<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_base.C</div>  </div>
</div>
<div class="contents">
<a href="rb__base_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="rb__base_8h.php">rb_base.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__system_8h.php">rb_eim_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__evaluation_8h.php">rb_eim_evaluation.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// For the solver switching stuff.</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="petsc__linear__solver_8h.php">petsc_linear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Includes for template instantiation</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="condensed__eigen__system_8h.php">condensed_eigen_system.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// RBBase implementation</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1RBBase.php#aafb80586fc29cea3954ac961a9c04c04">00045</a> <a class="code" href="classlibMesh_1_1RBBase.php#aafb80586fc29cea3954ac961a9c04c04">RBBase&lt;Base&gt;::RBBase</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00046"></a>00046                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00047"></a>00047                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00048"></a>00048   : Base(es, name, number),
<a name="l00049"></a>00049     training_parameters_initialized(false),
<a name="l00050"></a>00050     initialize_mesh_dependent_data(true),
<a name="l00051"></a>00051     training_parameters_random_seed(-1), <span class="comment">// by default, use std::time to seed RNG</span>
<a name="l00052"></a>00052     serial_training_set(false),
<a name="l00053"></a>00053     alternative_solver(<span class="stringliteral">&quot;unchanged&quot;</span>)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>.clear();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// Make sure we clear theta_q_a_vector so we can then push_back</span>
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1RBBase.php#a2faaa4c9e681878e30f1444313ba64b9">theta_q_a_vector</a>.clear();
<a name="l00059"></a>00059   
<a name="l00060"></a>00060   <span class="comment">// Make sure we clear A_EIM_systems_vector so we can then push_back</span>
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>.clear();
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   <span class="comment">// The rbOOmit code is still in a state of flux</span>
<a name="l00064"></a>00064   libmesh_experimental();
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00068"></a><a class="code" href="classlibMesh_1_1RBBase.php#a3f28bed53bf6c639ea70c8b059b22285">00068</a> <a class="code" href="classlibMesh_1_1RBBase.php#a3f28bed53bf6c639ea70c8b059b22285">RBBase&lt;Base&gt;::~RBBase</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   this-&gt;clear();
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00074"></a><a class="code" href="classlibMesh_1_1RBBase.php#ae9eea4c052b84a8038c348489ddcd1d9">00074</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#ae9eea4c052b84a8038c348489ddcd1d9">RBBase&lt;Base&gt;::clear</a> ()
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076   <span class="comment">// clear the parent data</span>
<a name="l00077"></a>00077   Base::clear();
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;training_parameters.size(); i++)
<a name="l00080"></a>00080   {
<a name="l00081"></a>00081     <span class="keywordflow">if</span>(training_parameters[i])
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083       <span class="keyword">delete</span> training_parameters[i];
<a name="l00084"></a>00084       training_parameters[i] = NULL;
<a name="l00085"></a>00085     }
<a name="l00086"></a>00086   }
<a name="l00087"></a>00087   training_parameters.resize(0);
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00091"></a><a class="code" href="classlibMesh_1_1RBBase.php#a22845ff428edfd2a0716aaecdb3788b7">00091</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a22845ff428edfd2a0716aaecdb3788b7">RBBase&lt;Base&gt;::init_data</a> ()
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="keywordflow">if</span>(initialize_mesh_dependent_data)
<a name="l00095"></a>00095   {
<a name="l00096"></a>00096     Base::init_data();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <span class="comment">// Initialize the inner product storage vector</span>
<a name="l00099"></a>00099     inner_product_storage_vector = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>();
<a name="l00100"></a>00100     inner_product_storage_vector-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00101"></a>00101   }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00106"></a><a class="code" href="classlibMesh_1_1RBBase.php#a4e6e0ae8de711c3b46b26c914a7c2507">00106</a> std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a4e6e0ae8de711c3b46b26c914a7c2507">RBBase&lt;Base&gt;::get_training_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword"></span>{
<a name="l00108"></a>00108   libmesh_assert(training_parameters_initialized);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   libmesh_assert( (this-&gt;get_first_local_training_index() &lt;= index) &amp;&amp;
<a name="l00111"></a>00111                   (index &lt; this-&gt;get_last_local_training_index()) );
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   std::vector&lt;Real&gt; parameter(this-&gt;get_n_params());
<a name="l00114"></a>00114   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;parameter.size(); i++)
<a name="l00115"></a>00115     parameter[i] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*training_parameters[i])(index));
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="keywordflow">return</span> parameter;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1RBBase.php#a0d982ba07d961cb438fa783bf17517e7">00121</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a0d982ba07d961cb438fa783bf17517e7">RBBase&lt;Base&gt;::load_training_parameter_locally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   set_current_parameters( get_training_parameter(index) );
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00127"></a><a class="code" href="classlibMesh_1_1RBBase.php#a54e4e9c609bcf66c7a95a0307e6b5a78">00127</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a54e4e9c609bcf66c7a95a0307e6b5a78">RBBase&lt;Base&gt;::load_training_parameter_globally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   libmesh_assert(training_parameters_initialized);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id = 0;
<a name="l00132"></a>00132   std::vector&lt;Real&gt; new_param(get_n_params());
<a name="l00133"></a>00133   <span class="keywordflow">if</span>( (this-&gt;get_first_local_training_index() &lt;= index) &amp;&amp;
<a name="l00134"></a>00134       (index &lt; this-&gt;get_last_local_training_index()) )
<a name="l00135"></a>00135   {
<a name="l00136"></a>00136     new_param = this-&gt;get_training_parameter(index);
<a name="l00137"></a>00137     root_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); <span class="comment">// Only non-zero on one processor</span>
<a name="l00138"></a>00138   }
<a name="l00139"></a>00139   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(root_id);
<a name="l00140"></a>00140   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(new_param, root_id);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   set_current_parameters(new_param);
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00146"></a><a class="code" href="classlibMesh_1_1RBBase.php#aab8ed17932e5a8eacaa00b093128d651">00146</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#aab8ed17932e5a8eacaa00b093128d651">RBBase&lt;Base&gt;::initialize_training_parameters</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_min_vector,
<a name="l00147"></a>00147                                                   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_max_vector,
<a name="l00148"></a>00148                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples,
<a name="l00149"></a>00149                                                   <span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00150"></a>00150                                                   <span class="keyword">const</span> <span class="keywordtype">bool</span> deterministic)
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   libmesh_assert( (mu_min_vector.size() == mu_max_vector.size()) );
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   this-&gt;mu_min_vector = mu_min_vector;
<a name="l00155"></a>00155   this-&gt;mu_max_vector = mu_max_vector;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="keywordflow">if</span>(deterministic)
<a name="l00158"></a>00158   {
<a name="l00159"></a>00159     generate_training_parameters_deterministic(log_param_scale,
<a name="l00160"></a>00160                                                training_parameters,
<a name="l00161"></a>00161                                                n_training_samples,
<a name="l00162"></a>00162                                                mu_min_vector,
<a name="l00163"></a>00163                                                mu_max_vector,
<a name="l00164"></a>00164                                                serial_training_set);
<a name="l00165"></a>00165   }
<a name="l00166"></a>00166   <span class="keywordflow">else</span>
<a name="l00167"></a>00167   {
<a name="l00168"></a>00168     generate_training_parameters_random(log_param_scale,
<a name="l00169"></a>00169                                         training_parameters,
<a name="l00170"></a>00170                                         n_training_samples,
<a name="l00171"></a>00171                                         mu_min_vector,
<a name="l00172"></a>00172                                         mu_max_vector,
<a name="l00173"></a>00173                                         this-&gt;training_parameters_random_seed,
<a name="l00174"></a>00174                                         serial_training_set);
<a name="l00175"></a>00175   }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   training_parameters_initialized = <span class="keyword">true</span>;
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00181"></a><a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">00181</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">RBBase&lt;Base&gt;::get_n_params</a>()<span class="keyword"> const</span>
<a name="l00182"></a>00182 <span class="keyword"></span>{
<a name="l00183"></a>00183   libmesh_assert( mu_min_vector.size() == mu_max_vector.size() );
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="keywordflow">return</span> mu_min_vector.size();
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00189"></a><a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">00189</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">RBBase&lt;Base&gt;::get_parameter_min</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00190"></a>00190 <span class="keyword"></span>{
<a name="l00191"></a>00191   libmesh_assert(i &lt; mu_min_vector.size());
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordflow">return</span> mu_min_vector[i];
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00197"></a><a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">00197</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">RBBase&lt;Base&gt;::get_parameter_max</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00198"></a>00198 <span class="keyword"></span>{
<a name="l00199"></a>00199   libmesh_assert(i &lt; mu_max_vector.size());
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">return</span> mu_max_vector[i];
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00205"></a><a class="code" href="classlibMesh_1_1RBBase.php#a0e95ad12b80cc5a4c766532f4e0edd31">00205</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1RBBase.php#a0e95ad12b80cc5a4c766532f4e0edd31">RBBase&lt;Base&gt;::get_n_A_EIM_systems</a>()<span class="keyword"> const</span>
<a name="l00206"></a>00206 <span class="keyword"></span>{
<a name="l00207"></a>00207   <span class="keywordflow">return</span> A_EIM_systems_vector.size();
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00211"></a><a class="code" href="classlibMesh_1_1RBBase.php#ad87fa52fb590ecb888c29d34a05b11f6">00211</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1RBBase.php#ad87fa52fb590ecb888c29d34a05b11f6">RBBase&lt;Base&gt;::get_n_A_EIM_operators</a>()<span class="keyword"> const</span>
<a name="l00212"></a>00212 <span class="keyword"></span>{
<a name="l00213"></a>00213   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l00214"></a>00214   
<a name="l00215"></a>00215   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;A_EIM_systems_vector.size(); i++)
<a name="l00216"></a>00216     count += A_EIM_systems_vector[i]-&gt;get_n_affine_functions();
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="keywordflow">return</span> count;
<a name="l00219"></a>00219 }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00222"></a><a class="code" href="classlibMesh_1_1RBBase.php#aece7757dc1e0c1adf4da8db835e6a3b6">00222</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#aece7757dc1e0c1adf4da8db835e6a3b6">RBBase&lt;Base&gt;::attach_theta_q_a</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_a)
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   libmesh_assert(theta_q_a != NULL);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   theta_q_a_vector.push_back(theta_q_a);
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00231"></a><a class="code" href="classlibMesh_1_1RBBase.php#ae4991b338eba5860addabff535f0c9e4">00231</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#ae4991b338eba5860addabff535f0c9e4">RBBase&lt;Base&gt;::attach_A_EIM_system</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system)
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   libmesh_assert(eim_system != NULL);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   A_EIM_systems_vector.push_back( eim_system );
<a name="l00236"></a>00236 }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00239"></a><a class="code" href="classlibMesh_1_1RBBase.php#afbb972fd9b138c16291b380796b5924b">00239</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#afbb972fd9b138c16291b380796b5924b">RBBase&lt;Base&gt;::is_A_EIM_operator</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00240"></a>00240 {
<a name="l00241"></a>00241   libmesh_assert(q &lt; get_Q_a());
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="keywordflow">return</span> (q &gt;= theta_q_a_vector.size());
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00247"></a><a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">00247</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">RBBase&lt;Base&gt;::set_current_parameters</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; params)
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249   libmesh_assert(training_parameters_initialized);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   libmesh_assert(params.size() == get_n_params());
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;params.size(); i++)
<a name="l00254"></a>00254     libmesh_assert( (mu_min_vector[i] &lt;= <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(params[i])) &amp;&amp;
<a name="l00255"></a>00255                     (<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(params[i]) &lt;= mu_max_vector[i]) );
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   current_parameters = params;
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00261"></a><a class="code" href="classlibMesh_1_1RBBase.php#a011a675808c24a57868f9c0237575870">00261</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a011a675808c24a57868f9c0237575870">RBBase&lt;Base&gt;::print_current_parameters</a>()
<a name="l00262"></a>00262 {
<a name="l00263"></a>00263   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;get_n_params(); j++)
<a name="l00264"></a>00264   {
<a name="l00265"></a>00265     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mu[&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;] = &quot;</span> &lt;&lt; current_parameters[j] &lt;&lt; std::endl;
<a name="l00266"></a>00266   }
<a name="l00267"></a>00267   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00271"></a><a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">00271</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">RBBase&lt;Base&gt;::eval_theta_q_a</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00272"></a>00272 {
<a name="l00273"></a>00273   <span class="keywordflow">if</span>(q &gt;= get_Q_a())
<a name="l00274"></a>00274   {
<a name="l00275"></a>00275     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_a in eval_theta_q_a.&quot;</span>
<a name="l00276"></a>00276                  &lt;&lt; std::endl;
<a name="l00277"></a>00277     libmesh_error();
<a name="l00278"></a>00278   }
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   <span class="keywordflow">if</span>(!is_A_EIM_operator(q))
<a name="l00281"></a>00281   {
<a name="l00282"></a>00282     <span class="keywordflow">return</span> theta_q_a_vector[q]-&gt;evaluate( get_current_parameters() );
<a name="l00283"></a>00283   }
<a name="l00284"></a>00284   <span class="keywordflow">else</span>
<a name="l00285"></a>00285   {
<a name="l00286"></a>00286     <span class="comment">// Find out the LHS EIM system index and the associated function index that corresponds to q</span>
<a name="l00287"></a>00287     std::pair&lt;unsigned int, unsigned int&gt; A_EIM_indices = get_A_EIM_indices(q);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289     <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; eim_system = *A_EIM_systems_vector[A_EIM_indices.first];
<a name="l00290"></a>00290     eim_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>(get_current_parameters());
<a name="l00291"></a>00291     
<a name="l00292"></a>00292     <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">RBEIMEvaluation</a>* eim_eval = libmesh_cast_ptr&lt;RBEIMEvaluation*&gt;(eim_system.<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l00293"></a>00293     eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">RB_solve</a>(eim_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>());
<a name="l00294"></a>00294 
<a name="l00295"></a>00295     <span class="keywordflow">return</span> eim_system.<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(A_EIM_indices.second);
<a name="l00296"></a>00296   }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00301"></a><a class="code" href="classlibMesh_1_1RBBase.php#a7719b794672b76909fdda3e8cf6b436e">00301</a> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a7719b794672b76909fdda3e8cf6b436e">RBBase&lt;Base&gt;::get_A_EIM_indices</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00302"></a>00302 {
<a name="l00303"></a>00303   <span class="comment">// Find out which EIM system q refers to</span>
<a name="l00304"></a>00304   <span class="keywordtype">int</span> function_index = q - theta_q_a_vector.size();
<a name="l00305"></a>00305   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> system_index = 0;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="keywordflow">if</span>( function_index != 0)
<a name="l00308"></a>00308   {
<a name="l00309"></a>00309     <span class="keywordflow">for</span>(system_index = 0; system_index&lt;A_EIM_systems_vector.size(); system_index++)
<a name="l00310"></a>00310     {
<a name="l00311"></a>00311       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> increment = A_EIM_systems_vector[system_index]-&gt;get_n_affine_functions();
<a name="l00312"></a>00312       <span class="keywordflow">if</span>( (static_cast&lt;int&gt;(function_index - increment)) &lt; 0)
<a name="l00313"></a>00313         <span class="keywordflow">break</span>;
<a name="l00314"></a>00314     
<a name="l00315"></a>00315       function_index -= increment;
<a name="l00316"></a>00316     }
<a name="l00317"></a>00317   }
<a name="l00318"></a>00318   
<a name="l00319"></a>00319   std::pair&lt;unsigned int, unsigned int&gt; EIM_indices(system_index, function_index);
<a name="l00320"></a>00320   <span class="keywordflow">return</span> EIM_indices;
<a name="l00321"></a>00321 }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00324"></a><a class="code" href="classlibMesh_1_1RBBase.php#a163dce33589ff76f959d42c2859a52e6">00324</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#a163dce33589ff76f959d42c2859a52e6">RBBase&lt;Base&gt;::valid_params</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; params)
<a name="l00325"></a>00325 {
<a name="l00326"></a>00326   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Quality.php#ac0d621e813e680024e89e202d5ba4901">valid</a> = (training_parameters_initialized &amp;&amp; (params.size() == get_n_params()));
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   <span class="keywordflow">if</span>(!valid)
<a name="l00329"></a>00329   {
<a name="l00330"></a>00330    <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332   <span class="keywordflow">else</span>
<a name="l00333"></a>00333   {
<a name="l00334"></a>00334     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;params.size(); i++)
<a name="l00335"></a>00335     {
<a name="l00336"></a>00336       valid = valid &amp;&amp; ( (mu_min_vector[i] &lt;= params[i]) &amp;&amp;
<a name="l00337"></a>00337                          (params[i] &lt;= mu_max_vector[i]) );
<a name="l00338"></a>00338     }
<a name="l00339"></a>00339   }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Quality.php#ac0d621e813e680024e89e202d5ba4901">valid</a>;
<a name="l00342"></a>00342 }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00345"></a><a class="code" href="classlibMesh_1_1RBBase.php#a1efd92f0f4a8d2c0e5cec5747dd933a4">00345</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a1efd92f0f4a8d2c0e5cec5747dd933a4">RBBase&lt;Base&gt;::broadcast_current_parameters</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00346"></a>00346 {
<a name="l00347"></a>00347   libmesh_assert(proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(current_parameters, proc_id);
<a name="l00350"></a>00350 }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00353"></a><a class="code" href="classlibMesh_1_1RBBase.php#a3f96fa0d87fd3f4bc00af8b403650cb3">00353</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a3f96fa0d87fd3f4bc00af8b403650cb3">RBBase&lt;Base&gt;::get_global_max_error_pair</a>(std::pair&lt;unsigned int, Real&gt;&amp; error_pair)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <span class="comment">// Set error_pair.second to the maximum global value and also</span>
<a name="l00356"></a>00356   <span class="comment">// find which processor contains the maximum value</span>
<a name="l00357"></a>00357   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_ID_index;
<a name="l00358"></a>00358   <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">Parallel::maxloc</a>(error_pair.second, proc_ID_index);
<a name="l00359"></a>00359   
<a name="l00360"></a>00360   <span class="comment">// Then broadcast error_pair.first from proc_ID_index</span>
<a name="l00361"></a>00361   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(error_pair.first, proc_ID_index);
<a name="l00362"></a>00362 }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00365"></a><a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">00365</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">RBBase&lt;Base&gt;::load_training_set</a>(std::vector&lt; std::vector&lt;Number&gt; &gt;&amp; new_training_set)
<a name="l00366"></a>00366 {
<a name="l00367"></a>00367   <span class="comment">// First, make sure that an initial training set has already been</span>
<a name="l00368"></a>00368   <span class="comment">// generated</span>
<a name="l00369"></a>00369   <span class="keywordflow">if</span>(!training_parameters_initialized)
<a name="l00370"></a>00370   {
<a name="l00371"></a>00371     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: load_training_set cannot be used to initialize parameters&quot;</span>
<a name="l00372"></a>00372                  &lt;&lt; std::endl;
<a name="l00373"></a>00373     libmesh_error();
<a name="l00374"></a>00374   }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <span class="comment">// Make sure that the training set has the correct number of parameters</span>
<a name="l00377"></a>00377   <span class="keywordflow">if</span>(new_training_set.size() != get_n_params())
<a name="l00378"></a>00378   {
<a name="l00379"></a>00379     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Incorrect number of parameters in load_training_set.&quot;</span>
<a name="l00380"></a>00380                  &lt;&lt; std::endl;
<a name="l00381"></a>00381     libmesh_error();
<a name="l00382"></a>00382   }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   <span class="comment">// Clear the training set</span>
<a name="l00385"></a>00385   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;training_parameters.size(); i++)
<a name="l00386"></a>00386   {
<a name="l00387"></a>00387     <span class="keywordflow">if</span>(training_parameters[i])
<a name="l00388"></a>00388     {
<a name="l00389"></a>00389       <span class="keyword">delete</span> training_parameters[i];
<a name="l00390"></a>00390       training_parameters[i] = NULL;
<a name="l00391"></a>00391     }
<a name="l00392"></a>00392   }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="comment">// Get the number of local and global training parameters</span>
<a name="l00395"></a>00395   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_training_samples  = new_training_set[0].size();
<a name="l00396"></a>00396   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_global_training_samples = n_local_training_samples;
<a name="l00397"></a>00397   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_global_training_samples);
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;get_n_params(); i++)
<a name="l00400"></a>00400   {
<a name="l00401"></a>00401     training_parameters[i] = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00402"></a>00402     training_parameters[i]-&gt;init(n_global_training_samples, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00403"></a>00403   }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;get_n_params(); j++)
<a name="l00406"></a>00406   {
<a name="l00407"></a>00407     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_index = training_parameters[j]-&gt;first_local_index();
<a name="l00408"></a>00408     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_local_training_samples; i++)
<a name="l00409"></a>00409     {
<a name="l00410"></a>00410       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = first_index + i;
<a name="l00411"></a>00411       training_parameters[j]-&gt;set(index, new_training_set[j][i]);
<a name="l00412"></a>00412     }
<a name="l00413"></a>00413   }
<a name="l00414"></a>00414 }
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00418"></a><a class="code" href="classlibMesh_1_1RBBase.php#a22c4ebd789154b075bfb09b148deea1e">00418</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a22c4ebd789154b075bfb09b148deea1e">RBBase&lt;Base&gt;::generate_training_parameters_random</a>(<span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00419"></a>00419                                                        std::vector&lt; <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;&amp; training_parameters_in,
<a name="l00420"></a>00420                                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_in,
<a name="l00421"></a>00421                                                        <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; min_parameters,
<a name="l00422"></a>00422                                                        <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; max_parameters,
<a name="l00423"></a>00423                                                        <span class="keywordtype">int</span> training_parameters_random_seed,
<a name="l00424"></a>00424                                                        <span class="keywordtype">bool</span> serial_training_set)
<a name="l00425"></a>00425 {
<a name="l00426"></a>00426   libmesh_assert( min_parameters.size() == max_parameters.size() );
<a name="l00427"></a>00427   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_params = min_parameters.size();
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="comment">// Clear training_parameters_in</span>
<a name="l00430"></a>00430   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;training_parameters_in.size(); i++)
<a name="l00431"></a>00431   {
<a name="l00432"></a>00432     <span class="keywordflow">if</span>(training_parameters_in[i])
<a name="l00433"></a>00433     {
<a name="l00434"></a>00434       <span class="keyword">delete</span> training_parameters_in[i];
<a name="l00435"></a>00435       training_parameters_in[i] = NULL;
<a name="l00436"></a>00436     }
<a name="l00437"></a>00437   }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="keywordflow">if</span> (num_params == 0)
<a name="l00440"></a>00440     <span class="keywordflow">return</span>;
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="keywordflow">if</span> (training_parameters_random_seed &lt; 0)
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444       
<a name="l00445"></a>00445       <span class="keywordflow">if</span>(!serial_training_set)
<a name="l00446"></a>00446       {
<a name="l00447"></a>00447         <span class="comment">// seed the random number generator with the system time</span>
<a name="l00448"></a>00448         <span class="comment">// and the processor ID so that the seed is different</span>
<a name="l00449"></a>00449         <span class="comment">// on different processors</span>
<a name="l00450"></a>00450         std::srand( static_cast&lt;unsigned&gt;( std::time(0)*(1+<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) ));
<a name="l00451"></a>00451       }
<a name="l00452"></a>00452       <span class="keywordflow">else</span>
<a name="l00453"></a>00453       {
<a name="l00454"></a>00454         <span class="comment">// seed the random number generator with the system time</span>
<a name="l00455"></a>00455         <span class="comment">// only so that the seed is the same on all processors</span>
<a name="l00456"></a>00456         std::srand( static_cast&lt;unsigned&gt;( std::time(0) ));
<a name="l00457"></a>00457       }
<a name="l00458"></a>00458     }
<a name="l00459"></a>00459   <span class="keywordflow">else</span>
<a name="l00460"></a>00460     {
<a name="l00461"></a>00461       <span class="keywordflow">if</span>(!serial_training_set)
<a name="l00462"></a>00462       {
<a name="l00463"></a>00463         <span class="comment">// seed the random number generator with the provided value</span>
<a name="l00464"></a>00464         <span class="comment">// and the processor ID so that the seed is different</span>
<a name="l00465"></a>00465         <span class="comment">// on different processors</span>
<a name="l00466"></a>00466         std::srand( static_cast&lt;unsigned&gt;( training_parameters_random_seed*(1+<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) ));
<a name="l00467"></a>00467       }
<a name="l00468"></a>00468       <span class="keywordflow">else</span>
<a name="l00469"></a>00469       {
<a name="l00470"></a>00470         <span class="comment">// seed the random number generator with the provided value</span>
<a name="l00471"></a>00471         <span class="comment">// so that the seed is the same on all processors</span>
<a name="l00472"></a>00472         std::srand( static_cast&lt;unsigned&gt;( training_parameters_random_seed ));
<a name="l00473"></a>00473       }
<a name="l00474"></a>00474     }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   
<a name="l00477"></a>00477   <span class="comment">// Initialize num_params NumericVectors</span>
<a name="l00478"></a>00478   training_parameters_in.resize(num_params);
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_params; i++)
<a name="l00481"></a>00481   {
<a name="l00482"></a>00482     training_parameters_in[i] = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00483"></a>00483     <span class="keywordflow">if</span>(!serial_training_set)
<a name="l00484"></a>00484     {
<a name="l00485"></a>00485       <span class="comment">// Calculate the number of training parameters local to this processor</span>
<a name="l00486"></a>00486       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_training_samples;
<a name="l00487"></a>00487       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> quotient  = n_training_samples_in/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00488"></a>00488       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> remainder = n_training_samples_in%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00489"></a>00489       <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt; remainder)
<a name="l00490"></a>00490         n_local_training_samples = (quotient + 1);
<a name="l00491"></a>00491       <span class="keywordflow">else</span>
<a name="l00492"></a>00492         n_local_training_samples = quotient;
<a name="l00493"></a>00493 
<a name="l00494"></a>00494       training_parameters_in[i]-&gt;init(n_training_samples_in, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00495"></a>00495     }
<a name="l00496"></a>00496     <span class="keywordflow">else</span>
<a name="l00497"></a>00497     {
<a name="l00498"></a>00498       training_parameters_in[i]-&gt;init(n_training_samples_in, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">libMeshEnums::SERIAL</a>);
<a name="l00499"></a>00499     }
<a name="l00500"></a>00500   }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;num_params; j++)
<a name="l00503"></a>00503   {
<a name="l00504"></a>00504     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_index = training_parameters_in[j]-&gt;first_local_index();
<a name="l00505"></a>00505     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;training_parameters_in[j]-&gt;local_size(); i++)
<a name="l00506"></a>00506     {
<a name="l00507"></a>00507       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = first_index + i;
<a name="l00508"></a>00508       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> random_number = ((double)std::rand())/RAND_MAX; <span class="comment">// in range [0,1]</span>
<a name="l00509"></a>00509 
<a name="l00510"></a>00510       <span class="comment">// Generate log10 scaled training parameters</span>
<a name="l00511"></a>00511       <span class="keywordflow">if</span>(log_param_scale[j])
<a name="l00512"></a>00512       {
<a name="l00513"></a>00513         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> log_min   = log10(min_parameters[j]);
<a name="l00514"></a>00514         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> log_range = log10(max_parameters[j] / min_parameters[j]);
<a name="l00515"></a>00515 
<a name="l00516"></a>00516         training_parameters_in[j]-&gt;set(index, <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(10., log_min + random_number*log_range ) );
<a name="l00517"></a>00517       }
<a name="l00518"></a>00518       <span class="comment">// Generate linearly scaled training parameters</span>
<a name="l00519"></a>00519       <span class="keywordflow">else</span>
<a name="l00520"></a>00520       {
<a name="l00521"></a>00521         training_parameters_in[j]-&gt;set(index, random_number*(max_parameters[j] - min_parameters[j])
<a name="l00522"></a>00522                                             + min_parameters[j]);
<a name="l00523"></a>00523       }
<a name="l00524"></a>00524     }
<a name="l00525"></a>00525   }
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00529"></a><a class="code" href="classlibMesh_1_1RBBase.php#acbaa8999c6d2296cd16b987a60b1b356">00529</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#acbaa8999c6d2296cd16b987a60b1b356">RBBase&lt;Base&gt;::generate_training_parameters_deterministic</a>(<span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00530"></a>00530                                                               std::vector&lt; <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;&amp; training_parameters_in,
<a name="l00531"></a>00531                                                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_in,
<a name="l00532"></a>00532                                                               <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; min_parameters,
<a name="l00533"></a>00533                                                               <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; max_parameters,
<a name="l00534"></a>00534                                                               <span class="keywordtype">bool</span> serial_training_set)
<a name="l00535"></a>00535 {
<a name="l00536"></a>00536   libmesh_assert( min_parameters.size() == max_parameters.size() );
<a name="l00537"></a>00537   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_params = min_parameters.size();
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (num_params == 0)
<a name="l00540"></a>00540     <span class="keywordflow">return</span>;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="keywordflow">if</span>(num_params &gt; 2)
<a name="l00543"></a>00543   {
<a name="l00544"></a>00544     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Deterministic training sample generation &quot;</span>
<a name="l00545"></a>00545                  &lt;&lt; <span class="stringliteral">&quot; not implemented for more than two parameters.&quot;</span> &lt;&lt; std::endl;
<a name="l00546"></a>00546     libmesh_not_implemented();
<a name="l00547"></a>00547   }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">// Clear training_parameters_in</span>
<a name="l00550"></a>00550   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;training_parameters_in.size(); i++)
<a name="l00551"></a>00551   {
<a name="l00552"></a>00552     <span class="keywordflow">if</span>(training_parameters_in[i])
<a name="l00553"></a>00553     {
<a name="l00554"></a>00554       <span class="keyword">delete</span> training_parameters_in[i];
<a name="l00555"></a>00555       training_parameters_in[i] = NULL;
<a name="l00556"></a>00556     }
<a name="l00557"></a>00557   }
<a name="l00558"></a>00558 
<a name="l00559"></a>00559   <span class="comment">// Initialize num_params NumericVectors</span>
<a name="l00560"></a>00560   training_parameters_in.resize(num_params);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_params; i++)
<a name="l00563"></a>00563   {
<a name="l00564"></a>00564     training_parameters_in[i] = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00565"></a>00565     <span class="keywordflow">if</span>(!serial_training_set)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567       <span class="comment">// Calculate the number of training parameters local to this processor</span>
<a name="l00568"></a>00568       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_training_samples;
<a name="l00569"></a>00569       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> quotient  = n_training_samples_in/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00570"></a>00570       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> remainder = n_training_samples_in%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00571"></a>00571       <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt; remainder)
<a name="l00572"></a>00572         n_local_training_samples = (quotient + 1);
<a name="l00573"></a>00573       <span class="keywordflow">else</span>
<a name="l00574"></a>00574         n_local_training_samples = quotient;
<a name="l00575"></a>00575 
<a name="l00576"></a>00576       training_parameters_in[i]-&gt;init(n_training_samples_in, n_local_training_samples, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00577"></a>00577     }
<a name="l00578"></a>00578     <span class="keywordflow">else</span>
<a name="l00579"></a>00579     {
<a name="l00580"></a>00580       training_parameters_in[i]-&gt;init(n_training_samples_in, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">libMeshEnums::SERIAL</a>);
<a name="l00581"></a>00581     }
<a name="l00582"></a>00582   }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   <span class="keywordflow">if</span>(num_params == 1)
<a name="l00586"></a>00586   {
<a name="l00587"></a>00587     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_index = training_parameters_in[0]-&gt;first_local_index();
<a name="l00588"></a>00588     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;training_parameters_in[0]-&gt;local_size(); i++)
<a name="l00589"></a>00589     {
<a name="l00590"></a>00590       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = first_index+i;
<a name="l00591"></a>00591       <span class="keywordflow">if</span>(log_param_scale[0])
<a name="l00592"></a>00592       {
<a name="l00593"></a>00593         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon = 1.e-6; <span class="comment">// Prevent rounding errors triggering asserts</span>
<a name="l00594"></a>00594         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> log_min   = log10(min_parameters[0] + epsilon);
<a name="l00595"></a>00595         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> log_range = log10( (max_parameters[0]-epsilon) / (min_parameters[0]+epsilon) );
<a name="l00596"></a>00596         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_size = log_range /
<a name="l00597"></a>00597           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)1,(n_training_samples_in-1));
<a name="l00598"></a>00598 
<a name="l00599"></a>00599         <span class="keywordflow">if</span>(index&lt;(n_training_samples_in-1))
<a name="l00600"></a>00600         {
<a name="l00601"></a>00601           training_parameters_in[0]-&gt;set(index, <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(10., log_min + index*step_size ));
<a name="l00602"></a>00602         }
<a name="l00603"></a>00603         <span class="keywordflow">else</span>
<a name="l00604"></a>00604         {
<a name="l00605"></a>00605           <span class="comment">// due to rounding error, the last parameter can be slightly</span>
<a name="l00606"></a>00606           <span class="comment">// bigger than max_parameters, hence snap back to the max</span>
<a name="l00607"></a>00607           training_parameters_in[0]-&gt;set(index, max_parameters[0]);
<a name="l00608"></a>00608         }
<a name="l00609"></a>00609       }
<a name="l00610"></a>00610       <span class="keywordflow">else</span>
<a name="l00611"></a>00611       {
<a name="l00612"></a>00612         <span class="comment">// Generate linearly scaled training parameters</span>
<a name="l00613"></a>00613         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_size = (max_parameters[0] - min_parameters[0]) /
<a name="l00614"></a>00614           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)1,(n_training_samples_in-1));
<a name="l00615"></a>00615         training_parameters_in[0]-&gt;set(index, index*step_size + min_parameters[0]);
<a name="l00616"></a>00616       }
<a name="l00617"></a>00617     }
<a name="l00618"></a>00618   }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   <span class="comment">// This is for two parameters</span>
<a name="l00622"></a>00622   <span class="keywordflow">if</span>(num_params == 2)
<a name="l00623"></a>00623   {
<a name="l00624"></a>00624     <span class="comment">// First make sure n_training_samples_in is a square number</span>
<a name="l00625"></a>00625     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_parameters_per_var = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>( std::sqrt(n_training_samples_in) );
<a name="l00626"></a>00626     <span class="keywordflow">if</span>( (n_training_parameters_per_var*n_training_parameters_per_var) != n_training_samples_in)
<a name="l00627"></a>00627     {
<a name="l00628"></a>00628       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Number of training parameters = &quot;</span> &lt;&lt; n_training_samples_in &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl
<a name="l00629"></a>00629                    &lt;&lt; <span class="stringliteral">&quot;Deterministic training set generation with two parameters requires &quot;</span> &lt;&lt; std::endl
<a name="l00630"></a>00630                    &lt;&lt; <span class="stringliteral">&quot;the number of training parameters to be a perfect square.&quot;</span> &lt;&lt; std::endl;
<a name="l00631"></a>00631       libmesh_error();
<a name="l00632"></a>00632     }
<a name="l00633"></a>00633 
<a name="l00634"></a>00634     <span class="comment">// make a matrix to store all the parameters, put them in vector form afterwards</span>
<a name="l00635"></a>00635     std::vector&lt; std::vector&lt;Real&gt; &gt; training_parameters_matrix(num_params);
<a name="l00636"></a>00636 
<a name="l00637"></a>00637     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_params; i++)
<a name="l00638"></a>00638     {
<a name="l00639"></a>00639       training_parameters_matrix[i].resize(n_training_parameters_per_var);
<a name="l00640"></a>00640 
<a name="l00641"></a>00641       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_training_parameters_per_var; j++)
<a name="l00642"></a>00642       {
<a name="l00643"></a>00643           <span class="comment">// Generate log10 scaled training parameters</span>
<a name="l00644"></a>00644           <span class="keywordflow">if</span>(log_param_scale[i])
<a name="l00645"></a>00645           {
<a name="l00646"></a>00646             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon = 1.e-6; <span class="comment">// Prevent rounding errors triggering asserts</span>
<a name="l00647"></a>00647             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> log_min   = log10(min_parameters[i] + epsilon);
<a name="l00648"></a>00648             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> log_range = log10( (max_parameters[i]-epsilon) / (min_parameters[i]+epsilon) );
<a name="l00649"></a>00649             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_size = log_range /
<a name="l00650"></a>00650               <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)1,(n_training_parameters_per_var-1));
<a name="l00651"></a>00651 
<a name="l00652"></a>00652             <span class="keywordflow">if</span>(j&lt;(n_training_parameters_per_var-1))
<a name="l00653"></a>00653             {
<a name="l00654"></a>00654               training_parameters_matrix[i][j] = <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(10., log_min + j*step_size );
<a name="l00655"></a>00655             }
<a name="l00656"></a>00656             <span class="keywordflow">else</span>
<a name="l00657"></a>00657             {
<a name="l00658"></a>00658               <span class="comment">// due to rounding error, the last parameter can be slightly</span>
<a name="l00659"></a>00659               <span class="comment">// bigger than max_parameters, hence snap back to the max</span>
<a name="l00660"></a>00660               training_parameters_matrix[i][j] = max_parameters[i];
<a name="l00661"></a>00661             }
<a name="l00662"></a>00662           }
<a name="l00663"></a>00663           <span class="keywordflow">else</span>
<a name="l00664"></a>00664           {
<a name="l00665"></a>00665             <span class="comment">// Generate linearly scaled training parameters</span>
<a name="l00666"></a>00666             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_size = (max_parameters[i] - min_parameters[i]) /
<a name="l00667"></a>00667               <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)1,(n_training_parameters_per_var-1));
<a name="l00668"></a>00668             training_parameters_matrix[i][j] = j*step_size + min_parameters[i];
<a name="l00669"></a>00669           }
<a name="l00670"></a>00670 
<a name="l00671"></a>00671       }
<a name="l00672"></a>00672     }
<a name="l00673"></a>00673 
<a name="l00674"></a>00674     <span class="comment">// now load into training_samples_in:</span>
<a name="l00675"></a>00675     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index1=0; index1&lt;n_training_parameters_per_var; index1++)
<a name="l00676"></a>00676     {
<a name="l00677"></a>00677       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index2=0; index2&lt;n_training_parameters_per_var; index2++)
<a name="l00678"></a>00678       {
<a name="l00679"></a>00679         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = index1*n_training_parameters_per_var + index2;
<a name="l00680"></a>00680 
<a name="l00681"></a>00681         <span class="keywordflow">if</span>( (training_parameters_in[0]-&gt;first_local_index() &lt;= index) &amp;&amp;
<a name="l00682"></a>00682             (index &lt; training_parameters_in[0]-&gt;last_local_index()) )
<a name="l00683"></a>00683         {
<a name="l00684"></a>00684           training_parameters_in[0]-&gt;set(index, training_parameters_matrix[0][index1]);
<a name="l00685"></a>00685           training_parameters_in[1]-&gt;set(index, training_parameters_matrix[1][index2]);
<a name="l00686"></a>00686         }
<a name="l00687"></a>00687       }
<a name="l00688"></a>00688     }
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 <span class="comment">//     libMesh::out &lt;&lt; &quot;n_training_samples = &quot; &lt;&lt; n_training_samples_in &lt;&lt; std::endl;</span>
<a name="l00691"></a>00691 <span class="comment">//     for(unsigned int index=0; index&lt;n_training_samples_in; index++)</span>
<a name="l00692"></a>00692 <span class="comment">//     {</span>
<a name="l00693"></a>00693 <span class="comment">//         libMesh::out &lt;&lt; &quot;training parameters for index=&quot;&lt;&lt;index&lt;&lt;&quot;:&quot;&lt;&lt;std::endl;</span>
<a name="l00694"></a>00694 <span class="comment">//         for(unsigned int param=0; param&lt;num_params; param++)</span>
<a name="l00695"></a>00695 <span class="comment">//         {</span>
<a name="l00696"></a>00696 <span class="comment">//           libMesh::out &lt;&lt; &quot; &quot; &lt;&lt; (*training_parameters_in[param])(index);</span>
<a name="l00697"></a>00697 <span class="comment">//         }</span>
<a name="l00698"></a>00698 <span class="comment">//         libMesh::out &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l00699"></a>00699 <span class="comment">//     }</span>
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   }
<a name="l00702"></a>00702 }
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00706"></a>00706 std::pair&lt;std::string,std::string&gt;
<a name="l00707"></a><a class="code" href="classlibMesh_1_1RBBase.php#a7fd20c081ea2d46f007c1454a553198a">00707</a> <a class="code" href="classlibMesh_1_1RBBase.php#a7fd20c081ea2d46f007c1454a553198a">RBBase&lt;Base&gt;::set_alternative_solver</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&lt;<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> &gt;&amp; ls)
<a name="l00708"></a>00708 {
<a name="l00709"></a>00709   <span class="comment">// It seems that setting it this generic way has no effect...</span>
<a name="l00710"></a>00710   <span class="comment">// PreconditionerType orig_pc = this-&gt;linear_solver-&gt;preconditioner_type();</span>
<a name="l00711"></a>00711   <span class="comment">// this-&gt;linear_solver-&gt;set_preconditioner_type(AMG_PRECOND);</span>
<a name="l00712"></a>00712   <span class="comment">// so we do it the &quot;hard&quot; way.</span>
<a name="l00713"></a>00713   std::string orig_petsc_pc_type_string, orig_petsc_ksp_type_string;
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00716"></a>00716 <span class="preprocessor"></span>  <span class="comment">// ... but we can set it the &quot;hard&quot; way</span>
<a name="l00717"></a>00717   <a class="code" href="classlibMesh_1_1PetscLinearSolver.php">PetscLinearSolver&lt;Number&gt;</a>* petsc_linear_solver =
<a name="l00718"></a>00718     libmesh_cast_ptr&lt;PetscLinearSolver&lt;Number&gt;*&gt;(ls.get());
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   <span class="comment">// Note: #define PCType char*, and PCGetType just sets a pointer.  We&#39;ll use</span>
<a name="l00721"></a>00721   <span class="comment">// the string below to make a real copy, and set the PC back to its original</span>
<a name="l00722"></a>00722   <span class="comment">// type at the end of the function.</span>
<a name="l00723"></a>00723 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00724"></a>00724 <span class="preprocessor"></span>  PCType orig_petsc_pc_type;
<a name="l00725"></a>00725   KSPType orig_petsc_ksp_type;
<a name="l00726"></a>00726 <span class="preprocessor">#else</span>
<a name="l00727"></a>00727 <span class="preprocessor"></span>  <span class="keyword">const</span> PCType orig_petsc_pc_type;
<a name="l00728"></a>00728   <span class="keyword">const</span> KSPType orig_petsc_ksp_type;
<a name="l00729"></a>00729 <span class="preprocessor">#endif</span>
<a name="l00730"></a>00730 <span class="preprocessor"></span>  <span class="keywordtype">int</span> ierr = 0;
<a name="l00731"></a>00731 
<a name="l00732"></a>00732   <span class="keywordflow">if</span> (petsc_linear_solver)
<a name="l00733"></a>00733     {
<a name="l00734"></a>00734       PC pc = petsc_linear_solver-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1aae14fe9e4e8e350918d1f954fd0444">pc</a>();
<a name="l00735"></a>00735       ierr = PCGetType(pc, &amp;orig_petsc_pc_type); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00736"></a>00736 
<a name="l00737"></a>00737       KSP ksp = petsc_linear_solver-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8f722acb8c35301ed1581726d4024d60">ksp</a>();
<a name="l00738"></a>00738       ierr = KSPGetType(ksp, &amp;orig_petsc_ksp_type); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00739"></a>00739       
<a name="l00740"></a>00740       <span class="comment">// libMesh::out &lt;&lt; &quot;orig_petsc_pc_type (before)=&quot; &lt;&lt; orig_petsc_pc_type &lt;&lt; std::endl;</span>
<a name="l00741"></a>00741       <span class="comment">// Make actual copies of the original PC and KSP types</span>
<a name="l00742"></a>00742       orig_petsc_pc_type_string = orig_petsc_pc_type;
<a name="l00743"></a>00743       orig_petsc_ksp_type_string = orig_petsc_ksp_type;
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC_HYPRE</span>
<a name="l00746"></a>00746 <span class="preprocessor"></span>      <span class="comment">// Set solver/PC combo specified in input file...</span>
<a name="l00747"></a>00747       <span class="keywordflow">if</span> (this-&gt;alternative_solver == <span class="stringliteral">&quot;amg&quot;</span>)
<a name="l00748"></a>00748         {
<a name="l00749"></a>00749           <span class="comment">// Set HYPRE and boomeramg PC types</span>
<a name="l00750"></a>00750           ierr = PCSetType(pc, PCHYPRE); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00751"></a>00751           ierr = PCHYPRESetType(pc, <span class="stringliteral">&quot;boomeramg&quot;</span>); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00752"></a>00752         }
<a name="l00753"></a>00753 <span class="preprocessor">#endif // LIBMESH_HAVE_PETSC_HYPRE</span>
<a name="l00754"></a>00754 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (this-&gt;alternative_solver == <span class="stringliteral">&quot;mumps&quot;</span>)
<a name="l00755"></a>00755         {
<a name="l00756"></a>00756           <span class="comment">// We&#39;ll use MUMPS... TODO: configure libmesh to detect</span>
<a name="l00757"></a>00757           <span class="comment">// when MUMPS is available via PETSc.</span>
<a name="l00758"></a>00758 
<a name="l00759"></a>00759           <span class="comment">// No initial guesses can be specified with KSPPREONLY.  We</span>
<a name="l00760"></a>00760           <span class="comment">// can leave the solver as gmres or whatever and it should</span>
<a name="l00761"></a>00761           <span class="comment">// converge in 1 iteration.  Otherwise, to use KSPPREONLY,</span>
<a name="l00762"></a>00762           <span class="comment">// you may need to do:</span>
<a name="l00763"></a>00763           <span class="comment">// KSPSetInitialGuessNonzero(ksp, PETSC_FALSE);</span>
<a name="l00764"></a>00764           <span class="comment">// ierr = KSPSetType(ksp, KSPPREONLY); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00765"></a>00765 
<a name="l00766"></a>00766           <span class="comment">// Need to call the equivalent for the command line options:</span>
<a name="l00767"></a>00767           <span class="comment">// -ksp_type preonly -pc_type lu -pc_factor_mat_solver_package mumps</span>
<a name="l00768"></a>00768           ierr = PCSetType(pc, PCLU); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00769"></a>00769 <span class="preprocessor">#if !(PETSC_VERSION_LESS_THAN(3,0,0))</span>
<a name="l00770"></a>00770 <span class="preprocessor"></span>          ierr = PCFactorSetMatSolverPackage(pc,<span class="stringliteral">&quot;mumps&quot;</span>); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00771"></a>00771 <span class="preprocessor">#endif</span>
<a name="l00772"></a>00772 <span class="preprocessor"></span>        }
<a name="l00773"></a>00773     }
<a name="l00774"></a>00774   <span class="keywordflow">else</span>
<a name="l00775"></a>00775     {
<a name="l00776"></a>00776       <span class="comment">// Otherwise, the cast failed and we are not using PETSc...</span>
<a name="l00777"></a>00777       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;You are not using PETSc, so don&#39;t know how to set AMG PC.&quot;</span> &lt;&lt; std::endl;
<a name="l00778"></a>00778       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Returning empty string!&quot;</span> &lt;&lt; std::endl;
<a name="l00779"></a>00779     }
<a name="l00780"></a>00780 <span class="preprocessor">#endif // LIBMESH_HAVE_PETSC</span>
<a name="l00781"></a>00781 <span class="preprocessor"></span>
<a name="l00782"></a>00782   <span class="keywordflow">return</span> std::make_pair(orig_petsc_pc_type_string, orig_petsc_ksp_type_string);
<a name="l00783"></a>00783 }
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00789"></a><a class="code" href="classlibMesh_1_1RBBase.php#a9f236decb17000238d3e1937bf547402">00789</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a9f236decb17000238d3e1937bf547402">RBBase&lt;Base&gt;::reset_alternative_solver</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&lt;<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> &gt;&amp; ls,
<a name="l00790"></a>00790                                             <span class="keyword">const</span> std::pair&lt;std::string,std::string&gt;&amp; orig)
<a name="l00791"></a>00791 {
<a name="l00792"></a>00792 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00793"></a>00793 <span class="preprocessor"></span>
<a name="l00794"></a>00794   <span class="comment">// If we never switched, we don&#39;t need to do anything...</span>
<a name="l00795"></a>00795   <span class="keywordflow">if</span> (this-&gt;alternative_solver != <span class="stringliteral">&quot;unchanged&quot;</span>)
<a name="l00796"></a>00796     {
<a name="l00797"></a>00797       <span class="comment">// this-&gt;linear_solver-&gt;set_preconditioner_type(orig_pc);</span>
<a name="l00798"></a>00798       <span class="comment">// Set PC back to its previous type</span>
<a name="l00799"></a>00799       <a class="code" href="classlibMesh_1_1PetscLinearSolver.php">PetscLinearSolver&lt;Number&gt;</a>* petsc_linear_solver =
<a name="l00800"></a>00800         libmesh_cast_ptr&lt;PetscLinearSolver&lt;Number&gt;*&gt;(ls.get());
<a name="l00801"></a>00801 
<a name="l00802"></a>00802       <span class="keywordtype">int</span> ierr = 0;
<a name="l00803"></a>00803       PC pc;
<a name="l00804"></a>00804       KSP ksp;
<a name="l00805"></a>00805 
<a name="l00806"></a>00806       <span class="keywordflow">if</span> (petsc_linear_solver)
<a name="l00807"></a>00807         {
<a name="l00808"></a>00808           pc = petsc_linear_solver-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1aae14fe9e4e8e350918d1f954fd0444">pc</a>();
<a name="l00809"></a>00809           ierr = PCSetType(pc, orig.first.c_str()); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00810"></a>00810 
<a name="l00811"></a>00811           ksp = petsc_linear_solver-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8f722acb8c35301ed1581726d4024d60">ksp</a>();
<a name="l00812"></a>00812           ierr = KSPSetType(ksp, orig.second.c_str()); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00813"></a>00813         }
<a name="l00814"></a>00814     }
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 <span class="preprocessor">#endif</span>
<a name="l00817"></a>00817 <span class="preprocessor"></span>}
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 <span class="comment">// Template specializations</span>
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 <span class="comment">// EigenSystem is only defined if we have SLEPc</span>
<a name="l00824"></a>00824 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00825"></a>00825 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBBase.php">RBBase&lt;CondensedEigenSystem&gt;</a>;
<a name="l00826"></a>00826 <span class="preprocessor">#endif</span>
<a name="l00827"></a>00827 <span class="preprocessor"></span>
<a name="l00828"></a>00828 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBBase.php">RBBase&lt;LinearImplicitSystem&gt;</a>;
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
