<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_base.h</div>  </div>
</div>
<div class="contents">
<a href="rb__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_base_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_base_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="rb__theta_8h.php">rb_theta.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// For the solver switching stuff.</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="perf__log_8h.php">perf_log.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00052"></a>00052 <span class="comment">// Forward declarations</span>
<a name="l00053"></a>00053 <span class="keyword">class </span>RBEIMSystem;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// RBBase class definition</span>
<a name="l00057"></a>00057 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Base&gt;
<a name="l00058"></a><a class="code" href="classlibMesh_1_1RBBase.php">00058</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBBase.php">RBBase</a> : <span class="keyword">public</span> Base
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1RBBase.php#aafb80586fc29cea3954ac961a9c04c04">RBBase</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00067"></a>00067           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00068"></a>00068           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBBase.php#a3f28bed53bf6c639ea70c8b059b22285">~RBBase</a> ();
<a name="l00074"></a>00074 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1RBBase.php#ae49803939573aa4da328f44954008f59">00078</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1RBBase.php#ae49803939573aa4da328f44954008f59">sys_type</a>;
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1RBBase.php#aa06d09d91257c28ee3a1064a79bf8e9f">00083</a>   <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1RBBase.php#aa06d09d91257c28ee3a1064a79bf8e9f">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00084"></a>00084 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#ae9eea4c052b84a8038c348489ddcd1d9">clear</a> ();
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1RBBase.php#a584ecef007a7992b6317db58f857e9e0">00094</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a584ecef007a7992b6317db58f857e9e0">get_n_training_samples</a>()<span class="keyword"> const</span>
<a name="l00095"></a>00095 <span class="keyword">    </span>{ libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>);
<a name="l00096"></a>00096        <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;size(); }
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1RBBase.php#a9695753c1fd434bccef96e258c6d1a40">00101</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a9695753c1fd434bccef96e258c6d1a40">get_local_n_training_samples</a>()<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword">    </span>{ libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>);
<a name="l00103"></a>00103       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;local_size(); }
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">00108</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a12552cd94e8487531fc5b7d7d461fb84">get_first_local_training_index</a>()<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword">    </span>{ libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>);
<a name="l00110"></a>00110       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;first_local_index(); }
<a name="l00111"></a>00111 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">00115</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#ab525b1169126b05cbbc6d0b435342eb3">get_last_local_training_index</a>()<span class="keyword"> const</span>
<a name="l00116"></a>00116 <span class="keyword">    </span>{ libmesh_assert(<a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>);
<a name="l00117"></a>00117       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[0]-&gt;last_local_index(); }
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a4e6e0ae8de711c3b46b26c914a7c2507">get_training_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a0d982ba07d961cb438fa783bf17517e7">load_training_parameter_locally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a54e4e9c609bcf66c7a95a0307e6b5a78">load_training_parameter_globally</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00135"></a>00135 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#aab8ed17932e5a8eacaa00b093128d651">initialize_training_parameters</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">mu_min_vector</a>,
<a name="l00142"></a>00142                                               <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">mu_max_vector</a>,
<a name="l00143"></a>00143                                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_parameters,
<a name="l00144"></a>00144                                               <span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00145"></a>00145                                               <span class="keyword">const</span> <span class="keywordtype">bool</span> deterministic=<span class="keyword">true</span>);
<a name="l00146"></a>00146 
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">load_training_set</a>(std::vector&lt; std::vector&lt;Number&gt; &gt;&amp; new_training_set);
<a name="l00151"></a>00151 
<a name="l00156"></a>00156   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>() <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00161"></a>00161   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00162"></a>00162   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">get_parameter_max</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00168"></a><a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">00168</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a2faaa4c9e681878e30f1444313ba64b9">theta_q_a_vector</a>.size() + <a class="code" href="classlibMesh_1_1RBBase.php#ad87fa52fb590ecb888c29d34a05b11f6">get_n_A_EIM_operators</a>(); }
<a name="l00169"></a>00169 
<a name="l00174"></a>00174   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#a0e95ad12b80cc5a4c766532f4e0edd31">get_n_A_EIM_systems</a>() <span class="keyword">const</span>;
<a name="l00175"></a>00175   
<a name="l00179"></a>00179   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#ad87fa52fb590ecb888c29d34a05b11f6">get_n_A_EIM_operators</a>() <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">00184</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBBase.php#a0d38b35c6ca90b64c8b4f63769d522e2">current_parameters</a>; };
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; params);
<a name="l00186"></a>00186 
<a name="l00190"></a>00190   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a011a675808c24a57868f9c0237575870">print_current_parameters</a>();
<a name="l00191"></a>00191 
<a name="l00196"></a>00196   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a1efd92f0f4a8d2c0e5cec5747dd933a4">broadcast_current_parameters</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00197"></a>00197 
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#aece7757dc1e0c1adf4da8db835e6a3b6">attach_theta_q_a</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_a);
<a name="l00205"></a>00205 
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#ae4991b338eba5860addabff535f0c9e4">attach_A_EIM_system</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system);
<a name="l00211"></a>00211   
<a name="l00216"></a>00216   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#afbb972fd9b138c16291b380796b5924b">is_A_EIM_operator</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00217"></a>00217 
<a name="l00223"></a>00223   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00224"></a>00224 
<a name="l00234"></a>00234   std::pair&lt;std::string,std::string&gt;
<a name="l00235"></a>00235   <a class="code" href="classlibMesh_1_1RBBase.php#a7fd20c081ea2d46f007c1454a553198a">set_alternative_solver</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&lt;<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> &gt;&amp; ls);
<a name="l00236"></a>00236 
<a name="l00243"></a>00243   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a9f236decb17000238d3e1937bf547402">reset_alternative_solver</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&lt;<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> &gt;&amp; ls,
<a name="l00244"></a>00244                                 <span class="keyword">const</span> std::pair&lt;std::string,std::string&gt;&amp; orig);
<a name="l00245"></a>00245   
<a name="l00246"></a>00246   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00247"></a>00247 
<a name="l00252"></a><a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">00252</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#acd3759e618b59d145fbc4d8668aa2564">training_parameters_initialized</a>;
<a name="l00253"></a>00253 
<a name="l00259"></a><a class="code" href="classlibMesh_1_1RBBase.php#abcbe187444a693974ccbf300517aaba1">00259</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#abcbe187444a693974ccbf300517aaba1">initialize_mesh_dependent_data</a>;
<a name="l00260"></a>00260 
<a name="l00264"></a><a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">00264</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>;
<a name="l00265"></a>00265 
<a name="l00272"></a><a class="code" href="classlibMesh_1_1RBBase.php#aa2f4297e83e21e49a5cc7dc2ad2bda44">00272</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#aa2f4297e83e21e49a5cc7dc2ad2bda44">training_parameters_random_seed</a>;
<a name="l00273"></a>00273   
<a name="l00274"></a>00274 <span class="keyword">protected</span>:
<a name="l00275"></a>00275 
<a name="l00280"></a>00280   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a22845ff428edfd2a0716aaecdb3788b7">init_data</a> ();
<a name="l00281"></a>00281 
<a name="l00287"></a>00287   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a3f96fa0d87fd3f4bc00af8b403650cb3">get_global_max_error_pair</a>(std::pair&lt;unsigned int, Real&gt;&amp; error_pair);
<a name="l00288"></a>00288 
<a name="l00292"></a>00292   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#a163dce33589ff76f959d42c2859a52e6">valid_params</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; params);
<a name="l00293"></a>00293 
<a name="l00297"></a>00297   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#a22c4ebd789154b075bfb09b148deea1e">generate_training_parameters_random</a>(<span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00298"></a>00298                                                   std::vector&lt; <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;&amp; training_parameters_in,
<a name="l00299"></a>00299                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_in,
<a name="l00300"></a>00300                                                   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; min_parameters,
<a name="l00301"></a>00301                                                   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; max_parameters,
<a name="l00302"></a>00302                                                   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBBase.php#aa2f4297e83e21e49a5cc7dc2ad2bda44">training_parameters_random_seed</a>=-1,
<a name="l00303"></a>00303                                                   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#a74dbe751421fdf4cc63fba5498fbc5c5">serial_training_set</a>=<span class="keyword">false</span>);
<a name="l00304"></a>00304 
<a name="l00309"></a>00309   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBBase.php#acbaa8999c6d2296cd16b987a60b1b356">generate_training_parameters_deterministic</a>(<span class="keyword">const</span> std::vector&lt;bool&gt; log_param_scale,
<a name="l00310"></a>00310                                                          std::vector&lt; <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;&amp; training_parameters_in,
<a name="l00311"></a>00311                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_training_samples_in,
<a name="l00312"></a>00312                                                          <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; min_parameters,
<a name="l00313"></a>00313                                                          <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; max_parameters,
<a name="l00314"></a>00314                                                          <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#a74dbe751421fdf4cc63fba5498fbc5c5">serial_training_set</a>=<span class="keyword">false</span>);
<a name="l00315"></a>00315 
<a name="l00320"></a>00320   std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a7719b794672b76909fdda3e8cf6b436e">get_A_EIM_indices</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00324"></a>00324   
<a name="l00331"></a><a class="code" href="classlibMesh_1_1RBBase.php#a74dbe751421fdf4cc63fba5498fbc5c5">00331</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBBase.php#a74dbe751421fdf4cc63fba5498fbc5c5">serial_training_set</a>;
<a name="l00332"></a>00332 
<a name="l00338"></a><a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">00338</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>;
<a name="l00339"></a>00339 
<a name="l00343"></a><a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">00343</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#aa54633a8a1d87dc76bbce3cec5e80421">mu_min_vector</a>;
<a name="l00344"></a><a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">00344</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a908713cda5467ba29a8141ee97d3a49d">mu_max_vector</a>;
<a name="l00345"></a>00345 
<a name="l00349"></a><a class="code" href="classlibMesh_1_1RBBase.php#a0d38b35c6ca90b64c8b4f63769d522e2">00349</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a0d38b35c6ca90b64c8b4f63769d522e2">current_parameters</a>;
<a name="l00350"></a>00350 
<a name="l00363"></a><a class="code" href="classlibMesh_1_1RBBase.php#a6391dc702582601a0ff44b8742ee7b1c">00363</a>   std::string <a class="code" href="classlibMesh_1_1RBBase.php#a6391dc702582601a0ff44b8742ee7b1c">alternative_solver</a>;
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="comment">//  /**</span>
<a name="l00366"></a>00366 <span class="comment">//   * Vector storing the function pointers to the theta_q.</span>
<a name="l00367"></a>00367 <span class="comment">//   */</span>
<a name="l00368"></a>00368 <span class="comment">//  std::vector&lt;theta_q_fptr&gt; theta_q_a_vector;</span>
<a name="l00372"></a><a class="code" href="classlibMesh_1_1RBBase.php#a2faaa4c9e681878e30f1444313ba64b9">00372</a> <span class="comment"></span>  std::vector&lt;RBTheta*&gt; <a class="code" href="classlibMesh_1_1RBBase.php#a2faaa4c9e681878e30f1444313ba64b9">theta_q_a_vector</a>;
<a name="l00373"></a>00373   
<a name="l00378"></a><a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">00378</a>   std::vector&lt; RBEIMSystem* &gt; <a class="code" href="classlibMesh_1_1RBBase.php#a6d45c615a2c06e710550570eb613f57f">A_EIM_systems_vector</a>;
<a name="l00379"></a>00379   
<a name="l00380"></a>00380 <span class="keyword">private</span>:
<a name="l00381"></a>00381 
<a name="l00386"></a><a class="code" href="classlibMesh_1_1RBBase.php#a8518918a83477d4cc9162cc85adeb39f">00386</a>   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1PerfLog.php">PerfLog</a> <a class="code" href="classlibMesh_1_1RBBase.php#a8518918a83477d4cc9162cc85adeb39f">pl</a>;
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 };
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 } <span class="comment">// namespace libMesh</span>
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
