<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_eim_evaluation.C</div>  </div>
</div>
<div class="contents">
<a href="rb__eim__evaluation_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__evaluation_8h.php">rb_eim_evaluation.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__system_8h.php">rb_eim_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a5ad2188c8c1f6b7f9ed86c368c79fb86">00027</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a5ad2188c8c1f6b7f9ed86c368c79fb86">RBEIMEvaluation::RBEIMEvaluation</a>(<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_sys)
<a name="l00028"></a>00028   :
<a name="l00029"></a>00029   <a class="code" href="classlibMesh_1_1RBEvaluation.php">Parent</a>(rb_sys)
<a name="l00030"></a>00030 {}
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#ae56da8fabb06dff6fb9b3d5b45a09fa0">00033</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#ae56da8fabb06dff6fb9b3d5b45a09fa0">RBEIMEvaluation::clear</a>()
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">Parent::clear</a>();
<a name="l00036"></a>00036   
<a name="l00037"></a>00037   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>.clear();
<a name="l00038"></a>00038   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>.clear();
<a name="l00039"></a>00039 }
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a55917f0b688d43cc55e06e5dc6a9cce2">00041</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a55917f0b688d43cc55e06e5dc6a9cce2">RBEIMEvaluation::initialize</a>()
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a1522bd9902fa9e97b9236532cd09bef8">Parent::initialize</a>();
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>();
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">// Resize the data structures relevant to the EIM system</span>
<a name="l00048"></a>00048   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>.clear();
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>.clear();
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(Nmax,Nmax);
<a name="l00051"></a>00051   
<a name="l00052"></a>00052   <span class="comment">// Resize the &quot;extra&quot; row due to the &quot;extra Greedy step&quot;</span>
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">extra_interpolation_matrix_row</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(Nmax);
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">00056</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">RBEIMEvaluation::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00061"></a>00061   {
<a name="l00062"></a>00062     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00063"></a>00063                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00064"></a>00064     libmesh_error();
<a name="l00065"></a>00065   }
<a name="l00066"></a>00066   <span class="keywordflow">if</span>(N==0)
<a name="l00067"></a>00067   {
<a name="l00068"></a>00068     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00069"></a>00069     libmesh_error();
<a name="l00070"></a>00070   }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; eim_sys = libmesh_cast_ref&lt;RBEIMSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="comment">// Get the rhs by sampling parametrized_function</span>
<a name="l00075"></a>00075   <span class="comment">// at the first N interpolation_points</span>
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> EIM_rhs(N);
<a name="l00077"></a>00077   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00078"></a>00078   {
<a name="l00079"></a>00079     EIM_rhs(i) = eim_sys.<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>[i], <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[i]);
<a name="l00080"></a>00080   }
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> interpolation_matrix_N;
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N, interpolation_matrix_N);
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   interpolation_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(EIM_rhs, <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_estimate = -1.;
<a name="l00090"></a>00090   <span class="keywordflow">if</span>(eim_sys.<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a>)
<a name="l00091"></a>00091   {
<a name="l00092"></a>00092     <span class="comment">// Compute the a posteriori error bound</span>
<a name="l00093"></a>00093     <span class="comment">// First, sample the parametrized function at x_{N+1}</span>
<a name="l00094"></a>00094     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> g_at_next_x;
<a name="l00095"></a>00095     <span class="keywordflow">if</span>(N == <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00096"></a>00096       g_at_next_x = eim_sys.<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a2da18c3cb162037409c72dd74b25d05f">extra_interpolation_point_var</a>, <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a>);
<a name="l00097"></a>00097     <span class="keywordflow">else</span>
<a name="l00098"></a>00098       g_at_next_x = eim_sys.<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>[N], <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[N]);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="comment">// Next, evaluate the EIM approximation at x_{N+1}</span>
<a name="l00101"></a>00101     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> EIM_approx_at_next_x = 0.;
<a name="l00102"></a>00102     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00103"></a>00103       <span class="keywordflow">if</span>(N == <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00104"></a>00104         EIM_approx_at_next_x += <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(j) * <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">extra_interpolation_matrix_row</a>(j);
<a name="l00105"></a>00105       <span class="keywordflow">else</span>
<a name="l00106"></a>00106         EIM_approx_at_next_x += <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(j) * <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>(N,j);
<a name="l00107"></a>00107       
<a name="l00108"></a>00108     error_estimate = std::abs(g_at_next_x - EIM_approx_at_next_x);
<a name="l00109"></a>00109   }
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="keywordflow">return</span> error_estimate;
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#adee5aeb23eb5ee1d4514ed099576693e">00116</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">RBEIMEvaluation::RB_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; EIM_rhs)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   <span class="keywordflow">if</span>(EIM_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00121"></a>00121   {
<a name="l00122"></a>00122     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00123"></a>00123                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00124"></a>00124     libmesh_error();
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126   <span class="keywordflow">if</span>(EIM_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()==0)
<a name="l00127"></a>00127   {
<a name="l00128"></a>00128     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N must be greater than 0 in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00129"></a>00129     libmesh_error();
<a name="l00130"></a>00130   }
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N = EIM_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> interpolation_matrix_N;
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N, interpolation_matrix_N);
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   interpolation_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(EIM_rhs, <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00137"></a>00137   
<a name="l00138"></a>00138   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#ae3068e60a02dc19a9347a44c54ff948b">00141</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#ae3068e60a02dc19a9347a44c54ff948b">RBEIMEvaluation::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00142"></a>00142 {
<a name="l00143"></a>00143   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a00e6ee9a21d2c3a4f3db3efb44582dce">Parent::write_offline_data_to_files</a>(directory_name);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00148"></a>00148   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() );
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00153"></a>00153   {
<a name="l00154"></a>00154     <span class="comment">// Next write out the interpolation_matrix</span>
<a name="l00155"></a>00155     std::ofstream interpolation_matrix_out;
<a name="l00156"></a>00156     {
<a name="l00157"></a>00157       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00158"></a>00158       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_matrix.dat&quot;</span>;
<a name="l00159"></a>00159       interpolation_matrix_out.open(file_name.str().c_str());
<a name="l00160"></a>00160     }
<a name="l00161"></a>00161     <span class="keywordflow">if</span> ( !interpolation_matrix_out.good() )
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00164"></a>00164       libmesh_error();
<a name="l00165"></a>00165     }
<a name="l00166"></a>00166     interpolation_matrix_out.precision(precision_level);
<a name="l00167"></a>00167     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00168"></a>00168     {
<a name="l00169"></a>00169       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l00170"></a>00170       {
<a name="l00171"></a>00171         interpolation_matrix_out &lt;&lt; std::scientific
<a name="l00172"></a>00172           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00173"></a>00173       }
<a name="l00174"></a>00174     }
<a name="l00175"></a>00175     
<a name="l00176"></a>00176     <span class="comment">// Also, write out the &quot;extra&quot; row</span>
<a name="l00177"></a>00177     std::ofstream extra_interpolation_matrix_row_out;
<a name="l00178"></a>00178     {
<a name="l00179"></a>00179       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00180"></a>00180       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_matrix_row.dat&quot;</span>;
<a name="l00181"></a>00181       extra_interpolation_matrix_row_out.open(file_name.str().c_str());
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183     <span class="keywordflow">if</span> ( !extra_interpolation_matrix_row_out.good() )
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_matrix_row.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00186"></a>00186       libmesh_error();
<a name="l00187"></a>00187     }
<a name="l00188"></a>00188     extra_interpolation_matrix_row_out.precision(precision_level);
<a name="l00189"></a>00189     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00190"></a>00190       extra_interpolation_matrix_row_out &lt;&lt; std::scientific
<a name="l00191"></a>00191           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">extra_interpolation_matrix_row</a>(j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00192"></a>00192     extra_interpolation_matrix_row_out.close();
<a name="l00193"></a>00193     
<a name="l00194"></a>00194     <span class="comment">// Next write out interpolation_points</span>
<a name="l00195"></a>00195     std::ofstream interpolation_points_out;
<a name="l00196"></a>00196     {
<a name="l00197"></a>00197       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00198"></a>00198       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points.dat&quot;</span>;
<a name="l00199"></a>00199       interpolation_points_out.open(file_name.str().c_str());
<a name="l00200"></a>00200     }
<a name="l00201"></a>00201     <span class="keywordflow">if</span> ( !interpolation_points_out.good() )
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00204"></a>00204       libmesh_error();
<a name="l00205"></a>00205     }
<a name="l00206"></a>00206     interpolation_points_out.precision(precision_level);
<a name="l00207"></a>00207     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00208"></a>00208       interpolation_points_out &lt;&lt; std::scientific
<a name="l00209"></a>00209           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[i](0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00210"></a>00210           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[i](1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00211"></a>00211           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[i](2) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     <span class="comment">// Also, write out the &quot;extra&quot; interpolation point</span>
<a name="l00214"></a>00214     std::ofstream extra_interpolation_point_out;
<a name="l00215"></a>00215     {
<a name="l00216"></a>00216       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00217"></a>00217       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point.dat&quot;</span>;
<a name="l00218"></a>00218       extra_interpolation_point_out.open(file_name.str().c_str());
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220     <span class="keywordflow">if</span> ( !extra_interpolation_point_out.good() )
<a name="l00221"></a>00221     {
<a name="l00222"></a>00222       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00223"></a>00223       libmesh_error();
<a name="l00224"></a>00224     }
<a name="l00225"></a>00225     extra_interpolation_point_out.precision(precision_level);
<a name="l00226"></a>00226     extra_interpolation_point_out &lt;&lt; std::scientific
<a name="l00227"></a>00227           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a>(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00228"></a>00228           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a>(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00229"></a>00229           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a>(2) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00230"></a>00230     extra_interpolation_point_out.close();
<a name="l00231"></a>00231     
<a name="l00232"></a>00232     <span class="comment">// Next write out interpolation_points_var</span>
<a name="l00233"></a>00233     std::ofstream interpolation_points_var_out;
<a name="l00234"></a>00234     {
<a name="l00235"></a>00235       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00236"></a>00236       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points_var.dat&quot;</span>;
<a name="l00237"></a>00237       interpolation_points_var_out.open(file_name.str().c_str());
<a name="l00238"></a>00238     }
<a name="l00239"></a>00239     <span class="keywordflow">if</span> ( !interpolation_points_var_out.good() )
<a name="l00240"></a>00240     {
<a name="l00241"></a>00241       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00242"></a>00242       libmesh_error();
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244     interpolation_points_var_out.precision(precision_level);
<a name="l00245"></a>00245     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00246"></a>00246       interpolation_points_var_out &lt;&lt; std::scientific
<a name="l00247"></a>00247           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249     <span class="comment">// Also, write out the &quot;extra&quot; interpolation variable</span>
<a name="l00250"></a>00250     std::ofstream extra_interpolation_point_var_out;
<a name="l00251"></a>00251     {
<a name="l00252"></a>00252       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00253"></a>00253       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point_var.dat&quot;</span>;
<a name="l00254"></a>00254       extra_interpolation_point_var_out.open(file_name.str().c_str());
<a name="l00255"></a>00255     }
<a name="l00256"></a>00256     <span class="keywordflow">if</span> ( !extra_interpolation_point_var_out.good() )
<a name="l00257"></a>00257     {
<a name="l00258"></a>00258       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00259"></a>00259       libmesh_error();
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261     extra_interpolation_point_var_out.precision(precision_level);
<a name="l00262"></a>00262     extra_interpolation_point_var_out &lt;&lt; std::scientific
<a name="l00263"></a>00263           &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a2da18c3cb162037409c72dd74b25d05f">extra_interpolation_point_var</a> &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00264"></a>00264     extra_interpolation_point_var_out.close();
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#abe078aa80850424a0d6dbb33024d9aab">00270</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#abe078aa80850424a0d6dbb33024d9aab">RBEIMEvaluation::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00271"></a>00271 {
<a name="l00272"></a>00272   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <a class="code" href="classlibMesh_1_1RBEvaluation.php#acfef418793d03a546a2b679f96e17f3f">Parent::read_offline_data_from_files</a>(directory_name);
<a name="l00275"></a>00275   
<a name="l00276"></a>00276   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l00277"></a>00277   <span class="comment">// This was set in RBSystem::read_offline_data_from_files</span>
<a name="l00278"></a>00278   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   <span class="comment">// Read in the interpolation matrix</span>
<a name="l00281"></a>00281   std::ifstream interpolation_matrix_in;
<a name="l00282"></a>00282   {
<a name="l00283"></a>00283     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00284"></a>00284     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_matrix.dat&quot;</span>;
<a name="l00285"></a>00285     interpolation_matrix_in.open(file_name.str().c_str());
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287   <span class="keywordflow">if</span> ( !interpolation_matrix_in.good() )
<a name="l00288"></a>00288   {
<a name="l00289"></a>00289     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00290"></a>00290     libmesh_error();
<a name="l00291"></a>00291   }
<a name="l00292"></a>00292   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00293"></a>00293   {
<a name="l00294"></a>00294     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l00295"></a>00295     {
<a name="l00296"></a>00296       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00297"></a>00297       interpolation_matrix_in &gt;&gt; value;
<a name="l00298"></a>00298       <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>(i,j) = value;
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300   }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// Also, read in the &quot;extra&quot; row</span>
<a name="l00303"></a>00303   std::ifstream extra_interpolation_matrix_row_in;
<a name="l00304"></a>00304   {
<a name="l00305"></a>00305     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00306"></a>00306     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_matrix_row.dat&quot;</span>;
<a name="l00307"></a>00307     extra_interpolation_matrix_row_in.open(file_name.str().c_str());
<a name="l00308"></a>00308   }
<a name="l00309"></a>00309   <span class="keywordflow">if</span> ( !extra_interpolation_matrix_row_in.good() )
<a name="l00310"></a>00310   {
<a name="l00311"></a>00311     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_matrix_row.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00312"></a>00312     libmesh_error();
<a name="l00313"></a>00313   }
<a name="l00314"></a>00314   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00315"></a>00315   {
<a name="l00316"></a>00316     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00317"></a>00317     extra_interpolation_matrix_row_in &gt;&gt; value;
<a name="l00318"></a>00318     <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">extra_interpolation_matrix_row</a>(j) = value;
<a name="l00319"></a>00319   }
<a name="l00320"></a>00320   extra_interpolation_matrix_row_in.close();
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Next read in interpolation_points</span>
<a name="l00323"></a>00323   std::ifstream interpolation_points_in;
<a name="l00324"></a>00324   {
<a name="l00325"></a>00325     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00326"></a>00326     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points.dat&quot;</span>;
<a name="l00327"></a>00327     interpolation_points_in.open(file_name.str().c_str());
<a name="l00328"></a>00328   }
<a name="l00329"></a>00329   <span class="keywordflow">if</span> ( !interpolation_points_in.good() )
<a name="l00330"></a>00330   {
<a name="l00331"></a>00331     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00332"></a>00332     libmesh_error();
<a name="l00333"></a>00333   }
<a name="l00334"></a>00334   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00335"></a>00335   {
<a name="l00336"></a>00336     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x_val, y_val, z_val;
<a name="l00337"></a>00337     interpolation_points_in &gt;&gt; x_val;
<a name="l00338"></a>00338     interpolation_points_in &gt;&gt; y_val;
<a name="l00339"></a>00339     interpolation_points_in &gt;&gt; z_val;
<a name="l00340"></a>00340     <a class="code" href="classlibMesh_1_1Point.php">Point</a> p(x_val, y_val, z_val);
<a name="l00341"></a>00341     <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>.push_back(p);
<a name="l00342"></a>00342   }
<a name="l00343"></a>00343   interpolation_points_in.close();
<a name="l00344"></a>00344   
<a name="l00345"></a>00345   <span class="comment">// Also, read in the extra interpolation point</span>
<a name="l00346"></a>00346   std::ifstream extra_interpolation_point_in;
<a name="l00347"></a>00347   {
<a name="l00348"></a>00348     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00349"></a>00349     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point.dat&quot;</span>;
<a name="l00350"></a>00350     extra_interpolation_point_in.open(file_name.str().c_str());
<a name="l00351"></a>00351   }
<a name="l00352"></a>00352   <span class="keywordflow">if</span> ( !extra_interpolation_point_in.good() )
<a name="l00353"></a>00353   {
<a name="l00354"></a>00354     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00355"></a>00355     libmesh_error();
<a name="l00356"></a>00356   }
<a name="l00357"></a>00357   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00358"></a>00358   {
<a name="l00359"></a>00359     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x_val, y_val, z_val;
<a name="l00360"></a>00360     extra_interpolation_point_in &gt;&gt; x_val;
<a name="l00361"></a>00361     extra_interpolation_point_in &gt;&gt; y_val;
<a name="l00362"></a>00362     extra_interpolation_point_in &gt;&gt; z_val;
<a name="l00363"></a>00363     <a class="code" href="classlibMesh_1_1Point.php">Point</a> p(x_val, y_val, z_val);
<a name="l00364"></a>00364     <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a> = p;
<a name="l00365"></a>00365   }
<a name="l00366"></a>00366   extra_interpolation_point_in.close();
<a name="l00367"></a>00367   
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Next read in interpolation_points_var</span>
<a name="l00370"></a>00370   std::ifstream interpolation_points_var_in;
<a name="l00371"></a>00371   {
<a name="l00372"></a>00372     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00373"></a>00373     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/interpolation_points_var.dat&quot;</span>;
<a name="l00374"></a>00374     interpolation_points_var_in.open(file_name.str().c_str());
<a name="l00375"></a>00375   }
<a name="l00376"></a>00376   <span class="keywordflow">if</span> ( !interpolation_points_var_in.good() )
<a name="l00377"></a>00377   {
<a name="l00378"></a>00378     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening interpolation_points_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00379"></a>00379     libmesh_error();
<a name="l00380"></a>00380   }
<a name="l00381"></a>00381   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=n_bfs; i++)
<a name="l00382"></a>00382   {
<a name="l00383"></a>00383     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var;
<a name="l00384"></a>00384     interpolation_points_var_in &gt;&gt; var;
<a name="l00385"></a>00385     <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>.push_back(var);
<a name="l00386"></a>00386   }
<a name="l00387"></a>00387   interpolation_points_var_in.close();
<a name="l00388"></a>00388   
<a name="l00389"></a>00389   <span class="comment">// Also, read in extra_interpolation_point_var</span>
<a name="l00390"></a>00390   std::ifstream extra_interpolation_point_var_in;
<a name="l00391"></a>00391   {
<a name="l00392"></a>00392     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00393"></a>00393     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/extra_interpolation_point_var.dat&quot;</span>;
<a name="l00394"></a>00394     extra_interpolation_point_var_in.open(file_name.str().c_str());
<a name="l00395"></a>00395   }
<a name="l00396"></a>00396   <span class="keywordflow">if</span> ( !extra_interpolation_point_var_in.good() )
<a name="l00397"></a>00397   {
<a name="l00398"></a>00398     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening extra_interpolation_point_var.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00399"></a>00399     libmesh_error();
<a name="l00400"></a>00400   }
<a name="l00401"></a>00401   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=n_bfs; i++)
<a name="l00402"></a>00402   {
<a name="l00403"></a>00403     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var;
<a name="l00404"></a>00404     extra_interpolation_point_var_in &gt;&gt; var;
<a name="l00405"></a>00405     <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a2da18c3cb162037409c72dd74b25d05f">extra_interpolation_point_var</a> = var;
<a name="l00406"></a>00406   }
<a name="l00407"></a>00407   extra_interpolation_point_var_in.close();
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBEIMEvaluation&quot;</span>);
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
