<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_eim_evaluation.h</div>  </div>
</div>
<div class="contents">
<a href="rb__eim__evaluation_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_eim_evaluation_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_eim_evaluation_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="rb__evaluation_8h.php">rb_evaluation.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028         
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// RBEIMEvaluation class definition</span>
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">RBEIMEvaluation</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a5ad2188c8c1f6b7f9ed86c368c79fb86">RBEIMEvaluation</a> (<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_sys_in);
<a name="l00050"></a>00050 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a665b39d6aa7176e00805cab05401ab5f">00054</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a665b39d6aa7176e00805cab05401ab5f">Parent</a>;
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#ae56da8fabb06dff6fb9b3d5b45a09fa0">clear</a>();
<a name="l00060"></a>00060 
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a55917f0b688d43cc55e06e5dc6a9cce2">initialize</a>();
<a name="l00065"></a>00065 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00073"></a>00073   
<a name="l00079"></a>00079   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">RB_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; EIM_rhs);
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#ae3068e60a02dc19a9347a44c54ff948b">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#abe078aa80850424a0d6dbb33024d9aab">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00094"></a>00094 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">00099</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>;
<a name="l00100"></a>00100   
<a name="l00105"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">00105</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>;
<a name="l00106"></a>00106   
<a name="l00111"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">00111</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>;
<a name="l00112"></a>00112   
<a name="l00118"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">00118</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a>;
<a name="l00119"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a2da18c3cb162037409c72dd74b25d05f">00119</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a2da18c3cb162037409c72dd74b25d05f">extra_interpolation_point_var</a>;
<a name="l00120"></a>00120   
<a name="l00125"></a><a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">00125</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">extra_interpolation_matrix_row</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 };
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
