<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_eim_system.C</div>  </div>
</div>
<div class="contents">
<a href="rb__eim__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// LibMesh includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__compute__data_8h.php">fe_compute_data.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__system_8h.php">rb_eim_system.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="rb__eim__evaluation_8h.php">rb_eim_evaluation.h</a>&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">namespace </span>libMesh
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d88b29db222d7f31a7038027a246823">00047</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d88b29db222d7f31a7038027a246823">RBEIMSystem::RBEIMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00048"></a>00048                           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00049"></a>00049                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00050"></a>00050   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00051"></a>00051     best_fit_type_flag(PROJECTION_BEST_FIT),
<a name="l00052"></a>00052     eval_error_estimate(false),
<a name="l00053"></a>00053     mesh_function(NULL),
<a name="l00054"></a>00054     performing_extra_greedy_step(false),
<a name="l00055"></a>00055     current_variable_number(0)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1RBSystem.php#a03ac7a535dcb71cf3192a6aed752e2bb">use_empty_RB_solve_in_greedy</a> = <span class="keyword">false</span>;
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a657429362f0e847d79290452089e3dce">00060</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a657429362f0e847d79290452089e3dce">RBEIMSystem::~RBEIMSystem</a> ()
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a>;
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a> = NULL;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3a12e0ed7f06c4864b00c5b8bd35013c">00066</a> std::string <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3a12e0ed7f06c4864b00c5b8bd35013c">RBEIMSystem::system_type</a> ()<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   <span class="keywordflow">return</span> <span class="stringliteral">&quot;RBEIMSystem&quot;</span>;
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#abaeca7499b59111ac858e3964e277556">00071</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abaeca7499b59111ac858e3964e277556">RBEIMSystem::process_parameters_file</a> ()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="comment">// Indicate that we need to compute the RB</span>
<a name="l00074"></a>00074   <span class="comment">// inner product matrix in this case</span>
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a> = <span class="keyword">true</span>;
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">// Indicate that we need the training set</span>
<a name="l00078"></a>00078   <span class="comment">// for the Greedy to be the same on all</span>
<a name="l00079"></a>00079   <span class="comment">// processors</span>
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1RBBase.php#a74dbe751421fdf4cc63fba5498fbc5c5">serial_training_set</a> = <span class="keyword">true</span>;
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1RBSystem.php#a7a1f96647b766dba6edef7d2abbdb7dc">Parent::process_parameters_file</a>();
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>() != <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>() )
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: The number of parametrized_functions must match n_vars in RBEIMSystem.&quot;</span>
<a name="l00087"></a>00087                  &lt;&lt; std::endl;
<a name="l00088"></a>00088     libmesh_error();
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   GetPot infile(<a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>);
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   std::string best_fit_type_string = infile(<span class="stringliteral">&quot;best_fit_type&quot;</span>,<span class="stringliteral">&quot;projection&quot;</span>);
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="keywordflow">if</span>(best_fit_type_string == <span class="stringliteral">&quot;projection&quot;</span>)
<a name="l00096"></a>00096   {
<a name="l00097"></a>00097     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a> = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">PROJECTION_BEST_FIT</a>;
<a name="l00098"></a>00098   }
<a name="l00099"></a>00099   <span class="keywordflow">else</span>
<a name="l00100"></a>00100   <span class="keywordflow">if</span>(best_fit_type_string == <span class="stringliteral">&quot;eim&quot;</span>)
<a name="l00101"></a>00101   {
<a name="l00102"></a>00102     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a> = <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aac8315f0606b381d2e4584ded33323e94">EIM_BEST_FIT</a>;
<a name="l00103"></a>00103   }
<a name="l00104"></a>00104   <span class="keywordflow">else</span>
<a name="l00105"></a>00105   {
<a name="l00106"></a>00106     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: invalid best_fit_type in input file&quot;</span> &lt;&lt; std::endl;
<a name="l00107"></a>00107     libmesh_error();
<a name="l00108"></a>00108   }
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;RBEIMSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00111"></a>00111   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;best fit type: &quot;</span> &lt;&lt; best_fit_type_string &lt;&lt; std::endl;
<a name="l00112"></a>00112   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;number of parametrized functions: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>() &lt;&lt; std::endl;
<a name="l00113"></a>00113   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9ffb12f992dfb9ea7693436957460d08">00116</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9ffb12f992dfb9ea7693436957460d08">RBEIMSystem::initialize_RB_system</a>(<span class="keywordtype">bool</span> do_not_assemble)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1RBSystem.php#ab1fed51de792660e9124b27469ab18dd">Parent::initialize_RB_system</a>(do_not_assemble);
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#abcbe187444a693974ccbf300517aaba1">initialize_mesh_dependent_data</a>)
<a name="l00121"></a>00121   {
<a name="l00122"></a>00122     <span class="comment">// initialize a serial vector that we will use for MeshFunction evaluations</span>
<a name="l00123"></a>00123     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a> = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00124"></a>00124     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="comment">// Initialize the MeshFunction for interpolating the</span>
<a name="l00127"></a>00127     <span class="comment">// solution vector at quadrature points</span>
<a name="l00128"></a>00128     std::vector&lt;unsigned int&gt; vars(<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00129"></a>00129     <a class="code" href="namespacelibMesh_1_1Utility.php#a40269b7cf3ba8157ed6b3c2399e62809">Utility::iota</a>(vars.begin(), vars.end(), 0); <span class="comment">// By default use all variables</span>
<a name="l00130"></a>00130     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>(<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>(), *<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>, <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>(), vars);
<a name="l00131"></a>00131     mesh_function-&gt;init();
<a name="l00132"></a>00132     
<a name="l00133"></a>00133     <span class="comment">// initialize the vector that stores the _current_ basis function,</span>
<a name="l00134"></a>00134     <span class="comment">// i.e. the basis funciton that is interpolated by evaluate_current_affine_function</span>
<a name="l00135"></a>00135     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a> = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00136"></a>00136 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>    <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00138"></a>00138                               <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00139"></a>00139 <span class="preprocessor">#else</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>    <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00141"></a>00141 <span class="preprocessor">#endif</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>
<a name="l00143"></a>00143     <span class="keywordflow">if</span>(!do_not_assemble)
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <span class="comment">// Load up the inner product matrix</span>
<a name="l00146"></a>00146       <span class="comment">// We only need one matrix in this class, so we</span>
<a name="l00147"></a>00147       <span class="comment">// can set matrix to inner_product_matrix here</span>
<a name="l00148"></a>00148       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00149"></a>00149       {
<a name="l00150"></a>00150         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00151"></a>00151         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l00152"></a>00152       }
<a name="l00153"></a>00153       <span class="keywordflow">else</span>
<a name="l00154"></a>00154       {
<a name="l00155"></a>00155         <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   }
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">00162</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">RBEIMSystem::evaluate_parametrized_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164   <span class="keywordflow">if</span>(var &gt;= <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>())
<a name="l00165"></a>00165   {
<a name="l00166"></a>00166     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have var &lt; get_n_parametrized_functions() in evaluate_parametrized_function.&quot;</span>
<a name="l00167"></a>00167                  &lt;&lt; std::endl;
<a name="l00168"></a>00168     libmesh_error();
<a name="l00169"></a>00169   }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>[var](p, *<span class="keyword">this</span>);
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">00174</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">RBEIMSystem::get_n_affine_functions</a>()<span class="keyword"> const</span>
<a name="l00175"></a>00175 <span class="keyword"></span>{
<a name="l00176"></a>00176   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>() * <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">00179</a> std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">RBEIMSystem::evaluate_current_affine_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element,
<a name="l00180"></a>00180                                                                   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints)
<a name="l00181"></a>00181 {
<a name="l00182"></a>00182   START_LOG(<span class="stringliteral">&quot;evaluate_current_affine_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// Get local coordinates to feed these into compute_data().  </span>
<a name="l00185"></a>00185   <span class="comment">// Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00186"></a>00186   <span class="comment">// since the inverse mapping is the same for all FEFamilies</span>
<a name="l00187"></a>00187   std::vector&lt;Point&gt; mapped_qpoints;
<a name="l00188"></a>00188   <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().mesh_dimension(), 
<a name="l00189"></a>00189                             <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(0),
<a name="l00190"></a>00190                             &amp;element, 
<a name="l00191"></a>00191                             qpoints,
<a name="l00192"></a>00192                             mapped_qpoints);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a>);
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   std::vector&lt;unsigned int&gt; dof_indices_var;
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (&amp;element, dof_indices_var, <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a>);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   std::vector&lt;Number&gt; values(dof_indices_var.size());
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;mapped_qpoints.size(); qp++)
<a name="l00202"></a>00202   {
<a name="l00203"></a>00203     <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a> data (<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>(), mapped_qpoints[qp]);
<a name="l00204"></a>00204     <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">FEInterface::compute_data</a> (<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().mesh_dimension(), fe_type, &amp;element, data);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206     values[qp] = 0.;
<a name="l00207"></a>00207     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices_var.size(); i++)
<a name="l00208"></a>00208       values[qp] += (*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>)(dof_indices_var[i]) * data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>[i];
<a name="l00209"></a>00209   }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   STOP_LOG(<span class="stringliteral">&quot;evaluate_current_affine_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="keywordflow">return</span> values;
<a name="l00214"></a>00214 }
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">00216</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">RBEIMSystem::cache_ghosted_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> function_index)
<a name="l00217"></a>00217 {
<a name="l00218"></a>00218   START_LOG(<span class="stringliteral">&quot;cache_ghosted_basis_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordflow">if</span>(function_index &gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">get_n_affine_functions</a>())
<a name="l00221"></a>00221   {
<a name="l00222"></a>00222     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: index cannot be larger than the number of affine functions in evaluate_affine_function&quot;</span>
<a name="l00223"></a>00223                  &lt;&lt; std::endl;
<a name="l00224"></a>00224     libmesh_error();
<a name="l00225"></a>00225   }
<a name="l00226"></a>00226         
<a name="l00227"></a>00227   <span class="comment">// First determine the basis function index implied by function_index</span>
<a name="l00228"></a>00228   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bf_index  = function_index/<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   <span class="comment">// and create a ghosted version of the appropriate basis function</span>
<a name="l00231"></a>00231   <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(bf_index).<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>
<a name="l00232"></a>00232     (*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l00233"></a>00233     
<a name="l00234"></a>00234   <span class="comment">// Finally, store the index of the variable number that we will be considering</span>
<a name="l00235"></a>00235   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a> = function_index % <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00236"></a>00236   
<a name="l00237"></a>00237   STOP_LOG(<span class="stringliteral">&quot;cache_ghosted_basis_function()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a54ece7bd74376f951c01c33f10c891b6">00240</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a54ece7bd74376f951c01c33f10c891b6">RBEIMSystem::enrich_RB_space</a>()
<a name="l00241"></a>00241 {
<a name="l00242"></a>00242   START_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">RBEIMEvaluation</a>* eim_eval = libmesh_cast_ptr&lt;RBEIMEvaluation*&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="comment">// If we have at least one basis function we need to use</span>
<a name="l00247"></a>00247   <span class="comment">// RB_solve, otherwise just use new_bf as is</span>
<a name="l00248"></a>00248   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt; 0)
<a name="l00249"></a>00249   {
<a name="l00250"></a>00250     <span class="comment">// get the right-hand side vector for the EIM approximation</span>
<a name="l00251"></a>00251     <span class="comment">// by sampling the parametrized function (stored in solution)</span>
<a name="l00252"></a>00252     <span class="comment">// at the interpolation points</span>
<a name="l00253"></a>00253     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00254"></a>00254     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> EIM_rhs(RB_size);
<a name="l00255"></a>00255     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00256"></a>00256     {
<a name="l00257"></a>00257       EIM_rhs(i) = (*mesh_function)(eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[i]);
<a name="l00258"></a>00258     }
<a name="l00259"></a>00259   
<a name="l00260"></a>00260     eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a8963f5a2766eec1482ad19bef35c952d">RB_solve</a>(EIM_rhs);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262     <span class="comment">// Load the &quot;EIM residual&quot; into solution by subtracting</span>
<a name="l00263"></a>00263     <span class="comment">// the EIM approximation</span>
<a name="l00264"></a>00264     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); i++)
<a name="l00265"></a>00265     {
<a name="l00266"></a>00266       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i), <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l00267"></a>00267     }
<a name="l00268"></a>00268   }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// need to update since context uses current_local_solution</span>
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="comment">// Find the quadrature point at which solution (which now stores</span>
<a name="l00274"></a>00274   <span class="comment">// the &quot;EIM residual&quot;) has maximum absolute value</span>
<a name="l00275"></a>00275   <span class="comment">// by looping over the mesh</span>
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1Point.php">Point</a> optimal_point;
<a name="l00277"></a>00277   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> optimal_value = 0.;
<a name="l00278"></a>00278   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> optimal_var;
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   <span class="comment">// Compute truth representation via projection</span>
<a name="l00281"></a>00281   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00284"></a>00284   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   this-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">init_context</a>(context);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00289"></a>00289   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00292"></a>00292   {
<a name="l00293"></a>00293     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00294"></a>00294     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00295"></a>00295       
<a name="l00296"></a>00296     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00297"></a>00297     {
<a name="l00298"></a>00298       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00299"></a>00299 
<a name="l00300"></a>00300       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qpoints; qp++)
<a name="l00301"></a>00301       {
<a name="l00302"></a>00302         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value = context.<a class="code" href="classlibMesh_1_1FEMContext.php#a15df99c408b61d4d93bc18c5ecbde22c">interior_value</a>(var, qp);
<a name="l00303"></a>00303         
<a name="l00304"></a>00304         <span class="keywordflow">if</span>( std::abs(value) &gt; std::abs(optimal_value) )
<a name="l00305"></a>00305         {
<a name="l00306"></a>00306           optimal_value = value;
<a name="l00307"></a>00307           optimal_point = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_xyz()[qp];
<a name="l00308"></a>00308           optimal_var = var;
<a name="l00309"></a>00309         }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311       }
<a name="l00312"></a>00312     }
<a name="l00313"></a>00313   }
<a name="l00314"></a>00314   
<a name="l00315"></a>00315   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> global_abs_value = std::abs(optimal_value);
<a name="l00316"></a>00316   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_ID_index;
<a name="l00317"></a>00317   <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">Parallel::maxloc</a>(global_abs_value, proc_ID_index);
<a name="l00318"></a>00318   
<a name="l00319"></a>00319   <span class="comment">// Broadcast the optimal point from proc_ID_index</span>
<a name="l00320"></a>00320   <span class="comment">// First need to store optimal_point as a vector</span>
<a name="l00321"></a>00321   std::vector&lt;Real&gt; global_optimal_point(3);
<a name="l00322"></a>00322   global_optimal_point[0] = optimal_point(0);
<a name="l00323"></a>00323   global_optimal_point[1] = optimal_point(1);
<a name="l00324"></a>00324   global_optimal_point[2] = optimal_point(2);
<a name="l00325"></a>00325   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(global_optimal_point, proc_ID_index);
<a name="l00326"></a>00326   optimal_point(0) = global_optimal_point[0];
<a name="l00327"></a>00327   optimal_point(1) = global_optimal_point[1];
<a name="l00328"></a>00328   optimal_point(2) = global_optimal_point[2];
<a name="l00329"></a>00329   <span class="comment">// Also broadcast the corresponding optimal_var and optimal_value</span>
<a name="l00330"></a>00330   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(optimal_var, proc_ID_index);
<a name="l00331"></a>00331   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(optimal_value, proc_ID_index);
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   <span class="comment">// Scale the solution</span>
<a name="l00334"></a>00334   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;scale(1./optimal_value);
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Store optimal point in interpolation_points</span>
<a name="l00337"></a>00337   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>)
<a name="l00338"></a>00338   {
<a name="l00339"></a>00339     eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>.push_back(optimal_point);
<a name="l00340"></a>00340     eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a490fa0ac999f3d36cd43637df6170229">interpolation_points_var</a>.push_back(optimal_var);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* new_bf = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00343"></a>00343     new_bf-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00344"></a>00344     *new_bf = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00345"></a>00345     <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.push_back( new_bf );
<a name="l00346"></a>00346   }
<a name="l00347"></a>00347   <span class="keywordflow">else</span>
<a name="l00348"></a>00348   {
<a name="l00349"></a>00349     eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a> = optimal_point;
<a name="l00350"></a>00350     eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a2da18c3cb162037409c72dd74b25d05f">extra_interpolation_point_var</a> = optimal_var;
<a name="l00351"></a>00351   }
<a name="l00352"></a>00352   
<a name="l00353"></a>00353   STOP_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">00356</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">RBEIMSystem::compute_best_fit_error</a>()
<a name="l00357"></a>00357 {
<a name="l00358"></a>00358   START_LOG(<span class="stringliteral">&quot;compute_best_fit_error()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00359"></a>00359   
<a name="l00360"></a>00360   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00361"></a>00361   
<a name="l00362"></a>00362   <span class="comment">// load the parametrized function into the solution vector</span>
<a name="l00363"></a>00363   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">truth_solve</a>(-1);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365   <span class="keywordflow">switch</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a>)
<a name="l00366"></a>00366   {
<a name="l00367"></a>00367     <span class="keywordflow">case</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">PROJECTION_BEST_FIT</a>):
<a name="l00368"></a>00368     {
<a name="l00369"></a>00369       <span class="comment">// compute the rhs by performing inner products</span>
<a name="l00370"></a>00370       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> best_fit_rhs(RB_size);
<a name="l00371"></a>00371       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00372"></a>00372       {
<a name="l00373"></a>00373         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00374"></a>00374         {
<a name="l00375"></a>00375           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00376"></a>00376         }
<a name="l00377"></a>00377         <span class="keywordflow">else</span> <span class="comment">// In low memory mode we loaded the inner-product matrix into matrix during initialization</span>
<a name="l00378"></a>00378         {
<a name="l00379"></a>00379           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00380"></a>00380         }
<a name="l00381"></a>00381         best_fit_rhs(i) = <a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(<a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l00382"></a>00382       }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384       <span class="comment">// Now compute the best fit by an LU solve</span>
<a name="l00385"></a>00385       <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(RB_size);
<a name="l00386"></a>00386       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_inner_product_matrix_N(RB_size);
<a name="l00387"></a>00387       <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">RB_inner_product_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(RB_size, RB_inner_product_matrix_N);
<a name="l00388"></a>00388 
<a name="l00389"></a>00389       RB_inner_product_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(best_fit_rhs, <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00390"></a>00390       <span class="keywordflow">break</span>;
<a name="l00391"></a>00391     }
<a name="l00392"></a>00392     <span class="keywordflow">case</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aac8315f0606b381d2e4584ded33323e94">EIM_BEST_FIT</a>):
<a name="l00393"></a>00393     {
<a name="l00394"></a>00394       <span class="comment">// Turn off error estimation here, we use the linfty norm instead</span>
<a name="l00395"></a>00395       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a> = <span class="keyword">false</span>;
<a name="l00396"></a>00396       <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a3e451b7c989bc337a99936a07b3fedf6">RB_solve</a>(RB_size);
<a name="l00397"></a>00397       <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a> = <span class="keyword">true</span>;
<a name="l00398"></a>00398       <span class="keywordflow">break</span>;
<a name="l00399"></a>00399     }
<a name="l00400"></a>00400     <span class="keywordflow">default</span>:
<a name="l00401"></a>00401     {
<a name="l00402"></a>00402       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Should not reach here&quot;</span> &lt;&lt; std::endl;
<a name="l00403"></a>00403       libmesh_error();
<a name="l00404"></a>00404     }
<a name="l00405"></a>00405   }
<a name="l00406"></a>00406   
<a name="l00407"></a>00407   <span class="comment">// load the error into solution</span>
<a name="l00408"></a>00408   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); i++)
<a name="l00409"></a>00409   {
<a name="l00410"></a>00410     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i), <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l00411"></a>00411   }
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> best_fit_error = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;linfty_norm();
<a name="l00414"></a>00414   
<a name="l00415"></a>00415   STOP_LOG(<span class="stringliteral">&quot;compute_best_fit_error()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00416"></a>00416   
<a name="l00417"></a>00417   <span class="keywordflow">return</span> best_fit_error;
<a name="l00418"></a>00418 }
<a name="l00419"></a>00419 
<a name="l00420"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">00420</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">RBEIMSystem::truth_solve</a>(<span class="keywordtype">int</span> plot_solution)
<a name="l00421"></a>00421 {
<a name="l00422"></a>00422   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00423"></a>00423         
<a name="l00424"></a>00424   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBBase.php#abcbe187444a693974ccbf300517aaba1">initialize_mesh_dependent_data</a>)
<a name="l00425"></a>00425   {
<a name="l00426"></a>00426     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the mesh dependent &quot;</span>
<a name="l00427"></a>00427                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to load the truth solution.&quot;</span>
<a name="l00428"></a>00428                  &lt;&lt; std::endl;
<a name="l00429"></a>00429     libmesh_error();
<a name="l00430"></a>00430   }
<a name="l00431"></a>00431   
<a name="l00432"></a>00432 <span class="comment">//  matrix should have been set to inner_product_matrix during initialization</span>
<a name="l00433"></a>00433 <span class="comment">//  if(!low_memory_mode)</span>
<a name="l00434"></a>00434 <span class="comment">//  {</span>
<a name="l00435"></a>00435 <span class="comment">//    matrix-&gt;zero();</span>
<a name="l00436"></a>00436 <span class="comment">//    matrix-&gt;add(1., *inner_product_matrix);</span>
<a name="l00437"></a>00437 <span class="comment">//  }</span>
<a name="l00438"></a>00438 <span class="comment">//  else</span>
<a name="l00439"></a>00439 <span class="comment">//  {</span>
<a name="l00440"></a>00440 <span class="comment">//    assemble_inner_product_matrix(matrix);</span>
<a name="l00441"></a>00441 <span class="comment">//  }</span>
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="comment">// Compute truth representation via projection</span>
<a name="l00444"></a>00444   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00445"></a>00445 
<a name="l00446"></a>00446   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> c = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00447"></a>00447   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context  = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*c);
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   this-&gt;<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">init_context</a>(context);
<a name="l00450"></a>00450   
<a name="l00451"></a>00451   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00454"></a>00454   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00457"></a>00457   {
<a name="l00458"></a>00458     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00459"></a>00459     context.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00460"></a>00460       
<a name="l00461"></a>00461     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00462"></a>00462     {
<a name="l00463"></a>00463       <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;JxW =
<a name="l00464"></a>00464         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00465"></a>00465 
<a name="l00466"></a>00466       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi =
<a name="l00467"></a>00467         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00468"></a>00468 
<a name="l00469"></a>00469       <span class="keyword">const</span> std::vector&lt;Point&gt; &amp;xyz =
<a name="l00470"></a>00470         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_xyz();
<a name="l00471"></a>00471 
<a name="l00472"></a>00472       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00473"></a>00473       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_var_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00474"></a>00474 
<a name="l00475"></a>00475       <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>&amp; subresidual_var = *context.<a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[var];
<a name="l00476"></a>00476 
<a name="l00477"></a>00477       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qpoints; qp++)
<a name="l00478"></a>00478         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_var_dofs; i++)
<a name="l00479"></a>00479           subresidual_var(i) += JxW[qp] * <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(var, xyz[qp]) * phi[i][qp];
<a name="l00480"></a>00480     }
<a name="l00481"></a>00481 
<a name="l00482"></a>00482     <span class="comment">// Apply constraints, e.g. periodic constraints</span>
<a name="l00483"></a>00483     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00484"></a>00484 
<a name="l00485"></a>00485     <span class="comment">// Add element vector to global vector</span>
<a name="l00486"></a>00486     <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00487"></a>00487   }
<a name="l00488"></a>00488   
<a name="l00489"></a>00489   <span class="comment">// Solve to find the best fit, then solution stores the truth representation</span>
<a name="l00490"></a>00490   <span class="comment">// of the function to be approximated</span>
<a name="l00491"></a>00491   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l00492"></a>00492   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>(); <span class="comment">// put the solution into current_local_solution as well in case we want to plot it</span>
<a name="l00493"></a>00493   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize(*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>);
<a name="l00494"></a>00494   
<a name="l00495"></a>00495   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00496"></a>00496   {
<a name="l00497"></a>00497     <span class="comment">// After we&#39;ve done a solve we can now reuse the preconditioner</span>
<a name="l00498"></a>00498     <span class="comment">// because the matrix is not changing</span>
<a name="l00499"></a>00499     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l00500"></a>00500   }
<a name="l00501"></a>00501   
<a name="l00502"></a>00502   <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l00503"></a>00503   <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l00504"></a>00504        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l00505"></a>00505       (this-&gt;final_linear_residual() &gt;
<a name="l00506"></a>00506        this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l00507"></a>00507   {
<a name="l00508"></a>00508       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l00509"></a>00509                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l00510"></a>00510                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00511"></a>00511 <span class="comment">//     libmesh_error();</span>
<a name="l00512"></a>00512   }
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   <span class="keywordflow">if</span>(plot_solution &gt; 0)
<a name="l00515"></a>00515   {
<a name="l00516"></a>00516     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh = <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00517"></a>00517     <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (<span class="stringliteral">&quot;truth.gmv&quot;</span>,
<a name="l00518"></a>00518                                         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00519"></a>00519   }
<a name="l00520"></a>00520   
<a name="l00521"></a>00521   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00522"></a>00522   
<a name="l00523"></a>00523   <span class="keywordflow">return</span> 0.;
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">00526</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">RBEIMSystem::init_context</a>(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;c)
<a name="l00527"></a>00527 {
<a name="l00528"></a>00528   <span class="comment">// default implementation of init_context</span>
<a name="l00529"></a>00529   <span class="comment">// for compute_best_fit</span>
<a name="l00530"></a>00530   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00531"></a>00531   {
<a name="l00532"></a>00532     c.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00533"></a>00533     c.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00534"></a>00534     c.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_xyz();
<a name="l00535"></a>00535   }
<a name="l00536"></a>00536 }
<a name="l00537"></a>00537 
<a name="l00538"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a51f66301f3927c5724ad37a3c23e42e9">00538</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>* <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a51f66301f3927c5724ad37a3c23e42e9">RBEIMSystem::add_new_rb_evaluation_object</a>()
<a name="l00539"></a>00539 {
<a name="l00540"></a>00540   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">RBEIMEvaluation</a>* e = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">RBEIMEvaluation</a>(*<span class="keyword">this</span>);
<a name="l00541"></a>00541   <a class="code" href="classlibMesh_1_1RBSystem.php#a465a32a7ecf189138b5d660bbd19cbf4">rb_evaluation_objects</a>.push_back(e);
<a name="l00542"></a>00542   
<a name="l00543"></a>00543   <span class="keywordflow">return</span> e;
<a name="l00544"></a>00544 }
<a name="l00545"></a>00545 
<a name="l00546"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">00546</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">RBEIMSystem::update_RB_system_matrices</a>()
<a name="l00547"></a>00547 {
<a name="l00548"></a>00548   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00549"></a>00549   
<a name="l00550"></a>00550   <a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">Parent::update_RB_system_matrices</a>();
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00553"></a>00553   
<a name="l00554"></a>00554   <a class="code" href="classlibMesh_1_1RBEIMEvaluation.php">RBEIMEvaluation</a>* eim_eval = libmesh_cast_ptr&lt;RBEIMEvaluation*&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l00555"></a>00555   
<a name="l00556"></a>00556   <span class="comment">// update the EIM interpolation matrix</span>
<a name="l00557"></a>00557   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00558"></a>00558   {
<a name="l00559"></a>00559     <span class="comment">// Sample the basis functions at the</span>
<a name="l00560"></a>00560     <span class="comment">// new interpolation point</span>
<a name="l00561"></a>00561     <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(j).<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>(*<a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>);
<a name="l00562"></a>00562 
<a name="l00563"></a>00563     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>)
<a name="l00564"></a>00564     {
<a name="l00565"></a>00565       eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a952c4e75880c9c37947fd25fcd14ab47">interpolation_matrix</a>(RB_size-1,j) =
<a name="l00566"></a>00566         (*mesh_function)(eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a6930417e258139ecfe96b1185afa43c2">interpolation_points</a>[RB_size-1]);
<a name="l00567"></a>00567     }
<a name="l00568"></a>00568     <span class="keywordflow">else</span>
<a name="l00569"></a>00569     {
<a name="l00570"></a>00570       eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#aa01e9284f387481647d829f4ca03b788">extra_interpolation_matrix_row</a>(j) =
<a name="l00571"></a>00571         (*mesh_function)(eim_eval-&gt;<a class="code" href="classlibMesh_1_1RBEIMEvaluation.php#a1a2a6a7e9bed08985849db6d7ba4cefa">extra_interpolation_point</a>);
<a name="l00572"></a>00572     }
<a name="l00573"></a>00573   }
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;RBEIMSystem&quot;</span>);
<a name="l00576"></a>00576 }
<a name="l00577"></a>00577 
<a name="l00578"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#aabd12f850f9e826396ec8eeffdb9fbc1">00578</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#aabd12f850f9e826396ec8eeffdb9fbc1">RBEIMSystem::update_system</a>()
<a name="l00579"></a>00579 {
<a name="l00580"></a>00580   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating RB matrices&quot;</span> &lt;&lt; std::endl;
<a name="l00581"></a>00581   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">update_RB_system_matrices</a>();
<a name="l00582"></a>00582 }
<a name="l00583"></a>00583 
<a name="l00584"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a50914d7bcd2d62551b1961eca497f252">00584</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a50914d7bcd2d62551b1961eca497f252">RBEIMSystem::greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span>)
<a name="l00585"></a>00585 {
<a name="l00586"></a>00586   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>)
<a name="l00587"></a>00587   {
<a name="l00588"></a>00588     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Extra Greedy iteration finished.&quot;</span> &lt;&lt; std::endl;
<a name="l00589"></a>00589     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">false</span>;
<a name="l00590"></a>00590     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00591"></a>00591   }
<a name="l00592"></a>00592 
<a name="l00593"></a>00593   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">false</span>;
<a name="l00594"></a>00594 
<a name="l00595"></a>00595   <span class="keywordflow">if</span>(training_greedy_error &lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">get_training_tolerance</a>())
<a name="l00596"></a>00596   {
<a name="l00597"></a>00597     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Specified error tolerance reached.&quot;</span> &lt;&lt; std::endl
<a name="l00598"></a>00598                  &lt;&lt; <span class="stringliteral">&quot;Perform one more Greedy iteration for error bounds.&quot;</span> &lt;&lt; std::endl;
<a name="l00599"></a>00599     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">true</span>;
<a name="l00600"></a>00600     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00601"></a>00601   }
<a name="l00602"></a>00602 
<a name="l00603"></a>00603   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt;= this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>())
<a name="l00604"></a>00604   {
<a name="l00605"></a>00605     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of basis functions reached: Nmax = &quot;</span>
<a name="l00606"></a>00606               &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl
<a name="l00607"></a>00607               &lt;&lt; <span class="stringliteral">&quot;Perform one more Greedy iteration for error bounds.&quot;</span> &lt;&lt; std::endl;
<a name="l00608"></a>00608     <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a> = <span class="keyword">true</span>;
<a name="l00609"></a>00609     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00610"></a>00610   }
<a name="l00611"></a>00611   
<a name="l00612"></a>00612   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00613"></a>00613 }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 } <span class="comment">// namespace libMesh</span>
<a name="l00616"></a>00616 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
