<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_eim_system.h</div>  </div>
</div>
<div class="contents">
<a href="rb__eim__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_eim_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_eim_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="mesh__function_8h.php">mesh_function.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00042"></a><a class="code" href="namespacelibMesh.php#aedacb3429d477794325ea67817f8e395">00042</a> <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (*<a class="code" href="namespacelibMesh.php#aedacb3429d477794325ea67817f8e395">parametrized_function_fptr</a>)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp;);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// RBEIMSystem class definition</span>
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">00051</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2a">BEST_FIT_TYPE</a> { <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aa077a557c95c17e5a4546e5e325f5bdab">PROJECTION_BEST_FIT</a>, <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2aac8315f0606b381d2e4584ded33323e94">EIM_BEST_FIT</a> };
<a name="l00052"></a>00052 
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a0d88b29db222d7f31a7038027a246823">RBEIMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00058"></a>00058                <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00059"></a>00059                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00060"></a>00060 
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a657429362f0e847d79290452089e3dce">~RBEIMSystem</a> ();
<a name="l00065"></a>00065 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#afe7c405bbae10cdc5ef71ea9ac305122">00069</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#afe7c405bbae10cdc5ef71ea9ac305122">sys_type</a>;
<a name="l00070"></a>00070   
<a name="l00074"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a75be5c788ee4549f8cf1210c602daa46">00074</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a75be5c788ee4549f8cf1210c602daa46">Parent</a>;
<a name="l00075"></a>00075   
<a name="l00079"></a>00079   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3a12e0ed7f06c4864b00c5b8bd35013c">system_type</a> () <span class="keyword">const</span>;
<a name="l00080"></a>00080   
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9ffb12f992dfb9ea7693436957460d08">initialize_RB_system</a>(<span class="keywordtype">bool</span> online_mode);
<a name="l00086"></a>00086  
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a09bc2cb1397e774b2e792d565ce40a21">truth_solve</a>(<span class="keywordtype">int</span> plot_solution);
<a name="l00096"></a>00096 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">compute_best_fit_error</a>();
<a name="l00105"></a>00105   
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ac2cf12446f8194fa22c2b3c9a7b1fca2">init_context</a>(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;c);
<a name="l00112"></a>00112   
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>* <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a51f66301f3927c5724ad37a3c23e42e9">add_new_rb_evaluation_object</a>();
<a name="l00118"></a>00118 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a90a1d8ca0b8b10fe41c1854e8343ea4b">00123</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a90a1d8ca0b8b10fe41c1854e8343ea4b">attach_paramerized_function</a>(<a class="code" href="namespacelibMesh.php#aedacb3429d477794325ea67817f8e395">parametrized_function_fptr</a> fptr)
<a name="l00124"></a>00124     { <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>.push_back(fptr); }
<a name="l00125"></a>00125   
<a name="l00130"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">00130</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a48ecfe2c8fc98bf0a17e730e786467bd">get_n_parametrized_functions</a>()<span class="keyword"> const</span>
<a name="l00131"></a>00131 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>.size(); }
<a name="l00132"></a>00132 
<a name="l00137"></a>00137   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9d72a25b6a85986018ec297a73bd8f97">evaluate_parametrized_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00138"></a>00138   
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a1fe41b9f0c69104eb59220166afb929c">get_n_affine_functions</a>() <span class="keyword">const</span>;
<a name="l00145"></a>00145   
<a name="l00149"></a>00149   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a3c90ab10e1378d26ea0db2094ad37f17">evaluate_current_affine_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element,
<a name="l00150"></a>00150                                                        <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints);
<a name="l00151"></a>00151 
<a name="l00157"></a>00157   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a46b55bb7ba6c15b09d42c0b3e6feacda">cache_ghosted_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> function_index);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00160"></a>00160   
<a name="l00170"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">00170</a>   <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af69284437ee73022900134a07d029d2a">BEST_FIT_TYPE</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a59e0e07c97341f774dfe93b8ca87c17d">best_fit_type_flag</a>;
<a name="l00171"></a>00171 
<a name="l00177"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">00177</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a49536f1b30de5b44b86f2361f52dd925">eval_error_estimate</a>;
<a name="l00178"></a>00178   
<a name="l00179"></a>00179 <span class="keyword">protected</span>:
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abaeca7499b59111ac858e3964e277556">process_parameters_file</a> ();
<a name="l00186"></a>00186 
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a54ece7bd74376f951c01c33f10c891b6">enrich_RB_space</a>();
<a name="l00192"></a>00192   
<a name="l00197"></a>00197   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#aabd12f850f9e826396ec8eeffdb9fbc1">update_system</a>();
<a name="l00198"></a>00198   
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9816bd5cd95b053b2cbbffc7b80881ab">update_RB_system_matrices</a>();
<a name="l00205"></a>00205   
<a name="l00210"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ad3093b9304c6e98973517a130bccc7f2">00210</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ad3093b9304c6e98973517a130bccc7f2">get_RB_error_bound</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a9697d17d54f4349389032bcd12b89683">compute_best_fit_error</a>(); }
<a name="l00211"></a>00211   
<a name="l00216"></a>00216   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a50914d7bcd2d62551b1961eca497f252">greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count);
<a name="l00217"></a>00217   
<a name="l00218"></a>00218 <span class="keyword">private</span>:
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">00223</a>   <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>* <a class="code" href="classlibMesh_1_1RBEIMSystem.php#acc26e4d0d9bce27a33ce4f956304b8c4">mesh_function</a>;
<a name="l00224"></a>00224   
<a name="l00231"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">00231</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abe224818af2634670a90d9dfa2f53686">performing_extra_greedy_step</a>;
<a name="l00232"></a>00232   
<a name="l00237"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">00237</a>   std::vector&lt;parametrized_function_fptr&gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#abcf8520a990282f876f26a164c74687f">parametrized_functions</a>;
<a name="l00238"></a>00238   
<a name="l00244"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">00244</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#af575f6d6a8fea8a3cdc385aba4779766">current_ghosted_bf</a>;
<a name="l00245"></a>00245   
<a name="l00251"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">00251</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEIMSystem.php#a6d851240aacbb38297f861d98c6487a3">current_variable_number</a>;
<a name="l00252"></a>00252   
<a name="l00258"></a><a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">00258</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBEIMSystem.php#ab0de301ef87beaca8ad3e97e70105743">serialized_vector</a>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 };
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 } <span class="comment">// namespace libMesh</span>
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
