<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_evaluation.C</div>  </div>
</div>
<div class="contents">
<a href="rb__evaluation_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="rb__evaluation_8h.php">rb_evaluation.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// For creating a directory</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;errno.h&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a21af67e6f842c9978c4fc21b96855de5">00039</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a21af67e6f842c9978c4fc21b96855de5">RBEvaluation::RBEvaluation</a> (<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_sys_in)
<a name="l00040"></a>00040   :
<a name="l00041"></a>00041   rb_sys(rb_sys_in),
<a name="l00042"></a>00042   multiple_files_for_outputs(false)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#ac7438022dbbe8f5704410e02c8b81f96">00046</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#ac7438022dbbe8f5704410e02c8b81f96">RBEvaluation::~RBEvaluation</a>()
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">clear</a>();
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">00051</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">RBEvaluation::clear</a>()
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   START_LOG(<span class="stringliteral">&quot;clear()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">// Clear the basis functions</span>
<a name="l00056"></a>00056   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.size(); i++)
<a name="l00057"></a>00057   {
<a name="l00058"></a>00058     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i])
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]-&gt;clear();
<a name="l00061"></a>00061       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i];
<a name="l00062"></a>00062       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i] = NULL;
<a name="l00063"></a>00063     }
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a8b5f98eea113593a2293fdba35df3f27">set_n_basis_functions</a>(0);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a93407d78dbbdb6a6b79e292eb2f5c41d">clear_riesz_representors</a>();
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// Clear the Greedy param list</span>
<a name="l00070"></a>00070   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>.size(); i++)
<a name="l00071"></a>00071     <a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>[i].<a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">clear</a>();
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>.clear();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   STOP_LOG(<span class="stringliteral">&quot;clear()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a1522bd9902fa9e97b9236532cd09bef8">00077</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a1522bd9902fa9e97b9236532cd09bef8">RBEvaluation::initialize</a>()
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>();
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1RBEvaluation.php#aca02e1bf8920dae0745cd88eed373a32">resize_RB_data</a>(Nmax);
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#aca02e1bf8920dae0745cd88eed373a32">00084</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aca02e1bf8920dae0745cd88eed373a32">RBEvaluation::resize_RB_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax)
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086   START_LOG(<span class="stringliteral">&quot;resize_RB_data()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="keywordflow">if</span>(Nmax &lt; this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00089"></a>00089   {
<a name="l00090"></a>00090     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot set Nmax to be less than the &quot;</span>
<a name="l00091"></a>00091                  &lt;&lt; <span class="stringliteral">&quot;current number of basis functions.&quot;</span>  &lt;&lt; std::endl;
<a name="l00092"></a>00092     libmesh_error();
<a name="l00093"></a>00093   }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// Resize/clear inner product matrix</span>
<a name="l00096"></a>00096   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l00097"></a>00097     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">RB_inner_product_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(Nmax,Nmax);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Allocate dense matrices for RB solves</span>
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q++)
<a name="l00103"></a>00103   {
<a name="l00104"></a>00104     <span class="comment">// Initialize the memory for the RB matrices</span>
<a name="l00105"></a>00105     <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>[q].resize(Nmax,Nmax);
<a name="l00106"></a>00106   }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q++)
<a name="l00111"></a>00111   {
<a name="l00112"></a>00112     <span class="comment">// Initialize the memory for the RB vectors</span>
<a name="l00113"></a>00113     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>[q].resize(Nmax);
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="comment">// Initialize vectors for the norms of the representors</span>
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00118"></a>00118   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); i++)
<a name="l00119"></a>00119   {
<a name="l00120"></a>00120     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[i].resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00121"></a>00121     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); j++)
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[i][j].resize(Nmax, 0.);
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_a_hat = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()*(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()+1)/2;
<a name="l00128"></a>00128   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>.resize(Q_a_hat);
<a name="l00129"></a>00129   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_a_hat; i++)
<a name="l00130"></a>00130   {
<a name="l00131"></a>00131     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[i].resize(Nmax);
<a name="l00132"></a>00132     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;Nmax; j++)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[i][j].resize(Nmax, 0.);
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136   }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// Initialize the RB output vectors</span>
<a name="l00139"></a>00139   <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00140"></a>00140   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142     <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n].resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n));
<a name="l00143"></a>00143     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l].resize(Nmax);
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147   }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// Initialize vectors storing output data</span>
<a name="l00150"></a>00150   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a52ae294af449d6de30d3d86e5f8f1193">RB_outputs</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(), 0.);
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a6e740bfd0e45ec06a1306f73960fdb42">RB_output_error_bounds</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(), 0.);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">// Clear and resize the vector of A_q_representors</span>
<a name="l00154"></a>00154   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a93407d78dbbdb6a6b79e292eb2f5c41d">clear_riesz_representors</a>();
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>.resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00157"></a>00157   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00158"></a>00158   {
<a name="l00159"></a>00159     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a].resize(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>());
<a name="l00160"></a>00160   }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   STOP_LOG(<span class="stringliteral">&quot;resize_RB_data()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a02ab98754dd78590703db930f306b07e">00165</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a02ab98754dd78590703db930f306b07e">RBEvaluation::get_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00166"></a>00166 {
<a name="l00167"></a>00167   libmesh_assert(i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.size());
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordflow">return</span> *(<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]);
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a3e451b7c989bc337a99936a07b3fedf6">00172</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a3e451b7c989bc337a99936a07b3fedf6">RBEvaluation::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00177"></a>00177   {
<a name="l00178"></a>00178     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00179"></a>00179                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00180"></a>00180     libmesh_error();
<a name="l00181"></a>00181   }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// Resize (and clear) the solution vector</span>
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// Assemble the RB system</span>
<a name="l00187"></a>00187   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_system_matrix(N,N);
<a name="l00188"></a>00188   RB_system_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_A_q_a;
<a name="l00191"></a>00191   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00192"></a>00192   {
<a name="l00193"></a>00193     <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>[q_a].get_principal_submatrix(N, RB_A_q_a);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     RB_system_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), RB_A_q_a);
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// Assemble the RB rhs</span>
<a name="l00199"></a>00199   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs(N);
<a name="l00200"></a>00200   RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_F_q_f;
<a name="l00203"></a>00203   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00204"></a>00204   {
<a name="l00205"></a>00205     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>[q_f].get_principal_subvector(N, RB_F_q_f);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207     RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f), RB_F_q_f);
<a name="l00208"></a>00208   }
<a name="l00209"></a>00209   
<a name="l00210"></a>00210   <span class="comment">// Solve the linear system</span>
<a name="l00211"></a>00211   <span class="keywordflow">if</span>(N &gt; 0)
<a name="l00212"></a>00212   {
<a name="l00213"></a>00213     RB_system_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs, <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00214"></a>00214   }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="comment">// Evaluate the dual norm of the residual for RB_solution_vector</span>
<a name="l00217"></a>00217   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon_N = <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa8227f32dafcbf7f1ca8b56d7c26a67a">compute_residual_dual_norm</a>(N);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="comment">// Get lower bound for coercivity constant</span>
<a name="l00220"></a>00220   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">get_SCM_lower_bound</a>();
<a name="l00221"></a>00221   <span class="comment">// alpha_LB needs to be positive to get a valid error bound</span>
<a name="l00222"></a>00222   libmesh_assert( alpha_LB &gt; 0. );
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="comment">// Store (absolute) error bound</span>
<a name="l00225"></a>00225   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> abs_error_bound = epsilon_N / <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">residual_scaling_denom</a>(alpha_LB);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// Compute the norm of RB_solution</span>
<a name="l00228"></a>00228   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> RB_solution_norm = <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">l2_norm</a>();
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="comment">// Now compute the outputs and associated errors</span>
<a name="l00231"></a>00231   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l00232"></a>00232   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00233"></a>00233   {
<a name="l00234"></a>00234     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a52ae294af449d6de30d3d86e5f8f1193">RB_outputs</a>[n] = 0.;
<a name="l00235"></a>00235     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l00238"></a>00238       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a52ae294af449d6de30d3d86e5f8f1193">RB_outputs</a>[n] += <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l))*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00239"></a>00239     }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a6e740bfd0e45ec06a1306f73960fdb42">RB_output_error_bounds</a>[n] = abs_error_bound * <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l00242"></a>00242   }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00245"></a>00245   
<a name="l00246"></a>00246   <span class="keywordflow">return</span> ( <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> ? abs_error_bound/RB_solution_norm : abs_error_bound );
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#aa8227f32dafcbf7f1ca8b56d7c26a67a">00249</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa8227f32dafcbf7f1ca8b56d7c26a67a">RBEvaluation::compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   START_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// Use the stored representor inner product values</span>
<a name="l00254"></a>00254   <span class="comment">// to evaluate the residual norm</span>
<a name="l00255"></a>00255   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = 0.;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l00258"></a>00258   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l00259"></a>00259   {
<a name="l00260"></a>00260     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l00261"></a>00261     {
<a name="l00262"></a>00262       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_f1==q_f2) ? 1. : 2.;
<a name="l00263"></a>00263       residual_norm_sq += delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(
<a name="l00264"></a>00264         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f1) * <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f2)) * <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q] );
<a name="l00265"></a>00265 
<a name="l00266"></a>00266       q++;
<a name="l00267"></a>00267     }
<a name="l00268"></a>00268   }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00271"></a>00271   {
<a name="l00272"></a>00272     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00275"></a>00275       {
<a name="l00276"></a>00276         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = 2.;
<a name="l00277"></a>00277         residual_norm_sq +=
<a name="l00278"></a>00278           delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f) * <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a)) *
<a name="l00279"></a>00279           <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i)) * <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[q_f][q_a][i] );
<a name="l00280"></a>00280       }
<a name="l00281"></a>00281     }
<a name="l00282"></a>00282   }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   q=0;
<a name="l00285"></a>00285   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l00286"></a>00286   {
<a name="l00287"></a>00287     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l00288"></a>00288     {
<a name="l00289"></a>00289       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_a1==q_a2) ? 1. : 2.;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00292"></a>00292       {
<a name="l00293"></a>00293         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00294"></a>00294         {
<a name="l00295"></a>00295           residual_norm_sq +=
<a name="l00296"></a>00296             delta * <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>( <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a1)) * <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a2) *
<a name="l00297"></a>00297             <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i)) * <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(j) * <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[q][i][j] );
<a name="l00298"></a>00298         }
<a name="l00299"></a>00299       }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301       q++;
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303   }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) &lt; 0.)
<a name="l00306"></a>00306   {
<a name="l00307"></a>00307 <span class="comment">//    libMesh::out &lt;&lt; &quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l00308"></a>00308 <span class="comment">//                 &lt;&lt; &quot;in RBSystem::compute_residual_dual_norm()&quot; &lt;&lt; std::endl;</span>
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="comment">//     Sometimes this is negative due to rounding error,</span>
<a name="l00311"></a>00311 <span class="comment">//     but when this occurs the error is on the order of 1.e-10,</span>
<a name="l00312"></a>00312 <span class="comment">//     so shouldn&#39;t affect error bound much...</span>
<a name="l00313"></a>00313 <span class="comment">//     libmesh_error();</span>
<a name="l00314"></a>00314     residual_norm_sq = std::abs(residual_norm_sq);
<a name="l00315"></a>00315   }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   STOP_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="keywordflow">return</span> std::sqrt( <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) );
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a93407d78dbbdb6a6b79e292eb2f5c41d">00322</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a93407d78dbbdb6a6b79e292eb2f5c41d">RBEvaluation::clear_riesz_representors</a>()
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324   START_LOG(<span class="stringliteral">&quot;clear_riesz_representors()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00325"></a>00325   
<a name="l00326"></a>00326   <span class="comment">// Clear the A_q_representors</span>
<a name="l00327"></a>00327   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>.size(); q_a++)
<a name="l00328"></a>00328   {
<a name="l00329"></a>00329     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a].size(); i++)
<a name="l00330"></a>00330     {
<a name="l00331"></a>00331       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a][i])
<a name="l00332"></a>00332       {
<a name="l00333"></a>00333         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a][i];
<a name="l00334"></a>00334         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a][i] = NULL;
<a name="l00335"></a>00335       }
<a name="l00336"></a>00336     }
<a name="l00337"></a>00337   }
<a name="l00338"></a>00338   
<a name="l00339"></a>00339   STOP_LOG(<span class="stringliteral">&quot;clear_riesz_representors()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00340"></a>00340 }
<a name="l00341"></a>00341 
<a name="l00342"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a00e6ee9a21d2c3a4f3db3efb44582dce">00342</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a00e6ee9a21d2c3a4f3db3efb44582dce">RBEvaluation::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00343"></a>00343 {
<a name="l00344"></a>00344   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00349"></a>00349   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() );
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00352"></a>00352   {
<a name="l00353"></a>00353 
<a name="l00354"></a>00354     <span class="comment">// Make a directory to store all the data files</span>
<a name="l00355"></a>00355     <span class="keywordflow">if</span>( mkdir(directory_name.c_str(), 0777) == -1)
<a name="l00356"></a>00356     {
<a name="l00357"></a>00357       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;In RBEvaluation::write_offline_data_to_files, directory &quot;</span>
<a name="l00358"></a>00358                    &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot; already exists, overwriting contents.&quot;</span> &lt;&lt; std::endl;
<a name="l00359"></a>00359     }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361     <span class="comment">// First, write out how many basis functions we have generated</span>
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363       std::ofstream n_bfs_out;
<a name="l00364"></a>00364       {
<a name="l00365"></a>00365         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00366"></a>00366         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/n_bfs.dat&quot;</span>;
<a name="l00367"></a>00367         n_bfs_out.open(file_name.str().c_str());
<a name="l00368"></a>00368       }
<a name="l00369"></a>00369       <span class="keywordflow">if</span> ( !n_bfs_out.good() )
<a name="l00370"></a>00370       {
<a name="l00371"></a>00371         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening n_bfs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00372"></a>00372         libmesh_error();
<a name="l00373"></a>00373       }
<a name="l00374"></a>00374       n_bfs_out &lt;&lt; n_bfs;
<a name="l00375"></a>00375       n_bfs_out.close();
<a name="l00376"></a>00376     }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d4dcf1be97b4f37f2c2bfd65668ec29">multiple_files_for_outputs</a>)
<a name="l00379"></a>00379     {
<a name="l00380"></a>00380       <span class="comment">// Write out output data to multiple files</span>
<a name="l00381"></a>00381       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00382"></a>00382       {
<a name="l00383"></a>00383         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00384"></a>00384         {
<a name="l00385"></a>00385           std::ofstream output_n_out;
<a name="l00386"></a>00386           {
<a name="l00387"></a>00387             <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00388"></a>00388             file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/output_&quot;</span>;
<a name="l00389"></a>00389             OSSRealzeroright(file_name,3,0,n);
<a name="l00390"></a>00390             file_name &lt;&lt; <span class="stringliteral">&quot;_&quot;</span>;
<a name="l00391"></a>00391             OSSRealzeroright(file_name,3,0,q_l);
<a name="l00392"></a>00392             file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00393"></a>00393             output_n_out.open(file_name.str().c_str());
<a name="l00394"></a>00394           }
<a name="l00395"></a>00395           <span class="keywordflow">if</span>( !output_n_out.good() )
<a name="l00396"></a>00396           {
<a name="l00397"></a>00397             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening output file for output &quot;</span> &lt;&lt; n &lt;&lt; std::endl;
<a name="l00398"></a>00398             libmesh_error();
<a name="l00399"></a>00399           }
<a name="l00400"></a>00400           output_n_out.precision(precision_level);
<a name="l00401"></a>00401 
<a name="l00402"></a>00402           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00403"></a>00403           {
<a name="l00404"></a>00404             output_n_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l](j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00405"></a>00405           }
<a name="l00406"></a>00406           output_n_out.close();
<a name="l00407"></a>00407         }
<a name="l00408"></a>00408       }
<a name="l00409"></a>00409     }
<a name="l00410"></a>00410     <span class="keywordflow">else</span>
<a name="l00411"></a>00411     {
<a name="l00412"></a>00412       <span class="comment">// Write out output data to a single file</span>
<a name="l00413"></a>00413       <span class="comment">// If we have a large number of outputs, then the IO is much faster</span>
<a name="l00414"></a>00414       <span class="comment">// if we store the data in a single file.</span>
<a name="l00415"></a>00415       std::ofstream output_out;
<a name="l00416"></a>00416       {
<a name="l00417"></a>00417         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00418"></a>00418         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/outputs.dat&quot;</span>;
<a name="l00419"></a>00419         output_out.open(file_name.str().c_str());
<a name="l00420"></a>00420       }
<a name="l00421"></a>00421       <span class="keywordflow">if</span>( !output_out.good() )
<a name="l00422"></a>00422       {
<a name="l00423"></a>00423         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening outputs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00424"></a>00424         libmesh_error();
<a name="l00425"></a>00425       }
<a name="l00426"></a>00426 
<a name="l00427"></a>00427       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00428"></a>00428       {
<a name="l00429"></a>00429         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00430"></a>00430         {
<a name="l00431"></a>00431           output_out.precision(precision_level);
<a name="l00432"></a>00432 
<a name="l00433"></a>00433           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00434"></a>00434           {
<a name="l00435"></a>00435             output_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l](j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00436"></a>00436           }
<a name="l00437"></a>00437         }
<a name="l00438"></a>00438       }
<a name="l00439"></a>00439       output_out.close();
<a name="l00440"></a>00440     }
<a name="l00441"></a>00441     
<a name="l00442"></a>00442     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444       <span class="comment">// Next write out the inner product matrix</span>
<a name="l00445"></a>00445       std::ofstream RB_inner_product_matrix_out;
<a name="l00446"></a>00446       {
<a name="l00447"></a>00447         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00448"></a>00448         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_inner_product_matrix.dat&quot;</span>;
<a name="l00449"></a>00449         RB_inner_product_matrix_out.open(file_name.str().c_str());
<a name="l00450"></a>00450       }
<a name="l00451"></a>00451       <span class="keywordflow">if</span> ( !RB_inner_product_matrix_out.good() )
<a name="l00452"></a>00452       {
<a name="l00453"></a>00453         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_inner_product_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00454"></a>00454         libmesh_error();
<a name="l00455"></a>00455       }
<a name="l00456"></a>00456       RB_inner_product_matrix_out.precision(precision_level);
<a name="l00457"></a>00457       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00458"></a>00458       {
<a name="l00459"></a>00459         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00460"></a>00460         {
<a name="l00461"></a>00461           RB_inner_product_matrix_out &lt;&lt; std::scientific
<a name="l00462"></a>00462             &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">RB_inner_product_matrix</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00463"></a>00463         }
<a name="l00464"></a>00464       }
<a name="l00465"></a>00465       RB_inner_product_matrix_out.close();
<a name="l00466"></a>00466     }
<a name="l00467"></a>00467 
<a name="l00468"></a>00468     <span class="comment">// Next write out the F_q vectors</span>
<a name="l00469"></a>00469     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00470"></a>00470     {
<a name="l00471"></a>00471       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00472"></a>00472       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_F_&quot;</span>;
<a name="l00473"></a>00473       OSSRealzeroright(file_name,3,0,q_f);
<a name="l00474"></a>00474       file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00475"></a>00475       std::ofstream RB_F_q_f_out(file_name.str().c_str());
<a name="l00476"></a>00476 
<a name="l00477"></a>00477       <span class="keywordflow">if</span> ( !RB_F_q_f_out.good() )
<a name="l00478"></a>00478       {
<a name="l00479"></a>00479         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_F_&quot;</span> &lt;&lt; q_f &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00480"></a>00480         libmesh_error();
<a name="l00481"></a>00481       }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483       RB_F_q_f_out.precision(precision_level);
<a name="l00484"></a>00484       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00485"></a>00485       {
<a name="l00486"></a>00486         RB_F_q_f_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>[q_f](i) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00487"></a>00487       }
<a name="l00488"></a>00488       RB_F_q_f_out.close();
<a name="l00489"></a>00489     }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491     <span class="comment">// Next write out the A_q matrices</span>
<a name="l00492"></a>00492     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00493"></a>00493     {
<a name="l00494"></a>00494       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00495"></a>00495       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_A_&quot;</span>;
<a name="l00496"></a>00496       OSSRealzeroright(file_name,3,0,q_a);
<a name="l00497"></a>00497       file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00498"></a>00498       std::ofstream RB_A_q_a_out(file_name.str().c_str());
<a name="l00499"></a>00499 
<a name="l00500"></a>00500       <span class="keywordflow">if</span> ( !RB_A_q_a_out.good() )
<a name="l00501"></a>00501       {
<a name="l00502"></a>00502         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_A_&quot;</span> &lt;&lt; q_a &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00503"></a>00503         libmesh_error();
<a name="l00504"></a>00504       }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506       RB_A_q_a_out.precision(precision_level);
<a name="l00507"></a>00507       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00508"></a>00508       {
<a name="l00509"></a>00509         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00510"></a>00510         {
<a name="l00511"></a>00511           RB_A_q_a_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>[q_a](i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00512"></a>00512         }
<a name="l00513"></a>00513       }
<a name="l00514"></a>00514       RB_A_q_a_out.close();
<a name="l00515"></a>00515     }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517     <span class="comment">// Next write out Fq_Aq representor norm data</span>
<a name="l00518"></a>00518     std::ofstream RB_Fq_Aq_norms_out;
<a name="l00519"></a>00519     {
<a name="l00520"></a>00520       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00521"></a>00521       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Aq_norms.dat&quot;</span>;
<a name="l00522"></a>00522       RB_Fq_Aq_norms_out.open(file_name.str().c_str());
<a name="l00523"></a>00523     }
<a name="l00524"></a>00524     <span class="keywordflow">if</span> ( !RB_Fq_Aq_norms_out.good() )
<a name="l00525"></a>00525     {
<a name="l00526"></a>00526       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00527"></a>00527       libmesh_error();
<a name="l00528"></a>00528     }
<a name="l00529"></a>00529     RB_Fq_Aq_norms_out.precision(precision_level);
<a name="l00530"></a>00530     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00531"></a>00531     {
<a name="l00532"></a>00532       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00533"></a>00533       {
<a name="l00534"></a>00534         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00535"></a>00535         {
<a name="l00536"></a>00536           RB_Fq_Aq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[q_f][q_a][i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00537"></a>00537         }
<a name="l00538"></a>00538       }
<a name="l00539"></a>00539     }
<a name="l00540"></a>00540     RB_Fq_Aq_norms_out.close();
<a name="l00541"></a>00541 
<a name="l00542"></a>00542     <span class="comment">// Next write out Aq_Aq representor norm data</span>
<a name="l00543"></a>00543     std::ofstream RB_Aq_Aq_norms_out;
<a name="l00544"></a>00544     {
<a name="l00545"></a>00545       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00546"></a>00546       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Aq_norms.dat&quot;</span>;
<a name="l00547"></a>00547       RB_Aq_Aq_norms_out.open(file_name.str().c_str());
<a name="l00548"></a>00548     }
<a name="l00549"></a>00549     <span class="keywordflow">if</span> ( !RB_Aq_Aq_norms_out.good() )
<a name="l00550"></a>00550     {
<a name="l00551"></a>00551       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00552"></a>00552       libmesh_error();
<a name="l00553"></a>00553     }
<a name="l00554"></a>00554     RB_Aq_Aq_norms_out.precision(precision_level);
<a name="l00555"></a>00555     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_a_hat = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()*(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()+1)/2;
<a name="l00556"></a>00556     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_a_hat; i++)
<a name="l00557"></a>00557     {
<a name="l00558"></a>00558       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00559"></a>00559       {
<a name="l00560"></a>00560         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;n_bfs; l++)
<a name="l00561"></a>00561         {
<a name="l00562"></a>00562           RB_Aq_Aq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[i][j][l] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00563"></a>00563         }
<a name="l00564"></a>00564       }
<a name="l00565"></a>00565     }
<a name="l00566"></a>00566     RB_Aq_Aq_norms_out.close();
<a name="l00567"></a>00567 
<a name="l00568"></a>00568     <span class="comment">// Also, write out the greedily selected parameters</span>
<a name="l00569"></a>00569     {
<a name="l00570"></a>00570       std::ofstream greedy_params_out;
<a name="l00571"></a>00571       {
<a name="l00572"></a>00572         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00573"></a>00573         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/greedy_params.dat&quot;</span>;
<a name="l00574"></a>00574         greedy_params_out.open(file_name.str().c_str());
<a name="l00575"></a>00575       }
<a name="l00576"></a>00576       <span class="keywordflow">if</span> ( !greedy_params_out.good() )
<a name="l00577"></a>00577       {
<a name="l00578"></a>00578         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening greedy_params.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00579"></a>00579         libmesh_error();
<a name="l00580"></a>00580       }
<a name="l00581"></a>00581       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>.size(); i++)
<a name="l00582"></a>00582       {
<a name="l00583"></a>00583         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); j++)
<a name="l00584"></a>00584         {
<a name="l00585"></a>00585           greedy_params_out &lt;&lt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00586"></a>00586         }
<a name="l00587"></a>00587         greedy_params_out &lt;&lt; std::endl;
<a name="l00588"></a>00588       }
<a name="l00589"></a>00589       greedy_params_out.close();
<a name="l00590"></a>00590     }
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   }
<a name="l00593"></a>00593   
<a name="l00594"></a>00594   <span class="comment">// Synchronize before moving on</span>
<a name="l00595"></a>00595   <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// Now write out the basis functions if requested</span>
<a name="l00598"></a>00598   <a class="code" href="classlibMesh_1_1RBEvaluation.php#ac51929ca0132ce69ff1348122bf80266">write_out_basis_functions</a>(directory_name, precision_level);
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="comment">// Write out residual representors if requested</span>
<a name="l00601"></a>00601   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l00602"></a>00602   {
<a name="l00603"></a>00603     <span class="comment">// Write out A_q_representors.  These are useful to have when restarting,</span>
<a name="l00604"></a>00604     <span class="comment">// so you don&#39;t have to recompute them all over again.  There should be</span>
<a name="l00605"></a>00605     <span class="comment">// Q_a * this-&gt;get_n_basis_functions() of these.</span>
<a name="l00606"></a>00606     <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a8b5ad508848699cdb22b9b7bc4681094">is_quiet</a>())
<a name="l00607"></a>00607       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the A_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609     <span class="keyword">const</span> std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l00610"></a>00610     <span class="keyword">const</span> std::string residual_representor_suffix =
<a name="l00611"></a>00611       (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l00612"></a>00612     std::ostringstream file_name;
<a name="l00613"></a>00613 
<a name="l00614"></a>00614     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jstop  = this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00615"></a>00615     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jstart = jstop-<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>();
<a name="l00616"></a>00616     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>.size(); ++i)
<a name="l00617"></a>00617       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=jstart; j&lt;jstop; ++j)
<a name="l00618"></a>00618       {
<a name="l00619"></a>00619         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out A_q_representor[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;]...&quot;</span> &lt;&lt; std::endl;
<a name="l00620"></a>00620         libmesh_assert(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j] != NULL);
<a name="l00621"></a>00621 
<a name="l00622"></a>00622         file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l00623"></a>00623         file_name &lt;&lt; residual_representors_dir
<a name="l00624"></a>00624                   &lt;&lt; <span class="stringliteral">&quot;/A_q_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l00625"></a>00625 
<a name="l00626"></a>00626         {
<a name="l00627"></a>00627           <span class="comment">// No need to copy! Use swap instead.</span>
<a name="l00628"></a>00628           <span class="comment">// *solution = *(A_q_representor[i][j]);</span>
<a name="l00629"></a>00629           <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00630"></a>00630 
<a name="l00631"></a>00631           <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> aqr_data(file_name.str(),
<a name="l00632"></a>00632                        <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00633"></a>00633 
<a name="l00634"></a>00634           <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(aqr_data, <span class="keyword">false</span>);
<a name="l00635"></a>00635 
<a name="l00636"></a>00636           <span class="comment">// Synchronize before moving on</span>
<a name="l00637"></a>00637           <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l00638"></a>00638 
<a name="l00639"></a>00639           <span class="comment">// Swap back.</span>
<a name="l00640"></a>00640           <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00641"></a>00641 
<a name="l00642"></a>00642           <span class="comment">// TODO: bzip the resulting file?  See $LIBMESH_DIR/src/mesh/unstructured_mesh.C</span>
<a name="l00643"></a>00643           <span class="comment">// for the system call, be sure to do it only on one processor, etc.</span>
<a name="l00644"></a>00644         }
<a name="l00645"></a>00645       }
<a name="l00646"></a>00646   }
<a name="l00647"></a>00647 
<a name="l00648"></a>00648   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#acfef418793d03a546a2b679f96e17f3f">00651</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#acfef418793d03a546a2b679f96e17f3f">RBEvaluation::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00652"></a>00652 {
<a name="l00653"></a>00653   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l00656"></a>00656   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs;
<a name="l00657"></a>00657   {
<a name="l00658"></a>00658     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00659"></a>00659     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/n_bfs.dat&quot;</span>;
<a name="l00660"></a>00660     std::ifstream n_bfs_in(file_name.str().c_str());
<a name="l00661"></a>00661 
<a name="l00662"></a>00662     <span class="keywordflow">if</span> ( !n_bfs_in.good() )
<a name="l00663"></a>00663     {
<a name="l00664"></a>00664       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening n_bfs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00665"></a>00665       libmesh_error();
<a name="l00666"></a>00666     }
<a name="l00667"></a>00667 
<a name="l00668"></a>00668     n_bfs_in &gt;&gt; n_bfs;
<a name="l00669"></a>00669     n_bfs_in.close();
<a name="l00670"></a>00670   }
<a name="l00671"></a>00671   libmesh_assert( n_bfs &lt;= <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() );
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d4dcf1be97b4f37f2c2bfd65668ec29">multiple_files_for_outputs</a>)
<a name="l00674"></a>00674   {
<a name="l00675"></a>00675     <span class="comment">// Read in output data in multiple files</span>
<a name="l00676"></a>00676     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00677"></a>00677     {
<a name="l00678"></a>00678       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00679"></a>00679       {
<a name="l00680"></a>00680         std::ifstream output_n_in;
<a name="l00681"></a>00681         {
<a name="l00682"></a>00682           <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00683"></a>00683           file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/output_&quot;</span>;
<a name="l00684"></a>00684           OSSRealzeroright(file_name,3,0,n);
<a name="l00685"></a>00685           file_name &lt;&lt; <span class="stringliteral">&quot;_&quot;</span>;
<a name="l00686"></a>00686           OSSRealzeroright(file_name,3,0,q_l);
<a name="l00687"></a>00687           file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00688"></a>00688           output_n_in.open(file_name.str().c_str());
<a name="l00689"></a>00689         }
<a name="l00690"></a>00690         <span class="keywordflow">if</span>( !output_n_in.good() )
<a name="l00691"></a>00691         {
<a name="l00692"></a>00692           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening input file for output &quot;</span> &lt;&lt; n &lt;&lt; std::endl;
<a name="l00693"></a>00693           libmesh_error();
<a name="l00694"></a>00694         }
<a name="l00695"></a>00695 
<a name="l00696"></a>00696         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00697"></a>00697         {
<a name="l00698"></a>00698           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l00699"></a>00699           output_n_in &gt;&gt; value;
<a name="l00700"></a>00700           <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l](j) = value;
<a name="l00701"></a>00701         }
<a name="l00702"></a>00702         output_n_in.close();
<a name="l00703"></a>00703       }
<a name="l00704"></a>00704     }
<a name="l00705"></a>00705   }
<a name="l00706"></a>00706   <span class="keywordflow">else</span>
<a name="l00707"></a>00707   {
<a name="l00708"></a>00708     <span class="comment">// If we have a large number of outputs, then the IO is much faster</span>
<a name="l00709"></a>00709     <span class="comment">// if we store the data in a single file.</span>
<a name="l00710"></a>00710 
<a name="l00711"></a>00711     std::ifstream output_in;
<a name="l00712"></a>00712     {
<a name="l00713"></a>00713       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00714"></a>00714       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/outputs.dat&quot;</span>;
<a name="l00715"></a>00715       output_in.open(file_name.str().c_str());
<a name="l00716"></a>00716     }
<a name="l00717"></a>00717     <span class="keywordflow">if</span>( !output_in.good() )
<a name="l00718"></a>00718     {
<a name="l00719"></a>00719       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening outputs.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00720"></a>00720       libmesh_error();
<a name="l00721"></a>00721     }
<a name="l00722"></a>00722     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00723"></a>00723     {
<a name="l00724"></a>00724       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00725"></a>00725       {
<a name="l00726"></a>00726         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00727"></a>00727         {
<a name="l00728"></a>00728           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00729"></a>00729           output_in &gt;&gt; value;
<a name="l00730"></a>00730           <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l](j) = value;
<a name="l00731"></a>00731         }
<a name="l00732"></a>00732       }
<a name="l00733"></a>00733     }
<a name="l00734"></a>00734     output_in.close();
<a name="l00735"></a>00735   }
<a name="l00736"></a>00736   
<a name="l00737"></a>00737   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>)
<a name="l00738"></a>00738   {
<a name="l00739"></a>00739     <span class="comment">// Next read in the inner product matrix</span>
<a name="l00740"></a>00740     std::ifstream RB_inner_product_matrix_in;
<a name="l00741"></a>00741     {
<a name="l00742"></a>00742       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00743"></a>00743       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_inner_product_matrix.dat&quot;</span>;
<a name="l00744"></a>00744       RB_inner_product_matrix_in.open(file_name.str().c_str());
<a name="l00745"></a>00745     }
<a name="l00746"></a>00746     <span class="keywordflow">if</span> ( !RB_inner_product_matrix_in.good() )
<a name="l00747"></a>00747     {
<a name="l00748"></a>00748       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_inner_product_matrix.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00749"></a>00749       libmesh_error();
<a name="l00750"></a>00750     }
<a name="l00751"></a>00751     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00752"></a>00752     {
<a name="l00753"></a>00753       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00754"></a>00754       {
<a name="l00755"></a>00755         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00756"></a>00756         RB_inner_product_matrix_in &gt;&gt; value;
<a name="l00757"></a>00757         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">RB_inner_product_matrix</a>(i,j) = value;
<a name="l00758"></a>00758       }
<a name="l00759"></a>00759     }
<a name="l00760"></a>00760     RB_inner_product_matrix_in.close();
<a name="l00761"></a>00761   }
<a name="l00762"></a>00762 
<a name="l00763"></a>00763   <span class="comment">// Next read in the F_q vectors</span>
<a name="l00764"></a>00764   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00765"></a>00765   {
<a name="l00766"></a>00766     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00767"></a>00767     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_F_&quot;</span>;
<a name="l00768"></a>00768     OSSRealzeroright(file_name,3,0,q_f);
<a name="l00769"></a>00769     file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00770"></a>00770     std::ifstream RB_F_q_f_in(file_name.str().c_str());
<a name="l00771"></a>00771 
<a name="l00772"></a>00772     <span class="keywordflow">if</span> ( !RB_F_q_f_in.good() )
<a name="l00773"></a>00773     {
<a name="l00774"></a>00774       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_F_&quot;</span> &lt;&lt; q_f &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00775"></a>00775       libmesh_error();
<a name="l00776"></a>00776     }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00779"></a>00779     {
<a name="l00780"></a>00780       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l00781"></a>00781       RB_F_q_f_in &gt;&gt; value;
<a name="l00782"></a>00782       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>[q_f](i) = value;
<a name="l00783"></a>00783     }
<a name="l00784"></a>00784     RB_F_q_f_in.close();
<a name="l00785"></a>00785   }
<a name="l00786"></a>00786 
<a name="l00787"></a>00787   <span class="comment">// Next read in the A_q matrices</span>
<a name="l00788"></a>00788   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00789"></a>00789   {
<a name="l00790"></a>00790     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00791"></a>00791     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_A_&quot;</span>;
<a name="l00792"></a>00792     OSSRealzeroright(file_name,3,0,q_a);
<a name="l00793"></a>00793     file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00794"></a>00794     std::ifstream RB_A_q_a_in(file_name.str().c_str());
<a name="l00795"></a>00795 
<a name="l00796"></a>00796     <span class="keywordflow">if</span> ( !RB_A_q_a_in.good() )
<a name="l00797"></a>00797     {
<a name="l00798"></a>00798       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_A_&quot;</span> &lt;&lt; q_a &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00799"></a>00799       libmesh_error();
<a name="l00800"></a>00800     }
<a name="l00801"></a>00801 
<a name="l00802"></a>00802     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00803"></a>00803     {
<a name="l00804"></a>00804       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00805"></a>00805       {
<a name="l00806"></a>00806         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l00807"></a>00807         RB_A_q_a_in &gt;&gt; value;
<a name="l00808"></a>00808         <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>[q_a](i,j) = value;
<a name="l00809"></a>00809       }
<a name="l00810"></a>00810     }
<a name="l00811"></a>00811     RB_A_q_a_in.close();
<a name="l00812"></a>00812   }
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815   <span class="comment">// Next read in Fq_Aq representor norm data</span>
<a name="l00816"></a>00816   std::ifstream RB_Fq_Aq_norms_in;
<a name="l00817"></a>00817   {
<a name="l00818"></a>00818     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00819"></a>00819     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Aq_norms.dat&quot;</span>;
<a name="l00820"></a>00820     RB_Fq_Aq_norms_in.open(file_name.str().c_str());
<a name="l00821"></a>00821   }
<a name="l00822"></a>00822   <span class="keywordflow">if</span> ( !RB_Fq_Aq_norms_in.good() )
<a name="l00823"></a>00823   {
<a name="l00824"></a>00824     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00825"></a>00825     libmesh_error();
<a name="l00826"></a>00826   }
<a name="l00827"></a>00827   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00828"></a>00828   {
<a name="l00829"></a>00829     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00830"></a>00830     {
<a name="l00831"></a>00831       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00832"></a>00832       {
<a name="l00833"></a>00833         RB_Fq_Aq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[q_f][q_a][i];
<a name="l00834"></a>00834       }
<a name="l00835"></a>00835     }
<a name="l00836"></a>00836   }
<a name="l00837"></a>00837   RB_Fq_Aq_norms_in.close();
<a name="l00838"></a>00838 
<a name="l00839"></a>00839   <span class="comment">// Next read in Aq_Aq representor norm data</span>
<a name="l00840"></a>00840   std::ifstream RB_Aq_Aq_norms_in;
<a name="l00841"></a>00841   {
<a name="l00842"></a>00842     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00843"></a>00843     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Aq_norms.dat&quot;</span>;
<a name="l00844"></a>00844     RB_Aq_Aq_norms_in.open(file_name.str().c_str());
<a name="l00845"></a>00845   }
<a name="l00846"></a>00846   <span class="keywordflow">if</span> ( !RB_Aq_Aq_norms_in.good() )
<a name="l00847"></a>00847   {
<a name="l00848"></a>00848     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Aq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00849"></a>00849     libmesh_error();
<a name="l00850"></a>00850   }
<a name="l00851"></a>00851   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_a_hat = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()*(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>()+1)/2;
<a name="l00852"></a>00852   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_a_hat; i++)
<a name="l00853"></a>00853   {
<a name="l00854"></a>00854     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00855"></a>00855     {
<a name="l00856"></a>00856       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;n_bfs; l++)
<a name="l00857"></a>00857       {
<a name="l00858"></a>00858         RB_Aq_Aq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[i][j][l];
<a name="l00859"></a>00859       }
<a name="l00860"></a>00860     }
<a name="l00861"></a>00861   }
<a name="l00862"></a>00862   RB_Aq_Aq_norms_in.close();
<a name="l00863"></a>00863 
<a name="l00864"></a>00864   <span class="comment">// Resize basis_functions even if we don&#39;t read them in so that</span>
<a name="l00865"></a>00865   <span class="comment">// get_n_bfs() returns the correct value. Initialize the pointers</span>
<a name="l00866"></a>00866   <span class="comment">// to NULL</span>
<a name="l00867"></a>00867   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a8b5f98eea113593a2293fdba35df3f27">set_n_basis_functions</a>(n_bfs);
<a name="l00868"></a>00868   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.size(); i++)
<a name="l00869"></a>00869     {
<a name="l00870"></a>00870       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i])
<a name="l00871"></a>00871       {
<a name="l00872"></a>00872         <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]-&gt;clear();
<a name="l00873"></a>00873         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i];
<a name="l00874"></a>00874       }
<a name="l00875"></a>00875       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i] = NULL;
<a name="l00876"></a>00876     }
<a name="l00877"></a>00877 
<a name="l00878"></a>00878   <span class="comment">// Read in the basis functions if requested.</span>
<a name="l00879"></a>00879   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a0fcde78a629aa11fa5aa23e2ad462f26">read_in_basis_functions</a>(directory_name);
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="comment">// Read in the representor vectors if requested</span>
<a name="l00882"></a>00882   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l00883"></a>00883   {
<a name="l00884"></a>00884     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the A_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l00885"></a>00885 
<a name="l00886"></a>00886     <span class="keyword">const</span> std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l00887"></a>00887     <span class="keyword">const</span> std::string residual_representor_suffix =
<a name="l00888"></a>00888       (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l00889"></a>00889     std::ostringstream file_name;
<a name="l00890"></a>00890     <span class="keyword">struct </span>stat stat_info;
<a name="l00891"></a>00891 
<a name="l00892"></a>00892     <span class="comment">// Read in the A_q representors.  The class makes room for [Q_a][Nmax] of these.  We are going to</span>
<a name="l00893"></a>00893     <span class="comment">// read in [Q_a][this-&gt;get_n_basis_functions()].  FIXME:</span>
<a name="l00894"></a>00894     <span class="comment">// should we be worried about leaks in the locations where we&#39;re about to fill entries?</span>
<a name="l00895"></a>00895     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>.size(); ++i)
<a name="l00896"></a>00896       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i].size(); ++j)
<a name="l00897"></a>00897       {
<a name="l00898"></a>00898         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j] != NULL)
<a name="l00899"></a>00899         {
<a name="l00900"></a>00900           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error, must delete existing A_q_representor before reading in from file.&quot;</span>
<a name="l00901"></a>00901                        &lt;&lt; std::endl;
<a name="l00902"></a>00902           libmesh_error();
<a name="l00903"></a>00903         }
<a name="l00904"></a>00904       }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906     <span class="comment">// Now ready to read them in from file!</span>
<a name="l00907"></a>00907     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>.size(); ++i)
<a name="l00908"></a>00908       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>(); ++j)
<a name="l00909"></a>00909       {
<a name="l00910"></a>00910         file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l00911"></a>00911         file_name &lt;&lt; residual_representors_dir
<a name="l00912"></a>00912                   &lt;&lt; <span class="stringliteral">&quot;/A_q_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l00913"></a>00913 
<a name="l00914"></a>00914         <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l00915"></a>00915         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00916"></a>00916         {
<a name="l00917"></a>00917           <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l00918"></a>00918 
<a name="l00919"></a>00919           <span class="keywordflow">if</span> (stat_result != 0)
<a name="l00920"></a>00920           {
<a name="l00921"></a>00921             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l00922"></a>00922             libmesh_error();
<a name="l00923"></a>00923           }
<a name="l00924"></a>00924         }
<a name="l00925"></a>00925 
<a name="l00926"></a>00926         <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> aqr_data(file_name.str(),
<a name="l00927"></a>00927         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00928"></a>00928 
<a name="l00929"></a>00929         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(aqr_data, <span class="keyword">false</span>);
<a name="l00930"></a>00930 
<a name="l00931"></a>00931         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00932"></a>00932         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j]-&gt;init (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00933"></a>00933                                      <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00934"></a>00934 
<a name="l00935"></a>00935         <span class="comment">// No need to copy, just swap</span>
<a name="l00936"></a>00936         <span class="comment">//*A_q_representor[i][j] = *solution;</span>
<a name="l00937"></a>00937         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00938"></a>00938       }
<a name="l00939"></a>00939   } <span class="comment">// end if (store_representors)</span>
<a name="l00940"></a>00940 
<a name="l00941"></a>00941   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;RBEvaluation&quot;</span>);
<a name="l00942"></a>00942 }
<a name="l00943"></a>00943 
<a name="l00944"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#ac51929ca0132ce69ff1348122bf80266">00944</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#ac51929ca0132ce69ff1348122bf80266">RBEvaluation::write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name,
<a name="l00945"></a>00945                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00946"></a>00946 {
<a name="l00947"></a>00947   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>)
<a name="l00948"></a>00948   {
<a name="l00949"></a>00949     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l00950"></a>00950 
<a name="l00951"></a>00951     std::ostringstream file_name;
<a name="l00952"></a>00952     <span class="keyword">const</span> std::string basis_function_suffix = (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l00953"></a>00953 
<a name="l00954"></a>00954     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/bf_header&quot;</span> &lt;&lt; basis_function_suffix;
<a name="l00955"></a>00955     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> header_data(file_name.str(),
<a name="l00956"></a>00956                     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00957"></a>00957     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ab85bb7019eaac1ceb8603975da8325ab">write_header</a>(header_data, <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">false</span>);
<a name="l00958"></a>00958 
<a name="l00959"></a>00959     <span class="comment">// Use System::write_serialized_data to write out the basis functions</span>
<a name="l00960"></a>00960     <span class="comment">// by copying them into this-&gt;solution one at a time.</span>
<a name="l00961"></a>00961     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.size(); i++)
<a name="l00962"></a>00962     {
<a name="l00963"></a>00963       <span class="comment">// No need to copy, just swap</span>
<a name="l00964"></a>00964       <span class="comment">// *solution = *basis_functions[i];</span>
<a name="l00965"></a>00965       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00966"></a>00966 
<a name="l00967"></a>00967       file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string</span>
<a name="l00968"></a>00968       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/bf&quot;</span> &lt;&lt; i &lt;&lt; basis_function_suffix;
<a name="l00969"></a>00969 
<a name="l00970"></a>00970       <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> bf_data(file_name.str(),
<a name="l00971"></a>00971                   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00972"></a>00972 
<a name="l00973"></a>00973       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(bf_data, <span class="keyword">false</span>);
<a name="l00974"></a>00974 
<a name="l00975"></a>00975       <span class="comment">// Synchronize before moving on</span>
<a name="l00976"></a>00976       <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l00977"></a>00977 
<a name="l00978"></a>00978       <span class="comment">// Swap back</span>
<a name="l00979"></a>00979       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00980"></a>00980     }
<a name="l00981"></a>00981   }
<a name="l00982"></a>00982 }
<a name="l00983"></a>00983 
<a name="l00984"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a0fcde78a629aa11fa5aa23e2ad462f26">00984</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a0fcde78a629aa11fa5aa23e2ad462f26">RBEvaluation::read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00985"></a>00985 {
<a name="l00986"></a>00986   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>)
<a name="l00987"></a>00987   {
<a name="l00988"></a>00988     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l00989"></a>00989 
<a name="l00990"></a>00990     std::ostringstream file_name;
<a name="l00991"></a>00991     <span class="keyword">const</span> std::string basis_function_suffix = (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l00992"></a>00992     <span class="keyword">struct </span>stat stat_info;
<a name="l00993"></a>00993 
<a name="l00994"></a>00994     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/bf_header&quot;</span> &lt;&lt; basis_function_suffix;
<a name="l00995"></a>00995     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> header_data(file_name.str(),
<a name="l00996"></a>00996                     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00997"></a>00997     <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">read_header</a>(header_data, <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">false</span>);
<a name="l00998"></a>00998 
<a name="l00999"></a>00999     <span class="comment">// Use System::read_serialized_data to read in the basis functions</span>
<a name="l01000"></a>01000     <span class="comment">// into this-&gt;solution and then swap with the appropriate</span>
<a name="l01001"></a>01001     <span class="comment">// of basis function.</span>
<a name="l01002"></a>01002     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.size(); i++)
<a name="l01003"></a>01003     {
<a name="l01004"></a>01004       file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string</span>
<a name="l01005"></a>01005       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/bf&quot;</span> &lt;&lt; i &lt;&lt; basis_function_suffix;
<a name="l01006"></a>01006 
<a name="l01007"></a>01007       <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l01008"></a>01008       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01009"></a>01009         {
<a name="l01010"></a>01010           <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l01011"></a>01011 
<a name="l01012"></a>01012           <span class="keywordflow">if</span> (stat_result != 0)
<a name="l01013"></a>01013             {
<a name="l01014"></a>01014               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l01015"></a>01015               libmesh_error();
<a name="l01016"></a>01016             }
<a name="l01017"></a>01017         }
<a name="l01018"></a>01018 
<a name="l01019"></a>01019       <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> bf_data(file_name.str(),
<a name="l01020"></a>01020                   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l01021"></a>01021 
<a name="l01022"></a>01022       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(bf_data, <span class="keyword">false</span>);
<a name="l01023"></a>01023 
<a name="l01024"></a>01024       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l01025"></a>01025       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]-&gt;init (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01026"></a>01026 
<a name="l01027"></a>01027       <span class="comment">// No need to copy, just swap</span>
<a name="l01028"></a>01028       <span class="comment">// *basis_functions[i] = *solution;</span>
<a name="l01029"></a>01029       <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>[i]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01030"></a>01030     }
<a name="l01031"></a>01031 
<a name="l01032"></a>01032     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished reading in the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l01033"></a>01033   }
<a name="l01034"></a>01034 }
<a name="l01035"></a>01035 
<a name="l01036"></a>01036 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
