<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_evaluation.h</div>  </div>
</div>
<div class="contents">
<a href="rb__evaluation_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_evaluation_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_evaluation_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">class </span>RBSystem;
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00032"></a>00032         
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// RBEvaluation class definition</span>
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;RBEvaluation&gt;
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a21af67e6f842c9978c4fc21b96855de5">RBEvaluation</a> (<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_sys_in);
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#ac7438022dbbe8f5704410e02c8b81f96">~RBEvaluation</a> ();
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">clear</a>();
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a1522bd9902fa9e97b9236532cd09bef8">initialize</a>();
<a name="l00069"></a>00069   
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aca02e1bf8920dae0745cd88eed373a32">resize_RB_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax);
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a02ab98754dd78590703db930f306b07e">get_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00082"></a>00082 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a3e451b7c989bc337a99936a07b3fedf6">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00093"></a>00093 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa8227f32dafcbf7f1ca8b56d7c26a67a">compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">00103</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.size(); }
<a name="l00104"></a>00104 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a8b5f98eea113593a2293fdba35df3f27">00109</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a8b5f98eea113593a2293fdba35df3f27">set_n_basis_functions</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs) { <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.resize(n_bfs); }
<a name="l00110"></a>00110   
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a93407d78dbbdb6a6b79e292eb2f5c41d">clear_riesz_representors</a>();
<a name="l00117"></a>00117 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a00e6ee9a21d2c3a4f3db3efb44582dce">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#acfef418793d03a546a2b679f96e17f3f">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#ac51929ca0132ce69ff1348122bf80266">write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level);
<a name="l00135"></a>00135   
<a name="l00139"></a>00139   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a0fcde78a629aa11fa5aa23e2ad462f26">read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name);
<a name="l00140"></a>00140   
<a name="l00141"></a>00141   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">00146</a>   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>;
<a name="l00147"></a>00147 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">00152</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>;
<a name="l00153"></a>00153 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">00158</a>   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>;
<a name="l00159"></a>00159 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">00166</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">RB_inner_product_matrix</a>;
<a name="l00167"></a>00167 
<a name="l00171"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">00171</a>   std::vector&lt; DenseMatrix&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>;
<a name="l00172"></a>00172 
<a name="l00176"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">00176</a>   std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>;
<a name="l00177"></a>00177 
<a name="l00181"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">00181</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>;
<a name="l00182"></a>00182 
<a name="l00186"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">00186</a>   std::vector&lt; std::vector&lt; DenseVector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>;
<a name="l00187"></a>00187 
<a name="l00192"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a52ae294af449d6de30d3d86e5f8f1193">00192</a>   std::vector&lt; Number &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a52ae294af449d6de30d3d86e5f8f1193">RB_outputs</a>;
<a name="l00193"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a6e740bfd0e45ec06a1306f73960fdb42">00193</a>   std::vector&lt; Real &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a6e740bfd0e45ec06a1306f73960fdb42">RB_output_error_bounds</a>;
<a name="l00194"></a>00194 
<a name="l00202"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">00202</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>;
<a name="l00203"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">00203</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>;
<a name="l00204"></a>00204 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">00211</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>;
<a name="l00212"></a>00212 
<a name="l00219"></a><a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d4dcf1be97b4f37f2c2bfd65668ec29">00219</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d4dcf1be97b4f37f2c2bfd65668ec29">multiple_files_for_outputs</a>;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 };
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
