<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_param_subdomain_node.C</div>  </div>
</div>
<div class="contents">
<a href="rb__param__subdomain__node_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="rb__param__subdomain__node_8h.php">rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="rb__param__subdomain__tree_8h.php">rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ace94a4eb96d424ad0073cab2240181e6">00032</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ace94a4eb96d424ad0073cab2240181e6">RBParamSubdomainNode::RBParamSubdomainNode</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">RBParamSubdomainTree</a>&amp; tree_in,
<a name="l00033"></a>00033                                            <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; anchor_in)
<a name="l00034"></a>00034         : left_child(NULL),
<a name="l00035"></a>00035         right_child(NULL),
<a name="l00036"></a>00036         _tree(tree_in),
<a name="l00037"></a>00037         _rb_system(tree_in._rb_system),
<a name="l00038"></a>00038         anchor(anchor_in),
<a name="l00039"></a>00039         model_number(-1),
<a name="l00040"></a>00040         training_set_initialized(false)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042     libmesh_assert( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a319a3958f2e480d5349d2cf3f53572c9">get_n_params</a>() != 0);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044     <span class="comment">// Clear the training set to begin with</span>
<a name="l00045"></a>00045     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.resize(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a319a3958f2e480d5349d2cf3f53572c9">get_n_params</a>());
<a name="l00046"></a>00046     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a319a3958f2e480d5349d2cf3f53572c9">get_n_params</a>(); i++)
<a name="l00047"></a>00047         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].clear();
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a4f1dc7a3d39e3587bdb31433fc61440d">00050</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a4f1dc7a3d39e3587bdb31433fc61440d">RBParamSubdomainNode::~RBParamSubdomainNode</a>()
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>)
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>;
<a name="l00055"></a>00055         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> = NULL;
<a name="l00056"></a>00056     }
<a name="l00057"></a>00057     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>)
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>;
<a name="l00060"></a>00060         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> = NULL;
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aff93a51c0784491f0c21df4ed46c3c92">00064</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aff93a51c0784491f0c21df4ed46c3c92">RBParamSubdomainNode::operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a>&amp; node)<span class="keyword"> const</span>
<a name="l00065"></a>00065 <span class="keyword"></span>{
<a name="l00066"></a>00066     START_LOG(<span class="stringliteral">&quot;operator==&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="comment">// We consider two RBParamSubdomainNodes to be equal if they have the</span>
<a name="l00069"></a>00069     <span class="comment">// same model number, anchor and training set</span>
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>() == node.<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>())
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073         <span class="keywordtype">bool</span> equal = <span class="keyword">true</span>;
<a name="l00074"></a>00074         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a319a3958f2e480d5349d2cf3f53572c9">get_n_params</a>(); i++)
<a name="l00075"></a>00075             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>(); j++)
<a name="l00076"></a>00076                 equal = equal &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i][j] == node.<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i][j]);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078         STOP_LOG(<span class="stringliteral">&quot;operator==&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00079"></a>00079         <span class="keywordflow">return</span> equal &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">model_number</a> == node.<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">model_number</a>) &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a> == node.<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>);
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     STOP_LOG(<span class="stringliteral">&quot;operator==&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">00087</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">RBParamSubdomainNode::n_local_training_parameters</a>()<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[0].size();
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">00092</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">RBParamSubdomainNode::n_global_training_parameters</a>()<span class="keyword"> const</span>
<a name="l00093"></a>00093 <span class="keyword"></span>{
<a name="l00094"></a>00094     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_training_set_size = this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>();
<a name="l00095"></a>00095     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(global_training_set_size);
<a name="l00096"></a>00096     <span class="keywordflow">return</span> global_training_set_size;
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">00099</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">RBParamSubdomainNode::hp_greedy</a>()
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">clear</a>();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     <span class="comment">// Load the (full or subsampled) training set</span>
<a name="l00104"></a>00104     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a> &gt;= <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>())
<a name="l00105"></a>00105     {
<a name="l00106"></a>00106       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">load_training_set</a>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a> );
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108     <span class="keywordflow">else</span>
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110       std::vector&lt; std::vector&lt;Number&gt; &gt; subsampled_training_set = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a1732ae1e3a47c8313bf5884ba3f296f5">get_subsampled_training_set</a>();
<a name="l00111"></a>00111       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">load_training_set</a>( subsampled_training_set );
<a name="l00112"></a>00112     }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a> );
<a name="l00115"></a>00115     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="comment">// Save _rb_system&#39;s Nmax and set Nmax to N_bar</span>
<a name="l00118"></a>00118     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> initial_Nmax = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>();
<a name="l00119"></a>00119     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">set_Nmax</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a>);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> greedy_bound = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">train_reduced_basis</a>();
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="comment">// Restore _rb_system&#39;s Nmax to initial_Nmax after h-stage greedy</span>
<a name="l00124"></a>00124     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">set_Nmax</a>(initial_Nmax);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     <span class="keywordflow">if</span> ( greedy_bound &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>) <span class="comment">// recursive call to hp_greedy</span>
<a name="l00128"></a>00128     {
<a name="l00129"></a>00129         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;h tolerance not satisfied, splitting subdomain...&quot;</span> &lt;&lt; std::endl;
<a name="l00130"></a>00130         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ab2b4a7a494c63508a5f03b0483b51fd0">split_this_subdomain</a>(<span class="keyword">true</span>);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00133"></a>00133         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00134"></a>00134     }
<a name="l00135"></a>00135     <span class="keywordflow">else</span> <span class="comment">// terminate branch, populate the model with standard p-type, write out subelement data</span>
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;h tolerance satisfied, performing p-refinement...&quot;</span> &lt;&lt; std::endl;
<a name="l00138"></a>00138         greedy_bound = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a5f10b34e5290ff4d04f710d70b10fe54">perform_p_stage</a>(greedy_bound);
<a name="l00139"></a>00139         <span class="keywordflow">if</span> (greedy_bound &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>)
<a name="l00140"></a>00140         {
<a name="l00141"></a>00141             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;p tolerance not satisfied, splitting subdomain...&quot;</span> &lt;&lt; std::endl;
<a name="l00142"></a>00142             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ab2b4a7a494c63508a5f03b0483b51fd0">split_this_subdomain</a>(<span class="keyword">false</span>);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00145"></a>00145             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147         <span class="keywordflow">else</span>
<a name="l00148"></a>00148         {
<a name="l00149"></a>00149             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;p tolerance satisfied, subdomain &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a> &lt;&lt; <span class="stringliteral">&quot; is a leaf node...&quot;</span> &lt;&lt; std::endl;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151             <span class="comment">// Finally, write out the data for this subdomain</span>
<a name="l00152"></a>00152             this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">model_number</a> = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>;
<a name="l00153"></a>00153             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a107717d12e7894851b2d5f113628ad58">write_subdomain_data_to_files</a>();
<a name="l00154"></a>00154             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>++;
<a name="l00155"></a>00155         }
<a name="l00156"></a>00156     }
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ab2b4a7a494c63508a5f03b0483b51fd0">00159</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ab2b4a7a494c63508a5f03b0483b51fd0">RBParamSubdomainNode::split_this_subdomain</a>(<span class="keywordtype">bool</span> )
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161     START_LOG(<span class="stringliteral">&quot;split_this_subdomain()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">add_child</a>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(0), <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">RBParamSubdomainNode::LEFT</a>);
<a name="l00164"></a>00164     this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">add_child</a>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(1), <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RBParamSubdomainNode::RIGHT</a>);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166     <span class="comment">// Set the distance_between_anchors member of the children</span>
<a name="l00167"></a>00167     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a> = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a> = 
<a name="l00168"></a>00168       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac4a7527bf06c07b099254a5445e86c79">distance</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     <span class="comment">// Make sure that the anchor points of the children are different</span>
<a name="l00171"></a>00171     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a> == 0.)
<a name="l00172"></a>00172     {
<a name="l00173"></a>00173         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Anchor points for children are equal!&quot;</span>
<a name="l00174"></a>00174                      &lt;&lt; std::endl;
<a name="l00175"></a>00175         libmesh_error();
<a name="l00176"></a>00176     }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7aae71ba487f206ae1e7ffae1696cf76">initialize_child_training_sets</a>();
<a name="l00179"></a>00179 
<a name="l00180"></a>00180     STOP_LOG(<span class="stringliteral">&quot;split_this_subdomain()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00181"></a>00181 }
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a5f10b34e5290ff4d04f710d70b10fe54">00183</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a5f10b34e5290ff4d04f710d70b10fe54">RBParamSubdomainNode::perform_p_stage</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> greedy_bound)
<a name="l00184"></a>00184 {
<a name="l00185"></a>00185     START_LOG(<span class="stringliteral">&quot;perform_p_stage()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     <span class="comment">// Continue the greedy process on this subdomain, i.e.</span>
<a name="l00188"></a>00188     <span class="comment">// we do not discard the basis functions generated for</span>
<a name="l00189"></a>00189     <span class="comment">// this subdomain in the h-refinement phase</span>
<a name="l00190"></a>00190     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192     <span class="comment">// Checking if p-tol is already satisfied or Nmax has been reached</span>
<a name="l00193"></a>00193     <span class="comment">// if not do another (standard) greedy</span>
<a name="l00194"></a>00194     <span class="keywordflow">if</span> ( (greedy_bound &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>) || (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>()) )
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196         greedy_bound = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">train_reduced_basis</a>();
<a name="l00197"></a>00197     }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     STOP_LOG(<span class="stringliteral">&quot;perform_p_stage()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     <span class="keywordflow">return</span> greedy_bound;
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a107717d12e7894851b2d5f113628ad58">00204</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a107717d12e7894851b2d5f113628ad58">RBParamSubdomainNode::write_subdomain_data_to_files</a>()
<a name="l00205"></a>00205 {
<a name="l00206"></a>00206     START_LOG(<span class="stringliteral">&quot;write_subdomain_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out RB data for leaf subdomain &quot;</span>
<a name="l00209"></a>00209                  &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a> &lt;&lt; std::endl;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     std::stringstream dir_name_stream;
<a name="l00212"></a>00212     dir_name_stream &lt;&lt; <span class="stringliteral">&quot;offline_data_hp&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>;
<a name="l00213"></a>00213     <span class="keyword">const</span> std::string&amp; directory_name = dir_name_stream.str();
<a name="l00214"></a>00214     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a60572ab72b024edf5e605d09f8a0ff73">write_offline_data_to_files</a>(directory_name);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     STOP_LOG(<span class="stringliteral">&quot;write_subdomain_data_to_files()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">00219</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">RBParamSubdomainNode::add_child</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_anchor, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18d">Child</a> c)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221     START_LOG(<span class="stringliteral">&quot;add_child()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223     <span class="keywordflow">if</span> (c == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">LEFT</a>)
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> != NULL)
<a name="l00226"></a>00226         {
<a name="l00227"></a>00227             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child already exists!&quot;</span>
<a name="l00228"></a>00228                          &lt;&lt; std::endl;
<a name="l00229"></a>00229             libmesh_error();
<a name="l00230"></a>00230         }
<a name="l00231"></a>00231         <span class="keywordflow">else</span>
<a name="l00232"></a>00232         {
<a name="l00233"></a>00233             <span class="comment">// Allocate a new child node</span>
<a name="l00234"></a>00234             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ace94a4eb96d424ad0073cab2240181e6">RBParamSubdomainNode</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>, new_anchor);
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236     }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238     <span class="keywordflow">if</span> (c == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RIGHT</a>)
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> != NULL)
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child already exists!&quot;</span>
<a name="l00243"></a>00243                          &lt;&lt; std::endl;
<a name="l00244"></a>00244             libmesh_error();
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246         <span class="keywordflow">else</span>
<a name="l00247"></a>00247         {
<a name="l00248"></a>00248             <span class="comment">// Allocate a new child node</span>
<a name="l00249"></a>00249             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ace94a4eb96d424ad0073cab2240181e6">RBParamSubdomainNode</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>, new_anchor);
<a name="l00250"></a>00250         }
<a name="l00251"></a>00251     }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253     STOP_LOG(<span class="stringliteral">&quot;add_child()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a606dddf9b3c7dd9f8b682072d53385fa">00257</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a606dddf9b3c7dd9f8b682072d53385fa">RBParamSubdomainNode::refine_training_set</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_local_training_set_size)
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259     START_LOG(<span class="stringliteral">&quot;refine_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261     <span class="comment">// seed the random number generator with the system time</span>
<a name="l00262"></a>00262     <span class="comment">// and the processor ID so that the seed is different</span>
<a name="l00263"></a>00263     <span class="comment">// on different processors</span>
<a name="l00264"></a>00264     std::srand((<span class="keywordtype">unsigned</span>)( std::time(0)*(1+<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) ));
<a name="l00265"></a>00265 
<a name="l00266"></a>00266     <span class="comment">// Use a deterministic seed, useful for testing purposes so that</span>
<a name="l00267"></a>00267     <span class="comment">// we obtain reproducible training sets</span>
<a name="l00268"></a>00268     <span class="comment">//std::srand((unsigned)( (1+libMesh::processor_id()) ));</span>
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     std::vector&lt;Real&gt; random_point(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size());
<a name="l00271"></a>00271     std::vector&lt; std::vector&lt;Real&gt; &gt; corners = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a0fadd79316fc806cc748720c235fd179">get_training_bbox</a>();
<a name="l00272"></a>00272 
<a name="l00273"></a>00273     <span class="keywordflow">while</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>() &lt; new_local_training_set_size)
<a name="l00274"></a>00274     {
<a name="l00275"></a>00275         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ran;
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); i++)
<a name="l00278"></a>00278         {
<a name="l00279"></a>00279             ran = ((double)std::rand())/RAND_MAX; <span class="comment">// in range [0,1]</span>
<a name="l00280"></a>00280             random_point[i] = corners[0][i] + (corners[1][i]-corners[0][i])*ran;
<a name="l00281"></a>00281         }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283         <span class="keywordflow">if</span> ( (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6328438a9f686ff5c043f34384ab02c6">determine_subdomain</a>(random_point)) == <span class="keyword">this</span> )
<a name="l00284"></a>00284         {
<a name="l00285"></a>00285             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); i++)
<a name="l00286"></a>00286                 <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].push_back(random_point[i]);
<a name="l00287"></a>00287         }
<a name="l00288"></a>00288     }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290     STOP_LOG(<span class="stringliteral">&quot;refine_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00291"></a>00291 }
<a name="l00292"></a>00292 
<a name="l00293"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7aae71ba487f206ae1e7ffae1696cf76">00293</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7aae71ba487f206ae1e7ffae1696cf76">RBParamSubdomainNode::initialize_child_training_sets</a>()
<a name="l00294"></a>00294 {
<a name="l00295"></a>00295     START_LOG(<span class="stringliteral">&quot;initialize_child_training_sets()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00296"></a>00296     
<a name="l00297"></a>00297     <span class="keywordflow">if</span> ( (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> == NULL) || (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> == NULL) )
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Children cannot be NULL in initialize_child_training_sets().&quot;</span>
<a name="l00300"></a>00300                      &lt;&lt; std::endl;
<a name="l00301"></a>00301         libmesh_error();
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304     libmesh_assert(!<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">training_set_initialized</a> &amp;&amp;
<a name="l00305"></a>00305                    !<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">training_set_initialized</a>);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.resize(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size());
<a name="l00308"></a>00308     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.resize(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size());
<a name="l00309"></a>00309 
<a name="l00310"></a>00310     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); i++)
<a name="l00311"></a>00311     {
<a name="l00312"></a>00312         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].clear();
<a name="l00313"></a>00313         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].clear();
<a name="l00314"></a>00314     }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316     <span class="comment">// Split this training set among the children</span>
<a name="l00317"></a>00317     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>(); i++)
<a name="l00318"></a>00318     {
<a name="l00319"></a>00319         std::vector&lt;Real&gt; next_param = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a9ad31eaec9f671ef759bb6ae39a2651d">get_local_training_parameter</a>(i);
<a name="l00320"></a>00320         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> left_dist  = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">dist_from_anchor</a>(next_param);
<a name="l00321"></a>00321         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> right_dist = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">dist_from_anchor</a>(next_param);
<a name="l00322"></a>00322         <span class="keywordflow">if</span> ( left_dist &lt;= right_dist )
<a name="l00323"></a>00323         {
<a name="l00324"></a>00324             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;next_param.size(); i++)
<a name="l00325"></a>00325                 <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].push_back(next_param[i]);
<a name="l00326"></a>00326         }
<a name="l00327"></a>00327         <span class="keywordflow">else</span>
<a name="l00328"></a>00328         {
<a name="l00329"></a>00329             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;next_param.size(); i++)
<a name="l00330"></a>00330                 <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].push_back(next_param[i]);
<a name="l00331"></a>00331         }
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334     <span class="comment">// Make sure that each child has at least one training point</span>
<a name="l00335"></a>00335     <span class="keywordflow">if</span> ( (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>()  == 0) ||
<a name="l00336"></a>00336          (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>() == 0) )
<a name="l00337"></a>00337     {
<a name="l00338"></a>00338         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child training set is empty after initialization.&quot;</span> &lt;&lt; std::endl
<a name="l00339"></a>00339                      &lt;&lt; <span class="stringliteral">&quot;At least the training set should contain the anchor point!&quot;</span> &lt;&lt; std::endl;
<a name="l00340"></a>00340         libmesh_error();
<a name="l00341"></a>00341     }
<a name="l00342"></a>00342     
<a name="l00343"></a>00343     <span class="comment">// Calculate the target number of local training samples. The global target</span>
<a name="l00344"></a>00344     <span class="comment">// is min(_tree.n_subsampled_training_points, n_global_training_parameters())</span>
<a name="l00345"></a>00345     <span class="comment">// since we just want to ignore n_subsampled_training_points if it is larger</span>
<a name="l00346"></a>00346     <span class="comment">// than the original training set</span>
<a name="l00347"></a>00347     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> target_n_local_training_samples;
<a name="l00348"></a>00348     <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a> &gt;= <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>() )
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350         target_n_local_training_samples = this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>();
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352     <span class="keywordflow">else</span>
<a name="l00353"></a>00353     {
<a name="l00354"></a>00354         <span class="comment">// Calculate the minimum number of training points that this processor must</span>
<a name="l00355"></a>00355         <span class="comment">// contain in order for this subdomain to have at least _tree.n_subsampled_training_points</span>
<a name="l00356"></a>00356         <span class="comment">// in total</span>
<a name="l00357"></a>00357         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> quotient  = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a>/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00358"></a>00358         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> remainder = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a>%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00359"></a>00359         target_n_local_training_samples =
<a name="l00360"></a>00360           (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt; remainder) ? (quotient + 1) : quotient;
<a name="l00361"></a>00361     }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363     <span class="comment">// Finally, perform the actual training set refinement</span>
<a name="l00364"></a>00364     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>() &lt; target_n_local_training_samples)
<a name="l00365"></a>00365     {
<a name="l00366"></a>00366         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a606dddf9b3c7dd9f8b682072d53385fa">refine_training_set</a>(target_n_local_training_samples);
<a name="l00367"></a>00367     }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>() &lt; target_n_local_training_samples)
<a name="l00370"></a>00370     {
<a name="l00371"></a>00371         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a606dddf9b3c7dd9f8b682072d53385fa">refine_training_set</a>(target_n_local_training_samples);
<a name="l00372"></a>00372     }
<a name="l00373"></a>00373     
<a name="l00374"></a>00374     <span class="comment">// possibly clear the parent node&#39;s training set once the children</span>
<a name="l00375"></a>00375     <span class="comment">// sets have been initialized</span>
<a name="l00376"></a>00376     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6a307c13af6c2d10ce35cffeab17499c">clear_training_sets_during_hp</a>)
<a name="l00377"></a>00377     {
<a name="l00378"></a>00378         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a3a7e06e533808d457c7b7cff1409aaf3">clear_training_set</a>();
<a name="l00379"></a>00379     }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">training_set_initialized</a>  = <span class="keyword">true</span>;
<a name="l00382"></a>00382     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">training_set_initialized</a> = <span class="keyword">true</span>;
<a name="l00383"></a>00383 
<a name="l00384"></a>00384     STOP_LOG(<span class="stringliteral">&quot;initialize_child_training_sets()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad8e5b2eefd00651ce38d3d88bd615137">00389</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad8e5b2eefd00651ce38d3d88bd615137">RBParamSubdomainNode::copy_training_set_from_system</a>()
<a name="l00390"></a>00390 {
<a name="l00391"></a>00391     START_LOG(<span class="stringliteral">&quot;copy_training_set_from_system()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00392"></a>00392     
<a name="l00393"></a>00393     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.resize(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>());
<a name="l00394"></a>00394 
<a name="l00395"></a>00395     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size(); i++)
<a name="l00396"></a>00396     {
<a name="l00397"></a>00397       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].clear();
<a name="l00398"></a>00398       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i]-&gt;first_local_index();
<a name="l00399"></a>00399                         j&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i]-&gt;last_local_index();
<a name="l00400"></a>00400                         j++)
<a name="l00401"></a>00401         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i].push_back( (*<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a299d5b623e51dd672d8b4d183a68bce8">training_parameters</a>[i])(j) );
<a name="l00402"></a>00402     }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">training_set_initialized</a> = <span class="keyword">true</span>;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406     STOP_LOG(<span class="stringliteral">&quot;copy_training_set_from_system()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac4a7527bf06c07b099254a5445e86c79">00409</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac4a7527bf06c07b099254a5445e86c79">RBParamSubdomainNode::distance</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; p1, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; p2)<span class="keyword"> const</span>
<a name="l00410"></a>00410 <span class="keyword"></span>{
<a name="l00411"></a>00411     START_LOG(<span class="stringliteral">&quot;distance()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00412"></a>00412     
<a name="l00413"></a>00413     <span class="keywordflow">if</span> (p1.size() != p2.size())
<a name="l00414"></a>00414     {
<a name="l00415"></a>00415         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Input vectors must have the same size in RBParamSubdomain::distance.&quot;</span>
<a name="l00416"></a>00416                      &lt;&lt; std::endl;
<a name="l00417"></a>00417         libmesh_error();
<a name="l00418"></a>00418     }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a> = 0.;
<a name="l00421"></a>00421     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;p1.size(); i++)
<a name="l00422"></a>00422     {
<a name="l00423"></a>00423         <span class="comment">// Map anchor[i] and new_param[i] to (0,1) before computing distance</span>
<a name="l00424"></a>00424         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jacobian = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">get_parameter_max</a>(i) - <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i);
<a name="l00425"></a>00425         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p1_mapped = (p1[i] - <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i))/jacobian;
<a name="l00426"></a>00426         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p2_mapped = (p2[i] - <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i))/jacobian;
<a name="l00427"></a>00427         sum += <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(p1_mapped - p2_mapped);
<a name="l00428"></a>00428     }
<a name="l00429"></a>00429     
<a name="l00430"></a>00430     STOP_LOG(<span class="stringliteral">&quot;distance()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00431"></a>00431 
<a name="l00432"></a>00432     <span class="keywordflow">return</span> std::sqrt(sum);
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">00435</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">RBParamSubdomainNode::dist_from_anchor</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_param)<span class="keyword"> const</span>
<a name="l00436"></a>00436 <span class="keyword"></span>{
<a name="l00437"></a>00437     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac4a7527bf06c07b099254a5445e86c79">distance</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>, new_param);
<a name="l00438"></a>00438 }
<a name="l00439"></a>00439 
<a name="l00440"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a9ad31eaec9f671ef759bb6ae39a2651d">00440</a> std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a9ad31eaec9f671ef759bb6ae39a2651d">RBParamSubdomainNode::get_local_training_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00441"></a>00441 {
<a name="l00442"></a>00442     START_LOG(<span class="stringliteral">&quot;get_local_training_parameter()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00443"></a>00443     
<a name="l00444"></a>00444     <span class="keywordflow">if</span> (i &gt;= <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>())
<a name="l00445"></a>00445     {
<a name="l00446"></a>00446         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Argument is too large in get_training_parameter.&quot;</span>
<a name="l00447"></a>00447                      &lt;&lt; std::endl;
<a name="l00448"></a>00448     }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450     std::vector&lt;Real&gt; param(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size());
<a name="l00451"></a>00451     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;param.size(); j++)
<a name="l00452"></a>00452         param[j] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[j][i]);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454     STOP_LOG(<span class="stringliteral">&quot;get_local_training_parameter()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00455"></a>00455 
<a name="l00456"></a>00456     <span class="keywordflow">return</span> param;
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
<a name="l00459"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a0fadd79316fc806cc748720c235fd179">00459</a> std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a0fadd79316fc806cc748720c235fd179">RBParamSubdomainNode::get_training_bbox</a>()
<a name="l00460"></a>00460 {
<a name="l00461"></a>00461     START_LOG(<span class="stringliteral">&quot;get_training_bbox()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00462"></a>00462 
<a name="l00463"></a>00463     std::vector &lt;std::vector&lt;Real&gt; &gt; corner_values(2);
<a name="l00464"></a>00464     corner_values[0].resize(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size());
<a name="l00465"></a>00465     corner_values[1].resize(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size());
<a name="l00466"></a>00466 
<a name="l00467"></a>00467     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size(); i++)
<a name="l00468"></a>00468     {
<a name="l00469"></a>00469         corner_values[0][i] = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[i] - <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa2a4c0e5f21458a2194e001b0301b1c5">bbox_margin</a>*this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a>;
<a name="l00470"></a>00470         corner_values[1][i] = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[i] + <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa2a4c0e5f21458a2194e001b0301b1c5">bbox_margin</a>*this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a>;
<a name="l00471"></a>00471 
<a name="l00472"></a>00472         <span class="comment">// Might have to set corner_values to the parameter domain boundaries</span>
<a name="l00473"></a>00473         <span class="keywordflow">if</span> (corner_values[0][i] &lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i))
<a name="l00474"></a>00474             corner_values[0][i] = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#aaed8f1fe273692ff7cad1be03de720d0">get_parameter_min</a>(i);
<a name="l00475"></a>00475         <span class="keywordflow">if</span> (corner_values[1][i] &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">get_parameter_max</a>(i))
<a name="l00476"></a>00476             corner_values[1][i] = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a711eff68113a6b4c6e491bef54e285fd">get_parameter_max</a>(i);
<a name="l00477"></a>00477     }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00481"></a>00481 <span class="preprocessor"></span>    <span class="comment">// Check whether the bbox is only one point; in this case print an error message</span>
<a name="l00482"></a>00482     <span class="keywordtype">bool</span> trivial_bbox = <span class="keyword">true</span>;
<a name="l00483"></a>00483     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size(); i++)
<a name="l00484"></a>00484     {
<a name="l00485"></a>00485         <span class="keywordflow">if</span> (corner_values[0][i] != corner_values[1][i])
<a name="l00486"></a>00486             trivial_bbox = <span class="keyword">false</span>;
<a name="l00487"></a>00487         <span class="keywordflow">break</span>;
<a name="l00488"></a>00488     }
<a name="l00489"></a>00489     libmesh_assert (!trivial_bbox);
<a name="l00490"></a>00490 <span class="preprocessor">#endif</span>
<a name="l00491"></a>00491 <span class="preprocessor"></span>
<a name="l00492"></a>00492     STOP_LOG(<span class="stringliteral">&quot;get_training_bbox()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00493"></a>00493 
<a name="l00494"></a>00494     <span class="keywordflow">return</span> corner_values;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a1732ae1e3a47c8313bf5884ba3f296f5">00497</a> std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a1732ae1e3a47c8313bf5884ba3f296f5">RBParamSubdomainNode::get_subsampled_training_set</a>()
<a name="l00498"></a>00498 {
<a name="l00499"></a>00499   START_LOG(<span class="stringliteral">&quot;get_subsampled_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <span class="comment">// Return the full training set if the subsampled set size is big enough</span>
<a name="l00502"></a>00502   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a> &gt;= <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>())
<a name="l00503"></a>00503   {
<a name="l00504"></a>00504     STOP_LOG(<span class="stringliteral">&quot;get_subsampled_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00505"></a>00505     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>;
<a name="l00506"></a>00506   }
<a name="l00507"></a>00507   
<a name="l00508"></a>00508   <span class="comment">// Otherwise, build a new set of size n_subsampled_training_points</span>
<a name="l00509"></a>00509   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> quotient  = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a>/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00510"></a>00510   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> remainder = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a>%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00511"></a>00511   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> target_n_local_training_samples =
<a name="l00512"></a>00512     (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt; remainder) ? (quotient + 1) : quotient;
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   <span class="comment">// Seed the random number generator</span>
<a name="l00515"></a>00515   std::srand((<span class="keywordtype">unsigned</span>)( std::time(0)*(1+<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) ));
<a name="l00516"></a>00516   std::vector&lt; std::vector&lt;Number&gt; &gt; subsampled_training_set(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size());
<a name="l00517"></a>00517   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;subsampled_training_set.size(); i++)
<a name="l00518"></a>00518     subsampled_training_set[i].clear();
<a name="l00519"></a>00519   
<a name="l00520"></a>00520   <span class="comment">// Create a vector of the local indices</span>
<a name="l00521"></a>00521   std::vector&lt;unsigned int&gt; local_index_set( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>() );
<a name="l00522"></a>00522   <a class="code" href="namespacelibMesh_1_1Utility.php#a40269b7cf3ba8157ed6b3c2399e62809">Utility::iota</a>(local_index_set.begin(), local_index_set.end(), 0);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524   <span class="keywordflow">while</span>(subsampled_training_set[0].size() &lt; target_n_local_training_samples)
<a name="l00525"></a>00525   {
<a name="l00526"></a>00526     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> position = std::rand() % local_index_set.size();
<a name="l00527"></a>00527     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> random_index = local_index_set[position];
<a name="l00528"></a>00528     
<a name="l00529"></a>00529     <span class="comment">// Make sure that we don&#39;t add repeated parameters to subsampled_training_set</span>
<a name="l00530"></a>00530     std::vector&lt;Real&gt; sample = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a9ad31eaec9f671ef759bb6ae39a2651d">get_local_training_parameter</a>(random_index);
<a name="l00531"></a>00531     local_index_set.erase(local_index_set.begin() + position);
<a name="l00532"></a>00532 
<a name="l00533"></a>00533     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;subsampled_training_set.size(); j++)
<a name="l00534"></a>00534     {
<a name="l00535"></a>00535       subsampled_training_set[j].push_back( sample[j] );
<a name="l00536"></a>00536     }
<a name="l00537"></a>00537   }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   STOP_LOG(<span class="stringliteral">&quot;get_subsampled_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00540"></a>00540 
<a name="l00541"></a>00541   <span class="keywordflow">return</span> subsampled_training_set;
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a3a7e06e533808d457c7b7cff1409aaf3">00544</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a3a7e06e533808d457c7b7cff1409aaf3">RBParamSubdomainNode::clear_training_set</a>()
<a name="l00545"></a>00545 {
<a name="l00546"></a>00546   START_LOG(<span class="stringliteral">&quot;clear_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="comment">// Use the &quot;swapping idiom&quot; to clear the capacity of each</span>
<a name="l00549"></a>00549   <span class="comment">// vector in the training set.</span>
<a name="l00550"></a>00550   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>.size(); i++)
<a name="l00551"></a>00551     std::vector&lt;Number&gt;().swap(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>[i]);
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   STOP_LOG(<span class="stringliteral">&quot;clear_training_set()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainNode&quot;</span>);
<a name="l00554"></a>00554 }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 } <span class="comment">// namespace libMesh</span>
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
