<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_param_subdomain_node.h</div>  </div>
</div>
<div class="contents">
<a href="rb__param__subdomain__node_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_param_subdomain_node_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_param_subdomain_node_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Forward declaration</span>
<a name="l00030"></a>00030 <span class="keyword">class </span>RBSystem;
<a name="l00031"></a>00031 <span class="keyword">class </span>RBParamSubdomainTree;
<a name="l00032"></a>00032 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// RBParamSubdomainNode class definition</span>
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">00057</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18d">Child</a> { <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">LEFT</a>  = 0,
<a name="l00058"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">00058</a>                <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RIGHT</a> = 1 };
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ace94a4eb96d424ad0073cab2240181e6">RBParamSubdomainNode</a> (<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">RBParamSubdomainTree</a>&amp; tree, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>);
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a4f1dc7a3d39e3587bdb31433fc61440d">~RBParamSubdomainNode</a> ();
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aff93a51c0784491f0c21df4ed46c3c92">operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a>&amp; node) <span class="keyword">const</span>;
<a name="l00074"></a>00074 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00082"></a>00082 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ab2b4a7a494c63508a5f03b0483b51fd0">split_this_subdomain</a>(<span class="keywordtype">bool</span> h_stage_split);
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a5f10b34e5290ff4d04f710d70b10fe54">perform_p_stage</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> greedy_bound);
<a name="l00095"></a>00095 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a107717d12e7894851b2d5f113628ad58">write_subdomain_data_to_files</a>();
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a319a3958f2e480d5349d2cf3f53572c9">00106</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a319a3958f2e480d5349d2cf3f53572c9">get_n_params</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); }
<a name="l00107"></a>00107 
<a name="l00113"></a>00113   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac4a7527bf06c07b099254a5445e86c79">distance</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; p1, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; p2) <span class="keyword">const</span>;
<a name="l00114"></a>00114 
<a name="l00120"></a>00120   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">dist_from_anchor</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_param) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">add_child</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; child_anchor, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18d">Child</a> c);
<a name="l00127"></a>00127 
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad8e5b2eefd00651ce38d3d88bd615137">copy_training_set_from_system</a>();
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a606dddf9b3c7dd9f8b682072d53385fa">refine_training_set</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_training_set_size);
<a name="l00138"></a>00138 
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7aae71ba487f206ae1e7ffae1696cf76">initialize_child_training_sets</a>();
<a name="l00145"></a>00145 
<a name="l00150"></a>00150   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad7e2a37f8c674e66ed278f1b37667b07">n_local_training_parameters</a>() <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>() <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00161"></a>00161   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a9ad31eaec9f671ef759bb6ae39a2651d">get_local_training_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00162"></a>00162 
<a name="l00169"></a>00169   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a0fadd79316fc806cc748720c235fd179">get_training_bbox</a>();
<a name="l00170"></a>00170 
<a name="l00177"></a>00177   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a1732ae1e3a47c8313bf5884ba3f296f5">get_subsampled_training_set</a>();
<a name="l00178"></a>00178   
<a name="l00182"></a>00182   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a3a7e06e533808d457c7b7cff1409aaf3">clear_training_set</a>();
<a name="l00183"></a>00183 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">00187</a>   <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>;
<a name="l00188"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">00188</a>   <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>;
<a name="l00189"></a>00189 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">00193</a>   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">RBParamSubdomainTree</a>&amp; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>;
<a name="l00194"></a>00194 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">00199</a>   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>;
<a name="l00200"></a>00200 
<a name="l00209"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">00209</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>;
<a name="l00210"></a>00210 
<a name="l00217"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">00217</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a>;
<a name="l00218"></a>00218 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">00225</a>   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a>;
<a name="l00226"></a>00226 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">00233</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">model_number</a>;
<a name="l00234"></a>00234 
<a name="l00239"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">00239</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7c805328e042dc93c3626e4242481170">training_set_initialized</a>;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 };
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 } <span class="comment">// namespace libMesh</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
