<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_param_subdomain_tree.C</div>  </div>
</div>
<div class="contents">
<a href="rb__param__subdomain__tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="rb__param__subdomain__node_8h.php">rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="rb__param__subdomain__tree_8h.php">rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// FOR CREATING A DIRECTORY</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a9bc9bb23d722d6826951a617ba50c972">00037</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a9bc9bb23d722d6826951a617ba50c972">RBParamSubdomainTree::RBParamSubdomainTree</a>(<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_system_in, <span class="keyword">const</span> std::string&amp; parameters_filename)
<a name="l00038"></a>00038   : root_node(NULL),
<a name="l00039"></a>00039     _rb_system(rb_system_in),
<a name="l00040"></a>00040     h_tol(0.),
<a name="l00041"></a>00041     p_tol(0.),
<a name="l00042"></a>00042     N_bar(1),
<a name="l00043"></a>00043     n_subsampled_training_points(0),
<a name="l00044"></a>00044     bbox_margin(0.),
<a name="l00045"></a>00045     leaf_node_index(0),
<a name="l00046"></a>00046     clear_training_sets_during_hp(true)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// Read in properties from parameters_filename</span>
<a name="l00049"></a>00049   GetPot infile(parameters_filename);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// Set hp-Greedy tolerances</span>
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a> = infile(<span class="stringliteral">&quot;h_tol&quot;</span>,<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>);
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a> = infile(<span class="stringliteral">&quot;p_tol&quot;</span>,<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a> = infile(<span class="stringliteral">&quot;N_bar&quot;</span>,<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a>);
<a name="l00056"></a>00056   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a> &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>())
<a name="l00057"></a>00057   {
<a name="l00058"></a>00058     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot set N_bar larger than Nmax for an RBParamSubdomainTree.&quot;</span>
<a name="l00059"></a>00059                  &lt;&lt; std::endl;
<a name="l00060"></a>00060     libmesh_error();
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   <span class="comment">// by default use all training points</span>
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a> = infile( <span class="stringliteral">&quot;n_subsampled_training_points&quot;</span>, <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a584ecef007a7992b6317db58f857e9e0">get_n_training_samples</a>() );
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// Set the subdomain bounding-box margin fraction</span>
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa2a4c0e5f21458a2194e001b0301b1c5">bbox_margin</a> = infile(<span class="stringliteral">&quot;bbox_margin&quot;</span>,bbox_margin);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;RBParamSubdomainTree parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00070"></a>00070   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Tolerance for the h-stage (h_tol): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a> &lt;&lt; std::endl;
<a name="l00071"></a>00071   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Tolerance for the p-stage (p_tol): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a> &lt;&lt; std::endl;
<a name="l00072"></a>00072   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Nmax during h-stage (N_bar): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a> &lt;&lt; std::endl;
<a name="l00073"></a>00073   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;n_subsampled_training_points: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a> &lt;&lt; std::endl;
<a name="l00074"></a>00074   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Bounding-box margin fraction for subdomain training set enrichment: &quot;</span> &lt;&lt; bbox_margin &lt;&lt; std::endl;
<a name="l00075"></a>00075   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">// The rbOOmit code is still in a state of flux</span>
<a name="l00078"></a>00078   libmesh_experimental();
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4851659fb07f4c807bb70a0aefb31bcc">00081</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4851659fb07f4c807bb70a0aefb31bcc">RBParamSubdomainTree::~RBParamSubdomainTree</a>()
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>)
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>;
<a name="l00086"></a>00086       <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a> = NULL;
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a07f859f5582cf633d8386770527f6da5">00090</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a07f859f5582cf633d8386770527f6da5">RBParamSubdomainTree::build_root_node</a>()
<a name="l00091"></a>00091 {
<a name="l00092"></a>00092   libmesh_assert(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a> == NULL);
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a>(*<span class="keyword">this</span>, <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>());
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a878ab222c6dacac218a3f2820c6efcf5">00096</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a878ab222c6dacac218a3f2820c6efcf5">RBParamSubdomainTree::hp_greedy</a>()
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   START_LOG(<span class="stringliteral">&quot;hp_greedy()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">// Build the root node rather than in the ctor</span>
<a name="l00101"></a>00101   <span class="comment">// so we can use virtual function</span>
<a name="l00102"></a>00102   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>)
<a name="l00103"></a>00103     <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a07f859f5582cf633d8386770527f6da5">build_root_node</a>();
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad8e5b2eefd00651ce38d3d88bd615137">copy_training_set_from_system</a>();
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   STOP_LOG(<span class="stringliteral">&quot;hp_greedy()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6328438a9f686ff5c043f34384ab02c6">00112</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6328438a9f686ff5c043f34384ab02c6">RBParamSubdomainTree::determine_subdomain</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_param)
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   START_LOG(<span class="stringliteral">&quot;determine_subdomain()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * current_node = <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">while</span> ( (current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> != NULL) &amp;&amp; (current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> != NULL) )
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120       <span class="keywordflow">if</span> (current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">dist_from_anchor</a>(new_param) &lt;= current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#aa6d1a8839a3ff54ac7aa05466286679c">dist_from_anchor</a>(new_param))
<a name="l00121"></a>00121         current_node = current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>;
<a name="l00122"></a>00122       <span class="keywordflow">else</span>
<a name="l00123"></a>00123         current_node = current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>;
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   STOP_LOG(<span class="stringliteral">&quot;determine_subdomain()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">return</span> current_node;
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a642fcf51dc193a48567f61812c44e15c">00131</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a642fcf51dc193a48567f61812c44e15c">RBParamSubdomainTree::write_tree_data_to_file</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   START_LOG(<span class="stringliteral">&quot;write_tree_data_to_file()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137 
<a name="l00138"></a>00138       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Writing tree data to tree_data/tree.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <span class="keywordflow">if</span>( mkdir(directory_name.c_str(), 0777) == -1)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Directory &quot;</span> &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot; already exists, overwriting contents.&quot;</span> &lt;&lt; std::endl;
<a name="l00143"></a>00143         }
<a name="l00144"></a>00144       {
<a name="l00145"></a>00145         std::ofstream n_leaves_out;
<a name="l00146"></a>00146         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00147"></a>00147         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/n_leaves.dat&quot;</span>;
<a name="l00148"></a>00148         n_leaves_out.open( file_name.str().c_str() );
<a name="l00149"></a>00149         <span class="keywordflow">if</span> ( !n_leaves_out.good() )
<a name="l00150"></a>00150           {
<a name="l00151"></a>00151             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening n_leaves.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00152"></a>00152             libmesh_error();
<a name="l00153"></a>00153           }
<a name="l00154"></a>00154         n_leaves_out &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>;
<a name="l00155"></a>00155         n_leaves_out.close();
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       {
<a name="l00159"></a>00159         std::ofstream tree_out;
<a name="l00160"></a>00160         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00161"></a>00161         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/tree.dat&quot;</span>;
<a name="l00162"></a>00162         tree_out.open( file_name.str().c_str() );
<a name="l00163"></a>00163         <span class="keywordflow">if</span> ( !tree_out.good() )
<a name="l00164"></a>00164           {
<a name="l00165"></a>00165             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening tree.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00166"></a>00166             libmesh_error();
<a name="l00167"></a>00167           }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169         std::vector&lt;int&gt; bool_vec_(1);
<a name="l00170"></a>00170         bool_vec_[0] = 1;
<a name="l00171"></a>00171         <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a> = 0;
<a name="l00172"></a>00172         <span class="comment">// Actual writing is performed recursively</span>
<a name="l00173"></a>00173         <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a15080ef46ede3ab94fd86c5e7f69e50c">write_tree_data_to_file_recursively</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>, tree_out, bool_vec_);
<a name="l00174"></a>00174         tree_out.close();
<a name="l00175"></a>00175       }
<a name="l00176"></a>00176     }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   STOP_LOG(<span class="stringliteral">&quot;write_tree_data_to_file()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a15080ef46ede3ab94fd86c5e7f69e50c">00181</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a15080ef46ede3ab94fd86c5e7f69e50c">RBParamSubdomainTree::write_tree_data_to_file_recursively</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * current_node,
<a name="l00182"></a>00182                                                                std::ofstream&amp; stream,
<a name="l00183"></a>00183                                                                std::vector&lt;int&gt;&amp; bool_vec)
<a name="l00184"></a>00184 {
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (current_node != NULL)
<a name="l00186"></a>00186     {
<a name="l00187"></a>00187       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i&lt; bool_vec.size(); i++)
<a name="l00188"></a>00188         stream &lt;&lt; bool_vec[i];
<a name="l00189"></a>00189       stream &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00190"></a>00190       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i&lt; current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); i++){
<a name="l00191"></a>00191         stream &lt;&lt; current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00192"></a>00192       }
<a name="l00193"></a>00193       <span class="keywordflow">if</span> ((current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> == NULL) &amp;&amp; (current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> == NULL)){
<a name="l00194"></a>00194         stream &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>;
<a name="l00195"></a>00195         leaf_node_index ++;
<a name="l00196"></a>00196         }
<a name="l00197"></a>00197       <span class="keywordflow">else</span>
<a name="l00198"></a>00198         {
<a name="l00199"></a>00199           stream &lt;&lt; -1;
<a name="l00200"></a>00200         }
<a name="l00201"></a>00201       stream &lt;&lt; std::endl;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       std::vector&lt;int&gt; bool_vec_left(bool_vec.size()+1);
<a name="l00204"></a>00204       std::vector&lt;int&gt; bool_vec_right(bool_vec.size()+1);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i&lt; bool_vec.size(); i++)
<a name="l00207"></a>00207         {
<a name="l00208"></a>00208           bool_vec_left[i] = bool_vec[i];
<a name="l00209"></a>00209           bool_vec_right[i] = bool_vec[i];
<a name="l00210"></a>00210         }
<a name="l00211"></a>00211       bool_vec_left[bool_vec.size()] = 0;
<a name="l00212"></a>00212       bool_vec_right[bool_vec.size()] = 1;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214       <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a15080ef46ede3ab94fd86c5e7f69e50c">write_tree_data_to_file_recursively</a>(current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>, stream, bool_vec_left);
<a name="l00215"></a>00215       <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a15080ef46ede3ab94fd86c5e7f69e50c">write_tree_data_to_file_recursively</a>(current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>, stream, bool_vec_right);
<a name="l00216"></a>00216     }
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7c2639d3584b9efd313cd3624b851c54">00219</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7c2639d3584b9efd313cd3624b851c54">RBParamSubdomainTree::read_tree_data_from_file</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   START_LOG(<span class="stringliteral">&quot;read_tree_data_from_file()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00222"></a>00222   
<a name="l00223"></a>00223   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading tree data from tree_data/tree.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="comment">// First, need to build a root node</span>
<a name="l00226"></a>00226   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>)
<a name="l00227"></a>00227     <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a07f859f5582cf633d8386770527f6da5">build_root_node</a>();
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00230"></a>00230   file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/tree.dat&quot;</span>;
<a name="l00231"></a>00231   std::ifstream tree_in(file_name.str().c_str());
<a name="l00232"></a>00232   <span class="keywordflow">if</span> ( !tree_in.good() )
<a name="l00233"></a>00233     {
<a name="l00234"></a>00234       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening tree.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00235"></a>00235       libmesh_error();
<a name="l00236"></a>00236     }
<a name="l00237"></a>00237   <span class="comment">// Actual reading is performed recursively</span>
<a name="l00238"></a>00238   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a158afbb65322f2417def169c6c1fc622">reconstruct_tree</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>, tree_in);
<a name="l00239"></a>00239   tree_in.close();
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   STOP_LOG(<span class="stringliteral">&quot;read_tree_data_from_file()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a158afbb65322f2417def169c6c1fc622">00244</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a158afbb65322f2417def169c6c1fc622">RBParamSubdomainTree::reconstruct_tree</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * current_node,  std::ifstream&amp; stream)
<a name="l00245"></a>00245 {
<a name="l00246"></a>00246   START_LOG(<span class="stringliteral">&quot;reconstruct_tree()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248  std::string bool_vec_string;
<a name="l00249"></a>00249 
<a name="l00250"></a>00250  stream &gt;&gt; bool_vec_string;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0 ; i &lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a2c3f951cf69b5da83a67734be6b01972">get_n_params</a>(); i++)
<a name="l00253"></a>00253    stream &gt;&gt; current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[i];
<a name="l00254"></a>00254 
<a name="l00255"></a>00255  stream &gt;&gt; current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">model_number</a>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="comment">//  libMesh::out &lt;&lt; bool_vec_string &lt;&lt; &quot; &quot;;</span>
<a name="l00258"></a>00258 <span class="comment">//  for (unsigned i = 0 ; i &lt; _rb_system.get_n_params(); i++)</span>
<a name="l00259"></a>00259 <span class="comment">//    libMesh::out&lt;&lt; current_node-&gt;anchor[i] &lt;&lt; &quot; &quot;;</span>
<a name="l00260"></a>00260 <span class="comment">//  libMesh::out &lt;&lt; current_node-&gt;model_number &lt;&lt; std::endl;</span>
<a name="l00261"></a>00261 
<a name="l00262"></a>00262  if (current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a2f62ac2841b8b28264883db4927244a2">model_number</a> == -1)
<a name="l00263"></a>00263    {
<a name="l00264"></a>00264     current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">add_child</a>(current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">RBParamSubdomainNode::LEFT</a>);
<a name="l00265"></a>00265     current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a27f02c15c5961503e12a25b2028aefce">add_child</a>(current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RBParamSubdomainNode::RIGHT</a>);
<a name="l00266"></a>00266     <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a158afbb65322f2417def169c6c1fc622">reconstruct_tree</a>(current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>, stream);
<a name="l00267"></a>00267     <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a158afbb65322f2417def169c6c1fc622">reconstruct_tree</a>(current_node-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>, stream);
<a name="l00268"></a>00268    }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   STOP_LOG(<span class="stringliteral">&quot;reconstruct_tree()&quot;</span>, <span class="stringliteral">&quot;RBParamSubdomainTree&quot;</span>);
<a name="l00271"></a>00271 }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
