<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_param_subdomain_tree.h</div>  </div>
</div>
<div class="contents">
<a href="rb__param__subdomain__tree_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_param_subdomain_tree_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_param_subdomain_tree_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Forward declaration</span>
<a name="l00030"></a>00030 <span class="keyword">class </span>RBSystem;
<a name="l00031"></a>00031 <span class="keyword">class </span>RBParamSubdomainNode;
<a name="l00032"></a>00032 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// RBParamSubdomainTree class definition</span>
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">RBParamSubdomainTree</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a9bc9bb23d722d6826951a617ba50c972">RBParamSubdomainTree</a> (<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; system, <span class="keyword">const</span> std::string&amp; parameters_filename);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4851659fb07f4c807bb70a0aefb31bcc">~RBParamSubdomainTree</a> ();
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a07f859f5582cf633d8386770527f6da5">build_root_node</a>();
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a878ab222c6dacac218a3f2820c6efcf5">hp_greedy</a>();
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6328438a9f686ff5c043f34384ab02c6">determine_subdomain</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_param);
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a642fcf51dc193a48567f61812c44e15c">write_tree_data_to_file</a>(<span class="keyword">const</span> std::string&amp; directory_name);
<a name="l00085"></a>00085 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a15080ef46ede3ab94fd86c5e7f69e50c">write_tree_data_to_file_recursively</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * current_node,   std::ofstream&amp; stream,   std::vector&lt;int&gt;&amp; bool_vec);
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7c2639d3584b9efd313cd3624b851c54">read_tree_data_from_file</a>(<span class="keyword">const</span> std::string&amp; directory_name);
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a158afbb65322f2417def169c6c1fc622">reconstruct_tree</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * current_node,  std::ifstream&amp; stream);
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">00106</a>   <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">RBParamSubdomainNode</a> * <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a>;
<a name="l00107"></a>00107 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">00112</a>   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> &amp; <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">_rb_system</a>;
<a name="l00113"></a>00113 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">00117</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>;
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">00122</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>;
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7e017d8af85f18e0d2c0e1a428ca8178">00127</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7e017d8af85f18e0d2c0e1a428ca8178">conserv_factor</a>;
<a name="l00128"></a>00128 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">00135</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a>;
<a name="l00136"></a>00136 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">00146</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a>;
<a name="l00147"></a>00147 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa2a4c0e5f21458a2194e001b0301b1c5">00153</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa2a4c0e5f21458a2194e001b0301b1c5">bbox_margin</a>;
<a name="l00154"></a>00154 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">00159</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>;
<a name="l00160"></a>00160   
<a name="l00166"></a><a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6a307c13af6c2d10ce35cffeab17499c">00166</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a6a307c13af6c2d10ce35cffeab17499c">clear_training_sets_during_hp</a>;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 };
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 } <span class="comment">// namespace libMesh</span>
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
