<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_scm_system.h</div>  </div>
</div>
<div class="contents">
<a href="rb__scm__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_scm_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_scm_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Configuration data</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Currently, the RBSCMSystem is only usable</span>
<a name="l00027"></a>00027 <span class="comment">// if SLEPc is enabled.</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; (LIBMESH_HAVE_GLPK)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="condensed__eigen__system_8h.php">condensed_eigen_system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="rb__base_8h.php">rb_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// RBSCMSystem class definition</span>
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase</a>&lt;CondensedEigenSystem&gt;
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a81bd11b0a842406c6d90b79d736cf8f8">RBSCMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00057"></a>00057                <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00058"></a>00058                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab50035fb885cb1e3faaa829fb1ae46af">~RBSCMSystem</a> ();
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa9e1be46ece1f20da787b391ea8f3de3">00068</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php">RBSCMSystem</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa9e1be46ece1f20da787b391ea8f3de3">sys_type</a>;
<a name="l00069"></a>00069 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4e030fbc397fdd36ba9b097fb3db239d">00073</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase&lt;CondensedEigenSystem&gt;</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4e030fbc397fdd36ba9b097fb3db239d">Parent</a>;
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8450f0e561356e2e86e30f0910b98bf7">clear</a> ();
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ace55884aa4081bb6d00ccec765db31e1">resize_SCM_vectors</a> ();
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad2228c6ba13252a417ae54ebf0d2264e">initialize_SCM_system</a> ();
<a name="l00092"></a>00092 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ae9924e8acc75b6aa416212a9b851233f">00102</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ae9924e8acc75b6aa416212a9b851233f">set_eigensolver_properties</a>(<span class="keywordtype">int</span> ) { }
<a name="l00103"></a>00103 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a40b8a26d3d227f9eba2b2c922f3a9f86">00108</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a40b8a26d3d227f9eba2b2c922f3a9f86">set_RB_system_name</a>(<span class="keyword">const</span> std::string&amp; name) { <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a> = <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>; }
<a name="l00109"></a>00109 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4301d15802fbba97a768b978968afb41">00113</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4301d15802fbba97a768b978968afb41">get_SCM_eps</a>()<span class="keyword"> const          </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">SCM_eps</a>; }
<a name="l00114"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa156e1b58ed97ef8d3fd8595eb58699d">00114</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa156e1b58ed97ef8d3fd8595eb58699d">set_SCM_eps</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> SCM_eps_in) { this-&gt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">SCM_eps</a> = SCM_eps_in; }
<a name="l00115"></a>00115 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8d829aba1d25af9b40a3eeb0418af191">00120</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a8d829aba1d25af9b40a3eeb0418af191">get_SCM_M</a>()<span class="keyword"> const     </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a>; }
<a name="l00121"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6b3b8091faff7f2277bed815450f411b">00121</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6b3b8091faff7f2277bed815450f411b">set_SCM_M</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> SCM_M_in) { this-&gt;<a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a> = SCM_M_in; }
<a name="l00122"></a>00122 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af7e4f77971d064fa4e614a8a098459af">perform_SCM_greedy</a>();
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aec9345df172fa49477f94c46d9d991a0">get_SCM_LB</a>();
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab481b656b3310e857f2a51e3e3fff497">get_SCM_UB</a>();
<a name="l00138"></a>00138 
<a name="l00145"></a>00145   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a86b972c3767ce29c2205d52aa99b6137">get_C_J_stability_constraint</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00146"></a>00146 
<a name="l00152"></a>00152   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#abf84d8ae05cd21fa26db5f08d8cabcd1">get_SCM_UB_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac91697287306f03cc8a355dca15d1b45">00157</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac91697287306f03cc8a355dca15d1b45">get_C_J_size</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>.size(); }
<a name="l00158"></a>00158 
<a name="l00162"></a>00162   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a18a95164c4ef874dddb37d5ee7f68d15">get_C_J_entry</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a57f8f827cf4bff1cdf94d2186836d318">00167</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a57f8f827cf4bff1cdf94d2186836d318">get_C_J_stability_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>[j]; }
<a name="l00168"></a>00168 
<a name="l00172"></a>00172   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa8d858e6d9830e531faa23d09c262f98">get_B_min</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00173"></a>00173   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af6e399c8666c527e73d7c5d4368fd7b7">get_B_max</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00183"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a925a4611f5063d5de177d1357e162d00">00183</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a925a4611f5063d5de177d1357e162d00">attach_deflation_space</a>() {}
<a name="l00184"></a>00184 
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad30371584074d6efd903cd311576c5f9">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00190"></a>00190 
<a name="l00195"></a>00195   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a1fc44cbf71f7e98ba7fad0a3c0236c87">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00198"></a>00198 
<a name="l00203"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4ddbdc1eeb20c9e7b0c34acccc0af214">00203</a>   std::string <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a4ddbdc1eeb20c9e7b0c34acccc0af214">parameters_filename</a>;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="keyword">protected</span>:
<a name="l00206"></a>00206 
<a name="l00211"></a>00211   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2b9680a829301afd6357b5550b685896">add_scaled_symm_Aq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a, <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar);
<a name="l00212"></a>00212 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7b2f05d31e5405d36969902f2f42107f">00218</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7b2f05d31e5405d36969902f2f42107f">load_matrix_B</a>() { libmesh_not_implemented(); }
<a name="l00219"></a>00219 
<a name="l00223"></a>00223   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a6904dbd9a7abb9edca262eb194c3d9ef">compute_SCM_bounding_box</a>();
<a name="l00224"></a>00224 
<a name="l00230"></a>00230   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a52a04025004a11827804c7ac8053119d">evaluate_stability_constant</a>();
<a name="l00231"></a>00231 
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af187e480f971ff7fc1ae862fd62f5d63">set_current_parameters_from_C_J</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> C_J_index);
<a name="l00237"></a>00237 
<a name="l00244"></a>00244   <span class="keyword">virtual</span> std::pair&lt;unsigned int,Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a7e6bc55d8a4a009a0c67aaea9e391028">compute_SCM_bounds_on_training_set</a>();
<a name="l00245"></a>00245 
<a name="l00250"></a>00250   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ac45951587c7bb4a87a5e9cf63cfd14be">enrich_C_J</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_C_J_index);
<a name="l00251"></a>00251 
<a name="l00255"></a>00255   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2a7aed900700d71cdf584c1717531196">set_B_min</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> B_min_val);
<a name="l00256"></a>00256   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae597bb05fcc74eed204d35dd3824775">set_B_max</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> B_max_val);
<a name="l00257"></a>00257 
<a name="l00264"></a>00264   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ad51a3d4b20f6bf643b2339d34222c94b">set_C_J_stability_constraint</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> stability_constraint_in);
<a name="l00265"></a>00265 
<a name="l00271"></a>00271   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a62609d8085599af5eb1da2c2ddc4e255">set_SCM_UB_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y_q);
<a name="l00272"></a>00272 
<a name="l00277"></a>00277   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#adb44280fac91598ee1d3068e2bbcc082">B_inner_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; w) <span class="keyword">const</span>;
<a name="l00278"></a>00278 
<a name="l00283"></a>00283   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae9065f20c0bb7ab443d39ce8e14b73d">Aq_inner_product</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q,
<a name="l00284"></a>00284                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00285"></a>00285                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; w);
<a name="l00286"></a>00286 
<a name="l00294"></a>00294   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af00012168d7a147c3ee3a0deb030166c">param_dist</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_1, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; mu_2);
<a name="l00295"></a>00295 
<a name="l00301"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab13ee120fe84658f078555fb8293bc98">00301</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab13ee120fe84658f078555fb8293bc98">SCM_greedy_error_indicator</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> LB, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> UB) { <span class="keywordflow">return</span> fabs(UB-LB)/fabs(UB); }
<a name="l00302"></a>00302 
<a name="l00307"></a>00307   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a213d1404621821585eeca3e60b71dda2">save_current_parameters</a>();
<a name="l00308"></a>00308 
<a name="l00313"></a>00313   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a256ff6e79bd7bf85111f78aa703d1868">reload_current_parameters</a>();
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00317"></a>00317 
<a name="l00321"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">00321</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#ab763cbcdecd8f0059f4a9431838a5488">SCM_eps</a>;
<a name="l00322"></a>00322 
<a name="l00326"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">00326</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aae6b24b5d60fd24a348830c0b672659f">SCM_M</a>;
<a name="l00327"></a>00327 
<a name="l00331"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">00331</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af64954db1af6eef59ad24ccecc960a89">B_min</a>;
<a name="l00332"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">00332</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#aa4214d13d5b9c1ea21b544d261e39a79">B_max</a>;
<a name="l00333"></a>00333 
<a name="l00338"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">00338</a>   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a2fb14e4c9d70dd1722635ab62bb72423">C_J</a>;
<a name="l00339"></a>00339 
<a name="l00344"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">00344</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#af66df67db4690fe68eb82028ee0fcf24">C_J_stability_vector</a>;
<a name="l00345"></a>00345 
<a name="l00352"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">00352</a>   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a105199f54a65f57e2c5e66de3ea07916">SCM_UB_vectors</a>;
<a name="l00353"></a>00353 
<a name="l00358"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#afceae43f1ce47e81f9b17408b3d853f9">00358</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSCMSystem.php#afceae43f1ce47e81f9b17408b3d853f9">saved_parameters</a>;
<a name="l00359"></a>00359 
<a name="l00363"></a><a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">00363</a>   std::string <a class="code" href="classlibMesh_1_1RBSCMSystem.php#a3427a19ee940f3b5eb5a953c3a833e5a">RB_system_name</a>;
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="keyword">private</span>:
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 };
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 } <span class="comment">// namespace libMesh</span>
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC &amp;&amp; LIBMESH_HAVE_GLPK</span>
<a name="l00372"></a>00372 <span class="preprocessor"></span>
<a name="l00373"></a>00373 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
