<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">rb_system.h</div>  </div>
</div>
<div class="contents">
<a href="rb__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __rb_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __rb_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="rb__base_8h.php">rb_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="rb__evaluation_8h.php">rb_evaluation.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem__assembly_8h.php">elem_assembly.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1DirichletDofAssembly.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DirichletDofAssembly.php">DirichletDofAssembly</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a><a class="code" href="classlibMesh_1_1DirichletDofAssembly.php#ac0bc86aae5d02f63a0f7030273bc1f01">00053</a>   std::set&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DirichletDofAssembly.php#ac0bc86aae5d02f63a0f7030273bc1f01">dirichlet_dofs_set</a>;
<a name="l00054"></a>00054 };
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// RBSystem class definition</span>
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1RBSystem.php">00059</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase</a>&lt;LinearImplicitSystem&gt;
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1RBSystem.php#a8f0b6f6507452d097f4c98e98ed49ecf">RBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00068"></a>00068             <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00069"></a>00069             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ace52091502758766654923323e89e66e">~RBSystem</a> ();
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a878915c13cc8f3971f504b32b04055ad">00079</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a878915c13cc8f3971f504b32b04055ad">sys_type</a>;
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6b0991d8d341b25a9e311cbc4ae5b569">00084</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a6b0991d8d341b25a9e311cbc4ae5b569">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1487ed2f96c2dbb400d41bc0f32ded96">00089</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBBase.php">RBBase&lt;LinearImplicitSystem&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a1487ed2f96c2dbb400d41bc0f32ded96">Parent</a>;
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad9de9f8d888f8b9072402b5fe656a30d">clear</a> ();
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1RBSystem.php#a6e385de97a2d50358ef9cc4ff0f11e53">system_type</a> () <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a6e3df26cf5cd4b4343483129a3d958df">truth_solve</a>(<span class="keywordtype">int</span> plot_solution);
<a name="l00109"></a>00109 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">train_reduced_basis</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00122"></a>00122 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a798528f51e8a431936d4262778218067">compute_max_error_bound</a>();
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00135"></a>00135 
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6d4f87f01e24e2dfa0a8b44314707116">set_eigen_system_name</a>(<span class="keyword">const</span> std::string&amp; name);
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">00144</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>)
<a name="l00145"></a>00145     {this-&gt;training_tolerance = <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>; }
<a name="l00146"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">00146</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a8166ac1af73cc69a154ff5a65ed9e959">get_training_tolerance</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>; }
<a name="l00147"></a>00147 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">00152</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>()<span class="keyword"> const    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>; }
<a name="l00153"></a>00153   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a0eedc533ec1db115433f692dbcd33e1f">set_Nmax</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00154"></a>00154 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">00159</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aaa2202b0964672c378c69f671cbd25af">theta_q_f_vector</a>.size() + <a class="code" href="classlibMesh_1_1RBSystem.php#a8d33ac93600827567a3c5fd0b7c5741c">get_n_F_EIM_functions</a>(); }
<a name="l00160"></a>00160 
<a name="l00165"></a>00165   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac1e04bfe35245ea3e225fc5865621fb0">get_n_F_EIM_systems</a>() <span class="keyword">const</span>;
<a name="l00166"></a>00166 
<a name="l00170"></a>00170   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8d33ac93600827567a3c5fd0b7c5741c">get_n_F_EIM_functions</a>() <span class="keyword">const</span>;
<a name="l00171"></a>00171 
<a name="l00175"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">00175</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a14ccfe52c9863e81feb204529e727464">theta_q_l_vector</a>.size(); }
<a name="l00176"></a>00176   
<a name="l00180"></a>00180   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> output_index) <span class="keyword">const</span>;
<a name="l00181"></a>00181 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa095cbb2ba565c3ffb2a05f1f4684534">00187</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aa095cbb2ba565c3ffb2a05f1f4684534">set_quiet_mode</a>(<span class="keywordtype">bool</span> quiet_mode_in)
<a name="l00188"></a>00188     { this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#af9e792c87763ddd32985062b119c9a7e">quiet_mode</a> = quiet_mode_in; }
<a name="l00189"></a>00189 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a8b5ad508848699cdb22b9b7bc4681094">00193</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8b5ad508848699cdb22b9b7bc4681094">is_quiet</a>()<span class="keyword"> const</span>
<a name="l00194"></a>00194 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#af9e792c87763ddd32985062b119c9a7e">quiet_mode</a>; }
<a name="l00195"></a>00195 
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af6e478cdf9c08312cdf7ca6a53349922">load_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00201"></a>00201 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">00205</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>(); }
<a name="l00206"></a>00206 
<a name="l00210"></a>00210   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00211"></a>00211 
<a name="l00216"></a>00216   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a24fc309a7bfce6fb9380e242d4fdd5bc">load_RB_solution</a>();
<a name="l00217"></a>00217 
<a name="l00222"></a>00222   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#adafd2ad491e581bad2f9907a8a1ec9f7">attach_dirichlet_dof_initialization</a> (<a class="code" href="classlibMesh_1_1DirichletDofAssembly.php">DirichletDofAssembly</a>* dirichlet_init);
<a name="l00223"></a>00223 
<a name="l00227"></a>00227   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#add5ef1d37331766d1b46208bb4e952fb">initialize_dirichlet_dofs</a>();
<a name="l00228"></a>00228 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1RBSystem.php#acbbf70ad7527418994fd5d9da4d0fe2b">00233</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acbbf70ad7527418994fd5d9da4d0fe2b">attach_theta_q_a</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* )
<a name="l00234"></a>00234   {
<a name="l00235"></a>00235     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot use attach_theta_q_a in RBSystem. Use attach_A_q instead.&quot;</span> &lt;&lt; std::endl;
<a name="l00236"></a>00236     libmesh_error();
<a name="l00237"></a>00237   }
<a name="l00238"></a>00238 
<a name="l00243"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac4acf0baeb2751763420084c197c2c38">00243</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac4acf0baeb2751763420084c197c2c38">attach_A_EIM_system</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>*)
<a name="l00244"></a>00244   {
<a name="l00245"></a>00245     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Cannot use attach_theta_q_a in RBSystem. Use attach_A_q instead.&quot;</span> &lt;&lt; std::endl;
<a name="l00246"></a>00246     libmesh_error();
<a name="l00247"></a>00247   }
<a name="l00248"></a>00248 
<a name="l00253"></a>00253   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2ae904d2b905e3fabfaf72690f1f5a47">attach_A_q</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_a,
<a name="l00254"></a>00254                           <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* A_q_assembly);
<a name="l00255"></a>00255 
<a name="l00260"></a>00260   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a43433784d9929afc7fb424b5d0bd51b0">attach_F_q</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_f,
<a name="l00261"></a>00261                           <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* F_q_assembly);
<a name="l00262"></a>00262 
<a name="l00268"></a>00268   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5e76b8aa866dca6d124a0cf77a91b48a">attach_A_EIM_operators</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system,
<a name="l00269"></a>00269                               <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* EIM_assembly);
<a name="l00270"></a>00270   
<a name="l00276"></a>00276   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a94d58a90b988199f07898265c7a11693">attach_F_EIM_vectors</a>(<a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* eim_system,
<a name="l00277"></a>00277                             <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* EIM_assembly);
<a name="l00278"></a>00278 
<a name="l00283"></a>00283   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a21aca93ce10d2135a08c36a8a38b2c8a">is_F_EIM_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00284"></a>00284 
<a name="l00289"></a>00289   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a0ccebda28f18c2f5e65ca15297f8e614">attach_inner_prod_assembly</a>(<a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* IP_assembly);
<a name="l00290"></a>00290 
<a name="l00295"></a>00295   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a12e5167dfc5e492e07f27da951ffa088">attach_constraint_assembly</a>(<a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* constraint_assembly_in);
<a name="l00296"></a>00296 
<a name="l00302"></a>00302   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afa3f43a126f4f301dbb7ca26ba5bb635">attach_output</a>(std::vector&lt;RBTheta*&gt; theta_q_l,
<a name="l00303"></a>00303                              std::vector&lt;ElemAssembly*&gt; output_assembly);
<a name="l00304"></a>00304 
<a name="l00311"></a>00311   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afa3f43a126f4f301dbb7ca26ba5bb635">attach_output</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_l,
<a name="l00312"></a>00312                              <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* output_assembly);
<a name="l00313"></a>00313 
<a name="l00320"></a>00320   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a691f98fe8a6b3f10d02d45df0b085571">get_inner_product_matrix</a>();
<a name="l00321"></a>00321 
<a name="l00330"></a>00330   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a47845f478c8b073663347bd8f2cb75b8">get_non_dirichlet_inner_product_matrix</a>();
<a name="l00331"></a>00331 
<a name="l00335"></a>00335   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00336"></a>00336 
<a name="l00340"></a>00340   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a7cf695ae6b7ab56b174dc3aa815d9603">get_non_dirichlet_A_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00341"></a>00341   
<a name="l00345"></a>00345   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a9136cc9298d4aeda4145fc61a76dd980">get_A_EIM_system</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00346"></a>00346   
<a name="l00350"></a>00350   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a5d80df31baa1197b3823040f1e85f585">get_F_EIM_system</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00351"></a>00351   
<a name="l00358"></a>00358   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2a8e92bd42f6ea347ef9c82b595648ac">evaluate_current_EIM_function</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; element,
<a name="l00359"></a>00359                                                     <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qpoints);
<a name="l00360"></a>00360 
<a name="l00364"></a>00364   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00365"></a>00365 
<a name="l00369"></a>00369   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> output_index, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l);
<a name="l00370"></a>00370 
<a name="l00381"></a>00381   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab1fed51de792660e9124b27469ab18dd">initialize_RB_system</a>(<span class="keywordtype">bool</span> do_not_assemble);
<a name="l00382"></a>00382 
<a name="l00386"></a>00386   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00387"></a>00387 
<a name="l00391"></a>00391   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#ac4bedc52a01b44e9adb7909ebac0a02e">get_non_dirichlet_F_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00392"></a>00392 
<a name="l00396"></a>00396   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l);
<a name="l00397"></a>00397 
<a name="l00401"></a>00401   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> apply_dirichlet_bc=<span class="keyword">true</span>);
<a name="l00402"></a>00402 
<a name="l00406"></a>00406   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aad586433d469565565b32a115573df81">assemble_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00407"></a>00407 
<a name="l00411"></a>00411   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a27c29a32ebf67c226b8dc3ae3f682a28">assemble_and_add_constraint_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00412"></a>00412 
<a name="l00416"></a>00416   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#adf71ba9e50803a933457ccc9c46aa053">assemble_Aq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix, <span class="keywordtype">bool</span> apply_dirichlet_bc=<span class="keyword">true</span>);
<a name="l00417"></a>00417 
<a name="l00421"></a>00421   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7952481f6c5e334234b84aefc1b74a67">assemble_Fq_vector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* input_vector, <span class="keywordtype">bool</span> apply_dirichlet_bc=<span class="keyword">true</span>);
<a name="l00422"></a>00422 
<a name="l00427"></a>00427   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7d2cb74519604f8392e318e1e9c17524">add_scaled_Aq</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a,
<a name="l00428"></a>00428                      <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix,
<a name="l00429"></a>00429                      <span class="keywordtype">bool</span> symmetrize);
<a name="l00430"></a>00430   
<a name="l00435"></a><a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83">00435</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83">RBDataIO</a> { <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83af2b69e51a06cc310d3f79904e68a74fa">ALL_DATA</a>          = 1,
<a name="l00436"></a><a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83a7fb10f2f21a8a5cc9e2799afbf976fed">00436</a>                   <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83a7fb10f2f21a8a5cc9e2799afbf976fed">BASIS_DEPENDENT</a>   = 2,
<a name="l00437"></a><a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83aeea340d7b4b464b30e9a85207a01064c">00437</a>                   <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83aeea340d7b4b464b30e9a85207a01064c">BASIS_INDEPENDENT</a> = 3 };
<a name="l00438"></a>00438 
<a name="l00446"></a>00446   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a60572ab72b024edf5e605d09f8a0ff73">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>,
<a name="l00447"></a>00447                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83">RBDataIO</a> io_flag = <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83af2b69e51a06cc310d3f79904e68a74fa">ALL_DATA</a>);
<a name="l00448"></a>00448 
<a name="l00456"></a>00456   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acc5422cc67987a8fe82860f4ed7329cd">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>,
<a name="l00457"></a>00457                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83">RBDataIO</a> io_flag = <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83af2b69e51a06cc310d3f79904e68a74fa">ALL_DATA</a>);
<a name="l00458"></a>00458   
<a name="l00466"></a>00466   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#acc902011eff428ae2cc3d39b00014b9f">recompute_all_residual_terms</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> compute_inner_products=<span class="keyword">true</span>);
<a name="l00467"></a>00467 
<a name="l00473"></a>00473   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#ad2bd62ba62fcadaae8dfcb9cfafed754">add_new_rb_evaluation_object</a>();
<a name="l00474"></a>00474   
<a name="l00479"></a>00479   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00480"></a>00480 
<a name="l00486"></a>00486   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">residual_scaling_denom</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB);
<a name="l00487"></a>00487 
<a name="l00495"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">00495</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>; }
<a name="l00496"></a>00496 
<a name="l00500"></a>00500   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">get_SCM_lower_bound</a>();
<a name="l00501"></a>00501 
<a name="l00505"></a>00505   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#af8bc520e41a0833e9a1ac853af41ce27">get_SCM_upper_bound</a>();
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00509"></a>00509 
<a name="l00513"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">00513</a>   <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>;
<a name="l00514"></a>00514 
<a name="l00525"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a465a32a7ecf189138b5d660bbd19cbf4">00525</a>   std::vector&lt;RBEvaluation*&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a465a32a7ecf189138b5d660bbd19cbf4">rb_evaluation_objects</a>;
<a name="l00526"></a>00526 
<a name="l00534"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">00534</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a406e42df7eb0a8eda5b95b67ba5840fb">training_error_bounds</a>;
<a name="l00535"></a>00535 
<a name="l00539"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">00539</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>;
<a name="l00540"></a>00540 
<a name="l00545"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a391725fef3b8ac1a0263c02d0e9ddd6a">00545</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a391725fef3b8ac1a0263c02d0e9ddd6a">non_dirichlet_inner_product_matrix</a>;
<a name="l00546"></a>00546 
<a name="l00551"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">00551</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>;
<a name="l00552"></a>00552 
<a name="l00557"></a><a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">00557</a>   std::vector&lt; Number &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#abef8df30d43713bb06b2a83b89a0ed29">truth_outputs</a>;
<a name="l00558"></a>00558 
<a name="l00563"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">00563</a>   std::vector&lt; std::vector&lt; Number &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2e3592b7167280ef4dd92cfb4a131c62">output_dual_norms</a>;
<a name="l00564"></a>00564 
<a name="l00571"></a><a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">00571</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>;
<a name="l00572"></a>00572 
<a name="l00580"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">00580</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>;
<a name="l00581"></a>00581 
<a name="l00586"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac1607788bc38fb49c179b386fcea96b6">00586</a>   std::set&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ac1607788bc38fb49c179b386fcea96b6">global_dirichlet_dofs_set</a>;
<a name="l00587"></a>00587 
<a name="l00592"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">00592</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>;
<a name="l00593"></a>00593 
<a name="l00598"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">00598</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a740fd251422d685fa5b1256022c29a06">store_basis_functions</a>;
<a name="l00599"></a>00599 
<a name="l00606"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">00606</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>;
<a name="l00607"></a>00607 
<a name="l00612"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">00612</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>;
<a name="l00613"></a>00613 
<a name="l00618"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">00618</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>;
<a name="l00619"></a>00619 
<a name="l00624"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">00624</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a>;
<a name="l00625"></a>00625 
<a name="l00631"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">00631</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5d9cd7b5d9de8e0d7b6efde6252c449c">write_data_during_training</a>;
<a name="l00632"></a>00632 
<a name="l00638"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">00638</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a254e2165b576bf932eaa57e726a6bebf">impose_internal_dirichlet_BCs</a>;
<a name="l00639"></a>00639 
<a name="l00644"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">00644</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a>;
<a name="l00645"></a>00645   
<a name="l00649"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">00649</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a>;
<a name="l00650"></a>00650 
<a name="l00656"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a7a34b111bce6886953c74c0255ffb452">00656</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7a34b111bce6886953c74c0255ffb452">store_non_dirichlet_operators</a>;
<a name="l00657"></a>00657 
<a name="l00662"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">00662</a>   std::string <a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>;
<a name="l00663"></a>00663   
<a name="l00670"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a185d55184fb6f7c1705066908d642319">00670</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a185d55184fb6f7c1705066908d642319">enforce_constraints_exactly</a>;
<a name="l00671"></a>00671 
<a name="l00677"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">00677</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1378ada675cf004646e15be203e631c6">write_binary_basis_functions</a>;
<a name="l00678"></a>00678 
<a name="l00686"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">00686</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a03fa5b207add059829b08f156320369d">read_binary_basis_functions</a>;
<a name="l00687"></a>00687 
<a name="l00693"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">00693</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a>;
<a name="l00694"></a>00694 
<a name="l00702"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">00702</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a>;
<a name="l00703"></a>00703 
<a name="l00709"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a03ac7a535dcb71cf3192a6aed752e2bb">00709</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a03ac7a535dcb71cf3192a6aed752e2bb">use_empty_RB_solve_in_greedy</a>;
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 <span class="keyword">protected</span>:
<a name="l00712"></a>00712 
<a name="l00717"></a>00717   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a7a1f96647b766dba6edef7d2abbdb7dc">process_parameters_file</a>();
<a name="l00718"></a>00718   
<a name="l00723"></a>00723   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1c9c1a00a85356890dd4f3e4ae0acbac">allocate_data_structures</a>();
<a name="l00724"></a>00724 
<a name="l00729"></a>00729   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a58274b561dcb5823736406bb7b9efadc">truth_assembly</a>();
<a name="l00730"></a>00730 
<a name="l00735"></a>00735   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;FEMContext&gt;</a> <a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>();
<a name="l00736"></a>00736   
<a name="l00742"></a>00742   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab3721f4dcfe7b60950382a6e03607fe9">assemble_matrix_for_output_dual_solves</a>();
<a name="l00743"></a>00743 
<a name="l00748"></a>00748   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count);
<a name="l00749"></a>00749 
<a name="l00754"></a>00754   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8a840ace6f0385a830ad6ab4b4edcb49">update_greedy_param_list</a>();
<a name="l00755"></a>00755 
<a name="l00763"></a>00763   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a9cc9c114e957dd3efe0ccc11ae2d4cca">add_scaled_matrix_and_vector</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00764"></a>00764                                     <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* elem_assembly,
<a name="l00765"></a>00765                                     <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix,
<a name="l00766"></a>00766                                     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* input_vector,
<a name="l00767"></a>00767                                     <span class="keywordtype">bool</span> symmetrize=<span class="keyword">false</span>,
<a name="l00768"></a>00768                                     <span class="keywordtype">bool</span> apply_dirichlet_bc=<span class="keyword">true</span>);
<a name="l00769"></a>00769 
<a name="l00775"></a>00775   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a5231ac40d0bea4c48f6b734fcff1b4c7">set_context_solution_vec</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec);
<a name="l00776"></a>00776 
<a name="l00782"></a>00782   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ad0a9b785750043ab4777aa9825ffe67d">assemble_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00783"></a>00783                               <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* elem_assembly,
<a name="l00784"></a>00784                               <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00785"></a>00785                               <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg);
<a name="l00786"></a>00786 
<a name="l00793"></a>00793   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">assemble_misc_matrices</a>();
<a name="l00794"></a>00794 
<a name="l00799"></a>00799   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">assemble_all_affine_operators</a>();
<a name="l00800"></a>00800 
<a name="l00804"></a>00804   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a1af76f5d23ae7d1af03f6c1666673db6">assemble_all_affine_vectors</a>();
<a name="l00805"></a>00805 
<a name="l00809"></a>00809   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aac92e937e2de9cd586d8fcb92967c739">assemble_all_output_vectors</a>();
<a name="l00810"></a>00810 
<a name="l00814"></a>00814   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a8718bf6f56c88f4ccab7521f334e6a2c">compute_output_dual_norms</a>();
<a name="l00815"></a>00815 
<a name="l00828"></a>00828   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#adfbfd67ed98213fc2926fdb07209762c">compute_Fq_representor_norms</a>(<span class="keywordtype">bool</span> compute_inner_products=<span class="keyword">true</span>);
<a name="l00829"></a>00829 
<a name="l00834"></a>00834   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ada44f7c1f672088d8ef2b6b8abc35cd5">enrich_RB_space</a>();
<a name="l00835"></a>00835 
<a name="l00840"></a>00840   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">update_system</a>();
<a name="l00841"></a>00841   
<a name="l00846"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ade32dc013fdad1eca4b1e03839651928">00846</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#ade32dc013fdad1eca4b1e03839651928">get_RB_error_bound</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a3e451b7c989bc337a99936a07b3fedf6">RB_solve</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()); }
<a name="l00847"></a>00847 
<a name="l00851"></a>00851   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a22351bccb17903c68cfd546412d04f3c">update_RB_system_matrices</a>();
<a name="l00852"></a>00852 
<a name="l00860"></a>00860   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a07341a81eabf77b919f6835638228946">update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products=<span class="keyword">true</span>);
<a name="l00861"></a>00861 
<a name="l00868"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">00868</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>&amp; ) {}
<a name="l00869"></a>00869 
<a name="l00875"></a>00875   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l00876"></a>00876 
<a name="l00882"></a>00882   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">zero_dirichlet_dofs_on_vector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; temp);
<a name="l00883"></a>00883   
<a name="l00888"></a>00888   std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a6f1c9a07eabe425ffbc8ebf2155bb187">get_F_EIM_indices</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00892"></a>00892 
<a name="l00897"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">00897</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>;
<a name="l00898"></a>00898 
<a name="l00903"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">00903</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>;
<a name="l00904"></a>00904 
<a name="l00909"></a><a class="code" href="classlibMesh_1_1RBSystem.php#af9e792c87763ddd32985062b119c9a7e">00909</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#af9e792c87763ddd32985062b119c9a7e">quiet_mode</a>;
<a name="l00910"></a>00910 
<a name="l00915"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">00915</a>   std::string <a class="code" href="classlibMesh_1_1RBSystem.php#ab53684df668b4dbad08d68fd6be1fd37">eigen_system_name</a>;
<a name="l00916"></a>00916 
<a name="l00920"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa2eaa8e2e173d7d317ec46ca4b62163d">00920</a>   <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#aa2eaa8e2e173d7d317ec46ca4b62163d">inner_prod_assembly</a>;
<a name="l00921"></a>00921 
<a name="l00926"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a0219c6a3aff294bc2329897bb5c8840b">00926</a>   <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a0219c6a3aff294bc2329897bb5c8840b">constraint_assembly</a>;
<a name="l00927"></a>00927 
<a name="l00933"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad5491bba0da39e7003947d15599bc200">00933</a>   std::vector&lt;ElemAssembly*&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ad5491bba0da39e7003947d15599bc200">A_q_assembly_vector</a>;
<a name="l00934"></a>00934 
<a name="l00939"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ad9af308a3a1c8684a4dd800b24fc430e">00939</a>   std::vector&lt;ElemAssembly*&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ad9af308a3a1c8684a4dd800b24fc430e">F_q_assembly_vector</a>;
<a name="l00940"></a>00940 
<a name="l00945"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a03cecb39a21deac5a30786d5780fe47f">00945</a>   std::vector&lt; std::vector&lt;ElemAssembly*&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a03cecb39a21deac5a30786d5780fe47f">output_assembly_vector</a>;
<a name="l00946"></a>00946 
<a name="l00952"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a20e880b9ff431b5a28eb4e7e75a4a635">00952</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a20e880b9ff431b5a28eb4e7e75a4a635">output_dual_norms_computed</a>;
<a name="l00953"></a>00953 
<a name="l00959"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ae995b192e4724170fd61d602f15600c3">00959</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ae995b192e4724170fd61d602f15600c3">Fq_representor_norms_computed</a>;
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 <span class="keyword">private</span>:
<a name="l00962"></a>00962 
<a name="l00963"></a>00963   <span class="comment">//----------- PRIVATE DATA MEMBERS -----------//</span>
<a name="l00964"></a>00964 
<a name="l00968"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aaa2202b0964672c378c69f671cbd25af">00968</a>   std::vector&lt;RBTheta*&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aaa2202b0964672c378c69f671cbd25af">theta_q_f_vector</a>;
<a name="l00969"></a>00969 
<a name="l00973"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a14ccfe52c9863e81feb204529e727464">00973</a>   std::vector&lt; std::vector&lt;RBTheta*&gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a14ccfe52c9863e81feb204529e727464">theta_q_l_vector</a>;
<a name="l00974"></a>00974   
<a name="l00979"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">00979</a>   std::vector&lt; RBEIMSystem* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a1c0266ace79018f4fe863549db995171">F_EIM_systems_vector</a>;
<a name="l00980"></a>00980 
<a name="l00985"></a><a class="code" href="classlibMesh_1_1RBSystem.php#aa90d4e2b5d8b202ac1df3673ddfc43f3">00985</a>   std::vector&lt;ElemAssembly*&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#aa90d4e2b5d8b202ac1df3673ddfc43f3">A_EIM_assembly_vector</a>;
<a name="l00986"></a>00986 
<a name="l00991"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ae5c148c4ad8fec099d9fc7756060f481">00991</a>   std::vector&lt;ElemAssembly*&gt; <a class="code" href="classlibMesh_1_1RBSystem.php#ae5c148c4ad8fec099d9fc7756060f481">F_EIM_assembly_vector</a>;
<a name="l00992"></a>00992 
<a name="l00996"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">00996</a>   std::vector&lt; SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a2950621ecac9122266a6893e18735778">A_q_vector</a>;
<a name="l00997"></a>00997 
<a name="l01002"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">01002</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a6c86729bd0f4556a8574e3638282fc01">F_q_vector</a>;
<a name="l01003"></a>01003 
<a name="l01009"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a30c1b625e737e4d66753cbc75569ff28">01009</a>   std::vector&lt; SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a30c1b625e737e4d66753cbc75569ff28">non_dirichlet_A_q_vector</a>;
<a name="l01010"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a76610f202972e50b26fbda568814b36e">01010</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a76610f202972e50b26fbda568814b36e">non_dirichlet_F_q_vector</a>;
<a name="l01011"></a>01011 
<a name="l01016"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">01016</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a3060a5cc6031acfef4808df71e3eda08">outputs_vector</a>;
<a name="l01017"></a>01017 
<a name="l01021"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">01021</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1RBSystem.php#a56a24996be9d774563f1a8e6165ed038">training_tolerance</a>;
<a name="l01022"></a>01022 
<a name="l01026"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a28adfa277c293f06e0c533cfbedf60c0">01026</a>   <a class="code" href="classlibMesh_1_1DirichletDofAssembly.php">DirichletDofAssembly</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a28adfa277c293f06e0c533cfbedf60c0">_dirichlet_list_init</a>;
<a name="l01027"></a>01027 
<a name="l01031"></a><a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">01031</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1RBSystem.php#ac5a6b09c8f4e8d788be2ad45dc1bfb05">RB_system_initialized</a>;
<a name="l01032"></a>01032   
<a name="l01039"></a><a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">01039</a>   <a class="code" href="classlibMesh_1_1RBEIMSystem.php">RBEIMSystem</a>* <a class="code" href="classlibMesh_1_1RBSystem.php#a9343f08e1c88fd8a6eb290038383ae6d">current_EIM_system</a>;
<a name="l01040"></a>01040 };
<a name="l01041"></a>01041 
<a name="l01042"></a>01042 } <span class="comment">// namespace libMesh</span>
<a name="l01043"></a>01043 
<a name="l01044"></a>01044 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
