<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">reference_counted_object.h</div>  </div>
</div>
<div class="contents">
<a href="reference__counted__object_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001  <span class="comment">// $Id: reference_counted_object.h 4342 2011-04-13 14:22:17Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __reference_counted_object_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __reference_counted_object_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;typeinfo&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="reference__counter_8h.php">reference_counter.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00068"></a>00068 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00069"></a>00069 <span class="comment">// ReferenceCounter class definition</span>
<a name="l00070"></a>00070 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00071"></a><a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">00071</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCounter.php">ReferenceCounter</a>
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073 <span class="keyword">protected</span>:
<a name="l00074"></a>00074 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1ReferenceCountedObject.php#ac0cfe9eb6071328881f1f030e7294b2b">00080</a>   <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php#ac0cfe9eb6071328881f1f030e7294b2b">ReferenceCountedObject</a> ()
<a name="l00081"></a>00081   {
<a name="l00082"></a>00082 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>    
<a name="l00084"></a>00084     <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a4d69475c6ae8e441306e90e57d755ced">increment_constructor_count</a>(<span class="keyword">typeid</span>(T).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>());
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>  }
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1ReferenceCountedObject.php#a28b9840ef385c49451a79099154785e2">00092</a>   <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php#ac0cfe9eb6071328881f1f030e7294b2b">ReferenceCountedObject</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&amp; other)
<a name="l00093"></a>00093     : <a class="code" href="classlibMesh_1_1ReferenceCounter.php">ReferenceCounter</a>(other)
<a name="l00094"></a>00094   {
<a name="l00095"></a>00095 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>    
<a name="l00097"></a>00097     <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a4d69475c6ae8e441306e90e57d755ced">increment_constructor_count</a>(<span class="keyword">typeid</span>(T).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>());
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="preprocessor">#endif</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>  }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">public</span>:
<a name="l00103"></a>00103   
<a name="l00107"></a><a class="code" href="classlibMesh_1_1ReferenceCountedObject.php#a3693d7857056e4159def9b9fb1e4451d">00107</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php#a3693d7857056e4159def9b9fb1e4451d">~ReferenceCountedObject</a> ()
<a name="l00108"></a>00108   {
<a name="l00109"></a>00109 <span class="preprocessor">#if defined(LIBMESH_ENABLE_REFERENCE_COUNTING) &amp;&amp; defined(DEBUG)</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>    
<a name="l00111"></a>00111     <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a9f8ca3935940b9b1a60f7645e856f2e4">increment_destructor_count</a>(<span class="keyword">typeid</span>(T).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>());
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>  }
<a name="l00115"></a>00115   
<a name="l00116"></a>00116 <span class="keyword">private</span>:
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 };
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 } <span class="comment">// namespace libMesh</span>
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="preprocessor">#endif // end #ifndef __reference_counted_object_h__</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
