<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sensitivity_data.h</div>  </div>
</div>
<div class="contents">
<a href="sensitivity__data_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// $Id: sensitivity_data.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00006"></a>00006 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00007"></a>00007   
<a name="l00008"></a>00008 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00010"></a>00010 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012   
<a name="l00013"></a>00013 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00017"></a>00017   
<a name="l00018"></a>00018 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00019"></a>00019 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00020"></a>00020 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifndef __sensitivity_data_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#define __sensitivity_data_h__</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="parameter__vector_8h.php">parameter_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// Forward declaractions</span>
<a name="l00040"></a>00040   <span class="keyword">class </span>QoISet;
<a name="l00041"></a>00041   
<a name="l00046"></a><a class="code" href="classlibMesh_1_1SensitivityData.php">00046</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>: 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php">00049</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php">Row</a>
<a name="l00050"></a>00050   {
<a name="l00051"></a>00051   <span class="keyword">public</span>:
<a name="l00052"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ac2edfbd6bcf34d276b370a0534788c42">00052</a>     <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ac2edfbd6bcf34d276b370a0534788c42">Row</a>(<a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a> &amp;sd, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi) : <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ab2666141a57957f134200d61aa6e54e7">_sd</a>(sd), <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ac5ae4e3ca6a5a891cf363048be1a05da">_qoi</a>(qoi) {}
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#aaac4d0746340d3ca809d3ee14950ca9e">00054</a>     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#aaac4d0746340d3ca809d3ee14950ca9e">operator[] </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter) { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ab2666141a57957f134200d61aa6e54e7">_sd</a>.<a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">derivative</a>(<a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ac5ae4e3ca6a5a891cf363048be1a05da">_qoi</a>, parameter); }
<a name="l00055"></a>00055   <span class="keyword">private</span>:
<a name="l00056"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ab2666141a57957f134200d61aa6e54e7">00056</a>     <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a> &amp;<a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ab2666141a57957f134200d61aa6e54e7">_sd</a>;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ac5ae4e3ca6a5a891cf363048be1a05da">00057</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php#ac5ae4e3ca6a5a891cf363048be1a05da">_qoi</a>;
<a name="l00058"></a>00058   };
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php">00060</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php">ConstRow</a>
<a name="l00061"></a>00061   {
<a name="l00062"></a>00062   <span class="keyword">public</span>:
<a name="l00063"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a19bc21d2766d01a537e3a979b06f82c9">00063</a>     <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a19bc21d2766d01a537e3a979b06f82c9">ConstRow</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a> &amp;sd, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi) : <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a557b93a5ee35c5aa26ccf96ddc2489e6">_sd</a>(sd), <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#ae7b73c2f8eb0ba62b0f88ec88ee85b48">_qoi</a>(qoi) {}
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a431840ba602fa36e723896733a0c9b09">00065</a>     <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a431840ba602fa36e723896733a0c9b09">operator[] </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter) { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a557b93a5ee35c5aa26ccf96ddc2489e6">_sd</a>.<a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">derivative</a>(<a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#ae7b73c2f8eb0ba62b0f88ec88ee85b48">_qoi</a>, parameter); }
<a name="l00066"></a>00066   <span class="keyword">private</span>:
<a name="l00067"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a557b93a5ee35c5aa26ccf96ddc2489e6">00067</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a> &amp;<a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#a557b93a5ee35c5aa26ccf96ddc2489e6">_sd</a>;
<a name="l00068"></a><a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#ae7b73c2f8eb0ba62b0f88ec88ee85b48">00068</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php#ae7b73c2f8eb0ba62b0f88ec88ee85b48">_qoi</a>;
<a name="l00069"></a>00069   };
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#af9a742e57176e802b8da8e54ee670572">00074</a>   <a class="code" href="classlibMesh_1_1SensitivityData.php#af9a742e57176e802b8da8e54ee670572">SensitivityData</a>() {}
<a name="l00075"></a>00075 
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1SensitivityData.php#af9a742e57176e802b8da8e54ee670572">SensitivityData</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00081"></a>00081                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00082"></a>00082                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameter_vector);
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a0792ae55472e237250532062b1170bbd">00087</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a0792ae55472e237250532062b1170bbd">clear</a>() { <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>.clear(); }
<a name="l00088"></a>00088 
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">allocate_data</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices,
<a name="l00094"></a>00094                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00095"></a>00095                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameter_vector);
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a11e2068254ef4c765d3a0e8c957540b0">allocate_hessian_data</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices,
<a name="l00102"></a>00102                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00103"></a>00103                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameter_vector);
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">derivative</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00110"></a>00110                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index) <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00116"></a>00116   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00117"></a>00117                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index1,
<a name="l00118"></a>00118                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index2) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00124"></a>00124   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">derivative</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00125"></a>00125                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index);
<a name="l00126"></a>00126 
<a name="l00132"></a>00132   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00133"></a>00133                              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index1,
<a name="l00134"></a>00134                              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index2);
<a name="l00135"></a>00135 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a410f6a5e1fc106bb5d89cccf118a9af9">00140</a>   <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php">ConstRow</a> <a class="code" href="classlibMesh_1_1SensitivityData.php#a410f6a5e1fc106bb5d89cccf118a9af9">operator[] </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData_1_1ConstRow.php">ConstRow</a>(*<span class="keyword">this</span>, qoi); }
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a4067eaf3feab65dfbcc937a454b2f2e4">00142</a>   <a class="code" href="classlibMesh_1_1SensitivityData_1_1Row.php">Row</a> <a class="code" href="classlibMesh_1_1SensitivityData.php#a410f6a5e1fc106bb5d89cccf118a9af9">operator[] </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi) { <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">Row</a>(*<span class="keyword">this</span>, qoi); }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">private</span>: 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">00148</a>   std::vector&lt;std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>;
<a name="l00149"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">00149</a>   std::vector&lt;std::vector&lt;std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>;
<a name="l00150"></a>00150 };
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00155"></a>00155 <span class="comment">// SensitivityData inline methods</span>
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">inline</span>
<a name="l00160"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a88e227214a241e20502da4dcf111c56e">00160</a> <a class="code" href="classlibMesh_1_1SensitivityData.php#af9a742e57176e802b8da8e54ee670572">SensitivityData::SensitivityData</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices,
<a name="l00161"></a>00161                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00162"></a>00162                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameter_vector)
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164   this-&gt;<a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">allocate_data</a>(qoi_indices, sys, parameter_vector);
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="keyword">inline</span>
<a name="l00170"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">00170</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">SensitivityData::allocate_data</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices,
<a name="l00171"></a>00171                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00172"></a>00172                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameter_vector)
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameter_vector.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l00175"></a>00175   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nq = sys.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>.size() &lt; Nq)
<a name="l00178"></a>00178     <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>.resize(Nq);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00181"></a>00181     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00182"></a>00182       {
<a name="l00183"></a>00183         <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>[i].clear();
<a name="l00184"></a>00184         <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>[i].resize(Np);
<a name="l00185"></a>00185       }
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="keyword">inline</span>
<a name="l00191"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a11e2068254ef4c765d3a0e8c957540b0">00191</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a11e2068254ef4c765d3a0e8c957540b0">SensitivityData::allocate_hessian_data</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices,
<a name="l00192"></a>00192                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00193"></a>00193                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameter_vector)
<a name="l00194"></a>00194 {
<a name="l00195"></a>00195   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameter_vector.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l00196"></a>00196   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nq = sys.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size();
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>.size() &lt; Nq)
<a name="l00199"></a>00199     <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>.resize(Nq);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00202"></a>00202     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00203"></a>00203       {
<a name="l00204"></a>00204         <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[i].clear();
<a name="l00205"></a>00205         <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[i].resize(Np);
<a name="l00206"></a>00206         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != Np; ++j)
<a name="l00207"></a>00207           <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[i][j].resize(Np);
<a name="l00208"></a>00208       }
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="keyword">inline</span>
<a name="l00214"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">00214</a> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">SensitivityData::derivative</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00215"></a>00215                                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index)<span class="keyword"> const</span>
<a name="l00216"></a>00216 <span class="keyword"></span>{
<a name="l00217"></a>00217   libmesh_assert(qoi_index &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>.size());
<a name="l00218"></a>00218   libmesh_assert(parameter_index &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>[qoi_index].size());
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>[qoi_index][parameter_index];
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="keyword">inline</span>
<a name="l00226"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a5cd5cd37263df8460227fcca1096965a">00226</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#abfceb7699b3dff371ea1b784800f2bad">SensitivityData::derivative</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00227"></a>00227                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index)
<a name="l00228"></a>00228 {
<a name="l00229"></a>00229   libmesh_assert(qoi_index &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>.size());
<a name="l00230"></a>00230   libmesh_assert(parameter_index &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>[qoi_index].size());
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#a4ae21f32a2f545edba76895831a065bd">_grad_data</a>[qoi_index][parameter_index];
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="keyword">inline</span>
<a name="l00238"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">00238</a> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">SensitivityData::second_derivative</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00239"></a>00239                                                  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index1,
<a name="l00240"></a>00240                                                  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index2)<span class="keyword"> const</span>
<a name="l00241"></a>00241 <span class="keyword"></span>{
<a name="l00242"></a>00242   libmesh_assert(qoi_index &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>.size());
<a name="l00243"></a>00243   libmesh_assert(parameter_index1 &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[qoi_index].size());
<a name="l00244"></a>00244   libmesh_assert(parameter_index2 &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[qoi_index][parameter_index1].size());
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[qoi_index][parameter_index1][parameter_index2];
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="keyword">inline</span>
<a name="l00252"></a><a class="code" href="classlibMesh_1_1SensitivityData.php#a1715d278a00212c1f08b07de5689363d">00252</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; <a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">SensitivityData::second_derivative</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_index,
<a name="l00253"></a>00253                                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index1,
<a name="l00254"></a>00254                                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parameter_index2)
<a name="l00255"></a>00255 {
<a name="l00256"></a>00256   libmesh_assert(qoi_index &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>.size());
<a name="l00257"></a>00257   libmesh_assert(parameter_index1 &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[qoi_index].size());
<a name="l00258"></a>00258   libmesh_assert(parameter_index2 &lt; <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[qoi_index][parameter_index1].size());
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SensitivityData.php#ad425071c202e27a43c68744336aaa3a4">_hess_data</a>[qoi_index][parameter_index1][parameter_index2];
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 } <span class="comment">// namespace libMesh</span>
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="preprocessor">#endif // #define __sensitivity_data_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
