<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">serial_mesh.h</div>  </div>
</div>
<div class="contents">
<a href="serial__mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: serial_mesh.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __serial_mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __serial_mesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// Mesh class definition</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1SerialMesh.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049  <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1SerialMesh.php#aab2a56fa6891b94372b32fc82cef4bec">SerialMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim=1);
<a name="l00057"></a>00057 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1SerialMesh.php#aab2a56fa6891b94372b32fc82cef4bec">SerialMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh);
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1SerialMesh.php#aab2a56fa6891b94372b32fc82cef4bec">SerialMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SerialMesh.php">SerialMesh</a>&amp; other_mesh);
<a name="l00069"></a>00069 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a6fab2d2a4b8ab0183a0ad017e7dcf970">00073</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a6fab2d2a4b8ab0183a0ad017e7dcf970">clone</a> ()<span class="keyword"> const</span>
<a name="l00074"></a>00074 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#aab2a56fa6891b94372b32fc82cef4bec">SerialMesh</a>(*<span class="keyword">this</span>)); }
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a887e540e5f1e7666e5b22f198801e5ad">~SerialMesh</a>();
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a29c594df4c7f11c15c87b5b482e9327d">clear</a>();
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a8b3e19eff64d5f61d75cbf2d530e2937">renumber_nodes_and_elements</a> ();
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a8663838de3fd5f6a62de99fd5dc28684">00091</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a8663838de3fd5f6a62de99fd5dc28684">n_nodes</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.size(); }
<a name="l00092"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a178f3af8661af253df13b871c1750202">00092</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a178f3af8661af253df13b871c1750202">max_node_id</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.size(); }
<a name="l00093"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#afac78c9047e79415f3b2437e68701384">00093</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#afac78c9047e79415f3b2437e68701384">reserve_nodes</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn) { <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.reserve (nn); }
<a name="l00094"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#af9885d8e4bc2de648011e4cf7c693a38">00094</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#af9885d8e4bc2de648011e4cf7c693a38">n_elem</a> ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.size(); }
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a40081b0f81d6b315586ed6650a00d979">n_active_elem</a> () <span class="keyword">const</span>;
<a name="l00096"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a54a1b1436d87b2b1cee4bdc2e48080ef">00096</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a54a1b1436d87b2b1cee4bdc2e48080ef">max_elem_id</a> ()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.size(); }
<a name="l00097"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ac3927266cf78936e9040c48f2aff9a7d">00097</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#ac3927266cf78936e9040c48f2aff9a7d">reserve_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne) { <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.reserve (ne); }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// SerialMesh has no caches to update</span>
<a name="l00100"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#abc50c9b0546ad1931dcfa63c1e96fa7a">00100</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#abc50c9b0546ad1931dcfa63c1e96fa7a">update_parallel_id_counts</a> () {}
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1SerialMesh.php#a87911b85515e11ef893d27d9048796c7">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp;  <a class="code" href="classlibMesh_1_1SerialMesh.php#a7689d07c1d2cbfc4696f162eda8bc084">node</a>  (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1SerialMesh.php#a7689d07c1d2cbfc4696f162eda8bc084">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1SerialMesh.php#a299244374ec78f6b5e9eb3df3c67cf66">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1SerialMesh.php#a299244374ec78f6b5e9eb3df3c67cf66">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1SerialMesh.php#a4ae4fad4e0080a770a7430df28ff0788">elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00111"></a>00111 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1SerialMesh.php#af94be3c53bfe169c3ff25f36b805e904">add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00116"></a>00116                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> =
<a name="l00117"></a>00117                              <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>,
<a name="l00118"></a>00118                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id =
<a name="l00119"></a>00119                              <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1SerialMesh.php#a80e333274ee4ffa9b1124e744ebf544c">add_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) ;
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3986cec0342dcd70c986278d8300b272">delete_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) ;
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a4a4b6f2364535e03965a4ebcda795dd6">renumber_node</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1SerialMesh.php#a372c4863d8784a0b3ac4ac3b9bc1e33e">add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) ;
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1SerialMesh.php#a30d0df62a9fedd52506fbde948c1d6d8">insert_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) ;
<a name="l00125"></a>00125   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a25ad416306bc3fb0f6726e7ce3968d77">delete_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) ;
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#a006f1784e9fba7852c93223a64b19f63">renumber_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00127"></a>00127 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SerialMesh.php#afe201fc8512212a3356d1bfba2d72eae">fix_broken_node_and_element_numbering</a> ();
<a name="l00135"></a>00135   
<a name="l00136"></a>00136 <span class="keyword">public</span>:
<a name="l00140"></a>00140   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aee3eedf865124e1e1f13089325107a3f">elements_begin</a> ();
<a name="l00141"></a>00141   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#ac46ed4bda194fbf08bca9f209c66f9e1">elements_end</a>   ();
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aaf83e4bf38168fae921772b8b67d068c">active_elements_begin</a> ();
<a name="l00144"></a>00144   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#ab57508d958674dd25e8d472fa943656f">active_elements_end</a>   ();
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a731e85224684aa448442dccecd289f73">ancestor_elements_begin</a> ();
<a name="l00147"></a>00147   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a34d56861309d2cb7f79e0d7f26c3bb61">ancestor_elements_end</a>   ();
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a87263f76365f372e70f13555138c5f6a">subactive_elements_begin</a> ();
<a name="l00150"></a>00150   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a620a1b359e615dfce6a86725fea97e2a">subactive_elements_end</a>   ();
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9f97c608412ffa20b206ce0506c3d51d">not_active_elements_begin</a> ();
<a name="l00153"></a>00153   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a23ea5c81118bf557fbcfc2e76aad6052">not_active_elements_end</a>   ();
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#acbc71c44dc62f93b4e61d906555b0b20">not_ancestor_elements_begin</a> ();
<a name="l00156"></a>00156   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a3d0b17a58633753c3e3d602e46338d3c">not_ancestor_elements_end</a>   ();
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a40b5eee7221d46585f3ee28767ea3917">not_subactive_elements_begin</a> ();
<a name="l00159"></a>00159   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a308a62cccd9eeb967e35007f975385ef">not_subactive_elements_end</a>   ();
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a304b5d1624cfe9aa060dd9c9cecd14f7">local_elements_begin</a> ();
<a name="l00162"></a>00162   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de4e8a7d794cfddc410b4a375176f19">local_elements_end</a>   ();
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a147636d117f505dfcf5fe3bdd43d3996">not_local_elements_begin</a> ();
<a name="l00165"></a>00165   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a66843d87a8edf2e2cc9f229011ecf14e">not_local_elements_end</a>   ();
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a30fafe9214ca2f4eaca83dccd77684a8">active_local_elements_begin</a> ();
<a name="l00168"></a>00168   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a33c794e9c1751d0c8e850e181043008e">active_local_elements_end</a>   ();
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de059028ed0e518902ba58339aeaa4d">active_not_local_elements_begin</a> ();
<a name="l00171"></a>00171   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aa20d6eb0c94fccd9b9ffb2a7401577cb">active_not_local_elements_end</a>   ();
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ff4a4ec07efede11cc35a83484d8ddd">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00174"></a>00174   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7780ef600299c2303afd5939853aef79">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7445fe14d9f3eeb3e8e2869d31bb071f">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00177"></a>00177   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ad044ee8cf0a3ad0dbdc09338edbaef">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a92975781c65056dbcdbdf39ad31933c8">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00180"></a>00180   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aa56a289d2ad7160e28c06ac947a65dc7">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#abe15d4217528cc656728cb59de7fcace">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00183"></a>00183   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9e7725883e7d45530186b51740384e22">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00186"></a>00186   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#acbdfd81fe1687a3d790e4c32ac713c4c">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00189"></a>00189   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a65862f6c9a1045ab8df1ff00ccd3adb5">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a3edb97b3158c427ec8ef1d28fe1c12c2">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00192"></a>00192   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7ec1e19f9ad924ea48b8c9b22f44d04f">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a0128ee5d4f5323b7bd1725858dc9a89b">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00195"></a>00195   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#afe3b3772b302fd16bd00110a2812f9ee">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a0161e28677de677433bd2851b44f1ca9">unpartitioned_elements_begin</a> ();
<a name="l00198"></a>00198   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a56c4d96036de3481270727db27170afd">unpartitioned_elements_end</a> ();
<a name="l00199"></a>00199   
<a name="l00200"></a>00200   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a908d14d924d6f98509d3c7cf87b6654c">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00201"></a>00201   element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9d17fe409085de23788af3b5cd326c97">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00202"></a>00202   
<a name="l00206"></a>00206   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aee3eedf865124e1e1f13089325107a3f">elements_begin</a>() <span class="keyword">const</span>;
<a name="l00207"></a>00207   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#ac46ed4bda194fbf08bca9f209c66f9e1">elements_end</a>()   <span class="keyword">const</span>;
<a name="l00208"></a>00208   
<a name="l00209"></a>00209   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aaf83e4bf38168fae921772b8b67d068c">active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00210"></a>00210   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#ab57508d958674dd25e8d472fa943656f">active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a731e85224684aa448442dccecd289f73">ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00213"></a>00213   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a34d56861309d2cb7f79e0d7f26c3bb61">ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00214"></a>00214   
<a name="l00215"></a>00215   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a87263f76365f372e70f13555138c5f6a">subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00216"></a>00216   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a620a1b359e615dfce6a86725fea97e2a">subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00217"></a>00217   
<a name="l00218"></a>00218   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9f97c608412ffa20b206ce0506c3d51d">not_active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00219"></a>00219   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a23ea5c81118bf557fbcfc2e76aad6052">not_active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#acbc71c44dc62f93b4e61d906555b0b20">not_ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00222"></a>00222   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a3d0b17a58633753c3e3d602e46338d3c">not_ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a40b5eee7221d46585f3ee28767ea3917">not_subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00225"></a>00225   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a308a62cccd9eeb967e35007f975385ef">not_subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a304b5d1624cfe9aa060dd9c9cecd14f7">local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de4e8a7d794cfddc410b4a375176f19">local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a147636d117f505dfcf5fe3bdd43d3996">not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00231"></a>00231   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a66843d87a8edf2e2cc9f229011ecf14e">not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a30fafe9214ca2f4eaca83dccd77684a8">active_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00234"></a>00234   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a33c794e9c1751d0c8e850e181043008e">active_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de059028ed0e518902ba58339aeaa4d">active_not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00237"></a>00237   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aa20d6eb0c94fccd9b9ffb2a7401577cb">active_not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ff4a4ec07efede11cc35a83484d8ddd">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00240"></a>00240   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7780ef600299c2303afd5939853aef79">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7445fe14d9f3eeb3e8e2869d31bb071f">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00243"></a>00243   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ad044ee8cf0a3ad0dbdc09338edbaef">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a92975781c65056dbcdbdf39ad31933c8">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00246"></a>00246   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#aa56a289d2ad7160e28c06ac947a65dc7">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#abe15d4217528cc656728cb59de7fcace">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00249"></a>00249   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9e7725883e7d45530186b51740384e22">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00252"></a>00252   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#acbdfd81fe1687a3d790e4c32ac713c4c">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00255"></a>00255   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a65862f6c9a1045ab8df1ff00ccd3adb5">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a3edb97b3158c427ec8ef1d28fe1c12c2">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00258"></a>00258   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a7ec1e19f9ad924ea48b8c9b22f44d04f">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a0128ee5d4f5323b7bd1725858dc9a89b">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00261"></a>00261   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#afe3b3772b302fd16bd00110a2812f9ee">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a0161e28677de677433bd2851b44f1ca9">unpartitioned_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00264"></a>00264   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a56c4d96036de3481270727db27170afd">unpartitioned_elements_end</a> () <span class="keyword">const</span>;
<a name="l00265"></a>00265   
<a name="l00266"></a>00266   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a908d14d924d6f98509d3c7cf87b6654c">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00267"></a>00267   const_element_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a9d17fe409085de23788af3b5cd326c97">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   
<a name="l00270"></a>00270   
<a name="l00271"></a>00271   
<a name="l00272"></a>00272   
<a name="l00273"></a>00273   
<a name="l00277"></a>00277   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a1060dbaa6d605a3c86eade4c77db0bf6">nodes_begin</a>();
<a name="l00278"></a>00278   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a42f4248f397ec953551488fe5ffb384b">nodes_end</a>();
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a077908da95fc8ce9b6c89baa4f6e0608">active_nodes_begin</a>();
<a name="l00281"></a>00281   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a49211a9a8ac63ea200ceeef327b3913e">active_nodes_end</a>();
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#ad895b5b34272ef3a1ed66c0cc1a2ccb6">local_nodes_begin</a>  ();
<a name="l00284"></a>00284   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a60c7b0a245aacdee7a47a7629c231f5c">local_nodes_end</a>    ();
<a name="l00285"></a>00285   
<a name="l00286"></a>00286   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a3ad7879951e41a04f8febd717abe10ad">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00287"></a>00287   node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a5ce6e0a421311128e1a6b338fa0176d5">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00288"></a>00288 
<a name="l00292"></a>00292   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a1060dbaa6d605a3c86eade4c77db0bf6">nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00293"></a>00293   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a42f4248f397ec953551488fe5ffb384b">nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a077908da95fc8ce9b6c89baa4f6e0608">active_nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00296"></a>00296   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a49211a9a8ac63ea200ceeef327b3913e">active_nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#ad895b5b34272ef3a1ed66c0cc1a2ccb6">local_nodes_begin</a>  () <span class="keyword">const</span>;
<a name="l00299"></a>00299   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a60c7b0a245aacdee7a47a7629c231f5c">local_nodes_end</a>    () <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a3ad7879951e41a04f8febd717abe10ad">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00302"></a>00302   const_node_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a5ce6e0a421311128e1a6b338fa0176d5">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00303"></a>00303   
<a name="l00304"></a>00304 <span class="keyword">protected</span>:
<a name="l00308"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">00308</a>   std::vector&lt;Node*&gt; <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>;
<a name="l00309"></a>00309   
<a name="l00313"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">00313</a>   std::vector&lt;Elem*&gt; <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="keyword">private</span>:
<a name="l00316"></a>00316   
<a name="l00321"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a47feb28a7253ffea18d28d11394d1b6a">00321</a>   <span class="keyword">typedef</span> std::vector&lt;Elem*&gt;::iterator             <a class="code" href="classlibMesh_1_1SerialMesh.php#a47feb28a7253ffea18d28d11394d1b6a">elem_iterator_imp</a>;
<a name="l00322"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a2479ee04780eaa620602d77c18d27462">00322</a>   <span class="keyword">typedef</span> std::vector&lt;Elem*&gt;::const_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a2479ee04780eaa620602d77c18d27462">const_elem_iterator_imp</a>;
<a name="l00323"></a>00323 
<a name="l00328"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aee8c416ee715ff445311a434f16f46f2">00328</a>   <span class="keyword">typedef</span> std::vector&lt;Node*&gt;::iterator             <a class="code" href="classlibMesh_1_1SerialMesh.php#aee8c416ee715ff445311a434f16f46f2">node_iterator_imp</a>;
<a name="l00329"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a103884e922a39ce393e7ed6e623807e4">00329</a>   <span class="keyword">typedef</span> std::vector&lt;Node*&gt;::const_iterator <a class="code" href="classlibMesh_1_1SerialMesh.php#a103884e922a39ce393e7ed6e623807e4">const_node_iterator_imp</a>;
<a name="l00330"></a>00330 };
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 } <span class="comment">// namespace libMesh</span>
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
