<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">serial_mesh_iterators.C</div>  </div>
</div>
<div class="contents">
<a href="serial__mesh__iterators_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: serial_mesh_iterators.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libSerialMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="comment">// #include &quot;mesh_base.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="serial__mesh_8h.php">serial_mesh.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// This file contains the implementation of all the different iterator</span>
<a name="l00033"></a>00033 <span class="comment">// functions for the mesh class.  They were put here to save space in the</span>
<a name="l00034"></a>00034 <span class="comment">// header files.</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// default begin() accessor</span>
<a name="l00038"></a>00038 SerialMesh::element_iterator
<a name="l00039"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aee3eedf865124e1e1f13089325107a3f">00039</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aee3eedf865124e1e1f13089325107a3f">SerialMesh::elements_begin</a> ()
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;elem_iterator_imp&gt;</a> p;
<a name="l00042"></a>00042   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// active elements begin() accessor</span>
<a name="l00048"></a>00048 SerialMesh::element_iterator
<a name="l00049"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aaf83e4bf38168fae921772b8b67d068c">00049</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aaf83e4bf38168fae921772b8b67d068c">SerialMesh::active_elements_begin</a> ()
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;elem_iterator_imp&gt;</a> p;
<a name="l00052"></a>00052   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="comment">// not active elements begin() accessor</span>
<a name="l00058"></a>00058 SerialMesh::element_iterator
<a name="l00059"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a9f97c608412ffa20b206ce0506c3d51d">00059</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9f97c608412ffa20b206ce0506c3d51d">SerialMesh::not_active_elements_begin</a> ()
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <a class="code" href="structlibMesh_1_1Predicates_1_1NotActive.php">Predicates::NotActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00062"></a>00062   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="comment">// ancestor elements begin() accessor</span>
<a name="l00068"></a>00068 SerialMesh::element_iterator
<a name="l00069"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a731e85224684aa448442dccecd289f73">00069</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a731e85224684aa448442dccecd289f73">SerialMesh::ancestor_elements_begin</a> ()
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00072"></a>00072   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">// not ancestor elements begin() accessor</span>
<a name="l00078"></a>00078 SerialMesh::element_iterator
<a name="l00079"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#acbc71c44dc62f93b4e61d906555b0b20">00079</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#acbc71c44dc62f93b4e61d906555b0b20">SerialMesh::not_ancestor_elements_begin</a> ()
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00082"></a>00082   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="comment">// subactive elements begin() accessor</span>
<a name="l00088"></a>00088 SerialMesh::element_iterator
<a name="l00089"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a87263f76365f372e70f13555138c5f6a">00089</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a87263f76365f372e70f13555138c5f6a">SerialMesh::subactive_elements_begin</a> ()
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   <a class="code" href="structlibMesh_1_1Predicates_1_1SubActive.php">Predicates::SubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00092"></a>00092   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="comment">// not subactive elements begin() accessor</span>
<a name="l00098"></a>00098 SerialMesh::element_iterator
<a name="l00099"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a40b5eee7221d46585f3ee28767ea3917">00099</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a40b5eee7221d46585f3ee28767ea3917">SerialMesh::not_subactive_elements_begin</a> ()
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   <a class="code" href="structlibMesh_1_1Predicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00102"></a>00102   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">// local elements begin() accessor</span>
<a name="l00108"></a>00108 SerialMesh::element_iterator
<a name="l00109"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a304b5d1624cfe9aa060dd9c9cecd14f7">00109</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a304b5d1624cfe9aa060dd9c9cecd14f7">SerialMesh::local_elements_begin</a> ()
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;elem_iterator_imp&gt;</a> p;
<a name="l00112"></a>00112   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">// not_local elements begin() accessor</span>
<a name="l00118"></a>00118 SerialMesh::element_iterator
<a name="l00119"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a147636d117f505dfcf5fe3bdd43d3996">00119</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a147636d117f505dfcf5fe3bdd43d3996">SerialMesh::not_local_elements_begin</a> ()
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLocal.php">Predicates::NotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00122"></a>00122   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="comment">// active local elements begin() accessor</span>
<a name="l00128"></a>00128 SerialMesh::element_iterator
<a name="l00129"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a30fafe9214ca2f4eaca83dccd77684a8">00129</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a30fafe9214ca2f4eaca83dccd77684a8">SerialMesh::active_local_elements_begin</a> ()
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00132"></a>00132   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="comment">// active_not_local elements begin() accessor</span>
<a name="l00138"></a>00138 SerialMesh::element_iterator
<a name="l00139"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a9de059028ed0e518902ba58339aeaa4d">00139</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de059028ed0e518902ba58339aeaa4d">SerialMesh::active_not_local_elements_begin</a> ()
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00142"></a>00142   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="comment">// level elements begin() accessor</span>
<a name="l00148"></a>00148 SerialMesh::element_iterator
<a name="l00149"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a2ff4a4ec07efede11cc35a83484d8ddd">00149</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ff4a4ec07efede11cc35a83484d8ddd">SerialMesh::level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00150"></a>00150 {
<a name="l00151"></a>00151   <a class="code" href="structlibMesh_1_1Predicates_1_1Level.php">Predicates::Level&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00152"></a>00152   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00153"></a>00153 }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="comment">// not level elements begin() accessor</span>
<a name="l00158"></a>00158 SerialMesh::element_iterator
<a name="l00159"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7445fe14d9f3eeb3e8e2869d31bb071f">00159</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7445fe14d9f3eeb3e8e2869d31bb071f">SerialMesh::not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLevel.php">Predicates::NotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00162"></a>00162   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="comment">// local level elements begin() accessor</span>
<a name="l00168"></a>00168 SerialMesh::element_iterator
<a name="l00169"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a92975781c65056dbcdbdf39ad31933c8">00169</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a92975781c65056dbcdbdf39ad31933c8">SerialMesh::local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00172"></a>00172   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="comment">// local not level elements begin() accessor</span>
<a name="l00178"></a>00178 SerialMesh::element_iterator
<a name="l00179"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#abe15d4217528cc656728cb59de7fcace">00179</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#abe15d4217528cc656728cb59de7fcace">SerialMesh::local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00182"></a>00182   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 <span class="comment">// pid elements begin() accessor</span>
<a name="l00188"></a>00188 SerialMesh::element_iterator
<a name="l00189"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">00189</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">SerialMesh::pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00190"></a>00190 {
<a name="l00191"></a>00191   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00192"></a>00192   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="comment">// type elements begin() accessor</span>
<a name="l00198"></a>00198 SerialMesh::element_iterator
<a name="l00199"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#acbdfd81fe1687a3d790e4c32ac713c4c">00199</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#acbdfd81fe1687a3d790e4c32ac713c4c">SerialMesh::type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201   <a class="code" href="structlibMesh_1_1Predicates_1_1Type.php">Predicates::Type&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00202"></a>00202   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="comment">// active type elements begin() accessor</span>
<a name="l00208"></a>00208 SerialMesh::element_iterator
<a name="l00209"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a3edb97b3158c427ec8ef1d28fe1c12c2">00209</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3edb97b3158c427ec8ef1d28fe1c12c2">SerialMesh::active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveType.php">Predicates::ActiveType&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00212"></a>00212   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="comment">// active pid elements begin() accessor</span>
<a name="l00218"></a>00218 SerialMesh::element_iterator
<a name="l00219"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a0128ee5d4f5323b7bd1725858dc9a89b">00219</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a0128ee5d4f5323b7bd1725858dc9a89b">SerialMesh::active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   <a class="code" href="structlibMesh_1_1Predicates_1_1ActivePID.php">Predicates::ActivePID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00222"></a>00222   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="comment">// unpartitioned elements begin() accessor</span>
<a name="l00228"></a>00228 SerialMesh::element_iterator
<a name="l00229"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a0161e28677de677433bd2851b44f1ca9">00229</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a0161e28677de677433bd2851b44f1ca9">SerialMesh::unpartitioned_elements_begin</a> ()
<a name="l00230"></a>00230 {
<a name="l00231"></a>00231   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">pid_elements_begin</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="comment">// subdomain elements begin() accessor</span>
<a name="l00237"></a>00237 SerialMesh::element_iterator
<a name="l00238"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a908d14d924d6f98509d3c7cf87b6654c">00238</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a908d14d924d6f98509d3c7cf87b6654c">SerialMesh::active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)
<a name="l00239"></a>00239 {
<a name="l00240"></a>00240   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00241"></a>00241   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="comment">// default const begin() accessor</span>
<a name="l00251"></a>00251 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00252"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7bdc13e0c2324448db01e2ea089be5a2">00252</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aee3eedf865124e1e1f13089325107a3f">SerialMesh::elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00253"></a>00253 <span class="keyword"></span>{
<a name="l00254"></a>00254   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00255"></a>00255   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00256"></a>00256 }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="comment">// const active begin() accessor</span>
<a name="l00261"></a>00261 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00262"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#af154b94ba91ae37a22d407dd3750f861">00262</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aaf83e4bf38168fae921772b8b67d068c">SerialMesh::active_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00263"></a>00263 <span class="keyword"></span>{
<a name="l00264"></a>00264   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00265"></a>00265   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00266"></a>00266 }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 <span class="comment">// const not active begin() accessor</span>
<a name="l00271"></a>00271 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00272"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a427b1d2b42c6cc95182a83842e2809a9">00272</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9f97c608412ffa20b206ce0506c3d51d">SerialMesh::not_active_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00273"></a>00273 <span class="keyword"></span>{
<a name="l00274"></a>00274   <a class="code" href="structlibMesh_1_1Predicates_1_1NotActive.php">Predicates::NotActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00275"></a>00275   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="comment">// const ancestor begin() accessor</span>
<a name="l00281"></a>00281 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00282"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a373d8ad5f50dbeb0701957beb7e3bb47">00282</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a731e85224684aa448442dccecd289f73">SerialMesh::ancestor_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00283"></a>00283 <span class="keyword"></span>{
<a name="l00284"></a>00284   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00285"></a>00285   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00286"></a>00286 }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 <span class="comment">// const not ancestor begin() accessor</span>
<a name="l00291"></a>00291 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00292"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ad4f35842b92a21be9797d8634d4bb9fd">00292</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#acbc71c44dc62f93b4e61d906555b0b20">SerialMesh::not_ancestor_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00293"></a>00293 <span class="keyword"></span>{
<a name="l00294"></a>00294   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00295"></a>00295   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00296"></a>00296 }
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="comment">// const subactive begin() accessor</span>
<a name="l00301"></a>00301 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00302"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a5e63f65565d3bba81123bbb296a793aa">00302</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a87263f76365f372e70f13555138c5f6a">SerialMesh::subactive_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00303"></a>00303 <span class="keyword"></span>{
<a name="l00304"></a>00304   <a class="code" href="structlibMesh_1_1Predicates_1_1SubActive.php">Predicates::SubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00305"></a>00305   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="comment">// const not subactive begin() accessor</span>
<a name="l00311"></a>00311 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00312"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a66ff63de38614f128793803224aadde5">00312</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a40b5eee7221d46585f3ee28767ea3917">SerialMesh::not_subactive_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00313"></a>00313 <span class="keyword"></span>{
<a name="l00314"></a>00314   <a class="code" href="structlibMesh_1_1Predicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00315"></a>00315   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 <span class="comment">// const local begin() accessor</span>
<a name="l00321"></a>00321 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00322"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#af8e696aacfb147385bd3f4e51e35bff1">00322</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a304b5d1624cfe9aa060dd9c9cecd14f7">SerialMesh::local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00323"></a>00323 <span class="keyword"></span>{
<a name="l00324"></a>00324   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00325"></a>00325   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="comment">// const not_local begin() accessor</span>
<a name="l00331"></a>00331 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00332"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a920da8ec2719dff8e3c4fe70eef3ac86">00332</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a147636d117f505dfcf5fe3bdd43d3996">SerialMesh::not_local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00333"></a>00333 <span class="keyword"></span>{
<a name="l00334"></a>00334   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLocal.php">Predicates::NotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00335"></a>00335   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="comment">// const active local begin() accessor</span>
<a name="l00341"></a>00341 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00342"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a301619984cc51d614c76c4772573e631">00342</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a30fafe9214ca2f4eaca83dccd77684a8">SerialMesh::active_local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00343"></a>00343 <span class="keyword"></span>{
<a name="l00344"></a>00344   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00345"></a>00345   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00346"></a>00346 }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 <span class="comment">// const active not_local begin() accessor</span>
<a name="l00351"></a>00351 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00352"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a935bcc7022938b1ca839ddad44498d76">00352</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de059028ed0e518902ba58339aeaa4d">SerialMesh::active_not_local_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00353"></a>00353 <span class="keyword"></span>{
<a name="l00354"></a>00354   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00355"></a>00355   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="comment">// const level begin() accessor</span>
<a name="l00361"></a>00361 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00362"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#afca8f5ff06e73a3ac06ab1ec5d1c1dd5">00362</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ff4a4ec07efede11cc35a83484d8ddd">SerialMesh::level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00363"></a>00363 <span class="keyword"></span>{
<a name="l00364"></a>00364   <a class="code" href="structlibMesh_1_1Predicates_1_1Level.php">Predicates::Level&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00365"></a>00365   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00366"></a>00366 }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 <span class="comment">// const not level begin() accessor</span>
<a name="l00371"></a>00371 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00372"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ac376384703dc4e1b087ff8dfc507766c">00372</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7445fe14d9f3eeb3e8e2869d31bb071f">SerialMesh::not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00373"></a>00373 <span class="keyword"></span>{
<a name="l00374"></a>00374   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLevel.php">Predicates::NotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00375"></a>00375   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="comment">// const local level begin() accessor</span>
<a name="l00381"></a>00381 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00382"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a0504615a99179136478c00bf704a6486">00382</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a92975781c65056dbcdbdf39ad31933c8">SerialMesh::local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00383"></a>00383 <span class="keyword"></span>{
<a name="l00384"></a>00384   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00385"></a>00385   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 <span class="comment">// const local not level begin() accessor</span>
<a name="l00391"></a>00391 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00392"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a3d2f0a4c33bd4960153d153798f7729b">00392</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#abe15d4217528cc656728cb59de7fcace">SerialMesh::local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00393"></a>00393 <span class="keyword"></span>{
<a name="l00394"></a>00394   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00395"></a>00395   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00396"></a>00396 }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 <span class="comment">// const pid begin() accessor</span>
<a name="l00401"></a>00401 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00402"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a5834255392355d65eb73e9c9c3ab9b13">00402</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">SerialMesh::pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00403"></a>00403 <span class="keyword"></span>{
<a name="l00404"></a>00404   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00405"></a>00405   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00406"></a>00406 }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 <span class="comment">// const type begin() accessor</span>
<a name="l00411"></a>00411 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00412"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a41b422f779f329594c303b59fdf25383">00412</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#acbdfd81fe1687a3d790e4c32ac713c4c">SerialMesh::type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00413"></a>00413 <span class="keyword"></span>{
<a name="l00414"></a>00414   <a class="code" href="structlibMesh_1_1Predicates_1_1Type.php">Predicates::Type&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00415"></a>00415   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00416"></a>00416 }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="comment">// const active type begin() accessor</span>
<a name="l00421"></a>00421 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00422"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a2a7f394796d45bd9463839b011bb04d6">00422</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3edb97b3158c427ec8ef1d28fe1c12c2">SerialMesh::active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00423"></a>00423 <span class="keyword"></span>{
<a name="l00424"></a>00424   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveType.php">Predicates::ActiveType&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00425"></a>00425   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00426"></a>00426 }
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="comment">// const active pid elements begin() accessor</span>
<a name="l00431"></a>00431 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00432"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a45c7fe80ae4c2299a6852343426d774e">00432</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a0128ee5d4f5323b7bd1725858dc9a89b">SerialMesh::active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00433"></a>00433 <span class="keyword"></span>{
<a name="l00434"></a>00434   <a class="code" href="structlibMesh_1_1Predicates_1_1ActivePID.php">Predicates::ActivePID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00435"></a>00435   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00436"></a>00436 }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="comment">// const unpartitioned elements begin() accessor</span>
<a name="l00441"></a>00441 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00442"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a4e87ea3cfbf50b2a6c997d1410c17421">00442</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a0161e28677de677433bd2851b44f1ca9">SerialMesh::unpartitioned_elements_begin</a> ()<span class="keyword"> const</span>
<a name="l00443"></a>00443 <span class="keyword"></span>{
<a name="l00444"></a>00444   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1SerialMesh.php#a7d8fc0e6a4b296dd846c84209557c7db">pid_elements_begin</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00445"></a>00445 }
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="comment">// subdomain elements begin() accessor</span>
<a name="l00450"></a>00450 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00451"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#afd645ff44e27563872f83b7e6eba1709">00451</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a908d14d924d6f98509d3c7cf87b6654c">SerialMesh::active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)<span class="keyword"> const</span>
<a name="l00452"></a>00452 <span class="keyword"></span>{
<a name="l00453"></a>00453   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;const_elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00454"></a>00454   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 <span class="comment">// default end() accessor</span>
<a name="l00464"></a>00464 SerialMesh::element_iterator
<a name="l00465"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ac46ed4bda194fbf08bca9f209c66f9e1">00465</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#ac46ed4bda194fbf08bca9f209c66f9e1">SerialMesh::elements_end</a> ()
<a name="l00466"></a>00466 {
<a name="l00467"></a>00467   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;elem_iterator_imp&gt;</a> p;
<a name="l00468"></a>00468   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00469"></a>00469 }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 <span class="comment">// active end() accessor</span>
<a name="l00474"></a>00474 SerialMesh::element_iterator
<a name="l00475"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ab57508d958674dd25e8d472fa943656f">00475</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#ab57508d958674dd25e8d472fa943656f">SerialMesh::active_elements_end</a> ()
<a name="l00476"></a>00476 {
<a name="l00477"></a>00477   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;elem_iterator_imp&gt;</a> p;
<a name="l00478"></a>00478   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00479"></a>00479 }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="comment">// active end() accessor</span>
<a name="l00484"></a>00484 SerialMesh::element_iterator
<a name="l00485"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a23ea5c81118bf557fbcfc2e76aad6052">00485</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a23ea5c81118bf557fbcfc2e76aad6052">SerialMesh::not_active_elements_end</a> ()
<a name="l00486"></a>00486 {
<a name="l00487"></a>00487   <a class="code" href="structlibMesh_1_1Predicates_1_1NotActive.php">Predicates::NotActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00488"></a>00488   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 <span class="comment">// ancestor end() accessor</span>
<a name="l00494"></a>00494 SerialMesh::element_iterator
<a name="l00495"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a34d56861309d2cb7f79e0d7f26c3bb61">00495</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a34d56861309d2cb7f79e0d7f26c3bb61">SerialMesh::ancestor_elements_end</a> ()
<a name="l00496"></a>00496 {
<a name="l00497"></a>00497   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00498"></a>00498   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00499"></a>00499 }
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 <span class="comment">// ancestor end() accessor</span>
<a name="l00504"></a>00504 SerialMesh::element_iterator
<a name="l00505"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a3d0b17a58633753c3e3d602e46338d3c">00505</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3d0b17a58633753c3e3d602e46338d3c">SerialMesh::not_ancestor_elements_end</a> ()
<a name="l00506"></a>00506 {
<a name="l00507"></a>00507   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;elem_iterator_imp&gt;</a> p;
<a name="l00508"></a>00508   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00509"></a>00509 }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="comment">// subactive end() accessor</span>
<a name="l00514"></a>00514 SerialMesh::element_iterator
<a name="l00515"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a620a1b359e615dfce6a86725fea97e2a">00515</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a620a1b359e615dfce6a86725fea97e2a">SerialMesh::subactive_elements_end</a> ()
<a name="l00516"></a>00516 {
<a name="l00517"></a>00517   <a class="code" href="structlibMesh_1_1Predicates_1_1SubActive.php">Predicates::SubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00518"></a>00518   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00519"></a>00519 }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 <span class="comment">// subactive end() accessor</span>
<a name="l00524"></a>00524 SerialMesh::element_iterator
<a name="l00525"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a308a62cccd9eeb967e35007f975385ef">00525</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a308a62cccd9eeb967e35007f975385ef">SerialMesh::not_subactive_elements_end</a> ()
<a name="l00526"></a>00526 {
<a name="l00527"></a>00527   <a class="code" href="structlibMesh_1_1Predicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;elem_iterator_imp&gt;</a> p;
<a name="l00528"></a>00528   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00529"></a>00529 }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 <span class="comment">// local end() accessor</span>
<a name="l00534"></a>00534 SerialMesh::element_iterator
<a name="l00535"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a9de4e8a7d794cfddc410b4a375176f19">00535</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de4e8a7d794cfddc410b4a375176f19">SerialMesh::local_elements_end</a> ()
<a name="l00536"></a>00536 {
<a name="l00537"></a>00537   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;elem_iterator_imp&gt;</a> p;
<a name="l00538"></a>00538   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00539"></a>00539 }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 <span class="comment">// not_local end() accessor</span>
<a name="l00544"></a>00544 SerialMesh::element_iterator
<a name="l00545"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a66843d87a8edf2e2cc9f229011ecf14e">00545</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a66843d87a8edf2e2cc9f229011ecf14e">SerialMesh::not_local_elements_end</a> ()
<a name="l00546"></a>00546 {
<a name="l00547"></a>00547   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLocal.php">Predicates::NotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00548"></a>00548   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00549"></a>00549 }
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 <span class="comment">// active local end() accessor</span>
<a name="l00554"></a>00554 SerialMesh::element_iterator
<a name="l00555"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a33c794e9c1751d0c8e850e181043008e">00555</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a33c794e9c1751d0c8e850e181043008e">SerialMesh::active_local_elements_end</a> ()
<a name="l00556"></a>00556 {
<a name="l00557"></a>00557   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00558"></a>00558   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 <span class="comment">// not_local end() accessor</span>
<a name="l00564"></a>00564 SerialMesh::element_iterator
<a name="l00565"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aa20d6eb0c94fccd9b9ffb2a7401577cb">00565</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aa20d6eb0c94fccd9b9ffb2a7401577cb">SerialMesh::active_not_local_elements_end</a> ()
<a name="l00566"></a>00566 {
<a name="l00567"></a>00567   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;elem_iterator_imp&gt;</a> p;
<a name="l00568"></a>00568   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00569"></a>00569 }
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 <span class="comment">// level end() accessor</span>
<a name="l00574"></a>00574 SerialMesh::element_iterator
<a name="l00575"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7780ef600299c2303afd5939853aef79">00575</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7780ef600299c2303afd5939853aef79">SerialMesh::level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00576"></a>00576 {
<a name="l00577"></a>00577   <a class="code" href="structlibMesh_1_1Predicates_1_1Level.php">Predicates::Level&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00578"></a>00578   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00579"></a>00579 }
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 <span class="comment">// not level end() accessor</span>
<a name="l00584"></a>00584 SerialMesh::element_iterator
<a name="l00585"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a2ad044ee8cf0a3ad0dbdc09338edbaef">00585</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ad044ee8cf0a3ad0dbdc09338edbaef">SerialMesh::not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00586"></a>00586 {
<a name="l00587"></a>00587   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLevel.php">Predicates::NotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00588"></a>00588   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00589"></a>00589 }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 <span class="comment">// local level end() accessor</span>
<a name="l00594"></a>00594 SerialMesh::element_iterator
<a name="l00595"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aa56a289d2ad7160e28c06ac947a65dc7">00595</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aa56a289d2ad7160e28c06ac947a65dc7">SerialMesh::local_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00596"></a>00596 {
<a name="l00597"></a>00597   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00598"></a>00598   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00599"></a>00599 }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 <span class="comment">// local not level end() accessor</span>
<a name="l00604"></a>00604 SerialMesh::element_iterator
<a name="l00605"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a9e7725883e7d45530186b51740384e22">00605</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9e7725883e7d45530186b51740384e22">SerialMesh::local_not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00606"></a>00606 {
<a name="l00607"></a>00607   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;elem_iterator_imp&gt;</a> p(level);
<a name="l00608"></a>00608   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00609"></a>00609 }
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 <span class="comment">// pid end() accessor</span>
<a name="l00614"></a>00614 SerialMesh::element_iterator
<a name="l00615"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">00615</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">SerialMesh::pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00616"></a>00616 {
<a name="l00617"></a>00617   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00618"></a>00618   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00619"></a>00619 }
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 <span class="comment">// type end() accessor</span>
<a name="l00624"></a>00624 SerialMesh::element_iterator
<a name="l00625"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a65862f6c9a1045ab8df1ff00ccd3adb5">00625</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a65862f6c9a1045ab8df1ff00ccd3adb5">SerialMesh::type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00626"></a>00626 {
<a name="l00627"></a>00627   <a class="code" href="structlibMesh_1_1Predicates_1_1Type.php">Predicates::Type&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00628"></a>00628   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00629"></a>00629 }
<a name="l00630"></a>00630 
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 <span class="comment">// active type end() accessor</span>
<a name="l00634"></a>00634 SerialMesh::element_iterator
<a name="l00635"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7ec1e19f9ad924ea48b8c9b22f44d04f">00635</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7ec1e19f9ad924ea48b8c9b22f44d04f">SerialMesh::active_type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00636"></a>00636 {
<a name="l00637"></a>00637   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveType.php">Predicates::ActiveType&lt;elem_iterator_imp&gt;</a> p(type);
<a name="l00638"></a>00638   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00639"></a>00639 }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 <span class="comment">// active PID end() accessor</span>
<a name="l00644"></a>00644 SerialMesh::element_iterator
<a name="l00645"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#afe3b3772b302fd16bd00110a2812f9ee">00645</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#afe3b3772b302fd16bd00110a2812f9ee">SerialMesh::active_pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00646"></a>00646 {
<a name="l00647"></a>00647   <a class="code" href="structlibMesh_1_1Predicates_1_1ActivePID.php">Predicates::ActivePID&lt;elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00648"></a>00648   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="comment">// unpartitioned elements end() accessor</span>
<a name="l00654"></a>00654 SerialMesh::element_iterator
<a name="l00655"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a56c4d96036de3481270727db27170afd">00655</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a56c4d96036de3481270727db27170afd">SerialMesh::unpartitioned_elements_end</a> ()
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">pid_elements_end</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 <span class="comment">// subdomain elements end() accessor</span>
<a name="l00663"></a>00663 SerialMesh::element_iterator
<a name="l00664"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a9d17fe409085de23788af3b5cd326c97">00664</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9d17fe409085de23788af3b5cd326c97">SerialMesh::active_local_subdomain_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)
<a name="l00665"></a>00665 {
<a name="l00666"></a>00666   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00667"></a>00667   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00668"></a>00668 }
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 <span class="comment">// default const end() accessor</span>
<a name="l00681"></a>00681 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00682"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aa76a664be9d1347f05f56cfcb37c4194">00682</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#ac46ed4bda194fbf08bca9f209c66f9e1">SerialMesh::elements_end</a> ()<span class="keyword"> const</span>
<a name="l00683"></a>00683 <span class="keyword"></span>{
<a name="l00684"></a>00684   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00685"></a>00685   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00686"></a>00686 }
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 <span class="comment">// active const end() accessor</span>
<a name="l00691"></a>00691 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00692"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a60c54b5ad870a571d4b2b77cf2fde9f1">00692</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#ab57508d958674dd25e8d472fa943656f">SerialMesh::active_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00693"></a>00693 <span class="keyword"></span>{
<a name="l00694"></a>00694   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00695"></a>00695   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00696"></a>00696 }
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 <span class="comment">// not active const end() accessor</span>
<a name="l00701"></a>00701 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00702"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a45f9311571da55a25dd14ed34b93c207">00702</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a23ea5c81118bf557fbcfc2e76aad6052">SerialMesh::not_active_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00703"></a>00703 <span class="keyword"></span>{
<a name="l00704"></a>00704   <a class="code" href="structlibMesh_1_1Predicates_1_1NotActive.php">Predicates::NotActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00705"></a>00705   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 <span class="comment">// ancestor const end() accessor</span>
<a name="l00711"></a>00711 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00712"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a265fec65b41d0ba57322fc8a7fb26a55">00712</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a34d56861309d2cb7f79e0d7f26c3bb61">SerialMesh::ancestor_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00713"></a>00713 <span class="keyword"></span>{
<a name="l00714"></a>00714   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00715"></a>00715   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00716"></a>00716 }
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 <span class="comment">// not ancestor const end() accessor</span>
<a name="l00721"></a>00721 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00722"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#acace7dd9d0ea43fb71b2b6ce16c84d62">00722</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3d0b17a58633753c3e3d602e46338d3c">SerialMesh::not_ancestor_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00723"></a>00723 <span class="keyword"></span>{
<a name="l00724"></a>00724   <a class="code" href="structlibMesh_1_1Predicates_1_1Ancestor.php">Predicates::Ancestor&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00725"></a>00725   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00726"></a>00726 }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a>00730 <span class="comment">// subactive const end() accessor</span>
<a name="l00731"></a>00731 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00732"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a822f75bdd2dc5e940b20e152fcf03bd6">00732</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a620a1b359e615dfce6a86725fea97e2a">SerialMesh::subactive_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00733"></a>00733 <span class="keyword"></span>{
<a name="l00734"></a>00734   <a class="code" href="structlibMesh_1_1Predicates_1_1SubActive.php">Predicates::SubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00735"></a>00735   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00736"></a>00736 }
<a name="l00737"></a>00737 
<a name="l00738"></a>00738 
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 <span class="comment">// not subactive const end() accessor</span>
<a name="l00741"></a>00741 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00742"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ad15a393a429cfdb29e3ecdc349e793ee">00742</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a308a62cccd9eeb967e35007f975385ef">SerialMesh::not_subactive_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00743"></a>00743 <span class="keyword"></span>{
<a name="l00744"></a>00744   <a class="code" href="structlibMesh_1_1Predicates_1_1NotSubActive.php">Predicates::NotSubActive&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00745"></a>00745   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00746"></a>00746 }
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 <span class="comment">// local const end() accessor</span>
<a name="l00751"></a>00751 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00752"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aeb4436e4adb415ea1ed666d3b8ebe2c8">00752</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9de4e8a7d794cfddc410b4a375176f19">SerialMesh::local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00753"></a>00753 <span class="keyword"></span>{
<a name="l00754"></a>00754   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00755"></a>00755   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00756"></a>00756 }
<a name="l00757"></a>00757 
<a name="l00758"></a>00758 
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 <span class="comment">// not_local const end() accessor</span>
<a name="l00761"></a>00761 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00762"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a871582eb4339df8cebcedaa300f44dcb">00762</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a66843d87a8edf2e2cc9f229011ecf14e">SerialMesh::not_local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00763"></a>00763 <span class="keyword"></span>{
<a name="l00764"></a>00764   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLocal.php">Predicates::NotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00765"></a>00765   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00766"></a>00766 }
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 <span class="comment">// local active const end() accessor</span>
<a name="l00771"></a>00771 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00772"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a50ad71f2a066e2707301cb494359cc0a">00772</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a33c794e9c1751d0c8e850e181043008e">SerialMesh::active_local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00773"></a>00773 <span class="keyword"></span>{
<a name="l00774"></a>00774   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocal.php">Predicates::ActiveLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00775"></a>00775   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00776"></a>00776 }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 <span class="comment">// const local active const end() accessor</span>
<a name="l00781"></a>00781 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00782"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ad65bb3dd748e567da709d5200e3ad8dd">00782</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aa20d6eb0c94fccd9b9ffb2a7401577cb">SerialMesh::active_not_local_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00783"></a>00783 <span class="keyword"></span>{
<a name="l00784"></a>00784   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveNotLocal.php">Predicates::ActiveNotLocal&lt;const_elem_iterator_imp&gt;</a> p;
<a name="l00785"></a>00785   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00786"></a>00786 }
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 <span class="comment">// level const end() accessor</span>
<a name="l00791"></a>00791 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00792"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a565c8f72357e8db3dd52e77539ef3928">00792</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7780ef600299c2303afd5939853aef79">SerialMesh::level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00793"></a>00793 <span class="keyword"></span>{
<a name="l00794"></a>00794   <a class="code" href="structlibMesh_1_1Predicates_1_1Level.php">Predicates::Level&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00795"></a>00795   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00796"></a>00796 }
<a name="l00797"></a>00797 
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 <span class="comment">// not level const end() accessor</span>
<a name="l00801"></a>00801 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00802"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a83bb322f73221685c756bf2107d69cee">00802</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a2ad044ee8cf0a3ad0dbdc09338edbaef">SerialMesh::not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00803"></a>00803 <span class="keyword"></span>{
<a name="l00804"></a>00804   <a class="code" href="structlibMesh_1_1Predicates_1_1NotLevel.php">Predicates::NotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00805"></a>00805   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00806"></a>00806 }
<a name="l00807"></a>00807 
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 
<a name="l00810"></a>00810 <span class="comment">// local level const end() accessor</span>
<a name="l00811"></a>00811 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00812"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7b2f0a1afca04cbfba4df176e4e4231d">00812</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#aa56a289d2ad7160e28c06ac947a65dc7">SerialMesh::local_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00813"></a>00813 <span class="keyword"></span>{
<a name="l00814"></a>00814   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalLevel.php">Predicates::LocalLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00815"></a>00815   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00816"></a>00816 }
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 <span class="comment">// local not level const end() accessor</span>
<a name="l00821"></a>00821 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00822"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a7f89d4c8266704e476f99a1c6bde03ab">00822</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9e7725883e7d45530186b51740384e22">SerialMesh::local_not_level_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)<span class="keyword"> const</span>
<a name="l00823"></a>00823 <span class="keyword"></span>{
<a name="l00824"></a>00824   <a class="code" href="structlibMesh_1_1Predicates_1_1LocalNotLevel.php">Predicates::LocalNotLevel&lt;const_elem_iterator_imp&gt;</a> p(level);
<a name="l00825"></a>00825   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00826"></a>00826 }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 <span class="comment">// pid const end() accessor</span>
<a name="l00831"></a>00831 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00832"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a2f7861901af71b19b039d2c6479ad39a">00832</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">SerialMesh::pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00833"></a>00833 <span class="keyword"></span>{
<a name="l00834"></a>00834   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00835"></a>00835   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00836"></a>00836 }
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00840"></a>00840 <span class="comment">// type const end() accessor</span>
<a name="l00841"></a>00841 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00842"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a85d192fc0b30703cc700797ae43e1929">00842</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a65862f6c9a1045ab8df1ff00ccd3adb5">SerialMesh::type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00843"></a>00843 <span class="keyword"></span>{
<a name="l00844"></a>00844   <a class="code" href="structlibMesh_1_1Predicates_1_1Type.php">Predicates::Type&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00845"></a>00845   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00846"></a>00846 }
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 
<a name="l00850"></a>00850 <span class="comment">// active type const end() accessor</span>
<a name="l00851"></a>00851 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00852"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#afbc3c43bb556a356b163da3ca4c0d782">00852</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a7ec1e19f9ad924ea48b8c9b22f44d04f">SerialMesh::active_type_elements_end</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)<span class="keyword"> const</span>
<a name="l00853"></a>00853 <span class="keyword"></span>{
<a name="l00854"></a>00854   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveType.php">Predicates::ActiveType&lt;const_elem_iterator_imp&gt;</a> p(type);
<a name="l00855"></a>00855   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00856"></a>00856 }
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 <span class="comment">// active PID end() accessor</span>
<a name="l00861"></a>00861 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00862"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#af0fa3dc4cfcd43c9e7099eddc8a7c24f">00862</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#afe3b3772b302fd16bd00110a2812f9ee">SerialMesh::active_pid_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00863"></a>00863 <span class="keyword"></span>{
<a name="l00864"></a>00864   <a class="code" href="structlibMesh_1_1Predicates_1_1ActivePID.php">Predicates::ActivePID&lt;const_elem_iterator_imp&gt;</a> p(proc_id);
<a name="l00865"></a>00865   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00866"></a>00866 }
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 
<a name="l00869"></a>00869 
<a name="l00870"></a>00870 <span class="comment">// unpartitioned elements end() accessor</span>
<a name="l00871"></a>00871 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00872"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#adab78cc34574ded51c66966a477fed02">00872</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a56c4d96036de3481270727db27170afd">SerialMesh::unpartitioned_elements_end</a> ()<span class="keyword"> const</span>
<a name="l00873"></a>00873 <span class="keyword"></span>{
<a name="l00874"></a>00874   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1SerialMesh.php#a4839c83d9483d74d8cef7b40be929672">pid_elements_end</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00875"></a>00875 }
<a name="l00876"></a>00876 
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 
<a name="l00879"></a>00879 <span class="comment">// subdomain elements end() accessor</span>
<a name="l00880"></a>00880 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">SerialMesh::const_element_iterator</a>
<a name="l00881"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a59e835c620600a71612f2d221f834f13">00881</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a9d17fe409085de23788af3b5cd326c97">SerialMesh::active_local_subdomain_elements_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id)<span class="keyword"> const</span>
<a name="l00882"></a>00882 <span class="keyword"></span>{
<a name="l00883"></a>00883   <a class="code" href="structlibMesh_1_1Predicates_1_1ActiveLocalSubdomain.php">Predicates::ActiveLocalSubdomain&lt;const_elem_iterator_imp&gt;</a> p(subdomain_id);
<a name="l00884"></a>00884   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acfd0315f8d0009ae9720cab45c8b6f7e">_elements</a>.end(), p);
<a name="l00885"></a>00885 }
<a name="l00886"></a>00886 
<a name="l00887"></a>00887 
<a name="l00888"></a>00888 
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 <span class="comment">// default nodes begin() accessor</span>
<a name="l00893"></a>00893 SerialMesh::node_iterator
<a name="l00894"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a1060dbaa6d605a3c86eade4c77db0bf6">00894</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a1060dbaa6d605a3c86eade4c77db0bf6">SerialMesh::nodes_begin</a> ()
<a name="l00895"></a>00895 {
<a name="l00896"></a>00896   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;node_iterator_imp&gt;</a> p;
<a name="l00897"></a>00897   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00898"></a>00898 }
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 
<a name="l00901"></a>00901 
<a name="l00902"></a>00902 <span class="comment">// active nodes begin() accessor</span>
<a name="l00903"></a>00903 SerialMesh::node_iterator
<a name="l00904"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a077908da95fc8ce9b6c89baa4f6e0608">00904</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a077908da95fc8ce9b6c89baa4f6e0608">SerialMesh::active_nodes_begin</a> ()
<a name="l00905"></a>00905 {
<a name="l00906"></a>00906   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;node_iterator_imp&gt;</a> p;
<a name="l00907"></a>00907   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00908"></a>00908 }
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 <span class="comment">// local nodes begin() accessor</span>
<a name="l00913"></a>00913 SerialMesh::node_iterator
<a name="l00914"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#ad895b5b34272ef3a1ed66c0cc1a2ccb6">00914</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#ad895b5b34272ef3a1ed66c0cc1a2ccb6">SerialMesh::local_nodes_begin</a> ()
<a name="l00915"></a>00915 {
<a name="l00916"></a>00916   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;node_iterator_imp&gt;</a> p;
<a name="l00917"></a>00917   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00918"></a>00918 }
<a name="l00919"></a>00919 
<a name="l00920"></a>00920 
<a name="l00921"></a>00921 
<a name="l00922"></a>00922 <span class="comment">// pid nodes begin() accessor</span>
<a name="l00923"></a>00923 SerialMesh::node_iterator
<a name="l00924"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a3ad7879951e41a04f8febd717abe10ad">00924</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3ad7879951e41a04f8febd717abe10ad">SerialMesh::pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00925"></a>00925 {
<a name="l00926"></a>00926   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;node_iterator_imp&gt;</a> p(proc_id);
<a name="l00927"></a>00927   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00928"></a>00928 }
<a name="l00929"></a>00929 
<a name="l00930"></a>00930 
<a name="l00931"></a>00931 
<a name="l00932"></a>00932 <span class="comment">// default const nodes begin() accessor</span>
<a name="l00933"></a>00933 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l00934"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a0317dd285c1b53260db6fc5c294b48cf">00934</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a1060dbaa6d605a3c86eade4c77db0bf6">SerialMesh::nodes_begin</a> ()<span class="keyword"> const</span>
<a name="l00935"></a>00935 <span class="keyword"></span>{
<a name="l00936"></a>00936   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;const_node_iterator_imp&gt;</a> p;
<a name="l00937"></a>00937   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00938"></a>00938 }
<a name="l00939"></a>00939 
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 
<a name="l00942"></a>00942 <span class="comment">// active const nodes begin() accessor</span>
<a name="l00943"></a>00943 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l00944"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#af2b784c6169226a64d535e80160573ee">00944</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a077908da95fc8ce9b6c89baa4f6e0608">SerialMesh::active_nodes_begin</a> ()<span class="keyword"> const</span>
<a name="l00945"></a>00945 <span class="keyword"></span>{
<a name="l00946"></a>00946   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;const_node_iterator_imp&gt;</a> p;
<a name="l00947"></a>00947   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00948"></a>00948 }
<a name="l00949"></a>00949 
<a name="l00950"></a>00950 
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 <span class="comment">// local const nodes begin() accessor</span>
<a name="l00953"></a>00953 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l00954"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a138ba0b5729029536661b737da5d5d35">00954</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#ad895b5b34272ef3a1ed66c0cc1a2ccb6">SerialMesh::local_nodes_begin</a> ()<span class="keyword"> const</span>
<a name="l00955"></a>00955 <span class="keyword"></span>{
<a name="l00956"></a>00956   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;const_node_iterator_imp&gt;</a> p;
<a name="l00957"></a>00957   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00958"></a>00958 }
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 
<a name="l00962"></a>00962 <span class="comment">// pid const nodes begin() accessor</span>
<a name="l00963"></a>00963 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l00964"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a181b629491c5c30d6142a4939ae63756">00964</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a3ad7879951e41a04f8febd717abe10ad">SerialMesh::pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00965"></a>00965 <span class="keyword"></span>{
<a name="l00966"></a>00966   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;const_node_iterator_imp&gt;</a> p(proc_id);
<a name="l00967"></a>00967   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.begin(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00968"></a>00968 }
<a name="l00969"></a>00969 
<a name="l00970"></a>00970 
<a name="l00971"></a>00971 
<a name="l00972"></a>00972 <span class="comment">// default nodes end() accessor</span>
<a name="l00973"></a>00973 SerialMesh::node_iterator
<a name="l00974"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a42f4248f397ec953551488fe5ffb384b">00974</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a42f4248f397ec953551488fe5ffb384b">SerialMesh::nodes_end</a> ()
<a name="l00975"></a>00975 {
<a name="l00976"></a>00976   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;node_iterator_imp&gt;</a> p;
<a name="l00977"></a>00977   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00978"></a>00978 }
<a name="l00979"></a>00979 
<a name="l00980"></a>00980 
<a name="l00981"></a>00981 
<a name="l00982"></a>00982 <span class="comment">// active nodes end() accessor</span>
<a name="l00983"></a>00983 SerialMesh::node_iterator
<a name="l00984"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a49211a9a8ac63ea200ceeef327b3913e">00984</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a49211a9a8ac63ea200ceeef327b3913e">SerialMesh::active_nodes_end</a> ()
<a name="l00985"></a>00985 {
<a name="l00986"></a>00986   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;node_iterator_imp&gt;</a> p;
<a name="l00987"></a>00987   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00988"></a>00988 }
<a name="l00989"></a>00989 
<a name="l00990"></a>00990 
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 <span class="comment">// local nodes end() accessor</span>
<a name="l00993"></a>00993 SerialMesh::node_iterator
<a name="l00994"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a60c7b0a245aacdee7a47a7629c231f5c">00994</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a60c7b0a245aacdee7a47a7629c231f5c">SerialMesh::local_nodes_end</a> ()
<a name="l00995"></a>00995 {
<a name="l00996"></a>00996   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;node_iterator_imp&gt;</a> p;
<a name="l00997"></a>00997   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l00998"></a>00998 }
<a name="l00999"></a>00999 
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 <span class="comment">// pid nodes end() accessor</span>
<a name="l01003"></a>01003 SerialMesh::node_iterator
<a name="l01004"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a5ce6e0a421311128e1a6b338fa0176d5">01004</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a5ce6e0a421311128e1a6b338fa0176d5">SerialMesh::pid_nodes_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l01005"></a>01005 {
<a name="l01006"></a>01006   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;node_iterator_imp&gt;</a> p(proc_id);
<a name="l01007"></a>01007   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l01008"></a>01008 }
<a name="l01009"></a>01009 
<a name="l01010"></a>01010 
<a name="l01011"></a>01011 
<a name="l01012"></a>01012 <span class="comment">// default const nodes end() accessor</span>
<a name="l01013"></a>01013 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l01014"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#aec9e6c029dacd77aa5c3d9a1f707b3c9">01014</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a42f4248f397ec953551488fe5ffb384b">SerialMesh::nodes_end</a> ()<span class="keyword"> const</span>
<a name="l01015"></a>01015 <span class="keyword"></span>{
<a name="l01016"></a>01016   <a class="code" href="structlibMesh_1_1Predicates_1_1NotNull.php">Predicates::NotNull&lt;const_node_iterator_imp&gt;</a> p;
<a name="l01017"></a>01017   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l01018"></a>01018 }
<a name="l01019"></a>01019 
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 <span class="comment">// const active nodes end() accessor</span>
<a name="l01023"></a>01023 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l01024"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a2235b252bd5232998ce22f52486cf3f1">01024</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a49211a9a8ac63ea200ceeef327b3913e">SerialMesh::active_nodes_end</a> ()<span class="keyword"> const</span>
<a name="l01025"></a>01025 <span class="keyword"></span>{
<a name="l01026"></a>01026   <a class="code" href="structlibMesh_1_1Predicates_1_1Active.php">Predicates::Active&lt;const_node_iterator_imp&gt;</a> p;
<a name="l01027"></a>01027   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l01028"></a>01028 }
<a name="l01029"></a>01029 
<a name="l01030"></a>01030 
<a name="l01031"></a>01031 
<a name="l01032"></a>01032 <span class="comment">// local const nodes end() accessor</span>
<a name="l01033"></a>01033 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l01034"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a1dea9092c13002dbd9e36320ddf8bc23">01034</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a60c7b0a245aacdee7a47a7629c231f5c">SerialMesh::local_nodes_end</a> ()<span class="keyword"> const</span>
<a name="l01035"></a>01035 <span class="keyword"></span>{
<a name="l01036"></a>01036   <a class="code" href="structlibMesh_1_1Predicates_1_1Local.php">Predicates::Local&lt;const_node_iterator_imp&gt;</a> p;
<a name="l01037"></a>01037   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l01038"></a>01038 }
<a name="l01039"></a>01039 
<a name="l01040"></a>01040 
<a name="l01041"></a>01041 
<a name="l01042"></a>01042 <span class="comment">// pid const nodes end() accessor</span>
<a name="l01043"></a>01043 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">SerialMesh::const_node_iterator</a>
<a name="l01044"></a><a class="code" href="classlibMesh_1_1SerialMesh.php#a51e0bc8e56f456b80903f64850fd02ed">01044</a> <a class="code" href="classlibMesh_1_1SerialMesh.php#a5ce6e0a421311128e1a6b338fa0176d5">SerialMesh::pid_nodes_end</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l01045"></a>01045 <span class="keyword"></span>{
<a name="l01046"></a>01046   <a class="code" href="structlibMesh_1_1Predicates_1_1PID.php">Predicates::PID&lt;const_node_iterator_imp&gt;</a> p(proc_id);
<a name="l01047"></a>01047   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>(<a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), <a class="code" href="classlibMesh_1_1SerialMesh.php#acbd817716d57198397acb97dadf45ff8">_nodes</a>.end(), p);
<a name="l01048"></a>01048 }
<a name="l01049"></a>01049 
<a name="l01050"></a>01050 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
