<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_4d3110f67e028a3227e23bfd240351cc.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sfc_partitioner.C</div>  </div>
</div>
<div class="contents">
<a href="sfc__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sfc_partitioner.C 3875 2010-07-03 13:11:54Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="sfc__partitioner_8h.php">sfc_partitioner.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_HAVE_SFCURVES</span>
<a name="l00032"></a><a class="code" href="namespaceSfc.php">00032</a> <span class="preprocessor"></span>  <span class="keyword">namespace </span>Sfc {
<a name="l00033"></a>00033     <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00034"></a>00034 <span class="preprocessor">#     include &quot;sfcurves.h&quot;</span>
<a name="l00035"></a>00035     }
<a name="l00036"></a>00036   }
<a name="l00037"></a>00037 <span class="preprocessor">#else</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="linear__partitioner_8h.php">linear_partitioner.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#endif</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// SFCPartitioner implementation</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1SFCPartitioner.php#a8d89498f903c3c0f78340acd6a9ffdb1">00047</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SFCPartitioner.php#a8d89498f903c3c0f78340acd6a9ffdb1">SFCPartitioner::_do_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00048"></a>00048                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   libmesh_assert (n &gt; 0);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">// Check for an easy return</span>
<a name="l00054"></a>00054   <span class="keywordflow">if</span> (n == 1)
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056       this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">single_partition</a> (mesh);
<a name="l00057"></a>00057       <span class="keywordflow">return</span>;
<a name="l00058"></a>00058     }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// What to do if the sfcurves library IS NOT present</span>
<a name="l00061"></a>00061 <span class="preprocessor">#ifndef LIBMESH_HAVE_SFCURVES</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063   libmesh_here();
<a name="l00064"></a>00064   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: The library has been built without&quot;</span>    &lt;&lt; std::endl
<a name="l00065"></a>00065                 &lt;&lt; <span class="stringliteral">&quot;Space Filling Curve support.  Using a linear&quot;</span> &lt;&lt; std::endl
<a name="l00066"></a>00066                 &lt;&lt; <span class="stringliteral">&quot;partitioner instead!&quot;</span> &lt;&lt; std::endl;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1LinearPartitioner.php">LinearPartitioner</a> lp;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   lp.<a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">partition</a> (mesh, n);
<a name="l00071"></a>00071   
<a name="l00072"></a>00072 <span class="comment">// What to do if the sfcurves library IS present</span>
<a name="l00073"></a>00073 <span class="preprocessor">#else</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>
<a name="l00075"></a>00075   START_LOG(<span class="stringliteral">&quot;sfc_partition()&quot;</span>, <span class="stringliteral">&quot;SFCPartitioner&quot;</span>);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>();
<a name="l00078"></a>00078   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>        = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="comment">// the forward_map maps the active element id</span>
<a name="l00081"></a>00081   <span class="comment">// into a contiguous block of indices</span>
<a name="l00082"></a>00082   std::vector&lt;unsigned int&gt;
<a name="l00083"></a>00083     forward_map (n_elem, <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// the reverse_map maps the contiguous ids back</span>
<a name="l00086"></a>00086   <span class="comment">// to active elements</span>
<a name="l00087"></a>00087   std::vector&lt;Elem*&gt; reverse_map (n_active_elem, NULL);
<a name="l00088"></a>00088   
<a name="l00089"></a>00089   <span class="keywordtype">int</span> size = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_active_elem);
<a name="l00090"></a>00090   std::vector&lt;double&gt; x      (size);
<a name="l00091"></a>00091   std::vector&lt;double&gt; y      (size);
<a name="l00092"></a>00092   std::vector&lt;double&gt; z      (size);
<a name="l00093"></a>00093   std::vector&lt;int&gt;    table  (size);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">// We need to map the active element ids into a</span>
<a name="l00097"></a>00097   <span class="comment">// contiguous range.</span>
<a name="l00098"></a>00098   {
<a name="l00099"></a>00099 <span class="comment">//     active_elem_iterator       elem_it (mesh.elements_begin());</span>
<a name="l00100"></a>00100 <span class="comment">//     const active_elem_iterator elem_end(mesh.elements_end());</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00103"></a>00103     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> el_num = 0;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00108"></a>00108       {
<a name="l00109"></a>00109         libmesh_assert ((*elem_it)-&gt;id() &lt; forward_map.size());
<a name="l00110"></a>00110         libmesh_assert (el_num           &lt; reverse_map.size());
<a name="l00111"></a>00111         
<a name="l00112"></a>00112         forward_map[(*elem_it)-&gt;id()] = el_num;
<a name="l00113"></a>00113         reverse_map[el_num]           = *elem_it;
<a name="l00114"></a>00114         el_num++;
<a name="l00115"></a>00115       }
<a name="l00116"></a>00116     libmesh_assert (el_num == n_active_elem);
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118   
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">// Get the centroid for each active element</span>
<a name="l00121"></a>00121   {
<a name="l00122"></a>00122 <span class="comment">//     const_active_elem_iterator       elem_it (mesh.const_elements_begin());</span>
<a name="l00123"></a>00123 <span class="comment">//     const const_active_elem_iterator elem_end(mesh.const_elements_end());</span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00126"></a>00126     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00127"></a>00127     
<a name="l00128"></a>00128     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00129"></a>00129       {
<a name="l00130"></a>00130         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00131"></a>00131         
<a name="l00132"></a>00132         libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt; forward_map.size());
<a name="l00133"></a>00133         
<a name="l00134"></a>00134         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         x[forward_map[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]] = p(0);
<a name="l00137"></a>00137         y[forward_map[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]] = p(1);
<a name="l00138"></a>00138         z[forward_map[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]] = p(2);
<a name="l00139"></a>00139       }
<a name="l00140"></a>00140   }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// build the space-filling curve</span>
<a name="l00143"></a>00143   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SFCPartitioner.php#a15a08f0bfaf8e3230b4d705ac40805dc">_sfc_type</a> == <span class="stringliteral">&quot;Hilbert&quot;</span>)
<a name="l00144"></a>00144     Sfc::hilbert (&amp;x[0], &amp;y[0], &amp;z[0], &amp;size, &amp;table[0]);
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SFCPartitioner.php#a15a08f0bfaf8e3230b4d705ac40805dc">_sfc_type</a> == <span class="stringliteral">&quot;Morton&quot;</span>)
<a name="l00147"></a>00147     Sfc::morton  (&amp;x[0], &amp;y[0], &amp;z[0], &amp;size, &amp;table[0]);
<a name="l00148"></a>00148   
<a name="l00149"></a>00149   <span class="keywordflow">else</span>
<a name="l00150"></a>00150     {
<a name="l00151"></a>00151       libmesh_here();
<a name="l00152"></a>00152       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown type: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1SFCPartitioner.php#a15a08f0bfaf8e3230b4d705ac40805dc">_sfc_type</a> &lt;&lt; std::endl
<a name="l00153"></a>00153                     &lt;&lt; <span class="stringliteral">&quot; Valid types are&quot;</span>                   &lt;&lt; std::endl
<a name="l00154"></a>00154                     &lt;&lt; <span class="stringliteral">&quot;  \&quot;Hilbert\&quot;&quot;</span>                      &lt;&lt; std::endl
<a name="l00155"></a>00155                     &lt;&lt; <span class="stringliteral">&quot;  \&quot;Morton\&quot;&quot;</span>                       &lt;&lt; std::endl
<a name="l00156"></a>00156                     &lt;&lt; <span class="stringliteral">&quot; &quot;</span>                                  &lt;&lt; std::endl
<a name="l00157"></a>00157                     &lt;&lt; <span class="stringliteral">&quot;Proceeding with a Hilbert curve.&quot;</span>   &lt;&lt; std::endl;
<a name="l00158"></a>00158       
<a name="l00159"></a>00159       Sfc::hilbert (&amp;x[0], &amp;y[0], &amp;z[0], &amp;size, &amp;table[0]);
<a name="l00160"></a>00160     }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <span class="comment">// Assign the partitioning to the active elements</span>
<a name="l00164"></a>00164   {
<a name="l00165"></a>00165 <span class="comment">//      {</span>
<a name="l00166"></a>00166 <span class="comment">//        std::ofstream out (&quot;sfc.dat&quot;);</span>
<a name="l00167"></a>00167 <span class="comment">//        out &lt;&lt; &quot;variables=x,y,z&quot; &lt;&lt; std::endl;</span>
<a name="l00168"></a>00168 <span class="comment">//        out &lt;&lt; &quot;zone f=point&quot; &lt;&lt; std::endl;</span>
<a name="l00169"></a>00169     
<a name="l00170"></a>00170 <span class="comment">//        for (unsigned int i=0; i&lt;n_active_elem; i++)</span>
<a name="l00171"></a>00171 <span class="comment">//      out &lt;&lt; x[i] &lt;&lt; &quot; &quot;</span>
<a name="l00172"></a>00172 <span class="comment">//          &lt;&lt; y[i] &lt;&lt; &quot; &quot;</span>
<a name="l00173"></a>00173 <span class="comment">//          &lt;&lt; z[i] &lt;&lt; std::endl;</span>
<a name="l00174"></a>00174 <span class="comment">//      }      </span>
<a name="l00175"></a>00175     
<a name="l00176"></a>00176     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blksize = (n_active_elem+n-1)/n; 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_active_elem; i++)
<a name="l00179"></a>00179       {
<a name="l00180"></a>00180         libmesh_assert (static_cast&lt;unsigned int&gt;(table[i]-1) &lt; reverse_map.size());
<a name="l00181"></a>00181           
<a name="l00182"></a>00182         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = reverse_map[table[i]-1];
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = i/blksize;
<a name="l00185"></a>00185       }
<a name="l00186"></a>00186   }
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   STOP_LOG(<span class="stringliteral">&quot;sfc_partition()&quot;</span>, <span class="stringliteral">&quot;SFCPartitioner&quot;</span>);  
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>  
<a name="l00192"></a>00192 }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
