<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">side.h</div>  </div>
</div>
<div class="contents">
<a href="side_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: side.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __side_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __side_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>Point;
<a name="l00036"></a>00036 <span class="keyword">class </span>Node;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">//Side class definition</span>
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">class</span> S<span class="keywordtype">id</span>eType, <span class="keyword">class</span> ParentType&gt;
<a name="l00056"></a><a class="code" href="classlibMesh_1_1Side.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Side.php">Side</a> : <span class="keyword">public</span> SideType
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058  <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Side.php#ac31982f7321191bd9a24773123108cfe">00063</a>   <a class="code" href="classlibMesh_1_1Side.php#ac31982f7321191bd9a24773123108cfe">Side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent,
<a name="l00064"></a>00064         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) :
<a name="l00065"></a>00065     SideType(0,0,const_cast&lt;<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;(parent)), <span class="comment">// Allocate no storage for nodes or neighbors!</span>
<a name="l00066"></a>00066     <a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>(side)
<a name="l00067"></a>00067   {
<a name="l00068"></a>00068     libmesh_assert (parent != NULL);
<a name="l00069"></a>00069     <span class="comment">// may not be true when building infinite element sides</span>
<a name="l00070"></a>00070     <span class="comment">// libmesh_assert (_side_number &lt; this-&gt;parent()-&gt;n_sides());</span>
<a name="l00071"></a>00071     libmesh_assert ((this-&gt;dim()+1) == this-&gt;parent()-&gt;dim());
<a name="l00072"></a>00072   }
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1Side.php#acbad0a860fc5e9133562d48c70564759">00077</a>   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Side.php#acbad0a860fc5e9133562d48c70564759">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword">  </span>{
<a name="l00079"></a>00079     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());    
<a name="l00080"></a>00080     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::side_nodes_map[<a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>][i]);
<a name="l00081"></a>00081   }
<a name="l00082"></a>00082  
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Side.php#a07124ce3186dbe13215ab667df98c780">00087</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Side.php#acbad0a860fc5e9133562d48c70564759">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00088"></a>00088   {
<a name="l00089"></a>00089     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());
<a name="l00090"></a>00090     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::side_nodes_map[<a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>][i]);
<a name="l00091"></a>00091   }
<a name="l00092"></a>00092   
<a name="l00096"></a><a class="code" href="classlibMesh_1_1Side.php#a0502c9c70c7f037eafd492da712f6d4d">00096</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Side.php#a0502c9c70c7f037eafd492da712f6d4d">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00097"></a>00097 <span class="keyword">  </span>{
<a name="l00098"></a>00098     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());
<a name="l00099"></a>00099     <span class="keywordflow">return</span> this-&gt;parent()-&gt;node (ParentType::side_nodes_map[<a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>][i]);  
<a name="l00100"></a>00100   }
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Side.php#a2f28ab0bab7e6e722fade6b120d74ef8">00105</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1Side.php#a2f28ab0bab7e6e722fade6b120d74ef8">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">  </span>{
<a name="l00107"></a>00107     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());    
<a name="l00108"></a>00108     <span class="keywordflow">return</span> this-&gt;parent()-&gt;get_node (ParentType::side_nodes_map[<a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>][i]);
<a name="l00109"></a>00109   }
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classlibMesh_1_1Side.php#aa61200295119e66be5959fabd8a080a2">00114</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1Side.php#aa61200295119e66be5959fabd8a080a2">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00115"></a>00115   {
<a name="l00116"></a>00116     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());    
<a name="l00117"></a>00117     <span class="keywordflow">return</span> this-&gt;parent()-&gt;set_node (ParentType::side_nodes_map[<a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>][i]);
<a name="l00118"></a>00118   }
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1Side.php#a0a316fd07c6fa769bf2074f0a7156407">00123</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Side.php#a0a316fd07c6fa769bf2074f0a7156407">n_sides</a> ()<span class="keyword"> const </span>
<a name="l00124"></a>00124 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1Side.php#a265091acf3fac5adfa12e47b8ceb432d">00126</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Side.php#a265091acf3fac5adfa12e47b8ceb432d">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00127"></a>00127                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   
<a name="l00131"></a>00131  <span class="keyword">private</span>:
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   
<a name="l00137"></a><a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">00137</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Side.php#ac46984ec6e30b3d3bd5b3f1fad39e1f4">_side_number</a>;
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00155"></a>00155 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00156"></a>00156 <span class="comment">//SideEdge class definition</span>
<a name="l00157"></a>00157 <span class="keyword">template</span> &lt;<span class="keyword">class</span> EdgeType, <span class="keyword">class</span> ParentType&gt;
<a name="l00158"></a><a class="code" href="classlibMesh_1_1SideEdge.php">00158</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge</a> : <span class="keyword">public</span> EdgeType
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160  <span class="keyword">public</span>:
<a name="l00161"></a>00161 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1SideEdge.php#acf9f3d3a4c0c0c6d73e37cfab803b364">00165</a>   <a class="code" href="classlibMesh_1_1SideEdge.php#acf9f3d3a4c0c0c6d73e37cfab803b364">SideEdge</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent,
<a name="l00166"></a>00166             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge) :
<a name="l00167"></a>00167     EdgeType(0,0,const_cast&lt;<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;(parent)), <span class="comment">// Allocate no storage for nodes or neighbors!</span>
<a name="l00168"></a>00168     <a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>(edge)
<a name="l00169"></a>00169   {
<a name="l00170"></a>00170     libmesh_assert (parent != NULL);
<a name="l00171"></a>00171     libmesh_assert (_edge_number &lt; this-&gt;parent()-&gt;n_edges());
<a name="l00172"></a>00172     libmesh_assert (this-&gt;dim() == 1);
<a name="l00173"></a>00173   }
<a name="l00174"></a>00174 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1SideEdge.php#a4c58a5f040235dbb2959e03a4b48228e">00178</a>   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1SideEdge.php#a4c58a5f040235dbb2959e03a4b48228e">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00179"></a>00179 <span class="keyword">  </span>{
<a name="l00180"></a>00180     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());    
<a name="l00181"></a>00181     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::edge_nodes_map[<a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>][i]);
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183  
<a name="l00188"></a><a class="code" href="classlibMesh_1_1SideEdge.php#a34e5be30d733a1a38a38d526c41033fd">00188</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1SideEdge.php#a4c58a5f040235dbb2959e03a4b48228e">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00189"></a>00189   {
<a name="l00190"></a>00190     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());
<a name="l00191"></a>00191     <span class="keywordflow">return</span> this-&gt;parent()-&gt;point (ParentType::edge_nodes_map[<a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>][i]);
<a name="l00192"></a>00192   }
<a name="l00193"></a>00193   
<a name="l00197"></a><a class="code" href="classlibMesh_1_1SideEdge.php#a2de5cdac1e0136445d94317928efda45">00197</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SideEdge.php#a2de5cdac1e0136445d94317928efda45">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00198"></a>00198 <span class="keyword">  </span>{
<a name="l00199"></a>00199     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());
<a name="l00200"></a>00200     <span class="keywordflow">return</span> this-&gt;parent()-&gt;node (ParentType::edge_nodes_map[<a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>][i]);  
<a name="l00201"></a>00201   }
<a name="l00202"></a>00202 
<a name="l00206"></a><a class="code" href="classlibMesh_1_1SideEdge.php#a685a56f2d02223df1553c0584a6ac32c">00206</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1SideEdge.php#a685a56f2d02223df1553c0584a6ac32c">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00207"></a>00207 <span class="keyword">  </span>{
<a name="l00208"></a>00208     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());    
<a name="l00209"></a>00209     <span class="keywordflow">return</span> this-&gt;parent()-&gt;get_node (ParentType::edge_nodes_map[<a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>][i]);
<a name="l00210"></a>00210   }
<a name="l00211"></a>00211 
<a name="l00215"></a><a class="code" href="classlibMesh_1_1SideEdge.php#a5e8c52055bb368a42ec10cbf12ca3db4">00215</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1SideEdge.php#a5e8c52055bb368a42ec10cbf12ca3db4">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00216"></a>00216   {
<a name="l00217"></a>00217     libmesh_assert (i &lt; this-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());    
<a name="l00218"></a>00218     <span class="keywordflow">return</span> this-&gt;parent()-&gt;set_node (ParentType::edge_nodes_map[<a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>][i]);
<a name="l00219"></a>00219   }
<a name="l00220"></a>00220 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1SideEdge.php#a3ac4b517436d022990990074b36d8696">00225</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SideEdge.php#a3ac4b517436d022990990074b36d8696">n_sides</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   
<a name="l00228"></a>00228  <span class="keyword">private</span>:
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   
<a name="l00234"></a><a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">00234</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SideEdge.php#ac2c8d2f7b63fda8a32e8160d8a0347e9">_edge_number</a>;
<a name="l00235"></a>00235 };
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 } <span class="comment">// namespace libMesh</span>
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="preprocessor">#endif // end #ifndef __side_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
