<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">single_predicates.h</div>  </div>
</div>
<div class="contents">
<a href="single__predicates_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: single_predicates.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __single_predicates_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __single_predicates_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="id__types_8h.php">id_types.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Predicates
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <span class="comment">// Forward declaration</span>
<a name="l00043"></a>00043   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>abstract_multi_predicate;
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <span class="comment">// abstract single predicate.  Derived classes must implement the clone()</span>
<a name="l00046"></a>00046   <span class="comment">// function.  Be careful using it since it allocates memory!  The clone()</span>
<a name="l00047"></a>00047   <span class="comment">// function is necessary since the predicate class has pure virtual</span>
<a name="l00048"></a>00048   <span class="comment">// functions.</span>
<a name="l00049"></a>00049   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00050"></a><a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">00050</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>
<a name="l00051"></a>00051   {
<a name="l00052"></a><a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php#acfb3f1aeefb524e8800b3e16dd575428">00052</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php#acfb3f1aeefb524e8800b3e16dd575428">~predicate</a>() {}
<a name="l00053"></a>00053     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php#a737870e71ced6f3c4fd0014a28e9b35c">operator()</a>(<span class="keyword">const</span> T&amp; it) <span class="keyword">const</span> = 0;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keyword">protected</span>:
<a name="l00057"></a><a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php#abda0f718f2b5dd6de03d6bf20356697a">00057</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="structlibMesh_1_1Predicates_1_1abstract__multi__predicate.php">abstract_multi_predicate</a>&lt;T&gt;;
<a name="l00058"></a>00058     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php#a3005f0399b529ce2cd28d37cdab08ac9">clone</a>() <span class="keyword">const</span> = 0;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// The is_null predicate returns true if the underlying pointer is NULL.</span>
<a name="l00064"></a>00064   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00065"></a><a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php">00065</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php">is_null</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00066"></a>00066   {
<a name="l00067"></a><a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php#a58812c8391f2e481307e7e6c118be9f2">00067</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php#a58812c8391f2e481307e7e6c118be9f2">~is_null</a>() {}
<a name="l00068"></a><a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php#ad75d1ede846527ba56ba6fa4ae6a2e19">00068</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php#ad75d1ede846527ba56ba6fa4ae6a2e19">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> *it == NULL; }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keyword">protected</span>:
<a name="l00071"></a><a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php#a06219c91479128496c864e1b81a2b655">00071</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php#a06219c91479128496c864e1b81a2b655">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php">is_null&lt;T&gt;</a>(*this); }
<a name="l00072"></a>00072   };
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <span class="comment">// The not_null predicate simply returns true if the pointer is not NULL.</span>
<a name="l00075"></a>00075   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00076"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php">00076</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php">not_null</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1is__null.php">is_null</a>&lt;T&gt;
<a name="l00077"></a>00077   {
<a name="l00078"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php#aeb397049c330a488e89cca4c1fad32a3">00078</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php#aeb397049c330a488e89cca4c1fad32a3">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php#aeb397049c330a488e89cca4c1fad32a3">is_null&lt;T&gt;::operator()</a>(it); }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keyword">protected</span>:
<a name="l00081"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php#a86cc6a0cead5341b1530b0727372f9cc">00081</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php#a86cc6a0cead5341b1530b0727372f9cc">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__null.php">not_null&lt;T&gt;</a>(*this); }
<a name="l00082"></a>00082   };
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// The active predicate returns true if the pointer is active.</span>
<a name="l00086"></a>00086   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00087"></a><a class="code" href="structlibMesh_1_1Predicates_1_1active.php">00087</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1active.php">active</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00088"></a>00088   {
<a name="l00089"></a><a class="code" href="structlibMesh_1_1Predicates_1_1active.php#a2149df7687cb35ca224704bf3a8a8d6e">00089</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1active.php#a2149df7687cb35ca224704bf3a8a8d6e">~active</a>() {}
<a name="l00090"></a><a class="code" href="structlibMesh_1_1Predicates_1_1active.php#aedf0c1d1b3152f418e36838c844bafd9">00090</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1active.php#aedf0c1d1b3152f418e36838c844bafd9">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;active(); }
<a name="l00091"></a>00091     
<a name="l00092"></a>00092   <span class="keyword">protected</span>:
<a name="l00093"></a><a class="code" href="structlibMesh_1_1Predicates_1_1active.php#abb455207823842bcc70530e336823b84">00093</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1active.php#abb455207823842bcc70530e336823b84">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1active.php">active&lt;T&gt;</a>(*this); }
<a name="l00094"></a>00094   };
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">// The not active predicate returns true when the pointer is inactive</span>
<a name="l00097"></a>00097   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00098"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php">00098</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php">not_active</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1active.php">active</a>&lt;T&gt;
<a name="l00099"></a>00099   {
<a name="l00100"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php#aceb49a683fd6eebf93b202952e8ab024">00100</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php#aceb49a683fd6eebf93b202952e8ab024">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php#aceb49a683fd6eebf93b202952e8ab024">active&lt;T&gt;::operator()</a>(it); }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="keyword">protected</span>:
<a name="l00103"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php#a3a3760ebc1c3a9de01949788c45429a1">00103</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php#a3a3760ebc1c3a9de01949788c45429a1">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__active.php">not_active&lt;T&gt;</a>(*this); }
<a name="l00104"></a>00104   };
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// The ancestor predicate returns true if the pointer is ancestor.</span>
<a name="l00108"></a>00108   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00109"></a><a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php">00109</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php">ancestor</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00110"></a>00110   {
<a name="l00111"></a><a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php#aee519cd787c53444223cf8797b25e89e">00111</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php#aee519cd787c53444223cf8797b25e89e">~ancestor</a>() {}
<a name="l00112"></a><a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php#a7b6428dcc7b99653c773800ca629a274">00112</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php#a7b6428dcc7b99653c773800ca629a274">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;ancestor(); }
<a name="l00113"></a>00113     
<a name="l00114"></a>00114   <span class="keyword">protected</span>:
<a name="l00115"></a><a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php#a4bbefe706f862d7c48298886b1e8c7e3">00115</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php#a4bbefe706f862d7c48298886b1e8c7e3">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php">ancestor&lt;T&gt;</a>(*this); }
<a name="l00116"></a>00116   };
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// The not_ancestor predicate returns true when the pointer is not ancestor</span>
<a name="l00119"></a>00119   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00120"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php">00120</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php">not_ancestor</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1ancestor.php">ancestor</a>&lt;T&gt;
<a name="l00121"></a>00121   {
<a name="l00122"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php#a95c3ee258e888b4ae69bb2430a9a5dae">00122</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php#a95c3ee258e888b4ae69bb2430a9a5dae">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php#a95c3ee258e888b4ae69bb2430a9a5dae">ancestor&lt;T&gt;::operator()</a>(it); }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="keyword">protected</span>:
<a name="l00125"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php#a427681296916991458c5407567f90f01">00125</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php#a427681296916991458c5407567f90f01">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__ancestor.php">not_ancestor&lt;T&gt;</a>(*this); }
<a name="l00126"></a>00126   };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// The subactive predicate returns true if the pointer is subactive.</span>
<a name="l00130"></a>00130   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00131"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php">00131</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php">subactive</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00132"></a>00132   {
<a name="l00133"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php#a9fd07968b729aa81c5444d38129857c3">00133</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php#a9fd07968b729aa81c5444d38129857c3">~subactive</a>() {}
<a name="l00134"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php#a0cf212403fa721b7748bcb30de0ac604">00134</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php#a0cf212403fa721b7748bcb30de0ac604">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;subactive(); }
<a name="l00135"></a>00135     
<a name="l00136"></a>00136   <span class="keyword">protected</span>:
<a name="l00137"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php#a4fdc5b58a536b8ee93584ecd5b8cd3b0">00137</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php#a4fdc5b58a536b8ee93584ecd5b8cd3b0">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php">subactive&lt;T&gt;</a>(*this); }
<a name="l00138"></a>00138   };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// The not_subactive predicate returns true when the pointer is not subactive</span>
<a name="l00141"></a>00141   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00142"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php">00142</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php">not_subactive</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1subactive.php">subactive</a>&lt;T&gt;
<a name="l00143"></a>00143   {
<a name="l00144"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php#a77052a39725d13153e401f2aeae49b96">00144</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php#a77052a39725d13153e401f2aeae49b96">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php#a77052a39725d13153e401f2aeae49b96">subactive&lt;T&gt;::operator()</a>(it); }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keyword">protected</span>:
<a name="l00147"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php#a274036e35c5e0048335355ed581224da">00147</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php#a274036e35c5e0048335355ed581224da">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__subactive.php">not_subactive&lt;T&gt;</a>(*this); }
<a name="l00148"></a>00148   };
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// The pid predicate returns true if the pointers</span>
<a name="l00153"></a>00153   <span class="comment">// processor id matches a given processor id.</span>
<a name="l00154"></a>00154   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00155"></a><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php">00155</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php">pid</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00156"></a>00156   {
<a name="l00157"></a>00157     <span class="comment">// Constructor</span>
<a name="l00158"></a><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a82e56d9fe47c9127850bc71a0ce62a5a">00158</a>     <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a82e56d9fe47c9127850bc71a0ce62a5a">pid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p) : <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a93e14175bda96e094cf6de41b017ce45">_pid</a>(p) {}
<a name="l00159"></a><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#aa3d0645f58a1fb0ef880fccd0d11f9c8">00159</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#aa3d0645f58a1fb0ef880fccd0d11f9c8">~pid</a>() {}
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="comment">// op()</span>
<a name="l00162"></a><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a5e1dbeaf36fb336912f48cb4c479f9a3">00162</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a5e1dbeaf36fb336912f48cb4c479f9a3">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;processor_id() == <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a93e14175bda96e094cf6de41b017ce45">_pid</a>; }
<a name="l00163"></a>00163     
<a name="l00164"></a>00164   <span class="keyword">protected</span>:
<a name="l00165"></a><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#ae176deef26bfed9319b704b40b239783">00165</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#ae176deef26bfed9319b704b40b239783">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php">pid&lt;T&gt;</a>(*this); }
<a name="l00166"></a><a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a93e14175bda96e094cf6de41b017ce45">00166</a>     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php#a93e14175bda96e094cf6de41b017ce45">_pid</a>;
<a name="l00167"></a>00167   };
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   
<a name="l00171"></a>00171   <span class="comment">// The not_pid predicate returns ture if the pointers</span>
<a name="l00172"></a>00172   <span class="comment">// processor id does _not_ match p.</span>
<a name="l00173"></a>00173   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00174"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php">00174</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php">not_pid</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php">pid</a>&lt;T&gt;
<a name="l00175"></a>00175   {
<a name="l00176"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#a5e6e84d9f28715f1b4e0beb2d8b01e1a">00176</a>     <a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#a5e6e84d9f28715f1b4e0beb2d8b01e1a">not_pid</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p) : <a class="code" href="structlibMesh_1_1Predicates_1_1pid.php">pid</a>&lt;T&gt;(p) {}
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#acd78c1d0ec2bada133765932e4535c37">00178</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#acd78c1d0ec2bada133765932e4535c37">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#acd78c1d0ec2bada133765932e4535c37">pid&lt;T&gt;::operator()</a>(it); }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="keyword">protected</span>:
<a name="l00181"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#aff987b5f8e26ee47ee124a2dc0f1f19a">00181</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php#aff987b5f8e26ee47ee124a2dc0f1f19a">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__pid.php">not_pid&lt;T&gt;</a>(*this); }
<a name="l00182"></a>00182   };
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">// The elem_type predicate returns true if the pointers</span>
<a name="l00186"></a>00186   <span class="comment">// type matches the given type.  Of course, this one can only</span>
<a name="l00187"></a>00187   <span class="comment">// be instantiated for objects which return Elem*s when dereferened.</span>
<a name="l00188"></a>00188   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00189"></a><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php">00189</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php">elem_type</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00190"></a>00190   {
<a name="l00191"></a>00191     <span class="comment">// Constructor</span>
<a name="l00192"></a><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ac8a4a558208051dec4e3ff58a3a83947">00192</a>     <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ac8a4a558208051dec4e3ff58a3a83947">elem_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t) : <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ad054188d8908807524c7bfaa4e639ebb">_elem_type</a>(t) {}
<a name="l00193"></a><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#a0be4aaa22dd15f46f3ab79935f27ab0a">00193</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#a0be4aaa22dd15f46f3ab79935f27ab0a">~elem_type</a>() {}
<a name="l00194"></a>00194     
<a name="l00195"></a><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#a11f100516f2f3db01393c16dd5ff573f">00195</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#a11f100516f2f3db01393c16dd5ff573f">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;type() == <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ad054188d8908807524c7bfaa4e639ebb">_elem_type</a>; }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keyword">protected</span>:
<a name="l00198"></a><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ad8e3c1034ffd37d715712cc877e82f7c">00198</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ad8e3c1034ffd37d715712cc877e82f7c">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php">elem_type&lt;T&gt;</a>(*this); }
<a name="l00199"></a><a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ad054188d8908807524c7bfaa4e639ebb">00199</a>     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="structlibMesh_1_1Predicates_1_1elem__type.php#ad054188d8908807524c7bfaa4e639ebb">_elem_type</a>;
<a name="l00200"></a>00200   };
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   
<a name="l00206"></a>00206   <span class="comment">// The level predicate returns true if the pointers level</span>
<a name="l00207"></a>00207   <span class="comment">// matches the given level.</span>
<a name="l00208"></a>00208   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00209"></a><a class="code" href="structlibMesh_1_1Predicates_1_1level.php">00209</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1level.php">level</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00210"></a>00210   {
<a name="l00211"></a>00211     <span class="comment">// Constructor</span>
<a name="l00212"></a><a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ab7d6e63a6b14085b2213698fd88f3fc6">00212</a>     <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ab7d6e63a6b14085b2213698fd88f3fc6">level</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l) : <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ae392de8cbce5a47c5850eb13d5ce5e19">_level</a>(l) {}
<a name="l00213"></a><a class="code" href="structlibMesh_1_1Predicates_1_1level.php#a79e2dabd783fcce8deabd7b5bb8cdd7e">00213</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#a79e2dabd783fcce8deabd7b5bb8cdd7e">~level</a>() {}
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ad336c3c577066e542b838bc237bb9be7">00215</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ad336c3c577066e542b838bc237bb9be7">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;level() == <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ae392de8cbce5a47c5850eb13d5ce5e19">_level</a>; }
<a name="l00216"></a>00216     
<a name="l00217"></a>00217   <span class="keyword">protected</span>:
<a name="l00218"></a><a class="code" href="structlibMesh_1_1Predicates_1_1level.php#aab39129c89e8f3cf0677593667ffdfe6">00218</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#aab39129c89e8f3cf0677593667ffdfe6">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1level.php">level&lt;T&gt;</a>(*this); }
<a name="l00219"></a><a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ae392de8cbce5a47c5850eb13d5ce5e19">00219</a>     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structlibMesh_1_1Predicates_1_1level.php#ae392de8cbce5a47c5850eb13d5ce5e19">_level</a>;
<a name="l00220"></a>00220   };
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   
<a name="l00224"></a>00224   <span class="comment">// The not_level predicate returns true if the pointers level</span>
<a name="l00225"></a>00225   <span class="comment">// _does not_ match the given level.</span>
<a name="l00226"></a>00226   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00227"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php">00227</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php">not_level</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1level.php">level</a>&lt;T&gt;
<a name="l00228"></a>00228   {
<a name="l00229"></a>00229     <span class="comment">// Constructor</span>
<a name="l00230"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#a7f5bc7b789a95c0b957b2d01e01c078c">00230</a>     <a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#a7f5bc7b789a95c0b957b2d01e01c078c">not_level</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l) : <a class="code" href="structlibMesh_1_1Predicates_1_1level.php">level</a>&lt;T&gt;(l) {}
<a name="l00231"></a>00231   
<a name="l00232"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#adc17b6aab82a0dbeee39405c248db541">00232</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#adc17b6aab82a0dbeee39405c248db541">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !<a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#adc17b6aab82a0dbeee39405c248db541">level&lt;T&gt;::operator()</a>(it); }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="keyword">protected</span>:
<a name="l00235"></a><a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#adc14566339ad17b6a8965917fa5e6adc">00235</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php#adc14566339ad17b6a8965917fa5e6adc">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1not__level.php">not_level&lt;T&gt;</a>(*this); }
<a name="l00236"></a>00236   };
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">// The null_neighbor predicate returns true if the pointer has any</span>
<a name="l00242"></a>00242   <span class="comment">// NULL neigbors.</span>
<a name="l00243"></a>00243   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00244"></a><a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php">00244</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php">null_neighbor</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00245"></a>00245   {
<a name="l00246"></a><a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php#ae8a3789c34f1a9cf20fc321ba24a5b78">00246</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php#ae8a3789c34f1a9cf20fc321ba24a5b78">~null_neighbor</a>() {}
<a name="l00247"></a><a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php#adc3dbdbcc2c91b2ae6e6627b3b8952d8">00247</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php#adc3dbdbcc2c91b2ae6e6627b3b8952d8">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const</span>
<a name="l00248"></a>00248 <span class="keyword">    </span>{
<a name="l00249"></a>00249       <span class="keywordflow">return</span> (*it)-&gt;on_boundary();
<a name="l00250"></a>00250     }
<a name="l00251"></a>00251     
<a name="l00252"></a>00252   <span class="keyword">protected</span>:
<a name="l00253"></a><a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php#ace5411f608323c87699c91ea427dab8f">00253</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php#ace5411f608323c87699c91ea427dab8f">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1null__neighbor.php">null_neighbor&lt;T&gt;</a>(*this); }
<a name="l00254"></a>00254   };
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// This predicate simply forwards the work of determining whether</span>
<a name="l00259"></a>00259   <span class="comment">// a particular side is on the boundary to the iterator itself, which</span>
<a name="l00260"></a>00260   <span class="comment">// has more information.</span>
<a name="l00261"></a>00261   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00262"></a><a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php">00262</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php">boundary_side</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00263"></a>00263   {
<a name="l00264"></a><a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php#a96645339eb6cf6ef77e7e56266eb6723">00264</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php#a96645339eb6cf6ef77e7e56266eb6723">~boundary_side</a>() {}
<a name="l00265"></a><a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php#ac7e8e589b4bf3e29c80f20bd41a1acf2">00265</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php#ac7e8e589b4bf3e29c80f20bd41a1acf2">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const</span>
<a name="l00266"></a>00266 <span class="keyword">    </span>{
<a name="l00267"></a>00267       <span class="keywordflow">return</span> it.side_on_boundary();
<a name="l00268"></a>00268     }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="keyword">protected</span>:
<a name="l00271"></a><a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php#abdd0001fd82c276bb7b2558beab1b5b0">00271</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php#abdd0001fd82c276bb7b2558beab1b5b0">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1boundary__side.php">boundary_side&lt;T&gt;</a>(*this); }
<a name="l00272"></a>00272   };
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// The subdomain predicate returns true if the pointers</span>
<a name="l00275"></a>00275   <span class="comment">// subdimain id matches a given subdomain id.</span>
<a name="l00276"></a>00276   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00277"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php">00277</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php">subdomain</a> : <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate</a>&lt;T&gt;
<a name="l00278"></a>00278   {
<a name="l00279"></a>00279     <span class="comment">// Constructor</span>
<a name="l00280"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#aed2fc5760ed3e0e706f1c307dce2f46f">00280</a>     <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#aed2fc5760ed3e0e706f1c307dce2f46f">subdomain</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sid) : <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a0f009c2a87196e5a3dc533844f6d0407">_subdomain</a>(sid) {}
<a name="l00281"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a80faee4cea66f06577e2493387f46bc3">00281</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a80faee4cea66f06577e2493387f46bc3">~subdomain</a>() {}
<a name="l00282"></a>00282 
<a name="l00283"></a>00283     <span class="comment">// op()</span>
<a name="l00284"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#acec8a061884a67c9149ddb1d2e66e3e6">00284</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#acec8a061884a67c9149ddb1d2e66e3e6">operator()</a>(<span class="keyword">const</span> T&amp; it)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*it)-&gt;subdomain_id() == <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a0f009c2a87196e5a3dc533844f6d0407">_subdomain</a>; }
<a name="l00285"></a>00285     
<a name="l00286"></a>00286   <span class="keyword">protected</span>:
<a name="l00287"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a323422c41c6458498f3ac6e810356f4f">00287</a>     <span class="keyword">virtual</span> <a class="code" href="structlibMesh_1_1Predicates_1_1predicate.php">predicate&lt;T&gt;</a>* <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a323422c41c6458498f3ac6e810356f4f">clone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php">subdomain&lt;T&gt;</a>(*this); }
<a name="l00288"></a><a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a0f009c2a87196e5a3dc533844f6d0407">00288</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> <a class="code" href="structlibMesh_1_1Predicates_1_1subdomain.php#a0f009c2a87196e5a3dc533844f6d0407">_subdomain</a>;
<a name="l00289"></a>00289   };
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 } <span class="comment">// namespace libMesh</span>
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
