<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">slepc_eigen_solver.C</div>  </div>
</div>
<div class="contents">
<a href="slepc__eigen__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC) &amp;&amp; defined(LIBMESH_HAVE_PETSC)</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="slepc__eigen__solver_8h.php">slepc_eigen_solver.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a8a9fa50bf0b8ff10c728fc5a7e51c458">00042</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a8a9fa50bf0b8ff10c728fc5a7e51c458">SlepcEigenSolver&lt;T&gt;::clear</a> ()
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048       <span class="keywordtype">int</span> ierr=0;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050       ierr = EPSDestroy(_eps);
<a name="l00051"></a>00051              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053       <span class="comment">// SLEPc default eigenproblem solver</span>
<a name="l00054"></a>00054 <span class="preprocessor">#if SLEPC_VERSION_LESS_THAN(2,3,2)</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>    this-&gt;_eigen_solver_type = <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a12dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>;
<a name="l00056"></a>00056 <span class="preprocessor">#else</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>    <span class="comment">// Krylov-Schur showed up as of Slepc 2.3.2</span>
<a name="l00058"></a>00058     this-&gt;_eigen_solver_type = <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802aab344a669e1795431ec3a973e82c8cc4">KRYLOVSCHUR</a>;
<a name="l00059"></a>00059 <span class="preprocessor">#endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>    }
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00066"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ab93a28b2f4aa39463a73bfea7daea035">00066</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ab93a28b2f4aa39463a73bfea7daea035">SlepcEigenSolver&lt;T&gt;::init</a> ()
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="keywordtype">int</span> ierr=0;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076       <span class="comment">// Create the eigenproblem solver context</span>
<a name="l00077"></a>00077       ierr = EPSCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_eps);
<a name="l00078"></a>00078       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080       <span class="comment">// Set user-specified  solver</span>
<a name="l00081"></a>00081       set_slepc_solver_type();
<a name="l00082"></a>00082     } 
<a name="l00083"></a>00083 }    
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00088"></a>00088 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a79e925883cca4095b8c1b6cb1b75d26c">00089</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a79e925883cca4095b8c1b6cb1b75d26c">SlepcEigenSolver&lt;T&gt;::solve_standard</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A_in,
<a name="l00090"></a>00090                                      <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00091"></a>00091                                      <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00092"></a>00092                                      <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00093"></a>00093                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095 <span class="comment">//   START_LOG(&quot;solve_standard()&quot;, &quot;SlepcEigenSolver&quot;);</span>
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="comment">// Make sure the SparseMatrix passed in is really a PetscMatrix</span>
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix_A   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_A_in);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Close the matrix and vectors in case this wasn&#39;t already done.</span>
<a name="l00103"></a>00103   matrix_A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// just for debugging, remove this </span>
<a name="l00106"></a>00106 <span class="comment">//   char mat_file[] = &quot;matA.petsc&quot;;</span>
<a name="l00107"></a>00107 <span class="comment">//   PetscViewer petsc_viewer;</span>
<a name="l00108"></a>00108 <span class="comment">//   ierr = PetscViewerBinaryOpen(libMesh::COMM_WORLD, mat_file, PETSC_FILE_CREATE, &amp;petsc_viewer);</span>
<a name="l00109"></a>00109 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00110"></a>00110 <span class="comment">//   ierr = MatView(matrix_A-&gt;mat(),petsc_viewer);</span>
<a name="l00111"></a>00111 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="keywordflow">return</span> _solve_standard_helper(matrix_A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), nev, ncv, tol, m_its);
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00118"></a>00118 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a7d55366967e4bc2fca168146e4630cfc">00119</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a79e925883cca4095b8c1b6cb1b75d26c">SlepcEigenSolver&lt;T&gt;::solve_standard</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix,
<a name="l00120"></a>00120                                      <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00121"></a>00121                                      <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00122"></a>00122                                      <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00123"></a>00123                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordtype">int</span> ierr=0;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// Prepare the matrix.</span>
<a name="l00130"></a>00130   Mat mat;
<a name="l00131"></a>00131   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00132"></a>00132             shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a3257a7170e8dd3829d06c0ee4ab761c1">m</a>(), <span class="comment">// Specify the number of local rows</span>
<a name="l00133"></a>00133             shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#afb8b4c2c14a37e7ecf03fd09be6434af">n</a>(), <span class="comment">// Specify the number of local columns</span>
<a name="l00134"></a>00134             PETSC_DETERMINE,
<a name="l00135"></a>00135             PETSC_DETERMINE,
<a name="l00136"></a>00136             <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l00137"></a>00137             &amp;mat);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00140"></a>00140 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00141"></a>00141 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00142"></a>00142 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00145"></a>00145   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00146"></a>00146   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00147"></a>00147   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keywordflow">return</span> _solve_standard_helper(mat, nev, ncv, tol, m_its);
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00154"></a>00154 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00155"></a>00155 <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ae23257b288ee7946da38bee8cd342fce">SlepcEigenSolver&lt;T&gt;::_solve_standard_helper</a>
<a name="l00156"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ae23257b288ee7946da38bee8cd342fce">00156</a>                                     (Mat mat,
<a name="l00157"></a>00157                                      <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00158"></a>00158                                      <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00159"></a>00159                                      <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00160"></a>00160                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00161"></a>00161 {
<a name="l00162"></a>00162   START_LOG(<span class="stringliteral">&quot;solve_standard()&quot;</span>, <span class="stringliteral">&quot;SlepcEigenSolver&quot;</span>);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <span class="keywordtype">int</span> ierr=0;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <span class="comment">// converged eigen pairs and number of iterations</span>
<a name="l00167"></a>00167   <span class="keywordtype">int</span> nconv=0;
<a name="l00168"></a>00168   <span class="keywordtype">int</span> its=0;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="preprocessor">#ifdef  DEBUG</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span>  <span class="comment">// The relative error.</span>
<a name="l00172"></a>00172   PetscReal error, re, im;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// Pointer to vectors of the real parts, imaginary parts.</span>
<a name="l00175"></a>00175   PetscScalar kr, ki;
<a name="l00176"></a>00176 <span class="preprocessor">#endif</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>
<a name="l00178"></a>00178   <span class="comment">// Set operators.</span>
<a name="l00179"></a>00179   ierr = EPSSetOperators (_eps, mat, PETSC_NULL);
<a name="l00180"></a>00180          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//set the problem type and the position of the spectrum</span>
<a name="l00183"></a>00183   set_slepc_problem_type();
<a name="l00184"></a>00184   set_slepc_position_of_spectrum();
<a name="l00185"></a>00185       
<a name="l00186"></a>00186   <span class="comment">// Set eigenvalues to be computed.</span>
<a name="l00187"></a>00187 <span class="preprocessor">#if SLEPC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>  ierr = EPSSetDimensions (_eps, nev, ncv);
<a name="l00189"></a>00189 <span class="preprocessor">#else</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span>  ierr = EPSSetDimensions (_eps, nev, ncv, PETSC_DECIDE);
<a name="l00191"></a>00191 <span class="preprocessor">#endif</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00193"></a>00193   <span class="comment">// Set the tolerance and maximum iterations.</span>
<a name="l00194"></a>00194   ierr = EPSSetTolerances (_eps, tol, m_its);
<a name="l00195"></a>00195          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00198"></a>00198   <span class="comment">//      -eps_type &lt;type&gt;, -eps_nev &lt;nev&gt;, -eps_ncv &lt;ncv&gt;</span>
<a name="l00199"></a>00199   <span class="comment">// Similar to PETSc, these options will override those specified</span>
<a name="l00200"></a>00200   <span class="comment">// above as long as EPSSetFromOptions() is called _after_ any</span>
<a name="l00201"></a>00201   <span class="comment">// other customization routines.</span>
<a name="l00202"></a>00202   ierr = EPSSetFromOptions (_eps);
<a name="l00203"></a>00203          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="comment">// Solve the eigenproblem.</span>
<a name="l00206"></a>00206   ierr = EPSSolve (_eps);
<a name="l00207"></a>00207          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">// Get the number of iterations.</span>
<a name="l00210"></a>00210   ierr = EPSGetIterationNumber (_eps, &amp;its);
<a name="l00211"></a>00211          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Get number of converged eigenpairs.</span>
<a name="l00214"></a>00214   ierr = EPSGetConverged(_eps,&amp;nconv);
<a name="l00215"></a>00215          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>         <span class="comment">// ierr = PetscPrintf(libMesh::COMM_WORLD,</span>
<a name="l00220"></a>00220          <span class="comment">//         &quot;\n Number of iterations: %d\n&quot;</span>
<a name="l00221"></a>00221          <span class="comment">//         &quot; Number of converged eigenpairs: %d\n\n&quot;, its, nconv);</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="comment">// Display eigenvalues and relative errors.</span>
<a name="l00224"></a>00224   ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00225"></a>00225                      <span class="stringliteral">&quot;           k           ||Ax-kx||/|kx|\n&quot;</span>
<a name="l00226"></a>00226                      <span class="stringliteral">&quot;   ----------------- -----------------\n&quot;</span> );
<a name="l00227"></a>00227          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;nconv; i++ )
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231       ierr = EPSGetEigenpair(_eps, i, &amp;kr, &amp;ki, PETSC_NULL, PETSC_NULL);
<a name="l00232"></a>00232              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234       ierr = EPSComputeRelativeError(_eps, i, &amp;error);
<a name="l00235"></a>00235              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00238"></a>00238 <span class="preprocessor"></span>      re = PetscRealPart(kr);
<a name="l00239"></a>00239       im = PetscImaginaryPart(kr);
<a name="l00240"></a>00240 <span class="preprocessor">#else</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>      re = kr;
<a name="l00242"></a>00242       im = ki;
<a name="l00243"></a>00243 <span class="preprocessor">#endif</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span>
<a name="l00245"></a>00245       <span class="keywordflow">if</span> (im != .0)
<a name="l00246"></a>00246         {
<a name="l00247"></a>00247           ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,<span class="stringliteral">&quot; %9f%+9f i %12f\n&quot;</span>, re, im, error);
<a name="l00248"></a>00248                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00249"></a>00249         }
<a name="l00250"></a>00250       <span class="keywordflow">else</span>
<a name="l00251"></a>00251         {
<a name="l00252"></a>00252           ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,<span class="stringliteral">&quot;   %12f       %12f\n&quot;</span>, re, error);
<a name="l00253"></a>00253                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00254"></a>00254         }
<a name="l00255"></a>00255     }
<a name="l00256"></a>00256   
<a name="l00257"></a>00257   ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,<span class="stringliteral">&quot;\n&quot;</span> );
<a name="l00258"></a>00258          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00259"></a>00259 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   STOP_LOG(<span class="stringliteral">&quot;solve_standard()&quot;</span>, <span class="stringliteral">&quot;SlepcEigenSolver&quot;</span>);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// return the number of converged eigenpairs</span>
<a name="l00265"></a>00265   <span class="comment">// and the number of iterations</span>
<a name="l00266"></a>00266   <span class="keywordflow">return</span> std::make_pair(nconv, its);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00275"></a>00275 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00276"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">00276</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">SlepcEigenSolver&lt;T&gt;::solve_generalized</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A_in,
<a name="l00277"></a>00277                                         <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B_in,
<a name="l00278"></a>00278                                         <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00279"></a>00279                                         <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00280"></a>00280                                         <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00281"></a>00281                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00282"></a>00282 {
<a name="l00283"></a>00283   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00286"></a>00286   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix_A   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_A_in);
<a name="l00287"></a>00287   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix_B   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_B_in);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <span class="comment">// Close the matrix and vectors in case this wasn&#39;t already done.</span>
<a name="l00290"></a>00290   matrix_A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l00291"></a>00291   matrix_B-&gt;close ();
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="keywordflow">return</span> _solve_generalized_helper (matrix_A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), matrix_B-&gt;mat(), nev, ncv, tol, m_its);
<a name="l00295"></a>00295 }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00298"></a>00298 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00299"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a57d80a37c62c61607d43ccabce4e824a">00299</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">SlepcEigenSolver&lt;T&gt;::solve_generalized</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix_A,
<a name="l00300"></a>00300                                         <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B_in,
<a name="l00301"></a>00301                                         <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00302"></a>00302                                         <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00303"></a>00303                                         <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00304"></a>00304                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="keywordtype">int</span> ierr=0;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// Prepare the matrix.</span>
<a name="l00311"></a>00311   Mat mat_A;
<a name="l00312"></a>00312   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00313"></a>00313             shell_matrix_A.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a3257a7170e8dd3829d06c0ee4ab761c1">m</a>(), <span class="comment">// Specify the number of local rows</span>
<a name="l00314"></a>00314             shell_matrix_A.<a class="code" href="classlibMesh_1_1ShellMatrix.php#afb8b4c2c14a37e7ecf03fd09be6434af">n</a>(), <span class="comment">// Specify the number of local columns</span>
<a name="l00315"></a>00315             PETSC_DETERMINE,
<a name="l00316"></a>00316             PETSC_DETERMINE,
<a name="l00317"></a>00317             <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix_A)),
<a name="l00318"></a>00318             &amp;mat_A);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix_B   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_B_in);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Close the matrix and vectors in case this wasn&#39;t already done.</span>
<a name="l00323"></a>00323   matrix_B-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00326"></a>00326 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00327"></a>00327 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00328"></a>00328 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00331"></a>00331   ierr = MatShellSetOperation(mat_A,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00332"></a>00332   ierr = MatShellSetOperation(mat_A,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00333"></a>00333   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="keywordflow">return</span> _solve_generalized_helper (mat_A, matrix_B-&gt;mat(), nev, ncv, tol, m_its);
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00339"></a>00339 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00340"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a74cdd8b56f4f46f1d4c41ce53a46c6e5">00340</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">SlepcEigenSolver&lt;T&gt;::solve_generalized</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A_in,
<a name="l00341"></a>00341                                         <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix_B,
<a name="l00342"></a>00342                                         <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00343"></a>00343                                         <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00344"></a>00344                                         <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00345"></a>00345                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00346"></a>00346 {
<a name="l00347"></a>00347   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <span class="keywordtype">int</span> ierr=0;
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix_A = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_A_in);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   <span class="comment">// Close the matrix and vectors in case this wasn&#39;t already done.</span>
<a name="l00354"></a>00354   matrix_A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="comment">// Prepare the matrix.</span>
<a name="l00357"></a>00357   Mat mat_B;
<a name="l00358"></a>00358   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00359"></a>00359             shell_matrix_B.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a3257a7170e8dd3829d06c0ee4ab761c1">m</a>(), <span class="comment">// Specify the number of local rows</span>
<a name="l00360"></a>00360             shell_matrix_B.<a class="code" href="classlibMesh_1_1ShellMatrix.php#afb8b4c2c14a37e7ecf03fd09be6434af">n</a>(), <span class="comment">// Specify the number of local columns</span>
<a name="l00361"></a>00361             PETSC_DETERMINE,
<a name="l00362"></a>00362             PETSC_DETERMINE,
<a name="l00363"></a>00363             <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix_B)),
<a name="l00364"></a>00364             &amp;mat_B);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00368"></a>00368 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00369"></a>00369 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00370"></a>00370 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00373"></a>00373   ierr = MatShellSetOperation(mat_B,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00374"></a>00374   ierr = MatShellSetOperation(mat_B,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00375"></a>00375   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="keywordflow">return</span> _solve_generalized_helper (matrix_A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), mat_B, nev, ncv, tol, m_its);
<a name="l00378"></a>00378 }
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00381"></a>00381 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00382"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ad29a1f4daea051f45b3d5fac0217f899">00382</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">SlepcEigenSolver&lt;T&gt;::solve_generalized</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix_A,
<a name="l00383"></a>00383                                         <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix_B,
<a name="l00384"></a>00384                                         <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00385"></a>00385                                         <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00386"></a>00386                                         <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00387"></a>00387                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00388"></a>00388 {
<a name="l00389"></a>00389   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   <span class="keywordtype">int</span> ierr=0;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="comment">// Prepare the matrix.</span>
<a name="l00394"></a>00394   Mat mat_A;
<a name="l00395"></a>00395   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00396"></a>00396             shell_matrix_A.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a3257a7170e8dd3829d06c0ee4ab761c1">m</a>(), <span class="comment">// Specify the number of local rows</span>
<a name="l00397"></a>00397             shell_matrix_A.<a class="code" href="classlibMesh_1_1ShellMatrix.php#afb8b4c2c14a37e7ecf03fd09be6434af">n</a>(), <span class="comment">// Specify the number of local columns</span>
<a name="l00398"></a>00398             PETSC_DETERMINE,
<a name="l00399"></a>00399             PETSC_DETERMINE,
<a name="l00400"></a>00400             <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix_A)),
<a name="l00401"></a>00401             &amp;mat_A);
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   Mat mat_B;
<a name="l00404"></a>00404   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00405"></a>00405             shell_matrix_B.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a3257a7170e8dd3829d06c0ee4ab761c1">m</a>(), <span class="comment">// Specify the number of local rows</span>
<a name="l00406"></a>00406             shell_matrix_B.<a class="code" href="classlibMesh_1_1ShellMatrix.php#afb8b4c2c14a37e7ecf03fd09be6434af">n</a>(), <span class="comment">// Specify the number of local columns</span>
<a name="l00407"></a>00407             PETSC_DETERMINE,
<a name="l00408"></a>00408             PETSC_DETERMINE,
<a name="l00409"></a>00409             <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix_B)),
<a name="l00410"></a>00410             &amp;mat_B);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00413"></a>00413 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00414"></a>00414 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00415"></a>00415 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00418"></a>00418   ierr = MatShellSetOperation(mat_A,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00419"></a>00419   ierr = MatShellSetOperation(mat_A,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00420"></a>00420   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00423"></a>00423   ierr = MatShellSetOperation(mat_B,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00424"></a>00424   ierr = MatShellSetOperation(mat_B,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00425"></a>00425   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="keywordflow">return</span> _solve_generalized_helper (mat_A, mat_B, nev, ncv, tol, m_its);
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00433"></a>00433 std::pair&lt;unsigned int, unsigned int&gt; 
<a name="l00434"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac944550f0deaa9b61c1fad1ed2c236ce">00434</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac944550f0deaa9b61c1fad1ed2c236ce">SlepcEigenSolver&lt;T&gt;::_solve_generalized_helper</a> (Mat mat_A,
<a name="l00435"></a>00435                                                 Mat mat_B,
<a name="l00436"></a>00436                                                 <span class="keywordtype">int</span> nev,                  <span class="comment">// number of requested eigenpairs</span>
<a name="l00437"></a>00437                                                 <span class="keywordtype">int</span> ncv,                  <span class="comment">// number of basis vectors</span>
<a name="l00438"></a>00438                                                 <span class="keyword">const</span> <span class="keywordtype">double</span> tol,         <span class="comment">// solver tolerance</span>
<a name="l00439"></a>00439                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) <span class="comment">// maximum number of iterations</span>
<a name="l00440"></a>00440 {
<a name="l00441"></a>00441   START_LOG(<span class="stringliteral">&quot;solve_generalized()&quot;</span>, <span class="stringliteral">&quot;SlepcEigenSolver&quot;</span>);
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keywordtype">int</span> ierr=0;
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">// converged eigen pairs and number of iterations</span>
<a name="l00446"></a>00446   <span class="keywordtype">int</span> nconv=0;
<a name="l00447"></a>00447   <span class="keywordtype">int</span> its=0;
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="preprocessor">#ifdef  DEBUG</span>
<a name="l00450"></a>00450 <span class="preprocessor"></span>  <span class="comment">// The relative error.</span>
<a name="l00451"></a>00451   PetscReal error, re, im;
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="comment">// Pointer to vectors of the real parts, imaginary parts.</span>
<a name="l00454"></a>00454   PetscScalar kr, ki;
<a name="l00455"></a>00455 <span class="preprocessor">#endif</span>
<a name="l00456"></a>00456 <span class="preprocessor"></span>
<a name="l00457"></a>00457   <span class="comment">// Set operators.</span>
<a name="l00458"></a>00458   ierr = EPSSetOperators (_eps, mat_A, mat_B);
<a name="l00459"></a>00459          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   <span class="comment">//set the problem type and the position of the spectrum</span>
<a name="l00462"></a>00462   set_slepc_problem_type();
<a name="l00463"></a>00463   set_slepc_position_of_spectrum();
<a name="l00464"></a>00464       
<a name="l00465"></a>00465   <span class="comment">// Set eigenvalues to be computed.</span>
<a name="l00466"></a>00466 <span class="preprocessor">#if SLEPC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00467"></a>00467 <span class="preprocessor"></span>  ierr = EPSSetDimensions (_eps, nev, ncv);
<a name="l00468"></a>00468 <span class="preprocessor">#else</span>
<a name="l00469"></a>00469 <span class="preprocessor"></span>  ierr = EPSSetDimensions (_eps, nev, ncv, PETSC_DECIDE);
<a name="l00470"></a>00470 <span class="preprocessor">#endif</span>
<a name="l00471"></a>00471 <span class="preprocessor"></span>         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="comment">// Set the tolerance and maximum iterations.</span>
<a name="l00475"></a>00475   ierr = EPSSetTolerances (_eps, tol, m_its);
<a name="l00476"></a>00476          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00479"></a>00479   <span class="comment">//      -eps_type &lt;type&gt;, -eps_nev &lt;nev&gt;, -eps_ncv &lt;ncv&gt;</span>
<a name="l00480"></a>00480   <span class="comment">// Similar to PETSc, these options will override those specified</span>
<a name="l00481"></a>00481   <span class="comment">// above as long as EPSSetFromOptions() is called _after_ any</span>
<a name="l00482"></a>00482   <span class="comment">// other customization routines.</span>
<a name="l00483"></a>00483   ierr = EPSSetFromOptions (_eps);
<a name="l00484"></a>00484          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="comment">// Solve the eigenproblem.</span>
<a name="l00487"></a>00487   ierr = EPSSolve (_eps);
<a name="l00488"></a>00488          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="comment">// Get the number of iterations.</span>
<a name="l00491"></a>00491   ierr = EPSGetIterationNumber (_eps, &amp;its);
<a name="l00492"></a>00492          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   <span class="comment">// Get number of converged eigenpairs.</span>
<a name="l00495"></a>00495   ierr = EPSGetConverged(_eps,&amp;nconv);
<a name="l00496"></a>00496          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00500"></a>00500 <span class="preprocessor"></span>         <span class="comment">// ierr = PetscPrintf(libMesh::COMM_WORLD,</span>
<a name="l00501"></a>00501          <span class="comment">//         &quot;\n Number of iterations: %d\n&quot;</span>
<a name="l00502"></a>00502          <span class="comment">//         &quot; Number of converged eigenpairs: %d\n\n&quot;, its, nconv);</span>
<a name="l00503"></a>00503 
<a name="l00504"></a>00504   <span class="comment">// Display eigenvalues and relative errors.</span>
<a name="l00505"></a>00505   ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00506"></a>00506                      <span class="stringliteral">&quot;           k           ||Ax-kx||/|kx|\n&quot;</span>
<a name="l00507"></a>00507                      <span class="stringliteral">&quot;   ----------------- -----------------\n&quot;</span> );
<a name="l00508"></a>00508          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;nconv; i++ )
<a name="l00511"></a>00511     {
<a name="l00512"></a>00512       ierr = EPSGetEigenpair(_eps, i, &amp;kr, &amp;ki, PETSC_NULL, PETSC_NULL);
<a name="l00513"></a>00513              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00514"></a>00514 
<a name="l00515"></a>00515       ierr = EPSComputeRelativeError(_eps, i, &amp;error);
<a name="l00516"></a>00516              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00519"></a>00519 <span class="preprocessor"></span>      re = PetscRealPart(kr);
<a name="l00520"></a>00520       im = PetscImaginaryPart(kr);
<a name="l00521"></a>00521 <span class="preprocessor">#else</span>
<a name="l00522"></a>00522 <span class="preprocessor"></span>      re = kr;
<a name="l00523"></a>00523       im = ki;
<a name="l00524"></a>00524 <span class="preprocessor">#endif</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>
<a name="l00526"></a>00526       <span class="keywordflow">if</span> (im != .0)
<a name="l00527"></a>00527         {
<a name="l00528"></a>00528           ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,<span class="stringliteral">&quot; %9f%+9f i %12f\n&quot;</span>, re, im, error);
<a name="l00529"></a>00529                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00530"></a>00530         }
<a name="l00531"></a>00531       <span class="keywordflow">else</span>
<a name="l00532"></a>00532         {
<a name="l00533"></a>00533           ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,<span class="stringliteral">&quot;   %12f       %12f\n&quot;</span>, re, error);
<a name="l00534"></a>00534                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00535"></a>00535         }
<a name="l00536"></a>00536     }
<a name="l00537"></a>00537   
<a name="l00538"></a>00538   ierr = PetscPrintf(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,<span class="stringliteral">&quot;\n&quot;</span> );
<a name="l00539"></a>00539          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00540"></a>00540 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00541"></a>00541 <span class="preprocessor"></span>
<a name="l00542"></a>00542   STOP_LOG(<span class="stringliteral">&quot;solve_generalized()&quot;</span>, <span class="stringliteral">&quot;SlepcEigenSolver&quot;</span>);
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   <span class="comment">// return the number of converged eigenpairs</span>
<a name="l00545"></a>00545   <span class="comment">// and the number of iterations</span>
<a name="l00546"></a>00546   <span class="keywordflow">return</span> std::make_pair(nconv, its);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 }
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00561"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a1b133c7c73cdeae3fcb5f0044ad2f3d0">00561</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a1b133c7c73cdeae3fcb5f0044ad2f3d0">SlepcEigenSolver&lt;T&gt;::set_slepc_solver_type</a>()
<a name="l00562"></a>00562 {
<a name="l00563"></a>00563   <span class="keywordtype">int</span> ierr = 0;
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="keywordflow">switch</span> (this-&gt;_eigen_solver_type)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a4c4cba0c68fed20d9c594627023439a7">POWER</a>:
<a name="l00568"></a>00568       ierr = EPSSetType (_eps, (<span class="keywordtype">char</span>*) EPSPOWER);    CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00569"></a>00569     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a35b82325c302dc5a2bad5925c06e6378">SUBSPACE</a>:
<a name="l00570"></a>00570       ierr = EPSSetType (_eps, (<span class="keywordtype">char</span>*) EPSSUBSPACE); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00571"></a>00571     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a96583282f35715b59e30c4533689bf6b">LAPACK</a>:
<a name="l00572"></a>00572       ierr = EPSSetType (_eps, (<span class="keywordtype">char</span>*) EPSLAPACK);   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00573"></a>00573     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a12dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>:
<a name="l00574"></a>00574       ierr = EPSSetType (_eps, (<span class="keywordtype">char</span>*) EPSARNOLDI);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00575"></a>00575     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a414a7b3da73d65668baf9de851f85b80">LANCZOS</a>:
<a name="l00576"></a>00576       ierr = EPSSetType (_eps, (<span class="keywordtype">char</span>*) EPSLANCZOS);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00577"></a>00577 <span class="preprocessor">#if !SLEPC_VERSION_LESS_THAN(2,3,2)</span>
<a name="l00578"></a>00578 <span class="preprocessor"></span>      <span class="comment">// EPSKRYLOVSCHUR added in 2.3.2</span>
<a name="l00579"></a>00579     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802aab344a669e1795431ec3a973e82c8cc4">KRYLOVSCHUR</a>:
<a name="l00580"></a>00580       ierr = EPSSetType (_eps, (<span class="keywordtype">char</span>*) EPSKRYLOVSCHUR);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00581"></a>00581 <span class="preprocessor">#endif</span>
<a name="l00582"></a>00582 <span class="preprocessor"></span>      <span class="comment">// case ARPACK:</span>
<a name="l00583"></a>00583       <span class="comment">// ierr = EPSSetType (_eps, (char*) EPSARPACK);   CHKERRABORT(libMesh::COMM_WORLD,ierr); return;</span>
<a name="l00584"></a>00584       
<a name="l00585"></a>00585     <span class="keywordflow">default</span>:
<a name="l00586"></a>00586       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported SLEPc Eigen Solver: &quot;</span>
<a name="l00587"></a>00587                     &lt;&lt; this-&gt;_eigen_solver_type         &lt;&lt; std::endl
<a name="l00588"></a>00588                     &lt;&lt; <span class="stringliteral">&quot;Continuing with SLEPc defaults&quot;</span> &lt;&lt; std::endl;
<a name="l00589"></a>00589     }
<a name="l00590"></a>00590 }
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 
<a name="l00593"></a>00593         
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00596"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a4caededd993a541ee42b1aac12ec9b0a">00596</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a4caededd993a541ee42b1aac12ec9b0a">SlepcEigenSolver&lt;T&gt;:: set_slepc_problem_type</a>()
<a name="l00597"></a>00597 {
<a name="l00598"></a>00598   <span class="keywordtype">int</span> ierr = 0;
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="keywordflow">switch</span> (this-&gt;_eigen_problem_type)
<a name="l00601"></a>00601     {
<a name="l00602"></a>00602     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>:
<a name="l00603"></a>00603       ierr = EPSSetProblemType (_eps, EPS_NHEP);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00604"></a>00604     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a456841f5f527e93817e4bcea61b6cdfb">GNHEP</a>:
<a name="l00605"></a>00605       ierr = EPSSetProblemType (_eps, EPS_GNHEP); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00606"></a>00606     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a0fbfb4356e45e29380946d58569abdff">HEP</a>:
<a name="l00607"></a>00607       ierr = EPSSetProblemType (_eps, EPS_HEP);   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00608"></a>00608     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>:
<a name="l00609"></a>00609       ierr = EPSSetProblemType (_eps, EPS_GHEP);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00610"></a>00610       
<a name="l00611"></a>00611     <span class="keywordflow">default</span>:
<a name="l00612"></a>00612       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported SLEPc Eigen Problem: &quot;</span>
<a name="l00613"></a>00613                     &lt;&lt; this-&gt;_eigen_problem_type        &lt;&lt; std::endl
<a name="l00614"></a>00614                     &lt;&lt; <span class="stringliteral">&quot;Continuing with SLEPc defaults&quot;</span> &lt;&lt; std::endl;
<a name="l00615"></a>00615     }
<a name="l00616"></a>00616 }
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00621"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a77ebdb1f99c6b42405b7aa1b7404c116">00621</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a77ebdb1f99c6b42405b7aa1b7404c116">SlepcEigenSolver&lt;T&gt;:: set_slepc_position_of_spectrum</a>()
<a name="l00622"></a>00622 {
<a name="l00623"></a>00623   <span class="keywordtype">int</span> ierr = 0;
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <span class="keywordflow">switch</span> (this-&gt;_position_of_spectrum)
<a name="l00626"></a>00626     {
<a name="l00627"></a>00627     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84aa33e7e94f5eba77558dbdb57a640e964">LARGEST_MAGNITUDE</a>:
<a name="l00628"></a>00628       ierr = EPSSetWhichEigenpairs (_eps, EPS_LARGEST_MAGNITUDE);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00629"></a>00629     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84aa60cb1ca5386fdb87a4ace420ac16f18">SMALLEST_MAGNITUDE</a>:
<a name="l00630"></a>00630       ierr = EPSSetWhichEigenpairs (_eps, EPS_SMALLEST_MAGNITUDE); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00631"></a>00631     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a1b94059b18d6e3e5dcdcd025a8c70e3c">LARGEST_REAL</a>:
<a name="l00632"></a>00632       ierr = EPSSetWhichEigenpairs (_eps, EPS_LARGEST_REAL);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00633"></a>00633     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a70d88d6415d884726e778f256c886c66">SMALLEST_REAL</a>:
<a name="l00634"></a>00634       ierr = EPSSetWhichEigenpairs (_eps, EPS_SMALLEST_REAL);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l00635"></a>00635     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a0440fa306d273d7de7f07f701c82fd0f">LARGEST_IMAGINARY</a>:
<a name="l00636"></a>00636       ierr = EPSSetWhichEigenpairs (_eps, EPS_LARGEST_IMAGINARY);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>; 
<a name="l00637"></a>00637     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84a2e9061e7e75f89f93e99bf548acbcf24">SMALLEST_IMAGINARY</a>:
<a name="l00638"></a>00638       ierr = EPSSetWhichEigenpairs (_eps, EPS_SMALLEST_IMAGINARY); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>; 
<a name="l00639"></a>00639      
<a name="l00640"></a>00640       
<a name="l00641"></a>00641     <span class="keywordflow">default</span>:
<a name="l00642"></a>00642       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported SLEPc position of spectrum: &quot;</span>
<a name="l00643"></a>00643                     &lt;&lt; this-&gt;_position_of_spectrum        &lt;&lt; std::endl;
<a name="l00644"></a>00644       libmesh_error();
<a name="l00645"></a>00645     }
<a name="l00646"></a>00646 }
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00654"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a661fcf911531b12e4a0e031a6d6bc283">00654</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a661fcf911531b12e4a0e031a6d6bc283">SlepcEigenSolver&lt;T&gt;::get_eigenpair</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00655"></a>00655                                                          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in)
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <span class="keywordtype">int</span> ierr=0;
<a name="l00658"></a>00658 
<a name="l00659"></a>00659   PetscReal re, im;
<a name="l00660"></a>00660 
<a name="l00661"></a>00661   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00662"></a>00662   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// real and imaginary part of the ith eigenvalue.</span>
<a name="l00665"></a>00665   PetscScalar kr, ki;
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a>();
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   ierr = EPSGetEigenpair(_eps, i, &amp;kr, &amp;ki, solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(), PETSC_NULL);
<a name="l00670"></a>00670          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00673"></a>00673 <span class="preprocessor"></span>  re = PetscRealPart(kr);
<a name="l00674"></a>00674   im = PetscImaginaryPart(kr);
<a name="l00675"></a>00675 <span class="preprocessor">#else</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>  re = kr;
<a name="l00677"></a>00677   im = ki;
<a name="l00678"></a>00678 <span class="preprocessor">#endif</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>
<a name="l00680"></a>00680   <span class="keywordflow">return</span> std::make_pair(re, im);
<a name="l00681"></a>00681 }
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00685"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a8c76354390e90fe41183b1c479e24750">00685</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a8c76354390e90fe41183b1c479e24750">SlepcEigenSolver&lt;T&gt;::get_relative_error</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00686"></a>00686 {
<a name="l00687"></a>00687   <span class="keywordtype">int</span> ierr=0;
<a name="l00688"></a>00688   PetscReal error;
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   ierr = EPSComputeRelativeError(_eps, i, &amp;error);
<a name="l00691"></a>00691          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00692"></a>00692 
<a name="l00693"></a>00693   <span class="keywordflow">return</span> error;
<a name="l00694"></a>00694 }
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00698"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a3c5e078577712cbcc7a01e3cf043eac9">00698</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a3c5e078577712cbcc7a01e3cf043eac9">SlepcEigenSolver&lt;T&gt;::attach_deflation_space</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; deflation_vector_in)
<a name="l00699"></a>00699 {
<a name="l00700"></a>00700   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>();
<a name="l00701"></a>00701 
<a name="l00702"></a>00702   <span class="keywordtype">int</span> ierr = 0;
<a name="l00703"></a>00703   Vec deflation_vector = (libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;deflation_vector_in))-&gt;vec();
<a name="l00704"></a>00704   Vec* deflation_space = &amp;deflation_vector;
<a name="l00705"></a>00705 <span class="preprocessor">#if SLEPC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00706"></a>00706 <span class="preprocessor"></span>  ierr = EPSAttachDeflationSpace(_eps, 1, deflation_space, PETSC_FALSE);
<a name="l00707"></a>00707 <span class="preprocessor">#else</span>
<a name="l00708"></a>00708 <span class="preprocessor"></span>  ierr = EPSSetDeflationSpace(_eps, 1, deflation_space);
<a name="l00709"></a>00709 <span class="preprocessor">#endif</span>
<a name="l00710"></a>00710 <span class="preprocessor"></span>  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00711"></a>00711 }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00714"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ad74b1e25c35e1b2a74a3c2b6b9124fa7">00714</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ad74b1e25c35e1b2a74a3c2b6b9124fa7">SlepcEigenSolver&lt;T&gt;::_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest)
<a name="l00715"></a>00715 {
<a name="l00716"></a>00716   <span class="comment">/* Get the matrix context.  */</span>
<a name="l00717"></a>00717   <span class="keywordtype">int</span> ierr=0;
<a name="l00718"></a>00718   <span class="keywordtype">void</span>* ctx;
<a name="l00719"></a>00719   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l00720"></a>00720   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00721"></a>00721 
<a name="l00722"></a>00722   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l00723"></a>00723   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <span class="comment">/* Make \p NumericVector instances around the vectors.  */</span>
<a name="l00726"></a>00726   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> arg_global(arg);
<a name="l00727"></a>00727   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   <span class="comment">/* Call the user function.  */</span>
<a name="l00730"></a>00730   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a090ec49ccc34e8d103eba352b66cdf31">vector_mult</a>(dest_global,arg_global);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732   <span class="keywordflow">return</span> ierr;
<a name="l00733"></a>00733 }
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00736"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac8d84e98150670e1d13388f3eb1a58dc">00736</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac8d84e98150670e1d13388f3eb1a58dc">SlepcEigenSolver&lt;T&gt;::_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest)
<a name="l00737"></a>00737 {
<a name="l00738"></a>00738   <span class="comment">/* Get the matrix context.  */</span>
<a name="l00739"></a>00739   <span class="keywordtype">int</span> ierr=0;
<a name="l00740"></a>00740   <span class="keywordtype">void</span>* ctx;
<a name="l00741"></a>00741   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l00742"></a>00742   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l00745"></a>00745   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l00746"></a>00746 
<a name="l00747"></a>00747   <span class="comment">/* Make \p NumericVector instances around the vector.  */</span>
<a name="l00748"></a>00748   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l00749"></a>00749 
<a name="l00750"></a>00750   <span class="comment">/* Call the user function.  */</span>
<a name="l00751"></a>00751   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a1516571b30e8da439c498ce0e4ac788c">get_diagonal</a>(dest_global);
<a name="l00752"></a>00752 
<a name="l00753"></a>00753   <span class="keywordflow">return</span> ierr;
<a name="l00754"></a>00754 }
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00757"></a>00757 <span class="comment">// Explicit instantiations</span>
<a name="l00758"></a>00758 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php">SlepcEigenSolver&lt;Number&gt;</a>;
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 } <span class="comment">// namespace libMesh</span>
<a name="l00761"></a>00761  
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_SLEPC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
