<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">slepc_eigen_solver.h</div>  </div>
</div>
<div class="contents">
<a href="slepc__eigen__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: slepc_eigen_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __slepc_eigen_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __slepc_eigen_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="eigen__solver_8h.php">eigen_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="slepc__macro_8h.php">slepc_macro.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00036"></a>00036 EXTERN_C_FOR_SLEPC_BEGIN
<a name="l00037"></a>00037 <span class="preprocessor"># include &lt;slepceps.h&gt;</span>
<a name="l00038"></a>00038 EXTERN_C_FOR_SLEPC_END
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00051"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php">00051</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php">SlepcEigenSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1EigenSolver.php">EigenSolver</a>&lt;T&gt;
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ae37798cc48b475435a554ed9f084fa0c">SlepcEigenSolver</a>();
<a name="l00060"></a>00060     
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a9d9c191a9a9d0a759fe0cb8236945dfe">~SlepcEigenSolver</a>();
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a8a9fa50bf0b8ff10c728fc5a7e51c458">clear</a>();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ab93a28b2f4aa39463a73bfea7daea035">init</a>();
<a name="l00078"></a>00078 
<a name="l00079"></a>00079        
<a name="l00090"></a>00090   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a79e925883cca4095b8c1b6cb1b75d26c">solve_standard</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00091"></a>00091                                                          <span class="keywordtype">int</span> nev,
<a name="l00092"></a>00092                                                          <span class="keywordtype">int</span> ncv,
<a name="l00093"></a>00093                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00094"></a>00094                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00095"></a>00095 
<a name="l00100"></a>00100   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a79e925883cca4095b8c1b6cb1b75d26c">solve_standard</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;shell_matrix,
<a name="l00101"></a>00101                                                          <span class="keywordtype">int</span> nev,
<a name="l00102"></a>00102                                                          <span class="keywordtype">int</span> ncv,
<a name="l00103"></a>00103                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00104"></a>00104                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00105"></a>00105   
<a name="l00106"></a>00106 
<a name="l00119"></a>00119   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">solve_generalized</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00120"></a>00120                                                            <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00121"></a>00121                                                            <span class="keywordtype">int</span> nev,
<a name="l00122"></a>00122                                                            <span class="keywordtype">int</span> ncv,
<a name="l00123"></a>00123                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00124"></a>00124                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00125"></a>00125 
<a name="l00130"></a>00130     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">solve_generalized</a>(<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00131"></a>00131                                                            <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00132"></a>00132                                                            <span class="keywordtype">int</span> nev,
<a name="l00133"></a>00133                                                            <span class="keywordtype">int</span> ncv,
<a name="l00134"></a>00134                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00135"></a>00135                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00136"></a>00136 
<a name="l00147"></a>00147     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">solve_generalized</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00148"></a>00148                                                            <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00149"></a>00149                                                            <span class="keywordtype">int</span> nev,
<a name="l00150"></a>00150                                                            <span class="keywordtype">int</span> ncv,
<a name="l00151"></a>00151                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00152"></a>00152                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00153"></a>00153 
<a name="l00164"></a>00164     std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a34746d3805c0c34ccffd0f8adcea442a">solve_generalized</a>(<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,
<a name="l00165"></a>00165                                                            <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,
<a name="l00166"></a>00166                                                            <span class="keywordtype">int</span> nev,
<a name="l00167"></a>00167                                                            <span class="keywordtype">int</span> ncv,
<a name="l00168"></a>00168                                                            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00169"></a>00169                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171  
<a name="l00172"></a>00172  
<a name="l00179"></a>00179   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a661fcf911531b12e4a0e031a6d6bc283">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00180"></a>00180                                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in);
<a name="l00181"></a>00181 
<a name="l00186"></a>00186   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a8c76354390e90fe41183b1c479e24750">get_relative_error</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00187"></a>00187 
<a name="l00191"></a>00191   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a3c5e078577712cbcc7a01e3cf043eac9">attach_deflation_space</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; deflation_vector);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="keyword">private</span>:
<a name="l00194"></a>00194 
<a name="l00198"></a>00198   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ae23257b288ee7946da38bee8cd342fce">_solve_standard_helper</a> (Mat mat,
<a name="l00199"></a>00199                                                          <span class="keywordtype">int</span> nev,
<a name="l00200"></a>00200                                                          <span class="keywordtype">int</span> ncv,
<a name="l00201"></a>00201                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00202"></a>00202                                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00203"></a>00203 
<a name="l00207"></a>00207   std::pair&lt;unsigned int, unsigned int&gt;  <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac944550f0deaa9b61c1fad1ed2c236ce">_solve_generalized_helper</a> (Mat mat_A,
<a name="l00208"></a>00208                                                                  Mat mat_B,
<a name="l00209"></a>00209                                                                  <span class="keywordtype">int</span> nev,
<a name="l00210"></a>00210                                                                  <span class="keywordtype">int</span> ncv,
<a name="l00211"></a>00211                                                                  <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00212"></a>00212                                                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00213"></a>00213 
<a name="l00218"></a>00218   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a1b133c7c73cdeae3fcb5f0044ad2f3d0">set_slepc_solver_type</a> ();
<a name="l00219"></a>00219 
<a name="l00224"></a>00224   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a4caededd993a541ee42b1aac12ec9b0a">set_slepc_problem_type</a> ();
<a name="l00225"></a>00225 
<a name="l00230"></a>00230   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a77ebdb1f99c6b42405b7aa1b7404c116">set_slepc_position_of_spectrum</a>();
<a name="l00231"></a>00231 
<a name="l00237"></a>00237   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ad74b1e25c35e1b2a74a3c2b6b9124fa7">_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest);
<a name="l00238"></a>00238 
<a name="l00244"></a>00244   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac8d84e98150670e1d13388f3eb1a58dc">_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest);
<a name="l00245"></a>00245 
<a name="l00249"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac60dbf9c9ea50b21f5ddce9ea10604ea">00249</a>   EPS <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ac60dbf9c9ea50b21f5ddce9ea10604ea">_eps</a>;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 };
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00255"></a>00255 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00256"></a>00256 <span class="keyword">inline</span>
<a name="l00257"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ae37798cc48b475435a554ed9f084fa0c">00257</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#ae37798cc48b475435a554ed9f084fa0c">SlepcEigenSolver&lt;T&gt;::SlepcEigenSolver</a> ()
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   this-&gt;_eigen_solver_type  = <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a12dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>;
<a name="l00260"></a>00260   this-&gt;_eigen_problem_type = <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>;
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00266"></a>00266 <span class="keyword">inline</span>
<a name="l00267"></a><a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a9d9c191a9a9d0a759fe0cb8236945dfe">00267</a> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php#a9d9c191a9a9d0a759fe0cb8236945dfe">SlepcEigenSolver&lt;T&gt;::~SlepcEigenSolver</a> ()
<a name="l00268"></a>00268 {
<a name="l00269"></a>00269   this-&gt;clear ();
<a name="l00270"></a>00270 }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 } <span class="comment">// namespace libMesh</span>
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __slepc_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
