<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">slepc_macro.h</div>  </div>
</div>
<div class="contents">
<a href="slepc__macro_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: slepc_macro.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __slepc_macro_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __slepc_macro_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="preprocessor"># include &lt;slepcversion.h&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// A convenient macro for comparing SLEPc versions.</span>
<a name="l00038"></a>00038 <span class="comment">// Returns 1 if the current SLEPc version is &lt; major.minor.subminor</span>
<a name="l00039"></a>00039 <span class="comment">// and zero otherwise.</span>
<a name="l00040"></a>00040 <span class="preprocessor">#define SLEPC_VERSION_LESS_THAN(major,minor,subminor)                               \</span>
<a name="l00041"></a>00041 <span class="preprocessor">  ((SLEPC_VERSION_MAJOR &lt; (major) ||                                                \</span>
<a name="l00042"></a>00042 <span class="preprocessor">    (SLEPC_VERSION_MAJOR == (major) &amp;&amp; (SLEPC_VERSION_MINOR &lt; (minor) ||            \</span>
<a name="l00043"></a>00043 <span class="preprocessor">                                  (SLEPC_VERSION_MINOR == (minor) &amp;&amp;                \</span>
<a name="l00044"></a>00044 <span class="preprocessor">                                   SLEPC_VERSION_SUBMINOR &lt; (subminor))))) ? 1 : 0)</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="comment">// Make up for missing extern &quot;C&quot; in old SLEPc versions</span>
<a name="l00047"></a>00047 <span class="preprocessor">#if !defined(LIBMESH_USE_COMPLEX_NUMBERS) &amp;&amp; SLEPC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_SLEPC_BEGIN extern &quot;C&quot; {</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_SLEPC_END }</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_SLEPC_BEGIN </span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_SLEPC_END</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055 <span class="preprocessor">#endif // #if LIBMESH_HAVE_SLEPC</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __slepc_macro_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
