<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">solver.h</div>  </div>
</div>
<div class="contents">
<a href="solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: solver.h 4044 2010-10-12 23:33:03Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>MeshBase;
<a name="l00037"></a>00037 <span class="keyword">class </span>Solver;
<a name="l00038"></a>00038 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// Solver class definition</span>
<a name="l00049"></a><a class="code" href="classlibMesh_1_1Solver.php">00049</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Solver.php">Solver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Solver&gt;
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">protected</span>:
<a name="l00052"></a>00052   
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1Solver.php#a694dfe728cc02a220899b0fb69fc0705">Solver</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00059"></a>00059 
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1Solver.php#a694dfe728cc02a220899b0fb69fc0705">Solver</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00065"></a>00065           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00066"></a>00066           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00067"></a>00067   
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">public</span>:
<a name="l00070"></a>00070   
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1Solver.php#a20b1f7a1f80b389fda42763229e454ea">~Solver</a> ();
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1Solver.php#a788919e8b3e0af59d4272bcc7749ded1">00079</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> <a class="code" href="classlibMesh_1_1Solver.php#a788919e8b3e0af59d4272bcc7749ded1">sys_type</a>;
<a name="l00080"></a>00080   
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#aa2c1a1c599a955097f75d9e2e470c53e">init</a> ();
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#a85f1c35b5046d5a14da16804cfd75c28">pre_process</a> ();
<a name="l00092"></a>00092 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#aa08ef529c58b47404e1fc2481e65194d">solve</a> ();
<a name="l00099"></a>00099 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#a2cf59bb78e541de0494a20af1ecd6bf5">post_process</a> ();
<a name="l00105"></a>00105 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Solver.php#a2c00e51bb1ae1db52437ef3a51cece1b">00109</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1Solver.php#a2c00e51bb1ae1db52437ef3a51cece1b">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Solver.php#a1edc68cac706f74f9fcda804a7655f80">_system</a>; }
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classlibMesh_1_1Solver.php#a8cb05962447614b1349434c03994f03c">00114</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1Solver.php#a8cb05962447614b1349434c03994f03c">mesh</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Solver.php#ab619701bd01be1b671b537938ce2d04e">_mesh</a>; }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   
<a name="l00117"></a>00117 <span class="keyword">protected</span>:
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1Solver.php#af5f7a173b9e163dac45f0b718de5b0f2">00122</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1Solver.php#af5f7a173b9e163dac45f0b718de5b0f2">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Solver.php#a1edc68cac706f74f9fcda804a7655f80">_system</a>; }
<a name="l00123"></a>00123   
<a name="l00127"></a><a class="code" href="classlibMesh_1_1Solver.php#a92b007f580f027496787e98149b50455">00127</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1Solver.php#a92b007f580f027496787e98149b50455">mesh</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Solver.php#ab619701bd01be1b671b537938ce2d04e">_mesh</a>; }
<a name="l00128"></a>00128 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1Solver.php#a1edc68cac706f74f9fcda804a7655f80">00132</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">sys_type</a>&amp; <a class="code" href="classlibMesh_1_1Solver.php#a1edc68cac706f74f9fcda804a7655f80">_system</a>;
<a name="l00133"></a>00133 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1Solver.php#ab619701bd01be1b671b537938ce2d04e">00138</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1Solver.php#ab619701bd01be1b671b537938ce2d04e">_mesh</a>;
<a name="l00139"></a>00139 };
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00144"></a>00144 <span class="comment">// Solver inline members</span>
<a name="l00145"></a>00145 <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="classlibMesh_1_1Solver.php#a694dfe728cc02a220899b0fb69fc0705">00146</a> <a class="code" href="classlibMesh_1_1Solver.php#a694dfe728cc02a220899b0fb69fc0705">Solver::Solver</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00147"></a>00147   _system (es),
<a name="l00148"></a>00148   _mesh   (es.get_mesh())
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150 libmesh_deprecated();
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">inline</span>
<a name="l00156"></a><a class="code" href="classlibMesh_1_1Solver.php#a20b1f7a1f80b389fda42763229e454ea">00156</a> <a class="code" href="classlibMesh_1_1Solver.php#a20b1f7a1f80b389fda42763229e454ea">Solver::~Solver</a> ()
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">inline</span>
<a name="l00163"></a><a class="code" href="classlibMesh_1_1Solver.php#aa2c1a1c599a955097f75d9e2e470c53e">00163</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#aa2c1a1c599a955097f75d9e2e470c53e">Solver::init</a> ()
<a name="l00164"></a>00164 {
<a name="l00165"></a>00165   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Initializing $Id: solver.h 4044 2010-10-12 23:33:03Z roystgnr $&quot;</span>
<a name="l00166"></a>00166                &lt;&lt; std::endl;
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   <span class="comment">// Initialize the system.</span>
<a name="l00169"></a>00169   this-&gt;<a class="code" href="classlibMesh_1_1Solver.php#a2c00e51bb1ae1db52437ef3a51cece1b">system</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#aa79320b68e236ece82d5b358721ebd13">init</a> ();
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="keyword">inline</span>
<a name="l00175"></a><a class="code" href="classlibMesh_1_1Solver.php#a85f1c35b5046d5a14da16804cfd75c28">00175</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#a85f1c35b5046d5a14da16804cfd75c28">Solver::pre_process</a> ()
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177 <span class="comment">//  libMesh::out &lt;&lt; &quot;Pre-processing&quot;</span>
<a name="l00178"></a>00178 <span class="comment">//               &lt;&lt; std::endl;</span>
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">inline</span>
<a name="l00184"></a><a class="code" href="classlibMesh_1_1Solver.php#aa08ef529c58b47404e1fc2481e65194d">00184</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#aa08ef529c58b47404e1fc2481e65194d">Solver::solve</a> ()
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   <span class="comment">// Perform any necessary pre-processing</span>
<a name="l00187"></a>00187   <a class="code" href="classlibMesh_1_1Solver.php#a85f1c35b5046d5a14da16804cfd75c28">Solver::pre_process</a> ();
<a name="l00188"></a>00188   
<a name="l00189"></a>00189 <span class="comment">//  libMesh::out &lt;&lt; &quot;Solving $Id: solver.h 4044 2010-10-12 23:33:03Z roystgnr $&quot;</span>
<a name="l00190"></a>00190 <span class="comment">//               &lt;&lt; std::endl;</span>
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="comment">// Solve the system</span>
<a name="l00193"></a>00193   this-&gt;<a class="code" href="classlibMesh_1_1Solver.php#a2c00e51bb1ae1db52437ef3a51cece1b">system</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#ae63435d018c0c5cd6d0b72547afc0032">solve</a> ();
<a name="l00194"></a>00194   
<a name="l00195"></a>00195   <span class="comment">// Perform any necessary post-processing</span>
<a name="l00196"></a>00196   <a class="code" href="classlibMesh_1_1Solver.php#a2cf59bb78e541de0494a20af1ecd6bf5">Solver::post_process</a> ();  
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="keyword">inline</span>
<a name="l00202"></a><a class="code" href="classlibMesh_1_1Solver.php#a2cf59bb78e541de0494a20af1ecd6bf5">00202</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Solver.php#a2cf59bb78e541de0494a20af1ecd6bf5">Solver::post_process</a> ()
<a name="l00203"></a>00203 {
<a name="l00204"></a>00204 <span class="comment">//  libMesh::out &lt;&lt; &quot;Post-processing&quot;</span>
<a name="l00205"></a>00205 <span class="comment">//               &lt;&lt; std::endl;</span>
<a name="l00206"></a>00206 }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 } <span class="comment">// namespace libMesh</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#endif // #define __solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
