<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sparse_matrix.C</div>  </div>
</div>
<div class="contents">
<a href="sparse__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sparse_matrix.C 4267 2011-03-16 09:24:03Z sheep_tk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="laspack__matrix_8h.php">laspack_matrix.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__epetra__matrix_8h.php">trilinos_epetra_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// SparseMatrix Methods</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Full specialization for Real datatypes</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00042"></a>00042 AutoPtr&lt;SparseMatrix&lt;T&gt; &gt;
<a name="l00043"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a119240002210a79e854aed341d223fba">00043</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a119240002210a79e854aed341d223fba">SparseMatrix&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   <span class="comment">// Build the appropriate vector</span>
<a name="l00046"></a>00046   <span class="keywordflow">switch</span> (solver_package)
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMesh.php#aeb2a777af969e03421c99c4afe9d68a0">LASPACK_SOLVERS</a>:
<a name="l00052"></a>00052       {
<a name="l00053"></a>00053         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>);
<a name="l00054"></a>00054         <span class="keywordflow">return</span> ap;
<a name="l00055"></a>00055       }
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00061"></a>00061       {
<a name="l00062"></a>00062         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>);
<a name="l00063"></a>00063         <span class="keywordflow">return</span> ap;
<a name="l00064"></a>00064       }
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMesh.php#aa27e267f495ee0599f7cd8981c0cf7ad">TRILINOS_SOLVERS</a>:
<a name="l00070"></a>00070       {
<a name="l00071"></a>00071         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php">EpetraMatrix&lt;T&gt;</a>);
<a name="l00072"></a>00072         <span class="keywordflow">return</span> ap;
<a name="l00073"></a>00073       }
<a name="l00074"></a>00074 <span class="preprocessor">#endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keywordflow">default</span>:
<a name="l00078"></a>00078       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unrecognized solver package: &quot;</span>
<a name="l00079"></a>00079                     &lt;&lt; solver_package
<a name="l00080"></a>00080                     &lt;&lt; std::endl;
<a name="l00081"></a>00081       libmesh_error();
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00085"></a>00085   <span class="keywordflow">return</span> ap;    
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00090"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">00090</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">SparseMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00091"></a>00091                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00092"></a>00092 <span class="keyword"></span>{
<a name="l00093"></a>00093   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00094"></a>00094   this-&gt;vector_mult_add(dest,arg);
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00100"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a0a7445955e126e341cd9a2e71b3c3976">00100</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a0a7445955e126e341cd9a2e71b3c3976">SparseMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00101"></a>00101                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword"></span>{
<a name="l00103"></a>00103   <span class="comment">/* This functionality is actually implemented in the \p</span>
<a name="l00104"></a>00104 <span class="comment">     NumericVector class.  */</span>
<a name="l00105"></a>00105   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>(arg,*<span class="keyword">this</span>);
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00111"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#af5629d649061318333d2a3364ecddb75">00111</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#af5629d649061318333d2a3364ecddb75">SparseMatrix&lt;T&gt;::zero_rows</a> (std::vector&lt;int&gt; &amp;, T)
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113   <span class="comment">/* This functionality isn&#39;t implemented or stubbed in every subclass yet */</span>
<a name="l00114"></a>00114   libmesh_not_implemented();
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00120"></a>00120 <span class="keyword">inline</span>
<a name="l00121"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#afcdf5bc4246bc646599e5d1a031b3c96">00121</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#afcdf5bc4246bc646599e5d1a031b3c96">SparseMatrix&lt;T&gt;::print</a>(std::ostream&amp; os, <span class="keyword">const</span> <span class="keywordtype">bool</span> sparse)<span class="keyword"> const</span>
<a name="l00122"></a>00122 <span class="keyword"></span>{
<a name="l00123"></a>00123   parallel_only();
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordflow">if</span>(!this-&gt;_dof_map)
<a name="l00128"></a>00128   {
<a name="l00129"></a>00129     os &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Error!  Trying to print a matrix with no dof_map set!&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00130"></a>00130     libmesh_error();
<a name="l00131"></a>00131   }  
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// We&#39;ll print the matrix from processor 0 to make sure</span>
<a name="l00134"></a>00134   <span class="comment">// it&#39;s serialized properly</span>
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       libmesh_assert(this-&gt;_dof_map-&gt;first_dof() == 0);
<a name="l00138"></a>00138       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;_dof_map-&gt;first_dof();
<a name="l00139"></a>00139            i!=this-&gt;_dof_map-&gt;end_dof(); ++i)
<a name="l00140"></a>00140         {
<a name="l00141"></a>00141           <span class="keywordflow">if</span>(sparse)
<a name="l00142"></a>00142             {
<a name="l00143"></a>00143               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00144"></a>00144                 {
<a name="l00145"></a>00145                   T c = (*this)(i,j);
<a name="l00146"></a>00146                   <span class="keywordflow">if</span> (c != static_cast&lt;T&gt;(0.0))
<a name="l00147"></a>00147                     {
<a name="l00148"></a>00148                       os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; c &lt;&lt; std::endl;
<a name="l00149"></a>00149                     }
<a name="l00150"></a>00150                 }
<a name="l00151"></a>00151             }
<a name="l00152"></a>00152           <span class="keywordflow">else</span>
<a name="l00153"></a>00153             {
<a name="l00154"></a>00154               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00155"></a>00155                 os &lt;&lt; (*<span class="keyword">this</span>)(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00156"></a>00156               os &lt;&lt; std::endl;
<a name="l00157"></a>00157             }
<a name="l00158"></a>00158         }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160       std::vector&lt;unsigned int&gt; ibuf, jbuf;
<a name="l00161"></a>00161       std::vector&lt;T&gt; cbuf;
<a name="l00162"></a>00162       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> currenti = this-&gt;_dof_map-&gt;end_dof();
<a name="l00163"></a>00163       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(p, ibuf);
<a name="l00166"></a>00166           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(p, jbuf);
<a name="l00167"></a>00167           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(p, cbuf);
<a name="l00168"></a>00168           libmesh_assert(ibuf.size() == jbuf.size());
<a name="l00169"></a>00169           libmesh_assert(ibuf.size() == cbuf.size());
<a name="l00170"></a>00170 
<a name="l00171"></a>00171           <span class="keywordflow">if</span> (ibuf.empty())
<a name="l00172"></a>00172             <span class="keywordflow">continue</span>;
<a name="l00173"></a>00173           libmesh_assert(ibuf.front() &gt;= currenti);
<a name="l00174"></a>00174           libmesh_assert(ibuf.back() &gt;= ibuf.front());
<a name="l00175"></a>00175 
<a name="l00176"></a>00176           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> currentb = 0;
<a name="l00177"></a>00177           <span class="keywordflow">for</span> (;currenti &lt;= ibuf.back(); ++currenti)
<a name="l00178"></a>00178             {
<a name="l00179"></a>00179               <span class="keywordflow">if</span>(sparse)
<a name="l00180"></a>00180                 {
<a name="l00181"></a>00181                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00182"></a>00182                     {
<a name="l00183"></a>00183                       <span class="keywordflow">if</span> (currentb &lt; ibuf.size() &amp;&amp;
<a name="l00184"></a>00184                           ibuf[currentb] == currenti &amp;&amp;
<a name="l00185"></a>00185                           jbuf[currentb] == j)
<a name="l00186"></a>00186                         {
<a name="l00187"></a>00187                           os &lt;&lt; currenti &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; cbuf[currentb] &lt;&lt; std::endl;
<a name="l00188"></a>00188                           currentb++;
<a name="l00189"></a>00189                         }
<a name="l00190"></a>00190                     }
<a name="l00191"></a>00191                 }
<a name="l00192"></a>00192               <span class="keywordflow">else</span>
<a name="l00193"></a>00193                 {
<a name="l00194"></a>00194                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00195"></a>00195                     {
<a name="l00196"></a>00196                       <span class="keywordflow">if</span> (currentb &lt; ibuf.size() &amp;&amp;
<a name="l00197"></a>00197                           ibuf[currentb] == currenti &amp;&amp;
<a name="l00198"></a>00198                           jbuf[currentb] == j)
<a name="l00199"></a>00199                         {
<a name="l00200"></a>00200                           os &lt;&lt; cbuf[currentb] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00201"></a>00201                           currentb++;
<a name="l00202"></a>00202                         }
<a name="l00203"></a>00203                       <span class="keywordflow">else</span>
<a name="l00204"></a>00204                         os &lt;&lt; static_cast&lt;T&gt;(0.0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00205"></a>00205                     }
<a name="l00206"></a>00206                   os &lt;&lt; std::endl;
<a name="l00207"></a>00207                 }
<a name="l00208"></a>00208             }
<a name="l00209"></a>00209         }
<a name="l00210"></a>00210       <span class="keywordflow">if</span>(!sparse)
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           <span class="keywordflow">for</span> (; currenti != this-&gt;m(); ++currenti)
<a name="l00213"></a>00213             {
<a name="l00214"></a>00214               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00215"></a>00215                 os &lt;&lt; static_cast&lt;T&gt;(0.0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00216"></a>00216               os &lt;&lt; std::endl;
<a name="l00217"></a>00217             }
<a name="l00218"></a>00218         }
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220   <span class="keywordflow">else</span>
<a name="l00221"></a>00221     {
<a name="l00222"></a>00222       std::vector&lt;unsigned int&gt; ibuf, jbuf;
<a name="l00223"></a>00223       std::vector&lt;T&gt; cbuf;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225       <span class="comment">// We&#39;ll assume each processor has access to entire</span>
<a name="l00226"></a>00226       <span class="comment">// matrix rows, so (*this)(i,j) is valid if i is a local index.</span>
<a name="l00227"></a>00227       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;_dof_map-&gt;first_dof();
<a name="l00228"></a>00228            i!=this-&gt;_dof_map-&gt;end_dof(); ++i)
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232               T c = (*this)(i,j);
<a name="l00233"></a>00233               <span class="keywordflow">if</span> (c != static_cast&lt;T&gt;(0.0))
<a name="l00234"></a>00234                 {
<a name="l00235"></a>00235                   ibuf.push_back(i);
<a name="l00236"></a>00236                   jbuf.push_back(j);
<a name="l00237"></a>00237                   cbuf.push_back(c);
<a name="l00238"></a>00238                 }
<a name="l00239"></a>00239             }
<a name="l00240"></a>00240         }
<a name="l00241"></a>00241       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(0,ibuf);
<a name="l00242"></a>00242       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(0,jbuf);
<a name="l00243"></a>00243       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(0,cbuf);
<a name="l00244"></a>00244     }
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00250"></a>00250 <span class="comment">// Explicit instantiations</span>
<a name="l00251"></a>00251 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
