<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sparse_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="sparse__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sparse_matrix.h 4267 2011-03-16 09:24:03Z sheep_tk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __sparse_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __sparse_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// forward declarations</span>
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseMatrix;
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const SparseMatrix&lt;T&gt;&amp; m);
<a name="l00043"></a>00043 <span class="keyword">class </span>DofMap;
<a name="l00044"></a>00044 <span class="keyword">namespace </span>SparsityPattern { <span class="keyword">class </span>Graph; }
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00059"></a>00059 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00060"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php">00060</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;SparseMatrix&lt;T&gt; &gt;
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 <span class="keyword">public</span>:
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1SparseMatrix.php#a911c860b3449f5b89cd6bb5b7a685705">SparseMatrix</a> ();
<a name="l00079"></a>00079 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a383353568d4052ceb681b294bb7c5905">~SparseMatrix</a> ();
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;SparseMatrix&lt;T&gt;</a> &gt;
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1SparseMatrix.php#a119240002210a79e854aed341d223fba">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package = <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00093"></a>00093   
<a name="l00098"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a71ac3668357d2f61480589e2bc9c1b04">00098</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a71ac3668357d2f61480589e2bc9c1b04">initialized</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a9af4f8901ed954b3980801faf2250a55">_is_initialized</a>; }
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a327789280fc9e054844455b212d143b4">00103</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a327789280fc9e054844455b212d143b4">attach_dof_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map)
<a name="l00104"></a>00104   { <a class="code" href="classlibMesh_1_1SparseMatrix.php#a88e1bdd4ea3c4d30c03d64a622546bf4">_dof_map</a> = &amp;dof_map; }
<a name="l00105"></a>00105 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a0c3741f9333fde25de40eb921fb73f2d">00113</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a0c3741f9333fde25de40eb921fb73f2d">need_full_sparsity_pattern</a>()<span class="keyword"> const </span>
<a name="l00114"></a>00114 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }  
<a name="l00115"></a>00115 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a06b61220d6f442caedbe46f5f0ed2482">00121</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a06b61220d6f442caedbe46f5f0ed2482">update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;) {}
<a name="l00122"></a>00122   
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a80ce749ed645ed99836052904fbd0f57">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#ad0f01d9919e7b33f2d614848e494bb44">m</a>,
<a name="l00132"></a>00132                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#adf547081169c5a585ea1d7bf816f4edc">n</a>,
<a name="l00133"></a>00133                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00134"></a>00134                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00135"></a>00135                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00136"></a>00136                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10) = 0;
<a name="l00137"></a>00137 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a80ce749ed645ed99836052904fbd0f57">init</a> () = 0;
<a name="l00142"></a>00142   
<a name="l00149"></a>00149   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a81c9892fe2233b297993ed87dcea4c0f">clear</a> () = 0;
<a name="l00150"></a>00150 
<a name="l00154"></a>00154   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a> () = 0;
<a name="l00155"></a>00155 
<a name="l00159"></a>00159   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#af5629d649061318333d2a3364ecddb75">zero_rows</a> (std::vector&lt;int&gt; &amp; rows, T diag_value = 0.0);
<a name="l00160"></a>00160   
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a> () <span class="keyword">const</span> = 0;
<a name="l00167"></a>00167   
<a name="l00172"></a>00172   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#ad0f01d9919e7b33f2d614848e494bb44">m</a> () <span class="keyword">const</span> = 0;
<a name="l00173"></a>00173 
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#adf547081169c5a585ea1d7bf816f4edc">n</a> () <span class="keyword">const</span> = 0;
<a name="l00179"></a>00179 
<a name="l00184"></a>00184   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#af71751deaa4d474fd25c58f836a2e17c">row_start</a> () <span class="keyword">const</span> = 0;
<a name="l00185"></a>00185 
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a04f3cebcc848166b6b41f03f05036765">row_stop</a> () <span class="keyword">const</span> = 0;
<a name="l00191"></a>00191 
<a name="l00198"></a>00198   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00199"></a>00199                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00200"></a>00200                     <span class="keyword">const</span> T value) = 0;
<a name="l00201"></a>00201     
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00211"></a>00211                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00212"></a>00212                     <span class="keyword">const</span> T value) = 0;
<a name="l00213"></a>00213 
<a name="l00220"></a>00220   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00221"></a>00221                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00222"></a>00222                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols) = 0;
<a name="l00223"></a>00223   
<a name="l00228"></a>00228   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00229"></a>00229                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices) = 0;
<a name="l00230"></a>00230       
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a> (<span class="keyword">const</span> T, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;) = 0;
<a name="l00237"></a>00237 
<a name="l00256"></a>00256   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1SparseMatrix.php#a501cbea70c0a4cb9c95286153ccf181c">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00257"></a>00257                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span> = 0;
<a name="l00258"></a>00258 
<a name="l00269"></a>00269   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a02cd39b31c06bd3d344ac68d282f21cb">l1_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00270"></a>00270 
<a name="l00282"></a>00282   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php#af3950addff2fa6a5ea627b002859c4b4">linfty_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00283"></a>00283 
<a name="l00288"></a>00288   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#aed594c7fee7d1af0cbed4314781505e8">closed</a>() <span class="keyword">const</span> = 0;
<a name="l00289"></a>00289 
<a name="l00295"></a>00295   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#afcdf5bc4246bc646599e5d1a031b3c96">print</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>, <span class="keyword">const</span> <span class="keywordtype">bool</span> sparse=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00296"></a>00296 
<a name="l00301"></a>00301   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> U&gt;
<a name="l00302"></a>00302   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const SparseMatrix&lt;U&gt;&amp; <a class="code" href="classlibMesh_1_1SparseMatrix.php#ad0f01d9919e7b33f2d614848e494bb44">m</a>);
<a name="l00303"></a>00303   
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#ae41cb7aaf4e8d520879cd735bf6c8127">print_personal</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span> = 0;
<a name="l00309"></a>00309   
<a name="l00316"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a44912d50f53fe7ea04c34e4eae8467fb">00316</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a44912d50f53fe7ea04c34e4eae8467fb">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>)<span class="keyword"> const</span>
<a name="l00317"></a>00317 <span class="keyword">  </span>{
<a name="l00318"></a>00318     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Not Implemented in base class yet!&quot;</span> &lt;&lt; std::endl;
<a name="l00319"></a>00319     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR writing MATLAB file &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a> &lt;&lt; std::endl;
<a name="l00320"></a>00320     libmesh_error();
<a name="l00321"></a>00321   }
<a name="l00322"></a>00322 
<a name="l00328"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#ae7069ca3b5265f87438c1ffcce9470f5">00328</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#ae7069ca3b5265f87438c1ffcce9470f5">create_submatrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00329"></a>00329                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00330"></a>00330                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)<span class="keyword"> const</span>
<a name="l00331"></a>00331 <span class="keyword">  </span>{
<a name="l00332"></a>00332     this-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9bc9b69c8594b5866105665c3622f73b">_get_submatrix</a>(submatrix,
<a name="l00333"></a>00333                          rows,
<a name="l00334"></a>00334                          cols,
<a name="l00335"></a>00335                          <span class="keyword">false</span>); <span class="comment">// false means DO NOT REUSE submatrix</span>
<a name="l00336"></a>00336   }
<a name="l00337"></a>00337 
<a name="l00344"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#ac9c24110470ec4b4bd8dcbe7cb7758b2">00344</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#ac9c24110470ec4b4bd8dcbe7cb7758b2">reinit_submatrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00345"></a>00345                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00346"></a>00346                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)<span class="keyword"> const</span>
<a name="l00347"></a>00347 <span class="keyword">  </span>{
<a name="l00348"></a>00348     this-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9bc9b69c8594b5866105665c3622f73b">_get_submatrix</a>(submatrix,
<a name="l00349"></a>00349                          rows,
<a name="l00350"></a>00350                          cols,
<a name="l00351"></a>00351                          <span class="keyword">true</span>); <span class="comment">// true means REUSE submatrix</span>
<a name="l00352"></a>00352   }
<a name="l00353"></a>00353   
<a name="l00358"></a>00358   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00359"></a>00359                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00360"></a>00360 
<a name="l00364"></a>00364   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a0a7445955e126e341cd9a2e71b3c3976">vector_mult_add</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00365"></a>00365                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00366"></a>00366 
<a name="l00370"></a>00370   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#ae3fa35056e55337f5b291c62fe9c9d17">get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span> = 0;
<a name="l00371"></a>00371 
<a name="l00376"></a>00376   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#aa85149e85125392a2fdb7671bb50a1e2">get_transpose</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span> = 0;
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="keyword">protected</span>:
<a name="l00379"></a>00379 
<a name="l00385"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a9bc9b69c8594b5866105665c3622f73b">00385</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a9bc9b69c8594b5866105665c3622f73b">_get_submatrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; ,
<a name="l00386"></a>00386                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ,
<a name="l00387"></a>00387                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ,
<a name="l00388"></a>00388                               <span class="keyword">const</span> <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00389"></a>00389 <span class="keyword">  </span>{
<a name="l00390"></a>00390     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! This function is not yet implemented in the base class!&quot;</span>
<a name="l00391"></a>00391                   &lt;&lt; std::endl;
<a name="l00392"></a>00392     libmesh_error();
<a name="l00393"></a>00393   }
<a name="l00394"></a>00394   
<a name="l00398"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a88e1bdd4ea3c4d30c03d64a622546bf4">00398</a>   <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> <span class="keyword">const</span> *<a class="code" href="classlibMesh_1_1SparseMatrix.php#a88e1bdd4ea3c4d30c03d64a622546bf4">_dof_map</a>;
<a name="l00399"></a>00399   
<a name="l00404"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a9af4f8901ed954b3980801faf2250a55">00404</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a9af4f8901ed954b3980801faf2250a55">_is_initialized</a>;
<a name="l00405"></a>00405 };
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00410"></a>00410 <span class="comment">// SparseMatrix inline members</span>
<a name="l00411"></a>00411 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00412"></a>00412 <span class="keyword">inline</span>
<a name="l00413"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a911c860b3449f5b89cd6bb5b7a685705">00413</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a911c860b3449f5b89cd6bb5b7a685705">SparseMatrix&lt;T&gt;::SparseMatrix</a> () :
<a name="l00414"></a>00414   _dof_map(NULL),
<a name="l00415"></a>00415   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false)
<a name="l00416"></a>00416 {}
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00421"></a>00421 <span class="keyword">inline</span>
<a name="l00422"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a383353568d4052ceb681b294bb7c5905">00422</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php#a383353568d4052ceb681b294bb7c5905">SparseMatrix&lt;T&gt;::~SparseMatrix</a> ()
<a name="l00423"></a>00423 {}
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 <span class="comment">// Full specialization for Complex datatypes</span>
<a name="l00430"></a>00430 <span class="keyword">template</span> &lt;&gt;
<a name="l00431"></a>00431 <span class="keyword">inline</span>
<a name="l00432"></a><a class="code" href="classlibMesh_1_1SparseMatrix.php#a9b812aa2e53243a7d9725ff076bff21e">00432</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php#afcdf5bc4246bc646599e5d1a031b3c96">SparseMatrix&lt;Complex&gt;::print</a>(std::ostream&amp; os, <span class="keyword">const</span> <span class="keywordtype">bool</span> sparse)<span class="keyword"> const</span>
<a name="l00433"></a>00433 <span class="keyword"></span>{
<a name="l00434"></a>00434   <span class="comment">// std::complex&lt;&gt;::operator&lt;&lt;() is defined, but use this form</span>
<a name="l00435"></a>00435 
<a name="l00436"></a>00436   <span class="keywordflow">if</span>(sparse)
<a name="l00437"></a>00437     {
<a name="l00438"></a>00438       libmesh_not_implemented();
<a name="l00439"></a>00439     }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   os &lt;&lt; <span class="stringliteral">&quot;Real part:&quot;</span> &lt;&lt; std::endl;
<a name="l00442"></a>00442   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00445"></a>00445         os &lt;&lt; std::setw(8) &lt;&lt; (*this)(i,j).real() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00446"></a>00446       os &lt;&lt; std::endl;
<a name="l00447"></a>00447     }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   os &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Imaginary part:&quot;</span> &lt;&lt; std::endl;
<a name="l00450"></a>00450   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00451"></a>00451     {
<a name="l00452"></a>00452       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00453"></a>00453         os &lt;&lt; std::setw(8) &lt;&lt; (*this)(i,j).imag() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00454"></a>00454       os &lt;&lt; std::endl;
<a name="l00455"></a>00455     }
<a name="l00456"></a>00456 }
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 <span class="comment">// For SGI MIPSpro this implementation must occur after</span>
<a name="l00461"></a>00461 <span class="comment">// the partial specialization of the print() member.</span>
<a name="l00462"></a>00462 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00463"></a>00463 <span class="keyword">inline</span>
<a name="l00464"></a><a class="code" href="namespacelibMesh.php#ae1be260aa589a7cca13635ec52f66948">00464</a> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const SparseMatrix&lt;T&gt;&amp; m)
<a name="l00465"></a>00465 {
<a name="l00466"></a>00466   m.print(os);
<a name="l00467"></a>00467   <span class="keywordflow">return</span> os;
<a name="l00468"></a>00468 }
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 } <span class="comment">// namespace libMesh</span>
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 
<a name="l00474"></a>00474 <span class="preprocessor">#endif // #ifndef __sparse_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
