<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sparse_shell_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="sparse__shell__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sparse_shell_matrix.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __sparse_shell_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __sparse_shell_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00044"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparseShellMatrix.php">SparseShellMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix</a>&lt;T&gt;
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a2408e9e2777ba23e4da37897fb43f136">SparseShellMatrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a3117125af71b8a69369cae0f0329dc77">m</a>);
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a1146150905a0f8fc4a155afb66941911">~SparseShellMatrix</a> ();
<a name="l00057"></a>00057 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a3117125af71b8a69369cae0f0329dc77">m</a> () <span class="keyword">const</span>;
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a12ea5008b0d3a68786028435240954a2">n</a> () <span class="keyword">const</span>;
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#ad7178285c682ed08ec4f9b00a803e6a1">vector_mult</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00075"></a>00075                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a434e537704146f231e559c7486a71f31">vector_mult_add</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00081"></a>00081                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#ac33ec0abc32b1deda41a04b1a64961f6">get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="keyword">protected</span>:
<a name="l00092"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a381cd9f7f4f1295fd660ef165ed88a89">00092</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a381cd9f7f4f1295fd660ef165ed88a89">_m</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 };
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00099"></a>00099 <span class="comment">// SparseShellMatrix inline members</span>
<a name="l00100"></a>00100 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00101"></a>00101 <span class="keyword">inline</span>
<a name="l00102"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a2408e9e2777ba23e4da37897fb43f136">00102</a> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a2408e9e2777ba23e4da37897fb43f136">SparseShellMatrix&lt;T&gt;::SparseShellMatrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; m):
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix</a>&lt;T&gt;(),
<a name="l00104"></a>00104   _m(m)
<a name="l00105"></a>00105 {}
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00110"></a>00110 <span class="keyword">inline</span>
<a name="l00111"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a1146150905a0f8fc4a155afb66941911">00111</a> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a1146150905a0f8fc4a155afb66941911">SparseShellMatrix&lt;T&gt;::~SparseShellMatrix</a> ()
<a name="l00112"></a>00112 {}
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00117"></a>00117 <span class="keyword">inline</span>
<a name="l00118"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a3117125af71b8a69369cae0f0329dc77">00118</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a3117125af71b8a69369cae0f0329dc77">SparseShellMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword"></span>{
<a name="l00120"></a>00120   <span class="keywordflow">return</span> _m.m();
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00126"></a>00126 <span class="keyword">inline</span>
<a name="l00127"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a12ea5008b0d3a68786028435240954a2">00127</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#a12ea5008b0d3a68786028435240954a2">SparseShellMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword"></span>{
<a name="l00129"></a>00129   <span class="keywordflow">return</span> _m.n();
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00135"></a>00135 <span class="keyword">inline</span>
<a name="l00136"></a><a class="code" href="classlibMesh_1_1SparseShellMatrix.php#ac33ec0abc32b1deda41a04b1a64961f6">00136</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparseShellMatrix.php#ac33ec0abc32b1deda41a04b1a64961f6">SparseShellMatrix&lt;T&gt;::get_diagonal</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00137"></a>00137 <span class="keyword"></span>{
<a name="l00138"></a>00138   _m.get_diagonal(dest);
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 } <span class="comment">// namespace libMesh</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif // #ifndef __sparse_shell_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
