<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sparsity_pattern.h</div>  </div>
</div>
<div class="contents">
<a href="sparsity__pattern_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sparsity_pattern.h 4166 2011-01-13 18:53:25Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __sparsity_pattern_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __sparsity_pattern_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="threads__allocators_8h.php">threads_allocators.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="comment">// Forward declaractions</span>
<a name="l00035"></a>00035   <span class="keyword">class </span>MeshBase;
<a name="l00036"></a>00036   <span class="keyword">class </span>DofMap;
<a name="l00037"></a>00037   <span class="keyword">class </span>CouplingMatrix;
<a name="l00038"></a>00038   
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Sparsity Pattern</span>
<a name="l00041"></a>00041 
<a name="l00048"></a>00048 <span class="keyword">namespace </span>SparsityPattern <span class="comment">// use a namespace so member classes can be forward-declared.</span>
<a name="l00049"></a>00049 {
<a name="l00050"></a><a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">00050</a>   <span class="keyword">typedef</span> std::vector&lt;unsigned int, Threads::scalable_allocator&lt;unsigned int&gt; &gt; <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a2e0f69d5c103cf7baee9f8fd5929cbb7">Row</a>;
<a name="l00051"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">00051</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">Graph</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;Row&gt; {};
<a name="l00052"></a>00052   
<a name="l00062"></a>00062   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> B<span class="keywordtype">id</span>irectionalIterator&gt;
<a name="l00063"></a>00063   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a3f484f3a9c8ae7878d8e91d16859c624">sort_row</a> (<span class="keyword">const</span> BidirectionalIterator begin,
<a name="l00064"></a>00064                         BidirectionalIterator       middle,
<a name="l00065"></a>00065                         <span class="keyword">const</span> BidirectionalIterator end);
<a name="l00066"></a>00066 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">00078</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">Build</a>
<a name="l00079"></a>00079   {
<a name="l00080"></a>00080   <span class="keyword">private</span>:
<a name="l00081"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7eca2b2512224d01cb599177e5f1c8a1">00081</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7eca2b2512224d01cb599177e5f1c8a1">mesh</a>;
<a name="l00082"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">00082</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>;
<a name="l00083"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">00083</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php">CouplingMatrix</a> *<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>;
<a name="l00084"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">00084</a>     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">implicit_neighbor_dofs</a>;
<a name="l00085"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af61ba6f3d2d45a3cfacb0d32b4bfe428">00085</a>     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af61ba6f3d2d45a3cfacb0d32b4bfe428">need_full_sparsity_pattern</a>;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keyword">public</span>:
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">00089</a>     <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>;
<a name="l00090"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">00090</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>;
<a name="l00091"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">00091</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>;
<a name="l00092"></a>00092     
<a name="l00093"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e1437870f3449075054e3d62318849c">00093</a>     <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e1437870f3449075054e3d62318849c">Build</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh_in,
<a name="l00094"></a>00094            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map_in,
<a name="l00095"></a>00095            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php">CouplingMatrix</a> *dof_coupling_in,
<a name="l00096"></a>00096            <span class="keyword">const</span> <span class="keywordtype">bool</span> implicit_neighbor_dofs_in,
<a name="l00097"></a>00097            <span class="keyword">const</span> <span class="keywordtype">bool</span> need_full_sparsity_pattern_in) :
<a name="l00098"></a>00098       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7eca2b2512224d01cb599177e5f1c8a1">mesh</a>(mesh_in),
<a name="l00099"></a>00099       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>(dof_map_in),
<a name="l00100"></a>00100       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>(dof_coupling_in),
<a name="l00101"></a>00101       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">implicit_neighbor_dofs</a>(implicit_neighbor_dofs_in),
<a name="l00102"></a>00102       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af61ba6f3d2d45a3cfacb0d32b4bfe428">need_full_sparsity_pattern</a>(need_full_sparsity_pattern_in),
<a name="l00103"></a>00103       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>(),
<a name="l00104"></a>00104       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>(),
<a name="l00105"></a>00105       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>()
<a name="l00106"></a>00106     {}
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a532b3f84dbe671badabb7ec2f1ed6631">00108</a>     <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e1437870f3449075054e3d62318849c">Build</a> (<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">Build</a> &amp;other, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a>) :
<a name="l00109"></a>00109       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7eca2b2512224d01cb599177e5f1c8a1">mesh</a>(other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7eca2b2512224d01cb599177e5f1c8a1">mesh</a>),
<a name="l00110"></a>00110       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>(other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#adaaeb1039af971d4376bcd896686a281">dof_map</a>),
<a name="l00111"></a>00111       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>(other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a7e288ac68552ad57f0b56c9feff455b2">dof_coupling</a>),
<a name="l00112"></a>00112       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">implicit_neighbor_dofs</a>(other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a65ae2307529ece863ce1092155185762">implicit_neighbor_dofs</a>),
<a name="l00113"></a>00113       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af61ba6f3d2d45a3cfacb0d32b4bfe428">need_full_sparsity_pattern</a>(other.<a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af61ba6f3d2d45a3cfacb0d32b4bfe428">need_full_sparsity_pattern</a>),
<a name="l00114"></a>00114       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a054aa3bf4ab1ff21352e2aaf2495c589">sparsity_pattern</a>(),
<a name="l00115"></a>00115       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a4624e244606dff65d27017738a51003f">n_nz</a>(),
<a name="l00116"></a>00116       <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#af51c83786a5f07846030c63a6d560c3f">n_oz</a>()
<a name="l00117"></a>00117     {}
<a name="l00118"></a>00118 
<a name="l00119"></a>00119     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#acc76917e49e35f190ee11ca95d319db8">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php#a0a76acc8f8e9997d9572957695835302">join</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">Build</a> &amp;other);
<a name="l00122"></a>00122   };
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>
<a name="l00130"></a>00130   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a859cc7fecedbd239ca60ef57d33fd1d0">_dummy_function</a>(<span class="keywordtype">void</span>);
<a name="l00131"></a>00131 <span class="preprocessor">#endif</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>  
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00138"></a>00138 <span class="comment">// SparsityPattern inline member functions</span>
<a name="l00139"></a>00139 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> B<span class="keywordtype">id</span>irectionalIterator&gt;
<a name="l00140"></a>00140 <span class="keyword">inline</span>
<a name="l00141"></a><a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a3f484f3a9c8ae7878d8e91d16859c624">00141</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a3f484f3a9c8ae7878d8e91d16859c624">SparsityPattern::sort_row</a> (<span class="keyword">const</span> BidirectionalIterator begin,
<a name="l00142"></a>00142                                 BidirectionalIterator       middle,
<a name="l00143"></a>00143                                 <span class="keyword">const</span> BidirectionalIterator end)
<a name="l00144"></a>00144 {
<a name="l00145"></a>00145   <span class="keywordflow">if</span> ((begin == middle) || (middle == end)) <span class="keywordflow">return</span>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   libmesh_assert (std::distance (begin,  middle) &gt; 0);
<a name="l00148"></a>00148   libmesh_assert (std::distance (middle, end)    &gt; 0);
<a name="l00149"></a>00149   libmesh_assert (std::unique (begin,  middle) == middle);
<a name="l00150"></a>00150   libmesh_assert (std::unique (middle, end)    == end);
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   <span class="keywordflow">while</span> (middle != end)
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154       BidirectionalIterator
<a name="l00155"></a>00155         b = middle,
<a name="l00156"></a>00156         a = b-1;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">// Bubble-sort the middle value downward</span>
<a name="l00159"></a>00159       <span class="keywordflow">while</span> (!(*a &lt; *b)) <span class="comment">// *a &amp; *b are less-than comparable, so use &lt;</span>
<a name="l00160"></a>00160         {
<a name="l00161"></a>00161           std::swap (*a, *b);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#if defined(__GNUC__) &amp;&amp; (__GNUC__ &lt; 4) &amp;&amp; !defined(__INTEL_COMPILER)</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>          <span class="comment">/* Prohibit optimization at this point since gcc 3.3.5 seems</span>
<a name="l00165"></a>00165 <span class="comment">             to have a bug.  */</span>
<a name="l00166"></a>00166           <a class="code" href="namespacelibMesh_1_1SparsityPattern.php#a859cc7fecedbd239ca60ef57d33fd1d0">SparsityPattern::_dummy_function</a>();
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>
<a name="l00169"></a>00169           <span class="keywordflow">if</span> (a == begin) <span class="keywordflow">break</span>;
<a name="l00170"></a>00170           
<a name="l00171"></a>00171           b=a;
<a name="l00172"></a>00172           --a;
<a name="l00173"></a>00173         }
<a name="l00174"></a>00174       
<a name="l00175"></a>00175       ++middle;
<a name="l00176"></a>00176     }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">// Assure the algorithm worked if we are in DEBUG mode</span>
<a name="l00179"></a>00179 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>  {
<a name="l00181"></a>00181     <span class="comment">// SGI STL extension!</span>
<a name="l00182"></a>00182     <span class="comment">// libmesh_assert (std::is_sorted(begin,end));</span>
<a name="l00183"></a>00183     
<a name="l00184"></a>00184     BidirectionalIterator
<a name="l00185"></a>00185       prev  = begin,
<a name="l00186"></a>00186       first = begin;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">for</span> (++first; first != end; prev=first, ++first)
<a name="l00189"></a>00189       <span class="keywordflow">if</span> (*first &lt; *prev)
<a name="l00190"></a>00190         libmesh_assert(<span class="keyword">false</span>);
<a name="l00191"></a>00191   }  
<a name="l00192"></a>00192 <span class="preprocessor">#endif</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span>
<a name="l00194"></a>00194   <span class="comment">// Make sure the two ranges did not contain any common elements</span>
<a name="l00195"></a>00195   libmesh_assert (std::unique (begin, end) == end);
<a name="l00196"></a>00196 }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 } <span class="comment">// namespace libMesh</span>
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#endif // __sparsity_pattern_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
