<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sphere.C</div>  </div>
</div>
<div class="contents">
<a href="sphere_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sphere.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="sphere_8h.php">sphere.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// Sphere class member functions</span>
<a name="l00037"></a><a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">00037</a> <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere::Sphere</a> () : 
<a name="l00038"></a>00038   _rad(-1.)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classlibMesh_1_1Sphere.php#a1fce204a2035f3bc18459087812183ce">00044</a> <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere::Sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; c, 
<a name="l00045"></a>00045                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>   r)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   libmesh_assert (r &gt; 0.);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a39e04e9dc2a00c14bee08032cf239f1f">create_from_center_radius</a> (c, r);
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1Sphere.php#afe11440e804304a2a2d17c465ab1d3df">00054</a> <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere::Sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>&amp; other_sphere) :
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1Surface.php">Surface</a>()
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a39e04e9dc2a00c14bee08032cf239f1f">create_from_center_radius</a> (other_sphere.<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>(),
<a name="l00058"></a>00058                                    other_sphere.<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>());
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Sphere.php#ac504155ce5ad98ec0d80e37c22a487f4">00063</a> <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere::Sphere</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; pa,
<a name="l00064"></a>00064                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; pb,
<a name="l00065"></a>00065                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; pc,
<a name="l00066"></a>00066                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; pd)
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1Point.php">Point</a> pad = pa - pd;
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1Point.php">Point</a> pbd = pb - pd;
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1Point.php">Point</a> pcd = pc - pd;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Real&gt;</a> T(pad,pbd,pcd);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> D = T.<a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">det</a>();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// The points had better not be coplanar</span>
<a name="l00077"></a>00077   libmesh_assert (std::abs(D) &gt; 1e-12);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> e = 0.5*(pa.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>() - pd.size_sq());
<a name="l00080"></a>00080   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> f = 0.5*(pb.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>() - pd.size_sq());
<a name="l00081"></a>00081   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g = 0.5*(pc.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>() - pd.size_sq());
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Real&gt;</a> T1(e,pad(1),pad(2),
<a name="l00084"></a>00084                        f,pbd(1),pbd(2),
<a name="l00085"></a>00085                        g,pcd(1),pcd(2));
<a name="l00086"></a>00086   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sx = T1.<a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">det</a>()/D;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Real&gt;</a> T2(pad(0),e,pad(2),
<a name="l00089"></a>00089                        pbd(0),f,pbd(2),
<a name="l00090"></a>00090                        pcd(0),g,pcd(2));
<a name="l00091"></a>00091   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sy = T2.<a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">det</a>()/D;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Real&gt;</a> T3(pad(0),pad(1),e,
<a name="l00094"></a>00094                        pbd(0),pbd(1),f,
<a name="l00095"></a>00095                        pcd(0),pcd(1),g);
<a name="l00096"></a>00096   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sz = T3.<a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">det</a>()/D;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <a class="code" href="classlibMesh_1_1Point.php">Point</a> c(sx,sy,sz);
<a name="l00099"></a>00099   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r = (c-pa).size();
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a39e04e9dc2a00c14bee08032cf239f1f">create_from_center_radius</a>(c,r);
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1Sphere.php#ac22ffa53a7bd9eeeae2cbc25fe4418f2">00106</a> <a class="code" href="classlibMesh_1_1Sphere.php#ac22ffa53a7bd9eeeae2cbc25fe4418f2">Sphere::~Sphere</a> ()
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1Sphere.php#a39e04e9dc2a00c14bee08032cf239f1f">00112</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Sphere.php#a39e04e9dc2a00c14bee08032cf239f1f">Sphere::create_from_center_radius</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; c, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r)
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>() = c;
<a name="l00115"></a>00115   this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() = r;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0.);
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1Sphere.php#a7a69bad842ba787eb65342880f2f7a29">00122</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#a7a69bad842ba787eb65342880f2f7a29">Sphere::intersects</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>&amp; other_sphere)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword"></span>{
<a name="l00124"></a>00124   libmesh_assert ( this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0. );
<a name="l00125"></a>00125   libmesh_assert ( other_sphere.<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0. );
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> distance = (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>() - other_sphere.<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>()).size();
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">if</span> (distance &lt; (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() + other_sphere.<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>()) )
<a name="l00130"></a>00130     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1Sphere.php#ae33665381deac351e9a9256bfc4aee66">00137</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#ae33665381deac351e9a9256bfc4aee66">Sphere::above_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00138"></a>00138 <span class="keyword"></span>{
<a name="l00139"></a>00139   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0.);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">// create a vector from the center to the point.</span>
<a name="l00142"></a>00142   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> w = p - this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>();
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="keywordflow">if</span> (w.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() &gt; this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>())
<a name="l00145"></a>00145     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1Sphere.php#a24d32b63bc3b1ead351411130a6743ad">00152</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#a24d32b63bc3b1ead351411130a6743ad">Sphere::below_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00153"></a>00153 <span class="keyword"></span>{
<a name="l00154"></a>00154   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0.);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordflow">return</span> ( !this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#ae33665381deac351e9a9256bfc4aee66">above_surface</a> (p) );
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1Sphere.php#adcf4ac3045af00c9a485c89d5f0a1bb1">00161</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#adcf4ac3045af00c9a485c89d5f0a1bb1">Sphere::on_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const </span>
<a name="l00162"></a>00162 <span class="keyword"></span>{
<a name="l00163"></a>00163   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0.);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">// Create a vector from the center to the point.</span>
<a name="l00166"></a>00166   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> w = p - this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>();
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">// if the size of that vector is the same as the radius() then</span>
<a name="l00169"></a>00169   <span class="comment">// the point is on the surface.</span>
<a name="l00170"></a>00170   <span class="keywordflow">if</span> (std::abs(w.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() - this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>()) &lt; 1.e-10)
<a name="l00171"></a>00171     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1Sphere.php#a91ebc92f86bff21465257020dc999a98">00178</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a91ebc92f86bff21465257020dc999a98">Sphere::closest_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00179"></a>00179 <span class="keyword"></span>{
<a name="l00180"></a>00180   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0.);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">// get the normal from the surface in the direction</span>
<a name="l00183"></a>00183   <span class="comment">// of p</span>
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1Point.php">Point</a> normal = this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a1c2a8bb1170f858abe26ecb1ec8084aa">unit_normal</a> (p);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// The closest point on the sphere is in the direction</span>
<a name="l00187"></a>00187   <span class="comment">// of the normal a distance r from the center.</span>
<a name="l00188"></a>00188   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> cp = this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>() + normal*this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>();
<a name="l00189"></a>00189   
<a name="l00190"></a>00190   <span class="keywordflow">return</span> cp;
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classlibMesh_1_1Sphere.php#a1c2a8bb1170f858abe26ecb1ec8084aa">00195</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a1c2a8bb1170f858abe26ecb1ec8084aa">Sphere::unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword"></span>{
<a name="l00197"></a>00197   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>() &gt; 0.);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   libmesh_assert ( !(p == this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>()) );
<a name="l00200"></a>00200   
<a name="l00201"></a>00201   <span class="comment">// Create a vector from the center to the point</span>
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1Point.php">Point</a> n = p - this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>();
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="keywordflow">return</span> n.<a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>();
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
