<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sphere.h</div>  </div>
</div>
<div class="contents">
<a href="sphere_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sphere.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __sphere_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __sphere_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="surface_8h.php">surface.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00075"></a>00075 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00076"></a>00076 <span class="comment">// Sphere class definition</span>
<a name="l00077"></a><a class="code" href="classlibMesh_1_1Sphere.php">00077</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Surface.php">Surface</a>
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079 <span class="keyword">public</span>:
<a name="l00080"></a>00080   
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere</a> ();
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; c, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r);
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;);
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1Sphere.php#aa99e06062ce40fd6cf1d52a6809cdd39">Sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>&amp; other_sphere);
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1Sphere.php#ac22ffa53a7bd9eeeae2cbc25fe4418f2">~Sphere</a> ();
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Sphere.php#a39e04e9dc2a00c14bee08032cf239f1f">create_from_center_radius</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; c, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r);
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#a7a69bad842ba787eb65342880f2f7a29">intersects</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>&amp; other_sphere) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00121"></a>00121   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#ae33665381deac351e9a9256bfc4aee66">above_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00122"></a>00122 
<a name="l00127"></a>00127   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#a24d32b63bc3b1ead351411130a6743ad">below_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00135"></a>00135   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Sphere.php#adcf4ac3045af00c9a485c89d5f0a1bb1">on_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a91ebc92f86bff21465257020dc999a98">closest_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a1c2a8bb1170f858abe26ecb1ec8084aa">unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">00151</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Sphere.php#a313834b5acda26732dbfe683996b7e64">radius</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php#a1faa45caf9a1a5181f0b6f4dad4d8c44">_rad</a>; }
<a name="l00152"></a>00152 
<a name="l00156"></a><a class="code" href="classlibMesh_1_1Sphere.php#aebedea6165210987601f40e72e414f1d">00156</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1Sphere.php#aebedea6165210987601f40e72e414f1d">radius</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php#a1faa45caf9a1a5181f0b6f4dad4d8c44">_rad</a>; }
<a name="l00157"></a>00157 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">00161</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php#a4a23eb4e923a3e19167e33d0266c04d4">_cent</a>; }
<a name="l00162"></a>00162 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1Sphere.php#a2a86be41f3a1660ff047c90fcee47540">00166</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1Sphere.php#a2a86be41f3a1660ff047c90fcee47540">center</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php#a4a23eb4e923a3e19167e33d0266c04d4">_cent</a>; }
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a3d44f68251b07abae14510c37f683743">surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; cart) <span class="keyword">const</span>;
<a name="l00173"></a>00173 
<a name="l00178"></a>00178   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a5bba4319d66ba127bf2f67391594e4b4">world_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; sph) <span class="keyword">const</span>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   
<a name="l00181"></a>00181 <span class="keyword">private</span>:
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   
<a name="l00187"></a><a class="code" href="classlibMesh_1_1Sphere.php#a4a23eb4e923a3e19167e33d0266c04d4">00187</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a4a23eb4e923a3e19167e33d0266c04d4">_cent</a>;
<a name="l00188"></a>00188 
<a name="l00192"></a><a class="code" href="classlibMesh_1_1Sphere.php#a1faa45caf9a1a5181f0b6f4dad4d8c44">00192</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  <a class="code" href="classlibMesh_1_1Sphere.php#a1faa45caf9a1a5181f0b6f4dad4d8c44">_rad</a>;
<a name="l00193"></a>00193 };
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00198"></a>00198 <span class="comment">// Sphere inline functions</span>
<a name="l00199"></a>00199 <span class="keyword">inline</span>
<a name="l00200"></a><a class="code" href="classlibMesh_1_1Sphere.php#a3d44f68251b07abae14510c37f683743">00200</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a3d44f68251b07abae14510c37f683743">Sphere::surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; cart)<span class="keyword"> const</span>
<a name="l00201"></a>00201 <span class="keyword"></span>{
<a name="l00202"></a>00202   <span class="comment">// constant translation in the origin</span>
<a name="l00203"></a>00203   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> c (cart-this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>());
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="comment">// phi: special care, so that it gives 0..2pi results</span>
<a name="l00206"></a>00206   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> phi = std::atan2(c(1), c(0));
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>(<span class="comment">/* radius */</span> c.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>(),
<a name="l00209"></a>00209                <span class="comment">/* theta  */</span> std::atan2( std::sqrt( c(0)*c(0) + c(1)*c(1) ), c(2) ),
<a name="l00210"></a>00210                <span class="comment">/* phi    */</span> ( (phi &lt; 0)  ?  2.*<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>+phi  :  phi ) );
<a name="l00211"></a>00211 }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 <span class="keyword">inline</span>
<a name="l00216"></a><a class="code" href="classlibMesh_1_1Sphere.php#a5bba4319d66ba127bf2f67391594e4b4">00216</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Sphere.php#a5bba4319d66ba127bf2f67391594e4b4">Sphere::world_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; sph)<span class="keyword"> const</span>
<a name="l00217"></a>00217 <span class="keyword"></span>{
<a name="l00218"></a>00218   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r     = sph(0);
<a name="l00219"></a>00219   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta = sph(1);
<a name="l00220"></a>00220   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> phi   = sph(2);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <span class="comment">// constant translation out of the origin</span>
<a name="l00223"></a>00223   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> (<span class="comment">/* x */</span> r*std::sin(theta)*std::cos(phi) + this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>()(0),
<a name="l00224"></a>00224                 <span class="comment">/* y */</span> r*std::sin(theta)*std::sin(phi) + this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>()(1),
<a name="l00225"></a>00225                 <span class="comment">/* z */</span> r*std::cos(theta)               + this-&gt;<a class="code" href="classlibMesh_1_1Sphere.php#a9e47f744762137d278c3bcfab0a6ac04">center</a>()(2));
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 } <span class="comment">// namespace libMesh</span>
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
