<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">statistics.C</div>  </div>
</div>
<div class="contents">
<a href="statistics_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: statistics.C 4100 2010-11-15 17:46:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min_element, std::max_element</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span> <span class="comment">// std::ofstream</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;numeric&gt;</span> <span class="comment">// std::accumulate</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="statistics_8h.php">statistics.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// StatisticsVector class member functions</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00038"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a7f812876e5fb9237ee5e00882052da1b">00038</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a7f812876e5fb9237ee5e00882052da1b">StatisticsVector&lt;T&gt;::l2_norm</a>()<span class="keyword"> const</span>
<a name="l00039"></a>00039 <span class="keyword"></span>{
<a name="l00040"></a>00040   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> normsq = 0.;
<a name="l00041"></a>00041   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i != this-&gt;size(); ++i)
<a name="l00042"></a>00042     normsq += ((*<span class="keyword">this</span>)[i] * (*this)[i]);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordflow">return</span> std::sqrt(normsq);
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00049"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a4b87ff98b05015dd0d78e247aadb92da">00049</a> T <a class="code" href="classlibMesh_1_1StatisticsVector.php#a4b87ff98b05015dd0d78e247aadb92da">StatisticsVector&lt;T&gt;::minimum</a>()<span class="keyword"> const</span>
<a name="l00050"></a>00050 <span class="keyword"></span>{
<a name="l00051"></a>00051   START_LOG (<span class="stringliteral">&quot;minimum()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keyword">const</span> T <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = *(std::min_element(this-&gt;begin(), this-&gt;end()));
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   STOP_LOG (<span class="stringliteral">&quot;minimum()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>;
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00064"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a8145b8254720c71e9a7e977135229d6c">00064</a> T <a class="code" href="classlibMesh_1_1StatisticsVector.php#a8145b8254720c71e9a7e977135229d6c">StatisticsVector&lt;T&gt;::maximum</a>()<span class="keyword"> const</span>
<a name="l00065"></a>00065 <span class="keyword"></span>{
<a name="l00066"></a>00066   START_LOG (<span class="stringliteral">&quot;maximum()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keyword">const</span> T <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = *(std::max_element(this-&gt;begin(), this-&gt;end()));
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   STOP_LOG (<span class="stringliteral">&quot;maximum()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00071"></a>00071   
<a name="l00072"></a>00072   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00079"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#ae16519b8e9ed1f8159a12d79087de301">00079</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#ae16519b8e9ed1f8159a12d79087de301">StatisticsVector&lt;T&gt;::mean</a>()<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   START_LOG (<span class="stringliteral">&quot;mean()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00082"></a>00082   
<a name="l00083"></a>00083   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> mean = 0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089       mean += ( <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>((*this)[i]) - mean ) / (i + 1);
<a name="l00090"></a>00090     }
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   STOP_LOG (<span class="stringliteral">&quot;mean()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="keywordflow">return</span> mean;
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00101"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">00101</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">StatisticsVector&lt;T&gt;::median</a>() 
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (n == 0)
<a name="l00106"></a>00106     <span class="keywordflow">return</span> 0.;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   START_LOG (<span class="stringliteral">&quot;median()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   std::sort(this-&gt;begin(), this-&gt;end());
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lhs = (n-1) / 2;
<a name="l00113"></a>00113   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rhs = n / 2;
<a name="l00114"></a>00114   
<a name="l00115"></a>00115   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> median = 0;
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (lhs == rhs)
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120       median = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>((*this)[lhs]);
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="keywordflow">else</span>
<a name="l00124"></a>00124     {
<a name="l00125"></a>00125       median = ( <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>((*this)[lhs]) + 
<a name="l00126"></a>00126                  static_cast&lt;Real&gt;((*<span class="keyword">this</span>)[rhs]) ) / 2.0;
<a name="l00127"></a>00127     }
<a name="l00128"></a>00128  
<a name="l00129"></a>00129   STOP_LOG (<span class="stringliteral">&quot;median()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   <span class="keywordflow">return</span> median;
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00138"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a9bd27cf996c2cc065f364ec0294bc612">00138</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">StatisticsVector&lt;T&gt;::median</a>()<span class="keyword"> const</span>
<a name="l00139"></a>00139 <span class="keyword"></span>{
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;T&gt;</a> sv = (*this);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="keywordflow">return</span> sv.<a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">median</a>();
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00149"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#adc9209cb9aad364139c36501c8624de2">00149</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">StatisticsVector&lt;T&gt;::variance</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> mean)<span class="keyword"> const</span>
<a name="l00150"></a>00150 <span class="keyword"></span>{
<a name="l00151"></a>00151   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00152"></a>00152   
<a name="l00153"></a>00153   START_LOG (<span class="stringliteral">&quot;variance()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00154"></a>00154   
<a name="l00155"></a>00155   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> variance = 0;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00158"></a>00158     {
<a name="l00159"></a>00159       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = ( <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>((*this)[i]) - mean );
<a name="l00160"></a>00160       variance += (delta * delta - variance) / (i + 1);
<a name="l00161"></a>00161     }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="keywordflow">if</span> (n &gt; 1)
<a name="l00164"></a>00164     variance *= <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(n) / static_cast&lt;Real&gt;(n - 1);
<a name="l00165"></a>00165   
<a name="l00166"></a>00166   STOP_LOG (<span class="stringliteral">&quot;variance()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   <span class="keywordflow">return</span> variance;
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00173"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a12f8d44137d31baa4184428b72e5f422">00173</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a12f8d44137d31baa4184428b72e5f422">StatisticsVector&lt;T&gt;::normalize</a>()
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = this-&gt;maximum();
<a name="l00177"></a>00177   
<a name="l00178"></a>00178   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00179"></a>00179   {
<a name="l00180"></a>00180     (*this)[i] = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>((*this)[i] / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>);
<a name="l00181"></a>00181   }
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00189"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a27dbd15badfb9ba5f0a554f8ffdd1c6f">00189</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a27dbd15badfb9ba5f0a554f8ffdd1c6f">StatisticsVector&lt;T&gt;::histogram</a>(std::vector&lt;unsigned int&gt;&amp; bin_members,
<a name="l00190"></a>00190                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins)
<a name="l00191"></a>00191 {
<a name="l00192"></a>00192   <span class="comment">// Must have at least 1 bin</span>
<a name="l00193"></a>00193   libmesh_assert (n_bins&gt;0);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   std::sort(this-&gt;begin(), this-&gt;end());
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="comment">// The StatisticsVector can hold both integer and float types.</span>
<a name="l00200"></a>00200   <span class="comment">// We will define all the bins, etc. using Reals.</span>
<a name="l00201"></a>00201   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>      = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(this-&gt;minimum());
<a name="l00202"></a>00202   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>      = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(this-&gt;maximum());
<a name="l00203"></a>00203   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> bin_size = (max - <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>) / static_cast&lt;Real&gt;(n_bins); 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   START_LOG (<span class="stringliteral">&quot;histogram()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   std::vector&lt;Real&gt; bin_bounds(n_bins+1);
<a name="l00208"></a>00208   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;bin_bounds.size(); i++)
<a name="l00209"></a>00209     bin_bounds[i] = min + i * bin_size;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// Give the last bin boundary a little wiggle room: we don&#39;t want</span>
<a name="l00212"></a>00212   <span class="comment">// it to be just barely less than the max, otherwise our bin test below</span>
<a name="l00213"></a>00213   <span class="comment">// may fail.</span>
<a name="l00214"></a>00214   bin_bounds.back() += 1.e-6 * bin_size;
<a name="l00215"></a>00215   
<a name="l00216"></a>00216   <span class="comment">// This vector will store the number of members each bin has.</span>
<a name="l00217"></a>00217   bin_members.resize(n_bins);
<a name="l00218"></a>00218   
<a name="l00219"></a>00219   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_index = 0;
<a name="l00220"></a>00220   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;bin_members.size(); j++) <span class="comment">// bin vector indexing</span>
<a name="l00221"></a>00221     {
<a name="l00222"></a>00222       <span class="comment">// libMesh::out &lt;&lt; &quot;(debug) Filling bin &quot; &lt;&lt; j &lt;&lt; std::endl;</span>
<a name="l00223"></a>00223       
<a name="l00224"></a>00224       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=data_index; i&lt;n; i++) <span class="comment">// data vector indexing</span>
<a name="l00225"></a>00225         {
<a name="l00226"></a>00226           <span class="comment">//    libMesh::out &lt;&lt; &quot;(debug) Processing index=&quot; &lt;&lt; i &lt;&lt; std::endl;</span>
<a name="l00227"></a>00227           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_val = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>( (*this)[i] );
<a name="l00228"></a>00228           
<a name="l00229"></a>00229           <span class="comment">// There may be entries in the vector smaller than the value</span>
<a name="l00230"></a>00230           <span class="comment">// reported by this-&gt;minimum().  (e.g. inactive elements in an</span>
<a name="l00231"></a>00231           <span class="comment">// ErrorVector.)  We just skip entries like that.</span>
<a name="l00232"></a>00232           <span class="keywordflow">if</span> ( current_val &lt; min )
<a name="l00233"></a>00233             {
<a name="l00234"></a>00234               <span class="comment">//            libMesh::out &lt;&lt; &quot;(debug) Skipping entry v[&quot; &lt;&lt; i &lt;&lt; &quot;]=&quot;</span>
<a name="l00235"></a>00235               <span class="comment">//                      &lt;&lt; (*this)[i]</span>
<a name="l00236"></a>00236               <span class="comment">//                      &lt;&lt; &quot; which is less than the min value: min=&quot;</span>
<a name="l00237"></a>00237               <span class="comment">//                      &lt;&lt; min &lt;&lt; std::endl;</span>
<a name="l00238"></a>00238               <span class="keywordflow">continue</span>;
<a name="l00239"></a>00239             }
<a name="l00240"></a>00240         
<a name="l00241"></a>00241           <span class="keywordflow">if</span> ( current_val &gt; bin_bounds[j+1] ) <span class="comment">// if outside the current bin (bin[j] is bounded</span>
<a name="l00242"></a>00242                                                <span class="comment">// by bin_bounds[j] and bin_bounds[j+1])</span>
<a name="l00243"></a>00243             {
<a name="l00244"></a>00244               <span class="comment">// libMesh::out.precision(16);</span>
<a name="l00245"></a>00245               <span class="comment">//            libMesh::out.setf(std::ios_base::fixed);</span>
<a name="l00246"></a>00246               <span class="comment">//            libMesh::out &lt;&lt; &quot;(debug) (*this)[i]= &quot; &lt;&lt; (*this)[i]</span>
<a name="l00247"></a>00247               <span class="comment">//                      &lt;&lt; &quot; is greater than bin_bounds[j+1]=&quot;</span>
<a name="l00248"></a>00248               <span class="comment">//                      &lt;&lt; bin_bounds[j+1]         &lt;&lt; std::endl;</span>
<a name="l00249"></a>00249               data_index = i; <span class="comment">// start searching here for next bin </span>
<a name="l00250"></a>00250               <span class="keywordflow">break</span>; <span class="comment">// go to next bin</span>
<a name="l00251"></a>00251             }
<a name="l00252"></a>00252         
<a name="l00253"></a>00253           <span class="comment">// Otherwise, increment current bin&#39;s count</span>
<a name="l00254"></a>00254           bin_members[j]++;
<a name="l00255"></a>00255           <span class="comment">// libMesh::out &lt;&lt; &quot;(debug) Binned index=&quot; &lt;&lt; i &lt;&lt; std::endl;</span>
<a name="l00256"></a>00256         }
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258   
<a name="l00259"></a>00259 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>  <span class="comment">// Check the number of binned entries</span>
<a name="l00261"></a>00261   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_binned = std::accumulate(bin_members.begin(),
<a name="l00262"></a>00262                                                 bin_members.end(),
<a name="l00263"></a>00263                                                 <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(0),
<a name="l00264"></a>00264                                                 std::plus&lt;unsigned int&gt;());
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="keywordflow">if</span> (n != n_binned)
<a name="l00267"></a>00267     {
<a name="l00268"></a>00268       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: The number of binned entries, n_binned=&quot;</span>
<a name="l00269"></a>00269                 &lt;&lt; n_binned
<a name="l00270"></a>00270                 &lt;&lt; <span class="stringliteral">&quot;, did not match the total number of entries, n=&quot;</span>
<a name="l00271"></a>00271                 &lt;&lt; n &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00272"></a>00272       <span class="comment">//libmesh_error();</span>
<a name="l00273"></a>00273     }
<a name="l00274"></a>00274 <span class="preprocessor">#endif</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span>
<a name="l00276"></a>00276   
<a name="l00277"></a>00277   STOP_LOG (<span class="stringliteral">&quot;histogram()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00278"></a>00278 }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00285"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a28fe86ca7c0ac60ce4e572660f83d385">00285</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a28fe86ca7c0ac60ce4e572660f83d385">StatisticsVector&lt;T&gt;::plot_histogram</a>(<span class="keyword">const</span> std::string&amp; filename,
<a name="l00286"></a>00286                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins)
<a name="l00287"></a>00287 {
<a name="l00288"></a>00288   <span class="comment">// First generate the histogram with the desired number of bins</span>
<a name="l00289"></a>00289   std::vector&lt;unsigned int&gt; bin_members;
<a name="l00290"></a>00290   this-&gt;histogram(bin_members, n_bins);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="comment">// The max, min and bin size are used to generate x-axis values.</span>
<a name="l00293"></a>00293   T <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>      = this-&gt;minimum();
<a name="l00294"></a>00294   T <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>      = this-&gt;maximum();
<a name="l00295"></a>00295   T bin_size = (max - <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>) / static_cast&lt;T&gt;(n_bins); 
<a name="l00296"></a>00296   
<a name="l00297"></a>00297   <span class="comment">// On processor 0: Write histogram to file</span>
<a name="l00298"></a>00298   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()==0)
<a name="l00299"></a>00299     {
<a name="l00300"></a>00300       std::ofstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> (filename.c_str());
<a name="l00301"></a>00301 
<a name="l00302"></a>00302       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;clear all\n&quot;</span>;
<a name="l00303"></a>00303       out &lt;&lt; <span class="stringliteral">&quot;clf\n&quot;</span>;
<a name="l00304"></a>00304       <span class="comment">//out &lt;&lt; &quot;x=linspace(&quot; &lt;&lt; min &lt;&lt; &quot;,&quot; &lt;&lt; max &lt;&lt; &quot;,&quot; &lt;&lt; n_bins+1 &lt;&lt; &quot;);\n&quot;;</span>
<a name="l00305"></a>00305 
<a name="l00306"></a>00306       <span class="comment">// abscissa values are located at the center of each bin.</span>
<a name="l00307"></a>00307       out &lt;&lt; <span class="stringliteral">&quot;x=[&quot;</span>;
<a name="l00308"></a>00308       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;bin_members.size(); ++i)
<a name="l00309"></a>00309         {
<a name="l00310"></a>00310           out &lt;&lt; min + (i+0.5)*bin_size &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312       out &lt;&lt; <span class="stringliteral">&quot;];\n&quot;</span>;
<a name="l00313"></a>00313         
<a name="l00314"></a>00314       out &lt;&lt; <span class="stringliteral">&quot;y=[&quot;</span>;
<a name="l00315"></a>00315       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;bin_members.size(); ++i)
<a name="l00316"></a>00316         {
<a name="l00317"></a>00317           out &lt;&lt; bin_members[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00318"></a>00318         }
<a name="l00319"></a>00319       out &lt;&lt; <span class="stringliteral">&quot;];\n&quot;</span>;
<a name="l00320"></a>00320       out &lt;&lt; <span class="stringliteral">&quot;bar(x,y);\n&quot;</span>;
<a name="l00321"></a>00321     }
<a name="l00322"></a>00322 }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00327"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#ac028a3ea07d4230ada8ba9c28ab14a92">00327</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a27dbd15badfb9ba5f0a554f8ffdd1c6f">StatisticsVector&lt;T&gt;::histogram</a>(std::vector&lt;unsigned int&gt;&amp; bin_members,
<a name="l00328"></a>00328                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins)<span class="keyword"> const</span>
<a name="l00329"></a>00329 <span class="keyword"></span>{
<a name="l00330"></a>00330   <a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;T&gt;</a> sv = (*this);
<a name="l00331"></a>00331   
<a name="l00332"></a>00332   <span class="keywordflow">return</span> sv.<a class="code" href="classlibMesh_1_1StatisticsVector.php#a27dbd15badfb9ba5f0a554f8ffdd1c6f">histogram</a>(bin_members, n_bins);
<a name="l00333"></a>00333 }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00339"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a15cbab02af33d8c84e65a82de3851346">00339</a> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1StatisticsVector.php#a15cbab02af33d8c84e65a82de3851346">StatisticsVector&lt;T&gt;::cut_below</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut)<span class="keyword"> const</span>
<a name="l00340"></a>00340 <span class="keyword"></span>{
<a name="l00341"></a>00341   START_LOG (<span class="stringliteral">&quot;cut_below()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00344"></a>00344   
<a name="l00345"></a>00345   std::vector&lt;unsigned int&gt; cut_indices;
<a name="l00346"></a>00346   cut_indices.reserve(n/2);  <span class="comment">// Arbitrary </span>
<a name="l00347"></a>00347   
<a name="l00348"></a>00348   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)[i] &lt; cut)
<a name="l00351"></a>00351         {
<a name="l00352"></a>00352           cut_indices.push_back(i);
<a name="l00353"></a>00353         }
<a name="l00354"></a>00354     }
<a name="l00355"></a>00355   
<a name="l00356"></a>00356   STOP_LOG (<span class="stringliteral">&quot;cut_below()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00357"></a>00357   
<a name="l00358"></a>00358   <span class="keywordflow">return</span> cut_indices;
<a name="l00359"></a>00359 }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00365"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a1ab17767ad0f01850fdd72b14255f22f">00365</a> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1StatisticsVector.php#a1ab17767ad0f01850fdd72b14255f22f">StatisticsVector&lt;T&gt;::cut_above</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut)<span class="keyword"> const</span>
<a name="l00366"></a>00366 <span class="keyword"></span>{
<a name="l00367"></a>00367   START_LOG (<span class="stringliteral">&quot;cut_above()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00368"></a>00368   
<a name="l00369"></a>00369   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00370"></a>00370   
<a name="l00371"></a>00371   std::vector&lt;unsigned int&gt; cut_indices;
<a name="l00372"></a>00372   cut_indices.reserve(n/2);  <span class="comment">// Arbitrary </span>
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00375"></a>00375     {
<a name="l00376"></a>00376       <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)[i] &gt; cut)
<a name="l00377"></a>00377         {
<a name="l00378"></a>00378           cut_indices.push_back(i);
<a name="l00379"></a>00379         }
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381   
<a name="l00382"></a>00382   STOP_LOG (<span class="stringliteral">&quot;cut_above()&quot;</span>, <span class="stringliteral">&quot;StatisticsVector&quot;</span>);
<a name="l00383"></a>00383   
<a name="l00384"></a>00384   <span class="keywordflow">return</span> cut_indices;
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 <span class="comment">//------------------------------------------------------------</span>
<a name="l00391"></a>00391 <span class="comment">// Explicit Instantions</span>
<a name="l00392"></a>00392 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;float&gt;</a>;
<a name="l00393"></a>00393 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;double&gt;</a>;
<a name="l00394"></a>00394 <span class="preprocessor">#ifdef LIBMESH_DEFAULT_TRIPLE_PRECISION</span>
<a name="l00395"></a>00395 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;long double&gt;</a>;
<a name="l00396"></a>00396 <span class="preprocessor">#endif</span>
<a name="l00397"></a>00397 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;int&gt;</a>;
<a name="l00398"></a>00398 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;unsigned int&gt;</a>;
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
