<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">statistics.h</div>  </div>
</div>
<div class="contents">
<a href="statistics_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: statistics.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __statistics_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __statistics_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00074"></a>00074 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00075"></a>00075 <span class="comment">// StatisticsVector class definition</span>
<a name="l00076"></a>00076 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00077"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php">00077</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;T&gt;
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079  <span class="keyword">public</span>:
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#abce2ec8f57db9908a37e7bc4aa630fa3">00084</a>   <a class="code" href="classlibMesh_1_1StatisticsVector.php#abce2ec8f57db9908a37e7bc4aa630fa3">StatisticsVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) : std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;T&gt; (i) {}
<a name="l00085"></a>00085   
<a name="l00089"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#aa4dc51e730a7c001de6d5cdf86028d11">00089</a>   <a class="code" href="classlibMesh_1_1StatisticsVector.php#aa4dc51e730a7c001de6d5cdf86028d11">StatisticsVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, T val) : std::<a class="code" href="classstd_1_1vector.php">vector</a>&lt;T&gt; (i,val) {}
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a24c9d96f5974590b07d113bd9ad1eb63">00094</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a24c9d96f5974590b07d113bd9ad1eb63">~StatisticsVector</a> () {}
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a7f812876e5fb9237ee5e00882052da1b">l2_norm</a>() <span class="keyword">const</span>;
<a name="l00101"></a>00101   
<a name="l00105"></a>00105   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1StatisticsVector.php#a4b87ff98b05015dd0d78e247aadb92da">minimum</a>() <span class="keyword">const</span>;
<a name="l00106"></a>00106   
<a name="l00110"></a>00110   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1StatisticsVector.php#a8145b8254720c71e9a7e977135229d6c">maximum</a>() <span class="keyword">const</span>;
<a name="l00111"></a>00111   
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#ae16519b8e9ed1f8159a12d79087de301">mean</a>() <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">median</a>();
<a name="l00128"></a>00128 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">median</a>() <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">00144</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">variance</a>()<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">variance</a>(this-&gt;<a class="code" href="classlibMesh_1_1StatisticsVector.php#ae16519b8e9ed1f8159a12d79087de301">mean</a>()); }
<a name="l00146"></a>00146 
<a name="l00157"></a>00157   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">variance</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#ae16519b8e9ed1f8159a12d79087de301">mean</a>) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00164"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#a426d125d56b6d99f1ef2c4ef44c9fc0d">00164</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a426d125d56b6d99f1ef2c4ef44c9fc0d">stddev</a>()<span class="keyword"> const</span>
<a name="l00165"></a>00165 <span class="keyword">  </span>{ <span class="keywordflow">return</span> std::sqrt(this-&gt;<a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">variance</a>()); }
<a name="l00166"></a>00166   
<a name="l00173"></a><a class="code" href="classlibMesh_1_1StatisticsVector.php#ae97b6151bac9ec17c88b67b1fa88bcb4">00173</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a426d125d56b6d99f1ef2c4ef44c9fc0d">stddev</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1StatisticsVector.php#ae16519b8e9ed1f8159a12d79087de301">mean</a>)<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword">  </span>{ <span class="keywordflow">return</span> std::sqrt(this-&gt;<a class="code" href="classlibMesh_1_1StatisticsVector.php#a45f2604e6b3ba3098ffdb6e228d8549d">variance</a>(mean)); }
<a name="l00175"></a>00175 
<a name="l00180"></a>00180   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a12f8d44137d31baa4184428b72e5f422">normalize</a>();
<a name="l00181"></a>00181   
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a27dbd15badfb9ba5f0a554f8ffdd1c6f">histogram</a> (std::vector&lt;unsigned int&gt;&amp; bin_members,
<a name="l00192"></a>00192                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins=10);
<a name="l00193"></a>00193 
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a28fe86ca7c0ac60ce4e572660f83d385">plot_histogram</a>(<span class="keyword">const</span> std::string&amp; filename,
<a name="l00202"></a>00202                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins);
<a name="l00203"></a>00203   
<a name="l00207"></a>00207   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php#a27dbd15badfb9ba5f0a554f8ffdd1c6f">histogram</a> (std::vector&lt;unsigned int&gt;&amp; bin_members,
<a name="l00208"></a>00208                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bins=10) <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00215"></a>00215   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1StatisticsVector.php#a15cbab02af33d8c84e65a82de3851346">cut_below</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut) <span class="keyword">const</span>;
<a name="l00216"></a>00216 
<a name="l00224"></a>00224   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1StatisticsVector.php#a1ab17767ad0f01850fdd72b14255f22f">cut_above</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut) <span class="keyword">const</span>;
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   
<a name="l00227"></a>00227  <span class="keyword">private</span>:
<a name="l00228"></a>00228   
<a name="l00229"></a>00229 };
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 } <span class="comment">// namespace libMesh</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
