<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">steady_solver.C</div>  </div>
</div>
<div class="contents">
<a href="steady__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: steady_solver.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="steady__solver_8h.php">steady_solver.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#a808ba69b2087df85f16892cffdc6e3eb">00030</a> <a class="code" href="classlibMesh_1_1SteadySolver.php#a808ba69b2087df85f16892cffdc6e3eb">SteadySolver::~SteadySolver</a> ()
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 }
<a name="l00033"></a>00033   
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#ad80b263a539deed44cee7224f88264bc">00036</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SteadySolver.php#ad80b263a539deed44cee7224f88264bc">SteadySolver::element_residual</a>(<span class="keywordtype">bool</span> request_jacobian,
<a name="l00037"></a>00037                                     <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp; context)
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   <span class="comment">// If a fixed solution is requested, it will just be the current</span>
<a name="l00040"></a>00040   <span class="comment">// solution</span>
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a> = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>;
<a name="l00044"></a>00044       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = 1.0;
<a name="l00045"></a>00045     }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00048"></a>00048     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">element_time_derivative</a>(request_jacobian, context);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00051"></a>00051   libmesh_assert(request_jacobian || !jacobian_computed);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordtype">bool</span> jacobian_computed2 =
<a name="l00054"></a>00054     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acf8f44832ec07639d55b1688787c80d0">element_constraint</a>(jacobian_computed, context);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00057"></a>00057   libmesh_assert (jacobian_computed || !jacobian_computed2);
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="keywordflow">return</span> jacobian_computed2;
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#a5f5fd5b720c007d256119cc3265e00f7">00064</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SteadySolver.php#a5f5fd5b720c007d256119cc3265e00f7">SteadySolver::side_residual</a>(<span class="keywordtype">bool</span> request_jacobian,
<a name="l00065"></a>00065                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp; context)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="comment">// If a fixed solution is requested, it will just be the current</span>
<a name="l00068"></a>00068   <span class="comment">// solution</span>
<a name="l00069"></a>00069   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a> = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>;
<a name="l00072"></a>00072       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = 1.0;
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00076"></a>00076     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">side_time_derivative</a>(request_jacobian, context);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00079"></a>00079   libmesh_assert (request_jacobian || !jacobian_computed);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="keywordtype">bool</span> jacobian_computed2 =
<a name="l00082"></a>00082     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa70056a38d864596769ef8382ba1e9d8">side_constraint</a>(jacobian_computed, context);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// The user shouldn&#39;t compute a jacobian unless requested</span>
<a name="l00085"></a>00085   libmesh_assert (jacobian_computed || !jacobian_computed2);
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="keywordflow">return</span> jacobian_computed2;
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 } <span class="comment">// namespace libMesh</span>
<a name="l00091"></a>00091 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
