<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">steady_solver.h</div>  </div>
</div>
<div class="contents">
<a href="steady__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: steady_solver.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __steady_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __steady_solver_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>DiffContext;
<a name="l00036"></a>00036 <span class="keyword">class </span>DifferentiableSystem;
<a name="l00037"></a>00037 <span class="keyword">class </span>TimeSolver;
<a name="l00038"></a>00038 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// Solver class definition</span>
<a name="l00052"></a><a class="code" href="classlibMesh_1_1SteadySolver.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SteadySolver.php">SteadySolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#a2cc737808aec6c524ff25d48abc501af">00058</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classlibMesh_1_1SteadySolver.php#a2cc737808aec6c524ff25d48abc501af">sys_type</a>;
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#a24d8c0eaae3b9ee1b419017d010d6d41">00063</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a> <a class="code" href="classlibMesh_1_1SteadySolver.php#a24d8c0eaae3b9ee1b419017d010d6d41">Parent</a>;
<a name="l00064"></a>00064   
<a name="l00069"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#ad812c368c8dca2e760cac50b660214cc">00069</a>   <a class="code" href="classlibMesh_1_1SteadySolver.php#ad812c368c8dca2e760cac50b660214cc">SteadySolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s) : <a class="code" href="classlibMesh_1_1TimeSolver.php">Parent</a>(s) {}
<a name="l00070"></a>00070   
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1SteadySolver.php#a808ba69b2087df85f16892cffdc6e3eb">~SteadySolver</a> ();
<a name="l00075"></a>00075 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#a6b6b322b54bb3f4d5bacb1047023e2cf">00080</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SteadySolver.php#a6b6b322b54bb3f4d5bacb1047023e2cf">error_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.; }
<a name="l00081"></a>00081 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SteadySolver.php#ad80b263a539deed44cee7224f88264bc">element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00088"></a>00088                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;);
<a name="l00089"></a>00089 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SteadySolver.php#a5f5fd5b720c007d256119cc3265e00f7">side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00096"></a>00096                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;);
<a name="l00097"></a>00097 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#aaf284504dcaf773e2e9c41789bd4d45e">00103</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SteadySolver.php#aaf284504dcaf773e2e9c41789bd4d45e">du</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>&amp;)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1SteadySolver.php#afc6984d7ca8bcf8fa4c31f3d3239d188">00108</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SteadySolver.php#afc6984d7ca8bcf8fa4c31f3d3239d188">is_steady</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00109"></a>00109 };
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 } <span class="comment">// namespace libMesh</span>
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="preprocessor">#endif // #define __steady_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
