<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">stored_range.h</div>  </div>
</div>
<div class="contents">
<a href="stored__range_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: stored_range.h 4170 2011-01-13 23:55:44Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __stored_range_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __stored_range_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type, <span class="keyword">typename</span> <span class="keywordtype">object</span>_type&gt;
<a name="l00053"></a><a class="code" href="classlibMesh_1_1StoredRange.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange</a> 
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">00059</a>   <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;object_type&gt;::const_iterator <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a>;
<a name="l00060"></a>00060 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">00066</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a> = 1000) :
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>(),
<a name="l00068"></a>00068     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>(),
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>(),
<a name="l00070"></a>00070     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>(),
<a name="l00071"></a>00071     <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(<a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a>),
<a name="l00072"></a>00072     <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>()
<a name="l00073"></a>00073   {}
<a name="l00074"></a>00074 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a458013c6429e39b247b0a27ddc4925c8">00081</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<span class="keyword">const</span> iterator_type &amp;first,
<a name="l00082"></a>00082                <span class="keyword">const</span> iterator_type &amp;last,
<a name="l00083"></a>00083                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a> = 1000) :
<a name="l00084"></a>00084     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>(),
<a name="l00085"></a>00085     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>(),
<a name="l00086"></a>00086     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>(),
<a name="l00087"></a>00087     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>(),
<a name="l00088"></a>00088     <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(<a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a>),
<a name="l00089"></a>00089     <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>()
<a name="l00090"></a>00090   {
<a name="l00091"></a>00091     this-&gt;<a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">reset</a>(first, last);
<a name="l00092"></a>00092   }
<a name="l00093"></a>00093 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ae3dd9b80ecbf1b72e95d7bc5c717f5cc">00107</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type,object_type&gt;</a> &amp;er):
<a name="l00108"></a>00108     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>), 
<a name="l00109"></a>00109     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>),
<a name="l00110"></a>00110     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>),
<a name="l00111"></a>00111     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>),
<a name="l00112"></a>00112     <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(er.<a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>),
<a name="l00113"></a>00113     <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>()
<a name="l00114"></a>00114   {
<a name="l00115"></a>00115     <span class="comment">// specifically, do *not* copy the vector</span>
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117     
<a name="l00123"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a6b049f2fcac81ee252a456aa24a5c01f">00123</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a3a1dfbb26a0bef88bfa38806c5f53bd3">StoredRange</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type,object_type&gt;</a> &amp;r, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a> ) : 
<a name="l00124"></a>00124     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>),
<a name="l00125"></a>00125     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>),
<a name="l00126"></a>00126     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>),
<a name="l00127"></a>00127     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>),
<a name="l00128"></a>00128     <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>(r.<a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>),
<a name="l00129"></a>00129     <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>()
<a name="l00130"></a>00130   {
<a name="l00131"></a>00131     <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a>
<a name="l00132"></a>00132       beginning = r.<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>,
<a name="l00133"></a>00133       ending    = r.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>,
<a name="l00134"></a>00134       middle    = beginning + std::distance(beginning, ending)/2u;
<a name="l00135"></a>00135     
<a name="l00136"></a>00136     r.<a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> = middle;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00139"></a>00139       first = r.<a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>,
<a name="l00140"></a>00140       last  = r.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>,
<a name="l00141"></a>00141       half  = first + (last-first)/2u;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     r.<a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a> = half;
<a name="l00144"></a>00144   }
<a name="l00145"></a>00145     
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type, object_type&gt;</a> &amp; 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a6769bcd5b501cb9a10cdbc85c64a2e72">00152</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">reset</a> (<span class="keyword">const</span> iterator_type &amp;first,
<a name="l00153"></a>00153          <span class="keyword">const</span> iterator_type &amp;last)
<a name="l00154"></a>00154   {
<a name="l00155"></a>00155     <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.clear();
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     <span class="keywordflow">for</span> (iterator_type it=first; it!=last; ++it)
<a name="l00158"></a>00158       <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.push_back(*it);
<a name="l00159"></a>00159     
<a name="l00160"></a>00160     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.begin();
<a name="l00161"></a>00161     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>   = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.end();
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a> = 0;
<a name="l00164"></a>00164     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>  = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.size();
<a name="l00165"></a>00165     
<a name="l00166"></a>00166     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00167"></a>00167   }
<a name="l00168"></a>00168 
<a name="l00176"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">00176</a>   <a class="code" href="classlibMesh_1_1StoredRange.php">StoredRange&lt;iterator_type, object_type&gt;</a> &amp; <a class="code" href="classlibMesh_1_1StoredRange.php#a4f7c25f4b4c7883aa39749fb384191c5">reset</a> ()
<a name="l00177"></a>00177   {
<a name="l00178"></a>00178     <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.begin();
<a name="l00179"></a>00179     <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>   = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.end();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a> = 0;
<a name="l00182"></a>00182     <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>  = <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>.size();
<a name="l00183"></a>00183 
<a name="l00184"></a>00184     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00185"></a>00185   }
<a name="l00186"></a>00186   
<a name="l00190"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">00190</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>; }  
<a name="l00191"></a>00191   
<a name="l00195"></a><a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">00195</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>; }
<a name="l00196"></a>00196 
<a name="l00200"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ac97b17b636979aeff8b549906e36fe1a">00200</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ac97b17b636979aeff8b549906e36fe1a">first_idx</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>; }
<a name="l00201"></a>00201 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a761a91693a95bcda1505c2c1770db3d7">00205</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a761a91693a95bcda1505c2c1770db3d7">last_idx</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>; }
<a name="l00206"></a>00206 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">00211</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>;}
<a name="l00212"></a>00212 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a84618641926b5c141a5ff8a9b4499448">00216</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a84618641926b5c141a5ff8a9b4499448">grainsize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;gs) {<a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a> = gs;}
<a name="l00217"></a>00217 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1StoredRange.php#aadde9c3b9c818aaa0f5ca8788360a291">00221</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#aadde9c3b9c818aaa0f5ca8788360a291">size</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> std::distance(<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>, <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>); }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00224"></a>00224   <span class="comment">// Methods that implement Range concept</span>
<a name="l00225"></a>00225   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00226"></a>00226 
<a name="l00230"></a><a class="code" href="classlibMesh_1_1StoredRange.php#adea84b1d6e4d76b3738b32f6dd3e7160">00230</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1StoredRange.php#adea84b1d6e4d76b3738b32f6dd3e7160">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a> == <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>); }
<a name="l00231"></a>00231 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a71d873f71f5ba1a70d14ed2b1a7c766d">00235</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a71d873f71f5ba1a70d14ed2b1a7c766d">is_divisible</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1StoredRange.php#a6b8ccdf79669d164dddcf09cc3b1991b">grainsize</a>() &lt; <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(<a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>, <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>)); }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="keyword">private</span>:
<a name="l00238"></a>00238 
<a name="l00239"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">00239</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#ab33f2561d66303e52a57dcc6dfea03b1">_end</a>;
<a name="l00240"></a><a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">00240</a>   <a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">const_iterator</a> <a class="code" href="classlibMesh_1_1StoredRange.php#afa4a75f963bd242310f245cb04e1f208">_begin</a>;
<a name="l00241"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">00241</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a464850e04a770f2f06dd36164d0932ab">_last</a>;
<a name="l00242"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">00242</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#ac65cfe88cbe40e52418e48a79d6b2a53">_first</a>;
<a name="l00243"></a><a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">00243</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1StoredRange.php#a0dd7748951852d34cffcc9c2feea03a6">_grainsize</a>;
<a name="l00244"></a><a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">00244</a>   std::vector&lt;object_type&gt; <a class="code" href="classlibMesh_1_1StoredRange.php#ac1c9408f46667d5496a70473ffacff33">_objs</a>;
<a name="l00245"></a>00245 };
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 } <span class="comment">// namespace libMesh</span>
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="preprocessor">#endif // end #ifndef __stored_range_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
