<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">sum_shell_matrix.C</div>  </div>
</div>
<div class="contents">
<a href="sum__shell__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: sum_shell_matrix.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="sum__shell__matrix_8h.php">sum_shell_matrix.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00030"></a><a class="code" href="classlibMesh_1_1SumShellMatrix.php#a3726dad1e7edb24396770a56d91f9414">00030</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SumShellMatrix.php#a3726dad1e7edb24396770a56d91f9414">SumShellMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00031"></a>00031 <span class="keyword"></span>{
<a name="l00032"></a>00032   libmesh_assert(!matrices.empty());
<a name="l00033"></a>00033   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> result = matrices[0]-&gt;m();
<a name="l00034"></a>00034   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;1; )
<a name="l00035"></a>00035     {
<a name="l00036"></a>00036       libmesh_assert(matrices[i]-&gt;m()==result);
<a name="l00037"></a>00037     }
<a name="l00038"></a>00038   <span class="keywordflow">return</span> result;
<a name="l00039"></a>00039 }
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00044"></a><a class="code" href="classlibMesh_1_1SumShellMatrix.php#ab976cb30a90983d383610b9299ec0852">00044</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1SumShellMatrix.php#ab976cb30a90983d383610b9299ec0852">SumShellMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00045"></a>00045 <span class="keyword"></span>{
<a name="l00046"></a>00046   libmesh_assert(!matrices.empty());
<a name="l00047"></a>00047   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> result = matrices[0]-&gt;n();
<a name="l00048"></a>00048   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;1; )
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       libmesh_assert(matrices[i]-&gt;n()==result);
<a name="l00051"></a>00051     }
<a name="l00052"></a>00052   <span class="keywordflow">return</span> result;
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00058"></a><a class="code" href="classlibMesh_1_1SumShellMatrix.php#a35332ad16ed4c3b37def91fca9ea25ac">00058</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SumShellMatrix.php#a35332ad16ed4c3b37def91fca9ea25ac">SumShellMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00059"></a>00059                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00060"></a>00060 <span class="keyword"></span>{
<a name="l00061"></a>00061   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00062"></a>00062   this-&gt;vector_mult_add(dest,arg);
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00068"></a><a class="code" href="classlibMesh_1_1SumShellMatrix.php#a5f039e3b5a290bc54e95bb7584fb1b91">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SumShellMatrix.php#a5f039e3b5a290bc54e95bb7584fb1b91">SumShellMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00069"></a>00069                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00070"></a>00070 <span class="keyword"></span>{
<a name="l00071"></a>00071   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;0; )
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073       matrices[i]-&gt;vector_mult_add(dest,arg);
<a name="l00074"></a>00074     }
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00080"></a><a class="code" href="classlibMesh_1_1SumShellMatrix.php#aede671730c5ad27490efb3db18ee9083">00080</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SumShellMatrix.php#aede671730c5ad27490efb3db18ee9083">SumShellMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00081"></a>00081 <span class="keyword"></span>{
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; a = dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a5c4b5cbb3877d0ad466895286fc8bb55">clone</a>();
<a name="l00083"></a>00083   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00084"></a>00084   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=matrices.size(); i--&gt;0; )
<a name="l00085"></a>00085     {
<a name="l00086"></a>00086       matrices[i]-&gt;get_diagonal(*a);
<a name="l00087"></a>00087       dest += *a;
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00094"></a>00094 <span class="comment">// Explicit instantiations</span>
<a name="l00095"></a>00095 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SumShellMatrix.php">SumShellMatrix&lt;Number&gt;</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 } <span class="comment">// namespace libMesh</span>
<a name="l00098"></a>00098 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
