<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">surface.h</div>  </div>
</div>
<div class="contents">
<a href="surface_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: surface.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __surface_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __surface_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// Surface class definition</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1Surface.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Surface.php">Surface</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050   
<a name="l00054"></a><a class="code" href="classlibMesh_1_1Surface.php#a123a7c8b48cf92de5e31eb543afd476a">00054</a>   <a class="code" href="classlibMesh_1_1Surface.php#a123a7c8b48cf92de5e31eb543afd476a">Surface</a> () {}
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1Surface.php#ae2f057950da3e487f8ccab907bff0c0c">00059</a>   <a class="code" href="classlibMesh_1_1Surface.php#ae2f057950da3e487f8ccab907bff0c0c">Surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Surface.php">Surface</a>&amp;) {}
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1Surface.php#a823cb0a315394149afdbc469c26a2323">00064</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Surface.php#a823cb0a315394149afdbc469c26a2323">~Surface</a> () {}
<a name="l00065"></a>00065 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Surface.php#affcf5b567bb5ef2f2fd2410599b853c5">above_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Surface.php#a0f7e3d0e7a9528c19e087d996560e100">below_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00077"></a>00077 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Surface.php#a41be0551ded958bab175046a4a259321">on_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Surface.php#a524c8adf956705862a28259670674be0">closest_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Surface.php#a38a53c9e7f08045b627efb3375112c24">unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00096"></a>00096 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Surface.php#abb29fc8cf4e40b12f2fb1e8866cc0b21">surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1Surface.php#af0773d0212d47f3b0106c2b66e0c94e2">world_coords</a>) <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Surface.php#af0773d0212d47f3b0106c2b66e0c94e2">world_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; surf_coords) <span class="keyword">const</span>;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">protected</span>:
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 };
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00121"></a>00121 <span class="comment">// Surface class member functions</span>
<a name="l00122"></a>00122 <span class="keyword">inline</span>
<a name="l00123"></a><a class="code" href="classlibMesh_1_1Surface.php#abb29fc8cf4e40b12f2fb1e8866cc0b21">00123</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Surface.php#abb29fc8cf4e40b12f2fb1e8866cc0b21">Surface::surface_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; world_coords)<span class="keyword"> const</span>
<a name="l00124"></a>00124 <span class="keyword"></span>{
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p (world_coords);
<a name="l00126"></a>00126   <span class="keywordflow">return</span> p;
<a name="l00127"></a>00127 }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="keyword">inline</span>
<a name="l00132"></a><a class="code" href="classlibMesh_1_1Surface.php#af0773d0212d47f3b0106c2b66e0c94e2">00132</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Surface.php#af0773d0212d47f3b0106c2b66e0c94e2">Surface::world_coords</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; surf_coords)<span class="keyword"> const</span>
<a name="l00133"></a>00133 <span class="keyword"></span>{
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p (surf_coords);
<a name="l00135"></a>00135   <span class="keywordflow">return</span> p;
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 } <span class="comment">// namespace libMesh</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
