<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system.h</div>  </div>
</div>
<div class="contents">
<a href="system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system.h 4402 2011-04-22 23:10:19Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__norm__type_8h.php">enum_norm_type.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__xdr__mode_8h.php">enum_xdr_mode.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__subset__solve__mode_8h.php">enum_subset_solve_mode.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="enum__parallel__type_8h.php">enum_parallel_type.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span> <span class="comment">// For point_hessian</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="variable_8h.php">variable.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>libMesh
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// Forward Declarations</span>
<a name="l00047"></a>00047 <span class="keyword">class </span>System;
<a name="l00048"></a>00048 <span class="keyword">class </span>SystemNorm;
<a name="l00049"></a>00049 <span class="keyword">class </span>EquationSystems;
<a name="l00050"></a>00050 <span class="keyword">class </span>MeshBase;
<a name="l00051"></a>00051 <span class="keyword">class </span>Xdr;
<a name="l00052"></a>00052 <span class="keyword">class </span>DofMap;
<a name="l00053"></a>00053 <span class="keyword">class </span>Parameters;
<a name="l00054"></a>00054 <span class="keyword">class </span>ParameterVector;
<a name="l00055"></a>00055 <span class="keyword">class </span>Point;
<a name="l00056"></a>00056 <span class="keyword">class </span>SensitivityData;
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>VectorValue;
<a name="l00059"></a>00059 <span class="keyword">typedef</span> VectorValue&lt;Number&gt; <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a>;
<a name="l00060"></a>00060 <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a> <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a>;
<a name="l00061"></a>00061 <span class="keyword">class </span>SystemSubset;
<a name="l00062"></a>00062 
<a name="l00075"></a>00075 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00076"></a>00076 <span class="comment">// System class definition</span>
<a name="l00077"></a><a class="code" href="classlibMesh_1_1System.php">00077</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System.php">System</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;System&gt;
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079 <span class="keyword">protected</span>:
<a name="l00080"></a>00080 
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">System</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00087"></a>00087           <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00088"></a>00088           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00089"></a>00089   
<a name="l00090"></a>00090 <span class="keyword">public</span>:
<a name="l00091"></a>00091 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1System_1_1Initialization.php">00098</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1Initialization.php">Initialization</a>
<a name="l00099"></a>00099   {
<a name="l00100"></a>00100   <span class="keyword">public</span>:
<a name="l00104"></a><a class="code" href="classlibMesh_1_1System_1_1Initialization.php#aa326982ec08684b85ad4342c78827561">00104</a>     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System_1_1Initialization.php#aa326982ec08684b85ad4342c78827561">~Initialization</a> () {};
<a name="l00105"></a>00105 
<a name="l00111"></a>00111     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1Initialization.php#addfa6e36fd94b2255bdf508d29db0d12">initialize</a> () = 0;
<a name="l00112"></a>00112   };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   
<a name="l00115"></a>00115 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1System_1_1Assembly.php">00122</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1Assembly.php">Assembly</a>
<a name="l00123"></a>00123   {
<a name="l00124"></a>00124   <span class="keyword">public</span>:
<a name="l00128"></a><a class="code" href="classlibMesh_1_1System_1_1Assembly.php#a3cb0c9e4462a690b7bd942826e26bce0">00128</a>     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System_1_1Assembly.php#a3cb0c9e4462a690b7bd942826e26bce0">~Assembly</a> () {};
<a name="l00129"></a>00129 
<a name="l00135"></a>00135     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1Assembly.php#a5a74d6c96079b1aeb5ba327fae58762b">assemble</a> () = 0;
<a name="l00136"></a>00136   };
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   
<a name="l00139"></a>00139 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1System_1_1Constraint.php">00146</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1Constraint.php">Constraint</a>
<a name="l00147"></a>00147   {
<a name="l00148"></a>00148   <span class="keyword">public</span>:
<a name="l00152"></a><a class="code" href="classlibMesh_1_1System_1_1Constraint.php#a0e18cc46086528fd74f8c0064679d8d5">00152</a>     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System_1_1Constraint.php#a0e18cc46086528fd74f8c0064679d8d5">~Constraint</a> () {};
<a name="l00153"></a>00153 
<a name="l00159"></a>00159     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1Constraint.php#af7e1606e430fded80731f98b151a40a0">constrain</a> () = 0;
<a name="l00160"></a>00160   };
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   
<a name="l00163"></a>00163 
<a name="l00170"></a><a class="code" href="classlibMesh_1_1System_1_1QOI.php">00170</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1QOI.php">QOI</a>
<a name="l00171"></a>00171   {
<a name="l00172"></a>00172   <span class="keyword">public</span>:
<a name="l00176"></a><a class="code" href="classlibMesh_1_1System_1_1QOI.php#abe599d49ae95435e4158ebc9a400a516">00176</a>     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System_1_1QOI.php#abe599d49ae95435e4158ebc9a400a516">~QOI</a> () {};
<a name="l00177"></a>00177 
<a name="l00183"></a>00183     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1QOI.php#a2f927fdd3255275024529f9a9f22b751">qoi</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices) = 0;
<a name="l00184"></a>00184   };
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   
<a name="l00187"></a>00187 
<a name="l00194"></a><a class="code" href="classlibMesh_1_1System_1_1QOIDerivative.php">00194</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1QOIDerivative.php">QOIDerivative</a>
<a name="l00195"></a>00195   {
<a name="l00196"></a>00196   <span class="keyword">public</span>:
<a name="l00200"></a><a class="code" href="classlibMesh_1_1System_1_1QOIDerivative.php#af3668acd2f9e50aefaed84e715c72bd3">00200</a>     <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System_1_1QOIDerivative.php#af3668acd2f9e50aefaed84e715c72bd3">~QOIDerivative</a> () {};
<a name="l00201"></a>00201 
<a name="l00207"></a>00207     <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1QOIDerivative.php#ae946fa719ce783d2054bddc712ebfb76">qoi_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices) = 0;
<a name="l00208"></a>00208   };
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1System.php#a419421462d140c9d4b71d3df59ff7722">~System</a> ();
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1System.php#a89beaa12b7f2a89c42f1a3ede9a94ced">00220</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1System.php">System</a> <a class="code" href="classlibMesh_1_1System.php#a89beaa12b7f2a89c42f1a3ede9a94ced">sys_type</a>;
<a name="l00221"></a>00221 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1System.php#a9e38c75024ebd02b2f17af5fde17eb75">00225</a>   <a class="code" href="classlibMesh_1_1System.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a9e38c75024ebd02b2f17af5fde17eb75">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00226"></a>00226   
<a name="l00231"></a>00231   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">clear</a> ();
<a name="l00232"></a>00232   
<a name="l00237"></a>00237   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9cbe27bf56eae7baea5c397fa88c09a3">init</a> ();
<a name="l00238"></a>00238   
<a name="l00245"></a>00245   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cb3b5ae4fdd2f72d8fbddcadf3d3256">reinit</a> ();
<a name="l00246"></a>00246   
<a name="l00251"></a>00251   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a> ();
<a name="l00252"></a>00252   
<a name="l00259"></a>00259   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">assemble</a> ();
<a name="l00260"></a>00260 
<a name="l00265"></a>00265   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab57cde3f61d1816856e1100f068a25fa">assemble_qoi</a>
<a name="l00266"></a>00266     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00267"></a>00267  
<a name="l00272"></a>00272   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a7d69df3b46fdd7073cfaaaf0fa71fbbc">assemble_qoi_derivative</a> 
<a name="l00273"></a>00273     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00274"></a>00274  
<a name="l00286"></a>00286   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cc007b379ff2997715998c01106d790">assemble_residual_derivatives</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters);
<a name="l00287"></a>00287 
<a name="l00293"></a>00293   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a271e81524cb5f49448bbb486005abb9b">restrict_solve_to</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemSubset.php">SystemSubset</a>* subset,
<a name="l00294"></a>00294                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137">SubsetSolveMode</a> subset_solve_mode=<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>);
<a name="l00295"></a>00295  
<a name="l00299"></a>00299   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab3e63f2241fc4a3647083b8fd16d2f4c">solve</a> () = 0;
<a name="l00300"></a>00300   
<a name="l00310"></a>00310   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00311"></a>00311     <a class="code" href="classlibMesh_1_1System.php#a9dba69c2da2eff36d8c161d55ddcfb2c">sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters);
<a name="l00312"></a>00312   
<a name="l00323"></a>00323   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00324"></a>00324     <a class="code" href="classlibMesh_1_1System.php#a12a66f71be2f232f7136905559c1bbdb">weighted_sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00325"></a>00325                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights);
<a name="l00326"></a>00326  
<a name="l00337"></a>00337   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00338"></a>00338     <a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00339"></a>00339   
<a name="l00354"></a>00354   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00355"></a>00355     <a class="code" href="classlibMesh_1_1System.php#a79ae2650c56afe266ec27ee2fea57957">weighted_sensitivity_adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00356"></a>00356                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights,
<a name="l00357"></a>00357                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00358"></a>00358  
<a name="l00376"></a>00376   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a4fd540ebc82189c84815d2e50b4a04c2">qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00377"></a>00377                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00378"></a>00378                                           <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00379"></a>00379   
<a name="l00385"></a>00385   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a16e47d56606c347fbc996072f666c1b2">adjoint_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00386"></a>00386                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00387"></a>00387                                                   <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00388"></a>00388   
<a name="l00394"></a>00394   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab19259df51db305760418290ae5b2f57">forward_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00395"></a>00395                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00396"></a>00396                                                   <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00397"></a>00397   
<a name="l00408"></a>00408   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a941661b0198ad8fe5f9d62cfc5f9a03b">qoi_parameter_hessian</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00409"></a>00409                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00410"></a>00410                                      <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; hessian);
<a name="l00411"></a>00411 
<a name="l00424"></a>00424   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a24bec5dc18f42bc87ad135a06aada457">qoi_parameter_hessian_vector_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00425"></a>00425                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00426"></a>00426                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classstd_1_1vector.php">vector</a>,
<a name="l00427"></a>00427                                                     <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; product);
<a name="l00428"></a>00428   
<a name="l00434"></a>00434   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a8a3e5f73bb8c49d5d69ed59849e9b20e">compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; other_system, 
<a name="l00435"></a>00435                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold,
<a name="l00436"></a>00436                         <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose) <span class="keyword">const</span>;
<a name="l00437"></a>00437 
<a name="l00441"></a>00441   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a> () <span class="keyword">const</span>;
<a name="l00442"></a>00442 
<a name="l00448"></a><a class="code" href="classlibMesh_1_1System.php#af6548563b24dc5a00d12979b9869a4bf">00448</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1System.php#af6548563b24dc5a00d12979b9869a4bf">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;BasicSystem&quot;</span>; }
<a name="l00449"></a>00449 
<a name="l00453"></a>00453   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2cf57ff5d137c7be896b2e1442e9916b">project_solution</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00454"></a>00454                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00455"></a>00455                                      <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00456"></a>00456                                      <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00457"></a>00457                          <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> gptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00458"></a>00458                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00459"></a>00459                                        <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00460"></a>00460                                        <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00461"></a>00461                          <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters) <span class="keyword">const</span>;
<a name="l00462"></a>00462 
<a name="l00466"></a>00466   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00467"></a>00467                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00468"></a>00468                                    <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00469"></a>00469                                    <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00470"></a>00470                        <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> gptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00471"></a>00471                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00472"></a>00472                                      <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00473"></a>00473                                      <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00474"></a>00474                        <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00475"></a>00475                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; new_vector) <span class="keyword">const</span>;
<a name="l00476"></a>00476   
<a name="l00480"></a>00480   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a> () <span class="keyword">const</span>;
<a name="l00481"></a>00481   
<a name="l00487"></a>00487   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln) <span class="keyword">const</span>;
<a name="l00488"></a>00488 
<a name="l00494"></a>00494   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (std::vector&lt;Number&gt;&amp; global_soln,
<a name="l00495"></a>00495                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_proc) <span class="keyword">const</span>;
<a name="l00496"></a>00496 
<a name="l00500"></a>00500   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>() <span class="keyword">const</span>;
<a name="l00501"></a>00501   
<a name="l00505"></a>00505   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00506"></a>00506   
<a name="l00510"></a>00510   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>() <span class="keyword">const</span>;
<a name="l00511"></a>00511   
<a name="l00515"></a>00515   <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00516"></a>00516 
<a name="l00520"></a><a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">00520</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>; }
<a name="l00521"></a>00521 
<a name="l00525"></a><a class="code" href="classlibMesh_1_1System.php#a6407174ed7461749bc7fb9c453f169cf">00525</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a6407174ed7461749bc7fb9c453f169cf">get_equation_systems</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>; }
<a name="l00526"></a>00526 
<a name="l00531"></a>00531   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a0abd752d5ad75ea99581c65e0d5c2fb7">active</a> () <span class="keyword">const</span>;
<a name="l00532"></a>00532 
<a name="l00536"></a>00536   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2caec05f9f5fbdeee0ed4a1245f5e150">activate</a> ();
<a name="l00537"></a>00537 
<a name="l00541"></a>00541   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9ba45875ecfb9f9151a014cadac8109c">deactivate</a> ();
<a name="l00542"></a>00542 
<a name="l00546"></a><a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">00546</a>   <span class="keyword">typedef</span> std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>       <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a>;
<a name="l00547"></a><a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">00547</a>   <span class="keyword">typedef</span> std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a>;
<a name="l00548"></a>00548 
<a name="l00552"></a>00552   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a> ();
<a name="l00553"></a>00553 
<a name="l00557"></a>00557   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a> () <span class="keyword">const</span>;
<a name="l00558"></a>00558 
<a name="l00562"></a>00562   <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a> ();
<a name="l00563"></a>00563 
<a name="l00567"></a>00567   <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a> () <span class="keyword">const</span>;
<a name="l00568"></a>00568 
<a name="l00579"></a>00579   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name,
<a name="l00580"></a>00580                                                               <span class="keyword">const</span> <span class="keywordtype">bool</span> projections=<span class="keyword">true</span>,
<a name="l00581"></a>00581                                                               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00582"></a>00582 
<a name="l00588"></a><a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">00588</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">project_solution_on_reinit</a> (<span class="keywordtype">void</span>)
<a name="l00589"></a>00589     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">_solution_projection</a>; }
<a name="l00590"></a>00590   
<a name="l00595"></a>00595   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">have_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00596"></a>00596   
<a name="l00601"></a>00601   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00602"></a>00602   
<a name="l00607"></a>00607   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name);
<a name="l00608"></a>00608   
<a name="l00614"></a>00614   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num) <span class="keyword">const</span>;
<a name="l00615"></a>00615 
<a name="l00621"></a>00621   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1System.php#aa1098d22312396ab1de8256f50c5a351">request_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00622"></a>00622 
<a name="l00628"></a>00628   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name) <span class="keyword">const</span>;
<a name="l00629"></a>00629 
<a name="l00635"></a>00635   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name);
<a name="l00636"></a>00636 
<a name="l00642"></a>00642   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num) <span class="keyword">const</span>;
<a name="l00643"></a>00643 
<a name="l00649"></a>00649   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00650"></a>00650 
<a name="l00655"></a>00655   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#a63a2a2e98a9932173e5b8607ab03687e">vector_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_num);
<a name="l00656"></a>00656 
<a name="l00662"></a>00662   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab5777831398d0a7a0d8ef2a231824989">add_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00663"></a>00663 
<a name="l00668"></a>00668   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00669"></a>00669 
<a name="l00674"></a>00674   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00675"></a>00675 
<a name="l00681"></a>00681   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a8af728122cdd5677dc5a78e698bd1b35">add_sensitivity_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00682"></a>00682 
<a name="l00687"></a>00687   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">get_sensitivity_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00688"></a>00688 
<a name="l00693"></a>00693   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">get_sensitivity_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00694"></a>00694 
<a name="l00701"></a>00701   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a16e412144b3c5c1cc59cbb9e52b9ab05">add_weighted_sensitivity_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00702"></a>00702 
<a name="l00708"></a>00708   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">get_weighted_sensitivity_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00709"></a>00709 
<a name="l00715"></a>00715   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">get_weighted_sensitivity_adjoint_solution</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00716"></a>00716 
<a name="l00722"></a>00722   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ae1922f73d344e6e1bea9100fec966e54">add_weighted_sensitivity_solution</a>();
<a name="l00723"></a>00723 
<a name="l00728"></a>00728   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">get_weighted_sensitivity_solution</a>();
<a name="l00729"></a>00729 
<a name="l00734"></a>00734   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">get_weighted_sensitivity_solution</a>() <span class="keyword">const</span>;
<a name="l00735"></a>00735 
<a name="l00741"></a>00741   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab21c031f38c12ff111865623561b6687">add_adjoint_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00742"></a>00742 
<a name="l00749"></a>00749   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00750"></a>00750 
<a name="l00755"></a>00755   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00756"></a>00756 
<a name="l00762"></a>00762   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a65312b9004fc31ba812b7ec32515a2fa">add_sensitivity_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00763"></a>00763 
<a name="l00773"></a>00773   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">get_sensitivity_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0);
<a name="l00774"></a>00774 
<a name="l00779"></a>00779   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">get_sensitivity_rhs</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00780"></a>00780 
<a name="l00786"></a>00786   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a> () <span class="keyword">const</span>;
<a name="l00787"></a>00787 
<a name="l00791"></a>00791   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>() <span class="keyword">const</span>;
<a name="l00792"></a>00792 
<a name="l00796"></a>00796   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>() <span class="keyword">const</span>;
<a name="l00797"></a>00797 
<a name="l00802"></a>00802   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ab87249ec70609d4d3376b7705829fee0">n_active_dofs</a>() <span class="keyword">const</span>;
<a name="l00803"></a>00803 
<a name="l00808"></a>00808   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">n_constrained_dofs</a>() <span class="keyword">const</span>;
<a name="l00809"></a>00809   
<a name="l00814"></a>00814   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>() <span class="keyword">const</span>;
<a name="l00815"></a>00815 
<a name="l00820"></a>00820   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00821"></a>00821                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type,
<a name="l00822"></a>00822                              <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains = NULL);
<a name="l00823"></a>00823 
<a name="l00829"></a>00829   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a> (<span class="keyword">const</span> std::string&amp; var,
<a name="l00830"></a>00830                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order = <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00831"></a>00831                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> = <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>,
<a name="l00832"></a>00832                              <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; * <span class="keyword">const</span> active_subdomains = NULL);
<a name="l00833"></a>00833 
<a name="l00837"></a>00837   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00838"></a>00838 
<a name="l00842"></a>00842   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a700306a949024804a0933b98f406a71b">has_variable</a>(<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00843"></a>00843   
<a name="l00847"></a>00847   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00848"></a>00848   
<a name="l00853"></a>00853   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a> (<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00854"></a>00854 
<a name="l00858"></a>00858   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00859"></a>00859 
<a name="l00863"></a>00863   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a> (<span class="keyword">const</span> std::string&amp; var) <span class="keyword">const</span>;
<a name="l00864"></a>00864 
<a name="l00869"></a>00869   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00870"></a>00870                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0,
<a name="l00871"></a>00871                       <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>) <span class="keyword">const</span>;
<a name="l00872"></a>00872 
<a name="l00877"></a>00877   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l00878"></a>00878                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;norm) <span class="keyword">const</span>;
<a name="l00879"></a>00879 
<a name="l00883"></a>00883   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">read_header</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00884"></a>00884                     <span class="keyword">const</span> std::string &amp;version,
<a name="l00885"></a>00885                     <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">read_header</a>=<span class="keyword">true</span>,
<a name="l00886"></a>00886                     <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>,
<a name="l00887"></a>00887                     <span class="keyword">const</span> <span class="keywordtype">bool</span> read_legacy_format=<span class="keyword">false</span>);
<a name="l00888"></a>00888 
<a name="l00892"></a>00892   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a01d9de7172eb9ae886bbcba4aa3f9a2a">read_legacy_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00893"></a>00893                          <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>);
<a name="l00894"></a>00894 
<a name="l00899"></a>00899   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00900"></a>00900                              <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data=<span class="keyword">true</span>);
<a name="l00901"></a>00901 
<a name="l00908"></a>00908   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a13f952c98690727e4168a8b03918f008">read_parallel_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00909"></a>00909                            <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data);
<a name="l00913"></a>00913   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab85bb7019eaac1ceb8603975da8325ab">write_header</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00914"></a>00914                      <span class="keyword">const</span> std::string &amp;version,
<a name="l00915"></a>00915                      <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data) <span class="keyword">const</span>;
<a name="l00916"></a>00916 
<a name="l00921"></a>00921   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00922"></a>00922                               <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00923"></a>00923 
<a name="l00930"></a>00930   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6ce0f02169af7e0f55924c488bb63ad8">write_parallel_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00931"></a>00931                             <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data) <span class="keyword">const</span>;
<a name="l00932"></a>00932   
<a name="l00937"></a>00937   std::string <a class="code" href="classlibMesh_1_1System.php#a4d4e901465589bb4d2f6a8ce19d4e2c5">get_info</a> () <span class="keyword">const</span>;
<a name="l00938"></a>00938 
<a name="l00942"></a>00942   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a69c99bee95fdfc5b9a38cac034861496">attach_init_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00943"></a>00943                                        <span class="keyword">const</span> std::string&amp; name));
<a name="l00944"></a>00944 
<a name="l00949"></a>00949   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#aac3c54815715309e41ba939db46dfff5">attach_init_object</a> (Initialization&amp; <a class="code" href="classlibMesh_1_1System.php#a9cbe27bf56eae7baea5c397fa88c09a3">init</a>);
<a name="l00950"></a>00950   
<a name="l00955"></a>00955   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a611b54551324acd1f072a1f809f5843a">attach_assemble_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00956"></a>00956                                            <span class="keyword">const</span> std::string&amp; name));
<a name="l00957"></a>00957   
<a name="l00962"></a>00962   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a0fc7da4a4654dea097846bb441fe16d8">attach_assemble_object</a> (Assembly&amp; <a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">assemble</a>);
<a name="l00963"></a>00963   
<a name="l00967"></a>00967   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a10381e68b0376de0772a5ba07982beba">attach_constraint_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00968"></a>00968                                              <span class="keyword">const</span> std::string&amp; name));
<a name="l00969"></a>00969   
<a name="l00973"></a>00973   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad341754f0468b7a1878a26d50c8726ae">attach_constraint_object</a> (Constraint&amp; constrain);
<a name="l00974"></a>00974   
<a name="l00979"></a>00979   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6471fddc304ce4a3de018b4fbf821135">attach_QOI_function</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00980"></a>00980                                       <span class="keyword">const</span> std::string&amp; name,
<a name="l00981"></a>00981                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices));
<a name="l00982"></a>00982   
<a name="l00987"></a>00987   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ad7b1c3e4b9aa3ef3a95c0939c3e1183b">attach_QOI_object</a> (QOI&amp; <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>); 
<a name="l00988"></a>00988 
<a name="l00994"></a>00994   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6674774a0f6eb6648a63901491cd1973">attach_QOI_derivative</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00995"></a>00995                                         <span class="keyword">const</span> std::string&amp; name,
<a name="l00996"></a>00996                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices));
<a name="l00997"></a>00997   
<a name="l01003"></a>01003   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#aed3ee567661a12b5282580e0a9cb8988">attach_QOI_derivative_object</a> (QOIDerivative&amp; qoi_derivative); 
<a name="l01004"></a>01004 
<a name="l01009"></a>01009   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a5f7a3a1e154fe61af97e966f3ab34ae2">user_initialization</a> ();
<a name="l01010"></a>01010   
<a name="l01015"></a>01015   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a792940ed6cca41b5dcaf878429a50253">user_assembly</a> ();
<a name="l01016"></a>01016   
<a name="l01021"></a>01021   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">user_constrain</a> ();
<a name="l01022"></a>01022 
<a name="l01027"></a>01027   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a3e75c1bd2055bb1bf9f5832a62c0039d">user_QOI</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l01028"></a>01028 
<a name="l01033"></a>01033   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab181e4e31e37f117493cc3d0f74d0f25">user_QOI_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l01034"></a>01034 
<a name="l01040"></a>01040   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a95f76b0ddbd8084a2a01a12495ebad2d">re_update</a> ();
<a name="l01041"></a>01041 
<a name="l01045"></a>01045   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a78af7f915ad5c678e3629ddced200967">restrict_vectors</a> ();
<a name="l01046"></a>01046 
<a name="l01050"></a>01050   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a55667d016781687feed399872671c963">prolong_vectors</a> ();
<a name="l01051"></a>01051 
<a name="l01057"></a>01057   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>* <a class="code" href="classlibMesh_1_1System.php#a039694a88131a6f186c1e19a985bcc44">get_mesh_system</a>() <span class="keyword">const</span>;
<a name="l01058"></a>01058 
<a name="l01063"></a>01063   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#adfdcfb87806718445a09dd3255379301">get_mesh_x_var</a>() <span class="keyword">const</span>;
<a name="l01064"></a>01064 
<a name="l01069"></a>01069   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a7ae8bd453e9335a699dc853e94d39a2e">get_mesh_y_var</a>() <span class="keyword">const</span>;
<a name="l01070"></a>01070 
<a name="l01075"></a>01075   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a643a7f15d85ed211a9cb46d73bcb60b3">get_mesh_z_var</a>() <span class="keyword">const</span>;
<a name="l01076"></a>01076 
<a name="l01096"></a><a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">01096</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>;
<a name="l01097"></a>01097 
<a name="l01107"></a><a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">01107</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>;
<a name="l01108"></a>01108   
<a name="l01122"></a><a class="code" href="classlibMesh_1_1System.php#a078ffa703ae75f9e2505b4177af2e530">01122</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a078ffa703ae75f9e2505b4177af2e530">extra_quadrature_order</a>;
<a name="l01123"></a>01123 
<a name="l01124"></a>01124 
<a name="l01125"></a>01125   <span class="comment">//--------------------------------------------------</span>
<a name="l01126"></a>01126   <span class="comment">// The solution and solution access members</span>
<a name="l01127"></a>01127   
<a name="l01132"></a>01132   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l01133"></a>01133 
<a name="l01137"></a><a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">01137</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01138"></a>01138 
<a name="l01149"></a><a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">01149</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>;
<a name="l01150"></a>01150 
<a name="l01160"></a><a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">01160</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">time</a>;
<a name="l01161"></a>01161 
<a name="l01168"></a><a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">01168</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>;
<a name="l01169"></a>01169 
<a name="l01184"></a>01184   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1System.php#af077a1b91c8b03020f2c6da41fcb72fb">point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l01185"></a>01185 
<a name="l01190"></a>01190   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1System.php#a4e07b8705c855e9537944dd9f35ffd30">point_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l01191"></a>01191 
<a name="l01196"></a>01196   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1System.php#a6ea18ca2d8af1292053329c6ced7c549">point_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l01197"></a>01197  
<a name="l01202"></a>01202   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a7184315a233256f4d8d0591d62b28f63">local_dof_indices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01203"></a>01203                           std::set&lt;unsigned int&gt; &amp; var_indices) <span class="keyword">const</span>;
<a name="l01204"></a>01204 
<a name="l01209"></a>01209   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1768b0db365db97ce4486167dca4efff">zero_variable</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num) <span class="keyword">const</span>;
<a name="l01210"></a>01210 
<a name="l01211"></a>01211 <span class="keyword">protected</span>:
<a name="l01212"></a>01212 
<a name="l01218"></a>01218   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">init_data</a> ();
<a name="l01219"></a>01219 
<a name="l01224"></a>01224   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l01225"></a>01225 
<a name="l01231"></a>01231   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;,
<a name="l01232"></a>01232                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l01233"></a>01233 
<a name="l01237"></a><a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">01237</a>   <a class="code" href="classlibMesh_1_1System.php">System</a> *<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a>;
<a name="l01238"></a>01238 
<a name="l01242"></a><a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">01242</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>, <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>, <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>;
<a name="l01243"></a>01243   
<a name="l01244"></a>01244 <span class="keyword">private</span>:
<a name="l01251"></a>01251   <a class="code" href="classlibMesh_1_1System.php#a7bd52dc210afb90d7304101d38a46357">System</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;);
<a name="l01252"></a>01252 
<a name="l01259"></a>01259   <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a454d9868ada86f3dbfb1bdd84971b626">operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;);
<a name="l01260"></a>01260 
<a name="l01265"></a>01265   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1System.php#a9118db90385450eddb5738ce2f9ebec0">discrete_var_norm</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; v,
<a name="l01266"></a>01266                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01267"></a>01267                           <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> norm_type) <span class="keyword">const</span>;
<a name="l01268"></a>01268 
<a name="l01274"></a>01274   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l01275"></a>01275   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a3656a2d9faf108f1e230912ea5635d4f">read_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01276"></a>01276                                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">n_objects</a>,
<a name="l01277"></a>01277                                                     <span class="keyword">const</span> iterator_type begin,
<a name="l01278"></a>01278                                                     <span class="keyword">const</span> iterator_type end,
<a name="l01279"></a>01279                                                     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l01280"></a>01280                                                     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l01281"></a>01281 
<a name="l01286"></a>01286   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9059cad1ef841d18f1804c4c2837d17e">read_SCALAR_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01287"></a>01287                                  <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l01288"></a>01288                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l01289"></a>01289 
<a name="l01294"></a>01294   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1abcba5d9ffb5edf18c138eb2a0214c1">read_serialized_vector</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l01295"></a>01295                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec);
<a name="l01296"></a>01296 
<a name="l01301"></a>01301   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l01302"></a>01302   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ad06d512307afb47317e3215c52150021">write_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l01303"></a>01303                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01304"></a>01304                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">n_objects</a>,
<a name="l01305"></a>01305                                                      <span class="keyword">const</span> iterator_type begin,
<a name="l01306"></a>01306                                                      <span class="keyword">const</span> iterator_type end,
<a name="l01307"></a>01307                                                      <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io) <span class="keyword">const</span>;
<a name="l01308"></a>01308 
<a name="l01312"></a>01312   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a25f805c53b81067c6460dad96d0eb8f6">write_SCALAR_dofs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l01313"></a>01313                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01314"></a>01314                                   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io) <span class="keyword">const</span>;
<a name="l01315"></a>01315 
<a name="l01320"></a>01320   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a477f8f5cd5acba2aa5af78affa76b955">write_serialized_vector</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l01321"></a>01321                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l01322"></a>01322 
<a name="l01326"></a><a class="code" href="classlibMesh_1_1System.php#afe15bce2e6df79b84fba25a827c42c85">01326</a>   void (* <a class="code" href="classlibMesh_1_1System.php#afe15bce2e6df79b84fba25a827c42c85">_init_system_function</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01327"></a>01327                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l01328"></a>01328 
<a name="l01332"></a><a class="code" href="classlibMesh_1_1System.php#a81cfbe1a4f87d9e7e6e784944279b38d">01332</a>   <a class="code" href="classlibMesh_1_1System_1_1Initialization.php">Initialization</a> * <a class="code" href="classlibMesh_1_1System.php#a81cfbe1a4f87d9e7e6e784944279b38d">_init_system_object</a>;
<a name="l01333"></a>01333 
<a name="l01337"></a><a class="code" href="classlibMesh_1_1System.php#a81c1888970a6f1b1582dbd7b23ea076a">01337</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a81c1888970a6f1b1582dbd7b23ea076a">_assemble_system_function</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l01338"></a>01338                                       <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l01339"></a>01339 
<a name="l01343"></a><a class="code" href="classlibMesh_1_1System.php#a259e042a0e9930ae697fac2be3479932">01343</a>   <a class="code" href="classlibMesh_1_1System_1_1Assembly.php">Assembly</a> * <a class="code" href="classlibMesh_1_1System.php#a259e042a0e9930ae697fac2be3479932">_assemble_system_object</a>;
<a name="l01344"></a>01344 
<a name="l01348"></a><a class="code" href="classlibMesh_1_1System.php#a153c867170e5e962def23d9df5dc1c1f">01348</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a153c867170e5e962def23d9df5dc1c1f">_constrain_system_function</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l01349"></a>01349                                        <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l01350"></a>01350 
<a name="l01354"></a><a class="code" href="classlibMesh_1_1System.php#a34a3dce9f1e27210362fd6299a321205">01354</a>   <a class="code" href="classlibMesh_1_1System_1_1Constraint.php">Constraint</a> * <a class="code" href="classlibMesh_1_1System.php#a34a3dce9f1e27210362fd6299a321205">_constrain_system_object</a>;
<a name="l01355"></a>01355 
<a name="l01359"></a><a class="code" href="classlibMesh_1_1System.php#a3c4ae20c873d77b245714f37f049d0cd">01359</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a3c4ae20c873d77b245714f37f049d0cd">_qoi_evaluate_function</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l01360"></a>01360                                    <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l01361"></a>01361                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l01362"></a>01362 
<a name="l01366"></a><a class="code" href="classlibMesh_1_1System.php#a681b7f4f93772852656e22913bd4da6c">01366</a>   <a class="code" href="classlibMesh_1_1System_1_1QOI.php">QOI</a> *<a class="code" href="classlibMesh_1_1System.php#a681b7f4f93772852656e22913bd4da6c">_qoi_evaluate_object</a>;
<a name="l01367"></a>01367 
<a name="l01371"></a><a class="code" href="classlibMesh_1_1System.php#a6519bb0ded6e98c17351bee48a3733de">01371</a>   void (* <a class="code" href="classlibMesh_1_1System.php#a6519bb0ded6e98c17351bee48a3733de">_qoi_evaluate_derivative_function</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es, 
<a name="l01372"></a>01372                                               <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l01373"></a>01373                                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices);
<a name="l01374"></a>01374 
<a name="l01378"></a><a class="code" href="classlibMesh_1_1System.php#a8157382573a7458d5852e0547eef55e6">01378</a>   <a class="code" href="classlibMesh_1_1System_1_1QOIDerivative.php">QOIDerivative</a> *<a class="code" href="classlibMesh_1_1System.php#a8157382573a7458d5852e0547eef55e6">_qoi_evaluate_derivative_object</a>;
<a name="l01379"></a>01379 
<a name="l01384"></a><a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">01384</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DofMap&gt;</a> <a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>;
<a name="l01385"></a>01385 
<a name="l01390"></a><a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">01390</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a99c9ba78a233464c052accdcbcc17153">_equation_systems</a>;
<a name="l01391"></a>01391   
<a name="l01396"></a><a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">01396</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">_mesh</a>;
<a name="l01397"></a>01397   
<a name="l01401"></a><a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">01401</a>   <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">_sys_name</a>;
<a name="l01402"></a>01402 
<a name="l01406"></a><a class="code" href="classlibMesh_1_1System.php#a1ea531a98e00c4ddbcc170529561d72e">01406</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a1ea531a98e00c4ddbcc170529561d72e">_sys_number</a>;
<a name="l01407"></a>01407   
<a name="l01411"></a><a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">01411</a>   std::vector&lt;Variable&gt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>;
<a name="l01412"></a>01412 
<a name="l01417"></a><a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">01417</a>   std::map&lt;std::string, unsigned short int&gt; <a class="code" href="classlibMesh_1_1System.php#aca4105a9e0b687784fa38b95bd999d80">_variable_numbers</a>;
<a name="l01418"></a>01418 
<a name="l01422"></a><a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">01422</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a>;
<a name="l01423"></a>01423   
<a name="l01430"></a><a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">01430</a>   std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>;
<a name="l01431"></a>01431 
<a name="l01436"></a><a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">01436</a>   std::map&lt;std::string, bool&gt; <a class="code" href="classlibMesh_1_1System.php#a96f148e01190c571cc92789fb5cd5ca4">_vector_projections</a>;
<a name="l01437"></a>01437 
<a name="l01441"></a><a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">01441</a>   std::map&lt;std::string, ParallelType&gt; <a class="code" href="classlibMesh_1_1System.php#a2623509811966d32d649c6c135f43c6c">_vector_types</a>;
<a name="l01442"></a>01442 
<a name="l01448"></a><a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">01448</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a711acee387038ac906783a0d39d8e840">_solution_projection</a>;
<a name="l01449"></a>01449 
<a name="l01453"></a><a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">01453</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#adc22ea07ed2a681eef304a471715cc85">_can_add_vectors</a>;
<a name="l01454"></a>01454 
<a name="l01460"></a><a class="code" href="classlibMesh_1_1System.php#a35519cd3073b5cdc687b8ca7ee60af98">01460</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a35519cd3073b5cdc687b8ca7ee60af98">_additional_data_written</a>;
<a name="l01461"></a>01461 
<a name="l01472"></a><a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">01472</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>;
<a name="l01473"></a>01473 
<a name="l01479"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php">01479</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php">ProjectVector</a> 
<a name="l01480"></a>01480   {
<a name="l01481"></a>01481   <span class="keyword">private</span>:
<a name="l01482"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">01482</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>                &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>;
<a name="l01483"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">01483</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>;
<a name="l01484"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#af68ee9baa1c1a8be5729898be236b063">01484</a>     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>       &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#af68ee9baa1c1a8be5729898be236b063">new_vector</a>;
<a name="l01485"></a>01485 
<a name="l01486"></a>01486   <span class="keyword">public</span>:
<a name="l01487"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a7a3c3ab89770051b52ed06d7552803be">01487</a>     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a7a3c3ab89770051b52ed06d7552803be">ProjectVector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system_in,
<a name="l01488"></a>01488                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;old_v_in,
<a name="l01489"></a>01489                    <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;new_v_in) :
<a name="l01490"></a>01490     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>(system_in),
<a name="l01491"></a>01491     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_v_in),
<a name="l01492"></a>01492     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#af68ee9baa1c1a8be5729898be236b063">new_vector</a>(new_v_in)
<a name="l01493"></a>01493     {}
<a name="l01494"></a>01494     
<a name="l01495"></a>01495     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l01496"></a>01496   };
<a name="l01497"></a>01497 
<a name="l01498"></a>01498 
<a name="l01508"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">01508</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">BuildProjectionList</a>
<a name="l01509"></a>01509   {
<a name="l01510"></a>01510   <span class="keyword">private</span>:
<a name="l01511"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">01511</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>              &amp;<a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>;
<a name="l01512"></a>01512 
<a name="l01513"></a>01513   <span class="keyword">public</span>:
<a name="l01514"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a87042251957ae12fa6934e0e41633d90">01514</a>     <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a87042251957ae12fa6934e0e41633d90">BuildProjectionList</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system_in) :
<a name="l01515"></a>01515       <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>(system_in),
<a name="l01516"></a>01516       <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a960cac38bbea936b05e469998f702d4d">send_list</a>()
<a name="l01517"></a>01517     {}
<a name="l01518"></a>01518 
<a name="l01519"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a38632ff4a8aeae23d7ebcf800893282e">01519</a>     <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a87042251957ae12fa6934e0e41633d90">BuildProjectionList</a> (<a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">BuildProjectionList</a> &amp;other, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a>) :
<a name="l01520"></a>01520       <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>(other.<a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a0c56ee775e16120d04ee8eced39d9d48">system</a>),
<a name="l01521"></a>01521       <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a960cac38bbea936b05e469998f702d4d">send_list</a>()
<a name="l01522"></a>01522     {}
<a name="l01523"></a>01523     
<a name="l01524"></a>01524     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a688346b5a79bda8d3e3bf33641669526">unique</a>();
<a name="l01525"></a>01525     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#aeeb6917d0ff898d305f19204b4cff572">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range);
<a name="l01526"></a>01526     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a1839efc2a5864e8af4762cde5258a7c2">join</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php">BuildProjectionList</a> &amp;other);
<a name="l01527"></a><a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a960cac38bbea936b05e469998f702d4d">01527</a>     std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a960cac38bbea936b05e469998f702d4d">send_list</a>;
<a name="l01528"></a>01528   };
<a name="l01529"></a>01529 
<a name="l01530"></a>01530 
<a name="l01531"></a>01531 
<a name="l01537"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php">01537</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php">ProjectSolution</a>
<a name="l01538"></a>01538   {
<a name="l01539"></a>01539   <span class="keyword">private</span>:
<a name="l01540"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a2e8457cb0939704390ce0d04d42bc6b7">01540</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>                &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a2e8457cb0939704390ce0d04d42bc6b7">system</a>;
<a name="l01541"></a>01541 
<a name="l01542"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#ae8735452c8c41d36a9893c0851009aec">01542</a>     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (* <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#ae8735452c8c41d36a9893c0851009aec">fptr</a>)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01543"></a>01543                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">parameters</a>,
<a name="l01544"></a>01544                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01545"></a>01545                     <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l01546"></a>01546 
<a name="l01547"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a4ae24673a50a860fd242cefce09af53d">01547</a>     <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> (* <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a4ae24673a50a860fd242cefce09af53d">gptr</a>)(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01548"></a>01548                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">parameters</a>,
<a name="l01549"></a>01549                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01550"></a>01550                       <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l01551"></a>01551 
<a name="l01552"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">01552</a>     <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a> &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a916a8e4cf3af5c242e2cef1bc4c589e4">parameters</a>;
<a name="l01553"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a728612268b8c23d87f0bee5e45ac65ae">01553</a>     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>       &amp;<a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a728612268b8c23d87f0bee5e45ac65ae">new_vector</a>;
<a name="l01554"></a>01554 
<a name="l01555"></a>01555   <span class="keyword">public</span>:
<a name="l01556"></a><a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a353d6f1d08d8e2802ea6430d2b58c9ac">01556</a>     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a353d6f1d08d8e2802ea6430d2b58c9ac">ProjectSolution</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system_in,
<a name="l01557"></a>01557                      <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr_in(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01558"></a>01558                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l01559"></a>01559                                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01560"></a>01560                                     <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l01561"></a>01561                      <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> gptr_in(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l01562"></a>01562                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l01563"></a>01563                                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l01564"></a>01564                                       <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l01565"></a>01565                      <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a> &amp;parameters_in,
<a name="l01566"></a>01566                      <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;new_v_in) :
<a name="l01567"></a>01567     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a2e8457cb0939704390ce0d04d42bc6b7">system</a>(system_in),
<a name="l01568"></a>01568     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#ae8735452c8c41d36a9893c0851009aec">fptr</a>(fptr_in),
<a name="l01569"></a>01569     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a4ae24673a50a860fd242cefce09af53d">gptr</a>(gptr_in),
<a name="l01570"></a>01570     parameters(parameters_in),
<a name="l01571"></a>01571     <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a728612268b8c23d87f0bee5e45ac65ae">new_vector</a>(new_v_in)
<a name="l01572"></a>01572     {}
<a name="l01573"></a>01573     
<a name="l01574"></a>01574     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectSolution.php#a91eb814c7a3e588b03b92b3a3c9af7a2">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l01575"></a>01575   };
<a name="l01576"></a>01576 };
<a name="l01577"></a>01577 
<a name="l01578"></a>01578 
<a name="l01579"></a>01579 
<a name="l01580"></a>01580 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01581"></a>01581 <span class="comment">// System inline methods</span>
<a name="l01582"></a>01582 <span class="keyword">inline</span>
<a name="l01583"></a><a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">01583</a> <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">System::name</a>()<span class="keyword"> const</span>
<a name="l01584"></a>01584 <span class="keyword"></span>{
<a name="l01585"></a>01585   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#aa6ed4b98503185caee2e333148b8f457">_sys_name</a>;
<a name="l01586"></a>01586 }
<a name="l01587"></a>01587 
<a name="l01588"></a>01588 
<a name="l01589"></a>01589 
<a name="l01590"></a>01590 <span class="keyword">inline</span>
<a name="l01591"></a><a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">01591</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">System::number</a>()<span class="keyword"> const</span>
<a name="l01592"></a>01592 <span class="keyword"></span>{
<a name="l01593"></a>01593   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a1ea531a98e00c4ddbcc170529561d72e">_sys_number</a>;
<a name="l01594"></a>01594 }
<a name="l01595"></a>01595 
<a name="l01596"></a>01596 
<a name="l01597"></a>01597 
<a name="l01598"></a>01598 <span class="keyword">inline</span>
<a name="l01599"></a><a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">01599</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">System::get_mesh</a>()<span class="keyword"> const</span>
<a name="l01600"></a>01600 <span class="keyword"></span>{
<a name="l01601"></a>01601   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">_mesh</a>;
<a name="l01602"></a>01602 }
<a name="l01603"></a>01603 
<a name="l01604"></a>01604 
<a name="l01605"></a>01605 
<a name="l01606"></a>01606 <span class="keyword">inline</span>
<a name="l01607"></a><a class="code" href="classlibMesh_1_1System.php#ad21ba8b25570465e1262a579566375ae">01607</a> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">System::get_mesh</a>()
<a name="l01608"></a>01608 {
<a name="l01609"></a>01609   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a6b1d416e0d9270f47499f7cdf3db3525">_mesh</a>;
<a name="l01610"></a>01610 }
<a name="l01611"></a>01611 
<a name="l01612"></a>01612 
<a name="l01613"></a>01613 
<a name="l01614"></a>01614 <span class="keyword">inline</span>
<a name="l01615"></a><a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">01615</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">System::get_dof_map</a>()<span class="keyword"> const</span>
<a name="l01616"></a>01616 <span class="keyword"></span>{
<a name="l01617"></a>01617   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>;
<a name="l01618"></a>01618 }
<a name="l01619"></a>01619 
<a name="l01620"></a>01620 
<a name="l01621"></a>01621 
<a name="l01622"></a>01622 <span class="keyword">inline</span>
<a name="l01623"></a><a class="code" href="classlibMesh_1_1System.php#a255709f85c1967d3670ec371048f20e7">01623</a> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">System::get_dof_map</a>()
<a name="l01624"></a>01624 {
<a name="l01625"></a>01625   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1System.php#a7386701e1324744b8d08db251374926b">_dof_map</a>;
<a name="l01626"></a>01626 }
<a name="l01627"></a>01627 
<a name="l01628"></a>01628 
<a name="l01629"></a>01629 
<a name="l01630"></a>01630 <span class="keyword">inline</span>
<a name="l01631"></a><a class="code" href="classlibMesh_1_1System.php#a0abd752d5ad75ea99581c65e0d5c2fb7">01631</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a0abd752d5ad75ea99581c65e0d5c2fb7">System::active</a>()<span class="keyword"> const</span>
<a name="l01632"></a>01632 <span class="keyword"></span>{
<a name="l01633"></a>01633   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a>;  
<a name="l01634"></a>01634 }
<a name="l01635"></a>01635 
<a name="l01636"></a>01636 
<a name="l01637"></a>01637 
<a name="l01638"></a>01638 <span class="keyword">inline</span>
<a name="l01639"></a><a class="code" href="classlibMesh_1_1System.php#a2caec05f9f5fbdeee0ed4a1245f5e150">01639</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2caec05f9f5fbdeee0ed4a1245f5e150">System::activate</a> ()
<a name="l01640"></a>01640 {
<a name="l01641"></a>01641   <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a> = <span class="keyword">true</span>;
<a name="l01642"></a>01642 }
<a name="l01643"></a>01643 
<a name="l01644"></a>01644 
<a name="l01645"></a>01645 
<a name="l01646"></a>01646 <span class="keyword">inline</span>
<a name="l01647"></a><a class="code" href="classlibMesh_1_1System.php#a9ba45875ecfb9f9151a014cadac8109c">01647</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a9ba45875ecfb9f9151a014cadac8109c">System::deactivate</a> ()
<a name="l01648"></a>01648 {
<a name="l01649"></a>01649   <a class="code" href="classlibMesh_1_1System.php#aee881365cfab1a56929cf344a34e9585">_active</a> = <span class="keyword">false</span>;
<a name="l01650"></a>01650 }
<a name="l01651"></a>01651 
<a name="l01652"></a>01652 
<a name="l01653"></a>01653 
<a name="l01654"></a>01654 <span class="keyword">inline</span>
<a name="l01655"></a><a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">01655</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">System::n_vars</a>()<span class="keyword"> const</span>
<a name="l01656"></a>01656 <span class="keyword"></span>{
<a name="l01657"></a>01657   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size();
<a name="l01658"></a>01658 }
<a name="l01659"></a>01659 
<a name="l01660"></a>01660 
<a name="l01661"></a>01661 
<a name="l01662"></a>01662 <span class="keyword">inline</span>
<a name="l01663"></a><a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">01663</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp; <a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">System::variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01664"></a>01664 <span class="keyword"></span>{
<a name="l01665"></a>01665   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size());
<a name="l01666"></a>01666 
<a name="l01667"></a>01667   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[i];
<a name="l01668"></a>01668 }
<a name="l01669"></a>01669 
<a name="l01670"></a>01670 
<a name="l01671"></a>01671 
<a name="l01672"></a>01672 <span class="keyword">inline</span>
<a name="l01673"></a><a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">01673</a> <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">System::variable_name</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01674"></a>01674 <span class="keyword"></span>{
<a name="l01675"></a>01675   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size());
<a name="l01676"></a>01676 
<a name="l01677"></a>01677   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[i].name();
<a name="l01678"></a>01678 }
<a name="l01679"></a>01679 
<a name="l01680"></a>01680 
<a name="l01681"></a>01681 
<a name="l01682"></a>01682 <span class="keyword">inline</span>
<a name="l01683"></a><a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">01683</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">System::variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01684"></a>01684 <span class="keyword"></span>{
<a name="l01685"></a>01685   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>.size());
<a name="l01686"></a>01686   
<a name="l01687"></a>01687   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[i].type();
<a name="l01688"></a>01688 }
<a name="l01689"></a>01689 
<a name="l01690"></a>01690 
<a name="l01691"></a>01691 
<a name="l01692"></a>01692 <span class="keyword">inline</span>
<a name="l01693"></a><a class="code" href="classlibMesh_1_1System.php#ae58688904ec53bf96a4a7ee2ffe6108d">01693</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">System::variable_type</a> (<span class="keyword">const</span> std::string&amp; var)<span class="keyword"> const</span>
<a name="l01694"></a>01694 <span class="keyword"></span>{
<a name="l01695"></a>01695   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a17fc76a7e9339dcc3c834a646169bf0e">_variables</a>[this-&gt;<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(var)].type();
<a name="l01696"></a>01696 }
<a name="l01697"></a>01697 
<a name="l01698"></a>01698 
<a name="l01699"></a>01699 
<a name="l01700"></a>01700 <span class="keyword">inline</span>
<a name="l01701"></a><a class="code" href="classlibMesh_1_1System.php#ab87249ec70609d4d3376b7705829fee0">01701</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ab87249ec70609d4d3376b7705829fee0">System::n_active_dofs</a>()<span class="keyword"> const</span>
<a name="l01702"></a>01702 <span class="keyword"></span>{
<a name="l01703"></a>01703   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>() - this-&gt;<a class="code" href="classlibMesh_1_1System.php#af44e0a3ba6dee841752b85b0c2b64854">n_constrained_dofs</a>();
<a name="l01704"></a>01704 }
<a name="l01705"></a>01705 
<a name="l01706"></a>01706 
<a name="l01707"></a>01707 
<a name="l01708"></a>01708 <span class="keyword">inline</span>
<a name="l01709"></a><a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">01709</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1System.php#a3d09f6a50bbf0d99489b88091d509a0f">System::have_vector</a> (<span class="keyword">const</span> std::string&amp; vec_name)<span class="keyword"> const</span>
<a name="l01710"></a>01710 <span class="keyword"></span>{
<a name="l01711"></a>01711   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.count(vec_name));
<a name="l01712"></a>01712 }
<a name="l01713"></a>01713 
<a name="l01714"></a>01714 
<a name="l01715"></a>01715 
<a name="l01716"></a>01716 <span class="keyword">inline</span>
<a name="l01717"></a><a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">01717</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">System::n_vectors</a> ()<span class="keyword"> const</span>
<a name="l01718"></a>01718 <span class="keyword"></span>{
<a name="l01719"></a>01719   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.size(); 
<a name="l01720"></a>01720 }
<a name="l01721"></a>01721 
<a name="l01722"></a>01722 <span class="keyword">inline</span>
<a name="l01723"></a><a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">01723</a> <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">System::vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">System::vectors_begin</a> ()
<a name="l01724"></a>01724 {
<a name="l01725"></a>01725   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01726"></a>01726 }
<a name="l01727"></a>01727 
<a name="l01728"></a>01728 <span class="keyword">inline</span>
<a name="l01729"></a><a class="code" href="classlibMesh_1_1System.php#a0394a0bff8e3746a49eed518cc8c00c8">01729</a> <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">System::const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">System::vectors_begin</a> ()<span class="keyword"> const</span>
<a name="l01730"></a>01730 <span class="keyword"></span>{
<a name="l01731"></a>01731   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01732"></a>01732 }
<a name="l01733"></a>01733 
<a name="l01734"></a>01734 <span class="keyword">inline</span>
<a name="l01735"></a><a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">01735</a> <a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">System::vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">System::vectors_end</a> ()
<a name="l01736"></a>01736 {
<a name="l01737"></a>01737   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end();
<a name="l01738"></a>01738 }
<a name="l01739"></a>01739 
<a name="l01740"></a>01740 <span class="keyword">inline</span>
<a name="l01741"></a><a class="code" href="classlibMesh_1_1System.php#acb796e766f91a826247574816d375407">01741</a> <a class="code" href="classlibMesh_1_1System.php#aa4c2b06e622c0a42bce85716cad92fbd">System::const_vectors_iterator</a> <a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">System::vectors_end</a> ()<span class="keyword"> const</span>
<a name="l01742"></a>01742 <span class="keyword"></span>{
<a name="l01743"></a>01743   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end();
<a name="l01744"></a>01744 }
<a name="l01745"></a>01745 
<a name="l01746"></a>01746 <span class="keyword">inline</span>
<a name="l01747"></a><a class="code" href="classlibMesh_1_1System.php#a1cc007b379ff2997715998c01106d790">01747</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1cc007b379ff2997715998c01106d790">System::assemble_residual_derivatives</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;)
<a name="l01748"></a>01748 {
<a name="l01749"></a>01749   libmesh_not_implemented();
<a name="l01750"></a>01750 }
<a name="l01751"></a>01751 
<a name="l01752"></a>01752 <span class="keyword">inline</span>
<a name="l01753"></a>01753 std::pair&lt;unsigned int, Real&gt;
<a name="l01754"></a><a class="code" href="classlibMesh_1_1System.php#a9dba69c2da2eff36d8c161d55ddcfb2c">01754</a> <a class="code" href="classlibMesh_1_1System.php#a9dba69c2da2eff36d8c161d55ddcfb2c">System::sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;)
<a name="l01755"></a>01755 {
<a name="l01756"></a>01756   libmesh_not_implemented();
<a name="l01757"></a>01757 }
<a name="l01758"></a>01758 
<a name="l01759"></a>01759 <span class="keyword">inline</span>
<a name="l01760"></a>01760 std::pair&lt;unsigned int, Real&gt;
<a name="l01761"></a><a class="code" href="classlibMesh_1_1System.php#a12a66f71be2f232f7136905559c1bbdb">01761</a> <a class="code" href="classlibMesh_1_1System.php#a12a66f71be2f232f7136905559c1bbdb">System::weighted_sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01762"></a>01762                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;)
<a name="l01763"></a>01763 {
<a name="l01764"></a>01764   libmesh_not_implemented();
<a name="l01765"></a>01765 }
<a name="l01766"></a>01766 
<a name="l01767"></a>01767 <span class="keyword">inline</span>
<a name="l01768"></a>01768 std::pair&lt;unsigned int, Real&gt;
<a name="l01769"></a><a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">01769</a> <a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">System::adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l01770"></a>01770 {
<a name="l01771"></a>01771   libmesh_not_implemented();
<a name="l01772"></a>01772 }
<a name="l01773"></a>01773 
<a name="l01774"></a>01774 <span class="keyword">inline</span>
<a name="l01775"></a>01775 std::pair&lt;unsigned int, Real&gt;
<a name="l01776"></a><a class="code" href="classlibMesh_1_1System.php#a79ae2650c56afe266ec27ee2fea57957">01776</a> <a class="code" href="classlibMesh_1_1System.php#a79ae2650c56afe266ec27ee2fea57957">System::weighted_sensitivity_adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01777"></a>01777                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01778"></a>01778                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l01779"></a>01779 {
<a name="l01780"></a>01780   libmesh_not_implemented();
<a name="l01781"></a>01781 }
<a name="l01782"></a>01782 
<a name="l01783"></a>01783 <span class="keyword">inline</span>
<a name="l01784"></a>01784 <span class="keywordtype">void</span>
<a name="l01785"></a><a class="code" href="classlibMesh_1_1System.php#a16e47d56606c347fbc996072f666c1b2">01785</a> <a class="code" href="classlibMesh_1_1System.php#a16e47d56606c347fbc996072f666c1b2">System::adjoint_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01786"></a>01786                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01787"></a>01787                                            <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01788"></a>01788 {
<a name="l01789"></a>01789   libmesh_not_implemented();
<a name="l01790"></a>01790 }
<a name="l01791"></a>01791 
<a name="l01792"></a>01792 <span class="keyword">inline</span>
<a name="l01793"></a>01793 <span class="keywordtype">void</span>
<a name="l01794"></a><a class="code" href="classlibMesh_1_1System.php#ab19259df51db305760418290ae5b2f57">01794</a> <a class="code" href="classlibMesh_1_1System.php#ab19259df51db305760418290ae5b2f57">System::forward_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01795"></a>01795                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01796"></a>01796                                            <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01797"></a>01797 {
<a name="l01798"></a>01798   libmesh_not_implemented();
<a name="l01799"></a>01799 }
<a name="l01800"></a>01800 
<a name="l01801"></a>01801 <span class="keyword">inline</span>
<a name="l01802"></a>01802 <span class="keywordtype">void</span>
<a name="l01803"></a><a class="code" href="classlibMesh_1_1System.php#a941661b0198ad8fe5f9d62cfc5f9a03b">01803</a> <a class="code" href="classlibMesh_1_1System.php#a941661b0198ad8fe5f9d62cfc5f9a03b">System::qoi_parameter_hessian</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01804"></a>01804                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01805"></a>01805                               <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01806"></a>01806 {
<a name="l01807"></a>01807   libmesh_not_implemented();
<a name="l01808"></a>01808 }
<a name="l01809"></a>01809 
<a name="l01810"></a>01810 <span class="keyword">inline</span>
<a name="l01811"></a>01811 <span class="keywordtype">void</span>
<a name="l01812"></a><a class="code" href="classlibMesh_1_1System.php#a24bec5dc18f42bc87ad135a06aada457">01812</a> <a class="code" href="classlibMesh_1_1System.php#a24bec5dc18f42bc87ad135a06aada457">System::qoi_parameter_hessian_vector_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;,
<a name="l01813"></a>01813                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01814"></a>01814                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp;,
<a name="l01815"></a>01815                                              <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;)
<a name="l01816"></a>01816 {
<a name="l01817"></a>01817   libmesh_not_implemented();
<a name="l01818"></a>01818 }
<a name="l01819"></a>01819 
<a name="l01820"></a>01820 <span class="keyword">inline</span>
<a name="l01821"></a><a class="code" href="classlibMesh_1_1System.php#a039694a88131a6f186c1e19a985bcc44">01821</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>* <a class="code" href="classlibMesh_1_1System.php#a039694a88131a6f186c1e19a985bcc44">System::get_mesh_system</a>()<span class="keyword"> const</span>
<a name="l01822"></a>01822 <span class="keyword"></span>{
<a name="l01823"></a>01823   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a>;
<a name="l01824"></a>01824 }
<a name="l01825"></a>01825 
<a name="l01826"></a>01826 <span class="keyword">inline</span>
<a name="l01827"></a><a class="code" href="classlibMesh_1_1System.php#adfdcfb87806718445a09dd3255379301">01827</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#adfdcfb87806718445a09dd3255379301">System::get_mesh_x_var</a>()<span class="keyword"> const</span>
<a name="l01828"></a>01828 <span class="keyword"></span>{
<a name="l01829"></a>01829   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>;
<a name="l01830"></a>01830 }
<a name="l01831"></a>01831 
<a name="l01832"></a>01832 <span class="keyword">inline</span>
<a name="l01833"></a><a class="code" href="classlibMesh_1_1System.php#a7ae8bd453e9335a699dc853e94d39a2e">01833</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a7ae8bd453e9335a699dc853e94d39a2e">System::get_mesh_y_var</a>()<span class="keyword"> const</span>
<a name="l01834"></a>01834 <span class="keyword"></span>{
<a name="l01835"></a>01835   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>;
<a name="l01836"></a>01836 }
<a name="l01837"></a>01837 
<a name="l01838"></a>01838 <span class="keyword">inline</span>
<a name="l01839"></a><a class="code" href="classlibMesh_1_1System.php#a643a7f15d85ed211a9cb46d73bcb60b3">01839</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a643a7f15d85ed211a9cb46d73bcb60b3">System::get_mesh_z_var</a>()<span class="keyword"> const</span>
<a name="l01840"></a>01840 <span class="keyword"></span>{
<a name="l01841"></a>01841   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>;
<a name="l01842"></a>01842 }
<a name="l01843"></a>01843 
<a name="l01844"></a>01844 } <span class="comment">// namespace libMesh</span>
<a name="l01845"></a>01845 
<a name="l01846"></a>01846 <span class="preprocessor">#endif // #define __system_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
