<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system_norm.h</div>  </div>
</div>
<div class="contents">
<a href="system__norm_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system_norm.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __system_norm_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __system_norm_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span> <span class="comment">// for Real</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__norm__type_8h.php">enum_norm_type.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// SystemNorm class definition</span>
<a name="l00050"></a><a class="code" href="classlibMesh_1_1SystemNorm.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053   
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>();
<a name="l00058"></a>00058   
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> &amp;t);
<a name="l00065"></a>00065   
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms);
<a name="l00074"></a>00074 
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms, std::vector&lt;Real&gt; &amp;weights);
<a name="l00083"></a>00083 
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms, std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;weights);
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;s);
<a name="l00097"></a>00097   
<a name="l00101"></a>00101   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">is_discrete</a>() <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00107"></a>00107   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">calculate_norm</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; v);
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">calculate_norm</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; v1, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; v2);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#ae6cce0dd5b1659cd55e4f8430ea1bb39">is_identity</a>();
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3950a2608908f1d3fcd314bb21086a4c">set_type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a>&amp; t);
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a83afcff574efcefe51268faecc4309f3">set_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w);
<a name="l00138"></a>00138 
<a name="l00142"></a>00142   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a984d4ab947b18f330db8454c0008ce80">set_off_diagonal_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w);
<a name="l00143"></a>00143 
<a name="l00148"></a>00148   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">private</span>:
<a name="l00153"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">00153</a>   std::vector&lt;FEMNormType&gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">00155</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>;
<a name="l00156"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">00156</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>;
<a name="l00157"></a>00157 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">00162</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>;
<a name="l00163"></a>00163 };
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00168"></a>00168 <span class="comment">// SystemNorm inline methods</span>
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="keyword">inline</span>
<a name="l00171"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">00171</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>() :
<a name="l00172"></a>00172     _norms(1, <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>), _weights(1, 1.0), _weights_sq(1, 1.0)
<a name="l00173"></a>00173 { 
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="keyword">inline</span>
<a name="l00178"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a7a5a596219683f300bff4dfaffe79b59">00178</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> &amp;t) :
<a name="l00179"></a>00179     _norms(1, t), _weights(1, 1.0), _weights_sq(1, 1.0)
<a name="l00180"></a>00180 { 
<a name="l00181"></a>00181 }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="keyword">inline</span>
<a name="l00185"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ad7e31883269c2fafae0d8b27ddcbff92">00185</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms) :
<a name="l00186"></a>00186     _norms(norms), _weights(1, 1.0), _weights_sq(1, 1.0)
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty())
<a name="l00189"></a>00189     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="keyword">inline</span>
<a name="l00194"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a30cdeef981035d452fd71ea37df2a7e6">00194</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms,
<a name="l00195"></a>00195                        std::vector&lt;Real&gt; &amp;weights) :
<a name="l00196"></a>00196     _norms(norms), _weights(weights), _weights_sq(_weights.size(), 0.0)
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty())
<a name="l00199"></a>00199     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty())
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.push_back(1.0);
<a name="l00204"></a>00204       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.push_back(1.0);
<a name="l00205"></a>00205     }
<a name="l00206"></a>00206   <span class="keywordflow">else</span>
<a name="l00207"></a>00207     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size(); ++i)
<a name="l00208"></a>00208       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[i] = <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] * <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i];
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">inline</span>
<a name="l00212"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a623beca772eef4a950ec3431508ac4e5">00212</a>   <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> std::vector&lt;FEMNormType&gt; &amp;norms,
<a name="l00213"></a>00213                          std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;weights):
<a name="l00214"></a>00214   _norms(norms), _weights(weights.size()), _off_diagonal_weights(weights)
<a name="l00215"></a>00215 {
<a name="l00216"></a>00216   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty())
<a name="l00217"></a>00217     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.push_back(<a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a>);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty())
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221       <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.push_back(1.0);
<a name="l00222"></a>00222       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.push_back(1.0);
<a name="l00223"></a>00223     }
<a name="l00224"></a>00224   <span class="keywordflow">else</span>
<a name="l00225"></a>00225     {
<a name="l00226"></a>00226       <span class="comment">// Loop over the entries of the user provided matrix and store its entries in </span>
<a name="l00227"></a>00227       <span class="comment">// the _off_diagonal_weights or _diagonal_weights</span>
<a name="l00228"></a>00228       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>.size(); ++i)
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230           <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i].size() &gt; i)
<a name="l00231"></a>00231             {
<a name="l00232"></a>00232               <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] = <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i][i];
<a name="l00233"></a>00233               <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i][i] = 0;
<a name="l00234"></a>00234             }
<a name="l00235"></a>00235           <span class="keywordflow">else</span>
<a name="l00236"></a>00236             <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] = 1.0;
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size(); ++i)
<a name="l00239"></a>00239         <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[i] = <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] * <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i];
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="keyword">inline</span>
<a name="l00244"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#aff7b5e7eaac2b842a90602e301b89b2e">00244</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ab075ea78340017a0c6686e85075aaff9">SystemNorm::SystemNorm</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;s) :
<a name="l00245"></a>00245     _norms(s._norms), _weights(s._weights), _weights_sq(s._weights_sq)
<a name="l00246"></a>00246 {
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="keyword">inline</span>
<a name="l00251"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">00251</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a31678e569cf9f6c1e4d13de2315b5d64">SystemNorm::is_discrete</a>()<span class="keyword"> const</span>
<a name="l00252"></a>00252 <span class="keyword"></span>{
<a name="l00253"></a>00253   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty());
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad5b9182056de3e279abd0e8120c1c774">DISCRETE_L1</a> ||
<a name="l00256"></a>00256       <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a482797897c042873f53453795347edb6">DISCRETE_L2</a> ||
<a name="l00257"></a>00257       <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[0] == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ae354be98c29a8529ca57555180313292">DISCRETE_L_INF</a>)
<a name="l00258"></a>00258     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="keyword">inline</span>
<a name="l00265"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">00265</a> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">SystemNorm::type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00266"></a>00266 <span class="keyword"></span>{
<a name="l00267"></a>00267   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty());
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = (var &lt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.size()) ? var : <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.size() - 1;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[i];
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="keyword">inline</span>
<a name="l00277"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a3950a2608908f1d3fcd314bb21086a4c">00277</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a3950a2608908f1d3fcd314bb21086a4c">SystemNorm::set_type</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a> &amp;t)
<a name="l00278"></a>00278 {
<a name="l00279"></a>00279   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.empty());
<a name="l00280"></a>00280   
<a name="l00281"></a>00281   <span class="keywordflow">if</span> (var &gt;= <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.size())
<a name="l00282"></a>00282     <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>.resize(var+1, t);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <a class="code" href="classlibMesh_1_1SystemNorm.php#a6123a2cd3b26d58f49e8b23940de09c5">_norms</a>[var] = t;
<a name="l00285"></a>00285 }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="keyword">inline</span>
<a name="l00289"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">00289</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">SystemNorm::weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00290"></a>00290 <span class="keyword"></span>{
<a name="l00291"></a>00291   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty());
<a name="l00292"></a>00292   
<a name="l00293"></a>00293   <span class="keywordflow">return</span> (var &lt; <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size()) ? <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[var] : 1.0;
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="keyword">inline</span>
<a name="l00298"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a83afcff574efcefe51268faecc4309f3">00298</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a83afcff574efcefe51268faecc4309f3">SystemNorm::set_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w)
<a name="l00299"></a>00299 {
<a name="l00300"></a>00300   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty());
<a name="l00301"></a>00301   
<a name="l00302"></a>00302   <span class="keywordflow">if</span> (var &gt;= <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size())
<a name="l00303"></a>00303     {
<a name="l00304"></a>00304       <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.resize(var+1, 1.0);
<a name="l00305"></a>00305       <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.resize(var+1, 1.0);
<a name="l00306"></a>00306     }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[var] = w;
<a name="l00309"></a>00309   <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[var] = w*w;
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 <span class="keyword">inline</span>
<a name="l00313"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a984d4ab947b18f330db8454c0008ce80">00313</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#a984d4ab947b18f330db8454c0008ce80">SystemNorm::set_off_diagonal_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.empty());
<a name="l00316"></a>00316   
<a name="l00317"></a>00317   <span class="keywordflow">if</span> (i &gt;= <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>.size())
<a name="l00318"></a>00318     {      
<a name="l00319"></a>00319       <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>.resize(i+1);      
<a name="l00320"></a>00320     }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="keywordflow">if</span> (j &gt;= <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i].size())
<a name="l00323"></a>00323     {
<a name="l00324"></a>00324       <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i].resize(j+1, 0.);
<a name="l00325"></a>00325     }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i][j] = w;
<a name="l00328"></a>00328   
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">inline</span>
<a name="l00333"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">00333</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">SystemNorm::weight_sq</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00334"></a>00334 <span class="keyword"></span>{
<a name="l00335"></a>00335   libmesh_assert (!<a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.empty());
<a name="l00336"></a>00336   
<a name="l00337"></a>00337   <span class="keywordflow">return</span> (var &lt; <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>.size()) ? <a class="code" href="classlibMesh_1_1SystemNorm.php#ad2d4cfa8bee893843d274f3c90534a1d">_weights_sq</a>[var] : 1.0;
<a name="l00338"></a>00338 }
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="keyword">inline</span>
<a name="l00342"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#a57e0f71ad53f1f163671587a90dd15f9">00342</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">SystemNorm::calculate_norm</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; v1, <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; v2) 
<a name="l00343"></a>00343 {
<a name="l00344"></a>00344   <span class="comment">// The vectors are assumed to both be vectors of the (same number</span>
<a name="l00345"></a>00345   <span class="comment">// of) components</span>
<a name="l00346"></a>00346   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vsize = v1.size();
<a name="l00347"></a>00347   libmesh_assert(vsize == v2.size());
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <span class="comment">// We&#39;ll support implicitly defining weights, but if the user sets</span>
<a name="l00350"></a>00350   <span class="comment">// more weights than he uses then something&#39;s probably wrong</span>
<a name="l00351"></a>00351   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> diagsize = this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size();
<a name="l00352"></a>00352   libmesh_assert(vsize &gt;= diagsize);
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// Initialize the variable val</span>
<a name="l00355"></a>00355   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = 0.;
<a name="l00356"></a>00356   
<a name="l00357"></a>00357   <span class="comment">// Loop over all the components of the system with explicit</span>
<a name="l00358"></a>00358   <span class="comment">// weights</span>
<a name="l00359"></a>00359   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != diagsize; i++)
<a name="l00360"></a>00360     {                           
<a name="l00361"></a>00361       val += this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] * v1[i] * v2[i];         
<a name="l00362"></a>00362     }
<a name="l00363"></a>00363   <span class="comment">// Loop over all the components of the system with implicit</span>
<a name="l00364"></a>00364   <span class="comment">// weights</span>
<a name="l00365"></a>00365   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = diagsize; i &lt; vsize; i++)
<a name="l00366"></a>00366     {                           
<a name="l00367"></a>00367       val += v1[i] * v2[i];             
<a name="l00368"></a>00368     }
<a name="l00369"></a>00369     
<a name="l00370"></a>00370   <span class="comment">// Loop over the components of the system</span>
<a name="l00371"></a>00371   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nrows = this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>.size();
<a name="l00372"></a>00372   libmesh_assert(vsize &lt;= nrows);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != nrows; i++)
<a name="l00375"></a>00375     {           
<a name="l00376"></a>00376       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncols = this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i].size();
<a name="l00377"></a>00377       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != ncols; j++)
<a name="l00378"></a>00378         {
<a name="l00379"></a>00379           <span class="comment">// Note that the diagonal weights here were set to zero</span>
<a name="l00380"></a>00380           <span class="comment">// in the constructor</span>
<a name="l00381"></a>00381           val += this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i][j] * v1[i] * v2[j];         
<a name="l00382"></a>00382         }
<a name="l00383"></a>00383     }
<a name="l00384"></a>00384     
<a name="l00385"></a>00385     <span class="keywordflow">return</span>(val);
<a name="l00386"></a>00386   }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="keyword">inline</span>
<a name="l00389"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">00389</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">SystemNorm::calculate_norm</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; v1) 
<a name="l00390"></a>00390 {
<a name="l00391"></a>00391   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">calculate_norm</a>(v1,v1);
<a name="l00392"></a>00392 }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 <span class="keyword">inline</span>
<a name="l00395"></a><a class="code" href="classlibMesh_1_1SystemNorm.php#ae6cce0dd5b1659cd55e4f8430ea1bb39">00395</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1SystemNorm.php#ae6cce0dd5b1659cd55e4f8430ea1bb39">SystemNorm::is_identity</a>()
<a name="l00396"></a>00396 {
<a name="l00397"></a>00397   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nrows = this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>.size();
<a name="l00398"></a>00398   
<a name="l00399"></a>00399   <span class="comment">// If any of the off-diagonal elements is not 0, then we are in the non-identity case</span>
<a name="l00400"></a>00400   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != nrows; i++)
<a name="l00401"></a>00401     {
<a name="l00402"></a>00402       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncols = this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i].size();
<a name="l00403"></a>00403       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != ncols; j++)
<a name="l00404"></a>00404         {
<a name="l00405"></a>00405           <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1SystemNorm.php#abdea33e684a32b331d2daf7ad43f6428">_off_diagonal_weights</a>[i][j] != 0)
<a name="l00406"></a>00406             {
<a name="l00407"></a>00407               <span class="keywordflow">return</span>(<span class="keyword">false</span>);
<a name="l00408"></a>00408             }
<a name="l00409"></a>00409         }
<a name="l00410"></a>00410     }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   <span class="comment">// If any of the diagonal elements is not 1, then we are in the non-identity case</span>
<a name="l00413"></a>00413   nrows = this-&gt;<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>.size();
<a name="l00414"></a>00414   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != nrows; i++)
<a name="l00415"></a>00415     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1SystemNorm.php#a938e26426c1694e34d558ec4c0beda57">_weights</a>[i] != 1)
<a name="l00416"></a>00416       <span class="keywordflow">return</span>(<span class="keyword">false</span>);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">// If all the off-diagonals elements are 0, and diagonal elements 1, then we are in an identity case</span>
<a name="l00419"></a>00419   <span class="keywordflow">return</span>(<span class="keyword">true</span>);
<a name="l00420"></a>00420 }
<a name="l00421"></a>00421         
<a name="l00422"></a>00422 } <span class="comment">// namespace libMesh</span>
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 <span class="preprocessor">#endif // #define __system_norm_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
