<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system_projection.C</div>  </div>
</div>
<div class="contents">
<a href="system__projection_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system_projection.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// System implementation</span>
<a name="l00046"></a>00046 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">System::project_vector</a> (NumericVector&lt;Number&gt;&amp; <a class="code" href="classstd_1_1vector.php">vector</a>)<span class="keyword"> const</span>
<a name="l00047"></a>00047 <span class="keyword"></span>{
<a name="l00048"></a>00048   <span class="comment">// Create a copy of the vector, which currently</span>
<a name="l00049"></a>00049   <span class="comment">// contains the old data.</span>
<a name="l00050"></a>00050   AutoPtr&lt;NumericVector&lt;Number&gt; &gt;
<a name="l00051"></a>00051     old_vector (vector.clone());
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">// Project the old vector to the new vector</span>
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a> (*old_vector, vector);
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00063"></a>00063 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">System::project_vector</a> (<span class="keyword">const</span> NumericVector&lt;Number&gt;&amp; old_v,
<a name="l00064"></a>00064                              NumericVector&lt;Number&gt;&amp; new_v)<span class="keyword"> const</span>
<a name="l00065"></a>00065 <span class="keyword"></span>{
<a name="l00066"></a>00066   START_LOG (<span class="stringliteral">&quot;project_vector()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00067"></a>00067 
<a name="l00074"></a>00074   new_v.clear();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078   <span class="comment">// Resize the new vector and get a serial version.</span>
<a name="l00079"></a>00079   NumericVector&lt;Number&gt; *new_vector_ptr = NULL;
<a name="l00080"></a>00080   AutoPtr&lt;NumericVector&lt;Number&gt; &gt; new_vector_built;
<a name="l00081"></a>00081   NumericVector&lt;Number&gt; *local_old_vector;
<a name="l00082"></a>00082   AutoPtr&lt;NumericVector&lt;Number&gt; &gt; local_old_vector_built;
<a name="l00083"></a>00083   <span class="keyword">const</span> NumericVector&lt;Number&gt; *old_vector_ptr = NULL;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> active_local_elem_range 
<a name="l00086"></a>00086     (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().active_local_elements_begin(),
<a name="l00087"></a>00087      this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().active_local_elements_end());
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// If the old vector was uniprocessor, make the new</span>
<a name="l00090"></a>00090   <span class="comment">// vector uniprocessor</span>
<a name="l00091"></a>00091   <span class="keywordflow">if</span> (old_v.type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       new_v.init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00094"></a>00094       new_vector_ptr = &amp;new_v;
<a name="l00095"></a>00095       old_vector_ptr = &amp;old_v;
<a name="l00096"></a>00096     }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">// Otherwise it is a parallel, distributed vector, which</span>
<a name="l00099"></a>00099   <span class="comment">// we need to localize.</span>
<a name="l00100"></a>00100   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (old_v.type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="comment">// Build a send list for efficient localization</span>
<a name="l00103"></a>00103       BuildProjectionList projection_list(*<span class="keyword">this</span>);
<a name="l00104"></a>00104       <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (active_local_elem_range, 
<a name="l00105"></a>00105                                 projection_list);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107       <span class="comment">// Create a sorted, unique send_list</span>
<a name="l00108"></a>00108       projection_list.unique();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110       new_v.init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00111"></a>00111       new_vector_built = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>();
<a name="l00112"></a>00112       local_old_vector_built = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>();
<a name="l00113"></a>00113       new_vector_ptr = new_vector_built.get();
<a name="l00114"></a>00114       local_old_vector = local_old_vector_built.get();
<a name="l00115"></a>00115       new_vector_ptr-&gt;init(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00116"></a>00116       local_old_vector-&gt;init(old_v.size(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00117"></a>00117       old_v.localize(*local_old_vector, projection_list.send_list);
<a name="l00118"></a>00118       local_old_vector-&gt;close();
<a name="l00119"></a>00119       old_vector_ptr = local_old_vector;
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (old_v.type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123       <span class="comment">// Build a send list for efficient localization</span>
<a name="l00124"></a>00124       BuildProjectionList projection_list(*<span class="keyword">this</span>);
<a name="l00125"></a>00125       <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (active_local_elem_range, 
<a name="l00126"></a>00126                                 projection_list);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128       <span class="comment">// Create a sorted, unique send_list</span>
<a name="l00129"></a>00129       projection_list.unique();
<a name="l00130"></a>00130 
<a name="l00131"></a>00131       new_v.init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00132"></a>00132                   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       local_old_vector_built = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>();
<a name="l00135"></a>00135       new_vector_ptr = &amp;new_v;
<a name="l00136"></a>00136       local_old_vector = local_old_vector_built.get();
<a name="l00137"></a>00137       local_old_vector-&gt;init(old_v.size(), old_v.local_size(),
<a name="l00138"></a>00138                              projection_list.send_list, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00139"></a>00139       old_v.localize(*local_old_vector, projection_list.send_list);
<a name="l00140"></a>00140       local_old_vector-&gt;close();
<a name="l00141"></a>00141       old_vector_ptr = local_old_vector;
<a name="l00142"></a>00142     }
<a name="l00143"></a>00143   <span class="keywordflow">else</span> <span class="comment">// unknown old_v.type()</span>
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown old_v.type() == &quot;</span> &lt;&lt; old_v.type() 
<a name="l00146"></a>00146                     &lt;&lt; std::endl;
<a name="l00147"></a>00147       libmesh_error();
<a name="l00148"></a>00148     }
<a name="l00149"></a>00149   
<a name="l00150"></a>00150   <span class="comment">// Note that the above will have zeroed the new_vector.</span>
<a name="l00151"></a>00151   <span class="comment">// Just to be sure, assert that new_vector_ptr and old_vector_ptr</span>
<a name="l00152"></a>00152   <span class="comment">// were successfully set before trying to deref them.</span>
<a name="l00153"></a>00153   libmesh_assert(new_vector_ptr);
<a name="l00154"></a>00154   libmesh_assert(old_vector_ptr);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   NumericVector&lt;Number&gt; &amp;new_vector = *new_vector_ptr;
<a name="l00157"></a>00157   <span class="keyword">const</span> NumericVector&lt;Number&gt; &amp;old_vector = *old_vector_ptr;
<a name="l00158"></a>00158     
<a name="l00159"></a>00159   <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">Threads::parallel_for</a> (active_local_elem_range,
<a name="l00160"></a>00160                          ProjectVector(*<span class="keyword">this</span>,
<a name="l00161"></a>00161                                        old_vector,
<a name="l00162"></a>00162                                        new_vector)
<a name="l00163"></a>00163                          );
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">// Copy the SCALAR dofs from old_vector to new_vector</span>
<a name="l00166"></a>00166   <span class="comment">// Note: We assume that all SCALAR dofs are on the</span>
<a name="l00167"></a>00167   <span class="comment">// processor with highest ID</span>
<a name="l00168"></a>00168   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l00169"></a>00169   {
<a name="l00170"></a>00170     <span class="keyword">const</span> DofMap&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00171"></a>00171     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00172"></a>00172       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00173"></a>00173         {
<a name="l00174"></a>00174           <span class="comment">// We can just map SCALAR dofs directly across</span>
<a name="l00175"></a>00175           std::vector&lt;unsigned int&gt; new_SCALAR_indices, old_SCALAR_indices;
<a name="l00176"></a>00176           dof_map.SCALAR_dof_indices (new_SCALAR_indices, var, <span class="keyword">false</span>);
<a name="l00177"></a>00177           dof_map.SCALAR_dof_indices (old_SCALAR_indices, var, <span class="keyword">true</span>);
<a name="l00178"></a>00178           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_n_dofs = new_SCALAR_indices.size();
<a name="l00179"></a>00179 
<a name="l00180"></a>00180           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;new_n_dofs; i++)
<a name="l00181"></a>00181           {
<a name="l00182"></a>00182             new_vector.set( new_SCALAR_indices[i], old_vector(old_SCALAR_indices[i]) );
<a name="l00183"></a>00183           }
<a name="l00184"></a>00184         }
<a name="l00185"></a>00185   }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   new_vector.close();
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">// If the old vector was serial, we probably need to send our values</span>
<a name="l00190"></a>00190   <span class="comment">// to other processors</span>
<a name="l00191"></a>00191   <span class="comment">//</span>
<a name="l00192"></a>00192   <span class="comment">// FIXME: I&#39;m not sure how to make a NumericVector do that without</span>
<a name="l00193"></a>00193   <span class="comment">// creating a temporary parallel vector to use localize! - RHS</span>
<a name="l00194"></a>00194   <span class="keywordflow">if</span> (old_v.type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196       AutoPtr&lt;NumericVector&lt;Number&gt; &gt; dist_v = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>();
<a name="l00197"></a>00197       dist_v-&gt;init(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00198"></a>00198       dist_v-&gt;close();
<a name="l00199"></a>00199     
<a name="l00200"></a>00200       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=dist_v-&gt;size(); i++)
<a name="l00201"></a>00201         <span class="keywordflow">if</span> (new_vector(i) != 0.0)
<a name="l00202"></a>00202           dist_v-&gt;set(i, new_vector(i));
<a name="l00203"></a>00203 
<a name="l00204"></a>00204       dist_v-&gt;close();
<a name="l00205"></a>00205 
<a name="l00206"></a>00206       dist_v-&gt;localize (new_v, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().get_send_list());
<a name="l00207"></a>00207       new_v.close();
<a name="l00208"></a>00208     }
<a name="l00209"></a>00209   <span class="comment">// If the old vector was parallel, we need to update it</span>
<a name="l00210"></a>00210   <span class="comment">// and free the localized copies</span>
<a name="l00211"></a>00211   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (old_v.type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00212"></a>00212     {
<a name="l00213"></a>00213       <span class="comment">// We may have to set dof values that this processor doesn&#39;t</span>
<a name="l00214"></a>00214       <span class="comment">// own in certain special cases, like LAGRANGE FIRST or</span>
<a name="l00215"></a>00215       <span class="comment">// HERMITE THIRD elements on second-order meshes</span>
<a name="l00216"></a>00216       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=new_v.size(); i++)
<a name="l00217"></a>00217         <span class="keywordflow">if</span> (new_vector(i) != 0.0)
<a name="l00218"></a>00218           new_v.set(i, new_vector(i));
<a name="l00219"></a>00219       new_v.close();
<a name="l00220"></a>00220     }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().enforce_constraints_exactly(*<span class="keyword">this</span>, &amp;new_v);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 <span class="preprocessor">#else</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>
<a name="l00226"></a>00226   <span class="comment">// AMR is disabled: simply copy the vector</span>
<a name="l00227"></a>00227   new_v = old_v;
<a name="l00228"></a>00228   
<a name="l00229"></a>00229 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>
<a name="l00231"></a>00231   STOP_LOG(<span class="stringliteral">&quot;project_vector()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00240"></a>00240 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a2cf57ff5d137c7be896b2e1442e9916b">System::project_solution</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> Point&amp; p,
<a name="l00241"></a>00241                                            <span class="keyword">const</span> Parameters&amp; parameters,
<a name="l00242"></a>00242                                            <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00243"></a>00243                                            <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00244"></a>00244                                <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gptr(<span class="keyword">const</span> Point&amp; p,
<a name="l00245"></a>00245                                              <span class="keyword">const</span> Parameters&amp; parameters,
<a name="l00246"></a>00246                                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00247"></a>00247                                              <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00248"></a>00248                                Parameters&amp; parameters)<span class="keyword"> const</span>
<a name="l00249"></a>00249 <span class="keyword"></span>{
<a name="l00250"></a>00250   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">project_vector</a>(fptr, gptr, parameters, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize(*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>);
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00261"></a>00261 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ac31376d8fbe17c9f3a341d0a599a98c1">System::project_vector</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> Point&amp; p,
<a name="l00262"></a>00262                                          <span class="keyword">const</span> Parameters&amp; parameters,
<a name="l00263"></a>00263                                          <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00264"></a>00264                                          <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00265"></a>00265                              <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gptr(<span class="keyword">const</span> Point&amp; p,
<a name="l00266"></a>00266                                            <span class="keyword">const</span> Parameters&amp; parameters,
<a name="l00267"></a>00267                                            <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00268"></a>00268                                            <span class="keyword">const</span> std::string&amp; unknown_name),
<a name="l00269"></a>00269                              Parameters&amp; parameters,
<a name="l00270"></a>00270                              NumericVector&lt;Number&gt;&amp; new_vector)<span class="keyword"> const</span>
<a name="l00271"></a>00271 <span class="keyword"></span>{
<a name="l00272"></a>00272   START_LOG (<span class="stringliteral">&quot;project_vector()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">Threads::parallel_for</a> (<a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().active_local_elements_begin(),
<a name="l00275"></a>00275                                          this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().active_local_elements_end(),
<a name="l00276"></a>00276                                          1000),
<a name="l00277"></a>00277                          ProjectSolution(*<span class="keyword">this</span>,
<a name="l00278"></a>00278                                          fptr,
<a name="l00279"></a>00279                                          gptr,
<a name="l00280"></a>00280                                          parameters,
<a name="l00281"></a>00281                                          new_vector)
<a name="l00282"></a>00282                          );
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="comment">// Also, load values into the SCALAR dofs</span>
<a name="l00285"></a>00285   <span class="comment">// Note: We assume that all SCALAR dofs are on the</span>
<a name="l00286"></a>00286   <span class="comment">// processor with highest ID</span>
<a name="l00287"></a>00287   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l00288"></a>00288   {
<a name="l00289"></a>00289     <span class="keyword">const</span> DofMap&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00290"></a>00290     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l00291"></a>00291       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293           std::vector&lt;unsigned int&gt; SCALAR_indices;
<a name="l00294"></a>00294           dof_map.SCALAR_dof_indices (SCALAR_indices, var);
<a name="l00295"></a>00295           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_SCALAR_dofs = SCALAR_indices.size();
<a name="l00296"></a>00296 
<a name="l00297"></a>00297           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_SCALAR_dofs; i++)
<a name="l00298"></a>00298           {
<a name="l00299"></a>00299             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = SCALAR_indices[i];
<a name="l00300"></a>00300 
<a name="l00301"></a>00301             <span class="comment">// We pass the point (i,0,0) to the fptr to distinguish</span>
<a name="l00302"></a>00302             <span class="comment">// the different scalars within the SCALAR variable</span>
<a name="l00303"></a>00303             Point p_i(i,0,0);
<a name="l00304"></a>00304             new_vector.set( index, fptr(p_i,
<a name="l00305"></a>00305                                         parameters,
<a name="l00306"></a>00306                                         this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>(),
<a name="l00307"></a>00307                                         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var))
<a name="l00308"></a>00308                           );
<a name="l00309"></a>00309           }
<a name="l00310"></a>00310         }
<a name="l00311"></a>00311   }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   new_vector.close();
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().enforce_constraints_exactly(*<span class="keyword">this</span>, &amp;new_vector);
<a name="l00317"></a>00317 <span class="preprocessor">#endif</span>
<a name="l00318"></a>00318 <span class="preprocessor"></span>
<a name="l00319"></a>00319   STOP_LOG(<span class="stringliteral">&quot;project_vector()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 <span class="preprocessor">#ifndef LIBMESH_ENABLE_AMR</span>
<a name="l00324"></a>00324 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">System::ProjectVector::operator()</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> &amp;)<span class="keyword"> const</span>
<a name="l00325"></a>00325 <span class="keyword"></span>{
<a name="l00326"></a>00326   libmesh_error();
<a name="l00327"></a>00327 <span class="preprocessor">#else</span>
<a name="l00328"></a>00328 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">System::ProjectVector::operator()</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00329"></a>00329 <span class="keyword"></span>{
<a name="l00330"></a>00330   START_LOG (<span class="stringliteral">&quot;operator()&quot;</span>,<span class="stringliteral">&quot;ProjectVector&quot;</span>);
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   <span class="comment">// A vector for Lagrange element interpolation, indicating if we</span>
<a name="l00333"></a>00333   <span class="comment">// have visited a DOF yet.  Note that this is thread-local storage,</span>
<a name="l00334"></a>00334   <span class="comment">// hence shared DOFS that live on thread boundaries may be doubly</span>
<a name="l00335"></a>00335   <span class="comment">// computed.  It is expected that this will be more efficient</span>
<a name="l00336"></a>00336   <span class="comment">// than locking a thread-global version of already_done, though.</span>
<a name="l00337"></a>00337   <span class="comment">//</span>
<a name="l00338"></a>00338   <span class="comment">// FIXME: we should use this for non-Lagrange coarsening, too</span>
<a name="l00339"></a>00339   std::vector&lt;bool&gt; already_done (<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.n_dofs(), <span class="keyword">false</span>);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// The number of variables in this system</span>
<a name="l00342"></a>00342   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_variables = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.n_vars();
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// The dimensionality of the current mesh</span>
<a name="l00345"></a>00345   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.get_mesh().mesh_dimension();
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="comment">// The DofMap for this system</span>
<a name="l00348"></a>00348   <span class="keyword">const</span> DofMap&amp; dof_map = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.get_dof_map();
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="comment">// The element matrix and RHS for projections.</span>
<a name="l00351"></a>00351   <span class="comment">// Note that Ke is always real-valued, whereas</span>
<a name="l00352"></a>00352   <span class="comment">// Fe may be complex valued if complex number</span>
<a name="l00353"></a>00353   <span class="comment">// support is enabled</span>
<a name="l00354"></a>00354   DenseMatrix&lt;Real&gt; Ke;
<a name="l00355"></a>00355   DenseVector&lt;Number&gt; Fe;
<a name="l00356"></a>00356   <span class="comment">// The new element coefficients</span>
<a name="l00357"></a>00357   DenseVector&lt;Number&gt; Ue;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00361"></a>00361   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_variables; var++)
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363       <span class="keyword">const</span> Variable&amp; <a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a> = dof_map.variable(var);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365       <span class="keyword">const</span> FEType&amp; base_fe_type = variable.type();     
<a name="l00366"></a>00366 
<a name="l00367"></a>00367       <span class="keywordflow">if</span> (base_fe_type.family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00368"></a>00368         <span class="keywordflow">continue</span>;
<a name="l00369"></a>00369 
<a name="l00370"></a>00370       <span class="comment">// Get FE objects of the appropriate type</span>
<a name="l00371"></a>00371       AutoPtr&lt;FEBase&gt; fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, base_fe_type));      
<a name="l00372"></a>00372       AutoPtr&lt;FEBase&gt; fe_coarse (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, base_fe_type));      
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="comment">// Create FE objects with potentially different p_level</span>
<a name="l00375"></a>00375       FEType fe_type, temp_fe_type;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <span class="comment">// Prepare variables for non-Lagrange projection</span>
<a name="l00378"></a>00378       AutoPtr&lt;QBase&gt; qrule     (base_fe_type.default_quadrature_rule(dim));
<a name="l00379"></a>00379       AutoPtr&lt;QBase&gt; qedgerule (base_fe_type.default_quadrature_rule(1));
<a name="l00380"></a>00380       AutoPtr&lt;QBase&gt; qsiderule (base_fe_type.default_quadrature_rule(dim-1));
<a name="l00381"></a>00381       std::vector&lt;Point&gt; coarse_qpoints;
<a name="l00382"></a>00382 
<a name="l00383"></a>00383       <span class="comment">// The values of the shape functions at the quadrature</span>
<a name="l00384"></a>00384       <span class="comment">// points</span>
<a name="l00385"></a>00385       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi_values =
<a name="l00386"></a>00386         fe-&gt;get_phi();
<a name="l00387"></a>00387       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi_coarse =
<a name="l00388"></a>00388         fe_coarse-&gt;get_phi();
<a name="l00389"></a>00389 
<a name="l00390"></a>00390       <span class="comment">// The gradients of the shape functions at the quadrature</span>
<a name="l00391"></a>00391       <span class="comment">// points on the child element.</span>
<a name="l00392"></a>00392       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi_values =
<a name="l00393"></a>00393         NULL;
<a name="l00394"></a>00394       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi_coarse =
<a name="l00395"></a>00395         NULL;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = fe-&gt;get_continuity();
<a name="l00398"></a>00398 
<a name="l00399"></a>00399       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00400"></a>00400         {
<a name="l00401"></a>00401           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp;
<a name="l00402"></a>00402             ref_dphi_values = fe-&gt;get_dphi();
<a name="l00403"></a>00403           dphi_values = &amp;ref_dphi_values;
<a name="l00404"></a>00404           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp;
<a name="l00405"></a>00405             ref_dphi_coarse = fe_coarse-&gt;get_dphi();
<a name="l00406"></a>00406           dphi_coarse = &amp;ref_dphi_coarse;
<a name="l00407"></a>00407         }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409       <span class="comment">// The Jacobian * quadrature weight at the quadrature points</span>
<a name="l00410"></a>00410       <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; JxW =
<a name="l00411"></a>00411         fe-&gt;get_JxW();
<a name="l00412"></a>00412      
<a name="l00413"></a>00413       <span class="comment">// The XYZ locations of the quadrature points on the</span>
<a name="l00414"></a>00414       <span class="comment">// child element</span>
<a name="l00415"></a>00415       <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; xyz_values =
<a name="l00416"></a>00416         fe-&gt;get_xyz();
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419       <span class="comment">// The global DOF indices</span>
<a name="l00420"></a>00420       std::vector&lt;unsigned int&gt; new_dof_indices, old_dof_indices;
<a name="l00421"></a>00421       <span class="comment">// Side/edge DOF indices</span>
<a name="l00422"></a>00422       std::vector&lt;unsigned int&gt; new_side_dofs, old_side_dofs;
<a name="l00423"></a>00423    
<a name="l00424"></a>00424       <span class="comment">// Iterate over the elements in the range</span>
<a name="l00425"></a>00425       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> elem_it=range.begin(); elem_it != range.end(); ++elem_it)
<a name="l00426"></a>00426         {
<a name="l00427"></a>00427           <span class="keyword">const</span> Elem* elem = *elem_it;
<a name="l00428"></a>00428           <span class="comment">// If this element doesn&#39;t have an old_dof_object with dofs for the</span>
<a name="l00429"></a>00429           <span class="comment">// current system, then it must be newly added, so the user</span>
<a name="l00430"></a>00430           <span class="comment">// is responsible for setting the new dofs.</span>
<a name="l00431"></a>00431 
<a name="l00432"></a>00432           <span class="comment">// ... but we need a better way to test for that; the code</span>
<a name="l00433"></a>00433           <span class="comment">// below breaks on any FE type for which the elem stores no</span>
<a name="l00434"></a>00434           <span class="comment">// dofs.</span>
<a name="l00435"></a>00435           <span class="comment">// if (!elem-&gt;old_dof_object || !elem-&gt;old_dof_object-&gt;has_dofs(system.number()))</span>
<a name="l00436"></a>00436           <span class="comment">//  continue;</span>
<a name="l00437"></a>00437           <span class="keyword">const</span> Elem* parent = elem-&gt;parent();
<a name="l00438"></a>00438 
<a name="l00439"></a>00439           <span class="comment">// Per-subdomain variables don&#39;t need to be projected on</span>
<a name="l00440"></a>00440           <span class="comment">// elements where they&#39;re not active</span>
<a name="l00441"></a>00441           <span class="keywordflow">if</span> (!variable.active_on_subdomain(elem-&gt;subdomain_id()))
<a name="l00442"></a>00442             <span class="keywordflow">continue</span>;
<a name="l00443"></a>00443 
<a name="l00444"></a>00444           <span class="comment">// Adjust the FE type for p-refined elements</span>
<a name="l00445"></a>00445           fe_type = base_fe_type;
<a name="l00446"></a>00446           fe_type.order = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.order +
<a name="l00447"></a>00447                                              elem-&gt;p_level());
<a name="l00448"></a>00448 
<a name="l00449"></a>00449           <span class="comment">// We may need to remember the parent&#39;s p_level</span>
<a name="l00450"></a>00450           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_parent_level = 0;
<a name="l00451"></a>00451 
<a name="l00452"></a>00452           <span class="comment">// Update the DOF indices for this element based on</span>
<a name="l00453"></a>00453           <span class="comment">// the new mesh</span>
<a name="l00454"></a>00454           dof_map.dof_indices (elem, new_dof_indices, var);
<a name="l00455"></a>00455 
<a name="l00456"></a>00456           <span class="comment">// The number of DOFs on the new element</span>
<a name="l00457"></a>00457           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_n_dofs = new_dof_indices.size();
<a name="l00458"></a>00458 
<a name="l00459"></a>00459           <span class="comment">// Fixed vs. free DoFs on edge/face projections</span>
<a name="l00460"></a>00460           std::vector&lt;char&gt; dof_is_fixed(new_n_dofs, <span class="keyword">false</span>); <span class="comment">// bools</span>
<a name="l00461"></a>00461           std::vector&lt;int&gt; free_dof(new_n_dofs, 0);
<a name="l00462"></a>00462 
<a name="l00463"></a>00463           <span class="comment">// The element type</span>
<a name="l00464"></a>00464           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> elem_type = elem-&gt;type();
<a name="l00465"></a>00465 
<a name="l00466"></a>00466           <span class="comment">// The number of nodes on the new element</span>
<a name="l00467"></a>00467           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;n_nodes();
<a name="l00468"></a>00468 
<a name="l00469"></a>00469           <span class="comment">// Zero the interpolated values</span>
<a name="l00470"></a>00470           Ue.resize (new_n_dofs); Ue.zero();
<a name="l00471"></a>00471 
<a name="l00472"></a>00472           <span class="comment">// Update the DOF indices based on the old mesh.</span>
<a name="l00473"></a>00473           <span class="comment">// This is done in one of three ways:</span>
<a name="l00474"></a>00474           <span class="comment">// 1.) If the child was just refined then it was not</span>
<a name="l00475"></a>00475           <span class="comment">//     active in the previous mesh &amp; hence has no solution</span>
<a name="l00476"></a>00476           <span class="comment">//     values on it.  In this case simply project or</span>
<a name="l00477"></a>00477           <span class="comment">//     interpolate the solution from the parent, who was</span>
<a name="l00478"></a>00478           <span class="comment">//     active in the previous mesh</span>
<a name="l00479"></a>00479           <span class="comment">// 2.) If the child was just coarsened, obtaining a</span>
<a name="l00480"></a>00480           <span class="comment">//     well-defined solution may require doing independent</span>
<a name="l00481"></a>00481           <span class="comment">//     projections on nodes, edges, faces, and interiors</span>
<a name="l00482"></a>00482           <span class="comment">// 3.) If the child was active in the previous</span>
<a name="l00483"></a>00483           <span class="comment">//     mesh, we can just copy coefficients directly</span>
<a name="l00484"></a>00484           <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00485"></a>00485             {
<a name="l00486"></a>00486               libmesh_assert (parent != NULL);
<a name="l00487"></a>00487               old_parent_level = parent-&gt;p_level();
<a name="l00488"></a>00488 
<a name="l00489"></a>00489               <span class="comment">// We may have done p refinement or coarsening as well;</span>
<a name="l00490"></a>00490               <span class="comment">// if so then we need to reset the parent&#39;s p level</span>
<a name="l00491"></a>00491               <span class="comment">// so we can get the right DoFs from it</span>
<a name="l00492"></a>00492               <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00493"></a>00493                 {
<a name="l00494"></a>00494                   libmesh_assert(elem-&gt;p_level() &gt; 0);
<a name="l00495"></a>00495                   (<span class="keyword">const_cast&lt;</span>Elem *<span class="keyword">&gt;</span>(parent))-&gt;hack_p_level(elem-&gt;p_level() - 1);
<a name="l00496"></a>00496                 }
<a name="l00497"></a>00497               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00498"></a>00498                 {
<a name="l00499"></a>00499                   (<span class="keyword">const_cast&lt;</span>Elem *<span class="keyword">&gt;</span>(parent))-&gt;hack_p_level(elem-&gt;p_level() + 1);
<a name="l00500"></a>00500                 }
<a name="l00501"></a>00501          
<a name="l00502"></a>00502               dof_map.old_dof_indices (parent, old_dof_indices, var);
<a name="l00503"></a>00503             }
<a name="l00504"></a>00504           <span class="keywordflow">else</span>
<a name="l00505"></a>00505             {
<a name="l00506"></a>00506               dof_map.old_dof_indices (elem, old_dof_indices, var);
<a name="l00507"></a>00507 
<a name="l00508"></a>00508               <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>)
<a name="l00509"></a>00509                 libmesh_assert (old_dof_indices.size() == new_n_dofs);
<a name="l00510"></a>00510               <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00511"></a>00511                 libmesh_assert (elem-&gt;has_children());
<a name="l00512"></a>00512             }
<a name="l00513"></a>00513 
<a name="l00514"></a>00514           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_n_dofs = old_dof_indices.size();
<a name="l00515"></a>00515 
<a name="l00516"></a>00516           <span class="keywordflow">if</span> (fe_type.family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>) {
<a name="l00517"></a>00517 
<a name="l00518"></a>00518             <span class="comment">// For refined non-Lagrange elements, we do an L2</span>
<a name="l00519"></a>00519             <span class="comment">// projection</span>
<a name="l00520"></a>00520             <span class="comment">// FIXME: this will be a suboptimal and ill-defined</span>
<a name="l00521"></a>00521             <span class="comment">// result if we&#39;re using non-nested finite element</span>
<a name="l00522"></a>00522             <span class="comment">// spaces or if we&#39;re on a p-coarsened element!</span>
<a name="l00523"></a>00523             <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00524"></a>00524               {
<a name="l00525"></a>00525                 <span class="comment">// Update the fe object based on the current child</span>
<a name="l00526"></a>00526                 fe-&gt;attach_quadrature_rule (qrule.get());
<a name="l00527"></a>00527                 fe-&gt;reinit (elem);
<a name="l00528"></a>00528           
<a name="l00529"></a>00529                 <span class="comment">// The number of quadrature points on the child</span>
<a name="l00530"></a>00530                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l00531"></a>00531 
<a name="l00532"></a>00532                 <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, fe_type, parent,
<a name="l00533"></a>00533                                           xyz_values, coarse_qpoints);
<a name="l00534"></a>00534 
<a name="l00535"></a>00535                 fe_coarse-&gt;reinit(parent, &amp;coarse_qpoints);
<a name="l00536"></a>00536 
<a name="l00537"></a>00537                 <span class="comment">// Reinitialize the element matrix and vector for</span>
<a name="l00538"></a>00538                 <span class="comment">// the current element.  Note that this will zero them</span>
<a name="l00539"></a>00539                 <span class="comment">// before they are summed.</span>
<a name="l00540"></a>00540                 Ke.resize (new_n_dofs, new_n_dofs); Ke.zero();
<a name="l00541"></a>00541                 Fe.resize (new_n_dofs); Fe.zero();
<a name="l00542"></a>00542           
<a name="l00543"></a>00543           
<a name="l00544"></a>00544                 <span class="comment">// Loop over the quadrature points</span>
<a name="l00545"></a>00545                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00546"></a>00546                   {
<a name="l00547"></a>00547                     <span class="comment">// The solution value at the quadrature point             </span>
<a name="l00548"></a>00548                     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550                     <span class="comment">// Sum the function values * the DOF values</span>
<a name="l00551"></a>00551                     <span class="comment">// at the point of interest to get the function value</span>
<a name="l00552"></a>00552                     <span class="comment">// (Note that the # of DOFs on the parent need not be the</span>
<a name="l00553"></a>00553                     <span class="comment">//  same as on the child!)</span>
<a name="l00554"></a>00554                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;old_n_dofs; i++)
<a name="l00555"></a>00555                       {
<a name="l00556"></a>00556                         val += (<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_dof_indices[i])*
<a name="l00557"></a>00557                                 phi_coarse[i][qp]);
<a name="l00558"></a>00558                       }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560                     <span class="comment">// Now \p val contains the solution value of variable</span>
<a name="l00561"></a>00561                     <span class="comment">// \p var at the qp&#39;th quadrature point on the child</span>
<a name="l00562"></a>00562                     <span class="comment">// element.  It has been interpolated from the parent</span>
<a name="l00563"></a>00563                     <span class="comment">// in case the child was just refined.  Next we will</span>
<a name="l00564"></a>00564                     <span class="comment">// construct the L2-projection matrix for the element.</span>
<a name="l00565"></a>00565 
<a name="l00566"></a>00566                     <span class="comment">// Construct the Mass Matrix</span>
<a name="l00567"></a>00567                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;new_n_dofs; i++)
<a name="l00568"></a>00568                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;new_n_dofs; j++)
<a name="l00569"></a>00569                         Ke(i,j) += JxW[qp]*phi_values[i][qp]*phi_values[j][qp];
<a name="l00570"></a>00570 
<a name="l00571"></a>00571                     <span class="comment">// Construct the RHS</span>
<a name="l00572"></a>00572                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;new_n_dofs; i++)
<a name="l00573"></a>00573                       Fe(i) += JxW[qp]*phi_values[i][qp]*val;
<a name="l00574"></a>00574               
<a name="l00575"></a>00575                   } <span class="comment">// end qp loop</span>
<a name="l00576"></a>00576 
<a name="l00577"></a>00577                 Ke.cholesky_solve(Fe, Ue);
<a name="l00578"></a>00578 
<a name="l00579"></a>00579                 <span class="comment">// Fix up the parent&#39;s p level in case we changed it</span>
<a name="l00580"></a>00580                 (<span class="keyword">const_cast&lt;</span>Elem *<span class="keyword">&gt;</span>(parent))-&gt;hack_p_level(old_parent_level);
<a name="l00581"></a>00581               }
<a name="l00582"></a>00582             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00583"></a>00583               {
<a name="l00584"></a>00584                 <a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">FEBase::coarsened_dof_values</a>(old_vector, dof_map,
<a name="l00585"></a>00585                                              elem, Ue, var, <span class="keyword">true</span>);
<a name="l00586"></a>00586               }
<a name="l00587"></a>00587             <span class="comment">// For unrefined uncoarsened elements, we just copy DoFs</span>
<a name="l00588"></a>00588             <span class="keywordflow">else</span>
<a name="l00589"></a>00589               {
<a name="l00590"></a>00590                 <span class="comment">// FIXME - I&#39;m sure this function would be about half</span>
<a name="l00591"></a>00591                 <span class="comment">// the size if anyone ever figures out how to improve</span>
<a name="l00592"></a>00592                 <span class="comment">// the DofMap interface... - RHS</span>
<a name="l00593"></a>00593                 <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00594"></a>00594                   {
<a name="l00595"></a>00595                     libmesh_assert (elem-&gt;p_level() &gt; 0);
<a name="l00596"></a>00596                     <span class="comment">// P refinement of non-hierarchic bases will</span>
<a name="l00597"></a>00597                     <span class="comment">// require a whole separate code path</span>
<a name="l00598"></a>00598                     libmesh_assert (fe-&gt;is_hierarchic());
<a name="l00599"></a>00599                     temp_fe_type = fe_type;
<a name="l00600"></a>00600                     temp_fe_type.order =
<a name="l00601"></a>00601                       <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(temp_fe_type.order - 1);
<a name="l00602"></a>00602                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_index = 0, new_index = 0;
<a name="l00603"></a>00603                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l00604"></a>00604                       {
<a name="l00605"></a>00605                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc =
<a name="l00606"></a>00606                           <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, temp_fe_type,
<a name="l00607"></a>00607                                                        elem_type, n);
<a name="l00608"></a>00608                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != nc; ++i)
<a name="l00609"></a>00609                           {
<a name="l00610"></a>00610                             Ue(new_index + i) =
<a name="l00611"></a>00611                               <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_dof_indices[old_index++]);
<a name="l00612"></a>00612                           }
<a name="l00613"></a>00613                         new_index +=
<a name="l00614"></a>00614                           <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, fe_type,
<a name="l00615"></a>00615                                                        elem_type, n);
<a name="l00616"></a>00616                       }
<a name="l00617"></a>00617                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc =
<a name="l00618"></a>00618                       <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a> (dim, temp_fe_type,
<a name="l00619"></a>00619                                                     elem_type);
<a name="l00620"></a>00620                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != nc; ++i)
<a name="l00621"></a>00621                       {
<a name="l00622"></a>00622                         Ue(new_index++) =
<a name="l00623"></a>00623                           <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_dof_indices[old_index+i]);
<a name="l00624"></a>00624                       }
<a name="l00625"></a>00625                   }
<a name="l00626"></a>00626                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() ==
<a name="l00627"></a>00627                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00628"></a>00628                   {
<a name="l00629"></a>00629                     <span class="comment">// P coarsening of non-hierarchic bases will</span>
<a name="l00630"></a>00630                     <span class="comment">// require a whole separate code path</span>
<a name="l00631"></a>00631                     libmesh_assert (fe-&gt;is_hierarchic());
<a name="l00632"></a>00632                     temp_fe_type = fe_type;
<a name="l00633"></a>00633                     temp_fe_type.order =
<a name="l00634"></a>00634                       <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(temp_fe_type.order + 1);
<a name="l00635"></a>00635                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_index = 0, new_index = 0;
<a name="l00636"></a>00636                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l00637"></a>00637                       {
<a name="l00638"></a>00638                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc =
<a name="l00639"></a>00639                           <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, fe_type,
<a name="l00640"></a>00640                                                        elem_type, n);
<a name="l00641"></a>00641                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != nc; ++i)
<a name="l00642"></a>00642                           {
<a name="l00643"></a>00643                             Ue(new_index++) =
<a name="l00644"></a>00644                               <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_dof_indices[old_index+i]);
<a name="l00645"></a>00645                           }
<a name="l00646"></a>00646                         old_index +=
<a name="l00647"></a>00647                           <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, temp_fe_type,
<a name="l00648"></a>00648                                                        elem_type, n);
<a name="l00649"></a>00649                       }
<a name="l00650"></a>00650                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc =
<a name="l00651"></a>00651                       <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a> (dim, fe_type,
<a name="l00652"></a>00652                                                     elem_type);
<a name="l00653"></a>00653                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != nc; ++i)
<a name="l00654"></a>00654                       {
<a name="l00655"></a>00655                         Ue(new_index++) =
<a name="l00656"></a>00656                           <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_dof_indices[old_index+i]);
<a name="l00657"></a>00657                       }
<a name="l00658"></a>00658                   }
<a name="l00659"></a>00659                 <span class="keywordflow">else</span>
<a name="l00660"></a>00660                   <span class="comment">// If there&#39;s no p refinement, we can copy every DoF</span>
<a name="l00661"></a>00661                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;new_n_dofs; i++)
<a name="l00662"></a>00662                     Ue(i) = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_dof_indices[i]);
<a name="l00663"></a>00663               }
<a name="l00664"></a>00664           } 
<a name="l00665"></a>00665           <span class="keywordflow">else</span> { <span class="comment">// fe type is Lagrange</span>
<a name="l00666"></a>00666             <span class="comment">// Loop over the DOFs on the element</span>
<a name="l00667"></a>00667             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_local_dof=0;
<a name="l00668"></a>00668                  new_local_dof&lt;new_n_dofs; new_local_dof++)
<a name="l00669"></a>00669               {
<a name="l00670"></a>00670                 <span class="comment">// The global DOF number for this local DOF</span>
<a name="l00671"></a>00671                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_global_dof =
<a name="l00672"></a>00672                   new_dof_indices[new_local_dof];
<a name="l00673"></a>00673 
<a name="l00674"></a>00674                 <span class="comment">// The global DOF might lie outside of the bounds of a</span>
<a name="l00675"></a>00675                 <span class="comment">// distributed vector.  Check for that and possibly continue</span>
<a name="l00676"></a>00676                 <span class="comment">// the loop</span>
<a name="l00677"></a>00677                 <span class="keywordflow">if</span> ((new_global_dof &lt;  new_vector.first_local_index()) ||
<a name="l00678"></a>00678                     (new_global_dof &gt;= new_vector.last_local_index()))
<a name="l00679"></a>00679                   <span class="keywordflow">continue</span>;
<a name="l00680"></a>00680 
<a name="l00681"></a>00681                 <span class="comment">// We might have already computed the solution for this DOF.</span>
<a name="l00682"></a>00682                 <span class="comment">// This is likely in the case of a shared node, particularly</span>
<a name="l00683"></a>00683                 <span class="comment">// at the corners of an element.  Check to see if that is the</span>
<a name="l00684"></a>00684                 <span class="comment">// case</span>
<a name="l00685"></a>00685                 <span class="keywordflow">if</span> (already_done[new_global_dof] == <span class="keyword">true</span>)
<a name="l00686"></a>00686                   <span class="keywordflow">continue</span>;
<a name="l00687"></a>00687 
<a name="l00688"></a>00688                 already_done[new_global_dof] = <span class="keyword">true</span>;
<a name="l00689"></a>00689               
<a name="l00690"></a>00690                 <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00691"></a>00691                   {
<a name="l00692"></a>00692                     <span class="comment">// The location of the child&#39;s node on the parent element</span>
<a name="l00693"></a>00693                     <span class="keyword">const</span> Point point =
<a name="l00694"></a>00694                       <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, fe_type, parent,
<a name="l00695"></a>00695                                                 elem-&gt;point(new_local_dof));
<a name="l00696"></a>00696                   
<a name="l00697"></a>00697                     <span class="comment">// Sum the function values * the DOF values</span>
<a name="l00698"></a>00698                     <span class="comment">// at the point of interest to get the function value</span>
<a name="l00699"></a>00699                     <span class="comment">// (Note that the # of DOFs on the parent need not be the</span>
<a name="l00700"></a>00700                     <span class="comment">//  same as on the child!)</span>
<a name="l00701"></a>00701                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_local_dof=0;
<a name="l00702"></a>00702                          old_local_dof&lt;old_n_dofs; old_local_dof++)
<a name="l00703"></a>00703                       {
<a name="l00704"></a>00704                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_global_dof =
<a name="l00705"></a>00705                           old_dof_indices[old_local_dof];
<a name="l00706"></a>00706                       
<a name="l00707"></a>00707                         Ue(new_local_dof) += 
<a name="l00708"></a>00708                           (<a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_global_dof)*
<a name="l00709"></a>00709                           <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(dim, fe_type, parent,
<a name="l00710"></a>00710                                              old_local_dof, point));
<a name="l00711"></a>00711                       }
<a name="l00712"></a>00712                   }
<a name="l00713"></a>00713                 <span class="keywordflow">else</span>
<a name="l00714"></a>00714                   {
<a name="l00715"></a>00715                     <span class="comment">// Get the old global DOF index</span>
<a name="l00716"></a>00716                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_global_dof =
<a name="l00717"></a>00717                       old_dof_indices[new_local_dof];
<a name="l00718"></a>00718 
<a name="l00719"></a>00719                     Ue(new_local_dof) = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a0d9e9aada8dd86375a4b919ea5608fa3">old_vector</a>(old_global_dof);
<a name="l00720"></a>00720                   }
<a name="l00721"></a>00721               } <span class="comment">// end local DOF loop</span>
<a name="l00722"></a>00722 
<a name="l00723"></a>00723             <span class="comment">// We may have to clean up a parent&#39;s p_level</span>
<a name="l00724"></a>00724             <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00725"></a>00725               (const_cast&lt;Elem *&gt;(parent))-&gt;hack_p_level(old_parent_level);
<a name="l00726"></a>00726           }  <span class="comment">// end fe_type if()</span>
<a name="l00727"></a>00727 
<a name="l00728"></a>00728           <span class="comment">// Lock the new_vector since it is shared among threads.</span>
<a name="l00729"></a>00729           {
<a name="l00730"></a>00730             Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; new_n_dofs; i++) 
<a name="l00733"></a>00733               <span class="keywordflow">if</span> (Ue(i) != 0.)
<a name="l00734"></a>00734                 new_vector.set(new_dof_indices[i], Ue(i));
<a name="l00735"></a>00735           }
<a name="l00736"></a>00736         }  <span class="comment">// end elem loop</span>
<a name="l00737"></a>00737     } <span class="comment">// end variables loop</span>
<a name="l00738"></a>00738 
<a name="l00739"></a>00739   STOP_LOG (<span class="stringliteral">&quot;operator()&quot;</span>,<span class="stringliteral">&quot;ProjectVector&quot;</span>);
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00742"></a>00742 <span class="preprocessor"></span>}
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a688346b5a79bda8d3e3bf33641669526">System::BuildProjectionList::unique</a>()
<a name="l00747"></a>00747 {
<a name="l00748"></a>00748   <span class="comment">// Sort the send list.  After this duplicated</span>
<a name="l00749"></a>00749   <span class="comment">// elements will be adjacent in the vector</span>
<a name="l00750"></a>00750   std::sort(this-&gt;send_list.begin(), 
<a name="l00751"></a>00751             this-&gt;send_list.end());
<a name="l00752"></a>00752   
<a name="l00753"></a>00753   <span class="comment">// Now use std::unique to remove duplicate entries</span>
<a name="l00754"></a>00754   std::vector&lt;unsigned int&gt;::iterator new_end =
<a name="l00755"></a>00755     std::unique (this-&gt;send_list.begin(), 
<a name="l00756"></a>00756                  this-&gt;send_list.end());
<a name="l00757"></a>00757   
<a name="l00758"></a>00758   <span class="comment">// Remove the end of the send_list.  Use the &quot;swap trick&quot;</span>
<a name="l00759"></a>00759   <span class="comment">// from Effective STL</span>
<a name="l00760"></a>00760   std::vector&lt;unsigned int&gt; 
<a name="l00761"></a>00761     (this-&gt;send_list.begin(), new_end).swap (this-&gt;send_list);
<a name="l00762"></a>00762 }
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 <span class="preprocessor">#ifndef LIBMESH_ENABLE_AMR</span>
<a name="l00767"></a>00767 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">System::BuildProjectionList::operator()</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> &amp;)
<a name="l00768"></a>00768 {
<a name="l00769"></a>00769   libmesh_error();
<a name="l00770"></a>00770 <span class="preprocessor">#else</span>
<a name="l00771"></a>00771 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">System::BuildProjectionList::operator()</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> &amp;range)
<a name="l00772"></a>00772 {
<a name="l00773"></a>00773   <span class="comment">// The DofMap for this system</span>
<a name="l00774"></a>00774   <span class="keyword">const</span> DofMap&amp; dof_map = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.get_dof_map();
<a name="l00775"></a>00775 
<a name="l00776"></a>00776   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_old_dof = dof_map.first_old_dof();
<a name="l00777"></a>00777   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_old_dof   = dof_map.end_old_dof();
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="comment">// We can handle all the variables at once.</span>
<a name="l00780"></a>00780   <span class="comment">// The old global DOF indices</span>
<a name="l00781"></a>00781   std::vector&lt;unsigned int&gt; di;
<a name="l00782"></a>00782    
<a name="l00783"></a>00783   <span class="comment">// Iterate over the elements in the range</span>
<a name="l00784"></a>00784   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> elem_it=range.begin(); elem_it != range.end(); ++elem_it)
<a name="l00785"></a>00785     {
<a name="l00786"></a>00786       <span class="keyword">const</span> Elem* elem = *elem_it;
<a name="l00787"></a>00787       <span class="comment">// If this element doesn&#39;t have an old_dof_object with dofs for the</span>
<a name="l00788"></a>00788       <span class="comment">// current system, then it must be newly added, so the user</span>
<a name="l00789"></a>00789       <span class="comment">// is responsible for setting the new dofs.</span>
<a name="l00790"></a>00790 
<a name="l00791"></a>00791       <span class="comment">// ... but we need a better way to test for that; the code</span>
<a name="l00792"></a>00792       <span class="comment">// below breaks on any FE type for which the elem stores no</span>
<a name="l00793"></a>00793       <span class="comment">// dofs.</span>
<a name="l00794"></a>00794       <span class="comment">// if (!elem-&gt;old_dof_object || !elem-&gt;old_dof_object-&gt;has_dofs(system.number()))</span>
<a name="l00795"></a>00795       <span class="comment">//  continue;</span>
<a name="l00796"></a>00796       <span class="keyword">const</span> Elem* parent = elem-&gt;parent();
<a name="l00797"></a>00797       
<a name="l00798"></a>00798       <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00799"></a>00799         {
<a name="l00800"></a>00800           libmesh_assert (parent != NULL);
<a name="l00801"></a>00801           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_parent_level = parent-&gt;p_level();
<a name="l00802"></a>00802           
<a name="l00803"></a>00803           <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>)
<a name="l00804"></a>00804             {
<a name="l00805"></a>00805               <span class="comment">// We may have done p refinement or coarsening as well;</span>
<a name="l00806"></a>00806               <span class="comment">// if so then we need to reset the parent&#39;s p level</span>
<a name="l00807"></a>00807               <span class="comment">// so we can get the right DoFs from it</span>
<a name="l00808"></a>00808               libmesh_assert(elem-&gt;p_level() &gt; 0);
<a name="l00809"></a>00809               (<span class="keyword">const_cast&lt;</span>Elem *<span class="keyword">&gt;</span>(parent))-&gt;hack_p_level(elem-&gt;p_level() - 1);
<a name="l00810"></a>00810             }
<a name="l00811"></a>00811           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;p_refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00812"></a>00812             {
<a name="l00813"></a>00813               (<span class="keyword">const_cast&lt;</span>Elem *<span class="keyword">&gt;</span>(parent))-&gt;hack_p_level(elem-&gt;p_level() + 1);
<a name="l00814"></a>00814             }
<a name="l00815"></a>00815 
<a name="l00816"></a>00816           dof_map.old_dof_indices (parent, di);
<a name="l00817"></a>00817           
<a name="l00818"></a>00818           <span class="comment">// Fix up the parent&#39;s p level in case we changed it</span>
<a name="l00819"></a>00819           (<span class="keyword">const_cast&lt;</span>Elem *<span class="keyword">&gt;</span>(parent))-&gt;hack_p_level(old_parent_level);
<a name="l00820"></a>00820         }
<a name="l00821"></a>00821       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00822"></a>00822         {
<a name="l00823"></a>00823           std::vector&lt;unsigned int&gt; di_child;
<a name="l00824"></a>00824           di.clear();
<a name="l00825"></a>00825           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;n_children(); ++c)
<a name="l00826"></a>00826             {
<a name="l00827"></a>00827               dof_map.old_dof_indices (elem-&gt;child(c), di_child);
<a name="l00828"></a>00828               di.insert(di.end(), di_child.begin(), di_child.end());
<a name="l00829"></a>00829             }
<a name="l00830"></a>00830         }
<a name="l00831"></a>00831       <span class="keywordflow">else</span>
<a name="l00832"></a>00832         dof_map.old_dof_indices (elem, di);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != di.size(); ++i)
<a name="l00835"></a>00835         <span class="keywordflow">if</span> (di[i] &lt; first_old_dof || di[i] &gt;= end_old_dof)
<a name="l00836"></a>00836           this-&gt;send_list.push_back(di[i]);
<a name="l00837"></a>00837     }  <span class="comment">// end elem loop</span>
<a name="l00838"></a>00838 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00839"></a>00839 <span class="preprocessor"></span>}
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1BuildProjectionList.php#a1839efc2a5864e8af4762cde5258a7c2">System::BuildProjectionList::join</a>(<span class="keyword">const</span> BuildProjectionList &amp;other)
<a name="l00844"></a>00844 {
<a name="l00845"></a>00845   <span class="comment">// Joining simply requires I add the dof indices from the other object</span>
<a name="l00846"></a>00846   this-&gt;send_list.insert(this-&gt;send_list.end(),
<a name="l00847"></a>00847                          other.send_list.begin(),
<a name="l00848"></a>00848                          other.send_list.end());
<a name="l00849"></a>00849 }
<a name="l00850"></a>00850 
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#aac4a001d5e37cd11933a1bd7bf7115a4">System::ProjectSolution::operator()</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00853"></a>00853 <span class="keyword"></span>{
<a name="l00854"></a>00854   <span class="comment">// We need data to project</span>
<a name="l00855"></a>00855   libmesh_assert(fptr);
<a name="l00856"></a>00856 
<a name="l00864"></a>00864   <span class="comment">// The number of variables in this system</span>
<a name="l00865"></a>00865   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_variables = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.n_vars();
<a name="l00866"></a>00866 
<a name="l00867"></a>00867   <span class="comment">// The dimensionality of the current mesh</span>
<a name="l00868"></a>00868   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.get_mesh().mesh_dimension();
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <span class="comment">// The DofMap for this system</span>
<a name="l00871"></a>00871   <span class="keyword">const</span> DofMap&amp; dof_map = <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.get_dof_map();
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="comment">// The element matrix and RHS for projections.</span>
<a name="l00874"></a>00874   <span class="comment">// Note that Ke is always real-valued, whereas</span>
<a name="l00875"></a>00875   <span class="comment">// Fe may be complex valued if complex number</span>
<a name="l00876"></a>00876   <span class="comment">// support is enabled</span>
<a name="l00877"></a>00877   DenseMatrix&lt;Real&gt; Ke;
<a name="l00878"></a>00878   DenseVector&lt;Number&gt; Fe;
<a name="l00879"></a>00879   <span class="comment">// The new element coefficients</span>
<a name="l00880"></a>00880   DenseVector&lt;Number&gt; Ue;
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00884"></a>00884   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;n_variables; var++)
<a name="l00885"></a>00885     {
<a name="l00886"></a>00886       <span class="keyword">const</span> Variable&amp; variable = dof_map.variable(var);
<a name="l00887"></a>00887 
<a name="l00888"></a>00888       <span class="keyword">const</span> FEType&amp; fe_type = variable.type();     
<a name="l00889"></a>00889 
<a name="l00890"></a>00890       <span class="keywordflow">if</span> (fe_type.family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00891"></a>00891         <span class="keywordflow">continue</span>;
<a name="l00892"></a>00892 
<a name="l00893"></a>00893       <span class="comment">// Get FE objects of the appropriate type</span>
<a name="l00894"></a>00894       AutoPtr&lt;FEBase&gt; fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));      
<a name="l00895"></a>00895 
<a name="l00896"></a>00896       <span class="comment">// Prepare variables for projection</span>
<a name="l00897"></a>00897       AutoPtr&lt;QBase&gt; qrule     (fe_type.default_quadrature_rule(dim));
<a name="l00898"></a>00898       AutoPtr&lt;QBase&gt; qedgerule (fe_type.default_quadrature_rule(1));
<a name="l00899"></a>00899       AutoPtr&lt;QBase&gt; qsiderule (fe_type.default_quadrature_rule(dim-1));
<a name="l00900"></a>00900 
<a name="l00901"></a>00901       <span class="comment">// The values of the shape functions at the quadrature</span>
<a name="l00902"></a>00902       <span class="comment">// points</span>
<a name="l00903"></a>00903       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi = fe-&gt;get_phi();
<a name="l00904"></a>00904 
<a name="l00905"></a>00905       <span class="comment">// The gradients of the shape functions at the quadrature</span>
<a name="l00906"></a>00906       <span class="comment">// points on the child element.</span>
<a name="l00907"></a>00907       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi = NULL;
<a name="l00908"></a>00908 
<a name="l00909"></a>00909       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = fe-&gt;get_continuity();
<a name="l00910"></a>00910 
<a name="l00911"></a>00911       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00912"></a>00912         {
<a name="l00913"></a>00913           <span class="comment">// We&#39;ll need gradient data for a C1 projection</span>
<a name="l00914"></a>00914           libmesh_assert(gptr);
<a name="l00915"></a>00915 
<a name="l00916"></a>00916           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp;
<a name="l00917"></a>00917             ref_dphi = fe-&gt;get_dphi();
<a name="l00918"></a>00918           dphi = &amp;ref_dphi;
<a name="l00919"></a>00919         }
<a name="l00920"></a>00920 
<a name="l00921"></a>00921       <span class="comment">// The Jacobian * quadrature weight at the quadrature points</span>
<a name="l00922"></a>00922       <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; JxW =
<a name="l00923"></a>00923         fe-&gt;get_JxW();
<a name="l00924"></a>00924      
<a name="l00925"></a>00925       <span class="comment">// The XYZ locations of the quadrature points</span>
<a name="l00926"></a>00926       <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; xyz_values =
<a name="l00927"></a>00927         fe-&gt;get_xyz();
<a name="l00928"></a>00928 
<a name="l00929"></a>00929       <span class="comment">// The global DOF indices</span>
<a name="l00930"></a>00930       std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00931"></a>00931       <span class="comment">// Side/edge DOF indices</span>
<a name="l00932"></a>00932       std::vector&lt;unsigned int&gt; side_dofs;
<a name="l00933"></a>00933    
<a name="l00934"></a>00934       <span class="comment">// Iterate over all the elements in the range</span>
<a name="l00935"></a>00935       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> elem_it=range.begin(); elem_it != range.end(); ++elem_it)
<a name="l00936"></a>00936         {
<a name="l00937"></a>00937           <span class="keyword">const</span> Elem* elem = *elem_it;
<a name="l00938"></a>00938 
<a name="l00939"></a>00939           <span class="comment">// Per-subdomain variables don&#39;t need to be projected on</span>
<a name="l00940"></a>00940           <span class="comment">// elements where they&#39;re not active</span>
<a name="l00941"></a>00941           <span class="keywordflow">if</span> (!variable.active_on_subdomain(elem-&gt;subdomain_id()))
<a name="l00942"></a>00942             <span class="keywordflow">continue</span>;
<a name="l00943"></a>00943 
<a name="l00944"></a>00944           <span class="comment">// Update the DOF indices for this element based on</span>
<a name="l00945"></a>00945           <span class="comment">// the current mesh</span>
<a name="l00946"></a>00946           dof_map.dof_indices (elem, dof_indices, var);
<a name="l00947"></a>00947 
<a name="l00948"></a>00948           <span class="comment">// The number of DOFs on the element</span>
<a name="l00949"></a>00949           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a> = dof_indices.size();
<a name="l00950"></a>00950 
<a name="l00951"></a>00951           <span class="comment">// Fixed vs. free DoFs on edge/face projections</span>
<a name="l00952"></a>00952           std::vector&lt;char&gt; dof_is_fixed(n_dofs, <span class="keyword">false</span>); <span class="comment">// bools</span>
<a name="l00953"></a>00953           std::vector&lt;int&gt; free_dof(n_dofs, 0);
<a name="l00954"></a>00954 
<a name="l00955"></a>00955           <span class="comment">// The element type</span>
<a name="l00956"></a>00956           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> elem_type = elem-&gt;type();
<a name="l00957"></a>00957 
<a name="l00958"></a>00958           <span class="comment">// The number of nodes on the new element</span>
<a name="l00959"></a>00959           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_nodes = elem-&gt;n_nodes();
<a name="l00960"></a>00960 
<a name="l00961"></a>00961           <span class="comment">// Zero the interpolated values</span>
<a name="l00962"></a>00962           Ue.resize (n_dofs); Ue.zero();
<a name="l00963"></a>00963 
<a name="l00964"></a>00964           <span class="comment">// In general, we need a series of</span>
<a name="l00965"></a>00965           <span class="comment">// projections to ensure a unique and continuous</span>
<a name="l00966"></a>00966           <span class="comment">// solution.  We start by interpolating nodes, then</span>
<a name="l00967"></a>00967           <span class="comment">// hold those fixed and project edges, then</span>
<a name="l00968"></a>00968           <span class="comment">// hold those fixed and project faces, then</span>
<a name="l00969"></a>00969           <span class="comment">// hold those fixed and project interiors</span>
<a name="l00970"></a>00970 
<a name="l00971"></a>00971           <span class="comment">// Interpolate node values first</span>
<a name="l00972"></a>00972           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_dof = 0;
<a name="l00973"></a>00973           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n!= <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l00974"></a>00974             {
<a name="l00975"></a>00975               <span class="comment">// FIXME: this should go through the DofMap,</span>
<a name="l00976"></a>00976               <span class="comment">// not duplicate dof_indices code badly!</span>
<a name="l00977"></a>00977               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc =
<a name="l00978"></a>00978                 <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, fe_type, elem_type,
<a name="l00979"></a>00979                                              n);
<a name="l00980"></a>00980               <span class="keywordflow">if</span> (!elem-&gt;is_vertex(n))
<a name="l00981"></a>00981                 {
<a name="l00982"></a>00982                   current_dof += nc;
<a name="l00983"></a>00983                   <span class="keywordflow">continue</span>;
<a name="l00984"></a>00984                 }
<a name="l00985"></a>00985               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l00986"></a>00986                 {
<a name="l00987"></a>00987                   libmesh_assert(nc == 0);
<a name="l00988"></a>00988                 }
<a name="l00989"></a>00989               <span class="comment">// Assume that C_ZERO elements have a single nodal</span>
<a name="l00990"></a>00990               <span class="comment">// value shape function</span>
<a name="l00991"></a>00991               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l00992"></a>00992                 {
<a name="l00993"></a>00993                   libmesh_assert(nc == 1);
<a name="l00994"></a>00994                   Ue(current_dof) = fptr(elem-&gt;point(n),
<a name="l00995"></a>00995                                          parameters,
<a name="l00996"></a>00996                                          <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l00997"></a>00997                                          <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l00998"></a>00998                   dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l00999"></a>00999                   current_dof++;
<a name="l01000"></a>01000                 }
<a name="l01001"></a>01001               <span class="comment">// The hermite element vertex shape functions are weird</span>
<a name="l01002"></a>01002               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (fe_type.family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>)
<a name="l01003"></a>01003                 {
<a name="l01004"></a>01004                   Ue(current_dof) = fptr(elem-&gt;point(n),
<a name="l01005"></a>01005                                          parameters,
<a name="l01006"></a>01006                                          <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01007"></a>01007                                          <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01008"></a>01008                   dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01009"></a>01009                   current_dof++;
<a name="l01010"></a>01010                   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> g = gptr(elem-&gt;point(n),
<a name="l01011"></a>01011                                     parameters,
<a name="l01012"></a>01012                                     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01013"></a>01013                                     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01014"></a>01014                   <span class="comment">// x derivative</span>
<a name="l01015"></a>01015                   Ue(current_dof) = g(0);
<a name="l01016"></a>01016                   dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01017"></a>01017                   current_dof++;
<a name="l01018"></a>01018                   <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l01019"></a>01019                     {
<a name="l01020"></a>01020                       <span class="comment">// We&#39;ll finite difference mixed derivatives</span>
<a name="l01021"></a>01021                       Point nxminus = elem-&gt;point(n),
<a name="l01022"></a>01022                             nxplus = elem-&gt;point(n);
<a name="l01023"></a>01023                       nxminus(0) -= TOLERANCE;
<a name="l01024"></a>01024                       nxplus(0) += TOLERANCE;
<a name="l01025"></a>01025                       <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gxminus = gptr(nxminus,
<a name="l01026"></a>01026                                               parameters,
<a name="l01027"></a>01027                                               <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01028"></a>01028                                               <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01029"></a>01029                       <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gxplus = gptr(nxminus,
<a name="l01030"></a>01030                                              parameters,
<a name="l01031"></a>01031                                              <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01032"></a>01032                                              <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01033"></a>01033                       <span class="comment">// y derivative</span>
<a name="l01034"></a>01034                       Ue(current_dof) = g(1);
<a name="l01035"></a>01035                       dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01036"></a>01036                       current_dof++;
<a name="l01037"></a>01037                       <span class="comment">// xy derivative</span>
<a name="l01038"></a>01038                       Ue(current_dof) = (gxplus(1) - gxminus(1))
<a name="l01039"></a>01039                                         / 2. / TOLERANCE;
<a name="l01040"></a>01040                       dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01041"></a>01041                       current_dof++;
<a name="l01042"></a>01042 
<a name="l01043"></a>01043                       <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l01044"></a>01044                         {
<a name="l01045"></a>01045                           <span class="comment">// z derivative</span>
<a name="l01046"></a>01046                           Ue(current_dof) = g(2);
<a name="l01047"></a>01047                           dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01048"></a>01048                           current_dof++;
<a name="l01049"></a>01049                           <span class="comment">// xz derivative</span>
<a name="l01050"></a>01050                           Ue(current_dof) = (gxplus(2) - gxminus(2))
<a name="l01051"></a>01051                                             / 2. / TOLERANCE;
<a name="l01052"></a>01052                           dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01053"></a>01053                           current_dof++;
<a name="l01054"></a>01054                           <span class="comment">// We need new points for yz</span>
<a name="l01055"></a>01055                           Point nyminus = elem-&gt;point(n),
<a name="l01056"></a>01056                                 nyplus = elem-&gt;point(n);
<a name="l01057"></a>01057                           nyminus(1) -= TOLERANCE;
<a name="l01058"></a>01058                           nyplus(1) += TOLERANCE;
<a name="l01059"></a>01059                           <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gyminus = gptr(nyminus,
<a name="l01060"></a>01060                                                   parameters,
<a name="l01061"></a>01061                                                   <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01062"></a>01062                                                   <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01063"></a>01063                           <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gyplus = gptr(nyminus,
<a name="l01064"></a>01064                                                  parameters,
<a name="l01065"></a>01065                                                  <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01066"></a>01066                                                  <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01067"></a>01067                           <span class="comment">// xz derivative</span>
<a name="l01068"></a>01068                           Ue(current_dof) = (gyplus(2) - gyminus(2))
<a name="l01069"></a>01069                                             / 2. / TOLERANCE;
<a name="l01070"></a>01070                           dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01071"></a>01071                           current_dof++;
<a name="l01072"></a>01072                           <span class="comment">// Getting a 2nd order xyz is more tedious</span>
<a name="l01073"></a>01073                           Point nxmym = elem-&gt;point(n),
<a name="l01074"></a>01074                                 nxmyp = elem-&gt;point(n),
<a name="l01075"></a>01075                                 nxpym = elem-&gt;point(n),
<a name="l01076"></a>01076                                 nxpyp = elem-&gt;point(n);
<a name="l01077"></a>01077                           nxmym(0) -= TOLERANCE;
<a name="l01078"></a>01078                           nxmym(1) -= TOLERANCE;
<a name="l01079"></a>01079                           nxmyp(0) -= TOLERANCE;
<a name="l01080"></a>01080                           nxmyp(1) += TOLERANCE;
<a name="l01081"></a>01081                           nxpym(0) += TOLERANCE;
<a name="l01082"></a>01082                           nxpym(1) -= TOLERANCE;
<a name="l01083"></a>01083                           nxpyp(0) += TOLERANCE;
<a name="l01084"></a>01084                           nxpyp(1) += TOLERANCE;
<a name="l01085"></a>01085                           <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gxmym = gptr(nxmym,
<a name="l01086"></a>01086                                                 parameters,
<a name="l01087"></a>01087                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01088"></a>01088                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01089"></a>01089                           <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gxmyp = gptr(nxmyp,
<a name="l01090"></a>01090                                                 parameters,
<a name="l01091"></a>01091                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01092"></a>01092                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01093"></a>01093                           <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gxpym = gptr(nxpym,
<a name="l01094"></a>01094                                                 parameters,
<a name="l01095"></a>01095                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01096"></a>01096                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01097"></a>01097                           <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> gxpyp = gptr(nxpyp,
<a name="l01098"></a>01098                                                 parameters,
<a name="l01099"></a>01099                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01100"></a>01100                                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01101"></a>01101                           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> gxzplus = (gxpyp(2) - gxmyp(2))
<a name="l01102"></a>01102                                          / 2. / TOLERANCE;
<a name="l01103"></a>01103                           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> gxzminus = (gxpym(2) - gxmym(2))
<a name="l01104"></a>01104                                           / 2. / TOLERANCE;
<a name="l01105"></a>01105                           <span class="comment">// xyz derivative</span>
<a name="l01106"></a>01106                           Ue(current_dof) = (gxzplus - gxzminus)
<a name="l01107"></a>01107                                             / 2. / TOLERANCE;
<a name="l01108"></a>01108                           dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01109"></a>01109                           current_dof++;
<a name="l01110"></a>01110                         }
<a name="l01111"></a>01111                     }
<a name="l01112"></a>01112                 }
<a name="l01113"></a>01113               <span class="comment">// Assume that other C_ONE elements have a single nodal</span>
<a name="l01114"></a>01114               <span class="comment">// value shape function and nodal gradient component</span>
<a name="l01115"></a>01115               <span class="comment">// shape functions</span>
<a name="l01116"></a>01116               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01117"></a>01117                 {
<a name="l01118"></a>01118                   libmesh_assert(nc == 1 + dim);
<a name="l01119"></a>01119                   Ue(current_dof) = fptr(elem-&gt;point(n),
<a name="l01120"></a>01120                                          parameters,
<a name="l01121"></a>01121                                          <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01122"></a>01122                                          <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01123"></a>01123                   dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01124"></a>01124                   current_dof++;
<a name="l01125"></a>01125                   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> g = gptr(elem-&gt;point(n),
<a name="l01126"></a>01126                                     parameters,
<a name="l01127"></a>01127                                     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01128"></a>01128                                     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01129"></a>01129                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= dim; ++i)
<a name="l01130"></a>01130                     {
<a name="l01131"></a>01131                       Ue(current_dof) = g(i);
<a name="l01132"></a>01132                       dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01133"></a>01133                       current_dof++;
<a name="l01134"></a>01134                     }
<a name="l01135"></a>01135                 }
<a name="l01136"></a>01136               <span class="keywordflow">else</span>
<a name="l01137"></a>01137                 libmesh_error();
<a name="l01138"></a>01138             }
<a name="l01139"></a>01139 
<a name="l01140"></a>01140           <span class="comment">// In 3D, project any edge values next</span>
<a name="l01141"></a>01141           <span class="keywordflow">if</span> (dim &gt; 2 &amp;&amp; cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01142"></a>01142             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e != elem-&gt;n_edges(); ++e)
<a name="l01143"></a>01143               {
<a name="l01144"></a>01144                 <a class="code" href="classlibMesh_1_1FEInterface.php#a7391d432c820009be1a10837ccda221b">FEInterface::dofs_on_edge</a>(elem, dim, fe_type, e,
<a name="l01145"></a>01145                                           side_dofs);
<a name="l01146"></a>01146 
<a name="l01147"></a>01147                 <span class="comment">// Some edge dofs are on nodes and already</span>
<a name="l01148"></a>01148                 <span class="comment">// fixed, others are free to calculate</span>
<a name="l01149"></a>01149                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> free_dofs = 0;
<a name="l01150"></a>01150                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != side_dofs.size(); ++i)
<a name="l01151"></a>01151                   <span class="keywordflow">if</span> (!dof_is_fixed[side_dofs[i]])
<a name="l01152"></a>01152                     free_dof[free_dofs++] = i;
<a name="l01153"></a>01153 
<a name="l01154"></a>01154                 <span class="comment">// There may be nothing to project</span>
<a name="l01155"></a>01155                 <span class="keywordflow">if</span> (!free_dofs)
<a name="l01156"></a>01156                   <span class="keywordflow">continue</span>;
<a name="l01157"></a>01157 
<a name="l01158"></a>01158                 Ke.resize (free_dofs, free_dofs); Ke.zero();
<a name="l01159"></a>01159                 Fe.resize (free_dofs); Fe.zero();
<a name="l01160"></a>01160                 <span class="comment">// The new edge coefficients</span>
<a name="l01161"></a>01161                 DenseVector&lt;Number&gt; Uedge(free_dofs);
<a name="l01162"></a>01162 
<a name="l01163"></a>01163                 <span class="comment">// Initialize FE data on the edge</span>
<a name="l01164"></a>01164                 fe-&gt;attach_quadrature_rule (qedgerule.get());
<a name="l01165"></a>01165                 fe-&gt;edge_reinit (elem, e);
<a name="l01166"></a>01166                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qedgerule-&gt;n_points();
<a name="l01167"></a>01167 
<a name="l01168"></a>01168                 <span class="comment">// Loop over the quadrature points</span>
<a name="l01169"></a>01169                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01170"></a>01170                   {
<a name="l01171"></a>01171                     <span class="comment">// solution at the quadrature point       </span>
<a name="l01172"></a>01172                     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fineval = fptr(xyz_values[qp],
<a name="l01173"></a>01173                                           parameters,
<a name="l01174"></a>01174                                           <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01175"></a>01175                                           <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01176"></a>01176                     <span class="comment">// solution grad at the quadrature point          </span>
<a name="l01177"></a>01177                     <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> finegrad;
<a name="l01178"></a>01178                     <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01179"></a>01179                       finegrad = gptr(xyz_values[qp], parameters,
<a name="l01180"></a>01180                                       <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01181"></a>01181                                       <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01182"></a>01182 
<a name="l01183"></a>01183                     <span class="comment">// Form edge projection matrix</span>
<a name="l01184"></a>01184                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidei=0, freei=0; 
<a name="l01185"></a>01185                          sidei != side_dofs.size(); ++sidei)
<a name="l01186"></a>01186                       {
<a name="l01187"></a>01187                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = side_dofs[sidei];
<a name="l01188"></a>01188                         <span class="comment">// fixed DoFs aren&#39;t test functions</span>
<a name="l01189"></a>01189                         <span class="keywordflow">if</span> (dof_is_fixed[i])
<a name="l01190"></a>01190                           <span class="keywordflow">continue</span>;
<a name="l01191"></a>01191                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidej=0, freej=0;
<a name="l01192"></a>01192                              sidej != side_dofs.size(); ++sidej)
<a name="l01193"></a>01193                           {
<a name="l01194"></a>01194                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = side_dofs[sidej];
<a name="l01195"></a>01195                             <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01196"></a>01196                               Fe(freei) -= phi[i][qp] * phi[j][qp] *
<a name="l01197"></a>01197                                            JxW[qp] * Ue(j);
<a name="l01198"></a>01198                             <span class="keywordflow">else</span>
<a name="l01199"></a>01199                               Ke(freei,freej) += phi[i][qp] *
<a name="l01200"></a>01200                                                  phi[j][qp] * JxW[qp];
<a name="l01201"></a>01201                             <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01202"></a>01202                               {
<a name="l01203"></a>01203                                 <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01204"></a>01204                                   Fe(freei) -= ((*dphi)[i][qp] *
<a name="l01205"></a>01205                                                 (*dphi)[j][qp]) *
<a name="l01206"></a>01206                                                 JxW[qp] * Ue(j);
<a name="l01207"></a>01207                                 <span class="keywordflow">else</span>
<a name="l01208"></a>01208                                   Ke(freei,freej) += ((*dphi)[i][qp] *
<a name="l01209"></a>01209                                                       (*dphi)[j][qp])
<a name="l01210"></a>01210                                                       * JxW[qp];
<a name="l01211"></a>01211                               }
<a name="l01212"></a>01212                             <span class="keywordflow">if</span> (!dof_is_fixed[j])
<a name="l01213"></a>01213                               freej++;
<a name="l01214"></a>01214                           }
<a name="l01215"></a>01215                         Fe(freei) += phi[i][qp] * fineval * JxW[qp];
<a name="l01216"></a>01216                         <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01217"></a>01217                           Fe(freei) += (finegrad * (*dphi)[i][qp]) *
<a name="l01218"></a>01218                                        JxW[qp];
<a name="l01219"></a>01219                         freei++;
<a name="l01220"></a>01220                       }
<a name="l01221"></a>01221                   }
<a name="l01222"></a>01222 
<a name="l01223"></a>01223                 Ke.cholesky_solve(Fe, Uedge);
<a name="l01224"></a>01224 
<a name="l01225"></a>01225                 <span class="comment">// Transfer new edge solutions to element</span>
<a name="l01226"></a>01226                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != free_dofs; ++i)
<a name="l01227"></a>01227                   {
<a name="l01228"></a>01228                     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;ui = Ue(side_dofs[free_dof[i]]);
<a name="l01229"></a>01229                     libmesh_assert(std::abs(ui) &lt; TOLERANCE ||
<a name="l01230"></a>01230                            std::abs(ui - Uedge(i)) &lt; TOLERANCE);
<a name="l01231"></a>01231                     ui = Uedge(i);
<a name="l01232"></a>01232                     dof_is_fixed[side_dofs[free_dof[i]]] = <span class="keyword">true</span>;
<a name="l01233"></a>01233                   }
<a name="l01234"></a>01234               }
<a name="l01235"></a>01235                  
<a name="l01236"></a>01236           <span class="comment">// Project any side values (edges in 2D, faces in 3D)</span>
<a name="l01237"></a>01237           <span class="keywordflow">if</span> (dim &gt; 1 &amp;&amp; cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01238"></a>01238             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s != elem-&gt;n_sides(); ++s)
<a name="l01239"></a>01239               {
<a name="l01240"></a>01240                 <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(elem, dim, fe_type, s,
<a name="l01241"></a>01241                                           side_dofs);
<a name="l01242"></a>01242 
<a name="l01243"></a>01243                 <span class="comment">// Some side dofs are on nodes/edges and already</span>
<a name="l01244"></a>01244                 <span class="comment">// fixed, others are free to calculate</span>
<a name="l01245"></a>01245                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> free_dofs = 0;
<a name="l01246"></a>01246                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != side_dofs.size(); ++i)
<a name="l01247"></a>01247                   <span class="keywordflow">if</span> (!dof_is_fixed[side_dofs[i]])
<a name="l01248"></a>01248                     free_dof[free_dofs++] = i;
<a name="l01249"></a>01249 
<a name="l01250"></a>01250                 <span class="comment">// There may be nothing to project</span>
<a name="l01251"></a>01251                 <span class="keywordflow">if</span> (!free_dofs)
<a name="l01252"></a>01252                   <span class="keywordflow">continue</span>;
<a name="l01253"></a>01253              
<a name="l01254"></a>01254                 Ke.resize (free_dofs, free_dofs); Ke.zero();
<a name="l01255"></a>01255                 Fe.resize (free_dofs); Fe.zero();
<a name="l01256"></a>01256                 <span class="comment">// The new side coefficients</span>
<a name="l01257"></a>01257                 DenseVector&lt;Number&gt; Uside(free_dofs);
<a name="l01258"></a>01258 
<a name="l01259"></a>01259                 <span class="comment">// Initialize FE data on the side</span>
<a name="l01260"></a>01260                 fe-&gt;attach_quadrature_rule (qsiderule.get());
<a name="l01261"></a>01261                 fe-&gt;reinit (elem, s);
<a name="l01262"></a>01262                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qsiderule-&gt;n_points();
<a name="l01263"></a>01263 
<a name="l01264"></a>01264                 <span class="comment">// Loop over the quadrature points</span>
<a name="l01265"></a>01265                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01266"></a>01266                   {
<a name="l01267"></a>01267                     <span class="comment">// solution at the quadrature point       </span>
<a name="l01268"></a>01268                     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fineval = fptr(xyz_values[qp],
<a name="l01269"></a>01269                                           parameters,
<a name="l01270"></a>01270                                           <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01271"></a>01271                                           <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01272"></a>01272                     <span class="comment">// solution grad at the quadrature point          </span>
<a name="l01273"></a>01273                     <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> finegrad;
<a name="l01274"></a>01274                     <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01275"></a>01275                       finegrad = gptr(xyz_values[qp], parameters,
<a name="l01276"></a>01276                                       <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01277"></a>01277                                       <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01278"></a>01278 
<a name="l01279"></a>01279                     <span class="comment">// Form side projection matrix</span>
<a name="l01280"></a>01280                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidei=0, freei=0;
<a name="l01281"></a>01281                          sidei != side_dofs.size(); ++sidei)
<a name="l01282"></a>01282                       {
<a name="l01283"></a>01283                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = side_dofs[sidei];
<a name="l01284"></a>01284                         <span class="comment">// fixed DoFs aren&#39;t test functions</span>
<a name="l01285"></a>01285                         <span class="keywordflow">if</span> (dof_is_fixed[i])
<a name="l01286"></a>01286                           <span class="keywordflow">continue</span>;
<a name="l01287"></a>01287                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidej=0, freej=0;
<a name="l01288"></a>01288                              sidej != side_dofs.size(); ++sidej)
<a name="l01289"></a>01289                           {
<a name="l01290"></a>01290                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = side_dofs[sidej];
<a name="l01291"></a>01291                             <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01292"></a>01292                               Fe(freei) -= phi[i][qp] * phi[j][qp] *
<a name="l01293"></a>01293                                            JxW[qp] * Ue(j);
<a name="l01294"></a>01294                             <span class="keywordflow">else</span>
<a name="l01295"></a>01295                               Ke(freei,freej) += phi[i][qp] *
<a name="l01296"></a>01296                                                  phi[j][qp] * JxW[qp];
<a name="l01297"></a>01297                             <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01298"></a>01298                               {
<a name="l01299"></a>01299                                 <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01300"></a>01300                                   Fe(freei) -= ((*dphi)[i][qp] *
<a name="l01301"></a>01301                                                 (*dphi)[j][qp]) *
<a name="l01302"></a>01302                                                JxW[qp] * Ue(j);
<a name="l01303"></a>01303                                 <span class="keywordflow">else</span>
<a name="l01304"></a>01304                                   Ke(freei,freej) += ((*dphi)[i][qp] *
<a name="l01305"></a>01305                                                       (*dphi)[j][qp])
<a name="l01306"></a>01306                                                      * JxW[qp];
<a name="l01307"></a>01307                               }
<a name="l01308"></a>01308                             <span class="keywordflow">if</span> (!dof_is_fixed[j])
<a name="l01309"></a>01309                               freej++;
<a name="l01310"></a>01310                           }
<a name="l01311"></a>01311                         Fe(freei) += (fineval * phi[i][qp]) * JxW[qp];
<a name="l01312"></a>01312                         <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01313"></a>01313                           Fe(freei) += (finegrad * (*dphi)[i][qp]) *
<a name="l01314"></a>01314                                        JxW[qp];
<a name="l01315"></a>01315                         freei++;
<a name="l01316"></a>01316                       }
<a name="l01317"></a>01317                   }
<a name="l01318"></a>01318 
<a name="l01319"></a>01319                 Ke.cholesky_solve(Fe, Uside);
<a name="l01320"></a>01320 
<a name="l01321"></a>01321                 <span class="comment">// Transfer new side solutions to element</span>
<a name="l01322"></a>01322                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != free_dofs; ++i)
<a name="l01323"></a>01323                   {
<a name="l01324"></a>01324                     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;ui = Ue(side_dofs[free_dof[i]]);
<a name="l01325"></a>01325                     libmesh_assert(std::abs(ui) &lt; TOLERANCE ||
<a name="l01326"></a>01326                            std::abs(ui - Uside(i)) &lt; TOLERANCE);
<a name="l01327"></a>01327                     ui = Uside(i);
<a name="l01328"></a>01328                     dof_is_fixed[side_dofs[free_dof[i]]] = <span class="keyword">true</span>;
<a name="l01329"></a>01329                   }
<a name="l01330"></a>01330               }
<a name="l01331"></a>01331 
<a name="l01332"></a>01332           <span class="comment">// Project the interior values, finally</span>
<a name="l01333"></a>01333 
<a name="l01334"></a>01334           <span class="comment">// Some interior dofs are on nodes/edges/sides and</span>
<a name="l01335"></a>01335           <span class="comment">// already fixed, others are free to calculate</span>
<a name="l01336"></a>01336           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> free_dofs = 0;
<a name="l01337"></a>01337           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; ++i)
<a name="l01338"></a>01338             <span class="keywordflow">if</span> (!dof_is_fixed[i])
<a name="l01339"></a>01339               free_dof[free_dofs++] = i;
<a name="l01340"></a>01340 
<a name="l01341"></a>01341           <span class="comment">// There may be nothing to project</span>
<a name="l01342"></a>01342           <span class="keywordflow">if</span> (free_dofs)
<a name="l01343"></a>01343             {
<a name="l01344"></a>01344              
<a name="l01345"></a>01345           Ke.resize (free_dofs, free_dofs); Ke.zero();
<a name="l01346"></a>01346           Fe.resize (free_dofs); Fe.zero();
<a name="l01347"></a>01347           <span class="comment">// The new interior coefficients</span>
<a name="l01348"></a>01348           DenseVector&lt;Number&gt; Uint(free_dofs);
<a name="l01349"></a>01349 
<a name="l01350"></a>01350           <span class="comment">// Initialize FE data</span>
<a name="l01351"></a>01351           fe-&gt;attach_quadrature_rule (qrule.get());
<a name="l01352"></a>01352           fe-&gt;reinit (elem);
<a name="l01353"></a>01353           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l01354"></a>01354 
<a name="l01355"></a>01355           <span class="comment">// Loop over the quadrature points</span>
<a name="l01356"></a>01356           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01357"></a>01357             {
<a name="l01358"></a>01358               <span class="comment">// solution at the quadrature point             </span>
<a name="l01359"></a>01359               <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fineval = fptr(xyz_values[qp],
<a name="l01360"></a>01360                                     parameters,
<a name="l01361"></a>01361                                     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01362"></a>01362                                     <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01363"></a>01363               <span class="comment">// solution grad at the quadrature point        </span>
<a name="l01364"></a>01364               <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> finegrad;
<a name="l01365"></a>01365               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01366"></a>01366                 finegrad = gptr(xyz_values[qp], parameters,
<a name="l01367"></a>01367                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.name(),
<a name="l01368"></a>01368                                 <a class="code" href="classlibMesh_1_1System_1_1ProjectVector.php#a97b60552832b10ea11d2bf1dde95d35d">system</a>.variable_name(var));
<a name="l01369"></a>01369 
<a name="l01370"></a>01370               <span class="comment">// Form interior projection matrix</span>
<a name="l01371"></a>01371               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, freei=0; i != <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; ++i)
<a name="l01372"></a>01372                 {
<a name="l01373"></a>01373                   <span class="comment">// fixed DoFs aren&#39;t test functions</span>
<a name="l01374"></a>01374                   <span class="keywordflow">if</span> (dof_is_fixed[i])
<a name="l01375"></a>01375                     <span class="keywordflow">continue</span>;
<a name="l01376"></a>01376                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0, freej=0; j != <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; ++j)
<a name="l01377"></a>01377                     {
<a name="l01378"></a>01378                       <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01379"></a>01379                         Fe(freei) -= phi[i][qp] * phi[j][qp] * JxW[qp]
<a name="l01380"></a>01380                                      * Ue(j);
<a name="l01381"></a>01381                       <span class="keywordflow">else</span>
<a name="l01382"></a>01382                         Ke(freei,freej) += phi[i][qp] * phi[j][qp] *
<a name="l01383"></a>01383                                            JxW[qp];
<a name="l01384"></a>01384                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01385"></a>01385                         {
<a name="l01386"></a>01386                           <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01387"></a>01387                             Fe(freei) -= ((*dphi)[i][qp] *
<a name="l01388"></a>01388                                          (*dphi)[j][qp]) * JxW[qp] *
<a name="l01389"></a>01389                                          Ue(j);
<a name="l01390"></a>01390                           <span class="keywordflow">else</span>
<a name="l01391"></a>01391                             Ke(freei,freej) += ((*dphi)[i][qp] *
<a name="l01392"></a>01392                                                 (*dphi)[j][qp]) *
<a name="l01393"></a>01393                                                JxW[qp];
<a name="l01394"></a>01394                         }
<a name="l01395"></a>01395                       <span class="keywordflow">if</span> (!dof_is_fixed[j])
<a name="l01396"></a>01396                         freej++;
<a name="l01397"></a>01397                     }
<a name="l01398"></a>01398                   Fe(freei) += phi[i][qp] * fineval * JxW[qp];
<a name="l01399"></a>01399                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01400"></a>01400                     Fe(freei) += (finegrad * (*dphi)[i][qp]) * JxW[qp];
<a name="l01401"></a>01401                   freei++;
<a name="l01402"></a>01402                 }
<a name="l01403"></a>01403             }
<a name="l01404"></a>01404           Ke.cholesky_solve(Fe, Uint);
<a name="l01405"></a>01405 
<a name="l01406"></a>01406           <span class="comment">// Transfer new interior solutions to element</span>
<a name="l01407"></a>01407           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != free_dofs; ++i)
<a name="l01408"></a>01408             {
<a name="l01409"></a>01409               <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;ui = Ue(free_dof[i]);
<a name="l01410"></a>01410               libmesh_assert(std::abs(ui) &lt; TOLERANCE ||
<a name="l01411"></a>01411                      std::abs(ui - Uint(i)) &lt; TOLERANCE);
<a name="l01412"></a>01412               ui = Uint(i);
<a name="l01413"></a>01413               dof_is_fixed[free_dof[i]] = <span class="keyword">true</span>;
<a name="l01414"></a>01414             }
<a name="l01415"></a>01415 
<a name="l01416"></a>01416             } <span class="comment">// if there are free interior dofs</span>
<a name="l01417"></a>01417 
<a name="l01418"></a>01418           <span class="comment">// Make sure every DoF got reached!</span>
<a name="l01419"></a>01419           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; ++i)
<a name="l01420"></a>01420             libmesh_assert(dof_is_fixed[i]);
<a name="l01421"></a>01421 
<a name="l01422"></a>01422           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01423"></a>01423             first = new_vector.first_local_index(),
<a name="l01424"></a>01424             last  = new_vector.last_local_index();
<a name="l01425"></a>01425           
<a name="l01426"></a>01426           <span class="comment">// Lock the new_vector since it is shared among threads.</span>
<a name="l01427"></a>01427           {
<a name="l01428"></a>01428             Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l01429"></a>01429             
<a name="l01430"></a>01430             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; i++) 
<a name="l01431"></a>01431               <span class="comment">// We may be projecting a new zero value onto</span>
<a name="l01432"></a>01432               <span class="comment">// an old nonzero approximation - RHS</span>
<a name="l01433"></a>01433               <span class="comment">// if (Ue(i) != 0.)</span>
<a name="l01434"></a>01434               <span class="keywordflow">if</span> ((dof_indices[i] &gt;= first) &amp;&amp;
<a name="l01435"></a>01435                   (dof_indices[i] &lt;  last))
<a name="l01436"></a>01436                 {
<a name="l01437"></a>01437                   new_vector.set(dof_indices[i], Ue(i));
<a name="l01438"></a>01438                 }
<a name="l01439"></a>01439           }
<a name="l01440"></a>01440         }  <span class="comment">// end elem loop</span>
<a name="l01441"></a>01441     } <span class="comment">// end variables loop</span>
<a name="l01442"></a>01442 }
<a name="l01443"></a>01443 
<a name="l01444"></a>01444 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
