<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system_subset.h</div>  </div>
</div>
<div class="contents">
<a href="system__subset_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system_subset.h 4253 2011-03-12 04:44:04Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __system_subset_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __system_subset_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>System;
<a name="l00036"></a>00036 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// SystemSubset class definition</span>
<a name="l00046"></a><a class="code" href="classlibMesh_1_1SystemSubset.php">00046</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SystemSubset.php">SystemSubset</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;SystemSubset&gt;
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1SystemSubset.php#a9501878eedacb957e11b6a67d413464d">SystemSubset</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system);
<a name="l00054"></a>00054   
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00056"></a>00056   
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1SystemSubset.php#af571f42f622134f40c667f925cd6e739">~SystemSubset</a> (<span class="keywordtype">void</span>);
<a name="l00061"></a>00061 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1SystemSubset.php#acc57d6d675d8b55d0c1e8e1f47e24510">dof_ids</a>(<span class="keywordtype">void</span>)<span class="keyword">const</span>=0;
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; <a class="code" href="classlibMesh_1_1SystemSubset.php#a2be4abdaac14494458dfb6d00a90e71a">get_system</a>(<span class="keywordtype">void</span>)<span class="keyword">const</span>;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="keyword">protected</span>:
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1SystemSubset.php#ae774667e2b85554fd3f503f920e534db">00079</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; <a class="code" href="classlibMesh_1_1SystemSubset.php#ae774667e2b85554fd3f503f920e534db">_system</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="keyword">private</span>:
<a name="l00088"></a>00088   <a class="code" href="classlibMesh_1_1SystemSubset.php#a9501878eedacb957e11b6a67d413464d">SystemSubset</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemSubset.php">SystemSubset</a>&amp;);
<a name="l00089"></a>00089 
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1SystemSubset.php">SystemSubset</a>&amp; <a class="code" href="classlibMesh_1_1SystemSubset.php#a5ccb48b1a45104c70e3691e588088cec">operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemSubset.php">SystemSubset</a>&amp;);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 }; <span class="comment">// class SystemSubset</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 } <span class="comment">// namespace libMesh</span>
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="preprocessor">#endif</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
