<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tensor_shell_matrix.C</div>  </div>
</div>
<div class="contents">
<a href="tensor__shell__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tensor_shell_matrix.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="tensor__shell__matrix_8h.php">tensor_shell_matrix.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00029"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a4c01d779373358aa1dd37220a90b8f0e">00029</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a4c01d779373358aa1dd37220a90b8f0e">TensorShellMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00030"></a>00030                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00031"></a>00031 <span class="keyword"></span>{
<a name="l00032"></a>00032   dest = _v;
<a name="l00033"></a>00033   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(_w.dot(arg));
<a name="l00034"></a>00034 }
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00039"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ae15af4664070c51f937e005f4255fedb">00039</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ae15af4664070c51f937e005f4255fedb">TensorShellMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00040"></a>00040                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00041"></a>00041 <span class="keyword"></span>{
<a name="l00042"></a>00042   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(_w.dot(arg),_v);
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a50660112b1a17c01d29fd81dffe8a2fd">00048</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a50660112b1a17c01d29fd81dffe8a2fd">TensorShellMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00049"></a>00049 <span class="keyword"></span>{
<a name="l00050"></a>00050   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a01ffe7580b8f038caade2a22d0bb505e">pointwise_mult</a>(_v,_w);
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// Explicit instantiations</span>
<a name="l00057"></a>00057 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TensorShellMatrix.php">TensorShellMatrix&lt;Number&gt;</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 } <span class="comment">// namespace libMesh</span>
<a name="l00060"></a>00060 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
