<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tensor_shell_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="tensor__shell__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tensor_shell_matrix.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tensor_shell_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tensor_shell_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00044"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TensorShellMatrix.php">TensorShellMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix</a>&lt;T&gt;
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a783d9d0d748a4e622342776e54d1f1e6">TensorShellMatrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00052"></a>00052                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; w);
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#afda8876ea2276079d2f394471838aaa7">~TensorShellMatrix</a> ();
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ae58deccba50dcdfa1b29831de47ba5d3">m</a> () <span class="keyword">const</span>;
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ade1053040063db904a45d77890c56f31">n</a> () <span class="keyword">const</span>;
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a4c01d779373358aa1dd37220a90b8f0e">vector_mult</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00076"></a>00076                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ae15af4664070c51f937e005f4255fedb">vector_mult_add</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest,
<a name="l00082"></a>00082                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a50660112b1a17c01d29fd81dffe8a2fd">get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="keyword">protected</span>:
<a name="l00093"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a6779d9619b7715f104db4dd6020ddde8">00093</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a6779d9619b7715f104db4dd6020ddde8">_v</a>;
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a4b9860fc99c7a50fff6481238f1a8f37">00098</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a4b9860fc99c7a50fff6481238f1a8f37">_w</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 };
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00105"></a>00105 <span class="comment">// TensorShellMatrix inline members</span>
<a name="l00106"></a>00106 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00107"></a>00107 <span class="keyword">inline</span>
<a name="l00108"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a783d9d0d748a4e622342776e54d1f1e6">00108</a> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#a783d9d0d748a4e622342776e54d1f1e6">TensorShellMatrix&lt;T&gt;::TensorShellMatrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00109"></a>00109                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; w):
<a name="l00110"></a>00110   <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix</a>&lt;T&gt;(),
<a name="l00111"></a>00111   _v(v),
<a name="l00112"></a>00112   _w(w)
<a name="l00113"></a>00113 {}
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00118"></a>00118 <span class="keyword">inline</span>
<a name="l00119"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#afda8876ea2276079d2f394471838aaa7">00119</a> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#afda8876ea2276079d2f394471838aaa7">TensorShellMatrix&lt;T&gt;::~TensorShellMatrix</a> ()
<a name="l00120"></a>00120 {}
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00125"></a>00125 <span class="keyword">inline</span>
<a name="l00126"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ae58deccba50dcdfa1b29831de47ba5d3">00126</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ae58deccba50dcdfa1b29831de47ba5d3">TensorShellMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00127"></a>00127 <span class="keyword"></span>{
<a name="l00128"></a>00128   <span class="keywordflow">return</span> _v.size();
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00134"></a>00134 <span class="keyword">inline</span>
<a name="l00135"></a><a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ade1053040063db904a45d77890c56f31">00135</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TensorShellMatrix.php#ade1053040063db904a45d77890c56f31">TensorShellMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword"></span>{
<a name="l00137"></a>00137   <span class="keywordflow">return</span> _w.size();
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 } <span class="comment">// namespace libMesh</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#endif // #ifndef __tensor_shell_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
