<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tensor_value.h</div>  </div>
</div>
<div class="contents">
<a href="tensor__value_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tensor_value.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tensor_value_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tensor_value_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="type__tensor_8h.php">type_tensor.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1TensorValue.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt;
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a>  (<span class="keyword">const</span> T xx=0.,
<a name="l00053"></a>00053                 <span class="keyword">const</span> T xy=0.,
<a name="l00054"></a>00054                 <span class="keyword">const</span> T xz=0.,
<a name="l00055"></a>00055                 <span class="keyword">const</span> T yx=0.,
<a name="l00056"></a>00056                 <span class="keyword">const</span> T yy=0.,
<a name="l00057"></a>00057                 <span class="keyword">const</span> T yz=0.,
<a name="l00058"></a>00058                 <span class="keyword">const</span> T zx=0.,
<a name="l00059"></a>00059                 <span class="keyword">const</span> T zy=0.,
<a name="l00060"></a>00060                 <span class="keyword">const</span> T zz=0.);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx);
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vy);
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vy, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vz);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   
<a name="l00084"></a>00084   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;T2&gt;</a>&amp; p);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a>&amp; p);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;Real&gt;</a>&amp; p_re,
<a name="l00101"></a>00101                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;Real&gt;</a>&amp; p_im);
<a name="l00102"></a>00102 <span class="preprocessor">#endif</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00104"></a>00104   
<a name="l00105"></a>00105 <span class="keyword">private</span>:
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   
<a name="l00108"></a>00108 };
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00116"></a>00116 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Real&gt;</a>   <a class="code" href="namespacelibMesh.php#a452831d26a60cf3bcf349610a85b52da">RealTensorValue</a>;
<a name="l00117"></a>00117 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Number&gt;</a> <a class="code" href="namespacelibMesh.php#a080d44bce9955f29c426e896dfd01c4e">NumberTensorValue</a>;
<a name="l00118"></a>00118 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">RealTensorValue</a>     <a class="code" href="namespacelibMesh.php#a9bd4c05784227753fe29f61700ac5190">RealTensor</a>;
<a name="l00119"></a>00119 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">NumberTensorValue</a>   <a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">Tensor</a>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="comment">//------------------------------------------------------</span>
<a name="l00124"></a>00124 <span class="comment">// Inline functions</span>
<a name="l00125"></a>00125 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00126"></a>00126 <span class="keyword">inline</span>
<a name="l00127"></a><a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">00127</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> T xx,
<a name="l00128"></a>00128                              <span class="keyword">const</span> T xy,
<a name="l00129"></a>00129                              <span class="keyword">const</span> T xz,
<a name="l00130"></a>00130                              <span class="keyword">const</span> T yx,
<a name="l00131"></a>00131                              <span class="keyword">const</span> T yy,
<a name="l00132"></a>00132                              <span class="keyword">const</span> T yz,
<a name="l00133"></a>00133                              <span class="keyword">const</span> T zx,
<a name="l00134"></a>00134                              <span class="keyword">const</span> T zy,
<a name="l00135"></a>00135                              <span class="keyword">const</span> T zz) :
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (xx,xy,xz,yx,yy,yz,zx,zy,zz)
<a name="l00137"></a>00137 {
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00143"></a>00143 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00144"></a>00144 <span class="keyword">inline</span>
<a name="l00145"></a><a class="code" href="classlibMesh_1_1TensorValue.php#a51590bbf178e848ca4cbd3b2603fb030">00145</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;T2&gt;</a>&amp; p) :
<a name="l00146"></a>00146   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (p)
<a name="l00147"></a>00147 {
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00153"></a>00153 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00154"></a>00154 <span class="keyword">inline</span>
<a name="l00155"></a><a class="code" href="classlibMesh_1_1TensorValue.php#a5ae2d62fc3fcbf01f768230fdea2cbc3">00155</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx) :
<a name="l00156"></a>00156   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (vx)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00163"></a>00163 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00164"></a>00164 <span class="keyword">inline</span>
<a name="l00165"></a><a class="code" href="classlibMesh_1_1TensorValue.php#a1260b6395d49e36af11a26cc2faa75e2">00165</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx,
<a name="l00166"></a>00166                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vy) :
<a name="l00167"></a>00167   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (vx, vy)
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00174"></a>00174 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00175"></a>00175 <span class="keyword">inline</span>
<a name="l00176"></a><a class="code" href="classlibMesh_1_1TensorValue.php#adaf80dcdb1b4448bea657d14616eaae0">00176</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx,
<a name="l00177"></a>00177                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vy,
<a name="l00178"></a>00178                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vz) :
<a name="l00179"></a>00179   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (vx, vy, vz)
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181 }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00186"></a>00186 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00187"></a>00187 <span class="keyword">inline</span>
<a name="l00188"></a><a class="code" href="classlibMesh_1_1TensorValue.php#acbcd26b3687b895a74e0bfb93c92ae62">00188</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a>&amp; p) :
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (p)
<a name="l00190"></a>00190 {
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00196"></a>00196 <span class="keyword">inline</span>
<a name="l00197"></a><a class="code" href="classlibMesh_1_1TensorValue.php#ab2ab63687c14ec057ba788d54ebcbf63">00197</a> <a class="code" href="classlibMesh_1_1TensorValue.php#a92f9c816428186c62a534ce93934e891">TensorValue&lt;T&gt;::TensorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;Real&gt;</a>&amp; p_re,
<a name="l00198"></a>00198                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;Real&gt;</a>&amp; p_im) :
<a name="l00199"></a>00199   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>&lt;T&gt; (<a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(0,0), p_im(0,0)),
<a name="l00200"></a>00200                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(0,1), p_im(0,1)),
<a name="l00201"></a>00201                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(0,2), p_im(0,2)),
<a name="l00202"></a>00202                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(1,0), p_im(1,0)),
<a name="l00203"></a>00203                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(1,1), p_im(1,1)),
<a name="l00204"></a>00204                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(1,2), p_im(1,2)),
<a name="l00205"></a>00205                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(2,0), p_im(2,0)),
<a name="l00206"></a>00206                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(2,1), p_im(2,1)),
<a name="l00207"></a>00207                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(2,2), p_im(2,2)))
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 <span class="preprocessor">#endif</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 } <span class="comment">// namespace libMesh</span>
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 <span class="preprocessor">#endif // #define __tensor_value_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
