<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tetgen_io.C</div>  </div>
</div>
<div class="contents">
<a href="tetgen__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tetgen_io.C 4195 2011-02-09 17:04:17Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="tetgen__io_8h.php">tetgen_io.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet10_8h.php">cell_tet10.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__data_8h.php">mesh_data.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// TetgenIO class members</span>
<a name="l00036"></a><a class="code" href="classlibMesh_1_1TetGenIO.php#ad06b7d388a2174c5bb513e076015b39f">00036</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenIO.php#ad06b7d388a2174c5bb513e076015b39f">TetGenIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00039"></a>00039   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00040"></a>00040   <span class="comment">// broadcast later</span>
<a name="l00041"></a>00041   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   std::string name_node, name_ele, dummy;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">// tetgen only works in 3D</span>
<a name="l00046"></a>00046   <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(3);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Cannot open dimension 3 mesh file when configured without 3D support.&quot;</span> &lt;&lt;
<a name="l00050"></a>00050                   std::endl;
<a name="l00051"></a>00051   libmesh_error();
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054   <span class="comment">// Check name for *.node or *.ele extension.</span>
<a name="l00055"></a>00055   <span class="comment">// Set std::istream for node_stream and ele_stream.</span>
<a name="l00056"></a>00056   <span class="comment">//</span>
<a name="l00057"></a>00057   <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.node&quot;</span>) &lt; name.size()) 
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059       name_node = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00060"></a>00060       dummy     = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00061"></a>00061       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00062"></a>00062       name_ele     = dummy.replace(position, 5, <span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00063"></a>00063     }
<a name="l00064"></a>00064   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>) &lt; name.size()) 
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       name_ele = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00067"></a>00067       dummy    = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00068"></a>00068       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00069"></a>00069       name_node    = dummy.replace(position, 4, <span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071   <span class="keywordflow">else</span>
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized file name: &quot;</span>
<a name="l00074"></a>00074                     &lt;&lt; name &lt;&lt; std::endl;
<a name="l00075"></a>00075       libmesh_error();
<a name="l00076"></a>00076     }
<a name="l00077"></a>00077         
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="comment">// Set the streams from which to read in</span>
<a name="l00081"></a>00081   std::ifstream node_stream (name_node.c_str());
<a name="l00082"></a>00082   std::ifstream ele_stream  (name_ele.c_str());
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="keywordflow">if</span> ( !node_stream.good() || !ele_stream.good() )
<a name="l00085"></a>00085     {
<a name="l00086"></a>00086       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: One or both Input file(s) not good.&quot;</span> &lt;&lt; std::endl
<a name="l00087"></a>00087                     &lt;&lt; <span class="stringliteral">&quot;Error checking files &quot;</span>
<a name="l00088"></a>00088                     &lt;&lt; name_node &lt;&lt; <span class="stringliteral">&quot; and &quot;</span>
<a name="l00089"></a>00089                     &lt;&lt; name_ele  &lt;&lt; std::endl;
<a name="l00090"></a>00090       libmesh_error();
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt; <span class="stringliteral">&quot;TetGenIO found the tetgen files to read &quot;</span> &lt;&lt;std::endl; 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// Skip the comment lines at the beginning</span>
<a name="l00095"></a>00095   this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#a96cc4aa98c2495e488522155a3fa07f2">skip_comment_lines</a> (node_stream, <span class="charliteral">&#39;#&#39;</span>);
<a name="l00096"></a>00096   this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#a96cc4aa98c2495e488522155a3fa07f2">skip_comment_lines</a> (ele_stream, <span class="charliteral">&#39;#&#39;</span>);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">// Read the nodes and elements from the streams</span>
<a name="l00099"></a>00099   this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#a876680c1d26eed24d574dccb79f11d44">read_nodes_and_elem</a> (node_stream, ele_stream);
<a name="l00100"></a>00100   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt; <span class="stringliteral">&quot;TetGenIO read in nodes and elements &quot;</span> &lt;&lt;std::endl; 
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1TetGenIO.php#a876680c1d26eed24d574dccb79f11d44">00105</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenIO.php#a876680c1d26eed24d574dccb79f11d44">TetGenIO::read_nodes_and_elem</a> (std::istream&amp; node_stream,
<a name="l00106"></a>00106                                     std::istream&amp; ele_stream)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1TetGenIO.php#a129dfaf42e414d65d26abc9018b6fad4">_num_nodes</a>    = 0;
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1TetGenIO.php#aadb1366ebb1a8d780a0f5042b3bac48f">_num_elements</a> = 0;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// Read all the datasets.</span>
<a name="l00112"></a>00112   this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#a3bf133683be90a1e16fd0c6b97e7277c">node_in</a>    (node_stream);
<a name="l00113"></a>00113   this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#a38aecf6a9b8dda26066ba9ac476d2e8c">element_in</a> (ele_stream);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// Tell the MeshData object that we are finished </span>
<a name="l00116"></a>00116   <span class="comment">// reading data.</span>
<a name="l00117"></a>00117   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#ae0640b09b25b7e4497a91813667641bc">_mesh_data</a> != NULL)
<a name="l00118"></a>00118     this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#ae0640b09b25b7e4497a91813667641bc">_mesh_data</a>-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a9d18d3adfdf70d79d8c48aaec35f7145">close_foreign_id_maps</a> ();
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">// some more clean-up</span>
<a name="l00121"></a>00121   <a class="code" href="classlibMesh_1_1TetGenIO.php#a33481199fa030e26d98b38fb3ad8607f">_assign_nodes</a>.clear();
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00127"></a>00127 <span class="comment">// Function to read in the node table.</span>
<a name="l00128"></a><a class="code" href="classlibMesh_1_1TetGenIO.php#a3bf133683be90a1e16fd0c6b97e7277c">00128</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenIO.php#a3bf133683be90a1e16fd0c6b97e7277c">TetGenIO::node_in</a> (std::istream&amp; node_stream)
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Check input buffer</span>
<a name="l00131"></a>00131   libmesh_assert (node_stream.good());
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Get a reference to the mesh</span>
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dimension=0, nAttributes=0, BoundaryMarkers=0;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   node_stream &gt;&gt; <a class="code" href="classlibMesh_1_1TetGenIO.php#a129dfaf42e414d65d26abc9018b6fad4">_num_nodes</a>       <span class="comment">// Read the number of nodes from the stream</span>
<a name="l00139"></a>00139               &gt;&gt; dimension        <span class="comment">// Read the dimension from the stream</span>
<a name="l00140"></a>00140               &gt;&gt; nAttributes      <span class="comment">// Read the number of attributes from stream</span>
<a name="l00141"></a>00141               &gt;&gt; BoundaryMarkers; <span class="comment">// Read if or not boundary markers are included in *.node (0 or 1)</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">// Read the nodal coordinates from the node_stream (*.node file).</span>
<a name="l00144"></a>00144   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_lab=0;
<a name="l00145"></a>00145   <a class="code" href="classlibMesh_1_1Point.php">Point</a> xyz;
<a name="l00146"></a>00146   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dummy;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TetGenIO.php#a129dfaf42e414d65d26abc9018b6fad4">_num_nodes</a>; i++)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       <span class="comment">// Check input buffer</span>
<a name="l00151"></a>00151       libmesh_assert (node_stream.good());
<a name="l00152"></a>00152       
<a name="l00153"></a>00153       node_stream &gt;&gt; node_lab  <span class="comment">// node number</span>
<a name="l00154"></a>00154                   &gt;&gt; xyz(0)    <span class="comment">// x-coordinate value</span>
<a name="l00155"></a>00155                   &gt;&gt; xyz(1)    <span class="comment">// y-coordinate value</span>
<a name="l00156"></a>00156                   &gt;&gt; xyz(2);   <span class="comment">// z-coordinate value</span>
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">// For the number of attributes read all into dummy.</span>
<a name="l00159"></a>00159       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttributes; j++)
<a name="l00160"></a>00160         node_stream &gt;&gt; dummy;
<a name="l00161"></a>00161       
<a name="l00162"></a>00162       <span class="comment">// Read boundary marker if BoundaryMarker=1.</span>
<a name="l00163"></a>00163       <span class="keywordflow">if</span> (BoundaryMarkers == 1)
<a name="l00164"></a>00164         node_stream &gt;&gt; dummy;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166       <span class="comment">// Store the new position of the node under its label.</span>
<a name="l00167"></a>00167       <span class="comment">//_assign_nodes.insert (std::make_pair(node_lab,i));</span>
<a name="l00168"></a>00168       <a class="code" href="classlibMesh_1_1TetGenIO.php#a33481199fa030e26d98b38fb3ad8607f">_assign_nodes</a>[node_lab] = i;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170       <span class="comment">// do this irrespective whether MeshData exists</span>
<a name="l00171"></a>00171       <a class="code" href="classlibMesh_1_1Node.php">Node</a>* newnode = mesh.add_point(xyz, i);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173       <span class="comment">// Add node to the nodes vector &amp;</span>
<a name="l00174"></a>00174       <span class="comment">// tell the MeshData object the foreign node id.</span>
<a name="l00175"></a>00175       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#ae0640b09b25b7e4497a91813667641bc">_mesh_data</a> != NULL)
<a name="l00176"></a>00176         this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#ae0640b09b25b7e4497a91813667641bc">_mesh_data</a>-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a42a382455dea188b00e990477439456d">add_foreign_node_id</a> (newnode, node_lab);
<a name="l00177"></a>00177     }
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00183"></a>00183 <span class="comment">// Function to read in the element table.</span>
<a name="l00184"></a><a class="code" href="classlibMesh_1_1TetGenIO.php#a38aecf6a9b8dda26066ba9ac476d2e8c">00184</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenIO.php#a38aecf6a9b8dda26066ba9ac476d2e8c">TetGenIO::element_in</a> (std::istream&amp; ele_stream)
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   <span class="comment">// Check input buffer</span>
<a name="l00187"></a>00187   libmesh_assert (ele_stream.good());
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">// Get a reference to the mesh</span>
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="comment">// Read the elements from the ele_stream (*.ele file). </span>
<a name="l00193"></a>00193   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> element_lab=0, <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>=0, nAttri=0;
<a name="l00194"></a>00194   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dummy=0.0;
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   ele_stream &gt;&gt; <a class="code" href="classlibMesh_1_1TetGenIO.php#aadb1366ebb1a8d780a0f5042b3bac48f">_num_elements</a> <span class="comment">// Read the number of tetrahedrons from the stream.</span>
<a name="l00197"></a>00197              &gt;&gt; <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>       <span class="comment">// Read the number of nodes per tetrahedron from the stream (defaults to 4).</span>
<a name="l00198"></a>00198              &gt;&gt; nAttri;       <span class="comment">// Read the number of attributes from stream.</span>
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// Vector that assigns element nodes to their correct position.</span>
<a name="l00201"></a>00201   <span class="comment">// TetGen is normaly 0-based</span>
<a name="l00202"></a>00202   <span class="comment">// (right now this is strictly not necessary since it is the identity map,</span>
<a name="l00203"></a>00203   <span class="comment">//  but in the future TetGen could change their numbering scheme.)</span>
<a name="l00204"></a>00204   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assign_elm_nodes[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TetGenIO.php#aadb1366ebb1a8d780a0f5042b3bac48f">_num_elements</a>; i++)
<a name="l00207"></a>00207     {
<a name="l00208"></a>00208       libmesh_assert (ele_stream.good());
<a name="l00209"></a>00209       
<a name="l00210"></a>00210       <span class="comment">// TetGen only supports Tet4 and Tet10 elements.</span>
<a name="l00211"></a>00211       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem;
<a name="l00212"></a>00212       
<a name="l00213"></a>00213       <span class="keywordflow">if</span> (<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>==4)
<a name="l00214"></a>00214         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a>;
<a name="l00215"></a>00215       
<a name="l00216"></a>00216       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>==10)
<a name="l00217"></a>00217         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet10.php">Tet10</a>;
<a name="l00218"></a>00218       
<a name="l00219"></a>00219       <span class="keywordflow">else</span>
<a name="l00220"></a>00220         {
<a name="l00221"></a>00221           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Elements with &quot;</span> &lt;&lt; <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>
<a name="l00222"></a>00222                         &lt;&lt; <span class="stringliteral">&quot; nodes are not supported in the LibMesh tetgen module\n&quot;</span>;
<a name="l00223"></a>00223           libmesh_error();
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225       elem-&gt;set_id(i);
<a name="l00226"></a>00226       mesh.add_elem (elem);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228       libmesh_assert (elem != NULL);
<a name="l00229"></a>00229       libmesh_assert (elem-&gt;n_nodes() == <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231       <span class="comment">// Read the element label</span>
<a name="l00232"></a>00232       ele_stream &gt;&gt; element_lab;
<a name="l00233"></a>00233 
<a name="l00234"></a>00234       <span class="comment">// Add the element to the mesh &amp;</span>
<a name="l00235"></a>00235       <span class="comment">// tell the MeshData object the foreign element id</span>
<a name="l00236"></a>00236       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#ae0640b09b25b7e4497a91813667641bc">_mesh_data</a> != NULL)
<a name="l00237"></a>00237         this-&gt;<a class="code" href="classlibMesh_1_1TetGenIO.php#ae0640b09b25b7e4497a91813667641bc">_mesh_data</a>-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aca3722b2bab0198b3e3efc7d47eed1c8">add_foreign_elem_id</a> (elem, element_lab);
<a name="l00238"></a>00238       
<a name="l00239"></a>00239       <span class="comment">// Read node labels</span>
<a name="l00240"></a>00240       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; j++)
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242           <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_label;
<a name="l00243"></a>00243           ele_stream &gt;&gt; node_label;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245           <span class="comment">// Assign node to element</span>
<a name="l00246"></a>00246           elem-&gt;set_node(assign_elm_nodes[j]) =
<a name="l00247"></a>00247             mesh.node_ptr(<a class="code" href="classlibMesh_1_1TetGenIO.php#a33481199fa030e26d98b38fb3ad8607f">_assign_nodes</a>[node_label]);
<a name="l00248"></a>00248         }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250       <span class="comment">// Read attributes from the stream.</span>
<a name="l00251"></a>00251       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttri; j++)
<a name="l00252"></a>00252         ele_stream &gt;&gt; dummy;
<a name="l00253"></a>00253     }
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00261"></a><a class="code" href="classlibMesh_1_1TetGenIO.php#ad6d6de8b33d18a5a9d6b09ad1e15f319">00261</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenIO.php#ad6d6de8b33d18a5a9d6b09ad1e15f319">TetGenIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00262"></a>00262 {
<a name="l00263"></a>00263   <span class="comment">// libmesh_assert three dimensions (should be extended later)</span>
<a name="l00264"></a>00264   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput&lt;MeshBase&gt;::mesh</a>().mesh_dimension() == 3);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="keywordflow">if</span> (!(fname.rfind(<span class="stringliteral">&quot;.poly&quot;</span>) &lt; fname.size())) 
<a name="l00267"></a>00267     {
<a name="l00268"></a>00268       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized file name: &quot;</span>
<a name="l00269"></a>00269                     &lt;&lt; fname &lt;&lt; std::endl;
<a name="l00270"></a>00270       libmesh_error();
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="comment">// Open the output file stream</span>
<a name="l00274"></a>00274   std::ofstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> (fname.c_str());
<a name="l00275"></a>00275   
<a name="l00276"></a>00276   <span class="comment">// Make sure it opened correctly</span>
<a name="l00277"></a>00277   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>.good())
<a name="l00278"></a>00278     libmesh_file_error(fname.c_str());
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="comment">// Get a reference to the mesh</span>
<a name="l00281"></a>00281   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00282"></a>00282   
<a name="l00283"></a>00283   <span class="comment">// Begin interfacing with the .poly file</span>
<a name="l00284"></a>00284   {
<a name="l00285"></a>00285     <span class="comment">// header:</span>
<a name="l00286"></a>00286     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;# poly file output generated by libmesh\n&quot;</span>
<a name="l00287"></a>00287         &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot; 3 0 0\n&quot;</span>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289     <span class="comment">// write the nodes:</span>
<a name="l00290"></a>00290     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); v++)
<a name="l00291"></a>00291       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; v &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00292"></a>00292           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(v)(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00293"></a>00293           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(v)(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00294"></a>00294           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(v)(2) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00295"></a>00295   }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   {
<a name="l00298"></a>00298     <span class="comment">// write the connectivity:</span>
<a name="l00299"></a>00299     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;# Facets:\n&quot;</span>
<a name="l00300"></a>00300         &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>() &lt;&lt; <span class="stringliteral">&quot; 0\n&quot;</span>;
<a name="l00301"></a>00301     
<a name="l00302"></a>00302 <span class="comment">//     const_active_elem_iterator       it (mesh.elements_begin());</span>
<a name="l00303"></a>00303 <span class="comment">//     const const_active_elem_iterator end(mesh.elements_end());</span>
<a name="l00304"></a>00304 
<a name="l00305"></a>00305     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00306"></a>00306     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00307"></a>00307       
<a name="l00308"></a>00308     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00309"></a>00309       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;1\n3 &quot;</span> <span class="comment">// no. of facet polygons</span>
<a name="l00310"></a>00310         <span class="comment">//        &lt;&lt; (*it)-&gt;n_nodes() &lt;&lt; &quot; &quot;</span>
<a name="l00311"></a>00311           &lt;&lt; (*it)-&gt;node(0)   &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00312"></a>00312           &lt;&lt; (*it)-&gt;node(1)   &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00313"></a>00313           &lt;&lt; (*it)-&gt;node(2)   &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00314"></a>00314   }  
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="comment">// end of the file</span>
<a name="l00317"></a>00317   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;0\n&quot;</span>; <span class="comment">// no holes output!</span>
<a name="l00318"></a>00318   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;\n\n# end of file\n&quot;</span>;
<a name="l00319"></a>00319 }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 } <span class="comment">// namespace libMesh</span>
<a name="l00322"></a>00322 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
