<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">threads.h</div>  </div>
</div>
<div class="contents">
<a href="threads_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: threads.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __threads_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __threads_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>  <span class="comment">// for libmesh_assert</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Threading building blocks includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span> <span class="comment">// only mess with the perflog if we are really multithreaded</span>
<a name="l00033"></a>00033 <span class="preprocessor">#  include &quot;tbb/tbb_stddef.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#  include &quot;tbb/blocked_range.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#  include &quot;tbb/parallel_for.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#  include &quot;tbb/parallel_reduce.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#  include &quot;tbb/task_scheduler_init.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#  include &quot;tbb/partitioner.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#  include &quot;tbb/spin_mutex.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#  include &quot;tbb/recursive_mutex.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#  include &quot;tbb/atomic.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="keyword">namespace </span>libMesh
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00052"></a><a class="code" href="namespacelibMesh_1_1Threads.php">00052</a> <span class="keyword">namespace </span>Threads
<a name="l00053"></a>00053 {
<a name="l00059"></a>00059   <span class="keyword">extern</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>;
<a name="l00060"></a>00060 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">00065</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">BoolAcquire</a> {
<a name="l00066"></a>00066   <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#a34e84f7012f8dd48288ed3f73913ff3b">00067</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#a34e84f7012f8dd48288ed3f73913ff3b">BoolAcquire</a>(<span class="keywordtype">bool</span>&amp; b) : <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">_b</a>(b) { libmesh_assert(!<a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">_b</a>); <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">_b</a> = <span class="keyword">true</span>; }
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ab49f717b29881b81d700d9ecb7996d42">00069</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ab49f717b29881b81d700d9ecb7996d42">~BoolAcquire</a>() { libmesh_assert(<a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">_b</a>); <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">_b</a> = <span class="keyword">false</span>; }
<a name="l00070"></a>00070   <span class="keyword">private</span>:
<a name="l00071"></a><a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">00071</a>     <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php#ae5c123051de9ddeae507cd36b5ea4105">_b</a>;
<a name="l00072"></a>00072   };
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00079"></a><a class="code" href="namespacelibMesh_1_1Threads.php#ad2bb356ccf0cb75a2e2633803cb229cd">00079</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh_1_1Threads.php#ad2bb356ccf0cb75a2e2633803cb229cd">tbb::task_scheduler_init</a> <a class="code" href="namespacelibMesh_1_1Threads.php#ad2bb356ccf0cb75a2e2633803cb229cd">task_scheduler_init</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00088"></a><a class="code" href="namespacelibMesh_1_1Threads.php#a24ac7706cba4c670c5fe8e1654c9bbd9">00088</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a24ac7706cba4c670c5fe8e1654c9bbd9">tbb::split</a> <a class="code" href="namespacelibMesh_1_1Threads.php#a24ac7706cba4c670c5fe8e1654c9bbd9">split</a>;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00097"></a>00097 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00098"></a>00098   <span class="keyword">inline</span>
<a name="l00099"></a><a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">00099</a>   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body)
<a name="l00100"></a>00100   {
<a name="l00101"></a>00101     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">BoolAcquire</a> b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00105"></a>00105       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">disable_logging</a>();
<a name="l00106"></a>00106 <span class="preprocessor">#endif   </span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>
<a name="l00108"></a>00108     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00109"></a>00109       <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">tbb::parallel_for</a> (range, body, tbb::auto_partitioner());
<a name="l00110"></a>00110 
<a name="l00111"></a>00111     <span class="keywordflow">else</span> 
<a name="l00112"></a>00112       body(range);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00116"></a>00116       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a8e929e91e0fd9c6915bbbbdfca03e346">enable_logging</a>();
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>  }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00127"></a>00127 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00128"></a>00128   <span class="keyword">inline</span>
<a name="l00129"></a><a class="code" href="namespacelibMesh_1_1Threads.php#a3a95474f27a0275eb0941064959a7ec8">00129</a>   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a> &amp;partitioner)
<a name="l00130"></a>00130   { 
<a name="l00131"></a>00131     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">BoolAcquire</a> b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00135"></a>00135       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">disable_logging</a>();
<a name="l00136"></a>00136 <span class="preprocessor">#endif   </span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>    
<a name="l00138"></a>00138     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00139"></a>00139       <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">tbb::parallel_for</a> (range, body, partitioner); 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="keywordflow">else</span>
<a name="l00142"></a>00142       body(range);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00146"></a>00146       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a8e929e91e0fd9c6915bbbbdfca03e346">enable_logging</a>();
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>  }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00157"></a>00157 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00158"></a>00158   <span class="keyword">inline</span>
<a name="l00159"></a><a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">00159</a>   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body)
<a name="l00160"></a>00160   { 
<a name="l00161"></a>00161     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">BoolAcquire</a> b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00165"></a>00165       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">disable_logging</a>();
<a name="l00166"></a>00166 <span class="preprocessor">#endif   </span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>
<a name="l00168"></a>00168     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00169"></a>00169       <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">tbb::parallel_reduce</a> (range, body, tbb::auto_partitioner()); 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="keywordflow">else</span>
<a name="l00172"></a>00172       body(range);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00176"></a>00176       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a8e929e91e0fd9c6915bbbbdfca03e346">enable_logging</a>();
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>  }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00187"></a>00187 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00188"></a>00188   <span class="keyword">inline</span>
<a name="l00189"></a><a class="code" href="namespacelibMesh_1_1Threads.php#a8928fd26157947418f736ca68b40a0ac">00189</a>   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a> &amp;partitioner)
<a name="l00190"></a>00190   { 
<a name="l00191"></a>00191     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">BoolAcquire</a> b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00194"></a>00194 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00195"></a>00195       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">disable_logging</a>();
<a name="l00196"></a>00196 <span class="preprocessor">#endif   </span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198        <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00199"></a>00199          <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">tbb::parallel_reduce</a> (range, body); 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201        <span class="keywordflow">else</span>
<a name="l00202"></a>00202          body(range);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() &gt; 1)
<a name="l00206"></a>00206       <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">libMesh::perflog</a>.<a class="code" href="classlibMesh_1_1PerfLog.php#a8e929e91e0fd9c6915bbbbdfca03e346">enable_logging</a>();
<a name="l00207"></a>00207 <span class="preprocessor">#endif</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span>  }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00217"></a><a class="code" href="namespacelibMesh_1_1Threads.php#a6e34d4e9e4f0c5da38e5c12d38e893bd">00217</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a6e34d4e9e4f0c5da38e5c12d38e893bd">tbb::spin_mutex</a> <a class="code" href="namespacelibMesh_1_1Threads.php#a6e34d4e9e4f0c5da38e5c12d38e893bd">spin_mutex</a>;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00225"></a><a class="code" href="namespacelibMesh_1_1Threads.php#a64122d1e50161e0a8be0fb802b7bb424">00225</a> <span class="comment"></span>  <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a64122d1e50161e0a8be0fb802b7bb424">tbb::recursive_mutex</a> <a class="code" href="namespacelibMesh_1_1Threads.php#a64122d1e50161e0a8be0fb802b7bb424">recursive_mutex</a>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00233"></a>00233 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00234"></a><a class="code" href="classlibMesh_1_1Threads_1_1atomic.php">00234</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1atomic.php">atomic</a> : <span class="keyword">public</span> tbb::<a class="code" href="classlibMesh_1_1Threads_1_1atomic.php">atomic</a>&lt;T&gt; {};
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="preprocessor">#else //LIBMESH_HAVE_TBB_API</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>
<a name="l00240"></a>00240   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00244"></a><a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php">00244</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php">task_scheduler_init</a>
<a name="l00245"></a>00245   {
<a name="l00246"></a>00246   <span class="keyword">public</span>:
<a name="l00247"></a><a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a3d8c69ca8b4f43096ead10759907177b">00247</a>     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a3d8c69ca8b4f43096ead10759907177b">automatic</a> = -1;
<a name="l00248"></a><a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#aa8642acbeef9821fb5a573142e9a5f32">00248</a>     <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#aa8642acbeef9821fb5a573142e9a5f32">task_scheduler_init</a> (<span class="keywordtype">int</span> = <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a3d8c69ca8b4f43096ead10759907177b">automatic</a>) {};
<a name="l00249"></a><a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a2c803b7e6b7c2375d9ec89033871bed0">00249</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a2c803b7e6b7c2375d9ec89033871bed0">initialize</a> (<span class="keywordtype">int</span> = <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a3d8c69ca8b4f43096ead10759907177b">automatic</a>) {};
<a name="l00250"></a><a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a5f01727c9fbb342aaf555d685b77af14">00250</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1task__scheduler__init.php#a5f01727c9fbb342aaf555d685b77af14">terminate</a> () {};    
<a name="l00251"></a>00251   };
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00258"></a><a class="code" href="classlibMesh_1_1Threads_1_1split.php">00258</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1split.php">split</a> {};
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00265"></a>00265 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00266"></a>00266   <span class="keyword">inline</span>
<a name="l00267"></a>00267   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body)
<a name="l00268"></a>00268   { 
<a name="l00269"></a>00269     <a class="code" href="classlibMesh_1_1Threads_1_1BoolAcquire.php">BoolAcquire</a> b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00270"></a>00270     body(range);
<a name="l00271"></a>00271   }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00278"></a>00278 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00279"></a>00279   <span class="keyword">inline</span>
<a name="l00280"></a>00280   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">parallel_for</a> (<span class="keyword">const</span> Range &amp;range, <span class="keyword">const</span> Body &amp;body, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a> &amp;)
<a name="l00281"></a>00281   {
<a name="l00282"></a>00282     BoolAcquire b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00283"></a>00283     body(range);
<a name="l00284"></a>00284   }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00291"></a>00291 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body&gt;
<a name="l00292"></a>00292   <span class="keyword">inline</span>
<a name="l00293"></a>00293   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body)
<a name="l00294"></a>00294   {
<a name="l00295"></a>00295     BoolAcquire b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00296"></a>00296     body(range);
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00304"></a>00304 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Range, <span class="keyword">typename</span> Body, <span class="keyword">typename</span> Partitioner&gt;
<a name="l00305"></a>00305   <span class="keyword">inline</span>
<a name="l00306"></a>00306   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">parallel_reduce</a> (<span class="keyword">const</span> Range &amp;range, Body &amp;body, <span class="keyword">const</span> Partitioner &amp;)
<a name="l00307"></a>00307   {
<a name="l00308"></a>00308     BoolAcquire b(<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">in_threads</a>);
<a name="l00309"></a>00309     body(range);
<a name="l00310"></a>00310   }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00317"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php">00317</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php">spin_mutex</a> 
<a name="l00318"></a>00318   {
<a name="l00319"></a>00319   <span class="keyword">public</span>:
<a name="l00320"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php#a6c427359394dcefdaf45c1bfd8e60517">00320</a>     <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php#a6c427359394dcefdaf45c1bfd8e60517">spin_mutex</a>() {}
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php">00322</a>     <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php">scoped_lock</a> 
<a name="l00323"></a>00323     {
<a name="l00324"></a>00324     <span class="keyword">public</span>:
<a name="l00325"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#a03df2b5bbc622a3e70d7ac1e7cb4d492">00325</a>       <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#a03df2b5bbc622a3e70d7ac1e7cb4d492">scoped_lock</a> () {}
<a name="l00326"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#acc7d3fee15ff96eb67d96d3147f4cb9f">00326</a>       <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#acc7d3fee15ff96eb67d96d3147f4cb9f">scoped_lock</a> ( <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php">spin_mutex</a>&amp;  ) {} 
<a name="l00327"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#a0fa5a051d6af9a39776ba9cc4b01e44a">00327</a>       <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#a0fa5a051d6af9a39776ba9cc4b01e44a">acquire</a> ( <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php">spin_mutex</a>&amp; ) {}
<a name="l00328"></a><a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#acfcb5bba3e74a193a1f8d89d96dfc9ec">00328</a>       <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex_1_1scoped__lock.php#acfcb5bba3e74a193a1f8d89d96dfc9ec">release</a> () {}
<a name="l00329"></a>00329     };
<a name="l00330"></a>00330   };
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00337"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php">00337</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php">recursive_mutex</a> 
<a name="l00338"></a>00338   {
<a name="l00339"></a>00339   <span class="keyword">public</span>:
<a name="l00340"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php#a1f7b549ba72d59be7fb7cefb5b93a9bd">00340</a>     <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php#a1f7b549ba72d59be7fb7cefb5b93a9bd">recursive_mutex</a>() {}
<a name="l00341"></a>00341 
<a name="l00342"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php">00342</a>     <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php">scoped_lock</a> 
<a name="l00343"></a>00343     {
<a name="l00344"></a>00344     <span class="keyword">public</span>:
<a name="l00345"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#af1dd5d53b34b5e327f16036fe46ad6e4">00345</a>       <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#af1dd5d53b34b5e327f16036fe46ad6e4">scoped_lock</a> () {}
<a name="l00346"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#af8178f38bc18da1641efa1e9bf7f60b4">00346</a>       <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#af8178f38bc18da1641efa1e9bf7f60b4">scoped_lock</a> ( <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php">recursive_mutex</a>&amp;  ) {} 
<a name="l00347"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#a7540d7bb8288c2d4f1cf6bc5ef89b675">00347</a>       <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#a7540d7bb8288c2d4f1cf6bc5ef89b675">acquire</a> ( <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php">recursive_mutex</a>&amp; ) {}
<a name="l00348"></a><a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#a394b2840a38b0b9a0472d1af00b6548f">00348</a>       <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex_1_1scoped__lock.php#a394b2840a38b0b9a0472d1af00b6548f">release</a> () {}
<a name="l00349"></a>00349     };
<a name="l00350"></a>00350   };
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00357"></a>00357 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00358"></a>00358   <span class="keyword">class </span><a class="code" href="classtbb_1_1atomic.php">atomic</a>
<a name="l00359"></a>00359   {
<a name="l00360"></a>00360   <span class="keyword">public</span>:
<a name="l00361"></a><a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#acc09568cd3c5f678850a7bcb1e8a81cc">00361</a>     <a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#acc09568cd3c5f678850a7bcb1e8a81cc">atomic</a> () : <a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#a0c99f0de33998e3daa11e458fb9cde1f">_val</a>(0) {}
<a name="l00362"></a><a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#ae809302b88c944f860f447d0db6deb3a">00362</a>     <a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#ae809302b88c944f860f447d0db6deb3a">operator T&amp; </a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#a0c99f0de33998e3daa11e458fb9cde1f">_val</a>; }
<a name="l00363"></a>00363   <span class="keyword">private</span>:
<a name="l00364"></a><a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#a0c99f0de33998e3daa11e458fb9cde1f">00364</a>     T <a class="code" href="classlibMesh_1_1Threads_1_1atomic.php#a0c99f0de33998e3daa11e458fb9cde1f">_val</a>;
<a name="l00365"></a>00365   };
<a name="l00366"></a>00366   
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00375"></a>00375   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00376"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php">00376</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php">BlockedRange</a> 
<a name="l00377"></a>00377   {
<a name="l00378"></a>00378   <span class="keyword">public</span>:
<a name="l00382"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">00382</a>     <span class="keyword">typedef</span> T <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a>;
<a name="l00383"></a>00383 
<a name="l00389"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a333996b8875ea1e56a5eaf0eb0e3799e">00389</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a333996b8875ea1e56a5eaf0eb0e3799e">BlockedRange</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">grainsize</a> = 1000) :
<a name="l00390"></a>00390       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>(<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">grainsize</a>)
<a name="l00391"></a>00391     {}
<a name="l00392"></a>00392 
<a name="l00399"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a97f72abbdf4c180736e7eee1ca2faade">00399</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a333996b8875ea1e56a5eaf0eb0e3799e">BlockedRange</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> first,
<a name="l00400"></a>00400                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> last,
<a name="l00401"></a>00401                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">grainsize</a> = 1000) :
<a name="l00402"></a>00402       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>(<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">grainsize</a>)
<a name="l00403"></a>00403     {
<a name="l00404"></a>00404       this-&gt;<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a13caef340c6e4aa8ade9fbd2fdf34504">reset</a>(first, last);
<a name="l00405"></a>00405     }
<a name="l00406"></a>00406 
<a name="l00420"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aa77dea5e949b11177d3d704c4a43b8d7">00420</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a333996b8875ea1e56a5eaf0eb0e3799e">BlockedRange</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php">BlockedRange&lt;T&gt;</a> &amp;r):
<a name="l00421"></a>00421       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>(r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>), 
<a name="l00422"></a>00422       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>(r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>),
<a name="l00423"></a>00423       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>(r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>)
<a name="l00424"></a>00424     {}
<a name="l00425"></a>00425     
<a name="l00431"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ab8c4438ff9f183da0783312eff1de976">00431</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a333996b8875ea1e56a5eaf0eb0e3799e">BlockedRange</a> (<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php">BlockedRange&lt;T&gt;</a> &amp;r, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a> ) : 
<a name="l00432"></a>00432       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>(r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>),
<a name="l00433"></a>00433       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>(r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>),
<a name="l00434"></a>00434       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>(r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>)
<a name="l00435"></a>00435     {
<a name="l00436"></a>00436       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a>
<a name="l00437"></a>00437         beginning = r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>,
<a name="l00438"></a>00438         ending    = r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>,
<a name="l00439"></a>00439         middle    = beginning + (ending - beginning)/2u;
<a name="l00440"></a>00440     
<a name="l00441"></a>00441       r.<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a> = <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a> = middle;
<a name="l00442"></a>00442     }
<a name="l00443"></a>00443     
<a name="l00447"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a13caef340c6e4aa8ade9fbd2fdf34504">00447</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a13caef340c6e4aa8ade9fbd2fdf34504">reset</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> first,
<a name="l00448"></a>00448                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> last)
<a name="l00449"></a>00449     {
<a name="l00450"></a>00450       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a> = first;
<a name="l00451"></a>00451       <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>   = last;
<a name="l00452"></a>00452     }
<a name="l00453"></a>00453     
<a name="l00457"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a8f875a2e02657f66c2126c1e99c5bf77">00457</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a8f875a2e02657f66c2126c1e99c5bf77">begin</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>; }  
<a name="l00458"></a>00458     
<a name="l00462"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a79b62c942b56319d74753e43921dd9e7">00462</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a79b62c942b56319d74753e43921dd9e7">end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>; }
<a name="l00463"></a>00463     
<a name="l00468"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">00468</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">grainsize</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>;}
<a name="l00469"></a>00469     
<a name="l00473"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a87a4ca7448d544e7915345103aee8321">00473</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a87a4ca7448d544e7915345103aee8321">grainsize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;gs) {<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a> = gs;}
<a name="l00474"></a>00474     
<a name="l00478"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#adb20eaa063d49dba2aacdf2851e08f56">00478</a>     <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#adb20eaa063d49dba2aacdf2851e08f56">size</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a> -<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>); }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480     <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00481"></a>00481     <span class="comment">// Methods that implement Range concept</span>
<a name="l00482"></a>00482     <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00483"></a>00483     
<a name="l00487"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a17caa11a78a546d602f3d690c23e180e">00487</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a17caa11a78a546d602f3d690c23e180e">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a> == <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>); }
<a name="l00488"></a>00488     
<a name="l00492"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a85eea3d1465f7279f459648bf1ee53b1">00492</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a85eea3d1465f7279f459648bf1ee53b1">is_divisible</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> ((<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a> + this-&gt;<a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#a08c05c2232b220ee2d70ef5bc507ce14">grainsize</a>()) &lt; <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>); }
<a name="l00493"></a>00493     
<a name="l00494"></a>00494   <span class="keyword">private</span>:
<a name="l00495"></a>00495     
<a name="l00496"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">00496</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac4ed63e3965cb5beefdf395dfa620b5c">_end</a>;
<a name="l00497"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">00497</a>     <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aff2aae9faf14ba4e9f116037fd66538e">const_iterator</a> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#ac8a1dddc6c58545b00bb18dc6ab2df4c">_begin</a>;
<a name="l00498"></a><a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">00498</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Threads_1_1BlockedRange.php#aeaeda1b210b774182ff93ecbc2f43f17">_grainsize</a>;
<a name="l00499"></a>00499   };
<a name="l00500"></a>00500   
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   
<a name="l00506"></a>00506   <span class="keyword">extern</span> <a class="code" href="classlibMesh_1_1Threads_1_1spin__mutex.php">spin_mutex</a> <a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">spin_mtx</a>;
<a name="l00507"></a>00507 
<a name="l00511"></a>00511   <span class="keyword">extern</span> <a class="code" href="classlibMesh_1_1Threads_1_1recursive__mutex.php">recursive_mutex</a> <a class="code" href="namespacelibMesh_1_1Threads.php#ad7ed8eb1154bb9d1c0a42f10126f3175">recursive_mtx</a>;
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 } <span class="comment">// namespace Threads</span>
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 } <span class="comment">// namespace libMesh</span>
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 <span class="preprocessor">#endif // #define __threads_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
