<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">threads_allocators.h</div>  </div>
</div>
<div class="contents">
<a href="threads__allocators_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: threads_allocators.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __threads_allocators_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __threads_allocators_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;memory&gt;</span> <span class="comment">// for std::allocator</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Threading building blocks includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;tbb/scalable_allocator.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00044"></a>00044 <span class="keyword">namespace </span>Threads
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span> 
<a name="l00048"></a>00048  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00055"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">00055</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a> : <span class="keyword">public</span> tbb::<a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;
<a name="l00056"></a>00056   {
<a name="l00057"></a>00057   <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ae5f16e5934a3ba75682dd7f12cc5877a">00058</a>     <span class="keyword">typedef</span> T* <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ae5f16e5934a3ba75682dd7f12cc5877a">pointer</a>;
<a name="l00059"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ac4a444f23e623c700d3944204b52b5db">00059</a>     <span class="keyword">typedef</span> <span class="keyword">const</span> T* <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ac4a444f23e623c700d3944204b52b5db">const_pointer</a>;
<a name="l00060"></a>00060 <span class="comment">//     typedef T&amp; reference;              // Intel 7.1 tries to instantiate an allocator&lt;void&gt;, </span>
<a name="l00061"></a>00061 <span class="comment">//     typedef const T&amp; const_reference;  // so we can&#39;t typedef a reference to void.</span>
<a name="l00062"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af747f433c47e3c4ff49c1b85e6d472bb">00062</a>     <span class="keyword">typedef</span> T <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af747f433c47e3c4ff49c1b85e6d472bb">value_type</a>;
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af6f806852fa78a943e0dd90cef475120">00063</a>     <span class="keyword">typedef</span> <span class="keywordtype">size_t</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af6f806852fa78a943e0dd90cef475120">size_type</a>;
<a name="l00064"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa27e66beb5c7189b869aa42f23ae022c">00064</a>     <span class="keyword">typedef</span> ptrdiff_t <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa27e66beb5c7189b869aa42f23ae022c">difference_type</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00067"></a><a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php">00067</a>     <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php">rebind</a> 
<a name="l00068"></a>00068     {
<a name="l00069"></a><a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php#ad8ce6fb1b8083bce939d5b47194bae08">00069</a>       <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> <a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php#ad8ce6fb1b8083bce939d5b47194bae08">other</a>;
<a name="l00070"></a>00070     };
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">00072</a>     <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">scalable_allocator</a> () :
<a name="l00073"></a>00073       tbb::<a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;() {}
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#a682e26c92abaae491eecbbf561dfa65d">00075</a>     <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">scalable_allocator</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a> &amp;a) :
<a name="l00076"></a>00076       tbb::<a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;(a) {}
<a name="l00077"></a>00077 
<a name="l00078"></a>00078     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aea1e2707f8f8917dcc29b4b113878d20">00079</a>     <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">scalable_allocator</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> &amp;a) :
<a name="l00080"></a>00080       tbb::<a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a>&lt;T&gt;(a) {}
<a name="l00081"></a>00081   };
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="preprocessor">#else //LIBMESH_HAVE_TBB_API</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088  
<a name="l00089"></a>00089  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00093"></a>00093 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00094"></a>00094   <span class="keyword">class </span>scalable_allocator : <span class="keyword">public</span> std::allocator&lt;T&gt;
<a name="l00095"></a>00095   {
<a name="l00096"></a>00096   <span class="keyword">public</span>:
<a name="l00097"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ae5f16e5934a3ba75682dd7f12cc5877a">00097</a>     <span class="keyword">typedef</span> T* <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ae5f16e5934a3ba75682dd7f12cc5877a">pointer</a>;
<a name="l00098"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ac4a444f23e623c700d3944204b52b5db">00098</a>     <span class="keyword">typedef</span> <span class="keyword">const</span> T* <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#ac4a444f23e623c700d3944204b52b5db">const_pointer</a>;
<a name="l00099"></a>00099 <span class="comment">//     typedef T&amp; reference;              // Intel 7.1 tries to instantiate an allocator&lt;void&gt;, </span>
<a name="l00100"></a>00100 <span class="comment">//     typedef const T&amp; const_reference;  // so we can&#39;t typedef a reference to void.</span>
<a name="l00101"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af747f433c47e3c4ff49c1b85e6d472bb">00101</a>     <span class="keyword">typedef</span> T <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af747f433c47e3c4ff49c1b85e6d472bb">value_type</a>;
<a name="l00102"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af6f806852fa78a943e0dd90cef475120">00102</a>     <span class="keyword">typedef</span> <span class="keywordtype">size_t</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#af6f806852fa78a943e0dd90cef475120">size_type</a>;
<a name="l00103"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa27e66beb5c7189b869aa42f23ae022c">00103</a>     <span class="keyword">typedef</span> ptrdiff_t <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa27e66beb5c7189b869aa42f23ae022c">difference_type</a>;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00106"></a>00106     <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php">rebind</a> 
<a name="l00107"></a>00107     {
<a name="l00108"></a><a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php#ad8ce6fb1b8083bce939d5b47194bae08">00108</a>       <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> <a class="code" href="structlibMesh_1_1Threads_1_1scalable__allocator_1_1rebind.php#ad8ce6fb1b8083bce939d5b47194bae08">other</a>;
<a name="l00109"></a>00109     };
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">00111</a>     <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">scalable_allocator</a> () :
<a name="l00112"></a>00112       std::allocator&lt;T&gt;() {}
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#a682e26c92abaae491eecbbf561dfa65d">00114</a>     <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">scalable_allocator</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator</a> &amp;a) :
<a name="l00115"></a>00115       std::allocator&lt;T&gt;(a) {}
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt; 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aea1e2707f8f8917dcc29b4b113878d20">00118</a>     <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php#aa77c1548e7a391e197aa4199cd74e719">scalable_allocator</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">scalable_allocator&lt;U&gt;</a> &amp;a) :
<a name="l00119"></a>00119       std::allocator&lt;T&gt;(a) {}
<a name="l00120"></a>00120   };
<a name="l00121"></a>00121   
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00125"></a>00125 } <span class="comment">// namespace Threads</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 } <span class="comment">// namespace libMesh</span>
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="preprocessor">#endif // #define __threads_allocators_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
