<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">time_solver.C</div>  </div>
</div>
<div class="contents">
<a href="time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: time_solver.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a006ce39387d1026cdc18e60a7d1e5347">00031</a> <a class="code" href="classlibMesh_1_1TimeSolver.php#a006ce39387d1026cdc18e60a7d1e5347">TimeSolver::TimeSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00032"></a>00032   : quiet (true),
<a name="l00033"></a>00033     reduce_deltat_on_diffsolver_failure (0),
<a name="l00034"></a>00034     _diff_solver (NULL),
<a name="l00035"></a>00035     _linear_solver (NULL),
<a name="l00036"></a>00036     _system (s)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a016ae01898edf74001082d4c7110a79b">00042</a> <a class="code" href="classlibMesh_1_1TimeSolver.php#a016ae01898edf74001082d4c7110a79b">TimeSolver::~TimeSolver</a> ()
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#aa6c31a2d2b1985b498bce1b52ff63e9a">00048</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#aa6c31a2d2b1985b498bce1b52ff63e9a">TimeSolver::reinit</a> ()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>-&gt;reinit();
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a>-&gt;clear();
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a>-&gt;init();
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a05faa0e4d9c664b40b518b6476766720">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a05faa0e4d9c664b40b518b6476766720">TimeSolver::init</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="comment">// If the user hasn&#39;t given us a solver to use,</span>
<a name="l00060"></a>00060   <span class="comment">// just build a default solver</span>
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00062"></a>00062     <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a> = <a class="code" href="classlibMesh_1_1DiffSolver.php#a0577e99d7a903ad3d732489cf9dbbd95">DiffSolver::build</a>(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00065"></a>00065     <a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a> = <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;::build</a>();
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>-&gt;init();
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a>-&gt;init();
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#aa2384832e4c6390cdb3bed830b3c52b0">00073</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#aa2384832e4c6390cdb3bed830b3c52b0">TimeSolver::solve</a> ()
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>-&gt;solve();
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#afbdfc3a614b82a60c89ca5024cc0ac43">00080</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#afbdfc3a614b82a60c89ca5024cc0ac43">TimeSolver::advance_timestep</a> ()
<a name="l00081"></a>00081 {
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a4e2086e907a2b295c9a8a5fb284ec93b">00086</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a4e2086e907a2b295c9a8a5fb284ec93b">TimeSolver::adjoint_recede_timestep</a> ()
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
