<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">time_solver.h</div>  </div>
</div>
<div class="contents">
<a href="time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: time_solver.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>DiffContext;
<a name="l00039"></a>00039 <span class="keyword">class </span>DiffSolver;
<a name="l00040"></a>00040 <span class="keyword">class </span>DifferentiableSystem;
<a name="l00041"></a>00041 <span class="keyword">class </span>ParameterVector;
<a name="l00042"></a>00042 <span class="keyword">class </span>SystemNorm;
<a name="l00043"></a>00043 <span class="keyword">class </span>TimeSolver;
<a name="l00044"></a>00044 
<a name="l00059"></a>00059 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00060"></a>00060 <span class="comment">// Solver class definition</span>
<a name="l00061"></a><a class="code" href="classlibMesh_1_1TimeSolver.php">00061</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;TimeSolver&gt;
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a4e7363e989661b62466ed602c1189f5a">00067</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classlibMesh_1_1TimeSolver.php#a4e7363e989661b62466ed602c1189f5a">sys_type</a>;
<a name="l00068"></a>00068   
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1TimeSolver.php#a006ce39387d1026cdc18e60a7d1e5347">TimeSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00074"></a>00074   
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a016ae01898edf74001082d4c7110a79b">~TimeSolver</a> ();
<a name="l00079"></a>00079 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a05faa0e4d9c664b40b518b6476766720">init</a> ();
<a name="l00085"></a>00085 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#aa6c31a2d2b1985b498bce1b52ff63e9a">reinit</a> ();
<a name="l00091"></a>00091 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#aa2384832e4c6390cdb3bed830b3c52b0">solve</a> ();
<a name="l00099"></a>00099 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#afbdfc3a614b82a60c89ca5024cc0ac43">advance_timestep</a> ();
<a name="l00107"></a>00107 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a4e2086e907a2b295c9a8a5fb284ec93b">adjoint_recede_timestep</a> ();
<a name="l00114"></a>00114 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#ae93a1e73cc5e4bea79942c738d038dd5">element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00123"></a>00123                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) = 0;
<a name="l00124"></a>00124 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#afe6b041195b7c116b534ff31b60b2214">side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00133"></a>00133                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) = 0;
<a name="l00134"></a>00134 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#ab8c634934e73a55d1cb397bbdb745904">00139</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#ab8c634934e73a55d1cb397bbdb745904">before_timestep</a> () {}
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a72073432986fac3e0f54a1d312955e34">00144</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1TimeSolver.php#a72073432986fac3e0f54a1d312955e34">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>; }
<a name="l00145"></a>00145 
<a name="l00149"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a7abf96cc8412560af5a6c1f44033efd9">00149</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp;<a class="code" href="classlibMesh_1_1TimeSolver.php#a7abf96cc8412560af5a6c1f44033efd9">diff_solver</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>; }
<a name="l00150"></a>00150 
<a name="l00154"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a012dc476c7840dedfe703167d66b531b">00154</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; &amp;<a class="code" href="classlibMesh_1_1TimeSolver.php#a012dc476c7840dedfe703167d66b531b">linear_solver</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a>; }
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">00159</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>;
<a name="l00160"></a>00160 
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TimeSolver.php#ad9f91c868ac40017ed2e1a74cf8e511a">du</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>&amp; norm) <span class="keyword">const</span> = 0;
<a name="l00171"></a>00171 
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a58a7309d684a6e1ed6daf1737a6125b6">is_steady</a>() <span class="keyword">const</span> = 0;
<a name="l00176"></a>00176 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a9b77957719eae28de2e753d9a99d825e">00187</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a9b77957719eae28de2e753d9a99d825e">reduce_deltat_on_diffsolver_failure</a>;
<a name="l00188"></a>00188   
<a name="l00189"></a>00189 <span class="keyword">protected</span>:
<a name="l00190"></a>00190 
<a name="l00194"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">00194</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>;
<a name="l00195"></a>00195 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">00199</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1TimeSolver.php#a14ef58eb2269df2537cfaed747117eec">_linear_solver</a>;
<a name="l00200"></a>00200 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#ac973fc3e98afd2e50a536fe9b5501d58">00204</a>   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1TimeSolver.php#ac973fc3e98afd2e50a536fe9b5501d58">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>; }
<a name="l00205"></a>00205   
<a name="l00209"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">00209</a>   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>;
<a name="l00210"></a>00210 
<a name="l00215"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#a40c0a10eb375d5c242023e74ecd14af7">00215</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a40c0a10eb375d5c242023e74ecd14af7">first_solve</a>;
<a name="l00216"></a>00216 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1TimeSolver.php#aed59a34a9f53d107b98a90e23c3eb1e9">00220</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1TimeSolver.php#aed59a34a9f53d107b98a90e23c3eb1e9">old_local_nonlinear_solution</a>;
<a name="l00221"></a>00221 };
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 } <span class="comment">// namespace libMesh</span>
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="preprocessor">#endif // #define __time_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
