<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">timestamp.C</div>  </div>
</div>
<div class="contents">
<a href="timestamp_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: timestamp.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_LOCALE    </span>
<a name="l00026"></a>00026 <span class="preprocessor"></span><span class="preprocessor">#include &lt;locale&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#endif</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Utility
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="comment">// If the locale header is available, we will use the &quot;C++&quot; way of</span>
<a name="l00038"></a>00038   <span class="comment">// creating a timestamp, otherwise, we&#39;ll fall back on the C way.</span>
<a name="l00039"></a><a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">00039</a>   std::string <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">get_timestamp</a>()
<a name="l00040"></a>00040   {
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef LIBMESH_HAVE_LOCALE    </span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>    <span class="comment">// Create time_put &quot;facet&quot;</span>
<a name="l00043"></a>00043     std::locale loc;
<a name="l00044"></a>00044     <span class="keyword">const</span> std::time_put&lt;char&gt;&amp; tp = std::use_facet &lt;std::time_put&lt;char&gt; &gt; (loc);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     <span class="comment">// Call C-style time getting functions</span>
<a name="l00047"></a>00047     time_t now    = time(NULL);
<a name="l00048"></a>00048     tm* tm_struct = localtime(&amp;now);
<a name="l00049"></a>00049   
<a name="l00050"></a>00050     <span class="comment">// Date will eventually be stored in this ostringstream&#39;s string</span>
<a name="l00051"></a>00051     std::ostringstream date_stream;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="comment">// See below for documentation on the use of the</span>
<a name="l00054"></a>00054     <span class="comment">// std::time_put::put() function</span>
<a name="l00055"></a>00055     tp.put(date_stream,        <span class="comment">/*s*/</span>
<a name="l00056"></a>00056            date_stream,        <span class="comment">/*str*/</span>
<a name="l00057"></a>00057            date_stream.fill(), <span class="comment">/*fill*/</span>
<a name="l00058"></a>00058            tm_struct,          <span class="comment">/*tm*/</span>
<a name="l00059"></a>00059            <span class="charliteral">&#39;c&#39;</span>);               <span class="comment">/*format*/</span>
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="comment">// Another way to use it is to totally customize the format...</span>
<a name="l00062"></a>00062     <span class="comment">//    char pattern[]=&quot;%d %B %Y %I:%M:%S %p&quot;;</span>
<a name="l00063"></a>00063     <span class="comment">//    tp.put(date_stream,                /*s*/</span>
<a name="l00064"></a>00064     <span class="comment">//     date_stream,                /*str*/</span>
<a name="l00065"></a>00065     <span class="comment">//     date_stream.fill(),         /*fill*/</span>
<a name="l00066"></a>00066     <span class="comment">//     tm_struct,                  /*tm*/</span>
<a name="l00067"></a>00067     <span class="comment">//     pattern,                    /*format begin*/</span>
<a name="l00068"></a>00068     <span class="comment">//     pattern+sizeof(pattern)-1); /*format end  */</span>
<a name="l00069"></a>00069   
<a name="l00070"></a>00070     <span class="keywordflow">return</span> date_stream.str();
<a name="l00071"></a>00071 <span class="preprocessor">#else</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>  <span class="comment">// C-stye code originally found here:</span>
<a name="l00073"></a>00073   <span class="comment">// http://people.sc.fsu.edu/~burkardt/cpp_src/timestamp/timestamp.C</span>
<a name="l00074"></a>00074   <span class="comment">// Author: John Burkardt, 24 September 2003</span>
<a name="l00075"></a>00075   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_size = 40;
<a name="l00076"></a>00076   <span class="keywordtype">char</span> time_buffer[time_size];
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   time_t now = time ( NULL );
<a name="l00079"></a>00079   tm* tm_struct = localtime ( &amp;now );
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// No more than time_size characters will be placed into the array.  If the</span>
<a name="l00082"></a>00082   <span class="comment">// total number of resulting characters, including the terminating</span>
<a name="l00083"></a>00083   <span class="comment">// NUL character, is not more than time_size, strftime() returns the</span>
<a name="l00084"></a>00084   <span class="comment">// number of characters in the array, not counting the terminating</span>
<a name="l00085"></a>00085   <span class="comment">// NUL.  Otherwise, zero is returned and the buffer contents are</span>
<a name="l00086"></a>00086   <span class="comment">// indeterminate.</span>
<a name="l00087"></a>00087   <span class="keywordtype">size_t</span> len = strftime ( time_buffer, time_size, <span class="stringliteral">&quot;%c&quot;</span>, tm_struct );
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (len != 0)
<a name="l00090"></a>00090     <span class="keywordflow">return</span> std::string(time_buffer);
<a name="l00091"></a>00091   <span class="keywordflow">else</span>
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error formatting time buffer, returning empty string!&quot;</span> &lt;&lt; std::endl;
<a name="l00094"></a>00094       <span class="keywordflow">return</span> std::string(<span class="stringliteral">&quot;&quot;</span>);
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="preprocessor">#endif // LIBMESH_HAVE_LOCALE</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>  }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">// std::time_put::put() documentation</span>
<a name="l00101"></a>00101   <span class="comment">// s=Iterator pointing to the first character of the output sequence.</span>
<a name="l00102"></a>00102   <span class="comment">//</span>
<a name="l00103"></a>00103   <span class="comment">// str=Object of a class derived from ios_base (generally an output</span>
<a name="l00104"></a>00104   <span class="comment">// stream object). It is used to obtain formatting information.</span>
<a name="l00105"></a>00105   <span class="comment">//</span>
<a name="l00106"></a>00106   <span class="comment">// fill=Fill character. The fill character is used in output insertion</span>
<a name="l00107"></a>00107   <span class="comment">// operations to fill spaces when the format requires some character padding.</span>
<a name="l00108"></a>00108   <span class="comment">//</span>
<a name="l00109"></a>00109   <span class="comment">// tm=Pointer to an object of type struct tm</span>
<a name="l00110"></a>00110   <span class="comment">//</span>
<a name="l00111"></a>00111   <span class="comment">// format=The final argument to time_put::put is an individual format character.</span>
<a name="l00112"></a>00112   <span class="comment">// The function will format some of the information pointed by the tm struct</span>
<a name="l00113"></a>00113   <span class="comment">// into a sequence of characters as specified by this character, just as if</span>
<a name="l00114"></a>00114   <span class="comment">// it was preceded by a percentage sign in a format string passed to strftime.</span>
<a name="l00115"></a>00115   <span class="comment">// (see &#39;man strftime&#39; for more...)</span>
<a name="l00116"></a>00116   <span class="comment">// Example: &#39;c&#39; is national representation of time and date</span>
<a name="l00117"></a>00117   <span class="comment">// &#39;c&#39; = Thu Feb  4 12:24:11 2010</span>
<a name="l00118"></a>00118   <span class="comment">//  tp.put(date_stream /*s*/,</span>
<a name="l00119"></a>00119   <span class="comment">//     date_stream /*str*/,</span>
<a name="l00120"></a>00120   <span class="comment">//     date_stream.fill() /*fill*/,</span>
<a name="l00121"></a>00121   <span class="comment">//     tm_struct, /*tm*/</span>
<a name="l00122"></a>00122   <span class="comment">//     &#39;c&#39;/*format*/);</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// We can also pass to char* to the beginning and end of the desired format:</span>
<a name="l00125"></a>00125   <span class="comment">// const charT* pattern, const charT* pat_end.  This allows us to have the full</span>
<a name="l00126"></a>00126   <span class="comment">// flexibility of strftime.</span>
<a name="l00127"></a>00127   <span class="comment">// Example: &quot;%d %B %Y %I:%M:%S %p&quot;</span>
<a name="l00128"></a>00128   <span class="comment">// 04 February 2010 01:44:10 PM</span>
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
