<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient.h</div>  </div>
</div>
<div class="contents">
<a href="transient_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: transient.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __transient_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __transient_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear_8h.php">linear.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// Transient class definition</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Linear&lt;&gt; &gt;
<a name="l00047"></a><a class="code" href="classlibMesh_1_1Transient.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Transient.php">Transient</a> : <span class="keyword">public</span> T
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050   
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1Transient.php#ac482781fa7091d58718a4cc67728fd3e">Transient</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1Transient.php#ac482781fa7091d58718a4cc67728fd3e">Transient</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00060"></a>00060              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00061"></a>00061              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1Transient.php#a2f44246150b514636b08f0f5d2dda8ec">~Transient</a> ();
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Transient.php#a06b2270e995d461b624a5b2cc8311aed">solve</a> ();
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1Transient.php#add61e10799478a2037706f084e571f12">00076</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Transient.php#add61e10799478a2037706f084e571f12">time</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#a300c5604fde8b883b5dc0ecbded870f2">_time</a>; }
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1Transient.php#ab7c17e1e03422990ff37108d9ad0f7a6">00081</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Transient.php#ab7c17e1e03422990ff37108d9ad0f7a6">t_end</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#aabf242b6c986b0d33baac6c1988dc73d">_t_end</a>; }
<a name="l00082"></a>00082 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1Transient.php#a4eac90695322c47638fb975f6379f79b">00086</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp; <a class="code" href="classlibMesh_1_1Transient.php#a4eac90695322c47638fb975f6379f79b">t_end</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#aabf242b6c986b0d33baac6c1988dc73d">_t_end</a>; }
<a name="l00087"></a>00087   
<a name="l00091"></a><a class="code" href="classlibMesh_1_1Transient.php#addac77d4ebd43dd223c7ead1cf516a36">00091</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Transient.php#addac77d4ebd43dd223c7ead1cf516a36">dt</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#adf2751d1ae4feb6ec6c451bead1c2d1b">_dt</a>; }
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1Transient.php#a6346283050562924827ea5b29aabd37f">00096</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp; <a class="code" href="classlibMesh_1_1Transient.php#a6346283050562924827ea5b29aabd37f">dt</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#adf2751d1ae4feb6ec6c451bead1c2d1b">_dt</a>; }
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1Transient.php#ab60f810cbad5a3bcca60a7cfe82d1e27">00101</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Transient.php#ab60f810cbad5a3bcca60a7cfe82d1e27">time_step</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#ab3d292096f2b4b16f96eee51c3af4aff">_time_step</a>; }
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1Transient.php#aaf892206cb09d8ce7a85f7ab5fef00eb">00106</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Transient.php#aaf892206cb09d8ce7a85f7ab5fef00eb">max_time_steps</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#adde4d1948d49b0a8764bcba5e4c0f1c0">_max_time_steps</a>; }
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1Transient.php#a12670ea0d8fefef379d01068b0604743">00111</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1Transient.php#a12670ea0d8fefef379d01068b0604743">max_time_steps</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#adde4d1948d49b0a8764bcba5e4c0f1c0">_max_time_steps</a>; }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113  
<a name="l00114"></a>00114 <span class="keyword">protected</span>:
<a name="l00115"></a>00115 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1Transient.php#abc84d71927082a7ad5c18c525e5d0929">00120</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp; <a class="code" href="classlibMesh_1_1Transient.php#abc84d71927082a7ad5c18c525e5d0929">time</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#a300c5604fde8b883b5dc0ecbded870f2">_time</a>; }
<a name="l00121"></a>00121 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1Transient.php#a06a52ec4bd198cfcd9a0f06ccd42e43e">00126</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1Transient.php#a06a52ec4bd198cfcd9a0f06ccd42e43e">time_step</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Transient.php#ab3d292096f2b4b16f96eee51c3af4aff">_time_step</a>; }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   
<a name="l00129"></a>00129 <span class="keyword">private</span>:
<a name="l00130"></a>00130 
<a name="l00134"></a><a class="code" href="classlibMesh_1_1Transient.php#a300c5604fde8b883b5dc0ecbded870f2">00134</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Transient.php#a300c5604fde8b883b5dc0ecbded870f2">_time</a>;
<a name="l00135"></a>00135 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1Transient.php#aabf242b6c986b0d33baac6c1988dc73d">00139</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Transient.php#aabf242b6c986b0d33baac6c1988dc73d">_t_end</a>;
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1Transient.php#adf2751d1ae4feb6ec6c451bead1c2d1b">00144</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Transient.php#adf2751d1ae4feb6ec6c451bead1c2d1b">_dt</a>;
<a name="l00145"></a>00145 
<a name="l00149"></a><a class="code" href="classlibMesh_1_1Transient.php#ab3d292096f2b4b16f96eee51c3af4aff">00149</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Transient.php#ab3d292096f2b4b16f96eee51c3af4aff">_time_step</a>;
<a name="l00150"></a>00150   
<a name="l00154"></a><a class="code" href="classlibMesh_1_1Transient.php#adde4d1948d49b0a8764bcba5e4c0f1c0">00154</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Transient.php#adde4d1948d49b0a8764bcba5e4c0f1c0">_max_time_steps</a>;
<a name="l00155"></a>00155 };
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00160"></a>00160 <span class="comment">// Transient inline members</span>
<a name="l00161"></a>00161 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00162"></a>00162 <span class="keyword">inline</span>
<a name="l00163"></a><a class="code" href="classlibMesh_1_1Transient.php#ac482781fa7091d58718a4cc67728fd3e">00163</a> <a class="code" href="classlibMesh_1_1Transient.php#ac482781fa7091d58718a4cc67728fd3e">Transient&lt;T&gt;::Transient</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00164"></a>00164   T               (es),   <span class="comment">// Call the base class constructor</span>
<a name="l00165"></a>00165   _time           (0.),   <span class="comment">// Default solver attributes</span>
<a name="l00166"></a>00166   _t_end          (1.e20),
<a name="l00167"></a>00167   _dt             (1.e-2),
<a name="l00168"></a>00168   _time_step      (0),
<a name="l00169"></a>00169   _max_time_steps (5)
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171 libmesh_deprecated();
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00177"></a>00177 <span class="keyword">inline</span>
<a name="l00178"></a><a class="code" href="classlibMesh_1_1Transient.php#affa89812bcb9cfd6907bdebcabf70766">00178</a> <a class="code" href="classlibMesh_1_1Transient.php#ac482781fa7091d58718a4cc67728fd3e">Transient&lt;T&gt;::Transient</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00179"></a>00179                          <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00180"></a>00180                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00181"></a>00181   <a class="code" href="classlibMesh_1_1Transient.php">Transient</a> (es),
<a name="l00182"></a>00182   T         (es, name, number)
<a name="l00183"></a>00183 {
<a name="l00184"></a>00184 libmesh_deprecated();
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00190"></a>00190 <span class="keyword">inline</span>
<a name="l00191"></a><a class="code" href="classlibMesh_1_1Transient.php#a2f44246150b514636b08f0f5d2dda8ec">00191</a> <a class="code" href="classlibMesh_1_1Transient.php#a2f44246150b514636b08f0f5d2dda8ec">Transient&lt;T&gt;::~Transient</a> ()
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00198"></a>00198 <span class="keyword">inline</span>
<a name="l00199"></a><a class="code" href="classlibMesh_1_1Transient.php#a06b2270e995d461b624a5b2cc8311aed">00199</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Transient.php#a06b2270e995d461b624a5b2cc8311aed">Transient&lt;T&gt;::solve</a> ()
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201   <span class="keywordflow">do</span>
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <span class="comment">// Incriment the time step counter</span>
<a name="l00204"></a>00204       this-&gt;time_step()++;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206       <span class="comment">// Incriment the time counter</span>
<a name="l00207"></a>00207       this-&gt;time() += this-&gt;dt();
<a name="l00208"></a>00208       
<a name="l00209"></a>00209       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Solving time step &quot;</span>
<a name="l00210"></a>00210                    &lt;&lt; this-&gt;time_step()
<a name="l00211"></a>00211                    &lt;&lt; std::endl;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213       <span class="comment">// Call the base class solver</span>
<a name="l00214"></a>00214       T::solve ();      
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216   <span class="keywordflow">while</span> ((this-&gt;time_step() &lt; this-&gt;max_time_steps()) &amp;&amp;
<a name="l00217"></a>00217          (this-&gt;time()      &lt; this-&gt;t_end()));
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 } <span class="comment">// namespace libMesh</span>
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#endif // #define __transient_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
