<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_evaluation.C</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__evaluation_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__evaluation_8h.php">transient_rb_evaluation.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// For checking for the existence of files</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aa4b0b0dbec64bd27786d82bf41a2688f">00037</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aa4b0b0dbec64bd27786d82bf41a2688f">TransientRBEvaluation::TransientRBEvaluation</a> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; rb_sys_in)
<a name="l00038"></a>00038   :
<a name="l00039"></a>00039   <a class="code" href="classlibMesh_1_1RBEvaluation.php">Parent</a>(rb_sys_in)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae1ddf429a4274bad3193738db12c2550">00043</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae1ddf429a4274bad3193738db12c2550">TransientRBEvaluation::clear</a>()
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">Parent::clear</a>();
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0e3f21b86043520b258ac2328ff93fe2">clear_riesz_representors</a>();
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0e3f21b86043520b258ac2328ff93fe2">00050</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0e3f21b86043520b258ac2328ff93fe2">TransientRBEvaluation::clear_riesz_representors</a>()
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <span class="comment">// Delete the M_q representors</span>
<a name="l00053"></a>00053   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>.size(); q_m++)
<a name="l00054"></a>00054   {
<a name="l00055"></a>00055     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m].size(); i++)
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i])
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i];
<a name="l00060"></a>00060         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i] = NULL;
<a name="l00061"></a>00061       }
<a name="l00062"></a>00062     }
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0ef8aa93c685317659079d8736500d47">00067</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0ef8aa93c685317659079d8736500d47">TransientRBEvaluation::resize_RB_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   START_LOG(<span class="stringliteral">&quot;resize_RB_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1RBEvaluation.php#aca02e1bf8920dae0745cd88eed373a32">Parent::resize_RB_data</a>(Nmax);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(Nmax,Nmax);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// Allocate dense matrices for RB solves</span>
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00079"></a>00079   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00080"></a>00080   {
<a name="l00081"></a>00081     <span class="comment">// Initialize the memory for the RB matrices</span>
<a name="l00082"></a>00082     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>[q].resize(Nmax,Nmax);
<a name="l00083"></a>00083   }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Initialize vectors for the norms of the representors</span>
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00087"></a>00087   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); i++)
<a name="l00088"></a>00088   {
<a name="l00089"></a>00089     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[i].resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00090"></a>00090     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); j++)
<a name="l00091"></a>00091     {
<a name="l00092"></a>00092       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[i][j].resize(Nmax, 0.);
<a name="l00093"></a>00093     }
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_m_hat = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()*(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()+1)/2;
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>.resize(Q_m_hat);
<a name="l00098"></a>00098   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Q_m_hat; i++)
<a name="l00099"></a>00099   {
<a name="l00100"></a>00100     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[i].resize(Nmax);
<a name="l00101"></a>00101     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;Nmax; j++)
<a name="l00102"></a>00102     {
<a name="l00103"></a>00103       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[i][j].resize(Nmax, 0.);
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00108"></a>00108   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); i++)
<a name="l00109"></a>00109   {
<a name="l00110"></a>00110     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[i].resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00111"></a>00111     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); j++)
<a name="l00112"></a>00112     {
<a name="l00113"></a>00113       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[i][j].resize(Nmax);
<a name="l00114"></a>00114       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;Nmax; k++)
<a name="l00115"></a>00115       {
<a name="l00116"></a>00116         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[i][j][k].resize(Nmax, 0.);
<a name="l00117"></a>00117       }
<a name="l00118"></a>00118     }
<a name="l00119"></a>00119   }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// Initialize the initial condition storage</span>
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>.resize(Nmax);
<a name="l00123"></a>00123   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>.size(); i++)
<a name="l00124"></a>00124   {
<a name="l00125"></a>00125     <span class="comment">// The i^th row holds a vector of lenght i+1</span>
<a name="l00126"></a>00126     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>[i].resize(i+1);
<a name="l00127"></a>00127   }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">initial_L2_error_all_N</a>.resize(Nmax, 0.);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// Resize the RB output vectors</span>
<a name="l00132"></a>00132   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aff9f3f96d6529a3db3243f098a880a2b">RB_output_error_bounds_all_k</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00134"></a>00134   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00135"></a>00135   {
<a name="l00136"></a>00136     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>[n].resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()+1, 0.);
<a name="l00137"></a>00137     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aff9f3f96d6529a3db3243f098a880a2b">RB_output_error_bounds_all_k</a>[n].resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()+1, 0.);
<a name="l00138"></a>00138   }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// Resize M_q_representor</span>
<a name="l00141"></a>00141   <span class="comment">// This is cleared in the call to clear_riesz_representors</span>
<a name="l00142"></a>00142   <span class="comment">// in Parent::resize_RB_data, so just resize here</span>
<a name="l00143"></a>00143   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00144"></a>00144   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00145"></a>00145   {
<a name="l00146"></a>00146     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m].resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>());
<a name="l00147"></a>00147   }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   STOP_LOG(<span class="stringliteral">&quot;resize_RB_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a91ae85f2d8bb7e501d0b05e13e5024f0">00152</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a91ae85f2d8bb7e501d0b05e13e5024f0">TransientRBEvaluation::RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154   START_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordflow">if</span>(N &gt; <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>())
<a name="l00157"></a>00157   {
<a name="l00158"></a>00158     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: N cannot be larger than the number &quot;</span>
<a name="l00159"></a>00159                  &lt;&lt; <span class="stringliteral">&quot;of basis functions in RB_solve&quot;</span> &lt;&lt; std::endl;
<a name="l00160"></a>00160     libmesh_error();
<a name="l00161"></a>00161   }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00164"></a>00164   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dt = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <span class="comment">// First assemble the mass matrix</span>
<a name="l00167"></a>00167   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_mass_matrix_N(N,N);
<a name="l00168"></a>00168   RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00169"></a>00169   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_M_q_m;
<a name="l00170"></a>00170   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00171"></a>00171   {
<a name="l00172"></a>00172     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>[q_m].get_principal_submatrix(N, RB_M_q_m);
<a name="l00173"></a>00173     RB_mass_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m), RB_M_q_m);
<a name="l00174"></a>00174   }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_LHS_matrix(N,N);
<a name="l00177"></a>00177   RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_RHS_matrix(N,N);
<a name="l00180"></a>00180   RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1./dt, RB_mass_matrix_N);
<a name="l00183"></a>00183   RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1./dt, RB_mass_matrix_N);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_A_q_a;
<a name="l00186"></a>00186   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00187"></a>00187   {
<a name="l00188"></a>00188     <a class="code" href="classlibMesh_1_1RBEvaluation.php#ab11cb4a429ced696761ff4b46587b8b4">RB_A_q_vector</a>[q_a].get_principal_submatrix(N, RB_A_q_a);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190     RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(       trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), RB_A_q_a);
<a name="l00191"></a>00191     RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>( -(1.-trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), RB_A_q_a);
<a name="l00192"></a>00192   }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// Set system time level to 0</span>
<a name="l00195"></a>00195   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()+1);
<a name="l00196"></a>00196   trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(0); <span class="comment">// Sets the member variable _k to zero</span>
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// Resize/clear the solution vector</span>
<a name="l00199"></a>00199   <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="comment">// Load the initial condition into RB_solution</span>
<a name="l00202"></a>00202   <span class="keywordflow">if</span>(N &gt; 0)
<a name="l00203"></a>00203   {
<a name="l00204"></a>00204     <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a> = <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>[N-1];
<a name="l00205"></a>00205   }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">// Resize/clear the old solution vector</span>
<a name="l00208"></a>00208   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="comment">// Initialize the RB rhs</span>
<a name="l00211"></a>00211   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs(N);
<a name="l00212"></a>00212   RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// Initialize the vectors storing solution data</span>
<a name="l00215"></a>00215   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">RB_temporal_solution_data</a>.resize(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()+1);
<a name="l00216"></a>00216   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=0; time_level&lt;=trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>(); time_level++)
<a name="l00217"></a>00217   {
<a name="l00218"></a>00218     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">RB_temporal_solution_data</a>[time_level].resize(N);
<a name="l00219"></a>00219   }
<a name="l00220"></a>00220   <span class="comment">// and load the initial data</span>
<a name="l00221"></a>00221   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">RB_temporal_solution_data</a>[0] = <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_bound_sum = 0.;
<a name="l00224"></a>00224   <span class="keywordflow">if</span>(N &gt; 0)
<a name="l00225"></a>00225   {
<a name="l00226"></a>00226     error_bound_sum += <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>( <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">initial_L2_error_all_N</a>[N-1], 2.);
<a name="l00227"></a>00227   }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">// Set error bound at the initial time</span>
<a name="l00230"></a>00230   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>[trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a569330d25d5c05702896779bf564490c">get_time_level</a>()] = std::sqrt(error_bound_sum);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <span class="comment">// Compute the outputs and associated error bounds at the initial time</span>
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l00234"></a>00234   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00235"></a>00235   {
<a name="l00236"></a>00236     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>[n][0] = 0.;
<a name="l00237"></a>00237     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00238"></a>00238     {
<a name="l00239"></a>00239       <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l00240"></a>00240       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>[n][0] += trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*RB_output_vector_N.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aff9f3f96d6529a3db3243f098a880a2b">RB_output_error_bounds_all_k</a>[n][0] = <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>[0] * trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l00244"></a>00244   }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a572b94b57df61e1670254e91233e5c8a">get_SCM_lower_bound</a>();
<a name="l00247"></a>00247   
<a name="l00248"></a>00248   <span class="comment">// Precompute time-invariant parts of the dual norm of the residual.</span>
<a name="l00249"></a>00249   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a68ffce951c0a1e5789d7d63c4d84edbf">cache_online_residual_terms</a>(N);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=1; time_level&lt;=trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>(); time_level++)
<a name="l00252"></a>00252   {
<a name="l00253"></a>00253     trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(time_level); <span class="comment">// This updates the member variable _k</span>
<a name="l00254"></a>00254     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a> = <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     <span class="comment">// Compute RB_rhs, as RB_LHS_matrix x old_RB_solution</span>
<a name="l00257"></a>00257     RB_RHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(RB_rhs, <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259     <span class="comment">// Add forcing terms</span>
<a name="l00260"></a>00260     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_F_q_f;
<a name="l00261"></a>00261     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00262"></a>00262     {
<a name="l00263"></a>00263       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a5835514d898b139cd742ba9be75bfc53">RB_F_q_vector</a>[q_f].get_principal_subvector(N, RB_F_q_f);
<a name="l00264"></a>00264       RB_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f), RB_F_q_f);
<a name="l00265"></a>00265     }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267     <span class="keywordflow">if</span>(N &gt; 0)
<a name="l00268"></a>00268     {
<a name="l00269"></a>00269       RB_LHS_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs, <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00270"></a>00270     }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272     <span class="comment">// Save RB_solution for current time level</span>
<a name="l00273"></a>00273     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">RB_temporal_solution_data</a>[time_level] = <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>;
<a name="l00274"></a>00274 
<a name="l00275"></a>00275     <span class="comment">// Evaluate the dual norm of the residual for RB_solution_vector</span>
<a name="l00276"></a>00276 <span class="comment">//    Real epsilon_N = uncached_compute_residual_dual_norm(N);</span>
<a name="l00277"></a>00277     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> epsilon_N = <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aea972a8b8a9aa781bb10c6f572f7b845">compute_residual_dual_norm</a>(N);
<a name="l00278"></a>00278 
<a name="l00279"></a>00279     error_bound_sum += trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">residual_scaling_numer</a>(alpha_LB) * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(epsilon_N, 2.);
<a name="l00280"></a>00280 
<a name="l00281"></a>00281     <span class="comment">// store error bound at time-level _k</span>
<a name="l00282"></a>00282     <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>[time_level] = std::sqrt(error_bound_sum/trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a763e47c3abb2cafc44d68812042a6f73">residual_scaling_denom</a>(alpha_LB));
<a name="l00283"></a>00283 
<a name="l00284"></a>00284     <span class="comment">// Now compute the outputs and associated errors</span>
<a name="l00285"></a>00285     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_output_vector_N;
<a name="l00286"></a>00286     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00287"></a>00287     {
<a name="l00288"></a>00288       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>[n][time_level] = 0.;
<a name="l00289"></a>00289       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00290"></a>00290       {
<a name="l00291"></a>00291         <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad65c54e51591fb51f21b60f37d080bdd">RB_output_vectors</a>[n][q_l].get_principal_subvector(N, RB_output_vector_N);
<a name="l00292"></a>00292         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>[n][time_level] += trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*RB_output_vector_N.dot(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00293"></a>00293       }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aff9f3f96d6529a3db3243f098a880a2b">RB_output_error_bounds_all_k</a>[n][time_level] = <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>[time_level] * trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a6cae03a0338b32c65938db1f805deb3c">eval_output_dual_norm</a>(n);
<a name="l00296"></a>00296     }
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">// Now compute the L2 norm of the RB solution at time-level _K</span>
<a name="l00300"></a>00300   <span class="comment">// to normalize the error bound</span>
<a name="l00301"></a>00301   <span class="comment">// We reuse RB_rhs here</span>
<a name="l00302"></a>00302   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_L2_matrix_N;
<a name="l00303"></a>00303   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N,RB_L2_matrix_N);
<a name="l00304"></a>00304   RB_L2_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(RB_rhs, <a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>);
<a name="l00305"></a>00305   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_RB_L2_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(RB_rhs)));
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   STOP_LOG(<span class="stringliteral">&quot;RB_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00308"></a>00308 
<a name="l00309"></a>00309    <span class="keywordflow">return</span> ( trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a56ab5090b2d6e6322742ade2772330e7">return_rel_error_bound</a> ? <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>[trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()]/final_RB_L2_norm :
<a name="l00310"></a>00310                                                   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>[trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()] );
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a68ffce951c0a1e5789d7d63c4d84edbf">00313</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a68ffce951c0a1e5789d7d63c4d84edbf">TransientRBEvaluation::cache_online_residual_terms</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   START_LOG(<span class="stringliteral">&quot;cache_online_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a33ecc2378c0bd62651d28a03a0fb8aeb">cached_Fq_term</a> = 0.;
<a name="l00320"></a>00320   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l00321"></a>00321   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l00322"></a>00322   {
<a name="l00323"></a>00323     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f1 = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f1);
<a name="l00324"></a>00324     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l00325"></a>00325     {
<a name="l00326"></a>00326       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_f1==q_f2) ? 1. : 2.;
<a name="l00327"></a>00327       cached_Fq_term += delta*cached_theta_q_f1*trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f2) * trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q];
<a name="l00328"></a>00328 
<a name="l00329"></a>00329       q++;
<a name="l00330"></a>00330     }
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a85f1a0b843c8805f0493157aff3007c6">cached_Fq_Aq_vector</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00334"></a>00334   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00335"></a>00335   {
<a name="l00336"></a>00336     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00337"></a>00337     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00338"></a>00338     {
<a name="l00339"></a>00339       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00340"></a>00340       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00341"></a>00341       {
<a name="l00342"></a>00342         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a85f1a0b843c8805f0493157aff3007c6">cached_Fq_Aq_vector</a>(i) += 2.*cached_theta_q_f*cached_theta_q_a*
<a name="l00343"></a>00343                                   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[q_f][q_a][i];
<a name="l00344"></a>00344       }
<a name="l00345"></a>00345     }
<a name="l00346"></a>00346   }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab57d3f52906fa244711efb8b686ead90">cached_Aq_Aq_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(N,N);
<a name="l00349"></a>00349   q=0;
<a name="l00350"></a>00350   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l00351"></a>00351   {
<a name="l00352"></a>00352     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a1 = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a1);
<a name="l00353"></a>00353     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l00354"></a>00354     {
<a name="l00355"></a>00355       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a2 = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a2);
<a name="l00356"></a>00356       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_a1==q_a2) ? 1. : 2.;
<a name="l00357"></a>00357 
<a name="l00358"></a>00358       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00359"></a>00359       {
<a name="l00360"></a>00360         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00361"></a>00361         {
<a name="l00362"></a>00362           <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab57d3f52906fa244711efb8b686ead90">cached_Aq_Aq_matrix</a>(i,j) += delta*
<a name="l00363"></a>00363                                       cached_theta_q_a1*cached_theta_q_a2*
<a name="l00364"></a>00364                                       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[q][i][j];
<a name="l00365"></a>00365         }
<a name="l00366"></a>00366       }
<a name="l00367"></a>00367       q++;
<a name="l00368"></a>00368     }
<a name="l00369"></a>00369   }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6cc2e62e3c331fb76925fa57493b81b3">cached_Fq_Mq_vector</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(N);
<a name="l00372"></a>00372   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00373"></a>00373   {
<a name="l00374"></a>00374     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00375"></a>00375     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00378"></a>00378       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00379"></a>00379       {
<a name="l00380"></a>00380         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6cc2e62e3c331fb76925fa57493b81b3">cached_Fq_Mq_vector</a>(i) += 2.*cached_theta_q_f * cached_theta_q_m * <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[q_f][q_m][i];
<a name="l00381"></a>00381       }
<a name="l00382"></a>00382     }
<a name="l00383"></a>00383   }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a898654e319bfc34c69f3c926852a3b9d">cached_Aq_Mq_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(N,N);
<a name="l00386"></a>00386   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00387"></a>00387   {
<a name="l00388"></a>00388     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00389"></a>00389     
<a name="l00390"></a>00390     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00391"></a>00391     {
<a name="l00392"></a>00392       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00393"></a>00393       
<a name="l00394"></a>00394       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00395"></a>00395       {
<a name="l00396"></a>00396         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00397"></a>00397         {
<a name="l00398"></a>00398           <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a898654e319bfc34c69f3c926852a3b9d">cached_Aq_Mq_matrix</a>(i,j) += 2.*cached_theta_q_a*cached_theta_q_m*<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[q_a][q_m][i][j];
<a name="l00399"></a>00399         }
<a name="l00400"></a>00400       }
<a name="l00401"></a>00401     }
<a name="l00402"></a>00402   }
<a name="l00403"></a>00403   
<a name="l00404"></a>00404   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad110c69986a29c617945291abf9f9e93">cached_Mq_Mq_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(N,N);
<a name="l00405"></a>00405   q=0;
<a name="l00406"></a>00406   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m1=0; q_m1&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m1++)
<a name="l00407"></a>00407   {
<a name="l00408"></a>00408     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m1 = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m1);
<a name="l00409"></a>00409     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m2=q_m1; q_m2&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m2++)
<a name="l00410"></a>00410     {
<a name="l00411"></a>00411       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m2 = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m2);
<a name="l00412"></a>00412       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_m1==q_m2) ? 1. : 2.;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00415"></a>00415       {
<a name="l00416"></a>00416         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00417"></a>00417         {
<a name="l00418"></a>00418           <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad110c69986a29c617945291abf9f9e93">cached_Mq_Mq_matrix</a>(i,j) += delta*
<a name="l00419"></a>00419                                       cached_theta_q_m1*cached_theta_q_m2*
<a name="l00420"></a>00420                                       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[q][i][j];
<a name="l00421"></a>00421         }
<a name="l00422"></a>00422       }
<a name="l00423"></a>00423       q++;
<a name="l00424"></a>00424     }
<a name="l00425"></a>00425   }
<a name="l00426"></a>00426   
<a name="l00427"></a>00427   STOP_LOG(<span class="stringliteral">&quot;cache_online_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aea972a8b8a9aa781bb10c6f572f7b845">00430</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aea972a8b8a9aa781bb10c6f572f7b845">TransientRBEvaluation::compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00431"></a>00431 {
<a name="l00432"></a>00432   START_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   <span class="comment">// This assembly assumes we have already called cache_online_residual_terms</span>
<a name="l00435"></a>00435   <span class="comment">// and that the RB_solve parameter is constant in time</span>
<a name="l00436"></a>00436   
<a name="l00437"></a>00437   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dt = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_u_euler_theta(N);
<a name="l00442"></a>00442   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> mass_coeffs(N);
<a name="l00443"></a>00443   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00444"></a>00444   {
<a name="l00445"></a>00445     RB_u_euler_theta(i)  = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i) +
<a name="l00446"></a>00446                           (1.-trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>(i);
<a name="l00447"></a>00447     mass_coeffs(i) = -(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i) - <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>(i))/dt;
<a name="l00448"></a>00448   }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a33ecc2378c0bd62651d28a03a0fb8aeb">cached_Fq_term</a>;
<a name="l00451"></a>00451   
<a name="l00452"></a>00452   residual_norm_sq += RB_u_euler_theta.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a85f1a0b843c8805f0493157aff3007c6">cached_Fq_Aq_vector</a>);
<a name="l00453"></a>00453   residual_norm_sq += mass_coeffs.<a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a>(<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6cc2e62e3c331fb76925fa57493b81b3">cached_Fq_Mq_vector</a>);
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00456"></a>00456     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00457"></a>00457     {
<a name="l00458"></a>00458       residual_norm_sq += RB_u_euler_theta(i)*RB_u_euler_theta(j)*<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab57d3f52906fa244711efb8b686ead90">cached_Aq_Aq_matrix</a>(i,j);
<a name="l00459"></a>00459       residual_norm_sq += mass_coeffs(i)*mass_coeffs(j)*<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad110c69986a29c617945291abf9f9e93">cached_Mq_Mq_matrix</a>(i,j);
<a name="l00460"></a>00460       residual_norm_sq += RB_u_euler_theta(i)*mass_coeffs(j)*<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a898654e319bfc34c69f3c926852a3b9d">cached_Aq_Mq_matrix</a>(i,j);
<a name="l00461"></a>00461     }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) &lt; 0)
<a name="l00465"></a>00465   {
<a name="l00466"></a>00466     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l00467"></a>00467                  &lt;&lt; <span class="stringliteral">&quot;in TransientRBEvaluation::compute_residual_dual_norm()&quot;</span> &lt;&lt; std::endl;
<a name="l00468"></a>00468 
<a name="l00469"></a>00469     <span class="comment">// Sometimes this is negative due to rounding error,</span>
<a name="l00470"></a>00470     <span class="comment">// but error is on the order of 1.e-10, so shouldn&#39;t</span>
<a name="l00471"></a>00471     <span class="comment">// affect result</span>
<a name="l00472"></a>00472 <span class="comment">//    libmesh_error();</span>
<a name="l00473"></a>00473      residual_norm_sq = std::abs(residual_norm_sq);
<a name="l00474"></a>00474   }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   STOP_LOG(<span class="stringliteral">&quot;compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( residual_norm_sq ));
<a name="l00479"></a>00479 }
<a name="l00480"></a>00480 
<a name="l00481"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a3a7d19f6293523430605fca8f7e280d2">00481</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a3a7d19f6293523430605fca8f7e280d2">TransientRBEvaluation::uncached_compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N)
<a name="l00482"></a>00482 {
<a name="l00483"></a>00483   START_LOG(<span class="stringliteral">&quot;uncached_compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <span class="comment">// Use the stored representor inner product values</span>
<a name="l00486"></a>00486   <span class="comment">// to evaluate the residual norm</span>
<a name="l00487"></a>00487   
<a name="l00488"></a>00488   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dt = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   std::vector&lt;Number&gt; RB_u_euler_theta(N);
<a name="l00493"></a>00493   std::vector&lt;Number&gt; mass_coeffs(N);
<a name="l00494"></a>00494   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00495"></a>00495   {
<a name="l00496"></a>00496     RB_u_euler_theta[i]  = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i) +
<a name="l00497"></a>00497                           (1.-trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>(i);
<a name="l00498"></a>00498     mass_coeffs[i] = -(<a class="code" href="classlibMesh_1_1RBEvaluation.php#ad9691dbfa119f75f3f0a21a33e4652a7">RB_solution</a>(i) - <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>(i))/dt;
<a name="l00499"></a>00499   }
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> residual_norm_sq = 0.;
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l00504"></a>00504   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f1=0; q_f1&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f1++)
<a name="l00505"></a>00505   {
<a name="l00506"></a>00506     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f1 = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f1);
<a name="l00507"></a>00507     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f2=q_f1; q_f2&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f2++)
<a name="l00508"></a>00508     {
<a name="l00509"></a>00509       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_f1==q_f2) ? 1. : 2.;
<a name="l00510"></a>00510       residual_norm_sq += delta*cached_theta_q_f1*trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f2) * trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a567c86950bb6d2ab2800ac0b14ed3dd2">Fq_representor_norms</a>[q];
<a name="l00511"></a>00511 
<a name="l00512"></a>00512       q++;
<a name="l00513"></a>00513     }
<a name="l00514"></a>00514   }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00517"></a>00517   {
<a name="l00518"></a>00518     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00519"></a>00519     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00520"></a>00520     {
<a name="l00521"></a>00521       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00522"></a>00522       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00523"></a>00523       {
<a name="l00524"></a>00524         residual_norm_sq += 2.*RB_u_euler_theta[i]*cached_theta_q_f*cached_theta_q_a*
<a name="l00525"></a>00525                                <a class="code" href="classlibMesh_1_1RBEvaluation.php#a845f8ca50294e8064c2fbf5c78d5a9dc">Fq_Aq_representor_norms</a>[q_f][q_a][i];
<a name="l00526"></a>00526       }
<a name="l00527"></a>00527     }
<a name="l00528"></a>00528   }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530   q=0;
<a name="l00531"></a>00531   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a1=0; q_a1&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a1++)
<a name="l00532"></a>00532   {
<a name="l00533"></a>00533     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a1 = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a1);
<a name="l00534"></a>00534     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a2=q_a1; q_a2&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a2++)
<a name="l00535"></a>00535     {
<a name="l00536"></a>00536       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a2 = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a2);
<a name="l00537"></a>00537       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_a1==q_a2) ? 1. : 2.;
<a name="l00538"></a>00538 
<a name="l00539"></a>00539       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00540"></a>00540       {
<a name="l00541"></a>00541         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00542"></a>00542         {
<a name="l00543"></a>00543           residual_norm_sq += delta*RB_u_euler_theta[i]*RB_u_euler_theta[j]*
<a name="l00544"></a>00544                               cached_theta_q_a1*cached_theta_q_a2*
<a name="l00545"></a>00545                               <a class="code" href="classlibMesh_1_1RBEvaluation.php#a83b45238c1d80d7b8530c05c7335b0b2">Aq_Aq_representor_norms</a>[q][i][j];
<a name="l00546"></a>00546         }
<a name="l00547"></a>00547       }
<a name="l00548"></a>00548       q++;
<a name="l00549"></a>00549     }
<a name="l00550"></a>00550   }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="comment">// Now add the terms due to the time-derivative</span>
<a name="l00553"></a>00553   q=0;
<a name="l00554"></a>00554   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m1=0; q_m1&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m1++)
<a name="l00555"></a>00555   {
<a name="l00556"></a>00556     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m1 = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m1);
<a name="l00557"></a>00557     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m2=q_m1; q_m2&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m2++)
<a name="l00558"></a>00558     {
<a name="l00559"></a>00559       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m2 = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m2);
<a name="l00560"></a>00560       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = (q_m1==q_m2) ? 1. : 2.;
<a name="l00561"></a>00561 
<a name="l00562"></a>00562       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00563"></a>00563       {
<a name="l00564"></a>00564         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00565"></a>00565         {
<a name="l00566"></a>00566           residual_norm_sq += delta*mass_coeffs[i]*mass_coeffs[j]*
<a name="l00567"></a>00567                               cached_theta_q_m1*cached_theta_q_m2*
<a name="l00568"></a>00568                               <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[q][i][j];
<a name="l00569"></a>00569         }
<a name="l00570"></a>00570       }
<a name="l00571"></a>00571       q++;
<a name="l00572"></a>00572     }
<a name="l00573"></a>00573   }
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00576"></a>00576   {
<a name="l00577"></a>00577     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_f = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00578"></a>00578     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00579"></a>00579     {
<a name="l00580"></a>00580       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00581"></a>00581       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00582"></a>00582       {
<a name="l00583"></a>00583         residual_norm_sq += 2.*mass_coeffs[i]*cached_theta_q_f * cached_theta_q_m * <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[q_f][q_m][i];
<a name="l00584"></a>00584       }
<a name="l00585"></a>00585     }
<a name="l00586"></a>00586   }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00589"></a>00589   {
<a name="l00590"></a>00590     <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_a = trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00591"></a>00591     
<a name="l00592"></a>00592     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00593"></a>00593     {
<a name="l00594"></a>00594       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> cached_theta_q_m = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00595"></a>00595       
<a name="l00596"></a>00596       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N; i++)
<a name="l00597"></a>00597       {
<a name="l00598"></a>00598         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;N; j++)
<a name="l00599"></a>00599         {
<a name="l00600"></a>00600           residual_norm_sq += 2.*RB_u_euler_theta[i]*mass_coeffs[j]*
<a name="l00601"></a>00601                                          cached_theta_q_a*cached_theta_q_m*
<a name="l00602"></a>00602                                          <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[q_a][q_m][i][j];
<a name="l00603"></a>00603         }
<a name="l00604"></a>00604       }
<a name="l00605"></a>00605     }
<a name="l00606"></a>00606   }
<a name="l00607"></a>00607   
<a name="l00608"></a>00608   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(residual_norm_sq) &lt; 0)
<a name="l00609"></a>00609   {
<a name="l00610"></a>00610     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Square of residual norm is negative &quot;</span>
<a name="l00611"></a>00611                  &lt;&lt; <span class="stringliteral">&quot;in TransientRBEvaluation::compute_residual_dual_norm()&quot;</span> &lt;&lt; std::endl;
<a name="l00612"></a>00612 
<a name="l00613"></a>00613     <span class="comment">// Sometimes this is negative due to rounding error,</span>
<a name="l00614"></a>00614     <span class="comment">// but error is on the order of 1.e-10, so shouldn&#39;t</span>
<a name="l00615"></a>00615     <span class="comment">// affect result</span>
<a name="l00616"></a>00616 <span class="comment">//    libmesh_error();</span>
<a name="l00617"></a>00617      residual_norm_sq = std::abs(residual_norm_sq);
<a name="l00618"></a>00618   }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 <span class="comment">//   libMesh::out &lt;&lt; &quot;slow residual_sq = &quot; &lt;&lt; slow_residual_norm_sq</span>
<a name="l00621"></a>00621 <span class="comment">//                &lt;&lt; &quot;, fast residual_sq = &quot; &lt;&lt; residual_norm_sq &lt;&lt; std::endl;</span>
<a name="l00622"></a>00622 
<a name="l00623"></a>00623   STOP_LOG(<span class="stringliteral">&quot;uncached_compute_residual_dual_norm()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( residual_norm_sq ));
<a name="l00626"></a>00626 }
<a name="l00627"></a>00627 
<a name="l00628"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a113d14592f6b8f4967d6a4054ce1a651">00628</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a113d14592f6b8f4967d6a4054ce1a651">TransientRBEvaluation::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00629"></a>00629 {
<a name="l00630"></a>00630   START_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00631"></a>00631 
<a name="l00632"></a>00632   <a class="code" href="classlibMesh_1_1RBEvaluation.php#a00e6ee9a21d2c3a4f3db3efb44582dce">Parent::write_offline_data_to_files</a>(directory_name);
<a name="l00633"></a>00633   
<a name="l00634"></a>00634   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00635"></a>00635 
<a name="l00636"></a>00636   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = <a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00637"></a>00637   libmesh_assert( n_bfs &lt;= trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>() );
<a name="l00638"></a>00638 
<a name="l00639"></a>00639   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level = 14;
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <span class="keywordflow">if</span>(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00642"></a>00642   {
<a name="l00643"></a>00643     <span class="comment">// Write out the L2 matrix</span>
<a name="l00644"></a>00644     std::ofstream RB_L2_matrix_out;
<a name="l00645"></a>00645     {
<a name="l00646"></a>00646       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00647"></a>00647       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_L2_matrix.dat&quot;</span>;
<a name="l00648"></a>00648       RB_L2_matrix_out.open(file_name.str().c_str());
<a name="l00649"></a>00649     }
<a name="l00650"></a>00650     RB_L2_matrix_out.precision(precision_level);
<a name="l00651"></a>00651     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00652"></a>00652     {
<a name="l00653"></a>00653       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00654"></a>00654       {
<a name="l00655"></a>00655         RB_L2_matrix_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00656"></a>00656       }
<a name="l00657"></a>00657     }
<a name="l00658"></a>00658     RB_L2_matrix_out.close();
<a name="l00659"></a>00659           
<a name="l00660"></a>00660     <span class="comment">// Write out the M_q matrices</span>
<a name="l00661"></a>00661     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00662"></a>00662     {
<a name="l00663"></a>00663       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00664"></a>00664       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_M_&quot;</span>;
<a name="l00665"></a>00665       OSSRealzeroright(file_name,3,0,q_m);
<a name="l00666"></a>00666       file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00667"></a>00667       std::ofstream RB_M_q_m_out(file_name.str().c_str());
<a name="l00668"></a>00668 
<a name="l00669"></a>00669       <span class="keywordflow">if</span> ( !RB_M_q_m_out.good() )
<a name="l00670"></a>00670       {
<a name="l00671"></a>00671         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_M_&quot;</span> &lt;&lt; q_m &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00672"></a>00672         libmesh_error();
<a name="l00673"></a>00673       }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675       RB_M_q_m_out.precision(precision_level);
<a name="l00676"></a>00676       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00677"></a>00677       {
<a name="l00678"></a>00678         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00679"></a>00679         {
<a name="l00680"></a>00680           RB_M_q_m_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>[q_m](i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00681"></a>00681         }
<a name="l00682"></a>00682       }
<a name="l00683"></a>00683       RB_M_q_m_out.close();
<a name="l00684"></a>00684     }
<a name="l00685"></a>00685 
<a name="l00686"></a>00686     <span class="comment">// Write out the initial condition data</span>
<a name="l00687"></a>00687     <span class="comment">// and the initial L2 error for all N</span>
<a name="l00688"></a>00688     std::ofstream initial_conditions_out;
<a name="l00689"></a>00689     {
<a name="l00690"></a>00690       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00691"></a>00691       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_conditions.dat&quot;</span>;
<a name="l00692"></a>00692       initial_conditions_out.open(file_name.str().c_str());
<a name="l00693"></a>00693     }
<a name="l00694"></a>00694     std::ofstream initial_L2_error_out;
<a name="l00695"></a>00695     {
<a name="l00696"></a>00696       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00697"></a>00697       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_L2_error.dat&quot;</span>;
<a name="l00698"></a>00698       initial_L2_error_out.open(file_name.str().c_str());
<a name="l00699"></a>00699     }
<a name="l00700"></a>00700     <span class="keywordflow">if</span> (!initial_conditions_out.good() || !initial_L2_error_out.good())
<a name="l00701"></a>00701     {
<a name="l00702"></a>00702       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening initial conditions output files&quot;</span> &lt;&lt; std::endl;
<a name="l00703"></a>00703       libmesh_error();
<a name="l00704"></a>00704     }
<a name="l00705"></a>00705 
<a name="l00706"></a>00706     initial_conditions_out.precision(precision_level);
<a name="l00707"></a>00707     initial_L2_error_out.precision(precision_level);
<a name="l00708"></a>00708 
<a name="l00709"></a>00709     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00710"></a>00710     {
<a name="l00711"></a>00711       initial_L2_error_out &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">initial_L2_error_all_N</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00712"></a>00712       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l00713"></a>00713       {
<a name="l00714"></a>00714         initial_conditions_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>[i](j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00715"></a>00715       }
<a name="l00716"></a>00716     }
<a name="l00717"></a>00717     initial_conditions_out.close();
<a name="l00718"></a>00718     initial_L2_error_out.close();
<a name="l00719"></a>00719 
<a name="l00720"></a>00720     <span class="comment">// Next write out the Fq_Mq representor norm data</span>
<a name="l00721"></a>00721     std::ofstream RB_Fq_Mq_norms_out;
<a name="l00722"></a>00722     {
<a name="l00723"></a>00723       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00724"></a>00724       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Mq_norms.dat&quot;</span>;
<a name="l00725"></a>00725       RB_Fq_Mq_norms_out.open(file_name.str().c_str());
<a name="l00726"></a>00726     }
<a name="l00727"></a>00727     <span class="keywordflow">if</span> ( !RB_Fq_Mq_norms_out.good() )
<a name="l00728"></a>00728     {
<a name="l00729"></a>00729       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00730"></a>00730       libmesh_error();
<a name="l00731"></a>00731     }
<a name="l00732"></a>00732     RB_Fq_Mq_norms_out.precision(precision_level);
<a name="l00733"></a>00733     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00734"></a>00734     {
<a name="l00735"></a>00735       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00736"></a>00736       {
<a name="l00737"></a>00737         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00738"></a>00738         {
<a name="l00739"></a>00739           RB_Fq_Mq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[q_f][q_m][i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00740"></a>00740         }
<a name="l00741"></a>00741       }
<a name="l00742"></a>00742     }
<a name="l00743"></a>00743     RB_Fq_Mq_norms_out.close();
<a name="l00744"></a>00744 
<a name="l00745"></a>00745     <span class="comment">// Next write out the Mq_Mq representor norm data</span>
<a name="l00746"></a>00746     std::ofstream RB_Mq_Mq_norms_out;
<a name="l00747"></a>00747     {
<a name="l00748"></a>00748       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00749"></a>00749       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Mq_Mq_norms.dat&quot;</span>;
<a name="l00750"></a>00750       RB_Mq_Mq_norms_out.open(file_name.str().c_str());
<a name="l00751"></a>00751     }
<a name="l00752"></a>00752     <span class="keywordflow">if</span> ( !RB_Mq_Mq_norms_out.good() )
<a name="l00753"></a>00753     {
<a name="l00754"></a>00754       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_Mq_Mq_norms_out.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00755"></a>00755       libmesh_error();
<a name="l00756"></a>00756     }
<a name="l00757"></a>00757     RB_Mq_Mq_norms_out.precision(precision_level);
<a name="l00758"></a>00758     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_m_hat = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()*(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()+1)/2;
<a name="l00759"></a>00759     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;Q_m_hat; q++)
<a name="l00760"></a>00760     {
<a name="l00761"></a>00761       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00762"></a>00762       {
<a name="l00763"></a>00763         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00764"></a>00764         {
<a name="l00765"></a>00765           RB_Mq_Mq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[q][i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00766"></a>00766         }
<a name="l00767"></a>00767       }
<a name="l00768"></a>00768     }
<a name="l00769"></a>00769     RB_Mq_Mq_norms_out.close();
<a name="l00770"></a>00770 
<a name="l00771"></a>00771     <span class="comment">// Next write out the Aq_Mq representor norm data</span>
<a name="l00772"></a>00772     std::ofstream RB_Aq_Mq_norms_out;
<a name="l00773"></a>00773     {
<a name="l00774"></a>00774       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00775"></a>00775       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Mq_norms.dat&quot;</span>;
<a name="l00776"></a>00776       RB_Aq_Mq_norms_out.open(file_name.str().c_str());
<a name="l00777"></a>00777     }
<a name="l00778"></a>00778     <span class="keywordflow">if</span> ( !RB_Aq_Mq_norms_out.good() )
<a name="l00779"></a>00779     {
<a name="l00780"></a>00780       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00781"></a>00781       libmesh_error();
<a name="l00782"></a>00782     }
<a name="l00783"></a>00783     RB_Aq_Mq_norms_out.precision(precision_level);
<a name="l00784"></a>00784     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00785"></a>00785     {
<a name="l00786"></a>00786       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00787"></a>00787       {
<a name="l00788"></a>00788         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00789"></a>00789         {
<a name="l00790"></a>00790           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00791"></a>00791           {
<a name="l00792"></a>00792             RB_Aq_Mq_norms_out &lt;&lt; std::scientific &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[q_a][q_m][i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00793"></a>00793           }
<a name="l00794"></a>00794         }
<a name="l00795"></a>00795       }
<a name="l00796"></a>00796     }
<a name="l00797"></a>00797     RB_Aq_Mq_norms_out.close();
<a name="l00798"></a>00798   }
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   <span class="comment">// Write out the residual representors to file if requested</span>
<a name="l00801"></a>00801   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l00802"></a>00802   {
<a name="l00803"></a>00803     <span class="comment">// Write out the M_q_representors.  These are useful to have when restarting,</span>
<a name="l00804"></a>00804     <span class="comment">// so you don&#39;t have to recompute them all over again.  There should be</span>
<a name="l00805"></a>00805     <span class="comment">// this-&gt;get_n_basis_functions() of these.</span>
<a name="l00806"></a>00806     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the M_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l00807"></a>00807 
<a name="l00808"></a>00808     std::ostringstream file_name;
<a name="l00809"></a>00809     <span class="keyword">const</span> std::string residual_representor_suffix = (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l00810"></a>00810 
<a name="l00811"></a>00811     <span class="comment">// Residual representors written out to their own separate directory</span>
<a name="l00812"></a>00812     std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l00813"></a>00813 
<a name="l00814"></a>00814     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> istop  = this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00815"></a>00815     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> istart = istop-<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>();
<a name="l00816"></a>00816 
<a name="l00817"></a>00817     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>.size(); ++q)
<a name="l00818"></a>00818       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=istart; i&lt;istop; ++i)
<a name="l00819"></a>00819       {
<a name="l00820"></a>00820         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out M_q_representor[&quot;</span> &lt;&lt; q &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]...&quot;</span> &lt;&lt; std::endl;
<a name="l00821"></a>00821         libmesh_assert(<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q][i] != NULL);
<a name="l00822"></a>00822 
<a name="l00823"></a>00823         file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l00824"></a>00824         file_name &lt;&lt; residual_representors_dir &lt;&lt; <span class="stringliteral">&quot;/M_q_representor&quot;</span> &lt;&lt; i &lt;&lt; residual_representor_suffix;
<a name="l00825"></a>00825 
<a name="l00826"></a>00826         {
<a name="l00827"></a>00827           <span class="comment">// No need to copy!</span>
<a name="l00828"></a>00828           <span class="comment">//*solution = *(M_q_representor[q][i]);</span>
<a name="l00829"></a>00829           <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q][i]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00830"></a>00830 
<a name="l00831"></a>00831           <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> mr_data(file_name.str(),
<a name="l00832"></a>00832                       <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a399f7ee60adcc350ce7f27e8c60ed9de">write_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834           <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">write_serialized_data</a>(mr_data, <span class="keyword">false</span>);
<a name="l00835"></a>00835 
<a name="l00836"></a>00836           <span class="comment">// Synchronize before moving on</span>
<a name="l00837"></a>00837           <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">Parallel::barrier</a>();
<a name="l00838"></a>00838 
<a name="l00839"></a>00839           <span class="comment">// Swap back.</span>
<a name="l00840"></a>00840           <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q][i]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00841"></a>00841 
<a name="l00842"></a>00842           <span class="comment">// TODO: bzip the resulting file?  See $LIBMESH_DIR/src/mesh/unstructured_mesh.C</span>
<a name="l00843"></a>00843           <span class="comment">// for the system call, be sure to do it only on one processor, etc.</span>
<a name="l00844"></a>00844         }
<a name="l00845"></a>00845       }
<a name="l00846"></a>00846   } <span class="comment">// end if store_representors</span>
<a name="l00847"></a>00847 
<a name="l00848"></a>00848   STOP_LOG(<span class="stringliteral">&quot;write_offline_data_to_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00849"></a>00849 }
<a name="l00850"></a>00850 
<a name="l00851"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a7b8937e589db61fd1e7582ce7d2c16b2">00851</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a7b8937e589db61fd1e7582ce7d2c16b2">TransientRBEvaluation::read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00852"></a>00852 {
<a name="l00853"></a>00853   START_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   <a class="code" href="classlibMesh_1_1RBEvaluation.php#acfef418793d03a546a2b679f96e17f3f">Parent::read_offline_data_from_files</a>(directory_name);
<a name="l00856"></a>00856   
<a name="l00857"></a>00857   <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb_sys = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>);
<a name="l00858"></a>00858 
<a name="l00859"></a>00859   <span class="comment">// First, find out how many basis functions we had when Greedy terminated</span>
<a name="l00860"></a>00860   <span class="comment">// This was set in RBSystem::read_offline_data_from_files</span>
<a name="l00861"></a>00861   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs = this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>();
<a name="l00862"></a>00862   
<a name="l00863"></a>00863   std::ifstream RB_L2_matrix_in;
<a name="l00864"></a>00864   {
<a name="l00865"></a>00865     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00866"></a>00866     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_L2_matrix.dat&quot;</span>;
<a name="l00867"></a>00867     RB_L2_matrix_in.open(file_name.str().c_str());
<a name="l00868"></a>00868   }
<a name="l00869"></a>00869   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00870"></a>00870   {
<a name="l00871"></a>00871     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00872"></a>00872     {
<a name="l00873"></a>00873       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00874"></a>00874       RB_L2_matrix_in &gt;&gt; value;
<a name="l00875"></a>00875       <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>(i,j) = value;
<a name="l00876"></a>00876     }
<a name="l00877"></a>00877   }
<a name="l00878"></a>00878   RB_L2_matrix_in.close();
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="comment">// Read in the M_q matrices</span>
<a name="l00881"></a>00881   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00882"></a>00882   {
<a name="l00883"></a>00883     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00884"></a>00884     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/RB_M_&quot;</span>;
<a name="l00885"></a>00885     OSSRealzeroright(file_name,3,0,q_m);
<a name="l00886"></a>00886     file_name &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00887"></a>00887     std::ifstream RB_M_q_m_in(file_name.str().c_str());
<a name="l00888"></a>00888 
<a name="l00889"></a>00889     <span class="keywordflow">if</span> ( !RB_M_q_m_in.good() )
<a name="l00890"></a>00890     {
<a name="l00891"></a>00891       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_M_&quot;</span> &lt;&lt; q_m &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00892"></a>00892       libmesh_error();
<a name="l00893"></a>00893     }
<a name="l00894"></a>00894 
<a name="l00895"></a>00895     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00896"></a>00896     {
<a name="l00897"></a>00897       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00898"></a>00898       {
<a name="l00899"></a>00899         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value;
<a name="l00900"></a>00900         RB_M_q_m_in &gt;&gt; value;
<a name="l00901"></a>00901         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>[q_m](i,j) = value;
<a name="l00902"></a>00902       }
<a name="l00903"></a>00903     }
<a name="l00904"></a>00904     RB_M_q_m_in.close();
<a name="l00905"></a>00905   }
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908   <span class="comment">// Read in the initial condition data</span>
<a name="l00909"></a>00909   <span class="comment">// and the initial L2 error for all N</span>
<a name="l00910"></a>00910   std::ifstream initial_conditions_in;
<a name="l00911"></a>00911   {
<a name="l00912"></a>00912     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00913"></a>00913     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_conditions.dat&quot;</span>;
<a name="l00914"></a>00914     initial_conditions_in.open(file_name.str().c_str());
<a name="l00915"></a>00915   }
<a name="l00916"></a>00916   std::ifstream initial_L2_error_in;
<a name="l00917"></a>00917   {
<a name="l00918"></a>00918     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00919"></a>00919     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/initial_L2_error.dat&quot;</span>;
<a name="l00920"></a>00920     initial_L2_error_in.open(file_name.str().c_str());
<a name="l00921"></a>00921   }
<a name="l00922"></a>00922   <span class="keywordflow">if</span> (!initial_conditions_in.good() || !initial_L2_error_in.good())
<a name="l00923"></a>00923   {
<a name="l00924"></a>00924     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening initial conditions output files&quot;</span> &lt;&lt; std::endl;
<a name="l00925"></a>00925     libmesh_error();
<a name="l00926"></a>00926   }
<a name="l00927"></a>00927 
<a name="l00928"></a>00928   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00929"></a>00929   {
<a name="l00930"></a>00930     initial_L2_error_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">initial_L2_error_all_N</a>[i];
<a name="l00931"></a>00931     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; j++)
<a name="l00932"></a>00932     {
<a name="l00933"></a>00933       initial_conditions_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>[i](j);
<a name="l00934"></a>00934     }
<a name="l00935"></a>00935   }
<a name="l00936"></a>00936   initial_conditions_in.close();
<a name="l00937"></a>00937   initial_L2_error_in.close();
<a name="l00938"></a>00938 
<a name="l00939"></a>00939   <span class="comment">// Next read in the Fq_Mq representor norm data</span>
<a name="l00940"></a>00940   std::ifstream RB_Fq_Mq_norms_in;
<a name="l00941"></a>00941   {
<a name="l00942"></a>00942     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00943"></a>00943     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Fq_Mq_norms.dat&quot;</span>;
<a name="l00944"></a>00944     RB_Fq_Mq_norms_in.open(file_name.str().c_str());
<a name="l00945"></a>00945   }
<a name="l00946"></a>00946   <span class="keywordflow">if</span> ( !RB_Fq_Mq_norms_in.good() )
<a name="l00947"></a>00947   {
<a name="l00948"></a>00948     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Fq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00949"></a>00949     libmesh_error();
<a name="l00950"></a>00950   }
<a name="l00951"></a>00951   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00952"></a>00952   {
<a name="l00953"></a>00953     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00954"></a>00954     {
<a name="l00955"></a>00955       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00956"></a>00956       {
<a name="l00957"></a>00957         RB_Fq_Mq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[q_f][q_m][i];
<a name="l00958"></a>00958       }
<a name="l00959"></a>00959     }
<a name="l00960"></a>00960   }
<a name="l00961"></a>00961   RB_Fq_Mq_norms_in.close();
<a name="l00962"></a>00962 
<a name="l00963"></a>00963   <span class="comment">// Next read in the Mq_Mq representor norm data</span>
<a name="l00964"></a>00964   std::ifstream RB_Mq_Mq_norms_in;
<a name="l00965"></a>00965   {
<a name="l00966"></a>00966     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00967"></a>00967     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Mq_Mq_norms.dat&quot;</span>;
<a name="l00968"></a>00968     RB_Mq_Mq_norms_in.open(file_name.str().c_str());
<a name="l00969"></a>00969   }
<a name="l00970"></a>00970   <span class="keywordflow">if</span> ( !RB_Mq_Mq_norms_in.good() )
<a name="l00971"></a>00971   {
<a name="l00972"></a>00972     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening RB_Mq_Mq_norms_in.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00973"></a>00973     libmesh_error();
<a name="l00974"></a>00974   }
<a name="l00975"></a>00975   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Q_m_hat = trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()*(trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>()+1)/2;
<a name="l00976"></a>00976   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;Q_m_hat; q++)
<a name="l00977"></a>00977   {
<a name="l00978"></a>00978     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l00979"></a>00979     {
<a name="l00980"></a>00980       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l00981"></a>00981       {
<a name="l00982"></a>00982         RB_Mq_Mq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[q][i][j];
<a name="l00983"></a>00983       }
<a name="l00984"></a>00984     }
<a name="l00985"></a>00985   }
<a name="l00986"></a>00986   RB_Mq_Mq_norms_in.close();
<a name="l00987"></a>00987 
<a name="l00988"></a>00988   <span class="comment">// Next read in the Aq_Mq representor norm data</span>
<a name="l00989"></a>00989   std::ifstream RB_Aq_Mq_norms_in;
<a name="l00990"></a>00990   {
<a name="l00991"></a>00991     <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00992"></a>00992     file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/Aq_Mq_norms.dat&quot;</span>;
<a name="l00993"></a>00993     RB_Aq_Mq_norms_in.open(file_name.str().c_str());
<a name="l00994"></a>00994   }
<a name="l00995"></a>00995   <span class="keywordflow">if</span> ( !RB_Aq_Mq_norms_in.good() )
<a name="l00996"></a>00996   {
<a name="l00997"></a>00997     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening Aq_Mq_norms.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00998"></a>00998     libmesh_error();
<a name="l00999"></a>00999   }
<a name="l01000"></a>01000   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01001"></a>01001   {
<a name="l01002"></a>01002     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;trans_rb_sys.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01003"></a>01003     {
<a name="l01004"></a>01004       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_bfs; i++)
<a name="l01005"></a>01005       {
<a name="l01006"></a>01006         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_bfs; j++)
<a name="l01007"></a>01007         {
<a name="l01008"></a>01008           RB_Aq_Mq_norms_in &gt;&gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[q_a][q_m][i][j];
<a name="l01009"></a>01009         }
<a name="l01010"></a>01010       }
<a name="l01011"></a>01011     }
<a name="l01012"></a>01012   }
<a name="l01013"></a>01013   RB_Aq_Mq_norms_in.close();
<a name="l01014"></a>01014   
<a name="l01015"></a>01015   <span class="comment">// Read in the representors if requested</span>
<a name="l01016"></a>01016   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5ac870aac52f838bd28ee088ddc095b0">store_representors</a>)
<a name="l01017"></a>01017   {
<a name="l01018"></a>01018     <span class="keyword">const</span> std::string residual_representors_dir = <span class="stringliteral">&quot;residual_representors&quot;</span>;
<a name="l01019"></a>01019     <span class="keyword">const</span> std::string residual_representor_suffix =
<a name="l01020"></a>01020       (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <span class="stringliteral">&quot;.xdr&quot;</span> : <span class="stringliteral">&quot;.dat&quot;</span>);
<a name="l01021"></a>01021 
<a name="l01022"></a>01022     std::ostringstream file_name;
<a name="l01023"></a>01023     <span class="keyword">struct </span>stat stat_info;
<a name="l01024"></a>01024       
<a name="l01025"></a>01025 
<a name="l01026"></a>01026     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the M_q_representors...&quot;</span> &lt;&lt; std::endl;
<a name="l01027"></a>01027 
<a name="l01028"></a>01028     <span class="comment">// Read in the A_q representors.  The class makes room for [Q_m][Nmax] of these.  We are going to</span>
<a name="l01029"></a>01029     <span class="comment">// read in [Q_m][this-&gt;get_n_basis_functions()].  FIXME:</span>
<a name="l01030"></a>01030     <span class="comment">// should we be worried about leaks in the locations where we&#39;re about to fill entries?</span>
<a name="l01031"></a>01031     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>.size(); ++i)
<a name="l01032"></a>01032       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[i].size(); ++j)
<a name="l01033"></a>01033       {
<a name="l01034"></a>01034         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[i][j] != NULL)
<a name="l01035"></a>01035         {
<a name="l01036"></a>01036           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error, must delete existing M_q_representor before reading in from file.&quot;</span>
<a name="l01037"></a>01037                        &lt;&lt; std::endl;
<a name="l01038"></a>01038           libmesh_error();
<a name="l01039"></a>01039         }
<a name="l01040"></a>01040       }
<a name="l01041"></a>01041 
<a name="l01042"></a>01042     <span class="comment">// Now ready to read them in from file!</span>
<a name="l01043"></a>01043     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>.size(); ++i)
<a name="l01044"></a>01044       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a4d67a1b7ab7abe1e9a11b4cb5464af9f">get_n_basis_functions</a>(); ++j)
<a name="l01045"></a>01045       {
<a name="l01046"></a>01046         file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset filename</span>
<a name="l01047"></a>01047         file_name &lt;&lt; residual_representors_dir
<a name="l01048"></a>01048                   &lt;&lt; <span class="stringliteral">&quot;/M_q_representor&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; j &lt;&lt; residual_representor_suffix;
<a name="l01049"></a>01049 
<a name="l01050"></a>01050         <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l01051"></a>01051         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01052"></a>01052         {
<a name="l01053"></a>01053           <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l01054"></a>01054 
<a name="l01055"></a>01055           <span class="keywordflow">if</span> (stat_result != 0)
<a name="l01056"></a>01056           {
<a name="l01057"></a>01057             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l01058"></a>01058             libmesh_error();
<a name="l01059"></a>01059           }
<a name="l01060"></a>01060         }
<a name="l01061"></a>01061 
<a name="l01062"></a>01062         <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> aqr_data(file_name.str(),
<a name="l01063"></a>01063                      <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a6be264f3a81564aa2cf7144b54d74552">read_binary_residual_representors</a> ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l01064"></a>01064 
<a name="l01065"></a>01065         <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(aqr_data, <span class="keyword">false</span>);
<a name="l01066"></a>01066 
<a name="l01067"></a>01067         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[i][j] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l01068"></a>01068         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[i][j]-&gt;init (<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l01069"></a>01069                                      <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01070"></a>01070 
<a name="l01071"></a>01071         <span class="comment">// No need to copy, just swap</span>
<a name="l01072"></a>01072         <span class="comment">//*M_q_representor[i][j] = *solution;</span>
<a name="l01073"></a>01073         <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[i][j]-&gt;swap(*<a class="code" href="classlibMesh_1_1RBEvaluation.php#a970d1b1aabb36c8fe6611e910e4a3098">rb_sys</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01074"></a>01074       }
<a name="l01075"></a>01075   } <span class="comment">// end if (store_representors)</span>
<a name="l01076"></a>01076 
<a name="l01077"></a>01077   STOP_LOG(<span class="stringliteral">&quot;read_offline_data_from_files()&quot;</span>, <span class="stringliteral">&quot;TransientRBEvaluation&quot;</span>);
<a name="l01078"></a>01078 
<a name="l01079"></a>01079 }
<a name="l01080"></a>01080 
<a name="l01081"></a>01081 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
