<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_evaluation.h</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__evaluation_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __transient_rb_evaluation_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __transient_rb_evaluation_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="rb__evaluation_8h.php">rb_evaluation.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028         
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// QNTransientRBEvaluation class definition</span>
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aa4b0b0dbec64bd27786d82bf41a2688f">TransientRBEvaluation</a> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; rb_sys_in);
<a name="l00050"></a>00050 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad5337c03ea5b281667e9b3d543cf9bb9">00054</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad5337c03ea5b281667e9b3d543cf9bb9">Parent</a>;
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae1ddf429a4274bad3193738db12c2550">clear</a>();
<a name="l00061"></a>00061 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0ef8aa93c685317659079d8736500d47">resize_RB_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax);
<a name="l00069"></a>00069 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a91ae85f2d8bb7e501d0b05e13e5024f0">RB_solve</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00076"></a>00076 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aea972a8b8a9aa781bb10c6f572f7b845">compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00083"></a>00083   
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a3a7d19f6293523430605fca8f7e280d2">uncached_compute_residual_dual_norm</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00091"></a>00091 
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a68ffce951c0a1e5789d7d63c4d84edbf">cache_online_residual_terms</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N);
<a name="l00098"></a>00098 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a0e3f21b86043520b258ac2328ff93fe2">clear_riesz_representors</a>();
<a name="l00106"></a>00106 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a113d14592f6b8f4967d6a4054ce1a651">write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00112"></a>00112 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a7b8937e589db61fd1e7582ce7d2c16b2">read_offline_data_from_files</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00118"></a>00118   
<a name="l00119"></a>00119   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00120"></a>00120 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">00124</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>;
<a name="l00125"></a>00125 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">00129</a>   std::vector&lt; DenseMatrix&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>;
<a name="l00130"></a>00130 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">00135</a>   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#abde33aac6344df82e6bd0951cc3ed38a">RB_outputs_all_k</a>;
<a name="l00136"></a>00136 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aff9f3f96d6529a3db3243f098a880a2b">00141</a>   std::vector&lt; std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aff9f3f96d6529a3db3243f098a880a2b">RB_output_error_bounds_all_k</a>;
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">00146</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab56380e00f65e80d08b678cdea4577fd">old_RB_solution</a>;
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">00151</a>   std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">RB_temporal_solution_data</a>;
<a name="l00152"></a>00152 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">00157</a>   std::vector&lt; Real &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aba4644b0c6622967d5e4ea99bd4ce155">error_bound_all_k</a>;
<a name="l00158"></a>00158 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">00163</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">initial_L2_error_all_N</a>;
<a name="l00164"></a>00164 
<a name="l00169"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">00169</a>   std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>;
<a name="l00170"></a>00170   
<a name="l00175"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">00175</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>;
<a name="l00176"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">00176</a>   std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>;
<a name="l00177"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">00177</a>   std::vector&lt; std::vector&lt; std::vector&lt; std::vector&lt;Number&gt; &gt; &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>;
<a name="l00178"></a>00178   
<a name="l00179"></a>00179 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a33ecc2378c0bd62651d28a03a0fb8aeb">00184</a>   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a33ecc2378c0bd62651d28a03a0fb8aeb">cached_Fq_term</a>;
<a name="l00185"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a85f1a0b843c8805f0493157aff3007c6">00185</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a85f1a0b843c8805f0493157aff3007c6">cached_Fq_Aq_vector</a>;
<a name="l00186"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab57d3f52906fa244711efb8b686ead90">00186</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ab57d3f52906fa244711efb8b686ead90">cached_Aq_Aq_matrix</a>;
<a name="l00187"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6cc2e62e3c331fb76925fa57493b81b3">00187</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6cc2e62e3c331fb76925fa57493b81b3">cached_Fq_Mq_vector</a>;
<a name="l00188"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a898654e319bfc34c69f3c926852a3b9d">00188</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a898654e319bfc34c69f3c926852a3b9d">cached_Aq_Mq_matrix</a>;
<a name="l00189"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad110c69986a29c617945291abf9f9e93">00189</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad110c69986a29c617945291abf9f9e93">cached_Mq_Mq_matrix</a>;
<a name="l00190"></a>00190 
<a name="l00195"></a><a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">00195</a>   std::vector&lt; std::vector&lt; NumericVector&lt;Number&gt;* &gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>;
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 };
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
