<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_param_subdomain_node.C</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__param__subdomain__node_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__node_8h.php">transient_rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__tree_8h.php">transient_rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a158868496bd2dd04c483f7bb60df6640">00028</a> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a158868496bd2dd04c483f7bb60df6640">TransientRBParamSubdomainNode::TransientRBParamSubdomainNode</a>(<a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php">TransientRBParamSubdomainTree</a>&amp; tree_in,
<a name="l00029"></a>00029         <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; anchor_in)
<a name="l00030"></a>00030         : <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php">Parent</a>(tree_in, anchor_in)
<a name="l00031"></a>00031 { }
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a60e4158336c550db5d00d9eb54fea59a">00033</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a60e4158336c550db5d00d9eb54fea59a">TransientRBParamSubdomainNode::add_child</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; new_anchor, <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18d">Child</a> c)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   START_LOG(<span class="stringliteral">&quot;add_child()&quot;</span>, <span class="stringliteral">&quot;TransientRBParamSubdomainNode&quot;</span>);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">// cast the tree reference to a TransientRBParamSubdomainTree</span>
<a name="l00038"></a>00038   <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php">TransientRBParamSubdomainTree</a>&amp; trans_tree =
<a name="l00039"></a>00039     libmesh_cast_ref&lt;TransientRBParamSubdomainTree&amp;&gt;(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>);
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="keywordflow">if</span>(c == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">LEFT</a>)
<a name="l00042"></a>00042   {
<a name="l00043"></a>00043     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> != NULL)
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child already exists!&quot;</span>
<a name="l00046"></a>00046                    &lt;&lt; std::endl;
<a name="l00047"></a>00047       libmesh_error();
<a name="l00048"></a>00048     }
<a name="l00049"></a>00049     <span class="keywordflow">else</span>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051       <span class="comment">// Allocate a new child node</span>
<a name="l00052"></a>00052       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a158868496bd2dd04c483f7bb60df6640">TransientRBParamSubdomainNode</a>(trans_tree, new_anchor);
<a name="l00053"></a>00053     }
<a name="l00054"></a>00054   }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordflow">if</span>(c == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RIGHT</a>)
<a name="l00057"></a>00057   {
<a name="l00058"></a>00058     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> != NULL)
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Child already exists!&quot;</span>
<a name="l00061"></a>00061                    &lt;&lt; std::endl;
<a name="l00062"></a>00062       libmesh_error();
<a name="l00063"></a>00063     }
<a name="l00064"></a>00064     <span class="keywordflow">else</span>
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       <span class="comment">// Allocate a new child node</span>
<a name="l00067"></a>00067       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a158868496bd2dd04c483f7bb60df6640">TransientRBParamSubdomainNode</a>(trans_tree, new_anchor);
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   STOP_LOG(<span class="stringliteral">&quot;add_child()&quot;</span>, <span class="stringliteral">&quot;TransientRBParamSubdomainNode&quot;</span>);
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a43bbc4ae3895f9ba7c486dadb3fbadf5">00074</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a43bbc4ae3895f9ba7c486dadb3fbadf5">TransientRBParamSubdomainNode::hp_greedy</a>()
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a7e25ddc42dd9822168351a5e083faca7">clear</a>();
<a name="l00077"></a>00077 
<a name="l00078"></a>00078     <span class="comment">// Load the (full or subsampled) training set</span>
<a name="l00079"></a>00079     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aab006ced89f06890c94199ea7d828cc8">n_subsampled_training_points</a> &gt;= <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad439a4317e0430c022eeed19a06b2ec5">n_global_training_parameters</a>())
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">load_training_set</a>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ac0430d470355eb02db9c5c7813dec26d">training_set</a> );
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083     <span class="keywordflow">else</span>
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085       std::vector&lt; std::vector&lt;Number&gt; &gt; subsampled_training_set = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a1732ae1e3a47c8313bf5884ba3f296f5">get_subsampled_training_set</a>();
<a name="l00086"></a>00086       <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a35db9e73a8fdee4ee5ebed5123d26068">load_training_set</a>( subsampled_training_set );
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a> );
<a name="l00090"></a>00090     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> greedy_bound;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     <span class="comment">// These casts have to succeed</span>
<a name="l00095"></a>00095     <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php">TransientRBParamSubdomainTree</a>&amp; trans_tree =
<a name="l00096"></a>00096       libmesh_cast_ref&lt;TransientRBParamSubdomainTree&amp;&gt;(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="comment">// Set the maximum number of truth solves to N_bar in the time-dependent case</span>
<a name="l00101"></a>00101     trans_rb.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">set_max_truth_solves</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a82c8104ddf118bda698240919f78b013">N_bar</a>);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     <span class="keywordflow">if</span> (!trans_tree.<a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af46efe1a99a351423f9960c27fcce46c">use_delta_N_in_h_stage</a>)
<a name="l00104"></a>00104     {
<a name="l00105"></a>00105         trans_rb.set_POD_tol(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>/trans_tree.<a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af4d9ffc005e80c91eb75c5cf8595617a">conserv_factor</a>);
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107     <span class="keywordflow">else</span>
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109         trans_rb.set_POD_tol(-1.);
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <span class="comment">// delta_N might be changed in basis training in the transient case</span>
<a name="l00113"></a>00113     <span class="comment">// (i.e., if we&#39;re using POD_tol, or if we hit Nmax)</span>
<a name="l00114"></a>00114     <span class="comment">// hence we save and reload delta_N</span>
<a name="l00115"></a>00115     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> saved_delta_N = trans_rb.get_delta_N();
<a name="l00116"></a>00116     greedy_bound = trans_rb.train_reduced_basis();
<a name="l00117"></a>00117     <span class="comment">// Reload delta_N</span>
<a name="l00118"></a>00118     trans_rb.set_delta_N(saved_delta_N);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     trans_rb.set_current_parameters(this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>);
<a name="l00121"></a>00121     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> RB_error = trans_rb.rb_eval-&gt;RB_solve(trans_rb.get_n_basis_functions());
<a name="l00122"></a>00122     <span class="keywordflow">if</span> (RB_error &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>/trans_tree.<a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af4d9ffc005e80c91eb75c5cf8595617a">conserv_factor</a>)
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: The h-tolerance was not satisfied at the &quot;</span>
<a name="l00125"></a>00125                      &lt;&lt; <span class="stringliteral">&quot;anchor point hence h-type refinement may not converge.&quot;</span>
<a name="l00126"></a>00126                      &lt;&lt; std::endl;
<a name="l00127"></a>00127         libmesh_error();
<a name="l00128"></a>00128     }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     <span class="keywordflow">if</span> ( greedy_bound &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#af5b8b7414c23ee8ef147b3a22382710f">h_tol</a>) <span class="comment">// recursive call to hp_greedy</span>
<a name="l00134"></a>00134     {
<a name="l00135"></a>00135         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;h tolerance not satisfied, splitting subdomain...&quot;</span> &lt;&lt; std::endl;
<a name="l00136"></a>00136         <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a4cb5f9d66d680dd3429960493ebf97f7">split_this_subdomain</a>(<span class="keyword">true</span>);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00139"></a>00139         <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141     <span class="keywordflow">else</span> <span class="comment">// terminate branch, populate the model with standard p-type,write out subelement data</span>
<a name="l00142"></a>00142     {
<a name="l00143"></a>00143         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;h tolerance satisfied, performing p-refinement...&quot;</span> &lt;&lt; std::endl;
<a name="l00144"></a>00144         greedy_bound = <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#aec037b2e684a43808a24c235b74899dd">perform_p_stage</a>(greedy_bound);
<a name="l00145"></a>00145         <span class="keywordflow">if</span> (greedy_bound &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>)
<a name="l00146"></a>00146         {
<a name="l00147"></a>00147             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;p tolerance not satisfied, splitting subdomain...&quot;</span> &lt;&lt; std::endl;
<a name="l00148"></a>00148             <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a4cb5f9d66d680dd3429960493ebf97f7">split_this_subdomain</a>(<span class="keyword">false</span>);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00151"></a>00151             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8b55b89eb8c63c9cc75d91f7b727a16c">hp_greedy</a>();
<a name="l00152"></a>00152         }
<a name="l00153"></a>00153         <span class="keywordflow">else</span>
<a name="l00154"></a>00154         {
<a name="l00155"></a>00155             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;p tolerance satisfied, subdomain &quot;</span>
<a name="l00156"></a>00156                          &lt;&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a> &lt;&lt; <span class="stringliteral">&quot; is a leaf node...&quot;</span>
<a name="l00157"></a>00157                          &lt;&lt; std::endl;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159             <span class="comment">// Finally, write out the data for this subdomain</span>
<a name="l00160"></a>00160             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a107717d12e7894851b2d5f113628ad58">write_subdomain_data_to_files</a>();
<a name="l00161"></a>00161             <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a7fa296aaec53be8a43777fd13f179f43">leaf_node_index</a>++;
<a name="l00162"></a>00162         }
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#aec037b2e684a43808a24c235b74899dd">00166</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#aec037b2e684a43808a24c235b74899dd">TransientRBParamSubdomainNode::perform_p_stage</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> greedy_bound)
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168     START_LOG(<span class="stringliteral">&quot;perform_p_stage()&quot;</span>, <span class="stringliteral">&quot;TransientRBParamSubdomainNode&quot;</span>);
<a name="l00169"></a>00169     
<a name="l00170"></a>00170     <span class="comment">// Continue the greedy process on this subdomain, i.e.</span>
<a name="l00171"></a>00171     <span class="comment">// we do not discard the basis functions generated for</span>
<a name="l00172"></a>00172     <span class="comment">// this subdomain in the h-refinement phase</span>
<a name="l00173"></a>00173     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a3178424e9ea7e39bdf7f4db2404c9eba">set_training_tolerance</a>(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175     <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; trans_rb = libmesh_cast_ref&lt;TransientRBSystem&amp;&gt;(<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="comment">// Ignore max_truth_solves and POD-tol in the p-stage</span>
<a name="l00178"></a>00178     trans_rb.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">set_POD_tol</a>(-1.);
<a name="l00179"></a>00179     trans_rb.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">set_max_truth_solves</a>(-1);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     <span class="comment">// Clear the reduced basis and reinitialize the greedy to the anchor point</span>
<a name="l00182"></a>00182     trans_rb.<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">clear</a>();
<a name="l00183"></a>00183     trans_rb.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a> );
<a name="l00184"></a>00184 
<a name="l00185"></a>00185     <span class="comment">// Checking if p-tol is already satisfied or Nmax has been reached</span>
<a name="l00186"></a>00186     <span class="comment">// if not do another (standard) greedy</span>
<a name="l00187"></a>00187     <span class="keywordflow">if</span> ( (greedy_bound &gt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a8261232adfa2e3c67b36772e9bbb1304">_tree</a>.<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#aa38e727810a120ad274bb4169a5ea664">p_tol</a>) || (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>()) )
<a name="l00188"></a>00188     {
<a name="l00189"></a>00189         greedy_bound = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">train_reduced_basis</a>();
<a name="l00190"></a>00190     }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192     STOP_LOG(<span class="stringliteral">&quot;perform_p_stage()&quot;</span>, <span class="stringliteral">&quot;TransientRBParamSubdomainNode&quot;</span>);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194     <span class="keywordflow">return</span> greedy_bound;
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a4cb5f9d66d680dd3429960493ebf97f7">00197</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a4cb5f9d66d680dd3429960493ebf97f7">TransientRBParamSubdomainNode::split_this_subdomain</a>(<span class="keywordtype">bool</span> h_stage_split)
<a name="l00198"></a>00198 {
<a name="l00199"></a>00199     START_LOG(<span class="stringliteral">&quot;split_this_subdomain()&quot;</span>, <span class="stringliteral">&quot;TransientRBParamSubdomainNode&quot;</span>);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     <span class="comment">// These first few lines are the same as RBParamSubdomainNode::split_this_subdomain</span>
<a name="l00202"></a>00202     this-&gt;<a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a60e4158336c550db5d00d9eb54fea59a">add_child</a>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(0), <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18dae0b682b625e6a6f6274c37cc8baf789c">RBParamSubdomainNode::LEFT</a>);
<a name="l00203"></a>00203     this-&gt;<a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php#a60e4158336c550db5d00d9eb54fea59a">add_child</a>( <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(1), <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#ad1f33d84f4d4e5b49515a5cd84a7f18daeec71da1ac45404e962a18da04fb96cb">RBParamSubdomainNode::RIGHT</a>);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205     <span class="comment">// Compute distance between the children anchor points, and pass to children (JLE 2010-09-16)</span>
<a name="l00206"></a>00206     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> distance_between_children_anchors = 0.;
<a name="l00207"></a>00207     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); i++)
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209         distance_between_children_anchors += <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[i] - <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[i]),<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>(2.));
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211     distance_between_children_anchors = std::sqrt(distance_between_children_anchors);
<a name="l00212"></a>00212     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a> = distance_between_children_anchors;
<a name="l00213"></a>00213     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a434fc3e392b6b7e4f8f935e0a68ef432">distance_between_anchors</a> = distance_between_children_anchors;
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     <span class="comment">// We now need some code specific to the transient case because it</span>
<a name="l00217"></a>00217     <span class="comment">// is possible that we have repeated selection of training points</span>
<a name="l00218"></a>00218     <span class="comment">// in the transient case (due to the POD-Greedy) and hence we</span>
<a name="l00219"></a>00219     <span class="comment">// may have distance_between_children_anchors == 0.</span>
<a name="l00220"></a>00220     <span class="keywordtype">bool</span> anchors_are_equal = (distance_between_children_anchors == 0.);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222     <span class="keywordflow">if</span> (h_stage_split)
<a name="l00223"></a>00223     {
<a name="l00224"></a>00224         <span class="keywordflow">if</span> (anchors_are_equal)
<a name="l00225"></a>00225         {
<a name="l00226"></a>00226             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Anchor points for children are equal!&quot;</span>
<a name="l00227"></a>00227                          &lt;&lt; std::endl;
<a name="l00228"></a>00228             libmesh_error();
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230     }
<a name="l00231"></a>00231     <span class="keywordflow">else</span>
<a name="l00232"></a>00232     {
<a name="l00233"></a>00233         <span class="keywordflow">if</span> (anchors_are_equal)
<a name="l00234"></a>00234         {
<a name="l00235"></a>00235             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=2; i&lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aada6ff5e63c65ac62c3f0ddae95f0b77">greedy_param_list</a>.size() ; i++)
<a name="l00236"></a>00236             {
<a name="l00237"></a>00237                 <span class="keywordtype">bool</span> parameters_are_equal = <span class="keyword">true</span>;
<a name="l00238"></a>00238                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>  j = 0; j &lt; <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>.size(); j++)
<a name="l00239"></a>00239                 {
<a name="l00240"></a>00240                     parameters_are_equal = ( parameters_are_equal &amp;&amp; (<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a914fa2d276aa527935e111c4bd39fdff">left_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a>[j] == <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(i)[j]));
<a name="l00241"></a>00241                 }
<a name="l00242"></a>00242                 <span class="keywordflow">if</span> (!parameters_are_equal)
<a name="l00243"></a>00243                 {
<a name="l00244"></a>00244                     <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a85f1796c2ef55cc35166347a2c76ec12">right_child</a>-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a271e33d157314a8f221ef14150812924">anchor</a> = <a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a98115e3d62497a05b6c1a383ac8f21e7">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBSystem.php#aa30b66f0a86c1c1b58216db87022766c">get_greedy_parameter</a>(i);
<a name="l00245"></a>00245                     anchors_are_equal = <span class="keyword">false</span>;
<a name="l00246"></a>00246                     <span class="keywordflow">break</span>;
<a name="l00247"></a>00247                 }
<a name="l00248"></a>00248             }
<a name="l00249"></a>00249             
<a name="l00250"></a>00250             <span class="comment">// anchors_are_equal has been updated, check if we have found different point.</span>
<a name="l00251"></a>00251             <span class="keywordflow">if</span>(anchors_are_equal) 
<a name="l00252"></a>00252             {
<a name="l00253"></a>00253                 <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Unable to find distinct anchors in additional splitting step.&quot;</span> &lt;&lt; std::endl;
<a name="l00254"></a>00254                 libmesh_error();
<a name="l00255"></a>00255             }
<a name="l00256"></a>00256         }
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259     this-&gt;<a class="code" href="classlibMesh_1_1RBParamSubdomainNode.php#a7aae71ba487f206ae1e7ffae1696cf76">initialize_child_training_sets</a>();
<a name="l00260"></a>00260 
<a name="l00261"></a>00261     STOP_LOG(<span class="stringliteral">&quot;split_this_subdomain()&quot;</span>, <span class="stringliteral">&quot;TransientRBParamSubdomainNode&quot;</span>);
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
