<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_param_subdomain_tree.C</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__param__subdomain__tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__tree_8h.php">transient_rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__param__subdomain__node_8h.php">transient_rb_param_subdomain_node.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#acf2cc746a508db72beafd279336d90c6">TransientRBParamSubdomainTree::TransientRBParamSubdomainTree</a>
<a name="l00028"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#acf2cc746a508db72beafd279336d90c6">00028</a>   (<a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; rb_system_in, <span class="keyword">const</span> std::string&amp; parameters_filename)
<a name="l00029"></a>00029   : <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">Parent</a>(rb_system_in, parameters_filename),
<a name="l00030"></a>00030     conserv_factor(-1.),
<a name="l00031"></a>00031     use_delta_N_in_h_stage(<span class="keyword">false</span>)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="comment">// Read in properties from parameters_filename</span>
<a name="l00034"></a>00034   GetPot infile(parameters_filename);
<a name="l00035"></a>00035 
<a name="l00036"></a>00036   conserv_factor = infile(<span class="stringliteral">&quot;conserv_factor&quot;</span>,conserv_factor);
<a name="l00037"></a>00037   libmesh_assert(conserv_factor &gt;= 1.);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">// Set the boolean that indicates whether we use delta_N or the POD_tol</span>
<a name="l00040"></a>00040   <span class="comment">// in order to determine how many basis functions we add in the h-stage</span>
<a name="l00041"></a>00041   <span class="comment">// refinement for a time-dependent problem.</span>
<a name="l00042"></a>00042   use_delta_N_in_h_stage = infile(<span class="stringliteral">&quot;use_delta_N_in_h_stage&quot;</span>,use_delta_N_in_h_stage);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;TransientRBParamSubdomainTree parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00045"></a>00045   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Conservativity factor: &quot;</span> &lt;&lt; conserv_factor &lt;&lt; std::endl;
<a name="l00046"></a>00046   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Using delta_N in h-stage: &quot;</span> &lt;&lt; use_delta_N_in_h_stage &lt;&lt; std::endl;
<a name="l00047"></a>00047   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#a80cbb6c96e4147f8bd5f8757c5887bc8">00050</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#a80cbb6c96e4147f8bd5f8757c5887bc8">TransientRBParamSubdomainTree::build_root_node</a>()
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   libmesh_assert(<a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a> == NULL);
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a25dd693a3842a513788af1e3eb82917c">root_node</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainNode.php">TransientRBParamSubdomainNode</a>(*<span class="keyword">this</span>, <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php#a4595e687f33dd3825433fe555a4dce9d">_rb_system</a>.<a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>());
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
