<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_param_subdomain_tree.h</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__param__subdomain__tree_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __transient_rb_param_subdomain_tree_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __transient_rb_param_subdomain_tree_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="rb__param__subdomain__tree_8h.php">rb_param_subdomain_tree.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Forward declaration</span>
<a name="l00030"></a>00030 <span class="keyword">class </span>RBParamSubdomainNode;
<a name="l00031"></a>00031 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// TransientRBParamSubdomainTree class definition</span>
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php">TransientRBParamSubdomainTree</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">RBParamSubdomainTree</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#acf2cc746a508db72beafd279336d90c6">TransientRBParamSubdomainTree</a> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a>&amp; rb_system_in, <span class="keyword">const</span> std::string&amp; parameters_filename);
<a name="l00053"></a>00053   
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#a80cbb6c96e4147f8bd5f8757c5887bc8">build_root_node</a>();
<a name="l00058"></a>00058   
<a name="l00062"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#abc732d468ac9365d8bac01604800e3f9">00062</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1RBParamSubdomainTree.php">RBParamSubdomainTree</a> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#abc732d468ac9365d8bac01604800e3f9">Parent</a>;
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af4d9ffc005e80c91eb75c5cf8595617a">00067</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af4d9ffc005e80c91eb75c5cf8595617a">conserv_factor</a>;
<a name="l00068"></a>00068 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af46efe1a99a351423f9960c27fcce46c">00074</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBParamSubdomainTree.php#af46efe1a99a351423f9960c27fcce46c">use_delta_N_in_h_stage</a>;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 };
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 } <span class="comment">// namespace libMesh</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
