<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_system.h</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __transient_rb_system_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __transient_rb_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// TransientRBSystem class definition</span>
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem</a>&lt;RBSystem&gt;
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a332178f1af3116ae727fbcdcb03eb686">TransientRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00051"></a>00051             <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00052"></a>00052             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a66cc224cd6cf5b3fe6ea704dc956b101">~TransientRBSystem</a> ();
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4bb55247df6f0012ea8e7d4086baa50e">00062</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php">TransientRBSystem</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4bb55247df6f0012ea8e7d4086baa50e">sys_type</a>;
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1687df5cea8c05ea781ab30c5c8b63d2">00067</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;RBSystem&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1687df5cea8c05ea781ab30c5c8b63d2">Parent</a>;
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">clear</a> ();
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9be4b235602aceea66681766c0832210">truth_solve</a>(<span class="keywordtype">int</span> write_interval);
<a name="l00079"></a>00079 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4c3ddeb0c9fd2b3c56b0273396464ebc">train_reduced_basis</a>(<span class="keyword">const</span> std::string&amp; directory_name = <span class="stringliteral">&quot;offline_data&quot;</span>);
<a name="l00088"></a>00088 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a70c663d69b94e1389703b8442f8f46e0">greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count);
<a name="l00094"></a>00094 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5a3140301d034e23caf1bd68a2e2209">assemble_all_affine_operators</a>();
<a name="l00100"></a>00100   
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a597eb72e0f68b4759224f0c9efcdf6df">assemble_misc_matrices</a>();
<a name="l00105"></a>00105 
<a name="l00109"></a>00109   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9171ce91830a0ebfddb1666078552366">assemble_mass_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00116"></a>00116   
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">add_scaled_mass_matrix</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00122"></a>00122                               <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00123"></a>00123 
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">mass_matrix_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00129"></a>00129                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00130"></a>00130                                  <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg);
<a name="l00131"></a>00131 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3579b9bc66d8b143704d0674d40184be">add_new_rb_evaluation_object</a>();
<a name="l00137"></a>00137   
<a name="l00142"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">00142</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">theta_q_m_vector</a>.size(); }
<a name="l00143"></a>00143   
<a name="l00148"></a>00148   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab7b6710e2f6c1b9a00680388206c39e8">attach_L2_assembly</a>(<a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a96a8761554ddf4b1cf2734f94fcda800">L2_assembly</a>);
<a name="l00149"></a>00149 
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5f1f79f9726112924e042293cb73543">attach_M_q</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_m,
<a name="l00156"></a>00156                   <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* M_q_assembly);
<a name="l00157"></a>00157 
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">assemble_Mq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix);
<a name="l00162"></a>00162   
<a name="l00166"></a>00166   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00167"></a>00167   
<a name="l00171"></a>00171   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q);
<a name="l00172"></a>00172 
<a name="l00177"></a>00177   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af1f68b4b920581dc6fb19f47f2fbd561">initialize_RB_system</a>(<span class="keywordtype">bool</span> do_not_assemble);
<a name="l00178"></a>00178 
<a name="l00182"></a>00182   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">truth_assembly</a>();
<a name="l00183"></a>00183 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">00190</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">get_max_truth_solves</a>()<span class="keyword"> const                   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a>; }
<a name="l00191"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">00191</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">set_max_truth_solves</a>(<span class="keywordtype">int</span> max_truth_solves_in) { this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a> = max_truth_solves_in; }
<a name="l00192"></a>00192 
<a name="l00196"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">00196</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>()<span class="keyword"> const        </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>; }
<a name="l00197"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a64abf8bdf7b064b4704c09c8f4f50682">00197</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a64abf8bdf7b064b4704c09c8f4f50682">set_dt</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>) { this-&gt;dt = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>; }
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">00202</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">get_POD_tol</a>()<span class="keyword"> const                </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>; }
<a name="l00203"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">00203</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">set_POD_tol</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> POD_tol_in) { this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a> = POD_tol_in; }
<a name="l00204"></a>00204 
<a name="l00212"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">00212</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()<span class="keyword"> const                 </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>; }
<a name="l00213"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a91b4d8e4e75b43cc4958945198a39efd">00213</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a91b4d8e4e75b43cc4958945198a39efd">set_euler_theta</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>) { libmesh_assert((0. &lt;= euler_theta ) &amp;&amp; (euler_theta &lt;= 1.));
<a name="l00214"></a>00214                                                  this-&gt;euler_theta = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>; }
<a name="l00215"></a>00215 
<a name="l00219"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a569330d25d5c05702896779bf564490c">00219</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a569330d25d5c05702896779bf564490c">get_time_level</a>()<span class="keyword"> const       </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>; }
<a name="l00220"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">00220</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k) { libmesh_assert(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> &lt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>); this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> = k; }
<a name="l00221"></a>00221 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">00225</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()<span class="keyword"> const       </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; }
<a name="l00226"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a287beb41c8dcc60c976eb4a95146ea84">00226</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a287beb41c8dcc60c976eb4a95146ea84">set_K</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> K) { this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a> = K; }
<a name="l00227"></a>00227 
<a name="l00232"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">00232</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>) { this-&gt;delta_N = <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>; }
<a name="l00233"></a>00233 
<a name="l00238"></a>00238   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad23a86810dc83165bb0ed2237fa6f521">load_RB_solution</a>();
<a name="l00239"></a>00239 
<a name="l00246"></a>00246   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac94d6411ae422281596c89fd15731cd0">get_error_temporal_data</a>();
<a name="l00247"></a>00247 
<a name="l00253"></a>00253   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">update_RB_initial_condition_all_N</a>();
<a name="l00254"></a>00254 
<a name="l00260"></a>00260   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">residual_scaling_numer</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha_LB);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00264"></a>00264 
<a name="l00268"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">00268</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>;
<a name="l00269"></a>00269 
<a name="l00273"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">00273</a>   std::vector&lt; SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>;
<a name="l00274"></a>00274 
<a name="l00279"></a>00279 <span class="comment">//   std::vector&lt; Number &gt; true_error_all_k;</span>
<a name="l00280"></a>00280 
<a name="l00285"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">00285</a>   std::vector&lt; std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>;
<a name="l00286"></a>00286 
<a name="l00291"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">00291</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>;
<a name="l00292"></a>00292   
<a name="l00298"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a88b1c2f6e963c1af2b38cc3c2a3eb190">00298</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a88b1c2f6e963c1af2b38cc3c2a3eb190">compute_truth_projection_error</a>;
<a name="l00299"></a>00299 
<a name="l00304"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">00304</a>   std::string <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a>;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 <span class="keyword">protected</span>:
<a name="l00307"></a>00307 
<a name="l00311"></a>00311   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">init_data</a> ();
<a name="l00312"></a>00312 
<a name="l00317"></a>00317   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8c940d821026652ec874b4bf1e1d2788">process_parameters_file</a> ();
<a name="l00318"></a>00318 
<a name="l00323"></a>00323   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ace8ecc6387181c68bc6583b414a5bd38">allocate_data_structures</a>();
<a name="l00324"></a>00324 
<a name="l00330"></a>00330   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00331"></a>00331   
<a name="l00336"></a>00336   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a14c59681fde1890ec3d0e1fbc031b784">assemble_matrix_for_output_dual_solves</a>();
<a name="l00337"></a>00337 
<a name="l00342"></a>00342   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc7508cfa934d11004a3c61914fb496a">add_IC_to_RB_space</a>();
<a name="l00343"></a>00343 
<a name="l00349"></a>00349   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4787525ef1c9e18634fef8c8dc85ad6a">enrich_RB_space</a>();
<a name="l00350"></a>00350 
<a name="l00354"></a>00354   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">update_system</a>();
<a name="l00355"></a>00355 
<a name="l00359"></a>00359   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">update_RB_system_matrices</a>();
<a name="l00360"></a>00360 
<a name="l00365"></a>00365   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products);
<a name="l00366"></a>00366 
<a name="l00372"></a>00372   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">//----------- PROTECTED DATA MEMBERS -----------//</span>
<a name="l00375"></a>00375 
<a name="l00379"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">00379</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>;
<a name="l00380"></a>00380 
<a name="l00387"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">00387</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>;
<a name="l00388"></a>00388 
<a name="l00392"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">00392</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>;
<a name="l00393"></a>00393 
<a name="l00397"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">00397</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>;
<a name="l00398"></a>00398 
<a name="l00404"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">00404</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>;
<a name="l00405"></a>00405 
<a name="l00412"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">00412</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a>;
<a name="l00413"></a>00413   
<a name="l00417"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a96a8761554ddf4b1cf2734f94fcda800">00417</a>   <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a96a8761554ddf4b1cf2734f94fcda800">L2_assembly</a>;
<a name="l00418"></a>00418 
<a name="l00423"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">00423</a>   std::vector&lt;RBTheta*&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">theta_q_m_vector</a>;
<a name="l00424"></a>00424   
<a name="l00428"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">00428</a>   std::vector&lt;ElemAssembly*&gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>;
<a name="l00429"></a>00429   
<a name="l00434"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">00434</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>;
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 <span class="keyword">private</span>:
<a name="l00437"></a>00437 
<a name="l00438"></a>00438   <span class="comment">//----------- PRIVATE DATA MEMBERS -----------//</span>
<a name="l00439"></a>00439 
<a name="l00443"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">00443</a>   std::vector&lt; NumericVector&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>;
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 };
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 } <span class="comment">// namespace libMesh</span>
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
