<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_system.C</div>  </div>
</div>
<div class="contents">
<a href="transient__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: transient_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="explicit__system_8h.php">explicit_system.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__implicit__system_8h.php">nonlinear_implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// TransientSystem implementation</span>
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00040"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a300ef08ad9b1c1e8a31b45c3d9afd336">00040</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#a300ef08ad9b1c1e8a31b45c3d9afd336">TransientSystem&lt;Base&gt;::TransientSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00041"></a>00041                                         <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00042"></a>00042                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   Base                 (es, name, number)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <a class="code" href="classlibMesh_1_1TransientSystem.php#a61cfd7f2e0a4c5133beae4a0e8c69141">old_local_solution</a> =
<a name="l00047"></a>00047     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00048"></a>00048       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_old_local_solution&quot;</span>)));
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1TransientSystem.php#a389416dcdfb9c95abbc373a53303bdc0">older_local_solution</a> =
<a name="l00050"></a>00050     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00051"></a>00051       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_older_local_solution&quot;</span>)));
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#ab7b4e37dc29fb4ac87e9f710f60c18c3">00057</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#ab7b4e37dc29fb4ac87e9f710f60c18c3">TransientSystem&lt;Base&gt;::~TransientSystem</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   this-&gt;clear();
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// We still have AutoPtrs for API compatibility, but</span>
<a name="l00062"></a>00062   <span class="comment">// now that we&#39;re System::add_vector()ing these, we can trust</span>
<a name="l00063"></a>00063   <span class="comment">// the base class to handle memory management</span>
<a name="l00064"></a>00064   old_local_solution.release();  
<a name="l00065"></a>00065   older_local_solution.release();  
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00071"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#aff00cbc23f30989911888cad863ee24b">00071</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#aff00cbc23f30989911888cad863ee24b">TransientSystem&lt;Base&gt;::clear</a> ()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="comment">// clear the parent data</span>
<a name="l00074"></a>00074   Base::clear();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// the old &amp; older local solutions</span>
<a name="l00077"></a>00077   <span class="comment">// are now deleted by System!</span>
<a name="l00078"></a>00078   <span class="comment">// old_local_solution-&gt;clear();</span>
<a name="l00079"></a>00079   <span class="comment">// older_local_solution-&gt;clear();  </span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// FIXME: This preserves maximum backwards compatibility,</span>
<a name="l00082"></a>00082   <span class="comment">// but is probably grossly unnecessary:</span>
<a name="l00083"></a>00083   old_local_solution.release();  
<a name="l00084"></a>00084   older_local_solution.release();  
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   old_local_solution =
<a name="l00087"></a>00087     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00088"></a>00088       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_old_local_solution&quot;</span>)));
<a name="l00089"></a>00089   older_local_solution =
<a name="l00090"></a>00090     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00091"></a>00091       (&amp;(this-&gt;add_vector(<span class="stringliteral">&quot;_transient_older_local_solution&quot;</span>)));
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00098"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a125261b1215285f17cb24424b36e9ee4">00098</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#a125261b1215285f17cb24424b36e9ee4">TransientSystem&lt;Base&gt;::init_data</a> ()
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   <span class="comment">// initialize parent data</span>
<a name="l00101"></a>00101   Base::init_data();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Initialize the old &amp; older solutions</span>
<a name="l00104"></a>00104   <span class="comment">// Using new ghosted vectors if enabled</span>
<a name="l00105"></a>00105 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>  old_local_solution-&gt;init   (this-&gt;n_dofs(), this-&gt;n_local_dofs(),
<a name="l00107"></a>00107                               this-&gt;get_dof_map().get_send_list(), <span class="keyword">false</span>,
<a name="l00108"></a>00108                               <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00109"></a>00109   older_local_solution-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(),
<a name="l00110"></a>00110                               this-&gt;get_dof_map().get_send_list(), <span class="keyword">false</span>,
<a name="l00111"></a>00111                               <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00112"></a>00112 <span class="preprocessor">#else</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>  old_local_solution-&gt;init   (this-&gt;n_dofs(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00114"></a>00114   older_local_solution-&gt;init (this-&gt;n_dofs(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>}
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#aea0d42a5efb2ce1ab6945d338e441901">00121</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#aea0d42a5efb2ce1ab6945d338e441901">TransientSystem&lt;Base&gt;::reinit</a> ()
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   <span class="comment">// initialize parent data</span>
<a name="l00124"></a>00124   Base::reinit();
<a name="l00125"></a>00125     
<a name="l00126"></a>00126   <span class="comment">// Project the old &amp; older vectors to the new mesh</span>
<a name="l00127"></a>00127   <span class="comment">// The System::reinit handles this now</span>
<a name="l00128"></a>00128   <span class="comment">// this-&gt;project_vector (*old_local_solution);</span>
<a name="l00129"></a>00129   <span class="comment">// this-&gt;project_vector (*older_local_solution);</span>
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00135"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#ab2282d619d6eece39c73af099bb1984c">00135</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#ab2282d619d6eece39c73af099bb1984c">TransientSystem&lt;Base&gt;::re_update</a> ()
<a name="l00136"></a>00136 {
<a name="l00137"></a>00137   <span class="comment">// re_update the parent system</span>
<a name="l00138"></a>00138   Base::re_update ();
<a name="l00139"></a>00139   
<a name="l00140"></a>00140   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list = this-&gt;get_dof_map().get_send_list ();
<a name="l00141"></a>00141   
<a name="l00142"></a>00142   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_dof = Base::get_dof_map().first_dof();
<a name="l00143"></a>00143   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> end_local_dof  = Base::get_dof_map().end_dof();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="comment">// Check sizes</span>
<a name="l00146"></a>00146   libmesh_assert (end_local_dof &gt;= first_local_dof);
<a name="l00147"></a>00147   libmesh_assert (older_local_solution-&gt;size() &gt;= send_list.size());
<a name="l00148"></a>00148   libmesh_assert (old_local_solution-&gt;size()   &gt;= send_list.size());
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Make sure we have something to do</span>
<a name="l00151"></a>00151   <span class="keywordflow">if</span> (first_local_dof == end_local_dof)
<a name="l00152"></a>00152     <span class="keywordflow">return</span>;
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="comment">// Update the old &amp; older solutions with the send_list,</span>
<a name="l00155"></a>00155   <span class="comment">// which may have changed since their last update.</span>
<a name="l00156"></a>00156   older_local_solution-&gt;localize (first_local_dof,
<a name="l00157"></a>00157                                   end_local_dof-1,
<a name="l00158"></a>00158                                   send_list);
<a name="l00159"></a>00159   
<a name="l00160"></a>00160   old_local_solution-&gt;localize (first_local_dof,
<a name="l00161"></a>00161                                 end_local_dof-1,
<a name="l00162"></a>00162                                 send_list);  
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00169"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a6fd0aa7c5dc3b811b96a5ece10ecf0cd">00169</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#a6fd0aa7c5dc3b811b96a5ece10ecf0cd">TransientSystem&lt;Base&gt;::old_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"> const</span>
<a name="l00170"></a>00170 <span class="keyword"></span>{
<a name="l00171"></a>00171   <span class="comment">// Check the sizes</span>
<a name="l00172"></a>00172   libmesh_assert (global_dof_number &lt; this-&gt;get_dof_map().n_dofs());
<a name="l00173"></a>00173   libmesh_assert (global_dof_number &lt; old_local_solution-&gt;size());
<a name="l00174"></a>00174    
<a name="l00175"></a>00175   <span class="keywordflow">return</span> (*old_local_solution)(global_dof_number);
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00181"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a8dc6664ab8c2318beb86466a23992f8d">00181</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#a8dc6664ab8c2318beb86466a23992f8d">TransientSystem&lt;Base&gt;::older_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"> const</span>
<a name="l00182"></a>00182 <span class="keyword"></span>{
<a name="l00183"></a>00183   <span class="comment">// Check the sizes</span>
<a name="l00184"></a>00184   libmesh_assert (global_dof_number &lt; this-&gt;get_dof_map().n_dofs());
<a name="l00185"></a>00185   libmesh_assert (global_dof_number &lt; older_local_solution-&gt;size());
<a name="l00186"></a>00186    
<a name="l00187"></a>00187   <span class="keywordflow">return</span> (*older_local_solution)(global_dof_number);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00194"></a>00194 <span class="comment">// TransientSystem instantiations</span>
<a name="l00195"></a>00195 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;LinearImplicitSystem&gt;</a>;
<a name="l00196"></a>00196 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;NonlinearImplicitSystem&gt;</a>;
<a name="l00197"></a>00197 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;ExplicitSystem&gt;</a>;
<a name="l00198"></a>00198 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;RBSystem&gt;</a>;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
