<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_system.h</div>  </div>
</div>
<div class="contents">
<a href="transient__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: transient_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __transient_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __transient_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>LinearImplicitSystem;
<a name="l00036"></a>00036 <span class="keyword">class </span>NonlinearImplicitSystem;
<a name="l00037"></a>00037 <span class="keyword">class </span>ExplicitSystem;
<a name="l00038"></a>00038 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// TransientSystem class definition</span>
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00050"></a><a class="code" href="classlibMesh_1_1TransientSystem.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem</a> : <span class="keyword">public</span> Base
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1TransientSystem.php#a300ef08ad9b1c1e8a31b45c3d9afd336">TransientSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00059"></a>00059                    <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00060"></a>00060                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#ab7b4e37dc29fb4ac87e9f710f60c18c3">~TransientSystem</a> ();
<a name="l00066"></a>00066   
<a name="l00070"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a45f8db28da6cb5c3facef59b750b694d">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#a45f8db28da6cb5c3facef59b750b694d">sys_type</a>;
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#aba8a4cc4186af8b93a3c89da1821c3dd">00075</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1TransientSystem.php#aba8a4cc4186af8b93a3c89da1821c3dd">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00076"></a>00076 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#aff00cbc23f30989911888cad863ee24b">clear</a> ();
<a name="l00082"></a>00082 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#aea0d42a5efb2ce1ab6945d338e441901">reinit</a> ();
<a name="l00088"></a>00088   
<a name="l00094"></a>00094   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1TransientSystem.php#a67e6d3ed9daa5b7c1935168eac476078">system_type</a> () <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   
<a name="l00097"></a>00097   <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00098"></a>00098   <span class="comment">// access to the solution data fields</span>
<a name="l00099"></a>00099   
<a name="l00104"></a>00104   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#a6fd0aa7c5dc3b811b96a5ece10ecf0cd">old_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00110"></a>00110   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientSystem.php#a8dc6664ab8c2318beb86466a23992f8d">older_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a61cfd7f2e0a4c5133beae4a0e8c69141">00118</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1TransientSystem.php#a61cfd7f2e0a4c5133beae4a0e8c69141">old_local_solution</a>;
<a name="l00119"></a>00119 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a389416dcdfb9c95abbc373a53303bdc0">00126</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1TransientSystem.php#a389416dcdfb9c95abbc373a53303bdc0">older_local_solution</a>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="keyword">protected</span>:
<a name="l00130"></a>00130   
<a name="l00131"></a>00131 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#a125261b1215285f17cb24424b36e9ee4">init_data</a> ();
<a name="l00137"></a>00137 
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientSystem.php#ab2282d619d6eece39c73af099bb1984c">re_update</a> ();
<a name="l00144"></a>00144 };
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="comment">// -----------------------------------------------------------</span>
<a name="l00149"></a>00149 <span class="comment">// Useful typedefs</span>
<a name="l00150"></a><a class="code" href="namespacelibMesh.php#a53aae819897d0ab51e72e106314d23d7">00150</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;LinearImplicitSystem&gt;</a> <a class="code" href="namespacelibMesh.php#a53aae819897d0ab51e72e106314d23d7">TransientImplicitSystem</a>;
<a name="l00151"></a><a class="code" href="namespacelibMesh.php#a9c3e79d3207e257906310ccc14123cdf">00151</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;LinearImplicitSystem&gt;</a> <a class="code" href="namespacelibMesh.php#a9c3e79d3207e257906310ccc14123cdf">TransientLinearImplicitSystem</a>;
<a name="l00152"></a><a class="code" href="namespacelibMesh.php#aa912fb77ea748f8211031e72dca575ef">00152</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;NonlinearImplicitSystem&gt;</a> <a class="code" href="namespacelibMesh.php#aa912fb77ea748f8211031e72dca575ef">TransientNonlinearImplicitSystem</a>;
<a name="l00153"></a><a class="code" href="namespacelibMesh.php#a76d59763fc76a51b242ec59ca217c449">00153</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TransientSystem.php">TransientSystem&lt;ExplicitSystem&gt;</a> <a class="code" href="namespacelibMesh.php#a76d59763fc76a51b242ec59ca217c449">TransientExplicitSystem</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00158"></a>00158 <span class="comment">// TransientSystem inline methods</span>
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00160"></a>00160 <span class="keyword">inline</span>
<a name="l00161"></a><a class="code" href="classlibMesh_1_1TransientSystem.php#a67e6d3ed9daa5b7c1935168eac476078">00161</a> std::string <a class="code" href="classlibMesh_1_1TransientSystem.php#a67e6d3ed9daa5b7c1935168eac476078">TransientSystem&lt;Base&gt;::system_type</a> ()<span class="keyword"> const</span>
<a name="l00162"></a>00162 <span class="keyword"></span>{
<a name="l00163"></a>00163   std::string type = <span class="stringliteral">&quot;Transient&quot;</span>;
<a name="l00164"></a>00164   type += Base::system_type ();
<a name="l00165"></a>00165   
<a name="l00166"></a>00166   <span class="keywordflow">return</span> type;
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 } <span class="comment">// namespace libMesh</span>
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
