<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tree.C</div>  </div>
</div>
<div class="contents">
<a href="tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="tree_8h.php">tree.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// Tree class method</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// constructor</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00039"></a><a class="code" href="classlibMesh_1_1Tree.php#afb4116dbc5236cd821e5c1980eb018c9">00039</a> <a class="code" href="classlibMesh_1_1Tree.php#afb4116dbc5236cd821e5c1980eb018c9">Tree&lt;N&gt;::Tree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m,
<a name="l00040"></a>00040                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level,
<a name="l00041"></a>00041                <span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> bt) :
<a name="l00042"></a>00042   <a class="code" href="classlibMesh_1_1TreeBase.php">TreeBase</a>(m),
<a name="l00043"></a>00043   root(m,level),
<a name="l00044"></a>00044   build_type(bt)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// Set the root node bounding box equal to the bounding</span>
<a name="l00047"></a>00047   <span class="comment">// box for the entire domain.</span>
<a name="l00048"></a>00048   <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.set_bounding_box (<a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(<a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>));
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tree.php#a969052acefed658e09160709db0c3eac">build_type</a> == <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">Trees::NODES</a>)
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053       <span class="comment">// Add all the nodes to the root node.  It will </span>
<a name="l00054"></a>00054       <span class="comment">// automagically build the tree for us.</span>
<a name="l00055"></a>00055       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       it  = <a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00056"></a>00056       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00057"></a>00057 
<a name="l00058"></a>00058       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00059"></a>00059         <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.insert (*it);
<a name="l00060"></a>00060       
<a name="l00061"></a>00061       <span class="comment">// Now the tree contains the nodes.</span>
<a name="l00062"></a>00062       <span class="comment">// However, we want element pointers, so here we</span>
<a name="l00063"></a>00063       <span class="comment">// convert between the two.</span>
<a name="l00064"></a>00064       std::vector&lt;std::vector&lt;const Elem*&gt; &gt; nodes_to_elem;
<a name="l00065"></a>00065       
<a name="l00066"></a>00066       <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">MeshTools::build_nodes_to_elem_map</a> (<a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>, nodes_to_elem);      
<a name="l00067"></a>00067       <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.transform_nodes_to_elements (nodes_to_elem);
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tree.php#a969052acefed658e09160709db0c3eac">build_type</a> == <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9ade07fd9bcdcf0d49239569295014a4d1">Trees::ELEMENTS</a>)
<a name="l00071"></a>00071     {
<a name="l00072"></a>00072       <span class="comment">// Add all active elements to the root node.  It will</span>
<a name="l00073"></a>00073       <span class="comment">// automatically build the tree for us.</span>
<a name="l00074"></a>00074       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00075"></a>00075       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = <a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00076"></a>00076 
<a name="l00077"></a>00077       
<a name="l00078"></a>00078       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00079"></a>00079         <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.insert (*it);
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00086"></a><a class="code" href="classlibMesh_1_1Tree.php#a67d4683831dc5956b510f4e60212043e">00086</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Tree.php#a67d4683831dc5956b510f4e60212043e">Tree&lt;N&gt;::find_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00087"></a>00087 <span class="keyword"></span>{
<a name="l00088"></a>00088   <span class="keywordflow">return</span> root.find_element(p);
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00093"></a>00093 <span class="comment">// Explicit Instantiations</span>
<a name="l00094"></a>00094 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Tree.php">Tree&lt;4&gt;</a>;
<a name="l00095"></a>00095 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Tree.php">Tree&lt;8&gt;</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 } <span class="comment">// namespace libMesh</span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
