<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tree.h</div>  </div>
</div>
<div class="contents">
<a href="tree_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tree_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tree_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="tree__node_8h.php">tree_node.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="tree__base_8h.php">tree_base.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>MeshBase;
<a name="l00036"></a>00036 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// Tree class definition</span>
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00047"></a><a class="code" href="classlibMesh_1_1Tree.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Tree.php">Tree</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TreeBase.php">TreeBase</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050   
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1Tree.php#afb4116dbc5236cd821e5c1980eb018c9">Tree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level, <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> bt=<a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">Trees::NODES</a>);
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1Tree.php#afb4116dbc5236cd821e5c1980eb018c9">Tree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Tree.php">Tree&lt;N&gt;</a>&amp; other_tree);
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1Tree.php#aca6050d772769d191fd99578c66f2fbf">00064</a>   <a class="code" href="classlibMesh_1_1Tree.php#aca6050d772769d191fd99578c66f2fbf">~Tree</a>() {}
<a name="l00065"></a>00065   
<a name="l00069"></a><a class="code" href="classlibMesh_1_1Tree.php#a5433a6297ecd5de07757bece3364e3c3">00069</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tree.php#a5433a6297ecd5de07757bece3364e3c3">print_nodes</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>)<span class="keyword"> const</span>
<a name="l00070"></a>00070 <span class="keyword">  </span>{ <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;Printing nodes...\n&quot;</span>; <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.print_nodes(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>); }
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1Tree.php#a4ddb983d8f4f106059c266c5277d8c83">00075</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tree.php#a4ddb983d8f4f106059c266c5277d8c83">print_elements</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>)<span class="keyword"> const</span>
<a name="l00076"></a>00076 <span class="keyword">  </span>{ <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;Printing elements...\n&quot;</span>; <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.print_elements(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>); }
<a name="l00077"></a>00077   
<a name="l00081"></a><a class="code" href="classlibMesh_1_1Tree.php#aa4b92d07cb8da7a453c5abc314ee3ea9">00081</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tree.php#aa4b92d07cb8da7a453c5abc314ee3ea9">n_active_bins</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>.n_active_bins(); }
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Tree.php#a67d4683831dc5956b510f4e60212043e">find_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Tree.php#a63889cc73b9036d66539654c1f0d819a">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   
<a name="l00094"></a>00094 <span class="keyword">private</span>:
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">00100</a>   <a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;N&gt;</a> <a class="code" href="classlibMesh_1_1Tree.php#a54e8f23b2c81759d0c913a204a351eb2">root</a>;
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Tree.php#a969052acefed658e09160709db0c3eac">00105</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> <a class="code" href="classlibMesh_1_1Tree.php#a969052acefed658e09160709db0c3eac">build_type</a>;
<a name="l00106"></a>00106   
<a name="l00107"></a>00107 };
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00115"></a><a class="code" href="namespacelibMesh_1_1Trees.php">00115</a> <span class="keyword">namespace </span>Trees
<a name="l00116"></a>00116 {
<a name="l00121"></a><a class="code" href="namespacelibMesh_1_1Trees.php#a29a21088dbdfa3cf27d5a38780a19760">00121</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1Tree.php">Tree&lt;4&gt;</a> <a class="code" href="namespacelibMesh_1_1Trees.php#a29a21088dbdfa3cf27d5a38780a19760">QuadTree</a>;
<a name="l00122"></a>00122 
<a name="l00127"></a><a class="code" href="namespacelibMesh_1_1Trees.php#afb2b70bbc4692560ad1dac3727feb769">00127</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1Tree.php">Tree&lt;8&gt;</a> <a class="code" href="namespacelibMesh_1_1Trees.php#afb2b70bbc4692560ad1dac3727feb769">OctTree</a>;
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00133"></a>00133 <span class="comment">// Tree class inline methods</span>
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="comment">// copy-constructor</span>
<a name="l00138"></a>00138 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00139"></a>00139 <span class="keyword">inline</span>
<a name="l00140"></a><a class="code" href="classlibMesh_1_1Tree.php#a3821d79b7b16004f6c2e45064bb559f4">00140</a> <a class="code" href="classlibMesh_1_1Tree.php#afb4116dbc5236cd821e5c1980eb018c9">Tree&lt;N&gt;::Tree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Tree.php">Tree&lt;N&gt;</a>&amp; other_tree) :
<a name="l00141"></a>00141   <a class="code" href="classlibMesh_1_1TreeBase.php">TreeBase</a>   (other_tree),
<a name="l00142"></a>00142   root       (other_tree.root),
<a name="l00143"></a>00143   build_type (other_tree.build_type)
<a name="l00144"></a>00144 {
<a name="l00145"></a>00145   libmesh_error();
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00151"></a>00151 <span class="keyword">inline</span>
<a name="l00152"></a><a class="code" href="classlibMesh_1_1Tree.php#a63889cc73b9036d66539654c1f0d819a">00152</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Tree.php#a63889cc73b9036d66539654c1f0d819a">Tree&lt;N&gt;::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword"></span>{
<a name="l00154"></a>00154   <span class="keywordflow">return</span> this-&gt;find_element(p);
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 } <span class="comment">// namespace libMesh</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
