<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tree_base.h</div>  </div>
</div>
<div class="contents">
<a href="tree__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree_base.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tree_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tree_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>TreeBase;
<a name="l00036"></a>00036 <span class="keyword">class </span>MeshBase;
<a name="l00037"></a>00037 <span class="keyword">class </span>Point;
<a name="l00038"></a>00038 <span class="keyword">class </span>Elem;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Trees
<a name="l00042"></a>00042 {
<a name="l00049"></a><a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">00049</a>   <span class="keyword">enum</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">BuildType</a> {<a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">NODES</a>=0,
<a name="l00050"></a><a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9ade07fd9bcdcf0d49239569295014a4d1">00050</a>                   <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9ade07fd9bcdcf0d49239569295014a4d1">ELEMENTS</a>,
<a name="l00051"></a><a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a24805a6a0d41f64a87aba8f745d920bd">00051</a>                   <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a24805a6a0d41f64a87aba8f745d920bd">INVALID_BUILD_TYPE</a> };
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00059"></a>00059 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00060"></a>00060 <span class="comment">// TreeBase class definition</span>
<a name="l00061"></a><a class="code" href="classlibMesh_1_1TreeBase.php">00061</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TreeBase.php">TreeBase</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;TreeBase&gt;
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 <span class="keyword">protected</span>:  
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1TreeBase.php#af115ed7a286c77fc8443fa07bb6dc63e">TreeBase</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="keyword">public</span>:
<a name="l00072"></a>00072   
<a name="l00076"></a><a class="code" href="classlibMesh_1_1TreeBase.php#a4c692573ef57d24ade056b773fde3a36">00076</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TreeBase.php#a4c692573ef57d24ade056b773fde3a36">~TreeBase</a>() {}
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeBase.php#ae97798e4dc65de7e0652268a4e3fb49b">print_nodes</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span> = 0;
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeBase.php#a1d698d7bf1ab442fe5d314c9ebbdaa61">print_elements</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span> = 0;
<a name="l00087"></a>00087   
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TreeBase.php#ac2b7609dcdf024fe82909863eeab3126">n_active_bins</a>() <span class="keyword">const</span> = 0;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1TreeBase.php#a7aa72a9fc3cdb8bc9b8539ce7f63b1df">find_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="keyword">protected</span>:
<a name="l00099"></a>00099 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">00104</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1TreeBase.php#a32a175fe474fb0ac5591c5420ba4b89d">mesh</a>;
<a name="l00105"></a>00105   
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00110"></a>00110 <span class="comment">// TreeBase class inline methods</span>
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="comment">// constructor</span>
<a name="l00113"></a>00113 <span class="keyword">inline</span>
<a name="l00114"></a><a class="code" href="classlibMesh_1_1TreeBase.php#af115ed7a286c77fc8443fa07bb6dc63e">00114</a> <a class="code" href="classlibMesh_1_1TreeBase.php#af115ed7a286c77fc8443fa07bb6dc63e">TreeBase::TreeBase</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m) :
<a name="l00115"></a>00115   <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>(m)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 } <span class="comment">// namespace libMesh</span>
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
