<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tree_node.C</div>  </div>
</div>
<div class="contents">
<a href="tree__node_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree_node.C 4390 2011-04-21 17:02:25Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="tree__node_8h.php">tree_node.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// TreeNode class methods</span>
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00037"></a><a class="code" href="classlibMesh_1_1TreeNode.php#abe7a3c67369588d07e3166ae7f12e85e">00037</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#abe7a3c67369588d07e3166ae7f12e85e">TreeNode&lt;N&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* nd)
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   libmesh_assert (nd != NULL);
<a name="l00040"></a>00040   libmesh_assert (nd-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// Return if we don&#39;t bound the node</span>
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (!this-&gt;bounds_node(nd))
<a name="l00044"></a>00044     <span class="keywordflow">return</span>;
<a name="l00045"></a>00045   
<a name="l00046"></a>00046   <span class="comment">// Only add the node if we are active</span>
<a name="l00047"></a>00047   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049       nodes.push_back (nd);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051       <span class="comment">// Refine ourself if we reach the target bin size for a TreeNode.</span>
<a name="l00052"></a>00052       <span class="keywordflow">if</span> (nodes.size() == tgt_bin_size)
<a name="l00053"></a>00053         this-&gt;refine();
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055   
<a name="l00056"></a>00056   <span class="comment">// If we are not active simply pass the node along to</span>
<a name="l00057"></a>00057   <span class="comment">// our children</span>
<a name="l00058"></a>00058   <span class="keywordflow">else</span>
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       libmesh_assert (children.size() == N);
<a name="l00061"></a>00061       
<a name="l00062"></a>00062       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;N; c++)
<a name="l00063"></a>00063         children[c]-&gt;insert (nd);
<a name="l00064"></a>00064     }
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00070"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a3f993ead6709001e9c132aca7ea52752">00070</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#abe7a3c67369588d07e3166ae7f12e85e">TreeNode&lt;N&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   libmesh_assert (elem != NULL);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="comment">/* We first want to find the corners of the cuboid surrounding the</span>
<a name="l00075"></a>00075 <span class="comment">     cell.  */</span>
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1Point.php">Point</a> minCoord = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0);
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1Point.php">Point</a> maxCoord = minCoord;
<a name="l00078"></a>00078   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l00079"></a>00079   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>()-1; i&gt;0; i--)
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081       <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);
<a name="l00082"></a>00082       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;dim; d++)
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084           <span class="keywordflow">if</span>(minCoord(d)&gt;p(d)) minCoord(d) = p(d);
<a name="l00085"></a>00085           <span class="keywordflow">if</span>(maxCoord(d)&lt;p(d)) maxCoord(d) = p(d);
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">/* Next, find out whether this cuboid has got non-empty intersection</span>
<a name="l00090"></a>00090 <span class="comment">     with the bounding box of the current tree node.  */</span>
<a name="l00091"></a>00091   <span class="keywordtype">bool</span> intersects = <span class="keyword">true</span>;
<a name="l00092"></a>00092   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;dim; d++)
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094       <span class="keywordflow">if</span>(maxCoord(d)&lt;this-&gt;<a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first(d) ||
<a name="l00095"></a>00095          minCoord(d)&gt;this-&gt;<a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second(d))
<a name="l00096"></a>00096         {
<a name="l00097"></a>00097           intersects = <span class="keyword">false</span>;
<a name="l00098"></a>00098         }
<a name="l00099"></a>00099     }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">/* If not, we should not care about this element.  */</span>
<a name="l00102"></a>00102   <span class="keywordflow">if</span>(!intersects)
<a name="l00103"></a>00103     {
<a name="l00104"></a>00104       <span class="keywordflow">return</span>;
<a name="l00105"></a>00105     }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// Only add the element if we are active</span>
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110       elements.push_back (elem);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
<a name="l00114"></a>00114       <span class="comment">// flag indicating this node contains</span>
<a name="l00115"></a>00115       <span class="comment">// infinite elements</span>
<a name="l00116"></a>00116       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af5eecb2e1afee8bc7ebf8632da91e4ff">infinite</a>())     
<a name="l00117"></a>00117         this-&gt;contains_ifems = <span class="keyword">true</span>;
<a name="l00118"></a>00118       
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>      
<a name="l00121"></a>00121       <span class="comment">// Refine ourself if we reach the target bin size for a TreeNode.</span>
<a name="l00122"></a>00122       <span class="keywordflow">if</span> (elements.size() == tgt_bin_size)
<a name="l00123"></a>00123         this-&gt;refine();
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">// If we are not active simply pass the element along to</span>
<a name="l00127"></a>00127   <span class="comment">// our children</span>
<a name="l00128"></a>00128   <span class="keywordflow">else</span>
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       libmesh_assert (children.size() == N);
<a name="l00131"></a>00131       
<a name="l00132"></a>00132       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;N; c++)
<a name="l00133"></a>00133         children[c]-&gt;insert (elem);
<a name="l00134"></a>00134     }
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00140"></a><a class="code" href="classlibMesh_1_1TreeNode.php#aaf7ff9c13b6d74e4abf1b20e57b3e118">00140</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#aaf7ff9c13b6d74e4abf1b20e57b3e118">TreeNode&lt;N&gt;::refine</a> ()
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <span class="comment">// Huh?  better be active...</span>
<a name="l00143"></a>00143   libmesh_assert (this-&gt;active());
<a name="l00144"></a>00144   libmesh_assert (children.empty());
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   <span class="comment">// A TreeNode&lt;N&gt; has by definition N children</span>
<a name="l00147"></a>00147   children.resize(N);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;N; c++)
<a name="l00150"></a>00150     {
<a name="l00151"></a>00151       <span class="comment">// Create the child and set its bounding box.</span>
<a name="l00152"></a>00152       children[c] = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;N&gt;</a> (<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, tgt_bin_size, <span class="keyword">this</span>);
<a name="l00153"></a>00153       children[c]-&gt;<a class="code" href="classlibMesh_1_1TreeNode.php#ab65de2214ecabc4d6e6ac9b5b5f406a9">set_bounding_box</a>(this-&gt;create_bounding_box(c));
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="comment">// Pass off our nodes to our children</span>
<a name="l00156"></a>00156       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes.size(); n++)
<a name="l00157"></a>00157         children[c]-&gt;insert(nodes[n]);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159       <span class="comment">// Pass off our elements to our children</span>
<a name="l00160"></a>00160       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;elements.size(); e++)
<a name="l00161"></a>00161         children[c]-&gt;insert(elements[e]);
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <span class="comment">// We don&#39;t need to store nodes or elements any more,</span>
<a name="l00165"></a>00165   <span class="comment">// they have been added to the children.</span>
<a name="l00166"></a>00166   <span class="comment">// Note that we cannot use std::vector&lt;&gt;::clear() here</span>
<a name="l00167"></a>00167   <span class="comment">// since that in general does not reduce capacity!!</span>
<a name="l00168"></a>00168   <span class="comment">// That would be a bad, bad thing.</span>
<a name="l00169"></a>00169   std::vector&lt;const Node*&gt;().swap(nodes);
<a name="l00170"></a>00170   std::vector&lt;const Elem*&gt;().swap(elements);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   libmesh_assert (nodes.capacity()    == 0);
<a name="l00173"></a>00173   libmesh_assert (elements.capacity() == 0);
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00179"></a><a class="code" href="classlibMesh_1_1TreeNode.php#ab65de2214ecabc4d6e6ac9b5b5f406a9">00179</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#ab65de2214ecabc4d6e6ac9b5b5f406a9">TreeNode&lt;N&gt;::set_bounding_box</a> (<span class="keyword">const</span> std::pair&lt;Point, Point&gt;&amp; bbox)
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181   <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a> = bbox;
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00187"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a763ed617204a19e85cc16128987d26c8">00187</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a763ed617204a19e85cc16128987d26c8">TreeNode&lt;N&gt;::bounds_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00188"></a>00188 <span class="keyword"></span>{
<a name="l00189"></a>00189   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first;
<a name="l00190"></a>00190   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordflow">if</span> ((p(0) &gt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(0))
<a name="l00194"></a>00194       &amp;&amp; (p(0) &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(0))
<a name="l00195"></a>00195 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 1
<a name="l00196"></a>00196       &amp;&amp; (p(1) &gt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(1))
<a name="l00197"></a>00197       &amp;&amp; (p(1) &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(1))
<a name="l00198"></a>00198 #endif
<a name="l00199"></a>00199 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 2
<a name="l00200"></a>00200       &amp;&amp; (p(2) &gt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(2))
<a name="l00201"></a>00201       &amp;&amp; (p(2) &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(2))
<a name="l00202"></a>00202 #endif
<a name="l00203"></a>00203      )
<a name="l00204"></a>00204     <span class="keywordflow">return</span> <span class="keyword">true</span>;   
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00212"></a>00212 std::pair&lt;Point, Point&gt; 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1TreeNode.php#af18649f22ac317d9ffbdb0aaa2d9796c">00213</a> <a class="code" href="classlibMesh_1_1TreeNode.php#af18649f22ac317d9ffbdb0aaa2d9796c">TreeNode&lt;N&gt;::create_bounding_box</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)<span class="keyword"> const</span>
<a name="l00214"></a>00214 <span class="keyword"></span>{
<a name="l00215"></a>00215   <span class="keywordflow">switch</span> (N)
<a name="l00216"></a>00216     {
<a name="l00217"></a>00217 
<a name="l00218"></a>00218       <span class="comment">// How to refine an OctTree Node</span>
<a name="l00219"></a>00219     <span class="keywordflow">case</span> 8:
<a name="l00220"></a>00220       {
<a name="l00221"></a>00221         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first(0);
<a name="l00222"></a>00222         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first(1);
<a name="l00223"></a>00223         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zmin = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first(2);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second(0);
<a name="l00226"></a>00226         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second(1);
<a name="l00227"></a>00227         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zmax = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second(2);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xc = xmin + .5*(xmax - xmin);
<a name="l00230"></a>00230         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yc = ymin + .5*(ymax - ymin);
<a name="l00231"></a>00231         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zc = zmin + .5*(zmax - zmin);
<a name="l00232"></a>00232 
<a name="l00233"></a>00233         
<a name="l00234"></a>00234         <span class="keywordflow">switch</span> (c)
<a name="l00235"></a>00235           {
<a name="l00236"></a>00236 
<a name="l00237"></a>00237           <span class="keywordflow">case</span> 0:
<a name="l00238"></a>00238             {
<a name="l00239"></a>00239               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, ymin, zmin);
<a name="l00240"></a>00240               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   yc,   zc);
<a name="l00241"></a>00241               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00242"></a>00242               <span class="keywordflow">break</span>;
<a name="l00243"></a>00243             }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245           <span class="keywordflow">case</span> 1:
<a name="l00246"></a>00246             {
<a name="l00247"></a>00247               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   ymin, zmin);
<a name="l00248"></a>00248               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, yc,   zc);
<a name="l00249"></a>00249               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00250"></a>00250               <span class="keywordflow">break</span>;
<a name="l00251"></a>00251             }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253           <span class="keywordflow">case</span> 2:
<a name="l00254"></a>00254             {
<a name="l00255"></a>00255               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, yc,   zmin);
<a name="l00256"></a>00256               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   ymax, zc);
<a name="l00257"></a>00257               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00258"></a>00258               <span class="keywordflow">break</span>;
<a name="l00259"></a>00259             }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261           <span class="keywordflow">case</span> 3:
<a name="l00262"></a>00262             {
<a name="l00263"></a>00263               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   yc,   zmin);
<a name="l00264"></a>00264               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, ymax, zc);
<a name="l00265"></a>00265               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00266"></a>00266               <span class="keywordflow">break</span>;
<a name="l00267"></a>00267             }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269           <span class="keywordflow">case</span> 4:
<a name="l00270"></a>00270             {
<a name="l00271"></a>00271               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, ymin, zc);
<a name="l00272"></a>00272               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   yc,   zmax);
<a name="l00273"></a>00273               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00274"></a>00274               <span class="keywordflow">break</span>;
<a name="l00275"></a>00275             }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277           <span class="keywordflow">case</span> 5:
<a name="l00278"></a>00278             {
<a name="l00279"></a>00279               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   ymin, zc);
<a name="l00280"></a>00280               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, yc,   zmax);
<a name="l00281"></a>00281               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00282"></a>00282               <span class="keywordflow">break</span>;
<a name="l00283"></a>00283             }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285           <span class="keywordflow">case</span> 6:
<a name="l00286"></a>00286             {
<a name="l00287"></a>00287               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, yc,   zc);
<a name="l00288"></a>00288               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   ymax, zmax);
<a name="l00289"></a>00289               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00290"></a>00290               <span class="keywordflow">break</span>;
<a name="l00291"></a>00291             }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293           <span class="keywordflow">case</span> 7:
<a name="l00294"></a>00294             {
<a name="l00295"></a>00295               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   yc,   zc);
<a name="l00296"></a>00296               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, ymax, zmax);
<a name="l00297"></a>00297               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00298"></a>00298               <span class="keywordflow">break</span>;
<a name="l00299"></a>00299             }
<a name="l00300"></a>00300     
<a name="l00301"></a>00301           <span class="keywordflow">default</span>:
<a name="l00302"></a>00302             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;c &gt;= N! : &quot;</span> &lt;&lt; c
<a name="l00303"></a>00303                           &lt;&lt; std::endl;
<a name="l00304"></a>00304             libmesh_error();
<a name="l00305"></a>00305           }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309         <span class="keywordflow">break</span>;
<a name="l00310"></a>00310       } <span class="comment">// case 8</span>
<a name="l00311"></a>00311 
<a name="l00312"></a>00312       <span class="comment">// How to refine an QuadTree Node</span>
<a name="l00313"></a>00313     <span class="keywordflow">case</span> 4:
<a name="l00314"></a>00314       {
<a name="l00315"></a>00315         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first(0);
<a name="l00316"></a>00316         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.first(1);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second(0);
<a name="l00319"></a>00319         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>.second(1);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xc = xmin + .5*(xmax - xmin);
<a name="l00322"></a>00322         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yc = ymin + .5*(ymax - ymin);
<a name="l00323"></a>00323 
<a name="l00324"></a>00324         <span class="keywordflow">switch</span> (c)
<a name="l00325"></a>00325           {
<a name="l00326"></a>00326           <span class="keywordflow">case</span> 0:
<a name="l00327"></a>00327             {
<a name="l00328"></a>00328               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, ymin);
<a name="l00329"></a>00329               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   yc);
<a name="l00330"></a>00330               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00331"></a>00331               <span class="keywordflow">break</span>;
<a name="l00332"></a>00332             }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334           <span class="keywordflow">case</span> 1:
<a name="l00335"></a>00335             {
<a name="l00336"></a>00336               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   ymin);
<a name="l00337"></a>00337               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, yc);
<a name="l00338"></a>00338               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00339"></a>00339               <span class="keywordflow">break</span>;
<a name="l00340"></a>00340             }
<a name="l00341"></a>00341 
<a name="l00342"></a>00342           <span class="keywordflow">case</span> 2:
<a name="l00343"></a>00343             {
<a name="l00344"></a>00344               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xmin, yc);
<a name="l00345"></a>00345               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xc,   ymax);
<a name="l00346"></a>00346               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00347"></a>00347               <span class="keywordflow">break</span>;
<a name="l00348"></a>00348             }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350           <span class="keywordflow">case</span> 3:
<a name="l00351"></a>00351             {
<a name="l00352"></a>00352               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(xc,   yc);
<a name="l00353"></a>00353               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(xmax, ymax);
<a name="l00354"></a>00354               <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00355"></a>00355               <span class="keywordflow">break</span>;
<a name="l00356"></a>00356             }
<a name="l00357"></a>00357             
<a name="l00358"></a>00358           <span class="keywordflow">default</span>:
<a name="l00359"></a>00359             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;c &gt;= N!&quot;</span> &lt;&lt; std::endl;
<a name="l00360"></a>00360             libmesh_error();
<a name="l00361"></a>00361             
<a name="l00362"></a>00362           }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364         <span class="keywordflow">break</span>;
<a name="l00365"></a>00365       } <span class="comment">// case 4</span>
<a name="l00366"></a>00366 
<a name="l00367"></a>00367     <span class="keywordflow">default</span>:
<a name="l00368"></a>00368       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Only implemented for Octrees and QuadTrees!&quot;</span> &lt;&lt; std::endl;
<a name="l00369"></a>00369       libmesh_error();
<a name="l00370"></a>00370 
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">// How did we get here?</span>
<a name="l00374"></a>00374   libmesh_error();
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;  
<a name="l00377"></a>00377   <span class="keywordflow">return</span> std::make_pair (min, max);
<a name="l00378"></a>00378 }
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00383"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a73cca584a5ebd1e96ac715088b743ed6">00383</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a73cca584a5ebd1e96ac715088b743ed6">TreeNode&lt;N&gt;::print_nodes</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)<span class="keyword"> const</span>
<a name="l00384"></a>00384 <span class="keyword"></span>{
<a name="l00385"></a>00385   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00386"></a>00386     {
<a name="l00387"></a>00387       out &lt;&lt; <span class="stringliteral">&quot;TreeNode Level: &quot;</span> &lt;&lt; this-&gt;level() &lt;&lt; std::endl;
<a name="l00388"></a>00388       
<a name="l00389"></a>00389       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes.size(); n++)
<a name="l00390"></a>00390         out &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; nodes[n]-&gt;<span class="keywordtype">id</span>();
<a name="l00391"></a>00391       
<a name="l00392"></a>00392       out &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00393"></a>00393         
<a name="l00394"></a>00394     }
<a name="l00395"></a>00395   <span class="keywordflow">else</span>
<a name="l00396"></a>00396     {
<a name="l00397"></a>00397       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child=0; child&lt;children.size(); child++)
<a name="l00398"></a>00398         children[child]-&gt;print_nodes();
<a name="l00399"></a>00399     }
<a name="l00400"></a>00400 }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00405"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a04d556756221fd960b9361a84f395eba">00405</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a04d556756221fd960b9361a84f395eba">TreeNode&lt;N&gt;::print_elements</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)<span class="keyword"> const</span>
<a name="l00406"></a>00406 <span class="keyword"></span>{
<a name="l00407"></a>00407   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00408"></a>00408     {
<a name="l00409"></a>00409       out &lt;&lt; <span class="stringliteral">&quot;TreeNode Level: &quot;</span> &lt;&lt; this-&gt;level() &lt;&lt; std::endl;
<a name="l00410"></a>00410      
<a name="l00411"></a>00411       <span class="keywordflow">for</span> (std::vector&lt;const Elem*&gt;::const_iterator pos=elements.begin();
<a name="l00412"></a>00412            pos != elements.end(); ++pos)
<a name="l00413"></a>00413         out &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; *pos;
<a name="l00414"></a>00414 
<a name="l00415"></a>00415       out &lt;&lt; std::endl &lt;&lt; std::endl;    
<a name="l00416"></a>00416     }
<a name="l00417"></a>00417   <span class="keywordflow">else</span>
<a name="l00418"></a>00418     {
<a name="l00419"></a>00419       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child=0; child&lt;children.size(); child++)
<a name="l00420"></a>00420         children[child]-&gt;print_elements();
<a name="l00421"></a>00421     }
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00427"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a738038ceff0432364ac4619ee47b451c">00427</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a738038ceff0432364ac4619ee47b451c">TreeNode&lt;N&gt;::transform_nodes_to_elements</a> (std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem)
<a name="l00428"></a>00428 {
<a name="l00429"></a>00429    <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00430"></a>00430     {
<a name="l00431"></a>00431       elements.clear();
<a name="l00432"></a>00432 
<a name="l00433"></a>00433       <span class="comment">// Temporarily use a set. Since multiple nodes</span>
<a name="l00434"></a>00434       <span class="comment">// will likely map to the same element we use a</span>
<a name="l00435"></a>00435       <span class="comment">// set to eliminate the duplication.</span>
<a name="l00436"></a>00436       std::set&lt;const Elem*&gt; elements_set;
<a name="l00437"></a>00437       
<a name="l00438"></a>00438       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes.size(); n++)
<a name="l00439"></a>00439         {
<a name="l00440"></a>00440           <span class="comment">// the actual global node number we are replacing</span>
<a name="l00441"></a>00441           <span class="comment">// with the connected elements</span>
<a name="l00442"></a>00442           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_number = nodes[n]-&gt;id();
<a name="l00443"></a>00443 
<a name="l00444"></a>00444           libmesh_assert (node_number &lt; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00445"></a>00445           libmesh_assert (node_number &lt; nodes_to_elem.size());
<a name="l00446"></a>00446           
<a name="l00447"></a>00447           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;nodes_to_elem[node_number].size(); e++)
<a name="l00448"></a>00448             elements_set.insert(nodes_to_elem[node_number][e]);
<a name="l00449"></a>00449         }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451       <span class="comment">// Done with the nodes.</span>
<a name="l00452"></a>00452       std::vector&lt;const Node*&gt;().swap(nodes);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454       <span class="comment">// Now the set is built.  We can copy this to the</span>
<a name="l00455"></a>00455       <span class="comment">// vector.  Note that the resulting vector will </span>
<a name="l00456"></a>00456       <span class="comment">// already be sorted, and will require less memory</span>
<a name="l00457"></a>00457       <span class="comment">// than the set.</span>
<a name="l00458"></a>00458       elements.reserve(elements_set.size());
<a name="l00459"></a>00459 
<a name="l00460"></a>00460       <span class="keywordflow">for</span> (std::set&lt;const Elem*&gt;::iterator pos=elements_set.begin();
<a name="l00461"></a>00461            pos != elements_set.end(); ++pos)
<a name="l00462"></a>00462         {
<a name="l00463"></a>00463           elements.push_back(*pos);
<a name="l00464"></a>00464           
<a name="l00465"></a>00465 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>
<a name="l00467"></a>00467           <span class="comment">// flag indicating this node contains</span>
<a name="l00468"></a>00468           <span class="comment">// infinite elements</span>
<a name="l00469"></a>00469           <span class="keywordflow">if</span> ((*pos)-&gt;infinite())
<a name="l00470"></a>00470             this-&gt;contains_ifems = <span class="keyword">true</span>;
<a name="l00471"></a>00471           
<a name="l00472"></a>00472 <span class="preprocessor">#endif</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>        }
<a name="l00474"></a>00474     }
<a name="l00475"></a>00475   <span class="keywordflow">else</span>
<a name="l00476"></a>00476     {
<a name="l00477"></a>00477       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child=0; child&lt;children.size(); child++)
<a name="l00478"></a>00478         children[child]-&gt;transform_nodes_to_elements (nodes_to_elem);
<a name="l00479"></a>00479     }
<a name="l00480"></a>00480  
<a name="l00481"></a>00481 }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00486"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a685b42e4c404fb312d281d68b260517f">00486</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a685b42e4c404fb312d281d68b260517f">TreeNode&lt;N&gt;::n_active_bins</a>()<span class="keyword"> const</span>
<a name="l00487"></a>00487 <span class="keyword"></span>{
<a name="l00488"></a>00488   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00489"></a>00489     <span class="keywordflow">return</span> 1;
<a name="l00490"></a>00490   
<a name="l00491"></a>00491   <span class="keywordflow">else</span>
<a name="l00492"></a>00492     {
<a name="l00493"></a>00493       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>=0;
<a name="l00494"></a>00494 
<a name="l00495"></a>00495       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00496"></a>00496         sum += children[c]-&gt;n_active_bins();
<a name="l00497"></a>00497 
<a name="l00498"></a>00498       <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>;
<a name="l00499"></a>00499     }
<a name="l00500"></a>00500 }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00505"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a79e201490bcf6e7dfccc4dead7a7d778">00505</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1TreeNode.php#a79e201490bcf6e7dfccc4dead7a7d778">TreeNode&lt;N&gt;::find_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00506"></a>00506 <span class="keyword"></span>{
<a name="l00507"></a>00507   <span class="keywordflow">if</span> (this-&gt;active())
<a name="l00508"></a>00508     {
<a name="l00509"></a>00509       <span class="comment">// Only check our children if the point is in our bounding box</span>
<a name="l00510"></a>00510       <span class="comment">// or if the node contains infinite elements</span>
<a name="l00511"></a>00511       <span class="keywordflow">if</span> (this-&gt;bounds_point(p) || this-&gt;contains_ifems)
<a name="l00512"></a>00512         <span class="comment">// Search the active elements in the active TreeNode.</span>
<a name="l00513"></a>00513         <span class="keywordflow">for</span> (std::vector&lt;const Elem*&gt;::const_iterator pos=elements.begin();
<a name="l00514"></a>00514              pos != elements.end(); ++pos)
<a name="l00515"></a>00515           <span class="keywordflow">if</span> ((*pos)-&gt;active())
<a name="l00516"></a>00516             <span class="keywordflow">if</span> ((*pos)-&gt;contains_point(p))
<a name="l00517"></a>00517               <span class="keywordflow">return</span> *pos;
<a name="l00518"></a>00518       
<a name="l00519"></a>00519       <span class="comment">// The point was not found in any element</span>
<a name="l00520"></a>00520       <span class="keywordflow">return</span> NULL;          
<a name="l00521"></a>00521     }
<a name="l00522"></a>00522   <span class="keywordflow">else</span>
<a name="l00523"></a>00523     <span class="keywordflow">return</span> this-&gt;find_element_in_children(p);
<a name="l00524"></a>00524   
<a name="l00525"></a>00525     
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="comment">// Should never get here.  See if-else structure</span>
<a name="l00528"></a>00528   <span class="comment">// above with return statements that must get executed.</span>
<a name="l00529"></a>00529   libmesh_error();
<a name="l00530"></a>00530   
<a name="l00531"></a>00531   <span class="keywordflow">return</span> NULL;
<a name="l00532"></a>00532 }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00538"></a><a class="code" href="classlibMesh_1_1TreeNode.php#ad60dfcc0d48f3cf0ca00b043f6a718cf">00538</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1TreeNode.php#ad60dfcc0d48f3cf0ca00b043f6a718cf">TreeNode&lt;N&gt;::find_element_in_children</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00539"></a>00539 <span class="keyword"></span>{
<a name="l00540"></a>00540   libmesh_assert (!this-&gt;active());
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> excluded_child = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00543"></a>00543   
<a name="l00544"></a>00544   <span class="comment">// First only look in the children whose bounding box</span>
<a name="l00545"></a>00545   <span class="comment">// contain the point p.  Note that only one child will</span>
<a name="l00546"></a>00546   <span class="comment">// bound the point since the bounding boxes are not</span>
<a name="l00547"></a>00547   <span class="comment">// overlapping</span>
<a name="l00548"></a>00548   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00549"></a>00549     <span class="keywordflow">if</span> (children[c]-&gt;bounds_point(p))
<a name="l00550"></a>00550       {
<a name="l00551"></a>00551         <span class="keywordflow">if</span> (children[c]-&gt;active())
<a name="l00552"></a>00552           {
<a name="l00553"></a>00553             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e = children[c]-&gt;find_element(p);
<a name="l00554"></a>00554             
<a name="l00555"></a>00555             <span class="keywordflow">if</span> (e != NULL)
<a name="l00556"></a>00556               <span class="keywordflow">return</span> e;   
<a name="l00557"></a>00557           }
<a name="l00558"></a>00558         <span class="keywordflow">else</span>
<a name="l00559"></a>00559           {
<a name="l00560"></a>00560             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e = children[c]-&gt;find_element_in_children(p);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562             <span class="keywordflow">if</span> (e != NULL)
<a name="l00563"></a>00563               <span class="keywordflow">return</span> e;
<a name="l00564"></a>00564           }
<a name="l00565"></a>00565 
<a name="l00566"></a>00566         <span class="comment">// If we get here than the child that bounds the</span>
<a name="l00567"></a>00567         <span class="comment">// point does not have any elements that contain</span>
<a name="l00568"></a>00568         <span class="comment">// the point.  So, we will search all our children.</span>
<a name="l00569"></a>00569         <span class="comment">// However, we have already searched child c so there</span>
<a name="l00570"></a>00570         <span class="comment">// is no use searching her again.</span>
<a name="l00571"></a>00571         excluded_child = c;
<a name="l00572"></a>00572       }
<a name="l00573"></a>00573          
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="comment">// If we get here then our child whose bounding box</span>
<a name="l00576"></a>00576   <span class="comment">// was searched and did not find any elements containing</span>
<a name="l00577"></a>00577   <span class="comment">// the point p.  So, let&#39;s look at the other children</span>
<a name="l00578"></a>00578   <span class="comment">// but exclude the one we have already searched.</span>
<a name="l00579"></a>00579   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00580"></a>00580     <span class="keywordflow">if</span> (c != excluded_child)    
<a name="l00581"></a>00581       {
<a name="l00582"></a>00582         <span class="keywordflow">if</span> (children[c]-&gt;active())
<a name="l00583"></a>00583           {
<a name="l00584"></a>00584             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e = children[c]-&gt;find_element(p);
<a name="l00585"></a>00585             
<a name="l00586"></a>00586             <span class="keywordflow">if</span> (e != NULL)
<a name="l00587"></a>00587               <span class="keywordflow">return</span> e;   
<a name="l00588"></a>00588           }
<a name="l00589"></a>00589         <span class="keywordflow">else</span>
<a name="l00590"></a>00590           {
<a name="l00591"></a>00591             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e = children[c]-&gt;find_element_in_children(p);
<a name="l00592"></a>00592             
<a name="l00593"></a>00593             <span class="keywordflow">if</span> (e != NULL)
<a name="l00594"></a>00594               <span class="keywordflow">return</span> e;
<a name="l00595"></a>00595           }
<a name="l00596"></a>00596       }
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   <span class="comment">// If we get here we have searched all our children.</span>
<a name="l00599"></a>00599   <span class="comment">// Since this process was started at the root node then</span>
<a name="l00600"></a>00600   <span class="comment">// we have searched all the elements in the tree without</span>
<a name="l00601"></a>00601   <span class="comment">// success.  So, we should return NULL since at this point</span>
<a name="l00602"></a>00602   <span class="comment">// _no_ elements in the tree claim to contain point p.</span>
<a name="l00603"></a>00603   
<a name="l00604"></a>00604   <span class="keywordflow">return</span> NULL;     
<a name="l00605"></a>00605 }
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00610"></a>00610 <span class="comment">// Explicit Instantiations</span>
<a name="l00611"></a>00611 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;4&gt;</a>;
<a name="l00612"></a>00612 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;8&gt;</a>;
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 } <span class="comment">// namespace libMesh</span>
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
