<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tree_node.h</div>  </div>
</div>
<div class="contents">
<a href="tree__node_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: tree_node.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tree_node_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tree_node_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>MeshBase;
<a name="l00037"></a>00037 <span class="keyword">class </span>Node;
<a name="l00038"></a>00038 <span class="keyword">class </span>Elem;
<a name="l00039"></a>00039 
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00047"></a><a class="code" href="classlibMesh_1_1TreeNode.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode</a>
<a name="l00048"></a>00048 {  
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1TreeNode.php#adf1e706ce7e5a74d8906eedee186356f">TreeNode</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m, 
<a name="l00058"></a>00058             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tbs,         
<a name="l00059"></a>00059             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;N&gt;</a> *p = NULL);
<a name="l00060"></a>00060 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1TreeNode.php#ab8a74fe00a969a49781ab800fb195342">~TreeNode</a> ();
<a name="l00067"></a>00067 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a5b06322b8712acba5287af9f65004148">00072</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a5b06322b8712acba5287af9f65004148">is_root</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1TreeNode.php#a98575c8b74bf9d72f85796cf6cf7c89f">parent</a> == NULL); }
<a name="l00073"></a>00073 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1TreeNode.php#ad5c262dd88a8f9e6b23e70a306868d79">00078</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TreeNode.php#ad5c262dd88a8f9e6b23e70a306868d79">active</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a0542a65563060fa788a9461a85a23f47">children</a>.empty(); }
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#abe7a3c67369588d07e3166ae7f12e85e">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* nd);
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#abe7a3c67369588d07e3166ae7f12e85e">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* nd);
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#aaf7ff9c13b6d74e4abf1b20e57b3e118">refine</a> (); 
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#ab65de2214ecabc4d6e6ac9b5b5f406a9">set_bounding_box</a> (<span class="keyword">const</span> std::pair&lt;Point, Point&gt;&amp; bbox);
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a5dd2ee0dff2019e53f2aa69c870d9608">00105</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a5dd2ee0dff2019e53f2aa69c870d9608">bounds_node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* nd)<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">  </span>{ libmesh_assert (nd != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a763ed617204a19e85cc16128987d26c8">bounds_point</a>(*nd); }
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a763ed617204a19e85cc16128987d26c8">bounds_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p) <span class="keyword">const</span>;
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a7d5d9e9b7f00b2a843c65be863f5441b">level</a> () <span class="keyword">const</span>; 
<a name="l00118"></a>00118     
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a73cca584a5ebd1e96ac715088b743ed6">print_nodes</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00124"></a>00124     
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a04d556756221fd960b9361a84f395eba">print_elements</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a738038ceff0432364ac4619ee47b451c">transform_nodes_to_elements</a> (std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; 
<a name="l00135"></a>00135                                     nodes_to_elem);
<a name="l00136"></a>00136 
<a name="l00141"></a>00141   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a685b42e4c404fb312d281d68b260517f">n_active_bins</a>() <span class="keyword">const</span>;
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1TreeNode.php#a79e201490bcf6e7dfccc4dead7a7d778">find_element</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   
<a name="l00149"></a>00149 <span class="keyword">private</span>:
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   
<a name="l00155"></a>00155   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1TreeNode.php#ad60dfcc0d48f3cf0ca00b043f6a718cf">find_element_in_children</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00160"></a>00160   std::pair&lt;Point, Point&gt; <a class="code" href="classlibMesh_1_1TreeNode.php#af18649f22ac317d9ffbdb0aaa2d9796c">create_bounding_box</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a37039a85042f440dd232a4d6673bab99">00165</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1TreeNode.php#a37039a85042f440dd232a4d6673bab99">mesh</a>;
<a name="l00166"></a>00166 
<a name="l00171"></a><a class="code" href="classlibMesh_1_1TreeNode.php#aff965c397f937629040562583add6002">00171</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TreeNode.php#aff965c397f937629040562583add6002">tgt_bin_size</a>;
<a name="l00172"></a>00172 
<a name="l00176"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a98575c8b74bf9d72f85796cf6cf7c89f">00176</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;N&gt;</a> *<a class="code" href="classlibMesh_1_1TreeNode.php#a98575c8b74bf9d72f85796cf6cf7c89f">parent</a>;
<a name="l00177"></a>00177 
<a name="l00182"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a0542a65563060fa788a9461a85a23f47">00182</a>   std::vector&lt;TreeNode&lt;N&gt;* &gt; <a class="code" href="classlibMesh_1_1TreeNode.php#a0542a65563060fa788a9461a85a23f47">children</a>;
<a name="l00183"></a>00183 
<a name="l00189"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a6344cc96994daa5bfc5233582a1c984b">00189</a>   std::pair&lt;Point, Point&gt; <a class="code" href="classlibMesh_1_1TreeNode.php#a6344cc96994daa5bfc5233582a1c984b">bounding_box</a>;
<a name="l00190"></a>00190 
<a name="l00194"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a9818edf35034c2a14af94c9cc64f8f05">00194</a>   std::vector&lt;const Elem*&gt; <a class="code" href="classlibMesh_1_1TreeNode.php#a9818edf35034c2a14af94c9cc64f8f05">elements</a>;
<a name="l00195"></a>00195 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a1867b42a30e22e661f3acc515caddba3">00199</a>   std::vector&lt;const Node*&gt; <a class="code" href="classlibMesh_1_1TreeNode.php#a1867b42a30e22e661f3acc515caddba3">nodes</a>;
<a name="l00200"></a>00200 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1TreeNode.php#ac0262c3c49fb5ffea2ab359794b7a252">00204</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TreeNode.php#ac0262c3c49fb5ffea2ab359794b7a252">contains_ifems</a>;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 };
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00213"></a>00213 <span class="comment">// TreeNode class inline methods</span>
<a name="l00214"></a>00214 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00215"></a>00215 <span class="keyword">inline</span>
<a name="l00216"></a><a class="code" href="classlibMesh_1_1TreeNode.php#adf1e706ce7e5a74d8906eedee186356f">00216</a> <a class="code" href="classlibMesh_1_1TreeNode.php#adf1e706ce7e5a74d8906eedee186356f">TreeNode&lt;N&gt;::TreeNode</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m, 
<a name="l00217"></a>00217                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tbs,
<a name="l00218"></a>00218                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TreeNode.php">TreeNode&lt;N&gt;</a>* p) :
<a name="l00219"></a>00219   <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>           (m),
<a name="l00220"></a>00220   tgt_bin_size   (tbs),
<a name="l00221"></a>00221   parent         (p),
<a name="l00222"></a>00222   contains_ifems (false)
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   <span class="comment">// libmesh_assert our children are empty, thus we are active.</span>
<a name="l00225"></a>00225   libmesh_assert (<a class="code" href="classlibMesh_1_1TreeNode.php#a0542a65563060fa788a9461a85a23f47">children</a>.empty());
<a name="l00226"></a>00226   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1TreeNode.php#ad5c262dd88a8f9e6b23e70a306868d79">active</a>());
<a name="l00227"></a>00227   
<a name="l00228"></a>00228   <span class="comment">// Reserve space for the nodes &amp; elements</span>
<a name="l00229"></a>00229   <a class="code" href="classlibMesh_1_1TreeNode.php#a1867b42a30e22e661f3acc515caddba3">nodes</a>.reserve    (<a class="code" href="classlibMesh_1_1TreeNode.php#aff965c397f937629040562583add6002">tgt_bin_size</a>);
<a name="l00230"></a>00230   <a class="code" href="classlibMesh_1_1TreeNode.php#a9818edf35034c2a14af94c9cc64f8f05">elements</a>.reserve (<a class="code" href="classlibMesh_1_1TreeNode.php#aff965c397f937629040562583add6002">tgt_bin_size</a>);
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00236"></a>00236 <span class="keyword">inline</span>
<a name="l00237"></a><a class="code" href="classlibMesh_1_1TreeNode.php#ab8a74fe00a969a49781ab800fb195342">00237</a> <a class="code" href="classlibMesh_1_1TreeNode.php#ab8a74fe00a969a49781ab800fb195342">TreeNode&lt;N&gt;::~TreeNode</a> ()
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <span class="comment">// When we are destructed we must delete all of our</span>
<a name="l00240"></a>00240   <span class="comment">// children.  They will this delete their children,</span>
<a name="l00241"></a>00241   <span class="comment">// All the way down the line...</span>
<a name="l00242"></a>00242   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;children.size(); c++)
<a name="l00243"></a>00243     <span class="keyword">delete</span> children[c];
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N&gt;
<a name="l00249"></a>00249 <span class="keyword">inline</span>
<a name="l00250"></a><a class="code" href="classlibMesh_1_1TreeNode.php#a7d5d9e9b7f00b2a843c65be863f5441b">00250</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TreeNode.php#a7d5d9e9b7f00b2a843c65be863f5441b">TreeNode&lt;N&gt;::level</a> ()<span class="keyword"> const </span>
<a name="l00251"></a>00251 <span class="keyword"></span>{ 
<a name="l00252"></a>00252   <span class="keywordflow">if</span> (parent != NULL)
<a name="l00253"></a>00253     <span class="keywordflow">return</span> parent-&gt;level()+1;
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="comment">// if we have no parent, we are a level-0 box</span>
<a name="l00256"></a>00256   <span class="keywordflow">return</span> 0;
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 } <span class="comment">// namespace libMesh</span>
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
