<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_aztec_linear_solver.h</div>  </div>
</div>
<div class="contents">
<a href="trilinos__aztec__linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_aztec_linear_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __trilinos_azec_linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_azec_linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#include &lt;Epetra_LinearProblem.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;AztecOO.h&gt;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// C++ includes</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00053"></a><a class="code" href="classlibMesh_1_1AztecLinearSolver.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1AztecLinearSolver.php">AztecLinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a>&lt;T&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a6e0fde15b2769e716226176cdcbb78d2">AztecLinearSolver</a> ();
<a name="l00060"></a>00060     
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a7e1a3437643525fe8405a59e5908fc30">~AztecLinearSolver</a> ();
<a name="l00065"></a>00065   
<a name="l00069"></a>00069   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#ace3ea9cdd5c6a6c2042a073ba3a7a6e0">clear</a> ();
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a0a33abb1f265ff621401cd2e9fdde05e">init</a> ();
<a name="l00075"></a>00075 
<a name="l00080"></a>00080   std::pair&lt;unsigned int, Real&gt; 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a1d213f9a9e7664d68cb149f3d04b8ad9">00081</a>   <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a1d213f9a9e7664d68cb149f3d04b8ad9">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix_in,
<a name="l00082"></a>00082          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00083"></a>00083          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00084"></a>00084          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00085"></a>00085          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00086"></a>00086   {
<a name="l00087"></a>00087     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a1d213f9a9e7664d68cb149f3d04b8ad9">solve</a>(matrix_in, matrix_in, solution_in, rhs_in, tol, m_its);
<a name="l00088"></a>00088   }
<a name="l00089"></a>00089 
<a name="l00096"></a>00096   std::pair&lt;unsigned int, Real&gt; 
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a1d213f9a9e7664d68cb149f3d04b8ad9">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00098"></a>00098          <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;preconditioner,
<a name="l00099"></a>00099          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00100"></a>00100          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00101"></a>00101          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00102"></a>00102          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   std::pair&lt;unsigned int, Real&gt;
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a1d213f9a9e7664d68cb149f3d04b8ad9">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00109"></a>00109          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00110"></a>00110          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00111"></a>00111          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00112"></a>00112          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00113"></a>00113 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00120"></a>00120     <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a1d213f9a9e7664d68cb149f3d04b8ad9">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00121"></a>00121            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00122"></a>00122            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00123"></a>00123            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00124"></a>00124            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00125"></a>00125            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00126"></a>00126 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a4f48d646f380c48d4a5e931a1c7e14c3">get_residual_history</a>(std::vector&lt;double&gt;&amp; hist);
<a name="l00132"></a>00132 
<a name="l00139"></a>00139   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a55d77aa563114b2271db05c2eb8e352c">get_initial_residual</a>();
<a name="l00140"></a>00140 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#af6f584a246597141018ee31c2e0201a2">print_converged_reason</a>();
<a name="l00146"></a>00146   
<a name="l00147"></a>00147 <span class="keyword">private</span>:
<a name="l00148"></a>00148 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a3ddc25e7eab0761d270a78956b927bce">00152</a>   Epetra_LinearProblem * <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a3ddc25e7eab0761d270a78956b927bce">_linear_problem</a>;
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1AztecLinearSolver.php#af46f4259ee8ba2256b1f5a467f43144e">00157</a>   AztecOO * <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#af46f4259ee8ba2256b1f5a467f43144e">_linear_solver</a>;
<a name="l00158"></a>00158 };
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00162"></a>00162 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00163"></a>00163 <span class="keyword">inline</span>
<a name="l00164"></a><a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a6e0fde15b2769e716226176cdcbb78d2">00164</a> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a6e0fde15b2769e716226176cdcbb78d2">AztecLinearSolver&lt;T&gt;::AztecLinearSolver</a> ()
<a name="l00165"></a>00165 {
<a name="l00166"></a>00166   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00167"></a>00167     this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00168"></a>00168   <span class="keywordflow">else</span>
<a name="l00169"></a>00169     this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00175"></a>00175 <span class="keyword">inline</span>
<a name="l00176"></a><a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a7e1a3437643525fe8405a59e5908fc30">00176</a> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php#a7e1a3437643525fe8405a59e5908fc30">AztecLinearSolver&lt;T&gt;::~AztecLinearSolver</a> ()
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   this-&gt;clear ();
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 } <span class="comment">// namespace libMesh</span>
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_azec_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
