<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_epetra_matrix.C</div>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_matrix.C 3917 2010-08-24 20:59:51Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__epetra__matrix_8h.php">trilinos_epetra_matrix.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__epetra__vector_8h.php">trilinos_epetra_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="sparsity__pattern_8h.php">sparsity_pattern.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">//EpetraMatrix members</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00043"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a7bc59ff84930ecd182f39655a7a2951d">00043</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a7bc59ff84930ecd182f39655a7a2951d">EpetraMatrix&lt;T&gt;::update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;sparsity_pattern)
<a name="l00044"></a>00044 {  
<a name="l00045"></a>00045   <span class="comment">// clear data, start over</span>
<a name="l00046"></a>00046   this-&gt;clear ();    
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="comment">// big trouble if this fails!</span>
<a name="l00049"></a>00049   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = sparsity_pattern.size();
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m   = this-&gt;_dof_map-&gt;n_dofs();
<a name="l00054"></a>00054   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = m;
<a name="l00055"></a>00055   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l = this-&gt;_dof_map-&gt;n_dofs_on_processor(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); 
<a name="l00056"></a>00056   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l = n_l;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// error checking</span>
<a name="l00059"></a>00059 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>  {
<a name="l00061"></a>00061     libmesh_assert (n == m);
<a name="l00062"></a>00062     libmesh_assert (n_l == m_l);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00065"></a>00065       summed_m_l = m_l,
<a name="l00066"></a>00066       summed_n_l = n_l;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (summed_m_l);
<a name="l00069"></a>00069     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (summed_n_l);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     libmesh_assert (m == summed_m_l);
<a name="l00072"></a>00072     libmesh_assert (n == summed_n_l);
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074 <span class="preprocessor">#endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>  
<a name="l00076"></a>00076   <span class="comment">// build a map defining the data distribution</span>
<a name="l00077"></a>00077   _map = <span class="keyword">new</span> Epetra_Map (m, 
<a name="l00078"></a>00078                          m_l,
<a name="l00079"></a>00079                          0,
<a name="l00080"></a>00080                          Epetra_MpiComm (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>));
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;NumGlobalPoints()) == m);
<a name="l00083"></a>00083   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;MaxAllGID()+1) == m);
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_nz = this-&gt;_dof_map-&gt;get_n_nz();
<a name="l00086"></a>00086   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; n_oz = this-&gt;_dof_map-&gt;get_n_oz();
<a name="l00087"></a>00087   
<a name="l00088"></a>00088    <span class="comment">// Make sure the sparsity pattern isn&#39;t empty</span>
<a name="l00089"></a>00089   libmesh_assert (n_nz.size() == n_l);
<a name="l00090"></a>00090   libmesh_assert (n_oz.size() == n_l);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// Epetra wants the total number of nonzeros, both local and remote.</span>
<a name="l00093"></a>00093   std::vector&lt;int&gt; n_nz_tot;  n_nz_tot.reserve(n_nz.size());
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_nz.size(); i++)    
<a name="l00096"></a>00096     n_nz_tot.push_back(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(n_nz[i] + n_oz[i], n));
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (m==0)
<a name="l00099"></a>00099     <span class="keywordflow">return</span>;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   _graph = <span class="keyword">new</span> Epetra_CrsGraph(Copy, *_map, &amp;n_nz_tot[0]);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Tell the matrix about its structure.  Initialize it</span>
<a name="l00104"></a>00104   <span class="comment">// to zero.</span>
<a name="l00105"></a>00105   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_rows; i++)
<a name="l00106"></a>00106     _graph-&gt;InsertGlobalIndices(_graph-&gt;GRID(i),
<a name="l00107"></a>00107                                 sparsity_pattern[i].size(),
<a name="l00108"></a>00108                                 <span class="keyword">const_cast&lt;</span><span class="keywordtype">int</span> *<span class="keyword">&gt;</span>((<span class="keyword">const</span> <span class="keywordtype">int</span> *)&amp;sparsity_pattern[i][0]));
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   _graph-&gt;FillComplete();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">//Initialize the matrix</span>
<a name="l00113"></a>00113   libmesh_assert (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00114"></a>00114   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00115"></a>00115   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0ff73ec39efcab38698f9ba25fa6c136">00121</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a1b58eeb3e7e629f22f43c93211391db0">EpetraMatrix&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00122"></a>00122                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00123"></a>00123                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00124"></a>00124                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00125"></a>00125                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz,
<a name="l00126"></a>00126                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz)
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128   <span class="keywordflow">if</span> ((m==0) || (n==0))
<a name="l00129"></a>00129     <span class="keywordflow">return</span>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   {
<a name="l00132"></a>00132     <span class="comment">// Clear initialized matrices</span>
<a name="l00133"></a>00133     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00134"></a>00134       this-&gt;clear();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     libmesh_assert (this-&gt;_mat == NULL);
<a name="l00137"></a>00137     libmesh_assert (this-&gt;_map == NULL);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139     this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00140"></a>00140   }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// error checking</span>
<a name="l00143"></a>00143 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>  {
<a name="l00145"></a>00145     libmesh_assert (n == m);
<a name="l00146"></a>00146     libmesh_assert (n_l == m_l);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00149"></a>00149       summed_m_l = m_l,
<a name="l00150"></a>00150       summed_n_l = n_l;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (summed_m_l);
<a name="l00153"></a>00153     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (summed_n_l);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     libmesh_assert (m == summed_m_l);
<a name="l00156"></a>00156     libmesh_assert (n == summed_n_l);
<a name="l00157"></a>00157   }
<a name="l00158"></a>00158 <span class="preprocessor">#endif</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>
<a name="l00160"></a>00160   <span class="comment">// build a map defining the data distribution</span>
<a name="l00161"></a>00161   _map = <span class="keyword">new</span> Epetra_Map (m, 
<a name="l00162"></a>00162                          m_l,
<a name="l00163"></a>00163                          0,
<a name="l00164"></a>00164                          Epetra_MpiComm (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>));
<a name="l00165"></a>00165   
<a name="l00166"></a>00166   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;NumGlobalPoints()) == m);
<a name="l00167"></a>00167   libmesh_assert (static_cast&lt;unsigned int&gt;(_map-&gt;MaxAllGID()+1) == m);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   _mat = <span class="keyword">new</span> Epetra_FECrsMatrix (Copy, *_map, nnz + noz);
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00176"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a1b58eeb3e7e629f22f43c93211391db0">00176</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a1b58eeb3e7e629f22f43c93211391db0">EpetraMatrix&lt;T&gt;::init</a> ()
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   libmesh_assert (this-&gt;_dof_map != NULL);
<a name="l00179"></a>00179   
<a name="l00180"></a>00180   {
<a name="l00181"></a>00181     <span class="comment">// Clear initialized matrices</span>
<a name="l00182"></a>00182     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00183"></a>00183       this-&gt;clear();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185     this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00186"></a>00186   }
<a name="l00187"></a>00187   
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   _mat = <span class="keyword">new</span> Epetra_FECrsMatrix (Copy, *_graph);
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00195"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0b9da46673fa9bd43be32b79e6722bff">00195</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0b9da46673fa9bd43be32b79e6722bff">EpetraMatrix&lt;T&gt;::zero</a> ()
<a name="l00196"></a>00196 {
<a name="l00197"></a>00197   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   _mat-&gt;Scale(0.0);
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00205"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a5cf6fb68c554a1d84b87b1b3b897e0a0">00205</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a5cf6fb68c554a1d84b87b1b3b897e0a0">EpetraMatrix&lt;T&gt;::clear</a> ()
<a name="l00206"></a>00206 {
<a name="l00207"></a>00207 <span class="comment">//  delete _mat;</span>
<a name="l00208"></a>00208 <span class="comment">//  delete _map;</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   libmesh_assert (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00218"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a2913f285f3785d416cb772a5fcc28039">00218</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a2913f285f3785d416cb772a5fcc28039">EpetraMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00219"></a>00219 <span class="keyword"></span>{
<a name="l00220"></a>00220   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00221"></a>00221   
<a name="l00222"></a>00222   libmesh_assert (_mat != NULL);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(_mat-&gt;NormOne());
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00230"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa9d989e0117ec2d0d6b9d3be6884614f">00230</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa9d989e0117ec2d0d6b9d3be6884614f">EpetraMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00231"></a>00231 <span class="keyword"></span>{
<a name="l00232"></a>00232   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00233"></a>00233   
<a name="l00234"></a>00234   
<a name="l00235"></a>00235   libmesh_assert (_mat != NULL);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(_mat-&gt;NormInf());
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00243"></a>00243 <span class="comment">//void EpetraMatrix&lt;T&gt;::print_matlab (const std::string name) const</span>
<a name="l00244"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4b4372895899e844370ea5d470099907">00244</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4b4372895899e844370ea5d470099907">EpetraMatrix&lt;T&gt;::print_matlab</a> (<span class="keyword">const</span> std::string)<span class="keyword"> const</span>
<a name="l00245"></a>00245 <span class="keyword"></span>{
<a name="l00246"></a>00246   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   <span class="comment">// libmesh_assert (this-&gt;closed());</span>
<a name="l00249"></a>00249   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00250"></a>00250   
<a name="l00251"></a>00251   libmesh_not_implemented();
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="comment">//   int ierr=0; </span>
<a name="l00254"></a>00254 <span class="comment">//   PetscViewer petsc_viewer;</span>
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="comment">//   ierr = PetscViewerCreate (libMesh::COMM_WORLD,</span>
<a name="l00258"></a>00258 <span class="comment">//                          &amp;petsc_viewer);</span>
<a name="l00259"></a>00259 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="comment">//   /**</span>
<a name="l00262"></a>00262 <span class="comment">//    * Create an ASCII file containing the matrix</span>
<a name="l00263"></a>00263 <span class="comment">//    * if a filename was provided.  </span>
<a name="l00264"></a>00264 <span class="comment">//    */</span>
<a name="l00265"></a>00265 <span class="comment">//   if (name != &quot;NULL&quot;)</span>
<a name="l00266"></a>00266 <span class="comment">//     {</span>
<a name="l00267"></a>00267 <span class="comment">//       ierr = PetscViewerASCIIOpen( libMesh::COMM_WORLD,</span>
<a name="l00268"></a>00268 <span class="comment">//                                 name.c_str(),</span>
<a name="l00269"></a>00269 <span class="comment">//                                 &amp;petsc_viewer);</span>
<a name="l00270"></a>00270 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00271"></a>00271       
<a name="l00272"></a>00272 <span class="comment">//       ierr = PetscViewerSetFormat (petsc_viewer,</span>
<a name="l00273"></a>00273 <span class="comment">//                                 PETSC_VIEWER_ASCII_MATLAB);</span>
<a name="l00274"></a>00274 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00275"></a>00275   
<a name="l00276"></a>00276 <span class="comment">//       ierr = MatView (_mat, petsc_viewer);</span>
<a name="l00277"></a>00277 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00278"></a>00278 <span class="comment">//     }</span>
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="comment">//   /**</span>
<a name="l00281"></a>00281 <span class="comment">//    * Otherwise the matrix will be dumped to the screen.</span>
<a name="l00282"></a>00282 <span class="comment">//    */</span>
<a name="l00283"></a>00283 <span class="comment">//   else</span>
<a name="l00284"></a>00284 <span class="comment">//     {</span>
<a name="l00285"></a>00285 <span class="comment">//       ierr = PetscViewerSetFormat (PETSC_VIEWER_STDOUT_WORLD,</span>
<a name="l00286"></a>00286 <span class="comment">//                                 PETSC_VIEWER_ASCII_MATLAB);</span>
<a name="l00287"></a>00287 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00288"></a>00288   
<a name="l00289"></a>00289 <span class="comment">//       ierr = MatView (_mat, PETSC_VIEWER_STDOUT_WORLD);</span>
<a name="l00290"></a>00290 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00291"></a>00291 <span class="comment">//     }</span>
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 <span class="comment">//   /**</span>
<a name="l00295"></a>00295 <span class="comment">//    * Destroy the viewer.</span>
<a name="l00296"></a>00296 <span class="comment">//    */</span>
<a name="l00297"></a>00297 <span class="comment">//   ierr = PetscViewerDestroy (petsc_viewer);</span>
<a name="l00298"></a>00298 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00299"></a>00299 }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00305"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa7e5240157a7e20cdcba401fce6e9985">00305</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa7e5240157a7e20cdcba401fce6e9985">EpetraMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00306"></a>00306                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00307"></a>00307                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols)
<a name="l00308"></a>00308 {
<a name="l00309"></a>00309   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = dm.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>();
<a name="l00312"></a>00312   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = dm.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   libmesh_assert (rows.size() == m);
<a name="l00315"></a>00315   libmesh_assert (cols.size() == n);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   _mat-&gt;SumIntoGlobalValues(m, (<span class="keywordtype">int</span> *)&amp;rows[0], n, (<span class="keywordtype">int</span> *)&amp;cols[0], &amp;dm.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">get_values</a>()[0]);
<a name="l00318"></a>00318 }
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 <span class="comment">// template &lt;typename T&gt;</span>
<a name="l00325"></a>00325 <span class="comment">// void EpetraMatrix&lt;T&gt;::_get_submatrix(SparseMatrix&lt;T&gt;&amp; submatrix,</span>
<a name="l00326"></a>00326 <span class="comment">//                                   const std::vector&lt;unsigned int&gt; &amp;rows,</span>
<a name="l00327"></a>00327 <span class="comment">//                                   const std::vector&lt;unsigned int&gt; &amp;cols,</span>
<a name="l00328"></a>00328 <span class="comment">//                                   const bool reuse_submatrix) const</span>
<a name="l00329"></a>00329 <span class="comment">// {</span>
<a name="l00330"></a>00330 <span class="comment">//   // Can only extract submatrices from closed matrices</span>
<a name="l00331"></a>00331 <span class="comment">//   this-&gt;close();</span>
<a name="l00332"></a>00332   
<a name="l00333"></a>00333 <span class="comment">//   libmesh_not_implemented();</span>
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 <span class="comment">// //   // Attempt to cast the input matrix to a EpetraMatrix*</span>
<a name="l00336"></a>00336 <span class="comment">// //   EpetraMatrix&lt;T&gt;* petsc_submatrix = libmesh_cast_ptr&lt;EpetraMatrix&lt;T&gt;*&gt;(&amp;submatrix);</span>
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="comment">// //   // Construct row and column index sets.</span>
<a name="l00339"></a>00339 <span class="comment">// //   int ierr=0;</span>
<a name="l00340"></a>00340 <span class="comment">// //   IS isrow, iscol;</span>
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 <span class="comment">// //   ierr = ISCreateGeneral(libMesh::COMM_WORLD,</span>
<a name="l00343"></a>00343 <span class="comment">// //                    rows.size(),</span>
<a name="l00344"></a>00344 <span class="comment">// //                    (int*) &amp;rows[0],</span>
<a name="l00345"></a>00345 <span class="comment">// //                    &amp;isrow); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 <span class="comment">// //   ierr = ISCreateGeneral(libMesh::COMM_WORLD,</span>
<a name="l00348"></a>00348 <span class="comment">// //                    cols.size(),</span>
<a name="l00349"></a>00349 <span class="comment">// //                    (int*) &amp;cols[0],</span>
<a name="l00350"></a>00350 <span class="comment">// //                    &amp;iscol); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="comment">// //   // Extract submatrix</span>
<a name="l00353"></a>00353 <span class="comment">// //   ierr = MatGetSubMatrix(_mat,</span>
<a name="l00354"></a>00354 <span class="comment">// //                    isrow,</span>
<a name="l00355"></a>00355 <span class="comment">// //                    iscol,</span>
<a name="l00356"></a>00356 <span class="comment">// //                    PETSC_DECIDE,</span>
<a name="l00357"></a>00357 <span class="comment">// //                    (reuse_submatrix ? MAT_RELIBMESH_USE_MATRIX : MAT_INITIAL_MATRIX),</span>
<a name="l00358"></a>00358 <span class="comment">// //                    &amp;(petsc_submatrix-&gt;_mat));  CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="comment">// //   // Specify that the new submatrix is initialized and close it.</span>
<a name="l00361"></a>00361 <span class="comment">// //   petsc_submatrix-&gt;_is_initialized = true;</span>
<a name="l00362"></a>00362 <span class="comment">// //   petsc_submatrix-&gt;close();</span>
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 <span class="comment">// //   // Clean up PETSc data structures</span>
<a name="l00365"></a>00365 <span class="comment">// //   ierr = ISDestroy(isrow); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00366"></a>00366 <span class="comment">// //   ierr = ISDestroy(iscol); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00367"></a>00367 <span class="comment">// }</span>
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00370"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#af753b4ef7b0c2e5cd4bc90f9307c235d">00370</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#af753b4ef7b0c2e5cd4bc90f9307c235d">EpetraMatrix&lt;T&gt;::get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00371"></a>00371 <span class="keyword"></span>{
<a name="l00372"></a>00372   <span class="comment">// Convert vector to EpetraVector.</span>
<a name="l00373"></a>00373   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* epetra_dest = libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;dest);
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="comment">// Call Epetra function.</span>
<a name="l00376"></a>00376   _mat-&gt;ExtractDiagonalCopy(*(epetra_dest-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#a03abaf449b6dd2980bf744f231a3dc0a">vec</a>()));
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00382"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#aff9ceaee2f800e2153e49852343308e3">00382</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aff9ceaee2f800e2153e49852343308e3">EpetraMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;)<span class="keyword"> const</span>
<a name="l00383"></a>00383 <span class="keyword"></span>{
<a name="l00384"></a>00384   libmesh_not_implemented();
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00390"></a>00390 <span class="comment">// Explicit instantiations</span>
<a name="l00391"></a>00391 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EpetraMatrix.php">EpetraMatrix&lt;Number&gt;</a>;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 } <span class="comment">// namespace libMesh</span>
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TRILINOS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
