<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_epetra_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_matrix.h 4246 2011-03-11 22:24:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __trilinos_epetra_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_epetra_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// Trilinos includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;Epetra_FECrsMatrix.h&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;Epetra_Map.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;Epetra_MpiComm.h&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// C++ includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Local includes</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Forward Declarations</span>
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseMatrix;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EpetraMatrix.php">EpetraMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;T&gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0252cc9d38d34fd32b9c0f0307b993fa">EpetraMatrix</a> ();
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">//   /**</span>
<a name="l00078"></a>00078 <span class="comment">//    * Constructor.  Creates a EpetraMatrix assuming you already</span>
<a name="l00079"></a>00079 <span class="comment">//    * have a valid Mat object.  In this case, m is NOT destroyed</span>
<a name="l00080"></a>00080 <span class="comment">//    * by the EpetraMatrix destructor when this object goes out of scope.</span>
<a name="l00081"></a>00081 <span class="comment">//    * This allows ownership of m to remain with the original creator,</span>
<a name="l00082"></a>00082 <span class="comment">//    * and to simply provide additional functionality with the EpetraMatrix.</span>
<a name="l00083"></a>00083 <span class="comment">//    */</span>
<a name="l00084"></a>00084 <span class="comment">//   EpetraMatrix (Mat m);</span>
<a name="l00085"></a>00085   
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4709172e24ee4792dd74af5567541d0a">~EpetraMatrix</a> ();
<a name="l00092"></a>00092  
<a name="l00093"></a>00093 <span class="comment">//   /**</span>
<a name="l00094"></a>00094 <span class="comment">//    * The \p EpetraMatrix needs the full sparsity pattern.</span>
<a name="l00095"></a>00095 <span class="comment">//    */ </span>
<a name="l00096"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a751554e5ef6dc47395adfd1ca82bfdc3">00096</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a751554e5ef6dc47395adfd1ca82bfdc3">need_full_sparsity_pattern</a> ()<span class="keyword"> const </span>
<a name="l00097"></a>00097 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="comment">//   /**</span>
<a name="l00100"></a>00100 <span class="comment">//    * Updates the matrix sparsity pattern.  This will</span>
<a name="l00101"></a>00101 <span class="comment">//    * tell the underlying matrix storage scheme how</span>
<a name="l00102"></a>00102 <span class="comment">//    * to map the \f$ (i,j) \f$ elements.</span>
<a name="l00103"></a>00103 <span class="comment">//    */</span>
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a7bc59ff84930ecd182f39655a7a2951d">update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;);
<a name="l00105"></a>00105 
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a1b58eeb3e7e629f22f43c93211391db0">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a8a9ed3dbae7bf870cfd5dc01759a9b8e">m</a>,
<a name="l00115"></a>00115              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a968094c6395539e97b805221b92c992d">n</a>,
<a name="l00116"></a>00116              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00117"></a>00117              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00118"></a>00118              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00119"></a>00119              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10);
<a name="l00120"></a>00120 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a1b58eeb3e7e629f22f43c93211391db0">init</a> ();
<a name="l00125"></a>00125   
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a5cf6fb68c554a1d84b87b1b3b897e0a0">clear</a> ();
<a name="l00133"></a>00133 
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0b9da46673fa9bd43be32b79e6722bff">zero</a> ();
<a name="l00139"></a>00139   
<a name="l00145"></a>00145   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aec7c5a68bf7a9f0e06323e117cb3b295">close</a> () <span class="keyword">const</span>;
<a name="l00146"></a>00146   
<a name="l00151"></a>00151   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a8a9ed3dbae7bf870cfd5dc01759a9b8e">m</a> () <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00157"></a>00157   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a968094c6395539e97b805221b92c992d">n</a> () <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a12f22b43047f8aa3159649ab40463af1">row_start</a> () <span class="keyword">const</span>;
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4125d9d44ed2a3ea3ff234beb8fd24c9">row_stop</a> () <span class="keyword">const</span>;
<a name="l00170"></a>00170 
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00178"></a>00178             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00179"></a>00179             <span class="keyword">const</span> T value);
<a name="l00180"></a>00180     
<a name="l00189"></a>00189   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a229afccafdcb6c5f78244c6ec91a46e9">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00190"></a>00190             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00191"></a>00191             <span class="keyword">const</span> T value);
<a name="l00192"></a>00192 
<a name="l00200"></a>00200   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa7e5240157a7e20cdcba401fce6e9985">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00201"></a>00201                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00202"></a>00202                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols);           
<a name="l00203"></a>00203 
<a name="l00208"></a>00208   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa7e5240157a7e20cdcba401fce6e9985">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00209"></a>00209                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices);            
<a name="l00210"></a>00210       
<a name="l00220"></a>00220   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a229afccafdcb6c5f78244c6ec91a46e9">add</a> (<span class="keyword">const</span> T a, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X);
<a name="l00221"></a>00221     
<a name="l00240"></a>00240   T <a class="code" href="classlibMesh_1_1EpetraMatrix.php#ada3b245053ae16108581a3653cfe01b9">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00241"></a>00241                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00242"></a>00242 
<a name="l00254"></a>00254   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a2913f285f3785d416cb772a5fcc28039">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00268"></a>00268   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa9d989e0117ec2d0d6b9d3be6884614f">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00269"></a>00269 
<a name="l00274"></a>00274   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0961b114f8a5817c75b478644e5bb916">closed</a>() <span class="keyword">const</span>;
<a name="l00275"></a>00275   
<a name="l00279"></a>00279   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a6c1342a8fc8645c439a89a37f6195e66">print_personal</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00280"></a>00280 
<a name="l00287"></a>00287   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4b4372895899e844370ea5d470099907">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00288"></a>00288 
<a name="l00292"></a>00292   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#af753b4ef7b0c2e5cd4bc90f9307c235d">get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00293"></a>00293 
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aff9ceaee2f800e2153e49852343308e3">get_transpose</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00299"></a>00299 
<a name="l00303"></a>00303   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a273f59c6b2e4964915ed36e159bc0d9b">swap</a> (<a class="code" href="classlibMesh_1_1EpetraMatrix.php">EpetraMatrix&lt;T&gt;</a> &amp;);
<a name="l00304"></a>00304 
<a name="l00310"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a5541d6f3675c22725482fa96bb104f89">00310</a>   Epetra_FECrsMatrix * <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a5541d6f3675c22725482fa96bb104f89">mat</a> () { libmesh_assert (<a class="code" href="classlibMesh_1_1EpetraMatrix.php#a704e963bfa13e7429384b70e37d9bb57">_mat</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a704e963bfa13e7429384b70e37d9bb57">_mat</a>; }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   
<a name="l00313"></a>00313 <span class="keyword">protected</span>:
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="comment">//   /**</span>
<a name="l00316"></a>00316 <span class="comment">//    * This function either creates or re-initializes</span>
<a name="l00317"></a>00317 <span class="comment">//    * a matrix called &quot;submatrix&quot; which is defined</span>
<a name="l00318"></a>00318 <span class="comment">//    * by the row and column indices given in the &quot;rows&quot; and &quot;cols&quot; entries.</span>
<a name="l00319"></a>00319 <span class="comment">//    * This function is implemented in terms of the MatGetSubMatrix()</span>
<a name="l00320"></a>00320 <span class="comment">//    * routine of PETSc.  The boolean reuse_submatrix parameter determines</span>
<a name="l00321"></a>00321 <span class="comment">//    * whether or not PETSc will treat &quot;submatrix&quot; as one which has already</span>
<a name="l00322"></a>00322 <span class="comment">//    * been used (had memory allocated) or as a new matrix.</span>
<a name="l00323"></a>00323 <span class="comment">//    */</span>
<a name="l00324"></a>00324 <span class="comment">//   virtual void _get_submatrix(SparseMatrix&lt;T&gt;&amp; submatrix,</span>
<a name="l00325"></a>00325 <span class="comment">//                            const std::vector&lt;unsigned int&gt;&amp; rows,</span>
<a name="l00326"></a>00326 <span class="comment">//                            const std::vector&lt;unsigned int&gt;&amp; cols,</span>
<a name="l00327"></a>00327 <span class="comment">//                            const bool reuse_submatrix) const;</span>
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">private</span>:
<a name="l00330"></a>00330   
<a name="l00335"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a704e963bfa13e7429384b70e37d9bb57">00335</a>   Epetra_FECrsMatrix * <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a704e963bfa13e7429384b70e37d9bb57">_mat</a>;
<a name="l00336"></a>00336 
<a name="l00340"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a9ec6a9841e1b6b801cf50517a2c1617b">00340</a>   Epetra_Map * <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a9ec6a9841e1b6b801cf50517a2c1617b">_map</a>;
<a name="l00341"></a>00341 
<a name="l00345"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#abe731cc8a3488c1e2672443836b6ce61">00345</a>   Epetra_CrsGraph * <a class="code" href="classlibMesh_1_1EpetraMatrix.php#abe731cc8a3488c1e2672443836b6ce61">_graph</a>;
<a name="l00346"></a>00346 
<a name="l00351"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#adc8d1ff2d410fac11728e6c762b8017f">00351</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#adc8d1ff2d410fac11728e6c762b8017f">_destroy_mat_on_exit</a>;
<a name="l00352"></a>00352 };
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00358"></a>00358 <span class="comment">// EpetraMatrix inline members</span>
<a name="l00359"></a>00359 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00360"></a>00360 <span class="keyword">inline</span>
<a name="l00361"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0252cc9d38d34fd32b9c0f0307b993fa">00361</a> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0252cc9d38d34fd32b9c0f0307b993fa">EpetraMatrix&lt;T&gt;::EpetraMatrix</a>()
<a name="l00362"></a>00362   : _destroy_mat_on_exit(true)
<a name="l00363"></a>00363 {}
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="comment">// template &lt;typename T&gt;</span>
<a name="l00369"></a>00369 <span class="comment">// inline</span>
<a name="l00370"></a>00370 <span class="comment">// EpetraMatrix&lt;T&gt;::EpetraMatrix(Mat m)</span>
<a name="l00371"></a>00371 <span class="comment">//   : _destroy_mat_on_exit(false)</span>
<a name="l00372"></a>00372 <span class="comment">// {</span>
<a name="l00373"></a>00373 <span class="comment">//   this-&gt;_mat = m;</span>
<a name="l00374"></a>00374 <span class="comment">//   this-&gt;_is_initialized = true;</span>
<a name="l00375"></a>00375 <span class="comment">// }</span>
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00381"></a>00381 <span class="keyword">inline</span>
<a name="l00382"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4709172e24ee4792dd74af5567541d0a">00382</a> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4709172e24ee4792dd74af5567541d0a">EpetraMatrix&lt;T&gt;::~EpetraMatrix</a>()
<a name="l00383"></a>00383 {
<a name="l00384"></a>00384   this-&gt;clear();
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00390"></a>00390 <span class="keyword">inline</span>
<a name="l00391"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#aec7c5a68bf7a9f0e06323e117cb3b295">00391</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aec7c5a68bf7a9f0e06323e117cb3b295">EpetraMatrix&lt;T&gt;::close</a> ()<span class="keyword"> const</span>
<a name="l00392"></a>00392 <span class="keyword"></span>{
<a name="l00393"></a>00393   libmesh_assert (_mat != NULL);
<a name="l00394"></a>00394   
<a name="l00395"></a>00395   _mat-&gt;GlobalAssemble();
<a name="l00396"></a>00396 }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00401"></a>00401 <span class="keyword">inline</span>
<a name="l00402"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a8a9ed3dbae7bf870cfd5dc01759a9b8e">00402</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a8a9ed3dbae7bf870cfd5dc01759a9b8e">EpetraMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00403"></a>00403 <span class="keyword"></span>{
<a name="l00404"></a>00404   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00405"></a>00405   
<a name="l00406"></a>00406   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_mat-&gt;NumGlobalRows());
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00412"></a>00412 <span class="keyword">inline</span>
<a name="l00413"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a968094c6395539e97b805221b92c992d">00413</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a968094c6395539e97b805221b92c992d">EpetraMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00414"></a>00414 <span class="keyword"></span>{
<a name="l00415"></a>00415   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00416"></a>00416   
<a name="l00417"></a>00417   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_mat-&gt;NumGlobalCols());
<a name="l00418"></a>00418 }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00423"></a>00423 <span class="keyword">inline</span>
<a name="l00424"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a12f22b43047f8aa3159649ab40463af1">00424</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a12f22b43047f8aa3159649ab40463af1">EpetraMatrix&lt;T&gt;::row_start</a> ()<span class="keyword"> const</span>
<a name="l00425"></a>00425 <span class="keyword"></span>{
<a name="l00426"></a>00426   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00427"></a>00427   libmesh_assert (_map != NULL);
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_map-&gt;MinMyGID());
<a name="l00430"></a>00430 }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00435"></a>00435 <span class="keyword">inline</span>
<a name="l00436"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4125d9d44ed2a3ea3ff234beb8fd24c9">00436</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a4125d9d44ed2a3ea3ff234beb8fd24c9">EpetraMatrix&lt;T&gt;::row_stop</a> ()<span class="keyword"> const</span>
<a name="l00437"></a>00437 <span class="keyword"></span>{
<a name="l00438"></a>00438   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00439"></a>00439   libmesh_assert (_map != NULL);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(_map-&gt;MaxMyGID())+1;
<a name="l00442"></a>00442 }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00447"></a>00447 <span class="keyword">inline</span>
<a name="l00448"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa5de570535c85bbdff54f2e8669e8ad1">00448</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa5de570535c85bbdff54f2e8669e8ad1">EpetraMatrix&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00449"></a>00449                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00450"></a>00450                            <span class="keyword">const</span> T value)
<a name="l00451"></a>00451 {  
<a name="l00452"></a>00452   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="keywordtype">int</span> 
<a name="l00455"></a>00455     epetra_i = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i),
<a name="l00456"></a>00456     epetra_j = static_cast&lt;int&gt;(j);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   T epetra_value = value;
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="keywordflow">if</span> (_mat-&gt;Filled())    
<a name="l00461"></a>00461     _mat-&gt;ReplaceGlobalValues (epetra_i, 1, &amp;epetra_value, &amp;epetra_j);
<a name="l00462"></a>00462   <span class="keywordflow">else</span>    
<a name="l00463"></a>00463     _mat-&gt;InsertGlobalValues (epetra_i, 1, &amp;epetra_value, &amp;epetra_j);
<a name="l00464"></a>00464 }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00469"></a>00469 <span class="keyword">inline</span>
<a name="l00470"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a229afccafdcb6c5f78244c6ec91a46e9">00470</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a229afccafdcb6c5f78244c6ec91a46e9">EpetraMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00471"></a>00471                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00472"></a>00472                            <span class="keyword">const</span> T value)
<a name="l00473"></a>00473 {
<a name="l00474"></a>00474   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00475"></a>00475   
<a name="l00476"></a>00476   <span class="keywordtype">int</span> 
<a name="l00477"></a>00477     epetra_i = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i),
<a name="l00478"></a>00478     epetra_j = static_cast&lt;int&gt;(j);
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   T epetra_value = value;
<a name="l00481"></a>00481   
<a name="l00482"></a>00482   _mat-&gt;SumIntoGlobalValues (epetra_i, 1, &amp;epetra_value, &amp;epetra_j);
<a name="l00483"></a>00483 }
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00488"></a>00488 <span class="keyword">inline</span>
<a name="l00489"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a07465fb10ec71e3ea94d79e7f5d696e3">00489</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#aa7e5240157a7e20cdcba401fce6e9985">EpetraMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00490"></a>00490                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00491"></a>00491 {
<a name="l00492"></a>00492   this-&gt;add_matrix (dm, dof_indices, dof_indices);
<a name="l00493"></a>00493 }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00498"></a>00498 <span class="keyword">inline</span>
<a name="l00499"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#aec3f28683cb78a91580c94db8a152dbd">00499</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a229afccafdcb6c5f78244c6ec91a46e9">EpetraMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X_in)
<a name="l00500"></a>00500 {
<a name="l00501"></a>00501   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="comment">// sanity check. but this cannot avoid </span>
<a name="l00504"></a>00504   <span class="comment">// crash due to incompatible sparsity structure...</span>
<a name="l00505"></a>00505   libmesh_assert (this-&gt;m() == X_in.<a class="code" href="classlibMesh_1_1SparseMatrix.php#ad0f01d9919e7b33f2d614848e494bb44">m</a>());
<a name="l00506"></a>00506   libmesh_assert (this-&gt;n() == X_in.<a class="code" href="classlibMesh_1_1SparseMatrix.php#adf547081169c5a585ea1d7bf816f4edc">n</a>());
<a name="l00507"></a>00507 
<a name="l00508"></a>00508   libmesh_not_implemented();
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="comment">//   PetscScalar     a = static_cast&lt;PetscScalar&gt;      (a_in);</span>
<a name="l00511"></a>00511 <span class="comment">//   EpetraMatrix&lt;T&gt;* X = libmesh_cast_ptr&lt;EpetraMatrix&lt;T&gt;*&gt; (&amp;X_in);</span>
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="comment">//   libmesh_assert (X != NULL);</span>
<a name="l00514"></a>00514   
<a name="l00515"></a>00515 <span class="comment">//   int ierr=0;</span>
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 <span class="comment">//   // the matrix from which we copy the values has to be assembled/closed</span>
<a name="l00518"></a>00518 <span class="comment">//   X-&gt;close ();</span>
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 <span class="comment">// // 2.2.x &amp; earlier style</span>
<a name="l00521"></a>00521 <span class="comment">// #if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00522"></a>00522   
<a name="l00523"></a>00523 <span class="comment">//   ierr = MatAXPY(&amp;a,  X-&gt;_mat, _mat, SAME_NONZERO_PATTERN);</span>
<a name="l00524"></a>00524 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00525"></a>00525          
<a name="l00526"></a>00526 <span class="comment">// // 2.3.x &amp; newer</span>
<a name="l00527"></a>00527 <span class="comment">// #else</span>
<a name="l00528"></a>00528   
<a name="l00529"></a>00529 <span class="comment">//   ierr = MatAXPY(_mat, a, X-&gt;_mat, DIFFERENT_NONZERO_PATTERN);</span>
<a name="l00530"></a>00530 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00531"></a>00531          
<a name="l00532"></a>00532 <span class="comment">// #endif</span>
<a name="l00533"></a>00533 }
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00539"></a>00539 <span class="keyword">inline</span>
<a name="l00540"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#ada3b245053ae16108581a3653cfe01b9">00540</a> T <a class="code" href="classlibMesh_1_1EpetraMatrix.php#ada3b245053ae16108581a3653cfe01b9">EpetraMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00541"></a>00541                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00542"></a>00542 <span class="keyword"></span>{
<a name="l00543"></a>00543   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00544"></a>00544   libmesh_assert (this-&gt;_mat != NULL);
<a name="l00545"></a>00545   libmesh_assert (this-&gt;_mat-&gt;MyGlobalRow(i));
<a name="l00546"></a>00546   libmesh_assert (i &gt;= this-&gt;row_start());
<a name="l00547"></a>00547   libmesh_assert (i &lt; this-&gt;row_stop());
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="keywordtype">int</span> row_length, *row_indices;
<a name="l00551"></a>00551   <span class="keywordtype">double</span> *values;
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   _mat-&gt;ExtractMyRowView (i-this-&gt;row_start(),
<a name="l00554"></a>00554                           row_length,
<a name="l00555"></a>00555                           values,
<a name="l00556"></a>00556                           row_indices);
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   <span class="comment">//libMesh::out &lt;&lt; &quot;row_length=&quot; &lt;&lt; row_length &lt;&lt; std::endl;</span>
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="keywordtype">int</span> *index = std::lower_bound (row_indices, row_indices+row_length, j);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562   libmesh_assert (*index &lt; row_length);
<a name="l00563"></a>00563   libmesh_assert (static_cast&lt;unsigned int&gt;(row_indices[*index]) == j);
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="comment">//libMesh::out &lt;&lt; &quot;val=&quot; &lt;&lt; values[*index] &lt;&lt; std::endl;</span>
<a name="l00566"></a>00566   
<a name="l00567"></a>00567   <span class="keywordflow">return</span> values[*index];
<a name="l00568"></a>00568 }
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00574"></a>00574 <span class="keyword">inline</span>
<a name="l00575"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0961b114f8a5817c75b478644e5bb916">00575</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a0961b114f8a5817c75b478644e5bb916">EpetraMatrix&lt;T&gt;::closed</a>()<span class="keyword"> const</span>
<a name="l00576"></a>00576 <span class="keyword"></span>{
<a name="l00577"></a>00577   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00578"></a>00578   libmesh_assert (this-&gt;_mat != NULL);
<a name="l00579"></a>00579   
<a name="l00580"></a>00580   <span class="keywordflow">return</span> this-&gt;_mat-&gt;Filled();
<a name="l00581"></a>00581 }
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00585"></a>00585 <span class="keyword">inline</span>
<a name="l00586"></a>00586 <span class="comment">//void EpetraMatrix&lt;T&gt;::swap(EpetraMatrix&lt;T&gt; &amp;m) </span>
<a name="l00587"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a273f59c6b2e4964915ed36e159bc0d9b">00587</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a273f59c6b2e4964915ed36e159bc0d9b">EpetraMatrix&lt;T&gt;::swap</a>(<a class="code" href="classlibMesh_1_1EpetraMatrix.php">EpetraMatrix&lt;T&gt;</a> &amp;) 
<a name="l00588"></a>00588 {
<a name="l00589"></a>00589   libmesh_not_implemented();
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 <span class="comment">//   std::swap(_mat, m._mat);</span>
<a name="l00592"></a>00592 <span class="comment">//   std::swap(_destroy_mat_on_exit, m._destroy_mat_on_exit);</span>
<a name="l00593"></a>00593 }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00600"></a>00600 <span class="keyword">inline</span>
<a name="l00601"></a><a class="code" href="classlibMesh_1_1EpetraMatrix.php#a6c1342a8fc8645c439a89a37f6195e66">00601</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraMatrix.php#a6c1342a8fc8645c439a89a37f6195e66">EpetraMatrix&lt;T&gt;::print_personal</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00602"></a>00602 <span class="keyword"></span>{
<a name="l00603"></a>00603   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00604"></a>00604   libmesh_assert (_mat != NULL);
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   os &lt;&lt; *_mat;
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 } <span class="comment">// namespace libMesh</span>
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00612"></a>00612 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_epetra_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
