<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_epetra_vector.C</div>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_vector.C 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local Includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__epetra__vector_8h.php">trilinos_epetra_vector.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Trilinos Includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;Epetra_LocalMap.h&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;Epetra_Comm.h&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;Epetra_Map.h&gt;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;Epetra_BlockMap.h&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;Epetra_Import.h&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;Epetra_Export.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;Epetra_Util.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;Epetra_IntSerialDenseVector.h&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &lt;Epetra_SerialDenseVector.h&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &lt;Epetra_Vector.h&gt;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">namespace </span>libMesh
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#adf626509f9ec0be93331bee02499b7f0">00048</a> T <a class="code" href="classlibMesh_1_1EpetraVector.php#adf626509f9ec0be93331bee02499b7f0">EpetraVector&lt;T&gt;::sum</a> ()<span class="keyword"> const</span>
<a name="l00049"></a>00049 <span class="keyword"></span>{
<a name="l00050"></a>00050   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00051"></a>00051   
<a name="l00052"></a>00052   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = _vec-&gt;MyLength();
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   T <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>=0.0;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   T * values = _vec-&gt;Values();
<a name="l00057"></a>00057   
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00059"></a>00059     sum += values[i];
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   Parallel::sum&lt;T&gt;(<a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>);
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00067"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a9ecf30eb7b9fcdc53e08517f6c0a9aac">00067</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9ecf30eb7b9fcdc53e08517f6c0a9aac">EpetraVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword"></span>{
<a name="l00069"></a>00069   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   _vec-&gt;Norm1(&amp;value);
<a name="l00074"></a>00074   
<a name="l00075"></a>00075   <span class="keywordflow">return</span> value;
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00079"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a92639f82c52a0d68e4dbb225e12a2b8a">00079</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a92639f82c52a0d68e4dbb225e12a2b8a">EpetraVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00082"></a>00082   
<a name="l00083"></a>00083   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   _vec-&gt;Norm2(&amp;value);
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="keywordflow">return</span> value;
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00091"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a81bf109b8faed8f69e0ac2526291138a">00091</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a81bf109b8faed8f69e0ac2526291138a">EpetraVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00092"></a>00092 <span class="keyword"></span>{
<a name="l00093"></a>00093   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   _vec-&gt;NormInf(&amp;value);
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="keywordflow">return</span> value;
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00103"></a>00103 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00104"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ae7c104623427f98fd17b8bb29e8cb62b">00104</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#ae7c104623427f98fd17b8bb29e8cb62b">EpetraVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   this-&gt;add(1., v);
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00116"></a>00116 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00117"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a83db01744bdf55f476f601a8c7498797">00117</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a83db01744bdf55f476f601a8c7498797">EpetraVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   this-&gt;add(-1., v);
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00129"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a38d68940bf5b654b7e98c1356174c168">00129</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a38d68940bf5b654b7e98c1356174c168">EpetraVector&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_in, <span class="keyword">const</span> T value_in)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   <span class="keywordtype">int</span> i = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span> (i_in);
<a name="l00132"></a>00132   T value = value_in;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   libmesh_assert(i_in&lt;this-&gt;size());
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   ReplaceGlobalValues(1, &amp;i, &amp;value);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   this-&gt;_is_closed = <span class="keyword">false</span>;
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00144"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">00144</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">EpetraVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_in, <span class="keyword">const</span> T value_in)
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146   <span class="keywordtype">int</span> i = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span> (i_in);
<a name="l00147"></a>00147   T value = value_in;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   libmesh_assert(i_in&lt;this-&gt;size());
<a name="l00150"></a>00150   
<a name="l00151"></a>00151   SumIntoGlobalValues(1, &amp;i, &amp;value);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   this-&gt;_is_closed = <span class="keyword">false</span>;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00159"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">00159</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">EpetraVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00160"></a>00160                                   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00161"></a>00161 {
<a name="l00162"></a>00162   libmesh_assert (v.size() == dof_indices.size());
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   SumIntoGlobalValues (v.size(),
<a name="l00165"></a>00165                        (<span class="keywordtype">int</span>*) &amp;dof_indices[0],
<a name="l00166"></a>00166                        const_cast&lt;T*&gt;(&amp;v[0]));
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00172"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ac2b4be341fa762389819a76c662571a8">00172</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">EpetraVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00173"></a>00173                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00178"></a>00178     this-&gt;add (dof_indices[i], V(i));
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="comment">// TODO: fill this in after creating an EpetraMatrix</span>
<a name="l00184"></a>00184 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00185"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afc958e8fff2192b5ab4de1d7fdc2ea54">00185</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">EpetraVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/* V_in */</span>,
<a name="l00186"></a>00186                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; <span class="comment">/* A_in */</span>)
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   libmesh_not_implemented();
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="comment">//   const EpetraVector&lt;T&gt;* V = libmesh_cast_ptr&lt;const EpetraVector&lt;T&gt;*&gt;(&amp;V_in);</span>
<a name="l00191"></a>00191 <span class="comment">//   const EpetraMatrix&lt;T&gt;* A = libmesh_cast_ptr&lt;const EpetraMatrix&lt;T&gt;*&gt;(&amp;A_in);</span>
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="comment">//   int ierr=0;</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="comment">//   A-&gt;close();</span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="comment">//   // The const_cast&lt;&gt; is not elegant, but it is required since Epetra</span>
<a name="l00198"></a>00198 <span class="comment">//   // is not const-correct.  </span>
<a name="l00199"></a>00199 <span class="comment">//   ierr = MatMultAdd(const_cast&lt;EpetraMatrix&lt;T&gt;*&gt;(A)-&gt;mat(), V-&gt;_vec, _vec, _vec);</span>
<a name="l00200"></a>00200 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr); </span>
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00206"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a9e892bbb1694121499c2101e3347f72c">00206</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">EpetraVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V_in,
<a name="l00207"></a>00207                                   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209   libmesh_assert (V_in.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   SumIntoGlobalValues(dof_indices.size(),
<a name="l00212"></a>00212                       (<span class="keywordtype">int</span> *)&amp;dof_indices[0],
<a name="l00213"></a>00213                       &amp;<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a> *<span class="keyword">&gt;</span>(&amp;V_in)-&gt;<a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>()[0]);
<a name="l00214"></a>00214 }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="comment">// TODO: fill this in after creating an EpetraMatrix</span>
<a name="l00218"></a>00218 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00219"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#accd17e550b0f9ebad7740ec9433f463b">00219</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#accd17e550b0f9ebad7740ec9433f463b">EpetraVector&lt;T&gt;::add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/* V_in */</span>,
<a name="l00220"></a>00220                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; <span class="comment">/* A_in */</span>)
<a name="l00221"></a>00221 {
<a name="l00222"></a>00222   libmesh_not_implemented();
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00228"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a8fbeec611c7311c968e3f99e3d001511">00228</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">EpetraVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T v_in)
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = _vec-&gt;MyLength();
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   T * values = _vec-&gt;Values();
<a name="l00233"></a>00233   
<a name="l00234"></a>00234   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00235"></a>00235     values[i]+=v_in;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   this-&gt;_is_closed = <span class="keyword">false</span>;
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00242"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#acedd4e2042bdcb781a0a2209a72acdfa">00242</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">EpetraVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00243"></a>00243 {
<a name="l00244"></a>00244   this-&gt;add (1., v);
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00249"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a90eea3af40c65c01e92182c22674e2a5">00249</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">EpetraVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T a_in, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const EpetraVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   libmesh_assert(this-&gt;size() == v-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#a3eec013c41b5db8f1197ee82521cdd39">size</a>());
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   _vec-&gt;Update(a_in,*v-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>, 1.);
<a name="l00256"></a>00256 }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00261"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">00261</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">EpetraVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00262"></a>00262                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   libmesh_assert (v.size() == dof_indices.size());
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   ReplaceGlobalValues (v.size(),
<a name="l00267"></a>00267                        (<span class="keywordtype">int</span>*) &amp;dof_indices[0],
<a name="l00268"></a>00268                        const_cast&lt;T*&gt;(&amp;v[0]));
<a name="l00269"></a>00269 }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00274"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a196e87a2323ff3b9df7864ff5f32c32f">00274</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">EpetraVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00275"></a>00275                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00276"></a>00276 {
<a name="l00277"></a>00277   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   <span class="comment">// TODO: If V is an EpetraVector this can be optimized</span>
<a name="l00280"></a>00280   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00281"></a>00281     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00287"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a4bf548aaab95295f9dd510a8059e66b2">00287</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">EpetraVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; v,
<a name="l00288"></a>00288                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00289"></a>00289 {
<a name="l00290"></a>00290   libmesh_assert (v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00291"></a>00291   
<a name="l00292"></a>00292   std::vector&lt;T&gt; &amp;vals = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp;<span class="keyword">&gt;</span>(v).get_values();
<a name="l00293"></a>00293   
<a name="l00294"></a>00294   ReplaceGlobalValues (v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(),
<a name="l00295"></a>00295                        (<span class="keywordtype">int</span>*) &amp;dof_indices[0],
<a name="l00296"></a>00296                        &amp;vals[0]);
<a name="l00297"></a>00297 }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00302"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a7d5d5288f8959c7f38afbcff9a4853d0">00302</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">EpetraVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; v,
<a name="l00303"></a>00303                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00304"></a>00304 {
<a name="l00305"></a>00305   libmesh_assert (v.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>() == dof_indices.size());
<a name="l00306"></a>00306   
<a name="l00307"></a>00307   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; v.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>(); ++i)
<a name="l00308"></a>00308     this-&gt;<span class="keyword">set</span> (dof_indices[i], v(i));
<a name="l00309"></a>00309 }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00314"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a390f633c8db6e35d2561e700174e3002">00314</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a390f633c8db6e35d2561e700174e3002">EpetraVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor_in)
<a name="l00315"></a>00315 {
<a name="l00316"></a>00316   _vec-&gt;Scale(factor_in);
<a name="l00317"></a>00317 }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00320"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a4060e0a5542a97c62ecea60933fb3e59">00320</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a4060e0a5542a97c62ecea60933fb3e59">EpetraVector&lt;T&gt;::abs</a>()
<a name="l00321"></a>00321 {
<a name="l00322"></a>00322   _vec-&gt;Abs(*_vec);
<a name="l00323"></a>00323 }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00327"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a0f9b700f76eccebea13e0fa9a65fdd97">00327</a> T <a class="code" href="classlibMesh_1_1EpetraVector.php#a0f9b700f76eccebea13e0fa9a65fdd97">EpetraVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V_in)<span class="keyword"> const</span>
<a name="l00328"></a>00328 <span class="keyword"></span>{
<a name="l00329"></a>00329   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* V = libmesh_cast_ptr&lt;const EpetraVector&lt;T&gt;*&gt;(&amp;V_in);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   T result=0.0;
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   _vec-&gt;Dot(*V-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>, &amp;result);
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="keywordflow">return</span> result;
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00340"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afc3f3a22712325193c5113c75061ff18">00340</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc3f3a22712325193c5113c75061ff18">EpetraVector&lt;T&gt;::pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00341"></a>00341                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2)
<a name="l00342"></a>00342 {
<a name="l00343"></a>00343   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* V1 = libmesh_cast_ptr&lt;const EpetraVector&lt;T&gt;*&gt;(&amp;vec1);
<a name="l00344"></a>00344   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* V2 = libmesh_cast_ptr&lt;const EpetraVector&lt;T&gt;*&gt;(&amp;vec2);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   _vec-&gt;Multiply(1.0, *V1-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>, *V2-&gt;_vec, 0.0);
<a name="l00347"></a>00347 }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00351"></a>00351 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; 
<a name="l00352"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">00352</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">EpetraVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> T s_in)
<a name="l00353"></a>00353 {
<a name="l00354"></a>00354   _vec-&gt;PutScalar(s_in);
<a name="l00355"></a>00355   
<a name="l00356"></a>00356   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00362"></a>00362 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00363"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a68d4c7e2660babe438975683da846daa">00363</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">EpetraVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00364"></a>00364 {
<a name="l00365"></a>00365   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const EpetraVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00366"></a>00366 
<a name="l00367"></a>00367   *<span class="keyword">this</span> = *v;
<a name="l00368"></a>00368   
<a name="l00369"></a>00369   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00370"></a>00370 }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00375"></a>00375 <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>&amp;
<a name="l00376"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a5f1f9437caa360762421940513665ec3">00376</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">EpetraVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>&amp; v)
<a name="l00377"></a>00377 {
<a name="l00378"></a>00378   (*_vec) = *v.<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>;
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00381"></a>00381 }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00386"></a>00386 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00387"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a09e281b2235a1aa07f013ef93278dac8">00387</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">EpetraVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v)
<a name="l00388"></a>00388 {
<a name="l00389"></a>00389   T * values = _vec-&gt;Values();
<a name="l00390"></a>00390   
<a name="l00395"></a>00395   <span class="keywordflow">if</span>(this-&gt;size() == v.size())
<a name="l00396"></a>00396   {
<a name="l00397"></a>00397     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl=this-&gt;local_size();
<a name="l00398"></a>00398     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fli=this-&gt;first_local_index();
<a name="l00399"></a>00399     
<a name="l00400"></a>00400     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;nl;i++)
<a name="l00401"></a>00401       values[i]=v[fli+i];
<a name="l00402"></a>00402   }
<a name="l00403"></a>00403 
<a name="l00408"></a>00408   <span class="keywordflow">else</span>
<a name="l00409"></a>00409   {
<a name="l00410"></a>00410     libmesh_assert(v.size()==this-&gt;local_size());
<a name="l00411"></a>00411     
<a name="l00412"></a>00412     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl=this-&gt;local_size();
<a name="l00413"></a>00413     
<a name="l00414"></a>00414     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;nl;i++)
<a name="l00415"></a>00415       values[i]=v[i];
<a name="l00416"></a>00416   }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00419"></a>00419 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00424"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a6e1a7757b187019627a5e9cfe725afea">00424</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">EpetraVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in)<span class="keyword"> const</span>
<a name="l00425"></a>00425 <span class="keyword"></span>{
<a name="l00426"></a>00426   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>* v_local = libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   Epetra_Map rootMap = Epetra_Util::Create_Root_Map( *_map, -1);
<a name="l00429"></a>00429   v_local-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>-&gt;ReplaceMap(rootMap);
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   Epetra_Import importer(v_local-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>-&gt;Map(), *_map);
<a name="l00432"></a>00432   v_local-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>-&gt;Import(*_vec, importer, Insert);
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00438"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a426de78b9b9b5c975a6471fa1c390295">00438</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">EpetraVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in,
<a name="l00439"></a>00439                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/* send_list */</span>)<span class="keyword"> const</span>
<a name="l00440"></a>00440 <span class="keyword"></span>{
<a name="l00441"></a>00441   <span class="comment">// TODO: optimize to sync only the send list values</span>
<a name="l00442"></a>00442   this-&gt;localize(v_local_in);
<a name="l00443"></a>00443   
<a name="l00444"></a>00444 <span class="comment">//   EpetraVector&lt;T&gt;* v_local =</span>
<a name="l00445"></a>00445 <span class="comment">//   libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;v_local_in);</span>
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="comment">//   libmesh_assert (this-&gt;_map.get() != NULL);</span>
<a name="l00448"></a>00448 <span class="comment">//   libmesh_assert (v_local-&gt;_map.get() != NULL);</span>
<a name="l00449"></a>00449 <span class="comment">//   libmesh_assert (v_local-&gt;local_size() == this-&gt;size());</span>
<a name="l00450"></a>00450 <span class="comment">//   libmesh_assert (send_list.size() &lt;= v_local-&gt;size());</span>
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 <span class="comment">//   Epetra_Import importer (*v_local-&gt;_map, *this-&gt;_map);</span>
<a name="l00453"></a>00453   
<a name="l00454"></a>00454 <span class="comment">//   v_local-&gt;_vec-&gt;Import (*this-&gt;_vec, importer, Insert);</span>
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00459"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a7c55ad5cbb3d547767d10b3af4351b9f">00459</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">EpetraVector&lt;T&gt;::localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/* first_local_idx */</span>,
<a name="l00460"></a>00460                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/* last_local_idx */</span>,
<a name="l00461"></a>00461                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/* send_list */</span>)
<a name="l00462"></a>00462 {
<a name="l00463"></a>00463   libmesh_not_implemented();
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="comment">//   // Only good for serial vectors.</span>
<a name="l00466"></a>00466 <span class="comment">//   libmesh_assert (this-&gt;size() == this-&gt;local_size());</span>
<a name="l00467"></a>00467 <span class="comment">//   libmesh_assert (last_local_idx &gt; first_local_idx);</span>
<a name="l00468"></a>00468 <span class="comment">//   libmesh_assert (send_list.size() &lt;= this-&gt;size());</span>
<a name="l00469"></a>00469 <span class="comment">//   libmesh_assert (last_local_idx &lt; this-&gt;size());</span>
<a name="l00470"></a>00470   
<a name="l00471"></a>00471 <span class="comment">//   const unsigned int size       = this-&gt;size();</span>
<a name="l00472"></a>00472 <span class="comment">//   const unsigned int local_size = (last_local_idx - first_local_idx + 1);</span>
<a name="l00473"></a>00473 <span class="comment">//   int ierr=0;  </span>
<a name="l00474"></a>00474   
<a name="l00475"></a>00475 <span class="comment">//   // Don&#39;t bother for serial cases</span>
<a name="l00476"></a>00476 <span class="comment">//   if ((first_local_idx == 0) &amp;&amp;</span>
<a name="l00477"></a>00477 <span class="comment">//       (local_size == size))</span>
<a name="l00478"></a>00478 <span class="comment">//     return;</span>
<a name="l00479"></a>00479   
<a name="l00480"></a>00480   
<a name="l00481"></a>00481 <span class="comment">//   // Build a parallel vector, initialize it with the local</span>
<a name="l00482"></a>00482 <span class="comment">//   // parts of (*this)</span>
<a name="l00483"></a>00483 <span class="comment">//   EpetraVector&lt;T&gt; parallel_vec;</span>
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 <span class="comment">//   parallel_vec.init (size, local_size, true, PARALLEL);</span>
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 <span class="comment">//   // Copy part of *this into the parallel_vec</span>
<a name="l00489"></a>00489 <span class="comment">//   {</span>
<a name="l00490"></a>00490 <span class="comment">//     IS is;</span>
<a name="l00491"></a>00491 <span class="comment">//     VecScatter scatter;</span>
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 <span class="comment">//     // Create idx, idx[i] = i+first_local_idx;</span>
<a name="l00494"></a>00494 <span class="comment">//     std::vector&lt;int&gt; idx(local_size);</span>
<a name="l00495"></a>00495 <span class="comment">//     Utility::iota (idx.begin(), idx.end(), first_local_idx);</span>
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 <span class="comment">//     // Create the index set &amp; scatter object</span>
<a name="l00498"></a>00498 <span class="comment">//     ierr = ISCreateGeneral(libMesh::COMM_WORLD, local_size, &amp;idx[0], &amp;is); </span>
<a name="l00499"></a>00499 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="comment">//     ierr = VecScatterCreate(_vec,              is,</span>
<a name="l00502"></a>00502 <span class="comment">//                          parallel_vec._vec, is,</span>
<a name="l00503"></a>00503 <span class="comment">//                          &amp;scatter);</span>
<a name="l00504"></a>00504 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 <span class="comment">//     // Perform the scatter</span>
<a name="l00507"></a>00507 <span class="comment">// #if EPETRA_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 <span class="comment">//     ierr = VecScatterBegin(_vec, parallel_vec._vec, INSERT_VALUES,</span>
<a name="l00510"></a>00510 <span class="comment">//                         SCATTER_FORWARD, scatter);</span>
<a name="l00511"></a>00511 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00512"></a>00512   
<a name="l00513"></a>00513 <span class="comment">//     ierr = VecScatterEnd  (_vec, parallel_vec._vec, INSERT_VALUES,</span>
<a name="l00514"></a>00514 <span class="comment">//                         SCATTER_FORWARD, scatter);</span>
<a name="l00515"></a>00515 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 <span class="comment">// #else</span>
<a name="l00518"></a>00518            
<a name="l00519"></a>00519 <span class="comment">//       // API argument order change in Epetra 2.3.3</span>
<a name="l00520"></a>00520 <span class="comment">//     ierr = VecScatterBegin(scatter, _vec, parallel_vec._vec,</span>
<a name="l00521"></a>00521 <span class="comment">//                         INSERT_VALUES, SCATTER_FORWARD);</span>
<a name="l00522"></a>00522 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00523"></a>00523   
<a name="l00524"></a>00524 <span class="comment">//     ierr = VecScatterEnd  (scatter, _vec, parallel_vec._vec,</span>
<a name="l00525"></a>00525 <span class="comment">//                         INSERT_VALUES, SCATTER_FORWARD);</span>
<a name="l00526"></a>00526 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00527"></a>00527            
<a name="l00528"></a>00528 <span class="comment">// #endif</span>
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="comment">//     // Clean up</span>
<a name="l00531"></a>00531 <span class="comment">//     ierr = ISDestroy (is);</span>
<a name="l00532"></a>00532 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00533"></a>00533   
<a name="l00534"></a>00534 <span class="comment">//     ierr = VecScatterDestroy(scatter);</span>
<a name="l00535"></a>00535 <span class="comment">//            CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00536"></a>00536 <span class="comment">//   }</span>
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 <span class="comment">//   // localize like normal</span>
<a name="l00539"></a>00539 <span class="comment">//   parallel_vec.close();</span>
<a name="l00540"></a>00540 <span class="comment">//   parallel_vec.localize (*this, send_list);</span>
<a name="l00541"></a>00541 <span class="comment">//   this-&gt;close();</span>
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00547"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">00547</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">EpetraVector&lt;T&gt;::localize</a> (std::vector&lt;T&gt;&amp; v_local)<span class="keyword"> const</span>
<a name="l00548"></a>00548 <span class="keyword"></span>{
<a name="l00549"></a>00549   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00550"></a>00550   parallel_only();
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n  = this-&gt;size();
<a name="l00553"></a>00553   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = this-&gt;local_size();
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   libmesh_assert (this-&gt;_vec != NULL);
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   v_local.clear();
<a name="l00558"></a>00558   v_local.reserve(n);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="comment">// build up my local part</span>
<a name="l00561"></a>00561   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00562"></a>00562     v_local.push_back((*this-&gt;_vec)[i]);
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a> (v_local);
<a name="l00565"></a>00565 }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00570"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a506e7c063b9ea190a54f0ee792b75cbe">00570</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a506e7c063b9ea190a54f0ee792b75cbe">EpetraVector&lt;T&gt;::localize_to_one</a> (std::vector&lt;T&gt;&amp;  v_local,
<a name="l00571"></a>00571                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>  pid)<span class="keyword"> const</span>
<a name="l00572"></a>00572 <span class="keyword"></span>{
<a name="l00573"></a>00573   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00574"></a>00574   parallel_only();
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n  = this-&gt;size();
<a name="l00577"></a>00577   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = this-&gt;local_size();
<a name="l00578"></a>00578 
<a name="l00579"></a>00579   libmesh_assert (pid &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00580"></a>00580   libmesh_assert (this-&gt;_vec != NULL);
<a name="l00581"></a>00581   
<a name="l00582"></a>00582   v_local.clear();
<a name="l00583"></a>00583   v_local.reserve(n);
<a name="l00584"></a>00584   
<a name="l00585"></a>00585   
<a name="l00586"></a>00586   <span class="comment">// build up my local part</span>
<a name="l00587"></a>00587   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00588"></a>00588     v_local.push_back((*this-&gt;_vec)[i]);
<a name="l00589"></a>00589 
<a name="l00590"></a>00590   <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">Parallel::gather</a> (pid, v_local);
<a name="l00591"></a>00591 }
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00596"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a69cf8f4baa990583ea74f95e0ac3496a">00596</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a69cf8f4baa990583ea74f95e0ac3496a">EpetraVector&lt;T&gt;::print_matlab</a> (<span class="keyword">const</span> std::string <span class="comment">/* name */</span>)<span class="keyword"> const</span>
<a name="l00597"></a>00597 <span class="keyword"></span>{
<a name="l00598"></a>00598   libmesh_not_implemented();
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 <span class="comment">//   libmesh_assert (this-&gt;initialized());</span>
<a name="l00601"></a>00601 <span class="comment">//   libmesh_assert (this-&gt;closed());</span>
<a name="l00602"></a>00602   
<a name="l00603"></a>00603 <span class="comment">//   int ierr=0; </span>
<a name="l00604"></a>00604 <span class="comment">//   EpetraViewer epetra_viewer;</span>
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 <span class="comment">//   ierr = EpetraViewerCreate (libMesh::COMM_WORLD,</span>
<a name="l00608"></a>00608 <span class="comment">//                          &amp;epetra_viewer);</span>
<a name="l00609"></a>00609 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 <span class="comment">//   /**</span>
<a name="l00612"></a>00612 <span class="comment">//    * Create an ASCII file containing the matrix</span>
<a name="l00613"></a>00613 <span class="comment">//    * if a filename was provided.  </span>
<a name="l00614"></a>00614 <span class="comment">//    */</span>
<a name="l00615"></a>00615 <span class="comment">//   if (name != &quot;NULL&quot;)</span>
<a name="l00616"></a>00616 <span class="comment">//     {</span>
<a name="l00617"></a>00617 <span class="comment">//       ierr = EpetraViewerASCIIOpen( libMesh::COMM_WORLD,</span>
<a name="l00618"></a>00618 <span class="comment">//                                 name.c_str(),</span>
<a name="l00619"></a>00619 <span class="comment">//                                 &amp;epetra_viewer);</span>
<a name="l00620"></a>00620 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00621"></a>00621       
<a name="l00622"></a>00622 <span class="comment">//       ierr = EpetraViewerSetFormat (epetra_viewer,</span>
<a name="l00623"></a>00623 <span class="comment">//                                 EPETRA_VIEWER_ASCII_MATLAB);</span>
<a name="l00624"></a>00624 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00625"></a>00625   
<a name="l00626"></a>00626 <span class="comment">//       ierr = VecView (_vec, epetra_viewer);</span>
<a name="l00627"></a>00627 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00628"></a>00628 <span class="comment">//     }</span>
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 <span class="comment">//   /**</span>
<a name="l00631"></a>00631 <span class="comment">//    * Otherwise the matrix will be dumped to the screen.</span>
<a name="l00632"></a>00632 <span class="comment">//    */</span>
<a name="l00633"></a>00633 <span class="comment">//   else</span>
<a name="l00634"></a>00634 <span class="comment">//     {</span>
<a name="l00635"></a>00635 <span class="comment">//       ierr = EpetraViewerSetFormat (EPETRA_VIEWER_STDOUT_WORLD,</span>
<a name="l00636"></a>00636 <span class="comment">//                                 EPETRA_VIEWER_ASCII_MATLAB);</span>
<a name="l00637"></a>00637 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00638"></a>00638   
<a name="l00639"></a>00639 <span class="comment">//       ierr = VecView (_vec, EPETRA_VIEWER_STDOUT_WORLD);</span>
<a name="l00640"></a>00640 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00641"></a>00641 <span class="comment">//     }</span>
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 <span class="comment">//   /**</span>
<a name="l00645"></a>00645 <span class="comment">//    * Destroy the viewer.</span>
<a name="l00646"></a>00646 <span class="comment">//    */</span>
<a name="l00647"></a>00647 <span class="comment">//   ierr = EpetraViewerDestroy (epetra_viewer);</span>
<a name="l00648"></a>00648 <span class="comment">//          CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00656"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a89978f2a182411aef6b5e6a10527ed1c">00656</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a89978f2a182411aef6b5e6a10527ed1c">EpetraVector&lt;T&gt;::create_subvector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/* subvector */</span>,
<a name="l00657"></a>00657                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/* rows */</span>)<span class="keyword"> const</span>
<a name="l00658"></a>00658 <span class="keyword"></span>{
<a name="l00659"></a>00659   libmesh_not_implemented();
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 <span class="comment">//   // Epetra data structures</span>
<a name="l00662"></a>00662 <span class="comment">//   IS parent_is, subvector_is;</span>
<a name="l00663"></a>00663 <span class="comment">//   VecScatter scatter;</span>
<a name="l00664"></a>00664 <span class="comment">//   int ierr = 0;</span>
<a name="l00665"></a>00665   
<a name="l00666"></a>00666 <span class="comment">//   // Make sure the passed int subvector is really a EpetraVector</span>
<a name="l00667"></a>00667 <span class="comment">//   EpetraVector&lt;T&gt;* epetra_subvector = libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;subvector);</span>
<a name="l00668"></a>00668 <span class="comment">//   libmesh_assert(epetra_subvector != NULL);</span>
<a name="l00669"></a>00669   
<a name="l00670"></a>00670 <span class="comment">//   // If the epetra_subvector is already initialized, we assume that the</span>
<a name="l00671"></a>00671 <span class="comment">//   // user has already allocated the *correct* amount of space for it.</span>
<a name="l00672"></a>00672 <span class="comment">//   // If not, we use the appropriate Epetra routines to initialize it.</span>
<a name="l00673"></a>00673 <span class="comment">//   if (!epetra_subvector-&gt;initialized())</span>
<a name="l00674"></a>00674 <span class="comment">//     {</span>
<a name="l00675"></a>00675 <span class="comment">//       // Initialize the epetra_subvector to have enough space to hold</span>
<a name="l00676"></a>00676 <span class="comment">//       // the entries which will be scattered into it.  Note: such an</span>
<a name="l00677"></a>00677 <span class="comment">//       // init() function (where we let Epetra decide the number of local</span>
<a name="l00678"></a>00678 <span class="comment">//       // entries) is not currently offered by the EpetraVector</span>
<a name="l00679"></a>00679 <span class="comment">//       // class.  Should we differentiate here between sequential and</span>
<a name="l00680"></a>00680 <span class="comment">//       // parallel vector creation based on libMesh::n_processors() ?</span>
<a name="l00681"></a>00681 <span class="comment">//       ierr = VecCreateMPI(libMesh::COMM_WORLD,</span>
<a name="l00682"></a>00682 <span class="comment">//                        EPETRA_DECIDE,          // n_local</span>
<a name="l00683"></a>00683 <span class="comment">//                        rows.size(),           // n_global</span>
<a name="l00684"></a>00684 <span class="comment">//                        &amp;(epetra_subvector-&gt;_vec)); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 <span class="comment">//       ierr = VecSetFromOptions (epetra_subvector-&gt;_vec); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 <span class="comment">//       // Mark the subvector as initialized</span>
<a name="l00689"></a>00689 <span class="comment">//       epetra_subvector-&gt;_is_initialized = true;</span>
<a name="l00690"></a>00690 <span class="comment">//     }</span>
<a name="l00691"></a>00691   
<a name="l00692"></a>00692 <span class="comment">//   // Use iota to fill an array with entries [0,1,2,3,4,...rows.size()]</span>
<a name="l00693"></a>00693 <span class="comment">//   std::vector&lt;int&gt; idx(rows.size());</span>
<a name="l00694"></a>00694 <span class="comment">//   Utility::iota (idx.begin(), idx.end(), 0);</span>
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 <span class="comment">//   // Construct index sets</span>
<a name="l00697"></a>00697 <span class="comment">//   ierr = ISCreateGeneral(libMesh::COMM_WORLD,</span>
<a name="l00698"></a>00698 <span class="comment">//                       rows.size(),</span>
<a name="l00699"></a>00699 <span class="comment">//                       (int*) &amp;rows[0],</span>
<a name="l00700"></a>00700 <span class="comment">//                       &amp;parent_is); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 <span class="comment">//   ierr = ISCreateGeneral(libMesh::COMM_WORLD,</span>
<a name="l00703"></a>00703 <span class="comment">//                       rows.size(),</span>
<a name="l00704"></a>00704 <span class="comment">//                       (int*) &amp;idx[0],</span>
<a name="l00705"></a>00705 <span class="comment">//                       &amp;subvector_is); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 <span class="comment">//   // Construct the scatter object</span>
<a name="l00708"></a>00708 <span class="comment">//   ierr = VecScatterCreate(this-&gt;_vec,</span>
<a name="l00709"></a>00709 <span class="comment">//                        parent_is,</span>
<a name="l00710"></a>00710 <span class="comment">//                        epetra_subvector-&gt;_vec,</span>
<a name="l00711"></a>00711 <span class="comment">//                        subvector_is,</span>
<a name="l00712"></a>00712 <span class="comment">//                        &amp;scatter); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 <span class="comment">//   // Actually perform the scatter</span>
<a name="l00715"></a>00715 <span class="comment">// #if EPETRA_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00716"></a>00716 <span class="comment">//   ierr = VecScatterBegin(this-&gt;_vec,</span>
<a name="l00717"></a>00717 <span class="comment">//                       epetra_subvector-&gt;_vec,</span>
<a name="l00718"></a>00718 <span class="comment">//                       INSERT_VALUES,</span>
<a name="l00719"></a>00719 <span class="comment">//                       SCATTER_FORWARD,</span>
<a name="l00720"></a>00720 <span class="comment">//                       scatter); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 <span class="comment">//   ierr = VecScatterEnd(this-&gt;_vec,</span>
<a name="l00723"></a>00723 <span class="comment">//                     epetra_subvector-&gt;_vec,</span>
<a name="l00724"></a>00724 <span class="comment">//                     INSERT_VALUES,</span>
<a name="l00725"></a>00725 <span class="comment">//                     SCATTER_FORWARD,</span>
<a name="l00726"></a>00726 <span class="comment">//                     scatter); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00727"></a>00727 <span class="comment">// #else</span>
<a name="l00728"></a>00728 <span class="comment">//   // API argument order change in Epetra 2.3.3</span>
<a name="l00729"></a>00729 <span class="comment">//   ierr = VecScatterBegin(scatter,</span>
<a name="l00730"></a>00730 <span class="comment">//                       this-&gt;_vec,</span>
<a name="l00731"></a>00731 <span class="comment">//                       epetra_subvector-&gt;_vec,</span>
<a name="l00732"></a>00732 <span class="comment">//                       INSERT_VALUES,</span>
<a name="l00733"></a>00733 <span class="comment">//                       SCATTER_FORWARD); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 <span class="comment">//   ierr = VecScatterEnd(scatter,</span>
<a name="l00736"></a>00736 <span class="comment">//                     this-&gt;_vec,</span>
<a name="l00737"></a>00737 <span class="comment">//                     epetra_subvector-&gt;_vec,</span>
<a name="l00738"></a>00738 <span class="comment">//                     INSERT_VALUES,</span>
<a name="l00739"></a>00739 <span class="comment">//                     SCATTER_FORWARD); CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00740"></a>00740 <span class="comment">// #endif</span>
<a name="l00741"></a>00741   
<a name="l00742"></a>00742 <span class="comment">//   // Clean up </span>
<a name="l00743"></a>00743 <span class="comment">//   ierr = ISDestroy(parent_is);       CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00744"></a>00744 <span class="comment">//   ierr = ISDestroy(subvector_is);    CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00745"></a>00745 <span class="comment">//   ierr = VecScatterDestroy(scatter); CHKERRABORT(libMesh::COMM_WORLD,ierr); </span>
<a name="l00746"></a>00746 }
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 <span class="comment">/*********************************************************************</span>
<a name="l00750"></a>00750 <span class="comment"> * The following were copied (and slightly modified) from</span>
<a name="l00751"></a>00751 <span class="comment"> * Epetra_FEVector.h in order to allow us to use a standard</span>
<a name="l00752"></a>00752 <span class="comment"> * Epetra_Vector... which is more compatible with other Trilinos</span>
<a name="l00753"></a>00753 <span class="comment"> * packages such as NOX.  All of this code is originally under LGPL</span>
<a name="l00754"></a>00754 <span class="comment"> *********************************************************************/</span>
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00757"></a>00757 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00758"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">00758</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">EpetraVector&lt;T&gt;::SumIntoGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00759"></a>00759                                          <span class="keyword">const</span> <span class="keywordtype">double</span>* values)
<a name="l00760"></a>00760 {
<a name="l00761"></a>00761   <span class="keywordflow">return</span>( inputValues( numIDs, GIDs, values, <span class="keyword">true</span>) );
<a name="l00762"></a>00762 }
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00765"></a>00765 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00766"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a8ca96e63b7ac1922212303238cd662b7">00766</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">EpetraVector&lt;T&gt;::SumIntoGlobalValues</a>(<span class="keyword">const</span> Epetra_IntSerialDenseVector&amp; GIDs,
<a name="l00767"></a>00767                                          <span class="keyword">const</span> Epetra_SerialDenseVector&amp; values)
<a name="l00768"></a>00768 {
<a name="l00769"></a>00769   <span class="keywordflow">if</span> (GIDs.Length() != values.Length()) {
<a name="l00770"></a>00770     <span class="keywordflow">return</span>(-1);
<a name="l00771"></a>00771   }
<a name="l00772"></a>00772 
<a name="l00773"></a>00773   <span class="keywordflow">return</span>( inputValues( GIDs.Length(), GIDs.Values(), values.Values(), <span class="keyword">true</span>) );
<a name="l00774"></a>00774 }
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00777"></a>00777 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00778"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a2bfdfe8077330b359bab8a076b7800bf">00778</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">EpetraVector&lt;T&gt;::SumIntoGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00779"></a>00779                                          <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00780"></a>00780                                          <span class="keyword">const</span> <span class="keywordtype">double</span>* values)
<a name="l00781"></a>00781 {
<a name="l00782"></a>00782   <span class="keywordflow">return</span>( inputValues( numIDs, GIDs, numValuesPerID, values, <span class="keyword">true</span>) );
<a name="l00783"></a>00783 }
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00786"></a>00786 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00787"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">00787</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">EpetraVector&lt;T&gt;::ReplaceGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00788"></a>00788                                          <span class="keyword">const</span> <span class="keywordtype">double</span>* values)
<a name="l00789"></a>00789 {
<a name="l00790"></a>00790   <span class="keywordflow">return</span>( inputValues( numIDs, GIDs, values, <span class="keyword">false</span>) );
<a name="l00791"></a>00791 }
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00794"></a>00794 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00795"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a6817edeef2738abbfd08e7dacd538cc7">00795</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">EpetraVector&lt;T&gt;::ReplaceGlobalValues</a>(<span class="keyword">const</span> Epetra_IntSerialDenseVector&amp; GIDs,
<a name="l00796"></a>00796                                          <span class="keyword">const</span> Epetra_SerialDenseVector&amp; values)
<a name="l00797"></a>00797 {
<a name="l00798"></a>00798   <span class="keywordflow">if</span> (GIDs.Length() != values.Length()) {
<a name="l00799"></a>00799     <span class="keywordflow">return</span>(-1);
<a name="l00800"></a>00800   }
<a name="l00801"></a>00801 
<a name="l00802"></a>00802   <span class="keywordflow">return</span>( inputValues( GIDs.Length(), GIDs.Values(), values.Values(), <span class="keyword">false</span>) );
<a name="l00803"></a>00803 }
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00806"></a>00806 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00807"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a33880b9437af816953463d24f9ae778f">00807</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">EpetraVector&lt;T&gt;::ReplaceGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00808"></a>00808                                          <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00809"></a>00809                                          <span class="keyword">const</span> <span class="keywordtype">double</span>* values)
<a name="l00810"></a>00810 {
<a name="l00811"></a>00811   <span class="keywordflow">return</span>( inputValues( numIDs, GIDs, numValuesPerID, values, <span class="keyword">false</span>) );
<a name="l00812"></a>00812 }
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00815"></a>00815 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00816"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#aab04851cd42cbdc56e2ed49cfe01c618">00816</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aab04851cd42cbdc56e2ed49cfe01c618">EpetraVector&lt;T&gt;::inputValues</a>(<span class="keywordtype">int</span> numIDs,
<a name="l00817"></a>00817                                  <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00818"></a>00818                                  <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00819"></a>00819                                  <span class="keywordtype">bool</span> accumulate)
<a name="l00820"></a>00820 {
<a name="l00821"></a>00821  <span class="comment">//Important note!! This method assumes that there is only 1 point</span>
<a name="l00822"></a>00822  <span class="comment">//associated with each element.</span>
<a name="l00823"></a>00823 
<a name="l00824"></a>00824   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;numIDs; ++i) {
<a name="l00825"></a>00825     <span class="keywordflow">if</span> (_vec-&gt;Map().MyGID(GIDs[i])) {
<a name="l00826"></a>00826       <span class="keywordflow">if</span> (accumulate) {
<a name="l00827"></a>00827         _vec-&gt;SumIntoGlobalValue(GIDs[i], 0, 0, values[i]);
<a name="l00828"></a>00828       }
<a name="l00829"></a>00829       <span class="keywordflow">else</span> {
<a name="l00830"></a>00830         _vec-&gt;ReplaceGlobalValue(GIDs[i], 0, 0, values[i]);
<a name="l00831"></a>00831       }
<a name="l00832"></a>00832     }
<a name="l00833"></a>00833     <span class="keywordflow">else</span> {
<a name="l00834"></a>00834       <span class="keywordflow">if</span> (!ignoreNonLocalEntries_) {
<a name="l00835"></a>00835         EPETRA_CHK_ERR( inputNonlocalValue(GIDs[i], values[i], accumulate) );
<a name="l00836"></a>00836       }
<a name="l00837"></a>00837     }
<a name="l00838"></a>00838   }
<a name="l00839"></a>00839 
<a name="l00840"></a>00840   <span class="keywordflow">return</span>(0);
<a name="l00841"></a>00841 }
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00844"></a>00844 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00845"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ad9c67dc10b19858b281eaa3ecbe49e64">00845</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aab04851cd42cbdc56e2ed49cfe01c618">EpetraVector&lt;T&gt;::inputValues</a>(<span class="keywordtype">int</span> numIDs,
<a name="l00846"></a>00846                                  <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00847"></a>00847                                  <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00848"></a>00848                                  <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00849"></a>00849                                  <span class="keywordtype">bool</span> accumulate)
<a name="l00850"></a>00850 {
<a name="l00851"></a>00851   <span class="keywordtype">int</span> offset=0;
<a name="l00852"></a>00852   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;numIDs; ++i) {
<a name="l00853"></a>00853     <span class="keywordtype">int</span> numValues = numValuesPerID[i];
<a name="l00854"></a>00854     <span class="keywordflow">if</span> (_vec-&gt;Map().MyGID(GIDs[i])) {
<a name="l00855"></a>00855       <span class="keywordflow">if</span> (accumulate) {
<a name="l00856"></a>00856         <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;numValues; ++j) {
<a name="l00857"></a>00857           _vec-&gt;SumIntoGlobalValue(GIDs[i], j, 0, values[offset+j]);
<a name="l00858"></a>00858         }
<a name="l00859"></a>00859       }
<a name="l00860"></a>00860       <span class="keywordflow">else</span> {
<a name="l00861"></a>00861         <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;numValues; ++j) {
<a name="l00862"></a>00862           _vec-&gt;ReplaceGlobalValue(GIDs[i], j, 0, values[offset+j]);
<a name="l00863"></a>00863         }
<a name="l00864"></a>00864       }
<a name="l00865"></a>00865     }
<a name="l00866"></a>00866     <span class="keywordflow">else</span> {
<a name="l00867"></a>00867       <span class="keywordflow">if</span> (!ignoreNonLocalEntries_) {
<a name="l00868"></a>00868         EPETRA_CHK_ERR( inputNonlocalValues(GIDs[i], numValues,
<a name="l00869"></a>00869                                             &amp;(values[offset]), accumulate) );
<a name="l00870"></a>00870       }
<a name="l00871"></a>00871     }
<a name="l00872"></a>00872     offset += numValues;
<a name="l00873"></a>00873   }
<a name="l00874"></a>00874 
<a name="l00875"></a>00875   <span class="keywordflow">return</span>(0);
<a name="l00876"></a>00876 }
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00879"></a>00879 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00880"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a4699de5b2bdd29556cdbbb984c21ef64">00880</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a4699de5b2bdd29556cdbbb984c21ef64">EpetraVector&lt;T&gt;::inputNonlocalValue</a>(<span class="keywordtype">int</span> GID, <span class="keywordtype">double</span> value, <span class="keywordtype">bool</span> accumulate)
<a name="l00881"></a>00881 {
<a name="l00882"></a>00882   <span class="keywordtype">int</span> insertPoint = -1;
<a name="l00883"></a>00883 
<a name="l00884"></a>00884   <span class="comment">//find offset of GID in nonlocalIDs_</span>
<a name="l00885"></a>00885   <span class="keywordtype">int</span> offset = Epetra_Util_binary_search(GID, nonlocalIDs_, numNonlocalIDs_,
<a name="l00886"></a>00886                                          insertPoint);
<a name="l00887"></a>00887   <span class="keywordflow">if</span> (offset &gt;= 0) {
<a name="l00888"></a>00888     <span class="comment">//if offset &gt;= 0</span>
<a name="l00889"></a>00889     <span class="comment">//  put value in nonlocalCoefs_[offset][0]</span>
<a name="l00890"></a>00890 
<a name="l00891"></a>00891     <span class="keywordflow">if</span> (accumulate) {
<a name="l00892"></a>00892       nonlocalCoefs_[offset][0] += value;
<a name="l00893"></a>00893     }
<a name="l00894"></a>00894     <span class="keywordflow">else</span> {
<a name="l00895"></a>00895       nonlocalCoefs_[offset][0] = value;
<a name="l00896"></a>00896     }
<a name="l00897"></a>00897   }
<a name="l00898"></a>00898   <span class="keywordflow">else</span> {
<a name="l00899"></a>00899     <span class="comment">//else</span>
<a name="l00900"></a>00900     <span class="comment">//  insert GID in nonlocalIDs_</span>
<a name="l00901"></a>00901     <span class="comment">//  insert 1   in nonlocalElementSize_</span>
<a name="l00902"></a>00902     <span class="comment">//  insert value in nonlocalCoefs_</span>
<a name="l00903"></a>00903 
<a name="l00904"></a>00904     <span class="keywordtype">int</span> tmp1 = numNonlocalIDs_;
<a name="l00905"></a>00905     <span class="keywordtype">int</span> tmp2 = allocatedNonlocalLength_;
<a name="l00906"></a>00906     <span class="keywordtype">int</span> tmp3 = allocatedNonlocalLength_;
<a name="l00907"></a>00907     EPETRA_CHK_ERR( Epetra_Util_insert(GID, insertPoint, nonlocalIDs_,
<a name="l00908"></a>00908                                        tmp1, tmp2) );
<a name="l00909"></a>00909     --tmp1;
<a name="l00910"></a>00910     EPETRA_CHK_ERR( Epetra_Util_insert(1, insertPoint, nonlocalElementSize_,
<a name="l00911"></a>00911                                        tmp1, tmp3) );
<a name="l00912"></a>00912     <span class="keywordtype">double</span>* values = <span class="keyword">new</span> <span class="keywordtype">double</span>[1];
<a name="l00913"></a>00913     values[0] = value;
<a name="l00914"></a>00914     EPETRA_CHK_ERR( Epetra_Util_insert(values, insertPoint, nonlocalCoefs_,
<a name="l00915"></a>00915                                        numNonlocalIDs_, allocatedNonlocalLength_) );
<a name="l00916"></a>00916   }
<a name="l00917"></a>00917 
<a name="l00918"></a>00918   <span class="keywordflow">return</span>(0);
<a name="l00919"></a>00919 }
<a name="l00920"></a>00920 
<a name="l00921"></a>00921 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00922"></a>00922 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00923"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a48f34eb52ce17b635443650287f6ccd3">00923</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a48f34eb52ce17b635443650287f6ccd3">EpetraVector&lt;T&gt;::inputNonlocalValues</a>(<span class="keywordtype">int</span> GID, <span class="keywordtype">int</span> numValues,
<a name="l00924"></a>00924                                          <span class="keyword">const</span> <span class="keywordtype">double</span>* values, <span class="keywordtype">bool</span> accumulate)
<a name="l00925"></a>00925 {
<a name="l00926"></a>00926   <span class="keywordtype">int</span> insertPoint = -1;
<a name="l00927"></a>00927 
<a name="l00928"></a>00928   <span class="comment">//find offset of GID in nonlocalIDs_</span>
<a name="l00929"></a>00929   <span class="keywordtype">int</span> offset = Epetra_Util_binary_search(GID, nonlocalIDs_, numNonlocalIDs_,
<a name="l00930"></a>00930                                          insertPoint);
<a name="l00931"></a>00931   <span class="keywordflow">if</span> (offset &gt;= 0) {
<a name="l00932"></a>00932     <span class="comment">//if offset &gt;= 0</span>
<a name="l00933"></a>00933     <span class="comment">//  put value in nonlocalCoefs_[offset][0]</span>
<a name="l00934"></a>00934 
<a name="l00935"></a>00935     <span class="keywordflow">if</span> (numValues != nonlocalElementSize_[offset]) {
<a name="l00936"></a>00936       cerr &lt;&lt; <span class="stringliteral">&quot;Epetra_FEVector ERROR: block-size for GID &quot;</span> &lt;&lt; GID &lt;&lt; <span class="stringliteral">&quot; is &quot;</span>
<a name="l00937"></a>00937            &lt;&lt; numValues&lt;&lt;<span class="stringliteral">&quot; which doesn&#39;t match previously set block-size of &quot;</span>
<a name="l00938"></a>00938            &lt;&lt; nonlocalElementSize_[offset] &lt;&lt; endl;
<a name="l00939"></a>00939       <span class="keywordflow">return</span>(-1);
<a name="l00940"></a>00940     }
<a name="l00941"></a>00941 
<a name="l00942"></a>00942     <span class="keywordflow">if</span> (accumulate) {
<a name="l00943"></a>00943       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;numValues; ++j) {
<a name="l00944"></a>00944         nonlocalCoefs_[offset][j] += values[j];
<a name="l00945"></a>00945       }
<a name="l00946"></a>00946     }
<a name="l00947"></a>00947     <span class="keywordflow">else</span> {
<a name="l00948"></a>00948       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;numValues; ++j) {
<a name="l00949"></a>00949         nonlocalCoefs_[offset][j] = values[j];
<a name="l00950"></a>00950       }
<a name="l00951"></a>00951     }
<a name="l00952"></a>00952   }
<a name="l00953"></a>00953   <span class="keywordflow">else</span> {
<a name="l00954"></a>00954     <span class="comment">//else</span>
<a name="l00955"></a>00955     <span class="comment">//  insert GID in nonlocalIDs_</span>
<a name="l00956"></a>00956     <span class="comment">//  insert numValues   in nonlocalElementSize_</span>
<a name="l00957"></a>00957     <span class="comment">//  insert values in nonlocalCoefs_</span>
<a name="l00958"></a>00958 
<a name="l00959"></a>00959     <span class="keywordtype">int</span> tmp1 = numNonlocalIDs_;
<a name="l00960"></a>00960     <span class="keywordtype">int</span> tmp2 = allocatedNonlocalLength_;
<a name="l00961"></a>00961     <span class="keywordtype">int</span> tmp3 = allocatedNonlocalLength_;
<a name="l00962"></a>00962     EPETRA_CHK_ERR( Epetra_Util_insert(GID, insertPoint, nonlocalIDs_,
<a name="l00963"></a>00963                                        tmp1, tmp2) );
<a name="l00964"></a>00964     --tmp1;
<a name="l00965"></a>00965     EPETRA_CHK_ERR( Epetra_Util_insert(numValues, insertPoint, nonlocalElementSize_,
<a name="l00966"></a>00966                                        tmp1, tmp3) );
<a name="l00967"></a>00967     <span class="keywordtype">double</span>* newvalues = <span class="keyword">new</span> <span class="keywordtype">double</span>[numValues];
<a name="l00968"></a>00968     <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;numValues; ++j) {
<a name="l00969"></a>00969       newvalues[j] = values[j];
<a name="l00970"></a>00970     }
<a name="l00971"></a>00971     EPETRA_CHK_ERR( Epetra_Util_insert(newvalues, insertPoint, nonlocalCoefs_,
<a name="l00972"></a>00972                                        numNonlocalIDs_, allocatedNonlocalLength_) );
<a name="l00973"></a>00973   }
<a name="l00974"></a>00974 
<a name="l00975"></a>00975   <span class="keywordflow">return</span>(0);
<a name="l00976"></a>00976 }
<a name="l00977"></a>00977 
<a name="l00978"></a>00978 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00979"></a>00979 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00980"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#aec534ba0330488ed660696adef7ca5c8">00980</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aec534ba0330488ed660696adef7ca5c8">EpetraVector&lt;T&gt;::GlobalAssemble</a>(Epetra_CombineMode mode)
<a name="l00981"></a>00981 {
<a name="l00982"></a>00982   <span class="comment">//In this method we need to gather all the non-local (overlapping) data</span>
<a name="l00983"></a>00983   <span class="comment">//that&#39;s been input on each processor, into the (probably) non-overlapping</span>
<a name="l00984"></a>00984   <span class="comment">//distribution defined by the map that &#39;this&#39; vector was constructed with.</span>
<a name="l00985"></a>00985 
<a name="l00986"></a>00986   <span class="comment">//We don&#39;t need to do anything if there&#39;s only one processor or if</span>
<a name="l00987"></a>00987   <span class="comment">//ignoreNonLocalEntries_ is true.</span>
<a name="l00988"></a>00988   <span class="keywordflow">if</span> (_vec-&gt;Map().Comm().NumProc() &lt; 2 || ignoreNonLocalEntries_) {
<a name="l00989"></a>00989     <span class="keywordflow">return</span>(0);
<a name="l00990"></a>00990   }
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 
<a name="l00993"></a>00993   
<a name="l00994"></a>00994   <span class="comment">//First build a map that describes the data in nonlocalIDs_/nonlocalCoefs_.</span>
<a name="l00995"></a>00995   <span class="comment">//We&#39;ll use the arbitrary distribution constructor of Map.</span>
<a name="l00996"></a>00996 
<a name="l00997"></a>00997   Epetra_BlockMap sourceMap(-1, numNonlocalIDs_,
<a name="l00998"></a>00998                             nonlocalIDs_, nonlocalElementSize_,
<a name="l00999"></a>00999                             _vec-&gt;Map().IndexBase(), _vec-&gt;Map().Comm());
<a name="l01000"></a>01000 
<a name="l01001"></a>01001   <span class="comment">//Now build a vector to hold our nonlocalCoefs_, and to act as the source-</span>
<a name="l01002"></a>01002   <span class="comment">//vector for our import operation.</span>
<a name="l01003"></a>01003   Epetra_MultiVector nonlocalVector(sourceMap, 1);
<a name="l01004"></a>01004 
<a name="l01005"></a>01005   <span class="keywordtype">int</span> i,j;
<a name="l01006"></a>01006   <span class="keywordflow">for</span>(i=0; i&lt;numNonlocalIDs_; ++i) {
<a name="l01007"></a>01007     <span class="keywordflow">for</span>(j=0; j&lt;nonlocalElementSize_[i]; ++j) {
<a name="l01008"></a>01008       nonlocalVector.ReplaceGlobalValue(nonlocalIDs_[i], j, 0,
<a name="l01009"></a>01009                                         nonlocalCoefs_[i][j]);
<a name="l01010"></a>01010     }
<a name="l01011"></a>01011   }
<a name="l01012"></a>01012 
<a name="l01013"></a>01013   Epetra_Export exporter(sourceMap, _vec-&gt;Map());
<a name="l01014"></a>01014 
<a name="l01015"></a>01015   EPETRA_CHK_ERR( _vec-&gt;Export(nonlocalVector, exporter, mode) );
<a name="l01016"></a>01016 
<a name="l01017"></a>01017   destroyNonlocalData();
<a name="l01018"></a>01018 
<a name="l01019"></a>01019   <span class="keywordflow">return</span>(0);
<a name="l01020"></a>01020 }
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 
<a name="l01023"></a>01023 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l01024"></a>01024 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01025"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a4012c96aec95f816a6fa7718e74a7c9e">01025</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a4012c96aec95f816a6fa7718e74a7c9e">EpetraVector&lt;T&gt;::FEoperatorequals</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector</a>&amp; source)
<a name="l01026"></a>01026 {
<a name="l01027"></a>01027   (*_vec) = *(source.<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>);
<a name="l01028"></a>01028 
<a name="l01029"></a>01029   destroyNonlocalData();
<a name="l01030"></a>01030 
<a name="l01031"></a>01031   <span class="keywordflow">if</span> (source.<a class="code" href="classlibMesh_1_1EpetraVector.php#a0b3f93e467b835d167218d1b5e246bc3">allocatedNonlocalLength_</a> &gt; 0) {
<a name="l01032"></a>01032     allocatedNonlocalLength_ = source.<a class="code" href="classlibMesh_1_1EpetraVector.php#a0b3f93e467b835d167218d1b5e246bc3">allocatedNonlocalLength_</a>;
<a name="l01033"></a>01033     numNonlocalIDs_ = source.<a class="code" href="classlibMesh_1_1EpetraVector.php#a7d2aa132f0948b0ab9e27eaca79e9da3">numNonlocalIDs_</a>;
<a name="l01034"></a>01034     nonlocalIDs_ = <span class="keyword">new</span> <span class="keywordtype">int</span>[allocatedNonlocalLength_];
<a name="l01035"></a>01035     nonlocalElementSize_ = <span class="keyword">new</span> <span class="keywordtype">int</span>[allocatedNonlocalLength_];
<a name="l01036"></a>01036     nonlocalCoefs_ = <span class="keyword">new</span> <span class="keywordtype">double</span>*[allocatedNonlocalLength_];
<a name="l01037"></a>01037     <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;numNonlocalIDs_; ++i) {
<a name="l01038"></a>01038       <span class="keywordtype">int</span> elemSize = source.<a class="code" href="classlibMesh_1_1EpetraVector.php#ab608be0ceb08eee90124f50a7375fa01">nonlocalElementSize_</a>[i];
<a name="l01039"></a>01039       nonlocalCoefs_[i] = <span class="keyword">new</span> <span class="keywordtype">double</span>[elemSize];
<a name="l01040"></a>01040       nonlocalIDs_[i] = source.<a class="code" href="classlibMesh_1_1EpetraVector.php#a511d2648aecb01cf1c0afe44a5faf5e2">nonlocalIDs_</a>[i];
<a name="l01041"></a>01041       nonlocalElementSize_[i] = elemSize;
<a name="l01042"></a>01042       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;elemSize; ++j) {
<a name="l01043"></a>01043         nonlocalCoefs_[i][j] = source.<a class="code" href="classlibMesh_1_1EpetraVector.php#aa1e7328f1102266e20469f1fb8701d33">nonlocalCoefs_</a>[i][j];
<a name="l01044"></a>01044       }
<a name="l01045"></a>01045     }
<a name="l01046"></a>01046   }
<a name="l01047"></a>01047 }
<a name="l01048"></a>01048 
<a name="l01049"></a>01049 
<a name="l01050"></a>01050 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l01051"></a>01051 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01052"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ac90a48a92387c00639bc9845963fd59f">01052</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#ac90a48a92387c00639bc9845963fd59f">EpetraVector&lt;T&gt;::destroyNonlocalData</a>()
<a name="l01053"></a>01053 {
<a name="l01054"></a>01054   <span class="keywordflow">if</span> (allocatedNonlocalLength_ &gt; 0) {
<a name="l01055"></a>01055     <span class="keyword">delete</span> [] nonlocalIDs_;
<a name="l01056"></a>01056     <span class="keyword">delete</span> [] nonlocalElementSize_;
<a name="l01057"></a>01057     nonlocalIDs_ = NULL;
<a name="l01058"></a>01058     nonlocalElementSize_ = NULL;
<a name="l01059"></a>01059     <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;numNonlocalIDs_; ++i) {
<a name="l01060"></a>01060       <span class="keyword">delete</span> [] nonlocalCoefs_[i];
<a name="l01061"></a>01061     }
<a name="l01062"></a>01062     <span class="keyword">delete</span> [] nonlocalCoefs_;
<a name="l01063"></a>01063     nonlocalCoefs_ = NULL;
<a name="l01064"></a>01064     numNonlocalIDs_ = 0;
<a name="l01065"></a>01065     allocatedNonlocalLength_ = 0;
<a name="l01066"></a>01066   }
<a name="l01067"></a>01067   <span class="keywordflow">return</span>;
<a name="l01068"></a>01068 }
<a name="l01069"></a>01069 
<a name="l01070"></a>01070 
<a name="l01071"></a>01071 <span class="comment">//------------------------------------------------------------------</span>
<a name="l01072"></a>01072 <span class="comment">// Explicit instantiations</span>
<a name="l01073"></a>01073 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;Number&gt;</a>;
<a name="l01074"></a>01074 
<a name="l01075"></a>01075 } <span class="comment">// namespace libMesh</span>
<a name="l01076"></a>01076 
<a name="l01077"></a>01077 <span class="preprocessor">#endif // #ifdef HAVE_EPETRA</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
