<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_epetra_vector.h</div>  </div>
</div>
<div class="contents">
<a href="trilinos__epetra__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_epetra_vector.h 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __trilinos_epetra_vector_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_epetra_vector_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Trilinos includes</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;Epetra_CombineMode.h&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;Epetra_Map.h&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;Epetra_MultiVector.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;Epetra_Vector.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;Epetra_MpiComm.h&gt;</span>
<a name="l00041"></a>00041 <span class="keyword">class </span>Epetra_IntSerialDenseVector;
<a name="l00042"></a>00042 <span class="keyword">class </span>Epetra_SerialDenseVector;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">namespace </span>libMesh
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// forward declarations</span>
<a name="l00048"></a>00048 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00049"></a>00049 
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00058"></a><a class="code" href="classlibMesh_1_1EpetraVector.php">00058</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">explicit</span>
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <span class="keyword">explicit</span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00073"></a>00073                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00074"></a>00074     
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00080"></a>00080                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00081"></a>00081                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00082"></a>00082 
<a name="l00088"></a>00088   <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00089"></a>00089                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00090"></a>00090                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00091"></a>00091                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00092"></a>00092 
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector</a>(Epetra_Vector &amp; v);
<a name="l00101"></a>00101   
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1EpetraVector.php#a5b2347d6f3b479c1ef4440e895b584d7">~EpetraVector</a> ();
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#abf3f9f07e3a4fe3f0277f6da61afcff4">close</a> (); 
<a name="l00112"></a>00112 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#af6dc7817a297f48e34f60d4dde4d8fd1">clear</a> ();
<a name="l00117"></a>00117   
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a2e380e98855fcca2df2dd84db288ba64">zero</a> ();    
<a name="l00123"></a>00123 
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EpetraVector.php#ab2dd65aeac60ee83da46cd8c45072b2a">zero_clone</a> () <span class="keyword">const</span>;
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EpetraVector.php#afa5438432d03e9444b4a7744b6728b8c">clone</a> () <span class="keyword">const</span>;
<a name="l00135"></a>00135   
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00150"></a>00150              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00151"></a>00151              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00152"></a>00152              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00153"></a>00153     
<a name="l00157"></a>00157   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00158"></a>00158              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00159"></a>00159              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00160"></a>00160 
<a name="l00165"></a>00165   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00166"></a>00166              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00167"></a>00167              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00168"></a>00168              <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00169"></a>00169              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00170"></a>00170 
<a name="l00175"></a>00175   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00176"></a>00176                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">//   /**</span>
<a name="l00179"></a>00179   <span class="comment">//    * Change the dimension to that of the</span>
<a name="l00180"></a>00180   <span class="comment">//    * vector \p V. The same applies as for</span>
<a name="l00181"></a>00181   <span class="comment">//    * the other \p init function.</span>
<a name="l00182"></a>00182   <span class="comment">//    *</span>
<a name="l00183"></a>00183   <span class="comment">//    * The elements of \p V are not copied, i.e.</span>
<a name="l00184"></a>00184   <span class="comment">//    * this function is the same as calling</span>
<a name="l00185"></a>00185   <span class="comment">//    * \p init(V.size(),fast).</span>
<a name="l00186"></a>00186   <span class="comment">//    */</span>
<a name="l00187"></a>00187   <span class="comment">//   void init (const NumericVector&lt;T&gt;&amp; V,</span>
<a name="l00188"></a>00188   <span class="comment">//         const bool fast=false);</span>
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00194"></a>00194     
<a name="l00198"></a>00198   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00199"></a>00199 
<a name="l00203"></a>00203   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a> &amp;V);
<a name="l00204"></a>00204 
<a name="l00208"></a>00208   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1EpetraVector.php#a1be5e396f882b79362964bd110eac859">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00209"></a>00209 
<a name="l00215"></a>00215   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#aef2ce5837a55788120c58f5d83b4122e">min</a> () <span class="keyword">const</span>;
<a name="l00216"></a>00216   
<a name="l00222"></a>00222   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#ab7b99b39cb6a4be6272ce01bcd33c85d">max</a> () <span class="keyword">const</span>;
<a name="l00223"></a>00223 
<a name="l00227"></a>00227   T <a class="code" href="classlibMesh_1_1EpetraVector.php#adf626509f9ec0be93331bee02499b7f0">sum</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00233"></a>00233   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9ecf30eb7b9fcdc53e08517f6c0a9aac">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00234"></a>00234 
<a name="l00240"></a>00240   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a92639f82c52a0d68e4dbb225e12a2b8a">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00247"></a>00247   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a81bf109b8faed8f69e0ac2526291138a">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00248"></a>00248 
<a name="l00256"></a>00256   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a3eec013c41b5db8f1197ee82521cdd39">size</a> () <span class="keyword">const</span>;
<a name="l00257"></a>00257 
<a name="l00262"></a>00262   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a14f65bb6cb1f67f39045301356c94055">local_size</a>() <span class="keyword">const</span>;
<a name="l00263"></a>00263 
<a name="l00268"></a>00268   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc316f16864520c99c55ec50fe5bf4b8">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00269"></a>00269 
<a name="l00274"></a>00274   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#ae09258a2089640c728cf75b72619c52e">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00275"></a>00275     
<a name="l00279"></a>00279   T <a class="code" href="classlibMesh_1_1EpetraVector.php#afbebf858c2afa4dcb070c79388d83890">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00280"></a>00280     
<a name="l00285"></a>00285   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1EpetraVector.php#ae7c104623427f98fd17b8bb29e8cb62b">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00286"></a>00286 
<a name="l00291"></a>00291   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1EpetraVector.php#a83db01744bdf55f476f601a8c7498797">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00292"></a>00292     
<a name="l00296"></a>00296   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00297"></a>00297     
<a name="l00301"></a>00301   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00302"></a>00302     
<a name="l00308"></a>00308   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">add</a> (<span class="keyword">const</span> T s);
<a name="l00309"></a>00309     
<a name="l00315"></a>00315   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00316"></a>00316 
<a name="l00322"></a>00322   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a9a33066abe2856ce3c25bdab116be457">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00323"></a>00323   
<a name="l00329"></a>00329   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00330"></a>00330                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00331"></a>00331 
<a name="l00338"></a>00338   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00339"></a>00339                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00346"></a>00346   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00347"></a>00347                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A);
<a name="l00348"></a>00348      
<a name="l00355"></a>00355   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a98720eb68f2e3fa70868f9c7954a7dd7">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00356"></a>00356                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00357"></a>00357 
<a name="l00362"></a>00362   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#accd17e550b0f9ebad7740ec9433f463b">add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00363"></a>00363                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A_trans);
<a name="l00364"></a>00364   
<a name="l00369"></a>00369   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00370"></a>00370                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00371"></a>00371 
<a name="l00378"></a>00378   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00379"></a>00379                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00380"></a>00380       
<a name="l00386"></a>00386   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00387"></a>00387                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00388"></a>00388     
<a name="l00394"></a>00394   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a820c14ede8b132ac1a1a8171133ef29f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00395"></a>00395                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00396"></a>00396   
<a name="l00401"></a>00401   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a390f633c8db6e35d2561e700174e3002">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00402"></a>00402 
<a name="l00407"></a>00407   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a4060e0a5542a97c62ecea60933fb3e59">abs</a>();
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00413"></a>00413   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1EpetraVector.php#a0f9b700f76eccebea13e0fa9a65fdd97">dot</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00414"></a>00414   
<a name="l00419"></a>00419   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00420"></a>00420 
<a name="l00425"></a>00425   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00426"></a>00426 
<a name="l00432"></a>00432   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00433"></a>00433                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00434"></a>00434   
<a name="l00439"></a>00439   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afef8fea778d634c9d34eb3935528e53a">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00440"></a>00440                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00441"></a>00441                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00442"></a>00442   
<a name="l00449"></a>00449   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a506e7c063b9ea190a54f0ee792b75cbe">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00450"></a>00450                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00451"></a>00451   
<a name="l00456"></a>00456   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc3f3a22712325193c5113c75061ff18">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00457"></a>00457                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00458"></a>00458 
<a name="l00465"></a>00465   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a69cf8f4baa990583ea74f95e0ac3496a">print_matlab</a> (<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00466"></a>00466 
<a name="l00471"></a>00471   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a89978f2a182411aef6b5e6a10527ed1c">create_subvector</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; subvector,
<a name="l00472"></a>00472                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows) <span class="keyword">const</span>;
<a name="l00473"></a>00473 
<a name="l00477"></a>00477   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aef71c93ac3630e17fb5170b93eae604e">swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00478"></a>00478 
<a name="l00484"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a03abaf449b6dd2980bf744f231a3dc0a">00484</a>   Epetra_Vector * <a class="code" href="classlibMesh_1_1EpetraVector.php#a03abaf449b6dd2980bf744f231a3dc0a">vec</a> () { libmesh_assert (<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>; }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="keyword">private</span>:
<a name="l00487"></a>00487 
<a name="l00492"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">00492</a>   Epetra_Vector * <a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>;
<a name="l00493"></a>00493 
<a name="l00497"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#af4cf3187075fcf8738884d945fd25dee">00497</a>   Epetra_Map * <a class="code" href="classlibMesh_1_1EpetraVector.php#af4cf3187075fcf8738884d945fd25dee">_map</a>;
<a name="l00498"></a>00498 
<a name="l00503"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ae4ac0d1825f55db8ad6343ea04eed9f0">00503</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#ae4ac0d1825f55db8ad6343ea04eed9f0">_destroy_vec_on_exit</a>;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   
<a name="l00507"></a>00507   <span class="comment">/*********************************************************************</span>
<a name="l00508"></a>00508 <span class="comment">   * The following were copied (and slightly modified) from</span>
<a name="l00509"></a>00509 <span class="comment">   * Epetra_FEVector.h in order to allow us to use a standard</span>
<a name="l00510"></a>00510 <span class="comment">   * Epetra_Vector... which is more compatible with other Trilinos</span>
<a name="l00511"></a>00511 <span class="comment">   * packages such as NOX.  All of this code is originally under LGPL</span>
<a name="l00512"></a>00512 <span class="comment">   *********************************************************************/</span>
<a name="l00513"></a>00513 
<a name="l00517"></a>00517   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">SumIntoGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00518"></a>00518 
<a name="l00528"></a>00528   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">SumIntoGlobalValues</a>(<span class="keyword">const</span> Epetra_IntSerialDenseVector&amp; GIDs,
<a name="l00529"></a>00529                           <span class="keyword">const</span> Epetra_SerialDenseVector&amp; values);
<a name="l00530"></a>00530 
<a name="l00534"></a>00534   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">ReplaceGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00535"></a>00535 
<a name="l00545"></a>00545   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">ReplaceGlobalValues</a>(<span class="keyword">const</span> Epetra_IntSerialDenseVector&amp; GIDs,
<a name="l00546"></a>00546                           <span class="keyword">const</span> Epetra_SerialDenseVector&amp; values);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a12568a839178b1bc0cf5385f6734b9f5">SumIntoGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00549"></a>00549                           <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00550"></a>00550                           <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a250f4f5bc2d5b33fc4978f843c1c459e">ReplaceGlobalValues</a>(<span class="keywordtype">int</span> numIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs,
<a name="l00553"></a>00553                           <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00554"></a>00554                           <span class="keyword">const</span> <span class="keywordtype">double</span>* values);
<a name="l00555"></a>00555 
<a name="l00563"></a>00563   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aec534ba0330488ed660696adef7ca5c8">GlobalAssemble</a>(Epetra_CombineMode mode = Add);
<a name="l00564"></a>00564 
<a name="l00567"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ab1bcb9302339941f47e7c0b899dd82fe">00567</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#ab1bcb9302339941f47e7c0b899dd82fe">setIgnoreNonLocalEntries</a>(<span class="keywordtype">bool</span> flag) {
<a name="l00568"></a>00568     <a class="code" href="classlibMesh_1_1EpetraVector.php#a50a869ec4dd6355266d9b4f4e18d1396">ignoreNonLocalEntries_</a> = flag;
<a name="l00569"></a>00569   }
<a name="l00570"></a>00570 
<a name="l00571"></a>00571   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a4012c96aec95f816a6fa7718e74a7c9e">FEoperatorequals</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector</a>&amp; source);
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aab04851cd42cbdc56e2ed49cfe01c618">inputValues</a>(<span class="keywordtype">int</span> numIDs,
<a name="l00574"></a>00574                   <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00575"></a>00575                   <span class="keywordtype">bool</span> accumulate);
<a name="l00576"></a>00576 
<a name="l00577"></a>00577   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aab04851cd42cbdc56e2ed49cfe01c618">inputValues</a>(<span class="keywordtype">int</span> numIDs,
<a name="l00578"></a>00578                   <span class="keyword">const</span> <span class="keywordtype">int</span>* GIDs, <span class="keyword">const</span> <span class="keywordtype">int</span>* numValuesPerID,
<a name="l00579"></a>00579                   <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00580"></a>00580                   <span class="keywordtype">bool</span> accumulate);
<a name="l00581"></a>00581 
<a name="l00582"></a>00582   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a4699de5b2bdd29556cdbbb984c21ef64">inputNonlocalValue</a>(<span class="keywordtype">int</span> GID, <span class="keywordtype">double</span> value, <span class="keywordtype">bool</span> accumulate);
<a name="l00583"></a>00583 
<a name="l00584"></a>00584   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a48f34eb52ce17b635443650287f6ccd3">inputNonlocalValues</a>(<span class="keywordtype">int</span> GID, <span class="keywordtype">int</span> numValues, <span class="keyword">const</span> <span class="keywordtype">double</span>* values,
<a name="l00585"></a>00585                           <span class="keywordtype">bool</span> accumulate);
<a name="l00586"></a>00586 
<a name="l00587"></a>00587   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#ac90a48a92387c00639bc9845963fd59f">destroyNonlocalData</a>();
<a name="l00588"></a>00588 
<a name="l00589"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a3c12acfe04f0a76f4ae18248be2c1047">00589</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a3c12acfe04f0a76f4ae18248be2c1047">myFirstID_</a>;
<a name="l00590"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a3ca4837357a5ce0625d7789e2511b6f1">00590</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a3ca4837357a5ce0625d7789e2511b6f1">myNumIDs_</a>;
<a name="l00591"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#aa74881da558f063f8006eb4c0e8c4306">00591</a>   <span class="keywordtype">double</span>* <a class="code" href="classlibMesh_1_1EpetraVector.php#aa74881da558f063f8006eb4c0e8c4306">myCoefs_</a>;
<a name="l00592"></a>00592 
<a name="l00593"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a511d2648aecb01cf1c0afe44a5faf5e2">00593</a>   <span class="keywordtype">int</span>* <a class="code" href="classlibMesh_1_1EpetraVector.php#a511d2648aecb01cf1c0afe44a5faf5e2">nonlocalIDs_</a>;
<a name="l00594"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ab608be0ceb08eee90124f50a7375fa01">00594</a>   <span class="keywordtype">int</span>* <a class="code" href="classlibMesh_1_1EpetraVector.php#ab608be0ceb08eee90124f50a7375fa01">nonlocalElementSize_</a>;
<a name="l00595"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a7d2aa132f0948b0ab9e27eaca79e9da3">00595</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d2aa132f0948b0ab9e27eaca79e9da3">numNonlocalIDs_</a>;
<a name="l00596"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a0b3f93e467b835d167218d1b5e246bc3">00596</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a0b3f93e467b835d167218d1b5e246bc3">allocatedNonlocalLength_</a>;
<a name="l00597"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#aa1e7328f1102266e20469f1fb8701d33">00597</a>   <span class="keywordtype">double</span>** <a class="code" href="classlibMesh_1_1EpetraVector.php#aa1e7328f1102266e20469f1fb8701d33">nonlocalCoefs_</a>;
<a name="l00598"></a>00598 
<a name="l00599"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a50a869ec4dd6355266d9b4f4e18d1396">00599</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a50a869ec4dd6355266d9b4f4e18d1396">ignoreNonLocalEntries_</a>;
<a name="l00600"></a>00600 };
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00608"></a>00608 <span class="keyword">inline</span>
<a name="l00609"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">00609</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00610"></a>00610 : _destroy_vec_on_exit(true),
<a name="l00611"></a>00611   myFirstID_(0),
<a name="l00612"></a>00612   myNumIDs_(0),
<a name="l00613"></a>00613   myCoefs_(NULL),
<a name="l00614"></a>00614   nonlocalIDs_(NULL),
<a name="l00615"></a>00615   nonlocalElementSize_(NULL),
<a name="l00616"></a>00616   numNonlocalIDs_(0),
<a name="l00617"></a>00617   allocatedNonlocalLength_(0),
<a name="l00618"></a>00618   nonlocalCoefs_(NULL),
<a name="l00619"></a>00619   ignoreNonLocalEntries_(false)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>;
<a name="l00622"></a>00622 }
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00627"></a>00627 <span class="keyword">inline</span>
<a name="l00628"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a3b705107b897e258cb82f476c6b26bf4">00628</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00629"></a>00629                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00630"></a>00630 : _destroy_vec_on_exit(true),
<a name="l00631"></a>00631   myFirstID_(0),
<a name="l00632"></a>00632   myNumIDs_(0),
<a name="l00633"></a>00633   myCoefs_(NULL),
<a name="l00634"></a>00634   nonlocalIDs_(NULL),
<a name="l00635"></a>00635   nonlocalElementSize_(NULL),
<a name="l00636"></a>00636   numNonlocalIDs_(0),
<a name="l00637"></a>00637   allocatedNonlocalLength_(0),
<a name="l00638"></a>00638   nonlocalCoefs_(NULL),
<a name="l00639"></a>00639   ignoreNonLocalEntries_(false)
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 {
<a name="l00642"></a>00642   this-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00643"></a>00643 }
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00648"></a>00648 <span class="keyword">inline</span>
<a name="l00649"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#af4418f89915267d6b10e76feaef7b38f">00649</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00650"></a>00650                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00651"></a>00651                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00652"></a>00652 : _destroy_vec_on_exit(true),
<a name="l00653"></a>00653   myFirstID_(0),
<a name="l00654"></a>00654   myNumIDs_(0),
<a name="l00655"></a>00655   myCoefs_(NULL),
<a name="l00656"></a>00656   nonlocalIDs_(NULL),
<a name="l00657"></a>00657   nonlocalElementSize_(NULL),
<a name="l00658"></a>00658   numNonlocalIDs_(0),
<a name="l00659"></a>00659   allocatedNonlocalLength_(0),
<a name="l00660"></a>00660   nonlocalCoefs_(NULL),
<a name="l00661"></a>00661   ignoreNonLocalEntries_(false)
<a name="l00662"></a>00662 {
<a name="l00663"></a>00663   this-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00664"></a>00664 }
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00670"></a>00670 <span class="keyword">inline</span>
<a name="l00671"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ad9fb686ce235277c72a42e1598fdc8a4">00671</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector&lt;T&gt;::EpetraVector</a>(Epetra_Vector &amp; v)
<a name="l00672"></a>00672 : _destroy_vec_on_exit(false),
<a name="l00673"></a>00673   myFirstID_(0),
<a name="l00674"></a>00674   myNumIDs_(0),
<a name="l00675"></a>00675   myCoefs_(NULL),
<a name="l00676"></a>00676   nonlocalIDs_(NULL),
<a name="l00677"></a>00677   nonlocalElementSize_(NULL),
<a name="l00678"></a>00678   numNonlocalIDs_(0),
<a name="l00679"></a>00679   allocatedNonlocalLength_(0),
<a name="l00680"></a>00680   nonlocalCoefs_(NULL),
<a name="l00681"></a>00681   ignoreNonLocalEntries_(false)
<a name="l00682"></a>00682 {
<a name="l00683"></a>00683   <a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a> = &amp;v;
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>; <span class="comment">// FIXME - need to determine this from v!</span>
<a name="l00686"></a>00686 
<a name="l00687"></a>00687   <a class="code" href="classlibMesh_1_1EpetraVector.php#a3c12acfe04f0a76f4ae18248be2c1047">myFirstID_</a> = <a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>-&gt;Map().MinMyGID();
<a name="l00688"></a>00688   <a class="code" href="classlibMesh_1_1EpetraVector.php#a3ca4837357a5ce0625d7789e2511b6f1">myNumIDs_</a> = <a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>-&gt;Map().NumMyElements();
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   <span class="comment">//Currently we impose the restriction that NumVectors==1, so we won&#39;t</span>
<a name="l00691"></a>00691   <span class="comment">//need the LDA argument when calling ExtractView. Hence the &quot;dummy&quot; arg.</span>
<a name="l00692"></a>00692   <span class="keywordtype">int</span> dummy;
<a name="l00693"></a>00693   <a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>-&gt;ExtractView(&amp;<a class="code" href="classlibMesh_1_1EpetraVector.php#aa74881da558f063f8006eb4c0e8c4306">myCoefs_</a>, &amp;dummy);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00696"></a>00696 }
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00701"></a>00701 <span class="keyword">inline</span>
<a name="l00702"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a72d96046215e79d2f5f5b24487ef1e60">00702</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a7d296aa673e5ba9ec559c9a7565cece2">EpetraVector&lt;T&gt;::EpetraVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00703"></a>00703                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00704"></a>00704                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00705"></a>00705                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00706"></a>00706 : _destroy_vec_on_exit(true),
<a name="l00707"></a>00707   myFirstID_(0),
<a name="l00708"></a>00708   myNumIDs_(0),
<a name="l00709"></a>00709   myCoefs_(NULL),
<a name="l00710"></a>00710   nonlocalIDs_(NULL),
<a name="l00711"></a>00711   nonlocalElementSize_(NULL),
<a name="l00712"></a>00712   numNonlocalIDs_(0),
<a name="l00713"></a>00713   allocatedNonlocalLength_(0),
<a name="l00714"></a>00714   nonlocalCoefs_(NULL),
<a name="l00715"></a>00715   ignoreNonLocalEntries_(false)
<a name="l00716"></a>00716 {
<a name="l00717"></a>00717   this-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00718"></a>00718 }
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 <span class="comment">/* Default implementation for solver packages for which ghosted</span>
<a name="l00723"></a>00723 <span class="comment">   vectors are not yet implemented.  */</span>
<a name="l00724"></a>00724 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00725"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a0346dca2ec11450b3a9a48427ffab147">00725</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00726"></a>00726                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00727"></a>00727 {
<a name="l00728"></a>00728   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(other.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),other.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),fast,other.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>());
<a name="l00729"></a>00729 }
<a name="l00730"></a>00730 
<a name="l00731"></a>00731 
<a name="l00732"></a>00732 
<a name="l00733"></a>00733 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00734"></a>00734 <span class="keyword">inline</span>
<a name="l00735"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a5b2347d6f3b479c1ef4440e895b584d7">00735</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#a5b2347d6f3b479c1ef4440e895b584d7">EpetraVector&lt;T&gt;::~EpetraVector</a> ()
<a name="l00736"></a>00736 {
<a name="l00737"></a>00737   this-&gt;clear ();
<a name="l00738"></a>00738 }
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00743"></a>00743 <span class="keyword">inline</span>
<a name="l00744"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">00744</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00745"></a>00745                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00746"></a>00746                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00747"></a>00747                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00748"></a>00748 {
<a name="l00749"></a>00749   <span class="comment">// We default to allocating n_local local storage</span>
<a name="l00750"></a>00750   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_n_local = n_local;
<a name="l00751"></a>00751 
<a name="l00752"></a>00752   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00753"></a>00753     {
<a name="l00754"></a>00754       <span class="keywordflow">if</span> (n == n_local)
<a name="l00755"></a>00755         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00756"></a>00756       <span class="keywordflow">else</span>
<a name="l00757"></a>00757         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00758"></a>00758     }
<a name="l00759"></a>00759   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00760"></a>00760     {
<a name="l00761"></a>00761       <span class="comment">// We don&#39;t yet support GHOSTED Epetra vectors, so to get the</span>
<a name="l00762"></a>00762       <span class="comment">// same functionality we need a SERIAL vector with local</span>
<a name="l00763"></a>00763       <span class="comment">// storage allocated for every entry.</span>
<a name="l00764"></a>00764       this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00765"></a>00765       my_n_local = n;
<a name="l00766"></a>00766     }
<a name="l00767"></a>00767   <span class="keywordflow">else</span>
<a name="l00768"></a>00768     this-&gt;_type = type;
<a name="l00769"></a>00769 
<a name="l00770"></a>00770   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==my_n_local) ||
<a name="l00771"></a>00771                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00772"></a>00772 
<a name="l00773"></a>00773   _map = <span class="keyword">new</span> Epetra_Map(n, 
<a name="l00774"></a>00774                         my_n_local, 
<a name="l00775"></a>00775                         0, 
<a name="l00776"></a>00776                         Epetra_MpiComm (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>));
<a name="l00777"></a>00777               
<a name="l00778"></a>00778   _vec = <span class="keyword">new</span> Epetra_Vector(*_map);
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   myFirstID_ = _vec-&gt;Map().MinMyGID();
<a name="l00781"></a>00781   myNumIDs_ = _vec-&gt;Map().NumMyElements();
<a name="l00782"></a>00782 
<a name="l00783"></a>00783   <span class="comment">//Currently we impose the restriction that NumVectors==1, so we won&#39;t</span>
<a name="l00784"></a>00784   <span class="comment">//need the LDA argument when calling ExtractView. Hence the &quot;dummy&quot; arg.</span>
<a name="l00785"></a>00785   <span class="keywordtype">int</span> dummy;
<a name="l00786"></a>00786   _vec-&gt;ExtractView(&amp;myCoefs_, &amp;dummy);
<a name="l00787"></a>00787   
<a name="l00788"></a>00788   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00789"></a>00789   
<a name="l00790"></a>00790   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00791"></a>00791     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00792"></a>00792 }
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00796"></a>00796 <span class="keyword">inline</span>
<a name="l00797"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a39b5b21f401e7ad5b548a98735c87a8a">00797</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00798"></a>00798                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00799"></a>00799                             <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00800"></a>00800                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00801"></a>00801                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00802"></a>00802 {
<a name="l00803"></a>00803   <span class="comment">// TODO: we shouldn&#39;t ignore the ghost sparsity pattern</span>
<a name="l00804"></a>00804   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, fast, type);
<a name="l00805"></a>00805 }
<a name="l00806"></a>00806 
<a name="l00807"></a>00807 
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00810"></a>00810 <span class="keyword">inline</span>
<a name="l00811"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a14252005f0dbec6b193f17c672a27f25">00811</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc027379452f474cfe6dabc133183aff">EpetraVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00812"></a>00812                             <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00813"></a>00813                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00814"></a>00814 {
<a name="l00815"></a>00815   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00816"></a>00816 }
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00821"></a>00821 <span class="keyword">inline</span>
<a name="l00822"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#abf3f9f07e3a4fe3f0277f6da61afcff4">00822</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#abf3f9f07e3a4fe3f0277f6da61afcff4">EpetraVector&lt;T&gt;::close</a> ()
<a name="l00823"></a>00823 {
<a name="l00824"></a>00824   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   this-&gt;GlobalAssemble();
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00829"></a>00829 }
<a name="l00830"></a>00830 
<a name="l00831"></a>00831 
<a name="l00832"></a>00832 
<a name="l00833"></a>00833 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00834"></a>00834 <span class="keyword">inline</span>
<a name="l00835"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#af6dc7817a297f48e34f60d4dde4d8fd1">00835</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#af6dc7817a297f48e34f60d4dde4d8fd1">EpetraVector&lt;T&gt;::clear</a> ()
<a name="l00836"></a>00836 {
<a name="l00837"></a>00837   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_vec_on_exit))
<a name="l00838"></a>00838     <span class="keyword">delete</span> _vec;
<a name="l00839"></a>00839 
<a name="l00840"></a>00840   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00841"></a>00841 }
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00846"></a>00846 <span class="keyword">inline</span>
<a name="l00847"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a2e380e98855fcca2df2dd84db288ba64">00847</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a2e380e98855fcca2df2dd84db288ba64">EpetraVector&lt;T&gt;::zero</a> ()
<a name="l00848"></a>00848 {
<a name="l00849"></a>00849   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   _vec-&gt;PutScalar(0.0);
<a name="l00852"></a>00852 }
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00857"></a>00857 <span class="keyword">inline</span>
<a name="l00858"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ab2dd65aeac60ee83da46cd8c45072b2a">00858</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EpetraVector.php#ab2dd65aeac60ee83da46cd8c45072b2a">EpetraVector&lt;T&gt;::zero_clone</a> ()<span class="keyword"> const</span>
<a name="l00859"></a>00859 <span class="keyword"></span>{
<a name="l00860"></a>00860   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>);
<a name="l00861"></a>00861 
<a name="l00862"></a>00862   cloned_vector-&gt;init(*<span class="keyword">this</span>);
<a name="l00863"></a>00863 
<a name="l00864"></a>00864   <span class="keywordflow">return</span> cloned_vector;
<a name="l00865"></a>00865 }
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 
<a name="l00869"></a>00869 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00870"></a>00870 <span class="keyword">inline</span>
<a name="l00871"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afa5438432d03e9444b4a7744b6728b8c">00871</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EpetraVector.php#afa5438432d03e9444b4a7744b6728b8c">EpetraVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00872"></a>00872 <span class="keyword"></span>{
<a name="l00873"></a>00873   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>);
<a name="l00874"></a>00874 
<a name="l00875"></a>00875   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00878"></a>00878 
<a name="l00879"></a>00879   <span class="keywordflow">return</span> cloned_vector;
<a name="l00880"></a>00880 }
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00885"></a>00885 <span class="keyword">inline</span>
<a name="l00886"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a3eec013c41b5db8f1197ee82521cdd39">00886</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a3eec013c41b5db8f1197ee82521cdd39">EpetraVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00887"></a>00887 <span class="keyword"></span>{
<a name="l00888"></a>00888   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());  
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   <span class="keywordflow">return</span> _vec-&gt;GlobalLength();
<a name="l00891"></a>00891 }
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00896"></a>00896 <span class="keyword">inline</span>
<a name="l00897"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#a14f65bb6cb1f67f39045301356c94055">00897</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#a14f65bb6cb1f67f39045301356c94055">EpetraVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00898"></a>00898 <span class="keyword"></span>{
<a name="l00899"></a>00899   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00900"></a>00900   
<a name="l00901"></a>00901   <span class="keywordflow">return</span> _vec-&gt;MyLength();
<a name="l00902"></a>00902 }
<a name="l00903"></a>00903 
<a name="l00904"></a>00904 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00905"></a>00905 <span class="keyword">inline</span>
<a name="l00906"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afc316f16864520c99c55ec50fe5bf4b8">00906</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#afc316f16864520c99c55ec50fe5bf4b8">EpetraVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00907"></a>00907 <span class="keyword"></span>{
<a name="l00908"></a>00908   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00909"></a>00909   
<a name="l00910"></a>00910   <span class="keywordflow">return</span> _vec-&gt;Map().MinMyGID();
<a name="l00911"></a>00911 }
<a name="l00912"></a>00912 
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00916"></a>00916 <span class="keyword">inline</span>
<a name="l00917"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ae09258a2089640c728cf75b72619c52e">00917</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#ae09258a2089640c728cf75b72619c52e">EpetraVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l00918"></a>00918 <span class="keyword"></span>{
<a name="l00919"></a>00919   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00920"></a>00920   
<a name="l00921"></a>00921   <span class="keywordflow">return</span> _vec-&gt;Map().MaxMyGID()+1;
<a name="l00922"></a>00922 }
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00926"></a>00926 <span class="keyword">inline</span>
<a name="l00927"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#afbebf858c2afa4dcb070c79388d83890">00927</a> T <a class="code" href="classlibMesh_1_1EpetraVector.php#afbebf858c2afa4dcb070c79388d83890">EpetraVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00928"></a>00928 <span class="keyword"></span>{
<a name="l00929"></a>00929   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00930"></a>00930   libmesh_assert ( ((i &gt;= this-&gt;first_local_index()) &amp;&amp;
<a name="l00931"></a>00931                     (i &lt;  this-&gt;last_local_index())) );
<a name="l00932"></a>00932 
<a name="l00933"></a>00933   <span class="keywordflow">return</span> (*_vec)[i-this-&gt;first_local_index()];
<a name="l00934"></a>00934 }
<a name="l00935"></a>00935 
<a name="l00936"></a>00936 
<a name="l00937"></a>00937 
<a name="l00938"></a>00938 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00939"></a>00939 <span class="keyword">inline</span>
<a name="l00940"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#aef2ce5837a55788120c58f5d83b4122e">00940</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#aef2ce5837a55788120c58f5d83b4122e">EpetraVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00941"></a>00941 <span class="keyword"></span>{
<a name="l00942"></a>00942   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00943"></a>00943 
<a name="l00944"></a>00944   T value;
<a name="l00945"></a>00945 
<a name="l00946"></a>00946   _vec-&gt;MinValue(&amp;value);
<a name="l00947"></a>00947 
<a name="l00948"></a>00948   <span class="keywordflow">return</span> value;
<a name="l00949"></a>00949 }
<a name="l00950"></a>00950 
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00954"></a>00954 <span class="keyword">inline</span>
<a name="l00955"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#ab7b99b39cb6a4be6272ce01bcd33c85d">00955</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EpetraVector.php#ab7b99b39cb6a4be6272ce01bcd33c85d">EpetraVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l00956"></a>00956 <span class="keyword"></span>{
<a name="l00957"></a>00957   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00958"></a>00958 
<a name="l00959"></a>00959   T value;
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   _vec-&gt;MaxValue(&amp;value);
<a name="l00962"></a>00962 
<a name="l00963"></a>00963   <span class="keywordflow">return</span> value;
<a name="l00964"></a>00964 }
<a name="l00965"></a>00965 
<a name="l00966"></a>00966 
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00969"></a>00969 <span class="keyword">inline</span>
<a name="l00970"></a><a class="code" href="classlibMesh_1_1EpetraVector.php#aef71c93ac3630e17fb5170b93eae604e">00970</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EpetraVector.php#aef71c93ac3630e17fb5170b93eae604e">EpetraVector&lt;T&gt;::swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l00971"></a>00971 {
<a name="l00972"></a>00972   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;EpetraVector&lt;T&gt;&amp;&gt;(other);
<a name="l00973"></a>00973 
<a name="l00974"></a>00974   std::swap(_vec, v.<a class="code" href="classlibMesh_1_1EpetraVector.php#affda08d05cb864d520f4e520bc07a4e8">_vec</a>);
<a name="l00975"></a>00975   std::swap(_destroy_vec_on_exit, v.<a class="code" href="classlibMesh_1_1EpetraVector.php#ae4ac0d1825f55db8ad6343ea04eed9f0">_destroy_vec_on_exit</a>);
<a name="l00976"></a>00976 }
<a name="l00977"></a>00977 
<a name="l00978"></a>00978 } <span class="comment">// namespace libMesh</span>
<a name="l00979"></a>00979 
<a name="l00980"></a>00980 
<a name="l00981"></a>00981 <span class="preprocessor">#endif // #ifdef HAVE_EPETRA</span>
<a name="l00982"></a>00982 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_epetra_vector_h__</span>
<a name="l00983"></a>00983 <span class="preprocessor"></span>
<a name="l00984"></a>00984 
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 
<a name="l00989"></a>00989 
<a name="l00990"></a>00990 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
