<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_nox_nonlinear_solver.C</div>  </div>
</div>
<div class="contents">
<a href="trilinos__nox__nonlinear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_nox_nonlinear_solver.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_NOX</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__implicit__system_8h.php">nonlinear_implicit_system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__nox__nonlinear__solver_8h.php">trilinos_nox_nonlinear_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__epetra__vector_8h.php">trilinos_epetra_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ---------- Standard Includes ----------</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;Epetra_Vector.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;Epetra_Operator.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;Epetra_RowMatrix.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Required.H&quot;</span> <span class="comment">// base class</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Jacobian.H&quot;</span> <span class="comment">// base class</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Preconditioner.H&quot;</span> <span class="comment">// base class</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;NOX_Epetra_MatrixFree.H&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;NOX_Epetra_LinearSystem_AztecOO.H&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;NOX_Epetra_Group.H&quot;</span>   <span class="comment">// class definition</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;NOX_Epetra_Vector.H&quot;</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="keyword">namespace </span>libMesh
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php">00051</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Problem__Interface.php">Problem_Interface</a> : <span class="keyword">public</span> NOX::Epetra::Interface::Required,
<a name="l00052"></a>00052                           <span class="keyword">public</span> NOX::Epetra::Interface::Jacobian,
<a name="l00053"></a>00053                           <span class="keyword">public</span> NOX::Epetra::Interface::<a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner</a>
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1Problem__Interface.php#aefdc9dfae48451970546cefa6af97c36">Problem_Interface</a>(<a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php">NoxNonlinearSolver&lt;Number&gt;</a> * solver);
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1Problem__Interface.php#af44b6f250d2035625ea539926f8d4aae">~Problem_Interface</a>();
<a name="l00058"></a>00058   
<a name="l00060"></a>00060   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#abb78bdfc4c3bbda4046358d3ea12c049" title="Compute and return F.">computeF</a>(<span class="keyword">const</span> Epetra_Vector&amp; x, Epetra_Vector&amp; FVec,
<a name="l00061"></a>00061                 NOX::Epetra::Interface::Required::FillType fillType);
<a name="l00062"></a>00062         
<a name="l00064"></a>00064   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#a0266c8edfba6fbd97e57327d416be50d" title="Compute an explicit Jacobian.">computeJacobian</a>(<span class="keyword">const</span> Epetra_Vector&amp; x, Epetra_Operator&amp; Jac);
<a name="l00065"></a>00065   
<a name="l00067"></a>00067   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#ae52a0a4be0f8994bd24a02a2b628805c" title="Compute the Epetra_RowMatrix M, that will be used by the Aztec preconditioner instead of the Jacobian...">computePrecMatrix</a>(<span class="keyword">const</span> Epetra_Vector&amp; x, Epetra_RowMatrix&amp; M);
<a name="l00068"></a>00068   
<a name="l00070"></a>00070   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#a6680f8bcd28e3f9f6c5a278ebdca2b8b" title="Computes a user supplied preconditioner based on input vector x. Returns true if computation was succ...">computePreconditioner</a>(<span class="keyword">const</span> Epetra_Vector&amp; x, Epetra_Operator&amp; Prec,
<a name="l00071"></a>00071                              Teuchos::ParameterList* p);
<a name="l00072"></a>00072   
<a name="l00073"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#a7f2326ace64baa1d959f625d7b3d321f">00073</a>   <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php">NoxNonlinearSolver&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1Problem__Interface.php#a7f2326ace64baa1d959f625d7b3d321f">_solver</a>;
<a name="l00074"></a>00074 };
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00077"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#aefdc9dfae48451970546cefa6af97c36">00077</a> <a class="code" href="classlibMesh_1_1Problem__Interface.php#aefdc9dfae48451970546cefa6af97c36">Problem_Interface::Problem_Interface</a>(<a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php">NoxNonlinearSolver&lt;Number&gt;</a> * solver) :
<a name="l00078"></a>00078   _solver(solver)
<a name="l00079"></a>00079 { }
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#af44b6f250d2035625ea539926f8d4aae">00081</a> <a class="code" href="classlibMesh_1_1Problem__Interface.php#af44b6f250d2035625ea539926f8d4aae">Problem_Interface::~Problem_Interface</a>()
<a name="l00082"></a>00082 { }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#abb78bdfc4c3bbda4046358d3ea12c049">00084</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#abb78bdfc4c3bbda4046358d3ea12c049" title="Compute and return F.">Problem_Interface::computeF</a>(<span class="keyword">const</span> Epetra_Vector&amp; x, Epetra_Vector&amp; r,
<a name="l00085"></a>00085                        NOX::Epetra::Interface::Required::FillType)
<a name="l00086"></a>00086 <span class="comment">//bool Problem_Interface::computeF(const Epetra_Vector&amp; x, Epetra_Vector&amp; r,</span>
<a name="l00087"></a>00087 <span class="comment">//                       NOX::Epetra::Interface::Required::FillType fillType)</span>
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> &amp;sys = <a class="code" href="classlibMesh_1_1Problem__Interface.php#a7f2326ace64baa1d959f625d7b3d321f">_solver</a>-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#afd4b2819b5c5cc4384a879df8b34ceb3">system</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;Number&gt;</a> X_global(*const_cast&lt;Epetra_Vector *&gt;(&amp;x)), R(r);
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;Number&gt;</a>&amp; X_sys = *libmesh_cast_ptr&lt;EpetraVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// Use the systems update() to get a good local version of the parallel solution</span>
<a name="l00095"></a>00095   X_global.<a class="code" href="classlibMesh_1_1EpetraVector.php#aef71c93ac3630e17fb5170b93eae604e">swap</a>(X_sys);
<a name="l00096"></a>00096   sys.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00097"></a>00097   X_global.swap(X_sys);
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   R.<a class="code" href="classlibMesh_1_1EpetraVector.php#a2e380e98855fcca2df2dd84db288ba64">zero</a>();
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1Problem__Interface.php#a7f2326ace64baa1d959f625d7b3d321f">_solver</a>-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a9a7a991c403fba622accbf7ffc955537">residual</a> == NULL )
<a name="l00102"></a>00102     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1Problem__Interface.php#a7f2326ace64baa1d959f625d7b3d321f">_solver</a>-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a9a7a991c403fba622accbf7ffc955537">residual</a> (*sys.<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), R, sys);
<a name="l00104"></a>00104   R.<a class="code" href="classlibMesh_1_1EpetraVector.php#abf3f9f07e3a4fe3f0277f6da61afcff4">close</a>();
<a name="l00105"></a>00105   X_global.close();
<a name="l00106"></a>00106   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#a0266c8edfba6fbd97e57327d416be50d">00109</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#a0266c8edfba6fbd97e57327d416be50d" title="Compute an explicit Jacobian.">Problem_Interface::computeJacobian</a>(<span class="keyword">const</span> Epetra_Vector&amp;,
<a name="l00110"></a>00110                                         Epetra_Operator&amp;)
<a name="l00111"></a>00111 <span class="comment">//bool Problem_Interface::computeJacobian(const Epetra_Vector&amp; x,</span>
<a name="l00112"></a>00112 <span class="comment">//                                        Epetra_Operator&amp; Jac)</span>
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   <span class="keywordflow">throw</span> 1;
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">// return problem.evaluate(NOX::Epetra::Interface::Required::Jac, &amp;x, 0, 0);</span>
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#ae52a0a4be0f8994bd24a02a2b628805c">00119</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#ae52a0a4be0f8994bd24a02a2b628805c" title="Compute the Epetra_RowMatrix M, that will be used by the Aztec preconditioner instead of the Jacobian...">Problem_Interface::computePrecMatrix</a>(<span class="keyword">const</span> Epetra_Vector&amp;, Epetra_RowMatrix&amp;)
<a name="l00120"></a>00120 <span class="comment">//bool Problem_Interface::computePrecMatrix(const Epetra_Vector&amp; x, Epetra_RowMatrix&amp; M)</span>
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122 <span class="comment">//   cout &lt;&lt; &quot;ERROR: Problem_Interface::preconditionVector() - Use Explicit Jacobian only for this test problem!&quot; &lt;&lt; endl;</span>
<a name="l00123"></a>00123    <span class="keywordflow">throw</span> 1;
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1Problem__Interface.php#a6680f8bcd28e3f9f6c5a278ebdca2b8b">00126</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php#a6680f8bcd28e3f9f6c5a278ebdca2b8b" title="Computes a user supplied preconditioner based on input vector x. Returns true if computation was succ...">Problem_Interface::computePreconditioner</a>(<span class="keyword">const</span> Epetra_Vector&amp;,
<a name="l00127"></a>00127                                               Epetra_Operator&amp;,
<a name="l00128"></a>00128                                               Teuchos::ParameterList*)
<a name="l00129"></a>00129 <span class="comment">//bool Problem_Interface::computePreconditioner(const Epetra_Vector&amp; x,</span>
<a name="l00130"></a>00130 <span class="comment">//                                              Epetra_Operator&amp; Prec,</span>
<a name="l00131"></a>00131 <span class="comment">//                                              Teuchos::ParameterList* p)</span>
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133 <span class="comment">//   cout &lt;&lt; &quot;ERROR: Problem_Interface::preconditionVector() - Use Explicit Jacobian only for this test problem!&quot; &lt;&lt; endl;</span>
<a name="l00134"></a>00134    <span class="keywordflow">throw</span> 1;
<a name="l00135"></a>00135 }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00139"></a>00139 <span class="comment">// NoxNonlinearSolver&lt;&gt; methods</span>
<a name="l00140"></a>00140 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00141"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a78ed12c5532ddfd2959426cdbb0fef5c">00141</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a78ed12c5532ddfd2959426cdbb0fef5c">NoxNonlinearSolver&lt;T&gt;::clear</a> ()
<a name="l00142"></a>00142 {
<a name="l00143"></a>00143  <span class="comment">//  if (this-&gt;initialized())</span>
<a name="l00144"></a>00144 <span class="comment">//     {</span>
<a name="l00145"></a>00145 <span class="comment">//       this-&gt;_is_initialized = false;</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="comment">//       int ierr=0;</span>
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="comment">//       ierr = SNESDestroy(_snes);</span>
<a name="l00150"></a>00150 <span class="comment">//              CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00151"></a>00151 <span class="comment">//     }</span>
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00155"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac94b0f4b72fd86dd9af3127461f2f789">00155</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac94b0f4b72fd86dd9af3127461f2f789">NoxNonlinearSolver&lt;T&gt;::init</a> ()
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00158"></a>00158     _interface = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Problem__Interface.php">Problem_Interface</a>(<span class="keyword">this</span>);
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00162"></a>00162 std::pair&lt;unsigned int, Real&gt; 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac0d1d36dbaa5ddb130ea1486999d9320">00163</a> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac0d1d36dbaa5ddb130ea1486999d9320">NoxNonlinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  jac_in,  <span class="comment">// System Jacobian Matrix</span>
<a name="l00164"></a>00164                                 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; x_in,    <span class="comment">// Solution vector</span>
<a name="l00165"></a>00165                                 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; r_in,    <span class="comment">// Residual vector</span>
<a name="l00166"></a>00166                                 <span class="keyword">const</span> <span class="keywordtype">double</span>,              <span class="comment">// Stopping tolerance</span>
<a name="l00167"></a>00167                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) 
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a> * x_epetra = libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;x_in);
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a> * r_epetra = libmesh_cast_ptr&lt;EpetraVector&lt;T&gt;*&gt;(&amp;r_in);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   Teuchos::RCP&lt;Epetra_Vector&gt; x_t(x_epetra-&gt;<a class="code" href="classlibMesh_1_1EpetraVector.php#a03abaf449b6dd2980bf744f231a3dc0a">vec</a>());
<a name="l00175"></a>00175   Teuchos::RCP&lt;Epetra_Vector&gt; r_t(r_epetra-&gt;vec());
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   NOX::Epetra::Vector x(x_t, NOX::Epetra::Vector::CreateView);
<a name="l00178"></a>00178   NOX::Epetra::Vector r(r_t, NOX::Epetra::Vector::CreateView);
<a name="l00179"></a>00179   
<a name="l00180"></a>00180   Teuchos::RCP&lt;Teuchos::ParameterList&gt; nlParamsPtr =
<a name="l00181"></a>00181     Teuchos::rcp(<span class="keyword">new</span> Teuchos::ParameterList);
<a name="l00182"></a>00182   Teuchos::ParameterList&amp; nlParams = *(nlParamsPtr.get());
<a name="l00183"></a>00183   nlParams.set(<span class="stringliteral">&quot;Nonlinear Solver&quot;</span>, <span class="stringliteral">&quot;Line Search Based&quot;</span>);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">//print params        </span>
<a name="l00186"></a>00186   Teuchos::ParameterList&amp; printParams = nlParams.sublist(<span class="stringliteral">&quot;Printing&quot;</span>);
<a name="l00187"></a>00187   printParams.set(<span class="stringliteral">&quot;Output Precision&quot;</span>, 3);
<a name="l00188"></a>00188   printParams.set(<span class="stringliteral">&quot;Output Processor&quot;</span>, 0);
<a name="l00189"></a>00189   printParams.set(<span class="stringliteral">&quot;Output Information&quot;</span>,
<a name="l00190"></a>00190                   NOX::Utils::OuterIteration +
<a name="l00191"></a>00191                   NOX::Utils::OuterIterationStatusTest +
<a name="l00192"></a>00192                   NOX::Utils::InnerIteration +
<a name="l00193"></a>00193                   NOX::Utils::LinearSolverDetails +
<a name="l00194"></a>00194                   NOX::Utils::Parameters +
<a name="l00195"></a>00195                   NOX::Utils::Details +
<a name="l00196"></a>00196                   NOX::Utils::Warning);
<a name="l00197"></a>00197   
<a name="l00198"></a>00198   <span class="comment">//create linear system</span>
<a name="l00199"></a>00199   Teuchos::RCP&lt;NOX::Epetra::Interface::Required&gt; iReq(_interface);      
<a name="l00200"></a>00200   Teuchos::RCP&lt;NOX::Epetra::MatrixFree&gt; MF = 
<a name="l00201"></a>00201     Teuchos::rcp(<span class="keyword">new</span> NOX::Epetra::MatrixFree(printParams,
<a name="l00202"></a>00202                                              iReq,
<a name="l00203"></a>00203                                              x));
<a name="l00204"></a>00204         
<a name="l00205"></a>00205   Teuchos::ParameterList&amp; dirParams = nlParams.sublist(<span class="stringliteral">&quot;Direction&quot;</span>);
<a name="l00206"></a>00206   dirParams.set(<span class="stringliteral">&quot;Method&quot;</span>, <span class="stringliteral">&quot;Newton&quot;</span>);
<a name="l00207"></a>00207   Teuchos::ParameterList&amp; newtonParams = dirParams.sublist(<span class="stringliteral">&quot;Newton&quot;</span>);
<a name="l00208"></a>00208   newtonParams.set(<span class="stringliteral">&quot;Forcing Term Method&quot;</span>, <span class="stringliteral">&quot;Constant&quot;</span>);
<a name="l00209"></a>00209   
<a name="l00210"></a>00210   Teuchos::ParameterList&amp; lsParams = newtonParams.sublist(<span class="stringliteral">&quot;Linear Solver&quot;</span>);
<a name="l00211"></a>00211   lsParams.set(<span class="stringliteral">&quot;Aztec Solver&quot;</span>, <span class="stringliteral">&quot;GMRES&quot;</span>); 
<a name="l00212"></a>00212   lsParams.set(<span class="stringliteral">&quot;Max Iterations&quot;</span>, static_cast&lt;int&gt;(this-&gt;max_linear_iterations));
<a name="l00213"></a>00213   lsParams.set(<span class="stringliteral">&quot;Tolerance&quot;</span>, this-&gt;initial_linear_tolerance);  lsParams.set(<span class="stringliteral">&quot;Output Frequency&quot;</span>, 1);       
<a name="l00214"></a>00214 <span class="comment">//  lsParams.set(&quot;Preconditioner&quot;, &quot;AztecOO&quot;);</span>
<a name="l00215"></a>00215   
<a name="l00216"></a>00216   Teuchos::RCP&lt;NOX::Epetra::Interface::Jacobian&gt; iJac = MF;
<a name="l00217"></a>00217   Teuchos::RCP&lt;NOX::Epetra::LinearSystemAztecOO&gt; linSys =
<a name="l00218"></a>00218     Teuchos::rcp(<span class="keyword">new</span> NOX::Epetra::LinearSystemAztecOO(printParams, lsParams,
<a name="l00219"></a>00219                                                       iReq, iJac, MF,
<a name="l00220"></a>00220                                                       x));
<a name="l00221"></a>00221   <span class="comment">//create group</span>
<a name="l00222"></a>00222   Teuchos::RCP&lt;NOX::Epetra::Group&gt; grpPtr =
<a name="l00223"></a>00223     Teuchos::rcp(<span class="keyword">new</span> NOX::Epetra::Group(printParams,
<a name="l00224"></a>00224                                         iReq,
<a name="l00225"></a>00225                                         x,
<a name="l00226"></a>00226                                         linSys)); 
<a name="l00227"></a>00227   NOX::Epetra::Group&amp; grp = *(grpPtr.get());
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   Teuchos::RCP&lt;NOX::StatusTest::NormF&gt; absresid =
<a name="l00230"></a>00230     Teuchos::rcp(<span class="keyword">new</span> NOX::StatusTest::NormF(this-&gt;absolute_residual_tolerance, NOX::StatusTest::NormF::Unscaled));
<a name="l00231"></a>00231   Teuchos::RCP&lt;NOX::StatusTest::NormF&gt; relresid =
<a name="l00232"></a>00232     Teuchos::rcp(<span class="keyword">new</span> NOX::StatusTest::NormF(grp, this-&gt;relative_residual_tolerance));
<a name="l00233"></a>00233   Teuchos::RCP&lt;NOX::StatusTest::MaxIters&gt; maxiters =
<a name="l00234"></a>00234     Teuchos::rcp(<span class="keyword">new</span> NOX::StatusTest::MaxIters(this-&gt;max_nonlinear_iterations));
<a name="l00235"></a>00235   Teuchos::RCP&lt;NOX::StatusTest::FiniteValue&gt; finiteval =
<a name="l00236"></a>00236     Teuchos::rcp(<span class="keyword">new</span> NOX::StatusTest::FiniteValue());
<a name="l00237"></a>00237   Teuchos::RCP&lt;NOX::StatusTest::NormUpdate&gt; normupdate =
<a name="l00238"></a>00238     Teuchos::rcp(<span class="keyword">new</span> NOX::StatusTest::NormUpdate(this-&gt;absolute_step_tolerance));
<a name="l00239"></a>00239   Teuchos::RCP&lt;NOX::StatusTest::Combo&gt; combo =
<a name="l00240"></a>00240     Teuchos::rcp(<span class="keyword">new</span> NOX::StatusTest::Combo(NOX::StatusTest::Combo::OR));
<a name="l00241"></a>00241   combo-&gt;addStatusTest(absresid);
<a name="l00242"></a>00242   combo-&gt;addStatusTest(relresid);
<a name="l00243"></a>00243   combo-&gt;addStatusTest(maxiters);
<a name="l00244"></a>00244   combo-&gt;addStatusTest(finiteval);
<a name="l00245"></a>00245   combo-&gt;addStatusTest(normupdate);
<a name="l00246"></a>00246   
<a name="l00247"></a>00247   Teuchos::RCP&lt;NOX::Solver::Generic&gt; solver =
<a name="l00248"></a>00248     NOX::Solver::buildSolver(grpPtr, combo, nlParamsPtr);
<a name="l00249"></a>00249   NOX::StatusTest::StatusType <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> = NOX::StatusTest::Unconverged;
<a name="l00250"></a>00250   status = solver-&gt;solve();
<a name="l00251"></a>00251   
<a name="l00252"></a>00252   <span class="keyword">const</span> NOX::Epetra::Group&amp; finalGroup =
<a name="l00253"></a>00253     <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span>NOX::Epetra::Group&amp;<span class="keyword">&gt;</span>(solver-&gt;getSolutionGroup());
<a name="l00254"></a>00254   <span class="keyword">const</span> NOX::Abstract::Vector&amp; finalSolution = finalGroup.getX();
<a name="l00255"></a>00255 <span class="comment">//  const Epetra_Vector&amp; finalSolution =</span>
<a name="l00256"></a>00256 <span class="comment">//    (dynamic_cast&lt;const NOX::Epetra::Vector&amp;&gt;(finalGroup.getX())).getEpetraVector();</span>
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   x = finalSolution;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordflow">return</span> std::make_pair(1, 0.);
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00267"></a>00267 <span class="comment">// Explicit instantiations</span>
<a name="l00268"></a>00268 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php">NoxNonlinearSolver&lt;Number&gt;</a>;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 } <span class="comment">// namespace libMesh</span>
<a name="l00271"></a>00271  
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_NOX</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
