<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">trilinos_nox_nonlinear_solver.h</div>  </div>
</div>
<div class="contents">
<a href="trilinos__nox__nonlinear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: trilinos_nox_nonlinear_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __trilinos_nox_nonlinear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __trilinos_nox_nonlinear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_NOX</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__solver_8h.php">nonlinear_solver.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">//trilinos includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;Epetra_Vector.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;Epetra_Operator.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;Epetra_RowMatrix.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Required.H&quot;</span> <span class="comment">// base class</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Jacobian.H&quot;</span> <span class="comment">// base class</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;NOX_Epetra_Interface_Preconditioner.H&quot;</span> <span class="comment">// base class  </span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;NOX.H&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Forward declarations</span>
<a name="l00045"></a>00045 <span class="keyword">class </span>Problem_Interface;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php">NoxNonlinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php">NonlinearSolver</a>&lt;T&gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00063"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#af1aacccf7eb69ed33aa1f47a943067d6">00063</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#af1aacccf7eb69ed33aa1f47a943067d6">sys_type</a>;
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac2cf4acf71c1be25c1c74a6dc0261402">NoxNonlinearSolver</a> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classlibMesh_1_1NonlinearSolver.php#afd4b2819b5c5cc4384a879df8b34ceb3">system</a>);
<a name="l00069"></a>00069     
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#aebec8b722f2f1a9d77d2d682823cd13f">~NoxNonlinearSolver</a> ();
<a name="l00074"></a>00074   
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a78ed12c5532ddfd2959426cdbb0fef5c">clear</a> ();
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac94b0f4b72fd86dd9af3127461f2f789">init</a> ();
<a name="l00084"></a>00084   
<a name="l00089"></a>00089   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac0d1d36dbaa5ddb130ea1486999d9320">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,    <span class="comment">// System Jacobian Matrix</span>
<a name="l00090"></a>00090                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,   <span class="comment">// Solution vector</span>
<a name="l00091"></a>00091                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,   <span class="comment">// Residual vector</span>
<a name="l00092"></a>00092                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,        <span class="comment">// Stopping tolerance</span>
<a name="l00093"></a>00093                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>); <span class="comment">// N. Iterations</span>
<a name="l00094"></a>00094 <span class="keyword">private</span>:
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a4f9cf1ff98265db09f00504f37b0ade6">00099</a>   NOX::Solver::Generic * <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a4f9cf1ff98265db09f00504f37b0ade6">_solver</a>;
<a name="l00100"></a>00100   
<a name="l00104"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a63cebda016929877d13d280ad2b054fd">00104</a>   <a class="code" href="classlibMesh_1_1Problem__Interface.php">Problem_Interface</a> * <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#a63cebda016929877d13d280ad2b054fd">_interface</a>;
<a name="l00105"></a>00105   
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00111"></a>00111 <span class="keyword">inline</span>
<a name="l00112"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac2cf4acf71c1be25c1c74a6dc0261402">00112</a> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#ac2cf4acf71c1be25c1c74a6dc0261402">NoxNonlinearSolver&lt;T&gt;::NoxNonlinearSolver</a> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; system) :
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1NonlinearSolver.php">NonlinearSolver</a>&lt;T&gt;(system)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00120"></a>00120 <span class="keyword">inline</span>
<a name="l00121"></a><a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#aebec8b722f2f1a9d77d2d682823cd13f">00121</a> <a class="code" href="classlibMesh_1_1NoxNonlinearSolver.php#aebec8b722f2f1a9d77d2d682823cd13f">NoxNonlinearSolver&lt;T&gt;::~NoxNonlinearSolver</a> ()
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   this-&gt;clear ();
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 } <span class="comment">// namespace libMesh</span>
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_NOX</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __trilinos_nox_nonlinear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
