<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">twostep_time_solver.C</div>  </div>
</div>
<div class="contents">
<a href="twostep__time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: twostep_time_solver.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="twostep__time__solver_8h.php">twostep_time_solver.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="euler__solver_8h.php">euler_solver.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a><a class="code" href="classlibMesh_1_1TwostepTimeSolver.php#ab1888616e3161ab60e6fa5cd70616ace">00031</a> <a class="code" href="classlibMesh_1_1TwostepTimeSolver.php#ab1888616e3161ab60e6fa5cd70616ace">TwostepTimeSolver::TwostepTimeSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00032"></a>00032   : <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php">AdaptiveTimeSolver</a>(s)
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="comment">// We start with a reasonable time solver: implicit Euler</span>
<a name="l00036"></a>00036   <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1EulerSolver.php">EulerSolver</a>(s));
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1TwostepTimeSolver.php#a36453cea9c438810d00052aa079182b8">00041</a> <a class="code" href="classlibMesh_1_1TwostepTimeSolver.php#a36453cea9c438810d00052aa079182b8">TwostepTimeSolver::~TwostepTimeSolver</a> ()
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1TwostepTimeSolver.php#a216b8b2c33f3eebb218c050d8761a603">00047</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TwostepTimeSolver.php#a216b8b2c33f3eebb218c050d8761a603">TwostepTimeSolver::solve</a>()
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   libmesh_assert(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// The core_time_solver will handle any first_solve actions</span>
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">first_solve</a> = <span class="keyword">false</span>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// We may have to repeat timesteps entirely if our error is bad</span>
<a name="l00055"></a>00055   <span class="comment">// enough</span>
<a name="l00056"></a>00056   <span class="keywordtype">bool</span> max_tolerance_met = <span class="keyword">false</span>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Calculating error values each time</span>
<a name="l00059"></a>00059   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> single_norm(0.), double_norm(0.), error_norm(0.),
<a name="l00060"></a>00060        relative_error(0.);
<a name="l00061"></a>00061  
<a name="l00062"></a>00062   <span class="keywordflow">while</span> (!max_tolerance_met)
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064       <span class="comment">// If we&#39;ve been asked to reduce deltat if necessary, make sure</span>
<a name="l00065"></a>00065       <span class="comment">// the core timesolver does so</span>
<a name="l00066"></a>00066       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;reduce_deltat_on_diffsolver_failure =
<a name="l00067"></a>00067         this-&gt;<a class="code" href="classlibMesh_1_1TimeSolver.php#a9b77957719eae28de2e753d9a99d825e">reduce_deltat_on_diffsolver_failure</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;\n === Computing adaptive timestep === &quot;</span> 
<a name="l00072"></a>00072                         &lt;&lt; std::endl;
<a name="l00073"></a>00073         }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075       <span class="comment">// Use the double-length timestep first (so the</span>
<a name="l00076"></a>00076       <span class="comment">// old_nonlinear_solution won&#39;t have to change)</span>
<a name="l00077"></a>00077       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;solve();
<a name="l00078"></a>00078 
<a name="l00079"></a>00079       <span class="comment">// Save a copy of the double-length nonlinear solution</span>
<a name="l00080"></a>00080       <span class="comment">// and the old nonlinear solution</span>
<a name="l00081"></a>00081       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; double_solution =
<a name="l00082"></a>00082         <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;clone();
<a name="l00083"></a>00083       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; old_solution =
<a name="l00084"></a>00084         <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>).<a class="code" href="classlibMesh_1_1NumericVector.php#a5c4b5cbb3877d0ad466895286fc8bb55">clone</a>();
<a name="l00085"></a>00085 
<a name="l00086"></a>00086       double_norm = <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a24cf02c068643d8cd3e4c25d96895a8a">calculate_norm</a>(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>, *double_solution);
<a name="l00087"></a>00087       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00088"></a>00088         {
<a name="l00089"></a>00089           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Double norm = &quot;</span> &lt;&lt; double_norm &lt;&lt; std::endl;
<a name="l00090"></a>00090         }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092       <span class="comment">// Then reset the initial guess for our single-length calcs</span>
<a name="l00093"></a>00093       *(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>) = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095       <span class="comment">// Call two single-length timesteps</span>
<a name="l00096"></a>00096       <span class="comment">// Be sure that the core_time_solver does not change the</span>
<a name="l00097"></a>00097       <span class="comment">// timestep here.  (This is unlikely because it just succeeded</span>
<a name="l00098"></a>00098       <span class="comment">// with a timestep twice as large!)</span>
<a name="l00099"></a>00099       <span class="comment">// FIXME: even if diffsolver failure is unlikely, we ought to</span>
<a name="l00100"></a>00100       <span class="comment">// do *something* if it happens</span>
<a name="l00101"></a>00101       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;reduce_deltat_on_diffsolver_failure = 0;
<a name="l00102"></a>00102   
<a name="l00103"></a>00103       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> old_time = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">time</a>;
<a name="l00104"></a>00104       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> old_deltat = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00105"></a>00105       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> *= 0.5;
<a name="l00106"></a>00106       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;solve();
<a name="l00107"></a>00107       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;advance_timestep();
<a name="l00108"></a>00108       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;solve();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110       single_norm = <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a24cf02c068643d8cd3e4c25d96895a8a">calculate_norm</a>(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>, *<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00111"></a>00111       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Single norm = &quot;</span> &lt;&lt; single_norm &lt;&lt; std::endl;
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116       <span class="comment">// Reset the core_time_solver&#39;s reduce_deltat... value.</span>
<a name="l00117"></a>00117       <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;reduce_deltat_on_diffsolver_failure =
<a name="l00118"></a>00118         this-&gt;<a class="code" href="classlibMesh_1_1TimeSolver.php#a9b77957719eae28de2e753d9a99d825e">reduce_deltat_on_diffsolver_failure</a>;
<a name="l00119"></a>00119   
<a name="l00120"></a>00120       <span class="comment">// But then back off just in case our advance_timestep() isn&#39;t</span>
<a name="l00121"></a>00121       <span class="comment">// called.</span>
<a name="l00122"></a>00122       <span class="comment">// FIXME: this probably doesn&#39;t work with multistep methods</span>
<a name="l00123"></a>00123       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>) = *old_solution;
<a name="l00124"></a>00124       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">time</a> = old_time;
<a name="l00125"></a>00125       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> = old_deltat;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127       <span class="comment">// Find the relative error</span>
<a name="l00128"></a>00128       *double_solution -= *(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00129"></a>00129       error_norm  = <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a24cf02c068643d8cd3e4c25d96895a8a">calculate_norm</a>(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>, *double_solution);
<a name="l00130"></a>00130       relative_error = error_norm / <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> /
<a name="l00131"></a>00131         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133       <span class="comment">// If the relative error makes no sense, we&#39;re done</span>
<a name="l00134"></a>00134       <span class="keywordflow">if</span> (!double_norm &amp;&amp; !single_norm)
<a name="l00135"></a>00135         <span class="keywordflow">return</span>;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00138"></a>00138         {
<a name="l00139"></a>00139           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error norm = &quot;</span> &lt;&lt; error_norm &lt;&lt; std::endl;
<a name="l00140"></a>00140           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Local relative error = &quot;</span>
<a name="l00141"></a>00141                         &lt;&lt; (error_norm /
<a name="l00142"></a>00142                             <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm))
<a name="l00143"></a>00143                         &lt;&lt; std::endl;
<a name="l00144"></a>00144           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Global relative error = &quot;</span>
<a name="l00145"></a>00145                         &lt;&lt; (error_norm / <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> / 
<a name="l00146"></a>00146                             <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm)) 
<a name="l00147"></a>00147                         &lt;&lt; std::endl;
<a name="l00148"></a>00148           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;old delta t = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> &lt;&lt; std::endl;
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151       <span class="comment">// If we haven&#39;t met our upper error tolerance, we&#39;ll have to</span>
<a name="l00152"></a>00152       <span class="comment">// repeat this timestep entirely</span>
<a name="l00153"></a>00153       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a4d15b5d216cbb6657055125da543c388">upper_tolerance</a> &amp;&amp; relative_error &gt; this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a4d15b5d216cbb6657055125da543c388">upper_tolerance</a>)
<a name="l00154"></a>00154         {
<a name="l00155"></a>00155           <span class="comment">// Reset the initial guess for our next try</span>
<a name="l00156"></a>00156           *(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>) =
<a name="l00157"></a>00157             <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159           <span class="comment">// Chop delta t in half</span>
<a name="l00160"></a>00160           <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> /= 2.;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00163"></a>00163             {
<a name="l00164"></a>00164               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Failed to meet upper error tolerance&quot;</span> 
<a name="l00165"></a>00165                             &lt;&lt; std::endl;
<a name="l00166"></a>00166               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Retrying with delta t = &quot;</span>
<a name="l00167"></a>00167                             &lt;&lt; <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> &lt;&lt; std::endl;
<a name="l00168"></a>00168             }
<a name="l00169"></a>00169         }
<a name="l00170"></a>00170       <span class="keywordflow">else</span>
<a name="l00171"></a>00171         max_tolerance_met = <span class="keyword">true</span>;
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   
<a name="l00175"></a>00175   <span class="comment">// Otherwise, compare the relative error to the tolerance</span>
<a name="l00176"></a>00176   <span class="comment">// and adjust deltat</span>
<a name="l00177"></a>00177   <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aafc55e61a042582de96032b721d46b55">last_deltat</a> = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> global_shrink_or_growth_factor =
<a name="l00180"></a>00180     <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca9e4ce98150b7452299c990c6d13741">target_tolerance</a> / relative_error,
<a name="l00181"></a>00181              static_cast&lt;Real&gt;(1. / <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;error_order()));
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> local_shrink_or_growth_factor =
<a name="l00184"></a>00184     <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca9e4ce98150b7452299c990c6d13741">target_tolerance</a> /
<a name="l00185"></a>00185              (error_norm/<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(double_norm, single_norm)),
<a name="l00186"></a>00186              static_cast&lt;Real&gt;(1. / (<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;error_order()+1.)));
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00189"></a>00189     {
<a name="l00190"></a>00190       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;The global growth/shrink factor is: &quot;</span>
<a name="l00191"></a>00191                     &lt;&lt; global_shrink_or_growth_factor &lt;&lt; std::endl;
<a name="l00192"></a>00192       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;The local growth/shrink factor is: &quot;</span>
<a name="l00193"></a>00193                     &lt;&lt; local_shrink_or_growth_factor &lt;&lt; std::endl;
<a name="l00194"></a>00194     }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">// The local s.o.g. factor is based on the expected **local**</span>
<a name="l00197"></a>00197   <span class="comment">// truncation error for the timestepping method, the global</span>
<a name="l00198"></a>00198   <span class="comment">// s.o.g. factor is based on the method&#39;s **global** truncation</span>
<a name="l00199"></a>00199   <span class="comment">// error.  You can shrink/grow the timestep to attempt to satisfy</span>
<a name="l00200"></a>00200   <span class="comment">// either a global or local time-discretization error tolerance.</span>
<a name="l00201"></a>00201  
<a name="l00202"></a>00202   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> shrink_or_growth_factor =
<a name="l00203"></a>00203     this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#accf5c408d7a99cb7d27a819404b85ea3">global_tolerance</a> ? global_shrink_or_growth_factor :
<a name="l00204"></a>00204                              local_shrink_or_growth_factor;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ada68f2f70960a70215aa8978105d9df2">max_growth</a> &amp;&amp; this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ada68f2f70960a70215aa8978105d9df2">max_growth</a> &lt; shrink_or_growth_factor)
<a name="l00207"></a>00207     {
<a name="l00208"></a>00208       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a> &amp;&amp; this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#accf5c408d7a99cb7d27a819404b85ea3">global_tolerance</a>)
<a name="l00209"></a>00209         {
<a name="l00210"></a>00210           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;delta t is constrained by max_growth&quot;</span> &lt;&lt; std::endl;
<a name="l00211"></a>00211         }
<a name="l00212"></a>00212         shrink_or_growth_factor = this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ada68f2f70960a70215aa8978105d9df2">max_growth</a>;
<a name="l00213"></a>00213     }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> *= shrink_or_growth_factor;
<a name="l00216"></a>00216   
<a name="l00217"></a>00217   <span class="comment">// Restrict deltat to max-allowable value if necessary</span>
<a name="l00218"></a>00218   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a93b378583a8e5d6da9d1408a49b8a0a9">max_deltat</a> != 0.0) &amp;&amp; (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> &gt; this-&gt;max_deltat))
<a name="l00219"></a>00219     {
<a name="l00220"></a>00220       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00221"></a>00221         {
<a name="l00222"></a>00222           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;delta t is constrained by maximum-allowable delta t.&quot;</span>
<a name="l00223"></a>00223                         &lt;&lt; std::endl;
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> = this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a93b378583a8e5d6da9d1408a49b8a0a9">max_deltat</a>;
<a name="l00226"></a>00226     }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   <span class="comment">// Restrict deltat to min-allowable value if necessary</span>
<a name="l00229"></a>00229   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3ef4f9c102adce5c8ef9cacab1b8cd7c">min_deltat</a> != 0.0) &amp;&amp; (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> &lt; this-&gt;min_deltat))
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00232"></a>00232         {
<a name="l00233"></a>00233           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;delta t is constrained by minimum-allowable delta t.&quot;</span>
<a name="l00234"></a>00234                         &lt;&lt; std::endl;
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> = this-&gt;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3ef4f9c102adce5c8ef9cacab1b8cd7c">min_deltat</a>;
<a name="l00237"></a>00237     }
<a name="l00238"></a>00238   
<a name="l00239"></a>00239   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00240"></a>00240     {
<a name="l00241"></a>00241       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;new delta t = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> &lt;&lt; std::endl;
<a name="l00242"></a>00242     }
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
