<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">type_tensor.h</div>  </div>
</div>
<div class="contents">
<a href="type__tensor_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: type_tensor.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __type_tensor_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __type_tensor_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="type__vector_8h.php">type_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1TypeTensor.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00051"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">00051</a> <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">protected</span>:
<a name="l00054"></a>00054 
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>  (<span class="keyword">const</span> T xx=0.,
<a name="l00062"></a>00062                <span class="keyword">const</span> T xy=0.,
<a name="l00063"></a>00063                <span class="keyword">const</span> T xz=0.,
<a name="l00064"></a>00064                <span class="keyword">const</span> T yx=0.,
<a name="l00065"></a>00065                <span class="keyword">const</span> T yy=0.,
<a name="l00066"></a>00066                <span class="keyword">const</span> T yz=0.,
<a name="l00067"></a>00067                <span class="keyword">const</span> T zx=0.,
<a name="l00068"></a>00068                <span class="keyword">const</span> T zy=0.,
<a name="l00069"></a>00069                <span class="keyword">const</span> T zz=0.);
<a name="l00070"></a>00070 
<a name="l00076"></a>00076   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx);
<a name="l00078"></a>00078   
<a name="l00079"></a>00079   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vz);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="keyword">public</span>:
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a>&amp; p);
<a name="l00092"></a>00092   
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1TypeTensor.php#ad51860da4b4ba8216ade9dae62e30729">~TypeTensor</a>();
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#ab817de7fdef116e2691a76bb9c4fc496">assign</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;);
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   T <a class="code" href="classlibMesh_1_1TypeTensor.php#ada438acd743d6b532befa8972cf21f6e">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00113"></a>00113   T &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#ada438acd743d6b532befa8972cf21f6e">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00114"></a>00114 
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ad03f2d90553d4c76a2cbedb09786223b">row</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r);
<a name="l00119"></a>00119 
<a name="l00123"></a>00123   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00124"></a>00124   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1TypeTensor.php#aa58391827b4c76b72a71ac6242ff48a6">operator + </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00130"></a>00130   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00131"></a>00131   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#a1708da49ef220e1354fd0010c6725b23">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;);
<a name="l00132"></a>00132   
<a name="l00136"></a>00136   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#aa99a2a5e0ee616fe4a65a6b3842f2a69">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;); 
<a name="l00138"></a>00138   
<a name="l00143"></a>00143   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00150"></a>00150   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1TypeTensor.php#a86f5c24711d3ce5e5a80f048a0668592">operator - </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00156"></a>00156   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00157"></a>00157   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#ad84fbe5ae6e64dad75ce682df01d5b62">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;);
<a name="l00158"></a>00158 
<a name="l00162"></a>00162   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00163"></a>00163   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#af4941912d81ad84d7de56706b1523d4f">subtract</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;); 
<a name="l00164"></a>00164   
<a name="l00169"></a>00169   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#abfe91509bae68904b75b8cedcdff7209">subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;, <span class="keyword">const</span> T); 
<a name="l00171"></a>00171   
<a name="l00175"></a>00175   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a86f5c24711d3ce5e5a80f048a0668592">operator - </a>() <span class="keyword">const</span>;
<a name="l00176"></a>00176   
<a name="l00180"></a>00180   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00181"></a>00181   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00182"></a>00182     <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00183"></a>00183     <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">operator * </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00185"></a>00185   
<a name="l00189"></a>00189   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00190"></a>00190   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#ac15f773ad4cf8f1d0c6aae4041e2fd64">operator *= </a>(<span class="keyword">const</span> Scalar);
<a name="l00191"></a>00191   
<a name="l00195"></a>00195   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00196"></a>00196   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00197"></a>00197     <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00198"></a>00198     <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00199"></a>00199   <a class="code" href="classlibMesh_1_1TypeTensor.php#a3523f8a212b31c5962f4223be8cbdd4b">operator / </a>(<span class="keyword">const</span> Scalar) <span class="keyword">const</span>;
<a name="l00200"></a>00200 
<a name="l00204"></a>00204   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#a3c2aa5c20e04196eddc725e55b406554">operator /= </a>(<span class="keyword">const</span> T);
<a name="l00205"></a>00205 
<a name="l00210"></a>00210   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00211"></a>00211   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">operator * </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00217"></a>00217   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00218"></a>00218   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T,T2&gt;::supertype</a>
<a name="l00219"></a>00219   <a class="code" href="classlibMesh_1_1TypeTensor.php#a91ced4ae7e8d72aee0d21193e2fa7dbc">contract</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00225"></a>00225   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00226"></a>00226   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T,T2&gt;::supertype</a>&gt;
<a name="l00227"></a>00227   <a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">operator * </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;) <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00232"></a>00232   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ab53b025a4e815cd4d2493e929f82aa70">transpose</a>() <span class="keyword">const</span>;
<a name="l00233"></a>00233 
<a name="l00238"></a>00238   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a6e514d706640dd89649d59f0a0a2e923">size</a>() <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00244"></a>00244   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>() <span class="keyword">const</span>;
<a name="l00245"></a>00245 
<a name="l00251"></a>00251   T <a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">det</a>() <span class="keyword">const</span>;
<a name="l00252"></a>00252 
<a name="l00256"></a>00256   T <a class="code" href="classlibMesh_1_1TypeTensor.php#a9d7a4e6e7d0df17a315aa215806d115d">tr</a>() <span class="keyword">const</span>;
<a name="l00257"></a>00257 
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#ab8531257e3cd525ea57a62b14c23a2d0">zero</a>();
<a name="l00262"></a>00262 
<a name="l00266"></a>00266   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#a367ed45df8b826d2e7b3c80e11f0586f">operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00267"></a>00267   
<a name="l00272"></a>00272   <span class="keywordtype">bool</span> operator &lt; (const TypeTensor&lt;T&gt;&amp; rhs) <span class="keyword">const</span>;
<a name="l00273"></a>00273   
<a name="l00278"></a>00278   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#a776b8949879eb8a4581376b45e655238">operator &gt; </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00279"></a>00279   
<a name="l00283"></a>00283   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#af9cd72d4c5032325266d14f4d9d4bf73">print</a>(std::ostream&amp; os = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00284"></a>00284 
<a name="l00289"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#aeddb9e754cdb6049b74cd4da88bf2476">00289</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const TypeTensor&lt;T&gt;&amp; t)
<a name="l00290"></a>00290   {
<a name="l00291"></a>00291     t.print(os);
<a name="l00292"></a>00292     <span class="keywordflow">return</span> os;
<a name="l00293"></a>00293   }
<a name="l00294"></a>00294   
<a name="l00299"></a>00299   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#a6c3d5b73b80452e9dcd4d983070b33cf">write_unformatted</a> (std::ostream &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>, <span class="keyword">const</span> <span class="keywordtype">bool</span> newline = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00300"></a>00300     
<a name="l00301"></a>00301   <span class="comment">// protected:</span>
<a name="l00302"></a>00302 
<a name="l00306"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">00306</a>   T <a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[LIBMESH_DIM*LIBMESH_DIM];
<a name="l00307"></a>00307 };
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 <span class="comment">//------------------------------------------------------</span>
<a name="l00312"></a>00312 <span class="comment">// Inline functions</span>
<a name="l00313"></a>00313 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00314"></a>00314 <span class="keyword">inline</span>
<a name="l00315"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#af6d13eae12cb8455e3026dbf20380064">00315</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a> (<span class="keyword">const</span> T xx,
<a name="l00316"></a>00316                            <span class="keyword">const</span> T xy,
<a name="l00317"></a>00317                            <span class="keyword">const</span> T xz,
<a name="l00318"></a>00318                            <span class="keyword">const</span> T yx,
<a name="l00319"></a>00319                            <span class="keyword">const</span> T yy,
<a name="l00320"></a>00320                            <span class="keyword">const</span> T yz,
<a name="l00321"></a>00321                            <span class="keyword">const</span> T zx,
<a name="l00322"></a>00322                            <span class="keyword">const</span> T zy,
<a name="l00323"></a>00323                            <span class="keyword">const</span> T zz)
<a name="l00324"></a>00324 {
<a name="l00325"></a>00325   _coords[0] = xx;
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="keywordflow">if</span> (LIBMESH_DIM == 2)
<a name="l00328"></a>00328     {
<a name="l00329"></a>00329       _coords[1] = xy;
<a name="l00330"></a>00330       _coords[2] = yx;
<a name="l00331"></a>00331       _coords[3] = yy;
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="keywordflow">if</span> (LIBMESH_DIM == 3)
<a name="l00335"></a>00335     {
<a name="l00336"></a>00336       _coords[1] = xy;
<a name="l00337"></a>00337       _coords[2] = xz;
<a name="l00338"></a>00338       _coords[3] = yx;
<a name="l00339"></a>00339       _coords[4] = yy;
<a name="l00340"></a>00340       _coords[5] = yz;
<a name="l00341"></a>00341       _coords[6] = zx;
<a name="l00342"></a>00342       _coords[7] = zy;
<a name="l00343"></a>00343       _coords[8] = zz;
<a name="l00344"></a>00344     }
<a name="l00345"></a>00345 }
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00350"></a>00350 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00351"></a>00351 <span class="keyword">inline</span>
<a name="l00352"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a8c47dae9f179b8388dae5265ff95d6d5">00352</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor &lt;T2&gt;</a> &amp;p)
<a name="l00353"></a>00353 {
<a name="l00354"></a>00354   <span class="comment">// copy the nodes from vector p to me</span>
<a name="l00355"></a>00355   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00356"></a>00356     _coords[i] = p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00361"></a>00361 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00362"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a459b4e35b7388f00de637019268f27e1">00362</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx)
<a name="l00363"></a>00363 {
<a name="l00364"></a>00364   libmesh_assert(LIBMESH_DIM == 1);
<a name="l00365"></a>00365   _coords[0] = vx(0);
<a name="l00366"></a>00366 }
<a name="l00367"></a>00367   
<a name="l00368"></a>00368 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00369"></a>00369 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00370"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a6e362b13a25b8d4b592ba3a3d4e118fb">00370</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy)
<a name="l00371"></a>00371 {
<a name="l00372"></a>00372   libmesh_assert(LIBMESH_DIM == 2);
<a name="l00373"></a>00373   _coords[0] = vx(0);
<a name="l00374"></a>00374   _coords[1] = vx(1);
<a name="l00375"></a>00375   _coords[2] = vy(0);
<a name="l00376"></a>00376   _coords[3] = vy(1);
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00380"></a>00380 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00381"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ac8679d51cffc02a3219327cdbade51c0">00381</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ae16486b9e6dc6e6fb0537409850ed01a">TypeTensor&lt;T&gt;::TypeTensor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; vx, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vy, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;vz)
<a name="l00382"></a>00382 {
<a name="l00383"></a>00383   libmesh_assert(LIBMESH_DIM == 3);
<a name="l00384"></a>00384   _coords[0] = vx(0);
<a name="l00385"></a>00385   _coords[1] = vx(1);
<a name="l00386"></a>00386   _coords[2] = vx(2);
<a name="l00387"></a>00387   _coords[3] = vy(0);
<a name="l00388"></a>00388   _coords[4] = vy(1);
<a name="l00389"></a>00389   _coords[5] = vy(2);
<a name="l00390"></a>00390   _coords[6] = vz(0);
<a name="l00391"></a>00391   _coords[7] = vz(1);
<a name="l00392"></a>00392   _coords[8] = vz(2);
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00399"></a>00399 <span class="keyword">inline</span>
<a name="l00400"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ad51860da4b4ba8216ade9dae62e30729">00400</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ad51860da4b4ba8216ade9dae62e30729">TypeTensor&lt;T&gt;::~TypeTensor</a> ()
<a name="l00401"></a>00401 {
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00407"></a>00407 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00408"></a>00408 <span class="keyword">inline</span>
<a name="l00409"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ab817de7fdef116e2691a76bb9c4fc496">00409</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#ab817de7fdef116e2691a76bb9c4fc496">TypeTensor&lt;T&gt;::assign</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00410"></a>00410 {
<a name="l00411"></a>00411   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00412"></a>00412     _coords[i] = p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00413"></a>00413 }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00418"></a>00418 <span class="keyword">inline</span>
<a name="l00419"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ada438acd743d6b532befa8972cf21f6e">00419</a> T <a class="code" href="classlibMesh_1_1TypeTensor.php#ada438acd743d6b532befa8972cf21f6e">TypeTensor&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00420"></a>00420                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00421"></a>00421 <span class="keyword"></span>{
<a name="l00422"></a>00422   libmesh_assert (i&lt;3);
<a name="l00423"></a>00423   libmesh_assert (j&lt;3);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00426"></a>00426 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (i &gt;= LIBMESH_DIM || j &gt;= LIBMESH_DIM)
<a name="l00427"></a>00427     <span class="keywordflow">return</span> 0.;
<a name="l00428"></a>00428 <span class="preprocessor">#endif</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>  
<a name="l00430"></a>00430   <span class="keywordflow">return</span> _coords[i*LIBMESH_DIM+j];
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00436"></a>00436 <span class="keyword">inline</span>
<a name="l00437"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ac9564dd13a28df25f3d4ad06b5649834">00437</a> T &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#ada438acd743d6b532befa8972cf21f6e">TypeTensor&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00438"></a>00438                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00439"></a>00439 {
<a name="l00440"></a>00440 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00441"></a>00441 <span class="preprocessor"></span>
<a name="l00442"></a>00442   <span class="keywordflow">if</span> (i &gt;= LIBMESH_DIM || j &gt;= LIBMESH_DIM)
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444 <span class="comment">//       libMesh::err &lt;&lt; &quot;ERROR:  You are assigning to a tensor component&quot; &lt;&lt; std::endl</span>
<a name="l00445"></a>00445 <span class="comment">//              &lt;&lt; &quot;that is out of range for the compiled LIBMESH_DIM!&quot;      &lt;&lt; std::endl</span>
<a name="l00446"></a>00446 <span class="comment">//              &lt;&lt; &quot; LIBMESH_DIM=&quot; &lt;&lt; LIBMESH_DIM &lt;&lt; &quot; , i=&quot; &lt;&lt; i &lt;&lt; &quot; , j=&quot; &lt;&lt; j &lt;&lt; std::endl;</span>
<a name="l00447"></a>00447       libmesh_error();
<a name="l00448"></a>00448     }
<a name="l00449"></a>00449   
<a name="l00450"></a>00450 <span class="preprocessor">#endif</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span>  
<a name="l00452"></a>00452   libmesh_assert (i&lt;LIBMESH_DIM);
<a name="l00453"></a>00453   libmesh_assert (j&lt;LIBMESH_DIM);
<a name="l00454"></a>00454   
<a name="l00455"></a>00455   <span class="keywordflow">return</span> _coords[i*LIBMESH_DIM+j];
<a name="l00456"></a>00456 }
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00459"></a>00459 <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a>
<a name="l00460"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ad03f2d90553d4c76a2cbedb09786223b">00460</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ad03f2d90553d4c76a2cbedb09786223b">TypeTensor&lt;T&gt;::row</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r)
<a name="l00461"></a>00461 {
<a name="l00462"></a>00462   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T&gt;</a> return_vector;
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;LIBMESH_DIM; j++)
<a name="l00465"></a>00465     return_vector.<a class="code" href="classlibMesh_1_1TypeVector.php#a164f4a8009b50213232b6fe9e47b5de0">_coords</a>[j] = _coords[r*LIBMESH_DIM + j];
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   <span class="keywordflow">return</span> return_vector;
<a name="l00468"></a>00468 }
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00471"></a>00471 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00472"></a>00472 <span class="keyword">inline</span>
<a name="l00473"></a>00473 <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00474"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#aa58391827b4c76b72a71ac6242ff48a6">00474</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#aa58391827b4c76b72a71ac6242ff48a6">TypeTensor&lt;T&gt;::operator + </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00475"></a>00475 <span class="keyword"></span>{
<a name="l00476"></a>00476  
<a name="l00477"></a>00477 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00478"></a>00478 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0]);
<a name="l00479"></a>00479 <span class="preprocessor">#endif</span>
<a name="l00480"></a>00480 <span class="preprocessor"></span>
<a name="l00481"></a>00481 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00482"></a>00482 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0],
<a name="l00483"></a>00483                     _coords[1] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[1],
<a name="l00484"></a>00484                     0.,
<a name="l00485"></a>00485                     _coords[2] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[2],
<a name="l00486"></a>00486                     _coords[3] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[3]);
<a name="l00487"></a>00487 <span class="preprocessor">#endif</span>
<a name="l00488"></a>00488 <span class="preprocessor"></span>
<a name="l00489"></a>00489 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00490"></a>00490 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0],
<a name="l00491"></a>00491                     _coords[1] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[1],
<a name="l00492"></a>00492                     _coords[2] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[2],
<a name="l00493"></a>00493                     _coords[3] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[3],
<a name="l00494"></a>00494                     _coords[4] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[4],
<a name="l00495"></a>00495                     _coords[5] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[5],
<a name="l00496"></a>00496                     _coords[6] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[6],
<a name="l00497"></a>00497                     _coords[7] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[7],
<a name="l00498"></a>00498                     _coords[8] + p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[8]);
<a name="l00499"></a>00499 <span class="preprocessor">#endif</span>
<a name="l00500"></a>00500 <span class="preprocessor"></span>               
<a name="l00501"></a>00501 }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00506"></a>00506 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00507"></a>00507 <span class="keyword">inline</span>
<a name="l00508"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a1708da49ef220e1354fd0010c6725b23">00508</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#a1708da49ef220e1354fd0010c6725b23">TypeTensor&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00509"></a>00509 {
<a name="l00510"></a>00510   this-&gt;add (p);
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00513"></a>00513 }
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00518"></a>00518 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00519"></a>00519 <span class="keyword">inline</span>
<a name="l00520"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#aa99a2a5e0ee616fe4a65a6b3842f2a69">00520</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#aa99a2a5e0ee616fe4a65a6b3842f2a69">TypeTensor&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00521"></a>00521 {
<a name="l00522"></a>00522   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00523"></a>00523     _coords[i] += p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00529"></a>00529 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00530"></a>00530 <span class="keyword">inline</span>
<a name="l00531"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">00531</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">TypeTensor&lt;T&gt;::add_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00534"></a>00534     _coords[i] += factor*p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00541"></a>00541 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00542"></a>00542 <span class="keyword">inline</span>
<a name="l00543"></a>00543 <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, T2&gt;::supertype</a>&gt;
<a name="l00544"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a772b68016e6b77c16df93d88f9103b0b">00544</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a86f5c24711d3ce5e5a80f048a0668592">TypeTensor&lt;T&gt;::operator - </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00545"></a>00545 <span class="keyword"></span>{
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00548"></a>00548 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0]);
<a name="l00549"></a>00549 <span class="preprocessor">#endif</span>
<a name="l00550"></a>00550 <span class="preprocessor"></span>
<a name="l00551"></a>00551 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00552"></a>00552 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0],
<a name="l00553"></a>00553                     _coords[1] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[1],
<a name="l00554"></a>00554                     0.,
<a name="l00555"></a>00555                     _coords[2] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[2],
<a name="l00556"></a>00556                     _coords[3] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[3]);
<a name="l00557"></a>00557 <span class="preprocessor">#endif</span>
<a name="l00558"></a>00558 <span class="preprocessor"></span>
<a name="l00559"></a>00559 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00560"></a>00560 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0],
<a name="l00561"></a>00561                     _coords[1] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[1],
<a name="l00562"></a>00562                     _coords[2] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[2],
<a name="l00563"></a>00563                     _coords[3] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[3],
<a name="l00564"></a>00564                     _coords[4] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[4],
<a name="l00565"></a>00565                     _coords[5] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[5],
<a name="l00566"></a>00566                     _coords[6] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[6],
<a name="l00567"></a>00567                     _coords[7] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[7],
<a name="l00568"></a>00568                     _coords[8] - p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[8]);
<a name="l00569"></a>00569 <span class="preprocessor">#endif</span>
<a name="l00570"></a>00570 <span class="preprocessor"></span>
<a name="l00571"></a>00571 }
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00576"></a>00576 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00577"></a>00577 <span class="keyword">inline</span>
<a name="l00578"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ad84fbe5ae6e64dad75ce682df01d5b62">00578</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#ad84fbe5ae6e64dad75ce682df01d5b62">TypeTensor&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)
<a name="l00579"></a>00579 {
<a name="l00580"></a>00580   this-&gt;subtract (p);
<a name="l00581"></a>00581 
<a name="l00582"></a>00582   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00583"></a>00583 }
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00588"></a>00588 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00589"></a>00589 <span class="keyword">inline</span>
<a name="l00590"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#af4941912d81ad84d7de56706b1523d4f">00590</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#af4941912d81ad84d7de56706b1523d4f">TypeTensor&lt;T&gt;::subtract</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a>&amp; p)
<a name="l00591"></a>00591 {
<a name="l00592"></a>00592   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00593"></a>00593     _coords[i] -= p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00594"></a>00594 }
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597 
<a name="l00598"></a>00598 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00599"></a>00599 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00600"></a>00600 <span class="keyword">inline</span>
<a name="l00601"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#abfe91509bae68904b75b8cedcdff7209">00601</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#abfe91509bae68904b75b8cedcdff7209">TypeTensor&lt;T&gt;::subtract_scaled</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p, <span class="keyword">const</span> T factor)
<a name="l00602"></a>00602 {
<a name="l00603"></a>00603   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00604"></a>00604     _coords[i] -= factor*p.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00605"></a>00605 }
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00610"></a>00610 <span class="keyword">inline</span>
<a name="l00611"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a86f5c24711d3ce5e5a80f048a0668592">00611</a> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a86f5c24711d3ce5e5a80f048a0668592">TypeTensor&lt;T&gt;::operator - </a>()<span class="keyword"> const</span>
<a name="l00612"></a>00612 <span class="keyword"></span>{
<a name="l00613"></a>00613   
<a name="l00614"></a>00614 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00615"></a>00615 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(-_coords[0]);
<a name="l00616"></a>00616 <span class="preprocessor">#endif</span>
<a name="l00617"></a>00617 <span class="preprocessor"></span>
<a name="l00618"></a>00618 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00619"></a>00619 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(-_coords[0],
<a name="l00620"></a>00620                     -_coords[1],
<a name="l00621"></a>00621                     -_coords[2],
<a name="l00622"></a>00622                     -_coords[3]);
<a name="l00623"></a>00623 <span class="preprocessor">#endif</span>
<a name="l00624"></a>00624 <span class="preprocessor"></span>
<a name="l00625"></a>00625 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00626"></a>00626 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(-_coords[0],
<a name="l00627"></a>00627                     -_coords[1], 
<a name="l00628"></a>00628                     -_coords[2], 
<a name="l00629"></a>00629                     -_coords[3], 
<a name="l00630"></a>00630                     -_coords[4], 
<a name="l00631"></a>00631                     -_coords[5], 
<a name="l00632"></a>00632                     -_coords[6], 
<a name="l00633"></a>00633                     -_coords[7], 
<a name="l00634"></a>00634                     -_coords[8]);
<a name="l00635"></a>00635 <span class="preprocessor">#endif</span>
<a name="l00636"></a>00636 <span class="preprocessor"></span>  
<a name="l00637"></a>00637 }
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00642"></a>00642 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00643"></a>00643 <span class="keyword">inline</span>
<a name="l00644"></a>00644 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00645"></a>00645   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00646"></a>00646   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00647"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">00647</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">TypeTensor&lt;T&gt;::operator * </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00648"></a>00648 <span class="keyword"></span>{
<a name="l00649"></a>00649   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00653"></a>00653 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;TS&gt;</a>(_coords[0]*factor);
<a name="l00654"></a>00654 <span class="preprocessor">#endif</span>
<a name="l00655"></a>00655 <span class="preprocessor"></span>  
<a name="l00656"></a>00656 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00657"></a>00657 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;TS&gt;</a>(_coords[0]*factor,
<a name="l00658"></a>00658                         _coords[1]*factor,
<a name="l00659"></a>00659                         _coords[2]*factor,
<a name="l00660"></a>00660                         _coords[3]*factor);
<a name="l00661"></a>00661 <span class="preprocessor">#endif</span>
<a name="l00662"></a>00662 <span class="preprocessor"></span>  
<a name="l00663"></a>00663 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00664"></a>00664 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;TS&gt;</a>(_coords[0]*factor,
<a name="l00665"></a>00665                         _coords[1]*factor, 
<a name="l00666"></a>00666                         _coords[2]*factor, 
<a name="l00667"></a>00667                         _coords[3]*factor, 
<a name="l00668"></a>00668                         _coords[4]*factor, 
<a name="l00669"></a>00669                         _coords[5]*factor, 
<a name="l00670"></a>00670                         _coords[6]*factor, 
<a name="l00671"></a>00671                         _coords[7]*factor, 
<a name="l00672"></a>00672                         _coords[8]*factor);
<a name="l00673"></a>00673 <span class="preprocessor">#endif  </span>
<a name="l00674"></a>00674 <span class="preprocessor"></span>}
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 
<a name="l00677"></a>00677 
<a name="l00678"></a>00678 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> Scalar&gt;
<a name="l00679"></a>00679 <span class="keyword">inline</span>
<a name="l00680"></a>00680 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00681"></a>00681   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00682"></a>00682   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00683"></a><a class="code" href="namespacelibMesh.php#a0c087fb32eb3bd2530fb6d6a9dd87d74">00683</a> <a class="code" href="namespacelibMesh.php#a0c087fb32eb3bd2530fb6d6a9dd87d74">operator * </a>(<span class="keyword">const</span> Scalar factor,
<a name="l00684"></a>00684             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp;t)
<a name="l00685"></a>00685 {
<a name="l00686"></a>00686   <span class="keywordflow">return</span> t * factor;
<a name="l00687"></a>00687 }
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00692"></a>00692 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00693"></a>00693 <span class="keyword">inline</span>
<a name="l00694"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ac15f773ad4cf8f1d0c6aae4041e2fd64">00694</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#ac15f773ad4cf8f1d0c6aae4041e2fd64">TypeTensor&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> Scalar factor)
<a name="l00695"></a>00695 {
<a name="l00696"></a>00696   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00697"></a>00697     _coords[i] *= factor;
<a name="l00698"></a>00698 
<a name="l00699"></a>00699   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00700"></a>00700 }
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00706"></a>00706 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Scalar&gt;
<a name="l00707"></a>00707 <span class="keyword">inline</span>
<a name="l00708"></a>00708 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00709"></a>00709   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;Scalar&gt;::value</a>,
<a name="l00710"></a>00710   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;typename CompareTypes&lt;T, Scalar&gt;::supertype</a>&gt; &gt;::type
<a name="l00711"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a3523f8a212b31c5962f4223be8cbdd4b">00711</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a3523f8a212b31c5962f4223be8cbdd4b">TypeTensor&lt;T&gt;::operator / </a>(<span class="keyword">const</span> Scalar factor)<span class="keyword"> const</span>
<a name="l00712"></a>00712 <span class="keyword"></span>{
<a name="l00713"></a>00713   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T, Scalar&gt;::supertype</a> TS;
<a name="l00716"></a>00716   
<a name="l00717"></a>00717 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00718"></a>00718 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;TS&gt;</a>(_coords[0]/factor);
<a name="l00719"></a>00719 <span class="preprocessor">#endif</span>
<a name="l00720"></a>00720 <span class="preprocessor"></span>  
<a name="l00721"></a>00721 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00722"></a>00722 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;TS&gt;</a>(_coords[0]/factor,
<a name="l00723"></a>00723                         _coords[1]/factor,
<a name="l00724"></a>00724                         _coords[2]/factor,
<a name="l00725"></a>00725                         _coords[3]/factor);
<a name="l00726"></a>00726 <span class="preprocessor">#endif</span>
<a name="l00727"></a>00727 <span class="preprocessor"></span>  
<a name="l00728"></a>00728 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00729"></a>00729 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;TS&gt;</a>(_coords[0]/factor,
<a name="l00730"></a>00730                         _coords[1]/factor, 
<a name="l00731"></a>00731                         _coords[2]/factor, 
<a name="l00732"></a>00732                         _coords[3]/factor, 
<a name="l00733"></a>00733                         _coords[4]/factor, 
<a name="l00734"></a>00734                         _coords[5]/factor, 
<a name="l00735"></a>00735                         _coords[6]/factor, 
<a name="l00736"></a>00736                         _coords[7]/factor, 
<a name="l00737"></a>00737                         _coords[8]/factor);
<a name="l00738"></a>00738 <span class="preprocessor">#endif</span>
<a name="l00739"></a>00739 <span class="preprocessor"></span>  
<a name="l00740"></a>00740 }
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00745"></a>00745 <span class="keyword">inline</span>
<a name="l00746"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ab53b025a4e815cd4d2493e929f82aa70">00746</a> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#ab53b025a4e815cd4d2493e929f82aa70">TypeTensor&lt;T&gt;::transpose</a>()<span class="keyword"> const</span>
<a name="l00747"></a>00747 <span class="keyword"></span>{
<a name="l00748"></a>00748 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00749"></a>00749 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0]);
<a name="l00750"></a>00750 <span class="preprocessor">#endif</span>
<a name="l00751"></a>00751 <span class="preprocessor"></span>  
<a name="l00752"></a>00752 <span class="preprocessor">#if LIBMESH_DIM == 2 </span>
<a name="l00753"></a>00753 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0],
<a name="l00754"></a>00754                     _coords[2],
<a name="l00755"></a>00755                     _coords[1],
<a name="l00756"></a>00756                     _coords[3]);
<a name="l00757"></a>00757 <span class="preprocessor">#endif</span>
<a name="l00758"></a>00758 <span class="preprocessor"></span>  
<a name="l00759"></a>00759 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00760"></a>00760 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor</a>(_coords[0],
<a name="l00761"></a>00761                     _coords[3], 
<a name="l00762"></a>00762                     _coords[6], 
<a name="l00763"></a>00763                     _coords[1], 
<a name="l00764"></a>00764                     _coords[4], 
<a name="l00765"></a>00765                     _coords[7], 
<a name="l00766"></a>00766                     _coords[2], 
<a name="l00767"></a>00767                     _coords[5], 
<a name="l00768"></a>00768                     _coords[8]);
<a name="l00769"></a>00769 <span class="preprocessor">#endif</span>
<a name="l00770"></a>00770 <span class="preprocessor"></span>}
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00775"></a>00775 <span class="keyword">inline</span>
<a name="l00776"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a3c2aa5c20e04196eddc725e55b406554">00776</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1TypeTensor.php#a3c2aa5c20e04196eddc725e55b406554">TypeTensor&lt;T&gt;::operator /= </a>(<span class="keyword">const</span> T factor)
<a name="l00777"></a>00777 {
<a name="l00778"></a>00778   libmesh_assert (factor != static_cast&lt;T&gt;(0.));
<a name="l00779"></a>00779   
<a name="l00780"></a>00780   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00781"></a>00781     _coords[i] /= factor;
<a name="l00782"></a>00782 
<a name="l00783"></a>00783   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00784"></a>00784 }
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00790"></a>00790 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00791"></a>00791 <span class="keyword">inline</span>
<a name="l00792"></a>00792 <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T,T2&gt;::supertype</a>&gt;
<a name="l00793"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a45b15e129347c4d2899fc80d1f36397a">00793</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">TypeTensor&lt;T&gt;::operator * </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00794"></a>00794 <span class="keyword"></span>{
<a name="l00795"></a>00795   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;typename CompareTypes&lt;T,T2&gt;::supertype</a>&gt; returnval;
<a name="l00796"></a>00796   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00797"></a>00797     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;LIBMESH_DIM; j++)
<a name="l00798"></a>00798       returnval(i) += (*this)(i,j)*p(j);
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   <span class="keywordflow">return</span> returnval;
<a name="l00801"></a>00801 }
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00806"></a>00806 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00807"></a>00807 <span class="keyword">inline</span>
<a name="l00808"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a96a3aad13a1e78c0de6d8863b68841ec">00808</a> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#abb58d3b107d436ed743cc92e007bd27a">TypeTensor&lt;T&gt;::operator * </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;p)<span class="keyword"> const</span>
<a name="l00809"></a>00809 <span class="keyword"></span>{
<a name="l00810"></a>00810   <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a> returnval;
<a name="l00811"></a>00811   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00812"></a>00812     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;LIBMESH_DIM; j++)
<a name="l00813"></a>00813       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;LIBMESH_DIM; k++)
<a name="l00814"></a>00814         returnval(i,j) += (*this)(i,k)*p(k,j);
<a name="l00815"></a>00815 
<a name="l00816"></a>00816   <span class="keywordflow">return</span> returnval;
<a name="l00817"></a>00817 }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00825"></a>00825 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00826"></a>00826 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00827"></a>00827 <span class="keyword">inline</span>
<a name="l00828"></a>00828 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T,T2&gt;::supertype</a>
<a name="l00829"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a91ced4ae7e8d72aee0d21193e2fa7dbc">00829</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a91ced4ae7e8d72aee0d21193e2fa7dbc">TypeTensor&lt;T&gt;::contract</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T2&gt;</a> &amp;t)<span class="keyword"> const</span>
<a name="l00830"></a>00830 <span class="keyword"></span>{
<a name="l00831"></a>00831   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1CompareTypes.php#ad4a5d1fd1ae6c9db9a9422258d7ca949">CompareTypes&lt;T,T2&gt;::supertype</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a> = 0.;
<a name="l00832"></a>00832   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00833"></a>00833     sum += _coords[i]*t.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[i];
<a name="l00834"></a>00834   <span class="keywordflow">return</span> sum;
<a name="l00835"></a>00835 }
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00840"></a>00840 <span class="keyword">inline</span>
<a name="l00841"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a6e514d706640dd89649d59f0a0a2e923">00841</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a6e514d706640dd89649d59f0a0a2e923">TypeTensor&lt;T&gt;::size</a>()<span class="keyword"> const</span>
<a name="l00842"></a>00842 <span class="keyword"></span>{
<a name="l00843"></a>00843   <span class="keywordflow">return</span> std::sqrt(this-&gt;size_sq());  
<a name="l00844"></a>00844 }
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00849"></a>00849 <span class="keyword">inline</span>
<a name="l00850"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">00850</a> T <a class="code" href="classlibMesh_1_1TypeTensor.php#a420567d583c1ef607a8dc40b9da6e92d">TypeTensor&lt;T&gt;::det</a>()<span class="keyword"> const</span>
<a name="l00851"></a>00851 <span class="keyword"></span>{
<a name="l00852"></a>00852 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00853"></a>00853 <span class="preprocessor"></span>  <span class="keywordflow">return</span> _coords[0];
<a name="l00854"></a>00854 <span class="preprocessor">#endif</span>
<a name="l00855"></a>00855 <span class="preprocessor"></span>
<a name="l00856"></a>00856 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00857"></a>00857 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0] * _coords[3]
<a name="l00858"></a>00858           - _coords[1] * _coords[2]);
<a name="l00859"></a>00859 <span class="preprocessor">#endif</span>
<a name="l00860"></a>00860 <span class="preprocessor"></span>
<a name="l00861"></a>00861 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00862"></a>00862 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (_coords[0] * _coords[4] * _coords[8]
<a name="l00863"></a>00863           + _coords[1] * _coords[5] * _coords[6]
<a name="l00864"></a>00864           + _coords[2] * _coords[3] * _coords[7]
<a name="l00865"></a>00865           - _coords[0] * _coords[5] * _coords[7]
<a name="l00866"></a>00866           - _coords[1] * _coords[3] * _coords[8]
<a name="l00867"></a>00867           - _coords[2] * _coords[4] * _coords[6]);
<a name="l00868"></a>00868 <span class="preprocessor">#endif</span>
<a name="l00869"></a>00869 <span class="preprocessor"></span>}
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00872"></a>00872 <span class="keyword">inline</span>
<a name="l00873"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a9d7a4e6e7d0df17a315aa215806d115d">00873</a> T <a class="code" href="classlibMesh_1_1TypeTensor.php#a9d7a4e6e7d0df17a315aa215806d115d">TypeTensor&lt;T&gt;::tr</a>()<span class="keyword"> const</span>
<a name="l00874"></a>00874 <span class="keyword"></span>{
<a name="l00875"></a>00875 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00876"></a>00876 <span class="preprocessor"></span>  <span class="keywordflow">return</span> _coords[0];
<a name="l00877"></a>00877 <span class="preprocessor">#endif</span>
<a name="l00878"></a>00878 <span class="preprocessor"></span>
<a name="l00879"></a>00879 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00880"></a>00880 <span class="preprocessor"></span>  <span class="keywordflow">return</span> _coords[0] + _coords[3];
<a name="l00881"></a>00881 <span class="preprocessor">#endif</span>
<a name="l00882"></a>00882 <span class="preprocessor"></span>
<a name="l00883"></a>00883 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00884"></a>00884 <span class="preprocessor"></span>  <span class="keywordflow">return</span> _coords[0] + _coords[4] + _coords[8];
<a name="l00885"></a>00885 <span class="preprocessor">#endif</span>
<a name="l00886"></a>00886 <span class="preprocessor"></span>}
<a name="l00887"></a>00887 
<a name="l00888"></a>00888 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00889"></a>00889 <span class="keyword">inline</span>
<a name="l00890"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#ab8531257e3cd525ea57a62b14c23a2d0">00890</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#ab8531257e3cd525ea57a62b14c23a2d0">TypeTensor&lt;T&gt;::zero</a>()
<a name="l00891"></a>00891 {
<a name="l00892"></a>00892   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00893"></a>00893     _coords[i] = 0.;
<a name="l00894"></a>00894 }
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00899"></a>00899 <span class="keyword">inline</span>
<a name="l00900"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">00900</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">TypeTensor&lt;T&gt;::size_sq</a> ()<span class="keyword"> const</span>
<a name="l00901"></a>00901 <span class="keyword"></span>{
<a name="l00902"></a>00902   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a> = 0.;
<a name="l00903"></a>00903   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM*LIBMESH_DIM; i++)
<a name="l00904"></a>00904     sum += <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_coords[i]);
<a name="l00905"></a>00905   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>;
<a name="l00906"></a>00906 }
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00911"></a>00911 <span class="keyword">inline</span>
<a name="l00912"></a><a class="code" href="classlibMesh_1_1TypeTensor.php#a367ed45df8b826d2e7b3c80e11f0586f">00912</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TypeTensor.php#a367ed45df8b826d2e7b3c80e11f0586f">TypeTensor&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeTensor.php">TypeTensor&lt;T&gt;</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00913"></a>00913 <span class="keyword"></span>{
<a name="l00914"></a>00914 <span class="preprocessor">#if LIBMESH_DIM == 1</span>
<a name="l00915"></a>00915 <span class="preprocessor"></span>  <span class="keywordflow">return</span> (std::abs(_coords[0] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0])
<a name="l00916"></a>00916           &lt; TOLERANCE);
<a name="l00917"></a>00917 <span class="preprocessor">#endif</span>
<a name="l00918"></a>00918 <span class="preprocessor"></span>  
<a name="l00919"></a>00919 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00920"></a>00920 <span class="preprocessor"></span>  <span class="keywordflow">return</span> ((std::abs(_coords[0] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0]) +
<a name="l00921"></a>00921            std::abs(_coords[1] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[1]) +
<a name="l00922"></a>00922            std::abs(_coords[2] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[2]) +
<a name="l00923"></a>00923            std::abs(_coords[3] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[3]))
<a name="l00924"></a>00924           &lt; 4.*TOLERANCE);
<a name="l00925"></a>00925 <span class="preprocessor">#endif</span>
<a name="l00926"></a>00926 <span class="preprocessor"></span>  
<a name="l00927"></a>00927 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00928"></a>00928 <span class="preprocessor"></span>  <span class="keywordflow">return</span> ((std::abs(_coords[0] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[0]) +
<a name="l00929"></a>00929            std::abs(_coords[1] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[1]) +
<a name="l00930"></a>00930            std::abs(_coords[2] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[2]) +
<a name="l00931"></a>00931            std::abs(_coords[3] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[3]) +
<a name="l00932"></a>00932            std::abs(_coords[4] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[4]) +
<a name="l00933"></a>00933            std::abs(_coords[5] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[5]) +
<a name="l00934"></a>00934            std::abs(_coords[6] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[6]) +
<a name="l00935"></a>00935            std::abs(_coords[7] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[7]) +
<a name="l00936"></a>00936            std::abs(_coords[8] - rhs.<a class="code" href="classlibMesh_1_1TypeTensor.php#a957623f929f3199439d59ff4841e484b">_coords</a>[8]))
<a name="l00937"></a>00937           &lt; 9.*TOLERANCE);
<a name="l00938"></a>00938 <span class="preprocessor">#endif</span>
<a name="l00939"></a>00939 <span class="preprocessor"></span>  
<a name="l00940"></a>00940 }
<a name="l00941"></a>00941 
<a name="l00942"></a>00942 } <span class="comment">// namespace libMesh</span>
<a name="l00943"></a>00943 
<a name="l00944"></a>00944 <span class="preprocessor">#endif // #define __type_tensor_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
