<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">ucd_io.C</div>  </div>
</div>
<div class="contents">
<a href="ucd__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: ucd_io.C 4195 2011-02-09 17:04:17Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="ucd__io_8h.php">ucd_io.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex8_8h.php">cell_hex8.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism6_8h.php">cell_prism6.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor"># include &quot;gzstream.h&quot;</span> <span class="comment">// For reading/writing compressed streams</span>
<a name="l00037"></a>00037 <span class="preprocessor">#endif</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// UCDIO class members</span>
<a name="l00048"></a><a class="code" href="classlibMesh_1_1UCDIO.php#a090ae9cd08dcdb05fbc0cf8a5a65c1b2">00048</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UCDIO.php#a090ae9cd08dcdb05fbc0cf8a5a65c1b2">UCDIO::read</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>      
<a name="l00054"></a>00054       igzstream in_stream (file_name.c_str());
<a name="l00055"></a>00055       this-&gt;<a class="code" href="classlibMesh_1_1UCDIO.php#aa699818b59da2e80e98a30ddf99b34b9">read_implementation</a> (in_stream);
<a name="l00056"></a>00056       
<a name="l00057"></a>00057 <span class="preprocessor">#else</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>      
<a name="l00059"></a>00059       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00060"></a>00060                     &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00061"></a>00061                     &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00062"></a>00062                     &lt;&lt; std::endl;
<a name="l00063"></a>00063       libmesh_error();
<a name="l00064"></a>00064       
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>      <span class="keywordflow">return</span>;      
<a name="l00067"></a>00067     }
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="keywordflow">else</span>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071       std::ifstream in_stream (file_name.c_str());
<a name="l00072"></a>00072       this-&gt;<a class="code" href="classlibMesh_1_1UCDIO.php#aa699818b59da2e80e98a30ddf99b34b9">read_implementation</a> (in_stream);
<a name="l00073"></a>00073       <span class="keywordflow">return</span>;
<a name="l00074"></a>00074     }
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1UCDIO.php#a8fb6788014a837d486e5038025149447">00079</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UCDIO.php#a8fb6788014a837d486e5038025149447">UCDIO::write</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>      
<a name="l00085"></a>00085       ogzstream out_stream (file_name.c_str());
<a name="l00086"></a>00086       this-&gt;<a class="code" href="classlibMesh_1_1UCDIO.php#a0b6b8b2c648906b4e5f8f045a61b5a08">write_implementation</a> (out_stream);
<a name="l00087"></a>00087       
<a name="l00088"></a>00088 <span class="preprocessor">#else</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>      
<a name="l00090"></a>00090       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00091"></a>00091                     &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00092"></a>00092                     &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00093"></a>00093                     &lt;&lt; std::endl;
<a name="l00094"></a>00094       libmesh_error();
<a name="l00095"></a>00095       
<a name="l00096"></a>00096 <span class="preprocessor">#endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>      <span class="keywordflow">return</span>;      
<a name="l00098"></a>00098     }
<a name="l00099"></a>00099   
<a name="l00100"></a>00100   <span class="keywordflow">else</span>
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       std::ofstream out_stream (file_name.c_str());
<a name="l00103"></a>00103       this-&gt;<a class="code" href="classlibMesh_1_1UCDIO.php#a0b6b8b2c648906b4e5f8f045a61b5a08">write_implementation</a> (out_stream);
<a name="l00104"></a>00104       <span class="keywordflow">return</span>;
<a name="l00105"></a>00105     }
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1UCDIO.php#aa699818b59da2e80e98a30ddf99b34b9">00110</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UCDIO.php#aa699818b59da2e80e98a30ddf99b34b9">UCDIO::read_implementation</a> (std::istream&amp; in)
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00113"></a>00113   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00114"></a>00114   <span class="comment">// broadcast later</span>
<a name="l00115"></a>00115   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// Check input buffer</span>
<a name="l00118"></a>00118   libmesh_assert (in.good());
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <span class="comment">// Keep track of what kinds of elements this file contains</span>
<a name="l00123"></a>00123   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.clear();
<a name="l00124"></a>00124   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.resize(4, <span class="keyword">false</span>);
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#a96cc4aa98c2495e488522155a3fa07f2">skip_comment_lines</a> (in, <span class="charliteral">&#39;#&#39;</span>);
<a name="l00127"></a>00127   
<a name="l00128"></a>00128   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nNodes=0, nElem=0, dummy=0;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   in &gt;&gt; nNodes   <span class="comment">// Read the number of nodes from the stream</span>
<a name="l00131"></a>00131      &gt;&gt; nElem    <span class="comment">// Read the number of elements from the stream</span>
<a name="l00132"></a>00132      &gt;&gt; dummy
<a name="l00133"></a>00133      &gt;&gt; dummy
<a name="l00134"></a>00134      &gt;&gt; dummy;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// Read the nodal coordinates. Note that UCD format always</span>
<a name="l00138"></a>00138   <span class="comment">// stores (x,y,z), and in 2D z=0. We don&#39;t need to store this,</span>
<a name="l00139"></a>00139   <span class="comment">// however.  So, we read in x,y,z for each node and make a point</span>
<a name="l00140"></a>00140   <span class="comment">// in the proper way based on what dimension we&#39;re in</span>
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142     <a class="code" href="classlibMesh_1_1Point.php">Point</a> xyz;    
<a name="l00143"></a>00143     
<a name="l00144"></a>00144     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nNodes; i++)
<a name="l00145"></a>00145       {
<a name="l00146"></a>00146         libmesh_assert (in.good());
<a name="l00147"></a>00147         
<a name="l00148"></a>00148         in &gt;&gt; dummy   <span class="comment">// Point number</span>
<a name="l00149"></a>00149            &gt;&gt; xyz(0)  <span class="comment">// x-coordinate value</span>
<a name="l00150"></a>00150            &gt;&gt; xyz(1)  <span class="comment">// y-coordinate value</span>
<a name="l00151"></a>00151            &gt;&gt; xyz(2); <span class="comment">// z-coordinate value</span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153         <span class="comment">// Build the node</span>
<a name="l00154"></a>00154         mesh.add_point (xyz, i);
<a name="l00155"></a>00155       }
<a name="l00156"></a>00156   }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   
<a name="l00160"></a>00160   <span class="comment">// Read the elements from the stream. Notice that the UCD node-numbering</span>
<a name="l00161"></a>00161   <span class="comment">// scheme is 1-based, and we just created a 0-based scheme above</span>
<a name="l00162"></a>00162   <span class="comment">// (which is of course what we want). So, when we read in the nodal</span>
<a name="l00163"></a>00163   <span class="comment">// connectivity for each element we need to take 1 off the value of</span>
<a name="l00164"></a>00164   <span class="comment">// each node so that we get the right thing.</span>
<a name="l00165"></a>00165   {
<a name="l00166"></a>00166     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> material_id=0, node=0;
<a name="l00167"></a>00167     std::string type;
<a name="l00168"></a>00168     
<a name="l00169"></a>00169     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nElem; i++)
<a name="l00170"></a>00170       {
<a name="l00171"></a>00171         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173         libmesh_assert (in.good());
<a name="l00174"></a>00174         
<a name="l00175"></a>00175         in &gt;&gt; dummy        <span class="comment">// Cell number, means nothing to us</span>
<a name="l00176"></a>00176            &gt;&gt; material_id  <span class="comment">// doesn&#39;t mean anything at present, might later</span>
<a name="l00177"></a>00177            &gt;&gt; type;        <span class="comment">// string describing cell type:</span>
<a name="l00178"></a>00178                            <span class="comment">// either tri, quad, tet, hex, or prism for the</span>
<a name="l00179"></a>00179                            <span class="comment">// obvious cases</span>
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182                            <span class="comment">// Now read the connectivity.</span>
<a name="l00183"></a>00183         <span class="keywordflow">if</span> (type == <span class="stringliteral">&quot;quad&quot;</span>)
<a name="l00184"></a>00184           elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>;
<a name="l00185"></a>00185         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == <span class="stringliteral">&quot;tri&quot;</span>)
<a name="l00186"></a>00186           elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>;
<a name="l00187"></a>00187         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == <span class="stringliteral">&quot;hex&quot;</span>)
<a name="l00188"></a>00188           elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex8.php">Hex8</a>;
<a name="l00189"></a>00189         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == <span class="stringliteral">&quot;tet&quot;</span>)
<a name="l00190"></a>00190           elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a>;
<a name="l00191"></a>00191         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == <span class="stringliteral">&quot;prism&quot;</span>)
<a name="l00192"></a>00192           elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism6.php">Prism6</a>;
<a name="l00193"></a>00193         <span class="keywordflow">else</span>
<a name="l00194"></a>00194           libmesh_error();
<a name="l00195"></a>00195         
<a name="l00196"></a>00196         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00197"></a>00197           {
<a name="l00198"></a>00198             libmesh_assert (in.good());
<a name="l00199"></a>00199             
<a name="l00200"></a>00200             in &gt;&gt; node; <span class="comment">// read the current node</span>
<a name="l00201"></a>00201             node -= 1;  <span class="comment">// UCD is 1-based, so subtract</span>
<a name="l00202"></a>00202 
<a name="l00203"></a>00203             libmesh_assert (node &lt; mesh.n_nodes());
<a name="l00204"></a>00204             
<a name="l00205"></a>00205             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(n) =
<a name="l00206"></a>00206               mesh.node_ptr(node); <span class="comment">// assign the node</span>
<a name="l00207"></a>00207           }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209         <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>()] = <span class="keyword">true</span>;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211         <span class="comment">// Add the element to the mesh</span>
<a name="l00212"></a>00212         elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(i);
<a name="l00213"></a>00213         mesh.add_elem (elem);
<a name="l00214"></a>00214       }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     <span class="comment">// Set the mesh dimension to the largest encountered for an element</span>
<a name="l00217"></a>00217     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=4; ++i)
<a name="l00218"></a>00218       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[i])
<a name="l00219"></a>00219         mesh.set_mesh_dimension(i);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (mesh.mesh_dimension() &gt; LIBMESH_DIM)
<a name="l00223"></a>00223       {
<a name="l00224"></a>00224         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Cannot open dimension &quot;</span> &lt;&lt;
<a name="l00225"></a>00225                         mesh.mesh_dimension() &lt;&lt;
<a name="l00226"></a>00226                         <span class="stringliteral">&quot; mesh file when configured without &quot;</span> &lt;&lt;
<a name="l00227"></a>00227                         mesh.mesh_dimension() &lt;&lt; <span class="stringliteral">&quot;D support.&quot;</span> &lt;&lt;
<a name="l00228"></a>00228                         std::endl;
<a name="l00229"></a>00229         libmesh_error();
<a name="l00230"></a>00230       }
<a name="l00231"></a>00231 <span class="preprocessor">#endif</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>  }  
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classlibMesh_1_1UCDIO.php#a0b6b8b2c648906b4e5f8f045a61b5a08">00237</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UCDIO.php#a0b6b8b2c648906b4e5f8f045a61b5a08">UCDIO::write_implementation</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   libmesh_assert (out.good());
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00242"></a>00242   
<a name="l00243"></a>00243   <span class="comment">// UCD doesn&#39;t work in 1D</span>
<a name="l00244"></a>00244   libmesh_assert (mesh.mesh_dimension() != 1);
<a name="l00245"></a>00245   
<a name="l00246"></a>00246   <span class="comment">// Write header to stream</span>
<a name="l00247"></a>00247   out &lt;&lt; <span class="stringliteral">&quot;# This file was generated by:\n&quot;</span>
<a name="l00248"></a>00248       &lt;&lt; <span class="stringliteral">&quot;#\n&quot;</span>
<a name="l00249"></a>00249       &lt;&lt; <span class="stringliteral">&quot;# $Id: ucd_io.C 4195 2011-02-09 17:04:17Z roystgnr $\n&quot;</span>
<a name="l00250"></a>00250       &lt;&lt; <span class="stringliteral">&quot;#\n&quot;</span>
<a name="l00251"></a>00251       &lt;&lt; <span class="stringliteral">&quot;# For a description of the UCD format see the AVS Developer&#39;s guide.\n&quot;</span>
<a name="l00252"></a>00252       &lt;&lt; <span class="stringliteral">&quot;#\n&quot;</span>;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   
<a name="l00255"></a>00255   <span class="comment">// Write the mesh info</span>
<a name="l00256"></a>00256   out &lt;&lt; mesh.n_nodes() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00257"></a>00257       &lt;&lt; mesh.n_elem()  &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00258"></a>00258       &lt;&lt; <span class="stringliteral">&quot; 0 0 0\n&quot;</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">// Write the coordinates</span>
<a name="l00261"></a>00261   {
<a name="l00262"></a>00262 <span class="comment">//     const_node_iterator       it  (mesh.nodes_begin());</span>
<a name="l00263"></a>00263 <span class="comment">//     const const_node_iterator end (mesh.nodes_end());</span>
<a name="l00264"></a>00264 
<a name="l00265"></a>00265     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       it  = mesh.nodes_begin();
<a name="l00266"></a>00266     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = mesh.nodes_end();
<a name="l00267"></a>00267         
<a name="l00268"></a>00268     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; <span class="comment">// 1-based node number for UCD</span>
<a name="l00269"></a>00269     
<a name="l00270"></a>00270     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00271"></a>00271       {
<a name="l00272"></a>00272         libmesh_assert (out.good());
<a name="l00273"></a>00273         
<a name="l00274"></a>00274         out &lt;&lt; n++ &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00275"></a>00275         (*it)-&gt;write_unformatted(out);
<a name="l00276"></a>00276       }
<a name="l00277"></a>00277   }
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   <span class="comment">// Write the elements</span>
<a name="l00280"></a>00280   {
<a name="l00281"></a>00281     std::string type[] =
<a name="l00282"></a>00282       { <span class="stringliteral">&quot;edge&quot;</span>,  <span class="stringliteral">&quot;edge&quot;</span>,  <span class="stringliteral">&quot;edge&quot;</span>,       
<a name="l00283"></a>00283         <span class="stringliteral">&quot;tri&quot;</span>,   <span class="stringliteral">&quot;tri&quot;</span>,  
<a name="l00284"></a>00284         <span class="stringliteral">&quot;quad&quot;</span>,  <span class="stringliteral">&quot;quad&quot;</span>,  <span class="stringliteral">&quot;quad&quot;</span>,
<a name="l00285"></a>00285         <span class="stringliteral">&quot;tet&quot;</span>,   <span class="stringliteral">&quot;tet&quot;</span>,  
<a name="l00286"></a>00286         <span class="stringliteral">&quot;hex&quot;</span>,   <span class="stringliteral">&quot;hex&quot;</span>,   <span class="stringliteral">&quot;hex&quot;</span>,
<a name="l00287"></a>00287         <span class="stringliteral">&quot;prism&quot;</span>, <span class="stringliteral">&quot;prism&quot;</span>, <span class="stringliteral">&quot;prism&quot;</span>,      
<a name="l00288"></a>00288         <span class="stringliteral">&quot;pyramid&quot;</span> };
<a name="l00289"></a>00289     
<a name="l00290"></a>00290 <span class="comment">//     const_elem_iterator       it  (mesh.elements_begin());</span>
<a name="l00291"></a>00291 <span class="comment">//     const const_elem_iterator end (mesh.elements_end());</span>
<a name="l00292"></a>00292 
<a name="l00293"></a>00293     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = mesh.elements_begin();
<a name="l00294"></a>00294     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.elements_end();
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=1; <span class="comment">// 1-based element number for UCD</span>
<a name="l00297"></a>00297     
<a name="l00298"></a>00298     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00299"></a>00299       {
<a name="l00300"></a>00300         libmesh_assert (out.good());
<a name="l00301"></a>00301         
<a name="l00302"></a>00302         out &lt;&lt; e++ &lt;&lt; <span class="stringliteral">&quot; 0 &quot;</span> &lt;&lt; type[(*it)-&gt;type()] &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span>; 
<a name="l00303"></a>00303         <span class="comment">// (*it)-&gt;write_ucd_connectivity(out);</span>
<a name="l00304"></a>00304         (*it)-&gt;write_connectivity(out, <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa602f692ea59febe36c106d912a443d1">UCD</a>);
<a name="l00305"></a>00305       }
<a name="l00306"></a>00306   }
<a name="l00307"></a>00307 }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
