<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">unsteady_solver.C</div>  </div>
</div>
<div class="contents">
<a href="unsteady__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unsteady_solver.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#a018eeeb96c635ea1049a2b2c4c001b1f">00032</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a018eeeb96c635ea1049a2b2c4c001b1f">UnsteadySolver::UnsteadySolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00033"></a>00033   : <a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a>(s),
<a name="l00034"></a>00034     old_local_nonlinear_solution (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00035"></a>00035     first_solve                  (true)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#a0c86b7b35fac2818527530fd6f75eee4">00041</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a0c86b7b35fac2818527530fd6f75eee4">UnsteadySolver::~UnsteadySolver</a> ()
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 }
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#abc5f1a243458ac055e72526043a0622d">00047</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#abc5f1a243458ac055e72526043a0622d">UnsteadySolver::init</a> ()
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1UnsteadySolver.php#abc5f1a243458ac055e72526043a0622d">TimeSolver::init</a>();
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#aa0323d5265ad992433fcb623a2e6da41">00056</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#aa0323d5265ad992433fcb623a2e6da41">UnsteadySolver::solve</a> ()
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">first_solve</a>)
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a8994bb489d6f17a0288518679a21c53a">advance_timestep</a>();
<a name="l00061"></a>00061       <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">first_solve</a> = <span class="keyword">false</span>;
<a name="l00062"></a>00062     }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="preprocessor">#ifdef LIBMESH_ENABLE_GHOSTED</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>-&gt;init (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(),
<a name="l00066"></a>00066                                       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a>(), <span class="keyword">false</span>,
<a name="l00067"></a>00067                                       <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00068"></a>00068 <span class="preprocessor">#else</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>-&gt;init (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>).<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>
<a name="l00073"></a>00073     (*<a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>,
<a name="l00074"></a>00074      <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a>());
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> solve_result = <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>-&gt;solve();
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// If we requested the UnsteadySolver to attempt reducing dt after a</span>
<a name="l00079"></a>00079   <span class="comment">// failed DiffSolver solve, check the results of the solve now.</span>
<a name="l00080"></a>00080   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a9b77957719eae28de2e753d9a99d825e">reduce_deltat_on_diffsolver_failure</a>)
<a name="l00081"></a>00081     {
<a name="l00082"></a>00082       <span class="keywordtype">bool</span> backtracking_failed =
<a name="l00083"></a>00083         solve_result &amp; <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a5a9f6f2aa16e982c8ab85b4394140755">DiffSolver::DIVERGED_BACKTRACKING_FAILURE</a>;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       <span class="keywordtype">bool</span> max_iterations =
<a name="l00086"></a>00086         solve_result &amp; <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a7161b703163120b21894f1dec0ab6799">DiffSolver::DIVERGED_MAX_NONLINEAR_ITERATIONS</a>;
<a name="l00087"></a>00087         
<a name="l00088"></a>00088       <span class="keywordflow">if</span> (backtracking_failed || max_iterations)
<a name="l00089"></a>00089         {
<a name="l00090"></a>00090           <span class="comment">// Cut timestep in half</span>
<a name="l00091"></a>00091           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nr=0; nr&lt;<a class="code" href="classlibMesh_1_1TimeSolver.php#a9b77957719eae28de2e753d9a99d825e">reduce_deltat_on_diffsolver_failure</a>; ++nr)
<a name="l00092"></a>00092             {
<a name="l00093"></a>00093               <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> *= 0.5;
<a name="l00094"></a>00094               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Newton backtracking failed.  Trying with smaller timestep, dt=&quot;</span>
<a name="l00095"></a>00095                             &lt;&lt; <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> &lt;&lt; std::endl;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097               solve_result = <a class="code" href="classlibMesh_1_1TimeSolver.php#a631a04e1abe9fa20c1216143c590ce66">_diff_solver</a>-&gt;solve();
<a name="l00098"></a>00098 
<a name="l00099"></a>00099               <span class="comment">// Check solve results with reduced timestep</span>
<a name="l00100"></a>00100               <span class="keywordtype">bool</span> backtracking_failed =
<a name="l00101"></a>00101                 solve_result &amp; DiffSolver::DIVERGED_BACKTRACKING_FAILURE;
<a name="l00102"></a>00102               
<a name="l00103"></a>00103               <span class="keywordtype">bool</span> max_iterations =
<a name="l00104"></a>00104                 solve_result &amp; DiffSolver::DIVERGED_MAX_NONLINEAR_ITERATIONS;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106               <span class="keywordflow">if</span> (!backtracking_failed &amp;&amp; !max_iterations)
<a name="l00107"></a>00107                 {
<a name="l00108"></a>00108                   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TimeSolver.php#af0dff23f37925276a226b06b6f78c136">quiet</a>)
<a name="l00109"></a>00109                     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reduced dt solve succeeded.&quot;</span> &lt;&lt; std::endl;
<a name="l00110"></a>00110                   <span class="keywordflow">return</span>;
<a name="l00111"></a>00111                 }
<a name="l00112"></a>00112             }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114           <span class="comment">// If we made it here, we still couldn&#39;t converge the solve after</span>
<a name="l00115"></a>00115           <span class="comment">// reducing deltat</span>
<a name="l00116"></a>00116           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;DiffSolver::solve() did not succeed after &quot;</span>
<a name="l00117"></a>00117                         &lt;&lt; reduce_deltat_on_diffsolver_failure
<a name="l00118"></a>00118                         &lt;&lt; <span class="stringliteral">&quot; attempts.&quot;</span> &lt;&lt; std::endl;
<a name="l00119"></a>00119           libmesh_convergence_failure();
<a name="l00120"></a>00120           
<a name="l00121"></a>00121         } <span class="comment">// end if (backtracking_failed || max_iterations)</span>
<a name="l00122"></a>00122     } <span class="comment">// end if (reduce_deltat_on_diffsolver_failure)</span>
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#a8994bb489d6f17a0288518679a21c53a">00127</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a8994bb489d6f17a0288518679a21c53a">UnsteadySolver::advance_timestep</a> ()
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a> =
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;nonlinear_solution =
<a name="l00132"></a>00132     *(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   old_nonlinear_solution = nonlinear_solution;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">first_solve</a>)
<a name="l00137"></a>00137     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">time</a> += <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">00142</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">UnsteadySolver::old_nonlinear_solution</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number)<span class="keyword"></span>
<a name="l00143"></a>00143 <span class="keyword">const</span>
<a name="l00144"></a>00144 <span class="keyword"></span>{
<a name="l00145"></a>00145   libmesh_assert (global_dof_number &lt; <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">n_dofs</a>());
<a name="l00146"></a>00146   libmesh_assert (global_dof_number &lt; old_local_nonlinear_solution-&gt;size());
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>)(global_dof_number);
<a name="l00149"></a>00149 }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#a9074bd95d19b607d6674f3df3bba52e5">00153</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a9074bd95d19b607d6674f3df3bba52e5">UnsteadySolver::du</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;norm)<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword"></span>{
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; solution_copy =
<a name="l00157"></a>00157     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;clone();
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   solution_copy-&gt;add(-1., <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>));
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   solution_copy-&gt;close();
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(*solution_copy, norm);
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
