<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">unsteady_solver.h</div>  </div>
</div>
<div class="contents">
<a href="unsteady__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unsteady_solver.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __unsteady_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __unsteady_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>UnsteadySolver;
<a name="l00038"></a>00038 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// UnsteadySolver class definition</span>
<a name="l00055"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a018eeeb96c635ea1049a2b2c4c001b1f">UnsteadySolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00063"></a>00063   
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a0c86b7b35fac2818527530fd6f75eee4">~UnsteadySolver</a> ();
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#abc5f1a243458ac055e72526043a0622d">init</a> ();
<a name="l00074"></a>00074 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#aa0323d5265ad992433fcb623a2e6da41">solve</a> ();
<a name="l00081"></a>00081 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a8994bb489d6f17a0288518679a21c53a">advance_timestep</a> ();
<a name="l00089"></a>00089 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a54a7e63ce7ae0e82f983886661ccecbf">error_order</a> () <span class="keyword">const</span> = 0;
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof_number) <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">00108</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>;
<a name="l00109"></a>00109 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a9074bd95d19b607d6674f3df3bba52e5">du</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>&amp; norm) <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#a255496eda735c0e81f76ad459fadf99f">00124</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#a255496eda735c0e81f76ad459fadf99f">is_steady</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="keyword">protected</span>:
<a name="l00127"></a>00127 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">00132</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">first_solve</a>;
<a name="l00133"></a>00133 };
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 } <span class="comment">// namespace libMesh</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif // #define __time_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
