<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">unstructured_mesh.h</div>  </div>
</div>
<div class="contents">
<a href="unstructured__mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unstructured_mesh.h 4362 2011-04-19 14:50:30Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __unstructured_mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __unstructured_mesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span>MeshData;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// UnstructuredMesh class definition</span>
<a name="l00052"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054  <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a15d8ad28c2d15f3b1075618c309a848d">UnstructuredMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim=1);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#ae79b5e964be73d1c1fd3ec8a99d07517">~UnstructuredMesh</a>();
<a name="l00067"></a>00067 
<a name="l00078"></a>00078   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a66e2824ed094296417d15205ea998a71">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00079"></a>00079              <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data=NULL,
<a name="l00080"></a>00080              <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements=<span class="keyword">false</span>);
<a name="l00089"></a>00089   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a7a7b9ff3b911b0037c514f31e429c79f">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00090"></a>00090               <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data=NULL);
<a name="l00091"></a>00091   
<a name="l00096"></a>00096   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a7a7b9ff3b911b0037c514f31e429c79f">write</a> (<span class="keyword">const</span> std::string&amp; name,
<a name="l00097"></a>00097               <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values,
<a name="l00098"></a>00098               <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; variable_names);
<a name="l00099"></a>00099 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#ab6de572c3a2499e34361e819c405dedc">all_first_order</a> ();
<a name="l00107"></a>00107 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#adf74c2d3201889fe61af362800538680">all_second_order</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered=<span class="keyword">true</span>);
<a name="l00120"></a>00120   
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#acaadcec9f9d14add2168c369eef4b233">create_pid_mesh</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; pid_mesh,
<a name="l00128"></a>00128                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid) <span class="keyword">const</span>;
<a name="l00129"></a>00129   
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a3ee9cbc4df033089f9d202e7244173d2">create_submesh</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; new_mesh,
<a name="l00136"></a>00136                        <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it,
<a name="l00137"></a>00137                        <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>&amp; it_end) <span class="keyword">const</span>;
<a name="l00138"></a>00138   
<a name="l00139"></a>00139 
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">copy_nodes_and_elements</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh);  
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a341e57f0c00d50bf885a10fbd6bcb903">find_neighbors</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> reset_remote_elements = <span class="keyword">false</span>,
<a name="l00151"></a>00151                                <span class="keyword">const</span> <span class="keywordtype">bool</span> reset_current_list    = <span class="keyword">true</span>);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>
<a name="l00159"></a>00159   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a47fd892108fd672f5d7c5ccd117fee31">contract</a> ();
<a name="l00160"></a>00160 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00162"></a>00162 };
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 } <span class="comment">// namespace libMesh</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
