<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">unv_io.C</div>  </div>
</div>
<div class="contents">
<a href="unv__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unv_io.C 4195 2011-02-09 17:04:17Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstdio&gt;</span>   <span class="comment">// for std::sprintf</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="unv__io_8h.php">unv_io.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__data_8h.php">mesh_data.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="face__quad8_8h.php">face_quad8.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="face__quad9_8h.php">face_quad9.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex8_8h.php">cell_hex8.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex20_8h.php">cell_hex20.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet10_8h.php">cell_tet10.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism6_8h.php">cell_prism6.h</a>&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor"># include &quot;gzstream.h&quot;</span> <span class="comment">// For reading/writing compressed streams</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">namespace </span>libMesh
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="comment">//-----------------------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// UNVIO class static members</span>
<a name="l00057"></a>00057 <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">UNVIO::_label_dataset_nodes</a>    = <span class="stringliteral">&quot;2411&quot;</span>;
<a name="l00058"></a>00058 <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">UNVIO::_label_dataset_elements</a> = <span class="stringliteral">&quot;2412&quot;</span>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00063"></a>00063 <span class="comment">// UNVIO class members</span>
<a name="l00064"></a><a class="code" href="classlibMesh_1_1UNVIO.php#ad7630b487339fa82cfcc919899797dda">00064</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#ad7630b487339fa82cfcc919899797dda">UNVIO::clear</a> ()
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <span class="comment">/*</span>
<a name="l00067"></a>00067 <span class="comment">   * Initialize these to dummy values</span>
<a name="l00068"></a>00068 <span class="comment">   */</span>
<a name="l00069"></a>00069   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>     = 0;
<a name="l00070"></a>00070   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a>  = 0;
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">_need_D_to_e</a> = <span class="keyword">true</span>;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.clear();
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a8b768d76871a9c094f22b351e03d09ce">_ds_position</a>.clear();
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a66258f5a1d703e345d3f3d824a0e6a01">00081</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a66258f5a1d703e345d3f3d824a0e6a01">UNVIO::read</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>      
<a name="l00087"></a>00087       igzstream in_stream (file_name.c_str());
<a name="l00088"></a>00088       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#aab1c8512d0bc0de87e6897d20f5e9e54">read_implementation</a> (in_stream);
<a name="l00089"></a>00089       
<a name="l00090"></a>00090 <span class="preprocessor">#else</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>      
<a name="l00092"></a>00092       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00093"></a>00093                     &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00094"></a>00094                     &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00095"></a>00095                     &lt;&lt; std::endl;
<a name="l00096"></a>00096       libmesh_error();
<a name="l00097"></a>00097       
<a name="l00098"></a>00098 <span class="preprocessor">#endif</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span>      <span class="keywordflow">return</span>;      
<a name="l00100"></a>00100     }
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="keywordflow">else</span>
<a name="l00103"></a>00103     {
<a name="l00104"></a>00104       std::ifstream in_stream (file_name.c_str());
<a name="l00105"></a>00105       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#aab1c8512d0bc0de87e6897d20f5e9e54">read_implementation</a> (in_stream);
<a name="l00106"></a>00106       <span class="keywordflow">return</span>;
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1UNVIO.php#aab1c8512d0bc0de87e6897d20f5e9e54">00111</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#aab1c8512d0bc0de87e6897d20f5e9e54">UNVIO::read_implementation</a> (std::istream&amp; in_stream)
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113   <span class="comment">// clear everything, so that</span>
<a name="l00114"></a>00114   <span class="comment">// we can start from scratch</span>
<a name="l00115"></a>00115   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ad7630b487339fa82cfcc919899797dda">clear</a> ();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// Keep track of what kinds of elements this file contains</span>
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.clear();
<a name="l00119"></a>00119   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.resize(4, <span class="keyword">false</span>);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121    <span class="comment">// Note that we read this file</span>
<a name="l00122"></a>00122    <span class="comment">// @e twice.  First time to</span>
<a name="l00123"></a>00123    <span class="comment">// detect the number of nodes</span>
<a name="l00124"></a>00124    <span class="comment">// and elements (and possible</span>
<a name="l00125"></a>00125    <span class="comment">// conversion tasks like D_to_e)</span>
<a name="l00126"></a>00126    <span class="comment">// and the order of datasets</span>
<a name="l00127"></a>00127    <span class="comment">// (nodes first, then elements,</span>
<a name="l00128"></a>00128    <span class="comment">// or the other way around),</span>
<a name="l00129"></a>00129    <span class="comment">// and second to do the actual</span>
<a name="l00130"></a>00130    <span class="comment">// read.</span>
<a name="l00131"></a>00131   std::vector&lt;std::string&gt; order_of_datasets;
<a name="l00132"></a>00132   order_of_datasets.reserve(2);
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   {
<a name="l00135"></a>00135     <span class="comment">// the first time we read the file,</span>
<a name="l00136"></a>00136     <span class="comment">// merely to obtain overall info</span>
<a name="l00137"></a>00137     <span class="keywordflow">if</span> ( !in_stream.good() )
<a name="l00138"></a>00138       {
<a name="l00139"></a>00139         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Input file not good.&quot;</span> 
<a name="l00140"></a>00140                       &lt;&lt; std::endl;
<a name="l00141"></a>00141         libmesh_error();
<a name="l00142"></a>00142       }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     
<a name="l00145"></a>00145     <span class="comment">// Count nodes and elements, then let </span>
<a name="l00146"></a>00146     <span class="comment">// other methods read the element and </span>
<a name="l00147"></a>00147     <span class="comment">// node data.  Also remember which</span>
<a name="l00148"></a>00148     <span class="comment">// dataset comes first: nodes or elements</span>
<a name="l00149"></a>00149     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00150"></a>00150       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Counting nodes and elements&quot;</span> &lt;&lt; std::endl;
<a name="l00151"></a>00151     
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="comment">//    bool reached_eof = false;</span>
<a name="l00154"></a>00154     <span class="keywordtype">bool</span> found_node  = <span class="keyword">false</span>;
<a name="l00155"></a>00155     <span class="keywordtype">bool</span> found_elem  = <span class="keyword">false</span>;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     std::string olds, news;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160     <span class="keywordflow">while</span> (in_stream.good())
<a name="l00161"></a>00161       {
<a name="l00162"></a>00162         in_stream &gt;&gt; olds &gt;&gt; news;
<a name="l00163"></a>00163         
<a name="l00164"></a>00164         <span class="comment">// a &quot;-1&quot; followed by a number means the beginning of a dataset</span>
<a name="l00165"></a>00165         <span class="comment">// stop combing at the end of the file</span>
<a name="l00166"></a>00166         <span class="keywordflow">while</span> ( ((olds != <span class="stringliteral">&quot;-1&quot;</span>) || (news == <span class="stringliteral">&quot;-1&quot;</span>) ) &amp;&amp; !in_stream.eof() )
<a name="l00167"></a>00167           {       
<a name="l00168"></a>00168             olds = news;
<a name="l00169"></a>00169             in_stream &gt;&gt; news;
<a name="l00170"></a>00170           }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="comment">//      if (in_stream.eof())</span>
<a name="l00173"></a>00173 <span class="comment">//        {</span>
<a name="l00174"></a>00174 <span class="comment">//          reached_eof = true;</span>
<a name="l00175"></a>00175 <span class="comment">//          break;</span>
<a name="l00176"></a>00176 <span class="comment">//        }</span>
<a name="l00177"></a>00177 
<a name="l00178"></a>00178         
<a name="l00179"></a>00179         <span class="comment">// if beginning of dataset, buffer it in</span>
<a name="l00180"></a>00180         <span class="comment">// temp_buffer, if desired</span>
<a name="l00181"></a>00181         <span class="keywordflow">if</span> (news == <a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">_label_dataset_nodes</a>)
<a name="l00182"></a>00182           {
<a name="l00183"></a>00183             found_node = <span class="keyword">true</span>;
<a name="l00184"></a>00184             order_of_datasets.push_back (<a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">_label_dataset_nodes</a>);
<a name="l00185"></a>00185             this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a6a9eed76be876b4ecea672983b05ffe9">count_nodes</a> (in_stream);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187             <span class="comment">// we can save some time scanning the file</span>
<a name="l00188"></a>00188             <span class="comment">// when we know we already have everything</span>
<a name="l00189"></a>00189             <span class="comment">// we want</span>
<a name="l00190"></a>00190             <span class="keywordflow">if</span> (found_elem)
<a name="l00191"></a>00191               <span class="keywordflow">break</span>;
<a name="l00192"></a>00192           }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (news == <a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">_label_dataset_elements</a>)
<a name="l00195"></a>00195           {
<a name="l00196"></a>00196             found_elem = <span class="keyword">true</span>;
<a name="l00197"></a>00197             order_of_datasets.push_back (<a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">_label_dataset_elements</a>);
<a name="l00198"></a>00198             this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2fb79162c368a835190cf36e21d9e757">count_elements</a> (in_stream);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200             <span class="comment">// we can save some time scanning the file</span>
<a name="l00201"></a>00201             <span class="comment">// when we know we already have everything</span>
<a name="l00202"></a>00202             <span class="comment">// we want</span>
<a name="l00203"></a>00203             <span class="keywordflow">if</span> (found_node)
<a name="l00204"></a>00204               <span class="keywordflow">break</span>;
<a name="l00205"></a>00205           }
<a name="l00206"></a>00206       }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     <span class="comment">// Here we should better have found</span>
<a name="l00210"></a>00210     <span class="comment">// the datasets for nodes and elements,</span>
<a name="l00211"></a>00211     <span class="comment">// otherwise the unv files is bad!</span>
<a name="l00212"></a>00212     <span class="keywordflow">if</span> (!found_elem)
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find elements!&quot;</span> &lt;&lt; std::endl;
<a name="l00215"></a>00215         libmesh_error();
<a name="l00216"></a>00216       }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     <span class="keywordflow">if</span> (!found_node)
<a name="l00219"></a>00219       {
<a name="l00220"></a>00220         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find nodes!&quot;</span> &lt;&lt; std::endl;
<a name="l00221"></a>00221         libmesh_error();
<a name="l00222"></a>00222       }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225     <span class="comment">// Don&#39;t close, just seek to the beginning</span>
<a name="l00226"></a>00226     in_stream.seekg(0, std::ios::beg);
<a name="l00227"></a>00227     
<a name="l00228"></a>00228     <span class="keywordflow">if</span> (!in_stream.good() )
<a name="l00229"></a>00229       {
<a name="l00230"></a>00230         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Cannot re-read input file.&quot;</span> 
<a name="l00231"></a>00231                       &lt;&lt; std::endl;
<a name="l00232"></a>00232         libmesh_error();
<a name="l00233"></a>00233       }
<a name="l00234"></a>00234   }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">// We finished scanning the file,</span>
<a name="l00241"></a>00241   <span class="comment">// and our member data </span>
<a name="l00242"></a>00242   <span class="comment">// \p this-&gt;_n_nodes,</span>
<a name="l00243"></a>00243   <span class="comment">// \p this-&gt;_n_elements,</span>
<a name="l00244"></a>00244   <span class="comment">// \p this-&gt;_need_D_to_e</span>
<a name="l00245"></a>00245   <span class="comment">// should be properly initialized.</span>
<a name="l00246"></a>00246   {
<a name="l00247"></a>00247     <span class="comment">// Read the datasets in the order that</span>
<a name="l00248"></a>00248     <span class="comment">// we already know</span>
<a name="l00249"></a>00249     libmesh_assert (order_of_datasets.size()==2);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ds=0; ds &lt; order_of_datasets.size(); ds++)
<a name="l00252"></a>00252       {
<a name="l00253"></a>00253         <span class="keywordflow">if</span> (order_of_datasets[ds] == <a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">_label_dataset_nodes</a>)
<a name="l00254"></a>00254           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#acc120086cc1194bbcabe50b6c0a808b2">node_in</a>    (in_stream);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (order_of_datasets[ds] == <a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">_label_dataset_elements</a>)
<a name="l00257"></a>00257           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#afec425506c340cceca0bcfb8f1766d04">element_in</a> (in_stream);
<a name="l00258"></a>00258 
<a name="l00259"></a>00259         <span class="keywordflow">else</span>
<a name="l00260"></a>00260           libmesh_error();
<a name="l00261"></a>00261       }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263     <span class="comment">// Set the mesh dimension to the largest encountered for an element</span>
<a name="l00264"></a>00264     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=4; ++i)
<a name="l00265"></a>00265       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[i])
<a name="l00266"></a>00266         <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(i);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput&lt;MeshBase&gt;::mesh</a>().mesh_dimension() &gt; LIBMESH_DIM)
<a name="l00270"></a>00270       {
<a name="l00271"></a>00271         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Cannot open dimension &quot;</span> &lt;&lt;
<a name="l00272"></a>00272                         <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &lt;&lt;
<a name="l00273"></a>00273                         <span class="stringliteral">&quot; mesh file when configured without &quot;</span> &lt;&lt;
<a name="l00274"></a>00274                         <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &lt;&lt; <span class="stringliteral">&quot;D support.&quot;</span> &lt;&lt;
<a name="l00275"></a>00275                         std::endl;
<a name="l00276"></a>00276         libmesh_error();
<a name="l00277"></a>00277       }
<a name="l00278"></a>00278 <span class="preprocessor">#endif</span>
<a name="l00279"></a>00279 <span class="preprocessor"></span>
<a name="l00280"></a>00280     <span class="comment">// tell the MeshData object that we are finished </span>
<a name="l00281"></a>00281     <span class="comment">// reading data</span>
<a name="l00282"></a>00282     this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a9d18d3adfdf70d79d8c48aaec35f7145">close_foreign_id_maps</a> ();
<a name="l00283"></a>00283 
<a name="l00284"></a>00284     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00285"></a>00285       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Finished.&quot;</span> &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287   
<a name="l00288"></a>00288   <span class="comment">// save memory</span>
<a name="l00289"></a>00289   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.clear();
<a name="l00290"></a>00290   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a8b768d76871a9c094f22b351e03d09ce">_ds_position</a>.clear();
<a name="l00291"></a>00291 }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a><a class="code" href="classlibMesh_1_1UNVIO.php#adf786fd5f78f0edc656d5cfe628241de">00297</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#adf786fd5f78f0edc656d5cfe628241de">UNVIO::write</a> (<span class="keyword">const</span> std::string&amp; file_name)
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   <span class="keywordflow">if</span> (file_name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>) &lt; file_name.size())
<a name="l00300"></a>00300     {
<a name="l00301"></a>00301 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00302"></a>00302 <span class="preprocessor"></span>      
<a name="l00303"></a>00303       ogzstream out_stream(file_name.c_str());
<a name="l00304"></a>00304       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#aa680a6e763c89ebe09041e53a4cf54e3">write_implementation</a> (out_stream);
<a name="l00305"></a>00305       
<a name="l00306"></a>00306 <span class="preprocessor">#else</span>
<a name="l00307"></a>00307 <span class="preprocessor"></span>      
<a name="l00308"></a>00308       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  You must have the zlib.h header &quot;</span>
<a name="l00309"></a>00309                     &lt;&lt; <span class="stringliteral">&quot;files and libraries to read and write &quot;</span>
<a name="l00310"></a>00310                     &lt;&lt; <span class="stringliteral">&quot;compressed streams.&quot;</span>
<a name="l00311"></a>00311                     &lt;&lt; std::endl;
<a name="l00312"></a>00312       libmesh_error();
<a name="l00313"></a>00313       
<a name="l00314"></a>00314 <span class="preprocessor">#endif</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span>      
<a name="l00316"></a>00316       <span class="keywordflow">return</span>;      
<a name="l00317"></a>00317     }
<a name="l00318"></a>00318   
<a name="l00319"></a>00319   <span class="keywordflow">else</span>
<a name="l00320"></a>00320     {
<a name="l00321"></a>00321       std::ofstream out_stream (file_name.c_str());
<a name="l00322"></a>00322       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#aa680a6e763c89ebe09041e53a4cf54e3">write_implementation</a> (out_stream);
<a name="l00323"></a>00323       <span class="keywordflow">return</span>;
<a name="l00324"></a>00324     }
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a><a class="code" href="classlibMesh_1_1UNVIO.php#aa680a6e763c89ebe09041e53a4cf54e3">00330</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#aa680a6e763c89ebe09041e53a4cf54e3">UNVIO::write_implementation</a> (std::ostream&amp; out_file)
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="keywordflow">if</span> ( !out_file.good() )
<a name="l00333"></a>00333     {
<a name="l00334"></a>00334       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Output file not good.&quot;</span> 
<a name="l00335"></a>00335                     &lt;&lt; std::endl;
<a name="l00336"></a>00336       libmesh_error();
<a name="l00337"></a>00337     }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   <span class="comment">// already know these data, so initialize</span>
<a name="l00343"></a>00343   <span class="comment">// them.  Does not hurt.</span>
<a name="l00344"></a>00344   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>      = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00345"></a>00345   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a>   = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00346"></a>00346   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">_need_D_to_e</a>  = <span class="keyword">false</span>;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349  
<a name="l00350"></a>00350   <span class="comment">// we need the MeshData, otherwise we do not</span>
<a name="l00351"></a>00351   <span class="comment">// know the foreign node id</span>
<a name="l00352"></a>00352   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a>())
<a name="l00353"></a>00353     <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>())
<a name="l00354"></a>00354       {
<a name="l00355"></a>00355         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; std::endl
<a name="l00356"></a>00356           &lt;&lt; <span class="stringliteral">&quot;*************************************************************************&quot;</span> &lt;&lt; std::endl
<a name="l00357"></a>00357           &lt;&lt; <span class="stringliteral">&quot;* WARNING: MeshData neither active nor in compatibility mode.           *&quot;</span> &lt;&lt; std::endl
<a name="l00358"></a>00358           &lt;&lt; <span class="stringliteral">&quot;*          Enable compatibility mode for MeshData.  Use this Universal  *&quot;</span> &lt;&lt; std::endl
<a name="l00359"></a>00359           &lt;&lt; <span class="stringliteral">&quot;*          file with caution: libMesh node and element ids are used.    *&quot;</span> &lt;&lt; std::endl
<a name="l00360"></a>00360           &lt;&lt; <span class="stringliteral">&quot;*************************************************************************&quot;</span> &lt;&lt; std::endl
<a name="l00361"></a>00361           &lt;&lt; std::endl;
<a name="l00362"></a>00362         this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a3e1a2ffd0b28624afa10d5a7c436d9e0">enable_compatibility_mode</a>();
<a name="l00363"></a>00363       }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367   <span class="comment">// write the nodes,  then the elements</span>
<a name="l00368"></a>00368   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ae302f8983fb88071d534effc4a156d08">node_out</a>    (out_file);
<a name="l00369"></a>00369   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a54de35003f4a4398a0c6b30abbed26cf">element_out</a> (out_file);
<a name="l00370"></a>00370 }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a6a9eed76be876b4ecea672983b05ffe9">00376</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a6a9eed76be876b4ecea672983b05ffe9">UNVIO::count_nodes</a> (std::istream&amp; in_file)
<a name="l00377"></a>00377 {
<a name="l00378"></a>00378   START_LOG(<span class="stringliteral">&quot;count_nodes()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="comment">// if this-&gt;_n_nodes is not 0 the dataset </span>
<a name="l00381"></a>00381   <span class="comment">// has already been scanned</span>
<a name="l00382"></a>00382   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a> != 0)
<a name="l00383"></a>00383     {
<a name="l00384"></a>00384       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Trying to scan nodes twice!&quot;</span> 
<a name="l00385"></a>00385                     &lt;&lt; std::endl;
<a name="l00386"></a>00386       libmesh_error();
<a name="l00387"></a>00387     }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// Read from file, count nodes,</span>
<a name="l00391"></a>00391   <span class="comment">// check if floats have to be converted</span>
<a name="l00392"></a>00392   std::string data;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   in_file &gt;&gt; data; <span class="comment">// read the first node label</span>
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="keywordflow">if</span> (data == <span class="stringliteral">&quot;-1&quot;</span>)
<a name="l00398"></a>00398     {
<a name="l00399"></a>00399       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad, already reached end of dataset before even starting to read nodes!&quot;</span>
<a name="l00400"></a>00400                     &lt;&lt; std::endl;
<a name="l00401"></a>00401       libmesh_error();
<a name="l00402"></a>00402     }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404  
<a name="l00405"></a>00405   <span class="comment">// ignore the misc data for this node</span>
<a name="l00406"></a>00406   in_file.ignore(256,<span class="charliteral">&#39;\n&#39;</span>);           
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   
<a name="l00410"></a>00410   <span class="comment">// Now we are there to verify whether we need</span>
<a name="l00411"></a>00411   <span class="comment">// to convert from D to e or not</span>
<a name="l00412"></a>00412   in_file &gt;&gt; data;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">// When this &quot;data&quot; contains a &quot;D&quot;, then</span>
<a name="l00415"></a>00415   <span class="comment">// we have to convert each and every float...</span>
<a name="l00416"></a>00416   <span class="comment">// But also assume when _this_ specific</span>
<a name="l00417"></a>00417   <span class="comment">// line does not contain a &quot;D&quot;, then the</span>
<a name="l00418"></a>00418   <span class="comment">// other lines won&#39;t, too.</span>
<a name="l00419"></a>00419   {
<a name="l00420"></a>00420 <span class="comment">// #ifdef __HP_aCC</span>
<a name="l00421"></a>00421 <span class="comment">//     // Use an &quot;int&quot; instead of unsigned int,</span>
<a name="l00422"></a>00422 <span class="comment">//     // otherwise HP aCC may crash!</span>
<a name="l00423"></a>00423 <span class="comment">//     const int position          = data.find(&quot;D&quot;,6);</span>
<a name="l00424"></a>00424 <span class="comment">// #else</span>
<a name="l00425"></a>00425 <span class="comment">//     const unsigned int position = data.find(&quot;D&quot;,6);</span>
<a name="l00426"></a>00426 <span class="comment">// #endif</span>
<a name="l00427"></a>00427     std::string::size_type position = data.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00428"></a>00428 
<a name="l00429"></a>00429     <span class="keywordflow">if</span> (position!=std::string::npos) <span class="comment">// npos means no position</span>
<a name="l00430"></a>00430       {
<a name="l00431"></a>00431         this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">_need_D_to_e</a> = <span class="keyword">true</span>;
<a name="l00432"></a>00432         
<a name="l00433"></a>00433         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00434"></a>00434           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Convert from \&quot;D\&quot; to \&quot;e\&quot;&quot;</span> &lt;&lt; std::endl;
<a name="l00435"></a>00435       }
<a name="l00436"></a>00436     <span class="keywordflow">else</span>
<a name="l00437"></a>00437       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">_need_D_to_e</a> = <span class="keyword">false</span>;
<a name="l00438"></a>00438   }
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="comment">// read the remaining two coordinates</span>
<a name="l00441"></a>00441   in_file &gt;&gt; data;
<a name="l00442"></a>00442   in_file &gt;&gt; data;
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">// this was our first node</span>
<a name="l00446"></a>00446   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>++;
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <span class="comment">// proceed _counting_ the remaining</span>
<a name="l00451"></a>00451   <span class="comment">// nodes.</span>
<a name="l00452"></a>00452   <span class="keywordflow">while</span> (in_file.good())
<a name="l00453"></a>00453     {
<a name="l00454"></a>00454       <span class="comment">// read the node label</span>
<a name="l00455"></a>00455       in_file &gt;&gt; data; 
<a name="l00456"></a>00456                 
<a name="l00457"></a>00457       <span class="keywordflow">if</span> (data == <span class="stringliteral">&quot;-1&quot;</span>)
<a name="l00458"></a>00458         <span class="comment">// end of dataset is reached</span>
<a name="l00459"></a>00459         <span class="keywordflow">break</span>;
<a name="l00460"></a>00460       
<a name="l00461"></a>00461       <span class="comment">// ignore the remaining data (coord_sys_label, color etc)</span>
<a name="l00462"></a>00462       in_file.ignore (256, <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00463"></a>00463       <span class="comment">// ignore the coordinates</span>
<a name="l00464"></a>00464       in_file.ignore (256, <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>++;
<a name="l00467"></a>00467     }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="keywordflow">if</span> (in_file.eof())
<a name="l00471"></a>00471     {
<a name="l00472"></a>00472       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: File ended before end of node dataset!&quot;</span>
<a name="l00473"></a>00473                     &lt;&lt; std::endl;
<a name="l00474"></a>00474       libmesh_error();
<a name="l00475"></a>00475     }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00478"></a>00478     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nodes   : &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a> &lt;&lt; std::endl;
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   STOP_LOG(<span class="stringliteral">&quot;count_nodes()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00481"></a>00481 }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a2fb79162c368a835190cf36e21d9e757">00488</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a2fb79162c368a835190cf36e21d9e757">UNVIO::count_elements</a> (std::istream&amp; in_file)
<a name="l00489"></a>00489 {
<a name="l00490"></a>00490   START_LOG(<span class="stringliteral">&quot;count_elements()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a> != 0)
<a name="l00493"></a>00493     {
<a name="l00494"></a>00494       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Trying to scan elements twice!&quot;</span> 
<a name="l00495"></a>00495                     &lt;&lt; std::endl;
<a name="l00496"></a>00496       libmesh_error();
<a name="l00497"></a>00497     }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// Simply read the element</span>
<a name="l00501"></a>00501   <span class="comment">// dataset for the @e only</span>
<a name="l00502"></a>00502   <span class="comment">// purpose to count nodes!</span>
<a name="l00503"></a>00503   
<a name="l00504"></a>00504   std::string data;
<a name="l00505"></a>00505   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fe_id;
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   <span class="keywordflow">while</span> (!in_file.eof())
<a name="l00508"></a>00508     {
<a name="l00509"></a>00509       <span class="comment">// read element label</span>
<a name="l00510"></a>00510       in_file &gt;&gt; data;
<a name="l00511"></a>00511       
<a name="l00512"></a>00512       <span class="comment">// end of dataset?</span>
<a name="l00513"></a>00513       <span class="keywordflow">if</span> (data == <span class="stringliteral">&quot;-1&quot;</span>) 
<a name="l00514"></a>00514         <span class="keywordflow">break</span>;
<a name="l00515"></a>00515         
<a name="l00516"></a>00516       <span class="comment">// read fe_id</span>
<a name="l00517"></a>00517       in_file &gt;&gt; fe_id;
<a name="l00518"></a>00518 
<a name="l00519"></a>00519       <span class="comment">// Skip related data,</span>
<a name="l00520"></a>00520       <span class="comment">// and node number list</span>
<a name="l00521"></a>00521       in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00522"></a>00522       in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524       <span class="comment">// For some elements the node numbers</span>
<a name="l00525"></a>00525       <span class="comment">// are given more than one record</span>
<a name="l00526"></a>00526 
<a name="l00527"></a>00527       <span class="comment">// TET10 or QUAD9</span>
<a name="l00528"></a>00528       <span class="keywordflow">if</span> (fe_id == 118 || fe_id == 300)
<a name="l00529"></a>00529           in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00530"></a>00530 
<a name="l00531"></a>00531       <span class="comment">// HEX20</span>
<a name="l00532"></a>00532       <span class="keywordflow">if</span> (fe_id == 116)
<a name="l00533"></a>00533         {
<a name="l00534"></a>00534           in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00535"></a>00535           in_file.ignore (256,<span class="charliteral">&#39;\n&#39;</span>);
<a name="l00536"></a>00536         }
<a name="l00537"></a>00537      
<a name="l00538"></a>00538       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a>++;
<a name="l00539"></a>00539     }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="keywordflow">if</span> (in_file.eof())
<a name="l00543"></a>00543     {
<a name="l00544"></a>00544       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: File ended before end of element dataset!&quot;</span>
<a name="l00545"></a>00545                     &lt;&lt; std::endl;
<a name="l00546"></a>00546       libmesh_error();
<a name="l00547"></a>00547     }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00550"></a>00550     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Elements: &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a> &lt;&lt; std::endl;
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   STOP_LOG(<span class="stringliteral">&quot;count_elements()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00553"></a>00553 }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a><a class="code" href="classlibMesh_1_1UNVIO.php#acc120086cc1194bbcabe50b6c0a808b2">00557</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#acc120086cc1194bbcabe50b6c0a808b2">UNVIO::node_in</a> (std::istream&amp; in_file)
<a name="l00558"></a>00558 {
<a name="l00559"></a>00559   START_LOG(<span class="stringliteral">&quot;node_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00560"></a>00560 
<a name="l00561"></a>00561   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00562"></a>00562     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Reading nodes&quot;</span> &lt;&lt; std::endl;
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <span class="comment">// adjust the \p istream to our position</span>
<a name="l00565"></a>00565   <span class="keyword">const</span> <span class="keywordtype">bool</span> ok = this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a83608b46105917653390bd428bd3f6d9">beginning_of_dataset</a>(in_file, <a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">_label_dataset_nodes</a>);
<a name="l00566"></a>00566 
<a name="l00567"></a>00567   <span class="keywordflow">if</span> (!ok)
<a name="l00568"></a>00568     {
<a name="l00569"></a>00569       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find node dataset!&quot;</span> &lt;&lt; std::endl;
<a name="l00570"></a>00570       libmesh_error();
<a name="l00571"></a>00571     }
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00574"></a>00574   
<a name="l00575"></a>00575   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_lab;           <span class="comment">// label of the node</span>
<a name="l00576"></a>00576   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exp_coord_sys_num,  <span class="comment">// export coordinate system number       (not supported yet)</span>
<a name="l00577"></a>00577                disp_coord_sys_num, <span class="comment">// displacement coordinate system number (not supported yet)</span>
<a name="l00578"></a>00578                color;              <span class="comment">// color                                 (not supported yet)</span>
<a name="l00579"></a>00579 
<a name="l00580"></a>00580   <span class="comment">// allocate the correct amount </span>
<a name="l00581"></a>00581   <span class="comment">// of memory for the node vector</span>
<a name="l00582"></a>00582   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.reserve (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>);
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   <span class="comment">// always 3 coordinates in the UNV file, no matter</span>
<a name="l00586"></a>00586   <span class="comment">// which dimensionality libMesh is in</span>
<a name="l00587"></a>00587   <span class="comment">//std::vector&lt;Real&gt; xyz (3);</span>
<a name="l00588"></a>00588   <a class="code" href="classlibMesh_1_1Point.php">Point</a> xyz;
<a name="l00589"></a>00589       
<a name="l00590"></a>00590   <span class="comment">// depending on whether we have to convert each</span>
<a name="l00591"></a>00591   <span class="comment">// coordinate (float), we offer two versions.</span>
<a name="l00592"></a>00592   <span class="comment">// Note that \p count_nodes() already verified</span>
<a name="l00593"></a>00593   <span class="comment">// whether this file uses &quot;D&quot; of &quot;e&quot;</span>
<a name="l00594"></a>00594   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">_need_D_to_e</a>)
<a name="l00595"></a>00595     {
<a name="l00596"></a>00596       <span class="comment">// ok, convert...</span>
<a name="l00597"></a>00597       std::string num_buf;
<a name="l00598"></a>00598 
<a name="l00599"></a>00599       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>; i++)
<a name="l00600"></a>00600         {
<a name="l00601"></a>00601           libmesh_assert (!in_file.eof());
<a name="l00602"></a>00602 
<a name="l00603"></a>00603           in_file &gt;&gt; node_lab                <span class="comment">// read the node label</span>
<a name="l00604"></a>00604                   &gt;&gt; exp_coord_sys_num       <span class="comment">// (not supported yet)</span>
<a name="l00605"></a>00605                   &gt;&gt; disp_coord_sys_num      <span class="comment">// (not supported yet)</span>
<a name="l00606"></a>00606                   &gt;&gt; color;                  <span class="comment">// (not supported yet)</span>
<a name="l00607"></a>00607 
<a name="l00608"></a>00608           <span class="comment">// take care of the</span>
<a name="l00609"></a>00609           <span class="comment">// floating-point data</span>
<a name="l00610"></a>00610           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;3; d++)
<a name="l00611"></a>00611             {
<a name="l00612"></a>00612               in_file &gt;&gt; num_buf;
<a name="l00613"></a>00613               xyz(d) = this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#afe906e09e5cb3effe5d4f0afe5ccf405">D_to_e</a> (num_buf);
<a name="l00614"></a>00614             }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616           <span class="comment">// set up the id map</span>
<a name="l00617"></a>00617           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.push_back (node_lab);
<a name="l00618"></a>00618           
<a name="l00619"></a>00619           <span class="comment">// add node to the Mesh &amp; </span>
<a name="l00620"></a>00620           <span class="comment">// tell the MeshData object the foreign node id</span>
<a name="l00621"></a>00621           <span class="comment">// (note that mesh.add_point() returns a pointer to the new node)</span>
<a name="l00622"></a>00622           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a42a382455dea188b00e990477439456d">add_foreign_node_id</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>(xyz,i), node_lab);
<a name="l00623"></a>00623         }
<a name="l00624"></a>00624     }
<a name="l00625"></a>00625 
<a name="l00626"></a>00626   <span class="keywordflow">else</span>
<a name="l00627"></a>00627     {
<a name="l00628"></a>00628       <span class="comment">// very well, no need to convert anything,</span>
<a name="l00629"></a>00629       <span class="comment">// just plain import.</span>
<a name="l00630"></a>00630       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0;i&lt;this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>;i++)
<a name="l00631"></a>00631         {
<a name="l00632"></a>00632           libmesh_assert (!in_file.eof());
<a name="l00633"></a>00633 
<a name="l00634"></a>00634           in_file &gt;&gt; node_lab                <span class="comment">// read the node label</span>
<a name="l00635"></a>00635                   &gt;&gt; exp_coord_sys_num       <span class="comment">// (not supported yet)</span>
<a name="l00636"></a>00636                   &gt;&gt; disp_coord_sys_num      <span class="comment">// (not supported yet)</span>
<a name="l00637"></a>00637                   &gt;&gt; color                   <span class="comment">// (not supported yet)</span>
<a name="l00638"></a>00638                   &gt;&gt; xyz(0)                  <span class="comment">// read x-coordinate</span>
<a name="l00639"></a>00639                   &gt;&gt; xyz(1)                  <span class="comment">// read y-coordinate</span>
<a name="l00640"></a>00640                   &gt;&gt; xyz(2);                 <span class="comment">// read z-coordinate</span>
<a name="l00641"></a>00641 
<a name="l00642"></a>00642           <span class="comment">// set up the id map</span>
<a name="l00643"></a>00643           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.push_back (node_lab);
<a name="l00644"></a>00644           
<a name="l00645"></a>00645           <span class="comment">// add node to the Mesh &amp; </span>
<a name="l00646"></a>00646           <span class="comment">// tell the MeshData object the foreign node id</span>
<a name="l00647"></a>00647           <span class="comment">// (note that mesh.add_point() returns a pointer to the new node)</span>
<a name="l00648"></a>00648           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a42a382455dea188b00e990477439456d">add_foreign_node_id</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>(xyz,i), node_lab);
<a name="l00649"></a>00649         }
<a name="l00650"></a>00650     }
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="comment">// now we need to sort the _assign_nodes vector so we can</span>
<a name="l00653"></a>00653   <span class="comment">// search it efficiently like a map</span>
<a name="l00654"></a>00654   std::sort (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.begin(),
<a name="l00655"></a>00655              this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.end());
<a name="l00656"></a>00656 
<a name="l00657"></a>00657   STOP_LOG(<span class="stringliteral">&quot;node_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a><a class="code" href="classlibMesh_1_1UNVIO.php#afec425506c340cceca0bcfb8f1766d04">00664</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#afec425506c340cceca0bcfb8f1766d04">UNVIO::element_in</a> (std::istream&amp; in_file)
<a name="l00665"></a>00665 {
<a name="l00666"></a>00666   START_LOG(<span class="stringliteral">&quot;element_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00669"></a>00669     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Reading elements&quot;</span> &lt;&lt; std::endl;
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">// adjust the \p istream to our</span>
<a name="l00674"></a>00674   <span class="comment">// position</span>
<a name="l00675"></a>00675   <span class="keyword">const</span> <span class="keywordtype">bool</span> ok = this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a83608b46105917653390bd428bd3f6d9">beginning_of_dataset</a>(in_file, <a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">_label_dataset_elements</a>);
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="keywordflow">if</span> (!ok)
<a name="l00678"></a>00678     {
<a name="l00679"></a>00679       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Could not find element dataset!&quot;</span> &lt;&lt; std::endl;
<a name="l00680"></a>00680       libmesh_error();
<a name="l00681"></a>00681     }
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>      element_lab,       <span class="comment">// element label (not supported yet)</span>
<a name="l00685"></a>00685                     <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>;           <span class="comment">// number of nodes on element</span>
<a name="l00686"></a>00686   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> fe_descriptor_id,  <span class="comment">// FE descriptor id</span>
<a name="l00687"></a>00687                     phys_prop_tab_num, <span class="comment">// physical property table number (not supported yet)</span>
<a name="l00688"></a>00688                     mat_prop_tab_num,  <span class="comment">// material property table number (not supported yet)</span>
<a name="l00689"></a>00689                     color;             <span class="comment">// color (not supported yet)</span>
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="comment">// vector that temporarily holds the node labels defining element</span>
<a name="l00693"></a>00693   std::vector&lt;unsigned int&gt; node_labels (21);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="comment">// vector that assigns element nodes to their correct position</span>
<a name="l00697"></a>00697   <span class="comment">// for example:</span>
<a name="l00698"></a>00698   <span class="comment">// 44:plane stress      | QUAD4</span>
<a name="l00699"></a>00699   <span class="comment">// linear quadrilateral |</span>
<a name="l00700"></a>00700   <span class="comment">// position in UNV-file | position in libmesh</span>
<a name="l00701"></a>00701   <span class="comment">// assign_elem_node[1]   = 0</span>
<a name="l00702"></a>00702   <span class="comment">// assign_elem_node[2]   = 3</span>
<a name="l00703"></a>00703   <span class="comment">// assign_elem_node[3]   = 2</span>
<a name="l00704"></a>00704   <span class="comment">// assign_elem_node[4]   = 1</span>
<a name="l00705"></a>00705   <span class="comment">//</span>
<a name="l00706"></a>00706   <span class="comment">// UNV is 1-based, we leave the 0th element of the vectors unused in order</span>
<a name="l00707"></a>00707   <span class="comment">// to prevent confusion, this way we can store elements with up to 20 nodes</span>
<a name="l00708"></a>00708   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assign_elem_nodes[21];
<a name="l00709"></a>00709   
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   <span class="comment">// Get the beginning and end of the _assign_nodes vector</span>
<a name="l00712"></a>00712   <span class="comment">// to eliminate repeated function calls</span>
<a name="l00713"></a>00713   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator it_begin =
<a name="l00714"></a>00714     this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.begin();
<a name="l00715"></a>00715   
<a name="l00716"></a>00716   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator it_end   =
<a name="l00717"></a>00717     this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>.end();
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720       
<a name="l00721"></a>00721   <span class="comment">// read from the virtual file</span>
<a name="l00722"></a>00722   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a>; i++)
<a name="l00723"></a>00723     {
<a name="l00724"></a>00724       in_file &gt;&gt; element_lab             <span class="comment">// read element label</span>
<a name="l00725"></a>00725               &gt;&gt; fe_descriptor_id        <span class="comment">// read FE descriptor id</span>
<a name="l00726"></a>00726               &gt;&gt; phys_prop_tab_num       <span class="comment">// (not supported yet)</span>
<a name="l00727"></a>00727               &gt;&gt; mat_prop_tab_num        <span class="comment">// (not supported yet)</span>
<a name="l00728"></a>00728               &gt;&gt; color                   <span class="comment">// (not supported yet)</span>
<a name="l00729"></a>00729               &gt;&gt; <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>;                <span class="comment">// read number of nodes on element</span>
<a name="l00730"></a>00730 
<a name="l00731"></a>00731       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;=<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; j++)
<a name="l00732"></a>00732         in_file &gt;&gt; node_labels[j];       <span class="comment">// read node labels</span>
<a name="l00733"></a>00733 
<a name="l00734"></a>00734       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;                 <span class="comment">// element pointer</span>
<a name="l00735"></a>00735       
<a name="l00736"></a>00736       <span class="keywordflow">switch</span> (fe_descriptor_id)
<a name="l00737"></a>00737         {
<a name="l00738"></a>00738         
<a name="l00739"></a>00739         <span class="keywordflow">case</span> 41: <span class="comment">// Plane Stress Linear Triangle</span>
<a name="l00740"></a>00740         <span class="keywordflow">case</span> 91: <span class="comment">// Thin Shell   Linear Triangle</span>
<a name="l00741"></a>00741           {
<a name="l00742"></a>00742             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>;  <span class="comment">// create new element</span>
<a name="l00743"></a>00743             
<a name="l00744"></a>00744             assign_elem_nodes[1]=0;
<a name="l00745"></a>00745             assign_elem_nodes[2]=2;
<a name="l00746"></a>00746             assign_elem_nodes[3]=1;
<a name="l00747"></a>00747             <span class="keywordflow">break</span>;
<a name="l00748"></a>00748           }
<a name="l00749"></a>00749         
<a name="l00750"></a>00750         <span class="keywordflow">case</span> 42: <span class="comment">// Plane Stress Quadratic Triangle</span>
<a name="l00751"></a>00751         <span class="keywordflow">case</span> 92: <span class="comment">// Thin Shell   Quadratic Triangle</span>
<a name="l00752"></a>00752           {
<a name="l00753"></a>00753             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>;  <span class="comment">// create new element</span>
<a name="l00754"></a>00754             
<a name="l00755"></a>00755             assign_elem_nodes[1]=0;
<a name="l00756"></a>00756             assign_elem_nodes[2]=5;
<a name="l00757"></a>00757             assign_elem_nodes[3]=2;
<a name="l00758"></a>00758             assign_elem_nodes[4]=4;
<a name="l00759"></a>00759             assign_elem_nodes[5]=1;
<a name="l00760"></a>00760             assign_elem_nodes[6]=3;
<a name="l00761"></a>00761             <span class="keywordflow">break</span>;
<a name="l00762"></a>00762           }
<a name="l00763"></a>00763         
<a name="l00764"></a>00764         <span class="keywordflow">case</span> 43: <span class="comment">// Plane Stress Cubic Triangle</span>
<a name="l00765"></a>00765           {
<a name="l00766"></a>00766             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: UNV-element type 43: Plane Stress Cubic Triangle&quot;</span>
<a name="l00767"></a>00767                           &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00768"></a>00768                           &lt;&lt; std::endl;
<a name="l00769"></a>00769             libmesh_error();        
<a name="l00770"></a>00770             <span class="keywordflow">break</span>;
<a name="l00771"></a>00771           }
<a name="l00772"></a>00772         
<a name="l00773"></a>00773         <span class="keywordflow">case</span> 44: <span class="comment">// Plane Stress Linear Quadrilateral</span>
<a name="l00774"></a>00774         <span class="keywordflow">case</span> 94: <span class="comment">// Thin Shell   Linear Quadrilateral</span>
<a name="l00775"></a>00775           {
<a name="l00776"></a>00776             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>; <span class="comment">// create new element</span>
<a name="l00777"></a>00777             
<a name="l00778"></a>00778             assign_elem_nodes[1]=0;
<a name="l00779"></a>00779             assign_elem_nodes[2]=3;
<a name="l00780"></a>00780             assign_elem_nodes[3]=2;
<a name="l00781"></a>00781             assign_elem_nodes[4]=1;
<a name="l00782"></a>00782             <span class="keywordflow">break</span>;
<a name="l00783"></a>00783           }
<a name="l00784"></a>00784         
<a name="l00785"></a>00785         <span class="keywordflow">case</span> 45: <span class="comment">// Plane Stress Quadratic Quadrilateral</span>
<a name="l00786"></a>00786         <span class="keywordflow">case</span> 95: <span class="comment">// Thin Shell   Quadratic Quadrilateral</span>
<a name="l00787"></a>00787           {
<a name="l00788"></a>00788             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>; <span class="comment">// create new element</span>
<a name="l00789"></a>00789             
<a name="l00790"></a>00790             assign_elem_nodes[1]=0;
<a name="l00791"></a>00791             assign_elem_nodes[2]=7;
<a name="l00792"></a>00792             assign_elem_nodes[3]=3;
<a name="l00793"></a>00793             assign_elem_nodes[4]=6;
<a name="l00794"></a>00794             assign_elem_nodes[5]=2;
<a name="l00795"></a>00795             assign_elem_nodes[6]=5;
<a name="l00796"></a>00796             assign_elem_nodes[7]=1;
<a name="l00797"></a>00797             assign_elem_nodes[8]=4;
<a name="l00798"></a>00798             <span class="keywordflow">break</span>;
<a name="l00799"></a>00799           }
<a name="l00800"></a>00800         
<a name="l00801"></a>00801         <span class="keywordflow">case</span> 300: <span class="comment">// Thin Shell   Quadratic Quadrilateral (nine nodes)</span>
<a name="l00802"></a>00802           {
<a name="l00803"></a>00803             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>; <span class="comment">// create new element</span>
<a name="l00804"></a>00804             
<a name="l00805"></a>00805             assign_elem_nodes[1]=0;
<a name="l00806"></a>00806             assign_elem_nodes[2]=7;
<a name="l00807"></a>00807             assign_elem_nodes[3]=3;
<a name="l00808"></a>00808             assign_elem_nodes[4]=6;
<a name="l00809"></a>00809             assign_elem_nodes[5]=2;
<a name="l00810"></a>00810             assign_elem_nodes[6]=5;
<a name="l00811"></a>00811             assign_elem_nodes[7]=1;
<a name="l00812"></a>00812             assign_elem_nodes[8]=4;
<a name="l00813"></a>00813             assign_elem_nodes[9]=8;
<a name="l00814"></a>00814             <span class="keywordflow">break</span>;
<a name="l00815"></a>00815           }
<a name="l00816"></a>00816         
<a name="l00817"></a>00817         <span class="keywordflow">case</span> 46: <span class="comment">// Plane Stress Cubic Quadrilateral</span>
<a name="l00818"></a>00818           {
<a name="l00819"></a>00819             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: UNV-element type 46: Plane Stress Cubic Quadrilateral&quot;</span>
<a name="l00820"></a>00820                           &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00821"></a>00821                           &lt;&lt; std::endl;
<a name="l00822"></a>00822             libmesh_error();
<a name="l00823"></a>00823             <span class="keywordflow">break</span>;
<a name="l00824"></a>00824           }
<a name="l00825"></a>00825         
<a name="l00826"></a>00826         <span class="keywordflow">case</span> 111: <span class="comment">// Solid Linear Tetrahedron</span>
<a name="l00827"></a>00827           {
<a name="l00828"></a>00828             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a>;  <span class="comment">// create new element</span>
<a name="l00829"></a>00829             
<a name="l00830"></a>00830             assign_elem_nodes[1]=0;
<a name="l00831"></a>00831             assign_elem_nodes[2]=1;
<a name="l00832"></a>00832             assign_elem_nodes[3]=2;
<a name="l00833"></a>00833             assign_elem_nodes[4]=3;
<a name="l00834"></a>00834             <span class="keywordflow">break</span>;
<a name="l00835"></a>00835           }
<a name="l00836"></a>00836 
<a name="l00837"></a>00837         <span class="keywordflow">case</span> 112: <span class="comment">// Solid Linear Prism</span>
<a name="l00838"></a>00838           {
<a name="l00839"></a>00839             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism6.php">Prism6</a>;  <span class="comment">// create new element</span>
<a name="l00840"></a>00840             
<a name="l00841"></a>00841             assign_elem_nodes[1]=0;
<a name="l00842"></a>00842             assign_elem_nodes[2]=1;
<a name="l00843"></a>00843             assign_elem_nodes[3]=2;
<a name="l00844"></a>00844             assign_elem_nodes[4]=3;
<a name="l00845"></a>00845             assign_elem_nodes[5]=4;
<a name="l00846"></a>00846             assign_elem_nodes[6]=5;
<a name="l00847"></a>00847             <span class="keywordflow">break</span>;
<a name="l00848"></a>00848           }
<a name="l00849"></a>00849         
<a name="l00850"></a>00850         <span class="keywordflow">case</span> 115: <span class="comment">// Solid Linear Brick</span>
<a name="l00851"></a>00851           {
<a name="l00852"></a>00852             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex8.php">Hex8</a>;  <span class="comment">// create new element</span>
<a name="l00853"></a>00853             
<a name="l00854"></a>00854             assign_elem_nodes[1]=0;
<a name="l00855"></a>00855             assign_elem_nodes[2]=4;
<a name="l00856"></a>00856             assign_elem_nodes[3]=5;
<a name="l00857"></a>00857             assign_elem_nodes[4]=1;
<a name="l00858"></a>00858             assign_elem_nodes[5]=3;
<a name="l00859"></a>00859             assign_elem_nodes[6]=7;
<a name="l00860"></a>00860             assign_elem_nodes[7]=6;
<a name="l00861"></a>00861             assign_elem_nodes[8]=2;
<a name="l00862"></a>00862             <span class="keywordflow">break</span>;
<a name="l00863"></a>00863           }
<a name="l00864"></a>00864                 
<a name="l00865"></a>00865         <span class="keywordflow">case</span> 116: <span class="comment">// Solid Quadratic Brick</span>
<a name="l00866"></a>00866           {
<a name="l00867"></a>00867             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex20.php">Hex20</a>; <span class="comment">// create new element</span>
<a name="l00868"></a>00868             
<a name="l00869"></a>00869             assign_elem_nodes[1]=0;
<a name="l00870"></a>00870             assign_elem_nodes[2]=12;
<a name="l00871"></a>00871             assign_elem_nodes[3]=4;
<a name="l00872"></a>00872             assign_elem_nodes[4]=16;
<a name="l00873"></a>00873             assign_elem_nodes[5]=5;
<a name="l00874"></a>00874             assign_elem_nodes[6]=13;
<a name="l00875"></a>00875             assign_elem_nodes[7]=1;
<a name="l00876"></a>00876             assign_elem_nodes[8]=8;
<a name="l00877"></a>00877 
<a name="l00878"></a>00878             assign_elem_nodes[9]=11;
<a name="l00879"></a>00879             assign_elem_nodes[10]=19;
<a name="l00880"></a>00880             assign_elem_nodes[11]=17;
<a name="l00881"></a>00881             assign_elem_nodes[12]=9;
<a name="l00882"></a>00882 
<a name="l00883"></a>00883             assign_elem_nodes[13]=3;
<a name="l00884"></a>00884             assign_elem_nodes[14]=15;
<a name="l00885"></a>00885             assign_elem_nodes[15]=7;
<a name="l00886"></a>00886             assign_elem_nodes[16]=18;
<a name="l00887"></a>00887             assign_elem_nodes[17]=6;
<a name="l00888"></a>00888             assign_elem_nodes[18]=14;
<a name="l00889"></a>00889             assign_elem_nodes[19]=2;
<a name="l00890"></a>00890             assign_elem_nodes[20]=10;
<a name="l00891"></a>00891             <span class="keywordflow">break</span>;
<a name="l00892"></a>00892           }     
<a name="l00893"></a>00893         
<a name="l00894"></a>00894         <span class="keywordflow">case</span> 117: <span class="comment">// Solid Cubic Brick</span>
<a name="l00895"></a>00895           {
<a name="l00896"></a>00896             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: UNV-element type 117: Solid Cubic Brick&quot;</span>
<a name="l00897"></a>00897                           &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00898"></a>00898                           &lt;&lt; std::endl;
<a name="l00899"></a>00899             libmesh_error();        
<a name="l00900"></a>00900             <span class="keywordflow">break</span>;
<a name="l00901"></a>00901           }
<a name="l00902"></a>00902         
<a name="l00903"></a>00903         <span class="keywordflow">case</span> 118: <span class="comment">// Solid Quadratic Tetrahedron</span>
<a name="l00904"></a>00904           {
<a name="l00905"></a>00905             elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet10.php">Tet10</a>; <span class="comment">// create new element</span>
<a name="l00906"></a>00906             
<a name="l00907"></a>00907             assign_elem_nodes[1]=0;
<a name="l00908"></a>00908             assign_elem_nodes[2]=4;
<a name="l00909"></a>00909             assign_elem_nodes[3]=1;
<a name="l00910"></a>00910             assign_elem_nodes[4]=5;
<a name="l00911"></a>00911             assign_elem_nodes[5]=2;
<a name="l00912"></a>00912             assign_elem_nodes[6]=6;
<a name="l00913"></a>00913             assign_elem_nodes[7]=7;
<a name="l00914"></a>00914             assign_elem_nodes[8]=8;
<a name="l00915"></a>00915             assign_elem_nodes[9]=9;
<a name="l00916"></a>00916             assign_elem_nodes[10]=3;
<a name="l00917"></a>00917             <span class="keywordflow">break</span>;
<a name="l00918"></a>00918           }     
<a name="l00919"></a>00919         
<a name="l00920"></a>00920         <span class="keywordflow">default</span>: <span class="comment">// Unrecognized element type</span>
<a name="l00921"></a>00921           {
<a name="l00922"></a>00922             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: UNV-element type &quot;</span> 
<a name="l00923"></a>00923                           &lt;&lt; fe_descriptor_id
<a name="l00924"></a>00924                           &lt;&lt; <span class="stringliteral">&quot; not supported.&quot;</span> 
<a name="l00925"></a>00925                       &lt;&lt; std::endl;
<a name="l00926"></a>00926             libmesh_error();        
<a name="l00927"></a>00927             <span class="keywordflow">break</span>;
<a name="l00928"></a>00928           }
<a name="l00929"></a>00929         }
<a name="l00930"></a>00930 
<a name="l00931"></a>00931       <span class="comment">// nodes are being stored in element</span>
<a name="l00932"></a>00932       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;=<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; j++)
<a name="l00933"></a>00933         {
<a name="l00934"></a>00934           <span class="comment">// Find the position of node_labels[j] in the _assign_nodes vector.</span>
<a name="l00935"></a>00935           <span class="keyword">const</span> std::pair&lt;std::vector&lt;unsigned int&gt;::const_iterator,
<a name="l00936"></a>00936                           std::vector&lt;unsigned int&gt;::const_iterator&gt;        
<a name="l00937"></a>00937             it = std::equal_range (it_begin,
<a name="l00938"></a>00938                                    it_end,
<a name="l00939"></a>00939                                    node_labels[j]);
<a name="l00940"></a>00940 
<a name="l00941"></a>00941           <span class="comment">// it better be there, so libmesh_assert that it was found.</span>
<a name="l00942"></a>00942           libmesh_assert (it.first  != it.second);
<a name="l00943"></a>00943           libmesh_assert (*(it.first) == node_labels[j]);
<a name="l00944"></a>00944 
<a name="l00945"></a>00945           <span class="comment">// Now, the distance between this UNV id and the beginning of</span>
<a name="l00946"></a>00946           <span class="comment">// the _assign_nodes vector will give us a unique id in the</span>
<a name="l00947"></a>00947           <span class="comment">// range [0,n_nodes) that we can use for defining a contiguous</span>
<a name="l00948"></a>00948           <span class="comment">// connectivity.</span>
<a name="l00949"></a>00949           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assigned_node = std::distance (it_begin,
<a name="l00950"></a>00950                                                             it.first);
<a name="l00951"></a>00951 
<a name="l00952"></a>00952           <span class="comment">// Make sure we didn&#39;t get an out-of-bounds id</span>
<a name="l00953"></a>00953           libmesh_assert (assigned_node &lt; this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>);
<a name="l00954"></a>00954           
<a name="l00955"></a>00955           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(assign_elem_nodes[j]) =
<a name="l00956"></a>00956             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(assigned_node);
<a name="l00957"></a>00957         }
<a name="l00958"></a>00958 
<a name="l00959"></a>00959       <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>()] = <span class="keyword">true</span>;
<a name="l00960"></a>00960 
<a name="l00961"></a>00961       <span class="comment">// add elem to the Mesh &amp; </span>
<a name="l00962"></a>00962       <span class="comment">// tell the MeshData object the foreign elem id</span>
<a name="l00963"></a>00963       <span class="comment">// (note that mesh.add_elem() returns a pointer to the new element)</span>
<a name="l00964"></a>00964       elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(i);
<a name="l00965"></a>00965       this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#aca3722b2bab0198b3e3efc7d47eed1c8">add_foreign_elem_id</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(elem), element_lab);
<a name="l00966"></a>00966     }
<a name="l00967"></a>00967 
<a name="l00968"></a>00968   STOP_LOG(<span class="stringliteral">&quot;element_in()&quot;</span>,<span class="stringliteral">&quot;UNVIO&quot;</span>);
<a name="l00969"></a>00969 }
<a name="l00970"></a>00970 
<a name="l00971"></a>00971 
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 
<a name="l00974"></a>00974 
<a name="l00975"></a>00975 
<a name="l00976"></a><a class="code" href="classlibMesh_1_1UNVIO.php#ae302f8983fb88071d534effc4a156d08">00976</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#ae302f8983fb88071d534effc4a156d08">UNVIO::node_out</a> (std::ostream&amp; out_file)
<a name="l00977"></a>00977 {
<a name="l00978"></a>00978   
<a name="l00979"></a>00979   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a>() ||
<a name="l00980"></a>00980           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>());
<a name="l00981"></a>00981 
<a name="l00982"></a>00982 
<a name="l00983"></a>00983   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l00984"></a>00984     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Writing &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a> &lt;&lt; <span class="stringliteral">&quot; nodes&quot;</span> &lt;&lt; std::endl;
<a name="l00985"></a>00985 
<a name="l00986"></a>00986   <span class="comment">// Write beginning of dataset</span>
<a name="l00987"></a>00987   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>
<a name="l00988"></a>00988            &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> 
<a name="l00989"></a>00989            &lt;&lt; <a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">_label_dataset_nodes</a>
<a name="l00990"></a>00990            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 
<a name="l00993"></a>00993   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exp_coord_sys_dummy  = 0; <span class="comment">// export coordinate sys. (not supported yet)</span>
<a name="l00994"></a>00994   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> disp_coord_sys_dummy = 0; <span class="comment">// displacement coordinate sys. (not supp. yet)</span>
<a name="l00995"></a>00995   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> color_dummy          = 0; <span class="comment">// color(not supported yet)</span>
<a name="l00996"></a>00996 
<a name="l00997"></a>00997   <span class="comment">// A reference to the parent class&#39;s mesh</span>
<a name="l00998"></a>00998   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00999"></a>00999 
<a name="l01000"></a>01000   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       nd  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l01001"></a>01001   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l01002"></a>01002 
<a name="l01003"></a>01003   <span class="keywordflow">for</span> (; nd != end; ++nd)
<a name="l01004"></a>01004     {
<a name="l01005"></a>01005       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* current_node = *nd;
<a name="l01006"></a>01006       
<a name="l01007"></a>01007       <span class="keywordtype">char</span> buf[78];
<a name="l01008"></a>01008       std::sprintf(buf, <span class="stringliteral">&quot;%10d%10d%10d%10d\n&quot;</span>, 
<a name="l01009"></a>01009                    this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a61177caeb0fb845281a61e8f52a0bb5f">node_to_foreign_id</a>(current_node),
<a name="l01010"></a>01010                    exp_coord_sys_dummy,
<a name="l01011"></a>01011                    disp_coord_sys_dummy,
<a name="l01012"></a>01012                    color_dummy);
<a name="l01013"></a>01013       out_file &lt;&lt; buf;
<a name="l01014"></a>01014 
<a name="l01015"></a>01015       <span class="comment">// the coordinates</span>
<a name="l01016"></a>01016       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>() == 3)
<a name="l01017"></a>01017         std::sprintf(buf, <span class="stringliteral">&quot;%25.16E%25.16E%25.16E\n&quot;</span>, 
<a name="l01018"></a>01018                      static_cast&lt;double&gt;((*current_node)(0)),
<a name="l01019"></a>01019                      <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>((*current_node)(1)),
<a name="l01020"></a>01020                      <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>((*current_node)(2)));
<a name="l01021"></a>01021       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>() == 2)
<a name="l01022"></a>01022         std::sprintf(buf, <span class="stringliteral">&quot;%25.16E%25.16E\n&quot;</span>, 
<a name="l01023"></a>01023                      static_cast&lt;double&gt;((*current_node)(0)),
<a name="l01024"></a>01024                      <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>((*current_node)(1)));
<a name="l01025"></a>01025       <span class="keywordflow">else</span>
<a name="l01026"></a>01026         std::sprintf(buf, <span class="stringliteral">&quot;%25.16E\n&quot;</span>, 
<a name="l01027"></a>01027                      static_cast&lt;double&gt;((*current_node)(0)));
<a name="l01028"></a>01028       
<a name="l01029"></a>01029       out_file &lt;&lt; buf;
<a name="l01030"></a>01030     }
<a name="l01031"></a>01031   
<a name="l01032"></a>01032   
<a name="l01033"></a>01033   <span class="comment">// Write end of dataset</span>
<a name="l01034"></a>01034   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>;
<a name="l01035"></a>01035 }
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 
<a name="l01039"></a>01039 
<a name="l01040"></a>01040 
<a name="l01041"></a>01041 
<a name="l01042"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a54de35003f4a4398a0c6b30abbed26cf">01042</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a54de35003f4a4398a0c6b30abbed26cf">UNVIO::element_out</a>(std::ostream&amp; out_file)
<a name="l01043"></a>01043 {
<a name="l01044"></a>01044   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a>() ||
<a name="l01045"></a>01045           this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>());
<a name="l01046"></a>01046 
<a name="l01047"></a>01047   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l01048"></a>01048     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Writing elements&quot;</span> &lt;&lt; std::endl;
<a name="l01049"></a>01049   
<a name="l01050"></a>01050   <span class="comment">// Write beginning of dataset</span>
<a name="l01051"></a>01051   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>
<a name="l01052"></a>01052            &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> 
<a name="l01053"></a>01053            &lt;&lt; <a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">_label_dataset_elements</a>
<a name="l01054"></a>01054            &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l01055"></a>01055 
<a name="l01056"></a>01056   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> fe_descriptor_id = 0;    <span class="comment">// FE descriptor id </span>
<a name="l01057"></a>01057   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> phys_prop_tab_dummy = 2; <span class="comment">// physical property (not supported yet)</span>
<a name="l01058"></a>01058   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> mat_prop_tab_dummy = 1;  <span class="comment">// material property (not supported yet)</span>
<a name="l01059"></a>01059   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> color_dummy = 7;         <span class="comment">// color (not supported yet)</span>
<a name="l01060"></a>01060 
<a name="l01061"></a>01061 
<a name="l01062"></a>01062   <span class="comment">// vector that assigns element nodes to their correct position</span>
<a name="l01063"></a>01063   <span class="comment">// currently only elements with up to 20 nodes</span>
<a name="l01064"></a>01064   <span class="comment">//  </span>
<a name="l01065"></a>01065   <span class="comment">// Example:</span>
<a name="l01066"></a>01066   <span class="comment">// QUAD4               | 44:plane stress</span>
<a name="l01067"></a>01067   <span class="comment">//                     | linear quad</span>
<a name="l01068"></a>01068   <span class="comment">// position in libMesh | UNV numbering</span>
<a name="l01069"></a>01069   <span class="comment">// (note: 0-based)     | (note: 1-based)</span>
<a name="l01070"></a>01070   <span class="comment">//     </span>
<a name="l01071"></a>01071   <span class="comment">// assign_elem_node[0]  = 0</span>
<a name="l01072"></a>01072   <span class="comment">// assign_elem_node[1]  = 3</span>
<a name="l01073"></a>01073   <span class="comment">// assign_elem_node[2]  = 2</span>
<a name="l01074"></a>01074   <span class="comment">// assign_elem_node[3]  = 1</span>
<a name="l01075"></a>01075   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> assign_elem_nodes[20];
<a name="l01076"></a>01076 
<a name="l01077"></a>01077   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_written=0;
<a name="l01078"></a>01078 
<a name="l01079"></a>01079   <span class="comment">// A reference to the parent class&#39;s mesh</span>
<a name="l01080"></a>01080   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l01081"></a>01081 
<a name="l01082"></a>01082   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01083"></a>01083   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01084"></a>01084 
<a name="l01085"></a>01085   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01086"></a>01086     {
<a name="l01087"></a>01087       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l01088"></a>01088 
<a name="l01089"></a>01089       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01090"></a>01090       
<a name="l01091"></a>01091       <span class="keywordflow">switch</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>())
<a name="l01092"></a>01092         {
<a name="l01093"></a>01093         
<a name="l01094"></a>01094         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01095"></a>01095           {
<a name="l01096"></a>01096             fe_descriptor_id = 41; <span class="comment">// Plane Stress Linear Triangle</span>
<a name="l01097"></a>01097             assign_elem_nodes[0] = 0;
<a name="l01098"></a>01098             assign_elem_nodes[1] = 2;
<a name="l01099"></a>01099             assign_elem_nodes[2] = 1;
<a name="l01100"></a>01100             <span class="keywordflow">break</span>;
<a name="l01101"></a>01101           }
<a name="l01102"></a>01102 
<a name="l01103"></a>01103         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01104"></a>01104           {
<a name="l01105"></a>01105             fe_descriptor_id = 42; <span class="comment">// Plane Stress Quadratic Triangle</span>
<a name="l01106"></a>01106             assign_elem_nodes[0] = 0;
<a name="l01107"></a>01107             assign_elem_nodes[1] = 5;
<a name="l01108"></a>01108             assign_elem_nodes[2] = 2;
<a name="l01109"></a>01109             assign_elem_nodes[3] = 4;
<a name="l01110"></a>01110             assign_elem_nodes[4] = 1;
<a name="l01111"></a>01111             assign_elem_nodes[5] = 3;
<a name="l01112"></a>01112             <span class="keywordflow">break</span>;
<a name="l01113"></a>01113           }
<a name="l01114"></a>01114           
<a name="l01115"></a>01115         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01116"></a>01116           {
<a name="l01117"></a>01117             fe_descriptor_id = 44; <span class="comment">// Plane Stress Linear Quadrilateral</span>
<a name="l01118"></a>01118             assign_elem_nodes[0] = 0;
<a name="l01119"></a>01119             assign_elem_nodes[1] = 3;
<a name="l01120"></a>01120             assign_elem_nodes[2] = 2;
<a name="l01121"></a>01121             assign_elem_nodes[3] = 1;
<a name="l01122"></a>01122             <span class="keywordflow">break</span>;
<a name="l01123"></a>01123           }
<a name="l01124"></a>01124         
<a name="l01125"></a>01125         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01126"></a>01126           {
<a name="l01127"></a>01127             fe_descriptor_id = 45; <span class="comment">// Plane Stress Quadratic Quadrilateral</span>
<a name="l01128"></a>01128             assign_elem_nodes[0] = 0;
<a name="l01129"></a>01129             assign_elem_nodes[1] = 7;
<a name="l01130"></a>01130             assign_elem_nodes[2] = 3;
<a name="l01131"></a>01131             assign_elem_nodes[3] = 6;
<a name="l01132"></a>01132             assign_elem_nodes[4] = 2;
<a name="l01133"></a>01133             assign_elem_nodes[5] = 5;
<a name="l01134"></a>01134             assign_elem_nodes[6] = 1;
<a name="l01135"></a>01135             assign_elem_nodes[7] = 4;
<a name="l01136"></a>01136             <span class="keywordflow">break</span>;
<a name="l01137"></a>01137           }
<a name="l01138"></a>01138         
<a name="l01139"></a>01139         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01140"></a>01140           {
<a name="l01141"></a>01141             fe_descriptor_id = 300; <span class="comment">// Plane Stress Quadratic Quadrilateral</span>
<a name="l01142"></a>01142             assign_elem_nodes[0] = 0;
<a name="l01143"></a>01143             assign_elem_nodes[1] = 7;
<a name="l01144"></a>01144             assign_elem_nodes[2] = 3;
<a name="l01145"></a>01145             assign_elem_nodes[3] = 6;
<a name="l01146"></a>01146             assign_elem_nodes[4] = 2;
<a name="l01147"></a>01147             assign_elem_nodes[5] = 5;
<a name="l01148"></a>01148             assign_elem_nodes[6] = 1;
<a name="l01149"></a>01149             assign_elem_nodes[7] = 4;
<a name="l01150"></a>01150             assign_elem_nodes[8] = 8;
<a name="l01151"></a>01151             <span class="keywordflow">break</span>;
<a name="l01152"></a>01152           }
<a name="l01153"></a>01153         
<a name="l01154"></a>01154         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01155"></a>01155           {
<a name="l01156"></a>01156             fe_descriptor_id = 111; <span class="comment">// Solid Linear Tetrahedron</span>
<a name="l01157"></a>01157             assign_elem_nodes[0] = 0;
<a name="l01158"></a>01158             assign_elem_nodes[1] = 1;
<a name="l01159"></a>01159             assign_elem_nodes[2] = 2;
<a name="l01160"></a>01160             assign_elem_nodes[3] = 3;
<a name="l01161"></a>01161             <span class="keywordflow">break</span>;
<a name="l01162"></a>01162           }
<a name="l01163"></a>01163 
<a name="l01164"></a>01164         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01165"></a>01165           {
<a name="l01166"></a>01166             fe_descriptor_id = 112; <span class="comment">// Solid Linear Prism</span>
<a name="l01167"></a>01167             assign_elem_nodes[0] = 0;
<a name="l01168"></a>01168             assign_elem_nodes[1] = 1;
<a name="l01169"></a>01169             assign_elem_nodes[2] = 2;
<a name="l01170"></a>01170             assign_elem_nodes[3] = 3;
<a name="l01171"></a>01171             assign_elem_nodes[4] = 4;
<a name="l01172"></a>01172             assign_elem_nodes[5] = 5;
<a name="l01173"></a>01173             <span class="keywordflow">break</span>;
<a name="l01174"></a>01174           }
<a name="l01175"></a>01175 
<a name="l01176"></a>01176         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01177"></a>01177           {
<a name="l01178"></a>01178             fe_descriptor_id = 115; <span class="comment">// Solid Linear Brick</span>
<a name="l01179"></a>01179             assign_elem_nodes[0] = 0;
<a name="l01180"></a>01180             assign_elem_nodes[1] = 4;
<a name="l01181"></a>01181             assign_elem_nodes[2] = 5;
<a name="l01182"></a>01182             assign_elem_nodes[3] = 1;
<a name="l01183"></a>01183             assign_elem_nodes[4] = 3;
<a name="l01184"></a>01184             assign_elem_nodes[5] = 7;
<a name="l01185"></a>01185             assign_elem_nodes[6] = 6;
<a name="l01186"></a>01186             assign_elem_nodes[7] = 2;
<a name="l01187"></a>01187             <span class="keywordflow">break</span>;
<a name="l01188"></a>01188           }
<a name="l01189"></a>01189         
<a name="l01190"></a>01190         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01191"></a>01191           {
<a name="l01192"></a>01192             fe_descriptor_id = 116; <span class="comment">// Solid Quadratic Brick</span>
<a name="l01193"></a>01193             assign_elem_nodes[ 0] = 0;
<a name="l01194"></a>01194             assign_elem_nodes[ 1] = 12;
<a name="l01195"></a>01195             assign_elem_nodes[ 2] = 4;
<a name="l01196"></a>01196             assign_elem_nodes[ 3] = 16;
<a name="l01197"></a>01197             assign_elem_nodes[ 4] = 5;
<a name="l01198"></a>01198             assign_elem_nodes[ 5] = 13;
<a name="l01199"></a>01199             assign_elem_nodes[ 6] = 1;
<a name="l01200"></a>01200             assign_elem_nodes[ 7] = 8;
<a name="l01201"></a>01201 
<a name="l01202"></a>01202             assign_elem_nodes[ 8] = 11;
<a name="l01203"></a>01203             assign_elem_nodes[ 9] = 19;
<a name="l01204"></a>01204             assign_elem_nodes[10] = 17;
<a name="l01205"></a>01205             assign_elem_nodes[11] = 9;
<a name="l01206"></a>01206 
<a name="l01207"></a>01207             assign_elem_nodes[12] = 3;
<a name="l01208"></a>01208             assign_elem_nodes[13] = 15;
<a name="l01209"></a>01209             assign_elem_nodes[14] = 7;
<a name="l01210"></a>01210             assign_elem_nodes[15] = 18;
<a name="l01211"></a>01211             assign_elem_nodes[16] = 6;
<a name="l01212"></a>01212             assign_elem_nodes[17] = 14;
<a name="l01213"></a>01213             assign_elem_nodes[18] = 2;
<a name="l01214"></a>01214             assign_elem_nodes[19] = 10;
<a name="l01215"></a>01215 
<a name="l01216"></a>01216 
<a name="l01217"></a>01217             <span class="keywordflow">break</span>;
<a name="l01218"></a>01218           }
<a name="l01219"></a>01219                 
<a name="l01220"></a>01220         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01221"></a>01221           {
<a name="l01222"></a>01222             fe_descriptor_id = 118; <span class="comment">// Solid Quadratic Tetrahedron</span>
<a name="l01223"></a>01223             assign_elem_nodes[0] = 0;
<a name="l01224"></a>01224             assign_elem_nodes[1] = 4;
<a name="l01225"></a>01225             assign_elem_nodes[2] = 1;
<a name="l01226"></a>01226             assign_elem_nodes[3] = 5;
<a name="l01227"></a>01227             assign_elem_nodes[4] = 2;
<a name="l01228"></a>01228             assign_elem_nodes[5] = 6;
<a name="l01229"></a>01229             assign_elem_nodes[6] = 7;
<a name="l01230"></a>01230             assign_elem_nodes[7] = 8;
<a name="l01231"></a>01231             assign_elem_nodes[8] = 9;
<a name="l01232"></a>01232             assign_elem_nodes[9] = 3;
<a name="l01233"></a>01233             <span class="keywordflow">break</span>;
<a name="l01234"></a>01234           }
<a name="l01235"></a>01235                 
<a name="l01236"></a>01236         <span class="keywordflow">default</span>:
<a name="l01237"></a>01237           {
<a name="l01238"></a>01238             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Element type = &quot;</span> 
<a name="l01239"></a>01239                           &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() 
<a name="l01240"></a>01240                           &lt;&lt; <span class="stringliteral">&quot; not supported in &quot;</span>
<a name="l01241"></a>01241                           &lt;&lt; <span class="stringliteral">&quot;UNVIO!&quot;</span>
<a name="l01242"></a>01242                           &lt;&lt; std::endl;
<a name="l01243"></a>01243             libmesh_error();    
<a name="l01244"></a>01244             <span class="keywordflow">break</span>;
<a name="l01245"></a>01245           }
<a name="l01246"></a>01246         }
<a name="l01247"></a>01247 
<a name="l01248"></a>01248 
<a name="l01249"></a>01249       out_file &lt;&lt; std::setw(10) &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#ad92a581667b41710c22c7b59aec3fe64">elem_to_foreign_id</a>(elem)  <span class="comment">// element ID</span>
<a name="l01250"></a>01250                &lt;&lt; std::setw(10) &lt;&lt; fe_descriptor_id                           <span class="comment">// type of element</span>
<a name="l01251"></a>01251                &lt;&lt; std::setw(10) &lt;&lt; phys_prop_tab_dummy                        <span class="comment">// not supported </span>
<a name="l01252"></a>01252                &lt;&lt; std::setw(10) &lt;&lt; mat_prop_tab_dummy                         <span class="comment">// not supported </span>
<a name="l01253"></a>01253                &lt;&lt; std::setw(10) &lt;&lt; color_dummy                                <span class="comment">// not supported </span>
<a name="l01254"></a>01254                &lt;&lt; std::setw(10) &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>()                            <span class="comment">// No. of nodes per element</span>
<a name="l01255"></a>01255                &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01256"></a>01256 
<a name="l01257"></a>01257       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); j++)
<a name="l01258"></a>01258         {
<a name="l01259"></a>01259           <span class="comment">// assign_elem_nodes[j]-th node: i.e., j loops over the</span>
<a name="l01260"></a>01260           <span class="comment">// libMesh numbering, and assign_elem_nodes[j] over the</span>
<a name="l01261"></a>01261           <span class="comment">// UNV numbering.</span>
<a name="l01262"></a>01262           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node_in_unv_order = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(assign_elem_nodes[j]);
<a name="l01263"></a>01263 
<a name="l01264"></a>01264           <span class="comment">// new record after 8 id entries</span>
<a name="l01265"></a>01265           <span class="keywordflow">if</span> (j==8 || j==16)
<a name="l01266"></a>01266             out_file &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01267"></a>01267 
<a name="l01268"></a>01268           <span class="comment">// write foreign label for this node</span>
<a name="l01269"></a>01269           out_file &lt;&lt; std::setw(10) &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>.<a class="code" href="classlibMesh_1_1MeshData.php#a61177caeb0fb845281a61e8f52a0bb5f">node_to_foreign_id</a>(node_in_unv_order);
<a name="l01270"></a>01270 
<a name="l01271"></a>01271 
<a name="l01272"></a>01272         }
<a name="l01273"></a>01273 
<a name="l01274"></a>01274       out_file &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01275"></a>01275 
<a name="l01276"></a>01276       n_elem_written++;
<a name="l01277"></a>01277     }
<a name="l01278"></a>01278 
<a name="l01279"></a>01279   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a>())
<a name="l01280"></a>01280     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Finished writing &quot;</span> &lt;&lt; n_elem_written &lt;&lt; <span class="stringliteral">&quot; elements&quot;</span> &lt;&lt; std::endl;
<a name="l01281"></a>01281 
<a name="l01282"></a>01282   <span class="comment">// Write end of dataset</span>
<a name="l01283"></a>01283   out_file &lt;&lt; <span class="stringliteral">&quot;    -1\n&quot;</span>;
<a name="l01284"></a>01284 }
<a name="l01285"></a>01285 
<a name="l01286"></a>01286 } <span class="comment">// namespace libMesh</span>
<a name="l01287"></a>01287 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
