<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">unv_io.h</div>  </div>
</div>
<div class="contents">
<a href="unv__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: unv_io.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __unv_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __unv_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>MeshBase;
<a name="l00040"></a>00040 <span class="keyword">class </span>MeshData;
<a name="l00041"></a>00041 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// UNVIO class definition</span>
<a name="l00050"></a><a class="code" href="classlibMesh_1_1UNVIO.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1UNVIO.php">UNVIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00051"></a>00051               <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 
<a name="l00054"></a>00054  <span class="keyword">public</span>:
<a name="l00055"></a>00055   
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1UNVIO.php#a78fb1e1b56415aa356e8f408054ebe70">UNVIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; mesh_data);
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1UNVIO.php#a78fb1e1b56415aa356e8f408054ebe70">UNVIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; mesh_data);
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a1cbc9a5fdd0f8cb4fa526e1570d12677">~UNVIO</a> ();
<a name="l00072"></a>00072   
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a66258f5a1d703e345d3f3d824a0e6a01">read</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#adf786fd5f78f0edc656d5cfe628241de">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">verbose</a> ();
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   
<a name="l00089"></a>00089  <span class="keyword">private</span>:
<a name="l00090"></a>00090   
<a name="l00091"></a>00091 
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#aab1c8512d0bc0de87e6897d20f5e9e54">read_implementation</a> (std::istream&amp; in_stream);
<a name="l00098"></a>00098 
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#aa680a6e763c89ebe09041e53a4cf54e3">write_implementation</a> (std::ostream&amp; out_stream);
<a name="l00105"></a>00105   
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#ad7630b487339fa82cfcc919899797dda">clear</a>();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00114"></a>00114   <span class="comment">// read support methods</span>
<a name="l00120"></a>00120 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a6a9eed76be876b4ecea672983b05ffe9">count_nodes</a> (std::istream&amp; in_file);
<a name="l00121"></a>00121   
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#acc120086cc1194bbcabe50b6c0a808b2">node_in</a> (std::istream&amp; in_file);
<a name="l00132"></a>00132 
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a2fb79162c368a835190cf36e21d9e757">count_elements</a> (std::istream&amp; in_file);
<a name="l00138"></a>00138 
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#afec425506c340cceca0bcfb8f1766d04">element_in</a> (std::istream&amp; in_file);
<a name="l00147"></a>00147 
<a name="l00153"></a>00153   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a83608b46105917653390bd428bd3f6d9">beginning_of_dataset</a> (std::istream&amp; in_file, 
<a name="l00154"></a>00154                              <span class="keyword">const</span> std::string&amp; ds_name) <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00162"></a>00162   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1UNVIO.php#afe906e09e5cb3effe5d4f0afe5ccf405">D_to_e</a> (std::string&amp; number) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00166"></a>00166   <span class="comment">// write support methods</span>
<a name="l00173"></a>00173 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#ae302f8983fb88071d534effc4a156d08">node_out</a> (std::ostream&amp; out_file);
<a name="l00174"></a>00174 
<a name="l00181"></a>00181   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a54de35003f4a4398a0c6b30abbed26cf">element_out</a> (std::ostream&amp; out_file);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00185"></a>00185   <span class="comment">// local data</span>
<a name="l00186"></a>00186 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a7c0fd126addbf0191ae0878e842620ea">00190</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a7c0fd126addbf0191ae0878e842620ea">_verbose</a>;
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">00195</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1UNVIO.php#a678233291bad93a9cd8ffebdfb667fb5">_assign_nodes</a>;
<a name="l00196"></a>00196 
<a name="l00201"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a8b768d76871a9c094f22b351e03d09ce">00201</a>   std::map&lt;std::string,std::streampos&gt; <a class="code" href="classlibMesh_1_1UNVIO.php#a8b768d76871a9c094f22b351e03d09ce">_ds_position</a>;
<a name="l00202"></a>00202 
<a name="l00207"></a><a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">00207</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1UNVIO.php#af9af375647fb6b17fec2df4d39d3634f">_n_nodes</a>;
<a name="l00208"></a>00208 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">00213</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a95fcd37afc377e1ebc75d7ff4d1446d0">_n_elements</a>;
<a name="l00214"></a>00214 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">00218</a>   <span class="keyword">static</span> <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1UNVIO.php#a1b8bf678245623240552b211c6c2621d">_label_dataset_nodes</a>;
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">00223</a>   <span class="keyword">static</span> <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1UNVIO.php#a97ee9b594a8b9b73cb5d986486606929">_label_dataset_elements</a>;
<a name="l00224"></a>00224 
<a name="l00229"></a><a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">00229</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UNVIO.php#ab0749d0dea0f0c100982edb3c94a8f25">_need_D_to_e</a>;
<a name="l00230"></a>00230 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">00235</a>   <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; <a class="code" href="classlibMesh_1_1UNVIO.php#a2f19a863725204d0eb6644d2e93186e4">_mesh_data</a>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 };
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00242"></a>00242 <span class="comment">// MeshIO inline members</span>
<a name="l00243"></a>00243 <span class="keyword">inline</span>
<a name="l00244"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a78fb1e1b56415aa356e8f408054ebe70">00244</a> <a class="code" href="classlibMesh_1_1UNVIO.php#a78fb1e1b56415aa356e8f408054ebe70">UNVIO::UNVIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; mesh_data) :
<a name="l00245"></a>00245   <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00246"></a>00246   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00247"></a>00247   _verbose (false),
<a name="l00248"></a>00248   _mesh_data (mesh_data)
<a name="l00249"></a>00249 {
<a name="l00250"></a>00250 }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="keyword">inline</span>
<a name="l00255"></a><a class="code" href="classlibMesh_1_1UNVIO.php#ad55d01c013e6464761cb2472570eac53">00255</a> <a class="code" href="classlibMesh_1_1UNVIO.php#a78fb1e1b56415aa356e8f408054ebe70">UNVIO::UNVIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; mesh_data) :
<a name="l00256"></a>00256   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00257"></a>00257   _verbose (false),
<a name="l00258"></a>00258   _mesh_data (mesh_data)
<a name="l00259"></a>00259 {
<a name="l00260"></a>00260 }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="keyword">inline</span>
<a name="l00265"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a1cbc9a5fdd0f8cb4fa526e1570d12677">00265</a> <a class="code" href="classlibMesh_1_1UNVIO.php#a1cbc9a5fdd0f8cb4fa526e1570d12677">UNVIO::~UNVIO</a> ()
<a name="l00266"></a>00266 {
<a name="l00267"></a>00267   this-&gt;<a class="code" href="classlibMesh_1_1UNVIO.php#ad7630b487339fa82cfcc919899797dda">clear</a> ();
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <span class="keyword">inline</span>
<a name="l00273"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">00273</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1UNVIO.php#a272e10211b23c7601a51ef68c5be0365">UNVIO::verbose</a> ()
<a name="l00274"></a>00274 {
<a name="l00275"></a>00275   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a7c0fd126addbf0191ae0878e842620ea">_verbose</a>;
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="keyword">inline</span>
<a name="l00281"></a><a class="code" href="classlibMesh_1_1UNVIO.php#a83608b46105917653390bd428bd3f6d9">00281</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1UNVIO.php#a83608b46105917653390bd428bd3f6d9">UNVIO::beginning_of_dataset</a> (std::istream&amp; in_file, 
<a name="l00282"></a>00282                                   <span class="keyword">const</span> std::string&amp; ds_name)<span class="keyword"> const</span>
<a name="l00283"></a>00283 <span class="keyword"></span>{
<a name="l00284"></a>00284   libmesh_assert (in_file.good());
<a name="l00285"></a>00285   libmesh_assert (!ds_name.empty());
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   std::string olds, news;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <span class="keywordflow">while</span> (<span class="keyword">true</span>)
<a name="l00290"></a>00290     {
<a name="l00291"></a>00291       in_file &gt;&gt; olds &gt;&gt; news;
<a name="l00292"></a>00292 
<a name="l00293"></a>00293       <span class="comment">/*</span>
<a name="l00294"></a>00294 <span class="comment">       * a &quot;-1&quot; followed by a number means the beginning of a dataset</span>
<a name="l00295"></a>00295 <span class="comment">       * stop combing at the end of the file</span>
<a name="l00296"></a>00296 <span class="comment">       */</span>
<a name="l00297"></a>00297       <span class="keywordflow">while</span>( ((olds != <span class="stringliteral">&quot;-1&quot;</span>) || (news == <span class="stringliteral">&quot;-1&quot;</span>) ) &amp;&amp; !in_file.eof() )
<a name="l00298"></a>00298         {         
<a name="l00299"></a>00299           olds = news;
<a name="l00300"></a>00300           in_file &gt;&gt; news;
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303       <span class="keywordflow">if</span> (in_file.eof())
<a name="l00304"></a>00304         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00305"></a>00305       
<a name="l00306"></a>00306       <span class="keywordflow">if</span> (news == ds_name)
<a name="l00307"></a>00307         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00308"></a>00308     }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// should never end up here</span>
<a name="l00311"></a>00311   libmesh_error();
<a name="l00312"></a>00312   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00313"></a>00313 }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 <span class="keyword">inline</span>
<a name="l00318"></a><a class="code" href="classlibMesh_1_1UNVIO.php#afe906e09e5cb3effe5d4f0afe5ccf405">00318</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1UNVIO.php#afe906e09e5cb3effe5d4f0afe5ccf405">UNVIO::D_to_e</a> (std::string&amp; number)<span class="keyword"> const</span>
<a name="l00319"></a>00319 <span class="keyword"></span>{
<a name="l00320"></a>00320   <span class="comment">/* find &quot;D&quot; in string, start looking at </span>
<a name="l00321"></a>00321 <span class="comment">   * 6th element, to improve speed.</span>
<a name="l00322"></a>00322 <span class="comment">   * We dont expect a &quot;D&quot; earlier</span>
<a name="l00323"></a>00323 <span class="comment">   */</span>
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 <span class="preprocessor">#ifdef __HP_aCC</span>
<a name="l00326"></a>00326 <span class="preprocessor"></span>  <span class="comment">// Use an int instead of an unsigned int,</span>
<a name="l00327"></a>00327   <span class="comment">// otherwise HP aCC may crash!</span>
<a name="l00328"></a>00328   <span class="keyword">const</span> <span class="keywordtype">int</span> position = number.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00329"></a>00329 <span class="preprocessor">#else</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>  <span class="keyword">const</span> std::string::size_type position = number.find(<span class="stringliteral">&quot;D&quot;</span>,6);
<a name="l00331"></a>00331 <span class="preprocessor">#endif</span>
<a name="l00332"></a>00332 <span class="preprocessor"></span>
<a name="l00333"></a>00333   libmesh_assert (position != std::string::npos);
<a name="l00334"></a>00334   number.replace(position, 1, <span class="stringliteral">&quot;e&quot;</span>); 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="keywordflow">return</span> std::atof (number.c_str());
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 } <span class="comment">// namespace libMesh</span>
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 <span class="preprocessor">#endif // #define __unv_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
