<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">utility.C</div>  </div>
</div>
<div class="contents">
<a href="utility_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: utility.C 3884 2010-07-27 21:25:16Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// library configuration</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;pwd.h&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;unistd.h&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/utsname.h&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Utility members</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// The system_info function duplicates some of the</span>
<a name="l00044"></a>00044 <span class="comment">// functionality found in the perf_log function.</span>
<a name="l00045"></a>00045 <span class="comment">// This way you can get information about a user&#39;s</span>
<a name="l00046"></a>00046 <span class="comment">// system without creating a perf_log object.</span>
<a name="l00047"></a><a class="code" href="namespacelibMesh_1_1Utility.php#abfbbf7ee55c32d70de987564589f9924">00047</a> std::string <a class="code" href="namespacelibMesh_1_1Utility.php#abfbbf7ee55c32d70de987564589f9924">Utility::system_info</a>()
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   std::string date = <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>();
<a name="l00052"></a>00052   
<a name="l00053"></a>00053   <span class="comment">// Get system information</span>
<a name="l00054"></a>00054   <span class="keyword">struct </span>utsname sysInfo;
<a name="l00055"></a>00055   uname(&amp;sysInfo);
<a name="l00056"></a>00056   
<a name="l00057"></a>00057   <span class="comment">// Get user information</span>
<a name="l00058"></a>00058 <span class="preprocessor">#ifdef LIBMESH_HAVE_GETPWUID</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>      <span class="keyword">struct </span>passwd* p = getpwuid(getuid());
<a name="l00060"></a>00060 <span class="preprocessor">#endif</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a>00062       
<a name="l00063"></a>00063   out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00064"></a>00064       &lt;&lt; <span class="stringliteral">&quot; ---------------------------------------------------------------------\n&quot;</span>
<a name="l00065"></a>00065       &lt;&lt; <span class="stringliteral">&quot;| Time:           &quot;</span> &lt;&lt; date             &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00066"></a>00066       &lt;&lt; <span class="stringliteral">&quot;| OS:             &quot;</span> &lt;&lt; sysInfo.sysname  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00067"></a>00067       &lt;&lt; <span class="stringliteral">&quot;| HostName:       &quot;</span> &lt;&lt; sysInfo.nodename &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00068"></a>00068       &lt;&lt; <span class="stringliteral">&quot;| OS Release      &quot;</span> &lt;&lt; sysInfo.release  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00069"></a>00069       &lt;&lt; <span class="stringliteral">&quot;| OS Version:     &quot;</span> &lt;&lt; sysInfo.version  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00070"></a>00070       &lt;&lt; <span class="stringliteral">&quot;| Machine:        &quot;</span> &lt;&lt; sysInfo.machine  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00071"></a>00071 <span class="preprocessor">#ifdef LIBMESH_HAVE_GETPWUID</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot;| Username:       &quot;</span> &lt;&lt; p-&gt;pw_name       &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00073"></a>00073 <span class="preprocessor">#else</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot;| Username:       &quot;</span> &lt;&lt; <span class="stringliteral">&quot;Unknown&quot;</span>        &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00075"></a>00075 <span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot; ---------------------------------------------------------------------\n&quot;</span>;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="keywordflow">return</span> out.str();
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00085"></a><a class="code" href="namespacelibMesh_1_1Utility.php#a6d4e6e8b690b770d64817bd6c7f7d14b">00085</a> std::string <a class="code" href="namespacelibMesh_1_1Utility.php#a6d4e6e8b690b770d64817bd6c7f7d14b">Utility::complex_filename</a> (<span class="keyword">const</span> std::string&amp; basename,
<a name="l00086"></a>00086                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r_o_c)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>(basename);
<a name="l00089"></a>00089   
<a name="l00090"></a>00090   <span class="keywordflow">if</span> (r_o_c == 0)
<a name="l00091"></a>00091     name.append(<span class="stringliteral">&quot;.real&quot;</span>);
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   <span class="keywordflow">else</span>
<a name="l00094"></a>00094     name.append(<span class="stringliteral">&quot;.imag&quot;</span>);
<a name="l00095"></a>00095   
<a name="l00096"></a>00096   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="namespacelibMesh_1_1Utility.php#af5e69ae30b8a867ecb476d1b1e09384c">00101</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Utility.php#af5e69ae30b8a867ecb476d1b1e09384c">Utility::prepare_complex_data</a>(<span class="keyword">const</span> std::vector&lt;Complex&gt;&amp; source,
<a name="l00102"></a>00102                                    std::vector&lt;Real&gt;&amp; real_part,
<a name="l00103"></a>00103                                    std::vector&lt;Real&gt;&amp; imag_part)
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len = source.size();
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   real_part.resize(len);
<a name="l00108"></a>00108   imag_part.resize(len);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l00111"></a>00111     {
<a name="l00112"></a>00112       real_part[i] = source[i].real();
<a name="l00113"></a>00113       imag_part[i] = source[i].imag();
<a name="l00114"></a>00114     }
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif // #ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00119"></a>00119 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
