<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">variable.h</div>  </div>
</div>
<div class="contents">
<a href="variable_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: variable.h 4161 2011-01-12 17:07:58Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __variable_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __variable_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="id__types_8h.php">id_types.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh {
<a name="l00032"></a>00032 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1Variable.php">00041</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Variable.php">Variable</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 <span class="keyword">public</span>:
<a name="l00044"></a>00044   
<a name="l00050"></a><a class="code" href="classlibMesh_1_1Variable.php#aab83af474a53898a41d5d69dc700b296">00050</a>   <a class="code" href="classlibMesh_1_1Variable.php#aab83af474a53898a41d5d69dc700b296">Variable</a> (<span class="keyword">const</span> std::string &amp;var_name,
<a name="l00051"></a>00051             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_number,
<a name="l00052"></a>00052             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp;var_type) :
<a name="l00053"></a>00053     <a class="code" href="classlibMesh_1_1Variable.php#a46257bc3411bfb52c558237d320ab70c">_name</a>(var_name),
<a name="l00054"></a>00054     <a class="code" href="classlibMesh_1_1Variable.php#a1548eaad53ac768456434c88fde11125">_number</a>(var_number),
<a name="l00055"></a>00055     <a class="code" href="classlibMesh_1_1Variable.php#a090ae01f230b682249525c2c671f1a54">_type</a>(var_type),
<a name="l00056"></a>00056     <a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">_active_subdomains</a>()
<a name="l00057"></a>00057   {}
<a name="l00058"></a>00058   
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Variable.php#a9f430b3fdbeaaee38ada5c05cd2af8b1">00063</a>   <a class="code" href="classlibMesh_1_1Variable.php#aab83af474a53898a41d5d69dc700b296">Variable</a> (<span class="keyword">const</span> std::string &amp;var_name,
<a name="l00064"></a>00064             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_number,
<a name="l00065"></a>00065             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp;var_type,
<a name="l00066"></a>00066             <span class="keyword">const</span> std::set&lt;subdomain_id_type&gt; &amp;var_active_subdomains) :
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1Variable.php#a46257bc3411bfb52c558237d320ab70c">_name</a>(var_name),
<a name="l00068"></a>00068     <a class="code" href="classlibMesh_1_1Variable.php#a1548eaad53ac768456434c88fde11125">_number</a>(var_number),
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1Variable.php#a090ae01f230b682249525c2c671f1a54">_type</a>(var_type),
<a name="l00070"></a>00070     <a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">_active_subdomains</a>(var_active_subdomains)
<a name="l00071"></a>00071   {}
<a name="l00072"></a>00072   
<a name="l00076"></a><a class="code" href="classlibMesh_1_1Variable.php#a05070dc43e1e774a0c2843fe82d3f02d">00076</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1Variable.php#a05070dc43e1e774a0c2843fe82d3f02d">name</a>()<span class="keyword"> const </span>
<a name="l00077"></a>00077 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Variable.php#a46257bc3411bfb52c558237d320ab70c">_name</a>; }
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1Variable.php#a5598a098153a64e0a62b49fbdd879c32">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Variable.php#a5598a098153a64e0a62b49fbdd879c32">number</a>()<span class="keyword"> const </span>
<a name="l00083"></a>00083 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Variable.php#a1548eaad53ac768456434c88fde11125">_number</a>; }
<a name="l00084"></a>00084 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">00088</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp; <a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>()<span class="keyword"> const </span>
<a name="l00089"></a>00089 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Variable.php#a090ae01f230b682249525c2c671f1a54">_type</a>; }
<a name="l00090"></a>00090 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">00097</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> sid)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword">  </span>{ <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">_active_subdomains</a>.empty() || <a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">_active_subdomains</a>.count(sid));  }
<a name="l00099"></a>00099 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Variable.php#ad6a1439e083b51801997da06fb663443">00105</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Variable.php#ad6a1439e083b51801997da06fb663443">implicitly_active</a> ()<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">_active_subdomains</a>.empty(); }
<a name="l00107"></a>00107   
<a name="l00108"></a>00108 <span class="keyword">private</span>:
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Variable.php#a46257bc3411bfb52c558237d320ab70c">00109</a>   std::string             <a class="code" href="classlibMesh_1_1Variable.php#a46257bc3411bfb52c558237d320ab70c">_name</a>; 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1Variable.php#a1548eaad53ac768456434c88fde11125">00110</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>            <a class="code" href="classlibMesh_1_1Variable.php#a1548eaad53ac768456434c88fde11125">_number</a>;
<a name="l00111"></a><a class="code" href="classlibMesh_1_1Variable.php#a090ae01f230b682249525c2c671f1a54">00111</a>   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>                  <a class="code" href="classlibMesh_1_1Variable.php#a090ae01f230b682249525c2c671f1a54">_type</a>;
<a name="l00112"></a><a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">00112</a>   std::set&lt;subdomain_id_type&gt; <a class="code" href="classlibMesh_1_1Variable.php#a37c9779e6cc08241b5d17b4919d02397">_active_subdomains</a>;
<a name="l00113"></a>00113 };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 } <span class="comment">// namespace libMesh</span>
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif // #define __variable_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
