<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">variant_filter_iterator.h</div>  </div>
</div>
<div class="contents">
<a href="variant__filter__iterator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: variant_filter_iterator.h 4257 2011-03-14 04:26:09Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __variant_filter_iterator_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __variant_filter_iterator_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::swap</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;cstdlib&gt;</span>   <span class="comment">// for std::abort()</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span> <span class="comment">// for libmesh_cast_ptr()</span>
<a name="l00030"></a>00030 
<a name="l00044"></a>00044 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Predicate, <span class="keyword">class</span> Type, <span class="keyword">class</span> ReferenceType = Type&amp;, <span class="keyword">class</span> Po<span class="keywordtype">int</span>erType = Type*&gt;
<a name="l00045"></a><a class="code" href="classvariant__filter__iterator.php">00045</a> <span class="keyword">class </span><a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1iterator.php">iterator</a>&lt;std::forward_iterator_tag,  Type&gt;
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classvariant__filter__iterator.php#a23c53659ac9157dec76f6c88ef503a97">00051</a>   <span class="keyword">typedef</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a> <a class="code" href="classvariant__filter__iterator.php#a23c53659ac9157dec76f6c88ef503a97">Iterator</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00062"></a><a class="code" href="structvariant__filter__iterator_1_1IterBase.php">00062</a>   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>
<a name="l00063"></a>00063   {
<a name="l00064"></a><a class="code" href="structvariant__filter__iterator_1_1IterBase.php#a98aeadf88739211693b7e73529040b85">00064</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#a98aeadf88739211693b7e73529040b85">~IterBase</a>() {}
<a name="l00065"></a>00065     <span class="keyword">virtual</span>  <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#a21f29418376c68d57fc5d21000379751">clone</a>() <span class="keyword">const</span> = 0 ;
<a name="l00066"></a>00066     <span class="keyword">virtual</span> ReferenceType <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#a16f042ee7760e371e91fef4a95eb0cdf">operator*</a>() <span class="keyword">const</span> = 0;    <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00067"></a>00067     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>&amp; <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#aaa1ca08c4f5771e940ea3f4b46f9f06d">operator++</a>() = 0;          <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00068"></a>00068     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#ad950ec9d5c1e122a832a57f5e37b7fc6">equal</a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a> *other) <span class="keyword">const</span> = 0;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <span class="comment">// Similar to clone function above, but returns a pointer to a copy of a different type.</span>
<a name="l00071"></a>00071     <span class="comment">// typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::IterBase const_IterBase;</span>
<a name="l00072"></a><a class="code" href="structvariant__filter__iterator_1_1IterBase.php#af18d02ffa3020f00726d6a723530ef06">00072</a>     <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">variant_filter_iterator&lt;Predicate, Type const, Type const &amp; , Type const*&gt;::IterBase</a> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#af18d02ffa3020f00726d6a723530ef06">const_IterBase</a>;
<a name="l00073"></a>00073     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">const_IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1IterBase.php#a7ce190637309c41cf5514547dd0a6b21">const_clone</a>() <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074   };
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   
<a name="l00085"></a><a class="code" href="structvariant__filter__iterator_1_1PredBase.php">00085</a>   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>
<a name="l00086"></a>00086   {
<a name="l00087"></a><a class="code" href="structvariant__filter__iterator_1_1PredBase.php#aae08a3ace0c8ffe3d10499656076cccf">00087</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#aae08a3ace0c8ffe3d10499656076cccf">~PredBase</a>() {}
<a name="l00088"></a>00088     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#a1a1f2c652e009c29c8d55172102066fc">clone</a>() <span class="keyword">const</span> = 0 ;
<a name="l00089"></a>00089     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#ae34310ba9e58eed92243cdafd44d53e7">operator()</a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* in) <span class="keyword">const</span> = 0;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     <span class="comment">// Similar to clone function above, but returns a pointer to a copy of a different type.</span>
<a name="l00092"></a>00092     <span class="comment">// typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::PredBase const_PredBase;</span>
<a name="l00093"></a><a class="code" href="structvariant__filter__iterator_1_1PredBase.php#af87a419fd9c9cd0c839cb36ac2b47760">00093</a>     <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">variant_filter_iterator&lt;Predicate, Type const,  Type const &amp;,  Type const *&gt;::PredBase</a> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#af87a419fd9c9cd0c839cb36ac2b47760">const_PredBase</a>;
<a name="l00094"></a>00094     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">const_PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1PredBase.php#af7478ab145480b27f7e6ec6be0aef64f">const_clone</a>() <span class="keyword">const</span> = 0;
<a name="l00095"></a>00095   };
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   
<a name="l00106"></a>00106   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> IterType&gt;
<a name="l00107"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php">00107</a>   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter</a> : <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>
<a name="l00108"></a>00108   {
<a name="l00109"></a>00109     
<a name="l00113"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#a551cc198d1b7b9b38f4074296320f076">00113</a>     <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a551cc198d1b7b9b38f4074296320f076">Iter</a> (<span class="keyword">const</span> IterType&amp; v) :
<a name="l00114"></a>00114       <a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a> (v)
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116       <span class="comment">// libMesh::out &lt;&lt; &quot;In Iter&lt;IterType&gt;::Iter(const IterType&amp; v)&quot; &lt;&lt; std::endl;</span>
<a name="l00117"></a>00117     }
<a name="l00118"></a>00118     
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#acb7c43fe60c01960d18eb7c54d75a830">00123</a>     <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a551cc198d1b7b9b38f4074296320f076">Iter</a> (<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter</a>&amp; other) :
<a name="l00124"></a>00124       <a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>(other.<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>)
<a name="l00125"></a>00125     {}
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#a526b6ce05a87a9b9fa852e9ada4b42ff">00131</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a526b6ce05a87a9b9fa852e9ada4b42ff">~Iter</a> () {}
<a name="l00132"></a>00132     
<a name="l00137"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#a11befbafac66da26deddded1dde7dd11">00137</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a11befbafac66da26deddded1dde7dd11">clone</a>()<span class="keyword"> const</span>
<a name="l00138"></a>00138 <span class="keyword">    </span>{
<a name="l00139"></a>00139 <span class="preprocessor">#ifdef __SUNPRO_CC      </span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a> *copy = 
<a name="l00141"></a>00141         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">variant_filter_iterator::Iter&lt;IterType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00142"></a>00142 <span class="preprocessor">#else</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a> *copy = 
<a name="l00144"></a>00144         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);      
<a name="l00145"></a>00145 <span class="preprocessor">#endif</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>      
<a name="l00147"></a>00147       <span class="keywordflow">return</span> copy;
<a name="l00148"></a>00148     }
<a name="l00149"></a>00149 
<a name="l00154"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#a47a238588cd276035a424d5729aa5cf4">00154</a>     <span class="keyword">virtual</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase::const_IterBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a47a238588cd276035a424d5729aa5cf4">const_clone</a>()<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword">    </span>{
<a name="l00159"></a>00159       <span class="comment">// typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::template Iter&lt;IterType&gt; const_Iter;</span>
<a name="l00160"></a>00160       <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type const, Type const &amp;,  Type const *&gt;::template</a> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a> const_Iter;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162       <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase::const_IterBase</a>* copy =
<a name="l00163"></a>00163         <span class="keyword">new</span> const_Iter(<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165       <span class="keywordflow">return</span> copy;
<a name="l00166"></a>00166     }
<a name="l00167"></a>00167 
<a name="l00171"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5bd948431a1b0a0b2b30e47d975fe5a">00171</a>     <span class="keyword">virtual</span> ReferenceType <a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5bd948431a1b0a0b2b30e47d975fe5a">operator*</a>() const   <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00172"></a>00172     {
<a name="l00173"></a>00173       <span class="keywordflow">return</span> *<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>;
<a name="l00174"></a>00174     }
<a name="l00175"></a>00175 
<a name="l00179"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#a0f8b704775af2322e9cd9622c5eac913">00179</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter</a>&amp; <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a0f8b704775af2322e9cd9622c5eac913">operator++</a>()         <span class="comment">// &lt;-- CUSTOM INTERFACE METHOD</span>
<a name="l00180"></a>00180     {
<a name="l00181"></a>00181       ++<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>;
<a name="l00182"></a>00182       <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184 
<a name="l00191"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#a1df6b54eac34da7595985bc827b435c0">00191</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php#a1df6b54eac34da7595985bc827b435c0">equal</a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a> *other)<span class="keyword"> const</span>
<a name="l00192"></a>00192 <span class="keyword">    </span>{
<a name="l00193"></a>00193       <span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>* p = 
<a name="l00194"></a>00194         libMesh::libmesh_cast_ptr&lt;const Iter&lt;IterType&gt;*&gt;(other);      
<a name="l00195"></a>00195       
<a name="l00196"></a>00196       <span class="keywordflow">return</span> (<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a> == p-&gt;<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00197"></a>00197     }
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">00202</a>     IterType <a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>;
<a name="l00203"></a>00203   };
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   
<a name="l00213"></a>00213   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> IterType, <span class="keyword">typename</span> PredType&gt;
<a name="l00214"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php">00214</a>   <span class="keyword">struct </span><a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred</a> : <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>
<a name="l00215"></a>00215   {
<a name="l00219"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php#ae66454fe61d27a236a0898dae2222f82">00219</a>     <a class="code" href="structvariant__filter__iterator_1_1Pred.php#ae66454fe61d27a236a0898dae2222f82">Pred</a> (<span class="keyword">const</span> PredType&amp; v) :
<a name="l00220"></a>00220       <a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">pred_data</a> (v) {}
<a name="l00221"></a>00221 
<a name="l00225"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php#a41b7670454e6a726e6dbeda42430d504">00225</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php#a41b7670454e6a726e6dbeda42430d504">~Pred</a> () {}
<a name="l00226"></a>00226 
<a name="l00230"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php#a92eb71efd52707d2f9bc9e999a9cd6db">00230</a>     <span class="keyword">virtual</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Pred.php#a92eb71efd52707d2f9bc9e999a9cd6db">clone</a>()<span class="keyword"> const</span>
<a name="l00231"></a>00231 <span class="keyword">    </span>{
<a name="l00232"></a>00232 <span class="preprocessor">#ifdef __SUNPRO_CC</span>
<a name="l00233"></a>00233 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Pred.php">variant_filter_iterator::Pred&lt;IterType,PredType&gt;</a> *copy = 
<a name="l00234"></a>00234         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php">variant_filter_iterator::Pred&lt;IterType,PredType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">pred_data</a>);
<a name="l00235"></a>00235 <span class="preprocessor">#else</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>      <a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred&lt;IterType,PredType&gt;</a> *copy = 
<a name="l00237"></a>00237         <span class="keyword">new</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred&lt;IterType,PredType&gt;</a>(<a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">pred_data</a>);
<a name="l00238"></a>00238 <span class="preprocessor">#endif</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>      
<a name="l00240"></a>00240       <span class="keywordflow">return</span> copy;
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00248"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php#af7125d2d7b518d6a9e78177c8d0a65b5">00248</a>     <span class="keyword">virtual</span> <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase::const_PredBase</a>* <a class="code" href="structvariant__filter__iterator_1_1Pred.php#af7125d2d7b518d6a9e78177c8d0a65b5">const_clone</a>()<span class="keyword"> const</span>
<a name="l00249"></a>00249 <span class="keyword">    </span>{
<a name="l00253"></a>00253       <span class="comment">//      typedef typename variant_filter_iterator&lt;Predicate, Type, const Type&amp;, const Type*&gt;::template Pred&lt;IterType, PredType&gt; const_Pred;</span>
<a name="l00254"></a>00254       <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type const, Type const &amp;,  Type const *&gt;::template</a> <a class="code" href="structvariant__filter__iterator_1_1Pred.php">Pred&lt;IterType, PredType&gt;</a> const_Pred;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257       <span class="keyword">typename</span> <a class="code" href="structvariant__filter__iterator_1_1PredBase.php">PredBase::const_PredBase</a>* copy =
<a name="l00258"></a>00258         <span class="keyword">new</span> const_Pred(<a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">pred_data</a>);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260       <span class="keywordflow">return</span> copy;
<a name="l00261"></a>00261     }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264     
<a name="l00265"></a>00265     
<a name="l00269"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php#a8015c99778c86868d8e17deb591808a6">00269</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php#a8015c99778c86868d8e17deb591808a6">operator() </a>(<span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1IterBase.php">IterBase</a>* in)<span class="keyword"> const</span>
<a name="l00270"></a>00270 <span class="keyword">    </span>{
<a name="l00271"></a>00271       libmesh_assert (in != NULL);
<a name="l00272"></a>00272       
<a name="l00273"></a>00273       <span class="comment">// Attempt downcast</span>
<a name="l00274"></a>00274       <span class="keyword">const</span> <a class="code" href="structvariant__filter__iterator_1_1Iter.php">Iter&lt;IterType&gt;</a>* p =
<a name="l00275"></a>00275         libMesh::libmesh_cast_ptr&lt;const Iter&lt;IterType&gt;* &gt;(in);
<a name="l00276"></a>00276       
<a name="l00277"></a>00277       <span class="comment">// Return result of op() for the user&#39;s predicate.</span>
<a name="l00278"></a>00278       <span class="keywordflow">return</span> <a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">pred_data</a>(p-&gt;<a class="code" href="structvariant__filter__iterator_1_1Iter.php#ab5e809d8734da0aabbd386f9ea2acfcd">iter_data</a>);
<a name="l00279"></a>00279     }
<a name="l00280"></a>00280     
<a name="l00284"></a><a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">00284</a>     PredType <a class="code" href="structvariant__filter__iterator_1_1Pred.php#a33306ebf933db66f4a2d073b80f43a30">pred_data</a>;
<a name="l00285"></a>00285   };
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="keyword">public</span>:
<a name="l00299"></a><a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">00299</a>   IterBase* <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00300"></a>00300 
<a name="l00305"></a><a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">00305</a>   IterBase* <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>;
<a name="l00306"></a>00306 
<a name="l00312"></a><a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">00312</a>   PredBase* <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>;
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   
<a name="l00316"></a>00316 <span class="keyword">public</span>:
<a name="l00322"></a>00322   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00323"></a><a class="code" href="classvariant__filter__iterator.php#ab37227024b090401527ec1bc8f833963">00323</a>   <a class="code" href="classvariant__filter__iterator.php#af3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00324"></a>00324                            <span class="keyword">const</span> IterType&amp; e,
<a name="l00325"></a>00325                            <span class="keyword">const</span> PredType&amp; p ):
<a name="l00326"></a>00326     <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a> ( new Iter&lt;IterType&gt;(d) ), <span class="comment">// note: uses default IterBase copy constructor</span>
<a name="l00327"></a>00327     <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>  ( new Iter&lt;IterType&gt;(e) ),
<a name="l00328"></a>00328     <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a> ( new Pred&lt;IterType,PredType&gt;(p) )
<a name="l00329"></a>00329   {
<a name="l00330"></a>00330     this-&gt;<a class="code" href="classvariant__filter__iterator.php#a4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>();
<a name="l00331"></a>00331   }
<a name="l00332"></a>00332   
<a name="l00336"></a><a class="code" href="classvariant__filter__iterator.php#af3a3f4dc726350a9318a01cb2d5f09cf">00336</a>   <a class="code" href="classvariant__filter__iterator.php#af3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> () :
<a name="l00337"></a>00337     <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>(NULL),
<a name="l00338"></a>00338     <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>(NULL),
<a name="l00339"></a>00339     <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>(NULL) {}
<a name="l00340"></a>00340 
<a name="l00345"></a><a class="code" href="classvariant__filter__iterator.php#a2e039d9d6a93535464143f7dfaca65c6">00345</a>   <a class="code" href="classvariant__filter__iterator.php#af3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> (<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">Iterator</a>&amp; rhs) :
<a name="l00346"></a>00346     <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>-&gt;clone() : NULL),
<a name="l00347"></a>00347     <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>  (rhs.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>  != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>-&gt;clone()  : NULL),
<a name="l00348"></a>00348     <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>-&gt;clone() : NULL) {}
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00363"></a>00363   <span class="keyword">template</span> &lt;<span class="keyword">class</span> OtherType, <span class="keyword">class</span> OtherReferenceType, <span class="keyword">class</span> OtherPo<span class="keywordtype">int</span>erType&gt;
<a name="l00364"></a><a class="code" href="classvariant__filter__iterator.php#ad584a71be98357fd31de2866e013663e">00364</a>   <a class="code" href="classvariant__filter__iterator.php#af3a3f4dc726350a9318a01cb2d5f09cf">variant_filter_iterator</a> (<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, OtherType, OtherReferenceType, OtherPointerType&gt;</a>&amp; rhs)
<a name="l00365"></a>00365     : <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>-&gt;const_clone() : NULL),
<a name="l00366"></a>00366       <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>  (rhs.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>  != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>-&gt;const_clone()  : NULL),
<a name="l00367"></a>00367       <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a> (rhs.<a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a> != NULL ? rhs.<a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>-&gt;const_clone() : NULL)
<a name="l00368"></a>00368   {
<a name="l00369"></a>00369     <span class="comment">// libMesh::out &lt;&lt; &quot;Called templated copy constructor for variant_filter_iterator&quot; &lt;&lt; std::endl;</span>
<a name="l00370"></a>00370   }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   
<a name="l00376"></a>00376   
<a name="l00380"></a><a class="code" href="classvariant__filter__iterator.php#ab44e43ae0e17f90b99f298b0d823cdc7">00380</a>   <span class="keyword">virtual</span> <a class="code" href="classvariant__filter__iterator.php#ab44e43ae0e17f90b99f298b0d823cdc7">~variant_filter_iterator</a>()
<a name="l00381"></a>00381   {
<a name="l00382"></a>00382     <span class="keyword">delete</span> <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>; <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a> = NULL;
<a name="l00383"></a>00383     <span class="keyword">delete</span> <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>;  <a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>  = NULL;
<a name="l00384"></a>00384     <span class="keyword">delete</span> <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>; <a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a> = NULL;
<a name="l00385"></a>00385   }
<a name="l00386"></a>00386   
<a name="l00390"></a><a class="code" href="classvariant__filter__iterator.php#a4bb7a327fcb2664488f4dfee1d5dc595">00390</a>   ReferenceType <a class="code" href="classvariant__filter__iterator.php#a4bb7a327fcb2664488f4dfee1d5dc595">operator*</a>()<span class="keyword"> const</span>
<a name="l00391"></a>00391 <span class="keyword">  </span>{
<a name="l00392"></a>00392     <span class="keywordflow">return</span> **<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00393"></a>00393   }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00399"></a><a class="code" href="classvariant__filter__iterator.php#a2011fabe87e16e10e7e9831fdd30aa53">00399</a>   PointerType <a class="code" href="classvariant__filter__iterator.php#a2011fabe87e16e10e7e9831fdd30aa53">operator-&gt;</a>()<span class="keyword"> const</span>
<a name="l00400"></a>00400 <span class="keyword">  </span>{
<a name="l00401"></a>00401     <span class="keywordflow">return</span> (&amp;**<span class="keyword">this</span>);
<a name="l00402"></a>00402   }
<a name="l00403"></a>00403   
<a name="l00407"></a><a class="code" href="classvariant__filter__iterator.php#ac98d8f165f14deae8050c7e062d0e78e">00407</a>   <a class="code" href="classvariant__filter__iterator.php">Iterator</a>&amp; <a class="code" href="classvariant__filter__iterator.php#ac98d8f165f14deae8050c7e062d0e78e">operator++</a>()
<a name="l00408"></a>00408   {
<a name="l00409"></a>00409     ++*<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00410"></a>00410     this-&gt;<a class="code" href="classvariant__filter__iterator.php#a4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>();
<a name="l00411"></a>00411     <span class="keywordflow">return</span> (*<span class="keyword">this</span>);
<a name="l00412"></a>00412   }
<a name="l00413"></a>00413 
<a name="l00417"></a><a class="code" href="classvariant__filter__iterator.php#aca856aa2d2cea4b98e37e11c2373382e">00417</a>   <span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">Iterator</a> <a class="code" href="classvariant__filter__iterator.php#ac98d8f165f14deae8050c7e062d0e78e">operator++</a>(<span class="keywordtype">int</span>) <span class="comment">// const here to prevent iterator++++ type operations</span>
<a name="l00418"></a>00418   {
<a name="l00419"></a>00419     <a class="code" href="classvariant__filter__iterator.php">Iterator</a> oldValue(*<span class="keyword">this</span>); <span class="comment">// standard is to return old value</span>
<a name="l00420"></a>00420     ++*<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>;
<a name="l00421"></a>00421     this-&gt;<a class="code" href="classvariant__filter__iterator.php#a4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>();
<a name="l00422"></a>00422     <span class="keywordflow">return</span> oldValue;
<a name="l00423"></a>00423   }
<a name="l00424"></a>00424 
<a name="l00431"></a><a class="code" href="classvariant__filter__iterator.php#a525841235875ad49bbe5ee29681edb8c">00431</a>   <span class="keywordtype">bool</span> <a class="code" href="classvariant__filter__iterator.php#a525841235875ad49bbe5ee29681edb8c">equal</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&amp; other)<span class="keyword"> const</span>
<a name="l00432"></a>00432 <span class="keyword">  </span>{
<a name="l00433"></a>00433     <span class="keywordflow">return</span> <a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>-&gt;<a class="code" href="structvariant__filter__iterator_1_1IterBase.php#ad950ec9d5c1e122a832a57f5e37b7fc6">equal</a>(other.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>);
<a name="l00434"></a>00434   }
<a name="l00435"></a>00435 
<a name="l00439"></a><a class="code" href="classvariant__filter__iterator.php#a1170519c7839bb1f534e68fe4481e222">00439</a>   <span class="keywordtype">void</span> <a class="code" href="classvariant__filter__iterator.php#a1170519c7839bb1f534e68fe4481e222">swap</a>(<a class="code" href="classvariant__filter__iterator.php">Iterator</a>&amp; lhs, <a class="code" href="classvariant__filter__iterator.php">Iterator</a>&amp; rhs)
<a name="l00440"></a>00440   {
<a name="l00441"></a>00441     <span class="comment">// Swap the data pointers</span>
<a name="l00442"></a>00442     <a class="code" href="classvariant__filter__iterator.php#a1170519c7839bb1f534e68fe4481e222">std::swap</a> (lhs.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>, rhs.<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>);
<a name="l00443"></a>00443 
<a name="l00444"></a>00444     <span class="comment">// Swap the end pointers</span>
<a name="l00445"></a>00445     <a class="code" href="classvariant__filter__iterator.php#a1170519c7839bb1f534e68fe4481e222">std::swap</a> (lhs.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>, rhs.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447     <span class="comment">// Also swap the predicate objects.</span>
<a name="l00448"></a>00448     <a class="code" href="classvariant__filter__iterator.php#a1170519c7839bb1f534e68fe4481e222">std::swap</a> (lhs.<a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>, rhs.<a class="code" href="classvariant__filter__iterator.php#a313cad79630e8e081d2a0379b125a6ca">pred</a>);
<a name="l00449"></a>00449   }
<a name="l00450"></a>00450 
<a name="l00454"></a><a class="code" href="classvariant__filter__iterator.php#a3f7dce148857c6a2f6b66a92ec16347e">00454</a>   <a class="code" href="classvariant__filter__iterator.php">Iterator</a>&amp; <a class="code" href="classvariant__filter__iterator.php#a3f7dce148857c6a2f6b66a92ec16347e">operator=</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">Iterator</a>&amp; rhs)
<a name="l00455"></a>00455   {
<a name="l00456"></a>00456     <a class="code" href="classvariant__filter__iterator.php">Iterator</a> temp(rhs);
<a name="l00457"></a>00457     <a class="code" href="classvariant__filter__iterator.php#a1170519c7839bb1f534e68fe4481e222">swap</a>(temp, *<span class="keyword">this</span>);
<a name="l00458"></a>00458     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00459"></a>00459   }
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462   
<a name="l00463"></a>00463 <span class="keyword">private</span>:
<a name="l00464"></a>00464   
<a name="l00469"></a><a class="code" href="classvariant__filter__iterator.php#a4c71b0455ada6518e5b7ee735f21aaa8">00469</a>   <span class="keywordtype">void</span> <a class="code" href="classvariant__filter__iterator.php#a4c71b0455ada6518e5b7ee735f21aaa8">satisfy_predicate</a>()
<a name="l00470"></a>00470   {
<a name="l00471"></a>00471     <span class="keywordflow">while</span> ( !<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>-&gt;<a class="code" href="structvariant__filter__iterator_1_1IterBase.php#ad950ec9d5c1e122a832a57f5e37b7fc6">equal</a>(<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>) &amp;&amp; !(*pred)(<a class="code" href="classvariant__filter__iterator.php#a938a5a347ebca2588769ffce74daa428">data</a>) )
<a name="l00472"></a>00472       ++(*data);
<a name="l00473"></a>00473   }  
<a name="l00474"></a>00474 };
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00482"></a>00482 <span class="comment">// op==</span>
<a name="l00483"></a>00483 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Predicate, <span class="keyword">class</span> Type, <span class="keyword">class</span> ReferenceType, <span class="keyword">class</span> Po<span class="keywordtype">int</span>erType&gt;
<a name="l00484"></a>00484 <span class="keyword">inline</span>
<a name="l00485"></a><a class="code" href="variant__filter__iterator_8h.php#a3201fc9c9bbdb9eaf27ae0bbee186846">00485</a> <span class="keywordtype">bool</span> <a class="code" href="variant__filter__iterator_8h.php#a3201fc9c9bbdb9eaf27ae0bbee186846">operator==</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; x,
<a name="l00486"></a>00486                 <span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; y)
<a name="l00487"></a>00487 {
<a name="l00488"></a>00488   <span class="keywordflow">return</span> x.<a class="code" href="classvariant__filter__iterator.php#a525841235875ad49bbe5ee29681edb8c">equal</a>(y);
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 <span class="comment">// op!=</span>
<a name="l00494"></a>00494 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Predicate, <span class="keyword">class</span> Type, <span class="keyword">class</span> ReferenceType, <span class="keyword">class</span> Po<span class="keywordtype">int</span>erType&gt;
<a name="l00495"></a>00495 <span class="keyword">inline</span>
<a name="l00496"></a><a class="code" href="variant__filter__iterator_8h.php#abca78fc01f1572f1977080638637880d">00496</a> <span class="keywordtype">bool</span> <a class="code" href="variant__filter__iterator_8h.php#abca78fc01f1572f1977080638637880d">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; x,
<a name="l00497"></a>00497                 <span class="keyword">const</span> <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator&lt;Predicate, Type, ReferenceType, PointerType&gt;</a>&amp; y)
<a name="l00498"></a>00498 {
<a name="l00499"></a>00499   <span class="keywordflow">return</span> !(x == y);
<a name="l00500"></a>00500 }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
