<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">vector_value.h</div>  </div>
</div>
<div class="contents">
<a href="vector__value_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: vector_value.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __vector_value_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __vector_value_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="type__vector_8h.php">type_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1VectorValue.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>&lt;T&gt;
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue</a>  (<span class="keyword">const</span> T x=0.,
<a name="l00054"></a>00054                 <span class="keyword">const</span> T y=0.,
<a name="l00055"></a>00055                 <span class="keyword">const</span> T z=0.);
<a name="l00056"></a>00056   
<a name="l00060"></a>00060   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue&lt;T2&gt;</a>&amp; p);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_re,
<a name="l00077"></a>00077                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_im);
<a name="l00078"></a>00078 <span class="preprocessor">#endif</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>
<a name="l00080"></a>00080   
<a name="l00081"></a>00081 <span class="keyword">private</span>:
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   
<a name="l00084"></a>00084 };
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00092"></a>00092 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue&lt;Real&gt;</a>   <a class="code" href="namespacelibMesh.php#a7b24a45345db9b61375489cb2d385538">RealVectorValue</a>;
<a name="l00093"></a>00093 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue&lt;Number&gt;</a> <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a>;
<a name="l00094"></a>00094 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">RealVectorValue</a>     <a class="code" href="namespacelibMesh.php#adabb700efe8eff368f2a23cb17dce706">RealGradient</a>;
<a name="l00095"></a>00095 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">NumberVectorValue</a>   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="comment">//------------------------------------------------------</span>
<a name="l00100"></a>00100 <span class="comment">// Inline functions</span>
<a name="l00101"></a>00101 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00102"></a>00102 <span class="keyword">inline</span>
<a name="l00103"></a><a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">00103</a> <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> T x,
<a name="l00104"></a>00104                              <span class="keyword">const</span> T y,
<a name="l00105"></a>00105                              <span class="keyword">const</span> T z) :
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>&lt;T&gt; (x,y,z)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00113"></a>00113 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00114"></a>00114 <span class="keyword">inline</span>
<a name="l00115"></a><a class="code" href="classlibMesh_1_1VectorValue.php#ac0317c656453a76bf9df0c471cb6ed08">00115</a> <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue&lt;T2&gt;</a>&amp; p) :
<a name="l00116"></a>00116   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>&lt;T&gt; (p)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00123"></a>00123 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00124"></a>00124 <span class="keyword">inline</span>
<a name="l00125"></a><a class="code" href="classlibMesh_1_1VectorValue.php#ad4d7164c6865567e2c782cb2b22a2076">00125</a> <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;T2&gt;</a>&amp; p) :
<a name="l00126"></a>00126   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>&lt;T&gt; (p)
<a name="l00127"></a>00127 {
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00133"></a>00133 <span class="keyword">inline</span>
<a name="l00134"></a><a class="code" href="classlibMesh_1_1VectorValue.php#a580824417d1b7e4eec42868a7dce51ce">00134</a> <a class="code" href="classlibMesh_1_1VectorValue.php#a7af28e8c55ef3dd994cfb080538672d5">VectorValue&lt;T&gt;::VectorValue</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_re,
<a name="l00135"></a>00135                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector&lt;Real&gt;</a>&amp; p_im) :
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1TypeVector.php">TypeVector</a>&lt;T&gt; (<a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(0), p_im(0)),
<a name="l00137"></a>00137                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(1), p_im(1)),
<a name="l00138"></a>00138                  <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> (p_re(2), p_im(2)))
<a name="l00139"></a>00139 {
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 <span class="preprocessor">#endif</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 } <span class="comment">// namespace libMesh</span>
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="preprocessor">#endif // #define __vector_value_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
