<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_cxx.h</div>  </div>
</div>
<div class="contents">
<a href="xdr__cxx_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_cxx.h 4272 2011-03-18 17:40:18Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __xdr_cxx_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_cxx_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="enum__xdr__mode_8h.php">enum_xdr_mode.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// C++ includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;rpc/rpc.h&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;iosfwd&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor"># include &lt;complex&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="preprocessor">#define xdr_MAX_STRING_LENGTH 256</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="preprocessor">#ifndef LIBMESH_DEFAULT_SINGLE_PRECISION</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#define xdr_REAL xdr_double</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#define xdr_REAL xdr_float</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="keyword">namespace </span>libMesh
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// Xdr class definition</span>
<a name="l00058"></a>00058 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1Xdr.php">00067</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1Xdr.php#a4d6da7e91e39ea1a00830942f03e51c2">Xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">libMeshEnums::XdrMODE</a> m=<a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a9e4c21571990496ef66e6212465b5760">UNKNOWN</a>);
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1Xdr.php#a81d10e761936f92f1e886cc32d63bf50">~Xdr</a> ();
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a87b80f1eaa4ef62d5d97ec18da5a6be9">open</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#aec6e011b6f52a182c8f181c2290456de">close</a>();
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>() <span class="keyword">const</span>;
<a name="l00098"></a>00098 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">00103</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> ((<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>) || (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>)); }
<a name="l00104"></a>00104 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">00109</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">writing</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> ((<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>) || (<a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>)); }
<a name="l00110"></a>00110 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Xdr.php#a46e8a8db60dbaa8d9a81dec815049aaa">00115</a>   <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> <a class="code" href="classlibMesh_1_1Xdr.php#a46e8a8db60dbaa8d9a81dec815049aaa">access_mode</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>; }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// Data access methods</span>
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(T&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">comment</a>=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00124"></a>00124 
<a name="l00128"></a>00128   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00129"></a><a class="code" href="classlibMesh_1_1Xdr.php#ae69d2d6bf59f74adb7e1ee5efb422b46">00129</a>   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; <a class="code" href="classlibMesh_1_1Xdr.php#ae69d2d6bf59f74adb7e1ee5efb422b46">operator &lt;&lt; </a>(T&amp; a) { libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">writing</a>()); <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00135"></a><a class="code" href="classlibMesh_1_1Xdr.php#a33412ed0f2c4c7ed47dd802af153ee2a">00135</a>   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; <a class="code" href="classlibMesh_1_1Xdr.php#a33412ed0f2c4c7ed47dd802af153ee2a">operator &gt;&gt; </a>(T&amp; a) { libmesh_assert (<a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>()); <a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00136"></a>00136   
<a name="l00140"></a>00140   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">data_stream</a> (T *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break=<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">comment</a> (std::string &amp;);
<a name="l00147"></a>00147   
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="keyword">private</span>:
<a name="l00150"></a>00150 
<a name="l00154"></a>00154   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">do_read</a>(T&amp; a);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00158"></a>00158   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">do_read</a>(std::complex&lt;T&gt;&amp; a);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">do_read</a>(std::vector&lt;T&gt;&amp; a);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00164"></a>00164   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#a076c0e3c482eadea9c32547f27b22a0d">do_read</a>(std::vector&lt;std::complex&lt;T&gt; &gt;&amp; a);
<a name="l00165"></a>00165 
<a name="l00169"></a>00169   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(T&amp; a);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00173"></a>00173   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(std::complex&lt;T&gt;&amp; a);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(std::vector&lt;T&gt;&amp; a);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Xdr.php#af684f6d64b0241bff0b33dade59c68f0">do_write</a>(std::vector&lt;std::complex&lt;T&gt; &gt;&amp; a);
<a name="l00180"></a>00180 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">00184</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> <a class="code" href="classlibMesh_1_1Xdr.php#a6a8c422d1ff20293804d45ae6ce8efd8">mode</a>;
<a name="l00185"></a>00185 
<a name="l00189"></a><a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">00189</a>   std::string <a class="code" href="classlibMesh_1_1Xdr.php#a2166573cc1fc5e4c42ed041416c45da1">file_name</a>;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>  
<a name="l00199"></a><a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">00199</a>   XDR* <a class="code" href="classlibMesh_1_1Xdr.php#a21085b5edf0f8e659840649437da98e8">xdrs</a>;
<a name="l00200"></a>00200 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">00204</a>   FILE* <a class="code" href="classlibMesh_1_1Xdr.php#a7380d1ad6d90509a125247441218910e">fp</a>;
<a name="l00205"></a>00205   
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>
<a name="l00211"></a><a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">00211</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;std::istream&gt;</a> <a class="code" href="classlibMesh_1_1Xdr.php#a90dea8073f1a0d8d0315c22fd408e7ec">in</a>;
<a name="l00212"></a>00212 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">00216</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;std::ostream&gt;</a> <a class="code" href="classlibMesh_1_1Xdr.php#a1cc9cc60e3a68f70cd35bc7528408fd6">out</a>;
<a name="l00217"></a>00217 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">00221</a>   <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Xdr.php#a5254e6bf8f5faad6b858e258e497ba6e">comm_len</a>;
<a name="l00222"></a><a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">00222</a>   <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1Xdr.php#a5fcf1760d922e948634032ee556e8277">comm</a>[xdr_MAX_STRING_LENGTH];  
<a name="l00223"></a>00223 
<a name="l00227"></a><a class="code" href="classlibMesh_1_1Xdr.php#addebeb2cd103ea45f93f72cf70e01b1e">00227</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Xdr.php#ac6ac7b13397c8b728a3add588afbd77f">gzipped_file</a>, <a class="code" href="classlibMesh_1_1Xdr.php#a23ead5481f3ed8bd7d63bfdad00e88da">bzipped_file</a>, <a class="code" href="classlibMesh_1_1Xdr.php#addebeb2cd103ea45f93f72cf70e01b1e">xzipped_file</a>;
<a name="l00228"></a>00228 };
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 } <span class="comment">// namespace libMesh</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
