<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_io.h</div>  </div>
</div>
<div class="contents">
<a href="xdr__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_io.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __xdr_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>MeshBase;
<a name="l00040"></a>00040 <span class="keyword">class </span>MeshData;
<a name="l00041"></a>00041 <span class="keyword">class </span>Xdr;
<a name="l00042"></a>00042 <span class="keyword">class </span>Elem;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// XdrIO class definition</span>
<a name="l00052"></a><a class="code" href="classlibMesh_1_1XdrIO.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1XdrIO.php">XdrIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00053"></a>00053               <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 
<a name="l00056"></a>00056  <span class="keyword">public</span>:
<a name="l00057"></a>00057 
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1XdrIO.php#a091d268c6dc55b032737e7a5feae5e56">XdrIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;,       <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00066"></a>00066 
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1XdrIO.php#a091d268c6dc55b032737e7a5feae5e56">XdrIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00075"></a>00075   
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a3a68c9da2fcf48538d5046f3eb774c6b">~XdrIO</a> ();
<a name="l00080"></a>00080   
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#ac5e61b735c35aecbeacf3da421c4afb6">read</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00085"></a>00085     
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#af03ee4419d64f47236b3459bbc3f17ed">write</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a06ba25e781d9a45faeb2d3325c152ee8">00094</a>   <span class="keywordtype">bool</span>   <a class="code" href="classlibMesh_1_1XdrIO.php#a06ba25e781d9a45faeb2d3325c152ee8">binary</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a29156e67c39399b00c9f88589a1e0bb3">_binary</a>; };
<a name="l00095"></a><a class="code" href="classlibMesh_1_1XdrIO.php#aae9367659a2fbe9fc676ebc22202ec7a">00095</a>   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#aae9367659a2fbe9fc676ebc22202ec7a">binary</a>()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a29156e67c39399b00c9f88589a1e0bb3">_binary</a>; };
<a name="l00096"></a>00096   
<a name="l00100"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a8634a4e2f0d3fc91a44c12ccc20d704f">00100</a>   <span class="keywordtype">bool</span>   <a class="code" href="classlibMesh_1_1XdrIO.php#a8634a4e2f0d3fc91a44c12ccc20d704f">legacy</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a7d7ca760fd76bb534e623aa3acde9a75">_legacy</a>; };
<a name="l00101"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a3881b59581d50d8ccbb52f340ad272a4">00101</a>   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#a3881b59581d50d8ccbb52f340ad272a4">legacy</a>()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a7d7ca760fd76bb534e623aa3acde9a75">_legacy</a>; };
<a name="l00102"></a>00102   
<a name="l00115"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a33b051da5512fa02e7805deb140b1941">00115</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#a33b051da5512fa02e7805deb140b1941">version</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a8e19c6c63842a8ddfce0e040426a62c7">_version</a>; };
<a name="l00116"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a34fa5904da6b1b9b9ff1e6646f2956b4">00116</a>   std::string &amp;       <a class="code" href="classlibMesh_1_1XdrIO.php#a34fa5904da6b1b9b9ff1e6646f2956b4">version</a> ()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a8e19c6c63842a8ddfce0e040426a62c7">_version</a>; };
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a425b4b84469f0613c13f32116290c93d">00121</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#a425b4b84469f0613c13f32116290c93d">boundary_condition_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a06cc9f43a614610f9335449f53fcc9f1">_bc_file_name</a>; };
<a name="l00122"></a><a class="code" href="classlibMesh_1_1XdrIO.php#af6fbea8ee484cbd46cc8cd6cd8547477">00122</a>   std::string &amp;       <a class="code" href="classlibMesh_1_1XdrIO.php#af6fbea8ee484cbd46cc8cd6cd8547477">boundary_condition_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a06cc9f43a614610f9335449f53fcc9f1">_bc_file_name</a>; };
<a name="l00123"></a>00123 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a4a4f52f884be013415de3e553b2d4bab">00127</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#a4a4f52f884be013415de3e553b2d4bab">partition_map_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a9f10a19e56517efcd7cea80737d1c19e">_partition_map_file</a>; };
<a name="l00128"></a><a class="code" href="classlibMesh_1_1XdrIO.php#af6cdf686d7497497afb0019d18a2d24b">00128</a>   std::string &amp;       <a class="code" href="classlibMesh_1_1XdrIO.php#af6cdf686d7497497afb0019d18a2d24b">partition_map_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a9f10a19e56517efcd7cea80737d1c19e">_partition_map_file</a>; };
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a869fa310827c82b31b7ccdf1214be580">00133</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#a869fa310827c82b31b7ccdf1214be580">subdomain_map_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a5bd4718d5d0656faf648d79c298f5e35">_subdomain_map_file</a>; };
<a name="l00134"></a><a class="code" href="classlibMesh_1_1XdrIO.php#aada67a3525a045cf7826241f7ea43153">00134</a>   std::string &amp;       <a class="code" href="classlibMesh_1_1XdrIO.php#aada67a3525a045cf7826241f7ea43153">subdomain_map_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a5bd4718d5d0656faf648d79c298f5e35">_subdomain_map_file</a>; };
<a name="l00135"></a>00135 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1XdrIO.php#ad9f7b9f1b99a5ca1b81e8f8de79c700d">00139</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classlibMesh_1_1XdrIO.php#ad9f7b9f1b99a5ca1b81e8f8de79c700d">polynomial_level_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#aed056d9c2e68d9644103d22a6b303a18">_p_level_file</a>; };
<a name="l00140"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a1d5eb85d5d45bf1129da6b0c754da038">00140</a>   std::string &amp;       <a class="code" href="classlibMesh_1_1XdrIO.php#a1d5eb85d5d45bf1129da6b0c754da038">polynomial_level_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrIO.php#aed056d9c2e68d9644103d22a6b303a18">_p_level_file</a>; };
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143  <span class="keyword">private</span>:
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00147"></a>00147   <span class="comment">// Write Implementation  </span>
<a name="l00151"></a>00151 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#ab82707164414211bc4a31cf78f21b381">write_serialized_connectivity</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>) <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a5e50a95296ac2d862cdfe4d8758a1142">write_serialized_nodes</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>) <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#accf8c2299f8c23a385cb98f0e2bf7302">write_serialized_bcs</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs) <span class="keyword">const</span>;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   
<a name="l00165"></a>00165   <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00166"></a>00166   <span class="comment">// Read Implementation</span>
<a name="l00170"></a>00170 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a98d50d604630a066b013bd6c783c6677">read_serialized_connectivity</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>);
<a name="l00171"></a>00171 
<a name="l00175"></a>00175   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#aa28eead2abd961c10789d388c7387bfd">read_serialized_nodes</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>);
<a name="l00176"></a>00176 
<a name="l00180"></a>00180   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#aa0490951818fad9163cad50dd542dfb6">read_serialized_bcs</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00186"></a>00186 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a88ef51ba6805be0f8ec58d20153f109f">pack_element</a> (std::vector&lt;unsigned int&gt; &amp;conn, 
<a name="l00187"></a>00187                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem, 
<a name="l00188"></a>00188                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id  = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>,
<a name="l00189"></a>00189                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_pid = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a29156e67c39399b00c9f88589a1e0bb3">00191</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a29156e67c39399b00c9f88589a1e0bb3">_binary</a>;
<a name="l00192"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a7d7ca760fd76bb534e623aa3acde9a75">00192</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1XdrIO.php#a7d7ca760fd76bb534e623aa3acde9a75">_legacy</a>;
<a name="l00193"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a8e19c6c63842a8ddfce0e040426a62c7">00193</a>   std::string <a class="code" href="classlibMesh_1_1XdrIO.php#a8e19c6c63842a8ddfce0e040426a62c7">_version</a>;
<a name="l00194"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a06cc9f43a614610f9335449f53fcc9f1">00194</a>   std::string <a class="code" href="classlibMesh_1_1XdrIO.php#a06cc9f43a614610f9335449f53fcc9f1">_bc_file_name</a>;
<a name="l00195"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a9f10a19e56517efcd7cea80737d1c19e">00195</a>   std::string <a class="code" href="classlibMesh_1_1XdrIO.php#a9f10a19e56517efcd7cea80737d1c19e">_partition_map_file</a>;
<a name="l00196"></a><a class="code" href="classlibMesh_1_1XdrIO.php#a5bd4718d5d0656faf648d79c298f5e35">00196</a>   std::string <a class="code" href="classlibMesh_1_1XdrIO.php#a5bd4718d5d0656faf648d79c298f5e35">_subdomain_map_file</a>;
<a name="l00197"></a><a class="code" href="classlibMesh_1_1XdrIO.php#aed056d9c2e68d9644103d22a6b303a18">00197</a>   std::string <a class="code" href="classlibMesh_1_1XdrIO.php#aed056d9c2e68d9644103d22a6b303a18">_p_level_file</a>;
<a name="l00198"></a>00198 
<a name="l00202"></a><a class="code" href="classlibMesh_1_1XdrIO.php#ae002437be3f47bc687f6348744841f42">00202</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrIO.php#ae002437be3f47bc687f6348744841f42">io_blksize</a>;
<a name="l00203"></a>00203 };
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 } <span class="comment">// namespace libMesh</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="preprocessor">#endif // #define __xdr_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
