<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_mesh.C</div>  </div>
</div>
<div class="contents">
<a href="xdr__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mesh.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mesh_8h.php">xdr_mesh.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mhead_8h.php">xdr_mhead.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span> <span class="comment">// for ElemType</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00029"></a>00029 <span class="comment">// XdrMESH members</span>
<a name="l00030"></a><a class="code" href="classlibMesh_1_1XdrMESH.php#a840da33262d0310cfcdf1368bdd5f924">00030</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMESH.php#a840da33262d0310cfcdf1368bdd5f924">XdrMESH::header</a>(<a class="code" href="classlibMesh_1_1XdrMHEAD.php">XdrMHEAD</a> *hd)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="comment">// Temporary variables to facilitate stream reading</span>
<a name="l00033"></a>00033   <span class="keyword">const</span> <span class="keywordtype">int</span> comm_len= 256;  
<a name="l00034"></a>00034   <span class="keywordtype">char</span> comment[comm_len];
<a name="l00035"></a>00035   
<a name="l00036"></a>00036   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038       
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>      
<a name="l00041"></a>00041     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00042"></a>00042     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>): 
<a name="l00043"></a>00043       {
<a name="l00044"></a>00044         xdr_int(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ab8913bc7f50f382fbe24ec7e9607e939">m_numel</a>));
<a name="l00045"></a>00045         xdr_int(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ac405d0d42e38c983216e724128fce431">m_numNodes</a>));
<a name="l00046"></a>00046         xdr_int(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aa2fb94613d95ed13d4f761d290438c92">m_sumWghts</a>));
<a name="l00047"></a>00047         xdr_int(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#a8f4c78e133c8939d99d47647ccf8d685">m_numBCs</a>));
<a name="l00048"></a>00048         xdr_int(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aac06650be0aa7a3f287fe4a7447c8537">m_strSize</a>));
<a name="l00049"></a>00049         <span class="keywordflow">break</span>;
<a name="l00050"></a>00050       }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>      
<a name="l00054"></a>00054     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00055"></a>00055       {
<a name="l00056"></a>00056         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ab8913bc7f50f382fbe24ec7e9607e939">m_numel</a>    &lt;&lt; <span class="stringliteral">&quot;\t # Num. Elements\n&quot;</span>;
<a name="l00057"></a>00057         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ac405d0d42e38c983216e724128fce431">m_numNodes</a> &lt;&lt; <span class="stringliteral">&quot;\t # Num. Nodes\n&quot;</span>;
<a name="l00058"></a>00058         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aa2fb94613d95ed13d4f761d290438c92">m_sumWghts</a> &lt;&lt; <span class="stringliteral">&quot;\t # Sum of Element Weights\n&quot;</span>;
<a name="l00059"></a>00059         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#a8f4c78e133c8939d99d47647ccf8d685">m_numBCs</a>   &lt;&lt; <span class="stringliteral">&quot;\t # Num. Boundary Conds.\n&quot;</span>;
<a name="l00060"></a>00060         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aac06650be0aa7a3f287fe4a7447c8537">m_strSize</a>  &lt;&lt; <span class="stringliteral">&quot;\t # String Size (ignore)\n&quot;</span>;
<a name="l00061"></a>00061         <span class="keywordflow">break</span>;
<a name="l00062"></a>00062       }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00065"></a>00065       {
<a name="l00066"></a>00066         libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00067"></a>00067         
<a name="l00068"></a>00068         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ab8913bc7f50f382fbe24ec7e9607e939">m_numel</a>    ; <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00069"></a>00069         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ac405d0d42e38c983216e724128fce431">m_numNodes</a> ; <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00070"></a>00070         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aa2fb94613d95ed13d4f761d290438c92">m_sumWghts</a> ; <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00071"></a>00071         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#a8f4c78e133c8939d99d47647ccf8d685">m_numBCs</a>   ; <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00072"></a>00072         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aac06650be0aa7a3f287fe4a7447c8537">m_strSize</a>  ; <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074         libmesh_assert(<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00075"></a>00075 
<a name="l00076"></a>00076         <span class="keywordflow">break</span>;
<a name="l00077"></a>00077       }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keywordflow">default</span>:
<a name="l00080"></a>00080       <span class="comment">// Unknown access type</span>
<a name="l00081"></a>00081       libmesh_error();
<a name="l00082"></a>00082       
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="comment">// Let&#39;s write the augmented header information</span>
<a name="l00086"></a>00086   <span class="comment">// before we write the title and id string</span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// Both DEAL and LIBM style files have augmented headers.</span>
<a name="l00089"></a>00089   <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> == 0) || (<a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> == 2)) 
<a name="l00090"></a>00090     {
<a name="l00091"></a>00091 
<a name="l00092"></a>00092       <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00093"></a>00093         {
<a name="l00094"></a>00094           
<a name="l00095"></a>00095 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>          
<a name="l00097"></a>00097         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00098"></a>00098         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00099"></a>00099           {
<a name="l00100"></a>00100             <span class="comment">// this used to be 0.  How did that work?</span>
<a name="l00101"></a>00101             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp_n_blocks = hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>(); 
<a name="l00102"></a>00102             xdr_u_int(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;temp_n_blocks);
<a name="l00103"></a>00103             hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#a9d08aad7addbac95c254b4c1442f677e">set_n_blocks</a>(temp_n_blocks);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105             <span class="comment">// The number of blocks (i.e. the number of element types)</span>
<a name="l00106"></a>00106             <span class="comment">// for any mesh must always</span>
<a name="l00107"></a>00107             <span class="comment">// be at least 1.</span>
<a name="l00108"></a>00108             libmesh_assert(hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>() != 0);
<a name="l00109"></a>00109             <span class="keywordflow">break</span>;
<a name="l00110"></a>00110           }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#endif</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>          
<a name="l00114"></a>00114         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00115"></a>00115           {
<a name="l00116"></a>00116             <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>() &lt;&lt; <span class="stringliteral">&quot;\t # Num. Element Blocks.\n&quot;</span>;
<a name="l00117"></a>00117             <span class="keywordflow">break</span>;
<a name="l00118"></a>00118           }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00121"></a>00121           {
<a name="l00122"></a>00122             libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00123"></a>00123             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp_n_blocks=0;
<a name="l00124"></a>00124             <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; temp_n_blocks;
<a name="l00125"></a>00125             hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#a9d08aad7addbac95c254b4c1442f677e">set_n_blocks</a>(temp_n_blocks);
<a name="l00126"></a>00126             <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00127"></a>00127             <span class="keywordflow">break</span>;
<a name="l00128"></a>00128           }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130         <span class="keywordflow">default</span>:
<a name="l00131"></a>00131           <span class="comment">// Unknown access type</span>
<a name="l00132"></a>00132           libmesh_error();
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135       
<a name="l00136"></a>00136       std::vector&lt;ElemType&gt; et;
<a name="l00137"></a>00137       hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#abdbabb97df064d82a06590418201b72d">get_block_elt_types</a>(et);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       
<a name="l00140"></a>00140       <span class="comment">// Note:  If DECODING or READING, allocate space in the vector</span>
<a name="l00141"></a>00141       <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">DECODE</a>) || (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">R_ASCII</a>))
<a name="l00142"></a>00142         et.resize(hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>());  
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145       <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00146"></a>00146         {
<a name="l00147"></a>00147           
<a name="l00148"></a>00148 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span>          
<a name="l00150"></a>00150         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00151"></a>00151         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00152"></a>00152           {
<a name="l00153"></a>00153             xdr_vector(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,
<a name="l00154"></a>00154                        (<span class="keywordtype">char</span> *) &amp;et[0],
<a name="l00155"></a>00155                        et.size(), 
<a name="l00156"></a>00156                        <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> int),
<a name="l00157"></a>00157                        (xdrproc_t) xdr_u_int);
<a name="l00158"></a>00158             <span class="keywordflow">break</span>;
<a name="l00159"></a>00159           }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>
<a name="l00163"></a>00163         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00164"></a>00164           {
<a name="l00165"></a>00165             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>(); i++)
<a name="l00166"></a>00166               <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; et[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00167"></a>00167               
<a name="l00168"></a>00168             <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; <span class="stringliteral">&quot;\t # Element types in each block.\n&quot;</span>;
<a name="l00169"></a>00169             <span class="keywordflow">break</span>;
<a name="l00170"></a>00170           }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00173"></a>00173           {
<a name="l00174"></a>00174             libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00175"></a>00175         
<a name="l00176"></a>00176             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>(); i++)
<a name="l00177"></a>00177               {
<a name="l00178"></a>00178                 <span class="comment">// convoluted way of doing it to</span>
<a name="l00179"></a>00179                 <span class="comment">// satisfy icc</span>
<a name="l00180"></a>00180                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> type;
<a name="l00181"></a>00181                 
<a name="l00182"></a>00182                 <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; type ;
<a name="l00183"></a>00183                 
<a name="l00184"></a>00184                 et[i] = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a><span class="keyword">&gt;</span>(type) ;
<a name="l00185"></a>00185               }
<a name="l00186"></a>00186             <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00187"></a>00187             <span class="keywordflow">break</span>;
<a name="l00188"></a>00188           }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         <span class="keywordflow">default</span>:
<a name="l00191"></a>00191           <span class="comment">// Unknown access type</span>
<a name="l00192"></a>00192           libmesh_error();
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196       
<a name="l00197"></a>00197       <span class="comment">// Note:  If DECODING or READING, you need to set the value </span>
<a name="l00198"></a>00198       <span class="comment">// in the header data structure.</span>
<a name="l00199"></a>00199       <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">DECODE</a>) || (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">R_ASCII</a>)) 
<a name="l00200"></a>00200         hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#a5ee4d62786a85ee04bd270173e2bb2c7">set_block_elt_types</a>(et);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       std::vector&lt;unsigned int&gt; neeb;
<a name="l00204"></a>00204       hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#acb58d6aa78f0259b2a78ab759e126028">get_num_elem_each_block</a>(neeb);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206       <span class="comment">// If DECODING or READING, allocate space for the vector </span>
<a name="l00207"></a>00207       <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">DECODE</a>) || (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">R_ASCII</a>))
<a name="l00208"></a>00208         neeb.resize( hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>()*(this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#accd9072374f310e64f48b1d83e180304">get_num_levels</a>()+1) );
<a name="l00209"></a>00209 
<a name="l00210"></a>00210       <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           
<a name="l00213"></a>00213 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>          
<a name="l00215"></a>00215         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00216"></a>00216         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00217"></a>00217           {
<a name="l00218"></a>00218             xdr_vector(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,
<a name="l00219"></a>00219                        (<span class="keywordtype">char</span> *) &amp;neeb[0],
<a name="l00220"></a>00220                        neeb.size(), 
<a name="l00221"></a>00221                        <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> int),
<a name="l00222"></a>00222                        (xdrproc_t) xdr_u_int);
<a name="l00223"></a>00223           }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="preprocessor">#endif</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>          
<a name="l00227"></a>00227         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00228"></a>00228           {
<a name="l00229"></a>00229             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;neeb.size(); i++)
<a name="l00230"></a>00230               <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; neeb[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00231"></a>00231               
<a name="l00232"></a>00232             <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; <span class="stringliteral">&quot;\t # Num. of elements in each block at each level.\n&quot;</span>;
<a name="l00233"></a>00233             <span class="keywordflow">break</span>;
<a name="l00234"></a>00234           }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236         <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00237"></a>00237           {
<a name="l00238"></a>00238 
<a name="l00239"></a>00239             <span class="comment">// We will treat this line as containing</span>
<a name="l00240"></a>00240             <span class="comment">// 1.) The number of elements in each block OR</span>
<a name="l00241"></a>00241             <span class="comment">// 2.) The number of elements at each level in each block</span>
<a name="l00242"></a>00242             <span class="comment">// Therefore, we don&#39;t know a-priori how many ints to read.</span>
<a name="l00243"></a>00243 
<a name="l00244"></a>00244             <span class="comment">// Get the full line from the stream up to the newline</span>
<a name="l00245"></a>00245             <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247             <span class="comment">// Construct a char buffer to hold the tokens as we</span>
<a name="l00248"></a>00248             <span class="comment">// process them, and construct a std::string object and</span>
<a name="l00249"></a>00249             <span class="comment">// a std::stringstream object for tokenizing this line.</span>
<a name="l00250"></a>00250             <span class="keywordtype">char</span> token[comm_len];
<a name="l00251"></a>00251             std::string s_temp(comment);
<a name="l00252"></a>00252             std::stringstream ss(s_temp);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254             <span class="comment">// Resize the neeb vector to zero so we can push back</span>
<a name="l00255"></a>00255             <span class="comment">// values onto it.  Note that we are using a tokenizer</span>
<a name="l00256"></a>00256             <span class="comment">// scheme again here to read the line, but it&#39;s not entirely</span>
<a name="l00257"></a>00257             <span class="comment">// necessary since we know the size neeb should have.</span>
<a name="l00258"></a>00258             neeb.resize(0);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260             <span class="comment">// Process the tokens one at a time</span>
<a name="l00261"></a>00261             <span class="keywordflow">while</span> (ss &gt;&gt; token)
<a name="l00262"></a>00262               {
<a name="l00263"></a>00263                 <span class="comment">// If you reach the hash, the rest of the line is a comment,</span>
<a name="l00264"></a>00264                 <span class="comment">// so quit reading.</span>
<a name="l00265"></a>00265                 <span class="keywordflow">if</span> (token[0] == <span class="charliteral">&#39;#&#39;</span>)
<a name="l00266"></a>00266                   <span class="keywordflow">break</span>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268                 <span class="comment">// If you reach an alphabetic character, this is an error</span>
<a name="l00269"></a>00269                 <span class="keywordflow">if</span> (!isdigit(token[0]))
<a name="l00270"></a>00270                   {
<a name="l00271"></a>00271                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Unrecognized character detected.&quot;</span> 
<a name="l00272"></a>00272                                   &lt;&lt; std::endl;
<a name="l00273"></a>00273                     libmesh_error();
<a name="l00274"></a>00274                   }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276                 <span class="comment">// Otherwise, add the value to the neeb vector</span>
<a name="l00277"></a>00277                 neeb.push_back( std::atoi(token) );
<a name="l00278"></a>00278               }
<a name="l00279"></a>00279               
<a name="l00280"></a>00280             <span class="comment">// Be sure you have the right number of entries in neeb</span>
<a name="l00281"></a>00281             libmesh_assert (neeb.size() == (hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>() * (this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#accd9072374f310e64f48b1d83e180304">get_num_levels</a>()+1)));
<a name="l00282"></a>00282 
<a name="l00283"></a>00283             <span class="keywordflow">break</span>;
<a name="l00284"></a>00284           }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286         <span class="keywordflow">default</span>:
<a name="l00287"></a>00287           <span class="comment">// Unknown access type</span>
<a name="l00288"></a>00288           libmesh_error();
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291       <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">DECODE</a>) || (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">R_ASCII</a>)) 
<a name="l00292"></a>00292         hd-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#a4bd6263ae1dbb0c6e0c045de633bc246">set_num_elem_each_block</a>(neeb);      
<a name="l00293"></a>00293     }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> == 1) <span class="comment">// MGF originator</span>
<a name="l00297"></a>00297     {
<a name="l00298"></a>00298     }
<a name="l00299"></a>00299   <span class="keywordflow">else</span>  <span class="comment">// Unknown Originator!</span>
<a name="l00300"></a>00300     {
<a name="l00301"></a>00301       libmesh_error();
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303   
<a name="l00304"></a>00304   
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">// Write the ID and TITLE strings (can be safely ignored)</span>
<a name="l00308"></a>00308   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00309"></a>00309     {
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00312"></a>00312 <span class="preprocessor"></span>      
<a name="l00313"></a>00313     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00314"></a>00314     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00315"></a>00315       {
<a name="l00316"></a>00316         <span class="keywordtype">char</span>* temp = hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ab85203a79c4f71cf63efc194fa345955">cpyString</a>(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#a2391d7d2017ddfe07c67894fac6d86d5">getId</a>());
<a name="l00317"></a>00317         xdr_string(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,&amp;temp, ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>) ? std::strlen(temp) : hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aac06650be0aa7a3f287fe4a7447c8537">m_strSize</a>));
<a name="l00318"></a>00318         hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ac76890e217fabb4b9ae14ff5a3dba2d5">setId</a>(temp);
<a name="l00319"></a>00319         <span class="keyword">delete</span> [] temp;
<a name="l00320"></a>00320 
<a name="l00321"></a>00321         temp = hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ab85203a79c4f71cf63efc194fa345955">cpyString</a>(hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#a61cd8b8510aa0bda9e6a2742bab2e7bb">getTitle</a>());
<a name="l00322"></a>00322 
<a name="l00323"></a>00323         xdr_string(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,&amp;temp, ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>) ? std::strlen(temp) : hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#aac06650be0aa7a3f287fe4a7447c8537">m_strSize</a>));
<a name="l00324"></a>00324         hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#abc842ad99aafd3f49024c603558d089d">setTitle</a>(temp);
<a name="l00325"></a>00325         <span class="keyword">delete</span> [] temp;
<a name="l00326"></a>00326         <span class="keywordflow">break</span>;
<a name="l00327"></a>00327       }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="preprocessor">#endif</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>      
<a name="l00331"></a>00331     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00332"></a>00332       {
<a name="l00333"></a>00333         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ae1eeed4ed33722a0a54d363437ef74e6">mp_id</a>    &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00334"></a>00334         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#a23bc25488e4619c28ef0997f74394cec">mp_title</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00335"></a>00335         <span class="keywordflow">break</span>;
<a name="l00336"></a>00336       }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00339"></a>00339       {
<a name="l00340"></a>00340         libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00341"></a>00341         
<a name="l00342"></a>00342         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00343"></a>00343         hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#ac76890e217fabb4b9ae14ff5a3dba2d5">setId</a>(comment);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345         libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00346"></a>00346         
<a name="l00347"></a>00347         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(comment, comm_len);
<a name="l00348"></a>00348         hd-&gt;<a class="code" href="classlibMesh_1_1XdrHEAD.php#abc842ad99aafd3f49024c603558d089d">setTitle</a>(comment);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350         <span class="keywordflow">break</span>;
<a name="l00351"></a>00351       }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353     <span class="keywordflow">default</span>:
<a name="l00354"></a>00354       <span class="comment">// Unknown access type</span>
<a name="l00355"></a>00355       libmesh_error();
<a name="l00356"></a>00356     }
<a name="l00357"></a>00357   
<a name="l00358"></a>00358   <span class="keywordflow">return</span> 1;
<a name="l00359"></a>00359 }
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
