<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_mgf.C</div>  </div>
</div>
<div class="contents">
<a href="xdr__mgf_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mgf.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mgf_8h.php">xdr_mgf.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// XdrMGF member functions</span>
<a name="l00029"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a6c08bd2a46d6a08b695ab55f847a8dc5">00029</a> <a class="code" href="classlibMesh_1_1XdrMGF.php#a6c08bd2a46d6a08b695ab55f847a8dc5">XdrMGF::~XdrMGF</a>()
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#ac62d546b16803a6f5741a650f931d8ba">fini</a>();
<a name="l00032"></a>00032 }
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#ac62d546b16803a6f5741a650f931d8ba">00036</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#ac62d546b16803a6f5741a650f931d8ba">XdrMGF::fini</a>()
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>  
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>)
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043       <span class="comment">//libMesh::out &lt;&lt; &quot;Destroying XDR file handle.&quot; &lt;&lt; std::endl;</span>
<a name="l00044"></a>00044       xdr_destroy(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>);
<a name="l00045"></a>00045     }
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <span class="comment">//libMesh::out &lt;&lt; &quot;Deleting the file handle pointer.&quot; &lt;&lt; std::endl;</span>
<a name="l00048"></a>00048   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>;
<a name="l00049"></a>00049   
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a> = NULL;
<a name="l00051"></a>00051   
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>  
<a name="l00054"></a>00054   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>)
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056       <span class="comment">//libMesh::out &lt;&lt; &quot;Closing file.&quot; &lt;&lt; std::endl;</span>
<a name="l00057"></a>00057       std::fflush(<a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>);
<a name="l00058"></a>00058       std::fclose(<a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>);
<a name="l00059"></a>00059     }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a> = NULL;
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a8fdbdc54acc9425c1eb0549e3bc25b1b">00069</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a8fdbdc54acc9425c1eb0549e3bc25b1b">XdrMGF::init</a> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2a">XdrMGF::XdrIO_TYPE</a> t, <span class="keyword">const</span> <span class="keywordtype">char</span>* fn, <span class="keyword">const</span> <span class="keywordtype">char</span>*, <span class="keywordtype">int</span>)
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>=t;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// Close old file if necessary</span>
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>) this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#ac62d546b16803a6f5741a650f931d8ba">fini</a>(); 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">// Open file </span>
<a name="l00078"></a>00078   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00079"></a>00079     {
<a name="l00080"></a>00080       
<a name="l00081"></a>00081 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>      
<a name="l00083"></a>00083     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00084"></a>00084     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00085"></a>00085       {
<a name="l00086"></a>00086         <a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a> = fopen (fn, (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">ENCODE</a>) ? <span class="stringliteral">&quot;w&quot;</span> : <span class="stringliteral">&quot;r&quot;</span>);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088         <span class="comment">// Make sure the file is ready for use</span>
<a name="l00089"></a>00089         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>)
<a name="l00090"></a>00090           {
<a name="l00091"></a>00091             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;XDR Error: Accessing file: &quot;</span>
<a name="l00092"></a>00092                           &lt;&lt; fn
<a name="l00093"></a>00093                           &lt;&lt; <span class="stringliteral">&quot; failed.&quot;</span>
<a name="l00094"></a>00094                           &lt;&lt; std::endl;
<a name="l00095"></a>00095             libmesh_error();
<a name="l00096"></a>00096           }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098         <span class="comment">// Create the XDR handle </span>
<a name="l00099"></a>00099         <a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a> = <span class="keyword">new</span> XDR;
<a name="l00100"></a>00100         xdrstdio_create(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,
<a name="l00101"></a>00101                         <a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>,
<a name="l00102"></a>00102                         ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">ENCODE</a>) ? XDR_ENCODE : XDR_DECODE));
<a name="l00103"></a>00103         
<a name="l00104"></a>00104         <span class="keywordflow">break</span>;
<a name="l00105"></a>00105       }
<a name="l00106"></a>00106       
<a name="l00107"></a>00107 <span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>      
<a name="l00109"></a>00109     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00110"></a>00110       {
<a name="l00111"></a>00111         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.open(fn, std::ios::in);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113         <span class="comment">// Make sure it opened correctly</span>
<a name="l00114"></a>00114         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good())
<a name="l00115"></a>00115           libmesh_file_error(fn);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <span class="keywordflow">break</span>;
<a name="l00118"></a>00118       }
<a name="l00119"></a>00119       
<a name="l00120"></a>00120     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00121"></a>00121       {
<a name="l00122"></a>00122         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a>.open(fn, <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">std::ios::out</a>);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124         <span class="comment">// Make sure it opened correctly</span>
<a name="l00125"></a>00125         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a>.good())
<a name="l00126"></a>00126           libmesh_file_error(fn);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         <span class="keywordflow">break</span>;
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130       
<a name="l00131"></a>00131     <span class="keywordflow">default</span>:
<a name="l00132"></a>00132       {
<a name="l00133"></a>00133         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Unrecognized file access type!&quot;</span> &lt;&lt; std::endl;
<a name="l00134"></a>00134         libmesh_error();
<a name="l00135"></a>00135       }
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   
<a name="l00142"></a>00142   <span class="comment">// Read/Write the file signature</span>
<a name="l00143"></a>00143   <span class="keyword">const</span> <span class="keywordtype">int</span>  bufLen = 12;
<a name="l00144"></a>00144   <span class="keywordtype">char</span>       buf[bufLen+1];
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00147"></a>00147     {
<a name="l00148"></a>00148       
<a name="l00149"></a>00149 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>      
<a name="l00151"></a>00151     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00152"></a>00152       {
<a name="l00153"></a>00153         <span class="keywordtype">char</span>* p = &amp;buf[0];
<a name="l00154"></a>00154         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> orig = this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#a29e0c8c4fe50b5e7bfcd6b2b958ea322">get_orig_flag</a>();
<a name="l00155"></a>00155 
<a name="l00156"></a>00156         std::ostringstream <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00157"></a>00157         <span class="keywordflow">if</span> (orig == <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba6d96e003c93b90ea62108271a7081c4a">LegacyXdrIO::DEAL</a>)
<a name="l00158"></a>00158           name &lt;&lt; <span class="stringliteral">&quot;DEAL 003:003&quot;</span>;
<a name="l00159"></a>00159           
<a name="l00160"></a>00160         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (orig == <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba58605e1d65accdfed3fe439ccf3ba2cc">LegacyXdrIO::MGF</a>)
<a name="l00161"></a>00161           name &lt;&lt; <span class="stringliteral">&quot;MGF  002:000&quot;</span>;
<a name="l00162"></a>00162           
<a name="l00163"></a>00163         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (orig == <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>)
<a name="l00164"></a>00164           name &lt;&lt; <span class="stringliteral">&quot;LIBM &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#accd9072374f310e64f48b1d83e180304">get_num_levels</a>();
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="keywordflow">else</span>
<a name="l00167"></a>00167           libmesh_error();
<a name="l00168"></a>00168 
<a name="l00169"></a>00169         <span class="comment">// Fill the buffer</span>
<a name="l00170"></a>00170         std::sprintf(&amp;buf[0], <span class="stringliteral">&quot;%s&quot;</span>, name.str().c_str());
<a name="l00171"></a>00171           
<a name="l00172"></a>00172         xdr_string(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;p, bufLen);  <span class="comment">// Writes binary signature</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <span class="keywordflow">break</span>;
<a name="l00175"></a>00175       }
<a name="l00176"></a>00176       
<a name="l00177"></a>00177     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00178"></a>00178       {
<a name="l00179"></a>00179         <span class="keywordtype">char</span>* p = &amp;buf[0];
<a name="l00180"></a>00180         xdr_string(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>, &amp;p, bufLen); <span class="comment">// Reads binary signature</span>
<a name="l00181"></a>00181          
<a name="l00182"></a>00182         <span class="comment">// Set the number of levels used in the mesh</span>
<a name="l00183"></a>00183         this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#a649282efa3452ca2c1b80adb485cd6b4">tokenize_first_line</a>(p);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185         <span class="keywordflow">break</span>;
<a name="l00186"></a>00186       }
<a name="l00187"></a>00187       
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>      
<a name="l00190"></a>00190     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00191"></a>00191       {
<a name="l00192"></a>00192         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> orig = this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#a29e0c8c4fe50b5e7bfcd6b2b958ea322">get_orig_flag</a>();
<a name="l00193"></a>00193 
<a name="l00194"></a>00194         <span class="keywordflow">if</span> (orig == <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba6d96e003c93b90ea62108271a7081c4a">LegacyXdrIO::DEAL</a>)
<a name="l00195"></a>00195           std::sprintf(&amp;buf[0], <span class="stringliteral">&quot;%s %03d:%03d&quot;</span>, <span class="stringliteral">&quot;DEAL&quot;</span>, 3, 3);
<a name="l00196"></a>00196           
<a name="l00197"></a>00197         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (orig == <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba58605e1d65accdfed3fe439ccf3ba2cc">LegacyXdrIO::MGF</a>)
<a name="l00198"></a>00198           std::sprintf(&amp;buf[0], <span class="stringliteral">&quot;%s %03d:%03d&quot;</span>, <span class="stringliteral">&quot;MGF &quot;</span>, 2, 0);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (orig == <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>)
<a name="l00201"></a>00201           std::sprintf(&amp;buf[0], <span class="stringliteral">&quot;%s %d&quot;</span>, <span class="stringliteral">&quot;LIBM&quot;</span>, this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#accd9072374f310e64f48b1d83e180304">get_num_levels</a>());
<a name="l00202"></a>00202           
<a name="l00203"></a>00203         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; buf &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00204"></a>00204         
<a name="l00205"></a>00205         <span class="keywordflow">break</span>;
<a name="l00206"></a>00206       }
<a name="l00207"></a>00207       
<a name="l00208"></a>00208     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00209"></a>00209       {
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#ifdef __HP_aCC</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>        <span class="comment">// weirdly, _only_ here aCC</span>
<a name="l00213"></a>00213         <span class="comment">// is not fond of mp_in.getline()</span>
<a name="l00214"></a>00214         <span class="comment">// however, using mp_in.getline()</span>
<a name="l00215"></a>00215         <span class="comment">// further below is ok...</span>
<a name="l00216"></a>00216         std::string buf_buf;
<a name="l00217"></a>00217         std::getline (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>, buf_buf, <span class="charliteral">&#39;\n&#39;</span>);
<a name="l00218"></a>00218         libmesh_assert (buf_buf.size() &lt;= bufLen);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220         buf_buf.copy (buf, std::string::npos);
<a name="l00221"></a>00221 <span class="preprocessor">#else</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span>
<a name="l00223"></a>00223         <span class="comment">// Here we first use getline() to grab the very </span>
<a name="l00224"></a>00224         <span class="comment">// first line of the file into a char buffer.  Then</span>
<a name="l00225"></a>00225         <span class="comment">// this line is tokenized to look for:</span>
<a name="l00226"></a>00226         <span class="comment">// 1.) The name LIBM, which specifies the new Mesh style.</span>
<a name="l00227"></a>00227         <span class="comment">// 2.) The number of levels in the Mesh which is being read.</span>
<a name="l00228"></a>00228         <span class="comment">// Note that &quot;buf&quot; will be further processed below, here we</span>
<a name="l00229"></a>00229         <span class="comment">// are just attempting to get the number of levels.</span>
<a name="l00230"></a>00230         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.getline(buf, bufLen+1);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="preprocessor">#endif</span>
<a name="l00233"></a>00233 <span class="preprocessor"></span>
<a name="l00234"></a>00234         <span class="comment">// Determine the number of levels in this mesh</span>
<a name="l00235"></a>00235         this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#a649282efa3452ca2c1b80adb485cd6b4">tokenize_first_line</a>(buf);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237         <span class="keywordflow">break</span>;
<a name="l00238"></a>00238       }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240     <span class="keywordflow">default</span>:
<a name="l00241"></a>00241       libmesh_error();
<a name="l00242"></a>00242     }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="comment">// If you are reading or decoding, process the signature</span>
<a name="l00247"></a>00247   <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">R_ASCII</a>) || (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a> == <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">DECODE</a>))
<a name="l00248"></a>00248     {
<a name="l00249"></a>00249       <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>[5];
<a name="l00250"></a>00250       std::strncpy(name, &amp;buf[0], 4);
<a name="l00251"></a>00251       name[4] = <span class="charliteral">&#39;\0&#39;</span>;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253       <span class="keywordflow">if</span> (std::strcmp (name, <span class="stringliteral">&quot;DEAL&quot;</span>) == 0)
<a name="l00254"></a>00254         {
<a name="l00255"></a>00255           this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba6d96e003c93b90ea62108271a7081c4a">LegacyXdrIO::DEAL</a>; <span class="comment">// 0 is the DEAL identifier by definition</span>
<a name="l00256"></a>00256         }
<a name="l00257"></a>00257       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (std::strcmp (name, <span class="stringliteral">&quot;MGF &quot;</span>) == 0)
<a name="l00258"></a>00258         {
<a name="l00259"></a>00259           this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba58605e1d65accdfed3fe439ccf3ba2cc">LegacyXdrIO::MGF</a>; <span class="comment">// 1 is the MGF identifier by definition</span>
<a name="l00260"></a>00260         }
<a name="l00261"></a>00261       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (std::strcmp (name, <span class="stringliteral">&quot;LIBM&quot;</span>) == 0)
<a name="l00262"></a>00262         {
<a name="l00263"></a>00263           this-&gt;<a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>; <span class="comment">// the New and Improved XDA</span>
<a name="l00264"></a>00264         }
<a name="l00265"></a>00265 
<a name="l00266"></a>00266       <span class="keywordflow">else</span>
<a name="l00267"></a>00267         {
<a name="l00268"></a>00268           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No originating software can be determined. Error.&quot;</span> 
<a name="l00269"></a>00269                         &lt;&lt; std::endl;
<a name="l00270"></a>00270           libmesh_error();
<a name="l00271"></a>00271         }
<a name="l00272"></a>00272     }
<a name="l00273"></a>00273   
<a name="l00274"></a>00274 }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a98d9fcd583d958354adbc3f609018076">00278</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a98d9fcd583d958354adbc3f609018076">XdrMGF::dataBlk</a>(<span class="keywordtype">int</span>* array, <span class="keywordtype">int</span> numvar, <span class="keywordtype">int</span> size)
<a name="l00279"></a>00279 {
<a name="l00280"></a>00280   <span class="keywordtype">int</span> totalSize = numvar*size;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00283"></a>00283     {
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00286"></a>00286 <span class="preprocessor"></span>      
<a name="l00287"></a>00287     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00288"></a>00288     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00289"></a>00289       {
<a name="l00290"></a>00290         xdr_vector(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,
<a name="l00291"></a>00291                    (<span class="keywordtype">char</span> *) &amp;array[0],
<a name="l00292"></a>00292                    totalSize, 
<a name="l00293"></a>00293                    <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),
<a name="l00294"></a>00294                    (xdrproc_t) xdr_int);
<a name="l00295"></a>00295         <span class="keywordflow">break</span>;
<a name="l00296"></a>00296       }
<a name="l00297"></a>00297       
<a name="l00298"></a>00298 <span class="preprocessor">#endif</span>
<a name="l00299"></a>00299 <span class="preprocessor"></span>      
<a name="l00300"></a>00300     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00301"></a>00301       { 
<a name="l00302"></a>00302         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;size; i++)
<a name="l00303"></a>00303           {
<a name="l00304"></a>00304             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;numvar; j++)
<a name="l00305"></a>00305               <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; array[i*numvar + j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00306"></a>00306           
<a name="l00307"></a>00307             <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00308"></a>00308           }
<a name="l00309"></a>00309         
<a name="l00310"></a>00310         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a>.flush();
<a name="l00311"></a>00311         <span class="keywordflow">break</span>;
<a name="l00312"></a>00312       }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00315"></a>00315       {
<a name="l00316"></a>00316         libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00317"></a>00317         
<a name="l00318"></a>00318         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;size; i++)
<a name="l00319"></a>00319           {
<a name="l00320"></a>00320             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;numvar; j++)
<a name="l00321"></a>00321               {
<a name="l00322"></a>00322                 <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; array[i*numvar + j];
<a name="l00323"></a>00323               }
<a name="l00324"></a>00324           
<a name="l00325"></a>00325             <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.ignore(); <span class="comment">// Read newline</span>
<a name="l00326"></a>00326           }
<a name="l00327"></a>00327         
<a name="l00328"></a>00328         <span class="keywordflow">break</span>;
<a name="l00329"></a>00329       }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331     <span class="keywordflow">default</span>:
<a name="l00332"></a>00332       <span class="comment">// Unknown access type</span>
<a name="l00333"></a>00333       libmesh_error();
<a name="l00334"></a>00334     }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="keywordflow">return</span> totalSize;
<a name="l00337"></a>00337 }
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#ace594208237f7b69164bfd7bf45c3a88">00341</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a98d9fcd583d958354adbc3f609018076">XdrMGF::dataBlk</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>* array, <span class="keywordtype">int</span> numvar, <span class="keywordtype">int</span> size)
<a name="l00342"></a>00342 {
<a name="l00343"></a>00343   <span class="keywordtype">int</span> totalSize = numvar*size;
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// If this function is called by coord(),</span>
<a name="l00346"></a>00346   <span class="comment">// numvar is the problem dimension, and</span>
<a name="l00347"></a>00347   <span class="comment">// size is the number of nodes in the problem.</span>
<a name="l00348"></a>00348   
<a name="l00349"></a>00349   <span class="comment">//libMesh::out &lt;&lt; &quot;Total amount of data to be written: &quot; &lt;&lt; totalSize &lt;&lt; std::endl;</span>
<a name="l00350"></a>00350   
<a name="l00351"></a>00351   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>)
<a name="l00352"></a>00352     {
<a name="l00353"></a>00353       
<a name="l00354"></a>00354 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>      
<a name="l00356"></a>00356     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">XdrMGF::DECODE</a>):
<a name="l00357"></a>00357     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">XdrMGF::ENCODE</a>):
<a name="l00358"></a>00358       { 
<a name="l00359"></a>00359         <span class="comment">// FIXME - this is probably broken for Real == long double</span>
<a name="l00360"></a>00360         <span class="comment">// RHS</span>
<a name="l00361"></a>00361         xdr_vector(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>,
<a name="l00362"></a>00362                    (<span class="keywordtype">char</span> *) &amp;array[0],
<a name="l00363"></a>00363                    totalSize, 
<a name="l00364"></a>00364                    <span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>),
<a name="l00365"></a>00365                    (xdrproc_t) xdr_REAL);
<a name="l00366"></a>00366       }
<a name="l00367"></a>00367       
<a name="l00368"></a>00368 <span class="preprocessor">#endif</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>      
<a name="l00370"></a>00370     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">XdrMGF::W_ASCII</a>):
<a name="l00371"></a>00371       {
<a name="l00372"></a>00372 
<a name="l00373"></a>00373         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;size; i++)
<a name="l00374"></a>00374           {
<a name="l00375"></a>00375             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;numvar; j++)
<a name="l00376"></a>00376               OFSRealscientific(<a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a>,17,array[i*numvar + j]) &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>;
<a name="l00377"></a>00377             
<a name="l00378"></a>00378             <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00379"></a>00379           }
<a name="l00380"></a>00380         
<a name="l00381"></a>00381         <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a>.flush();
<a name="l00382"></a>00382         <span class="keywordflow">break</span>;
<a name="l00383"></a>00383       }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385     <span class="keywordflow">case</span> (<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">XdrMGF::R_ASCII</a>):
<a name="l00386"></a>00386       {
<a name="l00387"></a>00387         libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00388"></a>00388         
<a name="l00389"></a>00389         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;size; i++)
<a name="l00390"></a>00390           {
<a name="l00391"></a>00391             libmesh_assert (<a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.good());
<a name="l00392"></a>00392         
<a name="l00393"></a>00393             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;numvar; j++)
<a name="l00394"></a>00394               <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a> &gt;&gt; array[i*numvar + j];
<a name="l00395"></a>00395           
<a name="l00396"></a>00396             <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>.ignore(); <span class="comment">// Read newline</span>
<a name="l00397"></a>00397           }
<a name="l00398"></a>00398         
<a name="l00399"></a>00399         <span class="keywordflow">break</span>;
<a name="l00400"></a>00400       }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402     <span class="keywordflow">default</span>:
<a name="l00403"></a>00403       <span class="comment">// Unknown access type</span>
<a name="l00404"></a>00404       libmesh_error();
<a name="l00405"></a>00405     }
<a name="l00406"></a>00406       
<a name="l00407"></a>00407   <span class="keywordflow">return</span> totalSize;
<a name="l00408"></a>00408 }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
