<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_mgf.h</div>  </div>
</div>
<div class="contents">
<a href="xdr__mgf_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mgf.h 4100 2010-11-15 17:46:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_mgf_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_mgf_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;cstdio&gt;</span>  <span class="comment">// for std::FILE</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstring&gt;</span> <span class="comment">// std::strlen, std::strcmp</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;fstream&gt;</span> <span class="comment">// for std::ifstream</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="legacy__xdr__io_8h.php">legacy_xdr_io.h</a>&quot;</span>          <span class="comment">// for LegacyXdrIO::FileFormat</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>  <span class="comment">// for LIBMESH_HAVE_XDR</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="o__f__stream_8h.php">o_f_stream.h</a>&quot;</span>      <span class="comment">// for OFStream</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;rpc/rpc.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#  ifndef LIBMESH_DEFAULT_SINGLE_PRECISION</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#    ifdef LIBMESH_DEFAULT_TRIPLE_PRECISION</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="comment">// #      define xdr_REAL xdr_quadruple</span>
<a name="l00042"></a>00042 <span class="comment">// For some reason my xdr implementation doesn&#39;t define</span>
<a name="l00043"></a>00043 <span class="comment">// xdr_quadruple... - RHS</span>
<a name="l00044"></a>00044 <span class="preprocessor">#      define xdr_REAL xdr_double</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#      define xdr_Real double</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#    else</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#      define xdr_REAL xdr_double</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#      define xdr_Real Real</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#    endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#  else</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#    define xdr_REAL xdr_float</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#    define xdr_Real Real</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#  endif</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#  define xdr_Real Real</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">namespace </span>libMesh
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1XdrMGF.php">00084</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1XdrMGF.php">XdrMGF</a>
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086 <span class="keyword">public</span>:
<a name="l00097"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2a">00097</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2a">XdrIO_TYPE</a> {<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa97733d8d7c6cb16c55427e53e1736990">UNKNOWN</a> = -1, <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa2ec8f3f778710dc7c73bbf8e281bf8f9">ENCODE</a>=0, <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aaefb4b8cc9561f347ea61ceebe669f3e4">DECODE</a>,
<a name="l00098"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">00098</a>                    <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa00437af06faec16916e56dcbe0407e3d">W_ASCII</a> , <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa36a678642fc711fcc647a7783eac4c39">R_ASCII</a>};
<a name="l00099"></a>00099 
<a name="l00100"></a>00100      
<a name="l00113"></a>00113 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00114"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a2e9845ffcdb7fedfbb6fdd760e01e444">00114</a> <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1XdrMGF.php#a2e9845ffcdb7fedfbb6fdd760e01e444">XdrMGF</a>() : <a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">_num_levels</a>(0), <a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa97733d8d7c6cb16c55427e53e1736990">UNKNOWN</a>), <a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>(0), <a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a>(<a class="code" href="classlibMesh_1_1LegacyXdrIO.php">LegacyXdrIO</a>::LIBM), <a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>(0) {}
<a name="l00115"></a>00115 <span class="preprocessor">#else</span>
<a name="l00116"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a2e9845ffcdb7fedfbb6fdd760e01e444">00116</a> <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1XdrMGF.php#a2e9845ffcdb7fedfbb6fdd760e01e444">XdrMGF</a>() : <a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">_num_levels</a>(0), <a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2aa97733d8d7c6cb16c55427e53e1736990">UNKNOWN</a>), <a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a>(<a class="code" href="classlibMesh_1_1LegacyXdrIO.php">LegacyXdrIO</a>::LIBM), <a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>(0) {}
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>    
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a8fdbdc54acc9425c1eb0549e3bc25b1b">init</a>(<a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2a">XdrIO_TYPE</a> t, <span class="keyword">const</span> <span class="keywordtype">char</span>* fn, <span class="keyword">const</span> <span class="keywordtype">char</span>* type, <span class="keywordtype">int</span> icnt);
<a name="l00135"></a>00135 
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a6c08bd2a46d6a08b695ab55f847a8dc5">~XdrMGF</a>();
<a name="l00142"></a>00142 
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#ac62d546b16803a6f5741a650f931d8ba">fini</a>();
<a name="l00152"></a>00152 
<a name="l00161"></a>00161   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a98d9fcd583d958354adbc3f609018076">dataBlk</a>(<span class="keywordtype">int</span>*  array, <span class="keywordtype">int</span> numvar, <span class="keywordtype">int</span> size);
<a name="l00162"></a>00162 
<a name="l00168"></a>00168   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a98d9fcd583d958354adbc3f609018076">dataBlk</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>* array, <span class="keywordtype">int</span> numvar, <span class="keywordtype">int</span> size);
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a29e0c8c4fe50b5e7bfcd6b2b958ea322">00173</a>   <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> <a class="code" href="classlibMesh_1_1XdrMGF.php#a29e0c8c4fe50b5e7bfcd6b2b958ea322">get_orig_flag</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a>; }
<a name="l00174"></a>00174 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a0989df1fceb12c3d62e529f25b5d69d5">00178</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a0989df1fceb12c3d62e529f25b5d69d5">set_orig_flag</a>(<a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> in_orig_flag) { <a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a> = in_orig_flag; }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a47c0f57c8b4b075f36873e7818cebbc7">00184</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a47c0f57c8b4b075f36873e7818cebbc7">set_num_levels</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_levels) { <a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">_num_levels</a> = num_levels; }
<a name="l00185"></a>00185 
<a name="l00189"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#accd9072374f310e64f48b1d83e180304">00189</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#accd9072374f310e64f48b1d83e180304">get_num_levels</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">_num_levels</a>; }
<a name="l00190"></a>00190   
<a name="l00191"></a>00191 <span class="keyword">protected</span>:
<a name="l00192"></a>00192 
<a name="l00196"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">00196</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">_num_levels</a>;
<a name="l00197"></a>00197 
<a name="l00209"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">00209</a>   <a class="code" href="classlibMesh_1_1XdrMGF.php#a9461e634e9303e0de433c6eb87e7cd2a">XdrIO_TYPE</a> <a class="code" href="classlibMesh_1_1XdrMGF.php#a30506feb941b748dfaca0e8f666f5974">m_type</a>;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>  
<a name="l00219"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">00219</a>   XDR*  <a class="code" href="classlibMesh_1_1XdrMGF.php#a9d12aaa335ef6c54784a6d539089207c">mp_xdr_handle</a>;
<a name="l00220"></a>00220   
<a name="l00221"></a>00221 <span class="preprocessor">#endif</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span>  
<a name="l00238"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">00238</a>   <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> <a class="code" href="classlibMesh_1_1XdrMGF.php#af5c30aa1f30f74f43e3a4508c669fcb7">orig_flag</a>;
<a name="l00239"></a>00239 
<a name="l00243"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">00243</a>   std::ifstream <a class="code" href="classlibMesh_1_1XdrMGF.php#a0bdabadfad9bac94bc463a82b1d3eeff">mp_in</a>;
<a name="l00244"></a>00244 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">00251</a>   <a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a> <a class="code" href="classlibMesh_1_1XdrMGF.php#afe62b25814b871e9512d56840b66112f">mp_out</a>;
<a name="l00252"></a>00252   
<a name="l00253"></a>00253 <span class="keyword">private</span>:
<a name="l00254"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">00254</a>   std::FILE* <a class="code" href="classlibMesh_1_1XdrMGF.php#ab3cdc8a4ff82692f2dfa9279e5564888">mp_fp</a>;
<a name="l00255"></a>00255 
<a name="l00260"></a><a class="code" href="classlibMesh_1_1XdrMGF.php#a649282efa3452ca2c1b80adb485cd6b4">00260</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMGF.php#a649282efa3452ca2c1b80adb485cd6b4">tokenize_first_line</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* p)
<a name="l00261"></a>00261   {
<a name="l00262"></a>00262     std::string buf_str(p);
<a name="l00263"></a>00263     std::stringstream ss(buf_str);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265     <span class="keywordtype">char</span> token[256];
<a name="l00266"></a>00266     ss &gt;&gt; token;
<a name="l00267"></a>00267     <span class="keywordflow">if</span>(std::strcmp(token,<span class="stringliteral">&quot;LIBM&quot;</span>) == 0)
<a name="l00268"></a>00268       {
<a name="l00269"></a>00269         ss &gt;&gt; token;
<a name="l00270"></a>00270         <a class="code" href="classlibMesh_1_1XdrMGF.php#a0cdc7f35b1a5c384a144173fb2deb0c4">_num_levels</a> = std::atoi(token);
<a name="l00271"></a>00271       }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   }
<a name="l00274"></a>00274 };
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 } <span class="comment">// namespace libMesh</span>
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   
<a name="l00280"></a>00280 <span class="preprocessor">#endif // #ifndef __xdr_mgf_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
