<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">xdr_mhead.h</div>  </div>
</div>
<div class="contents">
<a href="xdr__mhead_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mhead.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_mhead_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_mhead_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="xdr__head_8h.php">xdr_head.h</a>&quot;</span> <span class="comment">// for base class</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mesh_8h.php">xdr_mesh.h</a>&quot;</span> <span class="comment">// for friend</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span> <span class="comment">// for ElemType</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php">00041</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1XdrMHEAD.php">XdrMHEAD</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1XdrHEAD.php">XdrHEAD</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#ab2797be1cf03c27b41802ca50a10ae23">00043</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1XdrMESH.php">XdrMESH</a>;
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00049"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a8d067d28ff823dba2b8757758b491ab3">00049</a>   <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a8d067d28ff823dba2b8757758b491ab3">XdrMHEAD</a>() : <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a213644ca2be41569ca1337a1b67a5341">_n_blocks</a>(1) {}
<a name="l00050"></a>00050 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a30aedd988a90c37dd5c08790a765a96e">00054</a>   <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a30aedd988a90c37dd5c08790a765a96e">~XdrMHEAD</a>()                          {}
<a name="l00055"></a>00055 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#ab16ea384cd24fb48066656151c4ec751">00060</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#ab16ea384cd24fb48066656151c4ec751">setNumEl</a>(<span class="keywordtype">int</span> numel)             { <a class="code" href="classlibMesh_1_1XdrHEAD.php#ab8913bc7f50f382fbe24ec7e9607e939">m_numel</a> = numel; }
<a name="l00061"></a>00061 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a4b2087272c4af1ae77d3f2cb8c811f73">00066</a>   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a4b2087272c4af1ae77d3f2cb8c811f73">getNumEl</a>()<span class="keyword"> const                </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrHEAD.php#ab8913bc7f50f382fbe24ec7e9607e939">m_numel</a>; }
<a name="l00067"></a>00067 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a76b9d0af500d99cf42f80b0b3f4ff72c">00073</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a76b9d0af500d99cf42f80b0b3f4ff72c">setSumWghts</a>(<span class="keywordtype">int</span> sumWghts)       { <a class="code" href="classlibMesh_1_1XdrHEAD.php#aa2fb94613d95ed13d4f761d290438c92">m_sumWghts</a> = sumWghts; }
<a name="l00074"></a>00074 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#aba04a2ad7d0c739e66595a52400cc2ee">00080</a>   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1XdrMHEAD.php#aba04a2ad7d0c739e66595a52400cc2ee">getSumWghts</a>()<span class="keyword"> const             </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrHEAD.php#aa2fb94613d95ed13d4f761d290438c92">m_sumWghts</a>; }
<a name="l00081"></a>00081 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">00088</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#aa559cd491f4d28772601138d288c4bfb">get_n_blocks</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a213644ca2be41569ca1337a1b67a5341">_n_blocks</a>; }
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a9d08aad7addbac95c254b4c1442f677e">00093</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a9d08aad7addbac95c254b4c1442f677e">set_n_blocks</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb) { this-&gt;<a class="code" href="classlibMesh_1_1XdrMHEAD.php#a213644ca2be41569ca1337a1b67a5341">_n_blocks</a> = nb; }
<a name="l00094"></a>00094 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#abdbabb97df064d82a06590418201b72d">00101</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#abdbabb97df064d82a06590418201b72d">get_block_elt_types</a>(std::vector&lt;ElemType&gt;&amp; bet)<span class="keyword"> const </span>{ bet = <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a2339bf217592b5f72c7d1c9ab57c97d5">block_elt_types</a>; }
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a5ee4d62786a85ee04bd270173e2bb2c7">00106</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a5ee4d62786a85ee04bd270173e2bb2c7">set_block_elt_types</a>(<span class="keyword">const</span> std::vector&lt;ElemType&gt;&amp; bet) { <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a2339bf217592b5f72c7d1c9ab57c97d5">block_elt_types</a> = bet; }
<a name="l00107"></a>00107 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#acb58d6aa78f0259b2a78ab759e126028">00115</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#acb58d6aa78f0259b2a78ab759e126028">get_num_elem_each_block</a>(std::vector&lt;unsigned int&gt;&amp; neeb)<span class="keyword"> const </span>{ neeb = <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a7122599a436a547f528824c95f829b4c">num_elem_each_block</a>; }
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a4bd6263ae1dbb0c6e0c045de633bc246">00120</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a4bd6263ae1dbb0c6e0c045de633bc246">set_num_elem_each_block</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; neeb) { <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a7122599a436a547f528824c95f829b4c">num_elem_each_block</a> = neeb; }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     
<a name="l00123"></a>00123 <span class="keyword">private</span>:
<a name="l00124"></a>00124     
<a name="l00134"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a213644ca2be41569ca1337a1b67a5341">00134</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a213644ca2be41569ca1337a1b67a5341">_n_blocks</a>;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a2339bf217592b5f72c7d1c9ab57c97d5">00146</a>   std::vector&lt;ElemType&gt; <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a2339bf217592b5f72c7d1c9ab57c97d5">block_elt_types</a>;
<a name="l00147"></a>00147 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1XdrMHEAD.php#a7122599a436a547f528824c95f829b4c">00153</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1XdrMHEAD.php#a7122599a436a547f528824c95f829b4c">num_elem_each_block</a>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 };
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 } <span class="comment">// namespace libMesh</span>
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="preprocessor">#endif // #ifndef __xdr_mhead_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
