<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">continuation_system.C</div>  </div>
</div>
<div class="contents">
<a href="continuation__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: continuation_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// LibMesh includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="continuation__system_8h.php">continuation_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="newton__solver_8h.php">newton_solver.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6ec7c334543edd9117ce97e3eb491292">00030</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6ec7c334543edd9117ce97e3eb491292">ContinuationSystem::ContinuationSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00031"></a>00031                                         <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00032"></a>00032                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00033"></a>00033   : <a class="code" href="classlibMesh_1_1FEMSystem.php">Parent</a>(es, name, number),
<a name="l00034"></a>00034     continuation_parameter(NULL),
<a name="l00035"></a>00035     quiet(true),
<a name="l00036"></a>00036     continuation_parameter_tolerance(1.e-6),
<a name="l00037"></a>00037     solution_tolerance(1.e-6),
<a name="l00038"></a>00038     initial_newton_tolerance(0.01),
<a name="l00039"></a>00039     old_continuation_parameter(0.),
<a name="l00040"></a>00040     min_continuation_parameter(0.),
<a name="l00041"></a>00041     max_continuation_parameter(0.),
<a name="l00042"></a>00042     Theta(1.),
<a name="l00043"></a>00043     Theta_LOCA(1.),
<a name="l00044"></a>00044     <span class="comment">//tau(1.),</span>
<a name="l00045"></a>00045     n_backtrack_steps(5),
<a name="l00046"></a>00046     n_arclength_reductions(5),
<a name="l00047"></a>00047     ds_min(1.e-8),
<a name="l00048"></a>00048     predictor(Euler),
<a name="l00049"></a>00049     newton_stepgrowth_aggressiveness(1.),
<a name="l00050"></a>00050     newton_progress_check(true),
<a name="l00051"></a>00051     rhs_mode(Residual),
<a name="l00052"></a>00052     linear_solver(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00053"></a>00053     tangent_initialized(false),
<a name="l00054"></a>00054     newton_solver(NULL),
<a name="l00055"></a>00055     dlambda_ds(0.707),
<a name="l00056"></a>00056     ds(0.1),
<a name="l00057"></a>00057     ds_current(0.1),
<a name="l00058"></a>00058     previous_dlambda_ds(0.),
<a name="l00059"></a>00059     previous_ds(0.),
<a name="l00060"></a>00060     newton_step(0)
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   <span class="comment">// Warn about using untested code</span>
<a name="l00063"></a>00063   libmesh_experimental();
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3a438c87dd95393e480a98d239146450">00069</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3a438c87dd95393e480a98d239146450">ContinuationSystem::~ContinuationSystem</a> ()
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aca9bc20581a6aaa68ed6cc1f2b30c431">clear</a>();
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#aca9bc20581a6aaa68ed6cc1f2b30c431">00077</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aca9bc20581a6aaa68ed6cc1f2b30c431">ContinuationSystem::clear</a>()
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   <span class="comment">// FIXME: Do anything here, e.g. zero vectors, etc?</span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Call the Parent&#39;s clear function</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1FEMSystem.php#a18808e75d1ea6c77321edd13a88c2af8">Parent::clear</a>();
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#aac004fb67b83674c9d8d122a7912f646">00087</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aac004fb67b83674c9d8d122a7912f646">ContinuationSystem::init_data</a> ()
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   <span class="comment">// Add a vector which stores the tangent &quot;du/ds&quot; to the system and save its pointer.</span>
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;du_ds&quot;</span>));
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// Add a vector which stores the tangent &quot;du/ds&quot; to the system and save its pointer.</span>
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ae0f4570622a491f4879271fb6fb6ad08">previous_du_ds</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;previous_du_ds&quot;</span>));
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// Add a vector to keep track of the previous nonlinear solution</span>
<a name="l00096"></a>00096   <span class="comment">// at the old value of lambda.</span>
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;previous_u&quot;</span>));
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Add a vector to keep track of the temporary solution &quot;y&quot; of Ay=G_{\lambda}.</span>
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;y&quot;</span>));
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Add a vector to keep track of the &quot;old value&quot; of &quot;y&quot; which is the solution of Ay=G_{\lambda}.</span>
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">y_old</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;y_old&quot;</span>));
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// Add a vector to keep track of the temporary solution &quot;z&quot; of Az=-G.</span>
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;z&quot;</span>));
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// Add a vector to keep track of the Newton update during the constrained PDE solves.</span>
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a> = &amp;(<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(<span class="stringliteral">&quot;delta_u&quot;</span>));
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// Call the Parent&#39;s initialization routine.</span>
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1FEMSystem.php#a98c0176dcaa48e80b848e49987b9e6f8">Parent::init_data</a>();
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac64404dcb7d22aa6f73a5c8208e41217">00118</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac64404dcb7d22aa6f73a5c8208e41217">ContinuationSystem::solve</a>()
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   <span class="comment">// Set the Residual RHS mode, and call the normal solve routine.</span>
<a name="l00121"></a>00121   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a>      = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea24777dbaa6ef5bfd9980dc81ebfdba81">Residual</a>;
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac64404dcb7d22aa6f73a5c8208e41217">DifferentiableSystem::solve</a>();
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac5130a85829d1f6e7bb63373a3efe0a7">00128</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac5130a85829d1f6e7bb63373a3efe0a7">ContinuationSystem::initialize_tangent</a>()
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Be sure the tangent was not already initialized.</span>
<a name="l00131"></a>00131   libmesh_assert (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">tangent_initialized</a>);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <span class="comment">// Compute delta_s_zero, the initial arclength travelled during the</span>
<a name="l00134"></a>00134   <span class="comment">// first step.  Here we assume that previous_u and lambda_old store</span>
<a name="l00135"></a>00135   <span class="comment">// the previous solution and control parameter.  You may need to</span>
<a name="l00136"></a>00136   <span class="comment">// read in an old solution (or solve the non-continuation system)</span>
<a name="l00137"></a>00137   <span class="comment">// first and call save_current_solution() before getting here.</span>
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   <span class="comment">// 1.) Compute delta_s_zero as ||u|| - ||u_old|| + ...</span>
<a name="l00140"></a>00140   <span class="comment">// Compute norms of the current and previous solutions</span>
<a name="l00141"></a>00141 <span class="comment">//   Real norm_u          = solution-&gt;l2_norm();</span>
<a name="l00142"></a>00142 <span class="comment">//   Real norm_previous_u = previous_u-&gt;l2_norm();</span>
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 <span class="comment">//   if (!quiet)</span>
<a name="l00145"></a>00145 <span class="comment">//     {</span>
<a name="l00146"></a>00146 <span class="comment">//       libMesh::out &lt;&lt; &quot;norm_u=&quot; &lt;&lt; norm_u &lt;&lt; std::endl;</span>
<a name="l00147"></a>00147 <span class="comment">//       libMesh::out &lt;&lt; &quot;norm_previous_u=&quot; &lt;&lt; norm_previous_u &lt;&lt; std::endl;</span>
<a name="l00148"></a>00148 <span class="comment">//     }</span>
<a name="l00149"></a>00149   
<a name="l00150"></a>00150 <span class="comment">//   if (norm_u == norm_previous_u)</span>
<a name="l00151"></a>00151 <span class="comment">//     {</span>
<a name="l00152"></a>00152 <span class="comment">//       libMesh::err &lt;&lt; &quot;Warning, it appears u and previous_u are the &quot;</span>
<a name="l00153"></a>00153 <span class="comment">//              &lt;&lt; &quot;same, are you sure this is correct?&quot;</span>
<a name="l00154"></a>00154 <span class="comment">//              &lt;&lt; &quot;It&#39;s possible you forgot to set one or the other...&quot;</span>
<a name="l00155"></a>00155 <span class="comment">//              &lt;&lt; std::endl;</span>
<a name="l00156"></a>00156 <span class="comment">//     }</span>
<a name="l00157"></a>00157   
<a name="l00158"></a>00158 <span class="comment">//   Real delta_s_zero = std::sqrt(</span>
<a name="l00159"></a>00159 <span class="comment">//                              (norm_u - norm_previous_u)*(norm_u - norm_previous_u) +</span>
<a name="l00160"></a>00160 <span class="comment">//                              (*continuation_parameter-old_continuation_parameter)*</span>
<a name="l00161"></a>00161 <span class="comment">//                              (*continuation_parameter-old_continuation_parameter)</span>
<a name="l00162"></a>00162 <span class="comment">//                              );</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="comment">//   // 2.) Compute delta_s_zero as ||u -u_old|| + ...</span>
<a name="l00165"></a>00165 <span class="comment">//   *delta_u = *solution;</span>
<a name="l00166"></a>00166 <span class="comment">//   delta_u-&gt;add(-1., *previous_u);</span>
<a name="l00167"></a>00167 <span class="comment">//   delta_u-&gt;close();</span>
<a name="l00168"></a>00168 <span class="comment">//   Real norm_delta_u = delta_u-&gt;l2_norm();</span>
<a name="l00169"></a>00169 <span class="comment">//   Real norm_u          = solution-&gt;l2_norm();</span>
<a name="l00170"></a>00170 <span class="comment">//   Real norm_previous_u = previous_u-&gt;l2_norm();</span>
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="comment">//   // Scale norm_delta_u by the bigger of either norm_u or norm_previous_u</span>
<a name="l00173"></a>00173 <span class="comment">//   norm_delta_u /= std::max(norm_u, norm_previous_u);</span>
<a name="l00174"></a>00174   
<a name="l00175"></a>00175 <span class="comment">//   if (!quiet)</span>
<a name="l00176"></a>00176 <span class="comment">//     {</span>
<a name="l00177"></a>00177 <span class="comment">//       libMesh::out &lt;&lt; &quot;norm_u=&quot; &lt;&lt; norm_u &lt;&lt; std::endl;</span>
<a name="l00178"></a>00178 <span class="comment">//       libMesh::out &lt;&lt; &quot;norm_previous_u=&quot; &lt;&lt; norm_previous_u &lt;&lt; std::endl;</span>
<a name="l00179"></a>00179 <span class="comment">//       //libMesh::out &lt;&lt; &quot;norm_delta_u=&quot; &lt;&lt; norm_delta_u &lt;&lt; std::endl;</span>
<a name="l00180"></a>00180 <span class="comment">//       libMesh::out &lt;&lt; &quot;norm_delta_u/max(|u|,|u_old|)=&quot; &lt;&lt; norm_delta_u &lt;&lt; std::endl;</span>
<a name="l00181"></a>00181 <span class="comment">//       libMesh::out &lt;&lt; &quot;|norm_u-norm_previous_u|=&quot; &lt;&lt; std::abs(norm_u - norm_previous_u) &lt;&lt; std::endl;</span>
<a name="l00182"></a>00182 <span class="comment">//     }</span>
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 <span class="comment">//   const Real dlambda = *continuation_parameter-old_continuation_parameter;</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="comment">//   if (!quiet)</span>
<a name="l00187"></a>00187 <span class="comment">//     libMesh::out &lt;&lt; &quot;dlambda=&quot; &lt;&lt; dlambda &lt;&lt; std::endl;</span>
<a name="l00188"></a>00188   
<a name="l00189"></a>00189 <span class="comment">//   Real delta_s_zero = std::sqrt(</span>
<a name="l00190"></a>00190 <span class="comment">//                              (norm_delta_u*norm_delta_u) +</span>
<a name="l00191"></a>00191 <span class="comment">//                              (dlambda*dlambda)</span>
<a name="l00192"></a>00192 <span class="comment">//                              );</span>
<a name="l00193"></a>00193   
<a name="l00194"></a>00194 <span class="comment">//   if (!quiet)</span>
<a name="l00195"></a>00195 <span class="comment">//     libMesh::out &lt;&lt; &quot;delta_s_zero=&quot; &lt;&lt; delta_s_zero &lt;&lt; std::endl;</span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">// 1.) + 2.)</span>
<a name="l00198"></a>00198 <span class="comment">//   // Now approximate the initial tangent d(lambda)/ds</span>
<a name="l00199"></a>00199 <span class="comment">//   this-&gt;dlambda_ds = (*continuation_parameter-old_continuation_parameter) / delta_s_zero;</span>
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="comment">//   // We can also approximate the deriv. wrt s by finite differences:</span>
<a name="l00203"></a>00203 <span class="comment">//   // du/ds = (u1 - u0) / delta_s_zero.</span>
<a name="l00204"></a>00204 <span class="comment">//   // FIXME: Use delta_u from above if we decide to keep that method.</span>
<a name="l00205"></a>00205 <span class="comment">//   *du_ds = *solution;</span>
<a name="l00206"></a>00206 <span class="comment">//   du_ds-&gt;add(-1., *previous_u);</span>
<a name="l00207"></a>00207 <span class="comment">//   du_ds-&gt;scale(1./delta_s_zero);</span>
<a name="l00208"></a>00208 <span class="comment">//   du_ds-&gt;close();</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// 3.) Treating (u-previous_u)/(lambda - lambda_old) as an approximation to du/d(lambda),</span>
<a name="l00212"></a>00212   <span class="comment">// we follow the same technique as Carnes and Shadid.</span>
<a name="l00213"></a>00213 <span class="comment">//   const Real dlambda = *continuation_parameter-old_continuation_parameter;</span>
<a name="l00214"></a>00214 <span class="comment">//   libmesh_assert (dlambda &gt; 0.);</span>
<a name="l00215"></a>00215   
<a name="l00216"></a>00216 <span class="comment">//   // Use delta_u for temporary calculation of du/d(lambda)</span>
<a name="l00217"></a>00217 <span class="comment">//   *delta_u = *solution;</span>
<a name="l00218"></a>00218 <span class="comment">//   delta_u-&gt;add(-1., *previous_u);</span>
<a name="l00219"></a>00219 <span class="comment">//   delta_u-&gt;scale(1. / dlambda);</span>
<a name="l00220"></a>00220 <span class="comment">//   delta_u-&gt;close();</span>
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="comment">//   // Determine initial normalization parameter</span>
<a name="l00223"></a>00223 <span class="comment">//   const Real solution_size = std::max(solution-&gt;l2_norm(), previous_u-&gt;l2_norm());</span>
<a name="l00224"></a>00224 <span class="comment">//   if (solution_size &gt; 1.)</span>
<a name="l00225"></a>00225 <span class="comment">//     {</span>
<a name="l00226"></a>00226 <span class="comment">//       Theta = 1./solution_size;</span>
<a name="l00227"></a>00227       
<a name="l00228"></a>00228 <span class="comment">//       if (!quiet)</span>
<a name="l00229"></a>00229 <span class="comment">//      libMesh::out &lt;&lt; &quot;Setting Normalization Parameter Theta=&quot; &lt;&lt; Theta &lt;&lt; std::endl;</span>
<a name="l00230"></a>00230 <span class="comment">//     }</span>
<a name="l00231"></a>00231   
<a name="l00232"></a>00232 <span class="comment">//   // Compute d(lambda)/ds</span>
<a name="l00233"></a>00233 <span class="comment">//   // The correct sign of d(lambda)/ds should be positive, since we assume that (lambda &gt; lambda_old)</span>
<a name="l00234"></a>00234 <span class="comment">//   // but we could always double-check that as well.</span>
<a name="l00235"></a>00235 <span class="comment">//   Real norm_delta_u = delta_u-&gt;l2_norm();</span>
<a name="l00236"></a>00236 <span class="comment">//   this-&gt;dlambda_ds = 1. / std::sqrt(1. + Theta*Theta*norm_delta_u*norm_delta_u);</span>
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="comment">//   // Finally, compute du/ds = d(lambda)/ds * du/d(lambda)</span>
<a name="l00239"></a>00239 <span class="comment">//   *du_ds = *delta_u;</span>
<a name="l00240"></a>00240 <span class="comment">//   du_ds-&gt;scale(dlambda_ds);</span>
<a name="l00241"></a>00241 <span class="comment">//   du_ds-&gt;close();</span>
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// 4.) Use normalized arclength formula to estimate delta_s_zero</span>
<a name="l00245"></a>00245 <span class="comment">//   // Determine initial normalization parameter</span>
<a name="l00246"></a>00246 <span class="comment">//   set_Theta();</span>
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="comment">//   // Compute (normalized) delta_s_zero</span>
<a name="l00249"></a>00249 <span class="comment">//   *delta_u = *solution;</span>
<a name="l00250"></a>00250 <span class="comment">//   delta_u-&gt;add(-1., *previous_u);</span>
<a name="l00251"></a>00251 <span class="comment">//   delta_u-&gt;close();</span>
<a name="l00252"></a>00252 <span class="comment">//   Real norm_delta_u = delta_u-&gt;l2_norm();</span>
<a name="l00253"></a>00253   
<a name="l00254"></a>00254 <span class="comment">//   const Real dlambda = *continuation_parameter-old_continuation_parameter;</span>
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="comment">//   if (!quiet)</span>
<a name="l00257"></a>00257 <span class="comment">//     libMesh::out &lt;&lt; &quot;dlambda=&quot; &lt;&lt; dlambda &lt;&lt; std::endl;</span>
<a name="l00258"></a>00258   
<a name="l00259"></a>00259 <span class="comment">//   Real delta_s_zero = std::sqrt(</span>
<a name="l00260"></a>00260 <span class="comment">//                              (Theta_LOCA*Theta_LOCA*Theta*norm_delta_u*norm_delta_u) +</span>
<a name="l00261"></a>00261 <span class="comment">//                              (dlambda*dlambda)</span>
<a name="l00262"></a>00262 <span class="comment">//                              );</span>
<a name="l00263"></a>00263 <span class="comment">//   *du_ds = *delta_u;</span>
<a name="l00264"></a>00264 <span class="comment">//   du_ds-&gt;scale(1./delta_s_zero);</span>
<a name="l00265"></a>00265 <span class="comment">//   dlambda_ds = dlambda / delta_s_zero;</span>
<a name="l00266"></a>00266   
<a name="l00267"></a>00267 <span class="comment">//   if (!quiet)</span>
<a name="l00268"></a>00268 <span class="comment">//     {</span>
<a name="l00269"></a>00269 <span class="comment">//       libMesh::out &lt;&lt; &quot;delta_s_zero=&quot; &lt;&lt; delta_s_zero &lt;&lt; std::endl;</span>
<a name="l00270"></a>00270 <span class="comment">//       libMesh::out &lt;&lt; &quot;initial d(lambda)/ds|_0 = &quot; &lt;&lt; dlambda_ds &lt;&lt; std::endl;</span>
<a name="l00271"></a>00271 <span class="comment">//       libMesh::out &lt;&lt; &quot;initial ||du_ds||_0 = &quot; &lt;&lt; du_ds-&gt;l2_norm() &lt;&lt; std::endl;</span>
<a name="l00272"></a>00272 <span class="comment">//     }</span>
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="comment">//   // FIXME: Also store the initial finite-differenced approximation to -du/dlambda as y.</span>
<a name="l00275"></a>00275 <span class="comment">//   // We stick to the convention of storing negative y, since that is what we typically</span>
<a name="l00276"></a>00276 <span class="comment">//   // solve for anyway.</span>
<a name="l00277"></a>00277 <span class="comment">//   *y = *delta_u;</span>
<a name="l00278"></a>00278 <span class="comment">//   y-&gt;scale(-1./dlambda);</span>
<a name="l00279"></a>00279 <span class="comment">//   y-&gt;close();</span>
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <span class="comment">// 5.) Assume dlambda/ds_0 ~ 1/sqrt(2) and determine the value of Theta_LOCA which</span>
<a name="l00284"></a>00284   <span class="comment">// will satisfy this criterion</span>
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="comment">// Initial change in parameter</span>
<a name="l00287"></a>00287   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dlambda = *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>-<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a>;
<a name="l00288"></a>00288   libmesh_assert (dlambda != 0.0);
<a name="l00289"></a>00289   
<a name="l00290"></a>00290   <span class="comment">// Ideal initial value of dlambda_ds</span>
<a name="l00291"></a>00291   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> = 1. / std::sqrt(2.);
<a name="l00292"></a>00292   <span class="keywordflow">if</span> (dlambda &lt; 0.)
<a name="l00293"></a>00293     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> *= -1.;
<a name="l00294"></a>00294   
<a name="l00295"></a>00295   <span class="comment">// This also implies the initial value of ds</span>
<a name="l00296"></a>00296   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> = dlambda / <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00299"></a>00299     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Setting ds_current|_0=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> &lt;&lt; std::endl;
<a name="l00300"></a>00300   
<a name="l00301"></a>00301   <span class="comment">// Set y = -du/dlambda using finite difference approximation</span>
<a name="l00302"></a>00302   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a> = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00303"></a>00303   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-1., *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a>);
<a name="l00304"></a>00304   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-1./dlambda);
<a name="l00305"></a>00305   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00306"></a>00306   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ynorm=<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00307"></a>00307   
<a name="l00308"></a>00308   <span class="comment">// Finally, set the value of du_ds to be used in the upcoming</span>
<a name="l00309"></a>00309   <span class="comment">// tangent calculation. du/ds = du/dlambda * dlambda/ds</span>
<a name="l00310"></a>00310   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a> = *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>;
<a name="l00311"></a>00311   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>);
<a name="l00312"></a>00312   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="comment">// Determine additional solution normalization parameter</span>
<a name="l00315"></a>00315   <span class="comment">// (Since we just set du/ds, it will be:  ||du||*||du/ds||)</span>
<a name="l00316"></a>00316   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aec7faf1468f632e64415540f6c9897a2">set_Theta</a>();
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="comment">// The value of Theta_LOCA which makes dlambda_ds = 1/sqrt(2),</span>
<a name="l00319"></a>00319   <span class="comment">// assuming our Theta = ||du||^2.</span>
<a name="l00320"></a>00320   <span class="comment">// Theta_LOCA = std::abs(dlambda);</span>
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Assuming general Theta</span>
<a name="l00323"></a>00323   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> = std::sqrt(1./<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>/ynorm/ynorm);
<a name="l00324"></a>00324   
<a name="l00325"></a>00325   
<a name="l00326"></a>00326   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00327"></a>00327     {
<a name="l00328"></a>00328       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Setting initial Theta_LOCA = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> &lt;&lt; std::endl;
<a name="l00329"></a>00329       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Theta_LOCA^2*Theta         = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a> &lt;&lt; std::endl;
<a name="l00330"></a>00330       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;initial d(lambda)/ds|_0    = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> &lt;&lt; std::endl;
<a name="l00331"></a>00331       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;initial ||du_ds||_0        = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>() &lt;&lt; std::endl;
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   
<a name="l00336"></a>00336   <span class="comment">// OK, we estimated the tangent at point u0.</span>
<a name="l00337"></a>00337   <span class="comment">// Now, to estimate the tangent at point u1, we call the solve_tangent routine.</span>
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="comment">// Set the flag which tells us the method has been initialized.</span>
<a name="l00340"></a>00340   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">tangent_initialized</a> = <span class="keyword">true</span>;
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a686615e1d0b0559da3c1f0b620211bec">solve_tangent</a>();
<a name="l00343"></a>00343   
<a name="l00344"></a>00344   <span class="comment">// Advance the solution and the parameter to the next value.</span>
<a name="l00345"></a>00345   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6869735ca949bbd219ffdac8c2f08296">update_solution</a>();
<a name="l00346"></a>00346 }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 <span class="comment">// This is most of the &quot;guts&quot; of this class.  This is where we implement</span>
<a name="l00354"></a>00354 <span class="comment">// our custom Newton iterations and perform most of the solves.</span>
<a name="l00355"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8706b919a3b01da570359d8bb71338dd">00355</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8706b919a3b01da570359d8bb71338dd">ContinuationSystem::continuation_solve</a>()
<a name="l00356"></a>00356 {
<a name="l00357"></a>00357   <span class="comment">// Be sure the user has set the continuation parameter pointer</span>
<a name="l00358"></a>00358   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>)
<a name="l00359"></a>00359     {
<a name="l00360"></a>00360       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;You must set the continuation_parameter pointer &quot;</span>
<a name="l00361"></a>00361                     &lt;&lt; <span class="stringliteral">&quot;to a member variable of the derived class, preferably in the &quot;</span>
<a name="l00362"></a>00362                     &lt;&lt; <span class="stringliteral">&quot;Derived class&#39;s init_data function.  This is how the ContinuationSystem &quot;</span>
<a name="l00363"></a>00363                     &lt;&lt; <span class="stringliteral">&quot;updates the continuation parameter.&quot;</span>
<a name="l00364"></a>00364                     &lt;&lt; std::endl;
<a name="l00365"></a>00365       
<a name="l00366"></a>00366       libmesh_error();
<a name="l00367"></a>00367     }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Use extra precision for all the numbers printed in this function.</span>
<a name="l00370"></a>00370   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00371"></a>00371   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00372"></a>00372   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7be489dff0fb06bd015f4ab861a5f8f7">setf</a>(std::ios_base::scientific);
<a name="l00373"></a>00373   
<a name="l00374"></a>00374   <span class="comment">// We can&#39;t start solving the augmented PDE system unless the tangent</span>
<a name="l00375"></a>00375   <span class="comment">// vectors have been initialized.  This only needs to occur once.</span>
<a name="l00376"></a>00376   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">tangent_initialized</a>)
<a name="l00377"></a>00377     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac5130a85829d1f6e7bb63373a3efe0a7">initialize_tangent</a>();
<a name="l00378"></a>00378 
<a name="l00379"></a>00379   <span class="comment">// Save the old value of -du/dlambda.  This will be used after the Newton iterations</span>
<a name="l00380"></a>00380   <span class="comment">// to compute the angle between previous tangent vectors.  This cosine of this angle is</span>
<a name="l00381"></a>00381   <span class="comment">//</span>
<a name="l00382"></a>00382   <span class="comment">// tau := abs( (du/d(lambda)_i , du/d(lambda)_{i-1}) / (||du/d(lambda)_i|| * ||du/d(lambda)_{i-1}||) )</span>
<a name="l00383"></a>00383   <span class="comment">//</span>
<a name="l00384"></a>00384   <span class="comment">// The scaling factor tau (which should vary between 0 and 1) is used to shrink the step-size ds</span>
<a name="l00385"></a>00385   <span class="comment">// when we are approaching a turning point.  Note that it can only shrink the step size.  </span>
<a name="l00386"></a>00386   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">y_old</a> = *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>;
<a name="l00387"></a>00387   
<a name="l00388"></a>00388   <span class="comment">// Set pointer to underlying Newton solver</span>
<a name="l00389"></a>00389   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>)
<a name="l00390"></a>00390     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a> = libmesh_cast_ptr&lt;NewtonSolver*&gt; (this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;diff_solver().<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00391"></a>00391   
<a name="l00392"></a>00392   <span class="comment">// A pair for catching return values from linear system solves.</span>
<a name="l00393"></a>00393   std::pair&lt;unsigned int, Real&gt; rval;
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <span class="comment">// Convergence flag for the entire arcstep</span>
<a name="l00396"></a>00396   <span class="keywordtype">bool</span> arcstep_converged = <span class="keyword">false</span>;
<a name="l00397"></a>00397 
<a name="l00398"></a>00398   <span class="comment">// Begin loop over arcstep reductions.</span>
<a name="l00399"></a>00399   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns=0; ns&lt;<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a460a40fa157a8a02291bf801855da11a">n_arclength_reductions</a>; ++ns)
<a name="l00400"></a>00400     {
<a name="l00401"></a>00401       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Current arclength stepsize, ds_current=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> &lt;&lt; std::endl;
<a name="l00404"></a>00404           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Current parameter value, lambda=&quot;</span> &lt;&lt; *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &lt;&lt; std::endl;
<a name="l00405"></a>00405         }
<a name="l00406"></a>00406       
<a name="l00407"></a>00407       <span class="comment">// Upon exit from the nonlinear loop, the newton_converged flag</span>
<a name="l00408"></a>00408       <span class="comment">// will tell us the convergence status of Newton&#39;s method.</span>
<a name="l00409"></a>00409       <span class="keywordtype">bool</span> newton_converged = <span class="keyword">false</span>;
<a name="l00410"></a>00410 
<a name="l00411"></a>00411       <span class="comment">// The nonlinear residual before *any* nonlinear steps have been taken.</span>
<a name="l00412"></a>00412       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> nonlinear_residual_firststep = 0.;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414       <span class="comment">// The nonlinear residual from the current &quot;k&quot; Newton step, before the Newton step</span>
<a name="l00415"></a>00415       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> nonlinear_residual_beforestep = 0.;
<a name="l00416"></a>00416 
<a name="l00417"></a>00417       <span class="comment">// The nonlinear residual from the current &quot;k&quot; Newton step, after the Newton step</span>
<a name="l00418"></a>00418       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> nonlinear_residual_afterstep = 0.;
<a name="l00419"></a>00419 
<a name="l00420"></a>00420       <span class="comment">// The linear solver tolerance, can be updated dynamically at each Newton step.</span>
<a name="l00421"></a>00421       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_linear_tolerance = 0.;
<a name="l00422"></a>00422       
<a name="l00423"></a>00423       <span class="comment">// The nonlinear loop</span>
<a name="l00424"></a>00424       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>=0; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>&lt;<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>-&gt;<a class="code" href="classlibMesh_1_1DiffSolver.php#ae2d85fde243f9037ca23cc5f58483d21">max_nonlinear_iterations</a>; ++<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>)
<a name="l00425"></a>00425         {
<a name="l00426"></a>00426           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;\n === Starting Newton step &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a> &lt;&lt; <span class="stringliteral">&quot; ===&quot;</span> &lt;&lt; std::endl;
<a name="l00427"></a>00427           
<a name="l00428"></a>00428           <span class="comment">// Set the linear system solver tolerance</span>
<a name="l00429"></a>00429 <span class="comment">//        // 1.) Set the current linear tolerance based as a multiple of the current residual of the system.</span>
<a name="l00430"></a>00430 <span class="comment">//        const Real residual_multiple = 1.e-4;</span>
<a name="l00431"></a>00431 <span class="comment">//        Real current_linear_tolerance = residual_multiple*nonlinear_residual_beforestep;</span>
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 <span class="comment">//        // But if the current residual isn&#39;t small, don&#39;t let the solver exit with zero iterations!</span>
<a name="l00434"></a>00434 <span class="comment">//        if (current_linear_tolerance &gt; 1.)</span>
<a name="l00435"></a>00435 <span class="comment">//          current_linear_tolerance = residual_multiple;</span>
<a name="l00436"></a>00436 
<a name="l00437"></a>00437           <span class="comment">// 2.) Set the current linear tolerance based on the method based on technique of Eisenstat &amp; Walker.</span>
<a name="l00438"></a>00438           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>==0)
<a name="l00439"></a>00439             {
<a name="l00440"></a>00440               <span class="comment">// At first step, only try reducing the residual by a small amount</span>
<a name="l00441"></a>00441               current_linear_tolerance = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a23b9ced011dfbbf49fcac0d00b58d5c5">initial_newton_tolerance</a>;<span class="comment">//0.01;</span>
<a name="l00442"></a>00442             }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444           <span class="keywordflow">else</span>
<a name="l00445"></a>00445             {
<a name="l00446"></a>00446               <span class="comment">// The new tolerance is based on the ratio of the most recent tolerances</span>
<a name="l00447"></a>00447               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alp=0.5*(1.+std::sqrt(5.));
<a name="l00448"></a>00448               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> gam=0.9;
<a name="l00449"></a>00449 
<a name="l00450"></a>00450               libmesh_assert (nonlinear_residual_beforestep != 0.0);
<a name="l00451"></a>00451               libmesh_assert (nonlinear_residual_afterstep != 0.0);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453               current_linear_tolerance = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(gam*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(nonlinear_residual_afterstep/nonlinear_residual_beforestep, alp),
<a name="l00454"></a>00454                                                   current_linear_tolerance*current_linear_tolerance
<a name="l00455"></a>00455                                                   );
<a name="l00456"></a>00456 
<a name="l00457"></a>00457               <span class="comment">// Don&#39;t let it get ridiculously small!!</span>
<a name="l00458"></a>00458               <span class="keywordflow">if</span> (current_linear_tolerance &lt; 1.e-12)
<a name="l00459"></a>00459                 current_linear_tolerance = 1.e-12;
<a name="l00460"></a>00460             }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00463"></a>00463             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Using current_linear_tolerance=&quot;</span> &lt;&lt; current_linear_tolerance &lt;&lt; std::endl;
<a name="l00464"></a>00464 
<a name="l00465"></a>00465           
<a name="l00466"></a>00466           <span class="comment">// Assemble the residual (and Jacobian).</span>
<a name="l00467"></a>00467           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea24777dbaa6ef5bfd9980dc81ebfdba81">Residual</a>;
<a name="l00468"></a>00468           <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a>(<span class="keyword">true</span>,   <span class="comment">// Residual</span>
<a name="l00469"></a>00469                    <span class="keyword">true</span>); <span class="comment">// Jacobian</span>
<a name="l00470"></a>00470           <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00471"></a>00471 
<a name="l00472"></a>00472           <span class="comment">// Save the current nonlinear residual.  We don&#39;t need to recompute the residual unless</span>
<a name="l00473"></a>00473           <span class="comment">// this is the first step, since it was already computed as part of the convergence check</span>
<a name="l00474"></a>00474           <span class="comment">// at the end of the last loop iteration.</span>
<a name="l00475"></a>00475           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>==0)
<a name="l00476"></a>00476             {
<a name="l00477"></a>00477               nonlinear_residual_beforestep = <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00478"></a>00478 
<a name="l00479"></a>00479               <span class="comment">// Store the residual before any steps have been taken.  This will *not*</span>
<a name="l00480"></a>00480               <span class="comment">// be updated at each step, and can be used to see if any progress has</span>
<a name="l00481"></a>00481               <span class="comment">// been made from the initial residual at later steps.</span>
<a name="l00482"></a>00482               nonlinear_residual_firststep = nonlinear_residual_beforestep;
<a name="l00483"></a>00483 
<a name="l00484"></a>00484               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> old_norm_u = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;l2_norm();
<a name="l00485"></a>00485               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  (before step) ||R||_{L2} = &quot;</span> &lt;&lt; nonlinear_residual_beforestep &lt;&lt; std::endl;
<a name="l00486"></a>00486               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  (before step) ||R||_{L2}/||u|| = &quot;</span> &lt;&lt; nonlinear_residual_beforestep / old_norm_u &lt;&lt; std::endl;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488               <span class="comment">// In rare cases (very small arcsteps), it&#39;s possible that the residual is</span>
<a name="l00489"></a>00489               <span class="comment">// already below our absolute linear tolerance.</span>
<a name="l00490"></a>00490               <span class="keywordflow">if</span> (nonlinear_residual_beforestep  &lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab7bd605b573521a7a98cf44627bd7e4e">solution_tolerance</a>)
<a name="l00491"></a>00491                 {
<a name="l00492"></a>00492                   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00493"></a>00493                     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Initial guess satisfied linear tolerance, exiting with zero Newton iterations!&quot;</span> &lt;&lt; std::endl;
<a name="l00494"></a>00494 
<a name="l00495"></a>00495                   <span class="comment">// Since we go straight from here to the solve of the next tangent, we</span>
<a name="l00496"></a>00496                   <span class="comment">// have to close the matrix before it can be assembled again.</span>
<a name="l00497"></a>00497                   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00498"></a>00498                   newton_converged=<span class="keyword">true</span>;
<a name="l00499"></a>00499                   <span class="keywordflow">break</span>; <span class="comment">// out of Newton iterations, with newton_converged=true</span>
<a name="l00500"></a>00500                 }
<a name="l00501"></a>00501             }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503           <span class="keywordflow">else</span>
<a name="l00504"></a>00504             {
<a name="l00505"></a>00505               nonlinear_residual_beforestep = nonlinear_residual_afterstep;
<a name="l00506"></a>00506             }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508           
<a name="l00509"></a>00509           <span class="comment">// Solve the linear system G_u*z = G</span>
<a name="l00510"></a>00510           <span class="comment">// Initial guess?</span>
<a name="l00511"></a>00511           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>(); <span class="comment">// It seems to be extremely important to zero z here, otherwise the solver quits early.</span>
<a name="l00512"></a>00512           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00513"></a>00513           
<a name="l00514"></a>00514           <span class="comment">// It&#39;s possible that we have selected the current_linear_tolerance so large that</span>
<a name="l00515"></a>00515           <span class="comment">// a guess of z=zero yields a linear system residual |Az + R| small enough that the</span>
<a name="l00516"></a>00516           <span class="comment">// linear solver exits in zero iterations.  If this happens, we will reduce the</span>
<a name="l00517"></a>00517           <span class="comment">// current_linear_tolerance until the linear solver does at least 1 iteration.</span>
<a name="l00518"></a>00518           <span class="keywordflow">do</span>
<a name="l00519"></a>00519             {
<a name="l00520"></a>00520               rval =
<a name="l00521"></a>00521                 <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a13d62743d8c1ad7f52869d151208ac08">linear_solver</a>-&gt;solve(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>,
<a name="l00522"></a>00522                                      *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>,
<a name="l00523"></a>00523                                      *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>,
<a name="l00524"></a>00524                                      <span class="comment">//1.e-12,</span>
<a name="l00525"></a>00525                                      current_linear_tolerance,
<a name="l00526"></a>00526                                      <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>-&gt;<a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>);   <span class="comment">// max linear iterations</span>
<a name="l00527"></a>00527               
<a name="l00528"></a>00528               <span class="keywordflow">if</span> (rval.first==0)
<a name="l00529"></a>00529                 {
<a name="l00530"></a>00530                   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>==0)
<a name="l00531"></a>00531                     {
<a name="l00532"></a>00532                       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Repeating initial solve with smaller linear tolerance!&quot;</span> &lt;&lt; std::endl;
<a name="l00533"></a>00533                       current_linear_tolerance *= <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a23b9ced011dfbbf49fcac0d00b58d5c5">initial_newton_tolerance</a>; <span class="comment">// reduce the linear tolerance to force the solver to do some work</span>
<a name="l00534"></a>00534                     }
<a name="l00535"></a>00535                   <span class="keywordflow">else</span>
<a name="l00536"></a>00536                     {
<a name="l00537"></a>00537                       <span class="comment">// We shouldn&#39;t get here ... it means the linear solver did no work on a Newton</span>
<a name="l00538"></a>00538                       <span class="comment">// step other than the first one.  If this happens, we need to think more about our</span>
<a name="l00539"></a>00539                       <span class="comment">// tolerance selection.</span>
<a name="l00540"></a>00540                       libmesh_error();
<a name="l00541"></a>00541                     }
<a name="l00542"></a>00542                 }
<a name="l00543"></a>00543               
<a name="l00544"></a>00544             } <span class="keywordflow">while</span> (rval.first==0);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546           
<a name="l00547"></a>00547           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00548"></a>00548             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  G_u*z = G solver converged at step &quot;</span>
<a name="l00549"></a>00549                           &lt;&lt; rval.first
<a name="l00550"></a>00550                           &lt;&lt; <span class="stringliteral">&quot; linear tolerance = &quot;</span>
<a name="l00551"></a>00551                           &lt;&lt; rval.second
<a name="l00552"></a>00552                           &lt;&lt; <span class="stringliteral">&quot;.&quot;</span>
<a name="l00553"></a>00553                           &lt;&lt; std::endl;
<a name="l00554"></a>00554 
<a name="l00555"></a>00555           <span class="comment">// Sometimes (I am not sure why) the linear solver exits after zero iterations.</span>
<a name="l00556"></a>00556           <span class="comment">// Perhaps it is hitting PETSc&#39;s divergence tolerance dtol???  If this occurs,</span>
<a name="l00557"></a>00557           <span class="comment">// we should break out of the Newton iteration loop because nothing further is</span>
<a name="l00558"></a>00558           <span class="comment">// going to happen...  Of course if the tolerance is already small enough after</span>
<a name="l00559"></a>00559           <span class="comment">// zero iterations (how can this happen?!) we should not quit.</span>
<a name="l00560"></a>00560           <span class="keywordflow">if</span> ((rval.first == 0) &amp;&amp; (rval.second &gt; current_linear_tolerance*nonlinear_residual_beforestep))
<a name="l00561"></a>00561             {
<a name="l00562"></a>00562               <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00563"></a>00563                 <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver exited in zero iterations!&quot;</span> &lt;&lt; std::endl;
<a name="l00564"></a>00564 
<a name="l00565"></a>00565               <span class="comment">// Try to find out the reason for convergence/divergence</span>
<a name="l00566"></a>00566               <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a13d62743d8c1ad7f52869d151208ac08">linear_solver</a>-&gt;print_converged_reason();
<a name="l00567"></a>00567               
<a name="l00568"></a>00568               <span class="keywordflow">break</span>; <span class="comment">// out of Newton iterations</span>
<a name="l00569"></a>00569             }
<a name="l00570"></a>00570           
<a name="l00571"></a>00571           <span class="comment">// Note: need to scale z by -1 since our code always solves Jx=R</span>
<a name="l00572"></a>00572           <span class="comment">// instead of Jx=-R.</span>
<a name="l00573"></a>00573           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-1.);
<a name="l00574"></a>00574           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580           
<a name="l00581"></a>00581           <span class="comment">// Assemble the G_Lambda vector, skip residual.</span>
<a name="l00582"></a>00582           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea4bcf4ab6f979f5e38505fc32720307f1">G_Lambda</a>;
<a name="l00583"></a>00583 
<a name="l00584"></a>00584           <span class="comment">// Assemble both rhs and Jacobian</span>
<a name="l00585"></a>00585           <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a>(<span class="keyword">true</span>,  <span class="comment">// Residual</span>
<a name="l00586"></a>00586                    <span class="keyword">false</span>); <span class="comment">// Jacobian</span>
<a name="l00587"></a>00587 
<a name="l00588"></a>00588           <span class="comment">// Not sure if this is really necessary</span>
<a name="l00589"></a>00589           <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00590"></a>00590           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yrhsnorm=<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00591"></a>00591           <span class="keywordflow">if</span> (yrhsnorm == 0.0)
<a name="l00592"></a>00592             {
<a name="l00593"></a>00593               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;||G_Lambda|| = 0&quot;</span> &lt;&lt; std::endl;
<a name="l00594"></a>00594               libmesh_error();
<a name="l00595"></a>00595             }
<a name="l00596"></a>00596 
<a name="l00597"></a>00597           <span class="comment">// We select a tolerance for the y-system which is based on the inexact Newton</span>
<a name="l00598"></a>00598           <span class="comment">// tolerance but scaled by an extra term proportional to the RHS (which is not -&gt; 0 in this case)</span>
<a name="l00599"></a>00599           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ysystemtol=current_linear_tolerance*(nonlinear_residual_beforestep/yrhsnorm);
<a name="l00600"></a>00600           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00601"></a>00601             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ysystemtol=&quot;</span> &lt;&lt; ysystemtol &lt;&lt; std::endl;
<a name="l00602"></a>00602           
<a name="l00603"></a>00603           <span class="comment">// Solve G_u*y = G_{\lambda}</span>
<a name="l00604"></a>00604           <span class="comment">// FIXME: Initial guess?  This is really a solve for -du/dlambda so we could try</span>
<a name="l00605"></a>00605           <span class="comment">// initializing it with the latest approximation to that... du/dlambda ~ du/ds * ds/dlambda</span>
<a name="l00606"></a>00606           <span class="comment">//*y = *solution;</span>
<a name="l00607"></a>00607           <span class="comment">//y-&gt;add(-1., *previous_u);</span>
<a name="l00608"></a>00608           <span class="comment">//y-&gt;scale(-1. / (*continuation_parameter - old_continuation_parameter)); // Be careful of divide by zero...</span>
<a name="l00609"></a>00609           <span class="comment">//y-&gt;close();</span>
<a name="l00610"></a>00610           
<a name="l00611"></a>00611           <span class="comment">//      const unsigned int max_attempts=1;</span>
<a name="l00612"></a>00612           <span class="comment">// unsigned int attempt=0;</span>
<a name="l00613"></a>00613           <span class="comment">//      do</span>
<a name="l00614"></a>00614           <span class="comment">//        {</span>
<a name="l00615"></a>00615           <span class="comment">//          if (!quiet)</span>
<a name="l00616"></a>00616           <span class="comment">//            libMesh::out &lt;&lt; &quot;Trying to solve tangent system, attempt &quot; &lt;&lt; attempt &lt;&lt; std::endl;</span>
<a name="l00617"></a>00617               
<a name="l00618"></a>00618               rval =
<a name="l00619"></a>00619                 <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a13d62743d8c1ad7f52869d151208ac08">linear_solver</a>-&gt;solve(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>,
<a name="l00620"></a>00620                                      *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>,
<a name="l00621"></a>00621                                      *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>,
<a name="l00622"></a>00622                                      <span class="comment">//1.e-12, </span>
<a name="l00623"></a>00623                                      ysystemtol,
<a name="l00624"></a>00624                                      <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>-&gt;<a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>);   <span class="comment">// max linear iterations</span>
<a name="l00625"></a>00625 
<a name="l00626"></a>00626               <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00627"></a>00627                 <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  G_u*y = G_{lambda} solver converged at step &quot;</span>
<a name="l00628"></a>00628                           &lt;&lt; rval.first
<a name="l00629"></a>00629                           &lt;&lt; <span class="stringliteral">&quot;, linear tolerance = &quot;</span>
<a name="l00630"></a>00630                           &lt;&lt; rval.second
<a name="l00631"></a>00631                           &lt;&lt; <span class="stringliteral">&quot;.&quot;</span>
<a name="l00632"></a>00632                           &lt;&lt; std::endl;
<a name="l00633"></a>00633 
<a name="l00634"></a>00634               <span class="comment">// Sometimes (I am not sure why) the linear solver exits after zero iterations.</span>
<a name="l00635"></a>00635               <span class="comment">// Perhaps it is hitting PETSc&#39;s divergence tolerance dtol???  If this occurs,</span>
<a name="l00636"></a>00636               <span class="comment">// we should break out of the Newton iteration loop because nothing further is</span>
<a name="l00637"></a>00637               <span class="comment">// going to happen...</span>
<a name="l00638"></a>00638               <span class="keywordflow">if</span> ((rval.first == 0) &amp;&amp; (rval.second &gt; ysystemtol))
<a name="l00639"></a>00639                 {
<a name="l00640"></a>00640                   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00641"></a>00641                     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver exited in zero iterations!&quot;</span> &lt;&lt; std::endl;
<a name="l00642"></a>00642 
<a name="l00643"></a>00643                   <span class="keywordflow">break</span>; <span class="comment">// out of Newton iterations</span>
<a name="l00644"></a>00644                 }
<a name="l00645"></a>00645               
<a name="l00646"></a>00646 <span class="comment">//            ++attempt;</span>
<a name="l00647"></a>00647 <span class="comment">//          } while ((attempt&lt;max_attempts) &amp;&amp; (rval.first==newton_solver-&gt;max_linear_iterations));</span>
<a name="l00648"></a>00648             
<a name="l00649"></a>00649       
<a name="l00650"></a>00650       
<a name="l00651"></a>00651       
<a name="l00652"></a>00652       
<a name="l00653"></a>00653           <span class="comment">// Compute N, the residual of the arclength constraint eqn.</span>
<a name="l00654"></a>00654           <span class="comment">// Note 1: N(u,lambda,s) := (u-u_{old}, du_ds) + (lambda-lambda_{old}, dlambda_ds) - _ds </span>
<a name="l00655"></a>00655           <span class="comment">// We temporarily use the delta_u vector as a temporary vector for this calculation.</span>
<a name="l00656"></a>00656           *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a> = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00657"></a>00657           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-1., *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a>);
<a name="l00658"></a>00658 
<a name="l00659"></a>00659           <span class="comment">// First part of the arclength constraint</span>
<a name="l00660"></a>00660           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> N1 = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>);
<a name="l00661"></a>00661           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> N2 = ((*continuation_parameter) - <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a>)*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>;
<a name="l00662"></a>00662           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> N3 = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>;
<a name="l00663"></a>00663 
<a name="l00664"></a>00664           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00665"></a>00665             {
<a name="l00666"></a>00666               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  N1=&quot;</span> &lt;&lt; N1 &lt;&lt; std::endl;
<a name="l00667"></a>00667               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  N2=&quot;</span> &lt;&lt; N2 &lt;&lt; std::endl;
<a name="l00668"></a>00668               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  N3=&quot;</span> &lt;&lt; N3 &lt;&lt; std::endl;
<a name="l00669"></a>00669             }
<a name="l00670"></a>00670       
<a name="l00671"></a>00671           <span class="comment">// The arclength constraint value </span>
<a name="l00672"></a>00672           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> N = N1+N2-N3;
<a name="l00673"></a>00673       
<a name="l00674"></a>00674           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00675"></a>00675             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  N=&quot;</span> &lt;&lt; N &lt;&lt; std::endl;
<a name="l00676"></a>00676 
<a name="l00677"></a>00677           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> duds_dot_z = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>);
<a name="l00678"></a>00678           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> duds_dot_y = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>);
<a name="l00679"></a>00679 
<a name="l00680"></a>00680           <span class="comment">//libMesh::out &lt;&lt; &quot;duds_dot_z=&quot; &lt;&lt; duds_dot_z &lt;&lt; std::endl;</span>
<a name="l00681"></a>00681           <span class="comment">//libMesh::out &lt;&lt; &quot;duds_dot_y=&quot; &lt;&lt; duds_dot_y &lt;&lt; std::endl;</span>
<a name="l00682"></a>00682           <span class="comment">//libMesh::out &lt;&lt; &quot;dlambda_ds=&quot; &lt;&lt; dlambda_ds &lt;&lt; std::endl;</span>
<a name="l00683"></a>00683 
<a name="l00684"></a>00684           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> delta_lambda_numerator   = -(N          + <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>*duds_dot_z);
<a name="l00685"></a>00685           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> delta_lambda_denominator =  (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> - <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>*duds_dot_y);
<a name="l00686"></a>00686 
<a name="l00687"></a>00687           libmesh_assert (delta_lambda_denominator != 0.0);
<a name="l00688"></a>00688 
<a name="l00689"></a>00689           <span class="comment">// Now, we are ready to compute the step delta_lambda</span>
<a name="l00690"></a>00690           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> delta_lambda_comp = delta_lambda_numerator /
<a name="l00691"></a>00691                                            delta_lambda_denominator;
<a name="l00692"></a>00692           <span class="comment">// Lambda is real-valued</span>
<a name="l00693"></a>00693           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_lambda = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(delta_lambda_comp);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695           <span class="comment">// Knowing delta_lambda, we are ready to update delta_u</span>
<a name="l00696"></a>00696           <span class="comment">// delta_u = z - delta_lambda*y</span>
<a name="l00697"></a>00697           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00698"></a>00698           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(1., *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>);
<a name="l00699"></a>00699           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-delta_lambda, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>);
<a name="l00700"></a>00700           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00701"></a>00701 
<a name="l00702"></a>00702           <span class="comment">// Update the system solution and the continuation parameter.</span>
<a name="l00703"></a>00703           <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(1., *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>);
<a name="l00704"></a>00704           <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00705"></a>00705           *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> += delta_lambda;
<a name="l00706"></a>00706 
<a name="l00707"></a>00707           <span class="comment">// Did the Newton step actually reduce the residual?</span>
<a name="l00708"></a>00708           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea24777dbaa6ef5bfd9980dc81ebfdba81">Residual</a>;
<a name="l00709"></a>00709           <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a>(<span class="keyword">true</span>,   <span class="comment">// Residual</span>
<a name="l00710"></a>00710                    <span class="keyword">false</span>); <span class="comment">// Jacobian</span>
<a name="l00711"></a>00711           <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00712"></a>00712           nonlinear_residual_afterstep = <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00713"></a>00713 
<a name="l00714"></a>00714           
<a name="l00715"></a>00715           <span class="comment">// In a &quot;normal&quot; Newton step, ||du||/||R|| &gt; 1 since the most recent</span>
<a name="l00716"></a>00716           <span class="comment">// step is where you &quot;just were&quot; and the current residual is where</span>
<a name="l00717"></a>00717           <span class="comment">// you are now.  It can occur that ||du||/||R|| &lt; 1, but these are</span>
<a name="l00718"></a>00718           <span class="comment">// likely not good cases to attempt backtracking (?).</span>
<a name="l00719"></a>00719           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_du_norm_R = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>() / nonlinear_residual_afterstep;
<a name="l00720"></a>00720           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00721"></a>00721             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  norm_du_norm_R=&quot;</span> &lt;&lt; norm_du_norm_R &lt;&lt; std::endl;
<a name="l00722"></a>00722       
<a name="l00723"></a>00723       
<a name="l00724"></a>00724           <span class="comment">// Factor to decrease the stepsize by for backtracking</span>
<a name="l00725"></a>00725           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> newton_stepfactor = 1.;
<a name="l00726"></a>00726 
<a name="l00727"></a>00727           <span class="keyword">const</span> <span class="keywordtype">bool</span> attempt_backtracking =
<a name="l00728"></a>00728             (nonlinear_residual_afterstep &gt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab7bd605b573521a7a98cf44627bd7e4e">solution_tolerance</a>)
<a name="l00729"></a>00729             &amp;&amp; (nonlinear_residual_afterstep &gt; nonlinear_residual_beforestep)
<a name="l00730"></a>00730             &amp;&amp; (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecb2c9bf8e35299c02a1fb768082f8cb">n_backtrack_steps</a>&gt;0)
<a name="l00731"></a>00731             &amp;&amp; (norm_du_norm_R &gt; 1.)
<a name="l00732"></a>00732             ;
<a name="l00733"></a>00733     
<a name="l00734"></a>00734           <span class="comment">// If residual is not reduced, do Newton back tracking.  </span>
<a name="l00735"></a>00735           <span class="keywordflow">if</span> (attempt_backtracking)
<a name="l00736"></a>00736             {
<a name="l00737"></a>00737               <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00738"></a>00738                 <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Newton step did not reduce residual.&quot;</span> &lt;&lt; std::endl;
<a name="l00739"></a>00739 
<a name="l00740"></a>00740               <span class="comment">// back off the previous step.</span>
<a name="l00741"></a>00741               <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-1., *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>);
<a name="l00742"></a>00742               <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00743"></a>00743               *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> -= delta_lambda;
<a name="l00744"></a>00744 
<a name="l00745"></a>00745               <span class="comment">// Backtracking: start cutting the Newton stepsize by halves until</span>
<a name="l00746"></a>00746               <span class="comment">// the new residual is actually smaller...</span>
<a name="l00747"></a>00747               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> backtrack_step=0; backtrack_step&lt;<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecb2c9bf8e35299c02a1fb768082f8cb">n_backtrack_steps</a>; ++backtrack_step)
<a name="l00748"></a>00748                 {
<a name="l00749"></a>00749                   newton_stepfactor *= 0.5;
<a name="l00750"></a>00750 
<a name="l00751"></a>00751                   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00752"></a>00752                     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Shrinking step size by &quot;</span> &lt;&lt; newton_stepfactor &lt;&lt; std::endl;
<a name="l00753"></a>00753               
<a name="l00754"></a>00754                   <span class="comment">// Take fractional step</span>
<a name="l00755"></a>00755                   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(newton_stepfactor, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>);
<a name="l00756"></a>00756                   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00757"></a>00757                   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> += newton_stepfactor*delta_lambda;
<a name="l00758"></a>00758               
<a name="l00759"></a>00759                   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea24777dbaa6ef5bfd9980dc81ebfdba81">Residual</a>;
<a name="l00760"></a>00760                   <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a>(<span class="keyword">true</span>,   <span class="comment">// Residual</span>
<a name="l00761"></a>00761                            <span class="keyword">false</span>); <span class="comment">// Jacobian</span>
<a name="l00762"></a>00762                   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00763"></a>00763                   nonlinear_residual_afterstep = <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00764"></a>00764 
<a name="l00765"></a>00765                   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00766"></a>00766                     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;At shrink step &quot;</span>
<a name="l00767"></a>00767                               &lt;&lt; backtrack_step
<a name="l00768"></a>00768                               &lt;&lt; <span class="stringliteral">&quot;, nonlinear_residual_afterstep=&quot;</span>
<a name="l00769"></a>00769                               &lt;&lt; nonlinear_residual_afterstep
<a name="l00770"></a>00770                               &lt;&lt; std::endl;
<a name="l00771"></a>00771 
<a name="l00772"></a>00772                   <span class="keywordflow">if</span> (nonlinear_residual_afterstep &lt; nonlinear_residual_beforestep)
<a name="l00773"></a>00773                     {
<a name="l00774"></a>00774                       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00775"></a>00775                         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Backtracking succeeded!&quot;</span> &lt;&lt; std::endl;
<a name="l00776"></a>00776                       
<a name="l00777"></a>00777                       <span class="keywordflow">break</span>; <span class="comment">// out of backtracking loop</span>
<a name="l00778"></a>00778                     }
<a name="l00779"></a>00779                   
<a name="l00780"></a>00780                   <span class="keywordflow">else</span>
<a name="l00781"></a>00781                     {
<a name="l00782"></a>00782                       <span class="comment">// Back off that step</span>
<a name="l00783"></a>00783                       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-newton_stepfactor, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>);
<a name="l00784"></a>00784                       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00785"></a>00785                       *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> -= newton_stepfactor*delta_lambda;
<a name="l00786"></a>00786                     }
<a name="l00787"></a>00787               
<a name="l00788"></a>00788                   <span class="comment">// Save a copy of the solution from before the Newton step.</span>
<a name="l00789"></a>00789                   <span class="comment">//AutoPtr&lt;NumericVector&lt;Number&gt; &gt; prior_iterate = solution-&gt;clone();</span>
<a name="l00790"></a>00790                 }
<a name="l00791"></a>00791             } <span class="comment">// end if (attempte_backtracking)</span>
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 
<a name="l00794"></a>00794           <span class="comment">// If we tried backtracking but the residual is still not reduced, print message.</span>
<a name="l00795"></a>00795           <span class="keywordflow">if</span> ((attempt_backtracking) &amp;&amp; (nonlinear_residual_afterstep &gt; nonlinear_residual_beforestep))
<a name="l00796"></a>00796             {
<a name="l00797"></a>00797               <span class="comment">//libMesh::err &lt;&lt; &quot;Backtracking failed.&quot; &lt;&lt; std::endl;</span>
<a name="l00798"></a>00798               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Backtracking failed.&quot;</span> &lt;&lt; std::endl;
<a name="l00799"></a>00799           
<a name="l00800"></a>00800               <span class="comment">// 1.) Quit, exit program.</span>
<a name="l00801"></a>00801               <span class="comment">//libmesh_error();</span>
<a name="l00802"></a>00802 
<a name="l00803"></a>00803               <span class="comment">// 2.) Continue with last newton_stepfactor</span>
<a name="l00804"></a>00804               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>&lt;3)
<a name="l00805"></a>00805                 {
<a name="l00806"></a>00806                   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(newton_stepfactor, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>);
<a name="l00807"></a>00807                   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00808"></a>00808                   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> += newton_stepfactor*delta_lambda;
<a name="l00809"></a>00809                   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00810"></a>00810                     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Backtracking could not reduce residual ... continuing anyway!&quot;</span> &lt;&lt; std::endl;
<a name="l00811"></a>00811                 }
<a name="l00812"></a>00812               
<a name="l00813"></a>00813               <span class="comment">// 3.) Break out of Newton iteration loop with newton_converged = false,</span>
<a name="l00814"></a>00814               <span class="comment">//     reduce the arclength stepsize, and try again.</span>
<a name="l00815"></a>00815               <span class="keywordflow">else</span>
<a name="l00816"></a>00816                 {
<a name="l00817"></a>00817                   <span class="keywordflow">break</span>; <span class="comment">// out of Newton iteration loop, with newton_converged=false</span>
<a name="l00818"></a>00818                 }
<a name="l00819"></a>00819             }
<a name="l00820"></a>00820 
<a name="l00821"></a>00821           <span class="comment">// Another type of convergence check: suppose the residual has not been reduced</span>
<a name="l00822"></a>00822           <span class="comment">// from its initial value after half of the allowed Newton steps have occurred.</span>
<a name="l00823"></a>00823           <span class="comment">// In our experience, this typically means that it isn&#39;t going to converge and</span>
<a name="l00824"></a>00824           <span class="comment">// we could probably save time by dropping out of the Newton iteration loop and</span>
<a name="l00825"></a>00825           <span class="comment">// trying a smaller arcstep.</span>
<a name="l00826"></a>00826           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8723254d749f107d589deffb4eae4f5f">newton_progress_check</a>)
<a name="l00827"></a>00827             {
<a name="l00828"></a>00828               <span class="keywordflow">if</span> ((nonlinear_residual_afterstep &gt; nonlinear_residual_firststep) &amp;&amp;
<a name="l00829"></a>00829                   (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>+1 &gt; static_cast&lt;unsigned int&gt;(0.5*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>-&gt;<a class="code" href="classlibMesh_1_1DiffSolver.php#ae2d85fde243f9037ca23cc5f58483d21">max_nonlinear_iterations</a>)))
<a name="l00830"></a>00830                 {
<a name="l00831"></a>00831                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Progress check failed: the current residual: &quot;</span>
<a name="l00832"></a>00832                                 &lt;&lt; nonlinear_residual_afterstep
<a name="l00833"></a>00833                                 &lt;&lt; <span class="stringliteral">&quot;, is\n&quot;</span>
<a name="l00834"></a>00834                                 &lt;&lt; <span class="stringliteral">&quot;larger than the initial residual, and half of the allowed\n&quot;</span>
<a name="l00835"></a>00835                                 &lt;&lt; <span class="stringliteral">&quot;number of Newton iterations have elapsed.\n&quot;</span>
<a name="l00836"></a>00836                                 &lt;&lt; <span class="stringliteral">&quot;Exiting Newton iterations with converged==false.&quot;</span> &lt;&lt; std::endl;
<a name="l00837"></a>00837               
<a name="l00838"></a>00838                   <span class="keywordflow">break</span>; <span class="comment">// out of Newton iteration loop, newton_converged = false</span>
<a name="l00839"></a>00839                 }
<a name="l00840"></a>00840             }
<a name="l00841"></a>00841           
<a name="l00842"></a>00842           <span class="comment">// Safety check: Check the current continuation parameter against user-provided min-allowable parameter value</span>
<a name="l00843"></a>00843           <span class="keywordflow">if</span> (*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3c926e951ebf781dd05157295532a833">min_continuation_parameter</a>)
<a name="l00844"></a>00844             {
<a name="l00845"></a>00845               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Continuation parameter fell below min-allowable value.&quot;</span> &lt;&lt; std::endl;
<a name="l00846"></a>00846               <span class="comment">// libmesh_error();</span>
<a name="l00847"></a>00847               <span class="keywordflow">break</span>; <span class="comment">// out of Newton iteration loop, newton_converged = false</span>
<a name="l00848"></a>00848             }
<a name="l00849"></a>00849           
<a name="l00850"></a>00850           <span class="comment">// Safety check: Check the current continuation parameter against user-provided max-allowable parameter value</span>
<a name="l00851"></a>00851           <span class="keywordflow">if</span> ( (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a69d569bd9b652d24df1fbc9bd2c9c54a">max_continuation_parameter</a> != 0.0) &amp;&amp;
<a name="l00852"></a>00852                (*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &gt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a69d569bd9b652d24df1fbc9bd2c9c54a">max_continuation_parameter</a>) )
<a name="l00853"></a>00853             {
<a name="l00854"></a>00854               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Current continuation parameter value: &quot;</span>
<a name="l00855"></a>00855                             &lt;&lt; *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>
<a name="l00856"></a>00856                             &lt;&lt; <span class="stringliteral">&quot; exceeded max-allowable value.&quot;</span>
<a name="l00857"></a>00857                             &lt;&lt; std::endl;
<a name="l00858"></a>00858               <span class="comment">// libmesh_error();</span>
<a name="l00859"></a>00859               <span class="keywordflow">break</span>; <span class="comment">// out of Newton iteration loop, newton_converged = false</span>
<a name="l00860"></a>00860             }
<a name="l00861"></a>00861           
<a name="l00862"></a>00862       
<a name="l00863"></a>00863           <span class="comment">// Check the convergence of the parameter and the solution.  If they are small</span>
<a name="l00864"></a>00864           <span class="comment">// enough, we can break out of the Newton iteration loop.  </span>
<a name="l00865"></a>00865           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_delta_u = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00866"></a>00866           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_u = <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;l2_norm();
<a name="l00867"></a>00867           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  delta_lambda                   = &quot;</span> &lt;&lt; delta_lambda &lt;&lt; std::endl;
<a name="l00868"></a>00868           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  newton_stepfactor*delta_lambda = &quot;</span> &lt;&lt; newton_stepfactor*delta_lambda &lt;&lt; std::endl;
<a name="l00869"></a>00869           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  lambda_current                 = &quot;</span> &lt;&lt; *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &lt;&lt; std::endl;
<a name="l00870"></a>00870           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  ||delta_u||                    = &quot;</span> &lt;&lt; norm_delta_u &lt;&lt; std::endl;
<a name="l00871"></a>00871           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  ||delta_u||/||u||              = &quot;</span> &lt;&lt; norm_delta_u / norm_u &lt;&lt; std::endl;
<a name="l00872"></a>00872       
<a name="l00873"></a>00873 
<a name="l00874"></a>00874           <span class="comment">// Evaluate the residual at the current Newton iterate.  We don&#39;t want to detect</span>
<a name="l00875"></a>00875           <span class="comment">// convergence due to a small Newton step when the residual is still not small.</span>
<a name="l00876"></a>00876           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea24777dbaa6ef5bfd9980dc81ebfdba81">Residual</a>;
<a name="l00877"></a>00877           <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a>(<span class="keyword">true</span>,   <span class="comment">// Residual</span>
<a name="l00878"></a>00878                    <span class="keyword">false</span>); <span class="comment">// Jacobian</span>
<a name="l00879"></a>00879           <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00880"></a>00880           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_residual = <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00881"></a>00881           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  ||R||_{L2} = &quot;</span> &lt;&lt; norm_residual &lt;&lt; std::endl;
<a name="l00882"></a>00882           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  ||R||_{L2}/||u|| = &quot;</span> &lt;&lt; norm_residual / norm_u &lt;&lt; std::endl;
<a name="l00883"></a>00883       
<a name="l00884"></a>00884       
<a name="l00885"></a>00885           <span class="comment">// FIXME: The norm_delta_u tolerance (at least) should be relative.</span>
<a name="l00886"></a>00886           <span class="comment">// It doesn&#39;t make sense to converge a solution whose size is ~ 10^5 to</span>
<a name="l00887"></a>00887           <span class="comment">// a tolerance of 1.e-6.  Oh, and we should also probably check the</span>
<a name="l00888"></a>00888           <span class="comment">// (relative) size of the residual as well, instead of just the step.</span>
<a name="l00889"></a>00889           <span class="keywordflow">if</span> ((std::abs(delta_lambda) &lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#acaa3c4e3ee838ed8c53c0636e83b3846">continuation_parameter_tolerance</a>) &amp;&amp;
<a name="l00890"></a>00890               <span class="comment">//(norm_delta_u       &lt; solution_tolerance)               &amp;&amp; // This is a *very* strict criterion we can probably skip</span>
<a name="l00891"></a>00891               (norm_residual      &lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab7bd605b573521a7a98cf44627bd7e4e">solution_tolerance</a>))
<a name="l00892"></a>00892             {
<a name="l00893"></a>00893               <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l00894"></a>00894                 <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Newton iterations converged!&quot;</span> &lt;&lt; std::endl;
<a name="l00895"></a>00895 
<a name="l00896"></a>00896               newton_converged = <span class="keyword">true</span>;
<a name="l00897"></a>00897               <span class="keywordflow">break</span>; <span class="comment">// out of Newton iterations</span>
<a name="l00898"></a>00898             }
<a name="l00899"></a>00899         } <span class="comment">// end nonlinear loop</span>
<a name="l00900"></a>00900 
<a name="l00901"></a>00901       <span class="keywordflow">if</span> (!newton_converged)
<a name="l00902"></a>00902         {
<a name="l00903"></a>00903           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Newton iterations of augmented system did not converge!&quot;</span> &lt;&lt; std::endl;
<a name="l00904"></a>00904           
<a name="l00905"></a>00905           <span class="comment">// Reduce ds_current, recompute the solution and parameter, and continue to next</span>
<a name="l00906"></a>00906           <span class="comment">// arcstep, if there is one.</span>
<a name="l00907"></a>00907           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> *= 0.5;
<a name="l00908"></a>00908 
<a name="l00909"></a>00909           <span class="comment">// Go back to previous solution and parameter value.</span>
<a name="l00910"></a>00910           *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a> = *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a>;
<a name="l00911"></a>00911           *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a>;
<a name="l00912"></a>00912 
<a name="l00913"></a>00913           <span class="comment">// Compute new predictor with smaller ds</span>
<a name="l00914"></a>00914           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a619cd33885c0d1568fa26970fea8f5cd">apply_predictor</a>();
<a name="l00915"></a>00915         }
<a name="l00916"></a>00916       <span class="keywordflow">else</span>
<a name="l00917"></a>00917         {
<a name="l00918"></a>00918           <span class="comment">// Set step convergence and break out</span>
<a name="l00919"></a>00919           arcstep_converged=<span class="keyword">true</span>;
<a name="l00920"></a>00920           <span class="keywordflow">break</span>; <span class="comment">// out of arclength reduction loop</span>
<a name="l00921"></a>00921         }
<a name="l00922"></a>00922       
<a name="l00923"></a>00923     } <span class="comment">// end loop over arclength reductions</span>
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   <span class="comment">// Check for convergence of the whole arcstep.  If not converged at this</span>
<a name="l00926"></a>00926   <span class="comment">// point, we have no choice but to quit.</span>
<a name="l00927"></a>00927   <span class="keywordflow">if</span> (!arcstep_converged)
<a name="l00928"></a>00928     {
<a name="l00929"></a>00929       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Arcstep failed to converge after max number of reductions! Exiting...&quot;</span> &lt;&lt; std::endl;
<a name="l00930"></a>00930       libmesh_error();
<a name="l00931"></a>00931     }
<a name="l00932"></a>00932   
<a name="l00933"></a>00933   <span class="comment">// Print converged solution control parameter and max value.</span>
<a name="l00934"></a>00934   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;lambda_current=&quot;</span> &lt;&lt; *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &lt;&lt; std::endl;
<a name="l00935"></a>00935   <span class="comment">//libMesh::out &lt;&lt; &quot;u_max=&quot; &lt;&lt; solution-&gt;max() &lt;&lt; std::endl;</span>
<a name="l00936"></a>00936 
<a name="l00937"></a>00937   <span class="comment">// Reset old stream precision and flags.</span>
<a name="l00938"></a>00938   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00939"></a>00939   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a959cfec8e67f429502f9dee0558c7b79">unsetf</a>(std::ios_base::scientific);
<a name="l00940"></a>00940 
<a name="l00941"></a>00941   <span class="comment">// Note: we don&#39;t want to go on to the next guess yet, since the user may</span>
<a name="l00942"></a>00942   <span class="comment">// want to post-process this data.  It&#39;s up to the user to call advance_arcstep()</span>
<a name="l00943"></a>00943   <span class="comment">// when they are ready to go on.</span>
<a name="l00944"></a>00944 }
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a>00947 
<a name="l00948"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a652388ee34fa6ffefe9d67e8655e5d1e">00948</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a652388ee34fa6ffefe9d67e8655e5d1e">ContinuationSystem::advance_arcstep</a>()
<a name="l00949"></a>00949 {
<a name="l00950"></a>00950   <span class="comment">// Solve for the updated tangent du1/ds, d(lambda1)/ds</span>
<a name="l00951"></a>00951   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a686615e1d0b0559da3c1f0b620211bec">solve_tangent</a>();
<a name="l00952"></a>00952 
<a name="l00953"></a>00953   <span class="comment">// Advance the solution and the parameter to the next value.</span>
<a name="l00954"></a>00954   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6869735ca949bbd219ffdac8c2f08296">update_solution</a>();
<a name="l00955"></a>00955 }
<a name="l00956"></a>00956 
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 
<a name="l00959"></a>00959 <span class="comment">// This function solves the tangent system:</span>
<a name="l00960"></a>00960 <span class="comment">// [ G_u                G_{lambda}        ][(du/ds)_new      ] = [  0 ]</span>
<a name="l00961"></a>00961 <span class="comment">// [ Theta*(du/ds)_old  (dlambda/ds)_old  ][(dlambda/ds)_new ]   [-N_s]</span>
<a name="l00962"></a>00962 <span class="comment">// The solution is given by:</span>
<a name="l00963"></a>00963 <span class="comment">// .) Let G_u y = G_lambda, then </span>
<a name="l00964"></a>00964 <span class="comment">// .) 2nd row yields:</span>
<a name="l00965"></a>00965 <span class="comment">//    (dlambda/ds)_new = 1.0 / ( (dlambda/ds)_old - Theta*(du/ds)_old*y )</span>
<a name="l00966"></a>00966 <span class="comment">// .) 1st row yields</span>
<a name="l00967"></a>00967 <span class="comment">//    (du_ds)_new = -(dlambda/ds)_new * y</span>
<a name="l00968"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a686615e1d0b0559da3c1f0b620211bec">00968</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a686615e1d0b0559da3c1f0b620211bec">ContinuationSystem::solve_tangent</a>()
<a name="l00969"></a>00969 {
<a name="l00970"></a>00970   <span class="comment">// We shouldn&#39;t call this unless the current tangent already makes sense.</span>
<a name="l00971"></a>00971   libmesh_assert (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">tangent_initialized</a>);
<a name="l00972"></a>00972   
<a name="l00973"></a>00973   <span class="comment">// Set pointer to underlying Newton solver</span>
<a name="l00974"></a>00974   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>)
<a name="l00975"></a>00975     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a> =
<a name="l00976"></a>00976       libmesh_cast_ptr&lt;NewtonSolver*&gt; (this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;diff_solver().<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00977"></a>00977 
<a name="l00978"></a>00978   <span class="comment">// Assemble the system matrix AND rhs, with rhs = G_{\lambda}</span>
<a name="l00979"></a>00979   this-&gt;<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea4bcf4ab6f979f5e38505fc32720307f1">G_Lambda</a>;
<a name="l00980"></a>00980   
<a name="l00981"></a>00981   <span class="comment">// Assemble Residual and Jacobian</span>
<a name="l00982"></a>00982   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a>(<span class="keyword">true</span>,   <span class="comment">// Residual</span>
<a name="l00983"></a>00983                  <span class="keyword">true</span>); <span class="comment">// Jacobian</span>
<a name="l00984"></a>00984 
<a name="l00985"></a>00985   <span class="comment">// Not sure if this is really necessary</span>
<a name="l00986"></a>00986   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00987"></a>00987       
<a name="l00988"></a>00988   <span class="comment">// Solve G_u*y =  G_{\lambda}</span>
<a name="l00989"></a>00989   std::pair&lt;unsigned int, Real&gt; rval = 
<a name="l00990"></a>00990     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a13d62743d8c1ad7f52869d151208ac08">linear_solver</a>-&gt;solve(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>,
<a name="l00991"></a>00991                          *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>,
<a name="l00992"></a>00992                          *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>,
<a name="l00993"></a>00993                          1.e-12, <span class="comment">// relative linear tolerance</span>
<a name="l00994"></a>00994                          2*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>-&gt;<a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>);   <span class="comment">// max linear iterations</span>
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   <span class="comment">// FIXME: If this doesn&#39;t converge at all, the new tangent vector is</span>
<a name="l00997"></a>00997   <span class="comment">// going to be really bad...</span>
<a name="l00998"></a>00998   
<a name="l00999"></a>00999   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01000"></a>01000     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;G_u*y = G_{lambda} solver converged at step &quot;</span>
<a name="l01001"></a>01001                   &lt;&lt; rval.first
<a name="l01002"></a>01002                   &lt;&lt; <span class="stringliteral">&quot; linear tolerance = &quot;</span>
<a name="l01003"></a>01003                   &lt;&lt; rval.second
<a name="l01004"></a>01004                   &lt;&lt; <span class="stringliteral">&quot;.&quot;</span>
<a name="l01005"></a>01005                   &lt;&lt; std::endl;
<a name="l01006"></a>01006 
<a name="l01007"></a>01007   <span class="comment">// Save old solution and parameter tangents for possible use in higher-order</span>
<a name="l01008"></a>01008   <span class="comment">// predictor schemes.</span>
<a name="l01009"></a>01009   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a0cf5468ad5b4aef78f63c4f30395c7b5">previous_dlambda_ds</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>;
<a name="l01010"></a>01010   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ae0f4570622a491f4879271fb6fb6ad08">previous_du_ds</a>     = *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>;
<a name="l01011"></a>01011 
<a name="l01012"></a>01012   
<a name="l01013"></a>01013   <span class="comment">// 1.) Previous, probably wrong, technique!</span>
<a name="l01014"></a>01014 <span class="comment">//   // Solve for the updated d(lambda)/ds</span>
<a name="l01015"></a>01015 <span class="comment">//   // denom = N_{lambda}   - (du_ds)^t y</span>
<a name="l01016"></a>01016 <span class="comment">//   //       = d(lambda)/ds - (du_ds)^t y</span>
<a name="l01017"></a>01017 <span class="comment">//   Real denom = dlambda_ds - du_ds-&gt;dot(*y);</span>
<a name="l01018"></a>01018 
<a name="l01019"></a>01019 <span class="comment">//   //libMesh::out &lt;&lt; &quot;denom=&quot; &lt;&lt; denom &lt;&lt; std::endl;</span>
<a name="l01020"></a>01020 <span class="comment">//   libmesh_assert (denom != 0.0);</span>
<a name="l01021"></a>01021   
<a name="l01022"></a>01022 <span class="comment">//   dlambda_ds = 1.0 / denom;</span>
<a name="l01023"></a>01023 
<a name="l01024"></a>01024 
<a name="l01025"></a>01025 <span class="comment">//   if (!quiet)</span>
<a name="l01026"></a>01026 <span class="comment">//     libMesh::out &lt;&lt; &quot;dlambda_ds=&quot; &lt;&lt; dlambda_ds &lt;&lt; std::endl;</span>
<a name="l01027"></a>01027   
<a name="l01028"></a>01028 <span class="comment">//   // Compute the updated value of du/ds = -_dlambda_ds * y</span>
<a name="l01029"></a>01029 <span class="comment">//   du_ds-&gt;zero();</span>
<a name="l01030"></a>01030 <span class="comment">//   du_ds-&gt;add(-dlambda_ds, *y);</span>
<a name="l01031"></a>01031 <span class="comment">//   du_ds-&gt;close();</span>
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   
<a name="l01034"></a>01034   <span class="comment">// 2.) From Brian Carnes&#39; paper...</span>
<a name="l01035"></a>01035   <span class="comment">// According to Carnes, y comes from solving G_u * y = -G_{\lambda}</span>
<a name="l01036"></a>01036   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-1.);
<a name="l01037"></a>01037   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ynorm = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l01038"></a>01038   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> = 1. / std::sqrt(1. + <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>*ynorm*ynorm);
<a name="l01039"></a>01039 
<a name="l01040"></a>01040   <span class="comment">// Determine the correct sign for dlambda_ds.</span>
<a name="l01041"></a>01041   
<a name="l01042"></a>01042   <span class="comment">// We will use delta_u to temporarily compute this sign.</span>
<a name="l01043"></a>01043   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a> = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01044"></a>01044   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-1., *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a>);
<a name="l01045"></a>01045   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01046"></a>01046 
<a name="l01047"></a>01047   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sgn_dlambda_ds =
<a name="l01048"></a>01048     <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>) +
<a name="l01049"></a>01049     (*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>-<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a>));
<a name="l01050"></a>01050 
<a name="l01051"></a>01051   <span class="keywordflow">if</span> (sgn_dlambda_ds &lt; 0.)
<a name="l01052"></a>01052     {
<a name="l01053"></a>01053       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01054"></a>01054         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;dlambda_ds is negative.&quot;</span> &lt;&lt; std::endl;
<a name="l01055"></a>01055       
<a name="l01056"></a>01056       <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> *= -1.;
<a name="l01057"></a>01057     }
<a name="l01058"></a>01058 
<a name="l01059"></a>01059   <span class="comment">// Finally, set the new tangent vector, du/ds = dlambda/ds * y.</span>
<a name="l01060"></a>01060   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01061"></a>01061   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>);
<a name="l01062"></a>01062   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01063"></a>01063 
<a name="l01064"></a>01064   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01065"></a>01065     {
<a name="l01066"></a>01066       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;d(lambda)/ds = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> &lt;&lt; std::endl;
<a name="l01067"></a>01067       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;||du_ds||    = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>() &lt;&lt; std::endl;
<a name="l01068"></a>01068     }
<a name="l01069"></a>01069 
<a name="l01070"></a>01070   <span class="comment">// Our next solve expects y ~ -du/dlambda, so scale it back by -1 again now.</span>
<a name="l01071"></a>01071   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-1.);
<a name="l01072"></a>01072   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01073"></a>01073 }
<a name="l01074"></a>01074 
<a name="l01075"></a>01075 
<a name="l01076"></a>01076 
<a name="l01077"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#aec7faf1468f632e64415540f6c9897a2">01077</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aec7faf1468f632e64415540f6c9897a2">ContinuationSystem::set_Theta</a>()
<a name="l01078"></a>01078 {
<a name="l01079"></a>01079   <span class="comment">// // Use the norm of the latest solution, squared.</span>
<a name="l01080"></a>01080   <span class="comment">//const Real normu = solution-&gt;l2_norm();</span>
<a name="l01081"></a>01081   <span class="comment">//libmesh_assert (normu != 0.0);</span>
<a name="l01082"></a>01082   <span class="comment">//Theta = 1./normu/normu;</span>
<a name="l01083"></a>01083   
<a name="l01084"></a>01084   <span class="comment">// // 1.) Use the norm of du, squared</span>
<a name="l01085"></a>01085 <span class="comment">//   *delta_u = *solution;</span>
<a name="l01086"></a>01086 <span class="comment">//   delta_u-&gt;add(-1, *previous_u);</span>
<a name="l01087"></a>01087 <span class="comment">//   delta_u-&gt;close();</span>
<a name="l01088"></a>01088 <span class="comment">//   const Real normdu = delta_u-&gt;l2_norm();</span>
<a name="l01089"></a>01089   
<a name="l01090"></a>01090 <span class="comment">//   if (normdu &lt; 1.) // don&#39;t divide by zero or make a huge scaling parameter.</span>
<a name="l01091"></a>01091 <span class="comment">//     Theta = 1.;</span>
<a name="l01092"></a>01092 <span class="comment">//   else</span>
<a name="l01093"></a>01093 <span class="comment">//     Theta = 1./normdu/normdu;</span>
<a name="l01094"></a>01094 
<a name="l01095"></a>01095   <span class="comment">// 2.) Use 1.0, i.e. don&#39;t scale</span>
<a name="l01096"></a>01096   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>=1.;
<a name="l01097"></a>01097 
<a name="l01098"></a>01098   <span class="comment">// 3.) Use a formula which attempts to make the &quot;solution triangle&quot; isosceles.</span>
<a name="l01099"></a>01099 <span class="comment">//   libmesh_assert (std::abs(dlambda_ds) &lt; 1.);</span>
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 <span class="comment">//   *delta_u = *solution;</span>
<a name="l01102"></a>01102 <span class="comment">//   delta_u-&gt;add(-1, *previous_u);</span>
<a name="l01103"></a>01103 <span class="comment">//   delta_u-&gt;close();</span>
<a name="l01104"></a>01104 <span class="comment">//   const Real normdu = delta_u-&gt;l2_norm();</span>
<a name="l01105"></a>01105 
<a name="l01106"></a>01106 <span class="comment">//   Theta = std::sqrt(1. - dlambda_ds*dlambda_ds) / normdu * tau * ds;</span>
<a name="l01107"></a>01107 
<a name="l01108"></a>01108 
<a name="l01109"></a>01109 <span class="comment">//   // 4.) Use the norm of du and the norm of du/ds</span>
<a name="l01110"></a>01110 <span class="comment">//   *delta_u = *solution;</span>
<a name="l01111"></a>01111 <span class="comment">//   delta_u-&gt;add(-1, *previous_u);</span>
<a name="l01112"></a>01112 <span class="comment">//   delta_u-&gt;close();</span>
<a name="l01113"></a>01113 <span class="comment">//   const Real normdu   = delta_u-&gt;l2_norm();</span>
<a name="l01114"></a>01114 <span class="comment">//   du_ds-&gt;close();</span>
<a name="l01115"></a>01115 <span class="comment">//   const Real normduds = du_ds-&gt;l2_norm();</span>
<a name="l01116"></a>01116 
<a name="l01117"></a>01117 <span class="comment">//   if (normduds &lt; 1.e-12)</span>
<a name="l01118"></a>01118 <span class="comment">//     {</span>
<a name="l01119"></a>01119 <span class="comment">//       libMesh::out &lt;&lt; &quot;Setting initial Theta= 1./normdu/normdu&quot; &lt;&lt; std::endl;</span>
<a name="l01120"></a>01120 <span class="comment">//       libMesh::out &lt;&lt; &quot;normdu=&quot; &lt;&lt; normdu &lt;&lt; std::endl;</span>
<a name="l01121"></a>01121 
<a name="l01122"></a>01122 <span class="comment">//       // Don&#39;t use this scaling if the solution delta is already O(1)</span>
<a name="l01123"></a>01123 <span class="comment">//       if (normdu &gt; 1.)</span>
<a name="l01124"></a>01124 <span class="comment">//      Theta = 1./normdu/normdu;</span>
<a name="l01125"></a>01125 <span class="comment">//       else</span>
<a name="l01126"></a>01126 <span class="comment">//      Theta = 1.;</span>
<a name="l01127"></a>01127 <span class="comment">//     }</span>
<a name="l01128"></a>01128 <span class="comment">//   else</span>
<a name="l01129"></a>01129 <span class="comment">//     {</span>
<a name="l01130"></a>01130 <span class="comment">//       libMesh::out &lt;&lt; &quot;Setting Theta= 1./normdu/normduds&quot; &lt;&lt; std::endl;</span>
<a name="l01131"></a>01131 <span class="comment">//       libMesh::out &lt;&lt; &quot;normdu=&quot; &lt;&lt; normdu &lt;&lt; std::endl;</span>
<a name="l01132"></a>01132 <span class="comment">//       libMesh::out &lt;&lt; &quot;normduds=&quot; &lt;&lt; normduds &lt;&lt; std::endl;</span>
<a name="l01133"></a>01133 
<a name="l01134"></a>01134 <span class="comment">//       // Don&#39;t use this scaling if the solution delta is already O(1)</span>
<a name="l01135"></a>01135 <span class="comment">//       if ((normdu&gt;1.) || (normduds&gt;1.))</span>
<a name="l01136"></a>01136 <span class="comment">//      Theta = 1./normdu/normduds;</span>
<a name="l01137"></a>01137 <span class="comment">//       else</span>
<a name="l01138"></a>01138 <span class="comment">//      Theta = 1.;</span>
<a name="l01139"></a>01139 <span class="comment">//     }</span>
<a name="l01140"></a>01140   
<a name="l01141"></a>01141  <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01142"></a>01142    <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Setting Normalization Parameter Theta=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a> &lt;&lt; std::endl;
<a name="l01143"></a>01143 }
<a name="l01144"></a>01144 
<a name="l01145"></a>01145 
<a name="l01146"></a>01146 
<a name="l01147"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ff4d70ffecd54e4c2f35a341cddf3bd">01147</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ff4d70ffecd54e4c2f35a341cddf3bd">ContinuationSystem::set_Theta_LOCA</a>()
<a name="l01148"></a>01148 {
<a name="l01149"></a>01149   <span class="comment">// We also recompute the LOCA normalization parameter based on the</span>
<a name="l01150"></a>01150   <span class="comment">// most recently computed value of dlambda_ds</span>
<a name="l01151"></a>01151   <span class="comment">// if (!quiet)</span>
<a name="l01152"></a>01152   <span class="comment">//   libMesh::out &lt;&lt; &quot;(Theta_LOCA) dlambda_ds=&quot; &lt;&lt; dlambda_ds &lt;&lt; std::endl;</span>
<a name="l01153"></a>01153 
<a name="l01154"></a>01154   <span class="comment">// Formula makes no sense if |dlambda_ds| &gt; 1</span>
<a name="l01155"></a>01155   libmesh_assert (std::abs(<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>) &lt; 1.);
<a name="l01156"></a>01156   
<a name="l01157"></a>01157   <span class="comment">// 1.) Attempt to implement the method in LOCA paper</span>
<a name="l01158"></a>01158 <span class="comment">//   const Real g = 1./std::sqrt(2.); // &quot;desired&quot; dlambda_ds</span>
<a name="l01159"></a>01159 
<a name="l01160"></a>01160 <span class="comment">//   // According to the LOCA people, we only renormalize for</span>
<a name="l01161"></a>01161 <span class="comment">//   // when |dlambda_ds| exceeds some pre-selected maximum (which they take to be zero, btw).</span>
<a name="l01162"></a>01162 <span class="comment">//   if (std::abs(dlambda_ds) &gt; .9)</span>
<a name="l01163"></a>01163 <span class="comment">//     {</span>
<a name="l01164"></a>01164 <span class="comment">//       // Note the *= ... This is updating the previous value of Theta_LOCA</span>
<a name="l01165"></a>01165 <span class="comment">//       // Note: The LOCA people actually use Theta_LOCA^2 to normalize their arclength constraint.</span>
<a name="l01166"></a>01166 <span class="comment">//       Theta_LOCA *= std::abs( (dlambda_ds/g)*std::sqrt( (1.-g*g) / (1.-dlambda_ds*dlambda_ds) ) );</span>
<a name="l01167"></a>01167   
<a name="l01168"></a>01168 <span class="comment">//       // Suggested max-allowable value for Theta_LOCA</span>
<a name="l01169"></a>01169 <span class="comment">//       if (Theta_LOCA &gt; 1.e8)</span>
<a name="l01170"></a>01170 <span class="comment">//      {</span>
<a name="l01171"></a>01171 <span class="comment">//        Theta_LOCA = 1.e8;</span>
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 <span class="comment">//        if (!quiet)</span>
<a name="l01174"></a>01174 <span class="comment">//          libMesh::out &lt;&lt; &quot;max Theta_LOCA=&quot; &lt;&lt; Theta_LOCA &lt;&lt; &quot; has been selected.&quot; &lt;&lt; std::endl;</span>
<a name="l01175"></a>01175 <span class="comment">//      }</span>
<a name="l01176"></a>01176 <span class="comment">//     }</span>
<a name="l01177"></a>01177 <span class="comment">//   else</span>
<a name="l01178"></a>01178 <span class="comment">//     Theta_LOCA=1.0;</span>
<a name="l01179"></a>01179 
<a name="l01180"></a>01180   <span class="comment">// 2.) FIXME: Should we do *= or just =?  This function is of dlambda_ds is</span>
<a name="l01181"></a>01181   <span class="comment">//  &lt; 1,  |dlambda_ds| &lt; 1/sqrt(2) ~~ .7071</span>
<a name="l01182"></a>01182   <span class="comment">//  &gt; 1,  |dlambda_ds| &gt; 1/sqrt(2) ~~ .7071</span>
<a name="l01183"></a>01183   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> *= std::abs( <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> / std::sqrt( (1.-<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>) ) );
<a name="l01184"></a>01184 
<a name="l01185"></a>01185   <span class="comment">// Suggested max-allowable value for Theta_LOCA.  I&#39;ve never come close</span>
<a name="l01186"></a>01186   <span class="comment">// to this value in my code.</span>
<a name="l01187"></a>01187   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> &gt; 1.e8)
<a name="l01188"></a>01188     {
<a name="l01189"></a>01189       <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> = 1.e8;
<a name="l01190"></a>01190       
<a name="l01191"></a>01191       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01192"></a>01192         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;max Theta_LOCA=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> &lt;&lt; <span class="stringliteral">&quot; has been selected.&quot;</span> &lt;&lt; std::endl;
<a name="l01193"></a>01193     }
<a name="l01194"></a>01194     
<a name="l01195"></a>01195   <span class="comment">// 3.) Use 1.0, i.e. don&#39;t scale</span>
<a name="l01196"></a>01196   <span class="comment">//Theta_LOCA=1.0;</span>
<a name="l01197"></a>01197 
<a name="l01198"></a>01198   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01199"></a>01199     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Setting Theta_LOCA=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> &lt;&lt; std::endl;
<a name="l01200"></a>01200 }
<a name="l01201"></a>01201 
<a name="l01202"></a>01202 
<a name="l01203"></a>01203 
<a name="l01204"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6869735ca949bbd219ffdac8c2f08296">01204</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6869735ca949bbd219ffdac8c2f08296">ContinuationSystem::update_solution</a>()
<a name="l01205"></a>01205 {
<a name="l01206"></a>01206   <span class="comment">// Set some stream formatting flags</span>
<a name="l01207"></a>01207   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l01208"></a>01208   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l01209"></a>01209   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a7be489dff0fb06bd015f4ab861a5f8f7">setf</a>(std::ios_base::scientific);
<a name="l01210"></a>01210   
<a name="l01211"></a>01211   <span class="comment">// We must have a tangent that makes sense before we can update the solution.</span>
<a name="l01212"></a>01212   libmesh_assert (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">tangent_initialized</a>);
<a name="l01213"></a>01213 
<a name="l01214"></a>01214   <span class="comment">// Compute tau, the stepsize scaling parameter which attempts to</span>
<a name="l01215"></a>01215   <span class="comment">// reduce ds when the angle between the most recent two tangent</span>
<a name="l01216"></a>01216   <span class="comment">// vectors becomes large.  tau is actually the (absolute value of</span>
<a name="l01217"></a>01217   <span class="comment">// the) cosine of the angle between these two vectors... so if tau ~</span>
<a name="l01218"></a>01218   <span class="comment">// 0 the angle is ~ 90 degrees, while if tau ~ 1 the angle is ~ 0</span>
<a name="l01219"></a>01219   <span class="comment">// degrees.</span>
<a name="l01220"></a>01220   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">y_old</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01221"></a>01221   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01222"></a>01222   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yoldnorm = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">y_old</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l01223"></a>01223   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ynorm = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l01224"></a>01224   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> yoldy = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">y_old</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>);
<a name="l01225"></a>01225   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yold_over_y = yoldnorm/ynorm;
<a name="l01226"></a>01226   
<a name="l01227"></a>01227   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01228"></a>01228     {
<a name="l01229"></a>01229       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;yoldnorm=&quot;</span> &lt;&lt; yoldnorm &lt;&lt; std::endl;
<a name="l01230"></a>01230       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ynorm=&quot;</span>    &lt;&lt; ynorm &lt;&lt; std::endl;
<a name="l01231"></a>01231       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;yoldy=&quot;</span>    &lt;&lt; yoldy &lt;&lt; std::endl;
<a name="l01232"></a>01232       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;yoldnorm/ynorm=&quot;</span> &lt;&lt; yoldnorm/ynorm &lt;&lt; std::endl;
<a name="l01233"></a>01233     }      
<a name="l01234"></a>01234 
<a name="l01235"></a>01235   <span class="comment">// Save the current value of ds before updating it</span>
<a name="l01236"></a>01236   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6fb1f05891c1986f8b3294ae7de8038e">previous_ds</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>;
<a name="l01237"></a>01237   
<a name="l01238"></a>01238   <span class="comment">// // 1.) Cosine method (for some reason this always predicts the angle is ~0)</span>
<a name="l01239"></a>01239   <span class="comment">// // Don&#39;t try divinding by zero</span>
<a name="l01240"></a>01240   <span class="comment">// if ((yoldnorm &gt; 1.e-12) &amp;&amp; (ynorm &gt; 1.e-12))</span>
<a name="l01241"></a>01241   <span class="comment">//   tau = std::abs(yoldy) / yoldnorm  / ynorm;</span>
<a name="l01242"></a>01242   <span class="comment">// else</span>
<a name="l01243"></a>01243   <span class="comment">//   tau = 1.;</span>
<a name="l01244"></a>01244 
<a name="l01245"></a>01245   <span class="comment">// // 2.) Relative size of old and new du/dlambda method with cutoff of 0.9</span>
<a name="l01246"></a>01246   <span class="comment">// if ((yold_over_y &lt; 0.9) &amp;&amp; (yold_over_y &gt; 1.e-6))</span>
<a name="l01247"></a>01247   <span class="comment">//   tau = yold_over_y;</span>
<a name="l01248"></a>01248   <span class="comment">// else</span>
<a name="l01249"></a>01249   <span class="comment">//   tau = 1.;</span>
<a name="l01250"></a>01250 
<a name="l01251"></a>01251   <span class="comment">// 3.) Grow (or shrink) the arclength stepsize by the ratio of du/dlambda, but do not</span>
<a name="l01252"></a>01252   <span class="comment">// exceed the user-specified value of ds.</span>
<a name="l01253"></a>01253   <span class="keywordflow">if</span> (yold_over_y &gt; 1.e-6)
<a name="l01254"></a>01254     {
<a name="l01255"></a>01255       <span class="comment">// // 1.) Scale current ds by the ratio of successive tangents.</span>
<a name="l01256"></a>01256       <span class="comment">//       ds_current *= yold_over_y;</span>
<a name="l01257"></a>01257       <span class="comment">//       if (ds_current &gt; ds)</span>
<a name="l01258"></a>01258       <span class="comment">//        ds_current = ds;</span>
<a name="l01259"></a>01259 
<a name="l01260"></a>01260       <span class="comment">// 2.) Technique 1 tends to shrink the step fairly well (and even if it doesn&#39;t</span>
<a name="l01261"></a>01261       <span class="comment">// get very small, we still have step reduction) but it seems to grow the step</span>
<a name="l01262"></a>01262       <span class="comment">// very slowly.  Another possible technique is step-doubling:</span>
<a name="l01263"></a>01263 <span class="comment">//       if (yold_over_y &gt; 1.)</span>
<a name="l01264"></a>01264 <span class="comment">//              ds_current *= 2.;</span>
<a name="l01265"></a>01265 <span class="comment">//       else</span>
<a name="l01266"></a>01266 <span class="comment">//      ds_current *= yold_over_y;</span>
<a name="l01267"></a>01267 
<a name="l01268"></a>01268       <span class="comment">// 3.) Technique 2 may over-zealous when we are also using the Newton stepgrowth</span>
<a name="l01269"></a>01269       <span class="comment">// factor.  For technique 3 we multiply by yold_over_y unless yold_over_y &gt; 2</span>
<a name="l01270"></a>01270       <span class="comment">// in which case we use 2.</span>
<a name="l01271"></a>01271       <span class="comment">//       if (yold_over_y &gt; 2.)</span>
<a name="l01272"></a>01272       <span class="comment">//        ds_current *= 2.;</span>
<a name="l01273"></a>01273       <span class="comment">//       else</span>
<a name="l01274"></a>01274       <span class="comment">//        ds_current *= yold_over_y;</span>
<a name="l01275"></a>01275 
<a name="l01276"></a>01276       <span class="comment">// 4.) Double-or-halve.  We double the arc-step if the ratio of successive tangents</span>
<a name="l01277"></a>01277       <span class="comment">// is larger than &#39;double_threshold&#39;, halve it if it is less than &#39;halve_threshold&#39;</span>
<a name="l01278"></a>01278       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> double_threshold = 0.5;
<a name="l01279"></a>01279       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> halve_threshold  = 0.5;
<a name="l01280"></a>01280       <span class="keywordflow">if</span> (yold_over_y &gt; double_threshold)
<a name="l01281"></a>01281         <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> *= 2.;
<a name="l01282"></a>01282       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (yold_over_y &lt; halve_threshold)
<a name="l01283"></a>01283         <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> *= 0.5;
<a name="l01284"></a>01284         
<a name="l01285"></a>01285       
<a name="l01286"></a>01286       <span class="comment">// Also possibly use the number of Newton iterations required to compute the previous</span>
<a name="l01287"></a>01287       <span class="comment">// step (relative to the maximum-allowed number of Newton iterations) to grow the step.</span>
<a name="l01288"></a>01288       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad499324a7a490ad9a4777fd48bfca048">newton_stepgrowth_aggressiveness</a> &gt; 0.)
<a name="l01289"></a>01289         {
<a name="l01290"></a>01290           libmesh_assert (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a> != NULL);
<a name="l01291"></a>01291           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nmax = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>-&gt;<a class="code" href="classlibMesh_1_1DiffSolver.php#ae2d85fde243f9037ca23cc5f58483d21">max_nonlinear_iterations</a>;
<a name="l01292"></a>01292 
<a name="l01293"></a>01293           <span class="comment">// // The LOCA Newton step growth technique (note: only grows step length)</span>
<a name="l01294"></a>01294           <span class="comment">// const Real stepratio = static_cast&lt;Real&gt;(Nmax-(newton_step+1))/static_cast&lt;Real&gt;(Nmax-1.);</span>
<a name="l01295"></a>01295           <span class="comment">// const Real newtonstep_growthfactor = 1. + newton_stepgrowth_aggressiveness*stepratio*stepratio;</span>
<a name="l01296"></a>01296 
<a name="l01297"></a>01297           <span class="comment">// The &quot;Nopt/N&quot; method, may grow or shrink the step.  Assume Nopt=Nmax/2.</span>
<a name="l01298"></a>01298           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> newtonstep_growthfactor =
<a name="l01299"></a>01299             <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad499324a7a490ad9a4777fd48bfca048">newton_stepgrowth_aggressiveness</a> * 0.5 *
<a name="l01300"></a>01300             <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(Nmax) / static_cast&lt;Real&gt;(<a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>+1);
<a name="l01301"></a>01301 
<a name="l01302"></a>01302           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01303"></a>01303             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;newtonstep_growthfactor=&quot;</span> &lt;&lt; newtonstep_growthfactor &lt;&lt; std::endl;
<a name="l01304"></a>01304         
<a name="l01305"></a>01305           <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> *= newtonstep_growthfactor;
<a name="l01306"></a>01306         }
<a name="l01307"></a>01307     }
<a name="l01308"></a>01308 
<a name="l01309"></a>01309   
<a name="l01310"></a>01310   <span class="comment">// Don&#39;t let the stepsize get above the user&#39;s maximum-allowed stepsize.</span>
<a name="l01311"></a>01311   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> &gt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a113feb65e8fc969228ce08e71971aae6">ds</a>)
<a name="l01312"></a>01312     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a113feb65e8fc969228ce08e71971aae6">ds</a>;
<a name="l01313"></a>01313   
<a name="l01314"></a>01314   <span class="comment">// Check also for a minimum allowed stepsize.</span>
<a name="l01315"></a>01315   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> &lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7cc77804ea5ef5dde638fe522aeed6a3">ds_min</a>)
<a name="l01316"></a>01316     {
<a name="l01317"></a>01317       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Enforcing minimum-allowed arclength stepsize of &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7cc77804ea5ef5dde638fe522aeed6a3">ds_min</a> &lt;&lt; std::endl;
<a name="l01318"></a>01318       <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7cc77804ea5ef5dde638fe522aeed6a3">ds_min</a>;
<a name="l01319"></a>01319     }
<a name="l01320"></a>01320   
<a name="l01321"></a>01321   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01322"></a>01322     {
<a name="l01323"></a>01323       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Current step size: ds_current=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a> &lt;&lt; std::endl;
<a name="l01324"></a>01324     }
<a name="l01325"></a>01325   
<a name="l01326"></a>01326   <span class="comment">// Recompute scaling factor Theta for</span>
<a name="l01327"></a>01327   <span class="comment">// the current solution before updating.</span>
<a name="l01328"></a>01328   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aec7faf1468f632e64415540f6c9897a2">set_Theta</a>();
<a name="l01329"></a>01329 
<a name="l01330"></a>01330   <span class="comment">// Also, recompute the LOCA scaling factor, which attempts to</span>
<a name="l01331"></a>01331   <span class="comment">// maintain a reasonable value of dlambda/ds</span>
<a name="l01332"></a>01332   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ff4d70ffecd54e4c2f35a341cddf3bd">set_Theta_LOCA</a>();
<a name="l01333"></a>01333     
<a name="l01334"></a>01334   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Theta*Theta_LOCA^2=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a> &lt;&lt; std::endl;
<a name="l01335"></a>01335 
<a name="l01336"></a>01336   <span class="comment">// Based on the asymptotic singular behavior of du/dlambda near simple turning points,</span>
<a name="l01337"></a>01337   <span class="comment">// we can compute a single parameter which may suggest that we are close to a singularity.</span>
<a name="l01338"></a>01338   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a> = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01339"></a>01339   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-1, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a>);
<a name="l01340"></a>01340   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l01341"></a>01341   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> normdu   = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l01342"></a>01342   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> C = (std::log (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>*normdu) /
<a name="l01343"></a>01343                   std::log (std::abs(*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>-<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a>))) - 1.0;
<a name="l01344"></a>01344   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01345"></a>01345     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;C=&quot;</span> &lt;&lt; C &lt;&lt; std::endl;
<a name="l01346"></a>01346   
<a name="l01347"></a>01347   <span class="comment">// Save the current value of u and lambda before updating.</span>
<a name="l01348"></a>01348   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ab1f92beb3279c4ed3267e63c7a9eb9">save_current_solution</a>();
<a name="l01349"></a>01349 
<a name="l01350"></a>01350   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01351"></a>01351     {
<a name="l01352"></a>01352       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating the solution with the tangent guess.&quot;</span> &lt;&lt; std::endl;
<a name="l01353"></a>01353       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;||u_old||=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;l2_norm() &lt;&lt; std::endl;
<a name="l01354"></a>01354       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;lambda_old=&quot;</span> &lt;&lt; *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &lt;&lt; std::endl;
<a name="l01355"></a>01355     }
<a name="l01356"></a>01356 
<a name="l01357"></a>01357   <span class="comment">// Since we solved for the tangent vector, now we can compute an</span>
<a name="l01358"></a>01358   <span class="comment">// initial guess for the new solution, and an initial guess for the</span>
<a name="l01359"></a>01359   <span class="comment">// new value of lambda.</span>
<a name="l01360"></a>01360   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a619cd33885c0d1568fa26970fea8f5cd">apply_predictor</a>();
<a name="l01361"></a>01361 
<a name="l01362"></a>01362   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>)
<a name="l01363"></a>01363     {
<a name="l01364"></a>01364       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;||u_new||=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;l2_norm() &lt;&lt; std::endl;
<a name="l01365"></a>01365       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;lambda_new=&quot;</span> &lt;&lt; *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> &lt;&lt; std::endl;
<a name="l01366"></a>01366     }
<a name="l01367"></a>01367   
<a name="l01368"></a>01368   <span class="comment">// Unset previous stream flags</span>
<a name="l01369"></a>01369   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l01370"></a>01370   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a959cfec8e67f429502f9dee0558c7b79">unsetf</a>(std::ios_base::scientific);
<a name="l01371"></a>01371 }
<a name="l01372"></a>01372 
<a name="l01373"></a>01373 
<a name="l01374"></a>01374 
<a name="l01375"></a>01375 
<a name="l01376"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ab1f92beb3279c4ed3267e63c7a9eb9">01376</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ab1f92beb3279c4ed3267e63c7a9eb9">ContinuationSystem::save_current_solution</a>()
<a name="l01377"></a>01377 {
<a name="l01378"></a>01378   <span class="comment">// Save the old solution vector</span>
<a name="l01379"></a>01379   *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a> = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01380"></a>01380 
<a name="l01381"></a>01381   <span class="comment">// Save the old value of lambda</span>
<a name="l01382"></a>01382   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a> = *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>;
<a name="l01383"></a>01383 }
<a name="l01384"></a>01384 
<a name="l01385"></a>01385 
<a name="l01386"></a>01386 
<a name="l01387"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a619cd33885c0d1568fa26970fea8f5cd">01387</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a619cd33885c0d1568fa26970fea8f5cd">ContinuationSystem::apply_predictor</a>()
<a name="l01388"></a>01388 {
<a name="l01389"></a>01389   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a172cfb334a843f73419f20ab5cde57a5">predictor</a> == <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a9c5dbe46dad699af1f4278be53012c76">Euler</a>)
<a name="l01390"></a>01390     {
<a name="l01391"></a>01391       <span class="comment">// 1.) Euler Predictor</span>
<a name="l01392"></a>01392       <span class="comment">// Predict next the solution</span>
<a name="l01393"></a>01393       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>, *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>);
<a name="l01394"></a>01394       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l01395"></a>01395   
<a name="l01396"></a>01396       <span class="comment">// Predict next parameter value</span>
<a name="l01397"></a>01397       *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> += <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>;
<a name="l01398"></a>01398     }
<a name="l01399"></a>01399 
<a name="l01400"></a>01400 
<a name="l01401"></a>01401   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a172cfb334a843f73419f20ab5cde57a5">predictor</a> == <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a64dba0386d970145477a4d001db5e549">AB2</a>)
<a name="l01402"></a>01402     {
<a name="l01403"></a>01403       <span class="comment">// 2.) 2nd-order explicit AB predictor</span>
<a name="l01404"></a>01404       libmesh_assert(<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6fb1f05891c1986f8b3294ae7de8038e">previous_ds</a> != 0.0);
<a name="l01405"></a>01405       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> stepratio = <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>/<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6fb1f05891c1986f8b3294ae7de8038e">previous_ds</a>;
<a name="l01406"></a>01406       
<a name="l01407"></a>01407       <span class="comment">// Build up next solution value.</span>
<a name="l01408"></a>01408       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add( 0.5*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>*(2.+stepratio), *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>);
<a name="l01409"></a>01409       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(-0.5*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>*stepratio     , *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#ae0f4570622a491f4879271fb6fb6ad08">previous_du_ds</a>);
<a name="l01410"></a>01410       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l01411"></a>01411       
<a name="l01412"></a>01412       <span class="comment">// Next parameter value</span>
<a name="l01413"></a>01413       *<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a> +=
<a name="l01414"></a>01414         0.5*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>*((2.+stepratio)*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a> -
<a name="l01415"></a>01415                         stepratio*<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a0cf5468ad5b4aef78f63c4f30395c7b5">previous_dlambda_ds</a>);
<a name="l01416"></a>01416     }
<a name="l01417"></a>01417 
<a name="l01418"></a>01418   <span class="keywordflow">else</span>
<a name="l01419"></a>01419     {
<a name="l01420"></a>01420       <span class="comment">// Unknown predictor</span>
<a name="l01421"></a>01421       libmesh_error();
<a name="l01422"></a>01422     }
<a name="l01423"></a>01423   
<a name="l01424"></a>01424 }
<a name="l01425"></a>01425 
<a name="l01426"></a>01426 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
