<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">elem.C</div>  </div>
</div>
<div class="contents">
<a href="elem_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem.C 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iterator&gt;</span>  <span class="comment">// for std::ostream_iterator</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge2_8h.php">edge_edge2.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge4_8h.php">edge_edge4.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="face__quad8_8h.php">face_quad8.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="face__quad9_8h.php">face_quad9.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad4_8h.php">face_inf_quad4.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad6_8h.php">face_inf_quad6.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet10_8h.php">cell_tet10.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex8_8h.php">cell_hex8.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex20_8h.php">cell_hex20.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex27_8h.php">cell_hex27.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex8_8h.php">cell_inf_hex8.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex16_8h.php">cell_inf_hex16.h</a>&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex18_8h.php">cell_inf_hex18.h</a>&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism6_8h.php">cell_prism6.h</a>&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism15_8h.php">cell_prism15.h</a>&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism18_8h.php">cell_prism18.h</a>&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism6_8h.php">cell_inf_prism6.h</a>&quot;</span>
<a name="l00053"></a>00053 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism12_8h.php">cell_inf_prism12.h</a>&quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor">#include &quot;<a class="code" href="cell__pyramid5_8h.php">cell_pyramid5.h</a>&quot;</span>
<a name="l00055"></a>00055 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00056"></a>00056 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00057"></a>00057 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00058"></a>00058 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="mesh_8h.php">mesh.h</a>&quot;</span>
<a name="l00062"></a>00062 <span class="preprocessor">#include &quot;<a class="code" href="periodic__boundaries_8h.php">periodic_boundaries.h</a>&quot;</span>
<a name="l00063"></a>00063 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00064"></a>00064 <span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>
<a name="l00066"></a>00066 <span class="keyword">namespace </span>libMesh
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="comment">// Initialize static member variables</span>
<a name="l00070"></a>00070 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#aa264f7b65b55bcafe3a1ca127c419602">Elem::_bp1</a> = 65449;
<a name="l00071"></a>00071 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0228a7bfb5dda3f22a4f9851ec09d2d1">Elem::_bp2</a> = 48661;
<a name="l00072"></a>00072 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a1a76b7c00bdaac5d0a245ec42d1e0576">Elem::type_to_n_nodes_map</a> [] =
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     2,  <span class="comment">// EDGE2</span>
<a name="l00075"></a>00075     3,  <span class="comment">// EDGE3</span>
<a name="l00076"></a>00076     4,  <span class="comment">// EDGE4</span>
<a name="l00077"></a>00077                  
<a name="l00078"></a>00078     3,  <span class="comment">// TRI3</span>
<a name="l00079"></a>00079     6,  <span class="comment">// TRI6</span>
<a name="l00080"></a>00080                  
<a name="l00081"></a>00081     4,  <span class="comment">// QUAD4</span>
<a name="l00082"></a>00082     8,  <span class="comment">// QUAD8</span>
<a name="l00083"></a>00083     9,  <span class="comment">// QUAD9</span>
<a name="l00084"></a>00084     
<a name="l00085"></a>00085     4,  <span class="comment">// TET4</span>
<a name="l00086"></a>00086     10, <span class="comment">// TET10</span>
<a name="l00087"></a>00087                  
<a name="l00088"></a>00088     8,  <span class="comment">// HEX8</span>
<a name="l00089"></a>00089     20, <span class="comment">// HEX20</span>
<a name="l00090"></a>00090     27, <span class="comment">// HEX27</span>
<a name="l00091"></a>00091                  
<a name="l00092"></a>00092     6,  <span class="comment">// PRISM6</span>
<a name="l00093"></a>00093     15, <span class="comment">// PRISM15</span>
<a name="l00094"></a>00094     18, <span class="comment">// PRISM18</span>
<a name="l00095"></a>00095     
<a name="l00096"></a>00096     5,  <span class="comment">// PYRAMID5</span>
<a name="l00097"></a>00097     
<a name="l00098"></a>00098     2,  <span class="comment">// INFEDGE2</span>
<a name="l00099"></a>00099     
<a name="l00100"></a>00100     4,  <span class="comment">// INFQUAD4</span>
<a name="l00101"></a>00101     6,  <span class="comment">// INFQUAD6</span>
<a name="l00102"></a>00102                  
<a name="l00103"></a>00103     8,  <span class="comment">// INFHEX8</span>
<a name="l00104"></a>00104     16, <span class="comment">// INFHEX16</span>
<a name="l00105"></a>00105     18, <span class="comment">// INFHEX18</span>
<a name="l00106"></a>00106                  
<a name="l00107"></a>00107     6,  <span class="comment">// INFPRISM6</span>
<a name="l00108"></a>00108     16, <span class="comment">// INFPRISM12</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     1,  <span class="comment">// NODEELEM</span>
<a name="l00111"></a>00111   };
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00116"></a>00116 <span class="comment">// Elem class member funcions</span>
<a name="l00117"></a><a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">00117</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00118"></a>00118                           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p)
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;
<a name="l00121"></a>00121  
<a name="l00122"></a>00122   <span class="keywordflow">switch</span> (type)
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124       <span class="comment">// 1D elements </span>
<a name="l00125"></a>00125     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00126"></a>00126       {
<a name="l00127"></a>00127         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge2.php">Edge2</a>(p);
<a name="l00128"></a>00128         <span class="keywordflow">break</span>;
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00131"></a>00131       {
<a name="l00132"></a>00132         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>(p);
<a name="l00133"></a>00133         <span class="keywordflow">break</span>;
<a name="l00134"></a>00134       }
<a name="l00135"></a>00135     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00136"></a>00136       {
<a name="l00137"></a>00137         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge4.php">Edge4</a>(p);
<a name="l00138"></a>00138         <span class="keywordflow">break</span>;
<a name="l00139"></a>00139       }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142       
<a name="l00143"></a>00143       <span class="comment">// 2D elements</span>
<a name="l00144"></a>00144     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00145"></a>00145       {
<a name="l00146"></a>00146         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>(p);
<a name="l00147"></a>00147         <span class="keywordflow">break</span>;
<a name="l00148"></a>00148       }
<a name="l00149"></a>00149     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00150"></a>00150       {
<a name="l00151"></a>00151         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>(p);
<a name="l00152"></a>00152         <span class="keywordflow">break</span>;
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00155"></a>00155       {
<a name="l00156"></a>00156         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>(p);
<a name="l00157"></a>00157         <span class="keywordflow">break</span>;
<a name="l00158"></a>00158       }
<a name="l00159"></a>00159     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00160"></a>00160       {
<a name="l00161"></a>00161         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>(p);
<a name="l00162"></a>00162         <span class="keywordflow">break</span>;
<a name="l00163"></a>00163       }
<a name="l00164"></a>00164     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00165"></a>00165       {
<a name="l00166"></a>00166         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>(p);
<a name="l00167"></a>00167         <span class="keywordflow">break</span>;
<a name="l00168"></a>00168       }
<a name="l00169"></a>00169    
<a name="l00170"></a>00170 
<a name="l00171"></a>00171       <span class="comment">// 3D elements</span>
<a name="l00172"></a>00172     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00173"></a>00173       {
<a name="l00174"></a>00174         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a>(p);
<a name="l00175"></a>00175         <span class="keywordflow">break</span>;
<a name="l00176"></a>00176       }
<a name="l00177"></a>00177     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00178"></a>00178       {
<a name="l00179"></a>00179         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet10.php">Tet10</a>(p);
<a name="l00180"></a>00180         <span class="keywordflow">break</span>;
<a name="l00181"></a>00181       }
<a name="l00182"></a>00182     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00183"></a>00183       {
<a name="l00184"></a>00184         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex8.php">Hex8</a>(p);
<a name="l00185"></a>00185         <span class="keywordflow">break</span>;
<a name="l00186"></a>00186       }
<a name="l00187"></a>00187     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00188"></a>00188       {
<a name="l00189"></a>00189         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex20.php">Hex20</a>(p);
<a name="l00190"></a>00190         <span class="keywordflow">break</span>;
<a name="l00191"></a>00191       }
<a name="l00192"></a>00192     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00193"></a>00193       {
<a name="l00194"></a>00194         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex27.php">Hex27</a>(p);
<a name="l00195"></a>00195         <span class="keywordflow">break</span>;
<a name="l00196"></a>00196       }
<a name="l00197"></a>00197     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00198"></a>00198       {
<a name="l00199"></a>00199         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism6.php">Prism6</a>(p);
<a name="l00200"></a>00200         <span class="keywordflow">break</span>;
<a name="l00201"></a>00201       }
<a name="l00202"></a>00202     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00203"></a>00203       {
<a name="l00204"></a>00204         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism15.php">Prism15</a>(p);
<a name="l00205"></a>00205         <span class="keywordflow">break</span>;
<a name="l00206"></a>00206       }
<a name="l00207"></a>00207     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00208"></a>00208       {
<a name="l00209"></a>00209         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism18.php">Prism18</a>(p);
<a name="l00210"></a>00210         <span class="keywordflow">break</span>;
<a name="l00211"></a>00211       }
<a name="l00212"></a>00212     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Pyramid5.php">Pyramid5</a>(p);
<a name="l00215"></a>00215         <span class="keywordflow">break</span>;
<a name="l00216"></a>00216       }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span>
<a name="l00222"></a>00222       <span class="comment">// 1D infinite elements</span>
<a name="l00223"></a>00223     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00224"></a>00224       {
<a name="l00225"></a>00225         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a>(p);
<a name="l00226"></a>00226         <span class="keywordflow">break</span>;
<a name="l00227"></a>00227       }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230       <span class="comment">// 2D infinite elements</span>
<a name="l00231"></a>00231     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00232"></a>00232       {
<a name="l00233"></a>00233         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>(p);
<a name="l00234"></a>00234         <span class="keywordflow">break</span>;
<a name="l00235"></a>00235       }
<a name="l00236"></a>00236     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00237"></a>00237       {
<a name="l00238"></a>00238         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>(p);
<a name="l00239"></a>00239         <span class="keywordflow">break</span>;
<a name="l00240"></a>00240       }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242    
<a name="l00243"></a>00243     <span class="comment">// 3D infinite elements</span>
<a name="l00244"></a>00244     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00245"></a>00245       {
<a name="l00246"></a>00246         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfHex8.php">InfHex8</a>(p);
<a name="l00247"></a>00247         <span class="keywordflow">break</span>;
<a name="l00248"></a>00248       }
<a name="l00249"></a>00249     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00250"></a>00250       {
<a name="l00251"></a>00251         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfHex16.php">InfHex16</a>(p);
<a name="l00252"></a>00252         <span class="keywordflow">break</span>;
<a name="l00253"></a>00253       }
<a name="l00254"></a>00254     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00255"></a>00255       {
<a name="l00256"></a>00256         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfHex18.php">InfHex18</a>(p);
<a name="l00257"></a>00257         <span class="keywordflow">break</span>;
<a name="l00258"></a>00258       }
<a name="l00259"></a>00259     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00260"></a>00260       {
<a name="l00261"></a>00261         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfPrism6.php">InfPrism6</a>(p);
<a name="l00262"></a>00262         <span class="keywordflow">break</span>;
<a name="l00263"></a>00263       }
<a name="l00264"></a>00264     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00265"></a>00265       {
<a name="l00266"></a>00266         elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfPrism12.php">InfPrism12</a>(p);
<a name="l00267"></a>00267         <span class="keywordflow">break</span>;
<a name="l00268"></a>00268       }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 <span class="preprocessor">#endif</span>
<a name="l00271"></a>00271 <span class="preprocessor"></span>           
<a name="l00272"></a>00272     <span class="keywordflow">default</span>:
<a name="l00273"></a>00273       {
<a name="l00274"></a>00274         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Undefined element type!.&quot;</span> &lt;&lt; std::endl;
<a name="l00275"></a>00275         libmesh_error();
<a name="l00276"></a>00276       }
<a name="l00277"></a>00277     }
<a name="l00278"></a>00278   
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(elem);
<a name="l00281"></a>00281   <span class="keywordflow">return</span> ap;
<a name="l00282"></a>00282 }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a><a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">00286</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">Elem::centroid</a>()<span class="keyword"> const</span>
<a name="l00287"></a>00287 <span class="keyword"></span>{
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1Point.php">Point</a> cp;
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); n++)
<a name="l00291"></a>00291     cp.<a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">add</a> (this-&gt;point(n));
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">return</span> (cp /= static_cast&lt;Real&gt;(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>()));    
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a><a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">00298</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">Elem::hmin</a>()<span class="keyword"> const</span>
<a name="l00299"></a>00299 <span class="keyword"></span>{
<a name="l00300"></a>00300   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> h_min=1.e30;
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_outer=0; n_outer&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); n_outer++)
<a name="l00303"></a>00303     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_inner=n_outer+1; n_inner&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); n_inner++)
<a name="l00304"></a>00304       {
<a name="l00305"></a>00305         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> diff = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n_outer) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n_inner));
<a name="l00306"></a>00306         
<a name="l00307"></a>00307         h_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(h_min,diff.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>());
<a name="l00308"></a>00308       }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="keywordflow">return</span> h_min;
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a><a class="code" href="classlibMesh_1_1Elem.php#af238e5529e55b1c434b0a6ec923b5f47">00315</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#af238e5529e55b1c434b0a6ec923b5f47">Elem::hmax</a>()<span class="keyword"> const</span>
<a name="l00316"></a>00316 <span class="keyword"></span>{
<a name="l00317"></a>00317   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> h_max=0;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_outer=0; n_outer&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); n_outer++)
<a name="l00320"></a>00320     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_inner=n_outer+1; n_inner&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); n_inner++)
<a name="l00321"></a>00321       {
<a name="l00322"></a>00322         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> diff = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n_outer) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n_inner));
<a name="l00323"></a>00323         
<a name="l00324"></a>00324         h_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(h_max,diff.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>());
<a name="l00325"></a>00325       }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="keywordflow">return</span> h_max;
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a><a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">00332</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">Elem::length</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1, 
<a name="l00333"></a>00333                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2)<span class="keyword"> const</span>
<a name="l00334"></a>00334 <span class="keyword"></span>{
<a name="l00335"></a>00335   libmesh_assert ( n1 &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>() );
<a name="l00336"></a>00336   libmesh_assert ( n2 &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>() );
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n2)).size();
<a name="l00339"></a>00339 }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a><a class="code" href="classlibMesh_1_1Elem.php#a9fcb2f0b5d9b258d4b1189806d577d5f">00343</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a9fcb2f0b5d9b258d4b1189806d577d5f">Elem::operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00344"></a>00344 <span class="keyword"></span>{
<a name="l00345"></a>00345 
<a name="l00346"></a>00346     <span class="comment">// Cast rhs to an Elem*</span>
<a name="l00347"></a>00347 <span class="comment">//    const Elem* rhs_elem = dynamic_cast&lt;const Elem*&gt;(&amp;rhs);</span>
<a name="l00348"></a>00348     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* rhs_elem = &amp;rhs;
<a name="l00349"></a>00349 
<a name="l00350"></a>00350     <span class="comment">// If we cannot cast to an Elem*, rhs must be a Node</span>
<a name="l00351"></a>00351 <span class="comment">//    if(rhs_elem == static_cast&lt;const Elem*&gt;(NULL))</span>
<a name="l00352"></a>00352 <span class="comment">//        return false;</span>
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 <span class="comment">//   libmesh_assert (n_nodes());</span>
<a name="l00355"></a>00355 <span class="comment">//   libmesh_assert (rhs.n_nodes());</span>
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="comment">//   // Elements can only be equal if they</span>
<a name="l00358"></a>00358 <span class="comment">//   // contain the same number of nodes.</span>
<a name="l00359"></a>00359 <span class="comment">//   if (this-&gt;n_nodes() == rhs.n_nodes())</span>
<a name="l00360"></a>00360 <span class="comment">//     {</span>
<a name="l00361"></a>00361 <span class="comment">//       // Create a set that contains our global</span>
<a name="l00362"></a>00362 <span class="comment">//       // node numbers and those of our neighbor.</span>
<a name="l00363"></a>00363 <span class="comment">//       // If the set is the same size as the number</span>
<a name="l00364"></a>00364 <span class="comment">//       // of nodes in both elements then they must</span>
<a name="l00365"></a>00365 <span class="comment">//       // be connected to the same nodes.     </span>
<a name="l00366"></a>00366 <span class="comment">//       std::set&lt;unsigned int&gt; nodes_set;</span>
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="comment">//       for (unsigned int n=0; n&lt;this-&gt;n_nodes(); n++)</span>
<a name="l00369"></a>00369 <span class="comment">//         {</span>
<a name="l00370"></a>00370 <span class="comment">//           nodes_set.insert(this-&gt;node(n));</span>
<a name="l00371"></a>00371 <span class="comment">//           nodes_set.insert(rhs.node(n));</span>
<a name="l00372"></a>00372 <span class="comment">//         }</span>
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 <span class="comment">//       // If this passes the elements are connected</span>
<a name="l00375"></a>00375 <span class="comment">//       // to the same global nodes</span>
<a name="l00376"></a>00376 <span class="comment">//       if (nodes_set.size() == this-&gt;n_nodes())</span>
<a name="l00377"></a>00377 <span class="comment">//         return true;</span>
<a name="l00378"></a>00378 <span class="comment">//     }</span>
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="comment">//   // If we get here it is because the elements either</span>
<a name="l00381"></a>00381 <span class="comment">//   // do not have the same number of nodes or they are</span>
<a name="l00382"></a>00382 <span class="comment">//   // connected to different nodes.  Either way they</span>
<a name="l00383"></a>00383 <span class="comment">//   // are not the same element</span>
<a name="l00384"></a>00384 <span class="comment">//   return false;</span>
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   <span class="comment">// Useful typedefs</span>
<a name="l00387"></a>00387   <span class="keyword">typedef</span> std::vector&lt;unsigned int&gt;::iterator <a class="code" href="classstd_1_1iterator.php">iterator</a>;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   
<a name="l00390"></a>00390   <span class="comment">// Elements can only be equal if they</span>
<a name="l00391"></a>00391   <span class="comment">// contain the same number of nodes.</span>
<a name="l00392"></a>00392   <span class="comment">// However, we will only test the vertices,</span>
<a name="l00393"></a>00393   <span class="comment">// which is sufficient &amp; cheaper</span>
<a name="l00394"></a>00394   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>() == rhs_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>())
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396       <span class="comment">// The number of nodes in the element</span>
<a name="l00397"></a>00397       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00398"></a>00398       
<a name="l00399"></a>00399       <span class="comment">// Create a vector that contains our global</span>
<a name="l00400"></a>00400       <span class="comment">// node numbers and those of our neighbor.</span>
<a name="l00401"></a>00401       <span class="comment">// If the sorted, unique vector is the same size</span>
<a name="l00402"></a>00402       <span class="comment">// as the number of nodes in both elements then</span>
<a name="l00403"></a>00403       <span class="comment">// they must be connected to the same nodes.</span>
<a name="l00404"></a>00404       <span class="comment">//</span>
<a name="l00405"></a>00405       <span class="comment">// The vector will be no larger than 2*n_nodes(),</span>
<a name="l00406"></a>00406       <span class="comment">// so we might as well reserve the space.</span>
<a name="l00407"></a>00407       std::vector&lt;unsigned int&gt; common_nodes;
<a name="l00408"></a>00408       common_nodes.reserve (2*nn);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410       <span class="comment">// Add the global indices of the nodes</span>
<a name="l00411"></a>00411       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l00412"></a>00412         {
<a name="l00413"></a>00413           common_nodes.push_back (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));
<a name="l00414"></a>00414           common_nodes.push_back (rhs_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));
<a name="l00415"></a>00415         }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417       <span class="comment">// Sort the vector and find out how long</span>
<a name="l00418"></a>00418       <span class="comment">// the sorted vector is.</span>
<a name="l00419"></a>00419       std::sort (common_nodes.begin(), common_nodes.end());
<a name="l00420"></a>00420       
<a name="l00421"></a>00421       iterator new_end = std::unique (common_nodes.begin(),
<a name="l00422"></a>00422                                       common_nodes.end());
<a name="l00423"></a>00423       
<a name="l00424"></a>00424       <span class="keyword">const</span> <span class="keywordtype">int</span> new_size = std::distance (common_nodes.begin(),
<a name="l00425"></a>00425                                           new_end);
<a name="l00426"></a>00426       
<a name="l00427"></a>00427       <span class="comment">// If this passes the elements are connected</span>
<a name="l00428"></a>00428       <span class="comment">// to the same global vertex nodes</span>
<a name="l00429"></a>00429       <span class="keywordflow">if</span> (new_size == static_cast&lt;int&gt;(nn))
<a name="l00430"></a>00430         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00431"></a>00431     }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <span class="comment">// If we get here it is because the elements either</span>
<a name="l00434"></a>00434   <span class="comment">// do not have the same number of nodes or they are</span>
<a name="l00435"></a>00435   <span class="comment">// connected to different nodes.  Either way they</span>
<a name="l00436"></a>00436   <span class="comment">// are not the same element</span>
<a name="l00437"></a>00437   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00438"></a>00438 }
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a><a class="code" href="classlibMesh_1_1Elem.php#a9eb4aede10696470eb619cf0ccbc6c04">00442</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a9eb4aede10696470eb619cf0ccbc6c04">Elem::contains_vertex_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e)<span class="keyword"> const</span>
<a name="l00443"></a>00443 <span class="keyword"></span>{
<a name="l00444"></a>00444   <span class="comment">// Our vertices are the first numbered nodes</span>
<a name="l00445"></a>00445   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); ++n)
<a name="l00446"></a>00446     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#afd665f3e6d13b0aaaf4c4620067329bc">contains_point</a>(e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n)))
<a name="l00447"></a>00447       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00448"></a>00448   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00449"></a>00449 }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a><a class="code" href="classlibMesh_1_1Elem.php#a65c90c62886121e4ff7b33f7acf48843">00453</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a65c90c62886121e4ff7b33f7acf48843">Elem::contains_edge_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e)<span class="keyword"> const</span>
<a name="l00454"></a>00454 <span class="keyword"></span>{
<a name="l00455"></a>00455   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_contained_edges = 0;
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="comment">// Our vertices are the first numbered nodes</span>
<a name="l00458"></a>00458   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); ++n)
<a name="l00459"></a>00459     {
<a name="l00460"></a>00460       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#afd665f3e6d13b0aaaf4c4620067329bc">contains_point</a>(e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n)))
<a name="l00461"></a>00461         {
<a name="l00462"></a>00462           num_contained_edges++;
<a name="l00463"></a>00463           <span class="keywordflow">if</span>(num_contained_edges&gt;=2)
<a name="l00464"></a>00464             {
<a name="l00465"></a>00465               <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00466"></a>00466             }
<a name="l00467"></a>00467         }
<a name="l00468"></a>00468     }
<a name="l00469"></a>00469   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00470"></a>00470 }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 
<a name="l00474"></a><a class="code" href="classlibMesh_1_1Elem.php#a479ca39359c81c4c75f19457a23ad32f">00474</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a479ca39359c81c4c75f19457a23ad32f">Elem::find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set)<span class="keyword"> const</span>
<a name="l00475"></a>00475 <span class="keyword"></span>{
<a name="l00476"></a>00476   neighbor_set.clear();
<a name="l00477"></a>00477   neighbor_set.insert(<span class="keyword">this</span>);
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size;
<a name="l00480"></a>00480   <span class="keywordflow">do</span>
<a name="l00481"></a>00481     {
<a name="l00482"></a>00482       old_size = neighbor_set.size();
<a name="l00483"></a>00483 
<a name="l00484"></a>00484       <span class="comment">// Loop over all the elements in the patch</span>
<a name="l00485"></a>00485       std::set&lt;const Elem*&gt;::const_iterator       it  = neighbor_set.begin();
<a name="l00486"></a>00486       <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = neighbor_set.end();
<a name="l00487"></a>00487 
<a name="l00488"></a>00488       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00489"></a>00489         {
<a name="l00490"></a>00490           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00491"></a>00491 
<a name="l00492"></a>00492           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00493"></a>00493             {
<a name="l00494"></a>00494               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00495"></a>00495               <span class="keywordflow">if</span> (neighbor &amp;&amp;
<a name="l00496"></a>00496                   neighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)    <span class="comment">// we have a real neighbor on this side</span>
<a name="l00497"></a>00497                 {
<a name="l00498"></a>00498                   <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())                <span class="comment">// ... if it is active</span>
<a name="l00499"></a>00499                     {
<a name="l00500"></a>00500                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a9eb4aede10696470eb619cf0ccbc6c04">contains_vertex_of</a>(neighbor) <span class="comment">// ... and touches us</span>
<a name="l00501"></a>00501                           || neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a9eb4aede10696470eb619cf0ccbc6c04">contains_vertex_of</a>(<span class="keyword">this</span>))  
<a name="l00502"></a>00502                         neighbor_set.insert (neighbor);  <span class="comment">// ... then add it</span>
<a name="l00503"></a>00503                     }
<a name="l00504"></a>00504 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00505"></a>00505 <span class="preprocessor"></span>                  <span class="keywordflow">else</span>                                 <span class="comment">// ... the neighbor is *not* active,</span>
<a name="l00506"></a>00506                     {                                  <span class="comment">// ... so add *all* neighboring</span>
<a name="l00507"></a>00507                                                        <span class="comment">// active children</span>
<a name="l00508"></a>00508                       std::vector&lt;const Elem*&gt; active_neighbor_children;
<a name="l00509"></a>00509   
<a name="l00510"></a>00510                       neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a>
<a name="l00511"></a>00511                         (active_neighbor_children, elem);
<a name="l00512"></a>00512 
<a name="l00513"></a>00513                       std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00514"></a>00514                         child_it = active_neighbor_children.begin();
<a name="l00515"></a>00515                       <span class="keyword">const</span> std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00516"></a>00516                         child_end = active_neighbor_children.end();
<a name="l00517"></a>00517                       <span class="keywordflow">for</span> (; child_it != child_end; ++child_it)
<a name="l00518"></a>00518                         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a9eb4aede10696470eb619cf0ccbc6c04">contains_vertex_of</a>(*child_it) ||
<a name="l00519"></a>00519                             (*child_it)-&gt;contains_vertex_of(<span class="keyword">this</span>))
<a name="l00520"></a>00520                           neighbor_set.insert (*child_it);
<a name="l00521"></a>00521                     }
<a name="l00522"></a>00522 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00523"></a>00523 <span class="preprocessor"></span>                }
<a name="l00524"></a>00524             }
<a name="l00525"></a>00525         }
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527   <span class="keywordflow">while</span> (old_size != neighbor_set.size());
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a><a class="code" href="classlibMesh_1_1Elem.php#a673c008a4c1d4ddf3671b55f3ff1829a">00532</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a673c008a4c1d4ddf3671b55f3ff1829a">Elem::find_edge_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set)<span class="keyword"> const</span>
<a name="l00533"></a>00533 <span class="keyword"></span>{
<a name="l00534"></a>00534   neighbor_set.clear();
<a name="l00535"></a>00535   neighbor_set.insert(<span class="keyword">this</span>);
<a name="l00536"></a>00536 
<a name="l00537"></a>00537   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size;
<a name="l00538"></a>00538   <span class="keywordflow">do</span>
<a name="l00539"></a>00539     {
<a name="l00540"></a>00540       old_size = neighbor_set.size();
<a name="l00541"></a>00541 
<a name="l00542"></a>00542       <span class="comment">// Loop over all the elements in the patch</span>
<a name="l00543"></a>00543       std::set&lt;const Elem*&gt;::const_iterator       it  = neighbor_set.begin();
<a name="l00544"></a>00544       <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = neighbor_set.end();
<a name="l00545"></a>00545 
<a name="l00546"></a>00546       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00547"></a>00547         {
<a name="l00548"></a>00548           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00551"></a>00551             {
<a name="l00552"></a>00552               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00553"></a>00553               <span class="keywordflow">if</span> (neighbor &amp;&amp;
<a name="l00554"></a>00554                   neighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)    <span class="comment">// we have a real neighbor on this side</span>
<a name="l00555"></a>00555                 {
<a name="l00556"></a>00556                   <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())                <span class="comment">// ... if it is active</span>
<a name="l00557"></a>00557                     {
<a name="l00558"></a>00558                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a65c90c62886121e4ff7b33f7acf48843">contains_edge_of</a>(neighbor) <span class="comment">// ... and touches us</span>
<a name="l00559"></a>00559                           || neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a65c90c62886121e4ff7b33f7acf48843">contains_edge_of</a>(<span class="keyword">this</span>))  
<a name="l00560"></a>00560                         neighbor_set.insert (neighbor);  <span class="comment">// ... then add it</span>
<a name="l00561"></a>00561                     }
<a name="l00562"></a>00562 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00563"></a>00563 <span class="preprocessor"></span>                  <span class="keywordflow">else</span>                                 <span class="comment">// ... the neighbor is *not* active,</span>
<a name="l00564"></a>00564                     {                                  <span class="comment">// ... so add *all* neighboring</span>
<a name="l00565"></a>00565                                                        <span class="comment">// active children</span>
<a name="l00566"></a>00566                       std::vector&lt;const Elem*&gt; active_neighbor_children;
<a name="l00567"></a>00567   
<a name="l00568"></a>00568                       neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a>
<a name="l00569"></a>00569                         (active_neighbor_children, elem);
<a name="l00570"></a>00570 
<a name="l00571"></a>00571                       std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00572"></a>00572                         child_it = active_neighbor_children.begin();
<a name="l00573"></a>00573                       <span class="keyword">const</span> std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00574"></a>00574                         child_end = active_neighbor_children.end();
<a name="l00575"></a>00575                       <span class="keywordflow">for</span> (; child_it != child_end; ++child_it)
<a name="l00576"></a>00576                         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a65c90c62886121e4ff7b33f7acf48843">contains_edge_of</a>(*child_it) ||
<a name="l00577"></a>00577                             (*child_it)-&gt;contains_edge_of(<span class="keyword">this</span>))
<a name="l00578"></a>00578                           neighbor_set.insert (*child_it);
<a name="l00579"></a>00579                     }
<a name="l00580"></a>00580 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00581"></a>00581 <span class="preprocessor"></span>                }
<a name="l00582"></a>00582             }
<a name="l00583"></a>00583         }
<a name="l00584"></a>00584     }
<a name="l00585"></a>00585   <span class="keywordflow">while</span> (old_size != neighbor_set.size());
<a name="l00586"></a>00586 }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>
<a name="l00590"></a><a class="code" href="classlibMesh_1_1Elem.php#a4a0000dc4a95551cf712a89fc7093f65">00590</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a4a0000dc4a95551cf712a89fc7093f65">Elem::topological_neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00591"></a>00591                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00592"></a>00592                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; point_locator,
<a name="l00593"></a>00593                                   <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> * pb)<span class="keyword"> const</span>
<a name="l00594"></a>00594 <span class="keyword"></span>{
<a name="l00595"></a>00595   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a> = <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a>[i];
<a name="l00598"></a>00598   <span class="keywordflow">if</span> (neighbor != NULL)
<a name="l00599"></a>00599     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>;
<a name="l00600"></a>00600   
<a name="l00601"></a>00601   <span class="keywordflow">if</span> (pb)
<a name="l00602"></a>00602   {  
<a name="l00603"></a>00603     <span class="comment">// Since the neighbor is NULL it must be on a boundary. We need</span>
<a name="l00604"></a>00604     <span class="comment">// see if this is a periodic boundary in which case it will have a</span>
<a name="l00605"></a>00605     <span class="comment">// topological neighbor</span>
<a name="l00606"></a>00606 
<a name="l00607"></a>00607     std::vector&lt;short int&gt; boundary_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(<span class="keyword">this</span>, i);
<a name="l00608"></a>00608     <span class="keywordflow">for</span> (std::vector&lt;short int&gt;::iterator j = boundary_ids.begin(); j != boundary_ids.end(); ++j)
<a name="l00609"></a>00609       <span class="keywordflow">if</span> (pb-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">boundary</a>(*j))
<a name="l00610"></a>00610       {
<a name="l00611"></a>00611         <span class="comment">// Since the point locator inside of periodic boundaries</span>
<a name="l00612"></a>00612         <span class="comment">// returns a const pointer we will retrieve the proper</span>
<a name="l00613"></a>00613         <span class="comment">// pointer directly from the mesh object.  Also since coarse</span>
<a name="l00614"></a>00614         <span class="comment">// elements do not have more refined neighbors we need to make</span>
<a name="l00615"></a>00615         <span class="comment">// sure that we don&#39;t return one of these types of neighbors.</span>
<a name="l00616"></a>00616         neighbor = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(pb-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a06b6e333d6a0ffaee9252b703dfefede">neighbor</a>(*j, point_locator, <span class="keyword">this</span>, i)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00617"></a>00617         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>())
<a name="l00618"></a>00618           neighbor = neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00619"></a>00619         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>; 
<a name="l00620"></a>00620       }
<a name="l00621"></a>00621   }
<a name="l00622"></a>00622   
<a name="l00623"></a>00623   <span class="keywordflow">return</span> NULL;
<a name="l00624"></a>00624 }
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a><a class="code" href="classlibMesh_1_1Elem.php#a5924562ce5ef72ddf2da1c796376b188">00627</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a5924562ce5ef72ddf2da1c796376b188">Elem::has_topological_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00628"></a>00628                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00629"></a>00629                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; point_locator,
<a name="l00630"></a>00630                                      <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> * pb)<span class="keyword"> const</span>
<a name="l00631"></a>00631 <span class="keyword"></span>{
<a name="l00632"></a>00632   <span class="comment">// First see if this is a normal &quot;interior&quot; neighbor</span>
<a name="l00633"></a>00633   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(elem))
<a name="l00634"></a>00634     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00635"></a>00635 
<a name="l00636"></a>00636   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l00637"></a>00637     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4a0000dc4a95551cf712a89fc7093f65">topological_neighbor</a>(n, mesh, point_locator, pb))
<a name="l00638"></a>00638       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00641"></a>00641 }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 <span class="preprocessor">#endif</span>
<a name="l00645"></a>00645 <span class="preprocessor"></span>
<a name="l00646"></a>00646 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00647"></a>00647 <span class="preprocessor"></span>
<a name="l00648"></a><a class="code" href="classlibMesh_1_1Elem.php#a6a2e745d84e1846b7456137051fe94b3">00648</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a6a2e745d84e1846b7456137051fe94b3">Elem::libmesh_assert_valid_node_pointers</a>()<span class="keyword"> const</span>
<a name="l00649"></a>00649 <span class="keyword"></span>{
<a name="l00650"></a>00650   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>());
<a name="l00651"></a>00651   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00652"></a>00652     {
<a name="l00653"></a>00653       libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n));
<a name="l00654"></a>00654       libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>());
<a name="l00655"></a>00655     }
<a name="l00656"></a>00656 }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a><a class="code" href="classlibMesh_1_1Elem.php#ae15bea57cf5f41dbb2bdc680c6921200">00660</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ae15bea57cf5f41dbb2bdc680c6921200">Elem::libmesh_assert_valid_neighbors</a>()<span class="keyword"> const</span>
<a name="l00661"></a>00661 <span class="keyword"></span>{
<a name="l00662"></a>00662   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l00663"></a>00663     {
<a name="l00664"></a>00664       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neigh = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00665"></a>00665 
<a name="l00666"></a>00666       <span class="comment">// Any element might have a remote neighbor; checking</span>
<a name="l00667"></a>00667       <span class="comment">// to make sure that&#39;s not inaccurate is tough.</span>
<a name="l00668"></a>00668       <span class="keywordflow">if</span> (neigh == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00669"></a>00669         <span class="keywordflow">continue</span>;
<a name="l00670"></a>00670 
<a name="l00671"></a>00671       <span class="keywordflow">if</span> (neigh)
<a name="l00672"></a>00672         {
<a name="l00673"></a>00673           <span class="comment">// Only subactive elements have subactive neighbors</span>
<a name="l00674"></a>00674           libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>() || !neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l00675"></a>00675 
<a name="l00676"></a>00676           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = <span class="keyword">this</span>;
<a name="l00677"></a>00677 
<a name="l00678"></a>00678           <span class="comment">// If we&#39;re subactive but our neighbor isn&#39;t, its</span>
<a name="l00679"></a>00679           <span class="comment">// return neighbor link will be to our first active</span>
<a name="l00680"></a>00680           <span class="comment">// ancestor OR to our inactive ancestor of the same</span>
<a name="l00681"></a>00681           <span class="comment">// level as neigh, </span>
<a name="l00682"></a>00682           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>() &amp;&amp; !neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00683"></a>00683             {
<a name="l00684"></a>00684               <span class="keywordflow">for</span> (elem = <span class="keyword">this</span>; !elem-&gt;active();
<a name="l00685"></a>00685                    elem = elem-&gt;parent())
<a name="l00686"></a>00686                 libmesh_assert(elem);
<a name="l00687"></a>00687             }
<a name="l00688"></a>00688 
<a name="l00689"></a>00689           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rev = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(elem);
<a name="l00690"></a>00690           libmesh_assert (rev &lt; neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l00691"></a>00691 
<a name="l00692"></a>00692           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>() &amp;&amp; !neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00693"></a>00693             {
<a name="l00694"></a>00694               <span class="keywordflow">while</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(rev) != elem)
<a name="l00695"></a>00695                 {
<a name="l00696"></a>00696                   libmesh_assert(elem-&gt;parent());
<a name="l00697"></a>00697                   elem = elem-&gt;parent();
<a name="l00698"></a>00698                 }
<a name="l00699"></a>00699             }
<a name="l00700"></a>00700           <span class="keywordflow">else</span>
<a name="l00701"></a>00701             {
<a name="l00702"></a>00702               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *nn = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(rev);
<a name="l00703"></a>00703               libmesh_assert(nn);
<a name="l00704"></a>00704 
<a name="l00705"></a>00705               <span class="keywordflow">for</span> (; elem != nn; elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l00706"></a>00706                 libmesh_assert(elem);
<a name="l00707"></a>00707             }
<a name="l00708"></a>00708         }
<a name="l00709"></a>00709       <span class="comment">// If we don&#39;t have a neighbor, our ancestors shouldn&#39;t have any</span>
<a name="l00710"></a>00710       <span class="comment">// neighbors in this same direction.</span>
<a name="l00711"></a>00711       <span class="keywordflow">else</span>
<a name="l00712"></a>00712         {
<a name="l00713"></a>00713           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00714"></a>00714           <span class="keywordflow">if</span> (parent &amp;&amp;
<a name="l00715"></a>00715           <span class="comment">// A parent with a different dimension isn&#39;t really one of</span>
<a name="l00716"></a>00716           <span class="comment">// our ancestors, it means we&#39;re on a boundary mesh and this</span>
<a name="l00717"></a>00717           <span class="comment">// is an interior mesh element for which we&#39;re on a side.</span>
<a name="l00718"></a>00718           <span class="comment">// Nothing to test for in that case.</span>
<a name="l00719"></a>00719               (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>() == this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>()))
<a name="l00720"></a>00720             libmesh_assert (!parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s));
<a name="l00721"></a>00721         }
<a name="l00722"></a>00722     }
<a name="l00723"></a>00723 }
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00726"></a>00726 <span class="preprocessor"></span>
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00729"></a><a class="code" href="classlibMesh_1_1Elem.php#a975ab6f3e93964a1c30821c3a97baecb">00729</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a975ab6f3e93964a1c30821c3a97baecb">Elem::make_links_to_me_remote</a>()
<a name="l00730"></a>00730 {
<a name="l00731"></a>00731   libmesh_assert (<span class="keyword">this</span> != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00732"></a>00732 
<a name="l00733"></a>00733   <span class="comment">// We need to have handled any children first</span>
<a name="l00734"></a>00734 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) &amp;&amp; defined(DEBUG)</span>
<a name="l00735"></a>00735 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l00736"></a>00736     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c = 0; c != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00737"></a>00737       {
<a name="l00738"></a>00738         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00739"></a>00739         libmesh_assert (child == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00740"></a>00740       }
<a name="l00741"></a>00741 <span class="preprocessor">#endif</span>
<a name="l00742"></a>00742 <span class="preprocessor"></span>
<a name="l00743"></a>00743   <span class="comment">// Remotify any neighbor links</span>
<a name="l00744"></a>00744   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s = 0; s != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); ++s)
<a name="l00745"></a>00745     {
<a name="l00746"></a>00746       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neigh = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00747"></a>00747       <span class="keywordflow">if</span> (neigh &amp;&amp; neigh != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00748"></a>00748         {
<a name="l00749"></a>00749           <span class="comment">// My neighbor should never be more refined than me; my real</span>
<a name="l00750"></a>00750           <span class="comment">// neighbor would have been its parent in that case.</span>
<a name="l00751"></a>00751           libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &gt;= neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>());
<a name="l00752"></a>00752           
<a name="l00753"></a>00753           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &amp;&amp;
<a name="l00754"></a>00754               neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(<span class="keyword">this</span>))
<a name="l00755"></a>00755             {
<a name="l00756"></a>00756 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00757"></a>00757 <span class="preprocessor"></span>              <span class="comment">// My neighbor may have descendants which also consider me a</span>
<a name="l00758"></a>00758               <span class="comment">// neighbor</span>
<a name="l00759"></a>00759               std::vector&lt;const Elem*&gt; family;
<a name="l00760"></a>00760               neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#afc76f1733c9adbe6181f225cc740a7a7">family_tree_by_neighbor</a> (family, <span class="keyword">this</span>);
<a name="l00761"></a>00761 
<a name="l00762"></a>00762               <span class="comment">// FIXME - There&#39;s a lot of ugly const_casts here; we</span>
<a name="l00763"></a>00763               <span class="comment">// may want to make remote_elem non-const and create</span>
<a name="l00764"></a>00764               <span class="comment">// non-const versions of the family_tree methods</span>
<a name="l00765"></a>00765               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != family.size(); ++i)
<a name="l00766"></a>00766                 {
<a name="l00767"></a>00767                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *n = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*<span class="keyword">&gt;</span>(family[i]);
<a name="l00768"></a>00768                   libmesh_assert (n);
<a name="l00769"></a>00769                   <span class="keywordflow">if</span> (n == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00770"></a>00770                     <span class="keywordflow">continue</span>;
<a name="l00771"></a>00771                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_s = n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l00772"></a>00772                   libmesh_assert (my_s &lt; n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l00773"></a>00773                   libmesh_assert (n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(my_s) == <span class="keyword">this</span>);
<a name="l00774"></a>00774                   n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(my_s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>));
<a name="l00775"></a>00775                 }
<a name="l00776"></a>00776 <span class="preprocessor">#else</span>
<a name="l00777"></a>00777 <span class="preprocessor"></span>              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_s = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l00778"></a>00778               libmesh_assert (my_s &lt; neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l00779"></a>00779               libmesh_assert (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(my_s) == <span class="keyword">this</span>);
<a name="l00780"></a>00780               neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(my_s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>));
<a name="l00781"></a>00781 <span class="preprocessor">#endif</span>
<a name="l00782"></a>00782 <span class="preprocessor"></span>            }
<a name="l00783"></a>00783 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00784"></a>00784 <span class="preprocessor"></span>          <span class="comment">// Even if my neighbor doesn&#39;t link back to me, it might</span>
<a name="l00785"></a>00785           <span class="comment">// have subactive descendants which do</span>
<a name="l00786"></a>00786           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l00787"></a>00787             {
<a name="l00788"></a>00788               <span class="comment">// If my neighbor at the same level doesn&#39;t have me as a</span>
<a name="l00789"></a>00789               <span class="comment">// neighbor, I must be subactive</span>
<a name="l00790"></a>00790               libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &gt; neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() ||
<a name="l00791"></a>00791                              this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l00792"></a>00792 
<a name="l00793"></a>00793               <span class="comment">// My neighbor must have some ancestor of mine as a</span>
<a name="l00794"></a>00794               <span class="comment">// neighbor</span>
<a name="l00795"></a>00795               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00796"></a>00796               libmesh_assert(ancestor);
<a name="l00797"></a>00797               <span class="keywordflow">while</span> (!neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(ancestor))
<a name="l00798"></a>00798                 {
<a name="l00799"></a>00799                   ancestor = ancestor-&gt;parent();
<a name="l00800"></a>00800                   libmesh_assert(ancestor);
<a name="l00801"></a>00801                 }
<a name="l00802"></a>00802 
<a name="l00803"></a>00803               <span class="comment">// My neighbor may have descendants which consider me a</span>
<a name="l00804"></a>00804               <span class="comment">// neighbor</span>
<a name="l00805"></a>00805               std::vector&lt;const Elem*&gt; family;
<a name="l00806"></a>00806               neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4072ab635a948802d7ed49a8202221f0">family_tree_by_subneighbor</a> (family, ancestor, <span class="keyword">this</span>);
<a name="l00807"></a>00807 
<a name="l00808"></a>00808               <span class="comment">// FIXME - There&#39;s a lot of ugly const_casts here; we</span>
<a name="l00809"></a>00809               <span class="comment">// may want to make remote_elem non-const and create</span>
<a name="l00810"></a>00810               <span class="comment">// non-const versions of the family_tree methods</span>
<a name="l00811"></a>00811               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != family.size(); ++i)
<a name="l00812"></a>00812                 {
<a name="l00813"></a>00813                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *n = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*<span class="keyword">&gt;</span>(family[i]);
<a name="l00814"></a>00814                   libmesh_assert (n);
<a name="l00815"></a>00815                   <span class="keywordflow">if</span> (n == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00816"></a>00816                     <span class="keywordflow">continue</span>;
<a name="l00817"></a>00817                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_s = n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l00818"></a>00818                   libmesh_assert (my_s &lt; n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l00819"></a>00819                   libmesh_assert (n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(my_s) == <span class="keyword">this</span>);
<a name="l00820"></a>00820                   n-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(my_s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>));
<a name="l00821"></a>00821                 }
<a name="l00822"></a>00822             }
<a name="l00823"></a>00823 <span class="preprocessor">#endif</span>
<a name="l00824"></a>00824 <span class="preprocessor"></span>        }
<a name="l00825"></a>00825     }
<a name="l00826"></a>00826 
<a name="l00827"></a>00827 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00828"></a>00828 <span class="preprocessor"></span>  <span class="comment">// Remotify parent&#39;s child link</span>
<a name="l00829"></a>00829   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00830"></a>00830   <span class="keywordflow">if</span> (parent &amp;&amp; parent != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00831"></a>00831     {
<a name="l00832"></a>00832       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> me = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(<span class="keyword">this</span>);
<a name="l00833"></a>00833       libmesh_assert (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[me] == <span class="keyword">this</span>);
<a name="l00834"></a>00834       parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[me] = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1RemoteElem.php">RemoteElem</a>*<span class="keyword">&gt;</span>(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00835"></a>00835     }
<a name="l00836"></a>00836 <span class="preprocessor">#endif</span>
<a name="l00837"></a>00837 <span class="preprocessor"></span>}
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00840"></a>00840 
<a name="l00841"></a><a class="code" href="classlibMesh_1_1Elem.php#ab246c7ff89fc186970d92dcf8b78d481">00841</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab246c7ff89fc186970d92dcf8b78d481">Elem::write_connectivity</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>,
<a name="l00842"></a>00842                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop)<span class="keyword"> const</span>
<a name="l00843"></a>00843 <span class="keyword"></span>{
<a name="l00844"></a>00844   libmesh_assert (out.good());
<a name="l00845"></a>00845   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00846"></a>00846   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00847"></a>00847 
<a name="l00848"></a>00848   <span class="keywordflow">switch</span> (iop)
<a name="l00849"></a>00849     {
<a name="l00850"></a>00850     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00851"></a>00851       {
<a name="l00852"></a>00852         <span class="comment">// This connectivity vector will be used repeatedly instead</span>
<a name="l00853"></a>00853         <span class="comment">// of being reconstructed inside the loop.</span>
<a name="l00854"></a>00854         std::vector&lt;unsigned int&gt; conn;
<a name="l00855"></a>00855         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc=0; sc &lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a958eb1740332cf7a0ca291dc335f9a47">n_sub_elem</a>(); sc++)
<a name="l00856"></a>00856           {
<a name="l00857"></a>00857             this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#abbf1e39b13aa0ee2e41169274d5ec717">connectivity</a>(sc, <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>, conn);
<a name="l00858"></a>00858             
<a name="l00859"></a>00859             std::copy(conn.begin(),
<a name="l00860"></a>00860                       conn.end(),
<a name="l00861"></a>00861                       std::ostream_iterator&lt;unsigned int&gt;(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>, <span class="stringliteral">&quot; &quot;</span>));
<a name="l00862"></a>00862             
<a name="l00863"></a>00863             out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00864"></a>00864           }
<a name="l00865"></a>00865         <span class="keywordflow">return</span>;
<a name="l00866"></a>00866       }
<a name="l00867"></a>00867 
<a name="l00868"></a>00868     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa602f692ea59febe36c106d912a443d1">UCD</a>:
<a name="l00869"></a>00869       {
<a name="l00870"></a>00870         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); i++)
<a name="l00871"></a>00871           out &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(i)+1 &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00872"></a>00872         
<a name="l00873"></a>00873         out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00874"></a>00874         <span class="keywordflow">return</span>;
<a name="l00875"></a>00875       }
<a name="l00876"></a>00876 
<a name="l00877"></a>00877     <span class="keywordflow">default</span>:
<a name="l00878"></a>00878       libmesh_error();
<a name="l00879"></a>00879     }
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   libmesh_error();
<a name="l00882"></a>00882 }
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 
<a name="l00885"></a>00885 <span class="comment">// void Elem::write_tecplot_connectivity(std::ostream&amp; out) const</span>
<a name="l00886"></a>00886 <span class="comment">// {</span>
<a name="l00887"></a>00887 <span class="comment">//   libmesh_assert (!out.bad());</span>
<a name="l00888"></a>00888 <span class="comment">//   libmesh_assert (_nodes != NULL);</span>
<a name="l00889"></a>00889 
<a name="l00890"></a>00890 <span class="comment">//   // This connectivity vector will be used repeatedly instead</span>
<a name="l00891"></a>00891 <span class="comment">//   // of being reconstructed inside the loop.</span>
<a name="l00892"></a>00892 <span class="comment">//   std::vector&lt;unsigned int&gt; conn;</span>
<a name="l00893"></a>00893 <span class="comment">//   for (unsigned int sc=0; sc &lt;this-&gt;n_sub_elem(); sc++)</span>
<a name="l00894"></a>00894 <span class="comment">//     {</span>
<a name="l00895"></a>00895 <span class="comment">//       this-&gt;connectivity(sc, TECPLOT, conn);</span>
<a name="l00896"></a>00896       
<a name="l00897"></a>00897 <span class="comment">//       std::copy(conn.begin(),</span>
<a name="l00898"></a>00898 <span class="comment">//              conn.end(),</span>
<a name="l00899"></a>00899 <span class="comment">//              std::ostream_iterator&lt;unsigned int&gt;(out, &quot; &quot;));</span>
<a name="l00900"></a>00900       
<a name="l00901"></a>00901 <span class="comment">//       out &lt;&lt; std::endl;</span>
<a name="l00902"></a>00902 <span class="comment">//     }</span>
<a name="l00903"></a>00903 <span class="comment">// }</span>
<a name="l00904"></a>00904 
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 <span class="comment">// void Elem::write_ucd_connectivity(std::ostream &amp;out) const</span>
<a name="l00908"></a>00908 <span class="comment">// {</span>
<a name="l00909"></a>00909 <span class="comment">//   libmesh_assert (out);</span>
<a name="l00910"></a>00910 <span class="comment">//   libmesh_assert (_nodes != NULL);</span>
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 <span class="comment">//   for (unsigned int i=0; i&lt;this-&gt;n_nodes(); i++)</span>
<a name="l00913"></a>00913 <span class="comment">//     out &lt;&lt; this-&gt;node(i)+1 &lt;&lt; &quot;\t&quot;;</span>
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 <span class="comment">//   out &lt;&lt; std::endl;</span>
<a name="l00916"></a>00916 <span class="comment">// }</span>
<a name="l00917"></a>00917 
<a name="l00918"></a>00918 
<a name="l00919"></a>00919 
<a name="l00920"></a><a class="code" href="classlibMesh_1_1Elem.php#ac06d31c555b1d62e40f571a395b3bf6f">00920</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#ac06d31c555b1d62e40f571a395b3bf6f">Elem::quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00921"></a>00921 <span class="keyword"></span>{
<a name="l00922"></a>00922   <span class="keywordflow">switch</span> (q)
<a name="l00923"></a>00923     {    
<a name="l00927"></a>00927     <span class="keywordflow">default</span>:
<a name="l00928"></a>00928       {
<a name="l00929"></a>00929         libmesh_here();
<a name="l00930"></a>00930 
<a name="l00931"></a>00931         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  unknown quality metric: &quot;</span>
<a name="l00932"></a>00932                       &lt;&lt; q 
<a name="l00933"></a>00933                       &lt;&lt; std::endl
<a name="l00934"></a>00934                       &lt;&lt; <span class="stringliteral">&quot;Cowardly returning 1.&quot;</span>
<a name="l00935"></a>00935                       &lt;&lt; std::endl;
<a name="l00936"></a>00936 
<a name="l00937"></a>00937         <span class="keywordflow">return</span> 1.;
<a name="l00938"></a>00938       }
<a name="l00939"></a>00939     }
<a name="l00940"></a>00940 
<a name="l00941"></a>00941     
<a name="l00942"></a>00942     <span class="comment">// Will never get here...</span>
<a name="l00943"></a>00943     libmesh_error();
<a name="l00944"></a>00944     <span class="keywordflow">return</span> 0.;
<a name="l00945"></a>00945 }
<a name="l00946"></a>00946 
<a name="l00947"></a>00947 
<a name="l00948"></a>00948 
<a name="l00949"></a><a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">00949</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">Elem::ancestor</a>()<span class="keyword"> const</span>
<a name="l00950"></a>00950 <span class="keyword"></span>{
<a name="l00951"></a>00951 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00952"></a>00952 <span class="preprocessor"></span>
<a name="l00953"></a>00953   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00954"></a>00954     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00955"></a>00955 
<a name="l00956"></a>00956 <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l00957"></a>00957     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00958"></a>00958   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(0)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00959"></a>00959     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(0)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>();
<a name="l00962"></a>00962 <span class="preprocessor">#else</span>
<a name="l00963"></a>00963 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00964"></a>00964 <span class="preprocessor">#endif</span>
<a name="l00965"></a>00965 <span class="preprocessor"></span>}
<a name="l00966"></a>00966 
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 
<a name="l00969"></a>00969 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00970"></a>00970 <span class="preprocessor"></span>
<a name="l00971"></a><a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">00971</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">Elem::add_child</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00972"></a>00972 {
<a name="l00973"></a>00973   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> == NULL)
<a name="l00974"></a>00974     {
<a name="l00975"></a>00975       <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*[this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>()];
<a name="l00976"></a>00976       
<a name="l00977"></a>00977       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00978"></a>00978         <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] = NULL;
<a name="l00979"></a>00979     }
<a name="l00980"></a>00980   
<a name="l00981"></a>00981   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00982"></a>00982     {
<a name="l00983"></a>00983       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] == NULL || <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00984"></a>00984         {
<a name="l00985"></a>00985           libmesh_assert (<span class="keyword">this</span> == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>());
<a name="l00986"></a>00986           <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] = elem;
<a name="l00987"></a>00987           <span class="keywordflow">return</span>;
<a name="l00988"></a>00988         }
<a name="l00989"></a>00989     }
<a name="l00990"></a>00990 
<a name="l00991"></a>00991   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Tried to add a child to an element with full children array&quot;</span>
<a name="l00992"></a>00992                 &lt;&lt; std::endl;
<a name="l00993"></a>00993   libmesh_error();
<a name="l00994"></a>00994 }
<a name="l00995"></a>00995 
<a name="l00996"></a>00996 
<a name="l00997"></a>00997 
<a name="l00998"></a><a class="code" href="classlibMesh_1_1Elem.php#a6b4fc7d1953dda2ebb33d3657155b059">00998</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">Elem::add_child</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)
<a name="l00999"></a>00999 {
<a name="l01000"></a>01000   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> == NULL)
<a name="l01001"></a>01001     {
<a name="l01002"></a>01002       <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*[this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>()];
<a name="l01003"></a>01003       
<a name="l01004"></a>01004       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); i++)
<a name="l01005"></a>01005         <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[i] = NULL;
<a name="l01006"></a>01006     }
<a name="l01007"></a>01007   
<a name="l01008"></a>01008   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] == NULL || <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l01009"></a>01009   libmesh_assert (elem == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> || <span class="keyword">this</span> == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>());
<a name="l01010"></a>01010 
<a name="l01011"></a>01011   <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] = elem;
<a name="l01012"></a>01012 }
<a name="l01013"></a>01013 
<a name="l01014"></a>01014 
<a name="l01015"></a>01015 
<a name="l01016"></a><a class="code" href="classlibMesh_1_1Elem.php#ab1678542219d439b71a02beb477e94ce">01016</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab1678542219d439b71a02beb477e94ce">Elem::replace_child</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)
<a name="l01017"></a>01017 {
<a name="l01018"></a>01018   libmesh_assert(<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> != NULL);
<a name="l01019"></a>01019   
<a name="l01020"></a>01020   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] != NULL);
<a name="l01021"></a>01021 
<a name="l01022"></a>01022   <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] = elem;
<a name="l01023"></a>01023 }
<a name="l01024"></a>01024 
<a name="l01025"></a>01025 
<a name="l01026"></a>01026 
<a name="l01027"></a><a class="code" href="classlibMesh_1_1Elem.php#abbc77b3dfdf119b294cdfd0e5f15075a">01027</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#abbc77b3dfdf119b294cdfd0e5f15075a">Elem::is_child_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l01028"></a>01028                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l01029"></a>01029 <span class="keyword"></span>{
<a name="l01030"></a>01030   libmesh_assert (c &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>());
<a name="l01031"></a>01031   libmesh_assert (e &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adde1fccc9a1fc4b43485629cb6c4062b">n_edges</a>());
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> my_edge = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2b0590037d655ea1b3f325137fe142e7">build_edge</a>(e);
<a name="l01034"></a>01034   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> child_edge = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2b0590037d655ea1b3f325137fe142e7">build_edge</a>(e);
<a name="l01035"></a>01035 
<a name="l01036"></a>01036   <span class="comment">// We&#39;re assuming that an overlapping child edge has the same</span>
<a name="l01037"></a>01037   <span class="comment">// number and orientation as its parent</span>
<a name="l01038"></a>01038   <span class="keywordflow">return</span> (child_edge-&gt;node(0) == my_edge-&gt;node(0) ||
<a name="l01039"></a>01039       child_edge-&gt;node(1) == my_edge-&gt;node(1));
<a name="l01040"></a>01040 }
<a name="l01041"></a>01041 
<a name="l01042"></a>01042 
<a name="l01043"></a><a class="code" href="classlibMesh_1_1Elem.php#ad1d76a56b53265428558d0851f1ae09b">01043</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ad1d76a56b53265428558d0851f1ae09b">Elem::family_tree</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01044"></a>01044                         <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01045"></a>01045 <span class="keyword"></span>{
<a name="l01046"></a>01046   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01047"></a>01047   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01048"></a>01048 
<a name="l01049"></a>01049   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01050"></a>01050   <span class="keywordflow">if</span> (reset)
<a name="l01051"></a>01051     family.clear();
<a name="l01052"></a>01052 
<a name="l01053"></a>01053   <span class="comment">// Add this element to the family tree.</span>
<a name="l01054"></a>01054   family.push_back(<span class="keyword">this</span>);
<a name="l01055"></a>01055 
<a name="l01056"></a>01056   <span class="comment">// Recurse into the elements children, if it has them.</span>
<a name="l01057"></a>01057   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01058"></a>01058   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01059"></a>01059     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01060"></a>01060       <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a72a89396d5712c7541be0788d159403c">is_remote</a>())
<a name="l01061"></a>01061         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1d76a56b53265428558d0851f1ae09b">family_tree</a> (family, <span class="keyword">false</span>);
<a name="l01062"></a>01062 }
<a name="l01063"></a>01063 
<a name="l01064"></a>01064 
<a name="l01065"></a>01065 
<a name="l01066"></a><a class="code" href="classlibMesh_1_1Elem.php#a115d93be0231e3c0bacf45a6a4f1804d">01066</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a115d93be0231e3c0bacf45a6a4f1804d">Elem::active_family_tree</a> (std::vector&lt;const Elem*&gt;&amp; active_family,
<a name="l01067"></a>01067                                <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01068"></a>01068 <span class="keyword"></span>{
<a name="l01069"></a>01069   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01070"></a>01070   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01071"></a>01071 
<a name="l01072"></a>01072   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01073"></a>01073   <span class="keywordflow">if</span> (reset)
<a name="l01074"></a>01074     active_family.clear();
<a name="l01075"></a>01075 
<a name="l01076"></a>01076   <span class="comment">// Add this element to the family tree if it is active</span>
<a name="l01077"></a>01077   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01078"></a>01078     active_family.push_back(<span class="keyword">this</span>);
<a name="l01079"></a>01079 
<a name="l01080"></a>01080   <span class="comment">// Otherwise recurse into the element&#39;s children.</span>
<a name="l01081"></a>01081   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01082"></a>01082   <span class="keywordflow">else</span> 
<a name="l01083"></a>01083     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01084"></a>01084       <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a72a89396d5712c7541be0788d159403c">is_remote</a>())
<a name="l01085"></a>01085         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a115d93be0231e3c0bacf45a6a4f1804d">active_family_tree</a> (active_family, <span class="keyword">false</span>);
<a name="l01086"></a>01086 }
<a name="l01087"></a>01087 
<a name="l01088"></a>01088 
<a name="l01089"></a>01089 
<a name="l01090"></a><a class="code" href="classlibMesh_1_1Elem.php#a48ad0203e34ad29efd04caab0ff2842f">01090</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a48ad0203e34ad29efd04caab0ff2842f">Elem::family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01091"></a>01091                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l01092"></a>01092                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword">  const</span>
<a name="l01093"></a>01093 <span class="keyword"></span>{
<a name="l01094"></a>01094   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01095"></a>01095   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01096"></a>01096 
<a name="l01097"></a>01097   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01098"></a>01098   <span class="keywordflow">if</span> (reset)
<a name="l01099"></a>01099     family.clear();
<a name="l01100"></a>01100 
<a name="l01101"></a>01101   libmesh_assert(s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>());
<a name="l01102"></a>01102 
<a name="l01103"></a>01103   <span class="comment">// Add this element to the family tree.</span>
<a name="l01104"></a>01104   family.push_back(<span class="keyword">this</span>);
<a name="l01105"></a>01105 
<a name="l01106"></a>01106   <span class="comment">// Recurse into the elements children, if it has them.</span>
<a name="l01107"></a>01107   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01108"></a>01108   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01109"></a>01109     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01110"></a>01110       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(c, s))
<a name="l01111"></a>01111         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a48ad0203e34ad29efd04caab0ff2842f">family_tree_by_side</a> (family, s, <span class="keyword">false</span>);
<a name="l01112"></a>01112 
<a name="l01113"></a>01113 }
<a name="l01114"></a>01114 
<a name="l01115"></a>01115 
<a name="l01116"></a>01116 
<a name="l01117"></a><a class="code" href="classlibMesh_1_1Elem.php#a45301bbc272e10e4cfafc0bb38ada072">01117</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a45301bbc272e10e4cfafc0bb38ada072">Elem::active_family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01118"></a>01118                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l01119"></a>01119                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01120"></a>01120 <span class="keyword"></span>{
<a name="l01121"></a>01121   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01122"></a>01122   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01123"></a>01123 
<a name="l01124"></a>01124   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01125"></a>01125   <span class="keywordflow">if</span> (reset)
<a name="l01126"></a>01126     family.clear();
<a name="l01127"></a>01127 
<a name="l01128"></a>01128   libmesh_assert(s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>());
<a name="l01129"></a>01129 
<a name="l01130"></a>01130   <span class="comment">// Add an active element to the family tree.</span>
<a name="l01131"></a>01131   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01132"></a>01132     family.push_back(<span class="keyword">this</span>);
<a name="l01133"></a>01133 
<a name="l01134"></a>01134   <span class="comment">// Or recurse into an ancestor element&#39;s children.</span>
<a name="l01135"></a>01135   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01136"></a>01136   <span class="keywordflow">else</span>
<a name="l01137"></a>01137     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01138"></a>01138       <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a72a89396d5712c7541be0788d159403c">is_remote</a>() &amp;&amp; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(c, s))
<a name="l01139"></a>01139         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a45301bbc272e10e4cfafc0bb38ada072">active_family_tree_by_side</a> (family, s, <span class="keyword">false</span>);
<a name="l01140"></a>01140 }
<a name="l01141"></a>01141 
<a name="l01142"></a>01142 
<a name="l01143"></a>01143 
<a name="l01144"></a><a class="code" href="classlibMesh_1_1Elem.php#afc76f1733c9adbe6181f225cc740a7a7">01144</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#afc76f1733c9adbe6181f225cc740a7a7">Elem::family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01145"></a>01145                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l01146"></a>01146                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01147"></a>01147 <span class="keyword"></span>{
<a name="l01148"></a>01148   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01149"></a>01149   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01150"></a>01150 
<a name="l01151"></a>01151   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01152"></a>01152   <span class="keywordflow">if</span> (reset)
<a name="l01153"></a>01153     family.clear();
<a name="l01154"></a>01154 
<a name="l01155"></a>01155   <span class="comment">// This only makes sense if we&#39;re already a neighbor</span>
<a name="l01156"></a>01156   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor));
<a name="l01157"></a>01157 
<a name="l01158"></a>01158   <span class="comment">// Add this element to the family tree.</span>
<a name="l01159"></a>01159   family.push_back(<span class="keyword">this</span>);
<a name="l01160"></a>01160 
<a name="l01161"></a>01161   <span class="comment">// Recurse into the elements children, if it&#39;s not active.</span>
<a name="l01162"></a>01162   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01163"></a>01163   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01164"></a>01164     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01165"></a>01165       {
<a name="l01166"></a>01166         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01167"></a>01167         <span class="keywordflow">if</span> (child != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> &amp;&amp; child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor))
<a name="l01168"></a>01168           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#afc76f1733c9adbe6181f225cc740a7a7">family_tree_by_neighbor</a> (family, neighbor, <span class="keyword">false</span>);
<a name="l01169"></a>01169       }
<a name="l01170"></a>01170 }
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 
<a name="l01174"></a><a class="code" href="classlibMesh_1_1Elem.php#a4072ab635a948802d7ed49a8202221f0">01174</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a4072ab635a948802d7ed49a8202221f0">Elem::family_tree_by_subneighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01175"></a>01175                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l01176"></a>01176                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* subneighbor,
<a name="l01177"></a>01177                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01178"></a>01178 <span class="keyword"></span>{
<a name="l01179"></a>01179   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01180"></a>01180   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01181"></a>01181 
<a name="l01182"></a>01182   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01183"></a>01183   <span class="keywordflow">if</span> (reset)
<a name="l01184"></a>01184     family.clear();
<a name="l01185"></a>01185 
<a name="l01186"></a>01186   <span class="comment">// To simplifly this function we need an existing neighbor</span>
<a name="l01187"></a>01187   libmesh_assert (neighbor);
<a name="l01188"></a>01188   libmesh_assert (neighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l01189"></a>01189   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor));
<a name="l01190"></a>01190 
<a name="l01191"></a>01191   <span class="comment">// This only makes sense if subneighbor descends from neighbor</span>
<a name="l01192"></a>01192   libmesh_assert (subneighbor);
<a name="l01193"></a>01193   libmesh_assert (subneighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l01194"></a>01194   libmesh_assert (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#addbdfc1f56b018ade858aa3161792366">is_ancestor_of</a>(subneighbor));
<a name="l01195"></a>01195 
<a name="l01196"></a>01196   <span class="comment">// Add this element to the family tree if applicable.</span>
<a name="l01197"></a>01197   <span class="keywordflow">if</span> (neighbor == subneighbor)
<a name="l01198"></a>01198     family.push_back(<span class="keyword">this</span>);
<a name="l01199"></a>01199 
<a name="l01200"></a>01200   <span class="comment">// Recurse into the elements children, if it&#39;s not active.</span>
<a name="l01201"></a>01201   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01202"></a>01202   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01203"></a>01203     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l01204"></a>01204       {
<a name="l01205"></a>01205         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01206"></a>01206         <span class="keywordflow">if</span> (child != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01207"></a>01207           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s != child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); ++s)
<a name="l01208"></a>01208             {
<a name="l01209"></a>01209               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child_neigh = child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l01210"></a>01210               <span class="keywordflow">if</span> (child_neigh &amp;&amp;
<a name="l01211"></a>01211                   (child_neigh == neighbor ||
<a name="l01212"></a>01212                    (child_neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() == neighbor &amp;&amp;
<a name="l01213"></a>01213                     child_neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#addbdfc1f56b018ade858aa3161792366">is_ancestor_of</a>(subneighbor))))
<a name="l01214"></a>01214                 child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4072ab635a948802d7ed49a8202221f0">family_tree_by_subneighbor</a> (family, child_neigh,
<a name="l01215"></a>01215                                                    subneighbor, <span class="keyword">false</span>);
<a name="l01216"></a>01216             }
<a name="l01217"></a>01217       }
<a name="l01218"></a>01218 }
<a name="l01219"></a>01219 
<a name="l01220"></a>01220 
<a name="l01221"></a>01221 
<a name="l01222"></a><a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">01222</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">Elem::active_family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01223"></a>01223                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l01224"></a>01224                                            <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01225"></a>01225 <span class="keyword"></span>{
<a name="l01226"></a>01226   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01227"></a>01227   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01228"></a>01228 
<a name="l01229"></a>01229   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01230"></a>01230   <span class="keywordflow">if</span> (reset)
<a name="l01231"></a>01231     family.clear();
<a name="l01232"></a>01232 
<a name="l01233"></a>01233   <span class="comment">// This only makes sense if we&#39;re already a neighbor</span>
<a name="l01234"></a>01234   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &gt;= neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>())
<a name="l01235"></a>01235     libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor));
<a name="l01236"></a>01236 
<a name="l01237"></a>01237   <span class="comment">// Add an active element to the family tree.</span>
<a name="l01238"></a>01238   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01239"></a>01239     family.push_back(<span class="keyword">this</span>);
<a name="l01240"></a>01240 
<a name="l01241"></a>01241   <span class="comment">// Or recurse into an ancestor element&#39;s children.</span>
<a name="l01242"></a>01242   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01243"></a>01243   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01244"></a>01244     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01245"></a>01245       {
<a name="l01246"></a>01246         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01247"></a>01247         <span class="keywordflow">if</span> (child != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> &amp;&amp; child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor))
<a name="l01248"></a>01248           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a> (family, neighbor, <span class="keyword">false</span>);
<a name="l01249"></a>01249       }
<a name="l01250"></a>01250 }
<a name="l01251"></a>01251 
<a name="l01252"></a>01252 
<a name="l01253"></a>01253 
<a name="l01254"></a><a class="code" href="classlibMesh_1_1Elem.php#aad83f9aaca6d0bcef2a5205abcc134a9">01254</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#aad83f9aaca6d0bcef2a5205abcc134a9">Elem::min_p_level_by_neighbor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l01255"></a>01255                                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min)<span class="keyword"> const</span>
<a name="l01256"></a>01256 <span class="keyword"></span>{
<a name="l01257"></a>01257   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01258"></a>01258   libmesh_assert(neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l01259"></a>01259 
<a name="l01260"></a>01260   <span class="comment">// If we&#39;re an active element this is simple</span>
<a name="l01261"></a>01261   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01262"></a>01262     <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(current_min, this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01263"></a>01263 
<a name="l01264"></a>01264   libmesh_assert(<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor));
<a name="l01265"></a>01265 
<a name="l01266"></a>01266   <span class="comment">// The p_level() of an ancestor element is already the minimum</span>
<a name="l01267"></a>01267   <span class="comment">// p_level() of its children - so if that&#39;s high enough, we don&#39;t</span>
<a name="l01268"></a>01268   <span class="comment">// need to examine any children.</span>
<a name="l01269"></a>01269   <span class="keywordflow">if</span> (current_min &lt;= this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>())
<a name="l01270"></a>01270     <span class="keywordflow">return</span> current_min;
<a name="l01271"></a>01271 
<a name="l01272"></a>01272   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level = current_min;
<a name="l01273"></a>01273 
<a name="l01274"></a>01274   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01275"></a>01275     {
<a name="l01276"></a>01276       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01277"></a>01277       <span class="keywordflow">if</span> (child != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a> &amp;&amp; child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor))
<a name="l01278"></a>01278         min_p_level =
<a name="l01279"></a>01279           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aad83f9aaca6d0bcef2a5205abcc134a9">min_p_level_by_neighbor</a>(neighbor,
<a name="l01280"></a>01280                                          min_p_level);
<a name="l01281"></a>01281     }
<a name="l01282"></a>01282 
<a name="l01283"></a>01283   <span class="keywordflow">return</span> min_p_level;
<a name="l01284"></a>01284 }
<a name="l01285"></a>01285 
<a name="l01286"></a>01286 
<a name="l01287"></a><a class="code" href="classlibMesh_1_1Elem.php#ae4ccfe379ed5d23c4ae165e095867c22">01287</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ae4ccfe379ed5d23c4ae165e095867c22">Elem::min_new_p_level_by_neighbor</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l01288"></a>01288                                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min)<span class="keyword"> const</span>
<a name="l01289"></a>01289 <span class="keyword"></span>{
<a name="l01290"></a>01290   libmesh_assert(!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01291"></a>01291   libmesh_assert(neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l01292"></a>01292 
<a name="l01293"></a>01293   <span class="comment">// If we&#39;re an active element this is simple</span>
<a name="l01294"></a>01294   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01295"></a>01295     {
<a name="l01296"></a>01296       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_p_level = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l01297"></a>01297       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l01298"></a>01298         new_p_level += 1;
<a name="l01299"></a>01299       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l01300"></a>01300         {
<a name="l01301"></a>01301           libmesh_assert (new_p_level &gt; 0);
<a name="l01302"></a>01302           new_p_level -= 1;
<a name="l01303"></a>01303         }
<a name="l01304"></a>01304       <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(current_min, new_p_level);
<a name="l01305"></a>01305     }
<a name="l01306"></a>01306 
<a name="l01307"></a>01307   libmesh_assert(<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor));
<a name="l01308"></a>01308 
<a name="l01309"></a>01309   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level = current_min;
<a name="l01310"></a>01310 
<a name="l01311"></a>01311   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01312"></a>01312     {
<a name="l01313"></a>01313       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01314"></a>01314       <span class="keywordflow">if</span> (child &amp;&amp; child != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01315"></a>01315         <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(neighbor))
<a name="l01316"></a>01316           min_p_level =
<a name="l01317"></a>01317             child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae4ccfe379ed5d23c4ae165e095867c22">min_new_p_level_by_neighbor</a>(neighbor,
<a name="l01318"></a>01318                                                min_p_level);
<a name="l01319"></a>01319     }
<a name="l01320"></a>01320 
<a name="l01321"></a>01321   <span class="keywordflow">return</span> min_p_level;
<a name="l01322"></a>01322 }
<a name="l01323"></a>01323 
<a name="l01324"></a>01324 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01325"></a>01325 <span class="preprocessor"></span>
<a name="l01326"></a>01326 
<a name="l01327"></a>01327 
<a name="l01328"></a><a class="code" href="classlibMesh_1_1Elem.php#afd665f3e6d13b0aaaf4c4620067329bc">01328</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#afd665f3e6d13b0aaaf4c4620067329bc">Elem::contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)<span class="keyword"> const</span>
<a name="l01329"></a>01329 <span class="keyword"></span>{
<a name="l01330"></a>01330   <span class="comment">// Declare a basic FEType.  Will ue a Lagrange</span>
<a name="l01331"></a>01331   <span class="comment">// element by default.</span>
<a name="l01332"></a>01332   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>());
<a name="l01333"></a>01333   
<a name="l01334"></a>01334   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> mapped_point = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>(),
<a name="l01335"></a>01335                                                       fe_type,
<a name="l01336"></a>01336                                                       <span class="keyword">this</span>,
<a name="l01337"></a>01337                                                       p,
<a name="l01338"></a>01338                                                       1.e-4,
<a name="l01339"></a>01339                                                       <span class="keyword">false</span>);
<a name="l01340"></a>01340 
<a name="l01341"></a>01341   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5ed1b078cb472a00bf1b4cdb5cf28be7">FEInterface::on_reference_element</a>(mapped_point, this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), tol);
<a name="l01342"></a>01342 }
<a name="l01343"></a>01343 
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 
<a name="l01346"></a><a class="code" href="classlibMesh_1_1Elem.php#a726879346cab41cf1056a9eed73e02b0">01346</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a726879346cab41cf1056a9eed73e02b0">Elem::nullify_neighbors</a> ()
<a name="l01347"></a>01347 {
<a name="l01348"></a>01348   <span class="comment">// Tell any of my neighbors about my death...</span>
<a name="l01349"></a>01349   <span class="comment">// Looks strange, huh?</span>
<a name="l01350"></a>01350   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l01351"></a>01351     {
<a name="l01352"></a>01352       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l01353"></a>01353       <span class="keywordflow">if</span> (neighbor &amp;&amp; neighbor != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l01354"></a>01354         {
<a name="l01355"></a>01355           <span class="comment">// Note:  it is possible that I see the neighbor</span>
<a name="l01356"></a>01356           <span class="comment">// (which is coarser than me)</span>
<a name="l01357"></a>01357           <span class="comment">// but they don&#39;t see me, so avoid that case.</span>
<a name="l01358"></a>01358           <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>())
<a name="l01359"></a>01359             {   
<a name="l01360"></a>01360               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> w_n_a_i = neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l01361"></a>01361               libmesh_assert (w_n_a_i &lt; neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l01362"></a>01362               neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(w_n_a_i, NULL);
<a name="l01363"></a>01363               this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(n, NULL);
<a name="l01364"></a>01364             }
<a name="l01365"></a>01365         }
<a name="l01366"></a>01366     }
<a name="l01367"></a>01367 }
<a name="l01368"></a>01368 
<a name="l01369"></a>01369 
<a name="l01370"></a>01370 
<a name="l01371"></a>01371 
<a name="l01372"></a><a class="code" href="classlibMesh_1_1Elem.php#a5175062272874a37befab4a16ce68eaf">01372</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a5175062272874a37befab4a16ce68eaf">Elem::n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l01373"></a>01373 <span class="keyword"></span>{
<a name="l01374"></a>01374   <span class="comment">// for linear elements, always return 0</span>
<a name="l01375"></a>01375   <span class="keywordflow">return</span> 0;
<a name="l01376"></a>01376 }
<a name="l01377"></a>01377 
<a name="l01378"></a>01378 
<a name="l01379"></a>01379 
<a name="l01380"></a><a class="code" href="classlibMesh_1_1Elem.php#a430e1bdb48a91b50f7d22c203de8129f">01380</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a430e1bdb48a91b50f7d22c203de8129f">Elem::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01381"></a>01381                                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l01382"></a>01382 <span class="keyword"></span>{
<a name="l01383"></a>01383   <span class="comment">// for linear elements, always return 0</span>
<a name="l01384"></a>01384   <span class="keywordflow">return</span> 0;
<a name="l01385"></a>01385 }
<a name="l01386"></a>01386 
<a name="l01387"></a>01387 
<a name="l01388"></a>01388 
<a name="l01389"></a>01389 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l01390"></a><a class="code" href="classlibMesh_1_1Elem.php#af476a143ee494ae754e812466ccbdff4">01390</a> <a class="code" href="classlibMesh_1_1Elem.php#af476a143ee494ae754e812466ccbdff4">Elem::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l01391"></a>01391 <span class="keyword"></span>{
<a name="l01392"></a>01392   <span class="comment">// for linear elements, always return 0</span>
<a name="l01393"></a>01393   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;(0,0);
<a name="l01394"></a>01394 }
<a name="l01395"></a>01395 
<a name="l01396"></a>01396 
<a name="l01397"></a>01397 
<a name="l01398"></a><a class="code" href="classlibMesh_1_1Elem.php#a6c2704fb0b2d715cb19bb2a4f517b0f3">01398</a> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem.php#a6c2704fb0b2d715cb19bb2a4f517b0f3">Elem::first_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et)
<a name="l01399"></a>01399 { 
<a name="l01400"></a>01400   <span class="keywordflow">switch</span> (et)
<a name="l01401"></a>01401     {
<a name="l01402"></a>01402     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01403"></a>01403     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01404"></a>01404     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l01405"></a>01405       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l01406"></a>01406     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01407"></a>01407     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01408"></a>01408       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l01409"></a>01409     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01410"></a>01410     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01411"></a>01411     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01412"></a>01412       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l01413"></a>01413     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01414"></a>01414     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01415"></a>01415       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>;
<a name="l01416"></a>01416     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01417"></a>01417     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01418"></a>01418     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01419"></a>01419       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>;
<a name="l01420"></a>01420     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01421"></a>01421     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l01422"></a>01422     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l01423"></a>01423       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>;
<a name="l01424"></a>01424 
<a name="l01425"></a>01425 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01426"></a>01426 <span class="preprocessor"></span>
<a name="l01427"></a>01427     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l01428"></a>01428     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l01429"></a>01429       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>;
<a name="l01430"></a>01430     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l01431"></a>01431     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l01432"></a>01432     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l01433"></a>01433       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>;
<a name="l01434"></a>01434     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l01435"></a>01435     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l01436"></a>01436       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>;
<a name="l01437"></a>01437 
<a name="l01438"></a>01438 <span class="preprocessor">#endif</span>
<a name="l01439"></a>01439 <span class="preprocessor"></span>
<a name="l01440"></a>01440     <span class="keywordflow">default</span>:
<a name="l01441"></a>01441       <span class="comment">// unknown element</span>
<a name="l01442"></a>01442       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01443"></a>01443     }
<a name="l01444"></a>01444 }
<a name="l01445"></a>01445 
<a name="l01446"></a>01446 
<a name="l01447"></a>01447 
<a name="l01448"></a><a class="code" href="classlibMesh_1_1Elem.php#a877984e054cff62d2205a2a6c57cde0a">01448</a> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem.php#a877984e054cff62d2205a2a6c57cde0a">Elem::second_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et,
<a name="l01449"></a>01449                                              <span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered)
<a name="l01450"></a>01450 { 
<a name="l01451"></a>01451   <span class="comment">/* for second-order elements, always return \p INVALID_ELEM</span>
<a name="l01452"></a>01452 <span class="comment">   * since second-order elements should not be converted</span>
<a name="l01453"></a>01453 <span class="comment">   * into something else.  Only linear elements should </span>
<a name="l01454"></a>01454 <span class="comment">   * return something sensible here</span>
<a name="l01455"></a>01455 <span class="comment">   */</span>
<a name="l01456"></a>01456   <span class="keywordflow">switch</span> (et)
<a name="l01457"></a>01457     {
<a name="l01458"></a>01458     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01459"></a>01459       {
<a name="l01460"></a>01460         <span class="comment">// full_ordered not relevant</span>
<a name="l01461"></a>01461         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>;
<a name="l01462"></a>01462       }
<a name="l01463"></a>01463 
<a name="l01464"></a>01464     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01465"></a>01465       {
<a name="l01466"></a>01466         <span class="comment">// full_ordered not relevant</span>
<a name="l01467"></a>01467         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>;
<a name="l01468"></a>01468       }
<a name="l01469"></a>01469 
<a name="l01470"></a>01470     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01471"></a>01471       {
<a name="l01472"></a>01472         <span class="keywordflow">if</span> (full_ordered)
<a name="l01473"></a>01473           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>;
<a name="l01474"></a>01474         <span class="keywordflow">else</span> 
<a name="l01475"></a>01475           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>;
<a name="l01476"></a>01476       }
<a name="l01477"></a>01477 
<a name="l01478"></a>01478     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01479"></a>01479       {
<a name="l01480"></a>01480         <span class="comment">// full_ordered not relevant</span>
<a name="l01481"></a>01481         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>;
<a name="l01482"></a>01482       }
<a name="l01483"></a>01483 
<a name="l01484"></a>01484     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01485"></a>01485       {
<a name="l01486"></a>01486         <span class="comment">// see below how this correlates with INFHEX8</span>
<a name="l01487"></a>01487         <span class="keywordflow">if</span> (full_ordered)
<a name="l01488"></a>01488           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>;
<a name="l01489"></a>01489         <span class="keywordflow">else</span> 
<a name="l01490"></a>01490           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>;
<a name="l01491"></a>01491       }
<a name="l01492"></a>01492 
<a name="l01493"></a>01493     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01494"></a>01494       {
<a name="l01495"></a>01495         <span class="keywordflow">if</span> (full_ordered)
<a name="l01496"></a>01496           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>;
<a name="l01497"></a>01497         <span class="keywordflow">else</span> 
<a name="l01498"></a>01498           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>;
<a name="l01499"></a>01499       }
<a name="l01500"></a>01500 
<a name="l01501"></a>01501     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l01502"></a>01502       {
<a name="l01503"></a>01503         <span class="comment">// libmesh_error(); </span>
<a name="l01504"></a>01504         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01505"></a>01505       }
<a name="l01506"></a>01506 
<a name="l01507"></a>01507 
<a name="l01508"></a>01508 
<a name="l01509"></a>01509 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01510"></a>01510 <span class="preprocessor"></span>
<a name="l01511"></a>01511     <span class="comment">// infinite elements</span>
<a name="l01512"></a>01512     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l01513"></a>01513       {
<a name="l01514"></a>01514         <span class="comment">// libmesh_error(); </span>
<a name="l01515"></a>01515         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01516"></a>01516       }
<a name="l01517"></a>01517 
<a name="l01518"></a>01518     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l01519"></a>01519       {
<a name="l01520"></a>01520         <span class="comment">// full_ordered not relevant</span>
<a name="l01521"></a>01521         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>;
<a name="l01522"></a>01522       }
<a name="l01523"></a>01523 
<a name="l01524"></a>01524     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l01525"></a>01525       {
<a name="l01526"></a>01526         <span class="comment">/*</span>
<a name="l01527"></a>01527 <span class="comment">         * Note that this matches with \p Hex8:</span>
<a name="l01528"></a>01528 <span class="comment">         * For full-ordered, \p InfHex18 and \p Hex27</span>
<a name="l01529"></a>01529 <span class="comment">         * belong together, and for not full-ordered,</span>
<a name="l01530"></a>01530 <span class="comment">         * \p InfHex16 and \p Hex20 belong together.</span>
<a name="l01531"></a>01531 <span class="comment">         */</span>
<a name="l01532"></a>01532         <span class="keywordflow">if</span> (full_ordered)
<a name="l01533"></a>01533           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>;
<a name="l01534"></a>01534         <span class="keywordflow">else</span> 
<a name="l01535"></a>01535           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>;
<a name="l01536"></a>01536       }
<a name="l01537"></a>01537 
<a name="l01538"></a>01538     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l01539"></a>01539       {
<a name="l01540"></a>01540         <span class="comment">// full_ordered not relevant</span>
<a name="l01541"></a>01541         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>;
<a name="l01542"></a>01542       }
<a name="l01543"></a>01543 
<a name="l01544"></a>01544 <span class="preprocessor">#endif</span>
<a name="l01545"></a>01545 <span class="preprocessor"></span>
<a name="l01546"></a>01546 
<a name="l01547"></a>01547     <span class="keywordflow">default</span>:
<a name="l01548"></a>01548       {
<a name="l01549"></a>01549         <span class="comment">// second-order element</span>
<a name="l01550"></a>01550         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01551"></a>01551       }
<a name="l01552"></a>01552     }
<a name="l01553"></a>01553 }
<a name="l01554"></a>01554 
<a name="l01555"></a>01555 
<a name="l01556"></a>01556 
<a name="l01557"></a><a class="code" href="classlibMesh_1_1Elem.php#a6fdb6e30c09302ca9914913dc68e36e7">01557</a> <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">Elem::side_iterator</a> <a class="code" href="classlibMesh_1_1Elem.php#a6fdb6e30c09302ca9914913dc68e36e7">Elem::boundary_sides_begin</a>()
<a name="l01558"></a>01558 {
<a name="l01559"></a>01559   <a class="code" href="structlibMesh_1_1Predicates_1_1BoundarySide.php">Predicates::BoundarySide&lt;SideIter&gt;</a> bsp;
<a name="l01560"></a>01560   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">side_iterator</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a579b6b2edb461eba4790658149c36b0a">_first_side</a>(), this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40fb5e7605af6abe9ebbffc47bb7f982">_last_side</a>(), bsp);
<a name="l01561"></a>01561 }
<a name="l01562"></a>01562 
<a name="l01563"></a>01563 
<a name="l01564"></a>01564 
<a name="l01565"></a>01565 
<a name="l01566"></a><a class="code" href="classlibMesh_1_1Elem.php#a6d3285f9a6e90878e2c849ec2c74a024">01566</a> <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">Elem::side_iterator</a> <a class="code" href="classlibMesh_1_1Elem.php#a6d3285f9a6e90878e2c849ec2c74a024">Elem::boundary_sides_end</a>()
<a name="l01567"></a>01567 {
<a name="l01568"></a>01568   <a class="code" href="structlibMesh_1_1Predicates_1_1BoundarySide.php">Predicates::BoundarySide&lt;SideIter&gt;</a> bsp;
<a name="l01569"></a>01569   <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">side_iterator</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40fb5e7605af6abe9ebbffc47bb7f982">_last_side</a>(), this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40fb5e7605af6abe9ebbffc47bb7f982">_last_side</a>(), bsp);
<a name="l01570"></a>01570 }
<a name="l01571"></a>01571 
<a name="l01572"></a>01572 
<a name="l01573"></a>01573 
<a name="l01574"></a>01574 
<a name="l01575"></a><a class="code" href="classlibMesh_1_1Elem.php#ac8bbe0a421dc8a27a34948ade9ba0e21">01575</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#ac8bbe0a421dc8a27a34948ade9ba0e21">Elem::volume</a> ()<span class="keyword"> const</span>
<a name="l01576"></a>01576 <span class="keyword"></span>{
<a name="l01577"></a>01577   <span class="comment">// The default implementation builds a finite element of the correct</span>
<a name="l01578"></a>01578   <span class="comment">// order and sums up the JxW contributions.  This can be expensive,</span>
<a name="l01579"></a>01579   <span class="comment">// so the various element types can overload this method and compute</span>
<a name="l01580"></a>01580   <span class="comment">// the volume more efficiently.</span>
<a name="l01581"></a>01581   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>() , <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l01582"></a>01582 
<a name="l01583"></a>01583   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>(),
<a name="l01584"></a>01584                                     fe_type));
<a name="l01585"></a>01585 
<a name="l01586"></a>01586    <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; JxW = fe-&gt;get_JxW();
<a name="l01587"></a>01587    
<a name="l01588"></a>01588   <span class="comment">// The default quadrature rule should integrate the mass matrix,</span>
<a name="l01589"></a>01589   <span class="comment">// thus it should be plenty to compute the area</span>
<a name="l01590"></a>01590   <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> qrule (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>(), fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a>());
<a name="l01591"></a>01591 
<a name="l01592"></a>01592   fe-&gt;attach_quadrature_rule(&amp;qrule);
<a name="l01593"></a>01593 
<a name="l01594"></a>01594   fe-&gt;reinit(<span class="keyword">this</span>);
<a name="l01595"></a>01595 
<a name="l01596"></a>01596   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> vol=0.;
<a name="l01597"></a>01597   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;qrule.n_points(); ++qp)
<a name="l01598"></a>01598     vol += JxW[qp];
<a name="l01599"></a>01599   
<a name="l01600"></a>01600   <span class="keywordflow">return</span> vol;
<a name="l01601"></a>01601   
<a name="l01602"></a>01602 }
<a name="l01603"></a>01603 
<a name="l01604"></a>01604 
<a name="l01605"></a>01605 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01606"></a>01606 <span class="comment">// Elem::PackedElem static data</span>
<a name="l01607"></a>01607 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> = 10;
<a name="l01608"></a>01608 
<a name="l01609"></a>01609 
<a name="l01610"></a>01610 <span class="comment">// Elem::PackedElem member funcions</span>
<a name="l01611"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">01611</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">Elem::PackedElem::pack</a> (std::vector&lt;int&gt; &amp;conn, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l01612"></a>01612 {
<a name="l01613"></a>01613   libmesh_assert (elem != NULL);
<a name="l01614"></a>01614   
<a name="l01615"></a>01615   <span class="comment">// we can do at least this good. note that hopefully in general</span>
<a name="l01616"></a>01616   <span class="comment">// the user will already have reserved the full space, which will render</span>
<a name="l01617"></a>01617   <span class="comment">// this redundant</span>
<a name="l01618"></a>01618   conn.reserve (conn.size() + <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01619"></a>01619 
<a name="l01620"></a>01620 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01621"></a>01621 <span class="preprocessor"></span>  conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()));
<a name="l01622"></a>01622   conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()));
<a name="l01623"></a>01623   conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()));
<a name="l01624"></a>01624   conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>()));
<a name="l01625"></a>01625 <span class="preprocessor">#else</span>
<a name="l01626"></a>01626 <span class="preprocessor"></span>  conn.push_back (0);
<a name="l01627"></a>01627   conn.push_back (0);
<a name="l01628"></a>01628   conn.push_back (0);
<a name="l01629"></a>01629   conn.push_back (0);
<a name="l01630"></a>01630 <span class="preprocessor">#endif</span>
<a name="l01631"></a>01631 <span class="preprocessor"></span>  conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()));
<a name="l01632"></a>01632   conn.push_back (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>());
<a name="l01633"></a>01633   conn.push_back (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>());
<a name="l01634"></a>01634   conn.push_back (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l01635"></a>01635                 
<a name="l01636"></a>01636 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01637"></a>01637 <span class="preprocessor"></span>  <span class="comment">// use parent_ID of -1 to indicate a level 0 element</span>
<a name="l01638"></a>01638   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0)
<a name="l01639"></a>01639     {
<a name="l01640"></a>01640       conn.push_back(-1);
<a name="l01641"></a>01641       conn.push_back(-1);
<a name="l01642"></a>01642     }
<a name="l01643"></a>01643   <span class="keywordflow">else</span>
<a name="l01644"></a>01644     {
<a name="l01645"></a>01645       conn.push_back(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l01646"></a>01646       conn.push_back(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(elem));
<a name="l01647"></a>01647     }
<a name="l01648"></a>01648 <span class="preprocessor">#else</span>
<a name="l01649"></a>01649 <span class="preprocessor"></span>  conn.push_back (-1);
<a name="l01650"></a>01650   conn.push_back (-1);
<a name="l01651"></a>01651 <span class="preprocessor">#endif</span>
<a name="l01652"></a>01652 <span class="preprocessor"></span>  
<a name="l01653"></a>01653   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l01654"></a>01654     conn.push_back (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));             
<a name="l01655"></a>01655 }
<a name="l01656"></a>01656 
<a name="l01657"></a>01657 
<a name="l01658"></a>01658 
<a name="l01659"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af61ecf6a8d276b513691e4dfa6a0fba0">01659</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af61ecf6a8d276b513691e4dfa6a0fba0">Elem::PackedElem::unpack</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>)<span class="keyword"> const</span>
<a name="l01660"></a>01660 <span class="keyword"></span>{  
<a name="l01661"></a>01661   
<a name="l01662"></a>01662   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),parent).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l01663"></a>01663   libmesh_assert (elem);
<a name="l01664"></a>01664 
<a name="l01665"></a>01665 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01666"></a>01666 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() != 0) 
<a name="l01667"></a>01667     {
<a name="l01668"></a>01668       libmesh_assert (parent != NULL);
<a name="l01669"></a>01669       parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">add_child</a>(elem, this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>());
<a name="l01670"></a>01670       libmesh_assert (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l01671"></a>01671       libmesh_assert (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(this-&gt;which_child_am_i()) == elem);
<a name="l01672"></a>01672     }
<a name="l01673"></a>01673 <span class="preprocessor">#endif</span>
<a name="l01674"></a>01674 <span class="preprocessor"></span>
<a name="l01675"></a>01675   <span class="comment">// Assign the IDs</span>
<a name="l01676"></a>01676 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01677"></a>01677 <span class="preprocessor"></span>  elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01678"></a>01678   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>());
<a name="l01679"></a>01679   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>());
<a name="l01680"></a>01680   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>());
<a name="l01681"></a>01681 <span class="preprocessor">#endif</span>
<a name="l01682"></a>01682 <span class="preprocessor"></span>  elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l01683"></a>01683   elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l01684"></a>01684   elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>()       = this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01685"></a>01685   
<a name="l01686"></a>01686   <span class="comment">// Assign the connectivity</span>
<a name="l01687"></a>01687   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01688"></a>01688 
<a name="l01689"></a>01689   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l01690"></a>01690     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(n) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));
<a name="l01691"></a>01691   
<a name="l01692"></a>01692   <span class="keywordflow">return</span> elem;
<a name="l01693"></a>01693 }
<a name="l01694"></a>01694 
<a name="l01695"></a>01695 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
