<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">elem.h</div>  </div>
</div>
<div class="contents">
<a href="elem_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem.h 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __elem_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __elem_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="dof__object_8h.php">dof_object.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="id__types_8h.php">id_types.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="node_8h.php">node.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__quality_8h.php">enum_elem_quality.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="enum__order_8h.php">enum_order.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="enum__io__package_8h.php">enum_io_package.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="multi__predicates_8h.php">multi_predicates.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="variant__filter__iterator_8h.php">variant_filter_iterator.h</a>&quot;</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">namespace </span>libMesh
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// Forward declarations</span>
<a name="l00048"></a>00048 <span class="keyword">class </span>MeshBase;
<a name="l00049"></a>00049 <span class="keyword">class </span>MeshRefinement;
<a name="l00050"></a>00050 <span class="keyword">class </span>Elem;
<a name="l00051"></a>00051 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="keyword">class </span>PeriodicBoundaries;
<a name="l00053"></a>00053 <span class="keyword">class </span>PointLocatorBase;
<a name="l00054"></a>00054 <span class="preprocessor">#endif</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00089"></a>00089 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00090"></a>00090 <span class="comment">// Elem class definition</span>
<a name="l00091"></a><a class="code" href="classlibMesh_1_1Elem.php">00091</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Elem&gt;,
<a name="l00092"></a>00092              <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094  <span class="keyword">protected</span>:
<a name="l00095"></a>00095   
<a name="l00102"></a>00102   <a class="code" href="classlibMesh_1_1Elem.php#a8353939d19c08e5e75faa50390df1be0">Elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>=0,
<a name="l00103"></a>00103         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>=0,
<a name="l00104"></a>00104         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>=NULL);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106  <span class="keyword">public</span>:
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php#af8fbc51d11157a317256d65e9a620661">~Elem</a>();
<a name="l00112"></a>00112 
<a name="l00116"></a>00116   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00138"></a>00138   
<a name="l00143"></a>00143   <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> <a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a> () <span class="keyword">const</span>;
<a name="l00144"></a>00144   
<a name="l00149"></a>00149   <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> &amp; <a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a> ();
<a name="l00150"></a>00150 
<a name="l00156"></a>00156   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a1c04722ef6d6a8f49c66278a3c89a3ec">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span> = 0;
<a name="l00157"></a>00157   
<a name="l00164"></a>00164   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a9fcb2f0b5d9b258d4b1189806d577d5f">operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00165"></a>00165 
<a name="l00173"></a>00173   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC  </span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>
<a name="l00182"></a>00182   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a4a0000dc4a95551cf712a89fc7093f65">topological_neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00183"></a>00183                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00184"></a>00184                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; point_locator,
<a name="l00185"></a>00185                               <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a>* pb) <span class="keyword">const</span>;
<a name="l00186"></a>00186 
<a name="l00191"></a>00191   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a5924562ce5ef72ddf2da1c796376b188">has_topological_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00192"></a>00192                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00193"></a>00193                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; point_locator,
<a name="l00194"></a>00194                                  <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a>* pb) <span class="keyword">const</span>;
<a name="l00195"></a>00195 <span class="preprocessor">#endif   </span>
<a name="l00196"></a>00196 <span class="preprocessor"></span>
<a name="l00200"></a>00200   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* n);
<a name="l00201"></a>00201 
<a name="l00206"></a>00206   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00207"></a>00207   
<a name="l00213"></a>00213   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a9891d6c31a1bfd5776ff1a298b69bb20">child_neighbor</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00214"></a>00214   
<a name="l00220"></a>00220   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a9891d6c31a1bfd5776ff1a298b69bb20">child_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00221"></a>00221   
<a name="l00227"></a>00227   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a99b37a22b9bed12e5195243183cd9b8f">on_boundary</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228   
<a name="l00234"></a>00234   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e) <span class="keyword">const</span>; 
<a name="l00235"></a>00235 
<a name="l00240"></a>00240   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a9eb4aede10696470eb619cf0ccbc6c04">contains_vertex_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e) <span class="keyword">const</span>;
<a name="l00241"></a>00241 
<a name="l00247"></a>00247   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a65c90c62886121e4ff7b33f7acf48843">contains_edge_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e) <span class="keyword">const</span>;
<a name="l00248"></a>00248 
<a name="l00253"></a>00253   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a479ca39359c81c4c75f19457a23ad32f">find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set) <span class="keyword">const</span>;
<a name="l00254"></a>00254 
<a name="l00259"></a>00259   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a673c008a4c1d4ddf3671b55f3ff1829a">find_edge_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set) <span class="keyword">const</span>;
<a name="l00260"></a>00260 
<a name="l00268"></a>00268   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a975ab6f3e93964a1c30821c3a97baecb">make_links_to_me_remote</a> ();
<a name="l00269"></a>00269 
<a name="l00280"></a><a class="code" href="classlibMesh_1_1Elem.php#a72a89396d5712c7541be0788d159403c">00280</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a72a89396d5712c7541be0788d159403c">is_remote</a> ()<span class="keyword"> const</span>
<a name="l00281"></a>00281 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00282"></a>00282 
<a name="l00289"></a>00289   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#abbf1e39b13aa0ee2e41169274d5ec717">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00290"></a>00290                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00291"></a>00291                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span> = 0;
<a name="l00292"></a>00292 
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab246c7ff89fc186970d92dcf8b78d481">write_connectivity</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>,
<a name="l00301"></a>00301                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop) <span class="keyword">const</span>;
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 <span class="comment">//   /**</span>
<a name="l00304"></a>00304 <span class="comment">//    * @returns the VTK element type of the sc-th sub-element.</span>
<a name="l00305"></a>00305 <span class="comment">//    */</span>
<a name="l00306"></a>00306 <span class="comment">//   virtual unsigned int vtk_element_type (const unsigned int sc) const = 0;</span>
<a name="l00307"></a>00307 
<a name="l00312"></a>00312   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a> () <span class="keyword">const</span> = 0;
<a name="l00313"></a>00313 
<a name="l00318"></a><a class="code" href="classlibMesh_1_1Elem.php#a1a76b7c00bdaac5d0a245ec42d1e0576">00318</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a1a76b7c00bdaac5d0a245ec42d1e0576">type_to_n_nodes_map</a>[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>];
<a name="l00319"></a>00319   
<a name="l00323"></a>00323   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a> () <span class="keyword">const</span> = 0;
<a name="l00324"></a>00324   
<a name="l00328"></a>00328   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a> () <span class="keyword">const</span> = 0;
<a name="l00329"></a>00329 
<a name="l00335"></a>00335   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a> () <span class="keyword">const</span> = 0;
<a name="l00336"></a>00336 
<a name="l00343"></a><a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">00343</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a> ()<span class="keyword"> const</span>
<a name="l00344"></a>00344 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); }
<a name="l00345"></a>00345 
<a name="l00350"></a>00350   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a> () <span class="keyword">const</span> = 0;
<a name="l00351"></a>00351 
<a name="l00356"></a>00356   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#adde1fccc9a1fc4b43485629cb6c4062b">n_edges</a> () <span class="keyword">const</span> = 0;
<a name="l00357"></a>00357 
<a name="l00362"></a>00362   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#aa771d517cf54ef87047d30f8052a4986">n_faces</a> () <span class="keyword">const</span> = 0;
<a name="l00363"></a>00363   
<a name="l00368"></a>00368   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a> () <span class="keyword">const</span> = 0;
<a name="l00369"></a>00369 
<a name="l00373"></a>00373   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00374"></a>00374 
<a name="l00378"></a>00378   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a97ed0900db3702d67bac8b56b350c35b">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00379"></a>00379 
<a name="l00383"></a>00383   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a6dbd7084d5f64ad9005c9123a860236c">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00384"></a>00384   
<a name="l00385"></a>00385   <span class="comment">/*</span>
<a name="l00386"></a>00386 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00387"></a>00387 <span class="comment">   * specified side</span>
<a name="l00388"></a>00388 <span class="comment">   */</span>
<a name="l00389"></a>00389   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00390"></a>00390                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span> = 0;
<a name="l00391"></a>00391   
<a name="l00392"></a>00392   <span class="comment">/*</span>
<a name="l00393"></a>00393 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00394"></a>00394 <span class="comment">   * specified edge</span>
<a name="l00395"></a>00395 <span class="comment">   */</span>
<a name="l00396"></a>00396   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ad60e38f39743e85b379795b1b9958ec5">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00397"></a>00397                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span> = 0;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="comment">//   /**</span>
<a name="l00400"></a>00400 <span class="comment">//    * @returns the number of children this element has that</span>
<a name="l00401"></a>00401 <span class="comment">//    * share side \p s</span>
<a name="l00402"></a>00402 <span class="comment">//    */</span>
<a name="l00403"></a>00403 <span class="comment">//   virtual unsigned int n_children_per_side (const unsigned int) const = 0;</span>
<a name="l00404"></a>00404   
<a name="l00410"></a>00410   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a958eb1740332cf7a0ca291dc335f9a47">n_sub_elem</a> () <span class="keyword">const</span> = 0;
<a name="l00411"></a>00411 
<a name="l00420"></a>00420   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Elem.php#a94928c2026be2a791aa6b1ac40ff37a0">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00421"></a>00421   
<a name="l00438"></a>00438   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00439"></a>00439                                     <span class="keywordtype">bool</span> proxy=<span class="keyword">true</span>) <span class="keyword">const</span> = 0;
<a name="l00440"></a>00440 
<a name="l00449"></a>00449   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Elem.php#a2b0590037d655ea1b3f325137fe142e7">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00450"></a>00450 
<a name="l00456"></a>00456   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a> () <span class="keyword">const</span> = 0;
<a name="l00457"></a>00457   
<a name="l00464"></a>00464   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a> () <span class="keyword">const</span>;
<a name="l00465"></a>00465   
<a name="l00469"></a>00469   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">hmin</a> () <span class="keyword">const</span>;
<a name="l00470"></a>00470   
<a name="l00474"></a>00474   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#af238e5529e55b1c434b0a6ec923b5f47">hmax</a> () <span class="keyword">const</span>;
<a name="l00475"></a>00475 
<a name="l00479"></a>00479   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#ac8bbe0a421dc8a27a34948ade9ba0e21">volume</a> () <span class="keyword">const</span>;
<a name="l00480"></a>00480   
<a name="l00485"></a>00485   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#ac06d31c555b1d62e40f571a395b3bf6f">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;  
<a name="l00486"></a>00486 
<a name="l00494"></a><a class="code" href="classlibMesh_1_1Elem.php#ad9fb1e6fe58f38f6f4fd0bf3f6be7be1">00494</a>   <span class="keyword">virtual</span> std::pair&lt;Real,Real&gt; <a class="code" href="classlibMesh_1_1Elem.php#ad9fb1e6fe58f38f6f4fd0bf3f6be7be1">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a>)<span class="keyword"> const</span>
<a name="l00495"></a>00495 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> std::make_pair(0.,0.); }
<a name="l00496"></a>00496   
<a name="l00505"></a>00505   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#afd665f3e6d13b0aaaf4c4620067329bc">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol=TOLERANCE) <span class="keyword">const</span>;
<a name="l00506"></a>00506 
<a name="l00511"></a><a class="code" href="classlibMesh_1_1Elem.php#ad0155a2e8e15da7dc9c7a820265fd143">00511</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ad0155a2e8e15da7dc9c7a820265fd143">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00512"></a>00512 
<a name="l00518"></a>00518   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a> () <span class="keyword">const</span>;
<a name="l00519"></a>00519   
<a name="l00525"></a>00525   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a> () <span class="keyword">const</span>;
<a name="l00526"></a>00526   
<a name="l00532"></a>00532   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a> () <span class="keyword">const</span>;
<a name="l00533"></a>00533   
<a name="l00538"></a>00538   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a> () <span class="keyword">const</span>;
<a name="l00539"></a>00539 
<a name="l00545"></a>00545   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a364262f5f20dfece0872962ddb2b6145">has_ancestor_children</a> () <span class="keyword">const</span>;
<a name="l00546"></a>00546 
<a name="l00552"></a>00552   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#addbdfc1f56b018ade858aa3161792366">is_ancestor_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *descendant) <span class="keyword">const</span>;
<a name="l00553"></a>00553 
<a name="l00558"></a>00558   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a> () <span class="keyword">const</span>;
<a name="l00559"></a>00559 
<a name="l00564"></a>00564   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a> ();
<a name="l00565"></a>00565 
<a name="l00570"></a>00570   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#aa4496b9addd808d8c1fa2074e1a8cc4f">set_parent</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *p);
<a name="l00571"></a>00571 
<a name="l00578"></a>00578   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a> () <span class="keyword">const</span>;
<a name="l00579"></a>00579   
<a name="l00588"></a>00588   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a71acd72e0de11af46af5dc7409d83951">interior_parent</a> () <span class="keyword">const</span>;
<a name="l00589"></a>00589 
<a name="l00594"></a>00594   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1, 
<a name="l00595"></a>00595                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2) <span class="keyword">const</span>;
<a name="l00596"></a>00596 
<a name="l00605"></a>00605   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a5175062272874a37befab4a16ce68eaf">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00606"></a>00606 
<a name="l00614"></a>00614   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a430e1bdb48a91b50f7d22c203de8129f">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00615"></a>00615                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00616"></a>00616 
<a name="l00626"></a>00626   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00627"></a>00627           <a class="code" href="classlibMesh_1_1Elem.php#af476a143ee494ae754e812466ccbdff4">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00628"></a>00628 
<a name="l00640"></a>00640   <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem.php#a877984e054cff62d2205a2a6c57cde0a">second_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et,
<a name="l00641"></a>00641                                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered=<span class="keyword">true</span>);
<a name="l00642"></a>00642 
<a name="l00649"></a>00649   <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem.php#a6c2704fb0b2d715cb19bb2a4f517b0f3">first_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et);
<a name="l00650"></a>00650                                                
<a name="l00651"></a>00651 
<a name="l00658"></a>00658   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a> () <span class="keyword">const</span>;
<a name="l00659"></a>00659   
<a name="l00665"></a>00665   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a> () <span class="keyword">const</span>;
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00668"></a>00668 <span class="preprocessor"></span>
<a name="l00673"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">00673</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> { <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">COARSEN</a> = 0,
<a name="l00674"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">00674</a>                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">DO_NOTHING</a>,
<a name="l00675"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">00675</a>                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">REFINE</a>,
<a name="l00676"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">00676</a>                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>,
<a name="l00677"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">00677</a>                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">JUST_COARSENED</a>,
<a name="l00678"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">00678</a>                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">INACTIVE</a>,
<a name="l00679"></a><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">00679</a>                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">COARSEN_INACTIVE</a> };
<a name="l00680"></a>00680   
<a name="l00685"></a>00685   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00686"></a>00686 
<a name="l00692"></a>00692   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e) <span class="keyword">const</span>; 
<a name="l00693"></a>00693 
<a name="l00698"></a>00698   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00699"></a>00699                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span> = 0;
<a name="l00700"></a>00700   
<a name="l00705"></a>00705   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#abbc77b3dfdf119b294cdfd0e5f15075a">is_child_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00706"></a>00706                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00707"></a>00707 
<a name="l00714"></a>00714   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">add_child</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00715"></a>00715 
<a name="l00722"></a>00722   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">add_child</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c);
<a name="l00723"></a>00723 
<a name="l00728"></a>00728   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ab1678542219d439b71a02beb477e94ce">replace_child</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c);
<a name="l00729"></a>00729 
<a name="l00738"></a>00738   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ad1d76a56b53265428558d0851f1ae09b">family_tree</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00739"></a>00739                     <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00740"></a>00740 
<a name="l00747"></a>00747   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a115d93be0231e3c0bacf45a6a4f1804d">active_family_tree</a> (std::vector&lt;const Elem*&gt;&amp; active_family,
<a name="l00748"></a>00748                            <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00749"></a>00749 
<a name="l00754"></a>00754   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a48ad0203e34ad29efd04caab0ff2842f">family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00755"></a>00755                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a94928c2026be2a791aa6b1ac40ff37a0">side</a>,
<a name="l00756"></a>00756                             <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00757"></a>00757 
<a name="l00762"></a>00762   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a45301bbc272e10e4cfafc0bb38ada072">active_family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00763"></a>00763                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a94928c2026be2a791aa6b1ac40ff37a0">side</a>,
<a name="l00764"></a>00764                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00765"></a>00765   
<a name="l00770"></a>00770   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#afc76f1733c9adbe6181f225cc740a7a7">family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00771"></a>00771                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor,
<a name="l00772"></a>00772                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00773"></a>00773 
<a name="l00780"></a>00780   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a4072ab635a948802d7ed49a8202221f0">family_tree_by_subneighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00781"></a>00781                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor,
<a name="l00782"></a>00782                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *subneighbor,
<a name="l00783"></a>00783                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00784"></a>00784 
<a name="l00789"></a>00789   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00790"></a>00790                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor,
<a name="l00791"></a>00791                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset=<span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00792"></a>00792 
<a name="l00796"></a>00796   <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> <a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a> () <span class="keyword">const</span>;
<a name="l00797"></a>00797 
<a name="l00801"></a>00801   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> rflag);
<a name="l00802"></a>00802 
<a name="l00806"></a>00806   <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> <a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a> () <span class="keyword">const</span>;
<a name="l00807"></a>00807 
<a name="l00811"></a>00811   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> pflag);
<a name="l00812"></a>00812 
<a name="l00817"></a>00817   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a62f9ba081c33e128f91a413aebcfb554">max_descendant_p_level</a> () <span class="keyword">const</span>;
<a name="l00818"></a>00818 
<a name="l00824"></a>00824   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#aad83f9aaca6d0bcef2a5205abcc134a9">min_p_level_by_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l00825"></a>00825                                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min) <span class="keyword">const</span>;
<a name="l00826"></a>00826 
<a name="l00833"></a>00833   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ae4ccfe379ed5d23c4ae165e095867c22">min_new_p_level_by_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor,
<a name="l00834"></a>00834                                             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min) <span class="keyword">const</span>;
<a name="l00835"></a>00835 
<a name="l00840"></a>00840   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00841"></a>00841 
<a name="l00846"></a>00846   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a439bf8e694aaca274598b42d6c7faf9d">hack_p_level</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00847"></a>00847 
<a name="l00851"></a>00851   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a162331e5fa77118d63acfe93c1fece82">refine</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>&amp; mesh_refinement);
<a name="l00852"></a>00852  
<a name="l00858"></a>00858   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ac54b6c6495592ce7774d01167b71dfbd">coarsen</a> ();
<a name="l00859"></a>00859 
<a name="l00866"></a>00866   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a190384cbf87edfe3d41219615f3b6d27">contract</a> ();
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 <span class="preprocessor">#endif</span>
<a name="l00869"></a>00869 <span class="preprocessor"></span>
<a name="l00870"></a>00870 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00871"></a>00871 <span class="preprocessor"></span>
<a name="l00875"></a>00875   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ae15bea57cf5f41dbb2bdc680c6921200">libmesh_assert_valid_neighbors</a>() <span class="keyword">const</span>;
<a name="l00876"></a>00876 
<a name="l00881"></a>00881   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a6a2e745d84e1846b7456137051fe94b3">libmesh_assert_valid_node_pointers</a>() <span class="keyword">const</span>;
<a name="l00882"></a>00882 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00883"></a>00883 <span class="preprocessor"></span>
<a name="l00884"></a>00884 <span class="keyword">protected</span>:
<a name="l00885"></a>00885 
<a name="l00896"></a><a class="code" href="classlibMesh_1_1Elem.php#a99bb1c1db96162c43f76472122cb2447">00896</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>;
<a name="l00897"></a>00897   
<a name="l00898"></a>00898 <span class="keyword">public</span>:
<a name="l00902"></a>00902   <span class="keyword">typedef</span> <a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicates::multi_predicate</a> <a class="code" href="classlibMesh_1_1Elem.php#a99bb1c1db96162c43f76472122cb2447">Predicate</a>;
<a name="l00903"></a>00903   <span class="comment">//typedef variant_filter_iterator&lt;Elem*, Predicate&gt; side_iterator;</span>
<a name="l00904"></a>00904 
<a name="l00909"></a>00909   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">side_iterator</a>;
<a name="l00910"></a>00910   
<a name="l00914"></a>00914   <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">side_iterator</a> <a class="code" href="classlibMesh_1_1Elem.php#a6fdb6e30c09302ca9914913dc68e36e7">boundary_sides_begin</a>();
<a name="l00915"></a>00915   <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">side_iterator</a> <a class="code" href="classlibMesh_1_1Elem.php#a6d3285f9a6e90878e2c849ec2c74a024">boundary_sides_end</a>();
<a name="l00916"></a>00916 
<a name="l00917"></a>00917 <span class="keyword">private</span>:
<a name="l00922"></a>00922   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a> <a class="code" href="classlibMesh_1_1Elem.php#a579b6b2edb461eba4790658149c36b0a">_first_side</a>(); 
<a name="l00923"></a>00923   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a> <a class="code" href="classlibMesh_1_1Elem.php#a40fb5e7605af6abe9ebbffc47bb7f982">_last_side</a>();  
<a name="l00924"></a>00924   
<a name="l00925"></a>00925 <span class="keyword">public</span>:
<a name="l00926"></a>00926   
<a name="l00927"></a>00927 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00928"></a>00928 <span class="preprocessor"></span>
<a name="l00933"></a>00933   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#af5eecb2e1afee8bc7ebf8632da91e4ff">infinite</a> () <span class="keyword">const</span> = 0;
<a name="l00934"></a>00934 
<a name="l00943"></a><a class="code" href="classlibMesh_1_1Elem.php#a4da21e127a2f2f1b35168b3cfd458b74">00943</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Elem.php#a4da21e127a2f2f1b35168b3cfd458b74">origin</a> ()<span class="keyword"> const </span>{ libmesh_error(); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>(); }
<a name="l00944"></a>00944 
<a name="l00945"></a>00945 <span class="preprocessor">#endif</span>
<a name="l00946"></a>00946 <span class="preprocessor"></span>
<a name="l00947"></a>00947 
<a name="l00948"></a>00948 
<a name="l00949"></a>00949   
<a name="l00955"></a>00955   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">build</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>,
<a name="l00956"></a>00956                               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL);
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00959"></a>00959 <span class="preprocessor"></span>  
<a name="l00964"></a>00964   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Elem.php#a20e8a3350fb24fd249209e0089b2ca33">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00965"></a>00965                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00966"></a>00966                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k) <span class="keyword">const</span> = 0;
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 <span class="preprocessor">#endif</span>
<a name="l00969"></a>00969 <span class="preprocessor"></span>  
<a name="l00970"></a>00970 
<a name="l00971"></a>00971   <span class="comment">//--------------------------------------------------------</span>
<a name="l00980"></a>00980 <span class="comment"></span>  <span class="keyword">class </span>PackedElem;
<a name="l00981"></a>00981 
<a name="l00982"></a>00982 
<a name="l00983"></a>00983  <span class="keyword">protected</span>:
<a name="l00984"></a>00984 
<a name="l00985"></a>00985   <span class="comment">//-------------------------------------------------------</span>
<a name="l00986"></a>00986   <span class="comment">// These methods compute has keys from the specified</span>
<a name="l00987"></a>00987   <span class="comment">// global node numbers</span>
<a name="l00988"></a>00988   <span class="comment">//</span>
<a name="l00992"></a>00992 <span class="comment"></span>  <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0);
<a name="l00993"></a>00993 
<a name="l00997"></a>00997   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l00998"></a>00998                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1);
<a name="l00999"></a>00999 
<a name="l01003"></a>01003   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01004"></a>01004                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l01005"></a>01005                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2);
<a name="l01006"></a>01006 
<a name="l01010"></a>01010   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01011"></a>01011                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l01012"></a>01012                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2,
<a name="l01013"></a>01013                                    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n3);
<a name="l01014"></a>01014   <span class="comment">//-------------------------------------------------------</span>
<a name="l01015"></a>01015 
<a name="l01016"></a>01016 
<a name="l01017"></a>01017   
<a name="l01023"></a>01023   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a726879346cab41cf1056a9eed73e02b0">nullify_neighbors</a> ();
<a name="l01024"></a>01024   
<a name="l01028"></a><a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">01028</a>   <a class="code" href="classlibMesh_1_1Node.php">Node</a>** <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>;
<a name="l01029"></a>01029 
<a name="l01033"></a><a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">01033</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>** <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a>;
<a name="l01034"></a>01034  
<a name="l01038"></a><a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">01038</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a>;
<a name="l01039"></a>01039 
<a name="l01040"></a>01040 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01041"></a>01041 <span class="preprocessor"></span>  
<a name="l01045"></a><a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">01045</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>** <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>;
<a name="l01046"></a>01046 
<a name="l01051"></a><a class="code" href="classlibMesh_1_1Elem.php#a1be5295de3df06f8cfc0560653124c76">01051</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1Elem.php#a1be5295de3df06f8cfc0560653124c76">_rflag</a>;
<a name="l01052"></a>01052   <span class="comment">//RefinementState _rflag;</span>
<a name="l01053"></a>01053   
<a name="l01058"></a><a class="code" href="classlibMesh_1_1Elem.php#ad3ffad7d497f66f866bd8a6d8d9a3134">01058</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1Elem.php#ad3ffad7d497f66f866bd8a6d8d9a3134">_pflag</a>;
<a name="l01059"></a>01059   <span class="comment">//RefinementState _pflag;</span>
<a name="l01060"></a>01060   
<a name="l01069"></a><a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">01069</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a>;
<a name="l01070"></a>01070 
<a name="l01071"></a>01071 <span class="preprocessor">#endif</span>
<a name="l01072"></a>01072 <span class="preprocessor"></span>
<a name="l01076"></a><a class="code" href="classlibMesh_1_1Elem.php#a8b8584057f46d48705d90a73ef417f98">01076</a>   <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> <a class="code" href="classlibMesh_1_1Elem.php#a8b8584057f46d48705d90a73ef417f98">_sbd_id</a>;
<a name="l01077"></a>01077 
<a name="l01089"></a><a class="code" href="classlibMesh_1_1Elem.php#a7eb42a58c387442456965deba0fd97fd">01089</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>;    <span class="comment">// (Elem::nullify_neighbors)</span>
<a name="l01090"></a>01090 
<a name="l01091"></a>01091  <span class="keyword">private</span>:
<a name="l01096"></a>01096   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ab55ff0440bfc0a90025349270738df4d">_cast_node_address_to_unsigned_int</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l01097"></a>01097 
<a name="l01098"></a>01098   <span class="comment">// Prime numbers used for computing node keys.  These are the same</span>
<a name="l01099"></a>01099   <span class="comment">// for every instance of the Elem class.</span>
<a name="l01100"></a><a class="code" href="classlibMesh_1_1Elem.php#aa264f7b65b55bcafe3a1ca127c419602">01100</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#aa264f7b65b55bcafe3a1ca127c419602">_bp1</a>;
<a name="l01101"></a><a class="code" href="classlibMesh_1_1Elem.php#a0228a7bfb5dda3f22a4f9851ec09d2d1">01101</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0228a7bfb5dda3f22a4f9851ec09d2d1">_bp2</a>;
<a name="l01102"></a>01102 };
<a name="l01103"></a>01103 
<a name="l01104"></a>01104 
<a name="l01105"></a>01105 
<a name="l01106"></a>01106 
<a name="l01107"></a>01107 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01108"></a>01108 <span class="comment">// Elem class member functions</span>
<a name="l01109"></a>01109 <span class="keyword">inline</span>
<a name="l01110"></a><a class="code" href="classlibMesh_1_1Elem.php#a8353939d19c08e5e75faa50390df1be0">01110</a> <a class="code" href="classlibMesh_1_1Elem.php#a8353939d19c08e5e75faa50390df1be0">Elem::Elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l01111"></a>01111            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l01112"></a>01112            <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l01113"></a>01113   _nodes(NULL),
<a name="l01114"></a>01114   _neighbors(NULL),
<a name="l01115"></a>01115   _parent(p),
<a name="l01116"></a>01116 #ifdef LIBMESH_ENABLE_AMR
<a name="l01117"></a>01117   _children(NULL),
<a name="l01118"></a>01118   _rflag(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>::DO_NOTHING),
<a name="l01119"></a>01119   _pflag(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>::DO_NOTHING),
<a name="l01120"></a>01120   _p_level(0),
<a name="l01121"></a>01121 #endif
<a name="l01122"></a>01122   _sbd_id(0)
<a name="l01123"></a>01123 {
<a name="l01124"></a>01124   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>;
<a name="l01125"></a>01125   
<a name="l01126"></a>01126   <span class="comment">// Initialize the nodes data structure</span>
<a name="l01127"></a>01127   <span class="keywordflow">if</span> (nn != 0)
<a name="l01128"></a>01128     {
<a name="l01129"></a>01129       <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*[nn]; 
<a name="l01130"></a>01130       
<a name="l01131"></a>01131       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l01132"></a>01132         <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[n] = NULL;
<a name="l01133"></a>01133     }
<a name="l01134"></a>01134   
<a name="l01135"></a>01135   <span class="comment">// Initialize the neighbors data structure</span>
<a name="l01136"></a>01136   <span class="keywordflow">if</span> (ns != 0)
<a name="l01137"></a>01137     {
<a name="l01138"></a>01138       <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*[ns]; 
<a name="l01139"></a>01139       
<a name="l01140"></a>01140       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;ns; n++)
<a name="l01141"></a>01141         <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a>[n] = NULL;
<a name="l01142"></a>01142     }
<a name="l01143"></a>01143 
<a name="l01144"></a>01144   <span class="comment">// Optionally initialize data from the parent</span>
<a name="l01145"></a>01145   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != NULL)
<a name="l01146"></a>01146     {
<a name="l01147"></a>01147       this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l01148"></a>01148       this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l01149"></a>01149     }  
<a name="l01150"></a>01150 
<a name="l01151"></a>01151 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01152"></a>01152 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l01153"></a>01153     this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01154"></a>01154 <span class="preprocessor">#endif</span>
<a name="l01155"></a>01155 <span class="preprocessor"></span>}
<a name="l01156"></a>01156 
<a name="l01157"></a>01157 
<a name="l01158"></a>01158 
<a name="l01159"></a>01159 <span class="keyword">inline</span>
<a name="l01160"></a><a class="code" href="classlibMesh_1_1Elem.php#af8fbc51d11157a317256d65e9a620661">01160</a> <a class="code" href="classlibMesh_1_1Elem.php#af8fbc51d11157a317256d65e9a620661">Elem::~Elem</a>() 
<a name="l01161"></a>01161 {
<a name="l01162"></a>01162   <span class="comment">// Delete my node storage</span>
<a name="l01163"></a>01163   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL)
<a name="l01164"></a>01164     <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>;
<a name="l01165"></a>01165   <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> = NULL;
<a name="l01166"></a>01166 
<a name="l01167"></a>01167   <span class="comment">// Delete my neighbor storage</span>
<a name="l01168"></a>01168   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a> != NULL)
<a name="l01169"></a>01169     <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a>;
<a name="l01170"></a>01170   <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a> = NULL;
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01173"></a>01173 <span class="preprocessor"></span>
<a name="l01174"></a>01174   <span class="comment">// Delete my children&#39;s storage</span>
<a name="l01175"></a>01175   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> != NULL)
<a name="l01176"></a>01176     <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>;
<a name="l01177"></a>01177   <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> = NULL;
<a name="l01178"></a>01178   
<a name="l01179"></a>01179 <span class="preprocessor">#endif</span>
<a name="l01180"></a>01180 <span class="preprocessor"></span>}
<a name="l01181"></a>01181 
<a name="l01182"></a>01182 
<a name="l01183"></a>01183 
<a name="l01184"></a>01184 <span class="keyword">inline</span>
<a name="l01185"></a><a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">01185</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">Elem::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01186"></a>01186 <span class="keyword"></span>{
<a name="l01187"></a>01187   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01188"></a>01188   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i] != NULL);
<a name="l01189"></a>01189   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">Node::invalid_id</a>);
<a name="l01190"></a>01190 
<a name="l01191"></a>01191   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i];
<a name="l01192"></a>01192 }
<a name="l01193"></a>01193 
<a name="l01194"></a>01194 
<a name="l01195"></a>01195 
<a name="l01196"></a>01196 <span class="keyword">inline</span>
<a name="l01197"></a><a class="code" href="classlibMesh_1_1Elem.php#ab35cc5c69c3af966981be22e064e0a15">01197</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">Elem::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l01198"></a>01198 {
<a name="l01199"></a>01199   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01200"></a>01200 
<a name="l01201"></a>01201   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i];
<a name="l01202"></a>01202 }
<a name="l01203"></a>01203 
<a name="l01204"></a>01204 
<a name="l01205"></a>01205 
<a name="l01206"></a>01206 <span class="keyword">inline</span>
<a name="l01207"></a><a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">01207</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">Elem::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01208"></a>01208 <span class="keyword"></span>{
<a name="l01209"></a>01209   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01210"></a>01210   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i] != NULL);
<a name="l01211"></a>01211   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">Node::invalid_id</a>);
<a name="l01212"></a>01212 
<a name="l01213"></a>01213   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i]-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01214"></a>01214 }
<a name="l01215"></a>01215 
<a name="l01216"></a>01216 
<a name="l01217"></a>01217 
<a name="l01218"></a>01218 <span class="keyword">inline</span>
<a name="l01219"></a><a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">01219</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">Elem::get_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01220"></a>01220 <span class="keyword"></span>{
<a name="l01221"></a>01221   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01222"></a>01222   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i] != NULL);
<a name="l01223"></a>01223 
<a name="l01224"></a>01224   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i];
<a name="l01225"></a>01225 }
<a name="l01226"></a>01226 
<a name="l01227"></a>01227 
<a name="l01228"></a>01228 
<a name="l01229"></a>01229 <span class="keyword">inline</span>
<a name="l01230"></a><a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">01230</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">Elem::set_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l01231"></a>01231 {
<a name="l01232"></a>01232   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01233"></a>01233 
<a name="l01234"></a>01234   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a>[i];
<a name="l01235"></a>01235 }
<a name="l01236"></a>01236 
<a name="l01237"></a>01237 
<a name="l01238"></a>01238 
<a name="l01239"></a>01239 <span class="keyword">inline</span>
<a name="l01240"></a><a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">01240</a> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> <a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">Elem::subdomain_id</a> ()<span class="keyword"> const</span>
<a name="l01241"></a>01241 <span class="keyword"></span>{
<a name="l01242"></a>01242   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a8b8584057f46d48705d90a73ef417f98">_sbd_id</a>;
<a name="l01243"></a>01243 }
<a name="l01244"></a>01244 
<a name="l01245"></a>01245 
<a name="l01246"></a>01246 
<a name="l01247"></a>01247 <span class="keyword">inline</span>
<a name="l01248"></a><a class="code" href="classlibMesh_1_1Elem.php#a59f6d76e35d6d77450d3fecaa5e8f092">01248</a> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> &amp; <a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">Elem::subdomain_id</a> ()
<a name="l01249"></a>01249 {
<a name="l01250"></a>01250   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a8b8584057f46d48705d90a73ef417f98">_sbd_id</a>;
<a name="l01251"></a>01251 }
<a name="l01252"></a>01252 
<a name="l01253"></a>01253 
<a name="l01254"></a>01254 
<a name="l01255"></a>01255 <span class="keyword">inline</span>
<a name="l01256"></a><a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">01256</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">Elem::neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01257"></a>01257 <span class="keyword"></span>{
<a name="l01258"></a>01258   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l01259"></a>01259 
<a name="l01260"></a>01260   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a>[i];
<a name="l01261"></a>01261 }
<a name="l01262"></a>01262 
<a name="l01263"></a>01263 
<a name="l01264"></a>01264 
<a name="l01265"></a>01265 <span class="keyword">inline</span>
<a name="l01266"></a><a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">01266</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">Elem::set_neighbor</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* n)
<a name="l01267"></a>01267 {
<a name="l01268"></a>01268   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>());
<a name="l01269"></a>01269   
<a name="l01270"></a>01270   <a class="code" href="classlibMesh_1_1Elem.php#a765a4a38b2b8235a140163342aa0b349">_neighbors</a>[i] = n;
<a name="l01271"></a>01271 }
<a name="l01272"></a>01272 
<a name="l01273"></a>01273 
<a name="l01274"></a>01274 
<a name="l01275"></a>01275 <span class="keyword">inline</span>
<a name="l01276"></a><a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">01276</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">Elem::has_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l01277"></a>01277 <span class="keyword"></span>{
<a name="l01278"></a>01278   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l01279"></a>01279     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) == elem)
<a name="l01280"></a>01280       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01281"></a>01281 
<a name="l01282"></a>01282   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01283"></a>01283 }
<a name="l01284"></a>01284 
<a name="l01285"></a>01285 
<a name="l01286"></a>01286 
<a name="l01287"></a>01287 <span class="keyword">inline</span>
<a name="l01288"></a><a class="code" href="classlibMesh_1_1Elem.php#a9891d6c31a1bfd5776ff1a298b69bb20">01288</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a9891d6c31a1bfd5776ff1a298b69bb20">Elem::child_neighbor</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l01289"></a>01289 <span class="keyword"></span>{
<a name="l01290"></a>01290   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l01291"></a>01291     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) &amp;&amp;
<a name="l01292"></a>01292         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() == <span class="keyword">this</span>)
<a name="l01293"></a>01293       <span class="keywordflow">return</span> elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l01294"></a>01294 
<a name="l01295"></a>01295   <span class="keywordflow">return</span> NULL;
<a name="l01296"></a>01296 }
<a name="l01297"></a>01297 
<a name="l01298"></a>01298 
<a name="l01299"></a>01299 
<a name="l01300"></a>01300 <span class="keyword">inline</span>
<a name="l01301"></a><a class="code" href="classlibMesh_1_1Elem.php#a48e886a107283bcde6c26d5e0ed75b35">01301</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a9891d6c31a1bfd5776ff1a298b69bb20">Elem::child_neighbor</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l01302"></a>01302 <span class="keyword"></span>{
<a name="l01303"></a>01303   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l01304"></a>01304     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) &amp;&amp;
<a name="l01305"></a>01305         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() == <span class="keyword">this</span>)
<a name="l01306"></a>01306       <span class="keywordflow">return</span> elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l01307"></a>01307 
<a name="l01308"></a>01308   <span class="keywordflow">return</span> NULL;
<a name="l01309"></a>01309 }
<a name="l01310"></a>01310 
<a name="l01311"></a>01311 
<a name="l01312"></a>01312 
<a name="l01313"></a>01313 <span class="keyword">inline</span>
<a name="l01314"></a><a class="code" href="classlibMesh_1_1Elem.php#a99b37a22b9bed12e5195243183cd9b8f">01314</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a99b37a22b9bed12e5195243183cd9b8f">Elem::on_boundary</a> ()<span class="keyword"> const</span>
<a name="l01315"></a>01315 <span class="keyword"></span>{
<a name="l01316"></a>01316   <span class="comment">// By convention, the element is on the boundary</span>
<a name="l01317"></a>01317   <span class="comment">// if it has a NULL neighbor.</span>
<a name="l01318"></a>01318   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac38955440ced2b43f4aa74831d1da3f2">has_neighbor</a>(NULL);
<a name="l01319"></a>01319 }
<a name="l01320"></a>01320 
<a name="l01321"></a>01321 
<a name="l01322"></a>01322 
<a name="l01323"></a>01323 <span class="keyword">inline</span>
<a name="l01324"></a><a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">01324</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">Elem::which_neighbor_am_i</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)<span class="keyword"> const</span>
<a name="l01325"></a>01325 <span class="keyword"></span>{
<a name="l01326"></a>01326   libmesh_assert (e != NULL);
<a name="l01327"></a>01327 
<a name="l01328"></a>01328   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* eparent = e;
<a name="l01329"></a>01329 
<a name="l01330"></a>01330   <span class="keywordflow">while</span> (eparent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &gt; this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>())
<a name="l01331"></a>01331     {
<a name="l01332"></a>01332       eparent = eparent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l01333"></a>01333       libmesh_assert(eparent);
<a name="l01334"></a>01334     }
<a name="l01335"></a>01335   
<a name="l01336"></a>01336   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l01337"></a>01337     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == eparent)
<a name="l01338"></a>01338       <span class="keywordflow">return</span> s;
<a name="l01339"></a>01339     
<a name="l01340"></a>01340   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l01341"></a>01341 }
<a name="l01342"></a>01342 
<a name="l01343"></a>01343 
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 <span class="keyword">inline</span>
<a name="l01346"></a><a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">01346</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">Elem::active</a>()<span class="keyword"> const</span>
<a name="l01347"></a>01347 <span class="keyword"></span>{
<a name="l01348"></a>01348 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01349"></a>01349 <span class="preprocessor"></span>  <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">INACTIVE</a>) ||
<a name="l01350"></a>01350       (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">COARSEN_INACTIVE</a>))
<a name="l01351"></a>01351     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01352"></a>01352   <span class="keywordflow">else</span>
<a name="l01353"></a>01353     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01354"></a>01354 <span class="preprocessor">#else</span>
<a name="l01355"></a>01355 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01356"></a>01356 <span class="preprocessor">#endif</span>
<a name="l01357"></a>01357 <span class="preprocessor"></span>}
<a name="l01358"></a>01358 
<a name="l01359"></a>01359 
<a name="l01360"></a>01360 
<a name="l01361"></a>01361 
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 <span class="keyword">inline</span>
<a name="l01364"></a><a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">01364</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">Elem::subactive</a>()<span class="keyword"> const</span>
<a name="l01365"></a>01365 <span class="keyword"></span>{
<a name="l01366"></a>01366 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01367"></a>01367 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01368"></a>01368     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01369"></a>01369   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l01370"></a>01370     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01371"></a>01371   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(0)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>();
<a name="l01372"></a>01372 <span class="preprocessor">#else</span>
<a name="l01373"></a>01373 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01374"></a>01374 <span class="preprocessor">#endif</span>
<a name="l01375"></a>01375 <span class="preprocessor"></span>}
<a name="l01376"></a>01376 
<a name="l01377"></a>01377 
<a name="l01378"></a>01378 
<a name="l01379"></a>01379 <span class="keyword">inline</span>
<a name="l01380"></a><a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">01380</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">Elem::has_children</a>()<span class="keyword"> const</span>
<a name="l01381"></a>01381 <span class="keyword"></span>{
<a name="l01382"></a>01382 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01383"></a>01383 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> == NULL)
<a name="l01384"></a>01384     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01385"></a>01385   <span class="keywordflow">else</span>
<a name="l01386"></a>01386     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01387"></a>01387 <span class="preprocessor">#else</span>
<a name="l01388"></a>01388 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01389"></a>01389 <span class="preprocessor">#endif</span>
<a name="l01390"></a>01390 <span class="preprocessor"></span>}
<a name="l01391"></a>01391 
<a name="l01392"></a>01392 
<a name="l01393"></a>01393 <span class="keyword">inline</span>
<a name="l01394"></a><a class="code" href="classlibMesh_1_1Elem.php#a364262f5f20dfece0872962ddb2b6145">01394</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#a364262f5f20dfece0872962ddb2b6145">Elem::has_ancestor_children</a>()<span class="keyword"> const</span>
<a name="l01395"></a>01395 <span class="keyword"></span>{
<a name="l01396"></a>01396 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01397"></a>01397 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> == NULL)
<a name="l01398"></a>01398     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01399"></a>01399   <span class="keywordflow">else</span>
<a name="l01400"></a>01400     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01401"></a>01401       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l01402"></a>01402         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01403"></a>01403 <span class="preprocessor">#endif</span>
<a name="l01404"></a>01404 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01405"></a>01405 }
<a name="l01406"></a>01406 
<a name="l01407"></a>01407 
<a name="l01408"></a>01408 
<a name="l01409"></a>01409 <span class="keyword">inline</span>
<a name="l01410"></a><a class="code" href="classlibMesh_1_1Elem.php#addbdfc1f56b018ade858aa3161792366">01410</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem.php#addbdfc1f56b018ade858aa3161792366">Elem::is_ancestor_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *
<a name="l01411"></a>01411 #ifdef LIBMESH_ENABLE_AMR
<a name="l01412"></a>01412                           descendant
<a name="l01413"></a>01413 #endif
<a name="l01414"></a>01414                           )<span class="keyword"> const</span>
<a name="l01415"></a>01415 <span class="keyword"></span>{
<a name="l01416"></a>01416 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01417"></a>01417 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e = descendant;
<a name="l01418"></a>01418   <span class="keywordflow">while</span> (e)
<a name="l01419"></a>01419     {
<a name="l01420"></a>01420       <span class="keywordflow">if</span> (<span class="keyword">this</span> == e)
<a name="l01421"></a>01421         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01422"></a>01422       e = e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l01423"></a>01423     }
<a name="l01424"></a>01424 <span class="preprocessor">#endif</span>
<a name="l01425"></a>01425 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01426"></a>01426 }
<a name="l01427"></a>01427 
<a name="l01428"></a>01428 
<a name="l01429"></a>01429 
<a name="l01430"></a>01430 <span class="keyword">inline</span>
<a name="l01431"></a><a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">01431</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">Elem::parent</a> ()<span class="keyword"> const</span>
<a name="l01432"></a>01432 <span class="keyword"></span>{
<a name="l01433"></a>01433   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a>;
<a name="l01434"></a>01434 }
<a name="l01435"></a>01435 
<a name="l01436"></a>01436 
<a name="l01437"></a>01437 
<a name="l01438"></a>01438 <span class="keyword">inline</span>
<a name="l01439"></a><a class="code" href="classlibMesh_1_1Elem.php#a76c16af35cb183174bf94bb3fe85df11">01439</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">Elem::parent</a> ()
<a name="l01440"></a>01440 {
<a name="l01441"></a>01441   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a>;
<a name="l01442"></a>01442 }
<a name="l01443"></a>01443 
<a name="l01444"></a>01444 
<a name="l01445"></a>01445 
<a name="l01446"></a>01446 <span class="keyword">inline</span>
<a name="l01447"></a><a class="code" href="classlibMesh_1_1Elem.php#aa4496b9addd808d8c1fa2074e1a8cc4f">01447</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#aa4496b9addd808d8c1fa2074e1a8cc4f">Elem::set_parent</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *p)
<a name="l01448"></a>01448 {
<a name="l01449"></a>01449   <a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a> = p;
<a name="l01450"></a>01450 }
<a name="l01451"></a>01451 
<a name="l01452"></a>01452 
<a name="l01453"></a>01453 
<a name="l01454"></a>01454 <span class="keyword">inline</span>
<a name="l01455"></a><a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">01455</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">Elem::top_parent</a> ()<span class="keyword"> const</span>
<a name="l01456"></a>01456 <span class="keyword"></span>{
<a name="l01457"></a>01457   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* tp = <span class="keyword">this</span>;
<a name="l01458"></a>01458 
<a name="l01459"></a>01459   <span class="comment">// Keep getting the element&#39;s parent</span>
<a name="l01460"></a>01460   <span class="comment">// until that parent is at level-0</span>
<a name="l01461"></a>01461   <span class="keywordflow">while</span> (tp-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != NULL)
<a name="l01462"></a>01462     tp = tp-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l01463"></a>01463   
<a name="l01464"></a>01464   libmesh_assert (tp != NULL);
<a name="l01465"></a>01465   libmesh_assert (tp-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0);
<a name="l01466"></a>01466 
<a name="l01467"></a>01467   <span class="keywordflow">return</span> tp;  
<a name="l01468"></a>01468 }
<a name="l01469"></a>01469 
<a name="l01470"></a>01470 
<a name="l01471"></a>01471 
<a name="l01472"></a>01472 <span class="keyword">inline</span>
<a name="l01473"></a><a class="code" href="classlibMesh_1_1Elem.php#a71acd72e0de11af46af5dc7409d83951">01473</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a71acd72e0de11af46af5dc7409d83951">Elem::interior_parent</a> ()<span class="keyword"> const</span>
<a name="l01474"></a>01474 <span class="keyword"></span>{
<a name="l01475"></a>01475   <span class="comment">// interior parents make no sense for 3D elements.</span>
<a name="l01476"></a>01476   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>() != 3);
<a name="l01477"></a>01477 
<a name="l01478"></a>01478   <span class="comment">// and they are only good for level-0 elements</span>
<a name="l01479"></a>01479   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() != 0)
<a name="l01480"></a>01480     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a71acd72e0de11af46af5dc7409d83951">interior_parent</a>();
<a name="l01481"></a>01481   
<a name="l01482"></a>01482   <span class="comment">// if we are at level-0 and our parent is not NULL</span>
<a name="l01483"></a>01483   <span class="comment">// then it better be the higher-dimensional </span>
<a name="l01484"></a>01484   <span class="comment">// interior element we are looking for.</span>
<a name="l01485"></a>01485   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a>)
<a name="l01486"></a>01486     libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>() == (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>()+1));
<a name="l01487"></a>01487 
<a name="l01488"></a>01488   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a9a460e237cb1a6d2bb8dc3e70195787a">_parent</a>;
<a name="l01489"></a>01489 }
<a name="l01490"></a>01490 
<a name="l01491"></a>01491 
<a name="l01492"></a>01492 
<a name="l01493"></a>01493 <span class="keyword">inline</span>
<a name="l01494"></a><a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">01494</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">Elem::level</a>()<span class="keyword"> const</span>
<a name="l01495"></a>01495 <span class="keyword"></span>{
<a name="l01496"></a>01496 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01497"></a>01497 <span class="preprocessor"></span>
<a name="l01498"></a>01498   <span class="comment">// if I don&#39;t have a parent I was</span>
<a name="l01499"></a>01499   <span class="comment">// created directly from file</span>
<a name="l01500"></a>01500   <span class="comment">// or by the user, so I am a</span>
<a name="l01501"></a>01501   <span class="comment">// level-0 element</span>
<a name="l01502"></a>01502   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() == NULL)
<a name="l01503"></a>01503     <span class="keywordflow">return</span> 0;
<a name="l01504"></a>01504 
<a name="l01505"></a>01505   <span class="comment">// if the parent and this element are of different</span>
<a name="l01506"></a>01506   <span class="comment">// dimensionality we are at the same level as </span>
<a name="l01507"></a>01507   <span class="comment">// the parent (e.g. we are the 2D side of a </span>
<a name="l01508"></a>01508   <span class="comment">// 3D element)</span>
<a name="l01509"></a>01509   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>() != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>())
<a name="l01510"></a>01510     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>();
<a name="l01511"></a>01511 
<a name="l01512"></a>01512   <span class="comment">// otherwise we are at a level one</span>
<a name="l01513"></a>01513   <span class="comment">// higher than our parent</span>
<a name="l01514"></a>01514   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() + 1);
<a name="l01515"></a>01515 
<a name="l01516"></a>01516 <span class="preprocessor">#else</span>
<a name="l01517"></a>01517 <span class="preprocessor"></span>
<a name="l01518"></a>01518   <span class="comment">// Without AMR all elements are</span>
<a name="l01519"></a>01519   <span class="comment">// at level 0.</span>
<a name="l01520"></a>01520   <span class="keywordflow">return</span> 0;
<a name="l01521"></a>01521   
<a name="l01522"></a>01522 <span class="preprocessor">#endif</span>
<a name="l01523"></a>01523 <span class="preprocessor"></span>}
<a name="l01524"></a>01524 
<a name="l01525"></a>01525 
<a name="l01526"></a>01526 
<a name="l01527"></a>01527 <span class="keyword">inline</span>
<a name="l01528"></a><a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">01528</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">Elem::p_level</a>()<span class="keyword"> const</span>
<a name="l01529"></a>01529 <span class="keyword"></span>{
<a name="l01530"></a>01530 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01531"></a>01531 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a>;
<a name="l01532"></a>01532 <span class="preprocessor">#else</span>
<a name="l01533"></a>01533 <span class="preprocessor"></span>  <span class="keywordflow">return</span> 0;
<a name="l01534"></a>01534 <span class="preprocessor">#endif</span>
<a name="l01535"></a>01535 <span class="preprocessor"></span>}
<a name="l01536"></a>01536 
<a name="l01537"></a>01537 
<a name="l01538"></a>01538 
<a name="l01539"></a>01539 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01540"></a>01540 <span class="preprocessor"></span>
<a name="l01541"></a>01541 <span class="keyword">inline</span>
<a name="l01542"></a><a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">01542</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">Elem::child</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01543"></a>01543 <span class="keyword"></span>{
<a name="l01544"></a>01544   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>    != NULL);
<a name="l01545"></a>01545   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[i] != NULL);
<a name="l01546"></a>01546   
<a name="l01547"></a>01547   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[i];
<a name="l01548"></a>01548 }
<a name="l01549"></a>01549 
<a name="l01550"></a>01550 
<a name="l01551"></a>01551 
<a name="l01552"></a>01552 <span class="keyword">inline</span>
<a name="l01553"></a><a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">01553</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">Elem::which_child_am_i</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)<span class="keyword"> const</span>
<a name="l01554"></a>01554 <span class="keyword"></span>{
<a name="l01555"></a>01555   libmesh_assert (e != NULL);
<a name="l01556"></a>01556   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l01557"></a>01557 
<a name="l01558"></a>01558   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01559"></a>01559     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c) == e)
<a name="l01560"></a>01560       <span class="keywordflow">return</span> c;
<a name="l01561"></a>01561 
<a name="l01562"></a>01562   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  which_child_am_i() was called with a non-child!&quot;</span> 
<a name="l01563"></a>01563                 &lt;&lt; std::endl;
<a name="l01564"></a>01564 
<a name="l01565"></a>01565   libmesh_error();
<a name="l01566"></a>01566 
<a name="l01567"></a>01567   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l01568"></a>01568 }
<a name="l01569"></a>01569 
<a name="l01570"></a>01570 
<a name="l01571"></a>01571 
<a name="l01572"></a>01572 <span class="keyword">inline</span>
<a name="l01573"></a><a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">01573</a> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a> <a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">Elem::refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01574"></a>01574 <span class="keyword"></span>{
<a name="l01575"></a>01575   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1Elem.php#a1be5295de3df06f8cfc0560653124c76">_rflag</a>);
<a name="l01576"></a>01576 }
<a name="l01577"></a>01577 
<a name="l01578"></a>01578 
<a name="l01579"></a>01579 
<a name="l01580"></a>01580 <span class="keyword">inline</span>
<a name="l01581"></a><a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">01581</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">Elem::set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> rflag)
<a name="l01582"></a>01582 {
<a name="l01583"></a>01583 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01584"></a>01584 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (rflag != static_cast&lt;RefinementState&gt;(static_cast&lt;unsigned char&gt;(rflag)))
<a name="l01585"></a>01585     {
<a name="l01586"></a>01586       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: unsigned char too small to hold Elem::_rflag!&quot;</span>
<a name="l01587"></a>01587                     &lt;&lt; std::endl
<a name="l01588"></a>01588                     &lt;&lt; <span class="stringliteral">&quot;Recompile with Elem:_*flag set to something bigger!&quot;</span>
<a name="l01589"></a>01589                     &lt;&lt; std::endl;
<a name="l01590"></a>01590       libmesh_error();
<a name="l01591"></a>01591     }
<a name="l01592"></a>01592 <span class="preprocessor">#endif</span>
<a name="l01593"></a>01593 <span class="preprocessor"></span>
<a name="l01594"></a>01594   <a class="code" href="classlibMesh_1_1Elem.php#a1be5295de3df06f8cfc0560653124c76">_rflag</a> = rflag;
<a name="l01595"></a>01595 }
<a name="l01596"></a>01596 
<a name="l01597"></a>01597 
<a name="l01598"></a>01598 
<a name="l01599"></a>01599 <span class="keyword">inline</span>
<a name="l01600"></a><a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">01600</a> <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a> <a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">Elem::p_refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01601"></a>01601 <span class="keyword"></span>{
<a name="l01602"></a>01602   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1Elem.php#ad3ffad7d497f66f866bd8a6d8d9a3134">_pflag</a>);
<a name="l01603"></a>01603 }
<a name="l01604"></a>01604 
<a name="l01605"></a>01605 
<a name="l01606"></a>01606 
<a name="l01607"></a>01607 <span class="keyword">inline</span>
<a name="l01608"></a><a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">01608</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">Elem::set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">RefinementState</a> pflag)
<a name="l01609"></a>01609 {
<a name="l01610"></a>01610 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01611"></a>01611 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (pflag != static_cast&lt;RefinementState&gt;(static_cast&lt;unsigned char&gt;(pflag)))
<a name="l01612"></a>01612     {
<a name="l01613"></a>01613       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: unsigned char too small to hold Elem::_pflag!&quot;</span>
<a name="l01614"></a>01614                     &lt;&lt; std::endl
<a name="l01615"></a>01615                     &lt;&lt; <span class="stringliteral">&quot;Recompile with Elem:_*flag set to something bigger!&quot;</span>
<a name="l01616"></a>01616                     &lt;&lt; std::endl;
<a name="l01617"></a>01617       libmesh_error();
<a name="l01618"></a>01618     }
<a name="l01619"></a>01619 <span class="preprocessor">#endif</span>
<a name="l01620"></a>01620 <span class="preprocessor"></span>
<a name="l01621"></a>01621   <a class="code" href="classlibMesh_1_1Elem.php#ad3ffad7d497f66f866bd8a6d8d9a3134">_pflag</a> = pflag;
<a name="l01622"></a>01622 }
<a name="l01623"></a>01623 
<a name="l01624"></a>01624 
<a name="l01625"></a>01625 
<a name="l01626"></a>01626 <span class="keyword">inline</span>
<a name="l01627"></a><a class="code" href="classlibMesh_1_1Elem.php#a62f9ba081c33e128f91a413aebcfb554">01627</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a62f9ba081c33e128f91a413aebcfb554">Elem::max_descendant_p_level</a> ()<span class="keyword"> const</span>
<a name="l01628"></a>01628 <span class="keyword"></span>{
<a name="l01629"></a>01629   <span class="comment">// This is undefined for subactive elements,</span>
<a name="l01630"></a>01630   <span class="comment">// which have no active descendants</span>
<a name="l01631"></a>01631   libmesh_assert (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l01632"></a>01632   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01633"></a>01633     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l01634"></a>01634   
<a name="l01635"></a>01635   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_p_level = <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a>;
<a name="l01636"></a>01636   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01637"></a>01637     max_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_p_level,
<a name="l01638"></a>01638                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a62f9ba081c33e128f91a413aebcfb554">max_descendant_p_level</a>());
<a name="l01639"></a>01639   <span class="keywordflow">return</span> max_p_level;
<a name="l01640"></a>01640 }
<a name="l01641"></a>01641 
<a name="l01642"></a>01642 
<a name="l01643"></a>01643 
<a name="l01644"></a>01644 <span class="keyword">inline</span>
<a name="l01645"></a><a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">01645</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">Elem::set_p_level</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l01646"></a>01646 {
<a name="l01647"></a>01647 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01648"></a>01648 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (p != static_cast&lt;unsigned int&gt;(static_cast&lt;unsigned char&gt;(p)))
<a name="l01649"></a>01649     {
<a name="l01650"></a>01650       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: unsigned char too small to hold Elem::_p_level!&quot;</span>
<a name="l01651"></a>01651                     &lt;&lt; std::endl
<a name="l01652"></a>01652                     &lt;&lt; <span class="stringliteral">&quot;Recompile with Elem:_p_level set to something bigger!&quot;</span>
<a name="l01653"></a>01653                     &lt;&lt; std::endl;
<a name="l01654"></a>01654       libmesh_error();
<a name="l01655"></a>01655     }
<a name="l01656"></a>01656 <span class="preprocessor">#endif</span>
<a name="l01657"></a>01657 <span class="preprocessor"></span>
<a name="l01658"></a>01658   <span class="comment">// Maintain the parent&#39;s p level as the minimum of it&#39;s children</span>
<a name="l01659"></a>01659   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != NULL)
<a name="l01660"></a>01660     {
<a name="l01661"></a>01661       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l01662"></a>01662 
<a name="l01663"></a>01663       <span class="comment">// If our new p level is less than our parents, our parents drops</span>
<a name="l01664"></a>01664       <span class="keywordflow">if</span> (parent_p_level &gt; p)
<a name="l01665"></a>01665         {
<a name="l01666"></a>01666           this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(p);
<a name="l01667"></a>01667         }
<a name="l01668"></a>01668       <span class="comment">// If we are the lowest p level and it increases, so might</span>
<a name="l01669"></a>01669       <span class="comment">// our parent&#39;s, but we have to check every other child to see</span>
<a name="l01670"></a>01670       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (parent_p_level == <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a> &amp;&amp; <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a> &lt; p)
<a name="l01671"></a>01671         {
<a name="l01672"></a>01672           <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a> = p;
<a name="l01673"></a>01673           parent_p_level = p;
<a name="l01674"></a>01674           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01675"></a>01675             parent_p_level = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(parent_p_level,
<a name="l01676"></a>01676                                       this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01677"></a>01677 
<a name="l01678"></a>01678           <span class="keywordflow">if</span> (parent_p_level != this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>())
<a name="l01679"></a>01679             this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(parent_p_level);
<a name="l01680"></a>01680 
<a name="l01681"></a>01681           <span class="keywordflow">return</span>;
<a name="l01682"></a>01682         }
<a name="l01683"></a>01683     }
<a name="l01684"></a>01684 
<a name="l01685"></a>01685   <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a> = p;
<a name="l01686"></a>01686 }
<a name="l01687"></a>01687 
<a name="l01688"></a>01688 
<a name="l01689"></a>01689 
<a name="l01690"></a>01690 <span class="keyword">inline</span>
<a name="l01691"></a><a class="code" href="classlibMesh_1_1Elem.php#a439bf8e694aaca274598b42d6c7faf9d">01691</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a439bf8e694aaca274598b42d6c7faf9d">Elem::hack_p_level</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l01692"></a>01692 {
<a name="l01693"></a>01693   <a class="code" href="classlibMesh_1_1Elem.php#ab497f6182b768689af5eb915cd2c818a">_p_level</a> = p;
<a name="l01694"></a>01694 }
<a name="l01695"></a>01695 
<a name="l01696"></a>01696 
<a name="l01697"></a>01697 
<a name="l01698"></a>01698 <span class="preprocessor">#endif </span><span class="comment">/* ifdef LIBMESH_ENABLE_AMR */</span>
<a name="l01699"></a>01699 
<a name="l01700"></a>01700 
<a name="l01701"></a>01701 <span class="keyword">inline</span>
<a name="l01702"></a><a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">01702</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0)
<a name="l01703"></a>01703 {
<a name="l01704"></a>01704   <span class="keywordflow">return</span> n0;
<a name="l01705"></a>01705 }
<a name="l01706"></a>01706 
<a name="l01707"></a>01707 
<a name="l01708"></a>01708 
<a name="l01709"></a>01709 <span class="keyword">inline</span>
<a name="l01710"></a><a class="code" href="classlibMesh_1_1Elem.php#a684a2879faf97350e6e36a5822c5f6c9">01710</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01711"></a>01711                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1)
<a name="l01712"></a>01712 {
<a name="l01713"></a>01713   <span class="comment">// big prime number</span>
<a name="l01714"></a>01714   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp = 65449;
<a name="l01715"></a>01715   
<a name="l01716"></a>01716   <span class="comment">// Order the two so that n0 &lt; n1</span>
<a name="l01717"></a>01717   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01718"></a>01718 
<a name="l01719"></a>01719   <span class="keywordflow">return</span> (n0%bp + (n1&lt;&lt;5)%bp);  
<a name="l01720"></a>01720 }
<a name="l01721"></a>01721 
<a name="l01722"></a>01722 
<a name="l01723"></a>01723 
<a name="l01724"></a>01724 <span class="keyword">inline</span>
<a name="l01725"></a><a class="code" href="classlibMesh_1_1Elem.php#ad5ea0067321389506c4c960d224e3a24">01725</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01726"></a>01726                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l01727"></a>01727                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2)
<a name="l01728"></a>01728 {
<a name="l01729"></a>01729   <span class="comment">// big prime number</span>
<a name="l01730"></a>01730   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp = 65449;
<a name="l01731"></a>01731 
<a name="l01732"></a>01732   <span class="comment">// Order the numbers such that n0 &lt; n1 &lt; n2.</span>
<a name="l01733"></a>01733   <span class="comment">// We&#39;ll do it in 3 steps like this:</span>
<a name="l01734"></a>01734   <span class="comment">//</span>
<a name="l01735"></a>01735   <span class="comment">//     n0         n1                n2</span>
<a name="l01736"></a>01736   <span class="comment">//     min(n0,n1) max(n0,n1)        n2</span>
<a name="l01737"></a>01737   <span class="comment">//     min(n0,n1) min(n2,max(n0,n1) max(n2,max(n0,n1)</span>
<a name="l01738"></a>01738   <span class="comment">//           |\   /|                  |</span>
<a name="l01739"></a>01739   <span class="comment">//           | \ / |                  |</span>
<a name="l01740"></a>01740   <span class="comment">//           |  /  |                  |</span>
<a name="l01741"></a>01741   <span class="comment">//           | /  \|                  |</span>
<a name="l01742"></a>01742   <span class="comment">//  gb min= min   max              gb max</span>
<a name="l01743"></a>01743 
<a name="l01744"></a>01744 
<a name="l01745"></a>01745 
<a name="l01746"></a>01746   <span class="comment">// Step 1</span>
<a name="l01747"></a>01747   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01748"></a>01748 
<a name="l01749"></a>01749   <span class="comment">// Step 2</span>
<a name="l01750"></a>01750   <span class="keywordflow">if</span> (n1 &gt; n2) std::swap (n1, n2);
<a name="l01751"></a>01751 
<a name="l01752"></a>01752   <span class="comment">// Step 3</span>
<a name="l01753"></a>01753   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01754"></a>01754 
<a name="l01755"></a>01755   libmesh_assert ((n0 &lt; n1) &amp;&amp; (n1 &lt; n2));
<a name="l01756"></a>01756 
<a name="l01757"></a>01757   
<a name="l01758"></a>01758   <span class="keywordflow">return</span> (n0%bp + (n1&lt;&lt;5)%bp + (n2&lt;&lt;10)%bp);
<a name="l01759"></a>01759 }
<a name="l01760"></a>01760 
<a name="l01761"></a>01761 
<a name="l01762"></a>01762 
<a name="l01763"></a>01763 <span class="keyword">inline</span>
<a name="l01764"></a><a class="code" href="classlibMesh_1_1Elem.php#a4a6a9355e2052b0e6bff16f5c46f6ebe">01764</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0,
<a name="l01765"></a>01765                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1,
<a name="l01766"></a>01766                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2,
<a name="l01767"></a>01767                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n3)
<a name="l01768"></a>01768 {
<a name="l01769"></a>01769   <span class="comment">// big prime number</span>
<a name="l01770"></a>01770   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp = 65449;
<a name="l01771"></a>01771 
<a name="l01772"></a>01772   <span class="comment">// Step 1</span>
<a name="l01773"></a>01773   <span class="keywordflow">if</span> (n0 &gt; n1) std::swap (n0, n1);
<a name="l01774"></a>01774 
<a name="l01775"></a>01775   <span class="comment">// Step 2</span>
<a name="l01776"></a>01776   <span class="keywordflow">if</span> (n2 &gt; n3) std::swap (n2, n3);
<a name="l01777"></a>01777 
<a name="l01778"></a>01778   <span class="comment">// Step 3</span>
<a name="l01779"></a>01779   <span class="keywordflow">if</span> (n0 &gt; n2) std::swap (n0, n2);
<a name="l01780"></a>01780 
<a name="l01781"></a>01781   <span class="comment">// Step 4</span>
<a name="l01782"></a>01782   <span class="keywordflow">if</span> (n1 &gt; n3) std::swap (n1, n3);
<a name="l01783"></a>01783 
<a name="l01784"></a>01784   <span class="comment">// Finally step 5</span>
<a name="l01785"></a>01785   <span class="keywordflow">if</span> (n1 &gt; n2) std::swap (n1, n2);
<a name="l01786"></a>01786 
<a name="l01787"></a>01787   libmesh_assert ((n0 &lt; n1) &amp;&amp; (n1 &lt; n2) &amp;&amp; (n2 &lt; n3));
<a name="l01788"></a>01788   
<a name="l01789"></a>01789   <span class="keywordflow">return</span> (n0%bp + (n1&lt;&lt;5)%bp + (n2&lt;&lt;10)%bp + (n3&lt;&lt;15)%bp);
<a name="l01790"></a>01790 }
<a name="l01791"></a>01791 
<a name="l01792"></a>01792 
<a name="l01793"></a>01793 
<a name="l01794"></a>01794 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l01803"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php">01803</a> <span class="comment"></span><span class="keyword">class </span><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php">Elem::PackedElem</a>
<a name="l01804"></a>01804 {
<a name="l01805"></a>01805 <span class="keyword">private</span>:
<a name="l01806"></a>01806     
<a name="l01810"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">01810</a>   <span class="keyword">const</span> std::vector&lt;int&gt;::const_iterator <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>;
<a name="l01811"></a>01811 
<a name="l01812"></a>01812 <span class="keyword">public</span>:
<a name="l01813"></a>01813 
<a name="l01818"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a088e4b1b215eb8addc7cb8bd57088d25">01818</a>   <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a088e4b1b215eb8addc7cb8bd57088d25">PackedElem</a> (<span class="keyword">const</span> std::vector&lt;int&gt;::const_iterator _buf_in) :
<a name="l01819"></a>01819     <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>(_buf_in)
<a name="l01820"></a>01820   {}
<a name="l01821"></a>01821     
<a name="l01826"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">01826</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">header_size</a>; <span class="comment">/* = 10 with AMR, 4 without */</span>
<a name="l01827"></a>01827     
<a name="l01834"></a>01834   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">pack</a> (std::vector&lt;int&gt; &amp;conn, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);    
<a name="l01835"></a>01835 
<a name="l01841"></a>01841   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af61ecf6a8d276b513691e4dfa6a0fba0">unpack</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a> = NULL) <span class="keyword">const</span>;
<a name="l01842"></a>01842 
<a name="l01846"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af2667afc7eefc2d1ff36a63884c3e664">01846</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af2667afc7eefc2d1ff36a63884c3e664">level</a> ()<span class="keyword"> const</span>
<a name="l01847"></a>01847 <span class="keyword">  </span>{
<a name="l01848"></a>01848     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*_buf_begin);
<a name="l01849"></a>01849   }
<a name="l01850"></a>01850 
<a name="l01854"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aa431f7c144212c23fa5d0ab1ae67be41">01854</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aa431f7c144212c23fa5d0ab1ae67be41">p_level</a> ()<span class="keyword"> const</span>
<a name="l01855"></a>01855 <span class="keyword">  </span>{
<a name="l01856"></a>01856     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+1));
<a name="l01857"></a>01857   }
<a name="l01858"></a>01858 
<a name="l01859"></a>01859 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01860"></a>01860 <span class="preprocessor"></span>
<a name="l01863"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a07e3f4ace954129b44b561eeb72b17cd">01863</a>   <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a07e3f4ace954129b44b561eeb72b17cd">refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01864"></a>01864 <span class="keyword">  </span>{
<a name="l01865"></a>01865     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+2));
<a name="l01866"></a>01866   }
<a name="l01867"></a>01867 
<a name="l01871"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a1d67dbcd0f0b9364e579e8cd49c7c410">01871</a>   <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a1d67dbcd0f0b9364e579e8cd49c7c410">p_refinement_flag</a> ()<span class="keyword"> const</span>
<a name="l01872"></a>01872 <span class="keyword">  </span>{
<a name="l01873"></a>01873     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54">Elem::RefinementState</a><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+3));
<a name="l01874"></a>01874   }
<a name="l01875"></a>01875 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01876"></a>01876 <span class="preprocessor"></span>
<a name="l01880"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a853ff9f24ee9472b22101a001acd1223">01880</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a853ff9f24ee9472b22101a001acd1223">type</a> ()<span class="keyword"> const</span>
<a name="l01881"></a>01881 <span class="keyword">  </span>{
<a name="l01882"></a>01882     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+4));
<a name="l01883"></a>01883   }
<a name="l01884"></a>01884 
<a name="l01888"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aecc569e41a6d040d7ec4c38a0ce6bc38">01888</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aecc569e41a6d040d7ec4c38a0ce6bc38">processor_id</a> ()<span class="keyword"> const</span>
<a name="l01889"></a>01889 <span class="keyword">  </span>{
<a name="l01890"></a>01890     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+5));
<a name="l01891"></a>01891   }
<a name="l01892"></a>01892 
<a name="l01896"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a6a7046b867293db15220ec0a678baa18">01896</a>   <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a6a7046b867293db15220ec0a678baa18">subdomain_id</a> ()<span class="keyword"> const</span>
<a name="l01897"></a>01897 <span class="keyword">  </span>{
<a name="l01898"></a>01898     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+6));
<a name="l01899"></a>01899   }
<a name="l01900"></a>01900 
<a name="l01904"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aa55eefbffccc143c6be5d6cfa5de3910">01904</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aa55eefbffccc143c6be5d6cfa5de3910">id</a> ()<span class="keyword"> const</span>
<a name="l01905"></a>01905 <span class="keyword">  </span>{
<a name="l01906"></a>01906     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+7));
<a name="l01907"></a>01907   }
<a name="l01908"></a>01908 
<a name="l01912"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0a3300ce8670ff95629056f33583b444">01912</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0a3300ce8670ff95629056f33583b444">parent_id</a> ()<span class="keyword"> const</span>
<a name="l01913"></a>01913 <span class="keyword">  </span>{
<a name="l01914"></a>01914     <span class="keywordflow">return</span> *(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+8);
<a name="l01915"></a>01915   }
<a name="l01916"></a>01916 
<a name="l01920"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a7ff4a7d9a84ee6e47a519d9af9654751">01920</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a7ff4a7d9a84ee6e47a519d9af9654751">which_child_am_i</a> ()<span class="keyword"> const</span>
<a name="l01921"></a>01921 <span class="keyword">  </span>{
<a name="l01922"></a>01922     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+9));
<a name="l01923"></a>01923   }
<a name="l01924"></a>01924     
<a name="l01928"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a34fad412441c5fbbc3fe4fba61375a5e">01928</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a34fad412441c5fbbc3fe4fba61375a5e">n_nodes</a> ()<span class="keyword"> const</span>
<a name="l01929"></a>01929 <span class="keyword">  </span>{
<a name="l01930"></a>01930     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a1a76b7c00bdaac5d0a245ec42d1e0576">Elem::type_to_n_nodes_map</a>[this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a853ff9f24ee9472b22101a001acd1223">type</a>()];
<a name="l01931"></a>01931   }
<a name="l01932"></a>01932 
<a name="l01936"></a><a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a8da208db57dd40c5d3308bc6fb44f4b5">01936</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a8da208db57dd40c5d3308bc6fb44f4b5">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l01937"></a>01937 <span class="keyword">  </span>{
<a name="l01938"></a>01938     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(*(<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#af13624f601f1296e1e11b91639963294">_buf_begin</a>+10+n));
<a name="l01939"></a>01939   }    
<a name="l01940"></a>01940 }; <span class="comment">// end class PackedElem</span>
<a name="l01941"></a>01941 
<a name="l01942"></a>01942 
<a name="l01946"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">01946</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">Elem::SideIter</a>
<a name="l01947"></a>01947 {
<a name="l01948"></a>01948 <span class="keyword">public</span>:
<a name="l01949"></a>01949   <span class="comment">// Constructor with arguments.</span>
<a name="l01950"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#affdbd63cf626eb846551b56573502b88">01950</a>   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a1006a7c1b73323d96a4dc4ad43048e0d">SideIter</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side_number,
<a name="l01951"></a>01951            <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>)
<a name="l01952"></a>01952     : <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>(side_number),
<a name="l01953"></a>01953       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">_side</a>(),
<a name="l01954"></a>01954       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">_side_ptr</a>(NULL),
<a name="l01955"></a>01955       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>(parent)
<a name="l01956"></a>01956   {}
<a name="l01957"></a>01957 
<a name="l01958"></a>01958     
<a name="l01959"></a>01959   <span class="comment">// Empty constructor.</span>
<a name="l01960"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a1006a7c1b73323d96a4dc4ad43048e0d">01960</a>   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a1006a7c1b73323d96a4dc4ad43048e0d">SideIter</a>()
<a name="l01961"></a>01961     : <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l01962"></a>01962       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">_side</a>(),
<a name="l01963"></a>01963       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">_side_ptr</a>(NULL),
<a name="l01964"></a>01964       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>(NULL)
<a name="l01965"></a>01965   {}
<a name="l01966"></a>01966 
<a name="l01967"></a>01967 
<a name="l01968"></a>01968   <span class="comment">// Copy constructor</span>
<a name="l01969"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#aee6e22258e00981edc26328d6f1f35ae">01969</a>   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a1006a7c1b73323d96a4dc4ad43048e0d">SideIter</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>&amp; other)
<a name="l01970"></a>01970     : <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>(other.<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>),
<a name="l01971"></a>01971       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">_side</a>(),
<a name="l01972"></a>01972       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">_side_ptr</a>(NULL),
<a name="l01973"></a>01973       <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>(other.<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>)
<a name="l01974"></a>01974   {}
<a name="l01975"></a>01975 
<a name="l01976"></a>01976 
<a name="l01977"></a>01977   <span class="comment">// op=</span>
<a name="l01978"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a399fb3a267031c24fe9441228409ff81">01978</a>   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>&amp; <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a399fb3a267031c24fe9441228409ff81">operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>&amp; other)
<a name="l01979"></a>01979   {
<a name="l01980"></a>01980     this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a> = other.<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>;
<a name="l01981"></a>01981     this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>      = other.<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>;
<a name="l01982"></a>01982     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l01983"></a>01983   }
<a name="l01984"></a>01984 
<a name="l01985"></a>01985   <span class="comment">// unary op*</span>
<a name="l01986"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a8359ee94fc7c579fa671f70c1dcac814">01986</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&amp; <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a8359ee94fc7c579fa671f70c1dcac814">operator*</a>()<span class="keyword"> const</span>
<a name="l01987"></a>01987 <span class="keyword">  </span>{
<a name="l01988"></a>01988     <span class="comment">// Set the AutoPtr</span>
<a name="l01989"></a>01989     this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a8fad21a66e9fe5b0116da928c8496a7b">_update_side_ptr</a>();
<a name="l01990"></a>01990 
<a name="l01991"></a>01991     <span class="comment">// Return a reference to _side_ptr</span>
<a name="l01992"></a>01992     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">_side_ptr</a>;
<a name="l01993"></a>01993   }
<a name="l01994"></a>01994 
<a name="l01995"></a>01995   <span class="comment">// op++</span>
<a name="l01996"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ac515842767bdeeeb1cc3003df6e17085">01996</a>   <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>&amp; <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ac515842767bdeeeb1cc3003df6e17085">operator++</a>()
<a name="l01997"></a>01997   {
<a name="l01998"></a>01998     ++<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>;
<a name="l01999"></a>01999     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l02000"></a>02000   }
<a name="l02001"></a>02001   
<a name="l02002"></a>02002   <span class="comment">// op==  Two side iterators are equal if they have</span>
<a name="l02003"></a>02003   <span class="comment">// the same side number and the same parent element.</span>
<a name="l02004"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#aaf58c97872dbfa3fa7dc9c2d6b7fd644">02004</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#aaf58c97872dbfa3fa7dc9c2d6b7fd644">operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>&amp; other)<span class="keyword"> const</span>
<a name="l02005"></a>02005 <span class="keyword">  </span>{
<a name="l02006"></a>02006     <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a> == other.<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a> &amp;&amp;
<a name="l02007"></a>02007             this-&gt;_parent      == other.<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>);
<a name="l02008"></a>02008   }
<a name="l02009"></a>02009 
<a name="l02010"></a>02010 
<a name="l02011"></a>02011   <span class="comment">// Consults the parent Elem to determine if the side</span>
<a name="l02012"></a>02012   <span class="comment">// is a boundary side.  Note: currently side N is a</span>
<a name="l02013"></a>02013   <span class="comment">// boundary side if nieghbor N is NULL.  Be careful,</span>
<a name="l02014"></a>02014   <span class="comment">// this could possibly change in the future?</span>
<a name="l02015"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a61cd9a395bfca5ee4c3c5023670d2b01">02015</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a61cd9a395bfca5ee4c3c5023670d2b01">side_on_boundary</a>()<span class="keyword"> const</span>
<a name="l02016"></a>02016 <span class="keyword">  </span>{
<a name="l02017"></a>02017     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>) == NULL;
<a name="l02018"></a>02018   }
<a name="l02019"></a>02019     
<a name="l02020"></a>02020 <span class="keyword">private</span>:
<a name="l02021"></a>02021   <span class="comment">// Update the _side pointer by building the correct side.</span>
<a name="l02022"></a>02022   <span class="comment">// This has to be called before dereferencing.</span>
<a name="l02023"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a8fad21a66e9fe5b0116da928c8496a7b">02023</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a8fad21a66e9fe5b0116da928c8496a7b">_update_side_ptr</a>()<span class="keyword"> const</span>
<a name="l02024"></a>02024 <span class="keyword">  </span>{
<a name="l02025"></a>02025     <span class="comment">// Construct new side, store in AutoPtr</span>
<a name="l02026"></a>02026     this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">_side</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>);
<a name="l02027"></a>02027 
<a name="l02028"></a>02028     <span class="comment">// Also set our internal naked pointer.  Memory is still owned</span>
<a name="l02029"></a>02029     <span class="comment">// by the AutoPtr.</span>
<a name="l02030"></a>02030     this-&gt;<a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">_side_ptr</a> = <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">_side</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l02031"></a>02031   }
<a name="l02032"></a>02032     
<a name="l02033"></a>02033   <span class="comment">// A counter variable which keeps track of the side number</span>
<a name="l02034"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">02034</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a80ea6b61dd88dc15a5243fffb6631368">_side_number</a>;
<a name="l02035"></a>02035     
<a name="l02036"></a>02036   <span class="comment">// AutoPtr to the actual side, handles memory management for</span>
<a name="l02037"></a>02037   <span class="comment">// the sides which are created during the course of iteration.</span>
<a name="l02038"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">02038</a>   <span class="keyword">mutable</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a345d956fa8f17707a1ca4fc56071b8a4">_side</a>;
<a name="l02039"></a>02039 
<a name="l02040"></a>02040   <span class="comment">// Raw pointer needed to facilitate passing back to the user a</span>
<a name="l02041"></a>02041   <span class="comment">// reference to a non-temporary raw pointer in order to conform to</span>
<a name="l02042"></a>02042   <span class="comment">// the variant_filter_iterator interface.  It points to the same</span>
<a name="l02043"></a>02043   <span class="comment">// thing the AutoPtr &quot;_side&quot; above holds.  What happens if the user</span>
<a name="l02044"></a>02044   <span class="comment">// calls delete on the pointer passed back?  Well, this is an issue</span>
<a name="l02045"></a>02045   <span class="comment">// which is not addressed by the iterators in libMesh.  Basically it</span>
<a name="l02046"></a>02046   <span class="comment">// is a bad idea to ever call delete on an iterator from the library.</span>
<a name="l02047"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">02047</a>   <span class="keyword">mutable</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#ad0288d3f11382ebf673191c9308e763f">_side_ptr</a>;
<a name="l02048"></a>02048   
<a name="l02049"></a>02049   <span class="comment">// Pointer to the parent Elem class which generated this iterator</span>
<a name="l02050"></a><a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">02050</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php#a884752fe628048a4815cbbc406a4b18a">_parent</a>;
<a name="l02051"></a>02051 
<a name="l02052"></a>02052 };
<a name="l02053"></a>02053 
<a name="l02054"></a>02054 
<a name="l02055"></a>02055 
<a name="l02056"></a>02056 
<a name="l02057"></a>02057 
<a name="l02058"></a>02058 
<a name="l02059"></a>02059 <span class="comment">// Private implementation functions in the Elem class for the side iterators.</span>
<a name="l02060"></a>02060 <span class="comment">// They have to come after the definition of the SideIter class.</span>
<a name="l02061"></a>02061 <span class="keyword">inline</span>
<a name="l02062"></a><a class="code" href="classlibMesh_1_1Elem.php#a579b6b2edb461eba4790658149c36b0a">02062</a> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">Elem::SideIter</a> <a class="code" href="classlibMesh_1_1Elem.php#a579b6b2edb461eba4790658149c36b0a">Elem::_first_side</a>()
<a name="l02063"></a>02063 {
<a name="l02064"></a>02064   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>(0, <span class="keyword">this</span>);
<a name="l02065"></a>02065 }
<a name="l02066"></a>02066 
<a name="l02067"></a>02067 
<a name="l02068"></a>02068 
<a name="l02069"></a>02069 <span class="keyword">inline</span>
<a name="l02070"></a><a class="code" href="classlibMesh_1_1Elem.php#a40fb5e7605af6abe9ebbffc47bb7f982">02070</a> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">Elem::SideIter</a> <a class="code" href="classlibMesh_1_1Elem.php#a40fb5e7605af6abe9ebbffc47bb7f982">Elem::_last_side</a>()
<a name="l02071"></a>02071 {
<a name="l02072"></a>02072   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem_1_1SideIter.php">SideIter</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(), <span class="keyword">this</span>);
<a name="l02073"></a>02073 }
<a name="l02074"></a>02074                                 
<a name="l02075"></a>02075 
<a name="l02076"></a>02076 
<a name="l02077"></a>02077 
<a name="l02081"></a><a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">02081</a> <span class="keyword">struct</span>
<a name="l02082"></a>02082 <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">Elem::side_iterator</a> :
<a name="l02083"></a>02083 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1Elem.php#a99bb1c1db96162c43f76472122cb2447">Elem::Predicate</a>,
<a name="l02084"></a>02084                         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;
<a name="l02085"></a>02085 {
<a name="l02086"></a>02086   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l02087"></a>02087   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l02088"></a><a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php#a7be58d68e30bede26bc250d829bd5a6c">02088</a>   <a class="code" href="structlibMesh_1_1Elem_1_1side__iterator.php">side_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l02089"></a>02089                  <span class="keyword">const</span> IterType&amp; e,
<a name="l02090"></a>02090                  <span class="keyword">const</span> PredType&amp; p ) :
<a name="l02091"></a>02091     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>::<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l02092"></a>02092                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;(d,e,p) {}
<a name="l02093"></a>02093 };
<a name="l02094"></a>02094 
<a name="l02095"></a>02095 
<a name="l02096"></a>02096 
<a name="l02097"></a>02097 } <span class="comment">// namespace libMesh</span>
<a name="l02098"></a>02098 
<a name="l02099"></a>02099 
<a name="l02100"></a>02100 <span class="preprocessor">#endif // end #ifndef __elem_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
