<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exodusII_io_helper.C</div>  </div>
</div>
<div class="contents">
<a href="exodusII__io__helper_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exodusII_io_helper.C 4390 2011-04-21 17:02:25Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io__helper_8h.php">exodusII_io_helper.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;functional&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>  <span class="comment">// for elem_types warning</span>
<a name="l00039"></a>00039 <span class="preprocessor">#endif</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// ExodusII_IO_Helper::ElementMaps static data</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// 2D node map definitions</span>
<a name="l00048"></a>00048 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a2870f647fb9cf8067b123a656fb298b7">ExodusII_IO_Helper::ElementMaps::quad4_node_map</a>[4] = {0, 1, 2, 3};
<a name="l00049"></a>00049 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a664cbf81ae7ae5d7ea5c7b25b60577da">ExodusII_IO_Helper::ElementMaps::quad8_node_map</a>[8] = {0, 1, 2, 3, 4, 5, 6, 7};
<a name="l00050"></a>00050 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a6a0bf36799281222a5359235f3f92317">ExodusII_IO_Helper::ElementMaps::quad9_node_map</a>[9] = {0, 1, 2, 3, 4, 5, 6, 7, 8};
<a name="l00051"></a>00051 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ac4b7cb17e2a382a1d7a2db31ebde633e">ExodusII_IO_Helper::ElementMaps::tri3_node_map</a>[3]  = {0, 1, 2};
<a name="l00052"></a>00052 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a546f688825c1495d1dd6908802f3fdd3">ExodusII_IO_Helper::ElementMaps::tri6_node_map</a>[6]  = {0, 1, 2, 3, 4, 5};
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// 2D edge map definitions</span>
<a name="l00055"></a>00055 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9bf1c63066228938dea776e174cc7169">ExodusII_IO_Helper::ElementMaps::tri_edge_map</a>[3] = {0, 1, 2};
<a name="l00056"></a>00056 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#acaac6c3168c06642cff460091ed478dc">ExodusII_IO_Helper::ElementMaps::quad_edge_map</a>[4] = {0, 1, 2, 3};
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="comment">//These take a libMesh ID and turn it into an Exodus ID</span>
<a name="l00059"></a>00059 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a48fa958b2be407467f9c2cae59f22af3">ExodusII_IO_Helper::ElementMaps::tri_inverse_edge_map</a>[3] = {1, 2, 3};
<a name="l00060"></a>00060 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a54fdb2a067b3ffe561810345a36f9d3d">ExodusII_IO_Helper::ElementMaps::quad_inverse_edge_map</a>[4] = {1, 2, 3, 4};
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="comment">// 3D node map definitions</span>
<a name="l00063"></a>00063 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#abf85deeb6b00664d04fc0c32617be8bb">ExodusII_IO_Helper::ElementMaps::hex8_node_map</a>[8]   = {0, 1, 2, 3, 4, 5, 6, 7};
<a name="l00064"></a>00064 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aa8673162a0c07eef68c19fdcf3bdb635">ExodusII_IO_Helper::ElementMaps::hex20_node_map</a>[20] = { 0,  1,  2,  3,  4,  5,  6,  7,  8,  9,
<a name="l00065"></a>00065                                                         10, 11, 12, 13, 14, 15, 16, 17, 18, 19};  
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 <span class="comment">// Perhaps an older Hex27 node numbering?  This no longer works.</span>
<a name="l00068"></a>00068 <span class="comment">//const int ExodusII_IO_Helper::ElementMaps::hex27_node_map[27] = { 1,  5,  6,  2,  0,  4,  7,  3, 13, 17, 14,  9,  8, 16,</span>
<a name="l00069"></a>00069 <span class="comment">//                                                        18, 10, 12, 19, 15, 11, 24, 25, 22, 26, 21, 23, 20};</span>
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">//DRG: Using the newest exodus documentation available on sourceforge and using Table 2 to see</span>
<a name="l00072"></a>00072 <span class="comment">// where all of the nodes over 21 are supposed to go... we come up with:</span>
<a name="l00073"></a>00073 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9b0ebeecb2654e7eca0c144e0bb954f5">ExodusII_IO_Helper::ElementMaps::hex27_node_map</a>[27] = {
<a name="l00074"></a>00074   <span class="comment">// Vertex and mid-edge nodes</span>
<a name="l00075"></a>00075   0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
<a name="l00076"></a>00076   <span class="comment">// Mid-face nodes and centroid</span>
<a name="l00077"></a>00077   21, 25, 24, 26, 23, 22, 20};
<a name="l00078"></a>00078 <span class="comment">//20  21  22  23  24  25  26 // LibMesh indices</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aee9a6d6f6f2b26b9aff4f6fb71c06c8e">ExodusII_IO_Helper::ElementMaps::tet4_node_map</a>[4]   = {0, 1, 2, 3};
<a name="l00082"></a>00082 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a0f1436239fbf2f3aea47b86edc061c9d">ExodusII_IO_Helper::ElementMaps::tet10_node_map</a>[10] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a698dae2bf356b77c06a3bd7a7fdec15c">ExodusII_IO_Helper::ElementMaps::prism6_node_map</a>[6]   = {0, 1, 2, 3, 4, 5};
<a name="l00085"></a>00085 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad2c7741704ca99e07020a05bf8b9c0da">ExodusII_IO_Helper::ElementMaps::prism15_node_map</a>[15]   = {0, 1, 2, 3, 4, 5, 6,  7,  8,  9,
<a name="l00086"></a>00086                                                                      10, 11, 12, 13, 14};
<a name="l00087"></a>00087 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aecf1db695384ae0219d811cc89c83721">ExodusII_IO_Helper::ElementMaps::prism18_node_map</a>[18]   = {0, 1, 2, 3, 4, 5, 6,  7,  8,  9,
<a name="l00088"></a>00088                                                                      10, 11, 12, 13, 14, 15, 16, 17};
<a name="l00089"></a>00089 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#aaac4d726f9b34350e58697fd8ba00e20">ExodusII_IO_Helper::ElementMaps::pyramid5_node_map</a>[5] = {0, 1, 2, 3, 4};
<a name="l00090"></a>00090   
<a name="l00091"></a>00091 <span class="comment">// 3D face map definitions</span>
<a name="l00092"></a>00092 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a99f3976a164b16f2718c256967fe5c73">ExodusII_IO_Helper::ElementMaps::tet_face_map</a>[4]     = {1, 2, 3, 0};
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a7477ab19a4ff910fe0c60e5287ccff7f">ExodusII_IO_Helper::ElementMaps::hex_face_map</a>[6]     = {1, 2, 3, 4, 0, 5};
<a name="l00095"></a>00095 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#afb111b9e150f58656c5f252dfe9ebe99">ExodusII_IO_Helper::ElementMaps::hex27_face_map</a>[6]   = {1, 2, 3, 4, 0, 5};
<a name="l00096"></a>00096 <span class="comment">//const int ExodusII_IO_Helper::ElementMaps::hex27_face_map[6]   = {1, 0, 3, 5, 4, 2};</span>
<a name="l00097"></a>00097 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a3386e0d61e879f044524b9a1809f295b">ExodusII_IO_Helper::ElementMaps::prism_face_map</a>[5]   = {1, 2, 3, 0, 4};
<a name="l00098"></a>00098 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a54f7bdc9cf01417b9e850f6a83981c44">ExodusII_IO_Helper::ElementMaps::pyramid_face_map</a>[5] = {-1,-1,-1,-1,-1}; <span class="comment">// Not Implemented!</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="comment">//These take a libMesh ID and turn it into an Exodus ID</span>
<a name="l00101"></a>00101 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9873e92bc25eed6c717554f22818c135">ExodusII_IO_Helper::ElementMaps::tet_inverse_face_map</a>[4]     = {4, 1, 2, 3};
<a name="l00102"></a>00102 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#af46b0ab31cce8bfac7567594055bb854">ExodusII_IO_Helper::ElementMaps::hex_inverse_face_map</a>[6]     = {5, 1, 2, 3, 4, 6};
<a name="l00103"></a>00103 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ab3375c6bc4a77b49392a510822f9bd0c">ExodusII_IO_Helper::ElementMaps::hex27_inverse_face_map</a>[6]   = {5, 1, 2, 3, 4, 6};
<a name="l00104"></a>00104 <span class="comment">//const int ExodusII_IO_Helper::ElementMaps::hex27_inverse_face_map[6]   = {2, 1, 6, 3, 5, 4};</span>
<a name="l00105"></a>00105 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9f9e1e8c254843eab5c87d1110af9ccc">ExodusII_IO_Helper::ElementMaps::prism_inverse_face_map</a>[5]   = {4, 1, 2, 3, 5};
<a name="l00106"></a>00106 <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a459d91f313598316ccf70a2a29540f3f">ExodusII_IO_Helper::ElementMaps::pyramid_inverse_face_map</a>[5] = {-1,-1,-1,-1,-1}; <span class="comment">// Not Implemented!</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00110"></a>00110 <span class="comment">// ExodusII_IO_Helper class members</span>
<a name="l00111"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6781af765e39e49c9a244ea6628ad82d">00111</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6781af765e39e49c9a244ea6628ad82d">ExodusII_IO_Helper::~ExodusII_IO_Helper</a>()
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">00115</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">ExodusII_IO_Helper::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a> = set_verbosity;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">00122</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">ExodusII_IO_Helper::check_err</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">err</a>, <span class="keyword">const</span> std::string msg)
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   <span class="keywordflow">if</span> (err &lt; 0)
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; msg &lt;&lt; std::endl;
<a name="l00127"></a>00127       libmesh_error();
<a name="l00128"></a>00128     }
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">00133</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">ExodusII_IO_Helper::message</a>(<span class="keyword">const</span> std::string msg)
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>) <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; msg &lt;&lt; std::endl;
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1e38212a0e9d854b02a8dc9518c3b57c">00140</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">ExodusII_IO_Helper::message</a>(<span class="keyword">const</span> std::string msg, <span class="keywordtype">int</span> i)
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>) <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; msg &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;.&quot;</span> &lt;&lt; std::endl;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9bf6deacca92641b0d30d7749a06b887">00147</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9bf6deacca92641b0d30d7749a06b887">ExodusII_IO_Helper::open</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* filename)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a> = exII::ex_open(filename,
<a name="l00150"></a>00150                         EX_READ,
<a name="l00151"></a>00151                         &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0f5eb2c6a0d73df24a4ce5881af78e3e">comp_ws</a>,
<a name="l00152"></a>00152                         &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae89fbfcc501d91752083448eb1fb61db">io_ws</a>,
<a name="l00153"></a>00153                         &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e6a3bc8a3051c8ceb787e82d2218322">ex_version</a>);
<a name="l00154"></a>00154   
<a name="l00155"></a>00155   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <span class="stringliteral">&quot;Error opening ExodusII mesh file.&quot;</span>);
<a name="l00156"></a>00156   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>) <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File opened successfully.&quot;</span> &lt;&lt; std::endl;
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad33f14d5154d71c0bf8339e44b801997">00161</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad33f14d5154d71c0bf8339e44b801997">ExodusII_IO_Helper::read_header</a>()
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_init(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00164"></a>00164                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>[0],
<a name="l00165"></a>00165                              &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>,
<a name="l00166"></a>00166                              &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>,
<a name="l00167"></a>00167                              &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>,
<a name="l00168"></a>00168                              &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>,
<a name="l00169"></a>00169                              &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>,
<a name="l00170"></a>00170                              &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error retrieving header info.&quot;</span>);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a02727aa1e0f71bcc9e20dbae243c3b9d">num_time_steps</a> = <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac04c6c50813ae9630e7270f930e50b8d">inquire</a>(exII::EX_INQ_TIME, <span class="stringliteral">&quot;Error retrieving time steps&quot;</span>);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   exII::ex_get_var_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <span class="stringliteral">&quot;n&quot;</span>, &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Exodus header info retrieved successfully.&quot;</span>);
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa57b23eb3af94898729cb25919b3123c">00184</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa57b23eb3af94898729cb25919b3123c">ExodusII_IO_Helper::print_header</a>()
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00187"></a>00187     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Title: \t&quot;</span> &lt;&lt; &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaba6c963688bcc534d5df395bd1eec22">title</a>[0] &lt;&lt; std::endl
<a name="l00188"></a>00188                   &lt;&lt; <span class="stringliteral">&quot;Mesh Dimension: \t&quot;</span>   &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a> &lt;&lt; std::endl
<a name="l00189"></a>00189                   &lt;&lt; <span class="stringliteral">&quot;Number of Nodes: \t&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> &lt;&lt; std::endl
<a name="l00190"></a>00190                   &lt;&lt; <span class="stringliteral">&quot;Number of elements: \t&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a> &lt;&lt; std::endl
<a name="l00191"></a>00191                   &lt;&lt; <span class="stringliteral">&quot;Number of elt blocks: \t&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a> &lt;&lt; std::endl
<a name="l00192"></a>00192                   &lt;&lt; <span class="stringliteral">&quot;Number of node sets: \t&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a> &lt;&lt; std::endl
<a name="l00193"></a>00193                   &lt;&lt; <span class="stringliteral">&quot;Number of side sets: \t&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a> &lt;&lt; std::endl;
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6442ae2187f05185649d88efef41c000">00198</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6442ae2187f05185649d88efef41c000">ExodusII_IO_Helper::read_nodes</a>()
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00201"></a>00201   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>); 
<a name="l00202"></a>00202   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>); 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_coord(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00205"></a>00205                               static_cast&lt;void*&gt;(&amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[0]),
<a name="l00206"></a>00206                               static_cast&lt;void*&gt;(&amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[0]),
<a name="l00207"></a>00207                               static_cast&lt;void*&gt;(&amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[0]));
<a name="l00208"></a>00208   
<a name="l00209"></a>00209   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error retrieving nodal data.&quot;</span>);
<a name="l00210"></a>00210   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Nodal data retrieved successfully.&quot;</span>); 
<a name="l00211"></a>00211 }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a18cb4af65d380ec6197cceca28f755ab">00215</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a18cb4af65d380ec6197cceca28f755ab">ExodusII_IO_Helper::read_node_num_map</a> ()
<a name="l00216"></a>00216 {
<a name="l00217"></a>00217   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_node_num_map (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00220"></a>00220                                       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[0]);
<a name="l00221"></a>00221                                       
<a name="l00222"></a>00222   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error retrieving nodal number map.&quot;</span>);
<a name="l00223"></a>00223   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Nodal numbering map retrieved successfully.&quot;</span>); 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00226"></a>00226     {
<a name="l00227"></a>00227       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] node_num_map[i] = &quot;</span>;
<a name="l00228"></a>00228       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt; static_cast&lt;unsigned int&gt;(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(10, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>-1)); ++i)
<a name="l00229"></a>00229         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00230"></a>00230       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;... &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>.back() &lt;&lt; std::endl;
<a name="l00231"></a>00231     }
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a955739a996cd5816d38417393b8118b0">00235</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a955739a996cd5816d38417393b8118b0">ExodusII_IO_Helper::print_nodes</a>(std::ostream &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l00236"></a>00236 {
<a name="l00237"></a>00237   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>; i++)
<a name="l00238"></a>00238     {
<a name="l00239"></a>00239       out &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[i] &lt;&lt; <span class="stringliteral">&quot;)&quot;</span> &lt;&lt; std::endl;
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a025711d210123880b8cdac91184ab45b">00245</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a025711d210123880b8cdac91184ab45b">ExodusII_IO_Helper::read_block_info</a>()
<a name="l00246"></a>00246 {
<a name="l00247"></a>00247   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>);
<a name="l00248"></a>00248   <span class="comment">// Get all element block IDs.</span>
<a name="l00249"></a>00249   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_elem_blk_ids(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00250"></a>00250                                      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>[0]);
<a name="l00251"></a>00251   <span class="comment">// Usually, there is only one</span>
<a name="l00252"></a>00252   <span class="comment">// block since there is only</span>
<a name="l00253"></a>00253   <span class="comment">// one type of element.</span>
<a name="l00254"></a>00254   <span class="comment">// However, there could be more.</span>
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error getting block IDs.&quot;</span>);
<a name="l00257"></a>00257   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;All block IDs retrieved successfully.&quot;</span>); 
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5add1e7f7ce8f31ab39b9c5a429771f4">00262</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5add1e7f7ce8f31ab39b9c5a429771f4">ExodusII_IO_Helper::get_block_id</a>(<span class="keywordtype">int</span> block)
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   libmesh_assert (static_cast&lt;unsigned int&gt;(block) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>.size());
<a name="l00265"></a>00265     
<a name="l00266"></a>00266   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>[block];
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afc3acc1e28f081a9f8a3c3a160715387">00271</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afc3acc1e28f081a9f8a3c3a160715387">ExodusII_IO_Helper::read_elem_in_block</a>(<span class="keywordtype">int</span> block)
<a name="l00272"></a>00272 {
<a name="l00273"></a>00273   libmesh_assert (static_cast&lt;unsigned int&gt;(block) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>.size());
<a name="l00274"></a>00274   
<a name="l00275"></a>00275   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_elem_block(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00276"></a>00276                                    <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>[block],
<a name="l00277"></a>00277                                    &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>[0],
<a name="l00278"></a>00278                                    &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>,
<a name="l00279"></a>00279                                    &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>,
<a name="l00280"></a>00280                                    &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad8f3b6956e73626540249882fb72b850">num_attr</a>);
<a name="l00281"></a>00281   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00282"></a>00282     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading a block of &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>
<a name="l00283"></a>00283               &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>[0] &lt;&lt; <span class="stringliteral">&quot;(s)&quot;</span>
<a name="l00284"></a>00284               &lt;&lt; <span class="stringliteral">&quot; having &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>
<a name="l00285"></a>00285               &lt;&lt; <span class="stringliteral">&quot; nodes per element.&quot;</span> &lt;&lt; std::endl;
<a name="l00286"></a>00286       
<a name="l00287"></a>00287   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error getting block info.&quot;</span>);
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Info retrieved successfully for block: &quot;</span>, block); 
<a name="l00289"></a>00289   
<a name="l00290"></a>00290   
<a name="l00291"></a>00291   
<a name="l00292"></a>00292   <span class="comment">// Read in the connectivity of the elements of this block,</span>
<a name="l00293"></a>00293   <span class="comment">// watching out for the case where we actually have no</span>
<a name="l00294"></a>00294   <span class="comment">// elements in this block (possible with parallel files)</span>
<a name="l00295"></a>00295   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>.empty())
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299       ex_err = exII::ex_get_elem_conn(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00300"></a>00300                                       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>[block],
<a name="l00301"></a>00301                                       &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[0]);
<a name="l00302"></a>00302   
<a name="l00303"></a>00303       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error reading block connectivity.&quot;</span>);
<a name="l00304"></a>00304       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Connectivity retrieved successfully for block: &quot;</span>, block);
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ade4a8af03ed43f731bd6d3974bceee65">00310</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ade4a8af03ed43f731bd6d3974bceee65">ExodusII_IO_Helper::read_elem_num_map</a> () 
<a name="l00311"></a>00311 {
<a name="l00312"></a>00312   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_elem_num_map (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00315"></a>00315                                       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>[0]);
<a name="l00316"></a>00316                                       
<a name="l00317"></a>00317   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error retrieving element number map.&quot;</span>);
<a name="l00318"></a>00318   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Element numbering map retrieved successfully.&quot;</span>); 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00322"></a>00322     {
<a name="l00323"></a>00323       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_num_map[i] = &quot;</span>;
<a name="l00324"></a>00324       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt; static_cast&lt;unsigned int&gt;(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(10, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>-1)); ++i)
<a name="l00325"></a>00325         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00326"></a>00326       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;... &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>.back() &lt;&lt; std::endl;
<a name="l00327"></a>00327     }
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9374fbb748e06b3fcdd5ca6a25bc1cd7">00332</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9374fbb748e06b3fcdd5ca6a25bc1cd7">ExodusII_IO_Helper::read_sideset_info</a>()
<a name="l00333"></a>00333 {
<a name="l00334"></a>00334   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>);
<a name="l00335"></a>00335   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a> &gt; 0)
<a name="l00336"></a>00336     {
<a name="l00337"></a>00337       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_side_set_ids(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00338"></a>00338                                          &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>[0]);
<a name="l00339"></a>00339       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error retrieving sideset information.&quot;</span>);
<a name="l00340"></a>00340       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;All sideset information retrieved successfully.&quot;</span>); 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342       <span class="comment">// Resize appropriate data structures -- only do this once outside the loop</span>
<a name="l00343"></a>00343       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>);
<a name="l00344"></a>00344       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a211df8d73a9b57399c61bdd1d778a26d">num_df_per_set</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346       <span class="comment">// Inquire about the length of the</span>
<a name="l00347"></a>00347       <span class="comment">// concatenated side sets element list</span>
<a name="l00348"></a>00348       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc45b140efd492eff86f8e5b37985550">req_info</a> = exII::EX_INQ_SS_ELEM_LEN; 
<a name="l00349"></a>00349       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_inquire(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00350"></a>00350                                 <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc45b140efd492eff86f8e5b37985550">req_info</a>,
<a name="l00351"></a>00351                                 &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">ret_int</a>,
<a name="l00352"></a>00352                                 &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a95a5224bfbd1971f7d98e4c0cb2ef59b">ret_float</a>,
<a name="l00353"></a>00353                                 &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc8379b7a2186efaab257e6cd905b8ea">ret_char</a>);
<a name="l00354"></a>00354       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error inquiring about side set element list length.&quot;</span>);
<a name="l00355"></a>00355 
<a name="l00356"></a>00356       <span class="comment">//libMesh::out &lt;&lt; &quot;Value returned by ex_inquire was: &quot; &lt;&lt; ret_int &lt;&lt; std::endl;</span>
<a name="l00357"></a>00357       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a> = <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">ret_int</a>;  
<a name="l00358"></a>00358       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>.resize (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>);
<a name="l00359"></a>00359       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>.resize (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>);
<a name="l00360"></a>00360       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a599636589599e2135c964485cecbe9d7">id_list</a>.resize   (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>);
<a name="l00361"></a>00361     }
<a name="l00362"></a>00362 }
<a name="l00363"></a>00363 
<a name="l00364"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a08200f195605daac61ad8d56a29ec435">00364</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a08200f195605daac61ad8d56a29ec435">ExodusII_IO_Helper::read_nodeset_info</a>()
<a name="l00365"></a>00365 {
<a name="l00366"></a>00366   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>);
<a name="l00367"></a>00367   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a> &gt; 0)
<a name="l00368"></a>00368     {
<a name="l00369"></a>00369       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_node_set_ids(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00370"></a>00370                                          &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>[0]);
<a name="l00371"></a>00371       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error retrieving nodeset information.&quot;</span>);
<a name="l00372"></a>00372       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;All nodeset information retrieved successfully.&quot;</span>); 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="comment">// Resize appropriate data structures -- only do this once outnode the loop</span>
<a name="l00375"></a>00375       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>);
<a name="l00376"></a>00376       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aec30d2229aa8b7cde4163054b86cda2c">num_node_df_per_set</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>);
<a name="l00377"></a>00377     }
<a name="l00378"></a>00378 }
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7e8af82fdd1f4fed93190bfa0c0fb2cb">00381</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7e8af82fdd1f4fed93190bfa0c0fb2cb">ExodusII_IO_Helper::read_sideset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>, <span class="keywordtype">int</span> offset)
<a name="l00382"></a>00382 {
<a name="l00383"></a>00383   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>.size());
<a name="l00384"></a>00384   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>.size());
<a name="l00385"></a>00385   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a211df8d73a9b57399c61bdd1d778a26d">num_df_per_set</a>.size());
<a name="l00386"></a>00386   libmesh_assert (static_cast&lt;unsigned int&gt;(offset) &lt;= <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>.size());
<a name="l00387"></a>00387   libmesh_assert (static_cast&lt;unsigned int&gt;(offset) &lt;= <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>.size());
<a name="l00388"></a>00388   
<a name="l00389"></a>00389   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_side_set_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00390"></a>00390                                        <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>[<span class="keywordtype">id</span>],
<a name="l00391"></a>00391                                        &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>[<span class="keywordtype">id</span>],
<a name="l00392"></a>00392                                        &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a211df8d73a9b57399c61bdd1d778a26d">num_df_per_set</a>[<span class="keywordtype">id</span>]);
<a name="l00393"></a>00393   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving sideset parameters.&quot;</span>);
<a name="l00394"></a>00394   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Parameters retrieved successfully for sideset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">// It&#39;s OK for offset==elem_list.size() as long as num_sides_per_set[id]==0</span>
<a name="l00398"></a>00398   <span class="comment">// because in that case we don&#39;t actually read anything...</span>
<a name="l00399"></a>00399 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (static_cast&lt;unsigned int&gt;(offset) == <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>.size() ||
<a name="l00401"></a>00401       <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(offset) == <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>.size() )
<a name="l00402"></a>00402     libmesh_assert(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>[<span class="keywordtype">id</span>] == 0);
<a name="l00403"></a>00403 <span class="preprocessor">#endif</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span>
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">// Don&#39;t call ex_get_side_set unless there are actually sides there to get.</span>
<a name="l00407"></a>00407   <span class="comment">// Exodus prints an annoying warning in DEBUG mode otherwise...</span>
<a name="l00408"></a>00408   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>[<span class="keywordtype">id</span>] &gt; 0)
<a name="l00409"></a>00409     {
<a name="l00410"></a>00410       ex_err = exII::ex_get_side_set(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00411"></a>00411                                      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>[<span class="keywordtype">id</span>],
<a name="l00412"></a>00412                                      &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>[offset],
<a name="l00413"></a>00413                                      &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>[offset]);
<a name="l00414"></a>00414       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving sideset data.&quot;</span>);
<a name="l00415"></a>00415       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Data retrieved successfully for sideset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa1b6ac3ca42a05e4f577c8dc24faf68c">num_sides_per_set</a>[id]; i++)
<a name="l00418"></a>00418         <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a599636589599e2135c964485cecbe9d7">id_list</a>[i+offset] = <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5876356b1fe37790c999d69b5fc1fe54">ss_ids</a>[<span class="keywordtype">id</span>];
<a name="l00419"></a>00419     }
<a name="l00420"></a>00420 }
<a name="l00421"></a>00421 
<a name="l00422"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af6f691a32892f4eb9377dba60fe26b31">00422</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af6f691a32892f4eb9377dba60fe26b31">ExodusII_IO_Helper::read_nodeset</a>(<span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00423"></a>00423 {
<a name="l00424"></a>00424   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>.size());
<a name="l00425"></a>00425   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>.size());
<a name="l00426"></a>00426   libmesh_assert (static_cast&lt;unsigned int&gt;(<span class="keywordtype">id</span>) &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aec30d2229aa8b7cde4163054b86cda2c">num_node_df_per_set</a>.size());
<a name="l00427"></a>00427   
<a name="l00428"></a>00428   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_get_node_set_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00429"></a>00429                                        <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>[<span class="keywordtype">id</span>],
<a name="l00430"></a>00430                                        &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>[<span class="keywordtype">id</span>],
<a name="l00431"></a>00431                                        &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aec30d2229aa8b7cde4163054b86cda2c">num_node_df_per_set</a>[<span class="keywordtype">id</span>]);
<a name="l00432"></a>00432   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving nodeset parameters.&quot;</span>);
<a name="l00433"></a>00433   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Parameters retrieved successfully for nodeset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00434"></a>00434 
<a name="l00435"></a>00435   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a74e1c63a8f69ef3d248e0b2f500e8c0e">node_list</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>[<span class="keywordtype">id</span>]);
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="comment">// Don&#39;t call ex_get_node_set unless there are actually nodes there to get.</span>
<a name="l00438"></a>00438   <span class="comment">// Exodus prints an annoying warning message in DEBUG mode otherwise...</span>
<a name="l00439"></a>00439   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4dbc53fc232766876c94fe90a67b57b0">num_nodes_per_set</a>[<span class="keywordtype">id</span>] &gt; 0)
<a name="l00440"></a>00440     {
<a name="l00441"></a>00441       ex_err = exII::ex_get_node_set(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00442"></a>00442                                      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acc3c2cf0e56ebc7d49fcc0ee378cec21">nodeset_ids</a>[<span class="keywordtype">id</span>],
<a name="l00443"></a>00443                                      &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a74e1c63a8f69ef3d248e0b2f500e8c0e">node_list</a>[0]);
<a name="l00444"></a>00444   
<a name="l00445"></a>00445       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error retrieving nodeset data.&quot;</span>);
<a name="l00446"></a>00446       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Data retrieved successfully for nodeset: &quot;</span>, <span class="keywordtype">id</span>);
<a name="l00447"></a>00447     }
<a name="l00448"></a>00448 }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#adc9062c1a713d7c16ceef1f52536f800">00451</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#adc9062c1a713d7c16ceef1f52536f800">ExodusII_IO_Helper::print_sideset_info</a>()
<a name="l00452"></a>00452 {
<a name="l00453"></a>00453   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>; i++)
<a name="l00454"></a>00454     {
<a name="l00455"></a>00455       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c4902c6322244be6b70f927c01a6889">elem_list</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a625fe16b1b44f7eba2cd3f792a396dba">side_list</a>[i] &lt;&lt; std::endl;
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac6fdd71b06584b8fb6d1e0fe3e271964">00461</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac6fdd71b06584b8fb6d1e0fe3e271964">ExodusII_IO_Helper::close</a>()
<a name="l00462"></a>00462 {
<a name="l00463"></a>00463   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00464"></a>00464     {
<a name="l00465"></a>00465       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_close(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l00466"></a>00466       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error closing Exodus file.&quot;</span>);
<a name="l00467"></a>00467       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a35910b940780b757912d8a890a6fcb38">message</a>(<span class="stringliteral">&quot;Exodus file closed successfully.&quot;</span>); 
<a name="l00468"></a>00468     }
<a name="l00469"></a>00469 }
<a name="l00470"></a>00470 
<a name="l00471"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac04c6c50813ae9630e7270f930e50b8d">00471</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac04c6c50813ae9630e7270f930e50b8d">ExodusII_IO_Helper::inquire</a>(<span class="keywordtype">int</span> req_info, std::string error_msg)
<a name="l00472"></a>00472 {
<a name="l00473"></a>00473   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_inquire(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00474"></a>00474                             req_info,
<a name="l00475"></a>00475                             &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">ret_int</a>,
<a name="l00476"></a>00476                             &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a95a5224bfbd1971f7d98e4c0cb2ef59b">ret_float</a>,
<a name="l00477"></a>00477                             &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abc8379b7a2186efaab257e6cd905b8ea">ret_char</a>);
<a name="l00478"></a>00478     
<a name="l00479"></a>00479   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, error_msg);
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a71c91c6750b16720a98ab7d48ec320bc">ret_int</a>;
<a name="l00482"></a>00482 }
<a name="l00483"></a>00483 
<a name="l00484"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abad269308f48bf51afc8dc8b3423e117">00484</a> <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abad269308f48bf51afc8dc8b3423e117">ExodusII_IO_Helper::get_time_steps</a>()
<a name="l00485"></a>00485 {
<a name="l00486"></a>00486   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaf218d72fe1d485ef9eebab6e9ae32b0">time_steps</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a02727aa1e0f71bcc9e20dbae243c3b9d">num_time_steps</a>);
<a name="l00487"></a>00487   exII::ex_get_all_times(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaf218d72fe1d485ef9eebab6e9ae32b0">time_steps</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaf218d72fe1d485ef9eebab6e9ae32b0">time_steps</a>[0]);
<a name="l00488"></a>00488   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aaf218d72fe1d485ef9eebab6e9ae32b0">time_steps</a>;
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1872d25cd6269d0ef71703cf30203d26">00493</a> <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1872d25cd6269d0ef71703cf30203d26">ExodusII_IO_Helper::get_nodal_var_names</a>()
<a name="l00494"></a>00494 {
<a name="l00495"></a>00495   <span class="comment">// Allocate enough space for our variable name strings.</span>
<a name="l00496"></a>00496   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l00497"></a>00497     
<a name="l00498"></a>00498   <span class="comment">// Use the vvc and strings objects to emulate the behavior of</span>
<a name="l00499"></a>00499   <span class="comment">// a char** object.</span>
<a name="l00500"></a>00500   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l00501"></a>00501   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l00502"></a>00502   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>;i++)
<a name="l00503"></a>00503     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i].resize(MAX_STR_LENGTH+1);
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>;i++)
<a name="l00506"></a>00506     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i]=&amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]); <span class="comment">// set pointer into vvc only *after* all resizing is complete</span>
<a name="l00507"></a>00507     
<a name="l00508"></a>00508   exII::ex_get_var_names(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00509"></a>00509                          <span class="stringliteral">&quot;n&quot;</span>,
<a name="l00510"></a>00510                          num_nodal_vars,
<a name="l00511"></a>00511                          &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[0]<span class="comment">//var_names</span>
<a name="l00512"></a>00512                          );
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00515"></a>00515     {
<a name="l00516"></a>00516       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Read the variable(s) from the file:&quot;</span> &lt;&lt; std::endl;
<a name="l00517"></a>00517       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>; i++)
<a name="l00518"></a>00518         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;strings[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] &lt;&lt; std::endl;
<a name="l00519"></a>00519     }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521   
<a name="l00522"></a>00522   <span class="comment">// Copy the char buffers into strings.  </span>
<a name="l00523"></a>00523   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>;i++)
<a name="l00524"></a>00524     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>[i]=<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i]; <span class="comment">// calls string::op=(const char*)</span>
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   
<a name="l00527"></a>00527   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>;
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 
<a name="l00533"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2c1ad57fbda25ca8b03a89e3f256a79e">00533</a> <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2c1ad57fbda25ca8b03a89e3f256a79e">ExodusII_IO_Helper::get_nodal_var_values</a>(std::string nodal_var_name, <span class="keywordtype">int</span> time_step)
<a name="l00534"></a>00534 {
<a name="l00535"></a>00535   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0e41e15161c7a8dbf23a84cd792fa4af">nodal_var_values</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00536"></a>00536     
<a name="l00537"></a>00537   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1872d25cd6269d0ef71703cf30203d26">get_nodal_var_names</a>();
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="comment">//See if we can find the variable we are looking for</span>
<a name="l00540"></a>00540   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_index = 0;
<a name="l00541"></a>00541   <span class="keywordtype">bool</span> found = <span class="keyword">false</span>;
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   found = <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>[var_index] == nodal_var_name;
<a name="l00544"></a>00544     
<a name="l00545"></a>00545   <span class="keywordflow">while</span>(!found &amp;&amp; var_index &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>.size())
<a name="l00546"></a>00546     {
<a name="l00547"></a>00547       var_index++;
<a name="l00548"></a>00548       found = <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a1ee8ea05ec89e89547c83f8005578ed1">nodal_var_names</a>[var_index] == nodal_var_name;
<a name="l00549"></a>00549     }
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <span class="keywordflow">if</span>(!found)
<a name="l00552"></a>00552     {
<a name="l00553"></a>00553       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Unable to locate variable named: &quot;</span> &lt;&lt; nodal_var_name &lt;&lt; std::endl;
<a name="l00554"></a>00554       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0e41e15161c7a8dbf23a84cd792fa4af">nodal_var_values</a>;
<a name="l00555"></a>00555     }
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   exII::ex_get_nodal_var(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, time_step, var_index+1, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>, &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0e41e15161c7a8dbf23a84cd792fa4af">nodal_var_values</a>[0]);
<a name="l00558"></a>00558   
<a name="l00559"></a>00559   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0e41e15161c7a8dbf23a84cd792fa4af">nodal_var_values</a>;
<a name="l00560"></a>00560 }
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 
<a name="l00565"></a>00565 <span class="comment">// For Writing Solutions</span>
<a name="l00566"></a>00566 
<a name="l00567"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9daf17d8dc75021475d19e91ea1e3205">00567</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9daf17d8dc75021475d19e91ea1e3205">ExodusII_IO_Helper::create</a>(std::string filename)
<a name="l00568"></a>00568 {
<a name="l00569"></a>00569   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00570"></a>00570     {
<a name="l00571"></a>00571 
<a name="l00572"></a>00572       <span class="comment">//Fall back on double precision when necessary since ExodusII</span>
<a name="l00573"></a>00573       <span class="comment">//doesn&#39;t seem to support long double</span>
<a name="l00574"></a>00574       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0f5eb2c6a0d73df24a4ce5881af78e3e">comp_ws</a> = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>),<span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00575"></a>00575       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae89fbfcc501d91752083448eb1fb61db">io_ws</a> = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>),<span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00576"></a>00576     
<a name="l00577"></a>00577       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a> = exII::ex_create(filename.c_str(), EX_CLOBBER, &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0f5eb2c6a0d73df24a4ce5881af78e3e">comp_ws</a>, &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae89fbfcc501d91752083448eb1fb61db">io_ws</a>);
<a name="l00578"></a>00578 
<a name="l00579"></a>00579       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <span class="stringliteral">&quot;Error creating ExodusII mesh file.&quot;</span>);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00582"></a>00582         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File created successfully.&quot;</span> &lt;&lt; std::endl;
<a name="l00583"></a>00583     }
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa5fd423d103957beb37aab2a59dc5398">_created</a> = <span class="keyword">true</span>;
<a name="l00586"></a>00586 }
<a name="l00587"></a>00587 
<a name="l00588"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac3f01f52d7f36235a10ce8300f3ea186">00588</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac3f01f52d7f36235a10ce8300f3ea186">ExodusII_IO_Helper::initialize_discontinuous</a>(std::string str_title, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00589"></a>00589 {
<a name="l00590"></a>00590   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00591"></a>00591     <span class="keywordflow">return</span>;
<a name="l00592"></a>00592 
<a name="l00593"></a>00593   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>();
<a name="l00594"></a>00594 
<a name="l00595"></a>00595   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00596"></a>00596   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00597"></a>00597   <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00598"></a>00598         <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> += (*it)-&gt;n_nodes();
<a name="l00599"></a>00599   
<a name="l00600"></a>00600   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00601"></a>00601 
<a name="l00602"></a>00602   std::vector&lt;short int&gt; unique_side_boundaries;
<a name="l00603"></a>00603   std::vector&lt;short int&gt; unique_node_boundaries;
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_side_boundary_ids(unique_side_boundaries);
<a name="l00606"></a>00606   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_node_boundary_ids(unique_node_boundaries);
<a name="l00607"></a>00607 
<a name="l00608"></a>00608   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a> = unique_side_boundaries.size();
<a name="l00609"></a>00609   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a> = unique_node_boundaries.size();
<a name="l00610"></a>00610   
<a name="l00611"></a>00611   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l00612"></a>00612   std::map&lt;subdomain_id_type, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l00613"></a>00613 
<a name="l00614"></a>00614   <span class="keywordflow">for</span>(it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); it != end; ++it)
<a name="l00615"></a>00615     {
<a name="l00616"></a>00616       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = *it;
<a name="l00617"></a>00617       <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> cur_subdomain = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00618"></a>00618       
<a name="l00619"></a>00619       <span class="keywordflow">if</span>(cur_subdomain == 0)
<a name="l00620"></a>00620         cur_subdomain = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l00621"></a>00621 
<a name="l00622"></a>00622       subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00623"></a>00623     }
<a name="l00624"></a>00624   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a> = subdomain_map.size();
<a name="l00625"></a>00625 
<a name="l00626"></a>00626   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_init(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00627"></a>00627                              str_title.c_str(),
<a name="l00628"></a>00628                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>,
<a name="l00629"></a>00629                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>,
<a name="l00630"></a>00630                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>,
<a name="l00631"></a>00631                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>,
<a name="l00632"></a>00632                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>,
<a name="l00633"></a>00633                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>);
<a name="l00634"></a>00634     
<a name="l00635"></a>00635   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error initializing new Exodus file.&quot;</span>);
<a name="l00636"></a>00636 }
<a name="l00637"></a>00637 
<a name="l00638"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9de09b95a7b1d3d5a56e4874bae230c9">00638</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9de09b95a7b1d3d5a56e4874bae230c9">ExodusII_IO_Helper::initialize</a>(std::string str_title, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00639"></a>00639 {
<a name="l00640"></a>00640   <span class="comment">// n_active_elem() is a parallel_only function</span>
<a name="l00641"></a>00641   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>();
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00644"></a>00644     <span class="keywordflow">return</span>;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>();
<a name="l00647"></a>00647   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00648"></a>00648   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   std::vector&lt;short int&gt; unique_side_boundaries;
<a name="l00651"></a>00651   std::vector&lt;short int&gt; unique_node_boundaries;
<a name="l00652"></a>00652 
<a name="l00653"></a>00653   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_side_boundary_ids(unique_side_boundaries);
<a name="l00654"></a>00654   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_node_boundary_ids(unique_node_boundaries);
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a> = unique_side_boundaries.size();
<a name="l00657"></a>00657   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a> = unique_node_boundaries.size();
<a name="l00658"></a>00658   
<a name="l00659"></a>00659   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l00660"></a>00660   std::map&lt;subdomain_id_type, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l00661"></a>00661 
<a name="l00662"></a>00662   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); 
<a name="l00663"></a>00663   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00664"></a>00664   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00665"></a>00665   {
<a name="l00666"></a>00666     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = *it;
<a name="l00667"></a>00667     <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> cur_subdomain = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00668"></a>00668       
<a name="l00669"></a>00669     <span class="keywordflow">if</span>(cur_subdomain == 0)
<a name="l00670"></a>00670       cur_subdomain = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l00671"></a>00671 
<a name="l00672"></a>00672       subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00673"></a>00673   }
<a name="l00674"></a>00674   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a> = subdomain_map.size();
<a name="l00675"></a>00675 
<a name="l00676"></a>00676   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_init(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00677"></a>00677                              str_title.c_str(),
<a name="l00678"></a>00678                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a61acb9bb4d7ec8cf215bce77b582395e">num_dim</a>,
<a name="l00679"></a>00679                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>,
<a name="l00680"></a>00680                              n_active_elem,
<a name="l00681"></a>00681                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>,
<a name="l00682"></a>00682                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a>,
<a name="l00683"></a>00683                              <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a>);
<a name="l00684"></a>00684     
<a name="l00685"></a>00685   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error initializing new Exodus file.&quot;</span>);
<a name="l00686"></a>00686 }
<a name="l00687"></a>00687 
<a name="l00688"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a69566f6e18d15cb9087fdc021c857c8b">00688</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a69566f6e18d15cb9087fdc021c857c8b">ExodusII_IO_Helper::write_nodal_coordinates</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00689"></a>00689 {
<a name="l00690"></a>00690   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00691"></a>00691     <span class="keywordflow">return</span>;
<a name="l00692"></a>00692 
<a name="l00693"></a>00693   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00694"></a>00694   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00695"></a>00695   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00696"></a>00696 
<a name="l00697"></a>00697   <span class="keywordflow">for</span> (<span class="comment">/* unsigned */</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>; ++i)
<a name="l00698"></a>00698     {
<a name="l00699"></a>00699       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[i]=(*mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i))(0);
<a name="l00700"></a>00700 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00701"></a>00701 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[i]=(*mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i))(1);
<a name="l00702"></a>00702 <span class="preprocessor">#else</span>
<a name="l00703"></a>00703 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[i]=0.;
<a name="l00704"></a>00704 <span class="preprocessor">#endif</span>
<a name="l00705"></a>00705 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00706"></a>00706 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[i]=(*mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i))(2);
<a name="l00707"></a>00707 <span class="preprocessor">#else</span>
<a name="l00708"></a>00708 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[i]=0.;
<a name="l00709"></a>00709 <span class="preprocessor">#endif</span>
<a name="l00710"></a>00710 <span class="preprocessor"></span>    }
<a name="l00711"></a>00711 
<a name="l00712"></a>00712   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_coord(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00713"></a>00713                               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[0],
<a name="l00714"></a>00714                               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[0],
<a name="l00715"></a>00715                               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[0]);
<a name="l00716"></a>00716 
<a name="l00717"></a>00717   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing coordinates to Exodus file.&quot;</span>);
<a name="l00718"></a>00718 }
<a name="l00719"></a>00719 
<a name="l00720"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3fda115cb6c8778c275f030da81d91f2">00720</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3fda115cb6c8778c275f030da81d91f2">ExodusII_IO_Helper::write_nodal_coordinates_discontinuous</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00721"></a>00721 {
<a name="l00722"></a>00722   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00723"></a>00723     <span class="keywordflow">return</span>;
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00726"></a>00726   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00727"></a>00727   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>);
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00730"></a>00730   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00731"></a>00731  
<a name="l00732"></a>00732   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0;
<a name="l00733"></a>00733   <span class="keywordflow">for</span> ( ; it != end; ++it)   
<a name="l00734"></a>00734         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*it)-&gt;n_nodes(); n++)
<a name="l00735"></a>00735     {
<a name="l00736"></a>00736       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[i]=(*it)-&gt;point(n)(0);
<a name="l00737"></a>00737 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00738"></a>00738 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[i]=(*it)-&gt;point(n)(1);
<a name="l00739"></a>00739 <span class="preprocessor">#else</span>
<a name="l00740"></a>00740 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[i]=0.;
<a name="l00741"></a>00741 <span class="preprocessor">#endif</span>
<a name="l00742"></a>00742 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00743"></a>00743 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[i]=(*it)-&gt;point(n)(2);
<a name="l00744"></a>00744 <span class="preprocessor">#else</span>
<a name="l00745"></a>00745 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[i]=0.;
<a name="l00746"></a>00746 <span class="preprocessor">#endif</span>
<a name="l00747"></a>00747 <span class="preprocessor"></span>      i++;
<a name="l00748"></a>00748     }
<a name="l00749"></a>00749 
<a name="l00750"></a>00750   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_coord(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00751"></a>00751                               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[0],
<a name="l00752"></a>00752                               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[0],
<a name="l00753"></a>00753                               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[0]);
<a name="l00754"></a>00754 
<a name="l00755"></a>00755   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing coordinates to Exodus file.&quot;</span>);
<a name="l00756"></a>00756 }
<a name="l00757"></a>00757 
<a name="l00758"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0800a235c4e380606894be67b6062225">00758</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0800a235c4e380606894be67b6062225">ExodusII_IO_Helper::write_elements</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00759"></a>00759 {
<a name="l00760"></a>00760   <span class="comment">// n_active_elem() is a parallel_only function</span>
<a name="l00761"></a>00761   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>();
<a name="l00762"></a>00762 
<a name="l00763"></a>00763   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00764"></a>00764     <span class="keywordflow">return</span>;
<a name="l00765"></a>00765 
<a name="l00766"></a>00766   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l00767"></a>00767 
<a name="l00768"></a>00768   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> mesh_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); 
<a name="l00769"></a>00769   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00770"></a>00770   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l00771"></a>00771   <span class="keywordflow">for</span> (; mesh_it != end; ++mesh_it)
<a name="l00772"></a>00772   {
<a name="l00773"></a>00773     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = *mesh_it;
<a name="l00774"></a>00774 
<a name="l00775"></a>00775     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cur_subdomain = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00776"></a>00776 
<a name="l00777"></a>00777     <span class="keywordflow">if</span>(cur_subdomain == 0)
<a name="l00778"></a>00778       cur_subdomain = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l00779"></a>00779      
<a name="l00780"></a>00780     subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00781"></a>00781   }
<a name="l00782"></a>00782 
<a name="l00783"></a>00783   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>;
<a name="l00784"></a>00784 
<a name="l00785"></a>00785   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> it;
<a name="l00786"></a>00786 
<a name="l00787"></a>00787   <span class="comment">// element map vector</span>
<a name="l00788"></a>00788   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>.clear();
<a name="l00789"></a>00789   std::vector&lt;unsigned int&gt; elem_map(n_active_elem);
<a name="l00790"></a>00790   std::vector&lt;unsigned int&gt;::iterator curr_elem_map_end = elem_map.begin();
<a name="l00791"></a>00791   <span class="keywordflow">for</span>(it = subdomain_map.begin() ; it != subdomain_map.end(); it++)
<a name="l00792"></a>00792     {
<a name="l00793"></a>00793       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>.push_back((*it).first);
<a name="l00794"></a>00794 
<a name="l00795"></a>00795       std::vector&lt;unsigned int&gt; &amp; tmp_vec = (*it).second;
<a name="l00796"></a>00796 
<a name="l00797"></a>00797       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00798"></a>00798 
<a name="l00799"></a>00799       <span class="comment">//Use the first element in this block to get representative information.</span>
<a name="l00800"></a>00800       <span class="comment">//Note that Exodus assumes all elements in a block are of the same type!</span>
<a name="l00801"></a>00801       <span class="comment">//We are using that same assumption here!</span>
<a name="l00802"></a>00802       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(tmp_vec[0])-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00803"></a>00803       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(tmp_vec[0])-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00804"></a>00804     
<a name="l00805"></a>00805       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_block(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, (*it).first, conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ad47542ad6ffc52d42d9d489531548072">exodus_elem_type</a>().c_str(), tmp_vec.size(),<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>,0);
<a name="l00806"></a>00806     
<a name="l00807"></a>00807       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element block.&quot;</span>);
<a name="l00808"></a>00808   
<a name="l00809"></a>00809       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>.resize(tmp_vec.size()*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>);
<a name="l00810"></a>00810 
<a name="l00811"></a>00811       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;tmp_vec.size(); i++)
<a name="l00812"></a>00812         {
<a name="l00813"></a>00813           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = tmp_vec[i];
<a name="l00814"></a>00814           elem_num_map.push_back(elem_id);
<a name="l00815"></a>00815           <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a422a3541894dcbd8b4f75a122706c661">libmesh_elem_num_to_exodus</a>[<a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a>] = elem_num_map.size();
<a name="l00816"></a>00816           
<a name="l00817"></a>00817           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(elem_id);
<a name="l00818"></a>00818           
<a name="l00819"></a>00819           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>); j++)
<a name="l00820"></a>00820             {  
<a name="l00821"></a>00821               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> connect_index   = (i*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>)+j;
<a name="l00822"></a>00822               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_node_index = conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a84ae7256b57510e53b3d087cfc3fe0ca">get_node_map</a>(j);
<a name="l00823"></a>00823               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00824"></a>00824                 {
<a name="l00825"></a>00825                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Exodus node index: &quot;</span> &lt;&lt; j
<a name="l00826"></a>00826                                 &lt;&lt; <span class="stringliteral">&quot;=LibMesh node index &quot;</span> &lt;&lt; elem_node_index &lt;&lt; std::endl;
<a name="l00827"></a>00827                 }
<a name="l00828"></a>00828               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[connect_index] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(elem_node_index)+1;
<a name="l00829"></a>00829             }
<a name="l00830"></a>00830         }
<a name="l00831"></a>00831     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_conn(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, (*it).first, &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[0]);
<a name="l00832"></a>00832     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element connectivities&quot;</span>);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834     <span class="comment">// write out the element number map</span>
<a name="l00835"></a>00835     curr_elem_map_end = std::transform(tmp_vec.begin(), tmp_vec.end(), curr_elem_map_end,
<a name="l00836"></a>00836                    std::bind2nd(std::plus&lt;unsigned int&gt;(), 1));  <span class="comment">// Add one to each id for exodus!</span>
<a name="l00837"></a>00837     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_num_map(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, (<span class="keywordtype">int</span> *)&amp;elem_map[0]);
<a name="l00838"></a>00838     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error writing element map&quot;</span>);
<a name="l00839"></a>00839   }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 <span class="comment">//  ex_err = exII::ex_put_elem_num_map(ex_id, &amp;elem_num_map[0]);</span>
<a name="l00842"></a>00842   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element connectivities&quot;</span>);
<a name="l00843"></a>00843 }
<a name="l00844"></a>00844 
<a name="l00845"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af75f1991e197a050f46a6566876c3314">00845</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af75f1991e197a050f46a6566876c3314">ExodusII_IO_Helper::write_elements_discontinuous</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00846"></a>00846 {
<a name="l00847"></a>00847   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00848"></a>00848     <span class="keywordflow">return</span>;
<a name="l00849"></a>00849 
<a name="l00850"></a>00850   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l00851"></a>00851 
<a name="l00852"></a>00852   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> mesh_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); 
<a name="l00853"></a>00853   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00854"></a>00854   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l00855"></a>00855   <span class="keywordflow">for</span>(; mesh_it != end; ++mesh_it)
<a name="l00856"></a>00856     {
<a name="l00857"></a>00857       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = *mesh_it;
<a name="l00858"></a>00858 
<a name="l00859"></a>00859       <span class="comment">//Only write out the active elements</span>
<a name="l00860"></a>00860       <span class="keywordflow">if</span>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00861"></a>00861       {
<a name="l00862"></a>00862         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cur_subdomain = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00863"></a>00863 
<a name="l00864"></a>00864         <span class="keywordflow">if</span>(cur_subdomain == 0)
<a name="l00865"></a>00865           cur_subdomain = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l00866"></a>00866      
<a name="l00867"></a>00867         subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00868"></a>00868       }
<a name="l00869"></a>00869     }
<a name="l00870"></a>00870 
<a name="l00871"></a>00871   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afd686e5e7464c8d5c0fe424c9456d572">elem_num_map</a>;
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> it;
<a name="l00874"></a>00874   
<a name="l00875"></a>00875   <span class="keywordflow">for</span>(it = subdomain_map.begin() ; it != subdomain_map.end(); it++)
<a name="l00876"></a>00876     {
<a name="l00877"></a>00877       std::vector&lt;unsigned int&gt; &amp; tmp_vec = (*it).second;
<a name="l00878"></a>00878 
<a name="l00879"></a>00879       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00880"></a>00880 
<a name="l00881"></a>00881       <span class="comment">//Use the first element in this block to get representative information.</span>
<a name="l00882"></a>00882       <span class="comment">//Note that Exodus assumes all elements in a block are of the same type!</span>
<a name="l00883"></a>00883       <span class="comment">//We are using that same assumption here!</span>
<a name="l00884"></a>00884       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(tmp_vec[0])-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00885"></a>00885       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(tmp_vec[0])-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00886"></a>00886     
<a name="l00887"></a>00887       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_block(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, (*it).first, conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#ad47542ad6ffc52d42d9d489531548072">exodus_elem_type</a>().c_str(), tmp_vec.size(),<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>,0);
<a name="l00888"></a>00888     
<a name="l00889"></a>00889       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element block.&quot;</span>);
<a name="l00890"></a>00890   
<a name="l00891"></a>00891       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>.resize(tmp_vec.size()*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>);
<a name="l00892"></a>00892 
<a name="l00893"></a>00893       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;tmp_vec.size(); i++)
<a name="l00894"></a>00894         {
<a name="l00895"></a>00895           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = tmp_vec[i];
<a name="l00896"></a>00896           elem_num_map.push_back(elem_id);
<a name="l00897"></a>00897           <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a422a3541894dcbd8b4f75a122706c661">libmesh_elem_num_to_exodus</a>[<a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a>] = elem_num_map.size();
<a name="l00898"></a>00898           
<a name="l00899"></a>00899           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>); j++)
<a name="l00900"></a>00900             {  
<a name="l00901"></a>00901               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> connect_index   = (i*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>)+j;
<a name="l00902"></a>00902               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_node_index = conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a84ae7256b57510e53b3d087cfc3fe0ca">get_node_map</a>(j);
<a name="l00903"></a>00903               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00904"></a>00904                 {
<a name="l00905"></a>00905                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Exodus node index: &quot;</span> &lt;&lt; j
<a name="l00906"></a>00906                                 &lt;&lt; <span class="stringliteral">&quot;=LibMesh node index &quot;</span> &lt;&lt; elem_node_index &lt;&lt; std::endl;
<a name="l00907"></a>00907                 }
<a name="l00908"></a>00908               <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[connect_index] = i*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>+elem_node_index+1;
<a name="l00909"></a>00909             }
<a name="l00910"></a>00910         }
<a name="l00911"></a>00911     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_conn(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, (*it).first, &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[0]);
<a name="l00912"></a>00912     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element connectivities&quot;</span>);
<a name="l00913"></a>00913 
<a name="l00914"></a>00914     <span class="comment">// write out the element number map</span>
<a name="l00915"></a>00915     std::vector&lt;unsigned int&gt; elem_map(tmp_vec.size());
<a name="l00916"></a>00916     std::transform(tmp_vec.begin(), tmp_vec.end(), elem_map.begin(),
<a name="l00917"></a>00917                    std::bind2nd(std::plus&lt;unsigned int&gt;(), 1));  <span class="comment">// Add one to each id for exodus!</span>
<a name="l00918"></a>00918     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_num_map(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, (<span class="keywordtype">int</span> *)&amp;elem_map[0]);
<a name="l00919"></a>00919     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(ex_err, <span class="stringliteral">&quot;Error writing element map&quot;</span>);
<a name="l00920"></a>00920   }
<a name="l00921"></a>00921 
<a name="l00922"></a>00922 <span class="comment">//  ex_err = exII::ex_put_elem_num_map(ex_id, &amp;elem_num_map[0]);</span>
<a name="l00923"></a>00923   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element connectivities&quot;</span>);
<a name="l00924"></a>00924   
<a name="l00925"></a>00925   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_update(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l00926"></a>00926   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error flushing buffers to file.&quot;</span>);
<a name="l00927"></a>00927 }
<a name="l00928"></a>00928 
<a name="l00929"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2fd000be6f2bc33c98ad515dd036efe5">00929</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2fd000be6f2bc33c98ad515dd036efe5">ExodusII_IO_Helper::write_sidesets</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00930"></a>00930 {
<a name="l00931"></a>00931   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00932"></a>00932     <span class="keywordflow">return</span>;
<a name="l00933"></a>00933 
<a name="l00934"></a>00934   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00935"></a>00935 
<a name="l00936"></a>00936   std::vector&lt; unsigned int &gt; el;
<a name="l00937"></a>00937   std::vector&lt; unsigned short int &gt; sl;
<a name="l00938"></a>00938   std::vector&lt; short int &gt; il;
<a name="l00939"></a>00939       
<a name="l00940"></a>00940   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_side_list(el, sl, il);
<a name="l00941"></a>00941 
<a name="l00942"></a>00942   <span class="comment">//Maps from sideset id to the element and sides</span>
<a name="l00943"></a>00943   std::map&lt;int, std::vector&lt;int&gt; &gt; elem;
<a name="l00944"></a>00944   std::map&lt;int, std::vector&lt;int&gt; &gt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>;
<a name="l00945"></a>00945 
<a name="l00946"></a>00946   <span class="comment">//Accumulate the vectors to pass into ex_put_side_set</span>
<a name="l00947"></a>00947   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; el.size(); i++)
<a name="l00948"></a>00948   {
<a name="l00949"></a>00949     std::vector&lt;const Elem *&gt; family;
<a name="l00950"></a>00950 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00951"></a>00951 <span class="preprocessor"></span>
<a name="l00955"></a>00955     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(el[i])-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a45301bbc272e10e4cfafc0bb38ada072">active_family_tree_by_side</a>(family, sl[i], <span class="keyword">false</span>);
<a name="l00956"></a>00956 <span class="preprocessor">#else</span>
<a name="l00957"></a>00957 <span class="preprocessor"></span>    family.push_back(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(el[i]));
<a name="l00958"></a>00958 <span class="preprocessor">#endif</span>
<a name="l00959"></a>00959 <span class="preprocessor"></span>
<a name="l00960"></a>00960     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; family.size(); ++j)
<a name="l00961"></a>00961     {
<a name="l00962"></a>00962       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(family[j]-&gt;id())-&gt;type());
<a name="l00963"></a>00963 
<a name="l00964"></a>00964       <span class="comment">// Use the libmesh to exodus datastructure map to get the proper sideset IDs</span>
<a name="l00965"></a>00965       <span class="comment">// The datastructure contains the &quot;collapsed&quot; contiguous ids</span>
<a name="l00966"></a>00966       elem[il[i]].push_back(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a422a3541894dcbd8b4f75a122706c661">libmesh_elem_num_to_exodus</a>[family[j]-&gt;<span class="keywordtype">id</span>()]);
<a name="l00967"></a>00967       side[il[i]].push_back(conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#abc8000784296b47f55b91a33e90ad1c6">get_inverse_side_map</a>(sl[i]));
<a name="l00968"></a>00968     }
<a name="l00969"></a>00969   }
<a name="l00970"></a>00970   
<a name="l00971"></a>00971   std::vector&lt;short int&gt; side_boundary_ids;
<a name="l00972"></a>00972   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_side_boundary_ids(side_boundary_ids);
<a name="l00973"></a>00973   
<a name="l00974"></a>00974   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; side_boundary_ids.size(); i++)
<a name="l00975"></a>00975   {
<a name="l00976"></a>00976     <span class="keywordtype">int</span> ss_id = side_boundary_ids[i];
<a name="l00977"></a>00977 
<a name="l00978"></a>00978     <span class="keywordtype">int</span> actual_id = ss_id;
<a name="l00979"></a>00979     
<a name="l00980"></a>00980     <span class="keywordflow">if</span>(actual_id == 0)
<a name="l00981"></a>00981       actual_id = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l00982"></a>00982 
<a name="l00983"></a>00983     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_side_set_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, actual_id, elem[ss_id].size(), 4);
<a name="l00984"></a>00984     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing sideset parameters&quot;</span>);
<a name="l00985"></a>00985     
<a name="l00986"></a>00986     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_side_set(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, actual_id, &amp;elem[ss_id][0], &amp;side[ss_id][0]);
<a name="l00987"></a>00987     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing sidesets&quot;</span>);
<a name="l00988"></a>00988   }
<a name="l00989"></a>00989 }
<a name="l00990"></a>00990 
<a name="l00991"></a>00991 
<a name="l00992"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5bffc13cca54029728ced3d8babf25b1">00992</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5bffc13cca54029728ced3d8babf25b1">ExodusII_IO_Helper::write_nodesets</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00993"></a>00993 {
<a name="l00994"></a>00994   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l00995"></a>00995     <span class="keywordflow">return</span>;
<a name="l00996"></a>00996 
<a name="l00997"></a>00997   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00998"></a>00998 
<a name="l00999"></a>00999   std::vector&lt; unsigned int &gt; nl;
<a name="l01000"></a>01000   std::vector&lt; short int &gt; il;
<a name="l01001"></a>01001       
<a name="l01002"></a>01002   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_node_list(nl, il);
<a name="l01003"></a>01003 
<a name="l01004"></a>01004   <span class="comment">//Maps from nodeset id to the nodes</span>
<a name="l01005"></a>01005   std::map&lt;short int, std::vector&lt;int&gt; &gt; node;
<a name="l01006"></a>01006 
<a name="l01007"></a>01007   <span class="comment">//Accumulate the vectors to pass into ex_put_node_set</span>
<a name="l01008"></a>01008   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; nl.size(); i++)
<a name="l01009"></a>01009     node[il[i]].push_back(nl[i]+1);    
<a name="l01010"></a>01010   
<a name="l01011"></a>01011   std::vector&lt;short int&gt; node_boundary_ids;
<a name="l01012"></a>01012   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_node_boundary_ids(node_boundary_ids);
<a name="l01013"></a>01013   
<a name="l01014"></a>01014   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; node_boundary_ids.size(); i++)
<a name="l01015"></a>01015   {
<a name="l01016"></a>01016     <span class="keywordtype">int</span> nodeset_id = node_boundary_ids[i];
<a name="l01017"></a>01017 
<a name="l01018"></a>01018     <span class="keywordtype">int</span> actual_id = nodeset_id;
<a name="l01019"></a>01019     
<a name="l01020"></a>01020     <span class="keywordflow">if</span>(nodeset_id == 0)
<a name="l01021"></a>01021       actual_id = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l01022"></a>01022 
<a name="l01023"></a>01023     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_node_set_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, actual_id, node[nodeset_id].size(), 0);
<a name="l01024"></a>01024     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing nodeset parameters&quot;</span>);
<a name="l01025"></a>01025 
<a name="l01026"></a>01026     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_node_set(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, actual_id, &amp;node[nodeset_id][0]);
<a name="l01027"></a>01027     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing nodesets&quot;</span>);
<a name="l01028"></a>01028   }
<a name="l01029"></a>01029 }
<a name="l01030"></a>01030 
<a name="l01031"></a>01031 
<a name="l01032"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a66d20d2989de6d258122885507b39df4">01032</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a66d20d2989de6d258122885507b39df4">ExodusII_IO_Helper::initialize_element_variables</a>(std::vector&lt;std::string&gt; names)
<a name="l01033"></a>01033 {
<a name="l01034"></a>01034   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01035"></a>01035     <span class="keywordflow">return</span>;
<a name="l01036"></a>01036 
<a name="l01037"></a>01037   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a> = names.size();
<a name="l01038"></a>01038 
<a name="l01039"></a>01039   <span class="keywordflow">if</span> ( <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a> == 0 )
<a name="l01040"></a>01040     <span class="keywordflow">return</span>;
<a name="l01041"></a>01041 
<a name="l01042"></a>01042   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a41d70cdae9baae59350e063fa7b6521a">_elem_vars_initialized</a>)
<a name="l01043"></a>01043     <span class="keywordflow">return</span>;
<a name="l01044"></a>01044   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a41d70cdae9baae59350e063fa7b6521a">_elem_vars_initialized</a> = <span class="keyword">true</span>;
<a name="l01045"></a>01045 
<a name="l01046"></a>01046   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_var_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <span class="stringliteral">&quot;e&quot;</span>, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a>);
<a name="l01047"></a>01047   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error setting number of element vars.&quot;</span>);
<a name="l01048"></a>01048 
<a name="l01049"></a>01049   <span class="comment">// Use the vvc and strings objects to emulate the behavior of</span>
<a name="l01050"></a>01050   <span class="comment">// a char** object.</span>
<a name="l01051"></a>01051   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a>);
<a name="l01052"></a>01052   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a>);
<a name="l01053"></a>01053 
<a name="l01054"></a>01054   <span class="comment">// For each string in names, allocate enough space in vvc and copy from</span>
<a name="l01055"></a>01055   <span class="comment">// the C++ string into vvc for passing to the C interface.</span>
<a name="l01056"></a>01056   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i(0); i &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a>; ++i)
<a name="l01057"></a>01057     {
<a name="l01058"></a>01058       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i].resize(names[i].size()+1);
<a name="l01059"></a>01059       std::strcpy(&amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]), names[i].c_str());
<a name="l01060"></a>01060     }
<a name="l01061"></a>01061 
<a name="l01062"></a>01062   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a>; ++i)
<a name="l01063"></a>01063     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] = &amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]); <span class="comment">// set pointer into vvc only *after* all resizing is complete</span>
<a name="l01064"></a>01064 
<a name="l01065"></a>01065   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l01066"></a>01066     {
<a name="l01067"></a>01067       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing variable name(s) to file: &quot;</span> &lt;&lt; std::endl;
<a name="l01068"></a>01068       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i(0); i &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad233519540956178d2b1a4c5f41a35e0">num_elem_vars</a>; ++i)
<a name="l01069"></a>01069         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;strings[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] &lt;&lt; std::endl;
<a name="l01070"></a>01070     }
<a name="l01071"></a>01071 
<a name="l01072"></a>01072   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_var_names(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l01073"></a>01073                                   <span class="stringliteral">&quot;e&quot;</span>,
<a name="l01074"></a>01074                                   num_elem_vars,
<a name="l01075"></a>01075                                   &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[0]<span class="comment">//var_names</span>
<a name="l01076"></a>01076                                   );
<a name="l01077"></a>01077 
<a name="l01078"></a>01078   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error setting element variable names.&quot;</span>);
<a name="l01079"></a>01079 }
<a name="l01080"></a>01080 
<a name="l01081"></a>01081 
<a name="l01082"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae540e94c31f69447563279a75d8b8317">01082</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae540e94c31f69447563279a75d8b8317">ExodusII_IO_Helper::initialize_nodal_variables</a>(std::vector&lt;std::string&gt; names)
<a name="l01083"></a>01083 {
<a name="l01084"></a>01084   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01085"></a>01085     <span class="keywordflow">return</span>;
<a name="l01086"></a>01086 
<a name="l01087"></a>01087   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a> = names.size();
<a name="l01088"></a>01088 
<a name="l01089"></a>01089   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_var_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <span class="stringliteral">&quot;n&quot;</span>, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l01090"></a>01090   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error setting number of nodal vars.&quot;</span>);
<a name="l01091"></a>01091 
<a name="l01092"></a>01092   <span class="comment">// Use the vvc and strings objects to emulate the behavior of</span>
<a name="l01093"></a>01093   <span class="comment">// a char** object.</span>
<a name="l01094"></a>01094   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l01095"></a>01095   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>);
<a name="l01096"></a>01096 
<a name="l01097"></a>01097   <span class="comment">// For each string in names, allocate enough space in vvc and copy from</span>
<a name="l01098"></a>01098   <span class="comment">// the C++ string into vvc for passing to the C interface.</span>
<a name="l01099"></a>01099   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>; i++)
<a name="l01100"></a>01100     {
<a name="l01101"></a>01101       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i].resize(names[i].size()+1);
<a name="l01102"></a>01102       std::strcpy(&amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]), names[i].c_str());
<a name="l01103"></a>01103     }
<a name="l01104"></a>01104 
<a name="l01105"></a>01105   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>; i++)
<a name="l01106"></a>01106     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] = &amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]); <span class="comment">// set pointer into vvc only *after* all resizing is complete</span>
<a name="l01107"></a>01107 
<a name="l01108"></a>01108   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l01109"></a>01109     {
<a name="l01110"></a>01110       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing variable name(s) to file: &quot;</span> &lt;&lt; std::endl;
<a name="l01111"></a>01111       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a778e11c94ca5764c5c408fef4a0b37bc">num_nodal_vars</a>;i++)
<a name="l01112"></a>01112         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;strings[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] &lt;&lt; std::endl;
<a name="l01113"></a>01113     }
<a name="l01114"></a>01114     
<a name="l01115"></a>01115   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_var_names(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l01116"></a>01116                                   <span class="stringliteral">&quot;n&quot;</span>,
<a name="l01117"></a>01117                                   num_nodal_vars,
<a name="l01118"></a>01118                                   &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[0]<span class="comment">//var_names</span>
<a name="l01119"></a>01119                                   );
<a name="l01120"></a>01120     
<a name="l01121"></a>01121   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error setting nodal variable names.&quot;</span>);
<a name="l01122"></a>01122 }
<a name="l01123"></a>01123 
<a name="l01124"></a>01124 
<a name="l01125"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa43aa8a1c29b79464d0331b79425ea19">01125</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa43aa8a1c29b79464d0331b79425ea19">ExodusII_IO_Helper::initialize_global_variables</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt; &amp; names)
<a name="l01126"></a>01126 {
<a name="l01127"></a>01127   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01128"></a>01128     <span class="keywordflow">return</span>;
<a name="l01129"></a>01129 
<a name="l01130"></a>01130   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a227de65fc6256932ed54a0f921f339e0">_global_vars_initialized</a>) 
<a name="l01131"></a>01131   {
<a name="l01132"></a>01132     <span class="keywordflow">return</span>;
<a name="l01133"></a>01133   }
<a name="l01134"></a>01134   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a227de65fc6256932ed54a0f921f339e0">_global_vars_initialized</a> = <span class="keyword">true</span>;
<a name="l01135"></a>01135   
<a name="l01136"></a>01136   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a> = names.size();
<a name="l01137"></a>01137 
<a name="l01138"></a>01138   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_var_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, <span class="stringliteral">&quot;g&quot;</span>, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>);
<a name="l01139"></a>01139   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error setting number of global vars.&quot;</span>);
<a name="l01140"></a>01140 
<a name="l01141"></a>01141   <span class="comment">// Use the vvc and strings objects to emulate the behavior of</span>
<a name="l01142"></a>01142   <span class="comment">// a char** object.</span>
<a name="l01143"></a>01143   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>);
<a name="l01144"></a>01144   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>.resize(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>);
<a name="l01145"></a>01145 
<a name="l01146"></a>01146   <span class="comment">// For each string in names, allocate enough space in vvc and copy from</span>
<a name="l01147"></a>01147   <span class="comment">// the C++ string into vvc for passing to the C interface.</span>
<a name="l01148"></a>01148   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>; i++)
<a name="l01149"></a>01149     {
<a name="l01150"></a>01150       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i].resize(names[i].size()+1);
<a name="l01151"></a>01151       std::strcpy(&amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]), names[i].c_str());
<a name="l01152"></a>01152     }
<a name="l01153"></a>01153 
<a name="l01154"></a>01154   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>; i++)
<a name="l01155"></a>01155     <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] = &amp;(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba600ee1f6cca59ec1ac632f798e6fe6">vvc</a>[i][0]); <span class="comment">// set pointer into vvc only *after* all resizing is complete</span>
<a name="l01156"></a>01156 
<a name="l01157"></a>01157   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l01158"></a>01158     {
<a name="l01159"></a>01159       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing variable name(s) to file: &quot;</span> &lt;&lt; std::endl;
<a name="l01160"></a>01160       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i(0); i &lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>; ++i)
<a name="l01161"></a>01161         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;strings[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[i] &lt;&lt; std::endl;
<a name="l01162"></a>01162     }
<a name="l01163"></a>01163 
<a name="l01164"></a>01164   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_var_names(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l01165"></a>01165                                   <span class="stringliteral">&quot;g&quot;</span>,
<a name="l01166"></a>01166                                   num_globals,
<a name="l01167"></a>01167                                   &amp;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3a168461e6fc6898f8ad0c5e74da249e">strings</a>[0]
<a name="l01168"></a>01168                                   );
<a name="l01169"></a>01169     
<a name="l01170"></a>01170   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error setting global variable names.&quot;</span>);
<a name="l01171"></a>01171 }
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 
<a name="l01174"></a>01174 
<a name="l01175"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a87f37eb3a1bc0cf5c02a247d30679bc9">01175</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a87f37eb3a1bc0cf5c02a247d30679bc9">ExodusII_IO_Helper::write_timestep</a>(<span class="keywordtype">int</span> timestep, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)
<a name="l01176"></a>01176 {
<a name="l01177"></a>01177   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01178"></a>01178     <span class="keywordflow">return</span>;
<a name="l01179"></a>01179 
<a name="l01180"></a>01180   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_time(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, timestep, &amp;time);
<a name="l01181"></a>01181   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing timestep.&quot;</span>);
<a name="l01182"></a>01182 
<a name="l01183"></a>01183   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_update(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l01184"></a>01184   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error flushing buffers to file.&quot;</span>);
<a name="l01185"></a>01185 }
<a name="l01186"></a>01186 
<a name="l01187"></a>01187 
<a name="l01188"></a>01188 
<a name="l01189"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acde78b8e3c23851279ec7a5251ae6f58">01189</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#acde78b8e3c23851279ec7a5251ae6f58">ExodusII_IO_Helper::write_element_values</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep)
<a name="l01190"></a>01190 {
<a name="l01191"></a>01191   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01192"></a>01192     <span class="keywordflow">return</span>;
<a name="l01193"></a>01193 
<a name="l01194"></a>01194   <span class="comment">// Loop over the element blocks and write the data one block at a time</span>
<a name="l01195"></a>01195   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt; subdomain_map;
<a name="l01196"></a>01196 
<a name="l01197"></a>01197   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_vars = values.size() / <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>;
<a name="l01198"></a>01198 
<a name="l01199"></a>01199   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> mesh_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); 
<a name="l01200"></a>01200   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l01201"></a>01201   <span class="comment">//loop through element and map between block and element vector</span>
<a name="l01202"></a>01202   <span class="keywordflow">for</span>( ; mesh_it != end; ++mesh_it)
<a name="l01203"></a>01203     {
<a name="l01204"></a>01204       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * elem = *mesh_it;
<a name="l01205"></a>01205 
<a name="l01206"></a>01206       <span class="comment">//Only write out the active elements</span>
<a name="l01207"></a>01207       <span class="keywordflow">if</span>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01208"></a>01208       {
<a name="l01209"></a>01209         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cur_subdomain = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l01210"></a>01210 
<a name="l01211"></a>01211         <span class="keywordflow">if</span>(cur_subdomain == 0)
<a name="l01212"></a>01212           cur_subdomain = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;subdomain_id_type&gt;::max</a>();
<a name="l01213"></a>01213 
<a name="l01214"></a>01214         subdomain_map[cur_subdomain].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l01215"></a>01215       }
<a name="l01216"></a>01216     }
<a name="l01217"></a>01217 
<a name="l01218"></a>01218   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l(0); l &lt; num_vars; ++l)
<a name="l01219"></a>01219   {
<a name="l01220"></a>01220     <span class="comment">// The size of the subdomain map is the number of blocks.</span>
<a name="l01221"></a>01221     std::map&lt;unsigned int, std::vector&lt;unsigned int&gt;  &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> it( subdomain_map.begin() );
<a name="l01222"></a>01222 
<a name="l01223"></a>01223     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j(0); it != subdomain_map.end(); ++it, ++j)
<a name="l01224"></a>01224     {
<a name="l01225"></a>01225       <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp; elem_nums = (*it).second;
<a name="l01226"></a>01226       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elems_this_block = elem_nums.size();
<a name="l01227"></a>01227       std::vector&lt;Number&gt; data( num_elems_this_block );
<a name="l01228"></a>01228       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k(0); k &lt; num_elems_this_block; ++k)
<a name="l01229"></a>01229       {
<a name="l01230"></a>01230         data[k] = values[l*<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>+elem_nums[k]];
<a name="l01231"></a>01231       }
<a name="l01232"></a>01232 
<a name="l01233"></a>01233       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_elem_var(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, timestep, l+1, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5add1e7f7ce8f31ab39b9c5a429771f4">get_block_id</a>(j), num_elems_this_block, &amp;data[0]);
<a name="l01234"></a>01234       <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing element values.&quot;</span>);
<a name="l01235"></a>01235 
<a name="l01236"></a>01236     }
<a name="l01237"></a>01237   }
<a name="l01238"></a>01238 
<a name="l01239"></a>01239   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_update(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l01240"></a>01240   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error flushing buffers to file.&quot;</span>);
<a name="l01241"></a>01241 }
<a name="l01242"></a>01242 
<a name="l01243"></a>01243 
<a name="l01244"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae98bb0ac93b4292635959132b392d0aa">01244</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ae98bb0ac93b4292635959132b392d0aa">ExodusII_IO_Helper::write_nodal_values</a>(<span class="keywordtype">int</span> var_id, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep)
<a name="l01245"></a>01245 {
<a name="l01246"></a>01246   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01247"></a>01247     <span class="keywordflow">return</span>;
<a name="l01248"></a>01248 
<a name="l01249"></a>01249   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_nodal_var(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, timestep, var_id, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>, &amp;values[0]);
<a name="l01250"></a>01250   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing nodal values.&quot;</span>);
<a name="l01251"></a>01251 
<a name="l01252"></a>01252   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_update(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l01253"></a>01253   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error flushing buffers to file.&quot;</span>);
<a name="l01254"></a>01254 }
<a name="l01255"></a>01255 
<a name="l01256"></a>01256 
<a name="l01257"></a>01257 
<a name="l01258"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad348b126b81bf9874cea7354730d2e75">01258</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad348b126b81bf9874cea7354730d2e75">ExodusII_IO_Helper::write_information_records</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt; &amp; records)
<a name="l01259"></a>01259 {
<a name="l01260"></a>01260   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01261"></a>01261     <span class="keywordflow">return</span>;
<a name="l01262"></a>01262 
<a name="l01263"></a>01263   <span class="keywordtype">int</span> num_records = records.size();
<a name="l01264"></a>01264   std::vector&lt;char *&gt; info(num_records);
<a name="l01265"></a>01265   <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i(0); i &lt; num_records;  ++i )
<a name="l01266"></a>01266   {
<a name="l01267"></a>01267     info[i] = (<span class="keywordtype">char</span>*)records[i].c_str();
<a name="l01268"></a>01268   }
<a name="l01269"></a>01269   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_info(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, num_records, &amp;info[0]);
<a name="l01270"></a>01270   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing global values.&quot;</span>);
<a name="l01271"></a>01271 
<a name="l01272"></a>01272   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_update(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l01273"></a>01273   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error flushing buffers to file.&quot;</span>);
<a name="l01274"></a>01274 }
<a name="l01275"></a>01275 
<a name="l01276"></a>01276 
<a name="l01277"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a8d1e85361d6581469bc43851d9924af0">01277</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a8d1e85361d6581469bc43851d9924af0">ExodusII_IO_Helper::write_global_values</a>(<span class="keyword">const</span> std::vector&lt;Number&gt; &amp; values, <span class="keywordtype">int</span> timestep)
<a name="l01278"></a>01278 {
<a name="l01279"></a>01279   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01280"></a>01280     <span class="keywordflow">return</span>;
<a name="l01281"></a>01281 
<a name="l01282"></a>01282   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_put_glob_vars(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>, timestep, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a57d6bc333760e06a7c291ee6d5e692f8">num_globals</a>, &amp;values[0]);
<a name="l01283"></a>01283   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error writing global values.&quot;</span>);
<a name="l01284"></a>01284 
<a name="l01285"></a>01285   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a> = exII::ex_update(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>);
<a name="l01286"></a>01286   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a59e185c90bd5d80670856873279c0f58">ex_err</a>, <span class="stringliteral">&quot;Error flushing buffers to file.&quot;</span>);
<a name="l01287"></a>01287 }  
<a name="l01288"></a>01288 
<a name="l01289"></a>01289 
<a name="l01290"></a>01290 
<a name="l01291"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">01291</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a013eaef14de760ce2e4d736f0ebbb272">ExodusII_IO_Helper::created</a>()
<a name="l01292"></a>01292 {
<a name="l01293"></a>01293   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa5fd423d103957beb37aab2a59dc5398">_created</a>;
<a name="l01294"></a>01294 }
<a name="l01295"></a>01295 
<a name="l01296"></a>01296 
<a name="l01297"></a>01297 
<a name="l01298"></a>01298 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01299"></a>01299 <span class="comment">// ExodusII_IO_Helper::Conversion class members</span>
<a name="l01300"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">01300</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">ExodusII_IO_Helper::ElementMaps::assign_conversion</a>(<span class="keyword">const</span> std::string type_str)
<a name="l01301"></a>01301 {
<a name="l01302"></a>01302   <span class="comment">// ExodusII defines the following types in contrib/exodusii/Lib/include/exodusII_int.h</span>
<a name="l01303"></a>01303   <span class="comment">// UNK         =  -1     </span>
<a name="l01304"></a>01304   <span class="comment">// NULL_ELEMENT=   0     </span>
<a name="l01305"></a>01305   <span class="comment">// TRIANGLE    =   1     </span>
<a name="l01306"></a>01306   <span class="comment">// QUAD        =   2     </span>
<a name="l01307"></a>01307   <span class="comment">// HEX         =   3     </span>
<a name="l01308"></a>01308   <span class="comment">// WEDGE       =   4     </span>
<a name="l01309"></a>01309   <span class="comment">// TETRA       =   5     </span>
<a name="l01310"></a>01310   <span class="comment">// TRUSS       =   6     </span>
<a name="l01311"></a>01311   <span class="comment">// BEAM        =   7     </span>
<a name="l01312"></a>01312   <span class="comment">// SHELL       =   8     </span>
<a name="l01313"></a>01313   <span class="comment">// SPHERE      =   9     </span>
<a name="l01314"></a>01314   <span class="comment">// CIRCLE      =  10     </span>
<a name="l01315"></a>01315   <span class="comment">// TRISHELL    =  11     </span>
<a name="l01316"></a>01316   <span class="comment">// PYRAMID     =  12      </span>
<a name="l01317"></a>01317   
<a name="l01318"></a>01318   <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;QUAD4&quot;</span>) || (type_str == <span class="stringliteral">&quot;QUAD&quot;</span>) || (type_str == <span class="stringliteral">&quot;quad&quot;</span>) || (type_str == <span class="stringliteral">&quot;quad4&quot;</span>))
<a name="l01319"></a>01319     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>);
<a name="l01320"></a>01320 
<a name="l01321"></a>01321   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;QUAD8&quot;</span>)
<a name="l01322"></a>01322     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>);
<a name="l01323"></a>01323 
<a name="l01324"></a>01324   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;QUAD9&quot;</span>)
<a name="l01325"></a>01325     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>);
<a name="l01326"></a>01326 
<a name="l01327"></a>01327   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;TRI3&quot;</span>) || (type_str == <span class="stringliteral">&quot;TRIANGLE&quot;</span>) || (type_str == <span class="stringliteral">&quot;TRI&quot;</span>) || (type_str == <span class="stringliteral">&quot;tri&quot;</span>))
<a name="l01328"></a>01328     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>);
<a name="l01329"></a>01329 
<a name="l01330"></a>01330   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;TRI6&quot;</span>)
<a name="l01331"></a>01331     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>);
<a name="l01332"></a>01332 
<a name="l01333"></a>01333   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;HEX8&quot;</span>) || (type_str == <span class="stringliteral">&quot;HEX&quot;</span>) || (type_str==<span class="stringliteral">&quot;hex8&quot;</span>)) 
<a name="l01334"></a>01334     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>);
<a name="l01335"></a>01335 
<a name="l01336"></a>01336   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;HEX20&quot;</span>)
<a name="l01337"></a>01337     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>);
<a name="l01338"></a>01338 
<a name="l01339"></a>01339   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;HEX27&quot;</span>)
<a name="l01340"></a>01340     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>);
<a name="l01341"></a>01341 
<a name="l01342"></a>01342   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((type_str == <span class="stringliteral">&quot;TETRA4&quot;</span>) || (type_str == <span class="stringliteral">&quot;TETRA&quot;</span>))
<a name="l01343"></a>01343     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>);
<a name="l01344"></a>01344 
<a name="l01345"></a>01345   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;TETRA10&quot;</span>)
<a name="l01346"></a>01346     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>);
<a name="l01347"></a>01347 
<a name="l01348"></a>01348   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;WEDGE&quot;</span>)
<a name="l01349"></a>01349     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>);
<a name="l01350"></a>01350 
<a name="l01351"></a>01351   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;WEDGE15&quot;</span>)
<a name="l01352"></a>01352     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>);
<a name="l01353"></a>01353 
<a name="l01354"></a>01354   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;WEDGE18&quot;</span>)
<a name="l01355"></a>01355     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>);
<a name="l01356"></a>01356 
<a name="l01357"></a>01357   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (type_str == <span class="stringliteral">&quot;PYRAMID&quot;</span> || type_str == <span class="stringliteral">&quot;PYRAMID5&quot;</span>)
<a name="l01358"></a>01358     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>);
<a name="l01359"></a>01359 
<a name="l01360"></a>01360   <span class="keywordflow">else</span>
<a name="l01361"></a>01361     {
<a name="l01362"></a>01362       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR! Unrecognized element type_str: &quot;</span> &lt;&lt; type_str &lt;&lt; std::endl;
<a name="l01363"></a>01363       libmesh_error();
<a name="l01364"></a>01364     }
<a name="l01365"></a>01365 
<a name="l01366"></a>01366   libmesh_error();
<a name="l01367"></a>01367   
<a name="l01368"></a>01368   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ac4b7cb17e2a382a1d7a2db31ebde633e">tri3_node_map</a>, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a9bf1c63066228938dea776e174cc7169">tri_edge_map</a>, <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#a48fa958b2be407467f9c2cae59f22af3">tri_inverse_edge_map</a>, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>,<span class="stringliteral">&quot;TRI3&quot;</span>); <span class="comment">// dummy</span>
<a name="l01369"></a>01369   <span class="keywordflow">return</span> conv;  
<a name="l01370"></a>01370 }
<a name="l01371"></a>01371 
<a name="l01372"></a>01372 
<a name="l01373"></a>01373 
<a name="l01374"></a><a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#acf296176267207c198ffb17156439b24">01374</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">ExodusII_IO_Helper::ElementMaps::assign_conversion</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l01375"></a>01375 {
<a name="l01376"></a>01376   <span class="keywordflow">switch</span> (type)
<a name="l01377"></a>01377     {
<a name="l01378"></a>01378 
<a name="l01379"></a>01379     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01380"></a>01380       {
<a name="l01381"></a>01381         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(quad4_node_map, quad_edge_map, quad_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>, <span class="stringliteral">&quot;QUAD4&quot;</span>);
<a name="l01382"></a>01382         <span class="keywordflow">return</span> conv;
<a name="l01383"></a>01383       }
<a name="l01384"></a>01384 
<a name="l01385"></a>01385     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01386"></a>01386       {
<a name="l01387"></a>01387         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(quad8_node_map, quad_edge_map, quad_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>, <span class="stringliteral">&quot;QUAD8&quot;</span>);
<a name="l01388"></a>01388         <span class="keywordflow">return</span> conv;
<a name="l01389"></a>01389       }
<a name="l01390"></a>01390       
<a name="l01391"></a>01391     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01392"></a>01392       {
<a name="l01393"></a>01393         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(quad9_node_map, quad_edge_map, quad_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>, <span class="stringliteral">&quot;QUAD9&quot;</span>);
<a name="l01394"></a>01394         <span class="keywordflow">return</span> conv;
<a name="l01395"></a>01395       }
<a name="l01396"></a>01396       
<a name="l01397"></a>01397     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01398"></a>01398       {
<a name="l01399"></a>01399         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tri3_node_map, tri_edge_map, tri_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>, <span class="stringliteral">&quot;TRI3&quot;</span>);
<a name="l01400"></a>01400         <span class="keywordflow">return</span> conv;
<a name="l01401"></a>01401       }
<a name="l01402"></a>01402       
<a name="l01403"></a>01403     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01404"></a>01404       {
<a name="l01405"></a>01405         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tri6_node_map, tri_edge_map, tri_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>, <span class="stringliteral">&quot;TRI6&quot;</span>);
<a name="l01406"></a>01406         <span class="keywordflow">return</span> conv;
<a name="l01407"></a>01407       }
<a name="l01408"></a>01408       
<a name="l01409"></a>01409     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01410"></a>01410       {
<a name="l01411"></a>01411         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(hex8_node_map, hex_face_map, hex_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>, <span class="stringliteral">&quot;HEX8&quot;</span>);
<a name="l01412"></a>01412         <span class="keywordflow">return</span> conv;
<a name="l01413"></a>01413       }
<a name="l01414"></a>01414       
<a name="l01415"></a>01415     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01416"></a>01416       {
<a name="l01417"></a>01417         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(hex20_node_map, hex_face_map, hex_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>, <span class="stringliteral">&quot;HEX20&quot;</span>);
<a name="l01418"></a>01418         <span class="keywordflow">return</span> conv;
<a name="l01419"></a>01419       }
<a name="l01420"></a>01420       
<a name="l01421"></a>01421     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01422"></a>01422       {
<a name="l01423"></a>01423         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(hex27_node_map, hex27_face_map, hex27_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>, <span class="stringliteral">&quot;HEX27&quot;</span>);
<a name="l01424"></a>01424         <span class="keywordflow">return</span> conv;
<a name="l01425"></a>01425       }
<a name="l01426"></a>01426       
<a name="l01427"></a>01427     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01428"></a>01428       {
<a name="l01429"></a>01429         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tet4_node_map, tet_face_map, tet_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>, <span class="stringliteral">&quot;TETRA4&quot;</span>);
<a name="l01430"></a>01430         <span class="keywordflow">return</span> conv;
<a name="l01431"></a>01431       }
<a name="l01432"></a>01432       
<a name="l01433"></a>01433     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01434"></a>01434       {
<a name="l01435"></a>01435         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tet10_node_map, tet_face_map, tet_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>, <span class="stringliteral">&quot;TETRA10&quot;</span>);
<a name="l01436"></a>01436         <span class="keywordflow">return</span> conv;
<a name="l01437"></a>01437       }
<a name="l01438"></a>01438 
<a name="l01439"></a>01439     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01440"></a>01440       {
<a name="l01441"></a>01441         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(prism6_node_map, prism_face_map, prism_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>, <span class="stringliteral">&quot;WEDGE&quot;</span>);
<a name="l01442"></a>01442         <span class="keywordflow">return</span> conv;
<a name="l01443"></a>01443       }
<a name="l01444"></a>01444 
<a name="l01445"></a>01445     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l01446"></a>01446       {
<a name="l01447"></a>01447         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(prism15_node_map, prism_face_map, prism_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>, <span class="stringliteral">&quot;WEDGE15&quot;</span>);
<a name="l01448"></a>01448         <span class="keywordflow">return</span> conv;
<a name="l01449"></a>01449       }
<a name="l01450"></a>01450 
<a name="l01451"></a>01451     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l01452"></a>01452       {
<a name="l01453"></a>01453         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(prism18_node_map, prism_face_map, prism_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>, <span class="stringliteral">&quot;WEDGE18&quot;</span>);
<a name="l01454"></a>01454         <span class="keywordflow">return</span> conv;
<a name="l01455"></a>01455       }
<a name="l01456"></a>01456 
<a name="l01457"></a>01457     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l01458"></a>01458       {
<a name="l01459"></a>01459         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(pyramid5_node_map, pyramid_face_map, pyramid_inverse_face_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>, <span class="stringliteral">&quot;PYRAMID5&quot;</span>);
<a name="l01460"></a>01460         <span class="keywordflow">return</span> conv;
<a name="l01461"></a>01461       }
<a name="l01462"></a>01462         
<a name="l01463"></a>01463     <span class="keywordflow">default</span>:
<a name="l01464"></a>01464       libmesh_error();
<a name="l01465"></a>01465     }
<a name="l01466"></a>01466     
<a name="l01467"></a>01467   libmesh_error();
<a name="l01468"></a>01468     
<a name="l01469"></a>01469   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">Conversion</a> conv(tri3_node_map, tri_edge_map, tri_inverse_edge_map, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>, <span class="stringliteral">&quot;TRI3&quot;</span>); <span class="comment">// dummy</span>
<a name="l01470"></a>01470   <span class="keywordflow">return</span> conv;  
<a name="l01471"></a>01471 }
<a name="l01472"></a>01472 
<a name="l01473"></a>01473 } <span class="comment">// namespace libMesh</span>
<a name="l01474"></a>01474 
<a name="l01475"></a>01475 
<a name="l01476"></a>01476 
<a name="l01477"></a>01477 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_EXODUS_API</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
