<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_base.C</div>  </div>
</div>
<div class="contents">
<a href="fe__base_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_base.C 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="comment">// For projection code:</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="periodic__boundaries_8h.php">periodic_boundaries.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// FEBase class members</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">00047</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00048"></a>00048                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="comment">// The stupid AutoPtr&lt;FEBase&gt; ap(); return ap;</span>
<a name="l00051"></a>00051   <span class="comment">// construct is required to satisfy IBM&#39;s xlC</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">switch</span> (dim)
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055       <span class="comment">// 0D</span>
<a name="l00056"></a>00056     <span class="keywordflow">case</span> 0:
<a name="l00057"></a>00057       {
<a name="l00058"></a>00058         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00059"></a>00059           {
<a name="l00060"></a>00060           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00061"></a>00061             {
<a name="l00062"></a>00062               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,CLOUGH&gt;</a>(fet));
<a name="l00063"></a>00063               <span class="keywordflow">return</span> ap;
<a name="l00064"></a>00064             }
<a name="l00065"></a>00065             
<a name="l00066"></a>00066           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00067"></a>00067             {
<a name="l00068"></a>00068               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,HERMITE&gt;</a>(fet));
<a name="l00069"></a>00069               <span class="keywordflow">return</span> ap;
<a name="l00070"></a>00070             }
<a name="l00071"></a>00071             
<a name="l00072"></a>00072           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00073"></a>00073             {
<a name="l00074"></a>00074               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,LAGRANGE&gt;</a>(fet));
<a name="l00075"></a>00075               <span class="keywordflow">return</span> ap;
<a name="l00076"></a>00076             }
<a name="l00077"></a>00077                    
<a name="l00078"></a>00078           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00079"></a>00079             {
<a name="l00080"></a>00080               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,HIERARCHIC&gt;</a>(fet));
<a name="l00081"></a>00081               <span class="keywordflow">return</span> ap;
<a name="l00082"></a>00082             }
<a name="l00083"></a>00083             
<a name="l00084"></a>00084           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00085"></a>00085             {
<a name="l00086"></a>00086               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,MONOMIAL&gt;</a>(fet));
<a name="l00087"></a>00087               <span class="keywordflow">return</span> ap;
<a name="l00088"></a>00088             }
<a name="l00089"></a>00089             
<a name="l00090"></a>00090 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00092"></a>00092             {
<a name="l00093"></a>00093               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,SZABAB&gt;</a>(fet));
<a name="l00094"></a>00094               <span class="keywordflow">return</span> ap;
<a name="l00095"></a>00095             }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00098"></a>00098             {
<a name="l00099"></a>00099               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;0,BERNSTEIN&gt;</a>(fet));
<a name="l00100"></a>00100               <span class="keywordflow">return</span> ap;
<a name="l00101"></a>00101             }
<a name="l00102"></a>00102 <span class="preprocessor">#endif</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00104"></a>00104           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00105"></a>00105             {
<a name="l00106"></a>00106               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ&lt;0&gt;</a>(fet));
<a name="l00107"></a>00107               <span class="keywordflow">return</span> ap;
<a name="l00108"></a>00108             }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00111"></a>00111           {
<a name="l00112"></a>00112               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEScalar.php">FEScalar&lt;0&gt;</a>(fet));
<a name="l00113"></a>00113               <span class="keywordflow">return</span> ap;
<a name="l00114"></a>00114           }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116           <span class="keywordflow">default</span>:
<a name="l00117"></a>00117             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> &lt;&lt; std::endl;
<a name="l00118"></a>00118             libmesh_error();
<a name="l00119"></a>00119           }
<a name="l00120"></a>00120       }
<a name="l00121"></a>00121       <span class="comment">// 1D</span>
<a name="l00122"></a>00122     <span class="keywordflow">case</span> 1:
<a name="l00123"></a>00123       {
<a name="l00124"></a>00124         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00125"></a>00125           {
<a name="l00126"></a>00126           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00127"></a>00127             {
<a name="l00128"></a>00128               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,CLOUGH&gt;</a>(fet));
<a name="l00129"></a>00129               <span class="keywordflow">return</span> ap;
<a name="l00130"></a>00130             }
<a name="l00131"></a>00131             
<a name="l00132"></a>00132           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00133"></a>00133             {
<a name="l00134"></a>00134               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,HERMITE&gt;</a>(fet));
<a name="l00135"></a>00135               <span class="keywordflow">return</span> ap;
<a name="l00136"></a>00136             }
<a name="l00137"></a>00137             
<a name="l00138"></a>00138           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00139"></a>00139             {
<a name="l00140"></a>00140               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,LAGRANGE&gt;</a>(fet));
<a name="l00141"></a>00141               <span class="keywordflow">return</span> ap;
<a name="l00142"></a>00142             }
<a name="l00143"></a>00143                    
<a name="l00144"></a>00144           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00145"></a>00145             {
<a name="l00146"></a>00146               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,HIERARCHIC&gt;</a>(fet));
<a name="l00147"></a>00147               <span class="keywordflow">return</span> ap;
<a name="l00148"></a>00148             }
<a name="l00149"></a>00149             
<a name="l00150"></a>00150           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00151"></a>00151             {
<a name="l00152"></a>00152               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,MONOMIAL&gt;</a>(fet));
<a name="l00153"></a>00153               <span class="keywordflow">return</span> ap;
<a name="l00154"></a>00154             }
<a name="l00155"></a>00155             
<a name="l00156"></a>00156 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00158"></a>00158             {
<a name="l00159"></a>00159               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,SZABAB&gt;</a>(fet));
<a name="l00160"></a>00160               <span class="keywordflow">return</span> ap;
<a name="l00161"></a>00161             }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00164"></a>00164             {
<a name="l00165"></a>00165               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;</a>(fet));
<a name="l00166"></a>00166               <span class="keywordflow">return</span> ap;
<a name="l00167"></a>00167             }
<a name="l00168"></a>00168 <span class="preprocessor">#endif</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span>
<a name="l00170"></a>00170           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00171"></a>00171             {
<a name="l00172"></a>00172               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ&lt;1&gt;</a>(fet));
<a name="l00173"></a>00173               <span class="keywordflow">return</span> ap;
<a name="l00174"></a>00174             }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00177"></a>00177           {
<a name="l00178"></a>00178               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEScalar.php">FEScalar&lt;1&gt;</a>(fet));
<a name="l00179"></a>00179               <span class="keywordflow">return</span> ap;
<a name="l00180"></a>00180           }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182           <span class="keywordflow">default</span>:
<a name="l00183"></a>00183             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> &lt;&lt; std::endl;
<a name="l00184"></a>00184             libmesh_error();
<a name="l00185"></a>00185           }
<a name="l00186"></a>00186       }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       
<a name="l00189"></a>00189       <span class="comment">// 2D</span>
<a name="l00190"></a>00190     <span class="keywordflow">case</span> 2:
<a name="l00191"></a>00191       {
<a name="l00192"></a>00192         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00193"></a>00193           {
<a name="l00194"></a>00194           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00195"></a>00195             {
<a name="l00196"></a>00196               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,CLOUGH&gt;</a>(fet));
<a name="l00197"></a>00197               <span class="keywordflow">return</span> ap;
<a name="l00198"></a>00198             }
<a name="l00199"></a>00199             
<a name="l00200"></a>00200           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00201"></a>00201             {
<a name="l00202"></a>00202               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,HERMITE&gt;</a>(fet));
<a name="l00203"></a>00203               <span class="keywordflow">return</span> ap;
<a name="l00204"></a>00204             }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00207"></a>00207             {
<a name="l00208"></a>00208               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,LAGRANGE&gt;</a>(fet));
<a name="l00209"></a>00209               <span class="keywordflow">return</span> ap;
<a name="l00210"></a>00210             }
<a name="l00211"></a>00211             
<a name="l00212"></a>00212           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00213"></a>00213             {
<a name="l00214"></a>00214               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,HIERARCHIC&gt;</a>(fet));
<a name="l00215"></a>00215               <span class="keywordflow">return</span> ap;
<a name="l00216"></a>00216             }
<a name="l00217"></a>00217             
<a name="l00218"></a>00218           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00219"></a>00219             {
<a name="l00220"></a>00220               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,MONOMIAL&gt;</a>(fet));
<a name="l00221"></a>00221               <span class="keywordflow">return</span> ap;
<a name="l00222"></a>00222             }
<a name="l00223"></a>00223             
<a name="l00224"></a>00224 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00226"></a>00226             {
<a name="l00227"></a>00227               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,SZABAB&gt;</a>(fet));
<a name="l00228"></a>00228               <span class="keywordflow">return</span> ap;
<a name="l00229"></a>00229             }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00232"></a>00232             {
<a name="l00233"></a>00233               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,BERNSTEIN&gt;</a>(fet));
<a name="l00234"></a>00234               <span class="keywordflow">return</span> ap;
<a name="l00235"></a>00235             }
<a name="l00236"></a>00236 <span class="preprocessor">#endif</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>
<a name="l00238"></a>00238           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00239"></a>00239             {
<a name="l00240"></a>00240               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ&lt;2&gt;</a>(fet));
<a name="l00241"></a>00241               <span class="keywordflow">return</span> ap;
<a name="l00242"></a>00242             }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00245"></a>00245           {
<a name="l00246"></a>00246               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEScalar.php">FEScalar&lt;2&gt;</a>(fet));
<a name="l00247"></a>00247               <span class="keywordflow">return</span> ap;
<a name="l00248"></a>00248           }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250           <span class="keywordflow">default</span>:
<a name="l00251"></a>00251             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> &lt;&lt; std::endl;
<a name="l00252"></a>00252             libmesh_error();
<a name="l00253"></a>00253           }
<a name="l00254"></a>00254       }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256       
<a name="l00257"></a>00257       <span class="comment">// 3D</span>
<a name="l00258"></a>00258     <span class="keywordflow">case</span> 3:
<a name="l00259"></a>00259       {
<a name="l00260"></a>00260         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00261"></a>00261           {
<a name="l00262"></a>00262           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00263"></a>00263             {
<a name="l00264"></a>00264               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Clough-Tocher elements currently only support 1D and 2D&quot;</span>
<a name="l00265"></a>00265                             &lt;&lt; std::endl;
<a name="l00266"></a>00266               libmesh_error();
<a name="l00267"></a>00267             }
<a name="l00268"></a>00268             
<a name="l00269"></a>00269           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00270"></a>00270             {
<a name="l00271"></a>00271               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HERMITE&gt;</a>(fet));
<a name="l00272"></a>00272               <span class="keywordflow">return</span> ap;
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274             
<a name="l00275"></a>00275           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00276"></a>00276             {
<a name="l00277"></a>00277               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,LAGRANGE&gt;</a>(fet));
<a name="l00278"></a>00278               <span class="keywordflow">return</span> ap;
<a name="l00279"></a>00279             }
<a name="l00280"></a>00280             
<a name="l00281"></a>00281           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00282"></a>00282             {
<a name="l00283"></a>00283               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HIERARCHIC&gt;</a>(fet));
<a name="l00284"></a>00284               <span class="keywordflow">return</span> ap;
<a name="l00285"></a>00285             }
<a name="l00286"></a>00286             
<a name="l00287"></a>00287           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00288"></a>00288             {
<a name="l00289"></a>00289               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,MONOMIAL&gt;</a>(fet));
<a name="l00290"></a>00290               <span class="keywordflow">return</span> ap;
<a name="l00291"></a>00291             }
<a name="l00292"></a>00292             
<a name="l00293"></a>00293 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00295"></a>00295             {
<a name="l00296"></a>00296               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,SZABAB&gt;</a>(fet));
<a name="l00297"></a>00297               <span class="keywordflow">return</span> ap;
<a name="l00298"></a>00298             }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00301"></a>00301             {
<a name="l00302"></a>00302               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;</a>(fet));
<a name="l00303"></a>00303               <span class="keywordflow">return</span> ap;
<a name="l00304"></a>00304             }
<a name="l00305"></a>00305 <span class="preprocessor">#endif</span>
<a name="l00306"></a>00306 <span class="preprocessor"></span>
<a name="l00307"></a>00307           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00308"></a>00308             {
<a name="l00309"></a>00309               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ&lt;3&gt;</a>(fet));
<a name="l00310"></a>00310               <span class="keywordflow">return</span> ap;
<a name="l00311"></a>00311             }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00314"></a>00314           {
<a name="l00315"></a>00315               <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEScalar.php">FEScalar&lt;3&gt;</a>(fet));
<a name="l00316"></a>00316               <span class="keywordflow">return</span> ap;
<a name="l00317"></a>00317           }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319           <span class="keywordflow">default</span>:
<a name="l00320"></a>00320             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> &lt;&lt; std::endl;
<a name="l00321"></a>00321             libmesh_error();
<a name="l00322"></a>00322           }
<a name="l00323"></a>00323       }
<a name="l00324"></a>00324 
<a name="l00325"></a>00325     <span class="keywordflow">default</span>:
<a name="l00326"></a>00326       libmesh_error();
<a name="l00327"></a>00327     }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   libmesh_error();
<a name="l00330"></a>00330   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(NULL);
<a name="l00331"></a>00331   <span class="keywordflow">return</span> ap;
<a name="l00332"></a>00332 }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span>
<a name="l00342"></a>00342 
<a name="l00343"></a><a class="code" href="classlibMesh_1_1FEBase.php#a42df651089ddc60e9baea1a73633ed90">00343</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#a42df651089ddc60e9baea1a73633ed90">FEBase::build_InfFE</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00344"></a>00344                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet)
<a name="l00345"></a>00345 {
<a name="l00346"></a>00346   <span class="comment">// The stupid AutoPtr&lt;FEBase&gt; ap(); return ap;</span>
<a name="l00347"></a>00347   <span class="comment">// construct is required to satisfy IBM&#39;s xlC</span>
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <span class="keywordflow">switch</span> (dim)
<a name="l00350"></a>00350     {
<a name="l00351"></a>00351 
<a name="l00352"></a>00352       <span class="comment">// 1D</span>
<a name="l00353"></a>00353     <span class="keywordflow">case</span> 1:
<a name="l00354"></a>00354       {
<a name="l00355"></a>00355         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00356"></a>00356           {
<a name="l00357"></a>00357           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00358"></a>00358             {
<a name="l00359"></a>00359               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00360"></a>00360                             &lt;&lt; <span class="stringliteral">&quot; with FEFamily = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00361"></a>00361               libmesh_error();
<a name="l00362"></a>00362             }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00365"></a>00365             {
<a name="l00366"></a>00366               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00367"></a>00367                 {
<a name="l00368"></a>00368                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00369"></a>00369                     {
<a name="l00370"></a>00370                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;</a>(fet));
<a name="l00371"></a>00371                       <span class="keywordflow">return</span> ap;
<a name="l00372"></a>00372                     }
<a name="l00373"></a>00373                   <span class="keywordflow">default</span>:
<a name="l00374"></a>00374                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00375"></a>00375                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00376"></a>00376                     libmesh_error();
<a name="l00377"></a>00377                 }
<a name="l00378"></a>00378             }
<a name="l00379"></a>00379 
<a name="l00380"></a>00380           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00381"></a>00381             {
<a name="l00382"></a>00382               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00383"></a>00383                 {
<a name="l00384"></a>00384                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00385"></a>00385                     {
<a name="l00386"></a>00386                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;</a>(fet));
<a name="l00387"></a>00387                       <span class="keywordflow">return</span> ap;
<a name="l00388"></a>00388                     }
<a name="l00389"></a>00389                   <span class="keywordflow">default</span>:
<a name="l00390"></a>00390                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00391"></a>00391                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00392"></a>00392                     libmesh_error();
<a name="l00393"></a>00393                 }
<a name="l00394"></a>00394             }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:
<a name="l00397"></a>00397             {
<a name="l00398"></a>00398               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00399"></a>00399                 {
<a name="l00400"></a>00400                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00401"></a>00401                     {
<a name="l00402"></a>00402                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;</a>(fet));
<a name="l00403"></a>00403                       <span class="keywordflow">return</span> ap;
<a name="l00404"></a>00404                     }
<a name="l00405"></a>00405                   <span class="keywordflow">default</span>:
<a name="l00406"></a>00406                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00407"></a>00407                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00408"></a>00408                     libmesh_error();
<a name="l00409"></a>00409                 }
<a name="l00410"></a>00410             }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00413"></a>00413             {
<a name="l00414"></a>00414               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00415"></a>00415                 {
<a name="l00416"></a>00416                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00417"></a>00417                     {
<a name="l00418"></a>00418                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;</a>(fet));
<a name="l00419"></a>00419                       <span class="keywordflow">return</span> ap;
<a name="l00420"></a>00420                     }
<a name="l00421"></a>00421                   <span class="keywordflow">default</span>:
<a name="l00422"></a>00422                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00423"></a>00423                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00424"></a>00424                     libmesh_error();
<a name="l00425"></a>00425                 }
<a name="l00426"></a>00426             }
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429             
<a name="l00430"></a>00430           <span class="keywordflow">default</span>:
<a name="l00431"></a>00431             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.radial_family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00432"></a>00432             libmesh_error();
<a name="l00433"></a>00433           }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435       }
<a name="l00436"></a>00436 
<a name="l00437"></a>00437       
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440       <span class="comment">// 2D</span>
<a name="l00441"></a>00441     <span class="keywordflow">case</span> 2:
<a name="l00442"></a>00442       {
<a name="l00443"></a>00443         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00444"></a>00444           {
<a name="l00445"></a>00445           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00446"></a>00446             {
<a name="l00447"></a>00447               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00448"></a>00448                             &lt;&lt; <span class="stringliteral">&quot; with FEFamily = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00449"></a>00449               libmesh_error();
<a name="l00450"></a>00450             }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00453"></a>00453             {
<a name="l00454"></a>00454               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00455"></a>00455                 {
<a name="l00456"></a>00456                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00457"></a>00457                     {
<a name="l00458"></a>00458                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;</a>(fet));
<a name="l00459"></a>00459                       <span class="keywordflow">return</span> ap;
<a name="l00460"></a>00460                     }
<a name="l00461"></a>00461                   <span class="keywordflow">default</span>:
<a name="l00462"></a>00462                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00463"></a>00463                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00464"></a>00464                     libmesh_error();
<a name="l00465"></a>00465                 }
<a name="l00466"></a>00466             }
<a name="l00467"></a>00467 
<a name="l00468"></a>00468           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00469"></a>00469             {
<a name="l00470"></a>00470               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00471"></a>00471                 {
<a name="l00472"></a>00472                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00473"></a>00473                     {
<a name="l00474"></a>00474                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;</a>(fet));
<a name="l00475"></a>00475                       <span class="keywordflow">return</span> ap;
<a name="l00476"></a>00476                     }
<a name="l00477"></a>00477                   <span class="keywordflow">default</span>:
<a name="l00478"></a>00478                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00479"></a>00479                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00480"></a>00480                     libmesh_error();
<a name="l00481"></a>00481                 }
<a name="l00482"></a>00482             }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:
<a name="l00485"></a>00485             {
<a name="l00486"></a>00486               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00487"></a>00487                 {
<a name="l00488"></a>00488                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00489"></a>00489                     {
<a name="l00490"></a>00490                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;</a>(fet));
<a name="l00491"></a>00491                       <span class="keywordflow">return</span> ap;
<a name="l00492"></a>00492                     }
<a name="l00493"></a>00493                   <span class="keywordflow">default</span>:
<a name="l00494"></a>00494                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00495"></a>00495                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00496"></a>00496                     libmesh_error();
<a name="l00497"></a>00497                 }
<a name="l00498"></a>00498             }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00501"></a>00501             {
<a name="l00502"></a>00502               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00503"></a>00503                 {
<a name="l00504"></a>00504                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00505"></a>00505                     {
<a name="l00506"></a>00506                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;</a>(fet));
<a name="l00507"></a>00507                       <span class="keywordflow">return</span> ap;
<a name="l00508"></a>00508                     }
<a name="l00509"></a>00509                   <span class="keywordflow">default</span>:
<a name="l00510"></a>00510                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00511"></a>00511                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00512"></a>00512                     libmesh_error();
<a name="l00513"></a>00513                 }
<a name="l00514"></a>00514             }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 
<a name="l00517"></a>00517             
<a name="l00518"></a>00518           <span class="keywordflow">default</span>:
<a name="l00519"></a>00519             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.radial_family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00520"></a>00520             libmesh_error();
<a name="l00521"></a>00521           }
<a name="l00522"></a>00522 
<a name="l00523"></a>00523       }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525       
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528       <span class="comment">// 3D</span>
<a name="l00529"></a>00529     <span class="keywordflow">case</span> 3:
<a name="l00530"></a>00530       {
<a name="l00531"></a>00531         <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00532"></a>00532           {
<a name="l00533"></a>00533           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00534"></a>00534             {
<a name="l00535"></a>00535               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00536"></a>00536                             &lt;&lt; <span class="stringliteral">&quot; with FEFamily = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00537"></a>00537               libmesh_error();
<a name="l00538"></a>00538             }
<a name="l00539"></a>00539 
<a name="l00540"></a>00540           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00541"></a>00541             {
<a name="l00542"></a>00542               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00543"></a>00543                 {
<a name="l00544"></a>00544                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00545"></a>00545                     {
<a name="l00546"></a>00546                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;</a>(fet));
<a name="l00547"></a>00547                       <span class="keywordflow">return</span> ap;
<a name="l00548"></a>00548                     }
<a name="l00549"></a>00549                   <span class="keywordflow">default</span>:
<a name="l00550"></a>00550                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00551"></a>00551                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00552"></a>00552                     libmesh_error();
<a name="l00553"></a>00553                 }
<a name="l00554"></a>00554             }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00557"></a>00557             {
<a name="l00558"></a>00558               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00559"></a>00559                 {
<a name="l00560"></a>00560                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00561"></a>00561                     {
<a name="l00562"></a>00562                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;</a>(fet));
<a name="l00563"></a>00563                       <span class="keywordflow">return</span> ap;
<a name="l00564"></a>00564                     }
<a name="l00565"></a>00565                   <span class="keywordflow">default</span>:
<a name="l00566"></a>00566                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00567"></a>00567                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00568"></a>00568                     libmesh_error();
<a name="l00569"></a>00569                 }
<a name="l00570"></a>00570             }
<a name="l00571"></a>00571 
<a name="l00572"></a>00572           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:
<a name="l00573"></a>00573             {
<a name="l00574"></a>00574               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00575"></a>00575                 {
<a name="l00576"></a>00576                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00577"></a>00577                     {
<a name="l00578"></a>00578                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;</a>(fet));
<a name="l00579"></a>00579                       <span class="keywordflow">return</span> ap;
<a name="l00580"></a>00580                     }
<a name="l00581"></a>00581                   <span class="keywordflow">default</span>:
<a name="l00582"></a>00582                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00583"></a>00583                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00584"></a>00584                     libmesh_error();
<a name="l00585"></a>00585                 }
<a name="l00586"></a>00586             }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00589"></a>00589             {
<a name="l00590"></a>00590               <span class="keywordflow">switch</span> (fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00591"></a>00591                 {
<a name="l00592"></a>00592                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00593"></a>00593                     {
<a name="l00594"></a>00594                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;</a>(fet));
<a name="l00595"></a>00595                       <span class="keywordflow">return</span> ap;
<a name="l00596"></a>00596                     }
<a name="l00597"></a>00597                   <span class="keywordflow">default</span>:
<a name="l00598"></a>00598                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Don&#39;t build an infinite element &quot;</span> &lt;&lt; std::endl
<a name="l00599"></a>00599                                   &lt;&lt; <span class="stringliteral">&quot; with InfMapType = &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt;&lt; std::endl;
<a name="l00600"></a>00600                     libmesh_error();
<a name="l00601"></a>00601                 }
<a name="l00602"></a>00602             }
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605             
<a name="l00606"></a>00606           <span class="keywordflow">default</span>:
<a name="l00607"></a>00607             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.radial_family= &quot;</span> &lt;&lt; fet.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00608"></a>00608             libmesh_error();
<a name="l00609"></a>00609           }
<a name="l00610"></a>00610       }
<a name="l00611"></a>00611 
<a name="l00612"></a>00612     <span class="keywordflow">default</span>:
<a name="l00613"></a>00613       libmesh_error();
<a name="l00614"></a>00614     }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616   libmesh_error();
<a name="l00617"></a>00617   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap(NULL);
<a name="l00618"></a>00618   <span class="keywordflow">return</span> ap;
<a name="l00619"></a>00619 }
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span>
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a><a class="code" href="classlibMesh_1_1FEBase.php#aec0d64ab86b8d4ffcfc90588ace98524">00636</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aec0d64ab86b8d4ffcfc90588ace98524">FEBase::compute_shape_functions</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*)
<a name="l00637"></a>00637 {
<a name="l00638"></a>00638   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00639"></a>00639   <span class="comment">// Compute the shape function values (and derivatives)</span>
<a name="l00640"></a>00640   <span class="comment">// at the Quadrature points.  Note that the actual values</span>
<a name="l00641"></a>00641   <span class="comment">// have already been computed via init_shape_functions</span>
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   <span class="comment">// Start logging the shape function computation</span>
<a name="l00644"></a>00644   START_LOG(<span class="stringliteral">&quot;compute_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> = <span class="keyword">true</span>;
<a name="l00647"></a>00647 
<a name="l00648"></a>00648   <span class="comment">// If the user forgot to request anything, we&#39;ll be safe and</span>
<a name="l00649"></a>00649   <span class="comment">// calculate everything:</span>
<a name="l00650"></a>00650 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00651"></a>00651 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a> &amp;&amp; !<a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> &amp;&amp; !<a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>)
<a name="l00652"></a>00652     <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a> = <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>;
<a name="l00653"></a>00653 <span class="preprocessor">#else</span>
<a name="l00654"></a>00654 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a> &amp;&amp; !<a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>)
<a name="l00655"></a>00655     <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a> = <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>;
<a name="l00656"></a>00656 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00657"></a>00657 <span class="preprocessor"></span>
<a name="l00658"></a>00658   <span class="comment">// Compute the value of the derivative shape function i at quadrature point p</span>
<a name="l00659"></a>00659   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a>)
<a name="l00660"></a>00660     {
<a name="l00661"></a>00661 
<a name="l00662"></a>00662     <span class="keywordflow">case</span> 0: <span class="comment">// No derivatives in 0D</span>
<a name="l00663"></a>00663         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>)
<a name="l00664"></a>00664           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>.size(); i++)
<a name="l00665"></a>00665             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i].size(); p++)
<a name="l00666"></a>00666               {
<a name="l00667"></a>00667                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](0) = 0.;
<a name="l00668"></a>00668               
<a name="l00669"></a>00669 <span class="preprocessor">#if LIBMESH_DIM&gt;1</span>
<a name="l00670"></a>00670 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](1) = <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>[i][p] = 0.;
<a name="l00671"></a>00671 <span class="preprocessor">#endif</span>
<a name="l00672"></a>00672 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM&gt;2</span>
<a name="l00673"></a>00673 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](2) = <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>[i][p] = 0.;
<a name="l00674"></a>00674 <span class="preprocessor">#endif</span>
<a name="l00675"></a>00675 <span class="preprocessor"></span>              }
<a name="l00676"></a>00676 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00677"></a>00677 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>)
<a name="l00678"></a>00678           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>.size(); i++)
<a name="l00679"></a>00679             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i].size(); p++)
<a name="l00680"></a>00680               {
<a name="l00681"></a>00681                 <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,0) = <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>[i][p] = 0.;
<a name="l00682"></a>00682 <span class="preprocessor">#if LIBMESH_DIM&gt;1</span>
<a name="l00683"></a>00683 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,1) = <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>[i][p] = 
<a name="l00684"></a>00684                   d2phi[i][p](1,0) = 0.;
<a name="l00685"></a>00685                 d2phi[i][p](1,1) = <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>[i][p] = 0.;
<a name="l00686"></a>00686 <span class="preprocessor">#endif</span>
<a name="l00687"></a>00687 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM&gt;2</span>
<a name="l00688"></a>00688 <span class="preprocessor"></span>                d2phi[i][p](0,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>[i][p] =
<a name="l00689"></a>00689                   d2phi[i][p](2,0) = 0.;
<a name="l00690"></a>00690                 d2phi[i][p](1,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>[i][p] = 
<a name="l00691"></a>00691                   d2phi[i][p](2,1) = 0.;
<a name="l00692"></a>00692                 d2phi[i][p](2,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>[i][p] = 0.;
<a name="l00693"></a>00693 <span class="preprocessor">#endif</span>
<a name="l00694"></a>00694 <span class="preprocessor"></span>              }
<a name="l00695"></a>00695 <span class="preprocessor">#endif</span>
<a name="l00696"></a>00696 <span class="preprocessor"></span>
<a name="l00697"></a>00697         <span class="comment">// All done</span>
<a name="l00698"></a>00698         
<a name="l00699"></a>00699       <span class="keywordflow">break</span>;
<a name="l00700"></a>00700 
<a name="l00701"></a>00701     <span class="keywordflow">case</span> 1:
<a name="l00702"></a>00702       {
<a name="l00703"></a>00703         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>)
<a name="l00704"></a>00704           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>.size(); i++)
<a name="l00705"></a>00705             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i].size(); p++)
<a name="l00706"></a>00706               {
<a name="l00707"></a>00707                 <span class="comment">// dphi/dx    = (dphi/dxi)*(dxi/dx)</span>
<a name="l00708"></a>00708                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](0) =
<a name="l00709"></a>00709                   <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>[i][p] = <a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p];
<a name="l00710"></a>00710               
<a name="l00711"></a>00711 <span class="preprocessor">#if LIBMESH_DIM&gt;1</span>
<a name="l00712"></a>00712 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](1) = <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>[i][p] = 0.;
<a name="l00713"></a>00713 <span class="preprocessor">#endif</span>
<a name="l00714"></a>00714 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM&gt;2</span>
<a name="l00715"></a>00715 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](2) = <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>[i][p] = 0.;
<a name="l00716"></a>00716 <span class="preprocessor">#endif</span>
<a name="l00717"></a>00717 <span class="preprocessor"></span>              }
<a name="l00718"></a>00718 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00719"></a>00719 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>)
<a name="l00720"></a>00720           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>.size(); i++)
<a name="l00721"></a>00721             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i].size(); p++)
<a name="l00722"></a>00722               {
<a name="l00723"></a>00723                 <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,0) = <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>[i][p] = 
<a name="l00724"></a>00724                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p];
<a name="l00725"></a>00725 <span class="preprocessor">#if LIBMESH_DIM&gt;1</span>
<a name="l00726"></a>00726 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,1) = <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>[i][p] = 
<a name="l00727"></a>00727                   d2phi[i][p](1,0) = 0.;
<a name="l00728"></a>00728                 d2phi[i][p](1,1) = <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>[i][p] = 0.;
<a name="l00729"></a>00729 <span class="preprocessor">#endif</span>
<a name="l00730"></a>00730 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM&gt;2</span>
<a name="l00731"></a>00731 <span class="preprocessor"></span>                d2phi[i][p](0,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>[i][p] =
<a name="l00732"></a>00732                   d2phi[i][p](2,0) = 0.;
<a name="l00733"></a>00733                 d2phi[i][p](1,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>[i][p] = 
<a name="l00734"></a>00734                   d2phi[i][p](2,1) = 0.;
<a name="l00735"></a>00735                 d2phi[i][p](2,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>[i][p] = 0.;
<a name="l00736"></a>00736 <span class="preprocessor">#endif</span>
<a name="l00737"></a>00737 <span class="preprocessor"></span>              }
<a name="l00738"></a>00738 <span class="preprocessor">#endif</span>
<a name="l00739"></a>00739 <span class="preprocessor"></span>
<a name="l00740"></a>00740         <span class="comment">// All done</span>
<a name="l00741"></a>00741         <span class="keywordflow">break</span>;
<a name="l00742"></a>00742       }
<a name="l00743"></a>00743 
<a name="l00744"></a>00744     <span class="keywordflow">case</span> 2:
<a name="l00745"></a>00745       {
<a name="l00746"></a>00746         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>)
<a name="l00747"></a>00747           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>.size(); i++)
<a name="l00748"></a>00748             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i].size(); p++)
<a name="l00749"></a>00749               {
<a name="l00750"></a>00750                 <span class="comment">// dphi/dx    = (dphi/dxi)*(dxi/dx) + (dphi/deta)*(deta/dx)</span>
<a name="l00751"></a>00751                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](0) =
<a name="l00752"></a>00752                   <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>[i][p] = (<a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p] +
<a name="l00753"></a>00753                                   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]);
<a name="l00754"></a>00754               
<a name="l00755"></a>00755                 <span class="comment">// dphi/dy    = (dphi/dxi)*(dxi/dy) + (dphi/deta)*(deta/dy)</span>
<a name="l00756"></a>00756                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](1) =
<a name="l00757"></a>00757                   <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>[i][p] = (<a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00758"></a>00758                                   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p]);
<a name="l00759"></a>00759               
<a name="l00760"></a>00760                 <span class="comment">// dphi/dz    = (dphi/dxi)*(dxi/dz) + (dphi/deta)*(deta/dz)</span>
<a name="l00761"></a>00761 <span class="preprocessor">#if LIBMESH_DIM == 3  </span>
<a name="l00762"></a>00762 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](2) = <span class="comment">// can only assign to the Z component if LIBMESH_DIM==3</span>
<a name="l00763"></a>00763 #endif
<a name="l00764"></a>00764                 <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>[i][p] = (<a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00765"></a>00765                                 <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p]);
<a name="l00766"></a>00766               }
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00769"></a>00769 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>)
<a name="l00770"></a>00770           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>.size(); i++)
<a name="l00771"></a>00771             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i].size(); p++)
<a name="l00772"></a>00772               {
<a name="l00773"></a>00773                 <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,0) = <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>[i][p] = 
<a name="l00774"></a>00774                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p] +
<a name="l00775"></a>00775                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] +
<a name="l00776"></a>00776                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p];
<a name="l00777"></a>00777                 <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,1) = <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>[i][p] =
<a name="l00778"></a>00778                   d2phi[i][p](1,0) = 
<a name="l00779"></a>00779                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00780"></a>00780                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] +
<a name="l00781"></a>00781                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] +
<a name="l00782"></a>00782                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p];
<a name="l00783"></a>00783                 d2phi[i][p](1,1) = <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>[i][p] =
<a name="l00784"></a>00784                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*dxidy_map[p]*dxidy_map[p] +
<a name="l00785"></a>00785                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*dxidy_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] +
<a name="l00786"></a>00786                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p];
<a name="l00787"></a>00787 <span class="preprocessor">#if LIBMESH_DIM == 3  </span>
<a name="l00788"></a>00788 <span class="preprocessor"></span>                d2phi[i][p](0,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>[i][p] = 
<a name="l00789"></a>00789                   d2phi[i][p](2,0) = 
<a name="l00790"></a>00790                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00791"></a>00791                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00792"></a>00792                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00793"></a>00793                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p];
<a name="l00794"></a>00794                 d2phi[i][p](1,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>[i][p] = 
<a name="l00795"></a>00795                   d2phi[i][p](2,1) =
<a name="l00796"></a>00796                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*dxidy_map[p]*dxidz_map[p] +
<a name="l00797"></a>00797                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*dxidy_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00798"></a>00798                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00799"></a>00799                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p]*dxidz_map[p];
<a name="l00800"></a>00800                 d2phi[i][p](2,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>[i][p] =
<a name="l00801"></a>00801                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*dxidz_map[p]*dxidz_map[p] +
<a name="l00802"></a>00802                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*dxidz_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00803"></a>00803                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p];
<a name="l00804"></a>00804 <span class="preprocessor">#endif</span>
<a name="l00805"></a>00805 <span class="preprocessor"></span>              }
<a name="l00806"></a>00806 <span class="preprocessor">#endif</span>
<a name="l00807"></a>00807 <span class="preprocessor"></span>
<a name="l00808"></a>00808         <span class="comment">// All done</span>
<a name="l00809"></a>00809         <span class="keywordflow">break</span>;
<a name="l00810"></a>00810       }
<a name="l00811"></a>00811     
<a name="l00812"></a>00812     <span class="keywordflow">case</span> 3:
<a name="l00813"></a>00813       {
<a name="l00814"></a>00814         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>)
<a name="l00815"></a>00815           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>.size(); i++)
<a name="l00816"></a>00816             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i].size(); p++)
<a name="l00817"></a>00817               {
<a name="l00818"></a>00818                 <span class="comment">// dphi/dx    = (dphi/dxi)*(dxi/dx) + (dphi/deta)*(deta/dx) + (dphi/dzeta)*(dzeta/dx);</span>
<a name="l00819"></a>00819                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](0) =
<a name="l00820"></a>00820                   <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>[i][p] = (<a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p] +
<a name="l00821"></a>00821                                   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] +
<a name="l00822"></a>00822                                   <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]);
<a name="l00823"></a>00823                 
<a name="l00824"></a>00824                 <span class="comment">// dphi/dy    = (dphi/dxi)*(dxi/dy) + (dphi/deta)*(deta/dy) + (dphi/dzeta)*(dzeta/dy);</span>
<a name="l00825"></a>00825                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](1) =
<a name="l00826"></a>00826                   <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>[i][p] = (<a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00827"></a>00827                                   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] +
<a name="l00828"></a>00828                                   <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p]);
<a name="l00829"></a>00829                 
<a name="l00830"></a>00830                 <span class="comment">// dphi/dz    = (dphi/dxi)*(dxi/dz) + (dphi/deta)*(deta/dz) + (dphi/dzeta)*(dzeta/dz);</span>
<a name="l00831"></a>00831                 <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][p](2) =
<a name="l00832"></a>00832                   <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>[i][p] = (<a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00833"></a>00833                                   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00834"></a>00834                                   <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p]);            
<a name="l00835"></a>00835               }
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00838"></a>00838 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>)
<a name="l00839"></a>00839           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>.size(); i++)
<a name="l00840"></a>00840             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i].size(); p++)
<a name="l00841"></a>00841               {
<a name="l00842"></a>00842                 <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,0) = <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>[i][p] = 
<a name="l00843"></a>00843                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p] +
<a name="l00844"></a>00844                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] +
<a name="l00845"></a>00845                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p] +
<a name="l00846"></a>00846                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p] +
<a name="l00847"></a>00847                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] +
<a name="l00848"></a>00848                   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p];
<a name="l00849"></a>00849                 <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][p](0,1) = <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>[i][p] =
<a name="l00850"></a>00850                   d2phi[i][p](1,0) = 
<a name="l00851"></a>00851                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00852"></a>00852                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] +
<a name="l00853"></a>00853                   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] +
<a name="l00854"></a>00854                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] +
<a name="l00855"></a>00855                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00856"></a>00856                   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] +
<a name="l00857"></a>00857                   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] +
<a name="l00858"></a>00858                   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00859"></a>00859                   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p];
<a name="l00860"></a>00860                 d2phi[i][p](0,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>[i][p] = 
<a name="l00861"></a>00861                   d2phi[i][p](2,0) = 
<a name="l00862"></a>00862                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00863"></a>00863                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00864"></a>00864                   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00865"></a>00865                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] +
<a name="l00866"></a>00866                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00867"></a>00867                   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00868"></a>00868                   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00869"></a>00869                   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00870"></a>00870                   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p];
<a name="l00871"></a>00871                 d2phi[i][p](1,1) = <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>[i][p] =
<a name="l00872"></a>00872                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] +
<a name="l00873"></a>00873                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]*detady_map[p] +
<a name="l00874"></a>00874                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] +
<a name="l00875"></a>00875                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*detady_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] +
<a name="l00876"></a>00876                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*detady_map[p]*detady_map[p] +
<a name="l00877"></a>00877                   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p];
<a name="l00878"></a>00878                 d2phi[i][p](1,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>[i][p] = 
<a name="l00879"></a>00879                   d2phi[i][p](2,1) =
<a name="l00880"></a>00880                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00881"></a>00881                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]*detadz_map[p] +
<a name="l00882"></a>00882                   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00883"></a>00883                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*detady_map[p]*detadz_map[p] +
<a name="l00884"></a>00884                   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*detady_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00885"></a>00885                   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*detady_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00886"></a>00886                   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00887"></a>00887                   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00888"></a>00888                   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p]*detadz_map[p];
<a name="l00889"></a>00889                 d2phi[i][p](2,2) = <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>[i][p] =
<a name="l00890"></a>00890                   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] +
<a name="l00891"></a>00891                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p]*detadz_map[p] +
<a name="l00892"></a>00892                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00893"></a>00893                   2*<a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>[i][p]*detadz_map[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] +
<a name="l00894"></a>00894                   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>[i][p]*detadz_map[p]*detadz_map[p] +
<a name="l00895"></a>00895                   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>[i][p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p]*<a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p];
<a name="l00896"></a>00896               }
<a name="l00897"></a>00897 <span class="preprocessor">#endif</span>
<a name="l00898"></a>00898 <span class="preprocessor"></span>        <span class="comment">// All done</span>
<a name="l00899"></a>00899         <span class="keywordflow">break</span>;
<a name="l00900"></a>00900       }
<a name="l00901"></a>00901 
<a name="l00902"></a>00902     <span class="keywordflow">default</span>:
<a name="l00903"></a>00903       {
<a name="l00904"></a>00904         libmesh_error();
<a name="l00905"></a>00905       }
<a name="l00906"></a>00906     }
<a name="l00907"></a>00907   
<a name="l00908"></a>00908   <span class="comment">// Stop logging the shape function computation</span>
<a name="l00909"></a>00909   STOP_LOG(<span class="stringliteral">&quot;compute_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00910"></a>00910 }
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 
<a name="l00913"></a>00913 
<a name="l00914"></a><a class="code" href="classlibMesh_1_1FEBase.php#afde8f8b71cba1d61a14c63194c8ca68a">00914</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#afde8f8b71cba1d61a14c63194c8ca68a">FEBase::on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps)
<a name="l00915"></a>00915 {
<a name="l00916"></a>00916   libmesh_assert (eps &gt;= 0.);
<a name="l00917"></a>00917   
<a name="l00918"></a>00918   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l00919"></a>00919 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00920"></a>00920 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l00921"></a>00921 <span class="preprocessor">#else</span>
<a name="l00922"></a>00922 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = 0.;
<a name="l00923"></a>00923 <span class="preprocessor">#endif</span>
<a name="l00924"></a>00924 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00925"></a>00925 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l00926"></a>00926 <span class="preprocessor">#else</span>
<a name="l00927"></a>00927 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta  = 0.;
<a name="l00928"></a>00928 <span class="preprocessor">#endif</span>
<a name="l00929"></a>00929 <span class="preprocessor"></span>  
<a name="l00930"></a>00930   <span class="keywordflow">switch</span> (t)
<a name="l00931"></a>00931     {
<a name="l00932"></a>00932 
<a name="l00933"></a>00933     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00934"></a>00934     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00935"></a>00935     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00936"></a>00936       {
<a name="l00937"></a>00937         <span class="comment">// The reference 1D element is [-1,1].</span>
<a name="l00938"></a>00938         <span class="keywordflow">if</span> ((xi &gt;= -1.-eps) &amp;&amp;
<a name="l00939"></a>00939             (xi &lt;=  1.+eps))
<a name="l00940"></a>00940           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00941"></a>00941 
<a name="l00942"></a>00942         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00943"></a>00943       }
<a name="l00944"></a>00944 
<a name="l00945"></a>00945       
<a name="l00946"></a>00946     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00947"></a>00947     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00948"></a>00948       {
<a name="l00949"></a>00949         <span class="comment">// The reference triangle is isocoles</span>
<a name="l00950"></a>00950         <span class="comment">// and is bound by xi=0, eta=0, and xi+eta=1.</span>
<a name="l00951"></a>00951         <span class="keywordflow">if</span> ((xi  &gt;= 0.-eps) &amp;&amp;
<a name="l00952"></a>00952             (eta &gt;= 0.-eps) &amp;&amp;
<a name="l00953"></a>00953             ((xi + eta) &lt;= 1.+eps))
<a name="l00954"></a>00954           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00955"></a>00955 
<a name="l00956"></a>00956         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00957"></a>00957       }
<a name="l00958"></a>00958 
<a name="l00959"></a>00959       
<a name="l00960"></a>00960     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00961"></a>00961     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00962"></a>00962     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00963"></a>00963       {
<a name="l00964"></a>00964         <span class="comment">// The reference quadrilateral element is [-1,1]^2.</span>
<a name="l00965"></a>00965         <span class="keywordflow">if</span> ((xi  &gt;= -1.-eps) &amp;&amp;
<a name="l00966"></a>00966             (xi  &lt;=  1.+eps) &amp;&amp;
<a name="l00967"></a>00967             (eta &gt;= -1.-eps) &amp;&amp;
<a name="l00968"></a>00968             (eta &lt;=  1.+eps))
<a name="l00969"></a>00969           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00970"></a>00970                 
<a name="l00971"></a>00971         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00972"></a>00972       }
<a name="l00973"></a>00973 
<a name="l00974"></a>00974 
<a name="l00975"></a>00975     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00976"></a>00976     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00977"></a>00977       {
<a name="l00978"></a>00978         <span class="comment">// The reference tetrahedral is isocoles</span>
<a name="l00979"></a>00979         <span class="comment">// and is bound by xi=0, eta=0, zeta=0,</span>
<a name="l00980"></a>00980         <span class="comment">// and xi+eta+zeta=1.</span>
<a name="l00981"></a>00981         <span class="keywordflow">if</span> ((xi   &gt;= 0.-eps) &amp;&amp;
<a name="l00982"></a>00982             (eta  &gt;= 0.-eps) &amp;&amp;
<a name="l00983"></a>00983             (zeta &gt;= 0.-eps) &amp;&amp;
<a name="l00984"></a>00984             ((xi + eta + zeta) &lt;= 1.+eps))
<a name="l00985"></a>00985           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00986"></a>00986                 
<a name="l00987"></a>00987         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00988"></a>00988       }
<a name="l00989"></a>00989 
<a name="l00990"></a>00990       
<a name="l00991"></a>00991     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00992"></a>00992     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00993"></a>00993     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00994"></a>00994       {
<a name="l00995"></a>00995         <span class="comment">/*</span>
<a name="l00996"></a>00996 <span class="comment">          if ((xi   &gt;= -1.) &amp;&amp;</span>
<a name="l00997"></a>00997 <span class="comment">          (xi   &lt;=  1.) &amp;&amp;</span>
<a name="l00998"></a>00998 <span class="comment">          (eta  &gt;= -1.) &amp;&amp;</span>
<a name="l00999"></a>00999 <span class="comment">          (eta  &lt;=  1.) &amp;&amp;</span>
<a name="l01000"></a>01000 <span class="comment">          (zeta &gt;= -1.) &amp;&amp;</span>
<a name="l01001"></a>01001 <span class="comment">          (zeta &lt;=  1.))</span>
<a name="l01002"></a>01002 <span class="comment">          return true;</span>
<a name="l01003"></a>01003 <span class="comment">        */</span>
<a name="l01004"></a>01004         
<a name="l01005"></a>01005         <span class="comment">// The reference hexahedral element is [-1,1]^3.</span>
<a name="l01006"></a>01006         <span class="keywordflow">if</span> ((xi   &gt;= -1.-eps) &amp;&amp;
<a name="l01007"></a>01007             (xi   &lt;=  1.+eps) &amp;&amp;
<a name="l01008"></a>01008             (eta  &gt;= -1.-eps) &amp;&amp;
<a name="l01009"></a>01009             (eta  &lt;=  1.+eps) &amp;&amp;
<a name="l01010"></a>01010             (zeta &gt;= -1.-eps) &amp;&amp;
<a name="l01011"></a>01011             (zeta &lt;=  1.+eps))
<a name="l01012"></a>01012           {
<a name="l01013"></a>01013             <span class="comment">//      libMesh::out &lt;&lt; &quot;Strange Point:\n&quot;;</span>
<a name="l01014"></a>01014             <span class="comment">//      p.print();</span>
<a name="l01015"></a>01015             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01016"></a>01016           }
<a name="l01017"></a>01017 
<a name="l01018"></a>01018         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01019"></a>01019       }
<a name="l01020"></a>01020 
<a name="l01021"></a>01021     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01022"></a>01022     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l01023"></a>01023     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l01024"></a>01024       {
<a name="l01025"></a>01025         <span class="comment">// Figure this one out...</span>
<a name="l01026"></a>01026         <span class="comment">// inside the reference triange with zeta in [-1,1]</span>
<a name="l01027"></a>01027         <span class="keywordflow">if</span> ((xi   &gt;=  0.-eps) &amp;&amp;
<a name="l01028"></a>01028             (eta  &gt;=  0.-eps) &amp;&amp;
<a name="l01029"></a>01029             (zeta &gt;= -1.-eps) &amp;&amp;
<a name="l01030"></a>01030             (zeta &lt;=  1.+eps) &amp;&amp;
<a name="l01031"></a>01031             ((xi + eta) &lt;= 1.+eps))
<a name="l01032"></a>01032           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01033"></a>01033 
<a name="l01034"></a>01034         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01035"></a>01035       }
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l01039"></a>01039       {
<a name="l01040"></a>01040         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;BEN: Implement this you lazy bastard!&quot;</span>
<a name="l01041"></a>01041                       &lt;&lt; std::endl;
<a name="l01042"></a>01042         libmesh_error();
<a name="l01043"></a>01043 
<a name="l01044"></a>01044         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01045"></a>01045       }
<a name="l01046"></a>01046 
<a name="l01047"></a>01047 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01048"></a>01048 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l01049"></a>01049       {      
<a name="l01050"></a>01050         <span class="comment">// The reference infhex8 is a [-1,1]^3.</span>
<a name="l01051"></a>01051         <span class="keywordflow">if</span> ((xi   &gt;= -1.-eps) &amp;&amp;
<a name="l01052"></a>01052             (xi   &lt;=  1.+eps) &amp;&amp;
<a name="l01053"></a>01053             (eta  &gt;= -1.-eps) &amp;&amp;
<a name="l01054"></a>01054             (eta  &lt;=  1.+eps) &amp;&amp;
<a name="l01055"></a>01055             (zeta &gt;= -1.-eps) &amp;&amp;
<a name="l01056"></a>01056             (zeta &lt;=  1.+eps))
<a name="l01057"></a>01057           {
<a name="l01058"></a>01058             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01059"></a>01059           }
<a name="l01060"></a>01060         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01061"></a>01061       }
<a name="l01062"></a>01062 
<a name="l01063"></a>01063     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l01064"></a>01064       {      
<a name="l01065"></a>01065         <span class="comment">// inside the reference triange with zeta in [-1,1]</span>
<a name="l01066"></a>01066         <span class="keywordflow">if</span> ((xi   &gt;=  0.-eps) &amp;&amp;
<a name="l01067"></a>01067             (eta  &gt;=  0.-eps) &amp;&amp;
<a name="l01068"></a>01068             (zeta &gt;= -1.-eps) &amp;&amp;
<a name="l01069"></a>01069             (zeta &lt;=  1.+eps) &amp;&amp;
<a name="l01070"></a>01070             ((xi + eta) &lt;= 1.+eps))
<a name="l01071"></a>01071           {
<a name="l01072"></a>01072             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01073"></a>01073           }
<a name="l01074"></a>01074 
<a name="l01075"></a>01075         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01076"></a>01076       }
<a name="l01077"></a>01077 <span class="preprocessor">#endif</span>
<a name="l01078"></a>01078 <span class="preprocessor"></span>
<a name="l01079"></a>01079     <span class="keywordflow">default</span>:
<a name="l01080"></a>01080       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown element type &quot;</span> &lt;&lt; t &lt;&lt; std::endl;
<a name="l01081"></a>01081       libmesh_error();
<a name="l01082"></a>01082     }
<a name="l01083"></a>01083 
<a name="l01084"></a>01084   <span class="comment">// If we get here then the point is _not_ in the</span>
<a name="l01085"></a>01085   <span class="comment">// reference element.   Better return false.</span>
<a name="l01086"></a>01086   
<a name="l01087"></a>01087   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01088"></a>01088 }
<a name="l01089"></a>01089 
<a name="l01090"></a>01090 
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 
<a name="l01093"></a><a class="code" href="classlibMesh_1_1FEBase.php#a756e10b9e7a9c4f92531e6f8fe278795">01093</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a756e10b9e7a9c4f92531e6f8fe278795">FEBase::print_JxW</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l01094"></a>01094 <span class="keyword"></span>{
<a name="l01095"></a>01095   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>.size(); ++i)
<a name="l01096"></a>01096     os &lt;&lt; <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[i] &lt;&lt; std::endl;
<a name="l01097"></a>01097 }
<a name="l01098"></a>01098 
<a name="l01099"></a>01099 
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 
<a name="l01102"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9d95ed9fed8a96c18ff68be25d988b8f">01102</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9d95ed9fed8a96c18ff68be25d988b8f">FEBase::print_phi</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l01103"></a>01103 <span class="keyword"></span>{
<a name="l01104"></a>01104   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>.size(); ++i)
<a name="l01105"></a>01105     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>[i].size(); ++j)
<a name="l01106"></a>01106       os &lt;&lt; <span class="stringliteral">&quot; phi[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>[i][j] &lt;&lt; std::endl;
<a name="l01107"></a>01107 }
<a name="l01108"></a>01108 
<a name="l01109"></a>01109 
<a name="l01110"></a>01110 
<a name="l01111"></a>01111 
<a name="l01112"></a><a class="code" href="classlibMesh_1_1FEBase.php#a2b5d94c3ceb3f6b9a5eb589238f532b9">01112</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2b5d94c3ceb3f6b9a5eb589238f532b9">FEBase::print_dphi</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l01113"></a>01113 <span class="keyword"></span>{
<a name="l01114"></a>01114   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>.size(); ++i)
<a name="l01115"></a>01115     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i].size(); ++j)
<a name="l01116"></a>01116       os &lt;&lt; <span class="stringliteral">&quot; dphi[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i][j];
<a name="l01117"></a>01117 }
<a name="l01118"></a>01118 
<a name="l01119"></a>01119 
<a name="l01120"></a>01120 
<a name="l01121"></a>01121 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01122"></a>01122 <span class="preprocessor"></span>
<a name="l01123"></a>01123 
<a name="l01124"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac335f09834d705416b119e0a7c6d83a3">01124</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac335f09834d705416b119e0a7c6d83a3">FEBase::print_d2phi</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l01125"></a>01125 <span class="keyword"></span>{
<a name="l01126"></a>01126   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>.size(); ++i)
<a name="l01127"></a>01127     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>[i].size(); ++j)
<a name="l01128"></a>01128       os &lt;&lt; <span class="stringliteral">&quot; d2phi[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;][&quot;</span> &lt;&lt; j &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>[i][j];
<a name="l01129"></a>01129 }
<a name="l01130"></a>01130 
<a name="l01131"></a>01131 <span class="preprocessor">#endif</span>
<a name="l01132"></a>01132 <span class="preprocessor"></span>
<a name="l01133"></a>01133 
<a name="l01134"></a>01134 
<a name="l01135"></a>01135 
<a name="l01136"></a><a class="code" href="classlibMesh_1_1FEBase.php#ade57dae87a9086c7c30741368a47b8e5">01136</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ade57dae87a9086c7c30741368a47b8e5">FEBase::print_xyz</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l01137"></a>01137 <span class="keyword"></span>{
<a name="l01138"></a>01138   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>.size(); ++i)
<a name="l01139"></a>01139     os &lt;&lt; <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[i];
<a name="l01140"></a>01140 }
<a name="l01141"></a>01141 
<a name="l01142"></a>01142 
<a name="l01143"></a>01143 
<a name="l01144"></a>01144 
<a name="l01145"></a><a class="code" href="classlibMesh_1_1FEBase.php#af737e6b5daf21df5f3b8a850c20db32a">01145</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#af737e6b5daf21df5f3b8a850c20db32a">FEBase::print_info</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l01146"></a>01146 <span class="keyword"></span>{
<a name="l01147"></a>01147   os &lt;&lt; <span class="stringliteral">&quot;Shape functions at the Gauss pts.&quot;</span> &lt;&lt; std::endl;
<a name="l01148"></a>01148   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a9d95ed9fed8a96c18ff68be25d988b8f">print_phi</a>(os);
<a name="l01149"></a>01149   
<a name="l01150"></a>01150   os &lt;&lt; <span class="stringliteral">&quot;Shape function gradients at the Gauss pts.&quot;</span> &lt;&lt; std::endl;
<a name="l01151"></a>01151   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a2b5d94c3ceb3f6b9a5eb589238f532b9">print_dphi</a>(os);
<a name="l01152"></a>01152   
<a name="l01153"></a>01153   os &lt;&lt; <span class="stringliteral">&quot;XYZ locations of the Gauss pts.&quot;</span> &lt;&lt; std::endl;
<a name="l01154"></a>01154   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#ade57dae87a9086c7c30741368a47b8e5">print_xyz</a>(os);
<a name="l01155"></a>01155   
<a name="l01156"></a>01156   os &lt;&lt; <span class="stringliteral">&quot;Values of JxW at the Gauss pts.&quot;</span> &lt;&lt; std::endl;
<a name="l01157"></a>01157   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a756e10b9e7a9c4f92531e6f8fe278795">print_JxW</a>(os);
<a name="l01158"></a>01158 }
<a name="l01159"></a>01159 
<a name="l01160"></a>01160 
<a name="l01161"></a>01161 
<a name="l01162"></a>01162 
<a name="l01163"></a><a class="code" href="namespacelibMesh.php#a546a7b5eb3d073add8e1f19af6bcaf82">01163</a> std::ostream&amp; <a class="code" href="namespacelibMesh.php#a546a7b5eb3d073add8e1f19af6bcaf82">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>&amp; fe)
<a name="l01164"></a>01164 {
<a name="l01165"></a>01165   fe.<a class="code" href="classlibMesh_1_1FEBase.php#af737e6b5daf21df5f3b8a850c20db32a">print_info</a>(os);
<a name="l01166"></a>01166   <span class="keywordflow">return</span> os;
<a name="l01167"></a>01167 }
<a name="l01168"></a>01168 
<a name="l01169"></a>01169 
<a name="l01170"></a>01170 
<a name="l01171"></a>01171 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01172"></a>01172 <span class="preprocessor"></span>
<a name="l01173"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">01173</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">FEBase::coarsened_dof_values</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;old_vector,
<a name="l01174"></a>01174                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l01175"></a>01175                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l01176"></a>01176                                   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> &amp;Ue,
<a name="l01177"></a>01177                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01178"></a>01178                                   <span class="keyword">const</span> <span class="keywordtype">bool</span> use_old_dof_indices)
<a name="l01179"></a>01179 {
<a name="l01180"></a>01180   <span class="comment">// Side/edge DOF indices</span>
<a name="l01181"></a>01181   std::vector&lt;unsigned int&gt; new_side_dofs, old_side_dofs;
<a name="l01182"></a>01182 
<a name="l01183"></a>01183   <span class="comment">// FIXME: what about 2D shells in 3D space?</span>
<a name="l01184"></a>01184   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01185"></a>01185 
<a name="l01186"></a>01186   <span class="comment">// We use local FE objects for now</span>
<a name="l01187"></a>01187   <span class="comment">// FIXME: we should use more, external objects instead for efficiency</span>
<a name="l01188"></a>01188   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; base_fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l01189"></a>01189   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, base_fe_type));
<a name="l01190"></a>01190   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe_coarse (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, base_fe_type));
<a name="l01191"></a>01191 
<a name="l01192"></a>01192   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">qrule</a>     (base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>(dim));
<a name="l01193"></a>01193   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qedgerule (base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>(1));
<a name="l01194"></a>01194   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qsiderule (base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>(dim-1));
<a name="l01195"></a>01195   std::vector&lt;Point&gt; coarse_qpoints;
<a name="l01196"></a>01196 
<a name="l01197"></a>01197   <span class="comment">// The values of the shape functions at the quadrature</span>
<a name="l01198"></a>01198   <span class="comment">// points</span>
<a name="l01199"></a>01199   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi_values =
<a name="l01200"></a>01200     fe-&gt;get_phi();
<a name="l01201"></a>01201   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi_coarse =
<a name="l01202"></a>01202     fe_coarse-&gt;get_phi();
<a name="l01203"></a>01203 
<a name="l01204"></a>01204   <span class="comment">// The gradients of the shape functions at the quadrature</span>
<a name="l01205"></a>01205   <span class="comment">// points on the child element.</span>
<a name="l01206"></a>01206   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi_values =
<a name="l01207"></a>01207     NULL;
<a name="l01208"></a>01208   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi_coarse =
<a name="l01209"></a>01209     NULL;
<a name="l01210"></a>01210 
<a name="l01211"></a>01211   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = fe-&gt;get_continuity();
<a name="l01212"></a>01212 
<a name="l01213"></a>01213   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01214"></a>01214     {
<a name="l01215"></a>01215       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp;
<a name="l01216"></a>01216         ref_dphi_values = fe-&gt;get_dphi();
<a name="l01217"></a>01217       dphi_values = &amp;ref_dphi_values;
<a name="l01218"></a>01218       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp;
<a name="l01219"></a>01219         ref_dphi_coarse = fe_coarse-&gt;get_dphi();
<a name="l01220"></a>01220       dphi_coarse = &amp;ref_dphi_coarse;
<a name="l01221"></a>01221     }
<a name="l01222"></a>01222 
<a name="l01223"></a>01223       <span class="comment">// The Jacobian * quadrature weight at the quadrature points</span>
<a name="l01224"></a>01224       <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a> =
<a name="l01225"></a>01225         fe-&gt;get_JxW();
<a name="l01226"></a>01226 
<a name="l01227"></a>01227       <span class="comment">// The XYZ locations of the quadrature points on the</span>
<a name="l01228"></a>01228       <span class="comment">// child element</span>
<a name="l01229"></a>01229       <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; xyz_values =
<a name="l01230"></a>01230         fe-&gt;get_xyz();
<a name="l01231"></a>01231 
<a name="l01232"></a>01232 
<a name="l01233"></a>01233 
<a name="l01234"></a>01234   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a> = base_fe_type, temp_fe_type;
<a name="l01235"></a>01235   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">elem_type</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01236"></a>01236   fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> +
<a name="l01237"></a>01237                                      elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a62f9ba081c33e128f91a413aebcfb554">max_descendant_p_level</a>());
<a name="l01238"></a>01238 
<a name="l01239"></a>01239   <span class="comment">// Number of nodes on parent element</span>
<a name="l01240"></a>01240   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01241"></a>01241 
<a name="l01242"></a>01242   <span class="comment">// Number of dofs on parent element</span>
<a name="l01243"></a>01243   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_n_dofs =
<a name="l01244"></a>01244     <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">FEInterface::n_dofs</a>(dim, fe_type, elem_type);
<a name="l01245"></a>01245 
<a name="l01246"></a>01246   <span class="comment">// Fixed vs. free DoFs on edge/face projections</span>
<a name="l01247"></a>01247   std::vector&lt;char&gt; dof_is_fixed(new_n_dofs, <span class="keyword">false</span>); <span class="comment">// bools</span>
<a name="l01248"></a>01248   std::vector&lt;int&gt; free_dof(new_n_dofs, 0);
<a name="l01249"></a>01249 
<a name="l01250"></a>01250   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Real&gt;</a> Ke;
<a name="l01251"></a>01251   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Fe;
<a name="l01252"></a>01252   Ue.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(new_n_dofs); Ue.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l01253"></a>01253 
<a name="l01254"></a>01254 
<a name="l01255"></a>01255   <span class="comment">// When coarsening, in general, we need a series of</span>
<a name="l01256"></a>01256   <span class="comment">// projections to ensure a unique and continuous</span>
<a name="l01257"></a>01257   <span class="comment">// solution.  We start by interpolating nodes, then</span>
<a name="l01258"></a>01258   <span class="comment">// hold those fixed and project edges, then</span>
<a name="l01259"></a>01259   <span class="comment">// hold those fixed and project faces, then</span>
<a name="l01260"></a>01260   <span class="comment">// hold those fixed and project interiors</span>
<a name="l01261"></a>01261 
<a name="l01262"></a>01262   <span class="comment">// Copy node values first</span>
<a name="l01263"></a>01263   {
<a name="l01264"></a>01264   std::vector&lt;unsigned int&gt; node_dof_indices;
<a name="l01265"></a>01265   <span class="keywordflow">if</span> (use_old_dof_indices)
<a name="l01266"></a>01266     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">old_dof_indices</a> (elem, node_dof_indices, var);
<a name="l01267"></a>01267   <span class="keywordflow">else</span>
<a name="l01268"></a>01268     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, node_dof_indices, var);
<a name="l01269"></a>01269 
<a name="l01270"></a>01270   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_dof = 0;
<a name="l01271"></a>01271   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n!= <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l01272"></a>01272     {
<a name="l01273"></a>01273       <span class="comment">// FIXME: this should go through the DofMap,</span>
<a name="l01274"></a>01274       <span class="comment">// not duplicate dof_indices code badly!</span>
<a name="l01275"></a>01275       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_nc =
<a name="l01276"></a>01276         <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, fe_type,
<a name="l01277"></a>01277                                      elem_type, n);
<a name="l01278"></a>01278       <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l01279"></a>01279         {
<a name="l01280"></a>01280           current_dof += my_nc;
<a name="l01281"></a>01281           <span class="keywordflow">continue</span>;
<a name="l01282"></a>01282         }
<a name="l01283"></a>01283 
<a name="l01284"></a>01284       temp_fe_type = base_fe_type;
<a name="l01285"></a>01285       <span class="comment">// We&#39;re assuming here that child n shares vertex n,</span>
<a name="l01286"></a>01286       <span class="comment">// which is wrong on non-simplices right now</span>
<a name="l01287"></a>01287       <span class="comment">// ... but this code isn&#39;t necessary except on elements</span>
<a name="l01288"></a>01288       <span class="comment">// where p refinement creates more vertex dofs; we have</span>
<a name="l01289"></a>01289       <span class="comment">// no such elements yet.</span>
<a name="l01290"></a>01290 <span class="comment">/*</span>
<a name="l01291"></a>01291 <span class="comment">      if (elem-&gt;child(n)-&gt;p_level() &lt; elem-&gt;p_level())</span>
<a name="l01292"></a>01292 <span class="comment">        {</span>
<a name="l01293"></a>01293 <span class="comment">          temp_fe_type.order = </span>
<a name="l01294"></a>01294 <span class="comment">            static_cast&lt;Order&gt;(temp_fe_type.order +</span>
<a name="l01295"></a>01295 <span class="comment">                               elem-&gt;child(n)-&gt;p_level());</span>
<a name="l01296"></a>01296 <span class="comment">        }</span>
<a name="l01297"></a>01297 <span class="comment">*/</span>
<a name="l01298"></a>01298       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc =
<a name="l01299"></a>01299         <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (dim, temp_fe_type,
<a name="l01300"></a>01300                                      elem_type, n);
<a name="l01301"></a>01301       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= nc; ++i)
<a name="l01302"></a>01302         {
<a name="l01303"></a>01303           Ue(current_dof) =
<a name="l01304"></a>01304             old_vector(node_dof_indices[current_dof]);
<a name="l01305"></a>01305           dof_is_fixed[current_dof] = <span class="keyword">true</span>;
<a name="l01306"></a>01306           current_dof++;
<a name="l01307"></a>01307         }
<a name="l01308"></a>01308     }
<a name="l01309"></a>01309   }
<a name="l01310"></a>01310 
<a name="l01311"></a>01311   <span class="comment">// In 3D, project any edge values next</span>
<a name="l01312"></a>01312   <span class="keywordflow">if</span> (dim &gt; 2 &amp;&amp; cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01313"></a>01313     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adde1fccc9a1fc4b43485629cb6c4062b">n_edges</a>(); ++e)
<a name="l01314"></a>01314       {
<a name="l01315"></a>01315         <a class="code" href="classlibMesh_1_1FEInterface.php#a7391d432c820009be1a10837ccda221b">FEInterface::dofs_on_edge</a>(elem, dim, fe_type,
<a name="l01316"></a>01316                                   e, new_side_dofs);
<a name="l01317"></a>01317 
<a name="l01318"></a>01318         <span class="comment">// Some edge dofs are on nodes and already</span>
<a name="l01319"></a>01319         <span class="comment">// fixed, others are free to calculate</span>
<a name="l01320"></a>01320         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> free_dofs = 0;
<a name="l01321"></a>01321         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i !=
<a name="l01322"></a>01322              new_side_dofs.size(); ++i)
<a name="l01323"></a>01323           <span class="keywordflow">if</span> (!dof_is_fixed[new_side_dofs[i]])
<a name="l01324"></a>01324             free_dof[free_dofs++] = i;
<a name="l01325"></a>01325         Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (free_dofs, free_dofs); Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01326"></a>01326         Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (free_dofs); Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l01327"></a>01327         <span class="comment">// The new edge coefficients</span>
<a name="l01328"></a>01328         <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Uedge(free_dofs);
<a name="l01329"></a>01329 
<a name="l01330"></a>01330         <span class="comment">// Add projection terms from each child sharing</span>
<a name="l01331"></a>01331         <span class="comment">// this edge</span>
<a name="l01332"></a>01332         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>();
<a name="l01333"></a>01333              ++c)
<a name="l01334"></a>01334           {
<a name="l01335"></a>01335             <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#abbc77b3dfdf119b294cdfd0e5f15075a">is_child_on_edge</a>(c,e))
<a name="l01336"></a>01336               <span class="keywordflow">continue</span>;
<a name="l01337"></a>01337             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01338"></a>01338 
<a name="l01339"></a>01339             std::vector&lt;unsigned int&gt; child_dof_indices;
<a name="l01340"></a>01340             <span class="keywordflow">if</span> (use_old_dof_indices)
<a name="l01341"></a>01341               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">old_dof_indices</a> (child,
<a name="l01342"></a>01342                 child_dof_indices, var);
<a name="l01343"></a>01343             <span class="keywordflow">else</span>
<a name="l01344"></a>01344               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (child,
<a name="l01345"></a>01345                 child_dof_indices, var);
<a name="l01346"></a>01346             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_n_dofs = child_dof_indices.size();
<a name="l01347"></a>01347 
<a name="l01348"></a>01348             temp_fe_type = base_fe_type;
<a name="l01349"></a>01349             temp_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = 
<a name="l01350"></a>01350               <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(temp_fe_type.order +
<a name="l01351"></a>01351                                  child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01352"></a>01352 
<a name="l01353"></a>01353             <a class="code" href="classlibMesh_1_1FEInterface.php#a7391d432c820009be1a10837ccda221b">FEInterface::dofs_on_edge</a>(child, dim,
<a name="l01354"></a>01354               temp_fe_type, e, old_side_dofs);
<a name="l01355"></a>01355 
<a name="l01356"></a>01356             <span class="comment">// Initialize both child and parent FE data</span>
<a name="l01357"></a>01357             <span class="comment">// on the child&#39;s edge</span>
<a name="l01358"></a>01358             fe-&gt;attach_quadrature_rule (qedgerule.get());
<a name="l01359"></a>01359             fe-&gt;edge_reinit (child, e);
<a name="l01360"></a>01360             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qedgerule-&gt;n_points();
<a name="l01361"></a>01361 
<a name="l01362"></a>01362             <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, fe_type, elem,
<a name="l01363"></a>01363                             xyz_values, coarse_qpoints);
<a name="l01364"></a>01364 
<a name="l01365"></a>01365             fe_coarse-&gt;reinit(elem, &amp;coarse_qpoints);
<a name="l01366"></a>01366 
<a name="l01367"></a>01367             <span class="comment">// Loop over the quadrature points</span>
<a name="l01368"></a>01368             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01369"></a>01369               {
<a name="l01370"></a>01370                 <span class="comment">// solution value at the quadrature point</span>
<a name="l01371"></a>01371                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fineval = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l01372"></a>01372                 <span class="comment">// solution grad at the quadrature point</span>
<a name="l01373"></a>01373                 <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> finegrad;
<a name="l01374"></a>01374 
<a name="l01375"></a>01375                 <span class="comment">// Sum the solution values * the DOF</span>
<a name="l01376"></a>01376                 <span class="comment">// values at the quadrature point to</span>
<a name="l01377"></a>01377                 <span class="comment">// get the solution value and gradient.</span>
<a name="l01378"></a>01378                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;child_n_dofs;
<a name="l01379"></a>01379                      i++)
<a name="l01380"></a>01380                   {
<a name="l01381"></a>01381                     fineval +=
<a name="l01382"></a>01382                       (old_vector(child_dof_indices[i])*
<a name="l01383"></a>01383                       phi_values[i][qp]);
<a name="l01384"></a>01384                     <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01385"></a>01385                       finegrad.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*dphi_values)[i][qp],
<a name="l01386"></a>01386                                           old_vector(child_dof_indices[i]));
<a name="l01387"></a>01387                   }
<a name="l01388"></a>01388 
<a name="l01389"></a>01389                 <span class="comment">// Form edge projection matrix</span>
<a name="l01390"></a>01390                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidei=0, freei=0; 
<a name="l01391"></a>01391                      sidei != new_side_dofs.size();
<a name="l01392"></a>01392                      ++sidei)
<a name="l01393"></a>01393                   {
<a name="l01394"></a>01394                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = new_side_dofs[sidei];
<a name="l01395"></a>01395                     <span class="comment">// fixed DoFs aren&#39;t test functions</span>
<a name="l01396"></a>01396                     <span class="keywordflow">if</span> (dof_is_fixed[i])
<a name="l01397"></a>01397                       <span class="keywordflow">continue</span>;
<a name="l01398"></a>01398                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidej=0, freej=0;
<a name="l01399"></a>01399                          sidej != new_side_dofs.size();
<a name="l01400"></a>01400                          ++sidej)
<a name="l01401"></a>01401                       {
<a name="l01402"></a>01402                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j =
<a name="l01403"></a>01403                           new_side_dofs[sidej];
<a name="l01404"></a>01404                         <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01405"></a>01405                           Fe(freei) -=
<a name="l01406"></a>01406                             phi_coarse[i][qp] *
<a name="l01407"></a>01407                             phi_coarse[j][qp] * JxW[qp] *
<a name="l01408"></a>01408                             Ue(j);
<a name="l01409"></a>01409                         <span class="keywordflow">else</span>
<a name="l01410"></a>01410                           Ke(freei,freej) +=
<a name="l01411"></a>01411                             phi_coarse[i][qp] *
<a name="l01412"></a>01412                             phi_coarse[j][qp] * JxW[qp];
<a name="l01413"></a>01413                         <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01414"></a>01414                           {
<a name="l01415"></a>01415                             <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01416"></a>01416                               Fe(freei) -=
<a name="l01417"></a>01417                                 ((*dphi_coarse)[i][qp] *
<a name="l01418"></a>01418                                  (*dphi_coarse)[j][qp]) *
<a name="l01419"></a>01419                                 JxW[qp] *
<a name="l01420"></a>01420                                 Ue(j);
<a name="l01421"></a>01421                             <span class="keywordflow">else</span>
<a name="l01422"></a>01422                               Ke(freei,freej) +=
<a name="l01423"></a>01423                                 ((*dphi_coarse)[i][qp] *
<a name="l01424"></a>01424                                  (*dphi_coarse)[j][qp])
<a name="l01425"></a>01425                                 * JxW[qp];
<a name="l01426"></a>01426                           }
<a name="l01427"></a>01427                         <span class="keywordflow">if</span> (!dof_is_fixed[j])
<a name="l01428"></a>01428                           freej++;
<a name="l01429"></a>01429                       }
<a name="l01430"></a>01430                     Fe(freei) += phi_coarse[i][qp] *
<a name="l01431"></a>01431                                  fineval * JxW[qp];
<a name="l01432"></a>01432                     <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01433"></a>01433                       Fe(freei) +=
<a name="l01434"></a>01434                         (finegrad * (*dphi_coarse)[i][qp]) * JxW[qp];
<a name="l01435"></a>01435                     freei++;
<a name="l01436"></a>01436                   }
<a name="l01437"></a>01437               }
<a name="l01438"></a>01438           }
<a name="l01439"></a>01439         Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(Fe, Uedge);
<a name="l01440"></a>01440 
<a name="l01441"></a>01441         <span class="comment">// Transfer new edge solutions to element</span>
<a name="l01442"></a>01442         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != free_dofs; ++i)
<a name="l01443"></a>01443           {
<a name="l01444"></a>01444             <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;ui = Ue(new_side_dofs[free_dof[i]]);
<a name="l01445"></a>01445             libmesh_assert(std::abs(ui) &lt; TOLERANCE ||
<a name="l01446"></a>01446                    std::abs(ui - Uedge(i)) &lt; TOLERANCE);
<a name="l01447"></a>01447             ui = Uedge(i);
<a name="l01448"></a>01448             dof_is_fixed[new_side_dofs[free_dof[i]]] =
<a name="l01449"></a>01449               <span class="keyword">true</span>;
<a name="l01450"></a>01450           }
<a name="l01451"></a>01451       }
<a name="l01452"></a>01452    
<a name="l01453"></a>01453   <span class="comment">// Project any side values (edges in 2D, faces in 3D)</span>
<a name="l01454"></a>01454   <span class="keywordflow">if</span> (dim &gt; 1 &amp;&amp; cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01455"></a>01455     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); ++s)
<a name="l01456"></a>01456       {
<a name="l01457"></a>01457         <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(elem, dim, fe_type,
<a name="l01458"></a>01458                                   s, new_side_dofs);
<a name="l01459"></a>01459 
<a name="l01460"></a>01460         <span class="comment">// Some side dofs are on nodes/edges and already</span>
<a name="l01461"></a>01461         <span class="comment">// fixed, others are free to calculate</span>
<a name="l01462"></a>01462         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> free_dofs = 0;
<a name="l01463"></a>01463         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i !=
<a name="l01464"></a>01464              new_side_dofs.size(); ++i)
<a name="l01465"></a>01465           <span class="keywordflow">if</span> (!dof_is_fixed[new_side_dofs[i]])
<a name="l01466"></a>01466             free_dof[free_dofs++] = i;
<a name="l01467"></a>01467         Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (free_dofs, free_dofs); Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01468"></a>01468         Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (free_dofs); Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l01469"></a>01469         <span class="comment">// The new side coefficients</span>
<a name="l01470"></a>01470         <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Uside(free_dofs);
<a name="l01471"></a>01471 
<a name="l01472"></a>01472         <span class="comment">// Add projection terms from each child sharing</span>
<a name="l01473"></a>01473         <span class="comment">// this side</span>
<a name="l01474"></a>01474         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>();
<a name="l01475"></a>01475              ++c)
<a name="l01476"></a>01476           {
<a name="l01477"></a>01477             <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(c,s))
<a name="l01478"></a>01478               <span class="keywordflow">continue</span>;
<a name="l01479"></a>01479             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01480"></a>01480 
<a name="l01481"></a>01481             std::vector&lt;unsigned int&gt; child_dof_indices;
<a name="l01482"></a>01482             <span class="keywordflow">if</span> (use_old_dof_indices)
<a name="l01483"></a>01483               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">old_dof_indices</a> (child,
<a name="l01484"></a>01484                 child_dof_indices, var);
<a name="l01485"></a>01485             <span class="keywordflow">else</span>
<a name="l01486"></a>01486               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (child,
<a name="l01487"></a>01487                 child_dof_indices, var);
<a name="l01488"></a>01488             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_n_dofs = child_dof_indices.size();
<a name="l01489"></a>01489 
<a name="l01490"></a>01490             temp_fe_type = base_fe_type;
<a name="l01491"></a>01491             temp_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = 
<a name="l01492"></a>01492               <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(temp_fe_type.order +
<a name="l01493"></a>01493                                  child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01494"></a>01494 
<a name="l01495"></a>01495             <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(child, dim,
<a name="l01496"></a>01496               temp_fe_type, s, old_side_dofs);
<a name="l01497"></a>01497 
<a name="l01498"></a>01498             <span class="comment">// Initialize both child and parent FE data</span>
<a name="l01499"></a>01499             <span class="comment">// on the child&#39;s side</span>
<a name="l01500"></a>01500             fe-&gt;attach_quadrature_rule (qsiderule.get());
<a name="l01501"></a>01501             fe-&gt;reinit (child, s);
<a name="l01502"></a>01502             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qsiderule-&gt;n_points();
<a name="l01503"></a>01503 
<a name="l01504"></a>01504             <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, fe_type, elem,
<a name="l01505"></a>01505                             xyz_values, coarse_qpoints);
<a name="l01506"></a>01506 
<a name="l01507"></a>01507             fe_coarse-&gt;reinit(elem, &amp;coarse_qpoints);
<a name="l01508"></a>01508 
<a name="l01509"></a>01509             <span class="comment">// Loop over the quadrature points</span>
<a name="l01510"></a>01510             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01511"></a>01511               {
<a name="l01512"></a>01512                 <span class="comment">// solution value at the quadrature point</span>
<a name="l01513"></a>01513                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fineval = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l01514"></a>01514                 <span class="comment">// solution grad at the quadrature point</span>
<a name="l01515"></a>01515                 <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> finegrad;
<a name="l01516"></a>01516 
<a name="l01517"></a>01517                 <span class="comment">// Sum the solution values * the DOF</span>
<a name="l01518"></a>01518                 <span class="comment">// values at the quadrature point to</span>
<a name="l01519"></a>01519                 <span class="comment">// get the solution value and gradient.</span>
<a name="l01520"></a>01520                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;child_n_dofs;
<a name="l01521"></a>01521                      i++)
<a name="l01522"></a>01522                   {
<a name="l01523"></a>01523                     fineval +=
<a name="l01524"></a>01524                       (old_vector(child_dof_indices[i])*
<a name="l01525"></a>01525                       phi_values[i][qp]);
<a name="l01526"></a>01526                     <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01527"></a>01527                       finegrad.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*dphi_values)[i][qp],
<a name="l01528"></a>01528                                           old_vector(child_dof_indices[i]));
<a name="l01529"></a>01529                   }
<a name="l01530"></a>01530 
<a name="l01531"></a>01531                 <span class="comment">// Form side projection matrix</span>
<a name="l01532"></a>01532                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidei=0, freei=0;
<a name="l01533"></a>01533                      sidei != new_side_dofs.size();
<a name="l01534"></a>01534                      ++sidei)
<a name="l01535"></a>01535                   {
<a name="l01536"></a>01536                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = new_side_dofs[sidei];
<a name="l01537"></a>01537                     <span class="comment">// fixed DoFs aren&#39;t test functions</span>
<a name="l01538"></a>01538                     <span class="keywordflow">if</span> (dof_is_fixed[i])
<a name="l01539"></a>01539                       <span class="keywordflow">continue</span>;
<a name="l01540"></a>01540                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sidej=0, freej=0;
<a name="l01541"></a>01541                          sidej != new_side_dofs.size();
<a name="l01542"></a>01542                          ++sidej)
<a name="l01543"></a>01543                       {
<a name="l01544"></a>01544                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j =
<a name="l01545"></a>01545                           new_side_dofs[sidej];
<a name="l01546"></a>01546                         <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01547"></a>01547                           Fe(freei) -=
<a name="l01548"></a>01548                             phi_coarse[i][qp] *
<a name="l01549"></a>01549                             phi_coarse[j][qp] * JxW[qp] *
<a name="l01550"></a>01550                             Ue(j);
<a name="l01551"></a>01551                         <span class="keywordflow">else</span>
<a name="l01552"></a>01552                           Ke(freei,freej) +=
<a name="l01553"></a>01553                             phi_coarse[i][qp] *
<a name="l01554"></a>01554                             phi_coarse[j][qp] * JxW[qp];
<a name="l01555"></a>01555                         <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01556"></a>01556                           {
<a name="l01557"></a>01557                             <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01558"></a>01558                               Fe(freei) -=
<a name="l01559"></a>01559                                 ((*dphi_coarse)[i][qp] *
<a name="l01560"></a>01560                                  (*dphi_coarse)[j][qp]) *
<a name="l01561"></a>01561                                 JxW[qp] *
<a name="l01562"></a>01562                                 Ue(j);
<a name="l01563"></a>01563                             <span class="keywordflow">else</span>
<a name="l01564"></a>01564                               Ke(freei,freej) +=
<a name="l01565"></a>01565                                 ((*dphi_coarse)[i][qp] *
<a name="l01566"></a>01566                                  (*dphi_coarse)[j][qp])
<a name="l01567"></a>01567                                 * JxW[qp];
<a name="l01568"></a>01568                           }
<a name="l01569"></a>01569                         <span class="keywordflow">if</span> (!dof_is_fixed[j])
<a name="l01570"></a>01570                           freej++;
<a name="l01571"></a>01571                       }
<a name="l01572"></a>01572                     Fe(freei) += (fineval * phi_coarse[i][qp]) * JxW[qp];
<a name="l01573"></a>01573                     <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01574"></a>01574                       Fe(freei) +=
<a name="l01575"></a>01575                         (finegrad * (*dphi_coarse)[i][qp]) * JxW[qp];
<a name="l01576"></a>01576                     freei++;
<a name="l01577"></a>01577                   }
<a name="l01578"></a>01578               }
<a name="l01579"></a>01579           }
<a name="l01580"></a>01580         Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(Fe, Uside);
<a name="l01581"></a>01581 
<a name="l01582"></a>01582         <span class="comment">// Transfer new side solutions to element</span>
<a name="l01583"></a>01583         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != free_dofs; ++i)
<a name="l01584"></a>01584           {
<a name="l01585"></a>01585             <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;ui = Ue(new_side_dofs[free_dof[i]]);
<a name="l01586"></a>01586             libmesh_assert(std::abs(ui) &lt; TOLERANCE ||
<a name="l01587"></a>01587                    std::abs(ui - Uside(i)) &lt; TOLERANCE);
<a name="l01588"></a>01588             ui = Uside(i);
<a name="l01589"></a>01589             dof_is_fixed[new_side_dofs[free_dof[i]]] =
<a name="l01590"></a>01590               <span class="keyword">true</span>;
<a name="l01591"></a>01591           }
<a name="l01592"></a>01592       }
<a name="l01593"></a>01593 
<a name="l01594"></a>01594   <span class="comment">// Project the interior values, finally</span>
<a name="l01595"></a>01595 
<a name="l01596"></a>01596   <span class="comment">// Some interior dofs are on nodes/edges/sides and</span>
<a name="l01597"></a>01597   <span class="comment">// already fixed, others are free to calculate</span>
<a name="l01598"></a>01598   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> free_dofs = 0;
<a name="l01599"></a>01599   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != new_n_dofs; ++i)
<a name="l01600"></a>01600     <span class="keywordflow">if</span> (!dof_is_fixed[i])
<a name="l01601"></a>01601       free_dof[free_dofs++] = i;
<a name="l01602"></a>01602   Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (free_dofs, free_dofs); Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l01603"></a>01603   Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (free_dofs); Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l01604"></a>01604   <span class="comment">// The new interior coefficients</span>
<a name="l01605"></a>01605   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Uint(free_dofs);
<a name="l01606"></a>01606 
<a name="l01607"></a>01607   <span class="comment">// Add projection terms from each child</span>
<a name="l01608"></a>01608   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l01609"></a>01609     {
<a name="l01610"></a>01610       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l01611"></a>01611 
<a name="l01612"></a>01612       std::vector&lt;unsigned int&gt; child_dof_indices;
<a name="l01613"></a>01613       <span class="keywordflow">if</span> (use_old_dof_indices)
<a name="l01614"></a>01614         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">old_dof_indices</a> (child,
<a name="l01615"></a>01615           child_dof_indices, var);
<a name="l01616"></a>01616       <span class="keywordflow">else</span>
<a name="l01617"></a>01617         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (child,
<a name="l01618"></a>01618           child_dof_indices, var);
<a name="l01619"></a>01619       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_n_dofs = child_dof_indices.size();
<a name="l01620"></a>01620 
<a name="l01621"></a>01621       <span class="comment">// Initialize both child and parent FE data</span>
<a name="l01622"></a>01622       <span class="comment">// on the child&#39;s quadrature points</span>
<a name="l01623"></a>01623       fe-&gt;attach_quadrature_rule (<a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">qrule</a>.get());
<a name="l01624"></a>01624       fe-&gt;reinit (child);
<a name="l01625"></a>01625       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = <a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l01626"></a>01626 
<a name="l01627"></a>01627       <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, fe_type, elem,
<a name="l01628"></a>01628         xyz_values, coarse_qpoints);
<a name="l01629"></a>01629 
<a name="l01630"></a>01630       fe_coarse-&gt;reinit(elem, &amp;coarse_qpoints);
<a name="l01631"></a>01631 
<a name="l01632"></a>01632       <span class="comment">// Loop over the quadrature points</span>
<a name="l01633"></a>01633       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l01634"></a>01634         {
<a name="l01635"></a>01635           <span class="comment">// solution value at the quadrature point              </span>
<a name="l01636"></a>01636           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fineval = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l01637"></a>01637           <span class="comment">// solution grad at the quadrature point              </span>
<a name="l01638"></a>01638           <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> finegrad;
<a name="l01639"></a>01639 
<a name="l01640"></a>01640           <span class="comment">// Sum the solution values * the DOF</span>
<a name="l01641"></a>01641           <span class="comment">// values at the quadrature point to</span>
<a name="l01642"></a>01642           <span class="comment">// get the solution value and gradient.</span>
<a name="l01643"></a>01643           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;child_n_dofs; i++)
<a name="l01644"></a>01644             {
<a name="l01645"></a>01645               fineval +=
<a name="l01646"></a>01646                 (old_vector(child_dof_indices[i])*
<a name="l01647"></a>01647                  phi_values[i][qp]);
<a name="l01648"></a>01648               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01649"></a>01649                 finegrad.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*dphi_values)[i][qp],
<a name="l01650"></a>01650                                     old_vector(child_dof_indices[i]));
<a name="l01651"></a>01651             }
<a name="l01652"></a>01652 
<a name="l01653"></a>01653           <span class="comment">// Form interior projection matrix</span>
<a name="l01654"></a>01654           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, freei=0;
<a name="l01655"></a>01655                i != new_n_dofs; ++i)
<a name="l01656"></a>01656             {
<a name="l01657"></a>01657               <span class="comment">// fixed DoFs aren&#39;t test functions</span>
<a name="l01658"></a>01658               <span class="keywordflow">if</span> (dof_is_fixed[i])
<a name="l01659"></a>01659                 <span class="keywordflow">continue</span>;
<a name="l01660"></a>01660               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0, freej=0; j !=
<a name="l01661"></a>01661                    new_n_dofs; ++j)
<a name="l01662"></a>01662                 {
<a name="l01663"></a>01663                   <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01664"></a>01664                     Fe(freei) -=
<a name="l01665"></a>01665                       phi_coarse[i][qp] *
<a name="l01666"></a>01666                       phi_coarse[j][qp] * JxW[qp] *
<a name="l01667"></a>01667                       Ue(j);
<a name="l01668"></a>01668                   <span class="keywordflow">else</span>
<a name="l01669"></a>01669                     Ke(freei,freej) +=
<a name="l01670"></a>01670                       phi_coarse[i][qp] *
<a name="l01671"></a>01671                       phi_coarse[j][qp] * JxW[qp];
<a name="l01672"></a>01672                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01673"></a>01673                     {
<a name="l01674"></a>01674                       <span class="keywordflow">if</span> (dof_is_fixed[j])
<a name="l01675"></a>01675                         Fe(freei) -=
<a name="l01676"></a>01676                           ((*dphi_coarse)[i][qp] *
<a name="l01677"></a>01677                            (*dphi_coarse)[j][qp]) *
<a name="l01678"></a>01678                           JxW[qp] * Ue(j);
<a name="l01679"></a>01679                       <span class="keywordflow">else</span>
<a name="l01680"></a>01680                         Ke(freei,freej) +=
<a name="l01681"></a>01681                           ((*dphi_coarse)[i][qp] *
<a name="l01682"></a>01682                            (*dphi_coarse)[j][qp]) * JxW[qp];
<a name="l01683"></a>01683                     }
<a name="l01684"></a>01684                   <span class="keywordflow">if</span> (!dof_is_fixed[j])
<a name="l01685"></a>01685                     freej++;
<a name="l01686"></a>01686                 }
<a name="l01687"></a>01687               Fe(freei) += phi_coarse[i][qp] * fineval *
<a name="l01688"></a>01688                            JxW[qp];
<a name="l01689"></a>01689               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l01690"></a>01690                 Fe(freei) += (finegrad * (*dphi_coarse)[i][qp]) * JxW[qp];
<a name="l01691"></a>01691               freei++;
<a name="l01692"></a>01692             }
<a name="l01693"></a>01693         }
<a name="l01694"></a>01694     }
<a name="l01695"></a>01695   Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(Fe, Uint);
<a name="l01696"></a>01696 
<a name="l01697"></a>01697   <span class="comment">// Transfer new interior solutions to element</span>
<a name="l01698"></a>01698   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != free_dofs; ++i)
<a name="l01699"></a>01699     {
<a name="l01700"></a>01700       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;ui = Ue(free_dof[i]);
<a name="l01701"></a>01701       libmesh_assert(std::abs(ui) &lt; TOLERANCE ||
<a name="l01702"></a>01702              std::abs(ui - Uint(i)) &lt; TOLERANCE);
<a name="l01703"></a>01703       ui = Uint(i);
<a name="l01704"></a>01704       dof_is_fixed[free_dof[i]] = <span class="keyword">true</span>;
<a name="l01705"></a>01705     }
<a name="l01706"></a>01706 
<a name="l01707"></a>01707   <span class="comment">// Make sure every DoF got reached!</span>
<a name="l01708"></a>01708   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != new_n_dofs; ++i)
<a name="l01709"></a>01709     libmesh_assert(dof_is_fixed[i]);
<a name="l01710"></a>01710 }
<a name="l01711"></a>01711 
<a name="l01712"></a>01712 
<a name="l01713"></a>01713 
<a name="l01714"></a><a class="code" href="classlibMesh_1_1FEBase.php#a3c6b19b079eaa80d062c0c6e3908bed1">01714</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3c6b19b079eaa80d062c0c6e3908bed1">FEBase::compute_proj_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l01715"></a>01715                                        <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l01716"></a>01716                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l01717"></a>01717                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l01718"></a>01718 {
<a name="l01719"></a>01719   libmesh_assert (elem != NULL);
<a name="l01720"></a>01720 
<a name="l01721"></a>01721   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01722"></a>01722 
<a name="l01723"></a>01723   <span class="comment">// Only constrain elements in 2,3D.</span>
<a name="l01724"></a>01724   <span class="keywordflow">if</span> (Dim == 1)
<a name="l01725"></a>01725     <span class="keywordflow">return</span>;
<a name="l01726"></a>01726 
<a name="l01727"></a>01727   <span class="comment">// Only constrain active elements with this method</span>
<a name="l01728"></a>01728   <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01729"></a>01729     <span class="keywordflow">return</span>;
<a name="l01730"></a>01730 
<a name="l01731"></a>01731   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; base_fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(variable_number);
<a name="l01732"></a>01732 
<a name="l01733"></a>01733   <span class="comment">// Construct FE objects for this element and its neighbors.</span>
<a name="l01734"></a>01734   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> my_fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim, base_fe_type));
<a name="l01735"></a>01735   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = my_fe-&gt;get_continuity();
<a name="l01736"></a>01736 
<a name="l01737"></a>01737   <span class="comment">// We don&#39;t need to constrain discontinuous elements</span>
<a name="l01738"></a>01738   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01739"></a>01739     <span class="keywordflow">return</span>;
<a name="l01740"></a>01740   libmesh_assert (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>);
<a name="l01741"></a>01741 
<a name="l01742"></a>01742   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> neigh_fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim, base_fe_type));
<a name="l01743"></a>01743 
<a name="l01744"></a>01744   <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> my_qface(Dim-1, base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a>());
<a name="l01745"></a>01745   my_fe-&gt;attach_quadrature_rule (&amp;my_qface);
<a name="l01746"></a>01746   std::vector&lt;Point&gt; neigh_qface;
<a name="l01747"></a>01747 
<a name="l01748"></a>01748   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a> = my_fe-&gt;get_JxW();
<a name="l01749"></a>01749   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; q_point = my_fe-&gt;get_xyz();
<a name="l01750"></a>01750   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a> = my_fe-&gt;get_phi();
<a name="l01751"></a>01751   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; neigh_phi =
<a name="l01752"></a>01752                   neigh_fe-&gt;get_phi();
<a name="l01753"></a>01753   <span class="keyword">const</span> std::vector&lt;Point&gt; *face_normals = NULL;
<a name="l01754"></a>01754   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a> = NULL;
<a name="l01755"></a>01755   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *neigh_dphi = NULL;
<a name="l01756"></a>01756 
<a name="l01757"></a>01757   std::vector&lt;unsigned int&gt; my_dof_indices, neigh_dof_indices;
<a name="l01758"></a>01758   std::vector&lt;unsigned int&gt; my_side_dofs, neigh_side_dofs;
<a name="l01759"></a>01759 
<a name="l01760"></a>01760   <span class="keywordflow">if</span> (cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l01761"></a>01761     {
<a name="l01762"></a>01762       <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; ref_face_normals =
<a name="l01763"></a>01763         my_fe-&gt;get_normals();
<a name="l01764"></a>01764       face_normals = &amp;ref_face_normals;
<a name="l01765"></a>01765       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; ref_dphi =
<a name="l01766"></a>01766         my_fe-&gt;get_dphi();
<a name="l01767"></a>01767       dphi = &amp;ref_dphi;
<a name="l01768"></a>01768       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; ref_neigh_dphi =
<a name="l01769"></a>01769         neigh_fe-&gt;get_dphi();
<a name="l01770"></a>01770       neigh_dphi = &amp;ref_neigh_dphi;
<a name="l01771"></a>01771     }
<a name="l01772"></a>01772 
<a name="l01773"></a>01773   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Real&gt;</a> Ke;
<a name="l01774"></a>01774   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Real&gt;</a> Fe;
<a name="l01775"></a>01775   std::vector&lt;DenseVector&lt;Real&gt; &gt; Ue;
<a name="l01776"></a>01776 
<a name="l01777"></a>01777   <span class="comment">// Look at the element faces.  Check to see if we need to</span>
<a name="l01778"></a>01778   <span class="comment">// build constraints.</span>
<a name="l01779"></a>01779   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l01780"></a>01780     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL)
<a name="l01781"></a>01781       {
<a name="l01782"></a>01782         <span class="comment">// Get pointers to the element&#39;s neighbor.</span>
<a name="l01783"></a>01783         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neigh = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l01784"></a>01784 
<a name="l01785"></a>01785         <span class="comment">// h refinement constraints:</span>
<a name="l01786"></a>01786         <span class="comment">// constrain dofs shared between</span>
<a name="l01787"></a>01787         <span class="comment">// this element and ones coarser</span>
<a name="l01788"></a>01788         <span class="comment">// than this element.</span>
<a name="l01789"></a>01789         <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()) 
<a name="l01790"></a>01790           {
<a name="l01791"></a>01791             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s_neigh = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(elem);
<a name="l01792"></a>01792             libmesh_assert (s_neigh &lt; neigh-&gt;n_neighbors());
<a name="l01793"></a>01793 
<a name="l01794"></a>01794             <span class="comment">// Find the minimum p level; we build the h constraint</span>
<a name="l01795"></a>01795             <span class="comment">// matrix with this and then constrain away all higher p</span>
<a name="l01796"></a>01796             <span class="comment">// DoFs.</span>
<a name="l01797"></a>01797             libmesh_assert(neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l01798"></a>01798             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level =
<a name="l01799"></a>01799               <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>(), neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01800"></a>01800 
<a name="l01801"></a>01801             <span class="comment">// we may need to make the FE objects reinit with the</span>
<a name="l01802"></a>01802             <span class="comment">// minimum shared p_level</span>
<a name="l01803"></a>01803             <span class="comment">// FIXME - I hate using const_cast&lt;&gt; and avoiding</span>
<a name="l01804"></a>01804             <span class="comment">// accessor functions; there&#39;s got to be a</span>
<a name="l01805"></a>01805             <span class="comment">// better way to do this!</span>
<a name="l01806"></a>01806             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l01807"></a>01807             <span class="keywordflow">if</span> (old_elem_level != min_p_level)
<a name="l01808"></a>01808               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(elem))-&gt;hack_p_level(min_p_level);
<a name="l01809"></a>01809             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_neigh_level = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l01810"></a>01810             <span class="keywordflow">if</span> (old_neigh_level != min_p_level)
<a name="l01811"></a>01811               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(neigh))-&gt;hack_p_level(min_p_level);
<a name="l01812"></a>01812 
<a name="l01813"></a>01813             my_fe-&gt;reinit(elem, s);
<a name="l01814"></a>01814             
<a name="l01815"></a>01815             <span class="comment">// This function gets called element-by-element, so there</span>
<a name="l01816"></a>01816             <span class="comment">// will be a lot of memory allocation going on.  We can </span>
<a name="l01817"></a>01817             <span class="comment">// at least minimize this for the case of the dof indices</span>
<a name="l01818"></a>01818             <span class="comment">// by efficiently preallocating the requisite storage.</span>
<a name="l01819"></a>01819             <span class="comment">// n_nodes is not necessarily n_dofs, but it is better</span>
<a name="l01820"></a>01820             <span class="comment">// than nothing!</span>
<a name="l01821"></a>01821             my_dof_indices.reserve    (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01822"></a>01822             neigh_dof_indices.reserve (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l01823"></a>01823 
<a name="l01824"></a>01824             dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, my_dof_indices,
<a name="l01825"></a>01825                                  variable_number);
<a name="l01826"></a>01826             dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (neigh, neigh_dof_indices,
<a name="l01827"></a>01827                                  variable_number);
<a name="l01828"></a>01828 
<a name="l01829"></a>01829             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = my_qface.n_points();
<a name="l01830"></a>01830             
<a name="l01831"></a>01831             <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (Dim, base_fe_type, neigh,
<a name="l01832"></a>01832                                       q_point, neigh_qface);
<a name="l01833"></a>01833 
<a name="l01834"></a>01834             neigh_fe-&gt;reinit(neigh, &amp;neigh_qface);
<a name="l01835"></a>01835 
<a name="l01836"></a>01836             <span class="comment">// We&#39;re only concerned with DOFs whose values (and/or first</span>
<a name="l01837"></a>01837             <span class="comment">// derivatives for C1 elements) are supported on side nodes</span>
<a name="l01838"></a>01838             <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(elem,  Dim, base_fe_type, s,       my_side_dofs);
<a name="l01839"></a>01839             <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(neigh, Dim, base_fe_type, s_neigh, neigh_side_dofs);
<a name="l01840"></a>01840 
<a name="l01841"></a>01841             <span class="comment">// We&#39;re done with functions that examine Elem::p_level(),</span>
<a name="l01842"></a>01842             <span class="comment">// so let&#39;s unhack those levels</span>
<a name="l01843"></a>01843             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() != old_elem_level)
<a name="l01844"></a>01844               (const_cast&lt;Elem *&gt;(elem))-&gt;hack_p_level(old_elem_level);
<a name="l01845"></a>01845             <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() != old_neigh_level)
<a name="l01846"></a>01846               (const_cast&lt;Elem *&gt;(neigh))-&gt;hack_p_level(old_neigh_level);
<a name="l01847"></a>01847 
<a name="l01848"></a>01848             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_side_dofs = my_side_dofs.size();
<a name="l01849"></a>01849             libmesh_assert(n_side_dofs == neigh_side_dofs.size());
<a name="l01850"></a>01850 
<a name="l01851"></a>01851             Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (n_side_dofs, n_side_dofs);
<a name="l01852"></a>01852             Ue.resize(n_side_dofs);
<a name="l01853"></a>01853 
<a name="l01854"></a>01854             <span class="comment">// Form the projection matrix, (inner product of fine basis</span>
<a name="l01855"></a>01855             <span class="comment">// functions against fine test functions)</span>
<a name="l01856"></a>01856             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l01857"></a>01857               {
<a name="l01858"></a>01858                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = my_side_dofs[is];
<a name="l01859"></a>01859                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l01860"></a>01860                   {
<a name="l01861"></a>01861                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l01862"></a>01862                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qp; ++qp)
<a name="l01863"></a>01863                       {
<a name="l01864"></a>01864                         Ke(is,js) += JxW[qp] * (phi[i][qp] * phi[j][qp]);
<a name="l01865"></a>01865                         <span class="keywordflow">if</span> (cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l01866"></a>01866                           Ke(is,js) += JxW[qp] * (((*dphi)[i][qp] *
<a name="l01867"></a>01867                                                  (*face_normals)[qp]) *
<a name="l01868"></a>01868                                                 ((*dphi)[j][qp] *
<a name="l01869"></a>01869                                                  (*face_normals)[qp]));
<a name="l01870"></a>01870                       }
<a name="l01871"></a>01871                   }
<a name="l01872"></a>01872               }
<a name="l01873"></a>01873 
<a name="l01874"></a>01874             <span class="comment">// Form the right hand sides, (inner product of coarse basis</span>
<a name="l01875"></a>01875             <span class="comment">// functions against fine test functions)</span>
<a name="l01876"></a>01876             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l01877"></a>01877               {
<a name="l01878"></a>01878                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = neigh_side_dofs[is];
<a name="l01879"></a>01879                 Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (n_side_dofs);
<a name="l01880"></a>01880                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l01881"></a>01881                   {
<a name="l01882"></a>01882                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l01883"></a>01883                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qp; ++qp)
<a name="l01884"></a>01884                       {
<a name="l01885"></a>01885                         Fe(js) += JxW[qp] * (neigh_phi[i][qp] *
<a name="l01886"></a>01886                                              phi[j][qp]);
<a name="l01887"></a>01887                         <span class="keywordflow">if</span> (cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l01888"></a>01888                           Fe(js) += JxW[qp] * (((*neigh_dphi)[i][qp] *
<a name="l01889"></a>01889                                                 (*face_normals)[qp]) *
<a name="l01890"></a>01890                                                ((*dphi)[j][qp] *
<a name="l01891"></a>01891                                                 (*face_normals)[qp]));
<a name="l01892"></a>01892                       }
<a name="l01893"></a>01893                   }
<a name="l01894"></a>01894                 Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(Fe, Ue[is]);
<a name="l01895"></a>01895               }
<a name="l01896"></a>01896             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l01897"></a>01897               {
<a name="l01898"></a>01898                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = neigh_side_dofs[is];
<a name="l01899"></a>01899                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> their_dof_g = neigh_dof_indices[i];
<a name="l01900"></a>01900                 libmesh_assert(their_dof_g != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01901"></a>01901                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l01902"></a>01902                   {
<a name="l01903"></a>01903                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l01904"></a>01904                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_dof_g = my_dof_indices[j];
<a name="l01905"></a>01905                     libmesh_assert(my_dof_g != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01906"></a>01906                     <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> their_dof_value = Ue[is](js);
<a name="l01907"></a>01907                     <span class="keywordflow">if</span> (their_dof_g == my_dof_g)
<a name="l01908"></a>01908                       {
<a name="l01909"></a>01909                         libmesh_assert(std::abs(their_dof_value-1.) &lt; 1.e-5);
<a name="l01910"></a>01910                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0; k != n_side_dofs; ++k)
<a name="l01911"></a>01911                           libmesh_assert(k == is || std::abs(Ue[k](js)) &lt; 1.e-5);
<a name="l01912"></a>01912                         <span class="keywordflow">continue</span>;
<a name="l01913"></a>01913                       }
<a name="l01914"></a>01914                     <span class="keywordflow">if</span> (std::abs(their_dof_value) &lt; 1.e-5)
<a name="l01915"></a>01915                       <span class="keywordflow">continue</span>;
<a name="l01916"></a>01916 
<a name="l01917"></a>01917                     <span class="comment">// since we may be running this method concurretly </span>
<a name="l01918"></a>01918                     <span class="comment">// on multiple threads we need to acquire a lock </span>
<a name="l01919"></a>01919                     <span class="comment">// before modifying the shared constraint_row object.</span>
<a name="l01920"></a>01920                     {
<a name="l01921"></a>01921                       Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l01922"></a>01922 
<a name="l01923"></a>01923                       <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row =
<a name="l01924"></a>01924                         constraints[my_dof_g];
<a name="l01925"></a>01925                       
<a name="l01926"></a>01926                       constraint_row.insert(std::make_pair(their_dof_g,
<a name="l01927"></a>01927                                                            their_dof_value));
<a name="l01928"></a>01928                     }
<a name="l01929"></a>01929                   }
<a name="l01930"></a>01930               }
<a name="l01931"></a>01931           }
<a name="l01932"></a>01932         <span class="comment">// p refinement constraints:</span>
<a name="l01933"></a>01933         <span class="comment">// constrain dofs shared between</span>
<a name="l01934"></a>01934         <span class="comment">// active elements and neighbors with</span>
<a name="l01935"></a>01935         <span class="comment">// lower polynomial degrees</span>
<a name="l01936"></a>01936         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level =
<a name="l01937"></a>01937           neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aad83f9aaca6d0bcef2a5205abcc134a9">min_p_level_by_neighbor</a>(elem, elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01938"></a>01938         <span class="keywordflow">if</span> (min_p_level &lt; elem-&gt;p_level())
<a name="l01939"></a>01939           {
<a name="l01940"></a>01940             <span class="comment">// Adaptive p refinement of non-hierarchic bases will</span>
<a name="l01941"></a>01941             <span class="comment">// require more coding</span>
<a name="l01942"></a>01942             libmesh_assert(my_fe-&gt;is_hierarchic());
<a name="l01943"></a>01943             dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a1c8e17a57f38de4ae0060311b5497989">constrain_p_dofs</a>(variable_number, elem,
<a name="l01944"></a>01944                                      s, min_p_level);
<a name="l01945"></a>01945           }
<a name="l01946"></a>01946       }
<a name="l01947"></a>01947 }
<a name="l01948"></a>01948 
<a name="l01949"></a>01949 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01950"></a>01950 <span class="preprocessor"></span>
<a name="l01951"></a>01951 
<a name="l01952"></a>01952 
<a name="l01953"></a>01953 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l01954"></a>01954 <span class="preprocessor"></span>
<a name="l01955"></a><a class="code" href="classlibMesh_1_1FEBase.php#a6a9baff4a0f58c4c62d50d00a77fbb40">01955</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a6a9baff4a0f58c4c62d50d00a77fbb40">FEBase::compute_periodic_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l01956"></a>01956                                            <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l01957"></a>01957                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l01958"></a>01958                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01959"></a>01959                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> *point_locator,
<a name="l01960"></a>01960                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l01961"></a>01961                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l01962"></a>01962 {
<a name="l01963"></a>01963   <span class="comment">// Only bother if we truly have periodic boundaries</span>
<a name="l01964"></a>01964   <span class="keywordflow">if</span> (boundaries.empty())
<a name="l01965"></a>01965     <span class="keywordflow">return</span>;
<a name="l01966"></a>01966 
<a name="l01967"></a>01967   libmesh_assert (elem != NULL);
<a name="l01968"></a>01968   
<a name="l01969"></a>01969   <span class="comment">// Only constrain active elements with this method</span>
<a name="l01970"></a>01970   <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l01971"></a>01971     <span class="keywordflow">return</span>;
<a name="l01972"></a>01972 
<a name="l01973"></a>01973   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01974"></a>01974   
<a name="l01975"></a>01975   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; base_fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(variable_number);
<a name="l01976"></a>01976 
<a name="l01977"></a>01977   <span class="comment">// Construct FE objects for this element and its pseudo-neighbors.</span>
<a name="l01978"></a>01978   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> my_fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim, base_fe_type));
<a name="l01979"></a>01979   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = my_fe-&gt;get_continuity();
<a name="l01980"></a>01980 
<a name="l01981"></a>01981   <span class="comment">// We don&#39;t need to constrain discontinuous elements</span>
<a name="l01982"></a>01982   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a>)
<a name="l01983"></a>01983     <span class="keywordflow">return</span>;
<a name="l01984"></a>01984   libmesh_assert (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>);
<a name="l01985"></a>01985 
<a name="l01986"></a>01986   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> neigh_fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim, base_fe_type));
<a name="l01987"></a>01987 
<a name="l01988"></a>01988   <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> my_qface(Dim-1, base_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a>());
<a name="l01989"></a>01989   my_fe-&gt;attach_quadrature_rule (&amp;my_qface);
<a name="l01990"></a>01990   std::vector&lt;Point&gt; neigh_qface;
<a name="l01991"></a>01991 
<a name="l01992"></a>01992   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a> = my_fe-&gt;get_JxW();
<a name="l01993"></a>01993   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; q_point = my_fe-&gt;get_xyz();
<a name="l01994"></a>01994   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a> = my_fe-&gt;get_phi();
<a name="l01995"></a>01995   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; neigh_phi =
<a name="l01996"></a>01996                   neigh_fe-&gt;get_phi();
<a name="l01997"></a>01997   <span class="keyword">const</span> std::vector&lt;Point&gt; *face_normals = NULL;
<a name="l01998"></a>01998   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *<a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a> = NULL;
<a name="l01999"></a>01999   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *neigh_dphi = NULL;
<a name="l02000"></a>02000   std::vector&lt;unsigned int&gt; my_dof_indices, neigh_dof_indices;
<a name="l02001"></a>02001   std::vector&lt;unsigned int&gt; my_side_dofs, neigh_side_dofs;
<a name="l02002"></a>02002 
<a name="l02003"></a>02003   <span class="keywordflow">if</span> (cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l02004"></a>02004     {
<a name="l02005"></a>02005       <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; ref_face_normals =
<a name="l02006"></a>02006         my_fe-&gt;get_normals();
<a name="l02007"></a>02007       face_normals = &amp;ref_face_normals;
<a name="l02008"></a>02008       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; ref_dphi =
<a name="l02009"></a>02009         my_fe-&gt;get_dphi();
<a name="l02010"></a>02010       dphi = &amp;ref_dphi;
<a name="l02011"></a>02011       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; ref_neigh_dphi =
<a name="l02012"></a>02012         neigh_fe-&gt;get_dphi();
<a name="l02013"></a>02013       neigh_dphi = &amp;ref_neigh_dphi;
<a name="l02014"></a>02014     }
<a name="l02015"></a>02015 
<a name="l02016"></a>02016   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Real&gt;</a> Ke;
<a name="l02017"></a>02017   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Real&gt;</a> Fe;
<a name="l02018"></a>02018   std::vector&lt;DenseVector&lt;Real&gt; &gt; Ue;
<a name="l02019"></a>02019 
<a name="l02020"></a>02020   <span class="comment">// Look at the element faces.  Check to see if we need to</span>
<a name="l02021"></a>02021   <span class="comment">// build constraints.</span>
<a name="l02022"></a>02022   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l02023"></a>02023     {
<a name="l02024"></a>02024       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s))
<a name="l02025"></a>02025         <span class="keywordflow">continue</span>;
<a name="l02026"></a>02026 
<a name="l02027"></a>02027       <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; bc_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids (elem, s);
<a name="l02028"></a>02028       <span class="keywordflow">for</span> (std::vector&lt;short int&gt;::const_iterator id_it=bc_ids.begin(); id_it!=bc_ids.end(); ++id_it)
<a name="l02029"></a>02029         {
<a name="l02030"></a>02030           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundary_id = *id_it;
<a name="l02031"></a>02031           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *periodic = boundaries.<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">boundary</a>(boundary_id);
<a name="l02032"></a>02032           <span class="keywordflow">if</span> (periodic &amp;&amp; periodic-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#afdb1f2ade1a6985da7e6c0c6143af2bf">is_my_variable</a>(variable_number))
<a name="l02033"></a>02033             {
<a name="l02034"></a>02034               libmesh_assert(point_locator);
<a name="l02035"></a>02035 
<a name="l02036"></a>02036               <span class="comment">// Get pointers to the element&#39;s neighbor.</span>
<a name="l02037"></a>02037               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neigh = boundaries.<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a06b6e333d6a0ffaee9252b703dfefede">neighbor</a>(boundary_id, *point_locator, elem, s);
<a name="l02038"></a>02038 
<a name="l02039"></a>02039               <span class="comment">// h refinement constraints:</span>
<a name="l02040"></a>02040               <span class="comment">// constrain dofs shared between</span>
<a name="l02041"></a>02041               <span class="comment">// this element and ones as coarse</span>
<a name="l02042"></a>02042               <span class="comment">// as or coarser than this element.</span>
<a name="l02043"></a>02043               <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt;= elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()) 
<a name="l02044"></a>02044                 {
<a name="l02045"></a>02045                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s_neigh = 
<a name="l02046"></a>02046                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;side_with_boundary_id (neigh, periodic-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>);
<a name="l02047"></a>02047                   libmesh_assert(s_neigh != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l02048"></a>02048 
<a name="l02049"></a>02049 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02050"></a>02050 <span class="preprocessor"></span>                  <span class="comment">// Find the minimum p level; we build the h constraint</span>
<a name="l02051"></a>02051                   <span class="comment">// matrix with this and then constrain away all higher p</span>
<a name="l02052"></a>02052                   <span class="comment">// DoFs.</span>
<a name="l02053"></a>02053                   libmesh_assert(neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l02054"></a>02054                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level =
<a name="l02055"></a>02055                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>(), neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l02056"></a>02056 
<a name="l02057"></a>02057                   <span class="comment">// we may need to make the FE objects reinit with the</span>
<a name="l02058"></a>02058                   <span class="comment">// minimum shared p_level</span>
<a name="l02059"></a>02059                   <span class="comment">// FIXME - I hate using const_cast&lt;&gt; and avoiding</span>
<a name="l02060"></a>02060                   <span class="comment">// accessor functions; there&#39;s got to be a</span>
<a name="l02061"></a>02061                   <span class="comment">// better way to do this!</span>
<a name="l02062"></a>02062                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l02063"></a>02063                   <span class="keywordflow">if</span> (old_elem_level != min_p_level)
<a name="l02064"></a>02064                     (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(elem))-&gt;hack_p_level(min_p_level);
<a name="l02065"></a>02065                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_neigh_level = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l02066"></a>02066                   <span class="keywordflow">if</span> (old_neigh_level != min_p_level)
<a name="l02067"></a>02067                     (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(neigh))-&gt;hack_p_level(min_p_level);
<a name="l02068"></a>02068 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02069"></a>02069 <span class="preprocessor"></span>
<a name="l02070"></a>02070                   my_fe-&gt;reinit(elem, s);
<a name="l02071"></a>02071 
<a name="l02072"></a>02072                   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, my_dof_indices,
<a name="l02073"></a>02073                                        variable_number);
<a name="l02074"></a>02074                   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (neigh, neigh_dof_indices,
<a name="l02075"></a>02075                                        variable_number);
<a name="l02076"></a>02076 
<a name="l02077"></a>02077                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = my_qface.n_points();
<a name="l02078"></a>02078 
<a name="l02079"></a>02079                   <span class="comment">// Translate the quadrature points over to the</span>
<a name="l02080"></a>02080                   <span class="comment">// neighbor&#39;s boundary</span>
<a name="l02081"></a>02081                   std::vector&lt;Point&gt; neigh_point(q_point.size());
<a name="l02082"></a>02082                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != neigh_point.size(); ++i)
<a name="l02083"></a>02083                     neigh_point[i] = periodic-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a27be85e1730579d906bad0d1703acfe2">get_corresponding_pos</a>(q_point[i]);
<a name="l02084"></a>02084 
<a name="l02085"></a>02085                   <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (Dim, base_fe_type, neigh,
<a name="l02086"></a>02086                                             neigh_point, neigh_qface);
<a name="l02087"></a>02087 
<a name="l02088"></a>02088                   neigh_fe-&gt;reinit(neigh, &amp;neigh_qface);
<a name="l02089"></a>02089 
<a name="l02090"></a>02090                   <span class="comment">// We&#39;re only concerned with DOFs whose values (and/or first</span>
<a name="l02091"></a>02091                   <span class="comment">// derivatives for C1 elements) are supported on side nodes</span>
<a name="l02092"></a>02092                   <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(elem, Dim, base_fe_type, s, my_side_dofs);
<a name="l02093"></a>02093                   <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">FEInterface::dofs_on_side</a>(neigh, Dim, base_fe_type, s_neigh, neigh_side_dofs);
<a name="l02094"></a>02094 
<a name="l02095"></a>02095                   <span class="comment">// We&#39;re done with functions that examine Elem::p_level(),</span>
<a name="l02096"></a>02096                   <span class="comment">// so let&#39;s unhack those levels</span>
<a name="l02097"></a>02097 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02098"></a>02098 <span class="preprocessor"></span>                  <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() != old_elem_level)
<a name="l02099"></a>02099                     (const_cast&lt;Elem *&gt;(elem))-&gt;hack_p_level(old_elem_level);
<a name="l02100"></a>02100                   <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() != old_neigh_level)
<a name="l02101"></a>02101                     (const_cast&lt;Elem *&gt;(neigh))-&gt;hack_p_level(old_neigh_level);
<a name="l02102"></a>02102 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02103"></a>02103 <span class="preprocessor"></span>
<a name="l02104"></a>02104                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_side_dofs = my_side_dofs.size();
<a name="l02105"></a>02105                   libmesh_assert(n_side_dofs == neigh_side_dofs.size());
<a name="l02106"></a>02106 
<a name="l02107"></a>02107                   Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (n_side_dofs, n_side_dofs);
<a name="l02108"></a>02108                   Ue.resize(n_side_dofs);
<a name="l02109"></a>02109 
<a name="l02110"></a>02110                   <span class="comment">// Form the projection matrix, (inner product of fine basis</span>
<a name="l02111"></a>02111                   <span class="comment">// functions against fine test functions)</span>
<a name="l02112"></a>02112                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l02113"></a>02113                     {
<a name="l02114"></a>02114                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = my_side_dofs[is];
<a name="l02115"></a>02115                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l02116"></a>02116                         {
<a name="l02117"></a>02117                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l02118"></a>02118                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qp; ++qp)
<a name="l02119"></a>02119                             {
<a name="l02120"></a>02120                               Ke(is,js) += JxW[qp] * (phi[i][qp] * phi[j][qp]);
<a name="l02121"></a>02121                               <span class="keywordflow">if</span> (cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l02122"></a>02122                                 Ke(is,js) += JxW[qp] * (((*dphi)[i][qp] *
<a name="l02123"></a>02123                                                        (*face_normals)[qp]) *
<a name="l02124"></a>02124                                                       ((*dphi)[j][qp] *
<a name="l02125"></a>02125                                                        (*face_normals)[qp]));
<a name="l02126"></a>02126                             }
<a name="l02127"></a>02127                         }
<a name="l02128"></a>02128                     }
<a name="l02129"></a>02129 
<a name="l02130"></a>02130                   <span class="comment">// Form the right hand sides, (inner product of coarse basis</span>
<a name="l02131"></a>02131                   <span class="comment">// functions against fine test functions)</span>
<a name="l02132"></a>02132                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l02133"></a>02133                     {
<a name="l02134"></a>02134                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = neigh_side_dofs[is];
<a name="l02135"></a>02135                       Fe.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (n_side_dofs);
<a name="l02136"></a>02136                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l02137"></a>02137                         {
<a name="l02138"></a>02138                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l02139"></a>02139                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qp; ++qp)
<a name="l02140"></a>02140                             {
<a name="l02141"></a>02141                               Fe(js) += JxW[qp] * (neigh_phi[i][qp] *
<a name="l02142"></a>02142                                                    phi[j][qp]);
<a name="l02143"></a>02143                               <span class="keywordflow">if</span> (cont != <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>)
<a name="l02144"></a>02144                                 Fe(js) += JxW[qp] * (((*neigh_dphi)[i][qp] *
<a name="l02145"></a>02145                                                       (*face_normals)[qp]) *
<a name="l02146"></a>02146                                                      ((*dphi)[j][qp] *
<a name="l02147"></a>02147                                                       (*face_normals)[qp]));
<a name="l02148"></a>02148                             }
<a name="l02149"></a>02149                         }
<a name="l02150"></a>02150                       Ke.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(Fe, Ue[is]);
<a name="l02151"></a>02151                     }
<a name="l02152"></a>02152 
<a name="l02153"></a>02153                   <span class="comment">// Make sure we&#39;re not adding recursive constraints</span>
<a name="l02154"></a>02154                   <span class="comment">// due to the redundancy in the way we add periodic</span>
<a name="l02155"></a>02155                   <span class="comment">// boundary constraints</span>
<a name="l02156"></a>02156                   std::vector&lt;bool&gt; recursive_constraint(n_side_dofs, <span class="keyword">false</span>);
<a name="l02157"></a>02157 
<a name="l02158"></a>02158                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l02159"></a>02159                     {
<a name="l02160"></a>02160                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = neigh_side_dofs[is];
<a name="l02161"></a>02161                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> their_dof_g = neigh_dof_indices[i];
<a name="l02162"></a>02162                       libmesh_assert(their_dof_g != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l02163"></a>02163 
<a name="l02164"></a>02164                       <span class="keywordflow">if</span> (!dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">is_constrained_dof</a>(their_dof_g))
<a name="l02165"></a>02165                         <span class="keywordflow">continue</span>;
<a name="l02166"></a>02166 
<a name="l02167"></a>02167                       <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; their_constraint_row =
<a name="l02168"></a>02168                         constraints[their_dof_g];
<a name="l02169"></a>02169 
<a name="l02170"></a>02170                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l02171"></a>02171                         {
<a name="l02172"></a>02172                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l02173"></a>02173                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_dof_g = my_dof_indices[j];
<a name="l02174"></a>02174                           libmesh_assert(my_dof_g != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l02175"></a>02175 
<a name="l02176"></a>02176                           <span class="keywordflow">if</span> (their_constraint_row.count(my_dof_g))
<a name="l02177"></a>02177                             recursive_constraint[js] = <span class="keyword">true</span>;
<a name="l02178"></a>02178                         }
<a name="l02179"></a>02179                     }
<a name="l02180"></a>02180                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> js = 0; js != n_side_dofs; ++js)
<a name="l02181"></a>02181                     {
<a name="l02182"></a>02182                       <span class="keywordflow">if</span> (recursive_constraint[js])
<a name="l02183"></a>02183                         <span class="keywordflow">continue</span>;
<a name="l02184"></a>02184 
<a name="l02185"></a>02185                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = my_side_dofs[js];
<a name="l02186"></a>02186                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_dof_g = my_dof_indices[j];
<a name="l02187"></a>02187                       libmesh_assert(my_dof_g != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l02188"></a>02188 
<a name="l02189"></a>02189                       <span class="keywordflow">if</span> (dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">is_constrained_dof</a>(my_dof_g))
<a name="l02190"></a>02190                         <span class="keywordflow">continue</span>;
<a name="l02191"></a>02191 
<a name="l02192"></a>02192                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> is = 0; is != n_side_dofs; ++is)
<a name="l02193"></a>02193                         {
<a name="l02194"></a>02194                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = neigh_side_dofs[is];
<a name="l02195"></a>02195                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> their_dof_g = neigh_dof_indices[i];
<a name="l02196"></a>02196                           libmesh_assert(their_dof_g != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l02197"></a>02197 
<a name="l02198"></a>02198                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> their_dof_value = Ue[is](js);
<a name="l02199"></a>02199                           <span class="keywordflow">if</span> (their_dof_g == my_dof_g)
<a name="l02200"></a>02200                             {
<a name="l02201"></a>02201                               libmesh_assert(std::abs(their_dof_value-1.) &lt; 1.e-5);
<a name="l02202"></a>02202                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0; k != n_side_dofs; ++k)
<a name="l02203"></a>02203                                 libmesh_assert(k == is || std::abs(Ue[k](js)) &lt; 1.e-5);
<a name="l02204"></a>02204                               <span class="keywordflow">continue</span>;
<a name="l02205"></a>02205                             }
<a name="l02206"></a>02206                           <span class="keywordflow">if</span> (std::abs(their_dof_value) &lt; 1.e-5)
<a name="l02207"></a>02207                             <span class="keywordflow">continue</span>;
<a name="l02208"></a>02208 
<a name="l02209"></a>02209                           <span class="comment">// since we may be running this method concurretly </span>
<a name="l02210"></a>02210                           <span class="comment">// on multiple threads we need to acquire a lock </span>
<a name="l02211"></a>02211                           <span class="comment">// before modifying the shared constraint_row object.</span>
<a name="l02212"></a>02212                           {
<a name="l02213"></a>02213                             Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l02214"></a>02214 
<a name="l02215"></a>02215                             <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row =
<a name="l02216"></a>02216                               constraints[my_dof_g];
<a name="l02217"></a>02217 
<a name="l02218"></a>02218                             constraint_row.insert(std::make_pair(their_dof_g,
<a name="l02219"></a>02219                                                                  their_dof_value));
<a name="l02220"></a>02220                           }
<a name="l02221"></a>02221                         }
<a name="l02222"></a>02222                     }
<a name="l02223"></a>02223                 }
<a name="l02224"></a>02224               <span class="comment">// p refinement constraints:</span>
<a name="l02225"></a>02225               <span class="comment">// constrain dofs shared between</span>
<a name="l02226"></a>02226               <span class="comment">// active elements and neighbors with</span>
<a name="l02227"></a>02227               <span class="comment">// lower polynomial degrees</span>
<a name="l02228"></a>02228 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02229"></a>02229 <span class="preprocessor"></span>              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level =
<a name="l02230"></a>02230                 neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aad83f9aaca6d0bcef2a5205abcc134a9">min_p_level_by_neighbor</a>(elem, elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l02231"></a>02231               <span class="keywordflow">if</span> (min_p_level &lt; elem-&gt;p_level())
<a name="l02232"></a>02232                 {
<a name="l02233"></a>02233                   <span class="comment">// Adaptive p refinement of non-hierarchic bases will</span>
<a name="l02234"></a>02234                   <span class="comment">// require more coding</span>
<a name="l02235"></a>02235                   libmesh_assert(my_fe-&gt;is_hierarchic());
<a name="l02236"></a>02236                   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a1c8e17a57f38de4ae0060311b5497989">constrain_p_dofs</a>(variable_number, elem,
<a name="l02237"></a>02237                                            s, min_p_level);
<a name="l02238"></a>02238                 }
<a name="l02239"></a>02239 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02240"></a>02240 <span class="preprocessor"></span>            }
<a name="l02241"></a>02241         }
<a name="l02242"></a>02242     }
<a name="l02243"></a>02243 }
<a name="l02244"></a>02244 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l02245"></a>02245 <span class="preprocessor"></span>
<a name="l02246"></a>02246 
<a name="l02247"></a>02247 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
