<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_bernstein_shape_3D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__bernstein__shape__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_bernstein_shape_3D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The Next Great Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;&gt;
<a name="l00038"></a><a class="code" href="classlibMesh_1_1FE.php#a27272bbadca01c2ece812670c6b719d5">00038</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;3,BERNSTEIN&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00039"></a>00039                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00040"></a>00040                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00041"></a>00041                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Bernstein polynomials require the element type\n&quot;</span>
<a name="l00044"></a>00044                 &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00045"></a>00045                 &lt;&lt; std::endl;
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   libmesh_error();
<a name="l00048"></a>00048   <span class="keywordflow">return</span> 0.;
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;&gt;
<a name="l00054"></a><a class="code" href="classlibMesh_1_1FE.php#a9635cc2db620765a4dae1120c907ced2">00054</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;3,BERNSTEIN&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00055"></a>00055                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00056"></a>00056                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00057"></a>00057                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   
<a name="l00060"></a>00060 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>  
<a name="l00062"></a>00062   libmesh_assert (elem != NULL);
<a name="l00063"></a>00063   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00066"></a>00066   
<a name="l00067"></a>00067   <span class="keywordflow">switch</span> (totalorder)
<a name="l00068"></a>00068     {
<a name="l00069"></a>00069       
<a name="l00070"></a>00070       <span class="comment">// 1st order Bernstein.</span>
<a name="l00071"></a>00071     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00072"></a>00072       {
<a name="l00073"></a>00073         <span class="keywordflow">switch</span> (type)
<a name="l00074"></a>00074           {
<a name="l00075"></a>00075             
<a name="l00076"></a>00076             <span class="comment">// Bernstein shape functions on the tetrahedron.</span>
<a name="l00077"></a>00077           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00078"></a>00078           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00079"></a>00079             {
<a name="l00080"></a>00080               libmesh_assert(i&lt;4);
<a name="l00081"></a>00081               
<a name="l00082"></a>00082               <span class="comment">// Area coordinates</span>
<a name="l00083"></a>00083               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta1 = p(0);
<a name="l00084"></a>00084               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta2 = p(1);
<a name="l00085"></a>00085               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta3 = p(2);
<a name="l00086"></a>00086               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta0 = 1. - zeta1 - zeta2 - zeta3;
<a name="l00087"></a>00087               
<a name="l00088"></a>00088               <span class="keywordflow">switch</span>(i)
<a name="l00089"></a>00089                 {
<a name="l00090"></a>00090                 <span class="keywordflow">case</span>  0:  <span class="keywordflow">return</span> zeta0;    
<a name="l00091"></a>00091                 <span class="keywordflow">case</span>  1:  <span class="keywordflow">return</span> zeta1;    
<a name="l00092"></a>00092                 <span class="keywordflow">case</span>  2:  <span class="keywordflow">return</span> zeta2;    
<a name="l00093"></a>00093                 <span class="keywordflow">case</span>  3:  <span class="keywordflow">return</span> zeta3;
<a name="l00094"></a>00094                   
<a name="l00095"></a>00095                 <span class="keywordflow">default</span>:
<a name="l00096"></a>00096                   libmesh_error();
<a name="l00097"></a>00097                 }
<a name="l00098"></a>00098             }
<a name="l00099"></a>00099             
<a name="l00100"></a>00100             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l00101"></a>00101           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00102"></a>00102           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00103"></a>00103             {
<a name="l00104"></a>00104               libmesh_assert (i&lt;8);
<a name="l00105"></a>00105               
<a name="l00106"></a>00106               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00107"></a>00107               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l00108"></a>00108               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l00109"></a>00109               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l00110"></a>00110               
<a name="l00111"></a>00111               <span class="comment">// The only way to make any sense of this</span>
<a name="l00112"></a>00112               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00113"></a>00113               <span class="comment">// and make the cut-out cube!</span>
<a name="l00114"></a>00114               <span class="comment">//                                0  1  2  3  4  5  6  7</span>
<a name="l00115"></a>00115               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0};
<a name="l00116"></a>00116               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1};
<a name="l00117"></a>00117               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1};
<a name="l00118"></a>00118               
<a name="l00119"></a>00119               <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], xi)*
<a name="l00120"></a>00120                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], eta)*
<a name="l00121"></a>00121                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], zeta));
<a name="l00122"></a>00122             }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124             
<a name="l00125"></a>00125           <span class="keywordflow">default</span>:
<a name="l00126"></a>00126             libmesh_error();
<a name="l00127"></a>00127           }
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129       
<a name="l00130"></a>00130       
<a name="l00131"></a>00131       
<a name="l00132"></a>00132       
<a name="l00133"></a>00133     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00134"></a>00134       {
<a name="l00135"></a>00135         <span class="keywordflow">switch</span> (type)
<a name="l00136"></a>00136           {
<a name="l00137"></a>00137         
<a name="l00138"></a>00138             <span class="comment">// Bernstein shape functions on the tetrahedron.</span>
<a name="l00139"></a>00139           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00140"></a>00140             {
<a name="l00141"></a>00141               libmesh_assert(i&lt;10);
<a name="l00142"></a>00142         
<a name="l00143"></a>00143               <span class="comment">// Area coordinates</span>
<a name="l00144"></a>00144               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta1 = p(0);
<a name="l00145"></a>00145               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta2 = p(1);
<a name="l00146"></a>00146               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta3 = p(2);
<a name="l00147"></a>00147               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta0 = 1. - zeta1 - zeta2 - zeta3;
<a name="l00148"></a>00148               
<a name="l00149"></a>00149               <span class="keywordflow">switch</span>(i)
<a name="l00150"></a>00150                 {
<a name="l00151"></a>00151                 <span class="keywordflow">case</span>  0:  <span class="keywordflow">return</span> zeta0*zeta0;                   
<a name="l00152"></a>00152                 <span class="keywordflow">case</span>  1:  <span class="keywordflow">return</span> zeta1*zeta1;                   
<a name="l00153"></a>00153                 <span class="keywordflow">case</span>  2:  <span class="keywordflow">return</span> zeta2*zeta2;           
<a name="l00154"></a>00154                 <span class="keywordflow">case</span>  3:  <span class="keywordflow">return</span> zeta3*zeta3;
<a name="l00155"></a>00155                 <span class="keywordflow">case</span>  4:  <span class="keywordflow">return</span> 2.*zeta0*zeta1;
<a name="l00156"></a>00156                 <span class="keywordflow">case</span>  5:  <span class="keywordflow">return</span> 2.*zeta1*zeta2;
<a name="l00157"></a>00157                 <span class="keywordflow">case</span>  6:  <span class="keywordflow">return</span> 2.*zeta0*zeta2;
<a name="l00158"></a>00158                 <span class="keywordflow">case</span>  7:  <span class="keywordflow">return</span> 2.*zeta3*zeta0;
<a name="l00159"></a>00159                 <span class="keywordflow">case</span>  8:  <span class="keywordflow">return</span> 2.*zeta1*zeta3;
<a name="l00160"></a>00160                 <span class="keywordflow">case</span>  9:  <span class="keywordflow">return</span> 2.*zeta2*zeta3;     
<a name="l00161"></a>00161                   
<a name="l00162"></a>00162                 <span class="keywordflow">default</span>:
<a name="l00163"></a>00163                   libmesh_error();
<a name="l00164"></a>00164                 }
<a name="l00165"></a>00165             }
<a name="l00166"></a>00166             
<a name="l00167"></a>00167             <span class="comment">// Bernstein shape functions on the 20-noded hexahedral.</span>
<a name="l00168"></a>00168           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00169"></a>00169             {
<a name="l00170"></a>00170               libmesh_assert (i&lt;20);
<a name="l00171"></a>00171               
<a name="l00172"></a>00172               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00173"></a>00173               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l00174"></a>00174               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l00175"></a>00175               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l00176"></a>00176               
<a name="l00177"></a>00177               <span class="comment">// The only way to make any sense of this</span>
<a name="l00178"></a>00178               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00179"></a>00179               <span class="comment">// and make the cut-out cube!</span>
<a name="l00180"></a>00180               <span class="comment">//                                0      1      2      3      4      5      6      7      8      9      10     11     12     13     14     15     16     17     18     19  20 21 22 23 24 25 26</span>
<a name="l00181"></a>00181               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0,     1,     1,     0,     0,     1,     1,     0,     2,     1,     2,     0,     0,     1,     1,     0,     2,     1,     2,     0,  2, 2, 1, 2, 0, 2, 2};
<a name="l00182"></a>00182               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0,     0,     1,     1,     0,     0,     1,     1,     0,     2,     1,     2,     0,     0,     1,     1,     0,     2,     1,     2,  2, 0, 2, 1, 2, 2, 2};
<a name="l00183"></a>00183               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0,     0,     0,     0,     1,     1,     1,     1,     0,     0,     0,     0,     2,     2,     2,     2,     1,     1,     1,     1,  0, 2, 2, 2, 2, 1, 2};
<a name="l00184"></a>00184               <span class="comment">//To compute the hex20 shape functions the original shape functions for hex27 are used.</span>
<a name="l00185"></a>00185               <span class="comment">//scalx[i] tells how often the original x-th shape function has to be added to the original i-th shape function</span>
<a name="l00186"></a>00186               <span class="comment">//to compute the new i-th shape function for hex20</span>
<a name="l00187"></a>00187               <span class="comment">//example: B_0^HEX20 = B_0^HEX27 - 0.25*B_20^HEX27 - 0.25*B_21^HEX27 + 0*B_22^HEX27 + 0*B_23^HEX27 - 0.25*B_24^HEX27 + 0*B_25^HEX27 - 0.25*B_26^HEX27</span>
<a name="l00188"></a>00188               <span class="comment">//         B_0^HEX20 = B_0^HEX27 + scal20[0]*B_20^HEX27 + scal21[0]*B_21^HEX27 + ...</span>
<a name="l00189"></a>00189               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal20[] =     {-0.25, -0.25, -0.25, -0.25, 0,     0,     0,     0,     0.5,   0.5,   0.5,   0.5,   0,     0,     0,     0,     0,     0,     0,     0};
<a name="l00190"></a>00190               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal21[] =     {-0.25, -0.25, 0,     0,     -0.25, -0.25, 0,     0,     0.5,   0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0,     0,     0};
<a name="l00191"></a>00191               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal22[] =     {0,     -0.25, -0.25, 0,     0,     -0.25, -0.25, 0,     0,     0.5,   0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0,     0};
<a name="l00192"></a>00192               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal23[] =     {0,     0,     -0.25, -0.25, 0,     0,     -0.25, -0.25, 0,     0,     0.5,   0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0};
<a name="l00193"></a>00193               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal24[] =     {-0.25, 0,     0,     -0.25, -0.25, 0,     0,     -0.25, 0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0,     0,     0,     0.5};
<a name="l00194"></a>00194               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal25[] =     {0,     0,     0,     0,     -0.25, -0.25, -0.25, -0.25, 0,     0,     0,     0,     0,     0,     0,     0,     0.5,   0.5,   0.5,   0.5};
<a name="l00195"></a>00195               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal26[] =     {-0.25, -0.25, -0.25, -0.25, -0.25, -0.25, -0.25, -0.25, 0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25};
<a name="l00196"></a>00196               
<a name="l00197"></a>00197               <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], xi)*
<a name="l00198"></a>00198                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], eta)*
<a name="l00199"></a>00199                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], zeta)
<a name="l00200"></a>00200                       +scal20[i]*
<a name="l00201"></a>00201                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[20], xi)*
<a name="l00202"></a>00202                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[20], eta)*
<a name="l00203"></a>00203                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[20], zeta)
<a name="l00204"></a>00204                       +scal21[i]*
<a name="l00205"></a>00205                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[21], xi)*
<a name="l00206"></a>00206                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[21], eta)*
<a name="l00207"></a>00207                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[21], zeta)
<a name="l00208"></a>00208                       +scal22[i]*
<a name="l00209"></a>00209                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[22], xi)*
<a name="l00210"></a>00210                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[22], eta)*
<a name="l00211"></a>00211                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[22], zeta)
<a name="l00212"></a>00212                       +scal23[i]*
<a name="l00213"></a>00213                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[23], xi)*
<a name="l00214"></a>00214                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[23], eta)*
<a name="l00215"></a>00215                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[23], zeta)
<a name="l00216"></a>00216                       +scal24[i]*
<a name="l00217"></a>00217                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[24], xi)*
<a name="l00218"></a>00218                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[24], eta)*
<a name="l00219"></a>00219                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[24], zeta)
<a name="l00220"></a>00220                       +scal25[i]*
<a name="l00221"></a>00221                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[25], xi)*
<a name="l00222"></a>00222                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[25], eta)*
<a name="l00223"></a>00223                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[25], zeta)
<a name="l00224"></a>00224                       +scal26[i]*
<a name="l00225"></a>00225                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[26], xi)*
<a name="l00226"></a>00226                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[26], eta)*
<a name="l00227"></a>00227                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[26], zeta));
<a name="l00228"></a>00228             }
<a name="l00229"></a>00229             
<a name="l00230"></a>00230             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l00231"></a>00231           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00232"></a>00232             {
<a name="l00233"></a>00233               libmesh_assert (i&lt;27);
<a name="l00234"></a>00234               
<a name="l00235"></a>00235               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00236"></a>00236               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l00237"></a>00237               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l00238"></a>00238               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l00239"></a>00239         
<a name="l00240"></a>00240               <span class="comment">// The only way to make any sense of this</span>
<a name="l00241"></a>00241               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00242"></a>00242               <span class="comment">// and make the cut-out cube!</span>
<a name="l00243"></a>00243               <span class="comment">//                                0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26</span>
<a name="l00244"></a>00244               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 1, 2, 0, 0, 1, 1, 0, 2, 1, 2, 0, 2, 2, 1, 2, 0, 2, 2};
<a name="l00245"></a>00245               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 2, 1, 2, 0, 0, 1, 1, 0, 2, 1, 2, 2, 0, 2, 1, 2, 2, 2};
<a name="l00246"></a>00246               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 2, 2, 1, 1, 1, 1, 0, 2, 2, 2, 2, 1, 2};
<a name="l00247"></a>00247               
<a name="l00248"></a>00248               <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], xi)*
<a name="l00249"></a>00249                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], eta)*
<a name="l00250"></a>00250                       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], zeta));
<a name="l00251"></a>00251             }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253             
<a name="l00254"></a>00254           <span class="keywordflow">default</span>:
<a name="l00255"></a>00255             libmesh_error();
<a name="l00256"></a>00256           }
<a name="l00257"></a>00257         
<a name="l00258"></a>00258       }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260       
<a name="l00261"></a>00261       
<a name="l00262"></a>00262       <span class="comment">// 3rd-order Bernstein.</span>
<a name="l00263"></a>00263     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00264"></a>00264       {
<a name="l00265"></a>00265         <span class="keywordflow">switch</span> (type)
<a name="l00266"></a>00266           {
<a name="l00267"></a>00267           
<a name="l00268"></a>00268 <span class="comment">//          // Bernstein shape functions on the tetrahedron.</span>
<a name="l00269"></a>00269 <span class="comment">//        case TET10:</span>
<a name="l00270"></a>00270 <span class="comment">//          {</span>
<a name="l00271"></a>00271 <span class="comment">//            libmesh_assert(i&lt;20);</span>
<a name="l00272"></a>00272               
<a name="l00273"></a>00273 <span class="comment">//            // Area coordinates</span>
<a name="l00274"></a>00274 <span class="comment">//            const Real zeta1 = p(0);</span>
<a name="l00275"></a>00275 <span class="comment">//            const Real zeta2 = p(1);</span>
<a name="l00276"></a>00276 <span class="comment">//            const Real zeta3 = p(2);</span>
<a name="l00277"></a>00277 <span class="comment">//            const Real zeta0 = 1. - zeta1 - zeta2 - zeta3;</span>
<a name="l00278"></a>00278               
<a name="l00279"></a>00279               
<a name="l00280"></a>00280 <span class="comment">//            unsigned int shape=i;</span>
<a name="l00281"></a>00281               
<a name="l00282"></a>00282 <span class="comment">//            // handle the edge orientation</span>
<a name="l00283"></a>00283               
<a name="l00284"></a>00284 <span class="comment">//            if ((i== 4||i== 5) &amp;&amp; elem-&gt;node(0) &gt; elem-&gt;node(1))shape= 9-i;   //Edge 0</span>
<a name="l00285"></a>00285 <span class="comment">//            if ((i== 6||i== 7) &amp;&amp; elem-&gt;node(1) &gt; elem-&gt;node(2))shape=13-i;   //Edge 1</span>
<a name="l00286"></a>00286 <span class="comment">//            if ((i== 8||i== 9) &amp;&amp; elem-&gt;node(0) &gt; elem-&gt;node(2))shape=17-i;   //Edge 2</span>
<a name="l00287"></a>00287 <span class="comment">//            if ((i==10||i==11) &amp;&amp; elem-&gt;node(0) &gt; elem-&gt;node(3))shape=21-i;   //Edge 3</span>
<a name="l00288"></a>00288 <span class="comment">//            if ((i==12||i==13) &amp;&amp; elem-&gt;node(1) &gt; elem-&gt;node(3))shape=25-i;   //Edge 4</span>
<a name="l00289"></a>00289 <span class="comment">//            if ((i==14||i==15) &amp;&amp; elem-&gt;node(2) &gt; elem-&gt;node(3))shape=29-i;   //Edge 5</span>
<a name="l00290"></a>00290               
<a name="l00291"></a>00291 <span class="comment">//            // No need to handle face orientation in 3rd order.</span>
<a name="l00292"></a>00292               
<a name="l00293"></a>00293               
<a name="l00294"></a>00294 <span class="comment">//            switch(shape)</span>
<a name="l00295"></a>00295 <span class="comment">//              {</span>
<a name="l00296"></a>00296 <span class="comment">//                //point function</span>
<a name="l00297"></a>00297 <span class="comment">//              case  0:  return zeta0*zeta0*zeta0;</span>
<a name="l00298"></a>00298 <span class="comment">//              case  1:  return zeta1*zeta1*zeta1;</span>
<a name="l00299"></a>00299 <span class="comment">//              case  2:  return zeta2*zeta2*zeta2;</span>
<a name="l00300"></a>00300 <span class="comment">//              case  3:  return zeta3*zeta3*zeta3;</span>
<a name="l00301"></a>00301                   
<a name="l00302"></a>00302 <span class="comment">//                //edge functions</span>
<a name="l00303"></a>00303 <span class="comment">//              case  4:  return 3.*zeta0*zeta0*zeta1;</span>
<a name="l00304"></a>00304 <span class="comment">//              case  5:  return 3.*zeta1*zeta1*zeta0;</span>
<a name="l00305"></a>00305                           
<a name="l00306"></a>00306 <span class="comment">//              case  6:  return 3.*zeta1*zeta1*zeta2;</span>
<a name="l00307"></a>00307 <span class="comment">//              case  7:  return 3.*zeta2*zeta2*zeta1;</span>
<a name="l00308"></a>00308                   
<a name="l00309"></a>00309 <span class="comment">//              case  8:  return 3.*zeta0*zeta0*zeta2;</span>
<a name="l00310"></a>00310 <span class="comment">//              case  9:  return 3.*zeta2*zeta2*zeta0;</span>
<a name="l00311"></a>00311                   
<a name="l00312"></a>00312 <span class="comment">//              case 10:  return 3.*zeta0*zeta0*zeta3;</span>
<a name="l00313"></a>00313 <span class="comment">//              case 11:  return 3.*zeta3*zeta3*zeta0;</span>
<a name="l00314"></a>00314                   
<a name="l00315"></a>00315 <span class="comment">//              case 12:  return 3.*zeta1*zeta1*zeta3;</span>
<a name="l00316"></a>00316 <span class="comment">//              case 13:  return 3.*zeta3*zeta3*zeta1;</span>
<a name="l00317"></a>00317                   
<a name="l00318"></a>00318 <span class="comment">//              case 14:  return 3.*zeta2*zeta2*zeta3;</span>
<a name="l00319"></a>00319 <span class="comment">//              case 15:  return 3.*zeta3*zeta3*zeta2;</span>
<a name="l00320"></a>00320                           
<a name="l00321"></a>00321 <span class="comment">//                //face functions</span>
<a name="l00322"></a>00322 <span class="comment">//              case 16:  return 6.*zeta0*zeta1*zeta2;</span>
<a name="l00323"></a>00323 <span class="comment">//              case 17:  return 6.*zeta0*zeta1*zeta3;</span>
<a name="l00324"></a>00324 <span class="comment">//              case 18:  return 6.*zeta1*zeta2*zeta3;</span>
<a name="l00325"></a>00325 <span class="comment">//              case 19:  return 6.*zeta2*zeta0*zeta3;</span>
<a name="l00326"></a>00326                   
<a name="l00327"></a>00327 <span class="comment">//              default:</span>
<a name="l00328"></a>00328 <span class="comment">//                libmesh_error();</span>
<a name="l00329"></a>00329 <span class="comment">//              }</span>
<a name="l00330"></a>00330 <span class="comment">//          }</span>
<a name="l00331"></a>00331             
<a name="l00332"></a>00332             
<a name="l00333"></a>00333             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l00334"></a>00334           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00335"></a>00335             {
<a name="l00336"></a>00336               libmesh_assert (i&lt;64);
<a name="l00337"></a>00337               
<a name="l00338"></a>00338               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00339"></a>00339               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi    = p(0);
<a name="l00340"></a>00340               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta   = p(1);
<a name="l00341"></a>00341               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta  = p(2);
<a name="l00342"></a>00342               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi_mapped   = p(0);
<a name="l00343"></a>00343               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta_mapped  = p(1);
<a name="l00344"></a>00344               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta_mapped = p(2);
<a name="l00345"></a>00345               
<a name="l00346"></a>00346               <span class="comment">// The only way to make any sense of this</span>
<a name="l00347"></a>00347               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00348"></a>00348               <span class="comment">// and make the cut-out cube!</span>
<a name="l00349"></a>00349               <span class="comment">//  Nodes                         0  1  2  3  4  5  6  7  8  8  9  9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 20 20 21 21 21 21 22 22 22 22 23 23 23 23 24 24 24 24 25 25 25 25 26 26 26 26 26 26 26 26 </span>
<a name="l00350"></a>00350               <span class="comment">//  DOFS                          0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 18 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 60 62 63</span>
<a name="l00351"></a>00351               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3};
<a name="l00352"></a>00352               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 2, 2, 3, 3, 0, 0, 0, 0, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3};
<a name="l00353"></a>00353               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3};
<a name="l00354"></a>00354 
<a name="l00355"></a>00355               
<a name="l00356"></a>00356 
<a name="l00357"></a>00357               <span class="comment">// handle the edge orientation</span>
<a name="l00358"></a>00358               {
<a name="l00359"></a>00359                 <span class="comment">// Edge 0</span>
<a name="l00360"></a>00360                 <span class="keywordflow">if</span> ( (i0[i] &gt;= 2) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] == 0))
<a name="l00361"></a>00361                   {
<a name="l00362"></a>00362                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l00363"></a>00363                       xi_mapped = -xi;
<a name="l00364"></a>00364                   }
<a name="l00365"></a>00365                 <span class="comment">// Edge 1</span>
<a name="l00366"></a>00366                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] == 0))
<a name="l00367"></a>00367                   {
<a name="l00368"></a>00368                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00369"></a>00369                       eta_mapped = -eta;
<a name="l00370"></a>00370                   }
<a name="l00371"></a>00371                 <span class="comment">// Edge 2</span>
<a name="l00372"></a>00372                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] &gt;= 2) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] == 0))
<a name="l00373"></a>00373                   {
<a name="l00374"></a>00374                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00375"></a>00375                       xi_mapped = -xi;
<a name="l00376"></a>00376                   }
<a name="l00377"></a>00377                 <span class="comment">// Edge 3</span>
<a name="l00378"></a>00378                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] == 0))
<a name="l00379"></a>00379                   {
<a name="l00380"></a>00380                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00381"></a>00381                       eta_mapped = -eta;
<a name="l00382"></a>00382                   }
<a name="l00383"></a>00383                 <span class="comment">// Edge 4</span>
<a name="l00384"></a>00384                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00385"></a>00385                   {
<a name="l00386"></a>00386                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00387"></a>00387                       zeta_mapped = -zeta;
<a name="l00388"></a>00388                   }             
<a name="l00389"></a>00389                 <span class="comment">// Edge 5</span>
<a name="l00390"></a>00390                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00391"></a>00391                   {
<a name="l00392"></a>00392                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00393"></a>00393                       zeta_mapped = -zeta;
<a name="l00394"></a>00394                   }             
<a name="l00395"></a>00395                 <span class="comment">// Edge 6</span>
<a name="l00396"></a>00396                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00397"></a>00397                   {
<a name="l00398"></a>00398                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00399"></a>00399                       zeta_mapped = -zeta;
<a name="l00400"></a>00400                   }
<a name="l00401"></a>00401                 <span class="comment">// Edge 7</span>
<a name="l00402"></a>00402                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00403"></a>00403                   {
<a name="l00404"></a>00404                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00405"></a>00405                       zeta_mapped = -zeta;
<a name="l00406"></a>00406                   }             
<a name="l00407"></a>00407                 <span class="comment">// Edge 8</span>
<a name="l00408"></a>00408                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] &gt;=2 ) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] == 1))
<a name="l00409"></a>00409                   {
<a name="l00410"></a>00410                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00411"></a>00411                       xi_mapped = -xi;
<a name="l00412"></a>00412                   }
<a name="l00413"></a>00413                 <span class="comment">// Edge 9</span>
<a name="l00414"></a>00414                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] &gt;=2 ) &amp;&amp; (i2[i] == 1))
<a name="l00415"></a>00415                   {
<a name="l00416"></a>00416                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00417"></a>00417                       eta_mapped = -eta;
<a name="l00418"></a>00418                   }             
<a name="l00419"></a>00419                 <span class="comment">// Edge 10</span>
<a name="l00420"></a>00420                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] &gt;=2 ) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] == 1))
<a name="l00421"></a>00421                   {
<a name="l00422"></a>00422                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00423"></a>00423                       xi_mapped = -xi;
<a name="l00424"></a>00424                   }
<a name="l00425"></a>00425                 <span class="comment">// Edge 11</span>
<a name="l00426"></a>00426                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] &gt;=2 ) &amp;&amp; (i2[i] == 1))
<a name="l00427"></a>00427                   {
<a name="l00428"></a>00428                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00429"></a>00429                       eta_mapped = -eta;
<a name="l00430"></a>00430                   }
<a name="l00431"></a>00431               }
<a name="l00432"></a>00432               
<a name="l00433"></a>00433               
<a name="l00434"></a>00434               <span class="comment">// handle the face orientation</span>
<a name="l00435"></a>00435               {
<a name="l00436"></a>00436                 <span class="comment">// Face 0</span>
<a name="l00437"></a>00437                 <span class="keywordflow">if</span> (     (i2[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))
<a name="l00438"></a>00438                   {
<a name="l00439"></a>00439                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1),
<a name="l00440"></a>00440                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2),
<a name="l00441"></a>00441                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0),
<a name="l00442"></a>00442                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3))));
<a name="l00443"></a>00443                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == min_point)
<a name="l00444"></a>00444                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00445"></a>00445                         {
<a name="l00446"></a>00446                           <span class="comment">// Case 1</span>
<a name="l00447"></a>00447                           xi_mapped  = xi;
<a name="l00448"></a>00448                           eta_mapped = eta;
<a name="l00449"></a>00449                         }
<a name="l00450"></a>00450                       <span class="keywordflow">else</span>
<a name="l00451"></a>00451                         {
<a name="l00452"></a>00452                           <span class="comment">// Case 2</span>
<a name="l00453"></a>00453                           xi_mapped  = eta;
<a name="l00454"></a>00454                           eta_mapped = xi;
<a name="l00455"></a>00455                         }
<a name="l00456"></a>00456                     
<a name="l00457"></a>00457                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == min_point)
<a name="l00458"></a>00458                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00459"></a>00459                         {
<a name="l00460"></a>00460                           <span class="comment">// Case 3</span>
<a name="l00461"></a>00461                           xi_mapped  = -eta;
<a name="l00462"></a>00462                           eta_mapped = xi;
<a name="l00463"></a>00463                         }
<a name="l00464"></a>00464                       <span class="keywordflow">else</span>
<a name="l00465"></a>00465                         {
<a name="l00466"></a>00466                           <span class="comment">// Case 4</span>
<a name="l00467"></a>00467                           xi_mapped  = xi;
<a name="l00468"></a>00468                           eta_mapped = -eta;
<a name="l00469"></a>00469                         }
<a name="l00470"></a>00470                     
<a name="l00471"></a>00471                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == min_point)
<a name="l00472"></a>00472                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l00473"></a>00473                         {
<a name="l00474"></a>00474                           <span class="comment">// Case 5</span>
<a name="l00475"></a>00475                           xi_mapped  = -xi;
<a name="l00476"></a>00476                           eta_mapped = -eta;
<a name="l00477"></a>00477                         }
<a name="l00478"></a>00478                       <span class="keywordflow">else</span>
<a name="l00479"></a>00479                         {
<a name="l00480"></a>00480                           <span class="comment">// Case 6</span>
<a name="l00481"></a>00481                           xi_mapped  = -eta;
<a name="l00482"></a>00482                           eta_mapped = -xi;
<a name="l00483"></a>00483                         }
<a name="l00484"></a>00484                     
<a name="l00485"></a>00485                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == min_point)
<a name="l00486"></a>00486                       {
<a name="l00487"></a>00487                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)))
<a name="l00488"></a>00488                           {
<a name="l00489"></a>00489                             <span class="comment">// Case 7</span>
<a name="l00490"></a>00490                             xi_mapped  = eta;
<a name="l00491"></a>00491                             eta_mapped = -xi;
<a name="l00492"></a>00492                           }
<a name="l00493"></a>00493                         <span class="keywordflow">else</span>
<a name="l00494"></a>00494                           {
<a name="l00495"></a>00495                             <span class="comment">// Case 8</span>
<a name="l00496"></a>00496                             xi_mapped  = -xi;
<a name="l00497"></a>00497                             eta_mapped = eta;
<a name="l00498"></a>00498                           }
<a name="l00499"></a>00499                       }
<a name="l00500"></a>00500                   }
<a name="l00501"></a>00501                 
<a name="l00502"></a>00502                 
<a name="l00503"></a>00503                 <span class="comment">// Face 1</span>
<a name="l00504"></a>00504                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i1[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l00505"></a>00505                   {
<a name="l00506"></a>00506                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0),
<a name="l00507"></a>00507                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1),
<a name="l00508"></a>00508                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5),
<a name="l00509"></a>00509                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4))));
<a name="l00510"></a>00510                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == min_point)
<a name="l00511"></a>00511                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00512"></a>00512                         {
<a name="l00513"></a>00513                           <span class="comment">// Case 1</span>
<a name="l00514"></a>00514                           xi_mapped   = xi;
<a name="l00515"></a>00515                           zeta_mapped = zeta;
<a name="l00516"></a>00516                         }
<a name="l00517"></a>00517                       <span class="keywordflow">else</span>
<a name="l00518"></a>00518                         {
<a name="l00519"></a>00519                           <span class="comment">// Case 2</span>
<a name="l00520"></a>00520                           xi_mapped   = zeta;
<a name="l00521"></a>00521                           zeta_mapped = xi;
<a name="l00522"></a>00522                         }
<a name="l00523"></a>00523 
<a name="l00524"></a>00524                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == min_point)
<a name="l00525"></a>00525                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)))
<a name="l00526"></a>00526                         {
<a name="l00527"></a>00527                           <span class="comment">// Case 3</span>
<a name="l00528"></a>00528                           xi_mapped   = zeta;
<a name="l00529"></a>00529                           zeta_mapped = -xi;
<a name="l00530"></a>00530                         }
<a name="l00531"></a>00531                       <span class="keywordflow">else</span>
<a name="l00532"></a>00532                         {
<a name="l00533"></a>00533                           <span class="comment">// Case 4</span>
<a name="l00534"></a>00534                           xi_mapped   = -xi;
<a name="l00535"></a>00535                           zeta_mapped = zeta;
<a name="l00536"></a>00536                         }
<a name="l00537"></a>00537                     
<a name="l00538"></a>00538                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == min_point)
<a name="l00539"></a>00539                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l00540"></a>00540                         {
<a name="l00541"></a>00541                           <span class="comment">// Case 5</span>
<a name="l00542"></a>00542                           xi_mapped   = -xi;
<a name="l00543"></a>00543                           zeta_mapped = -zeta;
<a name="l00544"></a>00544                         }
<a name="l00545"></a>00545                       <span class="keywordflow">else</span>
<a name="l00546"></a>00546                         {
<a name="l00547"></a>00547                           <span class="comment">// Case 6</span>
<a name="l00548"></a>00548                           xi_mapped   = -zeta;
<a name="l00549"></a>00549                           zeta_mapped = -xi;
<a name="l00550"></a>00550                         }
<a name="l00551"></a>00551                     
<a name="l00552"></a>00552                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == min_point)
<a name="l00553"></a>00553                       {
<a name="l00554"></a>00554                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00555"></a>00555                           {
<a name="l00556"></a>00556                             <span class="comment">// Case 7</span>
<a name="l00557"></a>00557                             xi_mapped   = -xi;
<a name="l00558"></a>00558                             zeta_mapped = zeta;
<a name="l00559"></a>00559                           }
<a name="l00560"></a>00560                         <span class="keywordflow">else</span>
<a name="l00561"></a>00561                           {
<a name="l00562"></a>00562                             <span class="comment">// Case 8</span>
<a name="l00563"></a>00563                             xi_mapped   = xi;
<a name="l00564"></a>00564                             zeta_mapped = -zeta;
<a name="l00565"></a>00565                           }
<a name="l00566"></a>00566                       }
<a name="l00567"></a>00567                   }
<a name="l00568"></a>00568                 
<a name="l00569"></a>00569                 
<a name="l00570"></a>00570                 <span class="comment">// Face 2</span>
<a name="l00571"></a>00571                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l00572"></a>00572                   {
<a name="l00573"></a>00573                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1),
<a name="l00574"></a>00574                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2),
<a name="l00575"></a>00575                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6),
<a name="l00576"></a>00576                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5))));
<a name="l00577"></a>00577                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == min_point)
<a name="l00578"></a>00578                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00579"></a>00579                         {
<a name="l00580"></a>00580                           <span class="comment">// Case 1</span>
<a name="l00581"></a>00581                           eta_mapped  = eta;
<a name="l00582"></a>00582                           zeta_mapped = zeta;
<a name="l00583"></a>00583                         }
<a name="l00584"></a>00584                       <span class="keywordflow">else</span>
<a name="l00585"></a>00585                         {
<a name="l00586"></a>00586                           <span class="comment">// Case 2</span>
<a name="l00587"></a>00587                           eta_mapped  = zeta;
<a name="l00588"></a>00588                           zeta_mapped = eta;
<a name="l00589"></a>00589                         }
<a name="l00590"></a>00590                     
<a name="l00591"></a>00591                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == min_point)
<a name="l00592"></a>00592                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l00593"></a>00593                         {
<a name="l00594"></a>00594                           <span class="comment">// Case 3</span>
<a name="l00595"></a>00595                           eta_mapped  = zeta;
<a name="l00596"></a>00596                           zeta_mapped = -eta;
<a name="l00597"></a>00597                         }
<a name="l00598"></a>00598                       <span class="keywordflow">else</span>
<a name="l00599"></a>00599                         {
<a name="l00600"></a>00600                           <span class="comment">// Case 4</span>
<a name="l00601"></a>00601                           eta_mapped  = -eta;
<a name="l00602"></a>00602                           zeta_mapped = zeta;
<a name="l00603"></a>00603                         }
<a name="l00604"></a>00604                     
<a name="l00605"></a>00605                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == min_point)
<a name="l00606"></a>00606                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00607"></a>00607                         {
<a name="l00608"></a>00608                           <span class="comment">// Case 5</span>
<a name="l00609"></a>00609                           eta_mapped  = -eta;
<a name="l00610"></a>00610                           zeta_mapped = -zeta;
<a name="l00611"></a>00611                         }
<a name="l00612"></a>00612                       <span class="keywordflow">else</span>
<a name="l00613"></a>00613                         {
<a name="l00614"></a>00614                           <span class="comment">// Case 6</span>
<a name="l00615"></a>00615                           eta_mapped  = -zeta;
<a name="l00616"></a>00616                           zeta_mapped = -eta;
<a name="l00617"></a>00617                         }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == min_point)
<a name="l00620"></a>00620                       {
<a name="l00621"></a>00621                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00622"></a>00622                           {
<a name="l00623"></a>00623                             <span class="comment">// Case 7</span>
<a name="l00624"></a>00624                             eta_mapped  = -zeta;
<a name="l00625"></a>00625                             zeta_mapped = eta;
<a name="l00626"></a>00626                           }
<a name="l00627"></a>00627                         <span class="keywordflow">else</span>
<a name="l00628"></a>00628                           {
<a name="l00629"></a>00629                             <span class="comment">// Case 8</span>
<a name="l00630"></a>00630                             eta_mapped   = eta;
<a name="l00631"></a>00631                             zeta_mapped = -zeta;
<a name="l00632"></a>00632                           }
<a name="l00633"></a>00633                       }
<a name="l00634"></a>00634                   }
<a name="l00635"></a>00635 
<a name="l00636"></a>00636                 
<a name="l00637"></a>00637                 <span class="comment">// Face 3</span>
<a name="l00638"></a>00638                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i1[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l00639"></a>00639                   {
<a name="l00640"></a>00640                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2),
<a name="l00641"></a>00641                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3),
<a name="l00642"></a>00642                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7),
<a name="l00643"></a>00643                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6))));
<a name="l00644"></a>00644                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == min_point)
<a name="l00645"></a>00645                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00646"></a>00646                         {
<a name="l00647"></a>00647                           <span class="comment">// Case 1</span>
<a name="l00648"></a>00648                           xi_mapped   = xi;
<a name="l00649"></a>00649                           zeta_mapped = zeta;
<a name="l00650"></a>00650                         }
<a name="l00651"></a>00651                       <span class="keywordflow">else</span>
<a name="l00652"></a>00652                         {
<a name="l00653"></a>00653                           <span class="comment">// Case 2</span>
<a name="l00654"></a>00654                           xi_mapped   = zeta;
<a name="l00655"></a>00655                           zeta_mapped = xi;
<a name="l00656"></a>00656                         }
<a name="l00657"></a>00657                     
<a name="l00658"></a>00658                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == min_point)
<a name="l00659"></a>00659                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00660"></a>00660                         {
<a name="l00661"></a>00661                           <span class="comment">// Case 3</span>
<a name="l00662"></a>00662                           xi_mapped   = -zeta;
<a name="l00663"></a>00663                           zeta_mapped = xi;
<a name="l00664"></a>00664                         }
<a name="l00665"></a>00665                       <span class="keywordflow">else</span>
<a name="l00666"></a>00666                         {
<a name="l00667"></a>00667                           <span class="comment">// Case 4</span>
<a name="l00668"></a>00668                           xi_mapped   = xi;
<a name="l00669"></a>00669                           zeta_mapped = -zeta;
<a name="l00670"></a>00670                         }
<a name="l00671"></a>00671                     
<a name="l00672"></a>00672                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == min_point)
<a name="l00673"></a>00673                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00674"></a>00674                         {
<a name="l00675"></a>00675                           <span class="comment">// Case 5</span>
<a name="l00676"></a>00676                           xi_mapped   = -xi;
<a name="l00677"></a>00677                           zeta_mapped = -zeta;
<a name="l00678"></a>00678                         }
<a name="l00679"></a>00679                       <span class="keywordflow">else</span>
<a name="l00680"></a>00680                         {
<a name="l00681"></a>00681                           <span class="comment">// Case 6</span>
<a name="l00682"></a>00682                           xi_mapped   = -zeta;
<a name="l00683"></a>00683                           zeta_mapped = -xi;
<a name="l00684"></a>00684                         }
<a name="l00685"></a>00685 
<a name="l00686"></a>00686                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == min_point)
<a name="l00687"></a>00687                       {
<a name="l00688"></a>00688                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00689"></a>00689                           {
<a name="l00690"></a>00690                             <span class="comment">// Case 7</span>
<a name="l00691"></a>00691                             xi_mapped   = zeta;
<a name="l00692"></a>00692                             zeta_mapped = -xi;
<a name="l00693"></a>00693                           }
<a name="l00694"></a>00694                         <span class="keywordflow">else</span>
<a name="l00695"></a>00695                           {
<a name="l00696"></a>00696                             <span class="comment">// Case 8</span>
<a name="l00697"></a>00697                             xi_mapped   = -xi;
<a name="l00698"></a>00698                             zeta_mapped = zeta;
<a name="l00699"></a>00699                           }
<a name="l00700"></a>00700                       }
<a name="l00701"></a>00701                   }
<a name="l00702"></a>00702                 
<a name="l00703"></a>00703                 
<a name="l00704"></a>00704                 <span class="comment">// Face 4</span>
<a name="l00705"></a>00705                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l00706"></a>00706                   {
<a name="l00707"></a>00707                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3),
<a name="l00708"></a>00708                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0),
<a name="l00709"></a>00709                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4),
<a name="l00710"></a>00710                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7))));
<a name="l00711"></a>00711                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == min_point)
<a name="l00712"></a>00712                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00713"></a>00713                         {
<a name="l00714"></a>00714                           <span class="comment">// Case 1</span>
<a name="l00715"></a>00715                           eta_mapped  = eta;
<a name="l00716"></a>00716                           zeta_mapped = zeta;
<a name="l00717"></a>00717                         }
<a name="l00718"></a>00718                       <span class="keywordflow">else</span>
<a name="l00719"></a>00719                         {
<a name="l00720"></a>00720                           <span class="comment">// Case 2</span>
<a name="l00721"></a>00721                           eta_mapped  = zeta;
<a name="l00722"></a>00722                           zeta_mapped = eta;
<a name="l00723"></a>00723                         }
<a name="l00724"></a>00724 
<a name="l00725"></a>00725                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == min_point)
<a name="l00726"></a>00726                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00727"></a>00727                         {
<a name="l00728"></a>00728                           <span class="comment">// Case 3</span>
<a name="l00729"></a>00729                           eta_mapped  = -zeta;
<a name="l00730"></a>00730                           zeta_mapped = eta;
<a name="l00731"></a>00731                         }
<a name="l00732"></a>00732                       <span class="keywordflow">else</span>
<a name="l00733"></a>00733                         {
<a name="l00734"></a>00734                           <span class="comment">// Case 4</span>
<a name="l00735"></a>00735                           eta_mapped  = eta;
<a name="l00736"></a>00736                           zeta_mapped = -zeta;
<a name="l00737"></a>00737                         }
<a name="l00738"></a>00738                     
<a name="l00739"></a>00739                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == min_point)
<a name="l00740"></a>00740                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00741"></a>00741                         {
<a name="l00742"></a>00742                           <span class="comment">// Case 5</span>
<a name="l00743"></a>00743                           eta_mapped  = -eta;
<a name="l00744"></a>00744                           zeta_mapped = -zeta;
<a name="l00745"></a>00745                         }
<a name="l00746"></a>00746                       <span class="keywordflow">else</span>
<a name="l00747"></a>00747                         {
<a name="l00748"></a>00748                           <span class="comment">// Case 6</span>
<a name="l00749"></a>00749                           eta_mapped  = -zeta;
<a name="l00750"></a>00750                           zeta_mapped = -eta;
<a name="l00751"></a>00751                         }
<a name="l00752"></a>00752 
<a name="l00753"></a>00753                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == min_point)
<a name="l00754"></a>00754                       {
<a name="l00755"></a>00755                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)))
<a name="l00756"></a>00756                           {
<a name="l00757"></a>00757                             <span class="comment">// Case 7</span>
<a name="l00758"></a>00758                             eta_mapped   = zeta;
<a name="l00759"></a>00759                             zeta_mapped = -eta;
<a name="l00760"></a>00760                           }
<a name="l00761"></a>00761                         <span class="keywordflow">else</span>
<a name="l00762"></a>00762                           {
<a name="l00763"></a>00763                             <span class="comment">// Case 8</span>
<a name="l00764"></a>00764                             eta_mapped  = -eta;
<a name="l00765"></a>00765                             zeta_mapped = zeta;
<a name="l00766"></a>00766                           }
<a name="l00767"></a>00767                       }
<a name="l00768"></a>00768                   }
<a name="l00769"></a>00769                 
<a name="l00770"></a>00770                 
<a name="l00771"></a>00771                 <span class="comment">// Face 5</span>
<a name="l00772"></a>00772                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i2[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))
<a name="l00773"></a>00773                   {
<a name="l00774"></a>00774                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4),
<a name="l00775"></a>00775                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5),
<a name="l00776"></a>00776                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6),
<a name="l00777"></a>00777                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7))));
<a name="l00778"></a>00778                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == min_point)
<a name="l00779"></a>00779                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00780"></a>00780                         {
<a name="l00781"></a>00781                           <span class="comment">// Case 1</span>
<a name="l00782"></a>00782                           xi_mapped  = xi;
<a name="l00783"></a>00783                           eta_mapped = eta;
<a name="l00784"></a>00784                         }
<a name="l00785"></a>00785                       <span class="keywordflow">else</span>
<a name="l00786"></a>00786                         {
<a name="l00787"></a>00787                           <span class="comment">// Case 2</span>
<a name="l00788"></a>00788                           xi_mapped  = eta;
<a name="l00789"></a>00789                           eta_mapped = xi;
<a name="l00790"></a>00790                         }
<a name="l00791"></a>00791                     
<a name="l00792"></a>00792                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == min_point)
<a name="l00793"></a>00793                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00794"></a>00794                         {
<a name="l00795"></a>00795                           <span class="comment">// Case 3</span>
<a name="l00796"></a>00796                           xi_mapped  = eta;
<a name="l00797"></a>00797                           eta_mapped = -xi;
<a name="l00798"></a>00798                         }
<a name="l00799"></a>00799                       <span class="keywordflow">else</span>
<a name="l00800"></a>00800                         {
<a name="l00801"></a>00801                           <span class="comment">// Case 4</span>
<a name="l00802"></a>00802                           xi_mapped  = -xi;
<a name="l00803"></a>00803                           eta_mapped = eta;
<a name="l00804"></a>00804                         }
<a name="l00805"></a>00805                     
<a name="l00806"></a>00806                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == min_point)
<a name="l00807"></a>00807                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00808"></a>00808                         {
<a name="l00809"></a>00809                           <span class="comment">// Case 5</span>
<a name="l00810"></a>00810                           xi_mapped  = -xi;
<a name="l00811"></a>00811                           eta_mapped = -eta;
<a name="l00812"></a>00812                         }
<a name="l00813"></a>00813                       <span class="keywordflow">else</span>
<a name="l00814"></a>00814                         {
<a name="l00815"></a>00815                           <span class="comment">// Case 6</span>
<a name="l00816"></a>00816                           xi_mapped  = -eta;
<a name="l00817"></a>00817                           eta_mapped = -xi;
<a name="l00818"></a>00818                         }
<a name="l00819"></a>00819                     
<a name="l00820"></a>00820                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == min_point)
<a name="l00821"></a>00821                       {
<a name="l00822"></a>00822                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00823"></a>00823                           {
<a name="l00824"></a>00824                             <span class="comment">// Case 7</span>
<a name="l00825"></a>00825                             xi_mapped  = -eta;
<a name="l00826"></a>00826                             eta_mapped = xi;
<a name="l00827"></a>00827                           }
<a name="l00828"></a>00828                         <span class="keywordflow">else</span>
<a name="l00829"></a>00829                           {
<a name="l00830"></a>00830                             <span class="comment">// Case 8</span>
<a name="l00831"></a>00831                             xi_mapped  = xi;
<a name="l00832"></a>00832                             eta_mapped = eta;
<a name="l00833"></a>00833                           }
<a name="l00834"></a>00834                       }
<a name="l00835"></a>00835                   }
<a name="l00836"></a>00836               }
<a name="l00837"></a>00837               
<a name="l00838"></a>00838               <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], xi_mapped)*
<a name="l00839"></a>00839                       <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], eta_mapped)*
<a name="l00840"></a>00840                       <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], zeta_mapped));
<a name="l00841"></a>00841             }
<a name="l00842"></a>00842             
<a name="l00843"></a>00843             
<a name="l00844"></a>00844           <span class="keywordflow">default</span>:
<a name="l00845"></a>00845             libmesh_error();
<a name="l00846"></a>00846             
<a name="l00847"></a>00847           } <span class="comment">//case HEX27</span>
<a name="l00848"></a>00848  
<a name="l00849"></a>00849       } <span class="comment">//case THIRD</span>
<a name="l00850"></a>00850       
<a name="l00851"></a>00851       
<a name="l00852"></a>00852       <span class="comment">// 4th-order Bernstein.</span>
<a name="l00853"></a>00853     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00854"></a>00854       {
<a name="l00855"></a>00855         <span class="keywordflow">switch</span> (type)
<a name="l00856"></a>00856           {  
<a name="l00857"></a>00857             
<a name="l00858"></a>00858             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l00859"></a>00859           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00860"></a>00860             {
<a name="l00861"></a>00861               libmesh_assert (i&lt;125);
<a name="l00862"></a>00862               
<a name="l00863"></a>00863               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00864"></a>00864               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi    = p(0);
<a name="l00865"></a>00865               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta   = p(1);
<a name="l00866"></a>00866               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta  = p(2);
<a name="l00867"></a>00867               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi_mapped   = p(0);
<a name="l00868"></a>00868               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta_mapped  = p(1);
<a name="l00869"></a>00869               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta_mapped = p(2);
<a name="l00870"></a>00870               
<a name="l00871"></a>00871               <span class="comment">// The only way to make any sense of this</span>
<a name="l00872"></a>00872               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00873"></a>00873               <span class="comment">// and make the cut-out cube!</span>
<a name="l00874"></a>00874               <span class="comment">//  Nodes                         0  1  2  3  4  5  6  7  8  8  9  9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 20 20 21 21 21 21 22 22 22 22 23 23 23 23 24 24 24 24 25 25 25 25 26 26 26 26 26 26 26 26 </span>
<a name="l00875"></a>00875               <span class="comment">//  DOFS                          0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 18 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 60 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99  0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24</span>
<a name="l00876"></a>00876               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 2, 3, 4, 2, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4};
<a name="l00877"></a>00877               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4};
<a name="l00878"></a>00878               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4};
<a name="l00879"></a>00879               
<a name="l00880"></a>00880               
<a name="l00881"></a>00881               
<a name="l00882"></a>00882               <span class="comment">// handle the edge orientation</span>
<a name="l00883"></a>00883               {
<a name="l00884"></a>00884                 <span class="comment">// Edge 0</span>
<a name="l00885"></a>00885                 <span class="keywordflow">if</span> ( (i0[i] &gt;= 2) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] == 0))
<a name="l00886"></a>00886                   {
<a name="l00887"></a>00887                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l00888"></a>00888                       xi_mapped = -xi;
<a name="l00889"></a>00889                   }
<a name="l00890"></a>00890                 <span class="comment">// Edge 1</span>
<a name="l00891"></a>00891                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] == 0))
<a name="l00892"></a>00892                   {
<a name="l00893"></a>00893                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00894"></a>00894                       eta_mapped = -eta;
<a name="l00895"></a>00895                   }
<a name="l00896"></a>00896                 <span class="comment">// Edge 2</span>
<a name="l00897"></a>00897                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] &gt;= 2) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] == 0))
<a name="l00898"></a>00898                   {
<a name="l00899"></a>00899                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00900"></a>00900                       xi_mapped = -xi;
<a name="l00901"></a>00901                   }
<a name="l00902"></a>00902                 <span class="comment">// Edge 3</span>
<a name="l00903"></a>00903                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] == 0))
<a name="l00904"></a>00904                   {
<a name="l00905"></a>00905                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00906"></a>00906                       eta_mapped = -eta;
<a name="l00907"></a>00907                   }
<a name="l00908"></a>00908                 <span class="comment">// Edge 4</span>
<a name="l00909"></a>00909                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00910"></a>00910                   {
<a name="l00911"></a>00911                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00912"></a>00912                       zeta_mapped = -zeta;
<a name="l00913"></a>00913                   }             
<a name="l00914"></a>00914                 <span class="comment">// Edge 5</span>
<a name="l00915"></a>00915                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00916"></a>00916                   {
<a name="l00917"></a>00917                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00918"></a>00918                       zeta_mapped = -zeta;
<a name="l00919"></a>00919                   }             
<a name="l00920"></a>00920                 <span class="comment">// Edge 6</span>
<a name="l00921"></a>00921                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00922"></a>00922                   {
<a name="l00923"></a>00923                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00924"></a>00924                       zeta_mapped = -zeta;
<a name="l00925"></a>00925                   }
<a name="l00926"></a>00926                 <span class="comment">// Edge 7</span>
<a name="l00927"></a>00927                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] &gt;=2 ))
<a name="l00928"></a>00928                   {
<a name="l00929"></a>00929                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00930"></a>00930                       zeta_mapped = -zeta;
<a name="l00931"></a>00931                   }             
<a name="l00932"></a>00932                 <span class="comment">// Edge 8</span>
<a name="l00933"></a>00933                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] &gt;=2 ) &amp;&amp; (i1[i] == 0) &amp;&amp; (i2[i] == 1))
<a name="l00934"></a>00934                   {
<a name="l00935"></a>00935                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l00936"></a>00936                       xi_mapped = -xi;
<a name="l00937"></a>00937                   }
<a name="l00938"></a>00938                 <span class="comment">// Edge 9</span>
<a name="l00939"></a>00939                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] &gt;=2 ) &amp;&amp; (i2[i] == 1))
<a name="l00940"></a>00940                   {
<a name="l00941"></a>00941                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00942"></a>00942                       eta_mapped = -eta;
<a name="l00943"></a>00943                   }             
<a name="l00944"></a>00944                 <span class="comment">// Edge 10</span>
<a name="l00945"></a>00945                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] &gt;=2 ) &amp;&amp; (i1[i] == 1) &amp;&amp; (i2[i] == 1))
<a name="l00946"></a>00946                   {
<a name="l00947"></a>00947                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l00948"></a>00948                       xi_mapped = -xi;
<a name="l00949"></a>00949                   }
<a name="l00950"></a>00950                 <span class="comment">// Edge 11</span>
<a name="l00951"></a>00951                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] &gt;=2 ) &amp;&amp; (i2[i] == 1))
<a name="l00952"></a>00952                   {
<a name="l00953"></a>00953                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) != <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l00954"></a>00954                       eta_mapped = -eta;
<a name="l00955"></a>00955                   }
<a name="l00956"></a>00956               }
<a name="l00957"></a>00957               
<a name="l00958"></a>00958               
<a name="l00959"></a>00959               <span class="comment">// handle the face orientation</span>
<a name="l00960"></a>00960               {
<a name="l00961"></a>00961                 <span class="comment">// Face 0</span>
<a name="l00962"></a>00962                 <span class="keywordflow">if</span> (     (i2[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))
<a name="l00963"></a>00963                   {
<a name="l00964"></a>00964                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1),
<a name="l00965"></a>00965                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2),
<a name="l00966"></a>00966                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0),
<a name="l00967"></a>00967                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3))));
<a name="l00968"></a>00968                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == min_point)
<a name="l00969"></a>00969                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00970"></a>00970                         {
<a name="l00971"></a>00971                           <span class="comment">// Case 1</span>
<a name="l00972"></a>00972                           xi_mapped  = xi;
<a name="l00973"></a>00973                           eta_mapped = eta;
<a name="l00974"></a>00974                         }
<a name="l00975"></a>00975                       <span class="keywordflow">else</span>
<a name="l00976"></a>00976                         {
<a name="l00977"></a>00977                           <span class="comment">// Case 2</span>
<a name="l00978"></a>00978                           xi_mapped  = eta;
<a name="l00979"></a>00979                           eta_mapped = xi;
<a name="l00980"></a>00980                         }
<a name="l00981"></a>00981 
<a name="l00982"></a>00982                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == min_point)
<a name="l00983"></a>00983                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00984"></a>00984                         {
<a name="l00985"></a>00985                           <span class="comment">// Case 3</span>
<a name="l00986"></a>00986                           xi_mapped  = -eta;
<a name="l00987"></a>00987                           eta_mapped = xi;
<a name="l00988"></a>00988                         }
<a name="l00989"></a>00989                       <span class="keywordflow">else</span>
<a name="l00990"></a>00990                         {
<a name="l00991"></a>00991                           <span class="comment">// Case 4</span>
<a name="l00992"></a>00992                           xi_mapped  = xi;
<a name="l00993"></a>00993                           eta_mapped = -eta;
<a name="l00994"></a>00994                         }
<a name="l00995"></a>00995 
<a name="l00996"></a>00996                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == min_point)
<a name="l00997"></a>00997                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l00998"></a>00998                         {
<a name="l00999"></a>00999                           <span class="comment">// Case 5</span>
<a name="l01000"></a>01000                           xi_mapped  = -xi;
<a name="l01001"></a>01001                           eta_mapped = -eta;
<a name="l01002"></a>01002                         }
<a name="l01003"></a>01003                       <span class="keywordflow">else</span>
<a name="l01004"></a>01004                         {
<a name="l01005"></a>01005                           <span class="comment">// Case 6</span>
<a name="l01006"></a>01006                           xi_mapped  = -eta;
<a name="l01007"></a>01007                           eta_mapped = -xi;
<a name="l01008"></a>01008                         }
<a name="l01009"></a>01009 
<a name="l01010"></a>01010                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == min_point)
<a name="l01011"></a>01011                       {
<a name="l01012"></a>01012                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)))
<a name="l01013"></a>01013                           {
<a name="l01014"></a>01014                             <span class="comment">// Case 7</span>
<a name="l01015"></a>01015                             xi_mapped  = eta;
<a name="l01016"></a>01016                             eta_mapped = -xi;
<a name="l01017"></a>01017                           }
<a name="l01018"></a>01018                         <span class="keywordflow">else</span>
<a name="l01019"></a>01019                           {
<a name="l01020"></a>01020                             <span class="comment">// Case 8</span>
<a name="l01021"></a>01021                             xi_mapped  = -xi;
<a name="l01022"></a>01022                             eta_mapped = eta;
<a name="l01023"></a>01023                           }
<a name="l01024"></a>01024                       }
<a name="l01025"></a>01025                   }
<a name="l01026"></a>01026 
<a name="l01027"></a>01027                 
<a name="l01028"></a>01028                 <span class="comment">// Face 1</span>
<a name="l01029"></a>01029                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i1[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l01030"></a>01030                   {
<a name="l01031"></a>01031                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0),
<a name="l01032"></a>01032                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1),
<a name="l01033"></a>01033                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5),
<a name="l01034"></a>01034                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4))));
<a name="l01035"></a>01035                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == min_point)
<a name="l01036"></a>01036                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l01037"></a>01037                         {
<a name="l01038"></a>01038                           <span class="comment">// Case 1</span>
<a name="l01039"></a>01039                           xi_mapped   = xi;
<a name="l01040"></a>01040                           zeta_mapped = zeta;
<a name="l01041"></a>01041                         }
<a name="l01042"></a>01042                       <span class="keywordflow">else</span>
<a name="l01043"></a>01043                         {
<a name="l01044"></a>01044                           <span class="comment">// Case 2</span>
<a name="l01045"></a>01045                           xi_mapped   = zeta;
<a name="l01046"></a>01046                           zeta_mapped = xi;
<a name="l01047"></a>01047                         }
<a name="l01048"></a>01048 
<a name="l01049"></a>01049                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == min_point)
<a name="l01050"></a>01050                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)))
<a name="l01051"></a>01051                         {
<a name="l01052"></a>01052                           <span class="comment">// Case 3</span>
<a name="l01053"></a>01053                           xi_mapped   = zeta;
<a name="l01054"></a>01054                           zeta_mapped = -xi;
<a name="l01055"></a>01055                         }
<a name="l01056"></a>01056                       <span class="keywordflow">else</span>
<a name="l01057"></a>01057                         {
<a name="l01058"></a>01058                           <span class="comment">// Case 4</span>
<a name="l01059"></a>01059                           xi_mapped   = -xi;
<a name="l01060"></a>01060                           zeta_mapped = zeta;
<a name="l01061"></a>01061                         }
<a name="l01062"></a>01062 
<a name="l01063"></a>01063                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == min_point)
<a name="l01064"></a>01064                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l01065"></a>01065                         {
<a name="l01066"></a>01066                           <span class="comment">// Case 5</span>
<a name="l01067"></a>01067                           xi_mapped   = -xi;
<a name="l01068"></a>01068                           zeta_mapped = -zeta;
<a name="l01069"></a>01069                         }
<a name="l01070"></a>01070                       <span class="keywordflow">else</span>
<a name="l01071"></a>01071                         {
<a name="l01072"></a>01072                           <span class="comment">// Case 6</span>
<a name="l01073"></a>01073                           xi_mapped   = -zeta;
<a name="l01074"></a>01074                           zeta_mapped = -xi;
<a name="l01075"></a>01075                         }
<a name="l01076"></a>01076 
<a name="l01077"></a>01077                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == min_point)
<a name="l01078"></a>01078                       {
<a name="l01079"></a>01079                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l01080"></a>01080                           {
<a name="l01081"></a>01081                             <span class="comment">// Case 7</span>
<a name="l01082"></a>01082                             xi_mapped   = -xi;
<a name="l01083"></a>01083                             zeta_mapped = zeta;
<a name="l01084"></a>01084                           }
<a name="l01085"></a>01085                         <span class="keywordflow">else</span>
<a name="l01086"></a>01086                           {
<a name="l01087"></a>01087                             <span class="comment">// Case 8</span>
<a name="l01088"></a>01088                             xi_mapped   = xi;
<a name="l01089"></a>01089                             zeta_mapped = -zeta;
<a name="l01090"></a>01090                           }
<a name="l01091"></a>01091                       }
<a name="l01092"></a>01092                   }
<a name="l01093"></a>01093 
<a name="l01094"></a>01094                 
<a name="l01095"></a>01095                 <span class="comment">// Face 2</span>
<a name="l01096"></a>01096                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 1) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l01097"></a>01097                   {
<a name="l01098"></a>01098                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1),
<a name="l01099"></a>01099                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2),
<a name="l01100"></a>01100                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6),
<a name="l01101"></a>01101                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5))));
<a name="l01102"></a>01102                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == min_point)
<a name="l01103"></a>01103                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l01104"></a>01104                         {
<a name="l01105"></a>01105                           <span class="comment">// Case 1</span>
<a name="l01106"></a>01106                           eta_mapped  = eta;
<a name="l01107"></a>01107                           zeta_mapped = zeta;
<a name="l01108"></a>01108                         }
<a name="l01109"></a>01109                       <span class="keywordflow">else</span>
<a name="l01110"></a>01110                         {
<a name="l01111"></a>01111                           <span class="comment">// Case 2</span>
<a name="l01112"></a>01112                           eta_mapped  = zeta;
<a name="l01113"></a>01113                           zeta_mapped = eta;
<a name="l01114"></a>01114                         }
<a name="l01115"></a>01115 
<a name="l01116"></a>01116                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == min_point)
<a name="l01117"></a>01117                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)))
<a name="l01118"></a>01118                         {
<a name="l01119"></a>01119                           <span class="comment">// Case 3</span>
<a name="l01120"></a>01120                           eta_mapped  = zeta;
<a name="l01121"></a>01121                           zeta_mapped = -eta;
<a name="l01122"></a>01122                         }
<a name="l01123"></a>01123                       <span class="keywordflow">else</span>
<a name="l01124"></a>01124                         {
<a name="l01125"></a>01125                           <span class="comment">// Case 4</span>
<a name="l01126"></a>01126                           eta_mapped  = -eta;
<a name="l01127"></a>01127                           zeta_mapped = zeta;
<a name="l01128"></a>01128                         }
<a name="l01129"></a>01129 
<a name="l01130"></a>01130                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == min_point)
<a name="l01131"></a>01131                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l01132"></a>01132                         {
<a name="l01133"></a>01133                           <span class="comment">// Case 5</span>
<a name="l01134"></a>01134                           eta_mapped  = -eta;
<a name="l01135"></a>01135                           zeta_mapped = -zeta;
<a name="l01136"></a>01136                         }
<a name="l01137"></a>01137                       <span class="keywordflow">else</span>
<a name="l01138"></a>01138                         {
<a name="l01139"></a>01139                           <span class="comment">// Case 6</span>
<a name="l01140"></a>01140                           eta_mapped  = -zeta;
<a name="l01141"></a>01141                           zeta_mapped = -eta;
<a name="l01142"></a>01142                         }
<a name="l01143"></a>01143 
<a name="l01144"></a>01144                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == min_point)
<a name="l01145"></a>01145                       {
<a name="l01146"></a>01146                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l01147"></a>01147                           {
<a name="l01148"></a>01148                             <span class="comment">// Case 7</span>
<a name="l01149"></a>01149                             eta_mapped  = -zeta;
<a name="l01150"></a>01150                             zeta_mapped = eta;
<a name="l01151"></a>01151                           }
<a name="l01152"></a>01152                         <span class="keywordflow">else</span>
<a name="l01153"></a>01153                           {
<a name="l01154"></a>01154                             <span class="comment">// Case 8</span>
<a name="l01155"></a>01155                             eta_mapped   = eta;
<a name="l01156"></a>01156                             zeta_mapped = -zeta;
<a name="l01157"></a>01157                           }
<a name="l01158"></a>01158                       }
<a name="l01159"></a>01159                   }
<a name="l01160"></a>01160 
<a name="l01161"></a>01161                 
<a name="l01162"></a>01162                 <span class="comment">// Face 3</span>
<a name="l01163"></a>01163                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i1[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l01164"></a>01164                   {
<a name="l01165"></a>01165                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2),
<a name="l01166"></a>01166                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3),
<a name="l01167"></a>01167                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7),
<a name="l01168"></a>01168                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6))));
<a name="l01169"></a>01169                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == min_point)
<a name="l01170"></a>01170                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l01171"></a>01171                         {
<a name="l01172"></a>01172                           <span class="comment">// Case 1</span>
<a name="l01173"></a>01173                           xi_mapped   = xi;
<a name="l01174"></a>01174                           zeta_mapped = zeta;
<a name="l01175"></a>01175                         }
<a name="l01176"></a>01176                       <span class="keywordflow">else</span>
<a name="l01177"></a>01177                         {
<a name="l01178"></a>01178                           <span class="comment">// Case 2</span>
<a name="l01179"></a>01179                           xi_mapped   = zeta;
<a name="l01180"></a>01180                           zeta_mapped = xi;
<a name="l01181"></a>01181                         }
<a name="l01182"></a>01182 
<a name="l01183"></a>01183                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == min_point)
<a name="l01184"></a>01184                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l01185"></a>01185                         {
<a name="l01186"></a>01186                           <span class="comment">// Case 3</span>
<a name="l01187"></a>01187                           xi_mapped   = -zeta;
<a name="l01188"></a>01188                           zeta_mapped = xi;
<a name="l01189"></a>01189                         }
<a name="l01190"></a>01190                       <span class="keywordflow">else</span>
<a name="l01191"></a>01191                         {
<a name="l01192"></a>01192                           <span class="comment">// Case 4</span>
<a name="l01193"></a>01193                           xi_mapped   = xi;
<a name="l01194"></a>01194                           zeta_mapped = -zeta;
<a name="l01195"></a>01195                         }
<a name="l01196"></a>01196 
<a name="l01197"></a>01197                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == min_point)
<a name="l01198"></a>01198                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l01199"></a>01199                         {
<a name="l01200"></a>01200                           <span class="comment">// Case 5</span>
<a name="l01201"></a>01201                           xi_mapped   = -xi;
<a name="l01202"></a>01202                           zeta_mapped = -zeta;
<a name="l01203"></a>01203                         }
<a name="l01204"></a>01204                       <span class="keywordflow">else</span>
<a name="l01205"></a>01205                         {
<a name="l01206"></a>01206                           <span class="comment">// Case 6</span>
<a name="l01207"></a>01207                           xi_mapped   = -zeta;
<a name="l01208"></a>01208                           zeta_mapped = -xi;
<a name="l01209"></a>01209                         }
<a name="l01210"></a>01210 
<a name="l01211"></a>01211                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) == min_point)
<a name="l01212"></a>01212                       {
<a name="l01213"></a>01213                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l01214"></a>01214                           {
<a name="l01215"></a>01215                             <span class="comment">// Case 7</span>
<a name="l01216"></a>01216                             xi_mapped   = zeta;
<a name="l01217"></a>01217                             zeta_mapped = -xi;
<a name="l01218"></a>01218                           }
<a name="l01219"></a>01219                         <span class="keywordflow">else</span>
<a name="l01220"></a>01220                           {
<a name="l01221"></a>01221                             <span class="comment">// Case 8</span>
<a name="l01222"></a>01222                             xi_mapped   = -xi;
<a name="l01223"></a>01223                             zeta_mapped = zeta;
<a name="l01224"></a>01224                           }
<a name="l01225"></a>01225                       }
<a name="l01226"></a>01226                   }
<a name="l01227"></a>01227 
<a name="l01228"></a>01228                 
<a name="l01229"></a>01229                 <span class="comment">// Face 4</span>
<a name="l01230"></a>01230                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i0[i] == 0) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))
<a name="l01231"></a>01231                   {
<a name="l01232"></a>01232                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3),
<a name="l01233"></a>01233                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0),
<a name="l01234"></a>01234                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4),
<a name="l01235"></a>01235                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7))));
<a name="l01236"></a>01236                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == min_point)
<a name="l01237"></a>01237                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l01238"></a>01238                         {
<a name="l01239"></a>01239                           <span class="comment">// Case 1</span>
<a name="l01240"></a>01240                           eta_mapped  = eta;
<a name="l01241"></a>01241                           zeta_mapped = zeta;
<a name="l01242"></a>01242                         }
<a name="l01243"></a>01243                       <span class="keywordflow">else</span>
<a name="l01244"></a>01244                         {
<a name="l01245"></a>01245                           <span class="comment">// Case 2</span>
<a name="l01246"></a>01246                           eta_mapped  = zeta;
<a name="l01247"></a>01247                           zeta_mapped = eta;
<a name="l01248"></a>01248                         }
<a name="l01249"></a>01249 
<a name="l01250"></a>01250                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == min_point)
<a name="l01251"></a>01251                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l01252"></a>01252                         {
<a name="l01253"></a>01253                           <span class="comment">// Case 3</span>
<a name="l01254"></a>01254                           eta_mapped  = -zeta;
<a name="l01255"></a>01255                           zeta_mapped = eta;
<a name="l01256"></a>01256                         }
<a name="l01257"></a>01257                       <span class="keywordflow">else</span>
<a name="l01258"></a>01258                         {
<a name="l01259"></a>01259                           <span class="comment">// Case 4</span>
<a name="l01260"></a>01260                           eta_mapped  = eta;
<a name="l01261"></a>01261                           zeta_mapped = -zeta;
<a name="l01262"></a>01262                         }
<a name="l01263"></a>01263 
<a name="l01264"></a>01264                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == min_point)
<a name="l01265"></a>01265                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l01266"></a>01266                         {
<a name="l01267"></a>01267                           <span class="comment">// Case 5</span>
<a name="l01268"></a>01268                           eta_mapped  = -eta;
<a name="l01269"></a>01269                           zeta_mapped = -zeta;
<a name="l01270"></a>01270                         }
<a name="l01271"></a>01271                       <span class="keywordflow">else</span>
<a name="l01272"></a>01272                         {
<a name="l01273"></a>01273                           <span class="comment">// Case 6</span>
<a name="l01274"></a>01274                           eta_mapped  = -zeta;
<a name="l01275"></a>01275                           zeta_mapped = -eta;
<a name="l01276"></a>01276                         }
<a name="l01277"></a>01277 
<a name="l01278"></a>01278                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) == min_point)
<a name="l01279"></a>01279                       {
<a name="l01280"></a>01280                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)))
<a name="l01281"></a>01281                           {
<a name="l01282"></a>01282                             <span class="comment">// Case 7</span>
<a name="l01283"></a>01283                             eta_mapped   = zeta;
<a name="l01284"></a>01284                             zeta_mapped = -eta;
<a name="l01285"></a>01285                           }
<a name="l01286"></a>01286                         <span class="keywordflow">else</span>
<a name="l01287"></a>01287                           {
<a name="l01288"></a>01288                             <span class="comment">// Case 8</span>
<a name="l01289"></a>01289                             eta_mapped  = -eta;
<a name="l01290"></a>01290                             zeta_mapped = zeta;
<a name="l01291"></a>01291                           }
<a name="l01292"></a>01292                       }
<a name="l01293"></a>01293                   }
<a name="l01294"></a>01294 
<a name="l01295"></a>01295                 
<a name="l01296"></a>01296                 <span class="comment">// Face 5</span>
<a name="l01297"></a>01297                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((i2[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))
<a name="l01298"></a>01298                   {
<a name="l01299"></a>01299                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> min_point = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4),
<a name="l01300"></a>01300                                                            <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5),
<a name="l01301"></a>01301                                                                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6),
<a name="l01302"></a>01302                                                                              elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7))));
<a name="l01303"></a>01303                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == min_point)
<a name="l01304"></a>01304                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)))
<a name="l01305"></a>01305                         {
<a name="l01306"></a>01306                           <span class="comment">// Case 1</span>
<a name="l01307"></a>01307                           xi_mapped  = xi;
<a name="l01308"></a>01308                           eta_mapped = eta;
<a name="l01309"></a>01309                         }
<a name="l01310"></a>01310                       <span class="keywordflow">else</span>
<a name="l01311"></a>01311                         {
<a name="l01312"></a>01312                           <span class="comment">// Case 2</span>
<a name="l01313"></a>01313                           xi_mapped  = eta;
<a name="l01314"></a>01314                           eta_mapped = xi;
<a name="l01315"></a>01315                         }
<a name="l01316"></a>01316 
<a name="l01317"></a>01317                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5) == min_point)
<a name="l01318"></a>01318                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l01319"></a>01319                         {
<a name="l01320"></a>01320                           <span class="comment">// Case 3</span>
<a name="l01321"></a>01321                           xi_mapped  = eta;
<a name="l01322"></a>01322                           eta_mapped = -xi;
<a name="l01323"></a>01323                         }
<a name="l01324"></a>01324                       <span class="keywordflow">else</span>
<a name="l01325"></a>01325                         {
<a name="l01326"></a>01326                           <span class="comment">// Case 4</span>
<a name="l01327"></a>01327                           xi_mapped  = -xi;
<a name="l01328"></a>01328                           eta_mapped = eta;
<a name="l01329"></a>01329                         }
<a name="l01330"></a>01330 
<a name="l01331"></a>01331                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6) == min_point)
<a name="l01332"></a>01332                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5)))
<a name="l01333"></a>01333                         {
<a name="l01334"></a>01334                           <span class="comment">// Case 5</span>
<a name="l01335"></a>01335                           xi_mapped  = -xi;
<a name="l01336"></a>01336                           eta_mapped = -eta;
<a name="l01337"></a>01337                         }
<a name="l01338"></a>01338                       <span class="keywordflow">else</span>
<a name="l01339"></a>01339                         {
<a name="l01340"></a>01340                           <span class="comment">// Case 6</span>
<a name="l01341"></a>01341                           xi_mapped  = -eta;
<a name="l01342"></a>01342                           eta_mapped = -xi;
<a name="l01343"></a>01343                         }
<a name="l01344"></a>01344 
<a name="l01345"></a>01345                     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7) == min_point)
<a name="l01346"></a>01346                       {
<a name="l01347"></a>01347                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)))
<a name="l01348"></a>01348                           {
<a name="l01349"></a>01349                             <span class="comment">// Case 7</span>
<a name="l01350"></a>01350                             xi_mapped  = -eta;
<a name="l01351"></a>01351                             eta_mapped = xi;
<a name="l01352"></a>01352                           }
<a name="l01353"></a>01353                         <span class="keywordflow">else</span>
<a name="l01354"></a>01354                           {
<a name="l01355"></a>01355                             <span class="comment">// Case 8</span>
<a name="l01356"></a>01356                             xi_mapped  = xi;
<a name="l01357"></a>01357                             eta_mapped = eta;
<a name="l01358"></a>01358                           }
<a name="l01359"></a>01359                       }
<a name="l01360"></a>01360                   }
<a name="l01361"></a>01361 
<a name="l01362"></a>01362                 
<a name="l01363"></a>01363               }
<a name="l01364"></a>01364               
<a name="l01365"></a>01365               
<a name="l01366"></a>01366               <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], xi_mapped)*
<a name="l01367"></a>01367                       <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], eta_mapped)*
<a name="l01368"></a>01368                       <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], zeta_mapped));
<a name="l01369"></a>01369             }
<a name="l01370"></a>01370 
<a name="l01371"></a>01371             
<a name="l01372"></a>01372           <span class="keywordflow">default</span>:
<a name="l01373"></a>01373             libmesh_error();
<a name="l01374"></a>01374           }     
<a name="l01375"></a>01375       }
<a name="l01376"></a>01376       
<a name="l01377"></a>01377       
<a name="l01378"></a>01378     <span class="keywordflow">default</span>:
<a name="l01379"></a>01379       libmesh_error();
<a name="l01380"></a>01380     }
<a name="l01381"></a>01381   
<a name="l01382"></a>01382 <span class="preprocessor">#endif</span>
<a name="l01383"></a>01383 <span class="preprocessor"></span>  
<a name="l01384"></a>01384   libmesh_error();
<a name="l01385"></a>01385   <span class="keywordflow">return</span> 0.;
<a name="l01386"></a>01386 }
<a name="l01387"></a>01387 
<a name="l01388"></a>01388 
<a name="l01389"></a>01389 
<a name="l01390"></a>01390 
<a name="l01391"></a>01391 <span class="keyword">template</span> &lt;&gt;
<a name="l01392"></a><a class="code" href="classlibMesh_1_1FE.php#ae08567a5c542d9f8221608c350f34b55">01392</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,BERNSTEIN&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l01393"></a>01393                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l01394"></a>01394                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01395"></a>01395                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01396"></a>01396                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; )
<a name="l01397"></a>01397 {
<a name="l01398"></a>01398   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Bernstein polynomials require the element type\n&quot;</span>
<a name="l01399"></a>01399                 &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l01400"></a>01400                 &lt;&lt; std::endl;
<a name="l01401"></a>01401   libmesh_error();
<a name="l01402"></a>01402   
<a name="l01403"></a>01403   <span class="keywordflow">return</span> 0.;
<a name="l01404"></a>01404 }
<a name="l01405"></a>01405 
<a name="l01406"></a>01406 
<a name="l01407"></a>01407 
<a name="l01408"></a>01408 <span class="keyword">template</span> &lt;&gt;
<a name="l01409"></a><a class="code" href="classlibMesh_1_1FE.php#ab97c5db287d2cfbfb57e4c43bbc248a6">01409</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,BERNSTEIN&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l01410"></a>01410                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l01411"></a>01411                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l01412"></a>01412                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l01413"></a>01413                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l01414"></a>01414 {
<a name="l01415"></a>01415 
<a name="l01416"></a>01416 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l01417"></a>01417 <span class="preprocessor"></span>  libmesh_assert (elem != NULL);
<a name="l01418"></a>01418   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01419"></a>01419 
<a name="l01420"></a>01420   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01421"></a>01421   
<a name="l01422"></a>01422   libmesh_assert (j &lt; 3);
<a name="l01423"></a>01423   
<a name="l01424"></a>01424   <span class="keywordflow">switch</span> (totalorder)
<a name="l01425"></a>01425     {
<a name="l01426"></a>01426       
<a name="l01427"></a>01427       
<a name="l01428"></a>01428       <span class="comment">// 1st order Bernstein.</span>
<a name="l01429"></a>01429     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l01430"></a>01430       {
<a name="l01431"></a>01431         <span class="keywordflow">switch</span> (type)
<a name="l01432"></a>01432           {
<a name="l01433"></a>01433             <span class="comment">// Bernstein shape functions on the tetrahedron.</span>
<a name="l01434"></a>01434           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01435"></a>01435           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01436"></a>01436             {
<a name="l01437"></a>01437               <span class="comment">// I have been lazy here and am using finite differences</span>
<a name="l01438"></a>01438               <span class="comment">// to compute the derivatives!</span>
<a name="l01439"></a>01439               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = 1.e-6;
<a name="l01440"></a>01440               
<a name="l01441"></a>01441               libmesh_assert (i &lt; 4);
<a name="l01442"></a>01442               libmesh_assert (j &lt; 3);
<a name="l01443"></a>01443               
<a name="l01444"></a>01444               
<a name="l01445"></a>01445               <span class="keywordflow">switch</span> (j)
<a name="l01446"></a>01446                 {
<a name="l01447"></a>01447                   <span class="comment">//  d()/dxi</span>
<a name="l01448"></a>01448                 <span class="keywordflow">case</span> 0:
<a name="l01449"></a>01449                   {
<a name="l01450"></a>01450                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0)+eps, p(1), p(2));
<a name="l01451"></a>01451                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0)-eps, p(1), p(2));
<a name="l01452"></a>01452                     
<a name="l01453"></a>01453                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01454"></a>01454                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01455"></a>01455                   }
<a name="l01456"></a>01456 
<a name="l01457"></a>01457                   <span class="comment">// d()/deta</span>
<a name="l01458"></a>01458                 <span class="keywordflow">case</span> 1:
<a name="l01459"></a>01459                   {
<a name="l01460"></a>01460                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1)+eps, p(2));
<a name="l01461"></a>01461                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1)-eps, p(2));
<a name="l01462"></a>01462 
<a name="l01463"></a>01463                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01464"></a>01464                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01465"></a>01465                   }
<a name="l01466"></a>01466                   <span class="comment">// d()/dzeta</span>
<a name="l01467"></a>01467                 <span class="keywordflow">case</span> 2:
<a name="l01468"></a>01468                   {
<a name="l01469"></a>01469                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1), p(2)+eps);
<a name="l01470"></a>01470                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1), p(2)-eps);
<a name="l01471"></a>01471 
<a name="l01472"></a>01472                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01473"></a>01473                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01474"></a>01474                   }                 
<a name="l01475"></a>01475                 <span class="keywordflow">default</span>:
<a name="l01476"></a>01476                   libmesh_error();
<a name="l01477"></a>01477                 }
<a name="l01478"></a>01478                               
<a name="l01479"></a>01479             }
<a name="l01480"></a>01480 
<a name="l01481"></a>01481 
<a name="l01482"></a>01482 
<a name="l01483"></a>01483 
<a name="l01484"></a>01484             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l01485"></a>01485           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01486"></a>01486           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01487"></a>01487             {
<a name="l01488"></a>01488               libmesh_assert (i&lt;8);
<a name="l01489"></a>01489         
<a name="l01490"></a>01490               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l01491"></a>01491               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l01492"></a>01492               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l01493"></a>01493               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l01494"></a>01494         
<a name="l01495"></a>01495               <span class="comment">// The only way to make any sense of this</span>
<a name="l01496"></a>01496               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l01497"></a>01497               <span class="comment">// and make the cut-out cube!</span>
<a name="l01498"></a>01498               <span class="comment">//                                0  1  2  3  4  5  6  7</span>
<a name="l01499"></a>01499               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0};
<a name="l01500"></a>01500               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1};
<a name="l01501"></a>01501               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1};
<a name="l01502"></a>01502 
<a name="l01503"></a>01503               <span class="keywordflow">switch</span> (j)
<a name="l01504"></a>01504                 {
<a name="l01505"></a>01505                   <span class="comment">// d()/dxi</span>
<a name="l01506"></a>01506                 <span class="keywordflow">case</span> 0:
<a name="l01507"></a>01507                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], 0, xi)*
<a name="l01508"></a>01508                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i],    eta)*
<a name="l01509"></a>01509                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i],    zeta));
<a name="l01510"></a>01510 
<a name="l01511"></a>01511                   <span class="comment">// d()/deta</span>
<a name="l01512"></a>01512                 <span class="keywordflow">case</span> 1:
<a name="l01513"></a>01513                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i],     xi)*
<a name="l01514"></a>01514                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], 0, eta)*
<a name="l01515"></a>01515                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i],    zeta));
<a name="l01516"></a>01516 
<a name="l01517"></a>01517                   <span class="comment">// d()/dzeta</span>
<a name="l01518"></a>01518                 <span class="keywordflow">case</span> 2:
<a name="l01519"></a>01519                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i],    xi)*
<a name="l01520"></a>01520                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i],    eta)*
<a name="l01521"></a>01521                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], 0, zeta));
<a name="l01522"></a>01522 
<a name="l01523"></a>01523                 <span class="keywordflow">default</span>:
<a name="l01524"></a>01524                   libmesh_error();
<a name="l01525"></a>01525                 }
<a name="l01526"></a>01526             }
<a name="l01527"></a>01527 
<a name="l01528"></a>01528 
<a name="l01529"></a>01529           <span class="keywordflow">default</span>:
<a name="l01530"></a>01530             libmesh_error();
<a name="l01531"></a>01531           }
<a name="l01532"></a>01532       }
<a name="l01533"></a>01533 
<a name="l01534"></a>01534 
<a name="l01535"></a>01535 
<a name="l01536"></a>01536 
<a name="l01537"></a>01537     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l01538"></a>01538       {
<a name="l01539"></a>01539         <span class="keywordflow">switch</span> (type)
<a name="l01540"></a>01540           {
<a name="l01541"></a>01541                 <span class="comment">// Bernstein shape functions on the tetrahedron.</span>
<a name="l01542"></a>01542           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01543"></a>01543                 {
<a name="l01544"></a>01544               <span class="comment">// I have been lazy here and am using finite differences</span>
<a name="l01545"></a>01545               <span class="comment">// to compute the derivatives!</span>
<a name="l01546"></a>01546               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = 1.e-6;
<a name="l01547"></a>01547               
<a name="l01548"></a>01548               libmesh_assert (i &lt;10);
<a name="l01549"></a>01549               libmesh_assert (j &lt; 3);
<a name="l01550"></a>01550 
<a name="l01551"></a>01551 
<a name="l01552"></a>01552                 <span class="keywordflow">switch</span> (j)
<a name="l01553"></a>01553                 {
<a name="l01554"></a>01554                   <span class="comment">//  d()/dxi</span>
<a name="l01555"></a>01555                 <span class="keywordflow">case</span> 0:
<a name="l01556"></a>01556                   {
<a name="l01557"></a>01557                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0)+eps, p(1), p(2));
<a name="l01558"></a>01558                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0)-eps, p(1), p(2));
<a name="l01559"></a>01559 
<a name="l01560"></a>01560                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01561"></a>01561                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01562"></a>01562                   }
<a name="l01563"></a>01563 
<a name="l01564"></a>01564                   <span class="comment">// d()/deta</span>
<a name="l01565"></a>01565                 <span class="keywordflow">case</span> 1:
<a name="l01566"></a>01566                   {
<a name="l01567"></a>01567                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1)+eps, p(2));
<a name="l01568"></a>01568                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1)-eps, p(2));
<a name="l01569"></a>01569 
<a name="l01570"></a>01570                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01571"></a>01571                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01572"></a>01572                   }
<a name="l01573"></a>01573                   <span class="comment">// d()/dzeta</span>
<a name="l01574"></a>01574                 <span class="keywordflow">case</span> 2:
<a name="l01575"></a>01575                   {
<a name="l01576"></a>01576                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1), p(2)+eps);
<a name="l01577"></a>01577                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1), p(2)-eps);
<a name="l01578"></a>01578 
<a name="l01579"></a>01579                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01580"></a>01580                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01581"></a>01581                   }                 
<a name="l01582"></a>01582                 <span class="keywordflow">default</span>:
<a name="l01583"></a>01583                   libmesh_error();
<a name="l01584"></a>01584                 }
<a name="l01585"></a>01585                               
<a name="l01586"></a>01586             }
<a name="l01587"></a>01587 
<a name="l01588"></a>01588                 <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l01589"></a>01589           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01590"></a>01590             {
<a name="l01591"></a>01591               libmesh_assert (i&lt;20);
<a name="l01592"></a>01592         
<a name="l01593"></a>01593               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l01594"></a>01594               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l01595"></a>01595               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l01596"></a>01596               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l01597"></a>01597         
<a name="l01598"></a>01598               <span class="comment">// The only way to make any sense of this</span>
<a name="l01599"></a>01599               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l01600"></a>01600               <span class="comment">// and make the cut-out cube!</span>
<a name="l01601"></a>01601               <span class="comment">//                                0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26</span>
<a name="l01602"></a>01602               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 1, 2, 0, 0, 1, 1, 0, 2, 1, 2, 0, 2, 2, 1, 2, 0, 2, 2};
<a name="l01603"></a>01603               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 2, 1, 2, 0, 0, 1, 1, 0, 2, 1, 2, 2, 0, 2, 1, 2, 2, 2};
<a name="l01604"></a>01604               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 2, 2, 1, 1, 1, 1, 0, 2, 2, 2, 2, 1, 2};
<a name="l01605"></a>01605               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal20[] =     {-0.25, -0.25, -0.25, -0.25, 0,     0,     0,     0,     0.5,   0.5,   0.5,   0.5,   0,     0,     0,     0,     0,     0,     0,     0};
<a name="l01606"></a>01606               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal21[] =     {-0.25, -0.25, 0,     0,     -0.25, -0.25, 0,     0,     0.5,   0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0,     0,     0};
<a name="l01607"></a>01607               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal22[] =     {0,     -0.25, -0.25, 0,     0,     -0.25, -0.25, 0,     0,     0.5,   0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0,     0};
<a name="l01608"></a>01608               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal23[] =     {0,     0,     -0.25, -0.25, 0,     0,     -0.25, -0.25, 0,     0,     0.5,   0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0};
<a name="l01609"></a>01609               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal24[] =     {-0.25, 0,     0,     -0.25, -0.25, 0,     0,     -0.25, 0,     0,     0,     0.5,   0.5,   0,     0,     0.5,   0,     0,     0,     0.5};
<a name="l01610"></a>01610               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal25[] =     {0,     0,     0,     0,     -0.25, -0.25, -0.25, -0.25, 0,     0,     0,     0,     0,     0,     0,     0,     0.5,   0.5,   0.5,   0.5};
<a name="l01611"></a>01611               <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> scal26[] =     {-0.25, -0.25, -0.25, -0.25, -0.25, -0.25, -0.25, -0.25, 0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25};
<a name="l01612"></a>01612 
<a name="l01613"></a>01613               <span class="keywordflow">switch</span> (j)
<a name="l01614"></a>01614                 {
<a name="l01615"></a>01615                   <span class="comment">// d()/dxi</span>
<a name="l01616"></a>01616                 <span class="keywordflow">case</span> 0:
<a name="l01617"></a>01617                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], 0, xi)*
<a name="l01618"></a>01618                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i],    eta)*
<a name="l01619"></a>01619                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i],    zeta)
<a name="l01620"></a>01620                           +scal20[i]*
<a name="l01621"></a>01621                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[20], 0, xi)*
<a name="l01622"></a>01622                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[20],    eta)*
<a name="l01623"></a>01623                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[20],    zeta)
<a name="l01624"></a>01624                           +scal21[i]*
<a name="l01625"></a>01625                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[21], 0, xi)*
<a name="l01626"></a>01626                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[21],    eta)*
<a name="l01627"></a>01627                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[21],    zeta)
<a name="l01628"></a>01628                           +scal22[i]*
<a name="l01629"></a>01629                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[22], 0, xi)*
<a name="l01630"></a>01630                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[22],    eta)*
<a name="l01631"></a>01631                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[22],    zeta)
<a name="l01632"></a>01632                           +scal23[i]*
<a name="l01633"></a>01633                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[23], 0, xi)*
<a name="l01634"></a>01634                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[23],    eta)*
<a name="l01635"></a>01635                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[23],    zeta)
<a name="l01636"></a>01636                           +scal24[i]*
<a name="l01637"></a>01637                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[24], 0, xi)*
<a name="l01638"></a>01638                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[24],    eta)*
<a name="l01639"></a>01639                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[24],    zeta)
<a name="l01640"></a>01640                           +scal25[i]*
<a name="l01641"></a>01641                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[25], 0, xi)*
<a name="l01642"></a>01642                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[25],    eta)*
<a name="l01643"></a>01643                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[25],    zeta)
<a name="l01644"></a>01644                           +scal26[i]*
<a name="l01645"></a>01645                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[26], 0, xi)*
<a name="l01646"></a>01646                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[26],    eta)*
<a name="l01647"></a>01647                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[26],    zeta));
<a name="l01648"></a>01648 
<a name="l01649"></a>01649                   <span class="comment">// d()/deta</span>
<a name="l01650"></a>01650                 <span class="keywordflow">case</span> 1:
<a name="l01651"></a>01651                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i],     xi)*
<a name="l01652"></a>01652                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], 0, eta)*
<a name="l01653"></a>01653                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i],    zeta)
<a name="l01654"></a>01654                           +scal20[i]*
<a name="l01655"></a>01655                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[20],     xi)*
<a name="l01656"></a>01656                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[20], 0, eta)*
<a name="l01657"></a>01657                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[20],    zeta)
<a name="l01658"></a>01658                           +scal21[i]*
<a name="l01659"></a>01659                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[21],     xi)*
<a name="l01660"></a>01660                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[21], 0, eta)*
<a name="l01661"></a>01661                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[21],    zeta)
<a name="l01662"></a>01662                           +scal22[i]*
<a name="l01663"></a>01663                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[22],     xi)*
<a name="l01664"></a>01664                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[22], 0, eta)*
<a name="l01665"></a>01665                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[22],    zeta)
<a name="l01666"></a>01666                           +scal23[i]*
<a name="l01667"></a>01667                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[23],     xi)*
<a name="l01668"></a>01668                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[23], 0, eta)*
<a name="l01669"></a>01669                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[23],    zeta)
<a name="l01670"></a>01670                           +scal24[i]*
<a name="l01671"></a>01671                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[24],     xi)*
<a name="l01672"></a>01672                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[24], 0, eta)*
<a name="l01673"></a>01673                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[24],    zeta)
<a name="l01674"></a>01674                           +scal25[i]*
<a name="l01675"></a>01675                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[25],     xi)*
<a name="l01676"></a>01676                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[25], 0, eta)*
<a name="l01677"></a>01677                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[25],    zeta)
<a name="l01678"></a>01678                           +scal26[i]*
<a name="l01679"></a>01679                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[26],     xi)*
<a name="l01680"></a>01680                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[26], 0, eta)*
<a name="l01681"></a>01681                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[26],    zeta));
<a name="l01682"></a>01682 
<a name="l01683"></a>01683                   <span class="comment">// d()/dzeta</span>
<a name="l01684"></a>01684                 <span class="keywordflow">case</span> 2:
<a name="l01685"></a>01685                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i],    xi)*
<a name="l01686"></a>01686                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i],    eta)*
<a name="l01687"></a>01687                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], 0, zeta)
<a name="l01688"></a>01688                           +scal20[i]*
<a name="l01689"></a>01689                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[20],    xi)*
<a name="l01690"></a>01690                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[20],    eta)*
<a name="l01691"></a>01691                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[20], 0, zeta)
<a name="l01692"></a>01692                           +scal21[i]*
<a name="l01693"></a>01693                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[21],    xi)*
<a name="l01694"></a>01694                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[21],    eta)*
<a name="l01695"></a>01695                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[21], 0, zeta)
<a name="l01696"></a>01696                           +scal22[i]*
<a name="l01697"></a>01697                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[22],    xi)*
<a name="l01698"></a>01698                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[22],    eta)*
<a name="l01699"></a>01699                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[22], 0, zeta)
<a name="l01700"></a>01700                           +scal23[i]*
<a name="l01701"></a>01701                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[23],    xi)*
<a name="l01702"></a>01702                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[23],    eta)*
<a name="l01703"></a>01703                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[23], 0, zeta)
<a name="l01704"></a>01704                           +scal24[i]*
<a name="l01705"></a>01705                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[24],    xi)*
<a name="l01706"></a>01706                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[24],    eta)*
<a name="l01707"></a>01707                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[24], 0, zeta)
<a name="l01708"></a>01708                           +scal25[i]*
<a name="l01709"></a>01709                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[25],    xi)*
<a name="l01710"></a>01710                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[25],    eta)*
<a name="l01711"></a>01711                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[25], 0, zeta)
<a name="l01712"></a>01712                           +scal26[i]*
<a name="l01713"></a>01713                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[26],    xi)*
<a name="l01714"></a>01714                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[26],    eta)*
<a name="l01715"></a>01715                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[26], 0, zeta));
<a name="l01716"></a>01716 
<a name="l01717"></a>01717                 <span class="keywordflow">default</span>:
<a name="l01718"></a>01718                   libmesh_error();
<a name="l01719"></a>01719                 }
<a name="l01720"></a>01720             }
<a name="l01721"></a>01721 
<a name="l01722"></a>01722             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l01723"></a>01723           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01724"></a>01724             {
<a name="l01725"></a>01725               libmesh_assert (i&lt;27);
<a name="l01726"></a>01726         
<a name="l01727"></a>01727               <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l01728"></a>01728               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l01729"></a>01729               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l01730"></a>01730               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l01731"></a>01731         
<a name="l01732"></a>01732               <span class="comment">// The only way to make any sense of this</span>
<a name="l01733"></a>01733               <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l01734"></a>01734               <span class="comment">// and make the cut-out cube!</span>
<a name="l01735"></a>01735               <span class="comment">//                                0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26</span>
<a name="l01736"></a>01736               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 1, 2, 0, 0, 1, 1, 0, 2, 1, 2, 0, 2, 2, 1, 2, 0, 2, 2};
<a name="l01737"></a>01737               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 2, 1, 2, 0, 0, 1, 1, 0, 2, 1, 2, 2, 0, 2, 1, 2, 2, 2};
<a name="l01738"></a>01738               <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 2, 2, 1, 1, 1, 1, 0, 2, 2, 2, 2, 1, 2};
<a name="l01739"></a>01739 
<a name="l01740"></a>01740               <span class="keywordflow">switch</span> (j)
<a name="l01741"></a>01741                 {
<a name="l01742"></a>01742                   <span class="comment">// d()/dxi</span>
<a name="l01743"></a>01743                 <span class="keywordflow">case</span> 0:
<a name="l01744"></a>01744                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i], 0, xi)*
<a name="l01745"></a>01745                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i],    eta)*
<a name="l01746"></a>01746                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i],    zeta));
<a name="l01747"></a>01747 
<a name="l01748"></a>01748                   <span class="comment">// d()/deta</span>
<a name="l01749"></a>01749                 <span class="keywordflow">case</span> 1:
<a name="l01750"></a>01750                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i],     xi)*
<a name="l01751"></a>01751                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i], 0, eta)*
<a name="l01752"></a>01752                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i],    zeta));
<a name="l01753"></a>01753 
<a name="l01754"></a>01754                   <span class="comment">// d()/dzeta</span>
<a name="l01755"></a>01755                 <span class="keywordflow">case</span> 2:
<a name="l01756"></a>01756                   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0[i],    xi)*
<a name="l01757"></a>01757                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape</a>      (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1[i],    eta)*
<a name="l01758"></a>01758                           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2[i], 0, zeta));
<a name="l01759"></a>01759 
<a name="l01760"></a>01760                 <span class="keywordflow">default</span>:
<a name="l01761"></a>01761                   libmesh_error();
<a name="l01762"></a>01762                 }
<a name="l01763"></a>01763             }
<a name="l01764"></a>01764 
<a name="l01765"></a>01765 
<a name="l01766"></a>01766           <span class="keywordflow">default</span>:
<a name="l01767"></a>01767             libmesh_error();
<a name="l01768"></a>01768           }
<a name="l01769"></a>01769       }
<a name="l01770"></a>01770 
<a name="l01771"></a>01771       
<a name="l01772"></a>01772 
<a name="l01773"></a>01773       <span class="comment">// 3rd-order Bernstein.</span>
<a name="l01774"></a>01774     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l01775"></a>01775       {
<a name="l01776"></a>01776         <span class="keywordflow">switch</span> (type)
<a name="l01777"></a>01777           {
<a name="l01778"></a>01778 
<a name="l01779"></a>01779 <span class="comment">//          // Bernstein shape functions derivatives.</span>
<a name="l01780"></a>01780 <span class="comment">//        case TET10:</span>
<a name="l01781"></a>01781 <span class="comment">//          {</span>
<a name="l01782"></a>01782 <span class="comment">//            // I have been lazy here and am using finite differences</span>
<a name="l01783"></a>01783 <span class="comment">//            // to compute the derivatives!</span>
<a name="l01784"></a>01784 <span class="comment">//            const Real eps = 1.e-6;</span>
<a name="l01785"></a>01785               
<a name="l01786"></a>01786 <span class="comment">//            libmesh_assert (i &lt; 20);</span>
<a name="l01787"></a>01787 <span class="comment">//            libmesh_assert (j &lt; 3);    </span>
<a name="l01788"></a>01788  
<a name="l01789"></a>01789 <span class="comment">//              switch (j)</span>
<a name="l01790"></a>01790 <span class="comment">//              {</span>
<a name="l01791"></a>01791 <span class="comment">//                //  d()/dxi</span>
<a name="l01792"></a>01792 <span class="comment">//              case 0:</span>
<a name="l01793"></a>01793 <span class="comment">//                {</span>
<a name="l01794"></a>01794 <span class="comment">//                  const Point pp(p(0)+eps, p(1), p(2));</span>
<a name="l01795"></a>01795 <span class="comment">//                  const Point pm(p(0)-eps, p(1), p(2));</span>
<a name="l01796"></a>01796 
<a name="l01797"></a>01797 <span class="comment">//                  return (FE&lt;3,BERNSTEIN&gt;::shape(elem, order, i, pp) -</span>
<a name="l01798"></a>01798 <span class="comment">//                          FE&lt;3,BERNSTEIN&gt;::shape(elem, order, i, pm))/2./eps;</span>
<a name="l01799"></a>01799 <span class="comment">//                }</span>
<a name="l01800"></a>01800 
<a name="l01801"></a>01801 <span class="comment">//                // d()/deta</span>
<a name="l01802"></a>01802 <span class="comment">//              case 1:</span>
<a name="l01803"></a>01803 <span class="comment">//                {</span>
<a name="l01804"></a>01804 <span class="comment">//                  const Point pp(p(0), p(1)+eps, p(2));</span>
<a name="l01805"></a>01805 <span class="comment">//                  const Point pm(p(0), p(1)-eps, p(2));</span>
<a name="l01806"></a>01806 
<a name="l01807"></a>01807 <span class="comment">//                  return (FE&lt;3,BERNSTEIN&gt;::shape(elem, order, i, pp) -</span>
<a name="l01808"></a>01808 <span class="comment">//                          FE&lt;3,BERNSTEIN&gt;::shape(elem, order, i, pm))/2./eps;</span>
<a name="l01809"></a>01809 <span class="comment">//                }</span>
<a name="l01810"></a>01810 <span class="comment">//                // d()/dzeta</span>
<a name="l01811"></a>01811 <span class="comment">//              case 2:</span>
<a name="l01812"></a>01812 <span class="comment">//                {</span>
<a name="l01813"></a>01813 <span class="comment">//                  const Point pp(p(0), p(1), p(2)+eps);</span>
<a name="l01814"></a>01814 <span class="comment">//                  const Point pm(p(0), p(1), p(2)-eps);</span>
<a name="l01815"></a>01815 
<a name="l01816"></a>01816 <span class="comment">//                  return (FE&lt;3,BERNSTEIN&gt;::shape(elem, order, i, pp) -</span>
<a name="l01817"></a>01817 <span class="comment">//                          FE&lt;3,BERNSTEIN&gt;::shape(elem, order, i, pm))/2./eps;</span>
<a name="l01818"></a>01818 <span class="comment">//                }                 </span>
<a name="l01819"></a>01819 <span class="comment">//              default:</span>
<a name="l01820"></a>01820 <span class="comment">//                libmesh_error();</span>
<a name="l01821"></a>01821 <span class="comment">//              }</span>
<a name="l01822"></a>01822       
<a name="l01823"></a>01823                                       
<a name="l01824"></a>01824 <span class="comment">//          }</span>
<a name="l01825"></a>01825             
<a name="l01826"></a>01826 
<a name="l01827"></a>01827             <span class="comment">// Bernstein shape functions on the hexahedral.</span>
<a name="l01828"></a>01828           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01829"></a>01829             {
<a name="l01830"></a>01830               <span class="comment">// I have been lazy here and am using finite differences</span>
<a name="l01831"></a>01831               <span class="comment">// to compute the derivatives!</span>
<a name="l01832"></a>01832               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = 1.e-6;
<a name="l01833"></a>01833               
<a name="l01834"></a>01834               libmesh_assert (i &lt; 64);
<a name="l01835"></a>01835               libmesh_assert (j &lt; 3);    
<a name="l01836"></a>01836               
<a name="l01837"></a>01837               <span class="keywordflow">switch</span> (j)
<a name="l01838"></a>01838                 {
<a name="l01839"></a>01839                   <span class="comment">//  d()/dxi</span>
<a name="l01840"></a>01840                 <span class="keywordflow">case</span> 0:
<a name="l01841"></a>01841                   {
<a name="l01842"></a>01842                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0)+eps, p(1), p(2));
<a name="l01843"></a>01843                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0)-eps, p(1), p(2));
<a name="l01844"></a>01844                     
<a name="l01845"></a>01845                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01846"></a>01846                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01847"></a>01847                   }
<a name="l01848"></a>01848                   
<a name="l01849"></a>01849                   <span class="comment">// d()/deta</span>
<a name="l01850"></a>01850                 <span class="keywordflow">case</span> 1:
<a name="l01851"></a>01851                   {
<a name="l01852"></a>01852                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1)+eps, p(2));
<a name="l01853"></a>01853                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1)-eps, p(2));
<a name="l01854"></a>01854                     
<a name="l01855"></a>01855                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01856"></a>01856                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01857"></a>01857                   }
<a name="l01858"></a>01858                   <span class="comment">// d()/dzeta</span>
<a name="l01859"></a>01859                 <span class="keywordflow">case</span> 2:
<a name="l01860"></a>01860                   {
<a name="l01861"></a>01861                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1), p(2)+eps);
<a name="l01862"></a>01862                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1), p(2)-eps);
<a name="l01863"></a>01863                     
<a name="l01864"></a>01864                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l01865"></a>01865                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l01866"></a>01866                   }                 
<a name="l01867"></a>01867                 <span class="keywordflow">default</span>:
<a name="l01868"></a>01868                   libmesh_error();
<a name="l01869"></a>01869                 }
<a name="l01870"></a>01870               
<a name="l01871"></a>01871             }
<a name="l01872"></a>01872             
<a name="l01873"></a>01873 <span class="comment">//            // Compute hex shape functions as a tensor-product</span>
<a name="l01874"></a>01874 <span class="comment">//            const Real xi    = p(0);</span>
<a name="l01875"></a>01875 <span class="comment">//            const Real eta   = p(1);</span>
<a name="l01876"></a>01876 <span class="comment">//            const Real zeta  = p(2);</span>
<a name="l01877"></a>01877 <span class="comment">//            Real xi_mapped   = p(0);</span>
<a name="l01878"></a>01878 <span class="comment">//            Real eta_mapped  = p(1);</span>
<a name="l01879"></a>01879 <span class="comment">//            Real zeta_mapped = p(2);</span>
<a name="l01880"></a>01880         
<a name="l01881"></a>01881 <span class="comment">//            // The only way to make any sense of this</span>
<a name="l01882"></a>01882 <span class="comment">//            // is to look at the mgflo/mg2/mgf documentation</span>
<a name="l01883"></a>01883 <span class="comment">//            // and make the cut-out cube!</span>
<a name="l01884"></a>01884 <span class="comment">//            //  Nodes                         0  1  2  3  4  5  6  7  8  8  9  9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 20 20 21 21 21 21 22 22 22 22 23 23 23 23 24 24 24 24 25 25 25 25 26 26 26 26 26 26 26 26 </span>
<a name="l01885"></a>01885 <span class="comment">//            //  DOFS                          0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 18 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 60 62 63</span>
<a name="l01886"></a>01886 <span class="comment">//            static const unsigned int i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3};</span>
<a name="l01887"></a>01887 <span class="comment">//            static const unsigned int i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 2, 2, 3, 3, 0, 0, 0, 0, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3};</span>
<a name="l01888"></a>01888 <span class="comment">//            static const unsigned int i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3};</span>
<a name="l01889"></a>01889 
<a name="l01890"></a>01890 
<a name="l01891"></a>01891 
<a name="l01892"></a>01892 <span class="comment">//            // handle the edge orientation</span>
<a name="l01893"></a>01893 <span class="comment">//            {</span>
<a name="l01894"></a>01894 <span class="comment">//              // Edge 0</span>
<a name="l01895"></a>01895 <span class="comment">//              if ((i1[i] == 0) &amp;&amp; (i2[i] == 0))</span>
<a name="l01896"></a>01896 <span class="comment">//                {</span>
<a name="l01897"></a>01897 <span class="comment">//                  if (elem-&gt;node(0) != std::min(elem-&gt;node(0), elem-&gt;node(1)))</span>
<a name="l01898"></a>01898 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l01899"></a>01899 <span class="comment">//                }</span>
<a name="l01900"></a>01900 <span class="comment">//              // Edge 1</span>
<a name="l01901"></a>01901 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i2[i] == 0))</span>
<a name="l01902"></a>01902 <span class="comment">//                {</span>
<a name="l01903"></a>01903 <span class="comment">//                  if (elem-&gt;node(1) != std::min(elem-&gt;node(1), elem-&gt;node(2)))</span>
<a name="l01904"></a>01904 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l01905"></a>01905 <span class="comment">//                }</span>
<a name="l01906"></a>01906 <span class="comment">//              // Edge 2</span>
<a name="l01907"></a>01907 <span class="comment">//              else if ((i1[i] == 1) &amp;&amp; (i2[i] == 0))</span>
<a name="l01908"></a>01908 <span class="comment">//                {</span>
<a name="l01909"></a>01909 <span class="comment">//                  if (elem-&gt;node(3) != std::min(elem-&gt;node(3), elem-&gt;node(2)))</span>
<a name="l01910"></a>01910 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l01911"></a>01911 <span class="comment">//                }</span>
<a name="l01912"></a>01912 <span class="comment">//              // Edge 3</span>
<a name="l01913"></a>01913 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i2[i] == 0))</span>
<a name="l01914"></a>01914 <span class="comment">//                {</span>
<a name="l01915"></a>01915 <span class="comment">//                  if (elem-&gt;node(0) != std::min(elem-&gt;node(0), elem-&gt;node(3)))</span>
<a name="l01916"></a>01916 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l01917"></a>01917 <span class="comment">//                }</span>
<a name="l01918"></a>01918 <span class="comment">//              // Edge 4</span>
<a name="l01919"></a>01919 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i1[i] == 0))</span>
<a name="l01920"></a>01920 <span class="comment">//                {</span>
<a name="l01921"></a>01921 <span class="comment">//                  if (elem-&gt;node(0) != std::min(elem-&gt;node(0), elem-&gt;node(4)))</span>
<a name="l01922"></a>01922 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l01923"></a>01923 <span class="comment">//                }             </span>
<a name="l01924"></a>01924 <span class="comment">//              // Edge 5</span>
<a name="l01925"></a>01925 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i1[i] == 0))</span>
<a name="l01926"></a>01926 <span class="comment">//                {</span>
<a name="l01927"></a>01927 <span class="comment">//                  if (elem-&gt;node(1) != std::min(elem-&gt;node(1), elem-&gt;node(5)))</span>
<a name="l01928"></a>01928 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l01929"></a>01929 <span class="comment">//                }             </span>
<a name="l01930"></a>01930 <span class="comment">//              // Edge 6</span>
<a name="l01931"></a>01931 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i1[i] == 1))</span>
<a name="l01932"></a>01932 <span class="comment">//                {</span>
<a name="l01933"></a>01933 <span class="comment">//                  if (elem-&gt;node(2) != std::min(elem-&gt;node(2), elem-&gt;node(6)))</span>
<a name="l01934"></a>01934 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l01935"></a>01935 <span class="comment">//                }</span>
<a name="l01936"></a>01936 <span class="comment">//              // Edge 7</span>
<a name="l01937"></a>01937 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i1[i] == 1))</span>
<a name="l01938"></a>01938 <span class="comment">//                {</span>
<a name="l01939"></a>01939 <span class="comment">//                  if (elem-&gt;node(3) != std::min(elem-&gt;node(3), elem-&gt;node(7)))</span>
<a name="l01940"></a>01940 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l01941"></a>01941 <span class="comment">//                }             </span>
<a name="l01942"></a>01942 <span class="comment">//              // Edge 8</span>
<a name="l01943"></a>01943 <span class="comment">//              else if ((i1[i] == 0) &amp;&amp; (i2[i] == 1))</span>
<a name="l01944"></a>01944 <span class="comment">//                {</span>
<a name="l01945"></a>01945 <span class="comment">//                  if (elem-&gt;node(4) != std::min(elem-&gt;node(4), elem-&gt;node(5)))</span>
<a name="l01946"></a>01946 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l01947"></a>01947 <span class="comment">//                }</span>
<a name="l01948"></a>01948 <span class="comment">//              // Edge 9</span>
<a name="l01949"></a>01949 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i2[i] == 1))</span>
<a name="l01950"></a>01950 <span class="comment">//                {</span>
<a name="l01951"></a>01951 <span class="comment">//                  if (elem-&gt;node(5) != std::min(elem-&gt;node(5), elem-&gt;node(6)))</span>
<a name="l01952"></a>01952 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l01953"></a>01953 <span class="comment">//                }             </span>
<a name="l01954"></a>01954 <span class="comment">//              // Edge 10</span>
<a name="l01955"></a>01955 <span class="comment">//              else if ((i1[i] == 1) &amp;&amp; (i2[i] == 1))</span>
<a name="l01956"></a>01956 <span class="comment">//                {</span>
<a name="l01957"></a>01957 <span class="comment">//                  if (elem-&gt;node(7) != std::min(elem-&gt;node(7), elem-&gt;node(6)))</span>
<a name="l01958"></a>01958 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l01959"></a>01959 <span class="comment">//                }</span>
<a name="l01960"></a>01960 <span class="comment">//              // Edge 11</span>
<a name="l01961"></a>01961 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i2[i] == 1))</span>
<a name="l01962"></a>01962 <span class="comment">//                {</span>
<a name="l01963"></a>01963 <span class="comment">//                  if (elem-&gt;node(4) != std::min(elem-&gt;node(4), elem-&gt;node(7)))</span>
<a name="l01964"></a>01964 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l01965"></a>01965 <span class="comment">//                }</span>
<a name="l01966"></a>01966 <span class="comment">//            }</span>
<a name="l01967"></a>01967 
<a name="l01968"></a>01968 
<a name="l01969"></a>01969 <span class="comment">//            // handle the face orientation</span>
<a name="l01970"></a>01970 <span class="comment">//            {</span>
<a name="l01971"></a>01971 <span class="comment">//              // Face 0</span>
<a name="l01972"></a>01972 <span class="comment">//              if (     (i2[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))</span>
<a name="l01973"></a>01973 <span class="comment">//                {</span>
<a name="l01974"></a>01974 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(1),</span>
<a name="l01975"></a>01975 <span class="comment">//                                                         std::min(elem-&gt;node(2),</span>
<a name="l01976"></a>01976 <span class="comment">//                                                                  std::min(elem-&gt;node(0),</span>
<a name="l01977"></a>01977 <span class="comment">//                                                                           elem-&gt;node(3))));</span>
<a name="l01978"></a>01978 <span class="comment">//                  if (elem-&gt;node(0) == min_node)</span>
<a name="l01979"></a>01979 <span class="comment">//                    if (elem-&gt;node(1) == std::min(elem-&gt;node(1), elem-&gt;node(3)))</span>
<a name="l01980"></a>01980 <span class="comment">//                      {</span>
<a name="l01981"></a>01981 <span class="comment">//                        // Case 1</span>
<a name="l01982"></a>01982 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l01983"></a>01983 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l01984"></a>01984 <span class="comment">//                      }</span>
<a name="l01985"></a>01985 <span class="comment">//                    else</span>
<a name="l01986"></a>01986 <span class="comment">//                      {</span>
<a name="l01987"></a>01987 <span class="comment">//                        // Case 2</span>
<a name="l01988"></a>01988 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l01989"></a>01989 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l01990"></a>01990 <span class="comment">//                      }</span>
<a name="l01991"></a>01991 
<a name="l01992"></a>01992 <span class="comment">//                  else if (elem-&gt;node(3) == min_node)</span>
<a name="l01993"></a>01993 <span class="comment">//                    if (elem-&gt;node(0) == std::min(elem-&gt;node(0), elem-&gt;node(2)))</span>
<a name="l01994"></a>01994 <span class="comment">//                      {</span>
<a name="l01995"></a>01995 <span class="comment">//                        // Case 3</span>
<a name="l01996"></a>01996 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l01997"></a>01997 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l01998"></a>01998 <span class="comment">//                      }</span>
<a name="l01999"></a>01999 <span class="comment">//                    else</span>
<a name="l02000"></a>02000 <span class="comment">//                      {</span>
<a name="l02001"></a>02001 <span class="comment">//                        // Case 4</span>
<a name="l02002"></a>02002 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02003"></a>02003 <span class="comment">//                        eta_mapped = -eta;</span>
<a name="l02004"></a>02004 <span class="comment">//                      }</span>
<a name="l02005"></a>02005 
<a name="l02006"></a>02006 <span class="comment">//                  else if (elem-&gt;node(2) == min_node)</span>
<a name="l02007"></a>02007 <span class="comment">//                    if (elem-&gt;node(3) == std::min(elem-&gt;node(3), elem-&gt;node(1)))</span>
<a name="l02008"></a>02008 <span class="comment">//                      {</span>
<a name="l02009"></a>02009 <span class="comment">//                        // Case 5</span>
<a name="l02010"></a>02010 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02011"></a>02011 <span class="comment">//                        eta_mapped = -eta;</span>
<a name="l02012"></a>02012 <span class="comment">//                      }</span>
<a name="l02013"></a>02013 <span class="comment">//                    else</span>
<a name="l02014"></a>02014 <span class="comment">//                      {</span>
<a name="l02015"></a>02015 <span class="comment">//                        // Case 6</span>
<a name="l02016"></a>02016 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02017"></a>02017 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02018"></a>02018 <span class="comment">//                      }</span>
<a name="l02019"></a>02019 
<a name="l02020"></a>02020 <span class="comment">//                  else if (elem-&gt;node(1) == min_node)</span>
<a name="l02021"></a>02021 <span class="comment">//                    if (elem-&gt;node(2) == std::min(elem-&gt;node(2), elem-&gt;node(0)))</span>
<a name="l02022"></a>02022 <span class="comment">//                      {</span>
<a name="l02023"></a>02023 <span class="comment">//                        // Case 7</span>
<a name="l02024"></a>02024 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02025"></a>02025 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02026"></a>02026 <span class="comment">//                      }</span>
<a name="l02027"></a>02027 <span class="comment">//                    else</span>
<a name="l02028"></a>02028 <span class="comment">//                      {</span>
<a name="l02029"></a>02029 <span class="comment">//                        // Case 8</span>
<a name="l02030"></a>02030 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02031"></a>02031 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02032"></a>02032 <span class="comment">//                      }</span>
<a name="l02033"></a>02033 <span class="comment">//                }</span>
<a name="l02034"></a>02034 
<a name="l02035"></a>02035                 
<a name="l02036"></a>02036 <span class="comment">//              // Face 1</span>
<a name="l02037"></a>02037 <span class="comment">//              else if ((i1[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02038"></a>02038 <span class="comment">//                {</span>
<a name="l02039"></a>02039 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(0),</span>
<a name="l02040"></a>02040 <span class="comment">//                                                         std::min(elem-&gt;node(1),</span>
<a name="l02041"></a>02041 <span class="comment">//                                                                  std::min(elem-&gt;node(5),</span>
<a name="l02042"></a>02042 <span class="comment">//                                                                           elem-&gt;node(4))));</span>
<a name="l02043"></a>02043 <span class="comment">//                  if (elem-&gt;node(0) == min_node)</span>
<a name="l02044"></a>02044 <span class="comment">//                    if (elem-&gt;node(1) == std::min(elem-&gt;node(1), elem-&gt;node(4)))</span>
<a name="l02045"></a>02045 <span class="comment">//                      {</span>
<a name="l02046"></a>02046 <span class="comment">//                        // Case 1</span>
<a name="l02047"></a>02047 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02048"></a>02048 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02049"></a>02049 <span class="comment">//                      }</span>
<a name="l02050"></a>02050 <span class="comment">//                    else</span>
<a name="l02051"></a>02051 <span class="comment">//                      {</span>
<a name="l02052"></a>02052 <span class="comment">//                        // Case 2</span>
<a name="l02053"></a>02053 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02054"></a>02054 <span class="comment">//                        zeta_mapped = xi;</span>
<a name="l02055"></a>02055 <span class="comment">//                      }</span>
<a name="l02056"></a>02056 
<a name="l02057"></a>02057 <span class="comment">//                  else if (elem-&gt;node(1) == min_node)</span>
<a name="l02058"></a>02058 <span class="comment">//                    if (elem-&gt;node(5) == std::min(elem-&gt;node(5), elem-&gt;node(0)))</span>
<a name="l02059"></a>02059 <span class="comment">//                      {</span>
<a name="l02060"></a>02060 <span class="comment">//                        // Case 3</span>
<a name="l02061"></a>02061 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02062"></a>02062 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02063"></a>02063 <span class="comment">//                      }</span>
<a name="l02064"></a>02064 <span class="comment">//                    else</span>
<a name="l02065"></a>02065 <span class="comment">//                      {</span>
<a name="l02066"></a>02066 <span class="comment">//                        // Case 4</span>
<a name="l02067"></a>02067 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02068"></a>02068 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02069"></a>02069 <span class="comment">//                      }</span>
<a name="l02070"></a>02070 
<a name="l02071"></a>02071 <span class="comment">//                  else if (elem-&gt;node(5) == min_node)</span>
<a name="l02072"></a>02072 <span class="comment">//                    if (elem-&gt;node(4) == std::min(elem-&gt;node(4), elem-&gt;node(1)))</span>
<a name="l02073"></a>02073 <span class="comment">//                      {</span>
<a name="l02074"></a>02074 <span class="comment">//                        // Case 5</span>
<a name="l02075"></a>02075 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02076"></a>02076 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02077"></a>02077 <span class="comment">//                      }</span>
<a name="l02078"></a>02078 <span class="comment">//                    else</span>
<a name="l02079"></a>02079 <span class="comment">//                      {</span>
<a name="l02080"></a>02080 <span class="comment">//                        // Case 6</span>
<a name="l02081"></a>02081 <span class="comment">//                        xi_mapped   = -zeta;</span>
<a name="l02082"></a>02082 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02083"></a>02083 <span class="comment">//                      }</span>
<a name="l02084"></a>02084 
<a name="l02085"></a>02085 <span class="comment">//                  else if (elem-&gt;node(4) == min_node)</span>
<a name="l02086"></a>02086 <span class="comment">//                    if (elem-&gt;node(0) == std::min(elem-&gt;node(0), elem-&gt;node(5)))</span>
<a name="l02087"></a>02087 <span class="comment">//                      {</span>
<a name="l02088"></a>02088 <span class="comment">//                        // Case 7</span>
<a name="l02089"></a>02089 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02090"></a>02090 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02091"></a>02091 <span class="comment">//                      }</span>
<a name="l02092"></a>02092 <span class="comment">//                    else</span>
<a name="l02093"></a>02093 <span class="comment">//                      {</span>
<a name="l02094"></a>02094 <span class="comment">//                        // Case 8</span>
<a name="l02095"></a>02095 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02096"></a>02096 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02097"></a>02097 <span class="comment">//                      }</span>
<a name="l02098"></a>02098 <span class="comment">//                }</span>
<a name="l02099"></a>02099 
<a name="l02100"></a>02100                 
<a name="l02101"></a>02101 <span class="comment">//              // Face 2</span>
<a name="l02102"></a>02102 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02103"></a>02103 <span class="comment">//                {</span>
<a name="l02104"></a>02104 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(1),</span>
<a name="l02105"></a>02105 <span class="comment">//                                                         std::min(elem-&gt;node(2),</span>
<a name="l02106"></a>02106 <span class="comment">//                                                                  std::min(elem-&gt;node(6),</span>
<a name="l02107"></a>02107 <span class="comment">//                                                                           elem-&gt;node(5))));</span>
<a name="l02108"></a>02108 <span class="comment">//                  if (elem-&gt;node(1) == min_node)</span>
<a name="l02109"></a>02109 <span class="comment">//                    if (elem-&gt;node(2) == std::min(elem-&gt;node(2), elem-&gt;node(5)))</span>
<a name="l02110"></a>02110 <span class="comment">//                      {</span>
<a name="l02111"></a>02111 <span class="comment">//                        // Case 1</span>
<a name="l02112"></a>02112 <span class="comment">//                        eta_mapped  = eta;</span>
<a name="l02113"></a>02113 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02114"></a>02114 <span class="comment">//                      }</span>
<a name="l02115"></a>02115 <span class="comment">//                    else</span>
<a name="l02116"></a>02116 <span class="comment">//                      {</span>
<a name="l02117"></a>02117 <span class="comment">//                        // Case 2</span>
<a name="l02118"></a>02118 <span class="comment">//                        eta_mapped  = zeta;</span>
<a name="l02119"></a>02119 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02120"></a>02120 <span class="comment">//                      }</span>
<a name="l02121"></a>02121 
<a name="l02122"></a>02122 <span class="comment">//                  else if (elem-&gt;node(2) == min_node)</span>
<a name="l02123"></a>02123 <span class="comment">//                    if (elem-&gt;node(6) == std::min(elem-&gt;node(6), elem-&gt;node(1)))</span>
<a name="l02124"></a>02124 <span class="comment">//                      {</span>
<a name="l02125"></a>02125 <span class="comment">//                        // Case 3</span>
<a name="l02126"></a>02126 <span class="comment">//                        eta_mapped  = zeta;</span>
<a name="l02127"></a>02127 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02128"></a>02128 <span class="comment">//                      }</span>
<a name="l02129"></a>02129 <span class="comment">//                    else</span>
<a name="l02130"></a>02130 <span class="comment">//                      {</span>
<a name="l02131"></a>02131 <span class="comment">//                        // Case 4</span>
<a name="l02132"></a>02132 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02133"></a>02133 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02134"></a>02134 <span class="comment">//                      }</span>
<a name="l02135"></a>02135 
<a name="l02136"></a>02136 <span class="comment">//                  else if (elem-&gt;node(6) == min_node)</span>
<a name="l02137"></a>02137 <span class="comment">//                    if (elem-&gt;node(5) == std::min(elem-&gt;node(5), elem-&gt;node(2)))</span>
<a name="l02138"></a>02138 <span class="comment">//                      {</span>
<a name="l02139"></a>02139 <span class="comment">//                        // Case 5</span>
<a name="l02140"></a>02140 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02141"></a>02141 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02142"></a>02142 <span class="comment">//                      }</span>
<a name="l02143"></a>02143 <span class="comment">//                    else</span>
<a name="l02144"></a>02144 <span class="comment">//                      {</span>
<a name="l02145"></a>02145 <span class="comment">//                        // Case 6</span>
<a name="l02146"></a>02146 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02147"></a>02147 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02148"></a>02148 <span class="comment">//                      }</span>
<a name="l02149"></a>02149 
<a name="l02150"></a>02150 <span class="comment">//                  else if (elem-&gt;node(5) == min_node)</span>
<a name="l02151"></a>02151 <span class="comment">//                    if (elem-&gt;node(1) == std::min(elem-&gt;node(1), elem-&gt;node(6)))</span>
<a name="l02152"></a>02152 <span class="comment">//                      {</span>
<a name="l02153"></a>02153 <span class="comment">//                        // Case 7</span>
<a name="l02154"></a>02154 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02155"></a>02155 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02156"></a>02156 <span class="comment">//                      }</span>
<a name="l02157"></a>02157 <span class="comment">//                    else</span>
<a name="l02158"></a>02158 <span class="comment">//                      {</span>
<a name="l02159"></a>02159 <span class="comment">//                        // Case 8</span>
<a name="l02160"></a>02160 <span class="comment">//                        eta_mapped   = eta;</span>
<a name="l02161"></a>02161 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02162"></a>02162 <span class="comment">//                      }</span>
<a name="l02163"></a>02163 <span class="comment">//                }</span>
<a name="l02164"></a>02164 
<a name="l02165"></a>02165                 
<a name="l02166"></a>02166 <span class="comment">//              // Face 3</span>
<a name="l02167"></a>02167 <span class="comment">//              else if ((i1[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02168"></a>02168 <span class="comment">//                {</span>
<a name="l02169"></a>02169 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(2),</span>
<a name="l02170"></a>02170 <span class="comment">//                                                         std::min(elem-&gt;node(3),</span>
<a name="l02171"></a>02171 <span class="comment">//                                                                  std::min(elem-&gt;node(7),</span>
<a name="l02172"></a>02172 <span class="comment">//                                                                           elem-&gt;node(6))));</span>
<a name="l02173"></a>02173 <span class="comment">//                  if (elem-&gt;node(3) == min_node)</span>
<a name="l02174"></a>02174 <span class="comment">//                    if (elem-&gt;node(2) == std::min(elem-&gt;node(2), elem-&gt;node(7)))</span>
<a name="l02175"></a>02175 <span class="comment">//                      {</span>
<a name="l02176"></a>02176 <span class="comment">//                        // Case 1</span>
<a name="l02177"></a>02177 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02178"></a>02178 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02179"></a>02179 <span class="comment">//                      }</span>
<a name="l02180"></a>02180 <span class="comment">//                    else</span>
<a name="l02181"></a>02181 <span class="comment">//                      {</span>
<a name="l02182"></a>02182 <span class="comment">//                        // Case 2</span>
<a name="l02183"></a>02183 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02184"></a>02184 <span class="comment">//                        zeta_mapped = xi;</span>
<a name="l02185"></a>02185 <span class="comment">//                      }</span>
<a name="l02186"></a>02186 
<a name="l02187"></a>02187 <span class="comment">//                  else if (elem-&gt;node(7) == min_node)</span>
<a name="l02188"></a>02188 <span class="comment">//                    if (elem-&gt;node(3) == std::min(elem-&gt;node(3), elem-&gt;node(6)))</span>
<a name="l02189"></a>02189 <span class="comment">//                      {</span>
<a name="l02190"></a>02190 <span class="comment">//                        // Case 3</span>
<a name="l02191"></a>02191 <span class="comment">//                        xi_mapped   = -zeta;</span>
<a name="l02192"></a>02192 <span class="comment">//                        zeta_mapped = xi;</span>
<a name="l02193"></a>02193 <span class="comment">//                      }</span>
<a name="l02194"></a>02194 <span class="comment">//                    else</span>
<a name="l02195"></a>02195 <span class="comment">//                      {</span>
<a name="l02196"></a>02196 <span class="comment">//                        // Case 4</span>
<a name="l02197"></a>02197 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02198"></a>02198 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02199"></a>02199 <span class="comment">//                      }</span>
<a name="l02200"></a>02200 
<a name="l02201"></a>02201 <span class="comment">//                  else if (elem-&gt;node(6) == min_node)</span>
<a name="l02202"></a>02202 <span class="comment">//                    if (elem-&gt;node(7) == std::min(elem-&gt;node(7), elem-&gt;node(2)))</span>
<a name="l02203"></a>02203 <span class="comment">//                      {</span>
<a name="l02204"></a>02204 <span class="comment">//                        // Case 5</span>
<a name="l02205"></a>02205 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02206"></a>02206 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02207"></a>02207 <span class="comment">//                      }</span>
<a name="l02208"></a>02208 <span class="comment">//                    else</span>
<a name="l02209"></a>02209 <span class="comment">//                      {</span>
<a name="l02210"></a>02210 <span class="comment">//                        // Case 6</span>
<a name="l02211"></a>02211 <span class="comment">//                        xi_mapped   = -zeta;</span>
<a name="l02212"></a>02212 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02213"></a>02213 <span class="comment">//                      }</span>
<a name="l02214"></a>02214 
<a name="l02215"></a>02215 <span class="comment">//                  else if (elem-&gt;node(2) == min_node)</span>
<a name="l02216"></a>02216 <span class="comment">//                    if (elem-&gt;node(6) == std::min(elem-&gt;node(3), elem-&gt;node(6)))</span>
<a name="l02217"></a>02217 <span class="comment">//                      {</span>
<a name="l02218"></a>02218 <span class="comment">//                        // Case 7</span>
<a name="l02219"></a>02219 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02220"></a>02220 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02221"></a>02221 <span class="comment">//                      }</span>
<a name="l02222"></a>02222 <span class="comment">//                    else</span>
<a name="l02223"></a>02223 <span class="comment">//                      {</span>
<a name="l02224"></a>02224 <span class="comment">//                        // Case 8</span>
<a name="l02225"></a>02225 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02226"></a>02226 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02227"></a>02227 <span class="comment">//                      }</span>
<a name="l02228"></a>02228 <span class="comment">//                }</span>
<a name="l02229"></a>02229 
<a name="l02230"></a>02230                 
<a name="l02231"></a>02231 <span class="comment">//              // Face 4</span>
<a name="l02232"></a>02232 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02233"></a>02233 <span class="comment">//                {</span>
<a name="l02234"></a>02234 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(3),</span>
<a name="l02235"></a>02235 <span class="comment">//                                                         std::min(elem-&gt;node(0),</span>
<a name="l02236"></a>02236 <span class="comment">//                                                                  std::min(elem-&gt;node(4),</span>
<a name="l02237"></a>02237 <span class="comment">//                                                                           elem-&gt;node(7))));</span>
<a name="l02238"></a>02238 <span class="comment">//                  if (elem-&gt;node(0) == min_node)</span>
<a name="l02239"></a>02239 <span class="comment">//                    if (elem-&gt;node(3) == std::min(elem-&gt;node(3), elem-&gt;node(4)))</span>
<a name="l02240"></a>02240 <span class="comment">//                      {</span>
<a name="l02241"></a>02241 <span class="comment">//                        // Case 1</span>
<a name="l02242"></a>02242 <span class="comment">//                        eta_mapped  = eta;</span>
<a name="l02243"></a>02243 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02244"></a>02244 <span class="comment">//                      }</span>
<a name="l02245"></a>02245 <span class="comment">//                    else</span>
<a name="l02246"></a>02246 <span class="comment">//                      {</span>
<a name="l02247"></a>02247 <span class="comment">//                        // Case 2</span>
<a name="l02248"></a>02248 <span class="comment">//                        eta_mapped  = zeta;</span>
<a name="l02249"></a>02249 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02250"></a>02250 <span class="comment">//                      }</span>
<a name="l02251"></a>02251 
<a name="l02252"></a>02252 <span class="comment">//                  else if (elem-&gt;node(4) == min_node)</span>
<a name="l02253"></a>02253 <span class="comment">//                    if (elem-&gt;node(0) == std::min(elem-&gt;node(0), elem-&gt;node(7)))</span>
<a name="l02254"></a>02254 <span class="comment">//                      {</span>
<a name="l02255"></a>02255 <span class="comment">//                        // Case 3</span>
<a name="l02256"></a>02256 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02257"></a>02257 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02258"></a>02258 <span class="comment">//                      }</span>
<a name="l02259"></a>02259 <span class="comment">//                    else</span>
<a name="l02260"></a>02260 <span class="comment">//                      {</span>
<a name="l02261"></a>02261 <span class="comment">//                        // Case 4</span>
<a name="l02262"></a>02262 <span class="comment">//                        eta_mapped  = eta;</span>
<a name="l02263"></a>02263 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02264"></a>02264 <span class="comment">//                      }</span>
<a name="l02265"></a>02265 
<a name="l02266"></a>02266 <span class="comment">//                  else if (elem-&gt;node(7) == min_node)</span>
<a name="l02267"></a>02267 <span class="comment">//                    if (elem-&gt;node(4) == std::min(elem-&gt;node(4), elem-&gt;node(3)))</span>
<a name="l02268"></a>02268 <span class="comment">//                      {</span>
<a name="l02269"></a>02269 <span class="comment">//                        // Case 5</span>
<a name="l02270"></a>02270 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02271"></a>02271 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02272"></a>02272 <span class="comment">//                      }</span>
<a name="l02273"></a>02273 <span class="comment">//                    else</span>
<a name="l02274"></a>02274 <span class="comment">//                      {</span>
<a name="l02275"></a>02275 <span class="comment">//                        // Case 6</span>
<a name="l02276"></a>02276 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02277"></a>02277 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02278"></a>02278 <span class="comment">//                      }</span>
<a name="l02279"></a>02279 
<a name="l02280"></a>02280 <span class="comment">//                  else if (elem-&gt;node(3) == min_node)</span>
<a name="l02281"></a>02281 <span class="comment">//                    if (elem-&gt;node(7) == std::min(elem-&gt;node(7), elem-&gt;node(0)))</span>
<a name="l02282"></a>02282 <span class="comment">//                      {</span>
<a name="l02283"></a>02283 <span class="comment">//                        // Case 7</span>
<a name="l02284"></a>02284 <span class="comment">//                        eta_mapped   = zeta;</span>
<a name="l02285"></a>02285 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02286"></a>02286 <span class="comment">//                      }</span>
<a name="l02287"></a>02287 <span class="comment">//                    else</span>
<a name="l02288"></a>02288 <span class="comment">//                      {</span>
<a name="l02289"></a>02289 <span class="comment">//                        // Case 8</span>
<a name="l02290"></a>02290 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02291"></a>02291 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02292"></a>02292 <span class="comment">//                      }</span>
<a name="l02293"></a>02293 <span class="comment">//                }</span>
<a name="l02294"></a>02294 
<a name="l02295"></a>02295                 
<a name="l02296"></a>02296 <span class="comment">//              // Face 5</span>
<a name="l02297"></a>02297 <span class="comment">//              else if ((i2[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))</span>
<a name="l02298"></a>02298 <span class="comment">//                {</span>
<a name="l02299"></a>02299 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(4),</span>
<a name="l02300"></a>02300 <span class="comment">//                                                         std::min(elem-&gt;node(5),</span>
<a name="l02301"></a>02301 <span class="comment">//                                                                  std::min(elem-&gt;node(6),</span>
<a name="l02302"></a>02302 <span class="comment">//                                                                           elem-&gt;node(7))));</span>
<a name="l02303"></a>02303 <span class="comment">//                  if (elem-&gt;node(4) == min_node)</span>
<a name="l02304"></a>02304 <span class="comment">//                    if (elem-&gt;node(5) == std::min(elem-&gt;node(5), elem-&gt;node(7)))</span>
<a name="l02305"></a>02305 <span class="comment">//                      {</span>
<a name="l02306"></a>02306 <span class="comment">//                        // Case 1</span>
<a name="l02307"></a>02307 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02308"></a>02308 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02309"></a>02309 <span class="comment">//                      }</span>
<a name="l02310"></a>02310 <span class="comment">//                    else</span>
<a name="l02311"></a>02311 <span class="comment">//                      {</span>
<a name="l02312"></a>02312 <span class="comment">//                        // Case 2</span>
<a name="l02313"></a>02313 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02314"></a>02314 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l02315"></a>02315 <span class="comment">//                      }</span>
<a name="l02316"></a>02316 
<a name="l02317"></a>02317 <span class="comment">//                  else if (elem-&gt;node(5) == min_node)</span>
<a name="l02318"></a>02318 <span class="comment">//                    if (elem-&gt;node(6) == std::min(elem-&gt;node(6), elem-&gt;node(4)))</span>
<a name="l02319"></a>02319 <span class="comment">//                      {</span>
<a name="l02320"></a>02320 <span class="comment">//                        // Case 3</span>
<a name="l02321"></a>02321 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02322"></a>02322 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02323"></a>02323 <span class="comment">//                      }</span>
<a name="l02324"></a>02324 <span class="comment">//                    else</span>
<a name="l02325"></a>02325 <span class="comment">//                      {</span>
<a name="l02326"></a>02326 <span class="comment">//                        // Case 4</span>
<a name="l02327"></a>02327 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02328"></a>02328 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02329"></a>02329 <span class="comment">//                      }</span>
<a name="l02330"></a>02330 
<a name="l02331"></a>02331 <span class="comment">//                  else if (elem-&gt;node(6) == min_node)</span>
<a name="l02332"></a>02332 <span class="comment">//                    if (elem-&gt;node(7) == std::min(elem-&gt;node(7), elem-&gt;node(5)))</span>
<a name="l02333"></a>02333 <span class="comment">//                      {</span>
<a name="l02334"></a>02334 <span class="comment">//                        // Case 5</span>
<a name="l02335"></a>02335 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02336"></a>02336 <span class="comment">//                        eta_mapped = -eta;</span>
<a name="l02337"></a>02337 <span class="comment">//                      }</span>
<a name="l02338"></a>02338 <span class="comment">//                    else</span>
<a name="l02339"></a>02339 <span class="comment">//                      {</span>
<a name="l02340"></a>02340 <span class="comment">//                        // Case 6</span>
<a name="l02341"></a>02341 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02342"></a>02342 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02343"></a>02343 <span class="comment">//                      }</span>
<a name="l02344"></a>02344 
<a name="l02345"></a>02345 <span class="comment">//                  else if (elem-&gt;node(7) == min_node)</span>
<a name="l02346"></a>02346 <span class="comment">//                    if (elem-&gt;node(4) == std::min(elem-&gt;node(4), elem-&gt;node(6)))</span>
<a name="l02347"></a>02347 <span class="comment">//                      {</span>
<a name="l02348"></a>02348 <span class="comment">//                        // Case 7</span>
<a name="l02349"></a>02349 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02350"></a>02350 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l02351"></a>02351 <span class="comment">//                      }</span>
<a name="l02352"></a>02352 <span class="comment">//                    else</span>
<a name="l02353"></a>02353 <span class="comment">//                      {</span>
<a name="l02354"></a>02354 <span class="comment">//                        // Case 8</span>
<a name="l02355"></a>02355 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02356"></a>02356 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02357"></a>02357 <span class="comment">//                      }</span>
<a name="l02358"></a>02358 <span class="comment">//                }</span>
<a name="l02359"></a>02359 
<a name="l02360"></a>02360                 
<a name="l02361"></a>02361 <span class="comment">//            }</span>
<a name="l02362"></a>02362                   
<a name="l02363"></a>02363               
<a name="l02364"></a>02364 
<a name="l02365"></a>02365 <span class="comment">//            libmesh_assert (j &lt; 3);</span>
<a name="l02366"></a>02366 
<a name="l02367"></a>02367 <span class="comment">//            switch (j)</span>
<a name="l02368"></a>02368 <span class="comment">//              {</span>
<a name="l02369"></a>02369 <span class="comment">//                // d()/dxi</span>
<a name="l02370"></a>02370 <span class="comment">//              case 0:</span>
<a name="l02371"></a>02371 <span class="comment">//                return (FE&lt;1,BERNSTEIN&gt;::shape_deriv(EDGE3, totalorder, i0[i], 0, xi_mapped)*</span>
<a name="l02372"></a>02372 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i1[i],    eta_mapped)*</span>
<a name="l02373"></a>02373 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i2[i],    zeta_mapped));</span>
<a name="l02374"></a>02374 
<a name="l02375"></a>02375 <span class="comment">//                // d()/deta</span>
<a name="l02376"></a>02376 <span class="comment">//              case 1:</span>
<a name="l02377"></a>02377 <span class="comment">//                return (FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i0[i],    xi_mapped)*</span>
<a name="l02378"></a>02378 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape_deriv(EDGE3, totalorder, i1[i], 0, eta_mapped)*</span>
<a name="l02379"></a>02379 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i2[i],    zeta_mapped));</span>
<a name="l02380"></a>02380 
<a name="l02381"></a>02381 <span class="comment">//                // d()/dzeta</span>
<a name="l02382"></a>02382 <span class="comment">//              case 2:</span>
<a name="l02383"></a>02383 <span class="comment">//                return (FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i0[i],    xi_mapped)*</span>
<a name="l02384"></a>02384 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i1[i],    eta_mapped)*</span>
<a name="l02385"></a>02385 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape_deriv(EDGE3, totalorder, i2[i], 0, zeta_mapped));</span>
<a name="l02386"></a>02386 
<a name="l02387"></a>02387 <span class="comment">//              default:</span>
<a name="l02388"></a>02388 <span class="comment">//                libmesh_error();</span>
<a name="l02389"></a>02389 <span class="comment">//              }</span>
<a name="l02390"></a>02390 <span class="comment">//          }</span>
<a name="l02391"></a>02391 
<a name="l02392"></a>02392             
<a name="l02393"></a>02393           <span class="keywordflow">default</span>:
<a name="l02394"></a>02394             libmesh_error();
<a name="l02395"></a>02395           }
<a name="l02396"></a>02396       }
<a name="l02397"></a>02397 
<a name="l02398"></a>02398       <span class="comment">// 4th-order Bernstein.</span>
<a name="l02399"></a>02399     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l02400"></a>02400       {
<a name="l02401"></a>02401         <span class="keywordflow">switch</span> (type)
<a name="l02402"></a>02402           {
<a name="l02403"></a>02403 
<a name="l02404"></a>02404             <span class="comment">// Bernstein shape functions derivatives on the hexahedral.</span>
<a name="l02405"></a>02405           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02406"></a>02406             {
<a name="l02407"></a>02407               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = 1.e-6;
<a name="l02408"></a>02408               
<a name="l02409"></a>02409               libmesh_assert (i &lt; 125);
<a name="l02410"></a>02410               libmesh_assert (j &lt; 3);    
<a name="l02411"></a>02411               
<a name="l02412"></a>02412               <span class="keywordflow">switch</span> (j)
<a name="l02413"></a>02413                 {
<a name="l02414"></a>02414                   <span class="comment">//  d()/dxi</span>
<a name="l02415"></a>02415                 <span class="keywordflow">case</span> 0:
<a name="l02416"></a>02416                   {
<a name="l02417"></a>02417                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0)+eps, p(1), p(2));
<a name="l02418"></a>02418                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0)-eps, p(1), p(2));
<a name="l02419"></a>02419                     
<a name="l02420"></a>02420                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l02421"></a>02421                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l02422"></a>02422                   }
<a name="l02423"></a>02423                   
<a name="l02424"></a>02424                   <span class="comment">// d()/deta</span>
<a name="l02425"></a>02425                 <span class="keywordflow">case</span> 1:
<a name="l02426"></a>02426                   {
<a name="l02427"></a>02427                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1)+eps, p(2));
<a name="l02428"></a>02428                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1)-eps, p(2));
<a name="l02429"></a>02429                     
<a name="l02430"></a>02430                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l02431"></a>02431                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l02432"></a>02432                   }
<a name="l02433"></a>02433                   <span class="comment">// d()/dzeta</span>
<a name="l02434"></a>02434                 <span class="keywordflow">case</span> 2:
<a name="l02435"></a>02435                   {
<a name="l02436"></a>02436                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp(p(0), p(1), p(2)+eps);
<a name="l02437"></a>02437                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> pm(p(0), p(1), p(2)-eps);
<a name="l02438"></a>02438                     
<a name="l02439"></a>02439                     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pp) -
<a name="l02440"></a>02440                             <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l02441"></a>02441                   }                 
<a name="l02442"></a>02442                 <span class="keywordflow">default</span>:
<a name="l02443"></a>02443                   libmesh_error();
<a name="l02444"></a>02444                 }
<a name="l02445"></a>02445             }         
<a name="l02446"></a>02446 
<a name="l02447"></a>02447 <span class="comment">//            // Compute hex shape functions as a tensor-product</span>
<a name="l02448"></a>02448 <span class="comment">//            const Real xi    = p(0);</span>
<a name="l02449"></a>02449 <span class="comment">//            const Real eta   = p(1);</span>
<a name="l02450"></a>02450 <span class="comment">//            const Real zeta  = p(2);</span>
<a name="l02451"></a>02451 <span class="comment">//            Real xi_mapped   = p(0);</span>
<a name="l02452"></a>02452 <span class="comment">//            Real eta_mapped  = p(1);</span>
<a name="l02453"></a>02453 <span class="comment">//            Real zeta_mapped = p(2);</span>
<a name="l02454"></a>02454         
<a name="l02455"></a>02455 <span class="comment">//            // The only way to make any sense of this</span>
<a name="l02456"></a>02456 <span class="comment">//            // is to look at the mgflo/mg2/mgf documentation</span>
<a name="l02457"></a>02457 <span class="comment">//            // and make the cut-out cube!</span>
<a name="l02458"></a>02458 <span class="comment">//            //  Nodes                         0  1  2  3  4  5  6  7  8  8  9  9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 20 20 21 21 21 21 22 22 22 22 23 23 23 23 24 24 24 24 25 25 25 25 26 26 26 26 26 26 26 26  </span>
<a name="l02459"></a>02459 <span class="comment">//            //  DOFS                          0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 18 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 60 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24</span>
<a name="l02460"></a>02460 <span class="comment">//            static const unsigned int i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 2, 3, 4, 2, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4};</span>
<a name="l02461"></a>02461 <span class="comment">//            static const unsigned int i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 2, 3, 4, 1, 1, 1, 2, 3, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4};</span>
<a name="l02462"></a>02462 <span class="comment">//            static const unsigned int i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 2, 3, 4, 2, 3, 4, 2, 3, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 2, 2, 2, 3, 3, 3, 4, 4, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4};</span>
<a name="l02463"></a>02463 
<a name="l02464"></a>02464 
<a name="l02465"></a>02465 
<a name="l02466"></a>02466 <span class="comment">//            // handle the edge orientation</span>
<a name="l02467"></a>02467 <span class="comment">//            {</span>
<a name="l02468"></a>02468 <span class="comment">//              // Edge 0</span>
<a name="l02469"></a>02469 <span class="comment">//              if ((i1[i] == 0) &amp;&amp; (i2[i] == 0))</span>
<a name="l02470"></a>02470 <span class="comment">//                {</span>
<a name="l02471"></a>02471 <span class="comment">//                  if (elem-&gt;node(0) != std::min(elem-&gt;node(0), elem-&gt;node(1)))</span>
<a name="l02472"></a>02472 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l02473"></a>02473 <span class="comment">//                }</span>
<a name="l02474"></a>02474 <span class="comment">//              // Edge 1</span>
<a name="l02475"></a>02475 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i2[i] == 0))</span>
<a name="l02476"></a>02476 <span class="comment">//                {</span>
<a name="l02477"></a>02477 <span class="comment">//                  if (elem-&gt;node(1) != std::min(elem-&gt;node(1), elem-&gt;node(2)))</span>
<a name="l02478"></a>02478 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l02479"></a>02479 <span class="comment">//                }</span>
<a name="l02480"></a>02480 <span class="comment">//              // Edge 2</span>
<a name="l02481"></a>02481 <span class="comment">//              else if ((i1[i] == 1) &amp;&amp; (i2[i] == 0))</span>
<a name="l02482"></a>02482 <span class="comment">//                {</span>
<a name="l02483"></a>02483 <span class="comment">//                  if (elem-&gt;node(3) != std::min(elem-&gt;node(3), elem-&gt;node(2)))</span>
<a name="l02484"></a>02484 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l02485"></a>02485 <span class="comment">//                }</span>
<a name="l02486"></a>02486 <span class="comment">//              // Edge 3</span>
<a name="l02487"></a>02487 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i2[i] == 0))</span>
<a name="l02488"></a>02488 <span class="comment">//                {</span>
<a name="l02489"></a>02489 <span class="comment">//                  if (elem-&gt;node(0) != std::min(elem-&gt;node(0), elem-&gt;node(3)))</span>
<a name="l02490"></a>02490 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l02491"></a>02491 <span class="comment">//                }</span>
<a name="l02492"></a>02492 <span class="comment">//              // Edge 4</span>
<a name="l02493"></a>02493 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i1[i] == 0))</span>
<a name="l02494"></a>02494 <span class="comment">//                {</span>
<a name="l02495"></a>02495 <span class="comment">//                  if (elem-&gt;node(0) != std::min(elem-&gt;node(0), elem-&gt;node(4)))</span>
<a name="l02496"></a>02496 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l02497"></a>02497 <span class="comment">//                }             </span>
<a name="l02498"></a>02498 <span class="comment">//              // Edge 5</span>
<a name="l02499"></a>02499 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i1[i] == 0))</span>
<a name="l02500"></a>02500 <span class="comment">//                {</span>
<a name="l02501"></a>02501 <span class="comment">//                  if (elem-&gt;node(1) != std::min(elem-&gt;node(1), elem-&gt;node(5)))</span>
<a name="l02502"></a>02502 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l02503"></a>02503 <span class="comment">//                }             </span>
<a name="l02504"></a>02504 <span class="comment">//              // Edge 6</span>
<a name="l02505"></a>02505 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i1[i] == 1))</span>
<a name="l02506"></a>02506 <span class="comment">//                {</span>
<a name="l02507"></a>02507 <span class="comment">//                  if (elem-&gt;node(2) != std::min(elem-&gt;node(2), elem-&gt;node(6)))</span>
<a name="l02508"></a>02508 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l02509"></a>02509 <span class="comment">//                }</span>
<a name="l02510"></a>02510 <span class="comment">//              // Edge 7</span>
<a name="l02511"></a>02511 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i1[i] == 1))</span>
<a name="l02512"></a>02512 <span class="comment">//                {</span>
<a name="l02513"></a>02513 <span class="comment">//                  if (elem-&gt;node(3) != std::min(elem-&gt;node(3), elem-&gt;node(7)))</span>
<a name="l02514"></a>02514 <span class="comment">//                    zeta_mapped = -zeta;</span>
<a name="l02515"></a>02515 <span class="comment">//                }             </span>
<a name="l02516"></a>02516 <span class="comment">//              // Edge 8</span>
<a name="l02517"></a>02517 <span class="comment">//              else if ((i1[i] == 0) &amp;&amp; (i2[i] == 1))</span>
<a name="l02518"></a>02518 <span class="comment">//                {</span>
<a name="l02519"></a>02519 <span class="comment">//                  if (elem-&gt;node(4) != std::min(elem-&gt;node(4), elem-&gt;node(5)))</span>
<a name="l02520"></a>02520 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l02521"></a>02521 <span class="comment">//                }</span>
<a name="l02522"></a>02522 <span class="comment">//              // Edge 9</span>
<a name="l02523"></a>02523 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i2[i] == 1))</span>
<a name="l02524"></a>02524 <span class="comment">//                {</span>
<a name="l02525"></a>02525 <span class="comment">//                  if (elem-&gt;node(5) != std::min(elem-&gt;node(5), elem-&gt;node(6)))</span>
<a name="l02526"></a>02526 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l02527"></a>02527 <span class="comment">//                }             </span>
<a name="l02528"></a>02528 <span class="comment">//              // Edge 10</span>
<a name="l02529"></a>02529 <span class="comment">//              else if ((i1[i] == 1) &amp;&amp; (i2[i] == 1))</span>
<a name="l02530"></a>02530 <span class="comment">//                {</span>
<a name="l02531"></a>02531 <span class="comment">//                  if (elem-&gt;node(7) != std::min(elem-&gt;node(7), elem-&gt;node(6)))</span>
<a name="l02532"></a>02532 <span class="comment">//                    xi_mapped = -xi;</span>
<a name="l02533"></a>02533 <span class="comment">//                }</span>
<a name="l02534"></a>02534 <span class="comment">//              // Edge 11</span>
<a name="l02535"></a>02535 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i2[i] == 1))</span>
<a name="l02536"></a>02536 <span class="comment">//                {</span>
<a name="l02537"></a>02537 <span class="comment">//                  if (elem-&gt;node(4) != std::min(elem-&gt;node(4), elem-&gt;node(7)))</span>
<a name="l02538"></a>02538 <span class="comment">//                    eta_mapped = -eta;</span>
<a name="l02539"></a>02539 <span class="comment">//                }</span>
<a name="l02540"></a>02540 <span class="comment">//            }</span>
<a name="l02541"></a>02541 
<a name="l02542"></a>02542 
<a name="l02543"></a>02543 <span class="comment">//            // handle the face orientation</span>
<a name="l02544"></a>02544 <span class="comment">//            {</span>
<a name="l02545"></a>02545 <span class="comment">//              // Face 0</span>
<a name="l02546"></a>02546 <span class="comment">//              if (     (i2[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))</span>
<a name="l02547"></a>02547 <span class="comment">//                {</span>
<a name="l02548"></a>02548 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(1),</span>
<a name="l02549"></a>02549 <span class="comment">//                                                         std::min(elem-&gt;node(2),</span>
<a name="l02550"></a>02550 <span class="comment">//                                                                  std::min(elem-&gt;node(0),</span>
<a name="l02551"></a>02551 <span class="comment">//                                                                           elem-&gt;node(3))));</span>
<a name="l02552"></a>02552 <span class="comment">//                  if (elem-&gt;node(0) == min_node)</span>
<a name="l02553"></a>02553 <span class="comment">//                    if (elem-&gt;node(1) == std::min(elem-&gt;node(1), elem-&gt;node(3)))</span>
<a name="l02554"></a>02554 <span class="comment">//                      {</span>
<a name="l02555"></a>02555 <span class="comment">//                        // Case 1</span>
<a name="l02556"></a>02556 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02557"></a>02557 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02558"></a>02558 <span class="comment">//                      }</span>
<a name="l02559"></a>02559 <span class="comment">//                    else</span>
<a name="l02560"></a>02560 <span class="comment">//                      {</span>
<a name="l02561"></a>02561 <span class="comment">//                        // Case 2</span>
<a name="l02562"></a>02562 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02563"></a>02563 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l02564"></a>02564 <span class="comment">//                      }</span>
<a name="l02565"></a>02565 
<a name="l02566"></a>02566 <span class="comment">//                  else if (elem-&gt;node(3) == min_node)</span>
<a name="l02567"></a>02567 <span class="comment">//                    if (elem-&gt;node(0) == std::min(elem-&gt;node(0), elem-&gt;node(2)))</span>
<a name="l02568"></a>02568 <span class="comment">//                      {</span>
<a name="l02569"></a>02569 <span class="comment">//                        // Case 3</span>
<a name="l02570"></a>02570 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02571"></a>02571 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l02572"></a>02572 <span class="comment">//                      }</span>
<a name="l02573"></a>02573 <span class="comment">//                    else</span>
<a name="l02574"></a>02574 <span class="comment">//                      {</span>
<a name="l02575"></a>02575 <span class="comment">//                        // Case 4</span>
<a name="l02576"></a>02576 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02577"></a>02577 <span class="comment">//                        eta_mapped = -eta;</span>
<a name="l02578"></a>02578 <span class="comment">//                      }</span>
<a name="l02579"></a>02579 
<a name="l02580"></a>02580 <span class="comment">//                  else if (elem-&gt;node(2) == min_node)</span>
<a name="l02581"></a>02581 <span class="comment">//                    if (elem-&gt;node(3) == std::min(elem-&gt;node(3), elem-&gt;node(1)))</span>
<a name="l02582"></a>02582 <span class="comment">//                      {</span>
<a name="l02583"></a>02583 <span class="comment">//                        // Case 5</span>
<a name="l02584"></a>02584 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02585"></a>02585 <span class="comment">//                        eta_mapped = -eta;</span>
<a name="l02586"></a>02586 <span class="comment">//                      }</span>
<a name="l02587"></a>02587 <span class="comment">//                    else</span>
<a name="l02588"></a>02588 <span class="comment">//                      {</span>
<a name="l02589"></a>02589 <span class="comment">//                        // Case 6</span>
<a name="l02590"></a>02590 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02591"></a>02591 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02592"></a>02592 <span class="comment">//                      }</span>
<a name="l02593"></a>02593 
<a name="l02594"></a>02594 <span class="comment">//                  else if (elem-&gt;node(1) == min_node)</span>
<a name="l02595"></a>02595 <span class="comment">//                    if (elem-&gt;node(2) == std::min(elem-&gt;node(2), elem-&gt;node(0)))</span>
<a name="l02596"></a>02596 <span class="comment">//                      {</span>
<a name="l02597"></a>02597 <span class="comment">//                        // Case 7</span>
<a name="l02598"></a>02598 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02599"></a>02599 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02600"></a>02600 <span class="comment">//                      }</span>
<a name="l02601"></a>02601 <span class="comment">//                    else</span>
<a name="l02602"></a>02602 <span class="comment">//                      {</span>
<a name="l02603"></a>02603 <span class="comment">//                        // Case 8</span>
<a name="l02604"></a>02604 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02605"></a>02605 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02606"></a>02606 <span class="comment">//                      }</span>
<a name="l02607"></a>02607 <span class="comment">//                }</span>
<a name="l02608"></a>02608 
<a name="l02609"></a>02609                 
<a name="l02610"></a>02610 <span class="comment">//              // Face 1</span>
<a name="l02611"></a>02611 <span class="comment">//              else if ((i1[i] == 0) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02612"></a>02612 <span class="comment">//                {</span>
<a name="l02613"></a>02613 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(0),</span>
<a name="l02614"></a>02614 <span class="comment">//                                                         std::min(elem-&gt;node(1),</span>
<a name="l02615"></a>02615 <span class="comment">//                                                                  std::min(elem-&gt;node(5),</span>
<a name="l02616"></a>02616 <span class="comment">//                                                                           elem-&gt;node(4))));</span>
<a name="l02617"></a>02617 <span class="comment">//                  if (elem-&gt;node(0) == min_node)</span>
<a name="l02618"></a>02618 <span class="comment">//                    if (elem-&gt;node(1) == std::min(elem-&gt;node(1), elem-&gt;node(4)))</span>
<a name="l02619"></a>02619 <span class="comment">//                      {</span>
<a name="l02620"></a>02620 <span class="comment">//                        // Case 1</span>
<a name="l02621"></a>02621 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02622"></a>02622 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02623"></a>02623 <span class="comment">//                      }</span>
<a name="l02624"></a>02624 <span class="comment">//                    else</span>
<a name="l02625"></a>02625 <span class="comment">//                      {</span>
<a name="l02626"></a>02626 <span class="comment">//                        // Case 2</span>
<a name="l02627"></a>02627 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02628"></a>02628 <span class="comment">//                        zeta_mapped = xi;</span>
<a name="l02629"></a>02629 <span class="comment">//                      }</span>
<a name="l02630"></a>02630 
<a name="l02631"></a>02631 <span class="comment">//                  else if (elem-&gt;node(1) == min_node)</span>
<a name="l02632"></a>02632 <span class="comment">//                    if (elem-&gt;node(5) == std::min(elem-&gt;node(5), elem-&gt;node(0)))</span>
<a name="l02633"></a>02633 <span class="comment">//                      {</span>
<a name="l02634"></a>02634 <span class="comment">//                        // Case 3</span>
<a name="l02635"></a>02635 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02636"></a>02636 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02637"></a>02637 <span class="comment">//                      }</span>
<a name="l02638"></a>02638 <span class="comment">//                    else</span>
<a name="l02639"></a>02639 <span class="comment">//                      {</span>
<a name="l02640"></a>02640 <span class="comment">//                        // Case 4</span>
<a name="l02641"></a>02641 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02642"></a>02642 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02643"></a>02643 <span class="comment">//                      }</span>
<a name="l02644"></a>02644 
<a name="l02645"></a>02645 <span class="comment">//                  else if (elem-&gt;node(5) == min_node)</span>
<a name="l02646"></a>02646 <span class="comment">//                    if (elem-&gt;node(4) == std::min(elem-&gt;node(4), elem-&gt;node(1)))</span>
<a name="l02647"></a>02647 <span class="comment">//                      {</span>
<a name="l02648"></a>02648 <span class="comment">//                        // Case 5</span>
<a name="l02649"></a>02649 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02650"></a>02650 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02651"></a>02651 <span class="comment">//                      }</span>
<a name="l02652"></a>02652 <span class="comment">//                    else</span>
<a name="l02653"></a>02653 <span class="comment">//                      {</span>
<a name="l02654"></a>02654 <span class="comment">//                        // Case 6</span>
<a name="l02655"></a>02655 <span class="comment">//                        xi_mapped   = -zeta;</span>
<a name="l02656"></a>02656 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02657"></a>02657 <span class="comment">//                      }</span>
<a name="l02658"></a>02658 
<a name="l02659"></a>02659 <span class="comment">//                  else if (elem-&gt;node(4) == min_node)</span>
<a name="l02660"></a>02660 <span class="comment">//                    if (elem-&gt;node(0) == std::min(elem-&gt;node(0), elem-&gt;node(5)))</span>
<a name="l02661"></a>02661 <span class="comment">//                      {</span>
<a name="l02662"></a>02662 <span class="comment">//                        // Case 7</span>
<a name="l02663"></a>02663 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02664"></a>02664 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02665"></a>02665 <span class="comment">//                      }</span>
<a name="l02666"></a>02666 <span class="comment">//                    else</span>
<a name="l02667"></a>02667 <span class="comment">//                      {</span>
<a name="l02668"></a>02668 <span class="comment">//                        // Case 8</span>
<a name="l02669"></a>02669 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02670"></a>02670 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02671"></a>02671 <span class="comment">//                      }</span>
<a name="l02672"></a>02672 <span class="comment">//                }</span>
<a name="l02673"></a>02673 
<a name="l02674"></a>02674                 
<a name="l02675"></a>02675 <span class="comment">//              // Face 2</span>
<a name="l02676"></a>02676 <span class="comment">//              else if ((i0[i] == 1) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02677"></a>02677 <span class="comment">//                {</span>
<a name="l02678"></a>02678 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(1),</span>
<a name="l02679"></a>02679 <span class="comment">//                                                         std::min(elem-&gt;node(2),</span>
<a name="l02680"></a>02680 <span class="comment">//                                                                  std::min(elem-&gt;node(6),</span>
<a name="l02681"></a>02681 <span class="comment">//                                                                           elem-&gt;node(5))));</span>
<a name="l02682"></a>02682 <span class="comment">//                  if (elem-&gt;node(1) == min_node)</span>
<a name="l02683"></a>02683 <span class="comment">//                    if (elem-&gt;node(2) == std::min(elem-&gt;node(2), elem-&gt;node(5)))</span>
<a name="l02684"></a>02684 <span class="comment">//                      {</span>
<a name="l02685"></a>02685 <span class="comment">//                        // Case 1</span>
<a name="l02686"></a>02686 <span class="comment">//                        eta_mapped  = eta;</span>
<a name="l02687"></a>02687 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02688"></a>02688 <span class="comment">//                      }</span>
<a name="l02689"></a>02689 <span class="comment">//                    else</span>
<a name="l02690"></a>02690 <span class="comment">//                      {</span>
<a name="l02691"></a>02691 <span class="comment">//                        // Case 2</span>
<a name="l02692"></a>02692 <span class="comment">//                        eta_mapped  = zeta;</span>
<a name="l02693"></a>02693 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02694"></a>02694 <span class="comment">//                      }</span>
<a name="l02695"></a>02695 
<a name="l02696"></a>02696 <span class="comment">//                  else if (elem-&gt;node(2) == min_node)</span>
<a name="l02697"></a>02697 <span class="comment">//                    if (elem-&gt;node(6) == std::min(elem-&gt;node(6), elem-&gt;node(1)))</span>
<a name="l02698"></a>02698 <span class="comment">//                      {</span>
<a name="l02699"></a>02699 <span class="comment">//                        // Case 3</span>
<a name="l02700"></a>02700 <span class="comment">//                        eta_mapped  = zeta;</span>
<a name="l02701"></a>02701 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02702"></a>02702 <span class="comment">//                      }</span>
<a name="l02703"></a>02703 <span class="comment">//                    else</span>
<a name="l02704"></a>02704 <span class="comment">//                      {</span>
<a name="l02705"></a>02705 <span class="comment">//                        // Case 4</span>
<a name="l02706"></a>02706 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02707"></a>02707 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02708"></a>02708 <span class="comment">//                      }</span>
<a name="l02709"></a>02709 
<a name="l02710"></a>02710 <span class="comment">//                  else if (elem-&gt;node(6) == min_node)</span>
<a name="l02711"></a>02711 <span class="comment">//                    if (elem-&gt;node(5) == std::min(elem-&gt;node(5), elem-&gt;node(2)))</span>
<a name="l02712"></a>02712 <span class="comment">//                      {</span>
<a name="l02713"></a>02713 <span class="comment">//                        // Case 5</span>
<a name="l02714"></a>02714 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02715"></a>02715 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02716"></a>02716 <span class="comment">//                      }</span>
<a name="l02717"></a>02717 <span class="comment">//                    else</span>
<a name="l02718"></a>02718 <span class="comment">//                      {</span>
<a name="l02719"></a>02719 <span class="comment">//                        // Case 6</span>
<a name="l02720"></a>02720 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02721"></a>02721 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02722"></a>02722 <span class="comment">//                      }</span>
<a name="l02723"></a>02723 
<a name="l02724"></a>02724 <span class="comment">//                  else if (elem-&gt;node(5) == min_node)</span>
<a name="l02725"></a>02725 <span class="comment">//                    if (elem-&gt;node(1) == std::min(elem-&gt;node(1), elem-&gt;node(6)))</span>
<a name="l02726"></a>02726 <span class="comment">//                      {</span>
<a name="l02727"></a>02727 <span class="comment">//                        // Case 7</span>
<a name="l02728"></a>02728 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02729"></a>02729 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02730"></a>02730 <span class="comment">//                      }</span>
<a name="l02731"></a>02731 <span class="comment">//                    else</span>
<a name="l02732"></a>02732 <span class="comment">//                      {</span>
<a name="l02733"></a>02733 <span class="comment">//                        // Case 8</span>
<a name="l02734"></a>02734 <span class="comment">//                        eta_mapped   = eta;</span>
<a name="l02735"></a>02735 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02736"></a>02736 <span class="comment">//                      }</span>
<a name="l02737"></a>02737 <span class="comment">//                }</span>
<a name="l02738"></a>02738 
<a name="l02739"></a>02739                 
<a name="l02740"></a>02740 <span class="comment">//              // Face 3</span>
<a name="l02741"></a>02741 <span class="comment">//              else if ((i1[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02742"></a>02742 <span class="comment">//                {</span>
<a name="l02743"></a>02743 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(2),</span>
<a name="l02744"></a>02744 <span class="comment">//                                                         std::min(elem-&gt;node(3),</span>
<a name="l02745"></a>02745 <span class="comment">//                                                                  std::min(elem-&gt;node(7),</span>
<a name="l02746"></a>02746 <span class="comment">//                                                                           elem-&gt;node(6))));</span>
<a name="l02747"></a>02747 <span class="comment">//                  if (elem-&gt;node(3) == min_node)</span>
<a name="l02748"></a>02748 <span class="comment">//                    if (elem-&gt;node(2) == std::min(elem-&gt;node(2), elem-&gt;node(7)))</span>
<a name="l02749"></a>02749 <span class="comment">//                      {</span>
<a name="l02750"></a>02750 <span class="comment">//                        // Case 1</span>
<a name="l02751"></a>02751 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02752"></a>02752 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02753"></a>02753 <span class="comment">//                      }</span>
<a name="l02754"></a>02754 <span class="comment">//                    else</span>
<a name="l02755"></a>02755 <span class="comment">//                      {</span>
<a name="l02756"></a>02756 <span class="comment">//                        // Case 2</span>
<a name="l02757"></a>02757 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02758"></a>02758 <span class="comment">//                        zeta_mapped = xi;</span>
<a name="l02759"></a>02759 <span class="comment">//                      }</span>
<a name="l02760"></a>02760 
<a name="l02761"></a>02761 <span class="comment">//                  else if (elem-&gt;node(7) == min_node)</span>
<a name="l02762"></a>02762 <span class="comment">//                    if (elem-&gt;node(3) == std::min(elem-&gt;node(3), elem-&gt;node(6)))</span>
<a name="l02763"></a>02763 <span class="comment">//                      {</span>
<a name="l02764"></a>02764 <span class="comment">//                        // Case 3</span>
<a name="l02765"></a>02765 <span class="comment">//                        xi_mapped   = -zeta;</span>
<a name="l02766"></a>02766 <span class="comment">//                        zeta_mapped = xi;</span>
<a name="l02767"></a>02767 <span class="comment">//                      }</span>
<a name="l02768"></a>02768 <span class="comment">//                    else</span>
<a name="l02769"></a>02769 <span class="comment">//                      {</span>
<a name="l02770"></a>02770 <span class="comment">//                        // Case 4</span>
<a name="l02771"></a>02771 <span class="comment">//                        xi_mapped   = xi;</span>
<a name="l02772"></a>02772 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02773"></a>02773 <span class="comment">//                      }</span>
<a name="l02774"></a>02774 
<a name="l02775"></a>02775 <span class="comment">//                  else if (elem-&gt;node(6) == min_node)</span>
<a name="l02776"></a>02776 <span class="comment">//                    if (elem-&gt;node(7) == std::min(elem-&gt;node(7), elem-&gt;node(2)))</span>
<a name="l02777"></a>02777 <span class="comment">//                      {</span>
<a name="l02778"></a>02778 <span class="comment">//                        // Case 5</span>
<a name="l02779"></a>02779 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02780"></a>02780 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02781"></a>02781 <span class="comment">//                      }</span>
<a name="l02782"></a>02782 <span class="comment">//                    else</span>
<a name="l02783"></a>02783 <span class="comment">//                      {</span>
<a name="l02784"></a>02784 <span class="comment">//                        // Case 6</span>
<a name="l02785"></a>02785 <span class="comment">//                        xi_mapped   = -zeta;</span>
<a name="l02786"></a>02786 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02787"></a>02787 <span class="comment">//                      }</span>
<a name="l02788"></a>02788 
<a name="l02789"></a>02789 <span class="comment">//                  else if (elem-&gt;node(2) == min_node)</span>
<a name="l02790"></a>02790 <span class="comment">//                    if (elem-&gt;node(6) == std::min(elem-&gt;node(3), elem-&gt;node(6)))</span>
<a name="l02791"></a>02791 <span class="comment">//                      {</span>
<a name="l02792"></a>02792 <span class="comment">//                        // Case 7</span>
<a name="l02793"></a>02793 <span class="comment">//                        xi_mapped   = zeta;</span>
<a name="l02794"></a>02794 <span class="comment">//                        zeta_mapped = -xi;</span>
<a name="l02795"></a>02795 <span class="comment">//                      }</span>
<a name="l02796"></a>02796 <span class="comment">//                    else</span>
<a name="l02797"></a>02797 <span class="comment">//                      {</span>
<a name="l02798"></a>02798 <span class="comment">//                        // Case 8</span>
<a name="l02799"></a>02799 <span class="comment">//                        xi_mapped   = -xi;</span>
<a name="l02800"></a>02800 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02801"></a>02801 <span class="comment">//                      }</span>
<a name="l02802"></a>02802 <span class="comment">//                }</span>
<a name="l02803"></a>02803 
<a name="l02804"></a>02804                 
<a name="l02805"></a>02805 <span class="comment">//              // Face 4</span>
<a name="l02806"></a>02806 <span class="comment">//              else if ((i0[i] == 0) &amp;&amp; (i1[i] &gt;= 2) &amp;&amp; (i2[i] &gt;= 2))</span>
<a name="l02807"></a>02807 <span class="comment">//                {</span>
<a name="l02808"></a>02808 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(3),</span>
<a name="l02809"></a>02809 <span class="comment">//                                                         std::min(elem-&gt;node(0),</span>
<a name="l02810"></a>02810 <span class="comment">//                                                                  std::min(elem-&gt;node(4),</span>
<a name="l02811"></a>02811 <span class="comment">//                                                                           elem-&gt;node(7))));</span>
<a name="l02812"></a>02812 <span class="comment">//                  if (elem-&gt;node(0) == min_node)</span>
<a name="l02813"></a>02813 <span class="comment">//                    if (elem-&gt;node(3) == std::min(elem-&gt;node(3), elem-&gt;node(4)))</span>
<a name="l02814"></a>02814 <span class="comment">//                      {</span>
<a name="l02815"></a>02815 <span class="comment">//                        // Case 1</span>
<a name="l02816"></a>02816 <span class="comment">//                        eta_mapped  = eta;</span>
<a name="l02817"></a>02817 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02818"></a>02818 <span class="comment">//                      }</span>
<a name="l02819"></a>02819 <span class="comment">//                    else</span>
<a name="l02820"></a>02820 <span class="comment">//                      {</span>
<a name="l02821"></a>02821 <span class="comment">//                        // Case 2</span>
<a name="l02822"></a>02822 <span class="comment">//                        eta_mapped  = zeta;</span>
<a name="l02823"></a>02823 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02824"></a>02824 <span class="comment">//                      }</span>
<a name="l02825"></a>02825 
<a name="l02826"></a>02826 <span class="comment">//                  else if (elem-&gt;node(4) == min_node)</span>
<a name="l02827"></a>02827 <span class="comment">//                    if (elem-&gt;node(0) == std::min(elem-&gt;node(0), elem-&gt;node(7)))</span>
<a name="l02828"></a>02828 <span class="comment">//                      {</span>
<a name="l02829"></a>02829 <span class="comment">//                        // Case 3</span>
<a name="l02830"></a>02830 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02831"></a>02831 <span class="comment">//                        zeta_mapped = eta;</span>
<a name="l02832"></a>02832 <span class="comment">//                      }</span>
<a name="l02833"></a>02833 <span class="comment">//                    else</span>
<a name="l02834"></a>02834 <span class="comment">//                      {</span>
<a name="l02835"></a>02835 <span class="comment">//                        // Case 4</span>
<a name="l02836"></a>02836 <span class="comment">//                        eta_mapped  = eta;</span>
<a name="l02837"></a>02837 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02838"></a>02838 <span class="comment">//                      }</span>
<a name="l02839"></a>02839 
<a name="l02840"></a>02840 <span class="comment">//                  else if (elem-&gt;node(7) == min_node)</span>
<a name="l02841"></a>02841 <span class="comment">//                    if (elem-&gt;node(4) == std::min(elem-&gt;node(4), elem-&gt;node(3)))</span>
<a name="l02842"></a>02842 <span class="comment">//                      {</span>
<a name="l02843"></a>02843 <span class="comment">//                        // Case 5</span>
<a name="l02844"></a>02844 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02845"></a>02845 <span class="comment">//                        zeta_mapped = -zeta;</span>
<a name="l02846"></a>02846 <span class="comment">//                      }</span>
<a name="l02847"></a>02847 <span class="comment">//                    else</span>
<a name="l02848"></a>02848 <span class="comment">//                      {</span>
<a name="l02849"></a>02849 <span class="comment">//                        // Case 6</span>
<a name="l02850"></a>02850 <span class="comment">//                        eta_mapped  = -zeta;</span>
<a name="l02851"></a>02851 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02852"></a>02852 <span class="comment">//                      }</span>
<a name="l02853"></a>02853 
<a name="l02854"></a>02854 <span class="comment">//                  else if (elem-&gt;node(3) == min_node)</span>
<a name="l02855"></a>02855 <span class="comment">//                    if (elem-&gt;node(7) == std::min(elem-&gt;node(7), elem-&gt;node(0)))</span>
<a name="l02856"></a>02856 <span class="comment">//                      {</span>
<a name="l02857"></a>02857 <span class="comment">//                        // Case 7</span>
<a name="l02858"></a>02858 <span class="comment">//                        eta_mapped   = zeta;</span>
<a name="l02859"></a>02859 <span class="comment">//                        zeta_mapped = -eta;</span>
<a name="l02860"></a>02860 <span class="comment">//                      }</span>
<a name="l02861"></a>02861 <span class="comment">//                    else</span>
<a name="l02862"></a>02862 <span class="comment">//                      {</span>
<a name="l02863"></a>02863 <span class="comment">//                        // Case 8</span>
<a name="l02864"></a>02864 <span class="comment">//                        eta_mapped  = -eta;</span>
<a name="l02865"></a>02865 <span class="comment">//                        zeta_mapped = zeta;</span>
<a name="l02866"></a>02866 <span class="comment">//                      }</span>
<a name="l02867"></a>02867 <span class="comment">//                }</span>
<a name="l02868"></a>02868 
<a name="l02869"></a>02869                 
<a name="l02870"></a>02870 <span class="comment">//              // Face 5</span>
<a name="l02871"></a>02871 <span class="comment">//              else if ((i2[i] == 1) &amp;&amp; (i0[i] &gt;= 2) &amp;&amp; (i1[i] &gt;= 2))</span>
<a name="l02872"></a>02872 <span class="comment">//                {</span>
<a name="l02873"></a>02873 <span class="comment">//                  const unsigned int min_node = std::min(elem-&gt;node(4),</span>
<a name="l02874"></a>02874 <span class="comment">//                                                         std::min(elem-&gt;node(5),</span>
<a name="l02875"></a>02875 <span class="comment">//                                                                  std::min(elem-&gt;node(6),</span>
<a name="l02876"></a>02876 <span class="comment">//                                                                           elem-&gt;node(7))));</span>
<a name="l02877"></a>02877 <span class="comment">//                  if (elem-&gt;node(4) == min_node)</span>
<a name="l02878"></a>02878 <span class="comment">//                    if (elem-&gt;node(5) == std::min(elem-&gt;node(5), elem-&gt;node(7)))</span>
<a name="l02879"></a>02879 <span class="comment">//                      {</span>
<a name="l02880"></a>02880 <span class="comment">//                        // Case 1</span>
<a name="l02881"></a>02881 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02882"></a>02882 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02883"></a>02883 <span class="comment">//                      }</span>
<a name="l02884"></a>02884 <span class="comment">//                    else</span>
<a name="l02885"></a>02885 <span class="comment">//                      {</span>
<a name="l02886"></a>02886 <span class="comment">//                        // Case 2</span>
<a name="l02887"></a>02887 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02888"></a>02888 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l02889"></a>02889 <span class="comment">//                      }</span>
<a name="l02890"></a>02890 
<a name="l02891"></a>02891 <span class="comment">//                  else if (elem-&gt;node(5) == min_node)</span>
<a name="l02892"></a>02892 <span class="comment">//                    if (elem-&gt;node(6) == std::min(elem-&gt;node(6), elem-&gt;node(4)))</span>
<a name="l02893"></a>02893 <span class="comment">//                      {</span>
<a name="l02894"></a>02894 <span class="comment">//                        // Case 3</span>
<a name="l02895"></a>02895 <span class="comment">//                        xi_mapped  = eta;</span>
<a name="l02896"></a>02896 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02897"></a>02897 <span class="comment">//                      }</span>
<a name="l02898"></a>02898 <span class="comment">//                    else</span>
<a name="l02899"></a>02899 <span class="comment">//                      {</span>
<a name="l02900"></a>02900 <span class="comment">//                        // Case 4</span>
<a name="l02901"></a>02901 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02902"></a>02902 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02903"></a>02903 <span class="comment">//                      }</span>
<a name="l02904"></a>02904 
<a name="l02905"></a>02905 <span class="comment">//                  else if (elem-&gt;node(6) == min_node)</span>
<a name="l02906"></a>02906 <span class="comment">//                    if (elem-&gt;node(7) == std::min(elem-&gt;node(7), elem-&gt;node(5)))</span>
<a name="l02907"></a>02907 <span class="comment">//                      {</span>
<a name="l02908"></a>02908 <span class="comment">//                        // Case 5</span>
<a name="l02909"></a>02909 <span class="comment">//                        xi_mapped  = -xi;</span>
<a name="l02910"></a>02910 <span class="comment">//                        eta_mapped = -eta;</span>
<a name="l02911"></a>02911 <span class="comment">//                      }</span>
<a name="l02912"></a>02912 <span class="comment">//                    else</span>
<a name="l02913"></a>02913 <span class="comment">//                      {</span>
<a name="l02914"></a>02914 <span class="comment">//                        // Case 6</span>
<a name="l02915"></a>02915 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02916"></a>02916 <span class="comment">//                        eta_mapped = -xi;</span>
<a name="l02917"></a>02917 <span class="comment">//                      }</span>
<a name="l02918"></a>02918 
<a name="l02919"></a>02919 <span class="comment">//                  else if (elem-&gt;node(7) == min_node)</span>
<a name="l02920"></a>02920 <span class="comment">//                    if (elem-&gt;node(4) == std::min(elem-&gt;node(4), elem-&gt;node(6)))</span>
<a name="l02921"></a>02921 <span class="comment">//                      {</span>
<a name="l02922"></a>02922 <span class="comment">//                        // Case 7</span>
<a name="l02923"></a>02923 <span class="comment">//                        xi_mapped  = -eta;</span>
<a name="l02924"></a>02924 <span class="comment">//                        eta_mapped = xi;</span>
<a name="l02925"></a>02925 <span class="comment">//                      }</span>
<a name="l02926"></a>02926 <span class="comment">//                    else</span>
<a name="l02927"></a>02927 <span class="comment">//                      {</span>
<a name="l02928"></a>02928 <span class="comment">//                        // Case 8</span>
<a name="l02929"></a>02929 <span class="comment">//                        xi_mapped  = xi;</span>
<a name="l02930"></a>02930 <span class="comment">//                        eta_mapped = eta;</span>
<a name="l02931"></a>02931 <span class="comment">//                      }</span>
<a name="l02932"></a>02932 <span class="comment">//                }</span>
<a name="l02933"></a>02933 
<a name="l02934"></a>02934                 
<a name="l02935"></a>02935 <span class="comment">//            }</span>
<a name="l02936"></a>02936                   
<a name="l02937"></a>02937               
<a name="l02938"></a>02938 
<a name="l02939"></a>02939 <span class="comment">//            libmesh_assert (j &lt; 3);</span>
<a name="l02940"></a>02940 
<a name="l02941"></a>02941 <span class="comment">//            switch (j)</span>
<a name="l02942"></a>02942 <span class="comment">//              {</span>
<a name="l02943"></a>02943 <span class="comment">//                // d()/dxi</span>
<a name="l02944"></a>02944 <span class="comment">//              case 0:</span>
<a name="l02945"></a>02945 <span class="comment">//                return (FE&lt;1,BERNSTEIN&gt;::shape_deriv(EDGE3, totalorder, i0[i], 0, xi_mapped)*</span>
<a name="l02946"></a>02946 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i1[i],    eta_mapped)*</span>
<a name="l02947"></a>02947 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i2[i],    zeta_mapped));</span>
<a name="l02948"></a>02948 
<a name="l02949"></a>02949 <span class="comment">//                // d()/deta</span>
<a name="l02950"></a>02950 <span class="comment">//              case 1:</span>
<a name="l02951"></a>02951 <span class="comment">//                return (FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i0[i],    xi_mapped)*</span>
<a name="l02952"></a>02952 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape_deriv(EDGE3, totalorder, i1[i], 0, eta_mapped)*</span>
<a name="l02953"></a>02953 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i2[i],    zeta_mapped));</span>
<a name="l02954"></a>02954 
<a name="l02955"></a>02955 <span class="comment">//                // d()/dzeta</span>
<a name="l02956"></a>02956 <span class="comment">//              case 2:</span>
<a name="l02957"></a>02957 <span class="comment">//                return (FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i0[i],    xi_mapped)*</span>
<a name="l02958"></a>02958 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape      (EDGE3, totalorder, i1[i],    eta_mapped)*</span>
<a name="l02959"></a>02959 <span class="comment">//                        FE&lt;1,BERNSTEIN&gt;::shape_deriv(EDGE3, totalorder, i2[i], 0, zeta_mapped));</span>
<a name="l02960"></a>02960 
<a name="l02961"></a>02961 <span class="comment">//              default:</span>
<a name="l02962"></a>02962 <span class="comment">//                libmesh_error();</span>
<a name="l02963"></a>02963 <span class="comment">//              }</span>
<a name="l02964"></a>02964 <span class="comment">//          }</span>
<a name="l02965"></a>02965 
<a name="l02966"></a>02966             
<a name="l02967"></a>02967           <span class="keywordflow">default</span>:
<a name="l02968"></a>02968             libmesh_error();
<a name="l02969"></a>02969           }
<a name="l02970"></a>02970       }
<a name="l02971"></a>02971 
<a name="l02972"></a>02972 
<a name="l02973"></a>02973     <span class="keywordflow">default</span>:
<a name="l02974"></a>02974       libmesh_error();
<a name="l02975"></a>02975     }
<a name="l02976"></a>02976 
<a name="l02977"></a>02977 <span class="preprocessor">#endif</span>
<a name="l02978"></a>02978 <span class="preprocessor"></span>
<a name="l02979"></a>02979   libmesh_error();
<a name="l02980"></a>02980   <span class="keywordflow">return</span> 0.;
<a name="l02981"></a>02981 }
<a name="l02982"></a>02982 
<a name="l02983"></a>02983 
<a name="l02984"></a>02984 
<a name="l02985"></a>02985 <span class="keyword">template</span> &lt;&gt;
<a name="l02986"></a><a class="code" href="classlibMesh_1_1FE.php#aa6dd52bf3620214fd0f5a52f2aa8a074">02986</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;3,BERNSTEIN&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l02987"></a>02987                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l02988"></a>02988                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l02989"></a>02989                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l02990"></a>02990                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l02991"></a>02991 {
<a name="l02992"></a>02992   <span class="keyword">static</span> <span class="keywordtype">bool</span> warning_given = <span class="keyword">false</span>;
<a name="l02993"></a>02993 
<a name="l02994"></a>02994   <span class="keywordflow">if</span> (!warning_given)
<a name="l02995"></a>02995   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Bernstein elements &quot;</span>
<a name="l02996"></a>02996                 &lt;&lt; <span class="stringliteral">&quot;are not yet implemented!&quot;</span>
<a name="l02997"></a>02997                 &lt;&lt; std::endl;
<a name="l02998"></a>02998 
<a name="l02999"></a>02999   warning_given = <span class="keyword">true</span>;
<a name="l03000"></a>03000   <span class="keywordflow">return</span> 0.;
<a name="l03001"></a>03001 }
<a name="l03002"></a>03002 
<a name="l03003"></a>03003 
<a name="l03004"></a>03004 
<a name="l03005"></a>03005 <span class="keyword">template</span> &lt;&gt;
<a name="l03006"></a><a class="code" href="classlibMesh_1_1FE.php#abc22045a2519f35606ba8f9112f61ad2">03006</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;3,BERNSTEIN&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l03007"></a>03007                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l03008"></a>03008                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l03009"></a>03009                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l03010"></a>03010                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l03011"></a>03011 {
<a name="l03012"></a>03012   <span class="keyword">static</span> <span class="keywordtype">bool</span> warning_given = <span class="keyword">false</span>;
<a name="l03013"></a>03013 
<a name="l03014"></a>03014   <span class="keywordflow">if</span> (!warning_given)
<a name="l03015"></a>03015   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Bernstein elements &quot;</span>
<a name="l03016"></a>03016                 &lt;&lt; <span class="stringliteral">&quot;are not yet implemented!&quot;</span>
<a name="l03017"></a>03017                 &lt;&lt; std::endl;
<a name="l03018"></a>03018 
<a name="l03019"></a>03019   warning_given = <span class="keyword">true</span>;
<a name="l03020"></a>03020   <span class="keywordflow">return</span> 0.;
<a name="l03021"></a>03021 }
<a name="l03022"></a>03022 
<a name="l03023"></a>03023 } <span class="comment">// namespace libMesh</span>
<a name="l03024"></a>03024 
<a name="l03025"></a>03025 
<a name="l03026"></a>03026 
<a name="l03027"></a>03027 <span class="preprocessor">#endif //LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
