<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_clough_shape_2D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__clough__shape__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_clough_shape_2D.C 3883 2010-07-26 22:58:49Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ inlcludes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Anonymous namespace for persistant variables.</span>
<a name="l00029"></a>00029 <span class="comment">// This allows us to cache the global-to-local mapping transformation</span>
<a name="l00030"></a>00030 <span class="comment">// FIXME: This should also screw up multithreading royally</span>
<a name="l00031"></a>00031 <span class="keyword">namespace</span>
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="keyword">using namespace </span>libMesh;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_id = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00036"></a>00036   <span class="comment">// Coefficient naming: d(1)d(2n) is the coefficient of the</span>
<a name="l00037"></a>00037   <span class="comment">// global shape function corresponding to value 1 in terms of the</span>
<a name="l00038"></a>00038   <span class="comment">// local shape function corresponding to normal derivative 2</span>
<a name="l00039"></a>00039   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d2n, d1d3n, d2d3n, d2d1n, d3d1n, d3d2n;
<a name="l00040"></a>00040   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd1x, d1xd1y, d1xd2n, d1xd3n;
<a name="l00041"></a>00041   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd1x, d1yd1y, d1yd2n, d1yd3n;
<a name="l00042"></a>00042   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd2x, d2xd2y, d2xd3n, d2xd1n;
<a name="l00043"></a>00043   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd2x, d2yd2y, d2yd3n, d2yd1n;
<a name="l00044"></a>00044   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd3x, d3xd3y, d3xd1n, d3xd2n;
<a name="l00045"></a>00045   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd3x, d3yd3y, d3yd1n, d3yd2n;
<a name="l00046"></a>00046   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1nd1n, d2nd2n, d3nd3n;
<a name="l00047"></a>00047   <span class="comment">// Normal vector naming: N01x is the x component of the</span>
<a name="l00048"></a>00048   <span class="comment">// unit vector at point 0 normal to (possibly curved) side 01</span>
<a name="l00049"></a>00049   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N01x, N01y, N10x, N10y;
<a name="l00050"></a>00050   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N02x, N02y, N20x, N20y;
<a name="l00051"></a>00051   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N21x, N21y, N12x, N12y;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_second_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00054"></a>00054                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00055"></a>00055                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00056"></a>00056 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00057"></a>00057                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00058"></a>00058                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00059"></a>00059 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00060"></a>00060                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00061"></a>00061 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> subtriangle_lookup(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="comment">// Compute the static coefficients for an element</span>
<a name="l00065"></a>00065 <span class="keywordtype">void</span> clough_compute_coefs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="comment">// Using static globals for old_elem_id, etc. will fail</span>
<a name="l00068"></a>00068   <span class="comment">// horribly with more than one thread.</span>
<a name="l00069"></a>00069   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">// Coefficients are cached from old elements</span>
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_elem_id)
<a name="l00073"></a>00073     <span class="keywordflow">return</span>;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   old_elem_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> mapping_order        (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>());
<a name="l00078"></a>00078   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00079"></a>00079   <span class="keyword">const</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00080"></a>00080     <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;2,LAGRANGE&gt;::n_shape_functions</a>(mapping_elem_type,
<a name="l00081"></a>00081                                       mapping_order);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">// Degrees of freedom are at vertices and edge midpoints</span>
<a name="l00084"></a>00084   std::vector&lt;Point&gt; dofpt;
<a name="l00085"></a>00085   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0,0));
<a name="l00086"></a>00086   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(1,0));
<a name="l00087"></a>00087   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0,1));
<a name="l00088"></a>00088   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(1/2.,1/2.));
<a name="l00089"></a>00089   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0,1/2.));
<a name="l00090"></a>00090   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(1/2.,0));
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// Mapping functions - first derivatives at each dofpt</span>
<a name="l00093"></a>00093   std::vector&lt;Real&gt; dxdxi(6), dxdeta(6), dydxi(6), dydeta(6);
<a name="l00094"></a>00094   std::vector&lt;Real&gt; dxidx(6), detadx(6), dxidy(6), detady(6);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> p = 0; p != 6; ++p)
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098 <span class="comment">//      libMesh::err &lt;&lt; p &lt;&lt; &#39; &#39; &lt;&lt; dofpt[p];</span>
<a name="l00099"></a>00099       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i != n_mapping_shape_functions; ++i)
<a name="l00100"></a>00100         {
<a name="l00101"></a>00101           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ddxi = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,LAGRANGE&gt;::shape_deriv</a> 
<a name="l00102"></a>00102             (mapping_elem_type, mapping_order, i, 0, dofpt[p]);
<a name="l00103"></a>00103           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ddeta = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,LAGRANGE&gt;::shape_deriv</a> 
<a name="l00104"></a>00104             (mapping_elem_type, mapping_order, i, 1, dofpt[p]);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">//      libMesh::err &lt;&lt; ddxi &lt;&lt; &#39; &#39;;</span>
<a name="l00107"></a>00107 <span class="comment">//      libMesh::err &lt;&lt; ddeta &lt;&lt; std::endl;</span>
<a name="l00108"></a>00108 
<a name="l00109"></a>00109           dxdxi[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0) * ddxi;
<a name="l00110"></a>00110           dydxi[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1) * ddxi;
<a name="l00111"></a>00111           dxdeta[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0) * ddeta;
<a name="l00112"></a>00112           dydeta[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1) * ddeta;
<a name="l00113"></a>00113         }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="comment">//      for (int i = 0; i != 12; ++i)</span>
<a name="l00116"></a>00116 <span class="comment">//          libMesh::err &lt;&lt; i &lt;&lt; &#39; &#39; &lt;&lt; clough_raw_shape(i, dofpt[p]) &lt;&lt; std::endl;</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="comment">//      libMesh::err &lt;&lt; elem-&gt;point(p)(0) &lt;&lt; &#39; &#39;;</span>
<a name="l00119"></a>00119 <span class="comment">//      libMesh::err &lt;&lt; elem-&gt;point(p)(1) &lt;&lt; &#39; &#39;;</span>
<a name="l00120"></a>00120 <span class="comment">//      libMesh::err &lt;&lt; dxdxi[p] &lt;&lt; &#39; &#39;;</span>
<a name="l00121"></a>00121 <span class="comment">//      libMesh::err &lt;&lt; dydxi[p] &lt;&lt; &#39; &#39;;</span>
<a name="l00122"></a>00122 <span class="comment">//      libMesh::err &lt;&lt; dxdeta[p] &lt;&lt; &#39; &#39;;</span>
<a name="l00123"></a>00123 <span class="comment">//      libMesh::err &lt;&lt; dydeta[p] &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inv_jac = 1. / (dxdxi[p]*dydeta[p] - 
<a name="l00126"></a>00126         dxdeta[p]*dydxi[p]);
<a name="l00127"></a>00127       dxidx[p] = dydeta[p] * inv_jac;
<a name="l00128"></a>00128       dxidy[p] = - dxdeta[p] * inv_jac;
<a name="l00129"></a>00129       detadx[p] = - dydxi[p] * inv_jac;
<a name="l00130"></a>00130       detady[p] = dxdxi[p] * inv_jac;
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Calculate midpoint normal vectors</span>
<a name="l00134"></a>00134   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N1x = dydeta[3] - dydxi[3];
<a name="l00135"></a>00135   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N1y = dxdxi[3] - dxdeta[3];
<a name="l00136"></a>00136   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> Nlength = std::sqrt(static_cast&lt;Real&gt;(N1x*N1x + N1y*N1y));
<a name="l00137"></a>00137   N1x /= Nlength; N1y /= Nlength;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N2x = - dydeta[4];
<a name="l00140"></a>00140   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N2y = dxdeta[4];
<a name="l00141"></a>00141   Nlength = std::sqrt(static_cast&lt;Real&gt;(N2x*N2x + N2y*N2y));
<a name="l00142"></a>00142   N2x /= Nlength; N2y /= Nlength;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N3x = dydxi[5];
<a name="l00145"></a>00145   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N3y = - dxdxi[5];
<a name="l00146"></a>00146   Nlength = std::sqrt(static_cast&lt;Real&gt;(N3x*N3x + N3y*N3y));
<a name="l00147"></a>00147   N3x /= Nlength; N3y /= Nlength;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// Calculate corner normal vectors (used for reduced element)</span>
<a name="l00150"></a>00150   N01x = dydxi[0];
<a name="l00151"></a>00151   N01y = - dxdxi[0];
<a name="l00152"></a>00152   Nlength = std::sqrt(static_cast&lt;Real&gt;(N01x*N01x + N01y*N01y));
<a name="l00153"></a>00153   N01x /= Nlength; N01y /= Nlength;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   N10x = dydxi[1];
<a name="l00156"></a>00156   N10y = - dxdxi[1];
<a name="l00157"></a>00157   Nlength = std::sqrt(static_cast&lt;Real&gt;(N10x*N10x + N10y*N10y));
<a name="l00158"></a>00158   N10x /= Nlength; N10y /= Nlength;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   N02x = - dydeta[0];
<a name="l00161"></a>00161   N02y = dxdeta[0];
<a name="l00162"></a>00162   Nlength = std::sqrt(static_cast&lt;Real&gt;(N02x*N02x + N02y*N02y));
<a name="l00163"></a>00163   N02x /= Nlength; N02y /= Nlength;
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   N20x = - dydeta[2];
<a name="l00166"></a>00166   N20y = dxdeta[2];
<a name="l00167"></a>00167   Nlength = std::sqrt(static_cast&lt;Real&gt;(N20x*N20x + N20y*N20y));
<a name="l00168"></a>00168   N20x /= Nlength; N20y /= Nlength;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   N12x = dydeta[1] - dydxi[1];
<a name="l00171"></a>00171   N12y = dxdxi[1] - dxdeta[1];
<a name="l00172"></a>00172   Nlength = std::sqrt(static_cast&lt;Real&gt;(N12x*N12x + N12y*N12y));
<a name="l00173"></a>00173   N12x /= Nlength; N12y /= Nlength;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   N21x = dydeta[1] - dydxi[1];
<a name="l00176"></a>00176   N21y = dxdxi[1] - dxdeta[1];
<a name="l00177"></a>00177   Nlength = std::sqrt(static_cast&lt;Real&gt;(N21x*N21x + N21y*N21y));
<a name="l00178"></a>00178   N21x /= Nlength; N21y /= Nlength;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="comment">//  for (int i=0; i != 6; ++i) {</span>
<a name="l00181"></a>00181 <span class="comment">//    libMesh::err &lt;&lt; elem-&gt;node(i) &lt;&lt; &#39; &#39;;</span>
<a name="l00182"></a>00182 <span class="comment">//  }</span>
<a name="l00183"></a>00183 <span class="comment">//  libMesh::err &lt;&lt; std::endl;</span>
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="comment">//  for (int i=0; i != 6; ++i) {</span>
<a name="l00186"></a>00186 <span class="comment">//    libMesh::err &lt;&lt; elem-&gt;point(i)(0) &lt;&lt; &#39; &#39;;</span>
<a name="l00187"></a>00187 <span class="comment">//    libMesh::err &lt;&lt; elem-&gt;point(i)(1) &lt;&lt; &#39; &#39;;</span>
<a name="l00188"></a>00188 <span class="comment">//  }</span>
<a name="l00189"></a>00189 <span class="comment">//  libMesh::err &lt;&lt; std::endl;</span>
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="comment">// give normal vectors a globally unique orientation</span>
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196 <span class="comment">//      libMesh::err &lt;&lt; &quot;Flipping nodes &quot; &lt;&lt; elem-&gt;node(2);</span>
<a name="l00197"></a>00197 <span class="comment">//      libMesh::err &lt;&lt; &quot; and &quot; &lt;&lt; elem-&gt;node(1);</span>
<a name="l00198"></a>00198 <span class="comment">//      libMesh::err &lt;&lt; &quot; around node &quot; &lt;&lt; elem-&gt;node(4);</span>
<a name="l00199"></a>00199 <span class="comment">//      libMesh::err &lt;&lt; std::endl;</span>
<a name="l00200"></a>00200       N1x = -N1x; N1y = -N1y;
<a name="l00201"></a>00201       N12x = -N12x; N12y = -N12y;
<a name="l00202"></a>00202       N21x = -N21x; N21y = -N21y;
<a name="l00203"></a>00203     }
<a name="l00204"></a>00204   <span class="keywordflow">else</span>
<a name="l00205"></a>00205     {
<a name="l00206"></a>00206 <span class="comment">//      libMesh::err &lt;&lt; &quot;Not flipping nodes &quot; &lt;&lt; elem-&gt;node(2);</span>
<a name="l00207"></a>00207 <span class="comment">//      libMesh::err &lt;&lt; &quot; and &quot; &lt;&lt; elem-&gt;node(1);</span>
<a name="l00208"></a>00208 <span class="comment">//      libMesh::err &lt;&lt; &quot; around node &quot; &lt;&lt; elem-&gt;node(4);</span>
<a name="l00209"></a>00209 <span class="comment">//      libMesh::err &lt;&lt; std::endl;</span>
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2))
<a name="l00212"></a>00212     {
<a name="l00213"></a>00213 <span class="comment">//      libMesh::err &lt;&lt; &quot;Flipping nodes &quot; &lt;&lt; elem-&gt;node(0);</span>
<a name="l00214"></a>00214 <span class="comment">//      libMesh::err &lt;&lt; &quot; and &quot; &lt;&lt; elem-&gt;node(2);</span>
<a name="l00215"></a>00215 <span class="comment">//      libMesh::err &lt;&lt; &quot; around node &quot; &lt;&lt; elem-&gt;node(5);</span>
<a name="l00216"></a>00216 <span class="comment">//      libMesh::err &lt;&lt; std::endl;</span>
<a name="l00217"></a>00217 <span class="comment">//      libMesh::err &lt;&lt; N2x &lt;&lt; &#39; &#39; &lt;&lt; N2y &lt;&lt; std::endl;</span>
<a name="l00218"></a>00218       N2x = -N2x; N2y = -N2y;
<a name="l00219"></a>00219       N02x = -N02x; N02y = -N02y;
<a name="l00220"></a>00220       N20x = -N20x; N20y = -N20y;
<a name="l00221"></a>00221 <span class="comment">//      libMesh::err &lt;&lt; N2x &lt;&lt; &#39; &#39; &lt;&lt; N2y &lt;&lt; std::endl;</span>
<a name="l00222"></a>00222     }
<a name="l00223"></a>00223   <span class="keywordflow">else</span>
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225 <span class="comment">//      libMesh::err &lt;&lt; &quot;Not flipping nodes &quot; &lt;&lt; elem-&gt;node(0);</span>
<a name="l00226"></a>00226 <span class="comment">//      libMesh::err &lt;&lt; &quot; and &quot; &lt;&lt; elem-&gt;node(2);</span>
<a name="l00227"></a>00227 <span class="comment">//      libMesh::err &lt;&lt; &quot; around node &quot; &lt;&lt; elem-&gt;node(5);</span>
<a name="l00228"></a>00228 <span class="comment">//      libMesh::err &lt;&lt; std::endl;</span>
<a name="l00229"></a>00229     }
<a name="l00230"></a>00230   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))
<a name="l00231"></a>00231     {
<a name="l00232"></a>00232 <span class="comment">//      libMesh::err &lt;&lt; &quot;Flipping nodes &quot; &lt;&lt; elem-&gt;node(1);</span>
<a name="l00233"></a>00233 <span class="comment">//      libMesh::err &lt;&lt; &quot; and &quot; &lt;&lt; elem-&gt;node(0);</span>
<a name="l00234"></a>00234 <span class="comment">//      libMesh::err &lt;&lt; &quot; around node &quot; &lt;&lt; elem-&gt;node(3);</span>
<a name="l00235"></a>00235 <span class="comment">//      libMesh::err &lt;&lt; std::endl;</span>
<a name="l00236"></a>00236       N3x = -N3x;
<a name="l00237"></a>00237       N3y = -N3y;
<a name="l00238"></a>00238       N01x = -N01x; N01y = -N01y;
<a name="l00239"></a>00239       N10x = -N10x; N10y = -N10y;
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241   <span class="keywordflow">else</span>
<a name="l00242"></a>00242     {
<a name="l00243"></a>00243 <span class="comment">//      libMesh::err &lt;&lt; &quot;Not flipping nodes &quot; &lt;&lt; elem-&gt;node(1);</span>
<a name="l00244"></a>00244 <span class="comment">//      libMesh::err &lt;&lt; &quot; and &quot; &lt;&lt; elem-&gt;node(0);</span>
<a name="l00245"></a>00245 <span class="comment">//      libMesh::err &lt;&lt; &quot; around node &quot; &lt;&lt; elem-&gt;node(3);</span>
<a name="l00246"></a>00246 <span class="comment">//      libMesh::err &lt;&lt; std::endl;</span>
<a name="l00247"></a>00247     }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="comment">//  libMesh::err &lt;&lt; N2x &lt;&lt; &#39; &#39; &lt;&lt; N2y &lt;&lt; std::endl;</span>
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="comment">// Cache basis function gradients</span>
<a name="l00252"></a>00252   <span class="comment">// FIXME: the raw_shape calls shouldn&#39;t be done on every element!</span>
<a name="l00253"></a>00253   <span class="comment">// FIXME: I should probably be looping, too...</span>
<a name="l00254"></a>00254   <span class="comment">// Gradient naming: d(1)d(2n)d(xi) is the xi component of the</span>
<a name="l00255"></a>00255   <span class="comment">// gradient of the </span>
<a name="l00256"></a>00256   <span class="comment">// local basis function corresponding to value 1 at the node</span>
<a name="l00257"></a>00257   <span class="comment">// corresponding to normal vector 2</span>
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d2ndxi   = clough_raw_shape_deriv(0, 0, dofpt[4]);
<a name="l00260"></a>00260   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d2ndeta  = clough_raw_shape_deriv(0, 1, dofpt[4]);
<a name="l00261"></a>00261   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d2ndx = d1d2ndxi * dxidx[4] + d1d2ndeta * detadx[4];
<a name="l00262"></a>00262   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d2ndy = d1d2ndxi * dxidy[4] + d1d2ndeta * detady[4];
<a name="l00263"></a>00263   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d3ndxi   = clough_raw_shape_deriv(0, 0, dofpt[5]);
<a name="l00264"></a>00264   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d3ndeta  = clough_raw_shape_deriv(0, 1, dofpt[5]);
<a name="l00265"></a>00265   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d3ndx = d1d3ndxi * dxidx[5] + d1d3ndeta * detadx[5];
<a name="l00266"></a>00266   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1d3ndy = d1d3ndxi * dxidy[5] + d1d3ndeta * detady[5];
<a name="l00267"></a>00267   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d3ndxi   = clough_raw_shape_deriv(1, 0, dofpt[5]);
<a name="l00268"></a>00268   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d3ndeta  = clough_raw_shape_deriv(1, 1, dofpt[5]);
<a name="l00269"></a>00269   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d3ndx = d2d3ndxi * dxidx[5] + d2d3ndeta * detadx[5];
<a name="l00270"></a>00270   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d3ndy = d2d3ndxi * dxidy[5] + d2d3ndeta * detady[5];
<a name="l00271"></a>00271   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d1ndxi   = clough_raw_shape_deriv(1, 0, dofpt[3]);
<a name="l00272"></a>00272   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d1ndeta  = clough_raw_shape_deriv(1, 1, dofpt[3]);
<a name="l00273"></a>00273   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d1ndx = d2d1ndxi * dxidx[3] + d2d1ndeta * detadx[3];
<a name="l00274"></a>00274   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2d1ndy = d2d1ndxi * dxidy[3] + d2d1ndeta * detady[3];
<a name="l00275"></a>00275   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d1ndxi   = clough_raw_shape_deriv(2, 0, dofpt[3]);
<a name="l00276"></a>00276   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d1ndeta  = clough_raw_shape_deriv(2, 1, dofpt[3]);
<a name="l00277"></a>00277   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d1ndx = d3d1ndxi * dxidx[3] + d3d1ndeta * detadx[3];
<a name="l00278"></a>00278   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d1ndy = d3d1ndxi * dxidy[3] + d3d1ndeta * detady[3];
<a name="l00279"></a>00279   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d2ndxi   = clough_raw_shape_deriv(2, 0, dofpt[4]);
<a name="l00280"></a>00280   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d2ndeta  = clough_raw_shape_deriv(2, 1, dofpt[4]);
<a name="l00281"></a>00281   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d2ndx = d3d2ndxi * dxidx[4] + d3d2ndeta * detadx[4];
<a name="l00282"></a>00282   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3d2ndy = d3d2ndxi * dxidy[4] + d3d2ndeta * detady[4];
<a name="l00283"></a>00283   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd2ndxi  = clough_raw_shape_deriv(3, 0, dofpt[4]);
<a name="l00284"></a>00284   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd2ndeta = clough_raw_shape_deriv(3, 1, dofpt[4]);
<a name="l00285"></a>00285   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd2ndx = d1xd2ndxi * dxidx[4] + d1xd2ndeta * detadx[4];
<a name="l00286"></a>00286   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd2ndy = d1xd2ndxi * dxidy[4] + d1xd2ndeta * detady[4];
<a name="l00287"></a>00287   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd3ndxi  = clough_raw_shape_deriv(3, 0, dofpt[5]);
<a name="l00288"></a>00288   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd3ndeta = clough_raw_shape_deriv(3, 1, dofpt[5]);
<a name="l00289"></a>00289   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd3ndx = d1xd3ndxi * dxidx[5] + d1xd3ndeta * detadx[5];
<a name="l00290"></a>00290   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd3ndy = d1xd3ndxi * dxidy[5] + d1xd3ndeta * detady[5];
<a name="l00291"></a>00291   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd2ndxi  = clough_raw_shape_deriv(4, 0, dofpt[4]);
<a name="l00292"></a>00292   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd2ndeta = clough_raw_shape_deriv(4, 1, dofpt[4]);
<a name="l00293"></a>00293   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd2ndx = d1yd2ndxi * dxidx[4] + d1yd2ndeta * detadx[4];
<a name="l00294"></a>00294   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd2ndy = d1yd2ndxi * dxidy[4] + d1yd2ndeta * detady[4];
<a name="l00295"></a>00295   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd3ndxi  = clough_raw_shape_deriv(4, 0, dofpt[5]);
<a name="l00296"></a>00296   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd3ndeta = clough_raw_shape_deriv(4, 1, dofpt[5]);
<a name="l00297"></a>00297   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd3ndx = d1yd3ndxi * dxidx[5] + d1yd3ndeta * detadx[5];
<a name="l00298"></a>00298   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd3ndy = d1yd3ndxi * dxidy[5] + d1yd3ndeta * detady[5];
<a name="l00299"></a>00299   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd3ndxi  = clough_raw_shape_deriv(5, 0, dofpt[5]);
<a name="l00300"></a>00300   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd3ndeta = clough_raw_shape_deriv(5, 1, dofpt[5]);
<a name="l00301"></a>00301   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd3ndx = d2xd3ndxi * dxidx[5] + d2xd3ndeta * detadx[5];
<a name="l00302"></a>00302   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd3ndy = d2xd3ndxi * dxidy[5] + d2xd3ndeta * detady[5];
<a name="l00303"></a>00303   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd1ndxi  = clough_raw_shape_deriv(5, 0, dofpt[3]);
<a name="l00304"></a>00304   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd1ndeta = clough_raw_shape_deriv(5, 1, dofpt[3]);
<a name="l00305"></a>00305   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd1ndx = d2xd1ndxi * dxidx[3] + d2xd1ndeta * detadx[3];
<a name="l00306"></a>00306   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd1ndy = d2xd1ndxi * dxidy[3] + d2xd1ndeta * detady[3];
<a name="l00307"></a>00307   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd3ndxi  = clough_raw_shape_deriv(6, 0, dofpt[5]);
<a name="l00308"></a>00308   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd3ndeta = clough_raw_shape_deriv(6, 1, dofpt[5]);
<a name="l00309"></a>00309   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd3ndx = d2yd3ndxi * dxidx[5] + d2yd3ndeta * detadx[5];
<a name="l00310"></a>00310   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd3ndy = d2yd3ndxi * dxidy[5] + d2yd3ndeta * detady[5];
<a name="l00311"></a>00311   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd1ndxi  = clough_raw_shape_deriv(6, 0, dofpt[3]);
<a name="l00312"></a>00312   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd1ndeta = clough_raw_shape_deriv(6, 1, dofpt[3]);
<a name="l00313"></a>00313   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd1ndx = d2yd1ndxi * dxidx[3] + d2yd1ndeta * detadx[3];
<a name="l00314"></a>00314   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd1ndy = d2yd1ndxi * dxidy[3] + d2yd1ndeta * detady[3];
<a name="l00315"></a>00315   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd1ndxi  = clough_raw_shape_deriv(7, 0, dofpt[3]);
<a name="l00316"></a>00316   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd1ndeta = clough_raw_shape_deriv(7, 1, dofpt[3]);
<a name="l00317"></a>00317   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd1ndx = d3xd1ndxi * dxidx[3] + d3xd1ndeta * detadx[3];
<a name="l00318"></a>00318   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd1ndy = d3xd1ndxi * dxidy[3] + d3xd1ndeta * detady[3];
<a name="l00319"></a>00319   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd2ndxi  = clough_raw_shape_deriv(7, 0, dofpt[4]);
<a name="l00320"></a>00320   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd2ndeta = clough_raw_shape_deriv(7, 1, dofpt[4]);
<a name="l00321"></a>00321   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd2ndx = d3xd2ndxi * dxidx[4] + d3xd2ndeta * detadx[4];
<a name="l00322"></a>00322   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd2ndy = d3xd2ndxi * dxidy[4] + d3xd2ndeta * detady[4];
<a name="l00323"></a>00323   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd1ndxi  = clough_raw_shape_deriv(8, 0, dofpt[3]);
<a name="l00324"></a>00324   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd1ndeta = clough_raw_shape_deriv(8, 1, dofpt[3]);
<a name="l00325"></a>00325   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd1ndx = d3yd1ndxi * dxidx[3] + d3yd1ndeta * detadx[3];
<a name="l00326"></a>00326   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd1ndy = d3yd1ndxi * dxidy[3] + d3yd1ndeta * detady[3];
<a name="l00327"></a>00327   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd2ndxi  = clough_raw_shape_deriv(8, 0, dofpt[4]);
<a name="l00328"></a>00328   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd2ndeta = clough_raw_shape_deriv(8, 1, dofpt[4]);
<a name="l00329"></a>00329   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd2ndx = d3yd2ndxi * dxidx[4] + d3yd2ndeta * detadx[4];
<a name="l00330"></a>00330   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd2ndy = d3yd2ndxi * dxidy[4] + d3yd2ndeta * detady[4];
<a name="l00331"></a>00331   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1nd1ndxi  = clough_raw_shape_deriv(9, 0, dofpt[3]);
<a name="l00332"></a>00332   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1nd1ndeta = clough_raw_shape_deriv(9, 1, dofpt[3]);
<a name="l00333"></a>00333   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1nd1ndx = d1nd1ndxi * dxidx[3] + d1nd1ndeta * detadx[3];
<a name="l00334"></a>00334   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1nd1ndy = d1nd1ndxi * dxidy[3] + d1nd1ndeta * detady[3];
<a name="l00335"></a>00335   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2nd2ndxi  = clough_raw_shape_deriv(10, 0, dofpt[4]);
<a name="l00336"></a>00336   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2nd2ndeta = clough_raw_shape_deriv(10, 1, dofpt[4]);
<a name="l00337"></a>00337   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2nd2ndx = d2nd2ndxi * dxidx[4] + d2nd2ndeta * detadx[4];
<a name="l00338"></a>00338   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2nd2ndy = d2nd2ndxi * dxidy[4] + d2nd2ndeta * detady[4];
<a name="l00339"></a>00339   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3nd3ndxi  = clough_raw_shape_deriv(11, 0, dofpt[5]);
<a name="l00340"></a>00340   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3nd3ndeta = clough_raw_shape_deriv(11, 1, dofpt[5]);
<a name="l00341"></a>00341   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3nd3ndx = d3nd3ndxi * dxidx[3] + d3nd3ndeta * detadx[3];
<a name="l00342"></a>00342   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3nd3ndy = d3nd3ndxi * dxidy[3] + d3nd3ndeta * detady[3];
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd1dxi   = clough_raw_shape_deriv(3, 0, dofpt[0]);
<a name="l00345"></a>00345   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd1deta  = clough_raw_shape_deriv(3, 1, dofpt[0]);
<a name="l00346"></a>00346   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd1dx    = d1xd1dxi * dxidx[0] + d1xd1deta * detadx[0];
<a name="l00347"></a>00347   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd1dy    = d1xd1dxi * dxidy[0] + d1xd1deta * detady[0];
<a name="l00348"></a>00348   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd1dxi   = clough_raw_shape_deriv(4, 0, dofpt[0]);
<a name="l00349"></a>00349   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd1deta  = clough_raw_shape_deriv(4, 1, dofpt[0]);
<a name="l00350"></a>00350   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd1dx    = d1yd1dxi * dxidx[0] + d1yd1deta * detadx[0];
<a name="l00351"></a>00351   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd1dy    = d1yd1dxi * dxidy[0] + d1yd1deta * detady[0];
<a name="l00352"></a>00352   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd2dxi   = clough_raw_shape_deriv(5, 0, dofpt[1]);
<a name="l00353"></a>00353   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd2deta  = clough_raw_shape_deriv(5, 1, dofpt[1]);
<a name="l00354"></a>00354   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd2dx    = d2xd2dxi * dxidx[1] + d2xd2deta * detadx[1];
<a name="l00355"></a>00355   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd2dy    = d2xd2dxi * dxidy[1] + d2xd2deta * detady[1];
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="comment">//  libMesh::err &lt;&lt; dofpt[4](0) &lt;&lt; &#39; &#39;;</span>
<a name="l00358"></a>00358 <span class="comment">//  libMesh::err &lt;&lt; dofpt[4](1) &lt;&lt; &#39; &#39;;</span>
<a name="l00359"></a>00359 <span class="comment">//  libMesh::err &lt;&lt; (int)subtriangle_lookup(dofpt[5]) &lt;&lt; &#39; &#39;;</span>
<a name="l00360"></a>00360 <span class="comment">//  libMesh::err &lt;&lt; dxdxi[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00361"></a>00361 <span class="comment">//  libMesh::err &lt;&lt; dxdeta[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00362"></a>00362 <span class="comment">//  libMesh::err &lt;&lt; dydxi[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00363"></a>00363 <span class="comment">//  libMesh::err &lt;&lt; dydeta[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00364"></a>00364 <span class="comment">//  libMesh::err &lt;&lt; dxidx[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00365"></a>00365 <span class="comment">//  libMesh::err &lt;&lt; dxidy[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00366"></a>00366 <span class="comment">//  libMesh::err &lt;&lt; detadx[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00367"></a>00367 <span class="comment">//  libMesh::err &lt;&lt; detady[4] &lt;&lt; &#39; &#39;;</span>
<a name="l00368"></a>00368 <span class="comment">//  libMesh::err &lt;&lt; N1x &lt;&lt; &#39; &#39;;</span>
<a name="l00369"></a>00369 <span class="comment">//  libMesh::err &lt;&lt; N1y &lt;&lt; &#39; &#39;;</span>
<a name="l00370"></a>00370 <span class="comment">//  libMesh::err &lt;&lt; d2yd1ndxi &lt;&lt; &#39; &#39;;</span>
<a name="l00371"></a>00371 <span class="comment">//  libMesh::err &lt;&lt; d2yd1ndeta &lt;&lt; &#39; &#39;;</span>
<a name="l00372"></a>00372 <span class="comment">//  libMesh::err &lt;&lt; d2yd1ndx &lt;&lt; &#39; &#39;;</span>
<a name="l00373"></a>00373 <span class="comment">//  libMesh::err &lt;&lt; d2yd1ndy &lt;&lt; std::endl;</span>
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd2dxi   = clough_raw_shape_deriv(6, 0, dofpt[1]);
<a name="l00376"></a>00376   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd2deta  = clough_raw_shape_deriv(6, 1, dofpt[1]);
<a name="l00377"></a>00377   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd2dx    = d2yd2dxi * dxidx[1] + d2yd2deta * detadx[1];
<a name="l00378"></a>00378   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd2dy    = d2yd2dxi * dxidy[1] + d2yd2deta * detady[1];
<a name="l00379"></a>00379   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd3dxi   = clough_raw_shape_deriv(7, 0, dofpt[2]);
<a name="l00380"></a>00380   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd3deta  = clough_raw_shape_deriv(7, 1, dofpt[2]);
<a name="l00381"></a>00381   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd3dx    = d3xd3dxi * dxidx[1] + d3xd3deta * detadx[1];
<a name="l00382"></a>00382   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd3dy    = d3xd3dxi * dxidy[1] + d3xd3deta * detady[1];
<a name="l00383"></a>00383   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd3dxi   = clough_raw_shape_deriv(8, 0, dofpt[2]);
<a name="l00384"></a>00384   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd3deta  = clough_raw_shape_deriv(8, 1, dofpt[2]);
<a name="l00385"></a>00385   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd3dx    = d3yd3dxi * dxidx[1] + d3yd3deta * detadx[1];
<a name="l00386"></a>00386   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd3dy    = d3yd3dxi * dxidy[1] + d3yd3deta * detady[1];
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="comment">// Calculate normal derivatives</span>
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1nd1ndn = d1nd1ndx * N1x + d1nd1ndy * N1y;
<a name="l00391"></a>00391   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd2ndn = d1xd2ndx * N2x + d1xd2ndy * N2y;
<a name="l00392"></a>00392   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd3ndn = d1xd3ndx * N3x + d1xd3ndy * N3y;
<a name="l00393"></a>00393   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd2ndn = d1yd2ndx * N2x + d1yd2ndy * N2y;
<a name="l00394"></a>00394   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1yd3ndn = d1yd3ndx * N3x + d1yd3ndy * N3y;
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2nd2ndn = d2nd2ndx * N2x + d2nd2ndy * N2y;
<a name="l00397"></a>00397   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd3ndn = d2xd3ndx * N3x + d2xd3ndy * N3y;
<a name="l00398"></a>00398   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2xd1ndn = d2xd1ndx * N1x + d2xd1ndy * N1y;
<a name="l00399"></a>00399   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd3ndn = d2yd3ndx * N3x + d2yd3ndy * N3y;
<a name="l00400"></a>00400   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d2yd1ndn = d2yd1ndx * N1x + d2yd1ndy * N1y;
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3nd3ndn = d3nd3ndx * N3x + d3nd3ndy * N3y;
<a name="l00403"></a>00403   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd1ndn = d3xd1ndx * N1x + d3xd1ndy * N1y;
<a name="l00404"></a>00404   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3xd2ndn = d3xd2ndx * N2x + d3xd2ndy * N2y;
<a name="l00405"></a>00405   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd1ndn = d3yd1ndx * N1x + d3yd1ndy * N1y;
<a name="l00406"></a>00406   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d3yd2ndn = d3yd2ndx * N2x + d3yd2ndy * N2y;
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   <span class="comment">// Calculate midpoint scaling factors</span>
<a name="l00409"></a>00409   
<a name="l00410"></a>00410   d1nd1n = 1. / d1nd1ndn;
<a name="l00411"></a>00411   d2nd2n = 1. / d2nd2ndn;
<a name="l00412"></a>00412   d3nd3n = 1. / d3nd3ndn;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">// Calculate midpoint derivative adjustments to nodal value</span>
<a name="l00415"></a>00415   <span class="comment">// interpolant functions</span>
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   d1d2n = -(d1d2ndx * N2x + d1d2ndy * N2y) / d2nd2ndn;
<a name="l00418"></a>00418   d1d3n = -(d1d3ndx * N3x + d1d3ndy * N3y) / d3nd3ndn;
<a name="l00419"></a>00419   d2d3n = -(d2d3ndx * N3x + d2d3ndy * N3y) / d3nd3ndn;
<a name="l00420"></a>00420   d2d1n = -(d2d1ndx * N1x + d2d1ndy * N1y) / d1nd1ndn;
<a name="l00421"></a>00421   d3d1n = -(d3d1ndx * N1x + d3d1ndy * N1y) / d1nd1ndn;
<a name="l00422"></a>00422   d3d2n = -(d3d2ndx * N2x + d3d2ndy * N2y) / d2nd2ndn;
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <span class="comment">// Calculate nodal derivative scaling factors</span>
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   d1xd1x = 1. / (d1xd1dx - d1xd1dy * d1yd1dx / d1yd1dy);
<a name="l00427"></a>00427   d1xd1y = 1. / (d1yd1dx - d1xd1dx * d1yd1dy / d1xd1dy);
<a name="l00428"></a>00428 <span class="comment">//  d1xd1y = - d1xd1x * (d1xd1dy / d1yd1dy);</span>
<a name="l00429"></a>00429   d1yd1y = 1. / (d1yd1dy - d1yd1dx * d1xd1dy / d1xd1dx);
<a name="l00430"></a>00430   d1yd1x = 1. / (d1xd1dy - d1yd1dy * d1xd1dx / d1yd1dx);
<a name="l00431"></a>00431 <span class="comment">//  d1yd1x = - d1yd1y * (d1yd1dx / d1xd1dx);</span>
<a name="l00432"></a>00432   d2xd2x = 1. / (d2xd2dx - d2xd2dy * d2yd2dx / d2yd2dy);
<a name="l00433"></a>00433   d2xd2y = 1. / (d2yd2dx - d2xd2dx * d2yd2dy / d2xd2dy);
<a name="l00434"></a>00434 <span class="comment">//  d2xd2y = - d2xd2x * (d2xd2dy / d2yd2dy);</span>
<a name="l00435"></a>00435   d2yd2y = 1. / (d2yd2dy - d2yd2dx * d2xd2dy / d2xd2dx);
<a name="l00436"></a>00436   d2yd2x = 1. / (d2xd2dy - d2yd2dy * d2xd2dx / d2yd2dx);
<a name="l00437"></a>00437 <span class="comment">//  d2yd2x = - d2yd2y * (d2yd2dx / d2xd2dx);</span>
<a name="l00438"></a>00438   d3xd3x = 1. / (d3xd3dx - d3xd3dy * d3yd3dx / d3yd3dy);
<a name="l00439"></a>00439   d3xd3y = 1. / (d3yd3dx - d3xd3dx * d3yd3dy / d3xd3dy);
<a name="l00440"></a>00440 <span class="comment">//  d3xd3y = - d3xd3x * (d3xd3dy / d3yd3dy);</span>
<a name="l00441"></a>00441   d3yd3y = 1. / (d3yd3dy - d3yd3dx * d3xd3dy / d3xd3dx);
<a name="l00442"></a>00442   d3yd3x = 1. / (d3xd3dy - d3yd3dy * d3xd3dx / d3yd3dx);
<a name="l00443"></a>00443 <span class="comment">//  d3yd3x = - d3yd3y * (d3yd3dx / d3xd3dx);</span>
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="comment">//  libMesh::err &lt;&lt; d1xd1dx &lt;&lt; &#39; &#39;;</span>
<a name="l00446"></a>00446 <span class="comment">//  libMesh::err &lt;&lt; d1xd1dy &lt;&lt; &#39; &#39;;</span>
<a name="l00447"></a>00447 <span class="comment">//  libMesh::err &lt;&lt; d1yd1dx &lt;&lt; &#39; &#39;;</span>
<a name="l00448"></a>00448 <span class="comment">//  libMesh::err &lt;&lt; d1yd1dy &lt;&lt; &#39; &#39;;</span>
<a name="l00449"></a>00449 <span class="comment">//  libMesh::err &lt;&lt; d2xd2dx &lt;&lt; &#39; &#39;;</span>
<a name="l00450"></a>00450 <span class="comment">//  libMesh::err &lt;&lt; d2xd2dy &lt;&lt; &#39; &#39;;</span>
<a name="l00451"></a>00451 <span class="comment">//  libMesh::err &lt;&lt; d2yd2dx &lt;&lt; &#39; &#39;;</span>
<a name="l00452"></a>00452 <span class="comment">//  libMesh::err &lt;&lt; d2yd2dy &lt;&lt; &#39; &#39;;</span>
<a name="l00453"></a>00453 <span class="comment">//  libMesh::err &lt;&lt; d3xd3dx &lt;&lt; &#39; &#39;;</span>
<a name="l00454"></a>00454 <span class="comment">//  libMesh::err &lt;&lt; d3xd3dy &lt;&lt; &#39; &#39;;</span>
<a name="l00455"></a>00455 <span class="comment">//  libMesh::err &lt;&lt; d3yd3dx &lt;&lt; &#39; &#39;;</span>
<a name="l00456"></a>00456 <span class="comment">//  libMesh::err &lt;&lt; d3yd3dy &lt;&lt; std::endl;</span>
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="comment">// Calculate midpoint derivative adjustments to nodal derivative</span>
<a name="l00459"></a>00459   <span class="comment">// interpolant functions</span>
<a name="l00460"></a>00460   
<a name="l00461"></a>00461   d1xd2n = -(d1xd1x * d1xd2ndn + d1xd1y * d1yd2ndn) / d2nd2ndn;
<a name="l00462"></a>00462   d1yd2n = -(d1yd1y * d1yd2ndn + d1yd1x * d1xd2ndn) / d2nd2ndn;
<a name="l00463"></a>00463   d1xd3n = -(d1xd1x * d1xd3ndn + d1xd1y * d1yd3ndn) / d3nd3ndn;
<a name="l00464"></a>00464   d1yd3n = -(d1yd1y * d1yd3ndn + d1yd1x * d1xd3ndn) / d3nd3ndn;
<a name="l00465"></a>00465   d2xd3n = -(d2xd2x * d2xd3ndn + d2xd2y * d2yd3ndn) / d3nd3ndn;
<a name="l00466"></a>00466   d2yd3n = -(d2yd2y * d2yd3ndn + d2yd2x * d2xd3ndn) / d3nd3ndn;
<a name="l00467"></a>00467   d2xd1n = -(d2xd2x * d2xd1ndn + d2xd2y * d2yd1ndn) / d1nd1ndn;
<a name="l00468"></a>00468   d2yd1n = -(d2yd2y * d2yd1ndn + d2yd2x * d2xd1ndn) / d1nd1ndn;
<a name="l00469"></a>00469   d3xd1n = -(d3xd3x * d3xd1ndn + d3xd3y * d3yd1ndn) / d1nd1ndn;
<a name="l00470"></a>00470   d3yd1n = -(d3yd3y * d3yd1ndn + d3yd3x * d3xd1ndn) / d1nd1ndn;
<a name="l00471"></a>00471   d3xd2n = -(d3xd3x * d3xd2ndn + d3xd3y * d3yd2ndn) / d2nd2ndn;
<a name="l00472"></a>00472   d3yd2n = -(d3yd3y * d3yd2ndn + d3yd3x * d3xd2ndn) / d2nd2ndn;
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="comment">// Cross your fingers</span>
<a name="l00475"></a>00475 <span class="comment">//  libMesh::err &lt;&lt; d1nd1ndn &lt;&lt; &#39; &#39;;</span>
<a name="l00476"></a>00476 <span class="comment">//  libMesh::err &lt;&lt; d2xd1ndn &lt;&lt; &#39; &#39;;</span>
<a name="l00477"></a>00477 <span class="comment">//  libMesh::err &lt;&lt; d2yd1ndn &lt;&lt; &#39; &#39;;</span>
<a name="l00478"></a>00478 <span class="comment">//  libMesh::err &lt;&lt; std::endl;</span>
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 <span class="comment">//  libMesh::err &lt;&lt; &quot;Transform variables: &quot;;</span>
<a name="l00481"></a>00481 <span class="comment">//  libMesh::err &lt;&lt; d1nd1n &lt;&lt; &#39; &#39;;</span>
<a name="l00482"></a>00482 <span class="comment">//  libMesh::err &lt;&lt; d2nd2n &lt;&lt; &#39; &#39;;</span>
<a name="l00483"></a>00483 <span class="comment">//  libMesh::err &lt;&lt; d3nd3n &lt;&lt; &#39; &#39;;</span>
<a name="l00484"></a>00484 <span class="comment">//  libMesh::err &lt;&lt; d1d2n &lt;&lt; &#39; &#39;;</span>
<a name="l00485"></a>00485 <span class="comment">//  libMesh::err &lt;&lt; d1d3n &lt;&lt; &#39; &#39;;</span>
<a name="l00486"></a>00486 <span class="comment">//  libMesh::err &lt;&lt; d2d3n &lt;&lt; &#39; &#39;;</span>
<a name="l00487"></a>00487 <span class="comment">//  libMesh::err &lt;&lt; d2d1n &lt;&lt; &#39; &#39;;</span>
<a name="l00488"></a>00488 <span class="comment">//  libMesh::err &lt;&lt; d3d1n &lt;&lt; &#39; &#39;;</span>
<a name="l00489"></a>00489 <span class="comment">//  libMesh::err &lt;&lt; d3d2n &lt;&lt; std::endl;</span>
<a name="l00490"></a>00490 <span class="comment">//  libMesh::err &lt;&lt; d1xd1x &lt;&lt; &#39; &#39;;</span>
<a name="l00491"></a>00491 <span class="comment">//  libMesh::err &lt;&lt; d1xd1y &lt;&lt; &#39; &#39;;</span>
<a name="l00492"></a>00492 <span class="comment">//  libMesh::err &lt;&lt; d1yd1x &lt;&lt; &#39; &#39;;</span>
<a name="l00493"></a>00493 <span class="comment">//  libMesh::err &lt;&lt; d1yd1y &lt;&lt; &#39; &#39;;</span>
<a name="l00494"></a>00494 <span class="comment">//  libMesh::err &lt;&lt; d2xd2x &lt;&lt; &#39; &#39;;</span>
<a name="l00495"></a>00495 <span class="comment">//  libMesh::err &lt;&lt; d2xd2y &lt;&lt; &#39; &#39;;</span>
<a name="l00496"></a>00496 <span class="comment">//  libMesh::err &lt;&lt; d2yd2x &lt;&lt; &#39; &#39;;</span>
<a name="l00497"></a>00497 <span class="comment">//  libMesh::err &lt;&lt; d2yd2y &lt;&lt; &#39; &#39;;</span>
<a name="l00498"></a>00498 <span class="comment">//  libMesh::err &lt;&lt; d3xd3x &lt;&lt; &#39; &#39;;</span>
<a name="l00499"></a>00499 <span class="comment">//  libMesh::err &lt;&lt; d3xd3y &lt;&lt; &#39; &#39;;</span>
<a name="l00500"></a>00500 <span class="comment">//  libMesh::err &lt;&lt; d3yd3x &lt;&lt; &#39; &#39;;</span>
<a name="l00501"></a>00501 <span class="comment">//  libMesh::err &lt;&lt; d3yd3y &lt;&lt; std::endl;</span>
<a name="l00502"></a>00502 <span class="comment">//  libMesh::err &lt;&lt; d1xd2n &lt;&lt; &#39; &#39;;</span>
<a name="l00503"></a>00503 <span class="comment">//  libMesh::err &lt;&lt; d1yd2n &lt;&lt; &#39; &#39;;</span>
<a name="l00504"></a>00504 <span class="comment">//  libMesh::err &lt;&lt; d1xd3n &lt;&lt; &#39; &#39;;</span>
<a name="l00505"></a>00505 <span class="comment">//  libMesh::err &lt;&lt; d1yd3n &lt;&lt; &#39; &#39;;</span>
<a name="l00506"></a>00506 <span class="comment">//  libMesh::err &lt;&lt; d2xd3n &lt;&lt; &#39; &#39;;</span>
<a name="l00507"></a>00507 <span class="comment">//  libMesh::err &lt;&lt; d2yd3n &lt;&lt; &#39; &#39;;</span>
<a name="l00508"></a>00508 <span class="comment">//  libMesh::err &lt;&lt; d2xd1n &lt;&lt; &#39; &#39;;</span>
<a name="l00509"></a>00509 <span class="comment">//  libMesh::err &lt;&lt; d2yd1n &lt;&lt; &#39; &#39;;</span>
<a name="l00510"></a>00510 <span class="comment">//  libMesh::err &lt;&lt; d3xd1n &lt;&lt; &#39; &#39;;</span>
<a name="l00511"></a>00511 <span class="comment">//  libMesh::err &lt;&lt; d3yd1n &lt;&lt; &#39; &#39;;</span>
<a name="l00512"></a>00512 <span class="comment">//  libMesh::err &lt;&lt; d3xd2n &lt;&lt; &#39; &#39;;</span>
<a name="l00513"></a>00513 <span class="comment">//  libMesh::err &lt;&lt; d3yd2n &lt;&lt; &#39; &#39;;</span>
<a name="l00514"></a>00514 <span class="comment">//  libMesh::err &lt;&lt; std::endl;</span>
<a name="l00515"></a>00515 <span class="comment">//  libMesh::err &lt;&lt; std::endl;</span>
<a name="l00516"></a>00516 }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> subtriangle_lookup(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00520"></a>00520 {
<a name="l00521"></a>00521   <span class="keywordflow">if</span> ((p(0) &gt;= p(1)) &amp;&amp; (p(0) + 2 * p(1) &lt;= 1))
<a name="l00522"></a>00522     <span class="keywordflow">return</span> 0;
<a name="l00523"></a>00523   <span class="keywordflow">if</span> ((p(0) &lt;= p(1)) &amp;&amp; (p(1) + 2 * p(0) &lt;= 1))
<a name="l00524"></a>00524     <span class="keywordflow">return</span> 2;
<a name="l00525"></a>00525   <span class="keywordflow">return</span> 1;
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   <span class="comment">// Return shape function second derivatives on the unit right</span>
<a name="l00529"></a>00529   <span class="comment">// triangle</span>
<a name="l00530"></a>00530 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_second_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00531"></a>00531                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00532"></a>00532                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00533"></a>00533 {
<a name="l00534"></a>00534   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0), eta = p(1);
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   <span class="keywordflow">switch</span> (deriv_type)
<a name="l00537"></a>00537   {
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="comment">// second derivative in xi-xi direction</span>
<a name="l00540"></a>00540   <span class="keywordflow">case</span> 0:
<a name="l00541"></a>00541   <span class="keywordflow">switch</span> (basis_num)
<a name="l00542"></a>00542     {
<a name="l00543"></a>00543       <span class="keywordflow">case</span> 0:
<a name="l00544"></a>00544         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00545"></a>00545           {
<a name="l00546"></a>00546             <span class="keywordflow">case</span> 0:
<a name="l00547"></a>00547               <span class="keywordflow">return</span> -6 + 12*xi;
<a name="l00548"></a>00548             <span class="keywordflow">case</span> 1:
<a name="l00549"></a>00549               <span class="keywordflow">return</span> -30 + 42*xi + 42*eta;
<a name="l00550"></a>00550             <span class="keywordflow">case</span> 2:
<a name="l00551"></a>00551               <span class="keywordflow">return</span> -6 + 18*xi - 6*eta;
<a name="l00552"></a>00552           }
<a name="l00553"></a>00553       <span class="keywordflow">case</span> 1:
<a name="l00554"></a>00554         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00555"></a>00555           {
<a name="l00556"></a>00556             <span class="keywordflow">case</span> 0:
<a name="l00557"></a>00557               <span class="keywordflow">return</span> 6 - 12*xi;
<a name="l00558"></a>00558             <span class="keywordflow">case</span> 1:
<a name="l00559"></a>00559               <span class="keywordflow">return</span> 18 - 27*xi - 21*eta;
<a name="l00560"></a>00560             <span class="keywordflow">case</span> 2:
<a name="l00561"></a>00561               <span class="keywordflow">return</span> 6 - 15*xi + 3*eta;
<a name="l00562"></a>00562           }
<a name="l00563"></a>00563       <span class="keywordflow">case</span> 2:
<a name="l00564"></a>00564         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00565"></a>00565           {
<a name="l00566"></a>00566             <span class="keywordflow">case</span> 0:
<a name="l00567"></a>00567               <span class="keywordflow">return</span> 0;
<a name="l00568"></a>00568             <span class="keywordflow">case</span> 1:
<a name="l00569"></a>00569               <span class="keywordflow">return</span> 12 - 15*xi - 21*eta;
<a name="l00570"></a>00570             <span class="keywordflow">case</span> 2:
<a name="l00571"></a>00571               <span class="keywordflow">return</span> -3*xi + 3*eta;
<a name="l00572"></a>00572           }
<a name="l00573"></a>00573       <span class="keywordflow">case</span> 3:
<a name="l00574"></a>00574         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00575"></a>00575           {
<a name="l00576"></a>00576             <span class="keywordflow">case</span> 0:
<a name="l00577"></a>00577               <span class="keywordflow">return</span> -4 + 6*xi;
<a name="l00578"></a>00578             <span class="keywordflow">case</span> 1:
<a name="l00579"></a>00579               <span class="keywordflow">return</span> -9 + 13*xi + 8*eta;
<a name="l00580"></a>00580             <span class="keywordflow">case</span> 2:
<a name="l00581"></a>00581               <span class="keywordflow">return</span> -1 - 7*xi + 4*eta;
<a name="l00582"></a>00582           }
<a name="l00583"></a>00583       <span class="keywordflow">case</span> 4:
<a name="l00584"></a>00584         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00585"></a>00585           {
<a name="l00586"></a>00586             <span class="keywordflow">case</span> 0:
<a name="l00587"></a>00587               <span class="keywordflow">return</span> 4*eta;
<a name="l00588"></a>00588             <span class="keywordflow">case</span> 1:
<a name="l00589"></a>00589               <span class="keywordflow">return</span> 1 - 2*xi + 3*eta;
<a name="l00590"></a>00590             <span class="keywordflow">case</span> 2:
<a name="l00591"></a>00591               <span class="keywordflow">return</span> -3 + 14*xi - eta;
<a name="l00592"></a>00592           }
<a name="l00593"></a>00593       <span class="keywordflow">case</span> 5:
<a name="l00594"></a>00594         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00595"></a>00595           {
<a name="l00596"></a>00596             <span class="keywordflow">case</span> 0:
<a name="l00597"></a>00597               <span class="keywordflow">return</span> -2 + 6*xi;
<a name="l00598"></a>00598             <span class="keywordflow">case</span> 1:
<a name="l00599"></a>00599               <span class="keywordflow">return</span> -4 + 17./2.*xi + 7./2.*eta;
<a name="l00600"></a>00600             <span class="keywordflow">case</span> 2:
<a name="l00601"></a>00601               <span class="keywordflow">return</span> -2 + 13./2.*xi - 1./2.*eta;
<a name="l00602"></a>00602           }
<a name="l00603"></a>00603       <span class="keywordflow">case</span> 6:
<a name="l00604"></a>00604         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00605"></a>00605           {
<a name="l00606"></a>00606             <span class="keywordflow">case</span> 0:
<a name="l00607"></a>00607               <span class="keywordflow">return</span> 4*eta;
<a name="l00608"></a>00608             <span class="keywordflow">case</span> 1:
<a name="l00609"></a>00609               <span class="keywordflow">return</span> 9 - 23./2.*xi - 23./2.*eta;
<a name="l00610"></a>00610             <span class="keywordflow">case</span> 2:
<a name="l00611"></a>00611               <span class="keywordflow">return</span> -1 + 5./2.*xi + 9./2.*eta;
<a name="l00612"></a>00612           }
<a name="l00613"></a>00613       <span class="keywordflow">case</span> 7:
<a name="l00614"></a>00614         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00615"></a>00615           {
<a name="l00616"></a>00616             <span class="keywordflow">case</span> 0:
<a name="l00617"></a>00617               <span class="keywordflow">return</span> 0;
<a name="l00618"></a>00618             <span class="keywordflow">case</span> 1:
<a name="l00619"></a>00619               <span class="keywordflow">return</span> 7 - 17./2.*xi - 25./2.*eta;
<a name="l00620"></a>00620             <span class="keywordflow">case</span> 2:
<a name="l00621"></a>00621               <span class="keywordflow">return</span> 1 - 13./2.*xi + 7./2.*eta;
<a name="l00622"></a>00622           }
<a name="l00623"></a>00623       <span class="keywordflow">case</span> 8:
<a name="l00624"></a>00624         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00625"></a>00625           {
<a name="l00626"></a>00626             <span class="keywordflow">case</span> 0:
<a name="l00627"></a>00627               <span class="keywordflow">return</span> 0;
<a name="l00628"></a>00628             <span class="keywordflow">case</span> 1:
<a name="l00629"></a>00629               <span class="keywordflow">return</span> -2 + 5./2.*xi + 7./2.*eta;
<a name="l00630"></a>00630             <span class="keywordflow">case</span> 2:
<a name="l00631"></a>00631               <span class="keywordflow">return</span> 1./2.*xi - 1./2.*eta;
<a name="l00632"></a>00632           }
<a name="l00633"></a>00633       <span class="keywordflow">case</span> 9:
<a name="l00634"></a>00634         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00635"></a>00635           {
<a name="l00636"></a>00636             <span class="keywordflow">case</span> 0:
<a name="l00637"></a>00637               <span class="keywordflow">return</span> 0;
<a name="l00638"></a>00638             <span class="keywordflow">case</span> 1:
<a name="l00639"></a>00639               <span class="keywordflow">return</span> std::sqrt(2.) * (8 - 10*xi - 14*eta);
<a name="l00640"></a>00640             <span class="keywordflow">case</span> 2:
<a name="l00641"></a>00641               <span class="keywordflow">return</span> std::sqrt(2.) * (-2*xi + 2*eta);
<a name="l00642"></a>00642           }
<a name="l00643"></a>00643       <span class="keywordflow">case</span> 10:
<a name="l00644"></a>00644         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00645"></a>00645           {
<a name="l00646"></a>00646             <span class="keywordflow">case</span> 0:
<a name="l00647"></a>00647               <span class="keywordflow">return</span> 0;
<a name="l00648"></a>00648             <span class="keywordflow">case</span> 1:
<a name="l00649"></a>00649               <span class="keywordflow">return</span> -4 + 4*xi + 8*eta;
<a name="l00650"></a>00650             <span class="keywordflow">case</span> 2:
<a name="l00651"></a>00651               <span class="keywordflow">return</span> -4 + 20*xi - 8*eta;
<a name="l00652"></a>00652           }
<a name="l00653"></a>00653       <span class="keywordflow">case</span> 11:
<a name="l00654"></a>00654         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00655"></a>00655           {
<a name="l00656"></a>00656             <span class="keywordflow">case</span> 0:
<a name="l00657"></a>00657               <span class="keywordflow">return</span> -8*eta;
<a name="l00658"></a>00658             <span class="keywordflow">case</span> 1:
<a name="l00659"></a>00659               <span class="keywordflow">return</span> -12 + 16*xi + 12*eta;
<a name="l00660"></a>00660             <span class="keywordflow">case</span> 2:
<a name="l00661"></a>00661               <span class="keywordflow">return</span> 4 - 16*xi - 4*eta;
<a name="l00662"></a>00662           }
<a name="l00663"></a>00663     }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="comment">// second derivative in xi-eta direction</span>
<a name="l00666"></a>00666   <span class="keywordflow">case</span> 1:
<a name="l00667"></a>00667   <span class="keywordflow">switch</span> (basis_num)
<a name="l00668"></a>00668     {
<a name="l00669"></a>00669       <span class="keywordflow">case</span> 0:
<a name="l00670"></a>00670         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00671"></a>00671           {
<a name="l00672"></a>00672             <span class="keywordflow">case</span> 0:
<a name="l00673"></a>00673               <span class="keywordflow">return</span> -6*eta;
<a name="l00674"></a>00674             <span class="keywordflow">case</span> 1:
<a name="l00675"></a>00675               <span class="keywordflow">return</span> -30 +42*xi
<a name="l00676"></a>00676                 + 42*eta;
<a name="l00677"></a>00677             <span class="keywordflow">case</span> 2:
<a name="l00678"></a>00678               <span class="keywordflow">return</span> -6*xi;
<a name="l00679"></a>00679           }
<a name="l00680"></a>00680       <span class="keywordflow">case</span> 1:
<a name="l00681"></a>00681         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00682"></a>00682           {
<a name="l00683"></a>00683             <span class="keywordflow">case</span> 0:
<a name="l00684"></a>00684               <span class="keywordflow">return</span> + 3*eta;
<a name="l00685"></a>00685             <span class="keywordflow">case</span> 1:
<a name="l00686"></a>00686               <span class="keywordflow">return</span> 15 - 21*xi - 21*eta;
<a name="l00687"></a>00687             <span class="keywordflow">case</span> 2:
<a name="l00688"></a>00688               <span class="keywordflow">return</span> 3*xi;
<a name="l00689"></a>00689           }
<a name="l00690"></a>00690       <span class="keywordflow">case</span> 2:
<a name="l00691"></a>00691         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00692"></a>00692           {
<a name="l00693"></a>00693             <span class="keywordflow">case</span> 0:
<a name="l00694"></a>00694               <span class="keywordflow">return</span> 3*eta;
<a name="l00695"></a>00695             <span class="keywordflow">case</span> 1:
<a name="l00696"></a>00696               <span class="keywordflow">return</span> 15 - 21*xi - 21*eta;
<a name="l00697"></a>00697             <span class="keywordflow">case</span> 2:
<a name="l00698"></a>00698               <span class="keywordflow">return</span> 3*xi;
<a name="l00699"></a>00699           }
<a name="l00700"></a>00700       <span class="keywordflow">case</span> 3:
<a name="l00701"></a>00701         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00702"></a>00702           {
<a name="l00703"></a>00703             <span class="keywordflow">case</span> 0:
<a name="l00704"></a>00704               <span class="keywordflow">return</span> -eta;
<a name="l00705"></a>00705             <span class="keywordflow">case</span> 1:
<a name="l00706"></a>00706               <span class="keywordflow">return</span> -4 + 8*xi + 3*eta;
<a name="l00707"></a>00707             <span class="keywordflow">case</span> 2:
<a name="l00708"></a>00708               <span class="keywordflow">return</span> -3 + 4*xi + 4*eta;
<a name="l00709"></a>00709           }
<a name="l00710"></a>00710       <span class="keywordflow">case</span> 4:
<a name="l00711"></a>00711         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00712"></a>00712           {
<a name="l00713"></a>00713             <span class="keywordflow">case</span> 0:
<a name="l00714"></a>00714               <span class="keywordflow">return</span> -3 + 4*xi + 4*eta;
<a name="l00715"></a>00715             <span class="keywordflow">case</span> 1:
<a name="l00716"></a>00716               <span class="keywordflow">return</span> - 4 + 3*xi + 8*eta;
<a name="l00717"></a>00717             <span class="keywordflow">case</span> 2:
<a name="l00718"></a>00718               <span class="keywordflow">return</span> -xi;
<a name="l00719"></a>00719           }
<a name="l00720"></a>00720       <span class="keywordflow">case</span> 5:
<a name="l00721"></a>00721         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00722"></a>00722           {
<a name="l00723"></a>00723             <span class="keywordflow">case</span> 0:
<a name="l00724"></a>00724               <span class="keywordflow">return</span> - 1./2.*eta;
<a name="l00725"></a>00725             <span class="keywordflow">case</span> 1:
<a name="l00726"></a>00726               <span class="keywordflow">return</span> -5./2. + 7./2.*xi + 7./2.*eta;
<a name="l00727"></a>00727             <span class="keywordflow">case</span> 2:
<a name="l00728"></a>00728               <span class="keywordflow">return</span> - 1./2.*xi;
<a name="l00729"></a>00729           }
<a name="l00730"></a>00730       <span class="keywordflow">case</span> 6:
<a name="l00731"></a>00731         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00732"></a>00732           {
<a name="l00733"></a>00733             <span class="keywordflow">case</span> 0:
<a name="l00734"></a>00734               <span class="keywordflow">return</span> -1 + 4*xi + 7./2.*eta;
<a name="l00735"></a>00735             <span class="keywordflow">case</span> 1:
<a name="l00736"></a>00736               <span class="keywordflow">return</span> 19./2. - 23./2.*xi - 25./2.*eta;
<a name="l00737"></a>00737             <span class="keywordflow">case</span> 2:
<a name="l00738"></a>00738               <span class="keywordflow">return</span> 9./2.*xi;
<a name="l00739"></a>00739           }
<a name="l00740"></a>00740       <span class="keywordflow">case</span> 7:
<a name="l00741"></a>00741         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00742"></a>00742           {
<a name="l00743"></a>00743             <span class="keywordflow">case</span> 0:
<a name="l00744"></a>00744               <span class="keywordflow">return</span> 9./2.*eta;
<a name="l00745"></a>00745             <span class="keywordflow">case</span> 1:
<a name="l00746"></a>00746               <span class="keywordflow">return</span> 19./2. - 25./2.*xi - 23./2.*eta;
<a name="l00747"></a>00747             <span class="keywordflow">case</span> 2:
<a name="l00748"></a>00748               <span class="keywordflow">return</span> -1 + 7./2.*xi + 4*eta;
<a name="l00749"></a>00749           }
<a name="l00750"></a>00750       <span class="keywordflow">case</span> 8:
<a name="l00751"></a>00751         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00752"></a>00752           {
<a name="l00753"></a>00753             <span class="keywordflow">case</span> 0:
<a name="l00754"></a>00754               <span class="keywordflow">return</span> -1./2.*eta;
<a name="l00755"></a>00755             <span class="keywordflow">case</span> 1:
<a name="l00756"></a>00756               <span class="keywordflow">return</span> -5./2. + 7./2.*xi + 7./2.*eta;
<a name="l00757"></a>00757             <span class="keywordflow">case</span> 2:
<a name="l00758"></a>00758               <span class="keywordflow">return</span> -1./2.*xi;
<a name="l00759"></a>00759           }
<a name="l00760"></a>00760       <span class="keywordflow">case</span> 9:
<a name="l00761"></a>00761         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00762"></a>00762           {
<a name="l00763"></a>00763             <span class="keywordflow">case</span> 0:
<a name="l00764"></a>00764               <span class="keywordflow">return</span> std::sqrt(2.) * (2*eta);
<a name="l00765"></a>00765             <span class="keywordflow">case</span> 1:
<a name="l00766"></a>00766               <span class="keywordflow">return</span> std::sqrt(2.) * (10 - 14*xi - 14*eta);
<a name="l00767"></a>00767             <span class="keywordflow">case</span> 2:
<a name="l00768"></a>00768               <span class="keywordflow">return</span> std::sqrt(2.) * (2*xi);
<a name="l00769"></a>00769           }
<a name="l00770"></a>00770       <span class="keywordflow">case</span> 10:
<a name="l00771"></a>00771         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00772"></a>00772           {
<a name="l00773"></a>00773             <span class="keywordflow">case</span> 0:
<a name="l00774"></a>00774               <span class="keywordflow">return</span> -4*eta;
<a name="l00775"></a>00775             <span class="keywordflow">case</span> 1:
<a name="l00776"></a>00776               <span class="keywordflow">return</span> - 8 + 8*xi + 12*eta;
<a name="l00777"></a>00777             <span class="keywordflow">case</span> 2:
<a name="l00778"></a>00778               <span class="keywordflow">return</span> 4 - 8*xi - 8*eta;
<a name="l00779"></a>00779           }
<a name="l00780"></a>00780       <span class="keywordflow">case</span> 11:
<a name="l00781"></a>00781         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00782"></a>00782           {
<a name="l00783"></a>00783             <span class="keywordflow">case</span> 0:
<a name="l00784"></a>00784               <span class="keywordflow">return</span> 4 - 8*xi - 8*eta;
<a name="l00785"></a>00785             <span class="keywordflow">case</span> 1:
<a name="l00786"></a>00786               <span class="keywordflow">return</span> -8 + 12*xi + 8*eta;
<a name="l00787"></a>00787             <span class="keywordflow">case</span> 2:
<a name="l00788"></a>00788               <span class="keywordflow">return</span> -4*xi;
<a name="l00789"></a>00789           }
<a name="l00790"></a>00790     }
<a name="l00791"></a>00791 
<a name="l00792"></a>00792   <span class="comment">// second derivative in eta-eta direction</span>
<a name="l00793"></a>00793   <span class="keywordflow">case</span> 2:
<a name="l00794"></a>00794   <span class="keywordflow">switch</span> (basis_num)
<a name="l00795"></a>00795     {
<a name="l00796"></a>00796       <span class="keywordflow">case</span> 0:
<a name="l00797"></a>00797         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00798"></a>00798           {
<a name="l00799"></a>00799             <span class="keywordflow">case</span> 0:
<a name="l00800"></a>00800               <span class="keywordflow">return</span> -6 - 6*xi + 18*eta;
<a name="l00801"></a>00801             <span class="keywordflow">case</span> 1:
<a name="l00802"></a>00802               <span class="keywordflow">return</span> -30 + 42*xi + 42*eta;
<a name="l00803"></a>00803             <span class="keywordflow">case</span> 2:
<a name="l00804"></a>00804               <span class="keywordflow">return</span> -6 + 12*eta;
<a name="l00805"></a>00805           }
<a name="l00806"></a>00806       <span class="keywordflow">case</span> 1:
<a name="l00807"></a>00807         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00808"></a>00808           {
<a name="l00809"></a>00809             <span class="keywordflow">case</span> 0:
<a name="l00810"></a>00810               <span class="keywordflow">return</span> 3*xi - 3*eta;
<a name="l00811"></a>00811             <span class="keywordflow">case</span> 1:
<a name="l00812"></a>00812               <span class="keywordflow">return</span> 12 - 21*xi - 15*eta;
<a name="l00813"></a>00813             <span class="keywordflow">case</span> 2:
<a name="l00814"></a>00814               <span class="keywordflow">return</span> 0;
<a name="l00815"></a>00815           }
<a name="l00816"></a>00816       <span class="keywordflow">case</span> 2:
<a name="l00817"></a>00817         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00818"></a>00818           {
<a name="l00819"></a>00819             <span class="keywordflow">case</span> 0:
<a name="l00820"></a>00820               <span class="keywordflow">return</span> 6 + 3*xi - 15*eta;
<a name="l00821"></a>00821             <span class="keywordflow">case</span> 1:
<a name="l00822"></a>00822               <span class="keywordflow">return</span> 18 - 21.*xi - 27*eta;
<a name="l00823"></a>00823             <span class="keywordflow">case</span> 2:
<a name="l00824"></a>00824               <span class="keywordflow">return</span> 6 - 12*eta;
<a name="l00825"></a>00825           }
<a name="l00826"></a>00826       <span class="keywordflow">case</span> 3:
<a name="l00827"></a>00827         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00828"></a>00828           {
<a name="l00829"></a>00829             <span class="keywordflow">case</span> 0:
<a name="l00830"></a>00830               <span class="keywordflow">return</span> -3 - xi + 14*eta;
<a name="l00831"></a>00831             <span class="keywordflow">case</span> 1:
<a name="l00832"></a>00832               <span class="keywordflow">return</span> 1 + 3*xi - 2*eta;
<a name="l00833"></a>00833             <span class="keywordflow">case</span> 2:
<a name="l00834"></a>00834               <span class="keywordflow">return</span> 4*xi;
<a name="l00835"></a>00835           }
<a name="l00836"></a>00836       <span class="keywordflow">case</span> 4:
<a name="l00837"></a>00837         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00838"></a>00838           {
<a name="l00839"></a>00839             <span class="keywordflow">case</span> 0:
<a name="l00840"></a>00840               <span class="keywordflow">return</span> -1 + 4*xi - 7*eta;
<a name="l00841"></a>00841             <span class="keywordflow">case</span> 1:
<a name="l00842"></a>00842               <span class="keywordflow">return</span> -9 + 8*xi + 13*eta;
<a name="l00843"></a>00843             <span class="keywordflow">case</span> 2:
<a name="l00844"></a>00844               <span class="keywordflow">return</span> -4 + 6*eta;
<a name="l00845"></a>00845           }
<a name="l00846"></a>00846       <span class="keywordflow">case</span> 5:
<a name="l00847"></a>00847         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00848"></a>00848           {
<a name="l00849"></a>00849             <span class="keywordflow">case</span> 0:
<a name="l00850"></a>00850               <span class="keywordflow">return</span> - 1./2.*xi + 1./2.*eta;
<a name="l00851"></a>00851             <span class="keywordflow">case</span> 1:
<a name="l00852"></a>00852               <span class="keywordflow">return</span> -2 + 7./2.*xi + 5./2.*eta;
<a name="l00853"></a>00853             <span class="keywordflow">case</span> 2:
<a name="l00854"></a>00854               <span class="keywordflow">return</span> 0;
<a name="l00855"></a>00855           }
<a name="l00856"></a>00856       <span class="keywordflow">case</span> 6:
<a name="l00857"></a>00857         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00858"></a>00858           {
<a name="l00859"></a>00859             <span class="keywordflow">case</span> 0:
<a name="l00860"></a>00860               <span class="keywordflow">return</span> 1 + 7./2.*xi - 13./2.*eta;
<a name="l00861"></a>00861             <span class="keywordflow">case</span> 1:
<a name="l00862"></a>00862               <span class="keywordflow">return</span> 7 - 25./2.*xi - 17./2.*eta;
<a name="l00863"></a>00863             <span class="keywordflow">case</span> 2:
<a name="l00864"></a>00864               <span class="keywordflow">return</span> 0;
<a name="l00865"></a>00865           }
<a name="l00866"></a>00866       <span class="keywordflow">case</span> 7:
<a name="l00867"></a>00867         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00868"></a>00868           {
<a name="l00869"></a>00869             <span class="keywordflow">case</span> 0:
<a name="l00870"></a>00870               <span class="keywordflow">return</span> -1 + 9./2.*xi + 5./2.*eta;
<a name="l00871"></a>00871             <span class="keywordflow">case</span> 1:
<a name="l00872"></a>00872               <span class="keywordflow">return</span> 9 - 23./2.*xi - 23./2.*eta;
<a name="l00873"></a>00873             <span class="keywordflow">case</span> 2:
<a name="l00874"></a>00874               <span class="keywordflow">return</span> 4*xi;
<a name="l00875"></a>00875           }
<a name="l00876"></a>00876       <span class="keywordflow">case</span> 8:
<a name="l00877"></a>00877         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00878"></a>00878           {
<a name="l00879"></a>00879             <span class="keywordflow">case</span> 0:
<a name="l00880"></a>00880               <span class="keywordflow">return</span> -2 - 1./2.*xi + 13./2.*eta;
<a name="l00881"></a>00881             <span class="keywordflow">case</span> 1:
<a name="l00882"></a>00882               <span class="keywordflow">return</span> -4 + 7./2.*xi + 17./2.*eta;
<a name="l00883"></a>00883             <span class="keywordflow">case</span> 2:
<a name="l00884"></a>00884               <span class="keywordflow">return</span> -2 + 6*eta;
<a name="l00885"></a>00885           }
<a name="l00886"></a>00886       <span class="keywordflow">case</span> 9:
<a name="l00887"></a>00887         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00888"></a>00888           {
<a name="l00889"></a>00889             <span class="keywordflow">case</span> 0:
<a name="l00890"></a>00890               <span class="keywordflow">return</span> std::sqrt(2.) * (2*xi - 2*eta);
<a name="l00891"></a>00891             <span class="keywordflow">case</span> 1:
<a name="l00892"></a>00892               <span class="keywordflow">return</span> std::sqrt(2.) * (8 - 14*xi - 10*eta);
<a name="l00893"></a>00893             <span class="keywordflow">case</span> 2:
<a name="l00894"></a>00894               <span class="keywordflow">return</span> 0;
<a name="l00895"></a>00895           }
<a name="l00896"></a>00896       <span class="keywordflow">case</span> 10:
<a name="l00897"></a>00897         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00898"></a>00898           {
<a name="l00899"></a>00899             <span class="keywordflow">case</span> 0:
<a name="l00900"></a>00900               <span class="keywordflow">return</span> 4 - 4*xi - 16*eta;
<a name="l00901"></a>00901             <span class="keywordflow">case</span> 1:
<a name="l00902"></a>00902               <span class="keywordflow">return</span> -12 + 12*xi + 16*eta;
<a name="l00903"></a>00903             <span class="keywordflow">case</span> 2:
<a name="l00904"></a>00904               <span class="keywordflow">return</span> -8*xi;
<a name="l00905"></a>00905           }
<a name="l00906"></a>00906       <span class="keywordflow">case</span> 11:
<a name="l00907"></a>00907         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00908"></a>00908           {
<a name="l00909"></a>00909             <span class="keywordflow">case</span> 0:
<a name="l00910"></a>00910               <span class="keywordflow">return</span> -4 - 8*xi + 20*eta;
<a name="l00911"></a>00911             <span class="keywordflow">case</span> 1:
<a name="l00912"></a>00912               <span class="keywordflow">return</span> -4 + 8*xi + 4*eta;
<a name="l00913"></a>00913             <span class="keywordflow">case</span> 2:
<a name="l00914"></a>00914               <span class="keywordflow">return</span> 0;
<a name="l00915"></a>00915           }
<a name="l00916"></a>00916     }
<a name="l00917"></a>00917   }
<a name="l00918"></a>00918 
<a name="l00919"></a>00919   libmesh_error();
<a name="l00920"></a>00920   <span class="keywordflow">return</span> 0.;
<a name="l00921"></a>00921 }
<a name="l00922"></a>00922 
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00926"></a>00926                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00927"></a>00927                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00928"></a>00928 {
<a name="l00929"></a>00929   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0), eta = p(1);
<a name="l00930"></a>00930 
<a name="l00931"></a>00931   <span class="keywordflow">switch</span> (deriv_type)
<a name="l00932"></a>00932   {
<a name="l00933"></a>00933   <span class="comment">// derivative in xi direction</span>
<a name="l00934"></a>00934   <span class="keywordflow">case</span> 0:
<a name="l00935"></a>00935   <span class="keywordflow">switch</span> (basis_num)
<a name="l00936"></a>00936     {
<a name="l00937"></a>00937       <span class="keywordflow">case</span> 0:
<a name="l00938"></a>00938         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00939"></a>00939           {
<a name="l00940"></a>00940             <span class="keywordflow">case</span> 0:
<a name="l00941"></a>00941               <span class="keywordflow">return</span> -6*xi + 6*xi*xi
<a name="l00942"></a>00942                 - 3*eta*eta;
<a name="l00943"></a>00943             <span class="keywordflow">case</span> 1:
<a name="l00944"></a>00944               <span class="keywordflow">return</span> 9 - 30*xi + 21*xi*xi
<a name="l00945"></a>00945                 - 30*eta + 42*xi*eta
<a name="l00946"></a>00946                 + 21*eta*eta;
<a name="l00947"></a>00947             <span class="keywordflow">case</span> 2:
<a name="l00948"></a>00948               <span class="keywordflow">return</span> -6*xi + 9*xi*xi
<a name="l00949"></a>00949                 - 6*xi*eta;
<a name="l00950"></a>00950           }
<a name="l00951"></a>00951       <span class="keywordflow">case</span> 1:
<a name="l00952"></a>00952         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00953"></a>00953           {
<a name="l00954"></a>00954             <span class="keywordflow">case</span> 0:
<a name="l00955"></a>00955               <span class="keywordflow">return</span> 6*xi - 6*xi*xi
<a name="l00956"></a>00956                 + 3./2.*eta*eta;
<a name="l00957"></a>00957             <span class="keywordflow">case</span> 1:
<a name="l00958"></a>00958               <span class="keywordflow">return</span> - 9./2. + 18*xi - 27./2.*xi*xi
<a name="l00959"></a>00959                 + 15*eta - 21*xi*eta
<a name="l00960"></a>00960                 - 21./2.*eta*eta;
<a name="l00961"></a>00961             <span class="keywordflow">case</span> 2:
<a name="l00962"></a>00962               <span class="keywordflow">return</span> 6*xi - 15./2.*xi*xi
<a name="l00963"></a>00963                 + 3*xi*eta;
<a name="l00964"></a>00964           }
<a name="l00965"></a>00965       <span class="keywordflow">case</span> 2:
<a name="l00966"></a>00966         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00967"></a>00967           {
<a name="l00968"></a>00968             <span class="keywordflow">case</span> 0:
<a name="l00969"></a>00969               <span class="keywordflow">return</span> 3./2.*eta*eta;
<a name="l00970"></a>00970             <span class="keywordflow">case</span> 1:
<a name="l00971"></a>00971               <span class="keywordflow">return</span> - 9./2. + 12*xi - 15./2.*xi*xi
<a name="l00972"></a>00972                 + 15*eta - 21*xi*eta
<a name="l00973"></a>00973                 - 21./2.*eta*eta;
<a name="l00974"></a>00974             <span class="keywordflow">case</span> 2:
<a name="l00975"></a>00975               <span class="keywordflow">return</span> -3./2.*xi*xi
<a name="l00976"></a>00976                 + 3*xi*eta;
<a name="l00977"></a>00977           }
<a name="l00978"></a>00978       <span class="keywordflow">case</span> 3:
<a name="l00979"></a>00979         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00980"></a>00980           {
<a name="l00981"></a>00981             <span class="keywordflow">case</span> 0:
<a name="l00982"></a>00982               <span class="keywordflow">return</span> 1 - 4*xi + 3*xi*xi
<a name="l00983"></a>00983                 - 1./2.*eta*eta;
<a name="l00984"></a>00984             <span class="keywordflow">case</span> 1:
<a name="l00985"></a>00985               <span class="keywordflow">return</span> 5./2. - 9*xi + 13./2.*xi*xi
<a name="l00986"></a>00986                 - 4*eta + 8*xi*eta
<a name="l00987"></a>00987                 + 3./2.*eta*eta;
<a name="l00988"></a>00988             <span class="keywordflow">case</span> 2:
<a name="l00989"></a>00989               <span class="keywordflow">return</span> 1 - xi - 7./2.*xi*xi
<a name="l00990"></a>00990                 - 3*eta + 4*xi*eta
<a name="l00991"></a>00991                 + 2*eta*eta;
<a name="l00992"></a>00992           }
<a name="l00993"></a>00993       <span class="keywordflow">case</span> 4:
<a name="l00994"></a>00994         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l00995"></a>00995           {
<a name="l00996"></a>00996             <span class="keywordflow">case</span> 0:
<a name="l00997"></a>00997               <span class="keywordflow">return</span> - 3*eta + 4*xi*eta
<a name="l00998"></a>00998                 + 2*eta*eta;
<a name="l00999"></a>00999             <span class="keywordflow">case</span> 1:
<a name="l01000"></a>01000               <span class="keywordflow">return</span> xi - xi*xi
<a name="l01001"></a>01001                 - 4*eta + 3*xi*eta
<a name="l01002"></a>01002                 + 4*eta*eta;
<a name="l01003"></a>01003             <span class="keywordflow">case</span> 2:
<a name="l01004"></a>01004               <span class="keywordflow">return</span> -3*xi + 7*xi*xi
<a name="l01005"></a>01005                 - xi*eta;
<a name="l01006"></a>01006           }
<a name="l01007"></a>01007       <span class="keywordflow">case</span> 5:
<a name="l01008"></a>01008         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01009"></a>01009           {
<a name="l01010"></a>01010             <span class="keywordflow">case</span> 0:
<a name="l01011"></a>01011               <span class="keywordflow">return</span> -2*xi + 3*xi*xi
<a name="l01012"></a>01012                 - 1./4.*eta*eta;
<a name="l01013"></a>01013             <span class="keywordflow">case</span> 1:
<a name="l01014"></a>01014               <span class="keywordflow">return</span> 3./4. - 4*xi + 17./4.*xi*xi
<a name="l01015"></a>01015                 - 5./2.*eta + 7./2.*xi*eta
<a name="l01016"></a>01016                 + 7./4.*eta*eta;
<a name="l01017"></a>01017             <span class="keywordflow">case</span> 2:
<a name="l01018"></a>01018               <span class="keywordflow">return</span> -2*xi + 13./4.*xi*xi
<a name="l01019"></a>01019                 - 1./2.*xi*eta;
<a name="l01020"></a>01020           }
<a name="l01021"></a>01021       <span class="keywordflow">case</span> 6:
<a name="l01022"></a>01022         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01023"></a>01023           {
<a name="l01024"></a>01024             <span class="keywordflow">case</span> 0:
<a name="l01025"></a>01025               <span class="keywordflow">return</span> -eta + 4*xi*eta
<a name="l01026"></a>01026                 + 7./4.*eta*eta;
<a name="l01027"></a>01027             <span class="keywordflow">case</span> 1:
<a name="l01028"></a>01028               <span class="keywordflow">return</span> -13./4. + 9*xi - 23./4.*xi*xi
<a name="l01029"></a>01029                 + 19./2.*eta - 23./2.*xi*eta
<a name="l01030"></a>01030                 - 25./4.*eta*eta;
<a name="l01031"></a>01031             <span class="keywordflow">case</span> 2:
<a name="l01032"></a>01032               <span class="keywordflow">return</span> -xi + 5./4.*xi*xi
<a name="l01033"></a>01033                 + 9./2.*xi*eta;
<a name="l01034"></a>01034           }
<a name="l01035"></a>01035       <span class="keywordflow">case</span> 7:
<a name="l01036"></a>01036         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01037"></a>01037           {
<a name="l01038"></a>01038             <span class="keywordflow">case</span> 0:
<a name="l01039"></a>01039               <span class="keywordflow">return</span> 9./4.*eta*eta;
<a name="l01040"></a>01040             <span class="keywordflow">case</span> 1:
<a name="l01041"></a>01041               <span class="keywordflow">return</span> - 11./4. + 7*xi - 17./4.*xi*xi
<a name="l01042"></a>01042                 + 19./2.*eta - 25./2.*xi*eta
<a name="l01043"></a>01043                 - 23./4.*eta*eta;
<a name="l01044"></a>01044             <span class="keywordflow">case</span> 2:
<a name="l01045"></a>01045               <span class="keywordflow">return</span> xi - 13./4.*xi*xi
<a name="l01046"></a>01046                 - eta + 7./2.*xi*eta + 2*eta*eta;
<a name="l01047"></a>01047           }
<a name="l01048"></a>01048       <span class="keywordflow">case</span> 8:
<a name="l01049"></a>01049         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01050"></a>01050           {
<a name="l01051"></a>01051             <span class="keywordflow">case</span> 0:
<a name="l01052"></a>01052               <span class="keywordflow">return</span> - 1./4.*eta*eta;
<a name="l01053"></a>01053             <span class="keywordflow">case</span> 1:
<a name="l01054"></a>01054               <span class="keywordflow">return</span> 3./4. - 2*xi + 5./4.*xi*xi
<a name="l01055"></a>01055                 - 5./2.*eta + 7./2.*xi*eta
<a name="l01056"></a>01056                 + 7./4.*eta*eta;
<a name="l01057"></a>01057             <span class="keywordflow">case</span> 2:
<a name="l01058"></a>01058               <span class="keywordflow">return</span> 1./4.*xi*xi
<a name="l01059"></a>01059                 - 1./2.*xi*eta;
<a name="l01060"></a>01060           }
<a name="l01061"></a>01061       <span class="keywordflow">case</span> 9:
<a name="l01062"></a>01062         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01063"></a>01063           {
<a name="l01064"></a>01064             <span class="keywordflow">case</span> 0:
<a name="l01065"></a>01065               <span class="keywordflow">return</span> std::sqrt(2.) * eta*eta;
<a name="l01066"></a>01066             <span class="keywordflow">case</span> 1:
<a name="l01067"></a>01067               <span class="keywordflow">return</span> std::sqrt(2.) * (-3 + 8*xi - 5*xi*xi
<a name="l01068"></a>01068                 + 10*eta - 14*xi*eta
<a name="l01069"></a>01069                 - 7*eta*eta);
<a name="l01070"></a>01070             <span class="keywordflow">case</span> 2:
<a name="l01071"></a>01071               <span class="keywordflow">return</span> std::sqrt(2.) * (-xi*xi + 2*xi*eta);
<a name="l01072"></a>01072           }
<a name="l01073"></a>01073       <span class="keywordflow">case</span> 10:
<a name="l01074"></a>01074         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01075"></a>01075           {
<a name="l01076"></a>01076             <span class="keywordflow">case</span> 0:
<a name="l01077"></a>01077               <span class="keywordflow">return</span> -2*eta*eta;
<a name="l01078"></a>01078             <span class="keywordflow">case</span> 1:
<a name="l01079"></a>01079               <span class="keywordflow">return</span> 2 - 4*xi + 2*xi*xi
<a name="l01080"></a>01080                 - 8*eta + 8*xi*eta
<a name="l01081"></a>01081                 + 6*eta*eta;
<a name="l01082"></a>01082             <span class="keywordflow">case</span> 2:
<a name="l01083"></a>01083               <span class="keywordflow">return</span> -4*xi + 10*xi*xi
<a name="l01084"></a>01084                 + 4*eta - 8*xi*eta
<a name="l01085"></a>01085                 - 4*eta*eta;
<a name="l01086"></a>01086           }
<a name="l01087"></a>01087       <span class="keywordflow">case</span> 11:
<a name="l01088"></a>01088         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01089"></a>01089           {
<a name="l01090"></a>01090             <span class="keywordflow">case</span> 0:
<a name="l01091"></a>01091               <span class="keywordflow">return</span> 4*eta - 8*xi*eta
<a name="l01092"></a>01092                 - 4*eta*eta;
<a name="l01093"></a>01093             <span class="keywordflow">case</span> 1:
<a name="l01094"></a>01094               <span class="keywordflow">return</span> 4 - 12*xi + 8*xi*xi
<a name="l01095"></a>01095                 - 8*eta + 12*xi*eta
<a name="l01096"></a>01096                 + 4*eta*eta;
<a name="l01097"></a>01097             <span class="keywordflow">case</span> 2:
<a name="l01098"></a>01098               <span class="keywordflow">return</span> 4*xi - 8*xi*xi
<a name="l01099"></a>01099                 - 4*xi*eta;
<a name="l01100"></a>01100           }
<a name="l01101"></a>01101     }
<a name="l01102"></a>01102 
<a name="l01103"></a>01103   <span class="comment">// derivative in eta direction</span>
<a name="l01104"></a>01104   <span class="keywordflow">case</span> 1:
<a name="l01105"></a>01105   <span class="keywordflow">switch</span> (basis_num)
<a name="l01106"></a>01106     {
<a name="l01107"></a>01107       <span class="keywordflow">case</span> 0:
<a name="l01108"></a>01108         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01109"></a>01109           {
<a name="l01110"></a>01110             <span class="keywordflow">case</span> 0:
<a name="l01111"></a>01111               <span class="keywordflow">return</span> - 6*eta - 6*xi*eta + 9*eta*eta;
<a name="l01112"></a>01112             <span class="keywordflow">case</span> 1:
<a name="l01113"></a>01113               <span class="keywordflow">return</span> 9 - 30*xi + 21*xi*xi
<a name="l01114"></a>01114                 - 30*eta + 42*xi*eta + 21*eta*eta;
<a name="l01115"></a>01115             <span class="keywordflow">case</span> 2:
<a name="l01116"></a>01116               <span class="keywordflow">return</span> - 3*xi*xi
<a name="l01117"></a>01117                 - 6*eta + 6*eta*eta;
<a name="l01118"></a>01118           }
<a name="l01119"></a>01119       <span class="keywordflow">case</span> 1:
<a name="l01120"></a>01120         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01121"></a>01121           {
<a name="l01122"></a>01122             <span class="keywordflow">case</span> 0:
<a name="l01123"></a>01123               <span class="keywordflow">return</span> + 3*xi*eta
<a name="l01124"></a>01124                 - 3./2.*eta*eta;
<a name="l01125"></a>01125             <span class="keywordflow">case</span> 1:
<a name="l01126"></a>01126               <span class="keywordflow">return</span> - 9./2. + 15*xi - 21./2.*xi*xi
<a name="l01127"></a>01127                 + 12*eta - 21*xi*eta - 15./2.*eta*eta;
<a name="l01128"></a>01128             <span class="keywordflow">case</span> 2:
<a name="l01129"></a>01129               <span class="keywordflow">return</span> + 3./2.*xi*xi;
<a name="l01130"></a>01130           }
<a name="l01131"></a>01131       <span class="keywordflow">case</span> 2:
<a name="l01132"></a>01132         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01133"></a>01133           {
<a name="l01134"></a>01134             <span class="keywordflow">case</span> 0:
<a name="l01135"></a>01135               <span class="keywordflow">return</span> 6*eta + 3*xi*eta - 15./2.*eta*eta;
<a name="l01136"></a>01136             <span class="keywordflow">case</span> 1:
<a name="l01137"></a>01137               <span class="keywordflow">return</span> - 9./2. + 15*xi - 21./2.*xi*xi
<a name="l01138"></a>01138                 + 18*eta - 21.*xi*eta - 27./2.*eta*eta;
<a name="l01139"></a>01139             <span class="keywordflow">case</span> 2:
<a name="l01140"></a>01140               <span class="keywordflow">return</span> 3./2.*xi*xi
<a name="l01141"></a>01141                 + 6*eta - 6*eta*eta;
<a name="l01142"></a>01142           }
<a name="l01143"></a>01143       <span class="keywordflow">case</span> 3:
<a name="l01144"></a>01144         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01145"></a>01145           {
<a name="l01146"></a>01146             <span class="keywordflow">case</span> 0:
<a name="l01147"></a>01147               <span class="keywordflow">return</span> - 3*eta - xi*eta + 7*eta*eta;
<a name="l01148"></a>01148             <span class="keywordflow">case</span> 1:
<a name="l01149"></a>01149               <span class="keywordflow">return</span> - 4*xi + 4*xi*xi
<a name="l01150"></a>01150                 + eta + 3*xi*eta - eta*eta;
<a name="l01151"></a>01151             <span class="keywordflow">case</span> 2:
<a name="l01152"></a>01152               <span class="keywordflow">return</span> - 3*xi + 2*xi*xi
<a name="l01153"></a>01153                 + 4*xi*eta;
<a name="l01154"></a>01154           }
<a name="l01155"></a>01155       <span class="keywordflow">case</span> 4:
<a name="l01156"></a>01156         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01157"></a>01157           {
<a name="l01158"></a>01158             <span class="keywordflow">case</span> 0:
<a name="l01159"></a>01159               <span class="keywordflow">return</span> 1 - 3*xi + 2*xi*xi
<a name="l01160"></a>01160                 - eta + 4*xi*eta - 7./2.*eta*eta;
<a name="l01161"></a>01161             <span class="keywordflow">case</span> 1:
<a name="l01162"></a>01162               <span class="keywordflow">return</span> 5./2. - 4*xi + 3./2.*xi*xi
<a name="l01163"></a>01163                 - 9.*eta + 8*xi*eta + 13./2.*eta*eta;
<a name="l01164"></a>01164             <span class="keywordflow">case</span> 2:
<a name="l01165"></a>01165               <span class="keywordflow">return</span> 1 - 1./2.*xi*xi - 4*eta + 3*eta*eta;
<a name="l01166"></a>01166           }
<a name="l01167"></a>01167       <span class="keywordflow">case</span> 5:
<a name="l01168"></a>01168         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01169"></a>01169           {
<a name="l01170"></a>01170             <span class="keywordflow">case</span> 0:
<a name="l01171"></a>01171               <span class="keywordflow">return</span> - 1./2.*xi*eta + 1./4.*eta*eta;
<a name="l01172"></a>01172             <span class="keywordflow">case</span> 1:
<a name="l01173"></a>01173               <span class="keywordflow">return</span> 3./4. - 5./2.*xi + 7./4.*xi*xi
<a name="l01174"></a>01174                 - 2*eta + 7./2.*xi*eta + 5./4.*eta*eta;
<a name="l01175"></a>01175             <span class="keywordflow">case</span> 2:
<a name="l01176"></a>01176               <span class="keywordflow">return</span> - 1./4.*xi*xi;
<a name="l01177"></a>01177           }
<a name="l01178"></a>01178       <span class="keywordflow">case</span> 6:
<a name="l01179"></a>01179         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01180"></a>01180           {
<a name="l01181"></a>01181             <span class="keywordflow">case</span> 0:
<a name="l01182"></a>01182               <span class="keywordflow">return</span> -xi + 2*xi*xi
<a name="l01183"></a>01183                 + eta + 7./2.*xi*eta - 13./4.*eta*eta;
<a name="l01184"></a>01184             <span class="keywordflow">case</span> 1:
<a name="l01185"></a>01185               <span class="keywordflow">return</span> - 11./4. + 19./2.*xi - 23./4.*xi*xi
<a name="l01186"></a>01186                 + 7*eta - 25./2.*xi*eta - 17./4.*eta*eta;
<a name="l01187"></a>01187             <span class="keywordflow">case</span> 2:
<a name="l01188"></a>01188               <span class="keywordflow">return</span> 9./4.*xi*xi;
<a name="l01189"></a>01189           }
<a name="l01190"></a>01190       <span class="keywordflow">case</span> 7:
<a name="l01191"></a>01191         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01192"></a>01192           {
<a name="l01193"></a>01193             <span class="keywordflow">case</span> 0:
<a name="l01194"></a>01194               <span class="keywordflow">return</span> -eta + 9./2.*xi*eta + 5./4.*eta*eta;
<a name="l01195"></a>01195             <span class="keywordflow">case</span> 1:
<a name="l01196"></a>01196               <span class="keywordflow">return</span> - 13./4. + 19./2.*xi - 25./4.*xi*xi
<a name="l01197"></a>01197                 + 9*eta - 23./2.*xi*eta - 23./4.*eta*eta;
<a name="l01198"></a>01198             <span class="keywordflow">case</span> 2:
<a name="l01199"></a>01199               <span class="keywordflow">return</span> - xi + 7./4.*xi*xi + 4*xi*eta;
<a name="l01200"></a>01200           }
<a name="l01201"></a>01201       <span class="keywordflow">case</span> 8:
<a name="l01202"></a>01202         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01203"></a>01203           {
<a name="l01204"></a>01204             <span class="keywordflow">case</span> 0:
<a name="l01205"></a>01205               <span class="keywordflow">return</span> -2*eta - 1./2.*xi*eta + 13./4.*eta*eta;
<a name="l01206"></a>01206             <span class="keywordflow">case</span> 1:
<a name="l01207"></a>01207               <span class="keywordflow">return</span> 3./4. - 5./2.*xi + 7./4.*xi*xi
<a name="l01208"></a>01208                 - 4*eta + 7./2.*xi*eta + 17./4.*eta*eta;
<a name="l01209"></a>01209             <span class="keywordflow">case</span> 2:
<a name="l01210"></a>01210               <span class="keywordflow">return</span> - 1./4.*xi*xi
<a name="l01211"></a>01211                 - 2*eta + 3*eta*eta;
<a name="l01212"></a>01212           }
<a name="l01213"></a>01213       <span class="keywordflow">case</span> 9:
<a name="l01214"></a>01214         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01215"></a>01215           {
<a name="l01216"></a>01216             <span class="keywordflow">case</span> 0:
<a name="l01217"></a>01217               <span class="keywordflow">return</span> std::sqrt(2.) * (2*xi*eta - eta*eta);
<a name="l01218"></a>01218             <span class="keywordflow">case</span> 1:
<a name="l01219"></a>01219               <span class="keywordflow">return</span> std::sqrt(2.) * (- 3 + 10*xi - 7*xi*xi
<a name="l01220"></a>01220                 + 8*eta - 14*xi*eta - 5*eta*eta);
<a name="l01221"></a>01221             <span class="keywordflow">case</span> 2:
<a name="l01222"></a>01222               <span class="keywordflow">return</span> std::sqrt(2.) * (xi*xi);
<a name="l01223"></a>01223           }
<a name="l01224"></a>01224       <span class="keywordflow">case</span> 10:
<a name="l01225"></a>01225         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01226"></a>01226           {
<a name="l01227"></a>01227             <span class="keywordflow">case</span> 0:
<a name="l01228"></a>01228               <span class="keywordflow">return</span> 4*eta - 4*xi*eta - 8*eta*eta;
<a name="l01229"></a>01229             <span class="keywordflow">case</span> 1:
<a name="l01230"></a>01230               <span class="keywordflow">return</span> 4 - 8*xi + 4*xi*xi
<a name="l01231"></a>01231                 - 12*eta + 12*xi*eta + 8*eta*eta;
<a name="l01232"></a>01232             <span class="keywordflow">case</span> 2:
<a name="l01233"></a>01233               <span class="keywordflow">return</span> 4*xi - 4*xi*xi
<a name="l01234"></a>01234                 - 8*xi*eta;
<a name="l01235"></a>01235           }
<a name="l01236"></a>01236       <span class="keywordflow">case</span> 11:
<a name="l01237"></a>01237         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01238"></a>01238           {
<a name="l01239"></a>01239             <span class="keywordflow">case</span> 0:
<a name="l01240"></a>01240               <span class="keywordflow">return</span> 4*xi - 4*xi*xi
<a name="l01241"></a>01241                 - 4*eta - 8*xi*eta + 10.*eta*eta;
<a name="l01242"></a>01242             <span class="keywordflow">case</span> 1:
<a name="l01243"></a>01243               <span class="keywordflow">return</span> 2 - 8*xi + 6*xi*xi
<a name="l01244"></a>01244                 - 4*eta + 8*xi*eta + 2*eta*eta;
<a name="l01245"></a>01245             <span class="keywordflow">case</span> 2:
<a name="l01246"></a>01246               <span class="keywordflow">return</span> - 2*xi*xi;
<a name="l01247"></a>01247           }
<a name="l01248"></a>01248     }
<a name="l01249"></a>01249   }
<a name="l01250"></a>01250 
<a name="l01251"></a>01251   libmesh_error();
<a name="l01252"></a>01252   <span class="keywordflow">return</span> 0.;
<a name="l01253"></a>01253 }
<a name="l01254"></a>01254 
<a name="l01255"></a>01255 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l01256"></a>01256                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l01257"></a>01257 {
<a name="l01258"></a>01258   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0), eta = p(1);
<a name="l01259"></a>01259 
<a name="l01260"></a>01260   <span class="keywordflow">switch</span> (basis_num)
<a name="l01261"></a>01261     {
<a name="l01262"></a>01262       <span class="keywordflow">case</span> 0:
<a name="l01263"></a>01263         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01264"></a>01264           {
<a name="l01265"></a>01265             <span class="keywordflow">case</span> 0:
<a name="l01266"></a>01266               <span class="keywordflow">return</span> 1 - 3*xi*xi + 2*xi*xi*xi 
<a name="l01267"></a>01267                 - 3*eta*eta - 3*xi*eta*eta + 3*eta*eta*eta;
<a name="l01268"></a>01268             <span class="keywordflow">case</span> 1:
<a name="l01269"></a>01269               <span class="keywordflow">return</span> -1 + 9*xi - 15*xi*xi + 7*xi*xi*xi
<a name="l01270"></a>01270                 + 9*eta - 30*xi*eta +21*xi*xi*eta
<a name="l01271"></a>01271                 - 15*eta*eta + 21*xi*eta*eta + 7*eta*eta*eta;
<a name="l01272"></a>01272             <span class="keywordflow">case</span> 2:
<a name="l01273"></a>01273               <span class="keywordflow">return</span> 1 - 3*xi*xi + 3*xi*xi*xi
<a name="l01274"></a>01274                 - 3*xi*xi*eta
<a name="l01275"></a>01275                 - 3*eta*eta + 2*eta*eta*eta;
<a name="l01276"></a>01276           }
<a name="l01277"></a>01277       <span class="keywordflow">case</span> 1:
<a name="l01278"></a>01278         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01279"></a>01279           {
<a name="l01280"></a>01280             <span class="keywordflow">case</span> 0:
<a name="l01281"></a>01281               <span class="keywordflow">return</span> 3*xi*xi - 2*xi*xi*xi
<a name="l01282"></a>01282                 + 3./2.*xi*eta*eta
<a name="l01283"></a>01283                 - 1./2.*eta*eta*eta;
<a name="l01284"></a>01284             <span class="keywordflow">case</span> 1:
<a name="l01285"></a>01285               <span class="keywordflow">return</span> 1 - 9./2.*xi + 9*xi*xi - 9./2.*xi*xi*xi
<a name="l01286"></a>01286                 - 9./2.*eta + 15*xi*eta - 21./2.*xi*xi*eta
<a name="l01287"></a>01287                 + 6*eta*eta - 21./2.*xi*eta*eta - 5./2.*eta*eta*eta;
<a name="l01288"></a>01288             <span class="keywordflow">case</span> 2:
<a name="l01289"></a>01289               <span class="keywordflow">return</span> 3*xi*xi - 5./2.*xi*xi*xi
<a name="l01290"></a>01290                 + 3./2.*xi*xi*eta;
<a name="l01291"></a>01291           }
<a name="l01292"></a>01292       <span class="keywordflow">case</span> 2:
<a name="l01293"></a>01293         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01294"></a>01294           {
<a name="l01295"></a>01295             <span class="keywordflow">case</span> 0:
<a name="l01296"></a>01296               <span class="keywordflow">return</span> 3*eta*eta + 3./2.*xi*eta*eta - 5./2.*eta*eta*eta;
<a name="l01297"></a>01297             <span class="keywordflow">case</span> 1:
<a name="l01298"></a>01298               <span class="keywordflow">return</span> 1 - 9./2.*xi + 6*xi*xi - 5./2.*xi*xi*xi
<a name="l01299"></a>01299                 - 9./2.*eta + 15*xi*eta - 21./2.*xi*xi*eta
<a name="l01300"></a>01300                 + 9*eta*eta - 21./2.*xi*eta*eta - 9./2.*eta*eta*eta;
<a name="l01301"></a>01301             <span class="keywordflow">case</span> 2:
<a name="l01302"></a>01302               <span class="keywordflow">return</span> -1./2.*xi*xi*xi
<a name="l01303"></a>01303                 + 3./2.*xi*xi*eta
<a name="l01304"></a>01304                 + 3*eta*eta - 2*eta*eta*eta;
<a name="l01305"></a>01305           }
<a name="l01306"></a>01306       <span class="keywordflow">case</span> 3:
<a name="l01307"></a>01307         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01308"></a>01308           {
<a name="l01309"></a>01309             <span class="keywordflow">case</span> 0:
<a name="l01310"></a>01310               <span class="keywordflow">return</span> xi - 2*xi*xi + xi*xi*xi
<a name="l01311"></a>01311                 - 3./2.*eta*eta - 1./2.*xi*eta*eta + 7./3.*eta*eta*eta;
<a name="l01312"></a>01312             <span class="keywordflow">case</span> 1:
<a name="l01313"></a>01313               <span class="keywordflow">return</span> -1./6. + 5./2.*xi - 9./2.*xi*xi + 13./6.*xi*xi*xi
<a name="l01314"></a>01314                 - 4*xi*eta + 4*xi*xi*eta
<a name="l01315"></a>01315                 + 1./2.*eta*eta + 3./2.*xi*eta*eta - 1./3.*eta*eta*eta;
<a name="l01316"></a>01316             <span class="keywordflow">case</span> 2:
<a name="l01317"></a>01317               <span class="keywordflow">return</span> xi - 1./2.*xi*xi - 7./6.*xi*xi*xi
<a name="l01318"></a>01318                 - 3*xi*eta + 2*xi*xi*eta
<a name="l01319"></a>01319                 + 2*xi*eta*eta;
<a name="l01320"></a>01320           }
<a name="l01321"></a>01321       <span class="keywordflow">case</span> 4:
<a name="l01322"></a>01322         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01323"></a>01323           {
<a name="l01324"></a>01324             <span class="keywordflow">case</span> 0:
<a name="l01325"></a>01325               <span class="keywordflow">return</span> eta - 3*xi*eta + 2*xi*xi*eta
<a name="l01326"></a>01326                 - 1./2.*eta*eta + 2*xi*eta*eta - 7./6.*eta*eta*eta;
<a name="l01327"></a>01327             <span class="keywordflow">case</span> 1:
<a name="l01328"></a>01328               <span class="keywordflow">return</span> -1./6. + 1./2.*xi*xi - 1./3.*xi*xi*xi
<a name="l01329"></a>01329                 + 5./2.*eta - 4*xi*eta + 3./2.*xi*xi*eta
<a name="l01330"></a>01330                 - 9./2.*eta*eta + 4*xi*eta*eta + 13./6.*eta*eta*eta;
<a name="l01331"></a>01331             <span class="keywordflow">case</span> 2:
<a name="l01332"></a>01332               <span class="keywordflow">return</span> -3./2.*xi*xi + 7./3.*xi*xi*xi
<a name="l01333"></a>01333                 + eta - 1./2.*xi*xi*eta - 2*eta*eta + eta*eta*eta;
<a name="l01334"></a>01334           }
<a name="l01335"></a>01335       <span class="keywordflow">case</span> 5:
<a name="l01336"></a>01336         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01337"></a>01337           {
<a name="l01338"></a>01338             <span class="keywordflow">case</span> 0:
<a name="l01339"></a>01339               <span class="keywordflow">return</span> -xi*xi + xi*xi*xi
<a name="l01340"></a>01340                 - 1./4.*xi*eta*eta + 1./12.*eta*eta*eta;
<a name="l01341"></a>01341             <span class="keywordflow">case</span> 1:
<a name="l01342"></a>01342               <span class="keywordflow">return</span> -1./6. + 3./4.*xi - 2*xi*xi + 17./12.*xi*xi*xi
<a name="l01343"></a>01343                 + 3./4.*eta - 5./2.*xi*eta + 7./4.*xi*xi*eta
<a name="l01344"></a>01344                 - eta*eta + 7./4.*xi*eta*eta + 5./12.*eta*eta*eta;
<a name="l01345"></a>01345             <span class="keywordflow">case</span> 2:
<a name="l01346"></a>01346               <span class="keywordflow">return</span> -xi*xi + 13./12.*xi*xi*xi
<a name="l01347"></a>01347                 - 1./4.*xi*xi*eta;
<a name="l01348"></a>01348           }
<a name="l01349"></a>01349       <span class="keywordflow">case</span> 6:
<a name="l01350"></a>01350         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01351"></a>01351           {
<a name="l01352"></a>01352             <span class="keywordflow">case</span> 0:
<a name="l01353"></a>01353               <span class="keywordflow">return</span> -xi*eta + 2*xi*xi*eta
<a name="l01354"></a>01354                 + 1./2.*eta*eta + 7./4.*xi*eta*eta - 13./12.*eta*eta*eta;
<a name="l01355"></a>01355             <span class="keywordflow">case</span> 1:
<a name="l01356"></a>01356               <span class="keywordflow">return</span> 2./3. - 13./4.*xi + 9./2.*xi*xi - 23./12.*xi*xi*xi
<a name="l01357"></a>01357                 - 11./4.*eta + 19./2.*xi*eta - 23./4.*xi*xi*eta
<a name="l01358"></a>01358                 + 7./2.*eta*eta - 25./4.*xi*eta*eta - 17./12.*eta*eta*eta;
<a name="l01359"></a>01359             <span class="keywordflow">case</span> 2:
<a name="l01360"></a>01360               <span class="keywordflow">return</span> -1./2.*xi*xi + 5./12.*xi*xi*xi
<a name="l01361"></a>01361                 + 9./4.*xi*xi*eta;
<a name="l01362"></a>01362           }
<a name="l01363"></a>01363       <span class="keywordflow">case</span> 7:
<a name="l01364"></a>01364         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01365"></a>01365           {
<a name="l01366"></a>01366             <span class="keywordflow">case</span> 0:
<a name="l01367"></a>01367               <span class="keywordflow">return</span> -1./2.*eta*eta + 9./4.*xi*eta*eta + 5./12.*eta*eta*eta;
<a name="l01368"></a>01368             <span class="keywordflow">case</span> 1:
<a name="l01369"></a>01369               <span class="keywordflow">return</span> 2./3. - 11./4.*xi + 7./2.*xi*xi - 17./12.*xi*xi*xi
<a name="l01370"></a>01370                 - 13./4.*eta + 19./2.*xi*eta - 25./4.*xi*xi*eta
<a name="l01371"></a>01371                 + 9./2.*eta*eta - 23./4.*xi*eta*eta - 23./12.*eta*eta*eta;
<a name="l01372"></a>01372             <span class="keywordflow">case</span> 2:
<a name="l01373"></a>01373               <span class="keywordflow">return</span> 1./2.*xi*xi - 13./12.*xi*xi*xi
<a name="l01374"></a>01374                 - xi*eta + 7./4.*xi*xi*eta + 2*xi*eta*eta;
<a name="l01375"></a>01375           }
<a name="l01376"></a>01376       <span class="keywordflow">case</span> 8:
<a name="l01377"></a>01377         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01378"></a>01378           {
<a name="l01379"></a>01379             <span class="keywordflow">case</span> 0:
<a name="l01380"></a>01380               <span class="keywordflow">return</span> -eta*eta - 1./4.*xi*eta*eta + 13./12.*eta*eta*eta;
<a name="l01381"></a>01381             <span class="keywordflow">case</span> 1:
<a name="l01382"></a>01382               <span class="keywordflow">return</span> -1./6. + 3./4.*xi - xi*xi + 5./12.*xi*xi*xi
<a name="l01383"></a>01383                 + 3./4.*eta - 5./2.*xi*eta + 7./4.*xi*xi*eta
<a name="l01384"></a>01384                 - 2*eta*eta + 7./4.*xi*eta*eta + 17./12.*eta*eta*eta;
<a name="l01385"></a>01385             <span class="keywordflow">case</span> 2:
<a name="l01386"></a>01386               <span class="keywordflow">return</span> 1./12.*xi*xi*xi
<a name="l01387"></a>01387                 - 1./4.*xi*xi*eta
<a name="l01388"></a>01388                 - eta*eta + eta*eta*eta;
<a name="l01389"></a>01389           }
<a name="l01390"></a>01390       <span class="keywordflow">case</span> 9:
<a name="l01391"></a>01391         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01392"></a>01392           {
<a name="l01393"></a>01393             <span class="keywordflow">case</span> 0:
<a name="l01394"></a>01394               <span class="keywordflow">return</span> std::sqrt(2.) * (xi*eta*eta - 1./3.*eta*eta*eta);
<a name="l01395"></a>01395             <span class="keywordflow">case</span> 1:
<a name="l01396"></a>01396               <span class="keywordflow">return</span> std::sqrt(2.) * (2./3. - 3*xi + 4*xi*xi - 5./3.*xi*xi*xi
<a name="l01397"></a>01397                 - 3*eta + 10*xi*eta - 7*xi*xi*eta
<a name="l01398"></a>01398                 + 4*eta*eta - 7*xi*eta*eta - 5./3.*eta*eta*eta);
<a name="l01399"></a>01399             <span class="keywordflow">case</span> 2:
<a name="l01400"></a>01400               <span class="keywordflow">return</span> std::sqrt(2.) * (-1./3.*xi*xi*xi + xi*xi*eta);
<a name="l01401"></a>01401           }
<a name="l01402"></a>01402       <span class="keywordflow">case</span> 10:
<a name="l01403"></a>01403         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01404"></a>01404           {
<a name="l01405"></a>01405             <span class="keywordflow">case</span> 0:
<a name="l01406"></a>01406               <span class="keywordflow">return</span> 2*eta*eta - 2*xi*eta*eta - 8./3.*eta*eta*eta;
<a name="l01407"></a>01407             <span class="keywordflow">case</span> 1:
<a name="l01408"></a>01408               <span class="keywordflow">return</span> -2./3. + 2*xi - 2*xi*xi + 2./3.*xi*xi*xi
<a name="l01409"></a>01409                 + 4*eta - 8*xi*eta + 4*xi*xi*eta
<a name="l01410"></a>01410                 - 6*eta*eta + 6*xi*eta*eta + 8./3.*eta*eta*eta;
<a name="l01411"></a>01411             <span class="keywordflow">case</span> 2:
<a name="l01412"></a>01412               <span class="keywordflow">return</span> -2*xi*xi + 10./3.*xi*xi*xi
<a name="l01413"></a>01413                 + 4*xi*eta - 4*xi*xi*eta
<a name="l01414"></a>01414                 - 4*xi*eta*eta;
<a name="l01415"></a>01415           }
<a name="l01416"></a>01416       <span class="keywordflow">case</span> 11:
<a name="l01417"></a>01417         <span class="keywordflow">switch</span> (subtriangle_lookup(p))
<a name="l01418"></a>01418           {
<a name="l01419"></a>01419             <span class="keywordflow">case</span> 0:
<a name="l01420"></a>01420               <span class="keywordflow">return</span> 4*xi*eta - 4*xi*xi*eta
<a name="l01421"></a>01421                 - 2*eta*eta - 4*xi*eta*eta + 10./3.*eta*eta*eta;
<a name="l01422"></a>01422             <span class="keywordflow">case</span> 1:
<a name="l01423"></a>01423               <span class="keywordflow">return</span> -2./3. + 4*xi - 6*xi*xi + 8./3.*xi*xi*xi
<a name="l01424"></a>01424                 + 2*eta - 8*xi*eta + 6*xi*xi*eta
<a name="l01425"></a>01425                 - 2*eta*eta + 4*xi*eta*eta + 2./3.*eta*eta*eta;
<a name="l01426"></a>01426             <span class="keywordflow">case</span> 2:
<a name="l01427"></a>01427               <span class="keywordflow">return</span> 2*xi*xi - 8./3.*xi*xi*xi
<a name="l01428"></a>01428                 - 2*xi*xi*eta;
<a name="l01429"></a>01429           }
<a name="l01430"></a>01430     }
<a name="l01431"></a>01431 
<a name="l01432"></a>01432   libmesh_error();
<a name="l01433"></a>01433   <span class="keywordflow">return</span> 0.;
<a name="l01434"></a>01434 }
<a name="l01435"></a>01435 
<a name="l01436"></a>01436   
<a name="l01437"></a>01437 } <span class="comment">// end anonymous namespace</span>
<a name="l01438"></a>01438 
<a name="l01439"></a>01439 
<a name="l01440"></a>01440 <span class="keyword">namespace </span>libMesh
<a name="l01441"></a>01441 {
<a name="l01442"></a>01442 
<a name="l01443"></a>01443 
<a name="l01444"></a>01444 <span class="keyword">template</span> &lt;&gt;
<a name="l01445"></a><a class="code" href="classlibMesh_1_1FE.php#a05f6c1f2de652a0f6b6752dfca4c7d0f">01445</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,CLOUGH&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l01446"></a>01446                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l01447"></a>01447                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01448"></a>01448                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l01449"></a>01449 {
<a name="l01450"></a>01450   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Clough-Tocher elements require the real element\n&quot;</span>
<a name="l01451"></a>01451                 &lt;&lt; <span class="stringliteral">&quot;to construct gradient-based degrees of freedom.&quot;</span>
<a name="l01452"></a>01452                 &lt;&lt; std::endl;
<a name="l01453"></a>01453   
<a name="l01454"></a>01454   libmesh_error();
<a name="l01455"></a>01455   <span class="keywordflow">return</span> 0.;
<a name="l01456"></a>01456 }
<a name="l01457"></a>01457 
<a name="l01458"></a>01458 
<a name="l01459"></a>01459 
<a name="l01460"></a>01460 <span class="keyword">template</span> &lt;&gt;
<a name="l01461"></a><a class="code" href="classlibMesh_1_1FE.php#a82072df2d280ad323a8304735ae6fdfb">01461</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,CLOUGH&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l01462"></a>01462                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l01463"></a>01463                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l01464"></a>01464                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l01465"></a>01465 {
<a name="l01466"></a>01466   libmesh_assert (elem != NULL);
<a name="l01467"></a>01467 
<a name="l01468"></a>01468   clough_compute_coefs(elem);
<a name="l01469"></a>01469 
<a name="l01470"></a>01470   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01471"></a>01471   
<a name="l01472"></a>01472   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01473"></a>01473 
<a name="l01474"></a>01474   <span class="keywordflow">switch</span> (totalorder)
<a name="l01475"></a>01475     {      
<a name="l01476"></a>01476       <span class="comment">// 2nd-order restricted Clough-Tocher element</span>
<a name="l01477"></a>01477     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l01478"></a>01478       {
<a name="l01479"></a>01479         <span class="comment">// There may be a bug in the 2nd order case; the 3rd order</span>
<a name="l01480"></a>01480         <span class="comment">// Clough-Tocher elements are pretty uniformly better anyways</span>
<a name="l01481"></a>01481         <span class="comment">// so use those instead.</span>
<a name="l01482"></a>01482         libmesh_experimental();
<a name="l01483"></a>01483         <span class="keywordflow">switch</span> (type)
<a name="l01484"></a>01484           {
<a name="l01485"></a>01485             <span class="comment">// C1 functions on the Clough-Tocher triangle.</span>
<a name="l01486"></a>01486           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01487"></a>01487             {
<a name="l01488"></a>01488               libmesh_assert (i&lt;9);
<a name="l01489"></a>01489             <span class="comment">// FIXME: it would be nice to calculate (and cache)</span>
<a name="l01490"></a>01490             <span class="comment">// clough_raw_shape(j,p) only once per triangle, not 1-7</span>
<a name="l01491"></a>01491             <span class="comment">// times</span>
<a name="l01492"></a>01492               <span class="keywordflow">switch</span> (i)
<a name="l01493"></a>01493                 {
<a name="l01494"></a>01494             <span class="comment">// Note: these DoF numbers are &quot;scrambled&quot; because my</span>
<a name="l01495"></a>01495             <span class="comment">// initial numbering conventions didn&#39;t match libMesh</span>
<a name="l01496"></a>01496                 <span class="keywordflow">case</span> 0:
<a name="l01497"></a>01497                   <span class="keywordflow">return</span> clough_raw_shape(0, p)
<a name="l01498"></a>01498                     + d1d2n * clough_raw_shape(10, p)
<a name="l01499"></a>01499                     + d1d3n * clough_raw_shape(11, p);
<a name="l01500"></a>01500                 <span class="keywordflow">case</span> 3:
<a name="l01501"></a>01501                   <span class="keywordflow">return</span> clough_raw_shape(1, p)
<a name="l01502"></a>01502                     + d2d3n * clough_raw_shape(11, p)
<a name="l01503"></a>01503                     + d2d1n * clough_raw_shape(9, p);
<a name="l01504"></a>01504                 <span class="keywordflow">case</span> 6:
<a name="l01505"></a>01505                   <span class="keywordflow">return</span> clough_raw_shape(2, p)
<a name="l01506"></a>01506                     + d3d1n * clough_raw_shape(9, p)
<a name="l01507"></a>01507                     + d3d2n * clough_raw_shape(10, p);
<a name="l01508"></a>01508                 <span class="keywordflow">case</span> 1:
<a name="l01509"></a>01509                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape(3, p)
<a name="l01510"></a>01510                     + d1xd1y * clough_raw_shape(4, p)
<a name="l01511"></a>01511                     + d1xd2n * clough_raw_shape(10, p)
<a name="l01512"></a>01512                     + d1xd3n * clough_raw_shape(11, p)
<a name="l01513"></a>01513                     + 0.5 * N01x * d3nd3n * clough_raw_shape(11, p)
<a name="l01514"></a>01514                     + 0.5 * N02x * d2nd2n * clough_raw_shape(10, p);
<a name="l01515"></a>01515                 <span class="keywordflow">case</span> 2:
<a name="l01516"></a>01516                   <span class="keywordflow">return</span> d1yd1y * clough_raw_shape(4, p)
<a name="l01517"></a>01517                     + d1yd1x * clough_raw_shape(3, p)
<a name="l01518"></a>01518                     + d1yd2n * clough_raw_shape(10, p)
<a name="l01519"></a>01519                     + d1yd3n * clough_raw_shape(11, p)
<a name="l01520"></a>01520                     + 0.5 * N01y * d3nd3n * clough_raw_shape(11, p)
<a name="l01521"></a>01521                     + 0.5 * N02y * d2nd2n * clough_raw_shape(10, p);
<a name="l01522"></a>01522                 <span class="keywordflow">case</span> 4:
<a name="l01523"></a>01523                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape(5, p)
<a name="l01524"></a>01524                     + d2xd2y * clough_raw_shape(6, p)
<a name="l01525"></a>01525                     + d2xd3n * clough_raw_shape(11, p)
<a name="l01526"></a>01526                     + d2xd1n * clough_raw_shape(9, p)
<a name="l01527"></a>01527                     + 0.5 * N10x * d3nd3n * clough_raw_shape(11, p)
<a name="l01528"></a>01528                     + 0.5 * N12x * d1nd1n * clough_raw_shape(9, p);
<a name="l01529"></a>01529                 <span class="keywordflow">case</span> 5:
<a name="l01530"></a>01530                   <span class="keywordflow">return</span> d2yd2y * clough_raw_shape(6, p)
<a name="l01531"></a>01531                     + d2yd2x * clough_raw_shape(5, p)
<a name="l01532"></a>01532                     + d2yd3n * clough_raw_shape(11, p)
<a name="l01533"></a>01533                     + d2yd1n * clough_raw_shape(9, p)
<a name="l01534"></a>01534                     + 0.5 * N10y * d3nd3n * clough_raw_shape(11, p)
<a name="l01535"></a>01535                     + 0.5 * N12y * d1nd1n * clough_raw_shape(9, p);
<a name="l01536"></a>01536                 <span class="keywordflow">case</span> 7:
<a name="l01537"></a>01537                   <span class="keywordflow">return</span> d3xd3x * clough_raw_shape(7, p)
<a name="l01538"></a>01538                     + d3xd3y * clough_raw_shape(8, p)
<a name="l01539"></a>01539                     + d3xd1n * clough_raw_shape(9, p)
<a name="l01540"></a>01540                     + d3xd2n * clough_raw_shape(10, p)
<a name="l01541"></a>01541                     + 0.5 * N20x * d2nd2n * clough_raw_shape(10, p)
<a name="l01542"></a>01542                     + 0.5 * N21x * d1nd1n * clough_raw_shape(9, p);
<a name="l01543"></a>01543                 <span class="keywordflow">case</span> 8:
<a name="l01544"></a>01544                   <span class="keywordflow">return</span> d3yd3y * clough_raw_shape(8, p)
<a name="l01545"></a>01545                     + d3yd3x * clough_raw_shape(7, p)
<a name="l01546"></a>01546                     + d3yd1n * clough_raw_shape(9, p)
<a name="l01547"></a>01547                     + d3yd2n * clough_raw_shape(10, p)
<a name="l01548"></a>01548                     + 0.5 * N20y * d2nd2n * clough_raw_shape(10, p)
<a name="l01549"></a>01549                     + 0.5 * N21y * d1nd1n * clough_raw_shape(9, p);
<a name="l01550"></a>01550                 <span class="keywordflow">default</span>:
<a name="l01551"></a>01551                   libmesh_error();
<a name="l01552"></a>01552                 }
<a name="l01553"></a>01553             }
<a name="l01554"></a>01554           <span class="keywordflow">default</span>:
<a name="l01555"></a>01555             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l01556"></a>01556             libmesh_error();
<a name="l01557"></a>01557           }
<a name="l01558"></a>01558       }
<a name="l01559"></a>01559       <span class="comment">// 3rd-order Clough-Tocher element</span>
<a name="l01560"></a>01560     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l01561"></a>01561       {
<a name="l01562"></a>01562         <span class="keywordflow">switch</span> (type)
<a name="l01563"></a>01563           {
<a name="l01564"></a>01564             <span class="comment">// C1 functions on the Clough-Tocher triangle.</span>
<a name="l01565"></a>01565           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01566"></a>01566             {
<a name="l01567"></a>01567               libmesh_assert (i&lt;12);
<a name="l01568"></a>01568 
<a name="l01569"></a>01569             <span class="comment">// FIXME: it would be nice to calculate (and cache)</span>
<a name="l01570"></a>01570             <span class="comment">// clough_raw_shape(j,p) only once per triangle, not 1-7</span>
<a name="l01571"></a>01571             <span class="comment">// times</span>
<a name="l01572"></a>01572               <span class="keywordflow">switch</span> (i)
<a name="l01573"></a>01573                 {
<a name="l01574"></a>01574             <span class="comment">// Note: these DoF numbers are &quot;scrambled&quot; because my</span>
<a name="l01575"></a>01575             <span class="comment">// initial numbering conventions didn&#39;t match libMesh</span>
<a name="l01576"></a>01576                 <span class="keywordflow">case</span> 0:
<a name="l01577"></a>01577                   <span class="keywordflow">return</span> clough_raw_shape(0, p)
<a name="l01578"></a>01578                     + d1d2n * clough_raw_shape(10, p)
<a name="l01579"></a>01579                     + d1d3n * clough_raw_shape(11, p);
<a name="l01580"></a>01580                 <span class="keywordflow">case</span> 3:
<a name="l01581"></a>01581                   <span class="keywordflow">return</span> clough_raw_shape(1, p)
<a name="l01582"></a>01582                     + d2d3n * clough_raw_shape(11, p)
<a name="l01583"></a>01583                     + d2d1n * clough_raw_shape(9, p);
<a name="l01584"></a>01584                 <span class="keywordflow">case</span> 6:
<a name="l01585"></a>01585                   <span class="keywordflow">return</span> clough_raw_shape(2, p)
<a name="l01586"></a>01586                     + d3d1n * clough_raw_shape(9, p)
<a name="l01587"></a>01587                     + d3d2n * clough_raw_shape(10, p);
<a name="l01588"></a>01588                 <span class="keywordflow">case</span> 1:
<a name="l01589"></a>01589                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape(3, p)
<a name="l01590"></a>01590                     + d1xd1y * clough_raw_shape(4, p)
<a name="l01591"></a>01591                     + d1xd2n * clough_raw_shape(10, p)
<a name="l01592"></a>01592                     + d1xd3n * clough_raw_shape(11, p);
<a name="l01593"></a>01593                 <span class="keywordflow">case</span> 2:
<a name="l01594"></a>01594                   <span class="keywordflow">return</span> d1yd1y * clough_raw_shape(4, p)
<a name="l01595"></a>01595                     + d1yd1x * clough_raw_shape(3, p)
<a name="l01596"></a>01596                     + d1yd2n * clough_raw_shape(10, p)
<a name="l01597"></a>01597                     + d1yd3n * clough_raw_shape(11, p);
<a name="l01598"></a>01598                 <span class="keywordflow">case</span> 4:
<a name="l01599"></a>01599                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape(5, p)
<a name="l01600"></a>01600                     + d2xd2y * clough_raw_shape(6, p)
<a name="l01601"></a>01601                     + d2xd3n * clough_raw_shape(11, p)
<a name="l01602"></a>01602                     + d2xd1n * clough_raw_shape(9, p);
<a name="l01603"></a>01603                 <span class="keywordflow">case</span> 5:
<a name="l01604"></a>01604                   <span class="keywordflow">return</span> d2yd2y * clough_raw_shape(6, p)
<a name="l01605"></a>01605                     + d2yd2x * clough_raw_shape(5, p)
<a name="l01606"></a>01606                     + d2yd3n * clough_raw_shape(11, p)
<a name="l01607"></a>01607                     + d2yd1n * clough_raw_shape(9, p);
<a name="l01608"></a>01608                 <span class="keywordflow">case</span> 7:
<a name="l01609"></a>01609                   <span class="keywordflow">return</span> d3xd3x * clough_raw_shape(7, p)
<a name="l01610"></a>01610                     + d3xd3y * clough_raw_shape(8, p)
<a name="l01611"></a>01611                     + d3xd1n * clough_raw_shape(9, p)
<a name="l01612"></a>01612                     + d3xd2n * clough_raw_shape(10, p);
<a name="l01613"></a>01613                 <span class="keywordflow">case</span> 8:
<a name="l01614"></a>01614                   <span class="keywordflow">return</span> d3yd3y * clough_raw_shape(8, p)
<a name="l01615"></a>01615                     + d3yd3x * clough_raw_shape(7, p)
<a name="l01616"></a>01616                     + d3yd1n * clough_raw_shape(9, p)
<a name="l01617"></a>01617                     + d3yd2n * clough_raw_shape(10, p);
<a name="l01618"></a>01618                 <span class="keywordflow">case</span> 10:
<a name="l01619"></a>01619                   <span class="keywordflow">return</span> d1nd1n * clough_raw_shape(9, p);
<a name="l01620"></a>01620                 <span class="keywordflow">case</span> 11:
<a name="l01621"></a>01621                   <span class="keywordflow">return</span> d2nd2n * clough_raw_shape(10, p);
<a name="l01622"></a>01622                 <span class="keywordflow">case</span> 9:
<a name="l01623"></a>01623                   <span class="keywordflow">return</span> d3nd3n * clough_raw_shape(11, p);
<a name="l01624"></a>01624                   
<a name="l01625"></a>01625                 <span class="keywordflow">default</span>:
<a name="l01626"></a>01626                   libmesh_error();
<a name="l01627"></a>01627                 }
<a name="l01628"></a>01628             }
<a name="l01629"></a>01629           <span class="keywordflow">default</span>:
<a name="l01630"></a>01630             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l01631"></a>01631             libmesh_error();
<a name="l01632"></a>01632           }
<a name="l01633"></a>01633       }
<a name="l01634"></a>01634       <span class="comment">// by default throw an error</span>
<a name="l01635"></a>01635     <span class="keywordflow">default</span>:
<a name="l01636"></a>01636       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l01637"></a>01637       libmesh_error();
<a name="l01638"></a>01638     }
<a name="l01639"></a>01639   
<a name="l01640"></a>01640   libmesh_error();
<a name="l01641"></a>01641   <span class="keywordflow">return</span> 0.;
<a name="l01642"></a>01642 }
<a name="l01643"></a>01643 
<a name="l01644"></a>01644 
<a name="l01645"></a>01645 
<a name="l01646"></a>01646 <span class="keyword">template</span> &lt;&gt;
<a name="l01647"></a><a class="code" href="classlibMesh_1_1FE.php#a24405094930fc3f2e039ad715e6ad908">01647</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,CLOUGH&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l01648"></a>01648                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,                     
<a name="l01649"></a>01649                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01650"></a>01650                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01651"></a>01651                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l01652"></a>01652 {
<a name="l01653"></a>01653   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Clough-Tocher elements require the real element\n&quot;</span>
<a name="l01654"></a>01654                 &lt;&lt; <span class="stringliteral">&quot;to construct gradient-based degrees of freedom.&quot;</span>
<a name="l01655"></a>01655                 &lt;&lt; std::endl;
<a name="l01656"></a>01656 
<a name="l01657"></a>01657   libmesh_error();
<a name="l01658"></a>01658   <span class="keywordflow">return</span> 0.;
<a name="l01659"></a>01659 }
<a name="l01660"></a>01660 
<a name="l01661"></a>01661 
<a name="l01662"></a>01662 
<a name="l01663"></a>01663 <span class="keyword">template</span> &lt;&gt;
<a name="l01664"></a><a class="code" href="classlibMesh_1_1FE.php#aa90ba1402e3d449600075957360e168e">01664</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,CLOUGH&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l01665"></a>01665                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l01666"></a>01666                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l01667"></a>01667                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l01668"></a>01668                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l01669"></a>01669 {
<a name="l01670"></a>01670   libmesh_assert (elem != NULL);
<a name="l01671"></a>01671 
<a name="l01672"></a>01672   clough_compute_coefs(elem);
<a name="l01673"></a>01673 
<a name="l01674"></a>01674   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01675"></a>01675   
<a name="l01676"></a>01676   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01677"></a>01677 
<a name="l01678"></a>01678   <span class="keywordflow">switch</span> (totalorder)
<a name="l01679"></a>01679     {      
<a name="l01680"></a>01680       <span class="comment">// 2nd-order restricted Clough-Tocher element</span>
<a name="l01681"></a>01681     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l01682"></a>01682       {
<a name="l01683"></a>01683         <span class="comment">// There may be a bug in the 2nd order case; the 3rd order</span>
<a name="l01684"></a>01684         <span class="comment">// Clough-Tocher elements are pretty uniformly better anyways</span>
<a name="l01685"></a>01685         <span class="comment">// so use those instead.</span>
<a name="l01686"></a>01686         libmesh_experimental();
<a name="l01687"></a>01687         <span class="keywordflow">switch</span> (type)
<a name="l01688"></a>01688           {
<a name="l01689"></a>01689             <span class="comment">// C1 functions on the Clough-Tocher triangle.</span>
<a name="l01690"></a>01690           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01691"></a>01691             {
<a name="l01692"></a>01692               libmesh_assert (i&lt;9);
<a name="l01693"></a>01693             <span class="comment">// FIXME: it would be nice to calculate (and cache)</span>
<a name="l01694"></a>01694             <span class="comment">// clough_raw_shape(j,p) only once per triangle, not 1-7</span>
<a name="l01695"></a>01695             <span class="comment">// times</span>
<a name="l01696"></a>01696               <span class="keywordflow">switch</span> (i)
<a name="l01697"></a>01697                 {
<a name="l01698"></a>01698             <span class="comment">// Note: these DoF numbers are &quot;scrambled&quot; because my</span>
<a name="l01699"></a>01699             <span class="comment">// initial numbering conventions didn&#39;t match libMesh</span>
<a name="l01700"></a>01700                 <span class="keywordflow">case</span> 0:
<a name="l01701"></a>01701                   <span class="keywordflow">return</span> clough_raw_shape_deriv(0, j, p)
<a name="l01702"></a>01702                     + d1d2n * clough_raw_shape_deriv(10, j, p)
<a name="l01703"></a>01703                     + d1d3n * clough_raw_shape_deriv(11, j, p);
<a name="l01704"></a>01704                 <span class="keywordflow">case</span> 3:
<a name="l01705"></a>01705                   <span class="keywordflow">return</span> clough_raw_shape_deriv(1, j, p)
<a name="l01706"></a>01706                     + d2d3n * clough_raw_shape_deriv(11, j, p)
<a name="l01707"></a>01707                     + d2d1n * clough_raw_shape_deriv(9, j, p);
<a name="l01708"></a>01708                 <span class="keywordflow">case</span> 6:
<a name="l01709"></a>01709                   <span class="keywordflow">return</span> clough_raw_shape_deriv(2, j, p)
<a name="l01710"></a>01710                     + d3d1n * clough_raw_shape_deriv(9, j, p)
<a name="l01711"></a>01711                     + d3d2n * clough_raw_shape_deriv(10, j, p);
<a name="l01712"></a>01712                 <span class="keywordflow">case</span> 1:
<a name="l01713"></a>01713                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape_deriv(3, j, p)
<a name="l01714"></a>01714                     + d1xd1y * clough_raw_shape_deriv(4, j, p)
<a name="l01715"></a>01715                     + d1xd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01716"></a>01716                     + d1xd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01717"></a>01717                     + 0.5 * N01x * d3nd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01718"></a>01718                     + 0.5 * N02x * d2nd2n * clough_raw_shape_deriv(10, j, p);
<a name="l01719"></a>01719                 <span class="keywordflow">case</span> 2:
<a name="l01720"></a>01720                   <span class="keywordflow">return</span> d1yd1y * clough_raw_shape_deriv(4, j, p)
<a name="l01721"></a>01721                     + d1yd1x * clough_raw_shape_deriv(3, j, p)
<a name="l01722"></a>01722                     + d1yd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01723"></a>01723                     + d1yd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01724"></a>01724                     + 0.5 * N01y * d3nd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01725"></a>01725                     + 0.5 * N02y * d2nd2n * clough_raw_shape_deriv(10, j, p);
<a name="l01726"></a>01726                 <span class="keywordflow">case</span> 4:
<a name="l01727"></a>01727                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape_deriv(5, j, p)
<a name="l01728"></a>01728                     + d2xd2y * clough_raw_shape_deriv(6, j, p)
<a name="l01729"></a>01729                     + d2xd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01730"></a>01730                     + d2xd1n * clough_raw_shape_deriv(9, j, p)
<a name="l01731"></a>01731                     + 0.5 * N10x * d3nd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01732"></a>01732                     + 0.5 * N12x * d1nd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01733"></a>01733                 <span class="keywordflow">case</span> 5:
<a name="l01734"></a>01734                   <span class="keywordflow">return</span> d2yd2y * clough_raw_shape_deriv(6, j, p)
<a name="l01735"></a>01735                     + d2yd2x * clough_raw_shape_deriv(5, j, p)
<a name="l01736"></a>01736                     + d2yd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01737"></a>01737                     + d2yd1n * clough_raw_shape_deriv(9, j, p)
<a name="l01738"></a>01738                     + 0.5 * N10y * d3nd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01739"></a>01739                     + 0.5 * N12y * d1nd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01740"></a>01740                 <span class="keywordflow">case</span> 7:
<a name="l01741"></a>01741                   <span class="keywordflow">return</span> d3xd3x * clough_raw_shape_deriv(7, j, p)
<a name="l01742"></a>01742                     + d3xd3y * clough_raw_shape_deriv(8, j, p)
<a name="l01743"></a>01743                     + d3xd1n * clough_raw_shape_deriv(9, j, p)
<a name="l01744"></a>01744                     + d3xd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01745"></a>01745                     + 0.5 * N20x * d2nd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01746"></a>01746                     + 0.5 * N21x * d1nd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01747"></a>01747                 <span class="keywordflow">case</span> 8:
<a name="l01748"></a>01748                   <span class="keywordflow">return</span> d3yd3y * clough_raw_shape_deriv(8, j, p)
<a name="l01749"></a>01749                     + d3yd3x * clough_raw_shape_deriv(7, j, p)
<a name="l01750"></a>01750                     + d3yd1n * clough_raw_shape_deriv(9, j, p)
<a name="l01751"></a>01751                     + d3yd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01752"></a>01752                     + 0.5 * N20y * d2nd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01753"></a>01753                     + 0.5 * N21y * d1nd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01754"></a>01754                 <span class="keywordflow">default</span>:
<a name="l01755"></a>01755                   libmesh_error();
<a name="l01756"></a>01756                 }
<a name="l01757"></a>01757             }
<a name="l01758"></a>01758           <span class="keywordflow">default</span>:
<a name="l01759"></a>01759             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l01760"></a>01760             libmesh_error();
<a name="l01761"></a>01761           }
<a name="l01762"></a>01762       }
<a name="l01763"></a>01763       <span class="comment">// 3rd-order Clough-Tocher element</span>
<a name="l01764"></a>01764     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l01765"></a>01765       {
<a name="l01766"></a>01766         <span class="keywordflow">switch</span> (type)
<a name="l01767"></a>01767           {
<a name="l01768"></a>01768             <span class="comment">// C1 functions on the Clough-Tocher triangle.</span>
<a name="l01769"></a>01769           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01770"></a>01770             {
<a name="l01771"></a>01771               libmesh_assert (i&lt;12);
<a name="l01772"></a>01772 
<a name="l01773"></a>01773             <span class="comment">// FIXME: it would be nice to calculate (and cache)</span>
<a name="l01774"></a>01774             <span class="comment">// clough_raw_shape(j,p) only once per triangle, not 1-7</span>
<a name="l01775"></a>01775             <span class="comment">// times</span>
<a name="l01776"></a>01776               <span class="keywordflow">switch</span> (i)
<a name="l01777"></a>01777                 {
<a name="l01778"></a>01778             <span class="comment">// Note: these DoF numbers are &quot;scrambled&quot; because my</span>
<a name="l01779"></a>01779             <span class="comment">// initial numbering conventions didn&#39;t match libMesh</span>
<a name="l01780"></a>01780                 <span class="keywordflow">case</span> 0:
<a name="l01781"></a>01781                   <span class="keywordflow">return</span> clough_raw_shape_deriv(0, j, p)
<a name="l01782"></a>01782                     + d1d2n * clough_raw_shape_deriv(10, j, p)
<a name="l01783"></a>01783                     + d1d3n * clough_raw_shape_deriv(11, j, p);
<a name="l01784"></a>01784                 <span class="keywordflow">case</span> 3:
<a name="l01785"></a>01785                   <span class="keywordflow">return</span> clough_raw_shape_deriv(1, j, p)
<a name="l01786"></a>01786                     + d2d3n * clough_raw_shape_deriv(11, j, p)
<a name="l01787"></a>01787                     + d2d1n * clough_raw_shape_deriv(9, j, p);
<a name="l01788"></a>01788                 <span class="keywordflow">case</span> 6:
<a name="l01789"></a>01789                   <span class="keywordflow">return</span> clough_raw_shape_deriv(2, j, p)
<a name="l01790"></a>01790                     + d3d1n * clough_raw_shape_deriv(9, j, p)
<a name="l01791"></a>01791                     + d3d2n * clough_raw_shape_deriv(10, j, p);
<a name="l01792"></a>01792                 <span class="keywordflow">case</span> 1:
<a name="l01793"></a>01793                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape_deriv(3, j, p)
<a name="l01794"></a>01794                     + d1xd1y * clough_raw_shape_deriv(4, j, p)
<a name="l01795"></a>01795                     + d1xd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01796"></a>01796                     + d1xd3n * clough_raw_shape_deriv(11, j, p);
<a name="l01797"></a>01797                 <span class="keywordflow">case</span> 2:
<a name="l01798"></a>01798                   <span class="keywordflow">return</span> d1yd1y * clough_raw_shape_deriv(4, j, p)
<a name="l01799"></a>01799                     + d1yd1x * clough_raw_shape_deriv(3, j, p)
<a name="l01800"></a>01800                     + d1yd2n * clough_raw_shape_deriv(10, j, p)
<a name="l01801"></a>01801                     + d1yd3n * clough_raw_shape_deriv(11, j, p);
<a name="l01802"></a>01802                 <span class="keywordflow">case</span> 4:
<a name="l01803"></a>01803                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape_deriv(5, j, p)
<a name="l01804"></a>01804                     + d2xd2y * clough_raw_shape_deriv(6, j, p)
<a name="l01805"></a>01805                     + d2xd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01806"></a>01806                     + d2xd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01807"></a>01807                 <span class="keywordflow">case</span> 5:
<a name="l01808"></a>01808                   <span class="keywordflow">return</span> d2yd2y * clough_raw_shape_deriv(6, j, p)
<a name="l01809"></a>01809                     + d2yd2x * clough_raw_shape_deriv(5, j, p)
<a name="l01810"></a>01810                     + d2yd3n * clough_raw_shape_deriv(11, j, p)
<a name="l01811"></a>01811                     + d2yd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01812"></a>01812                 <span class="keywordflow">case</span> 7:
<a name="l01813"></a>01813                   <span class="keywordflow">return</span> d3xd3x * clough_raw_shape_deriv(7, j, p)
<a name="l01814"></a>01814                     + d3xd3y * clough_raw_shape_deriv(8, j, p)
<a name="l01815"></a>01815                     + d3xd1n * clough_raw_shape_deriv(9, j, p)
<a name="l01816"></a>01816                     + d3xd2n * clough_raw_shape_deriv(10, j, p);
<a name="l01817"></a>01817                 <span class="keywordflow">case</span> 8:
<a name="l01818"></a>01818                   <span class="keywordflow">return</span> d3yd3y * clough_raw_shape_deriv(8, j, p)
<a name="l01819"></a>01819                     + d3yd3x * clough_raw_shape_deriv(7, j, p)
<a name="l01820"></a>01820                     + d3yd1n * clough_raw_shape_deriv(9, j, p)
<a name="l01821"></a>01821                     + d3yd2n * clough_raw_shape_deriv(10, j, p);
<a name="l01822"></a>01822                 <span class="keywordflow">case</span> 10:
<a name="l01823"></a>01823                   <span class="keywordflow">return</span> d1nd1n * clough_raw_shape_deriv(9, j, p);
<a name="l01824"></a>01824                 <span class="keywordflow">case</span> 11:
<a name="l01825"></a>01825                   <span class="keywordflow">return</span> d2nd2n * clough_raw_shape_deriv(10, j, p);
<a name="l01826"></a>01826                 <span class="keywordflow">case</span> 9:
<a name="l01827"></a>01827                   <span class="keywordflow">return</span> d3nd3n * clough_raw_shape_deriv(11, j, p);
<a name="l01828"></a>01828                   
<a name="l01829"></a>01829                 <span class="keywordflow">default</span>:
<a name="l01830"></a>01830                   libmesh_error();
<a name="l01831"></a>01831                 }
<a name="l01832"></a>01832             }
<a name="l01833"></a>01833           <span class="keywordflow">default</span>:
<a name="l01834"></a>01834             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l01835"></a>01835             libmesh_error();
<a name="l01836"></a>01836           }
<a name="l01837"></a>01837       }
<a name="l01838"></a>01838       <span class="comment">// by default throw an error</span>
<a name="l01839"></a>01839     <span class="keywordflow">default</span>:
<a name="l01840"></a>01840       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l01841"></a>01841       libmesh_error();
<a name="l01842"></a>01842     }
<a name="l01843"></a>01843   
<a name="l01844"></a>01844   libmesh_error();
<a name="l01845"></a>01845   <span class="keywordflow">return</span> 0.;
<a name="l01846"></a>01846 }
<a name="l01847"></a>01847 
<a name="l01848"></a>01848 
<a name="l01849"></a>01849 
<a name="l01850"></a>01850 <span class="keyword">template</span> &lt;&gt;
<a name="l01851"></a><a class="code" href="classlibMesh_1_1FE.php#ae497ac6bec11cd13f269d92d122043a5">01851</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;2,CLOUGH&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l01852"></a>01852                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l01853"></a>01853                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l01854"></a>01854                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l01855"></a>01855                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l01856"></a>01856 {
<a name="l01857"></a>01857   libmesh_assert (elem != NULL);
<a name="l01858"></a>01858 
<a name="l01859"></a>01859   clough_compute_coefs(elem);
<a name="l01860"></a>01860 
<a name="l01861"></a>01861   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01862"></a>01862   
<a name="l01863"></a>01863   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01864"></a>01864 
<a name="l01865"></a>01865   <span class="keywordflow">switch</span> (totalorder)
<a name="l01866"></a>01866     {      
<a name="l01867"></a>01867       <span class="comment">// 2nd-order restricted Clough-Tocher element</span>
<a name="l01868"></a>01868     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l01869"></a>01869       {
<a name="l01870"></a>01870         <span class="keywordflow">switch</span> (type)
<a name="l01871"></a>01871           {
<a name="l01872"></a>01872             <span class="comment">// C1 functions on the Clough-Tocher triangle.</span>
<a name="l01873"></a>01873           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01874"></a>01874             {
<a name="l01875"></a>01875               libmesh_assert (i&lt;9);
<a name="l01876"></a>01876             <span class="comment">// FIXME: it would be nice to calculate (and cache)</span>
<a name="l01877"></a>01877             <span class="comment">// clough_raw_shape(j,p) only once per triangle, not 1-7</span>
<a name="l01878"></a>01878             <span class="comment">// times</span>
<a name="l01879"></a>01879               <span class="keywordflow">switch</span> (i)
<a name="l01880"></a>01880                 {
<a name="l01881"></a>01881             <span class="comment">// Note: these DoF numbers are &quot;scrambled&quot; because my</span>
<a name="l01882"></a>01882             <span class="comment">// initial numbering conventions didn&#39;t match libMesh</span>
<a name="l01883"></a>01883                 <span class="keywordflow">case</span> 0:
<a name="l01884"></a>01884                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(0, j, p)
<a name="l01885"></a>01885                     + d1d2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01886"></a>01886                     + d1d3n * clough_raw_shape_second_deriv(11, j, p);
<a name="l01887"></a>01887                 <span class="keywordflow">case</span> 3:
<a name="l01888"></a>01888                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(1, j, p)
<a name="l01889"></a>01889                     + d2d3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01890"></a>01890                     + d2d1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01891"></a>01891                 <span class="keywordflow">case</span> 6:
<a name="l01892"></a>01892                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(2, j, p)
<a name="l01893"></a>01893                     + d3d1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01894"></a>01894                     + d3d2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l01895"></a>01895                 <span class="keywordflow">case</span> 1:
<a name="l01896"></a>01896                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape_second_deriv(3, j, p)
<a name="l01897"></a>01897                     + d1xd1y * clough_raw_shape_second_deriv(4, j, p)
<a name="l01898"></a>01898                     + d1xd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01899"></a>01899                     + d1xd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01900"></a>01900                     + 0.5 * N01x * d3nd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01901"></a>01901                     + 0.5 * N02x * d2nd2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l01902"></a>01902                 <span class="keywordflow">case</span> 2:
<a name="l01903"></a>01903                   <span class="keywordflow">return</span> d1yd1y * clough_raw_shape_second_deriv(4, j, p)
<a name="l01904"></a>01904                     + d1yd1x * clough_raw_shape_second_deriv(3, j, p)
<a name="l01905"></a>01905                     + d1yd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01906"></a>01906                     + d1yd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01907"></a>01907                     + 0.5 * N01y * d3nd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01908"></a>01908                     + 0.5 * N02y * d2nd2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l01909"></a>01909                 <span class="keywordflow">case</span> 4:
<a name="l01910"></a>01910                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape_second_deriv(5, j, p)
<a name="l01911"></a>01911                     + d2xd2y * clough_raw_shape_second_deriv(6, j, p)
<a name="l01912"></a>01912                     + d2xd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01913"></a>01913                     + d2xd1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01914"></a>01914                     + 0.5 * N10x * d3nd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01915"></a>01915                     + 0.5 * N12x * d1nd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01916"></a>01916                 <span class="keywordflow">case</span> 5:
<a name="l01917"></a>01917                   <span class="keywordflow">return</span> d2yd2y * clough_raw_shape_second_deriv(6, j, p)
<a name="l01918"></a>01918                     + d2yd2x * clough_raw_shape_second_deriv(5, j, p)
<a name="l01919"></a>01919                     + d2yd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01920"></a>01920                     + d2yd1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01921"></a>01921                     + 0.5 * N10y * d3nd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01922"></a>01922                     + 0.5 * N12y * d1nd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01923"></a>01923                 <span class="keywordflow">case</span> 7:
<a name="l01924"></a>01924                   <span class="keywordflow">return</span> d3xd3x * clough_raw_shape_second_deriv(7, j, p)
<a name="l01925"></a>01925                     + d3xd3y * clough_raw_shape_second_deriv(8, j, p)
<a name="l01926"></a>01926                     + d3xd1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01927"></a>01927                     + d3xd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01928"></a>01928                     + 0.5 * N20x * d2nd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01929"></a>01929                     + 0.5 * N21x * d1nd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01930"></a>01930                 <span class="keywordflow">case</span> 8:
<a name="l01931"></a>01931                   <span class="keywordflow">return</span> d3yd3y * clough_raw_shape_second_deriv(8, j, p)
<a name="l01932"></a>01932                     + d3yd3x * clough_raw_shape_second_deriv(7, j, p)
<a name="l01933"></a>01933                     + d3yd1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01934"></a>01934                     + d3yd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01935"></a>01935                     + 0.5 * N20y * d2nd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01936"></a>01936                     + 0.5 * N21y * d1nd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01937"></a>01937                 <span class="keywordflow">default</span>:
<a name="l01938"></a>01938                   libmesh_error();
<a name="l01939"></a>01939                 }
<a name="l01940"></a>01940             }
<a name="l01941"></a>01941           <span class="keywordflow">default</span>:
<a name="l01942"></a>01942             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l01943"></a>01943             libmesh_error();
<a name="l01944"></a>01944           }
<a name="l01945"></a>01945       }
<a name="l01946"></a>01946       <span class="comment">// 3rd-order Clough-Tocher element</span>
<a name="l01947"></a>01947     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l01948"></a>01948       {
<a name="l01949"></a>01949         <span class="keywordflow">switch</span> (type)
<a name="l01950"></a>01950           {
<a name="l01951"></a>01951             <span class="comment">// C1 functions on the Clough-Tocher triangle.</span>
<a name="l01952"></a>01952           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01953"></a>01953             {
<a name="l01954"></a>01954               libmesh_assert (i&lt;12);
<a name="l01955"></a>01955 
<a name="l01956"></a>01956             <span class="comment">// FIXME: it would be nice to calculate (and cache)</span>
<a name="l01957"></a>01957             <span class="comment">// clough_raw_shape(j,p) only once per triangle, not 1-7</span>
<a name="l01958"></a>01958             <span class="comment">// times</span>
<a name="l01959"></a>01959               <span class="keywordflow">switch</span> (i)
<a name="l01960"></a>01960                 {
<a name="l01961"></a>01961             <span class="comment">// Note: these DoF numbers are &quot;scrambled&quot; because my</span>
<a name="l01962"></a>01962             <span class="comment">// initial numbering conventions didn&#39;t match libMesh</span>
<a name="l01963"></a>01963                 <span class="keywordflow">case</span> 0:
<a name="l01964"></a>01964                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(0, j, p)
<a name="l01965"></a>01965                     + d1d2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01966"></a>01966                     + d1d3n * clough_raw_shape_second_deriv(11, j, p);
<a name="l01967"></a>01967                 <span class="keywordflow">case</span> 3:
<a name="l01968"></a>01968                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(1, j, p)
<a name="l01969"></a>01969                     + d2d3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01970"></a>01970                     + d2d1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01971"></a>01971                 <span class="keywordflow">case</span> 6:
<a name="l01972"></a>01972                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(2, j, p)
<a name="l01973"></a>01973                     + d3d1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01974"></a>01974                     + d3d2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l01975"></a>01975                 <span class="keywordflow">case</span> 1:
<a name="l01976"></a>01976                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape_second_deriv(3, j, p)
<a name="l01977"></a>01977                     + d1xd1y * clough_raw_shape_second_deriv(4, j, p)
<a name="l01978"></a>01978                     + d1xd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01979"></a>01979                     + d1xd3n * clough_raw_shape_second_deriv(11, j, p);
<a name="l01980"></a>01980                 <span class="keywordflow">case</span> 2:
<a name="l01981"></a>01981                   <span class="keywordflow">return</span> d1yd1y * clough_raw_shape_second_deriv(4, j, p)
<a name="l01982"></a>01982                     + d1yd1x * clough_raw_shape_second_deriv(3, j, p)
<a name="l01983"></a>01983                     + d1yd2n * clough_raw_shape_second_deriv(10, j, p)
<a name="l01984"></a>01984                     + d1yd3n * clough_raw_shape_second_deriv(11, j, p);
<a name="l01985"></a>01985                 <span class="keywordflow">case</span> 4:
<a name="l01986"></a>01986                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape_second_deriv(5, j, p)
<a name="l01987"></a>01987                     + d2xd2y * clough_raw_shape_second_deriv(6, j, p)
<a name="l01988"></a>01988                     + d2xd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01989"></a>01989                     + d2xd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01990"></a>01990                 <span class="keywordflow">case</span> 5:
<a name="l01991"></a>01991                   <span class="keywordflow">return</span> d2yd2y * clough_raw_shape_second_deriv(6, j, p)
<a name="l01992"></a>01992                     + d2yd2x * clough_raw_shape_second_deriv(5, j, p)
<a name="l01993"></a>01993                     + d2yd3n * clough_raw_shape_second_deriv(11, j, p)
<a name="l01994"></a>01994                     + d2yd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l01995"></a>01995                 <span class="keywordflow">case</span> 7:
<a name="l01996"></a>01996                   <span class="keywordflow">return</span> d3xd3x * clough_raw_shape_second_deriv(7, j, p)
<a name="l01997"></a>01997                     + d3xd3y * clough_raw_shape_second_deriv(8, j, p)
<a name="l01998"></a>01998                     + d3xd1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l01999"></a>01999                     + d3xd2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l02000"></a>02000                 <span class="keywordflow">case</span> 8:
<a name="l02001"></a>02001                   <span class="keywordflow">return</span> d3yd3y * clough_raw_shape_second_deriv(8, j, p)
<a name="l02002"></a>02002                     + d3yd3x * clough_raw_shape_second_deriv(7, j, p)
<a name="l02003"></a>02003                     + d3yd1n * clough_raw_shape_second_deriv(9, j, p)
<a name="l02004"></a>02004                     + d3yd2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l02005"></a>02005                 <span class="keywordflow">case</span> 10:
<a name="l02006"></a>02006                   <span class="keywordflow">return</span> d1nd1n * clough_raw_shape_second_deriv(9, j, p);
<a name="l02007"></a>02007                 <span class="keywordflow">case</span> 11:
<a name="l02008"></a>02008                   <span class="keywordflow">return</span> d2nd2n * clough_raw_shape_second_deriv(10, j, p);
<a name="l02009"></a>02009                 <span class="keywordflow">case</span> 9:
<a name="l02010"></a>02010                   <span class="keywordflow">return</span> d3nd3n * clough_raw_shape_second_deriv(11, j, p);
<a name="l02011"></a>02011                   
<a name="l02012"></a>02012                 <span class="keywordflow">default</span>:
<a name="l02013"></a>02013                   libmesh_error();
<a name="l02014"></a>02014                 }
<a name="l02015"></a>02015             }
<a name="l02016"></a>02016           <span class="keywordflow">default</span>:
<a name="l02017"></a>02017             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l02018"></a>02018             libmesh_error();
<a name="l02019"></a>02019           }
<a name="l02020"></a>02020       }
<a name="l02021"></a>02021       <span class="comment">// by default throw an error</span>
<a name="l02022"></a>02022     <span class="keywordflow">default</span>:
<a name="l02023"></a>02023       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l02024"></a>02024       libmesh_error();
<a name="l02025"></a>02025     }
<a name="l02026"></a>02026   
<a name="l02027"></a>02027   libmesh_error();
<a name="l02028"></a>02028   <span class="keywordflow">return</span> 0.;
<a name="l02029"></a>02029 }
<a name="l02030"></a>02030 
<a name="l02031"></a>02031 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
