<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_communication.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__communication_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_communication.C 4390 2011-04-21 17:02:25Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="location__maps_8h.php">location_maps.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="parallel__ghost__sync_8h.php">parallel_ghost_sync.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">//-----------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// anonymous namespace for implementation details</span>
<a name="l00044"></a>00044 <span class="keyword">namespace </span>{
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keyword">using</span> <a class="code" href="classlibMesh_1_1Elem.php">libMesh::Elem</a>;
<a name="l00047"></a>00047 
<a name="l00054"></a>00054   <span class="keyword">struct </span>CompareElemIdsByLevel
<a name="l00055"></a>00055   {
<a name="l00056"></a>00056     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> Elem *a,
<a name="l00057"></a>00057                     <span class="keyword">const</span> Elem *b)<span class="keyword"> const</span>
<a name="l00058"></a>00058 <span class="keyword">    </span>{
<a name="l00059"></a>00059       libmesh_assert (a);
<a name="l00060"></a>00060       libmesh_assert (b);
<a name="l00061"></a>00061       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00062"></a>00062         al = a-&gt;level(), bl = b-&gt;level(),
<a name="l00063"></a>00063         aid = a-&gt;id(),   bid = b-&gt;id();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065       <span class="keywordflow">return</span> (al == bl) ? aid &lt; bid : al &lt; bl;
<a name="l00066"></a>00066     }
<a name="l00067"></a>00067   };
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00073"></a>00073     FaceNeighborMask[] = { 1,    <span class="comment">// face 0 neighbor</span>
<a name="l00074"></a>00074                            2,    <span class="comment">// face 1 neighbor</span>
<a name="l00075"></a>00075                            4,    <span class="comment">// face 2 neighbor</span>
<a name="l00076"></a>00076                            8,    <span class="comment">// face 3 neighbor</span>
<a name="l00077"></a>00077                            16,   <span class="comment">// face 4 neighbor</span>
<a name="l00078"></a>00078                            32 }; <span class="comment">// face 5 neighbor</span>
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="keyword">namespace </span>libMesh
<a name="l00083"></a>00083 {
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00087"></a>00087 <span class="comment">// MeshCommunication class members</span>
<a name="l00088"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a227f46dad6159d846d8e6c90a9cfe3cb">00088</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a227f46dad6159d846d8e6c90a9cfe3cb">MeshCommunication::clear</a> ()
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <span class="comment">//  _neighboring_processors.clear();</span>
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="comment">// #ifdef LIBMESH_HAVE_MPI</span>
<a name="l00095"></a>00095 <span class="comment">// void MeshCommunication::find_neighboring_processors (const MeshBase&amp; mesh)</span>
<a name="l00096"></a>00096 <span class="comment">// {</span>
<a name="l00097"></a>00097 <span class="comment">//   // Don&#39;t need to do anything if there is</span>
<a name="l00098"></a>00098 <span class="comment">//   // only one processor.</span>
<a name="l00099"></a>00099 <span class="comment">//   if (libMesh::n_processors() == 1)</span>
<a name="l00100"></a>00100 <span class="comment">//     return;</span>
<a name="l00101"></a>00101   
<a name="l00102"></a>00102 <span class="comment">//   _neighboring_processors.clear();</span>
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="comment">//   // Get the bounding sphere for the local processor</span>
<a name="l00105"></a>00105 <span class="comment">//   Sphere bounding_sphere =</span>
<a name="l00106"></a>00106 <span class="comment">//     MeshTools::processor_bounding_sphere (mesh, libMesh::processor_id());</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="comment">//   // Just to be sure, increase its radius by 10%.  Sure would suck to</span>
<a name="l00109"></a>00109 <span class="comment">//   // miss a neighboring processor!</span>
<a name="l00110"></a>00110 <span class="comment">//   bounding_sphere.radius() *= 1.1;</span>
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="comment">//   // Collect the bounding spheres from all processors, test for intersection</span>
<a name="l00113"></a>00113 <span class="comment">//   {</span>
<a name="l00114"></a>00114 <span class="comment">//     std::vector&lt;float&gt;</span>
<a name="l00115"></a>00115 <span class="comment">//       send (4,                         0),</span>
<a name="l00116"></a>00116 <span class="comment">//       recv (4*libMesh::n_processors(), 0);</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="comment">//     send[0] = bounding_sphere.center()(0);</span>
<a name="l00119"></a>00119 <span class="comment">//     send[1] = bounding_sphere.center()(1);</span>
<a name="l00120"></a>00120 <span class="comment">//     send[2] = bounding_sphere.center()(2);</span>
<a name="l00121"></a>00121 <span class="comment">//     send[3] = bounding_sphere.radius();</span>
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="comment">//     MPI_Allgather (&amp;send[0], send.size(), MPI_FLOAT,</span>
<a name="l00124"></a>00124 <span class="comment">//                 &amp;recv[0], send.size(), MPI_FLOAT,</span>
<a name="l00125"></a>00125 <span class="comment">//                 libMesh::COMM_WORLD);</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="comment">//     for (unsigned int proc=0; proc&lt;libMesh::n_processors(); proc++)</span>
<a name="l00129"></a>00129 <span class="comment">//       {</span>
<a name="l00130"></a>00130 <span class="comment">//      const Point center (recv[4*proc+0],</span>
<a name="l00131"></a>00131 <span class="comment">//                          recv[4*proc+1],</span>
<a name="l00132"></a>00132 <span class="comment">//                          recv[4*proc+2]);</span>
<a name="l00133"></a>00133         
<a name="l00134"></a>00134 <span class="comment">//      const Real radius = recv[4*proc+3];</span>
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="comment">//      const Sphere proc_sphere (center, radius);</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="comment">//      if (bounding_sphere.intersects(proc_sphere))</span>
<a name="l00139"></a>00139 <span class="comment">//        _neighboring_processors.push_back(proc);</span>
<a name="l00140"></a>00140 <span class="comment">//       }</span>
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="comment">//     // Print out the _neighboring_processors list</span>
<a name="l00143"></a>00143 <span class="comment">//     libMesh::out &lt;&lt; &quot;Processor &quot; &lt;&lt; libMesh::processor_id()</span>
<a name="l00144"></a>00144 <span class="comment">//            &lt;&lt; &quot; intersects:&quot; &lt;&lt; std::endl;</span>
<a name="l00145"></a>00145 <span class="comment">//     for (unsigned int p=0; p&lt;_neighboring_processors.size(); p++)</span>
<a name="l00146"></a>00146 <span class="comment">//       libMesh::out &lt;&lt; &quot; &quot; &lt;&lt; _neighboring_processors[p] &lt;&lt; std::endl;</span>
<a name="l00147"></a>00147 <span class="comment">//   }</span>
<a name="l00148"></a>00148 <span class="comment">// }</span>
<a name="l00149"></a>00149 <span class="comment">// #else</span>
<a name="l00150"></a>00150 <span class="comment">// void MeshCommunication::find_neighboring_processors (const MeshBase&amp;)</span>
<a name="l00151"></a>00151 <span class="comment">// {</span>
<a name="l00152"></a>00152 <span class="comment">// }</span>
<a name="l00153"></a>00153 <span class="comment">// #endif</span>
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI // avoid spurious gcc warnings</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00159"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a64195de35a3f834f9393aad8b6ca1be2">00159</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a64195de35a3f834f9393aad8b6ca1be2">MeshCommunication::redistribute</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;)<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword"></span>{
<a name="l00161"></a>00161   <span class="comment">// no MPI == one processor, no redistribution</span>
<a name="l00162"></a>00162   <span class="keywordflow">return</span>;
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 <span class="preprocessor">#else</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00166"></a>00166 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a64195de35a3f834f9393aad8b6ca1be2">MeshCommunication::redistribute</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword"></span>{
<a name="l00168"></a>00168   <span class="comment">// This method will be called after a new partitioning has been </span>
<a name="l00169"></a>00169   <span class="comment">// assigned to the elements.  This partitioning was defined in</span>
<a name="l00170"></a>00170   <span class="comment">// terms of the active elements, and &quot;trickled down&quot; to the</span>
<a name="l00171"></a>00171   <span class="comment">// parents and nodes as to be consistent.</span>
<a name="l00172"></a>00172   <span class="comment">//</span>
<a name="l00173"></a>00173   <span class="comment">// The point is that the entire concept of local elements is</span>
<a name="l00174"></a>00174   <span class="comment">// kinda shaky in this method.  Elements which were previously</span>
<a name="l00175"></a>00175   <span class="comment">// local may now be assigned to other processors, so we need to</span>
<a name="l00176"></a>00176   <span class="comment">// send those off.  Similarly, we need to accept elements from</span>
<a name="l00177"></a>00177   <span class="comment">// other processors.  </span>
<a name="l00178"></a>00178   <span class="comment">// </span>
<a name="l00179"></a>00179   <span class="comment">// The approach is as follows:</span>
<a name="l00180"></a>00180   <span class="comment">// (1) send all elements we have stored to their proper homes</span>
<a name="l00181"></a>00181   <span class="comment">// (2) receive elements from all processors, watching for duplicates</span>
<a name="l00182"></a>00182   <span class="comment">// (3) deleting all nonlocal elements elements</span>
<a name="l00183"></a>00183   <span class="comment">// (4) obtaining required ghost elements from neighboring processors</span>
<a name="l00184"></a>00184   parallel_only();
<a name="l00185"></a>00185   libmesh_assert (!mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>());
<a name="l00186"></a>00186   libmesh_assert (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">MeshTools::n_elem</a>(mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a118989a5196f5c3a3ba79bea01966c6d">unpartitioned_elements_begin</a>(),
<a name="l00187"></a>00187                                     mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac34a0c2b38beb146284f0462a13508d4">unpartitioned_elements_end</a>()) == 0);
<a name="l00188"></a>00188   
<a name="l00189"></a>00189   START_LOG(<span class="stringliteral">&quot;redistribute()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">// register a derived datatype to use in shipping nodes  </span>
<a name="l00192"></a>00192   <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">Parallel::DataType</a> packed_node_datatype = <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a55550d69ace1f2e06fa03a9f21d850c0">Node::PackedNode::create_mpi_datatype</a>();
<a name="l00193"></a>00193   packed_node_datatype.<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#ad851f9206f34f41a4b71426a3b642928">commit</a>();
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="comment">// Get a few unique message tags to use in communications; we&#39;ll</span>
<a name="l00196"></a>00196   <span class="comment">// default to some numbers around pi*1000</span>
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a>
<a name="l00198"></a>00198     nodestag   = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(3141),
<a name="l00199"></a>00199     nodebcstag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(3142),
<a name="l00200"></a>00200     elemstag   = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(3143),
<a name="l00201"></a>00201     elembcstag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(3144);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="comment">// Figure out how many nodes and elements we have which are assigned to each</span>
<a name="l00204"></a>00204   <span class="comment">// processor.  send_n_nodes_and_elem_per_proc contains the number of nodes/elements</span>
<a name="l00205"></a>00205   <span class="comment">// we will be sending to each processor, recv_n_nodes_and_elem_per_proc contains</span>
<a name="l00206"></a>00206   <span class="comment">// the number of nodes/elements we will be receiving from each processor.</span>
<a name="l00207"></a>00207   <span class="comment">// Format:</span>
<a name="l00208"></a>00208   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+0] = number of nodes to send to pid</span>
<a name="l00209"></a>00209   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+1] = number of elements to send to pid</span>
<a name="l00210"></a>00210   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+2] = connectivity buffer size</span>
<a name="l00211"></a>00211   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+3] = node bc buffer size</span>
<a name="l00212"></a>00212   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+4] = element bc buffer size</span>
<a name="l00213"></a>00213   std::vector&lt;unsigned int&gt; send_n_nodes_and_elem_per_proc(5*<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00214"></a>00214   
<a name="l00215"></a>00215   std::vector&lt;std::vector&lt;Node::PackedNode&gt; &gt;
<a name="l00216"></a>00216     nodes_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   std::vector&lt;std::vector&lt;int&gt; &gt; 
<a name="l00219"></a>00219     elements_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00220"></a>00220     node_bcs_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00221"></a>00221     element_bcs_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00222"></a>00222     
<a name="l00223"></a>00223   std::vector&lt;Parallel::Request&gt;
<a name="l00224"></a>00224     node_send_requests, element_send_requests,
<a name="l00225"></a>00225     node_bc_requests,   element_bc_requests;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00228"></a>00228     <span class="keywordflow">if</span> (pid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="comment">// don&#39;t send to ourselves!!</span>
<a name="l00229"></a>00229       {
<a name="l00230"></a>00230         <span class="comment">// Build up a list of nodes and elements to send to processor pid.</span>
<a name="l00231"></a>00231         <span class="comment">// We will certainly send all the active elements assigned to this processor,</span>
<a name="l00232"></a>00232         <span class="comment">// but we will also ship off the other elements in the same family tree</span>
<a name="l00233"></a>00233         <span class="comment">// as the active ones for data structure consistency.  We also</span>
<a name="l00234"></a>00234         <span class="comment">// ship any nodes connected to these elements.  Note some of these nodes</span>
<a name="l00235"></a>00235         <span class="comment">// and elements may be replicated from other processors, but that is OK.</span>
<a name="l00236"></a>00236         std::set&lt;const Elem*, CompareElemIdsByLevel&gt; elements_to_send;
<a name="l00237"></a>00237         std::set&lt;const Node*&gt; connected_nodes;
<a name="l00238"></a>00238         {
<a name="l00239"></a>00239           std::vector&lt;const Elem*&gt; family_tree;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241           <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84dd911088eb2db83dece207ae50878">active_pid_elements_begin</a>(pid);
<a name="l00242"></a>00242           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a76bebba197955acced2e10deba2052f6">active_pid_elements_end</a>(pid);
<a name="l00243"></a>00243           
<a name="l00244"></a>00244           <span class="keywordflow">for</span> (; elem_it!=elem_end; ++elem_it)
<a name="l00245"></a>00245             {
<a name="l00246"></a>00246               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *top_parent = (*elem_it)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a>();
<a name="l00247"></a>00247 
<a name="l00248"></a>00248               <span class="comment">// avoid a lot of duplication -- if we already have top_parent</span>
<a name="l00249"></a>00249               <span class="comment">// in the set its entire family tree is already in the set.</span>
<a name="l00250"></a>00250               <span class="keywordflow">if</span> (!elements_to_send.count(top_parent))
<a name="l00251"></a>00251                 {
<a name="l00252"></a>00252 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span>                  top_parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1d76a56b53265428558d0851f1ae09b">family_tree</a>(family_tree);
<a name="l00254"></a>00254 <span class="preprocessor">#else</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>                  family_tree.clear();
<a name="l00256"></a>00256                   family_tree.push_back(top_parent);
<a name="l00257"></a>00257 <span class="preprocessor">#endif</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>                  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;family_tree.size(); e++)
<a name="l00259"></a>00259                     {
<a name="l00260"></a>00260                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = family_tree[e];
<a name="l00261"></a>00261                       elements_to_send.insert (elem);
<a name="l00262"></a>00262                       
<a name="l00263"></a>00263                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00264"></a>00264                         connected_nodes.insert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n));               
<a name="l00265"></a>00265                     }
<a name="l00266"></a>00266                 }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268               <span class="comment">// then do the same for the face neighbors</span>
<a name="l00269"></a>00269               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*elem_it)-&gt;n_sides(); s++)
<a name="l00270"></a>00270                 <span class="keywordflow">if</span> ((*elem_it)-&gt;neighbor(s) != NULL)
<a name="l00271"></a>00271                   <span class="keywordflow">if</span> (!(*elem_it)-&gt;neighbor(s)-&gt;is_remote())
<a name="l00272"></a>00272                     {
<a name="l00273"></a>00273                       top_parent = (*elem_it)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s)-&gt;top_parent();
<a name="l00274"></a>00274                       
<a name="l00275"></a>00275                       <span class="keywordflow">if</span> (!elements_to_send.count(top_parent))
<a name="l00276"></a>00276                         {
<a name="l00277"></a>00277 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>                          top_parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1d76a56b53265428558d0851f1ae09b">family_tree</a>(family_tree);
<a name="l00279"></a>00279 <span class="preprocessor">#else</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>                          family_tree.clear();
<a name="l00281"></a>00281                           family_tree.push_back(top_parent);
<a name="l00282"></a>00282 <span class="preprocessor">#endif                    </span>
<a name="l00283"></a>00283 <span class="preprocessor"></span>                          <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;family_tree.size(); e++)
<a name="l00284"></a>00284                             {
<a name="l00285"></a>00285                               <span class="keyword">const</span> Elem *elem = family_tree[e];
<a name="l00286"></a>00286                               elements_to_send.insert (elem);
<a name="l00287"></a>00287                               
<a name="l00288"></a>00288                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;n_nodes(); n++)
<a name="l00289"></a>00289                                 connected_nodes.insert (elem-&gt;get_node(n));               
<a name="l00290"></a>00290                             }
<a name="l00291"></a>00291                         }
<a name="l00292"></a>00292                     }
<a name="l00293"></a>00293             }
<a name="l00294"></a>00294         }
<a name="l00295"></a>00295         <span class="comment">// The elements_to_send set now contains all the elements stored on the local</span>
<a name="l00296"></a>00296         <span class="comment">// processor but owned by processor pid.  Additionally, the face neighbors</span>
<a name="l00297"></a>00297         <span class="comment">// for these elements are also transferred.  Finally, the entire refinement</span>
<a name="l00298"></a>00298         <span class="comment">// tree is also included.  This is a very simplistic way of ensuring data</span>
<a name="l00299"></a>00299         <span class="comment">// structure consistency at the cost of larger communication buffers.  It is</span>
<a name="l00300"></a>00300         <span class="comment">// worth profiling this on several parallel architectures to assess its impact.</span>
<a name="l00301"></a>00301         
<a name="l00302"></a>00302         
<a name="l00303"></a>00303         <span class="keywordflow">if</span> (!connected_nodes.empty())
<a name="l00304"></a>00304           {
<a name="l00305"></a>00305             <span class="comment">// the number of nodes we will ship to pid</span>
<a name="l00306"></a>00306             send_n_nodes_and_elem_per_proc[5*pid+0] = connected_nodes.size();
<a name="l00307"></a>00307             
<a name="l00308"></a>00308             nodes_sent[pid].reserve(connected_nodes.size());
<a name="l00309"></a>00309             
<a name="l00310"></a>00310             <span class="keywordflow">for</span> (std::set&lt;const Node*&gt;::const_iterator node_it = connected_nodes.begin();
<a name="l00311"></a>00311                  node_it != connected_nodes.end(); ++node_it)
<a name="l00312"></a>00312               {
<a name="l00313"></a>00313                 nodes_sent[pid].push_back(Node::PackedNode(**node_it));
<a name="l00314"></a>00314 
<a name="l00315"></a>00315                 <span class="comment">// add the node if it has BCs</span>
<a name="l00316"></a>00316                 std::vector&lt;short int&gt; bcs = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(*node_it);
<a name="l00317"></a>00317                 
<a name="l00318"></a>00318                 <span class="keywordflow">if</span> (!bcs.empty())
<a name="l00319"></a>00319                   {
<a name="l00320"></a>00320                     node_bcs_sent[pid].push_back((*node_it)-&gt;id());
<a name="l00321"></a>00321                     node_bcs_sent[pid].push_back(bcs.size());
<a name="l00322"></a>00322                     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; bcs.size(); bc_it++)
<a name="l00323"></a>00323                       node_bcs_sent[pid].push_back(bcs[bc_it]);
<a name="l00324"></a>00324                   }
<a name="l00325"></a>00325               }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327             <span class="comment">// the size of the node bc buffer we will ship to pid</span>
<a name="l00328"></a>00328             send_n_nodes_and_elem_per_proc[5*pid+3] = node_bcs_sent[pid].size();            
<a name="l00329"></a>00329             
<a name="l00330"></a>00330             <span class="comment">// send the nodes off to the destination processor</span>
<a name="l00331"></a>00331             node_send_requests.push_back(<a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">Parallel::request</a>());
<a name="l00332"></a>00332           
<a name="l00333"></a>00333             <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (pid,
<a name="l00334"></a>00334                             nodes_sent[pid],
<a name="l00335"></a>00335                             packed_node_datatype,
<a name="l00336"></a>00336                             node_send_requests.back(),
<a name="l00337"></a>00337                             nodestag);
<a name="l00338"></a>00338 
<a name="l00339"></a>00339             <span class="keywordflow">if</span> (!node_bcs_sent[pid].empty())
<a name="l00340"></a>00340               {
<a name="l00341"></a>00341                 node_bc_requests.push_back(<a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">Parallel::request</a>());
<a name="l00342"></a>00342 
<a name="l00343"></a>00343                 <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (pid,
<a name="l00344"></a>00344                                 node_bcs_sent[pid],
<a name="l00345"></a>00345                                 node_bc_requests.back(),
<a name="l00346"></a>00346                                 nodebcstag);
<a name="l00347"></a>00347               }
<a name="l00348"></a>00348           }
<a name="l00349"></a>00349         
<a name="l00350"></a>00350         <span class="keywordflow">if</span> (!elements_to_send.empty())
<a name="l00351"></a>00351           {
<a name="l00352"></a>00352             <span class="comment">// the number of elements we will send to this processor</span>
<a name="l00353"></a>00353             send_n_nodes_and_elem_per_proc[5*pid+1] = elements_to_send.size();
<a name="l00354"></a>00354 
<a name="l00355"></a>00355             <span class="keywordflow">for</span> (std::set&lt;const Elem*, CompareElemIdsByLevel&gt;::const_iterator 
<a name="l00356"></a>00356                    elem_it = elements_to_send.begin(); elem_it != elements_to_send.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>(); ++elem_it)
<a name="l00357"></a>00357               {
<a name="l00358"></a>00358                 <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">Elem::PackedElem::pack</a> (elements_sent[pid], *elem_it);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360                 <span class="comment">// if this is a level-0 element look for boundary conditions</span>
<a name="l00361"></a>00361                 <span class="keywordflow">if</span> ((*elem_it)-&gt;level() == 0)
<a name="l00362"></a>00362                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*elem_it)-&gt;n_sides(); s++)
<a name="l00363"></a>00363                     <span class="keywordflow">if</span> ((*elem_it)-&gt;neighbor(s) == NULL)
<a name="l00364"></a>00364                       {
<a name="l00365"></a>00365                         <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; bc_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(*elem_it, s);
<a name="l00366"></a>00366                         <span class="keywordflow">for</span> (std::vector&lt;short int&gt;::const_iterator id_it=bc_ids.begin(); id_it!=bc_ids.end(); ++id_it)
<a name="l00367"></a>00367                           {
<a name="l00368"></a>00368                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a> = *id_it;
<a name="l00369"></a>00369                             <span class="keywordflow">if</span> (bc_id != mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;invalid_id)
<a name="l00370"></a>00370                               {
<a name="l00371"></a>00371                                 element_bcs_sent[pid].push_back ((*elem_it)-&gt;id());
<a name="l00372"></a>00372                                 element_bcs_sent[pid].push_back (s);
<a name="l00373"></a>00373                                 element_bcs_sent[pid].push_back (bc_id);
<a name="l00374"></a>00374                               }
<a name="l00375"></a>00375                           }
<a name="l00376"></a>00376                       }
<a name="l00377"></a>00377               }
<a name="l00378"></a>00378             
<a name="l00379"></a>00379             <span class="comment">// the packed connectivity size to send to this processor</span>
<a name="l00380"></a>00380             send_n_nodes_and_elem_per_proc[5*pid+2] = elements_sent[pid].size();
<a name="l00381"></a>00381 
<a name="l00382"></a>00382             <span class="comment">// send the elements off to the destination processor</span>
<a name="l00383"></a>00383             element_send_requests.push_back(<a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">Parallel::request</a>());
<a name="l00384"></a>00384           
<a name="l00385"></a>00385             <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (pid,
<a name="l00386"></a>00386                             elements_sent[pid],
<a name="l00387"></a>00387                             element_send_requests.back(),
<a name="l00388"></a>00388                             elemstag);
<a name="l00389"></a>00389 
<a name="l00390"></a>00390             <span class="comment">// the size of the element bc buffer we will ship to pid</span>
<a name="l00391"></a>00391             send_n_nodes_and_elem_per_proc[5*pid+4] = element_bcs_sent[pid].size();
<a name="l00392"></a>00392 
<a name="l00393"></a>00393             <span class="keywordflow">if</span> (!element_bcs_sent[pid].empty())
<a name="l00394"></a>00394               {
<a name="l00395"></a>00395                 element_bc_requests.push_back(<a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">Parallel::request</a>());
<a name="l00396"></a>00396 
<a name="l00397"></a>00397                 <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (pid,
<a name="l00398"></a>00398                                 element_bcs_sent[pid],
<a name="l00399"></a>00399                                 element_bc_requests.back(),
<a name="l00400"></a>00400                                 elembcstag);
<a name="l00401"></a>00401               }
<a name="l00402"></a>00402           }
<a name="l00403"></a>00403       }
<a name="l00404"></a>00404   
<a name="l00405"></a>00405   std::vector&lt;unsigned int&gt; recv_n_nodes_and_elem_per_proc(send_n_nodes_and_elem_per_proc);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">Parallel::alltoall</a> (recv_n_nodes_and_elem_per_proc);
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   <span class="comment">// In general we will only need to communicate with a subset of the other processors.</span>
<a name="l00410"></a>00410   <span class="comment">// I can&#39;t immediately think of a case where we will send elements but not nodes, but</span>
<a name="l00411"></a>00411   <span class="comment">// these are only bools and we have the information anyway...</span>
<a name="l00412"></a>00412   std::vector&lt;bool&gt;
<a name="l00413"></a>00413     send_node_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>), send_elem_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>),
<a name="l00414"></a>00414     recv_node_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>), recv_elem_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>);
<a name="l00415"></a>00415   
<a name="l00416"></a>00416   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00417"></a>00417     n_send_node_pairs=0,     n_send_elem_pairs=0,
<a name="l00418"></a>00418     n_send_node_bc_pairs=0,  n_send_elem_bc_pairs=0, 
<a name="l00419"></a>00419     n_recv_node_pairs=0,     n_recv_elem_pairs=0,
<a name="l00420"></a>00420     n_recv_node_bc_pairs=0,  n_recv_elem_bc_pairs=0, 
<a name="l00421"></a>00421     max_n_nodes_received=0,  max_conn_size_received=0,
<a name="l00422"></a>00422     max_node_bcs_received=0, max_elem_bcs_received=0;
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00425"></a>00425     {
<a name="l00426"></a>00426       <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+0]) <span class="comment">// we have nodes to send</span>
<a name="l00427"></a>00427         {
<a name="l00428"></a>00428           send_node_pair[pid] = <span class="keyword">true</span>;
<a name="l00429"></a>00429           n_send_node_pairs++;
<a name="l00430"></a>00430 
<a name="l00431"></a>00431           <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+3]) <span class="comment">// and node bcs</span>
<a name="l00432"></a>00432             n_send_node_bc_pairs++;
<a name="l00433"></a>00433         }
<a name="l00434"></a>00434       
<a name="l00435"></a>00435       <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+1]) <span class="comment">// we have elements to send</span>
<a name="l00436"></a>00436         {
<a name="l00437"></a>00437           send_elem_pair[pid] = <span class="keyword">true</span>;
<a name="l00438"></a>00438           n_send_elem_pairs++;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440           <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+4]) <span class="comment">// and element bcs</span>
<a name="l00441"></a>00441             n_send_elem_bc_pairs++;
<a name="l00442"></a>00442         }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444       <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+0]) <span class="comment">// we have nodes to receive</span>
<a name="l00445"></a>00445         {
<a name="l00446"></a>00446           recv_node_pair[pid] = <span class="keyword">true</span>;
<a name="l00447"></a>00447           n_recv_node_pairs++;
<a name="l00448"></a>00448           max_n_nodes_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_n_nodes_received,
<a name="l00449"></a>00449                                           recv_n_nodes_and_elem_per_proc[5*pid+0]);
<a name="l00450"></a>00450 
<a name="l00451"></a>00451           <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+3]) <span class="comment">// and node bcs</span>
<a name="l00452"></a>00452             {
<a name="l00453"></a>00453               n_recv_node_bc_pairs++;
<a name="l00454"></a>00454               max_node_bcs_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_node_bcs_received,
<a name="l00455"></a>00455                                                recv_n_nodes_and_elem_per_proc[5*pid+3]);
<a name="l00456"></a>00456             }           
<a name="l00457"></a>00457         }
<a name="l00458"></a>00458       
<a name="l00459"></a>00459       <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+1]) <span class="comment">// we have elements to receive</span>
<a name="l00460"></a>00460         {
<a name="l00461"></a>00461           recv_elem_pair[pid] = <span class="keyword">true</span>;
<a name="l00462"></a>00462           n_recv_elem_pairs++;
<a name="l00463"></a>00463           max_conn_size_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_conn_size_received,
<a name="l00464"></a>00464                                             recv_n_nodes_and_elem_per_proc[5*pid+2]);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466           <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+4]) <span class="comment">// and element bcs</span>
<a name="l00467"></a>00467             {
<a name="l00468"></a>00468               n_recv_elem_bc_pairs++;
<a name="l00469"></a>00469               max_elem_bcs_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_elem_bcs_received,
<a name="l00470"></a>00470                                                recv_n_nodes_and_elem_per_proc[5*pid+4]);
<a name="l00471"></a>00471             }
<a name="l00472"></a>00472         }
<a name="l00473"></a>00473     }
<a name="l00474"></a>00474   libmesh_assert (n_send_node_pairs    == node_send_requests.size());
<a name="l00475"></a>00475   libmesh_assert (n_send_elem_pairs    == element_send_requests.size());
<a name="l00476"></a>00476   libmesh_assert (n_send_node_bc_pairs == node_bc_requests.size());
<a name="l00477"></a>00477   libmesh_assert (n_send_elem_bc_pairs == element_bc_requests.size());
<a name="l00478"></a>00478 
<a name="l00479"></a>00479   <span class="comment">// Receive nodes.  Size this array for the largest message.</span>
<a name="l00480"></a>00480   {
<a name="l00481"></a>00481     std::vector&lt;Node::PackedNode&gt; received_nodes; 
<a name="l00482"></a>00482     received_nodes.reserve(max_n_nodes_received);
<a name="l00483"></a>00483 
<a name="l00484"></a>00484     <span class="comment">// We now know how many processors will be sending us nodes.</span>
<a name="l00485"></a>00485     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_comm_step=0; node_comm_step&lt;n_recv_node_pairs; node_comm_step++)
<a name="l00486"></a>00486       {
<a name="l00487"></a>00487         <span class="comment">// but we don&#39;t necessarily want to impose an ordering, so</span>
<a name="l00488"></a>00488         <span class="comment">// just grab whatever message is available next.  note that</span>
<a name="l00489"></a>00489         <span class="comment">// the blocking receive should resize the vector to fit the</span>
<a name="l00490"></a>00490         <span class="comment">// incoming message</span>
<a name="l00491"></a>00491         Parallel::Status <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> =
<a name="l00492"></a>00492           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>,
<a name="l00493"></a>00493                              received_nodes,
<a name="l00494"></a>00494                              packed_node_datatype,
<a name="l00495"></a>00495                              nodestag);
<a name="l00496"></a>00496         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_pid = status.source();
<a name="l00497"></a>00497         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_nodes_received =
<a name="l00498"></a>00498           recv_n_nodes_and_elem_per_proc[5*source_pid+0];
<a name="l00499"></a>00499         libmesh_assert (n_nodes_received == received_nodes.size());
<a name="l00500"></a>00500         libmesh_assert (status.size() == n_nodes_received);
<a name="l00501"></a>00501         libmesh_assert (recv_node_pair[source_pid]);
<a name="l00502"></a>00502         
<a name="l00503"></a>00503         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_nodes_received; n++)
<a name="l00504"></a>00504           {
<a name="l00505"></a>00505             Node *node = received_nodes[n].build_node().release();
<a name="l00506"></a>00506             mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">insert_node</a>(node); <span class="comment">// insert_node works even if the</span>
<a name="l00507"></a>00507           }                         <span class="comment">// node already exists in the mesh,</span>
<a name="l00508"></a>00508       }                             <span class="comment">// in which case it overwrites (x,y,z)</span>
<a name="l00509"></a>00509   }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511   <span class="comment">// Receive BCs for those nodes.</span>
<a name="l00512"></a>00512   {
<a name="l00513"></a>00513     std::vector&lt;int&gt; received_node_bcs(max_node_bcs_received);
<a name="l00514"></a>00514 
<a name="l00515"></a>00515     <span class="comment">// again, receive all the messages in whatever order they come.</span>
<a name="l00516"></a>00516     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_comm_step=0; node_comm_step&lt;n_recv_node_bc_pairs; node_comm_step++)
<a name="l00517"></a>00517       {
<a name="l00518"></a>00518         Parallel::Status status =
<a name="l00519"></a>00519           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>,
<a name="l00520"></a>00520                              received_node_bcs,
<a name="l00521"></a>00521                              nodebcstag);
<a name="l00522"></a>00522 
<a name="l00523"></a>00523         libmesh_assert (status.size() == recv_n_nodes_and_elem_per_proc[5*status.source()+3]);
<a name="l00524"></a>00524 
<a name="l00525"></a>00525         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffer_size = status.size();
<a name="l00526"></a>00526         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00527"></a>00527 
<a name="l00528"></a>00528         <span class="keywordflow">while</span> (cnt &lt; buffer_size)
<a name="l00529"></a>00529           {
<a name="l00530"></a>00530             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = received_node_bcs[cnt++];
<a name="l00531"></a>00531             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_bcs = received_node_bcs[cnt++];
<a name="l00532"></a>00532 
<a name="l00533"></a>00533             libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(node_id));
<a name="l00534"></a>00534             
<a name="l00535"></a>00535             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; num_bcs; bc_it++)
<a name="l00536"></a>00536               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_node (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(node_id), received_node_bcs[cnt++]);
<a name="l00537"></a>00537           }     
<a name="l00538"></a>00538       }
<a name="l00539"></a>00539   }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   
<a name="l00543"></a>00543   <span class="comment">// Receive elements.  Size this array for the largest message.</span>
<a name="l00544"></a>00544   {
<a name="l00545"></a>00545     std::vector&lt;int&gt; received_elements(max_conn_size_received);
<a name="l00546"></a>00546 
<a name="l00547"></a>00547     <span class="comment">// Similarly we know how many processors are sending us elements, </span>
<a name="l00548"></a>00548     <span class="comment">// but we don&#39;t really care in what order we receive them.</span>
<a name="l00549"></a>00549     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_comm_step=0; elem_comm_step&lt;n_recv_elem_pairs; elem_comm_step++)
<a name="l00550"></a>00550       {
<a name="l00551"></a>00551         Parallel::Status status =
<a name="l00552"></a>00552           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>,
<a name="l00553"></a>00553                              received_elements,
<a name="l00554"></a>00554                              elemstag);
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00557"></a>00557 <span class="preprocessor"></span>        <span class="comment">// Avoid declaring these variables unless asserts are enabled.</span>
<a name="l00558"></a>00558         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_pid = status.source();
<a name="l00559"></a>00559         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_received = 
<a name="l00560"></a>00560           recv_n_nodes_and_elem_per_proc[5*source_pid+1];
<a name="l00561"></a>00561 <span class="preprocessor">#endif</span>
<a name="l00562"></a>00562 <span class="preprocessor"></span>        libmesh_assert (recv_elem_pair[source_pid]);
<a name="l00563"></a>00563         libmesh_assert (recv_n_nodes_and_elem_per_proc[5*source_pid+2] 
<a name="l00564"></a>00564                 &lt;= received_elements.size());
<a name="l00565"></a>00565         libmesh_assert (recv_n_nodes_and_elem_per_proc[5*source_pid+2] 
<a name="l00566"></a>00566                 == status.size());
<a name="l00567"></a>00567 
<a name="l00568"></a>00568         <span class="comment">// iterate through the input buffer and add the elements</span>
<a name="l00569"></a>00569         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> xfer_buffer_size = status.size();
<a name="l00570"></a>00570         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00571"></a>00571         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_elem=0;
<a name="l00572"></a>00572         <span class="keywordflow">while</span> (cnt &lt; xfer_buffer_size)
<a name="l00573"></a>00573           {
<a name="l00574"></a>00574             <span class="comment">// Unpack the element </span>
<a name="l00575"></a>00575             Elem::PackedElem packed_elem (received_elements.begin()+cnt);
<a name="l00576"></a>00576             
<a name="l00577"></a>00577             <span class="comment">// The ParallelMesh::elem(i) member will return NULL if the element</span>
<a name="l00578"></a>00578             <span class="comment">// is not in the mesh.  We rely on that here, so it better not change!</span>
<a name="l00579"></a>00579             Elem *elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.id());
<a name="l00580"></a>00580             
<a name="l00581"></a>00581             <span class="comment">// if we already have this element, make sure its properties match</span>
<a name="l00582"></a>00582             <span class="comment">// but then go on</span>
<a name="l00583"></a>00583             <span class="keywordflow">if</span> (elem)
<a name="l00584"></a>00584               {
<a name="l00585"></a>00585                 libmesh_assert (elem-&gt;level()             == packed_elem.level());
<a name="l00586"></a>00586                 libmesh_assert (elem-&gt;id()                == packed_elem.id());
<a name="l00587"></a>00587                 libmesh_assert (elem-&gt;processor_id()      == packed_elem.processor_id());
<a name="l00588"></a>00588                 libmesh_assert (elem-&gt;subdomain_id()      == packed_elem.subdomain_id());
<a name="l00589"></a>00589                 libmesh_assert (elem-&gt;type()              == packed_elem.type());
<a name="l00590"></a>00590 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>                libmesh_assert (elem-&gt;p_level()           == packed_elem.p_level());
<a name="l00592"></a>00592                 libmesh_assert (elem-&gt;refinement_flag()   == packed_elem.refinement_flag());
<a name="l00593"></a>00593                 libmesh_assert (elem-&gt;p_refinement_flag() == packed_elem.p_refinement_flag());
<a name="l00594"></a>00594                 
<a name="l00595"></a>00595                 <span class="keywordflow">if</span> (elem-&gt;level() &gt; 0)
<a name="l00596"></a>00596                   {
<a name="l00597"></a>00597                     libmesh_assert (elem-&gt;parent()-&gt;id() == <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(packed_elem.parent_id()));
<a name="l00598"></a>00598                     libmesh_assert (elem-&gt;parent()-&gt;child(packed_elem.which_child_am_i()) == elem);
<a name="l00599"></a>00599                   }           
<a name="l00600"></a>00600 <span class="preprocessor">#endif</span>
<a name="l00601"></a>00601 <span class="preprocessor"></span>                libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l00602"></a>00602               }
<a name="l00603"></a>00603             <span class="keywordflow">else</span>
<a name="l00604"></a>00604               {
<a name="l00605"></a>00605                 <span class="comment">// We need to add the element.</span>
<a name="l00606"></a>00606 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00607"></a>00607 <span class="preprocessor"></span>                <span class="comment">// maybe find the parent</span>
<a name="l00608"></a>00608                 <span class="keywordflow">if</span> (packed_elem.level() &gt; 0)
<a name="l00609"></a>00609                   {
<a name="l00610"></a>00610                     Elem *parent = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.parent_id());
<a name="l00611"></a>00611                     
<a name="l00612"></a>00612                     <span class="comment">// Note that we were very careful to construct the send connectivity</span>
<a name="l00613"></a>00613                     <span class="comment">// so that parents are encountered before children.  So if we get here</span>
<a name="l00614"></a>00614                     <span class="comment">// and can&#39;t find the parent that is a fatal error.</span>
<a name="l00615"></a>00615                     <span class="keywordflow">if</span> (parent == NULL)
<a name="l00616"></a>00616                       {
<a name="l00617"></a>00617                         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l00618"></a>00618                                       &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l00619"></a>00619                         libmesh_error();
<a name="l00620"></a>00620                       }
<a name="l00621"></a>00621                     
<a name="l00622"></a>00622                     elem = packed_elem.unpack (mesh, parent);
<a name="l00623"></a>00623                   }
<a name="l00624"></a>00624                 <span class="keywordflow">else</span>
<a name="l00625"></a>00625                   {
<a name="l00626"></a>00626                     libmesh_assert (packed_elem.parent_id() == -1);
<a name="l00627"></a>00627 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00628"></a>00628 <span class="preprocessor"></span>                    elem = packed_elem.unpack (mesh);
<a name="l00629"></a>00629 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00630"></a>00630 <span class="preprocessor"></span>                  }
<a name="l00631"></a>00631 <span class="preprocessor">#endif          </span>
<a name="l00632"></a>00632 <span class="preprocessor"></span>                <span class="comment">// Good to go.  Add to the mesh.</span>
<a name="l00633"></a>00633                 libmesh_assert (elem);
<a name="l00634"></a>00634                 libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l00635"></a>00635                 mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">insert_elem</a>(elem);
<a name="l00636"></a>00636               }
<a name="l00637"></a>00637             
<a name="l00638"></a>00638             <span class="comment">// properly position cnt for the next element </span>
<a name="l00639"></a>00639             cnt += <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + packed_elem.n_nodes();
<a name="l00640"></a>00640             current_elem++;
<a name="l00641"></a>00641           }
<a name="l00642"></a>00642         libmesh_assert (current_elem == n_elem_received);
<a name="l00643"></a>00643       }
<a name="l00644"></a>00644   }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="comment">// Receive boundary conditions for those elements</span>
<a name="l00647"></a>00647   {
<a name="l00648"></a>00648     std::vector&lt;int&gt; received_element_bcs(max_elem_bcs_received);
<a name="l00649"></a>00649     
<a name="l00650"></a>00650     <span class="comment">// again, receive all the messages in whatever order they come.</span>
<a name="l00651"></a>00651     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_comm_step=0; elem_comm_step&lt;n_recv_elem_bc_pairs; elem_comm_step++)
<a name="l00652"></a>00652       {
<a name="l00653"></a>00653         Parallel::Status status =
<a name="l00654"></a>00654           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>,
<a name="l00655"></a>00655                              received_element_bcs,
<a name="l00656"></a>00656                              elembcstag);
<a name="l00657"></a>00657 
<a name="l00658"></a>00658         libmesh_assert (status.size() == recv_n_nodes_and_elem_per_proc[5*status.source()+4]);
<a name="l00659"></a>00659 
<a name="l00660"></a>00660         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffer_size = status.size();
<a name="l00661"></a>00661         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00662"></a>00662 
<a name="l00663"></a>00663         <span class="keywordflow">while</span> (cnt &lt; buffer_size)
<a name="l00664"></a>00664           {
<a name="l00665"></a>00665             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = received_element_bcs[cnt++];
<a name="l00666"></a>00666             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>    = received_element_bcs[cnt++];
<a name="l00667"></a>00667             <span class="keyword">const</span> <span class="keywordtype">int</span> bc_id            = received_element_bcs[cnt++];
<a name="l00668"></a>00668 
<a name="l00669"></a>00669             libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(elem_id));
<a name="l00670"></a>00670             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(elem_id), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>, <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>);
<a name="l00671"></a>00671           }
<a name="l00672"></a>00672       }    
<a name="l00673"></a>00673   }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675   <span class="comment">// Wait for all sends to complete</span>
<a name="l00676"></a>00676   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (node_send_requests);
<a name="l00677"></a>00677   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (node_bc_requests);
<a name="l00678"></a>00678   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (element_send_requests);
<a name="l00679"></a>00679   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (element_bc_requests);
<a name="l00680"></a>00680   
<a name="l00681"></a>00681   <span class="comment">// unregister MPI datatypes</span>
<a name="l00682"></a>00682   packed_node_datatype.<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a946f066948fc0ca306e7fc4025cef311">free</a>();
<a name="l00683"></a>00683   
<a name="l00684"></a>00684   STOP_LOG(<span class="stringliteral">&quot;redistribute()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);  
<a name="l00685"></a>00685 }
<a name="l00686"></a>00686 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l00687"></a>00687 <span class="preprocessor"></span>
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI // avoid spurious gcc warnings</span>
<a name="l00691"></a>00691 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00692"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a1b5bcfce3b9a9daccb4abb795a0638e0">00692</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a1b5bcfce3b9a9daccb4abb795a0638e0">MeshCommunication::gather_neighboring_elements</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;)<span class="keyword"> const</span>
<a name="l00693"></a>00693 <span class="keyword"></span>{
<a name="l00694"></a>00694   <span class="comment">// no MPI == one processor, no need for this method...</span>
<a name="l00695"></a>00695   <span class="keywordflow">return</span>;
<a name="l00696"></a>00696 }
<a name="l00697"></a>00697 <span class="preprocessor">#else</span>
<a name="l00698"></a>00698 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00699"></a>00699 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a1b5bcfce3b9a9daccb4abb795a0638e0">MeshCommunication::gather_neighboring_elements</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;mesh)<span class="keyword"> const</span>
<a name="l00700"></a>00700 <span class="keyword"></span>{
<a name="l00701"></a>00701   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l00702"></a>00702   <span class="comment">// only one processor.</span>
<a name="l00703"></a>00703   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00704"></a>00704     <span class="keywordflow">return</span>;  
<a name="l00705"></a>00705 
<a name="l00706"></a>00706   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00707"></a>00707   parallel_only();
<a name="l00708"></a>00708   
<a name="l00709"></a>00709   START_LOG(<span class="stringliteral">&quot;gather_neighboring_elements()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   <span class="comment">//------------------------------------------------------------------</span>
<a name="l00712"></a>00712   <span class="comment">// The purpose of this function is to provide neighbor data structure</span>
<a name="l00713"></a>00713   <span class="comment">// consistency for a parallel, distributed mesh.  In libMesh we require</span>
<a name="l00714"></a>00714   <span class="comment">// that each local element have access to a full set of valid face</span>
<a name="l00715"></a>00715   <span class="comment">// neighbors.  In some cases this requires us to store &quot;ghost elements&quot; -</span>
<a name="l00716"></a>00716   <span class="comment">// elements that belong to other processors but we store to provide</span>
<a name="l00717"></a>00717   <span class="comment">// data structure consistency.  Also, it is assumed that any element</span>
<a name="l00718"></a>00718   <span class="comment">// with a NULL neighbor resides on a physical domain boundary.  So,</span>
<a name="l00719"></a>00719   <span class="comment">// even our &quot;ghost elements&quot; must have non-NULL neighbors.  To handle</span>
<a name="l00720"></a>00720   <span class="comment">// this the concept of &quot;RemoteElem&quot; is used - a special construct which</span>
<a name="l00721"></a>00721   <span class="comment">// is used to denote that an element has a face neighbor, but we do</span>
<a name="l00722"></a>00722   <span class="comment">// not actually store detailed information about that neighbor.  This</span>
<a name="l00723"></a>00723   <span class="comment">// is required to prevent data structure explosion.</span>
<a name="l00724"></a>00724   <span class="comment">//</span>
<a name="l00725"></a>00725   <span class="comment">// So when this method is called we should have only local elements.</span>
<a name="l00726"></a>00726   <span class="comment">// These local elements will then find neighbors among the local</span>
<a name="l00727"></a>00727   <span class="comment">// element set.  After this is completed, any element with a NULL</span>
<a name="l00728"></a>00728   <span class="comment">// neighbor has either (i) a face on the physical boundary of the mesh,</span>
<a name="l00729"></a>00729   <span class="comment">// or (ii) a neighboring element which lives on a remote processor.</span>
<a name="l00730"></a>00730   <span class="comment">// To handle case (ii), we communicate the global node indices connected</span>
<a name="l00731"></a>00731   <span class="comment">// to all such faces to our neighboring processors.  They then send us</span>
<a name="l00732"></a>00732   <span class="comment">// all their elements with a NULL neighbor that are connected to any</span>
<a name="l00733"></a>00733   <span class="comment">// of the nodes in our list.</span>
<a name="l00734"></a>00734   <span class="comment">//------------------------------------------------------------------</span>
<a name="l00735"></a>00735 
<a name="l00736"></a>00736   <span class="comment">// Let&#39;s begin with finding consistent neighbor data information</span>
<a name="l00737"></a>00737   <span class="comment">// for all the elements we currently have.  We&#39;ll use a clean</span>
<a name="l00738"></a>00738   <span class="comment">// slate here - clear any existing information, including RemoteElem&#39;s.</span>
<a name="l00739"></a>00739   mesh.<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a341e57f0c00d50bf885a10fbd6bcb903">find_neighbors</a> (<span class="comment">/* reset_remote_elements = */</span> <span class="keyword">true</span>,
<a name="l00740"></a>00740                        <span class="comment">/* reset_current_list    = */</span> <span class="keyword">true</span>);    
<a name="l00741"></a>00741   
<a name="l00742"></a>00742   <span class="comment">// register a derived datatype to use in shipping nodes  </span>
<a name="l00743"></a>00743   <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">Parallel::DataType</a> packed_node_datatype = <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a55550d69ace1f2e06fa03a9f21d850c0">Node::PackedNode::create_mpi_datatype</a>();
<a name="l00744"></a>00744   packed_node_datatype.<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#ad851f9206f34f41a4b71426a3b642928">commit</a>();
<a name="l00745"></a>00745 
<a name="l00746"></a>00746   <span class="comment">// Get a few unique message tags to use in communications; we&#39;ll</span>
<a name="l00747"></a>00747   <span class="comment">// default to some numbers around pi*10000</span>
<a name="l00748"></a>00748   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a>
<a name="l00749"></a>00749     node_list_tag         = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(31415),
<a name="l00750"></a>00750     element_neighbors_tag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(31416);
<a name="l00751"></a>00751 
<a name="l00752"></a>00752   <span class="comment">// Now any element with a NULL neighbor either</span>
<a name="l00753"></a>00753   <span class="comment">// (i) lives on the physical domain boundary, or</span>
<a name="l00754"></a>00754   <span class="comment">// (ii) lives on an inter-processor boundary.</span>
<a name="l00755"></a>00755   <span class="comment">// We will now gather all the elements from adjacent processors</span>
<a name="l00756"></a>00756   <span class="comment">// which are of the same state, which should address all the type (ii)</span>
<a name="l00757"></a>00757   <span class="comment">// elements.</span>
<a name="l00758"></a>00758   
<a name="l00759"></a>00759   <span class="comment">// A list of all the processors which *may* contain neighboring elements.</span>
<a name="l00760"></a>00760   <span class="comment">// (for development simplicity, just make this the identity map)</span>
<a name="l00761"></a>00761   std::vector&lt;unsigned int&gt; adjacent_processors;
<a name="l00762"></a>00762   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00763"></a>00763     <span class="keywordflow">if</span> (pid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00764"></a>00764       adjacent_processors.push_back (pid);
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_processors = adjacent_processors.size();
<a name="l00768"></a>00768 
<a name="l00769"></a>00769   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00770"></a>00770   <span class="comment">// Let&#39;s build a list of all nodes which live on NULL-neighbor sides.</span>
<a name="l00771"></a>00771   <span class="comment">// For simplicity, we will use a set to build the list, then transfer</span>
<a name="l00772"></a>00772   <span class="comment">// it to a vector for communication.</span>
<a name="l00773"></a>00773   std::vector&lt;unsigned int&gt; my_interface_node_list;
<a name="l00774"></a>00774   std::vector&lt;const Elem*&gt;  my_interface_elements;
<a name="l00775"></a>00775   {
<a name="l00776"></a>00776     std::set&lt;unsigned int&gt; my_interface_node_set;
<a name="l00777"></a>00777 
<a name="l00778"></a>00778     <span class="comment">// since parent nodes are a subset of children nodes, this should be sufficient</span>
<a name="l00779"></a>00779     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it     = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a8523aa7490f182df9ed52422b62ce1b8">active_local_elements_begin</a>();
<a name="l00780"></a>00780     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it_end = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad64cb66d3478d53dff68cb1801e7f675">active_local_elements_end</a>();
<a name="l00781"></a>00781 
<a name="l00782"></a>00782     <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l00783"></a>00783       {
<a name="l00784"></a>00784         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * <span class="keyword">const</span> elem = *it;
<a name="l00785"></a>00785         libmesh_assert (elem != NULL);
<a name="l00786"></a>00786 
<a name="l00787"></a>00787         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a99b37a22b9bed12e5195243183cd9b8f">on_boundary</a>()) <span class="comment">// denotes *any* side has a NULL neighbor</span>
<a name="l00788"></a>00788           {
<a name="l00789"></a>00789             my_interface_elements.push_back(elem); <span class="comment">// add the element, but only once, even</span>
<a name="l00790"></a>00790                                                    <span class="comment">// if there are multiple NULL neighbors</span>
<a name="l00791"></a>00791             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00792"></a>00792               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00793"></a>00793                 {
<a name="l00794"></a>00794                   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00795"></a>00795                   
<a name="l00796"></a>00796                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_vertices(); n++)
<a name="l00797"></a>00797                     my_interface_node_set.insert (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(n));   
<a name="l00798"></a>00798                 }
<a name="l00799"></a>00799           }
<a name="l00800"></a>00800       }
<a name="l00801"></a>00801 
<a name="l00802"></a>00802     my_interface_node_list.reserve (my_interface_node_set.size());
<a name="l00803"></a>00803     my_interface_node_list.insert  (my_interface_node_list.end(),
<a name="l00804"></a>00804                                     my_interface_node_set.begin(),
<a name="l00805"></a>00805                                     my_interface_node_set.end());
<a name="l00806"></a>00806   }
<a name="l00807"></a>00807   
<a name="l00808"></a>00808   <span class="keywordflow">if</span> (<span class="keyword">false</span>)
<a name="l00809"></a>00809     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00810"></a>00810                   &lt;&lt; <span class="stringliteral">&quot;mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>
<a name="l00811"></a>00811                   &lt;&lt; <span class="stringliteral">&quot;my_interface_node_list.size()=&quot;</span> &lt;&lt; my_interface_node_list.size()
<a name="l00812"></a>00812                   &lt;&lt; std::endl;
<a name="l00813"></a>00813   
<a name="l00814"></a>00814   <span class="comment">// we will now send my_interface_node_list to all of the adjacent processors.</span>
<a name="l00815"></a>00815   <span class="comment">// note that for the time being we will copy the list to a unique buffer for </span>
<a name="l00816"></a>00816   <span class="comment">// each processor so that we can use a nonblocking send and not access the</span>
<a name="l00817"></a>00817   <span class="comment">// buffer again until the send completes.  it is my understanding that the</span>
<a name="l00818"></a>00818   <span class="comment">// MPI 2.1 standard seeks to remove this restriction as unnecessary, so in</span>
<a name="l00819"></a>00819   <span class="comment">// the future we should change this to send the same buffer to each of the</span>
<a name="l00820"></a>00820   <span class="comment">// adjacent processors. - BSK 11/17/2008</span>
<a name="l00821"></a>00821   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; 
<a name="l00822"></a>00822     my_interface_node_xfer_buffers (n_adjacent_processors, my_interface_node_list);
<a name="l00823"></a>00823   std::vector&lt;Parallel::Request&gt; my_interface_node_list_requests (n_adjacent_processors);
<a name="l00824"></a>00824   std::map&lt;unsigned int, unsigned int&gt; n_comm_steps;
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;n_adjacent_processors; comm_step++)
<a name="l00827"></a>00827     {
<a name="l00828"></a>00828       n_comm_steps[adjacent_processors[comm_step]]=1;
<a name="l00829"></a>00829       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (adjacent_processors[comm_step],
<a name="l00830"></a>00830                       my_interface_node_xfer_buffers[comm_step],
<a name="l00831"></a>00831                       my_interface_node_list_requests[comm_step],
<a name="l00832"></a>00832                       node_list_tag);
<a name="l00833"></a>00833     }
<a name="l00834"></a>00834 
<a name="l00835"></a>00835   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00836"></a>00836   <span class="comment">// processor pairings are symmetric - I expect to receive an interface node</span>
<a name="l00837"></a>00837   <span class="comment">// list from each processor in adjacent_processors as well!</span>
<a name="l00838"></a>00838   <span class="comment">// now we will catch an incoming node list for each of our adjacent processors.</span>
<a name="l00839"></a>00839   <span class="comment">//</span>
<a name="l00840"></a>00840   <span class="comment">// we are done with the adjacent_processors list - note that it is in general</span>
<a name="l00841"></a>00841   <span class="comment">// a superset of the processors we truly share elements with.  so let&#39;s</span>
<a name="l00842"></a>00842   <span class="comment">// clear the superset list, and we will fill it with the true list.</span>
<a name="l00843"></a>00843   adjacent_processors.clear();
<a name="l00844"></a>00844   
<a name="l00845"></a>00845   std::vector&lt;unsigned int&gt; common_interface_node_list;
<a name="l00846"></a>00846 
<a name="l00847"></a>00847   <span class="comment">// send buffers.  we will fill these with data from the elements we own </span>
<a name="l00848"></a>00848   <span class="comment">// which share nodes with an adjacent processor.  we will slightly abuse </span>
<a name="l00849"></a>00849   <span class="comment">// the node_bcs_sent and element_bcs_sent buffers - we&#39;ll fill them and then tack</span>
<a name="l00850"></a>00850   <span class="comment">// them on to the end of the elements_sent buffer to reduce the message count.</span>
<a name="l00851"></a>00851   std::vector&lt;std::vector&lt;Node::PackedNode&gt; &gt; nodes_sent(n_adjacent_processors);
<a name="l00852"></a>00852   std::vector&lt;std::vector&lt;int&gt; &gt; elements_sent(n_adjacent_processors);
<a name="l00853"></a>00853   std::vector&lt;int&gt; node_bcs_sent, &amp;element_bcs_sent(node_bcs_sent);
<a name="l00854"></a>00854   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; element_neighbors_sent(n_adjacent_processors);
<a name="l00855"></a>00855     
<a name="l00856"></a>00856   std::vector&lt;Parallel::Request&gt; 
<a name="l00857"></a>00857     node_send_requests(n_adjacent_processors), 
<a name="l00858"></a>00858     element_send_requests(n_adjacent_processors),
<a name="l00859"></a>00859     element_neighbor_send_requests(n_adjacent_processors);
<a name="l00860"></a>00860 
<a name="l00861"></a>00861   <span class="comment">// receive buffers</span>
<a name="l00862"></a>00862   std::vector&lt;Node::PackedNode&gt; nodes_received;
<a name="l00863"></a>00863   std::vector&lt;int&gt; elements_received;
<a name="l00864"></a>00864   std::vector&lt;unsigned int&gt; element_neighbors_received;
<a name="l00865"></a>00865 
<a name="l00866"></a>00866   <span class="comment">// we expect two classess of messages - </span>
<a name="l00867"></a>00867   <span class="comment">// (1) incoming interface node lists, to which we will reply with our elements </span>
<a name="l00868"></a>00868   <span class="comment">//     touching nodes in the list, and</span>
<a name="l00869"></a>00869   <span class="comment">// (2) replies from the requests we sent off previously.  </span>
<a name="l00870"></a>00870   <span class="comment">//  (2.a) - nodes</span>
<a name="l00871"></a>00871   <span class="comment">//  (2.b) - element connectivity &amp; bc info</span>
<a name="l00872"></a>00872   <span class="comment">// so we expect 3 communications from each adjacent processor.</span>
<a name="l00873"></a>00873   <span class="comment">// by structuring the communication in this way we hopefully impose no </span>
<a name="l00874"></a>00874   <span class="comment">// order on the handling of the arriving messages.  in particular, we</span>
<a name="l00875"></a>00875   <span class="comment">// should be able to handle the case where we receive a request and</span>
<a name="l00876"></a>00876   <span class="comment">// all replies from processor A before even receiving a request from</span>
<a name="l00877"></a>00877   <span class="comment">// processor B.</span>
<a name="l00878"></a>00878   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00879"></a>00879     n_node_replies_sent=0, n_node_replies_received=0, 
<a name="l00880"></a>00880     n_elem_replies_sent=0, n_elem_replies_received=0;
<a name="l00881"></a>00881 
<a name="l00882"></a>00882   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;3*n_adjacent_processors; comm_step++)
<a name="l00883"></a>00883     {
<a name="l00884"></a>00884       <span class="comment">//------------------------------------------------------------------</span>
<a name="l00885"></a>00885       <span class="comment">// catch incoming node list</span>
<a name="l00886"></a>00886       Parallel::Status
<a name="l00887"></a>00887         <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>(<a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">Parallel::probe</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>,
<a name="l00888"></a>00888                                 node_list_tag));      
<a name="l00889"></a>00889       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00890"></a>00890         source_pid_idx = status.source(),
<a name="l00891"></a>00891         dest_pid_idx   = source_pid_idx;
<a name="l00892"></a>00892 
<a name="l00893"></a>00893       <span class="comment">//------------------------------------------------------------------</span>
<a name="l00894"></a>00894       <span class="comment">// first time - incoming request</span>
<a name="l00895"></a>00895       <span class="keywordflow">if</span> (n_comm_steps[source_pid_idx] == 1)
<a name="l00896"></a>00896         {
<a name="l00897"></a>00897           n_comm_steps[source_pid_idx]++;
<a name="l00898"></a>00898           
<a name="l00899"></a>00899           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_pid_idx,
<a name="l00900"></a>00900                              common_interface_node_list,
<a name="l00901"></a>00901                              node_list_tag);
<a name="l00902"></a>00902           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>    
<a name="l00903"></a>00903             their_interface_node_list_size = common_interface_node_list.size();
<a name="l00904"></a>00904           
<a name="l00905"></a>00905           <span class="comment">// we now have the interface node list from processor source_pid_idx.</span>
<a name="l00906"></a>00906           <span class="comment">// now we can find all of our elements which touch any of these nodes</span>
<a name="l00907"></a>00907           <span class="comment">// and send copies back to this processor.  however, we can make our</span>
<a name="l00908"></a>00908           <span class="comment">// search more efficient by first excluding all the nodes in</span>
<a name="l00909"></a>00909           <span class="comment">// their list which are not also contained in</span>
<a name="l00910"></a>00910           <span class="comment">// my_interface_node_list.  we can do this in place as a set</span>
<a name="l00911"></a>00911           <span class="comment">// intersection.</span>
<a name="l00912"></a>00912           common_interface_node_list.erase
<a name="l00913"></a>00913             (std::set_intersection (my_interface_node_list.begin(),
<a name="l00914"></a>00914                                     my_interface_node_list.end(),
<a name="l00915"></a>00915                                     common_interface_node_list.begin(),
<a name="l00916"></a>00916                                     common_interface_node_list.end(),
<a name="l00917"></a>00917                                     common_interface_node_list.begin()),
<a name="l00918"></a>00918              common_interface_node_list.end());
<a name="l00919"></a>00919           
<a name="l00920"></a>00920           <span class="keywordflow">if</span> (<span class="keyword">false</span>)
<a name="l00921"></a>00921             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00922"></a>00922                           &lt;&lt; <span class="stringliteral">&quot;my_interface_node_list.size()=&quot;</span>       &lt;&lt; my_interface_node_list.size()
<a name="l00923"></a>00923                           &lt;&lt; <span class="stringliteral">&quot;, [&quot;</span> &lt;&lt; source_pid_idx &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00924"></a>00924                           &lt;&lt; <span class="stringliteral">&quot;their_interface_node_list.size()=&quot;</span>    &lt;&lt; their_interface_node_list_size
<a name="l00925"></a>00925                           &lt;&lt; <span class="stringliteral">&quot;, common_interface_node_list.size()=&quot;</span> &lt;&lt; common_interface_node_list.size()
<a name="l00926"></a>00926                           &lt;&lt; std::endl;
<a name="l00927"></a>00927           
<a name="l00928"></a>00928           <span class="comment">// Check for quick return?</span>
<a name="l00929"></a>00929           <span class="keywordflow">if</span> (common_interface_node_list.empty())
<a name="l00930"></a>00930             {
<a name="l00931"></a>00931               <span class="comment">// let&#39;s try to be smart here - if we have no nodes in common,</span>
<a name="l00932"></a>00932               <span class="comment">// we cannot share elements.  so post the messages expected</span>
<a name="l00933"></a>00933               <span class="comment">// from us here and go on about our business.  </span>
<a name="l00934"></a>00934               <span class="comment">// note that even though these are nonblocking sends</span>
<a name="l00935"></a>00935               <span class="comment">// they should complete essentially instantly, because</span>
<a name="l00936"></a>00936               <span class="comment">// in all cases the send buffers are empty</span>
<a name="l00937"></a>00937               <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (dest_pid_idx,
<a name="l00938"></a>00938                               nodes_sent[n_node_replies_sent],
<a name="l00939"></a>00939                               packed_node_datatype,
<a name="l00940"></a>00940                               node_send_requests[n_node_replies_sent],
<a name="l00941"></a>00941                               node_list_tag);
<a name="l00942"></a>00942               n_node_replies_sent++;
<a name="l00943"></a>00943 
<a name="l00944"></a>00944               <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (dest_pid_idx,
<a name="l00945"></a>00945                               elements_sent[n_elem_replies_sent],
<a name="l00946"></a>00946                               element_send_requests[n_elem_replies_sent],
<a name="l00947"></a>00947                               node_list_tag);
<a name="l00948"></a>00948 
<a name="l00949"></a>00949               <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (dest_pid_idx,
<a name="l00950"></a>00950                               element_neighbors_sent[n_elem_replies_sent],
<a name="l00951"></a>00951                               element_neighbor_send_requests[n_elem_replies_sent],
<a name="l00952"></a>00952                               element_neighbors_tag);
<a name="l00953"></a>00953               n_elem_replies_sent++;
<a name="l00954"></a>00954 
<a name="l00955"></a>00955               <span class="keywordflow">continue</span>;
<a name="l00956"></a>00956             }
<a name="l00957"></a>00957           <span class="comment">// otherwise, this really *is* an adjacent processor.</span>
<a name="l00958"></a>00958           adjacent_processors.push_back(source_pid_idx);
<a name="l00959"></a>00959 
<a name="l00960"></a>00960           <span class="comment">// Now we need to see which of our elements touch the nodes in the list.</span>
<a name="l00961"></a>00961           <span class="comment">// We built a reduced element list above, and we know the pointers are</span>
<a name="l00962"></a>00962           <span class="comment">// not NULL.</span>
<a name="l00963"></a>00963           <span class="comment">// We will certainly send all the active elements which intersect source_pid_idx,</span>
<a name="l00964"></a>00964           <span class="comment">// but we will also ship off the other elements in the same family tree</span>
<a name="l00965"></a>00965           <span class="comment">// as the active ones for data structure consistency.  We also</span>
<a name="l00966"></a>00966           <span class="comment">// ship any nodes connected to these elements.  Note some of these nodes</span>
<a name="l00967"></a>00967           <span class="comment">// and elements may be replicated from other processors, but that is OK.</span>
<a name="l00968"></a>00968           std::set&lt;const Elem*, CompareElemIdsByLevel&gt; elements_to_send;
<a name="l00969"></a>00969           std::set&lt;const Node*&gt; connected_nodes;
<a name="l00970"></a>00970           std::vector&lt;const Elem*&gt; family_tree;
<a name="l00971"></a>00971           
<a name="l00972"></a>00972           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0, n_shared_nodes=0; e&lt;my_interface_elements.size(); e++, n_shared_nodes=0)
<a name="l00973"></a>00973             {
<a name="l00974"></a>00974               <span class="keyword">const</span> Elem * elem = my_interface_elements[e];
<a name="l00975"></a>00975               
<a name="l00976"></a>00976               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;n_vertices(); n++)
<a name="l00977"></a>00977                 <span class="keywordflow">if</span> (std::binary_search (common_interface_node_list.begin(),
<a name="l00978"></a>00978                                         common_interface_node_list.end(),
<a name="l00979"></a>00979                                         elem-&gt;node(n)))
<a name="l00980"></a>00980                   { 
<a name="l00981"></a>00981                     n_shared_nodes++;
<a name="l00982"></a>00982                     
<a name="l00983"></a>00983                     <span class="comment">// TBD - how many nodes do we need to share </span>
<a name="l00984"></a>00984                     <span class="comment">// before we care?  certainly 2, but 1?  not </span>
<a name="l00985"></a>00985                     <span class="comment">// sure, so let&#39;s play it safe...</span>
<a name="l00986"></a>00986                     <span class="keywordflow">if</span> (n_shared_nodes &gt; 0) <span class="keywordflow">break</span>;
<a name="l00987"></a>00987                   }
<a name="l00988"></a>00988               
<a name="l00989"></a>00989               <span class="keywordflow">if</span> (n_shared_nodes) <span class="comment">// share at least one node?</span>
<a name="l00990"></a>00990                 {
<a name="l00991"></a>00991                   elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a>();
<a name="l00992"></a>00992                   
<a name="l00993"></a>00993                   <span class="comment">// avoid a lot of duplicated effort -- if we already have elem</span>
<a name="l00994"></a>00994                   <span class="comment">// in the set its entire family tree is already in the set.</span>
<a name="l00995"></a>00995                   <span class="keywordflow">if</span> (!elements_to_send.count(elem))
<a name="l00996"></a>00996                     {
<a name="l00997"></a>00997 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00998"></a>00998 <span class="preprocessor"></span>                      elem-&gt;family_tree(family_tree);
<a name="l00999"></a>00999 <span class="preprocessor">#else</span>
<a name="l01000"></a>01000 <span class="preprocessor"></span>                      family_tree.clear();
<a name="l01001"></a>01001                       family_tree.push_back(elem);
<a name="l01002"></a>01002 <span class="preprocessor">#endif</span>
<a name="l01003"></a>01003 <span class="preprocessor"></span>                      <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> leaf=0; leaf&lt;family_tree.size(); leaf++)
<a name="l01004"></a>01004                         {
<a name="l01005"></a>01005                           elem = family_tree[leaf];
<a name="l01006"></a>01006                           elements_to_send.insert (elem);
<a name="l01007"></a>01007                           
<a name="l01008"></a>01008                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;n_nodes(); n++)
<a name="l01009"></a>01009                             connected_nodes.insert (elem-&gt;get_node(n));           
<a name="l01010"></a>01010                         }                   
<a name="l01011"></a>01011                     }
<a name="l01012"></a>01012                 }
<a name="l01013"></a>01013             }
<a name="l01014"></a>01014           
<a name="l01015"></a>01015           <span class="comment">// The elements_to_send and connected_nodes sets now contain all</span>
<a name="l01016"></a>01016           <span class="comment">// the elements and nodes we need to send to this processor.</span>
<a name="l01017"></a>01017           <span class="comment">// All that remains is to pack up the objects (along with</span>
<a name="l01018"></a>01018           <span class="comment">// any boundary conditions) and send the messages off.</span>
<a name="l01019"></a>01019           {
<a name="l01020"></a>01020             <span class="keywordflow">if</span> (elements_to_send.empty()) libmesh_assert (connected_nodes.empty());
<a name="l01021"></a>01021             <span class="keywordflow">if</span> (connected_nodes.empty())  libmesh_assert (elements_to_send.empty());
<a name="l01022"></a>01022             
<a name="l01023"></a>01023             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_nodes_sent = connected_nodes.size();
<a name="l01024"></a>01024             nodes_sent[n_node_replies_sent].reserve (n_nodes_sent);
<a name="l01025"></a>01025             node_bcs_sent.clear();
<a name="l01026"></a>01026         
<a name="l01027"></a>01027             <span class="keywordflow">for</span> (std::set&lt;const Node*&gt;::const_iterator node_it = connected_nodes.begin();
<a name="l01028"></a>01028                  node_it != connected_nodes.end(); ++node_it)
<a name="l01029"></a>01029               {
<a name="l01030"></a>01030                 nodes_sent[n_node_replies_sent].push_back (Node::PackedNode(**node_it));
<a name="l01031"></a>01031                 
<a name="l01032"></a>01032                 <span class="comment">// add the node if it has BCs</span>
<a name="l01033"></a>01033                 std::vector&lt;short int&gt; bcs = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(*node_it);
<a name="l01034"></a>01034                 
<a name="l01035"></a>01035                 <span class="keywordflow">if</span> (!bcs.empty())
<a name="l01036"></a>01036                   {
<a name="l01037"></a>01037                     node_bcs_sent.push_back((*node_it)-&gt;id());
<a name="l01038"></a>01038                     node_bcs_sent.push_back(bcs.size());
<a name="l01039"></a>01039                     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; bcs.size(); bc_it++)
<a name="l01040"></a>01040                       node_bcs_sent.push_back(bcs[bc_it]);
<a name="l01041"></a>01041                   }
<a name="l01042"></a>01042               }
<a name="l01043"></a>01043             connected_nodes.clear();
<a name="l01044"></a>01044         
<a name="l01045"></a>01045             <span class="comment">// send the nodes off to the destination processor</span>
<a name="l01046"></a>01046             <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (dest_pid_idx,
<a name="l01047"></a>01047                             nodes_sent[n_node_replies_sent],
<a name="l01048"></a>01048                             packed_node_datatype,
<a name="l01049"></a>01049                             node_send_requests[n_node_replies_sent],
<a name="l01050"></a>01050                             node_list_tag);
<a name="l01051"></a>01051             n_node_replies_sent++;
<a name="l01052"></a>01052         
<a name="l01053"></a>01053             <span class="comment">// let&#39;s pack the node bc data in the front of the element</span>
<a name="l01054"></a>01054             <span class="comment">// connectivity buffer</span>
<a name="l01055"></a>01055             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01056"></a>01056               n_node_bcs_sent = node_bcs_sent.size();
<a name="l01057"></a>01057             
<a name="l01058"></a>01058             elements_sent[n_elem_replies_sent].clear();
<a name="l01059"></a>01059             elements_sent[n_elem_replies_sent].insert (elements_sent[n_elem_replies_sent].end(),
<a name="l01060"></a>01060                                                        node_bcs_sent.begin(),
<a name="l01061"></a>01061                                                        node_bcs_sent.end());
<a name="l01062"></a>01062         
<a name="l01063"></a>01063             <span class="comment">// this is really just a reference to node_bcs_sent,</span>
<a name="l01064"></a>01064             <span class="comment">// so be careful not to clear it before packing the</span>
<a name="l01065"></a>01065             <span class="comment">// node_bcs_sent into the elements_sent buffer!!</span>
<a name="l01066"></a>01066             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elements_sent = elements_to_send.size();
<a name="l01067"></a>01067             element_neighbors_sent[n_elem_replies_sent].reserve(2*n_elements_sent+1);
<a name="l01068"></a>01068             element_bcs_sent.clear(); 
<a name="l01069"></a>01069             
<a name="l01070"></a>01070             <span class="keywordflow">for</span> (std::set&lt;const Elem*, CompareElemIdsByLevel&gt;::const_iterator 
<a name="l01071"></a>01071                    elem_it = elements_to_send.begin(); elem_it != elements_to_send.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>(); ++elem_it)
<a name="l01072"></a>01072               {
<a name="l01073"></a>01073                 <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">Elem::PackedElem::pack</a> (elements_sent[n_elem_replies_sent], *elem_it);
<a name="l01074"></a>01074                 
<a name="l01075"></a>01075                 <span class="comment">// let&#39;s put the element index in the element_neighbors_sent</span>
<a name="l01076"></a>01076                 <span class="comment">// buffer - we will later overwrite it with a bitmask of the</span>
<a name="l01077"></a>01077                 <span class="comment">// element neighbor information to send out.  this will be used </span>
<a name="l01078"></a>01078                 <span class="comment">// to create RemoteElems where appropriate.</span>
<a name="l01079"></a>01079                 element_neighbors_sent[n_elem_replies_sent].push_back((*elem_it)-&gt;id());
<a name="l01080"></a>01080                 element_neighbors_sent[n_elem_replies_sent].push_back(0);
<a name="l01081"></a>01081                 
<a name="l01082"></a>01082                 <span class="comment">// if this is a level-0 element look for boundary conditions</span>
<a name="l01083"></a>01083                 <span class="keywordflow">if</span> ((*elem_it)-&gt;level() == 0)
<a name="l01084"></a>01084                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*elem_it)-&gt;n_sides(); s++)
<a name="l01085"></a>01085                     <span class="keywordflow">if</span> ((*elem_it)-&gt;neighbor(s) == NULL)
<a name="l01086"></a>01086                       {
<a name="l01087"></a>01087                         <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; bc_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(*elem_it, s);
<a name="l01088"></a>01088                         <span class="keywordflow">for</span> (std::vector&lt;short int&gt;::const_iterator id_it=bc_ids.begin(); id_it!=bc_ids.end(); ++id_it)
<a name="l01089"></a>01089                           {
<a name="l01090"></a>01090                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id = *id_it;
<a name="l01091"></a>01091                             <span class="keywordflow">if</span> (bc_id != mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;invalid_id)
<a name="l01092"></a>01092                               {
<a name="l01093"></a>01093                                 element_bcs_sent.push_back ((*elem_it)-&gt;id());
<a name="l01094"></a>01094                                 element_bcs_sent.push_back (s);
<a name="l01095"></a>01095                                 element_bcs_sent.push_back (bc_id);
<a name="l01096"></a>01096                               }
<a name="l01097"></a>01097                           }
<a name="l01098"></a>01098                       }
<a name="l01099"></a>01099               }
<a name="l01100"></a>01100             element_neighbors_sent[n_elem_replies_sent].push_back (dest_pid_idx);
<a name="l01101"></a>01101             elements_to_send.clear();
<a name="l01102"></a>01102             
<a name="l01103"></a>01103             <span class="comment">// let&#39;s pack the node bc data in the front of the element</span>
<a name="l01104"></a>01104             <span class="comment">// connectivity buffer</span>
<a name="l01105"></a>01105             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01106"></a>01106               n_elem_bcs_sent = element_bcs_sent.size() / 3;
<a name="l01107"></a>01107             
<a name="l01108"></a>01108             elements_sent[n_elem_replies_sent].insert (elements_sent[n_elem_replies_sent].end(),
<a name="l01109"></a>01109                                                        element_bcs_sent.begin(),
<a name="l01110"></a>01110                                                        element_bcs_sent.end());
<a name="l01111"></a>01111             
<a name="l01112"></a>01112             <span class="comment">// only append to the message if it is not empty</span>
<a name="l01113"></a>01113             <span class="keywordflow">if</span> (!elements_sent[n_elem_replies_sent].empty())
<a name="l01114"></a>01114               {
<a name="l01115"></a>01115                 <span class="comment">// let&#39;s tack three ints on to</span>
<a name="l01116"></a>01116                 <span class="comment">// the end of the elements_sent</span>
<a name="l01117"></a>01117                 <span class="comment">// buffer for use on the receiving end</span>
<a name="l01118"></a>01118                 elements_sent[n_elem_replies_sent].push_back (n_elements_sent);
<a name="l01119"></a>01119                 elements_sent[n_elem_replies_sent].push_back (n_elem_bcs_sent);
<a name="l01120"></a>01120                 elements_sent[n_elem_replies_sent].push_back (n_node_bcs_sent);
<a name="l01121"></a>01121               }
<a name="l01122"></a>01122             
<a name="l01123"></a>01123             <span class="comment">// send the elements off to the destination processor</span>
<a name="l01124"></a>01124             <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (dest_pid_idx,
<a name="l01125"></a>01125                             elements_sent[n_elem_replies_sent],
<a name="l01126"></a>01126                             element_send_requests[n_elem_replies_sent],
<a name="l01127"></a>01127                             node_list_tag);
<a name="l01128"></a>01128             n_elem_replies_sent++;
<a name="l01129"></a>01129           }
<a name="l01130"></a>01130         }
<a name="l01131"></a>01131 
<a name="l01132"></a>01132 
<a name="l01133"></a>01133 
<a name="l01134"></a>01134       <span class="comment">//------------------------------------------------------------------</span>
<a name="l01135"></a>01135       <span class="comment">// second time - reply of nodes</span>
<a name="l01136"></a>01136       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n_comm_steps[source_pid_idx] == 2)
<a name="l01137"></a>01137         {
<a name="l01138"></a>01138           n_comm_steps[source_pid_idx]++;
<a name="l01139"></a>01139         
<a name="l01140"></a>01140           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_pid_idx,
<a name="l01141"></a>01141                              nodes_received,
<a name="l01142"></a>01142                              packed_node_datatype,
<a name="l01143"></a>01143                              node_list_tag);
<a name="l01144"></a>01144           n_node_replies_received++;
<a name="l01145"></a>01145           
<a name="l01146"></a>01146           <span class="comment">// add the nodes we just received</span>
<a name="l01147"></a>01147           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes_received.size(); n++)
<a name="l01148"></a>01148             mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">insert_node</a> (nodes_received[n].build_node().release());
<a name="l01149"></a>01149         }
<a name="l01150"></a>01150 
<a name="l01151"></a>01151 
<a name="l01152"></a>01152 
<a name="l01153"></a>01153       <span class="comment">//------------------------------------------------------------------</span>
<a name="l01154"></a>01154       <span class="comment">// third time - elements &amp; bcs</span>
<a name="l01155"></a>01155       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n_comm_steps[source_pid_idx] == 3)
<a name="l01156"></a>01156         { 
<a name="l01157"></a>01157           n_comm_steps[source_pid_idx]++;
<a name="l01158"></a>01158 
<a name="l01159"></a>01159           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_pid_idx,
<a name="l01160"></a>01160                              elements_received,
<a name="l01161"></a>01161                              node_list_tag);      
<a name="l01162"></a>01162           n_elem_replies_received++;
<a name="l01163"></a>01163           
<a name="l01164"></a>01164           <span class="keywordflow">if</span> (elements_received.empty())
<a name="l01165"></a>01165             <span class="keywordflow">continue</span>;
<a name="l01166"></a>01166           
<a name="l01167"></a>01167           libmesh_assert (elements_received.size() &gt; 3);
<a name="l01168"></a>01168           
<a name="l01170"></a>01170           <span class="comment">// remember: elements_sent = </span>
<a name="l01171"></a>01171           <span class="comment">//          { [node bd data] [element conntectivity] [element bc data] # # # }</span>
<a name="l01173"></a>01173 <span class="comment"></span>          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node_bcs_received = elements_received.back(); elements_received.pop_back();
<a name="l01174"></a>01174           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_bcs_received = elements_received.back(); elements_received.pop_back();
<a name="l01175"></a>01175           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elements_received = elements_received.back(); elements_received.pop_back();
<a name="l01176"></a>01176           
<a name="l01177"></a>01177           <span class="comment">// counter into the bc/element connectivty buffer</span>
<a name="l01178"></a>01178           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01179"></a>01179           
<a name="l01180"></a>01180           <span class="comment">// add any node bcs</span>
<a name="l01181"></a>01181           <span class="keywordflow">while</span> (cnt &lt; n_node_bcs_received)
<a name="l01182"></a>01182             {
<a name="l01183"></a>01183               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = elements_received[cnt++];
<a name="l01184"></a>01184               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_bcs = elements_received[cnt++];
<a name="l01185"></a>01185 
<a name="l01186"></a>01186               libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(node_id));
<a name="l01187"></a>01187             
<a name="l01188"></a>01188               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; num_bcs; bc_it++)
<a name="l01189"></a>01189                 mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_node (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(node_id), elements_received[cnt++]);
<a name="l01190"></a>01190             }
<a name="l01191"></a>01191       
<a name="l01192"></a>01192           <span class="comment">// add the elements we just received</span>
<a name="l01193"></a>01193           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;n_elements_received; e++)
<a name="l01194"></a>01194             {
<a name="l01195"></a>01195               <span class="comment">// Unpack the element </span>
<a name="l01196"></a>01196               Elem::PackedElem packed_elem (elements_received.begin()+cnt);
<a name="l01197"></a>01197           
<a name="l01198"></a>01198               <span class="comment">// The ParallelMesh::elem(i) member will return NULL if the element</span>
<a name="l01199"></a>01199               <span class="comment">// is not in the mesh.  We rely on that here, so it better not change!</span>
<a name="l01200"></a>01200               Elem *elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.id());
<a name="l01201"></a>01201           
<a name="l01202"></a>01202               <span class="comment">// if we already have this element, make sure its properties match</span>
<a name="l01203"></a>01203               <span class="comment">// but then go on</span>
<a name="l01204"></a>01204               <span class="keywordflow">if</span> (elem)
<a name="l01205"></a>01205                 {
<a name="l01206"></a>01206                   libmesh_assert (elem-&gt;level()             == packed_elem.level());
<a name="l01207"></a>01207                   libmesh_assert (elem-&gt;id()                == packed_elem.id());
<a name="l01208"></a>01208                   libmesh_assert (elem-&gt;processor_id()      == packed_elem.processor_id());
<a name="l01209"></a>01209                   libmesh_assert (elem-&gt;subdomain_id()      == packed_elem.subdomain_id());
<a name="l01210"></a>01210                   libmesh_assert (elem-&gt;type()              == packed_elem.type());
<a name="l01211"></a>01211 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01212"></a>01212 <span class="preprocessor"></span>                  libmesh_assert (elem-&gt;p_level()           == packed_elem.p_level());
<a name="l01213"></a>01213                   libmesh_assert (elem-&gt;refinement_flag()   == packed_elem.refinement_flag());
<a name="l01214"></a>01214                   libmesh_assert (elem-&gt;p_refinement_flag() == packed_elem.p_refinement_flag());
<a name="l01215"></a>01215                   
<a name="l01216"></a>01216                   <span class="keywordflow">if</span> (elem-&gt;level() &gt; 0)
<a name="l01217"></a>01217                     {
<a name="l01218"></a>01218                       libmesh_assert (elem-&gt;parent()-&gt;id() == <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(packed_elem.parent_id()));
<a name="l01219"></a>01219                       libmesh_assert (elem-&gt;parent()-&gt;child(packed_elem.which_child_am_i()) == elem);
<a name="l01220"></a>01220                     }         
<a name="l01221"></a>01221 <span class="preprocessor">#endif</span>
<a name="l01222"></a>01222 <span class="preprocessor"></span>                  libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l01223"></a>01223                 }
<a name="l01224"></a>01224               <span class="keywordflow">else</span>
<a name="l01225"></a>01225                 {
<a name="l01226"></a>01226                   <span class="comment">// We need to add the element.</span>
<a name="l01227"></a>01227 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01228"></a>01228 <span class="preprocessor"></span>                  <span class="comment">// maybe find the parent</span>
<a name="l01229"></a>01229                   <span class="keywordflow">if</span> (packed_elem.level() &gt; 0)
<a name="l01230"></a>01230                     {
<a name="l01231"></a>01231                       Elem *parent = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.parent_id());
<a name="l01232"></a>01232                       
<a name="l01233"></a>01233                       <span class="comment">// Note that we were very careful to construct the send connectivity</span>
<a name="l01234"></a>01234                       <span class="comment">// so that parents are encountered before children.  So if we get here</span>
<a name="l01235"></a>01235                       <span class="comment">// and can&#39;t find the parent that is a fatal error.</span>
<a name="l01236"></a>01236                       <span class="keywordflow">if</span> (parent == NULL)
<a name="l01237"></a>01237                         {
<a name="l01238"></a>01238                           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l01239"></a>01239                                         &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l01240"></a>01240                           libmesh_error();
<a name="l01241"></a>01241                         }
<a name="l01242"></a>01242                       
<a name="l01243"></a>01243                       elem = packed_elem.unpack (mesh, parent);
<a name="l01244"></a>01244                     }
<a name="l01245"></a>01245                   <span class="keywordflow">else</span>
<a name="l01246"></a>01246                     {
<a name="l01247"></a>01247                       libmesh_assert (packed_elem.parent_id() == -1);
<a name="l01248"></a>01248                       elem = packed_elem.unpack (mesh);
<a name="l01249"></a>01249                     }
<a name="l01250"></a>01250 <span class="preprocessor">#else // !defined(LIBMESH_ENABLE_AMR)</span>
<a name="l01251"></a>01251 <span class="preprocessor"></span>                  elem = packed_elem.unpack (mesh);
<a name="l01252"></a>01252 <span class="preprocessor">#endif          </span>
<a name="l01253"></a>01253 <span class="preprocessor"></span>                  <span class="comment">// Good to go.  Add to the mesh.</span>
<a name="l01254"></a>01254                   libmesh_assert (elem);
<a name="l01255"></a>01255                   libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l01256"></a>01256                   mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">insert_elem</a>(elem);
<a name="l01257"></a>01257                 }
<a name="l01258"></a>01258           
<a name="l01259"></a>01259               <span class="comment">// properly position cnt for the next element </span>
<a name="l01260"></a>01260               cnt += <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + packed_elem.n_nodes();           
<a name="l01261"></a>01261             } <span class="comment">// done adding elements</span>
<a name="l01262"></a>01262       
<a name="l01263"></a>01263           <span class="comment">// add any element bcs</span>
<a name="l01264"></a>01264           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_bcs=0;
<a name="l01265"></a>01265           <span class="keywordflow">while</span> (cnt &lt; elements_received.size())
<a name="l01266"></a>01266             {
<a name="l01267"></a>01267               n_elem_bcs++;
<a name="l01268"></a>01268               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = elements_received[cnt++];
<a name="l01269"></a>01269               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>    = elements_received[cnt++];
<a name="l01270"></a>01270               <span class="keyword">const</span> <span class="keywordtype">int</span> bc_id            = elements_received[cnt++];
<a name="l01271"></a>01271               
<a name="l01272"></a>01272               libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(elem_id));
<a name="l01273"></a>01273               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(elem_id), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>, <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>);
<a name="l01274"></a>01274             }
<a name="l01275"></a>01275           libmesh_assert (n_elem_bcs_received == n_elem_bcs);
<a name="l01276"></a>01276         }
<a name="l01277"></a>01277 
<a name="l01278"></a>01278       <span class="comment">// Huh?</span>
<a name="l01279"></a>01279       <span class="keywordflow">else</span>
<a name="l01280"></a>01280         {
<a name="l01281"></a>01281           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  unexpected number of replies: &quot;</span>
<a name="l01282"></a>01282                         &lt;&lt; n_comm_steps[source_pid_idx]
<a name="l01283"></a>01283                     &lt;&lt; std::endl;
<a name="l01284"></a>01284         }
<a name="l01285"></a>01285     } <span class="comment">// done catching &amp; processing replies associated with tag ~ 100,000pi</span>
<a name="l01286"></a>01286   
<a name="l01287"></a>01287   <span class="comment">// Update neighbor information with the new elements,</span>
<a name="l01288"></a>01288   <span class="comment">// but don&#39;t throw away old information.</span>
<a name="l01289"></a>01289   mesh.<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a341e57f0c00d50bf885a10fbd6bcb903">find_neighbors</a> (<span class="comment">/* reset_remote_elements = */</span> <span class="keyword">true</span>,
<a name="l01290"></a>01290                        <span class="comment">/* reset_current_list    = */</span> <span class="keyword">false</span>);    
<a name="l01291"></a>01291   
<a name="l01292"></a>01292   <span class="comment">// OK, now at least all local elements should have a full set</span>
<a name="l01293"></a>01293   <span class="comment">// of neighbor information.  we still need to resolve remote</span>
<a name="l01294"></a>01294   <span class="comment">// element neighbor information though. to do this, we need</span>
<a name="l01295"></a>01295   <span class="comment">// to get the neighbor information from the processors that</span>
<a name="l01296"></a>01296   <span class="comment">// sent elements to us.</span>
<a name="l01297"></a>01297   <span class="comment">// </span>
<a name="l01298"></a>01298   <span class="comment">// first, send element face information to requisite processors</span>
<a name="l01299"></a>01299   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;n_adjacent_processors; comm_step++)
<a name="l01300"></a>01300     <span class="keywordflow">if</span> (!element_neighbors_sent[comm_step].empty()) <span class="comment">// if it is empty we already sent it!</span>
<a name="l01301"></a>01301       {
<a name="l01302"></a>01302         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_pid_idx = 
<a name="l01303"></a>01303           element_neighbors_sent[comm_step].back();
<a name="l01304"></a>01304         element_neighbors_sent[comm_step].pop_back();
<a name="l01305"></a>01305         
<a name="l01306"></a>01306         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pos=0; pos&lt;element_neighbors_sent[comm_step].size(); pos+=2)
<a name="l01307"></a>01307           {
<a name="l01308"></a>01308             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_global_idx = element_neighbors_sent[comm_step][pos+0];
<a name="l01309"></a>01309             <span class="keyword">const</span> Elem *elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(elem_global_idx);
<a name="l01310"></a>01310             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> face_neighbor_bitmask = 0;
<a name="l01311"></a>01311             
<a name="l01312"></a>01312             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;n_sides(); s++)
<a name="l01313"></a>01313               <span class="keywordflow">if</span> (elem-&gt;neighbor(s) != NULL)
<a name="l01314"></a>01314                 face_neighbor_bitmask |= FaceNeighborMask[s];
<a name="l01315"></a>01315             
<a name="l01316"></a>01316             element_neighbors_sent[comm_step][pos+1] = face_neighbor_bitmask;
<a name="l01317"></a>01317           }
<a name="l01318"></a>01318       
<a name="l01319"></a>01319         <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (dest_pid_idx,
<a name="l01320"></a>01320                         element_neighbors_sent[comm_step],
<a name="l01321"></a>01321                         element_neighbor_send_requests[comm_step],
<a name="l01322"></a>01322                         element_neighbors_tag);
<a name="l01323"></a>01323       } <span class="comment">// done sending neighbor information</span>
<a name="l01324"></a>01324 
<a name="l01325"></a>01325   <span class="comment">// second, receive and process all face neighbor information</span>
<a name="l01326"></a>01326   <span class="comment">// from the processors which sent us elements</span>
<a name="l01327"></a>01327   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;n_elem_replies_received; comm_step++)
<a name="l01328"></a>01328     {
<a name="l01329"></a>01329       <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>,
<a name="l01330"></a>01330                          element_neighbors_received,
<a name="l01331"></a>01331                          element_neighbors_tag);
<a name="l01332"></a>01332 
<a name="l01333"></a>01333       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pos=0; pos&lt;element_neighbors_received.size(); pos+=2)
<a name="l01334"></a>01334         {
<a name="l01335"></a>01335           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l01336"></a>01336             elem_global_idx       = element_neighbors_received[pos+0],
<a name="l01337"></a>01337             face_neighbor_bitmask = element_neighbors_received[pos+1];
<a name="l01338"></a>01338 
<a name="l01339"></a>01339           Elem *elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(elem_global_idx);
<a name="l01340"></a>01340 
<a name="l01341"></a>01341           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;n_sides(); s++)
<a name="l01342"></a>01342             <span class="keywordflow">if</span> ((face_neighbor_bitmask &amp; FaceNeighborMask[s]) <span class="comment">// if there is a face neighbor...</span>
<a name="l01343"></a>01343                 &amp;&amp; (elem-&gt;neighbor(s) == NULL))               <span class="comment">// ...and we do not have it</span>
<a name="l01344"></a>01344               elem-&gt;set_neighbor(s,const_cast&lt;RemoteElem*&gt;(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)); <span class="comment">// then it is a remote element</span>
<a name="l01345"></a>01345         }      
<a name="l01346"></a>01346     } <span class="comment">// done catching &amp; processing neighbor information</span>
<a name="l01347"></a>01347 
<a name="l01348"></a>01348   <span class="comment">// allow any pending requests to complete</span>
<a name="l01349"></a>01349   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (my_interface_node_list_requests);
<a name="l01350"></a>01350   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (node_send_requests);
<a name="l01351"></a>01351   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (element_send_requests);
<a name="l01352"></a>01352   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (element_neighbor_send_requests);  
<a name="l01353"></a>01353 
<a name="l01354"></a>01354   <span class="comment">// unregister MPI datatypes</span>
<a name="l01355"></a>01355   packed_node_datatype.<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a946f066948fc0ca306e7fc4025cef311">free</a>();
<a name="l01356"></a>01356   
<a name="l01357"></a>01357   STOP_LOG(<span class="stringliteral">&quot;gather_neighboring_elements()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);  
<a name="l01358"></a>01358 }
<a name="l01359"></a>01359 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l01360"></a>01360 <span class="preprocessor"></span>
<a name="l01361"></a>01361 
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01364"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">01364</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">MeshCommunication::broadcast</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01365"></a>01365 <span class="keyword"></span>{
<a name="l01366"></a>01366   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l01367"></a>01367   <span class="comment">// only one processor.</span>
<a name="l01368"></a>01368   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01369"></a>01369     <span class="keywordflow">return</span>;
<a name="l01370"></a>01370   
<a name="l01371"></a>01371   this-&gt;<a class="code" href="classlibMesh_1_1MeshCommunication.php#a0c40f3d84bf0007f8e2c3ec4de0c8081">broadcast_mesh</a> (mesh);
<a name="l01372"></a>01372   this-&gt;<a class="code" href="classlibMesh_1_1MeshCommunication.php#a80b2e2f53a4271810181ceb41bffcf15">broadcast_bcs</a>  (mesh, *(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>));
<a name="l01373"></a>01373 }
<a name="l01374"></a>01374 
<a name="l01375"></a>01375 
<a name="l01376"></a>01376 
<a name="l01377"></a>01377 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l01378"></a>01378 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01379"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a0c40f3d84bf0007f8e2c3ec4de0c8081">01379</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a0c40f3d84bf0007f8e2c3ec4de0c8081">MeshCommunication::broadcast_mesh</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;) const <span class="comment">// avoid spurious gcc warnings</span>
<a name="l01380"></a>01380 {
<a name="l01381"></a>01381   <span class="comment">// no MPI, no need for this method...</span>
<a name="l01382"></a>01382   <span class="keywordflow">return</span>;
<a name="l01383"></a>01383 }
<a name="l01384"></a>01384 <span class="preprocessor">#else </span>
<a name="l01385"></a>01385 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01386"></a>01386 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a0c40f3d84bf0007f8e2c3ec4de0c8081">MeshCommunication::broadcast_mesh</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01387"></a>01387 <span class="keyword"></span>{
<a name="l01388"></a>01388   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l01389"></a>01389   <span class="comment">// only one processor.</span>
<a name="l01390"></a>01390   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01391"></a>01391     <span class="keywordflow">return</span>;  
<a name="l01392"></a>01392 
<a name="l01393"></a>01393   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01394"></a>01394   parallel_only();
<a name="l01395"></a>01395 
<a name="l01396"></a>01396   START_LOG(<span class="stringliteral">&quot;broadcast_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01397"></a>01397 
<a name="l01398"></a>01398   <span class="comment">// Explicitly clear the mesh on all but processor 0.</span>
<a name="l01399"></a>01399   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01400"></a>01400     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l01401"></a>01401   
<a name="l01402"></a>01402   <span class="comment">// Get important sizes</span>
<a name="l01403"></a>01403   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>      = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l01404"></a>01404   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>       = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l01405"></a>01405   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a>     = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">MeshTools::n_levels</a>(mesh);
<a name="l01406"></a>01406   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">total_weight</a> = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">MeshTools::total_weight</a>(mesh);
<a name="l01407"></a>01407   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dimension    = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l01408"></a>01408 
<a name="l01409"></a>01409   <span class="comment">// Broadcast the sizes</span>
<a name="l01410"></a>01410   {
<a name="l01411"></a>01411     std::vector&lt;unsigned int&gt; buf (4);
<a name="l01412"></a>01412     
<a name="l01413"></a>01413     buf[0] = <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>;
<a name="l01414"></a>01414     buf[1] = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>;
<a name="l01415"></a>01415     buf[2] = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">total_weight</a>;
<a name="l01416"></a>01416     buf[3] = dimension;
<a name="l01417"></a>01417     
<a name="l01418"></a>01418     <span class="comment">// Broadcast</span>
<a name="l01419"></a>01419     <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (buf);
<a name="l01420"></a>01420 
<a name="l01421"></a>01421     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01422"></a>01422       {
<a name="l01423"></a>01423         n_nodes      = buf[0];
<a name="l01424"></a>01424         n_elem       = buf[1];
<a name="l01425"></a>01425         total_weight = buf[2];
<a name="l01426"></a>01426         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(buf[3]);
<a name="l01427"></a>01427       } 
<a name="l01428"></a>01428   }  
<a name="l01429"></a>01429 
<a name="l01430"></a>01430   <span class="comment">// First build up the pts vector which contains</span>
<a name="l01431"></a>01431   <span class="comment">// the spatial locations of all the nodes      </span>
<a name="l01432"></a>01432   {
<a name="l01433"></a>01433     std::vector&lt;Real&gt; pts;
<a name="l01434"></a>01434         
<a name="l01435"></a>01435     <span class="comment">// If we are processor 0, we must populate this vector and</span>
<a name="l01436"></a>01436     <span class="comment">// broadcast it to the other processors.</span>
<a name="l01437"></a>01437     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01438"></a>01438       {
<a name="l01439"></a>01439         pts.reserve (LIBMESH_DIM*n_nodes);
<a name="l01440"></a>01440 
<a name="l01441"></a>01441         MeshBase::node_iterator       it     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l01442"></a>01442         <span class="keyword">const</span> MeshBase::node_iterator it_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l01443"></a>01443 
<a name="l01444"></a>01444         <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l01445"></a>01445           {
<a name="l01446"></a>01446             libmesh_assert (*it != NULL);
<a name="l01447"></a>01447             libmesh_assert (!(*it)-&gt;valid_processor_id());
<a name="l01448"></a>01448             libmesh_assert ((*it)-&gt;id()*LIBMESH_DIM == pts.size());
<a name="l01449"></a>01449             
<a name="l01450"></a>01450             <span class="keyword">const</span> Point&amp; p = **it;
<a name="l01451"></a>01451             
<a name="l01452"></a>01452             pts.push_back ( p(0) ); <span class="comment">// x</span>
<a name="l01453"></a>01453 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l01454"></a>01454 <span class="preprocessor"></span>            pts.push_back ( p(1) ); <span class="comment">// y</span>
<a name="l01455"></a>01455 <span class="preprocessor">#endif</span>
<a name="l01456"></a>01456 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l01457"></a>01457 <span class="preprocessor"></span>            pts.push_back ( p(2) ); <span class="comment">// z          </span>
<a name="l01458"></a>01458 <span class="preprocessor">#endif</span>
<a name="l01459"></a>01459 <span class="preprocessor"></span>          }
<a name="l01460"></a>01460       }
<a name="l01461"></a>01461     <span class="keywordflow">else</span>
<a name="l01462"></a>01462       pts.resize (LIBMESH_DIM*n_nodes);
<a name="l01463"></a>01463 
<a name="l01464"></a>01464     <span class="comment">// Sanity check for all processors</span>
<a name="l01465"></a>01465     libmesh_assert (pts.size() == (LIBMESH_DIM*<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>));
<a name="l01466"></a>01466     
<a name="l01467"></a>01467     <span class="comment">// Broadcast the pts vector</span>
<a name="l01468"></a>01468     <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (pts);
<a name="l01469"></a>01469 
<a name="l01470"></a>01470     <span class="comment">// Add the nodes we just received if we are not</span>
<a name="l01471"></a>01471     <span class="comment">// processor 0.</span>
<a name="l01472"></a>01472     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01473"></a>01473       {
<a name="l01474"></a>01474         libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() == 0);
<a name="l01475"></a>01475         
<a name="l01476"></a>01476         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;pts.size(); i += LIBMESH_DIM)
<a name="l01477"></a>01477           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(pts[i+0]
<a name="l01478"></a>01478 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 1
<a name="l01479"></a>01479                                 , pts[i+1]
<a name="l01480"></a>01480 #endif
<a name="l01481"></a>01481 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 2
<a name="l01482"></a>01482                                 , pts[i+2]
<a name="l01483"></a>01483 #endif
<a name="l01484"></a>01484                                ),
<a name="l01485"></a>01485                           i/LIBMESH_DIM);
<a name="l01486"></a>01486       }
<a name="l01487"></a>01487     
<a name="l01488"></a>01488     libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() == <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>);
<a name="l01489"></a>01489   } <span class="comment">// Done distributing the nodes</span>
<a name="l01490"></a>01490 
<a name="l01491"></a>01491   
<a name="l01492"></a>01492   <span class="comment">// Now build up the elements vector which</span>
<a name="l01493"></a>01493   <span class="comment">// contains the element types and connectivity</span>
<a name="l01494"></a>01494   {
<a name="l01495"></a>01495     <span class="comment">// The conn array contains the information needed to construct each element.</span>
<a name="l01496"></a>01496     <span class="comment">// Pack all this information into one communication to avoid two latency hits</span>
<a name="l01497"></a>01497     <span class="comment">// For each element it is of the form</span>
<a name="l01498"></a>01498     <span class="comment">// [ level p_level r_flag p_flag etype subdomain_id </span>
<a name="l01499"></a>01499     <span class="comment">//   self_ID parent_ID which_child node_0 node_1 ... node_n]</span>
<a name="l01500"></a>01500     <span class="comment">// We cannot use unsigned int because parent_ID can be negative</span>
<a name="l01501"></a>01501     std::vector&lt;int&gt; conn;
<a name="l01502"></a>01502 
<a name="l01503"></a>01503     <span class="comment">// If we are processor 0, we must populate this vector and</span>
<a name="l01504"></a>01504     <span class="comment">// broadcast it to the other processors.</span>
<a name="l01505"></a>01505     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01506"></a>01506       {
<a name="l01507"></a>01507         conn.reserve (<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a>*n_elem + total_weight);
<a name="l01508"></a>01508         
<a name="l01509"></a>01509         <span class="comment">// We start from level 0. This is a bit simpler than in xdr_io.C</span>
<a name="l01510"></a>01510         <span class="comment">// because we do not have to worry about economizing by group elements</span>
<a name="l01511"></a>01511         <span class="comment">// of the same type. Element type is simply specified as an</span>
<a name="l01512"></a>01512         <span class="comment">// entry in the connectivity vector, &quot;conn&quot;.</span>
<a name="l01513"></a>01513         <span class="comment">// By filling conn in order of levels, parents should exist before children</span>
<a name="l01514"></a>01514         <span class="comment">// are built when we reconstruct the elements on the other processors.</span>
<a name="l01515"></a>01515         
<a name="l01516"></a>01516         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=<a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a>; ++level)
<a name="l01517"></a>01517           {
<a name="l01518"></a>01518             MeshBase::element_iterator it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>(level);
<a name="l01519"></a>01519             <span class="keyword">const</span> MeshBase::element_iterator it_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>(level);
<a name="l01520"></a>01520             
<a name="l01521"></a>01521             <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l01522"></a>01522               {
<a name="l01523"></a>01523                 libmesh_assert (*it);
<a name="l01524"></a>01524                 libmesh_assert (!(*it)-&gt;valid_processor_id());
<a name="l01525"></a>01525                 <span class="keyword">const</span> Elem* elem = *it;
<a name="l01526"></a>01526                 <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">Elem::PackedElem::pack</a> (conn, elem);
<a name="l01527"></a>01527               }
<a name="l01528"></a>01528           }
<a name="l01529"></a>01529       }
<a name="l01530"></a>01530     <span class="keywordflow">else</span>
<a name="l01531"></a>01531       conn.resize (<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a>*n_elem + total_weight);
<a name="l01532"></a>01532     
<a name="l01533"></a>01533     <span class="comment">// Sanity check for all processors</span>
<a name="l01534"></a>01534     libmesh_assert (conn.size() == (<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a>*n_elem + <a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">total_weight</a>));
<a name="l01535"></a>01535     
<a name="l01536"></a>01536     <span class="comment">// Broadcast the element connectivity</span>
<a name="l01537"></a>01537     <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (conn);
<a name="l01538"></a>01538 
<a name="l01539"></a>01539     <span class="comment">// Build the elements we just received if we are not</span>
<a name="l01540"></a>01540     <span class="comment">// processor 0.</span>
<a name="l01541"></a>01541     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01542"></a>01542       {
<a name="l01543"></a>01543         libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>() == 0);
<a name="l01544"></a>01544         
<a name="l01545"></a>01545         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l01546"></a>01546 
<a name="l01547"></a>01547         <span class="comment">// This map keeps track of elements we&#39;ve previously added to the mesh </span>
<a name="l01548"></a>01548         <span class="comment">// to avoid O(n) lookup times for parent pointers.</span>
<a name="l01549"></a>01549         std::map&lt;unsigned int, Elem*&gt; parents;
<a name="l01550"></a>01550 
<a name="l01551"></a>01551         <span class="keywordflow">while</span> (cnt &lt; conn.size())
<a name="l01552"></a>01552           {
<a name="l01553"></a>01553             <span class="comment">// Unpack the element</span>
<a name="l01554"></a>01554             Elem::PackedElem packed_elem (conn.begin()+cnt);
<a name="l01555"></a>01555 
<a name="l01556"></a>01556             <span class="comment">// Declare the element that we will add</span>
<a name="l01557"></a>01557             Elem* elem = NULL;
<a name="l01558"></a>01558 
<a name="l01559"></a>01559 <span class="comment">//          // Unpack the element header</span>
<a name="l01560"></a>01560 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01561"></a>01561 <span class="comment">//          const int level             = conn[cnt++];</span>
<a name="l01562"></a>01562 <span class="comment">//          const int p_level           = conn[cnt++];</span>
<a name="l01563"></a>01563 <span class="comment">//          const Elem::RefinementState refinement_flag =</span>
<a name="l01564"></a>01564 <span class="comment">//               static_cast&lt;Elem::RefinementState&gt;(conn[cnt++]);</span>
<a name="l01565"></a>01565 <span class="comment">//          const Elem::RefinementState p_refinement_flag =</span>
<a name="l01566"></a>01566 <span class="comment">//               static_cast&lt;Elem::RefinementState&gt;(conn[cnt++]);</span>
<a name="l01567"></a>01567 <span class="comment">// #endif</span>
<a name="l01568"></a>01568 <span class="comment">//             const ElemType elem_type    = static_cast&lt;ElemType&gt;(conn[cnt++]);</span>
<a name="l01569"></a>01569 <span class="comment">//          const unsigned int elem_PID = conn[cnt++];</span>
<a name="l01570"></a>01570 <span class="comment">//          const int subdomain_ID      = conn[cnt++];</span>
<a name="l01571"></a>01571 <span class="comment">//             const int self_ID           = conn[cnt++];</span>
<a name="l01572"></a>01572 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01573"></a>01573 <span class="comment">//             const int parent_ID         = conn[cnt++];</span>
<a name="l01574"></a>01574 <span class="comment">//             const int which_child       = conn[cnt++];</span>
<a name="l01575"></a>01575 
<a name="l01576"></a>01576 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01577"></a>01577 <span class="preprocessor"></span>
<a name="l01578"></a>01578             <span class="keywordflow">if</span> (packed_elem.parent_id() != -1) <span class="comment">// Do a log(n) search for the parent</span>
<a name="l01579"></a>01579               {
<a name="l01580"></a>01580                 Elem* my_parent = 
<a name="l01581"></a>01581                   parents.count(packed_elem.parent_id()) ? parents[packed_elem.parent_id()] : NULL;
<a name="l01582"></a>01582                 
<a name="l01583"></a>01583                 <span class="comment">// If the parent was not previously added, we cannot continue.</span>
<a name="l01584"></a>01584                 <span class="keywordflow">if</span> (my_parent == NULL)
<a name="l01585"></a>01585                   {
<a name="l01586"></a>01586                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l01587"></a>01587                                   &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l01588"></a>01588                     libmesh_error();
<a name="l01589"></a>01589                   }
<a name="l01590"></a>01590                 
<a name="l01591"></a>01591                 libmesh_assert (my_parent-&gt;refinement_flag() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);                
<a name="l01592"></a>01592                 
<a name="l01593"></a>01593                 elem = packed_elem.unpack (mesh, my_parent);
<a name="l01594"></a>01594               }
<a name="l01595"></a>01595             
<a name="l01596"></a>01596             <span class="keywordflow">else</span> <span class="comment">// level 0 element has no parent</span>
<a name="l01597"></a>01597               {
<a name="l01598"></a>01598                 libmesh_assert (packed_elem.level() == 0);
<a name="l01599"></a>01599 <span class="preprocessor">#endif          </span>
<a name="l01600"></a>01600 <span class="preprocessor"></span>                elem = packed_elem.unpack (mesh);
<a name="l01601"></a>01601 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01602"></a>01602 <span class="preprocessor"></span>              }
<a name="l01603"></a>01603 <span class="preprocessor">#endif      </span>
<a name="l01604"></a>01604 <span class="preprocessor"></span>            <span class="comment">// Add elem to the map of parents, since it may have</span>
<a name="l01605"></a>01605             <span class="comment">// children to be added later</span>
<a name="l01606"></a>01606             parents.insert(std::make_pair(elem-&gt;id(),elem));
<a name="l01607"></a>01607 
<a name="l01608"></a>01608             cnt += <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + packed_elem.n_nodes();
<a name="l01609"></a>01609           } <span class="comment">// end while cnt &lt; conn.size</span>
<a name="l01610"></a>01610 
<a name="l01611"></a>01611         <span class="comment">// Iterate in ascending elem ID order</span>
<a name="l01612"></a>01612         <span class="keywordflow">for</span> (std::map&lt;unsigned int, Elem *&gt;::iterator i =
<a name="l01613"></a>01613              parents.begin();
<a name="l01614"></a>01614              i != parents.end(); ++i)
<a name="l01615"></a>01615           {
<a name="l01616"></a>01616             Elem *elem = i-&gt;second;
<a name="l01617"></a>01617             <span class="keywordflow">if</span> (elem)
<a name="l01618"></a>01618               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(elem);
<a name="l01619"></a>01619             <span class="keywordflow">else</span>
<a name="l01620"></a>01620               <span class="comment">// We can probably handle this, but we don&#39;t expect it</span>
<a name="l01621"></a>01621               libmesh_error();
<a name="l01622"></a>01622           }
<a name="l01623"></a>01623 
<a name="l01624"></a>01624       } <span class="comment">// end if iam != cpu 0</span>
<a name="l01625"></a>01625     
<a name="l01626"></a>01626     
<a name="l01627"></a>01627     libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>() == <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>);
<a name="l01628"></a>01628   } <span class="comment">// Done distributing the elements</span>
<a name="l01629"></a>01629 
<a name="l01630"></a>01630 
<a name="l01631"></a>01631   STOP_LOG(<span class="stringliteral">&quot;broadcast_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01632"></a>01632 }
<a name="l01633"></a>01633 <span class="preprocessor">#endif</span>
<a name="l01634"></a>01634 <span class="preprocessor"></span>
<a name="l01635"></a>01635 
<a name="l01636"></a>01636 
<a name="l01637"></a>01637 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l01638"></a>01638 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01639"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a80b2e2f53a4271810181ceb41bffcf15">01639</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a80b2e2f53a4271810181ceb41bffcf15">MeshCommunication::broadcast_bcs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;,
<a name="l01640"></a>01640                                        <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp;) const <span class="comment">// avoid spurious gcc warnings</span>
<a name="l01641"></a>01641 {
<a name="l01642"></a>01642 }
<a name="l01643"></a>01643 <span class="preprocessor">#else</span>
<a name="l01644"></a>01644 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01645"></a>01645 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a80b2e2f53a4271810181ceb41bffcf15">MeshCommunication::broadcast_bcs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l01646"></a>01646                                        <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp; boundary_info)<span class="keyword"> const</span>
<a name="l01647"></a>01647 <span class="keyword"></span>{
<a name="l01648"></a>01648   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l01649"></a>01649   <span class="comment">// only one processor.</span>
<a name="l01650"></a>01650   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01651"></a>01651     <span class="keywordflow">return</span>;
<a name="l01652"></a>01652   
<a name="l01653"></a>01653   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01654"></a>01654   parallel_only();
<a name="l01655"></a>01655 
<a name="l01656"></a>01656   START_LOG(<span class="stringliteral">&quot;broadcast_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01657"></a>01657 
<a name="l01658"></a>01658   <span class="comment">// Explicitly clear the boundary conditions on all</span>
<a name="l01659"></a>01659   <span class="comment">// but processor 0.</span>
<a name="l01660"></a>01660   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01661"></a>01661     boundary_info.clear();
<a name="l01662"></a>01662 
<a name="l01663"></a>01663   <span class="comment">// Build up the list of elements with boundary conditions</span>
<a name="l01664"></a>01664   {
<a name="l01665"></a>01665     std::vector&lt;unsigned int&gt;       el_id;
<a name="l01666"></a>01666     std::vector&lt;unsigned short int&gt; side_id;
<a name="l01667"></a>01667     std::vector&lt;short int&gt;          <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>;
<a name="l01668"></a>01668 
<a name="l01669"></a>01669     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01670"></a>01670       boundary_info.build_side_list (el_id, side_id, bc_id);
<a name="l01671"></a>01671 
<a name="l01672"></a>01672     libmesh_assert (el_id.size() == side_id.size());
<a name="l01673"></a>01673     libmesh_assert (el_id.size() == bc_id.size());
<a name="l01674"></a>01674     
<a name="l01675"></a>01675     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = el_id.size();
<a name="l01676"></a>01676 
<a name="l01677"></a>01677     <span class="comment">// Broadcast the number of bcs to expect from processor 0.</span>
<a name="l01678"></a>01678     <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (n_bcs);
<a name="l01679"></a>01679 
<a name="l01680"></a>01680     <span class="comment">// Only continue if we have element BCs</span>
<a name="l01681"></a>01681     <span class="keywordflow">if</span> (n_bcs &gt; 0)
<a name="l01682"></a>01682       {
<a name="l01683"></a>01683         <span class="comment">// Allocate space. On CPU 0, these vectors should already have size n_bcs.</span>
<a name="l01684"></a>01684         el_id.resize   (n_bcs);
<a name="l01685"></a>01685         side_id.resize (n_bcs);
<a name="l01686"></a>01686         bc_id.resize   (n_bcs);
<a name="l01687"></a>01687         
<a name="l01688"></a>01688         <span class="comment">// Broadcast the element identities</span>
<a name="l01689"></a>01689         <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (el_id);
<a name="l01690"></a>01690 
<a name="l01691"></a>01691         <span class="comment">// Broadcast the side ids for those elements</span>
<a name="l01692"></a>01692         <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (side_id);
<a name="l01693"></a>01693 
<a name="l01694"></a>01694         <span class="comment">// Broadcast the bc ids for each side</span>
<a name="l01695"></a>01695         <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (bc_id);
<a name="l01696"></a>01696 
<a name="l01697"></a>01697         <span class="comment">// Build the boundary_info structure if we aren&#39;t processor 0</span>
<a name="l01698"></a>01698         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01699"></a>01699           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;n_bcs; e++)
<a name="l01700"></a>01700             {
<a name="l01701"></a>01701               libmesh_assert (el_id[e] &lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l01702"></a>01702               
<a name="l01703"></a>01703               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(el_id[e]);
<a name="l01704"></a>01704 
<a name="l01705"></a>01705               libmesh_assert (elem != NULL);
<a name="l01706"></a>01706 
<a name="l01707"></a>01707               <span class="comment">// sanity: be sure that the element returned by mesh.elem() really has id()==el_id[e]</span>
<a name="l01708"></a>01708               libmesh_assert(elem-&gt;id() == el_id[e]);
<a name="l01709"></a>01709 
<a name="l01710"></a>01710               libmesh_assert (side_id[e] &lt; elem-&gt;n_sides());
<a name="l01711"></a>01711             
<a name="l01712"></a>01712               boundary_info.add_side (elem, side_id[e], bc_id[e]);
<a name="l01713"></a>01713             }
<a name="l01714"></a>01714       }
<a name="l01715"></a>01715   }
<a name="l01716"></a>01716 
<a name="l01717"></a>01717 
<a name="l01718"></a>01718 
<a name="l01719"></a>01719   <span class="comment">// Build up the list of nodes with boundary conditions</span>
<a name="l01720"></a>01720   {
<a name="l01721"></a>01721     std::vector&lt;unsigned int&gt; node_id;
<a name="l01722"></a>01722     std::vector&lt;short int&gt;    <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>;
<a name="l01723"></a>01723 
<a name="l01724"></a>01724     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01725"></a>01725       boundary_info.build_node_list (node_id, bc_id);
<a name="l01726"></a>01726 
<a name="l01727"></a>01727     libmesh_assert (node_id.size() == bc_id.size());
<a name="l01728"></a>01728     
<a name="l01729"></a>01729     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = node_id.size();
<a name="l01730"></a>01730 
<a name="l01731"></a>01731     <span class="comment">// Broadcast the number of bcs to expect from processor 0.</span>
<a name="l01732"></a>01732     <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (n_bcs);
<a name="l01733"></a>01733 
<a name="l01734"></a>01734     <span class="comment">// Only continue if we have nodal BCs</span>
<a name="l01735"></a>01735     <span class="keywordflow">if</span> (n_bcs &gt; 0)
<a name="l01736"></a>01736       {      
<a name="l01737"></a>01737         <span class="comment">// Allocate space, again on CPU 0 this should be a no-op.</span>
<a name="l01738"></a>01738         node_id.resize (n_bcs);
<a name="l01739"></a>01739         bc_id.resize   (n_bcs);
<a name="l01740"></a>01740         
<a name="l01741"></a>01741         <span class="comment">// Broadcast the node ids</span>
<a name="l01742"></a>01742         <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (node_id);
<a name="l01743"></a>01743         
<a name="l01744"></a>01744         <span class="comment">// Broadcast the bc ids for each side</span>
<a name="l01745"></a>01745         <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">Parallel::broadcast</a> (bc_id);
<a name="l01746"></a>01746 
<a name="l01747"></a>01747         <span class="comment">// Build the boundary_info structure if we aren&#39;t processor 0</span>
<a name="l01748"></a>01748         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01749"></a>01749           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_bcs; n++)
<a name="l01750"></a>01750             {
<a name="l01751"></a>01751               libmesh_assert (node_id[n] &lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l01752"></a>01752               
<a name="l01753"></a>01753               <span class="keyword">const</span> Node* node = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a> (node_id[n]);
<a name="l01754"></a>01754 
<a name="l01755"></a>01755               libmesh_assert (node != NULL);
<a name="l01756"></a>01756               
<a name="l01757"></a>01757               <span class="comment">// sanity: be sure that the node returned by mesh.node_ptr() really has id()==node_id[n]</span>
<a name="l01758"></a>01758               libmesh_assert(node-&gt;id() == node_id[n]);
<a name="l01759"></a>01759             
<a name="l01760"></a>01760               boundary_info.add_node (node, bc_id[n]);
<a name="l01761"></a>01761             }
<a name="l01762"></a>01762       }
<a name="l01763"></a>01763   }
<a name="l01764"></a>01764 
<a name="l01765"></a>01765   STOP_LOG(<span class="stringliteral">&quot;broadcast_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01766"></a>01766 }
<a name="l01767"></a>01767 <span class="preprocessor">#endif  </span>
<a name="l01768"></a>01768 <span class="preprocessor"></span>
<a name="l01769"></a>01769 
<a name="l01770"></a>01770 
<a name="l01771"></a>01771 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01772"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">01772</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">MeshCommunication::allgather</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01773"></a>01773 <span class="keyword"></span>{
<a name="l01774"></a>01774   START_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01775"></a>01775 
<a name="l01776"></a>01776   <span class="comment">// The mesh should know it&#39;s about to be serialized</span>
<a name="l01777"></a>01777   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>());
<a name="l01778"></a>01778 
<a name="l01779"></a>01779   this-&gt;<a class="code" href="classlibMesh_1_1MeshCommunication.php#ac5191d5151039c4eca0aa05cd51e2e5d">allgather_mesh</a> (mesh);
<a name="l01780"></a>01780   this-&gt;<a class="code" href="classlibMesh_1_1MeshCommunication.php#aaa030e4082c298eca5efae64dfec69f3">allgather_bcs</a>  (mesh, *(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>));
<a name="l01781"></a>01781 
<a name="l01782"></a>01782   <span class="comment">// Inform new elements of their neighbors,</span>
<a name="l01783"></a>01783   <span class="comment">// while resetting all remote_elem links</span>
<a name="l01784"></a>01784   mesh.<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a341e57f0c00d50bf885a10fbd6bcb903">find_neighbors</a>(<span class="keyword">true</span>);
<a name="l01785"></a>01785 
<a name="l01786"></a>01786   STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01787"></a>01787 }
<a name="l01788"></a>01788 
<a name="l01789"></a>01789 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l01790"></a>01790 <span class="preprocessor"></span>  
<a name="l01791"></a>01791 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01792"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#ac5191d5151039c4eca0aa05cd51e2e5d">01792</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#ac5191d5151039c4eca0aa05cd51e2e5d">MeshCommunication::allgather_mesh</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp;)<span class="keyword"> const</span>
<a name="l01793"></a>01793 <span class="keyword"></span>{
<a name="l01794"></a>01794   <span class="comment">// NO MPI == one processor, no need for this method</span>
<a name="l01795"></a>01795   <span class="keywordflow">return</span>;
<a name="l01796"></a>01796 }
<a name="l01797"></a>01797   
<a name="l01798"></a>01798 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01799"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#aaa030e4082c298eca5efae64dfec69f3">01799</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#aaa030e4082c298eca5efae64dfec69f3">MeshCommunication::allgather_bcs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp;,
<a name="l01800"></a>01800                                        <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp;)<span class="keyword"> const</span>
<a name="l01801"></a>01801 <span class="keyword"></span>{
<a name="l01802"></a>01802   <span class="comment">// NO MPI == one processor, no need for this method</span>
<a name="l01803"></a>01803   <span class="keywordflow">return</span>;
<a name="l01804"></a>01804 }
<a name="l01805"></a>01805 
<a name="l01806"></a>01806 <span class="preprocessor">#else</span>
<a name="l01807"></a>01807 <span class="preprocessor"></span>
<a name="l01808"></a>01808 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01809"></a>01809 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#ac5191d5151039c4eca0aa05cd51e2e5d">MeshCommunication::allgather_mesh</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01810"></a>01810 <span class="keyword"></span>{
<a name="l01811"></a>01811   <span class="comment">// Check for quick return</span>
<a name="l01812"></a>01812   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01813"></a>01813     <span class="keywordflow">return</span>;
<a name="l01814"></a>01814 
<a name="l01815"></a>01815   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01816"></a>01816   parallel_only();
<a name="l01817"></a>01817 
<a name="l01818"></a>01818   START_LOG (<span class="stringliteral">&quot;allgather_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01819"></a>01819   
<a name="l01820"></a>01820   <span class="comment">// Gather the number of nodes and elements on each processor.</span>
<a name="l01821"></a>01821   std::vector&lt;unsigned int&gt;
<a name="l01822"></a>01822     <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()), <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01823"></a>01823   
<a name="l01824"></a>01824   {
<a name="l01825"></a>01825     std::vector&lt;unsigned int&gt; n_objects(2);
<a name="l01826"></a>01826     n_objects[0] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>();
<a name="l01827"></a>01827     n_objects[1] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>();
<a name="l01828"></a>01828 
<a name="l01829"></a>01829     <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">Parallel::allgather</a>(n_objects, <span class="comment">/* identical_buffer_sizes = */</span> <span class="keyword">true</span>);
<a name="l01830"></a>01830     
<a name="l01831"></a>01831     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0, <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01832"></a>01832       {
<a name="l01833"></a>01833         n_nodes[p] = n_objects[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++];
<a name="l01834"></a>01834         n_elem[p]  = n_objects[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++];  
<a name="l01835"></a>01835       }
<a name="l01836"></a>01836 
<a name="l01837"></a>01837     libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>() == n_nodes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01838"></a>01838     libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>()  ==  n_elem[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01839"></a>01839   }
<a name="l01840"></a>01840 
<a name="l01841"></a>01841   std::vector&lt;unsigned int&gt;
<a name="l01842"></a>01842     node_offsets(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01843"></a>01843     elem_offsets(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01844"></a>01844   
<a name="l01845"></a>01845   <span class="comment">// Compute the global sizes to cross-check the results of the</span>
<a name="l01846"></a>01846   <span class="comment">// operations that follow.</span>
<a name="l01847"></a>01847   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01848"></a>01848     global_n_nodes = n_nodes[0], 
<a name="l01849"></a>01849     global_n_elem  = n_elem[0];
<a name="l01850"></a>01850 
<a name="l01851"></a>01851   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01852"></a>01852     {
<a name="l01853"></a>01853       node_offsets[p] = node_offsets[p-1] + n_nodes[p-1];
<a name="l01854"></a>01854       elem_offsets[p] = elem_offsets[p-1] +  n_elem[p-1];
<a name="l01855"></a>01855 
<a name="l01856"></a>01856       global_n_nodes += n_nodes[p];
<a name="l01857"></a>01857       global_n_elem  += n_elem[p];
<a name="l01858"></a>01858     }
<a name="l01859"></a>01859 
<a name="l01860"></a>01860   
<a name="l01861"></a>01861   
<a name="l01862"></a>01862   <span class="comment">//-------------------------------------------------</span>
<a name="l01863"></a>01863   <span class="comment">// Gather the nodal coordinates from each processor.</span>
<a name="l01864"></a>01864   {
<a name="l01865"></a>01865     std::vector&lt;Real&gt; xyz; xyz.reserve(3*n_nodes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01866"></a>01866     
<a name="l01867"></a>01867     ParallelMesh::node_iterator       it  = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#abb46f88fbb47fef5636af8eae4ce36b4">local_nodes_begin</a>();
<a name="l01868"></a>01868     <span class="keyword">const</span> ParallelMesh::node_iterator end = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a06d628805eb6ca230022d0a1127b8fa4">local_nodes_end</a>();
<a name="l01869"></a>01869 
<a name="l01870"></a>01870     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01871"></a>01871       {
<a name="l01872"></a>01872         libmesh_assert (*it != NULL);
<a name="l01873"></a>01873             
<a name="l01874"></a>01874         <span class="keyword">const</span> Point &amp;p = **it;
<a name="l01875"></a>01875 
<a name="l01876"></a>01876         xyz.push_back(p(0));
<a name="l01877"></a>01877         xyz.push_back(p(1));
<a name="l01878"></a>01878         xyz.push_back(p(2));
<a name="l01879"></a>01879       }
<a name="l01880"></a>01880 
<a name="l01881"></a>01881     libmesh_assert (xyz.size() == 3*n_nodes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01882"></a>01882 
<a name="l01883"></a>01883     <span class="comment">// Get values from other processors</span>
<a name="l01884"></a>01884     <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">Parallel::allgather</a> (xyz);
<a name="l01885"></a>01885 
<a name="l01886"></a>01886     <span class="comment">// And add them to our mesh.</span>
<a name="l01887"></a>01887     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01888"></a>01888       <span class="keywordflow">if</span> (p == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="keywordflow">continue</span>; <span class="comment">// We&#39;ve already got our</span>
<a name="l01889"></a>01889                                                   <span class="comment">// own local nodes!</span>
<a name="l01890"></a>01890       <span class="keywordflow">else</span>
<a name="l01891"></a>01891         {
<a name="l01892"></a>01892           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01893"></a>01893             first_global_idx = node_offsets[p],
<a name="l01894"></a>01894             last_global_idx  = first_global_idx + n_nodes[p];
<a name="l01895"></a>01895 
<a name="l01896"></a>01896           <span class="comment">// Extract the coordinates for each node belonging to processor p</span>
<a name="l01897"></a>01897           <span class="comment">// and add it to our mesh.</span>
<a name="l01898"></a>01898           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_idx = first_global_idx; global_idx&lt;last_global_idx; global_idx++)
<a name="l01899"></a>01899             {
<a name="l01900"></a>01900               libmesh_assert ((3*global_idx + 2) &lt; xyz.size());
<a name="l01901"></a>01901               
<a name="l01902"></a>01902               Node *node = <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">Node::build</a>(xyz[3*global_idx + 0],
<a name="l01903"></a>01903                                        xyz[3*global_idx + 1],
<a name="l01904"></a>01904                                        xyz[3*global_idx + 2],
<a name="l01905"></a>01905                                        global_idx).release();
<a name="l01906"></a>01906               
<a name="l01907"></a>01907               libmesh_assert (node != NULL);
<a name="l01908"></a>01908               libmesh_assert (node-&gt;id() == global_idx);
<a name="l01909"></a>01909               
<a name="l01910"></a>01910               node-&gt;processor_id() = p;
<a name="l01911"></a>01911 
<a name="l01912"></a>01912               mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">insert_node</a>(node);
<a name="l01913"></a>01913             }
<a name="l01914"></a>01914         }
<a name="l01915"></a>01915     
<a name="l01916"></a>01916     <span class="comment">// Check the result</span>
<a name="l01917"></a>01917     libmesh_assert (global_n_nodes == mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>());
<a name="l01918"></a>01918   }
<a name="l01919"></a>01919   
<a name="l01920"></a>01920   <span class="comment">//----------------------------------------------------</span>
<a name="l01921"></a>01921   <span class="comment">// Gather the element connectivity from each processor.</span>
<a name="l01922"></a>01922   {
<a name="l01923"></a>01923     <span class="comment">// Get the sum of elem-&gt;n_nodes() for all local elements.  This</span>
<a name="l01924"></a>01924     <span class="comment">// will allow for efficient preallocation.</span>
<a name="l01925"></a>01925     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01926"></a>01926       local_weight   = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">MeshTools::weight</a>(mesh),
<a name="l01927"></a>01927       local_n_levels = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a86b5b94d1a51d606668a85e6f31af4b6">MeshTools::n_local_levels</a>(mesh);
<a name="l01928"></a>01928 
<a name="l01929"></a>01929     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_n_levels = local_n_levels;
<a name="l01930"></a>01930     <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a> (global_n_levels);
<a name="l01931"></a>01931     
<a name="l01932"></a>01932     <span class="comment">// The conn array contains the information needed to construct each element.</span>
<a name="l01933"></a>01933     std::vector&lt;int&gt; conn; conn.reserve 
<a name="l01934"></a>01934       (<a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a>*n_elem[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] + local_weight);
<a name="l01935"></a>01935                                                 
<a name="l01936"></a>01936     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=local_n_levels; level++)
<a name="l01937"></a>01937       {
<a name="l01938"></a>01938         ParallelMesh::element_iterator        it  = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a8ae6ffb939cec26f67bf491a6b6eb9c7">local_level_elements_begin</a>(level);
<a name="l01939"></a>01939         <span class="keyword">const</span> ParallelMesh::element_iterator  end = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab1c7a59e47bf42fe024b6c13a1989256">local_level_elements_end</a>(level);
<a name="l01940"></a>01940 
<a name="l01941"></a>01941         <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01942"></a>01942           {
<a name="l01943"></a>01943             <span class="keyword">const</span> Elem* elem = *it;
<a name="l01944"></a>01944 
<a name="l01945"></a>01945             libmesh_assert (elem != NULL);
<a name="l01946"></a>01946             libmesh_assert (elem-&gt;level() == level);
<a name="l01947"></a>01947             
<a name="l01948"></a>01948             <span class="comment">// We&#39;re not handling unpartitioned elements!</span>
<a name="l01949"></a>01949             libmesh_assert (elem-&gt;processor_id() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l01950"></a>01950 
<a name="l01951"></a>01951             <span class="comment">// Only local elements!</span>
<a name="l01952"></a>01952             libmesh_assert (elem-&gt;processor_id() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l01953"></a>01953 
<a name="l01954"></a>01954             <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#aee4de73229ca234360b6ceed1927391d">Elem::PackedElem::pack</a> (conn, elem);            
<a name="l01955"></a>01955           }
<a name="l01956"></a>01956       } <span class="comment">// ...that was easy.</span>
<a name="l01957"></a>01957 
<a name="l01958"></a>01958     libmesh_assert (conn.size() == 
<a name="l01959"></a>01959       <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a>*n_elem[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] + local_weight);
<a name="l01960"></a>01960 
<a name="l01961"></a>01961     <span class="comment">// Get the size of the connectivity array on each processor</span>
<a name="l01962"></a>01962     std::vector&lt;unsigned int&gt;
<a name="l01963"></a>01963       conn_size   (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01964"></a>01964       conn_offset (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01965"></a>01965     
<a name="l01966"></a>01966     <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">Parallel::allgather</a> (static_cast&lt;unsigned int&gt;(conn.size()), conn_size);
<a name="l01967"></a>01967 
<a name="l01968"></a>01968     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01969"></a>01969       conn_offset[p] = conn_offset[p-1] + conn_size[p-1];    
<a name="l01970"></a>01970     
<a name="l01971"></a>01971     <span class="comment">// Get the element connectivity from all the other processors</span>
<a name="l01972"></a>01972     <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">Parallel::allgather</a> (conn);
<a name="l01973"></a>01973 
<a name="l01974"></a>01974 
<a name="l01975"></a>01975         
<a name="l01976"></a>01976     <span class="comment">// ...and add them to our mesh.</span>
<a name="l01977"></a>01977     <span class="comment">// This is a little tricky.  We need to insure that parents are added before children. </span>
<a name="l01978"></a>01978     <span class="comment">// So we need to add elements level-wise to handle, for example, the case where a child on</span>
<a name="l01979"></a>01979     <span class="comment">// processor [0] has a parent on processor [1].  But we also need to add the elements </span>
<a name="l01980"></a>01980     <span class="comment">// processor-wise so that we can set the processor_id() properly.  </span>
<a name="l01981"></a>01981     <span class="comment">// So, loop on levels/processors</span>
<a name="l01982"></a>01982     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=global_n_levels; level++)
<a name="l01983"></a>01983       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01984"></a>01984         <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="comment">// We&#39;ve already got our</span>
<a name="l01985"></a>01985           {                               <span class="comment">// own local elements!</span>
<a name="l01986"></a>01986             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = conn_offset[p]; <span class="comment">// counter into the conn[] array.</span>
<a name="l01987"></a>01987             
<a name="l01988"></a>01988 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01989"></a>01989 <span class="preprocessor"></span>            <span class="comment">// The first and last global indices are only used for error-checking.</span>
<a name="l01990"></a>01990             <span class="comment">// Avoid declaring them unless asserts are enabled.</span>
<a name="l01991"></a>01991             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01992"></a>01992               first_global_idx = elem_offsets[p],
<a name="l01993"></a>01993               last_global_idx  = first_global_idx + n_elem[p];
<a name="l01994"></a>01994 <span class="preprocessor">#endif</span>
<a name="l01995"></a>01995 <span class="preprocessor"></span>            
<a name="l01996"></a>01996             <span class="comment">// Process each element for processor p.</span>
<a name="l01997"></a>01997             <span class="comment">// Note this must work in the case when conn_size[p] == 0.</span>
<a name="l01998"></a>01998             <span class="keywordflow">while</span> (cnt &lt; (conn_offset[p] + conn_size[p]))
<a name="l01999"></a>01999               {
<a name="l02000"></a>02000                 <span class="comment">// Unpack the element</span>
<a name="l02001"></a>02001                 Elem::PackedElem packed_elem (conn.begin()+cnt);
<a name="l02002"></a>02002 
<a name="l02003"></a>02003                 <span class="comment">// We require contiguous numbering on each processor</span>
<a name="l02004"></a>02004                 <span class="comment">// for elements.</span>
<a name="l02005"></a>02005                 libmesh_assert (packed_elem.id() &gt;= first_global_idx);
<a name="l02006"></a>02006                 libmesh_assert (packed_elem.id()  &lt; last_global_idx);
<a name="l02007"></a>02007 
<a name="l02008"></a>02008 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02009"></a>02009 <span class="preprocessor"></span>                libmesh_assert ((packed_elem.level() == 0) || (packed_elem.parent_id() != -1));
<a name="l02010"></a>02010   
<a name="l02011"></a>02011                 <span class="comment">// Ignore elements not matching the current level.</span>
<a name="l02012"></a>02012                 <span class="keywordflow">if</span> (packed_elem.level() &gt; level) <span class="comment">// skip all entries in the conn array for this element.</span>
<a name="l02013"></a>02013                   cnt += <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + packed_elem.n_nodes();
<a name="l02014"></a>02014 
<a name="l02015"></a>02015                 <span class="keywordflow">else</span>
<a name="l02016"></a>02016 <span class="preprocessor">#endif</span>
<a name="l02017"></a>02017 <span class="preprocessor"></span>                <span class="keywordflow">if</span> (packed_elem.level() &lt; level ||     <span class="comment">// we should already have</span>
<a name="l02018"></a>02018                     (packed_elem.level() == level &amp;&amp;   <span class="comment">// lower level and some</span>
<a name="l02019"></a>02019                      mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.id())))     <span class="comment">// ghost elements</span>
<a name="l02020"></a>02020                   {
<a name="l02021"></a>02021                     <span class="comment">// No need to construct a dummy element of this type</span>
<a name="l02022"></a>02022 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02023"></a>02023 <span class="preprocessor"></span>                    <span class="comment">// The elem information need not be extracted unless asserts are enabled.</span>
<a name="l02024"></a>02024                     <span class="keyword">const</span> Elem* elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.id());
<a name="l02025"></a>02025 <span class="preprocessor">#endif</span>
<a name="l02026"></a>02026 <span class="preprocessor"></span>                    libmesh_assert (elem);
<a name="l02027"></a>02027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02028"></a>02028 <span class="preprocessor"></span>                    libmesh_assert (!elem-&gt;parent() ||
<a name="l02029"></a>02029                                     elem-&gt;parent()-&gt;id() ==
<a name="l02030"></a>02030                                     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(packed_elem.parent_id()));
<a name="l02031"></a>02031                     libmesh_assert (elem-&gt;p_level()           == packed_elem.p_level());
<a name="l02032"></a>02032                     libmesh_assert (elem-&gt;refinement_flag()   == packed_elem.refinement_flag());
<a name="l02033"></a>02033                     libmesh_assert (elem-&gt;p_refinement_flag() == packed_elem.p_refinement_flag());
<a name="l02034"></a>02034 <span class="preprocessor">#endif</span>
<a name="l02035"></a>02035 <span class="preprocessor"></span>                    libmesh_assert (elem-&gt;type()              == packed_elem.type());
<a name="l02036"></a>02036                     libmesh_assert (elem-&gt;subdomain_id()      == packed_elem.subdomain_id());
<a name="l02037"></a>02037                     libmesh_assert (elem-&gt;id()                == packed_elem.id());
<a name="l02038"></a>02038                     libmesh_assert (elem-&gt;n_nodes()           == packed_elem.n_nodes());
<a name="l02039"></a>02039 
<a name="l02040"></a>02040                     cnt += <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + packed_elem.n_nodes();
<a name="l02041"></a>02041                   }
<a name="l02042"></a>02042                 <span class="comment">// Those are the easy cases...</span>
<a name="l02043"></a>02043                 <span class="comment">// now elem_level == level and we don&#39;t have it</span>
<a name="l02044"></a>02044                 <span class="keywordflow">else</span>
<a name="l02045"></a>02045                   {
<a name="l02046"></a>02046                     <span class="comment">// Declare the element we will add</span>
<a name="l02047"></a>02047                     Elem* elem = NULL;
<a name="l02048"></a>02048 
<a name="l02049"></a>02049 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02050"></a>02050 <span class="preprocessor"></span>                    <span class="comment">// Maybe find its parent</span>
<a name="l02051"></a>02051                     <span class="keywordflow">if</span> (level &gt; 0)
<a name="l02052"></a>02052                       {
<a name="l02053"></a>02053                         Elem* my_parent = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(packed_elem.parent_id());
<a name="l02054"></a>02054 
<a name="l02055"></a>02055                         <span class="comment">// If the parent was not previously added, we</span>
<a name="l02056"></a>02056                         <span class="comment">// cannot continue.</span>
<a name="l02057"></a>02057                         <span class="keywordflow">if</span> (my_parent == NULL)
<a name="l02058"></a>02058                           {
<a name="l02059"></a>02059                             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l02060"></a>02060                                           &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l02061"></a>02061                             libmesh_error();
<a name="l02062"></a>02062                           }
<a name="l02063"></a>02063                         
<a name="l02064"></a>02064                         elem = packed_elem.unpack (mesh, my_parent);
<a name="l02065"></a>02065                       }
<a name="l02066"></a>02066                     <span class="keywordflow">else</span>
<a name="l02067"></a>02067                       {
<a name="l02068"></a>02068                         libmesh_assert (packed_elem.parent_id() == -1);
<a name="l02069"></a>02069 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l02070"></a>02070 <span class="preprocessor"></span>                        elem = packed_elem.unpack (mesh);
<a name="l02071"></a>02071 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02072"></a>02072 <span class="preprocessor"></span>                      }
<a name="l02073"></a>02073 <span class="preprocessor">#endif</span>
<a name="l02074"></a>02074 <span class="preprocessor"></span>
<a name="l02075"></a>02075                     <span class="comment">// Good to go.  Add to the mesh.</span>
<a name="l02076"></a>02076                     libmesh_assert (elem);
<a name="l02077"></a>02077                     mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">insert_elem</a>(elem);
<a name="l02078"></a>02078 
<a name="l02079"></a>02079                     libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l02080"></a>02080 
<a name="l02081"></a>02081                     cnt += <a class="code" href="classlibMesh_1_1Elem_1_1PackedElem.php#a0eb18db071d0d6019c21e986895ea685">Elem::PackedElem::header_size</a> + packed_elem.n_nodes();
<a name="l02082"></a>02082                     
<a name="l02083"></a>02083                   } <span class="comment">// end elem_level == level</span>
<a name="l02084"></a>02084               }
<a name="l02085"></a>02085             
<a name="l02086"></a>02086           }   
<a name="l02087"></a>02087 
<a name="l02088"></a>02088     <span class="comment">// Check the result</span>
<a name="l02089"></a>02089     libmesh_assert (global_n_elem == mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>());
<a name="l02090"></a>02090   }
<a name="l02091"></a>02091 
<a name="l02092"></a>02092   <span class="comment">// All done!</span>
<a name="l02093"></a>02093   STOP_LOG (<span class="stringliteral">&quot;allgather_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02094"></a>02094 }
<a name="l02095"></a>02095 
<a name="l02096"></a>02096 
<a name="l02097"></a>02097 
<a name="l02098"></a>02098 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02099"></a>02099 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#aaa030e4082c298eca5efae64dfec69f3">MeshCommunication::allgather_bcs</a> (<span class="keyword">const</span> ParallelMesh&amp; mesh,
<a name="l02100"></a>02100                                        BoundaryInfo&amp; boundary_info)<span class="keyword"> const</span>
<a name="l02101"></a>02101 <span class="keyword"></span>{
<a name="l02102"></a>02102   <span class="comment">// Check for quick return</span>
<a name="l02103"></a>02103   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02104"></a>02104     <span class="keywordflow">return</span>;
<a name="l02105"></a>02105 
<a name="l02106"></a>02106   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02107"></a>02107   parallel_only();
<a name="l02108"></a>02108 
<a name="l02109"></a>02109   START_LOG (<span class="stringliteral">&quot;allgather_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02110"></a>02110 
<a name="l02111"></a>02111   std::vector&lt;int&gt;
<a name="l02112"></a>02112     xfer_elem_bcs,
<a name="l02113"></a>02113     xfer_node_bcs;
<a name="l02114"></a>02114   
<a name="l02115"></a>02115   
<a name="l02116"></a>02116   <span class="comment">// Get the element boundary conditions</span>
<a name="l02117"></a>02117   {    
<a name="l02118"></a>02118     std::vector&lt;unsigned int&gt;       el_id;
<a name="l02119"></a>02119     std::vector&lt;unsigned short int&gt; side_id;
<a name="l02120"></a>02120     std::vector&lt;short int&gt;          <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>;
<a name="l02121"></a>02121     
<a name="l02122"></a>02122     boundary_info.build_side_list (el_id, side_id, bc_id);
<a name="l02123"></a>02123 
<a name="l02124"></a>02124     libmesh_assert (el_id.size() == side_id.size());
<a name="l02125"></a>02125     libmesh_assert (el_id.size() == bc_id.size());
<a name="l02126"></a>02126     
<a name="l02127"></a>02127     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = el_id.size();
<a name="l02128"></a>02128 
<a name="l02129"></a>02129     <span class="comment">// reserve an upper bound for the number of BCs</span>
<a name="l02130"></a>02130     xfer_elem_bcs.reserve(3*n_bcs);
<a name="l02131"></a>02131 
<a name="l02132"></a>02132     <span class="comment">// populate the xfer_elem_bcs list with *local* elements only.</span>
<a name="l02133"></a>02133     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0; bc&lt;n_bcs; bc++)
<a name="l02134"></a>02134       {
<a name="l02135"></a>02135         <span class="keyword">const</span> Elem* elem = mesh.elem(el_id[bc]);
<a name="l02136"></a>02136         
<a name="l02137"></a>02137         <span class="comment">// sanity: be sure that the element returned by mesh.elem() really has id()==el_id[e]</span>
<a name="l02138"></a>02138         libmesh_assert(elem != NULL);
<a name="l02139"></a>02139         libmesh_assert(elem-&gt;id() == el_id[bc]);
<a name="l02140"></a>02140         libmesh_assert(elem-&gt;level() == 0);
<a name="l02141"></a>02141         libmesh_assert(side_id[bc] &lt; elem-&gt;n_sides());
<a name="l02142"></a>02142 
<a name="l02143"></a>02143         <span class="keywordflow">if</span> (elem-&gt;processor_id() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l02144"></a>02144           {
<a name="l02145"></a>02145             xfer_elem_bcs.push_back(el_id[bc]);
<a name="l02146"></a>02146             xfer_elem_bcs.push_back(side_id[bc]);
<a name="l02147"></a>02147             xfer_elem_bcs.push_back(bc_id[bc]);
<a name="l02148"></a>02148           }
<a name="l02149"></a>02149       }
<a name="l02150"></a>02150   
<a name="l02151"></a>02151   } <span class="comment">// done with element boundary conditions</span>
<a name="l02152"></a>02152 
<a name="l02153"></a>02153 
<a name="l02154"></a>02154   <span class="comment">// Get the nodal boundary conditions</span>
<a name="l02155"></a>02155   {
<a name="l02156"></a>02156     std::vector&lt;unsigned int&gt; node_id;
<a name="l02157"></a>02157     std::vector&lt;short int&gt;    <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>;
<a name="l02158"></a>02158     
<a name="l02159"></a>02159     boundary_info.build_node_list (node_id, bc_id);
<a name="l02160"></a>02160 
<a name="l02161"></a>02161     libmesh_assert (node_id.size() == bc_id.size());
<a name="l02162"></a>02162 
<a name="l02163"></a>02163     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = node_id.size();
<a name="l02164"></a>02164 
<a name="l02165"></a>02165     <span class="comment">// reserve an upper bound for the number of BCs</span>
<a name="l02166"></a>02166     xfer_node_bcs.reserve(2*n_bcs);
<a name="l02167"></a>02167 
<a name="l02168"></a>02168     <span class="comment">// populate the xfer_node_bcs witl *local* nodes only</span>
<a name="l02169"></a>02169     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0; bc&lt;n_bcs; bc++)
<a name="l02170"></a>02170       {
<a name="l02171"></a>02171         <span class="keyword">const</span> Node* node = mesh.node_ptr(node_id[bc]);
<a name="l02172"></a>02172         
<a name="l02173"></a>02173         libmesh_assert(node != NULL);
<a name="l02174"></a>02174         libmesh_assert(node-&gt;id() == node_id[bc]);
<a name="l02175"></a>02175 
<a name="l02176"></a>02176         <span class="keywordflow">if</span> (node-&gt;processor_id() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l02177"></a>02177           {
<a name="l02178"></a>02178             xfer_node_bcs.push_back(node_id[bc]);
<a name="l02179"></a>02179             xfer_node_bcs.push_back(bc_id[bc]);
<a name="l02180"></a>02180           }
<a name="l02181"></a>02181       }
<a name="l02182"></a>02182   } <span class="comment">// done with nodal boundary conditions</span>
<a name="l02183"></a>02183 
<a name="l02184"></a>02184 
<a name="l02185"></a>02185   <span class="comment">// The xfer arrays now contain all the information for our</span>
<a name="l02186"></a>02186   <span class="comment">// local bcs, and we are about to get all the information for</span>
<a name="l02187"></a>02187   <span class="comment">// remote bcs.  Go ahead and clear the current boundary_info</span>
<a name="l02188"></a>02188   <span class="comment">// information and rebuild it after we get the remote data.</span>
<a name="l02189"></a>02189   boundary_info.clear();
<a name="l02190"></a>02190   
<a name="l02191"></a>02191   <span class="comment">// Get the boundary condition information from adacent processors</span>
<a name="l02192"></a>02192   <span class="comment">// Insert the elements</span>
<a name="l02193"></a>02193   {
<a name="l02194"></a>02194     <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">Parallel::allgather</a> (xfer_elem_bcs);
<a name="l02195"></a>02195 
<a name="l02196"></a>02196     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = xfer_elem_bcs.size()/3;
<a name="l02197"></a>02197 
<a name="l02198"></a>02198     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0, cnt=0; bc&lt;n_bcs; bc++)
<a name="l02199"></a>02199       {
<a name="l02200"></a>02200         <span class="keyword">const</span> Elem* elem = mesh.elem(xfer_elem_bcs[cnt++]);
<a name="l02201"></a>02201         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side_id = xfer_elem_bcs[cnt++];
<a name="l02202"></a>02202         <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id = xfer_elem_bcs[cnt++];
<a name="l02203"></a>02203 
<a name="l02204"></a>02204         boundary_info.add_side (elem, side_id, bc_id);  
<a name="l02205"></a>02205       }
<a name="l02206"></a>02206 
<a name="l02207"></a>02207     <span class="comment">// no need for this any more</span>
<a name="l02208"></a>02208     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (xfer_elem_bcs);
<a name="l02209"></a>02209   }
<a name="l02210"></a>02210 
<a name="l02211"></a>02211   
<a name="l02212"></a>02212   <span class="comment">// Insert the nodes</span>
<a name="l02213"></a>02213   {
<a name="l02214"></a>02214     <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">Parallel::allgather</a> (xfer_node_bcs);
<a name="l02215"></a>02215 
<a name="l02216"></a>02216     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = xfer_node_bcs.size()/2;
<a name="l02217"></a>02217 
<a name="l02218"></a>02218     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0, cnt=0; bc&lt;n_bcs; bc++)
<a name="l02219"></a>02219       {
<a name="l02220"></a>02220         <span class="keyword">const</span> Node* node = mesh.node_ptr (xfer_node_bcs[cnt++]);
<a name="l02221"></a>02221         <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id = xfer_node_bcs[cnt++];
<a name="l02222"></a>02222 
<a name="l02223"></a>02223         boundary_info.add_node (node, bc_id);
<a name="l02224"></a>02224       }
<a name="l02225"></a>02225  
<a name="l02226"></a>02226     <span class="comment">// no need for this any more</span>
<a name="l02227"></a>02227     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (xfer_node_bcs);
<a name="l02228"></a>02228   }
<a name="l02229"></a>02229 
<a name="l02230"></a>02230  
<a name="l02231"></a>02231 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02232"></a>02232 <span class="preprocessor"></span>  
<a name="l02233"></a>02233   <span class="comment">// Make sure all processors agree on the number of boundary ids.</span>
<a name="l02234"></a>02234   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bc_ids = boundary_info.n_boundary_ids();
<a name="l02235"></a>02235   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_n_bc_ids = n_bc_ids;
<a name="l02236"></a>02236   
<a name="l02237"></a>02237   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a> (global_n_bc_ids);
<a name="l02238"></a>02238   libmesh_assert (n_bc_ids == global_n_bc_ids);
<a name="l02239"></a>02239   
<a name="l02240"></a>02240 <span class="preprocessor">#endif</span>
<a name="l02241"></a>02241 <span class="preprocessor"></span>  
<a name="l02242"></a>02242 
<a name="l02243"></a>02243   STOP_LOG  (<span class="stringliteral">&quot;allgather_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02244"></a>02244 }
<a name="l02245"></a>02245 
<a name="l02246"></a>02246 
<a name="l02247"></a>02247 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l02248"></a>02248 <span class="preprocessor"></span>
<a name="l02249"></a>02249 
<a name="l02250"></a>02250 
<a name="l02251"></a>02251 <span class="comment">// Functor for make_elems_parallel_consistent and</span>
<a name="l02252"></a>02252 <span class="comment">// make_node_ids_parallel_consistent</span>
<a name="l02253"></a>02253 <span class="keyword">namespace </span>{
<a name="l02254"></a>02254 
<a name="l02255"></a>02255 <span class="keyword">struct </span>SyncIds
<a name="l02256"></a>02256 {
<a name="l02257"></a>02257 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> datum;
<a name="l02258"></a>02258 <span class="keyword">typedef</span> void (MeshBase::*renumber_obj)(<span class="keywordtype">unsigned</span> int, <span class="keywordtype">unsigned</span> int);
<a name="l02259"></a>02259 
<a name="l02260"></a>02260 SyncIds(MeshBase &amp;_mesh, renumber_obj _renumberer) :
<a name="l02261"></a>02261   mesh(_mesh),
<a name="l02262"></a>02262   <a class="code" href="mesh__communication_8C.php#a1fdde33ca7868be1762e791eeb834d69">renumber</a>(_renumberer) {}
<a name="l02263"></a>02263 
<a name="l02264"></a><a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">02264</a> MeshBase &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>;
<a name="l02265"></a><a class="code" href="mesh__communication_8C.php#a1fdde33ca7868be1762e791eeb834d69">02265</a> renumber_obj <a class="code" href="mesh__communication_8C.php#a1fdde33ca7868be1762e791eeb834d69">renumber</a>;
<a name="l02266"></a>02266 <span class="comment">// renumber_obj &amp;renumber;</span>
<a name="l02267"></a>02267 
<a name="l02268"></a>02268 <span class="comment">// Find the id of each requested DofObject -</span>
<a name="l02269"></a>02269 <span class="comment">// sync_dofobject_data_by_xyz already did the work for us</span>
<a name="l02270"></a>02270 <span class="keywordtype">void</span> gather_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l02271"></a>02271                   std::vector&lt;datum&gt;&amp; ids_out)
<a name="l02272"></a>02272 {
<a name="l02273"></a>02273   ids_out = ids;
<a name="l02274"></a>02274 }
<a name="l02275"></a>02275 
<a name="l02276"></a>02276 <span class="keywordtype">void</span> act_on_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; old_ids,
<a name="l02277"></a>02277                   std::vector&lt;datum&gt;&amp; new_ids)
<a name="l02278"></a>02278 {
<a name="l02279"></a>02279   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != old_ids.size(); ++i)
<a name="l02280"></a>02280     <span class="keywordflow">if</span> (old_ids[i] != new_ids[i])
<a name="l02281"></a>02281       (mesh.*<a class="code" href="mesh__communication_8C.php#a1fdde33ca7868be1762e791eeb834d69">renumber</a>)(old_ids[i], new_ids[i]);
<a name="l02282"></a>02282 }
<a name="l02283"></a>02283 };
<a name="l02284"></a>02284 }
<a name="l02285"></a>02285 
<a name="l02286"></a>02286 
<a name="l02287"></a>02287 
<a name="l02288"></a>02288 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02289"></a>02289 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a12f81a2283c5629a144fac25019d1241">MeshCommunication::make_node_ids_parallel_consistent</a>
<a name="l02290"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a12f81a2283c5629a144fac25019d1241">02290</a>   (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l02291"></a>02291    <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;loc_map)
<a name="l02292"></a>02292 {
<a name="l02293"></a>02293   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02294"></a>02294   parallel_only();
<a name="l02295"></a>02295 
<a name="l02296"></a>02296   START_LOG (<span class="stringliteral">&quot;make_node_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02297"></a>02297 
<a name="l02298"></a>02298   SyncIds syncids(mesh, &amp;<a class="code" href="classlibMesh_1_1MeshBase.php#afff6be1835b4203202689641bd006aeb">MeshBase::renumber_node</a>);
<a name="l02299"></a>02299   <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cc88801cb0c7534c3c9954da9e5d26f">Parallel::sync_dofobject_data_by_xyz</a>
<a name="l02300"></a>02300     (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(), mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>(),
<a name="l02301"></a>02301      loc_map, syncids);
<a name="l02302"></a>02302 
<a name="l02303"></a>02303   STOP_LOG (<span class="stringliteral">&quot;make_node_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02304"></a>02304 }
<a name="l02305"></a>02305 
<a name="l02306"></a>02306 
<a name="l02307"></a>02307 
<a name="l02308"></a>02308 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02309"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a737da6ee13b781ac7aef37851a99af58">02309</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a737da6ee13b781ac7aef37851a99af58">MeshCommunication::make_elems_parallel_consistent</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l02310"></a>02310 {
<a name="l02311"></a>02311   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02312"></a>02312   parallel_only();
<a name="l02313"></a>02313 
<a name="l02314"></a>02314   START_LOG (<span class="stringliteral">&quot;make_elems_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02315"></a>02315 
<a name="l02316"></a>02316   SyncIds syncids(mesh, &amp;<a class="code" href="classlibMesh_1_1MeshBase.php#aeb6601a6b9c0df36148b41f6a2987c61">MeshBase::renumber_elem</a>);
<a name="l02317"></a>02317   <a class="code" href="namespacelibMesh_1_1Parallel.php#a9673356792a1d29be5012c1b0bbe6520">Parallel::sync_element_data_by_parent_id</a>
<a name="l02318"></a>02318     (mesh, mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(),
<a name="l02319"></a>02319      mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(), syncids);
<a name="l02320"></a>02320 
<a name="l02321"></a>02321   STOP_LOG (<span class="stringliteral">&quot;make_elems_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02322"></a>02322 }
<a name="l02323"></a>02323 
<a name="l02324"></a>02324 
<a name="l02325"></a>02325 
<a name="l02326"></a>02326 <span class="comment">// Functors for make_node_proc_ids_parallel_consistent</span>
<a name="l02327"></a>02327 <span class="keyword">namespace </span>{
<a name="l02328"></a>02328 
<a name="l02329"></a>02329 <span class="keyword">struct </span>SyncProcIds
<a name="l02330"></a>02330 {
<a name="l02331"></a>02331 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> datum;
<a name="l02332"></a>02332 
<a name="l02333"></a>02333 SyncProcIds(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;_mesh) : mesh(_mesh) {}
<a name="l02334"></a>02334 
<a name="l02335"></a>02335 MeshBase &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>;
<a name="l02336"></a>02336 
<a name="l02337"></a>02337 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02338"></a>02338 <span class="keywordtype">void</span> gather_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l02339"></a>02339                   std::vector&lt;datum&gt;&amp; data)
<a name="l02340"></a>02340 {
<a name="l02341"></a>02341   <span class="comment">// Find the processor id of each requested node</span>
<a name="l02342"></a>02342   data.resize(ids.size());
<a name="l02343"></a>02343 
<a name="l02344"></a>02344   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l02345"></a>02345     {
<a name="l02346"></a>02346       <span class="comment">// Look for this point in the mesh</span>
<a name="l02347"></a>02347       Node *node = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(ids[i]);
<a name="l02348"></a>02348 
<a name="l02349"></a>02349       <span class="comment">// We&#39;d better find every node we&#39;re asked for</span>
<a name="l02350"></a>02350       libmesh_assert (node);
<a name="l02351"></a>02351 
<a name="l02352"></a>02352       <span class="comment">// Return the node&#39;s correct processor id,</span>
<a name="l02353"></a>02353       data[i] = node-&gt;processor_id();
<a name="l02354"></a>02354     }
<a name="l02355"></a>02355 }
<a name="l02356"></a>02356 
<a name="l02357"></a>02357 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02358"></a>02358 <span class="keywordtype">void</span> act_on_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l02359"></a>02359                   std::vector&lt;datum&gt; proc_ids)
<a name="l02360"></a>02360 {
<a name="l02361"></a>02361   <span class="comment">// Set the ghost node processor ids we&#39;ve now been informed of</span>
<a name="l02362"></a>02362   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l02363"></a>02363     {
<a name="l02364"></a>02364       Node *node = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(ids[i]);
<a name="l02365"></a>02365       node-&gt;processor_id() = proc_ids[i];
<a name="l02366"></a>02366     }
<a name="l02367"></a>02367 }
<a name="l02368"></a>02368 };
<a name="l02369"></a>02369 }
<a name="l02370"></a>02370 
<a name="l02371"></a>02371 
<a name="l02372"></a>02372 
<a name="l02373"></a>02373 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02374"></a>02374 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a6343f61646db756556414516a068aa4e">MeshCommunication::make_node_proc_ids_parallel_consistent</a>
<a name="l02375"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a6343f61646db756556414516a068aa4e">02375</a>   (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l02376"></a>02376    <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a>&amp; loc_map)
<a name="l02377"></a>02377 {
<a name="l02378"></a>02378   START_LOG (<span class="stringliteral">&quot;make_node_proc_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02379"></a>02379 
<a name="l02380"></a>02380   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02381"></a>02381   parallel_only();
<a name="l02382"></a>02382 
<a name="l02383"></a>02383   <span class="comment">// When this function is called, each section of a parallelized mesh</span>
<a name="l02384"></a>02384   <span class="comment">// should be in the following state:</span>
<a name="l02385"></a>02385   <span class="comment">//</span>
<a name="l02386"></a>02386   <span class="comment">// All nodes should have the exact same physical location on every</span>
<a name="l02387"></a>02387   <span class="comment">// processor where they exist.</span>
<a name="l02388"></a>02388   <span class="comment">//</span>
<a name="l02389"></a>02389   <span class="comment">// Local nodes should have unique authoritative ids,</span>
<a name="l02390"></a>02390   <span class="comment">// and processor ids consistent with all processors which own</span>
<a name="l02391"></a>02391   <span class="comment">// an element touching them.</span>
<a name="l02392"></a>02392   <span class="comment">//</span>
<a name="l02393"></a>02393   <span class="comment">// Ghost nodes touching local elements should have processor ids</span>
<a name="l02394"></a>02394   <span class="comment">// consistent with all processors which own an element touching</span>
<a name="l02395"></a>02395   <span class="comment">// them.</span>
<a name="l02396"></a>02396   
<a name="l02397"></a>02397   SyncProcIds sync(mesh);
<a name="l02398"></a>02398   <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cc88801cb0c7534c3c9954da9e5d26f">Parallel::sync_dofobject_data_by_xyz</a>
<a name="l02399"></a>02399     (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(), mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>(), loc_map, sync);
<a name="l02400"></a>02400 
<a name="l02401"></a>02401   STOP_LOG (<span class="stringliteral">&quot;make_node_proc_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02402"></a>02402 }
<a name="l02403"></a>02403 
<a name="l02404"></a>02404 
<a name="l02405"></a>02405 
<a name="l02406"></a>02406 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02407"></a>02407 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a4267fefd3ddfeead0f25be8fb9918af8">MeshCommunication::make_nodes_parallel_consistent</a>
<a name="l02408"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a4267fefd3ddfeead0f25be8fb9918af8">02408</a>   (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l02409"></a>02409    <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;loc_map)
<a name="l02410"></a>02410 {
<a name="l02411"></a>02411   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02412"></a>02412   parallel_only();
<a name="l02413"></a>02413 
<a name="l02414"></a>02414   <span class="comment">// Create the loc_map if it hasn&#39;t been done already</span>
<a name="l02415"></a>02415   <span class="keywordtype">bool</span> need_map_update = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>() != mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>() &amp;&amp; 
<a name="l02416"></a>02416                           loc_map.<a class="code" href="classlibMesh_1_1LocationMap.php#ae5e9f2ba3dd8d494e6308459e2bba569">empty</a>());
<a name="l02417"></a>02417   <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(need_map_update);
<a name="l02418"></a>02418 
<a name="l02419"></a>02419   <span class="keywordflow">if</span> (need_map_update)
<a name="l02420"></a>02420     loc_map.<a class="code" href="classlibMesh_1_1LocationMap.php#abadcd2f57010852e4d343171bf225cd6">init</a>(mesh);
<a name="l02421"></a>02421 
<a name="l02422"></a>02422   <span class="comment">// When this function is called, each section of a parallelized mesh</span>
<a name="l02423"></a>02423   <span class="comment">// should be in the following state:</span>
<a name="l02424"></a>02424   <span class="comment">//</span>
<a name="l02425"></a>02425   <span class="comment">// All nodes should have the exact same physical location on every</span>
<a name="l02426"></a>02426   <span class="comment">// processor where they exist.</span>
<a name="l02427"></a>02427   <span class="comment">//</span>
<a name="l02428"></a>02428   <span class="comment">// Local nodes should have unique authoritative ids,</span>
<a name="l02429"></a>02429   <span class="comment">// and processor ids consistent with all processors which own</span>
<a name="l02430"></a>02430   <span class="comment">// an element touching them.</span>
<a name="l02431"></a>02431   <span class="comment">//</span>
<a name="l02432"></a>02432   <span class="comment">// Ghost nodes touching local elements should have processor ids</span>
<a name="l02433"></a>02433   <span class="comment">// consistent with all processors which own an element touching</span>
<a name="l02434"></a>02434   <span class="comment">// them.</span>
<a name="l02435"></a>02435   <span class="comment">//</span>
<a name="l02436"></a>02436   <span class="comment">// Ghost nodes should have ids which are either already correct</span>
<a name="l02437"></a>02437   <span class="comment">// or which are in the &quot;unpartitioned&quot; id space.</span>
<a name="l02438"></a>02438 
<a name="l02439"></a>02439   <span class="comment">// First, let&#39;s sync up processor ids.  Some of these processor ids</span>
<a name="l02440"></a>02440   <span class="comment">// may be &quot;wrong&quot; from coarsening, but they&#39;re right in the sense</span>
<a name="l02441"></a>02441   <span class="comment">// that they&#39;ll tell us who has the authoritative dofobject ids for</span>
<a name="l02442"></a>02442   <span class="comment">// each node.</span>
<a name="l02443"></a>02443   this-&gt;make_node_proc_ids_parallel_consistent(mesh, loc_map);
<a name="l02444"></a>02444 
<a name="l02445"></a>02445   <span class="comment">// Second, sync up dofobject ids.</span>
<a name="l02446"></a>02446   this-&gt;make_node_ids_parallel_consistent(mesh, loc_map);
<a name="l02447"></a>02447 
<a name="l02448"></a>02448   <span class="comment">// Finally, correct the processor ids to make DofMap happy</span>
<a name="l02449"></a>02449   <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae41cec551d5e6a5502564b01056512d3">MeshTools::correct_node_proc_ids</a>(mesh, loc_map);
<a name="l02450"></a>02450 }
<a name="l02451"></a>02451 
<a name="l02452"></a>02452 
<a name="l02453"></a>02453 
<a name="l02454"></a>02454 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02455"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a4a0107f13a8af6e904a6067b19d4f5be">02455</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a4a0107f13a8af6e904a6067b19d4f5be">MeshCommunication::delete_remote_elements</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; mesh, <span class="keyword">const</span> std::set&lt;Elem *&gt; &amp; extra_ghost_elem_ids)<span class="keyword"> const</span>
<a name="l02456"></a>02456 <span class="keyword"></span>{
<a name="l02457"></a>02457   <span class="comment">// The mesh should know it&#39;s about to be parallelized</span>
<a name="l02458"></a>02458   libmesh_assert (!mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>());
<a name="l02459"></a>02459 
<a name="l02460"></a>02460   START_LOG(<span class="stringliteral">&quot;delete_remote_elements()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02461"></a>02461 
<a name="l02462"></a>02462   <span class="comment">// FIXME - should these be &quot;unsorted_set&quot;s?  O(N) is O(N)...</span>
<a name="l02463"></a>02463   std::vector&lt;bool&gt; local_nodes(mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l02464"></a>02464   std::vector&lt;bool&gt; semilocal_elems(mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>(), <span class="keyword">false</span>);
<a name="l02465"></a>02465 
<a name="l02466"></a>02466   <span class="comment">// We don&#39;t want to delete any element that shares a node</span>
<a name="l02467"></a>02467   <span class="comment">// with or is an ancestor of a local element.</span>
<a name="l02468"></a>02468   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> l_elem_it = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a7939ec2e4cd98e1895f9194a1c7d63f7">local_elements_begin</a>(),
<a name="l02469"></a>02469                                    l_end     = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a66975b20577e03ae982e7a500c60bce3">local_elements_end</a>();
<a name="l02470"></a>02470   <span class="keywordflow">for</span> (; l_elem_it != l_end; ++l_elem_it)
<a name="l02471"></a>02471     {
<a name="l02472"></a>02472       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *l_elem_it;
<a name="l02473"></a>02473       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l02474"></a>02474         local_nodes[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] = <span class="keyword">true</span>;
<a name="l02475"></a>02475       <span class="keywordflow">while</span> (elem)
<a name="l02476"></a>02476         {
<a name="l02477"></a>02477           semilocal_elems[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = <span class="keyword">true</span>;
<a name="l02478"></a>02478           elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l02479"></a>02479         }
<a name="l02480"></a>02480     }
<a name="l02481"></a>02481 
<a name="l02482"></a>02482   <span class="comment">// We don&#39;t want to delete any element that shares a node</span>
<a name="l02483"></a>02483   <span class="comment">// with or is an ancestor of an unpartitioned element either.</span>
<a name="l02484"></a>02484   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l02485"></a>02485     u_elem_it = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a118989a5196f5c3a3ba79bea01966c6d">unpartitioned_elements_begin</a>(),
<a name="l02486"></a>02486     u_end     = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac34a0c2b38beb146284f0462a13508d4">unpartitioned_elements_end</a>();
<a name="l02487"></a>02487   
<a name="l02488"></a>02488   <span class="keywordflow">for</span> (; u_elem_it != u_end; ++u_elem_it)
<a name="l02489"></a>02489     {
<a name="l02490"></a>02490       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *u_elem_it;
<a name="l02491"></a>02491       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l02492"></a>02492         local_nodes[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] = <span class="keyword">true</span>;
<a name="l02493"></a>02493       <span class="keywordflow">while</span> (elem)
<a name="l02494"></a>02494         {
<a name="l02495"></a>02495           semilocal_elems[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = <span class="keyword">true</span>;
<a name="l02496"></a>02496           elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l02497"></a>02497         }
<a name="l02498"></a>02498     }
<a name="l02499"></a>02499 
<a name="l02500"></a>02500   <span class="comment">// Flag all the elements that share nodes with</span>
<a name="l02501"></a>02501   <span class="comment">// local and unpartitioned elements, along with their ancestors</span>
<a name="l02502"></a>02502   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> nl_elem_it = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#abb1e3a037f026da07015778658d34149">not_local_elements_begin</a>(),
<a name="l02503"></a>02503                              nl_end     = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a470683e7ff9f8e2d80648e119d92a4b3">not_local_elements_end</a>();
<a name="l02504"></a>02504   <span class="keywordflow">for</span> (; nl_elem_it != nl_end; ++nl_elem_it)
<a name="l02505"></a>02505     {
<a name="l02506"></a>02506       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *nl_elem_it;
<a name="l02507"></a>02507       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l02508"></a>02508         <span class="keywordflow">if</span> (local_nodes[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)])
<a name="l02509"></a>02509           {
<a name="l02510"></a>02510             <span class="keywordflow">while</span> (elem)
<a name="l02511"></a>02511               {
<a name="l02512"></a>02512                 semilocal_elems[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = <span class="keyword">true</span>;
<a name="l02513"></a>02513                 elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l02514"></a>02514               }
<a name="l02515"></a>02515             <span class="keywordflow">break</span>;
<a name="l02516"></a>02516           }
<a name="l02517"></a>02517     }
<a name="l02518"></a>02518 
<a name="l02519"></a>02519   <span class="comment">// Don&#39;t delete elements that we were explicitly told not to</span>
<a name="l02520"></a>02520   <span class="keywordflow">for</span>(std::set&lt;Elem *&gt;::iterator it = extra_ghost_elem_ids.begin();
<a name="l02521"></a>02521       it != extra_ghost_elem_ids.end();
<a name="l02522"></a>02522       ++it)
<a name="l02523"></a>02523     semilocal_elems[(*it)-&gt;id()] = <span class="keyword">true</span>;
<a name="l02524"></a>02524 
<a name="l02525"></a>02525   <span class="comment">// Delete all the elements we have no reason to save,</span>
<a name="l02526"></a>02526   <span class="comment">// starting with the most refined so that the mesh</span>
<a name="l02527"></a>02527   <span class="comment">// is valid at all intermediate steps</span>
<a name="l02528"></a>02528   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_levels = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">MeshTools::n_levels</a>(mesh);
<a name="l02529"></a>02529 
<a name="l02530"></a>02530   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l = n_levels - 1; l &gt;= 0; --l)
<a name="l02531"></a>02531     {
<a name="l02532"></a>02532       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> lev_elem_it = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab520fdc54337d02d6c15e5e56cc40bec">level_elements_begin</a>(l),
<a name="l02533"></a>02533                                  lev_end     = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab035ffb9897f365a2d907f93f7ebb7d2">level_elements_end</a>(l);
<a name="l02534"></a>02534       <span class="keywordflow">for</span> (; lev_elem_it != lev_end; ++lev_elem_it)
<a name="l02535"></a>02535         {
<a name="l02536"></a>02536           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *lev_elem_it;
<a name="l02537"></a>02537           libmesh_assert (elem);
<a name="l02538"></a>02538           <span class="keywordflow">if</span> (!semilocal_elems[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()])
<a name="l02539"></a>02539             {
<a name="l02540"></a>02540               <span class="comment">// Make sure we don&#39;t leave any invalid pointers</span>
<a name="l02541"></a>02541               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a975ab6f3e93964a1c30821c3a97baecb">make_links_to_me_remote</a>();
<a name="l02542"></a>02542 
<a name="l02543"></a>02543               <span class="comment">// delete_elem doesn&#39;t currently invalidate element</span>
<a name="l02544"></a>02544               <span class="comment">// iterators... that had better not change</span>
<a name="l02545"></a>02545               mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">delete_elem</a>(elem);
<a name="l02546"></a>02546             }
<a name="l02547"></a>02547         }
<a name="l02548"></a>02548     }
<a name="l02549"></a>02549 
<a name="l02550"></a>02550   STOP_LOG(<span class="stringliteral">&quot;delete_remote_elements()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02551"></a>02551 
<a name="l02552"></a>02552   <span class="comment">// Now make sure the containers actually shrink - strip</span>
<a name="l02553"></a>02553   <span class="comment">// any newly-created NULL voids out of the element array</span>
<a name="l02554"></a>02554   mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a453795c7436d377ed4fc99b6905c363a">renumber_nodes_and_elements</a>();
<a name="l02555"></a>02555 }
<a name="l02556"></a>02556 
<a name="l02557"></a>02557 
<a name="l02558"></a>02558 
<a name="l02559"></a>02559 
<a name="l02560"></a>02560 <span class="comment">// // Pack all this information into one communication to avoid two latency hits</span>
<a name="l02561"></a>02561 <span class="comment">// // For each element it is of the form</span>
<a name="l02562"></a>02562 <span class="comment">// // [ level p_level r_flag p_flag etype subdomain_id </span>
<a name="l02563"></a>02563 <span class="comment">// //   self_ID parent_ID which_child node_0 node_1 ... node_n]</span>
<a name="l02564"></a>02564 <span class="comment">// // We cannot use unsigned int because parent_ID can be negative</span>
<a name="l02565"></a>02565 <span class="comment">// void MeshCommunication::pack_element (std::vector&lt;int&gt; &amp;conn, const Elem* elem) const</span>
<a name="l02566"></a>02566 <span class="comment">// {</span>
<a name="l02567"></a>02567 <span class="comment">//   libmesh_assert (elem != NULL);</span>
<a name="l02568"></a>02568 
<a name="l02569"></a>02569 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02570"></a>02570 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;level()));</span>
<a name="l02571"></a>02571 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;p_level()));</span>
<a name="l02572"></a>02572 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;refinement_flag()));</span>
<a name="l02573"></a>02573 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;p_refinement_flag()));</span>
<a name="l02574"></a>02574 <span class="comment">// #endif</span>
<a name="l02575"></a>02575 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;type()));</span>
<a name="l02576"></a>02576 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;processor_id()));</span>
<a name="l02577"></a>02577 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;subdomain_id()));</span>
<a name="l02578"></a>02578 <span class="comment">//   conn.push_back (elem-&gt;id());</span>
<a name="l02579"></a>02579                 
<a name="l02580"></a>02580 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02581"></a>02581 <span class="comment">//   // use parent_ID of -1 to indicate a level 0 element</span>
<a name="l02582"></a>02582 <span class="comment">//   if (elem-&gt;level() == 0)</span>
<a name="l02583"></a>02583 <span class="comment">//     {</span>
<a name="l02584"></a>02584 <span class="comment">//       conn.push_back(-1);</span>
<a name="l02585"></a>02585 <span class="comment">//       conn.push_back(-1);</span>
<a name="l02586"></a>02586 <span class="comment">//     }</span>
<a name="l02587"></a>02587 <span class="comment">//   else</span>
<a name="l02588"></a>02588 <span class="comment">//     {</span>
<a name="l02589"></a>02589 <span class="comment">//       conn.push_back(elem-&gt;parent()-&gt;id());</span>
<a name="l02590"></a>02590 <span class="comment">//       conn.push_back(elem-&gt;parent()-&gt;which_child_am_i(elem));</span>
<a name="l02591"></a>02591 <span class="comment">//     }</span>
<a name="l02592"></a>02592 <span class="comment">// #endif</span>
<a name="l02593"></a>02593   
<a name="l02594"></a>02594 <span class="comment">//   for (unsigned int n=0; n&lt;elem-&gt;n_nodes(); n++)</span>
<a name="l02595"></a>02595 <span class="comment">//     conn.push_back (elem-&gt;node(n));          </span>
<a name="l02596"></a>02596 <span class="comment">// }</span>
<a name="l02597"></a>02597 
<a name="l02598"></a>02598 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
