<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_generation.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__generation_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_generation.C 4066 2010-10-27 16:45:23Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__generation_8h.php">mesh_generation.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="comment">// #include &quot;elem.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge2_8h.php">edge_edge2.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge4_8h.php">edge_edge4.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="face__quad8_8h.php">face_quad8.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="face__quad9_8h.php">face_quad9.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex8_8h.php">cell_hex8.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex20_8h.php">cell_hex20.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex27_8h.php">cell_hex27.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism6_8h.php">cell_prism6.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism15_8h.php">cell_prism15.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism18_8h.php">cell_prism18.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="cell__pyramid5_8h.php">cell_pyramid5.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;<a class="code" href="sphere_8h.php">sphere.h</a>&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &quot;<a class="code" href="mesh__modification_8h.php">mesh_modification.h</a>&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;<a class="code" href="mesh__smoother__laplace_8h.php">mesh_smoother_laplace.h</a>&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &quot;<a class="code" href="node__elem_8h.php">node_elem.h</a>&quot;</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="keyword">namespace </span>libMesh
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php">00057</a> <span class="keyword">namespace </span>MeshTools {
<a name="l00058"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php">00058</a>   <span class="keyword">namespace </span>Generation {
<a name="l00059"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php">00059</a>     <span class="keyword">namespace </span>Private {
<a name="l00067"></a>00067       <span class="keyword">inline</span>
<a name="l00068"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">00068</a>       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00069"></a>00069                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00070"></a>00070                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00071"></a>00071                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00072"></a>00072       {
<a name="l00073"></a>00073         <span class="keywordflow">switch</span>(type)
<a name="l00074"></a>00074           {
<a name="l00075"></a>00075           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00076"></a>00076           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00077"></a>00077           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00078"></a>00078             {
<a name="l00079"></a>00079               <span class="keywordflow">return</span> i + j*(nx+1);
<a name="l00080"></a>00080               <span class="keywordflow">break</span>;
<a name="l00081"></a>00081             }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00084"></a>00084           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00085"></a>00085           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00086"></a>00086             {
<a name="l00087"></a>00087               <span class="keywordflow">return</span> i + j*(2*nx+1);
<a name="l00088"></a>00088               <span class="keywordflow">break</span>;
<a name="l00089"></a>00089             }
<a name="l00090"></a>00090           
<a name="l00091"></a>00091           <span class="keywordflow">default</span>:
<a name="l00092"></a>00092             {
<a name="l00093"></a>00093               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 2D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00094"></a>00094               libmesh_error();
<a name="l00095"></a>00095             }
<a name="l00096"></a>00096           }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098         <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00099"></a>00099       }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     
<a name="l00103"></a>00103       <span class="comment">// Same as the function above, but for 3D elements</span>
<a name="l00104"></a>00104       <span class="keyword">inline</span>
<a name="l00105"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#a60a1e6bf9d761f534ae5ac1d466d8fcb">00105</a>       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00106"></a>00106                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00107"></a>00107                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny,
<a name="l00108"></a>00108                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00109"></a>00109                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00110"></a>00110                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)
<a name="l00111"></a>00111       {
<a name="l00112"></a>00112         <span class="keywordflow">switch</span>(type)
<a name="l00113"></a>00113           {
<a name="l00114"></a>00114           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00115"></a>00115           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00116"></a>00116           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00117"></a>00117             {
<a name="l00118"></a>00118               <span class="keywordflow">return</span> i + (nx+1)*(j + k*(ny+1));
<a name="l00119"></a>00119               <span class="keywordflow">break</span>;
<a name="l00120"></a>00120             }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00123"></a>00123           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00124"></a>00124           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:  <span class="comment">// TET4&#39;s are created from an initial HEX27 discretization</span>
<a name="l00125"></a>00125           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>: <span class="comment">// TET10&#39;s are created from an initial HEX27 discretization</span>
<a name="l00126"></a>00126           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>: <span class="comment">// PYRAMID5&#39;s are created from an initial HEX27 discretization</span>
<a name="l00127"></a>00127           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00128"></a>00128           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00129"></a>00129             {
<a name="l00130"></a>00130               <span class="keywordflow">return</span> i + (2*nx+1)*(j + k*(2*ny+1));
<a name="l00131"></a>00131               <span class="keywordflow">break</span>;
<a name="l00132"></a>00132             }
<a name="l00133"></a>00133           
<a name="l00134"></a>00134           <span class="keywordflow">default</span>:
<a name="l00135"></a>00135             {
<a name="l00136"></a>00136               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00137"></a>00137               libmesh_error();
<a name="l00138"></a>00138             }
<a name="l00139"></a>00139           }
<a name="l00140"></a>00140       
<a name="l00141"></a>00141         <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00142"></a>00142       }
<a name="l00143"></a>00143     } <span class="comment">// namespace Private</span>
<a name="l00144"></a>00144   } <span class="comment">// namespace Generation</span>
<a name="l00145"></a>00145 } <span class="comment">// namespace MeshTools</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00148"></a>00148 <span class="comment">// MeshTools::Generation function for mesh generation</span>
<a name="l00149"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#adc26f45af62fb628158c7585d4171d01">00149</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#adc26f45af62fb628158c7585d4171d01">MeshTools::Generation::build_cube</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00150"></a>00150                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00151"></a>00151                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny,
<a name="l00152"></a>00152                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nz,
<a name="l00153"></a>00153                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax,
<a name="l00154"></a>00154                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax,
<a name="l00155"></a>00155                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zmin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zmax,
<a name="l00156"></a>00156                                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00157"></a>00157                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid)
<a name="l00158"></a>00158 {
<a name="l00159"></a>00159   START_LOG(<span class="stringliteral">&quot;build_cube()&quot;</span>, <span class="stringliteral">&quot;MeshTools::Generation&quot;</span>);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="comment">// Declare that we are using the indexing utility routine</span>
<a name="l00162"></a>00162   <span class="comment">// in the &quot;Private&quot; part of our current namespace.  If this doesn&#39;t</span>
<a name="l00163"></a>00163   <span class="comment">// work in GCC 2.95.3 we can either remove it or stop supporting</span>
<a name="l00164"></a>00164   <span class="comment">// 2.95.3 altogether.</span>
<a name="l00165"></a>00165   <span class="comment">// Changing this to import the whole namespace... just importing idx</span>
<a name="l00166"></a>00166   <span class="comment">// causes an internal compiler error for Intel Compiler 11.0 on Linux</span>
<a name="l00167"></a>00167   <span class="comment">// in debug mode.</span>
<a name="l00168"></a>00168   <span class="keyword">using namespace </span>MeshTools::Generation::Private;
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <span class="comment">// Clear the mesh and start from scratch</span>
<a name="l00171"></a>00171   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">if</span> (nz != 0)
<a name="l00174"></a>00174     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(3);
<a name="l00175"></a>00175   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (ny != 0)
<a name="l00176"></a>00176     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(2);
<a name="l00177"></a>00177   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nx != 0)
<a name="l00178"></a>00178     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(1);
<a name="l00179"></a>00179   <span class="keywordflow">else</span>
<a name="l00180"></a>00180     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(0);
<a name="l00181"></a>00181   
<a name="l00182"></a>00182   <span class="keywordflow">switch</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>())
<a name="l00183"></a>00183     {
<a name="l00184"></a>00184       <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00185"></a>00185       <span class="comment">// Build a 0D point </span>
<a name="l00186"></a>00186     <span class="keywordflow">case</span> 0:
<a name="l00187"></a>00187       {
<a name="l00188"></a>00188         libmesh_assert (nx == 0);
<a name="l00189"></a>00189         libmesh_assert (ny == 0);
<a name="l00190"></a>00190         libmesh_assert (nz == 0);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192         libmesh_assert (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a> || type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194         <span class="comment">// Build one nodal element for the mesh</span>
<a name="l00195"></a>00195         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0, 0, 0), 0);
<a name="l00196"></a>00196         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1NodeElem.php">NodeElem</a>);
<a name="l00197"></a>00197         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(0);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199         <span class="keywordflow">break</span>;
<a name="l00200"></a>00200       }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204       <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00205"></a>00205       <span class="comment">// Build a 1D line</span>
<a name="l00206"></a>00206     <span class="keywordflow">case</span> 1:      
<a name="l00207"></a>00207       {
<a name="l00208"></a>00208         libmesh_assert (nx != 0);
<a name="l00209"></a>00209         libmesh_assert (ny == 0);
<a name="l00210"></a>00210         libmesh_assert (nz == 0);
<a name="l00211"></a>00211         libmesh_assert (xmin &lt; xmax);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213         <span class="comment">// Reserve elements</span>
<a name="l00214"></a>00214         <span class="keywordflow">switch</span> (type)
<a name="l00215"></a>00215           {
<a name="l00216"></a>00216           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00217"></a>00217           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00218"></a>00218           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00219"></a>00219           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00220"></a>00220             {
<a name="l00221"></a>00221               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a> (nx);
<a name="l00222"></a>00222               <span class="keywordflow">break</span>;
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225           <span class="keywordflow">default</span>:
<a name="l00226"></a>00226             {
<a name="l00227"></a>00227               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 1D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00228"></a>00228               libmesh_error();
<a name="l00229"></a>00229             }
<a name="l00230"></a>00230           }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232         <span class="comment">// Reserve nodes</span>
<a name="l00233"></a>00233         <span class="keywordflow">switch</span> (type)
<a name="l00234"></a>00234           {
<a name="l00235"></a>00235           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00236"></a>00236           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00237"></a>00237             {
<a name="l00238"></a>00238               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(nx+1);
<a name="l00239"></a>00239               <span class="keywordflow">break</span>;
<a name="l00240"></a>00240             }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00243"></a>00243             {
<a name="l00244"></a>00244               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(2*nx+1);
<a name="l00245"></a>00245               <span class="keywordflow">break</span>;
<a name="l00246"></a>00246             }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00249"></a>00249             {
<a name="l00250"></a>00250               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(3*nx+1);
<a name="l00251"></a>00251               <span class="keywordflow">break</span>;
<a name="l00252"></a>00252             }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254           <span class="keywordflow">default</span>:
<a name="l00255"></a>00255             {
<a name="l00256"></a>00256               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 1D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00257"></a>00257               libmesh_error();
<a name="l00258"></a>00258             }
<a name="l00259"></a>00259           }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262         <span class="comment">// Build the nodes, depends on whether we&#39;re using linears, </span>
<a name="l00263"></a>00263         <span class="comment">// quadratics or cubics and whether using uniform grid or Gauss-Lobatto</span>
<a name="l00264"></a>00264         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = 0;
<a name="l00265"></a>00265         <span class="keywordflow">switch</span>(type)
<a name="l00266"></a>00266         {
<a name="l00267"></a>00267           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00268"></a>00268           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00269"></a>00269             {
<a name="l00270"></a>00270               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=nx; i++)
<a name="l00271"></a>00271               {
<a name="l00272"></a>00272                 <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00273"></a>00273                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0.5*(std::cos(<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>*static_cast&lt;Real&gt;(nx-i)/static_cast&lt;Real&gt;(nx))+1.0),
<a name="l00274"></a>00274                         0, 
<a name="l00275"></a>00275                         0), node_id++);
<a name="l00276"></a>00276                 <span class="keywordflow">else</span>
<a name="l00277"></a>00277                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(nx), 
<a name="l00278"></a>00278                         0, 
<a name="l00279"></a>00279                         0), node_id++);
<a name="l00280"></a>00280               }
<a name="l00281"></a>00281               <span class="keywordflow">break</span>;
<a name="l00282"></a>00282             }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00285"></a>00285             {
<a name="l00286"></a>00286               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=2*nx; i++)
<a name="l00287"></a>00287               {
<a name="l00288"></a>00288                 <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00289"></a>00289                 {
<a name="l00290"></a>00290                   <span class="comment">// The x location of the point.</span>
<a name="l00291"></a>00291                   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x=0.;
<a name="l00292"></a>00292 
<a name="l00293"></a>00293                   <span class="comment">// Shortcut variable</span>
<a name="l00294"></a>00294                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296                   <span class="comment">// Shortcut quantities (do not depend on i)</span>
<a name="l00297"></a>00297                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> c = std::cos( pi*i / static_cast&lt;Real&gt;(2*nx) );
<a name="l00298"></a>00298 
<a name="l00299"></a>00299                   <span class="comment">// If i is even, compute a normal Gauss-Lobatto point</span>
<a name="l00300"></a>00300                   <span class="keywordflow">if</span> (i%2 == 0)
<a name="l00301"></a>00301                     x = 0.5*(1.0 - c);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303                   <span class="comment">// Otherwise, it is the average of the previous and next points</span>
<a name="l00304"></a>00304                   <span class="keywordflow">else</span>
<a name="l00305"></a>00305                   {
<a name="l00306"></a>00306                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cmin = std::cos( pi*(i-1) / static_cast&lt;Real&gt;(2*nx) );
<a name="l00307"></a>00307                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cmax = std::cos( pi*(i+1) / static_cast&lt;Real&gt;(2*nx) );
<a name="l00308"></a>00308                     
<a name="l00309"></a>00309                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin = 0.5*(1.0 - cmin);
<a name="l00310"></a>00310                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax = 0.5*(1.0 - cmax);
<a name="l00311"></a>00311                     x = 0.5*(xmin + xmax);
<a name="l00312"></a>00312                   }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(x,0.,0.), node_id++);
<a name="l00315"></a>00315                 }
<a name="l00316"></a>00316                 <span class="keywordflow">else</span>
<a name="l00317"></a>00317                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(2*nx),
<a name="l00318"></a>00318                         0,
<a name="l00319"></a>00319                         0), node_id++);
<a name="l00320"></a>00320               }
<a name="l00321"></a>00321               <span class="keywordflow">break</span>;
<a name="l00322"></a>00322             }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00325"></a>00325             {
<a name="l00326"></a>00326               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=3*nx; i++)
<a name="l00327"></a>00327               {
<a name="l00328"></a>00328                 <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00329"></a>00329                 {
<a name="l00330"></a>00330                   <span class="comment">// The x location of the point</span>
<a name="l00331"></a>00331                   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x=0.;
<a name="l00332"></a>00332                   
<a name="l00333"></a>00333                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>;
<a name="l00334"></a>00334 
<a name="l00335"></a>00335                   <span class="comment">// Shortcut quantities</span>
<a name="l00336"></a>00336                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> c = std::cos( pi*i / static_cast&lt;Real&gt;(3*nx) );
<a name="l00337"></a>00337 
<a name="l00338"></a>00338                   <span class="comment">// If i is multiple of 3, compute a normal Gauss-Lobatto point</span>
<a name="l00339"></a>00339                   <span class="keywordflow">if</span> (i%3 == 0)
<a name="l00340"></a>00340                     x = 0.5*(1.0 - c);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342                   <span class="comment">// Otherwise, distribute points evenly within the element</span>
<a name="l00343"></a>00343                   <span class="keywordflow">else</span>
<a name="l00344"></a>00344                   {
<a name="l00345"></a>00345                     <span class="keywordflow">if</span>(i%3 == 1)
<a name="l00346"></a>00346                     {
<a name="l00347"></a>00347                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cmin = std::cos( pi*(i-1) / static_cast&lt;Real&gt;(3*nx) );
<a name="l00348"></a>00348                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cmax = std::cos( pi*(i+2) / static_cast&lt;Real&gt;(3*nx) );
<a name="l00349"></a>00349 
<a name="l00350"></a>00350                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin = 0.5*(1.0 - cmin);
<a name="l00351"></a>00351                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax = 0.5*(1.0 - cmax);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353                       x = (2.*xmin + xmax)/3.;
<a name="l00354"></a>00354                     }
<a name="l00355"></a>00355                     <span class="keywordflow">else</span>
<a name="l00356"></a>00356                     <span class="keywordflow">if</span>(i%3 == 2)
<a name="l00357"></a>00357                     {
<a name="l00358"></a>00358                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cmin = std::cos( pi*(i-2) / static_cast&lt;Real&gt;(3*nx) );
<a name="l00359"></a>00359                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cmax = std::cos( pi*(i+1) / static_cast&lt;Real&gt;(3*nx) );
<a name="l00360"></a>00360 
<a name="l00361"></a>00361                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin = 0.5*(1.0 - cmin);
<a name="l00362"></a>00362                       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax = 0.5*(1.0 - cmax);
<a name="l00363"></a>00363 
<a name="l00364"></a>00364                       x = (xmin + 2.*xmax)/3.;
<a name="l00365"></a>00365                     }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367                   }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(x,0.,0.), node_id++);
<a name="l00370"></a>00370                 }
<a name="l00371"></a>00371                 <span class="keywordflow">else</span>
<a name="l00372"></a>00372                 mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(3*nx),
<a name="l00373"></a>00373                         0,
<a name="l00374"></a>00374                         0), node_id++);
<a name="l00375"></a>00375               }
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378             
<a name="l00379"></a>00379               <span class="keywordflow">break</span>;
<a name="l00380"></a>00380             }
<a name="l00381"></a>00381             
<a name="l00382"></a>00382           <span class="keywordflow">default</span>:
<a name="l00383"></a>00383             {
<a name="l00384"></a>00384               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 1D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00385"></a>00385               libmesh_error();
<a name="l00386"></a>00386             }
<a name="l00387"></a>00387               
<a name="l00388"></a>00388         }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390         <span class="comment">// Build the elements of the mesh</span>
<a name="l00391"></a>00391         <span class="keywordflow">switch</span>(type)
<a name="l00392"></a>00392           {
<a name="l00393"></a>00393             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00394"></a>00394             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00395"></a>00395               {
<a name="l00396"></a>00396                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l00397"></a>00397                 {
<a name="l00398"></a>00398                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge2.php">Edge2</a>);
<a name="l00399"></a>00399                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i);
<a name="l00400"></a>00400                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(i+1);
<a name="l00401"></a>00401 
<a name="l00402"></a>00402                   <span class="keywordflow">if</span> (i == 0)
<a name="l00403"></a>00403                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405                   <span class="keywordflow">if</span> (i == (nx-1))
<a name="l00406"></a>00406                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00407"></a>00407                 }
<a name="l00408"></a>00408               <span class="keywordflow">break</span>;
<a name="l00409"></a>00409               }
<a name="l00410"></a>00410 
<a name="l00411"></a>00411             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00412"></a>00412               {
<a name="l00413"></a>00413                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l00414"></a>00414                 {
<a name="l00415"></a>00415                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>);
<a name="l00416"></a>00416                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(2*i);
<a name="l00417"></a>00417                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(2*i+1);
<a name="l00418"></a>00418                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(2*i+2);
<a name="l00419"></a>00419 
<a name="l00420"></a>00420                   <span class="keywordflow">if</span> (i == 0)
<a name="l00421"></a>00421                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00422"></a>00422 
<a name="l00423"></a>00423                   <span class="keywordflow">if</span> (i == (nx-1))
<a name="l00424"></a>00424                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00425"></a>00425                 }
<a name="l00426"></a>00426               <span class="keywordflow">break</span>;
<a name="l00427"></a>00427               }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00430"></a>00430               {
<a name="l00431"></a>00431                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l00432"></a>00432                 {
<a name="l00433"></a>00433                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge4.php">Edge4</a>);
<a name="l00434"></a>00434                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(3*i);
<a name="l00435"></a>00435                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(3*i+1);
<a name="l00436"></a>00436                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(3*i+2);
<a name="l00437"></a>00437                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(3*i+3);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439                   <span class="keywordflow">if</span> (i == 0)
<a name="l00440"></a>00440                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442                   <span class="keywordflow">if</span> (i == (nx-1))
<a name="l00443"></a>00443                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00444"></a>00444                 }
<a name="l00445"></a>00445               <span class="keywordflow">break</span>;
<a name="l00446"></a>00446               }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448             <span class="keywordflow">default</span>:
<a name="l00449"></a>00449               {
<a name="l00450"></a>00450                 <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 1D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00451"></a>00451                 libmesh_error();                
<a name="l00452"></a>00452               }
<a name="l00453"></a>00453           }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455         <span class="comment">// Scale the nodal positions</span>
<a name="l00456"></a>00456         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); p++)
<a name="l00457"></a>00457           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(0) = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(0))*(xmax-xmin) + xmin;
<a name="l00458"></a>00458         
<a name="l00459"></a>00459         <span class="keywordflow">break</span>;
<a name="l00460"></a>00460       }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468       
<a name="l00469"></a>00469       
<a name="l00470"></a>00470       
<a name="l00471"></a>00471       <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00472"></a>00472       <span class="comment">// Build a 2D quadrilateral</span>
<a name="l00473"></a>00473     <span class="keywordflow">case</span> 2:
<a name="l00474"></a>00474       {
<a name="l00475"></a>00475         libmesh_assert (nx != 0);
<a name="l00476"></a>00476         libmesh_assert (ny != 0);
<a name="l00477"></a>00477         libmesh_assert (nz == 0);
<a name="l00478"></a>00478         libmesh_assert (xmin &lt; xmax);
<a name="l00479"></a>00479         libmesh_assert (ymin &lt; ymax);
<a name="l00480"></a>00480 
<a name="l00481"></a>00481         <span class="comment">// Reserve elements.  The TRI3 and TRI6 meshes</span>
<a name="l00482"></a>00482         <span class="comment">// have twice as many elements...</span>
<a name="l00483"></a>00483         <span class="keywordflow">switch</span> (type)
<a name="l00484"></a>00484           {
<a name="l00485"></a>00485           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00486"></a>00486           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00487"></a>00487           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00488"></a>00488           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00489"></a>00489             {
<a name="l00490"></a>00490               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a> (nx*ny);
<a name="l00491"></a>00491               <span class="keywordflow">break</span>;
<a name="l00492"></a>00492             }
<a name="l00493"></a>00493 
<a name="l00494"></a>00494           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00495"></a>00495           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00496"></a>00496             {
<a name="l00497"></a>00497               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a> (2*nx*ny);
<a name="l00498"></a>00498               <span class="keywordflow">break</span>;
<a name="l00499"></a>00499             }
<a name="l00500"></a>00500 
<a name="l00501"></a>00501           <span class="keywordflow">default</span>:
<a name="l00502"></a>00502             {
<a name="l00503"></a>00503               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 2D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00504"></a>00504               libmesh_error();
<a name="l00505"></a>00505             }
<a name="l00506"></a>00506           }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509         
<a name="l00510"></a>00510         <span class="comment">// Reserve nodes.  The quadratic element types</span>
<a name="l00511"></a>00511         <span class="comment">// need to reserve more nodes than the linear types.</span>
<a name="l00512"></a>00512         <span class="keywordflow">switch</span> (type)
<a name="l00513"></a>00513           {
<a name="l00514"></a>00514           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00515"></a>00515           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00516"></a>00516           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00517"></a>00517             {
<a name="l00518"></a>00518               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>( (nx+1)*(ny+1) );
<a name="l00519"></a>00519               <span class="keywordflow">break</span>;
<a name="l00520"></a>00520             }
<a name="l00521"></a>00521             
<a name="l00522"></a>00522           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00523"></a>00523           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00524"></a>00524           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00525"></a>00525             {
<a name="l00526"></a>00526               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>( (2*nx+1)*(2*ny+1) );
<a name="l00527"></a>00527               <span class="keywordflow">break</span>;
<a name="l00528"></a>00528             }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530             
<a name="l00531"></a>00531           <span class="keywordflow">default</span>:
<a name="l00532"></a>00532             {
<a name="l00533"></a>00533               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 2D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00534"></a>00534               libmesh_error();
<a name="l00535"></a>00535             }
<a name="l00536"></a>00536           }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540         <span class="comment">// Build the nodes. Depends on whether you are using a linear</span>
<a name="l00541"></a>00541         <span class="comment">// or quadratic element, and whether you are using a uniform</span>
<a name="l00542"></a>00542         <span class="comment">// grid or the Gauss-Lobatto grid points.</span>
<a name="l00543"></a>00543         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = 0;
<a name="l00544"></a>00544         <span class="keywordflow">switch</span> (type)
<a name="l00545"></a>00545           {
<a name="l00546"></a>00546           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00547"></a>00547           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00548"></a>00548           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00549"></a>00549             {
<a name="l00550"></a>00550               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=ny; j++)
<a name="l00551"></a>00551                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=nx; i++)
<a name="l00552"></a>00552                   {
<a name="l00553"></a>00553                     <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00554"></a>00554                       {
<a name="l00555"></a>00555                         <span class="comment">// Shortcut variable</span>
<a name="l00556"></a>00556                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>;
<a name="l00557"></a>00557 
<a name="l00558"></a>00558                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0.5*(1.0 - std::cos(pi*static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(nx))),
<a name="l00559"></a>00559                                               0.5*(1.0 - std::cos(pi*static_cast&lt;Real&gt;(j)/static_cast&lt;Real&gt;(ny))),
<a name="l00560"></a>00560                                               0.), node_id++);
<a name="l00561"></a>00561                       }
<a name="l00562"></a>00562                   
<a name="l00563"></a>00563                     <span class="keywordflow">else</span>
<a name="l00564"></a>00564                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(nx),
<a name="l00565"></a>00565                                             static_cast&lt;Real&gt;(j)/static_cast&lt;Real&gt;(ny),
<a name="l00566"></a>00566                                             0.), node_id++);
<a name="l00567"></a>00567                   }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569               <span class="keywordflow">break</span>;
<a name="l00570"></a>00570             }
<a name="l00571"></a>00571             
<a name="l00572"></a>00572           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00573"></a>00573           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00574"></a>00574           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00575"></a>00575             {
<a name="l00576"></a>00576               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=(2*ny); j++)
<a name="l00577"></a>00577                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=(2*nx); i++)
<a name="l00578"></a>00578                   {
<a name="l00579"></a>00579                     <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00580"></a>00580                       {
<a name="l00581"></a>00581                         <span class="comment">// The x,y locations of the point.</span>
<a name="l00582"></a>00582                         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x=0., y=0.;
<a name="l00583"></a>00583 
<a name="l00584"></a>00584                         <span class="comment">// Shortcut variable</span>
<a name="l00585"></a>00585                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>;
<a name="l00586"></a>00586                         
<a name="l00587"></a>00587                         <span class="comment">// Shortcut quantities (do not depend on i,j)</span>
<a name="l00588"></a>00588                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a = std::cos( pi / static_cast&lt;Real&gt;(2*nx) );
<a name="l00589"></a>00589                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b = std::cos( pi / static_cast&lt;Real&gt;(2*ny) );
<a name="l00590"></a>00590 
<a name="l00591"></a>00591                         <span class="comment">// Shortcut quantities (depend on i,j)</span>
<a name="l00592"></a>00592                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> c = std::cos( pi*i / static_cast&lt;Real&gt;(2*nx) );
<a name="l00593"></a>00593                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d = std::cos( pi*j / static_cast&lt;Real&gt;(2*ny) );
<a name="l00594"></a>00594                         
<a name="l00595"></a>00595                         <span class="comment">// If i is even, compute a normal Gauss-Lobatto point</span>
<a name="l00596"></a>00596                         <span class="keywordflow">if</span> (i%2 == 0)
<a name="l00597"></a>00597                           x = 0.5*(1.0 - c);
<a name="l00598"></a>00598 
<a name="l00599"></a>00599                         <span class="comment">// Otherwise, it is the average of the previous and next points</span>
<a name="l00600"></a>00600                         <span class="keywordflow">else</span>
<a name="l00601"></a>00601                           x = 0.5*(1.0 - a*c);
<a name="l00602"></a>00602                       
<a name="l00603"></a>00603                         <span class="comment">// If j is even, compute a normal Gauss-Lobatto point</span>
<a name="l00604"></a>00604                         <span class="keywordflow">if</span> (j%2 == 0)
<a name="l00605"></a>00605                           y = 0.5*(1.0 - d);
<a name="l00606"></a>00606                       
<a name="l00607"></a>00607                         <span class="comment">// Otherwise, it is the average of the previous and next points</span>
<a name="l00608"></a>00608                         <span class="keywordflow">else</span>
<a name="l00609"></a>00609                           y = 0.5*(1.0 - b*d);
<a name="l00610"></a>00610                       
<a name="l00611"></a>00611 
<a name="l00612"></a>00612                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(x,y,0.), node_id++);
<a name="l00613"></a>00613                       } 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615                   
<a name="l00616"></a>00616                     <span class="keywordflow">else</span>
<a name="l00617"></a>00617                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(2*nx),
<a name="l00618"></a>00618                                             static_cast&lt;Real&gt;(j)/static_cast&lt;Real&gt;(2*ny),
<a name="l00619"></a>00619                                             0), node_id++);
<a name="l00620"></a>00620                 }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622               <span class="keywordflow">break</span>;
<a name="l00623"></a>00623             }
<a name="l00624"></a>00624 
<a name="l00625"></a>00625             
<a name="l00626"></a>00626           <span class="keywordflow">default</span>:
<a name="l00627"></a>00627             {
<a name="l00628"></a>00628               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 2D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00629"></a>00629               libmesh_error();
<a name="l00630"></a>00630             }
<a name="l00631"></a>00631           }
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a>00638         <span class="comment">// Build the elements.  Each one is a bit different.</span>
<a name="l00639"></a>00639         <span class="keywordflow">switch</span> (type)
<a name="l00640"></a>00640           {
<a name="l00641"></a>00641 
<a name="l00642"></a>00642           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00643"></a>00643           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00644"></a>00644             {
<a name="l00645"></a>00645               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;ny; j++)
<a name="l00646"></a>00646                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l00647"></a>00647                   {
<a name="l00648"></a>00648                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>);
<a name="l00649"></a>00649 
<a name="l00650"></a>00650                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j)    );
<a name="l00651"></a>00651                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j)  );
<a name="l00652"></a>00652                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+1));
<a name="l00653"></a>00653                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j+1)  );
<a name="l00654"></a>00654 
<a name="l00655"></a>00655                     <span class="keywordflow">if</span> (j == 0)
<a name="l00656"></a>00656                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00657"></a>00657                   
<a name="l00658"></a>00658                     <span class="keywordflow">if</span> (j == (ny-1))
<a name="l00659"></a>00659                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 2);
<a name="l00660"></a>00660                   
<a name="l00661"></a>00661                     <span class="keywordflow">if</span> (i == 0)
<a name="l00662"></a>00662                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 3, 3);
<a name="l00663"></a>00663                   
<a name="l00664"></a>00664                     <span class="keywordflow">if</span> (i == (nx-1))
<a name="l00665"></a>00665                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00666"></a>00666                   }
<a name="l00667"></a>00667               <span class="keywordflow">break</span>;
<a name="l00668"></a>00668             }
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00672"></a>00672             {
<a name="l00673"></a>00673               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;ny; j++)
<a name="l00674"></a>00674                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l00675"></a>00675                   {
<a name="l00676"></a>00676                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;
<a name="l00677"></a>00677 
<a name="l00678"></a>00678                     <span class="comment">// Add first Tri3</span>
<a name="l00679"></a>00679                     elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>);
<a name="l00680"></a>00680 
<a name="l00681"></a>00681                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j)    );
<a name="l00682"></a>00682                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j)  );
<a name="l00683"></a>00683                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+1));
<a name="l00684"></a>00684 
<a name="l00685"></a>00685                     <span class="keywordflow">if</span> (j == 0)
<a name="l00686"></a>00686                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688                     <span class="keywordflow">if</span> (i == (nx-1))
<a name="l00689"></a>00689                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00690"></a>00690 
<a name="l00691"></a>00691                     <span class="comment">// Add second Tri3</span>
<a name="l00692"></a>00692                     elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>);
<a name="l00693"></a>00693 
<a name="l00694"></a>00694                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j)    );
<a name="l00695"></a>00695                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+1));
<a name="l00696"></a>00696                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j+1)  );
<a name="l00697"></a>00697 
<a name="l00698"></a>00698                     <span class="keywordflow">if</span> (j == (ny-1))
<a name="l00699"></a>00699                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 2);
<a name="l00700"></a>00700 
<a name="l00701"></a>00701                     <span class="keywordflow">if</span> (i == 0)
<a name="l00702"></a>00702                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 3);
<a name="l00703"></a>00703                   }
<a name="l00704"></a>00704               <span class="keywordflow">break</span>;
<a name="l00705"></a>00705             }
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00710"></a>00710           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00711"></a>00711             {
<a name="l00712"></a>00712               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;(2*ny); j += 2)
<a name="l00713"></a>00713                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(2*nx); i += 2)
<a name="l00714"></a>00714                   {
<a name="l00715"></a>00715                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>) ?
<a name="l00716"></a>00716                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>) :
<a name="l00717"></a>00717                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>);
<a name="l00718"></a>00718                   
<a name="l00719"></a>00719 
<a name="l00720"></a>00720                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j)    );
<a name="l00721"></a>00721                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j)  );
<a name="l00722"></a>00722                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j+2));
<a name="l00723"></a>00723                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j+2)  );
<a name="l00724"></a>00724                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j)  );
<a name="l00725"></a>00725                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j+1));
<a name="l00726"></a>00726                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(6) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+2));
<a name="l00727"></a>00727                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(7) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j+1)  );
<a name="l00728"></a>00728                     <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>)
<a name="l00729"></a>00729                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(8) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+1));
<a name="l00730"></a>00730                   
<a name="l00731"></a>00731 
<a name="l00732"></a>00732                     <span class="keywordflow">if</span> (j == 0)
<a name="l00733"></a>00733                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00734"></a>00734                   
<a name="l00735"></a>00735                     <span class="keywordflow">if</span> (j == 2*(ny-1))
<a name="l00736"></a>00736                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 2);
<a name="l00737"></a>00737                   
<a name="l00738"></a>00738                     <span class="keywordflow">if</span> (i == 0)
<a name="l00739"></a>00739                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 3, 3);
<a name="l00740"></a>00740                   
<a name="l00741"></a>00741                     <span class="keywordflow">if</span> (i == 2*(nx-1))
<a name="l00742"></a>00742                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00743"></a>00743                   }
<a name="l00744"></a>00744               <span class="keywordflow">break</span>;
<a name="l00745"></a>00745             }
<a name="l00746"></a>00746 
<a name="l00747"></a>00747 
<a name="l00748"></a>00748           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00749"></a>00749             {
<a name="l00750"></a>00750               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;(2*ny); j += 2)
<a name="l00751"></a>00751                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(2*nx); i += 2)
<a name="l00752"></a>00752                   {
<a name="l00753"></a>00753                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;
<a name="l00754"></a>00754 
<a name="l00755"></a>00755                     <span class="comment">// Add first Tri6</span>
<a name="l00756"></a>00756                     elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00757"></a>00757 
<a name="l00758"></a>00758                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j)    );
<a name="l00759"></a>00759                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j)  );
<a name="l00760"></a>00760                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j+2));
<a name="l00761"></a>00761                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j)  );
<a name="l00762"></a>00762                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j+1));
<a name="l00763"></a>00763                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+1));
<a name="l00764"></a>00764 
<a name="l00765"></a>00765                     <span class="keywordflow">if</span> (j == 0)
<a name="l00766"></a>00766                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l00767"></a>00767 
<a name="l00768"></a>00768                     <span class="keywordflow">if</span> (i == 2*(nx-1))
<a name="l00769"></a>00769                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l00770"></a>00770 
<a name="l00771"></a>00771                     <span class="comment">// Add second Tri6</span>
<a name="l00772"></a>00772                     elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00773"></a>00773 
<a name="l00774"></a>00774                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j)    );
<a name="l00775"></a>00775                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+2,j+2));
<a name="l00776"></a>00776                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j+2)  );
<a name="l00777"></a>00777                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+1));
<a name="l00778"></a>00778                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i+1,j+2));
<a name="l00779"></a>00779                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,i,j+1)  );
<a name="l00780"></a>00780 
<a name="l00781"></a>00781                     <span class="keywordflow">if</span> (j == 2*(ny-1))
<a name="l00782"></a>00782                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 2);
<a name="l00783"></a>00783 
<a name="l00784"></a>00784                     <span class="keywordflow">if</span> (i == 0)
<a name="l00785"></a>00785                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 3);
<a name="l00786"></a>00786 
<a name="l00787"></a>00787                   }
<a name="l00788"></a>00788               <span class="keywordflow">break</span>;
<a name="l00789"></a>00789             };
<a name="l00790"></a>00790 
<a name="l00791"></a>00791             
<a name="l00792"></a>00792           <span class="keywordflow">default</span>:
<a name="l00793"></a>00793             {
<a name="l00794"></a>00794               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 2D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00795"></a>00795               libmesh_error();
<a name="l00796"></a>00796             }
<a name="l00797"></a>00797           }
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 
<a name="l00801"></a>00801         
<a name="l00802"></a>00802         <span class="comment">// Scale the nodal positions</span>
<a name="l00803"></a>00803         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); p++)
<a name="l00804"></a>00804           {
<a name="l00805"></a>00805             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(0) = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(0))*(xmax-xmin) + xmin;
<a name="l00806"></a>00806             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(1) = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(1))*(ymax-ymin) + ymin;
<a name="l00807"></a>00807           }
<a name="l00808"></a>00808 
<a name="l00809"></a>00809         
<a name="l00810"></a>00810         <span class="keywordflow">break</span>;
<a name="l00811"></a>00811       }
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820       
<a name="l00821"></a>00821 
<a name="l00822"></a>00822 
<a name="l00823"></a>00823       <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00824"></a>00824       <span class="comment">// Build a 3D mesh using hexahedral or prismatic elements.</span>
<a name="l00825"></a>00825     <span class="keywordflow">case</span> 3:
<a name="l00826"></a>00826       {
<a name="l00827"></a>00827         libmesh_assert (nx != 0);
<a name="l00828"></a>00828         libmesh_assert (ny != 0);
<a name="l00829"></a>00829         libmesh_assert (nz != 0);
<a name="l00830"></a>00830         libmesh_assert (xmin &lt; xmax);
<a name="l00831"></a>00831         libmesh_assert (ymin &lt; ymax);
<a name="l00832"></a>00832         libmesh_assert (zmin &lt; zmax);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834 
<a name="l00835"></a>00835         <span class="comment">// Reserve elements.  Meshes with prismatic elements require</span>
<a name="l00836"></a>00836         <span class="comment">// twice as many elements.</span>
<a name="l00837"></a>00837         <span class="keywordflow">switch</span> (type)
<a name="l00838"></a>00838           {
<a name="l00839"></a>00839           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00840"></a>00840           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00841"></a>00841           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00842"></a>00842           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00843"></a>00843           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:  <span class="comment">// TET4&#39;s are created from an initial HEX27 discretization</span>
<a name="l00844"></a>00844           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>: <span class="comment">// TET10&#39;s are created from an initial HEX27 discretization</span>
<a name="l00845"></a>00845           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>: <span class="comment">// PYRAMID5&#39;s are created from an initial HEX27 discretization</span>
<a name="l00846"></a>00846             {
<a name="l00847"></a>00847               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a>(nx*ny*nz);
<a name="l00848"></a>00848               <span class="keywordflow">break</span>;
<a name="l00849"></a>00849             }
<a name="l00850"></a>00850 
<a name="l00851"></a>00851           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00852"></a>00852           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00853"></a>00853           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00854"></a>00854             {
<a name="l00855"></a>00855               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a>(2*nx*ny*nz);
<a name="l00856"></a>00856               <span class="keywordflow">break</span>;
<a name="l00857"></a>00857             }
<a name="l00858"></a>00858 
<a name="l00859"></a>00859           <span class="keywordflow">default</span>:
<a name="l00860"></a>00860             {
<a name="l00861"></a>00861               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 3D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00862"></a>00862               libmesh_error();
<a name="l00863"></a>00863             }
<a name="l00864"></a>00864           }
<a name="l00865"></a>00865 
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 
<a name="l00869"></a>00869         
<a name="l00870"></a>00870         <span class="comment">// Reserve nodes.  Quadratic elements need twice as many nodes as linear elements.</span>
<a name="l00871"></a>00871         <span class="keywordflow">switch</span> (type)
<a name="l00872"></a>00872           {
<a name="l00873"></a>00873           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00874"></a>00874           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00875"></a>00875           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00876"></a>00876             {
<a name="l00877"></a>00877               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>( (nx+1)*(ny+1)*(nz+1) );
<a name="l00878"></a>00878               <span class="keywordflow">break</span>;
<a name="l00879"></a>00879             }
<a name="l00880"></a>00880 
<a name="l00881"></a>00881           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00882"></a>00882           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00883"></a>00883           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>: <span class="comment">// TET4&#39;s are created from an initial HEX27 discretization</span>
<a name="l00884"></a>00884           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>: <span class="comment">// TET10&#39;s are created from an initial HEX27 discretization</span>
<a name="l00885"></a>00885           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>: <span class="comment">// PYRAMID5&#39;s are created from an initial HEX27 discretization</span>
<a name="l00886"></a>00886           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00887"></a>00887           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00888"></a>00888             {
<a name="l00889"></a>00889               <span class="comment">// FYI: The resulting TET4 mesh will have exactly</span>
<a name="l00890"></a>00890               <span class="comment">// 5*(nx*ny*nz) + 2*(nx*ny + nx*nz + ny*nz) + (nx+ny+nz) + 1</span>
<a name="l00891"></a>00891               <span class="comment">// nodes once the additional mid-edge nodes for the HEX27 discretization</span>
<a name="l00892"></a>00892               <span class="comment">// have been deleted.</span>
<a name="l00893"></a>00893               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>( (2*nx+1)*(2*ny+1)*(2*nz+1) );
<a name="l00894"></a>00894               <span class="keywordflow">break</span>;
<a name="l00895"></a>00895             }
<a name="l00896"></a>00896 
<a name="l00897"></a>00897           <span class="keywordflow">default</span>:
<a name="l00898"></a>00898             {
<a name="l00899"></a>00899               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 3D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l00900"></a>00900               libmesh_error();
<a name="l00901"></a>00901             }
<a name="l00902"></a>00902           }
<a name="l00903"></a>00903 
<a name="l00904"></a>00904 
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 
<a name="l00907"></a>00907         <span class="comment">// Build the nodes.</span>
<a name="l00908"></a>00908         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = 0;
<a name="l00909"></a>00909         <span class="keywordflow">switch</span> (type)
<a name="l00910"></a>00910           {
<a name="l00911"></a>00911           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l00912"></a>00912           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00913"></a>00913           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00914"></a>00914             {
<a name="l00915"></a>00915               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;=nz; k++)
<a name="l00916"></a>00916                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=ny; j++)
<a name="l00917"></a>00917                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=nx; i++)
<a name="l00918"></a>00918                     {
<a name="l00919"></a>00919                       <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00920"></a>00920                         {
<a name="l00921"></a>00921                           <span class="comment">// Shortcut variable</span>
<a name="l00922"></a>00922                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>;
<a name="l00923"></a>00923 
<a name="l00924"></a>00924                           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0.5*(1.0 - std::cos(pi*static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(nx))),
<a name="l00925"></a>00925                                                 0.5*(1.0 - std::cos(pi*static_cast&lt;Real&gt;(j)/static_cast&lt;Real&gt;(ny))),
<a name="l00926"></a>00926                                                 0.5*(1.0 - std::cos(pi*static_cast&lt;Real&gt;(k)/static_cast&lt;Real&gt;(nz)))), node_id++);
<a name="l00927"></a>00927                         }
<a name="l00928"></a>00928                       
<a name="l00929"></a>00929                       <span class="keywordflow">else</span>
<a name="l00930"></a>00930                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(nx),
<a name="l00931"></a>00931                                              static_cast&lt;Real&gt;(j)/static_cast&lt;Real&gt;(ny),
<a name="l00932"></a>00932                                              static_cast&lt;Real&gt;(k)/static_cast&lt;Real&gt;(nz)), node_id++);
<a name="l00933"></a>00933                     }
<a name="l00934"></a>00934               <span class="keywordflow">break</span>;
<a name="l00935"></a>00935             }
<a name="l00936"></a>00936             
<a name="l00937"></a>00937           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00938"></a>00938           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00939"></a>00939           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>: <span class="comment">// TET4&#39;s are created from an initial HEX27 discretization</span>
<a name="l00940"></a>00940           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>: <span class="comment">// TET10&#39;s are created from an initial HEX27 discretization</span>
<a name="l00941"></a>00941           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>: <span class="comment">// PYRAMID5&#39;s are created from an initial HEX27 discretization</span>
<a name="l00942"></a>00942           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00943"></a>00943           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00944"></a>00944             {
<a name="l00945"></a>00945               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;=(2*nz); k++)
<a name="l00946"></a>00946                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=(2*ny); j++)
<a name="l00947"></a>00947                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=(2*nx); i++)
<a name="l00948"></a>00948                     {
<a name="l00949"></a>00949                       <span class="keywordflow">if</span> (gauss_lobatto_grid)
<a name="l00950"></a>00950                         {
<a name="l00951"></a>00951                           <span class="comment">// Shortcut variable</span>
<a name="l00952"></a>00952                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>;
<a name="l00953"></a>00953                           
<a name="l00954"></a>00954                           <span class="comment">// The x,y locations of the point.</span>
<a name="l00955"></a>00955                           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x=0., y=0., z=0.;
<a name="l00956"></a>00956 
<a name="l00957"></a>00957                           <span class="comment">// Shortcut quantities (do not depend on i,j)</span>
<a name="l00958"></a>00958                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a = std::cos( pi / static_cast&lt;Real&gt;(2*nx) );
<a name="l00959"></a>00959                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b = std::cos( pi / static_cast&lt;Real&gt;(2*ny) );
<a name="l00960"></a>00960 
<a name="l00961"></a>00961                           <span class="comment">// Shortcut quantities (depend on i,j)</span>
<a name="l00962"></a>00962                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> c = std::cos( pi*i / static_cast&lt;Real&gt;(2*nx) );
<a name="l00963"></a>00963                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d = std::cos( pi*j / static_cast&lt;Real&gt;(2*ny) );
<a name="l00964"></a>00964                           
<a name="l00965"></a>00965                           <span class="comment">// Additional shortcut quantities (for 3D)</span>
<a name="l00966"></a>00966                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> e = std::cos( pi / static_cast&lt;Real&gt;(2*nz) );
<a name="l00967"></a>00967                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> f = std::cos( pi*k / static_cast&lt;Real&gt;(2*nz) );
<a name="l00968"></a>00968                           
<a name="l00969"></a>00969                           <span class="comment">// If i is even, compute a normal Gauss-Lobatto point</span>
<a name="l00970"></a>00970                           <span class="keywordflow">if</span> (i%2 == 0)
<a name="l00971"></a>00971                             x = 0.5*(1.0 - c);
<a name="l00972"></a>00972 
<a name="l00973"></a>00973                           <span class="comment">// Otherwise, it is the average of the previous and next points</span>
<a name="l00974"></a>00974                           <span class="keywordflow">else</span>
<a name="l00975"></a>00975                             x = 0.5*(1.0 - a*c);
<a name="l00976"></a>00976                       
<a name="l00977"></a>00977                           <span class="comment">// If j is even, compute a normal Gauss-Lobatto point</span>
<a name="l00978"></a>00978                           <span class="keywordflow">if</span> (j%2 == 0)
<a name="l00979"></a>00979                             y = 0.5*(1.0 - d);
<a name="l00980"></a>00980                       
<a name="l00981"></a>00981                           <span class="comment">// Otherwise, it is the average of the previous and next points</span>
<a name="l00982"></a>00982                           <span class="keywordflow">else</span>
<a name="l00983"></a>00983                             y = 0.5*(1.0 - b*d);
<a name="l00984"></a>00984 
<a name="l00985"></a>00985                           <span class="comment">// If k is even, compute a normal Gauss-Lobatto point</span>
<a name="l00986"></a>00986                           <span class="keywordflow">if</span> (k%2 == 0)
<a name="l00987"></a>00987                             z = 0.5*(1.0 - f);
<a name="l00988"></a>00988                       
<a name="l00989"></a>00989                           <span class="comment">// Otherwise, it is the average of the previous and next points</span>
<a name="l00990"></a>00990                           <span class="keywordflow">else</span>
<a name="l00991"></a>00991                             z = 0.5*(1.0 - e*f);
<a name="l00992"></a>00992                       
<a name="l00993"></a>00993                           
<a name="l00994"></a>00994                           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(x,y,z), node_id++);
<a name="l00995"></a>00995                         }
<a name="l00996"></a>00996 
<a name="l00997"></a>00997                       <span class="keywordflow">else</span>
<a name="l00998"></a>00998                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(static_cast&lt;Real&gt;(i)/static_cast&lt;Real&gt;(2*nx),
<a name="l00999"></a>00999                                              static_cast&lt;Real&gt;(j)/static_cast&lt;Real&gt;(2*ny),
<a name="l01000"></a>01000                                              static_cast&lt;Real&gt;(k)/static_cast&lt;Real&gt;(2*nz)), node_id++);
<a name="l01001"></a>01001                     }
<a name="l01002"></a>01002               <span class="keywordflow">break</span>;
<a name="l01003"></a>01003             }
<a name="l01004"></a>01004 
<a name="l01005"></a>01005 
<a name="l01006"></a>01006           <span class="keywordflow">default</span>:
<a name="l01007"></a>01007             {
<a name="l01008"></a>01008               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 3D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l01009"></a>01009               libmesh_error();
<a name="l01010"></a>01010             }
<a name="l01011"></a>01011           }
<a name="l01012"></a>01012 
<a name="l01013"></a>01013             
<a name="l01014"></a>01014 
<a name="l01015"></a>01015         
<a name="l01016"></a>01016         <span class="comment">// Build the elements.</span>
<a name="l01017"></a>01017         <span class="keywordflow">switch</span> (type)
<a name="l01018"></a>01018           {
<a name="l01019"></a>01019           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>:
<a name="l01020"></a>01020           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01021"></a>01021             {
<a name="l01022"></a>01022               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;nz; k++)
<a name="l01023"></a>01023                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;ny; j++)
<a name="l01024"></a>01024                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l01025"></a>01025                     {
<a name="l01026"></a>01026                       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex8.php">Hex8</a>);
<a name="l01027"></a>01027                         
<a name="l01028"></a>01028                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j,k)      );
<a name="l01029"></a>01029                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,k)    );
<a name="l01030"></a>01030                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k)  );
<a name="l01031"></a>01031                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+1,k)    );
<a name="l01032"></a>01032                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j,k+1)    );
<a name="l01033"></a>01033                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,k+1)  );
<a name="l01034"></a>01034                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(6) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+1));
<a name="l01035"></a>01035                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(7) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+1,k+1)  );
<a name="l01036"></a>01036                         
<a name="l01037"></a>01037                       <span class="keywordflow">if</span> (k == 0)
<a name="l01038"></a>01038                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l01039"></a>01039                         
<a name="l01040"></a>01040                       <span class="keywordflow">if</span> (k == (nz-1))
<a name="l01041"></a>01041                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 5, 5);
<a name="l01042"></a>01042                         
<a name="l01043"></a>01043                       <span class="keywordflow">if</span> (j == 0)
<a name="l01044"></a>01044                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l01045"></a>01045 
<a name="l01046"></a>01046                       <span class="keywordflow">if</span> (j == (ny-1))
<a name="l01047"></a>01047                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 3, 3);
<a name="l01048"></a>01048                         
<a name="l01049"></a>01049                       <span class="keywordflow">if</span> (i == 0)
<a name="l01050"></a>01050                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 4, 4);
<a name="l01051"></a>01051                         
<a name="l01052"></a>01052                       <span class="keywordflow">if</span> (i == (nx-1))
<a name="l01053"></a>01053                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 2);
<a name="l01054"></a>01054                     }
<a name="l01055"></a>01055               <span class="keywordflow">break</span>;
<a name="l01056"></a>01056             }
<a name="l01057"></a>01057 
<a name="l01058"></a>01058 
<a name="l01059"></a>01059 
<a name="l01060"></a>01060 
<a name="l01061"></a>01061           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01062"></a>01062             {
<a name="l01063"></a>01063               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;nz; k++)
<a name="l01064"></a>01064                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;ny; j++)
<a name="l01065"></a>01065                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nx; i++)
<a name="l01066"></a>01066                     {
<a name="l01067"></a>01067                       <span class="comment">// First Prism</span>
<a name="l01068"></a>01068                       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;
<a name="l01069"></a>01069                       elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism6.php">Prism6</a>);
<a name="l01070"></a>01070 
<a name="l01071"></a>01071                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j,k)      );
<a name="l01072"></a>01072                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,k)    );
<a name="l01073"></a>01073                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+1,k)    );
<a name="l01074"></a>01074                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j,k+1)    );
<a name="l01075"></a>01075                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,k+1)  );
<a name="l01076"></a>01076                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+1,k+1)  );
<a name="l01077"></a>01077 
<a name="l01078"></a>01078                       <span class="comment">// Add sides for first prism to boundary info object</span>
<a name="l01079"></a>01079                       <span class="keywordflow">if</span> (i==0)
<a name="l01080"></a>01080                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 3, 4);
<a name="l01081"></a>01081 
<a name="l01082"></a>01082                       <span class="keywordflow">if</span> (j==0)
<a name="l01083"></a>01083                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l01084"></a>01084 
<a name="l01085"></a>01085                       <span class="keywordflow">if</span> (k==0)
<a name="l01086"></a>01086                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l01087"></a>01087 
<a name="l01088"></a>01088                       <span class="keywordflow">if</span> (k == (nz-1))
<a name="l01089"></a>01089                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 4, 5);
<a name="l01090"></a>01090 
<a name="l01091"></a>01091                       <span class="comment">// Second Prism</span>
<a name="l01092"></a>01092                       elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism6.php">Prism6</a>);
<a name="l01093"></a>01093 
<a name="l01094"></a>01094                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,k)    );
<a name="l01095"></a>01095                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k)  );
<a name="l01096"></a>01096                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+1,k)    );
<a name="l01097"></a>01097                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,k+1)  );
<a name="l01098"></a>01098                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+1));
<a name="l01099"></a>01099                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+1,k+1)  );
<a name="l01100"></a>01100 
<a name="l01101"></a>01101                       <span class="comment">// Add sides for second prism to boundary info object</span>
<a name="l01102"></a>01102                       <span class="keywordflow">if</span> (i == (nx-1))
<a name="l01103"></a>01103                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 2);
<a name="l01104"></a>01104 
<a name="l01105"></a>01105                       <span class="keywordflow">if</span> (j == (ny-1))
<a name="l01106"></a>01106                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 3);
<a name="l01107"></a>01107 
<a name="l01108"></a>01108                       <span class="keywordflow">if</span> (k==0)
<a name="l01109"></a>01109                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l01110"></a>01110 
<a name="l01111"></a>01111                       <span class="keywordflow">if</span> (k == (nz-1))
<a name="l01112"></a>01112                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 4, 5);
<a name="l01113"></a>01113                     }
<a name="l01114"></a>01114               <span class="keywordflow">break</span>;
<a name="l01115"></a>01115             }
<a name="l01116"></a>01116 
<a name="l01117"></a>01117 
<a name="l01118"></a>01118 
<a name="l01119"></a>01119 
<a name="l01120"></a>01120             
<a name="l01121"></a>01121             
<a name="l01122"></a>01122           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01123"></a>01123           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01124"></a>01124           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>: <span class="comment">// TET4&#39;s are created from an initial HEX27 discretization</span>
<a name="l01125"></a>01125           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>: <span class="comment">// TET10&#39;s are created from an initial HEX27 discretization</span>
<a name="l01126"></a>01126           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>: <span class="comment">// PYRAMID5&#39;s are created from an initial HEX27 discretization</span>
<a name="l01127"></a>01127             {
<a name="l01128"></a>01128               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;(2*nz); k += 2)
<a name="l01129"></a>01129                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;(2*ny); j += 2)
<a name="l01130"></a>01130                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(2*nx); i += 2)
<a name="l01131"></a>01131                     {
<a name="l01132"></a>01132                       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>) ?
<a name="l01133"></a>01133                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex20.php">Hex20</a>) :
<a name="l01134"></a>01134                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Hex27.php">Hex27</a>);
<a name="l01135"></a>01135                     
<a name="l01136"></a>01136                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j,  k)  );
<a name="l01137"></a>01137                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,  k)  );
<a name="l01138"></a>01138                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+2,k)  );
<a name="l01139"></a>01139                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+2,k)  );
<a name="l01140"></a>01140                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j,  k+2));
<a name="l01141"></a>01141                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,  k+2));
<a name="l01142"></a>01142                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(6)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+2,k+2));
<a name="l01143"></a>01143                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(7)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+2,k+2));
<a name="l01144"></a>01144                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(8)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,  k)  );
<a name="l01145"></a>01145                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(9)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+1,k)  );
<a name="l01146"></a>01146                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(10) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+2,k)  );
<a name="l01147"></a>01147                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(11) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+1,k)  );
<a name="l01148"></a>01148                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(12) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j,  k+1));
<a name="l01149"></a>01149                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(13) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,  k+1));
<a name="l01150"></a>01150                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(14) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+2,k+1));
<a name="l01151"></a>01151                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(15) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+2,k+1));
<a name="l01152"></a>01152                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(16) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,  k+2));
<a name="l01153"></a>01153                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(17) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+1,k+2));
<a name="l01154"></a>01154                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(18) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+2,k+2));
<a name="l01155"></a>01155                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(19) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+1,k+2));
<a name="l01156"></a>01156                       <span class="keywordflow">if</span> ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>))
<a name="l01157"></a>01157                         {
<a name="l01158"></a>01158                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(20) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k)  );
<a name="l01159"></a>01159                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(21) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,  k+1));
<a name="l01160"></a>01160                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(22) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+1,k+1));
<a name="l01161"></a>01161                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(23) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+2,k+1));
<a name="l01162"></a>01162                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(24) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+1,k+1));
<a name="l01163"></a>01163                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(25) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+2));
<a name="l01164"></a>01164                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(26) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+1));
<a name="l01165"></a>01165                         }
<a name="l01166"></a>01166                         
<a name="l01167"></a>01167                         
<a name="l01168"></a>01168                       <span class="keywordflow">if</span> (k == 0)
<a name="l01169"></a>01169                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l01170"></a>01170                         
<a name="l01171"></a>01171                       <span class="keywordflow">if</span> (k == 2*(nz-1))
<a name="l01172"></a>01172                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 5, 5);
<a name="l01173"></a>01173                         
<a name="l01174"></a>01174                       <span class="keywordflow">if</span> (j == 0)
<a name="l01175"></a>01175                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l01176"></a>01176 
<a name="l01177"></a>01177                       <span class="keywordflow">if</span> (j == 2*(ny-1))
<a name="l01178"></a>01178                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 3, 3);
<a name="l01179"></a>01179                         
<a name="l01180"></a>01180                       <span class="keywordflow">if</span> (i == 0)
<a name="l01181"></a>01181                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 4, 4);
<a name="l01182"></a>01182                         
<a name="l01183"></a>01183                       <span class="keywordflow">if</span> (i == 2*(nx-1))
<a name="l01184"></a>01184                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 2);
<a name="l01185"></a>01185                     }
<a name="l01186"></a>01186               <span class="keywordflow">break</span>;
<a name="l01187"></a>01187             }
<a name="l01188"></a>01188 
<a name="l01189"></a>01189 
<a name="l01190"></a>01190 
<a name="l01191"></a>01191             
<a name="l01192"></a>01192           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l01193"></a>01193           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l01194"></a>01194             {
<a name="l01195"></a>01195               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;(2*nz); k += 2)
<a name="l01196"></a>01196                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;(2*ny); j += 2)
<a name="l01197"></a>01197                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(2*nx); i += 2)
<a name="l01198"></a>01198                     {
<a name="l01199"></a>01199                       <span class="comment">// First Prism</span>
<a name="l01200"></a>01200                       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = NULL;
<a name="l01201"></a>01201                       elem = ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>) ?
<a name="l01202"></a>01202                               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism15.php">Prism15</a>) :
<a name="l01203"></a>01203                               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism18.php">Prism18</a>));
<a name="l01204"></a>01204 
<a name="l01205"></a>01205                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j,  k)  );
<a name="l01206"></a>01206                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,  k)  );
<a name="l01207"></a>01207                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+2,k)  );
<a name="l01208"></a>01208                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j,  k+2));
<a name="l01209"></a>01209                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,  k+2));
<a name="l01210"></a>01210                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+2,k+2));
<a name="l01211"></a>01211                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(6)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,  k)  );
<a name="l01212"></a>01212                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(7)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k)  );
<a name="l01213"></a>01213                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(8)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+1,k)  );
<a name="l01214"></a>01214                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(9)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j,  k+1));
<a name="l01215"></a>01215                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(10) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,  k+1));
<a name="l01216"></a>01216                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(11) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+2,k+1));
<a name="l01217"></a>01217                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(12) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,  k+2));
<a name="l01218"></a>01218                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(13) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+2));
<a name="l01219"></a>01219                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(14) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+1,k+2));
<a name="l01220"></a>01220                       <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>)
<a name="l01221"></a>01221                         {
<a name="l01222"></a>01222                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(15) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j,  k+1));
<a name="l01223"></a>01223                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(16) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+1));
<a name="l01224"></a>01224                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(17) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,  j+1,k+1));
<a name="l01225"></a>01225                         }
<a name="l01226"></a>01226 
<a name="l01227"></a>01227                       <span class="comment">// Add sides for first prism to boundary info object</span>
<a name="l01228"></a>01228                       <span class="keywordflow">if</span> (i==0)
<a name="l01229"></a>01229                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 3, 4);
<a name="l01230"></a>01230 
<a name="l01231"></a>01231                       <span class="keywordflow">if</span> (j==0)
<a name="l01232"></a>01232                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 1);
<a name="l01233"></a>01233 
<a name="l01234"></a>01234                       <span class="keywordflow">if</span> (k==0)
<a name="l01235"></a>01235                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l01236"></a>01236 
<a name="l01237"></a>01237                       <span class="keywordflow">if</span> (k == 2*(nz-1))
<a name="l01238"></a>01238                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 4, 5);
<a name="l01239"></a>01239 
<a name="l01240"></a>01240                       
<a name="l01241"></a>01241                       <span class="comment">// Second Prism</span>
<a name="l01242"></a>01242                       elem = ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>) ?
<a name="l01243"></a>01243                               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism15.php">Prism15</a>) :
<a name="l01244"></a>01244                               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Prism18.php">Prism18</a>));
<a name="l01245"></a>01245                         
<a name="l01246"></a>01246                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,k)     );
<a name="l01247"></a>01247                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+2,k)   );
<a name="l01248"></a>01248                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+2,k)     );
<a name="l01249"></a>01249                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,k+2)   );
<a name="l01250"></a>01250                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+2,k+2) );
<a name="l01251"></a>01251                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+2,k+2)   );
<a name="l01252"></a>01252                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(6)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+1,k)  );
<a name="l01253"></a>01253                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(7)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+2,k)  );
<a name="l01254"></a>01254                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(8)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k)  );
<a name="l01255"></a>01255                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(9)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j,k+1)  );
<a name="l01256"></a>01256                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(10) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+2,k+1));
<a name="l01257"></a>01257                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(11) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i,j+2,k+1)  );
<a name="l01258"></a>01258                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(12) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+1,k+2));
<a name="l01259"></a>01259                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(13) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+2,k+2));
<a name="l01260"></a>01260                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(14) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+2));
<a name="l01261"></a>01261                       <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>)
<a name="l01262"></a>01262                         {
<a name="l01263"></a>01263                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(15)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+2,j+1,k+1));
<a name="l01264"></a>01264                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(16)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+2,k+1));
<a name="l01265"></a>01265                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(17)  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(type,nx,ny,i+1,j+1,k+1));
<a name="l01266"></a>01266                         }
<a name="l01267"></a>01267                       
<a name="l01268"></a>01268                       <span class="comment">// Add sides for second prism to boundary info object</span>
<a name="l01269"></a>01269                       <span class="keywordflow">if</span> (i == 2*(nx-1))
<a name="l01270"></a>01270                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 1, 2);
<a name="l01271"></a>01271 
<a name="l01272"></a>01272                       <span class="keywordflow">if</span> (j == 2*(ny-1))
<a name="l01273"></a>01273                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 2, 3);
<a name="l01274"></a>01274 
<a name="l01275"></a>01275                       <span class="keywordflow">if</span> (k==0)
<a name="l01276"></a>01276                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 0, 0);
<a name="l01277"></a>01277 
<a name="l01278"></a>01278                       <span class="keywordflow">if</span> (k == 2*(nz-1))
<a name="l01279"></a>01279                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, 4, 5);
<a name="l01280"></a>01280 
<a name="l01281"></a>01281                     }
<a name="l01282"></a>01282               <span class="keywordflow">break</span>;
<a name="l01283"></a>01283             }
<a name="l01284"></a>01284 
<a name="l01285"></a>01285 
<a name="l01286"></a>01286 
<a name="l01287"></a>01287 
<a name="l01288"></a>01288             
<a name="l01289"></a>01289           <span class="keywordflow">default</span>:
<a name="l01290"></a>01290             {
<a name="l01291"></a>01291               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized 3D element type.&quot;</span> &lt;&lt; std::endl;
<a name="l01292"></a>01292               libmesh_error();
<a name="l01293"></a>01293             }
<a name="l01294"></a>01294           }
<a name="l01295"></a>01295 
<a name="l01296"></a>01296             
<a name="l01297"></a>01297 
<a name="l01298"></a>01298 
<a name="l01299"></a>01299         <span class="comment">//.......................................</span>
<a name="l01300"></a>01300         <span class="comment">// Scale the nodal positions</span>
<a name="l01301"></a>01301         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); p++)
<a name="l01302"></a>01302           {
<a name="l01303"></a>01303             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(0) = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(0))*(xmax-xmin) + xmin;
<a name="l01304"></a>01304             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(1) = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(1))*(ymax-ymin) + ymin;
<a name="l01305"></a>01305             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(2) = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(p)(2))*(zmax-zmin) + zmin;
<a name="l01306"></a>01306           }
<a name="l01307"></a>01307 
<a name="l01308"></a>01308 
<a name="l01309"></a>01309 
<a name="l01310"></a>01310 
<a name="l01311"></a>01311         <span class="comment">// Additional work for tets and pyramids: we take the existing</span>
<a name="l01312"></a>01312         <span class="comment">// HEX27 discretization and split each element into 24</span>
<a name="l01313"></a>01313         <span class="comment">// sub-tets or 6 sub-pyramids.</span>
<a name="l01314"></a>01314         <span class="comment">//</span>
<a name="l01315"></a>01315         <span class="comment">// 24 isn&#39;t the minimum-possible number of tets, but it</span>
<a name="l01316"></a>01316         <span class="comment">// obviates any concerns about the edge orientations between</span>
<a name="l01317"></a>01317         <span class="comment">// the various elements.</span>
<a name="l01318"></a>01318         <span class="keywordflow">if</span> ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>) ||
<a name="l01319"></a>01319             (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>) ||
<a name="l01320"></a>01320             (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>)) 
<a name="l01321"></a>01321           {
<a name="l01322"></a>01322             <span class="comment">// Temporary storage for new elements. (24 tets per hex, 6 pyramids)</span>
<a name="l01323"></a>01323             std::vector&lt;Elem*&gt; new_elements;
<a name="l01324"></a>01324             
<a name="l01325"></a>01325             <span class="keywordflow">if</span> ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>))
<a name="l01326"></a>01326               new_elements.reserve(24*mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l01327"></a>01327             <span class="keywordflow">else</span>
<a name="l01328"></a>01328               new_elements.reserve(6*mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l01329"></a>01329               
<a name="l01330"></a>01330             <span class="comment">// Create tetrahedra or pyramids</span>
<a name="l01331"></a>01331             {
<a name="l01332"></a>01332               <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01333"></a>01333               <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01334"></a>01334 
<a name="l01335"></a>01335               <span class="keywordflow">for</span> ( ; el != end_el;  ++el)
<a name="l01336"></a>01336                 {
<a name="l01337"></a>01337                   <span class="comment">// Get a pointer to the HEX27 element.</span>
<a name="l01338"></a>01338                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* base_hex = *el;
<a name="l01339"></a>01339 
<a name="l01340"></a>01340                   <span class="comment">// Get a pointer to the node located at the HEX27 centroid</span>
<a name="l01341"></a>01341                   <a class="code" href="classlibMesh_1_1Node.php">Node</a>* apex_node = base_hex-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(26);
<a name="l01342"></a>01342          
<a name="l01343"></a>01343                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;base_hex-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); ++s)
<a name="l01344"></a>01344                     {
<a name="l01345"></a>01345                       <span class="comment">// Get the boundary ID for this side</span>
<a name="l01346"></a>01346                       <span class="keywordtype">short</span> <span class="keywordtype">int</span> b_id = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_id(*el, s);
<a name="l01347"></a>01347                       
<a name="l01348"></a>01348                       <span class="comment">// Need to build the full-ordered side!</span>
<a name="l01349"></a>01349                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = base_hex-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s);
<a name="l01350"></a>01350 
<a name="l01351"></a>01351                       <span class="keywordflow">if</span> ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>))
<a name="l01352"></a>01352                         {
<a name="l01353"></a>01353                           <span class="comment">// Build 4 sub-tets per side</span>
<a name="l01354"></a>01354                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_tet=0; sub_tet&lt;4; ++sub_tet)
<a name="l01355"></a>01355                             {
<a name="l01356"></a>01356                               new_elements.push_back( <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a> );
<a name="l01357"></a>01357                               <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* sub_elem = new_elements.back();
<a name="l01358"></a>01358                               sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = side-&gt;get_node(sub_tet);
<a name="l01359"></a>01359                               sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = side-&gt;get_node(8);                           <span class="comment">// centroid of the face</span>
<a name="l01360"></a>01360                               sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = side-&gt;get_node(sub_tet==3 ? 0 : sub_tet+1 ); <span class="comment">// wrap-around</span>
<a name="l01361"></a>01361                               sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = apex_node;                                   <span class="comment">// apex node always used!</span>
<a name="l01362"></a>01362 
<a name="l01363"></a>01363                               <span class="comment">// If the original hex was a boundary hex, add the new sub_tet&#39;s side</span>
<a name="l01364"></a>01364                               <span class="comment">// 0 with the same b_id.  Note: the tets are all aligned so that their</span>
<a name="l01365"></a>01365                               <span class="comment">// side 0 is on the boundary.</span>
<a name="l01366"></a>01366                               <span class="keywordflow">if</span> (b_id != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">BoundaryInfo::invalid_id</a>)
<a name="l01367"></a>01367                                 mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(sub_elem, 0, b_id);
<a name="l01368"></a>01368                             }
<a name="l01369"></a>01369                         } <span class="comment">// end if ((type == TET4) || (type == TET10))</span>
<a name="l01370"></a>01370 
<a name="l01371"></a>01371                       <span class="keywordflow">else</span> <span class="comment">// type==PYRAMID5</span>
<a name="l01372"></a>01372                         {
<a name="l01373"></a>01373                           <span class="comment">// Build 1 sub-pyramid per side.</span>
<a name="l01374"></a>01374                           new_elements.push_back(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Pyramid5.php">Pyramid5</a>);
<a name="l01375"></a>01375                           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* sub_elem = new_elements.back();
<a name="l01376"></a>01376                               
<a name="l01377"></a>01377                           <span class="comment">// Set the base.  Note that since the apex is *inside* the base_hex,</span>
<a name="l01378"></a>01378                           <span class="comment">// and the pyramid uses a counter-clockwise base numbering, we need to</span>
<a name="l01379"></a>01379                           <span class="comment">// reverse the [1] and [3] node indices.</span>
<a name="l01380"></a>01380                           sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = side-&gt;get_node(0);
<a name="l01381"></a>01381                           sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = side-&gt;get_node(3);
<a name="l01382"></a>01382                           sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = side-&gt;get_node(2);
<a name="l01383"></a>01383                           sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = side-&gt;get_node(1);
<a name="l01384"></a>01384                               
<a name="l01385"></a>01385                           <span class="comment">// Set the apex</span>
<a name="l01386"></a>01386                           sub_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = apex_node;
<a name="l01387"></a>01387                               
<a name="l01388"></a>01388                           <span class="comment">// If the original hex was a boundary hex, add the new sub_pyr&#39;s side</span>
<a name="l01389"></a>01389                           <span class="comment">// 4 (the square base) with the same b_id.  </span>
<a name="l01390"></a>01390                           <span class="keywordflow">if</span> (b_id != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">BoundaryInfo::invalid_id</a>)
<a name="l01391"></a>01391                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(sub_elem, 4, b_id);
<a name="l01392"></a>01392                         } <span class="comment">// end else type==PYRAMID5</span>
<a name="l01393"></a>01393                     }
<a name="l01394"></a>01394                 }
<a name="l01395"></a>01395             }
<a name="l01396"></a>01396             
<a name="l01397"></a>01397 
<a name="l01398"></a>01398             <span class="comment">// Delete the original HEX27 elements from the mesh, and the boundary info structure.</span>
<a name="l01399"></a>01399             {
<a name="l01400"></a>01400               <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01401"></a>01401               <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01402"></a>01402        
<a name="l01403"></a>01403               <span class="keywordflow">for</span> ( ; el != end_el;  ++el)
<a name="l01404"></a>01404                 {
<a name="l01405"></a>01405                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove(*el); <span class="comment">// Safe even if *el has no boundary info.</span>
<a name="l01406"></a>01406                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a>(*el);
<a name="l01407"></a>01407                 }
<a name="l01408"></a>01408             }
<a name="l01409"></a>01409 
<a name="l01410"></a>01410             <span class="comment">// Add the new elements</span>
<a name="l01411"></a>01411             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;new_elements.size(); ++i)
<a name="l01412"></a>01412               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(new_elements[i]);
<a name="l01413"></a>01413             
<a name="l01414"></a>01414           } <span class="comment">// end if (type == TET4,TET10,PYRAMID5</span>
<a name="l01415"></a>01415 
<a name="l01416"></a>01416 
<a name="l01417"></a>01417         <span class="comment">// Use all_second_order to convert the TET4&#39;s to TET10&#39;s</span>
<a name="l01418"></a>01418         <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>)
<a name="l01419"></a>01419           {
<a name="l01420"></a>01420             mesh.<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#adf74c2d3201889fe61af362800538680">all_second_order</a>();
<a name="l01421"></a>01421           }
<a name="l01422"></a>01422 
<a name="l01423"></a>01423         
<a name="l01424"></a>01424         <span class="keywordflow">break</span>;
<a name="l01425"></a>01425       } <span class="comment">// end case dim==3</span>
<a name="l01426"></a>01426 
<a name="l01427"></a>01427     <span class="keywordflow">default</span>:
<a name="l01428"></a>01428       {
<a name="l01429"></a>01429         libmesh_error();
<a name="l01430"></a>01430       }
<a name="l01431"></a>01431     }  
<a name="l01432"></a>01432 
<a name="l01433"></a>01433   STOP_LOG(<span class="stringliteral">&quot;build_cube()&quot;</span>, <span class="stringliteral">&quot;MeshTools::Generation&quot;</span>);
<a name="l01434"></a>01434 
<a name="l01435"></a>01435 
<a name="l01436"></a>01436   
<a name="l01437"></a>01437   <span class="comment">// Done building the mesh.  Now prepare it for use.</span>
<a name="l01438"></a>01438   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);  
<a name="l01439"></a>01439 }
<a name="l01440"></a>01440 
<a name="l01441"></a>01441 
<a name="l01442"></a>01442 
<a name="l01443"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a0292e2a29274c5a479807524457eb1a7">01443</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a0292e2a29274c5a479807524457eb1a7">MeshTools::Generation::build_point</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01444"></a>01444                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l01445"></a>01445                                          <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid)
<a name="l01446"></a>01446 {
<a name="l01447"></a>01447     <span class="comment">// This method only makes sense in 0D!</span>
<a name="l01448"></a>01448     <span class="comment">// But we now just turn a non-0D mesh into a 0D mesh</span>
<a name="l01449"></a>01449     <span class="comment">//libmesh_assert(mesh.mesh_dimension() == 1);</span>
<a name="l01450"></a>01450 
<a name="l01451"></a>01451     <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#adc26f45af62fb628158c7585d4171d01">build_cube</a>(mesh,
<a name="l01452"></a>01452                0, 0, 0,
<a name="l01453"></a>01453                0., 0.,
<a name="l01454"></a>01454                0., 0.,
<a name="l01455"></a>01455                0., 0.,
<a name="l01456"></a>01456                type,
<a name="l01457"></a>01457                gauss_lobatto_grid);
<a name="l01458"></a>01458 }
<a name="l01459"></a>01459                                         
<a name="l01460"></a>01460 
<a name="l01461"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#ad590f9cbf833bddb69fc812bf4434379">01461</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#ad590f9cbf833bddb69fc812bf4434379">MeshTools::Generation::build_line</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01462"></a>01462                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l01463"></a>01463                                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax,
<a name="l01464"></a>01464                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l01465"></a>01465                                         <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid)
<a name="l01466"></a>01466 {
<a name="l01467"></a>01467     <span class="comment">// This method only makes sense in 1D!</span>
<a name="l01468"></a>01468     <span class="comment">// But we now just turn a non-1D mesh into a 1D mesh</span>
<a name="l01469"></a>01469     <span class="comment">//libmesh_assert(mesh.mesh_dimension() == 1);</span>
<a name="l01470"></a>01470 
<a name="l01471"></a>01471     <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#adc26f45af62fb628158c7585d4171d01">build_cube</a>(mesh,
<a name="l01472"></a>01472                nx, 0, 0,
<a name="l01473"></a>01473                xmin, xmax,
<a name="l01474"></a>01474                0., 0.,
<a name="l01475"></a>01475                0., 0.,
<a name="l01476"></a>01476                type,
<a name="l01477"></a>01477                gauss_lobatto_grid);
<a name="l01478"></a>01478 }
<a name="l01479"></a>01479                                         
<a name="l01480"></a>01480 
<a name="l01481"></a>01481 
<a name="l01482"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a09ed2ca5dda1c38a23f7f44cf99cf617">01482</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a09ed2ca5dda1c38a23f7f44cf99cf617">MeshTools::Generation::build_square</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01483"></a>01483                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l01484"></a>01484                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny,
<a name="l01485"></a>01485                                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax,
<a name="l01486"></a>01486                                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax,
<a name="l01487"></a>01487                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l01488"></a>01488                                           <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid)
<a name="l01489"></a>01489 {
<a name="l01490"></a>01490   <span class="comment">// This method only makes sense in 2D!</span>
<a name="l01491"></a>01491   <span class="comment">// But we now just turn a non-2D mesh into a 2D mesh</span>
<a name="l01492"></a>01492   <span class="comment">//libmesh_assert (mesh.mesh_dimension() == 2);</span>
<a name="l01493"></a>01493 
<a name="l01494"></a>01494   <span class="comment">// Call the build_cube() member to actually do the work for us.</span>
<a name="l01495"></a>01495   <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#adc26f45af62fb628158c7585d4171d01">build_cube</a> (mesh,
<a name="l01496"></a>01496               nx, ny, 0,
<a name="l01497"></a>01497               xmin, xmax,
<a name="l01498"></a>01498               ymin, ymax,
<a name="l01499"></a>01499               0., 0.,
<a name="l01500"></a>01500               type,
<a name="l01501"></a>01501               gauss_lobatto_grid);
<a name="l01502"></a>01502 }
<a name="l01503"></a>01503 
<a name="l01504"></a>01504 
<a name="l01505"></a>01505 
<a name="l01506"></a>01506 
<a name="l01507"></a>01507 
<a name="l01508"></a>01508 
<a name="l01509"></a>01509 
<a name="l01510"></a>01510 
<a name="l01511"></a>01511 
<a name="l01512"></a>01512 <span class="preprocessor">#ifndef LIBMESH_ENABLE_AMR</span>
<a name="l01513"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#af94a54e1acc8f32e4fde70b0f3b73fed">01513</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#af94a54e1acc8f32e4fde70b0f3b73fed">MeshTools::Generation::build_sphere</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp;,
<a name="l01514"></a>01514                                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,
<a name="l01515"></a>01515                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01516"></a>01516                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>)
<a name="l01517"></a>01517 {
<a name="l01518"></a>01518         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Building a circle/sphere only works with AMR.&quot;</span> &lt;&lt; std::endl;
<a name="l01519"></a>01519         libmesh_error();
<a name="l01520"></a>01520 }
<a name="l01521"></a>01521 
<a name="l01522"></a>01522 <span class="preprocessor">#else</span>
<a name="l01523"></a>01523 <span class="preprocessor"></span>        
<a name="l01524"></a>01524 <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#af94a54e1acc8f32e4fde70b0f3b73fed">MeshTools::Generation::build_sphere</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01525"></a>01525                                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rad,
<a name="l01526"></a>01526                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nr,
<a name="l01527"></a>01527                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l01528"></a>01528 {
<a name="l01529"></a>01529   libmesh_assert (rad &gt; 0.);
<a name="l01530"></a>01530   <span class="comment">//libmesh_assert (nr &gt; 0); // must refine at least once otherwise will end up with a square/cube</span>
<a name="l01531"></a>01531   
<a name="l01532"></a>01532   START_LOG(<span class="stringliteral">&quot;build_sphere()&quot;</span>, <span class="stringliteral">&quot;MeshTools::Generation&quot;</span>);
<a name="l01533"></a>01533 
<a name="l01534"></a>01534   <span class="comment">// Clear the mesh and start from scratch</span>
<a name="l01535"></a>01535   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l01536"></a>01536   
<a name="l01537"></a>01537   <span class="comment">// Sphere is centered at origin by default</span>
<a name="l01538"></a>01538   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> cent;
<a name="l01539"></a>01539 
<a name="l01540"></a>01540   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> sphere (cent, rad);
<a name="l01541"></a>01541   
<a name="l01542"></a>01542   <span class="keywordflow">switch</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>())
<a name="l01543"></a>01543     {
<a name="l01544"></a>01544       <span class="comment">//-----------------------------------------------------------------</span>
<a name="l01545"></a>01545       <span class="comment">// Build a line in one dimension</span>
<a name="l01546"></a>01546     <span class="keywordflow">case</span> 1:
<a name="l01547"></a>01547       {
<a name="l01548"></a>01548         <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#ad590f9cbf833bddb69fc812bf4434379">build_line</a> (mesh, 3, -rad, rad, type);
<a name="l01549"></a>01549       }
<a name="l01550"></a>01550 
<a name="l01551"></a>01551 
<a name="l01552"></a>01552 
<a name="l01553"></a>01553 
<a name="l01554"></a>01554       <span class="comment">//-----------------------------------------------------------------</span>
<a name="l01555"></a>01555       <span class="comment">// Build a circle in two dimensions</span>
<a name="l01556"></a>01556     <span class="keywordflow">case</span> 2:
<a name="l01557"></a>01557       {
<a name="l01558"></a>01558         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sqrt_2     = std::sqrt(2.);
<a name="l01559"></a>01559         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rad_2      = .25*rad;
<a name="l01560"></a>01560         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rad_sqrt_2 = rad/sqrt_2;
<a name="l01561"></a>01561 
<a name="l01562"></a>01562         <span class="comment">// (Temporary) convenient storage for node pointers</span>
<a name="l01563"></a>01563         std::vector&lt;Node*&gt; nodes(8);
<a name="l01564"></a>01564             
<a name="l01565"></a>01565         <span class="comment">// Point 0</span>
<a name="l01566"></a>01566         nodes[0] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(-rad_2,-rad_2, 0.));
<a name="l01567"></a>01567             
<a name="l01568"></a>01568         <span class="comment">// Point 1</span>
<a name="l01569"></a>01569         nodes[1] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>( rad_2,-rad_2, 0.));
<a name="l01570"></a>01570             
<a name="l01571"></a>01571         <span class="comment">// Point 2</span>
<a name="l01572"></a>01572         nodes[2] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>( rad_2, rad_2, 0.));
<a name="l01573"></a>01573 
<a name="l01574"></a>01574         <span class="comment">// Point 3</span>
<a name="l01575"></a>01575         nodes[3] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(-rad_2, rad_2, 0.));
<a name="l01576"></a>01576             
<a name="l01577"></a>01577         <span class="comment">// Point 4</span>
<a name="l01578"></a>01578         nodes[4] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(-rad_sqrt_2,-rad_sqrt_2, 0.));
<a name="l01579"></a>01579             
<a name="l01580"></a>01580         <span class="comment">// Point 5</span>
<a name="l01581"></a>01581         nodes[5] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>( rad_sqrt_2,-rad_sqrt_2, 0.));
<a name="l01582"></a>01582             
<a name="l01583"></a>01583         <span class="comment">// Point 6</span>
<a name="l01584"></a>01584         nodes[6] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>( rad_sqrt_2, rad_sqrt_2, 0.));
<a name="l01585"></a>01585             
<a name="l01586"></a>01586         <span class="comment">// Point 7</span>
<a name="l01587"></a>01587         nodes[7] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(-rad_sqrt_2, rad_sqrt_2, 0.));
<a name="l01588"></a>01588 
<a name="l01589"></a>01589         <span class="comment">// Build the elements &amp; set node pointers</span>
<a name="l01590"></a>01590             
<a name="l01591"></a>01591         <span class="comment">// Element 0</span>
<a name="l01592"></a>01592         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem0 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>);
<a name="l01593"></a>01593         elem0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[0];
<a name="l01594"></a>01594         elem0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = nodes[1];
<a name="l01595"></a>01595         elem0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = nodes[2];
<a name="l01596"></a>01596         elem0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = nodes[3];
<a name="l01597"></a>01597             
<a name="l01598"></a>01598         <span class="comment">// Element 1</span>
<a name="l01599"></a>01599         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem1 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>);
<a name="l01600"></a>01600         elem1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[4];
<a name="l01601"></a>01601         elem1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = nodes[0];
<a name="l01602"></a>01602         elem1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = nodes[3];
<a name="l01603"></a>01603         elem1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = nodes[7];
<a name="l01604"></a>01604             
<a name="l01605"></a>01605         <span class="comment">// Element 2</span>
<a name="l01606"></a>01606         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem2 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>);
<a name="l01607"></a>01607         elem2-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[4];
<a name="l01608"></a>01608         elem2-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = nodes[5];
<a name="l01609"></a>01609         elem2-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = nodes[1];
<a name="l01610"></a>01610         elem2-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = nodes[0];
<a name="l01611"></a>01611             
<a name="l01612"></a>01612         <span class="comment">// Element 3</span>
<a name="l01613"></a>01613         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem3 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>);
<a name="l01614"></a>01614         elem3-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[1];
<a name="l01615"></a>01615         elem3-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = nodes[5];
<a name="l01616"></a>01616         elem3-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = nodes[6];
<a name="l01617"></a>01617         elem3-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = nodes[2];
<a name="l01618"></a>01618             
<a name="l01619"></a>01619         <span class="comment">// Element 4</span>
<a name="l01620"></a>01620         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem4 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>);
<a name="l01621"></a>01621         elem4-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[3];
<a name="l01622"></a>01622         elem4-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = nodes[2];
<a name="l01623"></a>01623         elem4-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = nodes[6];
<a name="l01624"></a>01624         elem4-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = nodes[7];
<a name="l01625"></a>01625 
<a name="l01626"></a>01626         <span class="keywordflow">break</span>;
<a name="l01627"></a>01627       } <span class="comment">// end case 2</span>
<a name="l01628"></a>01628 
<a name="l01629"></a>01629 
<a name="l01630"></a>01630       
<a name="l01631"></a>01631 
<a name="l01632"></a>01632       
<a name="l01633"></a>01633       <span class="comment">//-----------------------------------------------------------------</span>
<a name="l01634"></a>01634       <span class="comment">// Build a sphere in three dimensions</span>
<a name="l01635"></a>01635     <span class="keywordflow">case</span> 3:
<a name="l01636"></a>01636       {
<a name="l01637"></a>01637         <span class="comment">// (Currently) supported types</span>
<a name="l01638"></a>01638         <span class="keywordflow">if</span> (!((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>)))
<a name="l01639"></a>01639           {
<a name="l01640"></a>01640             <span class="comment">// FIXME: We&#39;d need an all_tet() routine (which could also be used by</span>
<a name="l01641"></a>01641             <span class="comment">// build_square()) to do Tets, or Prisms for that matter.</span>
<a name="l01642"></a>01642             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Only HEX8/27 currently supported.&quot;</span>
<a name="l01643"></a>01643                           &lt;&lt; std::endl;
<a name="l01644"></a>01644             libmesh_error();
<a name="l01645"></a>01645           }
<a name="l01646"></a>01646 
<a name="l01647"></a>01647         
<a name="l01648"></a>01648         <span class="comment">// 3D analog of 2D initial grid:</span>
<a name="l01649"></a>01649         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l01650"></a>01650           r_small = 0.25*rad,                      <span class="comment">//  0.25 *radius</span>
<a name="l01651"></a>01651           r_med   = (0.125*std::sqrt(2.)+0.5)*rad; <span class="comment">// .67677*radius </span>
<a name="l01652"></a>01652         
<a name="l01653"></a>01653         <span class="comment">// (Temporary) convenient storage for node pointers</span>
<a name="l01654"></a>01654         std::vector&lt;Node*&gt; nodes(16);
<a name="l01655"></a>01655         
<a name="l01656"></a>01656         <span class="comment">// Points 0-7 are the initial HEX8</span>
<a name="l01657"></a>01657         nodes[0] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_small,-r_small, -r_small));
<a name="l01658"></a>01658         nodes[1] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_small,-r_small, -r_small));
<a name="l01659"></a>01659         nodes[2] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_small, r_small, -r_small));
<a name="l01660"></a>01660         nodes[3] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_small, r_small, -r_small));
<a name="l01661"></a>01661         nodes[4] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_small,-r_small,  r_small));
<a name="l01662"></a>01662         nodes[5] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_small,-r_small,  r_small));
<a name="l01663"></a>01663         nodes[6] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_small, r_small,  r_small));
<a name="l01664"></a>01664         nodes[7] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_small, r_small,  r_small));
<a name="l01665"></a>01665 
<a name="l01666"></a>01666         <span class="comment">//  Points 8-15 are for the outer hexes, we number them in the same way</span>
<a name="l01667"></a>01667         nodes[8]  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_med,-r_med, -r_med));
<a name="l01668"></a>01668         nodes[9]  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_med,-r_med, -r_med));
<a name="l01669"></a>01669         nodes[10] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_med, r_med, -r_med));
<a name="l01670"></a>01670         nodes[11] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_med, r_med, -r_med));
<a name="l01671"></a>01671         nodes[12] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_med,-r_med,  r_med));
<a name="l01672"></a>01672         nodes[13] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_med,-r_med,  r_med));
<a name="l01673"></a>01673         nodes[14] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point( r_med, r_med,  r_med));
<a name="l01674"></a>01674         nodes[15] = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (Point(-r_med, r_med,  r_med));
<a name="l01675"></a>01675 
<a name="l01676"></a>01676         <span class="comment">// Now create the elements and add them to the mesh</span>
<a name="l01677"></a>01677         <span class="comment">// Element 0 - center element</span>
<a name="l01678"></a>01678         {
<a name="l01679"></a>01679           Elem* elem0 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01680"></a>01680           elem0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[0];
<a name="l01681"></a>01681           elem0-&gt;set_node(1) = nodes[1];
<a name="l01682"></a>01682           elem0-&gt;set_node(2) = nodes[2];
<a name="l01683"></a>01683           elem0-&gt;set_node(3) = nodes[3];
<a name="l01684"></a>01684           elem0-&gt;set_node(4) = nodes[4];
<a name="l01685"></a>01685           elem0-&gt;set_node(5) = nodes[5];
<a name="l01686"></a>01686           elem0-&gt;set_node(6) = nodes[6];
<a name="l01687"></a>01687           elem0-&gt;set_node(7) = nodes[7];
<a name="l01688"></a>01688         }
<a name="l01689"></a>01689         
<a name="l01690"></a>01690         <span class="comment">// Element 1 - &quot;bottom&quot;</span>
<a name="l01691"></a>01691         {
<a name="l01692"></a>01692           Elem* elem1 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01693"></a>01693           elem1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[8];
<a name="l01694"></a>01694           elem1-&gt;set_node(1) = nodes[9];
<a name="l01695"></a>01695           elem1-&gt;set_node(2) = nodes[10];
<a name="l01696"></a>01696           elem1-&gt;set_node(3) = nodes[11];
<a name="l01697"></a>01697           elem1-&gt;set_node(4) = nodes[0];
<a name="l01698"></a>01698           elem1-&gt;set_node(5) = nodes[1];
<a name="l01699"></a>01699           elem1-&gt;set_node(6) = nodes[2];
<a name="l01700"></a>01700           elem1-&gt;set_node(7) = nodes[3];
<a name="l01701"></a>01701         }
<a name="l01702"></a>01702         
<a name="l01703"></a>01703         <span class="comment">// Element 2 - &quot;front&quot;</span>
<a name="l01704"></a>01704         {
<a name="l01705"></a>01705           Elem* elem2 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01706"></a>01706           elem2-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[8];
<a name="l01707"></a>01707           elem2-&gt;set_node(1) = nodes[9];
<a name="l01708"></a>01708           elem2-&gt;set_node(2) = nodes[1];
<a name="l01709"></a>01709           elem2-&gt;set_node(3) = nodes[0];
<a name="l01710"></a>01710           elem2-&gt;set_node(4) = nodes[12];
<a name="l01711"></a>01711           elem2-&gt;set_node(5) = nodes[13];
<a name="l01712"></a>01712           elem2-&gt;set_node(6) = nodes[5];
<a name="l01713"></a>01713           elem2-&gt;set_node(7) = nodes[4];
<a name="l01714"></a>01714         }
<a name="l01715"></a>01715 
<a name="l01716"></a>01716         <span class="comment">// Element 3 - &quot;right&quot;</span>
<a name="l01717"></a>01717         {
<a name="l01718"></a>01718           Elem* elem3 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01719"></a>01719           elem3-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[1];
<a name="l01720"></a>01720           elem3-&gt;set_node(1) = nodes[9];
<a name="l01721"></a>01721           elem3-&gt;set_node(2) = nodes[10];
<a name="l01722"></a>01722           elem3-&gt;set_node(3) = nodes[2];
<a name="l01723"></a>01723           elem3-&gt;set_node(4) = nodes[5];
<a name="l01724"></a>01724           elem3-&gt;set_node(5) = nodes[13];
<a name="l01725"></a>01725           elem3-&gt;set_node(6) = nodes[14];
<a name="l01726"></a>01726           elem3-&gt;set_node(7) = nodes[6];
<a name="l01727"></a>01727         }
<a name="l01728"></a>01728 
<a name="l01729"></a>01729         <span class="comment">// Element 4 - &quot;back&quot;</span>
<a name="l01730"></a>01730         {
<a name="l01731"></a>01731           Elem* elem4 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01732"></a>01732           elem4-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[3];
<a name="l01733"></a>01733           elem4-&gt;set_node(1) = nodes[2];
<a name="l01734"></a>01734           elem4-&gt;set_node(2) = nodes[10];
<a name="l01735"></a>01735           elem4-&gt;set_node(3) = nodes[11];
<a name="l01736"></a>01736           elem4-&gt;set_node(4) = nodes[7];
<a name="l01737"></a>01737           elem4-&gt;set_node(5) = nodes[6];
<a name="l01738"></a>01738           elem4-&gt;set_node(6) = nodes[14];
<a name="l01739"></a>01739           elem4-&gt;set_node(7) = nodes[15];
<a name="l01740"></a>01740         }
<a name="l01741"></a>01741 
<a name="l01742"></a>01742         <span class="comment">// Element 5 - &quot;left&quot;</span>
<a name="l01743"></a>01743         {
<a name="l01744"></a>01744           Elem* elem5 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01745"></a>01745           elem5-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[8];
<a name="l01746"></a>01746           elem5-&gt;set_node(1) = nodes[0];
<a name="l01747"></a>01747           elem5-&gt;set_node(2) = nodes[3];
<a name="l01748"></a>01748           elem5-&gt;set_node(3) = nodes[11];
<a name="l01749"></a>01749           elem5-&gt;set_node(4) = nodes[12];
<a name="l01750"></a>01750           elem5-&gt;set_node(5) = nodes[4];
<a name="l01751"></a>01751           elem5-&gt;set_node(6) = nodes[7];
<a name="l01752"></a>01752           elem5-&gt;set_node(7) = nodes[15];
<a name="l01753"></a>01753         }
<a name="l01754"></a>01754 
<a name="l01755"></a>01755         <span class="comment">// Element 6 - &quot;top&quot;</span>
<a name="l01756"></a>01756         {
<a name="l01757"></a>01757           Elem* elem6 = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<span class="keyword">new</span> Hex8);
<a name="l01758"></a>01758           elem6-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = nodes[4];
<a name="l01759"></a>01759           elem6-&gt;set_node(1) = nodes[5];
<a name="l01760"></a>01760           elem6-&gt;set_node(2) = nodes[6];
<a name="l01761"></a>01761           elem6-&gt;set_node(3) = nodes[7];
<a name="l01762"></a>01762           elem6-&gt;set_node(4) = nodes[12];
<a name="l01763"></a>01763           elem6-&gt;set_node(5) = nodes[13];
<a name="l01764"></a>01764           elem6-&gt;set_node(6) = nodes[14];
<a name="l01765"></a>01765           elem6-&gt;set_node(7) = nodes[15];
<a name="l01766"></a>01766         }
<a name="l01767"></a>01767         
<a name="l01768"></a>01768         <span class="keywordflow">break</span>;
<a name="l01769"></a>01769       } <span class="comment">// end case 3</span>
<a name="l01770"></a>01770       
<a name="l01771"></a>01771     <span class="keywordflow">default</span>:
<a name="l01772"></a>01772       libmesh_error();
<a name="l01773"></a>01773       
<a name="l01774"></a>01774     } <span class="comment">// end switch (dim)</span>
<a name="l01775"></a>01775 
<a name="l01776"></a>01776   
<a name="l01777"></a>01777         
<a name="l01778"></a>01778   <span class="comment">// Now we have the beginnings of a sphere.</span>
<a name="l01779"></a>01779   <span class="comment">// Add some more elements by doing uniform refinements and</span>
<a name="l01780"></a>01780   <span class="comment">// popping nodes to the boundary.</span>
<a name="l01781"></a>01781   MeshRefinement mesh_refinement (mesh);
<a name="l01782"></a>01782 
<a name="l01783"></a>01783   <span class="comment">// Loop over the elements, refine, pop nodes to boundary.</span>
<a name="l01784"></a>01784   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;nr; r++)
<a name="l01785"></a>01785     {
<a name="l01786"></a>01786       mesh_refinement.uniformly_refine(1);
<a name="l01787"></a>01787 
<a name="l01788"></a>01788       MeshBase::element_iterator       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01789"></a>01789       <span class="keyword">const</span> MeshBase::element_iterator end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01790"></a>01790 
<a name="l01791"></a>01791       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01792"></a>01792         {
<a name="l01793"></a>01793           Elem* elem = *it;
<a name="l01794"></a>01794                 
<a name="l01795"></a>01795           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;n_sides(); s++)
<a name="l01796"></a>01796             <span class="keywordflow">if</span> (elem-&gt;neighbor(s) == NULL)
<a name="l01797"></a>01797               {
<a name="l01798"></a>01798                 AutoPtr&lt;Elem&gt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;build_side(s));
<a name="l01799"></a>01799 
<a name="l01800"></a>01800                 <span class="comment">// Pop each point to the sphere boundary</span>
<a name="l01801"></a>01801                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); n++)
<a name="l01802"></a>01802                   <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;point(n) =
<a name="l01803"></a>01803                     sphere.closest_point(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;point(n));
<a name="l01804"></a>01804               }
<a name="l01805"></a>01805         }
<a name="l01806"></a>01806       }
<a name="l01807"></a>01807 
<a name="l01808"></a>01808   <span class="comment">// The mesh now contains a refinement hierarchy due to the refinements</span>
<a name="l01809"></a>01809   <span class="comment">// used to generate the grid.  In order to call other support functions</span>
<a name="l01810"></a>01810   <span class="comment">// like all_tri() and all_second_order, you need a &quot;flat&quot; mesh file (with no</span>
<a name="l01811"></a>01811   <span class="comment">// refinement trees) so</span>
<a name="l01812"></a>01812   <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a31ce3f7f69838b3326f9bcabae3f2cd6">MeshTools::Modification::flatten</a>(mesh);
<a name="l01813"></a>01813 
<a name="l01814"></a>01814   <span class="comment">// In 2D, convert all the quads to triangles if requested</span>
<a name="l01815"></a>01815   <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>()==2)
<a name="l01816"></a>01816     {
<a name="l01817"></a>01817       <span class="keywordflow">if</span> ((type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>) || (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>))
<a name="l01818"></a>01818         {
<a name="l01819"></a>01819           <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a249f04550c345984831d08e013155668">MeshTools::Modification::all_tri</a>(mesh);
<a name="l01820"></a>01820         }
<a name="l01821"></a>01821     }
<a name="l01822"></a>01822 
<a name="l01823"></a>01823   
<a name="l01824"></a>01824   <span class="comment">// Convert to second-order elements if the user requested it.</span>
<a name="l01825"></a>01825   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#a877984e054cff62d2205a2a6c57cde0a">Elem::second_order_equivalent_type</a>(type) == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>)
<a name="l01826"></a>01826     {
<a name="l01827"></a>01827       <span class="comment">// type is already a second-order, determine if it is the</span>
<a name="l01828"></a>01828       <span class="comment">// &quot;full-ordered&quot; second-order element, or the &quot;serendipity&quot;</span>
<a name="l01829"></a>01829       <span class="comment">// second order element.  Note also that all_second_order</span>
<a name="l01830"></a>01830       <span class="comment">// can&#39;t be called once the mesh has been refined.</span>
<a name="l01831"></a>01831       <span class="keywordtype">bool</span> full_ordered = !((type==<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>) || (type==<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>));
<a name="l01832"></a>01832       mesh.<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#adf74c2d3201889fe61af362800538680">all_second_order</a>(full_ordered);
<a name="l01833"></a>01833 
<a name="l01834"></a>01834       <span class="comment">// And pop to the boundary again...</span>
<a name="l01835"></a>01835       MeshBase::element_iterator       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01836"></a>01836       <span class="keyword">const</span> MeshBase::element_iterator end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01837"></a>01837 
<a name="l01838"></a>01838       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01839"></a>01839         {
<a name="l01840"></a>01840           Elem* elem = *it;
<a name="l01841"></a>01841                 
<a name="l01842"></a>01842           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;n_sides(); s++)
<a name="l01843"></a>01843             <span class="keywordflow">if</span> (elem-&gt;neighbor(s) == NULL)
<a name="l01844"></a>01844               {
<a name="l01845"></a>01845                 AutoPtr&lt;Elem&gt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;build_side(s));
<a name="l01846"></a>01846 
<a name="l01847"></a>01847                 <span class="comment">// Pop each point to the sphere boundary</span>
<a name="l01848"></a>01848                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); n++)
<a name="l01849"></a>01849                   <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;point(n) =
<a name="l01850"></a>01850                     sphere.closest_point(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;point(n));
<a name="l01851"></a>01851               }
<a name="l01852"></a>01852         }
<a name="l01853"></a>01853     }
<a name="l01854"></a>01854   
<a name="l01855"></a>01855 
<a name="l01856"></a>01856   <span class="comment">// The meshes could probably use some smoothing...</span>
<a name="l01857"></a>01857   LaplaceMeshSmoother smoother(mesh);
<a name="l01858"></a>01858   smoother.smooth(2);
<a name="l01859"></a>01859   
<a name="l01860"></a>01860   STOP_LOG(<span class="stringliteral">&quot;build_sphere()&quot;</span>, <span class="stringliteral">&quot;MeshTools::Generation&quot;</span>);
<a name="l01861"></a>01861 
<a name="l01862"></a>01862   
<a name="l01863"></a>01863   <span class="comment">// Done building the mesh.  Now prepare it for use.</span>
<a name="l01864"></a>01864   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l01865"></a>01865 }
<a name="l01866"></a>01866 
<a name="l01867"></a>01867 <span class="preprocessor">#endif // #ifndef LIBMESH_ENABLE_AMR</span>
<a name="l01868"></a>01868 <span class="preprocessor"></span>
<a name="l01869"></a>01869 
<a name="l01870"></a>01870 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
