<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_smoother_vsmoother.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__smoother__vsmoother_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother_vsmoother.C 4306 2011-03-30 16:15:50Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#ifdef LIBMESH_ENABLE_VSMOOTHER</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::copy, std::sort</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;math.h&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;time.h&gt;</span> <span class="comment">// for clock_t, clock()</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__smoother__vsmoother_8h.php">mesh_smoother_vsmoother.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Optimization at -O2 or greater seem to break Intel&#39;s icc. So if we are</span>
<a name="l00041"></a>00041 <span class="comment">// being compiled with icc let&#39;s dumb-down the optimizations for this file</span>
<a name="l00042"></a>00042 <span class="preprocessor">#ifdef __INTEL_COMPILER</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#  pragma optimize ( &quot;&quot;, off )</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="comment">// Member functions for the Variational Smoother</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a28f5b5fafb97f5753f4167118378f43b">00047</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af079f6eb1f4ea95a3599a662baa556ee">VariationalMeshSmoother::smooth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <span class="keywordtype">int</span> n, me, gr, adp, miniter, miniterBC, maxiter, N, ncells, nedges, s, <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">err</a>=0;
<a name="l00050"></a>00050   <span class="keywordtype">double</span> theta;
<a name="l00051"></a>00051   <span class="keywordtype">char</span> grid[40], metr[40], grid_old[40], adap[40];
<a name="l00052"></a>00052 <span class="comment">//  FILE *stream;</span>
<a name="l00053"></a>00053   <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H;
<a name="l00054"></a>00054   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R;
<a name="l00055"></a>00055   <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells;
<a name="l00056"></a>00056   <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, edges, mcells, hnodes;
<a name="l00057"></a>00057   <span class="keywordtype">int</span> iter[4],i,j;
<a name="l00058"></a>00058   clock_t ticks1, ticks2;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   FILE *sout;
<a name="l00061"></a>00061   sout=fopen(<span class="stringliteral">&quot;smoother.out&quot;</span>,<span class="stringliteral">&quot;wr&quot;</span>);<span class="comment">//stdout;</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   n=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>;
<a name="l00064"></a>00064   me=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1afd2243593f9bfb12f663be2da5ec04">_metric</a>;
<a name="l00065"></a>00065   gr=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a37194033786670d51c4395d33e100cb0">_generate_data</a>?0:1;
<a name="l00066"></a>00066   adp=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac860cbe58bfa793085677352ec1a8f70">_adaptive_func</a>;
<a name="l00067"></a>00067   theta=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a21ace46583ecafb4ba33032fd21c12bd">_theta</a>;
<a name="l00068"></a>00068   miniter=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa0ed679cb6ea0e07b52cc95bfe05013e">_miniter</a>;
<a name="l00069"></a>00069   maxiter=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aba9e0c523e0efe0cbf08e574de8eb48c">_maxiter</a>;
<a name="l00070"></a>00070   miniterBC=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a02f2826b12a74bfe7bdf36baf467383d">_miniterBC</a>;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keywordflow">if</span>((gr==0)&amp;&amp;(me&gt;1))
<a name="l00073"></a>00073   {
<a name="l00074"></a>00074     <span class="keywordflow">for</span>(i=0;i&lt;40;i++) grid_old[i]=grid[i];
<a name="l00075"></a>00075       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a52a126c779d4646296ad65a0c0a92d23">metr_data_gen</a>(grid, metr, n, me, sout); <span class="comment">//generate metric from initial mesh (me=2,3)</span>
<a name="l00076"></a>00076   }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   s=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>;
<a name="l00079"></a>00079   N=<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00080"></a>00080   ncells=<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>();
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">//I wish I could do this in readgr... but the way she allocs</span>
<a name="l00083"></a>00083   <span class="comment">//memory we need to do this here... or pass a lot of things around</span>
<a name="l00084"></a>00084   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a693646efaadc6206730b7bd1bf4d5978">MeshTools::find_hanging_nodes_and_parents</a>(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>,<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a4af429062348bf93b94cf4b9e8987b52">_hanging_nodes</a>);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   nedges=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a4af429062348bf93b94cf4b9e8987b52">_hanging_nodes</a>.size();
<a name="l00087"></a>00087   <span class="comment">//nedges=0;</span>
<a name="l00088"></a>00088   <span class="keywordflow">if</span>(s!=n){ fprintf(sout,<span class="stringliteral">&quot;Error: dim in input file is inconsistent with dim in .cfg \n&quot;</span>); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>; }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   mask=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(N);
<a name="l00091"></a>00091   edges=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(2*nedges);
<a name="l00092"></a>00092   mcells=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(ncells);
<a name="l00093"></a>00093   hnodes=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(nedges);
<a name="l00094"></a>00094   H=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">alloc_d_n1_n2_n3</a>(ncells,n,n);
<a name="l00095"></a>00095   R=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(N,n);
<a name="l00096"></a>00096   cells=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aea218377addb1242650692248f082794">alloc_i_n1_n2</a>(ncells,3*n+n%2);
<a name="l00097"></a>00097   <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++){
<a name="l00098"></a>00098      cells[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(3*n+n%2);
<a name="l00099"></a>00099          <span class="keywordflow">if</span>(me&gt;1){
<a name="l00100"></a>00100                  H[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(n,n);
<a name="l00101"></a>00101                  <span class="keywordflow">for</span>(j=0;j&lt;n;j++) H[i][j]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l00102"></a>00102          }
<a name="l00103"></a>00103   }
<a name="l00104"></a>00104   <span class="keywordflow">for</span>(i=0;i&lt;N;i++) R[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">/*----------initial grid---------*/</span>
<a name="l00107"></a>00107   err=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3e4f20c7407b7c07bbaf7ad0bdbc77b4">readgr</a>(n,N,R,mask,ncells,cells,mcells,nedges,edges,hnodes,sout);
<a name="l00108"></a>00108   <span class="keywordflow">if</span>(err&lt;0) {fprintf(sout,<span class="stringliteral">&quot;Error reading input mesh file\n&quot;</span>); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>;}
<a name="l00109"></a>00109   <span class="keywordflow">if</span>(me&gt;1) err=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1695f359003a8e2cf7c9a083b7ae6911">readmetr</a>(metr,H,ncells,n,sout);
<a name="l00110"></a>00110   <span class="keywordflow">if</span>(err&lt;0) {fprintf(sout,<span class="stringliteral">&quot;Error reading metric file\n&quot;</span>); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>;}
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   iter[0]=miniter; iter[1]=maxiter; iter[2]=miniterBC;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">/*---------grid optimization--------*/</span>
<a name="l00116"></a>00116   fprintf(sout,<span class="stringliteral">&quot;Starting Grid Optimization \n&quot;</span>);
<a name="l00117"></a>00117   ticks1=clock();
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a73c40468cbbbcc85f6cc763c56ad4005">full_smooth</a>(n,N,R,mask,ncells,cells,mcells,nedges,edges,hnodes,theta,iter,me,H,adp,adap,gr,sout);
<a name="l00119"></a>00119   ticks2=clock();
<a name="l00120"></a>00120   fprintf(sout,<span class="stringliteral">&quot;full_smooth took (%d-%d)/%ld = %ld seconds \n&quot;</span>,
<a name="l00121"></a>00121           (<span class="keywordtype">int</span>)ticks2,(<span class="keywordtype">int</span>)ticks1,(<span class="keywordtype">long</span> <span class="keywordtype">int</span>)CLOCKS_PER_SEC,(<span class="keywordtype">long</span> <span class="keywordtype">int</span>)(ticks2-ticks1)/CLOCKS_PER_SEC);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">/*---------save result---------*/</span>
<a name="l00124"></a>00124   fprintf(sout,<span class="stringliteral">&quot;Saving Result \n&quot;</span>);
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3df91a4b440e5a71471316258deff34a">writegr</a>(n,N,R,mask,ncells,cells,mcells,nedges,edges,hnodes,<span class="stringliteral">&quot;fin_grid.dat&quot;</span>, 4-me+3*gr, grid_old, sout);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordflow">for</span>(i=0;i&lt;N;i++) free(R[i]);
<a name="l00128"></a>00128   <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++){
<a name="l00129"></a>00129           <span class="keywordflow">if</span>(me&gt;1){
<a name="l00130"></a>00130                   <span class="keywordflow">for</span>(j=0;j&lt;n;j++) free(H[i][j]);
<a name="l00131"></a>00131                   free(H[i]);
<a name="l00132"></a>00132           }
<a name="l00133"></a>00133      free(cells[i]);
<a name="l00134"></a>00134   }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   free(cells);
<a name="l00137"></a>00137   free(H);
<a name="l00138"></a>00138   free(R);
<a name="l00139"></a>00139   free(mask);
<a name="l00140"></a>00140   free(edges);
<a name="l00141"></a>00141   free(mcells);
<a name="l00142"></a>00142   free(hnodes);
<a name="l00143"></a>00143   <span class="comment">//fclose(sout);</span>
<a name="l00144"></a>00144   libmesh_assert(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a> &gt; 0);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>;
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00152"></a>00152 <span class="comment">//int VariationalMeshSmoother::writegr(int n, int N, LPLPDOUBLE R, LPINT mask, int ncells, LPLPINT cells,</span>
<a name="l00153"></a>00153 <span class="comment">//            LPINT mcells, int nedges, LPINT edges, LPINT hnodes, char grid[], int me, char grid_old[], FILE *sout)</span>
<a name="l00154"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3df91a4b440e5a71471316258deff34a">00154</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3df91a4b440e5a71471316258deff34a">VariationalMeshSmoother::writegr</a>(<span class="keywordtype">int</span>, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a>,
<a name="l00155"></a>00155             <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>, <span class="keyword">const</span> <span class="keywordtype">char</span> [], <span class="keywordtype">int</span>, <span class="keyword">const</span> <span class="keywordtype">char</span> [], FILE*)
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Starting writegr&quot;</span>&lt;&lt;std::endl;
<a name="l00158"></a>00158   <span class="keywordtype">int</span> i;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">//Adjust nodal coordinates to new positions</span>
<a name="l00161"></a>00161   {
<a name="l00162"></a>00162     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       it  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00163"></a>00163     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     libmesh_assert(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a> == 0.0);
<a name="l00166"></a>00166     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>=0;
<a name="l00167"></a>00167     i=0;
<a name="l00168"></a>00168     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00169"></a>00169     {
<a name="l00170"></a>00170       <span class="keywordtype">double</span> total_dist=0.0;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172       <span class="comment">//For each node set its X Y [Z] coordinates</span>
<a name="l00173"></a>00173       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>;j++)
<a name="l00174"></a>00174       {
<a name="l00175"></a>00175         <span class="keywordtype">double</span> distance = R[i][j]-(*(*it))(j);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         <span class="comment">//Save the squares of the distance</span>
<a name="l00178"></a>00178         total_dist+=<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">Utility::pow&lt;2&gt;</a>(distance);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180         (*(*it))(j)=(*(*it))(j)+(distance*<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3833cbb0ab5132da618a9fbc2e502c7c">_percent_to_move</a>);
<a name="l00181"></a>00181       }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       libmesh_assert(total_dist &gt;= 0.0);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185       <span class="comment">//Add the distance this node moved to the global distance</span>
<a name="l00186"></a>00186       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>+=total_dist;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       i++;
<a name="l00189"></a>00189     }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191     <span class="comment">//Relative &quot;error&quot;</span>
<a name="l00192"></a>00192     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>=sqrt(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>/<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00193"></a>00193   }
<a name="l00194"></a>00194   <span class="comment">/*</span>
<a name="l00195"></a>00195 <span class="comment">int scanned;</span>
<a name="l00196"></a>00196 <span class="comment">if(me&gt;=3){</span>
<a name="l00197"></a>00197 <span class="comment">        fprintf(stream,&quot;%d \n%d \n%d \n%d \n&quot;,n,N,ncells,nedges);</span>
<a name="l00198"></a>00198 <span class="comment"></span>
<a name="l00199"></a>00199 <span class="comment">    for(i=0;i&lt;N;i++){//node coordinates</span>
<a name="l00200"></a>00200 <span class="comment">            for(unsigned int j=0;j&lt;n;j++) fprintf(stream,&quot;%e &quot;,R[i][j]);</span>
<a name="l00201"></a>00201 <span class="comment">        fprintf(stream,&quot;%d \n&quot;,mask[i]);</span>
<a name="l00202"></a>00202 <span class="comment">    }</span>
<a name="l00203"></a>00203 <span class="comment">    for(i=0;i&lt;ncells;i++){//cell connectivity</span>
<a name="l00204"></a>00204 <span class="comment">            int nvert=0;</span>
<a name="l00205"></a>00205 <span class="comment">            while(cells[i][nvert]&gt;=0){</span>
<a name="l00206"></a>00206 <span class="comment">               fprintf(stream,&quot;%d &quot;,cells[i][nvert]);</span>
<a name="l00207"></a>00207 <span class="comment">               nvert++;</span>
<a name="l00208"></a>00208 <span class="comment">            }</span>
<a name="l00209"></a>00209 <span class="comment">            for(unsigned int j=nvert;j&lt;3*n+n%2;j++) fprintf(stream,&quot;-1 &quot;);</span>
<a name="l00210"></a>00210 <span class="comment">            fprintf(stream,&quot;%d \n&quot;,mcells[i]);</span>
<a name="l00211"></a>00211 <span class="comment">        }</span>
<a name="l00212"></a>00212 <span class="comment">    //hanging nodes on edges</span>
<a name="l00213"></a>00213 <span class="comment">    for(i=0;i&lt;nedges;i++) fprintf(stream,&quot;%d %d %d \n&quot;,edges[2*i],edges[2*i+1],hnodes[i]);</span>
<a name="l00214"></a>00214 <span class="comment">} else {//restoring original grid connectivity when me&gt;1</span>
<a name="l00215"></a>00215 <span class="comment">        int lo, Ncells;</span>
<a name="l00216"></a>00216 <span class="comment">        double d1;</span>
<a name="l00217"></a>00217 <span class="comment">        stream1=fopen(grid_old,&quot;r&quot;);</span>
<a name="l00218"></a>00218 <span class="comment">        scanned = fscanf(stream1,&quot;%d \n%d \n%d \n%d \n&quot;,&amp;lo,&amp;i,&amp;Ncells,&amp;nedges);</span>
<a name="l00219"></a>00219 <span class="comment">        libmesh_assert(scanned != EOF);</span>
<a name="l00220"></a>00220 <span class="comment">        fprintf(stream,&quot;%d \n%d \n%d \n%d \n&quot;,n,N,Ncells,nedges);</span>
<a name="l00221"></a>00221 <span class="comment"></span>
<a name="l00222"></a>00222 <span class="comment">        for(i=0;i&lt;N;i++){//node coordinates</span>
<a name="l00223"></a>00223 <span class="comment">                for(unsigned int j=0;j&lt;n;j++) {fprintf(stream,&quot;%e &quot;,R[i][j]);</span>
<a name="l00224"></a>00224 <span class="comment">                scanned = fscanf(stream1,&quot;%le &quot;,&amp;d1);</span>
<a name="l00225"></a>00225 <span class="comment">                libmesh_assert(scanned != EOF);</span>
<a name="l00226"></a>00226 <span class="comment">        }</span>
<a name="l00227"></a>00227 <span class="comment">        fprintf(stream,&quot;%d \n&quot;,mask[i]); </span>
<a name="l00228"></a>00228 <span class="comment">        scanned = fscanf(stream1,&quot;%d \n&quot;,&amp;lo);</span>
<a name="l00229"></a>00229 <span class="comment">        libmesh_assert(scanned != EOF);</span>
<a name="l00230"></a>00230 <span class="comment">    }</span>
<a name="l00231"></a>00231 <span class="comment">        for(i=0;i&lt;Ncells;i++){</span>
<a name="l00232"></a>00232 <span class="comment">                for(unsigned int j=0;j&lt;=3*n+n%2;j++){</span>
<a name="l00233"></a>00233 <span class="comment">                        scanned = fscanf(stream1,&quot;%d &quot;,&amp;lo);</span>
<a name="l00234"></a>00234 <span class="comment">                        libmesh_assert(scanned != EOF);</span>
<a name="l00235"></a>00235 <span class="comment">                        fprintf(stream,&quot;%d &quot;,lo);</span>
<a name="l00236"></a>00236 <span class="comment">                }</span>
<a name="l00237"></a>00237 <span class="comment">                scanned = fscanf(stream1,&quot;\n&quot;);</span>
<a name="l00238"></a>00238 <span class="comment">                libmesh_assert(scanned != EOF);</span>
<a name="l00239"></a>00239 <span class="comment">                fprintf(stream,&quot;\n&quot;);</span>
<a name="l00240"></a>00240 <span class="comment">        }</span>
<a name="l00241"></a>00241 <span class="comment">        for(i=0;i&lt;nedges;i++){</span>
<a name="l00242"></a>00242 <span class="comment">                for(unsigned int j=0;j&lt;3;j++){</span>
<a name="l00243"></a>00243 <span class="comment">                scanned = fscanf(stream1,&quot;%d &quot;,&amp;lo);</span>
<a name="l00244"></a>00244 <span class="comment">                libmesh_assert(scanned != EOF);</span>
<a name="l00245"></a>00245 <span class="comment">                fprintf(stream,&quot;%d &quot;,lo);</span>
<a name="l00246"></a>00246 <span class="comment">                }</span>
<a name="l00247"></a>00247 <span class="comment">        scanned = fscanf(stream1,&quot;\n&quot;);</span>
<a name="l00248"></a>00248 <span class="comment">        libmesh_assert(scanned != EOF);</span>
<a name="l00249"></a>00249 <span class="comment">        fprintf(stream,&quot;\n&quot;);</span>
<a name="l00250"></a>00250 <span class="comment">        }</span>
<a name="l00251"></a>00251 <span class="comment">        fclose(stream1);</span>
<a name="l00252"></a>00252 <span class="comment">}</span>
<a name="l00253"></a>00253 <span class="comment"></span>
<a name="l00254"></a>00254 <span class="comment">fclose(stream);</span>
<a name="l00255"></a>00255 <span class="comment">*/</span>
<a name="l00256"></a>00256   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Finished writegr&quot;</span>&lt;&lt;std::endl;
<a name="l00257"></a>00257   <span class="keywordflow">return</span> 0;
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00264"></a>00264 <span class="comment">// int VariationalMeshSmoother::readgr(int n, int N, LPLPDOUBLE R, LPINT mask, int ncells, LPLPINT cells,</span>
<a name="l00265"></a>00265 <span class="comment">//            LPINT mcells, int nedges, LPINT edges, LPINT hnodes, FILE *sout)</span>
<a name="l00266"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3e4f20c7407b7c07bbaf7ad0bdbc77b4">00266</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3e4f20c7407b7c07bbaf7ad0bdbc77b4">VariationalMeshSmoother::readgr</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells,
<a name="l00267"></a>00267            <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, FILE *)
<a name="l00268"></a>00268 {
<a name="l00269"></a>00269   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Sarting readgr&quot;</span>&lt;&lt;std::endl;
<a name="l00270"></a>00270   <span class="keywordtype">int</span> i;
<a name="l00271"></a>00271  <span class="comment">//add error messages where format can be inconsistent</span>
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="comment">//Find the boundary nodes</span>
<a name="l00274"></a>00274   std::vector&lt;bool&gt; on_boundary;
<a name="l00275"></a>00275   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">MeshTools::find_boundary_nodes</a>(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>, on_boundary);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="comment">//Grab node coordinates and set mask</span>
<a name="l00278"></a>00278   {
<a name="l00279"></a>00279     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       it  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00280"></a>00280     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00281"></a>00281 
<a name="l00282"></a>00282     <span class="comment">//Only compute the node to elem map once</span>
<a name="l00283"></a>00283     std::vector&lt;std::vector&lt;const Elem*&gt; &gt; nodes_to_elem_map;
<a name="l00284"></a>00284     <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">MeshTools::build_nodes_to_elem_map</a>(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>, nodes_to_elem_map);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286     i=0;
<a name="l00287"></a>00287     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00288"></a>00288     {
<a name="l00289"></a>00289       <span class="comment">//For each node grab its X Y [Z] coordinates</span>
<a name="l00290"></a>00290       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>;j++)
<a name="l00291"></a>00291         R[i][j]=(*(*it))(j);
<a name="l00292"></a>00292 
<a name="l00293"></a>00293       <span class="comment">//Set the Proper Mask</span>
<a name="l00294"></a>00294       <span class="comment">//Internal nodes are 0</span>
<a name="l00295"></a>00295       <span class="comment">//Immovable boundary nodes are 1</span>
<a name="l00296"></a>00296       <span class="comment">//Movable boundary nodes are 2</span>
<a name="l00297"></a>00297       <span class="keywordflow">if</span>(on_boundary[i])
<a name="l00298"></a>00298       {
<a name="l00299"></a>00299         <span class="comment">//Only look for sliding edge nodes in 2D</span>
<a name="l00300"></a>00300         <span class="keywordflow">if</span>(_dim == 2)
<a name="l00301"></a>00301         {
<a name="l00302"></a>00302           <span class="comment">//Find all the nodal neighbors... that is the nodes directly connected</span>
<a name="l00303"></a>00303           <span class="comment">//to this node through one edge</span>
<a name="l00304"></a>00304           std::vector&lt;const Node*&gt; neighbors;
<a name="l00305"></a>00305           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a56f90a762fb8feb128abb693690c223f">MeshTools::find_nodal_neighbors</a>(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>, *(*it), nodes_to_elem_map, neighbors);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307           std::vector&lt;const Node*&gt;::const_iterator ne = neighbors.begin();
<a name="l00308"></a>00308           std::vector&lt;const Node*&gt;::const_iterator ne_end = neighbors.end();
<a name="l00309"></a>00309 
<a name="l00310"></a>00310           <span class="comment">//Grab the x,y coordinates</span>
<a name="l00311"></a>00311           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x = (*(*it))(0);
<a name="l00312"></a>00312           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y = (*(*it))(1);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314           <span class="comment">//Theta will represent the atan2 angle (meaning with the proper quadrant in mind)</span>
<a name="l00315"></a>00315           <span class="comment">//of the neighbor node in a system where the current node is at the origin</span>
<a name="l00316"></a>00316           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta = 0;
<a name="l00317"></a>00317           std::vector&lt;Real&gt; thetas;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319           <span class="comment">//Calculate the thetas</span>
<a name="l00320"></a>00320           <span class="keywordflow">for</span>(; ne != ne_end; ne++)
<a name="l00321"></a>00321           {
<a name="l00322"></a>00322             <span class="comment">//Note that the x and y values of this node are subtracted off</span>
<a name="l00323"></a>00323             <span class="comment">//this centers the system around this node</span>
<a name="l00324"></a>00324             theta = atan2((*(*ne))(1)-y,(*(*ne))(0)-x);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326             <span class="comment">//Save it for later</span>
<a name="l00327"></a>00327             thetas.push_back(theta);
<a name="l00328"></a>00328           }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330           <span class="comment">//Assume the node is immovable... then prove otherwise</span>
<a name="l00331"></a>00331           mask[i]=1;
<a name="l00332"></a>00332 
<a name="l00333"></a>00333           <span class="comment">//Search through neighbor nodes looking for two that form a straight line with this node</span>
<a name="l00334"></a>00334           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a=0;a&lt;thetas.size()-1;a++)
<a name="l00335"></a>00335           {
<a name="l00336"></a>00336             <span class="comment">//Only try each pairing once</span>
<a name="l00337"></a>00337             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b=a+1;b&lt;thetas.size();b++)
<a name="l00338"></a>00338             {
<a name="l00339"></a>00339               <span class="comment">//Find if the two neighbor nodes angles are 180 degrees (pi) off of eachother (withing a tolerance)</span>
<a name="l00340"></a>00340               <span class="comment">//In order to make this a true movable boundary node... the two that forma  straight line with</span>
<a name="l00341"></a>00341               <span class="comment">//it must also be on the boundary</span>
<a name="l00342"></a>00342               <span class="keywordflow">if</span>(on_boundary[neighbors[a]-&gt;<span class="keywordtype">id</span>()] &amp;&amp;
<a name="l00343"></a>00343                 on_boundary[neighbors[b]-&gt;id()] &amp;&amp;
<a name="l00344"></a>00344                 (
<a name="l00345"></a>00345                   (fabs(thetas[a]-(thetas[b] + (<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>))) &lt; .001) ||
<a name="l00346"></a>00346                   (fabs(thetas[a]-(thetas[b] - (<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a>))) &lt; .001)
<a name="l00347"></a>00347                 )
<a name="l00348"></a>00348                 )
<a name="l00349"></a>00349               {
<a name="l00350"></a>00350                 <span class="comment">//if((*(*it))(1) &gt; 0.25 || (*(*it))(0) &gt; .7 || (*(*it))(0) &lt; .01)</span>
<a name="l00351"></a>00351                   mask[i]=2;
<a name="l00352"></a>00352               }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354             }
<a name="l00355"></a>00355           }
<a name="l00356"></a>00356         }
<a name="l00357"></a>00357         <span class="keywordflow">else</span> <span class="comment">//In 3D set all boundary nodes to be fixed</span>
<a name="l00358"></a>00358           mask[i]=1;
<a name="l00359"></a>00359       }
<a name="l00360"></a>00360       <span class="keywordflow">else</span>
<a name="l00361"></a>00361         mask[i]=0;  <span class="comment">//Internal Node</span>
<a name="l00362"></a>00362 
<a name="l00363"></a>00363       <span class="comment">//libMesh::out&lt;&lt;&quot;Node: &quot;&lt;&lt;i&lt;&lt;&quot;  Mask: &quot;&lt;&lt;mask[i]&lt;&lt;std::endl;</span>
<a name="l00364"></a>00364       i++;
<a name="l00365"></a>00365     }
<a name="l00366"></a>00366   }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Grab the connectivity</span>
<a name="l00369"></a>00369   <span class="comment">// FIXME: Generalize this!</span>
<a name="l00370"></a>00370   {
<a name="l00371"></a>00371     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00372"></a>00372     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00373"></a>00373 
<a name="l00374"></a>00374     i=0;
<a name="l00375"></a>00375     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377       <span class="comment">//Keep track of the number of nodes</span>
<a name="l00378"></a>00378       <span class="comment">//there must be 6 for 2D</span>
<a name="l00379"></a>00379       <span class="comment">//10 for 3D</span>
<a name="l00380"></a>00380       <span class="comment">//If there are actually less than that -1 must be used</span>
<a name="l00381"></a>00381       <span class="comment">//to fill out the rest</span>
<a name="l00382"></a>00382       <span class="keywordtype">int</span> num=0;
<a name="l00383"></a>00383       <span class="keywordtype">int</span> num_necessary = 0;
<a name="l00384"></a>00384 
<a name="l00385"></a>00385       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a> == 2)
<a name="l00386"></a>00386         num_necessary = 6;
<a name="l00387"></a>00387       <span class="keywordflow">else</span>
<a name="l00388"></a>00388         num_necessary = 10;
<a name="l00389"></a>00389 
<a name="l00390"></a>00390       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a> == 2)
<a name="l00391"></a>00391       {
<a name="l00392"></a>00392         <span class="keywordflow">switch</span>((*it)-&gt;n_vertices())
<a name="l00393"></a>00393         {
<a name="l00394"></a>00394           <span class="comment">//Grab nodes that do exist</span>
<a name="l00395"></a>00395           <span class="keywordflow">case</span> 3:  <span class="comment">//Tri</span>
<a name="l00396"></a>00396             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0;k&lt;(*it)-&gt;n_vertices();k++)
<a name="l00397"></a>00397               cells[i][k]=(*it)-&gt;node(k);
<a name="l00398"></a>00398             num=(*it)-&gt;n_vertices();
<a name="l00399"></a>00399             <span class="keywordflow">break</span>;
<a name="l00400"></a>00400           <span class="keywordflow">case</span> 4:  <span class="comment">//Quad 4</span>
<a name="l00401"></a>00401             cells[i][0]=(*it)-&gt;node(0);
<a name="l00402"></a>00402             cells[i][1]=(*it)-&gt;node(1);
<a name="l00403"></a>00403             cells[i][2]=(*it)-&gt;node(3); <span class="comment">//Note that 2 and 3 are switched!</span>
<a name="l00404"></a>00404             cells[i][3]=(*it)-&gt;node(2);
<a name="l00405"></a>00405             num=4;
<a name="l00406"></a>00406             <span class="keywordflow">break</span>;
<a name="l00407"></a>00407           <span class="keywordflow">default</span>:
<a name="l00408"></a>00408             libmesh_assert(<span class="keyword">false</span>);
<a name="l00409"></a>00409         }
<a name="l00410"></a>00410       }
<a name="l00411"></a>00411       <span class="keywordflow">else</span>
<a name="l00412"></a>00412       {
<a name="l00413"></a>00413         <span class="comment">//Grab nodes that do exist</span>
<a name="l00414"></a>00414         <span class="keywordflow">switch</span>((*it)-&gt;n_vertices())
<a name="l00415"></a>00415         {
<a name="l00416"></a>00416           <span class="keywordflow">case</span> 4:  <span class="comment">//Tet 4</span>
<a name="l00417"></a>00417             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0;k&lt;(*it)-&gt;n_vertices();k++)
<a name="l00418"></a>00418               cells[i][k]=(*it)-&gt;node(k);
<a name="l00419"></a>00419             num=(*it)-&gt;n_vertices();
<a name="l00420"></a>00420             <span class="keywordflow">break</span>;
<a name="l00421"></a>00421           <span class="keywordflow">case</span> 8:  <span class="comment">//Hex 8f</span>
<a name="l00422"></a>00422             cells[i][0]=(*it)-&gt;node(0);
<a name="l00423"></a>00423             cells[i][1]=(*it)-&gt;node(1);
<a name="l00424"></a>00424             cells[i][2]=(*it)-&gt;node(3); <span class="comment">//Note that 2 and 3 are switched!</span>
<a name="l00425"></a>00425             cells[i][3]=(*it)-&gt;node(2);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427             cells[i][4]=(*it)-&gt;node(4);
<a name="l00428"></a>00428             cells[i][5]=(*it)-&gt;node(5);
<a name="l00429"></a>00429             cells[i][6]=(*it)-&gt;node(7); <span class="comment">//Note that 6 and 7 are switched!</span>
<a name="l00430"></a>00430             cells[i][7]=(*it)-&gt;node(6);
<a name="l00431"></a>00431             num=8;
<a name="l00432"></a>00432           <span class="keywordflow">default</span>:
<a name="l00433"></a>00433             libmesh_assert(<span class="keyword">false</span>);
<a name="l00434"></a>00434         }
<a name="l00435"></a>00435       }
<a name="l00436"></a>00436 
<a name="l00437"></a>00437       <span class="comment">//Fill in the rest with -1</span>
<a name="l00438"></a>00438       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=num;j&lt;3*n+n%2;j++)
<a name="l00439"></a>00439         cells[i][j]=-1;
<a name="l00440"></a>00440 
<a name="l00441"></a>00441       <span class="comment">//Mask it with 0 to state that this is an active element</span>
<a name="l00442"></a>00442       <span class="comment">//FIXME: Could be something other than zero</span>
<a name="l00443"></a>00443       mcells[i]=0;
<a name="l00444"></a>00444 
<a name="l00445"></a>00445       i++;
<a name="l00446"></a>00446     }
<a name="l00447"></a>00447   }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   <span class="comment">//Grab hanging node connectivity</span>
<a name="l00450"></a>00450   {
<a name="l00451"></a>00451     std::map&lt;unsigned int, std::vector&lt;unsigned int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> it = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a4af429062348bf93b94cf4b9e8987b52">_hanging_nodes</a>.begin();
<a name="l00452"></a>00452     std::map&lt;unsigned int, std::vector&lt;unsigned int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> end = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a4af429062348bf93b94cf4b9e8987b52">_hanging_nodes</a>.end();
<a name="l00453"></a>00453 
<a name="l00454"></a>00454     <span class="keywordflow">for</span>(i=0;it!=end;it++)
<a name="l00455"></a>00455     {
<a name="l00456"></a>00456 
<a name="l00457"></a>00457       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Parent 1: &quot;</span>&lt;&lt;(it-&gt;second)[0]&lt;&lt;std::endl;
<a name="l00458"></a>00458       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Parent 2: &quot;</span>&lt;&lt;(it-&gt;second)[1]&lt;&lt;std::endl;
<a name="l00459"></a>00459       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Hanging Node: &quot;</span>&lt;&lt;it-&gt;first&lt;&lt;std::endl&lt;&lt;std::endl;
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462       <span class="comment">//First Parent</span>
<a name="l00463"></a>00463       edges[2*i]=(it-&gt;second)[1];
<a name="l00464"></a>00464 
<a name="l00465"></a>00465       <span class="comment">//Second Parent</span>
<a name="l00466"></a>00466       edges[2*i+1]=(it-&gt;second)[0];
<a name="l00467"></a>00467 
<a name="l00468"></a>00468       <span class="comment">//Hanging Node</span>
<a name="l00469"></a>00469       hnodes[i]=it-&gt;first;
<a name="l00470"></a>00470 
<a name="l00471"></a>00471       i++;
<a name="l00472"></a>00472     }
<a name="l00473"></a>00473   }
<a name="l00474"></a>00474   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;Finished readgr&quot;</span>&lt;&lt;std::endl;
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 <span class="keywordflow">return</span> 0;
<a name="l00477"></a>00477 }
<a name="l00478"></a>00478 
<a name="l00482"></a>00482 <span class="comment">//int VariationalMeshSmoother::readmetr(char *name, LPLPLPDOUBLE H, int ncells, int n, FILE *sout)</span>
<a name="l00483"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1695f359003a8e2cf7c9a083b7ae6911">00483</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1695f359003a8e2cf7c9a083b7ae6911">VariationalMeshSmoother::readmetr</a>(<span class="keywordtype">char</span> *<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> ncells, <span class="keywordtype">int</span> n, FILE *)
<a name="l00484"></a>00484 {
<a name="l00485"></a>00485 <span class="keywordtype">int</span> i, j, k, scanned;
<a name="l00486"></a>00486 <span class="keywordtype">double</span> d;
<a name="l00487"></a>00487 FILE *stream;
<a name="l00488"></a>00488 
<a name="l00489"></a>00489    stream=fopen(name,<span class="stringliteral">&quot;r&quot;</span>);
<a name="l00490"></a>00490    <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++)
<a name="l00491"></a>00491           <span class="keywordflow">for</span>(j=0;j&lt;n;j++){
<a name="l00492"></a>00492           <span class="keywordflow">for</span>(k=0;k&lt;n;k++){scanned = fscanf(stream,<span class="stringliteral">&quot;%le &quot;</span>,&amp;d); 
<a name="l00493"></a>00493             libmesh_assert(scanned != EOF);
<a name="l00494"></a>00494             H[i][j][k]=d;}
<a name="l00495"></a>00495                   scanned = fscanf(stream,<span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00496"></a>00496                   libmesh_assert(scanned != EOF);
<a name="l00497"></a>00497           }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499    fclose(stream);
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="keywordflow">return</span> 0;
<a name="l00502"></a>00502 }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="comment">// Stolen from ErrorVector!</span>
<a name="l00505"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa37db98faf9ff10394900d029da0a05c">00505</a> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa37db98faf9ff10394900d029da0a05c">VariationalMeshSmoother::adapt_minimum</a>()<span class="keyword"> const</span>
<a name="l00506"></a>00506 <span class="keyword"></span>{
<a name="l00507"></a>00507   std::vector&lt;float&gt;&amp; adapt_data = *<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>;
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = adapt_data.size();
<a name="l00510"></a>00510   <span class="keywordtype">float</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = 1.e30;
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00513"></a>00513   {
<a name="l00514"></a>00514       <span class="comment">// Only positive (or zero) values in the error vector</span>
<a name="l00515"></a>00515     libmesh_assert(adapt_data[i] &gt;= 0.);
<a name="l00516"></a>00516     min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (min, adapt_data[i]);
<a name="l00517"></a>00517   }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">// ErrorVectors are for positive values</span>
<a name="l00520"></a>00520   libmesh_assert (min &gt;= 0.);
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>;
<a name="l00523"></a>00523 }
<a name="l00524"></a>00524 
<a name="l00525"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ab1d2ee2a407aab6c95f3b6cefa34f879">00525</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ab1d2ee2a407aab6c95f3b6cefa34f879">VariationalMeshSmoother::adjust_adapt_data</a>()
<a name="l00526"></a>00526 {
<a name="l00527"></a>00527   <span class="comment">//For convenience</span>
<a name="l00528"></a>00528   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> &amp; aoe_mesh=*<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">_area_of_interest</a>;
<a name="l00529"></a>00529   std::vector&lt;float&gt;&amp; adapt_data = *<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>;
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="keywordtype">float</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa37db98faf9ff10394900d029da0a05c">adapt_minimum</a>();
<a name="l00532"></a>00532 
<a name="l00533"></a>00533   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00534"></a>00534   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       aoe_el     = aoe_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00537"></a>00537   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> aoe_end_el = aoe_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="comment">//Counter to keep track of which spot in adapt_data we&#39;re looking at</span>
<a name="l00540"></a>00540   <span class="keywordtype">int</span> i=0;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="keywordflow">for</span>(; el != end_el; el++)
<a name="l00543"></a>00543   {
<a name="l00544"></a>00544     <span class="comment">//Only do this for active elements</span>
<a name="l00545"></a>00545     <span class="keywordflow">if</span>(adapt_data[i])
<a name="l00546"></a>00546     {
<a name="l00547"></a>00547       <a class="code" href="classlibMesh_1_1Point.php">Point</a> centroid=(*el)-&gt;centroid();
<a name="l00548"></a>00548       <span class="keywordtype">bool</span> in_aoe=<span class="keyword">false</span>;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550       <span class="comment">//See if the elements centroid lies in the aoe mesh</span>
<a name="l00551"></a>00551       <span class="comment">//for(aoe_el=aoe_mesh.elements_begin(); aoe_el != aoe_end_el; ++aoe_el)</span>
<a name="l00552"></a>00552       <span class="comment">//{</span>
<a name="l00553"></a>00553         <span class="keywordflow">if</span>((*aoe_el)-&gt;contains_point(centroid))
<a name="l00554"></a>00554           in_aoe=<span class="keyword">true</span>;
<a name="l00555"></a>00555       <span class="comment">//}</span>
<a name="l00556"></a>00556 
<a name="l00557"></a>00557       <span class="comment">//If the element is not in the area of interest... then set</span>
<a name="l00558"></a>00558       <span class="comment">//it&#39;s adaptivity value to the minimum.</span>
<a name="l00559"></a>00559       <span class="keywordflow">if</span>(!in_aoe)
<a name="l00560"></a>00560         adapt_data[i]=<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>;
<a name="l00561"></a>00561     }
<a name="l00562"></a>00562     i++;
<a name="l00563"></a>00563   }
<a name="l00564"></a>00564 }
<a name="l00565"></a>00565 
<a name="l00569"></a>00569 <span class="comment">// int VariationalMeshSmoother::read_adp(LPDOUBLE afun, char adap[], FILE *sout)</span>
<a name="l00570"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abcd0c8f82d12085857cf14d1d2e09bb7">00570</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abcd0c8f82d12085857cf14d1d2e09bb7">VariationalMeshSmoother::read_adp</a>(<a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <span class="keywordtype">char</span> [], FILE *)
<a name="l00571"></a>00571 {
<a name="l00572"></a>00572   <span class="keywordtype">int</span> i, m, j;
<a name="l00573"></a>00573 
<a name="l00574"></a>00574   std::vector&lt;float&gt;&amp; adapt_data = *<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>;
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">_area_of_interest</a>)
<a name="l00577"></a>00577     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ab1d2ee2a407aab6c95f3b6cefa34f879">adjust_adapt_data</a>();
<a name="l00578"></a>00578 
<a name="l00579"></a>00579   m=adapt_data.size();
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   j=0;
<a name="l00582"></a>00582   <span class="keywordflow">for</span>(i=0;i&lt;m;i++)
<a name="l00583"></a>00583   {
<a name="l00584"></a>00584     <span class="keywordflow">if</span>(adapt_data[i]!=0)
<a name="l00585"></a>00585     {
<a name="l00586"></a>00586       afun[j]=adapt_data[i];
<a name="l00587"></a>00587       j++;
<a name="l00588"></a>00588     }
<a name="l00589"></a>00589   }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   <span class="keywordflow">return</span> 0;
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">00594</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">VariationalMeshSmoother::jac3</a>(<span class="keywordtype">double</span> x1,<span class="keywordtype">double</span> y1,<span class="keywordtype">double</span> z1,<span class="keywordtype">double</span> x2,<span class="keywordtype">double</span> y2,
<a name="l00595"></a>00595             <span class="keywordtype">double</span> z2,<span class="keywordtype">double</span> x3,<span class="keywordtype">double</span> y3,<span class="keywordtype">double</span> z3)
<a name="l00596"></a>00596 {
<a name="l00597"></a>00597   <span class="keywordflow">return</span>( x1*(y2*z3 - y3*z2) + y1*(z2*x3 - z3*x2) + z1*(x2*y3 - x3*y2) );
<a name="l00598"></a>00598 }
<a name="l00599"></a>00599 
<a name="l00600"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">00600</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">VariationalMeshSmoother::jac2</a>(<span class="keywordtype">double</span> x1,<span class="keywordtype">double</span> y1,<span class="keywordtype">double</span> x2,<span class="keywordtype">double</span> y2)
<a name="l00601"></a>00601 {
<a name="l00602"></a>00602   <span class="keywordflow">return</span>( x1*y2-x2*y1 );
<a name="l00603"></a>00603 }
<a name="l00604"></a>00604 
<a name="l00608"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">00608</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">VariationalMeshSmoother::basisA</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q, <span class="keywordtype">int</span> nvert, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> K, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me)
<a name="l00609"></a>00609 {
<a name="l00610"></a>00610  <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> U;
<a name="l00611"></a>00611  <span class="keywordtype">int</span> i,j,k;
<a name="l00612"></a>00612  U=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(n,nvert);
<a name="l00613"></a>00613  <span class="keywordflow">for</span>(i=0;i&lt;n;i++) U[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(nvert);
<a name="l00614"></a>00614 
<a name="l00615"></a>00615  <span class="keywordflow">if</span>(n==2){
<a name="l00616"></a>00616     <span class="keywordflow">if</span>(nvert==4){<span class="comment">//quad</span>
<a name="l00617"></a>00617         U[0][0]=(-(1-K[1]));
<a name="l00618"></a>00618         U[0][1]=( (1-K[1]));
<a name="l00619"></a>00619         U[0][2]=(-    K[1]);
<a name="l00620"></a>00620         U[0][3]=(     K[1]);
<a name="l00621"></a>00621         U[1][0]=(-(1-K[0]));
<a name="l00622"></a>00622         U[1][1]=(-    K[0]);
<a name="l00623"></a>00623         U[1][2]=( (1-K[0]));
<a name="l00624"></a>00624         U[1][3]=(     K[0]);
<a name="l00625"></a>00625     }
<a name="l00626"></a>00626     <span class="keywordflow">if</span>(nvert==3){<span class="comment">//tri</span>
<a name="l00627"></a>00627         <span class="comment">/*---for right target triangle---</span>
<a name="l00628"></a>00628 <span class="comment">        U[0][0]=-1.0; U[1][0]=-1.0;</span>
<a name="l00629"></a>00629 <span class="comment">        U[0][1]=1.0;  U[1][1]=0.0;</span>
<a name="l00630"></a>00630 <span class="comment">        U[0][2]=0.0;  U[1][2]=1.0;</span>
<a name="l00631"></a>00631 <span class="comment">        -----for regular triangle---*/</span>
<a name="l00632"></a>00632         U[0][0]=-1.0; U[1][0]=-1.0/sqrt(3.0);
<a name="l00633"></a>00633         U[0][1]= 1.0; U[1][1]=-1.0/sqrt(3.0);
<a name="l00634"></a>00634         U[0][2]=   0; U[1][2]= 2.0/sqrt(3.0);
<a name="l00635"></a>00635     }
<a name="l00636"></a>00636     <span class="keywordflow">if</span>(nvert==6){<span class="comment">/*--curved triangle*/</span>
<a name="l00637"></a>00637         U[0][0]=-3*(1-K[0]-K[1]*0.5)+(K[0]-0.5*K[1])+K[1];
<a name="l00638"></a>00638         U[0][1]=-(1-K[0]-K[1]*0.5)+(K[0]-0.5*K[1])*3-K[1];
<a name="l00639"></a>00639         U[0][2]=0;
<a name="l00640"></a>00640         U[0][3]=K[1]*4;
<a name="l00641"></a>00641         U[0][4]=-4*K[1];
<a name="l00642"></a>00642         U[0][5]=4*(1-K[0]-K[1]*0.5)-4*(K[0]-0.5*K[1]);
<a name="l00643"></a>00643         U[1][0]=(1-K[2]-K[3]*0.5)*(-1.5)+(K[2]-0.5*K[3])*(0.5)+K[3]*(0.5);
<a name="l00644"></a>00644         U[1][1]=(1-K[2]-K[3]*0.5)*(0.5)+(K[2]-0.5*K[3])*(-1.5)+K[3]*(0.5);
<a name="l00645"></a>00645         U[1][2]=(1-K[2]-K[3]*0.5)*(-1)+(K[2]-0.5*K[3])*(-1)+K[3]*(3);
<a name="l00646"></a>00646         U[1][3]=(K[2]-0.5*K[3])*(4.0)+K[3]*(-2.0);
<a name="l00647"></a>00647         U[1][4]=(1-K[2]-K[3]*0.5)*(4.0)+K[3]*(-2.0);
<a name="l00648"></a>00648         U[1][5]=(1-K[2]-K[3]*0.5)*(-2.0)+(K[2]-0.5*K[3])*(-2.0);
<a name="l00649"></a>00649     }
<a name="l00650"></a>00650  }
<a name="l00651"></a>00651  <span class="keywordflow">if</span>(n==3){
<a name="l00652"></a>00652      <span class="keywordflow">if</span>(nvert==8){<span class="comment">//hex</span>
<a name="l00653"></a>00653        U[0][0]=(-(1-K[0])*(1-K[1]));
<a name="l00654"></a>00654        U[0][1]=( (1-K[0])*(1-K[1]));
<a name="l00655"></a>00655        U[0][2]=(-    K[0]*(1-K[1]));
<a name="l00656"></a>00656        U[0][3]=(     K[0]*(1-K[1]));
<a name="l00657"></a>00657        U[0][4]=(-(1-K[0])*    K[1]);
<a name="l00658"></a>00658        U[0][5]=( (1-K[0])*    K[1]);
<a name="l00659"></a>00659        U[0][6]=(-    K[0]*    K[1]);
<a name="l00660"></a>00660        U[0][7]=(     K[0]*    K[1]);
<a name="l00661"></a>00661        U[1][0]=(-(1-K[2])*(1-K[3]));
<a name="l00662"></a>00662        U[1][1]=(-    K[2]*(1-K[3]));
<a name="l00663"></a>00663        U[1][2]=( (1-K[2])*(1-K[3]));
<a name="l00664"></a>00664        U[1][3]=(     K[2]*(1-K[3]));
<a name="l00665"></a>00665        U[1][4]=(-(1-K[2])*    K[3]);
<a name="l00666"></a>00666        U[1][5]=(-    K[2]*    K[3]);
<a name="l00667"></a>00667        U[1][6]=( (1-K[2])*    K[3]);
<a name="l00668"></a>00668        U[1][7]=(     K[2]*    K[3]);
<a name="l00669"></a>00669        U[2][0]=(-(1-K[4])*(1-K[5]));
<a name="l00670"></a>00670        U[2][1]=(-    K[4]*(1-K[5]));
<a name="l00671"></a>00671        U[2][2]=(-(1-K[4])*    K[5]);
<a name="l00672"></a>00672        U[2][3]=(-    K[4]*    K[5]);
<a name="l00673"></a>00673        U[2][4]=( (1-K[4])*(1-K[5]));
<a name="l00674"></a>00674        U[2][5]=(     K[4]*(1-K[5]));
<a name="l00675"></a>00675        U[2][6]=( (1-K[4])*    K[5]);
<a name="l00676"></a>00676        U[2][7]=(     K[4]*    K[5]);
<a name="l00677"></a>00677      }
<a name="l00678"></a>00678      <span class="keywordflow">if</span>(nvert==4){<span class="comment">//linear tetr</span>
<a name="l00679"></a>00679       <span class="comment">/*---for regular reference tetrahedron--------*/</span>
<a name="l00680"></a>00680       U[0][0]=-1; U[1][0]=-1.0/sqrt(3.0); U[2][0]=-1.0/sqrt(6.0);
<a name="l00681"></a>00681       U[0][1]=1;  U[1][1]=-1.0/sqrt(3.0); U[2][1]=-1.0/sqrt(6.0);
<a name="l00682"></a>00682       U[0][2]=0;  U[1][2]=2.0/sqrt(3.0);  U[2][2]=-1.0/sqrt(6.0);
<a name="l00683"></a>00683       U[0][3]=0;  U[1][3]=0;            U[2][3]=3.0/sqrt(6.0);
<a name="l00684"></a>00684       <span class="comment">/*---for right corner reference tetrahedron----</span>
<a name="l00685"></a>00685 <span class="comment">      U[0][0]=-1; U[1][0]=-1; U[2][0]=-1;</span>
<a name="l00686"></a>00686 <span class="comment">      U[0][1]=1;  U[1][1]=0;  U[2][1]=0;</span>
<a name="l00687"></a>00687 <span class="comment">      U[0][2]=0;  U[1][2]=1;  U[2][2]=0;</span>
<a name="l00688"></a>00688 <span class="comment">      U[0][3]=0;  U[1][3]=0;  U[2][3]=1;*/</span>
<a name="l00689"></a>00689      }
<a name="l00690"></a>00690      <span class="keywordflow">if</span>(nvert==6){<span class="comment">//prism</span>
<a name="l00691"></a>00691         <span class="comment">/* for regular triangle in the prism base */</span>
<a name="l00692"></a>00692         U[0][0]=-1+K[0]; U[1][0]=(-1+K[1])/2.0; U[2][0]=-1+K[2]+K[3]/2.0;
<a name="l00693"></a>00693         U[0][1]=1-K[0]; U[1][1]=(-1+K[1])/2.0; U[2][1]=-K[2]+K[3]/2.0;
<a name="l00694"></a>00694         U[0][2]=0; U[1][2]=(1-K[1]); U[2][2]=-K[3];
<a name="l00695"></a>00695         U[0][3]=-K[0]; U[1][3]=(-K[1])/2.0; U[2][3]=1-K[2]-K[3]/2.0;
<a name="l00696"></a>00696         U[0][4]=K[0]; U[1][4]=(-K[1])/2.0; U[2][4]=K[2]-K[3]/2.0;
<a name="l00697"></a>00697         U[0][5]=0; U[1][5]=K[1]; U[2][5]=K[3];
<a name="l00698"></a>00698      }
<a name="l00699"></a>00699      <span class="keywordflow">if</span>(nvert==10){<span class="comment">//quad tetr</span>
<a name="l00700"></a>00700          U[0][0]=(1-K[0]-K[1]/2-K[2]/3)*(-3)+(K[0]-K[1]/2-K[2]/3)+(K[1]-K[2]/3)+K[2];
<a name="l00701"></a>00701          U[0][1]=(1-K[0]-K[1]/2-K[2]/3)*(-1)+(K[0]-K[1]/2-K[2]/3)*3-(K[1]-K[2]/3)-K[2];
<a name="l00702"></a>00702          U[0][2]=0; U[0][3]=0;
<a name="l00703"></a>00703          U[0][4]=4*(K[1]-K[2]/3); U[0][5]=-4*(K[1]-K[2]/3);
<a name="l00704"></a>00704          U[0][6]=4*(1-K[0]-K[1]/2-K[2]/3)-4*(K[0]-K[1]/2-K[2]/3);
<a name="l00705"></a>00705          U[0][7]=4*K[2]; U[0][8]=0; U[0][9]=-4*K[2];
<a name="l00706"></a>00706          U[1][0]=(1-K[3]-K[4]/2-K[5]/3)*(-3/2)+(K[3]-K[4]/2-K[5]/3)/2+(K[4]-K[5]/3)/2+K[5]/2;
<a name="l00707"></a>00707          U[1][1]=(1-K[3]-K[4]/2-K[5]/3)/2+(K[3]-K[4]/2-K[5]/3)*(-3/2)+(K[4]-K[5]/3)/2+K[5]/2;
<a name="l00708"></a>00708          U[1][2]=-(1-K[3]-K[4]/2-K[5]/3)-(K[3]-K[4]/2-K[5]/3)+3*(K[4]-K[5]/3)-K[5];
<a name="l00709"></a>00709          U[1][3]=0; U[1][4]=4*(K[3]-K[4]/2-K[5]/3)-2*(K[4]-K[5]/3);
<a name="l00710"></a>00710          U[1][5]=4*(1-K[3]-K[4]/2-K[5]/3)-2*(K[4]-K[5]/3);
<a name="l00711"></a>00711          U[1][6]=-2*(1-K[3]-K[4]/2-K[5]/3)-2*(K[3]-K[4]/2-K[5]/3);
<a name="l00712"></a>00712          U[1][7]=-2*K[5]; U[1][8]=4*K[5]; U[1][9]=-2*K[5];
<a name="l00713"></a>00713          U[2][0]=-(1-K[6]-K[7]/2-K[8]/3)+(K[6]-K[7]/2-K[8]/3)/3+(K[7]-K[8]/3)/3+K[8]/3;
<a name="l00714"></a>00714          U[2][1]=(1-K[6]-K[7]/2-K[8]/3)/3-(K[6]-K[7]/2-K[8]/3)+(K[7]-K[8]/3)/3+K[8]/3;
<a name="l00715"></a>00715          U[2][2]=(1-K[6]-K[7]/2-K[8]/3)/3+(K[6]-K[7]/2-K[8]/3)/3-(K[7]-K[8]/3)+K[8]/3;
<a name="l00716"></a>00716          U[2][3]=-(1-K[6]-K[7]/2-K[8]/3)-(K[6]-K[7]/2-K[8]/3)-(K[7]-K[8]/3)+3*K[8];
<a name="l00717"></a>00717          U[2][4]=-4*(K[6]-K[7]/2-K[8]/3)/3-4*(K[7]-K[8]/3)/3;
<a name="l00718"></a>00718          U[2][5]=-4*(1-K[6]-K[7]/2-K[8]/3)/3-4*(K[7]-K[8]/3)/3;
<a name="l00719"></a>00719          U[2][6]=-4*(1-K[6]-K[7]/2-K[8]/3)/3-4*(K[6]-K[7]/2-K[8]/3)/3;
<a name="l00720"></a>00720          U[2][7]=4*(K[6]-K[7]/2-K[8]/3)-4*K[8]/3;
<a name="l00721"></a>00721          U[2][8]=4*(K[7]-K[8]/3)-4*K[8]/3; U[2][9]=4*(1-K[6]-K[7]/2-K[8]/3)-4*K[8]/3;
<a name="l00722"></a>00722      }
<a name="l00723"></a>00723  }
<a name="l00724"></a>00724 
<a name="l00725"></a>00725  <span class="keywordflow">if</span>(me==1){
<a name="l00726"></a>00726     <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l00727"></a>00727         <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++) Q[i][j]=U[i][j];
<a name="l00728"></a>00728 
<a name="l00729"></a>00729  } <span class="keywordflow">else</span> {
<a name="l00730"></a>00730     <span class="keywordflow">for</span>(i=0;i&lt;n;i++){
<a name="l00731"></a>00731        <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++){ Q[i][j]=0;
<a name="l00732"></a>00732           <span class="keywordflow">for</span>(k=0;k&lt;n;k++) Q[i][j]+=H[k][i]*U[k][j];
<a name="l00733"></a>00733        }
<a name="l00734"></a>00734     }
<a name="l00735"></a>00735  }
<a name="l00736"></a>00736 
<a name="l00737"></a>00737  <span class="keywordflow">for</span>(i=0;i&lt;n;i++) free(U[i]);
<a name="l00738"></a>00738  free(U);
<a name="l00739"></a>00739 <span class="keywordflow">return</span> 0;
<a name="l00740"></a>00740 }
<a name="l00741"></a>00741 
<a name="l00745"></a>00745 <span class="comment">// void VariationalMeshSmoother::adp_renew(int n, int N, LPLPDOUBLE R, int ncells, LPLPINT cells, LPDOUBLE afun, int adp, FILE *sout)</span>
<a name="l00746"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af8f5b5f11a05b03da6e2352a5aeba5a7">00746</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af8f5b5f11a05b03da6e2352a5aeba5a7">VariationalMeshSmoother::adp_renew</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <span class="keywordtype">int</span> adp, FILE *)
<a name="l00747"></a>00747 {
<a name="l00748"></a>00748   <span class="keywordtype">int</span> i, j, nvert;
<a name="l00749"></a>00749   <span class="keywordtype">double</span> x, y, z;
<a name="l00750"></a>00750 
<a name="l00751"></a>00751   <span class="comment">//evaluates given adaptive function on the provided mesh</span>
<a name="l00752"></a>00752   <span class="keywordflow">if</span>(adp&lt;0){
<a name="l00753"></a>00753     <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++)
<a name="l00754"></a>00754     {
<a name="l00755"></a>00755       x=y=z=0;
<a name="l00756"></a>00756       nvert=0;
<a name="l00757"></a>00757       <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0)
<a name="l00758"></a>00758       {
<a name="l00759"></a>00759         x+=R[cells[i][nvert]][0];
<a name="l00760"></a>00760         y+=R[cells[i][nvert]][1];
<a name="l00761"></a>00761         <span class="keywordflow">if</span>(n==3)
<a name="l00762"></a>00762           z+=R[cells[i][nvert]][2];
<a name="l00763"></a>00763         nvert++;
<a name="l00764"></a>00764       }
<a name="l00765"></a>00765       afun[i]=5*(x+y+z); <span class="comment">//adaptive function, cell based</span>
<a name="l00766"></a>00766     }
<a name="l00767"></a>00767   }
<a name="l00768"></a>00768   <span class="keywordflow">if</span>(adp&gt;0)
<a name="l00769"></a>00769   {
<a name="l00770"></a>00770     <span class="keywordflow">for</span>(i=0;i&lt;N;i++)
<a name="l00771"></a>00771     {
<a name="l00772"></a>00772       z=0; <span class="keywordflow">for</span>(j=0;j&lt;n;j++) z+=R[i][j];
<a name="l00773"></a>00773       afun[i]=5*sin(R[i][0]); <span class="comment">//adaptive function, node based</span>
<a name="l00774"></a>00774     }
<a name="l00775"></a>00775   }
<a name="l00776"></a>00776 
<a name="l00777"></a>00777   <span class="keywordflow">return</span>;
<a name="l00778"></a>00778 }
<a name="l00779"></a>00779 
<a name="l00783"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a73c40468cbbbcc85f6cc763c56ad4005">00783</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a73c40468cbbbcc85f6cc763c56ad4005">VariationalMeshSmoother::full_smooth</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l00784"></a>00784                  <span class="keywordtype">int</span> nedges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keywordtype">double</span> w, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> iter, <span class="keywordtype">int</span> me,
<a name="l00785"></a>00785                      <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> adp, <span class="keywordtype">char</span> adap[], <span class="keywordtype">int</span> gr, FILE *sout)
<a name="l00786"></a>00786 {
<a name="l00787"></a>00787   <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun=NULL, Gamma;
<a name="l00788"></a>00788   <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> maskf;
<a name="l00789"></a>00789   <span class="keywordtype">double</span>  Jk, epsilon, eps, qmin, vol, emax, Vmin, Enm1;
<a name="l00790"></a>00790   <span class="keywordtype">int</span> i, ii, j, counter, NBN, ladp, msglev=1;
<a name="l00791"></a>00791 
<a name="l00792"></a>00792   <span class="comment">//Adaptive function is on cells</span>
<a name="l00793"></a>00793   <span class="keywordflow">if</span>(adp&lt;0)
<a name="l00794"></a>00794     afun=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(ncells);
<a name="l00795"></a>00795 
<a name="l00796"></a>00796   <span class="comment">//Adaptive function is on nodes</span>
<a name="l00797"></a>00797   <span class="keywordflow">if</span>(adp&gt;0)
<a name="l00798"></a>00798     afun=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(N);
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   maskf=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(N);
<a name="l00801"></a>00801   Gamma=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(ncells);
<a name="l00802"></a>00802 
<a name="l00803"></a>00803   <span class="keywordflow">if</span>(msglev&gt;=1)
<a name="l00804"></a>00804     fprintf(sout,<span class="stringliteral">&quot;N=%d ncells=%d nedges=%d \n&quot;</span>,N,ncells,nedges);
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="comment">//Boundary node counting</span>
<a name="l00808"></a>00808   NBN=0;
<a name="l00809"></a>00809   <span class="keywordflow">for</span>(i=0;i&lt;N;i++)
<a name="l00810"></a>00810     <span class="keywordflow">if</span>(mask[i]==2 || mask[i]==1)
<a name="l00811"></a>00811       NBN++;
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   <span class="keywordflow">if</span>(NBN&gt;0)
<a name="l00814"></a>00814   {
<a name="l00815"></a>00815     <span class="keywordflow">if</span>(msglev&gt;=1) fprintf(sout,<span class="stringliteral">&quot;# of Boundary Nodes=%d  \n&quot;</span>,NBN);
<a name="l00816"></a>00816 
<a name="l00817"></a>00817     NBN=0;
<a name="l00818"></a>00818     <span class="keywordflow">for</span>(i=0;i&lt;N;i++)
<a name="l00819"></a>00819       <span class="keywordflow">if</span>(mask[i]==2)
<a name="l00820"></a>00820         NBN++;
<a name="l00821"></a>00821     <span class="keywordflow">if</span>(msglev&gt;=1) fprintf(sout,<span class="stringliteral">&quot;# of moving Boundary Nodes=%d  \n&quot;</span>,NBN);
<a name="l00822"></a>00822   }
<a name="l00823"></a>00823 
<a name="l00824"></a>00824   <span class="keywordflow">for</span>(i=0;i&lt;N;i++)
<a name="l00825"></a>00825   {
<a name="l00826"></a>00826     <span class="keywordflow">if</span>((mask[i]==1)||(mask[i]==2))
<a name="l00827"></a>00827       maskf[i]=1;
<a name="l00828"></a>00828     <span class="keywordflow">else</span>
<a name="l00829"></a>00829       maskf[i]=0;
<a name="l00830"></a>00830   }
<a name="l00831"></a>00831 
<a name="l00832"></a>00832   <span class="comment">/*-------determination of min jacobian-------*/</span>
<a name="l00833"></a>00833   qmin=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2849eb387db1a62d80463624dd4a2885">minq</a>(n, N, R, ncells, cells, mcells, me, H, &amp;vol, &amp;Vmin, sout);
<a name="l00834"></a>00834   <span class="keywordflow">if</span>(me&gt;1) vol=1.0;
<a name="l00835"></a>00835   <span class="keywordflow">if</span>(msglev&gt;=1) fprintf(sout,<span class="stringliteral">&quot;vol=%e  qmin=%e min volume = %e\n&quot;</span>,vol,qmin,Vmin);
<a name="l00836"></a>00836 
<a name="l00837"></a>00837   epsilon=0.000000001;
<a name="l00838"></a>00838   <span class="comment">//compute max distortion measure over all cells</span>
<a name="l00839"></a>00839   <span class="keywordflow">if</span>(qmin&lt;0){eps=sqrt(epsilon*epsilon+0.004*qmin*qmin*vol*vol);} <span class="keywordflow">else</span> eps=epsilon;
<a name="l00840"></a>00840   emax=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2ef72a340e51765a2b6aa843edbf88ad">maxE</a>(n, N, R, ncells, cells, mcells, me, H, vol, eps, w, Gamma, &amp;qmin, sout);
<a name="l00841"></a>00841   <span class="keywordflow">if</span>(msglev&gt;=1) fprintf(sout,<span class="stringliteral">&quot; emax=%e \n&quot;</span>,emax);
<a name="l00842"></a>00842 
<a name="l00843"></a>00843   <span class="comment">/*-------unfolding/smoothing-----------*/</span>
<a name="l00844"></a>00844 
<a name="l00845"></a>00845   <span class="comment">//iteration tolerance</span>
<a name="l00846"></a>00846   ii=0; counter=0;
<a name="l00847"></a>00847   Enm1=1.0;
<a name="l00848"></a>00848 
<a name="l00849"></a>00849   <span class="comment">//read adaptive function from file</span>
<a name="l00850"></a>00850   <span class="keywordflow">if</span>(adp*gr!=0) <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abcd0c8f82d12085857cf14d1d2e09bb7">read_adp</a>(afun, adap, sout);
<a name="l00851"></a>00851 
<a name="l00852"></a>00852   <span class="keywordflow">while</span>(((qmin&lt;=0)||(counter&lt;iter[0])||(fabs(emax-Enm1)&gt;1e-3))&amp;&amp;(ii&lt;iter[1])&amp;&amp;(counter&lt;iter[1]))
<a name="l00853"></a>00853   {
<a name="l00854"></a>00854     libmesh_assert(counter&lt;iter[1]);
<a name="l00855"></a>00855 
<a name="l00856"></a>00856     Enm1=emax;
<a name="l00857"></a>00857 
<a name="l00858"></a>00858     <span class="keywordflow">if</span>((ii&gt;=0)&amp;&amp;(ii%2==0))
<a name="l00859"></a>00859     {
<a name="l00860"></a>00860       <span class="keywordflow">if</span>(qmin&lt;0)
<a name="l00861"></a>00861         eps=sqrt(epsilon*epsilon+0.004*qmin*qmin*vol*vol);
<a name="l00862"></a>00862       <span class="keywordflow">else</span>
<a name="l00863"></a>00863         eps=epsilon;
<a name="l00864"></a>00864     }
<a name="l00865"></a>00865 
<a name="l00866"></a>00866     <span class="keywordflow">if</span>((qmin&lt;=0)||(counter&lt;ii)) ladp=0; <span class="keywordflow">else</span> ladp=adp;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868     <span class="comment">//update adaptation function before each iteration</span>
<a name="l00869"></a>00869     <span class="keywordflow">if</span>((ladp!=0)&amp;&amp;(gr==0))
<a name="l00870"></a>00870       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af8f5b5f11a05b03da6e2352a5aeba5a7">adp_renew</a>(n, N, R, ncells, cells, afun, adp, sout);
<a name="l00871"></a>00871 
<a name="l00872"></a>00872     Jk=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a9d0928fd44bcffeed376f882c1f11aeb">minJ</a>(n, N, R, maskf, ncells, cells, mcells, eps, w, me, H, vol, nedges, edges, hnodes,
<a name="l00873"></a>00873             msglev, &amp;Vmin, &amp;emax, &amp;qmin, ladp, afun, sout);
<a name="l00874"></a>00874 
<a name="l00875"></a>00875     <span class="keywordflow">if</span>(qmin&gt;0)
<a name="l00876"></a>00876       counter++;
<a name="l00877"></a>00877     <span class="keywordflow">else</span>
<a name="l00878"></a>00878       ii++;
<a name="l00879"></a>00879 
<a name="l00880"></a>00880     <span class="keywordflow">if</span>(msglev&gt;=1)
<a name="l00881"></a>00881     {
<a name="l00882"></a>00882       fprintf(sout, <span class="stringliteral">&quot;niter=%d, qmin*G/vol=%e, Vmin=%e, emax=%e  Jk=%e \n&quot;</span>,counter,qmin,Vmin,emax, Jk);
<a name="l00883"></a>00883       fprintf(sout,<span class="stringliteral">&quot; emax=%e, Enm1=%e \n&quot;</span>,emax,Enm1);
<a name="l00884"></a>00884     }
<a name="l00885"></a>00885 
<a name="l00886"></a>00886   }
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   free(Gamma);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   <span class="comment">/*-----BN correction - 2D only!---*/</span>
<a name="l00891"></a>00891   epsilon=0.000000001;
<a name="l00892"></a>00892   <span class="keywordflow">if</span>(NBN&gt;0) <span class="keywordflow">for</span>(counter=0;counter&lt;iter[2];counter++)
<a name="l00893"></a>00893   {
<a name="l00894"></a>00894     <span class="comment">//update adaptation function before each iteration</span>
<a name="l00895"></a>00895     <span class="keywordflow">if</span>((adp!=0)&amp;&amp;(gr==0))
<a name="l00896"></a>00896       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af8f5b5f11a05b03da6e2352a5aeba5a7">adp_renew</a>(n, N, R, ncells, cells, afun, adp, sout);
<a name="l00897"></a>00897     Jk=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a23a2e24c743ad61769e2b263fb2ca3fb">minJ_BC</a>(N, R, mask, ncells, cells, mcells, eps, w, me, H, vol, msglev, &amp;Vmin, &amp;emax, &amp;qmin, adp, afun, NBN, sout);
<a name="l00898"></a>00898     <span class="keywordflow">if</span>(msglev&gt;=1)
<a name="l00899"></a>00899       fprintf(sout, <span class="stringliteral">&quot;NBC niter=%d, qmin*G/vol=%e, Vmin=%e, emax=%e  \n&quot;</span>,counter,qmin,Vmin,emax);
<a name="l00900"></a>00900 
<a name="l00901"></a>00901     <span class="comment">//Outrageous Enm1 to make sure we hit this atleast once</span>
<a name="l00902"></a>00902     Enm1=99999;
<a name="l00903"></a>00903 
<a name="l00904"></a>00904     <span class="comment">//Now that we&#39;ve moved the boundary nodes (or not) we need to resmoooth</span>
<a name="l00905"></a>00905     <span class="keywordflow">for</span>(j=0;(j&lt;iter[1]);j++)
<a name="l00906"></a>00906     {
<a name="l00907"></a>00907       <span class="keywordflow">if</span>(fabs(emax-Enm1)&lt;1e-2)
<a name="l00908"></a>00908         <span class="keywordflow">break</span>;
<a name="l00909"></a>00909 
<a name="l00910"></a>00910       <span class="comment">//Save off the error from the previous smoothing step</span>
<a name="l00911"></a>00911       Enm1=emax;
<a name="l00912"></a>00912 
<a name="l00913"></a>00913       <span class="comment">//update adaptation function before each iteration</span>
<a name="l00914"></a>00914       <span class="keywordflow">if</span>((adp!=0)&amp;&amp;(gr==0))
<a name="l00915"></a>00915         <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af8f5b5f11a05b03da6e2352a5aeba5a7">adp_renew</a>(n, N, R, ncells, cells, afun, adp, sout);
<a name="l00916"></a>00916 
<a name="l00917"></a>00917       Jk=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a9d0928fd44bcffeed376f882c1f11aeb">minJ</a>(n, N, R, maskf, ncells, cells, mcells, eps, w, me, H, vol, nedges, edges, hnodes,msglev, &amp;Vmin, &amp;emax, &amp;qmin, adp, afun, sout);
<a name="l00918"></a>00918 
<a name="l00919"></a>00919       <span class="keywordflow">if</span>(msglev&gt;=1)
<a name="l00920"></a>00920       {
<a name="l00921"></a>00921         fprintf(sout, <span class="stringliteral">&quot;  Re-smooth: niter=%d, qmin*G/vol=%e, Vmin=%e, emax=%e  Jk=%e \n&quot;</span>,j,qmin,Vmin,emax, Jk);
<a name="l00922"></a>00922         <span class="comment">//fprintf(sout,&quot;    emax-Enm1=%e \n&quot;,emax-Enm1);</span>
<a name="l00923"></a>00923       }
<a name="l00924"></a>00924     }
<a name="l00925"></a>00925 
<a name="l00926"></a>00926     <span class="keywordflow">if</span>(msglev&gt;=1)
<a name="l00927"></a>00927       fprintf(sout, <span class="stringliteral">&quot;NBC smoothed niter=%d, qmin*G/vol=%e, Vmin=%e, emax=%e  \n&quot;</span>,counter,qmin,Vmin,emax);
<a name="l00928"></a>00928   }
<a name="l00929"></a>00929 
<a name="l00930"></a>00930   <span class="comment">/*----------free memory-----------------*/</span>
<a name="l00931"></a>00931   <span class="comment">//free(maskf);</span>
<a name="l00932"></a>00932   <span class="comment">//if(adp!=0) free(afun);</span>
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 
<a name="l00935"></a>00935   <span class="keywordflow">return</span>;
<a name="l00936"></a>00936 }
<a name="l00937"></a>00937 
<a name="l00941"></a>00941 <span class="comment">// double VariationalMeshSmoother::maxE(int n, int N, LPLPDOUBLE R, int ncells, LPLPINT cells, LPINT mcells,</span>
<a name="l00942"></a>00942 <span class="comment">//             int me, LPLPLPDOUBLE H, double v, double epsilon, double w, LPDOUBLE Gamma,</span>
<a name="l00943"></a>00943 <span class="comment">//                      double *qmin, FILE *sout)</span>
<a name="l00944"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2ef72a340e51765a2b6aa843edbf88ad">00944</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2ef72a340e51765a2b6aa843edbf88ad">VariationalMeshSmoother::maxE</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l00945"></a>00945             <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> v, <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> Gamma,
<a name="l00946"></a>00946                         <span class="keywordtype">double</span> *qmin, FILE *)
<a name="l00947"></a>00947 {
<a name="l00948"></a>00948   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q;
<a name="l00949"></a>00949   <span class="keywordtype">double</span> K[9], a1[3], a2[3], a3[3];
<a name="l00950"></a>00950   <span class="keywordtype">double</span>  gemax, det, tr, E=0.0, sigma=0.0, chi, vmin;
<a name="l00951"></a>00951   <span class="keywordtype">int</span>  ii, i, j, k, l, m, nn, kk, ll;
<a name="l00952"></a>00952 
<a name="l00953"></a>00953   Q = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3, 10);
<a name="l00954"></a>00954   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) Q[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3*n+n%2);
<a name="l00955"></a>00955 
<a name="l00956"></a>00956   gemax=-1e32; vmin=1e32;
<a name="l00957"></a>00957 
<a name="l00958"></a>00958 <span class="keywordflow">for</span>(ii=0; ii&lt;ncells; ii++) if(mcells[ii]&gt;=0){
<a name="l00959"></a>00959     <span class="keywordflow">if</span>(n==2){
<a name="l00960"></a>00960                 <span class="keywordflow">if</span>(cells[ii][3]==-1){<span class="comment">//tri</span>
<a name="l00961"></a>00961           <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,3,K,H[ii],me);
<a name="l00962"></a>00962           <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l00963"></a>00963              <span class="keywordflow">for</span>(l=0;l&lt;3;l++){
<a name="l00964"></a>00964                  a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l00965"></a>00965                  a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l00966"></a>00966              }
<a name="l00967"></a>00967           }
<a name="l00968"></a>00968           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l00969"></a>00969           tr=0.5*(a1[0]*a1[0]+a2[0]*a2[0]+a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l00970"></a>00970           chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l00971"></a>00971           E=(1-w)*tr/chi+0.5*w*(v+det*det/v)/chi;
<a name="l00972"></a>00972           <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l00973"></a>00973                   <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l00974"></a>00974                 } <span class="keywordflow">else</span> <span class="keywordflow">if</span>(cells[ii][4]==-1){ E=0; <span class="comment">//quad</span>
<a name="l00975"></a>00975           <span class="keywordflow">for</span>(i=0; i&lt;2; i++){ K[0]=i;
<a name="l00976"></a>00976             <span class="keywordflow">for</span>(j=0; j&lt;2; j++){ K[1]=j;
<a name="l00977"></a>00977                            <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,4,K,H[ii],me);
<a name="l00978"></a>00978                <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l00979"></a>00979                   <span class="keywordflow">for</span>(l=0;l&lt;4;l++){
<a name="l00980"></a>00980                       a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l00981"></a>00981                       a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l00982"></a>00982                   }
<a name="l00983"></a>00983                }
<a name="l00984"></a>00984                det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l00985"></a>00985                tr=0.5*(a1[0]*a1[0]+a2[0]*a2[0]+a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l00986"></a>00986                chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l00987"></a>00987                E+=0.25*((1-w)*tr/chi+0.5*w*(v+det*det/v)/chi);
<a name="l00988"></a>00988                            <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l00989"></a>00989                         }
<a name="l00990"></a>00990           }
<a name="l00991"></a>00991           <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l00992"></a>00992                 } <span class="keywordflow">else</span> { E=0; <span class="comment">//quad tri</span>
<a name="l00993"></a>00993             <span class="keywordflow">for</span>(i=0; i&lt;3; i++){ K[0]=i*0.5; k=i/2; K[1]=(double)k;
<a name="l00994"></a>00994                <span class="keywordflow">for</span>(j=0; j&lt;3; j++){  K[2]=j*0.5; k=j/2; K[3]=(double)k;
<a name="l00995"></a>00995                               <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,6,K,H[ii],me);
<a name="l00996"></a>00996                   <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l00997"></a>00997                      <span class="keywordflow">for</span>(l=0;l&lt;6;l++){
<a name="l00998"></a>00998                         a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l00999"></a>00999                         a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l01000"></a>01000                      }
<a name="l01001"></a>01001                   }
<a name="l01002"></a>01002                   det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l01003"></a>01003                   <span class="keywordflow">if</span>(i==j) sigma=1.0/12; <span class="keywordflow">else</span> sigma=1.0/24;
<a name="l01004"></a>01004                   tr=0.5*(a1[0]*a1[0]+a2[0]*a2[0]+a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l01005"></a>01005                   chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l01006"></a>01006                   E+=sigma*((1-w)*tr/chi+0.5*w*(v+det*det/v)/chi);
<a name="l01007"></a>01007                                   <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01008"></a>01008                            }
<a name="l01009"></a>01009                         }
<a name="l01010"></a>01010             <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l01011"></a>01011                 }
<a name="l01012"></a>01012         }
<a name="l01013"></a>01013     <span class="keywordflow">if</span>(n==3){
<a name="l01014"></a>01014        <span class="keywordflow">if</span>(cells[ii][4]==-1){<span class="comment">//tetr</span>
<a name="l01015"></a>01015            <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,4,K,H[ii],me);
<a name="l01016"></a>01016            <span class="keywordflow">for</span>(k=0;k&lt;3;k++){a1[k]=0; a2[k]=0; a3[k]=0;
<a name="l01017"></a>01017               <span class="keywordflow">for</span>(l=0;l&lt;4;l++){
<a name="l01018"></a>01018                   a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l01019"></a>01019                   a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l01020"></a>01020                   a3[k]=a3[k]+Q[k][l]*R[cells[ii][l]][2];
<a name="l01021"></a>01021               }
<a name="l01022"></a>01022            }
<a name="l01023"></a>01023            det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01024"></a>01024            tr=0; <span class="keywordflow">for</span>(k=0;k&lt;3;k++) tr+=(a1[k]*a1[k]+a2[k]*a2[k]+a3[k]*a3[k])/3.0;
<a name="l01025"></a>01025            chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l01026"></a>01026            E=(1-w)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(tr,1.5)/chi+0.5*w*(v+det*det/v)/chi;
<a name="l01027"></a>01027            <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l01028"></a>01028                    <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01029"></a>01029        } <span class="keywordflow">else</span> <span class="keywordflow">if</span>(cells[ii][6]==-1){<span class="comment">//prism</span>
<a name="l01030"></a>01030           E=0;
<a name="l01031"></a>01031           <span class="keywordflow">for</span>(i=0;i&lt;2;i++){ K[0]=i;
<a name="l01032"></a>01032               <span class="keywordflow">for</span>(j=0;j&lt;2;j++){ K[1]=j;
<a name="l01033"></a>01033                   <span class="keywordflow">for</span>(k=0;k&lt;3;k++) {K[2]=(double)k/2.0; K[3]=(double)(k%2);
<a name="l01034"></a>01034                       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,6,K,H[ii],me);
<a name="l01035"></a>01035                       <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++){a1[kk]=0; a2[kk]=0; a3[kk]=0;
<a name="l01036"></a>01036                           <span class="keywordflow">for</span>(ll=0;ll&lt;6;ll++){
<a name="l01037"></a>01037                               a1[kk]=a1[kk]+Q[kk][ll]*R[cells[ii][ll]][0];
<a name="l01038"></a>01038                               a2[kk]=a2[kk]+Q[kk][ll]*R[cells[ii][ll]][1];
<a name="l01039"></a>01039                               a3[kk]=a3[kk]+Q[kk][ll]*R[cells[ii][ll]][2];
<a name="l01040"></a>01040                           }
<a name="l01041"></a>01041                       }
<a name="l01042"></a>01042                       det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01043"></a>01043                       tr=0; <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++) tr+=(a1[kk]*a1[kk]+a2[kk]*a2[kk]+a3[kk]*a3[kk])/3.0;
<a name="l01044"></a>01044                       chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l01045"></a>01045                       E+=((1-w)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(tr,1.5)/chi+0.5*w*(v+det*det/v)/chi)/12.0;
<a name="l01046"></a>01046                                           <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01047"></a>01047                                   }
<a name="l01048"></a>01048                           }
<a name="l01049"></a>01049                   }
<a name="l01050"></a>01050           <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l01051"></a>01051        } <span class="keywordflow">else</span> <span class="keywordflow">if</span>(cells[ii][8]==-1){ E=0; <span class="comment">//hex</span>
<a name="l01052"></a>01052          <span class="keywordflow">for</span>(i=0; i&lt;2; i++){ K[0]=i;
<a name="l01053"></a>01053              <span class="keywordflow">for</span>(j=0; j&lt;2; j++){ K[1]=j;
<a name="l01054"></a>01054                  <span class="keywordflow">for</span>(k=0; k&lt;2; k++){ K[2]=k;
<a name="l01055"></a>01055                      <span class="keywordflow">for</span>(l=0; l&lt;2; l++){ K[3]=l;
<a name="l01056"></a>01056                          <span class="keywordflow">for</span>(m=0; m&lt;2; m++){ K[4]=m;
<a name="l01057"></a>01057                              <span class="keywordflow">for</span>(nn=0; nn&lt;2; nn++){ K[5]=nn;
<a name="l01058"></a>01058                                 <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,8,K,H[ii],me);
<a name="l01059"></a>01059                                 <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++){a1[kk]=0; a2[kk]=0; a3[kk]=0;
<a name="l01060"></a>01060                                    <span class="keywordflow">for</span>(ll=0;ll&lt;8;ll++){
<a name="l01061"></a>01061                                       a1[kk]=a1[kk]+Q[kk][ll]*R[cells[ii][ll]][0];
<a name="l01062"></a>01062                                       a2[kk]=a2[kk]+Q[kk][ll]*R[cells[ii][ll]][1];
<a name="l01063"></a>01063                                       a3[kk]=a3[kk]+Q[kk][ll]*R[cells[ii][ll]][2];
<a name="l01064"></a>01064                                    }
<a name="l01065"></a>01065                                 }
<a name="l01066"></a>01066                                 det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01067"></a>01067                                                                 <span class="keywordflow">if</span>((i==nn)&amp;&amp;(j==l)&amp;&amp;(k==m)) sigma=(double)1/27;
<a name="l01068"></a>01068                                 <span class="keywordflow">if</span>(((i==nn)&amp;&amp;(j==l)&amp;&amp;(k!=m))||((i==nn)&amp;&amp;(j!=l)&amp;&amp;(k==m))||((i!=nn)&amp;&amp;(j==l)&amp;&amp;(k==m))) sigma=(<span class="keywordtype">double</span>)1/(27*2);
<a name="l01069"></a>01069                                 <span class="keywordflow">if</span>(((i==nn)&amp;&amp;(j!=l)&amp;&amp;(k!=m))||((i!=nn)&amp;&amp;(j!=l)&amp;&amp;(k==m))||((i!=nn)&amp;&amp;(j==l)&amp;&amp;(k!=m))) sigma=(double)1/(27*4);
<a name="l01070"></a>01070                                 <span class="keywordflow">if</span>((i!=nn)&amp;&amp;(j!=l)&amp;&amp;(k!=m)) sigma=(<span class="keywordtype">double</span>)1/(27*8);
<a name="l01071"></a>01071                                 tr=0; <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++) tr+=(a1[kk]*a1[kk]+a2[kk]*a2[kk]+a3[kk]*a3[kk])/3.0;
<a name="l01072"></a>01072                                 chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l01073"></a>01073                                 E+=((1-w)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(tr,1.5)/chi+0.5*w*(v+det*det/v)/chi)*sigma;
<a name="l01074"></a>01074                                                                 <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01075"></a>01075                                                          }
<a name="l01076"></a>01076                          }
<a name="l01077"></a>01077                       }
<a name="l01078"></a>01078                   }
<a name="l01079"></a>01079               }
<a name="l01080"></a>01080           }
<a name="l01081"></a>01081           <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l01082"></a>01082        } <span class="keywordflow">else</span> {<span class="comment">//quad tetr</span>
<a name="l01083"></a>01083                    E=0;
<a name="l01084"></a>01084           <span class="keywordflow">for</span>(i=0;i&lt;4;i++){
<a name="l01085"></a>01085             <span class="keywordflow">for</span>(j=0;j&lt;4;j++){
<a name="l01086"></a>01086                   <span class="keywordflow">for</span>(k=0;k&lt;4;k++){
<a name="l01087"></a>01087                     <span class="keywordflow">switch</span> (i)
<a name="l01088"></a>01088                     { <span class="keywordflow">case</span> 0 : K[0]=0; K[1]=0; K[2]=0; <span class="keywordflow">break</span>;
<a name="l01089"></a>01089                       <span class="keywordflow">case</span> 1 : K[0]=1; K[1]=0; K[2]=0; <span class="keywordflow">break</span>;
<a name="l01090"></a>01090                       <span class="keywordflow">case</span> 2 : K[0]=1.0/2; K[1]=1; K[2]=0; <span class="keywordflow">break</span>;
<a name="l01091"></a>01091                       <span class="keywordflow">case</span> 3 : K[0]=1.0/2; K[1]=1.0/3; K[2]=1; <span class="keywordflow">break</span>; }
<a name="l01092"></a>01092                     <span class="keywordflow">switch</span> (j)
<a name="l01093"></a>01093                     { <span class="keywordflow">case</span> 0 : K[3]=0; K[4]=0; K[5]=0; <span class="keywordflow">break</span>;
<a name="l01094"></a>01094                       <span class="keywordflow">case</span> 1 : K[3]=1; K[4]=0; K[5]=0; <span class="keywordflow">break</span>;
<a name="l01095"></a>01095                       <span class="keywordflow">case</span> 2 : K[3]=1.0/2; K[4]=1; K[5]=0; <span class="keywordflow">break</span>;
<a name="l01096"></a>01096                       <span class="keywordflow">case</span> 3 : K[3]=1.0/2; K[4]=1.0/3; K[5]=1; <span class="keywordflow">break</span>; }
<a name="l01097"></a>01097                     <span class="keywordflow">switch</span> (k)
<a name="l01098"></a>01098                     { <span class="keywordflow">case</span> 0 : K[6]=0; K[7]=0; K[8]=0; <span class="keywordflow">break</span>;
<a name="l01099"></a>01099                       <span class="keywordflow">case</span> 1 : K[6]=1; K[7]=0; K[8]=0; <span class="keywordflow">break</span>;
<a name="l01100"></a>01100                       <span class="keywordflow">case</span> 2 : K[6]=1.0/2; K[7]=1; K[8]=0; <span class="keywordflow">break</span>;
<a name="l01101"></a>01101                       <span class="keywordflow">case</span> 3 : K[6]=1.0/2; K[7]=1.0/3; K[8]=1; <span class="keywordflow">break</span>; }
<a name="l01102"></a>01102                     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,10,K,H[ii],me);
<a name="l01103"></a>01103                     <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++){a1[kk]=0; a2[kk]=0; a3[kk]=0;
<a name="l01104"></a>01104                        <span class="keywordflow">for</span>(ll=0;ll&lt;10;ll++){
<a name="l01105"></a>01105                           a1[kk]=a1[kk]+Q[kk][ll]*R[cells[ii][ll]][0];
<a name="l01106"></a>01106                           a2[kk]=a2[kk]+Q[kk][ll]*R[cells[ii][ll]][1];
<a name="l01107"></a>01107                           a3[kk]=a3[kk]+Q[kk][ll]*R[cells[ii][ll]][2];
<a name="l01108"></a>01108                        }
<a name="l01109"></a>01109                     }
<a name="l01110"></a>01110                     det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01111"></a>01111                     <span class="keywordflow">if</span>((i==j)&amp;&amp;(j==k)) sigma=1.0/120; <span class="keywordflow">else</span>
<a name="l01112"></a>01112                             <span class="keywordflow">if</span>((i==j)||(j==k)||(i==k)) sigma=1.0/360; <span class="keywordflow">else</span> sigma=1.0/720;
<a name="l01113"></a>01113                     tr=0; <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++) tr+=(a1[kk]*a1[kk]+a2[kk]*a2[kk]+a3[kk]*a3[kk])/3.0;
<a name="l01114"></a>01114                     chi=0.5*(det+sqrt(det*det+epsilon*epsilon));
<a name="l01115"></a>01115                     E+=((1-w)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(tr,1.5)/chi+0.5*w*(v+det*det/v)/chi)*sigma;
<a name="l01116"></a>01116                                         <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01117"></a>01117                           }
<a name="l01118"></a>01118                         }
<a name="l01119"></a>01119                   }
<a name="l01120"></a>01120           <span class="keywordflow">if</span>(E&gt;gemax) gemax=E;
<a name="l01121"></a>01121            }
<a name="l01122"></a>01122         }
<a name="l01123"></a>01123         Gamma[ii]=E;
<a name="l01124"></a>01124 }
<a name="l01125"></a>01125 
<a name="l01126"></a>01126 (*qmin)=vmin;
<a name="l01127"></a>01127 
<a name="l01128"></a>01128 <span class="keywordflow">for</span>(i=0;i&lt;n;i++) free(Q[i]);
<a name="l01129"></a>01129 free(Q);
<a name="l01130"></a>01130 
<a name="l01131"></a>01131 <span class="keywordflow">return</span> gemax;
<a name="l01132"></a>01132 }
<a name="l01133"></a>01133 
<a name="l01137"></a>01137 <span class="comment">// double VariationalMeshSmoother::minq(int n, int N, LPLPDOUBLE R, int ncells, LPLPINT cells, LPINT mcells,</span>
<a name="l01138"></a>01138 <span class="comment">//                                      int me, LPLPLPDOUBLE H, double *vol, double *Vmin, FILE *sout)</span>
<a name="l01139"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2849eb387db1a62d80463624dd4a2885">01139</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2849eb387db1a62d80463624dd4a2885">VariationalMeshSmoother::minq</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l01140"></a>01140                                      <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> *vol, <span class="keywordtype">double</span> *Vmin, FILE *)
<a name="l01141"></a>01141 {
<a name="l01142"></a>01142   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q;
<a name="l01143"></a>01143   <span class="keywordtype">double</span> K[9], a1[3], a2[3], a3[3];
<a name="l01144"></a>01144   <span class="keywordtype">double</span>  v, vmin, gqmin, det, vcell, sigma=0.0;
<a name="l01145"></a>01145   <span class="keywordtype">int</span>  ii, i, j, k, l, m, nn, kk, ll;
<a name="l01146"></a>01146 
<a name="l01147"></a>01147   Q = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3, 10);
<a name="l01148"></a>01148   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) Q[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3*n+n%2);
<a name="l01149"></a>01149 
<a name="l01150"></a>01150   v=0; vmin=1e32; gqmin=1e32;
<a name="l01151"></a>01151 
<a name="l01152"></a>01152 <span class="keywordflow">for</span>(ii=0; ii&lt;ncells; ii++) if(mcells[ii]&gt;=0){
<a name="l01153"></a>01153     <span class="keywordflow">if</span>(n==2){<span class="comment">//2D</span>
<a name="l01154"></a>01154         <span class="keywordflow">if</span>(cells[ii][3]==-1){<span class="comment">//tri</span>
<a name="l01155"></a>01155           <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,3,K,H[ii],me);
<a name="l01156"></a>01156           <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l01157"></a>01157              <span class="keywordflow">for</span>(l=0;l&lt;3;l++){
<a name="l01158"></a>01158                  a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l01159"></a>01159                  a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l01160"></a>01160              }
<a name="l01161"></a>01161           }
<a name="l01162"></a>01162           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l01163"></a>01163           <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det;
<a name="l01164"></a>01164           <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01165"></a>01165           v+=det;
<a name="l01166"></a>01166         } <span class="keywordflow">else</span> <span class="keywordflow">if</span>(cells[ii][4]==-1){ vcell=0; <span class="comment">//quad</span>
<a name="l01167"></a>01167           <span class="keywordflow">for</span>(i=0; i&lt;2; i++){ K[0]=i;
<a name="l01168"></a>01168             <span class="keywordflow">for</span>(j=0; j&lt;2; j++){ K[1]=j;
<a name="l01169"></a>01169                <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,4,K,H[ii],me);
<a name="l01170"></a>01170                <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l01171"></a>01171                   <span class="keywordflow">for</span>(l=0;l&lt;4;l++){
<a name="l01172"></a>01172                       a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l01173"></a>01173                       a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l01174"></a>01174                   }
<a name="l01175"></a>01175                }
<a name="l01176"></a>01176                det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l01177"></a>01177                <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det;
<a name="l01178"></a>01178                            v+=0.25*det;
<a name="l01179"></a>01179                            vcell+=0.25*det;
<a name="l01180"></a>01180             }
<a name="l01181"></a>01181           }
<a name="l01182"></a>01182           <span class="keywordflow">if</span>(vmin&gt;vcell) vmin=vcell;
<a name="l01183"></a>01183                 } <span class="keywordflow">else</span> { vcell=0; <span class="comment">//quad tri</span>
<a name="l01184"></a>01184             <span class="keywordflow">for</span>(i=0; i&lt;3; i++){ K[0]=i*0.5; k=i/2; K[1]=(double)k;
<a name="l01185"></a>01185                <span class="keywordflow">for</span>(j=0; j&lt;3; j++){  K[2]=j*0.5; k=j/2; K[3]=(double)k;
<a name="l01186"></a>01186                               <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,6,K,H[ii],me);
<a name="l01187"></a>01187                   <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l01188"></a>01188                      <span class="keywordflow">for</span>(l=0;l&lt;6;l++){
<a name="l01189"></a>01189                         a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l01190"></a>01190                         a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l01191"></a>01191                      }
<a name="l01192"></a>01192                   }
<a name="l01193"></a>01193                   det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l01194"></a>01194                   <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det;
<a name="l01195"></a>01195                                   <span class="keywordflow">if</span>(i==j) sigma=1.0/12; <span class="keywordflow">else</span> sigma=1.0/24;
<a name="l01196"></a>01196                                   v+=sigma*det;
<a name="l01197"></a>01197                                   vcell+=sigma*det;
<a name="l01198"></a>01198                            }
<a name="l01199"></a>01199                         }
<a name="l01200"></a>01200                         <span class="keywordflow">if</span>(vmin&gt;vcell) vmin=vcell;
<a name="l01201"></a>01201                 }
<a name="l01202"></a>01202         }
<a name="l01203"></a>01203     <span class="keywordflow">if</span>(n==3){<span class="comment">//3D</span>
<a name="l01204"></a>01204        <span class="keywordflow">if</span>(cells[ii][4]==-1){<span class="comment">//tetr</span>
<a name="l01205"></a>01205            <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,4,K,H[ii],me);
<a name="l01206"></a>01206            <span class="keywordflow">for</span>(k=0;k&lt;3;k++){a1[k]=0; a2[k]=0; a3[k]=0;
<a name="l01207"></a>01207               <span class="keywordflow">for</span>(l=0;l&lt;4;l++){
<a name="l01208"></a>01208                   a1[k]=a1[k]+Q[k][l]*R[cells[ii][l]][0];
<a name="l01209"></a>01209                   a2[k]=a2[k]+Q[k][l]*R[cells[ii][l]][1];
<a name="l01210"></a>01210                   a3[k]=a3[k]+Q[k][l]*R[cells[ii][l]][2];
<a name="l01211"></a>01211               }
<a name="l01212"></a>01212            }
<a name="l01213"></a>01213            det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01214"></a>01214            <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det;
<a name="l01215"></a>01215                    <span class="keywordflow">if</span>(vmin&gt;det) vmin=det;
<a name="l01216"></a>01216            v+=det;
<a name="l01217"></a>01217        } <span class="keywordflow">else</span> <span class="keywordflow">if</span>(cells[ii][6]==-1){<span class="comment">//prism</span>
<a name="l01218"></a>01218           vcell=0;
<a name="l01219"></a>01219           <span class="keywordflow">for</span>(i=0;i&lt;2;i++){ K[0]=i;
<a name="l01220"></a>01220               <span class="keywordflow">for</span>(j=0;j&lt;2;j++){ K[1]=j;
<a name="l01221"></a>01221                   <span class="keywordflow">for</span>(k=0;k&lt;3;k++) {K[2]=(double)k/2.0; K[3]=(double)(k%2);
<a name="l01222"></a>01222                       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,6,K,H[ii],me);
<a name="l01223"></a>01223                       <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++){a1[kk]=0; a2[kk]=0; a3[kk]=0;
<a name="l01224"></a>01224                           <span class="keywordflow">for</span>(ll=0;ll&lt;6;ll++){
<a name="l01225"></a>01225                               a1[kk]=a1[kk]+Q[kk][ll]*R[cells[ii][ll]][0];
<a name="l01226"></a>01226                               a2[kk]=a2[kk]+Q[kk][ll]*R[cells[ii][ll]][1];
<a name="l01227"></a>01227                               a3[kk]=a3[kk]+Q[kk][ll]*R[cells[ii][ll]][2];
<a name="l01228"></a>01228                           }
<a name="l01229"></a>01229                       }
<a name="l01230"></a>01230                       det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01231"></a>01231                       <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det; sigma=1.0/12.0;
<a name="l01232"></a>01232                       v+=sigma*det; vcell+=sigma*det;
<a name="l01233"></a>01233                                   }
<a name="l01234"></a>01234                           }
<a name="l01235"></a>01235                   }
<a name="l01236"></a>01236           <span class="keywordflow">if</span>(vmin&gt;vcell) vmin=vcell;
<a name="l01237"></a>01237            } <span class="keywordflow">else</span> <span class="keywordflow">if</span>(cells[ii][8]==-1){ vcell=0; <span class="comment">//hex</span>
<a name="l01238"></a>01238          <span class="keywordflow">for</span>(i=0; i&lt;2; i++){ K[0]=i;
<a name="l01239"></a>01239              <span class="keywordflow">for</span>(j=0; j&lt;2; j++){ K[1]=j;
<a name="l01240"></a>01240                  <span class="keywordflow">for</span>(k=0; k&lt;2; k++){ K[2]=k;
<a name="l01241"></a>01241                      <span class="keywordflow">for</span>(l=0; l&lt;2; l++){ K[3]=l;
<a name="l01242"></a>01242                          <span class="keywordflow">for</span>(m=0; m&lt;2; m++){ K[4]=m;
<a name="l01243"></a>01243                              <span class="keywordflow">for</span>(nn=0; nn&lt;2; nn++){ K[5]=nn;
<a name="l01244"></a>01244                                 <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,8,K,H[ii],me);
<a name="l01245"></a>01245                                 <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++){a1[kk]=0; a2[kk]=0; a3[kk]=0;
<a name="l01246"></a>01246                                    <span class="keywordflow">for</span>(ll=0;ll&lt;8;ll++){
<a name="l01247"></a>01247                                       a1[kk]=a1[kk]+Q[kk][ll]*R[cells[ii][ll]][0];
<a name="l01248"></a>01248                                       a2[kk]=a2[kk]+Q[kk][ll]*R[cells[ii][ll]][1];
<a name="l01249"></a>01249                                       a3[kk]=a3[kk]+Q[kk][ll]*R[cells[ii][ll]][2];
<a name="l01250"></a>01250                                    }
<a name="l01251"></a>01251                                 }
<a name="l01252"></a>01252                                 det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01253"></a>01253                                 <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det;
<a name="l01254"></a>01254                                     <span class="keywordflow">if</span>((i==nn)&amp;&amp;(j==l)&amp;&amp;(k==m)) sigma=(double)1/27;
<a name="l01255"></a>01255                                 <span class="keywordflow">if</span>(((i==nn)&amp;&amp;(j==l)&amp;&amp;(k!=m))||((i==nn)&amp;&amp;(j!=l)&amp;&amp;(k==m))||((i!=nn)&amp;&amp;(j==l)&amp;&amp;(k==m))) sigma=(<span class="keywordtype">double</span>)1/(27*2);
<a name="l01256"></a>01256                                 <span class="keywordflow">if</span>(((i==nn)&amp;&amp;(j!=l)&amp;&amp;(k!=m))||((i!=nn)&amp;&amp;(j!=l)&amp;&amp;(k==m))||((i!=nn)&amp;&amp;(j==l)&amp;&amp;(k!=m))) sigma=(double)1/(27*4);
<a name="l01257"></a>01257                                 <span class="keywordflow">if</span>((i!=nn)&amp;&amp;(j!=l)&amp;&amp;(k!=m)) sigma=(<span class="keywordtype">double</span>)1/(27*8);
<a name="l01258"></a>01258                                 v+=sigma*det;
<a name="l01259"></a>01259                                 vcell+=sigma*det;
<a name="l01260"></a>01260                             }
<a name="l01261"></a>01261                          }
<a name="l01262"></a>01262                       }
<a name="l01263"></a>01263                   }
<a name="l01264"></a>01264               }
<a name="l01265"></a>01265           }
<a name="l01266"></a>01266           <span class="keywordflow">if</span>(vmin&gt;vcell) vmin=vcell;
<a name="l01267"></a>01267        } <span class="keywordflow">else</span> {<span class="comment">//quad tetr</span>
<a name="l01268"></a>01268           vcell=0;
<a name="l01269"></a>01269           <span class="keywordflow">for</span>(i=0;i&lt;4;i++){
<a name="l01270"></a>01270               <span class="keywordflow">for</span>(j=0;j&lt;4;j++){
<a name="l01271"></a>01271                   <span class="keywordflow">for</span>(k=0;k&lt;4;k++){
<a name="l01272"></a>01272                     <span class="keywordflow">switch</span> (i)
<a name="l01273"></a>01273                     { <span class="keywordflow">case</span> 0 : K[0]=0; K[1]=0; K[2]=0; <span class="keywordflow">break</span>;
<a name="l01274"></a>01274                       <span class="keywordflow">case</span> 1 : K[0]=1; K[1]=0; K[2]=0; <span class="keywordflow">break</span>;
<a name="l01275"></a>01275                       <span class="keywordflow">case</span> 2 : K[0]=1.0/2; K[1]=1; K[2]=0; <span class="keywordflow">break</span>;
<a name="l01276"></a>01276                       <span class="keywordflow">case</span> 3 : K[0]=1.0/2; K[1]=1.0/3; K[2]=1; <span class="keywordflow">break</span>; }
<a name="l01277"></a>01277                     <span class="keywordflow">switch</span> (j)
<a name="l01278"></a>01278                     { <span class="keywordflow">case</span> 0 : K[3]=0; K[4]=0; K[5]=0; <span class="keywordflow">break</span>;
<a name="l01279"></a>01279                       <span class="keywordflow">case</span> 1 : K[3]=1; K[4]=0; K[5]=0; <span class="keywordflow">break</span>;
<a name="l01280"></a>01280                       <span class="keywordflow">case</span> 2 : K[3]=1.0/2; K[4]=1; K[5]=0; <span class="keywordflow">break</span>;
<a name="l01281"></a>01281                       <span class="keywordflow">case</span> 3 : K[3]=1.0/2; K[4]=1.0/3; K[5]=1; <span class="keywordflow">break</span>; }
<a name="l01282"></a>01282                     <span class="keywordflow">switch</span> (k)
<a name="l01283"></a>01283                     { <span class="keywordflow">case</span> 0 : K[6]=0; K[7]=0; K[8]=0; <span class="keywordflow">break</span>;
<a name="l01284"></a>01284                       <span class="keywordflow">case</span> 1 : K[6]=1; K[7]=0; K[8]=0; <span class="keywordflow">break</span>;
<a name="l01285"></a>01285                       <span class="keywordflow">case</span> 2 : K[6]=1.0/2; K[7]=1; K[8]=0; <span class="keywordflow">break</span>;
<a name="l01286"></a>01286                       <span class="keywordflow">case</span> 3 : K[6]=1.0/2; K[7]=1.0/3; K[8]=1; <span class="keywordflow">break</span>; }
<a name="l01287"></a>01287                     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,10,K,H[ii],me);
<a name="l01288"></a>01288                     <span class="keywordflow">for</span>(kk=0;kk&lt;3;kk++){a1[kk]=0; a2[kk]=0; a3[kk]=0;
<a name="l01289"></a>01289                        <span class="keywordflow">for</span>(ll=0;ll&lt;10;ll++){
<a name="l01290"></a>01290                           a1[kk]=a1[kk]+Q[kk][ll]*R[cells[ii][ll]][0];
<a name="l01291"></a>01291                           a2[kk]=a2[kk]+Q[kk][ll]*R[cells[ii][ll]][1];
<a name="l01292"></a>01292                           a3[kk]=a3[kk]+Q[kk][ll]*R[cells[ii][ll]][2];
<a name="l01293"></a>01293                        }
<a name="l01294"></a>01294                     }
<a name="l01295"></a>01295                     det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l01296"></a>01296                     <span class="keywordflow">if</span>(gqmin&gt;det) gqmin=det;
<a name="l01297"></a>01297                     <span class="keywordflow">if</span>((i==j)&amp;&amp;(j==k)) sigma=1.0/120; <span class="keywordflow">else</span>
<a name="l01298"></a>01298                                                 <span class="keywordflow">if</span>((i==j)||(j==k)||(i==k)) sigma=1.0/360; <span class="keywordflow">else</span> sigma=1.0/720;
<a name="l01299"></a>01299                     v+=sigma*det;   vcell+=sigma*det;
<a name="l01300"></a>01300                           }
<a name="l01301"></a>01301                           }
<a name="l01302"></a>01302                   }
<a name="l01303"></a>01303                   <span class="keywordflow">if</span>(vmin&gt;vcell) vmin=vcell;
<a name="l01304"></a>01304        }
<a name="l01305"></a>01305     }
<a name="l01306"></a>01306 }
<a name="l01307"></a>01307 
<a name="l01308"></a>01308 
<a name="l01309"></a>01309 (*vol)=v/(double)ncells;
<a name="l01310"></a>01310 (*Vmin)=vmin;
<a name="l01311"></a>01311 
<a name="l01312"></a>01312   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) free(Q[i]);
<a name="l01313"></a>01313   free(Q);
<a name="l01314"></a>01314 
<a name="l01315"></a>01315 <span class="keywordflow">return</span> gqmin;
<a name="l01316"></a>01316 }
<a name="l01317"></a>01317 
<a name="l01323"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a9d0928fd44bcffeed376f882c1f11aeb">01323</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a9d0928fd44bcffeed376f882c1f11aeb">VariationalMeshSmoother::minJ</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l01324"></a>01324             <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> nedges,
<a name="l01325"></a>01325             <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keywordtype">int</span> msglev, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin,
<a name="l01326"></a>01326             <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, FILE *sout)
<a name="l01327"></a>01327 {
<a name="l01328"></a>01328 
<a name="l01329"></a>01329 <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> W; <span class="comment">//local Hessian matrix;</span>
<a name="l01330"></a>01330 <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>  F, A, G; <span class="comment">//F - local gradient; G - adaptation metric;</span>
<a name="l01331"></a>01331 <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> b, u, a; <span class="comment">// matrix &amp; rhs for solver, u - solution vector;</span>
<a name="l01332"></a>01332 <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, ja; <span class="comment">// matrix connectivity for solver;</span>
<a name="l01333"></a>01333 <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> JA; <span class="comment">//A, JA - internal form of global matrix;</span>
<a name="l01334"></a>01334 <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Rpr, P; <span class="comment">//P - minimization direction;</span>
<a name="l01335"></a>01335 <span class="keywordtype">double</span>  tau=0.0, J, T, Jpr, lVmin, lemax, lqmin, gVmin=0.0, gemax=0.0,
<a name="l01336"></a>01336 gqmin=0.0, gtmin0=0.0, gtmax0=0.0, gqmin0=0.0;
<a name="l01337"></a>01337 <span class="keywordtype">double</span> eps, nonzero, Tau_hn, g_i;
<a name="l01338"></a>01338 <span class="keywordtype">int</span> index, i, ii, j, jj, k, l, m, nz;
<a name="l01339"></a>01339 <span class="keywordtype">int</span> sch, ind, columns, nvert, ind_i, ind_j, ind_k;
<a name="l01340"></a>01340 <span class="comment">/* Jpr - value of functional;</span>
<a name="l01341"></a>01341 <span class="comment">   nonzero - norm of gradient;</span>
<a name="l01342"></a>01342 <span class="comment">   columns - max number of nonzero entries in every row of global matrix;</span>
<a name="l01343"></a>01343 <span class="comment">*/</span>
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 columns=n*n*10;
<a name="l01346"></a>01346 W=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">alloc_d_n1_n2_n3</a>(n,3*n+n%2,3*n+n%2);
<a name="l01347"></a>01347 F = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(n,3*n+n%2);
<a name="l01348"></a>01348 <span class="keywordflow">for</span>(i=0;i&lt;n;i++){
<a name="l01349"></a>01349    F[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3*n+n%2);
<a name="l01350"></a>01350    W[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3*n+n%2,3*n+n%2);
<a name="l01351"></a>01351    <span class="keywordflow">for</span>(j=0;j&lt;3*n+n%2;j++) W[i][j]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3*n+n%2);}
<a name="l01352"></a>01352 Rpr=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(N,n);
<a name="l01353"></a>01353 P=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(N,n);
<a name="l01354"></a>01354 <span class="keywordflow">for</span>(i=0;i&lt;N;i++) {Rpr[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l01355"></a>01355  P[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);}
<a name="l01356"></a>01356 A = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(n*N, columns);
<a name="l01357"></a>01357 b = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n*N);
<a name="l01358"></a>01358 u = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n*N);
<a name="l01359"></a>01359 a = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n*N*columns);
<a name="l01360"></a>01360 ia = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(n*N+1);
<a name="l01361"></a>01361 ja = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(n*N*columns);
<a name="l01362"></a>01362 JA = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aea218377addb1242650692248f082794">alloc_i_n1_n2</a>(n*N, columns);
<a name="l01363"></a>01363 <span class="keywordflow">for</span>(i=0;i&lt;n*N;i++) {
<a name="l01364"></a>01364    A[i] = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(columns);
<a name="l01365"></a>01365    JA[i] = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(columns);}
<a name="l01366"></a>01366 G=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(ncells,n);
<a name="l01367"></a>01367 <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) G[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l01368"></a>01368 
<a name="l01369"></a>01369 <span class="comment">//---------find minimization direction P-----------------</span>
<a name="l01370"></a>01370 nonzero=0; Jpr=0;
<a name="l01371"></a>01371 <span class="keywordflow">for</span>(i=0; i&lt;n*N; i++){<span class="comment">//initialise matrix and rhs</span>
<a name="l01372"></a>01372     <span class="keywordflow">for</span>(j=0; j&lt;columns; j++){ A[i][j] = 0; JA[i][j] =0;}
<a name="l01373"></a>01373     b[i] = 0;
<a name="l01374"></a>01374     }
<a name="l01375"></a>01375 <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++)
<a name="l01376"></a>01376 {
<a name="l01377"></a>01377   nvert=0;
<a name="l01378"></a>01378   <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0)
<a name="l01379"></a>01379     nvert++;
<a name="l01380"></a>01380   <span class="comment">//---determination of local matrices on each cell----</span>
<a name="l01381"></a>01381 
<a name="l01382"></a>01382   <span class="keywordflow">for</span>(j=0;j&lt;n;j++)
<a name="l01383"></a>01383   {
<a name="l01384"></a>01384     G[i][j]=0; <span class="comment">//adaptation metric G is held constant throughout minJ run</span>
<a name="l01385"></a>01385     <span class="keywordflow">if</span>(adp&lt;0)
<a name="l01386"></a>01386     {
<a name="l01387"></a>01387       <span class="keywordflow">for</span>(k=0;k&lt;abs(adp);k++)
<a name="l01388"></a>01388         G[i][j]=G[i][j]+afun[i*(-adp)+k]; <span class="comment">//cell-based adaptivity is computed here</span>
<a name="l01389"></a>01389     }
<a name="l01390"></a>01390   }
<a name="l01391"></a>01391      <span class="keywordflow">for</span>(index=0;index&lt;n;index++){<span class="comment">//initialise local matrices</span>
<a name="l01392"></a>01392          <span class="keywordflow">for</span>(k=0;k&lt;3*n+n%2;k++){ F[index][k]=0;
<a name="l01393"></a>01393              <span class="keywordflow">for</span>(j=0;j&lt;3*n+n%2;j++) W[index][k][j]=0;
<a name="l01394"></a>01394          }
<a name="l01395"></a>01395      }
<a name="l01396"></a>01396      <span class="keywordflow">if</span>(mcells[i]&gt;=0){<span class="comment">//if cell is not excluded</span>
<a name="l01397"></a>01397          Jpr+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(n, W, F, R, cells[i], mask, epsilon, w, nvert, H[i],
<a name="l01398"></a>01398                      me, vol, 0, &amp;lVmin, &amp;lqmin, adp, afun, G[i], sout);
<a name="l01399"></a>01399      } <span class="keywordflow">else</span> {
<a name="l01400"></a>01400             <span class="keywordflow">for</span>(index=0;index&lt;n;index++) <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++) W[index][j][j]=1;
<a name="l01401"></a>01401      }
<a name="l01402"></a>01402     <span class="comment">//----assembly of an upper triangular part of a global matrix A------</span>
<a name="l01403"></a>01403     <span class="keywordflow">for</span>(index=0;index&lt;n;index++)
<a name="l01404"></a>01404     {
<a name="l01405"></a>01405       <span class="keywordflow">for</span>(l=0; l&lt;nvert; l++)
<a name="l01406"></a>01406       {
<a name="l01407"></a>01407         <span class="keywordflow">for</span>(m=0; m&lt;nvert; m++){
<a name="l01408"></a>01408           <span class="keywordflow">if</span>((W[index][l][m]!=0)&amp;&amp;(cells[i][m]&gt;=cells[i][l]))
<a name="l01409"></a>01409           {
<a name="l01410"></a>01410             sch=0; ind=1;
<a name="l01411"></a>01411             <span class="keywordflow">while</span> (ind!=0)
<a name="l01412"></a>01412             {
<a name="l01413"></a>01413               <span class="keywordflow">if</span>(A[cells[i][l]+index*N][sch]!=0)
<a name="l01414"></a>01414               {
<a name="l01415"></a>01415                   <span class="keywordflow">if</span>(JA[cells[i][l]+index*N][sch]==(cells[i][m]+index*N))
<a name="l01416"></a>01416                   {
<a name="l01417"></a>01417                     A[cells[i][l]+index*N][sch] = A[cells[i][l]+index*N][sch] + W[index][l][m];
<a name="l01418"></a>01418                     ind=0;
<a name="l01419"></a>01419                   }
<a name="l01420"></a>01420                   <span class="keywordflow">else</span>
<a name="l01421"></a>01421                     sch++;
<a name="l01422"></a>01422               }
<a name="l01423"></a>01423               <span class="keywordflow">else</span>
<a name="l01424"></a>01424               {
<a name="l01425"></a>01425                 A[cells[i][l]+index*N][sch] = W[index][l][m];
<a name="l01426"></a>01426                 JA[cells[i][l]+index*N][sch]=cells[i][m]+index*N;
<a name="l01427"></a>01427                 ind = 0;
<a name="l01428"></a>01428               }
<a name="l01429"></a>01429               <span class="keywordflow">if</span>(sch&gt;columns-1) fprintf(sout,<span class="stringliteral">&quot;error: # of nonzero entries in the %d row of Hessian =%d &gt;= columns=%d \n&quot;</span>,cells[i][l],sch,columns);
<a name="l01430"></a>01430             }
<a name="l01431"></a>01431           }
<a name="l01432"></a>01432         }
<a name="l01433"></a>01433         b[cells[i][l]+index*N]=b[cells[i][l]+index*N]-F[index][l];
<a name="l01434"></a>01434       }
<a name="l01435"></a>01435     }
<a name="l01436"></a>01436 <span class="comment">//------end of matrix A---------</span>
<a name="l01437"></a>01437   }
<a name="l01438"></a>01438  <span class="comment">//-------HN correction--------</span>
<a name="l01439"></a>01439  Tau_hn=<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(vol,1.0/(<span class="keywordtype">double</span>)n)*1e-10; <span class="comment">//tolerance for HN being the mid-edge node for its parents</span>
<a name="l01440"></a>01440  <span class="keywordflow">for</span>(i=0;i&lt;nedges;i++){
<a name="l01441"></a>01441      ind_i=hnodes[i]; ind_j=edges[2*i]; ind_k=edges[2*i+1];
<a name="l01442"></a>01442      <span class="keywordflow">for</span>(j=0;j&lt;n;j++){
<a name="l01443"></a>01443          g_i=R[ind_i][j]-0.5*(R[ind_j][j]+R[ind_k][j]);
<a name="l01444"></a>01444          Jpr+=g_i*g_i/(2*Tau_hn);
<a name="l01445"></a>01445          b[ind_i+j*N]-=g_i/Tau_hn;
<a name="l01446"></a>01446          b[ind_j+j*N]+=0.5*g_i/Tau_hn;
<a name="l01447"></a>01447          b[ind_k+j*N]+=0.5*g_i/Tau_hn;
<a name="l01448"></a>01448      }
<a name="l01449"></a>01449      <span class="keywordflow">for</span>(ind=0;ind&lt;columns;ind++){
<a name="l01450"></a>01450          <span class="keywordflow">if</span>(JA[ind_i][ind]==ind_i) A[ind_i][ind]+=1.0/Tau_hn;
<a name="l01451"></a>01451          <span class="keywordflow">if</span>(JA[ind_i+N][ind]==ind_i+N) A[ind_i+N][ind]+=1.0/Tau_hn;
<a name="l01452"></a>01452          <span class="keywordflow">if</span>(n==3) <span class="keywordflow">if</span>(JA[ind_i+2*N][ind]==ind_i+2*N) A[ind_i+2*N][ind]+=1.0/Tau_hn;
<a name="l01453"></a>01453          <span class="keywordflow">if</span>((JA[ind_i][ind]==ind_j)||(JA[ind_i][ind]==ind_k)) A[ind_i][ind]-=0.5/Tau_hn;
<a name="l01454"></a>01454          <span class="keywordflow">if</span>((JA[ind_i+N][ind]==ind_j+N)||(JA[ind_i+N][ind]==ind_k+N)) A[ind_i+N][ind]-=0.5/Tau_hn;
<a name="l01455"></a>01455          <span class="keywordflow">if</span>(n==3) <span class="keywordflow">if</span>((JA[ind_i+2*N][ind]==ind_j+2*N)||(JA[ind_i+2*N][ind]==ind_k+2*N)) A[ind_i+2*N][ind]-=0.5/Tau_hn;
<a name="l01456"></a>01456          <span class="keywordflow">if</span>(JA[ind_j][ind]==ind_i) A[ind_j][ind]-=0.5/Tau_hn;
<a name="l01457"></a>01457          <span class="keywordflow">if</span>(JA[ind_k][ind]==ind_i) A[ind_k][ind]-=0.5/Tau_hn;
<a name="l01458"></a>01458          <span class="keywordflow">if</span>(JA[ind_j+N][ind]==ind_i+N) A[ind_j+N][ind]-=0.5/Tau_hn;
<a name="l01459"></a>01459          <span class="keywordflow">if</span>(JA[ind_k+N][ind]==ind_i+N) A[ind_k+N][ind]-=0.5/Tau_hn;
<a name="l01460"></a>01460          <span class="keywordflow">if</span>(n==3) <span class="keywordflow">if</span>(JA[ind_j+2*N][ind]==ind_i+2*N) A[ind_j+2*N][ind]-=0.5/Tau_hn;
<a name="l01461"></a>01461          <span class="keywordflow">if</span>(n==3) <span class="keywordflow">if</span>(JA[ind_k+2*N][ind]==ind_i+2*N) A[ind_k+2*N][ind]-=0.5/Tau_hn;
<a name="l01462"></a>01462          <span class="keywordflow">if</span>((JA[ind_j][ind]==ind_j)||(JA[ind_j][ind]==ind_k)) A[ind_j][ind]+=0.25/Tau_hn;
<a name="l01463"></a>01463          <span class="keywordflow">if</span>((JA[ind_k][ind]==ind_j)||(JA[ind_k][ind]==ind_k)) A[ind_k][ind]+=0.25/Tau_hn;
<a name="l01464"></a>01464          <span class="keywordflow">if</span>((JA[ind_j+N][ind]==ind_j+N)||(JA[ind_j+N][ind]==ind_k+N)) A[ind_j+N][ind]+=0.25/Tau_hn;
<a name="l01465"></a>01465          <span class="keywordflow">if</span>((JA[ind_k+N][ind]==ind_j+N)||(JA[ind_k+N][ind]==ind_k+N)) A[ind_k+N][ind]+=0.25/Tau_hn;
<a name="l01466"></a>01466          <span class="keywordflow">if</span>(n==3) <span class="keywordflow">if</span>((JA[ind_j+2*N][ind]==ind_j+2*N)||(JA[ind_j+2*N][ind]==ind_k+2*N)) A[ind_j+2*N][ind]+=0.25/Tau_hn;
<a name="l01467"></a>01467          <span class="keywordflow">if</span>(n==3) <span class="keywordflow">if</span>((JA[ind_k+2*N][ind]==ind_j+2*N)||(JA[ind_k+2*N][ind]==ind_k+2*N)) A[ind_k+2*N][ind]+=0.25/Tau_hn;
<a name="l01468"></a>01468      }
<a name="l01469"></a>01469  }
<a name="l01470"></a>01470 <span class="comment">//------||\grad J||_2------</span>
<a name="l01471"></a>01471 <span class="keywordflow">for</span>(i=0;i&lt;n*N;i++){ nonzero=nonzero+b[i]*b[i];}
<a name="l01472"></a>01472 
<a name="l01473"></a>01473 <span class="comment">//-----sort matrix A-----</span>
<a name="l01474"></a>01474   <span class="keywordflow">for</span>(i=0;i&lt;n*N;i++)
<a name="l01475"></a>01475   {
<a name="l01476"></a>01476       <span class="keywordflow">for</span>(j=columns-1;j&gt;1;j--)
<a name="l01477"></a>01477       {
<a name="l01478"></a>01478           <span class="keywordflow">for</span>(k=0;k&lt;j;k++)
<a name="l01479"></a>01479           {
<a name="l01480"></a>01480              <span class="keywordflow">if</span>(JA[i][k]&gt;JA[i][k+1])
<a name="l01481"></a>01481              {
<a name="l01482"></a>01482                sch=JA[i][k];
<a name="l01483"></a>01483                JA[i][k]=JA[i][k+1];
<a name="l01484"></a>01484                JA[i][k+1]=sch;
<a name="l01485"></a>01485                tau=A[i][k];
<a name="l01486"></a>01486                A[i][k]=A[i][k+1];
<a name="l01487"></a>01487                A[i][k+1]=tau;
<a name="l01488"></a>01488              }
<a name="l01489"></a>01489          }
<a name="l01490"></a>01490       }
<a name="l01491"></a>01491   }
<a name="l01492"></a>01492 
<a name="l01493"></a>01493 eps=sqrt(vol)*1e-9;
<a name="l01494"></a>01494 
<a name="l01495"></a>01495 <span class="comment">//-------solver for P (unconstrained)-------</span>
<a name="l01496"></a>01496   ia[0]=0; j=0;
<a name="l01497"></a>01497   <span class="keywordflow">for</span>(i=0;i&lt;n*N;i++)
<a name="l01498"></a>01498   {
<a name="l01499"></a>01499       u[i]=0;
<a name="l01500"></a>01500       nz=0;
<a name="l01501"></a>01501       <span class="keywordflow">for</span>(k=0;k&lt;columns;k++){
<a name="l01502"></a>01502          <span class="keywordflow">if</span>(A[i][k]!=0)
<a name="l01503"></a>01503          {
<a name="l01504"></a>01504            nz++;
<a name="l01505"></a>01505            ja[j]=JA[i][k]+1;
<a name="l01506"></a>01506            a[j]=A[i][k];
<a name="l01507"></a>01507            j++;
<a name="l01508"></a>01508          }
<a name="l01509"></a>01509       }
<a name="l01510"></a>01510       ia[i+1]=ia[i]+nz;
<a name="l01511"></a>01511   }
<a name="l01512"></a>01512   nz=ia[n*N];
<a name="l01513"></a>01513   m=n*N;
<a name="l01514"></a>01514   <span class="keywordflow">if</span>(msglev&gt;=3) sch=1; <span class="keywordflow">else</span> sch=0;
<a name="l01515"></a>01515 
<a name="l01516"></a>01516 
<a name="l01517"></a>01517   nz=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a86eb9c4d0df6ffdc1a0892daf7086131">solver</a>(m,ia,ja,a,u,b,eps,100,sch, sout);
<a name="l01518"></a>01518 <span class="comment">//    sol_pcg_pj(m,ia,ja,a,u,b,eps,100,sch);</span>
<a name="l01519"></a>01519 
<a name="l01520"></a>01520   <span class="keywordflow">for</span>(i=0;i&lt;N;i++){ <span class="comment">//ensure fixed nodes are not moved</span>
<a name="l01521"></a>01521       <span class="keywordflow">for</span>(index=0;index&lt;n;index++)
<a name="l01522"></a>01522           <span class="keywordflow">if</span>(mask[i]==1) P[i][index]=0; <span class="keywordflow">else</span> P[i][index]=u[i+index*N];
<a name="l01523"></a>01523   }
<a name="l01524"></a>01524  <span class="comment">//----P is determined--------</span>
<a name="l01525"></a>01525  <span class="keywordflow">if</span>(msglev&gt;=4){
<a name="l01526"></a>01526  <span class="keywordflow">for</span>(i=0;i&lt;N;i++){
<a name="l01527"></a>01527     <span class="keywordflow">for</span>(j=0;j&lt;n;j++)  <span class="keywordflow">if</span>(P[i][j]!=0) fprintf(sout, <span class="stringliteral">&quot;P[%d][%d]=%f  &quot;</span>,i,j,P[i][j]);
<a name="l01528"></a>01528     }
<a name="l01529"></a>01529  }
<a name="l01530"></a>01530 <span class="comment">//-------local minimization problem, determination of tau----------</span>
<a name="l01531"></a>01531 <span class="keywordflow">if</span>(msglev&gt;=3) fprintf(sout, <span class="stringliteral">&quot;dJ=%e J0=%e \n&quot;</span>,sqrt(nonzero),Jpr);
<a name="l01532"></a>01532 J=1e32; j=1;
<a name="l01533"></a>01533 <span class="keywordflow">while</span>((Jpr&lt;=J)&amp;&amp;(j&gt;-30)){
<a name="l01534"></a>01534    j=j-1;
<a name="l01535"></a>01535    tau=<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(2.0,j); <span class="comment">//search through finite # of values for tau</span>
<a name="l01536"></a>01536    <span class="keywordflow">for</span>(i=0;i&lt;N;i++)
<a name="l01537"></a>01537    {
<a name="l01538"></a>01538        <span class="keywordflow">for</span>(k=0;k&lt;n;k++)
<a name="l01539"></a>01539          Rpr[i][k]=R[i][k]+tau*P[i][k];
<a name="l01540"></a>01540    }
<a name="l01541"></a>01541    J=0;
<a name="l01542"></a>01542    gVmin=1e32; gemax=-1e32; gqmin=1e32;
<a name="l01543"></a>01543    <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++)
<a name="l01544"></a>01544    {
<a name="l01545"></a>01545      <span class="keywordflow">if</span>(mcells[i]&gt;=0)
<a name="l01546"></a>01546      {
<a name="l01547"></a>01547         nvert=0;
<a name="l01548"></a>01548         <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0)
<a name="l01549"></a>01549           nvert++;
<a name="l01550"></a>01550         lemax=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(n, W, F, Rpr, cells[i], mask, epsilon, w, nvert, H[i], me, vol, 1, &amp;lVmin, &amp;lqmin, adp, afun, G[i], sout);
<a name="l01551"></a>01551         J+=lemax;
<a name="l01552"></a>01552         <span class="keywordflow">if</span>(gVmin&gt;lVmin)
<a name="l01553"></a>01553           gVmin=lVmin;
<a name="l01554"></a>01554         <span class="keywordflow">if</span>(gemax&lt;lemax)
<a name="l01555"></a>01555           gemax=lemax;
<a name="l01556"></a>01556         <span class="keywordflow">if</span>(gqmin&gt;lqmin)
<a name="l01557"></a>01557           gqmin=lqmin;
<a name="l01558"></a>01558 
<a name="l01559"></a>01559         <span class="comment">//------HN correction--------</span>
<a name="l01560"></a>01560         <span class="keywordflow">for</span>(ii=0;ii&lt;nedges;ii++)
<a name="l01561"></a>01561         {
<a name="l01562"></a>01562             ind_i=hnodes[ii];
<a name="l01563"></a>01563             ind_j=edges[2*ii];
<a name="l01564"></a>01564             ind_k=edges[2*ii+1];
<a name="l01565"></a>01565             <span class="keywordflow">for</span>(jj=0;jj&lt;n;jj++)
<a name="l01566"></a>01566             {
<a name="l01567"></a>01567                 g_i=Rpr[ind_i][jj]-0.5*(Rpr[ind_j][jj]+Rpr[ind_k][jj]);
<a name="l01568"></a>01568                 J+=g_i*g_i/(2*Tau_hn);
<a name="l01569"></a>01569             }
<a name="l01570"></a>01570          }
<a name="l01571"></a>01571       }
<a name="l01572"></a>01572    }
<a name="l01573"></a>01573    <span class="keywordflow">if</span>(msglev&gt;=3)
<a name="l01574"></a>01574      fprintf(sout, <span class="stringliteral">&quot;tau=%f J=%f \n&quot;</span>,tau,J);
<a name="l01575"></a>01575 }
<a name="l01576"></a>01576 
<a name="l01577"></a>01577 <span class="keywordflow">if</span>(j==-30)
<a name="l01578"></a>01578   T=0;
<a name="l01579"></a>01579 <span class="keywordflow">else</span>
<a name="l01580"></a>01580 {
<a name="l01581"></a>01581   Jpr=J;
<a name="l01582"></a>01582   <span class="keywordflow">for</span>(i=0;i&lt;N;i++)
<a name="l01583"></a>01583   {
<a name="l01584"></a>01584     <span class="keywordflow">for</span>(k=0;k&lt;n;k++)
<a name="l01585"></a>01585       Rpr[i][k]=R[i][k]+tau*0.5*P[i][k];
<a name="l01586"></a>01586   }
<a name="l01587"></a>01587   J=0; gtmin0=1e32; gtmax0=-1e32; gqmin0=1e32;
<a name="l01588"></a>01588   <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++)
<a name="l01589"></a>01589   {
<a name="l01590"></a>01590     <span class="keywordflow">if</span>(mcells[i]&gt;=0)
<a name="l01591"></a>01591     {
<a name="l01592"></a>01592       nvert=0; <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0) nvert++;
<a name="l01593"></a>01593       lemax=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(n, W, F, Rpr, cells[i], mask, epsilon, w, nvert, H[i], me, vol, 1, &amp;lVmin, &amp;lqmin, adp, afun, G[i], sout);
<a name="l01594"></a>01594       J+=lemax;
<a name="l01595"></a>01595       <span class="keywordflow">if</span>(gtmin0&gt;lVmin)
<a name="l01596"></a>01596         gtmin0=lVmin;
<a name="l01597"></a>01597       <span class="keywordflow">if</span>(gtmax0&lt;lemax)
<a name="l01598"></a>01598         gtmax0=lemax;
<a name="l01599"></a>01599       <span class="keywordflow">if</span>(gqmin0&gt;lqmin)
<a name="l01600"></a>01600         gqmin0=lqmin;
<a name="l01601"></a>01601       <span class="comment">//-------HN correction--------</span>
<a name="l01602"></a>01602        <span class="keywordflow">for</span>(ii=0;ii&lt;nedges;ii++){
<a name="l01603"></a>01603            ind_i=hnodes[ii]; ind_j=edges[2*ii]; ind_k=edges[2*ii+1];
<a name="l01604"></a>01604            <span class="keywordflow">for</span>(jj=0;jj&lt;n;jj++){
<a name="l01605"></a>01605                g_i=Rpr[ind_i][jj]-0.5*(Rpr[ind_j][jj]+Rpr[ind_k][jj]);
<a name="l01606"></a>01606                J+=g_i*g_i/(2*Tau_hn);
<a name="l01607"></a>01607            }
<a name="l01608"></a>01608        }<span class="comment">//HN</span>
<a name="l01609"></a>01609    }
<a name="l01610"></a>01610   }
<a name="l01611"></a>01611 }
<a name="l01612"></a>01612  <span class="keywordflow">if</span>(Jpr&gt;J) {
<a name="l01613"></a>01613     T=0.5*tau;
<a name="l01614"></a>01614     (*Vmin)=gtmin0;
<a name="l01615"></a>01615     (*emax)=gtmax0;
<a name="l01616"></a>01616     (*qmin)=gqmin0;
<a name="l01617"></a>01617  } <span class="keywordflow">else</span> {
<a name="l01618"></a>01618     T=tau; J=Jpr;
<a name="l01619"></a>01619     (*Vmin)=gVmin;
<a name="l01620"></a>01620     (*emax)=gemax;
<a name="l01621"></a>01621     (*qmin)=gqmin;
<a name="l01622"></a>01622  }
<a name="l01623"></a>01623 
<a name="l01624"></a>01624  nonzero=0;
<a name="l01625"></a>01625 <span class="keywordflow">for</span>(j=0;j&lt;N;j++) <span class="keywordflow">for</span>(k=0;k&lt;n;k++){
<a name="l01626"></a>01626      R[j][k]=R[j][k]+T*P[j][k];
<a name="l01627"></a>01627      nonzero+=T*P[j][k]*T*P[j][k];
<a name="l01628"></a>01628 }
<a name="l01629"></a>01629 
<a name="l01630"></a>01630 <span class="keywordflow">if</span>(msglev&gt;=2)
<a name="l01631"></a>01631   fprintf(sout, <span class="stringliteral">&quot;tau=%e, J=%e  \n&quot;</span>,T,J);
<a name="l01632"></a>01632 
<a name="l01633"></a>01633 free(b);
<a name="l01634"></a>01634 free(u);
<a name="l01635"></a>01635 free(ia);
<a name="l01636"></a>01636 free(ja);
<a name="l01637"></a>01637 free(a);
<a name="l01638"></a>01638 <span class="keywordflow">for</span>(i=0;i&lt;n;i++){
<a name="l01639"></a>01639    <span class="keywordflow">for</span>(j=0;j&lt;3*n+n%2;j++) free(W[i][j]);
<a name="l01640"></a>01640    free(W[i]);
<a name="l01641"></a>01641    free(F[i]);}
<a name="l01642"></a>01642 free(W);
<a name="l01643"></a>01643 free(F);
<a name="l01644"></a>01644 <span class="keywordflow">for</span>(i=0;i&lt;N;i++) {free(Rpr[i]);
<a name="l01645"></a>01645     free(P[i]);}
<a name="l01646"></a>01646 free(Rpr);
<a name="l01647"></a>01647 free(P);
<a name="l01648"></a>01648 <span class="keywordflow">for</span>(i=0;i&lt;n*N;i++) {
<a name="l01649"></a>01649     free(A[i]);
<a name="l01650"></a>01650     free(JA[i]);}
<a name="l01651"></a>01651 free(A);
<a name="l01652"></a>01652 free(JA);
<a name="l01653"></a>01653 <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) free(G[i]);
<a name="l01654"></a>01654 free(G);
<a name="l01655"></a>01655 
<a name="l01656"></a>01656 <span class="keywordflow">return</span> (sqrt(nonzero));
<a name="l01657"></a>01657 
<a name="l01658"></a>01658 }
<a name="l01659"></a>01659 
<a name="l01665"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a23a2e24c743ad61769e2b263fb2ca3fb">01665</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a23a2e24c743ad61769e2b263fb2ca3fb">VariationalMeshSmoother::minJ_BC</a>(<span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l01666"></a>01666                <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> msglev,
<a name="l01667"></a>01667                    <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <span class="keywordtype">int</span> NCN, FILE *sout)
<a name="l01668"></a>01668 {
<a name="l01669"></a>01669 <span class="comment">/*---new form of matrices, 5 iterations for minL---*/</span>
<a name="l01670"></a>01670 <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> W;
<a name="l01671"></a>01671 <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>  F, G;
<a name="l01672"></a>01672 <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> b, hm, Plam, constr, lam;
<a name="l01673"></a>01673 <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> Bind;
<a name="l01674"></a>01674 <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Rpr, P;
<a name="l01675"></a>01675 <span class="keywordtype">double</span>  tau=0.0, J=0.0, T, Jpr, L, lVmin, lqmin, gVmin=0.0, gqmin=0.0, gVmin0=0.0,
<a name="l01676"></a>01676 gqmin0=0.0, lemax, gemax=0.0, gemax0=0.0;
<a name="l01677"></a>01677 <span class="keywordtype">double</span> a, g, qq=0.0, eps, nonzero, x0, y0, del1, del2, Bx, By;
<a name="l01678"></a>01678 <span class="keywordtype">int</span> index, i, j, k=0, l, nz, I;
<a name="l01679"></a>01679 <span class="keywordtype">int</span> ind, nvert;
<a name="l01680"></a>01680 
<a name="l01681"></a>01681 <span class="comment">//----memory------</span>
<a name="l01682"></a>01682 Bind=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(NCN); <span class="comment">//array of sliding BN</span>
<a name="l01683"></a>01683 lam=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(NCN);
<a name="l01684"></a>01684 hm=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(2*N);
<a name="l01685"></a>01685 Plam=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(NCN);
<a name="l01686"></a>01686 constr=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(4*NCN); <span class="comment">//holds constraints = local approximation to the boundary</span>
<a name="l01687"></a>01687 F = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(2, 6);
<a name="l01688"></a>01688 W=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">alloc_d_n1_n2_n3</a>(2, 6, 6);
<a name="l01689"></a>01689 <span class="keywordflow">for</span>(i=0;i&lt;2;i++){
<a name="l01690"></a>01690    F[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(6);
<a name="l01691"></a>01691    W[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(6,6);
<a name="l01692"></a>01692    <span class="keywordflow">for</span>(j=0;j&lt;6;j++) W[i][j]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(6);}
<a name="l01693"></a>01693 Rpr=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(N,2);
<a name="l01694"></a>01694 P=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(N,2);
<a name="l01695"></a>01695 <span class="keywordflow">for</span>(i=0;i&lt;N;i++) {Rpr[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(2);
<a name="l01696"></a>01696  P[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(2);}
<a name="l01697"></a>01697 b = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(2*N);
<a name="l01698"></a>01698 G=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(ncells,6);
<a name="l01699"></a>01699 <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) G[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(6);
<a name="l01700"></a>01700 
<a name="l01701"></a>01701 <span class="comment">//-----assembler of constraints-----</span>
<a name="l01702"></a>01702   eps=sqrt(vol)*1e-9;
<a name="l01703"></a>01703   <span class="keywordflow">for</span>(i=0;i&lt;4*NCN;i++) constr[i]=1.0/eps;
<a name="l01704"></a>01704   I=0; <span class="keywordflow">for</span>(i=0;i&lt;N;i++) <span class="keywordflow">if</span>(mask[i]==2) {Bind[I]=i; I++;}
<a name="l01705"></a>01705   <span class="keywordflow">for</span>(I=0;I&lt;NCN;I++){ i=Bind[I];
<a name="l01706"></a>01706       ind=0;
<a name="l01707"></a>01707       <span class="comment">//---boundary connectivity----</span>
<a name="l01708"></a>01708       <span class="keywordflow">for</span>(l=0;l&lt;ncells;l++){
<a name="l01709"></a>01709           nvert=0; <span class="keywordflow">while</span>(cells[l][nvert]&gt;=0) nvert++;
<a name="l01710"></a>01710                   <span class="keywordflow">switch</span>(nvert)
<a name="l01711"></a>01711                   {<span class="keywordflow">case</span> 3: <span class="comment">//tri</span>
<a name="l01712"></a>01712                   <span class="keywordflow">if</span>(i==cells[l][0]){
<a name="l01713"></a>01713                           <span class="keywordflow">if</span>(mask[cells[l][1]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][1]; ind++;} <span class="keywordflow">else</span> {k=cells[l][1]; ind++;}}
<a name="l01714"></a>01714                           <span class="keywordflow">if</span>(mask[cells[l][2]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][2]; ind++;} <span class="keywordflow">else</span> {k=cells[l][2]; ind++;}}
<a name="l01715"></a>01715                   }
<a name="l01716"></a>01716                   <span class="keywordflow">if</span>(i==cells[l][1]){
<a name="l01717"></a>01717                           <span class="keywordflow">if</span>(mask[cells[l][0]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][0]; ind++;} <span class="keywordflow">else</span> {k=cells[l][0]; ind++;}}
<a name="l01718"></a>01718                           <span class="keywordflow">if</span>(mask[cells[l][2]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][2]; ind++;} <span class="keywordflow">else</span> {k=cells[l][2]; ind++;}}
<a name="l01719"></a>01719                   }
<a name="l01720"></a>01720                   <span class="keywordflow">if</span>(i==cells[l][2]){
<a name="l01721"></a>01721                           <span class="keywordflow">if</span>(mask[cells[l][1]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][1]; ind++;} <span class="keywordflow">else</span> {k=cells[l][1]; ind++;}}
<a name="l01722"></a>01722                           <span class="keywordflow">if</span>(mask[cells[l][0]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][0]; ind++;} <span class="keywordflow">else</span> {k=cells[l][0]; ind++;}}
<a name="l01723"></a>01723                   }
<a name="l01724"></a>01724                   <span class="keywordflow">break</span>;
<a name="l01725"></a>01725                   <span class="keywordflow">case</span> 4: <span class="comment">//quad</span>
<a name="l01726"></a>01726                   <span class="keywordflow">if</span>((i==cells[l][0])||(i==cells[l][3])){
<a name="l01727"></a>01727                           <span class="keywordflow">if</span>(mask[cells[l][1]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][1]; ind++;} <span class="keywordflow">else</span> {k=cells[l][1]; ind++;}}
<a name="l01728"></a>01728                           <span class="keywordflow">if</span>(mask[cells[l][2]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][2]; ind++;} <span class="keywordflow">else</span> {k=cells[l][2]; ind++;}}
<a name="l01729"></a>01729                   }
<a name="l01730"></a>01730                   <span class="keywordflow">if</span>((i==cells[l][1])||(i==cells[l][2])){
<a name="l01731"></a>01731                           <span class="keywordflow">if</span>(mask[cells[l][0]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][0]; ind++;} <span class="keywordflow">else</span> {k=cells[l][0]; ind++;}}
<a name="l01732"></a>01732                           <span class="keywordflow">if</span>(mask[cells[l][3]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][3]; ind++;} <span class="keywordflow">else</span> {k=cells[l][3]; ind++;}}
<a name="l01733"></a>01733                   }
<a name="l01734"></a>01734                   <span class="keywordflow">break</span>;
<a name="l01735"></a>01735                   <span class="keywordflow">case</span> 6: <span class="comment">//quad tri</span>
<a name="l01736"></a>01736                   <span class="keywordflow">if</span>(i==cells[l][0]){
<a name="l01737"></a>01737                           <span class="keywordflow">if</span>(mask[cells[l][1]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][5]; ind++;} <span class="keywordflow">else</span> {k=cells[l][5]; ind++;}}
<a name="l01738"></a>01738                           <span class="keywordflow">if</span>(mask[cells[l][2]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][4]; ind++;} <span class="keywordflow">else</span> {k=cells[l][4]; ind++;}}
<a name="l01739"></a>01739                   }
<a name="l01740"></a>01740                   <span class="keywordflow">if</span>(i==cells[l][1]){
<a name="l01741"></a>01741                           <span class="keywordflow">if</span>(mask[cells[l][0]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][5]; ind++;} <span class="keywordflow">else</span> {k=cells[l][5]; ind++;}}
<a name="l01742"></a>01742                           <span class="keywordflow">if</span>(mask[cells[l][2]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][3]; ind++;} <span class="keywordflow">else</span> {k=cells[l][3]; ind++;}}
<a name="l01743"></a>01743                   }
<a name="l01744"></a>01744                   <span class="keywordflow">if</span>(i==cells[l][2]){
<a name="l01745"></a>01745                           <span class="keywordflow">if</span>(mask[cells[l][1]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][3]; ind++;} <span class="keywordflow">else</span> {k=cells[l][3]; ind++;}}
<a name="l01746"></a>01746                           <span class="keywordflow">if</span>(mask[cells[l][0]]&gt;0) {<span class="keywordflow">if</span>(ind==0) {j=cells[l][4]; ind++;} <span class="keywordflow">else</span> {k=cells[l][4]; ind++;}}
<a name="l01747"></a>01747                   }
<a name="l01748"></a>01748                   <span class="keywordflow">if</span>(i==cells[l][3]){j=cells[l][1]; k=cells[l][2];}
<a name="l01749"></a>01749           <span class="keywordflow">if</span>(i==cells[l][4]){j=cells[l][2]; k=cells[l][0];}
<a name="l01750"></a>01750           <span class="keywordflow">if</span>(i==cells[l][5]){j=cells[l][0]; k=cells[l][1];}
<a name="l01751"></a>01751                   <span class="keywordflow">break</span>;}
<a name="l01752"></a>01752           }<span class="comment">//end boundary connectivity</span>
<a name="l01753"></a>01753       <span class="comment">//lines</span>
<a name="l01754"></a>01754       del1=R[j][0]-R[i][0]; del2=R[i][0]-R[k][0];
<a name="l01755"></a>01755       <span class="keywordflow">if</span>((fabs(del1)&lt;eps)&amp;&amp;(fabs(del2)&lt;eps)) {constr[I*4]=1; constr[I*4+1]=0;
<a name="l01756"></a>01756           constr[I*4+2]=R[i][0]; constr[I*4+3]=R[i][1];} <span class="keywordflow">else</span> {
<a name="l01757"></a>01757           del1=R[j][1]-R[i][1]; del2=R[i][1]-R[k][1];
<a name="l01758"></a>01758           <span class="keywordflow">if</span>((fabs(del1)&lt;eps)&amp;&amp;(fabs(del2)&lt;eps)) {constr[I*4]=0; constr[I*4+1]=1;
<a name="l01759"></a>01759               constr[I*4+2]=R[i][0]; constr[I*4+3]=R[i][1];
<a name="l01760"></a>01760               } <span class="keywordflow">else</span> {
<a name="l01761"></a>01761                   J=(R[i][0]-R[j][0])*(R[k][1]-R[j][1])-(R[k][0]-R[j][0])*(R[i][1]-R[j][1]);
<a name="l01762"></a>01762                   <span class="keywordflow">if</span>(fabs(J)&lt;eps) {
<a name="l01763"></a>01763                       constr[I*4]=1.0/(R[k][0]-R[j][0]); constr[I*4+1]=-1.0/(R[k][1]-R[j][1]);
<a name="l01764"></a>01764                       constr[I*4+2]=R[i][0]; constr[I*4+3]=R[i][1];
<a name="l01765"></a>01765 } <span class="keywordflow">else</span> <span class="comment">//circle</span>
<a name="l01766"></a>01766 {
<a name="l01767"></a>01767                       x0=((R[k][1]-R[j][1])*(R[i][0]*R[i][0]-R[j][0]*R[j][0]+R[i][1]*R[i][1]-R[j][1]*R[j][1])+
<a name="l01768"></a>01768                           (R[j][1]-R[i][1])*(R[k][0]*R[k][0]-R[j][0]*R[j][0]+R[k][1]*R[k][1]-R[j][1]*R[j][1]))/(2*J);
<a name="l01769"></a>01769                       y0=((R[j][0]-R[k][0])*(R[i][0]*R[i][0]-R[j][0]*R[j][0]+R[i][1]*R[i][1]-R[j][1]*R[j][1])+
<a name="l01770"></a>01770                           (R[i][0]-R[j][0])*(R[k][0]*R[k][0]-R[j][0]*R[j][0]+R[k][1]*R[k][1]-R[j][1]*R[j][1]))/(2*J);
<a name="l01771"></a>01771                       constr[I*4]=x0; constr[I*4+1]=y0;
<a name="l01772"></a>01772                       constr[I*4+2]=(R[i][0]-x0)*(R[i][0]-x0)+(R[i][1]-y0)*(R[i][1]-y0);
<a name="l01773"></a>01773                   }
<a name="l01774"></a>01774               }
<a name="l01775"></a>01775       }
<a name="l01776"></a>01776   }
<a name="l01777"></a>01777 <span class="comment">/*for(i=0;i&lt;NCN;i++){</span>
<a name="l01778"></a>01778 <span class="comment">    for(j=0;j&lt;4;j++) fprintf(stdout,&quot; %e &quot;,constr[4*i+j]);</span>
<a name="l01779"></a>01779 <span class="comment">    fprintf(stdout, &quot;constr %d node %d \n&quot;,i,Bind[i]);</span>
<a name="l01780"></a>01780 <span class="comment">}*/</span>
<a name="l01781"></a>01781 
<a name="l01782"></a>01782 
<a name="l01783"></a>01783 
<a name="l01784"></a>01784 <span class="comment">//----initial values----</span>
<a name="l01785"></a>01785 <span class="keywordflow">for</span>(i=0;i&lt;NCN;i++) lam[i]=0;
<a name="l01786"></a>01786 <span class="keywordflow">for</span>(nz=0;nz&lt;5;nz++){
<a name="l01787"></a>01787   <span class="comment">//---------find H and -grad J-----------------</span>
<a name="l01788"></a>01788    nonzero=0; Jpr=0;
<a name="l01789"></a>01789    <span class="keywordflow">for</span>(i=0; i&lt;2*N; i++){ b[i] = 0; hm[i]=0; }
<a name="l01790"></a>01790    <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++){
<a name="l01791"></a>01791         nvert=0; <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0) nvert++;
<a name="l01792"></a>01792         <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++){ G[i][j]=0;
<a name="l01793"></a>01793         <span class="keywordflow">if</span>(adp&lt;0) <span class="keywordflow">for</span>(k=0;k&lt;abs(adp);k++) G[i][j]=G[i][j]+afun[i*(-adp)+k]; }
<a name="l01794"></a>01794         <span class="keywordflow">for</span>(index=0;index&lt;2;index++){
<a name="l01795"></a>01795             <span class="keywordflow">for</span>(k=0;k&lt;nvert;k++){ F[index][k]=0;
<a name="l01796"></a>01796                 <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++) W[index][k][j]=0;
<a name="l01797"></a>01797             }
<a name="l01798"></a>01798         }
<a name="l01799"></a>01799         <span class="keywordflow">if</span>(mcells[i]&gt;=0){
<a name="l01800"></a>01800                      Jpr+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(2, W, F, R, cells[i], mask, epsilon, w, nvert, H[i],
<a name="l01801"></a>01801                          me, vol, 0, &amp;lVmin, &amp;lqmin, adp, afun, G[i], sout);
<a name="l01802"></a>01802         } <span class="keywordflow">else</span> {
<a name="l01803"></a>01803             <span class="keywordflow">for</span>(index=0;index&lt;2;index++) <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++) W[index][j][j]=1;
<a name="l01804"></a>01804         }
<a name="l01805"></a>01805         <span class="keywordflow">for</span>(index=0;index&lt;2;index++){
<a name="l01806"></a>01806             <span class="keywordflow">for</span>(l=0; l&lt;nvert; l++){<span class="comment">//-diagonal Hessian-</span>
<a name="l01807"></a>01807                 hm[cells[i][l]+index*N]=hm[cells[i][l]+index*N]+W[index][l][l];
<a name="l01808"></a>01808                 b[cells[i][l]+index*N]=b[cells[i][l]+index*N]-F[index][l];
<a name="l01809"></a>01809             }
<a name="l01810"></a>01810         }
<a name="l01811"></a>01811     }
<a name="l01812"></a>01812     <span class="comment">//------||grad J||_2------</span>
<a name="l01813"></a>01813     <span class="keywordflow">for</span>(i=0;i&lt;2*N;i++){ nonzero=nonzero+b[i]*b[i];}
<a name="l01814"></a>01814     <span class="comment">//-----solve for Plam--------</span>
<a name="l01815"></a>01815     <span class="keywordflow">for</span>(I=0;I&lt;NCN;I++){i=Bind[I];
<a name="l01816"></a>01816        <span class="keywordflow">if</span>(constr[4*I+3]&lt;0.5/eps) {Bx=constr[4*I]; By=constr[4*I+1];
<a name="l01817"></a>01817            g=(R[i][0]-constr[4*I+2])*constr[4*I]+(R[i][1]-constr[4*I+3])*constr[4*I+1];
<a name="l01818"></a>01818        } <span class="keywordflow">else</span> {
<a name="l01819"></a>01819           Bx=2*(R[i][0]-constr[4*I]); By=2*(R[i][1]-constr[4*I+1]);
<a name="l01820"></a>01820               hm[i]+=2*lam[I]; hm[i+N]+=2*lam[I];
<a name="l01821"></a>01821               g=(R[i][0]-constr[4*I])*(R[i][0]-constr[4*I])+(R[i][1]-constr[4*I+1])*(R[i][1]-constr[4*I+1])-constr[4*I+2];
<a name="l01822"></a>01822        }
<a name="l01823"></a>01823        Jpr+=lam[I]*g;
<a name="l01824"></a>01824        qq=Bx*b[i]/hm[i]+By*b[i+N]/hm[i+N]-g;
<a name="l01825"></a>01825        a=Bx*Bx/hm[i]+By*By/hm[i+N];
<a name="l01826"></a>01826        <span class="keywordflow">if</span>(a!=0) Plam[I]=qq/a; <span class="keywordflow">else</span> fprintf(sout,<span class="stringliteral">&quot;error: B^TH-1B is degenerate \n&quot;</span>);
<a name="l01827"></a>01827        b[i]-=Plam[I]*Bx; b[i+N]-=Plam[I]*By;
<a name="l01828"></a>01828        Plam[I]-=lam[I];
<a name="l01829"></a>01829    }
<a name="l01830"></a>01830    <span class="comment">//-----------solve for P------------</span>
<a name="l01831"></a>01831    <span class="keywordflow">for</span>(i=0;i&lt;N;i++) {P[i][0]=b[i]/hm[i]; P[i][1]=b[i+N]/hm[i+N];}
<a name="l01832"></a>01832    <span class="comment">//-----correct solution-----</span>
<a name="l01833"></a>01833    <span class="keywordflow">for</span>(i=0;i&lt;N;i++) <span class="keywordflow">for</span>(j=0;j&lt;2;j++) <span class="keywordflow">if</span>((fabs(P[i][j])&lt;eps)||(mask[i]==1)) P[i][j]=0;
<a name="l01834"></a>01834    <span class="comment">//----P is determined--------</span>
<a name="l01835"></a>01835    <span class="keywordflow">if</span>(msglev&gt;=3){
<a name="l01836"></a>01836        <span class="keywordflow">for</span>(i=0;i&lt;N;i++){
<a name="l01837"></a>01837            <span class="keywordflow">for</span>(j=0;j&lt;2;j++)  <span class="keywordflow">if</span>(P[i][j]!=0) fprintf(sout, <span class="stringliteral">&quot;P[%d][%d]=%f  &quot;</span>,i,j,P[i][j]);
<a name="l01838"></a>01838        }
<a name="l01839"></a>01839    }
<a name="l01840"></a>01840    <span class="comment">//-------local minimization problem, determination of tau----------</span>
<a name="l01841"></a>01841    <span class="keywordflow">if</span>(msglev&gt;=3) fprintf(sout, <span class="stringliteral">&quot;dJ=%e L0=%e \n&quot;</span>,sqrt(nonzero), Jpr);
<a name="l01842"></a>01842    L=1e32; j=1;
<a name="l01843"></a>01843    <span class="keywordflow">while</span>((Jpr&lt;=L)&amp;&amp;(j&gt;-30)){
<a name="l01844"></a>01844       j=j-1;
<a name="l01845"></a>01845       tau=<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(2.0,j);
<a name="l01846"></a>01846       <span class="keywordflow">for</span>(i=0;i&lt;N;i++){
<a name="l01847"></a>01847           <span class="keywordflow">for</span>(k=0;k&lt;2;k++) Rpr[i][k]=R[i][k]+tau*P[i][k];}
<a name="l01848"></a>01848       J=0; gVmin=1e32; gemax=-1e32; gqmin=1e32;
<a name="l01849"></a>01849       <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++) if(mcells[i]&gt;=0){
<a name="l01850"></a>01850           nvert=0; <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0) nvert++;
<a name="l01851"></a>01851                   lemax=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(2, W, F, Rpr, cells[i], mask, epsilon, w, nvert, H[i], me, vol, 1, &amp;lVmin,
<a name="l01852"></a>01852                        &amp;lqmin, adp, afun, G[i], sout);
<a name="l01853"></a>01853               J+=lemax;
<a name="l01854"></a>01854           <span class="keywordflow">if</span>(gVmin&gt;lVmin) gVmin=lVmin;
<a name="l01855"></a>01855           <span class="keywordflow">if</span>(gemax&lt;lemax) gemax=lemax;
<a name="l01856"></a>01856           <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l01857"></a>01857           }
<a name="l01858"></a>01858       L=J;
<a name="l01859"></a>01859       <span class="comment">//----constraints contribution----</span>
<a name="l01860"></a>01860       <span class="keywordflow">for</span>(I=0;I&lt;NCN;I++){i=Bind[I];
<a name="l01861"></a>01861           <span class="keywordflow">if</span>(constr[4*I+3]&lt;0.5/eps) g=(Rpr[i][0]-constr[4*I+2])*constr[4*I]+(Rpr[i][1]-constr[4*I+3])*constr[4*I+1];
<a name="l01862"></a>01862               <span class="keywordflow">else</span> g=(Rpr[i][0]-constr[4*I])*(Rpr[i][0]-constr[4*I])+
<a name="l01863"></a>01863                    (Rpr[i][1]-constr[4*I+1])*(Rpr[i][1]-constr[4*I+1])-constr[4*I+2];
<a name="l01864"></a>01864           L+=(lam[I]+tau*Plam[I])*g;
<a name="l01865"></a>01865           }
<a name="l01866"></a>01866       <span class="comment">//----end of constraints----</span>
<a name="l01867"></a>01867       <span class="keywordflow">if</span>(msglev&gt;=3) fprintf(sout,<span class="stringliteral">&quot; tau=%f J=%f \n&quot;</span>,tau,J);
<a name="l01868"></a>01868    }
<a name="l01869"></a>01869    <span class="keywordflow">if</span>(j==-30) T=0; <span class="keywordflow">else</span> {
<a name="l01870"></a>01870       Jpr=L; qq=J;
<a name="l01871"></a>01871       <span class="keywordflow">for</span>(i=0;i&lt;N;i++){
<a name="l01872"></a>01872           <span class="keywordflow">for</span>(k=0;k&lt;2;k++) Rpr[i][k]=R[i][k]+tau*0.5*P[i][k];}
<a name="l01873"></a>01873       J=0; gVmin0=1e32; gemax0=-1e32; gqmin0=1e32;
<a name="l01874"></a>01874       <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++) if(mcells[i]&gt;=0){
<a name="l01875"></a>01875           nvert=0; <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0) nvert++;
<a name="l01876"></a>01876                   lemax=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(2, W, F, Rpr, cells[i], mask, epsilon, w, nvert, H[i], me, vol, 1, &amp;lVmin,
<a name="l01877"></a>01877                        &amp;lqmin, adp, afun, G[i], sout);
<a name="l01878"></a>01878                   J+=lemax;
<a name="l01879"></a>01879               <span class="keywordflow">if</span>(gVmin0&gt;lVmin) gVmin0=lVmin;
<a name="l01880"></a>01880           <span class="keywordflow">if</span>(gemax0&lt;lemax) gemax0=lemax;
<a name="l01881"></a>01881           <span class="keywordflow">if</span>(gqmin0&gt;lqmin) gqmin0=lqmin;
<a name="l01882"></a>01882           }
<a name="l01883"></a>01883       L=J;
<a name="l01884"></a>01884       <span class="comment">//----constraints contribution----</span>
<a name="l01885"></a>01885       <span class="keywordflow">for</span>(I=0;I&lt;NCN;I++){i=Bind[I];
<a name="l01886"></a>01886           <span class="keywordflow">if</span>(constr[4*I+3]&lt;0.5/eps) g=(Rpr[i][0]-constr[4*I+2])*constr[4*I]+(Rpr[i][1]-constr[4*I+3])*constr[4*I+1];
<a name="l01887"></a>01887               <span class="keywordflow">else</span> g=(Rpr[i][0]-constr[4*I])*(Rpr[i][0]-constr[4*I])+
<a name="l01888"></a>01888                      (Rpr[i][1]-constr[4*I+1])*(Rpr[i][1]-constr[4*I+1])-constr[4*I+2];
<a name="l01889"></a>01889           L+=(lam[I]+tau*0.5*Plam[I])*g;
<a name="l01890"></a>01890           }
<a name="l01891"></a>01891       <span class="comment">//----end of constraints----</span>
<a name="l01892"></a>01892    }
<a name="l01893"></a>01893    <span class="keywordflow">if</span>(Jpr&gt;L) {
<a name="l01894"></a>01894       T=0.5*tau;
<a name="l01895"></a>01895       (*Vmin)=gVmin0;
<a name="l01896"></a>01896       (*emax)=gemax0;
<a name="l01897"></a>01897       (*qmin)=gqmin0;
<a name="l01898"></a>01898    } <span class="keywordflow">else</span> {
<a name="l01899"></a>01899       T=tau; L=Jpr; J=qq;
<a name="l01900"></a>01900       (*Vmin)=gVmin;
<a name="l01901"></a>01901       (*emax)=gemax;
<a name="l01902"></a>01902       (*qmin)=gqmin;
<a name="l01903"></a>01903    }
<a name="l01904"></a>01904 
<a name="l01905"></a>01905    <span class="keywordflow">for</span>(j=0;j&lt;N;j++) <span class="keywordflow">for</span>(k=0;k&lt;2;k++) R[j][k]+=T*P[j][k];
<a name="l01906"></a>01906    <span class="keywordflow">for</span>(i=0;i&lt;NCN;i++) lam[i]+=T*Plam[i];
<a name="l01907"></a>01907 
<a name="l01908"></a>01908 }<span class="comment">//end Lagrangian iter</span>
<a name="l01909"></a>01909 
<a name="l01910"></a>01910  <span class="keywordflow">if</span>(msglev&gt;=2) fprintf(sout, <span class="stringliteral">&quot;tau=%e, J=%e, L=%e  \n&quot;</span>,T,J,L);
<a name="l01911"></a>01911 
<a name="l01912"></a>01912 free(lam);
<a name="l01913"></a>01913 free(b);
<a name="l01914"></a>01914 <span class="keywordflow">for</span>(i=0;i&lt;2;i++){
<a name="l01915"></a>01915    <span class="keywordflow">for</span>(j=0;j&lt;6;j++) free(W[i][j]);
<a name="l01916"></a>01916    free(W[i]);
<a name="l01917"></a>01917    free(F[i]);}
<a name="l01918"></a>01918 free(W);
<a name="l01919"></a>01919 free(F);
<a name="l01920"></a>01920 <span class="keywordflow">for</span>(i=0;i&lt;N;i++) {free(Rpr[i]);
<a name="l01921"></a>01921     free(P[i]);}
<a name="l01922"></a>01922 free(Rpr);
<a name="l01923"></a>01923 free(P);
<a name="l01924"></a>01924 <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) free(G[i]);
<a name="l01925"></a>01925 free(G);
<a name="l01926"></a>01926 free(Bind);
<a name="l01927"></a>01927 free(constr);
<a name="l01928"></a>01928 free(hm);
<a name="l01929"></a>01929 free(Plam);
<a name="l01930"></a>01930 
<a name="l01931"></a>01931 <span class="keywordflow">return</span> (sqrt(nonzero));
<a name="l01932"></a>01932 
<a name="l01933"></a>01933 }
<a name="l01934"></a>01934 
<a name="l01938"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">01938</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">VariationalMeshSmoother::localP</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> W, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> F, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> cell, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">double</span> epsilon,
<a name="l01939"></a>01939               <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> nvert, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> f, <span class="keywordtype">double</span> *Vmin,
<a name="l01940"></a>01940               <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> Gloc, FILE *sout)
<a name="l01941"></a>01941 {
<a name="l01942"></a>01942 
<a name="l01943"></a>01943   <span class="keywordtype">int</span>  ii, jj, kk, i, j, k, l, m, nn;
<a name="l01944"></a>01944   <span class="keywordtype">double</span>  sigma=0.0, fun, lqmin, gqmin, g;
<a name="l01945"></a>01945   <span class="keywordtype">double</span> K[9];
<a name="l01946"></a>01946   <span class="comment">/*f - flag, f=0 for determination of Hessian and gradient of the functional,</span>
<a name="l01947"></a>01947 <span class="comment">    f=1 for determination of the functional value only;</span>
<a name="l01948"></a>01948 <span class="comment">    K - determines approximation rule for local integral over the cell*/</span>
<a name="l01949"></a>01949 
<a name="l01950"></a>01950 
<a name="l01951"></a>01951   <span class="comment">/*-------adaptivity, determined on the first step for adp&gt;0 (nodal based)------*/</span>
<a name="l01952"></a>01952   <span class="keywordflow">if</span>(f==0)
<a name="l01953"></a>01953   {
<a name="l01954"></a>01954     <span class="keywordflow">if</span>(adp&gt;0)
<a name="l01955"></a>01955       <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a69d9610a0107c0dcf21e2eb7b5f01af8">avertex</a>(n, afun, Gloc, R, cell, nvert, adp, sout);
<a name="l01956"></a>01956     <span class="keywordflow">if</span>(adp==0)
<a name="l01957"></a>01957     {
<a name="l01958"></a>01958       <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l01959"></a>01959         Gloc[i]=1.0;
<a name="l01960"></a>01960     }
<a name="l01961"></a>01961   }
<a name="l01962"></a>01962 
<a name="l01963"></a>01963 fun=0; gqmin=1e32; g=0;<span class="comment">//Vmin</span>
<a name="l01964"></a>01964 
<a name="l01965"></a>01965 <span class="comment">//cell integration depending on cell type</span>
<a name="l01966"></a>01966 <span class="keywordflow">if</span>(n==2){<span class="comment">//2D</span>
<a name="l01967"></a>01967         <span class="keywordflow">if</span>(nvert==3){<span class="comment">//tri</span>
<a name="l01968"></a>01968                 sigma=1.0;
<a name="l01969"></a>01969         fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me, vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l01970"></a>01970                 g+=sigma*lqmin;
<a name="l01971"></a>01971         <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l01972"></a>01972         }
<a name="l01973"></a>01973     <span class="keywordflow">if</span>(nvert==4){<span class="comment">//quad</span>
<a name="l01974"></a>01974         <span class="keywordflow">for</span>(i=0; i&lt;2; i++){ K[0]=i;
<a name="l01975"></a>01975             <span class="keywordflow">for</span>(j=0; j&lt;2; j++){ K[1]=j;
<a name="l01976"></a>01976                             sigma=0.25;
<a name="l01977"></a>01977                             fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me,
<a name="l01978"></a>01978                                 vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l01979"></a>01979                 g+=sigma*lqmin;
<a name="l01980"></a>01980                 <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l01981"></a>01981             }
<a name="l01982"></a>01982           }
<a name="l01983"></a>01983         } <span class="keywordflow">else</span> {<span class="comment">//quad tri</span>
<a name="l01984"></a>01984             <span class="keywordflow">for</span>(i=0; i&lt;3; i++){ K[0]=i*0.5; k=i/2; K[1]=(double)k;
<a name="l01985"></a>01985                <span class="keywordflow">for</span>(j=0; j&lt;3; j++){  K[2]=j*0.5; k=j/2; K[3]=(double)k;
<a name="l01986"></a>01986                                <span class="keywordflow">if</span>(i==j) sigma=1.0/12; <span class="keywordflow">else</span> sigma=1.0/24;
<a name="l01987"></a>01987                                fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me,
<a name="l01988"></a>01988                                    vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l01989"></a>01989                            g+=sigma*lqmin;
<a name="l01990"></a>01990                    <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l01991"></a>01991                            }
<a name="l01992"></a>01992                         }
<a name="l01993"></a>01993         }
<a name="l01994"></a>01994 }
<a name="l01995"></a>01995 <span class="keywordflow">if</span>(n==3){<span class="comment">//3D</span>
<a name="l01996"></a>01996        <span class="keywordflow">if</span>(nvert==4){<span class="comment">//tetr</span>
<a name="l01997"></a>01997                    sigma=1.0;
<a name="l01998"></a>01998                    fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me,
<a name="l01999"></a>01999                            vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l02000"></a>02000                    g+=sigma*lqmin;
<a name="l02001"></a>02001            <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l02002"></a>02002        }
<a name="l02003"></a>02003        <span class="keywordflow">if</span>(nvert==6){<span class="comment">//prism</span>
<a name="l02004"></a>02004           <span class="keywordflow">for</span>(i=0;i&lt;2;i++){ K[0]=i;
<a name="l02005"></a>02005               <span class="keywordflow">for</span>(j=0;j&lt;2;j++){ K[1]=j;
<a name="l02006"></a>02006                   <span class="keywordflow">for</span>(k=0;k&lt;3;k++) {K[2]=(double)k/2.0; K[3]=(double)(k%2);
<a name="l02007"></a>02007                                       sigma=1.0/12.0;
<a name="l02008"></a>02008                                       fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me,
<a name="l02009"></a>02009                                       vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l02010"></a>02010                               g+=sigma*lqmin;
<a name="l02011"></a>02011                       <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l02012"></a>02012                                   }
<a name="l02013"></a>02013                           }
<a name="l02014"></a>02014                   }
<a name="l02015"></a>02015            }
<a name="l02016"></a>02016        <span class="keywordflow">if</span>(nvert==8){<span class="comment">//hex</span>
<a name="l02017"></a>02017          <span class="keywordflow">for</span>(i=0; i&lt;2; i++){ K[0]=i;
<a name="l02018"></a>02018              <span class="keywordflow">for</span>(j=0; j&lt;2; j++){ K[1]=j;
<a name="l02019"></a>02019                  <span class="keywordflow">for</span>(k=0; k&lt;2; k++){ K[2]=k;
<a name="l02020"></a>02020                      <span class="keywordflow">for</span>(l=0; l&lt;2; l++){ K[3]=l;
<a name="l02021"></a>02021                          <span class="keywordflow">for</span>(m=0; m&lt;2; m++){ K[4]=m;
<a name="l02022"></a>02022                              <span class="keywordflow">for</span>(nn=0; nn&lt;2; nn++){ K[5]=nn;
<a name="l02023"></a>02023                                                             <span class="keywordflow">if</span>((i==nn)&amp;&amp;(j==l)&amp;&amp;(k==m)) sigma=(double)1/27;
<a name="l02024"></a>02024                                 <span class="keywordflow">if</span>(((i==nn)&amp;&amp;(j==l)&amp;&amp;(k!=m))||((i==nn)&amp;&amp;(j!=l)&amp;&amp;(k==m))||((i!=nn)&amp;&amp;(j==l)&amp;&amp;(k==m))) sigma=(<span class="keywordtype">double</span>)1/(27*2);
<a name="l02025"></a>02025                                 <span class="keywordflow">if</span>(((i==nn)&amp;&amp;(j!=l)&amp;&amp;(k!=m))||((i!=nn)&amp;&amp;(j!=l)&amp;&amp;(k==m))||((i!=nn)&amp;&amp;(j==l)&amp;&amp;(k!=m))) sigma=(double)1/(27*4);
<a name="l02026"></a>02026                                 <span class="keywordflow">if</span>((i!=nn)&amp;&amp;(j!=l)&amp;&amp;(k!=m)) sigma=(<span class="keywordtype">double</span>)1/(27*8);
<a name="l02027"></a>02027                                                             fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me,
<a name="l02028"></a>02028                                                 vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l02029"></a>02029                                         g+=sigma*lqmin;
<a name="l02030"></a>02030                                 <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l02031"></a>02031                                                          }
<a name="l02032"></a>02032                                                  }
<a name="l02033"></a>02033                                          }
<a name="l02034"></a>02034                                  }
<a name="l02035"></a>02035                          }
<a name="l02036"></a>02036                  }
<a name="l02037"></a>02037            } <span class="keywordflow">else</span> {<span class="comment">//quad tetr</span>
<a name="l02038"></a>02038           <span class="keywordflow">for</span>(i=0;i&lt;4;i++){
<a name="l02039"></a>02039             <span class="keywordflow">for</span>(j=0;j&lt;4;j++){
<a name="l02040"></a>02040                   <span class="keywordflow">for</span>(k=0;k&lt;4;k++){
<a name="l02041"></a>02041                     <span class="keywordflow">switch</span> (i)
<a name="l02042"></a>02042                     { <span class="keywordflow">case</span> 0 : K[0]=0; K[1]=0; K[2]=0; <span class="keywordflow">break</span>;
<a name="l02043"></a>02043                       <span class="keywordflow">case</span> 1 : K[0]=1; K[1]=0; K[2]=0; <span class="keywordflow">break</span>;
<a name="l02044"></a>02044                       <span class="keywordflow">case</span> 2 : K[0]=1.0/2; K[1]=1; K[2]=0; <span class="keywordflow">break</span>;
<a name="l02045"></a>02045                       <span class="keywordflow">case</span> 3 : K[0]=1.0/2; K[1]=1.0/3; K[2]=1; <span class="keywordflow">break</span>; }
<a name="l02046"></a>02046                     <span class="keywordflow">switch</span> (j)
<a name="l02047"></a>02047                     { <span class="keywordflow">case</span> 0 : K[3]=0; K[4]=0; K[5]=0; <span class="keywordflow">break</span>;
<a name="l02048"></a>02048                       <span class="keywordflow">case</span> 1 : K[3]=1; K[4]=0; K[5]=0; <span class="keywordflow">break</span>;
<a name="l02049"></a>02049                       <span class="keywordflow">case</span> 2 : K[3]=1.0/2; K[4]=1; K[5]=0; <span class="keywordflow">break</span>;
<a name="l02050"></a>02050                       <span class="keywordflow">case</span> 3 : K[3]=1.0/2; K[4]=1.0/3; K[5]=1; <span class="keywordflow">break</span>; }
<a name="l02051"></a>02051                     <span class="keywordflow">switch</span> (k)
<a name="l02052"></a>02052                     { <span class="keywordflow">case</span> 0 : K[6]=0; K[7]=0; K[8]=0; <span class="keywordflow">break</span>;
<a name="l02053"></a>02053                       <span class="keywordflow">case</span> 1 : K[6]=1; K[7]=0; K[8]=0; <span class="keywordflow">break</span>;
<a name="l02054"></a>02054                       <span class="keywordflow">case</span> 2 : K[6]=1.0/2; K[7]=1; K[8]=0; <span class="keywordflow">break</span>;
<a name="l02055"></a>02055                       <span class="keywordflow">case</span> 3 : K[6]=1.0/2; K[7]=1.0/3; K[8]=1; <span class="keywordflow">break</span>; }
<a name="l02056"></a>02056                            <span class="keywordflow">if</span>((i==j)&amp;&amp;(j==k)) sigma=1.0/120; <span class="keywordflow">else</span>
<a name="l02057"></a>02057                        <span class="keywordflow">if</span>((i==j)||(j==k)||(i==k)) sigma=1.0/360; <span class="keywordflow">else</span> sigma=1.0/720;
<a name="l02058"></a>02058                            fun+=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(n, W, F, R, cell, epsilon, w, nvert, K, H, me,
<a name="l02059"></a>02059                                vol, f, &amp;lqmin, adp, Gloc, sigma, sout);
<a name="l02060"></a>02060                        g+=sigma*lqmin;
<a name="l02061"></a>02061                <span class="keywordflow">if</span>(gqmin&gt;lqmin) gqmin=lqmin;
<a name="l02062"></a>02062                           }
<a name="l02063"></a>02063                         }
<a name="l02064"></a>02064                   }
<a name="l02065"></a>02065            }
<a name="l02066"></a>02066 }
<a name="l02067"></a>02067 
<a name="l02068"></a>02068 <span class="comment">/*---fixed nodes correction---*/</span>
<a name="l02069"></a>02069 <span class="keywordflow">for</span>(ii=0;ii&lt;nvert;ii++)
<a name="l02070"></a>02070 {
<a name="l02071"></a>02071     <span class="keywordflow">if</span>(mask[cell[ii]]==1)
<a name="l02072"></a>02072     {
<a name="l02073"></a>02073       <span class="keywordflow">for</span>(kk=0;kk&lt;n;kk++)
<a name="l02074"></a>02074       {
<a name="l02075"></a>02075         <span class="keywordflow">for</span>(jj=0;jj&lt;nvert;jj++)
<a name="l02076"></a>02076         {
<a name="l02077"></a>02077           W[kk][ii][jj]=0;
<a name="l02078"></a>02078           W[kk][jj][ii]=0;
<a name="l02079"></a>02079         }
<a name="l02080"></a>02080 
<a name="l02081"></a>02081         W[kk][ii][ii]=1;
<a name="l02082"></a>02082         F[kk][ii]=0;
<a name="l02083"></a>02083       }
<a name="l02084"></a>02084     }
<a name="l02085"></a>02085 }
<a name="l02086"></a>02086 <span class="comment">/*---end of fixed nodes correction---*/</span>
<a name="l02087"></a>02087 
<a name="l02088"></a>02088 (*Vmin)=g;
<a name="l02089"></a>02089 (*qmin)=gqmin/vol;
<a name="l02090"></a>02090 
<a name="l02091"></a>02091 <span class="keywordflow">return</span> fun;
<a name="l02092"></a>02092 }
<a name="l02093"></a>02093 
<a name="l02097"></a>02097 <span class="comment">// double VariationalMeshSmoother::avertex(int n, LPDOUBLE afun, LPDOUBLE G, LPLPDOUBLE R, LPINT cell, int nvert, int adp, FILE *sout)</span>
<a name="l02098"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a69d9610a0107c0dcf21e2eb7b5f01af8">02098</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a69d9610a0107c0dcf21e2eb7b5f01af8">VariationalMeshSmoother::avertex</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> G, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> cell, <span class="keywordtype">int</span> nvert, <span class="keywordtype">int</span> adp, FILE *)
<a name="l02099"></a>02099 {
<a name="l02100"></a>02100   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q;
<a name="l02101"></a>02101   <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> K;
<a name="l02102"></a>02102   <span class="keywordtype">double</span> a1[3], a2[3], a3[3], qu[3];
<a name="l02103"></a>02103   <span class="keywordtype">int</span> i,j;
<a name="l02104"></a>02104   <span class="keywordtype">double</span> det, g, df0, df1, df2;
<a name="l02105"></a>02105   K=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(8);
<a name="l02106"></a>02106   Q = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3, nvert);
<a name="l02107"></a>02107   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) Q[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(nvert);
<a name="l02108"></a>02108 
<a name="l02109"></a>02109   <span class="keywordflow">for</span>(i=0;i&lt;8;i++) K[i]=0.5; <span class="comment">//cell center</span>
<a name="l02110"></a>02110 
<a name="l02111"></a>02111   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(n,Q,nvert,K,Q,1);
<a name="l02112"></a>02112   <span class="keywordflow">for</span>(i=0;i&lt;n;i++){a1[i]=0; a2[i]=0; a3[i]=0; qu[i]=0;
<a name="l02113"></a>02113      <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++){
<a name="l02114"></a>02114         a1[i]+=Q[i][j]*R[cell[j]][0];
<a name="l02115"></a>02115         a2[i]+=Q[i][j]*R[cell[j]][1];
<a name="l02116"></a>02116                 <span class="keywordflow">if</span>(n==3) a3[i]+=Q[i][j]*R[cell[j]][2];
<a name="l02117"></a>02117                 qu[i]+=Q[i][j]*afun[cell[j]];
<a name="l02118"></a>02118      }
<a name="l02119"></a>02119   }
<a name="l02120"></a>02120   <span class="keywordflow">if</span>(n==2) det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]); <span class="keywordflow">else</span> det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02121"></a>02121   <span class="keywordflow">if</span>(det!=0){
<a name="l02122"></a>02122           <span class="keywordflow">if</span>(n==2){
<a name="l02123"></a>02123           df0=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(qu[0],qu[1],a2[0],a2[1])/det;
<a name="l02124"></a>02124           df1=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],qu[0],qu[1])/det;
<a name="l02125"></a>02125                   g=(1+df0*df0+df1*df1);
<a name="l02126"></a>02126                   <span class="keywordflow">if</span>(adp==2){<span class="comment">//directional adaptation G=diag(g_i)</span>
<a name="l02127"></a>02127                           G[0]=1+df0*df0; G[1]=1+df1*df1;
<a name="l02128"></a>02128                   } <span class="keywordflow">else</span> <span class="keywordflow">for</span>(i=0;i&lt;n;i++) G[i]=g; <span class="comment">//simple adaptation G=gI</span>
<a name="l02129"></a>02129           } <span class="keywordflow">else</span> {
<a name="l02130"></a>02130                   df0=(qu[0]*(a2[1]*a3[2]-a2[2]*a3[1])+qu[1]*(a2[2]*a3[0]-a2[0]*a3[2])+qu[2]*(a2[0]*a3[1]-a2[1]*a3[0]))/det;
<a name="l02131"></a>02131           df1=(qu[0]*(a3[1]*a1[2]-a3[2]*a1[1])+qu[1]*(a3[2]*a1[0]-a3[0]*a1[2])+qu[2]*(a3[0]*a1[1]-a3[1]*a1[0]))/det;
<a name="l02132"></a>02132           df2=(qu[0]*(a1[1]*a2[2]-a1[2]*a2[1])+qu[1]*(a1[2]*a2[0]-a1[0]*a2[2])+qu[2]*(a1[0]*a2[1]-a1[1]*a2[0]))/det;
<a name="l02133"></a>02133                   g=(1+df0*df0+df1*df1+df2*df2);
<a name="l02134"></a>02134           <span class="keywordflow">if</span>(adp==2){<span class="comment">//directional adaptation G=diag(g_i)</span>
<a name="l02135"></a>02135                           G[0]=1+df0*df0; G[1]=1+df1*df1; G[2]=1+df2*df2;
<a name="l02136"></a>02136                   } <span class="keywordflow">else</span> <span class="keywordflow">for</span>(i=0;i&lt;n;i++) G[i]=g; <span class="comment">//simple adaptation G=gI</span>
<a name="l02137"></a>02137           }
<a name="l02138"></a>02138   } <span class="keywordflow">else</span> {g=1.0; <span class="keywordflow">for</span>(i=0;i&lt;n;i++) G[i]=g;}
<a name="l02139"></a>02139 
<a name="l02140"></a>02140 
<a name="l02141"></a>02141  <span class="keywordflow">for</span>(i=0;i&lt;n;i++) free(Q[i]);
<a name="l02142"></a>02142  free(Q);
<a name="l02143"></a>02143 
<a name="l02144"></a>02144  <span class="keywordflow">return</span>(g);
<a name="l02145"></a>02145 
<a name="l02146"></a>02146 }
<a name="l02147"></a>02147 
<a name="l02151"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">02151</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">VariationalMeshSmoother::vertex</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> W, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> F, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> cell,
<a name="l02152"></a>02152               <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> nvert, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> K, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> H,
<a name="l02153"></a>02153                   <span class="keywordtype">int</span> me, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> f, <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> g, <span class="keywordtype">double</span> sigma, FILE *)
<a name="l02154"></a>02154 <span class="comment">//                int me, double vol, int f, double *qmin, int adp, LPDOUBLE g, double sigma, FILE *sout)</span>
<a name="l02155"></a>02155 {
<a name="l02156"></a>02156   <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> P = NULL, d2phi = NULL;
<a name="l02157"></a>02157   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>  gpr = NULL, dphi = NULL, dfe = NULL;
<a name="l02158"></a>02158   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q;
<a name="l02159"></a>02159   <span class="keywordtype">double</span> a1[3], a2[3], a3[3], av1[3], av2[3], av3[3];
<a name="l02160"></a>02160   <span class="keywordtype">int</span> i,j,k,i1;
<a name="l02161"></a>02161   <span class="keywordtype">double</span> tr=0.0, det=0.0, dchi, chi, fet, phit=0.0, G, con=100.0;
<a name="l02162"></a>02162   Q = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3, nvert);
<a name="l02163"></a>02163   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) Q[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(nvert);
<a name="l02164"></a>02164 <span class="keywordflow">if</span>(f==0){
<a name="l02165"></a>02165   gpr = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3, nvert);
<a name="l02166"></a>02166   dphi=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3,3);
<a name="l02167"></a>02167   dfe=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3,3);
<a name="l02168"></a>02168   <span class="keywordflow">for</span>(i=0;i&lt;n;i++){ gpr[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(nvert);
<a name="l02169"></a>02169       dphi[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3);
<a name="l02170"></a>02170       dfe[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3);}
<a name="l02171"></a>02171   P = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">alloc_d_n1_n2_n3</a>(3,3,3);
<a name="l02172"></a>02172   d2phi = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">alloc_d_n1_n2_n3</a>(3,3,3);
<a name="l02173"></a>02173   <span class="keywordflow">for</span>(i=0;i&lt;n;i++){ P[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3,3);
<a name="l02174"></a>02174      d2phi[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3,3);
<a name="l02175"></a>02175      <span class="keywordflow">for</span>(j=0;j&lt;n;j++){ P[i][j]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3);
<a name="l02176"></a>02176         d2phi[i][j]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3);}
<a name="l02177"></a>02177   }
<a name="l02178"></a>02178 }
<a name="l02179"></a>02179 
<a name="l02180"></a>02180   <span class="comment">/*--------hessian, function, gradient-----------------------*/</span>
<a name="l02181"></a>02181   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(n,Q,nvert,K,H,me);
<a name="l02182"></a>02182   <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l02183"></a>02183   {
<a name="l02184"></a>02184     a1[i]=0;
<a name="l02185"></a>02185     a2[i]=0;
<a name="l02186"></a>02186     a3[i]=0;
<a name="l02187"></a>02187     <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++)
<a name="l02188"></a>02188     {
<a name="l02189"></a>02189       a1[i]+=Q[i][j]*R[cell[j]][0];
<a name="l02190"></a>02190       a2[i]+=Q[i][j]*R[cell[j]][1];
<a name="l02191"></a>02191       <span class="keywordflow">if</span>(n==3)
<a name="l02192"></a>02192         a3[i]+=Q[i][j]*R[cell[j]][2];
<a name="l02193"></a>02193     }
<a name="l02194"></a>02194   }
<a name="l02195"></a>02195   <span class="comment">//account for adaptation</span>
<a name="l02196"></a>02196   <span class="keywordflow">if</span>(adp&lt;2)
<a name="l02197"></a>02197     G=g[0];
<a name="l02198"></a>02198   <span class="keywordflow">else</span>
<a name="l02199"></a>02199   {
<a name="l02200"></a>02200     G=1.0;
<a name="l02201"></a>02201     <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l02202"></a>02202     {
<a name="l02203"></a>02203       a1[i]*=sqrt(g[0]);
<a name="l02204"></a>02204       a2[i]*=sqrt(g[1]);
<a name="l02205"></a>02205       <span class="keywordflow">if</span>(n==3)
<a name="l02206"></a>02206         a3[i]*=sqrt(g[2]);
<a name="l02207"></a>02207     }
<a name="l02208"></a>02208   }
<a name="l02209"></a>02209 
<a name="l02210"></a>02210   <span class="keywordflow">if</span>(n==2)
<a name="l02211"></a>02211   {
<a name="l02212"></a>02212     av1[0]= a2[1];  av1[1]=-a2[0];
<a name="l02213"></a>02213     av2[0]=-a1[1];  av2[1]= a1[0];
<a name="l02214"></a>02214     det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l02215"></a>02215     tr=0;
<a name="l02216"></a>02216     <span class="keywordflow">for</span>(i=0;i&lt;2;i++) tr=tr+a1[i]*a1[i]/2+a2[i]*a2[i]/2;
<a name="l02217"></a>02217       phit=(1-w)*tr+w*(vol/G+det*det*G/vol)/(double)2;
<a name="l02218"></a>02218   }
<a name="l02219"></a>02219 
<a name="l02220"></a>02220   <span class="keywordflow">if</span>(n==3)
<a name="l02221"></a>02221   {
<a name="l02222"></a>02222       av1[0]= a2[1]*a3[2]-a2[2]*a3[1];  av1[1]=a2[2]*a3[0]-a2[0]*a3[2]; av1[2]=a2[0]*a3[1]-a2[1]*a3[0];
<a name="l02223"></a>02223       av2[0]= a3[1]*a1[2]-a3[2]*a1[1];  av2[1]=a3[2]*a1[0]-a3[0]*a1[2]; av2[2]=a3[0]*a1[1]-a3[1]*a1[0];
<a name="l02224"></a>02224       av3[0]= a1[1]*a2[2]-a1[2]*a2[1];  av3[1]=a1[2]*a2[0]-a1[0]*a2[2]; av3[2]=a1[0]*a2[1]-a1[1]*a2[0];
<a name="l02225"></a>02225           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02226"></a>02226       tr=0;
<a name="l02227"></a>02227       <span class="keywordflow">for</span>(i=0;i&lt;3;i++) tr=tr+a1[i]*a1[i]/3+a2[i]*a2[i]/3+a3[i]*a3[i]/3;
<a name="l02228"></a>02228       phit=(1-w)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(tr,1.5)+w*(vol/G+det*det*G/vol)/(<span class="keywordtype">double</span>)2;
<a name="l02229"></a>02229   }
<a name="l02230"></a>02230 
<a name="l02231"></a>02231   dchi=0.5+det*0.5/sqrt(epsilon*epsilon+det*det);
<a name="l02232"></a>02232   chi=0.5*(det+sqrt(epsilon*epsilon+det*det));
<a name="l02233"></a>02233   <span class="keywordflow">if</span>(chi!=0) fet=phit/chi; <span class="keywordflow">else</span> fet=1e32; <span class="comment">//function is computed</span>
<a name="l02234"></a>02234   (*qmin)=det*G;
<a name="l02235"></a>02235 
<a name="l02236"></a>02236   <span class="comment">//gradient and Hessian</span>
<a name="l02237"></a>02237   <span class="keywordflow">if</span>(f==0)
<a name="l02238"></a>02238   {
<a name="l02239"></a>02239     <span class="keywordflow">if</span>(n==2)
<a name="l02240"></a>02240     {
<a name="l02241"></a>02241       <span class="keywordflow">for</span>(i=0;i&lt;2;i++)
<a name="l02242"></a>02242       {
<a name="l02243"></a>02243         dphi[0][i]=(1-w)*a1[i]+w*G*det*av1[i]/vol;
<a name="l02244"></a>02244         dphi[1][i]=(1-w)*a2[i]+w*G*det*av2[i]/vol;
<a name="l02245"></a>02245       }
<a name="l02246"></a>02246 
<a name="l02247"></a>02247       <span class="keywordflow">for</span>(i=0;i&lt;2;i++)
<a name="l02248"></a>02248       {
<a name="l02249"></a>02249         <span class="keywordflow">for</span>(j=0;j&lt;2;j++)
<a name="l02250"></a>02250         {
<a name="l02251"></a>02251           d2phi[0][i][j]=w*G*av1[i]*av1[j]/vol;
<a name="l02252"></a>02252           d2phi[1][i][j]=w*G*av2[i]*av2[j]/vol;
<a name="l02253"></a>02253 
<a name="l02254"></a>02254           <span class="keywordflow">if</span>(i==j) <span class="keywordflow">for</span>(k=0;k&lt;2;k++)
<a name="l02255"></a>02255           {
<a name="l02256"></a>02256             d2phi[k][i][j]+=(1-w);
<a name="l02257"></a>02257           }
<a name="l02258"></a>02258         }
<a name="l02259"></a>02259       }
<a name="l02260"></a>02260 
<a name="l02261"></a>02261       <span class="keywordflow">for</span>(i=0;i&lt;2;i++)
<a name="l02262"></a>02262       {
<a name="l02263"></a>02263         dfe[0][i]=(dphi[0][i]-fet*dchi*av1[i])/chi;
<a name="l02264"></a>02264         dfe[1][i]=(dphi[1][i]-fet*dchi*av2[i])/chi;
<a name="l02265"></a>02265       }
<a name="l02266"></a>02266 
<a name="l02267"></a>02267       <span class="keywordflow">for</span>(i=0;i&lt;2;i++)
<a name="l02268"></a>02268       {
<a name="l02269"></a>02269         <span class="keywordflow">for</span>(j=0;j&lt;2;j++)
<a name="l02270"></a>02270         {
<a name="l02271"></a>02271           P[0][i][j]=(d2phi[0][i][j]-dchi*(av1[i]*dfe[0][j]+dfe[0][i]*av1[j]))/chi;
<a name="l02272"></a>02272           P[1][i][j]=(d2phi[1][i][j]-dchi*(av2[i]*dfe[1][j]+dfe[1][i]*av2[j]))/chi;
<a name="l02273"></a>02273         }
<a name="l02274"></a>02274       }
<a name="l02275"></a>02275     }
<a name="l02276"></a>02276 
<a name="l02277"></a>02277     <span class="keywordflow">if</span>(n==3)
<a name="l02278"></a>02278     {
<a name="l02279"></a>02279       <span class="keywordflow">for</span>(i=0;i&lt;3;i++)
<a name="l02280"></a>02280       {
<a name="l02281"></a>02281         dphi[0][i]=(1-w)*sqrt(tr)*a1[i]+w*G*det*av1[i]/vol;
<a name="l02282"></a>02282         dphi[1][i]=(1-w)*sqrt(tr)*a2[i]+w*G*det*av2[i]/vol;
<a name="l02283"></a>02283         dphi[2][i]=(1-w)*sqrt(tr)*a3[i]+w*G*det*av3[i]/vol;
<a name="l02284"></a>02284       }
<a name="l02285"></a>02285 
<a name="l02286"></a>02286       <span class="keywordflow">for</span>(i=0;i&lt;3;i++)
<a name="l02287"></a>02287       {
<a name="l02288"></a>02288         <span class="keywordflow">if</span>(tr!=0)
<a name="l02289"></a>02289         {
<a name="l02290"></a>02290           d2phi[0][i][i]=(1-w)/((<span class="keywordtype">double</span>)3*sqrt(tr))*a1[i]*a1[i]+w*G*av1[i]*av1[i]/vol;
<a name="l02291"></a>02291           d2phi[1][i][i]=(1-w)/((<span class="keywordtype">double</span>)3*sqrt(tr))*a2[i]*a2[i]+w*G*av2[i]*av2[i]/vol;
<a name="l02292"></a>02292           d2phi[2][i][i]=(1-w)/((<span class="keywordtype">double</span>)3*sqrt(tr))*a3[i]*a3[i]+w*G*av3[i]*av3[i]/vol;
<a name="l02293"></a>02293         }
<a name="l02294"></a>02294         <span class="keywordflow">else</span>
<a name="l02295"></a>02295         {
<a name="l02296"></a>02296           <span class="keywordflow">for</span>(k=0;k&lt;3;k++)
<a name="l02297"></a>02297             d2phi[k][i][i]=0;
<a name="l02298"></a>02298         }
<a name="l02299"></a>02299 
<a name="l02300"></a>02300         <span class="keywordflow">for</span>(k=0;k&lt;3;k++)
<a name="l02301"></a>02301           d2phi[k][i][i]+=(1-w)*sqrt(tr);
<a name="l02302"></a>02302       }
<a name="l02303"></a>02303 
<a name="l02304"></a>02304       <span class="keywordflow">for</span>(i=0;i&lt;3;i++)
<a name="l02305"></a>02305       {
<a name="l02306"></a>02306         dfe[0][i]=(dphi[0][i]-fet*dchi*av1[i]+con*epsilon*a1[i])/chi;
<a name="l02307"></a>02307         dfe[1][i]=(dphi[1][i]-fet*dchi*av2[i]+con*epsilon*a2[i])/chi;
<a name="l02308"></a>02308         dfe[2][i]=(dphi[2][i]-fet*dchi*av3[i]+con*epsilon*a3[i])/chi;
<a name="l02309"></a>02309       }
<a name="l02310"></a>02310 
<a name="l02311"></a>02311       <span class="keywordflow">for</span>(i=0;i&lt;3;i++)
<a name="l02312"></a>02312       {
<a name="l02313"></a>02313         P[0][i][i]=(d2phi[0][i][i]-dchi*(av1[i]*dfe[0][i]+dfe[0][i]*av1[i])+con*epsilon)/chi;
<a name="l02314"></a>02314         P[1][i][i]=(d2phi[1][i][i]-dchi*(av2[i]*dfe[1][i]+dfe[1][i]*av2[i])+con*epsilon)/chi;
<a name="l02315"></a>02315         P[2][i][i]=(d2phi[2][i][i]-dchi*(av3[i]*dfe[2][i]+dfe[2][i]*av3[i])+con*epsilon)/chi;
<a name="l02316"></a>02316       }
<a name="l02317"></a>02317 
<a name="l02318"></a>02318       <span class="keywordflow">for</span>(k=0;k&lt;3;k++)
<a name="l02319"></a>02319       {
<a name="l02320"></a>02320         <span class="keywordflow">for</span>(i=0;i&lt;3;i++)
<a name="l02321"></a>02321         {
<a name="l02322"></a>02322           <span class="keywordflow">for</span>(j=0;j&lt;3;j++)
<a name="l02323"></a>02323           {
<a name="l02324"></a>02324             <span class="keywordflow">if</span>(i!=j)
<a name="l02325"></a>02325               P[k][i][j]=0;
<a name="l02326"></a>02326           }
<a name="l02327"></a>02327         }
<a name="l02328"></a>02328       }
<a name="l02329"></a>02329     }
<a name="l02330"></a>02330 
<a name="l02331"></a>02331     <span class="comment">/*--------matrix W, right side F---------------------*/</span>
<a name="l02332"></a>02332     <span class="keywordflow">for</span>(i1=0;i1&lt;n;i1++)
<a name="l02333"></a>02333     {
<a name="l02334"></a>02334       <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l02335"></a>02335       {
<a name="l02336"></a>02336         <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++)
<a name="l02337"></a>02337         {
<a name="l02338"></a>02338           gpr[i][j]=0;
<a name="l02339"></a>02339           <span class="keywordflow">for</span>(k=0;k&lt;n;k++) gpr[i][j]=gpr[i][j]+P[i1][i][k]*Q[k][j];
<a name="l02340"></a>02340         }
<a name="l02341"></a>02341       }
<a name="l02342"></a>02342 
<a name="l02343"></a>02343       <span class="keywordflow">for</span>(i=0;i&lt;nvert;i++)
<a name="l02344"></a>02344       {
<a name="l02345"></a>02345         <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++)
<a name="l02346"></a>02346         {
<a name="l02347"></a>02347           <span class="keywordflow">for</span>(k=0;k&lt;n;k++)
<a name="l02348"></a>02348           {
<a name="l02349"></a>02349             W[i1][i][j]=W[i1][i][j]+Q[k][i]*gpr[k][j]*sigma;
<a name="l02350"></a>02350           }
<a name="l02351"></a>02351         }
<a name="l02352"></a>02352       }
<a name="l02353"></a>02353 
<a name="l02354"></a>02354       <span class="keywordflow">for</span>(i=0;i&lt;nvert;i++)
<a name="l02355"></a>02355       {
<a name="l02356"></a>02356         <span class="keywordflow">for</span>(k=0;k&lt;2;k++)
<a name="l02357"></a>02357           F[i1][i]=F[i1][i]+Q[k][i]*dfe[i1][k]*sigma;
<a name="l02358"></a>02358       }
<a name="l02359"></a>02359     }
<a name="l02360"></a>02360   }
<a name="l02361"></a>02361 
<a name="l02362"></a>02362   <span class="comment">/*----------------------------------------*/</span>
<a name="l02363"></a>02363   <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l02364"></a>02364     free(Q[i]);
<a name="l02365"></a>02365   free(Q);
<a name="l02366"></a>02366   <span class="keywordflow">if</span>(f==0)
<a name="l02367"></a>02367   {
<a name="l02368"></a>02368     <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l02369"></a>02369     {
<a name="l02370"></a>02370       free(gpr[i]);
<a name="l02371"></a>02371       free(dphi[i]);
<a name="l02372"></a>02372       free(dfe[i]);
<a name="l02373"></a>02373     }
<a name="l02374"></a>02374     free(gpr);
<a name="l02375"></a>02375     free(dphi);
<a name="l02376"></a>02376     free(dfe);
<a name="l02377"></a>02377 
<a name="l02378"></a>02378     <span class="keywordflow">for</span>(i=0;i&lt;n;i++)
<a name="l02379"></a>02379     {
<a name="l02380"></a>02380       <span class="keywordflow">for</span>(j=0;j&lt;n;j++)
<a name="l02381"></a>02381       {
<a name="l02382"></a>02382         free(P[i][j]);
<a name="l02383"></a>02383         free(d2phi[i][j]);
<a name="l02384"></a>02384       }
<a name="l02385"></a>02385       free(P[i]);
<a name="l02386"></a>02386       free(d2phi[i]);
<a name="l02387"></a>02387     }
<a name="l02388"></a>02388     free(P);
<a name="l02389"></a>02389     free(d2phi);
<a name="l02390"></a>02390   }
<a name="l02391"></a>02391 
<a name="l02392"></a>02392   <span class="keywordflow">return</span> (fet*sigma);
<a name="l02393"></a>02393 }
<a name="l02394"></a>02394 
<a name="l02400"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a86eb9c4d0df6ffdc1a0892daf7086131">02400</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a86eb9c4d0df6ffdc1a0892daf7086131">VariationalMeshSmoother::solver</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ja, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> a, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> x, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> b, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout)
<a name="l02401"></a>02401 {
<a name="l02402"></a>02402     <span class="keywordtype">int</span> info, i;
<a name="l02403"></a>02403     <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> u, r, p, z;
<a name="l02404"></a>02404 
<a name="l02405"></a>02405     info = 0;
<a name="l02406"></a>02406 
<a name="l02407"></a>02407     fprintf(sout, <span class="stringliteral">&quot;Beginning Solve %d\n&quot;</span>, n);
<a name="l02408"></a>02408 
<a name="l02409"></a>02409 
<a name="l02410"></a>02410     <span class="comment">// Check parameters</span>
<a name="l02411"></a>02411     info=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abc0e1acadc8fd16c6f278c3d4056cc96">pcg_par_check</a>(n, ia, ja, a, eps, maxite, msglev, sout);
<a name="l02412"></a>02412     <span class="keywordflow">if</span> (info != 0)
<a name="l02413"></a>02413         <span class="keywordflow">return</span> info;
<a name="l02414"></a>02414 
<a name="l02415"></a>02415     <span class="comment">// Allocate working arrays</span>
<a name="l02416"></a>02416     u=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l02417"></a>02417     r=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l02418"></a>02418     p=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l02419"></a>02419     z=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l02420"></a>02420 
<a name="l02421"></a>02421     <span class="comment">// PJ preconditioner construction</span>
<a name="l02422"></a>02422         <span class="keywordflow">for</span> (i=0;i&lt;n;i++) u[i]=1.0/a[ia[i]];
<a name="l02423"></a>02423 
<a name="l02424"></a>02424     <span class="comment">// PCG iterations</span>
<a name="l02425"></a>02425     info=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a83878b9bb8e4e0e49330c037069ee44c">pcg_ic0</a>(n, ia, ja, a, u, x, b, r, p, z, eps, maxite, msglev, sout);
<a name="l02426"></a>02426 
<a name="l02427"></a>02427     <span class="comment">// Free working arrays</span>
<a name="l02428"></a>02428     free(u);
<a name="l02429"></a>02429         free(r);
<a name="l02430"></a>02430         free(p);
<a name="l02431"></a>02431         free(z);
<a name="l02432"></a>02432 
<a name="l02433"></a>02433     <span class="comment">//Mat sparse_global;</span>
<a name="l02434"></a>02434     <span class="comment">//MatCreateSeqAIJWithArrays(PETSC_COMM_SELF,n,n,ia,ja,a,&amp;sparse_global);</span>
<a name="l02435"></a>02435 
<a name="l02436"></a>02436     fprintf(sout, <span class="stringliteral">&quot;Finished Solve %d\n&quot;</span>,n);
<a name="l02437"></a>02437 
<a name="l02438"></a>02438     <span class="keywordflow">return</span> info;
<a name="l02439"></a>02439 }
<a name="l02440"></a>02440 
<a name="l02444"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abc0e1acadc8fd16c6f278c3d4056cc96">02444</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abc0e1acadc8fd16c6f278c3d4056cc96">VariationalMeshSmoother::pcg_par_check</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ja, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> a, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout)
<a name="l02445"></a>02445 {
<a name="l02446"></a>02446     <span class="keywordtype">int</span> i, j, jj, k;
<a name="l02447"></a>02447 
<a name="l02448"></a>02448     <span class="keywordflow">if</span> (n&lt;=0){
<a name="l02449"></a>02449             <span class="keywordflow">if</span> (msglev&gt;0) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: n =%d \n&quot;</span>,n);
<a name="l02450"></a>02450             <span class="keywordflow">return</span> -1;
<a name="l02451"></a>02451     }
<a name="l02452"></a>02452     <span class="keywordflow">if</span> (ia[0]!=0) {
<a name="l02453"></a>02453             <span class="keywordflow">if</span> (msglev &gt; 0) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: ia(1) =%d \n&quot;</span>, ia[0]);
<a name="l02454"></a>02454             <span class="keywordflow">return</span> -2;
<a name="l02455"></a>02455     }
<a name="l02456"></a>02456     <span class="keywordflow">for</span> (i=0;i&lt;n;i++) {
<a name="l02457"></a>02457             <span class="keywordflow">if</span> (ia[i+1]&lt;ia[i]) {
<a name="l02458"></a>02458             <span class="keywordflow">if</span> (msglev&gt;=1)fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: i =%d ; ia(i) =%d  must be &lt;= a(i+1) =%d \n&quot;</span>,
<a name="l02459"></a>02459                         (i+1), ia[i], ia[i+1]);
<a name="l02460"></a>02460             <span class="keywordflow">return</span> -2;
<a name="l02461"></a>02461                 }
<a name="l02462"></a>02462         }
<a name="l02463"></a>02463     <span class="keywordflow">for</span> (i=0;i&lt;n;i++) {
<a name="l02464"></a>02464             <span class="keywordflow">if</span> (ja[ia[i]]!=(i+1)) {
<a name="l02465"></a>02465             <span class="keywordflow">if</span> (msglev&gt;=1) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: i =%d ; ia(i) =%d ; absence of diagonal entry; k =%d ; the value ja(k) =%d  must be equal to i\n&quot;</span>,
<a name="l02466"></a>02466                         (i+1), ia[i], ia[i]+1, ja[ia[i]]);
<a name="l02467"></a>02467                 <span class="keywordflow">return</span> -3;
<a name="l02468"></a>02468                 }
<a name="l02469"></a>02469             jj = 0;
<a name="l02470"></a>02470             <span class="keywordflow">for</span> (k=ia[i];k&lt;ia[i+1];k++) {
<a name="l02471"></a>02471                 j=ja[k];
<a name="l02472"></a>02472                 <span class="keywordflow">if</span> ((j&lt;(i+1))||(j&gt;n)) {
<a name="l02473"></a>02473                     <span class="keywordflow">if</span> (msglev&gt;=1) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: i =%d ; ia(i) =%d ; a(i+1) =%d ; k =%d ; the value ja(k) =%d  is out of range\n&quot;</span>,
<a name="l02474"></a>02474                             (i+1), ia[i], ia[i+1], (k+1), ja[k]);
<a name="l02475"></a>02475                     <span class="keywordflow">return</span> -3;
<a name="l02476"></a>02476                         }
<a name="l02477"></a>02477                 <span class="keywordflow">if</span> (j&lt;=jj) {
<a name="l02478"></a>02478                        <span class="keywordflow">if</span> (msglev &gt;= 1) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: i =%d ; ia(i) =%d ; a(i+1) =%d ; k =%d ; the value ja(k) =%d  must be less than ja(k+1) =%d \n&quot;</span>,
<a name="l02479"></a>02479                                                (i+1), ia[i], ia[i+1], (k+1), ja[k], ja[k+1]);
<a name="l02480"></a>02480                     <span class="keywordflow">return</span> -3;
<a name="l02481"></a>02481                         }
<a name="l02482"></a>02482                         jj=j;
<a name="l02483"></a>02483                 }
<a name="l02484"></a>02484         }
<a name="l02485"></a>02485 
<a name="l02486"></a>02486     <span class="keywordflow">for</span> (i=0;i&lt;n;i++) {
<a name="l02487"></a>02487           <span class="keywordflow">if</span> (a[ia[i]]&lt;=0.0e0) {
<a name="l02488"></a>02488             <span class="keywordflow">if</span> (msglev&gt;=1) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: i =%d ; ia(i) =%d ; the diagonal entry a(ia(i)) =%g  must be &gt; 0\n&quot;</span>,
<a name="l02489"></a>02489                         (i+1), ia[i], a[ia[i]]);
<a name="l02490"></a>02490             <span class="keywordflow">return</span> -4;
<a name="l02491"></a>02491           }
<a name="l02492"></a>02492         }
<a name="l02493"></a>02493 
<a name="l02494"></a>02494     <span class="keywordflow">if</span> (eps&lt;0.0e0) {
<a name="l02495"></a>02495             <span class="keywordflow">if</span> (msglev&gt;0) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: eps =%g \n&quot;</span>,eps);
<a name="l02496"></a>02496             <span class="keywordflow">return</span> -7;
<a name="l02497"></a>02497     }
<a name="l02498"></a>02498     <span class="keywordflow">if</span> (maxite&lt;1) {
<a name="l02499"></a>02499             <span class="keywordflow">if</span> (msglev&gt;0) fprintf(sout, <span class="stringliteral">&quot;sol_pcg: incorrect input parameter: maxite =%d \n&quot;</span>, maxite);
<a name="l02500"></a>02500             <span class="keywordflow">return</span> -8;
<a name="l02501"></a>02501     }
<a name="l02502"></a>02502     <span class="keywordflow">return</span> 0;
<a name="l02503"></a>02503 }
<a name="l02504"></a>02504 
<a name="l02508"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a83878b9bb8e4e0e49330c037069ee44c">02508</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a83878b9bb8e4e0e49330c037069ee44c">VariationalMeshSmoother::pcg_ic0</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ja, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> a, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> u, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> x, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> b, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> r,
<a name="l02509"></a>02509                  <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> p, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> z, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout)
<a name="l02510"></a>02510 {
<a name="l02511"></a>02511     <span class="keywordtype">int</span> i, ii, j, k;
<a name="l02512"></a>02512     <span class="keywordtype">double</span> beta, pap, rhr = 0.0, rhr0 = 0.0, rhrold = 0.0, alpha, rr0 = 0.0, rr;
<a name="l02513"></a>02513 
<a name="l02514"></a>02514     <span class="keywordflow">for</span>(i=0;i&lt;=maxite;i++){
<a name="l02515"></a>02515            <span class="keywordflow">if</span>(i==0) <span class="keywordflow">for</span>(k=0;k&lt;n;k++) p[k]=x[k];
<a name="l02516"></a>02516            <span class="comment">//z=Ap</span>
<a name="l02517"></a>02517            <span class="keywordflow">for</span>(ii=0;ii&lt;n;ii++) z[ii]=0.0;
<a name="l02518"></a>02518        <span class="keywordflow">for</span>(ii=0;ii&lt;n;ii++){
<a name="l02519"></a>02519                    z[ii]+=a[ia[ii]]*p[ii];
<a name="l02520"></a>02520                    <span class="keywordflow">for</span>(j=ia[ii]+1;j&lt;ia[ii+1];j++){
<a name="l02521"></a>02521                        z[ii]+=a[j]*p[ja[j]-1];
<a name="l02522"></a>02522                        z[ja[j]-1]+=a[j]*p[ii];
<a name="l02523"></a>02523                            }
<a name="l02524"></a>02524            }
<a name="l02525"></a>02525            <span class="keywordflow">if</span>(i==0) <span class="keywordflow">for</span>(k=0;k&lt;n;k++) r[k]=b[k]-z[k]; <span class="comment">//r(0) = b - Ax(0)</span>
<a name="l02526"></a>02526            <span class="keywordflow">if</span>(i&gt;0){
<a name="l02527"></a>02527                pap=0.0;
<a name="l02528"></a>02528                <span class="keywordflow">for</span>(k=0;k&lt;n;k++) pap+=p[k]*z[k];
<a name="l02529"></a>02529                alpha=rhr/pap;
<a name="l02530"></a>02530            <span class="keywordflow">for</span>(k=0;k&lt;n;k++){
<a name="l02531"></a>02531                        x[k]+=p[k]*alpha;
<a name="l02532"></a>02532                        r[k]-=z[k]*alpha;
<a name="l02533"></a>02533                    }
<a name="l02534"></a>02534                rhrold = rhr;
<a name="l02535"></a>02535            }
<a name="l02536"></a>02536        <span class="comment">// z = H * r</span>
<a name="l02537"></a>02537        <span class="keywordflow">for</span>(ii=0;ii&lt;n;ii++) z[ii]=r[ii]*u[ii];
<a name="l02538"></a>02538            <span class="keywordflow">if</span>(i==0) <span class="keywordflow">for</span>(k=0;k&lt;n;k++) p[k]=z[k];<span class="comment">// p(0) = Hr(0)</span>
<a name="l02539"></a>02539            rhr=0.0;
<a name="l02540"></a>02540            rr=0.0;
<a name="l02541"></a>02541            <span class="keywordflow">for</span>(k=0;k&lt;n;k++){
<a name="l02542"></a>02542                rhr+=r[k]*z[k];
<a name="l02543"></a>02543                rr+=r[k]*r[k];
<a name="l02544"></a>02544            }
<a name="l02545"></a>02545            <span class="keywordflow">if</span>(i==0){
<a name="l02546"></a>02546             rhr0 = rhr;
<a name="l02547"></a>02547             rr0 = rr;
<a name="l02548"></a>02548            }
<a name="l02549"></a>02549            <span class="keywordflow">if</span>(msglev&gt;0) fprintf(sout, <span class="stringliteral">&quot;%d )  rHr =%g  rr =%g \n&quot;</span>, i, sqrt(rhr/rhr0), sqrt(rr/rr0));
<a name="l02550"></a>02550 
<a name="l02551"></a>02551            <span class="keywordflow">if</span>(rr&lt;=eps*eps*rr0) <span class="keywordflow">return</span> i;
<a name="l02552"></a>02552 
<a name="l02553"></a>02553            <span class="keywordflow">if</span>(i&gt;=maxite) <span class="keywordflow">return</span> i;
<a name="l02554"></a>02554 
<a name="l02555"></a>02555            <span class="keywordflow">if</span>(i&gt;0){
<a name="l02556"></a>02556               beta=rhr/rhrold;
<a name="l02557"></a>02557               <span class="keywordflow">for</span>(k=0;k&lt;n;k++) p[k]=z[k]+p[k]*beta;
<a name="l02558"></a>02558            }
<a name="l02559"></a>02559         }
<a name="l02560"></a>02560 
<a name="l02561"></a>02561     <span class="keywordflow">return</span> i;
<a name="l02562"></a>02562 }
<a name="l02563"></a>02563 
<a name="l02567"></a>02567 <span class="comment">//void VariationalMeshSmoother::gener(char grid[], int n, FILE *sout)</span>
<a name="l02568"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0db3322b3810b54d2bfb7297157409bf">02568</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0db3322b3810b54d2bfb7297157409bf">VariationalMeshSmoother::gener</a>(<span class="keywordtype">char</span> grid[], <span class="keywordtype">int</span> n, FILE *)
<a name="l02569"></a>02569 {
<a name="l02570"></a>02570         FILE *stream;
<a name="l02571"></a>02571         <span class="keywordtype">int</span> i, j, k, n1=3, N, ncells, mask, ii, jj, kk, nc;
<a name="l02572"></a>02572         <span class="keywordtype">double</span> x;
<a name="l02573"></a>02573 
<a name="l02574"></a>02574     N=1; ncells=1;
<a name="l02575"></a>02575         <span class="keywordflow">for</span>(i=0;i&lt;n;i++){N*=n1; ncells*=(n1-1);}
<a name="l02576"></a>02576         x=1.0/(double)(n1-1);
<a name="l02577"></a>02577 
<a name="l02578"></a>02578         stream=fopen(grid,<span class="stringliteral">&quot;w+&quot;</span>);
<a name="l02579"></a>02579 
<a name="l02580"></a>02580         fprintf(stream,<span class="stringliteral">&quot;%d \n%d \n%d \n0 \n&quot;</span>,n,N,ncells);
<a name="l02581"></a>02581 
<a name="l02582"></a>02582         <span class="keywordflow">for</span>(i=0;i&lt;N;i++){<span class="comment">//node coordinates</span>
<a name="l02583"></a>02583                 k=i; mask=0;
<a name="l02584"></a>02584                 <span class="keywordflow">for</span>(j=0;j&lt;n;j++){
<a name="l02585"></a>02585                     ii=k%n1;
<a name="l02586"></a>02586                     <span class="keywordflow">if</span>((ii==0)||(ii==n1-1)) mask=1;
<a name="l02587"></a>02587                     <span class="comment">//if((i==N/2)&amp;&amp;(j==1)) fprintf(stream,&quot;%e &quot;,(double)ii*x+x/2.0); else</span>
<a name="l02588"></a>02588                     fprintf(stream,<span class="stringliteral">&quot;%e &quot;</span>,(<span class="keywordtype">double</span>)ii*x);
<a name="l02589"></a>02589                     k/=n1;
<a name="l02590"></a>02590                 }
<a name="l02591"></a>02591         fprintf(stream,<span class="stringliteral">&quot;%d \n&quot;</span>,mask);
<a name="l02592"></a>02592     }
<a name="l02593"></a>02593     <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++){<span class="comment">//cell connectivity</span>
<a name="l02594"></a>02594             nc=i; ii=nc%(n1-1); nc/=(n1-1); jj=nc%(n1-1); kk=nc/(n1-1);
<a name="l02595"></a>02595                 <span class="keywordflow">if</span>(n==2) fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d &quot;</span>,ii+n1*jj,ii+1+jj*n1,ii+(jj+1)*n1,ii+1+(jj+1)*n1);
<a name="l02596"></a>02596                 <span class="keywordflow">if</span>(n==3) fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d %d %d %d %d &quot;</span>,ii+n1*jj+n1*n1*kk,ii+1+jj*n1+n1*n1*kk,ii+(jj+1)*n1+n1*n1*kk,ii+1+(jj+1)*n1+n1*n1*kk,
<a name="l02597"></a>02597                                      ii+n1*jj+n1*n1*(kk+1),ii+1+jj*n1+n1*n1*(kk+1),ii+(jj+1)*n1+n1*n1*(kk+1),ii+1+(jj+1)*n1+n1*n1*(kk+1));
<a name="l02598"></a>02598             fprintf(stream,<span class="stringliteral">&quot;-1 -1 0 \n&quot;</span>);
<a name="l02599"></a>02599         }
<a name="l02600"></a>02600         fclose(stream);
<a name="l02601"></a>02601 
<a name="l02602"></a>02602         <span class="keywordflow">return</span>;
<a name="l02603"></a>02603 }
<a name="l02604"></a>02604 
<a name="l02609"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a52a126c779d4646296ad65a0c0a92d23">02609</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a52a126c779d4646296ad65a0c0a92d23">VariationalMeshSmoother::metr_data_gen</a>(<span class="keywordtype">char</span> grid[], <span class="keywordtype">char</span> metr[], <span class="keywordtype">int</span> n, <span class="keywordtype">int</span> me, FILE *sout)
<a name="l02610"></a>02610 {
<a name="l02611"></a>02611   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R;
<a name="l02612"></a>02612   <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells;
<a name="l02613"></a>02613   <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, mcells;
<a name="l02614"></a>02614   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q;
<a name="l02615"></a>02615   <span class="keywordtype">double</span> K[9], a1[3], a2[3], a3[3];
<a name="l02616"></a>02616   <span class="keywordtype">double</span> det, g1, g2, g3, det_o, g1_o, g2_o, g3_o, eps=1e-3;
<a name="l02617"></a>02617   <span class="keywordtype">int</span>  i, j, k, l, N, ncells, Ncells, nvert, scanned;
<a name="l02618"></a>02618   FILE *stream;
<a name="l02619"></a>02619 
<a name="l02620"></a>02620   Q = <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(3, 10);
<a name="l02621"></a>02621   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) Q[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(3*n+n%2);
<a name="l02622"></a>02622 
<a name="l02623"></a>02623   <span class="comment">//read the initial mesh</span>
<a name="l02624"></a>02624   stream=fopen(grid,<span class="stringliteral">&quot;r&quot;</span>);
<a name="l02625"></a>02625   scanned = fscanf(stream, <span class="stringliteral">&quot;%d \n%d \n%d \n%d \n&quot;</span>,&amp;i,&amp;N,&amp;ncells,&amp;j);
<a name="l02626"></a>02626   libmesh_assert(scanned != EOF);
<a name="l02627"></a>02627   fclose(stream);
<a name="l02628"></a>02628 
<a name="l02629"></a>02629   mask=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(N);
<a name="l02630"></a>02630   mcells=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(ncells);
<a name="l02631"></a>02631   R=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(N,n);
<a name="l02632"></a>02632   cells=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aea218377addb1242650692248f082794">alloc_i_n1_n2</a>(ncells,3*n+n%2);
<a name="l02633"></a>02633   <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) cells[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(3*n+n%2);
<a name="l02634"></a>02634   <span class="keywordflow">for</span>(i=0;i&lt;N;i++) R[i]=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(n);
<a name="l02635"></a>02635 
<a name="l02636"></a>02636   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3e4f20c7407b7c07bbaf7ad0bdbc77b4">readgr</a>(n,N,R,mask,ncells,cells,mcells,0,mcells,mcells, sout);
<a name="l02637"></a>02637 
<a name="l02638"></a>02638   <span class="comment">//genetrate metric file</span>
<a name="l02639"></a>02639   stream=fopen(metr,<span class="stringliteral">&quot;w+&quot;</span>);
<a name="l02640"></a>02640   Ncells=0;
<a name="l02641"></a>02641   det_o=1.0; g1_o=1.0; g2_o=1.0; g3_o=1.0;
<a name="l02642"></a>02642   <span class="keywordflow">for</span>(i=0; i&lt;ncells; i++) if(mcells[i]&gt;=0){
<a name="l02643"></a>02643           nvert=0; <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0) nvert++;
<a name="l02644"></a>02644           <span class="keywordflow">if</span>(n==2){<span class="comment">//2D - tri and quad</span>
<a name="l02645"></a>02645                   <span class="keywordflow">if</span>(nvert==3){<span class="comment">//tri</span>
<a name="l02646"></a>02646                           <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(2,Q,3,K,Q,1);
<a name="l02647"></a>02647                           <span class="keywordflow">for</span>(k=0;k&lt;2;k++){a1[k]=0; a2[k]=0;
<a name="l02648"></a>02648                               <span class="keywordflow">for</span>(l=0;l&lt;3;l++){
<a name="l02649"></a>02649                                       a1[k]=a1[k]+Q[k][l]*R[cells[i][l]][0];
<a name="l02650"></a>02650                                       a2[k]=a2[k]+Q[k][l]*R[cells[i][l]][1];
<a name="l02651"></a>02651                                   }
<a name="l02652"></a>02652                           }
<a name="l02653"></a>02653                           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l02654"></a>02654                           g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]);
<a name="l02655"></a>02655                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l02656"></a>02656                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02657"></a>02657                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02658"></a>02658                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02659"></a>02659                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02660"></a>02660                           <span class="comment">//write to file</span>
<a name="l02661"></a>02661                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e 0.000000e+00 \n0.000000e+00 %e \n&quot;</span>,1.0/sqrt(det),1.0/sqrt(det));
<a name="l02662"></a>02662               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e 0.000000e+00 \n0.000000e+00 %e \n&quot;</span>,1.0/g1,1.0/g2);
<a name="l02663"></a>02663                           det_o=det; g1_o=g1; g2_o=g2;
<a name="l02664"></a>02664                           Ncells++;
<a name="l02665"></a>02665                   }
<a name="l02666"></a>02666                   <span class="keywordflow">if</span>(nvert==4){<span class="comment">//quad</span>
<a name="l02667"></a>02667               a1[0]=R[cells[i][1]][0]-R[cells[i][0]][0];
<a name="l02668"></a>02668               a1[1]=R[cells[i][2]][0]-R[cells[i][0]][0];
<a name="l02669"></a>02669               a2[0]=R[cells[i][1]][1]-R[cells[i][0]][1];
<a name="l02670"></a>02670               a2[1]=R[cells[i][2]][1]-R[cells[i][0]][1];
<a name="l02671"></a>02671                           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l02672"></a>02672                           g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]);
<a name="l02673"></a>02673                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l02674"></a>02674                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02675"></a>02675                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02676"></a>02676                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02677"></a>02677                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02678"></a>02678                           <span class="comment">//write to file</span>
<a name="l02679"></a>02679                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/sqrt(det),0.5/sqrt(det),0.5*sqrt(3.0/det));
<a name="l02680"></a>02680               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/g1,0.5/g2,0.5*sqrt(3.0)/g2);
<a name="l02681"></a>02681                           det_o=det; g1_o=g1; g2_o=g2;
<a name="l02682"></a>02682                           Ncells++;
<a name="l02683"></a>02683                       a1[0]=R[cells[i][3]][0]-R[cells[i][1]][0];
<a name="l02684"></a>02684                       a1[1]=R[cells[i][0]][0]-R[cells[i][1]][0];
<a name="l02685"></a>02685                       a2[0]=R[cells[i][3]][1]-R[cells[i][1]][1];
<a name="l02686"></a>02686                       a2[1]=R[cells[i][0]][1]-R[cells[i][1]][1];
<a name="l02687"></a>02687                           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l02688"></a>02688                           g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]);
<a name="l02689"></a>02689                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l02690"></a>02690                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02691"></a>02691                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02692"></a>02692                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02693"></a>02693                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02694"></a>02694                           <span class="comment">//write to file</span>
<a name="l02695"></a>02695                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/sqrt(det),0.5/sqrt(det),0.5*sqrt(3.0/det));
<a name="l02696"></a>02696               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/g1,0.5/g2,0.5*sqrt(3.0)/g2);
<a name="l02697"></a>02697                           det_o=det; g1_o=g1; g2_o=g2;
<a name="l02698"></a>02698                           Ncells++;
<a name="l02699"></a>02699                       a1[0]=R[cells[i][2]][0]-R[cells[i][3]][0];
<a name="l02700"></a>02700                       a1[1]=R[cells[i][1]][0]-R[cells[i][3]][0];
<a name="l02701"></a>02701                       a2[0]=R[cells[i][2]][1]-R[cells[i][3]][1];
<a name="l02702"></a>02702                       a2[1]=R[cells[i][1]][1]-R[cells[i][3]][1];
<a name="l02703"></a>02703                           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l02704"></a>02704                           g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]);
<a name="l02705"></a>02705                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l02706"></a>02706                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02707"></a>02707                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02708"></a>02708                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02709"></a>02709                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02710"></a>02710                           <span class="comment">//write to file</span>
<a name="l02711"></a>02711                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/sqrt(det),0.5/sqrt(det),0.5*sqrt(3.0/det));
<a name="l02712"></a>02712               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/g1,0.5/g2,0.5*sqrt(3.0)/g2);
<a name="l02713"></a>02713                           det_o=det; g1_o=g1; g2_o=g2;
<a name="l02714"></a>02714                           Ncells++;
<a name="l02715"></a>02715                       a1[0]=R[cells[i][0]][0]-R[cells[i][2]][0];
<a name="l02716"></a>02716                       a1[1]=R[cells[i][3]][0]-R[cells[i][2]][0];
<a name="l02717"></a>02717                       a2[0]=R[cells[i][0]][1]-R[cells[i][2]][1];
<a name="l02718"></a>02718                       a2[1]=R[cells[i][3]][1]-R[cells[i][2]][1];
<a name="l02719"></a>02719                           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(a1[0],a1[1],a2[0],a2[1]);
<a name="l02720"></a>02720                           g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]);
<a name="l02721"></a>02721                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]);
<a name="l02722"></a>02722                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02723"></a>02723                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02724"></a>02724                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02725"></a>02725                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02726"></a>02726                           <span class="comment">//write to file</span>
<a name="l02727"></a>02727                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/sqrt(det),0.5/sqrt(det),0.5*sqrt(3.0/det));
<a name="l02728"></a>02728               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e \n0.000000e+00 %e \n&quot;</span>,1.0/g1,0.5/g2,0.5*sqrt(3.0)/g2);
<a name="l02729"></a>02729                           det_o=det; g1_o=g1; g2_o=g2;
<a name="l02730"></a>02730                           Ncells++;
<a name="l02731"></a>02731 
<a name="l02732"></a>02732                   }
<a name="l02733"></a>02733           }
<a name="l02734"></a>02734           <span class="keywordflow">if</span>(n==3){<span class="comment">//3D - tetr and hex</span>
<a name="l02735"></a>02735                   <span class="keywordflow">if</span>(nvert==4){<span class="comment">//tetr</span>
<a name="l02736"></a>02736                           <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(3,Q,4,K,Q,1);
<a name="l02737"></a>02737                           <span class="keywordflow">for</span>(k=0;k&lt;3;k++){a1[k]=0; a2[k]=0; a3[k]=0;
<a name="l02738"></a>02738                               <span class="keywordflow">for</span>(l=0;l&lt;4;l++){
<a name="l02739"></a>02739                                           a1[k]=a1[k]+Q[k][l]*R[cells[i][l]][0];
<a name="l02740"></a>02740                                           a2[k]=a2[k]+Q[k][l]*R[cells[i][l]][1];
<a name="l02741"></a>02741                                           a3[k]=a3[k]+Q[k][l]*R[cells[i][l]][2];
<a name="l02742"></a>02742                                   }
<a name="l02743"></a>02743                           }
<a name="l02744"></a>02744                           det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02745"></a>02745               g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02746"></a>02746                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02747"></a>02747                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02748"></a>02748                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02749"></a>02749                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02750"></a>02750                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02751"></a>02751                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02752"></a>02752                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02753"></a>02753                           <span class="comment">//write to file</span>
<a name="l02754"></a>02754                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e 0.000000e+00  0.000000e+00\n0.000000e+00 %e 0.000000e+00\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02755"></a>02755               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e 0.000000e+00  0.000000e+00\n0.000000e+00 %e 0.000000e+00\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,1.0/g2,1.0/g3);
<a name="l02756"></a>02756                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02757"></a>02757                           Ncells++;
<a name="l02758"></a>02758                   }
<a name="l02759"></a>02759                   <span class="keywordflow">if</span>(nvert==8){<span class="comment">//hex</span>
<a name="l02760"></a>02760                      a1[0]=R[cells[i][1]][0]-R[cells[i][0]][0];
<a name="l02761"></a>02761                      a1[1]=R[cells[i][2]][0]-R[cells[i][0]][0];
<a name="l02762"></a>02762                      a1[2]=R[cells[i][4]][0]-R[cells[i][0]][0];
<a name="l02763"></a>02763                      a2[0]=R[cells[i][1]][1]-R[cells[i][0]][1];
<a name="l02764"></a>02764                      a2[1]=R[cells[i][2]][1]-R[cells[i][0]][1];
<a name="l02765"></a>02765                      a2[2]=R[cells[i][4]][1]-R[cells[i][0]][1];
<a name="l02766"></a>02766                      a3[0]=R[cells[i][1]][2]-R[cells[i][0]][2];
<a name="l02767"></a>02767                      a3[1]=R[cells[i][2]][2]-R[cells[i][0]][2];
<a name="l02768"></a>02768                      a3[2]=R[cells[i][4]][2]-R[cells[i][0]][2];
<a name="l02769"></a>02769                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02770"></a>02770                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02771"></a>02771                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02772"></a>02772                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02773"></a>02773                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02774"></a>02774                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02775"></a>02775                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02776"></a>02776                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02777"></a>02777                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02778"></a>02778                           <span class="comment">//write to file</span>
<a name="l02779"></a>02779                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02780"></a>02780                           <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02781"></a>02781                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02782"></a>02782                           Ncells++;
<a name="l02783"></a>02783                      a1[0]=R[cells[i][3]][0]-R[cells[i][1]][0];
<a name="l02784"></a>02784                      a1[1]=R[cells[i][0]][0]-R[cells[i][1]][0];
<a name="l02785"></a>02785                      a1[2]=R[cells[i][5]][0]-R[cells[i][1]][0];
<a name="l02786"></a>02786                      a2[0]=R[cells[i][3]][1]-R[cells[i][1]][1];
<a name="l02787"></a>02787                      a2[1]=R[cells[i][0]][1]-R[cells[i][1]][1];
<a name="l02788"></a>02788                      a2[2]=R[cells[i][5]][1]-R[cells[i][1]][1];
<a name="l02789"></a>02789                      a3[0]=R[cells[i][3]][2]-R[cells[i][1]][2];
<a name="l02790"></a>02790                      a3[1]=R[cells[i][0]][2]-R[cells[i][1]][2];
<a name="l02791"></a>02791                      a3[2]=R[cells[i][5]][2]-R[cells[i][1]][2];
<a name="l02792"></a>02792                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02793"></a>02793                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02794"></a>02794                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02795"></a>02795                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02796"></a>02796                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02797"></a>02797                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02798"></a>02798                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02799"></a>02799                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02800"></a>02800                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02801"></a>02801                           <span class="comment">//write to file</span>
<a name="l02802"></a>02802                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02803"></a>02803                           <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02804"></a>02804                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02805"></a>02805                           Ncells++;
<a name="l02806"></a>02806                      a1[0]=R[cells[i][2]][0]-R[cells[i][3]][0];
<a name="l02807"></a>02807                      a1[1]=R[cells[i][1]][0]-R[cells[i][3]][0];
<a name="l02808"></a>02808                      a1[2]=R[cells[i][7]][0]-R[cells[i][3]][0];
<a name="l02809"></a>02809                      a2[0]=R[cells[i][2]][1]-R[cells[i][3]][1];
<a name="l02810"></a>02810                      a2[1]=R[cells[i][1]][1]-R[cells[i][3]][1];
<a name="l02811"></a>02811                      a2[2]=R[cells[i][7]][1]-R[cells[i][3]][1];
<a name="l02812"></a>02812                      a3[0]=R[cells[i][2]][2]-R[cells[i][3]][2];
<a name="l02813"></a>02813                      a3[1]=R[cells[i][1]][2]-R[cells[i][3]][2];
<a name="l02814"></a>02814                      a3[2]=R[cells[i][7]][2]-R[cells[i][3]][2];
<a name="l02815"></a>02815                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02816"></a>02816                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02817"></a>02817                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02818"></a>02818                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02819"></a>02819                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02820"></a>02820                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02821"></a>02821                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02822"></a>02822                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02823"></a>02823                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02824"></a>02824                           <span class="comment">//write to file</span>
<a name="l02825"></a>02825                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02826"></a>02826                           <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02827"></a>02827                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02828"></a>02828                           Ncells++;
<a name="l02829"></a>02829                      a1[0]=R[cells[i][0]][0]-R[cells[i][2]][0];
<a name="l02830"></a>02830                      a1[1]=R[cells[i][3]][0]-R[cells[i][2]][0];
<a name="l02831"></a>02831                      a1[2]=R[cells[i][6]][0]-R[cells[i][2]][0];
<a name="l02832"></a>02832                      a2[0]=R[cells[i][0]][1]-R[cells[i][2]][1];
<a name="l02833"></a>02833                      a2[1]=R[cells[i][3]][1]-R[cells[i][2]][1];
<a name="l02834"></a>02834                      a2[2]=R[cells[i][6]][1]-R[cells[i][2]][1];
<a name="l02835"></a>02835                      a3[0]=R[cells[i][0]][2]-R[cells[i][2]][2];
<a name="l02836"></a>02836                      a3[1]=R[cells[i][3]][2]-R[cells[i][2]][2];
<a name="l02837"></a>02837                      a3[2]=R[cells[i][6]][2]-R[cells[i][2]][2];
<a name="l02838"></a>02838                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02839"></a>02839                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02840"></a>02840                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02841"></a>02841                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02842"></a>02842                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02843"></a>02843                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02844"></a>02844                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02845"></a>02845                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02846"></a>02846                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02847"></a>02847                           <span class="comment">//write to file</span>
<a name="l02848"></a>02848                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02849"></a>02849                           <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02850"></a>02850                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02851"></a>02851                           Ncells++;
<a name="l02852"></a>02852                      a1[0]=R[cells[i][6]][0]-R[cells[i][4]][0];
<a name="l02853"></a>02853                      a1[1]=R[cells[i][5]][0]-R[cells[i][4]][0];
<a name="l02854"></a>02854                      a1[2]=R[cells[i][0]][0]-R[cells[i][4]][0];
<a name="l02855"></a>02855                      a2[0]=R[cells[i][6]][1]-R[cells[i][4]][1];
<a name="l02856"></a>02856                      a2[1]=R[cells[i][5]][1]-R[cells[i][4]][1];
<a name="l02857"></a>02857                      a2[2]=R[cells[i][0]][1]-R[cells[i][4]][1];
<a name="l02858"></a>02858                      a3[0]=R[cells[i][6]][2]-R[cells[i][4]][2];
<a name="l02859"></a>02859                      a3[1]=R[cells[i][5]][2]-R[cells[i][4]][2];
<a name="l02860"></a>02860                      a3[2]=R[cells[i][0]][2]-R[cells[i][4]][2];
<a name="l02861"></a>02861                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02862"></a>02862                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02863"></a>02863                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02864"></a>02864                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02865"></a>02865                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02866"></a>02866                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02867"></a>02867                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02868"></a>02868                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02869"></a>02869                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02870"></a>02870                           <span class="comment">//write to file</span>
<a name="l02871"></a>02871                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02872"></a>02872                           <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02873"></a>02873                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02874"></a>02874                           Ncells++;
<a name="l02875"></a>02875                      a1[0]=R[cells[i][4]][0]-R[cells[i][5]][0];
<a name="l02876"></a>02876                      a1[1]=R[cells[i][7]][0]-R[cells[i][5]][0];
<a name="l02877"></a>02877                      a1[2]=R[cells[i][1]][0]-R[cells[i][5]][0];
<a name="l02878"></a>02878                      a2[0]=R[cells[i][4]][1]-R[cells[i][5]][1];
<a name="l02879"></a>02879                      a2[1]=R[cells[i][7]][1]-R[cells[i][5]][1];
<a name="l02880"></a>02880                      a2[2]=R[cells[i][1]][1]-R[cells[i][5]][1];
<a name="l02881"></a>02881                      a3[0]=R[cells[i][4]][2]-R[cells[i][5]][2];
<a name="l02882"></a>02882                      a3[1]=R[cells[i][7]][2]-R[cells[i][5]][2];
<a name="l02883"></a>02883                      a3[2]=R[cells[i][1]][2]-R[cells[i][5]][2];
<a name="l02884"></a>02884                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02885"></a>02885                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02886"></a>02886                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02887"></a>02887                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02888"></a>02888                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02889"></a>02889                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02890"></a>02890                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02891"></a>02891                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02892"></a>02892                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02893"></a>02893                           <span class="comment">//write to file</span>
<a name="l02894"></a>02894                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02895"></a>02895                           <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02896"></a>02896                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02897"></a>02897                           Ncells++;
<a name="l02898"></a>02898                      a1[0]=R[cells[i][5]][0]-R[cells[i][7]][0];
<a name="l02899"></a>02899                      a1[1]=R[cells[i][6]][0]-R[cells[i][7]][0];
<a name="l02900"></a>02900                      a1[2]=R[cells[i][3]][0]-R[cells[i][7]][0];
<a name="l02901"></a>02901                      a2[0]=R[cells[i][5]][1]-R[cells[i][7]][1];
<a name="l02902"></a>02902                      a2[1]=R[cells[i][6]][1]-R[cells[i][7]][1];
<a name="l02903"></a>02903                      a2[2]=R[cells[i][3]][1]-R[cells[i][7]][1];
<a name="l02904"></a>02904                      a3[0]=R[cells[i][5]][2]-R[cells[i][7]][2];
<a name="l02905"></a>02905                      a3[1]=R[cells[i][6]][2]-R[cells[i][7]][2];
<a name="l02906"></a>02906                      a3[2]=R[cells[i][3]][2]-R[cells[i][7]][2];
<a name="l02907"></a>02907                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02908"></a>02908                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02909"></a>02909                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02910"></a>02910                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02911"></a>02911                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02912"></a>02912                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02913"></a>02913                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02914"></a>02914                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02915"></a>02915                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02916"></a>02916                           <span class="comment">//write to file</span>
<a name="l02917"></a>02917                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02918"></a>02918               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02919"></a>02919                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02920"></a>02920                           Ncells++;
<a name="l02921"></a>02921                      a1[0]=R[cells[i][6]][0]-R[cells[i][6]][0];
<a name="l02922"></a>02922                      a1[1]=R[cells[i][4]][0]-R[cells[i][6]][0];
<a name="l02923"></a>02923                      a1[2]=R[cells[i][2]][0]-R[cells[i][6]][0];
<a name="l02924"></a>02924                      a2[0]=R[cells[i][6]][1]-R[cells[i][6]][1];
<a name="l02925"></a>02925                      a2[1]=R[cells[i][4]][1]-R[cells[i][6]][1];
<a name="l02926"></a>02926                      a2[2]=R[cells[i][2]][1]-R[cells[i][6]][1];
<a name="l02927"></a>02927                      a3[0]=R[cells[i][6]][2]-R[cells[i][6]][2];
<a name="l02928"></a>02928                      a3[1]=R[cells[i][4]][2]-R[cells[i][6]][2];
<a name="l02929"></a>02929                      a3[2]=R[cells[i][2]][2]-R[cells[i][6]][2];
<a name="l02930"></a>02930                      det=<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(a1[0],a1[1],a1[2],a2[0],a2[1],a2[2],a3[0],a3[1],a3[2]);
<a name="l02931"></a>02931                      g1=sqrt(a1[0]*a1[0]+a2[0]*a2[0]+a3[0]*a3[0]);
<a name="l02932"></a>02932                           g2=sqrt(a1[1]*a1[1]+a2[1]*a2[1]+a3[1]*a3[1]);
<a name="l02933"></a>02933                           g3=sqrt(a1[2]*a1[2]+a2[2]*a2[2]+a3[2]*a3[2]);
<a name="l02934"></a>02934                           <span class="comment">//need to keep data from previous cell</span>
<a name="l02935"></a>02935                           <span class="keywordflow">if</span>((fabs(det)&lt;eps*eps*eps*det_o)||(det&lt;0)) det=det_o;
<a name="l02936"></a>02936                           <span class="keywordflow">if</span>((fabs(g1)&lt;eps*g1_o)||(g1&lt;0)) g1=g1_o;
<a name="l02937"></a>02937                           <span class="keywordflow">if</span>((fabs(g2)&lt;eps*g2_o)||(g2&lt;0)) g2=g2_o;
<a name="l02938"></a>02938                           <span class="keywordflow">if</span>((fabs(g3)&lt;eps*g3_o)||(g3&lt;0)) g3=g3_o;
<a name="l02939"></a>02939                           <span class="comment">//write to file</span>
<a name="l02940"></a>02940                           <span class="keywordflow">if</span>(me==2) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5*sqrt(3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0),0.5/(sqrt(3.0)*<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0)),sqrt(2/3.0)/<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">pow</a>(det,1.0/3.0));
<a name="l02941"></a>02941               <span class="keywordflow">if</span>(me==3) fprintf(stream,<span class="stringliteral">&quot;%e %e %e\n0.000000e+00 %e %e\n  0.000000e+00 0.000000e+00 %e\n&quot;</span>,1.0/g1,0.5/g2,0.5/g3,0.5*sqrt(3.0)/g2,0.5/(sqrt(3.0)*g3),sqrt(2/3.0)/g3);
<a name="l02942"></a>02942                           det_o=det; g1_o=g1; g2_o=g2; g3_o=g3;
<a name="l02943"></a>02943                           Ncells++;
<a name="l02944"></a>02944                   }
<a name="l02945"></a>02945           }
<a name="l02946"></a>02946   }
<a name="l02947"></a>02947   fclose(stream);
<a name="l02948"></a>02948 
<a name="l02949"></a>02949   <span class="keywordflow">for</span>(i=0;i&lt;n;i++) free(Q[i]);
<a name="l02950"></a>02950   free(Q);
<a name="l02951"></a>02951 
<a name="l02952"></a>02952   <span class="comment">//write new grid connectivity</span>
<a name="l02953"></a>02953   grid[0]=grid[1]; grid[2]=grid[3];
<a name="l02954"></a>02954 
<a name="l02955"></a>02955   stream=fopen(grid,<span class="stringliteral">&quot;w+&quot;</span>);
<a name="l02956"></a>02956   fprintf(stream,<span class="stringliteral">&quot;%d \n%d \n%d \n0 \n&quot;</span>,n,N,Ncells);
<a name="l02957"></a>02957 
<a name="l02958"></a>02958   <span class="keywordflow">for</span>(i=0;i&lt;N;i++){<span class="comment">//node coordinates</span>
<a name="l02959"></a>02959         <span class="keywordflow">for</span>(j=0;j&lt;n;j++) fprintf(stream,<span class="stringliteral">&quot;%e &quot;</span>,R[i][j]);
<a name="l02960"></a>02960         fprintf(stream,<span class="stringliteral">&quot;%d \n&quot;</span>,mask[i]);
<a name="l02961"></a>02961   }
<a name="l02962"></a>02962   <span class="keywordflow">for</span>(i=0;i&lt;N;i++) free(R[i]);
<a name="l02963"></a>02963   free(R);
<a name="l02964"></a>02964   free(mask);
<a name="l02965"></a>02965 
<a name="l02966"></a>02966   <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) if(mcells[i]&gt;=0){<span class="comment">//cell connectivity</span>
<a name="l02967"></a>02967         nvert=0; <span class="keywordflow">while</span>(cells[i][nvert]&gt;=0) nvert++;
<a name="l02968"></a>02968         <span class="keywordflow">if</span>((nvert==3)||((n==3)&amp;&amp;(nvert==4))){<span class="comment">//tri &amp; tetr</span>
<a name="l02969"></a>02969                 <span class="keywordflow">for</span>(j=0;j&lt;nvert;j++) fprintf(stream,<span class="stringliteral">&quot;%d &quot;</span>,cells[i][j]);
<a name="l02970"></a>02970                 <span class="keywordflow">for</span>(j=nvert;j&lt;3*n+n%2;j++) fprintf(stream,<span class="stringliteral">&quot;-1 &quot;</span>);
<a name="l02971"></a>02971             fprintf(stream,<span class="stringliteral">&quot;%d \n&quot;</span>,mcells[i]);
<a name="l02972"></a>02972         }
<a name="l02973"></a>02973         <span class="keywordflow">if</span>((n==2)&amp;&amp;(nvert==4)){<span class="comment">//quad</span>
<a name="l02974"></a>02974                 fprintf(stream,<span class="stringliteral">&quot;%d %d %d -1 -1 -1 0\n&quot;</span>,cells[i][0],cells[i][1],cells[i][2]);
<a name="l02975"></a>02975         fprintf(stream,<span class="stringliteral">&quot;%d %d %d -1 -1 -1 0\n&quot;</span>,cells[i][1],cells[i][3],cells[i][0]);
<a name="l02976"></a>02976         fprintf(stream,<span class="stringliteral">&quot;%d %d %d -1 -1 -1 0\n&quot;</span>,cells[i][3],cells[i][2],cells[i][1]);
<a name="l02977"></a>02977         fprintf(stream,<span class="stringliteral">&quot;%d %d %d -1 -1 -1 0\n&quot;</span>,cells[i][2],cells[i][0],cells[i][3]);
<a name="l02978"></a>02978         }
<a name="l02979"></a>02979         <span class="keywordflow">if</span>(nvert==8){<span class="comment">//hex</span>
<a name="l02980"></a>02980                 fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][0],cells[i][1],cells[i][2],cells[i][4]);
<a name="l02981"></a>02981         fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][1],cells[i][3],cells[i][0],cells[i][5]);
<a name="l02982"></a>02982         fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][3],cells[i][2],cells[i][1],cells[i][7]);
<a name="l02983"></a>02983         fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][2],cells[i][0],cells[i][3],cells[i][6]);
<a name="l02984"></a>02984                 fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][4],cells[i][6],cells[i][5],cells[i][0]);
<a name="l02985"></a>02985         fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][5],cells[i][4],cells[i][7],cells[i][1]);
<a name="l02986"></a>02986         fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][7],cells[i][5],cells[i][6],cells[i][3]);
<a name="l02987"></a>02987         fprintf(stream,<span class="stringliteral">&quot;%d %d %d %d -1 -1 -1 -1 -1 -1 0\n&quot;</span>,cells[i][6],cells[i][7],cells[i][4],cells[i][2]);
<a name="l02988"></a>02988         }
<a name="l02989"></a>02989   }
<a name="l02990"></a>02990 
<a name="l02991"></a>02991 
<a name="l02992"></a>02992  fclose(stream);
<a name="l02993"></a>02993 
<a name="l02994"></a>02994  <span class="keywordflow">for</span>(i=0;i&lt;ncells;i++) free(cells[i]);
<a name="l02995"></a>02995  free(cells);
<a name="l02996"></a>02996  free(mcells);
<a name="l02997"></a>02997 
<a name="l02998"></a>02998 <span class="keywordflow">return</span>;
<a name="l02999"></a>02999 }
<a name="l03000"></a>03000 
<a name="l03001"></a>03001 } <span class="comment">// namespace libMesh</span>
<a name="l03002"></a>03002 
<a name="l03003"></a>03003 <span class="preprocessor">#endif // LIBMESH_ENABLE_VSMOOTHER</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
