<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel.h</div>  </div>
</div>
<div class="contents">
<a href="parallel_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel.h 4380 2011-04-20 22:02:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span> <span class="comment">// for libmesh_assert</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Macro to identify and debug functions which should only be called in</span>
<a name="l00039"></a>00039 <span class="comment">// parallel on every processor at once</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#undef parallel_only</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">  #define parallel_only() do { \</span>
<a name="l00044"></a>00044 <span class="preprocessor">    libmesh_assert(Parallel::verify(std::string(__FILE__).size())); \</span>
<a name="l00045"></a>00045 <span class="preprocessor">    libmesh_assert(Parallel::verify(std::string(__FILE__))); \</span>
<a name="l00046"></a>00046 <span class="preprocessor">    libmesh_assert(Parallel::verify(__LINE__)); } while (0)</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">  #define parallel_only()</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="comment">// Macro to identify and debug functions which should only be called in</span>
<a name="l00052"></a>00052 <span class="comment">// parallel on every processor at once</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="preprocessor">#undef parallel_only_on</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">  #define parallel_only_on(comm_arg) do { \</span>
<a name="l00057"></a>00057 <span class="preprocessor">    libmesh_assert(Parallel::verify(std::string(__FILE__).size(), comm_arg)); \</span>
<a name="l00058"></a>00058 <span class="preprocessor">    libmesh_assert(Parallel::verify(std::string(__FILE__), comm_arg)); \</span>
<a name="l00059"></a>00059 <span class="preprocessor">    libmesh_assert(Parallel::verify(__LINE__), comm_arg); } while (0)</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">  #define parallel_only_on(comm_arg)</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>
<a name="l00071"></a>00071 <span class="keyword">namespace </span>Parallel
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00077"></a>00077 <span class="comment"></span>  <span class="keyword">class </span>Communicator;
<a name="l00078"></a>00078   <span class="keyword">class </span>DataType;
<a name="l00079"></a>00079   <span class="keyword">class </span>Request;
<a name="l00080"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ad746570bb06f6070f3daf58cfc3cb77f">00080</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a>;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00087"></a>00087 <span class="comment"></span>  <span class="keyword">typedef</span> MPI_Datatype <a class="code" href="namespacelibMesh_1_1Parallel.php#ad746570bb06f6070f3daf58cfc3cb77f">data_type</a>;
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">00092</a>   <span class="keyword">typedef</span> MPI_Request <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">request</a>;
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">00097</a>   <span class="keyword">typedef</span> MPI_Status <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#acc030b7d402af26d39698e86b30987fe">00102</a>   <span class="keyword">typedef</span> MPI_Comm <a class="code" href="namespacelibMesh_1_1Parallel.php#acc030b7d402af26d39698e86b30987fe">communicator</a>;
<a name="l00103"></a>00103  
<a name="l00108"></a>00108   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00109"></a>00109   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ac96db2a61d200c9099d14dda860cf230">datatype</a>();
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00116"></a>00116   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a7ff11a5279b90bb0c2df44eee775ddae">dataplusint_type</a>();
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00122"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">00122</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt</a>
<a name="l00123"></a>00123   {
<a name="l00124"></a>00124     <span class="keyword">public</span>:
<a name="l00125"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">00125</a>       T <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a>;
<a name="l00126"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">00126</a>       <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a>;
<a name="l00127"></a>00127   };
<a name="l00128"></a>00128 
<a name="l00132"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">00132</a>   <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">any_source</a>=MPI_ANY_SOURCE;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   
<a name="l00135"></a>00135 <span class="preprocessor">#else</span>
<a name="l00136"></a>00136 <span class="preprocessor"></span>
<a name="l00137"></a>00137   <span class="comment">// These shouldn&#39;t actually be needed, but must be </span>
<a name="l00138"></a>00138   <span class="comment">// unique types for function overloading to work </span>
<a name="l00139"></a>00139   <span class="comment">// properly.</span>
<a name="l00140"></a><a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">00140</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a>    { <span class="comment">/* unsigned int t; */</span> };
<a name="l00141"></a><a class="code" href="structlibMesh_1_1Parallel_1_1request.php">00141</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a>      { <span class="comment">/* unsigned int r; */</span> };
<a name="l00142"></a><a class="code" href="structlibMesh_1_1Parallel_1_1status.php">00142</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>       { <span class="comment">/* unsigned int s; */</span> };
<a name="l00143"></a><a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">00143</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a> { <span class="comment">/* unsigned int s; */</span> };
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00146"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ac96db2a61d200c9099d14dda860cf230">00146</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ac96db2a61d200c9099d14dda860cf230">datatype</a>() { <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad746570bb06f6070f3daf58cfc3cb77f">data_type</a>(); }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">any_source</a>=0;
<a name="l00149"></a>00149 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00157"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">00157</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>
<a name="l00158"></a>00158   {
<a name="l00159"></a>00159   <span class="keyword">public</span>:
<a name="l00164"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a9a6004f0fc09c12fccbddc9a013e0c01">00164</a>     <span class="keyword">explicit</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a9a6004f0fc09c12fccbddc9a013e0c01">MessageTag</a>(<span class="keywordtype">int</span> tagvalue)
<a name="l00165"></a>00165       : <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">_tagvalue</a>(tagvalue), <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>(NULL) {}
<a name="l00166"></a>00166 
<a name="l00171"></a>00171     <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a9a6004f0fc09c12fccbddc9a013e0c01">MessageTag</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>&amp; other);
<a name="l00172"></a>00172 
<a name="l00177"></a>00177     <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a60ba578604d31e1e998b3bf864482191">~MessageTag</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">00179</a>     <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">value</a>()<span class="keyword"> const </span>{
<a name="l00180"></a>00180       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">_tagvalue</a>;
<a name="l00181"></a>00181     }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keyword">private</span>:
<a name="l00184"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">00184</a>     <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">_tagvalue</a>;
<a name="l00185"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">00185</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> *<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     <span class="comment">// Constructor for reference-counted unique tags</span>
<a name="l00188"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#aa75aaf352d5ff700ece7507ef6227aef">00188</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a9a6004f0fc09c12fccbddc9a013e0c01">MessageTag</a>(<span class="keywordtype">int</span> tagvalue, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> *comm)
<a name="l00189"></a>00189       : <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">_tagvalue</a>(tagvalue), <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>(comm) {}
<a name="l00190"></a>00190 
<a name="l00191"></a>00191     <span class="comment">// Let Communicator handle the reference counting</span>
<a name="l00192"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#ade690b78412fb1a6414ce3a7a81bfa32">00192</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a>;
<a name="l00193"></a>00193   };
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00200"></a>00200 <span class="comment"></span><span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00201"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">00201</a> <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a> = <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>(MPI_ANY_TAG);
<a name="l00202"></a>00202 <span class="preprocessor">#else</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a> = <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>(-1);
<a name="l00204"></a>00204 <span class="preprocessor">#endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>
<a name="l00206"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">00206</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a> = <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>(0);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00213"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">00213</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a>
<a name="l00214"></a>00214   {
<a name="l00215"></a>00215   <span class="keyword">public</span>:
<a name="l00216"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1867beb95ed532207b89fd6e30cce48a">00216</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1867beb95ed532207b89fd6e30cce48a">DataType</a> () : <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>() {}
<a name="l00217"></a>00217 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a7ea0c8d744b9bbdb0d650238587b2721">00218</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1867beb95ed532207b89fd6e30cce48a">DataType</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;other) :
<a name="l00219"></a>00219       <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>(other.<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>)
<a name="l00220"></a>00220     {}
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a2ecb6377255eebcf6ef6b1113fa2b90e">00222</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1867beb95ed532207b89fd6e30cce48a">DataType</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;type) :
<a name="l00223"></a>00223       <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>(type)
<a name="l00224"></a>00224     {}
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a0f545f594635582e0e2262edd5284389">00226</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp; <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a0f545f594635582e0e2262edd5284389">operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;other) 
<a name="l00227"></a>00227     { <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a> = other.<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#aa7edda6a7fdbc1aced72001788999422">00229</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp; <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a0f545f594635582e0e2262edd5284389">operator = </a>(<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;type)
<a name="l00230"></a>00230     { <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a> = type; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00231"></a>00231 
<a name="l00232"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#ae140465431b1b0001446a9d97bb31948">00232</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#ae140465431b1b0001446a9d97bb31948">operator const data_type &amp; </a>()<span class="keyword"> const</span>
<a name="l00233"></a>00233 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>; }
<a name="l00234"></a>00234 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1be32ec210d79fb1a65284b9217b6442">00235</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1be32ec210d79fb1a65284b9217b6442">operator data_type &amp; </a>()
<a name="l00236"></a>00236     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>; }
<a name="l00237"></a>00237     
<a name="l00238"></a>00238 <span class="comment">//     operator data_type const * () const</span>
<a name="l00239"></a>00239 <span class="comment">//     { return &amp;_datatype; }</span>
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="comment">//     operator data_type * ()</span>
<a name="l00242"></a>00242 <span class="comment">//     { return &amp;_datatype; }</span>
<a name="l00243"></a>00243 
<a name="l00244"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#ad851f9206f34f41a4b71426a3b642928">00244</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#ad851f9206f34f41a4b71426a3b642928">commit</a> ()
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span>      MPI_Type_commit (&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>);
<a name="l00248"></a>00248 <span class="preprocessor">#endif</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>    }
<a name="l00250"></a>00250 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a946f066948fc0ca306e7fc4025cef311">00251</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a946f066948fc0ca306e7fc4025cef311">free</a> ()
<a name="l00252"></a>00252     {
<a name="l00253"></a>00253 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>      MPI_Type_free (&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>);
<a name="l00255"></a>00255 <span class="preprocessor">#endif</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>    }
<a name="l00257"></a>00257     
<a name="l00258"></a>00258   <span class="keyword">private</span>:
<a name="l00259"></a>00259 
<a name="l00260"></a><a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">00260</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php#a1a45a289504e6b235e693a41fb7245d2">_datatype</a>;    
<a name="l00261"></a>00261   };
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00270"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">00270</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a>
<a name="l00271"></a>00271   {
<a name="l00272"></a>00272   <span class="keyword">public</span>:
<a name="l00273"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a697f8e599333609a45761828e14659c1">00273</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a697f8e599333609a45761828e14659c1">Communicator</a> () :
<a name="l00274"></a>00274 #ifdef LIBMESH_HAVE_MPI
<a name="l00275"></a>00275       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>(MPI_COMM_NULL),
<a name="l00276"></a>00276       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>(0),
<a name="l00277"></a>00277       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>(0),
<a name="l00278"></a>00278 #else
<a name="l00279"></a>00279       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>(0), 
<a name="l00280"></a>00280       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>(1), 
<a name="l00281"></a>00281 #endif
<a name="l00282"></a>00282       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>(),
<a name="l00283"></a>00283       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a>(false) {}
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     <span class="comment">/*</span>
<a name="l00286"></a>00286 <span class="comment">     * Constructor from MPI_Comm</span>
<a name="l00287"></a>00287 <span class="comment">     */</span>
<a name="l00288"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a69ad540a5c65c53b6936a1c6e064872d">00288</a>     <span class="keyword">explicit</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a697f8e599333609a45761828e14659c1">Communicator</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a> &amp;comm) : 
<a name="l00289"></a>00289 #ifdef LIBMESH_HAVE_MPI
<a name="l00290"></a>00290       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>(MPI_COMM_NULL),
<a name="l00291"></a>00291       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>(0),
<a name="l00292"></a>00292       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>(0),
<a name="l00293"></a>00293 #else
<a name="l00294"></a>00294       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>(0), 
<a name="l00295"></a>00295       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>(1), 
<a name="l00296"></a>00296 #endif
<a name="l00297"></a>00297       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>(),
<a name="l00298"></a>00298       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a>(false)
<a name="l00299"></a>00299     {
<a name="l00300"></a>00300       this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a1ec219683d6176b35ca148591e479285">assign</a>(comm);
<a name="l00301"></a>00301     }
<a name="l00302"></a>00302 
<a name="l00303"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a0c2660ebeda715ca47187e9799170ec1">00303</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a0c2660ebeda715ca47187e9799170ec1">~Communicator</a> () {
<a name="l00304"></a>00304       this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ad5efc36368344565c33efe98e974e7d9">clear</a>();
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307     <span class="comment">/*</span>
<a name="l00308"></a>00308 <span class="comment">     * Create a new communicator between some subset of \p this</span>
<a name="l00309"></a>00309 <span class="comment">     */</span>
<a name="l00310"></a>00310 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00311"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ada7026cf6cf928c70ec597edfb82b522">00311</a> <span class="preprocessor"></span>    <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ada7026cf6cf928c70ec597edfb82b522">split</a>(<span class="keywordtype">int</span> color, <span class="keywordtype">int</span> key, <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;target) {
<a name="l00312"></a>00312       MPI_Comm_split(this-&gt;<span class="keyword">get</span>(), color, key, &amp;target.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l00313"></a>00313     }
<a name="l00314"></a>00314 <span class="preprocessor">#else</span>
<a name="l00315"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab6380aa73716a2e57e076c69b35a6c05">00315</a> <span class="preprocessor"></span>    <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab6380aa73716a2e57e076c69b35a6c05">split</a>(<span class="keywordtype">int</span>, <span class="keywordtype">int</span>, <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;target) {
<a name="l00316"></a>00316       target.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a1ec219683d6176b35ca148591e479285">assign</a>(this-&gt;<span class="keyword">get</span>());
<a name="l00317"></a>00317     }
<a name="l00318"></a>00318 <span class="preprocessor">#endif</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>
<a name="l00320"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4ec832b6e2e70f65bd8cffe289a6d229">00320</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4ec832b6e2e70f65bd8cffe289a6d229">duplicate</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm) {
<a name="l00321"></a>00321       this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4ec832b6e2e70f65bd8cffe289a6d229">duplicate</a>(comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>);
<a name="l00322"></a>00322     }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00325"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a5cd52cf75f651344c0c460d2f9ee382f">00325</a> <span class="preprocessor"></span>    <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a5cd52cf75f651344c0c460d2f9ee382f">duplicate</a>(<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a> &amp;comm) {
<a name="l00326"></a>00326       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a> != MPI_COMM_NULL) 
<a name="l00327"></a>00327         {
<a name="l00328"></a>00328           MPI_Comm_dup(comm, &amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>);
<a name="l00329"></a>00329           <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a> = <span class="keyword">true</span>;
<a name="l00330"></a>00330         }
<a name="l00331"></a>00331       this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a1ec219683d6176b35ca148591e479285">assign</a>(<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>);
<a name="l00332"></a>00332     }
<a name="l00333"></a>00333 <span class="preprocessor">#else</span>
<a name="l00334"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ad378a279cb2e93ba6692c2514ad435e9">00334</a> <span class="preprocessor"></span>    <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ad378a279cb2e93ba6692c2514ad435e9">duplicate</a>(<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a> &amp;) {
<a name="l00335"></a>00335     }
<a name="l00336"></a>00336 <span class="preprocessor">#endif</span>
<a name="l00337"></a>00337 <span class="preprocessor"></span>
<a name="l00338"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">00338</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a>&amp; <span class="keyword">get</span>() {
<a name="l00339"></a>00339       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>;
<a name="l00340"></a>00340     }
<a name="l00341"></a>00341 
<a name="l00342"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#afa2c10ecfd3cdec63ea4e6cb4f372e9e">00342</a>     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a>&amp; <span class="keyword">get</span>() <span class="keyword">const</span> {
<a name="l00343"></a>00343       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>;
<a name="l00344"></a>00344     }
<a name="l00345"></a>00345 
<a name="l00352"></a>00352     <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a148450d5fa1ed4b60f3c1efc0e7bf83e">get_unique_tag</a>(<span class="keywordtype">int</span> tagvalue) <span class="keyword">const</span>;
<a name="l00353"></a>00353 
<a name="l00358"></a>00358     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac2b5426b53a768b0825fa146b1f8ec22">reference_unique_tag</a>(<span class="keywordtype">int</span> tagvalue) <span class="keyword">const</span>;
<a name="l00359"></a>00359 
<a name="l00364"></a>00364     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3274f8f1295853e4d542d48911848461">dereference_unique_tag</a>(<span class="keywordtype">int</span> tagvalue) <span class="keyword">const</span>;
<a name="l00365"></a>00365 
<a name="l00366"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ad5efc36368344565c33efe98e974e7d9">00366</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ad5efc36368344565c33efe98e974e7d9">clear</a>() {
<a name="l00367"></a>00367 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00368"></a>00368 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a>)
<a name="l00369"></a>00369         {
<a name="l00370"></a>00370           libmesh_assert(<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a> != MPI_COMM_NULL);
<a name="l00371"></a>00371           MPI_Comm_free(&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>);
<a name="l00372"></a>00372           <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a> = MPI_COMM_NULL;
<a name="l00373"></a>00373         }
<a name="l00374"></a>00374       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a> = <span class="keyword">false</span>;
<a name="l00375"></a>00375 <span class="preprocessor">#endif</span>
<a name="l00376"></a>00376 <span class="preprocessor"></span>    }
<a name="l00377"></a>00377 
<a name="l00378"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ae4940ec8ab661dde9d55b5070a8d828a">00378</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a>&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ae4940ec8ab661dde9d55b5070a8d828a">operator= </a>(<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a> &amp;comm) {
<a name="l00379"></a>00379       this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ad5efc36368344565c33efe98e974e7d9">clear</a>();
<a name="l00380"></a>00380       this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a1ec219683d6176b35ca148591e479285">assign</a>(comm);
<a name="l00381"></a>00381       <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00382"></a>00382     }
<a name="l00383"></a>00383 
<a name="l00384"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">00384</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>()<span class="keyword"> const </span>{
<a name="l00385"></a>00385       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>;
<a name="l00386"></a>00386     }
<a name="l00387"></a>00387 
<a name="l00388"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">00388</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>()<span class="keyword"> const </span>{
<a name="l00389"></a>00389       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>;
<a name="l00390"></a>00390     }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="keyword">private</span>:
<a name="l00393"></a>00393 
<a name="l00394"></a>00394     <span class="comment">// Don&#39;t use the copy constructor, just copy by reference or</span>
<a name="l00395"></a>00395     <span class="comment">// pointer - it&#39;s too hard to keep a common used_tag_values if</span>
<a name="l00396"></a>00396     <span class="comment">// each communicator is shared by more than one Communicator</span>
<a name="l00397"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#aa54a3697e0be1c84251d2bb3c52fc0bf">00397</a>     <span class="keyword">explicit</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a697f8e599333609a45761828e14659c1">Communicator</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;) :
<a name="l00398"></a>00398 #ifdef LIBMESH_HAVE_MPI
<a name="l00399"></a>00399       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>(MPI_COMM_NULL),
<a name="l00400"></a>00400       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>(0),
<a name="l00401"></a>00401       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>(0),
<a name="l00402"></a>00402 #else
<a name="l00403"></a>00403       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>(0), 
<a name="l00404"></a>00404       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>(1), 
<a name="l00405"></a>00405 #endif
<a name="l00406"></a>00406       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>(),
<a name="l00407"></a>00407       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a>(false)
<a name="l00408"></a>00408     {
<a name="l00409"></a>00409       libmesh_error();
<a name="l00410"></a>00410     }
<a name="l00411"></a>00411 
<a name="l00412"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a1ec219683d6176b35ca148591e479285">00412</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a1ec219683d6176b35ca148591e479285">assign</a>(<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a> &amp;comm) {
<a name="l00413"></a>00413       <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a> = comm;
<a name="l00414"></a>00414 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00415"></a>00415 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a> != MPI_COMM_NULL)
<a name="l00416"></a>00416         {
<a name="l00417"></a>00417           <span class="keywordtype">int</span> i;
<a name="l00418"></a>00418           MPI_Comm_size(<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>, &amp;i);
<a name="l00419"></a>00419           libmesh_assert (i &gt;= 0);
<a name="l00420"></a>00420           <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(i);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422           MPI_Comm_rank(<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>, &amp;i);
<a name="l00423"></a>00423           libmesh_assert (i &gt;= 0);
<a name="l00424"></a>00424           <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(i);
<a name="l00425"></a>00425         }
<a name="l00426"></a>00426       <span class="keywordflow">else</span>
<a name="l00427"></a>00427         {
<a name="l00428"></a>00428           <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a> = 0;
<a name="l00429"></a>00429           <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a> = 0;
<a name="l00430"></a>00430         }
<a name="l00431"></a>00431 <span class="preprocessor">#endif</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>    }
<a name="l00433"></a>00433 
<a name="l00434"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">00434</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1communicator.php">communicator</a>  <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac689cad2dd7fee804733524bf0a79592">_communicator</a>;
<a name="l00435"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">00435</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7907ef269a73c8f5c769a460a5459d6">_rank</a>, <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4e7a3b5f82561e127662517e93b460b4">_size</a>;
<a name="l00436"></a>00436 
<a name="l00437"></a>00437     <span class="comment">// mutable used_tag_values - not thread-safe, but then Parallel::</span>
<a name="l00438"></a>00438     <span class="comment">// isn&#39;t thread-safe in general.</span>
<a name="l00439"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">00439</a>     <span class="keyword">mutable</span> std::map&lt;int, unsigned int&gt; <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>;
<a name="l00440"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">00440</a>     <span class="keywordtype">bool</span>          <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a96077bfe9a046ad4a4b21460a3c69958">_I_duped_it</a>;
<a name="l00441"></a>00441   };
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00450"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">00450</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a>
<a name="l00451"></a>00451   {
<a name="l00452"></a>00452   <span class="keyword">public</span>:
<a name="l00453"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">00453</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">Status</a> () :
<a name="l00454"></a>00454       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>(),
<a name="l00455"></a>00455       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>()           
<a name="l00456"></a>00456     {}
<a name="l00457"></a>00457     
<a name="l00458"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aa632466c3b03f8c906907cf4400ac0a1">00458</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">Status</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;type) :
<a name="l00459"></a>00459       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>(),
<a name="l00460"></a>00460       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>(type)           
<a name="l00461"></a>00461     {}
<a name="l00462"></a>00462 
<a name="l00463"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a316312c7220f6915d10907c751b94d2f">00463</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">Status</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> &amp;<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>) :
<a name="l00464"></a>00464       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>(status),
<a name="l00465"></a>00465       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>()           
<a name="l00466"></a>00466     {}
<a name="l00467"></a>00467 
<a name="l00468"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aa5f92d83528727ef49909bfc96003233">00468</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">Status</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>    &amp;<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>,
<a name="l00469"></a>00469             <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;type) :
<a name="l00470"></a>00470       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>(status),
<a name="l00471"></a>00471       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>(type)           
<a name="l00472"></a>00472     {}
<a name="l00473"></a>00473 
<a name="l00474"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a2681a430f2f7ce0694a21f377053a1f2">00474</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">Status</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> &amp;<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>) :
<a name="l00475"></a>00475       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>(status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>),
<a name="l00476"></a>00476       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>(status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>)
<a name="l00477"></a>00477     {}
<a name="l00478"></a>00478 
<a name="l00479"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#ae9d96a693b3b7914a9d2f9ad3b7fe241">00479</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a7005e9350d405f3655f4718e480865cc">Status</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a>    &amp;<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>,
<a name="l00480"></a>00480             <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;type) :
<a name="l00481"></a>00481       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>(status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>),
<a name="l00482"></a>00482       <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>(type)
<a name="l00483"></a>00483     {}
<a name="l00484"></a>00484     
<a name="l00485"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a12f30af2bd1275a08bce82681f802e7e">00485</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a12f30af2bd1275a08bce82681f802e7e">operator status * </a>() 
<a name="l00486"></a>00486     { <span class="keywordflow">return</span> &amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>; }
<a name="l00487"></a>00487 
<a name="l00488"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#acf75ca0cb897035dadf560a20738927e">00488</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#acf75ca0cb897035dadf560a20738927e">operator status const * </a>()<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword">    </span>{ <span class="keywordflow">return</span> &amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>; }
<a name="l00490"></a>00490     
<a name="l00491"></a>00491 <span class="comment">//     operator status &amp; ()</span>
<a name="l00492"></a>00492 <span class="comment">//     { return _status; }</span>
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 <span class="comment">//     operator const status &amp; () const</span>
<a name="l00495"></a>00495 <span class="comment">//     { return _status; }</span>
<a name="l00496"></a>00496 
<a name="l00497"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aee8318932e11f49d49ad6f65768a629c">00497</a>     <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aee8318932e11f49d49ad6f65768a629c">source</a> ()<span class="keyword"> const</span>
<a name="l00498"></a>00498 <span class="keyword">    </span>{
<a name="l00499"></a>00499 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI </span>
<a name="l00500"></a>00500 <span class="preprocessor"></span>      <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>.MPI_SOURCE; 
<a name="l00501"></a>00501 <span class="preprocessor">#else</span>
<a name="l00502"></a>00502 <span class="preprocessor"></span>      <span class="keywordflow">return</span> 0;
<a name="l00503"></a>00503 <span class="preprocessor">#endif</span>
<a name="l00504"></a>00504 <span class="preprocessor"></span>    }    
<a name="l00505"></a>00505 
<a name="l00506"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a281d452b811ca66db848035c9f50e419">00506</a>     <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a281d452b811ca66db848035c9f50e419">tag</a> ()<span class="keyword"> const</span>
<a name="l00507"></a>00507 <span class="keyword">    </span>{
<a name="l00508"></a>00508 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI </span>
<a name="l00509"></a>00509 <span class="preprocessor"></span>      <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>.MPI_TAG; 
<a name="l00510"></a>00510 <span class="preprocessor">#else</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>      libmesh_error();
<a name="l00512"></a>00512       <span class="keywordflow">return</span> 0;
<a name="l00513"></a>00513 <span class="preprocessor">#endif</span>
<a name="l00514"></a>00514 <span class="preprocessor"></span>    }
<a name="l00515"></a>00515 
<a name="l00516"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a70c0acb3f40771031709a4c03e365664">00516</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a>&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a70c0acb3f40771031709a4c03e365664">datatype</a> () 
<a name="l00517"></a>00517     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>; }
<a name="l00518"></a>00518 
<a name="l00519"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#ac8d849d887a0e99e66d73bb92a1477c9">00519</a>     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a>&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a70c0acb3f40771031709a4c03e365664">datatype</a> ()<span class="keyword"> const</span>
<a name="l00520"></a>00520 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>; }
<a name="l00521"></a>00521   
<a name="l00522"></a>00522 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00523"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a4d5e449ef6b83498be62ee2a83923a91">00523</a> <span class="preprocessor"></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#af9e875cfba1b5545f940a46dcf60c8d3">size</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;type)<span class="keyword"> const</span>
<a name="l00524"></a>00524 <span class="keyword">    </span>{
<a name="l00525"></a>00525       <span class="keywordtype">int</span> msg_size;
<a name="l00526"></a>00526       MPI_Get_count (const_cast&lt;MPI_Status*&gt;(&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>), type, &amp;msg_size);
<a name="l00527"></a>00527       libmesh_assert (msg_size &gt;= 0);
<a name="l00528"></a>00528       <span class="keywordflow">return</span> msg_size;
<a name="l00529"></a>00529     }
<a name="l00530"></a>00530 <span class="preprocessor">#else</span>
<a name="l00531"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aea4a60b46b4fbb5a10efa89fd392a974">00531</a> <span class="preprocessor"></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#af9e875cfba1b5545f940a46dcf60c8d3">size</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> &amp;)<span class="keyword"> const</span>
<a name="l00532"></a>00532 <span class="keyword">    </span>{
<a name="l00533"></a>00533       libmesh_error();
<a name="l00534"></a>00534       <span class="keywordflow">return</span> 0;
<a name="l00535"></a>00535     }
<a name="l00536"></a>00536 <span class="preprocessor">#endif</span>
<a name="l00537"></a>00537 <span class="preprocessor"></span>
<a name="l00538"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#af9e875cfba1b5545f940a46dcf60c8d3">00538</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#af9e875cfba1b5545f940a46dcf60c8d3">size</a> ()<span class="keyword"> const</span>
<a name="l00539"></a>00539 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#af9e875cfba1b5545f940a46dcf60c8d3">size</a> (this-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a70c0acb3f40771031709a4c03e365664">datatype</a>()); }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541   <span class="keyword">private</span>:
<a name="l00542"></a>00542 
<a name="l00543"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">00543</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>    <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aeeba81cb3921716e64d6b93b790a5bba">_status</a>;
<a name="l00544"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">00544</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a90b41fd5d3b4631bc3c4170f1d4690d2">_datatype</a>;
<a name="l00545"></a>00545   };
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00553"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">00553</a> <span class="comment"></span>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a>
<a name="l00554"></a>00554   {
<a name="l00555"></a>00555   <span class="keyword">public</span>:
<a name="l00556"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#ae892db19114d1a79f6db22771c3cb0ef">00556</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#ae892db19114d1a79f6db22771c3cb0ef">Request</a> () :
<a name="l00557"></a>00557 #ifdef LIBMESH_HAVE_MPI
<a name="l00558"></a>00558       <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>(MPI_REQUEST_NULL)
<a name="l00559"></a>00559 #else
<a name="l00560"></a>00560       <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>()
<a name="l00561"></a>00561 #endif
<a name="l00562"></a>00562     {}
<a name="l00563"></a>00563 
<a name="l00564"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a17c0d0a06b71a5938c1055e411af1b00">00564</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#ae892db19114d1a79f6db22771c3cb0ef">Request</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a> &amp;r) :
<a name="l00565"></a>00565       <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>(r)
<a name="l00566"></a>00566     {}
<a name="l00567"></a>00567 
<a name="l00568"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#af017544bc47ef658b8da0841aaa2bcfa">00568</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#af017544bc47ef658b8da0841aaa2bcfa">operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;other) 
<a name="l00569"></a>00569     { <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a> = other.<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00570"></a>00570 
<a name="l00571"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#ada0380a688e3c1277a3c06ffe9b41837">00571</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#af017544bc47ef658b8da0841aaa2bcfa">operator = </a>(<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a> &amp;r)
<a name="l00572"></a>00572     { <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a> = r; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00573"></a>00573 
<a name="l00574"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aa6440938f811a53ad341911f0d9287ae">00574</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aa6440938f811a53ad341911f0d9287ae">~Request</a> () {}
<a name="l00575"></a>00575 
<a name="l00576"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aacd86704cabd68da6f553cf0dfafacd1">00576</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aacd86704cabd68da6f553cf0dfafacd1">operator const request &amp; </a>()<span class="keyword"> const</span>
<a name="l00577"></a>00577 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>; }
<a name="l00578"></a>00578 
<a name="l00579"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a21a05207800d13afa105e6eab6312f3e">00579</a>     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a21a05207800d13afa105e6eab6312f3e">operator request &amp; </a>() 
<a name="l00580"></a>00580     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>; }
<a name="l00581"></a>00581 
<a name="l00582"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a1c0f2d81c8f7d6148235fb57f4966f2c">00582</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a>* <span class="keyword">get</span>()
<a name="l00583"></a>00583     { <span class="keywordflow">return</span> &amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>; }
<a name="l00584"></a>00584 
<a name="l00585"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a7ca62836ab06d0d3903d057fe24e5b3b">00585</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a7ca62836ab06d0d3903d057fe24e5b3b">free</a> (<span class="keywordtype">void</span>)
<a name="l00586"></a>00586     {
<a name="l00587"></a>00587 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00588"></a>00588 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a> != MPI_REQUEST_NULL)
<a name="l00589"></a>00589         MPI_Request_free (&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>);
<a name="l00590"></a>00590 <span class="preprocessor">#endif</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>    }
<a name="l00592"></a>00592 
<a name="l00593"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0b247161117a685a1c91e5d6dad0923f">00593</a>     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a>* <span class="keyword">get</span>() <span class="keyword">const</span>
<a name="l00594"></a>00594     { <span class="keywordflow">return</span> &amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>; }
<a name="l00595"></a>00595 
<a name="l00596"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a5e0b8d2f885411da292f2f2b527104fa">00596</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a5e0b8d2f885411da292f2f2b527104fa">wait</a> ()
<a name="l00597"></a>00597     {
<a name="l00598"></a>00598       <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l00599"></a>00599 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00600"></a>00600 <span class="preprocessor"></span>      MPI_Wait (&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>, &amp;status);
<a name="l00601"></a>00601 <span class="preprocessor">#endif</span>
<a name="l00602"></a>00602 <span class="preprocessor"></span>      <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l00603"></a>00603     }
<a name="l00604"></a>00604 
<a name="l00605"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aece883361156951908275acfd59bfd81">00605</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aece883361156951908275acfd59bfd81">test</a> ()
<a name="l00606"></a>00606     {
<a name="l00607"></a>00607 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00608"></a>00608 <span class="preprocessor"></span>      <span class="keywordtype">int</span> val=0;
<a name="l00609"></a>00609 
<a name="l00610"></a>00610       MPI_Test (&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>,
<a name="l00611"></a>00611                 &amp;val,
<a name="l00612"></a>00612                 MPI_STATUS_IGNORE);
<a name="l00613"></a>00613       <span class="keywordflow">if</span> (val)
<a name="l00614"></a>00614         {
<a name="l00615"></a>00615           libmesh_assert (<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a> == MPI_REQUEST_NULL);
<a name="l00616"></a>00616           libmesh_assert (val == 1);
<a name="l00617"></a>00617         }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619       <span class="keywordflow">return</span> val;
<a name="l00620"></a>00620 <span class="preprocessor">#else</span>
<a name="l00621"></a>00621 <span class="preprocessor"></span>      <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00622"></a>00622 <span class="preprocessor">#endif</span>
<a name="l00623"></a>00623 <span class="preprocessor"></span>    }
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00626"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a82165cab942f8bfb38d0776b9ea5c097">00626</a> <span class="preprocessor"></span>    <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aece883361156951908275acfd59bfd81">test</a> (<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> &amp;<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a>)
<a name="l00627"></a>00627     {
<a name="l00628"></a>00628       <span class="keywordtype">int</span> val=0;
<a name="l00629"></a>00629 
<a name="l00630"></a>00630       MPI_Test (&amp;<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>,
<a name="l00631"></a>00631                 &amp;val,
<a name="l00632"></a>00632                 &amp;status);
<a name="l00633"></a>00633 
<a name="l00634"></a>00634       <span class="keywordflow">return</span> val;
<a name="l00635"></a>00635     }
<a name="l00636"></a>00636 <span class="preprocessor">#else</span>
<a name="l00637"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aa74186c6734807a6dce287ec5967c972">00637</a> <span class="preprocessor"></span>    <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#aece883361156951908275acfd59bfd81">test</a> (<a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> &amp;)
<a name="l00638"></a>00638     {
<a name="l00639"></a>00639       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00640"></a>00640     }
<a name="l00641"></a>00641 <span class="preprocessor">#endif</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span>
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   <span class="keyword">private</span>:
<a name="l00645"></a>00645 
<a name="l00646"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">00646</a>     <a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a0a73d72f38080abcf52d66c64a9b3ae6">_request</a>;    
<a name="l00647"></a>00647   };
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   
<a name="l00651"></a>00651   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00652"></a>00652   <span class="comment">/* </span>
<a name="l00653"></a>00653 <span class="comment">   * The default libMesh communicator</span>
<a name="l00654"></a>00654 <span class="comment">   */</span>
<a name="l00655"></a>00655   <span class="keyword">extern</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>;
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00663"></a>00663 <span class="comment"></span><span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00664"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">00664</a> <span class="preprocessor"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">barrier</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00665"></a>00665   {
<a name="l00666"></a>00666     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00667"></a>00667       {
<a name="l00668"></a>00668         START_LOG(<span class="stringliteral">&quot;barrier()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00669"></a>00669     
<a name="l00670"></a>00670         MPI_Barrier (comm.get());
<a name="l00671"></a>00671 
<a name="l00672"></a>00672         STOP_LOG(<span class="stringliteral">&quot;barrier()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00673"></a>00673       }
<a name="l00674"></a>00674   }    
<a name="l00675"></a>00675 <span class="preprocessor">#else</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a95416053432ed0ab6d1231070bfebeff">barrier</a> (<span class="keyword">const</span> Communicator &amp; = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>) {}
<a name="l00677"></a>00677 <span class="preprocessor">#endif</span>
<a name="l00678"></a>00678 <span class="preprocessor"></span>  
<a name="l00679"></a>00679   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00683"></a>00683 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00684"></a>00684   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">verify</a>(<span class="keyword">const</span> T &amp;r,
<a name="l00685"></a>00685                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00686"></a>00686 
<a name="l00687"></a>00687   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00692"></a>00692 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00693"></a>00693   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(T &amp;r,
<a name="l00694"></a>00694                   <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00701"></a>00701 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00702"></a>00702   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(std::vector&lt;T&gt; &amp;r,
<a name="l00703"></a>00703                   <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00704"></a>00704 
<a name="l00705"></a>00705   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00710"></a>00710 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00711"></a>00711   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(T &amp;r,
<a name="l00712"></a>00712                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;min_id,
<a name="l00713"></a>00713                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00720"></a>00720 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00721"></a>00721   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(std::vector&lt;T&gt; &amp;r,
<a name="l00722"></a>00722                      std::vector&lt;unsigned int&gt; &amp;min_id,
<a name="l00723"></a>00723                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00730"></a>00730 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00731"></a>00731   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(T &amp;r,
<a name="l00732"></a>00732                   <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00733"></a>00733 
<a name="l00734"></a>00734   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00739"></a>00739 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00740"></a>00740   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(std::vector&lt;T&gt; &amp;r,
<a name="l00741"></a>00741                   <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00742"></a>00742 
<a name="l00743"></a>00743   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00749"></a>00749 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00750"></a>00750   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(T &amp;r,
<a name="l00751"></a>00751                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;max_id,
<a name="l00752"></a>00752                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00753"></a>00753 
<a name="l00754"></a>00754   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00759"></a>00759 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00760"></a>00760   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(std::vector&lt;T&gt; &amp;r,
<a name="l00761"></a>00761                      std::vector&lt;unsigned int&gt; &amp;max_id,
<a name="l00762"></a>00762                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00763"></a>00763 
<a name="l00764"></a>00764   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00769"></a>00769 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00770"></a>00770   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(T &amp;r,
<a name="l00771"></a>00771                   <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00772"></a>00772 
<a name="l00773"></a>00773   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00778"></a>00778 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00779"></a>00779   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(std::vector&lt;T&gt; &amp;r,
<a name="l00780"></a>00780                   <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00781"></a>00781 
<a name="l00782"></a>00782   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00787"></a>00787 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00788"></a>00788   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">set_union</a>(std::set&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l00789"></a>00789                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00790"></a>00790 
<a name="l00791"></a>00791   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00796"></a>00796 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00797"></a>00797   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">set_union</a>(std::set&lt;T&gt; &amp;data,
<a name="l00798"></a>00798                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00799"></a>00799 
<a name="l00800"></a>00800   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00805"></a>00805 <span class="comment"></span>  <span class="keyword">inline</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">probe</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00806"></a>00806                        <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l00807"></a>00807                        <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00808"></a>00808 
<a name="l00809"></a>00809   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00813"></a>00813 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00814"></a>00814   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00815"></a>00815                     std::vector&lt;T&gt; &amp;buf,
<a name="l00816"></a>00816                     <span class="keyword">const</span> DataType &amp;type,
<a name="l00817"></a>00817                     <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00818"></a>00818                     <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00819"></a>00819 
<a name="l00820"></a>00820   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00824"></a>00824 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00825"></a>00825   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00826"></a>00826                     std::vector&lt;T&gt; &amp;buf,
<a name="l00827"></a>00827                     <span class="keyword">const</span> DataType &amp;type,
<a name="l00828"></a>00828                     Request &amp;req,
<a name="l00829"></a>00829                     <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00830"></a>00830                     <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00831"></a>00831 
<a name="l00832"></a>00832   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00837"></a>00837 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00838"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2f84812927889f5c011fb3106b6ea378">00838</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00839"></a>00839                     std::vector&lt;T&gt; &amp;buf,
<a name="l00840"></a>00840                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00841"></a>00841                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00842"></a>00842   {
<a name="l00843"></a>00843     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00844"></a>00844           buf,
<a name="l00845"></a>00845           datatype&lt;T&gt;(),
<a name="l00846"></a>00846           tag,
<a name="l00847"></a>00847           comm);
<a name="l00848"></a>00848   }
<a name="l00849"></a>00849 
<a name="l00850"></a>00850   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00851"></a>00851   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00852"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0fa3dc0ee66de7380ed030e1300cfc3b">00852</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00853"></a>00853                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00854"></a>00854                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00855"></a>00855                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00856"></a>00856   {
<a name="l00857"></a>00857     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00858"></a>00858           buf,
<a name="l00859"></a>00859           datatype&lt;T&gt;(),
<a name="l00860"></a>00860           tag,
<a name="l00861"></a>00861           comm);
<a name="l00862"></a>00862   }
<a name="l00863"></a>00863 
<a name="l00864"></a>00864 
<a name="l00865"></a>00865   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00870"></a>00870 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00871"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a1f4f01e78c16aa77d74301dcac332e27">00871</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00872"></a>00872                     std::vector&lt;T&gt; &amp;buf,
<a name="l00873"></a>00873                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l00874"></a>00874                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00875"></a>00875                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00876"></a>00876   {
<a name="l00877"></a>00877     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00878"></a>00878           buf,
<a name="l00879"></a>00879           datatype&lt;T&gt;(),
<a name="l00880"></a>00880           req,
<a name="l00881"></a>00881           tag,
<a name="l00882"></a>00882           comm);
<a name="l00883"></a>00883   }
<a name="l00884"></a>00884 
<a name="l00885"></a>00885   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00886"></a>00886   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00887"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a40e3a750a836444d1bc023b8389a8653">00887</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00888"></a>00888                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00889"></a>00889                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l00890"></a>00890                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00891"></a>00891                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00892"></a>00892   {
<a name="l00893"></a>00893     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00894"></a>00894           buf,
<a name="l00895"></a>00895           datatype&lt;T&gt;(),
<a name="l00896"></a>00896           req,
<a name="l00897"></a>00897           tag,
<a name="l00898"></a>00898           comm);
<a name="l00899"></a>00899   }
<a name="l00900"></a>00900 
<a name="l00901"></a>00901 
<a name="l00902"></a>00902   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00906"></a>00906 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00907"></a>00907   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00908"></a>00908                     std::set&lt;T&gt; &amp;buf,
<a name="l00909"></a>00909                     <span class="keyword">const</span> DataType &amp;type,
<a name="l00910"></a>00910                     <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00911"></a>00911                     <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00912"></a>00912 
<a name="l00913"></a>00913   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00917"></a>00917 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00918"></a>00918   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00919"></a>00919                     std::set&lt;T&gt; &amp;buf,
<a name="l00920"></a>00920                     <span class="keyword">const</span> DataType &amp;type,
<a name="l00921"></a>00921                     Request &amp;req,
<a name="l00922"></a>00922                     <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00923"></a>00923                     <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00930"></a>00930 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00931"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a46e68424734a4e9be8d6883521191687">00931</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00932"></a>00932                     std::set&lt;T&gt; &amp;buf,
<a name="l00933"></a>00933                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00934"></a>00934                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00935"></a>00935   {
<a name="l00936"></a>00936     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00937"></a>00937           buf,
<a name="l00938"></a>00938           datatype&lt;T&gt;(),
<a name="l00939"></a>00939           tag,
<a name="l00940"></a>00940           comm);
<a name="l00941"></a>00941   }
<a name="l00942"></a>00942 
<a name="l00943"></a>00943   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00944"></a>00944   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00945"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#af87b38b01fa27e9480e146a0d7091b4f">00945</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00946"></a>00946                     std::set&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00947"></a>00947                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00948"></a>00948                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00949"></a>00949   {
<a name="l00950"></a>00950     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00951"></a>00951           buf,
<a name="l00952"></a>00952           datatype&lt;T&gt;(),
<a name="l00953"></a>00953           tag,
<a name="l00954"></a>00954           comm);
<a name="l00955"></a>00955   }
<a name="l00956"></a>00956 
<a name="l00957"></a>00957 
<a name="l00958"></a>00958   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00963"></a>00963 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00964"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab61e84c635e428514815ac8ed55b3a95">00964</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00965"></a>00965                     std::set&lt;T&gt; &amp;buf,
<a name="l00966"></a>00966                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l00967"></a>00967                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00968"></a>00968                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00969"></a>00969   {
<a name="l00970"></a>00970     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00971"></a>00971           buf,
<a name="l00972"></a>00972           datatype&lt;T&gt;(),
<a name="l00973"></a>00973           req,
<a name="l00974"></a>00974           tag,
<a name="l00975"></a>00975           comm);
<a name="l00976"></a>00976   }
<a name="l00977"></a>00977 
<a name="l00978"></a>00978   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00979"></a>00979   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00980"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a934689901427582abf33f463e53431cb">00980</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00981"></a>00981                     std::set&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00982"></a>00982                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l00983"></a>00983                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l00984"></a>00984                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l00985"></a>00985   {
<a name="l00986"></a>00986     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l00987"></a>00987           buf,
<a name="l00988"></a>00988           datatype&lt;T&gt;(),
<a name="l00989"></a>00989           req,
<a name="l00990"></a>00990           tag,
<a name="l00991"></a>00991           comm);
<a name="l00992"></a>00992   }
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00998"></a>00998 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00999"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ae6bd6cc9034a501ab87f131846e17038">00999</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ae6bd6cc9034a501ab87f131846e17038">nonblocking_send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01000"></a>01000                                 std::vector&lt;T&gt; &amp;buf,
<a name="l01001"></a>01001                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l01002"></a>01002                                 <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;r,
<a name="l01003"></a>01003                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l01004"></a>01004                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01005"></a>01005   {
<a name="l01006"></a>01006     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l01007"></a>01007           buf,
<a name="l01008"></a>01008           type,
<a name="l01009"></a>01009           r,
<a name="l01010"></a>01010           tag,
<a name="l01011"></a>01011           comm);
<a name="l01012"></a>01012   }
<a name="l01013"></a>01013 
<a name="l01014"></a>01014   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01018"></a>01018 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01019"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a72cdf5cfdc20e7e151ba8b9640357e3b">01019</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ae6bd6cc9034a501ab87f131846e17038">nonblocking_send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01020"></a>01020                                 std::vector&lt;T&gt; &amp;buf,
<a name="l01021"></a>01021                                 <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;r,
<a name="l01022"></a>01022                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l01023"></a>01023                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01024"></a>01024   {
<a name="l01025"></a>01025     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l01026"></a>01026           buf,
<a name="l01027"></a>01027           datatype&lt;T&gt;(),
<a name="l01028"></a>01028           r,
<a name="l01029"></a>01029           tag,
<a name="l01030"></a>01030           comm);
<a name="l01031"></a>01031   }
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l01034"></a>01034   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01035"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a16eb9e720763f1c454a6ac950b57c017">01035</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ae6bd6cc9034a501ab87f131846e17038">nonblocking_send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01036"></a>01036                                 std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01037"></a>01037                                 <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;r,
<a name="l01038"></a>01038                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l01039"></a>01039                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01040"></a>01040   {
<a name="l01041"></a>01041     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (dest_processor_id,
<a name="l01042"></a>01042           buf,
<a name="l01043"></a>01043           datatype&lt;T&gt;(),
<a name="l01044"></a>01044           r,
<a name="l01045"></a>01045           tag,
<a name="l01046"></a>01046           comm);
<a name="l01047"></a>01047   }
<a name="l01048"></a>01048 
<a name="l01049"></a>01049   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01053"></a>01053 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01054"></a>01054   <span class="keyword">inline</span> Status <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01055"></a>01055                          std::vector&lt;T&gt; &amp;buf,
<a name="l01056"></a>01056                          <span class="keyword">const</span> DataType &amp;type,
<a name="l01057"></a>01057                          <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01058"></a>01058                          <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01059"></a>01059 
<a name="l01060"></a>01060   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01064"></a>01064 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01065"></a>01065   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01066"></a>01066                        std::vector&lt;T&gt; &amp;buf,
<a name="l01067"></a>01067                        <span class="keyword">const</span> DataType &amp;type,
<a name="l01068"></a>01068                        Request &amp;req,
<a name="l01069"></a>01069                        <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01070"></a>01070                        <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01071"></a>01071 
<a name="l01072"></a>01072   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01077"></a>01077 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01078"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ae1819843ae21b187e1f5392e5929aa2f">01078</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01079"></a>01079                          std::vector&lt;T&gt; &amp;buf,
<a name="l01080"></a>01080                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01081"></a>01081                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01082"></a>01082   {
<a name="l01083"></a>01083     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01084"></a>01084                     buf,
<a name="l01085"></a>01085                     datatype&lt;T&gt;(),
<a name="l01086"></a>01086                     tag,
<a name="l01087"></a>01087                     comm);
<a name="l01088"></a>01088   }
<a name="l01089"></a>01089 
<a name="l01090"></a>01090   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l01091"></a>01091   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01092"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a723cdb6d032aa818fdbbc2cb3d6ebbba">01092</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01093"></a>01093                          std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01094"></a>01094                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01095"></a>01095                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01096"></a>01096   {
<a name="l01097"></a>01097     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01098"></a>01098                     buf,
<a name="l01099"></a>01099                     datatype&lt;T&gt;(),
<a name="l01100"></a>01100                     tag,
<a name="l01101"></a>01101                     comm);
<a name="l01102"></a>01102   }
<a name="l01103"></a>01103 
<a name="l01104"></a>01104   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01109"></a>01109 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01110"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a182969b753816c6b425b14872e1acb94">01110</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01111"></a>01111                        std::vector&lt;T&gt; &amp;buf,
<a name="l01112"></a>01112                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l01113"></a>01113                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01114"></a>01114                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01115"></a>01115   {
<a name="l01116"></a>01116     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01117"></a>01117              buf,
<a name="l01118"></a>01118              datatype&lt;T&gt;(),
<a name="l01119"></a>01119              req,
<a name="l01120"></a>01120              tag,
<a name="l01121"></a>01121              comm);
<a name="l01122"></a>01122   }
<a name="l01123"></a>01123 
<a name="l01124"></a>01124   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l01125"></a>01125   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01126"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ac990fc783595ce0c931d549ceef1cb6a">01126</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01127"></a>01127                        std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01128"></a>01128                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l01129"></a>01129                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01130"></a>01130                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01131"></a>01131   {
<a name="l01132"></a>01132     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01133"></a>01133              buf,
<a name="l01134"></a>01134              datatype&lt;T&gt;(),
<a name="l01135"></a>01135              req,
<a name="l01136"></a>01136              tag,
<a name="l01137"></a>01137              comm);
<a name="l01138"></a>01138   }
<a name="l01139"></a>01139 
<a name="l01140"></a>01140   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01144"></a>01144 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01145"></a>01145   <span class="keyword">inline</span> Status <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01146"></a>01146                          std::set&lt;T&gt; &amp;buf,
<a name="l01147"></a>01147                          <span class="keyword">const</span> DataType &amp;type,
<a name="l01148"></a>01148                          <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01149"></a>01149                          <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01150"></a>01150 
<a name="l01151"></a>01151   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01155"></a>01155 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01156"></a>01156   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01157"></a>01157                        std::set&lt;T&gt; &amp;buf,
<a name="l01158"></a>01158                        <span class="keyword">const</span> DataType &amp;type,
<a name="l01159"></a>01159                        Request &amp;req,
<a name="l01160"></a>01160                        <span class="keyword">const</span> MessageTag &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01161"></a>01161                        <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01162"></a>01162 
<a name="l01163"></a>01163   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01168"></a>01168 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01169"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a8b249917b0a9183ba9dde728391958c0">01169</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01170"></a>01170                          std::set&lt;T&gt; &amp;buf,
<a name="l01171"></a>01171                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01172"></a>01172                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01173"></a>01173   {
<a name="l01174"></a>01174     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01175"></a>01175                     buf,
<a name="l01176"></a>01176                     datatype&lt;T&gt;(),
<a name="l01177"></a>01177                     tag,
<a name="l01178"></a>01178                     comm);
<a name="l01179"></a>01179   }
<a name="l01180"></a>01180 
<a name="l01181"></a>01181   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l01182"></a>01182   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01183"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a63bffad5babae08f8b6c3e989f11069b">01183</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01184"></a>01184                          std::set&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01185"></a>01185                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01186"></a>01186                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01187"></a>01187   {
<a name="l01188"></a>01188     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01189"></a>01189                     buf,
<a name="l01190"></a>01190                     datatype&lt;T&gt;(),
<a name="l01191"></a>01191                     tag,
<a name="l01192"></a>01192                     comm);
<a name="l01193"></a>01193   }
<a name="l01194"></a>01194 
<a name="l01195"></a>01195   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01200"></a>01200 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01201"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a536e27e4a97cf706a4e696f0cc55d1e8">01201</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01202"></a>01202                        std::set&lt;T&gt; &amp;buf,
<a name="l01203"></a>01203                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l01204"></a>01204                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01205"></a>01205                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01206"></a>01206   {
<a name="l01207"></a>01207     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01208"></a>01208              buf,
<a name="l01209"></a>01209              datatype&lt;T&gt;(),
<a name="l01210"></a>01210              req,
<a name="l01211"></a>01211              tag,
<a name="l01212"></a>01212              comm);
<a name="l01213"></a>01213   }
<a name="l01214"></a>01214 
<a name="l01215"></a>01215   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l01216"></a>01216   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01217"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2b7a4bf16ad64fe5e59779e2b6f89147">01217</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01218"></a>01218                        std::set&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01219"></a>01219                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l01220"></a>01220                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01221"></a>01221                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01222"></a>01222   {
<a name="l01223"></a>01223     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01224"></a>01224              buf,
<a name="l01225"></a>01225              datatype&lt;T&gt;(),
<a name="l01226"></a>01226              req,
<a name="l01227"></a>01227              tag,
<a name="l01228"></a>01228              comm);
<a name="l01229"></a>01229   }
<a name="l01230"></a>01230 
<a name="l01231"></a>01231   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01235"></a>01235 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01236"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#adec0f142c1edef2d2145515475e95815">01236</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#adec0f142c1edef2d2145515475e95815">nonblocking_receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01237"></a>01237                                    std::vector&lt;T&gt; &amp;buf,
<a name="l01238"></a>01238                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l01239"></a>01239                                    <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;r,
<a name="l01240"></a>01240                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01241"></a>01241                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01242"></a>01242   {
<a name="l01243"></a>01243     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01244"></a>01244              buf,
<a name="l01245"></a>01245              type,
<a name="l01246"></a>01246              r,
<a name="l01247"></a>01247              tag,
<a name="l01248"></a>01248              comm);
<a name="l01249"></a>01249   }
<a name="l01250"></a>01250 
<a name="l01251"></a>01251   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01255"></a>01255 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01256"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a5c22692297489aabd4bf91ffb27862d2">01256</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#adec0f142c1edef2d2145515475e95815">nonblocking_receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01257"></a>01257                                    std::vector&lt;T&gt; &amp;buf,
<a name="l01258"></a>01258                                    <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;r,
<a name="l01259"></a>01259                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01260"></a>01260                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01261"></a>01261   {
<a name="l01262"></a>01262     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01263"></a>01263              buf,
<a name="l01264"></a>01264              datatype&lt;T&gt;(),
<a name="l01265"></a>01265              r,
<a name="l01266"></a>01266              tag,
<a name="l01267"></a>01267              comm);
<a name="l01268"></a>01268   }
<a name="l01269"></a>01269 
<a name="l01270"></a>01270   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l01271"></a>01271   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01272"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a7139fe88abf8e05d113caf4f34af114a">01272</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#adec0f142c1edef2d2145515475e95815">nonblocking_receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01273"></a>01273                                    std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01274"></a>01274                                    <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;r,
<a name="l01275"></a>01275                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l01276"></a>01276                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l01277"></a>01277   {
<a name="l01278"></a>01278     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (src_processor_id,
<a name="l01279"></a>01279              buf,
<a name="l01280"></a>01280              datatype&lt;T&gt;(),
<a name="l01281"></a>01281              r,
<a name="l01282"></a>01282              tag,
<a name="l01283"></a>01283              comm);
<a name="l01284"></a>01284   }
<a name="l01285"></a>01285 
<a name="l01286"></a>01286   
<a name="l01287"></a>01287   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01291"></a>01291 <span class="comment"></span>  <span class="keyword">inline</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">request</a> &amp;r);
<a name="l01292"></a>01292   
<a name="l01293"></a>01293   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01297"></a>01297 <span class="comment"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (std::vector&lt;request&gt; &amp;r);
<a name="l01298"></a>01298   
<a name="l01299"></a>01299   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01303"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aea5278a91928fa4f33b74aa0786f3592">01303</a> <span class="comment"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (std::vector&lt;Request&gt; &amp;r)
<a name="l01304"></a>01304   { <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;r.size(); i++) r[i].<a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a>(); }
<a name="l01305"></a>01305   
<a name="l01306"></a>01306   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01311"></a>01311 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01312"></a>01312   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01313"></a>01313                            T &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l01314"></a>01314                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01315"></a>01315                            T &amp;recv,
<a name="l01316"></a>01316                            <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01317"></a>01317 
<a name="l01318"></a>01318   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01324"></a>01324 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01325"></a>01325   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01326"></a>01326                            T &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l01327"></a>01327                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01328"></a>01328                            T &amp;recv,
<a name="l01329"></a>01329                            <span class="keyword">const</span> DataType &amp;type,
<a name="l01330"></a>01330                            <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01331"></a>01331 
<a name="l01332"></a>01332   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01337"></a>01337 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01338"></a>01338   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l01339"></a>01339                      T <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l01340"></a>01340                      std::vector&lt;T&gt; &amp;recv,
<a name="l01341"></a>01341                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01342"></a>01342 
<a name="l01343"></a>01343   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01348"></a>01348 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01349"></a>01349   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l01350"></a>01350                      std::vector&lt;T&gt; &amp;r,
<a name="l01351"></a>01351                      <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01352"></a>01352 
<a name="l01353"></a>01353   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01358"></a>01358 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01359"></a>01359   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(T <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l01360"></a>01360                         std::vector&lt;T&gt; &amp;recv,
<a name="l01361"></a>01361                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 
<a name="l01364"></a>01364   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01372"></a>01372 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01373"></a>01373   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(std::vector&lt;T&gt; &amp;r,
<a name="l01374"></a>01374                         <span class="keyword">const</span> <span class="keywordtype">bool</span> identical_buffer_sizes = <span class="keyword">false</span>,
<a name="l01375"></a>01375                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01376"></a>01376 
<a name="l01377"></a>01377 
<a name="l01378"></a>01378 
<a name="l01379"></a>01379   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01385"></a>01385 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01386"></a>01386   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">alltoall</a>(std::vector&lt;T&gt; &amp;r,
<a name="l01387"></a>01387                        <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01388"></a>01388 
<a name="l01389"></a>01389 
<a name="l01390"></a>01390 
<a name="l01391"></a>01391   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01397"></a>01397 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01398"></a>01398   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a>(T &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0,
<a name="l01399"></a>01399                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01400"></a>01400 
<a name="l01401"></a>01401 
<a name="l01402"></a>01402 
<a name="l01403"></a>01403   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01410"></a>01410 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01411"></a>01411   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a>(std::vector&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0,
<a name="l01412"></a>01412                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01413"></a>01413 
<a name="l01414"></a>01414 
<a name="l01415"></a>01415   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l01421"></a>01421 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01422"></a>01422   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a>(std::set&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0,
<a name="l01423"></a>01423                         <span class="keyword">const</span> Communicator &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>);
<a name="l01424"></a>01424 
<a name="l01425"></a>01425 
<a name="l01426"></a>01426   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l01427"></a>01427   <span class="comment">// Parallel members</span>
<a name="l01428"></a>01428 
<a name="l01429"></a>01429   <span class="keyword">inline</span>
<a name="l01430"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a60ba578604d31e1e998b3bf864482191">01430</a>   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a60ba578604d31e1e998b3bf864482191">MessageTag::~MessageTag</a>()
<a name="l01431"></a>01431   {
<a name="l01432"></a>01432     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>)
<a name="l01433"></a>01433       <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3274f8f1295853e4d542d48911848461">dereference_unique_tag</a>(<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">_tagvalue</a>);
<a name="l01434"></a>01434   }
<a name="l01435"></a>01435 
<a name="l01436"></a>01436 
<a name="l01437"></a>01437   <span class="keyword">inline</span>
<a name="l01438"></a><a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a24488704034561645d3cf108eec3f13c">01438</a>   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a9a6004f0fc09c12fccbddc9a013e0c01">MessageTag::MessageTag</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;other)
<a name="l01439"></a>01439     : _tagvalue(other._tagvalue), _comm(other._comm)
<a name="l01440"></a>01440   {
<a name="l01441"></a>01441     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>)
<a name="l01442"></a>01442       <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a513aea8132d40a33ce965d68ca293086">_comm</a>-&gt;<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac2b5426b53a768b0825fa146b1f8ec22">reference_unique_tag</a>(<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#af0efccb30c094711aed5b832e2824b40">_tagvalue</a>);
<a name="l01443"></a>01443   }
<a name="l01444"></a>01444 
<a name="l01445"></a>01445 
<a name="l01446"></a>01446   <span class="keyword">inline</span>
<a name="l01447"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a148450d5fa1ed4b60f3c1efc0e7bf83e">01447</a>   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a148450d5fa1ed4b60f3c1efc0e7bf83e">Communicator::get_unique_tag</a>(<span class="keywordtype">int</span> tagvalue)<span class="keyword"> const</span>
<a name="l01448"></a>01448 <span class="keyword">  </span>{
<a name="l01449"></a>01449     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>.count(tagvalue))
<a name="l01450"></a>01450       {
<a name="l01451"></a>01451         <span class="comment">// Get the largest value in the used values, and pick one</span>
<a name="l01452"></a>01452         <span class="comment">// larger</span>
<a name="l01453"></a>01453         tagvalue = <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>.rbegin()-&gt;first+1;
<a name="l01454"></a>01454         libmesh_assert(!<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>.count(tagvalue));
<a name="l01455"></a>01455       }
<a name="l01456"></a>01456     <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>[tagvalue] = 1;
<a name="l01457"></a>01457 
<a name="l01458"></a>01458 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01459"></a>01459 <span class="preprocessor"></span>    <span class="comment">// Make sure everyone called get_unique_tag and make sure</span>
<a name="l01460"></a>01460     <span class="comment">// everyone got the same value</span>
<a name="l01461"></a>01461     <span class="keywordtype">int</span> maxval = tagvalue;
<a name="l01462"></a>01462     <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(maxval);
<a name="l01463"></a>01463     libmesh_assert(tagvalue == maxval);
<a name="l01464"></a>01464 <span class="preprocessor">#endif</span>
<a name="l01465"></a>01465 <span class="preprocessor"></span>
<a name="l01466"></a>01466     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>(tagvalue, <span class="keyword">this</span>);
<a name="l01467"></a>01467   }
<a name="l01468"></a>01468 
<a name="l01469"></a>01469 
<a name="l01470"></a>01470   <span class="keyword">inline</span>
<a name="l01471"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac2b5426b53a768b0825fa146b1f8ec22">01471</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ac2b5426b53a768b0825fa146b1f8ec22">Communicator::reference_unique_tag</a>(<span class="keywordtype">int</span> tagvalue)<span class="keyword"> const</span>
<a name="l01472"></a>01472 <span class="keyword">  </span>{
<a name="l01473"></a>01473     <span class="comment">// This has better be an already-acquired tag.</span>
<a name="l01474"></a>01474     libmesh_assert(<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>.count(tagvalue));
<a name="l01475"></a>01475 
<a name="l01476"></a>01476     <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>[tagvalue]++;
<a name="l01477"></a>01477   }
<a name="l01478"></a>01478 
<a name="l01479"></a>01479 
<a name="l01480"></a>01480   <span class="keyword">inline</span>
<a name="l01481"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3274f8f1295853e4d542d48911848461">01481</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3274f8f1295853e4d542d48911848461">Communicator::dereference_unique_tag</a>(<span class="keywordtype">int</span> tagvalue)<span class="keyword"> const</span>
<a name="l01482"></a>01482 <span class="keyword">  </span>{
<a name="l01483"></a>01483     <span class="comment">// This has better be an already-acquired tag.</span>
<a name="l01484"></a>01484     libmesh_assert(<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>.count(tagvalue));
<a name="l01485"></a>01485 
<a name="l01486"></a>01486     <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#ab7fb4268d1f36ef56b097fad47ab84ca">used_tag_values</a>[tagvalue]--;
<a name="l01487"></a>01487     <span class="comment">// If we don&#39;t have any more outstanding references, we</span>
<a name="l01488"></a>01488     <span class="comment">// don&#39;t even need to keep this tag in our &quot;used&quot; set.</span>
<a name="l01489"></a>01489     <span class="keywordflow">if</span> (!used_tag_values[tagvalue])
<a name="l01490"></a>01490       used_tag_values.erase(tagvalue);
<a name="l01491"></a>01491   }
<a name="l01492"></a>01492 
<a name="l01493"></a>01493 
<a name="l01494"></a>01494   <span class="comment">// Internal helper function to create vector&lt;something_useable&gt; from</span>
<a name="l01495"></a>01495   <span class="comment">// vector&lt;bool&gt; for compatibility with MPI bitwise operations</span>
<a name="l01496"></a>01496   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01497"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#af03e39a37c9fb12885a8064b8d3af7b4">01497</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af03e39a37c9fb12885a8064b8d3af7b4">pack_vector_bool</a>(<span class="keyword">const</span> std::vector&lt;bool&gt; &amp;in,
<a name="l01498"></a>01498                                std::vector&lt;T&gt; &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l01499"></a>01499   {
<a name="l01500"></a>01500     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_bits = 8*<span class="keyword">sizeof</span>(T);
<a name="l01501"></a>01501     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> in_size = in.size();
<a name="l01502"></a>01502     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> out_size = in_size/data_bits + (in_size%data_bits?1:0);
<a name="l01503"></a>01503     out.clear();
<a name="l01504"></a>01504     out.resize(out_size);
<a name="l01505"></a>01505     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != in_size; ++i)
<a name="l01506"></a>01506       {
<a name="l01507"></a>01507         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = i/data_bits;
<a name="l01508"></a>01508         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = i%data_bits;
<a name="l01509"></a>01509         out[index] += (in[i]?1:0) &lt;&lt; offset;
<a name="l01510"></a>01510       }
<a name="l01511"></a>01511   }
<a name="l01512"></a>01512 
<a name="l01513"></a>01513   <span class="comment">// Internal helper function to create vector&lt;bool&gt; from</span>
<a name="l01514"></a>01514   <span class="comment">// vector&lt;something usable&gt; for compatibility with MPI byte</span>
<a name="l01515"></a>01515   <span class="comment">// operations</span>
<a name="l01516"></a>01516   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01517"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a46767a37d3db91f9669ef07a82f09a36">01517</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a46767a37d3db91f9669ef07a82f09a36">unpack_vector_bool</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;in,
<a name="l01518"></a>01518                                  std::vector&lt;bool&gt; &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l01519"></a>01519   {
<a name="l01520"></a>01520     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_bits = 8*<span class="keyword">sizeof</span>(T);
<a name="l01521"></a>01521     <span class="comment">// We need the output vector to already be properly sized</span>
<a name="l01522"></a>01522     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> out_size = out.size();
<a name="l01523"></a>01523     libmesh_assert(out_size/data_bits + (out_size%data_bits?1:0) == in.size());
<a name="l01524"></a>01524 
<a name="l01525"></a>01525     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != out_size; ++i)
<a name="l01526"></a>01526       {
<a name="l01527"></a>01527         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = i/data_bits;
<a name="l01528"></a>01528         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = i%data_bits;
<a name="l01529"></a>01529         out[i] = in[index] &lt;&lt; (data_bits-1-offset) &gt;&gt; (data_bits-1);
<a name="l01530"></a>01530       }
<a name="l01531"></a>01531   }
<a name="l01532"></a>01532 
<a name="l01533"></a>01533 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l01534"></a>01534 <span class="preprocessor"></span>  <span class="keyword">template</span>&lt;&gt;
<a name="l01535"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#abaa294cef0cd6ff79fb85bd1f8594d6d">01535</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#abaa294cef0cd6ff79fb85bd1f8594d6d">datatype&lt;char&gt;</a>() { <span class="keywordflow">return</span> MPI_CHAR; }
<a name="l01536"></a>01536 
<a name="l01537"></a>01537   <span class="keyword">template</span>&lt;&gt;
<a name="l01538"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ae579c5bc5b8fb06b31965070b9ef921f">01538</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ae579c5bc5b8fb06b31965070b9ef921f">datatype&lt;unsigned char&gt;</a>() { <span class="keywordflow">return</span> MPI_UNSIGNED_CHAR; }
<a name="l01539"></a>01539 
<a name="l01540"></a>01540   <span class="keyword">template</span>&lt;&gt;
<a name="l01541"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2f1fbd2e1ef6b090e17e67d956265e3b">01541</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a2f1fbd2e1ef6b090e17e67d956265e3b">datatype&lt;short int&gt;</a>() { <span class="keywordflow">return</span> MPI_SHORT; }
<a name="l01542"></a>01542 
<a name="l01543"></a>01543   <span class="keyword">template</span>&lt;&gt;
<a name="l01544"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ad93400c0e97c05161ea148392fa88e89">01544</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad93400c0e97c05161ea148392fa88e89">datatype&lt;unsigned short int&gt;</a>() { <span class="keywordflow">return</span> MPI_UNSIGNED_SHORT; }
<a name="l01545"></a>01545 
<a name="l01546"></a>01546   <span class="keyword">template</span>&lt;&gt;
<a name="l01547"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a3d3a349564dd87fb292c2781d422b84b">01547</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a3d3a349564dd87fb292c2781d422b84b">datatype&lt;int&gt;</a>() { <span class="keywordflow">return</span> MPI_INT; }
<a name="l01548"></a>01548 
<a name="l01549"></a>01549   <span class="keyword">template</span>&lt;&gt;
<a name="l01550"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">01550</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>() { <span class="keywordflow">return</span> MPI_UNSIGNED; }
<a name="l01551"></a>01551 
<a name="l01552"></a>01552   <span class="keyword">template</span>&lt;&gt;
<a name="l01553"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2642e436caa6ed7c6488f8d91dc7d83c">01553</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a2642e436caa6ed7c6488f8d91dc7d83c">datatype&lt;long&gt;</a>() { <span class="keywordflow">return</span> MPI_LONG; }
<a name="l01554"></a>01554 
<a name="l01555"></a>01555   <span class="keyword">template</span>&lt;&gt;
<a name="l01556"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a1ac3c509a1c461499de21823bd52df10">01556</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1ac3c509a1c461499de21823bd52df10">datatype&lt;unsigned long&gt;</a>() { <span class="keywordflow">return</span> MPI_UNSIGNED_LONG; }
<a name="l01557"></a>01557 
<a name="l01558"></a>01558   <span class="keyword">template</span>&lt;&gt;
<a name="l01559"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a04203326298f416f0bff319a8ad8c224">01559</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a04203326298f416f0bff319a8ad8c224">datatype&lt;float&gt;</a>() { <span class="keywordflow">return</span> MPI_FLOAT; }
<a name="l01560"></a>01560 
<a name="l01561"></a>01561   <span class="keyword">template</span>&lt;&gt;
<a name="l01562"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#afefaebb2dad16a384b835fa3f4a3fbf7">01562</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#afefaebb2dad16a384b835fa3f4a3fbf7">datatype&lt;double&gt;</a>() { <span class="keywordflow">return</span> MPI_DOUBLE; }
<a name="l01563"></a>01563 
<a name="l01564"></a>01564   <span class="keyword">template</span>&lt;&gt;
<a name="l01565"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ac74fb37973a05a3498cfafffc128e3d2">01565</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ac74fb37973a05a3498cfafffc128e3d2">datatype&lt;long double&gt;</a>() { <span class="keywordflow">return</span> MPI_LONG_DOUBLE; }
<a name="l01566"></a>01566 
<a name="l01567"></a>01567   <span class="keyword">template</span>&lt;&gt;
<a name="l01568"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a8c345da244ca08b6724bbc8acd3fda1e">01568</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8c345da244ca08b6724bbc8acd3fda1e">dataplusint_type&lt;short int&gt;</a>() { <span class="keywordflow">return</span> MPI_SHORT_INT; }
<a name="l01569"></a>01569 
<a name="l01570"></a>01570   <span class="keyword">template</span>&lt;&gt;
<a name="l01571"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#adf81719823c7f2fce868c3d33062e59f">01571</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#adf81719823c7f2fce868c3d33062e59f">dataplusint_type&lt;int&gt;</a>() { <span class="keywordflow">return</span> MPI_2INT; }
<a name="l01572"></a>01572 
<a name="l01573"></a>01573   <span class="keyword">template</span>&lt;&gt;
<a name="l01574"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa92f5d358c721e514a069a811d5681d3">01574</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa92f5d358c721e514a069a811d5681d3">dataplusint_type&lt;long&gt;</a>() { <span class="keywordflow">return</span> MPI_LONG_INT; }
<a name="l01575"></a>01575 
<a name="l01576"></a>01576   <span class="keyword">template</span>&lt;&gt;
<a name="l01577"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#afd1203e579554810a535f6238136e383">01577</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#afd1203e579554810a535f6238136e383">dataplusint_type&lt;float&gt;</a>() { <span class="keywordflow">return</span> MPI_FLOAT_INT; }
<a name="l01578"></a>01578 
<a name="l01579"></a>01579   <span class="keyword">template</span>&lt;&gt;
<a name="l01580"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab2c503e55c1bc9c24e77a5316e23ac0c">01580</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ab2c503e55c1bc9c24e77a5316e23ac0c">dataplusint_type&lt;double&gt;</a>() { <span class="keywordflow">return</span> MPI_DOUBLE_INT; }
<a name="l01581"></a>01581 
<a name="l01582"></a>01582   <span class="keyword">template</span>&lt;&gt;
<a name="l01583"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab6d5aa50d0bd7c2e9456f1391fa19966">01583</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1data__type.php">data_type</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#ab6d5aa50d0bd7c2e9456f1391fa19966">dataplusint_type&lt;long double&gt;</a>() { <span class="keywordflow">return</span> MPI_LONG_DOUBLE_INT; }
<a name="l01584"></a>01584 
<a name="l01585"></a>01585   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01586"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">01586</a>   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">verify</a>(<span class="keyword">const</span> T &amp;r,
<a name="l01587"></a>01587                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01588"></a>01588   {
<a name="l01589"></a>01589     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01590"></a>01590       {
<a name="l01591"></a>01591         T tempmin = r, tempmax = r;
<a name="l01592"></a>01592         <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(tempmin, comm);
<a name="l01593"></a>01593         <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(tempmax, comm);
<a name="l01594"></a>01594         <span class="keywordtype">bool</span> verified = (r == tempmin) &amp;&amp;
<a name="l01595"></a>01595                         (r == tempmax);
<a name="l01596"></a>01596         <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(verified, comm);
<a name="l01597"></a>01597         <span class="keywordflow">return</span> verified;
<a name="l01598"></a>01598       }
<a name="l01599"></a>01599     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01600"></a>01600   }
<a name="l01601"></a>01601 
<a name="l01602"></a>01602 
<a name="l01603"></a>01603   <span class="keyword">template</span> &lt;&gt;
<a name="l01604"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a8e370e8ba776744a87e9004ef8568d5e">01604</a>   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">verify</a>(<span class="keyword">const</span> std::string &amp; r,
<a name="l01605"></a>01605                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01606"></a>01606   {
<a name="l01607"></a>01607     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01608"></a>01608       {
<a name="l01609"></a>01609         <span class="comment">// Cannot use &lt;char&gt; since MPI_MIN is not</span>
<a name="l01610"></a>01610         <span class="comment">// strictly defined for chars!</span>
<a name="l01611"></a>01611         std::vector&lt;short int&gt; temp; temp.reserve(r.size());
<a name="l01612"></a>01612         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01613"></a>01613           temp.push_back(r[i]);
<a name="l01614"></a>01614         <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">Parallel::verify</a>(temp, comm);
<a name="l01615"></a>01615       }
<a name="l01616"></a>01616     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01617"></a>01617   }
<a name="l01618"></a>01618 
<a name="l01619"></a>01619 
<a name="l01620"></a>01620   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01621"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">01621</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(T &amp;r,
<a name="l01622"></a>01622                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01623"></a>01623   {
<a name="l01624"></a>01624     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01625"></a>01625       {
<a name="l01626"></a>01626         START_LOG(<span class="stringliteral">&quot;min(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01627"></a>01627     
<a name="l01628"></a>01628         T temp = r;
<a name="l01629"></a>01629         MPI_Allreduce (&amp;temp,
<a name="l01630"></a>01630                        &amp;r,
<a name="l01631"></a>01631                        1,
<a name="l01632"></a>01632                        datatype&lt;T&gt;(),
<a name="l01633"></a>01633                        MPI_MIN,
<a name="l01634"></a>01634                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01635"></a>01635 
<a name="l01636"></a>01636         STOP_LOG(<span class="stringliteral">&quot;min(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01637"></a>01637       }
<a name="l01638"></a>01638   }
<a name="l01639"></a>01639 
<a name="l01640"></a>01640 
<a name="l01641"></a>01641   <span class="keyword">template</span> &lt;&gt;
<a name="l01642"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#acc9f4fe20ca431bec1e4c89bf0eeb5ea">01642</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(<span class="keywordtype">bool</span> &amp;r,
<a name="l01643"></a>01643                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01644"></a>01644   {
<a name="l01645"></a>01645     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01646"></a>01646       {
<a name="l01647"></a>01647         START_LOG(<span class="stringliteral">&quot;min(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01648"></a>01648     
<a name="l01649"></a>01649         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tempsend = r;
<a name="l01650"></a>01650         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l01651"></a>01651         MPI_Allreduce (&amp;tempsend,
<a name="l01652"></a>01652                        &amp;temp,
<a name="l01653"></a>01653                        1,
<a name="l01654"></a>01654                        <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l01655"></a>01655                        MPI_MIN,
<a name="l01656"></a>01656                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01657"></a>01657         r = temp;
<a name="l01658"></a>01658 
<a name="l01659"></a>01659         STOP_LOG(<span class="stringliteral">&quot;min(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01660"></a>01660       }
<a name="l01661"></a>01661   }
<a name="l01662"></a>01662 
<a name="l01663"></a>01663 
<a name="l01664"></a>01664   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01665"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a7cbc1d47df98c20f1a4f091c95a641dc">01665</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(std::vector&lt;T&gt; &amp;r,
<a name="l01666"></a>01666                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01667"></a>01667   {
<a name="l01668"></a>01668     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01669"></a>01669       {
<a name="l01670"></a>01670         START_LOG(<span class="stringliteral">&quot;min(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01671"></a>01671     
<a name="l01672"></a>01672         std::vector&lt;T&gt; temp(r);
<a name="l01673"></a>01673         MPI_Allreduce (&amp;temp[0],
<a name="l01674"></a>01674                        &amp;r[0],
<a name="l01675"></a>01675                        r.size(),
<a name="l01676"></a>01676                        datatype&lt;T&gt;(),
<a name="l01677"></a>01677                        MPI_MIN,
<a name="l01678"></a>01678                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01679"></a>01679 
<a name="l01680"></a>01680         STOP_LOG(<span class="stringliteral">&quot;min(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01681"></a>01681       }
<a name="l01682"></a>01682   }
<a name="l01683"></a>01683 
<a name="l01684"></a>01684 
<a name="l01685"></a>01685   <span class="keyword">template</span> &lt;&gt;
<a name="l01686"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa50341bb0d04685695030d0cccbb4683">01686</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(std::vector&lt;bool&gt; &amp;r,
<a name="l01687"></a>01687                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01688"></a>01688   {
<a name="l01689"></a>01689     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01690"></a>01690       {
<a name="l01691"></a>01691         START_LOG(<span class="stringliteral">&quot;min(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01692"></a>01692     
<a name="l01693"></a>01693         std::vector&lt;unsigned int&gt; ruint;
<a name="l01694"></a>01694         <a class="code" href="namespacelibMesh_1_1Parallel.php#af03e39a37c9fb12885a8064b8d3af7b4">pack_vector_bool</a>(r, ruint);
<a name="l01695"></a>01695         std::vector&lt;unsigned int&gt; temp(ruint.size());
<a name="l01696"></a>01696         MPI_Allreduce (&amp;ruint[0],
<a name="l01697"></a>01697                        &amp;temp[0],
<a name="l01698"></a>01698                        ruint.size(),
<a name="l01699"></a>01699                        <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l01700"></a>01700                        MPI_BAND,
<a name="l01701"></a>01701                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01702"></a>01702         <a class="code" href="namespacelibMesh_1_1Parallel.php#a46767a37d3db91f9669ef07a82f09a36">unpack_vector_bool</a>(temp, r);
<a name="l01703"></a>01703 
<a name="l01704"></a>01704         STOP_LOG(<span class="stringliteral">&quot;min(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01705"></a>01705       }
<a name="l01706"></a>01706   }
<a name="l01707"></a>01707 
<a name="l01708"></a>01708 
<a name="l01709"></a>01709   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01710"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">01710</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(T &amp;r,
<a name="l01711"></a>01711                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;min_id,
<a name="l01712"></a>01712                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01713"></a>01713   {
<a name="l01714"></a>01714     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01715"></a>01715       {
<a name="l01716"></a>01716         START_LOG(<span class="stringliteral">&quot;minloc(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01717"></a>01717     
<a name="l01718"></a>01718         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;T&gt;</a> in;
<a name="l01719"></a>01719         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a> = r;
<a name="l01720"></a>01720         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a> = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01721"></a>01721         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;T&gt;</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l01722"></a>01722         MPI_Allreduce (&amp;in,
<a name="l01723"></a>01723                        &amp;out,
<a name="l01724"></a>01724                        1,
<a name="l01725"></a>01725                        dataplusint_type&lt;T&gt;(),
<a name="l01726"></a>01726                        MPI_MINLOC,
<a name="l01727"></a>01727                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01728"></a>01728         r = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a>;
<a name="l01729"></a>01729         min_id = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a>;
<a name="l01730"></a>01730 
<a name="l01731"></a>01731         STOP_LOG(<span class="stringliteral">&quot;minloc(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01732"></a>01732       }
<a name="l01733"></a>01733     <span class="keywordflow">else</span>
<a name="l01734"></a>01734       min_id = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01735"></a>01735   }
<a name="l01736"></a>01736 
<a name="l01737"></a>01737 
<a name="l01738"></a>01738   <span class="keyword">template</span> &lt;&gt;
<a name="l01739"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a52520e088b692c9325a8877a59f98590">01739</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(<span class="keywordtype">bool</span> &amp;r,
<a name="l01740"></a>01740                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;min_id,
<a name="l01741"></a>01741                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01742"></a>01742   {
<a name="l01743"></a>01743     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01744"></a>01744       {
<a name="l01745"></a>01745         START_LOG(<span class="stringliteral">&quot;minloc(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01746"></a>01746     
<a name="l01747"></a>01747         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;int&gt;</a> in;
<a name="l01748"></a>01748         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a> = r;
<a name="l01749"></a>01749         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a> = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01750"></a>01750         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;int&gt;</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l01751"></a>01751         MPI_Allreduce (&amp;in,
<a name="l01752"></a>01752                        &amp;out,
<a name="l01753"></a>01753                        1,
<a name="l01754"></a>01754                        <a class="code" href="namespacelibMesh_1_1Parallel.php#adf81719823c7f2fce868c3d33062e59f">dataplusint_type&lt;int&gt;</a>(),
<a name="l01755"></a>01755                        MPI_MINLOC,
<a name="l01756"></a>01756                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01757"></a>01757         r = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a>;
<a name="l01758"></a>01758         min_id = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a>;
<a name="l01759"></a>01759 
<a name="l01760"></a>01760         STOP_LOG(<span class="stringliteral">&quot;minloc(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01761"></a>01761       }
<a name="l01762"></a>01762     <span class="keywordflow">else</span>
<a name="l01763"></a>01763       min_id = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01764"></a>01764   }
<a name="l01765"></a>01765 
<a name="l01766"></a>01766 
<a name="l01767"></a>01767   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01768"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#abdadc97c306b84408709d2441424042f">01768</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(std::vector&lt;T&gt; &amp;r,
<a name="l01769"></a>01769                      std::vector&lt;unsigned int&gt; &amp;min_id,
<a name="l01770"></a>01770                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01771"></a>01771   {
<a name="l01772"></a>01772     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01773"></a>01773       {
<a name="l01774"></a>01774         START_LOG(<span class="stringliteral">&quot;minloc(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01775"></a>01775     
<a name="l01776"></a>01776         std::vector&lt;DataPlusInt&lt;T&gt; &gt; in(r.size());
<a name="l01777"></a>01777         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01778"></a>01778           {
<a name="l01779"></a>01779             in[i].val  = r[i];
<a name="l01780"></a>01780             in[i].rank = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01781"></a>01781           }
<a name="l01782"></a>01782         std::vector&lt;DataPlusInt&lt;T&gt; &gt; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>(r.size());
<a name="l01783"></a>01783         MPI_Allreduce (&amp;in[0],
<a name="l01784"></a>01784                        &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[0],
<a name="l01785"></a>01785                        r.size(),
<a name="l01786"></a>01786                        dataplusint_type&lt;T&gt;(),
<a name="l01787"></a>01787                        MPI_MINLOC,
<a name="l01788"></a>01788                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01789"></a>01789         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01790"></a>01790           {
<a name="l01791"></a>01791             r[i]      = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].val;
<a name="l01792"></a>01792             min_id[i] = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].rank;
<a name="l01793"></a>01793           }
<a name="l01794"></a>01794 
<a name="l01795"></a>01795         STOP_LOG(<span class="stringliteral">&quot;minloc(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01796"></a>01796       }
<a name="l01797"></a>01797     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!r.empty())
<a name="l01798"></a>01798       {
<a name="l01799"></a>01799         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01800"></a>01800           min_id[i] = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01801"></a>01801       }
<a name="l01802"></a>01802   }
<a name="l01803"></a>01803 
<a name="l01804"></a>01804 
<a name="l01805"></a>01805   <span class="keyword">template</span> &lt;&gt;
<a name="l01806"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a67bad9bac25b0c4a8b657833928a5fa2">01806</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(std::vector&lt;bool&gt; &amp;r,
<a name="l01807"></a>01807                      std::vector&lt;unsigned int&gt; &amp;min_id,
<a name="l01808"></a>01808                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01809"></a>01809   {
<a name="l01810"></a>01810     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01811"></a>01811       {
<a name="l01812"></a>01812         START_LOG(<span class="stringliteral">&quot;minloc(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01813"></a>01813     
<a name="l01814"></a>01814         std::vector&lt;DataPlusInt&lt;int&gt; &gt; in(r.size());
<a name="l01815"></a>01815         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01816"></a>01816           {
<a name="l01817"></a>01817             in[i].val  = r[i];
<a name="l01818"></a>01818             in[i].rank = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01819"></a>01819           }
<a name="l01820"></a>01820         std::vector&lt;DataPlusInt&lt;int&gt; &gt; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>(r.size());
<a name="l01821"></a>01821         MPI_Allreduce (&amp;in[0],
<a name="l01822"></a>01822                        &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[0],
<a name="l01823"></a>01823                        r.size(),
<a name="l01824"></a>01824                        <a class="code" href="namespacelibMesh_1_1Parallel.php#a3d3a349564dd87fb292c2781d422b84b">datatype&lt;int&gt;</a>(),
<a name="l01825"></a>01825                        MPI_MINLOC,
<a name="l01826"></a>01826                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01827"></a>01827         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01828"></a>01828           {
<a name="l01829"></a>01829             r[i]      = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].val;
<a name="l01830"></a>01830             min_id[i] = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].rank;
<a name="l01831"></a>01831           }
<a name="l01832"></a>01832 
<a name="l01833"></a>01833         STOP_LOG(<span class="stringliteral">&quot;minloc(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01834"></a>01834       }
<a name="l01835"></a>01835     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!r.empty())
<a name="l01836"></a>01836       {
<a name="l01837"></a>01837         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l01838"></a>01838           min_id[i] = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01839"></a>01839       }
<a name="l01840"></a>01840   }
<a name="l01841"></a>01841 
<a name="l01842"></a>01842 
<a name="l01843"></a>01843   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01844"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">01844</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(T &amp;r,
<a name="l01845"></a>01845                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01846"></a>01846   {
<a name="l01847"></a>01847     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01848"></a>01848       {
<a name="l01849"></a>01849         START_LOG(<span class="stringliteral">&quot;max(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01850"></a>01850     
<a name="l01851"></a>01851         T temp;
<a name="l01852"></a>01852         MPI_Allreduce (&amp;r,
<a name="l01853"></a>01853                        &amp;temp,
<a name="l01854"></a>01854                        1,
<a name="l01855"></a>01855                        datatype&lt;T&gt;(),
<a name="l01856"></a>01856                        MPI_MAX,
<a name="l01857"></a>01857                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01858"></a>01858         r = temp;
<a name="l01859"></a>01859 
<a name="l01860"></a>01860         STOP_LOG(<span class="stringliteral">&quot;max(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01861"></a>01861       }
<a name="l01862"></a>01862   }
<a name="l01863"></a>01863 
<a name="l01864"></a>01864 
<a name="l01865"></a>01865   <span class="keyword">template</span> &lt;&gt;
<a name="l01866"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0a0d334af1d6b3e9b03b6b8a0352e5b2">01866</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(<span class="keywordtype">bool</span> &amp;r,
<a name="l01867"></a>01867                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01868"></a>01868   {
<a name="l01869"></a>01869     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01870"></a>01870       {
<a name="l01871"></a>01871         START_LOG(<span class="stringliteral">&quot;max(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01872"></a>01872     
<a name="l01873"></a>01873         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tempsend = r;
<a name="l01874"></a>01874         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l01875"></a>01875         MPI_Allreduce (&amp;tempsend,
<a name="l01876"></a>01876                        &amp;temp,
<a name="l01877"></a>01877                        1,
<a name="l01878"></a>01878                        <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l01879"></a>01879                        MPI_MAX,
<a name="l01880"></a>01880                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01881"></a>01881         r = temp;
<a name="l01882"></a>01882 
<a name="l01883"></a>01883         STOP_LOG(<span class="stringliteral">&quot;max(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01884"></a>01884       }
<a name="l01885"></a>01885   }
<a name="l01886"></a>01886 
<a name="l01887"></a>01887 
<a name="l01888"></a>01888   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01889"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2c636cfe85af005a8a5946d0b69e316b">01889</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(std::vector&lt;T&gt; &amp;r,
<a name="l01890"></a>01890                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01891"></a>01891   {
<a name="l01892"></a>01892     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01893"></a>01893       {
<a name="l01894"></a>01894         START_LOG(<span class="stringliteral">&quot;max(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01895"></a>01895     
<a name="l01896"></a>01896         std::vector&lt;T&gt; temp(r);
<a name="l01897"></a>01897         MPI_Allreduce (&amp;temp[0],
<a name="l01898"></a>01898                        &amp;r[0],
<a name="l01899"></a>01899                        r.size(),
<a name="l01900"></a>01900                        datatype&lt;T&gt;(),
<a name="l01901"></a>01901                        MPI_MAX,
<a name="l01902"></a>01902                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01903"></a>01903 
<a name="l01904"></a>01904         STOP_LOG(<span class="stringliteral">&quot;max(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01905"></a>01905       }
<a name="l01906"></a>01906   }
<a name="l01907"></a>01907 
<a name="l01908"></a>01908 
<a name="l01909"></a>01909   <span class="keyword">template</span> &lt;&gt;
<a name="l01910"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a1e3e97e1bf717b38b0feb40fcbcf9dde">01910</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(std::vector&lt;bool&gt; &amp;r,
<a name="l01911"></a>01911                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01912"></a>01912   {
<a name="l01913"></a>01913     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01914"></a>01914       {
<a name="l01915"></a>01915         START_LOG(<span class="stringliteral">&quot;max(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01916"></a>01916     
<a name="l01917"></a>01917         std::vector&lt;unsigned int&gt; ruint;
<a name="l01918"></a>01918         <a class="code" href="namespacelibMesh_1_1Parallel.php#af03e39a37c9fb12885a8064b8d3af7b4">pack_vector_bool</a>(r, ruint);
<a name="l01919"></a>01919         std::vector&lt;unsigned int&gt; temp(ruint.size());
<a name="l01920"></a>01920         MPI_Allreduce (&amp;ruint[0],
<a name="l01921"></a>01921                        &amp;temp[0],
<a name="l01922"></a>01922                        ruint.size(),
<a name="l01923"></a>01923                        <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l01924"></a>01924                        MPI_BOR,
<a name="l01925"></a>01925                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01926"></a>01926         <a class="code" href="namespacelibMesh_1_1Parallel.php#a46767a37d3db91f9669ef07a82f09a36">unpack_vector_bool</a>(temp, r);
<a name="l01927"></a>01927 
<a name="l01928"></a>01928         STOP_LOG(<span class="stringliteral">&quot;max(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01929"></a>01929       }
<a name="l01930"></a>01930   }
<a name="l01931"></a>01931 
<a name="l01932"></a>01932 
<a name="l01933"></a>01933   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01934"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">01934</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(T &amp;r,
<a name="l01935"></a>01935                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;max_id,
<a name="l01936"></a>01936                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01937"></a>01937   {
<a name="l01938"></a>01938     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01939"></a>01939       {
<a name="l01940"></a>01940         START_LOG(<span class="stringliteral">&quot;maxloc(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01941"></a>01941     
<a name="l01942"></a>01942         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;T&gt;</a> in;
<a name="l01943"></a>01943         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a> = r;
<a name="l01944"></a>01944         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a> = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01945"></a>01945         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;T&gt;</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l01946"></a>01946         MPI_Allreduce (&amp;in,
<a name="l01947"></a>01947                        &amp;out,
<a name="l01948"></a>01948                        1,
<a name="l01949"></a>01949                        dataplusint_type&lt;T&gt;(),
<a name="l01950"></a>01950                        MPI_MAXLOC,
<a name="l01951"></a>01951                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01952"></a>01952         r = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a>;
<a name="l01953"></a>01953         max_id = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a>;
<a name="l01954"></a>01954 
<a name="l01955"></a>01955         STOP_LOG(<span class="stringliteral">&quot;maxloc(scalar)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01956"></a>01956       }
<a name="l01957"></a>01957     <span class="keywordflow">else</span>
<a name="l01958"></a>01958       max_id = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01959"></a>01959   }
<a name="l01960"></a>01960 
<a name="l01961"></a>01961 
<a name="l01962"></a>01962   <span class="keyword">template</span> &lt;&gt;
<a name="l01963"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a63ed6a5bb19a1d568450f48a9eed9898">01963</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(<span class="keywordtype">bool</span> &amp;r,
<a name="l01964"></a>01964                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;max_id,
<a name="l01965"></a>01965                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01966"></a>01966   {
<a name="l01967"></a>01967     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l01968"></a>01968       {
<a name="l01969"></a>01969         START_LOG(<span class="stringliteral">&quot;maxloc(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01970"></a>01970     
<a name="l01971"></a>01971         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;int&gt;</a> in;
<a name="l01972"></a>01972         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a> = r;
<a name="l01973"></a>01973         in.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a> = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01974"></a>01974         <a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php">DataPlusInt&lt;int&gt;</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l01975"></a>01975         MPI_Allreduce (&amp;in,
<a name="l01976"></a>01976                        &amp;out,
<a name="l01977"></a>01977                        1,
<a name="l01978"></a>01978                        <a class="code" href="namespacelibMesh_1_1Parallel.php#adf81719823c7f2fce868c3d33062e59f">dataplusint_type&lt;int&gt;</a>(),
<a name="l01979"></a>01979                        MPI_MAXLOC,
<a name="l01980"></a>01980                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l01981"></a>01981         r = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a991f140f5972001528646a75bcfe9afb">val</a>;
<a name="l01982"></a>01982         max_id = out.<a class="code" href="classlibMesh_1_1Parallel_1_1DataPlusInt.php#a841730cbf0df1acf583d8d97c32db03c">rank</a>;
<a name="l01983"></a>01983 
<a name="l01984"></a>01984         STOP_LOG(<span class="stringliteral">&quot;maxloc(bool)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01985"></a>01985       }
<a name="l01986"></a>01986     <span class="keywordflow">else</span>
<a name="l01987"></a>01987       max_id = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l01988"></a>01988   }
<a name="l01989"></a>01989 
<a name="l01990"></a>01990 
<a name="l01991"></a>01991   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01992"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a6cd220ed615f17651ba8366afdbf39de">01992</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(std::vector&lt;T&gt; &amp;r,
<a name="l01993"></a>01993                      std::vector&lt;unsigned int&gt; &amp;max_id,
<a name="l01994"></a>01994                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l01995"></a>01995   {
<a name="l01996"></a>01996     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01997"></a>01997       {
<a name="l01998"></a>01998         START_LOG(<span class="stringliteral">&quot;maxloc(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01999"></a>01999     
<a name="l02000"></a>02000         std::vector&lt;DataPlusInt&lt;T&gt; &gt; in(r.size());
<a name="l02001"></a>02001         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l02002"></a>02002           {
<a name="l02003"></a>02003             in[i].val  = r[i];
<a name="l02004"></a>02004             in[i].rank = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l02005"></a>02005           }
<a name="l02006"></a>02006         std::vector&lt;DataPlusInt&lt;T&gt; &gt; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>(r.size());
<a name="l02007"></a>02007         MPI_Allreduce (&amp;in[0],
<a name="l02008"></a>02008                        &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[0],
<a name="l02009"></a>02009                        r.size(),
<a name="l02010"></a>02010                        dataplusint_type&lt;T&gt;(),
<a name="l02011"></a>02011                        MPI_MAXLOC,
<a name="l02012"></a>02012                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02013"></a>02013         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l02014"></a>02014           {
<a name="l02015"></a>02015             r[i]      = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].val;
<a name="l02016"></a>02016             max_id[i] = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].rank;
<a name="l02017"></a>02017           }
<a name="l02018"></a>02018 
<a name="l02019"></a>02019         STOP_LOG(<span class="stringliteral">&quot;maxloc(vector)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02020"></a>02020       }
<a name="l02021"></a>02021     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!r.empty())
<a name="l02022"></a>02022       {
<a name="l02023"></a>02023         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l02024"></a>02024           max_id[i] = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l02025"></a>02025       }
<a name="l02026"></a>02026   }
<a name="l02027"></a>02027 
<a name="l02028"></a>02028 
<a name="l02029"></a>02029   <span class="keyword">template</span> &lt;&gt;
<a name="l02030"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a739ed7435b4e8a1925a789e66a809529">02030</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(std::vector&lt;bool&gt; &amp;r,
<a name="l02031"></a>02031                      std::vector&lt;unsigned int&gt; &amp;max_id,
<a name="l02032"></a>02032                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02033"></a>02033   {
<a name="l02034"></a>02034     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l02035"></a>02035       {
<a name="l02036"></a>02036         START_LOG(<span class="stringliteral">&quot;maxloc(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02037"></a>02037     
<a name="l02038"></a>02038         std::vector&lt;DataPlusInt&lt;int&gt; &gt; in(r.size());
<a name="l02039"></a>02039         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l02040"></a>02040           {
<a name="l02041"></a>02041             in[i].val  = r[i];
<a name="l02042"></a>02042             in[i].rank = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l02043"></a>02043           }
<a name="l02044"></a>02044         std::vector&lt;DataPlusInt&lt;int&gt; &gt; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>(r.size());
<a name="l02045"></a>02045         MPI_Allreduce (&amp;in[0],
<a name="l02046"></a>02046                        &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[0],
<a name="l02047"></a>02047                        r.size(),
<a name="l02048"></a>02048                        <a class="code" href="namespacelibMesh_1_1Parallel.php#a3d3a349564dd87fb292c2781d422b84b">datatype&lt;int&gt;</a>(),
<a name="l02049"></a>02049                        MPI_MAXLOC,
<a name="l02050"></a>02050                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02051"></a>02051         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l02052"></a>02052           {
<a name="l02053"></a>02053             r[i]      = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].val;
<a name="l02054"></a>02054             max_id[i] = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>[i].rank;
<a name="l02055"></a>02055           }
<a name="l02056"></a>02056 
<a name="l02057"></a>02057         STOP_LOG(<span class="stringliteral">&quot;maxloc(vector&lt;bool&gt;)&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02058"></a>02058       }
<a name="l02059"></a>02059     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!r.empty())
<a name="l02060"></a>02060       {
<a name="l02061"></a>02061         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l02062"></a>02062           max_id[i] = comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>();
<a name="l02063"></a>02063       }
<a name="l02064"></a>02064   }
<a name="l02065"></a>02065 
<a name="l02066"></a>02066 
<a name="l02067"></a>02067   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02068"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">02068</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(T &amp;r,
<a name="l02069"></a>02069                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02070"></a>02070   {
<a name="l02071"></a>02071     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l02072"></a>02072       {
<a name="l02073"></a>02073         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02074"></a>02074     
<a name="l02075"></a>02075         T temp = r;
<a name="l02076"></a>02076         MPI_Allreduce (&amp;temp,
<a name="l02077"></a>02077                        &amp;r,
<a name="l02078"></a>02078                        1,
<a name="l02079"></a>02079                        datatype&lt;T&gt;(),
<a name="l02080"></a>02080                        MPI_SUM,
<a name="l02081"></a>02081                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02082"></a>02082 
<a name="l02083"></a>02083         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02084"></a>02084       }
<a name="l02085"></a>02085   }
<a name="l02086"></a>02086 
<a name="l02087"></a>02087 
<a name="l02088"></a>02088   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02089"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ad64662eca90ef26788c5214cbd35d7e6">02089</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(std::vector&lt;T&gt; &amp;r,
<a name="l02090"></a>02090                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02091"></a>02091   {
<a name="l02092"></a>02092     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l02093"></a>02093       {
<a name="l02094"></a>02094         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02095"></a>02095     
<a name="l02096"></a>02096         std::vector&lt;T&gt; temp(r);
<a name="l02097"></a>02097         MPI_Allreduce (&amp;temp[0],
<a name="l02098"></a>02098                        &amp;r[0],
<a name="l02099"></a>02099                        r.size(),
<a name="l02100"></a>02100                        datatype&lt;T&gt;(),
<a name="l02101"></a>02101                        MPI_SUM,
<a name="l02102"></a>02102                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02103"></a>02103 
<a name="l02104"></a>02104         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02105"></a>02105       }
<a name="l02106"></a>02106   }
<a name="l02107"></a>02107 
<a name="l02108"></a>02108 
<a name="l02109"></a>02109 
<a name="l02110"></a>02110   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l02111"></a>02111   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02112"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a9a6321be080e2b0f5eade8e280dc350e">02112</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(std::complex&lt;T&gt; &amp;r,
<a name="l02113"></a>02113                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02114"></a>02114   {
<a name="l02115"></a>02115     <span class="keywordflow">if</span> (comm.size() &gt; 1)
<a name="l02116"></a>02116       {
<a name="l02117"></a>02117         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02118"></a>02118     
<a name="l02119"></a>02119         std::complex&lt;T&gt; temp(r);
<a name="l02120"></a>02120         MPI_Allreduce (&amp;temp,
<a name="l02121"></a>02121                        &amp;r,
<a name="l02122"></a>02122                        2,
<a name="l02123"></a>02123                        datatype&lt;T&gt;(),
<a name="l02124"></a>02124                        MPI_SUM,
<a name="l02125"></a>02125                        comm.get());
<a name="l02126"></a>02126 
<a name="l02127"></a>02127         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02128"></a>02128       }
<a name="l02129"></a>02129   }
<a name="l02130"></a>02130 
<a name="l02131"></a>02131 
<a name="l02132"></a>02132   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02133"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab4970e798154cba9435d49aa5c521cf6">02133</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(std::vector&lt;std::complex&lt;T&gt; &gt; &amp;r,
<a name="l02134"></a>02134                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02135"></a>02135   {
<a name="l02136"></a>02136     <span class="keywordflow">if</span> (comm.size() &gt; 1 &amp;&amp; !r.empty())
<a name="l02137"></a>02137       {
<a name="l02138"></a>02138         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02139"></a>02139     
<a name="l02140"></a>02140         std::vector&lt;std::complex&lt;T&gt; &gt; temp(r);
<a name="l02141"></a>02141         MPI_Allreduce (&amp;temp[0],
<a name="l02142"></a>02142                        &amp;r[0],
<a name="l02143"></a>02143                        r.size() * 2,
<a name="l02144"></a>02144                        datatype&lt;T&gt;(),
<a name="l02145"></a>02145                        MPI_SUM,
<a name="l02146"></a>02146                        comm.get());
<a name="l02147"></a>02147 
<a name="l02148"></a>02148         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02149"></a>02149       }
<a name="l02150"></a>02150   }
<a name="l02151"></a>02151 
<a name="l02152"></a>02152 
<a name="l02153"></a>02153 
<a name="l02154"></a>02154   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02155"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">02155</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">set_union</a>(std::set&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l02156"></a>02156                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02157"></a>02157   {
<a name="l02158"></a>02158     std::vector&lt;T&gt; vecdata(data.begin(), data.end());
<a name="l02159"></a>02159     <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">Parallel::gather</a>(root_id, vecdata, comm);
<a name="l02160"></a>02160     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() == root_id)
<a name="l02161"></a>02161       data.insert(vecdata.begin(), vecdata.end());
<a name="l02162"></a>02162   }
<a name="l02163"></a>02163 
<a name="l02164"></a>02164 
<a name="l02165"></a>02165 
<a name="l02166"></a>02166   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02167"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a1b49ec04ec5eeb03919f14ebfc16b7d8">02167</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">set_union</a>(std::set&lt;T&gt; &amp;data,
<a name="l02168"></a>02168                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02169"></a>02169   {
<a name="l02170"></a>02170     std::vector&lt;T&gt; vecdata(data.begin(), data.end());
<a name="l02171"></a>02171     <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(vecdata, <span class="keyword">false</span>, comm);
<a name="l02172"></a>02172     data.insert(vecdata.begin(), vecdata.end());
<a name="l02173"></a>02173   }
<a name="l02174"></a>02174 
<a name="l02175"></a>02175 
<a name="l02176"></a>02176 
<a name="l02177"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">02177</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">probe</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02178"></a>02178                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02179"></a>02179                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02180"></a>02180   {
<a name="l02181"></a>02181     START_LOG(<span class="stringliteral">&quot;probe()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02182"></a>02182 
<a name="l02183"></a>02183     <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02184"></a>02184 
<a name="l02185"></a>02185     MPI_Probe (src_processor_id, 
<a name="l02186"></a>02186                tag.<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">value</a>(), 
<a name="l02187"></a>02187                comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>(), 
<a name="l02188"></a>02188                &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>);
<a name="l02189"></a>02189 
<a name="l02190"></a>02190     STOP_LOG(<span class="stringliteral">&quot;probe()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02191"></a>02191 
<a name="l02192"></a>02192     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02193"></a>02193   }  
<a name="l02194"></a>02194 
<a name="l02195"></a>02195 
<a name="l02196"></a>02196 
<a name="l02197"></a>02197   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02198"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">02198</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02199"></a>02199                     std::vector&lt;T&gt; &amp;buf,
<a name="l02200"></a>02200                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02201"></a>02201                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02202"></a>02202                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02203"></a>02203   {    
<a name="l02204"></a>02204     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02205"></a>02205 
<a name="l02206"></a>02206 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02207"></a>02207 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02208"></a>02208     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02209"></a>02209 <span class="preprocessor">#endif</span>
<a name="l02210"></a>02210 <span class="preprocessor"></span>      MPI_Send (buf.empty() ? NULL : &amp;buf[0],
<a name="l02211"></a>02211                 buf.size(),
<a name="l02212"></a>02212                 type,
<a name="l02213"></a>02213                 dest_processor_id,
<a name="l02214"></a>02214                 tag.<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">value</a>(),
<a name="l02215"></a>02215                 comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02216"></a>02216 
<a name="l02217"></a>02217     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l02218"></a>02218     
<a name="l02219"></a>02219     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02220"></a>02220   }
<a name="l02221"></a>02221 
<a name="l02222"></a>02222 
<a name="l02223"></a>02223 
<a name="l02224"></a>02224   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02225"></a>02225   <span class="comment">// function template, so we have to re-specify the default arguments</span>
<a name="l02226"></a>02226   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02227"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a7a31d174a4b0e380b07dff6457f55801">02227</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02228"></a>02228                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l02229"></a>02229                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02230"></a>02230                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l02231"></a>02231                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02232"></a>02232   {    
<a name="l02233"></a>02233     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02234"></a>02234 
<a name="l02235"></a>02235 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02236"></a>02236 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02237"></a>02237     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02238"></a>02238 <span class="preprocessor">#endif</span>
<a name="l02239"></a>02239 <span class="preprocessor"></span>      MPI_Send (buf.empty() ? NULL : &amp;buf[0],
<a name="l02240"></a>02240                 buf.size() * 2,
<a name="l02241"></a>02241                 type,
<a name="l02242"></a>02242                 dest_processor_id,
<a name="l02243"></a>02243                 tag.value(),
<a name="l02244"></a>02244                 comm.get());
<a name="l02245"></a>02245 
<a name="l02246"></a>02246     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l02247"></a>02247     
<a name="l02248"></a>02248     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02249"></a>02249   }
<a name="l02250"></a>02250 
<a name="l02251"></a>02251 
<a name="l02252"></a>02252 
<a name="l02253"></a>02253   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02254"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2862a0e5def6c419e1c39364eab6300f">02254</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02255"></a>02255                     std::vector&lt;T&gt; &amp;buf,
<a name="l02256"></a>02256                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02257"></a>02257                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l02258"></a>02258                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02259"></a>02259                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02260"></a>02260   {    
<a name="l02261"></a>02261     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02262"></a>02262 
<a name="l02263"></a>02263 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02264"></a>02264 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02265"></a>02265     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02266"></a>02266 <span class="preprocessor">#endif</span>
<a name="l02267"></a>02267 <span class="preprocessor"></span>      MPI_Isend (buf.empty() ? NULL : &amp;buf[0],
<a name="l02268"></a>02268                  buf.size(),
<a name="l02269"></a>02269                  type,
<a name="l02270"></a>02270                  dest_processor_id,
<a name="l02271"></a>02271                  tag.<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">value</a>(),
<a name="l02272"></a>02272                  comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>(),
<a name="l02273"></a>02273                  req.<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a1c0f2d81c8f7d6148235fb57f4966f2c">get</a>());    
<a name="l02274"></a>02274     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l02275"></a>02275 
<a name="l02276"></a>02276     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02277"></a>02277   }
<a name="l02278"></a>02278 
<a name="l02279"></a>02279 
<a name="l02280"></a>02280   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02281"></a>02281   <span class="comment">// function template, so we have to re-specify the default arguments</span>
<a name="l02282"></a>02282   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02283"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#abadbf1b235a47d40d27596209560859b">02283</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02284"></a>02284                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l02285"></a>02285                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02286"></a>02286                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l02287"></a>02287                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c2f05e8c57da65fd46aaa24d0af4078">no_tag</a>,
<a name="l02288"></a>02288                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02289"></a>02289   {
<a name="l02290"></a>02290     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02291"></a>02291 
<a name="l02292"></a>02292 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02293"></a>02293 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02294"></a>02294     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =      
<a name="l02295"></a>02295 <span class="preprocessor">#endif</span>
<a name="l02296"></a>02296 <span class="preprocessor"></span>      MPI_ISend (buf.empty() ? NULL : &amp;buf[0],
<a name="l02297"></a>02297                  buf.size() * 2,
<a name="l02298"></a>02298                  type,
<a name="l02299"></a>02299                  dest_processor_id,
<a name="l02300"></a>02300                  tag.value(),
<a name="l02301"></a>02301                  comm.get(),
<a name="l02302"></a>02302                  req.<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a1c0f2d81c8f7d6148235fb57f4966f2c">get</a>());    
<a name="l02303"></a>02303     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02304"></a>02304 
<a name="l02305"></a>02305     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02306"></a>02306   }
<a name="l02307"></a>02307 
<a name="l02308"></a>02308 
<a name="l02309"></a>02309 
<a name="l02310"></a>02310   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02311"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">02311</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02312"></a>02312                          std::vector&lt;T&gt; &amp;buf,
<a name="l02313"></a>02313                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02314"></a>02314                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02315"></a>02315                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02316"></a>02316   {
<a name="l02317"></a>02317     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02318"></a>02318 
<a name="l02319"></a>02319     <span class="comment">// Get the status of the message, explicitly provide the</span>
<a name="l02320"></a>02320     <span class="comment">// datatype so we can later query the size</span>
<a name="l02321"></a>02321     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>(<a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">Parallel::probe</a>(src_processor_id, tag, comm), type);
<a name="l02322"></a>02322 
<a name="l02323"></a>02323     buf.resize(status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a4d5e449ef6b83498be62ee2a83923a91">size</a>());
<a name="l02324"></a>02324     
<a name="l02325"></a>02325 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02326"></a>02326 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02327"></a>02327     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02328"></a>02328 <span class="preprocessor">#endif</span>
<a name="l02329"></a>02329 <span class="preprocessor"></span>      MPI_Recv (buf.empty() ? NULL : &amp;buf[0],
<a name="l02330"></a>02330                 buf.size(),
<a name="l02331"></a>02331                 type,
<a name="l02332"></a>02332                 src_processor_id,
<a name="l02333"></a>02333                 tag.<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">value</a>(),
<a name="l02334"></a>02334                 comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>(),
<a name="l02335"></a>02335                 <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>);
<a name="l02336"></a>02336     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02337"></a>02337 
<a name="l02338"></a>02338     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02339"></a>02339 
<a name="l02340"></a>02340     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02341"></a>02341   }
<a name="l02342"></a>02342 
<a name="l02343"></a>02343 
<a name="l02344"></a>02344 
<a name="l02345"></a>02345   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02346"></a>02346   <span class="comment">// function template, so we have to re-specify the default arguments</span>
<a name="l02347"></a>02347   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02348"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a2d31550c174991d49d4fb5efe5c352c2">02348</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02349"></a>02349                          std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l02350"></a>02350                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02351"></a>02351                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l02352"></a>02352                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02353"></a>02353   {
<a name="l02354"></a>02354     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02355"></a>02355 
<a name="l02356"></a>02356     <span class="comment">// Get the status of the message, explicitly provide the</span>
<a name="l02357"></a>02357     <span class="comment">// datatype so we can later query the size</span>
<a name="l02358"></a>02358     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>(<a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">Parallel::probe</a>(src_processor_id, tag, comm), datatype&lt;T&gt;());
<a name="l02359"></a>02359 
<a name="l02360"></a>02360     libmesh_assert(!(status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a4d5e449ef6b83498be62ee2a83923a91">size</a>()%2));
<a name="l02361"></a>02361     buf.resize(status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#a4d5e449ef6b83498be62ee2a83923a91">size</a>()/2);
<a name="l02362"></a>02362     
<a name="l02363"></a>02363 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02364"></a>02364 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02365"></a>02365     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =      
<a name="l02366"></a>02366 <span class="preprocessor">#endif</span>
<a name="l02367"></a>02367 <span class="preprocessor"></span>      MPI_Recv (buf.empty() ? NULL : &amp;buf[0],
<a name="l02368"></a>02368                 buf.size() * 2,
<a name="l02369"></a>02369                 type,
<a name="l02370"></a>02370                 src_processor_id,
<a name="l02371"></a>02371                 tag.value(),
<a name="l02372"></a>02372                 comm.get(),
<a name="l02373"></a>02373                 <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>);
<a name="l02374"></a>02374     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02375"></a>02375     
<a name="l02376"></a>02376     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02377"></a>02377 
<a name="l02378"></a>02378     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02379"></a>02379   }
<a name="l02380"></a>02380 
<a name="l02381"></a>02381 
<a name="l02382"></a>02382 
<a name="l02383"></a>02383   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02384"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a9aa8d3b5b9038a387b3dc63228c60534">02384</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02385"></a>02385                        std::vector&lt;T&gt; &amp;buf,
<a name="l02386"></a>02386                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02387"></a>02387                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l02388"></a>02388                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02389"></a>02389                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02390"></a>02390   {
<a name="l02391"></a>02391     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02392"></a>02392 
<a name="l02393"></a>02393 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02394"></a>02394 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02395"></a>02395     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02396"></a>02396 <span class="preprocessor">#endif</span>
<a name="l02397"></a>02397 <span class="preprocessor"></span>      MPI_Irecv (buf.empty() ? NULL : &amp;buf[0],
<a name="l02398"></a>02398                  buf.size(),
<a name="l02399"></a>02399                  type,
<a name="l02400"></a>02400                  src_processor_id,
<a name="l02401"></a>02401                  tag.<a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php#a521788a9c665c20c944b611413b0ec35">value</a>(),
<a name="l02402"></a>02402                  comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>(),
<a name="l02403"></a>02403                  req.<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a1c0f2d81c8f7d6148235fb57f4966f2c">get</a>());    
<a name="l02404"></a>02404     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l02405"></a>02405 
<a name="l02406"></a>02406     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02407"></a>02407   }
<a name="l02408"></a>02408 
<a name="l02409"></a>02409 
<a name="l02410"></a>02410 
<a name="l02411"></a>02411   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02412"></a>02412   <span class="comment">// function template, so we have to re-specify the default arguments</span>
<a name="l02413"></a>02413   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02414"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab0dc8ca76df8df1c26e89b3ad6424140">02414</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02415"></a>02415                        std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l02416"></a>02416                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02417"></a>02417                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l02418"></a>02418                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0c0fd69f268eede17208c4c720ac19d5">any_tag</a>,
<a name="l02419"></a>02419                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm=<a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02420"></a>02420   {
<a name="l02421"></a>02421     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02422"></a>02422 
<a name="l02423"></a>02423     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =      
<a name="l02424"></a>02424       MPI_Irecv (buf.empty() ? NULL : &amp;buf[0],
<a name="l02425"></a>02425                 buf.size() * 2,
<a name="l02426"></a>02426                 type,
<a name="l02427"></a>02427                 src_processor_id,
<a name="l02428"></a>02428                 tag.value(),
<a name="l02429"></a>02429                 comm.get(),
<a name="l02430"></a>02430                 req.<a class="code" href="classlibMesh_1_1Parallel_1_1Request.php#a1c0f2d81c8f7d6148235fb57f4966f2c">get</a>());
<a name="l02431"></a>02431 
<a name="l02432"></a>02432     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02433"></a>02433     
<a name="l02434"></a>02434     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02435"></a>02435 
<a name="l02436"></a>02436     <span class="keywordflow">return</span>;
<a name="l02437"></a>02437   }
<a name="l02438"></a>02438 
<a name="l02439"></a>02439   
<a name="l02440"></a>02440 
<a name="l02441"></a>02441   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02442"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a6c36756bf64e4cf3602e8c9e40234902">02442</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02443"></a>02443                     std::set&lt;T&gt; &amp;buf,
<a name="l02444"></a>02444                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02445"></a>02445                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02446"></a>02446                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02447"></a>02447   {    
<a name="l02448"></a>02448     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02449"></a>02449 
<a name="l02450"></a>02450     std::vector&lt;T&gt; vecbuf(buf.begin(), buf.end());
<a name="l02451"></a>02451     <span class="comment">// Use Parallel::send() so we get its specialization(s)</span>
<a name="l02452"></a>02452     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(dest_processor_id, vecbuf, type, tag, comm);
<a name="l02453"></a>02453 
<a name="l02454"></a>02454     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02455"></a>02455   }
<a name="l02456"></a>02456 
<a name="l02457"></a>02457 
<a name="l02458"></a>02458 
<a name="l02459"></a>02459   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02460"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa9dae039b99ad8b0bbd3575d095c73e1">02460</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02461"></a>02461                     std::set&lt;T&gt; &amp;buf,
<a name="l02462"></a>02462                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02463"></a>02463                     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l02464"></a>02464                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02465"></a>02465                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02466"></a>02466   {    
<a name="l02467"></a>02467     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02468"></a>02468 
<a name="l02469"></a>02469     std::vector&lt;T&gt; vecbuf(buf.begin(), buf.end());
<a name="l02470"></a>02470     <span class="comment">// Use Parallel::send() so we get its specialization(s)</span>
<a name="l02471"></a>02471     <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(dest_processor_id, vecbuf, type, req, tag, comm);
<a name="l02472"></a>02472 
<a name="l02473"></a>02473     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02474"></a>02474   }
<a name="l02475"></a>02475 
<a name="l02476"></a>02476 
<a name="l02477"></a>02477 
<a name="l02478"></a>02478   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02479"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#abff64a946302f7ebac87b6d209168ddf">02479</a>   <span class="keyword">inline</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02480"></a>02480                          std::set&lt;T&gt; &amp;buf,
<a name="l02481"></a>02481                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02482"></a>02482                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02483"></a>02483                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02484"></a>02484   {
<a name="l02485"></a>02485     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02486"></a>02486 
<a name="l02487"></a>02487     std::vector&lt;T&gt; vecbuf;
<a name="l02488"></a>02488     <span class="comment">// Use Parallel::receive() so we get its specialization(s)</span>
<a name="l02489"></a>02489     <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Status</a> <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> = <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(src_processor_id, vecbuf, type, tag, comm);
<a name="l02490"></a>02490     buf.assign(vecbuf.begin(), vecbuf.end());
<a name="l02491"></a>02491 
<a name="l02492"></a>02492     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02493"></a>02493 
<a name="l02494"></a>02494     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02495"></a>02495   }
<a name="l02496"></a>02496 
<a name="l02497"></a>02497 
<a name="l02498"></a>02498 
<a name="l02499"></a>02499   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02500"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ae7283e42420d4ff002859fa70e6e481c">02500</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l02501"></a>02501                        std::set&lt;T&gt; &amp;buf,
<a name="l02502"></a>02502                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02503"></a>02503                        <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Request</a> &amp;req,
<a name="l02504"></a>02504                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a> &amp;tag,
<a name="l02505"></a>02505                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02506"></a>02506   {
<a name="l02507"></a>02507     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02508"></a>02508 
<a name="l02509"></a>02509     std::vector&lt;T&gt; vecbuf;
<a name="l02510"></a>02510     <span class="comment">// Use Parallel::receive() so we get its specialization(s)</span>
<a name="l02511"></a>02511     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(src_processor_id, vecbuf, type, req, tag, comm);
<a name="l02512"></a>02512     buf.assign(vecbuf.begin(), vecbuf.end());
<a name="l02513"></a>02513 
<a name="l02514"></a>02514     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02515"></a>02515   }
<a name="l02516"></a>02516 
<a name="l02517"></a>02517 
<a name="l02518"></a>02518 
<a name="l02519"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">02519</a>   <span class="keyword">inline</span> <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (<a class="code" href="structlibMesh_1_1Parallel_1_1request.php">request</a> &amp;r)
<a name="l02520"></a>02520   {
<a name="l02521"></a>02521     START_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02522"></a>02522 
<a name="l02523"></a>02523     <a class="code" href="structlibMesh_1_1Parallel_1_1status.php">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02524"></a>02524 
<a name="l02525"></a>02525     MPI_Wait (&amp;r, &amp;status);
<a name="l02526"></a>02526 
<a name="l02527"></a>02527     STOP_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02528"></a>02528 
<a name="l02529"></a>02529     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>;
<a name="l02530"></a>02530   }
<a name="l02531"></a>02531 
<a name="l02532"></a>02532   
<a name="l02533"></a>02533 
<a name="l02534"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#adb898cf9838fb7d72d44e86908ae1473">02534</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (std::vector&lt;request&gt; &amp;r)
<a name="l02535"></a>02535   {
<a name="l02536"></a>02536     START_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02537"></a>02537     
<a name="l02538"></a>02538     MPI_Waitall (r.size(), r.empty() ? NULL : &amp;r[0], MPI_STATUSES_IGNORE);
<a name="l02539"></a>02539 
<a name="l02540"></a>02540     STOP_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02541"></a>02541   }
<a name="l02542"></a>02542 
<a name="l02543"></a>02543 
<a name="l02544"></a>02544 
<a name="l02545"></a>02545   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02546"></a>02546   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l02547"></a>02547   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02548"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ae154418e8b934355a61dd85697ff57e2">02548</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02549"></a>02549                            std::vector&lt;T&gt; &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02550"></a>02550                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l02551"></a>02551                            std::vector&lt;T&gt; &amp;recv,
<a name="l02552"></a>02552                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1DataType.php">DataType</a> &amp;type,
<a name="l02553"></a>02553                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02554"></a>02554   {
<a name="l02555"></a>02555     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02556"></a>02556 
<a name="l02557"></a>02557     <span class="keywordflow">if</span> (dest_processor_id   == comm.rank() &amp;&amp;
<a name="l02558"></a>02558         source_processor_id == comm.rank())
<a name="l02559"></a>02559       {
<a name="l02560"></a>02560         recv = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l02561"></a>02561         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02562"></a>02562         <span class="keywordflow">return</span>;
<a name="l02563"></a>02563       }
<a name="l02564"></a>02564 
<a name="l02565"></a>02565     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Parallel::Request</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">request</a>;
<a name="l02566"></a>02566     
<a name="l02567"></a>02567     <a class="code" href="namespacelibMesh_1_1Parallel.php#ae6bd6cc9034a501ab87f131846e17038">Parallel::nonblocking_send</a> (dest_processor_id,
<a name="l02568"></a>02568                                 send,
<a name="l02569"></a>02569                                 type,
<a name="l02570"></a>02570                                 request,
<a name="l02571"></a>02571                                 <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>(321),
<a name="l02572"></a>02572                                 comm);
<a name="l02573"></a>02573     
<a name="l02574"></a>02574     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_processor_id,
<a name="l02575"></a>02575                        recv,
<a name="l02576"></a>02576                        type,
<a name="l02577"></a>02577                        <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">MessageTag</a>(321),
<a name="l02578"></a>02578                        comm);
<a name="l02579"></a>02579     
<a name="l02580"></a>02580     <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (request);
<a name="l02581"></a>02581     
<a name="l02582"></a>02582     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02583"></a>02583   }
<a name="l02584"></a>02584   
<a name="l02585"></a>02585 
<a name="l02586"></a>02586   
<a name="l02587"></a>02587   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02588"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">02588</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02589"></a>02589                            T &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02590"></a>02590                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l02591"></a>02591                            T &amp;recv,
<a name="l02592"></a>02592                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02593"></a>02593   {
<a name="l02594"></a>02594     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02595"></a>02595 
<a name="l02596"></a>02596     <span class="keywordflow">if</span> (dest_processor_id   == comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() &amp;&amp;
<a name="l02597"></a>02597         source_processor_id == comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>())
<a name="l02598"></a>02598       {
<a name="l02599"></a>02599         recv = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l02600"></a>02600         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02601"></a>02601         <span class="keywordflow">return</span>;
<a name="l02602"></a>02602       }
<a name="l02603"></a>02603 
<a name="l02604"></a>02604     MPI_Sendrecv(&amp;send, 1, datatype&lt;T&gt;(),
<a name="l02605"></a>02605                  dest_processor_id, 0,
<a name="l02606"></a>02606                  &amp;recv, 1, datatype&lt;T&gt;(),
<a name="l02607"></a>02607                  source_processor_id, 0,
<a name="l02608"></a>02608                  comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>(),
<a name="l02609"></a>02609                  MPI_STATUS_IGNORE);
<a name="l02610"></a>02610 
<a name="l02611"></a>02611     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02612"></a>02612   }
<a name="l02613"></a>02613 
<a name="l02614"></a>02614 
<a name="l02615"></a>02615 
<a name="l02616"></a>02616   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02617"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a65a4e476bd7515d965282dff17ac0785">02617</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02618"></a>02618                            std::complex&lt;T&gt; &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02619"></a>02619                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l02620"></a>02620                            std::complex&lt;T&gt; &amp;recv,
<a name="l02621"></a>02621                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02622"></a>02622   {
<a name="l02623"></a>02623     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02624"></a>02624 
<a name="l02625"></a>02625     <span class="keywordflow">if</span> (dest_processor_id   == comm.rank() &amp;&amp;
<a name="l02626"></a>02626         source_processor_id == comm.rank())
<a name="l02627"></a>02627       {
<a name="l02628"></a>02628         recv = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l02629"></a>02629         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02630"></a>02630         <span class="keywordflow">return</span>;
<a name="l02631"></a>02631       }
<a name="l02632"></a>02632 
<a name="l02633"></a>02633     MPI_Sendrecv(&amp;send, 2, datatype&lt;T&gt;(),
<a name="l02634"></a>02634                  dest_processor_id, 0,
<a name="l02635"></a>02635                  &amp;recv, 2, datatype&lt;T&gt;(),
<a name="l02636"></a>02636                  source_processor_id, 0,
<a name="l02637"></a>02637                  comm.get(),
<a name="l02638"></a>02638                  MPI_STATUS_IGNORE);
<a name="l02639"></a>02639 
<a name="l02640"></a>02640     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02641"></a>02641   }
<a name="l02642"></a>02642 
<a name="l02643"></a>02643 
<a name="l02644"></a>02644 
<a name="l02645"></a>02645   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02646"></a>02646   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l02647"></a>02647   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02648"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ae24bd46568d908cba305a2a5779673bc">02648</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02649"></a>02649                            std::vector&lt;T&gt; &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02650"></a>02650                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l02651"></a>02651                            std::vector&lt;T&gt; &amp;recv,
<a name="l02652"></a>02652                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02653"></a>02653   {
<a name="l02654"></a>02654     <span class="comment">// Call the user-defined type version with automatic </span>
<a name="l02655"></a>02655     <span class="comment">// type conversion based on template argument:    </span>
<a name="l02656"></a>02656     <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a> (dest_processor_id,
<a name="l02657"></a>02657                   send,
<a name="l02658"></a>02658                   source_processor_id,
<a name="l02659"></a>02659                   recv,
<a name="l02660"></a>02660                   datatype&lt;T&gt;(),
<a name="l02661"></a>02661                   comm);
<a name="l02662"></a>02662   }
<a name="l02663"></a>02663 
<a name="l02664"></a>02664 
<a name="l02665"></a>02665 
<a name="l02666"></a>02666   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02667"></a>02667   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l02668"></a>02668   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02669"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a883b447e19c31bbf2cd74e4ba8d42f1b">02669</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l02670"></a>02670                            std::vector&lt;std::vector&lt;T&gt; &gt; &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02671"></a>02671                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l02672"></a>02672                            std::vector&lt;std::vector&lt;T&gt; &gt; &amp;recv,
<a name="l02673"></a>02673                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02674"></a>02674   {
<a name="l02675"></a>02675     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02676"></a>02676 
<a name="l02677"></a>02677     <span class="keywordflow">if</span> (dest_processor_id   == comm.rank() &amp;&amp;
<a name="l02678"></a>02678         source_processor_id == comm.rank())
<a name="l02679"></a>02679       {
<a name="l02680"></a>02680         recv = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l02681"></a>02681         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02682"></a>02682         <span class="keywordflow">return</span>;
<a name="l02683"></a>02683       }
<a name="l02684"></a>02684     
<a name="l02685"></a>02685     <span class="comment">// temporary buffers - these will be sized in bytes</span>
<a name="l02686"></a>02686     <span class="comment">// and manipulated with MPI_Pack and friends</span>
<a name="l02687"></a>02687     std::vector&lt;char&gt; sendbuf, recvbuf;
<a name="l02688"></a>02688 
<a name="l02689"></a>02689     <span class="comment">// figure out how many bytes we need to pack all the data</span>
<a name="l02690"></a>02690     <span class="keywordtype">int</span> packedsize=0, sendsize=0;
<a name="l02691"></a>02691 
<a name="l02692"></a>02692     <span class="comment">// The outer buffer size</span>
<a name="l02693"></a>02693     MPI_Pack_size (1,           
<a name="l02694"></a>02694                    <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l02695"></a>02695                    comm.get(),
<a name="l02696"></a>02696                    &amp;packedsize);
<a name="l02697"></a>02697     sendsize += packedsize;
<a name="l02698"></a>02698 
<a name="l02699"></a>02699     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>.size(); i++)
<a name="l02700"></a>02700       {
<a name="l02701"></a>02701         <span class="comment">// The size of the ith inner buffer</span>
<a name="l02702"></a>02702         MPI_Pack_size (1,           
<a name="l02703"></a>02703                        <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l02704"></a>02704                        comm.get(),
<a name="l02705"></a>02705                        &amp;packedsize);
<a name="l02706"></a>02706         sendsize += packedsize;
<a name="l02707"></a>02707 
<a name="l02708"></a>02708         <span class="comment">// The data for each inner buffer</span>
<a name="l02709"></a>02709         MPI_Pack_size (<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>[i].size(),
<a name="l02710"></a>02710                        datatype&lt;T&gt;(),
<a name="l02711"></a>02711                        comm.get(),
<a name="l02712"></a>02712                        &amp;packedsize);
<a name="l02713"></a>02713         sendsize += packedsize;
<a name="l02714"></a>02714       }
<a name="l02715"></a>02715     
<a name="l02716"></a>02716     libmesh_assert (sendsize <span class="comment">/* should at least be 1! */</span>);
<a name="l02717"></a>02717     sendbuf.resize (sendsize);
<a name="l02718"></a>02718 
<a name="l02719"></a>02719     <span class="comment">// Pack the send buffer</span>
<a name="l02720"></a>02720     <span class="keywordtype">int</span> pos=0;
<a name="l02721"></a>02721 
<a name="l02722"></a>02722     <span class="comment">// ... the size of the outer buffer</span>
<a name="l02723"></a>02723     sendsize = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>.size();
<a name="l02724"></a>02724     MPI_Pack (&amp;sendsize, 1, <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l02725"></a>02725               &amp;sendbuf[0], sendbuf.size(), &amp;pos,
<a name="l02726"></a>02726               comm.get());
<a name="l02727"></a>02727     
<a name="l02728"></a>02728     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>.size(); i++)
<a name="l02729"></a>02729       {
<a name="l02730"></a>02730         <span class="comment">// ... the size of the ith inner buffer</span>
<a name="l02731"></a>02731         sendsize = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>[i].size();
<a name="l02732"></a>02732         MPI_Pack (&amp;sendsize, 1, <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l02733"></a>02733                   &amp;sendbuf[0], sendbuf.size(), &amp;pos,
<a name="l02734"></a>02734                   comm.get());
<a name="l02735"></a>02735         
<a name="l02736"></a>02736         <span class="comment">// ... the contents of the ith inner buffer</span>
<a name="l02737"></a>02737         <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>[i].empty())
<a name="l02738"></a>02738           MPI_Pack (&amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>[i][0], <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>[i].size(), datatype&lt;T&gt;(),
<a name="l02739"></a>02739                     &amp;sendbuf[0], sendbuf.size(), &amp;pos,
<a name="l02740"></a>02740                     comm.get());
<a name="l02741"></a>02741       }
<a name="l02742"></a>02742 
<a name="l02743"></a>02743     libmesh_assert (static_cast&lt;unsigned int&gt;(pos) == sendbuf.size());
<a name="l02744"></a>02744 
<a name="l02745"></a>02745     <a class="code" href="classlibMesh_1_1Parallel_1_1Request.php">Parallel::Request</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">request</a>;
<a name="l02746"></a>02746 
<a name="l02747"></a>02747     <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a> tag = comm.get_unique_tag(123);
<a name="l02748"></a>02748 
<a name="l02749"></a>02749     <a class="code" href="namespacelibMesh_1_1Parallel.php#ae6bd6cc9034a501ab87f131846e17038">Parallel::nonblocking_send</a> (dest_processor_id,
<a name="l02750"></a>02750                                 sendbuf,
<a name="l02751"></a>02751                                 MPI_PACKED,
<a name="l02752"></a>02752                                 request,
<a name="l02753"></a>02753                                 tag,
<a name="l02754"></a>02754                                 comm);
<a name="l02755"></a>02755 
<a name="l02756"></a>02756     <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_processor_id,
<a name="l02757"></a>02757                        recvbuf,
<a name="l02758"></a>02758                        MPI_PACKED,
<a name="l02759"></a>02759                        tag,
<a name="l02760"></a>02760                        comm);
<a name="l02761"></a>02761 
<a name="l02762"></a>02762     <span class="comment">// Unpack the received buffer</span>
<a name="l02763"></a>02763     libmesh_assert (!recvbuf.empty());
<a name="l02764"></a>02764     pos=0;
<a name="l02765"></a>02765     MPI_Unpack (&amp;recvbuf[0], recvbuf.size(), &amp;pos,
<a name="l02766"></a>02766                 &amp;sendsize, 1, <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l02767"></a>02767                 comm.get());
<a name="l02768"></a>02768     
<a name="l02769"></a>02769     <span class="comment">// ... size the outer buffer</span>
<a name="l02770"></a>02770     recv.resize (sendsize);
<a name="l02771"></a>02771 
<a name="l02772"></a>02772     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;recv.size(); i++)
<a name="l02773"></a>02773       {
<a name="l02774"></a>02774         MPI_Unpack (&amp;recvbuf[0], recvbuf.size(), &amp;pos,
<a name="l02775"></a>02775                     &amp;sendsize, 1, <a class="code" href="namespacelibMesh_1_1Parallel.php#aa2cc4f78ded07edeb12b637564024bed">datatype&lt;unsigned int&gt;</a>(),
<a name="l02776"></a>02776                     comm.get());
<a name="l02777"></a>02777     
<a name="l02778"></a>02778         <span class="comment">// ... size the inner buffer</span>
<a name="l02779"></a>02779         recv[i].resize (sendsize);
<a name="l02780"></a>02780 
<a name="l02781"></a>02781         <span class="comment">// ... unpack the inner buffer if it is not empty</span>
<a name="l02782"></a>02782         <span class="keywordflow">if</span> (!recv[i].empty())
<a name="l02783"></a>02783           MPI_Unpack (&amp;recvbuf[0], recvbuf.size(), &amp;pos,
<a name="l02784"></a>02784                       &amp;recv[i][0], recv[i].size(), datatype&lt;T&gt;(),
<a name="l02785"></a>02785                       comm.get());
<a name="l02786"></a>02786       }
<a name="l02787"></a>02787 
<a name="l02788"></a>02788     <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (request);
<a name="l02789"></a>02789 
<a name="l02790"></a>02790     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02791"></a>02791   }
<a name="l02792"></a>02792 
<a name="l02793"></a>02793 
<a name="l02794"></a>02794   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02795"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">02795</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l02796"></a>02796                      T <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02797"></a>02797                      std::vector&lt;T&gt; &amp;recv,
<a name="l02798"></a>02798                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02799"></a>02799   {
<a name="l02800"></a>02800     libmesh_assert(root_id &lt; comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l02801"></a>02801 
<a name="l02802"></a>02802     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() == root_id)
<a name="l02803"></a>02803       recv.resize(comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l02804"></a>02804     
<a name="l02805"></a>02805     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l02806"></a>02806       {
<a name="l02807"></a>02807         START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02808"></a>02808 
<a name="l02809"></a>02809         MPI_Gather(&amp;send,
<a name="l02810"></a>02810                    1,
<a name="l02811"></a>02811                    datatype&lt;T&gt;(),
<a name="l02812"></a>02812                    recv.empty() ? NULL : &amp;recv[0],
<a name="l02813"></a>02813                    1,
<a name="l02814"></a>02814                    datatype&lt;T&gt;(),
<a name="l02815"></a>02815                    root_id,
<a name="l02816"></a>02816                    comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02817"></a>02817 
<a name="l02818"></a>02818         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02819"></a>02819       }
<a name="l02820"></a>02820     <span class="keywordflow">else</span>
<a name="l02821"></a>02821       recv[0] = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l02822"></a>02822   }
<a name="l02823"></a>02823 
<a name="l02824"></a>02824 
<a name="l02825"></a>02825 
<a name="l02826"></a>02826   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02827"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ace2a7e80f2938114720ffb9d523cdc1f">02827</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l02828"></a>02828                      std::complex&lt;T&gt; <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l02829"></a>02829                      std::vector&lt;std::complex&lt;T&gt; &gt; &amp;recv,
<a name="l02830"></a>02830                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02831"></a>02831   {
<a name="l02832"></a>02832     libmesh_assert(root_id &lt; comm.size());
<a name="l02833"></a>02833 
<a name="l02834"></a>02834     <span class="keywordflow">if</span> (comm.rank() == root_id)
<a name="l02835"></a>02835       recv.resize(comm.size());
<a name="l02836"></a>02836     
<a name="l02837"></a>02837     <span class="keywordflow">if</span> (comm.size() &gt; 1)
<a name="l02838"></a>02838       {
<a name="l02839"></a>02839         START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02840"></a>02840 
<a name="l02841"></a>02841         MPI_Gather(&amp;send,
<a name="l02842"></a>02842                    2,
<a name="l02843"></a>02843                    datatype&lt;T&gt;(),
<a name="l02844"></a>02844                    recv.empty() ? NULL : &amp;recv[0],
<a name="l02845"></a>02845                    2,
<a name="l02846"></a>02846                    datatype&lt;T&gt;(),
<a name="l02847"></a>02847                    root_id,
<a name="l02848"></a>02848                    comm.get());
<a name="l02849"></a>02849 
<a name="l02850"></a>02850         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02851"></a>02851       }
<a name="l02852"></a>02852     <span class="keywordflow">else</span>
<a name="l02853"></a>02853       recv[0] = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l02854"></a>02854   }
<a name="l02855"></a>02855 
<a name="l02856"></a>02856 
<a name="l02857"></a>02857 
<a name="l02880"></a>02880   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02881"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a64e9cd4737b6371b1df0e336c3c7ea67">02881</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l02882"></a>02882                      std::vector&lt;T&gt; &amp;r,
<a name="l02883"></a>02883                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l02884"></a>02884   {
<a name="l02885"></a>02885     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() == 1)
<a name="l02886"></a>02886       {
<a name="l02887"></a>02887         libmesh_assert (!comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>());
<a name="l02888"></a>02888         libmesh_assert (!root_id);
<a name="l02889"></a>02889         <span class="keywordflow">return</span>;
<a name="l02890"></a>02890       }
<a name="l02891"></a>02891 
<a name="l02892"></a>02892     libmesh_assert(root_id &lt; comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l02893"></a>02893     
<a name="l02894"></a>02894     std::vector&lt;int&gt;
<a name="l02895"></a>02895       sendlengths  (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>(), 0),
<a name="l02896"></a>02896       displacements(comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>(), 0);
<a name="l02897"></a>02897 
<a name="l02898"></a>02898     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size();
<a name="l02899"></a>02899     <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(mysize, sendlengths, comm);
<a name="l02900"></a>02900     
<a name="l02901"></a>02901     START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02902"></a>02902 
<a name="l02903"></a>02903     <span class="comment">// Find the total size of the final array and</span>
<a name="l02904"></a>02904     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l02905"></a>02905     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l02906"></a>02906     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>(); ++i)
<a name="l02907"></a>02907       {
<a name="l02908"></a>02908         displacements[i] = globalsize;
<a name="l02909"></a>02909         globalsize += sendlengths[i];
<a name="l02910"></a>02910       }
<a name="l02911"></a>02911 
<a name="l02912"></a>02912     <span class="comment">// Check for quick return</span>
<a name="l02913"></a>02913     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l02914"></a>02914       {
<a name="l02915"></a>02915         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02916"></a>02916         <span class="keywordflow">return</span>;
<a name="l02917"></a>02917       }
<a name="l02918"></a>02918 
<a name="l02919"></a>02919     <span class="comment">// copy the input buffer</span>
<a name="l02920"></a>02920     std::vector&lt;T&gt; r_src(r);
<a name="l02921"></a>02921 
<a name="l02922"></a>02922     <span class="comment">// now resize it to hold the global data</span>
<a name="l02923"></a>02923     <span class="comment">// on the receiving processor</span>
<a name="l02924"></a>02924     <span class="keywordflow">if</span> (root_id == comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>())
<a name="l02925"></a>02925       r.resize(globalsize);
<a name="l02926"></a>02926 
<a name="l02927"></a>02927     <span class="comment">// and get the data from the remote processors</span>
<a name="l02928"></a>02928 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02929"></a>02929 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02930"></a>02930     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02931"></a>02931 <span class="preprocessor">#endif</span>
<a name="l02932"></a>02932 <span class="preprocessor"></span>      MPI_Gatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l02933"></a>02933                    r.empty() ? NULL :  &amp;r[0], &amp;sendlengths[0],
<a name="l02934"></a>02934                    &amp;displacements[0], datatype&lt;T&gt;(),
<a name="l02935"></a>02935                    root_id,
<a name="l02936"></a>02936                    comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l02937"></a>02937 
<a name="l02938"></a>02938     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02939"></a>02939 
<a name="l02940"></a>02940     STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02941"></a>02941   }
<a name="l02942"></a>02942 
<a name="l02943"></a>02943 
<a name="l02944"></a>02944   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02945"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0802c655737459e9b95a4d8f2f669d3f">02945</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l02946"></a>02946                      std::vector&lt;std::complex&lt;T&gt; &gt; &amp;r,
<a name="l02947"></a>02947                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l02948"></a>02948   {
<a name="l02949"></a>02949     <span class="keywordflow">if</span> (comm.size() == 1)
<a name="l02950"></a>02950       {
<a name="l02951"></a>02951         libmesh_assert (!comm.rank());
<a name="l02952"></a>02952         libmesh_assert (!root_id);
<a name="l02953"></a>02953         <span class="keywordflow">return</span>;
<a name="l02954"></a>02954       }
<a name="l02955"></a>02955     
<a name="l02956"></a>02956     libmesh_assert(root_id &lt; comm.size());
<a name="l02957"></a>02957     
<a name="l02958"></a>02958     std::vector&lt;int&gt;
<a name="l02959"></a>02959       sendlengths  (comm.size(), 0),
<a name="l02960"></a>02960       displacements(comm.size(), 0);
<a name="l02961"></a>02961 
<a name="l02962"></a>02962     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size() * 2;
<a name="l02963"></a>02963     <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(mysize, sendlengths, comm);
<a name="l02964"></a>02964     
<a name="l02965"></a>02965     START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02966"></a>02966 
<a name="l02967"></a>02967     <span class="comment">// Find the total size of the final array and</span>
<a name="l02968"></a>02968     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l02969"></a>02969     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l02970"></a>02970     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != comm.size(); ++i)
<a name="l02971"></a>02971       {
<a name="l02972"></a>02972         displacements[i] = globalsize;
<a name="l02973"></a>02973         globalsize += sendlengths[i];
<a name="l02974"></a>02974       }
<a name="l02975"></a>02975 
<a name="l02976"></a>02976     <span class="comment">// Check for quick return</span>
<a name="l02977"></a>02977     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l02978"></a>02978       {
<a name="l02979"></a>02979         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02980"></a>02980         <span class="keywordflow">return</span>;
<a name="l02981"></a>02981       }
<a name="l02982"></a>02982 
<a name="l02983"></a>02983     <span class="comment">// Make temporary buffers for the input/output data</span>
<a name="l02984"></a>02984     std::vector&lt;std::complex&lt;T&gt; &gt; r_src(r);
<a name="l02985"></a>02985 
<a name="l02986"></a>02986     <span class="comment">// now resize r to hold the global data</span>
<a name="l02987"></a>02987     <span class="comment">// on the receiving processor</span>
<a name="l02988"></a>02988     <span class="keywordflow">if</span> (root_id == comm.rank())
<a name="l02989"></a>02989       r.resize(globalsize/2);
<a name="l02990"></a>02990 
<a name="l02991"></a>02991     <span class="comment">// and get the data from the remote processors</span>
<a name="l02992"></a>02992     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02993"></a>02993       MPI_Gatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l02994"></a>02994                    r.empty() ? NULL : &amp;r[0], &amp;sendlengths[0],
<a name="l02995"></a>02995                    &amp;displacements[0], datatype&lt;T&gt;(),
<a name="l02996"></a>02996                    root_id, comm.get());
<a name="l02997"></a>02997     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02998"></a>02998 
<a name="l02999"></a>02999     STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03000"></a>03000   }
<a name="l03001"></a>03001 
<a name="l03002"></a>03002 
<a name="l03003"></a>03003   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03004"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">03004</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(T <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l03005"></a>03005                         std::vector&lt;T&gt; &amp;recv,
<a name="l03006"></a>03006                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03007"></a>03007   {
<a name="l03008"></a>03008     START_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03009"></a>03009     
<a name="l03010"></a>03010     libmesh_assert(comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03011"></a>03011     recv.resize(comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03012"></a>03012     
<a name="l03013"></a>03013     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &gt; 1)
<a name="l03014"></a>03014       {
<a name="l03015"></a>03015         MPI_Allgather (&amp;send,
<a name="l03016"></a>03016                        1,
<a name="l03017"></a>03017                        datatype&lt;T&gt;(),
<a name="l03018"></a>03018                        &amp;recv[0],
<a name="l03019"></a>03019                        1, 
<a name="l03020"></a>03020                        datatype&lt;T&gt;(),
<a name="l03021"></a>03021                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l03022"></a>03022       }
<a name="l03023"></a>03023     <span class="keywordflow">else</span>
<a name="l03024"></a>03024       recv[0] = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l03025"></a>03025 
<a name="l03026"></a>03026     STOP_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03027"></a>03027   }
<a name="l03028"></a>03028 
<a name="l03029"></a>03029 
<a name="l03030"></a>03030 
<a name="l03031"></a>03031   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03032"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa40031975ee568dbf17a4ca94d8ad5a4">03032</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(std::complex&lt;T&gt; <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l03033"></a>03033                         std::vector&lt;std::complex&lt;T&gt; &gt; &amp;recv,
<a name="l03034"></a>03034                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l03035"></a>03035   {
<a name="l03036"></a>03036     START_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03037"></a>03037 
<a name="l03038"></a>03038     libmesh_assert(comm.size());
<a name="l03039"></a>03039     recv.resize(comm.size());
<a name="l03040"></a>03040 
<a name="l03041"></a>03041     <span class="keywordflow">if</span> (comm.size() &gt; 1)
<a name="l03042"></a>03042       {
<a name="l03043"></a>03043         MPI_Allgather (&amp;send,
<a name="l03044"></a>03044                        2,
<a name="l03045"></a>03045                        datatype&lt;T&gt;(),
<a name="l03046"></a>03046                        &amp;recv[0],
<a name="l03047"></a>03047                        2, 
<a name="l03048"></a>03048                        datatype&lt;T&gt;(),
<a name="l03049"></a>03049                        comm.get());
<a name="l03050"></a>03050       }
<a name="l03051"></a>03051     <span class="keywordflow">else</span>
<a name="l03052"></a>03052       recv[0] = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l03053"></a>03053 
<a name="l03054"></a>03054     STOP_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03055"></a>03055   }
<a name="l03056"></a>03056   
<a name="l03057"></a>03057 
<a name="l03058"></a>03058 
<a name="l03081"></a>03081   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03082"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a79e581543021989fc4b2c606c7fa0669">03082</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(std::vector&lt;T&gt; &amp;r,
<a name="l03083"></a>03083                         <span class="keyword">const</span> <span class="keywordtype">bool</span> identical_buffer_sizes,
<a name="l03084"></a>03084                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03085"></a>03085   {
<a name="l03086"></a>03086     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &lt; 2)
<a name="l03087"></a>03087       <span class="keywordflow">return</span>;
<a name="l03088"></a>03088 
<a name="l03089"></a>03089     START_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03090"></a>03090 
<a name="l03091"></a>03091     <span class="keywordflow">if</span> (identical_buffer_sizes)
<a name="l03092"></a>03092       {
<a name="l03093"></a>03093         std::vector&lt;T&gt; r_src(r.size()*comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03094"></a>03094         r_src.swap(r);
<a name="l03095"></a>03095         MPI_Allgather (r_src.empty() ? NULL : &amp;r_src[0],
<a name="l03096"></a>03096                        r_src.size(),
<a name="l03097"></a>03097                        datatype&lt;T&gt;(),
<a name="l03098"></a>03098                        r.empty() ? NULL : &amp;r[0],
<a name="l03099"></a>03099                        r_src.size(), 
<a name="l03100"></a>03100                        datatype&lt;T&gt;(),
<a name="l03101"></a>03101                        comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l03102"></a>03102         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03103"></a>03103         <span class="keywordflow">return</span>;
<a name="l03104"></a>03104       }
<a name="l03105"></a>03105 
<a name="l03106"></a>03106     std::vector&lt;int&gt;
<a name="l03107"></a>03107       sendlengths  (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>(), 0),
<a name="l03108"></a>03108       displacements(comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>(), 0);
<a name="l03109"></a>03109 
<a name="l03110"></a>03110     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size();
<a name="l03111"></a>03111     <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(mysize, sendlengths, comm);
<a name="l03112"></a>03112 
<a name="l03113"></a>03113     <span class="comment">// Find the total size of the final array and</span>
<a name="l03114"></a>03114     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l03115"></a>03115     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l03116"></a>03116     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>(); ++i)
<a name="l03117"></a>03117       {
<a name="l03118"></a>03118         displacements[i] = globalsize;
<a name="l03119"></a>03119         globalsize += sendlengths[i];
<a name="l03120"></a>03120       }
<a name="l03121"></a>03121 
<a name="l03122"></a>03122     <span class="comment">// Check for quick return</span>
<a name="l03123"></a>03123     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l03124"></a>03124       {
<a name="l03125"></a>03125         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03126"></a>03126         <span class="keywordflow">return</span>;
<a name="l03127"></a>03127       }
<a name="l03128"></a>03128 
<a name="l03129"></a>03129     <span class="comment">// copy the input buffer</span>
<a name="l03130"></a>03130     std::vector&lt;T&gt; r_src(globalsize);
<a name="l03131"></a>03131     r_src.swap(r);
<a name="l03132"></a>03132 
<a name="l03133"></a>03133     <span class="comment">// and get the data from the remote processors.</span>
<a name="l03134"></a>03134     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l03135"></a>03135 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l03136"></a>03136 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l03137"></a>03137     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03138"></a>03138 <span class="preprocessor">#endif</span>
<a name="l03139"></a>03139 <span class="preprocessor"></span>      MPI_Allgatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l03140"></a>03140                       r.empty()     ? NULL : &amp;r[0],     &amp;sendlengths[0],
<a name="l03141"></a>03141                       &amp;displacements[0], datatype&lt;T&gt;(), comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l03142"></a>03142 
<a name="l03143"></a>03143     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03144"></a>03144 
<a name="l03145"></a>03145     STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03146"></a>03146   }
<a name="l03147"></a>03147 
<a name="l03148"></a>03148 
<a name="l03149"></a>03149   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l03150"></a>03150   <span class="comment">// function template, so we have to re-specify the default arguments</span>
<a name="l03151"></a>03151   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03152"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0b8480a0bf0a94fe921aef445a3820e3">03152</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(std::vector&lt;std::complex&lt;T&gt; &gt; &amp;r,
<a name="l03153"></a>03153                         <span class="keyword">const</span> <span class="keywordtype">bool</span> identical_buffer_sizes = <span class="keyword">false</span>,
<a name="l03154"></a>03154                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l03155"></a>03155   {
<a name="l03156"></a>03156     <span class="keywordflow">if</span> (comm.size() &lt; 2)
<a name="l03157"></a>03157       <span class="keywordflow">return</span>;
<a name="l03158"></a>03158 
<a name="l03159"></a>03159     START_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03160"></a>03160 
<a name="l03161"></a>03161     <span class="keywordflow">if</span> (identical_buffer_sizes)
<a name="l03162"></a>03162       {
<a name="l03163"></a>03163         std::vector&lt;std::complex&lt;T&gt; &gt; r_src(r.size()*comm.size());
<a name="l03164"></a>03164         r_src.swap(r);
<a name="l03165"></a>03165         MPI_Allgather (r_src.empty() ? NULL : &amp;r_src[0],
<a name="l03166"></a>03166                        2*r_src.size(),
<a name="l03167"></a>03167                        datatype&lt;T&gt;(),
<a name="l03168"></a>03168                        r.empty() ? NULL : &amp;r[0],
<a name="l03169"></a>03169                        2*r_src.size(), 
<a name="l03170"></a>03170                        datatype&lt;T&gt;(),
<a name="l03171"></a>03171                        comm.get());
<a name="l03172"></a>03172         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03173"></a>03173         <span class="keywordflow">return</span>;
<a name="l03174"></a>03174       }
<a name="l03175"></a>03175 
<a name="l03176"></a>03176     std::vector&lt;int&gt;
<a name="l03177"></a>03177       sendlengths  (comm.size(), 0),
<a name="l03178"></a>03178       displacements(comm.size(), 0);
<a name="l03179"></a>03179 
<a name="l03180"></a>03180     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size() * 2;
<a name="l03181"></a>03181     <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(mysize, sendlengths, comm);
<a name="l03182"></a>03182 
<a name="l03183"></a>03183     <span class="comment">// Find the total size of the final array and</span>
<a name="l03184"></a>03184     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l03185"></a>03185     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l03186"></a>03186     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != comm.size(); ++i)
<a name="l03187"></a>03187       {
<a name="l03188"></a>03188         displacements[i] = globalsize;
<a name="l03189"></a>03189         globalsize += sendlengths[i];
<a name="l03190"></a>03190       }
<a name="l03191"></a>03191 
<a name="l03192"></a>03192     <span class="comment">// Check for quick return</span>
<a name="l03193"></a>03193     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l03194"></a>03194       {
<a name="l03195"></a>03195         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03196"></a>03196         <span class="keywordflow">return</span>;
<a name="l03197"></a>03197       }
<a name="l03198"></a>03198 
<a name="l03199"></a>03199     <span class="comment">// copy the input buffer</span>
<a name="l03200"></a>03200     std::vector&lt;std::complex&lt;T&gt; &gt; r_src(globalsize);
<a name="l03201"></a>03201     r_src.swap(r);
<a name="l03202"></a>03202 
<a name="l03203"></a>03203     <span class="comment">// and get the data from the remote processors.</span>
<a name="l03204"></a>03204     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l03205"></a>03205     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03206"></a>03206       MPI_Allgatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l03207"></a>03207                       r.empty()     ? NULL : &amp;r[0],     &amp;sendlengths[0],
<a name="l03208"></a>03208                       &amp;displacements[0], datatype&lt;T&gt;(),
<a name="l03209"></a>03209                       comm.get());
<a name="l03210"></a>03210     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03211"></a>03211 
<a name="l03212"></a>03212     STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03213"></a>03213   }
<a name="l03214"></a>03214   
<a name="l03215"></a>03215 
<a name="l03216"></a>03216 
<a name="l03223"></a>03223   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03224"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">03224</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">alltoall</a>(std::vector&lt;T&gt; &amp;buf,
<a name="l03225"></a>03225                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03226"></a>03226   {
<a name="l03227"></a>03227     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() &lt; 2)
<a name="l03228"></a>03228       <span class="keywordflow">return</span>;
<a name="l03229"></a>03229 
<a name="l03230"></a>03230     START_LOG(<span class="stringliteral">&quot;alltoall()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03231"></a>03231 
<a name="l03232"></a>03232     <span class="comment">// the per-processor size.  this is the same for all</span>
<a name="l03233"></a>03233     <span class="comment">// processors using MPI_Alltoall, could be variable</span>
<a name="l03234"></a>03234     <span class="comment">// using MPI_Alltoallv</span>
<a name="l03235"></a>03235     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size_per_proc = 
<a name="l03236"></a>03236       buf.size()/comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>();
<a name="l03237"></a>03237 
<a name="l03238"></a>03238     libmesh_assert (buf.size()%comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() == 0);
<a name="l03239"></a>03239 
<a name="l03240"></a>03240     std::vector&lt;T&gt; tmp(buf);
<a name="l03241"></a>03241     
<a name="l03242"></a>03242 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l03243"></a>03243 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l03244"></a>03244     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03245"></a>03245 <span class="preprocessor">#endif</span>
<a name="l03246"></a>03246 <span class="preprocessor"></span>      MPI_Alltoall (tmp.empty() ? NULL : &amp;tmp[0],
<a name="l03247"></a>03247                     size_per_proc,
<a name="l03248"></a>03248                     datatype&lt;T&gt;(),
<a name="l03249"></a>03249                     buf.empty() ? NULL : &amp;buf[0],
<a name="l03250"></a>03250                     size_per_proc,
<a name="l03251"></a>03251                     datatype&lt;T&gt;(),
<a name="l03252"></a>03252                     comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l03253"></a>03253     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03254"></a>03254     
<a name="l03255"></a>03255     STOP_LOG(<span class="stringliteral">&quot;alltoall()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03256"></a>03256   }
<a name="l03257"></a>03257 
<a name="l03258"></a>03258 
<a name="l03259"></a>03259 
<a name="l03260"></a>03260   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03261"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">03261</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (T &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l03262"></a>03262                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03263"></a>03263   {
<a name="l03264"></a>03264     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() == 1)
<a name="l03265"></a>03265       {
<a name="l03266"></a>03266         libmesh_assert (!comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>());
<a name="l03267"></a>03267         libmesh_assert (!root_id);
<a name="l03268"></a>03268         <span class="keywordflow">return</span>;
<a name="l03269"></a>03269       }
<a name="l03270"></a>03270 
<a name="l03271"></a>03271     libmesh_assert(root_id &lt; comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03272"></a>03272     
<a name="l03273"></a>03273     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03274"></a>03274 
<a name="l03275"></a>03275     <span class="comment">// Spread data to remote processors.</span>
<a name="l03276"></a>03276 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l03277"></a>03277 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l03278"></a>03278     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03279"></a>03279 <span class="preprocessor">#endif</span>
<a name="l03280"></a>03280 <span class="preprocessor"></span>      MPI_Bcast (&amp;data, 1, datatype&lt;T&gt;(), root_id, comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l03281"></a>03281 
<a name="l03282"></a>03282     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03283"></a>03283 
<a name="l03284"></a>03284     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03285"></a>03285   }
<a name="l03286"></a>03286 
<a name="l03287"></a>03287 
<a name="l03288"></a>03288   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l03289"></a>03289   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l03290"></a>03290   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03291"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aca9cd53d64f05ff90f78c388e767bada">03291</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (std::complex&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0,
<a name="l03292"></a>03292                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l03293"></a>03293   {
<a name="l03294"></a>03294     <span class="keywordflow">if</span> (comm.size() == 1)
<a name="l03295"></a>03295       {
<a name="l03296"></a>03296         libmesh_assert (!comm.rank());
<a name="l03297"></a>03297         libmesh_assert (!root_id);
<a name="l03298"></a>03298         <span class="keywordflow">return</span>;
<a name="l03299"></a>03299       }
<a name="l03300"></a>03300     
<a name="l03301"></a>03301     libmesh_assert(root_id &lt; comm.size());
<a name="l03302"></a>03302     
<a name="l03303"></a>03303     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03304"></a>03304 
<a name="l03305"></a>03305     <span class="comment">// Spread data to remote processors.</span>
<a name="l03306"></a>03306     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03307"></a>03307       MPI_Bcast (&amp;data, 2, datatype&lt;T&gt;(), root_id, comm.get());
<a name="l03308"></a>03308     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03309"></a>03309 
<a name="l03310"></a>03310     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03311"></a>03311   }
<a name="l03312"></a>03312 
<a name="l03313"></a>03313 
<a name="l03314"></a>03314 
<a name="l03315"></a>03315   <span class="keyword">template</span> &lt;&gt;
<a name="l03316"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a14551ff03499c55b9bffb543b0e030fe">03316</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (std::string &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l03317"></a>03317                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03318"></a>03318   {
<a name="l03319"></a>03319     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() == 1)
<a name="l03320"></a>03320       {
<a name="l03321"></a>03321         libmesh_assert (!comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>());
<a name="l03322"></a>03322         libmesh_assert (!root_id);
<a name="l03323"></a>03323         <span class="keywordflow">return</span>;
<a name="l03324"></a>03324       }
<a name="l03325"></a>03325 
<a name="l03326"></a>03326     libmesh_assert(root_id &lt; comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03327"></a>03327     
<a name="l03328"></a>03328     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03329"></a>03329 
<a name="l03330"></a>03330     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_size = data.size();
<a name="l03331"></a>03331     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(data_size, root_id, comm);
<a name="l03332"></a>03332     
<a name="l03333"></a>03333     std::vector&lt;char&gt; data_c(data_size);
<a name="l03334"></a>03334     std::string orig(data);
<a name="l03335"></a>03335 
<a name="l03336"></a>03336     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() == root_id)
<a name="l03337"></a>03337       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data.size(); i++)
<a name="l03338"></a>03338         data_c[i] = data[i];
<a name="l03339"></a>03339 
<a name="l03340"></a>03340     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a> (data_c, root_id, comm);
<a name="l03341"></a>03341     
<a name="l03342"></a>03342     data.clear(); data.reserve(data_c.size());
<a name="l03343"></a>03343     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data_c.size(); i++)
<a name="l03344"></a>03344       data.push_back(data_c[i]);
<a name="l03345"></a>03345     
<a name="l03346"></a>03346     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() == root_id)
<a name="l03347"></a>03347       libmesh_assert(data == orig);
<a name="l03348"></a>03348 
<a name="l03349"></a>03349     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03350"></a>03350   }
<a name="l03351"></a>03351 
<a name="l03352"></a>03352 
<a name="l03353"></a>03353 
<a name="l03354"></a>03354   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03355"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a9d210412a35ad1fe890ff01e94137072">03355</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (std::vector&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l03356"></a>03356                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03357"></a>03357   {
<a name="l03358"></a>03358     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() == 1)
<a name="l03359"></a>03359       {
<a name="l03360"></a>03360         libmesh_assert (!comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>());
<a name="l03361"></a>03361         libmesh_assert (!root_id);
<a name="l03362"></a>03362         <span class="keywordflow">return</span>;
<a name="l03363"></a>03363       }
<a name="l03364"></a>03364 
<a name="l03365"></a>03365     libmesh_assert(root_id &lt; comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03366"></a>03366     
<a name="l03367"></a>03367     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03368"></a>03368 
<a name="l03369"></a>03369     <span class="comment">// and get the data from the remote processors.</span>
<a name="l03370"></a>03370     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l03371"></a>03371 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l03372"></a>03372 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l03373"></a>03373     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03374"></a>03374 <span class="preprocessor">#endif</span>
<a name="l03375"></a>03375 <span class="preprocessor"></span>      MPI_Bcast (data.empty() ? NULL : &amp;data[0], data.size(), datatype&lt;T&gt;(),
<a name="l03376"></a>03376                  root_id, comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a4b6bd36c38eb7de350fcd56510306ced">get</a>());
<a name="l03377"></a>03377 
<a name="l03378"></a>03378     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03379"></a>03379 
<a name="l03380"></a>03380     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03381"></a>03381   }
<a name="l03382"></a>03382 
<a name="l03383"></a>03383 
<a name="l03384"></a>03384   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l03385"></a>03385   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l03386"></a>03386   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03387"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#aa9993851873f2384213dfb96e23cf18e">03387</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (std::vector&lt;std::complex&lt;T&gt; &gt; &amp;data,
<a name="l03388"></a>03388                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0,
<a name="l03389"></a>03389                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Communicator_World</a>)
<a name="l03390"></a>03390   {
<a name="l03391"></a>03391     <span class="keywordflow">if</span> (comm.size() == 1)
<a name="l03392"></a>03392       {
<a name="l03393"></a>03393         libmesh_assert (!comm.rank());
<a name="l03394"></a>03394         libmesh_assert (!root_id);
<a name="l03395"></a>03395         <span class="keywordflow">return</span>;
<a name="l03396"></a>03396       }
<a name="l03397"></a>03397 
<a name="l03398"></a>03398     libmesh_assert(root_id &lt; comm.size());
<a name="l03399"></a>03399     
<a name="l03400"></a>03400     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03401"></a>03401 
<a name="l03402"></a>03402     <span class="comment">// and get the data from the remote processors.</span>
<a name="l03403"></a>03403     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l03404"></a>03404     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l03405"></a>03405       MPI_Bcast (data.empty() ? NULL : &amp;data[0], data.size() * 2, datatype&lt;T&gt;(),
<a name="l03406"></a>03406                  root_id, comm.get());
<a name="l03407"></a>03407     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l03408"></a>03408 
<a name="l03409"></a>03409     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03410"></a>03410   }
<a name="l03411"></a>03411 
<a name="l03412"></a>03412 
<a name="l03413"></a>03413   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03414"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab982c087db8ebbff01147fbc83da0962">03414</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (std::set&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l03415"></a>03415                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php">Communicator</a> &amp;comm)
<a name="l03416"></a>03416   {
<a name="l03417"></a>03417     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>() == 1)
<a name="l03418"></a>03418       {
<a name="l03419"></a>03419         libmesh_assert (!comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>());
<a name="l03420"></a>03420         libmesh_assert (!root_id);
<a name="l03421"></a>03421         <span class="keywordflow">return</span>;
<a name="l03422"></a>03422       }
<a name="l03423"></a>03423 
<a name="l03424"></a>03424     libmesh_assert(root_id &lt; comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a3eca1f7abf02a11e5812b08b1d65f80b">size</a>());
<a name="l03425"></a>03425     
<a name="l03426"></a>03426     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03427"></a>03427 
<a name="l03428"></a>03428     std::vector&lt;T&gt; vecdata;
<a name="l03429"></a>03429     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() == root_id)
<a name="l03430"></a>03430       vecdata.assign(data.begin(), data.end());
<a name="l03431"></a>03431 
<a name="l03432"></a>03432     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vecsize = vecdata.size();
<a name="l03433"></a>03433     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(vecsize, root_id, comm);
<a name="l03434"></a>03434     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() != root_id)
<a name="l03435"></a>03435       vecdata.resize(vecsize);
<a name="l03436"></a>03436 
<a name="l03437"></a>03437     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(vecdata, root_id, comm);
<a name="l03438"></a>03438     <span class="keywordflow">if</span> (comm.<a class="code" href="classlibMesh_1_1Parallel_1_1Communicator.php#a73e079f0714b243453b9c65d15fafd36">rank</a>() != root_id)
<a name="l03439"></a>03439       data.assign(vecdata.begin(), vecdata.end());
<a name="l03440"></a>03440 
<a name="l03441"></a>03441     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l03442"></a>03442   }
<a name="l03443"></a>03443 
<a name="l03444"></a>03444 <span class="preprocessor">#else // LIBMESH_HAVE_MPI</span>
<a name="l03445"></a>03445 <span class="preprocessor"></span>
<a name="l03446"></a>03446   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03447"></a>03447   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">verify</a>(<span class="keyword">const</span> T &amp;, <span class="keyword">const</span> Communicator&amp;) { <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l03448"></a>03448 
<a name="l03449"></a>03449   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03450"></a>03450   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(T &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03451"></a>03451 
<a name="l03452"></a>03452   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03453"></a>03453   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>(std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03454"></a>03454 
<a name="l03455"></a>03455   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03456"></a>03456   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(T &amp;, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;min_id, <span class="keyword">const</span> Communicator&amp;) { min_id = 0; }
<a name="l03457"></a>03457 
<a name="l03458"></a>03458   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03459"></a>03459   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a00c095b66d0745ce76317589015b1b35">minloc</a>(std::vector&lt;T&gt; &amp;r, std::vector&lt;unsigned int&gt; &amp;min_id, <span class="keyword">const</span> Communicator&amp;)
<a name="l03460"></a>03460     { <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= r.size(); ++i) min_id[i] = 0; }
<a name="l03461"></a>03461 
<a name="l03462"></a>03462   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03463"></a>03463   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(T &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03464"></a>03464 
<a name="l03465"></a>03465   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03466"></a>03466   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>(std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03467"></a>03467 
<a name="l03468"></a>03468   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03469"></a>03469   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(T &amp;, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;max_id, <span class="keyword">const</span> Communicator&amp;) { max_id = 0; }
<a name="l03470"></a>03470 
<a name="l03471"></a>03471   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03472"></a>03472   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8ff1ccdddae18e342bb192e5000821bf">maxloc</a>(std::vector&lt;T&gt; &amp;r, std::vector&lt;unsigned int&gt; &amp;max_id, <span class="keyword">const</span> Communicator&amp;)
<a name="l03473"></a>03473     { <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= r.size(); ++i) max_id[i] = 0; }
<a name="l03474"></a>03474 
<a name="l03475"></a>03475   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03476"></a>03476   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(T &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03477"></a>03477 
<a name="l03478"></a>03478   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03479"></a>03479   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>(std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03480"></a>03480 
<a name="l03481"></a>03481   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03482"></a>03482   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">set_union</a>(std::set&lt;T&gt; &amp;, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03483"></a>03483 
<a name="l03484"></a>03484   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03485"></a>03485   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">set_union</a>(std::set&lt;T&gt; &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03486"></a>03486 
<a name="l03487"></a>03487  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l03494"></a>03494 <span class="comment"></span>  <span class="keyword">inline</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">probe</a> (<span class="keyword">const</span> <span class="keywordtype">int</span>,
<a name="l03495"></a>03495                        <span class="keyword">const</span> MessageTag&amp;,
<a name="l03496"></a>03496                        <span class="keyword">const</span> Communicator&amp;)
<a name="l03497"></a>03497   { libmesh_error(); <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>; <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>; }
<a name="l03498"></a>03498 
<a name="l03499"></a>03499   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l03505"></a>03505 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03506"></a>03506   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l03507"></a>03507                     std::vector&lt;T&gt; &amp;,
<a name="l03508"></a>03508                     <span class="keyword">const</span> DataType &amp;,
<a name="l03509"></a>03509                     <span class="keyword">const</span> MessageTag &amp;,
<a name="l03510"></a>03510                     <span class="keyword">const</span> Communicator&amp;)
<a name="l03511"></a>03511   { libmesh_error(); }
<a name="l03512"></a>03512 
<a name="l03513"></a>03513   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l03519"></a>03519 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03520"></a>03520   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l03521"></a>03521                     std::vector&lt;T&gt; &amp;,
<a name="l03522"></a>03522                     <span class="keyword">const</span> DataType &amp;,
<a name="l03523"></a>03523                     Request &amp;,
<a name="l03524"></a>03524                     <span class="keyword">const</span> MessageTag &amp;,
<a name="l03525"></a>03525                     <span class="keyword">const</span> Communicator&amp;)
<a name="l03526"></a>03526   { libmesh_error(); }
<a name="l03527"></a>03527 
<a name="l03528"></a>03528   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l03534"></a>03534 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03535"></a>03535   <span class="keyword">inline</span> Status <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span>,
<a name="l03536"></a>03536                          std::vector&lt;T&gt; &amp;,
<a name="l03537"></a>03537                          <span class="keyword">const</span> DataType &amp;,
<a name="l03538"></a>03538                          <span class="keyword">const</span> MessageTag &amp;,
<a name="l03539"></a>03539                          <span class="keyword">const</span> Communicator&amp;)
<a name="l03540"></a>03540   { libmesh_error(); <span class="keywordflow">return</span> Status(); }
<a name="l03541"></a>03541 
<a name="l03542"></a>03542   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l03548"></a>03548 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03549"></a>03549   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">receive</a> (<span class="keyword">const</span> <span class="keywordtype">int</span>,
<a name="l03550"></a>03550                        std::vector&lt;T&gt; &amp;,
<a name="l03551"></a>03551                        <span class="keyword">const</span> DataType &amp;,
<a name="l03552"></a>03552                        Request &amp;,
<a name="l03553"></a>03553                        <span class="keyword">const</span> MessageTag &amp;,
<a name="l03554"></a>03554                        <span class="keyword">const</span> Communicator&amp;)
<a name="l03555"></a>03555   { libmesh_error(); }
<a name="l03556"></a>03556 
<a name="l03557"></a>03557 
<a name="l03558"></a>03558 <span class="comment">//   // on one processor a blocking probe can only be used to </span>
<a name="l03559"></a>03559 <span class="comment">//   // test a nonblocking send, which we don&#39;t really support</span>
<a name="l03560"></a>03560 <span class="comment">//   inline status probe (const int,</span>
<a name="l03561"></a>03561 <span class="comment">//                     const int)</span>
<a name="l03562"></a>03562 <span class="comment">//   { libmesh_error(); status status; return status; }</span>
<a name="l03563"></a>03563 
<a name="l03564"></a>03564 
<a name="l03565"></a>03565 <span class="comment">//   // Blocking sends don&#39;t make sense on one processor</span>
<a name="l03566"></a>03566 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l03567"></a>03567 <span class="comment">//   inline void send (const unsigned int,</span>
<a name="l03568"></a>03568 <span class="comment">//                  std::vector&lt;T&gt; &amp;,</span>
<a name="l03569"></a>03569 <span class="comment">//                  const unsigned int) { libmesh_error(); }</span>
<a name="l03570"></a>03570 
<a name="l03571"></a>03571 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l03572"></a>03572 <span class="comment">//   inline void nonblocking_send (const unsigned int,</span>
<a name="l03573"></a>03573 <span class="comment">//                              std::vector&lt;T&gt; &amp;,</span>
<a name="l03574"></a>03574 <span class="comment">//                              Request &amp;,</span>
<a name="l03575"></a>03575 <span class="comment">//                              const int) {}</span>
<a name="l03576"></a>03576 
<a name="l03577"></a>03577 <span class="comment">//   // Blocking receives don&#39;t make sense on one processor</span>
<a name="l03578"></a>03578 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l03579"></a>03579 <span class="comment">//   inline Status receive (const int,</span>
<a name="l03580"></a>03580 <span class="comment">//                       std::vector&lt;T&gt; &amp;,</span>
<a name="l03581"></a>03581 <span class="comment">//                       const int) { libmesh_error(); return Status(); }</span>
<a name="l03582"></a>03582 
<a name="l03583"></a>03583 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l03584"></a>03584 <span class="comment">//   inline void nonblocking_receive (const int,</span>
<a name="l03585"></a>03585 <span class="comment">//                                 std::vector&lt;T&gt; &amp;,</span>
<a name="l03586"></a>03586 <span class="comment">//                                 Request &amp;,</span>
<a name="l03587"></a>03587 <span class="comment">//                                 const int) {}</span>
<a name="l03588"></a>03588   
<a name="l03589"></a>03589   <span class="keyword">inline</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#a4cf28cfb3d6fefc535e83fb4b2698276">request</a> &amp;) { <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>; <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a>; }
<a name="l03590"></a>03590   
<a name="l03591"></a>03591   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">wait</a> (std::vector&lt;request&gt; &amp;) {}
<a name="l03592"></a>03592   
<a name="l03593"></a>03593   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03594"></a>03594   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">send_receive</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> send_tgt,
<a name="l03595"></a>03595                             T &amp;<a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l03596"></a>03596                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> recv_source,
<a name="l03597"></a>03597                             T &amp;recv,
<a name="l03598"></a>03598                             <span class="keyword">const</span> Communicator&amp;)
<a name="l03599"></a>03599   {
<a name="l03600"></a>03600     libmesh_assert (send_tgt == recv_source);
<a name="l03601"></a>03601     recv = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l03602"></a>03602   }
<a name="l03603"></a>03603 
<a name="l03604"></a>03604   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03605"></a>03605   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l03606"></a>03606                      T <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>,
<a name="l03607"></a>03607                      std::vector&lt;T&gt; &amp;recv,
<a name="l03608"></a>03608                      <span class="keyword">const</span> Communicator&amp;)
<a name="l03609"></a>03609   {
<a name="l03610"></a>03610     libmesh_assert (!root_id);
<a name="l03611"></a>03611     recv.resize(1);
<a name="l03612"></a>03612     recv[0] = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l03613"></a>03613   }
<a name="l03614"></a>03614 
<a name="l03615"></a>03615   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03616"></a>03616   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">gather</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, std::vector&lt;T&gt; &amp;,
<a name="l03617"></a>03617                      <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03618"></a>03618 
<a name="l03619"></a>03619   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03620"></a>03620   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(T send,
<a name="l03621"></a>03621                         std::vector&lt;T&gt; &amp;recv,
<a name="l03622"></a>03622                         <span class="keyword">const</span> Communicator&amp;)
<a name="l03623"></a>03623   {
<a name="l03624"></a>03624     recv.resize(1);
<a name="l03625"></a>03625     recv[0] = <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">send</a>;
<a name="l03626"></a>03626   }
<a name="l03627"></a>03627 
<a name="l03628"></a>03628   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03629"></a>03629   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>(std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span>,
<a name="l03630"></a>03630                         <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03631"></a>03631 
<a name="l03632"></a>03632   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03633"></a>03633   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">alltoall</a>(std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03634"></a>03634 
<a name="l03635"></a>03635   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03636"></a>03636     <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (T &amp;, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03637"></a>03637 
<a name="l03638"></a>03638   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l03639"></a>03639     <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">broadcast</a> (std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> Communicator&amp;) {}
<a name="l03640"></a>03640 
<a name="l03641"></a>03641 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l03642"></a>03642 <span class="preprocessor"></span>
<a name="l03643"></a>03643 
<a name="l03644"></a>03644 }
<a name="l03645"></a>03645 
<a name="l03646"></a>03646 } <span class="comment">// namespace libMesh</span>
<a name="l03647"></a>03647 
<a name="l03648"></a>03648 <span class="preprocessor">#endif // #define __parallel_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
