<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_linear_solver.C</div>  </div>
</div>
<div class="contents">
<a href="petsc__linear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_linear_solver.C 4289 2011-03-24 16:24:13Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="petsc__linear__solver_8h.php">petsc_linear_solver.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="petsc__preconditioner_8h.php">petsc_preconditioner.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a>;
<a name="l00043"></a>00043   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>;
<a name="l00044"></a>00044 <span class="preprocessor">#endif</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,1) &amp;&amp; PETSC_VERSION_RELEASE</span>
<a name="l00048"></a><a class="code" href="petsc__linear__solver_8h.php#a4737870c4c15c93547318e44dea2e463">00048</a> <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a> (<span class="keywordtype">void</span> * ctx)
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00051"></a>00051     preconditioner-&gt;init();
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keywordflow">return</span> 0;
<a name="l00054"></a>00054   }
<a name="l00055"></a>00055   
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="petsc__linear__solver_8h.php#a13ac63a1ac4545e7ac3bac10a8bd8677">00057</a>   PetscErrorCode <a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>(<span class="keywordtype">void</span> *ctx, Vec x, Vec y)
<a name="l00058"></a>00058   {
<a name="l00059"></a>00059     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     PetscVector&lt;Number&gt; x_vec(x);
<a name="l00062"></a>00062     PetscVector&lt;Number&gt; y_vec(y);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     preconditioner-&gt;apply(x_vec,y_vec);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keywordflow">return</span> 0;
<a name="l00067"></a>00067   }
<a name="l00068"></a>00068 <span class="preprocessor">#else</span>
<a name="l00069"></a><a class="code" href="petsc__linear__solver_8h.php#a7f9050298a8ebb30a5e1998947b8653e">00069</a> <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a> (PC pc)
<a name="l00070"></a>00070   {
<a name="l00071"></a>00071     <span class="keywordtype">void</span> *ctx;
<a name="l00072"></a>00072     PetscErrorCode ierr = PCShellGetContext(pc,&amp;ctx);CHKERRQ(ierr);
<a name="l00073"></a>00073     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00074"></a>00074     preconditioner-&gt;init();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">return</span> 0;
<a name="l00077"></a>00077   }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="petsc__linear__solver_8h.php#add1205beb649851a35301fb431bdb655">00079</a>   PetscErrorCode <a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>(PC pc, Vec x, Vec y)
<a name="l00080"></a>00080   {
<a name="l00081"></a>00081     <span class="keywordtype">void</span> *ctx;
<a name="l00082"></a>00082     PetscErrorCode ierr = PCShellGetContext(pc,&amp;ctx);CHKERRQ(ierr);
<a name="l00083"></a>00083     Preconditioner&lt;Number&gt; * preconditioner = <span class="keyword">static_cast&lt;</span>Preconditioner&lt;Number&gt;*<span class="keyword">&gt;</span>(ctx);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     PetscVector&lt;Number&gt; x_vec(x);
<a name="l00086"></a>00086     PetscVector&lt;Number&gt; y_vec(y);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     preconditioner-&gt;apply(x_vec,y_vec);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="keywordflow">return</span> 0;
<a name="l00091"></a>00091   }
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>} <span class="comment">// end extern &quot;C&quot;</span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00096"></a>00096 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00097"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adafec932e0a6a770391d756a9b21fa14">00097</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adafec932e0a6a770391d756a9b21fa14">PetscLinearSolver&lt;T&gt;::clear</a> ()
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       <span class="comment">/* If we were restricted to some subset, this restriction must</span>
<a name="l00102"></a>00102 <span class="comment">         be removed and the subset index set destroyed.  */</span>
<a name="l00103"></a>00103       <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00104"></a>00104         {
<a name="l00105"></a>00105           <span class="keywordtype">int</span> ierr = ISDestroy(_restrict_solve_to_is);
<a name="l00106"></a>00106           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00107"></a>00107           _restrict_solve_to_is = NULL;
<a name="l00108"></a>00108         }
<a name="l00109"></a>00109       
<a name="l00110"></a>00110       <span class="keywordflow">if</span>(_restrict_solve_to_is_complement!=NULL)
<a name="l00111"></a>00111         {
<a name="l00112"></a>00112           <span class="keywordtype">int</span> ierr = ISDestroy(_restrict_solve_to_is_complement);
<a name="l00113"></a>00113           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00114"></a>00114           _restrict_solve_to_is_complement = NULL;
<a name="l00115"></a>00115         }
<a name="l00116"></a>00116       
<a name="l00117"></a>00117       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119       <span class="keywordtype">int</span> ierr=0;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>
<a name="l00123"></a>00123   <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00124"></a>00124   ierr = SLESDestroy(_sles);
<a name="l00125"></a>00125          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#else</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
<a name="l00129"></a>00129   <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00130"></a>00130   ierr = KSPDestroy(_ksp);
<a name="l00131"></a>00131          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="preprocessor">#endif</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>
<a name="l00135"></a>00135              
<a name="l00136"></a>00136       <span class="comment">// Mimic PETSc default solver and preconditioner</span>
<a name="l00137"></a>00137       this-&gt;_solver_type           = <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       <span class="keywordflow">if</span>(!this-&gt;_preconditioner)
<a name="l00140"></a>00140       {
<a name="l00141"></a>00141         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00142"></a>00142           this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00143"></a>00143         <span class="keywordflow">else</span>
<a name="l00144"></a>00144           this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00145"></a>00145       }
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00152"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">00152</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">PetscLinearSolver&lt;T&gt;::init</a> ()
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00155"></a>00155   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00156"></a>00156     {
<a name="l00157"></a>00157       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00158"></a>00158       
<a name="l00159"></a>00159       <span class="keywordtype">int</span> ierr=0;
<a name="l00160"></a>00160   
<a name="l00161"></a>00161 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00162"></a>00162 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>      
<a name="l00164"></a>00164       <span class="comment">// Create the linear solver context</span>
<a name="l00165"></a>00165       ierr = SLESCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_sles);
<a name="l00166"></a>00166              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00167"></a>00167       
<a name="l00168"></a>00168       <span class="comment">// Create the Krylov subspace &amp; preconditioner contexts</span>
<a name="l00169"></a>00169       ierr = SLESGetKSP       (_sles, &amp;_ksp);
<a name="l00170"></a>00170              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00171"></a>00171       ierr = SLESGetPC        (_sles, &amp;_pc);
<a name="l00172"></a>00172              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00173"></a>00173       
<a name="l00174"></a>00174       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00175"></a>00175       this-&gt;set_petsc_solver_type();
<a name="l00176"></a>00176       
<a name="l00177"></a>00177       <span class="comment">// Set the options from user-input</span>
<a name="l00178"></a>00178       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00179"></a>00179       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00180"></a>00180       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00181"></a>00181       <span class="comment">//  SLESSetFromOptions() is called _after_ any other customization</span>
<a name="l00182"></a>00182       <span class="comment">//  routines.</span>
<a name="l00183"></a>00183       
<a name="l00184"></a>00184       ierr = SLESSetFromOptions (_sles);
<a name="l00185"></a>00185              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00188"></a>00188 <span class="preprocessor">#else</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>      
<a name="l00190"></a>00190       <span class="comment">// Create the linear solver context</span>
<a name="l00191"></a>00191       ierr = KSPCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_ksp);
<a name="l00192"></a>00192              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00193"></a>00193       
<a name="l00194"></a>00194       <span class="comment">// Create the preconditioner context</span>
<a name="l00195"></a>00195       ierr = KSPGetPC        (_ksp, &amp;_pc);
<a name="l00196"></a>00196              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00199"></a>00199       this-&gt;set_petsc_solver_type();
<a name="l00200"></a>00200 
<a name="l00201"></a>00201       <span class="comment">// Set the options from user-input</span>
<a name="l00202"></a>00202       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00203"></a>00203       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00204"></a>00204       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00205"></a>00205       <span class="comment">//  KSPSetFromOptions() is called _after_ any other customization</span>
<a name="l00206"></a>00206       <span class="comment">//  routines.</span>
<a name="l00207"></a>00207       
<a name="l00208"></a>00208       ierr = KSPSetFromOptions (_ksp);
<a name="l00209"></a>00209       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211       <span class="comment">// Not sure if this is necessary, or if it is already handled by KSPSetFromOptions?</span>
<a name="l00212"></a>00212       <span class="comment">// NOT NECESSARY!!!!</span>
<a name="l00213"></a>00213       <span class="comment">//ierr = PCSetFromOptions (_pc);</span>
<a name="l00214"></a>00214       <span class="comment">//CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00215"></a>00215 
<a name="l00216"></a>00216                
<a name="l00217"></a>00217 <span class="preprocessor">#endif</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>             
<a name="l00219"></a>00219       <span class="comment">// Have the Krylov subspace method use our good initial guess</span>
<a name="l00220"></a>00220       <span class="comment">// rather than 0, unless the user requested a KSPType of</span>
<a name="l00221"></a>00221       <span class="comment">// preonly, which complains if asked to use initial guesses.</span>
<a name="l00222"></a>00222 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>      KSPType ksp_type;
<a name="l00224"></a>00224 <span class="preprocessor">#else</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>      <span class="keyword">const</span> KSPType ksp_type;
<a name="l00226"></a>00226 <span class="preprocessor">#endif</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>
<a name="l00228"></a>00228       ierr = KSPGetType (_ksp, &amp;ksp_type);
<a name="l00229"></a>00229              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231       <span class="keywordflow">if</span> (strcmp(ksp_type, <span class="stringliteral">&quot;preonly&quot;</span>))
<a name="l00232"></a>00232         {
<a name="l00233"></a>00233           ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00234"></a>00234                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236       
<a name="l00237"></a>00237       <span class="comment">// Notify PETSc of location to store residual history.</span>
<a name="l00238"></a>00238       <span class="comment">// This needs to be called before any solves, since</span>
<a name="l00239"></a>00239       <span class="comment">// it sets the residual history length to zero.  The default</span>
<a name="l00240"></a>00240       <span class="comment">// behavior is for PETSc to allocate (internally) an array</span>
<a name="l00241"></a>00241       <span class="comment">// of size 1000 to hold the residual norm history.</span>
<a name="l00242"></a>00242       ierr = KSPSetResidualHistory(_ksp,
<a name="l00243"></a>00243                                    PETSC_NULL,   <span class="comment">// pointer to the array which holds the history</span>
<a name="l00244"></a>00244                                    PETSC_DECIDE, <span class="comment">// size of the array holding the history</span>
<a name="l00245"></a>00245                                    PETSC_TRUE);  <span class="comment">// Whether or not to reset the history for each solve. </span>
<a name="l00246"></a>00246       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aab69801de7b38fc74cf110baa0bcde9b">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a>(this-&gt;_preconditioner_type,_pc);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250       <span class="comment">//If there is a preconditioner object we need to set the internal setup and apply routines</span>
<a name="l00251"></a>00251       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00252"></a>00252       {
<a name="l00253"></a>00253         PCShellSetContext(_pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00254"></a>00254         PCShellSetSetUp(_pc,<a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00255"></a>00255         PCShellSetApply(_pc,<a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00256"></a>00256       }
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00262"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a5043790d71e95c0c95e2c7de0b4a7cfd">00262</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">PetscLinearSolver&lt;T&gt;::init</a> ( <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix )
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00265"></a>00265   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00266"></a>00266     {
<a name="l00267"></a>00267       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00268"></a>00268       
<a name="l00269"></a>00269       <span class="keywordtype">int</span> ierr=0;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00272"></a>00272 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span>      
<a name="l00274"></a>00274       <span class="comment">// Create the linear solver context</span>
<a name="l00275"></a>00275       ierr = SLESCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_sles);
<a name="l00276"></a>00276              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00277"></a>00277       
<a name="l00278"></a>00278       <span class="comment">// Create the Krylov subspace &amp; preconditioner contexts</span>
<a name="l00279"></a>00279       ierr = SLESGetKSP       (_sles, &amp;_ksp);
<a name="l00280"></a>00280              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00281"></a>00281       ierr = SLESGetPC        (_sles, &amp;_pc);
<a name="l00282"></a>00282              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00283"></a>00283       
<a name="l00284"></a>00284       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00285"></a>00285       this-&gt;set_petsc_solver_type();
<a name="l00286"></a>00286       
<a name="l00287"></a>00287       <span class="comment">// Set the options from user-input</span>
<a name="l00288"></a>00288       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00289"></a>00289       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00290"></a>00290       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00291"></a>00291       <span class="comment">//  SLESSetFromOptions() is called _after_ any other customization</span>
<a name="l00292"></a>00292       <span class="comment">//  routines.</span>
<a name="l00293"></a>00293       
<a name="l00294"></a>00294       ierr = SLESSetFromOptions (_sles);
<a name="l00295"></a>00295              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="comment">// 2.2.0 &amp; newer style</span>
<a name="l00298"></a>00298 <span class="preprocessor">#else</span>
<a name="l00299"></a>00299 <span class="preprocessor"></span>      
<a name="l00300"></a>00300       <span class="comment">// Create the linear solver context</span>
<a name="l00301"></a>00301       ierr = KSPCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, &amp;_ksp);
<a name="l00302"></a>00302              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00303"></a>00303       
<a name="l00304"></a>00304     
<a name="l00305"></a>00305       <span class="comment">//ierr = PCCreate (libMesh::COMM_WORLD, &amp;_pc);</span>
<a name="l00306"></a>00306       <span class="comment">//     CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00307"></a>00307       
<a name="l00308"></a>00308       <span class="comment">// Create the preconditioner context</span>
<a name="l00309"></a>00309       ierr = KSPGetPC        (_ksp, &amp;_pc);
<a name="l00310"></a>00310              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00311"></a>00311       
<a name="l00312"></a>00312       <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00313"></a>00313       ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),DIFFERENT_NONZERO_PATTERN);
<a name="l00314"></a>00314              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);       
<a name="l00315"></a>00315 
<a name="l00316"></a>00316       <span class="comment">// Set user-specified  solver and preconditioner types</span>
<a name="l00317"></a>00317       this-&gt;set_petsc_solver_type();
<a name="l00318"></a>00318 
<a name="l00319"></a>00319       <span class="comment">// Set the options from user-input</span>
<a name="l00320"></a>00320       <span class="comment">// Set runtime options, e.g.,</span>
<a name="l00321"></a>00321       <span class="comment">//      -ksp_type &lt;type&gt; -pc_type &lt;type&gt; -ksp_monitor -ksp_rtol &lt;rtol&gt;</span>
<a name="l00322"></a>00322       <span class="comment">//  These options will override those specified above as long as</span>
<a name="l00323"></a>00323       <span class="comment">//  KSPSetFromOptions() is called _after_ any other customization</span>
<a name="l00324"></a>00324       <span class="comment">//  routines.</span>
<a name="l00325"></a>00325       
<a name="l00326"></a>00326       ierr = KSPSetFromOptions (_ksp);
<a name="l00327"></a>00327       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00328"></a>00328 
<a name="l00329"></a>00329       <span class="comment">// Not sure if this is necessary, or if it is already handled by KSPSetFromOptions?</span>
<a name="l00330"></a>00330       <span class="comment">// NOT NECESSARY!!!!</span>
<a name="l00331"></a>00331       <span class="comment">//ierr = PCSetFromOptions (_pc);</span>
<a name="l00332"></a>00332       <span class="comment">//CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00333"></a>00333 
<a name="l00334"></a>00334                
<a name="l00335"></a>00335 <span class="preprocessor">#endif</span>
<a name="l00336"></a>00336 <span class="preprocessor"></span>             
<a name="l00337"></a>00337       <span class="comment">// Have the Krylov subspace method use our good initial guess</span>
<a name="l00338"></a>00338       <span class="comment">// rather than 0, unless the user requested a KSPType of</span>
<a name="l00339"></a>00339       <span class="comment">// preonly, which complains if asked to use initial guesses.</span>
<a name="l00340"></a>00340 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span>      KSPType ksp_type;
<a name="l00342"></a>00342 <span class="preprocessor">#else</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span>      <span class="keyword">const</span> KSPType ksp_type;
<a name="l00344"></a>00344 <span class="preprocessor">#endif</span>
<a name="l00345"></a>00345 <span class="preprocessor"></span>
<a name="l00346"></a>00346       ierr = KSPGetType (_ksp, &amp;ksp_type);
<a name="l00347"></a>00347              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00348"></a>00348 
<a name="l00349"></a>00349       <span class="keywordflow">if</span> (strcmp(ksp_type, <span class="stringliteral">&quot;preonly&quot;</span>))
<a name="l00350"></a>00350         {
<a name="l00351"></a>00351           ierr = KSPSetInitialGuessNonzero (_ksp, PETSC_TRUE);
<a name="l00352"></a>00352                  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00353"></a>00353         }
<a name="l00354"></a>00354       
<a name="l00355"></a>00355       <span class="comment">// Notify PETSc of location to store residual history.</span>
<a name="l00356"></a>00356       <span class="comment">// This needs to be called before any solves, since</span>
<a name="l00357"></a>00357       <span class="comment">// it sets the residual history length to zero.  The default</span>
<a name="l00358"></a>00358       <span class="comment">// behavior is for PETSc to allocate (internally) an array</span>
<a name="l00359"></a>00359       <span class="comment">// of size 1000 to hold the residual norm history.</span>
<a name="l00360"></a>00360       ierr = KSPSetResidualHistory(_ksp,
<a name="l00361"></a>00361                                    PETSC_NULL,   <span class="comment">// pointer to the array which holds the history</span>
<a name="l00362"></a>00362                                    PETSC_DECIDE, <span class="comment">// size of the array holding the history</span>
<a name="l00363"></a>00363                                    PETSC_TRUE);  <span class="comment">// Whether or not to reset the history for each solve. </span>
<a name="l00364"></a>00364       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366       <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aab69801de7b38fc74cf110baa0bcde9b">PetscPreconditioner&lt;T&gt;::set_petsc_preconditioner_type</a>(this-&gt;_preconditioner_type,_pc);      
<a name="l00367"></a>00367       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00368"></a>00368       {
<a name="l00369"></a>00369         this-&gt;_preconditioner-&gt;set_matrix(*matrix);
<a name="l00370"></a>00370         PCShellSetContext(_pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00371"></a>00371         PCShellSetSetUp(_pc,<a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00372"></a>00372         PCShellSetApply(_pc,<a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00373"></a>00373       }
<a name="l00374"></a>00374     }
<a name="l00375"></a>00375 }
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00380"></a>00380 <span class="keywordtype">void</span>
<a name="l00381"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7252a37818ad8bab9bda8b95b2ec7162">00381</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7252a37818ad8bab9bda8b95b2ec7162">PetscLinearSolver&lt;T&gt;::restrict_solve_to</a> (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;* <span class="keyword">const</span> dofs,
<a name="l00382"></a>00382                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137">SubsetSolveMode</a> subset_solve_mode)
<a name="l00383"></a>00383 {
<a name="l00384"></a>00384   <span class="keywordtype">int</span> ierr=0;
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="comment">/* The preconditioner (in particular if a default preconditioner)</span>
<a name="l00387"></a>00387 <span class="comment">     will have to be reset.  We call this-&gt;clear() to do that.  This</span>
<a name="l00388"></a>00388 <span class="comment">     call will also remove and free any previous subset that may have</span>
<a name="l00389"></a>00389 <span class="comment">     been set before.  */</span>
<a name="l00390"></a>00390   this-&gt;clear();
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   _subset_solve_mode = subset_solve_mode;
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="keywordflow">if</span>(dofs!=NULL)
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396       <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>* petsc_dofs = NULL;
<a name="l00397"></a>00397       ierr = PetscMalloc(dofs-&gt;size()*<span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>), &amp;petsc_dofs);
<a name="l00398"></a>00398       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400       <span class="keywordflow">for</span>(<span class="keywordtype">size_t</span> i=0; i&lt;dofs-&gt;size(); i++)
<a name="l00401"></a>00401         {
<a name="l00402"></a>00402           petsc_dofs[i] = (*dofs)[i];
<a name="l00403"></a>00403         }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405       ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,dofs-&gt;size(),petsc_dofs,<a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca7c3700533291999bc8618cc62bcc8486">PETSC_OWN_POINTER</a>,&amp;_restrict_solve_to_is);
<a name="l00406"></a>00406       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00407"></a>00407     }
<a name="l00408"></a>00408 }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00413"></a>00413 std::pair&lt;unsigned int, Real&gt; 
<a name="l00414"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab8db52e42db4bf42c4ccfa575a4e0632">00414</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">PetscLinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  matrix_in,
<a name="l00415"></a>00415                              <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  precond_in,
<a name="l00416"></a>00416                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00417"></a>00417                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00418"></a>00418                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00419"></a>00419                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00420"></a>00420 {
<a name="l00421"></a>00421   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00424"></a>00424   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix   = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;matrix_in);
<a name="l00425"></a>00425   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* precond  = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;precond_in);
<a name="l00426"></a>00426   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00427"></a>00427   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (matrix);
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   <span class="keywordtype">int</span> ierr=0;
<a name="l00432"></a>00432   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00433"></a>00433   PetscReal final_resid=0.;
<a name="l00434"></a>00434 
<a name="l00435"></a>00435   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00436"></a>00436   matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l00437"></a>00437   precond-&gt;close ();
<a name="l00438"></a>00438   solution-&gt;close ();
<a name="l00439"></a>00439   rhs-&gt;close ();
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 <span class="comment">//   // If matrix != precond, then this means we have specified a</span>
<a name="l00442"></a>00442 <span class="comment">//   // special preconditioner, so reset preconditioner type to PCMAT.</span>
<a name="l00443"></a>00443 <span class="comment">//   if (matrix != precond)</span>
<a name="l00444"></a>00444 <span class="comment">//     {</span>
<a name="l00445"></a>00445 <span class="comment">//       this-&gt;_preconditioner_type = USER_PRECOND;</span>
<a name="l00446"></a>00446 <span class="comment">//       this-&gt;set_petsc_preconditioner_type ();</span>
<a name="l00447"></a>00447 <span class="comment">//     }</span>
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 <span class="comment">// 2.1.x &amp; earlier style      </span>
<a name="l00450"></a>00450 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span>
<a name="l00452"></a>00452   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00453"></a>00453     {
<a name="l00454"></a>00454       libmesh_not_implemented();
<a name="l00455"></a>00455     }
<a name="l00456"></a>00456       
<a name="l00457"></a>00457   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00458"></a>00458   ierr = SLESSetOperators(_sles, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), precond-&gt;mat(),
<a name="l00459"></a>00459                           DIFFERENT_NONZERO_PATTERN);
<a name="l00460"></a>00460          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00461"></a>00461 
<a name="l00462"></a>00462   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00463"></a>00463   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00464"></a>00464   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00465"></a>00465                            PETSC_DEFAULT, max_its);
<a name="l00466"></a>00466          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469   <span class="comment">// Solve the linear system</span>
<a name="l00470"></a>00470   ierr = SLESSolve (_sles, rhs-&gt;vec(), solution-&gt;vec(), &amp;its);
<a name="l00471"></a>00471          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00475"></a>00475   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00476"></a>00476          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="comment">// 2.2.0</span>
<a name="l00479"></a>00479 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00480"></a>00480 <span class="preprocessor"></span>      
<a name="l00481"></a>00481   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00482"></a>00482     {
<a name="l00483"></a>00483       libmesh_not_implemented();
<a name="l00484"></a>00484     }
<a name="l00485"></a>00485       
<a name="l00486"></a>00486   <span class="comment">// Set operators. The input matrix works as the preconditioning matrix</span>
<a name="l00487"></a>00487   <span class="comment">//ierr = KSPSetOperators(_ksp, matrix-&gt;mat(), precond-&gt;mat(),</span>
<a name="l00488"></a>00488          <span class="comment">//                      SAME_NONZERO_PATTERN);</span>
<a name="l00489"></a>00489          <span class="comment">//       CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00493"></a>00493   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00494"></a>00494   <span class="comment">// Convergence is detected at iteration k if</span>
<a name="l00495"></a>00495   <span class="comment">// ||r_k||_2 &lt; max(rtol*||b||_2 , abstol)</span>
<a name="l00496"></a>00496   <span class="comment">// where r_k is the residual vector and b is the right-hand side.  Note that</span>
<a name="l00497"></a>00497   <span class="comment">// it is the *maximum* of the two values, the larger of which will almost</span>
<a name="l00498"></a>00498   <span class="comment">// always be rtol*||b||_2. </span>
<a name="l00499"></a>00499   ierr = KSPSetTolerances (_ksp,
<a name="l00500"></a>00500                            tol,           <span class="comment">// rtol   = relative decrease in residual  (1.e-5)</span>
<a name="l00501"></a>00501                            PETSC_DEFAULT, <span class="comment">// abstol = absolute convergence tolerance (1.e-50)</span>
<a name="l00502"></a>00502                            PETSC_DEFAULT, <span class="comment">// dtol   = divergence tolerance           (1.e+5)</span>
<a name="l00503"></a>00503                            max_its);
<a name="l00504"></a>00504          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   <span class="comment">// Set the solution vector to use</span>
<a name="l00508"></a>00508   ierr = KSPSetSolution (_ksp, solution-&gt;vec());
<a name="l00509"></a>00509          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00510"></a>00510          
<a name="l00511"></a>00511   <span class="comment">// Set the RHS vector to use</span>
<a name="l00512"></a>00512   ierr = KSPSetRhs (_ksp, rhs-&gt;vec());
<a name="l00513"></a>00513          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00514"></a>00514    
<a name="l00515"></a>00515   <span class="comment">// Solve the linear system</span>
<a name="l00516"></a>00516   ierr = KSPSolve (_ksp);
<a name="l00517"></a>00517          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00518"></a>00518          
<a name="l00519"></a>00519   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00520"></a>00520   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00521"></a>00521          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00522"></a>00522          
<a name="l00523"></a>00523   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00524"></a>00524   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00525"></a>00525          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00526"></a>00526          
<a name="l00527"></a>00527 <span class="comment">// 2.2.1 &amp; newer style</span>
<a name="l00528"></a>00528 <span class="preprocessor">#else</span>
<a name="l00529"></a>00529 <span class="preprocessor"></span>      
<a name="l00530"></a>00530   Mat submat = NULL;
<a name="l00531"></a>00531   Mat subprecond = NULL;
<a name="l00532"></a>00532   Vec subrhs = NULL;
<a name="l00533"></a>00533   Vec subsolution = NULL;
<a name="l00534"></a>00534   VecScatter scatter = NULL;
<a name="l00535"></a>00535   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>* subprecond_matrix = NULL;
<a name="l00536"></a>00536 
<a name="l00537"></a>00537   <span class="comment">// Set operators.  Also restrict rhs and solution vector to</span>
<a name="l00538"></a>00538   <span class="comment">// subdomain if neccessary.</span>
<a name="l00539"></a>00539   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00540"></a>00540     {
<a name="l00541"></a>00541       <span class="keywordtype">size_t</span> is_local_size = this-&gt;_restrict_solve_to_is_local_size();
<a name="l00542"></a>00542 
<a name="l00543"></a>00543       ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subrhs);
<a name="l00544"></a>00544       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00545"></a>00545       ierr = VecSetSizes(subrhs,is_local_size,PETSC_DECIDE);
<a name="l00546"></a>00546       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00547"></a>00547       ierr = VecSetFromOptions(subrhs);
<a name="l00548"></a>00548       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550       ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subsolution);
<a name="l00551"></a>00551       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00552"></a>00552       ierr = VecSetSizes(subsolution,is_local_size,PETSC_DECIDE);
<a name="l00553"></a>00553       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00554"></a>00554       ierr = VecSetFromOptions(subsolution);
<a name="l00555"></a>00555       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00556"></a>00556 
<a name="l00557"></a>00557       ierr = VecScatterCreate(rhs-&gt;vec(),_restrict_solve_to_is, subrhs,NULL, &amp;scatter);
<a name="l00558"></a>00558       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560       ierr = VecScatterBegin(scatter,rhs-&gt;vec(),subrhs,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00561"></a>00561       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00562"></a>00562       ierr = VecScatterEnd(scatter,rhs-&gt;vec(),subrhs,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00563"></a>00563       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00564"></a>00564 
<a name="l00565"></a>00565       ierr = VecScatterBegin(scatter,solution-&gt;vec(),subsolution,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00566"></a>00566       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00567"></a>00567       ierr = VecScatterEnd(scatter,solution-&gt;vec(),subsolution,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00568"></a>00568       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00571"></a>00571 <span class="preprocessor"></span>      ierr = MatGetSubMatrix(matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),
<a name="l00572"></a>00572                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l00573"></a>00573                              PETSC_DECIDE,MAT_INITIAL_MATRIX,&amp;submat);
<a name="l00574"></a>00574       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00575"></a>00575       ierr = MatGetSubMatrix(precond-&gt;mat(),
<a name="l00576"></a>00576                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l00577"></a>00577                              PETSC_DECIDE,MAT_INITIAL_MATRIX,&amp;subprecond);
<a name="l00578"></a>00578       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00579"></a>00579 <span class="preprocessor">#else</span>
<a name="l00580"></a>00580 <span class="preprocessor"></span>      ierr = MatGetSubMatrix(matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),
<a name="l00581"></a>00581                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l00582"></a>00582                              MAT_INITIAL_MATRIX,&amp;submat);
<a name="l00583"></a>00583       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00584"></a>00584       ierr = MatGetSubMatrix(precond-&gt;mat(),
<a name="l00585"></a>00585                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l00586"></a>00586                              MAT_INITIAL_MATRIX,&amp;subprecond);
<a name="l00587"></a>00587       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00588"></a>00588 <span class="preprocessor">#endif</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>
<a name="l00590"></a>00590       <span class="comment">/* Since removing columns of the matrix changes the equation</span>
<a name="l00591"></a>00591 <span class="comment">         system, we will now change the right hand side to compensate</span>
<a name="l00592"></a>00592 <span class="comment">         for this.  Note that this is not necessary if \p SUBSET_ZERO</span>
<a name="l00593"></a>00593 <span class="comment">         has been selected.  */</span>
<a name="l00594"></a>00594       <span class="keywordflow">if</span>(_subset_solve_mode!=<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>)
<a name="l00595"></a>00595         {
<a name="l00596"></a>00596           _create_complement_is(rhs_in);
<a name="l00597"></a>00597           <span class="keywordtype">size_t</span> is_complement_local_size = rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>()-is_local_size;
<a name="l00598"></a>00598 
<a name="l00599"></a>00599           Vec subvec1 = NULL;
<a name="l00600"></a>00600           Mat submat1 = NULL;
<a name="l00601"></a>00601           VecScatter scatter1 = NULL;
<a name="l00602"></a>00602 
<a name="l00603"></a>00603           ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subvec1);
<a name="l00604"></a>00604           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00605"></a>00605           ierr = VecSetSizes(subvec1,is_complement_local_size,PETSC_DECIDE);
<a name="l00606"></a>00606           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00607"></a>00607           ierr = VecSetFromOptions(subvec1);
<a name="l00608"></a>00608           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00609"></a>00609 
<a name="l00610"></a>00610           ierr = VecScatterCreate(rhs-&gt;vec(),_restrict_solve_to_is_complement, subvec1,NULL, &amp;scatter1);
<a name="l00611"></a>00611           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00612"></a>00612 
<a name="l00613"></a>00613           ierr = VecScatterBegin(scatter1,_subset_solve_mode==<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a> ? rhs-&gt;vec() : solution-&gt;vec(),subvec1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00614"></a>00614           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00615"></a>00615           ierr = VecScatterEnd(scatter1,_subset_solve_mode==<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a> ? rhs-&gt;vec() : solution-&gt;vec(),subvec1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00616"></a>00616           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00617"></a>00617 
<a name="l00618"></a>00618           ierr = VecScale(subvec1,-1.0);
<a name="l00619"></a>00619           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00622"></a>00622 <span class="preprocessor"></span>          ierr = MatGetSubMatrix(matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),
<a name="l00623"></a>00623                                  _restrict_solve_to_is,_restrict_solve_to_is_complement,
<a name="l00624"></a>00624                                  PETSC_DECIDE,MAT_INITIAL_MATRIX,&amp;submat1);
<a name="l00625"></a>00625           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00626"></a>00626 <span class="preprocessor">#else</span>
<a name="l00627"></a>00627 <span class="preprocessor"></span>          ierr = MatGetSubMatrix(matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),
<a name="l00628"></a>00628                                  _restrict_solve_to_is,_restrict_solve_to_is_complement,
<a name="l00629"></a>00629                                  MAT_INITIAL_MATRIX,&amp;submat1);
<a name="l00630"></a>00630           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00631"></a>00631 <span class="preprocessor">#endif</span>
<a name="l00632"></a>00632 <span class="preprocessor"></span>
<a name="l00633"></a>00633           ierr = MatMultAdd(submat1,subvec1,subrhs,subrhs);
<a name="l00634"></a>00634           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00635"></a>00635 
<a name="l00636"></a>00636           ierr = VecScatterDestroy(scatter1);
<a name="l00637"></a>00637           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00638"></a>00638           ierr = VecDestroy(subvec1);
<a name="l00639"></a>00639           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00640"></a>00640           ierr = MatDestroy(submat1);
<a name="l00641"></a>00641           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00642"></a>00642         }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644       ierr = KSPSetOperators(_ksp, submat, subprecond,
<a name="l00645"></a>00645                              this-&gt;same_preconditioner ? SAME_PRECONDITIONER : DIFFERENT_NONZERO_PATTERN);
<a name="l00646"></a>00646       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00647"></a>00647 
<a name="l00648"></a>00648       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00649"></a>00649         {
<a name="l00650"></a>00650           subprecond_matrix = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>(subprecond);
<a name="l00651"></a>00651           this-&gt;_preconditioner-&gt;set_matrix(*subprecond_matrix);
<a name="l00652"></a>00652         }
<a name="l00653"></a>00653     }
<a name="l00654"></a>00654   <span class="keywordflow">else</span>
<a name="l00655"></a>00655     {
<a name="l00656"></a>00656       ierr = KSPSetOperators(_ksp, matrix-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), precond-&gt;mat(),
<a name="l00657"></a>00657                              this-&gt;same_preconditioner ? SAME_PRECONDITIONER : DIFFERENT_NONZERO_PATTERN);
<a name="l00658"></a>00658       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00659"></a>00659 
<a name="l00660"></a>00660       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00661"></a>00661         this-&gt;_preconditioner-&gt;set_matrix(matrix_in);
<a name="l00662"></a>00662     }
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00665"></a>00665   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00666"></a>00666   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00667"></a>00667                            PETSC_DEFAULT, max_its);
<a name="l00668"></a>00668          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00669"></a>00669 
<a name="l00670"></a>00670   <span class="comment">// Solve the linear system</span>
<a name="l00671"></a>00671   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00672"></a>00672     {
<a name="l00673"></a>00673       ierr = KSPSolve (_ksp, subrhs, subsolution);
<a name="l00674"></a>00674       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00675"></a>00675     }
<a name="l00676"></a>00676   <span class="keywordflow">else</span>
<a name="l00677"></a>00677     {
<a name="l00678"></a>00678       ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;vec());
<a name="l00679"></a>00679       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00680"></a>00680     }
<a name="l00681"></a>00681          
<a name="l00682"></a>00682   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00683"></a>00683   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00684"></a>00684          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00685"></a>00685          
<a name="l00686"></a>00686   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00687"></a>00687   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00688"></a>00688          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00689"></a>00689          
<a name="l00690"></a>00690   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00691"></a>00691     {
<a name="l00692"></a>00692       <span class="keywordflow">switch</span>(_subset_solve_mode)
<a name="l00693"></a>00693         {
<a name="l00694"></a>00694         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>:
<a name="l00695"></a>00695           ierr = VecZeroEntries(solution-&gt;vec());
<a name="l00696"></a>00696           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00697"></a>00697           <span class="keywordflow">break</span>;
<a name="l00698"></a>00698 
<a name="l00699"></a>00699         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a>:
<a name="l00700"></a>00700           ierr = VecCopy(rhs-&gt;vec(),solution-&gt;vec());
<a name="l00701"></a>00701           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00702"></a>00702           <span class="keywordflow">break</span>;
<a name="l00703"></a>00703 
<a name="l00704"></a>00704         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a25975645279317cbca573100f41caa8a" title="Leaves dofs outside the subset unchanged. This is fastest, but also most confusing because it abandon...">SUBSET_DONT_TOUCH</a>:
<a name="l00705"></a>00705           <span class="comment">/* Nothing to do here.  */</span>
<a name="l00706"></a>00706           <span class="keywordflow">break</span>;
<a name="l00707"></a>00707 
<a name="l00708"></a>00708         }
<a name="l00709"></a>00709       ierr = VecScatterBegin(scatter,subsolution,solution-&gt;vec(),INSERT_VALUES,SCATTER_REVERSE);
<a name="l00710"></a>00710       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00711"></a>00711       ierr = VecScatterEnd(scatter,subsolution,solution-&gt;vec(),INSERT_VALUES,SCATTER_REVERSE);
<a name="l00712"></a>00712       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00713"></a>00713 
<a name="l00714"></a>00714       ierr = VecScatterDestroy(scatter);
<a name="l00715"></a>00715       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00716"></a>00716 
<a name="l00717"></a>00717       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00718"></a>00718         {
<a name="l00719"></a>00719           <span class="comment">/* Before we delete subprecond_matrix, we should give the</span>
<a name="l00720"></a>00720 <span class="comment">             _preconditioner a different matrix.  */</span>
<a name="l00721"></a>00721           this-&gt;_preconditioner-&gt;set_matrix(matrix_in);
<a name="l00722"></a>00722           <span class="keyword">delete</span> subprecond_matrix;
<a name="l00723"></a>00723           subprecond_matrix = NULL;
<a name="l00724"></a>00724         }
<a name="l00725"></a>00725 
<a name="l00726"></a>00726       ierr = VecDestroy(subsolution);
<a name="l00727"></a>00727       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00728"></a>00728       ierr = VecDestroy(subrhs);
<a name="l00729"></a>00729       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00730"></a>00730       ierr = MatDestroy(submat);
<a name="l00731"></a>00731       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00732"></a>00732       ierr = MatDestroy(subprecond);
<a name="l00733"></a>00733       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00734"></a>00734     }
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 <span class="preprocessor">#endif</span>
<a name="l00737"></a>00737 <span class="preprocessor"></span>
<a name="l00738"></a>00738   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00739"></a>00739   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00740"></a>00740   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l00741"></a>00741 }
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00746"></a>00746 std::pair&lt;unsigned int, Real&gt; 
<a name="l00747"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab5036322d3115ada26fe626164c08153">00747</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">PetscLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00748"></a>00748                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00749"></a>00749                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00750"></a>00750                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00751"></a>00751                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00752"></a>00752 {
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l00755"></a>00755 <span class="preprocessor"></span>  <span class="comment">// FIXME[JWP]: There will be a bunch of unused variable warnings</span>
<a name="l00756"></a>00756   <span class="comment">// for older PETScs here.</span>
<a name="l00757"></a>00757   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l00758"></a>00758                 &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l00759"></a>00759                 &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l00760"></a>00760                 &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l00761"></a>00761   libmesh_error();
<a name="l00762"></a>00762   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 <span class="preprocessor">#else</span>
<a name="l00765"></a>00765 <span class="preprocessor"></span>
<a name="l00766"></a>00766 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00767"></a>00767 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00768"></a>00768     {
<a name="l00769"></a>00769       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;The current implementation of subset solves with &quot;</span>
<a name="l00770"></a>00770                    &lt;&lt; <span class="stringliteral">&quot;shell matrices requires PETSc version 3.1 or above.  &quot;</span>
<a name="l00771"></a>00771                    &lt;&lt; <span class="stringliteral">&quot;Older PETSc version do not support automatic &quot;</span>
<a name="l00772"></a>00772                    &lt;&lt; <span class="stringliteral">&quot;submatrix generation of shell matrices.&quot;</span>
<a name="l00773"></a>00773                    &lt;&lt; std::endl;
<a name="l00774"></a>00774       libmesh_error();
<a name="l00775"></a>00775     }
<a name="l00776"></a>00776 <span class="preprocessor">#endif</span>
<a name="l00777"></a>00777 <span class="preprocessor"></span>
<a name="l00778"></a>00778   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00781"></a>00781   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00782"></a>00782   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00783"></a>00783 
<a name="l00784"></a>00784   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   <span class="keywordtype">int</span> ierr=0;
<a name="l00787"></a>00787   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l00788"></a>00788   PetscReal final_resid=0.;
<a name="l00789"></a>00789 
<a name="l00790"></a>00790   Mat submat = NULL;
<a name="l00791"></a>00791   Vec subrhs = NULL;
<a name="l00792"></a>00792   Vec subsolution = NULL;
<a name="l00793"></a>00793   VecScatter scatter = NULL;
<a name="l00794"></a>00794 
<a name="l00795"></a>00795   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l00796"></a>00796   solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a> ();
<a name="l00797"></a>00797   rhs-&gt;close ();
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   <span class="comment">// Prepare the matrix.</span>
<a name="l00800"></a>00800   Mat mat;
<a name="l00801"></a>00801   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00802"></a>00802                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l00803"></a>00803                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l00804"></a>00804                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l00805"></a>00805                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l00806"></a>00806                         <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l00807"></a>00807                         &amp;mat);
<a name="l00808"></a>00808   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l00809"></a>00809 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l00810"></a>00810 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l00811"></a>00811 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00814"></a>00814   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l00815"></a>00815   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00816"></a>00816   ierr = MatShellSetOperation(mat,MATOP_MULT_ADD,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult_add));
<a name="l00817"></a>00817   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00818"></a>00818   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l00819"></a>00819   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00820"></a>00820 
<a name="l00821"></a>00821   <span class="comment">// Restrict rhs and solution vectors and set operators.  The input</span>
<a name="l00822"></a>00822   <span class="comment">// matrix works as the preconditioning matrix.</span>
<a name="l00823"></a>00823   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00824"></a>00824     {
<a name="l00825"></a>00825       <span class="keywordtype">size_t</span> is_local_size = this-&gt;_restrict_solve_to_is_local_size();
<a name="l00826"></a>00826 
<a name="l00827"></a>00827       ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subrhs);
<a name="l00828"></a>00828       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00829"></a>00829       ierr = VecSetSizes(subrhs,is_local_size,PETSC_DECIDE);
<a name="l00830"></a>00830       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00831"></a>00831       ierr = VecSetFromOptions(subrhs);
<a name="l00832"></a>00832       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00833"></a>00833 
<a name="l00834"></a>00834       ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subsolution);
<a name="l00835"></a>00835       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00836"></a>00836       ierr = VecSetSizes(subsolution,is_local_size,PETSC_DECIDE);
<a name="l00837"></a>00837       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00838"></a>00838       ierr = VecSetFromOptions(subsolution);
<a name="l00839"></a>00839       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00840"></a>00840 
<a name="l00841"></a>00841       ierr = VecScatterCreate(rhs-&gt;vec(),_restrict_solve_to_is, subrhs,NULL, &amp;scatter);
<a name="l00842"></a>00842       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00843"></a>00843 
<a name="l00844"></a>00844       ierr = VecScatterBegin(scatter,rhs-&gt;vec(),subrhs,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00845"></a>00845       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00846"></a>00846       ierr = VecScatterEnd(scatter,rhs-&gt;vec(),subrhs,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00847"></a>00847       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00848"></a>00848 
<a name="l00849"></a>00849       ierr = VecScatterBegin(scatter,solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),subsolution,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00850"></a>00850       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00851"></a>00851       ierr = VecScatterEnd(scatter,solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),subsolution,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00852"></a>00852       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00855"></a>00855 <span class="preprocessor"></span>      <span class="comment">/* This point can&#39;t be reached, see above.  */</span>
<a name="l00856"></a>00856       libmesh_assert(<span class="keyword">false</span>);
<a name="l00857"></a>00857 <span class="preprocessor">#else</span>
<a name="l00858"></a>00858 <span class="preprocessor"></span>      ierr = MatGetSubMatrix(mat,
<a name="l00859"></a>00859                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l00860"></a>00860                              MAT_INITIAL_MATRIX,&amp;submat);
<a name="l00861"></a>00861       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00862"></a>00862 <span class="preprocessor">#endif</span>
<a name="l00863"></a>00863 <span class="preprocessor"></span>
<a name="l00864"></a>00864       <span class="comment">/* Since removing columns of the matrix changes the equation</span>
<a name="l00865"></a>00865 <span class="comment">         system, we will now change the right hand side to compensate</span>
<a name="l00866"></a>00866 <span class="comment">         for this.  Note that this is not necessary if \p SUBSET_ZERO</span>
<a name="l00867"></a>00867 <span class="comment">         has been selected.  */</span>
<a name="l00868"></a>00868       <span class="keywordflow">if</span>(_subset_solve_mode!=<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>)
<a name="l00869"></a>00869         {
<a name="l00870"></a>00870           _create_complement_is(rhs_in);
<a name="l00871"></a>00871           <span class="keywordtype">size_t</span> is_complement_local_size = rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>()-is_local_size;
<a name="l00872"></a>00872 
<a name="l00873"></a>00873           Vec subvec1 = NULL;
<a name="l00874"></a>00874           Mat submat1 = NULL;
<a name="l00875"></a>00875           VecScatter scatter1 = NULL;
<a name="l00876"></a>00876 
<a name="l00877"></a>00877           ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subvec1);
<a name="l00878"></a>00878           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00879"></a>00879           ierr = VecSetSizes(subvec1,is_complement_local_size,PETSC_DECIDE);
<a name="l00880"></a>00880           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00881"></a>00881           ierr = VecSetFromOptions(subvec1);
<a name="l00882"></a>00882           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00883"></a>00883 
<a name="l00884"></a>00884           ierr = VecScatterCreate(rhs-&gt;vec(),_restrict_solve_to_is_complement, subvec1,NULL, &amp;scatter1);
<a name="l00885"></a>00885           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00886"></a>00886 
<a name="l00887"></a>00887           ierr = VecScatterBegin(scatter1,_subset_solve_mode==<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a> ? rhs-&gt;vec() : solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),subvec1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00888"></a>00888           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00889"></a>00889           ierr = VecScatterEnd(scatter1,_subset_solve_mode==<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a> ? rhs-&gt;vec() : solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),subvec1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00890"></a>00890           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00891"></a>00891 
<a name="l00892"></a>00892           ierr = VecScale(subvec1,-1.0);
<a name="l00893"></a>00893           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00896"></a>00896 <span class="preprocessor"></span>          <span class="comment">/* This point can&#39;t be reached, see above.  */</span>
<a name="l00897"></a>00897           libmesh_assert(<span class="keyword">false</span>);
<a name="l00898"></a>00898 <span class="preprocessor">#else</span>
<a name="l00899"></a>00899 <span class="preprocessor"></span>          ierr = MatGetSubMatrix(mat,
<a name="l00900"></a>00900                                  _restrict_solve_to_is,_restrict_solve_to_is_complement,
<a name="l00901"></a>00901                                  MAT_INITIAL_MATRIX,&amp;submat1);
<a name="l00902"></a>00902           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00903"></a>00903 <span class="preprocessor">#endif</span>
<a name="l00904"></a>00904 <span class="preprocessor"></span>
<a name="l00905"></a>00905           <span class="comment">// The following lines would be correct, but don&#39;t work</span>
<a name="l00906"></a>00906           <span class="comment">// correctly in PETSc up to 3.1.0-p5.  See discussion in</span>
<a name="l00907"></a>00907           <span class="comment">// petsc-users of Nov 9, 2010.</span>
<a name="l00908"></a>00908           <span class="comment">//</span>
<a name="l00909"></a>00909           <span class="comment">// ierr = MatMultAdd(submat1,subvec1,subrhs,subrhs);</span>
<a name="l00910"></a>00910           <span class="comment">// CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00911"></a>00911           <span class="comment">//</span>
<a name="l00912"></a>00912           <span class="comment">// We workaround by using a temporary vector.  Note that the</span>
<a name="l00913"></a>00913           <span class="comment">// fix in PETsc 3.1.0-p6 uses a temporary vector internally,</span>
<a name="l00914"></a>00914           <span class="comment">// so this is no effective performance loss.</span>
<a name="l00915"></a>00915           Vec subvec2 = NULL;
<a name="l00916"></a>00916           ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subvec2);
<a name="l00917"></a>00917           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00918"></a>00918           ierr = VecSetSizes(subvec2,is_local_size,PETSC_DECIDE);
<a name="l00919"></a>00919           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00920"></a>00920           ierr = VecSetFromOptions(subvec2);
<a name="l00921"></a>00921           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00922"></a>00922           ierr = MatMult(submat1,subvec1,subvec2);
<a name="l00923"></a>00923           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00924"></a>00924           ierr = VecAXPY(subrhs,1.0,subvec2);
<a name="l00925"></a>00925 
<a name="l00926"></a>00926           ierr = VecScatterDestroy(scatter1);
<a name="l00927"></a>00927           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00928"></a>00928           ierr = VecDestroy(subvec1);
<a name="l00929"></a>00929           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00930"></a>00930           ierr = MatDestroy(submat1);
<a name="l00931"></a>00931           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00932"></a>00932         }
<a name="l00933"></a>00933 
<a name="l00934"></a>00934       ierr = KSPSetOperators(_ksp, submat, submat,
<a name="l00935"></a>00935                              DIFFERENT_NONZERO_PATTERN);
<a name="l00936"></a>00936       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00937"></a>00937     }
<a name="l00938"></a>00938   <span class="keywordflow">else</span>
<a name="l00939"></a>00939     {
<a name="l00940"></a>00940       ierr = KSPSetOperators(_ksp, mat, mat,
<a name="l00941"></a>00941                              DIFFERENT_NONZERO_PATTERN);
<a name="l00942"></a>00942       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00943"></a>00943     }
<a name="l00944"></a>00944 
<a name="l00945"></a>00945   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00946"></a>00946   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l00947"></a>00947   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l00948"></a>00948                            PETSC_DEFAULT, max_its);
<a name="l00949"></a>00949   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00950"></a>00950 
<a name="l00951"></a>00951   <span class="comment">// Solve the linear system</span>
<a name="l00952"></a>00952   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00953"></a>00953     {
<a name="l00954"></a>00954       ierr = KSPSolve (_ksp, subrhs, subsolution);
<a name="l00955"></a>00955       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00956"></a>00956     }
<a name="l00957"></a>00957   <span class="keywordflow">else</span>
<a name="l00958"></a>00958     {
<a name="l00959"></a>00959       ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>());
<a name="l00960"></a>00960       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00961"></a>00961     }
<a name="l00962"></a>00962          
<a name="l00963"></a>00963   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l00964"></a>00964   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l00965"></a>00965   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00966"></a>00966          
<a name="l00967"></a>00967   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l00968"></a>00968   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l00969"></a>00969   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00970"></a>00970 
<a name="l00971"></a>00971   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l00972"></a>00972     {
<a name="l00973"></a>00973       <span class="keywordflow">switch</span>(_subset_solve_mode)
<a name="l00974"></a>00974         {
<a name="l00975"></a>00975         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>:
<a name="l00976"></a>00976           ierr = VecZeroEntries(solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>());
<a name="l00977"></a>00977           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00978"></a>00978           <span class="keywordflow">break</span>;
<a name="l00979"></a>00979 
<a name="l00980"></a>00980         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a>:
<a name="l00981"></a>00981           ierr = VecCopy(rhs-&gt;vec(),solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>());
<a name="l00982"></a>00982           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00983"></a>00983           <span class="keywordflow">break</span>;
<a name="l00984"></a>00984 
<a name="l00985"></a>00985         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a25975645279317cbca573100f41caa8a" title="Leaves dofs outside the subset unchanged. This is fastest, but also most confusing because it abandon...">SUBSET_DONT_TOUCH</a>:
<a name="l00986"></a>00986           <span class="comment">/* Nothing to do here.  */</span>
<a name="l00987"></a>00987           <span class="keywordflow">break</span>;
<a name="l00988"></a>00988 
<a name="l00989"></a>00989         }
<a name="l00990"></a>00990       ierr = VecScatterBegin(scatter,subsolution,solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),INSERT_VALUES,SCATTER_REVERSE);
<a name="l00991"></a>00991       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00992"></a>00992       ierr = VecScatterEnd(scatter,subsolution,solution-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),INSERT_VALUES,SCATTER_REVERSE);
<a name="l00993"></a>00993       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00994"></a>00994 
<a name="l00995"></a>00995       ierr = VecScatterDestroy(scatter);
<a name="l00996"></a>00996       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00997"></a>00997 
<a name="l00998"></a>00998       ierr = VecDestroy(subsolution);
<a name="l00999"></a>00999       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01000"></a>01000       ierr = VecDestroy(subrhs);
<a name="l01001"></a>01001       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01002"></a>01002       ierr = MatDestroy(submat);
<a name="l01003"></a>01003       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01004"></a>01004     }
<a name="l01005"></a>01005 
<a name="l01006"></a>01006   <span class="comment">// Destroy the matrix.</span>
<a name="l01007"></a>01007   ierr = MatDestroy(mat);
<a name="l01008"></a>01008   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01009"></a>01009          
<a name="l01010"></a>01010   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l01011"></a>01011   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l01012"></a>01012   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l01013"></a>01013 
<a name="l01014"></a>01014 <span class="preprocessor">#endif</span>
<a name="l01015"></a>01015 <span class="preprocessor"></span>
<a name="l01016"></a>01016 }
<a name="l01017"></a>01017 
<a name="l01018"></a>01018 
<a name="l01019"></a>01019 
<a name="l01020"></a>01020 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01021"></a>01021 std::pair&lt;unsigned int, Real&gt; 
<a name="l01022"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a601877cb3f2df95ddfb917d6f16ff2d3">01022</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">PetscLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l01023"></a>01023                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l01024"></a>01024                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l01025"></a>01025                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l01026"></a>01026                              <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l01027"></a>01027                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l01028"></a>01028 {
<a name="l01029"></a>01029 
<a name="l01030"></a>01030 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l01031"></a>01031 <span class="preprocessor"></span>  <span class="comment">// FIXME[JWP]: There will be a bunch of unused variable warnings</span>
<a name="l01032"></a>01032   <span class="comment">// for older PETScs here.</span>
<a name="l01033"></a>01033   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l01034"></a>01034                 &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l01035"></a>01035                 &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l01036"></a>01036                 &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l01037"></a>01037   libmesh_error();
<a name="l01038"></a>01038   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l01039"></a>01039 
<a name="l01040"></a>01040 <span class="preprocessor">#else</span>
<a name="l01041"></a>01041 <span class="preprocessor"></span>
<a name="l01042"></a>01042 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l01043"></a>01043 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l01044"></a>01044     {
<a name="l01045"></a>01045       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;The current implementation of subset solves with &quot;</span>
<a name="l01046"></a>01046                    &lt;&lt; <span class="stringliteral">&quot;shell matrices requires PETSc version 3.1 or above.  &quot;</span>
<a name="l01047"></a>01047                    &lt;&lt; <span class="stringliteral">&quot;Older PETSc version do not support automatic &quot;</span>
<a name="l01048"></a>01048                    &lt;&lt; <span class="stringliteral">&quot;submatrix generation of shell matrices.&quot;</span>
<a name="l01049"></a>01049                    &lt;&lt; std::endl;
<a name="l01050"></a>01050       libmesh_error();
<a name="l01051"></a>01051     }
<a name="l01052"></a>01052 <span class="preprocessor">#endif</span>
<a name="l01053"></a>01053 <span class="preprocessor"></span>
<a name="l01054"></a>01054   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l01055"></a>01055 
<a name="l01056"></a>01056   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l01057"></a>01057   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* precond  = libmesh_cast_ptr&lt;const PetscMatrix&lt;T&gt;*&gt;(&amp;precond_matrix);
<a name="l01058"></a>01058   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l01059"></a>01059   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l01060"></a>01060 
<a name="l01061"></a>01061   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l01062"></a>01062 
<a name="l01063"></a>01063   <span class="keywordtype">int</span> ierr=0;
<a name="l01064"></a>01064   <span class="keywordtype">int</span> its=0, max_its = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(m_its);
<a name="l01065"></a>01065   PetscReal final_resid=0.;
<a name="l01066"></a>01066 
<a name="l01067"></a>01067   Mat submat = NULL;
<a name="l01068"></a>01068   Mat subprecond = NULL;
<a name="l01069"></a>01069   Vec subrhs = NULL;
<a name="l01070"></a>01070   Vec subsolution = NULL;
<a name="l01071"></a>01071   VecScatter scatter = NULL;
<a name="l01072"></a>01072   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>* subprecond_matrix = NULL;
<a name="l01073"></a>01073 
<a name="l01074"></a>01074   <span class="comment">// Close the matrices and vectors in case this wasn&#39;t already done.</span>
<a name="l01075"></a>01075   solution-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> ();
<a name="l01076"></a>01076   rhs-&gt;close ();
<a name="l01077"></a>01077 
<a name="l01078"></a>01078   <span class="comment">// Prepare the matrix.</span>
<a name="l01079"></a>01079   Mat mat;
<a name="l01080"></a>01080   ierr = MatCreateShell(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l01081"></a>01081                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l01082"></a>01082                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),
<a name="l01083"></a>01083                         rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l01084"></a>01084                         solution_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),
<a name="l01085"></a>01085                         <span class="keyword">const_cast&lt;</span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;shell_matrix)),
<a name="l01086"></a>01086                         &amp;mat);
<a name="l01087"></a>01087   <span class="comment">/* Note that the const_cast above is only necessary because PETSc</span>
<a name="l01088"></a>01088 <span class="comment">     does not accept a const void*.  Inside the member function</span>
<a name="l01089"></a>01089 <span class="comment">     _petsc_shell_matrix() below, the pointer is casted back to a</span>
<a name="l01090"></a>01090 <span class="comment">     const ShellMatrix&lt;T&gt;*.  */</span>
<a name="l01091"></a>01091 
<a name="l01092"></a>01092   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01093"></a>01093   ierr = MatShellSetOperation(mat,MATOP_MULT,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult));
<a name="l01094"></a>01094   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01095"></a>01095   ierr = MatShellSetOperation(mat,MATOP_MULT_ADD,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_mult_add));
<a name="l01096"></a>01096   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01097"></a>01097   ierr = MatShellSetOperation(mat,MATOP_GET_DIAGONAL,<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">void</span>(*)(<span class="keywordtype">void</span>)<span class="keyword">&gt;</span>(_petsc_shell_matrix_get_diagonal));
<a name="l01098"></a>01098   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01099"></a>01099 
<a name="l01100"></a>01100   <span class="comment">// Restrict rhs and solution vectors and set operators.  The input</span>
<a name="l01101"></a>01101   <span class="comment">// matrix works as the preconditioning matrix.</span>
<a name="l01102"></a>01102   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l01103"></a>01103     {
<a name="l01104"></a>01104       <span class="keywordtype">size_t</span> is_local_size = this-&gt;_restrict_solve_to_is_local_size();
<a name="l01105"></a>01105 
<a name="l01106"></a>01106       ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subrhs);
<a name="l01107"></a>01107       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01108"></a>01108       ierr = VecSetSizes(subrhs,is_local_size,PETSC_DECIDE);
<a name="l01109"></a>01109       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01110"></a>01110       ierr = VecSetFromOptions(subrhs);
<a name="l01111"></a>01111       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01112"></a>01112 
<a name="l01113"></a>01113       ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subsolution);
<a name="l01114"></a>01114       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01115"></a>01115       ierr = VecSetSizes(subsolution,is_local_size,PETSC_DECIDE);
<a name="l01116"></a>01116       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01117"></a>01117       ierr = VecSetFromOptions(subsolution);
<a name="l01118"></a>01118       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01119"></a>01119 
<a name="l01120"></a>01120       ierr = VecScatterCreate(rhs-&gt;vec(),_restrict_solve_to_is, subrhs,NULL, &amp;scatter);
<a name="l01121"></a>01121       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01122"></a>01122 
<a name="l01123"></a>01123       ierr = VecScatterBegin(scatter,rhs-&gt;vec(),subrhs,INSERT_VALUES,SCATTER_FORWARD);
<a name="l01124"></a>01124       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01125"></a>01125       ierr = VecScatterEnd(scatter,rhs-&gt;vec(),subrhs,INSERT_VALUES,SCATTER_FORWARD);
<a name="l01126"></a>01126       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01127"></a>01127 
<a name="l01128"></a>01128       ierr = VecScatterBegin(scatter,solution-&gt;vec(),subsolution,INSERT_VALUES,SCATTER_FORWARD);
<a name="l01129"></a>01129       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01130"></a>01130       ierr = VecScatterEnd(scatter,solution-&gt;vec(),subsolution,INSERT_VALUES,SCATTER_FORWARD);
<a name="l01131"></a>01131       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01132"></a>01132 
<a name="l01133"></a>01133 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l01134"></a>01134 <span class="preprocessor"></span>      <span class="comment">/* This point can&#39;t be reached, see above.  */</span>
<a name="l01135"></a>01135       libmesh_assert(<span class="keyword">false</span>);
<a name="l01136"></a>01136 <span class="preprocessor">#else</span>
<a name="l01137"></a>01137 <span class="preprocessor"></span>      ierr = MatGetSubMatrix(mat,
<a name="l01138"></a>01138                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l01139"></a>01139                              MAT_INITIAL_MATRIX,&amp;submat);
<a name="l01140"></a>01140       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01141"></a>01141       ierr = MatGetSubMatrix(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(precond)-&gt;mat(),
<a name="l01142"></a>01142                              _restrict_solve_to_is,_restrict_solve_to_is,
<a name="l01143"></a>01143                              MAT_INITIAL_MATRIX,&amp;subprecond);
<a name="l01144"></a>01144       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01145"></a>01145 <span class="preprocessor">#endif</span>
<a name="l01146"></a>01146 <span class="preprocessor"></span>
<a name="l01147"></a>01147       <span class="comment">/* Since removing columns of the matrix changes the equation</span>
<a name="l01148"></a>01148 <span class="comment">         system, we will now change the right hand side to compensate</span>
<a name="l01149"></a>01149 <span class="comment">         for this.  Note that this is not necessary if \p SUBSET_ZERO</span>
<a name="l01150"></a>01150 <span class="comment">         has been selected.  */</span>
<a name="l01151"></a>01151       <span class="keywordflow">if</span>(_subset_solve_mode!=<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>)
<a name="l01152"></a>01152         {
<a name="l01153"></a>01153           _create_complement_is(rhs_in);
<a name="l01154"></a>01154           <span class="keywordtype">size_t</span> is_complement_local_size = rhs_in.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>()-is_local_size;
<a name="l01155"></a>01155 
<a name="l01156"></a>01156           Vec subvec1 = NULL;
<a name="l01157"></a>01157           Mat submat1 = NULL;
<a name="l01158"></a>01158           VecScatter scatter1 = NULL;
<a name="l01159"></a>01159 
<a name="l01160"></a>01160           ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subvec1);
<a name="l01161"></a>01161           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01162"></a>01162           ierr = VecSetSizes(subvec1,is_complement_local_size,PETSC_DECIDE);
<a name="l01163"></a>01163           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01164"></a>01164           ierr = VecSetFromOptions(subvec1);
<a name="l01165"></a>01165           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01166"></a>01166 
<a name="l01167"></a>01167           ierr = VecScatterCreate(rhs-&gt;vec(),_restrict_solve_to_is_complement, subvec1,NULL, &amp;scatter1);
<a name="l01168"></a>01168           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01169"></a>01169 
<a name="l01170"></a>01170           ierr = VecScatterBegin(scatter1,_subset_solve_mode==<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a> ? rhs-&gt;vec() : solution-&gt;vec(),subvec1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l01171"></a>01171           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01172"></a>01172           ierr = VecScatterEnd(scatter1,_subset_solve_mode==<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a> ? rhs-&gt;vec() : solution-&gt;vec(),subvec1,INSERT_VALUES,SCATTER_FORWARD);
<a name="l01173"></a>01173           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01174"></a>01174 
<a name="l01175"></a>01175           ierr = VecScale(subvec1,-1.0);
<a name="l01176"></a>01176           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01177"></a>01177 
<a name="l01178"></a>01178 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l01179"></a>01179 <span class="preprocessor"></span>          <span class="comment">/* This point can&#39;t be reached, see above.  */</span>
<a name="l01180"></a>01180           libmesh_assert(<span class="keyword">false</span>);
<a name="l01181"></a>01181 <span class="preprocessor">#else</span>
<a name="l01182"></a>01182 <span class="preprocessor"></span>          ierr = MatGetSubMatrix(mat,
<a name="l01183"></a>01183                                  _restrict_solve_to_is,_restrict_solve_to_is_complement,
<a name="l01184"></a>01184                                  MAT_INITIAL_MATRIX,&amp;submat1);
<a name="l01185"></a>01185           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01186"></a>01186 <span class="preprocessor">#endif</span>
<a name="l01187"></a>01187 <span class="preprocessor"></span>
<a name="l01188"></a>01188           <span class="comment">// The following lines would be correct, but don&#39;t work</span>
<a name="l01189"></a>01189           <span class="comment">// correctly in PETSc up to 3.1.0-p5.  See discussion in</span>
<a name="l01190"></a>01190           <span class="comment">// petsc-users of Nov 9, 2010.</span>
<a name="l01191"></a>01191           <span class="comment">//</span>
<a name="l01192"></a>01192           <span class="comment">// ierr = MatMultAdd(submat1,subvec1,subrhs,subrhs);</span>
<a name="l01193"></a>01193           <span class="comment">// CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l01194"></a>01194           <span class="comment">//</span>
<a name="l01195"></a>01195           <span class="comment">// We workaround by using a temporary vector.  Note that the</span>
<a name="l01196"></a>01196           <span class="comment">// fix in PETsc 3.1.0-p6 uses a temporary vector internally,</span>
<a name="l01197"></a>01197           <span class="comment">// so this is no effective performance loss.</span>
<a name="l01198"></a>01198           Vec subvec2 = NULL;
<a name="l01199"></a>01199           ierr = VecCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;subvec2);
<a name="l01200"></a>01200           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01201"></a>01201           ierr = VecSetSizes(subvec2,is_local_size,PETSC_DECIDE);
<a name="l01202"></a>01202           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01203"></a>01203           ierr = VecSetFromOptions(subvec2);
<a name="l01204"></a>01204           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01205"></a>01205           ierr = MatMult(submat1,subvec1,subvec2);
<a name="l01206"></a>01206           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01207"></a>01207           ierr = VecAXPY(subrhs,1.0,subvec2);
<a name="l01208"></a>01208           
<a name="l01209"></a>01209           ierr = VecScatterDestroy(scatter1);
<a name="l01210"></a>01210           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01211"></a>01211           ierr = VecDestroy(subvec1);
<a name="l01212"></a>01212           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01213"></a>01213           ierr = MatDestroy(submat1);
<a name="l01214"></a>01214           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01215"></a>01215         }
<a name="l01216"></a>01216 
<a name="l01217"></a>01217       ierr = KSPSetOperators(_ksp, submat, subprecond,
<a name="l01218"></a>01218                              DIFFERENT_NONZERO_PATTERN);
<a name="l01219"></a>01219       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01220"></a>01220 
<a name="l01221"></a>01221       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l01222"></a>01222         {
<a name="l01223"></a>01223           subprecond_matrix = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>(subprecond);
<a name="l01224"></a>01224           this-&gt;_preconditioner-&gt;set_matrix(*subprecond_matrix);
<a name="l01225"></a>01225         }
<a name="l01226"></a>01226     }
<a name="l01227"></a>01227   <span class="keywordflow">else</span>
<a name="l01228"></a>01228     {
<a name="l01229"></a>01229       ierr = KSPSetOperators(_ksp, mat, <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(precond)-&gt;mat(),
<a name="l01230"></a>01230                              DIFFERENT_NONZERO_PATTERN);
<a name="l01231"></a>01231       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01232"></a>01232 
<a name="l01233"></a>01233       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l01234"></a>01234         this-&gt;_preconditioner-&gt;set_matrix(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp;<span class="keyword">&gt;</span>(precond_matrix));
<a name="l01235"></a>01235     }
<a name="l01236"></a>01236 
<a name="l01237"></a>01237   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l01238"></a>01238   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values.</span>
<a name="l01239"></a>01239   ierr = KSPSetTolerances (_ksp, tol, PETSC_DEFAULT,
<a name="l01240"></a>01240                            PETSC_DEFAULT, max_its);
<a name="l01241"></a>01241   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01242"></a>01242 
<a name="l01243"></a>01243   <span class="comment">// Solve the linear system</span>
<a name="l01244"></a>01244   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l01245"></a>01245     {
<a name="l01246"></a>01246       ierr = KSPSolve (_ksp, subrhs, subsolution);
<a name="l01247"></a>01247       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01248"></a>01248     }
<a name="l01249"></a>01249   <span class="keywordflow">else</span>
<a name="l01250"></a>01250     {
<a name="l01251"></a>01251       ierr = KSPSolve (_ksp, rhs-&gt;vec(), solution-&gt;vec());
<a name="l01252"></a>01252       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01253"></a>01253     }
<a name="l01254"></a>01254          
<a name="l01255"></a>01255   <span class="comment">// Get the number of iterations required for convergence</span>
<a name="l01256"></a>01256   ierr = KSPGetIterationNumber (_ksp, &amp;its);
<a name="l01257"></a>01257   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01258"></a>01258          
<a name="l01259"></a>01259   <span class="comment">// Get the norm of the final residual to return to the user.</span>
<a name="l01260"></a>01260   ierr = KSPGetResidualNorm (_ksp, &amp;final_resid);
<a name="l01261"></a>01261   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01262"></a>01262 
<a name="l01263"></a>01263   <span class="keywordflow">if</span>(_restrict_solve_to_is!=NULL)
<a name="l01264"></a>01264     {
<a name="l01265"></a>01265       <span class="keywordflow">switch</span>(_subset_solve_mode)
<a name="l01266"></a>01266         {
<a name="l01267"></a>01267         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>:
<a name="l01268"></a>01268           ierr = VecZeroEntries(solution-&gt;vec());
<a name="l01269"></a>01269           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01270"></a>01270           <span class="keywordflow">break</span>;
<a name="l01271"></a>01271 
<a name="l01272"></a>01272         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a78b9e77757865834dee200ffcaf15b55" title="Set dofs outside the subset to the value of the corresponding dofs of the right hand side...">SUBSET_COPY_RHS</a>:
<a name="l01273"></a>01273           ierr = VecCopy(rhs-&gt;vec(),solution-&gt;vec());
<a name="l01274"></a>01274           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01275"></a>01275           <span class="keywordflow">break</span>;
<a name="l01276"></a>01276 
<a name="l01277"></a>01277         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a25975645279317cbca573100f41caa8a" title="Leaves dofs outside the subset unchanged. This is fastest, but also most confusing because it abandon...">SUBSET_DONT_TOUCH</a>:
<a name="l01278"></a>01278           <span class="comment">/* Nothing to do here.  */</span>
<a name="l01279"></a>01279           <span class="keywordflow">break</span>;
<a name="l01280"></a>01280 
<a name="l01281"></a>01281         }
<a name="l01282"></a>01282       ierr = VecScatterBegin(scatter,subsolution,solution-&gt;vec(),INSERT_VALUES,SCATTER_REVERSE);
<a name="l01283"></a>01283       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01284"></a>01284       ierr = VecScatterEnd(scatter,subsolution,solution-&gt;vec(),INSERT_VALUES,SCATTER_REVERSE);
<a name="l01285"></a>01285       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01286"></a>01286 
<a name="l01287"></a>01287       ierr = VecScatterDestroy(scatter);
<a name="l01288"></a>01288       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01289"></a>01289 
<a name="l01290"></a>01290       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l01291"></a>01291         {
<a name="l01292"></a>01292           <span class="comment">/* Before we delete subprecond_matrix, we should give the</span>
<a name="l01293"></a>01293 <span class="comment">             _preconditioner a different matrix.  */</span>
<a name="l01294"></a>01294           this-&gt;_preconditioner-&gt;set_matrix(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp;<span class="keyword">&gt;</span>(precond_matrix));
<a name="l01295"></a>01295           <span class="keyword">delete</span> subprecond_matrix;
<a name="l01296"></a>01296           subprecond_matrix = NULL;
<a name="l01297"></a>01297         }
<a name="l01298"></a>01298 
<a name="l01299"></a>01299       ierr = VecDestroy(subsolution);
<a name="l01300"></a>01300       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01301"></a>01301       ierr = VecDestroy(subrhs);
<a name="l01302"></a>01302       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01303"></a>01303       ierr = MatDestroy(submat);
<a name="l01304"></a>01304       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01305"></a>01305       ierr = MatDestroy(subprecond);
<a name="l01306"></a>01306       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01307"></a>01307     }
<a name="l01308"></a>01308 
<a name="l01309"></a>01309   <span class="comment">// Destroy the matrix.</span>
<a name="l01310"></a>01310   ierr = MatDestroy(mat);
<a name="l01311"></a>01311   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01312"></a>01312          
<a name="l01313"></a>01313   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscLinearSolver&quot;</span>);
<a name="l01314"></a>01314   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l01315"></a>01315   <span class="keywordflow">return</span> std::make_pair(its, final_resid);
<a name="l01316"></a>01316 
<a name="l01317"></a>01317 <span class="preprocessor">#endif</span>
<a name="l01318"></a>01318 <span class="preprocessor"></span>
<a name="l01319"></a>01319 }
<a name="l01320"></a>01320 
<a name="l01321"></a>01321 
<a name="l01322"></a>01322 
<a name="l01323"></a>01323 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01324"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1d8c73be13b0e349132fbd2f1a7e0efc">01324</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1d8c73be13b0e349132fbd2f1a7e0efc">PetscLinearSolver&lt;T&gt;::get_residual_history</a>(std::vector&lt;double&gt;&amp; hist)
<a name="l01325"></a>01325 {
<a name="l01326"></a>01326   <span class="keywordtype">int</span> ierr = 0;
<a name="l01327"></a>01327   <span class="keywordtype">int</span> its  = 0;
<a name="l01328"></a>01328 
<a name="l01329"></a>01329   <span class="comment">// Fill the residual history vector with the residual norms</span>
<a name="l01330"></a>01330   <span class="comment">// Note that GetResidualHistory() does not copy any values, it</span>
<a name="l01331"></a>01331   <span class="comment">// simply sets the pointer p.  Note that for some Krylov subspace</span>
<a name="l01332"></a>01332   <span class="comment">// methods, the number of residuals returned in the history</span>
<a name="l01333"></a>01333   <span class="comment">// vector may be different from what you are expecting.  For</span>
<a name="l01334"></a>01334   <span class="comment">// example, TFQMR returns two residual values per iteration step.</span>
<a name="l01335"></a>01335   PetscReal* p;
<a name="l01336"></a>01336   ierr = KSPGetResidualHistory(_ksp, &amp;p, &amp;its);
<a name="l01337"></a>01337   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01338"></a>01338 
<a name="l01339"></a>01339   <span class="comment">// Check for early return</span>
<a name="l01340"></a>01340   <span class="keywordflow">if</span> (its == 0) <span class="keywordflow">return</span>;
<a name="l01341"></a>01341   
<a name="l01342"></a>01342   <span class="comment">// Create space to store the result</span>
<a name="l01343"></a>01343   hist.resize(its);
<a name="l01344"></a>01344 
<a name="l01345"></a>01345   <span class="comment">// Copy history into the vector provided by the user.</span>
<a name="l01346"></a>01346   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;its; ++i)
<a name="l01347"></a>01347     {
<a name="l01348"></a>01348       hist[i] = *p;
<a name="l01349"></a>01349       p++;
<a name="l01350"></a>01350     }
<a name="l01351"></a>01351 }
<a name="l01352"></a>01352 
<a name="l01353"></a>01353 
<a name="l01354"></a>01354 
<a name="l01355"></a>01355 
<a name="l01356"></a>01356 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01357"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a37641e5e49a89c36098322f1e5b1f0d8">01357</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a37641e5e49a89c36098322f1e5b1f0d8">PetscLinearSolver&lt;T&gt;::get_initial_residual</a>()
<a name="l01358"></a>01358 {
<a name="l01359"></a>01359   <span class="keywordtype">int</span> ierr = 0;
<a name="l01360"></a>01360   <span class="keywordtype">int</span> its  = 0;
<a name="l01361"></a>01361 
<a name="l01362"></a>01362   <span class="comment">// Fill the residual history vector with the residual norms</span>
<a name="l01363"></a>01363   <span class="comment">// Note that GetResidualHistory() does not copy any values, it</span>
<a name="l01364"></a>01364   <span class="comment">// simply sets the pointer p.  Note that for some Krylov subspace</span>
<a name="l01365"></a>01365   <span class="comment">// methods, the number of residuals returned in the history</span>
<a name="l01366"></a>01366   <span class="comment">// vector may be different from what you are expecting.  For</span>
<a name="l01367"></a>01367   <span class="comment">// example, TFQMR returns two residual values per iteration step.</span>
<a name="l01368"></a>01368   PetscReal* p;
<a name="l01369"></a>01369   ierr = KSPGetResidualHistory(_ksp, &amp;p, &amp;its);
<a name="l01370"></a>01370   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01371"></a>01371 
<a name="l01372"></a>01372   <span class="comment">// Check no residual history</span>
<a name="l01373"></a>01373   <span class="keywordflow">if</span> (its == 0)
<a name="l01374"></a>01374     {
<a name="l01375"></a>01375       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No iterations have been performed, returning 0.&quot;</span> &lt;&lt; std::endl;
<a name="l01376"></a>01376       <span class="keywordflow">return</span> 0.;
<a name="l01377"></a>01377     }
<a name="l01378"></a>01378 
<a name="l01379"></a>01379   <span class="comment">// Otherwise, return the value pointed to by p.</span>
<a name="l01380"></a>01380   <span class="keywordflow">return</span> *p;
<a name="l01381"></a>01381 }
<a name="l01382"></a>01382 
<a name="l01383"></a>01383 
<a name="l01384"></a>01384 
<a name="l01385"></a>01385 
<a name="l01386"></a>01386 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01387"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7ba2130af69add0da3a7526c79095090">01387</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7ba2130af69add0da3a7526c79095090">PetscLinearSolver&lt;T&gt;::set_petsc_solver_type</a>()
<a name="l01388"></a>01388 {
<a name="l01389"></a>01389   <span class="keywordtype">int</span> ierr = 0;
<a name="l01390"></a>01390   
<a name="l01391"></a>01391   <span class="keywordflow">switch</span> (this-&gt;_solver_type)
<a name="l01392"></a>01392     {
<a name="l01393"></a>01393 
<a name="l01394"></a>01394     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19af0969a6b5512fce0e1ef22d7487e23d7">CG</a>:
<a name="l01395"></a>01395       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCG);         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01396"></a>01396 
<a name="l01397"></a>01397     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a201f83b26b927cf91cf1cbd3c6bc0ee2">CR</a>:
<a name="l01398"></a>01398       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCR);         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01399"></a>01399 
<a name="l01400"></a>01400     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19afff9553e13457ad7f271af09bc52f438">CGS</a>:
<a name="l01401"></a>01401       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCGS);        CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01402"></a>01402 
<a name="l01403"></a>01403     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a0dcffd9411a6eaa02f83ce1be41bcde2">BICG</a>:
<a name="l01404"></a>01404       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPBICG);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01405"></a>01405 
<a name="l01406"></a>01406     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a66f876695d8cb986b11fd03a6011da5c">TCQMR</a>:
<a name="l01407"></a>01407       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPTCQMR);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01408"></a>01408  
<a name="l01409"></a>01409     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a64344ae8d8320983e6f24873b0f59506">TFQMR</a>:
<a name="l01410"></a>01410       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPTFQMR);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01411"></a>01411 
<a name="l01412"></a>01412     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a4402b8ddf01d5b9a43a60c21b95738f6">LSQR</a>:
<a name="l01413"></a>01413       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPLSQR);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01414"></a>01414 
<a name="l01415"></a>01415     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ae5a5e49337074324233c300b1daf83ec">BICGSTAB</a>:
<a name="l01416"></a>01416       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPBCGS);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01417"></a>01417 
<a name="l01418"></a>01418     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a1c732aa5750b891b366f966a0ad1b33a">MINRES</a>:
<a name="l01419"></a>01419       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPMINRES);     CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01420"></a>01420 
<a name="l01421"></a>01421     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>:
<a name="l01422"></a>01422       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPGMRES);      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01423"></a>01423 
<a name="l01424"></a>01424     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ac89e84330ee207620b12f16ed98cb31c">RICHARDSON</a>:
<a name="l01425"></a>01425       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPRICHARDSON); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01426"></a>01426 
<a name="l01427"></a>01427     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a7c268c55b3f99132648b5c7245896764">CHEBYSHEV</a>: 
<a name="l01428"></a>01428       ierr = KSPSetType (_ksp, (<span class="keywordtype">char</span>*) KSPCHEBYCHEV);  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); <span class="keywordflow">return</span>;
<a name="l01429"></a>01429 
<a name="l01430"></a>01430     <span class="keywordflow">default</span>:
<a name="l01431"></a>01431       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported PETSC Solver: &quot;</span>
<a name="l01432"></a>01432                     &lt;&lt; this-&gt;_solver_type               &lt;&lt; std::endl
<a name="l01433"></a>01433                     &lt;&lt; <span class="stringliteral">&quot;Continuing with PETSC defaults&quot;</span> &lt;&lt; std::endl;
<a name="l01434"></a>01434     }
<a name="l01435"></a>01435 }
<a name="l01436"></a>01436 
<a name="l01437"></a>01437 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01438"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ae6d4b32b1157d3ac64bc48a1f0e63720">01438</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ae6d4b32b1157d3ac64bc48a1f0e63720">PetscLinearSolver&lt;T&gt;::print_converged_reason</a>()
<a name="l01439"></a>01439 {
<a name="l01440"></a>01440   KSPConvergedReason reason;
<a name="l01441"></a>01441   KSPGetConvergedReason(_ksp, &amp;reason);
<a name="l01442"></a>01442   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solver convergence/divergence reason: &quot;</span> &lt;&lt; KSPConvergedReasons[reason] &lt;&lt; std::endl;
<a name="l01443"></a>01443 }
<a name="l01444"></a>01444 
<a name="l01445"></a>01445 
<a name="l01446"></a>01446 
<a name="l01447"></a>01447 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01448"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a74fc6258796b7724355d07fac71e335b">01448</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a74fc6258796b7724355d07fac71e335b">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest)
<a name="l01449"></a>01449 {
<a name="l01450"></a>01450   <span class="comment">/* Get the matrix context.  */</span>
<a name="l01451"></a>01451   <span class="keywordtype">int</span> ierr=0;
<a name="l01452"></a>01452   <span class="keywordtype">void</span>* ctx;
<a name="l01453"></a>01453   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l01454"></a>01454   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01455"></a>01455 
<a name="l01456"></a>01456   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l01457"></a>01457   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l01458"></a>01458 
<a name="l01459"></a>01459   <span class="comment">/* Make \p NumericVector instances around the vectors.  */</span>
<a name="l01460"></a>01460   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> arg_global(arg);
<a name="l01461"></a>01461   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l01462"></a>01462 
<a name="l01463"></a>01463   <span class="comment">/* Call the user function.  */</span>
<a name="l01464"></a>01464   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a090ec49ccc34e8d103eba352b66cdf31">vector_mult</a>(dest_global,arg_global);
<a name="l01465"></a>01465 
<a name="l01466"></a>01466   <span class="keywordflow">return</span> ierr;
<a name="l01467"></a>01467 }
<a name="l01468"></a>01468 
<a name="l01469"></a>01469 
<a name="l01470"></a>01470 
<a name="l01471"></a>01471 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01472"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aca0fc5357cfc5608df9c2ed47ae2c471">01472</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aca0fc5357cfc5608df9c2ed47ae2c471">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_mult_add</a>(Mat mat, Vec arg, Vec add, Vec dest)
<a name="l01473"></a>01473 {
<a name="l01474"></a>01474   <span class="comment">/* Get the matrix context.  */</span>
<a name="l01475"></a>01475   <span class="keywordtype">int</span> ierr=0;
<a name="l01476"></a>01476   <span class="keywordtype">void</span>* ctx;
<a name="l01477"></a>01477   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l01478"></a>01478   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01479"></a>01479 
<a name="l01480"></a>01480   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l01481"></a>01481   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l01482"></a>01482 
<a name="l01483"></a>01483   <span class="comment">/* Make \p NumericVector instances around the vectors.  */</span>
<a name="l01484"></a>01484   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> arg_global(arg);
<a name="l01485"></a>01485   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l01486"></a>01486   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> add_global(add);
<a name="l01487"></a>01487 
<a name="l01488"></a>01488   <span class="keywordflow">if</span>(add!=arg)
<a name="l01489"></a>01489     {
<a name="l01490"></a>01490       arg_global = add_global;
<a name="l01491"></a>01491     }
<a name="l01492"></a>01492 
<a name="l01493"></a>01493   <span class="comment">/* Call the user function.  */</span>
<a name="l01494"></a>01494   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a754071de77d848c5481a42fd41fc5157">vector_mult_add</a>(dest_global,arg_global);
<a name="l01495"></a>01495 
<a name="l01496"></a>01496   <span class="keywordflow">return</span> ierr;
<a name="l01497"></a>01497 }
<a name="l01498"></a>01498 
<a name="l01499"></a>01499 
<a name="l01500"></a>01500 
<a name="l01501"></a>01501 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01502"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8568708754d996fda7f23f507577b4e9">01502</a> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8568708754d996fda7f23f507577b4e9">PetscLinearSolver&lt;T&gt;::_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest)
<a name="l01503"></a>01503 {
<a name="l01504"></a>01504   <span class="comment">/* Get the matrix context.  */</span>
<a name="l01505"></a>01505   <span class="keywordtype">int</span> ierr=0;
<a name="l01506"></a>01506   <span class="keywordtype">void</span>* ctx;
<a name="l01507"></a>01507   ierr = MatShellGetContext(mat,&amp;ctx);
<a name="l01508"></a>01508   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01509"></a>01509 
<a name="l01510"></a>01510   <span class="comment">/* Get user shell matrix object.  */</span>
<a name="l01511"></a>01511   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix = *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span><a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(ctx);
<a name="l01512"></a>01512 
<a name="l01513"></a>01513   <span class="comment">/* Make \p NumericVector instances around the vector.  */</span>
<a name="l01514"></a>01514   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> dest_global(dest);
<a name="l01515"></a>01515 
<a name="l01516"></a>01516   <span class="comment">/* Call the user function.  */</span>
<a name="l01517"></a>01517   shell_matrix.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a1516571b30e8da439c498ce0e4ac788c">get_diagonal</a>(dest_global);
<a name="l01518"></a>01518 
<a name="l01519"></a>01519   <span class="keywordflow">return</span> ierr;
<a name="l01520"></a>01520 }
<a name="l01521"></a>01521 
<a name="l01522"></a>01522 
<a name="l01523"></a>01523 
<a name="l01524"></a>01524 <span class="comment">//------------------------------------------------------------------</span>
<a name="l01525"></a>01525 <span class="comment">// Explicit instantiations</span>
<a name="l01526"></a>01526 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscLinearSolver.php">PetscLinearSolver&lt;Number&gt;</a>;
<a name="l01527"></a>01527 
<a name="l01528"></a>01528 } <span class="comment">// namespace libMesh</span>
<a name="l01529"></a>01529  
<a name="l01530"></a>01530 
<a name="l01531"></a>01531 
<a name="l01532"></a>01532 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
