<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_jacobi_1D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__jacobi__1D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_jacobi_1D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__jacobi_8h.php">quadrature_jacobi.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027  
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1QJacobi.php#a4e61796f18bc198922e439ecab8ace4e">00030</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QJacobi.php#a4e61796f18bc198922e439ecab8ace4e">QJacobi::init_1D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00031"></a>00031                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00034"></a>00034   <span class="comment">// 1D quadrature rules</span>
<a name="l00035"></a>00035   <span class="comment">// Note that we need to check _alpha and _beta</span>
<a name="l00036"></a>00036   <span class="comment">// to determine which quadrature rule to implement.</span>
<a name="l00037"></a>00037   <span class="comment">// These rules have been pre-scaled based on their</span>
<a name="l00038"></a>00038   <span class="comment">// intended use.  The weights of the (alpha=1,beta=0)</span>
<a name="l00039"></a>00039   <span class="comment">// rule sum to 0.5.  The weights of the (alpha=2,beta=0)</span>
<a name="l00040"></a>00040   <span class="comment">// rule sum to 0.333333333333.</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1QJacobi.php#a432af4bebde14ac394e948ca585cadcd">_alpha</a> == 1) &amp;&amp; (<a class="code" href="classlibMesh_1_1QJacobi.php#a812ed1eb1a7681cf7cc7dad1223ed668">_beta</a> == 0))
<a name="l00043"></a>00043     {
<a name="l00044"></a>00044       <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00045"></a>00045         {
<a name="l00046"></a>00046         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00047"></a>00047         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00048"></a>00048           {
<a name="l00049"></a>00049             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (1);
<a name="l00050"></a>00050             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(1);
<a name="l00051"></a>00051         
<a name="l00052"></a>00052             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0)  = 1./3.;
<a name="l00053"></a>00053         
<a name="l00054"></a>00054             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0]    = 0.5;
<a name="l00055"></a>00055         
<a name="l00056"></a>00056             <span class="keywordflow">return</span>;
<a name="l00057"></a>00057           }
<a name="l00058"></a>00058         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00059"></a>00059         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00060"></a>00060           {
<a name="l00061"></a>00061             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (2);
<a name="l00062"></a>00062             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(2);
<a name="l00063"></a>00063               
<a name="l00064"></a>00064             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.5505102572168219018027159252941e-01L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=3.1804138174397716939436900207516e-01L;
<a name="l00065"></a>00065             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=6.4494897427831780981972840747059e-01L;      _weights[ 1]=1.8195861825602283060563099792484e-01L;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067             <span class="keywordflow">return</span>;
<a name="l00068"></a>00068           }
<a name="l00069"></a>00069         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00070"></a>00070         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00071"></a>00071           {
<a name="l00072"></a>00072             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (3);
<a name="l00073"></a>00073             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(3);
<a name="l00074"></a>00074               
<a name="l00075"></a>00075             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=8.8587959512703947395546143769456e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.0093191373895963077219813326460e-01L;
<a name="l00076"></a>00076             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=4.0946686444073471086492625206883e-01L;      _weights[ 1]=2.2924110635958624669392059455632e-01L;
<a name="l00077"></a>00077             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=7.8765946176084705602524188987600e-01L;      _weights[ 2]=6.9826979901454122533881272179077e-02L;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079             <span class="keywordflow">return</span>;
<a name="l00080"></a>00080           }
<a name="l00081"></a>00081         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00082"></a>00082         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00083"></a>00083           {
<a name="l00084"></a>00084             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (4);
<a name="l00085"></a>00085             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(4);
<a name="l00086"></a>00086               
<a name="l00087"></a>00087             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=5.7104196114517682193121192554116e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.3550691343148811620826417407794e-01L;
<a name="l00088"></a>00088             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.7684301363812382768004599768563e-01L;      _weights[ 1]=2.0346456801027136079140447593585e-01L;
<a name="l00089"></a>00089             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=5.8359043236891682005669766866292e-01L;      _weights[ 2]=1.2984754760823244082645620288963e-01L;
<a name="l00090"></a>00090             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=8.6024013565621944784791291887512e-01L;      _weights[ 3]=3.1180970950008082173875147096575e-02L;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092             <span class="keywordflow">return</span>;
<a name="l00093"></a>00093           }
<a name="l00094"></a>00094         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00095"></a>00095         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00096"></a>00096           {
<a name="l00097"></a>00097             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (5);
<a name="l00098"></a>00098             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(5);
<a name="l00099"></a>00099               
<a name="l00100"></a>00100             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.9809857051468742340806690093333e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=9.6781590226651679274360971636151e-02L;
<a name="l00101"></a>00101             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.9801341787360817253579213679530e-01L;      _weights[ 1]=1.6717463809436956549167562309770e-01L;
<a name="l00102"></a>00102             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=4.3797481024738614400501252000523e-01L;      _weights[ 2]=1.4638698708466980869803786935596e-01L;
<a name="l00103"></a>00103             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=6.9546427335363609451461482372117e-01L;      _weights[ 3]=7.3908870072616670350633219341704e-02L;
<a name="l00104"></a>00104             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=9.0146491420117357387650110211225e-01L;      _weights[ 4]=1.5747914521692276185292316568488e-02L;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106             <span class="keywordflow">return</span>;
<a name="l00107"></a>00107           }
<a name="l00108"></a>00108         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00109"></a>00109         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00110"></a>00110           {
<a name="l00111"></a>00111         
<a name="l00112"></a>00112             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (6);
<a name="l00113"></a>00113             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(6);
<a name="l00114"></a>00114               
<a name="l00115"></a>00115             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.9316427159784891972050276913165e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=7.2310330725508683655454326124832e-02L;
<a name="l00116"></a>00116             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.4807859966848429184997685249598e-01L;      _weights[ 1]=1.3554249723151861684069039663805e-01L;
<a name="l00117"></a>00117             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.3698469028115429909705297208078e-01L;      _weights[ 2]=1.4079255378819892811907683907093e-01L;
<a name="l00118"></a>00118             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=5.5867151877155013208139334180552e-01L;      _weights[ 3]=9.8661150890655264120584510548360e-02L;
<a name="l00119"></a>00119             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=7.6923386203005450091688336011565e-01L;      _weights[ 4]=4.3955165550508975508176624305430e-02L;
<a name="l00120"></a>00120             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=9.2694567131974111485187396581968e-01L;      _weights[ 5]=8.7383018136095317560173033123989e-03L;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122             <span class="keywordflow">return</span>;
<a name="l00123"></a>00123           }
<a name="l00124"></a>00124         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00125"></a>00125         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00126"></a>00126           {
<a name="l00127"></a>00127             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (7);
<a name="l00128"></a>00128             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(7);
<a name="l00129"></a>00129               
<a name="l00130"></a>00130             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.2479386438712498108825499570845e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=5.5967363423491051151562113429926e-02L;
<a name="l00131"></a>00131             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.1467905316090423190964023706751e-01L;      _weights[ 1]=1.1050925819087460242112073636961e-01L;
<a name="l00132"></a>00132             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=2.6578982278458946847678939169339e-01L;      _weights[ 2]=1.2739089729958832691873448577496e-01L;
<a name="l00133"></a>00133             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=4.5284637366944461699855144234765e-01L;      _weights[ 3]=1.0712506569587366999091225299986e-01L;
<a name="l00134"></a>00134             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=6.4737528288683036262609222982876e-01L;      _weights[ 4]=6.6384696465491469983647988763640e-02L;
<a name="l00135"></a>00135             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=8.1975930826310763501242005719082e-01L;      _weights[ 5]=2.7408356721873475444331048358226e-02L;
<a name="l00136"></a>00136             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=9.4373743946307785353434780896769e-01L;      _weights[ 6]=5.2143622028074040896913743037830e-03L;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138             <span class="keywordflow">return</span>;
<a name="l00139"></a>00139           }
<a name="l00140"></a>00140         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00141"></a>00141         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7120ce4c6dcb4b9465b15e7531631fe6">FIFTEENTH</a>:
<a name="l00142"></a>00142           {
<a name="l00143"></a>00143             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (8);
<a name="l00144"></a>00144             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(8);
<a name="l00145"></a>00145               
<a name="l00146"></a>00146             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.7779915147363451813205101037679e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=4.4550804361555931326215619533963e-02L;
<a name="l00147"></a>00147             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=9.1323607899793956003741458074541e-02L;      _weights[ 1]=9.1119023636373626345722461782880e-02L;
<a name="l00148"></a>00148             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=2.1430847939563075835754126758167e-01L;      _weights[ 2]=1.1250579947088736617177209860428e-01L;
<a name="l00149"></a>00149             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=3.7193216458327230243085396048263e-01L;      _weights[ 3]=1.0604735943593001070453109641116e-01L;
<a name="l00150"></a>00150             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=5.4518668480342664903227222995321e-01L;      _weights[ 4]=7.9199599492319160120408189359892e-02L;
<a name="l00151"></a>00151             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=7.1317524285556948105131376025091e-01L;      _weights[ 5]=4.5439319504698898083055421095694e-02L;
<a name="l00152"></a>00152             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=8.5563374295785442851478147977179e-01L;      _weights[ 6]=1.7842902655986208393552797201042e-02L;
<a name="l00153"></a>00153             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=9.5536604471003014926687897814169e-01L;      _weights[ 7]=3.2951914422487988547423160110891e-03L;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155             <span class="keywordflow">return</span>;
<a name="l00156"></a>00156           }
<a name="l00157"></a>00157         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad3a83c160ba19d280cf82ab0fee65f2d">SIXTEENTH</a>:
<a name="l00158"></a>00158         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fae4eeb80a784baaf763cdccf0a47a4557">SEVENTEENTH</a>:
<a name="l00159"></a>00159           {
<a name="l00160"></a>00160             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (9);
<a name="l00161"></a>00161             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(9);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.4412409648876548632826740810813e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=3.6278003523279871459649597941160e-02L;
<a name="l00164"></a>00164             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=7.4387389709196044635918185955999e-02L;      _weights[ 1]=7.6074255109308162580079303753964e-02L;
<a name="l00165"></a>00165             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.7611665616299528186317574607257e-01L;      _weights[ 2]=9.8533742172345705160173020369274e-02L;
<a name="l00166"></a>00166             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=3.0966757992763781705962046722948e-01L;      _weights[ 3]=1.0030880919336828965415022473259e-01L;
<a name="l00167"></a>00167             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=4.6197040108101093488314310868056e-01L;      _weights[ 4]=8.4358321844920349394250019958587e-02L;
<a name="l00168"></a>00168             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=6.1811723469529402463922975160350e-01L;      _weights[ 5]=5.8401195295165110565731522901640e-02L;
<a name="l00169"></a>00169             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=7.6282301518503961468269330714673e-01L;      _weights[ 6]=3.1804821491054001261690106935870e-02L;
<a name="l00170"></a>00170             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=8.8192102121000129980771488800526e-01L;      _weights[ 7]=1.2060004284785379051727152286900e-02L;
<a name="l00171"></a>00171             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=9.6374218711679053905883569923192e-01L;      _weights[ 8]=2.1808470857731308725490511200170e-03L;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173             <span class="keywordflow">return</span>;
<a name="l00174"></a>00174           }
<a name="l00175"></a>00175         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa04abe26889214024e6b01556757afebc">EIGHTTEENTH</a>:
<a name="l00176"></a>00176         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa460d128a5ae3f0cab006386047945a63">NINTEENTH</a>:
<a name="l00177"></a>00177           {
<a name="l00178"></a>00178             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (10);
<a name="l00179"></a>00179             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(10);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.1917613432415596909745586958986e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=3.0099508024037023300654755523879e-02L;
<a name="l00182"></a>00182             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=6.1732071877148125522629367194250e-02L;      _weights[ 1]=6.4287154509082572874826538628865e-02L;
<a name="l00183"></a>00183             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.4711144964307024042759943557982e-01L;      _weights[ 2]=8.6211300289176036428333360711914e-02L;
<a name="l00184"></a>00184             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=2.6115967600845624026605165805485e-01L;      _weights[ 3]=9.2696893677723415844756991929711e-02L;
<a name="l00185"></a>00185             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=3.9463984688578684296195210507761e-01L;      _weights[ 4]=8.4557109690827332430645582165501e-02L;
<a name="l00186"></a>00186             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=5.3673876571566063287309517771189e-01L;      _weights[ 5]=6.6053075563350379166074502504878e-02L;
<a name="l00187"></a>00187             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=6.7594446167666510735715050893476e-01L;      _weights[ 6]=4.3401906407150625922456117586384e-02L;
<a name="l00188"></a>00188             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=8.0097892103689884513794630161724e-01L;      _weights[ 7]=2.2774591453263032586487649426060e-02L;
<a name="l00189"></a>00189             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=9.0171098779014677034879897840977e-01L;      _weights[ 8]=8.4193197829831874175163655187011e-03L;
<a name="l00190"></a>00190             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=9.6997096783851350295693564236559e-01L;      _weights[ 9]=1.4991406024063940282481360041064e-03L;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192             <span class="keywordflow">return</span>;
<a name="l00193"></a>00193           }      
<a name="l00194"></a>00194         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1fd67e9ea1cf7030e0e5b9c6e82698a2">TWENTIETH</a>:
<a name="l00195"></a>00195         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6e1551e839c8196b348cd883be5a4bd8">TWENTYFIRST</a>:
<a name="l00196"></a>00196           {
<a name="l00197"></a>00197             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (11);
<a name="l00198"></a>00198             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(11);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.0018280461680405843024729867805e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.5367340688141426184944658517383e-02L;
<a name="l00201"></a>00201             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=5.2035451127180552583542695772964e-02L;      _weights[ 1]=5.4938091132871498258746681665651e-02L;
<a name="l00202"></a>00202             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.2461922514444307373529958726391e-01L;      _weights[ 2]=7.5620048057186998321377054841660e-02L;
<a name="l00203"></a>00203             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=2.2284060704383785550783145345736e-01L;      _weights[ 3]=8.4659422884017621219239388551910e-02L;
<a name="l00204"></a>00204             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=3.4000815791466518823360523389702e-01L;      _weights[ 4]=8.1879102988063470389586851943461e-02L;
<a name="l00205"></a>00205             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=4.6813761308958404208311038075775e-01L;      _weights[ 5]=6.9531875158183049799050889633934e-02L;
<a name="l00206"></a>00206             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=5.9849727976713918322772071367304e-01L;      _weights[ 6]=5.1591360672297580193086641744608e-02L;
<a name="l00207"></a>00207             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=7.2220328489096792556332130780461e-01L;      _weights[ 7]=3.2641546713833346017953865389764e-02L;
<a name="l00208"></a>00208             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=8.3082489962281857403056654390566e-01L;      _weights[ 8]=1.6663623451680692415747124573826e-02L;
<a name="l00209"></a>00209             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=9.1695838655259485329313462701803e-01L;      _weights[ 9]=6.0439209604797757927329621765769e-03L;
<a name="l00210"></a>00210             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=9.7472637960247965024666881353837e-01L;      _weights[10]=1.0636672932445414075338809612253e-03L;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212             <span class="keywordflow">return</span>;
<a name="l00213"></a>00213           }
<a name="l00214"></a>00214         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac53c44bf97483f77b3b8f12689d1025f">TWENTYSECOND</a>:
<a name="l00215"></a>00215         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>:
<a name="l00216"></a>00216           {
<a name="l00217"></a>00217             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (12);
<a name="l00218"></a>00218             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(12);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=8.5390549884274193686644608778398e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.1664860886871767324583472077976e-02L;
<a name="l00221"></a>00221             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=4.4446463155407723025466798785553e-02L;      _weights[ 1]=4.7427851980377470134309182197087e-02L;
<a name="l00222"></a>00222             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.0685449088347665763410677043250e-01L;      _weights[ 2]=6.6606750626673198130834485351975e-02L;
<a name="l00223"></a>00223             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.9215105452985404099105725622861e-01L;      _weights[ 3]=7.6896602680041006281204469112373e-02L;
<a name="l00224"></a>00224             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.9538088426258022162291683437601e-01L;      _weights[ 4]=7.7696316815531026628765631099760e-02L;
<a name="l00225"></a>00225             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=4.1054508120145768248903435055933e-01L;      _weights[ 5]=7.0109339997630094495921805029671e-02L;
<a name="l00226"></a>00226             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=5.3095084931281767062893024289682e-01L;      _weights[ 6]=5.6613843713667631943701105156121e-02L;
<a name="l00227"></a>00227             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=6.4960065027725499276629172334298e-01L;      _weights[ 7]=4.0451653706913616760646424250646e-02L;
<a name="l00228"></a>00228             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=7.5959888952522705374260257404342e-01L;      _weights[ 8]=2.4876780409265432012508172290016e-02L;
<a name="l00229"></a>00229             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=8.5455254376493588079021191640562e-01L;      _weights[ 9]=1.2436009166422265607483293056674e-02L;
<a name="l00230"></a>00230             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=9.2894210126441101784881015513432e-01L;      _weights[10]=4.4448077956684623227961458658283e-03L;
<a name="l00231"></a>00231             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=9.7843793683414963909190691691700e-01L;      _weights[11]=7.7518222093802835724581451187414e-04L;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233             <span class="keywordflow">return</span>;
<a name="l00234"></a>00234           }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa8093001568608e51bbe10f03c871fc41">TWENTYFOURTH</a>:
<a name="l00237"></a>00237         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad2f79bea88fd463e33a7800d828bded9">TWENTYFIFTH</a>:
<a name="l00238"></a>00238           {
<a name="l00239"></a>00239             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (13);
<a name="l00240"></a>00240             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(13);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=7.3646510260893216506914984138223e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.8714731585615175193374408664994e-02L;
<a name="l00243"></a>00243             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=3.8398138739678350376832524864142e-02L;      _weights[ 1]=4.1320289419839298476611706952624e-02L;
<a name="l00244"></a>00244             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=9.2595224699002635282891375438616e-02L;      _weights[ 2]=5.8953937956647082536161503261961e-02L;
<a name="l00245"></a>00245             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.6725101139155773149552247875936e-01L;      _weights[ 3]=6.9713468282144398251416629950427e-02L;
<a name="l00246"></a>00246             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.5862354070576251658979073282269e-01L;      _weights[ 4]=7.2849696515818223079384033843973e-02L;
<a name="l00247"></a>00247             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=3.6213139728223880040868129822732e-01L;      _weights[ 5]=6.8815529487565417217837889436694e-02L;
<a name="l00248"></a>00248             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=4.7258438600411772517509464267860e-01L;      _weights[ 6]=5.9120481314092327419290155953032e-02L;
<a name="l00249"></a>00249             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=5.8444396402134045550422084781091e-01L;      _weights[ 7]=4.5995780676052393313259784530213e-02L;
<a name="l00250"></a>00250             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=6.9210100171960165689704195168767e-01L;      _weights[ 8]=3.1936787162203148842381371158461e-02L;
<a name="l00251"></a>00251             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=7.9015702827343748555286333249938e-01L;      _weights[ 9]=1.9213957164719820645895497863743e-02L;
<a name="l00252"></a>00252             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=8.7369482130668941936771456713174e-01L;      _weights[10]=9.4489244795927503661800865492413e-03L;
<a name="l00253"></a>00253             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=9.3852445910073101239763338676530e-01L;      _weights[11]=3.3383592507737718066104206420419e-03L;
<a name="l00254"></a>00254             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=9.8138963498901214856028062215971e-01L;      _weights[12]=5.7805670493619285159651119259460e-04L;
<a name="l00255"></a>00255             
<a name="l00256"></a>00256             <span class="keywordflow">return</span>;
<a name="l00257"></a>00257           }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5f33eeba0f7239d41b54654ce8d99aa3">TWENTYSIXTH</a>:
<a name="l00260"></a>00260         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0facb1defec8f9bfcd21f5ef0f62fcacd2f">TWENTYSEVENTH</a>:
<a name="l00261"></a>00261           {
<a name="l00262"></a>00262             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (14);
<a name="l00263"></a>00263             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(14);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=6.4167607928184568108204640945072e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.6326754322596839819449429350767e-02L;
<a name="l00266"></a>00266             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=3.3501404532013140035963928570572e-02L;      _weights[ 1]=3.6296078055443693187652118821852e-02L;
<a name="l00267"></a>00267             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=8.0985499681955184392451307739982e-02L;      _weights[ 2]=5.2445953501916745591081806162678e-02L;
<a name="l00268"></a>00268             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.4680486768121372992366016526080e-01L;      _weights[ 3]=6.3213025574329203442529115357932e-02L;
<a name="l00269"></a>00269             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.2808427064925799153464409861994e-01L;      _weights[ 4]=6.7831659604182837102347339834146e-02L;
<a name="l00270"></a>00270             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=3.2127174398893617440234039741304e-01L;      _weights[ 5]=6.6392350626085425132821358651277e-02L;
<a name="l00271"></a>00271             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=4.2229465730757025784040898751810e-01L;      _weights[ 6]=5.9785559022531584222614059168587e-02L;
<a name="l00272"></a>00272             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=5.2673786133987303205372694481288e-01L;      _weights[ 7]=4.9519454523203004580936179335753e-02L;
<a name="l00273"></a>00273             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=6.3003668837040395788448059413143e-01L;      _weights[ 8]=3.7443096458985826655938301826886e-02L;
<a name="l00274"></a>00274             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=7.2767645288926468543602672799033e-01L;      _weights[ 9]=2.5423465407148762115069898757459e-02L;
<a name="l00275"></a>00275             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=8.1538973944347464197307421861206e-01L;      _weights[10]=1.5032303743928643503408714751315e-02L;
<a name="l00276"></a>00276             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=8.8934280881951553969087166094649e-01L;      _weights[11]=7.2964841332126214434099222674776e-03L;
<a name="l00277"></a>00277             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=9.4630270006027538353340594342472e-01L;      _weights[12]=2.5541013176876539479794996099427e-03L;
<a name="l00278"></a>00278             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=9.8377523409860023828122800914100e-01L;      _weights[13]=4.3971370874715925476225610392609e-04L;
<a name="l00279"></a>00279 
<a name="l00280"></a>00280             <span class="keywordflow">return</span>;
<a name="l00281"></a>00281           }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0e295eb2dfc5e7e8c49b433ae27b1369">TWENTYEIGHTH</a>:
<a name="l00284"></a>00284         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2e33cfffe6c21901c488cc5c58d5bae9">TWENTYNINTH</a>:
<a name="l00285"></a>00285           {
<a name="l00286"></a>00286             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (15);
<a name="l00287"></a>00287             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(15);
<a name="l00288"></a>00288             
<a name="l00289"></a>00289             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=5.6406889725117097575064665794442e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.4367069621712523019113300206269e-02L;
<a name="l00290"></a>00290             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.9482298647942486631640984718004e-02L;      _weights[ 1]=3.2119044874965915878547666076448e-02L;
<a name="l00291"></a>00291             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=7.1412953115158840054783901746735e-02L;      _weights[ 2]=4.6891639944059925679345570546797e-02L;
<a name="l00292"></a>00292             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.2983102555359105597125453809429e-01L;      _weights[ 3]=5.7398825506941289374618916116414e-02L;
<a name="l00293"></a>00293             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.0249275505010404756821998832023e-01L;      _weights[ 4]=6.2918106648596909592665349230551e-02L;
<a name="l00294"></a>00294             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.8660608625752705998402604548440e-01L;      _weights[ 5]=6.3343955161511392519350738069297e-02L;
<a name="l00295"></a>00295             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=3.7893868864697803810652900914277e-01L;      _weights[ 6]=5.9174192059712931565021168664588e-02L;
<a name="l00296"></a>00296             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=4.7594230846323486057258899201585e-01L;      _weights[ 7]=5.1412362311886468530400169371359e-02L;
<a name="l00297"></a>00297             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=5.7388916090668588067145385523753e-01L;      _weights[ 8]=4.1400735184422578228813150524935e-02L;
<a name="l00298"></a>00298             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=6.6901519502995987653869563905314e-01L;      _weights[ 9]=3.0609769586468540804291808789747e-02L;
<a name="l00299"></a>00299             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=7.5766473903134271199707427774029e-01L;      _weights[10]=2.0416309272619835691190995270654e-02L;
<a name="l00300"></a>00300             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=8.3643096060561012397555908565418e-01L;      _weights[11]=1.1904190355097578843030186960250e-02L;
<a name="l00301"></a>00301             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=9.0228670067937802663123850466201e-01L;      _weights[12]=5.7172223947211761716246502974268e-03L;
<a name="l00302"></a>00302             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=9.5270040990583331433804420752426e-01L;      _weights[13]=1.9862346931450380410338051145760e-03L;
<a name="l00303"></a>00303             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=9.8573054526317422526590063305913e-01L;      _weights[14]=3.4034238413789606095252476068833e-04L;
<a name="l00304"></a>00304 
<a name="l00305"></a>00305             <span class="keywordflow">return</span>;
<a name="l00306"></a>00306           }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac64b552bcc7fd10e6a8723de2e2a1250">THIRTIETH</a>:
<a name="l00310"></a>00310         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6812a2218979fea1f20f3cdf06d855a9">THIRTYFIRST</a>:
<a name="l00311"></a>00311           {
<a name="l00312"></a>00312             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (16);
<a name="l00313"></a>00313             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(16);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=4.9972996637719210426511496015207e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.2739310657334184747549845879578e-02L;
<a name="l00316"></a>00316             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.6143513681394051978549323380543e-02L;      _weights[ 1]=2.8612452590143149357558068987418e-02L;
<a name="l00317"></a>00317             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=6.3430945583836745492528222770701e-02L;      _weights[ 2]=4.2129431157428284757515740541878e-02L;
<a name="l00318"></a>00318             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.1559843757981594017892362824740e-01L;      _weights[ 3]=5.2228594403959147363509678893029e-02L;
<a name="l00319"></a>00319             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.8087055965788366624757339125570e-01L;      _weights[ 4]=5.8254240209855835379301779422393e-02L;
<a name="l00320"></a>00320             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.5702480784517085992294423955927e-01L;      _weights[ 5]=6.0000854888113507055385942002166e-02L;
<a name="l00321"></a>00321             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=3.4146792754782306862589929793869e-01L;      _weights[ 6]=5.7718879609267823617681995467969e-02L;
<a name="l00322"></a>00322             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=4.3132434359562537508359226958274e-01L;      _weights[ 7]=5.2064137843806583754973352189273e-02L;
<a name="l00323"></a>00323             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=5.2353411602516832051747016507566e-01L;      _weights[ 8]=4.3997382189243923173481417304490e-02L;
<a name="l00324"></a>00324             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=6.1495715187648951748964083381908e-01L;      _weights[ 9]=3.4647816579285799103084877873731e-02L;
<a name="l00325"></a>00325             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=7.0248013792504104445480697553762e-01L;      _weights[10]=2.5159233106470040585653957496918e-02L;
<a name="l00326"></a>00326             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=7.8312255396486808385218178256205e-01L;      _weights[11]=1.6539584355635793501225242083105e-02L;
<a name="l00327"></a>00327             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=8.5413814777521063366511368381932e-01L;      _weights[12]=9.5341678846659366549669638207733e-03L;
<a name="l00328"></a>00328             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=9.1310837653714127462958554670327e-01L;      _weights[13]=4.5392323861386350682211111786128e-03L;
<a name="l00329"></a>00329             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=9.5802441769047545454495934455429e-01L;      _weights[14]=1.5671884735958197030724006964051e-03L;
<a name="l00330"></a>00330             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=9.8735302062604161803115590316790e-01L;      _weights[15]=2.6749366505553617681762616226073e-04L;
<a name="l00331"></a>00331 
<a name="l00332"></a>00332             <span class="keywordflow">return</span>;
<a name="l00333"></a>00333           }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa88a052a9254947f209a5736a2cf49b19">THIRTYSECOND</a>:
<a name="l00337"></a>00337         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa15d72f9acb6abf33bfbd64b4afdb59b4">THIRTYTHIRD</a>:
<a name="l00338"></a>00338           {
<a name="l00339"></a>00339             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (17);
<a name="l00340"></a>00340             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(17);
<a name="l00341"></a>00341         
<a name="l00342"></a>00342             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=4.4579935677873917545062291115464e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.1372703113196894148880104403419e-02L;
<a name="l00343"></a>00343             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.3340094123774273967021528207683e-02L;      _weights[ 1]=2.5642427920205179185750205247311e-02L;
<a name="l00344"></a>00344             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=5.6707968769078239532713331556521e-02L;      _weights[ 2]=3.8025728825742400201474917006665e-02L;
<a name="l00345"></a>00345             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.0355543293519706341349122696131e-01L;      _weights[ 3]=4.7641869374618441920575209265709e-02L;
<a name="l00346"></a>00346             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.6246000342813654998162954391410e-01L;      _weights[ 4]=5.3907931667527480191616020246527e-02L;
<a name="l00347"></a>00347             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.3163212577717218294679722573836e-01L;      _weights[ 5]=5.6573611382471512986991034182850e-02L;
<a name="l00348"></a>00348             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=3.0897011775219590331752426128626e-01L;      _weights[ 6]=5.5734917923560549577129019490753e-02L;
<a name="l00349"></a>00349             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.9212413472209565803361946333190e-01L;      _weights[ 7]=5.1809741929296333255214704762820e-02L;
<a name="l00350"></a>00350             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=4.7856759685307958878371046285937e-01L;      _weights[ 8]=4.5477790399142277497438924164211e-02L;
<a name="l00351"></a>00351             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=5.6567396688663433190330697600965e-01L;      _weights[ 9]=3.7592325487112238031431998524319e-02L;
<a name="l00352"></a>00352             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=6.5079655845338226473148740732315e-01L;      _weights[10]=2.9074524087705050563187355467924e-02L;
<a name="l00353"></a>00353             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=7.3134895273405138213302149556298e-01L;      _weights[11]=2.0803278010295362060012866375773e-02L;
<a name="l00354"></a>00354             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=8.0488357852496649199917770139703e-01L;      _weights[12]=1.3513697452300780909638958310491e-02L;
<a name="l00355"></a>00355             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=8.6916605956741361920444649801116e-01L;      _weights[13]=7.7164222148059386958884227660543e-03L;
<a name="l00356"></a>00356             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=9.2224303459229840848710732823038e-01L;      _weights[14]=3.6472304834214064450344565237838e-03L;
<a name="l00357"></a>00357             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=9.6250119782335004125046077538851e-01L;      _weights[15]=1.2526834393912207489106525201067e-03L;
<a name="l00358"></a>00358             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.8871404063224375141712140225296e-01L;      _weights[16]=2.1311628920693358082515074128342e-04L;
<a name="l00359"></a>00359         
<a name="l00360"></a>00360             <span class="keywordflow">return</span>;
<a name="l00361"></a>00361           }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa621d865989d4fc3580a8d55ddc63a03a">THIRTYFOURTH</a>:
<a name="l00364"></a>00364         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faa8088f586a6b0baa0a05d6a18361510e">THIRTYFIFTH</a>:
<a name="l00365"></a>00365           {
<a name="l00366"></a>00366             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (18);
<a name="l00367"></a>00367             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(18);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=4.0014793838673867970427199102708e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.0214339435040633872267566728543e-02L;
<a name="l00370"></a>00370             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.0963648393766477995135600986561e-02L;      _weights[ 1]=2.3106350163377066931289331193145e-02L;
<a name="l00371"></a>00371             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=5.0994041587890553966774921299853e-02L;      _weights[ 2]=3.4471118921922024965038695158493e-02L;
<a name="l00372"></a>00372             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=9.3280395928544950777609058826066e-02L;      _weights[ 3]=4.3573907074643088262181650935306e-02L;
<a name="l00373"></a>00373             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.4667010367761795715160882973461e-01L;      _weights[ 4]=4.9902226917702713891102223856106e-02L;
<a name="l00374"></a>00374             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.0970703958884296672188171145203e-01L;      _weights[ 5]=5.3192334631835660026223777017865e-02L;
<a name="l00375"></a>00375             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.8067179006017169910681926203455e-01L;      _weights[ 6]=5.3445287802814027020361560753181e-02L;
<a name="l00376"></a>00376             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.5762864997663462939832714298390e-01L;      _weights[ 7]=5.0916928856374093181562996165432e-02L;
<a name="l00377"></a>00377             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=4.3847844922413811765185426038741e-01L;      _weights[ 8]=4.6082400990241280762086995392822e-02L;
<a name="l00378"></a>00378             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=5.2101582087077614731981479158547e-01L;      _weights[ 9]=3.9579162288607878726422969126448e-02L;
<a name="l00379"></a>00379             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=6.0298936055983207213748070418747e-01L;      _weights[10]=3.2134806127628549240737903166505e-02L;
<a name="l00380"></a>00380             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=6.8216303911365156501882207998153e-01L;      _weights[11]=2.4487590001291716597869859208141e-02L;
<a name="l00381"></a>00381             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=7.5637719340615062679816733590978e-01L;      _weights[12]=1.7308300480899289815470186505791e-02L;
<a name="l00382"></a>00382             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=8.2360742977486956587394885462062e-01L;      _weights[13]=1.1131870097409362452892993478578e-02L;
<a name="l00383"></a>00383             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=8.8201982536207914673124120886230e-01L;      _weights[14]=6.3060388823805337332782426625400e-03L;
<a name="l00384"></a>00384             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=9.3002088969969321648195850472769e-01L;      _weights[15]=2.9624430644328375036535062298419e-03L;
<a name="l00385"></a>00385             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.6630075194563254241150674649068e-01L;      _weights[16]=1.0130251793010471252471709101709e-03L;
<a name="l00386"></a>00386             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.8986684820259713441676302277596e-01L;      _weights[17]=1.7186908409819589231237151109171e-04L;
<a name="l00387"></a>00387         
<a name="l00388"></a>00388             <span class="keywordflow">return</span>;
<a name="l00389"></a>00389           }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1c81e8502e0dabbaa5ea9e87b53459bd">THIRTYSIXTH</a>:
<a name="l00392"></a>00392         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa24cbc0dd8da68e1efcf1873487f9904c">THIRTYSEVENTH</a>:
<a name="l00393"></a>00393           {
<a name="l00394"></a>00394             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (19);
<a name="l00395"></a>00395             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(19);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.6116428185568930344532101262520e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=9.2240377250330766917668248692203e-03L;
<a name="l00398"></a>00398             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.8931837031588217250264524316949e-02L;      _weights[ 1]=2.0924651751979890481445228332988e-02L;
<a name="l00399"></a>00399             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=4.6097933048431083573924770835459e-02L;      _weights[ 2]=3.1376275285732898854356814457609e-02L;
<a name="l00400"></a>00400             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=8.4447222784209820599847900451170e-02L;      _weights[ 3]=3.9962370048991741940293076442317e-02L;
<a name="l00401"></a>00401             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.3303618855809877542408742397522e-01L;      _weights[ 4]=4.6234928168578411765380785132191e-02L;
<a name="l00402"></a>00402             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.9066859490476335108747466488719e-01L;      _weights[ 5]=4.9934138240419379553284105838773e-02L;
<a name="l00403"></a>00403             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.5592540348210296025204739729528e-01L;      _weights[ 6]=5.1004186626719396295755229568486e-02L;
<a name="l00404"></a>00404             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.2719980076381171572842996527566e-01L;      _weights[ 7]=4.9591046468706580141316052533532e-02L;
<a name="l00405"></a>00405             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=4.0273678616507709512304701110488e-01L;      _weights[ 8]=4.6021985716138412908362881060678e-02L;
<a name="l00406"></a>00406             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=4.8067639357855190263322135248271e-01L;      _weights[ 9]=4.0768870871836685572301729841664e-02L;
<a name="l00407"></a>00407             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=5.5909949264903198784692797587908e-01L;      _weights[10]=3.4398957951907391429559705435925e-02L;
<a name="l00408"></a>00408             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=6.3607504487927089469109105709816e-01L;      _weights[11]=2.7518058144347978141481142479516e-02L;
<a name="l00409"></a>00409             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=7.0970765165390239884374678311164e-01L;      _weights[12]=2.0711672562757804879837159838775e-02L;
<a name="l00410"></a>00410             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=7.7818422297676161420929964704208e-01L;      _weights[13]=1.4489847112109724657001233005036e-02L;
<a name="l00411"></a>00411             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=8.3981861570871107783863629442929e-01L;      _weights[14]=9.2410919293165977626976877702861e-03L;
<a name="l00412"></a>00412             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=8.9309313498184497075098115456491e-01L;      _weights[15]=5.1997813282783796868055465441831e-03L;
<a name="l00413"></a>00413             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.3669584807436508054390550208195e-01L;      _weights[16]=2.4300917120432807075681660438661e-03L;
<a name="l00414"></a>00414             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.6955263708022088547192878623227e-01L;      _weights[17]=8.2788076092398219334600301771448e-04L;
<a name="l00415"></a>00415             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.9085180527095568535309483522012e-01L;      _weights[18]=1.4012759417838633744062778723898e-04L;
<a name="l00416"></a>00416         
<a name="l00417"></a>00417             <span class="keywordflow">return</span>;
<a name="l00418"></a>00418           }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad7b5f8e152598d25c7c161f15221f5be">THIRTYEIGHTH</a>:
<a name="l00421"></a>00421         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7686c65f85c6e3ec25fb1ce492b41e2c">THIRTYNINTH</a>:
<a name="l00422"></a>00422           {
<a name="l00423"></a>00423             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (20);
<a name="l00424"></a>00424             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(20);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.2761066690500989752646761128711e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=8.3708441762725569742347797346057e-03L;
<a name="l00427"></a>00427             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.7181218145255713738247704631582e-02L;      _weights[ 1]=1.9034969463701666952317752319364e-02L;
<a name="l00428"></a>00428             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=4.1871431117765195244234634143709e-02L;      _weights[ 2]=2.8668237379130596303519483134423e-02L;
<a name="l00429"></a>00429             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=7.6800837089621970481870523019947e-02L;      _weights[ 3]=3.6750239836647855880170014918540e-02L;
<a name="l00430"></a>00430             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.2118986732367606561768615229454e-01L;      _weights[ 4]=4.2890295837978204214146023790200e-02L;
<a name="l00431"></a>00431             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.7404711263554216522415793419966e-01L;      _weights[ 5]=4.6841691862557827847492882468251e-02L;
<a name="l00432"></a>00432             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.3419188631359219089445571283230e-01L;      _weights[ 6]=4.8516105059854090810181874268668e-02L;
<a name="l00433"></a>00433             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.0028067683595016436625841871717e-01L;      _weights[ 7]=4.7985461609943912515256158210751e-02L;
<a name="l00434"></a>00434             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.7083718058439689644532207953771e-01L;      _weights[ 8]=4.5470588941353475125260875269943e-02L;
<a name="l00435"></a>00435             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=4.4428528696301116212882391783598e-01L;      _weights[ 9]=4.1317706816665737825832945172262e-02L;
<a name="l00436"></a>00436             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=5.1898428870357372961841176083024e-01L;      _weights[10]=3.5964919153862747854063187859799e-02L;
<a name="l00437"></a>00437             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=5.9326553348350648796739308654437e-01L;      _weights[11]=2.9901741842629013049082489189589e-02L;
<a name="l00438"></a>00438             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=6.6546969890551364795372958813385e-01L;      _weights[12]=2.3625296173548892813066360441583e-02L;
<a name="l00439"></a>00439             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=7.3398385823565944973202719329584e-01L;      _weights[13]=1.7597066879206016267686128655074e-02L;
<a name="l00440"></a>00440             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=7.9727750833659468770218885137527e-01L;      _weights[14]=1.2204046126680104278798703245791e-02L;
<a name="l00441"></a>00441             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=8.5393675303589045708900439161802e-01L;      _weights[15]=7.7276679300514628735780671415898e-03L;
<a name="l00442"></a>00442             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.0269587179345369227634694169967e-01L;      _weights[16]=4.3232191126901531337390520742896e-03L;
<a name="l00443"></a>00443             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.4246554236318633869089187742766e-01L;      _weights[17]=2.0114576139640780069071394684122e-03L;
<a name="l00444"></a>00444             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.7235694664743691118470187166465e-01L;      _weights[18]=6.8306227608592198451771987553801e-04L;
<a name="l00445"></a>00445             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[19](0)=9.9169995579293273076654365969470e-01L;      _weights[19]=1.1538190717568529014836276132844e-04L;
<a name="l00446"></a>00446         
<a name="l00447"></a>00447             <span class="keywordflow">return</span>;
<a name="l00448"></a>00448           }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0b2b50be416b002ce458061fe2d7506a">FORTIETH</a>:
<a name="l00451"></a>00451         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faae7b8a6cf8f301aa024087e7f371a81c">FORTYFIRST</a>:
<a name="l00452"></a>00452           {
<a name="l00453"></a>00453             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (21);
<a name="l00454"></a>00454             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(21);
<a name="l00455"></a>00455 
<a name="l00456"></a>00456             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.9852372832130627418887840757498e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=7.6306059065231890951709176867159e-03L;
<a name="l00457"></a>00457             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.5662280557573547332895610655678e-02L;      _weights[ 1]=1.7387926076195012545310092581185e-02L;
<a name="l00458"></a>00458             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.8198288245073553344832819395658e-02L;      _weights[ 2]=2.6287260083203306468723755830943e-02L;
<a name="l00459"></a>00459             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=7.0139619062325798139842656763758e-02L;      _weights[ 3]=3.3886790344403175515158905218748e-02L;
<a name="l00460"></a>00460             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.1083667332036350223762530758616e-01L;      _weights[ 4]=3.9845977571398966444570950002831e-02L;
<a name="l00461"></a>00461             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.5946112944406525026381380836555e-01L;      _weights[ 5]=4.3935570635150377464859835729052e-02L;
<a name="l00462"></a>00462             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.1502318535802028508091216764592e-01L;      _weights[ 6]=4.6050270723257502074077985626262e-02L;
<a name="l00463"></a>00463             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=2.7639177909378317240968620976306e-01L;      _weights[ 7]=4.6212552611022412660350368837561e-02L;
<a name="l00464"></a>00464             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.4231763295873079372348132371246e-01L;      _weights[ 8]=4.4566874686154606866984823191992e-02L;
<a name="l00465"></a>00465             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=4.1145869156190519892697533612651e-01L;      _weights[ 9]=4.1364760396997617354403702904192e-02L;
<a name="l00466"></a>00466             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=4.8240744461243888053531852185958e-01L;      _weights[10]=3.6942012648499385551903205764287e-02L;
<a name="l00467"></a>00467             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=5.5371958072829359140036561243486e-01L;      _weights[11]=3.1689953050127340376763333466278e-02L;
<a name="l00468"></a>00468             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=6.2394338972128194749630581474409e-01L;      _weights[12]=2.6023046795895555117823162899995e-02L;
<a name="l00469"></a>00469             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=6.9164931501296225721944667896925e-01L;      _weights[13]=2.0345549389821508292035088652126e-02L;
<a name="l00470"></a>00470             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=7.5545905444968698626584997281486e-01L;      _weights[14]=1.5019872613192784763520392446339e-02L;
<a name="l00471"></a>00471             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=8.1407361651269741678894410957934e-01L;      _weights[15]=1.0339209757970312663832726410241e-02L;
<a name="l00472"></a>00472             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=8.6629975897095659707636330435792e-01L;      _weights[16]=6.5065974236456053354067512991831e-03L;
<a name="l00473"></a>00473             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.1107426580261577477966643276619e-01L;      _weights[17]=3.6220528697449398652362737797211e-03L;
<a name="l00474"></a>00474             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.4748554440639734668609897166113e-01L;      _weights[18]=1.6787560215669155362763365937815e-03L;
<a name="l00475"></a>00475             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[19](0)=9.7479197566036565307915209128675e-01L;      _weights[19]=5.6849852669976417861179123569953e-04L;
<a name="l00476"></a>00476             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[20](0)=9.9243549072562147749379027938900e-01L;      _weights[20]=9.5861868529721828979599842865244e-05L;
<a name="l00477"></a>00477         
<a name="l00478"></a>00478             <span class="keywordflow">return</span>;
<a name="l00479"></a>00479           }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faf1ea9fc7d47660c23ff7ff4c0ffae985">FORTYSECOND</a>:
<a name="l00482"></a>00482         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5536e362ffba6fc36737d12d56016794">FORTYTHIRD</a>:
<a name="l00483"></a>00483           {
<a name="l00484"></a>00484             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (22);
<a name="l00485"></a>00485             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(22);
<a name="l00486"></a>00486 
<a name="l00487"></a>00487             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.7314460088842296840089704503200e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=6.9842561136978136538216549700282e-03L;
<a name="l00488"></a>00488             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.4335933483699706185308039285053e-02L;      _weights[ 1]=1.5944053454778496864565929126309e-02L;
<a name="l00489"></a>00489             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.4986328351216449387218814071085e-02L;      _weights[ 2]=2.4184236671890499758870393233781e-02L;
<a name="l00490"></a>00490             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=6.4302641132158882531275071395686e-02L;      _weights[ 3]=3.1327596999375227892408958559682e-02L;
<a name="l00491"></a>00491             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.0173934345216392401258226593794e-01L;      _weights[ 4]=3.7077054093202864483217335909271e-02L;
<a name="l00492"></a>00492             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.4659920015766541692656584266952e-01L;      _weights[ 5]=4.1222404906411452577079119693783e-02L;
<a name="l00493"></a>00493             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=1.9804660411818261484660504028001e-01L;      _weights[ 6]=4.3651203786303462995293138094828e-02L;
<a name="l00494"></a>00494             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=2.5512320697168696957682873507625e-01L;      _weights[ 7]=4.4353370900419806188626977124445e-02L;
<a name="l00495"></a>00495             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.1676578871044727183421117602379e-01L;      _weights[ 8]=4.3418750145417827908334525766667e-02L;
<a name="l00496"></a>00496             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=3.8182606925675020305095127628112e-01L;      _weights[ 9]=4.1027795781940901638265438618895e-02L;
<a name="l00497"></a>00497             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=4.4909210098681733251387195042393e-01L;      _weights[10]=3.7436116466930019239662981188891e-02L;
<a name="l00498"></a>00498             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=5.1731084595099112005136286684174e-01L;      _weights[11]=3.2954058785385534039887856528676e-02L;
<a name="l00499"></a>00499             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=5.8521151795129912975524533467408e-01L;      _weights[12]=2.7922870823442631249079662456458e-02L;
<a name="l00500"></a>00500             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=6.5152925489581447403580682231185e-01L;      _weights[13]=2.2689228598160995380212860776143e-02L;
<a name="l00501"></a>00501             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=7.1502868047476240261215783933800e-01L;      _weights[14]=1.7580017560152292742735027157072e-02L;
<a name="l00502"></a>00502             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=7.7452691606482263532020273841099e-01L;      _weights[15]=1.2879230281365339696348205046681e-02L;
<a name="l00503"></a>00503             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=8.2891561362172651235400549854277e-01L;      _weights[16]=8.8086724401109070881737532508054e-03L;
<a name="l00504"></a>00504             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=8.7718159746542002099358323827803e-01L;      _weights[17]=5.5138751021276410109163746634529e-03L;
<a name="l00505"></a>00505             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.1842572498984926327926994425432e-01L;      _weights[18]=3.0562141131504037344643025112362e-03L;
<a name="l00506"></a>00506             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[19](0)=9.5187959322971991452332541323047e-01L;      _weights[19]=1.4117668531394242829582650189559e-03L;
<a name="l00507"></a>00507             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[20](0)=9.7691966323712886717816657113704e-01L;      _weights[20]=4.7692790565900675904839748933142e-04L;
<a name="l00508"></a>00508             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[21](0)=9.9307748504434821490300210664154e-01L;      _weights[21]=8.0298216937450816028842814607537e-05L;
<a name="l00509"></a>00509         
<a name="l00510"></a>00510             <span class="keywordflow">return</span>;
<a name="l00511"></a>00511           }
<a name="l00512"></a>00512       
<a name="l00513"></a>00513         <span class="keywordflow">default</span>:
<a name="l00514"></a>00514           {
<a name="l00515"></a>00515             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Quadrature rule &quot;</span> &lt;&lt; _order
<a name="l00516"></a>00516                           &lt;&lt; <span class="stringliteral">&quot; not supported!&quot;</span> &lt;&lt; std::endl;
<a name="l00517"></a>00517               
<a name="l00518"></a>00518             libmesh_error();
<a name="l00519"></a>00519           }
<a name="l00520"></a>00520         } <span class="comment">// end switch(_order + 2*p)</span>
<a name="l00521"></a>00521 
<a name="l00522"></a>00522       libmesh_error();
<a name="l00523"></a>00523     } <span class="comment">// end if ((_alpha == 1) &amp;&amp; (_beta == 0))</span>
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   
<a name="l00527"></a>00527   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1QJacobi.php#a432af4bebde14ac394e948ca585cadcd">_alpha</a> == 2) &amp;&amp; (<a class="code" href="classlibMesh_1_1QJacobi.php#a812ed1eb1a7681cf7cc7dad1223ed668">_beta</a> == 0))
<a name="l00528"></a>00528     {
<a name="l00529"></a>00529       
<a name="l00530"></a>00530       <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00531"></a>00531         {
<a name="l00532"></a>00532         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00533"></a>00533         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00534"></a>00534           {
<a name="l00535"></a>00535             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (1);
<a name="l00536"></a>00536             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(1);
<a name="l00537"></a>00537         
<a name="l00538"></a>00538             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0)  = 0.25;
<a name="l00539"></a>00539         
<a name="l00540"></a>00540             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0]    = 1./3.;
<a name="l00541"></a>00541         
<a name="l00542"></a>00542             <span class="keywordflow">return</span>;
<a name="l00543"></a>00543           }
<a name="l00544"></a>00544         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00545"></a>00545         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00546"></a>00546           {
<a name="l00547"></a>00547             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (2);
<a name="l00548"></a>00548             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(2);
<a name="l00549"></a>00549             
<a name="l00550"></a>00550             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.2251482265544137786674043037115e-01L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.3254745125350790274997694884235e-01L;
<a name="l00551"></a>00551             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=5.4415184401122528879992623629551e-01L;      _weights[ 1]=1.0078588207982543058335638449099e-01L;
<a name="l00552"></a>00552 
<a name="l00553"></a>00553             <span class="keywordflow">return</span>;
<a name="l00554"></a>00554           }
<a name="l00555"></a>00555         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00556"></a>00556         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00557"></a>00557           {
<a name="l00558"></a>00558             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (3);
<a name="l00559"></a>00559             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(3);
<a name="l00560"></a>00560               
<a name="l00561"></a>00561             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=7.2994024073149732155837979012003e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.5713636106488661331834482221327e-01L;
<a name="l00562"></a>00562             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=3.4700376603835188472176354340395e-01L;      _weights[ 1]=1.4624626925986602200351202036424e-01L;
<a name="l00563"></a>00563             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=7.0500220988849838312239847758405e-01L;      _weights[ 2]=2.9950703008580698011476490755827e-02L;
<a name="l00564"></a>00564 
<a name="l00565"></a>00565             <span class="keywordflow">return</span>;
<a name="l00566"></a>00566           }
<a name="l00567"></a>00567         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00568"></a>00568         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00569"></a>00569           {
<a name="l00570"></a>00570             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (4);
<a name="l00571"></a>00571             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(4);
<a name="l00572"></a>00572               
<a name="l00573"></a>00573             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=4.8500549446997329297067257098986e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.1088841561127798368323131746895e-01L;
<a name="l00574"></a>00574             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.3860073755186230505898141272470e-01L;      _weights[ 1]=1.4345878979921420904832801427594e-01L;
<a name="l00575"></a>00575             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=5.1704729510436750234057336938307e-01L;      _weights[ 2]=6.8633887172923075317376345041811e-02L;
<a name="l00576"></a>00576             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=7.9585141789677286330337796079324e-01L;      _weights[ 3]=1.0352240749918065284397656546639e-02L;
<a name="l00577"></a>00577 
<a name="l00578"></a>00578             <span class="keywordflow">return</span>;
<a name="l00579"></a>00579           }
<a name="l00580"></a>00580         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00581"></a>00581         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00582"></a>00582           {
<a name="l00583"></a>00583             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (5);
<a name="l00584"></a>00584             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(5);
<a name="l00585"></a>00585               
<a name="l00586"></a>00586             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.4578939918215091524457428631527e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=8.1764784285770917904880732922352e-02L;
<a name="l00587"></a>00587             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.7348032077169572310459241798618e-01L;      _weights[ 1]=1.2619896189991148802883293516467e-01L;
<a name="l00588"></a>00588             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.8988638706551932824089541038499e-01L;      _weights[ 2]=8.9200161221590000186254493070384e-02L;
<a name="l00589"></a>00589             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=6.3433347263088677234716388892062e-01L;      _weights[ 3]=3.2055600722961919254748930556633e-02L;
<a name="l00590"></a>00590             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=8.5105421294701641811622418741001e-01L;      _weights[ 4]=4.1138252030990079586162416192983e-03L;
<a name="l00591"></a>00591 
<a name="l00592"></a>00592             <span class="keywordflow">return</span>;
<a name="l00593"></a>00593           }
<a name="l00594"></a>00594         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00595"></a>00595         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00596"></a>00596           {
<a name="l00597"></a>00597         
<a name="l00598"></a>00598             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (6);
<a name="l00599"></a>00599             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(6);
<a name="l00600"></a>00600               
<a name="l00601"></a>00601             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.5904555093667192754643606997235e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=6.2538702726580937878526556468332e-02L;
<a name="l00602"></a>00602             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.3156394165798513398691085074097e-01L;      _weights[ 1]=1.0737649973678063260575568234795e-01L;
<a name="l00603"></a>00603             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.0243691802289123274990557791855e-01L;      _weights[ 2]=9.4577186748541203568292051720052e-02L;
<a name="l00604"></a>00604             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=5.0903641316475208401103990516772e-01L;      _weights[ 3]=5.1289571129616210220129325076919e-02L;
<a name="l00605"></a>00605             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=7.1568112731171391876766262459361e-01L;      _weights[ 4]=1.5720297184945051327851262130020e-02L;
<a name="l00606"></a>00606             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=8.8680561617756186630126600601049e-01L;      _weights[ 5]=1.8310758068692977327784555900562e-03L;
<a name="l00607"></a>00607 
<a name="l00608"></a>00608             <span class="keywordflow">return</span>;
<a name="l00609"></a>00609           }
<a name="l00610"></a>00610         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00611"></a>00611         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00612"></a>00612           {
<a name="l00613"></a>00613             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (7);
<a name="l00614"></a>00614             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(7);
<a name="l00615"></a>00615               
<a name="l00616"></a>00616             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.0132773773400507230501687117472e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=4.9276501776438120823429129084905e-02L;
<a name="l00617"></a>00617             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.0308902914804901475222678600595e-01L;      _weights[ 1]=9.0698824612686144536967479972374e-02L;
<a name="l00618"></a>00618             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=2.4055412604805753665369914150100e-01L;      _weights[ 2]=9.1733803279795254111416595896867e-02L;
<a name="l00619"></a>00619             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=4.1400214459705974641828724885057e-01L;      _weights[ 3]=6.3146378708891297709533940481199e-02L;
<a name="l00620"></a>00620             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=6.0002151327899293019396877288994e-01L;      _weights[ 4]=2.9422211289528614840745351985011e-02L;
<a name="l00621"></a>00621             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=7.7351724659143750111199899642603e-01L;      _weights[ 5]=8.1629256323046945072318090687213e-03L;
<a name="l00622"></a>00622             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=9.1118316656300276363931736720905e-01L;      _weights[ 6]=8.9268803368920680400902684425561e-04L;
<a name="l00623"></a>00623 
<a name="l00624"></a>00624             <span class="keywordflow">return</span>;
<a name="l00625"></a>00625           }
<a name="l00626"></a>00626         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00627"></a>00627         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7120ce4c6dcb4b9465b15e7531631fe6">FIFTEENTH</a>:
<a name="l00628"></a>00628           {
<a name="l00629"></a>00629             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (8);
<a name="l00630"></a>00630             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(8);
<a name="l00631"></a>00631               
<a name="l00632"></a>00632             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.6097759551921033532013550096618e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=3.9778957806690559830106455926398e-02L;
<a name="l00633"></a>00633             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=8.2900617485651102700366353380388e-02L;      _weights[ 1]=7.6818093267222624804506735068290e-02L;
<a name="l00634"></a>00634             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.9547516848873991732426660953061e-01L;      _weights[ 2]=8.5284769171938765209441226265186e-02L;
<a name="l00635"></a>00635             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=3.4165199147720222027296226216240e-01L;      _weights[ 3]=6.8447183421653272247027200610852e-02L;
<a name="l00636"></a>00636             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=5.0559707818448917194006186500608e-01L;      _weights[ 4]=4.0814426388544023186461596152148e-02L;
<a name="l00637"></a>00637             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=6.6955227182436145183011451055437e-01L;      _weights[ 5]=1.7246863780234982804243655774862e-02L;
<a name="l00638"></a>00638             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=8.1577170358328376075475178697587e-01L;      _weights[ 6]=4.4745217130144079957565210032836e-03L;
<a name="l00639"></a>00639             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=9.2850896495990689720101861784923e-01L;      _weights[ 7]=4.6851778403469725578994253231334e-04L;
<a name="l00640"></a>00640 
<a name="l00641"></a>00641             <span class="keywordflow">return</span>;
<a name="l00642"></a>00642           }
<a name="l00643"></a>00643         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad3a83c160ba19d280cf82ab0fee65f2d">SIXTEENTH</a>:
<a name="l00644"></a>00644         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fae4eeb80a784baaf763cdccf0a47a4557">SEVENTEENTH</a>:
<a name="l00645"></a>00645           {
<a name="l00646"></a>00646             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (9);
<a name="l00647"></a>00647             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(9);
<a name="l00648"></a>00648 
<a name="l00649"></a>00649             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.3165885597114490545190537817972e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=3.2760145111039721461819540084274e-02L;
<a name="l00650"></a>00650             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=6.8084529593767587476505856986822e-02L;      _weights[ 1]=6.5489537033396631781939107203912e-02L;
<a name="l00651"></a>00651             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.6175951676407464206981091232919e-01L;      _weights[ 2]=7.7673569160555504078595170478444e-02L;
<a name="l00652"></a>00652             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=2.8589108833922039772798956691264e-01L;      _weights[ 3]=6.9284395689804709215727785348892e-02L;
<a name="l00653"></a>00653             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=4.2945364538781279250924800228659e-01L;      _weights[ 4]=4.8540627864506507959528062424865e-02L;
<a name="l00654"></a>00654             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=5.7969405635116312626577241331199e-01L;      _weights[ 5]=2.6343280902549835737974696002673e-02L;
<a name="l00655"></a>00655             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=7.2326857174033543181796015820021e-01L;      _weights[ 6]=1.0406116579352237052426337235938e-02L;
<a name="l00656"></a>00656             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=8.4743684201323732017318042501962e-01L;      _weights[ 7]=2.5743986456087231023317159056037e-03L;
<a name="l00657"></a>00657             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=9.4124586421327421141434212713498e-01L;      _weights[ 8]=2.6126234651946294299091864873302e-04L;
<a name="l00658"></a>00658 
<a name="l00659"></a>00659             <span class="keywordflow">return</span>;
<a name="l00660"></a>00660           }
<a name="l00661"></a>00661         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa04abe26889214024e6b01556757afebc">EIGHTTEENTH</a>:
<a name="l00662"></a>00662         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa460d128a5ae3f0cab006386047945a63">NINTEENTH</a>:
<a name="l00663"></a>00663           {
<a name="l00664"></a>00664             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (10);
<a name="l00665"></a>00665             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(10);
<a name="l00666"></a>00666 
<a name="l00667"></a>00667             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=1.0968452456174134250281032990432e-02L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.7434088710097496960451648584485e-02L;
<a name="l00668"></a>00668             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=5.6898150533657920711434859379121e-02L;      _weights[ 1]=5.6272936402808126282415832152709e-02L;
<a name="l00669"></a>00669             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.3595023405022895426576342938519e-01L;      _weights[ 2]=7.0069507708666334086372455308183e-02L;
<a name="l00670"></a>00670             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=2.4228119613252356111139455536509e-01L;      _weights[ 3]=6.7452219381437824970525794313691e-02L;
<a name="l00671"></a>00671             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=3.6800785044933771760476956625017e-01L;      _weights[ 4]=5.2883788766964158209884838942421e-02L;
<a name="l00672"></a>00672             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=5.0380712641487390700553064205723e-01L;      _weights[ 5]=3.3854565016814116044101071309373e-02L;
<a name="l00673"></a>00673             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=6.3960948865470970932853650616696e-01L;      _weights[ 6]=1.7197575046553008079137502323978e-02L;
<a name="l00674"></a>00674             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=7.6534767954810789620953312724460e-01L;      _weights[ 7]=6.4698890685585292297306065609276e-03L;
<a name="l00675"></a>00675             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=8.7171007457440848761186134200542e-01L;      _weights[ 8]=1.5455231947365786285853268147186e-03L;
<a name="l00676"></a>00676             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=9.5087429264052316644634948461033e-01L;      _weights[ 9]=1.5324003669716084212825702284675e-04L;
<a name="l00677"></a>00677 
<a name="l00678"></a>00678             <span class="keywordflow">return</span>;
<a name="l00679"></a>00679           }      
<a name="l00680"></a>00680         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1fd67e9ea1cf7030e0e5b9c6e82698a2">TWENTIETH</a>:
<a name="l00681"></a>00681         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6e1551e839c8196b348cd883be5a4bd8">TWENTYFIRST</a>:
<a name="l00682"></a>00682           {
<a name="l00683"></a>00683             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (11);
<a name="l00684"></a>00684             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(11);
<a name="l00685"></a>00685 
<a name="l00686"></a>00686             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=9.2789738313488342029466103013448e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.3300850051388377415061404350855e-02L;
<a name="l00687"></a>00687             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=4.8249692094286258286483723731132e-02L;      _weights[ 1]=4.8745861030664491864450329028080e-02L;
<a name="l00688"></a>00688             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=1.1578862662939522596030591825565e-01L;      _weights[ 2]=6.2979543000367394338333998811129e-02L;
<a name="l00689"></a>00689             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=2.0766834159705988244389542530053e-01L;      _weights[ 3]=6.4183559349755944992539371306173e-02L;
<a name="l00690"></a>00690             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=3.1811795190623396637744646657914e-01L;      _weights[ 4]=5.4632222321044926070678715192708e-02L;
<a name="l00691"></a>00691             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=4.4019839985886246708268132217632e-01L;      _weights[ 5]=3.9290217798435612246535835921329e-02L;
<a name="l00692"></a>00692             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=5.6623983915456831356751247193488e-01L;      _weights[ 6]=2.3589663538806928649316661943808e-02L;
<a name="l00693"></a>00693             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=6.8832423986295668569553397580809e-01L;      _weights[ 7]=1.1414590918097618249921262806781e-02L;
<a name="l00694"></a>00694             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=7.9878435859091464197460872800735e-01L;      _weights[ 8]=4.1400042632190223547676874553245e-03L;
<a name="l00695"></a>00695             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=8.9069109935439218915081289990608e-01L;      _weights[ 9]=9.6302057554323908320037373956771e-04L;
<a name="l00696"></a>00696             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=9.5832514378664820192443912466615e-01L;      _weights[10]=9.3800486009778068527692777578977e-05L;
<a name="l00697"></a>00697 
<a name="l00698"></a>00698             <span class="keywordflow">return</span>;
<a name="l00699"></a>00699           }
<a name="l00700"></a>00700         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac53c44bf97483f77b3b8f12689d1025f">TWENTYSECOND</a>:
<a name="l00701"></a>00701         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>:
<a name="l00702"></a>00702           {
<a name="l00703"></a>00703             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (12);
<a name="l00704"></a>00704             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(12);
<a name="l00705"></a>00705 
<a name="l00706"></a>00706             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=7.9520457026384368762190933400404e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=2.0031112584748752943807724216722e-02L;
<a name="l00707"></a>00707             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=4.1427810454294590790770165194795e-02L;      _weights[ 1]=4.2556615367405637772968490900760e-02L;
<a name="l00708"></a>00708             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=9.9757625542614157066081703480300e-02L;      _weights[ 2]=5.6584184749474069646478036154467e-02L;
<a name="l00709"></a>00709             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.7981078905242324954164334430721e-01L;      _weights[ 3]=6.0250607487604518170935343500906e-02L;
<a name="l00710"></a>00710             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.7727345779931511981753891831052e-01L;      _weights[ 4]=5.4573941164231582825558709780290e-02L;
<a name="l00711"></a>00711             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=3.8689200999768979166563470380544e-01L;      _weights[ 5]=4.2764763570188902317265936785879e-02L;
<a name="l00712"></a>00712             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=5.0275736044903220327930927843912e-01L;      _weights[ 6]=2.8908051838727360494403492180206e-02L;
<a name="l00713"></a>00713             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=6.1862386345845604629354886189114e-01L;      _weights[ 7]=1.6547343644609412101387213540038e-02L;
<a name="l00714"></a>00714             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=7.2824645295307268642888033006114e-01L;      _weights[ 8]=7.7163670238864266187877366246530e-03L;
<a name="l00715"></a>00715             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=8.2571851421478690176408336295370e-01L;      _weights[ 9]=2.7208421441038393545415361663513e-03L;
<a name="l00716"></a>00716             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=9.0579507354454372680179647039974e-01L;      _weights[10]=6.1995339854451942336673117135933e-04L;
<a name="l00717"></a>00717             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=9.6420653529267155121295530627839e-01L;      _weights[11]=5.9550359808311663832382311702501e-05L;
<a name="l00718"></a>00718 
<a name="l00719"></a>00719             <span class="keywordflow">return</span>;
<a name="l00720"></a>00720           }
<a name="l00721"></a>00721 
<a name="l00722"></a>00722         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa8093001568608e51bbe10f03c871fc41">TWENTYFOURTH</a>:
<a name="l00723"></a>00723         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad2f79bea88fd463e33a7800d828bded9">TWENTYFIFTH</a>:
<a name="l00724"></a>00724           {
<a name="l00725"></a>00725             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (13);
<a name="l00726"></a>00726             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(13);
<a name="l00727"></a>00727 
<a name="l00728"></a>00728             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=6.8908313099587313966815341534070e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.7401228610061845488081141733526e-02L;
<a name="l00729"></a>00729             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=3.5953362700170095501132811969521e-02L;      _weights[ 1]=3.7426708168844039953666298186474e-02L;
<a name="l00730"></a>00730             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=8.6811780157585433284280307690601e-02L;      _weights[ 2]=5.0909830712695019092906847187640e-02L;
<a name="l00731"></a>00731             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.5709997419650927473052206555148e-01L;      _weights[ 3]=5.6111537130827396185039872203667e-02L;
<a name="l00732"></a>00732             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.4353289958712844441903410356775e-01L;      _weights[ 4]=5.3340021605871745725401666422880e-02L;
<a name="l00733"></a>00733             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=3.4206951264607532347450799656627e-01L;      _weights[ 5]=4.4624600755614954430566337477243e-02L;
<a name="l00734"></a>00734             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=4.4810263890570985362873430879398e-01L;      _weights[ 6]=3.2940451678432790083648445397381e-02L;
<a name="l00735"></a>00735             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=5.5667462262945501069694664236208e-01L;      _weights[ 7]=2.1254996714756613031113108888658e-02L;
<a name="l00736"></a>00736             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=6.6270931356038854232146315212326e-01L;      _weights[ 8]=1.1728259593101880662970381149369e-02L;
<a name="l00737"></a>00737             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=7.6124976630827697227665952639343e-01L;      _weights[ 9]=5.3135693388326384480559144318474e-03L;
<a name="l00738"></a>00738             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=8.4769104394723239091031404895142e-01L;      _weights[10]=1.8323911392393785873485644191745e-03L;
<a name="l00739"></a>00739             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=9.1799964553720667953362597028835e-01L;      _weights[11]=4.1072089179088541678428389490865e-04L;
<a name="l00740"></a>00740             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=9.6892889422858896211181181730274e-01L;      _weights[12]=3.9016993264146227750471940564101e-05L;
<a name="l00741"></a>00741         
<a name="l00742"></a>00742             <span class="keywordflow">return</span>;
<a name="l00743"></a>00743           }
<a name="l00744"></a>00744 
<a name="l00745"></a>00745         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5f33eeba0f7239d41b54654ce8d99aa3">TWENTYSIXTH</a>:
<a name="l00746"></a>00746         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0facb1defec8f9bfcd21f5ef0f62fcacd2f">TWENTYSEVENTH</a>:
<a name="l00747"></a>00747           {
<a name="l00748"></a>00748             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (14);
<a name="l00749"></a>00749             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(14);
<a name="l00750"></a>00750 
<a name="l00751"></a>00751             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=6.0288088710666481700887477121600e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.5255206119448295373511341972378e-02L;
<a name="l00752"></a>00752             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=3.1494259818657590707306712766317e-02L;      _weights[ 1]=3.3139595469960559875930225836517e-02L;
<a name="l00753"></a>00753             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=7.6213622474853867586406786340023e-02L;      _weights[ 2]=4.5914772114671178911403799944693e-02L;
<a name="l00754"></a>00754             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.3836652595947406914513833295825e-01L;      _weights[ 3]=5.2025865410701701832827358849471e-02L;
<a name="l00755"></a>00755             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=2.1540975706889557490069553208515e-01L;      _weights[ 4]=5.1389924039471503273808065266413e-02L;
<a name="l00756"></a>00756             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=3.0418952814165630963236635490440e-01L;      _weights[ 5]=4.5253432254460881465122373566022e-02L;
<a name="l00757"></a>00757             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=4.0107137869715435758118603205199e-01L;      _weights[ 6]=3.5739010292514612984162525810346e-02L;
<a name="l00758"></a>00758             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=5.0208913974997841006932539804960e-01L;      _weights[ 7]=2.5216183536839055034306220202219e-02L;
<a name="l00759"></a>00759             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=6.0310739672759678368189556654036e-01L;      _weights[ 8]=1.5694332285072957184930434798487e-02L;
<a name="l00760"></a>00760             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=6.9999091716990649741073666393849e-01L;      _weights[ 9]=8.4129767371364622096077152778570e-03L;
<a name="l00761"></a>00761             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=7.8877423843456071534030488559891e-01L;      _weights[10]=3.7248756752828588215538124784652e-03L;
<a name="l00762"></a>00762             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=8.6582490073159695367114083518102e-01L;      _weights[11]=1.2617838951574880413283334197260e-03L;
<a name="l00763"></a>00763             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=9.2799573874675232498377812203940e-01L;      _weights[12]=2.7909934094687847008945560658272e-04L;
<a name="l00764"></a>00764             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=9.7277712074118323045296336316727e-01L;      _weights[13]=2.6276161668899854751670304157309e-05L;
<a name="l00765"></a>00765         
<a name="l00766"></a>00766             <span class="keywordflow">return</span>;
<a name="l00767"></a>00767           }
<a name="l00768"></a>00768 
<a name="l00769"></a>00769         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0e295eb2dfc5e7e8c49b433ae27b1369">TWENTYEIGHTH</a>:
<a name="l00770"></a>00770         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2e33cfffe6c21901c488cc5c58d5bae9">TWENTYNINTH</a>:
<a name="l00771"></a>00771           {
<a name="l00772"></a>00772             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (15);
<a name="l00773"></a>00773             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(15);
<a name="l00774"></a>00774 
<a name="l00775"></a>00775             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=5.3190520028437405909978402739774e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.3481662725134304090265733542410e-02L;
<a name="l00776"></a>00776             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.7814561918260051571980709238074e-02L;      _weights[ 1]=2.9527650756798205089388266870014e-02L;
<a name="l00777"></a>00777             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=6.7431865838998613384568577571818e-02L;      _weights[ 2]=4.1531307651604265373799456795289e-02L;
<a name="l00778"></a>00778             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.2274828621549783933958732401303e-01L;      _weights[ 3]=4.8132057668529815888404876719886e-02L;
<a name="l00779"></a>00779             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.9176570627765362550282684505042e-01L;      _weights[ 4]=4.9041267894409180565196427508457e-02L;
<a name="l00780"></a>00780             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.7198996592948620305633800793026e-01L;      _weights[ 5]=4.4991555820615933365730152800755e-02L;
<a name="l00781"></a>00781             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=3.6052169358705764815778444077840e-01L;      _weights[ 6]=3.7473875792101303095319296790068e-02L;
<a name="l00782"></a>00782             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=4.5416123575447709916009624996188e-01L;      _weights[ 7]=2.8326553174241247644068974123766e-02L;
<a name="l00783"></a>00783             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=5.4952435559355131365468962196031e-01L;      _weights[ 8]=1.9293416585274520485988288429744e-02L;
<a name="l00784"></a>00784             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=6.4316460176878493853949400884187e-01L;      _weights[ 9]=1.1668582484776638563534331197891e-02L;
<a name="l00785"></a>00785             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=7.3169797305252320629933948467521e-01L;      _weights[10]=6.1110501102060490412153142922240e-03L;
<a name="l00786"></a>00786             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=8.1192547727500966668969312120195e-01L;      _weights[11]=2.6556629857743191811282114211333e-03L;
<a name="l00787"></a>00787             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=8.8094952871531360238808055493652e-01L;      _weights[12]=8.8657363523409667398227745346013e-04L;
<a name="l00788"></a>00788             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=9.3628182173551874210251937228715e-01L;      _weights[13]=1.9398726306394554934013378631178e-04L;
<a name="l00789"></a>00789             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=9.7595387433502370956200384127912e-01L;      _weights[14]=1.8128785569508725971591601924058e-05L;
<a name="l00790"></a>00790         
<a name="l00791"></a>00791             <span class="keywordflow">return</span>;
<a name="l00792"></a>00792           }
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac64b552bcc7fd10e6a8723de2e2a1250">THIRTIETH</a>:
<a name="l00796"></a>00796         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6812a2218979fea1f20f3cdf06d855a9">THIRTYFIRST</a>:
<a name="l00797"></a>00797           {
<a name="l00798"></a>00798             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (16);
<a name="l00799"></a>00799             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(16);
<a name="l00800"></a>00800 
<a name="l00801"></a>00801             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=4.7276871229345922061506104450645e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.1999405624691969586506695404143e-02L;
<a name="l00802"></a>00802             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.4742967619434984512603456269536e-02L;      _weights[ 1]=2.6460842517339527040437264564557e-02L;
<a name="l00803"></a>00803             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=6.0076437716637992275242255328112e-02L;      _weights[ 2]=3.7685824681918572833315081444311e-02L;
<a name="l00804"></a>00804             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=1.0960060925877060286789758461950e-01L;      _weights[ 3]=4.4496573472543214976151049587710e-02L;
<a name="l00805"></a>00805             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.7172475948300210790307417791270e-01L;      _weights[ 4]=4.6506239397362658797012521100333e-02L;
<a name="l00806"></a>00806             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.4445243174451137730207656160275e-01L;      _weights[ 5]=4.4112657675899371113911374089320e-02L;
<a name="l00807"></a>00807             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=3.2544621002412961482683685190181e-01L;      _weights[ 6]=3.8348046951185955673582690910292e-02L;
<a name="l00808"></a>00808             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=4.1210296411685959691728421362251e-01L;      _weights[ 7]=3.0612037917837609541948834407964e-02L;
<a name="l00809"></a>00809             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=5.0163755615318759370013043235084e-01L;      _weights[ 8]=2.2357185649529930223334734263644e-02L;
<a name="l00810"></a>00810             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=5.9117238531650308897076051877634e-01L;      _weights[ 9]=1.4803776657751738340239250997704e-02L;
<a name="l00811"></a>00811             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=6.7782991741456081130251277264148e-01L;      _weights[10]=8.7475454956120699745801506391282e-03L;
<a name="l00812"></a>00812             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=7.5882525794914141335427940535114e-01L;      _weights[11]=4.4948488514798588832066397608164e-03L;
<a name="l00813"></a>00813             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=8.3155588302646195188920635482406e-01L;      _weights[12]=1.9235319260667742273824398535627e-03L;
<a name="l00814"></a>00814             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=8.9368597454880401881486969876816e-01L;      _weights[13]=6.3445999956883686801084896849641e-04L;
<a name="l00815"></a>00815             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=9.4322428571224559352545066239296e-01L;      _weights[14]=1.3757810397555175246959527906570e-04L;
<a name="l00816"></a>00816             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=9.7860643749869701257280091378128e-01L;      _weights[15]=1.2778410569693501244162062287056e-05L;
<a name="l00817"></a>00817         
<a name="l00818"></a>00818             <span class="keywordflow">return</span>;
<a name="l00819"></a>00819           }
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 
<a name="l00822"></a>00822         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa88a052a9254947f209a5736a2cf49b19">THIRTYSECOND</a>:
<a name="l00823"></a>00823         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa15d72f9acb6abf33bfbd64b4afdb59b4">THIRTYTHIRD</a>:
<a name="l00824"></a>00824           {
<a name="l00825"></a>00825             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (17);
<a name="l00826"></a>00826             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(17);
<a name="l00827"></a>00827 
<a name="l00828"></a>00828             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=4.2297654864907678749919877813007e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=1.0748151030768621662834062204936e-02L;
<a name="l00829"></a>00829             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=2.2152705311830232294209002101573e-02L;      _weights[ 1]=2.3837762018703244620506074665265e-02L;
<a name="l00830"></a>00830             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=5.3856014827184829566760322013645e-02L;      _weights[ 2]=3.4307889795671880028436869439002e-02L;
<a name="l00831"></a>00831             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=9.8434936830541362494246924237098e-02L;      _weights[ 3]=4.1143975847068207121110777965721e-02L;
<a name="l00832"></a>00832             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.5460792826588562987838903880788e-01L;      _weights[ 4]=4.3922618772592577808611328095136e-02L;
<a name="l00833"></a>00833             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.2075922519215138391363787768336e-01L;      _weights[ 5]=4.2825403927934553301439133345126e-02L;
<a name="l00834"></a>00834             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.9498586629802348865100598497056e-01L;      _weights[ 6]=3.8555241947102353628223582107170e-02L;
<a name="l00835"></a>00835             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.7515254164081788200834771392226e-01L;      _weights[ 7]=3.2163570112378639217164962127759e-02L;
<a name="l00836"></a>00836             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=4.5895305335301908085933451474375e-01L;      _weights[ 8]=2.4829256111976082802381065145755e-02L;
<a name="l00837"></a>00837             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=5.4397667809047570974515217435547e-01L;      _weights[ 9]=1.7638789331050110518481458865839e-02L;
<a name="l00838"></a>00838             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=6.2777753854681427256560538094776e-01L;      _weights[10]=1.1413642238636687747573403275566e-02L;
<a name="l00839"></a>00839             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=7.0794500138508556794362242607309e-01L;      _weights[11]=6.6164197603617147286557116199452e-03L;
<a name="l00840"></a>00840             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=7.8217310308122112810113854015572e-01L;      _weights[12]=3.3465172918198153715474254116460e-03L;
<a name="l00841"></a>00841             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=8.4832708570995060757906353137179e-01L;      _weights[13]=1.4138837589561322316624033902623e-03L;
<a name="l00842"></a>00842             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=9.0450542331432870037906100932836e-01L;      _weights[14]=4.6167405877711308077043506706165e-04L;
<a name="l00843"></a>00843             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=9.4909701659654457024654762835657e-01L;      _weights[15]=9.9356525335473959962406835119113e-05L;
<a name="l00844"></a>00844             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.8084389384741256367666372092760e-01L;      _weights[16]=9.1808042001255039722337720228143e-06L;
<a name="l00845"></a>00845         
<a name="l00846"></a>00846             <span class="keywordflow">return</span>;
<a name="l00847"></a>00847           }
<a name="l00848"></a>00848 
<a name="l00849"></a>00849         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa621d865989d4fc3580a8d55ddc63a03a">THIRTYFOURTH</a>:
<a name="l00850"></a>00850         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faa8088f586a6b0baa0a05d6a18361510e">THIRTYFIFTH</a>:
<a name="l00851"></a>00851           {
<a name="l00852"></a>00852             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (18);
<a name="l00853"></a>00853             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(18);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.8065822475018763836485343548908e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=9.6823988037660231774964807691529e-03L;
<a name="l00856"></a>00856             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.9948351047343018666301273550578e-02L;      _weights[ 1]=2.1578772679193827027157750409882e-02L;
<a name="l00857"></a>00857             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=4.8549645304224630965525818224597e-02L;      _weights[ 2]=3.1333907671729513327950397913143e-02L;
<a name="l00858"></a>00858             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=8.8876259116497388048181392194957e-02L;      _weights[ 3]=3.8075134253447687665457823100366e-02L;
<a name="l00859"></a>00859             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.3988457083516926493003835526765e-01L;      _weights[ 4]=4.1377182287519565332651504100178e-02L;
<a name="l00860"></a>00860             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=2.0025369592363033820671255853211e-01L;      _weights[ 5]=4.1283665809957749414286828772884e-02L;
<a name="l00861"></a>00861             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.6842018278660208442014712803618e-01L;      _weights[ 6]=3.8262794672349299757849656256339e-02L;
<a name="l00862"></a>00862             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.4261859780200830045140484446480e-01L;      _weights[ 7]=3.3095976202072497795672769135623e-02L;
<a name="l00863"></a>00863             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=4.2092727587031795580391095608392e-01L;      _weights[ 8]=2.6723424368960119486097972811646e-02L;
<a name="l00864"></a>00864             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=5.0131810275027358836467598537906e-01L;      _weights[ 9]=2.0078641696369720179443819032712e-02L;
<a name="l00865"></a>00865             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=5.8170905267091792822883758529331e-01L;      _weights[10]=1.3943897653647906425703531920973e-02L;
<a name="l00866"></a>00866             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=6.6001812722531554655212340270381e-01L;      _weights[11]=8.8522782250949774435502470347624e-03L;
<a name="l00867"></a>00867             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=7.3421730813501325031921736140253e-01L;      _weights[12]=5.0502487883546813166841235600508e-03L;
<a name="l00868"></a>00868             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=8.0238514983641747020667379058517e-01L;      _weights[13]=2.5207216384362558022745702364513e-03L;
<a name="l00869"></a>00869             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=8.6275672070005501336081662021610e-01L;      _weights[14]=1.0535502839571923712409403476880e-03L;
<a name="l00870"></a>00870             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=9.1376986411079293616612318979159e-01L;      _weights[15]=3.4109120368765498289598525047321e-04L;
<a name="l00871"></a>00871             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.5410789551731665881890309384613e-01L;      _weights[16]=7.2937008664118705328162954331465e-05L;
<a name="l00872"></a>00872             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.8274840759428696063307389954630e-01L;      _weights[17]=6.7100861245431215907697266774769e-06L;
<a name="l00873"></a>00873         
<a name="l00874"></a>00874             <span class="keywordflow">return</span>;
<a name="l00875"></a>00875           }
<a name="l00876"></a>00876 
<a name="l00877"></a>00877         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1c81e8502e0dabbaa5ea9e87b53459bd">THIRTYSIXTH</a>:
<a name="l00878"></a>00878         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa24cbc0dd8da68e1efcf1873487f9904c">THIRTYSEVENTH</a>:
<a name="l00879"></a>00879           {
<a name="l00880"></a>00880             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (19);
<a name="l00881"></a>00881             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(19);
<a name="l00882"></a>00882 
<a name="l00883"></a>00883             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.4438904038624902806940509331722e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=8.7672970568792323661393261305840e-03L;
<a name="l00884"></a>00884             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.8056978337900562863030093954343e-02L;      _weights[ 1]=1.9620856340232434512901283777202e-02L;
<a name="l00885"></a>00885             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=4.3987395090842734455198832773659e-02L;      _weights[ 2]=2.8708149778704086122791006941433e-02L;
<a name="l00886"></a>00886             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=8.0633276366661415469721776663016e-02L;      _weights[ 3]=3.5278117199476000434599584597235e-02L;
<a name="l00887"></a>00887             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.2713640986156026953002535083969e-01L;      _weights[ 4]=3.8922386222261737550985848811514e-02L;
<a name="l00888"></a>00888             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.8240698366909185313069695387128e-01L;      _weights[ 5]=3.9598248214880677015066061570123e-02L;
<a name="l00889"></a>00889             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.4514956909516857055249217701821e-01L;      _weights[ 6]=3.7607500520347543950912173611332e-02L;
<a name="l00890"></a>00890             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=3.1389356741821822415240859865307e-01L;      _weights[ 7]=3.3525068070610283960905700567460e-02L;
<a name="l00891"></a>00891             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.8702770276933220341545290751683e-01L;      _weights[ 8]=2.8091607936102907649141378579235e-02L;
<a name="l00892"></a>00892             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=4.6283779855202027820220487054694e-01L;      _weights[ 9]=2.2090563149823990465333672755377e-02L;
<a name="l00893"></a>00893             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=5.3954696279208808766943066332998e-01L;      _weights[10]=1.6231815321996325630177612472423e-02L;
<a name="l00894"></a>00894             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=6.1535724480454716546694016358337e-01L;      _weights[11]=1.1061440629037007897211784796273e-02L;
<a name="l00895"></a>00895             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=6.8849179091409498918986551203802e-01L;      _weights[12]=6.9108110779321981973514541466546e-03L;
<a name="l00896"></a>00896             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=7.5723651917329793549736932794667e-01L;      _weights[13]=3.8897848125530902102984958782958e-03L;
<a name="l00897"></a>00897             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=8.1998035706323733537954006841029e-01L;      _weights[14]=1.9197884726923132048372710905667e-03L;
<a name="l00898"></a>00898             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=8.7525316298382668006594890887609e-01L;      _weights[15]=7.9504432544855937325482850317179e-04L;
<a name="l00899"></a>00899             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=9.2176068172914004889937421632274e-01L;      _weights[16]=2.5553085889097125647555166013802e-04L;
<a name="l00900"></a>00900             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.5841690242340714510347790926694e-01L;      _weights[17]=5.4342643132004416773622274012570e-05L;
<a name="l00901"></a>00901             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.8438280655170201067612761745569e-01L;      _weights[18]=4.9807023319691181766751703037610e-06L;
<a name="l00902"></a>00902         
<a name="l00903"></a>00903             <span class="keywordflow">return</span>;
<a name="l00904"></a>00904           }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad7b5f8e152598d25c7c161f15221f5be">THIRTYEIGHTH</a>:
<a name="l00907"></a>00907         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7686c65f85c6e3ec25fb1ce492b41e2c">THIRTYNINTH</a>:
<a name="l00908"></a>00908           {
<a name="l00909"></a>00909             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (20);
<a name="l00910"></a>00910             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(20);
<a name="l00911"></a>00911 
<a name="l00912"></a>00912             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=3.1306837407435895621501417495463e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=7.9757927362766516852273101574255e-03L;
<a name="l00913"></a>00913             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.6422088133987832902541614256258e-02L;      _weights[ 1]=1.7913752325738559101773958866323e-02L;
<a name="l00914"></a>00914             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=4.0036900461906780996320149828793e-02L;      _weights[ 2]=2.6382564429125584794513408474046e-02L;
<a name="l00915"></a>00915             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=7.3477191785285283057566545285874e-02L;      _weights[ 3]=3.2734644317573148047479656498988e-02L;
<a name="l00916"></a>00916             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.1603090765548680494669743156748e-01L;      _weights[ 4]=3.6587916553227064986609295576925e-02L;
<a name="l00917"></a>00917             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.6679125348100943001298070145849e-01L;      _weights[ 5]=3.7847390376922340715354694449373e-02L;
<a name="l00918"></a>00918             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.2467641938430503840938196483210e-01L;      _weights[ 6]=3.6697420472018132713254249570653e-02L;
<a name="l00919"></a>00919             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=2.8845271218127238477194070665240e-01L;      _weights[ 7]=3.3556431453475493479002714822739e-02L;
<a name="l00920"></a>00920             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.5676087010245310564705506663326e-01L;      _weights[ 8]=2.9002404745589285169916357261403e-02L;
<a name="l00921"></a>00921             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=4.2814504093325668461542503477245e-01L;      _weights[ 9]=2.3682290414246053980866450266495e-02L;
<a name="l00922"></a>00922             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=5.0108381548284855137062465413693e-01L;      _weights[10]=1.8220503418268691551843315309759e-02L;
<a name="l00923"></a>00923             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=5.7402265818282687172751219665371e-01L;      _weights[11]=1.3140919256661651742108133720781e-02L;
<a name="l00924"></a>00924             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=6.4540704577736756661732083476397e-01L;      _weights[12]=8.8135560782433553289252731679767e-03L;
<a name="l00925"></a>00925             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=7.1371561101528768074208343535393e-01L;      _weights[13]=5.4320908061230274500120111426487e-03L;
<a name="l00926"></a>00926             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=7.7749259203548675355112594583658e-01L;      _weights[14]=3.0224891709073793749184859780611e-03L;
<a name="l00927"></a>00927             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=8.3537891463156172517151839471341e-01L;      _weights[15]=1.4774444419714858062838576456553e-03L;
<a name="l00928"></a>00928             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=8.8614130291454714368728293036495e-01L;      _weights[16]=6.0704570426725825415272373108771e-04L;
<a name="l00929"></a>00929             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=9.2869901491875054534509783716727e-01L;      _weights[17]=1.9388830961751181076983851525948e-04L;
<a name="l00930"></a>00930             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.6214871215049818970916080642292e-01L;      _weights[18]=4.1039102087320205549074040898061e-05L;
<a name="l00931"></a>00931             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[19](0)=9.8579578884064184668002313135922e-01L;      _weights[19]=3.7492209933371347725241368372638e-06L;
<a name="l00932"></a>00932         
<a name="l00933"></a>00933             <span class="keywordflow">return</span>;
<a name="l00934"></a>00934           }
<a name="l00935"></a>00935 
<a name="l00936"></a>00936 
<a name="l00937"></a>00937         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0b2b50be416b002ce458061fe2d7506a">FORTIETH</a>:
<a name="l00938"></a>00938         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faae7b8a6cf8f301aa024087e7f371a81c">FORTYFIRST</a>:
<a name="l00939"></a>00939           {
<a name="l00940"></a>00940             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (21);
<a name="l00941"></a>00941             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(21);
<a name="l00942"></a>00942 
<a name="l00943"></a>00943             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.8583506000918943222556277168267e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=7.2866317313744308995629793584932e-03L;
<a name="l00944"></a>00944             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.4999364972075522340357135916023e-02L;      _weights[ 1]=1.6417061144242818824757454238052e-02L;
<a name="l00945"></a>00945             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.6593863281140122626545055282186e-02L;      _weights[ 2]=2.4316074956305588348553255406534e-02L;
<a name="l00946"></a>00946             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=6.7226441667938638526563947674675e-02L;      _weights[ 3]=3.0423854654878694196479542521305e-02L;
<a name="l00947"></a>00947             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=1.0630147973769311755044868847393e-01L;      _weights[ 4]=3.4388553550627421941340376509459e-02L;
<a name="l00948"></a>00948             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.5305857495571921224970195300963e-01L;      _weights[ 5]=3.6085277384893044986268336555960e-02L;
<a name="l00949"></a>00949             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=2.0658770608253356867698033417515e-01L;      _weights[ 6]=3.5615944774693119613624648820995e-02L;
<a name="l00950"></a>00950             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=2.6584701401081590981089215154372e-01L;      _weights[ 7]=3.3281046762833346236473134492600e-02L;
<a name="l00951"></a>00951             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.2968309899010272373734914205452e-01L;      _weights[ 8]=2.9528072702082493907799384765866e-02L;
<a name="l00952"></a>00952             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=3.9685347698561900950394342909483e-01L;      _weights[ 9]=2.4885083875255978309567929915161e-02L;
<a name="l00953"></a>00953             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=4.6605076663517464847296649003812e-01L;      _weights[10]=1.9889780066352815019424534213776e-02L;
<a name="l00954"></a>00954             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=5.3592813869303216093268951839176e-01L;      _weights[11]=1.5024528041917190276613254752701e-02L;
<a name="l00955"></a>00955             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=6.0512553397610192844810985230774e-01L;      _weights[12]=1.0666270365508680718786852036243e-02L;
<a name="l00956"></a>00956             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=6.7229614098692961628997049948121e-01L;      _weights[13]=7.0573209743621604363614669672455e-03L;
<a name="l00957"></a>00957             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=7.3613262059728734846410297670221e-01L;      _weights[14]=4.2993100642134152210363702100934e-03L;
<a name="l00958"></a>00958             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=7.9539257374613146232498650332774e-01L;      _weights[15]=2.3686215346115318974092271035074e-03L;
<a name="l00959"></a>00959             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=8.4892277353768883984401746895126e-01L;      _weights[16]=1.1482414207164748272703814817286e-03L;
<a name="l00960"></a>00960             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=8.9568174292546676052820257429765e-01L;      _weights[17]=4.6857361253397420043294612589344e-04L;
<a name="l00961"></a>00961             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.3476043640122994798279429359660e-01L;      _weights[18]=1.4884999898655056859287865070751e-04L;
<a name="l00962"></a>00962             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[19](0)=9.6540160736574245809294907904429e-01L;      _weights[19]=3.1377233396792732027953172274463e-05L;
<a name="l00963"></a>00963             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[20](0)=9.8702556657875783654690055164718e-01L;      _weights[20]=2.8584835468101709504260347382715e-06L;
<a name="l00964"></a>00964         
<a name="l00965"></a>00965             <span class="keywordflow">return</span>;
<a name="l00966"></a>00966           }
<a name="l00967"></a>00967 
<a name="l00968"></a>00968         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faf1ea9fc7d47660c23ff7ff4c0ffae985">FORTYSECOND</a>:
<a name="l00969"></a>00969         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5536e362ffba6fc36737d12d56016794">FORTYTHIRD</a>:
<a name="l00970"></a>00970           {
<a name="l00971"></a>00971             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (22);
<a name="l00972"></a>00972             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(22);
<a name="l00973"></a>00973 
<a name="l00974"></a>00974             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0)=2.6200747203711594248593674552649e-03L;      <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]=6.6829315239216368796332393406135e-03L;
<a name="l00975"></a>00975             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0)=1.3753657987385804025756750709059e-02L;      _weights[ 1]=1.5098062421623821319493004238262e-02L;
<a name="l00976"></a>00976             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0)=3.3575226848026692714308191640158e-02L;      _weights[ 2]=2.2473713734526648003280648297671e-02L;
<a name="l00977"></a>00977             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0)=6.1735561623069601690826574395308e-02L;      _weights[ 3]=2.8324458025288763364233486167273e-02L;
<a name="l00978"></a>00978             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0)=9.7732696675368642458479884996723e-02L;      _weights[ 4]=3.2329473952869436965326587507885e-02L;
<a name="l00979"></a>00979             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0)=1.4092439775695158519450619775816e-01L;      _weights[ 5]=3.4348599664417779736425965942178e-02L;
<a name="l00980"></a>00980             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0)=1.9053995518421662849913969152881e-01L;      _weights[ 6]=3.4426309828130701949676126316990e-02L;
<a name="l00981"></a>00981             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0)=2.4569399962450332222446519900435e-01L;      _weights[ 7]=3.2774586900497126738748991342107e-02L;
<a name="l00982"></a>00982             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0)=3.0540231844259902315260853518244e-01L;      _weights[ 8]=2.9737336628427308246400548097974e-02L;
<a name="l00983"></a>00983             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0)=3.6859942495594128250321664201293e-01L;      _weights[ 9]=2.5741821234796918381507016798653e-02L;
<a name="l00984"></a>00984             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0)=4.3415757484015513750820121247106e-01L;      _weights[10]=2.1244167813524304464862872202199e-02L;
<a name="l00985"></a>00985             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11](0)=5.0090689264793505011775015892772e-01L;      _weights[11]=1.6676482379699419616981906191727e-02L;
<a name="l00986"></a>00986             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[12](0)=5.6765625027260978702177266771788e-01L;      _weights[12]=1.2402453510959574984251948178874e-02L;
<a name="l00987"></a>00987             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[13](0)=6.3321452557266284279166256182373e-01L;      _weights[13]=8.6866984738749141556196547655377e-03L;
<a name="l00988"></a>00988             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[14](0)=6.9641186298595172661126707689713e-01L;      _weights[14]=5.6807683849250404394970034550940e-03L;
<a name="l00989"></a>00989             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[15](0)=7.5612055917893487122928793527786e-01L;      _weights[15]=3.4260685209698087638377353482425e-03L;
<a name="l00990"></a>00990             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[16](0)=8.1127520683922050787811864631196e-01L;      _weights[16]=1.8713879532585689543042377871244e-03L;
<a name="l00991"></a>00991             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[17](0)=8.6089175276286621730656128908876e-01L;      _weights[17]=9.0066625279251987400261357834378e-04L;
<a name="l00992"></a>00992             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[18](0)=9.0408517849775272066170136431884e-01L;      _weights[18]=3.6536328467284676654467859219800e-04L;
<a name="l00993"></a>00993             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[19](0)=9.4008566921081846961603077466108e-01L;      _weights[19]=1.1551470917602499323205530447797e-04L;
<a name="l00994"></a>00994             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[20](0)=9.6825388381656365288164210087944e-01L;      _weights[20]=2.4263177919766775694554800111547e-05L;
<a name="l00995"></a>00995             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[21](0)=9.8810245999087788318348935085438e-01L;      _weights[21]=2.2049570604019597784590797971169e-06L;
<a name="l00996"></a>00996         
<a name="l00997"></a>00997             <span class="keywordflow">return</span>;
<a name="l00998"></a>00998           }
<a name="l00999"></a>00999 
<a name="l01000"></a>01000       
<a name="l01001"></a>01001         <span class="keywordflow">default</span>:
<a name="l01002"></a>01002           {
<a name="l01003"></a>01003             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Quadrature rule &quot;</span> &lt;&lt; _order
<a name="l01004"></a>01004                           &lt;&lt; <span class="stringliteral">&quot; not supported!&quot;</span> &lt;&lt; std::endl;
<a name="l01005"></a>01005               
<a name="l01006"></a>01006             libmesh_error();
<a name="l01007"></a>01007           }
<a name="l01008"></a>01008         } <span class="comment">// end switch(_order + 2*p)</span>
<a name="l01009"></a>01009 
<a name="l01010"></a>01010       libmesh_error();
<a name="l01011"></a>01011     } <span class="comment">// end else if ((_alpha == 2) &amp;&amp; (_beta == 0))</span>
<a name="l01012"></a>01012 
<a name="l01013"></a>01013   <span class="keywordflow">else</span>
<a name="l01014"></a>01014     {
<a name="l01015"></a>01015       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Unsupported combination of (alpha,beta) = (&quot;</span>
<a name="l01016"></a>01016                     &lt;&lt; <a class="code" href="classlibMesh_1_1QJacobi.php#a432af4bebde14ac394e948ca585cadcd">_alpha</a>
<a name="l01017"></a>01017                     &lt;&lt; <span class="stringliteral">&quot;,&quot;</span>
<a name="l01018"></a>01018                     &lt;&lt; <a class="code" href="classlibMesh_1_1QJacobi.php#a812ed1eb1a7681cf7cc7dad1223ed668">_beta</a>
<a name="l01019"></a>01019                     &lt;&lt; <span class="stringliteral">&quot;) requested in Jacobi-Gauss quadrature rule.&quot;</span>
<a name="l01020"></a>01020                     &lt;&lt; std::endl;
<a name="l01021"></a>01021     }
<a name="l01022"></a>01022 
<a name="l01023"></a>01023   
<a name="l01024"></a>01024   <span class="keywordflow">return</span>;
<a name="l01025"></a>01025 }
<a name="l01026"></a>01026 
<a name="l01027"></a>01027 } <span class="comment">// namespace libMesh</span>
<a name="l01028"></a>01028  
<a name="l01029"></a>01029 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
