<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">system_io.C</div>  </div>
</div>
<div class="contents">
<a href="system__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: system_io.C 4366 2011-04-19 20:16:35Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstdio&gt;</span> <span class="comment">// for std::sprintf</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="comment">//#include &quot;mesh_tools.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Anonymous namespace for implementation details.</span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>{
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="keyword">using</span> <a class="code" href="classlibMesh_1_1DofObject.php">libMesh::DofObject</a>;
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   <span class="comment">// Comments:</span>
<a name="l00045"></a>00045   <span class="comment">// ---------</span>
<a name="l00046"></a>00046   <span class="comment">// - The io_blksize governs how many nodes or elements will be treated as a single block</span>
<a name="l00047"></a>00047   <span class="comment">//   when performing parallel IO.</span>
<a name="l00048"></a>00048   <span class="comment">// - This parameter only loosely affects the size of the actual IO buffer as this depends</span>
<a name="l00049"></a>00049   <span class="comment">//   on the number of components a given variable has for the nodes/elements in the block.</span>
<a name="l00050"></a>00050   <span class="comment">// - When reading/writing each processor uses an ID map which is 3*io_blksize*sizeof(unsigned int) bytes</span>
<a name="l00051"></a>00051   <span class="comment">//   long, so if io_blksize=256000 we would expect that buffer alone to be ~3Mb.</span>
<a name="l00052"></a>00052   <span class="comment">// - In general, an increase in io_blksize should increase the efficiency of the parallel</span>
<a name="l00053"></a>00053   <span class="comment">//   read/writes by reducing the number of MPI messages at the expense of memory.</span>
<a name="l00054"></a>00054   <span class="comment">// - If the library exhausts memory during IO you might reduce this parameter.</span>
<a name="l00055"></a>00055   
<a name="l00056"></a>00056   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> io_blksize = 256000;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00064"></a>00064   <span class="keyword">struct </span>CompareDofObjectsByID
<a name="l00065"></a>00065   {
<a name="l00066"></a>00066     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> DofObject *a,
<a name="l00067"></a>00067                     <span class="keyword">const</span> DofObject *b)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword">    </span>{
<a name="l00069"></a>00069       libmesh_assert (a);
<a name="l00070"></a>00070       libmesh_assert (b);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       <span class="keywordflow">return</span> a-&gt;id() &lt; b-&gt;id();
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074   };
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="keyword">namespace </span>libMesh
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00083"></a>00083 <span class="comment">// System class implementation</span>
<a name="l00084"></a><a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">00084</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a80a2d705f01a0e18de74e02ccf43bb83">System::read_header</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00085"></a>00085                           <span class="keyword">const</span> std::string &amp;version,
<a name="l00086"></a>00086                           <span class="keyword">const</span> <span class="keywordtype">bool</span> read_header,
<a name="l00087"></a>00087                           <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data,
<a name="l00088"></a>00088                           <span class="keyword">const</span> <span class="keywordtype">bool</span> read_legacy_format)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <span class="comment">// This method implements the input of a</span>
<a name="l00091"></a>00091   <span class="comment">// System object, embedded in the output of</span>
<a name="l00092"></a>00092   <span class="comment">// an EquationSystems&lt;T_sys&gt;.  This warrants some </span>
<a name="l00093"></a>00093   <span class="comment">// documentation.  The output file essentially</span>
<a name="l00094"></a>00094   <span class="comment">// consists of 5 sections:</span>
<a name="l00095"></a>00095   <span class="comment">//</span>
<a name="l00096"></a>00096   <span class="comment">// for this system</span>
<a name="l00097"></a>00097   <span class="comment">//</span>
<a name="l00098"></a>00098   <span class="comment">//   5.) The number of variables in the system (unsigned int)</span>
<a name="l00099"></a>00099   <span class="comment">//</span>
<a name="l00100"></a>00100   <span class="comment">//   for each variable in the system</span>
<a name="l00101"></a>00101   <span class="comment">//     </span>
<a name="l00102"></a>00102   <span class="comment">//     6.) The name of the variable (string)</span>
<a name="l00103"></a>00103   <span class="comment">//     </span>
<a name="l00104"></a>00104   <span class="comment">//     7.) Combined in an FEType:</span>
<a name="l00105"></a>00105   <span class="comment">//         - The approximation order(s) of the variable </span>
<a name="l00106"></a>00106   <span class="comment">//           (Order Enum, cast to int/s)</span>
<a name="l00107"></a>00107   <span class="comment">//         - The finite element family/ies of the variable </span>
<a name="l00108"></a>00108   <span class="comment">//           (FEFamily Enum, cast to int/s)</span>
<a name="l00109"></a>00109   <span class="comment">// </span>
<a name="l00110"></a>00110   <span class="comment">//   end variable loop</span>
<a name="l00111"></a>00111   <span class="comment">//</span>
<a name="l00112"></a>00112   <span class="comment">//   8.) The number of additional vectors (unsigned int),      </span>
<a name="l00113"></a>00113   <span class="comment">//</span>
<a name="l00114"></a>00114   <span class="comment">//     for each additional vector in the system object</span>
<a name="l00115"></a>00115   <span class="comment">// </span>
<a name="l00116"></a>00116   <span class="comment">//     9.) the name of the additional vector  (string)</span>
<a name="l00117"></a>00117   <span class="comment">//</span>
<a name="l00118"></a>00118   <span class="comment">// end system</span>
<a name="l00119"></a>00119   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>());
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">// Possibly clear data structures and start from scratch.</span>
<a name="l00122"></a>00122   <span class="keywordflow">if</span> (read_header)
<a name="l00123"></a>00123     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">clear</a> ();
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="comment">// Figure out if we need to read infinite element information.</span>
<a name="l00126"></a>00126   <span class="comment">// This will be true if the version string contains &quot; with infinite elements&quot;</span>
<a name="l00127"></a>00127   <span class="keyword">const</span> <span class="keywordtype">bool</span> read_ifem_info =
<a name="l00128"></a>00128     (version.rfind(<span class="stringliteral">&quot; with infinite elements&quot;</span>) &lt; version.size()) ||
<a name="l00129"></a>00129     <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">libMesh::on_command_line</a> (<span class="stringliteral">&quot;--read_ifem_systems&quot;</span>);
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   {
<a name="l00133"></a>00133     <span class="comment">// 5.) </span>
<a name="l00134"></a>00134     <span class="comment">// Read the number of variables in the system</span>
<a name="l00135"></a>00135     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>=0;
<a name="l00136"></a>00136     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_vars);
<a name="l00137"></a>00137     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(n_vars);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139     <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>.clear();
<a name="l00140"></a>00140     <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>.resize(n_vars, 0);
<a name="l00141"></a>00141       
<a name="l00142"></a>00142     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; var++)
<a name="l00143"></a>00143       {             
<a name="l00144"></a>00144         <span class="comment">// 6.)</span>
<a name="l00145"></a>00145         <span class="comment">// Read the name of the var-th variable</span>
<a name="l00146"></a>00146         std::string var_name;     
<a name="l00147"></a>00147         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (var_name);
<a name="l00148"></a>00148         <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(var_name);
<a name="l00149"></a>00149                 
<a name="l00150"></a>00150         <span class="comment">// 7.)</span>
<a name="l00151"></a>00151         <span class="comment">// Read the approximation order(s) of the var-th variable </span>
<a name="l00152"></a>00152         <span class="keywordtype">int</span> order=0;      
<a name="l00153"></a>00153         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (order);
<a name="l00154"></a>00154         <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(order);
<a name="l00155"></a>00155         
<a name="l00156"></a>00156         
<a name="l00157"></a>00157         <span class="comment">// do the same for infinite element radial_order </span>
<a name="l00158"></a>00158         <span class="keywordtype">int</span> rad_order=0;
<a name="l00159"></a>00159         <span class="keywordflow">if</span> (read_ifem_info)
<a name="l00160"></a>00160           {
<a name="l00161"></a>00161             <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(rad_order);
<a name="l00162"></a>00162             <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(rad_order);
<a name="l00163"></a>00163           }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="comment">// Read the finite element type of the var-th variable </span>
<a name="l00167"></a>00167         <span class="keywordtype">int</span> fam=0;
<a name="l00168"></a>00168         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (fam);
<a name="l00169"></a>00169         <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(fam);
<a name="l00170"></a>00170         <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> type;
<a name="l00171"></a>00171         type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>  = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order);
<a name="l00172"></a>00172         type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a><span class="keyword">&gt;</span>(fam);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <span class="comment">// Check for incompatibilities.  The shape function indexing was</span>
<a name="l00175"></a>00175         <span class="comment">// changed for the monomial and xyz finite element families to </span>
<a name="l00176"></a>00176         <span class="comment">// simplify extension to arbitrary p.  The consequence is that </span>
<a name="l00177"></a>00177         <span class="comment">// old restart files will not be read correctly.  This is expected</span>
<a name="l00178"></a>00178         <span class="comment">// to be an unlikely occurance, but catch it anyway.</span>
<a name="l00179"></a>00179         <span class="keywordflow">if</span> (read_legacy_format)
<a name="l00180"></a>00180           <span class="keywordflow">if</span> ((type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a> || type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>) &amp;&amp; 
<a name="l00181"></a>00181               ((type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> &gt; 2 &amp;&amp; this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() == 2) ||
<a name="l00182"></a>00182                (type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> &gt; 1 &amp;&amp; this-&gt;get_mesh().mesh_dimension() == 3)))
<a name="l00183"></a>00183             {
<a name="l00184"></a>00184               libmesh_here();
<a name="l00185"></a>00185               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;*****************************************************************\n&quot;</span>
<a name="l00186"></a>00186                             &lt;&lt; <span class="stringliteral">&quot;* WARNING: reading a potentially incompatible restart file!!!   *\n&quot;</span>
<a name="l00187"></a>00187                             &lt;&lt; <span class="stringliteral">&quot;*  contact libmesh-users@lists.sourceforge.net for more details *\n&quot;</span>
<a name="l00188"></a>00188                             &lt;&lt; <span class="stringliteral">&quot;*****************************************************************&quot;</span>
<a name="l00189"></a>00189                             &lt;&lt; std::endl;
<a name="l00190"></a>00190             }
<a name="l00191"></a>00191                         
<a name="l00192"></a>00192         <span class="comment">// Read additional information for infinite elements    </span>
<a name="l00193"></a>00193         <span class="keywordtype">int</span> radial_fam=0;
<a name="l00194"></a>00194         <span class="keywordtype">int</span> i_map=0;
<a name="l00195"></a>00195         <span class="keywordflow">if</span> (read_ifem_info)
<a name="l00196"></a>00196           {
<a name="l00197"></a>00197             <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (radial_fam);
<a name="l00198"></a>00198             <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(radial_fam);
<a name="l00199"></a>00199             <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (i_map);
<a name="l00200"></a>00200             <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(i_map);
<a name="l00201"></a>00201           }
<a name="l00202"></a>00202         
<a name="l00203"></a>00203 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>        
<a name="l00205"></a>00205         type.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>  = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(rad_order);
<a name="l00206"></a>00206         type.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a><span class="keyword">&gt;</span>(radial_fam);
<a name="l00207"></a>00207         type.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>       = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7">InfMapType</a><span class="keyword">&gt;</span>(i_map);      
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="preprocessor">#endif</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211         <span class="keywordflow">if</span> (read_header) 
<a name="l00212"></a>00212           <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[var] = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a> (var_name, type);
<a name="l00213"></a>00213         <span class="keywordflow">else</span>
<a name="l00214"></a>00214           <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[var] = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(var_name);
<a name="l00215"></a>00215       }
<a name="l00216"></a>00216   }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="comment">// 8.)  </span>
<a name="l00219"></a>00219   <span class="comment">// Read the number of additional vectors.  </span>
<a name="l00220"></a>00220   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>=0;  
<a name="l00221"></a>00221   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_vectors);
<a name="l00222"></a>00222   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(n_vectors);
<a name="l00223"></a>00223   
<a name="l00224"></a>00224   <span class="comment">// If n_vectors &gt; 0, this means that write_additional_data</span>
<a name="l00225"></a>00225   <span class="comment">// was true when this file was written.  We will need to</span>
<a name="l00226"></a>00226   <span class="comment">// make use of this fact later.</span>
<a name="l00227"></a>00227   <span class="keywordflow">if</span> (n_vectors &gt; 0)
<a name="l00228"></a>00228     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a35519cd3073b5cdc687b8ca7ee60af98">_additional_data_written</a> = <span class="keyword">true</span>;  
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec=0; vec&lt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>; vec++)
<a name="l00231"></a>00231     {
<a name="l00232"></a>00232       <span class="comment">// 9.)</span>
<a name="l00233"></a>00233       <span class="comment">// Read the name of the vec-th additional vector</span>
<a name="l00234"></a>00234       std::string vec_name;      
<a name="l00235"></a>00235       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (vec_name);
<a name="l00236"></a>00236       <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(vec_name);
<a name="l00237"></a>00237       
<a name="l00238"></a>00238       <span class="keywordflow">if</span> (read_additional_data)
<a name="l00239"></a>00239         {
<a name="l00240"></a>00240           <span class="comment">// Systems now can handle adding post-initialization vectors</span>
<a name="l00241"></a>00241 <span class="comment">//        libmesh_assert(this-&gt;_can_add_vectors);</span>
<a name="l00242"></a>00242           <span class="comment">// Some systems may have added their own vectors already</span>
<a name="l00243"></a>00243 <span class="comment">//        libmesh_assert(this-&gt;_vectors.count(vec_name) == 0);</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245           this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(vec_name);
<a name="l00246"></a>00246         }
<a name="l00247"></a>00247     }
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a><a class="code" href="classlibMesh_1_1System.php#a01d9de7172eb9ae886bbcba4aa3f9a2a">00252</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a01d9de7172eb9ae886bbcba4aa3f9a2a">System::read_legacy_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00253"></a>00253                                <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data)
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255   libmesh_deprecated();
<a name="l00256"></a>00256   
<a name="l00257"></a>00257   <span class="comment">// This method implements the output of the vectors</span>
<a name="l00258"></a>00258   <span class="comment">// contained in this System object, embedded in the </span>
<a name="l00259"></a>00259   <span class="comment">// output of an EquationSystems&lt;T_sys&gt;. </span>
<a name="l00260"></a>00260   <span class="comment">//</span>
<a name="l00261"></a>00261   <span class="comment">//   10.) The global solution vector, re-ordered to be node-major </span>
<a name="l00262"></a>00262   <span class="comment">//       (More on this later.)                                    </span>
<a name="l00263"></a>00263   <span class="comment">//                                                                </span>
<a name="l00264"></a>00264   <span class="comment">//      for each additional vector in the object          </span>
<a name="l00265"></a>00265   <span class="comment">//                                                                </span>
<a name="l00266"></a>00266   <span class="comment">//      11.) The global additional vector, re-ordered to be       </span>
<a name="l00267"></a>00267   <span class="comment">//           node-major (More on this later.)</span>
<a name="l00268"></a>00268   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>());
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// read and reordering buffers</span>
<a name="l00271"></a>00271   std::vector&lt;Number&gt; global_vector;
<a name="l00272"></a>00272   std::vector&lt;Number&gt; reordered_vector;
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// 10.)</span>
<a name="l00275"></a>00275   <span class="comment">// Read and set the solution vector</span>
<a name="l00276"></a>00276   {     
<a name="l00277"></a>00277     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (global_vector);    
<a name="l00278"></a>00278     <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(global_vector);
<a name="l00279"></a>00279     
<a name="l00280"></a>00280     <span class="comment">// Remember that the stored vector is node-major.</span>
<a name="l00281"></a>00281     <span class="comment">// We need to put it into whatever application-specific</span>
<a name="l00282"></a>00282     <span class="comment">// ordering we may have using the dof_map.</span>
<a name="l00283"></a>00283     reordered_vector.resize(global_vector.size());
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     <span class="comment">//libMesh::out &lt;&lt; &quot;global_vector.size()=&quot; &lt;&lt; global_vector.size() &lt;&lt; std::endl;</span>
<a name="l00286"></a>00286     <span class="comment">//libMesh::out &lt;&lt; &quot;this-&gt;n_dofs()=&quot; &lt;&lt; this-&gt;n_dofs() &lt;&lt; std::endl;</span>
<a name="l00287"></a>00287     
<a name="l00288"></a>00288     libmesh_assert (global_vector.size() == this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>());
<a name="l00289"></a>00289         
<a name="l00290"></a>00290     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys     = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l00293"></a>00293     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>.size();
<a name="l00294"></a>00294     libmesh_assert(n_vars &lt;= this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00297"></a>00297       { 
<a name="l00298"></a>00298         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00299"></a>00299 
<a name="l00300"></a>00300         <span class="comment">// First reorder the nodal DOF values</span>
<a name="l00301"></a>00301         {
<a name="l00302"></a>00302           <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>
<a name="l00303"></a>00303             it  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(),
<a name="l00304"></a>00304             end = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00305"></a>00305         
<a name="l00306"></a>00306           <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00307"></a>00307             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;(*it)-&gt;n_comp(sys,var); index++)
<a name="l00308"></a>00308               {
<a name="l00309"></a>00309                 libmesh_assert ((*it)-&gt;dof_number(sys, var, index) !=
<a name="l00310"></a>00310                         <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00311"></a>00311                 
<a name="l00312"></a>00312                 libmesh_assert (cnt &lt; global_vector.size());
<a name="l00313"></a>00313                 
<a name="l00314"></a>00314                 reordered_vector[(*it)-&gt;dof_number(sys, var, index)] =
<a name="l00315"></a>00315                   global_vector[cnt++]; 
<a name="l00316"></a>00316               }
<a name="l00317"></a>00317         }
<a name="l00318"></a>00318         
<a name="l00319"></a>00319         <span class="comment">// Then reorder the element DOF values</span>
<a name="l00320"></a>00320         {
<a name="l00321"></a>00321           <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>
<a name="l00322"></a>00322             it  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(),
<a name="l00323"></a>00323             end = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00324"></a>00324 
<a name="l00325"></a>00325           <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00326"></a>00326             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;(*it)-&gt;n_comp(sys,var); index++)
<a name="l00327"></a>00327               {  
<a name="l00328"></a>00328                 libmesh_assert ((*it)-&gt;dof_number(sys, var, index) !=
<a name="l00329"></a>00329                         <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00330"></a>00330                 
<a name="l00331"></a>00331                 libmesh_assert (cnt &lt; global_vector.size());
<a name="l00332"></a>00332                 
<a name="l00333"></a>00333                 reordered_vector[(*it)-&gt;dof_number(sys, var, index)] =
<a name="l00334"></a>00334                   global_vector[cnt++]; 
<a name="l00335"></a>00335               }
<a name="l00336"></a>00336         }
<a name="l00337"></a>00337       }
<a name="l00338"></a>00338             
<a name="l00339"></a>00339     *(this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>) = reordered_vector;
<a name="l00340"></a>00340   }
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   <span class="comment">// For each additional vector, simply go through the list.</span>
<a name="l00343"></a>00343   <span class="comment">// ONLY attempt to do this IF additional data was actually</span>
<a name="l00344"></a>00344   <span class="comment">// written to the file for this system (controlled by the</span>
<a name="l00345"></a>00345   <span class="comment">// _additional_data_written flag).  </span>
<a name="l00346"></a>00346   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a35519cd3073b5cdc687b8ca7ee60af98">_additional_data_written</a>)
<a name="l00347"></a>00347     {
<a name="l00348"></a>00348       std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>
<a name="l00349"></a>00349         pos = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l00350"></a>00350   
<a name="l00351"></a>00351       <span class="keywordflow">for</span> (; pos != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00352"></a>00352         {
<a name="l00353"></a>00353           <span class="comment">// 11.)          </span>
<a name="l00354"></a>00354           <span class="comment">// Read the values of the vec-th additional vector.</span>
<a name="l00355"></a>00355           <span class="comment">// Prior do _not_ clear, but fill with zero, since the</span>
<a name="l00356"></a>00356           <span class="comment">// additional vectors _have_ to have the same size</span>
<a name="l00357"></a>00357           <span class="comment">// as the solution vector</span>
<a name="l00358"></a>00358           std::fill (global_vector.begin(), global_vector.end(), <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (global_vector);
<a name="l00361"></a>00361           <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(global_vector);
<a name="l00362"></a>00362 
<a name="l00363"></a>00363           <span class="comment">// If read_additional_data==true, then we will keep this vector, otherwise</span>
<a name="l00364"></a>00364           <span class="comment">// we are going to throw it away.</span>
<a name="l00365"></a>00365           <span class="keywordflow">if</span> (read_additional_data)
<a name="l00366"></a>00366             {
<a name="l00367"></a>00367               <span class="comment">// Remember that the stored vector is node-major.</span>
<a name="l00368"></a>00368               <span class="comment">// We need to put it into whatever application-specific</span>
<a name="l00369"></a>00369               <span class="comment">// ordering we may have using the dof_map.</span>
<a name="l00370"></a>00370               std::fill (reordered_vector.begin(),
<a name="l00371"></a>00371                          reordered_vector.end(),
<a name="l00372"></a>00372                          <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00373"></a>00373         
<a name="l00374"></a>00374               reordered_vector.resize(global_vector.size());    
<a name="l00375"></a>00375 
<a name="l00376"></a>00376               libmesh_assert (global_vector.size() == this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>());
<a name="l00377"></a>00377         
<a name="l00378"></a>00378               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00379"></a>00379 
<a name="l00380"></a>00380               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys     = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l00381"></a>00381               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>.size();
<a name="l00382"></a>00382               libmesh_assert(n_vars &lt;= this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00383"></a>00383         
<a name="l00384"></a>00384               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00385"></a>00385                 {       
<a name="l00386"></a>00386                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00387"></a>00387                   <span class="comment">// First reorder the nodal DOF values</span>
<a name="l00388"></a>00388                   {
<a name="l00389"></a>00389                     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>
<a name="l00390"></a>00390                       it  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(),
<a name="l00391"></a>00391                       end = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00392"></a>00392 
<a name="l00393"></a>00393                     <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00394"></a>00394                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;(*it)-&gt;n_comp(sys,var); index++)
<a name="l00395"></a>00395                         {
<a name="l00396"></a>00396                           libmesh_assert ((*it)-&gt;dof_number(sys, var, index) !=
<a name="l00397"></a>00397                                   <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00398"></a>00398                           
<a name="l00399"></a>00399                           libmesh_assert (cnt &lt; global_vector.size());
<a name="l00400"></a>00400                           
<a name="l00401"></a>00401                           reordered_vector[(*it)-&gt;dof_number(sys, var, index)] =
<a name="l00402"></a>00402                             global_vector[cnt++]; 
<a name="l00403"></a>00403                         }
<a name="l00404"></a>00404                   }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406                   <span class="comment">// Then reorder the element DOF values</span>
<a name="l00407"></a>00407                   {
<a name="l00408"></a>00408                     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>
<a name="l00409"></a>00409                       it  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(),
<a name="l00410"></a>00410                       end = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00411"></a>00411 
<a name="l00412"></a>00412                     <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00413"></a>00413                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index&lt;(*it)-&gt;n_comp(sys,var); index++)
<a name="l00414"></a>00414                         {  
<a name="l00415"></a>00415                           libmesh_assert ((*it)-&gt;dof_number(sys, var, index) !=
<a name="l00416"></a>00416                                   <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00417"></a>00417                           
<a name="l00418"></a>00418                           libmesh_assert (cnt &lt; global_vector.size());
<a name="l00419"></a>00419                           
<a name="l00420"></a>00420                           reordered_vector[(*it)-&gt;dof_number(sys, var, index)] =
<a name="l00421"></a>00421                             global_vector[cnt++]; 
<a name="l00422"></a>00422                         }
<a name="l00423"></a>00423                   }
<a name="l00424"></a>00424                 }
<a name="l00425"></a>00425             
<a name="l00426"></a>00426               <span class="comment">// use the overloaded operator=(std::vector) to assign the values</span>
<a name="l00427"></a>00427               *(pos-&gt;second) = reordered_vector;
<a name="l00428"></a>00428             }
<a name="l00429"></a>00429         }
<a name="l00430"></a>00430     } <span class="comment">// end if (_additional_data_written)    </span>
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a><a class="code" href="classlibMesh_1_1System.php#a13f952c98690727e4168a8b03918f008">00435</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a13f952c98690727e4168a8b03918f008">System::read_parallel_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00436"></a>00436                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data)
<a name="l00437"></a>00437 {
<a name="l00457"></a>00457   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>());
<a name="l00458"></a>00458   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#a065c4f3b76dccf8e30cd735d78394c64">is_open</a>());
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="comment">// build the ordered nodes and element maps.</span>
<a name="l00461"></a>00461   <span class="comment">// when writing/reading parallel files we need to iterate</span>
<a name="l00462"></a>00462   <span class="comment">// over our nodes/elements in order of increasing global id().</span>
<a name="l00463"></a>00463   <span class="comment">// however, this is not guaranteed to be ordering we obtain</span>
<a name="l00464"></a>00464   <span class="comment">// by using the node_iterators/element_iterators directly.</span>
<a name="l00465"></a>00465   <span class="comment">// so build a set, sorted by id(), that provides the ordering.</span>
<a name="l00466"></a>00466   <span class="comment">// further, for memory economy build the set but then transfer</span>
<a name="l00467"></a>00467   <span class="comment">// its contents to vectors, which will be sorted.</span>
<a name="l00468"></a>00468   std::vector&lt;const DofObject*&gt; ordered_nodes, ordered_elements;
<a name="l00469"></a>00469   {    
<a name="l00470"></a>00470     std::set&lt;const DofObject*, CompareDofObjectsByID&gt;
<a name="l00471"></a>00471       ordered_nodes_set (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_begin(),
<a name="l00472"></a>00472                          this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_end());
<a name="l00473"></a>00473       
<a name="l00474"></a>00474       ordered_nodes.insert(ordered_nodes.end(),
<a name="l00475"></a>00475                            ordered_nodes_set.begin(),
<a name="l00476"></a>00476                            ordered_nodes_set.end());
<a name="l00477"></a>00477   }
<a name="l00478"></a>00478   {
<a name="l00479"></a>00479     std::set&lt;const DofObject*, CompareDofObjectsByID&gt;
<a name="l00480"></a>00480       ordered_elements_set (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_begin(),
<a name="l00481"></a>00481                             this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_end());
<a name="l00482"></a>00482       
<a name="l00483"></a>00483       ordered_elements.insert(ordered_elements.end(),
<a name="l00484"></a>00484                               ordered_elements_set.begin(),
<a name="l00485"></a>00485                               ordered_elements_set.end());
<a name="l00486"></a>00486   }
<a name="l00487"></a>00487   
<a name="l00488"></a>00488   std::vector&lt;Number&gt; io_buffer;
<a name="l00489"></a>00489   
<a name="l00490"></a>00490   <span class="comment">// 9.)</span>
<a name="l00491"></a>00491   <span class="comment">//</span>
<a name="l00492"></a>00492   <span class="comment">// Actually read the solution components</span>
<a name="l00493"></a>00493   <span class="comment">// for the ith system to disk</span>
<a name="l00494"></a>00494   io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(io_buffer);
<a name="l00495"></a>00495   
<a name="l00496"></a>00496   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l00497"></a>00497   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>.size();
<a name="l00498"></a>00498   libmesh_assert(n_vars &lt;= this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00499"></a>00499         
<a name="l00500"></a>00500   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00501"></a>00501   
<a name="l00502"></a>00502   <span class="comment">// Loop over each non-SCALAR variable and each node, and read out the value.</span>
<a name="l00503"></a>00503   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00504"></a>00504     {
<a name="l00505"></a>00505       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00506"></a>00506       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00507"></a>00507         {
<a name="l00508"></a>00508           <span class="comment">// First read the node DOF values</span>
<a name="l00509"></a>00509           <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l00510"></a>00510                it = ordered_nodes.begin(); it != ordered_nodes.end(); ++it)
<a name="l00511"></a>00511             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l00512"></a>00512               {
<a name="l00513"></a>00513                 libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l00514"></a>00514                                 <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00515"></a>00515                 libmesh_assert (cnt &lt; io_buffer.size());
<a name="l00516"></a>00516                 this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set((*it)-&gt;dof_number(sys_num, var, comp), io_buffer[cnt++]);
<a name="l00517"></a>00517               }
<a name="l00518"></a>00518 
<a name="l00519"></a>00519           <span class="comment">// Then read the element DOF values</span>
<a name="l00520"></a>00520           <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l00521"></a>00521              it = ordered_elements.begin(); it != ordered_elements.end(); ++it)
<a name="l00522"></a>00522             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l00523"></a>00523             {
<a name="l00524"></a>00524               libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l00525"></a>00525                               <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00526"></a>00526               libmesh_assert (cnt &lt; io_buffer.size());
<a name="l00527"></a>00527               this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set((*it)-&gt;dof_number(sys_num, var, comp), io_buffer[cnt++]);
<a name="l00528"></a>00528             }      
<a name="l00529"></a>00529         }
<a name="l00530"></a>00530     }
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   <span class="comment">// Finally, read the SCALAR variables on the last processor</span>
<a name="l00533"></a>00533   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00534"></a>00534     {
<a name="l00535"></a>00535       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00536"></a>00536       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00537"></a>00537         {
<a name="l00538"></a>00538           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l00539"></a>00539             {
<a name="l00540"></a>00540               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00541"></a>00541               std::vector&lt;unsigned int&gt; SCALAR_dofs;
<a name="l00542"></a>00542               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(SCALAR_dofs, var);
<a name="l00543"></a>00543 
<a name="l00544"></a>00544               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_dofs.size(); i++)
<a name="l00545"></a>00545                 {
<a name="l00546"></a>00546                   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set( SCALAR_dofs[i], io_buffer[cnt++] );
<a name="l00547"></a>00547                 }
<a name="l00548"></a>00548             }
<a name="l00549"></a>00549         }
<a name="l00550"></a>00550     }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <span class="comment">// Only read additional vectors if wanted  </span>
<a name="l00553"></a>00553   <span class="keywordflow">if</span> (read_additional_data)
<a name="l00554"></a>00554     {     
<a name="l00555"></a>00555       std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator
<a name="l00556"></a>00556         pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l00557"></a>00557   
<a name="l00558"></a>00558       <span class="keywordflow">for</span>(; pos != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00559"></a>00559         {
<a name="l00560"></a>00560           cnt=0;
<a name="l00561"></a>00561           io_buffer.clear();
<a name="l00562"></a>00562           
<a name="l00563"></a>00563           <span class="comment">// 10.)</span>
<a name="l00564"></a>00564           <span class="comment">//</span>
<a name="l00565"></a>00565           <span class="comment">// Actually read the additional vector components</span>
<a name="l00566"></a>00566           <span class="comment">// for the ith system to disk</span>
<a name="l00567"></a>00567           io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(io_buffer);
<a name="l00568"></a>00568           
<a name="l00569"></a>00569           <span class="comment">// Loop over each non-SCALAR variable and each node, and read out the value.</span>
<a name="l00570"></a>00570           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00571"></a>00571             {
<a name="l00572"></a>00572               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00573"></a>00573               <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00574"></a>00574                 {
<a name="l00575"></a>00575                   <span class="comment">// First read the node DOF values</span>
<a name="l00576"></a>00576                   <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l00577"></a>00577                        it = ordered_nodes.begin(); it != ordered_nodes.end(); ++it)
<a name="l00578"></a>00578                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l00579"></a>00579                       {
<a name="l00580"></a>00580                         libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l00581"></a>00581                                         <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00582"></a>00582                         libmesh_assert (cnt &lt; io_buffer.size());
<a name="l00583"></a>00583                         pos-&gt;second-&gt;set((*it)-&gt;dof_number(sys_num, var, comp), io_buffer[cnt++]);
<a name="l00584"></a>00584                       }      
<a name="l00585"></a>00585               
<a name="l00586"></a>00586                   <span class="comment">// Then read the element DOF values</span>
<a name="l00587"></a>00587                   <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l00588"></a>00588                        it = ordered_elements.begin(); it != ordered_elements.end(); ++it)
<a name="l00589"></a>00589                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l00590"></a>00590                       {
<a name="l00591"></a>00591                         libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l00592"></a>00592                                         <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00593"></a>00593                         libmesh_assert (cnt &lt; io_buffer.size());
<a name="l00594"></a>00594                         pos-&gt;second-&gt;set((*it)-&gt;dof_number(sys_num, var, comp), io_buffer[cnt++]);
<a name="l00595"></a>00595                       }       
<a name="l00596"></a>00596                 }
<a name="l00597"></a>00597             }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599           <span class="comment">// Finally, read the SCALAR variables on the last processor</span>
<a name="l00600"></a>00600           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00601"></a>00601             {
<a name="l00602"></a>00602               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00603"></a>00603               <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00604"></a>00604                 {
<a name="l00605"></a>00605                   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l00606"></a>00606                     {
<a name="l00607"></a>00607                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00608"></a>00608                       std::vector&lt;unsigned int&gt; SCALAR_dofs;
<a name="l00609"></a>00609                       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(SCALAR_dofs, var);
<a name="l00610"></a>00610 
<a name="l00611"></a>00611                       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_dofs.size(); i++)
<a name="l00612"></a>00612                         {
<a name="l00613"></a>00613                           pos-&gt;second-&gt;set( SCALAR_dofs[i], io_buffer[cnt++] );
<a name="l00614"></a>00614                         }
<a name="l00615"></a>00615                     }
<a name="l00616"></a>00616                 }
<a name="l00617"></a>00617             }
<a name="l00618"></a>00618         }
<a name="l00619"></a>00619     }
<a name="l00620"></a>00620 }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a><a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">00624</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">System::read_serialized_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00625"></a>00625                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> read_additional_data)
<a name="l00626"></a>00626 {
<a name="l00627"></a>00627   <span class="comment">// This method implements the input of the vectors</span>
<a name="l00628"></a>00628   <span class="comment">// contained in this System object, embedded in the </span>
<a name="l00629"></a>00629   <span class="comment">// output of an EquationSystems&lt;T_sys&gt;. </span>
<a name="l00630"></a>00630   <span class="comment">//</span>
<a name="l00631"></a>00631   <span class="comment">//   10.) The global solution vector, re-ordered to be node-major </span>
<a name="l00632"></a>00632   <span class="comment">//       (More on this later.)                                    </span>
<a name="l00633"></a>00633   <span class="comment">//                                                                </span>
<a name="l00634"></a>00634   <span class="comment">//      for each additional vector in the object          </span>
<a name="l00635"></a>00635   <span class="comment">//                                                                </span>
<a name="l00636"></a>00636   <span class="comment">//      11.) The global additional vector, re-ordered to be       </span>
<a name="l00637"></a>00637   <span class="comment">//          node-major (More on this later.)</span>
<a name="l00638"></a>00638   parallel_only();
<a name="l00639"></a>00639   std::string comment;
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   <span class="comment">// 10.)</span>
<a name="l00642"></a>00642   <span class="comment">// Read the global solution vector</span>
<a name="l00643"></a>00643   {
<a name="l00644"></a>00644     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a1abcba5d9ffb5edf18c138eb2a0214c1">read_serialized_vector</a>(io, *this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>); 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646     <span class="comment">// get the comment</span>
<a name="l00647"></a>00647     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00648"></a>00648       io.<a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">comment</a> (comment);  
<a name="l00649"></a>00649   }
<a name="l00650"></a>00650   
<a name="l00651"></a>00651   <span class="comment">// 11.)</span>
<a name="l00652"></a>00652   <span class="comment">// Only read additional vectors if wanted  </span>
<a name="l00653"></a>00653   <span class="keywordflow">if</span> (read_additional_data)
<a name="l00654"></a>00654     {     
<a name="l00655"></a>00655       std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator
<a name="l00656"></a>00656         pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l00657"></a>00657   
<a name="l00658"></a>00658       <span class="keywordflow">for</span>(; pos != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l00659"></a>00659         {
<a name="l00660"></a>00660           this-&gt;<a class="code" href="classlibMesh_1_1System.php#a1abcba5d9ffb5edf18c138eb2a0214c1">read_serialized_vector</a>(io, *pos-&gt;second);
<a name="l00661"></a>00661 
<a name="l00662"></a>00662           <span class="comment">// get the comment</span>
<a name="l00663"></a>00663           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00664"></a>00664             io.<a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">comment</a> (comment);         
<a name="l00665"></a>00665             
<a name="l00666"></a>00666         }
<a name="l00667"></a>00667     }
<a name="l00668"></a>00668 }
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00673"></a><a class="code" href="classlibMesh_1_1System.php#a3656a2d9faf108f1e230912ea5635d4f">00673</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a3656a2d9faf108f1e230912ea5635d4f">System::read_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00674"></a>00674                                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_objects,
<a name="l00675"></a>00675                                                           <span class="keyword">const</span> iterator_type begin,
<a name="l00676"></a>00676                                                           <span class="keyword">const</span> iterator_type end,
<a name="l00677"></a>00677                                                           <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00678"></a>00678                                                           <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec)<span class="keyword"> const</span>
<a name="l00679"></a>00679 <span class="keyword"></span>{
<a name="l00680"></a>00680   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l00681"></a>00681   
<a name="l00682"></a>00682   std::vector&lt;Number&gt; input_buffer;        <span class="comment">// buffer to hold the input block read from io.               </span>
<a name="l00683"></a>00683   std::vector&lt;Number&gt; local_values;
<a name="l00684"></a>00684   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;  <span class="comment">// The IDs from each processor which map to the objects</span>
<a name="l00685"></a>00685     recv_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());     <span class="comment">//  read in the current block</span>
<a name="l00686"></a>00686   std::vector&lt;unsigned int&gt; idx_map;       <span class="comment">// Reordering map to traverse entry-wise rather than processor-wise</span>
<a name="l00687"></a>00687   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_assigned_vals = 0;        <span class="comment">// the number of values assigned, this will be returned.</span>
<a name="l00688"></a>00688   
<a name="l00689"></a>00689   <span class="comment">//-----------------------------------</span>
<a name="l00690"></a>00690   <span class="comment">// Collect the values for all objects</span>
<a name="l00691"></a>00691   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_object=0, last_object=0;
<a name="l00692"></a>00692 
<a name="l00693"></a>00693   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0; last_object&lt;<a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">n_objects</a>; blk++)
<a name="l00694"></a>00694     {
<a name="l00695"></a>00695       <span class="comment">//libMesh::out &lt;&lt; &quot;Reading object block &quot; &lt;&lt; blk &lt;&lt; std::endl;</span>
<a name="l00696"></a>00696       
<a name="l00697"></a>00697       <span class="comment">// Each processor should build up its transfer buffers for its</span>
<a name="l00698"></a>00698       <span class="comment">// local objects in [first_object,last_object).</span>
<a name="l00699"></a>00699       first_object = blk*io_blksize;
<a name="l00700"></a>00700       last_object  = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*io_blksize,n_objects);
<a name="l00701"></a>00701       
<a name="l00702"></a>00702       <span class="comment">// Clear the transfer buffers for this block.</span>
<a name="l00703"></a>00703       recv_ids[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()].clear();
<a name="l00704"></a>00704       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>=0;
<a name="l00705"></a>00705       <span class="keywordflow">for</span> (iterator_type it=begin; it!=end; ++it)
<a name="l00706"></a>00706         <span class="keywordflow">if</span> (((*it)-&gt;id() &gt;= first_object) &amp;&amp; <span class="comment">// object in [first_object,last_object)</span>
<a name="l00707"></a>00707             ((*it)-&gt;id() &lt;   last_object) &amp;&amp;
<a name="l00708"></a>00708             (*it)-&gt;n_comp(sys_num,var))      <span class="comment">// var has a nonzero # of components on this object</span>
<a name="l00709"></a>00709           {
<a name="l00710"></a>00710             recv_ids[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()].push_back((*it)-&gt;id());
<a name="l00711"></a>00711             recv_ids[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()].push_back((*it)-&gt;n_comp(sys_num, var));
<a name="l00712"></a>00712             recv_ids[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()].push_back(n_local_dofs);
<a name="l00713"></a>00713             n_local_dofs += (*it)-&gt;n_comp(sys_num, var);            
<a name="l00714"></a>00714           }
<a name="l00715"></a>00715       
<a name="l00716"></a>00716       <span class="comment">// Get the recv_ids for all other processors.</span>
<a name="l00717"></a>00717       {
<a name="l00718"></a>00718         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> curr_vec_size = recv_ids[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()].size();
<a name="l00719"></a>00719         std::vector&lt;unsigned int&gt; recv_id_sizes(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00720"></a>00720         <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(curr_vec_size, recv_id_sizes);
<a name="l00721"></a>00721         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00722"></a>00722           {
<a name="l00723"></a>00723             recv_ids[pid].resize(recv_id_sizes[pid]);
<a name="l00724"></a>00724             <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(recv_ids[pid], pid);
<a name="l00725"></a>00725           }
<a name="l00726"></a>00726       }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728       <span class="comment">// create the idx map for all processors -- this will match the ordering</span>
<a name="l00729"></a>00729       <span class="comment">// in the input buffer chunk which we are about to read.</span>
<a name="l00730"></a>00730       idx_map.resize(3*io_blksize); std::fill (idx_map.begin(), idx_map.end(), <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00731"></a>00731       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_n_comp=0;
<a name="l00732"></a>00732       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00733"></a>00733         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;recv_ids[pid].size(); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+=3)
<a name="l00734"></a>00734           {
<a name="l00735"></a>00735             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_idx = recv_ids[pid][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+0]-first_object;
<a name="l00736"></a>00736             libmesh_assert (local_idx &lt; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(io_blksize,n_objects));
<a name="l00737"></a>00737             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp    = recv_ids[pid][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+1];
<a name="l00738"></a>00738             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> start_pos = recv_ids[pid][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+2];
<a name="l00739"></a>00739             
<a name="l00740"></a>00740             idx_map[3*local_idx+0] = pid;
<a name="l00741"></a>00741             idx_map[3*local_idx+1] = n_comp;
<a name="l00742"></a>00742             idx_map[3*local_idx+2] = start_pos; <span class="comment">// this tells us where the values</span>
<a name="l00743"></a>00743                                                 <span class="comment">// for this object will live in the local_values buffer</span>
<a name="l00744"></a>00744             tot_n_comp += n_comp;
<a name="l00745"></a>00745           }
<a name="l00746"></a>00746       
<a name="l00747"></a>00747       <span class="comment">// Processor 0 will read the block from the buffer stream and send it to all other processors</span>
<a name="l00748"></a>00748       input_buffer.resize (tot_n_comp);
<a name="l00749"></a>00749       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">data_stream</a>(input_buffer.empty() ? NULL : &amp;input_buffer[0], tot_n_comp);
<a name="l00750"></a>00750       <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(input_buffer);
<a name="l00751"></a>00751 
<a name="l00752"></a>00752       <span class="comment">// Extract the values corresponding to the local objects from the input_buffer</span>
<a name="l00753"></a>00753       <span class="comment">// and place them into the local_values temporary buffer.</span>
<a name="l00754"></a>00754       {
<a name="l00755"></a>00755         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> processed_size=0;
<a name="l00756"></a>00756         std::vector&lt;Number&gt;::const_iterator next_value = input_buffer.begin();
<a name="l00757"></a>00757         local_values.clear(); local_values.resize(n_local_dofs);
<a name="l00758"></a>00758 
<a name="l00759"></a>00759         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;idx_map.size(); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+=3)
<a name="l00760"></a>00760           <span class="keywordflow">if</span> (idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>] != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="comment">// this could happen when an object</span>
<a name="l00761"></a>00761             {                                        <span class="comment">// has no components for the current variable</span>
<a name="l00762"></a>00762               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid       = idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+0];
<a name="l00763"></a>00763               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp    = idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+1];
<a name="l00764"></a>00764               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> start_pos = idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+2];
<a name="l00765"></a>00765               
<a name="l00766"></a>00766               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;n_comp; comp++)
<a name="l00767"></a>00767                 {
<a name="l00768"></a>00768                   libmesh_assert (next_value != input_buffer.end());
<a name="l00769"></a>00769                   <span class="keywordflow">if</span> (pid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00770"></a>00770                     {
<a name="l00771"></a>00771                       libmesh_assert ((start_pos+comp) &lt; local_values.size());
<a name="l00772"></a>00772                       local_values[start_pos+comp] = *next_value;
<a name="l00773"></a>00773                     }
<a name="l00774"></a>00774                   ++next_value;
<a name="l00775"></a>00775                   ++processed_size;                             
<a name="l00776"></a>00776                 }
<a name="l00777"></a>00777             }
<a name="l00778"></a>00778         libmesh_assert (processed_size == input_buffer.size());
<a name="l00779"></a>00779       }
<a name="l00780"></a>00780       
<a name="l00781"></a>00781       <span class="comment">// A subset of the components (potentially null set) will match our objects in</span>
<a name="l00782"></a>00782       <span class="comment">// [first_object,last_object), and we will assign the corresponding values from</span>
<a name="l00783"></a>00783       <span class="comment">// the local_values buffer.</span>
<a name="l00784"></a>00784       <span class="keywordflow">for</span> (iterator_type it=begin; it!=end; ++it)
<a name="l00785"></a>00785         <span class="keywordflow">if</span> (((*it)-&gt;id() &gt;= first_object) &amp;&amp; <span class="comment">// object in [first_object,last_object)</span>
<a name="l00786"></a>00786             ((*it)-&gt;id() &lt;   last_object) &amp;&amp;
<a name="l00787"></a>00787             (*it)-&gt;n_comp(sys_num,var))      <span class="comment">// var has a nonzero # of components on this object</span>
<a name="l00788"></a>00788           {
<a name="l00789"></a>00789             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_idx = (*it)-&gt;id()-first_object;
<a name="l00790"></a>00790             libmesh_assert (local_idx &lt; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(io_blksize,n_objects));
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00793"></a>00793 <span class="preprocessor"></span>            <span class="comment">// We only need to check the pid when asserts are active</span>
<a name="l00794"></a>00794             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid       = idx_map[3*local_idx+0];
<a name="l00795"></a>00795 <span class="preprocessor">#endif</span>
<a name="l00796"></a>00796 <span class="preprocessor"></span>            libmesh_assert (pid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00797"></a>00797             
<a name="l00798"></a>00798             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp    = idx_map[3*local_idx+1];
<a name="l00799"></a>00799             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> start_pos = idx_map[3*local_idx+2];
<a name="l00800"></a>00800             
<a name="l00801"></a>00801             libmesh_assert (n_comp == (*it)-&gt;n_comp(sys_num, var));
<a name="l00802"></a>00802             
<a name="l00803"></a>00803             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;n_comp; comp++)
<a name="l00804"></a>00804               {
<a name="l00805"></a>00805                 libmesh_assert ((start_pos+comp) &lt; local_values.size());
<a name="l00806"></a>00806                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> &amp;value = local_values[start_pos+comp];                             
<a name="l00807"></a>00807                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_index = (*it)-&gt;dof_number (sys_num, var, comp);
<a name="l00808"></a>00808                 libmesh_assert (dof_index &gt;= vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>());
<a name="l00809"></a>00809                 libmesh_assert (dof_index &lt;  vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>());
<a name="l00810"></a>00810                 <span class="comment">//libMesh::out &lt;&lt; &quot;di=&quot; &lt;&lt; dof_index &lt;&lt; &quot;, val=&quot; &lt;&lt; value &lt;&lt; std::endl;</span>
<a name="l00811"></a>00811                 vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a> (dof_index, value);
<a name="l00812"></a>00812                 ++n_assigned_vals;
<a name="l00813"></a>00813               }
<a name="l00814"></a>00814           }
<a name="l00815"></a>00815     }
<a name="l00816"></a>00816       
<a name="l00817"></a>00817   <span class="keywordflow">return</span> n_assigned_vals;
<a name="l00818"></a>00818 }
<a name="l00819"></a>00819 
<a name="l00820"></a><a class="code" href="classlibMesh_1_1System.php#a9059cad1ef841d18f1804c4c2837d17e">00820</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a9059cad1ef841d18f1804c4c2837d17e">System::read_SCALAR_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00821"></a>00821                                        <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l00822"></a>00822                                        <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec)<span class="keyword"> const</span>
<a name="l00823"></a>00823 <span class="keyword"></span>{
<a name="l00824"></a>00824   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_assigned_vals = 0; <span class="comment">// the number of values assigned, this will be returned.</span>
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   <span class="comment">// Processor 0 will read the block from the buffer stream and send it to the last processor</span>
<a name="l00827"></a>00827   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_SCALAR_dofs = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>;
<a name="l00828"></a>00828   std::vector&lt;Number&gt; input_buffer(n_SCALAR_dofs);
<a name="l00829"></a>00829   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00830"></a>00830     {
<a name="l00831"></a>00831       io.<a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">data_stream</a>(&amp;input_buffer[0], n_SCALAR_dofs);
<a name="l00832"></a>00832     }
<a name="l00833"></a>00833     
<a name="l00834"></a>00834 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00835"></a>00835 <span class="preprocessor"></span>  <span class="keywordflow">if</span> ( <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 )
<a name="l00836"></a>00836     {
<a name="l00837"></a>00837       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a> val_tag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(321);
<a name="l00838"></a>00838       
<a name="l00839"></a>00839       <span class="comment">// Post the receive on the last processor</span>
<a name="l00840"></a>00840       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l00841"></a>00841         <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(0, input_buffer, val_tag);
<a name="l00842"></a>00842 
<a name="l00843"></a>00843       <span class="comment">// Send the data to processor 0</span>
<a name="l00844"></a>00844       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00845"></a>00845         <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1, input_buffer, val_tag);
<a name="l00846"></a>00846     }
<a name="l00847"></a>00847 <span class="preprocessor">#endif</span>
<a name="l00848"></a>00848 <span class="preprocessor"></span>  
<a name="l00849"></a>00849   <span class="comment">// Finally, set the SCALAR values</span>
<a name="l00850"></a>00850   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l00851"></a>00851     {
<a name="l00852"></a>00852       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00853"></a>00853       std::vector&lt;unsigned int&gt; SCALAR_dofs;
<a name="l00854"></a>00854       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(SCALAR_dofs, var);
<a name="l00855"></a>00855 
<a name="l00856"></a>00856       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_dofs.size(); i++)
<a name="l00857"></a>00857         {
<a name="l00858"></a>00858           vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a> (SCALAR_dofs[i], input_buffer[i]);
<a name="l00859"></a>00859           ++n_assigned_vals;
<a name="l00860"></a>00860         }
<a name="l00861"></a>00861     }
<a name="l00862"></a>00862 
<a name="l00863"></a>00863   <span class="keywordflow">return</span> n_assigned_vals;
<a name="l00864"></a>00864 }
<a name="l00865"></a>00865 
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a><a class="code" href="classlibMesh_1_1System.php#a1abcba5d9ffb5edf18c138eb2a0214c1">00868</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a1abcba5d9ffb5edf18c138eb2a0214c1">System::read_serialized_vector</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io, <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec)
<a name="l00869"></a>00869 {
<a name="l00870"></a>00870   parallel_only();
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00873"></a>00873 <span class="preprocessor"></span>  <span class="comment">// In parallel we better be reading a parallel vector -- if not</span>
<a name="l00874"></a>00874   <span class="comment">// we will not set all of its components below!!</span>
<a name="l00875"></a>00875   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00876"></a>00876     {
<a name="l00877"></a>00877       libmesh_assert (vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a> ||
<a name="l00878"></a>00878                       vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00879"></a>00879     }
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="comment">// If this is not the same on all processors we&#39;re in trouble!</span>
<a name="l00882"></a>00882   <a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">Parallel::verify</a>(io_blksize);
<a name="l00883"></a>00883 <span class="preprocessor">#endif</span>
<a name="l00884"></a>00884 <span class="preprocessor"></span>  
<a name="l00885"></a>00885   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#aec343c8dd879abda1c8706342ff0cbfe">reading</a>());
<a name="l00886"></a>00886 
<a name="l00887"></a>00887   <span class="comment">// vector length</span>
<a name="l00888"></a>00888   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vector_length=0, n_assigned_vals=0;
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   <span class="comment">// Get the buffer size</span>
<a name="l00891"></a>00891   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a>(vector_length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00892"></a>00892   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(vector_length);
<a name="l00893"></a>00893   
<a name="l00894"></a>00894   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>.size();
<a name="l00895"></a>00895   libmesh_assert(n_vars &lt;= this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>());
<a name="l00896"></a>00896         
<a name="l00897"></a>00897   <span class="comment">// Loop over each variable in the system, and then each node/element in the mesh.</span>
<a name="l00898"></a>00898   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00899"></a>00899     {
<a name="l00900"></a>00900       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00901"></a>00901       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00902"></a>00902         {
<a name="l00903"></a>00903           <span class="comment">//---------------------------------</span>
<a name="l00904"></a>00904           <span class="comment">// Collect the values for all nodes</span>
<a name="l00905"></a>00905           n_assigned_vals +=
<a name="l00906"></a>00906             this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3656a2d9faf108f1e230912ea5635d4f">read_serialized_blocked_dof_objects</a> (var,
<a name="l00907"></a>00907                                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>(),
<a name="l00908"></a>00908                                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_begin(),
<a name="l00909"></a>00909                                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_end(),
<a name="l00910"></a>00910                                                        io,
<a name="l00911"></a>00911                                                        vec);
<a name="l00912"></a>00912       
<a name="l00913"></a>00913       
<a name="l00914"></a>00914           <span class="comment">//------------------------------------</span>
<a name="l00915"></a>00915           <span class="comment">// Collect the values for all elements</span>
<a name="l00916"></a>00916           n_assigned_vals +=
<a name="l00917"></a>00917             this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3656a2d9faf108f1e230912ea5635d4f">read_serialized_blocked_dof_objects</a> (var,
<a name="l00918"></a>00918                                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>(),
<a name="l00919"></a>00919                                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_begin(),
<a name="l00920"></a>00920                                                        this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_end(),
<a name="l00921"></a>00921                                                        io,
<a name="l00922"></a>00922                                                        vec);
<a name="l00923"></a>00923         } <span class="comment">// end variable loop</span>
<a name="l00924"></a>00924     }
<a name="l00925"></a>00925 
<a name="l00926"></a>00926   <span class="comment">// Finally loop over all the SCALAR variables</span>
<a name="l00927"></a>00927   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_var=0; data_var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; data_var++)
<a name="l00928"></a>00928     {
<a name="l00929"></a>00929       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1System.php#a50e5824ce72d3da7247710ee7c936367">_written_var_indices</a>[data_var];
<a name="l00930"></a>00930       <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l00931"></a>00931         {
<a name="l00932"></a>00932           n_assigned_vals +=
<a name="l00933"></a>00933             this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9059cad1ef841d18f1804c4c2837d17e">read_SCALAR_dofs</a> (var, io, vec);
<a name="l00934"></a>00934         }
<a name="l00935"></a>00935     }
<a name="l00936"></a>00936 
<a name="l00937"></a>00937   vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00940"></a>00940 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (n_assigned_vals);
<a name="l00941"></a>00941   libmesh_assert (n_assigned_vals == vector_length);
<a name="l00942"></a>00942 <span class="preprocessor">#endif</span>
<a name="l00943"></a>00943 <span class="preprocessor"></span>}
<a name="l00944"></a>00944 
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a><a class="code" href="classlibMesh_1_1System.php#ab85bb7019eaac1ceb8603975da8325ab">00947</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ab85bb7019eaac1ceb8603975da8325ab">System::write_header</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l00948"></a>00948                            <span class="keyword">const</span> std::string &amp; <span class="comment">/* version is currently unused */</span>,
<a name="l00949"></a>00949                            <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data)<span class="keyword"> const</span>
<a name="l00950"></a>00950 <span class="keyword"></span>{
<a name="l00982"></a>00982   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">writing</a>());
<a name="l00983"></a>00983 
<a name="l00984"></a>00984 
<a name="l00985"></a>00985   <span class="comment">// Only write the header information</span>
<a name="l00986"></a>00986   <span class="comment">// if we are processor 0.</span>
<a name="l00987"></a>00987   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>() != 0)
<a name="l00988"></a>00988     <span class="keywordflow">return</span>;
<a name="l00989"></a>00989   
<a name="l00990"></a>00990   std::string comment;
<a name="l00991"></a>00991   <span class="keywordtype">char</span> buf[80];
<a name="l00992"></a>00992 
<a name="l00993"></a>00993   <span class="comment">// 5.) </span>
<a name="l00994"></a>00994   <span class="comment">// Write the number of variables in the system</span>
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   {
<a name="l00997"></a>00997     <span class="comment">// set up the comment</span>
<a name="l00998"></a>00998     comment = <span class="stringliteral">&quot;# No. of Variables in System \&quot;&quot;</span>;
<a name="l00999"></a>00999     comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01000"></a>01000     comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;    
<a name="l01001"></a>01001           
<a name="l01002"></a>01002     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();   
<a name="l01003"></a>01003     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_vars, comment.c_str());
<a name="l01004"></a>01004   }
<a name="l01005"></a>01005 
<a name="l01006"></a>01006 
<a name="l01007"></a>01007   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l01008"></a>01008     {
<a name="l01009"></a>01009       <span class="comment">// 6.)</span>
<a name="l01010"></a>01010       <span class="comment">// Write the name of the var-th variable</span>
<a name="l01011"></a>01011       {
<a name="l01012"></a>01012         <span class="comment">// set up the comment</span>
<a name="l01013"></a>01013         comment  = <span class="stringliteral">&quot;#   Name, Variable No. &quot;</span>;
<a name="l01014"></a>01014         std::sprintf(buf, <span class="stringliteral">&quot;%d&quot;</span>, var);
<a name="l01015"></a>01015         comment += buf;
<a name="l01016"></a>01016         comment += <span class="stringliteral">&quot;, System \&quot;&quot;</span>;
<a name="l01017"></a>01017         comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01018"></a>01018         comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01019"></a>01019               
<a name="l01020"></a>01020         std::string var_name = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var);             
<a name="l01021"></a>01021         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (var_name, comment.c_str());
<a name="l01022"></a>01022       }
<a name="l01023"></a>01023       
<a name="l01024"></a>01024       <span class="comment">// 7.)</span>
<a name="l01025"></a>01025       <span class="comment">// Write the approximation order of the var-th variable </span>
<a name="l01026"></a>01026       <span class="comment">// in this system</span>
<a name="l01027"></a>01027       {
<a name="l01028"></a>01028         <span class="comment">// set up the comment</span>
<a name="l01029"></a>01029         comment = <span class="stringliteral">&quot;#     Approximation Order, Variable \&quot;&quot;</span>;
<a name="l01030"></a>01030         std::sprintf(buf, <span class="stringliteral">&quot;%s&quot;</span>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var).c_str());
<a name="l01031"></a>01031         comment += buf;
<a name="l01032"></a>01032         comment += <span class="stringliteral">&quot;\&quot;, System \&quot;&quot;</span>;
<a name="l01033"></a>01033         comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01034"></a>01034         comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01035"></a>01035               
<a name="l01036"></a>01036         <span class="keywordtype">int</span> order = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(var).<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>);         
<a name="l01037"></a>01037         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (order, comment.c_str());
<a name="l01038"></a>01038       }
<a name="l01039"></a>01039 
<a name="l01040"></a>01040 
<a name="l01041"></a>01041 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01042"></a>01042 <span class="preprocessor"></span>      
<a name="l01043"></a>01043       <span class="comment">// do the same for radial_order</span>
<a name="l01044"></a>01044       {
<a name="l01045"></a>01045         comment = <span class="stringliteral">&quot;#     Radial Approximation Order, Variable \&quot;&quot;</span>;
<a name="l01046"></a>01046         std::sprintf(buf, <span class="stringliteral">&quot;%s&quot;</span>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var).c_str());
<a name="l01047"></a>01047         comment += buf;
<a name="l01048"></a>01048         comment += <span class="stringliteral">&quot;\&quot;, System \&quot;&quot;</span>;
<a name="l01049"></a>01049         comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01050"></a>01050         comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01051"></a>01051       
<a name="l01052"></a>01052         <span class="keywordtype">int</span> rad_order = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(var).<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);              
<a name="l01053"></a>01053         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (rad_order, comment.c_str());
<a name="l01054"></a>01054       }
<a name="l01055"></a>01055 
<a name="l01056"></a>01056 <span class="preprocessor">#endif</span>
<a name="l01057"></a>01057 <span class="preprocessor"></span>      
<a name="l01058"></a>01058       <span class="comment">// Write the Finite Element type of the var-th variable </span>
<a name="l01059"></a>01059       <span class="comment">// in this System</span>
<a name="l01060"></a>01060       {
<a name="l01061"></a>01061         <span class="comment">// set up the comment</span>
<a name="l01062"></a>01062         comment = <span class="stringliteral">&quot;#     FE Family, Variable \&quot;&quot;</span>;
<a name="l01063"></a>01063         std::sprintf(buf, <span class="stringliteral">&quot;%s&quot;</span>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var).c_str());
<a name="l01064"></a>01064         comment += buf;
<a name="l01065"></a>01065         comment += <span class="stringliteral">&quot;\&quot;, System \&quot;&quot;</span>;
<a name="l01066"></a>01066         comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01067"></a>01067         comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01068"></a>01068       
<a name="l01069"></a>01069         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(var);        
<a name="l01070"></a>01070         <span class="keywordtype">int</span> fam = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(type.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>);              
<a name="l01071"></a>01071         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (fam, comment.c_str());
<a name="l01072"></a>01072 
<a name="l01073"></a>01073 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01074"></a>01074 <span class="preprocessor"></span>        
<a name="l01075"></a>01075         comment = <span class="stringliteral">&quot;#     Radial FE Family, Variable \&quot;&quot;</span>;
<a name="l01076"></a>01076         std::sprintf(buf, <span class="stringliteral">&quot;%s&quot;</span>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var).c_str());
<a name="l01077"></a>01077         comment += buf;
<a name="l01078"></a>01078         comment += <span class="stringliteral">&quot;\&quot;, System \&quot;&quot;</span>;
<a name="l01079"></a>01079         comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01080"></a>01080         comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01081"></a>01081       
<a name="l01082"></a>01082         <span class="keywordtype">int</span> radial_fam = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(type.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>);
<a name="l01083"></a>01083         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (radial_fam, comment.c_str());  
<a name="l01084"></a>01084         
<a name="l01085"></a>01085         comment = <span class="stringliteral">&quot;#     Infinite Mapping Type, Variable \&quot;&quot;</span>;
<a name="l01086"></a>01086         std::sprintf(buf, <span class="stringliteral">&quot;%s&quot;</span>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var).c_str());
<a name="l01087"></a>01087         comment += buf;
<a name="l01088"></a>01088         comment += <span class="stringliteral">&quot;\&quot;, System \&quot;&quot;</span>;
<a name="l01089"></a>01089         comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01090"></a>01090         comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01091"></a>01091 
<a name="l01092"></a>01092         <span class="keywordtype">int</span> i_map = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(type.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>);           
<a name="l01093"></a>01093         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (i_map, comment.c_str());
<a name="l01094"></a>01094 <span class="preprocessor">#endif</span>
<a name="l01095"></a>01095 <span class="preprocessor"></span>      }
<a name="l01096"></a>01096     } <span class="comment">// end of the variable loop</span>
<a name="l01097"></a>01097  
<a name="l01098"></a>01098   <span class="comment">// 8.) </span>
<a name="l01099"></a>01099   <span class="comment">// Write the number of additional vectors in the System.</span>
<a name="l01100"></a>01100   <span class="comment">// If write_additional_data==false, then write zero for</span>
<a name="l01101"></a>01101   <span class="comment">// the number of additional vectors.</span>
<a name="l01102"></a>01102   {       
<a name="l01103"></a>01103     {
<a name="l01104"></a>01104       <span class="comment">// set up the comment</span>
<a name="l01105"></a>01105       comment = <span class="stringliteral">&quot;# No. of Additional Vectors, System \&quot;&quot;</span>;
<a name="l01106"></a>01106       comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01107"></a>01107       comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01108"></a>01108     
<a name="l01109"></a>01109       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a> = write_additional_data ? this-&gt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a> () : 0;
<a name="l01110"></a>01110       io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_vectors, comment.c_str());
<a name="l01111"></a>01111     }  
<a name="l01112"></a>01112       
<a name="l01113"></a>01113     <span class="keywordflow">if</span> (write_additional_data)
<a name="l01114"></a>01114       {
<a name="l01115"></a>01115         std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator
<a name="l01116"></a>01116           vec_pos = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01117"></a>01117         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01118"></a>01118         
<a name="l01119"></a>01119         <span class="keywordflow">for</span> (; vec_pos != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++vec_pos)
<a name="l01120"></a>01120           {
<a name="l01121"></a>01121             <span class="comment">// 9.)</span>
<a name="l01122"></a>01122             <span class="comment">// write the name of the cnt-th additional vector</span>
<a name="l01123"></a>01123             comment =  <span class="stringliteral">&quot;# Name of &quot;</span>;
<a name="l01124"></a>01124             std::sprintf(buf, <span class="stringliteral">&quot;%d&quot;</span>, cnt++);
<a name="l01125"></a>01125             comment += buf;
<a name="l01126"></a>01126             comment += <span class="stringliteral">&quot;th vector&quot;</span>;
<a name="l01127"></a>01127             std::string vec_name = vec_pos-&gt;first;
<a name="l01128"></a>01128             
<a name="l01129"></a>01129             io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (vec_name, comment.c_str());
<a name="l01130"></a>01130           }
<a name="l01131"></a>01131       }
<a name="l01132"></a>01132   }
<a name="l01133"></a>01133 }
<a name="l01134"></a>01134 
<a name="l01135"></a>01135 
<a name="l01136"></a>01136 
<a name="l01137"></a>01137 <span class="comment">// void System::write_data (Xdr&amp; io,</span>
<a name="l01138"></a>01138 <span class="comment">//                       const bool write_additional_data) const</span>
<a name="l01139"></a>01139 <span class="comment">// {</span>
<a name="l01140"></a>01140 <span class="comment">//   // This is deprecated -- use write_serialized_data() instead.  This will be kept for reference</span>
<a name="l01141"></a>01141 <span class="comment">//   // for a little while, then dropped.  There is no need call this method any more.</span>
<a name="l01142"></a>01142 <span class="comment">//   libmesh_deprecated();</span>
<a name="l01143"></a>01143   
<a name="l01144"></a>01144 <span class="comment">//   /**</span>
<a name="l01145"></a>01145 <span class="comment">//    * This method implements the output of the vectors</span>
<a name="l01146"></a>01146 <span class="comment">//    * contained in this System object, embedded in the </span>
<a name="l01147"></a>01147 <span class="comment">//    * output of an EquationSystems&lt;T_sys&gt;. </span>
<a name="l01148"></a>01148 <span class="comment">//    *</span>
<a name="l01149"></a>01149 <span class="comment">//    *   9.) The global solution vector, re-ordered to be node-major </span>
<a name="l01150"></a>01150 <span class="comment">//    *       (More on this later.)                                    </span>
<a name="l01151"></a>01151 <span class="comment">//    *                                                                </span>
<a name="l01152"></a>01152 <span class="comment">//    *      for each additional vector in the object          </span>
<a name="l01153"></a>01153 <span class="comment">//    *                                                                </span>
<a name="l01154"></a>01154 <span class="comment">//    *      10.) The global additional vector, re-ordered to be       </span>
<a name="l01155"></a>01155 <span class="comment">//    *           node-major (More on this later.)</span>
<a name="l01156"></a>01156 <span class="comment">//    *</span>
<a name="l01157"></a>01157 <span class="comment">//    * Note that the actual IO is handled through the Xdr class </span>
<a name="l01158"></a>01158 <span class="comment">//    * (to be renamed later?) which provides a uniform interface to </span>
<a name="l01159"></a>01159 <span class="comment">//    * both the XDR (eXternal Data Representation) interface and standard</span>
<a name="l01160"></a>01160 <span class="comment">//    * ASCII output.  Thus this one section of code will read XDR or ASCII</span>
<a name="l01161"></a>01161 <span class="comment">//    * files with no changes.</span>
<a name="l01162"></a>01162 <span class="comment">//    */ </span>
<a name="l01163"></a>01163 <span class="comment">//   libmesh_assert (io.writing());</span>
<a name="l01164"></a>01164 
<a name="l01165"></a>01165 <span class="comment">//   const unsigned int proc_id = this-&gt;get_mesh().processor_id();</span>
<a name="l01166"></a>01166  
<a name="l01167"></a>01167 <span class="comment">//   std::string comment;</span>
<a name="l01168"></a>01168   
<a name="l01169"></a>01169 <span class="comment">//   // All processors contribute numeric vector values</span>
<a name="l01170"></a>01170 <span class="comment">//   std::vector&lt;Number&gt; global_vector;</span>
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 <span class="comment">//   // Collect the global solution on one processor</span>
<a name="l01173"></a>01173 <span class="comment">//   this-&gt;solution-&gt;localize_to_one (global_vector, 0);       </span>
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 <span class="comment">//   // Only processor 0 actually writes out the soltuion vector.  </span>
<a name="l01176"></a>01176 <span class="comment">//   if (proc_id == 0)</span>
<a name="l01177"></a>01177 <span class="comment">//     {               </span>
<a name="l01178"></a>01178 <span class="comment">//       // First we need to re-order the solution so that it</span>
<a name="l01179"></a>01179 <span class="comment">//       // is dof_map agnostic.  This is necessary so that the </span>
<a name="l01180"></a>01180 <span class="comment">//       // vector might be re-read with a different partitioning</span>
<a name="l01181"></a>01181 <span class="comment">//       // or DOF distribution.  </span>
<a name="l01182"></a>01182 <span class="comment">//       //</span>
<a name="l01183"></a>01183 <span class="comment">//       // Currently the vector is written in node-major order.</span>
<a name="l01184"></a>01184 <span class="comment">//       std::vector&lt;Number&gt; reordered_soln(global_vector.size());</span>
<a name="l01185"></a>01185           
<a name="l01186"></a>01186 <span class="comment">//       unsigned int cnt=0;</span>
<a name="l01187"></a>01187 
<a name="l01188"></a>01188 <span class="comment">//       const unsigned int sys_num = this-&gt;number();</span>
<a name="l01189"></a>01189 <span class="comment">//       const unsigned int n_vars  = this-&gt;n_vars();</span>
<a name="l01190"></a>01190 
<a name="l01191"></a>01191 <span class="comment">//       // Build a set of non subactive node indices. </span>
<a name="l01192"></a>01192 <span class="comment">//       std::set&lt;unsigned int&gt; not_subactive_node_ids;</span>
<a name="l01193"></a>01193 <span class="comment">//       MeshTools::get_not_subactive_node_ids(this-&gt;get_mesh(), not_subactive_node_ids);</span>
<a name="l01194"></a>01194 
<a name="l01195"></a>01195 <span class="comment">//       // Loop over each variable and each node, and write out the value.</span>
<a name="l01196"></a>01196 <span class="comment">//       for (unsigned int var=0; var&lt;n_vars; var++)</span>
<a name="l01197"></a>01197 <span class="comment">//         {            </span>
<a name="l01198"></a>01198 <span class="comment">//        // First write the nodal DOF values</span>
<a name="l01199"></a>01199 <span class="comment">//           std::set&lt;unsigned int&gt;::iterator it = not_subactive_node_ids.begin();</span>
<a name="l01200"></a>01200 <span class="comment">//           const std::set&lt;unsigned int&gt;::iterator end = not_subactive_node_ids.end();</span>
<a name="l01201"></a>01201           
<a name="l01202"></a>01202 <span class="comment">//           for (; it != end; ++it)</span>
<a name="l01203"></a>01203 <span class="comment">//           {</span>
<a name="l01204"></a>01204 <span class="comment">//             // Get the global index of this node</span>
<a name="l01205"></a>01205 <span class="comment">//             const unsigned int node = *it;</span>
<a name="l01206"></a>01206 <span class="comment">//          for (unsigned int index=0; index&lt;this-&gt;get_mesh().node(node).n_comp(sys_num, var); index++)</span>
<a name="l01207"></a>01207 <span class="comment">//            {</span>
<a name="l01208"></a>01208 <span class="comment">//                 libmesh_assert (this-&gt;get_mesh().node(node).id() == node);</span>
<a name="l01209"></a>01209 <span class="comment">//              libmesh_assert (this-&gt;get_mesh().node(node).dof_number(sys_num, var, index) !=</span>
<a name="l01210"></a>01210 <span class="comment">//                      DofObject::invalid_id);</span>
<a name="l01211"></a>01211 <span class="comment">//              libmesh_assert (cnt &lt; reordered_soln.size());</span>
<a name="l01212"></a>01212                 
<a name="l01213"></a>01213 <span class="comment">//              reordered_soln[cnt++] = </span>
<a name="l01214"></a>01214 <span class="comment">//                global_vector[this-&gt;get_mesh().node(node).dof_number(sys_num, var, index)];</span>
<a name="l01215"></a>01215 <span class="comment">//            }</span>
<a name="l01216"></a>01216 <span class="comment">//           }</span>
<a name="l01217"></a>01217 
<a name="l01218"></a>01218 <span class="comment">//        // Then write the element DOF values</span>
<a name="l01219"></a>01219 <span class="comment">//        {</span>
<a name="l01220"></a>01220 <span class="comment">//          MeshBase::const_element_iterator</span>
<a name="l01221"></a>01221 <span class="comment">//            it  = this-&gt;get_mesh().active_elements_begin(),</span>
<a name="l01222"></a>01222 <span class="comment">//            end = this-&gt;get_mesh().active_elements_end();</span>
<a name="l01223"></a>01223 
<a name="l01224"></a>01224 <span class="comment">//          for (; it!=end; ++it)</span>
<a name="l01225"></a>01225 <span class="comment">//            for (unsigned int index=0; index&lt;(*it)-&gt;n_comp(sys_num, var); index++)</span>
<a name="l01226"></a>01226 <span class="comment">//              {</span>
<a name="l01227"></a>01227 <span class="comment">//                libmesh_assert ((*it)-&gt;dof_number(sys_num, var, index) !=</span>
<a name="l01228"></a>01228 <span class="comment">//                        DofObject::invalid_id);</span>
<a name="l01229"></a>01229                         
<a name="l01230"></a>01230 <span class="comment">//                libmesh_assert (cnt &lt; reordered_soln.size());</span>
<a name="l01231"></a>01231                         
<a name="l01232"></a>01232 <span class="comment">//                reordered_soln[cnt++] = </span>
<a name="l01233"></a>01233 <span class="comment">//                    global_vector[(*it)-&gt;dof_number(sys_num, var, index)];</span>
<a name="l01234"></a>01234 <span class="comment">//              }</span>
<a name="l01235"></a>01235 <span class="comment">//        }</span>
<a name="l01236"></a>01236 <span class="comment">//      }</span>
<a name="l01237"></a>01237 
<a name="l01238"></a>01238 <span class="comment">//       // 9.)</span>
<a name="l01239"></a>01239 <span class="comment">//       //</span>
<a name="l01240"></a>01240 <span class="comment">//       // Actually write the reordered solution vector </span>
<a name="l01241"></a>01241 <span class="comment">//       // for the ith system to disk</span>
<a name="l01242"></a>01242 
<a name="l01243"></a>01243 <span class="comment">//       // set up the comment</span>
<a name="l01244"></a>01244 <span class="comment">//       {</span>
<a name="l01245"></a>01245 <span class="comment">//      comment = &quot;# System \&quot;&quot;;</span>
<a name="l01246"></a>01246 <span class="comment">//      comment += this-&gt;name();</span>
<a name="l01247"></a>01247 <span class="comment">//      comment += &quot;\&quot; Solution Vector&quot;;</span>
<a name="l01248"></a>01248 <span class="comment">//       }</span>
<a name="l01249"></a>01249 
<a name="l01250"></a>01250 <span class="comment">//       io.data (reordered_soln, comment.c_str());       </span>
<a name="l01251"></a>01251 <span class="comment">//     }</span>
<a name="l01252"></a>01252   
<a name="l01253"></a>01253 <span class="comment">//   // Only write additional vectors if wanted  </span>
<a name="l01254"></a>01254 <span class="comment">//   if (write_additional_data)</span>
<a name="l01255"></a>01255 <span class="comment">//     {          </span>
<a name="l01256"></a>01256 <span class="comment">//       std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator</span>
<a name="l01257"></a>01257 <span class="comment">//      pos = _vectors.begin();</span>
<a name="l01258"></a>01258   
<a name="l01259"></a>01259 <span class="comment">//       for(; pos != this-&gt;_vectors.end(); ++pos)</span>
<a name="l01260"></a>01260 <span class="comment">//         {</span>
<a name="l01261"></a>01261 <span class="comment">//        // fill with zero.  In general, a resize is not necessary            </span>
<a name="l01262"></a>01262 <span class="comment">//        std::fill (global_vector.begin(), global_vector.end(), libMesh::zero);</span>
<a name="l01263"></a>01263 
<a name="l01264"></a>01264 <span class="comment">//        // Collect the global solution on one processor</span>
<a name="l01265"></a>01265 <span class="comment">//        pos-&gt;second-&gt;localize_to_one (global_vector, 0);       </span>
<a name="l01266"></a>01266     
<a name="l01267"></a>01267 <span class="comment">//        // Only processor 0 actually writes out the  vector.  </span>
<a name="l01268"></a>01268 <span class="comment">//        if (proc_id == 0)</span>
<a name="l01269"></a>01269 <span class="comment">//          {     </span>
<a name="l01270"></a>01270 <span class="comment">//            // First we need to re-order the solution so that it</span>
<a name="l01271"></a>01271 <span class="comment">//            // is dof_map agnostic.  This is necessary so that the </span>
<a name="l01272"></a>01272 <span class="comment">//            // vector might be re-read with a different partitioning</span>
<a name="l01273"></a>01273 <span class="comment">//            // or DOF distribution.  </span>
<a name="l01274"></a>01274 <span class="comment">//            //</span>
<a name="l01275"></a>01275 <span class="comment">//            // Currently the vector is written in node-major order.</span>
<a name="l01276"></a>01276 <span class="comment">//            std::vector&lt;Number&gt; reordered_soln(global_vector.size());</span>
<a name="l01277"></a>01277           
<a name="l01278"></a>01278 <span class="comment">//            unsigned int cnt=0;</span>
<a name="l01279"></a>01279               
<a name="l01280"></a>01280 <span class="comment">//            const unsigned int sys_num = this-&gt;number();</span>
<a name="l01281"></a>01281 <span class="comment">//            const unsigned int n_vars  = this-&gt;n_vars();</span>
<a name="l01282"></a>01282               
<a name="l01283"></a>01283 <span class="comment">//            for (unsigned int var=0; var&lt;n_vars; var++)</span>
<a name="l01284"></a>01284 <span class="comment">//              {               </span>
<a name="l01285"></a>01285 <span class="comment">//                // First write the nodal DOF values</span>
<a name="l01286"></a>01286 <span class="comment">//                {</span>
<a name="l01287"></a>01287 <span class="comment">//                  MeshBase::const_node_iterator</span>
<a name="l01288"></a>01288 <span class="comment">//                    it  = this-&gt;get_mesh().nodes_begin(),</span>
<a name="l01289"></a>01289 <span class="comment">//                    end = this-&gt;get_mesh().nodes_end();</span>
<a name="l01290"></a>01290                     
<a name="l01291"></a>01291 <span class="comment">//                  for (; it !=end; ++it)</span>
<a name="l01292"></a>01292 <span class="comment">//                    for (unsigned int index=0; index&lt;(*it)-&gt;n_comp(sys_num, var); index++)</span>
<a name="l01293"></a>01293 <span class="comment">//                      {</span>
<a name="l01294"></a>01294 <span class="comment">//                        libmesh_assert ((*it)-&gt;dof_number(sys_num, var, index) !=</span>
<a name="l01295"></a>01295 <span class="comment">//                                DofObject::invalid_id);                         </span>
<a name="l01296"></a>01296 <span class="comment">//                        libmesh_assert (cnt &lt; reordered_soln.size());</span>
<a name="l01297"></a>01297                           
<a name="l01298"></a>01298 <span class="comment">//                        reordered_soln[cnt++] = </span>
<a name="l01299"></a>01299 <span class="comment">//                          global_vector[(*it)-&gt;dof_number(sys_num, var, index)];</span>
<a name="l01300"></a>01300 <span class="comment">//                      }</span>
<a name="l01301"></a>01301 <span class="comment">//                }</span>
<a name="l01302"></a>01302                   
<a name="l01303"></a>01303 <span class="comment">//                // Then write the element DOF values</span>
<a name="l01304"></a>01304 <span class="comment">//                {</span>
<a name="l01305"></a>01305 <span class="comment">//                  MeshBase::const_element_iterator</span>
<a name="l01306"></a>01306 <span class="comment">//                    it  = this-&gt;get_mesh().active_elements_begin(),</span>
<a name="l01307"></a>01307 <span class="comment">//                    end = this-&gt;get_mesh().active_elements_end();</span>
<a name="l01308"></a>01308                     
<a name="l01309"></a>01309 <span class="comment">//                  for (; it!=end; ++it)</span>
<a name="l01310"></a>01310 <span class="comment">//                    for (unsigned int index=0; index&lt;(*it)-&gt;n_comp(sys_num, var); index++)</span>
<a name="l01311"></a>01311 <span class="comment">//                      {</span>
<a name="l01312"></a>01312 <span class="comment">//                        libmesh_assert ((*it)-&gt;dof_number(sys_num, var, index) !=</span>
<a name="l01313"></a>01313 <span class="comment">//                                DofObject::invalid_id);                           </span>
<a name="l01314"></a>01314 <span class="comment">//                        libmesh_assert (cnt &lt; reordered_soln.size());</span>
<a name="l01315"></a>01315                           
<a name="l01316"></a>01316 <span class="comment">//                        reordered_soln[cnt++] = </span>
<a name="l01317"></a>01317 <span class="comment">//                          global_vector[(*it)-&gt;dof_number(sys_num, var, index)];</span>
<a name="l01318"></a>01318 <span class="comment">//                      }</span>
<a name="l01319"></a>01319 <span class="comment">//                }</span>
<a name="l01320"></a>01320 <span class="comment">//              }</span>
<a name="l01321"></a>01321 
<a name="l01322"></a>01322             
<a name="l01323"></a>01323 <span class="comment">//            // 10.)</span>
<a name="l01324"></a>01324 <span class="comment">//            //</span>
<a name="l01325"></a>01325 <span class="comment">//            // Actually write the reordered additional vector </span>
<a name="l01326"></a>01326 <span class="comment">//            // for this system to disk</span>
<a name="l01327"></a>01327 
<a name="l01328"></a>01328 <span class="comment">//            // set up the comment</span>
<a name="l01329"></a>01329 <span class="comment">//            {</span>
<a name="l01330"></a>01330 <span class="comment">//              comment = &quot;# System \&quot;&quot;;</span>
<a name="l01331"></a>01331 <span class="comment">//              comment += this-&gt;name(); </span>
<a name="l01332"></a>01332 <span class="comment">//              comment += &quot;\&quot; Additional Vector \&quot;&quot;;</span>
<a name="l01333"></a>01333 <span class="comment">//              comment += pos-&gt;first;</span>
<a name="l01334"></a>01334 <span class="comment">//              comment += &quot;\&quot;&quot;;</span>
<a name="l01335"></a>01335 <span class="comment">//            }</span>
<a name="l01336"></a>01336               
<a name="l01337"></a>01337 <span class="comment">//            io.data (reordered_soln, comment.c_str());          </span>
<a name="l01338"></a>01338 <span class="comment">//          }</span>
<a name="l01339"></a>01339 <span class="comment">//      }</span>
<a name="l01340"></a>01340 <span class="comment">//     }</span>
<a name="l01341"></a>01341 <span class="comment">// }</span>
<a name="l01342"></a>01342 
<a name="l01343"></a>01343 
<a name="l01344"></a>01344 
<a name="l01345"></a><a class="code" href="classlibMesh_1_1System.php#a6ce0f02169af7e0f55924c488bb63ad8">01345</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a6ce0f02169af7e0f55924c488bb63ad8">System::write_parallel_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io,
<a name="l01346"></a>01346                                   <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data)<span class="keyword"> const</span>
<a name="l01347"></a>01347 <span class="keyword"></span>{
<a name="l01367"></a>01367   std::string comment;
<a name="l01368"></a>01368   
<a name="l01369"></a>01369   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">writing</a>());
<a name="l01370"></a>01370 
<a name="l01371"></a>01371   std::vector&lt;Number&gt; io_buffer; io_buffer.reserve(this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;local_size());
<a name="l01372"></a>01372 
<a name="l01373"></a>01373   <span class="comment">// build the ordered nodes and element maps.</span>
<a name="l01374"></a>01374   <span class="comment">// when writing/reading parallel files we need to iterate</span>
<a name="l01375"></a>01375   <span class="comment">// over our nodes/elements in order of increasing global id().</span>
<a name="l01376"></a>01376   <span class="comment">// however, this is not guaranteed to be ordering we obtain</span>
<a name="l01377"></a>01377   <span class="comment">// by using the node_iterators/element_iterators directly.</span>
<a name="l01378"></a>01378   <span class="comment">// so build a set, sorted by id(), that provides the ordering.</span>
<a name="l01379"></a>01379   <span class="comment">// further, for memory economy build the set but then transfer</span>
<a name="l01380"></a>01380   <span class="comment">// its contents to vectors, which will be sorted.</span>
<a name="l01381"></a>01381   std::vector&lt;const DofObject*&gt; ordered_nodes, ordered_elements;
<a name="l01382"></a>01382   {    
<a name="l01383"></a>01383     std::set&lt;const DofObject*, CompareDofObjectsByID&gt;
<a name="l01384"></a>01384       ordered_nodes_set (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_begin(),
<a name="l01385"></a>01385                          this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_end());
<a name="l01386"></a>01386       
<a name="l01387"></a>01387       ordered_nodes.insert(ordered_nodes.end(),
<a name="l01388"></a>01388                            ordered_nodes_set.begin(),
<a name="l01389"></a>01389                            ordered_nodes_set.end());
<a name="l01390"></a>01390   }
<a name="l01391"></a>01391   {
<a name="l01392"></a>01392     std::set&lt;const DofObject*, CompareDofObjectsByID&gt;
<a name="l01393"></a>01393       ordered_elements_set (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_begin(),
<a name="l01394"></a>01394                             this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_end());
<a name="l01395"></a>01395       
<a name="l01396"></a>01396       ordered_elements.insert(ordered_elements.end(),
<a name="l01397"></a>01397                               ordered_elements_set.begin(),
<a name="l01398"></a>01398                               ordered_elements_set.end());
<a name="l01399"></a>01399   }
<a name="l01400"></a>01400   
<a name="l01401"></a>01401   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l01402"></a>01402   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>  = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l01403"></a>01403   
<a name="l01404"></a>01404   <span class="comment">// Loop over each non-SCALAR variable and each node, and write out the value.</span>
<a name="l01405"></a>01405   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; var++)
<a name="l01406"></a>01406     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).type().family != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01407"></a>01407     {
<a name="l01408"></a>01408       <span class="comment">// First write the node DOF values</span>
<a name="l01409"></a>01409       <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l01410"></a>01410              it = ordered_nodes.begin(); it != ordered_nodes.end(); ++it)      
<a name="l01411"></a>01411         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l01412"></a>01412           {
<a name="l01413"></a>01413             <span class="comment">//libMesh::out &lt;&lt; &quot;(*it)-&gt;id()=&quot; &lt;&lt; (*it)-&gt;id() &lt;&lt; std::endl;</span>
<a name="l01414"></a>01414             libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l01415"></a>01415                     <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01416"></a>01416             
<a name="l01417"></a>01417             io_buffer.push_back((*this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>)((*it)-&gt;dof_number(sys_num, var, comp)));
<a name="l01418"></a>01418           }
<a name="l01419"></a>01419 
<a name="l01420"></a>01420       <span class="comment">// Then write the element DOF values</span>
<a name="l01421"></a>01421       <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l01422"></a>01422              it = ordered_elements.begin(); it != ordered_elements.end(); ++it)
<a name="l01423"></a>01423         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l01424"></a>01424           {
<a name="l01425"></a>01425             libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l01426"></a>01426                     <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01427"></a>01427               
<a name="l01428"></a>01428             io_buffer.push_back((*this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>)((*it)-&gt;dof_number(sys_num, var, comp)));    
<a name="l01429"></a>01429           }
<a name="l01430"></a>01430     }
<a name="l01431"></a>01431 
<a name="l01432"></a>01432   <span class="comment">// Finally, write the SCALAR data on the last processor</span>
<a name="l01433"></a>01433   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l01434"></a>01434     <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01435"></a>01435       {
<a name="l01436"></a>01436         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l01437"></a>01437           {
<a name="l01438"></a>01438             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l01439"></a>01439             std::vector&lt;unsigned int&gt; SCALAR_dofs;
<a name="l01440"></a>01440             dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(SCALAR_dofs, var);
<a name="l01441"></a>01441 
<a name="l01442"></a>01442             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_dofs.size(); i++)
<a name="l01443"></a>01443               {
<a name="l01444"></a>01444                 io_buffer.push_back( (*this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>)(SCALAR_dofs[i]) );
<a name="l01445"></a>01445               }
<a name="l01446"></a>01446           }
<a name="l01447"></a>01447       }
<a name="l01448"></a>01448   
<a name="l01449"></a>01449   <span class="comment">// 9.)</span>
<a name="l01450"></a>01450   <span class="comment">//</span>
<a name="l01451"></a>01451   <span class="comment">// Actually write the reordered solution vector </span>
<a name="l01452"></a>01452   <span class="comment">// for the ith system to disk</span>
<a name="l01453"></a>01453   
<a name="l01454"></a>01454   <span class="comment">// set up the comment</span>
<a name="l01455"></a>01455   {
<a name="l01456"></a>01456     comment = <span class="stringliteral">&quot;# System \&quot;&quot;</span>;
<a name="l01457"></a>01457     comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01458"></a>01458     comment += <span class="stringliteral">&quot;\&quot; Solution Vector&quot;</span>;
<a name="l01459"></a>01459   }
<a name="l01460"></a>01460   
<a name="l01461"></a>01461   io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (io_buffer, comment.c_str());   
<a name="l01462"></a>01462   
<a name="l01463"></a>01463   <span class="comment">// Only write additional vectors if wanted  </span>
<a name="l01464"></a>01464   <span class="keywordflow">if</span> (write_additional_data)
<a name="l01465"></a>01465     {     
<a name="l01466"></a>01466       std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator
<a name="l01467"></a>01467         pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01468"></a>01468   
<a name="l01469"></a>01469       <span class="keywordflow">for</span>(; pos != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l01470"></a>01470         {
<a name="l01471"></a>01471           io_buffer.clear(); io_buffer.reserve( pos-&gt;second-&gt;local_size());
<a name="l01472"></a>01472           
<a name="l01473"></a>01473           <span class="comment">// Loop over each non-SCALAR variable and each node, and write out the value.</span>
<a name="l01474"></a>01474           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>; var++)
<a name="l01475"></a>01475             <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01476"></a>01476             {
<a name="l01477"></a>01477               <span class="comment">// First write the node DOF values</span>
<a name="l01478"></a>01478               <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l01479"></a>01479                      it = ordered_nodes.begin(); it != ordered_nodes.end(); ++it)      
<a name="l01480"></a>01480                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l01481"></a>01481                   {
<a name="l01482"></a>01482                     libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l01483"></a>01483                             <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01484"></a>01484                       
<a name="l01485"></a>01485                     io_buffer.push_back((*pos-&gt;second)((*it)-&gt;dof_number(sys_num, var, comp)));   
<a name="l01486"></a>01486                   }
<a name="l01487"></a>01487 
<a name="l01488"></a>01488               <span class="comment">// Then write the element DOF values</span>
<a name="l01489"></a>01489               <span class="keywordflow">for</span> (std::vector&lt;const DofObject*&gt;::const_iterator
<a name="l01490"></a>01490                      it = ordered_elements.begin(); it != ordered_elements.end(); ++it)
<a name="l01491"></a>01491                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l01492"></a>01492                   {
<a name="l01493"></a>01493                     libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) !=
<a name="l01494"></a>01494                             <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l01495"></a>01495               
<a name="l01496"></a>01496                     io_buffer.push_back((*pos-&gt;second)((*it)-&gt;dof_number(sys_num, var, comp)));
<a name="l01497"></a>01497                   }
<a name="l01498"></a>01498             }
<a name="l01499"></a>01499 
<a name="l01500"></a>01500             <span class="comment">// Finally, write the SCALAR data on the last processor</span>
<a name="l01501"></a>01501             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l01502"></a>01502               <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01503"></a>01503                 {
<a name="l01504"></a>01504                   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l01505"></a>01505                     {
<a name="l01506"></a>01506                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l01507"></a>01507                       std::vector&lt;unsigned int&gt; SCALAR_dofs;
<a name="l01508"></a>01508                       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(SCALAR_dofs, var);
<a name="l01509"></a>01509 
<a name="l01510"></a>01510                       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_dofs.size(); i++)
<a name="l01511"></a>01511                         {
<a name="l01512"></a>01512                           io_buffer.push_back( (*pos-&gt;second)(SCALAR_dofs[i]) );
<a name="l01513"></a>01513                         }
<a name="l01514"></a>01514                     }
<a name="l01515"></a>01515                 }
<a name="l01516"></a>01516           
<a name="l01517"></a>01517           <span class="comment">// 10.)</span>
<a name="l01518"></a>01518           <span class="comment">//</span>
<a name="l01519"></a>01519           <span class="comment">// Actually write the reordered additional vector </span>
<a name="l01520"></a>01520           <span class="comment">// for this system to disk</span>
<a name="l01521"></a>01521           
<a name="l01522"></a>01522           <span class="comment">// set up the comment</span>
<a name="l01523"></a>01523           {
<a name="l01524"></a>01524             comment = <span class="stringliteral">&quot;# System \&quot;&quot;</span>;
<a name="l01525"></a>01525             comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>(); 
<a name="l01526"></a>01526             comment += <span class="stringliteral">&quot;\&quot; Additional Vector \&quot;&quot;</span>;
<a name="l01527"></a>01527             comment += pos-&gt;first;
<a name="l01528"></a>01528             comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01529"></a>01529           }
<a name="l01530"></a>01530               
<a name="l01531"></a>01531           io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (io_buffer, comment.c_str());         
<a name="l01532"></a>01532         }
<a name="l01533"></a>01533     }
<a name="l01534"></a>01534 }
<a name="l01535"></a>01535 
<a name="l01536"></a>01536 
<a name="l01537"></a>01537 
<a name="l01538"></a><a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">01538</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#ae8063c135acc9c54240886e1ac3c9acd">System::write_serialized_data</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io,
<a name="l01539"></a>01539                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> write_additional_data)<span class="keyword"> const</span>
<a name="l01540"></a>01540 <span class="keyword"></span>{
<a name="l01554"></a>01554   parallel_only();
<a name="l01555"></a>01555   std::string comment;
<a name="l01556"></a>01556 
<a name="l01557"></a>01557   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a477f8f5cd5acba2aa5af78affa76b955">write_serialized_vector</a>(io, *this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>); 
<a name="l01558"></a>01558 
<a name="l01559"></a>01559   <span class="comment">// set up the comment</span>
<a name="l01560"></a>01560   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01561"></a>01561     {
<a name="l01562"></a>01562       comment = <span class="stringliteral">&quot;# System \&quot;&quot;</span>;
<a name="l01563"></a>01563       comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l01564"></a>01564       comment += <span class="stringliteral">&quot;\&quot; Solution Vector&quot;</span>;
<a name="l01565"></a>01565 
<a name="l01566"></a>01566       io.<a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">comment</a> (comment);
<a name="l01567"></a>01567     }
<a name="l01568"></a>01568 
<a name="l01569"></a>01569   <span class="comment">// Only write additional vectors if wanted  </span>
<a name="l01570"></a>01570   <span class="keywordflow">if</span> (write_additional_data)
<a name="l01571"></a>01571     {     
<a name="l01572"></a>01572       std::map&lt;std::string, NumericVector&lt;Number&gt;* &gt;::const_iterator
<a name="l01573"></a>01573         pos = <a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.begin();
<a name="l01574"></a>01574   
<a name="l01575"></a>01575       <span class="keywordflow">for</span>(; pos != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4068a7b090c2b32e2c73c018b4e22a80">_vectors</a>.end(); ++pos)
<a name="l01576"></a>01576         {
<a name="l01577"></a>01577           this-&gt;<a class="code" href="classlibMesh_1_1System.php#a477f8f5cd5acba2aa5af78affa76b955">write_serialized_vector</a>(io, *pos-&gt;second);
<a name="l01578"></a>01578 
<a name="l01579"></a>01579           <span class="comment">// set up the comment</span>
<a name="l01580"></a>01580           <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01581"></a>01581             {
<a name="l01582"></a>01582               comment = <span class="stringliteral">&quot;# System \&quot;&quot;</span>;
<a name="l01583"></a>01583               comment += this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>(); 
<a name="l01584"></a>01584               comment += <span class="stringliteral">&quot;\&quot; Additional Vector \&quot;&quot;</span>;
<a name="l01585"></a>01585               comment += pos-&gt;first;
<a name="l01586"></a>01586               comment += <span class="stringliteral">&quot;\&quot;&quot;</span>;
<a name="l01587"></a>01587               io.<a class="code" href="classlibMesh_1_1Xdr.php#a9d15d2f6ba8a973de45a86402a22a059">comment</a> (comment);       
<a name="l01588"></a>01588             }
<a name="l01589"></a>01589         }
<a name="l01590"></a>01590     }
<a name="l01591"></a>01591 }
<a name="l01592"></a>01592 
<a name="l01593"></a>01593 
<a name="l01594"></a>01594 
<a name="l01595"></a>01595 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l01596"></a><a class="code" href="classlibMesh_1_1System.php#ad06d512307afb47317e3215c52150021">01596</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#ad06d512307afb47317e3215c52150021">System::write_serialized_blocked_dof_objects</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l01597"></a>01597                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01598"></a>01598                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_objects,
<a name="l01599"></a>01599                                                            <span class="keyword">const</span> iterator_type begin,
<a name="l01600"></a>01600                                                            <span class="keyword">const</span> iterator_type end,
<a name="l01601"></a>01601                                                            <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io)<span class="keyword"> const</span>
<a name="l01602"></a>01602 <span class="keyword"></span>{
<a name="l01603"></a>01603   
<a name="l01604"></a>01604   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l01605"></a>01605   
<a name="l01606"></a>01606   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> written_length=0;                       <span class="comment">// The numer of values written.  This will be returned </span>
<a name="l01607"></a>01607   std::vector&lt;unsigned int&gt; xfer_ids;                  <span class="comment">// The global IDs and # of components for the local objects in the current block</span>
<a name="l01608"></a>01608   std::vector&lt;Number&gt;       xfer_vals;                 <span class="comment">// The raw values for the local objects in the current block</span>
<a name="l01609"></a>01609   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;              <span class="comment">// The global ID and # of components received from each processor</span>
<a name="l01610"></a>01610     recv_ids (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());                <span class="comment">//  for the current block</span>
<a name="l01611"></a>01611   std::vector&lt;std::vector&lt;Number&gt; &gt;                    <span class="comment">// The raw values received from each processor</span>
<a name="l01612"></a>01612     recv_vals(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());                <span class="comment">//  for the current block</span>
<a name="l01613"></a>01613   std::vector&lt;std::vector&lt;Number&gt;::iterator&gt;           <span class="comment">// The next value on each processor for the current block</span>
<a name="l01614"></a>01614     val_iters;
<a name="l01615"></a>01615   val_iters.reserve(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01616"></a>01616   std::vector&lt;unsigned int&gt; &amp;idx_map     = xfer_ids;   <span class="comment">// map to traverse entry-wise rather than processor-wise (renamed for notational convenience)</span>
<a name="l01617"></a>01617   std::vector&lt;Number&gt;       &amp;output_vals = xfer_vals;  <span class="comment">// The output buffer for the current block (renamed for notational convenience)</span>
<a name="l01618"></a>01618   
<a name="l01619"></a>01619   <span class="comment">//---------------------------------</span>
<a name="l01620"></a>01620   <span class="comment">// Collect the values for all objects</span>
<a name="l01621"></a>01621   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_object=0, last_object=0;
<a name="l01622"></a>01622   
<a name="l01623"></a>01623   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0; last_object&lt;<a class="code" href="classlibMesh_1_1ReferenceCounter.php#a50e74641afc6e2870c9e1ce412f8c44f">n_objects</a>; blk++)
<a name="l01624"></a>01624     {
<a name="l01625"></a>01625       <span class="comment">//libMesh::out &lt;&lt; &quot;Writing object block &quot; &lt;&lt; blk &lt;&lt; &quot; for var &quot; &lt;&lt; var &lt;&lt; std::endl;</span>
<a name="l01626"></a>01626       
<a name="l01627"></a>01627       <span class="comment">// Each processor should build up its transfer buffers for its</span>
<a name="l01628"></a>01628       <span class="comment">// local objects in [first_object,last_object).</span>
<a name="l01629"></a>01629       first_object = blk*io_blksize;
<a name="l01630"></a>01630       last_object  = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*io_blksize,n_objects);
<a name="l01631"></a>01631           
<a name="l01632"></a>01632       <span class="comment">// Clear the transfer buffers for this block.</span>
<a name="l01633"></a>01633       xfer_ids.clear(); xfer_vals.clear();
<a name="l01634"></a>01634       
<a name="l01635"></a>01635       <span class="keywordflow">for</span> (iterator_type it=begin; it!=end; ++it)
<a name="l01636"></a>01636         <span class="keywordflow">if</span> (((*it)-&gt;id() &gt;= first_object) &amp;&amp; <span class="comment">// object in [first_object,last_object)</span>
<a name="l01637"></a>01637             ((*it)-&gt;id() &lt;   last_object) &amp;&amp;
<a name="l01638"></a>01638             (*it)-&gt;n_comp(sys_num,var)  )    <span class="comment">// var has a nonzero # of components on this object</span>
<a name="l01639"></a>01639           {
<a name="l01640"></a>01640             xfer_ids.push_back((*it)-&gt;id());
<a name="l01641"></a>01641             xfer_ids.push_back((*it)-&gt;n_comp(sys_num, var));
<a name="l01642"></a>01642             
<a name="l01643"></a>01643             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;(*it)-&gt;n_comp(sys_num, var); comp++)
<a name="l01644"></a>01644               {
<a name="l01645"></a>01645                 libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) &gt;= vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>());
<a name="l01646"></a>01646                 libmesh_assert ((*it)-&gt;dof_number(sys_num, var, comp) &lt;  vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>());
<a name="l01647"></a>01647                 xfer_vals.push_back(vec((*it)-&gt;dof_number(sys_num, var, comp)));
<a name="l01648"></a>01648               }
<a name="l01649"></a>01649           }
<a name="l01650"></a>01650 
<a name="l01651"></a>01651       <span class="comment">//-----------------------------------------</span>
<a name="l01652"></a>01652       <span class="comment">// Send the transfer buffers to processor 0.</span>
<a name="l01653"></a>01653       
<a name="l01654"></a>01654       <span class="comment">// Get the size of the incoming buffers -- optionally</span>
<a name="l01655"></a>01655       <span class="comment">// we could over-size the recv buffers based on</span>
<a name="l01656"></a>01656       <span class="comment">// some maximum size to avoid these communications</span>
<a name="l01657"></a>01657       std::vector&lt;unsigned int&gt; ids_size, vals_size;
<a name="l01658"></a>01658       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_ids_size  = xfer_ids.size();
<a name="l01659"></a>01659       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_vals_size = xfer_vals.size();
<a name="l01660"></a>01660       
<a name="l01661"></a>01661       <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">Parallel::gather</a> (0, my_ids_size,  ids_size);
<a name="l01662"></a>01662       <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">Parallel::gather</a> (0, my_vals_size, vals_size);
<a name="l01663"></a>01663       
<a name="l01664"></a>01664       <span class="comment">// Note that we will actually send/receive to ourself if we are</span>
<a name="l01665"></a>01665       <span class="comment">// processor 0, so let&#39;s use nonblocking receives.</span>
<a name="l01666"></a>01666       std::vector&lt;Parallel::Request&gt;
<a name="l01667"></a>01667         id_request_handles(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l01668"></a>01668         val_request_handles(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01669"></a>01669       
<a name="l01670"></a>01670 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l01671"></a>01671 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a>
<a name="l01672"></a>01672         id_tag    = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(2345),
<a name="l01673"></a>01673         val_tag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(2346);
<a name="l01674"></a>01674       
<a name="l01675"></a>01675       <span class="comment">// Post the receives -- do this on processor 0 only.</span>
<a name="l01676"></a>01676       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01677"></a>01677         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l01678"></a>01678           {
<a name="l01679"></a>01679             recv_ids[pid].resize(ids_size[pid]);
<a name="l01680"></a>01680             recv_vals[pid].resize(vals_size[pid]);
<a name="l01681"></a>01681             
<a name="l01682"></a>01682             <a class="code" href="namespacelibMesh_1_1Parallel.php#adec0f142c1edef2d2145515475e95815">Parallel::nonblocking_receive</a> (pid, recv_ids[pid],
<a name="l01683"></a>01683                                            id_request_handles[pid],
<a name="l01684"></a>01684                                            id_tag);
<a name="l01685"></a>01685             <a class="code" href="namespacelibMesh_1_1Parallel.php#adec0f142c1edef2d2145515475e95815">Parallel::nonblocking_receive</a> (pid, recv_vals[pid],
<a name="l01686"></a>01686                                            val_request_handles[pid],
<a name="l01687"></a>01687                                            val_tag);
<a name="l01688"></a>01688           }
<a name="l01689"></a>01689       
<a name="l01690"></a>01690       <span class="comment">// Send -- do this on all processors.</span>
<a name="l01691"></a>01691       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(0, xfer_ids,  id_tag);
<a name="l01692"></a>01692       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(0, xfer_vals, val_tag);
<a name="l01693"></a>01693 <span class="preprocessor">#else</span>
<a name="l01694"></a>01694 <span class="preprocessor"></span>      <span class="comment">// On one processor there&#39;s nothing to send</span>
<a name="l01695"></a>01695       recv_ids[0] = xfer_ids;
<a name="l01696"></a>01696       recv_vals[0] = xfer_vals;
<a name="l01697"></a>01697 <span class="preprocessor">#endif</span>
<a name="l01698"></a>01698 <span class="preprocessor"></span>      
<a name="l01699"></a>01699       <span class="comment">// -------------------------------------------------------</span>
<a name="l01700"></a>01700       <span class="comment">// Receive the messages and write the output on processor 0.</span>
<a name="l01701"></a>01701       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01702"></a>01702         {
<a name="l01703"></a>01703           <span class="comment">// Wait for all the receives to complete. We have no</span>
<a name="l01704"></a>01704           <span class="comment">// need for the statuses since we already know the</span>
<a name="l01705"></a>01705           <span class="comment">// buffer sizes.</span>
<a name="l01706"></a>01706           <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (id_request_handles);
<a name="l01707"></a>01707           <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (val_request_handles);
<a name="l01708"></a>01708           
<a name="l01709"></a>01709           <span class="comment">// Write the values in this block.</span>
<a name="l01710"></a>01710           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_id_size=0, tot_val_size=0;
<a name="l01711"></a>01711           val_iters.clear();
<a name="l01712"></a>01712           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l01713"></a>01713             {
<a name="l01714"></a>01714               tot_id_size  += recv_ids[pid].size();                 
<a name="l01715"></a>01715               tot_val_size += recv_vals[pid].size();
<a name="l01716"></a>01716               val_iters.push_back(recv_vals[pid].begin());
<a name="l01717"></a>01717             }
<a name="l01718"></a>01718           
<a name="l01719"></a>01719           libmesh_assert (tot_id_size &lt;= 2*<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(io_blksize,n_objects));
<a name="l01720"></a>01720           
<a name="l01721"></a>01721           <span class="comment">// Create a map to avoid searching.  This will allow us to</span>
<a name="l01722"></a>01722           <span class="comment">// traverse the received values in [first_object,last_object) order.</span>
<a name="l01723"></a>01723           idx_map.resize(3*io_blksize); std::fill (idx_map.begin(), idx_map.end(), <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l01724"></a>01724           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l01725"></a>01725             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;recv_ids[pid].size(); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+=2)
<a name="l01726"></a>01726               {
<a name="l01727"></a>01727                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_idx = recv_ids[pid][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+0]-first_object;
<a name="l01728"></a>01728                 libmesh_assert (local_idx &lt; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(io_blksize,n_objects));
<a name="l01729"></a>01729                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp    = recv_ids[pid][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+1];
<a name="l01730"></a>01730                 
<a name="l01731"></a>01731                 idx_map[3*local_idx+0] = pid;
<a name="l01732"></a>01732                 idx_map[3*local_idx+1] = n_comp;
<a name="l01733"></a>01733                 idx_map[3*local_idx+2] = std::distance(recv_vals[pid].begin(), val_iters[pid]);
<a name="l01734"></a>01734                 val_iters[pid] += n_comp;
<a name="l01735"></a>01735               }
<a name="l01736"></a>01736 
<a name="l01737"></a>01737           output_vals.clear(); output_vals.reserve (tot_val_size);
<a name="l01738"></a>01738           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;idx_map.size(); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+=3)
<a name="l01739"></a>01739             <span class="keywordflow">if</span> (idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>] != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="comment">// this could happen when a local object</span>
<a name="l01740"></a>01740               {                                        <span class="comment">// has no components for the current variable</span>
<a name="l01741"></a>01741                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid       = idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+0];
<a name="l01742"></a>01742                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp    = idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+1];
<a name="l01743"></a>01743                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_pos = idx_map[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>+2];
<a name="l01744"></a>01744                 
<a name="l01745"></a>01745                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp=0; comp&lt;n_comp; comp++)
<a name="l01746"></a>01746                   {
<a name="l01747"></a>01747                     libmesh_assert (first_pos + comp &lt; recv_vals[pid].size());
<a name="l01748"></a>01748                     output_vals.push_back(recv_vals[pid][first_pos + comp]);
<a name="l01749"></a>01749                   }
<a name="l01750"></a>01750               }
<a name="l01751"></a>01751           libmesh_assert (output_vals.size() == tot_val_size);
<a name="l01752"></a>01752           
<a name="l01753"></a>01753           <span class="comment">// write the stream</span>
<a name="l01754"></a>01754           io.<a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">data_stream</a> (output_vals.empty() ? NULL : &amp;output_vals[0], output_vals.size());
<a name="l01755"></a>01755           written_length += output_vals.size();
<a name="l01756"></a>01756         } <span class="comment">// end processor 0 conditional block    </span>
<a name="l01757"></a>01757     } <span class="comment">// end object block loop</span>
<a name="l01758"></a>01758 
<a name="l01759"></a>01759   <span class="keywordflow">return</span> written_length;
<a name="l01760"></a>01760 }
<a name="l01761"></a>01761 
<a name="l01762"></a><a class="code" href="classlibMesh_1_1System.php#a25f805c53b81067c6460dad96d0eb8f6">01762</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a25f805c53b81067c6460dad96d0eb8f6">System::write_SCALAR_dofs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec,
<a name="l01763"></a>01763                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01764"></a>01764                                         <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> &amp;io)<span class="keyword"> const</span>
<a name="l01765"></a>01765 <span class="keyword"></span>{
<a name="l01766"></a>01766   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> written_length=0;
<a name="l01767"></a>01767   std::vector&lt;Number&gt; vals; <span class="comment">// The raw values for the local objects in the current block</span>
<a name="l01768"></a>01768   <span class="comment">// Collect the SCALARs for the current variable</span>
<a name="l01769"></a>01769   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l01770"></a>01770     {
<a name="l01771"></a>01771       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l01772"></a>01772       std::vector&lt;unsigned int&gt; SCALAR_dofs;
<a name="l01773"></a>01773       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a>(SCALAR_dofs, var);
<a name="l01774"></a>01774 
<a name="l01775"></a>01775       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;SCALAR_dofs.size(); i++)
<a name="l01776"></a>01776         {
<a name="l01777"></a>01777           vals.push_back( vec(SCALAR_dofs[i]) );
<a name="l01778"></a>01778         }
<a name="l01779"></a>01779     }
<a name="l01780"></a>01780 
<a name="l01781"></a>01781 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l01782"></a>01782 <span class="preprocessor"></span>  <span class="keywordflow">if</span> ( <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 )
<a name="l01783"></a>01783     {
<a name="l01784"></a>01784       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a> val_tag(1);
<a name="l01785"></a>01785       
<a name="l01786"></a>01786       <span class="comment">// Post the receive on processor 0</span>
<a name="l01787"></a>01787       <span class="keywordflow">if</span> ( <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0 )
<a name="l01788"></a>01788         {
<a name="l01789"></a>01789           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a>(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1, vals, val_tag);
<a name="l01790"></a>01790         }
<a name="l01791"></a>01791 
<a name="l01792"></a>01792       <span class="comment">// Send the data to processor 0</span>
<a name="l01793"></a>01793       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1))
<a name="l01794"></a>01794         {
<a name="l01795"></a>01795           <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a>(0, vals, val_tag);
<a name="l01796"></a>01796         }
<a name="l01797"></a>01797     }
<a name="l01798"></a>01798 <span class="preprocessor">#endif</span>
<a name="l01799"></a>01799 <span class="preprocessor"></span>
<a name="l01800"></a>01800   <span class="comment">// -------------------------------------------------------</span>
<a name="l01801"></a>01801   <span class="comment">// Write the output on processor 0.</span>
<a name="l01802"></a>01802   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01803"></a>01803     {
<a name="l01804"></a>01804       io.<a class="code" href="classlibMesh_1_1Xdr.php#a89f1c1a65390d6e3d168b5273913154c">data_stream</a> (&amp;vals[0], vals.size());
<a name="l01805"></a>01805       written_length += vals.size();
<a name="l01806"></a>01806     }
<a name="l01807"></a>01807 
<a name="l01808"></a>01808   <span class="keywordflow">return</span> written_length;
<a name="l01809"></a>01809 }
<a name="l01810"></a>01810 
<a name="l01811"></a>01811 
<a name="l01812"></a><a class="code" href="classlibMesh_1_1System.php#a477f8f5cd5acba2aa5af78affa76b955">01812</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1System.php#a477f8f5cd5acba2aa5af78affa76b955">System::write_serialized_vector</a> (<a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a>&amp; io, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l01813"></a>01813 <span class="keyword"></span>{
<a name="l01814"></a>01814   parallel_only();
<a name="l01815"></a>01815   
<a name="l01816"></a>01816   <span class="comment">// If this is not the same on all processors we&#39;re in trouble!</span>
<a name="l01817"></a>01817   libmesh_assert (<a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">Parallel::verify</a>(io_blksize));
<a name="l01818"></a>01818   libmesh_assert (io.<a class="code" href="classlibMesh_1_1Xdr.php#a55d24a44020695db1d5ea3d11d80ef77">writing</a>());
<a name="l01819"></a>01819   
<a name="l01820"></a>01820   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vec_length = vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>();
<a name="l01821"></a>01821   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (vec_length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01822"></a>01822   
<a name="l01823"></a>01823   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> written_length = 0;
<a name="l01824"></a>01824   
<a name="l01825"></a>01825   <span class="comment">// Loop over each non-SCALAR variable in the system, and then each node/element in the mesh.</span>
<a name="l01826"></a>01826   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l01827"></a>01827     <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01828"></a>01828     {
<a name="l01829"></a>01829       <span class="comment">//---------------------------------</span>
<a name="l01830"></a>01830       <span class="comment">// Collect the values for all nodes</span>
<a name="l01831"></a>01831       written_length +=
<a name="l01832"></a>01832         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ad06d512307afb47317e3215c52150021">write_serialized_blocked_dof_objects</a> (vec,
<a name="l01833"></a>01833                                                     var,
<a name="l01834"></a>01834                                                     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>(),
<a name="l01835"></a>01835                                                     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_begin(),
<a name="l01836"></a>01836                                                     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_nodes_end(),
<a name="l01837"></a>01837                                                     io);
<a name="l01838"></a>01838       
<a name="l01839"></a>01839       <span class="comment">//------------------------------------</span>
<a name="l01840"></a>01840       <span class="comment">// Collect the values for all elements</span>
<a name="l01841"></a>01841       written_length +=
<a name="l01842"></a>01842         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ad06d512307afb47317e3215c52150021">write_serialized_blocked_dof_objects</a> (vec,
<a name="l01843"></a>01843                                                     var,
<a name="l01844"></a>01844                                                     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>(),
<a name="l01845"></a>01845                                                     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_begin(),
<a name="l01846"></a>01846                                                     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().local_elements_end(),
<a name="l01847"></a>01847                                                     io);
<a name="l01848"></a>01848     } <span class="comment">// end variable loop</span>
<a name="l01849"></a>01849     
<a name="l01850"></a>01850   <span class="comment">// Finally loop over all the SCALAR variables</span>
<a name="l01851"></a>01851   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); var++)
<a name="l01852"></a>01852     <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var).<a class="code" href="classlibMesh_1_1Variable.php#a8dcb07137d70a83fcf5b412e08e2783e">type</a>().<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>)
<a name="l01853"></a>01853       {
<a name="l01854"></a>01854         written_length +=
<a name="l01855"></a>01855           this-&gt;<a class="code" href="classlibMesh_1_1System.php#a25f805c53b81067c6460dad96d0eb8f6">write_SCALAR_dofs</a> (vec, var, io);
<a name="l01856"></a>01856       }
<a name="l01857"></a>01857 
<a name="l01858"></a>01858   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01859"></a>01859     libmesh_assert(written_length == vec_length);
<a name="l01860"></a>01860 }
<a name="l01861"></a>01861 
<a name="l01862"></a>01862 } <span class="comment">// namespace libMesh</span>
<a name="l01863"></a>01863 
<a name="l01864"></a>01864 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
