<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">transient_rb_system.C</div>  </div>
</div>
<div class="contents">
<a href="transient__rb__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// LibMesh includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__system_8h.php">transient_rb_system.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="getpot_8h.php">getpot.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="transient__rb__evaluation_8h.php">transient_rb_evaluation.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// Need SLEPc to get the POD eigenvalues</span>
<a name="l00043"></a>00043 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="comment">// LAPACK include (via SLEPc)</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &lt;petscsys.h&gt;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &lt;slepcblaslapack.h&gt;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a332178f1af3116ae727fbcdcb03eb686">00052</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a332178f1af3116ae727fbcdcb03eb686">TransientRBSystem::TransientRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00053"></a>00053                     <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00054"></a>00054                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00055"></a>00055   : <a class="code" href="classlibMesh_1_1System.php">Parent</a>(es, name, number),
<a name="l00056"></a>00056     L2_matrix(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00057"></a>00057     nonzero_initialization(false),
<a name="l00058"></a>00058     compute_truth_projection_error(false),
<a name="l00059"></a>00059     init_filename(<span class="stringliteral">&quot;&quot;</span>),
<a name="l00060"></a>00060     dt(0.05),
<a name="l00061"></a>00061     euler_theta(1.),
<a name="l00062"></a>00062     _k(0),
<a name="l00063"></a>00063     _K(0),
<a name="l00064"></a>00064     POD_tol(-1.),
<a name="l00065"></a>00065     max_truth_solves(-1),
<a name="l00066"></a>00066     L2_assembly(NULL)
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.resize(0);
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   <span class="comment">// Clear the theta and assembly vectors so that we can push_back</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">theta_q_m_vector</a>.clear();
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>.clear();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a66cc224cd6cf5b3fe6ea704dc956b101">00077</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a66cc224cd6cf5b3fe6ea704dc956b101">TransientRBSystem::~TransientRBSystem</a> ()
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   this-&gt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">clear</a>();
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">00083</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7fd1249de92ea775b87fc6c26a193eb5">TransientRBSystem::clear</a>()
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1TransientSystem.php#aff00cbc23f30989911888cad863ee24b">Parent::clear</a>();
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="comment">// clear the mass matrices</span>
<a name="l00088"></a>00088   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00089"></a>00089   {
<a name="l00090"></a>00090     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q])
<a name="l00091"></a>00091     {
<a name="l00092"></a>00092       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q];
<a name="l00093"></a>00093       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q] = NULL;
<a name="l00094"></a>00094     }
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="comment">// clear the temporal_data</span>
<a name="l00098"></a>00098   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.size(); i++)
<a name="l00099"></a>00099   {
<a name="l00100"></a>00100     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i])
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]-&gt;clear();
<a name="l00103"></a>00103       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i];
<a name="l00104"></a>00104       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i] = NULL;
<a name="l00105"></a>00105     }
<a name="l00106"></a>00106   }
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.resize(0);
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">00110</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">TransientRBSystem::init_data</a>()
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112   <span class="comment">// Use the boolean initialize_mesh_dependent_data</span>
<a name="l00113"></a>00113   <span class="comment">// to determine whether or not we initialize the libMesh</span>
<a name="l00114"></a>00114   <span class="comment">// mesh-dependent data.</span>
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#abcbe187444a693974ccbf300517aaba1">initialize_mesh_dependent_data</a>)
<a name="l00117"></a>00117   {
<a name="l00118"></a>00118     <span class="comment">// Call the Parent&#39;s initialization routine.</span>
<a name="l00119"></a>00119     <a class="code" href="classlibMesh_1_1TransientSystem.php#a125261b1215285f17cb24424b36e9ee4">Parent::init_data</a>();
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121   <span class="keywordflow">else</span>
<a name="l00122"></a>00122   {
<a name="l00123"></a>00123     <span class="comment">// If we do not initialize mesh-dependent data, then we</span>
<a name="l00124"></a>00124     <span class="comment">// must skip initialization of Parent (=TransientSystem&lt;RBSystem&gt;)</span>
<a name="l00125"></a>00125     <span class="comment">// and just initialize RBSystem.</span>
<a name="l00126"></a>00126     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaff3a14e0f537aac7289e14239c0f3e5">RBSystem::init_data</a>();
<a name="l00127"></a>00127   }
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8c940d821026652ec874b4bf1e1d2788">00130</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a8c940d821026652ec874b4bf1e1d2788">TransientRBSystem::process_parameters_file</a> ()
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   <a class="code" href="classlibMesh_1_1RBSystem.php#a7a1f96647b766dba6edef7d2abbdb7dc">Parent::process_parameters_file</a>();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Indicate that we need to compute the RB</span>
<a name="l00135"></a>00135   <span class="comment">// inner product matrix in this case</span>
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1RBSystem.php#a52ba5c957ff8b7f85ae16707df632b67">compute_RB_inner_product</a> = <span class="keyword">true</span>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// Read in data from parameters_filename</span>
<a name="l00139"></a>00139   GetPot infile(<a class="code" href="classlibMesh_1_1RBSystem.php#a3aa3cce2414d86488881e1bbe4adcd00">parameters_filename</a>);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a> = infile(<span class="stringliteral">&quot;nonzero_initialization&quot;</span>,<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>);
<a name="l00142"></a>00142   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a> = infile(<span class="stringliteral">&quot;init_filename&quot;</span>,<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a>);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> K_in                    = infile(<span class="stringliteral">&quot;K&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>);
<a name="l00145"></a>00145   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dt_in                     = infile(<span class="stringliteral">&quot;dt&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a04397bf3cc20ccd2bb5056c22b45c9f5">dt</a>);
<a name="l00146"></a>00146   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> euler_theta_in            = infile(<span class="stringliteral">&quot;euler_theta&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5af426f9dc2b27772aef689c19fbf4b0">euler_theta</a>);
<a name="l00147"></a>00147   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> POD_tol_in                = infile(<span class="stringliteral">&quot;POD_tol&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>);
<a name="l00148"></a>00148   <span class="keyword">const</span> <span class="keywordtype">int</span> max_truth_solves_in        = infile(<span class="stringliteral">&quot;max_truth_solves&quot;</span>, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a>);
<a name="l00149"></a>00149   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> delta_N_in        = infile(<span class="stringliteral">&quot;delta_N&quot;</span>, <a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a287beb41c8dcc60c976eb4a95146ea84">set_K</a>(K_in);
<a name="l00152"></a>00152   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a64abf8bdf7b064b4704c09c8f4f50682">set_dt</a>(dt_in);
<a name="l00153"></a>00153   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a91b4d8e4e75b43cc4958945198a39efd">set_euler_theta</a>(euler_theta_in);
<a name="l00154"></a>00154   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af3a1ec2ed58b491118a32521bf9d6b55">set_POD_tol</a>(POD_tol_in);
<a name="l00155"></a>00155   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae6b33671e8cc08ffa859f6c32ce15506">set_max_truth_solves</a>(max_truth_solves_in);
<a name="l00156"></a>00156   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(delta_N_in);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;TransientRBSystem parameters:&quot;</span> &lt;&lt; std::endl;
<a name="l00159"></a>00159   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Q_m: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>() &lt;&lt; std::endl;
<a name="l00160"></a>00160   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Number of time-steps: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>() &lt;&lt; std::endl;
<a name="l00161"></a>00161   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;dt: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>() &lt;&lt; std::endl;
<a name="l00162"></a>00162   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;euler_theta (time discretization parameter): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>() &lt;&lt; std::endl;
<a name="l00163"></a>00163   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">get_POD_tol</a>() &gt; 0.)
<a name="l00164"></a>00164     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;POD_tol: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a00d040b3d3e32c093838a49ae143dfc9">get_POD_tol</a>() &lt;&lt; std::endl;
<a name="l00165"></a>00165   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a> &gt; 0)
<a name="l00166"></a>00166     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of truth solves: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a50ac30217ac9358f43981e9e04d930c9">max_truth_solves</a> &lt;&lt; std::endl;
<a name="l00167"></a>00167   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;delta_N (number of basis functions to add each POD-Greedy step): &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>() &lt;&lt; std::endl;
<a name="l00168"></a>00168   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l00169"></a>00169   {
<a name="l00170"></a>00170     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading initial condition from &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a> &lt;&lt; std::endl;
<a name="l00171"></a>00171   }
<a name="l00172"></a>00172   <span class="keywordflow">else</span>
<a name="l00173"></a>00173   {
<a name="l00174"></a>00174     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Using zero initial condition&quot;</span> &lt;&lt; std::endl;
<a name="l00175"></a>00175   }
<a name="l00176"></a>00176   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ace8ecc6387181c68bc6583b414a5bd38">00179</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ace8ecc6387181c68bc6583b414a5bd38">TransientRBSystem::allocate_data_structures</a>()
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181   <a class="code" href="classlibMesh_1_1RBSystem.php#a1c9c1a00a85356890dd4f3e4ae0acbac">Parent::allocate_data_structures</a>();
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// Resize vectors for storing mesh-dependent data but only</span>
<a name="l00184"></a>00184   <span class="comment">// initialize if initialize_mesh_dependent_data == true</span>
<a name="l00185"></a>00185   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_time_levels = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d6afd63f9ec53e44cf75eb982df07c4">get_K</a>()+1;
<a name="l00186"></a>00186   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.resize(n_time_levels);
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="comment">// Resize vectors for storing mesh-dependent data but only</span>
<a name="l00189"></a>00189   <span class="comment">// initialize if initialize_mesh_dependent_data == true</span>
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>.resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00191"></a>00191   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBBase.php#abcbe187444a693974ccbf300517aaba1">initialize_mesh_dependent_data</a>)
<a name="l00192"></a>00192   {
<a name="l00193"></a>00193     <span class="comment">// Only initialize the mass matrices if we</span>
<a name="l00194"></a>00194     <span class="comment">// are not in low-memory mode</span>
<a name="l00195"></a>00195     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00196"></a>00196     {
<a name="l00197"></a>00197       <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00198"></a>00198 
<a name="l00199"></a>00199       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>);
<a name="l00200"></a>00200       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;init();
<a name="l00201"></a>00201       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;zero();
<a name="l00202"></a>00202       
<a name="l00203"></a>00203       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00204"></a>00204       {
<a name="l00205"></a>00205         <span class="comment">// Initialize the memory for the matrices</span>
<a name="l00206"></a>00206         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q] = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00207"></a>00207         dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q]);
<a name="l00208"></a>00208         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q]-&gt;init();
<a name="l00209"></a>00209         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q]-&gt;zero();
<a name="l00210"></a>00210       }
<a name="l00211"></a>00211     }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_time_levels; i++)
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l00216"></a>00216       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218   }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="comment">// and the truth output vectors</span>
<a name="l00221"></a>00221   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>.resize(<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>());
<a name="l00222"></a>00222   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00223"></a>00223   {
<a name="l00224"></a>00224     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n].resize(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00225"></a>00225   }
<a name="l00226"></a>00226   
<a name="l00227"></a>00227   <span class="comment">// This vector is for storing rhs entries for</span>
<a name="l00228"></a>00228   <span class="comment">// computing the projection of the initial condition</span>
<a name="l00229"></a>00229   <span class="comment">// into the RB space</span>
<a name="l00230"></a>00230   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#ab47d6a963c4f68b5a3d1eea7905257f5">Nmax</a>);
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af1f68b4b920581dc6fb19f47f2fbd561">00233</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af1f68b4b920581dc6fb19f47f2fbd561">TransientRBSystem::initialize_RB_system</a>(<span class="keywordtype">bool</span> do_not_assemble)
<a name="l00234"></a>00234 {
<a name="l00235"></a>00235   <a class="code" href="classlibMesh_1_1RBSystem.php#ab1fed51de792660e9124b27469ab18dd">Parent::initialize_RB_system</a>(do_not_assemble);
<a name="l00236"></a>00236   
<a name="l00237"></a>00237   <span class="comment">// Now update RB_ic_proj_rhs_all_N if necessary.</span>
<a name="l00238"></a>00238   <span class="comment">// This allows us to compute the L2 projection</span>
<a name="l00239"></a>00239   <span class="comment">// of the initial condition into the RB space</span>
<a name="l00240"></a>00240   <span class="comment">// so that we can continue to enrich a given RB</span>
<a name="l00241"></a>00241   <span class="comment">// space.</span>
<a name="l00242"></a>00242   <span class="keywordflow">if</span>(!do_not_assemble)
<a name="l00243"></a>00243     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt; 0)
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245       <span class="comment">// Load the initial condition into the solution vector</span>
<a name="l00246"></a>00246       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp1 = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00249"></a>00249       temp1-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251       <span class="comment">// First compute the right-hand side vector for the L2 projection</span>
<a name="l00252"></a>00252       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00253"></a>00253       {
<a name="l00254"></a>00254         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00255"></a>00255       }
<a name="l00256"></a>00256       <span class="keywordflow">else</span>
<a name="l00257"></a>00257       {
<a name="l00258"></a>00258         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00259"></a>00259         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00260"></a>00260       }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); i++)
<a name="l00263"></a>00263       {
<a name="l00264"></a>00264         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>(i) = temp1-&gt;dot(<a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l00265"></a>00265       }
<a name="l00266"></a>00266     }
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 
<a name="l00269"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3579b9bc66d8b143704d0674d40184be">00269</a> <a class="code" href="classlibMesh_1_1RBEvaluation.php">RBEvaluation</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a3579b9bc66d8b143704d0674d40184be">TransientRBSystem::add_new_rb_evaluation_object</a>()
<a name="l00270"></a>00270 {
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a>* e = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a>(*<span class="keyword">this</span>);
<a name="l00272"></a>00272   <a class="code" href="classlibMesh_1_1RBSystem.php#a465a32a7ecf189138b5d660bbd19cbf4">rb_evaluation_objects</a>.push_back(e);
<a name="l00273"></a>00273   
<a name="l00274"></a>00274   <span class="keywordflow">return</span> e;
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4c3ddeb0c9fd2b3c56b0273396464ebc">00277</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4c3ddeb0c9fd2b3c56b0273396464ebc">TransientRBSystem::train_reduced_basis</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00278"></a>00278 {
<a name="l00279"></a>00279   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a88b1c2f6e963c1af2b38cc3c2a3eb190">compute_truth_projection_error</a> = <span class="keyword">true</span>;
<a name="l00280"></a>00280   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value = <a class="code" href="classlibMesh_1_1RBSystem.php#aa4881a599b045f666d63f824e86b5054">Parent::train_reduced_basis</a>(directory_name);
<a name="l00281"></a>00281   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a88b1c2f6e963c1af2b38cc3c2a3eb190">compute_truth_projection_error</a> = <span class="keyword">false</span>;
<a name="l00282"></a>00282   
<a name="l00283"></a>00283   <span class="keywordflow">return</span> value;
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 
<a name="l00286"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">00286</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">TransientRBSystem::get_M_q</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00287"></a>00287 {
<a name="l00288"></a>00288   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00289"></a>00289   {
<a name="l00290"></a>00290     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: The affine matrices are not store in low-memory mode.&quot;</span> &lt;&lt; std::endl;
<a name="l00291"></a>00291     libmesh_error();
<a name="l00292"></a>00292   }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>())
<a name="l00295"></a>00295   {
<a name="l00296"></a>00296     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_m in get_M_q.&quot;</span>
<a name="l00297"></a>00297                  &lt;&lt; std::endl;
<a name="l00298"></a>00298     libmesh_error();
<a name="l00299"></a>00299   }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q];
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">00304</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">TransientRBSystem::eval_theta_q_m</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q)
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>())
<a name="l00307"></a>00307   {
<a name="l00308"></a>00308     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_m in eval_theta_q_m.&quot;</span>
<a name="l00309"></a>00309                  &lt;&lt; std::endl;
<a name="l00310"></a>00310     libmesh_error();
<a name="l00311"></a>00311   }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   libmesh_assert(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">theta_q_m_vector</a>[q] != NULL);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">theta_q_m_vector</a>[q]-&gt;evaluate( <a class="code" href="classlibMesh_1_1RBBase.php#af3bb451bd612eb5e7e8f0684f4b9cc97">get_current_parameters</a>() );
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
<a name="l00318"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">00318</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">TransientRBSystem::assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00321"></a>00321   <a class="code" href="classlibMesh_1_1RBSystem.php#a9cc9c114e957dd3efe0ccc11ae2d4cca">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a96a8761554ddf4b1cf2734f94fcda800">L2_assembly</a>, input_matrix, NULL);
<a name="l00322"></a>00322 }
<a name="l00323"></a>00323 
<a name="l00324"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9171ce91830a0ebfddb1666078552366">00324</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9171ce91830a0ebfddb1666078552366">TransientRBSystem::assemble_mass_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00325"></a>00325 {
<a name="l00326"></a>00326   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00327"></a>00327   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">add_scaled_mass_matrix</a>(1., input_matrix);
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">00330</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">TransientRBSystem::add_scaled_mass_matrix</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00333"></a>00333   {
<a name="l00334"></a>00334     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00335"></a>00335       input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(scalar * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q), *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q));
<a name="l00336"></a>00336   }
<a name="l00337"></a>00337   <span class="keywordflow">else</span>
<a name="l00338"></a>00338   {
<a name="l00339"></a>00339     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00340"></a>00340       <a class="code" href="classlibMesh_1_1RBSystem.php#a9cc9c114e957dd3efe0ccc11ae2d4cca">add_scaled_matrix_and_vector</a>(scalar * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q),
<a name="l00341"></a>00341                                    <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>[q],
<a name="l00342"></a>00342                                    input_matrix,
<a name="l00343"></a>00343                                    NULL);
<a name="l00344"></a>00344   }
<a name="l00345"></a>00345 }
<a name="l00346"></a>00346 
<a name="l00347"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">00347</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">TransientRBSystem::mass_matrix_scaled_matvec</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> scalar,
<a name="l00348"></a>00348                                                   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; dest,
<a name="l00349"></a>00349                                                   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; arg)
<a name="l00350"></a>00350 {
<a name="l00351"></a>00351   START_LOG(<span class="stringliteral">&quot;mass_matrix_scaled_matvec()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00352"></a>00352   
<a name="l00353"></a>00353   dest.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp_vec = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00356"></a>00356   temp_vec-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00357"></a>00357         
<a name="l00358"></a>00358   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00359"></a>00359   {
<a name="l00360"></a>00360     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00361"></a>00361     {
<a name="l00362"></a>00362       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp_vec, arg);
<a name="l00363"></a>00363     }
<a name="l00364"></a>00364     <span class="keywordflow">else</span>
<a name="l00365"></a>00365     {
<a name="l00366"></a>00366       <a class="code" href="classlibMesh_1_1RBSystem.php#ad0a9b785750043ab4777aa9825ffe67d">assemble_scaled_matvec</a>(1.,
<a name="l00367"></a>00367                              <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>[q],
<a name="l00368"></a>00368                              *temp_vec,
<a name="l00369"></a>00369                              arg);
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371     dest.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(scalar * <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q), *temp_vec);
<a name="l00372"></a>00372   }
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   STOP_LOG(<span class="stringliteral">&quot;mass_matrix_scaled_matvec()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00375"></a>00375 }
<a name="l00376"></a>00376 
<a name="l00377"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">00377</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">TransientRBSystem::truth_assembly</a>()
<a name="l00378"></a>00378 {
<a name="l00379"></a>00379   START_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00382"></a>00382   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00385"></a>00385   {
<a name="l00386"></a>00386     <span class="comment">// We should have already assembled the matrices</span>
<a name="l00387"></a>00387     <span class="comment">// and vectors in the affine expansion, so</span>
<a name="l00388"></a>00388     <span class="comment">// just use them</span>
<a name="l00389"></a>00389 
<a name="l00390"></a>00390     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a380f4b25919a4c93733eed98862b8f7b">add_scaled_mass_matrix</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>(), <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00391"></a>00391     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca376bda2868976ae336c53078c9d40c">mass_matrix_scaled_matvec</a>(1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>(), *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>);
<a name="l00392"></a>00392     
<a name="l00393"></a>00393     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp_vec = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00394"></a>00394     temp_vec-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00395"></a>00395 
<a name="l00396"></a>00396     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00397"></a>00397     {
<a name="l00398"></a>00398       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a), *<a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a));
<a name="l00399"></a>00399 
<a name="l00400"></a>00400       <a class="code" href="classlibMesh_1_1RBSystem.php#aef1516ea2eb482f28578cab98bd53097">get_A_q</a>(q_a)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp_vec, *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>);
<a name="l00401"></a>00401       temp_vec-&gt;scale( -(1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a) );
<a name="l00402"></a>00402       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(*temp_vec);
<a name="l00403"></a>00403     }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00406"></a>00406     {
<a name="l00407"></a>00407       *temp_vec = *<a class="code" href="classlibMesh_1_1RBSystem.php#a1b3f04b60e3464d779c140c280e1010e">get_F_q</a>(q_f);
<a name="l00408"></a>00408       temp_vec-&gt;scale( <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f) );
<a name="l00409"></a>00409       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(*temp_vec);
<a name="l00410"></a>00410     }
<a name="l00411"></a>00411     <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l00412"></a>00412 
<a name="l00413"></a>00413     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l00414"></a>00414       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   }
<a name="l00417"></a>00417   <span class="keywordflow">else</span>
<a name="l00418"></a>00418   {
<a name="l00419"></a>00419     <span class="comment">// In low memory mode we do not store the matrices</span>
<a name="l00420"></a>00420     <span class="comment">// from the affine expansion, so need to assemble</span>
<a name="l00421"></a>00421 
<a name="l00422"></a>00422     <span class="comment">// For efficiency (i.e. to avoid doing Q_a+Q_f loops</span>
<a name="l00423"></a>00423     <span class="comment">// over the mesh) we do not use add_scaled_matrix_and_vector</span>
<a name="l00424"></a>00424     <span class="comment">// here</span>
<a name="l00425"></a>00425 
<a name="l00426"></a>00426     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00427"></a>00427     
<a name="l00428"></a>00428     std::vector&lt;FEMContext*&gt; Mq_context(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>());
<a name="l00429"></a>00429     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;Mq_context.size(); q_m++)
<a name="l00430"></a>00430     {
<a name="l00431"></a>00431       Mq_context[q_m] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00432"></a>00432       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Mq_context[q_m]);
<a name="l00433"></a>00433     }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435     std::vector&lt;FEMContext*&gt; Aq_context(<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>());
<a name="l00436"></a>00436     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;Aq_context.size(); q_a++)
<a name="l00437"></a>00437     {
<a name="l00438"></a>00438       Aq_context[q_a] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00439"></a>00439       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Aq_context[q_a]);
<a name="l00440"></a>00440     }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442     std::vector&lt;FEMContext*&gt; Fq_context(<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>());
<a name="l00443"></a>00443     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;Fq_context.size(); q_f++)
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445       Fq_context[q_f] = this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#aab5505a99e58300d0e4e17b31943f162">build_context</a>().release();
<a name="l00446"></a>00446       this-&gt;<a class="code" href="classlibMesh_1_1RBSystem.php#a2a9e0cb788597d488aa73e9108147ef2">init_context</a>(*Fq_context[q_f]);
<a name="l00447"></a>00447     }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00450"></a>00450     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00451"></a>00451 
<a name="l00452"></a>00452     <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00453"></a>00453     {
<a name="l00454"></a>00454       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00455"></a>00455       {
<a name="l00456"></a>00456         Mq_context[q_m]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00457"></a>00457         Mq_context[q_m]-&gt;elem_fe_reinit();
<a name="l00458"></a>00458         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>[q_m]-&gt;interior_assembly(*Mq_context[q_m]);
<a name="l00459"></a>00459         <span class="comment">// Now overwrite the local matrix with a matrix multiplication</span>
<a name="l00460"></a>00460         Mq_context[q_m]-&gt;elem_jacobian.vector_mult(Mq_context[q_m]-&gt;elem_residual, Mq_context[q_m]-&gt;elem_solution);
<a name="l00461"></a>00461       }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00464"></a>00464       {
<a name="l00465"></a>00465         Aq_context[q_a]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00466"></a>00466         Aq_context[q_a]-&gt;elem_fe_reinit();
<a name="l00467"></a>00467         <a class="code" href="classlibMesh_1_1RBSystem.php#ad5491bba0da39e7003947d15599bc200">A_q_assembly_vector</a>[q_a]-&gt;interior_assembly(*Aq_context[q_a]);
<a name="l00468"></a>00468         <span class="comment">// Now overwrite the local matrix with a matrix multiplication</span>
<a name="l00469"></a>00469         Aq_context[q_a]-&gt;elem_jacobian.vector_mult(Aq_context[q_a]-&gt;elem_residual, Aq_context[q_a]-&gt;elem_solution);
<a name="l00470"></a>00470       }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00473"></a>00473       {
<a name="l00474"></a>00474         Fq_context[q_f]-&gt;pre_fe_reinit(*<span class="keyword">this</span>, *el);
<a name="l00475"></a>00475         Fq_context[q_f]-&gt;elem_fe_reinit();
<a name="l00476"></a>00476         <a class="code" href="classlibMesh_1_1RBSystem.php#ad9af308a3a1c8684a4dd800b24fc430e">F_q_assembly_vector</a>[q_f]-&gt;interior_assembly(*Fq_context[q_f]);
<a name="l00477"></a>00477       }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479       <span class="keywordflow">for</span> (Aq_context[0]-&gt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = 0;
<a name="l00480"></a>00480             Aq_context[0]-&gt;side != Aq_context[0]-&gt;elem-&gt;n_sides();
<a name="l00481"></a>00481             ++Aq_context[0]-&gt;side)
<a name="l00482"></a>00482       {
<a name="l00483"></a>00483         <span class="comment">// May not need to apply fluxes on non-boundary elements</span>
<a name="l00484"></a>00484         <span class="keywordflow">if</span>( (Aq_context[0]-&gt;elem-&gt;neighbor(Aq_context[0]-&gt;side) != NULL) &amp;&amp; !<a class="code" href="classlibMesh_1_1RBSystem.php#ab76a069a5cb7bb72afe582be842d8e04">impose_internal_fluxes</a> )
<a name="l00485"></a>00485           <span class="keywordflow">continue</span>;
<a name="l00486"></a>00486 
<a name="l00487"></a>00487         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00488"></a>00488         {
<a name="l00489"></a>00489           Mq_context[q_m]-&gt;side = Mq_context[0]-&gt;side;
<a name="l00490"></a>00490 
<a name="l00491"></a>00491           Mq_context[q_m]-&gt;side_fe_reinit();
<a name="l00492"></a>00492           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>[q_m]-&gt;boundary_assembly(*Mq_context[q_m]);
<a name="l00493"></a>00493         }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00496"></a>00496         {
<a name="l00497"></a>00497           Aq_context[q_a]-&gt;side = Aq_context[0]-&gt;side;
<a name="l00498"></a>00498 
<a name="l00499"></a>00499           Aq_context[q_a]-&gt;side_fe_reinit();
<a name="l00500"></a>00500           <a class="code" href="classlibMesh_1_1RBSystem.php#ad5491bba0da39e7003947d15599bc200">A_q_assembly_vector</a>[q_a]-&gt;boundary_assembly(*Aq_context[q_a]);
<a name="l00501"></a>00501         }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503         <span class="comment">// Impose boundary terms, e.g. Neuman BCs</span>
<a name="l00504"></a>00504         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00505"></a>00505         {
<a name="l00506"></a>00506           <span class="comment">// Update the side information for all contexts</span>
<a name="l00507"></a>00507           Fq_context[q_f]-&gt;side = Aq_context[0]-&gt;side;
<a name="l00508"></a>00508 
<a name="l00509"></a>00509           Fq_context[q_f]-&gt;side_fe_reinit();
<a name="l00510"></a>00510           <a class="code" href="classlibMesh_1_1RBSystem.php#ad9af308a3a1c8684a4dd800b24fc430e">F_q_assembly_vector</a>[q_f]-&gt;boundary_assembly(*Fq_context[q_f]);
<a name="l00511"></a>00511         }
<a name="l00512"></a>00512       }
<a name="l00513"></a>00513 
<a name="l00514"></a>00514       <span class="comment">// Constrain the dofs to impose hanging node or periodic constraints</span>
<a name="l00515"></a>00515       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00516"></a>00516       {
<a name="l00517"></a>00517         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00518"></a>00518           (Mq_context[q_m]-&gt;elem_jacobian, Mq_context[q_m]-&gt;elem_residual, Mq_context[q_m]-&gt;dof_indices);
<a name="l00519"></a>00519       }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00522"></a>00522       {
<a name="l00523"></a>00523         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00524"></a>00524           (Aq_context[q_a]-&gt;elem_jacobian, Aq_context[q_a]-&gt;elem_residual, Aq_context[q_a]-&gt;dof_indices);
<a name="l00525"></a>00525       }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00528"></a>00528       {
<a name="l00529"></a>00529         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00530"></a>00530           (Fq_context[q_f]-&gt;elem_jacobian, Fq_context[q_f]-&gt;elem_residual, Fq_context[q_f]-&gt;dof_indices);
<a name="l00531"></a>00531       }
<a name="l00532"></a>00532         
<a name="l00533"></a>00533       <span class="comment">// Apply Dirichlet boundary conditions, we assume zero Dirichlet BCs</span>
<a name="l00534"></a>00534       <span class="comment">// Note that this cannot be inside the side-loop since non-boundary</span>
<a name="l00535"></a>00535       <span class="comment">// elements may contain boundary dofs</span>
<a name="l00536"></a>00536       std::set&lt;unsigned int&gt;::const_iterator iter;
<a name="l00537"></a>00537       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;Aq_context[0]-&gt;dof_indices.size(); n++)
<a name="l00538"></a>00538       {
<a name="l00539"></a>00539         iter = <a class="code" href="classlibMesh_1_1RBSystem.php#ac1607788bc38fb49c179b386fcea96b6">global_dirichlet_dofs_set</a>.find( Aq_context[0]-&gt;dof_indices[n] );
<a name="l00540"></a>00540         <span class="keywordflow">if</span>(iter != <a class="code" href="classlibMesh_1_1RBSystem.php#ac1607788bc38fb49c179b386fcea96b6">global_dirichlet_dofs_set</a>.end())
<a name="l00541"></a>00541         {
<a name="l00542"></a>00542           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00543"></a>00543           {
<a name="l00544"></a>00544             Aq_context[q_a]-&gt;elem_jacobian.condense
<a name="l00545"></a>00545               (n,n,0.,Aq_context[q_a]-&gt;elem_residual);
<a name="l00546"></a>00546           }
<a name="l00547"></a>00547 
<a name="l00548"></a>00548           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00549"></a>00549           {
<a name="l00550"></a>00550             Fq_context[q_f]-&gt;elem_jacobian.condense
<a name="l00551"></a>00551               (n,n,0.,Fq_context[q_f]-&gt;elem_residual);
<a name="l00552"></a>00552           }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00555"></a>00555           {
<a name="l00556"></a>00556             Mq_context[q_m]-&gt;elem_jacobian.condense
<a name="l00557"></a>00557               (n,n,0.,Mq_context[q_m]-&gt;elem_residual);
<a name="l00558"></a>00558           }
<a name="l00559"></a>00559         }
<a name="l00560"></a>00560       }
<a name="l00561"></a>00561 
<a name="l00562"></a>00562       <span class="comment">// Finally, add local matrices/vectors to the global system</span>
<a name="l00563"></a>00563       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l00564"></a>00564       {
<a name="l00565"></a>00565         Aq_context[q_a]-&gt;elem_jacobian *= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>()*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00566"></a>00566         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (Aq_context[q_a]-&gt;elem_jacobian,
<a name="l00567"></a>00567                                   Aq_context[q_a]-&gt;dof_indices);
<a name="l00568"></a>00568         Aq_context[q_a]-&gt;elem_residual *= -(1.-<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a546f47bca2dec636e0fe9c095c3dc3dd">get_euler_theta</a>())*<a class="code" href="classlibMesh_1_1RBBase.php#aeeb46ce2b390bf820f954976ee9da7ce">eval_theta_q_a</a>(q_a);
<a name="l00569"></a>00569         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>    (Aq_context[q_a]-&gt;elem_residual,
<a name="l00570"></a>00570                                   Aq_context[q_a]-&gt;dof_indices);
<a name="l00571"></a>00571       }
<a name="l00572"></a>00572 
<a name="l00573"></a>00573       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l00574"></a>00574       {
<a name="l00575"></a>00575         Fq_context[q_f]-&gt;elem_residual *= <a class="code" href="classlibMesh_1_1RBSystem.php#a0fd951279c9b851ac38443156b4b18bd">eval_theta_q_f</a>(q_f);
<a name="l00576"></a>00576         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (Fq_context[q_f]-&gt;elem_residual,
<a name="l00577"></a>00577                                Fq_context[q_f]-&gt;dof_indices);
<a name="l00578"></a>00578       }
<a name="l00579"></a>00579 
<a name="l00580"></a>00580       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l00581"></a>00581       {
<a name="l00582"></a>00582         Mq_context[q_m]-&gt;elem_jacobian *= 1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>()*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00583"></a>00583         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (Mq_context[q_m]-&gt;elem_jacobian,
<a name="l00584"></a>00584                                   Mq_context[q_m]-&gt;dof_indices);
<a name="l00585"></a>00585         Mq_context[q_m]-&gt;elem_residual *= 1./<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>()*<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a36a6aa3be4fb96b256cb9d664e5a2dfb">eval_theta_q_m</a>(q_m);
<a name="l00586"></a>00586         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>    (Mq_context[q_m]-&gt;elem_residual,
<a name="l00587"></a>00587                                   Mq_context[q_m]-&gt;dof_indices);
<a name="l00588"></a>00588       }
<a name="l00589"></a>00589     }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l00592"></a>00592       <a class="code" href="classlibMesh_1_1RBSystem.php#a9cc9c114e957dd3efe0ccc11ae2d4cca">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a0219c6a3aff294bc2329897bb5c8840b">constraint_assembly</a>, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l00593"></a>00593 
<a name="l00594"></a>00594     <span class="comment">// Delete all the ptrs to FEMContexts!</span>
<a name="l00595"></a>00595     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;Aq_context.size(); q_a++)
<a name="l00596"></a>00596     {
<a name="l00597"></a>00597       <span class="keyword">delete</span> Aq_context[q_a];
<a name="l00598"></a>00598       Aq_context[q_a] = NULL;
<a name="l00599"></a>00599     }
<a name="l00600"></a>00600     Aq_context.clear();
<a name="l00601"></a>00601 
<a name="l00602"></a>00602     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;Fq_context.size(); q_f++)
<a name="l00603"></a>00603     {
<a name="l00604"></a>00604       <span class="keyword">delete</span> Fq_context[q_f];
<a name="l00605"></a>00605       Fq_context[q_f] = NULL;
<a name="l00606"></a>00606     }
<a name="l00607"></a>00607     Fq_context.clear();
<a name="l00608"></a>00608 
<a name="l00609"></a>00609     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;Mq_context.size(); q_m++)
<a name="l00610"></a>00610     {
<a name="l00611"></a>00611       <span class="keyword">delete</span> Mq_context[q_m];
<a name="l00612"></a>00612       Mq_context[q_m] = NULL;
<a name="l00613"></a>00613     }
<a name="l00614"></a>00614     Mq_context.clear();
<a name="l00615"></a>00615   }
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00618"></a>00618   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00619"></a>00619 
<a name="l00620"></a>00620   STOP_LOG(<span class="stringliteral">&quot;truth_assembly()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00621"></a>00621 }
<a name="l00622"></a>00622 
<a name="l00623"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab7b6710e2f6c1b9a00680388206c39e8">00623</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab7b6710e2f6c1b9a00680388206c39e8">TransientRBSystem::attach_L2_assembly</a>(<a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* L2_assembly_in)
<a name="l00624"></a>00624 {
<a name="l00625"></a>00625   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a96a8761554ddf4b1cf2734f94fcda800">L2_assembly</a> = L2_assembly_in;
<a name="l00626"></a>00626 }
<a name="l00627"></a>00627 
<a name="l00628"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5f1f79f9726112924e042293cb73543">00628</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5f1f79f9726112924e042293cb73543">TransientRBSystem::attach_M_q</a>(<a class="code" href="classlibMesh_1_1RBTheta.php">RBTheta</a>* theta_q_m,
<a name="l00629"></a>00629                                    <a class="code" href="classlibMesh_1_1ElemAssembly.php">ElemAssembly</a>* M_q_assembly)
<a name="l00630"></a>00630 {
<a name="l00631"></a>00631   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#accb04704185f960a314d3e79aa97f4fd">theta_q_m_vector</a>.push_back(theta_q_m);
<a name="l00632"></a>00632   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>.push_back(M_q_assembly);
<a name="l00633"></a>00633 }
<a name="l00634"></a>00634 
<a name="l00635"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">00635</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">TransientRBSystem::assemble_Mq_matrix</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* input_matrix)
<a name="l00636"></a>00636 {
<a name="l00637"></a>00637   <span class="keywordflow">if</span>(q &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>())
<a name="l00638"></a>00638   {
<a name="l00639"></a>00639     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must have q &lt; Q_m in assemble_Mq_matrix.&quot;</span>
<a name="l00640"></a>00640                  &lt;&lt; std::endl;
<a name="l00641"></a>00641     libmesh_error();
<a name="l00642"></a>00642   }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   input_matrix-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00645"></a>00645   <a class="code" href="classlibMesh_1_1RBSystem.php#a9cc9c114e957dd3efe0ccc11ae2d4cca">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>[q], input_matrix, NULL);
<a name="l00646"></a>00646 }
<a name="l00647"></a>00647 
<a name="l00648"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5a3140301d034e23caf1bd68a2e2209">00648</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af5a3140301d034e23caf1bd68a2e2209">TransientRBSystem::assemble_all_affine_operators</a>()
<a name="l00649"></a>00649 {
<a name="l00650"></a>00650   <a class="code" href="classlibMesh_1_1RBSystem.php#af03382bc15075589cbfa15caf75b8b92">Parent::assemble_all_affine_operators</a>();
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q++)
<a name="l00653"></a>00653     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">assemble_Mq_matrix</a>(q, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q));
<a name="l00654"></a>00654 }
<a name="l00655"></a>00655 
<a name="l00656"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a597eb72e0f68b4759224f0c9efcdf6df">00656</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a597eb72e0f68b4759224f0c9efcdf6df">TransientRBSystem::assemble_misc_matrices</a>()
<a name="l00657"></a>00657 {
<a name="l00658"></a>00658   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00659"></a>00659 
<a name="l00660"></a>00660   <a class="code" href="classlibMesh_1_1RBSystem.php#a2fef453705e8c61cfe86eced45603dad">Parent::assemble_misc_matrices</a>();
<a name="l00661"></a>00661 }
<a name="l00662"></a>00662 
<a name="l00663"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9be4b235602aceea66681766c0832210">00663</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9be4b235602aceea66681766c0832210">TransientRBSystem::truth_solve</a>(<span class="keywordtype">int</span> write_interval)
<a name="l00664"></a>00664 {
<a name="l00665"></a>00665   START_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="comment">//   // NumericVector for computing true L2 error</span>
<a name="l00670"></a>00670 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l00671"></a>00671 <span class="comment">//   temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">// Apply initial condition again.</span>
<a name="l00674"></a>00674   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00675"></a>00675   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(0);
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="comment">// Now compute the truth outputs</span>
<a name="l00678"></a>00678   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00679"></a>00679   {
<a name="l00680"></a>00680     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l00681"></a>00681     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00682"></a>00682     {
<a name="l00683"></a>00683       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00684"></a>00684     }
<a name="l00685"></a>00685   }
<a name="l00686"></a>00686 
<a name="l00687"></a>00687   <span class="comment">// Load initial projection error into temporal_data dense matrix</span>
<a name="l00688"></a>00688   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a88b1c2f6e963c1af2b38cc3c2a3eb190">compute_truth_projection_error</a>)
<a name="l00689"></a>00689     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00690"></a>00690 
<a name="l00691"></a>00691   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00692"></a>00692   {
<a name="l00693"></a>00693     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l00694"></a>00694     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l00695"></a>00695   }
<a name="l00696"></a>00696 
<a name="l00697"></a>00697   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> time_level=1; time_level&lt;=<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>; time_level++)
<a name="l00698"></a>00698   {
<a name="l00699"></a>00699     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a262def83281fa63888e8ed5e3b59d1b8">set_time_level</a>(time_level); <span class="comment">// update the member variable _k</span>
<a name="l00700"></a>00700 
<a name="l00701"></a>00701     *<a class="code" href="classlibMesh_1_1TransientSystem.php#a61cfd7f2e0a4c5133beae4a0e8c69141">old_local_solution</a> = *<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>;
<a name="l00702"></a>00702 
<a name="l00703"></a>00703     <span class="comment">// We assume that the truth assembly has been attached to the system</span>
<a name="l00704"></a>00704     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aaa040e14836cebced3a91a0fc7a63400">truth_assembly</a>();
<a name="l00705"></a>00705     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l00706"></a>00706 
<a name="l00707"></a>00707     <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l00708"></a>00708     <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l00709"></a>00709         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l00710"></a>00710         (this-&gt;final_linear_residual() &gt;
<a name="l00711"></a>00711         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l00712"></a>00712     {
<a name="l00713"></a>00713       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l00714"></a>00714                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l00715"></a>00715                    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00716"></a>00716 <span class="comment">//       libmesh_error();</span>
<a name="l00717"></a>00717     }
<a name="l00718"></a>00718 
<a name="l00719"></a>00719     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00720"></a>00720       {
<a name="l00721"></a>00721         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l00722"></a>00722       }
<a name="l00723"></a>00723 
<a name="l00724"></a>00724     <span class="comment">// Now compute the truth outputs</span>
<a name="l00725"></a>00725     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#a80b9e06a7c60b3bb2f5870b0ff66a2ca">get_n_outputs</a>(); n++)
<a name="l00726"></a>00726     {
<a name="l00727"></a>00727       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] = 0.;
<a name="l00728"></a>00728       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_l=0; q_l&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#ab7f0b2268a9716189225e0446b519911">get_Q_l</a>(n); q_l++)
<a name="l00729"></a>00729       {
<a name="l00730"></a>00730         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a58dda0affa01e49069a725153dcf5cc6">truth_outputs_all_k</a>[n][<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>] += <a class="code" href="classlibMesh_1_1RBSystem.php#a3ab4b896903320a2b313f73efc2aaad1">eval_theta_q_l</a>(n,q_l)*<a class="code" href="classlibMesh_1_1RBSystem.php#a956b276ef7de8606c78698fcfa338343">get_output_vector</a>(n,q_l)-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00731"></a>00731       }
<a name="l00732"></a>00732     }
<a name="l00733"></a>00733 
<a name="l00734"></a>00734     <span class="comment">// load projection error into column _k of temporal_data matrix</span>
<a name="l00735"></a>00735     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a88b1c2f6e963c1af2b38cc3c2a3eb190">compute_truth_projection_error</a>)
<a name="l00736"></a>00736       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">set_error_temporal_data</a>();
<a name="l00737"></a>00737 
<a name="l00738"></a>00738     <span class="keywordflow">if</span> ( (write_interval &gt; 0) &amp;&amp; (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>%write_interval == 0) )
<a name="l00739"></a>00739       {
<a name="l00740"></a>00740         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;Truth solve, plotting time step &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a> &lt;&lt; std::endl;
<a name="l00741"></a>00741 
<a name="l00742"></a>00742         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00743"></a>00743 
<a name="l00744"></a>00744         <span class="comment">// We write the file name in the gmv auto-read format.</span>
<a name="l00745"></a>00745         file_name &lt;&lt; <span class="stringliteral">&quot;truth.gmv.&quot;</span>;
<a name="l00746"></a>00746         OSSRealzeroright(file_name,3,0, <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>);
<a name="l00747"></a>00747 
<a name="l00748"></a>00748         <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a> (file_name.str(),
<a name="l00749"></a>00749                                             this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00750"></a>00750       }
<a name="l00751"></a>00751   }
<a name="l00752"></a>00752 
<a name="l00753"></a>00753   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l00754"></a>00754     {
<a name="l00755"></a>00755       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l00756"></a>00756     }
<a name="l00757"></a>00757 
<a name="l00758"></a>00758   <span class="comment">// Get the L2 norm of the truth solution at time-level _K</span>
<a name="l00759"></a>00759   <span class="comment">// Useful for normalizing our true error data</span>
<a name="l00760"></a>00760   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00761"></a>00761   {
<a name="l00762"></a>00762     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00763"></a>00763   }
<a name="l00764"></a>00764   <span class="keywordflow">else</span>
<a name="l00765"></a>00765   {
<a name="l00766"></a>00766     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00767"></a>00767     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00768"></a>00768   }
<a name="l00769"></a>00769 
<a name="l00770"></a>00770   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_truth_L2_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt(<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>)));
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773   STOP_LOG(<span class="stringliteral">&quot;truth_solve()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00774"></a>00774 
<a name="l00775"></a>00775   <span class="keywordflow">return</span> final_truth_L2_norm;
<a name="l00776"></a>00776 }
<a name="l00777"></a>00777 
<a name="l00778"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a70c663d69b94e1389703b8442f8f46e0">00778</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a70c663d69b94e1389703b8442f8f46e0">TransientRBSystem::greedy_termination_test</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> training_greedy_error, <span class="keywordtype">int</span> count)
<a name="l00779"></a>00779 {
<a name="l00780"></a>00780   <span class="keywordflow">if</span> ( (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">get_max_truth_solves</a>()&gt;0) &amp;&amp; (count &gt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a68d017bd7128cbce35e29b64924827a4">get_max_truth_solves</a>()) )
<a name="l00781"></a>00781     {
<a name="l00782"></a>00782       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Maximum number of truth solves reached: max = &quot;</span>
<a name="l00783"></a>00783                    &lt;&lt; count &lt;&lt; std::endl;
<a name="l00784"></a>00784       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00785"></a>00785     }
<a name="l00786"></a>00786 
<a name="l00787"></a>00787   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1RBSystem.php#a79eb03faea6389086e2ccbb032569243">Parent::greedy_termination_test</a>(training_greedy_error, count);
<a name="l00788"></a>00788 }
<a name="l00789"></a>00789 
<a name="l00790"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">00790</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a1d1eb4f1214b4e26a86137ed7ba38a13">TransientRBSystem::set_error_temporal_data</a>()
<a name="l00791"></a>00791 {
<a name="l00792"></a>00792   START_LOG(<span class="stringliteral">&quot;set_error_temporal_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00793"></a>00793 
<a name="l00794"></a>00794   <span class="comment">// first compute the projection of solution onto the current</span>
<a name="l00795"></a>00795   <span class="comment">// RB space</span>
<a name="l00796"></a>00796 
<a name="l00797"></a>00797   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() == 0)
<a name="l00798"></a>00798   {
<a name="l00799"></a>00799     <span class="comment">// If the basis is empty, then the error is the solution itself</span>
<a name="l00800"></a>00800     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>]-&gt;zero();
<a name="l00801"></a>00801     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>]-&gt;add(1., *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00802"></a>00802   }
<a name="l00803"></a>00803   <span class="keywordflow">else</span>
<a name="l00804"></a>00804   {
<a name="l00805"></a>00805     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l00806"></a>00806 
<a name="l00807"></a>00807     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00808"></a>00808     temp-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00809"></a>00809 
<a name="l00810"></a>00810     <span class="comment">// First compute the right-hand side vector for the projection</span>
<a name="l00811"></a>00811     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00812"></a>00812     {
<a name="l00813"></a>00813       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*temp, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00814"></a>00814     }
<a name="l00815"></a>00815     <span class="keywordflow">else</span>
<a name="l00816"></a>00816     {
<a name="l00817"></a>00817       <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00818"></a>00818       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00819"></a>00819     }
<a name="l00820"></a>00820 
<a name="l00821"></a>00821     <a class="code" href="classlibMesh_1_1RBSystem.php#a002530dbacbc566d7c86bad54ee1138d">zero_dirichlet_dofs_on_vector</a>(*temp);
<a name="l00822"></a>00822 
<a name="l00823"></a>00823     <span class="comment">// Do not assume that RB_stiffness matrix is diagonal,</span>
<a name="l00824"></a>00824     <span class="comment">// diagonality degrades as N increases</span>
<a name="l00825"></a>00825 
<a name="l00826"></a>00826     <span class="comment">// Get an appropriately sized copy of RB_inner_product_matrix</span>
<a name="l00827"></a>00827     <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_inner_product_matrix_N(RB_size,RB_size);
<a name="l00828"></a>00828     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00829"></a>00829       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l00830"></a>00830       {
<a name="l00831"></a>00831         RB_inner_product_matrix_N(i,j) = <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a046cf3041ce845dc208f6640da926bf0">RB_inner_product_matrix</a>(i,j);
<a name="l00832"></a>00832       }
<a name="l00833"></a>00833 
<a name="l00834"></a>00834     <span class="comment">// Compute the projection RHS</span>
<a name="l00835"></a>00835     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_proj_rhs(RB_size);
<a name="l00836"></a>00836     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00837"></a>00837     {
<a name="l00838"></a>00838       RB_proj_rhs(i) = temp-&gt;dot(<a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l00839"></a>00839     }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_proj(RB_size);
<a name="l00842"></a>00842 
<a name="l00843"></a>00843     <span class="comment">// Now solve the linear system</span>
<a name="l00844"></a>00844     RB_inner_product_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_proj_rhs, RB_proj);
<a name="l00845"></a>00845 
<a name="l00846"></a>00846     <span class="comment">// Load the RB projection into temp</span>
<a name="l00847"></a>00847     temp-&gt;zero();
<a name="l00848"></a>00848     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_size; i++)
<a name="l00849"></a>00849     {
<a name="l00850"></a>00850       temp-&gt;add(RB_proj(i), <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l00851"></a>00851     }
<a name="l00852"></a>00852 
<a name="l00853"></a>00853     temp-&gt;add(-1., *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855     <span class="comment">// Now temp holds the projection error, store in temporal_data</span>
<a name="l00856"></a>00856     *(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>]) = *temp;
<a name="l00857"></a>00857   }
<a name="l00858"></a>00858 
<a name="l00859"></a>00859   STOP_LOG(<span class="stringliteral">&quot;set_error_temporal_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00860"></a>00860 
<a name="l00861"></a>00861   <span class="comment">// return the square of the X norm of the truth solution</span>
<a name="l00862"></a>00862   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00863"></a>00863   {
<a name="l00864"></a>00864     <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00865"></a>00865   }
<a name="l00866"></a>00866   <span class="keywordflow">else</span>
<a name="l00867"></a>00867   {
<a name="l00868"></a>00868     <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00869"></a>00869     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00870"></a>00870   }
<a name="l00871"></a>00871 
<a name="l00872"></a>00872   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l00873"></a>00873 }
<a name="l00874"></a>00874 
<a name="l00875"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac94d6411ae422281596c89fd15731cd0">00875</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ac94d6411ae422281596c89fd15731cd0">TransientRBSystem::get_error_temporal_data</a>()
<a name="l00876"></a>00876 {
<a name="l00877"></a>00877   START_LOG(<span class="stringliteral">&quot;get_error_temporal_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00878"></a>00878   
<a name="l00879"></a>00879   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a569330d25d5c05702896779bf564490c">get_time_level</a>()];
<a name="l00880"></a>00880   
<a name="l00881"></a>00881   STOP_LOG(<span class="stringliteral">&quot;get_error_temporal_data()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00882"></a>00882 }
<a name="l00883"></a>00883 
<a name="l00884"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">00884</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">TransientRBSystem::initialize_truth</a> ()
<a name="l00885"></a>00885 {
<a name="l00886"></a>00886   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l00887"></a>00887   {
<a name="l00888"></a>00888     <span class="comment">// Use System::read_serialized_data to read the initial condition</span>
<a name="l00889"></a>00889     <span class="comment">// into this-&gt;solution</span>
<a name="l00890"></a>00890     <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> IC_data(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a7cfe02ecfa70244829bb835fc9f2eab6">init_filename</a>, <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00891"></a>00891     <a class="code" href="classlibMesh_1_1System.php#a3eb0dd9d3ef0453daf9b5eeff0819736">read_serialized_data</a>(IC_data, <span class="keyword">false</span>);
<a name="l00892"></a>00892   }
<a name="l00893"></a>00893   <span class="keywordflow">else</span>
<a name="l00894"></a>00894   {
<a name="l00895"></a>00895     <span class="comment">// Otherwise zero out the solution as a default</span>
<a name="l00896"></a>00896     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00897"></a>00897   }
<a name="l00898"></a>00898   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00899"></a>00899   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00900"></a>00900 }
<a name="l00901"></a>00901 
<a name="l00902"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc7508cfa934d11004a3c61914fb496a">00902</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#abc7508cfa934d11004a3c61914fb496a">TransientRBSystem::add_IC_to_RB_space</a>()
<a name="l00903"></a>00903 {
<a name="l00904"></a>00904   START_LOG(<span class="stringliteral">&quot;add_IC_to_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00905"></a>00905 
<a name="l00906"></a>00906   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &gt; 0)
<a name="l00907"></a>00907   {
<a name="l00908"></a>00908     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Should not call TransientRBSystem::add_IC_to_RB_space() &quot;</span>
<a name="l00909"></a>00909                  &lt;&lt; <span class="stringliteral">&quot;on a system that already contains basis functions.&quot;</span> &lt;&lt; std::endl;
<a name="l00910"></a>00910     libmesh_error();
<a name="l00911"></a>00911   }
<a name="l00912"></a>00912   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TransientRBSystem.php#af0fbee2db2698376fe3a932c5a7bcc26">nonzero_initialization</a>)
<a name="l00913"></a>00913   {
<a name="l00914"></a>00914     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error: Should not call TransientRBSystem::add_IC_to_RB_space() &quot;</span>
<a name="l00915"></a>00915                  &lt;&lt; <span class="stringliteral">&quot;when nonzero_initialization==false.&quot;</span> &lt;&lt; std::endl;
<a name="l00916"></a>00916     libmesh_error();
<a name="l00917"></a>00917   }
<a name="l00918"></a>00918 
<a name="l00919"></a>00919   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l00920"></a>00920 
<a name="l00921"></a>00921   <span class="comment">// load the new basis function into the basis_functions vector.</span>
<a name="l00922"></a>00922   <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.push_back( <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release() );
<a name="l00923"></a>00923   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; current_bf = <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()-1);
<a name="l00924"></a>00924   current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00925"></a>00925   current_bf = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00926"></a>00926 
<a name="l00927"></a>00927   <span class="comment">// We can just set the norm to 1.</span>
<a name="l00928"></a>00928   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00929"></a>00929   {
<a name="l00930"></a>00930     <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00931"></a>00931   }
<a name="l00932"></a>00932   <span class="keywordflow">else</span>
<a name="l00933"></a>00933   {
<a name="l00934"></a>00934     <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00935"></a>00935     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,*<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00936"></a>00936   }
<a name="l00937"></a>00937   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_bf_norm = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt( current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>) ));
<a name="l00938"></a>00938   current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(1./current_bf_norm);
<a name="l00939"></a>00939 
<a name="l00940"></a>00940   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> saved_delta_N = <a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>();
<a name="l00941"></a>00941   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(1);
<a name="l00942"></a>00942   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">update_system</a>();
<a name="l00943"></a>00943   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(saved_delta_N);
<a name="l00944"></a>00944 
<a name="l00945"></a>00945   STOP_LOG(<span class="stringliteral">&quot;add_IC_to_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00946"></a>00946 }
<a name="l00947"></a>00947 
<a name="l00948"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4787525ef1c9e18634fef8c8dc85ad6a">00948</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4787525ef1c9e18634fef8c8dc85ad6a">TransientRBSystem::enrich_RB_space</a>()
<a name="l00949"></a>00949 {
<a name="l00950"></a>00950 <span class="comment">// Need SLEPc to get the POD eigenvalues</span>
<a name="l00951"></a>00951 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00952"></a>00952 <span class="preprocessor"></span>  START_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l00953"></a>00953 
<a name="l00954"></a>00954   <span class="comment">// With the &quot;method of snapshots&quot;, the size of</span>
<a name="l00955"></a>00955   <span class="comment">// the eigenproblem is determined by the number</span>
<a name="l00956"></a>00956   <span class="comment">// of time-steps (rather than the number of spatial dofs).</span>
<a name="l00957"></a>00957   <span class="keywordtype">int</span> eigen_size = <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>.size();
<a name="l00958"></a>00958   <span class="keywordtype">int</span> LDA = eigen_size; <span class="comment">// The leading order of correlation_matrix</span>
<a name="l00959"></a>00959   std::vector&lt;Number&gt; correlation_matrix(LDA*eigen_size);
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   <span class="comment">// set values of the correlation matrix</span>
<a name="l00962"></a>00962   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00963"></a>00963     <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00964"></a>00964 
<a name="l00965"></a>00965   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;eigen_size; i++)
<a name="l00966"></a>00966   {
<a name="l00967"></a>00967     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l00968"></a>00968     {
<a name="l00969"></a>00969       <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]);
<a name="l00970"></a>00970     }
<a name="l00971"></a>00971     <span class="keywordflow">else</span>
<a name="l00972"></a>00972     {
<a name="l00973"></a>00973       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[i]);
<a name="l00974"></a>00974     }
<a name="l00975"></a>00975 
<a name="l00976"></a>00976     <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=i; j&lt;eigen_size; j++)
<a name="l00977"></a>00977     {
<a name="l00978"></a>00978        <span class="comment">// Scale the inner products by the number of time-steps to normalize the</span>
<a name="l00979"></a>00979        <span class="comment">// POD energy norm appropriately</span>
<a name="l00980"></a>00980       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> inner_prod = (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[j]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>)) / (<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)(<a class="code" href="classlibMesh_1_1TransientRBSystem.php#aac8858a7e9af6497f3c37a4b7956ca6a">_K</a>+1);
<a name="l00981"></a>00981 
<a name="l00982"></a>00982       <span class="comment">// Fill upper triangular part of correlation_matrix</span>
<a name="l00983"></a>00983       correlation_matrix[j*eigen_size+i] = inner_prod;
<a name="l00984"></a>00984     }
<a name="l00985"></a>00985   }
<a name="l00986"></a>00986 
<a name="l00987"></a>00987   <span class="comment">// Call the LAPACK eigensolver</span>
<a name="l00988"></a>00988   <span class="keywordtype">char</span> JOBZ = <span class="charliteral">&#39;V&#39;</span>; <span class="comment">// Compute eigenvectors and eigenvalues</span>
<a name="l00989"></a>00989   <span class="keywordtype">char</span> RANGE = <span class="charliteral">&#39;A&#39;</span>; <span class="comment">// Compute all eigenvalues</span>
<a name="l00990"></a>00990   <span class="keywordtype">char</span> UPLO = <span class="charliteral">&#39;U&#39;</span>; <span class="comment">// Upper triangular symmetric matrix</span>
<a name="l00991"></a>00991   
<a name="l00992"></a>00992   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> VL = 0.; <span class="comment">// Not used when RANGE = A</span>
<a name="l00993"></a>00993   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> VU = 0.; <span class="comment">// Not used when RANGE = A</span>
<a name="l00994"></a>00994   
<a name="l00995"></a>00995   <span class="keywordtype">int</span> IL = 0; <span class="comment">// Not used when RANGE = A</span>
<a name="l00996"></a>00996   <span class="keywordtype">int</span> IU = 0; <span class="comment">// Not used when RANGE = A</span>
<a name="l00997"></a>00997   
<a name="l00998"></a>00998   <span class="keywordtype">double</span> ABSTOL = 1.e-14; <span class="comment">// Absolute tolerance for eigensolver</span>
<a name="l00999"></a>00999   
<a name="l01000"></a>01000   <span class="keywordtype">int</span> M = 0; <span class="comment">// (output) The total number of evals found</span>
<a name="l01001"></a>01001   
<a name="l01002"></a>01002   std::vector&lt;Real&gt; W(eigen_size); <span class="comment">// (output) the eigenvalues</span>
<a name="l01003"></a>01003 
<a name="l01004"></a>01004   <span class="keywordtype">int</span> LDZ = eigen_size; <span class="comment">// The leading order of Z</span>
<a name="l01005"></a>01005   std::vector&lt;Number&gt; Z(LDZ*eigen_size); <span class="comment">// (output) the eigenvectors</span>
<a name="l01006"></a>01006 
<a name="l01007"></a>01007   std::vector&lt;int&gt; ISUPPZ(2*eigen_size); <span class="comment">// Indicates which evecs in Z are nonzero</span>
<a name="l01008"></a>01008   
<a name="l01009"></a>01009   <span class="comment">// Work array, sized according to lapack documentation</span>
<a name="l01010"></a>01010   <span class="keywordtype">int</span> LWORK = 26*eigen_size;
<a name="l01011"></a>01011   std::vector&lt;Number&gt; WORK(LWORK);
<a name="l01012"></a>01012   
<a name="l01013"></a>01013   <span class="comment">// Work array, sized according to lapack documentation</span>
<a name="l01014"></a>01014   <span class="keywordtype">int</span> LIWORK = 10*eigen_size;
<a name="l01015"></a>01015   std::vector&lt;int&gt; IWORK(LIWORK);
<a name="l01016"></a>01016   
<a name="l01017"></a>01017   <span class="keywordtype">int</span> INFO = 0;
<a name="l01018"></a>01018   
<a name="l01019"></a>01019 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS // Use real numbers</span>
<a name="l01020"></a>01020 <span class="preprocessor"></span>  <span class="comment">// Call the eigensolver for symmetric eigenvalue problems.</span>
<a name="l01021"></a>01021   <span class="comment">// NOTE: evals in W are in ascending order</span>
<a name="l01022"></a>01022   LAPACKsyevr_(&amp;JOBZ, &amp;RANGE, &amp;UPLO, &amp;eigen_size, &amp;correlation_matrix[0],
<a name="l01023"></a>01023                &amp;LDA, &amp;VL, &amp;VU, &amp;IL, &amp;IU, &amp;ABSTOL, &amp;M, &amp;W[0], &amp;Z[0], &amp;LDZ,
<a name="l01024"></a>01024                &amp;ISUPPZ[0], &amp;WORK[0], &amp;LWORK, &amp;IWORK[0], &amp;LIWORK, &amp;INFO );
<a name="l01025"></a>01025 <span class="preprocessor">#endif</span>
<a name="l01026"></a>01026 <span class="preprocessor"></span>
<a name="l01027"></a>01027 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS // Use complex numbers</span>
<a name="l01028"></a>01028 <span class="preprocessor"></span>  <span class="comment">// Need some extra data in the complex case</span>
<a name="l01029"></a>01029   
<a name="l01030"></a>01030   <span class="comment">// Work array, sized according to lapack documentation</span>
<a name="l01031"></a>01031   <span class="keywordtype">int</span> LRWORK = 24*eigen_size;
<a name="l01032"></a>01032   std::vector&lt;Real&gt; RWORK(LRWORK);
<a name="l01033"></a>01033 
<a name="l01034"></a>01034   <span class="comment">// Call the eigensolver for symmetric eigenvalue problems.</span>
<a name="l01035"></a>01035   <span class="comment">// NOTE: evals in W are in ascending order</span>
<a name="l01036"></a>01036   LAPACKsyevr_(&amp;JOBZ, &amp;RANGE, &amp;UPLO, &amp;eigen_size, &amp;correlation_matrix[0],
<a name="l01037"></a>01037                &amp;LDA, &amp;VL, &amp;VU, &amp;IL, &amp;IU, &amp;ABSTOL, &amp;M, &amp;W[0], &amp;Z[0], &amp;LDZ,
<a name="l01038"></a>01038                &amp;ISUPPZ[0], &amp;WORK[0], &amp;LWORK, &amp;RWORK[0], &amp;LRWORK, &amp;IWORK[0],
<a name="l01039"></a>01039                &amp;LIWORK, &amp;INFO );
<a name="l01040"></a>01040 <span class="preprocessor">#endif</span>
<a name="l01041"></a>01041 <span class="preprocessor"></span>
<a name="l01042"></a>01042   <span class="keywordflow">if</span> (INFO != 0)
<a name="l01043"></a>01043   {
<a name="l01044"></a>01044     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Error in LAPACK syev eigensolver routine, INFO = &quot;</span> &lt;&lt; INFO &lt;&lt; std::endl;
<a name="l01045"></a>01045     libmesh_error();
<a name="l01046"></a>01046   }
<a name="l01047"></a>01047 
<a name="l01048"></a>01048   <span class="comment">// eval and evec now hold the sorted eigenvalues/eigenvectors</span>
<a name="l01049"></a>01049   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl &lt;&lt; <span class="stringliteral">&quot;POD Eigenvalues:&quot;</span> &lt;&lt; std::endl;
<a name="l01050"></a>01050   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;=2; i++)
<a name="l01051"></a>01051   {
<a name="l01052"></a>01052     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;eigenvalue &quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; = &quot;</span> &lt;&lt; W[eigen_size-1-i] &lt;&lt; std::endl;
<a name="l01053"></a>01053   }
<a name="l01054"></a>01054   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;eigenvalue K = &quot;</span> &lt;&lt; W[0] &lt;&lt; std::endl;
<a name="l01055"></a>01055   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l01056"></a>01056 
<a name="l01057"></a>01057   <span class="comment">// Now load the new basis functions</span>
<a name="l01058"></a>01058   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count = 0;
<a name="l01059"></a>01059   <span class="keywordflow">while</span> (<span class="keyword">true</span>)
<a name="l01060"></a>01060     {
<a name="l01061"></a>01061       <span class="comment">// load the new basis function into the basis_functions vector.</span>
<a name="l01062"></a>01062       <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#aa9f3cc19c2c956a2c0f0591795cdf5f9">basis_functions</a>.push_back( <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release() );
<a name="l01063"></a>01063       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; current_bf = <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()-1);
<a name="l01064"></a>01064       current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01065"></a>01065       current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01066"></a>01066 
<a name="l01067"></a>01067       <span class="comment">// Perform the matrix multiplication of temporal data with</span>
<a name="l01068"></a>01068       <span class="comment">// the next POD eigenvector</span>
<a name="l01069"></a>01069       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> j=0; j&lt;eigen_size; j++)
<a name="l01070"></a>01070         {
<a name="l01071"></a>01071           <span class="keywordtype">int</span> Z_row = j;
<a name="l01072"></a>01072           <span class="keywordtype">int</span> Z_col = (eigen_size-1-count);
<a name="l01073"></a>01073           <span class="keywordtype">int</span> Z_index = Z_col*eigen_size + Z_row;
<a name="l01074"></a>01074           current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(Z[Z_index], *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a5f9a29b24cc7de2f92e0e1b8f5acbe71">temporal_data</a>[j]);
<a name="l01075"></a>01075         }
<a name="l01076"></a>01076 
<a name="l01077"></a>01077       <span class="comment">// We just set the norm to 1.</span>
<a name="l01078"></a>01078       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01079"></a>01079         {
<a name="l01080"></a>01080           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,current_bf);
<a name="l01081"></a>01081         }
<a name="l01082"></a>01082       <span class="keywordflow">else</span>
<a name="l01083"></a>01083         {
<a name="l01084"></a>01084           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,current_bf);
<a name="l01085"></a>01085         }
<a name="l01086"></a>01086       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_bf_norm = std::abs( std::sqrt( current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>) ) );
<a name="l01087"></a>01087       current_bf.<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(1./current_bf_norm);
<a name="l01088"></a>01088 
<a name="l01089"></a>01089       <span class="comment">// Increment count here since we use the incremented counter</span>
<a name="l01090"></a>01090       <span class="comment">// in the if clauses below</span>
<a name="l01091"></a>01091       count++;
<a name="l01092"></a>01092 
<a name="l01093"></a>01093       <span class="comment">// If positive POD_tol, we use it to determine the number of basis functions</span>
<a name="l01094"></a>01094       <span class="comment">// to add, and then break the loop when POD_tol is satisfied, or after Nmax</span>
<a name="l01095"></a>01095       <span class="comment">// basis functions have been added. Else we break the loop after delta_N</span>
<a name="l01096"></a>01096       <span class="comment">// (or Nmax) new basis functions.</span>
<a name="l01097"></a>01097       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a> &gt; 0.)
<a name="l01098"></a>01098         {
<a name="l01099"></a>01099           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(1);
<a name="l01100"></a>01100 
<a name="l01101"></a>01101           <span class="comment">// We need to define the updated RB system matrices before the RB solve</span>
<a name="l01102"></a>01102           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">update_system</a>();
<a name="l01103"></a>01103           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_bound = <a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a3e451b7c989bc337a99936a07b3fedf6">RB_solve</a>(<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>());
<a name="l01104"></a>01104 
<a name="l01105"></a>01105           <span class="keywordflow">if</span> ( (error_bound &lt;= <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab631619490c50d5e4f7873b6800f5bf8">POD_tol</a>) || (<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()==<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>()) )
<a name="l01106"></a>01106             {
<a name="l01107"></a>01107               <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(0);
<a name="l01108"></a>01108               <span class="keywordflow">break</span>;
<a name="l01109"></a>01109             }
<a name="l01110"></a>01110         }
<a name="l01111"></a>01111       <span class="keywordflow">else</span>
<a name="l01112"></a>01112         {
<a name="l01113"></a>01113           <span class="keywordflow">if</span> (count == <a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>())
<a name="l01114"></a>01114           {
<a name="l01115"></a>01115             <span class="keywordflow">break</span>;
<a name="l01116"></a>01116           }
<a name="l01117"></a>01117           <span class="keywordflow">else</span>
<a name="l01118"></a>01118           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>()==<a class="code" href="classlibMesh_1_1RBSystem.php#a5acee637ff70dd65ec54de29241f0627">get_Nmax</a>())
<a name="l01119"></a>01119           {
<a name="l01120"></a>01120             <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a6a0ae338e9bb14d354ee6385cb5df85f">set_delta_N</a>(count);
<a name="l01121"></a>01121             <span class="keywordflow">break</span>;
<a name="l01122"></a>01122           }
<a name="l01123"></a>01123         }
<a name="l01124"></a>01124     }
<a name="l01125"></a>01125 
<a name="l01126"></a>01126   STOP_LOG(<span class="stringliteral">&quot;enrich_RB_space()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01127"></a>01127 <span class="preprocessor">#else</span>
<a name="l01128"></a>01128 <span class="preprocessor"></span>  libmesh_not_implemented();
<a name="l01129"></a>01129 <span class="preprocessor">#endif</span>
<a name="l01130"></a>01130 <span class="preprocessor"></span>}
<a name="l01131"></a>01131 
<a name="l01132"></a>01132 
<a name="l01133"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">01133</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae84573a528aea2088e92485998d83969">TransientRBSystem::update_system</a>()
<a name="l01134"></a>01134 {
<a name="l01135"></a>01135   <span class="comment">// If delta_N is set to zero, there is nothing to update</span>
<a name="l01136"></a>01136   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a9e51cdaa5058cf0eb04e73ed7c16f339">get_delta_N</a>() == 0)
<a name="l01137"></a>01137     <span class="keywordflow">return</span>;
<a name="l01138"></a>01138 
<a name="l01139"></a>01139   <a class="code" href="classlibMesh_1_1RBSystem.php#af539556a1dac63314567b39e46fa9a08">Parent::update_system</a>();
<a name="l01140"></a>01140 
<a name="l01141"></a>01141   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Updating RB initial conditions&quot;</span> &lt;&lt; std::endl;
<a name="l01142"></a>01142   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">update_RB_initial_condition_all_N</a>();
<a name="l01143"></a>01143 }
<a name="l01144"></a>01144 
<a name="l01145"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">01145</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae9b4ca47590dc2975de08c73aa0e3a55">TransientRBSystem::residual_scaling_numer</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l01146"></a>01146 {
<a name="l01147"></a>01147   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab5a283a3f305fd03ee1f8e25a5f11bbc">get_dt</a>();
<a name="l01148"></a>01148 }
<a name="l01149"></a>01149 
<a name="l01150"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a14c59681fde1890ec3d0e1fbc031b784">01150</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a14c59681fde1890ec3d0e1fbc031b784">TransientRBSystem::assemble_matrix_for_output_dual_solves</a>()
<a name="l01151"></a>01151 {
<a name="l01152"></a>01152   <span class="comment">// By default we use the L2 matrix for transient problems</span>
<a name="l01153"></a>01153   
<a name="l01154"></a>01154   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01155"></a>01155   {
<a name="l01156"></a>01156     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01157"></a>01157     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>);
<a name="l01158"></a>01158   }
<a name="l01159"></a>01159   <span class="keywordflow">else</span>
<a name="l01160"></a>01160   {
<a name="l01161"></a>01161     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01162"></a>01162   }
<a name="l01163"></a>01163 }
<a name="l01164"></a>01164 
<a name="l01165"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad23a86810dc83165bb0ed2237fa6f521">01165</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ad23a86810dc83165bb0ed2237fa6f521">TransientRBSystem::load_RB_solution</a>()
<a name="l01166"></a>01166 {
<a name="l01167"></a>01167   START_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01168"></a>01168 
<a name="l01169"></a>01169   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l01170"></a>01170 
<a name="l01171"></a>01171   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a>* trans_rb_eval = libmesh_cast_ptr&lt;TransientRBEvaluation*&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l01172"></a>01172   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_solution_vector_k = trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aab99875aafc262f13e2e59a79382ffd5">RB_temporal_solution_data</a>[<a class="code" href="classlibMesh_1_1TransientRBSystem.php#ae8bf672ee83dac4058eb4deb5b660750">_k</a>];
<a name="l01173"></a>01173 
<a name="l01174"></a>01174   <span class="keywordflow">if</span>(RB_solution_vector_k.size() &gt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>())
<a name="l01175"></a>01175   {
<a name="l01176"></a>01176     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: System contains &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>() &lt;&lt; <span class="stringliteral">&quot; basis functions.&quot;</span>
<a name="l01177"></a>01177                  &lt;&lt; <span class="stringliteral">&quot; RB_solution vector constains &quot;</span> &lt;&lt; RB_solution_vector_k.size() &lt;&lt; <span class="stringliteral">&quot; entries.&quot;</span>
<a name="l01178"></a>01178                  &lt;&lt; <span class="stringliteral">&quot; RB_solution in TransientRBSystem::load_RB_solution is too long!&quot;</span> &lt;&lt; std::endl;
<a name="l01179"></a>01179     libmesh_error();
<a name="l01180"></a>01180   }
<a name="l01181"></a>01181 
<a name="l01182"></a>01182   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;RB_solution_vector_k.size(); i++)
<a name="l01183"></a>01183   {
<a name="l01184"></a>01184     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;add(RB_solution_vector_k(i), <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l01185"></a>01185   }
<a name="l01186"></a>01186 
<a name="l01187"></a>01187   <a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l01188"></a>01188 
<a name="l01189"></a>01189   STOP_LOG(<span class="stringliteral">&quot;load_RB_solution()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01190"></a>01190 }
<a name="l01191"></a>01191 
<a name="l01192"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">01192</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">TransientRBSystem::update_RB_system_matrices</a>()
<a name="l01193"></a>01193 {
<a name="l01194"></a>01194   START_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01195"></a>01195 
<a name="l01196"></a>01196   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0bd7a0e822ac88f71f9dd7baeef179a7">RBSystem::update_RB_system_matrices</a>();
<a name="l01197"></a>01197   
<a name="l01198"></a>01198   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a>* trans_rb_eval = libmesh_cast_ptr&lt;TransientRBEvaluation*&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l01199"></a>01199 
<a name="l01200"></a>01200   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01201"></a>01201 
<a name="l01202"></a>01202   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01203"></a>01203   temp-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01204"></a>01204   
<a name="l01205"></a>01205   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01206"></a>01206   {
<a name="l01207"></a>01207     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01208"></a>01208     {
<a name="l01209"></a>01209       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value = 0.;
<a name="l01210"></a>01210       
<a name="l01211"></a>01211       <span class="comment">// Compute reduced L2 matrix</span>
<a name="l01212"></a>01212       temp-&gt;zero();
<a name="l01213"></a>01213       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01214"></a>01214       {
<a name="l01215"></a>01215         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp, <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(j));
<a name="l01216"></a>01216       }
<a name="l01217"></a>01217       <span class="keywordflow">else</span>
<a name="l01218"></a>01218       {
<a name="l01219"></a>01219         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01220"></a>01220         <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(j));
<a name="l01221"></a>01221       }
<a name="l01222"></a>01222       value = <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(*temp);
<a name="l01223"></a>01223       trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>(i,j) = value;
<a name="l01224"></a>01224       <span class="keywordflow">if</span>(i!=j)
<a name="l01225"></a>01225       {
<a name="l01226"></a>01226         <span class="comment">// The L2 matrix is assumed</span>
<a name="l01227"></a>01227         <span class="comment">// to be symmetric</span>
<a name="l01228"></a>01228         trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>(j,i) = value;
<a name="l01229"></a>01229       }
<a name="l01230"></a>01230 
<a name="l01231"></a>01231       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01232"></a>01232       {
<a name="l01233"></a>01233         <span class="comment">// Compute reduced M_q matrix</span>
<a name="l01234"></a>01234         temp-&gt;zero();
<a name="l01235"></a>01235         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01236"></a>01236         {
<a name="l01237"></a>01237           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a528a1bc40b5c1b63ee8c51375b1824dc">get_M_q</a>(q_m)-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(j));
<a name="l01238"></a>01238         }
<a name="l01239"></a>01239         <span class="keywordflow">else</span>
<a name="l01240"></a>01240         {
<a name="l01241"></a>01241           <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0b6610b9ad630934520fa4581101668e">assemble_Mq_matrix</a>(q_m,<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01242"></a>01242           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp, <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(j));
<a name="l01243"></a>01243         }
<a name="l01244"></a>01244 
<a name="l01245"></a>01245         value = (<a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i)).dot(*temp);
<a name="l01246"></a>01246         trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>[q_m](i,j) = value;
<a name="l01247"></a>01247 
<a name="l01248"></a>01248         <span class="keywordflow">if</span>(i!=j)
<a name="l01249"></a>01249         {
<a name="l01250"></a>01250           <span class="comment">// Each mass matrix term is assumed</span>
<a name="l01251"></a>01251           <span class="comment">// to be symmetric</span>
<a name="l01252"></a>01252           trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ad4ebd109e5a0de6d140dca5efcc58ab0">RB_M_q_vector</a>[q_m](j,i) = value;
<a name="l01253"></a>01253         }
<a name="l01254"></a>01254       }
<a name="l01255"></a>01255       
<a name="l01256"></a>01256     }
<a name="l01257"></a>01257   }
<a name="l01258"></a>01258 
<a name="l01259"></a>01259   STOP_LOG(<span class="stringliteral">&quot;update_RB_system_matrices()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01260"></a>01260 }
<a name="l01261"></a>01261 
<a name="l01262"></a>01262 
<a name="l01263"></a>01263 
<a name="l01264"></a>01264 
<a name="l01265"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">01265</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">TransientRBSystem::update_residual_terms</a>(<span class="keywordtype">bool</span> compute_inner_products)
<a name="l01266"></a>01266 {
<a name="l01267"></a>01267   START_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01268"></a>01268 
<a name="l01269"></a>01269   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#af65ff4ed2f3257fa79a540aafd6d58bc">RBSystem::update_residual_terms</a>(compute_inner_products);
<a name="l01270"></a>01270 
<a name="l01271"></a>01271   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a>* trans_rb_eval = libmesh_cast_ptr&lt;TransientRBEvaluation*&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l01272"></a>01272 
<a name="l01273"></a>01273   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01274"></a>01274 
<a name="l01275"></a>01275   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01276"></a>01276   {
<a name="l01277"></a>01277     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l01278"></a>01278     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>);
<a name="l01279"></a>01279     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01280"></a>01280       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a>(1., *<a class="code" href="classlibMesh_1_1RBSystem.php#aa7a3439518c1b8a421a79064e819f5c8">constraint_matrix</a>);
<a name="l01281"></a>01281   }
<a name="l01282"></a>01282   <span class="keywordflow">else</span>
<a name="l01283"></a>01283   {
<a name="l01284"></a>01284     <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01285"></a>01285     <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01286"></a>01286       <a class="code" href="classlibMesh_1_1RBSystem.php#a9cc9c114e957dd3efe0ccc11ae2d4cca">add_scaled_matrix_and_vector</a>(1., <a class="code" href="classlibMesh_1_1RBSystem.php#a0219c6a3aff294bc2329897bb5c8840b">constraint_assembly</a>, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, NULL);
<a name="l01287"></a>01287   }
<a name="l01288"></a>01288 
<a name="l01289"></a>01289   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01290"></a>01290   {
<a name="l01291"></a>01291     <span class="comment">// For the first solve, make sure we generate a new preconditioner</span>
<a name="l01292"></a>01292     <span class="comment">// Actually, this is not necessary as we can use the preconditioner</span>
<a name="l01293"></a>01293     <span class="comment">// generated by RBSystem::update_residual_terms()</span>
<a name="l01294"></a>01294     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l01295"></a>01295   }
<a name="l01296"></a>01296 
<a name="l01297"></a>01297   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01298"></a>01298   {
<a name="l01299"></a>01299     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01300"></a>01300     {
<a name="l01301"></a>01301       <span class="comment">// Initialize the vectors when we need them</span>
<a name="l01302"></a>01302       <span class="keywordflow">if</span>(!trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i])
<a name="l01303"></a>01303       {
<a name="l01304"></a>01304         trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i] = (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release());
<a name="l01305"></a>01305         trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i]-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01306"></a>01306       }
<a name="l01307"></a>01307 
<a name="l01308"></a>01308       libmesh_assert(trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i]-&gt;size()       == this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>()       &amp;&amp; 
<a name="l01309"></a>01309                      trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i]-&gt;local_size() == this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>() );
<a name="l01310"></a>01310 
<a name="l01311"></a>01311       <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l01312"></a>01312       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01313"></a>01313       {
<a name="l01314"></a>01314         <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a9ba330e7121f7141b7ec495b3a2370be">M_q_vector</a>[q_m]-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l01315"></a>01315       }
<a name="l01316"></a>01316       <span class="keywordflow">else</span>
<a name="l01317"></a>01317       {
<a name="l01318"></a>01318         <a class="code" href="classlibMesh_1_1RBSystem.php#ad0a9b785750043ab4777aa9825ffe67d">assemble_scaled_matvec</a>(1.,
<a name="l01319"></a>01319                                <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a09290a3561f7481815c9e9a047951b91">M_q_assembly_vector</a>[q_m],
<a name="l01320"></a>01320                                *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>,
<a name="l01321"></a>01321                                <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l01322"></a>01322       }
<a name="l01323"></a>01323       <a class="code" href="classlibMesh_1_1RBSystem.php#a85c25bbd66bed6e4111e44566e91b5ff">zero_dirichlet_dofs_on_rhs</a>();
<a name="l01324"></a>01324 
<a name="l01325"></a>01325       <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l01326"></a>01326 
<a name="l01327"></a>01327       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#a8b5ad508848699cdb22b9b7bc4681094">is_quiet</a>())
<a name="l01328"></a>01328         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Starting solve i=&quot;</span>
<a name="l01329"></a>01329                      &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; in TransientRBSystem::update_residual_terms() at &quot;</span>
<a name="l01330"></a>01330                      &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l01331"></a>01331       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">solve</a>();
<a name="l01332"></a>01332 
<a name="l01333"></a>01333       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1RBSystem.php#a8b5ad508848699cdb22b9b7bc4681094">is_quiet</a>())
<a name="l01334"></a>01334         {
<a name="l01335"></a>01335           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Finished solve i=&quot;</span>
<a name="l01336"></a>01336                        &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot; in TransientRBSystem::update_residual_terms() at &quot;</span>
<a name="l01337"></a>01337                        &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>() &lt;&lt; std::endl;
<a name="l01338"></a>01338 
<a name="l01339"></a>01339           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>()
<a name="l01340"></a>01340                        &lt;&lt; <span class="stringliteral">&quot; iterations, final residual &quot;</span>
<a name="l01341"></a>01341                        &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; std::endl;
<a name="l01342"></a>01342         }
<a name="l01343"></a>01343 
<a name="l01344"></a>01344       <span class="comment">// Make sure we didn&#39;t max out the number of iterations</span>
<a name="l01345"></a>01345       <span class="keywordflow">if</span>( (this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &gt;=
<a name="l01346"></a>01346           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>)) &amp;&amp;
<a name="l01347"></a>01347           (this-&gt;final_linear_residual() &gt;
<a name="l01348"></a>01348           this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>)) )
<a name="l01349"></a>01349       {
<a name="l01350"></a>01350         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l01351"></a>01351                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a86b5e2954d2a2e43014bcda8810239ac">final_linear_residual</a>() &lt;&lt; <span class="stringliteral">&quot;, number of iterations = &quot;</span>
<a name="l01352"></a>01352                      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af712dbf0e285c5ff4cc346daef05423c">n_linear_iterations</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l01353"></a>01353   <span class="comment">//       libmesh_error();</span>
<a name="l01354"></a>01354       }
<a name="l01355"></a>01355 
<a name="l01356"></a>01356       *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i] = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l01357"></a>01357 
<a name="l01358"></a>01358       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01359"></a>01359       {
<a name="l01360"></a>01360         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">true</span>;
<a name="l01361"></a>01361       }
<a name="l01362"></a>01362     }
<a name="l01363"></a>01363   }
<a name="l01364"></a>01364 
<a name="l01365"></a>01365   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#a61f47d68b0df487674a9001d13d77c88">reuse_preconditioner</a>)
<a name="l01366"></a>01366   {
<a name="l01367"></a>01367     <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;same_preconditioner = <span class="keyword">false</span>;
<a name="l01368"></a>01368   }
<a name="l01369"></a>01369 
<a name="l01370"></a>01370 
<a name="l01371"></a>01371   <span class="comment">// Now compute and store the inner products if requested</span>
<a name="l01372"></a>01372   <span class="keywordflow">if</span> (compute_inner_products)
<a name="l01373"></a>01373     {
<a name="l01374"></a>01374       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a> &amp;&amp; <a class="code" href="classlibMesh_1_1RBSystem.php#a28b1348023897cb1517724d6ac30a21d">constrained_problem</a>)
<a name="l01375"></a>01375         <a class="code" href="classlibMesh_1_1RBSystem.php#a7c76e70617488f440bc717b1790942f0">assemble_inner_product_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01376"></a>01376 
<a name="l01377"></a>01377       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_f=0; q_f&lt;<a class="code" href="classlibMesh_1_1RBSystem.php#acfb88001627d2e7c9acf2efea930429f">get_Q_f</a>(); q_f++)
<a name="l01378"></a>01378         {
<a name="l01379"></a>01379           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01380"></a>01380             {
<a name="l01381"></a>01381               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l01382"></a>01382             }
<a name="l01383"></a>01383           <span class="keywordflow">else</span>
<a name="l01384"></a>01384             {
<a name="l01385"></a>01385               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *<a class="code" href="classlibMesh_1_1RBSystem.php#acd91cfaa84058427cda2885e4d6d30ce">F_q_representor</a>[q_f]);
<a name="l01386"></a>01386             }
<a name="l01387"></a>01387 
<a name="l01388"></a>01388           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01389"></a>01389             {
<a name="l01390"></a>01390               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01391"></a>01391                 {
<a name="l01392"></a>01392                   trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#aad5768d274cb94c458eb1bc6b3b7578e">Fq_Mq_representor_norms</a>[q_f][q_m][i] =
<a name="l01393"></a>01393                     trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01394"></a>01394                 } <span class="comment">// end for q_m</span>
<a name="l01395"></a>01395             } <span class="comment">// end for i</span>
<a name="l01396"></a>01396         } <span class="comment">// end for q_f</span>
<a name="l01397"></a>01397 
<a name="l01398"></a>01398       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0;
<a name="l01399"></a>01399       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m1=0; q_m1&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m1++)
<a name="l01400"></a>01400         {
<a name="l01401"></a>01401           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m2=q_m1; q_m2&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m2++)
<a name="l01402"></a>01402             {
<a name="l01403"></a>01403               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01404"></a>01404                 {
<a name="l01405"></a>01405                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01406"></a>01406                     {
<a name="l01407"></a>01407                       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01408"></a>01408                         {
<a name="l01409"></a>01409                           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m2][j]);
<a name="l01410"></a>01410                         }
<a name="l01411"></a>01411                       <span class="keywordflow">else</span>
<a name="l01412"></a>01412                         {
<a name="l01413"></a>01413                           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>, *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m2][j]);
<a name="l01414"></a>01414                         }
<a name="l01415"></a>01415                       trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[q][i][j] =
<a name="l01416"></a>01416                         trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m1][i]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01417"></a>01417 
<a name="l01418"></a>01418                       <span class="keywordflow">if</span>(i != j)
<a name="l01419"></a>01419                         {
<a name="l01420"></a>01420                           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01421"></a>01421                             {
<a name="l01422"></a>01422                               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,
<a name="l01423"></a>01423                                                                 *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m2][i]);
<a name="l01424"></a>01424                             }
<a name="l01425"></a>01425                           <span class="keywordflow">else</span>
<a name="l01426"></a>01426                             {
<a name="l01427"></a>01427                               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,
<a name="l01428"></a>01428                                                   *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m2][i]);
<a name="l01429"></a>01429                             }
<a name="l01430"></a>01430                           trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ac6e90704da047753274c72a570b4203c">Mq_Mq_representor_norms</a>[q][j][i] =
<a name="l01431"></a>01431                             trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m1][j]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01432"></a>01432                         }
<a name="l01433"></a>01433                     } <span class="comment">// end for j</span>
<a name="l01434"></a>01434                 } <span class="comment">// end for i</span>
<a name="l01435"></a>01435               q++;
<a name="l01436"></a>01436             } <span class="comment">// end for q_m2</span>
<a name="l01437"></a>01437         } <span class="comment">// end for q_m1</span>
<a name="l01438"></a>01438 
<a name="l01439"></a>01439 
<a name="l01440"></a>01440       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01441"></a>01441         {
<a name="l01442"></a>01442           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;RB_size; j++)
<a name="l01443"></a>01443             {
<a name="l01444"></a>01444               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_a=0; q_a&lt;<a class="code" href="classlibMesh_1_1RBBase.php#a20d5a360f0b3b8775c324b3aaeab0de4">get_Q_a</a>(); q_a++)
<a name="l01445"></a>01445                 {
<a name="l01446"></a>01446                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q_m=0; q_m&lt;<a class="code" href="classlibMesh_1_1TransientRBSystem.php#a30abcdcdfaa89c4b6b6c87b9053ae4de">get_Q_m</a>(); q_m++)
<a name="l01447"></a>01447                     {
<a name="l01448"></a>01448                       <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01449"></a>01449                         {
<a name="l01450"></a>01450                           <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,
<a name="l01451"></a>01451                                                             *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][j]);
<a name="l01452"></a>01452                         }
<a name="l01453"></a>01453                       <span class="keywordflow">else</span>
<a name="l01454"></a>01454                         {
<a name="l01455"></a>01455                           <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,
<a name="l01456"></a>01456                                               *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][j]);
<a name="l01457"></a>01457                         }
<a name="l01458"></a>01458                       trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[q_a][q_m][i][j] =
<a name="l01459"></a>01459                         trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a][i]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01460"></a>01460 
<a name="l01461"></a>01461                       <span class="keywordflow">if</span>(i != j)
<a name="l01462"></a>01462                         {
<a name="l01463"></a>01463                           <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01464"></a>01464                             {
<a name="l01465"></a>01465                               <a class="code" href="classlibMesh_1_1RBSystem.php#a330478ef4e1a158dc7b6f08530e10ff3">inner_product_matrix</a>-&gt;vector_mult(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,
<a name="l01466"></a>01466                                                                 *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i]);
<a name="l01467"></a>01467                             }
<a name="l01468"></a>01468                           <span class="keywordflow">else</span>
<a name="l01469"></a>01469                             {
<a name="l01470"></a>01470                               <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>,
<a name="l01471"></a>01471                                                   *trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a2e5b0d0413be736856b1a26e89fc8275">M_q_representor</a>[q_m][i]);
<a name="l01472"></a>01472                             }
<a name="l01473"></a>01473                           trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a6ae7e40532e24ec205e46a328050aa48">Aq_Mq_representor_norms</a>[q_a][q_m][j][i] =
<a name="l01474"></a>01474                             trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1RBEvaluation.php#a802cef9e442d68a28b6b12e0b7315cde">A_q_representor</a>[q_a][j]-&gt;dot(*<a class="code" href="classlibMesh_1_1RBBase.php#aa98ca545976e37fa196058d9d6667471">inner_product_storage_vector</a>);
<a name="l01475"></a>01475                         }
<a name="l01476"></a>01476                     } <span class="comment">// end for q_m</span>
<a name="l01477"></a>01477                 } <span class="comment">// end for q_a</span>
<a name="l01478"></a>01478             } <span class="comment">// end for j</span>
<a name="l01479"></a>01479         } <span class="comment">// end for i</span>
<a name="l01480"></a>01480     } <span class="comment">// end if (compute_inner_products)</span>
<a name="l01481"></a>01481 
<a name="l01482"></a>01482   STOP_LOG(<span class="stringliteral">&quot;update_residual_terms()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01483"></a>01483 }
<a name="l01484"></a>01484 
<a name="l01485"></a>01485 
<a name="l01486"></a><a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">01486</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a465255c39194ff391528dfa0cff68995">TransientRBSystem::update_RB_initial_condition_all_N</a>()
<a name="l01487"></a>01487 {
<a name="l01488"></a>01488   START_LOG(<span class="stringliteral">&quot;update_RB_initial_condition_all_N()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01489"></a>01489 
<a name="l01490"></a>01490   <a class="code" href="classlibMesh_1_1TransientRBEvaluation.php">TransientRBEvaluation</a>* trans_rb_eval = libmesh_cast_ptr&lt;TransientRBEvaluation*&gt;(<a class="code" href="classlibMesh_1_1RBSystem.php#aae015df7deadefc043774b4d570af10b">rb_eval</a>);
<a name="l01491"></a>01491 
<a name="l01492"></a>01492   <span class="comment">// Load the initial condition into the solution vector</span>
<a name="l01493"></a>01493   <a class="code" href="classlibMesh_1_1TransientRBSystem.php#ab455004dfc57c1a9454534ab1a761dbc">initialize_truth</a>();
<a name="l01494"></a>01494 
<a name="l01495"></a>01495   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp1 = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01496"></a>01496   temp1-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01497"></a>01497 
<a name="l01498"></a>01498   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp2 = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l01499"></a>01499   temp2-&gt;init (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>(), this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae3aeb82e65b06789823d41da3c5df7a2">n_local_dofs</a>(), <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l01500"></a>01500 
<a name="l01501"></a>01501 
<a name="l01502"></a>01502   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> RB_size = <a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>();
<a name="l01503"></a>01503 
<a name="l01504"></a>01504   <span class="comment">// First compute the right-hand side vector for the L2 projection</span>
<a name="l01505"></a>01505   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01506"></a>01506   {
<a name="l01507"></a>01507     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01508"></a>01508   }
<a name="l01509"></a>01509   <span class="keywordflow">else</span>
<a name="l01510"></a>01510   {
<a name="l01511"></a>01511     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a0ee3e3816d13aeae07fe5212dda5f521">assemble_L2_matrix</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l01512"></a>01512     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp1, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01513"></a>01513   }
<a name="l01514"></a>01514 
<a name="l01515"></a>01515   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); i&lt;RB_size; i++)
<a name="l01516"></a>01516   {
<a name="l01517"></a>01517     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>(i) = temp1-&gt;dot(<a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l01518"></a>01518   }
<a name="l01519"></a>01519 
<a name="l01520"></a>01520 
<a name="l01521"></a>01521   <span class="comment">// Now compute the projection for each N</span>
<a name="l01522"></a>01522   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> RB_L2_matrix_N;
<a name="l01523"></a>01523   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_rhs_N;
<a name="l01524"></a>01524   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N=(RB_size-<a class="code" href="classlibMesh_1_1RBSystem.php#a36ba489bd3158bbff48a5607e1d21d30">delta_N</a>); N&lt;RB_size; N++)
<a name="l01525"></a>01525   {
<a name="l01526"></a>01526     <span class="comment">// We have to index here by N+1 since the loop index is zero-based.</span>
<a name="l01527"></a>01527     trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a5d6761d34663ffea8b14fb0b1408910d">RB_L2_matrix</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a>(N+1, RB_L2_matrix_N);
<a name="l01528"></a>01528     
<a name="l01529"></a>01529     <a class="code" href="classlibMesh_1_1TransientRBSystem.php#aca06ad6a5b244bb6e8b76d53810e2eb6">RB_ic_proj_rhs_all_N</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#aacfb5c2e5aee056320aaae4c9dd22a55">get_principal_subvector</a>(N+1, RB_rhs_N);
<a name="l01530"></a>01530 
<a name="l01531"></a>01531     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> RB_ic_N(N+1);
<a name="l01532"></a>01532 
<a name="l01533"></a>01533     <span class="comment">// Now solve the linear system</span>
<a name="l01534"></a>01534     RB_L2_matrix_N.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(RB_rhs_N, RB_ic_N);
<a name="l01535"></a>01535 
<a name="l01536"></a>01536     <span class="comment">// Load RB_ic_N into RB_initial_condition_all_N</span>
<a name="l01537"></a>01537     trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#ae14a49de994e3f4967b270fe40e2bc76">RB_initial_condition_all_N</a>[N] = RB_ic_N;
<a name="l01538"></a>01538 
<a name="l01539"></a>01539     <span class="comment">// Compute the L2 error for the RB initial condition</span>
<a name="l01540"></a>01540     <span class="comment">// This part is dependent on the truth space.</span>
<a name="l01541"></a>01541 
<a name="l01542"></a>01542     <span class="comment">// load the RB solution into temp1</span>
<a name="l01543"></a>01543     temp1-&gt;zero();
<a name="l01544"></a>01544     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;N+1; i++)
<a name="l01545"></a>01545     {
<a name="l01546"></a>01546       temp1-&gt;add(RB_ic_N(i), <a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(i));
<a name="l01547"></a>01547     }
<a name="l01548"></a>01548 
<a name="l01549"></a>01549     <span class="comment">// subtract truth initial condition from RB_ic_N</span>
<a name="l01550"></a>01550     temp1-&gt;add(-1., *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l01551"></a>01551 
<a name="l01552"></a>01552     <span class="comment">// Compute L2 norm error, i.e. sqrt(M(solution,solution))</span>
<a name="l01553"></a>01553     temp2-&gt;zero();
<a name="l01554"></a>01554     <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1RBSystem.php#aea5613430c16f0f353c91fe868472b74">low_memory_mode</a>)
<a name="l01555"></a>01555     {
<a name="l01556"></a>01556       <a class="code" href="classlibMesh_1_1TransientRBSystem.php#a4e15721a62defb903900352ceb0ea367">L2_matrix</a>-&gt;vector_mult(*temp2, *temp1);
<a name="l01557"></a>01557     }
<a name="l01558"></a>01558     <span class="keywordflow">else</span>
<a name="l01559"></a>01559     {
<a name="l01560"></a>01560       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#adaccc5857f1a5d5ca264ded0b8bfb986">vector_mult</a>(*temp2, *temp1);
<a name="l01561"></a>01561     }
<a name="l01562"></a>01562     trans_rb_eval-&gt;<a class="code" href="classlibMesh_1_1TransientRBEvaluation.php#a9473d65549ad018d40fe0d49d5b967d7">initial_L2_error_all_N</a>[N] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::sqrt(temp2-&gt;dot(*temp1)));
<a name="l01563"></a>01563   }
<a name="l01564"></a>01564 
<a name="l01565"></a>01565   STOP_LOG(<span class="stringliteral">&quot;update_RB_initial_condition_all_N()&quot;</span>, <span class="stringliteral">&quot;TransientRBSystem&quot;</span>);
<a name="l01566"></a>01566 }
<a name="l01567"></a>01567 
<a name="l01568"></a>01568 <span class="comment">//Real TransientRBSystem::uncached_compute_residual_dual_norm(const unsigned int N)</span>
<a name="l01569"></a>01569 <span class="comment">//{</span>
<a name="l01570"></a>01570 <span class="comment">//  START_LOG(&quot;uncached_compute_residual_dual_norm()&quot;, &quot;TransientRBSystem&quot;);</span>
<a name="l01571"></a>01571 <span class="comment">//</span>
<a name="l01572"></a>01572 <span class="comment">//   // This is the &quot;slow&quot; way of computing the residual, but it is useful</span>
<a name="l01573"></a>01573 <span class="comment">//   // for validating the &quot;fast&quot; way.</span>
<a name="l01574"></a>01574 <span class="comment">//   // Note that this only works in serial since otherwise each processor will</span>
<a name="l01575"></a>01575 <span class="comment">//   // have a different parameter value during the Greedy training.</span>
<a name="l01576"></a>01576 <span class="comment">//</span>
<a name="l01577"></a>01577 <span class="comment">//   // Assemble the right-hand side to find the Reisz representor</span>
<a name="l01578"></a>01578 <span class="comment">//   // of the residual in the X norm</span>
<a name="l01579"></a>01579 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; RB_sol = NumericVector&lt;Number&gt;::build();</span>
<a name="l01580"></a>01580 <span class="comment">//   RB_sol-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l01581"></a>01581 <span class="comment">//   RB_sol-&gt;zero();</span>
<a name="l01582"></a>01582 <span class="comment">//</span>
<a name="l01583"></a>01583 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; ghosted_temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l01584"></a>01584 <span class="comment">//   ghosted_temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(),</span>
<a name="l01585"></a>01585 <span class="comment">//                       this-&gt;get_dof_map().get_send_list(), false,</span>
<a name="l01586"></a>01586 <span class="comment">//                       GHOSTED);</span>
<a name="l01587"></a>01587 <span class="comment">//</span>
<a name="l01588"></a>01588 <span class="comment">//   AutoPtr&lt; NumericVector&lt;Number&gt; &gt; parallel_temp = NumericVector&lt;Number&gt;::build();</span>
<a name="l01589"></a>01589 <span class="comment">//   parallel_temp-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs(), false, libMeshEnums::PARALLEL);</span>
<a name="l01590"></a>01590 <span class="comment">//</span>
<a name="l01591"></a>01591 <span class="comment">//   // Store current_local_solution, since we don&#39;t want to corrupt it</span>
<a name="l01592"></a>01592 <span class="comment">//   *ghosted_temp = *current_local_solution;</span>
<a name="l01593"></a>01593 <span class="comment">//</span>
<a name="l01594"></a>01594 <span class="comment">//   for(unsigned int i=0; i&lt;N; i++)</span>
<a name="l01595"></a>01595 <span class="comment">//   {</span>
<a name="l01596"></a>01596 <span class="comment">//     RB_sol-&gt;add(RB_solution(i), get_basis_function(i));</span>
<a name="l01597"></a>01597 <span class="comment">//     parallel_temp-&gt;add(old_RB_solution(i), get_basis_function(i));</span>
<a name="l01598"></a>01598 <span class="comment">//   }</span>
<a name="l01599"></a>01599 <span class="comment">//</span>
<a name="l01600"></a>01600 <span class="comment">//   // Load parallel_temp into current_local_solution in order to do assembly</span>
<a name="l01601"></a>01601 <span class="comment">//   const std::vector&lt;unsigned int&gt;&amp; send_list = this-&gt;get_dof_map().get_send_list();</span>
<a name="l01602"></a>01602 <span class="comment">//   parallel_temp-&gt;localize (*current_local_solution, send_list);</span>
<a name="l01603"></a>01603 <span class="comment">//</span>
<a name="l01604"></a>01604 <span class="comment">//   // Load the system_matrix</span>
<a name="l01605"></a>01605 <span class="comment">//   this-&gt;truth_assembly();</span>
<a name="l01606"></a>01606 <span class="comment">//</span>
<a name="l01607"></a>01607 <span class="comment">//   // Restore current_local_solution</span>
<a name="l01608"></a>01608 <span class="comment">//   *current_local_solution = *ghosted_temp;</span>
<a name="l01609"></a>01609 <span class="comment">//</span>
<a name="l01610"></a>01610 <span class="comment">//   matrix-&gt;vector_mult(*parallel_temp, *RB_sol);</span>
<a name="l01611"></a>01611 <span class="comment">//   rhs-&gt;add(-1., *parallel_temp);</span>
<a name="l01612"></a>01612 <span class="comment">//   rhs-&gt;close();</span>
<a name="l01613"></a>01613 <span class="comment">//</span>
<a name="l01614"></a>01614 <span class="comment">//   zero_dirichlet_dofs_on_rhs();</span>
<a name="l01615"></a>01615 <span class="comment">//</span>
<a name="l01616"></a>01616 <span class="comment">//   // Then solve the system to get the Reisz representor</span>
<a name="l01617"></a>01617 <span class="comment">//   matrix-&gt;zero();</span>
<a name="l01618"></a>01618 <span class="comment">//   if(!low_memory_mode)</span>
<a name="l01619"></a>01619 <span class="comment">//   {</span>
<a name="l01620"></a>01620 <span class="comment">//     matrix-&gt;add(1., *inner_product_matrix);</span>
<a name="l01621"></a>01621 <span class="comment">//     if(constrained_problem)</span>
<a name="l01622"></a>01622 <span class="comment">//       matrix-&gt;add(1., *constraint_matrix);</span>
<a name="l01623"></a>01623 <span class="comment">//   }</span>
<a name="l01624"></a>01624 <span class="comment">//   else</span>
<a name="l01625"></a>01625 <span class="comment">//   {</span>
<a name="l01626"></a>01626 <span class="comment">//     assemble_inner_product_matrix(matrix);</span>
<a name="l01627"></a>01627 <span class="comment">//     if(constrained_problem)</span>
<a name="l01628"></a>01628 <span class="comment">//       add_scaled_matrix_and_vector(1., constraint_assembly, NULL, matrix, NULL);</span>
<a name="l01629"></a>01629 <span class="comment">//   }</span>
<a name="l01630"></a>01630 <span class="comment">//</span>
<a name="l01631"></a>01631 <span class="comment">//</span>
<a name="l01632"></a>01632 <span class="comment">//   solution-&gt;zero();</span>
<a name="l01633"></a>01633 <span class="comment">//   solve();</span>
<a name="l01634"></a>01634 <span class="comment">//   // Make sure we didn&#39;t max out the number of iterations</span>
<a name="l01635"></a>01635 <span class="comment">//   if( (this-&gt;n_linear_iterations() &gt;=</span>
<a name="l01636"></a>01636 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;unsigned int&gt;(&quot;linear solver maximum iterations&quot;)) &amp;&amp;</span>
<a name="l01637"></a>01637 <span class="comment">//       (this-&gt;final_linear_residual() &gt;</span>
<a name="l01638"></a>01638 <span class="comment">//        this-&gt;get_equation_systems().parameters.get&lt;Real&gt;(&quot;linear solver tolerance&quot;)) )</span>
<a name="l01639"></a>01639 <span class="comment">//   {</span>
<a name="l01640"></a>01640 <span class="comment">//     libMesh::out &lt;&lt; &quot;Warning: Linear solver may not have converged! Final linear residual = &quot;</span>
<a name="l01641"></a>01641 <span class="comment">//                  &lt;&lt; this-&gt;final_linear_residual() &lt;&lt; &quot;, number of iterations = &quot;</span>
<a name="l01642"></a>01642 <span class="comment">//                  &lt;&lt; this-&gt;n_linear_iterations() &lt;&lt; std::endl &lt;&lt; std::endl;</span>
<a name="l01643"></a>01643 <span class="comment">// //     libmesh_error();</span>
<a name="l01644"></a>01644 <span class="comment">//   }</span>
<a name="l01645"></a>01645 <span class="comment">//</span>
<a name="l01646"></a>01646 <span class="comment">//  if(!low_memory_mode)</span>
<a name="l01647"></a>01647 <span class="comment">//  {</span>
<a name="l01648"></a>01648 <span class="comment">//    inner_product_matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l01649"></a>01649 <span class="comment">//  }</span>
<a name="l01650"></a>01650 <span class="comment">//  else</span>
<a name="l01651"></a>01651 <span class="comment">//  {</span>
<a name="l01652"></a>01652 <span class="comment">//    assemble_inner_product_matrix(matrix);</span>
<a name="l01653"></a>01653 <span class="comment">//    matrix-&gt;vector_mult(*inner_product_storage_vector, *solution);</span>
<a name="l01654"></a>01654 <span class="comment">//  }</span>
<a name="l01655"></a>01655 <span class="comment">//</span>
<a name="l01656"></a>01656 <span class="comment">//  Real slow_residual_norm_sq = solution-&gt;dot(*inner_product_storage_vector);</span>
<a name="l01657"></a>01657 <span class="comment">//</span>
<a name="l01658"></a>01658 <span class="comment">//</span>
<a name="l01659"></a>01659 <span class="comment">//  STOP_LOG(&quot;uncached_compute_residual_dual_norm()&quot;, &quot;TransientRBSystem&quot;);</span>
<a name="l01660"></a>01660 <span class="comment">//</span>
<a name="l01661"></a>01661 <span class="comment">//  return libmesh_real(std::sqrt( slow_residual_norm_sq ));</span>
<a name="l01662"></a>01662 <span class="comment">//}</span>
<a name="l01663"></a>01663 
<a name="l01664"></a>01664 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
